# /etc/ksh.kshrc --
#   The system wide environment and startup programs for ksh
#   (Aliases go in $HOME/.kshrc)
#[ -e /etc/D ] && echo "/etc/ksh.kshrc: \$-='$-'" 1>&2

case "$-" in

# interactive shell
*i*)
  # we may have su'ed so reset these
  if [ -x /usr/bin/id ]; then
    [ `id -gn` = `id -un` ] && [ `id -u` != 0 ] && umask 002
    [ -z "$UID" ] && UID=`id -u`
    [ -z "$USER" ] && USER=`id -un`
  fi
  case $UID in
  0) PS1S='# ';;
  esac
  PS1S=${PS1S:-'$ '}
  HOSTNAME=${HOSTNAME:-`/bin/hostname`}
  HOST=${HOSTNAME%%.*}

  PROMPT="<$USER@$HOST:!>$PS1S"
  PPROMPT='<$USER@$HOST:$PWD:!>'"$PS1S"
  PS1=$PPROMPT

  # $TTY is the tty we logged in on,
  # $tty is that which we are in now (might by pty)
  tty=`tty`
  tty=`basename $tty`
        TTY=${TTY:-$tty}
        
  set -o emacs
  bind '^i'=complete-list
  bind '^v'=quote

  # the PD ksh is not 100% compatible
  case "$KSH_VERSION" in
  *PD*)  # PD ksh
    case "$TERM" in
    pc3|xterm*)
      # bind arrow keys
      bind '^[['=prefix-2
      bind '^XA'=up-history
      bind '^XB'=down-history
      bind '^XC'=forward-char
      bind '^XD'=backward-char
      ;;
    esac
    ;;
  *)  # real ksh ?
    [ -r $HOME/.functions ] && . $HOME/.functions
    set -o trackall
    ;;
  esac
;;

# non-interactive
*)
;;
esac
# commands for both interactive and non-interactive shells

