/* This file is part of the KDE project
   Copyright (C) 1999 Steffen Hansen <hansen@kde.org>
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#pragma interface

#ifndef KDED_UTILS_H
#define KDED_UTILS_H

#include <qstring.h>
#include <kded.h>

class KService;

/**
 * Call this by the client before using any
 * services from the ORB. kdeddisplay is unused for now.
 */
KDED::InitialReferences_ptr connect_to_kded( CORBA::ORB_ptr orb,
					     QString ior = QString::null,
					     const char *kdeddisplay = 0);

/**
 * Call this to start the KDED implementation
 * and obtain a refrence to it. The RootPOA is
 * also activated by this call
 */
KDED::InitialReferences_ptr start_kded( CORBA::ORB_ptr orb);

/**
 * Several tool functions
 */
 
CORBA::WChar *QString2WString( const QString &s );
QString WString2QString( const CORBA::WChar *s );

KDED::Trader::CService KService2CService( const KService &service );
KService CService2KService( const KDED::Trader::CService &service );

#endif /* KDED_UTILS_H */

/*
 * Local variables:
 * mode: c++
 * c-file-style: "k&r"
 * End:
 */
