/* This file is part of the KDE project
   Copyright (C) 1998, 1999 Simon Hausmann <hausmann@kde.org>
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __OPstatusbar_if_h__
#define __OPstatusbar_if_h__

#include "opQCProxy.h"
#include "opStatusBar.h"

#include <komBase.h>

#include "openparts_ui.h"

class QWidget;
class KTMainWindow;

class OPStatusBarIf : virtual public KOMBase,
		      virtual public OpenPartsUI::StatusBar_skel
{
public:
  OPStatusBarIf( OPStatusBar* _statusbar );
  ~OPStatusBarIf();

  virtual CORBA::Long insertItem( const CORBA::WChar *text, CORBA::Long ID );
  virtual void removeItem( CORBA::Long ID );
  virtual void changeItem( const CORBA::WChar *text, CORBA::Long ID );
  virtual void setInsertOrder( OpenPartsUI::StatusBar::InsertOrder order);
  virtual void setAlignment( CORBA::Long ID, OpenPartsUI::StatusBar::Alignment align );
  virtual void setHeight( CORBA::Long height );
  virtual void setBorderWidth( CORBA::Long width );
  virtual void message( const CORBA::WChar *text, CORBA::Long time );
  virtual void clear();
  virtual void pressed( CORBA::Long ID );
  virtual void released( CORBA::Long ID );
  virtual CORBA::Boolean enable( OpenPartsUI::BarStatus stat );
  virtual CORBA::Boolean isVisible();
   
  virtual void cleanUp();

  bool wasVisible() const { return m_bWasVisible; }

protected:
  OPStatusBar* m_pStatusBar;
  bool m_bWasVisible;
};

#endif

