/* This file is part of the KDE project
   Copyright (C) 1998, 1999 Simon Hausmann <hausmann@kde.org>
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __op_status_bar_manager_h__
#define __op_status_bar_manager_h__

#include "openparts.h"
#include <openparts_ui.h>
#include <opStatusBar.h>
#include <komBase.h>

#include <qmap.h>

class OPMainWindow;

class OPStatusBarManager : virtual public KOMBase,
			   virtual public OpenParts::StatusBarManager_skel
{
public:
  OPStatusBarManager( OPMainWindow* _main );
  ~OPStatusBarManager();

  // IDL
  virtual OpenPartsUI::StatusBar_ptr registerClient( OpenParts::Id id );
  virtual void unregisterClient( OpenParts::Id id );
  
  // C++
  virtual void create( OpenParts::Id id = 0 );
  virtual void clear();
  
protected:
  OPMainWindow* m_pMainWindow;

  OpenParts::Id m_activeId;
  
  QMap<OpenParts::Id,OPStatusBar*> m_mapBars;
};


#endif
