/* This file is part of the KDE project
   Copyright (C) 1998, 1999 Torben Weis <weis@kde.org>
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/     

//
// $Id: opUIUtils.h,v 1.5 1999/06/13 18:26:04 shausman Exp $
//
#ifndef __op_ui_utils_h__
#define __op_ui_utils_h__

#include <CORBA.h>
#include <qpixmap.h>
#include <qstringlist.h>

#include "openparts_ui.h"

#define Q2C(s) OPUIUtils::QString2WString( s )
#define C2Q(s) OPUIUtils::WString2QString( s )
#define QLST2CLST( lst ) OPUIUtils::QStringList2WStringList( lst )
#define CLST2QLST( lst ) OPUIUtils::WStringList2QStringList( lst )

class OPUIUtils
{
public:
  static QPixmap convertPixmap( const OpenPartsUI::Pixmap& _pix );
  static OpenPartsUI::Pixmap* convertPixmap( const QPixmap& _pixmap );
  static OpenPartsUI::Pixmap* loadPixmap( const char *_file );
  
  static CORBA::WChar *QString2WString( const QString &s );
  static QString WString2QString( const CORBA::WChar *s );
  
  static OpenPartsUI::WStrList *QStringList2WStringList( const QStringList &lst );
  static QStringList WStringList2QStringList( const OpenPartsUI::WStrList *lst );
};

#endif
