/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__OPENPARTS_UI_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __OPENPARTS_UI_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

#ifdef MICO_IN_GENERATED_CODE
#include <kom.h>
#else
#define MICO_IN_GENERATED_CODE
#include <kom.h>
#undef MICO_IN_GENERATED_CODE
#endif

#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL OpenPartsUI {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_OpenPartsUI)


enum BarStatus {
  Toggle = 0,
  Show,
  Hide
};

typedef BarStatus& BarStatus_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_BarStatus;

enum BarPosition {
  Top = 0,
  Left,
  Bottom,
  Right,
  Floating
};

typedef BarPosition& BarPosition_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_BarPosition;

struct Pixmap;
typedef TVarVar<Pixmap> Pixmap_var;
typedef Pixmap_var Pixmap_out;

struct Pixmap {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef Pixmap_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  Pixmap();
  ~Pixmap();
  Pixmap( const Pixmap& s );
  Pixmap& operator=( const Pixmap& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var data;
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_Pixmap;

class Menu;
typedef Menu *Menu_ptr;
typedef Menu_ptr MenuRef;
typedef ObjVar<Menu> Menu_var;
typedef Menu_var Menu_out;

class MenuData;
typedef MenuData *MenuData_ptr;
typedef MenuData_ptr MenuDataRef;
typedef ObjVar<MenuData> MenuData_var;
typedef MenuData_var MenuData_out;


// Common definitions for interface MenuData
class MenuData : 
  virtual public ::KOM::Base
{
  public:
    virtual ~MenuData();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef MenuData_ptr _ptr_type;
    typedef MenuData_var _var_type;
    #endif

    static MenuData_ptr _narrow( CORBA::Object_ptr obj );
    static MenuData_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static MenuData_ptr _duplicate( MenuData_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static MenuData_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual CORBA::ULong count() = 0;
    virtual CORBA::Long insertItem( const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel ) = 0;
    virtual CORBA::Long insertItem2( const Pixmap& pixmap, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel ) = 0;
    virtual CORBA::Long insertItem3( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel ) = 0;
    virtual CORBA::Long insertItem4( const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem5( const Pixmap& pixmap, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem6( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem7( const CORBA::WChar* text, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem8( const CORBA::WChar* text, Menu_ptr& popup, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem9( const Pixmap& pixmap, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem10( const Pixmap& pixmap, Menu_ptr& popup, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem11( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertItem12( const Pixmap& pixmap, const CORBA::WChar* text, Menu_ptr& popup, CORBA::Long id, CORBA::Long index ) = 0;
    virtual void insertSeparator( CORBA::Long index ) = 0;
    virtual void removeItem( CORBA::Long id ) = 0;
    virtual void removeItemAt( CORBA::Long index ) = 0;
    virtual void clear() = 0;
    virtual CORBA::Long accel( CORBA::Long id ) = 0;
    virtual void setAccel( CORBA::Long key, CORBA::Long id ) = 0;
    virtual CORBA::WChar* text( CORBA::Long id ) = 0;
    virtual Pixmap* pixmap( CORBA::Long id ) = 0;
    virtual void changeItemText( const CORBA::WChar* text, CORBA::Long id ) = 0;
    virtual void changeItemPixmap( const Pixmap& pixmap, CORBA::Long id ) = 0;
    virtual void changeItem( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Long id ) = 0;
    virtual CORBA::Boolean isItemEnabled( CORBA::Long id ) = 0;
    virtual void setItemEnabled( CORBA::Long id, CORBA::Boolean enable ) = 0;
    virtual CORBA::Boolean isItemChecked( CORBA::Long id ) = 0;
    virtual void setItemChecked( CORBA::Long id, CORBA::Boolean check ) = 0;
    virtual void updateItem( CORBA::Long id ) = 0;
    virtual CORBA::Long indexOf( CORBA::Long id ) = 0;
    virtual CORBA::Long idAt( CORBA::Long index ) = 0;
    virtual void setId( CORBA::Long index, CORBA::Long id ) = 0;
    virtual void setCheckable( CORBA::Boolean checkable ) = 0;
    virtual CORBA::Boolean isCheckable() = 0;
    virtual void activated( CORBA::Long id ) = 0;
    virtual void highlighted( CORBA::Long id ) = 0;
    virtual void aboutToShow() = 0;

  protected:
    MenuData() {};
  private:
    MenuData( const MenuData& );
    void operator=( const MenuData& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_MenuData;

// Stub for interface MenuData
class MenuData_stub:
  virtual public MenuData,
  virtual public ::KOM::Base_stub
{
  public:
    virtual ~MenuData_stub();
    CORBA::ULong count();
    CORBA::Long insertItem( const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel );
    CORBA::Long insertItem2( const Pixmap& pixmap, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel );
    CORBA::Long insertItem3( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel );
    CORBA::Long insertItem4( const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem5( const Pixmap& pixmap, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem6( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem7( const CORBA::WChar* text, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem8( const CORBA::WChar* text, Menu_ptr& popup, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem9( const Pixmap& pixmap, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem10( const Pixmap& pixmap, Menu_ptr& popup, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem11( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertItem12( const Pixmap& pixmap, const CORBA::WChar* text, Menu_ptr& popup, CORBA::Long id, CORBA::Long index );
    void insertSeparator( CORBA::Long index );
    void removeItem( CORBA::Long id );
    void removeItemAt( CORBA::Long index );
    void clear();
    CORBA::Long accel( CORBA::Long id );
    void setAccel( CORBA::Long key, CORBA::Long id );
    CORBA::WChar* text( CORBA::Long id );
    Pixmap* pixmap( CORBA::Long id );
    void changeItemText( const CORBA::WChar* text, CORBA::Long id );
    void changeItemPixmap( const Pixmap& pixmap, CORBA::Long id );
    void changeItem( const Pixmap& pixmap, const CORBA::WChar* text, CORBA::Long id );
    CORBA::Boolean isItemEnabled( CORBA::Long id );
    void setItemEnabled( CORBA::Long id, CORBA::Boolean enable );
    CORBA::Boolean isItemChecked( CORBA::Long id );
    void setItemChecked( CORBA::Long id, CORBA::Boolean check );
    void updateItem( CORBA::Long id );
    CORBA::Long indexOf( CORBA::Long id );
    CORBA::Long idAt( CORBA::Long index );
    void setId( CORBA::Long index, CORBA::Long id );
    void setCheckable( CORBA::Boolean checkable );
    CORBA::Boolean isCheckable();
    void activated( CORBA::Long id );
    void highlighted( CORBA::Long id );
    void aboutToShow();

  private:
    void operator=( const MenuData_stub& );
};

class MenuData_skel :
  virtual public StaticMethodDispatcher,
  virtual public MenuData
{
  public:
    MenuData_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~MenuData_skel();
    MenuData_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    MenuData_ptr _this();

};


// Common definitions for interface Menu
class Menu : 
  virtual public ::OpenPartsUI::MenuData
{
  public:
    virtual ~Menu();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef Menu_ptr _ptr_type;
    typedef Menu_var _var_type;
    #endif

    static Menu_ptr _narrow( CORBA::Object_ptr obj );
    static Menu_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static Menu_ptr _duplicate( Menu_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static Menu_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

  protected:
    Menu() {};
  private:
    Menu( const Menu& );
    void operator=( const Menu& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_Menu;

// Stub for interface Menu
class Menu_stub:
  virtual public Menu,
  virtual public ::OpenPartsUI::MenuData_stub
{
  public:
    virtual ~Menu_stub();
  private:
    void operator=( const Menu_stub& );
};

class Menu_skel :
  virtual public StaticMethodDispatcher,
  virtual public Menu
{
  public:
    Menu_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~Menu_skel();
    Menu_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    Menu_ptr _this();

};

class MenuBar;
typedef MenuBar *MenuBar_ptr;
typedef MenuBar_ptr MenuBarRef;
typedef ObjVar<MenuBar> MenuBar_var;
typedef MenuBar_var MenuBar_out;


// Common definitions for interface MenuBar
class MenuBar : 
  virtual public ::KOM::Base
{
  public:
    virtual ~MenuBar();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef MenuBar_ptr _ptr_type;
    typedef MenuBar_var _var_type;
    #endif

    static MenuBar_ptr _narrow( CORBA::Object_ptr obj );
    static MenuBar_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static MenuBar_ptr _duplicate( MenuBar_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static MenuBar_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    enum MenuBarPosition {
      Top = 0,
      Bottom,
      Floating,
      Flat,
      FloatingSystem
    };

    typedef MenuBarPosition& MenuBarPosition_out;

    static CORBA::TypeCodeConst _tc_MenuBarPosition;

    virtual CORBA::ULong count() = 0;
    virtual CORBA::Long insertItem( const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel ) = 0;
    virtual CORBA::Long insertItem2( const CORBA::WChar* text, CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long insertMenu( const CORBA::WChar* text, Menu_ptr& menu, CORBA::Long id, CORBA::Long index ) = 0;
    virtual void insertSeparator( CORBA::Long index ) = 0;
    virtual void removeItem( CORBA::Long id ) = 0;
    virtual void removeItemAt( CORBA::Long index ) = 0;
    virtual void clear() = 0;
    virtual CORBA::Long accel( CORBA::Long id ) = 0;
    virtual void setAccel( CORBA::Long key, CORBA::Long id ) = 0;
    virtual CORBA::WChar* text( CORBA::Long id ) = 0;
    virtual void changeItem( const CORBA::WChar* text, CORBA::Long id ) = 0;
    virtual void setItemChecked( CORBA::Long id, CORBA::Boolean flag ) = 0;
    virtual void setItemEnabled( CORBA::Long id, CORBA::Boolean flag ) = 0;
    virtual Menu_ptr menuAt( CORBA::Long index ) = 0;
    virtual Menu_ptr menu( CORBA::Long id ) = 0;
    virtual Menu_ptr helpMenu() = 0;
    virtual void setHelpMenu( CORBA::Long id ) = 0;
    virtual Menu_ptr fileMenu() = 0;
    virtual void setFileMenu( CORBA::Long id ) = 0;
    virtual void setMenuBarPos( MenuBarPosition bpos ) = 0;
    virtual MenuBarPosition barPos() = 0;
    virtual CORBA::Boolean enable( BarStatus stat ) = 0;
    virtual CORBA::Boolean isVisible() = 0;
    virtual void activated( CORBA::Long id ) = 0;
    virtual void highlighted( CORBA::Long id ) = 0;

  protected:
    MenuBar() {};
  private:
    MenuBar( const MenuBar& );
    void operator=( const MenuBar& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_MenuBar;

// Stub for interface MenuBar
class MenuBar_stub:
  virtual public MenuBar,
  virtual public ::KOM::Base_stub
{
  public:
    virtual ~MenuBar_stub();
    CORBA::ULong count();
    CORBA::Long insertItem( const CORBA::WChar* text, CORBA::Object_ptr receiver, const char* member, CORBA::Long accel );
    CORBA::Long insertItem2( const CORBA::WChar* text, CORBA::Long id, CORBA::Long index );
    CORBA::Long insertMenu( const CORBA::WChar* text, Menu_ptr& menu, CORBA::Long id, CORBA::Long index );
    void insertSeparator( CORBA::Long index );
    void removeItem( CORBA::Long id );
    void removeItemAt( CORBA::Long index );
    void clear();
    CORBA::Long accel( CORBA::Long id );
    void setAccel( CORBA::Long key, CORBA::Long id );
    CORBA::WChar* text( CORBA::Long id );
    void changeItem( const CORBA::WChar* text, CORBA::Long id );
    void setItemChecked( CORBA::Long id, CORBA::Boolean flag );
    void setItemEnabled( CORBA::Long id, CORBA::Boolean flag );
    Menu_ptr menuAt( CORBA::Long index );
    Menu_ptr menu( CORBA::Long id );
    Menu_ptr helpMenu();
    void setHelpMenu( CORBA::Long id );
    Menu_ptr fileMenu();
    void setFileMenu( CORBA::Long id );
    void setMenuBarPos( MenuBarPosition bpos );
    MenuBarPosition barPos();
    CORBA::Boolean enable( BarStatus stat );
    CORBA::Boolean isVisible();
    void activated( CORBA::Long id );
    void highlighted( CORBA::Long id );

  private:
    void operator=( const MenuBar_stub& );
};

class MenuBar_skel :
  virtual public StaticMethodDispatcher,
  virtual public MenuBar
{
  public:
    MenuBar_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~MenuBar_skel();
    MenuBar_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    MenuBar_ptr _this();

};

typedef StringSequenceTmpl<CORBA::String_var> StrList;
#ifdef _WINDOWS
static StrList _dummy_StrList;
#endif
typedef TSeqVar<StringSequenceTmpl<CORBA::String_var> > StrList_var;
typedef StrList_var StrList_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_StrList;

typedef WStringSequenceTmpl<CORBA::WString_var> WStrList;
#ifdef _WINDOWS
static WStrList _dummy_WStrList;
#endif
typedef TSeqVar<WStringSequenceTmpl<CORBA::WString_var> > WStrList_var;
typedef WStrList_var WStrList_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_WStrList;

enum ComboBoxPolicy {
  NoInsertion = 0,
  AtTop,
  AtCurrent,
  AtBottom,
  AfterCurrent,
  BeforeCurrent
};

typedef ComboBoxPolicy& ComboBoxPolicy_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_ComboBoxPolicy;

class ToolBar;
typedef ToolBar *ToolBar_ptr;
typedef ToolBar_ptr ToolBarRef;
typedef ObjVar<ToolBar> ToolBar_var;
typedef ToolBar_var ToolBar_out;


// Common definitions for interface ToolBar
class ToolBar : 
  virtual public ::KOM::Base
{
  public:
    virtual ~ToolBar();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ToolBar_ptr _ptr_type;
    typedef ToolBar_var _var_type;
    #endif

    static ToolBar_ptr _narrow( CORBA::Object_ptr obj );
    static ToolBar_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ToolBar_ptr _duplicate( ToolBar_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ToolBar_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual CORBA::Long insertButton( const Pixmap& pixmap, CORBA::Long id, CORBA::Boolean enabled, const CORBA::WChar* ToolTipText, CORBA::Long index ) = 0;
    virtual CORBA::Long insertButton2( const Pixmap& pixmap, CORBA::Long id, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long index ) = 0;
    virtual CORBA::Long insertButton3( const Pixmap& pixmap, CORBA::Long id, Menu_ptr& popup, CORBA::Boolean enabled, const CORBA::WChar* text, CORBA::Long index ) = 0;
    virtual CORBA::Long insertLined( const CORBA::WChar* text, CORBA::Long id, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* toolTipText, CORBA::Long size, CORBA::Long index ) = 0;
    virtual CORBA::Long insertCombo( const StrList& list, CORBA::Long id, CORBA::Boolean writable, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long size, CORBA::Long index, ComboBoxPolicy policy ) = 0;
    virtual CORBA::Long insertCombo2( const CORBA::WChar* text, CORBA::Long id, CORBA::Boolean writable, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long size, CORBA::Long index, ComboBoxPolicy policy ) = 0;
    virtual CORBA::Long insertCombo3( const WStrList& list, CORBA::Long id, CORBA::Boolean writable, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long size, CORBA::Long index, ComboBoxPolicy policy ) = 0;
    virtual CORBA::Long insertSeparator( CORBA::Long index ) = 0;
    virtual CORBA::Long insertTextLabel( const CORBA::WChar* text, CORBA::Long id, CORBA::Long index ) = 0;
    virtual void addConnection( CORBA::Long id, const char* signalname, CORBA::Object_ptr receiver, const char* slotname ) = 0;
    virtual void setItemEnabled( CORBA::Long id, CORBA::Boolean enabled ) = 0;
    virtual void setButtonPixmap( CORBA::Long id, const Pixmap& pixmap ) = 0;
    virtual void setDelayedPopup( CORBA::Long id, Menu_ptr& popup ) = 0;
    virtual void setToggle( CORBA::Long id, CORBA::Boolean flag ) = 0;
    virtual void toggleButton( CORBA::Long id ) = 0;
    virtual void setButton( CORBA::Long id, CORBA::Boolean flag ) = 0;
    virtual CORBA::Boolean isButtonOn( CORBA::Long id ) = 0;
    virtual void setLinedText( CORBA::Long id, const CORBA::WChar* text ) = 0;
    virtual CORBA::WChar* linedText( CORBA::Long id ) = 0;
    virtual void insertComboItem( CORBA::Long id, const CORBA::WChar* text, CORBA::Long index ) = 0;
    virtual void insertComboList( CORBA::Long id, const StrList& list, CORBA::Long index ) = 0;
    virtual void insertComboList2( CORBA::Long id, const WStrList& list, CORBA::Long index ) = 0;
    virtual void removeComboItem( CORBA::Long id, CORBA::Long index ) = 0;
    virtual void setCurrentComboItem( CORBA::Long id, CORBA::Long index ) = 0;
    virtual void changeComboItem( CORBA::Long id, const CORBA::WChar* text, CORBA::Long index ) = 0;
    virtual void clearCombo( CORBA::Long id ) = 0;
    virtual CORBA::WChar* comboItem( CORBA::Long id, CORBA::Long index ) = 0;
    virtual CORBA::Long comboItemCount( CORBA::Long id ) = 0;
    virtual CORBA::Long comboMaxCount( CORBA::Long id ) = 0;
    virtual void setComboMaxCount( CORBA::Long id, CORBA::Long count ) = 0;
    virtual CORBA::Boolean comboAutoCompletion( CORBA::Long id ) = 0;
    virtual void setComboAutoCompletion( CORBA::Long id, CORBA::Boolean enable ) = 0;
    virtual void alignItemRight( CORBA::Long id, CORBA::Boolean right ) = 0;
    virtual void setItemAutoSized( CORBA::Long id, CORBA::Boolean yes ) = 0;
    virtual void removeItem( CORBA::Long id ) = 0;
    virtual void hideItem( CORBA::Long id ) = 0;
    virtual void showItem( CORBA::Long id ) = 0;
    virtual void setFullWidth( CORBA::Boolean flag ) = 0;
    virtual void enableMoving( CORBA::Boolean flag ) = 0;
    virtual void setBarPos( BarPosition bpos ) = 0;
    virtual BarPosition barPos() = 0;
    virtual CORBA::Boolean enable( BarStatus stat ) = 0;
    virtual CORBA::Boolean isVisible() = 0;
    virtual void setMaxHeight( CORBA::Long h ) = 0;
    virtual void setMaxWidth( CORBA::Long dw ) = 0;
    virtual void setTitle( const CORBA::WChar* title ) = 0;
    virtual void enableFloating( CORBA::Boolean flag ) = 0;
    virtual void setIconText( CORBA::Long id ) = 0;
    virtual void changeLabelText( CORBA::Long id, const CORBA::WChar* text ) = 0;
    virtual void clicked( CORBA::Long id ) = 0;
    virtual void doubleClicked( CORBA::Long id ) = 0;
    virtual void pressed( CORBA::Long id ) = 0;
    virtual void released( CORBA::Long id ) = 0;
    virtual void toggled( CORBA::Long id ) = 0;
    virtual void highlighted( CORBA::Long id ) = 0;

  protected:
    ToolBar() {};
  private:
    ToolBar( const ToolBar& );
    void operator=( const ToolBar& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_ToolBar;

// Stub for interface ToolBar
class ToolBar_stub:
  virtual public ToolBar,
  virtual public ::KOM::Base_stub
{
  public:
    virtual ~ToolBar_stub();
    CORBA::Long insertButton( const Pixmap& pixmap, CORBA::Long id, CORBA::Boolean enabled, const CORBA::WChar* ToolTipText, CORBA::Long index );
    CORBA::Long insertButton2( const Pixmap& pixmap, CORBA::Long id, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long index );
    CORBA::Long insertButton3( const Pixmap& pixmap, CORBA::Long id, Menu_ptr& popup, CORBA::Boolean enabled, const CORBA::WChar* text, CORBA::Long index );
    CORBA::Long insertLined( const CORBA::WChar* text, CORBA::Long id, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* toolTipText, CORBA::Long size, CORBA::Long index );
    CORBA::Long insertCombo( const StrList& list, CORBA::Long id, CORBA::Boolean writable, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long size, CORBA::Long index, ComboBoxPolicy policy );
    CORBA::Long insertCombo2( const CORBA::WChar* text, CORBA::Long id, CORBA::Boolean writable, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long size, CORBA::Long index, ComboBoxPolicy policy );
    CORBA::Long insertCombo3( const WStrList& list, CORBA::Long id, CORBA::Boolean writable, const char* signalname, CORBA::Object_ptr receiver, const char* slotname, CORBA::Boolean enabled, const CORBA::WChar* tooltiptext, CORBA::Long size, CORBA::Long index, ComboBoxPolicy policy );
    CORBA::Long insertSeparator( CORBA::Long index );
    CORBA::Long insertTextLabel( const CORBA::WChar* text, CORBA::Long id, CORBA::Long index );
    void addConnection( CORBA::Long id, const char* signalname, CORBA::Object_ptr receiver, const char* slotname );
    void setItemEnabled( CORBA::Long id, CORBA::Boolean enabled );
    void setButtonPixmap( CORBA::Long id, const Pixmap& pixmap );
    void setDelayedPopup( CORBA::Long id, Menu_ptr& popup );
    void setToggle( CORBA::Long id, CORBA::Boolean flag );
    void toggleButton( CORBA::Long id );
    void setButton( CORBA::Long id, CORBA::Boolean flag );
    CORBA::Boolean isButtonOn( CORBA::Long id );
    void setLinedText( CORBA::Long id, const CORBA::WChar* text );
    CORBA::WChar* linedText( CORBA::Long id );
    void insertComboItem( CORBA::Long id, const CORBA::WChar* text, CORBA::Long index );
    void insertComboList( CORBA::Long id, const StrList& list, CORBA::Long index );
    void insertComboList2( CORBA::Long id, const WStrList& list, CORBA::Long index );
    void removeComboItem( CORBA::Long id, CORBA::Long index );
    void setCurrentComboItem( CORBA::Long id, CORBA::Long index );
    void changeComboItem( CORBA::Long id, const CORBA::WChar* text, CORBA::Long index );
    void clearCombo( CORBA::Long id );
    CORBA::WChar* comboItem( CORBA::Long id, CORBA::Long index );
    CORBA::Long comboItemCount( CORBA::Long id );
    CORBA::Long comboMaxCount( CORBA::Long id );
    void setComboMaxCount( CORBA::Long id, CORBA::Long count );
    CORBA::Boolean comboAutoCompletion( CORBA::Long id );
    void setComboAutoCompletion( CORBA::Long id, CORBA::Boolean enable );
    void alignItemRight( CORBA::Long id, CORBA::Boolean right );
    void setItemAutoSized( CORBA::Long id, CORBA::Boolean yes );
    void removeItem( CORBA::Long id );
    void hideItem( CORBA::Long id );
    void showItem( CORBA::Long id );
    void setFullWidth( CORBA::Boolean flag );
    void enableMoving( CORBA::Boolean flag );
    void setBarPos( BarPosition bpos );
    BarPosition barPos();
    CORBA::Boolean enable( BarStatus stat );
    CORBA::Boolean isVisible();
    void setMaxHeight( CORBA::Long h );
    void setMaxWidth( CORBA::Long dw );
    void setTitle( const CORBA::WChar* title );
    void enableFloating( CORBA::Boolean flag );
    void setIconText( CORBA::Long id );
    void changeLabelText( CORBA::Long id, const CORBA::WChar* text );
    void clicked( CORBA::Long id );
    void doubleClicked( CORBA::Long id );
    void pressed( CORBA::Long id );
    void released( CORBA::Long id );
    void toggled( CORBA::Long id );
    void highlighted( CORBA::Long id );

  private:
    void operator=( const ToolBar_stub& );
};

class ToolBar_skel :
  virtual public StaticMethodDispatcher,
  virtual public ToolBar
{
  public:
    ToolBar_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~ToolBar_skel();
    ToolBar_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    ToolBar_ptr _this();

};

class ColorBar;
typedef ColorBar *ColorBar_ptr;
typedef ColorBar_ptr ColorBarRef;
typedef ObjVar<ColorBar> ColorBar_var;
typedef ColorBar_var ColorBar_out;


// Common definitions for interface ColorBar
class ColorBar : 
  virtual public ::KOM::Base
{
  public:
    virtual ~ColorBar();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ColorBar_ptr _ptr_type;
    typedef ColorBar_var _var_type;
    #endif

    static ColorBar_ptr _narrow( CORBA::Object_ptr obj );
    static ColorBar_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ColorBar_ptr _duplicate( ColorBar_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ColorBar_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void insertRgbColor( CORBA::Long id, CORBA::Short red, CORBA::Short green, CORBA::Short blue, CORBA::Boolean fill ) = 0;
    virtual void setRgbColor( CORBA::Long id, CORBA::Short red, CORBA::Short green, CORBA::Short blue, CORBA::Boolean fill ) = 0;
    virtual CORBA::Boolean getRgbColor( CORBA::Long id, CORBA::Short& red, CORBA::Short& green, CORBA::Short& blue, CORBA::Boolean& fill ) = 0;
    virtual void addConnection( const char* signalname, CORBA::Object_ptr receiver, const char* slotname ) = 0;
    virtual void setFullWidth( CORBA::Boolean flag ) = 0;
    virtual void enableMoving( CORBA::Boolean flag ) = 0;
    virtual void setBarPos( BarPosition bpos ) = 0;
    virtual BarPosition barPos() = 0;
    virtual CORBA::Boolean enable( BarStatus stat ) = 0;
    virtual CORBA::Boolean isVisible() = 0;
    virtual void setMaxHeight( CORBA::Long h ) = 0;
    virtual void setMaxWidth( CORBA::Long dw ) = 0;
    virtual void setTitle( const CORBA::WChar* title ) = 0;
    virtual void enableFloating( CORBA::Boolean flag ) = 0;

  protected:
    ColorBar() {};
  private:
    ColorBar( const ColorBar& );
    void operator=( const ColorBar& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_ColorBar;

// Stub for interface ColorBar
class ColorBar_stub:
  virtual public ColorBar,
  virtual public ::KOM::Base_stub
{
  public:
    virtual ~ColorBar_stub();
    void insertRgbColor( CORBA::Long id, CORBA::Short red, CORBA::Short green, CORBA::Short blue, CORBA::Boolean fill );
    void setRgbColor( CORBA::Long id, CORBA::Short red, CORBA::Short green, CORBA::Short blue, CORBA::Boolean fill );
    CORBA::Boolean getRgbColor( CORBA::Long id, CORBA::Short& red, CORBA::Short& green, CORBA::Short& blue, CORBA::Boolean& fill );
    void addConnection( const char* signalname, CORBA::Object_ptr receiver, const char* slotname );
    void setFullWidth( CORBA::Boolean flag );
    void enableMoving( CORBA::Boolean flag );
    void setBarPos( BarPosition bpos );
    BarPosition barPos();
    CORBA::Boolean enable( BarStatus stat );
    CORBA::Boolean isVisible();
    void setMaxHeight( CORBA::Long h );
    void setMaxWidth( CORBA::Long dw );
    void setTitle( const CORBA::WChar* title );
    void enableFloating( CORBA::Boolean flag );

  private:
    void operator=( const ColorBar_stub& );
};

class ColorBar_skel :
  virtual public StaticMethodDispatcher,
  virtual public ColorBar
{
  public:
    ColorBar_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~ColorBar_skel();
    ColorBar_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    ColorBar_ptr _this();

};

class ToolBarFactory;
typedef ToolBarFactory *ToolBarFactory_ptr;
typedef ToolBarFactory_ptr ToolBarFactoryRef;
typedef ObjVar<ToolBarFactory> ToolBarFactory_var;
typedef ToolBarFactory_var ToolBarFactory_out;


// Common definitions for interface ToolBarFactory
class ToolBarFactory : 
  virtual public CORBA::Object
{
  public:
    virtual ~ToolBarFactory();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ToolBarFactory_ptr _ptr_type;
    typedef ToolBarFactory_var _var_type;
    #endif

    static ToolBarFactory_ptr _narrow( CORBA::Object_ptr obj );
    static ToolBarFactory_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ToolBarFactory_ptr _duplicate( ToolBarFactory_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ToolBarFactory_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    enum Modus {
      Transient = 0,
      Persistent
    };

    typedef Modus& Modus_out;

    static CORBA::TypeCodeConst _tc_Modus;

    virtual ToolBar_ptr create( Modus modus ) = 0;
    virtual ToolBar_ptr create2( Modus modus, CORBA::Long itemSize ) = 0;
    virtual ColorBar_ptr createColorBar( Modus modus ) = 0;

  protected:
    ToolBarFactory() {};
  private:
    ToolBarFactory( const ToolBarFactory& );
    void operator=( const ToolBarFactory& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_ToolBarFactory;

// Stub for interface ToolBarFactory
class ToolBarFactory_stub:
  virtual public ToolBarFactory
{
  public:
    virtual ~ToolBarFactory_stub();
    ToolBar_ptr create( Modus modus );
    ToolBar_ptr create2( Modus modus, CORBA::Long itemSize );
    ColorBar_ptr createColorBar( Modus modus );

  private:
    void operator=( const ToolBarFactory_stub& );
};

class ToolBarFactory_skel :
  virtual public StaticMethodDispatcher,
  virtual public ToolBarFactory
{
  public:
    ToolBarFactory_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~ToolBarFactory_skel();
    ToolBarFactory_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    ToolBarFactory_ptr _this();

};

class StatusBar;
typedef StatusBar *StatusBar_ptr;
typedef StatusBar_ptr StatusBarRef;
typedef ObjVar<StatusBar> StatusBar_var;
typedef StatusBar_var StatusBar_out;


// Common definitions for interface StatusBar
class StatusBar : 
  virtual public ::KOM::Base
{
  public:
    virtual ~StatusBar();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef StatusBar_ptr _ptr_type;
    typedef StatusBar_var _var_type;
    #endif

    static StatusBar_ptr _narrow( CORBA::Object_ptr obj );
    static StatusBar_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static StatusBar_ptr _duplicate( StatusBar_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static StatusBar_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    enum Alignment {
      AlignLeft = 0,
      AlignRight,
      AlignHCenter,
      AlignTop,
      AlignBottom,
      AlignVCenter,
      AlignCenter
    };

    typedef Alignment& Alignment_out;

    static CORBA::TypeCodeConst _tc_Alignment;

    enum InsertOrder {
      LeftToRight = 0,
      RightToLeft
    };

    typedef InsertOrder& InsertOrder_out;

    static CORBA::TypeCodeConst _tc_InsertOrder;

    virtual CORBA::Long insertItem( const CORBA::WChar* text, CORBA::Long ID ) = 0;
    virtual void removeItem( CORBA::Long ID ) = 0;
    virtual void changeItem( const CORBA::WChar* text, CORBA::Long ID ) = 0;
    virtual void setInsertOrder( InsertOrder order ) = 0;
    virtual void setAlignment( CORBA::Long ID, Alignment align ) = 0;
    virtual void setHeight( CORBA::Long height ) = 0;
    virtual void setBorderWidth( CORBA::Long width ) = 0;
    virtual void message( const CORBA::WChar* text, CORBA::Long time ) = 0;
    virtual void clear() = 0;
    virtual void pressed( CORBA::Long ID ) = 0;
    virtual void released( CORBA::Long ID ) = 0;
    virtual CORBA::Boolean enable( BarStatus stat ) = 0;
    virtual CORBA::Boolean isVisible() = 0;

  protected:
    StatusBar() {};
  private:
    StatusBar( const StatusBar& );
    void operator=( const StatusBar& );
};

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_StatusBar;

// Stub for interface StatusBar
class StatusBar_stub:
  virtual public StatusBar,
  virtual public ::KOM::Base_stub
{
  public:
    virtual ~StatusBar_stub();
    CORBA::Long insertItem( const CORBA::WChar* text, CORBA::Long ID );
    void removeItem( CORBA::Long ID );
    void changeItem( const CORBA::WChar* text, CORBA::Long ID );
    void setInsertOrder( InsertOrder order );
    void setAlignment( CORBA::Long ID, Alignment align );
    void setHeight( CORBA::Long height );
    void setBorderWidth( CORBA::Long width );
    void message( const CORBA::WChar* text, CORBA::Long time );
    void clear();
    void pressed( CORBA::Long ID );
    void released( CORBA::Long ID );
    CORBA::Boolean enable( BarStatus stat );
    CORBA::Boolean isVisible();

  private:
    void operator=( const StatusBar_stub& );
};

class StatusBar_skel :
  virtual public StaticMethodDispatcher,
  virtual public StatusBar
{
  public:
    StatusBar_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~StatusBar_skel();
    StatusBar_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    StatusBar_ptr _this();

};

MICO_EXPORT_CONST_DECL const char* eventCreateMenuBar;
typedef ::OpenPartsUI::MenuBar typeCreateMenuBar;
typedef ::OpenPartsUI::MenuBar_ptr typeCreateMenuBar_ptr;
typedef ::OpenPartsUI::MenuBarRef typeCreateMenuBarRef;
typedef ::OpenPartsUI::MenuBar_var typeCreateMenuBar_var;
typedef typeCreateMenuBar_var typeCreateMenuBar_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_typeCreateMenuBar;

MICO_EXPORT_CONST_DECL const char* eventCreateToolBar;
typedef ::OpenPartsUI::ToolBarFactory typeCreateToolBar;
typedef ::OpenPartsUI::ToolBarFactory_ptr typeCreateToolBar_ptr;
typedef ::OpenPartsUI::ToolBarFactoryRef typeCreateToolBarRef;
typedef ::OpenPartsUI::ToolBarFactory_var typeCreateToolBar_var;
typedef typeCreateToolBar_var typeCreateToolBar_out;

MICO_EXPORT_TYPEVAR_DECL CORBA::TypeCodeConst _tc_typeCreateToolBar;

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_OpenPartsUI)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif



#ifndef MICO_CONF_NO_POA

#endif // MICO_CONF_NO_POA

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::BarStatus &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::BarStatus &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_BarStatus;

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::BarPosition &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::BarPosition &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_BarPosition;

void operator<<=( CORBA::Any &_a, const ::OpenPartsUI::Pixmap &_s );
void operator<<=( CORBA::Any &_a, ::OpenPartsUI::Pixmap *_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::OpenPartsUI::Pixmap &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::OpenPartsUI::Pixmap *&_s );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_Pixmap;

void operator<<=( CORBA::Any &a, const OpenPartsUI::MenuData_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::MenuData_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::MenuData_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_MenuData;

void operator<<=( CORBA::Any &a, const OpenPartsUI::Menu_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::Menu_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::Menu_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_Menu;

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::MenuBar::MenuBarPosition &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::MenuBar::MenuBarPosition &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_MenuBar_MenuBarPosition;

void operator<<=( CORBA::Any &a, const OpenPartsUI::MenuBar_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::MenuBar_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::MenuBar_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_MenuBar;

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::ComboBoxPolicy &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::ComboBoxPolicy &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_ComboBoxPolicy;

void operator<<=( CORBA::Any &a, const OpenPartsUI::ToolBar_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::ToolBar_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::ToolBar_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_ToolBar;

void operator<<=( CORBA::Any &a, const OpenPartsUI::ColorBar_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::ColorBar_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::ColorBar_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_ColorBar;

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::ToolBarFactory::Modus &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::ToolBarFactory::Modus &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_ToolBarFactory_Modus;

void operator<<=( CORBA::Any &a, const OpenPartsUI::ToolBarFactory_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::ToolBarFactory_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::ToolBarFactory_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_ToolBarFactory;

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::StatusBar::Alignment &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::StatusBar::Alignment &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_StatusBar_Alignment;

void operator<<=( CORBA::Any &a, const ::OpenPartsUI::StatusBar::InsertOrder &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::OpenPartsUI::StatusBar::InsertOrder &e );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_StatusBar_InsertOrder;

void operator<<=( CORBA::Any &a, const OpenPartsUI::StatusBar_ptr obj );
void operator<<=( CORBA::Any &a, OpenPartsUI::StatusBar_ptr* obj_ptr );
CORBA::Boolean operator>>=( const CORBA::Any &a, OpenPartsUI::StatusBar_ptr &obj );

extern CORBA::StaticTypeInfo *_marshaller_OpenPartsUI_StatusBar;

void operator<<=( CORBA::Any &_a, const WStringSequenceTmpl<CORBA::WString_var> &_s );
void operator<<=( CORBA::Any &_a, WStringSequenceTmpl<CORBA::WString_var> *_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, WStringSequenceTmpl<CORBA::WString_var> &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, WStringSequenceTmpl<CORBA::WString_var> *&_s );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
