/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cpr_y.tab.c
   Applix ASC version: 6
   Date: Mon May 17 21:13:25 1999
*/
#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 87 "cpr_grammar.y"
#include <stdio.h>
#include <ctype.h>
#include "cproto.h"
#include "cpr_symbol.h"
#include "cpr_semantic.h"

#define YYMAXDEPTH 150

extern	int	yylex ARGS((void));

/* declaration specifier attributes for the typedef statement currently being
 * scanned
 */
static int cur_decl_spec_flags;

/* pointer to parameter list for the current function definition */
static ParameterList *func_params;

/* A parser semantic action sets this pointer to the current declarator in
 * a function parameter declaration in order to catch any comments following
 * the parameter declaration on the same line.  If the lexer scans a comment
 * and <cur_declarator> is not NULL, then the comment is attached to the
 * declarator.  To ignore subsequent comments, the lexer sets this to NULL
 * after scanning a comment or end of line.
 */
static Declarator *cur_declarator;

/* temporary string buffer */
static char buf[MAX_TEXT_SIZE];

/* table of typedef names */
static SymbolTable *typedef_names;

/* table of define names */
static SymbolTable *define_names;

/* table of type qualifiers */
static SymbolTable *type_qualifiers;

/* information about the current input file */
typedef struct {
    char *base_name;		/* base input file name */
    char *file_name;		/* current file name */
    FILE *file; 		/* input file */
    unsigned line_num;		/* current line number in input file */
    FILE *tmp_file;		/* temporary file */
    long begin_comment; 	/* tmp file offset after last written ) or ; */
    long end_comment;		/* tmp file offset after last comment */
    boolean convert;		/* if TRUE, convert function definitions */
    boolean changed;		/* TRUE if conversion done in this file */
} IncludeStack;

static IncludeStack *cur_file;	/* current input file */

#include "cpr_yyerror.h"

static int haveAnsiParam ARGS((void));


/* Flags to enable us to find if a procedure returns a value.
 */
static int return_val,	/* nonzero on BRACES iff return-expression found */
	   returned_at;	/* marker for token-number to set 'return_val' */

#if OPT_LINTLIBRARY
static char *dft_decl_spec ARGS((void));

static char *
dft_decl_spec ()
{
    return (lintLibrary() && !return_val) ? "void" : "int";
}

#else
#define dft_decl_spec() "int"
#endif

static int
haveAnsiParam ()
{
    Parameter *p;
    if (func_params != 0) {
	for (p = func_params->first; p != 0; p = p->next) {
	    if (p->declarator->func_def == FUNC_ANSI) {
		return TRUE;
	    }
	}
    }
    return FALSE;
}
#line 103 "y.tab.c"
#define T_IDENTIFIER 257
#define T_TYPEDEF_NAME 258
#define T_DEFINE_NAME 259
#define T_AUTO 260
#define T_EXTERN 261
#define T_REGISTER 262
#define T_STATIC 263
#define T_TYPEDEF 264
#define T_INLINE 265
#define T_CHAR 266
#define T_DOUBLE 267
#define T_FLOAT 268
#define T_INT 269
#define T_VOID 270
#define T_LONG 271
#define T_SHORT 272
#define T_SIGNED 273
#define T_UNSIGNED 274
#define T_ENUM 275
#define T_STRUCT 276
#define T_UNION 277
#define T_APLX1 278
#define T_APLX2 279
#define T_APLX3 280
#define T_APLX4 281
#define T_DECLSPEC 282
#define T_DLLIMPORT 283
#define T_DLLEXPORT 284
#define T_TYPE_QUALIFIER 285
#define T_BRACKETS 286
#define T_LBRACE 287
#define T_MATCHRBRACE 288
#define T_ELLIPSIS 289
#define T_INITIALIZER 290
#define T_STRING_LITERAL 291
#define T_ASM 292
#define T_ASMARG 293
#define T_VA_DCL 294
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   26,   26,   27,   27,   27,   27,   27,   27,
   27,   31,   30,   30,   28,   28,   34,   28,   32,   33,
   33,   35,   35,   37,   38,   29,   39,   29,   36,   36,
   36,   40,   40,    1,    1,    2,    2,    2,    3,    3,
    3,    3,    3,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    5,    5,    6,    6,    6,   19,   19,    8,    8,
    9,   41,    9,    7,    7,    7,   25,   23,   23,   10,
   10,   11,   11,   11,   11,   11,   20,   20,   20,   20,
   20,   20,   21,   21,   22,   22,   22,   22,   14,   14,
   15,   15,   16,   16,   16,   17,   17,   18,   18,   24,
   24,   12,   12,   12,   13,   13,   13,   13,   13,   13,
   13,
};
short yylen[] = {                                         2,
    0,    1,    1,    2,    1,    1,    1,    1,    3,    2,
    2,    2,    3,    3,    2,    3,    0,    5,    1,    0,
    1,    1,    3,    0,    0,    7,    0,    5,    0,    1,
    1,    1,    2,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    4,    4,    1,
    1,    1,    1,    3,    2,    2,    1,    1,    1,    3,
    1,    0,    4,    3,    2,    2,    1,    1,    1,    2,
    1,    1,    3,    2,    4,    4,    2,    3,    3,    4,
    3,    4,    0,    1,    1,    1,    1,    2,    1,    3,
    1,    3,    2,    2,    1,    0,    1,    1,    3,    1,
    2,    1,    2,    1,    3,    2,    1,    4,    3,    3,
    2,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,  110,   57,   63,   39,    0,   41,
   42,   19,   43,   44,   45,   46,   47,   56,   52,   53,
   54,   55,   77,   67,   68,    0,   49,   50,    0,    0,
   62,    0,    7,    0,    0,   34,   36,   37,   38,   60,
   61,   27,    0,    0,    0,   82,    0,    0,    3,    5,
    6,    8,    0,   10,   11,    0,    0,    0,   96,   97,
   95,    0,    0,  111,    0,    0,    0,    0,    0,   40,
   15,   35,    0,   69,    0,    0,    0,   84,   78,   79,
    0,    0,   65,    0,    0,   75,    4,   48,   51,    0,
   83,   88,   98,    0,   14,   13,    0,    0,    0,    0,
    9,   16,    0,   72,    0,   30,   32,    0,    0,  108,
    0,    0,    0,  101,    0,    0,   12,   64,   74,    0,
    0,   90,   92,   58,   59,   70,    0,    0,    0,   33,
    0,  117,  103,  104,    0,    0,   85,    0,   86,    0,
   22,    0,    0,   73,   25,   28,  121,    0,    0,    0,
  116,    0,  100,  102,  109,   18,    0,    0,  115,  120,
  119,    0,   23,   26,  118,
};
short yydgoto[] = {                                      34,
   94,   36,   37,   38,   39,   40,   41,   73,   74,   42,
   43,  134,  135,  112,  113,  114,  115,  116,   44,   45,
   62,   63,   82,   46,   47,   48,   49,   50,   51,   52,
   83,   53,  142,  120,  143,  108,  105,  158,   76,  109,
  127,
};
short yysindex[] = {                                    -38,
  -43,  174, -213, -246,    0,    0,    0,    0, -230,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    3,    0,    0,   11,   33,
    0, -231,    0,    0,  529,    0,    0,    0,    0,    0,
    0,    0,  -37, -238,   31,    0, -238,  -38,    0,    0,
    0,    0,  673,    0,    0,    3,   11,   35,    0,    0,
    0,   45, -233,    0,  586, -213, -213, -260,   20,    0,
    0,    0,  -34,    0,   27,  475,  617,    0,    0,    0,
 -197, -193,    0,  -37, -193,    0,    0,    0,    0,  673,
    0,    0,    0,  529,    0,    0,   45,   45,   55,   56,
    0,    0,  174,    0,  475,    0,    0, -189,  645,    0,
  280,   58,   59,    0,   61,   60,    0,    0,    0,  174,
   27,    0,    0,    0,    0,    0, -190, -182, -181,    0,
  245,    0,    0,    0,  -33,   -6,    0,  353,    0, -146,
    0,   54,   70,    0,    0,    0,    0,   75,   76,  447,
    0,  -33,    0,    0,    0,    0,  174, -169,    0,    0,
    0,   79,    0,    0,    0,
};
short yyrindex[] = {                                    121,
    0,    0,   -5,    0,    0,    0,    0,    0,  558,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  388,    0,    0,  418,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   -3,    0,    0,    0,    0,  122,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,  165,    0,    0,   -5,   -5,    0,    0,    0,
    0,    0,    0,    0,   71, -164,   83,    0,    0,    0,
    0,  109,    0,   34,  139,    0,    0,    0,    0,  -11,
    0,    0,    0,    0,    0,    0,  319,  425,    0,    0,
    0,    0,    0,    0, -164,    0,    0,    0, -162,    0,
  -27,    0,   85,    0,    0,   87,    0,    0,    0,   72,
  -31,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -26,   22,    0,    0,    0,    0,
    0,    0,   73,    0,    0,    0,    0,    0,    0,    0,
    0,   26,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    6,  -30,    0,    0,   19,    0,    0,    0,   30,    7,
  -44,   -2,   -1,  -76,    0,   -4,    0,    0,    0,  -54,
   23,    0,   89,    0,    0,    0,   91,  -25,    0,    0,
  -35,    0,    0,    0,    0,   36,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 958
short yytable[] = {                                       4,
   84,    2,   77,    3,   72,   35,  150,   92,   58,  103,
   64,   86,   71,  105,  114,   55,  105,  114,   79,   80,
   33,   61,   99,  100,  102,    7,   17,   71,   17,   96,
   17,    4,   93,  131,   93,   93,   93,   81,   93,   95,
   81,   75,  122,  123,   66,    7,  118,   17,   81,  119,
  107,   31,   67,   35,  149,   81,  136,   81,   90,   72,
   65,   69,  112,   72,   59,  112,  113,   60,    4,  113,
    2,   31,   68,  162,   80,   91,  136,   80,  101,  107,
   72,   93,  111,  130,   61,   61,    3,  104,   97,   98,
  117,   84,   80,   81,   80,  124,  125,  129,  137,  144,
  121,  139,  138,  140,  145,   87,  146,   87,   87,  121,
  155,   87,  156,  157,   71,  159,  160,  133,  164,  165,
    1,    2,   29,  106,   31,   99,  141,  107,  148,   71,
   20,   21,  126,  154,  152,   85,  111,   58,   87,    0,
  128,    0,    0,  111,    0,    0,   66,    0,   66,   66,
   66,    0,   66,    0,    0,  111,    0,    0,    0,    0,
    0,    0,    0,  163,    0,    0,    0,   66,    0,    0,
    0,    0,    0,    0,    0,    0,   76,    0,   76,   76,
   76,    0,   76,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   76,    0,    0,
    0,    0,   94,    0,   94,   94,   94,    0,   94,    0,
    0,    4,    0,    2,    0,    3,    0,    1,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   54,   17,   31,    0,   78,    0,
    5,   93,  151,   32,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,  132,
   93,   81,    4,   81,  131,  147,    3,    5,    0,    0,
   81,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   80,   80,   80,   80,   80,    0,    4,   80,  131,
   80,    3,   56,    0,   87,   57,    0,   80,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   24,   87,    0,   24,   89,   24,   89,   89,
    0,    0,   89,    0,   24,   66,   66,   66,   66,   66,
   66,   66,    0,   66,   66,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   66,    0,    0,   66,   66,   76,   76,   76,   76,   76,
   76,   76,    0,   76,   76,   76,   76,   76,   76,   76,
   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
   76,   94,    0,   76,   76,   48,    0,   48,   48,    0,
    5,   48,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   94,    0,    0,   94,   48,    0,    0,    0,
   94,   56,    0,    0,   57,   51,    0,   51,   51,    0,
    0,   51,   91,    0,   91,   91,    0,    0,   91,    0,
    0,    0,    0,    0,    0,    0,   51,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  161,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    5,    6,    7,    8,   70,   10,   11,    0,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,    0,    0,   31,
  132,    0,    0,    0,    0,    0,    5,    6,    7,    8,
   70,   10,   11,    0,   13,   14,   15,   16,   17,   18,
   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,    0,    0,   31,  132,    4,    0,    2,    0,
    3,    0,    0,    0,    0,   89,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   71,    0,    0,
    0,    0,    0,    0,    0,   40,    0,   40,    0,   40,
    0,    0,    0,    0,   89,    0,    0,    0,    0,    0,
    6,    7,    8,   70,   10,   11,   40,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   88,   27,   28,   89,   30,    0,    0,   31,    0,    0,
    0,  153,    0,    0,   48,   48,   48,   48,   48,   48,
   48,    0,   48,   48,   48,   48,   48,   48,   48,   48,
   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
    0,    0,   48,   48,   51,   51,   51,   51,   51,   51,
   51,   91,   51,   51,   51,   51,   51,   51,   51,   51,
   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
    0,    0,   51,   51,    6,    7,    8,   70,   10,   11,
   91,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,   23,   24,   25,   88,   27,   28,   89,   30,    0,
    0,   31,    6,    7,    8,   70,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   88,   27,   28,   89,   30,    0,    0,   31,
    0,    0,    0,    0,    0,    0,    0,    0,  106,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    5,    6,    7,    8,   70,
   10,   11,    0,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,    0,    0,   31,   40,   40,   40,   40,   40,   40,
   40,    0,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
    0,    0,   40,    6,    7,    8,   70,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
   23,   24,   25,   88,   27,   28,   89,   30,    0,    0,
   31,    0,   81,  110,    6,    7,    8,   70,   10,   11,
    0,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,   23,   24,   25,   88,   27,   28,   89,   30,    0,
    0,   31,    6,    7,    8,   70,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   88,   27,   28,   89,   30,    0,    0,   31,
    6,    7,    8,   70,   10,   11,    0,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   88,   27,   28,   89,   30,    0,    0,   31,
};
short yycheck[] = {                                      38,
   45,   40,   40,   42,   35,    0,   40,   62,    2,   44,
  257,   47,   44,   41,   41,   59,   44,   44,  257,  258,
   59,    3,  283,  284,   59,  259,   38,   59,   40,   65,
   42,   38,   38,   40,   40,   41,   42,   41,   44,   65,
   44,   35,   97,   98,   42,  259,   82,   59,  287,   85,
   76,  285,   42,   48,  131,   59,  111,   61,   53,   90,
  291,  293,   41,   94,  278,   44,   41,  281,   38,   44,
   40,  285,   40,  150,   41,   41,  131,   44,   59,  105,
  111,   63,   77,  109,   66,   67,   42,   61,   66,   67,
  288,  136,   59,  287,   61,   41,   41,  287,   41,  290,
   94,   41,   44,   44,  287,   38,  288,   40,   41,  103,
  257,   44,   59,   44,   44,   41,   41,  111,  288,   41,
    0,    0,  287,   41,  287,   41,  120,   41,  131,   59,
   59,   59,  103,  138,  136,   47,  131,  131,   48,   -1,
  105,   -1,   -1,  138,   -1,   -1,   38,   -1,   40,   41,
   42,   -1,   44,   -1,   -1,  150,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  157,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   38,   -1,   40,   41,
   42,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   38,   -1,   40,   41,   42,   -1,   44,   -1,
   -1,   38,   -1,   40,   -1,   42,   -1,  256,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  288,  257,  285,   -1,  286,   -1,
  257,  257,  286,  292,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  286,
  286,  285,   38,  287,   40,   41,   42,  257,   -1,   -1,
  294,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,   -1,   38,  285,   40,
  287,   42,  278,   -1,  257,  281,   -1,  294,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  286,   -1,  285,   38,  287,   40,   41,
   -1,   -1,   44,   -1,  294,  257,  258,  259,  260,  261,
  262,  263,   -1,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,   -1,   -1,  285,  286,  257,  258,  259,  260,  261,
  262,  263,   -1,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  257,   -1,  285,  286,   38,   -1,   40,   41,   -1,
  257,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  278,   -1,   -1,  281,   59,   -1,   -1,   -1,
  286,  278,   -1,   -1,  281,   38,   -1,   40,   41,   -1,
   -1,   44,   38,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,  261,  262,  263,   -1,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,   -1,   -1,  285,
  286,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,   -1,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,   -1,   -1,  285,  286,   38,   -1,   40,   -1,
   42,   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  258,  259,  260,  261,  262,  263,   59,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,   -1,   -1,  285,   -1,   -1,
   -1,  289,   -1,   -1,  257,  258,  259,  260,  261,  262,
  263,   -1,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
   -1,   -1,  285,  286,  257,  258,  259,  260,  261,  262,
  263,  257,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
   -1,   -1,  285,  286,  258,  259,  260,  261,  262,  263,
  286,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,   -1,
   -1,  285,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  294,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,
  262,  263,   -1,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,   -1,   -1,  285,  257,  258,  259,  260,  261,  262,
  263,   -1,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
   -1,   -1,  285,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,   -1,   -1,
  285,   -1,  287,  257,  258,  259,  260,  261,  262,  263,
   -1,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,   -1,
   -1,  285,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,   -1,   -1,  285,
  258,  259,  260,  261,  262,  263,   -1,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,   -1,   -1,  285,
};
#define YYFINAL 34
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 294
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'&'",0,"'('","')'","'*'",0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,
"'='",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"T_IDENTIFIER","T_TYPEDEF_NAME","T_DEFINE_NAME","T_AUTO","T_EXTERN",
"T_REGISTER","T_STATIC","T_TYPEDEF","T_INLINE","T_CHAR","T_DOUBLE","T_FLOAT",
"T_INT","T_VOID","T_LONG","T_SHORT","T_SIGNED","T_UNSIGNED","T_ENUM","T_STRUCT",
"T_UNION","T_APLX1","T_APLX2","T_APLX3","T_APLX4","T_DECLSPEC","T_DLLIMPORT",
"T_DLLEXPORT","T_TYPE_QUALIFIER","T_BRACKETS","T_LBRACE","T_MATCHRBRACE",
"T_ELLIPSIS","T_INITIALIZER","T_STRING_LITERAL","T_ASM","T_ASMARG","T_VA_DCL",
};
char *yyrule[] = {
"$accept : program",
"program :",
"program : translation_unit",
"translation_unit : external_declaration",
"translation_unit : translation_unit external_declaration",
"external_declaration : declaration",
"external_declaration : function_definition",
"external_declaration : ';'",
"external_declaration : linkage_specification",
"external_declaration : T_ASM T_ASMARG ';'",
"external_declaration : error T_MATCHRBRACE",
"external_declaration : error ';'",
"braces : T_LBRACE T_MATCHRBRACE",
"linkage_specification : T_EXTERN T_STRING_LITERAL braces",
"linkage_specification : T_EXTERN T_STRING_LITERAL declaration",
"declaration : decl_specifiers ';'",
"declaration : decl_specifiers init_declarator_list ';'",
"$$1 :",
"declaration : any_typedef decl_specifiers $$1 opt_declarator_list ';'",
"any_typedef : T_TYPEDEF",
"opt_declarator_list :",
"opt_declarator_list : declarator_list",
"declarator_list : declarator",
"declarator_list : declarator_list ',' declarator",
"$$2 :",
"$$3 :",
"function_definition : decl_specifiers declarator $$2 opt_declaration_list T_LBRACE $$3 T_MATCHRBRACE",
"$$4 :",
"function_definition : declarator $$4 opt_declaration_list T_LBRACE T_MATCHRBRACE",
"opt_declaration_list :",
"opt_declaration_list : T_VA_DCL",
"opt_declaration_list : declaration_list",
"declaration_list : declaration",
"declaration_list : declaration_list declaration",
"decl_specifiers : decl_specifier",
"decl_specifiers : decl_specifiers decl_specifier",
"decl_specifier : storage_class",
"decl_specifier : type_specifier",
"decl_specifier : type_qualifier",
"storage_class : T_AUTO",
"storage_class : T_EXTERN",
"storage_class : T_REGISTER",
"storage_class : T_STATIC",
"storage_class : T_INLINE",
"type_specifier : T_CHAR",
"type_specifier : T_DOUBLE",
"type_specifier : T_FLOAT",
"type_specifier : T_INT",
"type_specifier : T_APLX1",
"type_specifier : T_APLX2",
"type_specifier : T_APLX3",
"type_specifier : T_APLX4",
"type_specifier : T_LONG",
"type_specifier : T_SHORT",
"type_specifier : T_SIGNED",
"type_specifier : T_UNSIGNED",
"type_specifier : T_VOID",
"type_specifier : T_TYPEDEF_NAME",
"type_specifier : T_DECLSPEC '(' T_DLLIMPORT ')'",
"type_specifier : T_DECLSPEC '(' T_DLLEXPORT ')'",
"type_specifier : struct_or_union_specifier",
"type_specifier : enum_specifier",
"type_qualifier : T_TYPE_QUALIFIER",
"type_qualifier : T_DEFINE_NAME",
"struct_or_union_specifier : struct_or_union any_id braces",
"struct_or_union_specifier : struct_or_union braces",
"struct_or_union_specifier : struct_or_union any_id",
"struct_or_union : T_STRUCT",
"struct_or_union : T_UNION",
"init_declarator_list : init_declarator",
"init_declarator_list : init_declarator_list ',' init_declarator",
"init_declarator : declarator",
"$$5 :",
"init_declarator : declarator '=' $$5 T_INITIALIZER",
"enum_specifier : enumeration any_id braces",
"enum_specifier : enumeration braces",
"enum_specifier : enumeration any_id",
"enumeration : T_ENUM",
"any_id : T_IDENTIFIER",
"any_id : T_TYPEDEF_NAME",
"declarator : pointer direct_declarator",
"declarator : direct_declarator",
"direct_declarator : identifier_or_ref",
"direct_declarator : '(' declarator ')'",
"direct_declarator : direct_declarator T_BRACKETS",
"direct_declarator : direct_declarator '(' parameter_type_list ')'",
"direct_declarator : direct_declarator '(' opt_identifier_list ')'",
"pointer : '*' opt_type_qualifiers",
"pointer : '*' opt_type_qualifiers pointer",
"pointer : T_APLX1 '*' opt_type_qualifiers",
"pointer : T_APLX1 '*' opt_type_qualifiers pointer",
"pointer : T_APLX4 '*' opt_type_qualifiers",
"pointer : T_APLX4 '*' opt_type_qualifiers pointer",
"opt_type_qualifiers :",
"opt_type_qualifiers : type_qualifier_list",
"type_qualifier_list : type_qualifier",
"type_qualifier_list : T_APLX1",
"type_qualifier_list : T_APLX4",
"type_qualifier_list : type_qualifier_list type_qualifier",
"parameter_type_list : parameter_list",
"parameter_type_list : parameter_list ',' T_ELLIPSIS",
"parameter_list : parameter_declaration",
"parameter_list : parameter_list ',' parameter_declaration",
"parameter_declaration : decl_specifiers declarator",
"parameter_declaration : decl_specifiers abs_declarator",
"parameter_declaration : decl_specifiers",
"opt_identifier_list :",
"opt_identifier_list : identifier_list",
"identifier_list : T_IDENTIFIER",
"identifier_list : identifier_list ',' T_IDENTIFIER",
"identifier_or_ref : T_IDENTIFIER",
"identifier_or_ref : '&' T_IDENTIFIER",
"abs_declarator : pointer",
"abs_declarator : pointer direct_abs_declarator",
"abs_declarator : direct_abs_declarator",
"direct_abs_declarator : '(' abs_declarator ')'",
"direct_abs_declarator : direct_abs_declarator T_BRACKETS",
"direct_abs_declarator : T_BRACKETS",
"direct_abs_declarator : direct_abs_declarator '(' parameter_type_list ')'",
"direct_abs_declarator : direct_abs_declarator '(' ')'",
"direct_abs_declarator : '(' parameter_type_list ')'",
"direct_abs_declarator : '(' ')'",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 866 "cpr_grammar.y"

#include "cpr_lex.h"

int ExpectedOK;  /* used on NT.  If false, do not output "expected" error */
                 /* line since error is from Microsoft include files.     */

static void
yaccError (msg)
char *msg;
{
    func_params = NULL;
    ExpectedOK = FALSE;
#if MSDOS
    if ( put_error() )
        {
        ExpectedOK = TRUE;
        fprintf(stderr, "%s at token '%s'\n", msg, yytext);
        }
#else
    put_error();		/* tell what line we're on, and what file */
    fprintf(stderr, "%s at token '%s'\n", msg, yytext);
#endif
}

/* Initialize the table of type qualifier keywords recognized by the lexical
 * analyzer.
 */
void
init_parser ()
{
    static char *keywords[] = {
	"const", "volatile", "interrupt",
#ifdef vms
	"noshare", "readonly",
#endif
#if defined(MSDOS) || defined(OS2)
	"cdecl", "far", "huge", "near", "pascal",
	"_cdecl", "_export", "_far", "_fastcall", "_fortran", "_huge",
	"_interrupt", "_loadds", "_near", "_pascal", "_saveregs", "_segment",
	"_cs", "_ds", "_es", "_ss", "_seg",
	"__cdecl", "__export", "__far", "__fastcall", "__fortran", "__huge",
	"__inline", "__interrupt", "__loadds", "__near", "__pascal",
	"__saveregs", "__segment", "__stdcall", "__syscall",
#ifdef OS2
	"__far16",
#endif
#else
	"__const", "__inline__",
#endif
    };
    int i;

    /* Initialize type qualifier table. */
    type_qualifiers = new_symbol_table();
    for (i = 0; i < sizeof(keywords)/sizeof(keywords[0]); ++i) {
	new_symbol(type_qualifiers, keywords[i], NULL, DS_NONE);
    }
}

/* Process the C source file.  Write function prototypes to the standard
 * output.  Convert function definitions and write the converted source
 * code to a temporary file.
 */
void
process_file (infile, name)
FILE *infile;
char *name;
{
    char *s;

    if (strlen(name) > 2) {
	s = name + strlen(name) - 2;
	if (*s == '.') {
	    ++s;
	    if (*s == 'l' || *s == 'y')
		BEGIN LEXYACC;
#if defined(MSDOS) || defined(OS2)
	    if (*s == 'L' || *s == 'Y')
		BEGIN LEXYACC;
#endif
	}
    }

    included_files = new_symbol_table();
    typedef_names = new_symbol_table();
    define_names = new_symbol_table();
    inc_depth = -1;
    curly = 0;
    ly_count = 0;
    func_params = NULL;
    yyin = infile;
    include_file(strcpy(base_file, name), func_style != FUNC_NONE);
    if (file_comments) {
#if OPT_LINTLIBRARY
    	if (lintLibrary()) {
	    put_blankline(stdout);
	    begin_tracking();
	}
#endif
	put_string(stdout, "/* ");
	put_string(stdout, cur_file_name());
	put_string(stdout, " */\n");
    }
    yyparse();
    free_symbol_table(define_names);
    free_symbol_table(typedef_names);
    free_symbol_table(included_files);
}

#ifdef NO_LEAKS
void
free_parser()
{
    free_symbol_table (type_qualifiers);
#ifdef FLEX_SCANNER
    if (yy_current_buffer != 0)
	yy_delete_buffer(yy_current_buffer);
#endif
}
#endif
#line 718 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 10:
#line 197 "cpr_grammar.y"
{
	    yyerrok;
	}
break;
case 11:
#line 201 "cpr_grammar.y"
{
	    yyerrok;
	}
break;
case 13:
#line 212 "cpr_grammar.y"
{
	    /* Provide an empty action here so bison will not complain about
	     * incompatible types in the default action it normally would
	     * have generated.
	     */
	}
break;
case 14:
#line 219 "cpr_grammar.y"
{
	    /* empty */
	}
break;
case 15:
#line 226 "cpr_grammar.y"
{
#if OPT_LINTLIBRARY
	    if (types_out && want_typedef()) {
		gen_declarations(&yyvsp[-1].decl_spec, (DeclaratorList *)0);
		flush_varargs();
	    }
#endif
	    free_decl_spec(&yyvsp[-1].decl_spec);
	    end_typedef();
	}
break;
case 16:
#line 237 "cpr_grammar.y"
{
	    if (func_params != NULL) {
		set_param_types(func_params, &yyvsp[-2].decl_spec, &yyvsp[-1].decl_list);
	    } else {
		gen_declarations(&yyvsp[-2].decl_spec, &yyvsp[-1].decl_list);
		flush_varargs();
		free_decl_list(&yyvsp[-1].decl_list);
	    }
	    free_decl_spec(&yyvsp[-2].decl_spec);
	    end_typedef();
	}
break;
case 17:
#line 249 "cpr_grammar.y"
{
	    cur_decl_spec_flags = yyvsp[0].decl_spec.flags;
	    free_decl_spec(&yyvsp[0].decl_spec);
	}
break;
case 18:
#line 254 "cpr_grammar.y"
{
	    end_typedef();
	}
break;
case 19:
#line 261 "cpr_grammar.y"
{
	    begin_typedef();
	}
break;
case 22:
#line 273 "cpr_grammar.y"
{
	    int flags = cur_decl_spec_flags;

	    /* If the typedef is a pointer type, then reset the short type
	     * flags so it does not get promoted.
	     */
	    if (strcmp(yyvsp[0].declarator->text, yyvsp[0].declarator->name) != 0)
		flags &= ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, yyvsp[0].declarator->name, NULL, flags);
	    free_declarator(yyvsp[0].declarator);
	}
break;
case 23:
#line 285 "cpr_grammar.y"
{
	    int flags = cur_decl_spec_flags;

	    if (strcmp(yyvsp[0].declarator->text, yyvsp[0].declarator->name) != 0)
		flags &= ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, yyvsp[0].declarator->name, NULL, flags);
	    free_declarator(yyvsp[0].declarator);
	}
break;
case 24:
#line 297 "cpr_grammar.y"
{
	    check_untagged(&yyvsp[-1].decl_spec);
	    if (yyvsp[0].declarator->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &(yyvsp[0].declarator->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
break;
case 25:
#line 308 "cpr_grammar.y"
{
	    /* If we're converting to K&R and we've got a nominally K&R
	     * function which has a parameter which is ANSI (i.e., a prototyped
	     * function pointer), then we must override the deciphered value of
	     * 'func_def' so that the parameter will be converted.
	     */
	    if (func_style == FUNC_TRADITIONAL
	     && haveAnsiParam()
	     && yyvsp[-3].declarator->head->func_def == func_style) {
		yyvsp[-3].declarator->head->func_def = FUNC_BOTH;
	    }

	    func_params = NULL;

	    if (cur_file->convert)
		gen_func_definition(&yyvsp[-4].decl_spec, yyvsp[-3].declarator);
	    gen_prototype(&yyvsp[-4].decl_spec, yyvsp[-3].declarator);
	    flush_varargs();
	    free_decl_spec(&yyvsp[-4].decl_spec);
	    free_declarator(yyvsp[-3].declarator);
	}
break;
case 27:
#line 331 "cpr_grammar.y"
{
	    if (yyvsp[0].declarator->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &(yyvsp[0].declarator->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
break;
case 28:
#line 341 "cpr_grammar.y"
{
	    DeclSpec decl_spec;

	    func_params = NULL;

	    new_decl_spec(&decl_spec, dft_decl_spec(), yyvsp[-4].declarator->begin, DS_NONE);
	    if (cur_file->convert)
		gen_func_definition(&decl_spec, yyvsp[-4].declarator);
	    gen_prototype(&decl_spec, yyvsp[-4].declarator);
	    flush_varargs();
	    free_decl_spec(&decl_spec);
	    free_declarator(yyvsp[-4].declarator);
	}
break;
case 35:
#line 370 "cpr_grammar.y"
{
	    join_decl_specs(&yyval.decl_spec, &yyvsp[-1].decl_spec, &yyvsp[0].decl_spec);
	    free(yyvsp[-1].decl_spec.text);
	    free(yyvsp[0].decl_spec.text);
	}
break;
case 39:
#line 385 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 40:
#line 395 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_EXTERN);
	}
break;
case 41:
#line 399 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 42:
#line 403 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_STATIC);
	}
break;
case 43:
#line 407 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_JUNK);
	}
break;
case 44:
#line 414 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_CHAR);
	}
break;
case 45:
#line 418 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 46:
#line 422 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_FLOAT);
	}
break;
case 47:
#line 426 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 48:
#line 430 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 49:
#line 434 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 50:
#line 438 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 51:
#line 442 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 52:
#line 446 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 53:
#line 450 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_SHORT);
	}
break;
case 54:
#line 454 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 55:
#line 458 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 56:
#line 462 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 57:
#line 466 "cpr_grammar.y"
{
	    Symbol *s;
	    s = find_symbol(typedef_names, yyvsp[0].text.text);
	    if (s != NULL)
		new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, s->flags);
	}
break;
case 58:
#line 473 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, "__declspec ( dllimport )", yyvsp[-3].text.begin, DS_NONE);
	}
break;
case 59:
#line 477 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, "__declspec ( dllexport )", yyvsp[-3].text.begin, DS_NONE);
	}
break;
case 62:
#line 486 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 63:
#line 490 "cpr_grammar.y"
{
	    /* This rule allows the <pointer> nonterminal to scan #define
	     * names as if they were type modifiers.
	     */
	    Symbol *s;
	    s = find_symbol(define_names, yyvsp[0].text.text);
	    if (s != NULL)
		new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, s->flags);
	}
break;
case 64:
#line 503 "cpr_grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0)
	        (void)sprintf(s = buf, "%s %s", yyvsp[-2].text.text, yyvsp[-1].text.text);
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-2].text.begin, DS_NONE);
	}
break;
case 65:
#line 510 "cpr_grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0)
		(void)sprintf(s = buf, "%s {}", yyvsp[-1].text.text);
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 66:
#line 517 "cpr_grammar.y"
{
	    (void)sprintf(buf, "%s %s", yyvsp[-1].text.text, yyvsp[0].text.text);
	    new_decl_spec(&yyval.decl_spec, buf, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 67:
#line 525 "cpr_grammar.y"
{
	    imply_typedef(yyval.text.text);
	}
break;
case 68:
#line 529 "cpr_grammar.y"
{
	    imply_typedef(yyval.text.text);
	}
break;
case 69:
#line 536 "cpr_grammar.y"
{
	    new_decl_list(&yyval.decl_list, yyvsp[0].declarator);
	}
break;
case 70:
#line 540 "cpr_grammar.y"
{
	    add_decl_list(&yyval.decl_list, &yyvsp[-2].decl_list, yyvsp[0].declarator);
	}
break;
case 71:
#line 547 "cpr_grammar.y"
{
	    if (yyvsp[0].declarator->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator(yyvsp[0].declarator);
		fputs(cur_text(), cur_file->tmp_file);
	    }
	    cur_declarator = yyval.declarator;
	}
break;
case 72:
#line 556 "cpr_grammar.y"
{
	    if (yyvsp[-1].declarator->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator(yyvsp[-1].declarator);
		fputs(" =", cur_file->tmp_file);
	    }
	}
break;
case 74:
#line 568 "cpr_grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0)
		(void)sprintf(s = buf, "enum %s", yyvsp[-1].text.text);
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-2].text.begin, DS_NONE);
	}
break;
case 75:
#line 575 "cpr_grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0)
		(void)sprintf(s = buf, "%s {}", yyvsp[-1].text.text);
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 76:
#line 582 "cpr_grammar.y"
{
	    (void)sprintf(buf, "enum %s", yyvsp[0].text.text);
	    new_decl_spec(&yyval.decl_spec, buf, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 77:
#line 590 "cpr_grammar.y"
{
	    imply_typedef("enum");
	    yyval.text = yyvsp[0].text;
	}
break;
case 80:
#line 603 "cpr_grammar.y"
{
	    yyval.declarator = yyvsp[0].declarator;
	    (void)sprintf(buf, "%s%s", yyvsp[-1].text.text, yyval.declarator->text);
	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(buf);
	    yyval.declarator->begin = yyvsp[-1].text.begin;
	    yyval.declarator->pointer = TRUE;
	}
break;
case 82:
#line 616 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator(yyvsp[0].text.text, yyvsp[0].text.text, yyvsp[0].text.begin);
	}
break;
case 83:
#line 620 "cpr_grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;
	    (void)sprintf(buf, "(%s)", yyval.declarator->text);
	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(buf);
	    yyval.declarator->begin = yyvsp[-2].text.begin;
	}
break;
case 84:
#line 628 "cpr_grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;
	    (void)sprintf(buf, "%s%s", yyval.declarator->text, yyvsp[0].text.text);
	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(buf);
	}
break;
case 85:
#line 635 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator("%s()", yyvsp[-3].declarator->name, yyvsp[-3].declarator->begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = yyvsp[-3].declarator;
	    yyval.declarator->head = (yyvsp[-3].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-3].declarator->head;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 86:
#line 643 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator("%s()", yyvsp[-3].declarator->name, yyvsp[-3].declarator->begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = yyvsp[-3].declarator;
	    yyval.declarator->head = (yyvsp[-3].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-3].declarator->head;
	    yyval.declarator->func_def = FUNC_TRADITIONAL;
	}
break;
case 87:
#line 654 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "*%s", yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-1].text.begin;
	}
break;
case 88:
#line 659 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "*%s%s", yyvsp[-1].text.text, yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-2].text.begin;
	}
break;
case 89:
#line 664 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "__cdecl *%s", yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-2].text.begin;
	}
break;
case 90:
#line 669 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "__cdecl *%s%s", yyvsp[-1].text.text, yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-3].text.begin;
	}
break;
case 91:
#line 674 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "__cdecl *%s", yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-2].text.begin;
	}
break;
case 92:
#line 679 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "__cdecl *%s%s", yyvsp[-1].text.text, yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-3].text.begin;
	}
break;
case 93:
#line 687 "cpr_grammar.y"
{
	    strcpy(yyval.text.text, "");
	    yyval.text.begin = 0L;
	}
break;
case 95:
#line 696 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "%s ", yyvsp[0].decl_spec.text);
	    yyval.text.begin = yyvsp[0].decl_spec.begin;
	    free(yyvsp[0].decl_spec.text);
	}
break;
case 96:
#line 702 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.text, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 97:
#line 706 "cpr_grammar.y"
{
	    new_decl_spec(&yyval.text, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 98:
#line 710 "cpr_grammar.y"
{
	    (void)sprintf(yyval.text.text, "%s%s ", yyvsp[-1].text.text, yyvsp[0].decl_spec.text);
	    yyval.text.begin = yyvsp[-1].text.begin;
	    free(yyvsp[0].decl_spec.text);
	}
break;
case 100:
#line 720 "cpr_grammar.y"
{
	    add_ident_list(&yyval.param_list, &yyvsp[-2].param_list, "...");
	}
break;
case 101:
#line 727 "cpr_grammar.y"
{
	    new_param_list(&yyval.param_list, yyvsp[0].parameter);
	}
break;
case 102:
#line 731 "cpr_grammar.y"
{
	    add_param_list(&yyval.param_list, &yyvsp[-2].param_list, yyvsp[0].parameter);
	}
break;
case 103:
#line 738 "cpr_grammar.y"
{
	    check_untagged(&yyvsp[-1].decl_spec);
	    yyval.parameter = new_parameter(&yyvsp[-1].decl_spec, yyvsp[0].declarator);
	}
break;
case 104:
#line 743 "cpr_grammar.y"
{
	    check_untagged(&yyvsp[-1].decl_spec);
	    yyval.parameter = new_parameter(&yyvsp[-1].decl_spec, yyvsp[0].declarator);
	}
break;
case 105:
#line 748 "cpr_grammar.y"
{
	    check_untagged(&yyvsp[0].decl_spec);
	    yyval.parameter = new_parameter(&yyvsp[0].decl_spec, (Declarator *)0);
	}
break;
case 106:
#line 756 "cpr_grammar.y"
{
	    new_ident_list(&yyval.param_list);
	}
break;
case 108:
#line 764 "cpr_grammar.y"
{
	    new_ident_list(&yyval.param_list);
	    add_ident_list(&yyval.param_list, &yyval.param_list, yyvsp[0].text.text);
	}
break;
case 109:
#line 769 "cpr_grammar.y"
{
	    add_ident_list(&yyval.param_list, &yyvsp[-2].param_list, yyvsp[0].text.text);
	}
break;
case 110:
#line 776 "cpr_grammar.y"
{
	    yyval.text = yyvsp[0].text;
	}
break;
case 111:
#line 780 "cpr_grammar.y"
{
#if OPT_LINTLIBRARY
	    if (lintLibrary()) { /* Lint doesn't grok C++ ref variables */
		yyval.text = yyvsp[0].text;
	    } else
#endif
		(void)sprintf(yyval.text.text, "&%s", yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-1].text.begin;
	}
break;
case 112:
#line 793 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator(yyvsp[0].text.text, "", yyvsp[0].text.begin);
	}
break;
case 113:
#line 797 "cpr_grammar.y"
{
	    yyval.declarator = yyvsp[0].declarator;
	    (void)sprintf(buf, "%s%s", yyvsp[-1].text.text, yyval.declarator->text);
	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(buf);
	    yyval.declarator->begin = yyvsp[-1].text.begin;
	}
break;
case 115:
#line 809 "cpr_grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;
	    (void)sprintf(buf, "(%s)", yyval.declarator->text);
	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(buf);
	    yyval.declarator->begin = yyvsp[-2].text.begin;
	}
break;
case 116:
#line 817 "cpr_grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;
	    (void)sprintf(buf, "%s%s", yyval.declarator->text, yyvsp[0].text.text);
	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(buf);
	}
break;
case 117:
#line 824 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator(yyvsp[0].text.text, "", yyvsp[0].text.begin);
	}
break;
case 118:
#line 828 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-3].declarator->begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = yyvsp[-3].declarator;
	    yyval.declarator->head = (yyvsp[-3].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-3].declarator->head;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 119:
#line 836 "cpr_grammar.y"
{
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-2].declarator->begin);
	    yyval.declarator->func_stack = yyvsp[-2].declarator;
	    yyval.declarator->head = (yyvsp[-2].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-2].declarator->head;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 120:
#line 843 "cpr_grammar.y"
{
	    Declarator *d;
	    
	    d = new_declarator("", "", yyvsp[-2].text.begin);
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-2].text.begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = d;
	    yyval.declarator->head = yyval.declarator;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 121:
#line 854 "cpr_grammar.y"
{
	    Declarator *d;
	    
	    d = new_declarator("", "", yyvsp[-1].text.begin);
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-1].text.begin);
	    yyval.declarator->func_stack = d;
	    yyval.declarator->head = yyval.declarator;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
#line 1573 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
