/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: bldrbltn.h
   Applix ASC version: 6
   Date: Mon Nov 16 13:56:45 1998
*/
#ifndef BLDRBLTN_INCLUDED
#define BLDRBLTN_INCLUDED

#define BLDR_BAD_HANDLE -1

/*
   The following structures define the "context" in which a builder
   application inset executes.  Note that if any of these structures
   change, the following methods/procedures must be modified
   accordingly:
   1.  AxfBuilderGetContainerInfo in bldrbltn.h
   2.  assign_container_application_context$ in oapp.els
*/

typedef struct bldr_container_info_for_ss {
	int32           tl_row;
	int32           br_row;
	short           tl_col;
	short           tl_plate;
	short           br_col;
	short           br_plate;
} bldr_container_info_for_ss;

data_ptr bldrPackageInsetObject AXP_((data_ptr uidP, data_ptr srcP, data_ptr unitsP));
int bldrMeasureInsetObject AXP_((data_ptr objP, data_ptr *unitP, data_ptr *areaP));
void bldrRenderAssociatedGraphic AXP_((AXWidget w, data_ptr objP, data_ptr infP));
void AxFreeBldrByPID AXP_((int pid));
typeErr bldrSetContainerInfo AXP_((int bldr_inst, int c_app, void *c_app_data));
typeErr bldrSetTaskJustStartedFlag AXP_((int bldr_inst, int flag_val));
data_ptr AxfBuilderSetRootPathname AXP_((data_ptr argDatum));

#endif /* BLDRBLTN_INCLUDED */
