/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: bldrcorba.hh
   Applix ASC version: 2
   Date: Mon Nov 16 14:27:53 1998
*/
#ifndef _BLDRCORBA_HH_
#define _BLDRCORBA_HH_

#include <stdlib.h>
#include <elfapi.hh>
#include <bldrextbase.hh>
#include <bldrcorbainfo.hh>

/***************************************************
methodList					- defined in Parent
helpOnAllMethods			- defined in Parent
helpOnMethod				- defined in Parent
additionalInfo				- defined in Parent

invokeMethod				- pure virtual in Parent
listOfObjects				- pure virtual in Parent
infoObject					- pure virtual in Parent	
newInfoObject				- pure virtual in Parent


createObject				- virtual, defined here
getInterfaceName			- virtual, defined here

setInvocationMode			- pure virtual
getInvocationMode			- pure virtual
deferredInvocationResult	- pure virtual

Protected Pure Virtual Methods 
_createUsingSOR


****************************************************/
class BuilderCorba : public BuilderExternalObjectRoot {
	public: 
		virtual void *createObject(
			elfData objectInfo,
			int *status,
			elfData addInfo=0
				);
		virtual elfData getInterfaceName (
			elfData arg1,
			elfData arg2,
			int *status
				);
	public:
		virtual void setModeOfInvocation (
			int mode,
			elfData addInfo=0
				) = 0;
		virtual int getModeOfInvocation (
			elfData addInfo=0
				) = 0;
		virtual elfData deferredInvocationResult (
			elfData reqId,
			int *status,
			elfData addInfo=0
				) = 0;
		virtual void* objectPtr (void) = 0;

	protected:
		virtual void _createUsingSOR (
			elfData objectInfo,
			int *status,
			elfData addInfo
				) = 0;
		virtual void _createUsingNamingService (
			elfData objectInfo,
			int *status,
			elfData addInfo
				) = 0;
		virtual void _createUsingInitialReference (
			elfData objectInfo,
			int *status,
			elfData addInfo
				) = 0;
		virtual void _createUsingUserInfo (		
			elfData objectInfo,
			int *status,
			elfData addInfo
				) = 0;
		virtual void* _objectFromString (
			elfData arg
				) = 0;
		virtual void* _objectFromNamingService (
			elfData arg
				) = 0;
		virtual void* _objectFromInitialReference (
			elfData arg
				) = 0;
		virtual void releaseObject (
			void *obj
				) = 0;

};

typedef BuilderCorba corbabase;
typedef BuilderCorba bldrcorba;

#endif	// _BLDRCORBA_HH_
