/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: bldrcorbainfo.hh
   Applix ASC version: 2
   Date: Mon Nov 16 14:27:53 1998
*/
#ifndef _BLDRCORBAINFO_
#define _BLDRCORBAINFO_

#include <elfapi.hh>
#include <string.h>
#include <bldrextinfobase.hh>
/******************************************************************
method_name
helpOnMethod
method_has_return
interfaceNameFromObject
method_exists
object_name
number_of_methods
additionalInfo
update_class_info
server_name
host_name

impl
host
marker
intf_impl
intf_host
intf_marker
 
******************************************************************/
class bldrcorbainfo : public bldrextinfobase {
    public:
		virtual elfData interfaceNameFromObject(
			void *obj, 
			int *status
				) = 0;

	public:
		bldrcorbainfo();
		~bldrcorbainfo();

		virtual void update_class_info(elfData addInfo);
		virtual void object_name(char *n);

		virtual char *object_name(void) 	{ return _objectName; }
		virtual char *server_name(void) 	{ return _impl; }
		virtual char *host_name(void)   	{ return _host; }

		virtual char *impl(void)		{ return _impl; }
		virtual char *host(void)		{ return _host; }
		virtual char *marker(void)   	{ return _marker; }
		virtual char *intf_impl(void)	{ return _intfImpl; }
		virtual char *intf_host(void)	{ return _intfHost; }
		virtual char *intf_marker(void) { return _intfMarker; }

		virtual void host(char *h)	{ _host = new char[strlen(h)+1];
									  strcpy(_host,h);
									}
		

	protected:
		char *_objectName;
		char *_host, *_impl, *_marker;
		char *_intfHost, *_intfImpl, *_intfMarker;
		int _delMe; 
		
			
};

#endif 	// _BLDRCORBAINFO_
