/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: bldrextinfobase.hh
   Applix ASC version: 5
   Date: Mon Nov 16 14:27:53 1998
*/
#ifndef _BLDREXTINFOBASE_
#define _BLDREXTINFOBASE_

#include <elfapi.hh>

class bldrextinfobase {
    public:

// **************************************************************************
//                  P U R E    V I R T U A L     M E T H O D S
// **************************************************************************

		/* Return the name of this object */
		virtual char *object_name(void) = 0;

		/* Return the total number of methods supported by this object */
        virtual int number_of_methods(elfData addInfo = 0) = 0;

		/* Return the method name of the ix'th method */
        virtual char *method_name(int ix,elfData addInfo = 0) = 0;

		/* Return a help str to be displayed in the quick help */
        virtual elfData helpOnMethod(char *methodName, elfData addInfo = 0) = 0;

		/* Return any additional info (structs, constants, exceptions etc) 
		   used by the object - displayed to the user*/
        virtual elfData additionalInfo(elfData addInfo=0) = 0;

		/* Return 0 if the method has a void return type - determines if a method
		   is a "set" or a "get" type.*/
		virtual int method_has_return(char *methodName, elfData addInfo = 0) = 0;

		/* Update any other class related information reqd */
		virtual void update_class_info(elfData addInfo) = 0;

		/* Return an elf array with all structs converted to formats */
		virtual elfData structsAsFormats(elfData arg1, elfData addInfo=0) = 0;


	
// **************************************************************************
//					V I R T U A L     M E T H O D S
// **************************************************************************
		/* Return true of method exists (1) else false (0) */
		virtual int methodExists(char *methodName, elfData addInfo = 0);
		
		/* Return the list of methods supported by interface */
		virtual elfData methodList(elfData addInfo);

		/* Return help on the list of methods given */
		virtual elfData helpOnMethodList(elfData methodList, elfData addInfo=0);

		/* Return help on all the methods in this object */
		virtual elfData helpOnAllMethods(elfData addInfo);
};

#endif 	// _BLDREXTINFOBASE_
