/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: bldrextint.hh
   Applix ASC version: 13
   Date: Mon Nov 16 14:27:53 1998
*/
#ifndef _BLDREXTINT_
#define _BLDREXTINT_
 
#include <aos.h>
#include <string.h>

#ifdef getenv
#undef getenv
#endif

#define AX_USE_PROTOS 1
#include <elapi.h>

#ifdef __cplusplus

#include <bldrextbase.hh>
#include <bldrextinfobase.hh>
#include <bldrcorba.hh>
#include <axlist.hh>
 
/** Functions found in CORBA Library */
extern void *newExtCorbaObject(void);
extern int  IsAxCorbaLib(void);

extern  "C" {
extern  void ElfStrAbort(int, char *, char *);
extern  void *AxCorbaObjectId(data_ptr);

 
// Needed by all External Object Models.
void*	bldrControlForType		(int type);

data_ptr bldrInvokeMethodOnExtObj(
	bldrextobjectbase *extObj, 
    char *methodName,
    data_ptr args,
    int *status
);

data_ptr bldrExtObjMethodList(
    bldrextobjectbase *extObj,
    data_ptr addInfo
);

data_ptr bldrExtHelpOnMethod(
	bldrextobjectbase *extObj,
	data_ptr methodName,
	data_ptr addInfo
);

bldrextobjectbase *bldrExtNewObj(int type);
data_ptr bldrExtHelpOnAllMethods(data_ptr arg1);
data_ptr bldrExtAdditionalInfo(data_ptr, data_ptr);
bldrextinfobase *bldrExtInfoFromList(char *);
int  bldrExtInfoCmp(void *arg1, void *arg2);
void *bldrExtCreateClassObj(
	data_ptr className, 
	data_ptr classInfo,
	data_ptr addInfo,
	int *status);

void *bldrExtCreateObject(	
	data_ptr, 
	bldrextobjectbase *,
	int *, 
	data_ptr
);
 
data_ptr
bldrExtStructsAsFormats(
    bldrextobjectbase *extObj,
    data_ptr arg1,
    data_ptr addInfo
    );

data_ptr bldrExtListOfObjects(
	data_ptr,
	data_ptr,
	data_ptr
	);

// Supported by the CORBA Object Model.
void bldrExtSetInvocationMode(
	corbabase *extObj,
	int mode,
	data_ptr addInfo
);

data_ptr bldrExtGetInvocationMode(
	corbabase *extObj,
	data_ptr addInfo
);

data_ptr bldrDeferredInvocationResult(
	corbabase *extObj,
	data_ptr reqId,
	int *status,
	data_ptr addInfo
);

data_ptr bldrGetInterfaceName(
    data_ptr arg1,
    data_ptr arg2,
    int *status
);

int	bldrExtMethodExists(bldrextobjectbase *, char *);
void *bldrExtObjFromElfObj(data_ptr elfObj);
void bldrUpdateClassInfo(bldrextobjectbase *, data_ptr);
data_ptr bldrDummyCallToLoadLibrary(void);
void bldrSetExtInheritance(
	bldrextobjectbase *, 
	bldrextobjectbase *, 
	data_ptr
);
void bldrExtDeleteObject(bldrextobjectbase *obj);
data_ptr bldrUseAxORB(void);
void *bldrExtRegisterCallBack(int dex, int uid, bldrextobjectbase *obj);
void bldrExtAppTerminated(bldrextobjectbase *obj);

};	// extern "C"
 
enum {ORBIX, ORBPLUS, CPLUSPLUS};
#else	/* _cplusplus */
/* This is to satisfy the C binding - mostly calls from elobj.c */

typedef void axlist;
typedef void bldrextobjectbase;
typedef void corbabase;
typedef void bldrextinfobase;


extern data_ptr bldrDummyCallToLoadLibrary(void);
extern data_ptr bldrExtObjMethodList(void *,data_ptr);
extern void		*bldrExtCreateObject(data_ptr, void *, int *, data_ptr);
extern data_ptr bldrInvokeMethodOnExtObj(void*,char*,data_ptr,int*);
extern data_ptr bldrExtHelpOnMethod(void*, data_ptr, data_ptr);
extern data_ptr bldrExtAdditionalInfo(data_ptr, data_ptr);
extern data_ptr bldrExtStructsToFormats(void *, data_ptr, data_ptr);
extern int		bldrExtMethodExists(void *, char *);
extern data_ptr bldrDeferredInvocationResult(void*, data_ptr, int *, data_ptr);
extern void 	bldrUpdateClassInfo(void *, data_ptr);
extern void 	*bldrExtObjFromElfObj(data_ptr);
extern void 	*bldrExtCreateClassObj(data_ptr, data_ptr, data_ptr, int * );
extern data_ptr bldrExtStructsAsFormats(void *extObj, data_ptr arg1, data_ptr addInfo);
extern void		bldrSetExtInheritance(void *obj, void *inh, data_ptr addInfo);
extern void		bldrExtDeleteObject(void *obj);
extern data_ptr bldrUseAxORB(void);
extern void		*bldrExtRegisterCallBack(int dex, int uid, void *);
extern void 	bldrExtAppTerminated(void *obj);

#endif	/* cplusplus */
#endif	/* _BLDREXTINT_ */
