/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elfolap.h
   Applix ASC version: 11
   Date: Mon Nov 16 13:56:44 1998
*/
#define MAX_ENV_VARS          20
#define MAX_ENV_VAR_STR_LEN  400

/*****************************/
/* AxDispatch Case Constants */
/*****************************/

#define ELFOLAP_PING_                         0
#define ELFOLAP_PAUSE_                        1 /* pause for debug attch */
#define ELFOLAP_LOGGING_                      2
#define ELFOLAP_LOG_INPUT_FUNCDATA_           3
#define ELFOLAP_QUIT_NOW_                     4

#define ELFOLAP_INIT_ENV_VARS_               10
#define ELFOLAP_INIT_API_                    11
#define ELFOLAP_GET_APPL_DBASE_PAIRS_        12 /* Essbase Only */
#define ELFOLAP_LIST_TABLES_                 12 /* TM1 only */
#define ELFOLAP_CONNECT_                     13
#define ELFOLAP_SELECT_TABLE_                14 /* TM1 only */
#define ELFOLAP_ADD_TABLES_                  15 /* TM1 only */
#define ELFOLAP_DELETE_TABLES_               16 /* TM1 only */

#define ELFOLAP_GET_DIMENSION_HIERARCHIES_   20
#define ELFOLAP_GET_DIMENSIONS_ONLY_         21

#define ELFOLAP_GET_DATA_                    30
#define ELFOLAP_GET_INCR_DATA_               31
#define ELFOLAP_SETUP_FAST_DATA_RETRIEVE     32 /* TM1 only */
#define ELFOLAP_FAST_DATA_RETRIEVE           33 /* TM1 only */

#define ELFOLAP_UPDATE_DATA_                 40 /* TM1 only */

#define ELFOLAP_DISCONNECT_                  80
#define ELFOLAP_TERM_API_                    90

#define ELFOLAP_TERMINATE_EXEC_             100

/***************/
/* Error Codes */
/***************/

/*
   Note that positive return values are reserved so that the gateway
   program can indicate *where* a problem occurred in an array of
   input data -- first element?  second element? etc.
*/

#define ELFOLAP_NO_ERROR                                   0
#define ELFOLAP_NO_ERROR_WHOLE_DATA_RETRIEVE              -1
#define ELFOLAP_NO_ERROR_INCR_DATA_RETRIEVE               -2
#define ELFOLAP_NO_ERROR_INCR_DATA_RETRIEVE_LAST          -3

#define ELFOLAP_ERR_OUT_OF_MEMORY                         -8
#define ELFOLAP_ERR_GENERAL_BAD_ARG                       -9

#define ELFOLAP_ERR_ENV_VARS_INIT_FAILED                 -10
#define ELFOLAP_ERR_TOO_MANY_ENV_VARS                    -11
#define ELFOLAP_ERR_BAD_LD_LIB_PATH                      -12

#define ELFOLAP_ERR_API_INIT_FAILED                      -20
#define ELFOLAP_ERR_GRID_API_INIT_FAILED                 -21 /* Essbase only */
#define ELFOLAP_ERR_NEW_GRID_INIT_FAILED                 -22 /* Essbase only */
#define ELFOLAP_ERR_BAD_DATA_DIR                         -21 /* TM1 only */
#define ELFOLAP_ERR_BAD_ADMIN_FILE_DIR                   -22 /* TM1 only */

#define ELFOLAP_ERR_LOGIN_FAILED                         -29
#define ELFOLAP_ERR_CONNECT_FAILED                       -30

#define ELFOLAP_ERR_API_NOT_INITIALIZED                  -31
#define ELFOLAP_ERR_BAD_HOSTNAME                         -32
#define ELFOLAP_ERR_BAD_USERNAME                         -33
#define ELFOLAP_ERR_BAD_PASSWORD_FORMAT                  -34
#define ELFOLAP_ERR_BAD_APPLICATION_NAME                 -35
#define ELFOLAP_ERR_BAD_DATABASE_NAME                    -36

#define ELFOLAP_ERR_APPL_DBASE_SEL_FAILED                -40 /* Essbase only */
#define ELFOLAP_ERR_DBASE_SEL_BAD_LOGOUT                 -41 /* Essbase only */
#define ELFOLAP_ERR_LIST_OF_DBASES_FAILED                -40 /* TM1 only */
#define ELFOLAP_ERR_LIST_OF_DBASES_NAME_RETRIEVE_FAILED  -41 /* TM1 only */
#define ELFOLAP_ERR_ADD_TBLS_FAILED                      -42 /* TM1 only */
#define ELFOLAP_ERR_DEL_TBLS_FAILED                      -43 /* TM1 only */

#define ELFOLAP_ERR_GET_DIM_HIER_FAILED                  -50
#define ELFOLAP_ERR_DBASE_CONNECT                        -51
#define ELFOLAP_ERR_NO_DBASE_DIMTOP                      -52
#define ELFOLAP_ERR_GET_DIMS_ONLY_FAILED                 -53
#define ELFOLAP_ERR_NO_TABLE_SELECTION                   -54 /* TM1 only */

#define ELFOLAP_ERR_DATA_RET_FAILED                      -60
#define ELFOLAP_ERR_DATA_RET_BAD_RESULT                  -61
#define ELFOLAP_ERR_DATA_RET_BAD_TABLE_BUILD             -62 /* Essbase only */
#define ELFOLAP_ERR_DATA_RET_SETUP_FAILED                -62 /* TM1 only */

#define ELFOLAP_ERR_LOGOUT_FAILED                        -70
#define ELFOLAP_ERR_CLEAR_ACTIVE_FAILED                  -71

#define ELFOLAP_ERR_DISCONNECT_FAILED                    -80
#define ELFOLAP_ERR_DISCNXT_NO_CNXT                      -81

#define ELFOLAP_ERR_API_TERM_FAILED                      -90
#define ELFOLAP_ERR_GRID_API_TERM_FAILED                 -91
#define ELFOLAP_ERR_API_NOT_ACTIVE                       -92

#define ELFOLAP_ERR_TERMINATE_FAILED                    -100
#define ELFOLAP_ERR_TERMINATE_BAD_API_TERM              -101

#define ELFOLAP_ERR_DATA_UPDATE_FAILED                  -110
#define ELFOLAP_ERR_DATA_UPDATE_SAVE_FAILED             -111
