/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elfodbc.h
   Applix ASC version: 12
   Date: Mon Nov 16 14:25:15 1998
*/
/* STRIP LINES THROUGH HERE */

/* elfodbc.h - ELF/ODBC interface */

/* ELF/ODBC data types */
#define EO_STR 1
#define EO_BOOL 2
#define EO_INT 3
#define EO_FLOAT 4
#define EO_BINARY 5
#define EO_DATETIME 6


/* Core functions */
#define EO_SQLAllocConnect 		1
#define EO_SQLAllocEnv 			2
#define EO_SQLAllocStmt 			3
#define EO_SQLBindCol 			4
#define EO_SQLCancel 			5
#define EO_SQLColAttributes 		6
#define EO_SQLConnect 			7
#define EO_SQLDescribeCol 		8
#define EO_SQLDisconnect 		9
#define EO_SQLError 			10
#define EO_SQLExecDirect 		11
#define EO_SQLExecute			12
#define EO_SQLFetch 			13
#define EO_SQLFreeConnect 		14
#define EO_SQLFreeEnv 			15
#define EO_SQLFreeStmt 			16
#define EO_SQLGetCursorName 		17
#define EO_SQLNumResultCols 		18
#define EO_SQLPrepare 			19
#define EO_SQLRowCount			20
#define EO_SQLSetCursorName 		21
#define EO_SQLTransact 			22

/* Level 1 functions */
#define EO_SQLBindParameter		23
#define EO_SQLColumns			24
#define EO_SQLDriverConnect		25
#define EO_SQLGetConnectOption 	26
#define EO_SQLGetData			27
#define EO_SQLGetFunctions		28
#define EO_SQLGetInfo			29
#define EO_SQLGetStmtOption		30
#define EO_SQLGetTypeInfo		31
#define EO_SQLParamData			32
#define EO_SQLPutData			33
#define EO_SQLSetConnectOption	34
#define EO_SQLSetStmtOption		35
#define EO_SQLSpecialColumns		36
#define EO_SQLStatistics			37
#define EO_SQLTables			38

/* Level 2 functions */
#define EO_SQLBrowseConnect		39
#define EO_SQLColumnPrivileges	40
#define EO_SQLDataSources		41
#define EO_SQLDescribeParam		42
#define EO_SQLDrivers			43
#define EO_SQLExtendedFetch		44
#define EO_SQLForeignKeys		45
#define EO_SQLMoreResults		46
#define EO_SQLNativeSql			47
#define EO_SQLNumParams			48
#define EO_SQLParamOptions		49
#define EO_SQLPrimaryKeys		50
#define EO_SQLProcedures			51
#define EO_SQLProcedureColumns	52
#define EO_SQLSetScrollOptions	53
#define EO_SQLSetPos			54
#define EO_SQLTablePrivileges		55

/* Applix's define for sending bind parameter values at execute time */
#define EO_SQLBindValues			56
#define EO_SQLBindParameter_DataAtExec 57
#define EO_SQLConcurrencyOptions	58
#define EO_SQLLockTypes			59
#define EO_SQLRetrieveValues		60

#define EO_SQLConnectEncrypted 			61


/* AxDispatch defines */
#define ELFODBC_FUNC 1
#define ELFODBC_BATCH 2
#define ELFODBC_GET_PROPERTIES 3
#define ELFODBC_SET_PROPERTIES 4
#define ELFODBC_LOG 5
#define ELFODBC_ENV_VARS 6
#define ELFODBC_EXEC_STR 7
#define ELFODBC_READ_INI 8
#define ELFODBC_QUIT 9

#define MAX_FUNCTIONS 100

