/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: doctypes.h
   Applix ASC version: 47
   Date: Thu Mar  4 21:13:42 1999
*/
/* STRIP LINES THROUGH HERE */

/*
Defines for the file types returned by RECOGNIZE_FILE@ and RecognizeFile()

Currently only the SS cares about AX_DOC_TYPE_NONE and AX_DOC_TYPE_ILLEGAL.

*/

#define AX_DOC_TYPE_ILLEGAL				-2		/* For errors */
#define AX_DOC_TYPE_NONE				-1		/* For macro links */

#define AX_DOC_TYPE_ASCII				0		/* ASCII */
#define AX_DOC_TYPE_DCA					1		/* DCA */
#define AX_DOC_TYPE_APPLIX_MARKUP		2		/* Applix Markup */
#define AX_DOC_TYPE_INTERLEAF_ASCII		3		/* Interleaf (ASCII) */
#define AX_DOC_TYPE_FRAME_MIF			4		/* Frame MIF */
#define AX_DOC_TYPE_WP_51				5		/* WordPerfect 5.1 */
#define AX_DOC_TYPE_MS_WORD				6		/* MS Word */
#define AX_DOC_TYPE_OFFICE_WRITER		7		/* OfficeWriter */
#define AX_DOC_TYPE_WP_42				8		/* WordPerfect 4.2 */
#define AX_DOC_TYPE_SAMNA				9		/* Samna */
#define AX_DOC_TYPE_VOLKS_WRITER		10		/* VolksWriter */
#define AX_DOC_TYPE_LEADING_EDGE		11		/* Leading Edge */
#define AX_DOC_TYPE_WORDSTAR			12		/* WordStar */
#define AX_DOC_TYPE_WORDSTAR_2000		13		/* WordStar2000 */
#define AX_DOC_TYPE_XYWRITE				14		/* XYwrite */
#define AX_DOC_TYPE_PFS_PROFESSIONAL	15		/* PfsProfessional */
#define AX_DOC_TYPE_PFS_WRITE			16		/* PfsWrite */
#define AX_DOC_TYPE_EXECUTIVE_WRITER	17		/* ExecutiveWriter */
#define AX_DOC_TYPE_SPELL_BINDER		18		/* SpellBinder */
#define AX_DOC_TYPE_PC_WRITE			19		/* PCwrite */
#define AX_DOC_TYPE_Q_AND_A				20		/* QandA */
#define AX_DOC_TYPE_MULTI_MATE			21		/* MultiMate */
#define AX_DOC_TYPE_MANUSCRIPT			22		/* Manuscript */
#define AX_DOC_TYPE_SUN_WRITE			23		/* SunWrite */
#define AX_DOC_TYPE_ISLAND_WRITE		24		/* IslandWrite */
#define AX_DOC_TYPE_DISPLAY_WRITE		25		/* DisplayWrite */
#define AX_DOC_TYPE_RTF					26		/* Rich Text Format (RTF) */
#define AX_DOC_TYPE_MS_WFW2				27		/* MS Word for Windows 2.0 */
#define AX_DOC_TYPE_MS_WFM5				28		/* MS Word for Macintosh 5.1 */
#define AX_DOC_TYPE_ASTERX2				29		/* aster*x3 --> aster*x2.1 */
#define AX_DOC_TYPE_WP_50               30      /* WordPerfect 5.0 */
#define AX_DOC_TYPE_WP_6				31		/* WordPerfect 6.0 */
#define AX_DOC_TYPE_INTERLEAF5_ASCII	32		/* Interleaf5.0 (ASCII) */
#define AX_DOC_TYPE_FRAME_MIF_20		33		/* Frame 2.0 for export */
#define AX_DOC_TYPE_WINWORD60			34		/* Win/Mac Word 6.0 */
#define AX_DOC_TYPE_HTML				35		/* HTML for World Wide Web */
#define AX_DOC_TYPE_FRAME_MIF_50		36		/* Frame 5.0 for import */
#define AX_DOC_TYPE_WP_70				37		/* WordPerfect 7.0 */
#define AX_DOC_TYPE_MSWORD70			38		/* MS Word 7.0/95 */
#define AX_DOC_TYPE_MSWORD97			39		/* MS Word 97 */
#define AX_DOC_TYPE_WP_80				40		/* WordPerfect 8.0 */


		/*________________ G R A P H I C S   F I L T E R S   _______________*/
#define AX_DOC_TYPE_XWD					51		/* XWD */
#define AX_DOC_TYPE_FAX_M				52		/* FAX msb */
#define AX_DOC_TYPE_EPSI				53		/* EPSI */
#define AX_DOC_TYPE_HPGL				54		/* HPGL */
#define AX_DOC_TYPE_X_BITMAP				55		/* XBitmap */
#define AX_DOC_TYPE_PCX					56		/* PCX */
#define AX_DOC_TYPE_SUN_RASTER				57		/* Sun raster */
#define AX_DOC_TYPE_MAC_PAINT				58		/* MacPaint */
#define AX_DOC_TYPE_MS_WINDOWS_BITMAP			59		/* MSWindows Bitmap */
#define AX_DOC_TYPE_CGM					60		/* CGM */
#define AX_DOC_TYPE_DXF					61		/* DXF */
#define AX_DOC_TYPE_FAX_I				62		/* FAX lsb */
#define AX_DOC_TYPE_IGES				63		/* IGES */
#define AX_DOC_TYPE_TIFF_M				64		/* TIFF M */
#define AX_DOC_TYPE_TIFF_I				65		/* TIFF I */
#define AX_DOC_TYPE_GIF					66		/* GIF */
#define AX_DOC_TYPE_PICT				67		/* PICT */
#define AX_DOC_TYPE_TGA					68		/* TGA */
#define AX_DOC_TYPE_ILBM				69		/* ILBM */
#define AX_DOC_TYPE_GEM					70		/* GEM */
#define AX_DOC_TYPE_PBM					71		/* PBM */
#define AX_DOC_TYPE_PGM					72		/* PGM */
#define AX_DOC_TYPE_PPM					73		/* PPM */
#define AX_DOC_TYPE_PICT2				74		/* PICT2 */
#define AX_DOC_TYPE_WMF					75		/* Windows Metafile */
#define AX_DOC_TYPE_WPG					76		/* WordPerfect Graphics */
#define AX_DOC_TYPE_GP4					77		/* Group 4 fax */
#define AX_DOC_TYPE_XPM					78		/* X pixmap */
#define AX_DOC_TYPE_RAW					79		/* Raw Bitmap */
#define AX_DOC_TYPE_IRIS				80		/* SGI Iris images */
#define AX_DOC_TYPE_GR2					82		/* Graphics2.1 */ 
#define AX_DOC_TYPE_GR3					83		/* Graphics2.1 */
#define AX_DOC_TYPE_JPEG				84		/* JPEG */
#define AX_DOC_TYPE_PPT					85		/* Power Point */
#define AX_DOC_TYPE_FLW					86		/* Freelance */
#define AX_DOC_TYPE_PNG					87		/* PNG */
#define AX_DOC_TYPE_EMF					88		/* EMF -Enhanced MF */

#define AX_DOC_TYPE_WKS					100		/* WKS/WK1 */
#define AX_DOC_TYPE_WK1					100
#define AX_DOC_TYPE_SYLK				101		/* SYLK */
#define AX_DOC_TYPE_DIF					102		/* DIF/XDIF */
#define AX_DOC_TYPE_XDIF				102
#define AX_DOC_TYPE_ASCII_GRID			103		/* ASCII grid */
#define AX_DOC_TYPE_ASCII_COLUMN		104		/* ASCII into 1 column */
#define AX_DOC_TYPE_ASCII_ROW			105		/* ASCII into 1 row */
#define AX_DOC_TYPE_CSV					106		/* CSV */
#define AX_DOC_TYPE_XLS3				107		/* XLS 3.0 */
#define AX_DOC_TYPE_XLS4				108		/* XLS 4.0 */
#define AX_DOC_TYPE_WK3					109		/* WK3 */
#define AX_DOC_TYPE_ASTERX_SS2			110		/* Aster*x Spreadsheets 2.1 */
#define AX_DOC_TYPE_WK4					111		/* WK4 */

#define AX_DOC_TYPE_AUDIO				150		/* Audio */
#define AX_DOC_TYPE_DATA				151		/* Data */
#define AX_DOC_TYPE_COMPRESSED_AUDIO	152		/* Compressed Audio */

#define AX_DOC_TYPE_DIRECTORY			160		/* Directory */
#define AX_DOC_TYPE_CHAR_SPECIAL		161		/* Character special */
#define AX_DOC_TYPE_BLOCK_SPECIAL		162		/* Block special */
#define AX_DOC_TYPE_SYMBOLIC_LINK		163		/* Symbolic link */
#define AX_DOC_TYPE_SOCKET				164		/* Socket */
#define AX_DOC_TYPE_FIFO				165		/* Fifo */
#define AX_DOC_TYPE_UNKNOWN				166		/* Unknown */
#define AX_DOC_TYPE_EMPTY				167		/* Empty */
#define AX_DOC_TYPE_COMPRESSED_DATA		168		/* Compressed data */
#define AX_DOC_TYPE_BTOA_DATA			169		/* btoa'd data */
#define AX_DOC_TYPE_MAC_HEADER			170		/* has Mac Finder header */

#define AX_DOC_TYPE_ASTERX_WORDS		200		/* Aster*x Words */
#define AX_DOC_TYPE_ASTERX_GRAPHICS		201		/* Aster*x Graphics */
#define AX_DOC_TYPE_ASTERX_SS			203		/* Aster*x Spreadsheets */
#define AX_DOC_TYPE_ASTERX_MACROS		204		/* Aster*x Macros */
#define AX_DOC_TYPE_ASTERX_BINARY_SS	205		/* Binary Spreadsheets */
#define AX_DOC_TYPE_ASTERX_BITMAP		206		/* Aster*x Bitmap */
#define AX_DOC_TYPE_ASTERX_EQUATIONS	207		/* Aster*x Equations */
#define AX_DOC_TYPE_ASTERX_ASCII		208		/* Aster*x external ascii */
#define AX_DOC_TYPE_ASTERX_BINARY		209		/* Aster*x external binary */
#define AX_DOC_TYPE_ASTERX_ELFARRAY		210		/* Aster*x elf array */
#define AX_DOC_TYPE_ASTERX_QUERYDATA	211		/* Aster*x Query */
#define AX_DOC_TYPE_ASTERX_MACRO_OBJ	212		/* Aster*x Macros */
#define AX_DOC_TYPE_ASTERX_BUILDER		213		/* Applix Builder (.ab) */
#define AX_DOC_TYPE_ASTERX_OBJ_CLASS	214		/* Applix Builder - Object class library (.ell) */
#define AX_DOC_TYPE_ASTERX_BUILDER_ABD	215		/* Applix Builder Distribution (.abd) */
#define AX_DOC_TYPE_ASTERX_ELF_TABLE 	216 	/* ELF array in table_data@ format */
#define AX_DOC_TYPE_ASTERX_BUILDER_TURBO 217	/* Applix Builder (.abo) */
#define AX_DOC_TYPE_ASTERX_SLIDESHOW     218    /* Applix SlideShow (.ap) */
#define AX_DOC_TYPE_HEX                  219    /* Applix hexified binary */
#define AX_DOC_TYPE_ASTERX_MENUBAR       220    /* Applix Menubar */
