/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elaxddfl.c
   Applix ASC version: 6
   Date: Thu Feb 11 21:11:32 1999
*/
#include <elfapi.h>

#ifndef ELFC_HS2
#define ELFC_HS2 -5
#endif

#define TRUE 1
#define FALSE 0


/*************************************************************************
function: AxDispatch - process the client's request
*/

elfData 
AxDispatch(funcId, funcData, quitNow)
	int             funcId;
	elfData         funcData;
	int32          *quitNow;
{
	elfData         rData = NULL;       /* return data, presumed no-return */
	AxCallInfo_t *cP;
	int cnt, ix;
	static AxCallInfo_t *CallsTable;
	elfData namesD, categoryD, argInfoD, ssFuncD, cfuncsD;
    elfData (*func)();
	unsigned int val;

	switch (funcId) {

	case ELFC_INIT:		/* Automatically called once during server init */
		AxInit(funcData);
		break;
	case ELFC_EXIT:		/* Reserved convention for shutdown sequence */
	case ELFC_AXNET:		/* Allows C servers to look like ELF<->ELF servers */
	case ELFC_PORT:		/* Return port number from (e.g. from /etc/services) */
		break;

	case ELFC_HS1:			/* Private handshake support for axmain */
		cP = AxGetCallInfo();
		if(cP) 
			goto got_it;
		cP = AxGetCallInfo_ud_1();
		if(cP) 
			goto got_it;
		cP = AxGetCallInfo_ud_2();
		if(cP)
			goto got_it;
		cP = AxGetCallInfo_ud_3();
		if(cP)
			goto got_it;
		cP = AxGetCallInfo_ud_4();
		if(cP)
			goto got_it;
		cP = AxGetCallInfo_ud_5();
		if(cP)
			goto got_it;
		return(NULL);	/* no AxGetCallInfo defined by user */
got_it:
		/* make sure we can read the format */
		/* read the first element of the first entry */
		val = (unsigned int)(*((int *)cP));
		if((val != 0) && (val < 1024))	{
			/* new format, where the first word is the size of the function
			entry, in the old format the first word is a string pointer 
			which can never be in the zeroth page */
			return(NULL);
		}

		for ( cnt = 0; cP[cnt].func; cnt++ );	/* count calls */
		rData = AxMakeArray(5);					/* create call info retval */
		namesD = AxMakeArray(cnt);
		categoryD = AxMakeArray(cnt);
		argInfoD = AxMakeArray(cnt);
		ssFuncD = AxMakeArray(cnt);
		cfuncsD = AxMakeArray(cnt);
		for ( ix = 0; cP[ix].func; ix++ ) {		/* load up retval arrays */
			AxAddStrToArray(namesD,ix,cP[ix].alias);
			AxAddStrToArray(categoryD,ix,cP[ix].category);
			AxAddStrToArray(argInfoD,ix,cP[ix].argStr);
			AxAddIntToArray(ssFuncD,ix,cP[ix].callMode);
			AxAddIntToArray(cfuncsD,ix,ix+1);
		}
		CallsTable = (AxCallInfo_t *)calloc(cnt,sizeof(AxCallInfo_t));
		memcpy(CallsTable,cP,cnt*sizeof(AxCallInfo_t));
		rData = AxAddArrayToArray(rData,0,namesD);
		rData = AxAddArrayToArray(rData,1,categoryD);
		rData = AxAddArrayToArray(rData,2,argInfoD);
		rData = AxAddArrayToArray(rData,3,ssFuncD);
		rData = AxAddArrayToArray(rData,4,cfuncsD);
		break;

	case ELFC_HS2:			/* Private handshake support for axmain */
		func = CallsTable[AxIntFromArray(funcData,0)-1].func;
		rData = (*(func))(AxArrayElement(funcData,1));
		break;

	}


	return(rData);
}
