/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: eldraw.h
   Applix ASC version: 18
   Date: Thu May 20 21:13:18 1999
*/
/* STRIP LINES THROUGH HERE */

/************* COMMANDS *********************/

#define ELFDRAW_LINE_			1
#define ELFDRAW_TEXT_			2
#define ELFDRAW_CLEAR_			3
#define ELFDRAW_RECT_			4
#define ELFDRAW_IMAGE_			5
#define ELFDRAW_GET_TEXT_WIDTH_ 6
#define ELFDRAW_GET_ICON_SIZE_	7
#define ELFDRAW_PAINT_WIDTH_	8
#define ELFDRAW_PAINT_HEIGHT_	9
#define ELFDRAW_SCROLL_POS_		10
#define ELFDRAW_SCROLL_INCR_	11
#define ELFDRAW_SCROLL_PAGE_INCR_ 12
#define ELFDRAW_FILL_RECT_		13
#define ELFDRAW_ARC_			14
#define ELFDRAW_FILL_ARC_		15
#define ELFDRAW_POLY_			16
#define ELFDRAW_FILL_POLY_		17
#define ELFDRAW_CURVE_			18
#define ELFDRAW_FILL_CURVE_		19
#define ELFDRAW_PRINT_			20
#define ELFDRAW_SCROLL_GRID_	21
#define ELFDRAW_GET_FONT_HEIGHT_ 22
#define ELFDRAW_GET_FONT_BASELINE_ 23
#define ELFDRAW_SUPPRESS_COPY_     24
#define ELFDRAW_INSET_     		25


#define	PRINT_DOC_TYPE			0
#define	PRINT_PAGE_TYPE			1
#define	PRINT_TEXT_TYPE			2
#define	PRINT_POLY_TYPE			3
#define	PRINT_ICON_TYPE			4
#define PRINT_CHART_TYPE		5

#define	PRINT_POLY_LINE			0
#define	PRINT_POLY_RECTANGLE	1
#define	PRINT_POLY_ARC			2
#define	PRINT_POLY_POLY			3


/************* GC DECODING... not all of below may be supported *****/
#define XGC_function_			0
#define XGC_plane_mask_			1
#define XGC_foreground_			2
#define XGC_background_			3
#define XGC_line_width_			4
#define XGC_line_style_			5
#define XGC_cap_style_			6
#define XGC_join_style_			7
#define XGC_fill_style_			8
#define XGC_fill_rule_			9
#define XGC_arc_mode_			10
#define XGC_tile_				11
#define XGC_stipple_			12
#define XGC_ts_x_origin_		13
#define XGC_ts_y_origin_		14
#define XGC_font_				15
#define XGC_subwindow_mode_		16
#define XGC_graphics_exposures_	17
#define XGC_clip_x_origin_		18
#define XGC_clip_y_origin_		19
#define XGC_clip_mask_			20
#define XGC_dash_offset_		21
#define XGC_dashes_				22

/*****************************************************************
 * GRAPHICS DEFINITIONS
 *****************************************************************/

/* graphics functions, as in GC.alu */

#define	XVAL_GXclear		0		/* 0 */
#define XVAL_GXand			1		/* src AND dst */
#define XVAL_GXandReverse	2		/* src AND NOT dst */
#define XVAL_GXcopy			3		/* src */
#define XVAL_GXandInverted	4		/* NOT src AND dst */
#define	XVAL_GXnoop			5		/* dst */
#define XVAL_GXxor			6		/* src XOR dst */
#define XVAL_GXor			7		/* src OR dst */
#define XVAL_GXnor			8		/* NOT src AND NOT dst */
#define XVAL_GXequiv		9		/* NOT src XOR dst */
#define XVAL_GXinvert		10		/* NOT dst */
#define XVAL_GXorReverse	11		/* src OR NOT dst */
#define XVAL_GXcopyInverted	12		/* NOT src */
#define XVAL_GXorInverted	13		/* NOT src OR dst */
#define XVAL_GXnand			14		/* NOT src OR NOT dst */
#define XVAL_GXset			15		/* 1 */

/* LineStyle */

#define XVAL_LineSolid			0
#define XVAL_LineOnOffDash		1
#define XVAL_LineDoubleDash		2

/* capStyle */

#define XVAL_CapNotLast			0
#define XVAL_CapButt			1
#define XVAL_CapRound			2
#define XVAL_CapProjecting		3

/* joinStyle */

#define XVAL_JoinMiter		0
#define XVAL_JoinRound		1
#define XVAL_JoinBevel		2

/* fillStyle */

#define XVAL_FillSolid			0
#define XVAL_FillTiled			1
#define XVAL_FillStippled		2
#define XVAL_FillOpaqueStippled	3

/* fillRule */

#define XVAL_EvenOddRule		0
#define XVAL_WindingRule		1

/* subwindow mode */

#define XVAL_ClipByChildren		0
#define XVAL_IncludeInferiors	1

/* SetClipRectangles ordering */

#define XVAL_Unsorted		0
#define XVAL_YSorted		1
#define XVAL_YXSorted		2
#define XVAL_YXBanded		3

/* CoordinateMode for drawing routines */

#define XVAL_CoordModeOrigin		0	/* relative to the origin */
#define XVAL_CoordModePrevious      1	/* relative to previous point */

/* Polygon shapes */

#define XVAL_Complex		0	/* paths may intersect */
#define XVAL_Nonconvex		1	/* no paths intersect, but not convex */
#define XVAL_Convex			2	/* wholly convex */

/* Arc modes for PolyFillArc */

#define XVAL_ArcChord			0	/* join endpoints of arc */
#define XVAL_ArcPieSlice		1	/* join endpoints to center of arc */

/* Font Names */

#define XVAL_font_default				"default"		/* dialog font */
#define XVAL_font_times					"Times"
#define XVAL_font_helvetica				"Helvetica"
#define XVAL_font_courier				"Courier"
#define XVAL_font_symbol				"Symbol"
#define XVAL_font_bookman				"Bookman"
#define XVAL_font_new_century_schoolbook	"New Century Schoolbook"
#define XVAL_font_palatino				"Palatino"
#define XVAL_font_avant_garde			"Avant Garde"
#define XVAL_font_helvetica_narrow		"Helvetica Narrow"
#define XVAL_font_zapf_chancery			"Zapf Chancery"
#define XVAL_font_zapf_dingbats			"Zapf Dingbats"

/* Font sizes */

#define XVAL_size_10	10
#define XVAL_size_12	12
#define XVAL_size_14	14
#define XVAL_size_18	18
#define XVAL_size_24	24
#define XVAL_size_36	36

