/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elf_env.h
   Applix ASC version: 13
   Date: Tue Feb  2 15:20:56 1999
*/
#include <stdio.h>
#include <aos.h>
#include <elf.h>

#define VERIFY(x,y) if ( !(x) ) ElfAbort(y);
#define SVERIFY(x,y,z) if ( !(x) ) ElfStrAbort(y,NULL,z);

#define ERROR(body) ElfAbort(body)

/************* CONTROL OF EXECUTION TIMEOUTS ******************
OBSOLETE
*/
#define WORK(type)
#define TOTAL_WORK  10000  /* instructions before PC timeout occurs */
#define WORK_MALLOC    20  /* time to execute a malloc */
#define WORK_CALLSUB   10  /* time to execute a subroutine call */
#define WORK_SNAPLINK  50  /* average time to snap a dynamic link */
#define WORK_FLOAT     5   /* floating point addition */
#define WORK_CONVERT   10  /* convert num to str */
#define WORK_BITBLIT 1000  /* tasks that cuase atm bit blits */
#define WORK_INFINITY TOTAL_WORK    /* always pause */

extern DLL_IMPORT bint ElfInLearnMode;    /* TRUE while in learn mode */
extern DLL_IMPORT data_ptr ElfRetData; /* Builtin func generic return value */
extern DLL_IMPORT char *ElfStrPtrRet;  /* Builtin func returns Str value */


/****** PROTOTYPES ***************/

data_ptr ElfAddStrToArray AXP_((data_ptr aP, int dex, char* str));
data_ptr ElfAddNumToArray AXP_((data_ptr aP, int dex, int val));
data_ptr ElfAddDblToArray AXP_((data_ptr aP, int dex, double val));
data_ptr ElfAddBinaryToArray AXP_((data_ptr ap, int ix, int elements,
                                   char *data_bytes));
double NumFromDataPtr AXP_((data_ptr aP));
char *StrFromDataPtr AXP_((data_ptr aP));
char *StrFromArray AXP_((data_ptr aP,int dex));
data_ptr AnyFromArray AXP_((data_ptr aP, int dex));
data_ptr ReadArray AXP_((data_ptr aP, int dex));

