/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elf_ge.h
   Applix ASC version: 151
   Date: Tue Feb  2 15:20:48 1999
*/
#define ELF_CODE_PRINT    	 0

#define ELF_CODE_SAVE     	 0
#define ELF_CODE_ABANDON  	 1
#define ELF_CODE_DELETE   	 2
#define ELF_CODE_REVERT   	 3
#define ELF_CODE_SAVE_EXIT   4

#define ELF_CODE_MARK_ALL    0
#define ELF_CODE_UNMARK_ALL  1
#define ELF_CODE_MARK_LAST   2
#define ELF_CODE_REV_MARK    3
#define ELF_CODE_MARK_TYPE   4
#define ELF_CODE_MARK_NEXT   5
#define ELF_CODE_MARK_PREV   6

#define ELF_CODE_ROTATE      0
#define ELF_CODE_X_MIRROR    1
#define ELF_CODE_Y_MIRROR    2

#define ELF_CODE_SMOOTH      0
#define ELF_CODE_ED_ARC      1
#define ELF_CODE_ED_SIDES    2
#define ELF_CODE_PX_EDIT     3
#define ELF_CODE_TEXT_EDIT   4

#define ELF_CODE_GROUP       0
#define ELF_CODE_UNGROUP     1
#define ELF_CODE_MV_BACK     2
#define ELF_CODE_MV_FRONT    3
#define ELF_CODE_BACKWRD     4
#define ELF_CODE_FORWARD     5
#define ELF_CODE_COMPOSE     6
#define ELF_CODE_UNCOMPOSE   7
#define ELF_CODE_ASSOCIATE   8
#define ELF_CODE_UNASSOCIATE 9

#define ELF_CODE_HIDE        0
#define ELF_CODE_UNHIDE      1
#define ELF_CODE_REVEAL_ALL  2
#define ELF_CODE_REVEAL_MRK  3
#define ELF_CODE_LOCK        4
#define ELF_CODE_UNLOCK      5
#define ELF_CODE_UNLOCK_ALL  6

#define ELF_CODE_COPY        0
#define ELF_CODE_CUT         1
#define ELF_CODE_PASTE       2
#define ELF_CODE_IMPRT       3
#define ELF_CODE_PASTE_GFX   4

#define ELF_CODE_MOUSE_UP    0
#define ELF_CODE_MOUSE_MV    1
#define ELF_CODE_MOUSE_DN    2
#define ELF_CODE_MOUSE_DN2   3
#define ELF_CODE_MOUSE_DN3   4
#define ELF_CODE_MOUSE_DN4   5

#define ELF_CODE_START_MODE  0
#define ELF_CODE_SLIDE_ED    1
#define ELF_CODE_SLIDE_MSTR  2
#define ELF_CODE_SLIDE_SORT  3
#define ELF_CODE_HOUT_MSTR   4
#define ELF_CODE_OLIN_ED     5
#define ELF_CODE_OLIN_MSTR   6
#define ELF_CODE_SNOTES_ED   7
#define ELF_CODE_SNOTES_MSTR 8
#define ELF_CODE_BLANK_MODE  9

#define ELF_CODE_LOAD_FILLS  0
#define ELF_CODE_LOAD_PARTS  1
#define ELF_CODE_LOAD_CMAP   2
#define ELF_CODE_LOAD_TEMP   3
#define ELF_CODE_LOAD_CSHEME 4
#define ELF_CODE_LOAD_CHART  5
#define ELF_CODE_MERGE_FILE  6

#define ELF_CODE_NO_UPDATE   0
#define ELF_CODE_ON_DISK     1

/* chart sheet utils */
#define ELF_LEFT_ALIGN       0
#define ELF_CENTER_ALIGN     1
#define ELF_RIGHT_ALIGN      2
#define ELF_JUSTIFIED_ALIGN  3

/* chart sheet utils */
#define CHART_SHEET_GET_PART_INFO		1
#define CHART_SHEET_SET_PART_INFO		2
#define CHART_SHEET_PRS_RANGE			3
#define CHART_SHEET_DESTROY_PART    	4

/********* THE MAXIMUM VALID RANGE *********/
#define ELF_GE_MINCODE                  7000
#define ELF_GE_MAXCODE                  7700

/********* THE ACTUAL CODES ***************/
#define ELFC_GE_CATTRS                    7000
#define ELFC_GE_GUIDES                    7001
#define ELFC_GE_MODIFIED                  7002
#define ELFC_GE_RENAME                    7003
#define ELFC_GE_DOCINFO                   7004
#define ELFC_GE_WRTFILE                   7005
#define ELFC_GE_GRDATA                    7006
#define ELFC_GE_DOCSTR                    7007
#define ELFC_GE_HITMOD                    7008
#define ELFC_GE_GETSETUP                  7009
#define ELFC_GE_PUTSETUP                  7010
#define ELFC_GE_PALETTE                   7011
#define ELFC_GE_ISBG                      7012
#define ELFC_BG_SEMI_SAVE                 7013
#define ELFC_BG_DELETE_SEMI               7014
#define ELFC_GE_UDOINFO                   7015
#define ELFC_GE_PIXED                     7016
#define ELFC_GE_LEGEND                    7017
#define ELFC_GE_SETREZ                    7018
#define ELFC_GE_PIXCOLOR                  7019
#define ELFC_GE_COLR_TOGGLE               7020
#define ELFC_BG_AM_PRINTING               7021
#define ELFC_PX_FLOOD                     7022
#define ELFC_PX_COLOR_ERASE               7023
#define ELFC_PX_FILL                      7024
#define ELFC_PX_RESTART                   7025
#define ELFC_PX_SOFTEN                    7026
#define ELFC_PX_COLORSHIFT                7027
#define ELFC_PX_SETTOOL                   7028
#define ELFC_PX_SETSTYLE                  7029
#define ELFC_PX_INVERT                    7030
#define ELFC_PX_FLOODSTYLE                7031
#define ELFC_PX_GETINFO                   7032
#define ELFC_PX_PEL_FROM_IMAGE            7033
#define ELFC_PX_FINDEDGES                 7034
#define ELFC_PX_SETDENSITY                7035
#define ELFC_PX_MODIFIED                  7036
#define ELFC_GE_NEWEST_PART               7037
#define ELFC_GE_TEST_FUNC                 7038
#define ELFC_TERM_EDITS                   7039
#define ELFC_GE_WRITE_LOCAL               7040
#define ELFC_GE_GET_TOOL                  7041
#define ELFC_GE_SET_FOR_IMPORT            7042
#define ELFC_GE_ARRAY_DUP                 7043
#define ELFC_GE_SHEAR                     7044
#define ELFC_PX_SET_COLOR                 7045
#define ELFC_GE_BITFILL                   7046
#define ELFC_GE_INDEXFILL                 7047
#define ELFC_GE_GETPOS                    7048
#define ELFC_GE_LAYER                     7049
#define ELFC_GE_N_LAYERS                  7050
#define ELFC_GE_GET_LAYER_INFO            7051
#define ELFC_GE_GRADIENT                  7052
#define ELFC_GE_CMYK_TO_IX                7053
#define ELFC_GE_N_COLORS                  7054
#define ELFC_GE_GET_COLOR_INFO            7055
#define ELFC_GE_DEL_CMAP_INFO             7056
#define ELFC_GE_EDIT_CMAP_INFO            7057
#define ELFC_GE_CREATE_CMAP_ENTRY         7058
#define ELFC_GE_TOGGLE_CONTROLS           7059
#define ELFC_GE_N_PAL_PARTS               7060
#define ELFC_GE_PAL_PART_NAME             7061
#define ELFC_GE_DO_FILING                 7062
#define ELFC_GE_DO_MARKING                7063
#define ELFC_GE_DO_TRANSFORM              7064
#define ELFC_GE_DO_DATA_CHANGE            7065
#define ELFC_GE_SINGLE_DUP                7066
#define ELFC_GE_DO_ARRANGING              7067
#define ELFC_GE_ALIGN                     7068
#define ELFC_GE_HIDE                      7069
#define ELFC_GE_LOAD_PARTS                7070
#define ELFC_GE_CREATE_PART               7071
#define ELFC_GE_CHANGE_PART               7072
#define ELFC_GE_SORT_PARTS                7073
#define ELFC_GE_DELETE_PART               7074
#define ELFC_GE_CUT_COPY_PASTE            7075
#define ELFC_GE_ROTATE_EXACT              7076
#define ELFC_GE_SCALE_EXACT               7077
#define ELFC_GE_MOVE_EXACT                7078
#define ELFC_GE_CONSTRAINTS               7079
#define ELFC_GE_NATIVE_PASTE              7080
#define ELFC_GE_GRAPH_OPEN_SESSION        7081
#define ELFC_GE_GRAPH_CLOSE_SESSION       7082
#define ELFC_GE_RETURN_KEY                7083
#define ELFC_GE_ARROW_KEY                 7084
#define ELFC_GE_SCREEN_KEY                7085
#define ELFC_GE_DELETE_TEXT_KEY           7086
#define ELFC_GE_GOTO_TEXT_KEY             7087
#define ELFC_GE_ESCAPE_KEY                7088
#define ELFC_GE_CENTER                    7089
#define ELFC_GE_ENTER_HELP_MODE           7090
#define ELFC_GE_TAB_KEY                   7091
#define ELFC_GE_REGEN                     7092
#define ELFC_GE_UNDO                      7093
#define ELFC_GE_REDO                      7094
#define ELFC_GE_AGAIN                     7095
#define ELFC_GE_DELETE                    7096
#define ELFC_GE_LARGER                    7097
#define ELFC_GE_SMALLER                   7098
#define ELFC_GE_PRINT                     7099
#define ELFC_GE_FIT_TEXT_TO               7100
#define ELFC_GE_SET_TAG                   7101
#define ELFC_GE_GET_FILL_NAME             7102
#define ELFC_GE_GET_NUM_FILLS             7103
#define ELFC_GE_SET_RIBBON_INFO           7104
#define ELFC_GE_CHART_GET_CHARTS          7105
#define ELFC_GE_CHART_GET_GROUPS          7106
#define ELFC_GE_CHART_GET_DATA_GROUP      7107
#define ELFC_GE_CHART_GET_AXES            7108
#define ELFC_GE_CHART_CREATE              7109
#define ELFC_GE_CHART_CREATE_AXIS         7110
#define ELFC_GE_CHART_CREATE_DATA_GRP     7111
#define ELFC_GE_CHART_SET_LEGEND          7112
#define ELFC_GE_CHART_DESTROY             7113
#define ELFC_GE_CHART_DESTROY_AXIS        7114
#define ELFC_GE_CHART_DESTROY_DATA_GRP    7115
#define ELFC_GE_CHART_GET_LEGEND          7116
#define ELFC_GE_CHART_SET_TYPE            7117
#define ELFC_GE_CHART_SET_ORIENTATION     7118
#define ELFC_GE_CHART_SET_DECORATIONS     7119
#define ELFC_GE_CHART_SET_EXTENT          7120
#define ELFC_GE_CHART_SET_MARGIN          7121
#define ELFC_GE_CHART_SET_AXIS_STYLE      7122
#define ELFC_GE_CHART_SET_TITLE           7123
#define ELFC_GE_CHART_SET_DATUM           7124
#define ELFC_GE_CHART_GET_TYPE_NAME       7125
#define ELFC_GE_CHART_GET_TYPE_INFO       7126
#define ELFC_GE_CHART_GET_ORIENTATION     7127
#define ELFC_GE_CHART_GET_DECORATIONS     7128
#define ELFC_GE_CHART_GET_EXTENT          7129
#define ELFC_GE_CHART_GET_MARGIN          7130
#define ELFC_GE_CHART_GET_AXIS_STYLE      7131
#define ELFC_GE_CHART_GET_TITLE           7132
#define ELFC_GE_CHART_GET_DATUM           7133
#define ELFC_GE_CHART_SET_FMT             7134
#define ELFC_GE_CHART_GET_FMT             7135
#define ELFC_GE_CHART_SET_DATA_GROUP      7136
#define ELFC_GE_CHART_DRAW                7137
#define ELFC_GE_FIT_TEXT_IN               7138
#define ELFC_GE_LOAD_CMAP                 7139
#define ELFC_GE_SET_PRINT_INFO            7140
#define ELFC_GE_GET_PRINT_INFO            7141
#define ELFC_GE_SET_HDRFTR_INFO           7142
#define ELFC_GE_GET_HDRFTR_INFO           7143
#define ELFC_GE_QUERY                     7144
#define ELFC_GE_GET_AREA_BY_HANDLE        7145
#define ELFC_GE_SELECT_BY_HANDLE          7146
#define ELFC_GE_DRAW_BY_HANDLE            7147
#define ELFC_GE_GET_ATTR                  7148
#define ELFC_GE_SET_ATTR                  7149
#define ELFC_GE_CLEAR_AREA                7150
#define ELFC_GE_SET_UNITS                 7151
#define ELFC_GE_GET_UNITS                 7152
#define ELFC_GE_SET_GRID_FACTOR           7153
#define ELFC_GE_GET_GRID_FACTOR           7154
#define ELFC_GE_ADD_CURVATURE             7155
#define ELFC_GE_DEL_CURVATURE             7156
#define ELFC_GE_LIST_FONT_FAMILIES        7157
#define ELFC_GE_SET_PALETTE_LINE_WIDTH    7158
#define ELFC_GE_GET_PALETTE_LINE_WIDTH    7159
#define ELFC_GE_CREATE_CALLBACK           7160
#define ELFC_GE_DESTROY_CALLBACK          7161
#define ELFC_GE_CHANGE_CALLBACK           7162
#define ELFC_GE_GET_CALLBACKS             7163
#define ELFC_GE_SET_CALLBACK              7164
#define ELFC_GE_GET_CALLBACK              7165
#define ELFC_GE_DESTROY_FILL              7166
#define ELFC_GE_RENAME_FILL               7167
#define ELFC_GE_GET_TAG                   7168
#define ELFC_GE_GET_ELL_INFO              7169
#define ELFC_GE_SET_ELL_INFO              7170
#define ELFC_GE_GET_RECT_INFO             7171
#define ELFC_GE_SET_RECT_INFO             7172
#define ELFC_GE_GET_IM_INFO               7173
#define ELFC_GE_SET_IM_INFO               7174
#define ELFC_GE_GET_RPOLY_INFO            7175
#define ELFC_GE_SET_RPOLY_INFO            7176
#define ELFC_GE_SET_PERCENTFILL           7177
#define ELFC_GE_CREATE_NEW_IMAGE          7178
#define ELFC_GE_COPY_ATTR_TO_DROPPER      7179
#define ELFC_GE_COPY_ATTR_FROM_DROPPER    7180
#define ELFC_GE_SELECT_CHARACTERS         7181
#define ELFC_GE_GET_CURRENT_CHART         7182
#define ELFC_GE_TYPE                      7183
#define ELFC_PX_TOGGLE_IMAGE_TYPE         7184
#define ELFC_GE_MERGE_FILE                7185
#define ELFC_GE_CHART_RENAME              7186
#define ELFC_GE_REMOVE_TEXT_FROM          7187
#define ELFC_GE_ZOOM_TO_FIT               7188
#define ELFC_GE_SET_HOOK                  7189
#define ELFC_GE_GET_HOOK                  7190
#define ELFC_GE_CHART_SET_NULL_FORMAT     7191
#define ELFC_GE_CHART_GET_NULL_FORMAT     7192
#define ELFC_GE_GET_SESSION_PARENT		  7193
#define ELFC_GE_CHART_FORMAT_NUMBER       7194
#define ELFC_GE_GET_STRUCTURED_COMMENTS   7195
#define ELFC_GE_GET_STRUCTURED_COMMENT    7196
#define ELFC_GE_SET_STRUCTURED_COMMENT    7197
#define ELFC_GE_CONVERT_INSET             7198
#define ELFC_GE_SET_CMAP                  7199
#define ELFC_GE_EDIT_PATTERN              7200
#define ELFC_GE_TOGGLE_HANDLE             7201
#define ELFC_GE_TRACE_IMAGE               7202
#define ELFC_GE_EXTRUDE                   7203
#define ELFC_GE_CHART_SET_3D              7204
#define ELFC_GE_CHART_GET_3D              7205
#define ELFC_GE_GET_BOUNDER               7206
#define ELFC_GE_GET_UNIQUE_COLORS         7207
#define ELFC_GE_SET_GFX                   7208
#define ELFC_GE_GET_PAGE                  7209
#define ELFC_GE_SET_PAGE                  7210
#define ELFC_GE_ADD_PAGE                  7211
#define ELFC_GE_DEL_PAGE                  7212
#define ELFC_GE_N_PAGES                   7213
#define ELFC_GE_NEXT_PAGE                 7214
#define ELFC_GE_PREVIOUS_PAGE             7215
#define ELFC_GE_CHART_SET_DATASOURCE      7216
#define ELFC_GE_CHART_GET_DATASOURCE      7217
#define ELFC_GE_CHART_SET_AXIS_LINE       7218
#define ELFC_GE_CHART_GET_AXIS_LINE       7219
#define ELFC_GE_CHART_SET_AXIS_LABELS     7220
#define ELFC_GE_CHART_GET_AXIS_LABELS     7221
#define ELFC_GE_SET_EDIT_MODE             7222
#define ELFC_GE_LOAD_TEMPLATE_FILE        7223
#define ELFC_GE_SET_SLIDE_LAYOUT          7224
#define ELFC_GE_GET_SLIDE_LAYOUT          7225
#define ELFC_GE_SET_DISPLAY_SLIDE_BG      7226
#define ELFC_GE_GET_DISPLAY_SLIDE_BG      7227
#define ELFC_GE_SET_DISPLAY_TEMPLATE_BG   7228
#define ELFC_GE_GET_DISPLAY_TEMPLATE_BG   7229
#define ELFC_GE_SET_DISPLAY_SLIDE_OBJS    7230
#define ELFC_GE_GET_DISPLAY_SLIDE_OBJS    7231
#define ELFC_GE_SET_DISPLAY_TEMPLT_OBJS   7232
#define ELFC_GE_GET_DISPLAY_TEMPLT_OBJS   7233
#define ELFC_GE_SET_SLIDE_CSCHEME         7234
#define ELFC_GE_GET_SLIDE_CSCHEME         7235
#define ELFC_GE_SET_TEMPLATE_CSCHEME      7236
#define ELFC_GE_GET_TEMPLATE_CSCHEME      7237
#define ELFC_GE_CREATE_GFX_FROM_PART      7238
#define ELFC_GE_SET_SLIDE_TRANSITION      7239
#define ELFC_GE_GET_SLIDE_TRANSITION      7240
#define ELFC_GE_MOUSE_ACTION              7241
#define ELFC_GE_GET_FILL_STYLE            7242
#define ELFC_GE_SUPRESS_DRAWING           7243
#define ELFC_GE_SET_PRESENTATION_MODE     7244
#define ELFC_GE_LOAD_DATASOURCE           7245
#define ELFC_GE_CHART_NO_RANGES           7246
#define ELFC_GE_IN_CHILD_MODE             7247
#define ELFC_GE_LAST_MOUSE_POS            7248
#define ELFC_GE_FILE_OPERATION            7249
#define ELFC_GE_LOAD_FROM_GFX             7250
#define ELFC_GE_GET_COLOR_SCHEME          7251
#define ELFC_GE_IN_PRESENTATION           7252
#define ELFC_GE_CHART_DO_TREND            7253
#define ELFC_GE_CHART_CREATE_DATA_SHEET	  7254
#define ELFC_GE_CHART_DESTROY_DATA_SHEET  7255
#define ELFC_GE_CHART_GET_DATA            7256
#define ELFC_GE_CHART_SET_DATA            7257
#define ELFC_GE_CHART_SHEET_UTILS         7258
#define ELFC_GE_GET_GRADIENT              7259
#define ELFC_GE_N_GRADIENTS               7260
#define ELFC_GE_DELETE_GRADIENT           7261
#define ELFC_GE_CHANGE_GRADIENT           7262
#define ELFC_GE_CREATE_GRADIENT           7263
#define ELFC_GE_CHART_HAS_DATA_SHEET      7264
#define ELFC_GE_BULLET_LEVEL              7265
#define ELFC_GE_CHART_GET_RANGE_STR       7266
#define ELFC_GE_CHART_GET_GROUP_NAME      7267
#define ELFC_GE_LOAD_ASCII_OUTLINE        7268
#define ELFC_GE_GET_SLIDE_SHOW_OPTIONS    7269
#define ELFC_GE_SET_SLIDE_SHOW_OPTIONS    7270
#define ELFC_GE_GET_RUN_MACRO             7271
#define ELFC_GE_SET_RUN_MACRO             7272
#define ELFC_GE_SAVE_SLIDE_SHOW           7273
#define ELFC_GE_GET_CALLBACK_AT           7274
#define ELFC_GE_RUN_CALLBACK              7275
#define ELFC_GE_SET_PAGE_AUDIO            7276
#define ELFC_GE_GET_PAGE_AUDIO            7277
#define ELFC_GE_CHART_GET_GRP_RANGE       7278
#define ELFC_GE_CHART_SET_SHEET_HEADINGS  7279
#define ELFC_GE_CHART_GET_SHEET_HEADINGS  7280
#define ELFC_GE_CHART_SHEET_DESTROY_PART  7281
#define ELFC_GE_STRIP_PRESENT_INFO        7282
#define ELFC_GE_DUPLICATE_PAGE            7283
#define ELFC_GE_GET_TEXT                  7284
#define ELFC_GE_GET_TEXT_RANGE            7285
#define ELFC_GE_GET_TEXT_WORD_RANGE       7286
#define ELFC_GE_ADD_CUSTOM_COLOR          7287
#define ELFC_GE_CHART_CHANGE_TYPE         7288
#define ELFC_GE_LINK_TO_INSET             7289
#define ELFC_GE_EMBED_INSET               7290
#define ELFC_GE_OUTLINE_COLOR             7291
#define ELFC_GE_GET_OUTLINE_COLOR         7292
#define ELFC_GE_OUTLINE_FORMAT            7293
#define ELFC_GE_GET_OUTLINE_FORMAT        7294
#define ELFC_GE_OUTLINE_TITLES            7295
#define ELFC_GE_GET_OUTLINE_TITLES        7296
#define ELFC_GE_OUTLINE_MV_DOWN           7297
#define ELFC_GE_OUTLINE_MV_UP             7298
#define ELFC_GE_GET_INS                   7299
#define ELFC_GE_SET_INS                   7300
#define ELFC_GE_GET_INS_PROPS             7301
#define ELFC_GE_SET_INS_PROPS             7302
#define ELFC_GE_EMBED_LINK                7303
#define ELFC_GE_LINK_EMBED                7304
#define ELF_CODE_LINK_INSET_IN_PLACEHLDR  7305 /* no slave to consistancy! */
#define ELF_CODE_EMBED_INSET_IN_PLACEHLDR 7306 /* no slave to consistancy! */
#define ELFC_GE_CHART_GET_COORDINATE      7307
#define ELFC_GE_JV_KEY_DOWN               7308 /* replicated in symbase.dat */
#define ELFC_GE_JV_KEY_UP                 7309 /* replicated in symbase.dat */
#define ELFC_GE_JV_MOUSE_DOWN             7310 /* replicated in symbase.dat */
#define ELFC_GE_JV_MOUSE_UP               7311 /* replicated in symbase.dat */
#define ELFC_GE_JV_MOUSE_DRAG             7312 /* replicated in symbase.dat */
#define ELFC_GE_JV_MOUSE_MOVE             7313 /* replicated in symbase.dat */
#define ELFC_GE_JV_EXPOSE                 7314 /* replicated in symbase.dat */
#define ELFC_GE_JV_RESIZE                 7315 /* replicated in symbase.dat */
#define ELFC_GE_JV_INCX                   7316 /* replicated in symbase.dat */
#define ELFC_GE_JV_DECX                   7317 /* replicated in symbase.dat */
#define ELFC_GE_JV_NEXTPGX                7318 /* replicated in symbase.dat */
#define ELFC_GE_JV_PREVPGX                7319 /* replicated in symbase.dat */
#define ELFC_GE_JV_SCROLLX                7320 /* replicated in symbase.dat */
#define ELFC_GE_JV_INCY                   7321 /* replicated in symbase.dat */
#define ELFC_GE_JV_DECY                   7322 /* replicated in symbase.dat */
#define ELFC_GE_JV_NEXTPGY                7323 /* replicated in symbase.dat */
#define ELFC_GE_JV_PREVPGY                7324 /* replicated in symbase.dat */
#define ELFC_GE_JV_SCROLLY                7325 /* replicated in symbase.dat */
#define ELFC_GE_PALETTE_TO_COLOR          7326 /* replicated in symbase.dat */
#define ELFC_GE_SUPPRESS_UNDO             7327
#define ELFC_GE_GET_NOTES_INFO            7328
#define ELFC_GE_SET_NOTES_INFO            7329
#define ELFC_GE_GET_EMPTY_PAGEIX          7330
#define ELFC_GE_GET_BUILD_INFO            7331
#define ELFC_GE_SET_BUILD_INFO            7332
#define ELFC_GE_N_BUILDS                  7333
#define ELFC_GE_N_BUILD_LEVEL             7334
#define ELFC_GE_GET_ZOOM                  7335
#define ELFC_GE_SET_IMAGE_DATA            7336

/********* THE LAST CODE IN USE ***********/
#define ELF_GE_FINALCODE                  7336
