/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elf_ss.h
   Applix ASC version: 236.0.1
   Date: Tue Feb  2 15:20:58 1999
*/
#define ELF_SS_MINCODE  1000
 
#define ELFC_SS_CELL    1000
#define ELFG_SS_CELL    "II"
#define ELFR_SS_CELL    "IIISSISINI"

#define ELFC_SS_STAT    1001
#define ELFG_SS_STAT    ""
#define ELFR_SS_STAT    "IIIIIIIIIIIIIIIIIIIIII"

#define ELFC_SS_VERB	1002
#define ELFG_SS_VERB	"I"
#define ELFR_SS_VERB	""

#define ELFC_SS_GENERAL	1003
#define ELFG_SS_GENERAL	"IISISISISISISISISISIS"

#define ELFC_SS_INFO	1004
#define ELFG_SS_INFO	"III"
#define ELFR_SS_INFO	"S"

#define ELFC_SS_VALFLD  1005
#define ELFG_SS_VALFLD	"IIS"
#define ELFR_SS_VALFLD	"I"

#define ELFC_SS_DOCMOD	1006
#define ELFG_SS_DOCMOD	""
#define ELFR_SS_DOCMOD	"I"

#define ELFC_SS_CHART_INFO  1007

#define ELFC_SS_RENAME  1008
#define ELFG_SS_RENAME  "SIII"
#define ELFR_SS_RENAME  ""

#define ELFC_SS_DOCINFO  1009

#define ELFC_SS_WRTFILE	1010
#define ELFG_SS_WRTFILE	""
#define ELFR_SS_WRTFILE	""

#define ELFC_SS_NAMELIST 1011
#define ELFG_SS_NAMELIST "II"

#define ELFC_SS_NAMEINFO 1012
#define ELFG_SS_NAMEINFO "S"
#define ELFR_SS_NAMEINFO "SSSS"

#define ELFC_SS_VIEWLIST 1013
#define ELFG_SS_VIEWLIST ""

#define ELFC_SS_DOCSTR 1014
#define ELFC_SS_GRIDS 1015
#define ELFC_SS_HITMOD 1016
#define ELFC_SS_GETREF 1017
#define ELFC_SS_SETREF 1018
#define ELFC_SS_GETSETUP 1019
#define ELFC_SS_PUTSETUP 1020
#define ELFG_SS_GETSETUP "SSIIII"


#define ELFC_SS_PAGEBREAK 1021
#define ELFG_SS_PAGEBREAK ""
#define ELFR_SS_PAGEBREAK "S"

#define ELFC_SS_TITLES 1022
#define ELFR_SS_TITLES "S"
#define ELFG_SS_TITLES ""

#define ELFC_SS_GLOBAL_NUMTEXT	1023
#define ELFR_SS_GLOBAL_NUMTEXT  ""
#define ELFG_SS_GLOBAL_NUMTEXT  "IIII"

#define ELFC_SS_GETCOLWIDTH	1024
#define ELFG_SS_GETCOLWIDTH	"S"
#define ELFR_SS_GETCOLWIDTH	"I"

#define ELFC_SS_GETGBL    1025
#define ELFG_SS_GETGBL    ""
#define ELFR_SS_GETGBL    "NNNIIIIISISSSSS"

#define ELFC_SS_SETGBL    1026
#define ELFG_SS_SETGBL    "NNNIIIIISISSSSS"
#define ELFR_SS_SETGBL    ""

#define ELFC_SS_RANGEATTR    1027
#define ELFG_SS_RANGEATTR    "S"
#define ELFR_SS_RANGEATTR    "IIIIIIIII"

#define ELFC_SS_RANGEPROT    1028
#define ELFG_SS_RANGEPROT    "SI"
#define ELFR_SS_RANGEPROT    "II"

#define ELFC_SS_TMPDOCSTR 1029

#define ELFC_SS_SET_RET_KEY 1030
#define ELFG_SS_SET_RET_KEY "I"

#define ELFC_SS_RESET_RET_KEY 1031

#define ELFG_SS_FONTFACE	""
#define ELFC_SS_FONTFACE	1032
#define ELFR_SS_FONTFACE	"I"

#define ELFC_SS_DISABLE_DISPLAY	1033
#define ELFC_SS_ENABLE_DISPLAY	1034

#define ELFC_SS_PAGEBREAKS_INFO	1035
#define ELFG_SS_PAGEBREAKS_INFO	""
#define ELFR_SS_PAGEBREAKS_INFO	"III"

#define ELFC_SS_LOADCELL	1036
#define ELFG_SS_LOADCELL	"SSI"
#define ELFR_SS_LOADCELL	""

#define ELFC_SS_WRITE_LOCAL 1037    /* copy current doc and localize insets */
#define ELFG_SS_WRITE_LOCAL "S"     /* file name for copy */

#define ELFC_SS_QUERYGRAPH	1038    /* query to see if the business graph recieved */
#define ELFG_SS_QUERYGRAPH	""      /* all the data it needs to */
#define ELFR_SS_QUERYGRAPH	"I"

/***********************/
/* CELL BORDERS */

#define ELFC_SS_SETBORDERS 1039
#define ELFG_SS_SETBORDERS "SIIIIII"
#define ELFR_SS_SETBORDERS ""

#define ELFC_SS_GETBORDERS 1040
#define ELFG_SS_GETBORDERS "S"
#define ELFR_SS_GETBORDERS "IIIIII"

#define ELFC_SS_BUILTIN_NAME 1041
#define ELFG_SS_BUILTIN_NAME "I"
#define ELFR_SS_BUILTIN_NAME "S"

#define ELFC_SS_USER_CALLBACK 1042
#define ELFG_SS_USER_CALLBACK "I"
#define ELFR_SS_USER_CALLBACK ""

#define ELFC_SS_SET_RECMODE 1043
#define ELFG_SS_SET_RECMODE "I"
#define ELFR_SS_SET_RECMODE ""

#define ELFC_SS_EDITLINE	1044
#define ELFG_SS_EDITLINE	"I"
#define ELFR_SS_EDITLINE	"I"

#define ELFC_SS_LAST_CELL   1045
#define ELFG_SS_LAST_CELL    ""
#define ELFR_SS_LAST_CELL    "IIISSISIN"

#define ELFC_SS_DATE_STRING   1046
#define ELFG_SS_DATE_STRING    "LI"
#define ELFR_SS_DATE_STRING    "S"

#define ELFC_SS_DATE_VALUE   1047
#define ELFG_SS_DATE_VALUE    "S"
#define ELFR_SS_DATE_VALUE    "LI"

#define ELFC_SS_RANGESTYLE    1048
#define ELFG_SS_RANGESTYLE    "S"
#define ELFR_SS_RANGESTYLE    "III"

#define ELFC_SS_LOGICAL_KEY	  1049
#define ELFG_SS_LOGICAL_KEY	  "I"
#define ELFR_SS_LOGICAL_KEY	  ""

#define ELFC_SS_GRAPHDATA	1050
#define ELFG_SS_GRAPHDATA	"IISISSSSSSSSSSSSSSSSSSIII"
#define ELFR_SS_GRAPHDATA	""

#define ELFC_SS_GRAPHFORMAT	1051
#define ELFG_SS_GRAPHFORMAT	""
#define ELFR_SS_GRAPHFORMAT	""

#define ELFC_SS_CELL_FILENAME	1052
#define ELFG_SS_CELL_FILENAME	"SSI"
#define ELFR_SS_CELL_FILENAME	""

#define ELFC_SS_LOAD_EDITLINE	1053
#define ELFG_SS_LOAD_EDITLINE	"S"
#define ELFR_SS_LOAD_EDITLINE	""

#define ELFC_SS_SET_EDITSIZE 1054
#define ELFG_SS_SET_EDITSIZE "I"
#define ELFR_SS_SET_EDITSIZE ""

#define ELFC_SS_ADD_WINDOW 1055
#define ELFG_SS_ADD_WINDOW ""
#define ELFR_SS_ADD_WINDOW ""

#define ELFC_SS_VERIFY	  1056
#define ELFG_SS_VERIFY	  ""
#define ELFR_SS_VERIFY	  ""

#define ELFC_SS_TOGGLE_SYNC 1057
#define ELFG_SS_TOGGLE_SYNC ""
#define ELFR_SS_TOGGLE_SYNC ""

#define ELFC_SS_REF_CELL 1058
#define ELFG_SS_REF_CELL "SI"
#define ELFR_SS_REF_CELL "S"

#define ELFC_SS_RPC_INFO 1059
#define ELFG_SS_RPC_INFO "I"
#define ELFR_SS_RPC_INFO "S"

#define ELFC_SS_RPC_STATE 1060
#define ELFG_SS_RPC_STATE "S"
#define ELFR_SS_RPC_STATE "I"

#define ELFC_SS_RPC_DIR 1061
#define ELFG_SS_RPC_DIR "S"
#define ELFR_SS_RPC_DIR "S"

#define ELFC_SS_RPC_COM 1062
#define ELFG_SS_RPC_COM "SII"
#define ELFR_SS_RPC_COM "I"

#define ELFC_SS_PRINT	1063
#define ELFG_SS_PRINT	"SIIIIIIIIISS"
#define ELFR_SS_PRINT	""

#define ELFC_SS_INSERT_BUTTON 1064 

#define ELFC_SS_GET_COLOR_TABLE	1065
#define ELFG_SS_GET_COLOR_TABLE	""
#define ELFR_SS_GET_COLOR_TABLE ""

#define ELFC_SS_SHOW_PAGEBREAKS	1066
#define ELFG_SS_SHOW_PAGEBREAKS	""
#define ELFR_SS_SHOW_PAGEBREAKS	""

#define ELFC_SS_ASCII_IMPORT	1067
#define ELFG_SS_ASCII_IMPORT	"SI"
#define ELFR_SS_ASCII_IMPORT	""

#define ELFC_SS_DRAW_OBJ_AT_CELL	1068
#define ELFC_SS_SET_DB			1069
#define ELFC_SS_DB_EXTRACT		1070
#define ELFC_SS_DB_FIND			1071
#define ELFC_SS_DB_VIEW			1072
#define ELFC_SS_SET_SHOW_ZERO_VALS 1073
#define ELFC_SS_VERIFY_ARRAY_FORMS 1074
#define ELFC_SS_GETDBINFO	1075
#define ELFC_SS_GETDBNAMES	1076
#define ELFC_SS_DB_DELETE_REC	1077
#define ELFC_SS_SET_PAGE_SETUP	1078
#define ELFC_SS_GET_PAGE_SETUP	1079
#define ELFC_SS_DELETE_DB	1080

#define ELFC_SS_DRAG_INSET_OBJECT 1081 
#define ELFC_SS_EXT_DOC_INFO    1082
#define ELFC_SS_DEF_GROUP       1083
#define ELFC_SS_INIT_CHART_OBJ	1084
#define ELFC_SS_REVERT			1085

#define ELFC_SS_GET_OBJ_INFO	1086
#define ELFC_SS_SET_OBJ_INFO	1087

#define ELFC_SS_RPC_HOST 		1088
#define ELFC_SS_GET_ROW_HEIGHT	1089
#define ELFC_SS_SET_HDRFTRS		1090
#define ELFC_SS_GET_HDRFTRS		1091
#define ELFC_SS_NEXT_OBJ_NAME	1092
#define ELFC_SS_SET_MARGINS		1093
#define ELFC_SS_GET_MARGINS		1094
#define ELFC_SS_TOGGLE_XIM      1095     /* toggle x input method state */
#define ELFC_SS_GET_OBJS        1096   
#define ELFC_SS_LOAD_OBJ        1097  
#define ELFC_SS_DRAW_OBJS       1098  
#define ELFC_SS_DRAG_COPY_PASTE 1099
#define ELFC_SS_CHART_NAVIGATE  1100
#define ELFC_SS_AUTO_RESIZE_ROWS  1101
#define ELFC_SS_PUT_FONT_SIZE	1102
#define ELFC_SS_PUT_CELL_ATTR	1103
#define ELFC_SS_GET_REV2_TYPEFACES	1104
#define ELFC_SS_GET_FONTSIZES	1105
#define ELFC_SS_EXIT			1106
#define ELFC_SS_SET_DOC_ATTRS	1107
#define ELFC_SS_GET_DOC_ATTRS	1108
#define ELFC_SS_EDIT         	1109
#define ELFC_SS_DELETE_OBJ     	1110
#define ELFC_SS_DELETE_DOC		1111
#define ELFC_SS_PRINT_FORMULAS	1112
#define ELFC_SS_EXPORT			1113
#define ELFC_SS_REPAINT_WINDOW	1114
#define ELFC_SS_GET_HDRFTR_SIZES 1115
#define ELFC_SS_COPIED_ATTRS	1116
#define ELFC_SS_FILL_RANGE		1117
#define ELFC_SS_GOAL_SEEK		1118
#define ELFC_SS_PROJ_TABLE		1119
#define ELFC_SS_SAVE			1120
#define ELFC_SS_COPY			1121
#define ELFC_SS_CUT				1122
#define ELFC_SS_PASTE			1123

#define ELFC_SS_GO_UNDO			1124
#define ELFC_SS_GO_AGAIN		1125	
#define ELFC_SS_GO_RANGE		1126
#define ELFC_SS_GO_NXTLAB		1127
#define ELFC_SS_GO_PRVLAB		1128
#define ELFC_SS_GO_NXTMARK		1129
#define ELFC_SS_GO_PRVMARK		1130
#define ELFC_SS_GO_NXTSPCL		1131
#define ELFC_SS_GO_PRVSPCL		1132
#define ELFC_SS_GO_HOME			1133
#define ELFC_SS_GO_END			1134
#define ELFC_SS_LIST_FONT_FAMILIES      1135
#define ELFC_SS_SET_GRIDLINES	1136
#define ELFC_SS_SET_GLOBAL_COLWIDTH 1137
#define ELFC_SS_SET_CURRENCY 	1138
#define ELFC_SS_CLEAR_CELLS		1139
#define ELFC_SS_BLANK_CELLS		1140
#define ELFC_SS_INSERT_ROWCOL	1141
#define ELFC_SS_DELETE_ROWCOL	1142
#define ELFC_SS_PROTECT_CELLS	1143
#define ELFC_SS_UNPROTECT_CELLS	1144
#define ELFC_SS_SET_TITLES		1145
#define ELFC_SS_SET_PAGEBRKS	1146
#define ELFC_SS_CLEAR_PAGEBRKS	1147
#define ELFC_SS_SET_COL_WIDTH	1148
#define ELFC_SS_SET_ROW_HEIGHT	1149
#define ELFC_SS_RESET_COL_WIDTHS	1150
#define ELFC_SS_SET_CALC_MODE	1151
#define ELFC_SS_DO_ROW_SORT		1152
#define ELFC_SS_DO_COL_SORT		1153
#define ELFC_SS_SET_HOOK		1154
#define ELFC_SS_GET_HOOK		1155
#define ELFC_SS_SET_REFERENCE	1156
#define ELFC_SS_GRID_ADDR_TOGGLE	1157
#define ELFC_SS_SET_GRID_ADDR	1158
#define ELFC_SS_CHANGE_NAME		1159
#define ELFC_SS_CREATE_NAME		1160
#define ELFC_SS_CREATE_ISR		1161
#define ELFC_SS_DELETE_NAME		1162
#define ELFC_SS_CHANGE_ISR		1163
#define ELFC_SS_PASTE_SPECIAL	1164
#define ELFC_SS_VIEW_MODE		1165
#define ELFC_SS_LOAD_DB_SAVED_VIEW 1166
#define ELFC_SS_FIND_REPLACE 1167
#define ELFC_SS_SAVE_VIEW	1168
#define ELFC_SS_SET_CELL_JUST	1169
#define ELFC_SS_SET_CELL_STYLE	1170
#define ELFC_SS_SET_CELL_INVISIBILITY 1171
#define ELFC_SS_HIDE_SELECTED_ROWCOL	1172
#define ELFC_SS_VIEW_ALL	1173
#define ELFC_SS_LOAD_VIEW	1174
#define ELFC_SS_DELETE_VIEW 1175
#define ELFC_SS_VIEW_SELECTED_ROWCOL	1176
#define ELFC_SS_VIEW_RANGE	1177
#define ELFC_SS_CURSOR_DIRECTION 1178
#define ELFC_SS_INSERT_LINE_BREAK 1179
#define ELFC_SS_OPEN_FILE	1180
#define ELFC_SS_UNDO_STATUS 1181
#define ELFC_SS_PASTE_NAME 1182
#define ELFC_SS_GET_RANGE_VECTOR_VALS	1183
#define ELFC_SS_GET_LEGEND_AXIS_LABELS	1184
#define ELFC_SS_GET_CHART_GROUP_INFO	1185
#define ELFC_SS_CHART_DELETE_GROUP		1186
#define ELFC_SS_STR_TO_RANGE			1187
#define ELFC_SS_GET_DEFAULT_NUM_FORMAT	1188
#define ELFC_SS_GEN_NEW_NAME			1189
#define ELFC_SS_FILE_CONTAINS_CHARTS	1190
#define ELFC_SS_GET_SELECTED_OBJS		1191
#define ELFC_SS_SET_OBJ_EXTENT			1192
#define ELFC_SS_STATUS_MESSAGE			1193
#define ELFC_SS_EXIT_CLIPBOARD			1194
#define ELFC_SS_GET_LEGEND_LABELS		1195
#define ELFC_SS_INIT_STROKE_SELECT_MODE 1196

#define ELFC_SS_CHARTS_UPDATE			1197
#define ELFC_SS_UNHIDE_ROWCOL			1198
#define ELFC_SS_SELECT_PROTECTED		1199
#define ELFC_SS_SELECT_PAGEBRKS			1200
#define ELFC_SS_SELECT_ALL				1201
#define ELFC_SS_SET_CR_MOVEMENT			1202
#define ELFC_SS_CLEAR_MARKS				1203
#define ELFC_SS_UPDATE_REFS				1204
#define ELFC_SS_SELECT_MATERIAL			1205
#define ELFC_SS_GET_CURRENCY			1206
#define ELFC_SS_UPDATE_CHARTS			1207

#define ELFC_SS_DEFINE_DATA_GROUP		1208
#define ELFC_SS_DEFINE_LEGEND_LABELS	1209
#define ELFC_SS_DEFINE_LABEL_GROUP		1210
#define ELFC_SS_GET_CLIP_BOARD_RNG 		1211
#define ELFC_SS_INSERT_OBJ_AT_CELL		1212
#define ELFC_SS_INSERT_OBJ_AT_DOC_POS 	1213
#define ELFC_SS_SET_PRINT_SCALE_FACTOR	1214
#define ELFC_SS_GET_PRINT_SCALE_FACTOR	1215
#define ELFC_SS_GET_PRINT_SCALE_FACTOR	1215

#define ELFC_SS_PUT_GROUP				1216
#define ELFC_SS_SELECT_ARRAY_FORMULA	1217
#define ELFC_SS_RENAME_OBJECT			1218
#define ELFC_SS_GET_RANGE_NUM_FORMAT	1219
#define ELFC_SS_BG_FORMAT_NUMBER		1220
#define ELFC_SS_FIND_GR_OBJ				1221
#define ELFC_SS_REDRAW_CHART			1222
#define ELFC_SS_PUT_ARRAY_FORMULA		1223
#define ELFC_SS_OBJ_LOAD_FILE			1224
#define ELFC_SS_GET_DEL_VIEW_NAMES		1225
#define ELFC_SS_OBJ_SET_PROPERTY		1226
#define ELFC_SS_OBJ_GET_PROPERTY		1227
#define ELFC_SS_RT_UPDATE_ODS           1228
#define ELFC_SS_RT_LINK_DIED            1229
#define ELFC_SS_OBJ_MOVE_BACK			1230
#define ELFC_SS_OBJ_MOVE_FRONT			1231
#define ELFC_SS_OBJ_MOVE_FORWARD		1232
#define ELFC_SS_OBJ_MOVE_BACKWARD		1233
#define ELFC_SS_OBJ_GET_NEW_CHART_SIZE	1234
#define ELFC_SS_REDISPLAY				1235
#define ELFC_SS_OBJ_GET_STATE			1236
#define ELFC_SS_OBJ_GET_EXTENT			1237
#define ELFC_SS_OBJ_GET_LOCATION		1238
#define ELFC_SS_OBJ_SET_TASK_ID			1239
#define ELFC_SS_OBJ_GET_NAMES			1240
#define ELFC_SS_LOAD_CHART_BITMAP		1241
#define ELFC_SS_OPEN_CELL_FOR_RANGES	1242
#define ELFC_SS_SET_WORKSHEET_NAME		1243
#define ELFC_SS_GET_WORKSHEET_NAME		1244
#define ELFC_SS_GET_SHEETS_DISPLAY		1245
#define ELFC_SS_SET_SHEETS_DISPLAY		1246
#define ELFC_SS_GET_SHEETS				1247
#define ELFC_SS_SET_ZOOM_FACTOR			1248
#define ELFC_SS_GET_ZOOM_FACTOR			1249
#define ELFC_SS_GET_SELECTION_TYPE		1250
#define ELFC_SS_SET_MOVE_PREFERENCE		1251
#define ELFC_SS_NEW_SHEET				1252
#define ELFC_SS_SET_SHEET				1253
#define ELFC_SS_PUT_RANGE				1254
#define ELFC_SS_GET_CUR_VIEW			1255
#define ELFC_SS_SELECT_OBJ				1256
#define ELFC_SS_PRVIEW_CMD				1257
#define ELFC_SS_GET_EDIT_TYPEFACE		1258
#define ELFC_SS_SET_CUR_WIN				1259
#define ELFC_SS_GET_CUR_WIN				1260
#define ELFC_SS_SET_CALC_OPTIONS		1261
#define ELFC_SS_GET_CALC_OPTIONS		1262
#define ELFC_SS_SAVE_AS_311				1263
#define	ELFC_SS_RNGSTR_TO_ABSRNG_STR	1264
#define ELFC_SS_LOCAL_NAME_RNG			1265
#define ELFC_SS_CHART_COMPLETE			1266
#define ELFC_SS_PRS_RNG_FUNCS			1267
#define ELFC_SS_CHART_SETUP_INFO		1268
#define ELFC_SS_HELP_CELL				1269
#define ELFC_SS_GET_CALC_CELL			1270
#define ELFC_SS_GET_CALC_CELL_RANGE		1271
#define ELFC_SS_SET_CHART_GFX			1272
#define ELFC_SS_SET_BUTTON_TITLE		1273
#define ELFC_SS_GET_BUTTON_TITLE		1274
#define ELFC_SS_VERIFY_FORMULA_RANGES	1275
#define ELFC_SS_INSERT_CELLS			1276
#define ELFC_SS_DELETE_CELLS			1277
#define ELFC_SS_IS_RNG_ABS				1278
#define ELFC_SS_GE_RNGSTR_TO_DATA		1279
#define ELFC_SS_OBJ_SET_LOCATION		1280
#define ELFC_SS_OPEN_LOCAL_INSET		1281
#define ELFC_SS_CHART_UTILS				1282
#define ELFC_SS_RANGE_CALC				1283
#define ELFC_SS_LOCK_OBJ_FROM_DIALOG	1284
#define ELFC_SS_UNLOCK_OBJ_FOR_DIALOG	1285
#define ELFC_SS_MOVE_SHEET  			1286
#define ELFC_SS_MAKE_CELL_OBS  			1287
#define ELFC_SS_SET_STRUCTURED_COMMENT	1288
#define ELFC_SS_GET_STRUCTURED_COMMENT	1289
#define ELFC_SS_GET_CELL_DATA			1290
#define ELFC_SS_GET_RANGE_DATA			1291
#define ELFC_SS_GET_CELL_ATTR_INFO		1292
#define ELFC_SS_SET_CELL_ATTR_INFO		1293
#define ELFC_SSX_UTIL					1294
#define ELFC_SS_COPY_SHEET  			1295
#define ELFC_SS_DOC_INFO				1296
#define ELFC_SS_EDITLINE_STATE			1297
#define ELFC_SS_SET_ELF_OBJ				1298
#define ELFC_SS_GET_ELF_OBJ				1299
#define ELFC_SS_LINK_TO_INSET			1300
#define ELFC_SS_EMBED_INSET				1301
#define ELFC_SS_GET_INSET_INFO			1302
#define ELFC_SS_SET_INSET_INFO			1303
#define ELFC_SS_SET_WIN_TITLE			1304
#define ELFC_SS_GET_WIN_TITLE			1305
#define ELFC_SS_UNSELECT_ALL_OBJS		1306
#define ELFC_SS_ADD_SELECT_OBJ			1307
#define ELFC_SS_GET_READ_ONLY			1308
#define ELFC_SS_IS_CHILD_DOC			1309
#define ELFC_SS_VFY_ENABLE_LIVE_FEED    1310
#define ELFC_SS_JV_DEFER_HAMMER			1311 /* TEMP!!0 for 120578 */
#define ELFC_SS_JV_RESUME_HAMMER		1312 /* TEMP!!0 for 120578 */
#define ELFC_SS_SHEET_LOCK				1313
#define ELFC_SS_SPELL_CHECKER			1314
#define ELFC_SS_UPDT_RTI_CELLS			1315
#define ELFC_SS_DISP_REF_CELL_LIST		1316
#define ELFC_SS_DISP_DEP_CELL_LIST		1317
#define ELFC_SS_HTML_UTILS				1318
#define ELFC_SS_TM1_UTILS				1319
/* when you add a new code here, increment value of ELF_SS_MAXCODE */
#define ELF_SS_MAXCODE					1320

/* ELF_SS_JV_STARTCODE should be > ELF_SS_MAXCODE */
#define ELF_SS_JV_STARTCODE            3000

#define ELFC_SS_JV_GET_GRAPHIC			3000
#define ELFC_SS_JV_GET_VIEW_INFO		3001
#define ELFC_SS_JV_ALLOW_MORE_CELLS		3002
#define ELFC_SS_JV_RESET				3003
#define ELFC_SS_JV_SETSHEET				3004
#define ELFC_SS_JV_SETCOLWIDTH			3005
#define ELFC_SS_JV_STROKE_SELECT		3006
#define ELFC_SS_JV_UPDATE_OBJ_INFO		3007
#define ELFC_SS_JV_RESHAPE_OBJECT		3008
#define ELFC_SS_JV_GET_RANGE_INFO		3009
#define ELFC_SS_JV_SETROWHEIGHT			3010
#define ELFC_SS_JV_SET_EDITLINE			3011
#define ELFC_SS_JV_EDIT_CELL			3012
#define ELFC_SS_JV_SET_SELNOTIFY		3013
#define ELFC_SS_JV_NOTE_CELL			3014
#define ELFC_SS_JV_FLUSH				3015
#define ELFC_SS_JV_SET_DISPRANGE		3016
#define ELFC_SS_JV_LOADCELL				3017
#define ELFC_SS_JV_TM1_ADDIN_INSTALLED	3018
#define ELFC_SS_JV_CELL_MACRO           3019
#define ELFC_SS_JV_SET_CURWIN           3020
#define ELFC_SS_JV_GET_CURWIN           3021
#define ELFC_SS_JV_NOTIFY               3022
/* when you add a new code here, increment value of ELF_SS_JV_MAXCODE */
#define ELF_SS_JV_MAXCODE				3023

#define ELF_SS_GET_CELLS_INFO			1
#define ELF_SS_GET_FUNCS_INFO			2


/* ssx util macros */
#define	ELF_SSX_CREATE				1
#define ELF_SSX_DESTROY				2
#define ELF_SSX_READ_FILE			3
#define ELF_SSX_WRITE_FILE			4
#define ELF_SSX_SET_TASK_INFO 		5
#define ELF_SSX_GET_DOC_INFO  		6
#define ELF_SSX_GET_DOC_OBJ_LIST    7
#define ELF_SSX_PRS_RNG_FUNCS	  	8
#define ELF_SSX_WRITE_BUFFER		9	
#define ELF_SSX_READ_BUFFER			10	

#define NUM_CATEGORIES	12

#define ELF_SS_ALL_FUNC			0	
#define ELF_SS_FINANCIAL_FUNC	1
#define ELF_SS_MATH_FUNC		2
#define ELF_SS_STAT_FUNC		3
#define ELF_SS_DATE_FUNC		4
#define ELF_SS_STRING_FUNC		5
#define ELF_SS_DB_FUNC			6
#define ELF_SS_LOGICAL_FUNC		7
#define ELF_SS_SPECIAL_FUNC		8
#define ELF_SS_GENERAL_FUNC		9
#define ELF_SS_RTS_FUNC			10		
#define ELF_SS_EXT_FUNC			11

#define ELF_SS_FUNC_CATG		12


#define FUNC_ALL		XLT("All")
#define FUNC_FINANCIAL 	XLT("Financial")
#define FUNC_MATH		XLT("Math")
#define FUNC_STATISTICS	XLT("Statistical")
#define FUNC_DATETIME	XLT("DateTime")
#define FUNC_STRINGS	XLT("String")
#define FUNC_DB			XLT("Database")
#define	FUNC_LOGICAL	XLT("Logical")
#define FUNC_SPECIAL	XLT("Special")
#define FUNC_GENERAL	XLT("General")
#define FUNC_RT			XLT("Real Time")
#define FUNC_EXT		XLT("External")


#define SET_USER_CALLBACK      1
#define SET_DBL_CLICK_CALLBACK 2
#define SET_LOADCELL_CALLBACK  3
#define SET_CR_CALLBACK        4

#define UNSET_USER_CALLBACK      5
#define UNSET_DBL_CLICK_CALLBACK 6
#define UNSET_LOADCELL_CALLBACK  7
#define UNSET_CR_CALLBACK        8

#define GET_LOCAL_USER_CALLBACK		 	9
#define GET_LOCAL_DBL_CLICK_CALLBACK	10
#define GET_LOCAL_LOAD_CELL_CALLBACK	11
#define GET_LOCAL_CR_CALLBACK			12

#define SET_UI_LOADCELL_CALLBACK		13
#define UNSET_UI_LOADCELL_CALLBACK		14
#define GET_LOCAL_UI_LOADCELL_CALLBACK		15


#define SS_ELF_FIND_ONLY   0
#define SS_ELF_REPLACE_ONE 1
#define SS_ELF_REPLACE_ALL 2

#define	SS_ELF_DEFAULT_FG_COLOR		NXLT("WorkArea Foreground")
#define	SS_ELF_DEFAULT_BG_COLOR		NXLT("WorkArea Background")
#define SS_GROUP_OFFSET	100




#define ELF_SS_STR_TO_COLNUM		1	/* convert str to a col num */
#define ELF_SS_COLNUM_TO_STR		2	/* convert colnum to str */
#define ELF_SS_EXTRACT_COL_ROW		3	/* convert cell str to row-col */
#define ELF_SS_EXTRACT_RANGE		4	/* convert rngstr to range struct */
#define ELF_SS_RNG_TO_STR			5	/* convert range to str */
#define ELF_SS_COORD_TO_STR			6	/* convert coord to str */
#define ELF_SS_STR_TO_RNG			7	/* convert str to range */
#define ELF_SS_FULL_RNG_STR			8	/* convert rng to full rng str */
#define ELF_SS_SHEETNUM_TO_STR		9	/* convert sheetnum to str */
#define ELF_SS_STR_TO_SHEETNUM		10	/* convert str to a sheet num */
#define ELF_SS_GET_OPEN_CELL_STR	11	/* get open cell */
#define ELF_SS_GET_OPEN_CELL		12	/* get open cell */
#define ELF_SS_RT_NEED_REGISTER		13	/* true if need to register rt stuff */
#define ELF_SS_PASTE_GET_STATUS     14  /* return the status of last paste */
#define ELF_SS_VFY_CHART_UPDATE		15	/* make sure chart is upto date */
#define ELF_SS_VIEW_GET_COL_WID     16  /* get view based col width */
#define ELF_SS_VIEW_GET_ROW_HYT     17  /* get view based row height */
#define ELF_SS_SET_TOP_LEFT     	19  /* set the top left */
#define ELF_SS_MAKE_NA_DATA     	20  /* make na value */
#define ELF_SS_MAKE_ERROR_DATA    	21  /* make error value */
#define ELF_SS_IS_NA  				22  /* true if datum is NA */
#define ELF_SS_IS_ERROR				23  /* true if datum is ERROR */
#define ELF_SS_SET_VIEW_FORMULAS	24  /* set view formulas option */
#define ELF_SS_GET_VIEW_FORMULAS	25  /* set view formulas option */
#define ELF_SS_GET_VIEW_INFO		26  /* get view information */
#define ELF_SS_GET_WIN_INFO			27  /*  get window information */
#define ELF_SS_IS_SAFE_CALLING_MACROS	28  /*  is calling macros safe **/
#define ELF_SS_GET_CUSTOM_STYLES	29	/* get custom style strs */
#define	ELF_SS_SET_CUSTOM_STYLES	30	/* set custom style strs */
#define	ELF_SS_DEBUG_DUMP_ATTRS		31	/* dump attrs to file for debug */
#define	ELF_SS_DELETE_EMPTY_CELLS	32	/* delete empty cells */
#define	ELF_SS_SPL_STR_TO_RANGE		33	/* parse comma separated ranges */
#define ELF_SS_IMPORT_DELIMITED 	34 	/* Import Delimited ASCII */ 
#define ELF_SS_IMPORT_COLUMNS 		35 	/* Import Columned ASCII */
#define ELF_SS_CELL_IN_EXT_RANGE 	36 	/* Import Columned ASCII */


/* chart util defines */
#define SS_ELF_CHART_GET_TITLES			1
#define SS_ELF_CHART_SET_TITLES			2
#define SS_ELF_CHART_GET_AXIS_LABELS	3
#define SS_ELF_CHART_SET_AXIS_LABELS	4
#define SS_ELF_CHART_GET_LEGEND_TITLE	5
#define SS_ELF_CHART_SET_LEGEND_TITLE	6
#define SS_ELF_CHART_GET_GROUP_RANGES	7
#define SS_ELF_CHART_SET_GROUP_RANGES	8
#define SS_ELF_CHART_PRS_RANGE			9
#define SS_ELF_CHART_GET_REFERR_STR		10
#define SS_ELF_CHART_DESTROY_ALL		11
#define SS_ELF_CHART_SIZE_FROM_LOC		12
#define SS_ELF_CHART_COMPACT_RANGES		13
#define SS_ELF_CHART_EXPLODE_RANGES		14
#define SS_ELF_CHART_GET_SERIES			15
#define SS_ELF_CHART_SET_SERIES			16		
#define SS_ELF_CHART_RANGE_TO_SERIES    17


/* tm1 utils */
#define SS_ELF_TM1_IMPORT_FILE_DATA		1
#define SS_ELF_TM1_EXTRACT_UNIQ_ELEM	2

/*** for the editline defines ***/
#define SS_ELF_GET_EDITLINE_STATE		1
#define SS_ELF_SET_EDITLINE_STATE		2

/* spell check utilility */
#define SS_ELF_SPELL_NEXT_DATA			1 /* gets the next text cell string */
#define SS_ELF_SPELL_PREV_DATA			2 /* gets the prev text cell string */
#define SS_ELF_SPELL_UPDT_CELL			3 /* updts the cell with passed string*/
#define SS_ELF_SPELL_CUR_CELL			4 /* gets the current open_cell */
#define SS_ELF_SPELL_UPDT_SCREEN		5 /* updts the screen */

