/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elfsql.h
   Applix ASC version: 39
   Date: Tue Feb  2 15:21:27 1999
*/
/* STRIP LINES THROUGH HERE */

/* 
Interface between ELF & C for Elf database access.
SQL Gateway defines.

*/


#define ELFSQL_PING_  		0
#define ELFSQL_CONNECT_ 	1
#define ELFSQL_DISCONNECT_ 	2
#define ELFSQL_LOGGING_ 	3
#define ELFSQL_PREPARE_ 	4

#define ELFSQL_UNPREPARE_ 	5
#define ELFSQL_DECL_CURSOR_ 	6
#define ELFSQL_OPEN_CURSOR_ 	7
#define ELFSQL_FETCH_CURSOR_ 	8
#define ELFSQL_CLOSE_CURSOR_ 	9

#define ELFSQL_EXEC_STR_ 	10
#define ELFSQL_EXEC_STMT_ 	11
#define ELFSQL_PREPARE_UPDT_ 	12
#define ELFSQL_SEND_BIN_  	13
#define ELFSQL_CURSOR_PROPS_    14

#define ELFSQL_PROCEDURE_       15
#define ELFSQL_QUERY_FORMAT_    16		/* for non-SQL gateways */
#define ELFSQL_COL_NAMES_	17		/* for non-SQL gateways */
#define ELFSQL_TABLE_NAMES_	18		/* for non-SQL gateways */
#define ELFSQL_ACCEPT_TABLE_	19		/* for non-SQL gateways */
#define ELFSQL_DESCRIBE_	20
#define ELFSQL_PREPARE_WATCH_	21
#define ELFSQL_WATCH_QUERY_	22
#define ELFSQL_INTERRUPT_RECVD_	23
#define ELFSQL_PAUSE_ 24 /* gateway will pause(), so debugger can attach */
#define ODBC_DATA_SOURCES_ 25 /* for ODBC, get list of possible connections */
#define ODBC_TABLES_ 26 /* get table names */
#define ODBC_COLUMNS_ 27 /* get column names */
#define ODBC_DATASOURCES_ 28 /* get list of data sources */
#define ODBC_PRIMARYKEYS_ 29
#define ODBC_TRANSACT_ 30
#define ODBC_GETINFO_ 31
#define ODBC_SETPOS_ 32
#define ELFSQL_GET_SIGUSR1_ 33	/* send back the value of SIGUSR1*/

/*
 * The basic data types in RDBMS:
 */

#define SQL_CHAR_         1
#define SQL_NUMBER_       2
#define SQL_BINARY_       3
#define SQL_DATETIME_     4
#define SQL_MONEY_        5
#define SQL_DATE_     	  6		/* informix distinguishes between
								   a date field and a datetime field */

/*
 * The alignment information for the displayed columns. left, center 
 * and right.
 */

#define SQL_ALIGN_L_         1
#define SQL_ALIGN_C_         2
#define SQL_ALIGN_R_         3

/*
 * Whether and where to trim the strings
 */

#define SQL_TRIM_BOTH_        0
#define SQL_TRIM_BEGIN_       1
#define SQL_TRIM_END_         2
#define SQL_TRIM_NONE_        3


/* format string for dates coming from SQL gateways */
#define SQL_DATETIME_FORMAT_ "yyyy-mm-dd HH:mi:ss"

/* 
 * ID's for client/server version handshakes 
 */
/* from before we had version handshaking */
#define SQL_GATEWAY_V1 0 
/* beginning with version handshake, 10/17/95 */
#define SQL_GATEWAY_V2 1
/* axmain */
#define SQL_CLIENT_V1 3
/* realtime sql */
#define RTSQL_CLIENT_V1 4

