/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elparser.c
   Applix ASC version: 54
   Date: Tue Feb  2 15:21:27 1999
*/
#define FOR_PARSER
#define COMPILER_OPCODES 1      /* to get opcodes in compiler form */
#include <elcomp.h>
#include <elnodes.h>
#include <elcodes.h>

extern int InFunction;
extern ndata CrtNode();
extern int HaveFunctions;
extern int AllowSourceInfo;
extern int ElfIntMode;
 
#define CrtNode0(l,a) CrtNode(0,l,a)
#define CrtNode1(l,a,b) CrtNode(1,l,a,b)
#define CrtNode2(l,a,b,c) CrtNode(2,l,a,b,c)
#define CrtNode3(l,a,b,c,d) CrtNode(3,l,a,b,c,d)
#define CrtNode4(l,a,b,c,d,e) CrtNode(4,l,a,b,c,d,e)
#define CrtNode5(l,a,b,c,d,e,f) CrtNode(5,l,a,b,c,d,e,f)
#define CrtNode6(l,a,b,c,d,e,f,g) CrtNode(6,l,a,b,c,d,e,f,g)

# define TK_NOTHING 257
# define TK_COMMA 258
# define TK_COLON 259
# define TK_DOLLAR 260
# define TK_DOT 261
# define TK_SEMICO 262
# define TK_HOOK 263
# define TK_OPEN 264
# define TK_CLOSE 265
# define TK_OBRAK 266
# define TK_CBRAK 267
# define TK_BEGIN 268
# define TK_ENDCMD 269
# define TK_ENDFUNC 270
# define TK_ENDBLOCK 271
# define TK_ENTRY 272
# define TK_PERCENT 273
# define TK_BEGINSET 274
# define TK_ENDSET 275
# define TK_STRVAL 276
# define TK_NUMVAL 277
# define TK_FOR 278
# define TK_NEXT 279
# define TK_TO 280
# define TK_BY 281
# define TK_WHILE 282
# define TK_WEND 283
# define TK_IF 284
# define TK_THEN 285
# define TK_ELSE 286
# define TK_GOTO 287
# define TK_CALL 288
# define TK_ON 289
# define TK_RETURN 290
# define TK_BREAK 291
# define TK_CONTINUE 292
# define TK_DONE 293
# define TK_ERROR 294
# define TK_NODEBUG 295
# define TK_DEFINE 296
# define TK_INCLUDE 297
# define TK_SEARCH 298
# define TK_LET 299
# define TK_SELECT 300
# define TK_UPDATE 301
# define TK_EXECUTE 302
# define TK_CASE 303
# define TK_DEFAULT 304
# define TK_ENDCASE 305
# define TK_ARRAYOF 306
# define TK_ARRAYOF2 307
# define TK_FROM 308
# define TK_WHERE 309
# define TK_GROUP 310
# define TK_ORDER 311
# define TK_DISTINCT 312
# define TK_ALL 313
# define TK_IN 314
# define TK_BETWEEN 315
# define TK_CREATE 316
# define TK_TABLE 317
# define TK_VALUES 318
# define TK_INSERT 319
# define TK_DROP 320
# define TK_SQL 321
# define TK_DECLARE 322
# define TK_PREPARE 323
# define TK_OPENWORD 324
# define TK_FETCH 325
# define TK_CLOSEWORD 326
# define TK_ASC 327
# define TK_DESC 328
# define TK_UNION 329
# define TK_INTERSECT 330
# define TK_MINUS 331
# define TK_AT 332
# define TK_CURRENT 333
# define TK_OF 334
# define TK_CONNECT 335
# define TK_START 336
# define TK_WITH 337
# define TK_UNPREPARE 338
# define TK_EXTERN 339
# define TK_CONSTANT 340
# define TK_STATIC 341
# define TK_PROC 342
# define TK_UIPROC 343
# define TK_NRPROC 344
# define TK_FUNC 345
# define TK_VAR 346
# define TK_SYSVAR 347
# define TK_OBJVAR 348
# define TK_OBJECT 349
# define TK_FORMAT 350
# define TK_COMPILE 351
# define TK_PUBLIC 352
# define TK_PRIVATE 353
# define TK_OLDSET 354
# define TK_OLDGET 355
# define TK_SET 356
# define TK_GET 357
# define TK_TRUE 358
# define TK_FALSE 359
# define TK_NULL 360
# define TK_ID 361
# define TK_EQUALS 362
# define TK_GRTR 363
# define TK_LESS 364
# define TK_LEQ 365
# define TK_GEQ 366
# define TK_NEQ 367
# define TK_SGRTR 368
# define TK_SLESS 369
# define TK_SLEQ 370
# define TK_SGEQ 371
# define TK_NOT 372
# define TK_ADD 373
# define TK_SADD 374
# define TK_SUB 375
# define TK_MULT 376
# define TK_DIV 377
# define TK_IDIV 378
# define TK_EXP 379
# define TK_REM 380
# define TK_AND 381
# define TK_OR 382
# define TK_XOR 383
# define TK_EQV 384
# define TK_IMP 385
# define TK_ADDTO 386
# define TK_SUBTO 387
# define TK_LEXERROR 388
# define UNOP 389
# define PRIMOP 390
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 870 "elsyntax.y"
 /* START CODE */

int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 250
# define YYLAST 1639
int yyact[]={

   102,   120,   389,   366,   364,   365,   439,   319,   347,   320,
   322,   323,   453,   321,   324,   413,   414,   180,   181,   182,
   179,   183,   408,   221,    89,   322,   323,   409,   321,   324,
   321,   372,   116,   117,   319,   179,   320,   322,   323,   367,
   321,   324,   468,   177,   199,   178,   180,   181,   182,   179,
   183,   232,   233,   319,   308,   320,   322,   323,   408,   321,
   324,   459,   362,   420,   417,   416,   418,   419,   421,   457,
   226,   357,   406,   415,   319,   131,   320,   322,   323,   405,
   321,   324,   193,   190,   189,   191,   192,   194,   196,   195,
   197,   198,   200,   177,   199,   178,   180,   181,   182,   179,
   183,   206,   207,    86,   404,   224,   388,   199,    85,   180,
   181,   182,   179,   183,   247,   229,   322,   323,   172,   321,
   236,   180,   181,   408,   179,   130,   193,   190,   189,   191,
   192,   194,   196,   195,   197,   198,   217,   177,   199,   178,
   180,   181,   182,   179,   183,   184,   185,   186,   187,   188,
   193,   190,   189,   191,   192,   194,   196,   195,   197,   198,
   356,   177,   199,   178,   180,   181,   182,   179,   183,   184,
   185,   186,   187,   188,   107,   240,   241,   111,   394,   279,
   280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
   290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   139,   140,   278,   272,   358,   170,   134,   355,
   352,   135,   306,   224,   319,   403,   320,   322,   323,   276,
   321,   324,   171,   224,   224,   173,   134,   351,   329,   135,
   239,    82,   343,    86,    58,    57,    84,    86,    85,   336,
   165,   339,    85,   341,   217,    86,    56,   256,   108,   109,
    85,   210,   338,   106,   326,   327,   330,   138,    74,    75,
   193,   190,   189,   191,   192,   194,   196,   195,   197,   198,
   348,   177,   199,   178,   180,   181,   182,   179,   183,   184,
   185,   186,   187,   188,   193,   190,   189,   191,   192,   194,
   196,   195,   197,   198,   271,   177,   199,   178,   180,   181,
   182,   179,   183,   184,   185,   186,   187,   188,   275,   133,
   274,   224,   273,    73,   255,   376,   377,   378,   249,   224,
   224,   224,   224,   224,   224,   224,   254,   133,   111,   224,
    54,    58,    57,   363,    79,   122,   123,   247,   164,   253,
   227,   208,   387,    56,   201,   463,   174,   111,   209,   157,
   380,   381,   382,   383,   384,   385,   386,   156,   248,   154,
   393,   153,   361,   152,   151,    58,    57,   150,   149,   224,
   141,   129,   224,   128,   127,   224,   411,    56,   126,   424,
   125,   124,   112,   105,    88,    87,    65,    66,    67,    68,
    71,    64,   224,   224,   429,   430,   431,   423,    63,   363,
    69,    70,   224,   412,   224,   250,   433,    62,   410,   224,
   224,   434,    61,   438,   437,   224,    60,   224,   224,   224,
   224,   224,   224,   393,   393,    59,   348,   224,   442,   443,
   307,   436,   246,   401,   361,   435,   242,   104,   425,   247,
   230,   224,   114,   458,   224,   396,   441,   334,   444,   445,
   446,   447,   448,   449,   247,   104,    51,   375,   454,   464,
   224,   224,   132,   467,   224,   374,   373,   243,   471,   224,
   137,   237,   393,    86,   462,   461,    84,   237,    85,   428,
   460,   440,    36,   247,   328,    84,   270,    35,   304,   426,
   143,   466,   393,    16,    38,    39,   472,    21,   245,    17,
   473,   244,   113,    24,    26,   469,   470,    22,    23,    31,
   235,   426,    27,   160,    30,    28,    25,   360,   465,    29,
   451,   452,    72,   325,    20,   350,    51,    44,    32,    33,
    34,   309,   310,   313,   311,   426,   426,   426,   237,   237,
   407,   331,   456,   455,   427,   400,   399,    42,    40,    43,
   237,    45,   314,   315,   316,   136,   450,   354,   312,   237,
   228,   237,   353,    41,   402,   302,   269,   136,   318,   211,
   370,    47,    50,    48,   369,    55,   422,    49,     3,    76,
   214,    52,    46,   212,   346,   340,    19,   193,   190,   189,
   191,   192,   194,   196,   195,   197,   198,    78,   177,   199,
   178,   180,   181,   182,   179,   183,   184,   185,   186,   187,
   188,    37,     2,     1,   193,   190,   189,   191,   192,   194,
   196,   195,   197,   198,     0,   177,   199,   178,   180,   181,
   182,   179,   183,   184,   185,   186,   187,   188,   193,   190,
   189,   191,   192,   194,   196,   195,   197,   198,     0,   177,
   199,   178,   180,   181,   182,   179,   183,   184,   185,   186,
   187,   188,   193,   190,   189,   191,   192,   194,   196,   195,
   197,   198,    80,   177,   199,   178,   180,   181,   182,   179,
   183,   184,   185,   186,   187,   188,   193,   190,   189,   191,
   192,   194,   196,   195,   197,   198,    13,   177,   199,   178,
   180,   181,   182,   179,   183,   184,   185,   186,   187,    36,
   349,    83,   251,     0,    35,     0,     0,     0,     0,     0,
    16,    38,    39,     0,    21,     0,    17,     0,     0,     0,
    24,    26,     0,     0,    22,    23,    31,     0,     0,    27,
     0,    30,    28,    25,     0,     0,    29,    14,   379,     0,
     0,    20,     0,    51,    44,    32,    33,    34,     0,     0,
   175,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   205,     0,     0,    42,    40,    43,     0,    45,   166,
     0,     0,   317,     0,     0,     0,     0,     0,   349,    81,
    41,     4,   163,     0,     5,     6,     7,     8,    47,    50,
    48,     0,    15,    12,    49,    11,     0,     0,     9,    10,
     0,     0,   231,    19,   234,   193,   190,   189,   191,   192,
   194,   196,   195,   197,   198,   342,   177,   199,   178,   180,
   181,   182,   179,   183,   184,   185,   186,   193,   190,   189,
   191,   192,   194,   196,   195,   197,   198,   388,   177,   199,
   178,   180,   181,   182,   179,   183,   184,   185,   193,   190,
   189,   191,   192,   194,   196,   195,   197,   198,     0,   177,
   199,   178,   180,   181,   182,   179,   183,   184,   176,     0,
     0,     0,     0,     0,     0,     0,     0,   163,   204,    18,
    53,     0,     0,     0,     0,     0,   413,   414,   134,     0,
     0,   135,   222,     0,     0,     0,    77,    77,     0,     0,
     0,     0,     0,     0,   219,   218,     0,   163,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    90,   267,     0,
     0,     0,   335,     0,     0,    96,     0,    97,   104,    92,
    91,     0,   101,     0,   420,   417,   416,   418,   419,   421,
   391,   392,     0,     0,   415,   319,     0,   320,   322,   323,
    36,   321,   324,   104,   155,    35,   158,     0,   158,     0,
     0,    16,    38,    39,     0,    21,     0,    17,     0,     0,
     0,    24,    26,     0,     0,    22,    23,    31,   103,     0,
    27,   303,    30,    28,    25,   305,     0,    29,   220,   225,
     0,     0,    20,     0,    51,    44,    32,    33,    34,     0,
     0,     0,     0,   223,   390,     0,     0,     0,     0,     0,
     0,    94,    93,    95,    98,    42,    40,    43,   252,    45,
     0,   395,     0,     0,   257,   100,     0,     0,    99,     0,
     0,    41,     0,     0,     0,     0,     0,   264,   265,    47,
    50,    48,     0,    36,     0,    49,     0,     0,    35,     0,
     0,     0,     0,     0,    19,    38,    39,     0,    21,     0,
     0,   161,     0,     0,    24,    26,     0,     0,    22,    23,
    31,     0,     0,    27,     0,    30,    28,    25,     0,     0,
    29,     0,     0,   432,     0,    20,     0,    51,    44,    32,
    33,    34,    90,     0,     0,     0,     0,     0,     0,     0,
    96,     0,    97,   203,    92,    91,     0,   101,    42,    40,
    43,     0,    45,     0,     0,     0,     0,     0,   142,     0,
     0,     0,     0,     0,    41,     0,     0,     0,   104,     0,
    36,     0,    47,    50,    48,    35,     0,     0,    49,     0,
     0,     0,    38,    39,   159,    21,     0,    19,     0,     0,
     0,    24,    26,   103,     0,    22,    23,    31,     0,     0,
    27,     0,    30,    28,    25,     0,     0,    29,     0,     0,
     0,     0,    20,     0,    51,    44,    32,    33,    34,   144,
   145,   146,   147,   148,     0,     0,    94,    93,    95,    98,
     0,     0,     0,     0,     0,    42,    40,    43,     0,    45,
   100,     0,     0,    99,     0,     0,     0,     0,     0,     0,
     0,    41,     0,     0,     0,     0,     0,    36,     0,    47,
    50,    48,    35,     0,     0,    49,     0,     0,     0,    38,
    39,     0,    21,     0,    19,     0,     0,     0,    24,    26,
     0,     0,    22,    23,    31,     0,     0,    27,     0,    30,
    28,    25,   110,     0,    29,     0,     0,     0,     0,    20,
     0,    51,    44,    32,    33,    34,    90,   167,   258,   259,
   260,   261,   262,   263,    96,     0,    97,     0,    92,    91,
     0,   101,    42,    40,    43,     0,    45,     0,     0,     0,
   121,     0,     0,   134,     0,     0,   135,   222,    41,     0,
     0,     0,   104,    90,     0,     0,    47,    50,    48,   219,
   218,    96,    49,    97,     0,    92,    91,     0,   101,     0,
     0,    19,    90,     0,     0,   134,     0,   103,   135,   222,
    96,     0,    97,   104,    92,    91,     0,   101,     0,   104,
     0,   219,   218,     0,     0,   215,   216,     0,     0,   119,
   134,     0,   115,   135,   371,     0,     0,     0,   104,     0,
    94,    93,    95,    98,   103,   104,   219,   218,     0,     0,
     0,     0,     0,   118,   100,   238,    90,    99,     0,     0,
     0,     0,     0,   103,    96,     0,    97,     0,    92,    91,
   104,   101,     0,   220,   225,     0,     0,    94,    93,    95,
    98,     0,     0,     0,     0,     0,     0,     0,   223,   213,
     0,   100,   104,     0,    99,     0,    94,    93,    95,    98,
     0,     0,     0,     0,     0,   220,   225,     0,   134,   162,
   100,   135,   222,    99,   168,   169,     0,   103,     0,   134,
   223,   213,   135,   371,   219,   218,     0,   202,     0,     0,
   220,   225,     0,     0,     0,   219,   218,     0,     0,     0,
     0,     0,   368,     0,     0,   223,     0,     0,   104,     0,
    94,    93,    95,    98,     0,     0,     0,     0,     0,   104,
     0,     0,     0,     0,   100,   332,   333,    99,     0,     0,
     0,     0,   337,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   266,   268,     0,     0,     0,     0,
     0,     0,     0,     0,   277,     0,     0,     0,   220,   225,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
   225,     0,     0,   223,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   223,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   397,   398,     0,   344,   345,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   359 };
int yypact[]={

   452, -1000,   452, -1000,    16,    64,    55,    51,    46,    37,
    30,    44,    29,   260, -1000,   -48,   970,   970, -1000,   -28,
    24,    23,  1122, -1000,    22,  -108,   -33,    21,   238,   153,
  1068,  1122,  1049, -1000, -1000, -1000, -1000,   -14, -1000, -1000,
    20,    19,    17,    13,    12,    10, -1000, -1000, -1000,  -223,
 -1000,   -52, -1000,   309,   194, -1000, -1000,  -104,     9,   226,
   226,   226,   226,   226,   226,     7,     6,     3,     2,     0,
    -2, -1000, -1000,  -115,    -4,   -12,   883,   251,   796,  1122,
   -24, -1000,   703, -1000,  1012,  1122,  -154,   -16,   221,   -78,
  1122, -1000, -1000, -1000, -1000, -1000,   -17,   838,   212,  1122,
  1122,   -20, -1000,   -13,  1043,  -292, -1000, -1000,   -21, -1000,
   302, -1000, -1000,  1122,   146,   703,  -236,   225,  1122,   303,
   -78,   302,  -184,  -131,   128, -1000,   189,   237,   234, -1000,
 -1000,    76, -1000, -1000,    -3,    84,  -115,  -115,   -22,   -35,
   -47, -1000, -1000,   -18, -1000, -1000, -1000, -1000, -1000,   226,
   226,   226,   226,   226,   226,   309,  -115,  -115, -1000, -1000,
 -1000, -1000,   303, -1000,  1122,   663, -1000, -1000,   301,   219,
 -1000,   -67,   -51,   -53,  1122,  -158, -1000,  1122,  1122,  1122,
  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
   300,   221,   213, -1000, -1000,   212,  -344,  -280, -1000, -1000,
  1122,   223,  1075, -1000,   310, -1000, -1000,  -366, -1000, -1000,
 -1000,   262,  1178,  1178, -1000,   220,  1122, -1000,  -105,   276,
 -1000, -1000,  -184,  -184,   161,   703,   -78,  1122,   302,  -184,
  -109,  -120,   155,  -129,  1122,  1122,   -52,   -52, -1000,   266,
 -1000, -1000,   309, -1000,  -134,  -151, -1000,   297, -1000, -1000,
 -1000, -1000, -1000, -1000,   309,   309,   303, -1000,   292, -1000,
 -1000, -1000,  -152,  -201, -1000, -1000,  -155,   303,  1122,  -267,
  -267, -1000,  -344,  -344,  -255,  -344,  -280,   496,   475,   453,
   324,  -330,  -330,  -330,  -330,  -330,  -330,  -330,  -330,  -330,
  -330,  -359, -1000, -1000, -1000, -1000,   252,   223, -1000,   -52,
  1100,   185,   184,   176,   137,   137,   137,   223,  1178,  1178,
  1178,  1178,  1178,  1178,  1178,   -34,  -159,  -351,   638,  -102,
 -1000, -1000,   302,   302,   703,   159,   -78,   302,  -184,  -184,
 -1000, -1000, -1000, -1000,   281,   280,   124,   306,  -147, -1000,
  -257, -1000, -1000, -1000, -1000, -1000, -1000,  -282, -1000,   303,
  -289, -1000,   282,   222,  -360,  -354, -1000, -1000,  1189, -1000,
 -1000,  1100,  -299,   -52,  1100,   -52, -1000, -1000, -1000,   223,
  -366,  -351,  -351, -1000,  -349,  -349,  -260, -1000, -1000,   279,
   214,  1178,  1178,  -366,  1122, -1000,   703,   302,   302, -1000,
 -1000,  1100,   -52,  1178, -1000, -1000, -1000,   -52,  1100,  1100,
 -1000,  -259,   582,   217,  1178,   114,  1178,  1178,  1178,  1178,
  1178,  1178,   298,   193,  -324,   282,  1178, -1000, -1000,   278,
   277,  -212, -1000,  -360, -1000,  -366,   222,  -354, -1000, -1000,
  1178,  -320,   216,  1178,  -366,  -366,  -366,  -366,  -366,  -366,
   -52, -1000, -1000,     8,  -366, -1000, -1000,  1122,   253,  1178,
  1178,  -339,   178,  1100,   -78, -1000,  -366,   231,  1178, -1000,
 -1000,  -360, -1000,  -366 };
int yypgo[]={

     0,   613,   612,   578,   890,  1128,   696,   672,   711,  1359,
   579,   889,   575,  1262,     1,   611,   789,   585,   582,    23,
   584,     4,     8,    31,     0,   569,   430,   583,   580,   462,
    62,   576,    54,     5,     3,    39,   574,   570,     2 };
int yyr1[]={

     0,     1,     1,     2,     2,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     7,     7,
     8,     8,     8,     8,     8,     8,     8,     8,     8,    10,
    10,    10,     5,     5,     4,     4,    12,    12,    12,    12,
    12,    13,    13,     9,     9,    15,    15,    15,    15,     6,
     6,     6,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    18,    20,    20,    22,
    17,    17,    16,    16,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    24,    24,    27,
    27,    25,    25,    28,    28,    29,    29,    29,    29,    29,
    19,    19,    30,    30,    31,    31,    31,    31,    31,    31,
    26,    26,    32,    32,    32,    32,    32,    32,    32,    32,
    32,    21,    21,    33,    33,    34,    34,    35,    36,    36,
    38,    38,    37,    37,    37,    37,    37,    37,    37,    37,
    37,    37,    23,    23,    23,    23,    23,    23,    23,    23,
    23,    23,    23,    23,    23,    23,    23,    23,    23,    23 };
int yyr2[]={

     0,     1,     3,     2,     4,     5,     9,     5,     7,     5,
     7,     5,     7,     5,     7,     5,     7,     5,     7,     7,
     9,     7,     9,     7,     9,     7,     9,     7,     9,     7,
     9,     5,     3,     5,     3,     7,     9,     9,     3,     5,
     7,     5,     7,     7,     9,     7,     9,     9,    11,     3,
     5,     5,     5,     7,     3,     7,     3,     7,     9,     9,
     5,     3,     7,     3,     7,     3,     3,     5,     3,     7,
     7,     3,     7,     9,     5,     9,    11,     9,    11,     7,
     5,     5,     3,     5,     3,    13,    17,     5,     5,     7,
     5,     5,     5,     3,     9,     7,     7,     7,     9,    11,
    13,     7,     5,     3,     3,     9,     9,     7,     3,     3,
     5,     7,     9,    11,    11,     3,     3,     9,     5,     9,
     5,    11,     5,    11,     5,     3,    13,     3,     7,     7,
     3,     3,     5,     7,     7,     3,     3,     3,     3,     3,
     5,     7,     5,     5,     7,     3,     5,     7,     5,     5,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     5,     3,     5,    11,     7,     9,     3,
     3,     3,     3,     3,     7,     3,     5,     9,     3,     5,
     3,     7,     3,     7,     3,     7,     5,     9,     5,     9,
     3,     5,     5,     5,     7,     7,    13,     7,     5,     5,
     5,     3,     7,     3,     7,     3,     5,     3,     3,     7,
     3,     7,    11,    11,    13,    13,     7,     7,     7,     7,
     7,     7,     3,     3,     3,     3,     7,     7,     5,     7,
     7,     7,     7,     7,     7,     3,     9,     9,    11,    11 };
int yychk[]={

 -1000,    -1,    -2,    -3,   339,   342,   343,   344,   345,   356,
   357,   353,   351,    -6,   295,   350,   268,   274,   -11,   361,
   299,   272,   282,   283,   278,   291,   279,   287,   290,   294,
   289,   284,   303,   304,   305,   262,   257,   -15,   269,   270,
   323,   338,   322,   324,   302,   326,   -18,   346,   348,   352,
   347,   301,    -3,    -4,   314,   -12,   361,   350,   349,   361,
   361,   361,   361,   361,   361,   342,   343,   344,   345,   356,
   357,   361,   262,   361,   306,   307,   -10,   -11,   -10,   362,
    -7,   -16,   259,    -8,   264,   266,   261,   361,   361,   -14,
   264,   277,   276,   359,   358,   360,   272,   274,   361,   375,
   372,   279,   -24,   325,   300,   361,   361,   282,   281,   282,
   -13,   361,   361,   264,   289,   294,   -14,   -14,   334,    -9,
   -14,   -13,   349,   350,   361,   361,   361,   361,   361,   361,
   348,   -19,   -29,   361,   260,   263,   258,   276,   361,   306,
   307,   361,    -5,   264,    -5,    -5,    -5,    -5,    -5,   361,
   361,   361,   361,   361,   361,    -4,   361,   361,   -11,   271,
   262,   275,    -9,    -8,   362,   264,    -6,   265,    -9,    -9,
   361,   376,   272,   379,   362,    -7,   -16,   373,   375,   379,
   376,   377,   378,   380,   381,   382,   383,   384,   385,   364,
   363,   365,   366,   362,   367,   369,   368,   370,   371,   374,
   -14,   361,    -9,   275,   -16,    -7,   -14,   -14,   361,   361,
   264,   -25,   -27,   376,   -28,   312,   313,   -23,   277,   276,
   360,   -19,   264,   375,   -24,   361,   362,   361,   258,   -14,
   294,    -6,   287,   288,    -6,   285,   -14,   258,   -13,   361,
   306,   307,   308,   278,   264,   264,   356,   261,   361,   321,
   321,   -12,    -4,   361,   361,   361,   265,    -4,    -5,    -5,
    -5,    -5,    -5,    -5,    -4,    -4,    -9,   265,    -9,   265,
   267,   361,   272,   379,   361,   361,   272,    -9,   362,   -14,
   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
   -14,   -14,   265,   -16,   275,   -16,   -14,   -26,   -32,   308,
   309,   311,   335,   310,   329,   330,   331,   -25,   258,   373,
   375,   379,   376,   377,   380,   261,   -23,   -23,   264,   -14,
   361,   265,   -13,   -13,   286,    -6,   -14,   -13,   361,   361,
   -17,   -24,   -18,   361,    -9,    -9,   -20,   -22,   -19,   -29,
   259,   361,   361,   265,   265,   361,   361,   272,   361,    -9,
   265,   -32,   -30,   -19,   -21,   -33,   -34,   -35,   372,   -36,
   -37,   264,   -23,   281,   281,   281,   -24,   -24,   -24,   -26,
   -23,   -23,   -23,   -23,   -23,   -23,   -23,   376,   265,   -38,
   376,   312,   313,   -23,   280,    -6,   286,   -13,   -13,   265,
   265,   309,   258,   362,   361,   361,   361,   258,   382,   381,
   -35,   -21,   -23,   314,   315,   372,   364,   363,   365,   366,
   362,   367,   -31,   -19,   -21,   -30,   258,   265,   265,   -38,
   -38,   -14,    -6,   -21,   -22,   -23,   -19,   -33,   -34,   265,
   264,   -23,   314,   315,   -23,   -23,   -23,   -23,   -23,   -23,
   258,   327,   328,   336,   -23,   265,   265,   281,   -38,   381,
   264,   -23,   -19,   337,   -14,   265,   -23,   -38,   381,   327,
   328,   -21,   265,   -23 };
int yydef[]={

     1,    -2,     2,     3,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    32,    34,     0,     0,     0,    71,    82,
     0,     0,     0,    84,     0,     0,     0,     0,    93,     0,
     0,     0,     0,   103,   104,   108,   109,     0,   115,   116,
     0,     0,     0,     0,     0,     0,   125,    65,    66,     0,
    68,     0,     4,     5,     0,    54,    56,     0,     0,     7,
     9,    11,    13,    15,    17,     0,     0,     0,     0,     0,
     0,    31,    33,     0,     0,     0,     0,    49,     0,     0,
    74,    80,     0,    38,     0,     0,     0,     0,    81,    83,
     0,   135,   136,   137,   138,   139,     0,     0,   145,     0,
     0,     0,   174,     0,     0,     0,    87,    88,     0,    90,
    91,    61,    92,     0,     0,     0,     0,     0,     0,   102,
    63,   110,     0,     0,     0,   118,     0,   120,   122,   124,
    67,     0,   190,   185,     0,   188,     0,     0,     0,     0,
     0,    60,     8,     0,    10,    12,    14,    16,    18,    19,
    21,    23,    25,    27,    29,    35,     0,     0,    51,    69,
    50,    70,    72,    39,     0,     0,   107,   132,     0,     0,
    41,     0,     0,     0,     0,     0,    79,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   140,     0,   142,   143,   146,   148,   149,   173,   175,
     0,     0,     0,   181,   182,   179,   180,   183,   232,   233,
   234,   235,     0,     0,   245,   185,     0,    89,     0,     0,
    95,    96,     0,     0,    97,     0,   101,     0,   111,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   186,     0,
   189,    55,     6,    57,     0,     0,    52,     0,    20,    22,
    24,    26,    28,    30,    36,    37,    73,    75,     0,   133,
    40,    42,     0,     0,    43,    45,     0,    77,     0,   150,
   151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
   161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
   171,   172,   134,   144,   141,   147,     0,   177,   200,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
    62,    94,   105,   106,     0,    98,    64,   112,     0,     0,
   117,   130,   131,   119,     0,     0,     0,   127,     0,   191,
     0,    58,    59,    53,    76,    44,    47,     0,    46,    78,
     0,   201,   202,   192,   203,   211,   213,   215,     0,   217,
   218,     0,     0,     0,     0,     0,   208,   209,   210,   178,
   184,   239,   240,   241,   242,   243,   244,   236,   237,     0,
     0,     0,     0,   220,     0,    99,     0,   113,   114,   121,
   123,     0,     0,     0,   187,    48,   176,     0,     0,     0,
   216,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   204,   194,   205,   207,     0,   246,   247,     0,
     0,    85,   100,   126,   128,   129,   193,   212,   214,   219,
     0,     0,     0,     0,   226,   227,   228,   229,   230,   231,
     0,   196,   198,     0,   221,   248,   249,     0,     0,     0,
     0,     0,   195,     0,    86,   222,   223,     0,     0,   197,
   199,   206,   224,   225 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"TK_NOTHING",	257,
	"TK_COMMA",	258,
	"TK_COLON",	259,
	"TK_DOLLAR",	260,
	"TK_DOT",	261,
	"TK_SEMICO",	262,
	"TK_HOOK",	263,
	"TK_OPEN",	264,
	"TK_CLOSE",	265,
	"TK_OBRAK",	266,
	"TK_CBRAK",	267,
	"TK_BEGIN",	268,
	"TK_ENDCMD",	269,
	"TK_ENDFUNC",	270,
	"TK_ENDBLOCK",	271,
	"TK_ENTRY",	272,
	"TK_PERCENT",	273,
	"TK_BEGINSET",	274,
	"TK_ENDSET",	275,
	"TK_STRVAL",	276,
	"TK_NUMVAL",	277,
	"TK_FOR",	278,
	"TK_NEXT",	279,
	"TK_TO",	280,
	"TK_BY",	281,
	"TK_WHILE",	282,
	"TK_WEND",	283,
	"TK_IF",	284,
	"TK_THEN",	285,
	"TK_ELSE",	286,
	"TK_GOTO",	287,
	"TK_CALL",	288,
	"TK_ON",	289,
	"TK_RETURN",	290,
	"TK_BREAK",	291,
	"TK_CONTINUE",	292,
	"TK_DONE",	293,
	"TK_ERROR",	294,
	"TK_NODEBUG",	295,
	"TK_DEFINE",	296,
	"TK_INCLUDE",	297,
	"TK_SEARCH",	298,
	"TK_LET",	299,
	"TK_SELECT",	300,
	"TK_UPDATE",	301,
	"TK_EXECUTE",	302,
	"TK_CASE",	303,
	"TK_DEFAULT",	304,
	"TK_ENDCASE",	305,
	"TK_ARRAYOF",	306,
	"TK_ARRAYOF2",	307,
	"TK_FROM",	308,
	"TK_WHERE",	309,
	"TK_GROUP",	310,
	"TK_ORDER",	311,
	"TK_DISTINCT",	312,
	"TK_ALL",	313,
	"TK_IN",	314,
	"TK_BETWEEN",	315,
	"TK_CREATE",	316,
	"TK_TABLE",	317,
	"TK_VALUES",	318,
	"TK_INSERT",	319,
	"TK_DROP",	320,
	"TK_SQL",	321,
	"TK_DECLARE",	322,
	"TK_PREPARE",	323,
	"TK_OPENWORD",	324,
	"TK_FETCH",	325,
	"TK_CLOSEWORD",	326,
	"TK_ASC",	327,
	"TK_DESC",	328,
	"TK_UNION",	329,
	"TK_INTERSECT",	330,
	"TK_MINUS",	331,
	"TK_AT",	332,
	"TK_CURRENT",	333,
	"TK_OF",	334,
	"TK_CONNECT",	335,
	"TK_START",	336,
	"TK_WITH",	337,
	"TK_UNPREPARE",	338,
	"TK_EXTERN",	339,
	"TK_CONSTANT",	340,
	"TK_STATIC",	341,
	"TK_PROC",	342,
	"TK_UIPROC",	343,
	"TK_NRPROC",	344,
	"TK_FUNC",	345,
	"TK_VAR",	346,
	"TK_SYSVAR",	347,
	"TK_OBJVAR",	348,
	"TK_OBJECT",	349,
	"TK_FORMAT",	350,
	"TK_COMPILE",	351,
	"TK_PUBLIC",	352,
	"TK_PRIVATE",	353,
	"TK_OLDSET",	354,
	"TK_OLDGET",	355,
	"TK_SET",	356,
	"TK_GET",	357,
	"TK_TRUE",	358,
	"TK_FALSE",	359,
	"TK_NULL",	360,
	"TK_ID",	361,
	"TK_EQUALS",	362,
	"TK_GRTR",	363,
	"TK_LESS",	364,
	"TK_LEQ",	365,
	"TK_GEQ",	366,
	"TK_NEQ",	367,
	"TK_SGRTR",	368,
	"TK_SLESS",	369,
	"TK_SLEQ",	370,
	"TK_SGEQ",	371,
	"TK_NOT",	372,
	"TK_ADD",	373,
	"TK_SADD",	374,
	"TK_SUB",	375,
	"TK_MULT",	376,
	"TK_DIV",	377,
	"TK_IDIV",	378,
	"TK_EXP",	379,
	"TK_REM",	380,
	"TK_AND",	381,
	"TK_OR",	382,
	"TK_XOR",	383,
	"TK_EQV",	384,
	"TK_IMP",	385,
	"TK_ADDTO",	386,
	"TK_SUBTO",	387,
	"TK_LEXERROR",	388,
	"UNOP",	389,
	"PRIMOP",	390,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"source_file : /* empty */",
	"source_file : outer_list",
	"outer_list : outer_stmt",
	"outer_list : outer_list outer_stmt",
	"outer_stmt : TK_EXTERN fids",
	"outer_stmt : TK_EXTERN TK_IN TK_STRVAL fids",
	"outer_stmt : TK_PROC TK_ID",
	"outer_stmt : TK_PROC TK_ID fargs",
	"outer_stmt : TK_UIPROC TK_ID",
	"outer_stmt : TK_UIPROC TK_ID fargs",
	"outer_stmt : TK_NRPROC TK_ID",
	"outer_stmt : TK_NRPROC TK_ID fargs",
	"outer_stmt : TK_FUNC TK_ID",
	"outer_stmt : TK_FUNC TK_ID fargs",
	"outer_stmt : TK_SET TK_ID",
	"outer_stmt : TK_SET TK_ID fargs",
	"outer_stmt : TK_GET TK_ID",
	"outer_stmt : TK_GET TK_ID fargs",
	"outer_stmt : TK_PRIVATE TK_PROC TK_ID",
	"outer_stmt : TK_PRIVATE TK_PROC TK_ID fargs",
	"outer_stmt : TK_PRIVATE TK_UIPROC TK_ID",
	"outer_stmt : TK_PRIVATE TK_UIPROC TK_ID fargs",
	"outer_stmt : TK_PRIVATE TK_NRPROC TK_ID",
	"outer_stmt : TK_PRIVATE TK_NRPROC TK_ID fargs",
	"outer_stmt : TK_PRIVATE TK_FUNC TK_ID",
	"outer_stmt : TK_PRIVATE TK_FUNC TK_ID fargs",
	"outer_stmt : TK_PRIVATE TK_SET TK_ID",
	"outer_stmt : TK_PRIVATE TK_SET TK_ID fargs",
	"outer_stmt : TK_PRIVATE TK_GET TK_ID",
	"outer_stmt : TK_PRIVATE TK_GET TK_ID fargs",
	"outer_stmt : TK_COMPILE TK_ID",
	"outer_stmt : statement",
	"outer_stmt : statement TK_SEMICO",
	"outer_stmt : TK_NODEBUG",
	"outer_stmt : TK_FORMAT TK_ID fids",
	"outer_stmt : TK_FORMAT TK_ARRAYOF TK_ID fids",
	"outer_stmt : TK_FORMAT TK_ARRAYOF2 TK_ID fids",
	"array_ref : aref",
	"array_ref : array_ref aref",
	"aref : TK_OBRAK exprs TK_CBRAK",
	"aref : TK_DOT TK_ID",
	"aref : TK_DOT TK_MULT TK_ID",
	"aref : TK_DOT TK_ENTRY TK_ID",
	"aref : TK_DOT TK_MULT TK_ENTRY TK_ID",
	"aref : TK_DOT TK_EXP TK_ID",
	"aref : TK_DOT TK_EXP TK_ENTRY TK_ID",
	"aref : TK_DOT TK_MULT TK_EXP TK_ID",
	"aref : TK_DOT TK_MULT TK_EXP TK_ENTRY TK_ID",
	"stmt_list : simple_stmt",
	"stmt_list : simple_stmt TK_SEMICO",
	"stmt_list : stmt_list simple_stmt",
	"fargs : TK_OPEN TK_CLOSE",
	"fargs : TK_OPEN fids TK_CLOSE",
	"fids : fid",
	"fids : fids TK_COMMA fid",
	"fid : TK_ID",
	"fid : TK_FORMAT TK_ID TK_ID",
	"fid : TK_FORMAT TK_ARRAYOF TK_ID TK_ID",
	"fid : TK_FORMAT TK_ARRAYOF2 TK_ID TK_ID",
	"fid : TK_OBJECT TK_ID",
	"ids : TK_ID",
	"ids : ids TK_COMMA TK_ID",
	"exprs : expr",
	"exprs : exprs TK_COMMA expr",
	"var : TK_VAR",
	"var : TK_OBJVAR",
	"var : TK_PUBLIC TK_OBJVAR",
	"var : TK_SYSVAR",
	"statement : TK_BEGIN stmt_list TK_ENDBLOCK",
	"statement : TK_BEGINSET stmt_list TK_ENDSET",
	"statement : simple_stmt",
	"simple_stmt : TK_ID TK_EQUALS exprs",
	"simple_stmt : TK_ID array_ref TK_EQUALS exprs",
	"simple_stmt : TK_ID array_ref",
	"simple_stmt : TK_ID array_ref TK_OPEN TK_CLOSE",
	"simple_stmt : TK_ID array_ref TK_OPEN exprs TK_CLOSE",
	"simple_stmt : TK_LET TK_ID TK_EQUALS exprs",
	"simple_stmt : TK_LET TK_ID array_ref TK_EQUALS exprs",
	"simple_stmt : TK_ENTRY TK_ID parameters",
	"simple_stmt : TK_ID parameters",
	"simple_stmt : TK_ENTRY TK_ID",
	"simple_stmt : TK_ID",
	"simple_stmt : TK_WHILE expr",
	"simple_stmt : TK_WEND",
	"simple_stmt : TK_FOR TK_ID TK_EQUALS expr TK_TO expr",
	"simple_stmt : TK_FOR TK_ID TK_EQUALS expr TK_TO expr TK_BY expr",
	"simple_stmt : TK_BREAK TK_ID",
	"simple_stmt : TK_BREAK TK_WHILE",
	"simple_stmt : TK_NEXT TK_BY TK_ID",
	"simple_stmt : TK_NEXT TK_WHILE",
	"simple_stmt : TK_NEXT ids",
	"simple_stmt : TK_GOTO TK_ID",
	"simple_stmt : TK_RETURN",
	"simple_stmt : TK_RETURN TK_OPEN expr TK_CLOSE",
	"simple_stmt : TK_ERROR TK_ON TK_ERROR",
	"simple_stmt : TK_ON TK_ERROR statement",
	"simple_stmt : TK_IF expr statement",
	"simple_stmt : TK_IF expr TK_THEN statement",
	"simple_stmt : TK_IF expr statement TK_ELSE statement",
	"simple_stmt : TK_IF expr TK_THEN statement TK_ELSE statement",
	"simple_stmt : TK_CASE TK_OF expr",
	"simple_stmt : TK_CASE exprs",
	"simple_stmt : TK_DEFAULT",
	"simple_stmt : TK_ENDCASE",
	"simple_stmt : TK_ON expr TK_GOTO ids",
	"simple_stmt : TK_ON expr TK_CALL ids",
	"simple_stmt : TK_ID TK_COLON statement",
	"simple_stmt : TK_SEMICO",
	"simple_stmt : TK_NOTHING",
	"simple_stmt : var ids",
	"simple_stmt : var TK_OBJECT ids",
	"simple_stmt : var TK_FORMAT TK_ID ids",
	"simple_stmt : var TK_FORMAT TK_ARRAYOF TK_ID ids",
	"simple_stmt : var TK_FORMAT TK_ARRAYOF2 TK_ID ids",
	"simple_stmt : TK_ENDCMD",
	"simple_stmt : TK_ENDFUNC",
	"simple_stmt : TK_PREPARE TK_ID TK_FROM sql_statement",
	"simple_stmt : TK_UNPREPARE TK_ID",
	"simple_stmt : TK_DECLARE TK_ID TK_FOR TK_ID",
	"simple_stmt : TK_OPENWORD TK_ID",
	"simple_stmt : TK_OPENWORD TK_ID TK_OPEN exprs TK_CLOSE",
	"simple_stmt : TK_EXECUTE TK_ID",
	"simple_stmt : TK_EXECUTE TK_ID TK_OPEN exprs TK_CLOSE",
	"simple_stmt : TK_CLOSEWORD TK_ID",
	"simple_stmt : update_statement",
	"update_statement : TK_UPDATE itemname TK_SET colsets TK_WHERE search_condition",
	"colsets : colsetter",
	"colsets : colsetter TK_COMMA colsetter",
	"colsetter : itemname TK_EQUALS sql_expr",
	"sql_statement : select_expression",
	"sql_statement : update_statement",
	"parameters : TK_OPEN TK_CLOSE",
	"parameters : TK_OPEN exprs TK_CLOSE",
	"expr : TK_OPEN expr TK_CLOSE",
	"expr : TK_NUMVAL",
	"expr : TK_STRVAL",
	"expr : TK_FALSE",
	"expr : TK_TRUE",
	"expr : TK_NULL",
	"expr : TK_ENTRY TK_ID",
	"expr : TK_BEGINSET exprs TK_ENDSET",
	"expr : TK_BEGINSET TK_ENDSET",
	"expr : TK_ID parameters",
	"expr : TK_ENTRY TK_ID parameters",
	"expr : TK_ID",
	"expr : TK_ID array_ref",
	"expr : TK_ID array_ref parameters",
	"expr : TK_SUB expr",
	"expr : TK_NOT expr",
	"expr : expr TK_ADD expr",
	"expr : expr TK_SUB expr",
	"expr : expr TK_EXP expr",
	"expr : expr TK_MULT expr",
	"expr : expr TK_DIV expr",
	"expr : expr TK_IDIV expr",
	"expr : expr TK_REM expr",
	"expr : expr TK_AND expr",
	"expr : expr TK_OR expr",
	"expr : expr TK_XOR expr",
	"expr : expr TK_EQV expr",
	"expr : expr TK_IMP expr",
	"expr : expr TK_LESS expr",
	"expr : expr TK_GRTR expr",
	"expr : expr TK_LEQ expr",
	"expr : expr TK_GEQ expr",
	"expr : expr TK_EQUALS expr",
	"expr : expr TK_NEQ expr",
	"expr : expr TK_SLESS expr",
	"expr : expr TK_SGRTR expr",
	"expr : expr TK_SLEQ expr",
	"expr : expr TK_SGEQ expr",
	"expr : expr TK_SADD expr",
	"expr : TK_NEXT TK_ID",
	"expr : select_expression",
	"expr : TK_FETCH TK_ID",
	"expr : TK_FETCH TK_OPEN expr TK_CLOSE TK_ID",
	"select_expression : TK_SELECT select_list table_expressions",
	"select_expression : TK_SELECT set_qualifier select_list table_expressions",
	"set_qualifier : TK_DISTINCT",
	"set_qualifier : TK_ALL",
	"select_list : TK_MULT",
	"select_list : column_list",
	"column_list : sql_expr",
	"column_list : column_list TK_COMMA sql_expr",
	"bindable : TK_ID",
	"bindable : TK_DOLLAR TK_ID",
	"bindable : TK_DOLLAR TK_SQL TK_COLON TK_ID",
	"bindable : TK_HOOK",
	"bindable : TK_HOOK TK_SQL",
	"itemname : bindable",
	"itemname : itemname TK_DOT bindable",
	"table_names : itemname",
	"table_names : table_names TK_COMMA itemname",
	"order_names : itemname",
	"order_names : order_names TK_COMMA itemname",
	"order_names : itemname TK_ASC",
	"order_names : order_names TK_COMMA itemname TK_ASC",
	"order_names : itemname TK_DESC",
	"order_names : order_names TK_COMMA itemname TK_DESC",
	"table_expressions : table_expression",
	"table_expressions : table_expressions table_expression",
	"table_expression : TK_FROM table_names",
	"table_expression : TK_WHERE search_condition",
	"table_expression : TK_ORDER TK_BY order_names",
	"table_expression : TK_CONNECT TK_BY search_condition",
	"table_expression : TK_CONNECT TK_BY search_condition TK_START TK_WITH search_condition",
	"table_expression : TK_GROUP TK_BY table_names",
	"table_expression : TK_UNION select_expression",
	"table_expression : TK_INTERSECT select_expression",
	"table_expression : TK_MINUS select_expression",
	"search_condition : boolean_term",
	"search_condition : search_condition TK_OR boolean_term",
	"boolean_term : boolean_factor",
	"boolean_term : boolean_term TK_AND boolean_factor",
	"boolean_factor : boolean_test",
	"boolean_factor : TK_NOT boolean_test",
	"boolean_test : boolean_primary",
	"boolean_primary : predicate",
	"boolean_primary : TK_OPEN search_condition TK_CLOSE",
	"sql_exprs : sql_expr",
	"sql_exprs : sql_exprs TK_COMMA sql_expr",
	"predicate : sql_expr TK_IN TK_OPEN sql_exprs TK_CLOSE",
	"predicate : sql_expr TK_BETWEEN sql_expr TK_AND sql_expr",
	"predicate : sql_expr TK_NOT TK_IN TK_OPEN sql_exprs TK_CLOSE",
	"predicate : sql_expr TK_NOT TK_BETWEEN sql_expr TK_AND sql_expr",
	"predicate : sql_expr TK_LESS sql_expr",
	"predicate : sql_expr TK_GRTR sql_expr",
	"predicate : sql_expr TK_LEQ sql_expr",
	"predicate : sql_expr TK_GEQ sql_expr",
	"predicate : sql_expr TK_EQUALS sql_expr",
	"predicate : sql_expr TK_NEQ sql_expr",
	"sql_expr : TK_NUMVAL",
	"sql_expr : TK_STRVAL",
	"sql_expr : TK_NULL",
	"sql_expr : itemname",
	"sql_expr : itemname TK_DOT TK_MULT",
	"sql_expr : TK_OPEN sql_expr TK_CLOSE",
	"sql_expr : TK_SUB sql_expr",
	"sql_expr : sql_expr TK_ADD sql_expr",
	"sql_expr : sql_expr TK_SUB sql_expr",
	"sql_expr : sql_expr TK_EXP sql_expr",
	"sql_expr : sql_expr TK_MULT sql_expr",
	"sql_expr : sql_expr TK_DIV sql_expr",
	"sql_expr : sql_expr TK_REM sql_expr",
	"sql_expr : select_expression",
	"sql_expr : TK_ID TK_OPEN sql_exprs TK_CLOSE",
	"sql_expr : TK_ID TK_OPEN TK_MULT TK_CLOSE",
	"sql_expr : TK_ID TK_OPEN TK_DISTINCT sql_exprs TK_CLOSE",
	"sql_expr : TK_ID TK_OPEN TK_ALL sql_exprs TK_CLOSE",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 257 "elsyntax.y"
{FinishSrcFile();} break;
case 2:
# line 259 "elsyntax.y"
{FinishSrcFile();} break;
case 5:
# line 269 "elsyntax.y"
{EmitStatement(CrtNode2(yypvt[-1],ND_EXTERN,yypvt[-0],0));} break;
case 6:
# line 271 "elsyntax.y"
{EmitStatement(CrtNode2(yypvt[-3],ND_EXTERN,yypvt[-0],yypvt[-1]));} break;
case 7:
# line 273 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-1],ND_FUNC,TK_PROC,yypvt[-0],0,0));} break;
case 8:
# line 275 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_PROC,yypvt[-1],yypvt[-0],0));} break;
case 9:
# line 277 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-1],ND_FUNC,TK_UIPROC,yypvt[-0],0,0));} break;
case 10:
# line 279 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_UIPROC,yypvt[-1],yypvt[-0],0));} break;
case 11:
# line 281 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-1],ND_FUNC,TK_NRPROC,yypvt[-0],0,0));} break;
case 12:
# line 283 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_NRPROC,yypvt[-1],yypvt[-0],0));} break;
case 13:
# line 285 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-1],ND_FUNC,TK_FUNC,yypvt[-0],0,0));} break;
case 14:
# line 287 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_FUNC,yypvt[-1],yypvt[-0],0));} break;
case 15:
# line 289 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-1],ND_FUNC,TK_SET,yypvt[-0],0,0));} break;
case 16:
# line 291 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_SET,yypvt[-1],yypvt[-0],0));} break;
case 17:
# line 293 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-1],ND_FUNC,TK_GET,yypvt[-0],0,0));} break;
case 18:
# line 295 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_GET,yypvt[-1],yypvt[-0],0));} break;
case 19:
# line 297 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_PROC,yypvt[-0],0,TK_PRIVATE));} break;
case 20:
# line 299 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-3],ND_FUNC,TK_PROC,yypvt[-1],yypvt[-0],TK_PRIVATE));} break;
case 21:
# line 301 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_UIPROC,yypvt[-0],0,TK_PRIVATE));} break;
case 22:
# line 303 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-3],ND_FUNC,TK_UIPROC,yypvt[-1],yypvt[-0],TK_PRIVATE));} break;
case 23:
# line 305 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_NRPROC,yypvt[-0],0,TK_PRIVATE));} break;
case 24:
# line 307 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-3],ND_FUNC,TK_NRPROC,yypvt[-1],yypvt[-0],TK_PRIVATE));} break;
case 25:
# line 309 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_FUNC,yypvt[-0],0,TK_PRIVATE));} break;
case 26:
# line 311 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-3],ND_FUNC,TK_FUNC,yypvt[-1],yypvt[-0],TK_PRIVATE));} break;
case 27:
# line 313 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_SET,yypvt[-0],0,TK_PRIVATE));} break;
case 28:
# line 315 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-3],ND_FUNC,TK_SET,yypvt[-1],yypvt[-0],TK_PRIVATE));} break;
case 29:
# line 317 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-2],ND_FUNC,TK_GET,yypvt[-0],0,TK_PRIVATE));} break;
case 30:
# line 319 "elsyntax.y"
{EmitStatement(CrtNode4(yypvt[-3],ND_FUNC,TK_GET,yypvt[-1],yypvt[-0],TK_PRIVATE));} break;
case 31:
# line 321 "elsyntax.y"
{EmitStatement(CrtNode1(yypvt[-1],ND_COMPILE,yypvt[-0]));} break;
case 32:
# line 323 "elsyntax.y"
{EmitStatement((ndata)yypvt[-0]);} break;
case 33:
# line 325 "elsyntax.y"
{EmitStatement((ndata)yypvt[-1]);} break;
case 34:
# line 327 "elsyntax.y"
{AllowSourceInfo = FALSE;} break;
case 35:
# line 329 "elsyntax.y"
{EmitStatement(CrtNode3(yypvt[-2],ND_FORMAT,yypvt[-1],yypvt[-0],FALSE));} break;
case 36:
# line 331 "elsyntax.y"
{EmitStatement(CrtNode3(yypvt[-3],ND_FORMAT,yypvt[-1],yypvt[-0],TRUE));} break;
case 37:
# line 333 "elsyntax.y"
{EmitStatement(CrtNode3(yypvt[-3],ND_FORMAT,yypvt[-1],yypvt[-0],2));} break;
case 38:
# line 337 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_REFLIST,0,yypvt[-0]);} break;
case 39:
# line 339 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_REFLIST,yypvt[-1],yypvt[-0]);} break;
case 40:
# line 343 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 41:
# line 345 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 42:
# line 347 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_ENTRYFUNC,yypvt[-0],0,TK_MULT);} break;
case 43:
# line 349 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_ENTRYFUNC,yypvt[-0],0,TK_ENTRY);} break;
case 44:
# line 351 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_ENTRYFUNC,yypvt[-0],0,TK_ENTRY+TK_MULT);} break;
case 45:
# line 353 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_ENTRYFUNC,yypvt[-0],0,TK_EXP);} break;
case 46:
# line 355 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_ENTRYFUNC,yypvt[-0],0,TK_ENTRY+TK_EXP);} break;
case 47:
# line 357 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_ENTRYFUNC,yypvt[-0],0,TK_MULT+TK_EXP);} break;
case 48:
# line 359 "elsyntax.y"
{yyval = CrtNode3(yypvt[-4],ND_ENTRYFUNC,yypvt[-0],0,TK_ENTRY+TK_MULT+TK_EXP);} break;
case 49:
# line 363 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_STMTLIST,0,yypvt[-0]);} break;
case 50:
# line 365 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_STMTLIST,0,yypvt[-1]);} break;
case 51:
# line 367 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_STMTLIST,yypvt[-1],yypvt[-0]);} break;
case 52:
# line 371 "elsyntax.y"
{yyval = 0;} break;
case 53:
# line 373 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 54:
# line 377 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_IDLIST,0,yypvt[-0]);} break;
case 55:
# line 379 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_IDLIST,yypvt[-2],yypvt[-0]);} break;
case 56:
# line 383 "elsyntax.y"
{yyval = CrtNode4(yypvt[-0],ND_FID,0,yypvt[-0],FALSE,FALSE);} break;
case 57:
# line 385 "elsyntax.y"
{yyval = CrtNode4(yypvt[-2],ND_FID,yypvt[-1],yypvt[-0],FALSE,FALSE);} break;
case 58:
# line 387 "elsyntax.y"
{yyval = CrtNode4(yypvt[-3],ND_FID,yypvt[-1],yypvt[-0],1,FALSE);} break;
case 59:
# line 389 "elsyntax.y"
{yyval = CrtNode4(yypvt[-3],ND_FID,yypvt[-1],yypvt[-0],2,FALSE);} break;
case 60:
# line 391 "elsyntax.y"
{yyval = CrtNode4(yypvt[-1],ND_FID,0,yypvt[-0],FALSE,TRUE);} break;
case 61:
# line 395 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_IDLIST,0,yypvt[-0]);} break;
case 62:
# line 397 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_IDLIST,yypvt[-2],yypvt[-0]);} break;
case 63:
# line 401 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_NUMLIST,0,yypvt[-0]);} break;
case 64:
# line 403 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_NUMLIST,yypvt[-2],yypvt[-0]);} break;
case 65:
# line 407 "elsyntax.y"
{yyval = TK_VAR;} break;
case 66:
# line 409 "elsyntax.y"
{yyval = TK_OBJVAR;} break;
case 67:
# line 411 "elsyntax.y"
{yyval = TK_PUBLIC;} break;
case 68:
# line 413 "elsyntax.y"
{yyval = TK_SYSVAR;} break;
case 69:
# line 420 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 70:
# line 422 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 71:
# line 424 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 72:
# line 428 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_ASSIGN,yypvt[-2],0,yypvt[-0]);} break;
case 73:
# line 430 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_ASSIGN,yypvt[-3],yypvt[-2],yypvt[-0]);} break;
case 74:
# line 432 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_FUNCEXPR,yypvt[-1],0,yypvt[-0]);} break;
case 75:
# line 434 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_FUNCEXPR,yypvt[-3],0,yypvt[-2]);} break;
case 76:
# line 436 "elsyntax.y"
{yyval = CrtNode3(yypvt[-4],ND_ASSIGN,yypvt[-4],yypvt[-3],yypvt[-1]);} break;
case 77:
# line 438 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_ASSIGN,yypvt[-2],0,yypvt[-0]);} break;
case 78:
# line 440 "elsyntax.y"
{yyval = CrtNode3(yypvt[-4],ND_ASSIGN,yypvt[-3],yypvt[-2],yypvt[-0]);} break;
case 79:
# line 448 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_ENTRYFUNC,yypvt[-1],yypvt[-0]);} break;
case 80:
# line 450 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_FUNCEXPR,yypvt[-1],yypvt[-0],0);} break;
case 81:
# line 452 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_ENTRYFUNC,yypvt[-0],0);} break;
case 82:
# line 454 "elsyntax.y"
{yyval = CrtNode3(yypvt[-0],ND_FUNCEXPR,yypvt[-0],0,0);} break;
case 83:
# line 456 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_WHILE,yypvt[-0]);} break;
case 84:
# line 458 "elsyntax.y"
{yyval = CrtNode0(yypvt[-0],ND_WEND);} break;
case 85:
# line 460 "elsyntax.y"
{yyval = CrtNode4(yypvt[-5],ND_FOR,yypvt[-4],yypvt[-2],yypvt[-0],0);} break;
case 86:
# line 462 "elsyntax.y"
{yyval = CrtNode4(yypvt[-7],ND_FOR,yypvt[-6],yypvt[-4],yypvt[-2],yypvt[-0]);} break;
case 87:
# line 464 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_BREAKFOR,yypvt[-0]);} break;
case 88:
# line 466 "elsyntax.y"
{yyval = CrtNode0(yypvt[-1],ND_BREAKWHILE);} break;
case 89:
# line 468 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_CONTINFOR,yypvt[-0]);} break;
case 90:
# line 470 "elsyntax.y"
{yyval = CrtNode0(yypvt[-1],ND_CONTINWHILE);} break;
case 91:
# line 472 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_NEXT,yypvt[-0]);} break;
case 92:
# line 474 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_GOTO,yypvt[-0]);} break;
case 93:
# line 476 "elsyntax.y"
{yyval = CrtNode1(yypvt[-0],ND_RETURN,0);} break;
case 94:
# line 478 "elsyntax.y"
{yyval = CrtNode1(yypvt[-3],ND_RETURN,yypvt[-1]);} break;
case 95:
# line 480 "elsyntax.y"
{yyval = CrtNode0(yypvt[-2],ND_ERRERR); } break;
case 96:
# line 482 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_ONERROR,yypvt[-0]);} break;
case 97:
# line 484 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_IF,yypvt[-1],yypvt[-0],0);} break;
case 98:
# line 486 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_IF,yypvt[-2],yypvt[-0],0);} break;
case 99:
# line 488 "elsyntax.y"
{yyval = CrtNode3(yypvt[-4],ND_IF,yypvt[-3],yypvt[-2],yypvt[-0]);} break;
case 100:
# line 490 "elsyntax.y"
{yyval = CrtNode3(yypvt[-5],ND_IF,yypvt[-4],yypvt[-2],yypvt[-0]);} break;
case 101:
# line 492 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_SWITCH,yypvt[-0]);} break;
case 102:
# line 494 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_CASE,yypvt[-0]);} break;
case 103:
# line 496 "elsyntax.y"
{yyval = CrtNode0(yypvt[-0],ND_DEFAULT);} break;
case 104:
# line 498 "elsyntax.y"
{yyval = CrtNode0(yypvt[-0],ND_ENDSWITCH);} break;
case 105:
# line 500 "elsyntax.y"
{yyval = CrtNode2(yypvt[-3],ND_ONGOTO,yypvt[-2],yypvt[-0]);} break;
case 106:
# line 502 "elsyntax.y"
{yyval = CrtNode2(yypvt[-3],ND_ONCALL,yypvt[-2],yypvt[-0]);} break;
case 107:
# line 504 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_LABELED,yypvt[-2],yypvt[-0]);} break;
case 108:
# line 506 "elsyntax.y"
{yyval = CrtNode1(yypvt[-0],ND_NULLST,TRUE);} break;
case 109:
# line 508 "elsyntax.y"
{yyval = CrtNode1(yypvt[-0],ND_NULLST,TRUE);} break;
case 110:
# line 510 "elsyntax.y"
{yyval = CrtNode5(yypvt[-1],ND_VARS,yypvt[-1],0,yypvt[-0],FALSE,FALSE);} break;
case 111:
# line 512 "elsyntax.y"
{yyval = CrtNode5(yypvt[-2],ND_VARS,yypvt[-2],0,yypvt[-0],FALSE,TRUE);} break;
case 112:
# line 514 "elsyntax.y"
{yyval = CrtNode5(yypvt[-3],ND_VARS,yypvt[-3],yypvt[-1],yypvt[-0],FALSE,FALSE);} break;
case 113:
# line 516 "elsyntax.y"
{yyval = CrtNode5(yypvt[-4],ND_VARS,yypvt[-4],yypvt[-1],yypvt[-0],1,FALSE);} break;
case 114:
# line 518 "elsyntax.y"
{yyval = CrtNode5(yypvt[-4],ND_VARS,yypvt[-4],yypvt[-1],yypvt[-0],2,FALSE);} break;
case 115:
# line 520 "elsyntax.y"
{yyval = CrtNode0(yypvt[-0],ND_END);} break;
case 116:
# line 522 "elsyntax.y"
{yyval = CrtNode0(yypvt[-0],ND_END);} break;
case 117:
# line 527 "elsyntax.y"
{yyval = CrtNode2(yypvt[-3],ND_SQLPREPARE,yypvt[-2],yypvt[-0]);} break;
case 118:
# line 529 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_SQLUNPREPARE,yypvt[-0]);} break;
case 119:
# line 531 "elsyntax.y"
{yyval = CrtNode2(yypvt[-3],ND_DCLCURSOR,yypvt[-2],yypvt[-0]);} break;
case 120:
# line 533 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_OPENCURSOR,yypvt[-0],0);} break;
case 121:
# line 535 "elsyntax.y"
{yyval = CrtNode2(yypvt[-4],ND_OPENCURSOR,yypvt[-3],yypvt[-1]);} break;
case 122:
# line 537 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_EXECUTE,yypvt[-0],0);} break;
case 123:
# line 539 "elsyntax.y"
{yyval = CrtNode2(yypvt[-4],ND_EXECUTE,yypvt[-3],yypvt[-1]);} break;
case 124:
# line 541 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_CLOSECURSOR,yypvt[-0]);} break;
case 125:
# line 543 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 126:
# line 547 "elsyntax.y"
{yyval = CrtNode3(yypvt[-5],ND_UPDATE,yypvt[-4],yypvt[-2],yypvt[-0]);} break;
case 127:
# line 551 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_COLSETLIST,0,yypvt[-0]);} break;
case 128:
# line 553 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_COLSETLIST,yypvt[-2],yypvt[-0]);} break;
case 129:
# line 557 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_COLSET,yypvt[-2],yypvt[-0]);} break;
case 130:
# line 561 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 131:
# line 563 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 132:
# line 567 "elsyntax.y"
{yyval = 0;} break;
case 133:
# line 569 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 134:
# line 577 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 135:
# line 579 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 136:
# line 581 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 137:
# line 583 "elsyntax.y"
{yyval = TK_FALSE;} break;
case 138:
# line 585 "elsyntax.y"
{yyval = TK_TRUE;} break;
case 139:
# line 587 "elsyntax.y"
{yyval = TK_NULL;} break;
case 140:
# line 589 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_ENTRY,yypvt[-0]);} break;
case 141:
# line 591 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_ARRLIT,yypvt[-1]);} break;
case 142:
# line 593 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_ARRLIT,0);} break;
case 143:
# line 595 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_FUNCEXPR,yypvt[-1],yypvt[-0],0);} break;
case 144:
# line 597 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_ENTRYFUNC,yypvt[-1],yypvt[-0]);} break;
case 145:
# line 599 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 146:
# line 601 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_AREF,yypvt[-1],yypvt[-0],0);} break;
case 147:
# line 603 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_AREF,yypvt[-2],yypvt[-1],yypvt[-0]);} break;
case 148:
# line 605 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_OP,ElfIntMode?OP_IUMINUS:OP_UMINUS,0,yypvt[-0]);} break;
case 149:
# line 607 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_OP,OP_NOT,0,yypvt[-0]);} break;
case 150:
# line 609 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_IADD:OP_ADD,yypvt[-2],yypvt[-0]);} break;
case 151:
# line 611 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_ISUB:OP_SUB,yypvt[-2],yypvt[-0]);} break;
case 152:
# line 613 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_EXP,yypvt[-2],yypvt[-0]);} break;
case 153:
# line 615 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_IMULT:OP_MULT,yypvt[-2],yypvt[-0]);} break;
case 154:
# line 617 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_IDIV:OP_DIV,yypvt[-2],yypvt[-0]);} break;
case 155:
# line 619 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_IDIV,yypvt[-2],yypvt[-0]);} break;
case 156:
# line 621 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_REM,yypvt[-2],yypvt[-0]);} break;
case 157:
# line 623 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_AND,yypvt[-2],yypvt[-0]);} break;
case 158:
# line 625 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_OR,yypvt[-2],yypvt[-0]);} break;
case 159:
# line 627 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_XOR,yypvt[-2],yypvt[-0]);} break;
case 160:
# line 629 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_EQV,yypvt[-2],yypvt[-0]);} break;
case 161:
# line 631 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_IMP,yypvt[-2],yypvt[-0]);} break;
case 162:
# line 633 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_ILESS:OP_LESS,yypvt[-2],yypvt[-0]);} break;
case 163:
# line 635 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_IGRTR:OP_GRTR,yypvt[-2],yypvt[-0]);} break;
case 164:
# line 637 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_ILEQ:OP_LEQ,yypvt[-2],yypvt[-0]);} break;
case 165:
# line 639 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_IGEQ:OP_GEQ,yypvt[-2],yypvt[-0]);} break;
case 166:
# line 641 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_IEQUALS:OP_EQUALS,yypvt[-2],yypvt[-0]);} break;
case 167:
# line 643 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,ElfIntMode?OP_INEQ:OP_NEQ,yypvt[-2],yypvt[-0]);} break;
case 168:
# line 645 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_SLESS,yypvt[-2],yypvt[-0]);} break;
case 169:
# line 647 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_SGRTR,yypvt[-2],yypvt[-0]);} break;
case 170:
# line 649 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_SLEQ,yypvt[-2],yypvt[-0]);} break;
case 171:
# line 651 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_SGEQ,yypvt[-2],yypvt[-0]);} break;
case 172:
# line 653 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,OP_SADD,yypvt[-2],yypvt[-0]);} break;
case 173:
# line 655 "elsyntax.y"
{yyval = yypvt[-1];} break;
case 174:
# line 660 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 175:
# line 663 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_FETCHCURSOR,yypvt[-0],0);} break;
case 176:
# line 665 "elsyntax.y"
{yyval = CrtNode2(yypvt[-4],ND_FETCHCURSOR,yypvt[-0],yypvt[-2]);} break;
case 177:
# line 670 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_SELECT,0,yypvt[-1],yypvt[-0]);} break;
case 178:
# line 672 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_SELECT,yypvt[-2],yypvt[-1],yypvt[-0]);} break;
case 179:
# line 677 "elsyntax.y"
{yyval = TK_DISTINCT;} break;
case 180:
# line 679 "elsyntax.y"
{yyval = TK_ALL;} break;
case 181:
# line 684 "elsyntax.y"
{yyval = TK_MULT;} break;
case 182:
# line 686 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 183:
# line 691 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_COLLIST,0,yypvt[-0]);} break;
case 184:
# line 693 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_COLLIST,yypvt[-2],yypvt[-0]);} break;
case 185:
# line 698 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 186:
# line 700 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_BINDER,0,yypvt[-0]);} break;
case 187:
# line 702 "elsyntax.y"
{yyval = CrtNode2(yypvt[-3],ND_BINDER,TK_SQL,yypvt[-0]);} break;
case 188:
# line 704 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_BINDER,0,TK_HOOK);} break;
case 189:
# line 706 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_BINDER,TK_SQL,TK_HOOK);} break;
case 190:
# line 711 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_USERTAB,0,yypvt[-0]);} break;
case 191:
# line 713 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_USERTAB,yypvt[-2],yypvt[-0]);} break;
case 192:
# line 718 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_TABLIST,0,yypvt[-0]);} break;
case 193:
# line 720 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_TABLIST,yypvt[-2],yypvt[-0]);} break;
case 194:
# line 725 "elsyntax.y"
{yyval = CrtNode3(yypvt[-0],ND_TABLIST,0,yypvt[-0],TK_ASC);} break;
case 195:
# line 727 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_TABLIST,yypvt[-2],yypvt[-0],TK_ASC);} break;
case 196:
# line 729 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_TABLIST,0,yypvt[-1],TK_ASC);} break;
case 197:
# line 731 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_TABLIST,yypvt[-3],yypvt[-1],TK_ASC);} break;
case 198:
# line 733 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_TABLIST,0,yypvt[-1],TK_DESC);} break;
case 199:
# line 735 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_TABLIST,yypvt[-3],yypvt[-1],TK_DESC);} break;
case 200:
# line 740 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_TABEXPR,0,yypvt[-0]);} break;
case 201:
# line 742 "elsyntax.y"
{yyval = CrtNode2(yypvt[-1],ND_TABEXPR,yypvt[-1],yypvt[-0]);} break;
case 202:
# line 747 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_FROMTAB,yypvt[-0]);} break;
case 203:
# line 749 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_WHERE,yypvt[-0]);} break;
case 204:
# line 751 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_ORDERBY,yypvt[-0]);} break;
case 205:
# line 753 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_CONNECT,yypvt[-0],0);} break;
case 206:
# line 755 "elsyntax.y"
{yyval = CrtNode2(yypvt[-5],ND_CONNECT,yypvt[-3],yypvt[-0]);} break;
case 207:
# line 757 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_GROUPBY,yypvt[-0]);} break;
case 208:
# line 759 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_UNION,yypvt[-0]);} break;
case 209:
# line 761 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_INTERSECT,yypvt[-0]);} break;
case 210:
# line 763 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_MINUS,yypvt[-0]);} break;
case 211:
# line 768 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 212:
# line 770 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_SQLOR,yypvt[-2],yypvt[-0]);} break;
case 213:
# line 775 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 214:
# line 777 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_SQLAND,yypvt[-2],yypvt[-0]);} break;
case 215:
# line 782 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 216:
# line 784 "elsyntax.y"
{yyval = CrtNode1(yypvt[-1],ND_SQLNOT,yypvt[-0]);} break;
case 217:
# line 789 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 218:
# line 795 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 219:
# line 797 "elsyntax.y"
{yyval = CrtNode1(yypvt[-2],ND_SQLPAREN,yypvt[-1]);} break;
case 220:
# line 803 "elsyntax.y"
{yyval = CrtNode2(yypvt[-0],ND_NUMLIST,0,yypvt[-0]);} break;
case 221:
# line 805 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_NUMLIST,yypvt[-2],yypvt[-0]);} break;
case 222:
# line 810 "elsyntax.y"
{yyval = CrtNode4(yypvt[-4],ND_OP,TK_IN,0,yypvt[-4],yypvt[-1]);} break;
case 223:
# line 812 "elsyntax.y"
{yyval = CrtNode5(yypvt[-4],ND_OP,TK_BETWEEN,0,yypvt[-4],yypvt[-2],yypvt[-0]);} break;
case 224:
# line 814 "elsyntax.y"
{yyval = CrtNode4(yypvt[-5],ND_OP,TK_IN,TK_NOT,yypvt[-5],yypvt[-1]);} break;
case 225:
# line 816 "elsyntax.y"
{yyval = CrtNode5(yypvt[-5],ND_OP,TK_BETWEEN,TK_NOT,yypvt[-5],yypvt[-2],yypvt[-0]);} break;
case 226:
# line 818 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_LESS,yypvt[-2],yypvt[-0]);} break;
case 227:
# line 820 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_GRTR,yypvt[-2],yypvt[-0]);} break;
case 228:
# line 822 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_LEQ,yypvt[-2],yypvt[-0]);} break;
case 229:
# line 824 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_GEQ,yypvt[-2],yypvt[-0]);} break;
case 230:
# line 826 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_EQUALS,yypvt[-2],yypvt[-0]);} break;
case 231:
# line 828 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_NEQ,yypvt[-2],yypvt[-0]);} break;
case 232:
# line 833 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 233:
# line 835 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 234:
# line 837 "elsyntax.y"
{yyval = TK_NULL;} break;
case 235:
# line 839 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 236:
# line 841 "elsyntax.y"
{yyval = CrtNode2(yypvt[-2],ND_COLSTAR,yypvt[-2],yypvt[-0]);} break;
case 237:
# line 843 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_OPEN,0,yypvt[-1]);} break;
case 238:
# line 845 "elsyntax.y"
{yyval = CrtNode3(yypvt[-1],ND_OP,TK_SUB,0,yypvt[-0]);} break;
case 239:
# line 847 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_ADD,yypvt[-2],yypvt[-0]);} break;
case 240:
# line 849 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_SUB,yypvt[-2],yypvt[-0]);} break;
case 241:
# line 851 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_EXP,yypvt[-2],yypvt[-0]);} break;
case 242:
# line 853 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_MULT,yypvt[-2],yypvt[-0]);} break;
case 243:
# line 855 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_DIV,yypvt[-2],yypvt[-0]);} break;
case 244:
# line 857 "elsyntax.y"
{yyval = CrtNode3(yypvt[-2],ND_OP,TK_REM,yypvt[-2],yypvt[-0]);} break;
case 245:
# line 859 "elsyntax.y"
{yyval = yypvt[-0];} break;
case 246:
# line 861 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_SQLFUNC,yypvt[-3],0,yypvt[-1]);} break;
case 247:
# line 863 "elsyntax.y"
{yyval = CrtNode3(yypvt[-3],ND_SQLFUNC,yypvt[-3],0,TK_MULT);} break;
case 248:
# line 865 "elsyntax.y"
{yyval = CrtNode3(yypvt[-4],ND_SQLFUNC,yypvt[-4],TK_DISTINCT,yypvt[-1]);} break;
case 249:
# line 867 "elsyntax.y"
{yyval = CrtNode3(yypvt[-4],ND_SQLFUNC,yypvt[-4],TK_ALL,yypvt[-1]);} break;
	}
	goto yystack;		/* reset registers in driver code */
}
