/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elshlib.c
   Applix ASC version: 49
   Date: Fri Apr 16 21:11:25 1999
*/
#if RIOS
#include <stdio.h>
#include <sys/ldr.h>
#endif

#include <axtime.h>
#include <math.h>
#include <elf_env.h>
#include <adld.h>
#include <paripc.h>
#include <scac.h>
#include <thimble.h>
#include <elf_strs.h>
#include <fsrts.h>
#if LINUX
#include <stdlib.h>
#else
#include <search.h>
#endif
#include <axtrace.h>
#if RIOS
#define LIBID_SS 5 /* from axshlib.h */
#else
#include <elshlib.p>
#endif

#define ELF_DATA_DONE	1
#define	elfData	data_ptr
#include <elapi.h>

typedef struct AxClassInfo_t {	/* parallel definition in "elapi.hpp" */
	char *className;		/* C++ class name */
	void *modelObj;			/* an instance of class itself */
} AxClassInfo_t;


#if HP800V3		/* What a lame Hack! need this in aos.h instead !!! */
#define ACONST
#else
#define ACONST const
#endif


#if RIOS
void *AxGetEntryPointForIBM();
typedef struct {
    char *name; /* name of library */
    AxCallInfo_t *(*func)(); /* entry point in the library */
}AxShlibTable_t;

extern AxCallInfo_t *AxGetCallInfo_ss_1(), *AxGetCallInfo_ss_2(),
       *AxGetCallInfo_ss_3(), *AxGetCallInfo_ss_4(), *AxGetCallInfo_ss_5(),
       *AxGetCallInfo_ax_1(), *AxGetCallInfo_ax_2(), *AxGetCallInfo_ax_3(),
       *AxGetCallInfo_ax_4(), *AxGetCallInfo_ax_5(), *AxGetCallInfo_mr_1(),
       *AxGetCallInfo_mr_2(), *AxGetCallInfo_mr_3(), *AxGetCallInfo_mr_4(),
       *AxGetCallInfo_mr_5(), *AxGetCallInfo_mv_1(), *AxGetCallInfo_mv_2(),
       *AxGetCallInfo_mv_3(), *AxGetCallInfo_mv_4(), *AxGetCallInfo_mv_5(),
       *AxGetCallInfo_th_1(), *AxGetCallInfo_th_2(), *AxGetCallInfo_th_3(),
       *AxGetCallInfo_th_4(), *AxGetCallInfo_th_5(), *AxGetCallInfo_sh_1(),
       *AxGetCallInfo_sh_2(), *AxGetCallInfo_sh_3(), *AxGetCallInfo_sh_4(),
       *AxGetCallInfo_sh_5(), *AxGetCallInfo_br_1(), *AxGetCallInfo_br_2(),
       *AxGetCallInfo_br_3(), *AxGetCallInfo_br_4(), *AxGetCallInfo_br_5(),
       *AxGetCallInfo_kp_1(), *AxGetCallInfo_kp_2(), *AxGetCallInfo_kp_3(),
       *AxGetCallInfo_kp_4(), *AxGetCallInfo_kp_5(), *AxGetCallInfo_mk_1(),
	   *AxGetCallInfo_mk_2(), *AxGetCallInfo_mk_3(), *AxGetCallInfo_mk_4(),
	   *AxGetCallInfo_mk_5(), *AxGetCallInfo_ud_1(), *AxGetCallInfo_ud_2(), 
	   *AxGetCallInfo_ud_3(), *AxGetCallInfo_ud_4(), *AxGetCallInfo_ud_5(), 
	   *AxGetCallInfo_ud_6(), *AxGetCallInfo_ud_7(), *AxGetCallInfo_ud_8(), 
	   *AxGetCallInfo_ud_9(), *AxGetCallInfo_ud_10(), *AxGetCallInfo_ud_11(), 
	   *AxGetCallInfo_ud_12(), *AxGetCallInfo_ud_13(), *AxGetCallInfo_ud_14(), 
	   *AxGetCallInfo_ud_15(), *AxGetCallInfo_ud_16();
 
/*---------------------------------------------------------------------------*/
/* pre-define libraries for IBM */
#define MAX_SHLIB_ENTRIES  	61 
AxShlibTable_t AxShLibTable[MAX_SHLIB_ENTRIES] =
            {
                {NXLT("_ss_1"),AxGetCallInfo_ss_1},	/* Spreadsheet */
                {NXLT("_ss_2"),AxGetCallInfo_ss_2},
                {NXLT("_ss_3"),AxGetCallInfo_ss_3},
                {NXLT("_ss_4"),AxGetCallInfo_ss_4},
                {NXLT("_ss_5"),AxGetCallInfo_ss_5},
                {NXLT("_ax_1"),AxGetCallInfo_ax_1},	/* Applixware */
                {NXLT("_ax_2"),AxGetCallInfo_ax_2},
                {NXLT("_ax_3"),AxGetCallInfo_ax_3},
                {NXLT("_ax_4"),AxGetCallInfo_ax_4},
                {NXLT("_ax_5"),AxGetCallInfo_ax_5},
                {NXLT("_mr_1"),AxGetCallInfo_mr_1},	/* Marvin */
                {NXLT("_mr_2"),AxGetCallInfo_mr_2},
                {NXLT("_mr_3"),AxGetCallInfo_mr_3},
                {NXLT("_mr_4"),AxGetCallInfo_mr_4},
                {NXLT("_mr_5"),AxGetCallInfo_mr_5},
                {NXLT("_mv_1"),AxGetCallInfo_mv_1},	/* Market Vision */	
                {NXLT("_mv_2"),AxGetCallInfo_mv_2},
                {NXLT("_mv_3"),AxGetCallInfo_mv_3},
                {NXLT("_mv_4"),AxGetCallInfo_mv_4},
                {NXLT("_mv_5"),AxGetCallInfo_mv_5},
                {NXLT("_th_1"),AxGetCallInfo_th_1},	/* Tech hackers */
                {NXLT("_th_2"),AxGetCallInfo_th_2},
                {NXLT("_th_3"),AxGetCallInfo_th_3},
                {NXLT("_th_4"),AxGetCallInfo_th_4},
                {NXLT("_th_5"),AxGetCallInfo_th_5},
                {NXLT("_sh_1"),AxGetCallInfo_sh_1},	/* Shark */
                {NXLT("_sh_2"),AxGetCallInfo_sh_2},
                {NXLT("_sh_3"),AxGetCallInfo_sh_3},
                {NXLT("_sh_4"),AxGetCallInfo_sh_4},
                {NXLT("_sh_5"),AxGetCallInfo_sh_5},
                {NXLT("_br_1"),AxGetCallInfo_br_1},	/* Bridge */
                {NXLT("_br_2"),AxGetCallInfo_br_2},
                {NXLT("_br_3"),AxGetCallInfo_br_3},
                {NXLT("_br_4"),AxGetCallInfo_br_4},
                {NXLT("_br_5"),AxGetCallInfo_br_5},
                {NXLT("_kp_1"),AxGetCallInfo_kp_1},	/* Kapiti */
                {NXLT("_kp_2"),AxGetCallInfo_kp_2},
                {NXLT("_kp_3"),AxGetCallInfo_kp_3},
                {NXLT("_kp_4"),AxGetCallInfo_kp_4},
                {NXLT("_kp_5"),AxGetCallInfo_kp_5},
				{NXLT("_mk_1"), AxGetCallInfo_mk_1},	/* Moosmueller & Knauf */
				{NXLT("_mk_2"), AxGetCallInfo_mk_2},
				{NXLT("_mk_3"), AxGetCallInfo_mk_3},
				{NXLT("_mk_4"), AxGetCallInfo_mk_4},
				{NXLT("_mk_5"), AxGetCallInfo_mk_5},
                {NXLT("_ud_1"),AxGetCallInfo_ud_1},	/* User defined */
                {NXLT("_ud_2"),AxGetCallInfo_ud_2},
                {NXLT("_ud_3"),AxGetCallInfo_ud_3},
                {NXLT("_ud_4"),AxGetCallInfo_ud_4},
                {NXLT("_ud_5"),AxGetCallInfo_ud_5},
                {NXLT("_ud_6"),AxGetCallInfo_ud_6},
                {NXLT("_ud_7"),AxGetCallInfo_ud_7},
                {NXLT("_ud_8"),AxGetCallInfo_ud_8},
                {NXLT("_ud_9"),AxGetCallInfo_ud_9},
                {NXLT("_ud_10"),AxGetCallInfo_ud_10},
                {NXLT("_ud_11"),AxGetCallInfo_ud_11},
                {NXLT("_ud_12"),AxGetCallInfo_ud_12},
                {NXLT("_ud_13"),AxGetCallInfo_ud_13},
                {NXLT("_ud_14"),AxGetCallInfo_ud_14},
                {NXLT("_ud_15"),AxGetCallInfo_ud_15},
                {NXLT("_ud_16"),AxGetCallInfo_ud_16} };

/*
   function to return predefined entry point in the 
   library based on library name as on IBMs we can not do dlsym()
 */
static AxClassInfo_t *(*AxGetClassInfoEntryPointForIBM())();

typedef struct AxShlibClassInfoTable_t {
	char *name;					/* name of library */
	AxClassInfo_t *(*funcP)();	/* entry function pointer */
} AxShlibClassInfoTable_t;

extern AxClassInfo_t *AxGetClassInfo_cl_1(), *AxGetClassInfo_cl_2(),
		*AxGetClassInfo_cl_3(),*AxGetClassInfo_cl_4(),
		*AxGetClassInfo_cl_5();
/*
   Table of predefined entry points into libraries
 */
AxShlibClassInfoTable_t AxShlibClassInfoTable[] = {
	{ NXLT("_cl_1"), AxGetClassInfo_cl_1 },
	{ NXLT("_cl_2"), AxGetClassInfo_cl_2 },
	{ NXLT("_cl_3"), AxGetClassInfo_cl_3 },
	{ NXLT("_cl_4"), AxGetClassInfo_cl_4 },
	{ NXLT("_cl_5"), AxGetClassInfo_cl_5 },
	
	/* terminator */
	{ NULL, NULL }
};


/*---------------------------------------------------------------------------*/
#endif



static int NumLibs;
typedef struct {
char *libName;
void *handle;
char *firstCall;
time_t loadTime;
} LibInfo;

LibInfo* libInfo;


static int NumUserFuncs;
static data_user_func **UserFuncs;		/* Ptr to table of funcs ptrs */
static int ReSortUserFuncs;				/* If TRUE , list needs re-sorted */

static char *ElfPermString();
void ElfBindUserFunc();

data_ptr PopElfbArgVal();

extern int axErrorCode;
extern char *axErrorString;
extern char *axErrorObject;
extern jmp_buf axErrorHandler;
extern data_ptr ChannelDeReferenceServerObjects();
extern data_ptr ElfbDoSockRPCCall(), ElfGetSysVar();

static void AxErrorOvrStr();

#define PushPtr(p) (*Elf.sp++ = (data_ptr*)(p))

/*************************************************************************
function: CallUserElfb - Call user's function
*/
data_ptr CallUserElfb (funcP,args_passed,retloc)
register data_user_func *funcP;
register int args_passed;    /* how many args are pushed on stack */
register int retloc;    /* tempvar id to put return value or 0 for no ret */
{
	data_ptr aP;
	data_ptr funcData = NULL;
	data_ptr retval;
	int ix;
	void (*oldHandler)();
	int caughtError;
	int channel;		/* for remote funcs */
	char str[STRPATH+1], object[STRPATH+1], buf[STRPATH+1];
	int  err, new_err;
	data_ptr  strdP, objdP, sysvarP, retData, errP;
	char *callBackP;

	if ( !funcP->func )		/* a cleared reference */
		ElfBindUserFunc(funcP);

/* fix caller's prgram counter (just like CallElfb() does) */

	if ( retloc == -1 )
	    Elf.pc += (args_passed != 0);
	else
	    Elf.pc += (args_passed != 0) + (retloc != 0);

/* Load (not copy) args into a single array */

	aP = MkArray(args_passed);
	for ( ix = 0; ix < args_passed; ix++ )
		AX(aP)->vals[ix] = PopElfbArgVal();

/* setup for thrown errors */

	oldHandler = TaskInfo[THIMpid].elfAbortHandler;
	caughtError = FALSE;
	if ( setjmp(axErrorHandler) ) {
		caughtError = TRUE;
		goto wrap;
	}
	AxSetElfAbortHandler(AxErrorOvrStr);

/* call the func! */

	switch ( funcP->type ) {
	case TYPE_R_FUNC:
re_try:
		AXTRACE(("Calling rpc function '%s' \n", funcP->alias));
		funcData = MkArray(2);
		/* problem!!! we assume pointers are ints... :*( */
		AxAddIntToArray(funcData,0,(int)funcP->func);
		AxWriteArray(funcData,1,aP);
		channel = atoi(funcP->libname);
		errP = ElfbDoSockRPCCall(channel,-5,funcData, FALSE);
		if(NULL == errP)	{
			/* sucessful, done */
			ElfRetData = ChannelDeReferenceServerObjects(ElfRetData, channel);
			retval = ElfRetData;
			AXTRACE(("Returned from rpc function '%s' \n", funcP->alias));
			break;
		}
		/* the function returned with a communications error */
		AXTRACE(("communications error with rpc function '%s' \n", 
			funcP->alias));
		sprintf(buf,"%s%d",NXLT("rpc$callback$"), channel);
		sysvarP = ElfGetSysVar(buf);
		callBackP = NULL;
		if(AxIsString(sysvarP))
			callBackP = AxStrPtrFromDataPtr(sysvarP);
		if(NULL == callBackP)	{
			/* no callback, just throw original error back to caller */
			str[0] = '\0';
			object[0] = '\0';
			err = AxIntFromArray(errP, 0);
			strdP = AxArrayElement(errP, 1);
			objdP = AxArrayElement(errP, 2);
			if(AxIsString(strdP))
				strcpy(str, AxStrPtrFromDataPtr(strdP));
			if(AxIsString(objdP))
				strcpy(object, AxStrPtrFromDataPtr(objdP));
			AxFreeData(errP);
			ElfStrAbort(err, str, object);
		}

		AXTRACE(("calling rpc error callback %s\n", callBackP));
		new_err = ElfCallByName(callBackP, &retData, 3, 
			AxArrayElement(errP, 0),
			AxArrayElement(errP, 1),
			AxArrayElement(errP, 2));
		if(new_err != AOK)	{
			/* rethrow this error to caller */
			AXTRACE(("returned from rpc error callback with error=%d\n",
				new_err));
			str[0] = '\0';
			object[0] = '\0';
			strdP = AxArrayElement(retData, 0);
			objdP = AxArrayElement(retData, 1);
			if(AxIsString(strdP))
				strcpy(str, AxStrPtrFromDataPtr(strdP));
			if(AxIsString(objdP))
				strcpy(object, AxStrPtrFromDataPtr(objdP));
			AxFreeData(retData);
			AxFreeData(errP);
			ElfStrAbort(new_err, str, object);
		}

		if(AxIsNumber(retData))	{
			new_err = AxIntFromDataPtr(retData);
			AXTRACE(("returned from rpc error callback with retcode=%d\n",
				new_err));
			AxFreeData(retData);
			if(0 == new_err)	{
				AxFreeData(errP);
				AxFreeArrayButNotContents(funcData);
				goto re_try;
				/* re-call the function */
			}
		}	
		/* throw the original error to the caller */
		AxFreeData(retData);
		str[0] = '\0';
		object[0] = '\0';
		err = AxIntFromArray(errP, 0);
		strdP = AxArrayElement(errP, 1);
		objdP = AxArrayElement(errP, 2);
		if(AxIsString(strdP))
			strcpy(str, AxStrPtrFromDataPtr(strdP));
		if(AxIsString(objdP))
			strcpy(object, AxStrPtrFromDataPtr(objdP));
		AxFreeData(errP);
		ElfStrAbort(err, str, object);
		break;
	case TYPE_U_FUNC:
		AXTRACE(("Calling shared lib function '%s' from <%s>\n", funcP->alias,
			funcP->libname));
		retval = (*(funcP->func))(aP);
		AXTRACE(("Returned from  shared lib function '%s' from <%s>\n", 
			funcP->alias, funcP->libname));
		break;
	}

/* Unload and free the arg array */

wrap:
	AxSetElfAbortHandler(oldHandler);
	for ( ix = args_passed-1; ix >= 0; ix-- )
		AX(aP)->vals[ix] = 0;
	ElfDataFree(aP);
	if ( funcData )
		AxFreeArrayButNotContents(funcData);

	memset(&axErrorHandler,0,sizeof(axErrorHandler));/* avoid lalaland jumps */

	if ( caughtError )
		ElfStrAbort(axErrorCode,axErrorString,axErrorObject);

/* If there is no return value expected, toss whart user func created */

    if ( !retloc ) {    /* just exec function & return */
		ElfDataFree(retval);
        return(NULL);
    }

/* return value as result or assign back to calc stack */

	if ( retloc == -1 )
		return(retval);
	else {
		Assign(PushPtr(&Elf.curFrame->locvars[retloc]),retval);
		return(NULL);
	}
}

static int cmpUsrFunc(f1,f2)
ACONST void *f1, *f2;
{
	return(strcmp((*(data_user_func **)f1)->alias,(*(data_user_func **)f2)->alias));
}


/*************************************************************************
function: ElfFindUserFunc - Search User func list for passed name
Returns NULL if item not found
*/
data_user_func *ElfFindUserFunc (name)
char *name;		/* normalized (all upper case) name */
{
	data_user_func key, **funcPP;
	data_user_func *keyP = &key;

	if ( !UserFuncs )
		return(NULL);

	if ( ReSortUserFuncs ) {
		qsort((char*)UserFuncs,NumUserFuncs,sizeof(data_user_func*),cmpUsrFunc);
		ReSortUserFuncs = FALSE;
	}
	key.alias = name;
	funcPP = (data_user_func**)bsearch((char*)&keyP,(char*)UserFuncs,
				NumUserFuncs,sizeof(data_user_func*),
				(int (*)(ACONST void *, ACONST void *))cmpUsrFunc);
	if ( funcPP )
		return(*funcPP);
	else
		return(NULL);
}

/*************************************************************************
function: VfyLibLoaded - Return handle to lib... load if needed
*/
static void *VfyLibLoaded (libname, caller)
register char *libname;
char *caller;
{
	register int ix;
	void *handle;
	typeErr err=0;
	char *Adlerror(), *p, *errorP, *tmpP;
	int len;

	for ( ix = 0; libname != libInfo[ix].libName; ix++ );
	if ( !libInfo[ix].handle ) {
        handle = Adlopen(libname, ADL_BIND_IMMEDIATE);
#if RIOS
		if (handle && isShlibLoaded_SS()) {
			
			/* try resolving import symbols in shared lib 
			   from SS library exports */ 
			err = loadbind(0, AxLoadShlib(LIBID_SS,""), handle);
		}
#endif
		if ( !handle || err != 0)	{
			errorP = XLT("Could not Adlopen library ");	
			p = Adlerror();
			if(p && (*p != '\0'))	{
				len = strlen(errorP) + strlen(p) + 1;
				tmpP = malloc(len);
				strcpy(tmpP, errorP);
				strcat(tmpP, p);
				errorP = tmpP;
				ElfStrAbort(ERR_FUNCNOEXISTS, errorP, libname);
				free(errorP);
			}else	{
				ElfStrAbort(ERR_FUNCNOEXISTS, errorP, libname);
			}
		}
		libInfo[ix].handle = handle;
		libInfo[ix].loadTime = time(NULL);
		libInfo[ix].firstCall = caller;
		ElfbSetSysVar("LibStatusChanged$",AxMakeBoolData(BTRUE));
	}
	return(libInfo[ix].handle);
}

/*************************************************************************
function: ElfBindUserFunc - Verify lib loaded and func found
*/
void ElfBindUserFunc (funcP)
data_user_func *funcP;		/* IN/OUT */
{
	void *handle, (*fptr)();

#if RIOS
    /* all the functions should have been bound at install time */
    if(NULL == funcP->func) {
        ElfStrAbort(ERR_FUNCNOEXISTS, NULL, funcP->nameInCcode);
    }
#else


	if ( (long)funcP->func != 0 )	/* already snapped? */
		return;

/* find lib, load if not already loaded */

	handle = VfyLibLoaded(funcP->libname, funcP->alias);

/* find func, load func ptr if we succeed */

	fptr = (void (*)()) Adlsym(handle, funcP->nameInCcode, ADL_TYPE_PROCEDURE);
	if ( !fptr )
		ElfStrAbort(ERR_FUNCNOEXISTS,XLT("Could not find (Adlsym) in library"),funcP->nameInCcode);
	funcP->func = (data_ptr (*)()) fptr;
#endif
}

/*************************************************************************
function: getFuncsInfoFromLib - Get list of entris from lib (or cache file)
*/
static void getFuncsInfoFromLib (catPP,cfuncsPP,namePP,engnamePP, argInfoPP,ssFuncPP,libname)
data_ptr *catPP, *namePP, *engnamePP, *argInfoPP, *ssFuncPP;
void **cfuncsPP;
char *libname;
{
	data_ptr nameP, engnameP, argInfoP, ssFuncP, catP;
	void **cfuncsP;
	void *handle, (*fptr)();
	AxCallInfo_t *(*func)();
	AxCallInfo_t *calls;
	int cnt = 0;
	char *engname;

	cfuncsP = (void **)TaskCalloc(THIMpid,1, (cnt+1)*sizeof(void*));
	nameP = MkArray(0);
	engnameP = MkArray(0);
	ssFuncP = MkArray(0);
	argInfoP = MkArray(0);
	catP = MkArray(0);

/* find lib, load if not already loaded */

	handle = VfyLibLoaded(libname,"INSTALL_C_LIBRARY@");

/* find func, load func ptr if we succeed */

#if RIOS
    fptr = AxGetEntryPointForIBM(libname);
    if(NULL == fptr)	{
        goto done;
	}
#else
    fptr = (void (*)()) Adlsym(handle, "AxGetCallInfo", ADL_TYPE_PROCEDURE);
#endif

	if ( fptr ) {
		unsigned int val;
		func = (AxCallInfo_t *(*)()) fptr;
		calls = (*func)();	
		val = (unsigned int)(*((int *)calls));

		if((val != 0) && (val < 1024))	{
			/* new format, where the first word is the size of the function
			entries, in the old format the first word is a string pointer 
			which can never be in the zeroth page */
			goto done;
		}

		for ( ; calls->func; calls++,cnt++ ) {
			if (calls->alias) {
				if ((engname = strrchr(calls->alias, ':')) != NULL) {
					/* This is done for the ss addin function string, which
						now has the "foreignname:engname" so split the string*/
					engname[0] = '\0';
					engname++;
				} else {
					engname = NULL ;
				}
				nameP = ElfAddStrToArray(nameP, cnt, calls->alias);
				engnameP = ElfAddStrToArray(engnameP, cnt, engname);
			}
			cfuncsP = (void **)TaskRealloc(THIMpid,cfuncsP, (cnt+2)*sizeof(void*));
			cfuncsP[cnt] = (void*)calls->func;
			cfuncsP[cnt+1] = NULL;
			if ( calls->argStr )
				argInfoP = ElfAddStrToArray(argInfoP, cnt, calls->argStr);
			if ( calls->category && calls->category[0] )
				catP = ElfAddStrToArray(catP, cnt, calls->category);				
			ssFuncP = ElfAddNumToArray(ssFuncP,cnt, calls->callMode);
		}
	}
done:
	*cfuncsPP = cfuncsP;
	*namePP = nameP;
	*engnamePP = engnameP;
	*argInfoPP = argInfoP;
	*ssFuncPP = ssFuncP;
	*catPP = catP;
}

/***************************************************************************
function: elfLoadCppClasses - Load C++ class info from library and create
model objects in memory to hold that info.
*/
static void
elfLoadCppClasses (libnameP)
char *libnameP;
{
	AxClassInfo_t *(*funcP)();
	AxClassInfo_t *ciP;
	void *handle;

#if RIOS

/* Get predefined entry point into IBM library */
	funcP = AxGetClassInfoEntryPointForIBM(libnameP);

#else

/* find lib, load if not already loaded */
	handle = VfyLibLoaded(libnameP,"INSTALL_C_LIBRARY@");

/* find if class info table Callback function exist */
	funcP = (AxClassInfo_t *(*)())Adlsym(handle, "AxGetClassInfo",
										 ADL_TYPE_PROCEDURE);
#endif

	if (!funcP)
		return;

	for (ciP = (*funcP)(); ciP && ciP->className; ++ciP) {
		if (!ciP->className)
			return;
		if (!ciP->modelObj)
			continue;
		ElfObjLoadCppClassInfo(libnameP, ciP->className, ciP->modelObj);
	}
}


/*************************************************************************
function: ElfbUnBindSharedLib - Remove dynamic bindings... for developers
This expressly leaves the refereces for later auto-binding.
*/
ElfbUnBindSharedLib (nameP)
data_ptr nameP;
{
	int ix;
	char *pathname;
	int rpc_mode = FALSE;

#if RIOS
    return;
#else

	if ( AxIsNumber(nameP) ) {	/* RPC library */
		rpc_mode = TRUE;
	}

	pathname = StrFromDataPtr(nameP);
	for ( ix = 0; ix < NumLibs; ix++ ) {
		if ( streq(libInfo[ix].libName,pathname) )
			break;
	}
	if ( ix == NumLibs )		/* quietly fail if no such lib */
		return;
	if ( !libInfo[ix].handle  && !rpc_mode)
		return;

	/* Toss lib */
	if (!rpc_mode) {
		Adlclose(libInfo[ix].handle);
		libInfo[ix].handle = NULL;	
	}

	/* Unbind functions */
	pathname = libInfo[ix].libName;
	for ( ix = 0; ix < NumUserFuncs; ix++ ) {
		if (streq(UserFuncs[ix]->libname, pathname))
			UserFuncs[ix]->func = NULL;
	}

	ElfObjUnloadCppClasses(pathname);
#endif
}

/*************************************************************************
function: ElfbSharedLibs - Set shared library list
*/
void ElfbSharedLibs (libnameP,known_cfuncnames)
data_ptr libnameP;
data_ptr known_cfuncnames;
{
	char *pathname, *libNameP;
	int ix,jx, cnt;
	data_user_func *funcP;
	int added;		/* number of items added during this call */
	char *name, *engname, *argInfo, *category, *tmp_name;
	int callMode;
	data_ptr cfuncnames;
	void *cfuncsP;
	data_ptr nameP = NULL, ssFuncP = NULL, argInfoP = NULL, catP = NULL;
	data_ptr engnameP = NULL;
	data_ptr rpcFuncIds;
	int rpc_mode = FALSE;
	int createdFuncP = FALSE;	/* goes TRUE is list from lib */



	if ( AxIsNumber(libnameP) ) {	/* RPC library */
		if ( !AxIsArray(known_cfuncnames) )
			return;				/* library does not have RPC funcs */
		rpc_mode = TRUE;
		nameP = AxArrayElement(known_cfuncnames,0);
		catP = AxArrayElement(known_cfuncnames,1);
		argInfoP = AxArrayElement(known_cfuncnames,2);
		ssFuncP = AxArrayElement(known_cfuncnames,3);
		rpcFuncIds = AxArrayElement(known_cfuncnames,4);
		cnt = ElfbArraySize(nameP);
	}else	{
		/* shared library */
#if RIOS
    	VfyLibForIBM(libnameP, known_cfuncnames);
#endif
	}

/* Add pathname to LibNames table if not already there */

	pathname = StrFromDataPtr(libnameP);
	for ( ix = 0; ix < NumLibs; ix++ ) {
		if ( streq(libInfo[ix].libName,pathname) )
			break;
	}
	if ( ix == NumLibs ) {
		NumLibs++;
		libInfo = (LibInfo *)TaskRealloc(0,libInfo,NumLibs*sizeof(LibInfo));
		libInfo[ix].libName = ElfPermString(pathname);
		libInfo[ix].handle = NULL;
	}
	libNameP = libInfo[ix].libName;		/* stable pointer */

	if ( !rpc_mode ) {
		if ( known_cfuncnames ) {
			cfuncsP = NULL;
			cnt = ElfbArraySize(known_cfuncnames);
			nameP = known_cfuncnames;
		}
		else {
			getFuncsInfoFromLib(&catP,&cfuncsP,&nameP,&engnameP,&argInfoP,&ssFuncP,libNameP);
			createdFuncP = TRUE;
			cnt = ElfbArraySize(nameP);
		}
		elfLoadCppClasses(libNameP);
	}

/* Add Funcs to list if not already there */

	UserFuncs = (data_user_func**)TaskRealloc(0,UserFuncs,
					(NumUserFuncs+cnt)*sizeof(data_user_func*));
	added = 0;
	for ( ix = 0; ix < cnt; ix++ ) {
		name = StrFromArray(nameP,ix);
		engname = StrFromArray(engnameP, ix);
		if ( ssFuncP )
			callMode = IntFromArray(ssFuncP,ix);
		else
			callMode = AX_CALL_MODE_NORMAL;
		if ( argInfoP )
			argInfo = StrFromArray(argInfoP,ix);
		else
			argInfo = NULL;
		if ( catP )
			category = StrFromArray(catP,ix);
		else
			category = NULL;

		tmp_name = name;
		while(*tmp_name != '\0') {
        	*tmp_name = toupper(*tmp_name);
        	tmp_name++;
    	}
		funcP = ElfFindUserFunc(name);
		if ( !funcP ) {		/* create func and add to table */
			for ( jx = 0; jx < added; jx++ ) {
				if ( streq(name,UserFuncs[NumUserFuncs+jx]->alias) )
					break;
			}
			if ( jx == added ) {		/* new func not already added */
				funcP = (data_user_func*)TaskAlloc(0,sizeof(data_user_func));
				UserFuncs[NumUserFuncs+jx] = funcP;
				added++;
			}
		}
		if ( rpc_mode ) {
			funcP->func = (data_ptr (*)())AxIntFromArray(rpcFuncIds,ix);
			funcP->nameInCcode = NULL;
			funcP->type = TYPE_R_FUNC;
		}
		else if ( createdFuncP ) {
			funcP->func = ((data_ptr (**)())cfuncsP)[ix];
			funcP->nameInCcode = NULL;
			funcP->type = TYPE_U_FUNC;
		}
		else {
			funcP->func = NULL;
			funcP->nameInCcode = ElfPermString(StrFromArray(known_cfuncnames,ix));
			funcP->type = TYPE_U_FUNC;
		}
		funcP->alias = ElfPermString(name);
		if (0 != strcmp(engname, ""))
			engname = ElfPermString(engname) ;
		else 
			engname = funcP->alias;
		funcP->callMode = callMode;
		if ( argInfo )
			funcP->argInfo = ElfPermString(argInfo);
		else
			funcP->argInfo = "";
		if ( category )
			funcP->category = ElfPermString(category);
		else
			funcP->category = "";
		funcP->libname = libNameP;

		tmp_name = engname;
		while(*tmp_name != '\0') {
			*tmp_name = toupper(*tmp_name);
			tmp_name++;
		} 
		if (rpc_mode && !funcP->callMode) 
			continue;

		/* don't note the functions which are not going to be called from ss
			especially rpc ones **/
		SSNoteUserFunc(funcP->category,funcP->alias, engname, 
			funcP->argInfo, callMode);
	}

	NumUserFuncs += added;
	ReSortUserFuncs = TRUE;

	if ( createdFuncP ) {
		TaskFree(THIMpid,cfuncsP);
		ElfDataFree(nameP);
		ElfDataFree(engnameP);
		ElfDataFree(ssFuncP);
		ElfDataFree(catP);
	}

}

data_ptr AxElfGetInstalledSharedLibs()
{
	int ix;
	data_ptr retP;

	if(NULL == libInfo)
		return(NULL);
	retP = AxMakeArray(NumLibs);
	for ( ix = 0; ix < NumLibs; ix++)	{
		AxAddStrToArray(retP, ix, libInfo[ix].libName);	
	}
	return(retP);
}

/*************************************************************************
function: AxElfGetAddinLibInfo - return loaded user libraries info
*/
data_ptr AxElfGetAddinLibInfo(void)
{
	int ix, nloaded;
	char* str;
	data_ptr retP, aP;
	retP = AxMakeArray(NumLibs);
	for(ix=0, nloaded=0; ix < NumLibs; ix++) {
		if (libInfo[ix].handle == NULL)
			continue;
		aP = AxMakeArray(4);
		AxAddStrToArray(aP,0,libInfo[ix].libName);
		AxAddStrToArray(aP,1,libInfo[ix].firstCall);
		AxAddIntToArray(aP,2,BTRUE); /* isMacroCall */
		AxAddIntToArray(aP,3,libInfo[ix].loadTime);
		
		AxAddArrayToArray(retP,nloaded,aP);
		nloaded++;
	}
	if (nloaded != NumLibs)
		retP = AxTruncArray(retP,nloaded);
	return(retP);
}


static char *ElfPermString(name)
char *name;
{
	return(strcpy((char *) TaskAlloc(0,strlen(name)+1),name));
}

/*************************************************************************
function: AxErrorOvrStr - Like AxError, but alternate arg ordering
*/
static void AxErrorOvrStr (code,obj,str)
int code;
char *obj;
char *str;
{
	AxError(code,str,obj);
}

#if RIOS

#define MIN_IBM_NAME	5	/* template is xxxxxx_XX_Y where XX identifies */
							/* a vendor code and Y is a digit from 1 to 5 */
/*
*   VfyLibForIBM - will throw an error if libname is not a pre-define
*       libname
*/
VfyLibForIBM(libnameP, known_cfuncnames)
    data_ptr libnameP, known_cfuncnames;
{
    char *p;
 
    if ( !AxIsNumber(libnameP) ) {  /* shared lib */
        if(known_cfuncnames)
            ElfStrAbort(ERR_ILLVAL,
                XLT("Unexpected arg, needs AxCallInfo Table"), NULL);
    }
    p = AxStrPtrFromDataPtr(libnameP);
    if((p == NULL) || (*p == '\0')) {
        ElfStrAbort(ERR_ILLVAL, XLT("Bad library name"), p);
    }
 
    if ( (NULL == AxGetEntryPointForIBM(p)) &&
		 (NULL == AxGetClassInfoEntryPointForIBM(p)) )
        ElfStrAbort(ERR_ILLVAL, XLT("Bad library name"), p);
}

void    *AxGetEntryPointForIBM(libname)
    char *libname;
{
    int ix, len;
	char *p;
    char entryname[STRPATH+1], dirname[STRPATH+1];
    ParsePath(libname, dirname, entryname);

	/* point to the end of the string */
	len = strlen(entryname);
	if( len < MIN_IBM_NAME)
		return(NULL);	/* bad name */

	p = entryname;
	/* get the template part of the name */
	p = p + len - MIN_IBM_NAME;	

	/* search for the template in the pre-defined table */
    for(ix=0; ix < MAX_SHLIB_ENTRIES; ix++) {
        if(0 == strcmp(AxShLibTable[ix].name, p))
            return((void *)AxShLibTable[ix].func);
    }
    return(NULL);
}

/***************************************************************************
function: AxGetClassInfoEntryPointForIBM - function which returns pointer to
a function in the library which returns AxClassInfo_t *.
*/
static AxClassInfo_t *
(*AxGetClassInfoEntryPointForIBM (libname))()
char *libname;
{
	register AxShlibClassInfoTable_t *tblP;
	char *p, entryname[STRPATH+1], dirname[STRPATH+1];
	int len;

	ParsePath(libname, dirname, entryname);

	/* point to the end of the string */
	len = strlen(entryname);
	if (len < MIN_IBM_NAME)
		return(NULL);	/* bad name */

	p = entryname;
	/* get the template part of the name */
	p = p + len - MIN_IBM_NAME;	

	/* search for the template in the pre-defined table */
	for (tblP = AxShlibClassInfoTable; tblP->name; ++tblP) {
		if (streq(tblP->name, p))
			return(tblP->funcP);
	}
    return(NULL);
}

#endif
