/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elstatic.c
   Applix ASC version: 329.18
   Date: Wed Mar 10 21:10:02 1999
*/

/*

DANGER!!! ONLY ADD TO END OF ElfCoreFuncs DISPATCH TABLE... NEVER IN MIDDLE!!!!  
          NEVER DELETE TABLE ENTRIES, EITHER!!!
Existing customer .elo files reference builtins by index, not name.

*/

#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <axtime.h>

#if !AX_NT
#include <sys/time.h>
#else
#include <axtimev.h>    /* for timezone struct */
#endif  

#include <elf_env.h>
#include <akeys.h>
#undef VERIFY	/* to avoid conflict in elcomp.h */
#include <elcomp.h>
#include <amenudef.h>
#include <eldebug.h>
#include <getstr4.h>
#include <getstr5.h>
#include <getstr10.h>
#include <bltn_syms.h>
#include <el_syms.h>

#include <arghdr.h>
#include <elstatic.p>

extern short THIMpid;
extern int JavaMode;    /* TRUE for Java slaved axmain */

data_ptr AxTaskCopyElfData();
char *TaskAlloc();
int ThimbleSaysToReturnNow; /* hack for breaking out of XtAppNextEvent */
int CSpellPid = -1;  /*pid of speller, if it has been sucessfully proc-ed*/
int ElfIpcTask;	/* task waiting on IPC response */
FILE *ElfLogFp = NULL;
int ElfAllowNewTask = TRUE;
int ElfKbdSuppress;	/* non-zero if keyboard & mouse should be suppressed */
int ElfInDelayState;	/* count of elf tasks doing delays now */
elfstatic_dummy(){}
short ElfHasStatusMessageDisplayed; /* TRUE if there is a status message */
char *SEhackname = (char *)0;
char *SEhackfilename = (char *)0;
int SEisReallyTSE;	/* hack to serializer file printing */
int ThimDefDevBeforePrinting;	/* Printing hack */
int ElfHasMailOut;	/* TRUE if mail has been checked out */
int ATMinitCOMPLETE;    /* TRUE if initialization completed */
int DialogFrdTermed;	/* HERE for link line considerations (sysvar) */
int THIMhelpMode;
int ElfStdoutRecord;	/* If TRUE, sends stuff to stdout while recording */

char *ThimLangDir;		/* Where the THIMBLE alternate language dicts are */
char *ThimFiltersDir;	/* Where the optional filters live */
char *TrueMalloc();
extern int AxStartedForPrinting; 	/* axmain started for printing */

extern int AxElfrtMode;		/* TRUE if running as elfrt rather than axmain */

ElfbDoneInit()
{
#if !FOR_TESTER
	if ( !ATMinitCOMPLETE ) {
		ATMinitCOMPLETE = TRUE;
		if ( !JavaMode )
			ElfTaskProc(ELElfMacroId(ELFM_RPC_LISTENER_));
	}
#endif
}


char ElfSelTextKey[2];   /* Text char struck in learn selection mode */
char ElfLogonDoc[STRNORMAL+1];
bint ElfHelperPid;      /* process id of the elf helper */
menu_item_def *ServicesMenuPopup;	/* Elf specified services popup */
#if PMAX
char tempName[STRPATH+1];
#endif


data_ptr AxfAxFullAbort(),AxfAbs(),AxfAbsPath();
data_ptr AxfStdoutRecord(),AxfXmPutBusyCursor(),AxfGetLangDir(),AxfArgsToArray();
data_ptr AxfElfbArraySize(),AxfCatchErrors(),AxfElfbAddProfile(),AxfCloseFile();
data_ptr AxfElfbCopyFile(),AxfElfbCopyFileToClipboard(),AxfElfbCopyClipboardToFile(),AxfCos();
data_ptr AxfMkdir(),AxfElfbMenuStatus(),AxfElfbSys5(),AxfElfbMachine();
data_ptr AxfElfbSupportsAudio(),AxfElfbCheckAudioSupport(),AxfElfbDemoMode(),AxfElfbNewUser();
data_ptr AxfValidCmdName(),AxfCurrDir(),AxfCurrentTime(),AxfElfbCurWindow();
data_ptr AxfElfbWinTitle(),AxfGetCustomDir(),AxfFormatDate(),AxfDefErrStr();
data_ptr AxfDelay(),AxfElfbDelete(),AxfRecursiveDelete(),AxfDeleteDir();
data_ptr AxfDnCase(),AxfGetDtmod(),AxfElfbEditIcon(),AxfElfbColorState();
data_ptr AxfElfbUpdateBitmap(),AxfElfbLoadBitmap(),AxfElfbGetLiveData();
data_ptr AxfElfbSendMesToApp(),AxfElfbEndLearn(),AxfError(),AxfElfbReAbort();
data_ptr AxfErrorBox(),AxfErrNum(),AxfErrStr(),AxfErrObject();
data_ptr AxfErrLine(),AxfErrFile(),AxfElfbCurLineInfo(),AxfElfbExit();
data_ptr AxfElfbFetchAndRun(),AxfGetFilesize(),AxfFileExecutable(),AxfVfyFileExists();
data_ptr AxfFileExists(),AxfElfbDirExists(),AxfFileSavedNotify(),AxfFileReadable();
data_ptr AxfElfbFileWritable(),AxfFSQuery(),AxfFindElfFile(),AxfFormat();
data_ptr AxfElfbCompose_String(),AxfFullPathname(),AxfGetenv();
data_ptr AxfGetBluTime(),AxfEncryptTime(),AxfElfbGetKeyName(),AxfGetHelp();
data_ptr AxfGetKeyCode(),AxfElfbListPackages(),AxfMk1TempName();
data_ptr AxfElfbGEQuietCreate(),AxfElfbImageFromGE(),AxfElfbGEQuietOpen(),AxfElfbHelpAvailable();
data_ptr AxfSetHelp(),AxfHelpFile(),AxfElfbSetXKey(),AxfElfbDBList();
data_ptr AxfElfbGetXKeys();
data_ptr AxfElfbDoneInit(),AxfInt(),AxfInLearn();
data_ptr AxfIsElfrt(),AxfIsMailrt(),AxfElfbIsArray(),AxfIsFunc();
data_ptr AxfElfbIsNull(),AxfElfbIsNumber(),AxfElfbIsString(),AxfElfbKillTask();
data_ptr AxfStrlen(),AxfDlgLiftCursor(),AxfFuncList(),AxfElfbWindowList();
data_ptr AxfElfbInstall(),AxfCompileArray(),AxfElfbInstallBinary(),AxfNlog();
data_ptr Axflog10(),AxfLogout(),AxfTaskMaster(),AxfElfbSetTaskMaster();
data_ptr AxfMakeFileWriteable(),AxfMkTempName(),AxfElfbMapCursor();
data_ptr AxfMaxStrlen(),AxfElfbMiniDemo(),AxfMoveFile(),AxfNewTaskWithArgs();
data_ptr AxfElfbProc(),AxfPProc(),AxfGenSafeName(),AxfNormlKeySeq();
data_ptr AxfNumToStr(),AxfOpenDoc(),AxfOpenFile(),AxfPendForNewTaskWithArgs();
data_ptr AxfElfbPick(),AxfElfbPokeDialogs(),AxfElfbPrintFile(),AxfGetPageInfo();
data_ptr AxfElfbPrintDoc(),AxfProfile(),AxfProfileByCode(),AxfElfbPromoteDlg();
data_ptr AxfElfbPromotedDlgID(),AxfElfbIsQAmode(),AxfRand(),AxfSeedRand();
data_ptr AxfREV32(),AxfElfbReadFile(),AxfReadBigFile(),AxfElfbReadDataFile();
data_ptr AxfReadLine(),AxfAed(),AxfElfbMkWinActive(),AxfSetCurrDir();
data_ptr AxfElfbFreeRun(),AxfElfbSetHelpMode(),AxfElfbSetLiveMode();
data_ptr AxfElfbRunMode(),AxfSelections(),AxfSetServices(),AxfSetSubstr();
data_ptr AxfElfbSetSysVar(),AxfElfbWidgetProfile(),AxfWidgetColorsFromProfile(),AxfShcmd();
data_ptr AxfShWin(),AxfShXterm(),AxfSin(),AxfSort();
data_ptr AxfSortIndexed(),AxfSplitPath(),Axfsqrt(),AxfElfbStartLearn();
data_ptr AxfNewAE(),AxfNewDC(),AxfNewGE(),AxfNewHLP();
data_ptr AxfNewSS(),AxfElfbStatusMessage(),AxfStrIndex(),AxfStrToNum();
data_ptr AxfElfbStroke(),AxfSubstr(),AxfSuppressDisplay(),AxfSuppressErrsDisplay();
data_ptr AxfSysMode(),AxfGetDataDir(),AxfGetFilterDir(),AxfGetAxLangDir();
data_ptr AxfGetAxLocalLangDir(),AxfElfbGetSysVar(),AxfTabsToSpaces(),AxfListTasks();
data_ptr AxfGetTempDir(),AxfElfbTextDictAddWord(),AxfElfbTextDictGetWords(),AxfElfbTextDictRemoveWord();
data_ptr AxfElfbTextDictCanAdd(),AxfElfbTextDictClose(),AxfElfbTextDictCreate(),AxfElfbTextGetLanguageCode();
data_ptr AxfElfbTextGetLanguageName(),AxfElfbTextHyphenate(),AxfElfbTextSpelledCorrectly(),AxfElfbTextSpellerClose();
data_ptr AxfElfbTextSpellerCurrLanguage(),AxfElfbTextSpellerHyphenationOK(),AxfElfbTextSpellerLanguageOK(),AxfElfbTextSpellerThesaurusOK();
data_ptr AxfElfbTextSpellingAlternatives(),AxfElfbTextSpellingErrors(),AxfElfbTextSpellingInfo(),AxfElfbTextThesaurus();
data_ptr AxfElfbTextThesaurusClose(),AxfElfbTextThesaurusInfo(),AxfElfbImportAscii(),AxfElfbImportSS();
data_ptr AxfTrim(),AxfTruncArray(),AxfMakeEntryLink(),AxfNameFromEntry();
data_ptr AxfElfbIsEntry(),AxfDumpElfSymNames(),AxfElfbTest(),AxfUpCase();
data_ptr AxfGetUserDir(),AxfGetAxHomeDir(),AxfValDocName(),AxfElfValidName();
data_ptr AxfFRwait(),AxfElfbWindowInfo(),AxfWindowPos(),AxfWriteFile();
data_ptr AxfWriteBigFile(),AxfElfbWriteDataFile(),AxfWriteLine(),AxfElfbCreateChangeWidget();
data_ptr AxfElfbGetActiveWidgetFromElf(),AxfElfbCreateChoiceMenu(),AxfElfbCreateDialog(),AxfElfbDefaultButtons();
data_ptr AxfElfbDestroyWidget(),AxfElfbDelEditBoxData(),AxfElfbGetEditBoxData(),AxfElfbGetEditBoxSelectedRegion();
data_ptr AxfElfbMarkEditBoxRegion(),AxfElfbInsEditBoxData(),AxfElfbEditBoxEdited(),AxfElfbCutEditBoxSeln();
data_ptr AxfElfbCopyEditBoxSeln(),AxfElfbPasteEditBoxSeln(),AxfAxXmEditBoxResetEdited(),AxfElfbEntryFieldCreate();
data_ptr AxfElfbEntryValue(),AxfElfbFixupQuirks(),AxfElfbDialogDestroy(),AxfElfbCreateDlgMenuBar();
data_ptr AxfElfbUpdateDialog(),AxfElfbUpdateDialogSize(),AxfElfbRadioBoxCreate(),AxfElfbRebuildDialog();
data_ptr AxfElfbSetActiveWidget(),AxfElfbShowDialog(),AxfElfbTableData(),AxfElfbTableNewData();
data_ptr AxfElfbGetTableData(),AxfElfbSetTableSelections(),AxfElfbClearTableData(),AxfElfbGetTableSelections();
data_ptr AxfElfbAllowTableEditing(),AxfElfbDataRequestModel(),AxfElfbMenuCallback(),AxfElfbXferSafe();
data_ptr AxfXlateGothic(),AxfElfRecord(),AxfElfbPrtrFile(),AxfDispTutor();
data_ptr AxfAxRePaintAll(),AxfIsMetric(),AxfI2IN(),AxfI2CM();
data_ptr AxfVfyMenu(),AxfElfbIsBinary(),AxfElfbBinarySize(),AxfReadBinaryFile();
data_ptr AxfElfbWriteBinaryFile(),AxfBinaryToArray(),AxfArrayToBinary(),AxfBinaryByte();
data_ptr AxfElfbDecomposeFile(),AxfAxNet(),AxfElfbServer(),AxfElfbClient();
data_ptr AxfElfbSockRead(),AxfElfbSockRPCRead(),AxfElfbSockWrite(),AxfElfbSockRPCWrite();
data_ptr AxfElfbSockReadBinary(),AxfElfbSockWriteBinary(),AxfElfbRPCAccept(),AxfElfbRPCRespond();
data_ptr AxfElfbRPCErrRespond(),AxfElfbSockClose(),AxfElfbChanClose(),AxfElfbOpenMail();
data_ptr AxfParseDate(),AxfElfbIsLikeAscii(),AxfAxLockResource(),AxfAxUnlockResource();
data_ptr AxfElfbHasUnreadMail(),AxfElfbFormatMailItem(),AxfElfbDayArray(),AxfElfbMkRandKey();
data_ptr AxfElfbEncryptString(),AxfElfbAudio(),AxfElfbLocalizeSS(),AxfCreateTempfile();
data_ptr AxfXmNewStarMenu(),AxfTmToggleToolBar(),AxfElfbToggleToolBar(),AxfElfbToolBarStatus();
data_ptr AxfChmodAbsolute(),AxfElfbRecognizeFile(),AxfFormatArray(),AxfIsUUEncoded();
data_ptr AxfRingTheBell(),AxfUserName(),AxfElfbNewMailCount(),AxfElfbFetchRefs();
data_ptr AxfRunProgram(),AxfRunBatchProgram(),AxfRunStdinProgram(),AxfRunStdinBatchProgram();
data_ptr AxfRunProgramPid(),AxfDatePieces(),AxfElfbPrivateMenuBar(),AxfElfbGetInKS();
data_ptr AxfElfbPutToKS(),AxfElfbSetSelection(),AxfElfbGetSelection(),AxfElfbXwinOfWin();
data_ptr AxfElfbSelByXId(),AxfNoMapWindowsFlag();
data_ptr AxfViewRest(),AxfViewOnly(),AxfUnixFileSystem(),AxfElfbGetFontFamilies();
data_ptr AxfAxTimer(),AxfElfbSendElfData(),AxfElfbSendAndAckElfData(),AxfElfbRespondElf();
data_ptr AxfElfbRespondElfErr(),AxfElfbWaitForMessage(),AxfElfbWpCall(),ElfbSSCall();
data_ptr AxfElfbGetPrinterTypes(),AxfTaskId(),AxfElfbDEloadNewGadget(),AxfElfbDEeditWidget();
data_ptr AxfElfbDEeditSession(),AxfElfbDEreadData(),AxfParentTask(),AxfElfbCreateObject();
data_ptr AxfElfbObjCrtQueryMethod(),AxfElfbObjCrtChangeMethod(),AxfElfbObjCrtLocalData(),AxfElfbObjLoadImage();
data_ptr AxfElfbObjInfo(),AxfElfbIsObject(),AxfElfbObjectExists(),AxfElfbDataType();
data_ptr AxfProcessId(),AxfElfbPrintf(),AxfElfbWriteAppFile(),AxfElfbReadAppFile();
data_ptr AxfElfbFuncsInObject(),AxfElfbDraw(),AxfElfbDebugFuncs(),AxfElfbTblFuncs();
data_ptr AxfElfbEnterFuncs(),AxfIsAXMS(),AxfFreeNamedBitmap(),AxfInfoFromFileHeader();
data_ptr AxfFileHeaderFromInfo(),AxfDocHasLinks(),AxfGetDocLinksInfo(),AxfChangeDocLinksInfo();
data_ptr AxfLocalizeDocLinks(),AxfElfbGetMaxFileLength(),AxfElfbIsFileOpen(),AxfNoteFileInUse();
data_ptr AxfDoneWithFile(),AxfElfbGetDpyWid(),AxfElfbGetDpyHt(),AxfElfbProfiler();
data_ptr AxfElfbGetXLFD(),AxfArrayTranspose(),AxfArrayColumns(),AxfArray1Column();
data_ptr AxfBecomeParasite(),AxfUtil(),AxfIsOrientBuild(),AxfElfbTrayFuncs();
data_ptr AxfElfbTreeFuncs(),AxfElfbGetDlgFontHeight(),AxfElfbListImages(),AxfStrToValue();
data_ptr AxfGetHostname(),AxfElfbTextDictLanguage(),AxfGetDisplayVar(),AxfXLT_Complex();
data_ptr AxfUseWideMenuBarEdit(),AxfElfbAddressParse(),AxfElfbGadgetSizesFuncs(),AxfRtReader();
data_ptr AxfAxStringFileName(),AxfElfbTextSize(),AxfElfbListScreenfonts(),AxfElfbDEscaleDialog();
data_ptr AxfNormalizeOut(),AxfNormalizeIn(),AxfElfbReplaceSpace(),AxfElfbDeleteMessages();
data_ptr AxfElfbGraphicFuncs(),AxfNewFilePermissions(),AxfElfbMailBltins(),AxfElfbDestroyGraphic();
data_ptr AxfElfbAssignGraphic(),AxfElfbCreateGraphic(),AxfElfbReadGraphicBuffer(),AxfElfbReadGraphicFile();
data_ptr AxfSSUtil(),AxfSSRegisterFunction();
data_ptr AxfElfbPaintInsetObject(),AxfNoteTaskInterested();
data_ptr AxfFormatDate_Str(),AxfLockFile(),AxfUnlockFile();
data_ptr AxfElfbMapDefaultCursor(),AxfListParasites(),AxfElfbMapiFuncs(),AxfErrElfObj();
data_ptr AxfErrFunc(),AxfNewGP(),AxfReadElfFile(),AxfGetClipArtDir();
data_ptr AxfElfbLoadGraphic(),AxfFilterWpToAsciiLayout(),AxfElfbWriteGraphicBuffer(),AxfElfbWriteGraphicFile();
data_ptr AxfElfbGetGraphic(), AxfAppIsSS(),AxfJulianDate(),AxfAppIsData();
data_ptr AxfIsTask(),AxfElfbPromoteWindow(),AxfElfbIsFileLocked(),AxfNewDeamonWithArgs();
data_ptr AxfElfbReadRasterInfo(),AxfElfbReadCustomCursors(),AxfGetAxLangDemosDir(),AxfUserId();
data_ptr AxfSSFuncs(),AxfNewHTML(),AxfGetPresColorDir(),AxfGetPresMonoDir();
data_ptr AxfGetPresBklitDir(),AxfGetPresTemplateDir(),AxfSetPresTemplateDir(),AxfGetPresOutlineDir();
data_ptr AxfGetPresSchemeDir(),AxfGetPresChartDir(),AxfSockWriteAscii(),AxfStringToBinary();
data_ptr AxfBinaryToString(),AxfFontUtils(),AxfByteLen(),AxfStrClip();
data_ptr AxfSubstr(),Axfeuc2sjis(),Axfsjis2euc(),Axfeuc2jis();
data_ptr Axfjis2euc(),Axfsjis2jis(),Axfjis2sjis(),Axfmime2jis();
data_ptr Axfjis2mime(),AxfReadGlomBitmap(),AxfGetPres35mmDir(),AxfUnpendedNewTaskWithArgs();
data_ptr AxfBinarySubArray(),AxfElfbCreateWpInstance(),AxfElfbDestroyWpInstance(),AxfElfbAssignWpInstance();
data_ptr AxfElfbLoadWpInstance(),AxfElfbGetWpInstance(),AxfElfbReadWpInstanceBuffer(),AxfElfbWriteWpInstanceBuffer();
data_ptr AxfElfbReadWpInstanceFile(),AxfElfbWriteWpInstanceFile(),AxfElfbWpxCall(),AxfTrunc();
data_ptr AxfElfbCreateInsetObject(),AxfMeasureInsetObject(),AxfMDDFuncs();
data_ptr AxfGetBlobData(),AxfChangeDateFormat(),AxfMeasureWpInsetObjectCoords(),AxfStartApp();
data_ptr AxfGetServByName(),AxfTokenize(),AxfElfbCreateBuilder(),AxfBuilderRegisterAppobjWithInset();
data_ptr AxfBuilderDestroyInset(),AxfBuilderGetInsetAppobj(),AxfBuilderGetGraphicsInset(),AxfBuilderFindInstanceGivenFilenameAndParentTaskid();
data_ptr AxfBuilderGetContainerInfo(),AxfBuilderGetContainerApptype(),AxfBuilderGetGraphicsInsetUID(),AxfBuilderSetRootPathname();
data_ptr AxfBuilderSetSourceInfo(),AxfBuilderGetSourceInfo(),AxfBuilderSetInsetDocInfo(),AxfBuilderGetInsetDocInfo();
data_ptr AxfElfStack(),AxfPrintDatum(),AxfACLEnabled(),AxfSetACLEntry();
data_ptr AxfClearACLEntry(),AxfGetACL(),AxfListGroupsAndUsers();
data_ptr AxfFileOpenedNotify(),AxfFileClosedNotify(),AxfGetCurrentLanguage(),AxfPreloadJavaImgsFromStrs();
data_ptr AxfElfbAddIconInsetObject(),AxfGetEnterpriseDir(),AxfGetEnterpriseAppsDir(),AxfGetEnterpriseAppFilename();
data_ptr AxfIsLinuxOffice(),AxfPostJavaImage(),AxfPostJavaImagePacket(),AxfJavaMenubarNotify();
data_ptr AxfJavaTaskSyncMesNotify(),AxfJavaTaskNotify(),AxfJavaNotify(),AxfIsLikeLatin1();
data_ptr Axfascissjis(),AxfBinaryAppend(),AxfWriteBinaryToFile(),AxfReadBinaryFromFile();
data_ptr AxfElfbCreateInsetImage(),AxfElfbDestroyInsetImage(),Axfispureascii(),Axfiseuc();
data_ptr Axfissjis(),Axfisjis(),AxfFindLargeWindowId(),AxfFindSmallWindowId();
data_ptr AxRtTm1Funcs(),AxfMeasureInsetObjectArea(),AxfEncSetPasswd(),AxfEncDisable();
data_ptr AxfCheckSpellingLibrary(),AxfAxfMClientBltins(),AxfNoteTaskInterested();
data_ptr AxfCallLibFunc();

#define OBSOLETE NULL

/*

DANGER!!! ONLY ADD TO END OF ElfCoreFuncs DISPATCH TABLE... NEVER IN MIDDLE!!!!  

*/

bltin_desc ElfCoreFuncs[] = {
{TYPE_C_FUNC,ELFM_NOT_SYMBOL,AxfAxFullAbort},
{TYPE_C_FUNC,ELFM_FUNCTION_KEYX,OBSOLETE},
{TYPE_C_FUNC,ELFM_ABS,AxfAbs},
{TYPE_C_FUNC,ELFM_ABSPATH,AxfAbsPath},
{TYPE_C_FUNC,ELFM_STD_REC_,AxfStdoutRecord},
{TYPE_C_FUNC,ELFM_ALL_WINS_BUSY_,AxfXmPutBusyCursor},
{TYPE_C_FUNC,ELFM_ALT_LANG_DIRECTORY_,AxfGetLangDir},
{TYPE_C_FUNC,ELFM_ARRAY_FROM_ARGS_,AxfArgsToArray},
{TYPE_C_FUNC,ELFM_ARRAY_SIZE,AxfElfbArraySize},
{TYPE_C_FUNC,ELFM_CATCH_ERRORS,AxfCatchErrors},
{TYPE_C_FUNC,ELFM_CHANGE_PROFILE_,AxfElfbAddProfile},
{TYPE_C_FUNC,ELFM_CLOSE_FILE,AxfCloseFile},
{TYPE_C_FUNC,ELFM_COPY_FILE_,AxfElfbCopyFile},
{TYPE_C_FUNC,ELFM_COPY_FILE_TO_CLIPBOARD,AxfElfbCopyFileToClipboard},
{TYPE_C_FUNC,ELFM_COPY_CLIPBOARD_TO_FILE,AxfElfbCopyClipboardToFile},
{TYPE_C_FUNC,ELFM_COS,AxfCos},
{TYPE_C_FUNC,ELFM_CREATE_DIRECTORY_,AxfMkdir},
{TYPE_C_FUNC,ELFM_DBMENUSTAT,AxfElfbMenuStatus},
{TYPE_C_FUNC,ELFM_SYS5,AxfElfbSys5},
{TYPE_C_FUNC,ELFM_MACHINE,AxfElfbMachine},
{TYPE_C_FUNC,ELFM_AUDIO_SUPPORT,AxfElfbSupportsAudio},
{TYPE_C_FUNC,ELFM_CHECK_AUDIO_SUPPORT,AxfElfbCheckAudioSupport},
{TYPE_C_FUNC,ELFM_DEMOMODE,AxfElfbDemoMode},
{TYPE_C_FUNC,ELFM_NEWUSER,AxfElfbNewUser},
{TYPE_C_FUNC,ELFM_VALID_COMMAND_NAME_,AxfValidCmdName},
{TYPE_C_FUNC,ELFM_CURRENT_DIR_,AxfCurrDir},
{TYPE_C_FUNC,ELFM_CURRENT_TIME_,AxfCurrentTime},
{TYPE_C_FUNC,ELFM_CURRENT_WINDOW_NUM_,AxfElfbCurWindow},
{TYPE_C_FUNC,ELFM_CURRENT_WIN_TITLE_,AxfElfbWinTitle},
{TYPE_C_FUNC,ELFM_CUSTOM_DIRECTORY_,AxfGetCustomDir},
{TYPE_C_FUNC,ELFM_DATE_FORMAT_,AxfFormatDate},
{TYPE_C_FUNC,ELFM_DEFINE_ERROR_MESSAGE,AxfDefErrStr},
{TYPE_C_FUNC,ELFM_DELAY,AxfDelay},
{TYPE_C_FUNC,ELFM_DELETE_FILE,AxfElfbDelete},
{TYPE_C_FUNC,ELFM_DELETE_RECURSIVE,AxfRecursiveDelete},
{TYPE_C_FUNC,ELFM_DELETE_DIRECTORY,AxfDeleteDir},
{TYPE_C_FUNC,ELFM_DOWNCASE,AxfDnCase},
{TYPE_C_FUNC,ELFM_DTMOD_OF_FILE,AxfGetDtmod},
{TYPE_C_FUNC,ELFM_EDIT_ICON_,AxfElfbEditIcon},
{TYPE_C_FUNC,ELFM_COLOR_STATE_,AxfElfbColorState},
{TYPE_C_FUNC,ELFM_UPDATE_BITMAP_,AxfElfbUpdateBitmap},
{TYPE_C_FUNC,ELFM_LOAD_BITMAP_,AxfElfbLoadBitmap},
{TYPE_C_FUNC,ELFM_ELF_GET_IPC,OBSOLETE},
{TYPE_C_FUNC,ELFM_ELF_GET_LIVE_DATA,AxfElfbGetLiveData},
{TYPE_C_FUNC,ELFM_ELF_SEND_IPC,AxfElfbSendMesToApp},
{TYPE_C_FUNC,ELFM_END_LEARN_MODE,AxfElfbEndLearn},
{TYPE_C_FUNC,ELFM_ERROR,AxfError},
{TYPE_C_FUNC,ELFM_REERROR,AxfElfbReAbort},
{TYPE_C_FUNC,ELFM_ERROR_BOX,AxfErrorBox},
{TYPE_C_FUNC,ELFX_ERROR_NUMBER,AxfErrNum},
{TYPE_C_FUNC,ELFX_ERROR_STRING,AxfErrStr},
{TYPE_C_FUNC,ELFX_ERROR_OBJECT,AxfErrObject},
{TYPE_C_FUNC,ELFX_ERROR_LINE,AxfErrLine},
{TYPE_C_FUNC,ELFX_ERROR_FILE,AxfErrFile},
{TYPE_C_FUNC,ELFX_CURLINE,AxfElfbCurLineInfo},
{TYPE_C_FUNC,ELFM_EXIT,AxfElfbExit},
{TYPE_C_FUNC,ELFM_FETCH_CLIPBOARD_AND_RUN_,AxfElfbFetchAndRun},
{TYPE_C_FUNC,ELFM_FILE_SIZE_,AxfGetFilesize},
{TYPE_C_FUNC,ELFM_FILE_EXECUTABLE_,AxfFileExecutable},
{TYPE_C_FUNC,ELFM_VFY_FILE_EXISTS_,AxfVfyFileExists},
{TYPE_C_FUNC,ELFM_FILE_EXISTS_,AxfFileExists},
{TYPE_C_FUNC,ELFM_DIR_EXISTS_,AxfElfbDirExists},
{TYPE_C_FUNC,ELFM_FILE_SAVED_,AxfFileSavedNotify},
{TYPE_C_FUNC,ELFM_FILE_READABLE_,AxfFileReadable},
{TYPE_C_FUNC,ELFM_FILE_WRITEABLE_,AxfElfbFileWritable},
{TYPE_C_FUNC,ELFM_FILING_QUERY_,AxfFSQuery},
{TYPE_C_FUNC,ELFM_FIND_ELF_FILE_,AxfFindElfFile},
{TYPE_C_FUNC,ELFM_FORMAT_,AxfFormat},
{TYPE_C_FUNC,ELFM_COMPOSE_STRING_,AxfElfbCompose_String},
{TYPE_C_FUNC,ELFM_FULL_PATHNAME_,AxfFullPathname},
{TYPE_C_FUNC,ELFM_FUNCTION_INSTALLED_,OBSOLETE},
{TYPE_C_FUNC,ELFM_GETENV_,AxfGetenv},
{TYPE_C_FUNC,ELFM_GET_BLUE_TIME,AxfGetBluTime},
{TYPE_C_FUNC,ELFM_ENCRYPT_TIME,AxfEncryptTime},
{TYPE_C_FUNC,ELFM_GET_FKEY_NAME,AxfElfbGetKeyName},
{TYPE_C_FUNC,ELFM_GET_HELP_DATA_,AxfGetHelp},
{TYPE_C_FUNC,ELFM_GET_KEY_CODE_,AxfGetKeyCode},
{TYPE_C_FUNC,ELFM_OBSOLETE1_,OBSOLETE},
{TYPE_C_FUNC,ELFM_GET_PACKAGE_LIST,AxfElfbListPackages},
{TYPE_C_FUNC,ELFM_GET_TEMPFILENAME,AxfMk1TempName},
{TYPE_C_FUNC,ELFM_GE_CREATE_QUIET_,AxfElfbGEQuietCreate},
{TYPE_C_FUNC,ELFM_GE_IMG_,AxfElfbImageFromGE},
{TYPE_C_FUNC,ELFM_GE_OPEN_QUIET_,AxfElfbGEQuietOpen},
{TYPE_C_FUNC,ELFM_HAVE_HELP_,AxfElfbHelpAvailable},
{TYPE_C_FUNC,ELFX_SET_HELP,AxfSetHelp},
{TYPE_C_FUNC,ELFX_HELPFILE,AxfHelpFile},
{TYPE_C_FUNC,ELFX_XKEYDEF,AxfElfbSetXKey},
{TYPE_C_FUNC,ELFX_DBLIST,AxfElfbDBList},
{TYPE_C_FUNC,ELFX_XKEYS,AxfElfbGetXKeys},
{TYPE_C_FUNC,ELFM_OBSOLETE2_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE3_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE4_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE5_,OBSOLETE},
{TYPE_C_FUNC,ELFM_INIT_FINI_,AxfElfbDoneInit},
{TYPE_C_FUNC,ELFM_INT,AxfInt},
{TYPE_C_FUNC,ELFM_IN_LEARN_MODE,AxfInLearn},
{TYPE_C_FUNC,ELFM_IS_ELFRT,AxfIsElfrt},
{TYPE_C_FUNC,ELFM_IS_MAILRT,AxfIsMailrt},
{TYPE_C_FUNC,ELFM_IS_ARRAY,AxfElfbIsArray},
{TYPE_C_FUNC,ELFM_IS_FUNCTION_,AxfIsFunc},
{TYPE_C_FUNC,ELFM_IS_NULL,AxfElfbIsNull},
{TYPE_C_FUNC,ELFM_IS_NUMBER,AxfElfbIsNumber},
{TYPE_C_FUNC,ELFM_IS_STRING,AxfElfbIsString},
{TYPE_C_FUNC,ELFM_KILL_TASK_,AxfElfbKillTask},
{TYPE_C_FUNC,ELFM_LEN,AxfStrlen},
{TYPE_C_FUNC,ELFM_LIFT_DLG_CURSOR_,AxfDlgLiftCursor},
{TYPE_C_FUNC,ELFM_LIST_OF_GLOBALS_,AxfFuncList},
{TYPE_C_FUNC,ELFM_LIST_OF_WINDOWS_,AxfElfbWindowList},
{TYPE_C_FUNC,ELFM_LOADPACK_,AxfElfbInstall},
{TYPE_C_FUNC,ELFM_COMPILE_BUF_,AxfCompileArray},
{TYPE_C_FUNC,ELFM_LOAD_BINARY_,AxfElfbInstallBinary},
{TYPE_C_FUNC,ELFM_LOG,AxfNlog},
{TYPE_C_FUNC,ELFM_LOG10,Axflog10},
{TYPE_C_FUNC,ELFM_LOGOUT_,AxfLogout},
{TYPE_C_FUNC,ELFM_MACRO_PARENT_TASK,AxfTaskMaster},
{TYPE_C_FUNC,ELFM_SET_MACRO_PARENT_TASK,AxfElfbSetTaskMaster},
{TYPE_C_FUNC,ELFM_MAKE_FILE_WRITEABLE_,AxfMakeFileWriteable},
{TYPE_C_FUNC,ELFM_MAKE_STR_FOR_LEXOR,OBSOLETE},
{TYPE_C_FUNC,ELFM_MAKE_TEMPFILENAME,AxfMkTempName},
{TYPE_C_FUNC,ELFM_MAP_ICON_CURSOR_,AxfElfbMapCursor},
{TYPE_C_FUNC,ELFM_MAX_STRLEN_,AxfMaxStrlen},
{TYPE_C_FUNC,ELFM_MINI_DEMO_,AxfElfbMiniDemo},
{TYPE_C_FUNC,ELFM_MOVE_FILE_,AxfMoveFile},
{TYPE_C_FUNC,ELFM_NEWTASK_BY_NAME_,AxfNewTaskWithArgs},
{TYPE_C_FUNC,ELFM_PROC,AxfElfbProc},
{TYPE_C_FUNC,ELFM_PPROC,AxfPProc},
{TYPE_C_FUNC,ELFM_NEW_NAMER_,AxfGenSafeName},
{TYPE_C_FUNC,ELFM_NORML_KEY_ACCEL_,AxfNormlKeySeq},
{TYPE_C_FUNC,ELFM_NUM_TO_STR_,AxfNumToStr},
{TYPE_C_FUNC,ELFM_OPEN_DOC_,AxfOpenDoc},
{TYPE_C_FUNC,ELFM_OPEN_FILE,AxfOpenFile},
{TYPE_C_FUNC,ELFM_PEND_FOR_NEWTASK_BY_NAME_,AxfPendForNewTaskWithArgs},
{TYPE_C_FUNC,ELFM_PK_,AxfElfbPick},	/* in tmsim.c */
{TYPE_C_FUNC,ELFM_POKE_DLGS_,AxfElfbPokeDialogs},
{TYPE_C_FUNC,ELFM_PRINT_FILE_,OBSOLETE},
{TYPE_C_FUNC,ELFM_GET_PAGE_INFO,AxfGetPageInfo},
{TYPE_C_FUNC,ELFM_PRINT_XDOC_,OBSOLETE},
{TYPE_C_FUNC,ELFM_PROFILE_,AxfProfile},
{TYPE_C_FUNC,ELFM_PROFILE_N_,AxfProfileByCode},
{TYPE_C_FUNC,ELFM_PROMOTE_DIALOG_,AxfElfbPromoteDlg},
{TYPE_C_FUNC,ELFM_PROMOTED_DIALOG_ID_,AxfElfbPromotedDlgID},
{TYPE_C_FUNC,ELFM_QA_MODE_,AxfElfbIsQAmode},
{TYPE_C_FUNC,ELFM_RANDOM_,AxfRand},
{TYPE_C_FUNC,ELFM_RANDOM_SEED_,AxfSeedRand},
{TYPE_C_FUNC,ELFM_REV32,AxfREV32},
{TYPE_C_FUNC,ELFM_READ_ASCII_FILE_,AxfElfbReadFile},
{TYPE_C_FUNC,ELFM_READ_BIG_FILE_,AxfReadBigFile},
{TYPE_C_FUNC,ELFM_READ_ELF_DATA_FILE_,AxfElfbReadDataFile},
{TYPE_C_FUNC,ELFM_READ_FILE,AxfReadLine},
{TYPE_C_FUNC,ELFM_RUN_AED_,AxfAed},
{TYPE_C_FUNC,ELFM_SELECT_WINDOW,AxfElfbMkWinActive},	/* records itself */
{TYPE_C_FUNC,ELFM_SET_CURRENT_DIR_,AxfSetCurrDir},
{TYPE_C_FUNC,ELFM_SET_FREE_RUNNING,AxfElfbFreeRun},
{TYPE_C_FUNC,ELFM_SET_HELP_MODE_,AxfElfbSetHelpMode},
{TYPE_C_FUNC,ELFM_SET_LIVE_INPUT_MODE,AxfElfbSetLiveMode},
{TYPE_C_FUNC,ELFM_OBSOLETE6_,OBSOLETE},
{TYPE_C_FUNC,ELFM_SET_RUN_TIMER,AxfElfbRunMode},
{TYPE_C_FUNC,ELFM_SET_SELECTIONS_,AxfSelections},
{TYPE_C_FUNC,ELFM_SET_SERVICES_,AxfSetServices},
{TYPE_C_FUNC,ELFM_SET_SUBSTR_,AxfSetSubstr},
{TYPE_C_FUNC,ELFM_SET_SYSVAR_,AxfElfbSetSysVar},
{TYPE_C_FUNC,ELFM_SET_WIDGET_PROFILE_,AxfElfbWidgetProfile},
{TYPE_C_FUNC,ELFM_SET_COLORS_,AxfWidgetColorsFromProfile},
{TYPE_C_FUNC,ELFM_SHELL_COMMAND,AxfShcmd},
{TYPE_C_FUNC,ELFX_SHELL_WIN,AxfShWin},
{TYPE_C_FUNC,ELFX_SHELL_XTERM,AxfShXterm},
{TYPE_C_FUNC,ELFM_SIN,AxfSin},
{TYPE_C_FUNC,ELFM_SORT_,AxfSort},
{TYPE_C_FUNC,ELFM_SORT_INDEXED_,AxfSortIndexed},
{TYPE_C_FUNC,ELFM_SPLIT_PATHNAME_,AxfSplitPath},
{TYPE_C_FUNC,ELFM_SQR,Axfsqrt},
{TYPE_C_FUNC,ELFM_START_LEARN_MODE,AxfElfbStartLearn},
{TYPE_C_FUNC,ELFM_START_NEW_AE_,AxfNewAE},
{TYPE_C_FUNC,ELFM_START_NEW_DC_,AxfNewDC},
{TYPE_C_FUNC,ELFM_START_NEW_GE_,AxfNewGE},
{TYPE_C_FUNC,ELFM_START_NEW_HLP_,AxfNewHLP},
{TYPE_C_FUNC,ELFM_START_NEW_SS_,AxfNewSS},
{TYPE_C_FUNC,ELFM_STATUS_MESSAGE,AxfElfbStatusMessage},
{TYPE_C_FUNC,ELFM_STRING_INDEX,AxfStrIndex},
{TYPE_C_FUNC,ELFM_STR_TO_NUM_,AxfStrToNum},
{TYPE_C_FUNC,ELFM_ST_,AxfElfbStroke},	/* in tmsim.c */
{TYPE_C_FUNC,ELFM_SUBSTR,AxfSubstr},
{TYPE_C_FUNC,ELFM_SUPPRESS_DISPLAY_,AxfSuppressDisplay},
{TYPE_C_FUNC,ELFM_SUPPRESS_ERRORS_,AxfSuppressErrsDisplay},
{TYPE_C_FUNC,ELFM_SYSMODE_,AxfSysMode},
{TYPE_C_FUNC,ELFM_SYSTEM_DIRECTORY_,AxfGetDataDir},
{TYPE_C_FUNC,ELFM_FILTER_DIR_,AxfGetFilterDir},
{TYPE_C_FUNC,ELFM_AXLANG_DIR_,AxfGetAxLangDir},
{TYPE_C_FUNC,ELFM_AXLOCAL_LANG_DIR_,AxfGetAxLocalLangDir},
{TYPE_C_FUNC,ELFM_SYSVAR_,AxfElfbGetSysVar},
{TYPE_C_FUNC,ELFM_T2SP_,AxfTabsToSpaces},
{TYPE_C_FUNC,ELFM_TASK_LIST_,AxfListTasks},
{TYPE_C_FUNC,ELFM_TEMP_DIRECTORY_,AxfGetTempDir},
{TYPE_C_FUNC,ELFM_TEXT_DICT_ADD_WORD,AxfElfbTextDictAddWord},
{TYPE_C_FUNC,ELFM_TEXT_DICT_GET_WORDS,AxfElfbTextDictGetWords},
{TYPE_C_FUNC,ELFM_TEXT_DICT_REMOVE_WORD,AxfElfbTextDictRemoveWord},
{TYPE_C_FUNC,ELFM_TEXT_DICT_CAN_ADD,AxfElfbTextDictCanAdd},
{TYPE_C_FUNC,ELFM_TEXT_DICT_CLOSE,AxfElfbTextDictClose},
{TYPE_C_FUNC,ELFM_TEXT_DICT_CREATE,AxfElfbTextDictCreate},
{TYPE_C_FUNC,ELFM_TEXT_GET_LANGUAGE_CODE,AxfElfbTextGetLanguageCode},
{TYPE_C_FUNC,ELFM_TEXT_GET_LANGUAGE_NAME,AxfElfbTextGetLanguageName},
{TYPE_C_FUNC,ELFM_TEXT_HYPHENATE,AxfElfbTextHyphenate},
{TYPE_C_FUNC,ELFM_TEXT_SPELLED_CORRECTLY,AxfElfbTextSpelledCorrectly},
{TYPE_C_FUNC,ELFM_TEXT_SPELLER_CLOSE,AxfElfbTextSpellerClose},
{TYPE_C_FUNC,ELFM_TEXT_SPELLER_CURR_LANGUAGE,AxfElfbTextSpellerCurrLanguage},
{TYPE_C_FUNC,ELFM_TEXT_SPELLER_HYPHENATION_OK,AxfElfbTextSpellerHyphenationOK},
{TYPE_C_FUNC,ELFM_TEXT_SPELLER_LANGUAGE_OK,AxfElfbTextSpellerLanguageOK},
{TYPE_C_FUNC,ELFM_TEXT_SPELLER_THESAURUS_OK,AxfElfbTextSpellerThesaurusOK},
{TYPE_C_FUNC,ELFM_TEXT_SPELLING_ALTERNATIVES,AxfElfbTextSpellingAlternatives},
{TYPE_C_FUNC,ELFM_TEXT_SPELLING_ERRORS,AxfElfbTextSpellingErrors},
{TYPE_C_FUNC,ELFM_TEXT_SPELLING_INFO,AxfElfbTextSpellingInfo},
{TYPE_C_FUNC,ELFM_TEXT_THESAURUS,AxfElfbTextThesaurus},
{TYPE_C_FUNC,ELFM_TEXT_THESAURUS_CLOSE,AxfElfbTextThesaurusClose},
{TYPE_C_FUNC,ELFM_TEXT_THESAURUS_INFO,AxfElfbTextThesaurusInfo},
{TYPE_C_FUNC,ELFM_TO_DC_,AxfElfbImportAscii},
{TYPE_C_FUNC,ELFM_TO_SS_,AxfElfbImportSS},
{TYPE_C_FUNC,ELFM_TRIM,AxfTrim},
{TYPE_C_FUNC,ELFM_TRUNC_ARRAY,AxfTruncArray},
{TYPE_C_FUNC,ELFM_MAKE_ENTRY_,AxfMakeEntryLink},
{TYPE_C_FUNC,ELFM_STR_ENTRY_,AxfNameFromEntry},
{TYPE_C_FUNC,ELFM_IS_ENTRY_,AxfElfbIsEntry},
{TYPE_C_FUNC,ELFM_DUMPNAMES,AxfDumpElfSymNames},
{TYPE_C_FUNC,ELFM_TST_,AxfElfbTest},
{TYPE_C_FUNC,ELFM_UPCASE,AxfUpCase},
{TYPE_C_FUNC,ELFM_USER_DIRECTORY_,AxfGetUserDir},
{TYPE_C_FUNC,ELFM_AXHOME_DIRECTORY_,AxfGetAxHomeDir},
{TYPE_C_FUNC,ELFM_VALID_DOC_NAME_,AxfValDocName},
{TYPE_C_FUNC,ELFM_VERIFY_NAME_,AxfElfValidName},
{TYPE_C_FUNC,ELFM_WAIT_WHILE_BUSY,AxfFRwait},
{TYPE_C_FUNC,ELFM_WINDOW_INFO,AxfElfbWindowInfo},
{TYPE_C_FUNC,ELFM_WIN_POS_,AxfWindowPos},
{TYPE_C_FUNC,ELFM_WRITE_ASCII_FILE_,AxfWriteFile},
{TYPE_C_FUNC,ELFM_WRITE_BIG_FILE_,AxfWriteBigFile},
{TYPE_C_FUNC,ELFM_WRITE_ELF_DATA_FILE_,AxfElfbWriteDataFile},
{TYPE_C_FUNC,ELFM_WRITE_FILE,AxfWriteLine},
{TYPE_C_FUNC,ELFM_WIDGET_,AxfElfbCreateChangeWidget},
{TYPE_C_FUNC,ELFM_XDLG_CEN_,AxfElfbGetActiveWidgetFromElf},
{TYPE_C_FUNC,ELFM_XDLG_CHS_,AxfElfbCreateChoiceMenu},
{TYPE_C_FUNC,ELFM_XDLG_CRT_,AxfElfbCreateDialog},
{TYPE_C_FUNC,ELFM_XDLG_DBT_,AxfElfbDefaultButtons},
{TYPE_C_FUNC,ELFM_XDLG_DST_,AxfElfbDestroyWidget},
{TYPE_C_FUNC,ELFM_XDLG_EBDEL_,AxfElfbDelEditBoxData},
{TYPE_C_FUNC,ELFM_XDLG_EBGET_,AxfElfbGetEditBoxData},
{TYPE_C_FUNC,ELFM_XDLG_EBGETSELREG_, AxfElfbGetEditBoxSelectedRegion},
{TYPE_C_FUNC,ELFM_XDLG_EBMARKREG_,AxfElfbMarkEditBoxRegion},
{TYPE_C_FUNC,ELFM_XDLG_EBINS_,AxfElfbInsEditBoxData},
{TYPE_C_FUNC,ELFM_XDLG_EBEDITED_,AxfElfbEditBoxEdited},
{TYPE_C_FUNC,ELFM_XDLG_EBCUT_,AxfElfbCutEditBoxSeln},
{TYPE_C_FUNC,ELFM_XDLG_EBCOPY_,AxfElfbCopyEditBoxSeln},
{TYPE_C_FUNC,ELFM_XDLG_EBPASTE_,AxfElfbPasteEditBoxSeln},
{TYPE_C_FUNC,ELFM_XDLG_EBRESET_,AxfAxXmEditBoxResetEdited},
{TYPE_C_FUNC,ELFM_XDLG_ENT_,AxfElfbEntryFieldCreate},
{TYPE_C_FUNC,ELFM_XDLG_EVL_,AxfElfbEntryValue},
{TYPE_C_FUNC,ELFM_XDLG_FIX_,AxfElfbFixupQuirks},
{TYPE_C_FUNC,ELFM_XDLG_KIL_,AxfElfbDialogDestroy},
{TYPE_C_FUNC,ELFM_XDLG_MBR_,AxfElfbCreateDlgMenuBar},
{TYPE_C_FUNC,ELFM_XDLG_UPDATE_,AxfElfbUpdateDialog},
{TYPE_C_FUNC,ELFM_XDLG_UPDATE_SIZE_,AxfElfbUpdateDialogSize},
{TYPE_C_FUNC,ELFM_XDLG_RAD_,AxfElfbRadioBoxCreate},
{TYPE_C_FUNC,ELFM_XDLG_REBLD_,AxfElfbRebuildDialog},
{TYPE_C_FUNC,ELFM_XDLG_SEN_,AxfElfbSetActiveWidget},
{TYPE_C_FUNC,ELFM_XDLG_SHOW_,AxfElfbShowDialog},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_,AxfElfbTableData},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_NEW_DATA_,AxfElfbTableNewData},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_GET_DATA_,AxfElfbGetTableData},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_SET_SELECTIONS_,AxfElfbSetTableSelections},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_CLEAR_DATA_,AxfElfbClearTableData},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_GET_SELECTIONS_,AxfElfbGetTableSelections},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_ALLOW_EDITING_, AxfElfbAllowTableEditing},
{TYPE_C_FUNC,ELFM_XDLG_TABLE_DATA_REQUEST_MODEL_,AxfElfbDataRequestModel},
{TYPE_C_FUNC,ELFM_XDLG_MCALLBACK_,AxfElfbMenuCallback},
{TYPE_C_FUNC,ELFM_XFER_SAFE_,AxfElfbXferSafe},
{TYPE_C_FUNC,ELFM_XLATE_GOTHIC,AxfXlateGothic},
{TYPE_C_FUNC,ELFM_DLG_LEARN,AxfElfRecord},
{TYPE_C_FUNC,ELFM_PRTR_FILE_,OBSOLETE},
{TYPE_C_FUNC,ELFM_TUTOR_DISP_,AxfDispTutor},
{TYPE_C_FUNC,ELFM_REPAINT_ALL,AxfAxRePaintAll},
{TYPE_C_FUNC,ELFM_METRIC,AxfIsMetric},
{TYPE_C_FUNC,ELFM_I2IN,AxfI2IN},
{TYPE_C_FUNC,ELFM_I2CM,AxfI2CM},
{TYPE_C_FUNC,ELFM_VFY_MENU,AxfVfyMenu},
{TYPE_C_FUNC,ELFM_ISBIN,AxfElfbIsBinary},
{TYPE_C_FUNC,ELFM_BINSIZ,AxfElfbBinarySize},
{TYPE_C_FUNC,ELFM_READBIN,AxfReadBinaryFile},
{TYPE_C_FUNC,ELFM_WRTBIN,AxfElfbWriteBinaryFile},
{TYPE_C_FUNC,ELFM_BIN2ARR,AxfBinaryToArray},
{TYPE_C_FUNC,ELFM_ARR2BIN,AxfArrayToBinary},
{TYPE_C_FUNC,ELFM_BINBYTE,AxfBinaryByte},
{TYPE_C_FUNC,ELFM_DECOMPOSE,AxfElfbDecomposeFile},
{TYPE_C_FUNC,ELFM_AXNET,AxfAxNet},
{TYPE_C_FUNC,ELFM_SOCKSERV,AxfElfbServer},
{TYPE_C_FUNC,ELFM_SOCKCLI,AxfElfbClient},
{TYPE_C_FUNC,ELFM_SOCKREAD,AxfElfbSockRead},
{TYPE_C_FUNC,ELFM_SOCKRPCREAD,AxfElfbSockRPCRead},
{TYPE_C_FUNC,ELFM_SOCKWRT,AxfElfbSockWrite},
{TYPE_C_FUNC,ELFM_SOCKRPCWRT,AxfElfbSockRPCWrite},
{TYPE_C_FUNC,ELFM_SOCKBREAD,AxfElfbSockReadBinary},
{TYPE_C_FUNC,ELFM_SOCKBWRT,AxfElfbSockWriteBinary},
{TYPE_C_FUNC,ELFM_SOCKRPC_ACCEPT,AxfElfbRPCAccept},
{TYPE_C_FUNC,ELFM_SOCKRPC_RESPOND,AxfElfbRPCRespond},
{TYPE_C_FUNC,ELFM_SOCKRPC_ERR_RESPOND,AxfElfbRPCErrRespond},
{TYPE_C_FUNC,ELFM_SOCKCLOSE,AxfElfbSockClose},
{TYPE_C_FUNC,ELFM_SOCKCHANCLOSE,AxfElfbChanClose},
{TYPE_C_FUNC,ELFM_OPENMAIL,AxfElfbOpenMail},
{TYPE_C_FUNC,ELFM_PARSEDATE,AxfParseDate},
{TYPE_C_FUNC,ELFM_IS_ASCII,AxfElfbIsLikeAscii},
{TYPE_C_FUNC,ELFM_LOCK_RESOURCE,AxfAxLockResource},
{TYPE_C_FUNC,ELFM_UNLOCK_RESOURCE,AxfAxUnlockResource},
{TYPE_C_FUNC,ELFM_HAS_UNREAD_MAIL,AxfElfbHasUnreadMail},
{TYPE_C_FUNC,ELFM_FORMAT_MAIL_ITEM,AxfElfbFormatMailItem},
{TYPE_C_FUNC,ELFM_DATE_ARRAY,AxfElfbDayArray},
{TYPE_C_FUNC,ELFM_MAKE_RAND_KEY,AxfElfbMkRandKey},
{TYPE_C_FUNC,ELFM_ENCRYPT_STRING,AxfElfbEncryptString},
{TYPE_C_FUNC,ELFM_AUDIO,AxfElfbAudio},
{TYPE_C_FUNC,ELFM_LOCALIZE_SS,AxfElfbLocalizeSS},
{TYPE_C_FUNC,ELFM_CRTTEMP_,AxfCreateTempfile},
{TYPE_C_FUNC,ELFM_ASTERMENU,AxfXmNewStarMenu},
{TYPE_C_FUNC,ELFM_TOGGLE_APP_TOOLBAR,AxfTmToggleToolBar},
{TYPE_C_FUNC,ELFM_TOGGLE_DLG_TOOLBAR,AxfElfbToggleToolBar},
{TYPE_C_FUNC,ELFM_TOOLBAR_STATUS_,AxfElfbToolBarStatus},
{TYPE_C_FUNC,ELFM_CHMOD_ABSOLUTE,AxfChmodAbsolute},
{TYPE_C_FUNC,ELFM_RECOGNIZE_FILE_,AxfElfbRecognizeFile},
{TYPE_C_FUNC,ELFM_FORMAT_ARRAY_,AxfFormatArray},
{TYPE_C_FUNC,ELFM_IS_UUENCODED_,AxfIsUUEncoded},
{TYPE_C_FUNC,ELFM_RING_THE_BELL_,AxfRingTheBell},
{TYPE_C_FUNC,ELFM_USER_NAME_,AxfUserName},
{TYPE_C_FUNC,ELFM_NEW_MAIL_COUNT_,AxfElfbNewMailCount},
{TYPE_C_FUNC,ELFM_GET_REFS_,AxfElfbFetchRefs},
{TYPE_C_FUNC,ELFM_RUN_PROG_,AxfRunProgram},
{TYPE_C_FUNC,ELFM_RUN_PROG_NOPEND_,AxfRunBatchProgram},
{TYPE_C_FUNC,ELFM_RUN_PROGIN_,AxfRunStdinProgram},
{TYPE_C_FUNC,ELFM_RUN_PROGIN_NOPEND_,AxfRunStdinBatchProgram},
{TYPE_C_FUNC,ELFM_RUN_PROG_PID_,AxfRunProgramPid},
{TYPE_C_FUNC,ELFM_DATE_PARTS_,AxfDatePieces},
{TYPE_C_FUNC,ELFM_SET_MENUBAR_,AxfElfbPrivateMenuBar},
{TYPE_C_FUNC,ELFM_GET_KS_,AxfElfbGetInKS},
{TYPE_C_FUNC,ELFM_PUT_KS_,AxfElfbPutToKS},
{TYPE_C_FUNC,ELFM_SET_SEL_,AxfElfbSetSelection},
{TYPE_C_FUNC,ELFM_GET_SEL_,AxfElfbGetSelection},
{TYPE_C_FUNC,ELFM_GET_XID_,AxfElfbXwinOfWin},
{TYPE_C_FUNC,ELFM_SEL_XID_,AxfElfbSelByXId},
{TYPE_C_FUNC,ELFM_NOWINS_,AxfNoMapWindowsFlag},
{TYPE_C_FUNC,ELFM_OBSOLETE7_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE8_,OBSOLETE},
{TYPE_C_FUNC,ELFM_VIW_RST_,AxfViewRest},
{TYPE_C_FUNC,ELFM_VIW_ONL_,AxfViewOnly},
{TYPE_C_FUNC,ELFM_UNIX_FS_,AxfUnixFileSystem},	/* !!cvt from 3.0 */
{TYPE_C_FUNC,ELFM_XDLG_GET_FONT_FAMILIES_,AxfElfbGetFontFamilies},
{TYPE_C_FUNC,ELFM_TIMER_,AxfAxTimer},
{TYPE_C_FUNC,ELFM_SEND_MES_,AxfElfbSendElfData},
{TYPE_C_FUNC,ELFM_QRY_MES_,AxfElfbSendAndAckElfData},
{TYPE_C_FUNC,ELFM_RSP_MES_,AxfElfbRespondElf},
{TYPE_C_FUNC,ELFM_RSP_ERR_,AxfElfbRespondElfErr},
{TYPE_C_FUNC,ELFM_GET_MES_,AxfElfbWaitForMessage},
{TYPE_C_FUNC,ELFM_WP_CALL_,AxfElfbWpCall},
{TYPE_C_FUNC,ELFM_SS_CALL_,ElfbSSCall},
{TYPE_C_FUNC,ELFM_GET_PRINTER_TYPES_,AxfElfbGetPrinterTypes},
{TYPE_C_FUNC,ELFM_TASK_ID_,AxfTaskId},
{TYPE_C_FUNC,ELFM_LOAD_GADGET_,AxfElfbDEloadNewGadget},
{TYPE_C_FUNC,ELFM_DE_EDIT_,AxfElfbDEeditWidget},
{TYPE_C_FUNC,ELFM_DE_EDIT_SESSION_,AxfElfbDEeditSession},
{TYPE_C_FUNC,ELFM_DE_READ_DATA_,AxfElfbDEreadData},
{TYPE_C_FUNC,ELFM_PARENT_,AxfParentTask},
{TYPE_C_FUNC,ELFM_OBJ_CREATE_,AxfElfbCreateObject},
{TYPE_C_FUNC,ELFM_OBJ_CREATE_QUERY_METHOD_,AxfElfbObjCrtQueryMethod},
{TYPE_C_FUNC,ELFM_OBJ_CREATE_CHANGE_METHOD_,AxfElfbObjCrtChangeMethod},
{TYPE_C_FUNC,ELFM_OBJ_CREATE_LOCAL_DATA_,AxfElfbObjCrtLocalData},
{TYPE_C_FUNC,ELFM_OBJ_LOAD_IMAGE_,AxfElfbObjLoadImage},
{TYPE_C_FUNC,ELFM_OBJ_INFO,AxfElfbObjInfo},
{TYPE_C_FUNC,ELFM_IS_OBJECT,AxfElfbIsObject},
{TYPE_C_FUNC,ELFM_OBJ_EXISTS,AxfElfbObjectExists},
{TYPE_C_FUNC,ELFM_DATA_TYPE,AxfElfbDataType},
{TYPE_C_FUNC,ELFM_UNIX_PID_,AxfProcessId},
{TYPE_C_FUNC,ELFM_PRINTF_,AxfElfbPrintf},
{TYPE_C_FUNC,ELFM_WRITE_APP_,AxfElfbWriteAppFile},
{TYPE_C_FUNC,ELFM_READ_APP_,AxfElfbReadAppFile},
{TYPE_C_FUNC,ELFM_FUNCS_IN_OBJECT_,AxfElfbFuncsInObject},
{TYPE_C_FUNC,ELFM_DRAW_,AxfElfbDraw},
{TYPE_C_FUNC,ELFM_DEBUG_,AxfElfbDebugFuncs},
{TYPE_C_FUNC,ELFM_XDLG_TBL_FUNCS_,  AxfElfbTblFuncs},
{TYPE_C_FUNC,ELFM_XDLG_ENTER_FUNCS_,AxfElfbEnterFuncs},
{TYPE_C_FUNC,ELFM_IS_NT_,AxfIsAXMS},
{TYPE_C_FUNC,ELFM_FREE_NAMED_BITMAP_,AxfFreeNamedBitmap},
{TYPE_C_FUNC,ELFM_FHDR2INFO,AxfInfoFromFileHeader},
{TYPE_C_FUNC,ELFM_INFO2FHDR,AxfFileHeaderFromInfo},
{TYPE_C_FUNC,ELFM_DOC_HAS_LINKS_,AxfDocHasLinks},
{TYPE_C_FUNC,ELFM_DOC_LINKS_GET_INFO_,AxfGetDocLinksInfo},
{TYPE_C_FUNC,ELFM_DOC_LINKS_CHANGE_INFO_,AxfChangeDocLinksInfo},
{TYPE_C_FUNC,ELFM_DOC_LINKS_LOCALIZE_,AxfLocalizeDocLinks},
{TYPE_C_FUNC,ELFM_GET_MAX_FILE_LENGTH_,AxfElfbGetMaxFileLength},
{TYPE_C_FUNC,ELFM_IS_FILE_OPEN_,AxfElfbIsFileOpen},
{TYPE_C_FUNC,ELFM_NOTE_FILE_IN_USE_,AxfNoteFileInUse},
{TYPE_C_FUNC,ELFM_DONE_WITH_FILE_,AxfDoneWithFile},
{TYPE_C_FUNC,ELFM_GET_DISPLAY_WIDTH_,AxfElfbGetDpyWid},
{TYPE_C_FUNC,ELFM_GET_DISPLAY_HEIGHT_,AxfElfbGetDpyHt},
{TYPE_C_FUNC,ELFM_PROFILER_,AxfElfbProfiler},
{TYPE_C_FUNC,ELFM_GET_X_FONT,AxfElfbGetXLFD},
{TYPE_C_FUNC,ELFM_ARRAY_TRANSPOSE,AxfArrayTranspose},
{TYPE_C_FUNC,ELFM_ARRAY_COLUMNS,AxfArrayColumns},
{TYPE_C_FUNC,ELFM_ARRAY_COLUMN,AxfArray1Column},
{TYPE_C_FUNC,ELFM_BECOME_PARASITE,AxfBecomeParasite},
{TYPE_C_FUNC,ELFM_UTIL,AxfUtil},	/* funcs thru switch stmt */
{TYPE_C_FUNC,ELFM_IS_ORIENT,AxfIsOrientBuild},
{TYPE_C_FUNC,ELFM_XDLG_TRAY_FUNCS_, AxfElfbTrayFuncs},
{TYPE_C_FUNC,ELFM_ELF_TREE_FUNCS_,  AxfElfbTreeFuncs},
{TYPE_C_FUNC,ELFM_GET_DLG_FONT_HEIGHT_,AxfElfbGetDlgFontHeight},
{TYPE_C_FUNC,ELFM_LIST_IMAGES_,AxfElfbListImages},
{TYPE_C_FUNC,ELFM_STR_TO_VALUE,AxfStrToValue},
{TYPE_C_FUNC,ELFM_GETHOSTNAME,AxfGetHostname},
{TYPE_C_FUNC,ELFM_TEXT_DICT_GET_LANGUAGE,AxfElfbTextDictLanguage},
{TYPE_C_FUNC,ELFM_GET_DISPLAYVAR_,AxfGetDisplayVar},
{TYPE_C_FUNC,ELFM_XLT_COMPLEX_,AxfXLT_Complex},
{TYPE_C_FUNC,ELFM_USE_WIDE_MENUBAR_EDIT,AxfUseWideMenuBarEdit},
{TYPE_C_FUNC,ELFM_ADDRESSPARSE,AxfElfbAddressParse},
{TYPE_C_FUNC,ELFM_GADG_SIZES_FUNCS_, AxfElfbGadgetSizesFuncs},
{TYPE_C_FUNC,ELFM_RT_READER,AxfRtReader},
{TYPE_C_FUNC,ELFM_AX_STRING_FILE_NAME,AxfAxStringFileName},
{TYPE_C_FUNC,ELFM_TEXT_SIZE,AxfElfbTextSize},
{TYPE_C_FUNC,ELFM_LIST_SCREENFONTS,AxfElfbListScreenfonts},
{TYPE_C_FUNC,ELFM_DE_SCALE_DIALOG,AxfElfbDEscaleDialog},
{TYPE_C_FUNC,ELFM_NORMALIZE_OUT,AxfNormalizeOut},
{TYPE_C_FUNC,ELFM_NORMALIZE_IN,AxfNormalizeIn},
{TYPE_C_FUNC,ELFM_REPLACE_SPACE,AxfElfbReplaceSpace},
{TYPE_C_FUNC,ELFM_DELETE_MESSAGES,AxfElfbDeleteMessages},
{TYPE_C_FUNC,ELFM_GRAPHIC_FUNCTIONS_,AxfElfbGraphicFuncs},
{TYPE_C_FUNC,ELFM_NEW_FILE_PERMISSIONS,AxfNewFilePermissions},
{TYPE_C_FUNC,ELFM_MAIL_BLTINS,AxfElfbMailBltins},
{TYPE_C_FUNC,ELFM_DESTROY_GRAPHIC,AxfElfbDestroyGraphic},
{TYPE_C_FUNC,ELFM_ASSIGN_GRAPHIC,AxfElfbAssignGraphic},
{TYPE_C_FUNC,ELFM_CREATE_GRAPHIC,AxfElfbCreateGraphic},
{TYPE_C_FUNC,ELFM_READ_GRAPHIC_BUFFER,AxfElfbReadGraphicBuffer},
{TYPE_C_FUNC,ELFM_READ_GRAPHIC_FILE,AxfElfbReadGraphicFile},
{TYPE_C_FUNC,ELFM_SS_UTIL,AxfSSUtil},
{TYPE_C_FUNC,ELFM_SS_REGISTER_FUNCS,AxfSSRegisterFunction},
{TYPE_C_FUNC,ELFM_OBSOLETE9_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE10_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE11_,OBSOLETE},
{TYPE_C_FUNC,ELFM_OBSOLETE12_,OBSOLETE},
{TYPE_C_FUNC,ELFM_PAINT_INSOBJ,AxfElfbPaintInsetObject},
{TYPE_C_FUNC,ELFM_NOTE_TASK_INTERESTED,AxfNoteTaskInterested},
{TYPE_C_FUNC,ELFM_DATE_STR_FORMAT_,AxfFormatDate_Str},
{TYPE_C_FUNC,ELFM_OBSOLETE13_,OBSOLETE},
{TYPE_C_FUNC,ELFM_LOCK_FILE,AxfLockFile},
{TYPE_C_FUNC,ELFM_UNLOCK_FILE,AxfUnlockFile},
{TYPE_C_FUNC,ELFM_MAP_DEFAULT_CURSOR,AxfElfbMapDefaultCursor},
{TYPE_C_FUNC,ELFM_LIST_PARASITES,AxfListParasites},
{TYPE_C_FUNC,ELFM_MAPI_FUNCS,AxfElfbMapiFuncs},
{TYPE_C_FUNC,ELFX_ERROR_ELF_OBJECT,AxfErrElfObj},
{TYPE_C_FUNC,ELFX_ERROR_FUNCTION,AxfErrFunc},
{TYPE_C_FUNC,ELFM_START_NEW_GP_,AxfNewGP},
{TYPE_C_FUNC,ELFM_READ_ELF_FILE,AxfReadElfFile},
{TYPE_C_FUNC,ELFM_CLIPART_DIRECTORY_,AxfGetClipArtDir},
{TYPE_C_FUNC,ELFM_LOAD_GRAPHIC_,AxfElfbLoadGraphic},
{TYPE_C_FUNC,ELFM_FILTER_WP_TO_ASCII_LAYOUT,AxfFilterWpToAsciiLayout},
{TYPE_C_FUNC,ELFM_WRITE_GRAPHIC_BUFFER_,AxfElfbWriteGraphicBuffer},
{TYPE_C_FUNC,ELFM_WRITE_GRAPHIC_FILE_,AxfElfbWriteGraphicFile},
{TYPE_C_FUNC,ELFM_GET_GRAPHIC_,AxfElfbGetGraphic},
{TYPE_C_FUNC,ELFM_APP_IS_SS_, AxfAppIsSS},
{TYPE_C_FUNC,ELFM_JULIANDATE,AxfJulianDate},
{TYPE_C_FUNC,ELFM_APP_IS_DATA_,AxfAppIsData},
{TYPE_C_FUNC,ELFM_IS_TASK_,AxfIsTask},
{TYPE_C_FUNC,ELFM_PROMOTE_WINDOW_,AxfElfbPromoteWindow},
{TYPE_C_FUNC,ELFM_IS_FILE_LOCKED_,AxfElfbIsFileLocked},
{TYPE_C_FUNC,ELFM_NEWDEAMON_BY_NAME_,AxfNewDeamonWithArgs},
{TYPE_C_FUNC,ELFM_READ_RASTER_INFO,AxfElfbReadRasterInfo},
{TYPE_C_FUNC,ELFM_UPDATE_CURSOR_FILE,AxfElfbReadCustomCursors},
{TYPE_C_FUNC,ELFM_AXLANG_DEMOS_DIR_,AxfGetAxLangDemosDir},
{TYPE_C_FUNC,ELFM_UNIX_UID_,AxfUserId},
{TYPE_C_FUNC,ELFM_SS_FUNCS,AxfSSFuncs},	/* funcs thru switch stmt */
{TYPE_C_FUNC,ELFM_START_NEW_HTML_,AxfNewHTML},
{TYPE_C_FUNC,ELFM_COLOR_TEMP_DIRECTORY_,AxfGetPresColorDir},
{TYPE_C_FUNC,ELFM_MONO_TEMP_DIRECTORY_,AxfGetPresMonoDir},
{TYPE_C_FUNC,ELFM_BKLIT_TEMP_DIRECTORY_,AxfGetPresBklitDir},
{TYPE_C_FUNC,ELFM_GET_TEMP_DIRECTORY_,AxfGetPresTemplateDir},
{TYPE_C_FUNC,ELFM_SET_TEMP_DIRECTORY_,AxfSetPresTemplateDir},
{TYPE_C_FUNC,ELFM_OLINE_TEMP_DIRECTORY_,AxfGetPresOutlineDir},
{TYPE_C_FUNC,ELFM_SCHME_TEMP_DIRECTORY_,AxfGetPresSchemeDir},
{TYPE_C_FUNC,ELFM_CHART_TEMP_DIRECTORY_,AxfGetPresChartDir},
{TYPE_C_FUNC,ELFM_SOCKAWRT,AxfSockWriteAscii},
{TYPE_C_FUNC,ELFM_STRTOBIN,AxfStringToBinary},
{TYPE_C_FUNC,ELFM_BINTOSTR,AxfBinaryToString},
{TYPE_C_FUNC,ELFM_AXFONT_UTILS,AxfFontUtils},
{TYPE_C_FUNC,ELFM_BYTE_LEN,AxfByteLen}, /* Ashisuto added.  95.09.26 */
#if BUILD_ORIENT
   /* call a function which takes byte positions, but will be careful */
   /* not to cut a 2-byte character                                   */
{TYPE_C_FUNC,ELFM_MB_SUBSTR,AxfStrClip},
#else
{TYPE_C_FUNC,ELFM_MB_SUBSTR,AxfSubstr},
#endif
{TYPE_C_FUNC,ELFM_EUC_TO_SJIS,Axfeuc2sjis},
{TYPE_C_FUNC,ELFM_SJIS_TO_EUC,Axfsjis2euc},
{TYPE_C_FUNC,ELFM_EUC_TO_JIS,Axfeuc2jis},
{TYPE_C_FUNC,ELFM_JIS_TO_EUC,Axfjis2euc},
{TYPE_C_FUNC,ELFM_SJIS_TO_JIS,Axfsjis2jis},
{TYPE_C_FUNC,ELFM_JIS_TO_SJIS,Axfjis2sjis},
{TYPE_C_FUNC,ELFM_MIME_TO_JIS,Axfmime2jis},
{TYPE_C_FUNC,ELFM_JIS_TO_MIME,Axfjis2mime},
{TYPE_C_FUNC,ELFM_READ_GLOM_BITMAP,AxfReadGlomBitmap},
{TYPE_C_FUNC,ELFM_SCREEN_TEMP_DIRECTORY_,AxfGetPres35mmDir},
{TYPE_C_FUNC,ELFM_UNPENDED_NEWTASK_BY_NAME_,AxfUnpendedNewTaskWithArgs},
{TYPE_C_FUNC,ELFM_SUBBIN,AxfBinarySubArray},
{TYPE_C_FUNC,ELFM_CREATE_WPX,AxfElfbCreateWpInstance},
{TYPE_C_FUNC,ELFM_DESTROY_WPX,AxfElfbDestroyWpInstance},
{TYPE_C_FUNC,ELFM_ASSIGN_WPX,AxfElfbAssignWpInstance},
{TYPE_C_FUNC,ELFM_LOAD_WPX,AxfElfbLoadWpInstance},
{TYPE_C_FUNC,ELFM_GET_WPX,AxfElfbGetWpInstance},
{TYPE_C_FUNC,ELFM_READ_WPX_BUFFER,AxfElfbReadWpInstanceBuffer},
{TYPE_C_FUNC,ELFM_WRITE_WPX_BUFFER,AxfElfbWriteWpInstanceBuffer},
{TYPE_C_FUNC,ELFM_READ_WPX_FILE,AxfElfbReadWpInstanceFile},
{TYPE_C_FUNC,ELFM_WRITE_WPX_FILE,AxfElfbWriteWpInstanceFile},
{TYPE_C_FUNC,ELFM_WPX_CALL_,AxfElfbWpxCall},
{TYPE_C_FUNC,ELFM_TRUNC_,AxfTrunc},
{TYPE_C_FUNC,ELFM_CR_INSOBJ,AxfElfbCreateInsetObject},
{TYPE_C_FUNC,ELFM_MEASURE_INSOBJ,AxfMeasureInsetObject},
{TYPE_C_FUNC,ELFM_OBSOLETE14_,OBSOLETE},
{TYPE_C_FUNC,ELFM_MDD_FUNCS,AxfMDDFuncs},
{TYPE_C_FUNC,ELFM_GET_BLOB_DATA,AxfGetBlobData},
{TYPE_C_FUNC,ELFM_CHANGE_DATE_FORMAT,AxfChangeDateFormat},
{TYPE_C_FUNC,ELFM_MEASURE_WPX,AxfMeasureWpInsetObjectCoords},
{TYPE_C_FUNC,ELFM_START_APP,AxfStartApp},
{TYPE_C_FUNC,ELFM_GETSERVBYNAME,AxfGetServByName},
{TYPE_C_FUNC,ELFM_STRING_TOKENS,AxfTokenize},
{TYPE_C_FUNC,ELFM_CREATE_BUILDER,AxfElfbCreateBuilder},
{TYPE_C_FUNC,ELFM_BLDR_REG_APPOBJ_N_INSET,AxfBuilderRegisterAppobjWithInset},
{TYPE_C_FUNC,ELFM_BLDR_DESTROY_INSET,AxfBuilderDestroyInset},
{TYPE_C_FUNC,ELFM_BLDR_GET_INSET_APPOBJ,AxfBuilderGetInsetAppobj},
{TYPE_C_FUNC,ELFM_BLDR_GET_GRAPHIC_INSET,AxfBuilderGetGraphicsInset},
{TYPE_C_FUNC,ELFM_BLDR_FIND_INST_FROM_FNAME_N_TASK,AxfBuilderFindInstanceGivenFilenameAndParentTaskid},
{TYPE_C_FUNC,ELFM_BLDR_GET_CONTAINER_INFO,AxfBuilderGetContainerInfo},
{TYPE_C_FUNC,ELFM_BLDR_GET_CONTAINER_APPTYPE,AxfBuilderGetContainerApptype},
{TYPE_C_FUNC,ELFM_BLDR_GET_GRAPHICS_INSET_UID,AxfBuilderGetGraphicsInsetUID},
{TYPE_C_FUNC,ELFM_BLDR_SET_ROOT_PNAME,AxfBuilderSetRootPathname},
{TYPE_C_FUNC,ELFM_BLDR_INSET_ASSIGN_SOURCE_INFO,AxfBuilderSetSourceInfo},
{TYPE_C_FUNC,ELFM_BLDR_INSET_GET_SRC_INFO,AxfBuilderGetSourceInfo},
{TYPE_C_FUNC,ELFM_BLDR_INSET_SET_DOCINFO,AxfBuilderSetInsetDocInfo},
{TYPE_C_FUNC,ELFM_BLDR_INSET_GET_DOCINFO,AxfBuilderGetInsetDocInfo},
{TYPE_C_FUNC,ELFM_ELF_STACK,AxfElfStack},
{TYPE_C_FUNC,ELFM_PRINT_DATUM,AxfPrintDatum},
{TYPE_C_FUNC,ELFM_ACL_ENABLED_,AxfACLEnabled},
{TYPE_C_FUNC,ELFM_SET_ACL_ENTRY_,AxfSetACLEntry},
{TYPE_C_FUNC,ELFM_CLEAR_ACL_ENTRY_,AxfClearACLEntry},
{TYPE_C_FUNC,ELFM_GET_ACL_,AxfGetACL},
{TYPE_C_FUNC,ELFM_GET_GROUPS_AND_USERS_,AxfListGroupsAndUsers},
{TYPE_C_FUNC,ELFM_OBSOLETE15_,OBSOLETE},
{TYPE_C_FUNC,ELFM_FILE_OPEN_BROADCAST,AxfFileOpenedNotify},
{TYPE_C_FUNC,ELFM_FILE_TERM_BROADCAST,AxfFileClosedNotify},
{TYPE_C_FUNC,ELFM_GET_LANGUAGE,AxfGetCurrentLanguage},
{TYPE_C_FUNC,ELFM_PRELOAD_JAVA_IMGS_FROM_STRS,AxfPreloadJavaImgsFromStrs},
{TYPE_C_FUNC,ELFM_ADD_ICONOBJ,AxfElfbAddIconInsetObject},
{TYPE_C_FUNC,ELFM_ENTERPRISE_DIR,AxfGetEnterpriseDir},
{TYPE_C_FUNC,ELFM_ENTERPRISE_APPS_DIR,AxfGetEnterpriseAppsDir},
{TYPE_C_FUNC,ELFM_ENTERPRISE_APP_FILENAME,AxfGetEnterpriseAppFilename},
{TYPE_C_FUNC,ELFM_IS_LINUX_OFFICE,AxfIsLinuxOffice},
{TYPE_C_FUNC,ELFM_POST_JAVA_IMAGE,AxfPostJavaImage},
{TYPE_C_FUNC,ELFM_POST_JAVA_IMAGE_PACKET,AxfPostJavaImagePacket},
{TYPE_C_FUNC,ELFM_JAVA_MENUBAR_NOTIFY,AxfJavaMenubarNotify},
{TYPE_C_FUNC,ELFM_JAVA_TASK_SYNC_MES_NOTIFY,AxfJavaTaskSyncMesNotify},
{TYPE_C_FUNC,ELFM_JAVA_TASK_NOTIFY,AxfJavaTaskNotify},
{TYPE_C_FUNC,ELFM_JAVA_NOTIFY,AxfJavaNotify},
{TYPE_C_FUNC,ELFM_IS_LATIN1,AxfIsLikeLatin1},
{TYPE_C_FUNC,ELFM_ASCII_IS_SJIS,Axfascissjis},
{TYPE_C_FUNC,ELFM_BINARY_APPEND,AxfBinaryAppend},
{TYPE_C_FUNC,ELFM_WRITE_BINARY_TO_FILE,AxfWriteBinaryToFile},
{TYPE_C_FUNC,ELFM_READ_BINARY_FROM_FILE,AxfReadBinaryFromFile},
{TYPE_C_FUNC,ELFM_CR_INSOBJ,AxfElfbCreateInsetImage},
{TYPE_C_FUNC,ELFM_DESTROY_INS_IMAGE,AxfElfbDestroyInsetImage},
{TYPE_C_FUNC,ELFM_IS_PURE_ASCII,Axfispureascii},
{TYPE_C_FUNC,ELFM_IS_EUC,Axfiseuc},
{TYPE_C_FUNC,ELFM_IS_SJIS,Axfissjis},
{TYPE_C_FUNC,ELFM_IS_JIS,Axfisjis},
{TYPE_C_FUNC,ELFM_WINDOW_LARGE_ID,AxfFindLargeWindowId},
{TYPE_C_FUNC,ELFM_WINDOW_SMALL_ID,AxfFindSmallWindowId},
{TYPE_C_FUNC,ELFM_TM1_SERVER7_CALL,AxRtTm1Funcs},
{TYPE_C_FUNC,ELFM_MEASURE_INSOBJ_AREA,AxfMeasureInsetObjectArea},
{TYPE_C_FUNC,ELFM_ENC_SET_PASSWD,AxfEncSetPasswd},
{TYPE_C_FUNC,ELFM_ENC_DISABLE,AxfEncDisable},
{TYPE_C_FUNC,ELFM_CHECK_SPELLING_LIBRARY,AxfCheckSpellingLibrary},
{TYPE_C_FUNC,ELFM_MCLIENT_BLTINS,AxfAxfMClientBltins},
{TYPE_C_FUNC,ELFM_CALL_LIB_FUNC,AxfCallLibFunc},
{0,0,0},
};


/*************************************************************************
function: ElfNumBuiltins - Return number of builtin functions
*/
ElfNumBuiltins ()
{
	return(sizeof(ElfCoreFuncs) / sizeof(bltin_desc) - 1);
}

extern data_ptr ElfRetData;
extern data_ptr NullDataPtr;

#if 0
/*************************************************************************
function: AxReallocElfDataToAnotherTask - Move data to specified task
*/
void AxReallocElfDataToAnotherTask (task,aP)
int task;
register data_ptr aP;
{
#if !FOR_TESTER
	unsigned int ix;

    if ( !aP || IS_INTEGER(aP) || (((int)aP) & FAULT_BIT) )
        return;
	AxReallocToAnotherTask(aP,task);
    if ( aP->type == TYPE_ARRAY ) {
		for ( ix = 0; ix < AX(aP)->size; ix++ )
			AxReallocElfDataToAnotherTask(task,AX(aP)->vals[ix]);
	}
#endif
}
#endif

int PidOfDialog;

/*************************************************************************
function: AxfStdoutRecord - Set the stdout-recording flag
*/
data_ptr AxfStdoutRecord ()
{
	ElfStdoutRecord = TRUE;
	return(NullDataPtr);
}

#if !FOR_TESTER

typedef struct help_info {
	char *name;	/* to allocated string */
	struct help_info *next;
	short is_file;	/* TRUE if reference is really a file ref */
	char **data;	/* points to null termed array of string ptrs */
} help_info;

static help_info *ElfUserHelp;

/*************************************************************************
function: AxIsUserHelp - Return whether a name is user defined help
*/
AxIsUserHelp (name)
char *name;
{
	register help_info *hp;
	register int ix;

	for ( hp = ElfUserHelp; hp; hp = hp->next ) {
		if ( 0 == strcasecmp(hp->name,name) )
			return(TRUE);
	}
	return(FALSE);
}

/*************************************************************************
function: ElfbGetUserHelp - Return user help array
*/
ElfbGetUserHelp(name)
char *name;
{
	register help_info *hp;
	data_ptr aP;
	int ix;
	data_ptr ElfAddStrToArray();

	ElfRetData = NULL;	/* assume failure */
	for ( hp = ElfUserHelp; hp; hp = hp->next ) {
		if ( 0 == strcasecmp(hp->name,name) )
			break;
	}
	if ( !hp )
		return;

	if ( hp->is_file )
		ElfbReadFile(hp->data[0]);
	else {
		ElfRetData = aP = ELF_CREATE_ARRAY(0);
		for ( ix = 0; hp->data[ix]; ix++ )
			aP = ElfAddStrToArray(aP,ix,hp->data[ix]);
		ElfRetData = aP;
	}
}

/*************************************************************************
function: AxfSetHelp - Create user defined help
*/
data_ptr AxfSetHelp (argDatum)
data_ptr argDatum;
{
	char *passed_name = StrFromArgArray(argDatum,0);
	data_ptr info = AnyFromArgArray(argDatum,1);

	int num_lines, ix, data_size;
	char *p;
	help_info *hp;
	char *StrFromArray();
	char name[2001];	/* plenty big for a help id name */

	if ( strlen(passed_name) >= 2000 )
		ElfAbort(ERR_STRTOOLONG);
	strcpy(name,passed_name);
	for ( ix = 0; name[ix]; ix++ )
		name[ix] = toupper(name[ix]);

	num_lines = ElfbArraySize(info);	/* errs if not an array */

/* add name to database if not already there */

	for ( hp = ElfUserHelp; hp; hp = hp->next ) {
		if ( streq(hp->name,name) )
			break;
	}
	if ( !hp ) {
		hp = (help_info*)TrueMalloc(sizeof(help_info));
		hp->name = strcpy(TrueMalloc(strlen(name)+1),name);
		hp->next = ElfUserHelp;
		ElfUserHelp = hp;
	}

/* remove old text */

	else if ( hp->data ) {
		for ( ix = 0; hp->data[ix]; ix++ )
			TrueFree(hp->data[ix]);
		TrueFree(hp->data);
	}

/* create text array */

	hp->is_file = FALSE;
	data_size = (num_lines+1)*sizeof(char**);
	hp->data = (char**)TrueMalloc(data_size);
	memset(hp->data,0,data_size);

/* copy text from array to database */

	for ( ix = 0; ix < num_lines; ix++ ) {
		p = StrFromArray(info,ix);
		hp->data[ix] = strcpy(TrueMalloc(strlen(p)+1),p);
	}

	return(NullDataPtr);
}

/*************************************************************************
function: AxfHelpFile - Create user defined helpfile reference
*/
data_ptr AxfHelpFile (argDatum)
data_ptr argDatum;
{
	char *passed_name = StrFromArgArray(argDatum,0);
	char *filename = StrFromArgArray(argDatum,1);

	int ix, data_size;
	help_info *hp;
	char name[2001];	/* plenty big for a help id name */

	if ( strlen(passed_name) >= 2000 )
		ElfAbort(ERR_STRTOOLONG);
	strcpy(name,passed_name);
	for ( ix = 0; name[ix]; ix++ )
		name[ix] = toupper(name[ix]);

/* add name to database if not already there */

	for ( hp = ElfUserHelp; hp; hp = hp->next ) {
		if ( streq(hp->name,name) )
			break;
	}
	if ( !hp ) {
		hp = (help_info*)TrueMalloc(sizeof(help_info));
		hp->name = strcpy(TrueMalloc(strlen(name)+1),name);
		hp->next = ElfUserHelp;
		ElfUserHelp = hp;
	}

/* remove old text */

	else if ( hp->data ) {
		for ( ix = 0; hp->data[ix]; ix++ )
			TrueFree(hp->data[ix]);
		TrueFree(hp->data);
	}

/* create text array */

	hp->is_file = TRUE;
	data_size = 2*sizeof(char**);
	hp->data = (char**)TrueMalloc(data_size);
	memset(hp->data,0,data_size);
	hp->data[0] = strcpy(TrueMalloc(strlen(filename)+1),filename);

	return(NullDataPtr);
}

#endif	/* !FOR_TESTER */


/* !!cvt the following is from 3.0 */
AxFullAbort()
{
	abort();
}

int ElfbRunMode(){tempAbort("ElfbRunMode called");}
int ElfbSetLiveMode(){tempAbort("ElfbSetLiveMode called");}
int ElfbFreeRun(){tempAbort("ElfbFreeRun called");}
int ElfbIsQAmode(){tempAbort("ElfbIsQAmode called");}

/*************************************************************************
function: AxTimer - Used for measuring performance
C code may call starter,reseter, ender.
Only Elf code may called reporter.
Use the TIMER_DLG@ macro.
*/
int AxTimer (mode)
int mode;	/* start, stop, reset, get info */
{
#if !FOR_TESTER
	static int counter = 0;
	static double totalTime = 0;
	static int startedAtSecs = 0, startedAtUsecs;
	struct timeval currTime;
	struct timezone currTimezone;
	data_ptr aP;

	ElfRetData = 0;

	switch ( mode ) {
	case 0:			/* start */
		gettimeofday(&currTime, &currTimezone);
		startedAtSecs = currTime.tv_sec;
		startedAtUsecs = currTime.tv_usec;
		break;

	case 1:			/* stop */
		if ( startedAtSecs != 0 ) {
			gettimeofday(&currTime, &currTimezone);
			totalTime += (currTime.tv_sec - startedAtSecs) * 1000000;
			totalTime += (currTime.tv_usec - startedAtUsecs);
			counter++;
			startedAtSecs = 0;
		}
		break;

	case 2:			/* reset */
		counter = 0;
		totalTime = 0;
		startedAtSecs = 0;
		break;

	case 3: 		/* report */
		ElfRetData = aP = ELF_CREATE_ARRAY(3);
		if ( counter != 0 ) {
			ElfAddDblToArray(aP,0,totalTime);
			ElfAddDblToArray(aP,1,totalTime/counter);
			ElfAddNumToArray(aP,2,counter);
		}
	}
	return(0);
#endif
}

#if !BUILD_KANJI
data_ptr Axfeuc2sjis(data_ptr argDatum) { return(NULL); }
data_ptr Axfsjis2euc(data_ptr argDatum) { return(NULL); }
data_ptr Axfeuc2jis(data_ptr argDatum) { return(NULL); }
data_ptr Axfjis2euc(data_ptr argDatum) { return(NULL); }
data_ptr Axfsjis2jis(data_ptr argDatum) { return(NULL); }
data_ptr Axfjis2sjis(data_ptr argDatum) { return(NULL); }
data_ptr Axfmime2jis(data_ptr argDatum) { return(NULL); }
data_ptr Axfjis2mime(data_ptr argDatum) { return(NULL); }
data_ptr Axfascissjis(data_ptr argDatum) { return(NULL); }
data_ptr Axfispureascii(data_ptr argDatum) { return(NULL); }
data_ptr Axfiseuc(data_ptr argDatum) { return(NULL); }
data_ptr Axfissjis(data_ptr argDatum) { return(NULL); }
data_ptr Axfisjis(data_ptr argDatum) { return(NULL); }
#endif

