/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elsymgen.c
   Applix ASC version: 24.1
   Date: Tue Feb  2 15:21:09 1999
*/
#include <stdio.h>
#include <string.h>

#define streq(a,b) (!strcmp(a,b))

main(argc,argv)
int argc;
char *argv[];
{
	extern int errno;
	char *ErrnoTextFromUnix();
	FILE *fpIn;
	FILE *fp;
	char buf[500];
	char bufIn[500];
	char elfId[128];
	char name0[128];
	char name1[128];
	int ix, fx;

	/* open output file */

	fp = fopen(argv[2],"w");
	if ( !fp ) {
		printf( "Failed to open %s\n", argv[2]);
		goto errno_out;
	}

	/* do work */

	fx = 0;
	if ( streq(argv[1],"-header") ) {	/* produce #define lines */
		ix = 0;
		for (fx=3; fx<argc; ++fx) {
			fpIn = fopen(argv[fx],"r");
			if ( !fpIn ) {
				printf( "Failed to open %s\n", argv[fx]);
				goto errno_out;
			}
			while (fgets(bufIn, 500, fpIn)) {
				if (bufIn[0] != '#') {
					sscanf(bufIn, "(%[^)])", elfId);
					sprintf(buf,"#define %s %d\n",elfId,ix++);
					if ( 1 != fwrite(buf,strlen(buf),1,fp) )
						goto ferr_out;
				}
			}
			fclose(fpIn);
		}
	}
	if ( streq(argv[1],"-java") ) {	/* produce java class file */
		char *s1, *s2;
		ix = 0;
		for (fx=3; fx<argc; ++fx) {
			fpIn = fopen(argv[fx],"r");
			if ( !fpIn ) {
				printf( "Failed to open %s\n", argv[fx]);
				goto errno_out;
			}
			s2 = strrchr(argv[2],'/');
			if (s2 != NULL) {
				s1 = strrchr(s2,'\\');
				if (s1 == NULL)
					s1 = s2;
			}
			else
				s1 = strrchr(argv[2],'\\');
			s1++;
			s2 = strrchr(s1,'.');
			strncpy(bufIn,s1,s2-s1);
			bufIn[s2-s1] = '\0';
			sprintf(buf,"class %s {\n",bufIn); 
			if ( 1 != fwrite(buf,strlen(buf),1,fp) )
				goto ferr_out;
			while (fgets(bufIn, 500, fpIn)) {
				if (bufIn[0] != '#') {
					sscanf(bufIn, "(%[^)])", elfId);
					sprintf(buf,"public final static int %s = %d;\n",elfId,ix++);
					if ( 1 != fwrite(buf,strlen(buf),1,fp) )
						goto ferr_out;
				}
			}
			if ( fprintf(fp,"}\n") < 0)
				goto ferr_out;
			fclose(fpIn);
		}
	}
	else if ( streq(argv[1],"-symbols0") ) {	/* produce symbol table */
		for (fx=3; fx<argc; ++fx) {
			fpIn = fopen(argv[fx],"r");
			if ( !fpIn ) goto errno_out;
			while (fgets(bufIn, 500, fpIn)) {
				if (bufIn[0] != '#') {
					sscanf(bufIn, "(%[^)])%[^:]:%s", elfId, name1, name0);
					sprintf(buf,"%s\n",name0);
					if ( 1 != fwrite(buf,strlen(buf),1,fp) )
						goto ferr_out;
				}
			}
			fclose(fpIn);
		}
	}
	else if ( streq(argv[1],"-symbols1") ) {	/* produce symbol table */
		for (fx=3; fx<argc; ++fx) {
			fpIn = fopen(argv[fx],"r");
			if ( !fpIn ) goto errno_out;
			while (fgets(bufIn, 500, fpIn)) {
				if (bufIn[0] != '#') {
					sscanf(bufIn, "(%[^)])%[^:]:", elfId, name1);
					sprintf(buf,"%s\n",name1);
					if ( 1 != fwrite(buf,strlen(buf),1,fp) )
						goto ferr_out;
				}
			}
			fclose(fpIn);
		}
	}
	if ( EOF == fclose(fp) )
		goto ferr_out;
	exit(0);

ferr_out:
	fprintf(stderr,"%s\n",ErrnoTextFromUnix(ferror(fp)));
	exit(1);
errno_out:
	fprintf(stderr,"%s\n",ErrnoTextFromUnix(errno));
	exit(1);
}

/*************************************************************************
function: ErrnoTextFromUnix - Read Unix errno text
*/
char *ErrnoTextFromUnix (err)
int err;
{
    static char *buf;
#if 0										/* !!cvt commented out of 3.0 */
    extern char *sys_errlist[];
    extern int sys_nerr;
#endif										/* !!cvt */
	char *malloc();

#if 0										/* !!cvt commented out of 3.0 */
    if ( err < sys_nerr )
        return(sys_errlist[err]);
#endif										/* !!cvt */
	buf = malloc(300);
    sprintf(buf,"err %d",err);
    return(buf);
}

