%{
/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elsyntax.y
   Applix ASC version: 51
   Date: Tue Feb  2 15:21:24 1999
*/

/*

To produce elparser.c and eltokens.h... on a SunOS 4.1.3 machine:

	asc -edit elsyntax.y elparser.c eltokens.h
	cd /ax/lpgms
	/bin/yacc -dv elsyntax.y
	mv y.tab.c elparser.c
	mv y.tab.h eltokens.h
	remove "malloc" line from top of elparser.c
	add asc stamp to eltokens.h
*/

#define FOR_PARSER
#define COMPILER_OPCODES 1      /* to get opcodes in compiler form */
#include <elcomp.h>
#include <elnodes.h>
#include <elcodes.h>

extern int InFunction;
extern ndata CrtNode();
extern int HaveFunctions;
extern int AllowSourceInfo;
extern int ElfIntMode;
 
#define CrtNode0(l,a) CrtNode(0,l,a)
#define CrtNode1(l,a,b) CrtNode(1,l,a,b)
#define CrtNode2(l,a,b,c) CrtNode(2,l,a,b,c)
#define CrtNode3(l,a,b,c,d) CrtNode(3,l,a,b,c,d)
#define CrtNode4(l,a,b,c,d,e) CrtNode(4,l,a,b,c,d,e)
#define CrtNode5(l,a,b,c,d,e,f) CrtNode(5,l,a,b,c,d,e,f)
#define CrtNode6(l,a,b,c,d,e,f,g) CrtNode(6,l,a,b,c,d,e,f,g)

%}

%start source_file

%token TK_NOTHING
%token TK_COMMA
%token TK_COLON
%token TK_DOLLAR
%token TK_DOT
%token TK_SEMICO
%token TK_HOOK
%token TK_OPEN
%token TK_CLOSE
%token TK_OBRAK
%token TK_CBRAK
%token TK_BEGIN
%token TK_ENDCMD
%token TK_ENDFUNC
%token TK_ENDBLOCK
%token TK_ENTRY
%token TK_PERCENT
%token TK_BEGINSET
%token TK_ENDSET

/* literals */

%token TK_STRVAL
%token TK_NUMVAL

/* keywords */

%token TK_FOR
%token TK_NEXT
%token TK_TO
%token TK_BY
%token TK_WHILE
%token TK_WEND
%token TK_IF
%token TK_THEN
%token TK_ELSE
%token TK_GOTO
%token TK_CALL
%token TK_ON
%token TK_RETURN
%token TK_BREAK
%token TK_CONTINUE
%token TK_DONE
%token TK_ERROR
%token TK_NODEBUG
%token TK_DEFINE
%token TK_INCLUDE
%token TK_SEARCH
%token TK_LET
%token TK_SELECT
%token TK_UPDATE
%token TK_EXECUTE
%token TK_CASE
%token TK_DEFAULT
%token TK_ENDCASE
%token TK_ARRAYOF
%token TK_ARRAYOF2
%token TK_FROM
%token TK_WHERE
%token TK_GROUP
%token TK_ORDER
%token TK_DISTINCT
%token TK_ALL
%token TK_IN
%token TK_BETWEEN
%token TK_CREATE
%token TK_TABLE
%token TK_VALUES
%token TK_INSERT
%token TK_DROP
%token TK_SQL
%token TK_DECLARE
%token TK_PREPARE
%token TK_OPENWORD
%token TK_FETCH
%token TK_CLOSEWORD
%token TK_ASC
%token TK_DESC
%token TK_UNION
%token TK_INTERSECT
%token TK_MINUS
%token TK_AT
%token TK_CURRENT
%token TK_OF
%token TK_CONNECT
%token TK_START
%token TK_WITH
%token TK_UNPREPARE

/* declaration keywords */

%token TK_EXTERN
%token TK_CONSTANT
%token TK_STATIC
%token TK_PROC
%token TK_UIPROC
%token TK_NRPROC
%token TK_FUNC
%token TK_VAR
%token TK_SYSVAR
%token TK_OBJVAR
%token TK_OBJECT
%token TK_FORMAT
%token TK_COMPILE
%token TK_PUBLIC
%token TK_PRIVATE

%token TK_OLDSET
%token TK_OLDGET
%token TK_SET
%token TK_GET

/* literal keywords */

%token TK_TRUE
%token TK_FALSE
%token TK_NULL

/* identifier */

%token TK_ID

/* operators */

%token TK_EQUALS
%token TK_GRTR
%token TK_LESS
%token TK_LEQ
%token TK_GEQ
%token TK_NEQ
%token TK_SGRTR
%token TK_SLESS
%token TK_SLEQ
%token TK_SGEQ
%token TK_NOT
%token TK_ADD
%token TK_SADD
%token TK_SUB
%token TK_MULT
%token TK_DIV
%token TK_IDIV
%token TK_EXP
%token TK_REM
%token TK_AND
%token TK_OR
%token TK_XOR
%token TK_EQV
%token TK_IMP
%token TK_ADDTO
%token TK_SUBTO
%token TK_LEXERROR

/* precedence */

%left TK_IMP
%left TK_EQV
%left TK_XOR
%left TK_OR
%left TK_AND
%left TK_NOT
%left TK_EQUALS TK_NEQ TK_LESS TK_GRTR TK_GEQ TK_LEQ TK_SLESS TK_SGRTR TK_SGEQ TK_SLEQ
%left TK_ADD TK_SUB
%left TK_SADD
%left TK_REM
%left TK_IDIV
%left TK_MULT TK_DIV
%right UNOP
%left TK_EXP
%left PRIMOP

/* Yacc foobar, see top for more info */
/* %union {            /* type of yylval, yyval */
/*     long v;
/* }
*/

%%          /* START RULES */

/*
    Declarations
*/


source_file :   /* empty */
                    {FinishSrcFile();}
    |           outer_list
                    {FinishSrcFile();}
    ;

outer_list :    outer_stmt
    |           outer_list outer_stmt
    ;

/* ??These items listed as outer statements should be moved into the statements type and semantically checked rather the syntax check.  The rror messages from a missing 'finish' of a start/finish get very obscuer otherwise.
*/
outer_stmt :    TK_EXTERN fids
                    {EmitStatement(CrtNode2($1,ND_EXTERN,$2,0));}
	|		    TK_EXTERN TK_IN TK_STRVAL fids
                    {EmitStatement(CrtNode2($1,ND_EXTERN,$4,$3));}
    |           TK_PROC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_PROC,$2,0,0));}
    |           TK_PROC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_PROC,$2,$3,0));}
    |           TK_UIPROC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_UIPROC,$2,0,0));}
    |           TK_UIPROC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_UIPROC,$2,$3,0));}
    |           TK_NRPROC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_NRPROC,$2,0,0));}
    |           TK_NRPROC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_NRPROC,$2,$3,0));}
    |           TK_FUNC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_FUNC,$2,0,0));}
    |           TK_FUNC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_FUNC,$2,$3,0));}
	|			TK_SET TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_SET,$2,0,0));}
	|			TK_SET TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_SET,$2,$3,0));}
	|			TK_GET TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_GET,$2,0,0));}
	|			TK_GET TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_GET,$2,$3,0));}
    |           TK_PRIVATE TK_PROC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_PROC,$3,0,TK_PRIVATE));}
    |           TK_PRIVATE TK_PROC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_PROC,$3,$4,TK_PRIVATE));}
    |           TK_PRIVATE TK_UIPROC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_UIPROC,$3,0,TK_PRIVATE));}
    |           TK_PRIVATE TK_UIPROC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_UIPROC,$3,$4,TK_PRIVATE));}
    |           TK_PRIVATE TK_NRPROC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_NRPROC,$3,0,TK_PRIVATE));}
    |           TK_PRIVATE TK_NRPROC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_NRPROC,$3,$4,TK_PRIVATE));}
    |           TK_PRIVATE TK_FUNC TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_FUNC,$3,0,TK_PRIVATE));}
    |           TK_PRIVATE TK_FUNC TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_FUNC,$3,$4,TK_PRIVATE));}
	|			TK_PRIVATE TK_SET TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_SET,$3,0,TK_PRIVATE));}
	|			TK_PRIVATE TK_SET TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_SET,$3,$4,TK_PRIVATE));}
	|			TK_PRIVATE TK_GET TK_ID
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_GET,$3,0,TK_PRIVATE));}
	|			TK_PRIVATE TK_GET TK_ID fargs
                    {EmitStatement(CrtNode4($1,ND_FUNC,TK_GET,$3,$4,TK_PRIVATE));}
	|			TK_COMPILE TK_ID
					{EmitStatement(CrtNode1($1,ND_COMPILE,$2));}
    |           statement
                    {EmitStatement((ndata)$1);}
    |           statement TK_SEMICO
                    {EmitStatement((ndata)$1);}
    |           TK_NODEBUG
                    {AllowSourceInfo = FALSE;}
    |           TK_FORMAT TK_ID fids
                    {EmitStatement(CrtNode3($1,ND_FORMAT,$2,$3,FALSE));}
    |           TK_FORMAT TK_ARRAYOF TK_ID fids
                    {EmitStatement(CrtNode3($1,ND_FORMAT,$3,$4,TRUE));}
    |           TK_FORMAT TK_ARRAYOF2 TK_ID fids
                    {EmitStatement(CrtNode3($1,ND_FORMAT,$3,$4,2));}
    ;

array_ref :     aref
                    {$$ = CrtNode2($1,ND_REFLIST,0,$1);}
    |           array_ref aref
                    {$$ = CrtNode2($1,ND_REFLIST,$1,$2);}
    ;

aref :          TK_OBRAK exprs TK_CBRAK
                    {$$ = $2;}
    |           TK_DOT TK_ID
                    {$$ = $2;}
    |           TK_DOT TK_MULT TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$3,0,TK_MULT);}
    |           TK_DOT TK_ENTRY TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$3,0,TK_ENTRY);}
    |           TK_DOT TK_MULT TK_ENTRY TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$4,0,TK_ENTRY+TK_MULT);}
    |           TK_DOT TK_EXP TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$3,0,TK_EXP);}
    |           TK_DOT TK_EXP TK_ENTRY TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$4,0,TK_ENTRY+TK_EXP);}
    |           TK_DOT TK_MULT TK_EXP TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$4,0,TK_MULT+TK_EXP);}
    |           TK_DOT TK_MULT TK_EXP TK_ENTRY TK_ID
                    {$$ = CrtNode3($1,ND_ENTRYFUNC,$5,0,TK_ENTRY+TK_MULT+TK_EXP);}
    ;

stmt_list :     simple_stmt
                    {$$ = CrtNode2($1,ND_STMTLIST,0,$1);}
	|			simple_stmt TK_SEMICO
                    {$$ = CrtNode2($1,ND_STMTLIST,0,$1);}
    |           stmt_list simple_stmt
                    {$$ = CrtNode2($1,ND_STMTLIST,$1,$2);}
    ;

fargs :			TK_OPEN TK_CLOSE
					{$$ = 0;}
	|			TK_OPEN fids TK_CLOSE
					{$$ = $2;}
	;

fids :          fid
                    {$$ = CrtNode2($1,ND_IDLIST,0,$1);}
    |           fids TK_COMMA fid
                    {$$ = CrtNode2($1,ND_IDLIST,$1,$3);}
    ;

fid :           TK_ID
                    {$$ = CrtNode4($1,ND_FID,0,$1,FALSE,FALSE);}
    |           TK_FORMAT TK_ID TK_ID
                    {$$ = CrtNode4($1,ND_FID,$2,$3,FALSE,FALSE);}
    |           TK_FORMAT TK_ARRAYOF TK_ID TK_ID
                    {$$ = CrtNode4($1,ND_FID,$3,$4,1,FALSE);}
    |           TK_FORMAT TK_ARRAYOF2 TK_ID TK_ID
                    {$$ = CrtNode4($1,ND_FID,$3,$4,2,FALSE);}
    |           TK_OBJECT TK_ID
                    {$$ = CrtNode4($1,ND_FID,0,$2,FALSE,TRUE);}
    ;

ids :           TK_ID
                    {$$ = CrtNode2($1,ND_IDLIST,0,$1);}
    |           ids TK_COMMA TK_ID
                    {$$ = CrtNode2($1,ND_IDLIST,$1,$3);}
    ;

exprs :         expr
                    {$$ = CrtNode2($1,ND_NUMLIST,0,$1);}
    |           exprs TK_COMMA expr
                    {$$ = CrtNode2($1,ND_NUMLIST,$1,$3);}
    ;

var :			TK_VAR
					{$$ = TK_VAR;}
	|			TK_OBJVAR
					{$$ = TK_OBJVAR;}
	|			TK_PUBLIC TK_OBJVAR
					{$$ = TK_PUBLIC;}
	|			TK_SYSVAR
					{$$ = TK_SYSVAR;}
	;

/*
    Statements
*/
statement :     TK_BEGIN stmt_list TK_ENDBLOCK
                    {$$ = $2;}
	|			TK_BEGINSET stmt_list TK_ENDSET
                    {$$ = $2;}
	|			simple_stmt
					{$$ = $1;}
	;

simple_stmt :	TK_ID TK_EQUALS exprs
                    {$$ = CrtNode3($1,ND_ASSIGN,$1,0,$3);}
    |           TK_ID array_ref TK_EQUALS exprs
                    {$$ = CrtNode3($1,ND_ASSIGN,$1,$2,$4);}
    |           TK_ID array_ref
                    {$$ = CrtNode3($1,ND_FUNCEXPR,$1,0,$2);}
    |           TK_ID array_ref TK_OPEN TK_CLOSE
                    {$$ = CrtNode3($1,ND_FUNCEXPR,$1,0,$2);}
    |           TK_ID array_ref TK_OPEN exprs TK_CLOSE
                    {$$ = CrtNode3($1,ND_ASSIGN,$1,$2,$4);}
    |           TK_LET TK_ID TK_EQUALS exprs
                    {$$ = CrtNode3($1,ND_ASSIGN,$2,0,$4);}
    |           TK_LET TK_ID array_ref TK_EQUALS exprs
                    {$$ = CrtNode3($1,ND_ASSIGN,$2,$3,$5);}
/*
    |           TK_ID TK_ADDTO expr
                    {$$ = CrtNode2($1,ND_ADDTO,$1,$3);}
    |           TK_ID TK_SUBTO expr
                    {$$ = CrtNode2($1,ND_SUBTO,$1,$3);}
*/
    |           TK_ENTRY TK_ID parameters
                    {$$ = CrtNode2($1,ND_ENTRYFUNC,$2,$3);}
    |           TK_ID parameters
                    {$$ = CrtNode3($1,ND_FUNCEXPR,$1,$2,0);}
    |           TK_ENTRY TK_ID
                    {$$ = CrtNode2($1,ND_ENTRYFUNC,$2,0);}
    |           TK_ID
                    {$$ = CrtNode3($1,ND_FUNCEXPR,$1,0,0);}
    |           TK_WHILE expr
                    {$$ = CrtNode1($1,ND_WHILE,$2);}
    |           TK_WEND
                    {$$ = CrtNode0($1,ND_WEND);}
    |           TK_FOR TK_ID TK_EQUALS expr TK_TO expr
                    {$$ = CrtNode4($1,ND_FOR,$2,$4,$6,0);}
    |           TK_FOR TK_ID TK_EQUALS expr TK_TO expr TK_BY expr
                    {$$ = CrtNode4($1,ND_FOR,$2,$4,$6,$8);}
	|			TK_BREAK TK_ID
					{$$ = CrtNode1($1,ND_BREAKFOR,$2);}
	|			TK_BREAK TK_WHILE
					{$$ = CrtNode0($1,ND_BREAKWHILE);}
	|			TK_NEXT TK_BY TK_ID
					{$$ = CrtNode1($1,ND_CONTINFOR,$3);}
	|			TK_NEXT TK_WHILE
					{$$ = CrtNode0($1,ND_CONTINWHILE);}
    |           TK_NEXT ids
                    {$$ = CrtNode1($1,ND_NEXT,$2);}
    |           TK_GOTO TK_ID
                    {$$ = CrtNode1($1,ND_GOTO,$2);}
    |           TK_RETURN
                    {$$ = CrtNode1($1,ND_RETURN,0);}
    |           TK_RETURN TK_OPEN expr TK_CLOSE
                    {$$ = CrtNode1($1,ND_RETURN,$3);}
    |           TK_ERROR TK_ON TK_ERROR
                    {$$ = CrtNode0($1,ND_ERRERR); }
    |           TK_ON TK_ERROR statement
                    {$$ = CrtNode1($1,ND_ONERROR,$3);}
    |           TK_IF expr statement
                    {$$ = CrtNode3($1,ND_IF,$2,$3,0);}
    |           TK_IF expr TK_THEN statement
                    {$$ = CrtNode3($1,ND_IF,$2,$4,0);}
    |           TK_IF expr statement TK_ELSE statement
                    {$$ = CrtNode3($1,ND_IF,$2,$3,$5);}
    |           TK_IF expr TK_THEN statement TK_ELSE statement
                    {$$ = CrtNode3($1,ND_IF,$2,$4,$6);}
    |           TK_CASE TK_OF expr
                    {$$ = CrtNode1($1,ND_SWITCH,$3);}
    |           TK_CASE exprs
                    {$$ = CrtNode1($1,ND_CASE,$2);}
    |           TK_DEFAULT
                    {$$ = CrtNode0($1,ND_DEFAULT);}
    |           TK_ENDCASE
                    {$$ = CrtNode0($1,ND_ENDSWITCH);}
    |           TK_ON expr TK_GOTO ids
                    {$$ = CrtNode2($1,ND_ONGOTO,$2,$4);}
    |           TK_ON expr TK_CALL ids
                    {$$ = CrtNode2($1,ND_ONCALL,$2,$4);}
    |           TK_ID TK_COLON statement
                    {$$ = CrtNode2($1,ND_LABELED,$1,$3);}
    |           TK_SEMICO
                    {$$ = CrtNode1($1,ND_NULLST,TRUE);}
    |           TK_NOTHING
                    {$$ = CrtNode1($1,ND_NULLST,TRUE);}
    |           var ids
                    {$$ = CrtNode5($1,ND_VARS,$1,0,$2,FALSE,FALSE);}
    |           var TK_OBJECT ids
                    {$$ = CrtNode5($1,ND_VARS,$1,0,$3,FALSE,TRUE);}
    |           var TK_FORMAT TK_ID ids
                    {$$ = CrtNode5($1,ND_VARS,$1,$3,$4,FALSE,FALSE);}
    |           var TK_FORMAT TK_ARRAYOF TK_ID ids
                    {$$ = CrtNode5($1,ND_VARS,$1,$4,$5,1,FALSE);}
    |           var TK_FORMAT TK_ARRAYOF2 TK_ID ids
                    {$$ = CrtNode5($1,ND_VARS,$1,$4,$5,2,FALSE);}
    |           TK_ENDCMD
                    {$$ = CrtNode0($1,ND_END);}
    |           TK_ENDFUNC
                    {$$ = CrtNode0($1,ND_END);}

/* SQL STUFF */

	|		TK_PREPARE TK_ID TK_FROM sql_statement
				{$$ = CrtNode2($1,ND_SQLPREPARE,$2,$4);}
	|		TK_UNPREPARE TK_ID
				{$$ = CrtNode1($1,ND_SQLUNPREPARE,$2);}
	|		TK_DECLARE TK_ID TK_FOR TK_ID
				{$$ = CrtNode2($1,ND_DCLCURSOR,$2,$4);}
	|		TK_OPENWORD TK_ID
				{$$ = CrtNode2($1,ND_OPENCURSOR,$2,0);}
	|		TK_OPENWORD TK_ID TK_OPEN exprs TK_CLOSE
				{$$ = CrtNode2($1,ND_OPENCURSOR,$2,$4);}
	|		TK_EXECUTE TK_ID
				{$$ = CrtNode2($1,ND_EXECUTE,$2,0);}
	|		TK_EXECUTE TK_ID TK_OPEN exprs TK_CLOSE
				{$$ = CrtNode2($1,ND_EXECUTE,$2,$4);}
	|		TK_CLOSEWORD TK_ID
				{$$ = CrtNode1($1,ND_CLOSECURSOR,$2);}
	|		update_statement
				{$$ = $1;}
	;

update_statement :	TK_UPDATE itemname TK_SET colsets TK_WHERE search_condition
						{$$ = CrtNode3($1,ND_UPDATE,$2,$4,$6);}
	;

colsets :	colsetter
				{$$ = CrtNode2($1,ND_COLSETLIST,0,$1);}
	|		colsetter TK_COMMA colsetter
				{$$ = CrtNode2($1,ND_COLSETLIST,$1,$3);}
	;

colsetter :	itemname TK_EQUALS sql_expr		/* other form, too!!0 */
				{$$ = CrtNode2($1,ND_COLSET,$1,$3);}
	;

sql_statement :	select_expression
					{$$ = $1;}
	|			update_statement
					{$$ = $1;}
	;

parameters  :   TK_OPEN TK_CLOSE
                    {$$ = 0;}
    |           TK_OPEN exprs TK_CLOSE
                    {$$ = $2;}
    ;

/*
    Expressions
*/

expr :          TK_OPEN expr TK_CLOSE %prec PRIMOP
                    {$$ = $2;}
    |           TK_NUMVAL %prec PRIMOP
                    {$$ = $1;}
    |           TK_STRVAL %prec PRIMOP
                    {$$ = $1;}
    |           TK_FALSE %prec PRIMOP
                    {$$ = TK_FALSE;}
    |           TK_TRUE %prec PRIMOP
                    {$$ = TK_TRUE;}
    |           TK_NULL %prec PRIMOP
                    {$$ = TK_NULL;}
    |           TK_ENTRY TK_ID %prec PRIMOP
                    {$$ = CrtNode1($1,ND_ENTRY,$2);}
	|			TK_BEGINSET exprs TK_ENDSET
					{$$ = CrtNode1($1,ND_ARRLIT,$2);}
	|			TK_BEGINSET TK_ENDSET
					{$$ = CrtNode1($1,ND_ARRLIT,0);}
    |           TK_ID parameters %prec PRIMOP
                    {$$ = CrtNode3($1,ND_FUNCEXPR,$1,$2,0);}
    |           TK_ENTRY TK_ID parameters %prec PRIMOP
                    {$$ = CrtNode2($1,ND_ENTRYFUNC,$2,$3);}
    |           TK_ID %prec PRIMOP
                    {$$ = $1;}
    |           TK_ID array_ref %prec PRIMOP
                    {$$ = CrtNode3($1,ND_AREF,$1,$2,0);}
    |           TK_ID array_ref parameters %prec PRIMOP
                    {$$ = CrtNode3($1,ND_AREF,$1,$2,$3);}
    |           TK_SUB expr    %prec UNOP
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IUMINUS:OP_UMINUS,0,$2);}
    |           TK_NOT expr    %prec TK_NOT
                    {$$ = CrtNode3($1,ND_OP,OP_NOT,0,$2);}
    |           expr TK_ADD expr    %prec TK_ADD
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IADD:OP_ADD,$1,$3);}
    |           expr TK_SUB expr    %prec TK_SUB
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_ISUB:OP_SUB,$1,$3);}
    |           expr TK_EXP expr    %prec TK_EXP
                    {$$ = CrtNode3($1,ND_OP,OP_EXP,$1,$3);}
    |           expr TK_MULT expr   %prec TK_MULT
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IMULT:OP_MULT,$1,$3);}
    |           expr TK_DIV expr    %prec TK_DIV
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IDIV:OP_DIV,$1,$3);}
    |           expr TK_IDIV expr    %prec TK_IDIV
                    {$$ = CrtNode3($1,ND_OP,OP_IDIV,$1,$3);}
    |           expr TK_REM expr    %prec TK_DIV
                    {$$ = CrtNode3($1,ND_OP,OP_REM,$1,$3);}
    |           expr TK_AND expr    %prec TK_AND
                    {$$ = CrtNode3($1,ND_OP,OP_AND,$1,$3);}
    |           expr TK_OR expr %prec TK_OR
                    {$$ = CrtNode3($1,ND_OP,OP_OR,$1,$3);}
    |           expr TK_XOR expr    %prec TK_XOR
                    {$$ = CrtNode3($1,ND_OP,OP_XOR,$1,$3);}
    |           expr TK_EQV expr    %prec TK_EQV
                    {$$ = CrtNode3($1,ND_OP,OP_EQV,$1,$3);}
    |           expr TK_IMP expr    %prec TK_IMP
                    {$$ = CrtNode3($1,ND_OP,OP_IMP,$1,$3);}
    |           expr TK_LESS expr   %prec TK_LESS
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_ILESS:OP_LESS,$1,$3);}
    |           expr TK_GRTR expr   %prec TK_GRTR
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IGRTR:OP_GRTR,$1,$3);}
    |           expr TK_LEQ expr    %prec TK_LEQ
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_ILEQ:OP_LEQ,$1,$3);}
    |           expr TK_GEQ expr    %prec TK_GEQ
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IGEQ:OP_GEQ,$1,$3);}
    |           expr TK_EQUALS expr    %prec TK_EQUALS
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_IEQUALS:OP_EQUALS,$1,$3);}
    |           expr TK_NEQ expr  %prec TK_NEQ
                    {$$ = CrtNode3($1,ND_OP,ElfIntMode?OP_INEQ:OP_NEQ,$1,$3);}
    |           expr TK_SLESS expr   %prec TK_SLESS
                    {$$ = CrtNode3($1,ND_OP,OP_SLESS,$1,$3);}
    |           expr TK_SGRTR expr   %prec TK_SGRTR
                    {$$ = CrtNode3($1,ND_OP,OP_SGRTR,$1,$3);}
    |           expr TK_SLEQ expr    %prec TK_SLEQ
                    {$$ = CrtNode3($1,ND_OP,OP_SLEQ,$1,$3);}
    |           expr TK_SGEQ expr    %prec TK_SGEQ
                    {$$ = CrtNode3($1,ND_OP,OP_SGEQ,$1,$3);}
    |           expr TK_SADD expr    %prec TK_SADD
                    {$$ = CrtNode3($1,ND_OP,OP_SADD,$1,$3);}
	|			TK_NEXT TK_ID
					{$$ = $1;}

/* SQL STUF BEGINS HERE */

	|			select_expression
					{$$ = $1;}

	|			TK_FETCH TK_ID
					{$$ = CrtNode2($1,ND_FETCHCURSOR,$2,0);}
	|			TK_FETCH TK_OPEN expr TK_CLOSE TK_ID
					{$$ = CrtNode2($1,ND_FETCHCURSOR,$5,$3);}
	;

select_expression :
				TK_SELECT select_list table_expressions
					{$$ = CrtNode3($1,ND_SELECT,0,$2,$3);}
	|			TK_SELECT set_qualifier select_list table_expressions
					{$$ = CrtNode3($1,ND_SELECT,$2,$3,$4);}
    ;

set_qualifier :
			TK_DISTINCT
				{$$ = TK_DISTINCT;}
	|		TK_ALL
				{$$ = TK_ALL;}
	;

select_list :
			TK_MULT
				{$$ = TK_MULT;}
	|		column_list
				{$$ = $1;}
	;

column_list :
			sql_expr
				{$$ = CrtNode2($1,ND_COLLIST,0,$1);}
	|		column_list TK_COMMA sql_expr
				{$$ = CrtNode2($1,ND_COLLIST,$1,$3);}
	;

bindable :
			TK_ID
				{$$ = $1;}
	|		TK_DOLLAR TK_ID
				{$$ = CrtNode2($1,ND_BINDER,0,$2);}
	|		TK_DOLLAR TK_SQL TK_COLON TK_ID
				{$$ = CrtNode2($1,ND_BINDER,TK_SQL,$4);}
	|		TK_HOOK
				{$$ = CrtNode2($1,ND_BINDER,0,TK_HOOK);}
	|		TK_HOOK TK_SQL
				{$$ = CrtNode2($1,ND_BINDER,TK_SQL,TK_HOOK);}
	;

itemname :
			bindable
				{$$ = CrtNode2($1,ND_USERTAB,0,$1);}
	|		itemname TK_DOT bindable
				{$$ = CrtNode2($1,ND_USERTAB,$1,$3);}
	;

table_names :
			itemname
				{$$ = CrtNode2($1,ND_TABLIST,0,$1);}
	|		table_names TK_COMMA itemname
				{$$ = CrtNode2($1,ND_TABLIST,$1,$3);}
	;

order_names :
			itemname
				{$$ = CrtNode3($1,ND_TABLIST,0,$1,TK_ASC);}
	|		order_names TK_COMMA itemname
				{$$ = CrtNode3($1,ND_TABLIST,$1,$3,TK_ASC);}
	|		itemname TK_ASC
				{$$ = CrtNode3($1,ND_TABLIST,0,$1,TK_ASC);}
	|		order_names TK_COMMA itemname TK_ASC
				{$$ = CrtNode3($1,ND_TABLIST,$1,$3,TK_ASC);}
	|		itemname TK_DESC
				{$$ = CrtNode3($1,ND_TABLIST,0,$1,TK_DESC);}
	|		order_names TK_COMMA itemname TK_DESC
				{$$ = CrtNode3($1,ND_TABLIST,$1,$3,TK_DESC);}
	;

table_expressions :
			table_expression
				{$$ = CrtNode2($1,ND_TABEXPR,0,$1);}
	|		table_expressions table_expression
				{$$ = CrtNode2($1,ND_TABEXPR,$1,$2);}
	;

table_expression :
			TK_FROM table_names
				{$$ = CrtNode1($1,ND_FROMTAB,$2);}
	|		TK_WHERE search_condition
				{$$ = CrtNode1($1,ND_WHERE,$2);}
	|		TK_ORDER TK_BY order_names
				{$$ = CrtNode1($1,ND_ORDERBY,$3);}
	|		TK_CONNECT TK_BY search_condition
				{$$ = CrtNode2($1,ND_CONNECT,$3,0);}
	|		TK_CONNECT TK_BY search_condition TK_START TK_WITH search_condition
				{$$ = CrtNode2($1,ND_CONNECT,$3,$6);}
	|		TK_GROUP TK_BY table_names
				{$$ = CrtNode1($1,ND_GROUPBY,$3);}
	|		TK_UNION select_expression
				{$$ = CrtNode1($1,ND_UNION,$2);}
	|		TK_INTERSECT select_expression
				{$$ = CrtNode1($1,ND_INTERSECT,$2);}
	|		TK_MINUS select_expression
				{$$ = CrtNode1($1,ND_MINUS,$2);}
	;

search_condition :
			boolean_term
			{$$ = $1;}
	|		search_condition TK_OR boolean_term
			{$$ = CrtNode2($1,ND_SQLOR,$1,$3);}
	;

boolean_term :
			boolean_factor
			{$$ = $1;}
	|		boolean_term TK_AND boolean_factor
			{$$ = CrtNode2($1,ND_SQLAND,$1,$3);}
	;

boolean_factor :
			boolean_test
			{$$ = $1;}
	|		TK_NOT boolean_test
			{$$ = CrtNode1($1,ND_SQLNOT,$2);}
	;

boolean_test :
			boolean_primary
			{$$ = $1;}
/*	|		boolean_primary [IS [NOT] truth_value] */
	;

boolean_primary :
			predicate
			{$$ = $1;}
	|		TK_OPEN search_condition TK_CLOSE
			{$$ = CrtNode1($1,ND_SQLPAREN,$2);}
	;


sql_exprs :
			sql_expr
				{$$ = CrtNode2($1,ND_NUMLIST,0,$1);}
	|		sql_exprs TK_COMMA sql_expr
				{$$ = CrtNode2($1,ND_NUMLIST,$1,$3);}
	;

predicate :
			sql_expr TK_IN TK_OPEN sql_exprs TK_CLOSE
				{$$ = CrtNode4($1,ND_OP,TK_IN,0,$1,$4);}
	|		sql_expr TK_BETWEEN sql_expr TK_AND sql_expr
				{$$ = CrtNode5($1,ND_OP,TK_BETWEEN,0,$1,$3,$5);}
	|		sql_expr TK_NOT TK_IN TK_OPEN sql_exprs TK_CLOSE
				{$$ = CrtNode4($1,ND_OP,TK_IN,TK_NOT,$1,$5);}
	|		sql_expr TK_NOT TK_BETWEEN sql_expr TK_AND sql_expr
				{$$ = CrtNode5($1,ND_OP,TK_BETWEEN,TK_NOT,$1,$4,$6);}
	|		sql_expr TK_LESS sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_LESS,$1,$3);}
	|		sql_expr TK_GRTR sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_GRTR,$1,$3);}
	|		sql_expr TK_LEQ sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_LEQ,$1,$3);}
	|		sql_expr TK_GEQ sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_GEQ,$1,$3);}
	|		sql_expr TK_EQUALS sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_EQUALS,$1,$3);}
	|		sql_expr TK_NEQ sql_expr 
				{$$ = CrtNode3($1,ND_OP,TK_NEQ,$1,$3);}
	;

sql_expr :
			TK_NUMVAL
				{$$ = $1;}
	|		TK_STRVAL
				{$$ = $1;}
	|		TK_NULL
				{$$ = TK_NULL;}
	|		itemname
				{$$ = $1;}
	|		itemname TK_DOT TK_MULT
				{$$ = CrtNode2($1,ND_COLSTAR,$1,$3);}
	|		TK_OPEN sql_expr TK_CLOSE
				{$$ = CrtNode3($1,ND_OP,TK_OPEN,0,$2);}
	|		TK_SUB sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_SUB,0,$2);}
	|		sql_expr TK_ADD sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_ADD,$1,$3);}
	|		sql_expr TK_SUB sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_SUB,$1,$3);}
	|		sql_expr TK_EXP sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_EXP,$1,$3);}
	|		sql_expr TK_MULT sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_MULT,$1,$3);}
	|		sql_expr TK_DIV sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_DIV,$1,$3);}
	|		sql_expr TK_REM sql_expr
				{$$ = CrtNode3($1,ND_OP,TK_REM,$1,$3);}
	|		select_expression
				{$$ = $1;}
	|		TK_ID TK_OPEN sql_exprs TK_CLOSE
				{$$ = CrtNode3($1,ND_SQLFUNC,$1,0,$3);}
	|		TK_ID TK_OPEN TK_MULT TK_CLOSE
				{$$ = CrtNode3($1,ND_SQLFUNC,$1,0,TK_MULT);}
	|		TK_ID TK_OPEN TK_DISTINCT sql_exprs TK_CLOSE
				{$$ = CrtNode3($1,ND_SQLFUNC,$1,TK_DISTINCT,$4);}
	|		TK_ID TK_OPEN TK_ALL sql_exprs TK_CLOSE
				{$$ = CrtNode3($1,ND_SQLFUNC,$1,TK_ALL,$4);}
	;

%% /* START CODE */

