/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elxwins.c
   Applix ASC version: 195
   Date: Tue Feb  2 15:21:06 1999
*/
#define APPLIX_WIDGETS 1
#if XTESTER     /* test program for widgets */
#define THIMBLE 1
#define XWINS 1
#endif
#define NEED_X_INFO 1

#include <stdio.h>
#include <dwt2xm.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <ax_xm.h>

#include <aos.h>
#include <thimble.h>
#include <xmlib.h>
#include <elf_env.h>
#include <eldata.h>
#include <amenudef.h>
#include <evreason.h>
/* #include <xmcanvas.h>*/
/* #include <xmtable.h>*/
/* #include <evtray.h> */
#include <xmevent.h>
#include <xmres.h>
#include <elxwins.h>
/*#include <eltree.h>*/
#include <tree.h>
#include <adlgpoke.h>

#define XWLOG(body) if ( ThimLogEvents ) XWINSlog body;

#define AXSAB_16 \
    NXLT("-applix-axsab-bold-r-normal--16-160-75-75-p-65-iso8859-1")

extern short THIMpid;
extern int ThimLogEvents;
extern Display *Dpy;
extern int WidgetNeedsUpdated;
extern XFontStruct *Txfont, *MiniTxfont, *AxDlgMainFont;
extern data_ptr ElfRetData;

void ElfXCtray();
void ElfXCcanvas();
void ElfXCsplitter();
void ElfXClistItem();
void ElfXCentryChanged();
void ElfXCtogglePushed();
void ElfXCbuttonPushed();
void ElfXCradioPushed();
void ElfXCmenuBarSelected();
void ElfXRowColumnPulldown();
extern void ElfXCscale(), AxScaleDialogFrame();
extern void ElfXCchoicePushed();
extern XFontStruct *lookupNamedFont();
extern data_ptr getFontData(), getLabelFontData();
extern int widestOptionChoice();
extern int UnMapWidget();

AXWidget WidgetOfFocusWindow();
AXWidget ZXmCreateIconImage();
char *StrFromArray();
void deCopyGadget();
AXWidget XmCreateRect(), XmCreateSplitter(), XmCreateScale();
AXWidget XmCreateTable(), XmCreateCanvas();
AXWidget XmCreateEditBox();
AXWidget AXmCreateRowColumn();
AXWidget AXmCreatePulldownMenu();
AXWidget AXmCreateBulletinBoardDialog();
AXWidget AXmCreateLabelGadget(); 
AXWidget AXmCreateRadioBox(); 
AXWidget AXmCreateToggleButtonGadget(); 
AXWidget AXmCreatePushButtonGadget();
AXWidget AXmCreateOptionMenu();  
AXWidget AXmOptionButtonGadget(); 
AXWidget AXmOptionLabelGadget();
AXWidget AXmCreateText();
AXWidget AXmCreateScrolledList();
AXWidget XmCreateDlgShell();
AXWidget WidgetOfCurrentAtmWindow();
AXWidget WidgetOfWindow();
AXWidget AXmMainWidgetOfTask();
void MenuStartsTask();
AXWidget AxCreateMenuBar();
AXWidget WidgetPointerFromHandleData();
data_ptr AxXmGetTableData();
int AxXmSetTableSelections();
AXWidget XmDlgInWidget();
AXWidget ElfbGetActiveWidget();
menu_item_def *ElfCrtMenuBarDesc();
menu_item_def *ElfLookupSlider();


void ElfbRadioBoxCreate (old_dataP, parent_dataP, info)
data_ptr old_dataP;
data_ptr parent_dataP;
data_ptr info;
{
}

void ElfbCreateChoiceMenu (old_dataP, parentP, info)
data_ptr old_dataP;
data_ptr parentP;
data_ptr info;
{
}

/*************************************************************************
function: ElfbDelEditBoxData - Clear contents of edit box
*/
void ElfbDelEditBoxData (wid_dataP)
data_ptr wid_dataP;
{
    AXWidget wid;
    wid = WidgetPointerFromHandleData( wid_dataP );

    AxXmDelEditBoxData(wid);
}


/*************************************************************************
function: ElfbCreateDlgMenuBar - Apply menu bar to dialog box
*/
void ElfbCreateDlgMenuBar (oldP,parentP,strP,idP,elfObject)
data_ptr oldP;  /* current widget or 0 */
data_ptr parentP;       /* dialog widget */
data_ptr strP;      /* not used */
data_ptr idP;       /* menu bar id */
data_ptr elfObject;
{
    AXWidget old;   /* current widget or 0 */
    AXWidget parent;    /* dialog widget */
    int  id;            /* menu bar id */
    AXWidget menu_bar;
    static XtCallbackRec callback_list[2];  /* ??1 static? */
    Arg args[20];
    int an = 0;
    AXWidget_handle w_handle;
    menu_item_def *menu_item;

    old = WidgetPointerFromHandleData(oldP);
    parent = WidgetPointerFromHandleData(parentP);
    
    if ( AxIsArray(idP) ) {
        /* !!0 set the free-able flag */
        menu_item = ElfCrtMenuBarDesc(idP);
    }
    else {
        id = IntFromDataPtr(idP);
        menu_item = ElfLookupSlider( id );
    }
    menu_bar = AxCreateMenuBar(parent,menu_item, old, 0, 
                           elfObject, ElfXCmenuBarSelected, THIMpid, 0);

    w_handle = HANDLE_FROM_WIDGET( menu_bar );
    ElfRetData = AxMakeBinaryData( sizeof(w_handle), &w_handle );

    return;
}

/*************************************************************************
function: AxCenterWidgetOverMouse - Adjust x/y/ vals of passed (W_DIALOG)
widget based on current mouse position.
*/
#define TITLE_BAR_HEIGHT 25    /* a guess */
AxCenterWidgetOverMouse (w)
AXWidget_dialog w;                   /* in: widget handle of dialog box */
{
    short xpos, ypos;
    int xoffset, yoffset;
    extern short DpyWid;    /* physical screen size */
    extern short DpyHt; /* physical screen size */
    static int force_to_zero = -1;

    GetMousePosOnDesktop(&xpos,&ypos);
    
    if (w->defaultButton) {
        AxDefaultButtonCenter(w, &xoffset, &yoffset);
        yoffset += TITLE_BAR_HEIGHT;
    }
    else {
        xoffset = w->width / 2;
        yoffset = w->height / 2;
    }

    /* approx center */
    xpos -= xoffset;
    xpos = MAX(xpos,5); /* leave 5 for margin */
    ypos -= yoffset;
    ypos = MAX(ypos,20);        /* leave 20 for title bar */

/* keep from being below/beyond desktop */

    if ( (xpos + w->width) > DpyWid )
        xpos = DpyWid - w->width;
    if ( (ypos + w->height + TITLE_BAR_HEIGHT) > DpyHt )
        ypos = DpyHt - w->height - TITLE_BAR_HEIGHT;

/* but NEVER above/before desktop */

    xpos = MAX(0,xpos);
    ypos = MAX(0,ypos);

    if ( force_to_zero == -1 ) {
        /* see if we are to run in a special mode where all dialog boxes
         * are posted in the upper left corner of the window
         */
        if ( getenv("AX_FORCE_ZERO") != (char *)NULL )
            force_to_zero = TRUE;
        else
            force_to_zero = FALSE;
    }
    if ( force_to_zero )
        xpos = ypos = 0;
    
    w->xpos = xpos;
    w->ypos = ypos;
}

/*
 * function: ElfbXListScreenfonts - return list of available screenfonts
 */
int
ElfbXListScreenfonts()
{
    data_ptr fontList;
    char **tList;
    int ix, listsize;
    int maxnames;

    maxnames = 4000;       /* mustn't be too large, or null is returned */
    tList = XListFonts(Dpy, "-*-*-*-*-*-*-*-*-*-*-*-*-*-*",
                       maxnames, &listsize);
    if (!tList || !listsize) {
        ElfRetData = (data_ptr) NULL;
        return FALSE;
    }
    fontList = AxMakeArray(listsize);
    for (ix = 0; ix < listsize; ix++) {
        fontList = AxAddStrToArray(fontList, ix, tList[ix]);
    }
    XFreeFontNames(tList);
    ElfRetData = fontList;
}

