/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elxwins.h
   Applix ASC version: 67
   Date: Tue Feb  2 15:20:56 1999
*/
#ifndef _ELXWINS_H
#define _ELXWINS_H

/* The defines in here  must correspond to the defines in elf_dlg.elf */

#define WFLG_NODISPLAY		(0x01)
#define WFLG_MOD_RETURN		(0x02) /* callback on changes */
#define WFLG_REPAINT		(0x04)
#define WFLG_INACTIVE		(0x08)
#define WFLG_TOUCHED_RETURN	(0x10) /* callback on changes */
#define WFLG_ACTIVE_RETURN	(0x20)
#define WFLG_MONOSPACE_FONT (0x40)
#define WFLG_RESET_LIST		(0x80)
#define WFLG_DLG_NOT_PICKABLE (0x100) /* only for display-only list boxes */
#define WFLG_DIAMOND		(0x200) /* to make toggle buttons use diamonds */
#define WFLG_NO_ECHO		(0x400)
#define WFLG_IN_EDIT		(0x800) /* set by dlg editor */
#define WFLG_NO_DELETE		(0x1000) /* set by dlg editor */
#define WFLG_UNFOCUS_RETURN	(0x2000) /* callback on entry/editbox lost focus*/
#define WFLG_NO_PRIMARY_SELN (0x4000) /* If set, widget ignores primary
										 selection. */
#define WFLG_EDITABLE       (0x8000) /* allow editing to widget */
#define WFLG_JDK_NATIVE     (0x10000) /* use native awt peer (jdk102) */

/*
 * Font attribute types, must match elf_dlg.elf
 */
#define FONT_FAMILY    1               /* fontface familyname string */
#define FONT_SIZE      2               /* pointsize in points */
#define FONT_WEIGHT    3               /* stroke weight integer val */
#define FONT_SLANT     4               /* stroke slant integer */
#define FONT_SHADOW    5               /* drop shadow info */
#define FONT_CELLSIZE  5               /* mono cell size (reference_font) */


/* Format of a dialog box:  COPIED from elf_dlg.elf */

#define DB_radios 0
#define DB_toggles 1
#define DB_choices 2
#define DB_verbs 3
#define DB_enters 4
#define DB_texts 5
#define DB_icons 6
#define DB_lists 7
#define DB_rects 8
#define DB_edit_boxes 9
#define DB_splitters 10
#define DB_scalers 11
#define DB_tables 12
#define DB_rowcols 13
#define DB_canvases 14
#define DB_trays 15
#define DB_choosers 16
#define DB_combos 17
#define DB_groups 18
#define DB_aligners 19
#define DB_reserved13 20
#define DB_reserved14 21
#define DB_reserved15 22
#define DB_revstamp 23
#define DB_display_only 24
#define DB_open_look 25
#define DB_menu_status 26
#define DB_old_menu_status 27
#define DB_menu_bar 28
#define DB_non_transient 29
#define DB_menu_id 30
#define DB_title 31
#define DB_width 32
#define DB_height 33
#define DB_gadget_order 34
#define DB_default_button 35
#define DB_icon 36
#define DB_accept_poke 37
#define DB_display_new_values 38
#define DB_help_topic 39
#define DB_cancelled 40
#define DB_running 41
#define DB_exit_gadget 42
#define DB_changed 43
#define DB_xpos 44
#define DB_ypos 45
#define DB_widget 46
#define DB_widgets 47
#define DB_bar_widget 48
#define DB_bar_picked 49
#define DB_poked 50
#define DB_pokecode 51
#define DB_pokestr 52
#define DB_quiet_running 53
#define DB_cursor_in_entry 54
#define DB_pending_delete_entry 55
#define DB_leave_window 56
#define DB_old_widget_vals 57
#define DB_last_button_picked 58
#define DB_OBSOLETE1 59
#define DB_icon_title 60
#define DB_parent_id 61
#define DB_var_size 62
#define DB_min_width 63
#define DB_min_height 64
#define DB_max_width 65
#define DB_max_height 66
#define DB_disable_record 67
#define DB_no_expand 68
#define DB_exit_info 69
#define DB_event_handlers 70
#define DB_event_masks 71
#define DB_in_edit 72
#define DB_callbacks 73
#define DB_user_var_size 74
#define DB_user_poke_codes 75
#define DB_user_callbacks 76
#define DB_elfObject 77
#define DB_objectStuff 78
#define DB_exit_data   79
#define DB_exit_code   80
#define DB_timer 81
#define DB_reference_font 82
#define DB_reference_lang 83
#define DB_align_links 84
#define DB_keyfocus_links 85
#define DB_background_image 86
#define DB_color_table 87
#define DB_topmost_window   88
#define DB_default_cursor   89
#define DB_uid              90
#define DB_keyfocus_widget  91
#define DB_java_cache_id 92
#define DB_max_widget_id 93

#define DBDEXflags 0
#define DBDEXid 1
#define DBDEXtitle 2
#define DBDEXxpos 3
#define DBDEXypos 4
#define DBDEXvalue 5
#define DBDEXstrs 6
#define DBDEXwidth 7
#define DBDEXheight 8
#define DBDEXlength 9
#define DBDEXoptional 10
#define DBDEXno_trim 11
#define DBDEXno_title 12
#define DBDEXmulti_pick 13
#define DBDEXok_on_confirm 14
#define DBDEXhoriz_scroll 15
#define DBDEXmost_recent 16
#define DBDEXdouble_clicked 17
#define DBDEXthickness 18
#define DBDEXdflt 19
#define DBDEXtype 20
#define DBDEXpicked 21
#define DBDEXchanged 22
#define DBDEXhelpid 23
#define DBDEXvalid_chars 24
#define DBDEXfg_color 25
#define DBDEXbg_color 26
#define DBDEXhide_vscroll 27
#define DBDEXfont 28
#define DBDEXval_changed 29
#define DBDEXminValue 30
#define DBDEXmaxValue 31
#define DBDEXno_label 32
#define DBDEXforce_list_item_display 33
#define DBDEXlist_item_for_display 34
#define DBDEXreverseBitmap 35
#define DBDEXevent_handlers 36
#define DBDEXevent_masks 37
#define DBDEXwidget 38
#define DBDEXcallbacks 39
#define DBDEXpixmaps 40
#define DBDEXstyle   41
#define DBDEXelfObject 42
#define DBDEXobjectStuff 43
#define DBDEXgroupNames 44
#define DBDEXthree_state_toggle 45
#define DBDEXge_palette_btn_type 46
#define DBDEXbox_marker_value 47
#define DBDEXminor_event_notify 48
#define DBDEXmarker_width       49
#define DBDEXallow_hidden_columns     50
#define DBDEXallow_column_resizing    51
#define DBDEXsuppress_row_markers     52
#define DBDEXallow_column_reordering  53
#define DBDEXuse_data_request_model   54
#define DBDEXalis_style_scroll        55
#define DBDEXhide_vertical_grid       56
#define DBDEXhide_horizontal_grid     57
#define DBDEXvscroll_origin           58
#define DBDEXvscroll_length           59
#define DBDEXhscroll_origin           60
#define DBDEXhscroll_length           61
#define DBDEXshow_row_numbers         62
#define DBDEXbutton_up_scroll         63
#define DBDEXvisible_item_count       64
#define DBDEXno_primary_seln          65
#define DBDEXuser_callbacks           66
#define DBDEXshadow                   67
#define DBDEXtextShadow               68
#define DBDEXtextColor                69
#define DBDEXwidgetColor              70
#define DBDEXgraphic                  71
#define DBDEXfontAttr                 72
#define DBDEXlabelFont                73
#define DBDEXlabelColor               74
#define DBDEXlabelShadow              75
#define DBDEXrminfo                   76
#define DBDEXdeSelect                 77
#define DBDEXuid                      78
#define DBDEXrowcolcreate             79
#define DBDEXdefaultCursor            80
#define DBDEXtablayers                81
#define DBDEXalignment                82
#define DBDEXstrs_download_index      83
#define DBDEXstrs_download_timestamp  84
#define DBDEXselection                85
#define DBDEXedit_mask                86
#define DBDEXcanvas_data              87
#define DBDEXaccelerator_key          88

/* these are for dialog editor comm, and data at this 'pos'
 * is never written to the gadget array; keep the value above
 * the other DBDEX vals..  (here, and in elf_dlg.elf)
 */
#define DBDEXclear_flags              500
#define DBDEXmake_tablayer_link       501
#define DBDEXactive_tablayer          502

#define DLG_MAX_GADGET_MEMBERS 89

#define DLG_RADIO_BOX 0
#define DLG_TOGGLE_BUTTON 1
#define DLG_CHOICE 2
#define DLG_VERB_BUTTON 3
#define DLG_ENTER 4
#define DLG_TEXT 5
#define DLG_ICON 6
#define DLG_LIST_BOX 7
#define DLG_RECT 8
#define DLG_EDIT_BOX 9
#define DLG_SPLITTER 10
#define DLG_SCALE 11
#define DLG_TABLE 12
#define DLG_ROWCOL 13
#define DLG_CANVAS 14
#define DLG_TRAY   15
#define DLG_CHOOSE 16
#define DLG_COMBO_BOX 17
#define DLG_GROUP 18
#define DLG_ALIGNER 19
#define DLG_NUM_GADGETS 20

/* w->style values used for W_LABEL, W_ENTER, .. */
#define LABEL_NONE (-1)
#define LABEL_LEFT 0
#define LABEL_TOP 1
#define LABEL_BACKGROUND_CLEARED 2  /* painter performs background clear */

/* w->style values used by W_RECT */
#define RECT_PLAIN 1                  /* just a panel */
#define RECT_LABELED 2                /* panel label displayed on top edge */
#define RECT_LAYERED 3                /* tab-control style, tabs visible */
#define RECT_LAYERED_NOTABS 4         /* tab-control style, tabs invisible */

/* additional style info for RECT_LAYERED */
#define TABS_TOP 1
#define TABS_RIGHT 2
#define TABS_BOTTOM 3
#define TABS_LEFT 4

#define DLG_NORMAL_BUTTON 0
#define DLG_OK_BUTTON 1
#define DLG_CANCEL_BUTTON 2
#define DLG_HELP_BUTTON 3
#define DLG_ICON_BUTTON 4
#define DLG_APPLY_BUTTON 5
#define DLG_POLY_BUTTON 6


/* Values for horizontal and vertical widget aligment */
#define ALIGN_LEFT       1
#define ALIGN_RIGHT      2
#define ALIGN_CENTER     3
#define ALIGN_TOP        4
#define ALIGN_BOTTOM     5
#define ALIGN_BASELINE   6


#endif /* _ELXWINS_H */

