/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: insets_.h
   Applix ASC version: 16
   Date: Tue Feb  2 15:22:16 1999
*/
/* STRIP LINES THROUGH HERE */
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''' generic info ''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_units@
	dpi,
	dpu,
	precision,
	name

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_area@
	x,
	y,
	width,
	height

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_size@
	width,
	height

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_inset_size@			' Returned by generic inset measurement fcn
	format ax_units@ units,
	format ax_size@ size

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''' source info '''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

define BAD#INSET#UID			0		' Legal uid's are 1, 2, 3...

format ax_inset_object@ 
	type,   ' type of object, as defined in app_ids_.am:
	        '    APP#WORDS_, APP#GRAPHICS_, APP#SPREADSHEET_, etc.
	uid,    ' type specific unique identifier
	info,   ' Opaque, type-specific structure; null -> default
	units,  ' this will override units in opaque source structure
	parents, ' array of parents - reserved
	icon     ' icon info

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''' formatting info '''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_transition@
	video_enabled,
	video_style,
	audio_enabled,
	audio_pathname,
	audio_pended,
	audio_gain,    ' 0 (quietest) to 100 (loudest)
	video_throttle, ' 0 (fastest) to 100 (slowest)
	build_level

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_inset_info@
	' rendering information ''''''''''''''''''''''''''''''''''''''''''''''''''
	format ax_units@ units,
	format ax_area@ destination,
	format ax_area@ clip,
	suppress_cursor, ' true  - don't change pointer while rendering (default)
	                 ' false - the renderer may change the pointer
	direct_render,   ' true  - draw directly onto surface
	                 ' false - draw offscreen, copy to surface (default)
	icon_only,       ' true  - don't draw the source, just an icon
	                 ' false - draw the source material (default)

	' scaling information ''''''''''''''''''''''''''''''''''''''''''''''''''''
	x_zoom,          ' any number - 100.0 is 100% or 1X zoom (default)
	y_zoom,          ' any number - 100.0 is 100% or 1X zoom (default)
	scale_mode,      ' 0 / "clip to fit"    - no scaling (excluding zoom)
	                 ' 1 / "scale to fit"   - scale to fit destination (default)
	                 ' 2 / "scale if clips" - if the rendering is too big to
	                 '                        fit into the destination, the
	                 '                        rendering should be scaled to fit
	proportional,    ' true  - scaling may NOT change aspect ratio (default)
	                 ' false - scaling may distort aspect ratio
	centered,        ' true  - source is centered in destination
	                 ' false - source is aligned to upper left corner (default)

	' decorations ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	widget_colors,   ' true  - use widget color for screens and clears
	                 ' false - use window colors (default)
	invert_colors,   ' true  - invert fg/bg for screens, fills, and colors
	                 ' false - use normal fg/bg (default)
	clear,           ' true  - clear the background before rendering (default)
	                 ' false - do not clear the background before rendering
	fill,            ' true  - fill the background before rendering 
	                 ' false - don`t fill the backgrnd before rendering(default)
	border_style,    ' 0 / "none"          - no border (default)
	                 ' 1 / "solid"         - solid border
	                 ' 2 / "dashed"        - dashed border
	inactive_content,' true  - overlay a 50% screen after rendering
	                 ' false - do not overlay a 50% screen (default)
	inactive_border, ' true  - overlay a 50% screen over border
	                 ' false - do not overlay a 50% screen (default)

	' transitional effects (valid only when direct_render = false) '''''''''''
	format ax_transition@ transition

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''' unified container ''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format ax_inset@
	format ax_inset_object@ obj,
	format ax_inset_info@ info,
	image_uid                   ' specific unique identifier for inset 

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''' Clipboard inset '''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

define LINKED#INSET#STR					NXLT("linked")
define EMBEDDED#INSET#STR				NXLT("embedded")

format ax_clipboard_inset@
	inset_type,      ' LINKED#[INSET | EMBEDDED]#STR
	doc_type,        ' AX_DOC_TYPE_XXXX
	app_type,        ' AX_APP_TYPE_XXXX
	cvt_macro,       ' macro to run when inset is displayed (default if null)
	app_macro,       ' macro to run when inset is opened (default if null)
	obj,             ' ax_inset_object@ - default behavior if NULL
	x_zoom,          ' any number - 100.0 is 100% or 1X zoom (default)
	y_zoom,          ' any number - 100.0 is 100% or 1X zoom (default)
	scale_mode,      ' 0 / "clip to fit"    - no scaling (excluding zoom)
	                 ' 1 / "scale to fit"   - scale to fit destination (default)
	                 ' 2 / "scale if clips" - if the rendering is too big to
	                 '                        fit into the destination, the
	                 '                        rendering should be scaled to fit
	proportional,    ' true  - scaling may NOT change aspect ratio (default)
	                 ' false - scaling may distort aspect ratio
	centered,        ' true  - source is centered in destination
	                 ' false - source is aligned to upper left corner (default)
	data,            ' If inset_type = LINKED#INSET
	                 ' 	Absolutified path of linked file (URL's OK)
	                 ' else ( EMBEDDED#INSET: )
	                 ' 	Raw data representing inset (might be foreign format)
	icon_only        ' true  - don't draw the source, just an icon
	                 ' false - draw the source material (default)

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''' sample code '''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' #include graphics_.am
' #include insets_.am
' 
' macro sample(pathname)
' 	var format ax_inset_object@ inset_object
' 	var format ax_inset_info@ inset_info
' 	var format gr_inset_source@ src
' 	var format ax_inset@ inset
' 	var format ax_units@ units
' 	var dbox, gfx
' 
' 	' create a dialog box containing a canvas
' 	dbox = db_create_dialog@(0, "Sample", 150, 150)
' 	db_create_ctrl@(dbox, 14, "MyCanvas", "MyCanvas", 0, 0, null)
' 	db_paint@(dbox) ' this is a workaround for a canvas bug
' 	db_ctrl_line_thickness@(dbox, "MyCanvas", 0)
' 	db_ctrl_width@ (dbox, "MyCanvas", 150)
' 	db_ctrl_height@(dbox, "MyCanvas", 150)
' 
' 	' create a graphic object to render onto the canvas
' 	create_gfx@(gfx)
' 	read_graphic_file@(gfx, pathname, true, true)
' 	src = null ' null fields resolved at time of create_inset_object
' 	units.dpi = 1000
' 	units.dpu = 1000
' 	units.precision = 3
' 	units.name = "in."
' 	gfx_create_inset_object@(inset_object, gfx, src, units)
' 
' 	' bind the object to the canvas (will automatically display with widget)
' 	inset_info.widget_colors = true ' null fields resolved at display time
' 	inset.obj = inset_object
' 	inset.info = inset_info
' 	db_ctrl_inset@(dbox, "MyCanvas", inset)
' 
' 	' keep displaying the dbox until cancelled
' repost:
' 	db_display@(dbox)
' 	if not db_cancelled@(dbox)
' 		goto repost
' endmacro
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
