/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: skip_mh.c
   Applix ASC version: 1
   Date: Tue Feb  2 15:22:13 1999
*/
#include <mac.h>
#include <stdio.h>

FILE *skip_fp;
unsigned long read_4_long ();
unsigned short read_2_word ();
unsigned short read_2_uword ();
unsigned int read_1_byte ();
int GetC ();
#define TRUE 1
#define FALSE 0

int SkipMacHeader (filefp)
FILE *filefp;
{
    MACBINARY macBinary;
    MACDISKHEADER  macDiskHeader;
    MACENTRYREC macEntry;
    char *t, type[4];
    int n,m, temp;

	skip_fp = filefp;

    fread (type, 1, 4, filefp);
    n = (type[0] & 0xFF);
    n = (n << 8) | (type[1] & 0xFF);
    n = (n << 8) | (type[2] & 0xFF);
    n = (n << 8) | (type[3] & 0xFF);

    /* find if it has disk header or binary header */
    if (n == 0x00051600 || n == 0x00051607) {
    /* we have disk header */
		macDiskHeader.magic = n;
        	macDiskHeader.version = read_4_long ();
        	fread (macDiskHeader.filesys,	1, 16, filefp);
        	/*if (strncmp(macDiskHeader.filesys, MAC_FILESYS, 16)) {
			fseek (filefp, 0, 0);
        		return (FALSE);
		} */
		macDiskHeader.numentries = read_2_word ();
    		for (m=0; m < macDiskHeader.numentries; ++m) {
    			macEntry.id = read_4_long ();
        		macEntry.offset = read_4_long ();
			macEntry.length = read_4_long ();
        		if (macEntry.id == 1) {  /* fork data id */
         		   	if (fseek(filefp, macEntry.offset, 0) == EOF) {
					 fseek (filefp, 0, 0);
                   		 return (FALSE);
				}
				else
					return (TRUE);
        		}
		}
		fseek (filefp, 0, 0);
		return (FALSE);
	}
	fseek (filefp, 0, 0);
	return (FALSE);
}

/***********************************************************
Function : read_4_long---reads 4 bytes as long int in Big endian byte order 
*********************************************************/

unsigned long read_4_long ()
{
	unsigned long i;

	i = read_2_uword ();
	return ((i << 16) + read_2_uword ());

}


/***************************************************************************
function: read_2_uword - reads 2 bytes as unsinged short in big endian byte orde
r
*/
unsigned short read_2_uword ()
{
	unsigned short b;

	b = read_1_byte();
	return((b << 8) + read_1_byte());
}



/***************************************************************************
function: read_2_word - reads 2 bytes as signed short in big endian byte order
*/
unsigned short read_2_word ()
{
	unsigned short b;

	b = read_1_byte();
	return((b << 8) + read_1_byte());
}



/***************************************************************************
function: read_1_byte - reads 1 byte as unsigned byte
*/
unsigned int read_1_byte ()
{
	int c;

	c = GetC ();
	return (c & 0xFF);
}

/************************************************************************/


int GetC ()
{
	int ch = 0;
	unsigned char c;

	fread (&c, 1, 1, skip_fp);	/* 1 byte */
	ch = c;
	return (ch);
}

