/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cvt.h
   Applix ASC version: 212
   Date: Thu Mar 25 21:12:04 1999
*/
#include <setjmp.h>
#include <doctypes.h>
#include <afile.h>

#ifndef CVT_DEFINED
#define CVT_DEFINED 1

#define BG_EXT	".bc"
#define GE_EXT	".gc"

/* G - Graphics Editor */

/* So far we have used: */
	/* VERSION 1.0 ALIS GRAPHICS EDITOR */
	/* VERSION 1.1 ASTERIX GRAPHICS EDITOR (rev1.1) */
	/* VERSION 1.1 ASTERIX GRAPHICS EDITOR (rev2.0) */
	/* VERSION 1.1 ASTERX GRAPHICS EDITOR (rev2.1) */
	/* *START GRAPHICS VERSION=300 (rev3.0) */

#define GVER_MAJOR	3
#define GVER_MINOR	0

#define GVER1_MAJOR 1
#define GVER0_MINOR	0
#define GVER1_MINOR	1

/* B - Business Graphics */
#define BVER_MAJOR	1

#define BVER0_MINOR	0
#define BVER1_MINOR	1

#define BAPPLICATION1	"ALIS BUSINESS GRAPHICS"
#define BAPPLICATION2	"ASTERIX GRAPHICS"
#define BAPPLICATION3	"ASTERX GRAPHICS"

#define G_APP 0  /* Graphics Editor */
#define B_APP 1  /* Business Graphics */
#define F_APP 2  /* external filter   */

#define HEX	0
#define BIT6	1
#define MAX_CVT_IMAGE	512
#define SCREEN_RES 75
#define MAX_LINE	64

#define PAGE_ZEROX (ge->x_zero_pt)
#define PAGE_ZEROY (ge->y_zero_pt)

#define CVTBUFLEN 256
#define CVTBLKSIZE 1024

#define COMMENT	'#'
#define GROUP_OPEN '<'
#define GROUP_CLOSE '>'

#define FNTS2	4
#define FNTS1	13
#define FNTS 	13
#define SIZS1	4
#define SIZS	8
#define TSTS	2
#define JSTS	4
#define LSTS	4
#define LTHS	8
#define MKRS	5
#define AROWS	4
#define AROTS	4
#define CMPS	3
#define ITYS	2
#define ENCS	2
#define UNDS	4
#define CLRS	16 /* rev 2 colors */
#define NCHART_TYPES 6

/* <Begin> PPT stuff */
#define BASE_HANDLE    327
/* <End> PPT stuff */

enum {
    NNULL,
    NTBOX,
    NIMAGE,
    NTEXT,
    NPOLY,
    NSTROK,
    NUDO,
    NLINE,
    NRECT,
    NELL,
    NRPOLY,
    NINSET,
    NTEMP
};
#define FIRST_OBJ NNULL
#define LAST_OBJ  NTEMP

#define TNULLTOKEN  -1
#define TOK_UNK 0 /* unknown */
#define TOK_TOK	1 /* token */
#define TOK_STR	2 /* string */
#define TOK_NUM	3 /* number */
#define TOK_OTY	4 /* object type */
#define TOK_TST 5 /* off or on */
#define TOK_STS 5 /* false of true */
#define TOK_STD 6 /* asterx standard token */
#define TOK_GRP 7 /* a delimited group of token arguments */
#define TOK_AUX 8 /* some other token specific token */

#define ML_ANGNEXP	1	/* angle spec not expected */
#define ML_APPEXP	2	/* application name expected */
#define ML_BADTOK	3	/* token misplaced */
#define ML_DOCEXP	4	/* document name expected */
#define ML_EPICEXP	5	/* END PICTURE expected */
#define ML_GENDEXP	6	/* END GROUP expected */
#define ML_ILLTOK	7	/* Illegal token */
#define ML_LOCEXP	8	/* ORIGIN/CORNER/POSITION expected */
#define ML_NAMEXP	9	/* PART name expected */
#define ML_NUMNEXP	10	/* NUMBER not expected */
#define ML_OTYEXP	11	/* object type expected */
#define ML_PAVEXP	12	/* poly attribute expected */
#define ML_POSNEXP	13	/* POSITION not expected */
#define ML_STREXP	14	/* STRING expected */
#define ML_STRNEXP	15	/* STRING not expected */
#define ML_TAVEXP	16	/* text attribute expected */
#define ML_UNKPAV	17	/* unknown poly attribute */
#define ML_UNKTAV	18	/* unknown text attribute */
#define ML_UNKUDO	19	/* PART with this name not defined */
#define ML_VEREXP	20	/* version expected */
#define ML_XEXP	21	/* x coord expected */
#define ML_YEXP	22	/* y coord expected */
#define ML_BADFMT	23	/* image FORMAT id is unknown */
#define ML_DATAEXP	24	/* image DATA expected */
#define ML_DATANEXP	25	/* image DATA not expected */
#define ML_NUMEXP	26	/* (image info) NUMBER expected */
#define ML_UNKIMG	27	/* unknown image format attribute */
#define ML_MISIMG	28	/* image information missing */
#define ML_CAVEXP	29	/* color/mode attribute expected */

#define MT_BOOL	1
#define MT_WORD	2
#define MT_UWORD	3
#define MT_FLOAT	4
#define MT_STRING	5
#define MT_NEWLINE	6

#define SEETHRU_RGB (0xFF000000)
#define WHITE_RGB   (0x00FFFFFF)
#define BLACK_RGB   (0x00000000)
#define WHITE_CMYK  (0x00000000)
#define BLACK_CMYK  (0xFF000000)

#define CVTTEXT_UNDER_NONE			0		/* no underline */
#define CVTTEXT_UNDER_SINGLE		1		/* single underline */
#define CVTTEXT_UNDER_DOUBLE		2		/* double underline */
#define CVTTEXT_UNDER_WORDS			3		/* words single underline */
#define CVTTEXT_UNDER_DOUBLE_WORDS	4		/* words double underline */

#define CVTTEXT_COLOR_NONE 0
#define CVTTEXT_COLOR_CMYK 1
#define CVTTEXT_COLOR_RGB  2

#define Emu2Mils(p)   ((p/914400.0)*1000.0)

/* MD4 Message-Digest Algorithm */
typedef unsigned char *POINTER;
typedef unsigned short int UINT2;
typedef unsigned long int UINT4;
typedef struct {
	UINT4 state[4];            /* state (ABCD) */
	UINT4 count[2];            /* number of bits, modulo 2^64 (lsb first) */
	unsigned char buffer[64];  /* input buffer */
} MD4_CTX;


/* part creation flags */
typedef struct cvt_part_creation_type {
	unsigned int done:1;
	unsigned int sawOrigin:1;
	unsigned int sawCorner:1;
	unsigned int sawStart:1;
	unsigned int sawEnd:1;
	unsigned int sawChild:1;
	unsigned int sawTxtCorner:1;
	unsigned int sawData:1;
	unsigned int sawOutline:1;
	unsigned int sawXYres:1;
} cvt_part_creation_type;

typedef struct {
	char *fontname;
	int fontnum;
} CVTAXFONT;

typedef struct cvt_token_val_type {
	int type;
	union {
		int    ival;
		double fval;
		struct {
			int n_chars;
			tx_char *str;
		} cval;
	} u;
} cvt_token_val_type;

typedef struct cvt_token_val {
	/* the token */
	int type;
	int id;

	/* the token arguments */
	int n_vals;
	cvt_token_val_type *val;
} cvt_token_val;

typedef struct cvt_shape_info {
	int spid;
	thing *t;
} cvt_shape_info;

typedef struct cvt_obj_info {
	int type;
	int size;
	thing *t;
	int chart_ix;
	struct vector extent;
	int got_extent;
	char **c_strs;
	int n_strs;
	int invalid_obj;
	int v_align;
	int h_align;
} cvt_obj_info;

typedef struct rgb_color_tab {
	int red;
	int green;
	int blue;
} rgb_color_tab;

typedef struct chart_info {
	int chart_ix;
	int wid;
	int hyt;
} chart_info;

typedef struct di_glom_t {
    char name[16];
    int offset;
} di_glom_t;

typedef struct di_pattern_t {    /* ge pattern */
    int id;                 /* id of pattern */
    char *name;          /* name of pattern */
    int width, height;      /* width and height of pattern in bits */
    int byte_width;           /* bytes require to hold a row of bits */
    unsigned char *data; /* full data */
} di_pattern_t;

typedef struct di_dash_t {
    int id;       /* dash id */
    int length;   /* number of bytes in data */
    int count;    /* number of pixels */
    int data[10]; /* data */
} di_dash_t;

typedef struct cvt_fillmap {
    int x, y;            /* origin                       */
    int width, height;   /* width and height (in pixels) */
    int dbyte_width;     /* width in bytes (image)       */
    int mbyte_width;     /* width in bytes (image mask)  */
    unsigned char *data;
    unsigned char *mask;
} cvt_fillmap;

typedef struct di_xform_t {    /* transformation matrix for rotated objects */
    int width, height;
    double x_s, y_s;        /* x scale and y scale factors */
    double x_x, x_y;
    double y_x, y_y;
    int x_t, y_t;
} di_xform_t;               

typedef struct di_bmap {
    int n_patterns;
    di_pattern_t *pattern;

    int n_lstyles;
    di_dash_t lstyle[7];

    int orgX, orgY;         /* origin in source units */
    int leftMargin;         /* left margin in source units */
    int topMargin;          /* top margin in source units */
    int rightMargin;        /* right margin in source units */
    int bottomMargin;       /* bottom margin in source units */
    int wid;                /* width of pixmap in pels */
    int hyt;                /* height of pixmap in pels */
    int orig_wid;           /* orig width of pixmap in pels */
    int orig_hyt;           /* orig width of pixmap in pels */
    unsigned int imageSize; /* size of pixmap in bytes */
    unsigned int maskSize;  /* size of mask in bytes */
    int maskWid;
    int rowBytes;           /* number of bytes to hold a row of pels */
    int planes;             /* number of planes for target (always = 1) */
    int compression;        /* coding method (always none) */
    int bitsPerPixel;       /* 1 or 24 */
    int xPelsPerInch;       /* x dpi (default = 75) */
    int yPelsPerInch;       /* x dpi (default = 75) */
    int numColorsUsed;      /* total number of colors referenced (-1) */
    unsigned char *image;   /* image buffer */
    unsigned char *mask;   /* image buffer */
	struct vector clip;    /* current clip */
} di_bmap;

typedef struct blip_info {
	unsigned int converted;
	int g_id;
	int id;
	void *data;
	vector ext;
	int ins_type;
	thing *t;
} blip_info;

typedef struct ppt_rotate_info {
	unsigned int use_rotation_angle    : 1,
				 use_lock_rotation     : 1,
				 use_lock_aspect_ratio : 1;

	int rotation_angle;
	int lock_rotation;
	int lock_aspect_ratio;
} ppt_rotate_info;

typedef struct ppt_gtext_info {
	unsigned int use_gtext_size  : 1,
	             use_gtext_align : 1,
	             use_gtext_face  : 1;
	int gtext_size;
	int gtext_align;
	int gtext_face;
} ppt_gtext_info;

typedef struct ppt_geom_info {
	unsigned int use_geo_left    : 1,
	             use_geo_right   : 1,
	             use_geo_top     : 1,
	             use_geo_bottom  : 1;
	int geo_left;
	int geo_right;
	int geo_top;
	int geo_bottom;
} ppt_geom_info;

typedef struct ppt_text_info {
	unsigned int use_anchor_text : 1,
	             use_face_ix     : 1,
	             use_text_left   : 1,
	             use_text_top    : 1,
	             use_text_right  : 1,
	             use_text_bottom : 1,
	             use_wrap_text   : 1,
	             use_text_flow   : 1,
				 use_f_RotateText : 1, 
	             use_f_FitTextToShape : 1;
	/* textbox margins */
	int text_left;
	int text_top;
	int text_right;
	int text_bottom;
	int anchor_text;
	int face_ix;
	int wrap_text;
	int text_flow;
	int f_RotateText;
	int f_FitTextToShape;
} ppt_text_info;

typedef struct ppt_blip_info {
	unsigned int use_blip_pib : 1,
	             use_pibName  : 1,
	             use_pibFlags : 1,
	             use_picContrast : 1,
	             use_picBrightness : 1;
	int blip_pib;
	int pib_Name;
	int pib_Flags;
	int picContrast;
	int picBrightness;
} ppt_blip_info;

typedef struct ppt_fill_info {
	unsigned int use_f_index          : 1,
	             use_fType            : 1,
	             use_fColor           : 1,     
	             use_fOpacity         : 1,
	             use_fBackColor       : 1,
	             use_fBackOpacity     : 1,
	             use_fBlip            : 1,      
	             use_fBlipName        : 1,

	             use_fBlipFlags       : 1,
	             use_fWidth           : 1,
	             use_fHeight          : 1,
	             use_fAngle           : 1,
	             use_fFocus           : 1,
	             use_fToLeft          : 1,
	             use_fToTop           : 1,
	             use_fToRight         : 1,

	             use_fToBottom        : 1,
	             use_fRect            : 1,
	             use_fRectTop         : 1,
	             use_fRectRight       : 1,
	             use_fRectBottom      : 1,
	             use_fDzType          : 1,
	             use_fShadePreset     : 1,
	             use_fShadeColors     : 1,

	             use_fOriginX         : 1,
	             use_fOriginY         : 1,	
	             use_fShapeOriginX    : 1,
	             use_fShapeOriginY    : 1,
	             use_fShadeType       : 1,
	             use_f_fFilled        : 1,
				 use_f_fHitTestFill   : 1,
	             use_f_fillShape      : 1;

	unsigned int use_f_fillUseRect    : 1,
	             use_f_fNoFillHitTest : 1;		

	int f_index;
	int fType;
	int fColor;     
	int fOpacity;
	int fBackColor;
	int fBackOpacity;
	int fBlip;      
	int fBlipName;
	int fBlipFlags;
	int fWidth;
	int fHeight;
	int fAngle;
	int fFocus;
	int fToLeft;
	int fToTop;
	int fToRight;
	int fToBottom;
	int fRect;
	int fRectTop;
	int fRectRight;
	int fRectBottom;
	int fDzType;
	int fShadePreset;
	int fShadeColors;
	int fOriginX;
	int fOriginY;	
	int fShapeOriginX;
	int fShapeOriginY;
	int fShadeType;
	int f_fFilled        :1,
        f_fHitTestFill   :1,
	    f_fillShape      :1,
	    f_fillUseRect    :1,
	    f_fNoFillHitTest :1;		
} ppt_fill_info;

typedef struct ppt_line_info {
	unsigned int use_l_index           : 1,
	             use_lColor            : 1,
	             use_lOpacity          : 1,
	             use_lBackColor        : 1,
	             use_lCrMode           : 1,
	             use_lType             : 1,
	             use_lFillBlip         : 1,
	             use_lFillBlipName     : 1,

	             use_lFillBlipFlags    : 1,
	             use_lFillWidth        : 1,
	             use_lFillHeight       : 1,
	             use_lFillDzType       : 1,
	             use_lWidth            : 1,
	             use_lMiterLimit       : 1,
	             use_lStyle            : 1,
	             use_lDashStyle        : 1,

	             use_lDashing          : 1,
	             use_lStartArrowhead   : 1,
	             use_lEndArrowhead     : 1,
	             use_lStartArrowWidth  : 1,
	             use_lEndArrowWidth    : 1,
	             use_lStartArrowLength : 1,
	             use_lEndArrowLength   : 1,
	             use_lJoinStyle        : 1,

	             use_lEndCapStyle      : 1,
	             use_l_fArrowHeadsOK   : 1,
	             use_l_fLine           : 1, 
	             use_l_fHitTestLine    : 1,
	             use_l_FillShape       : 1, 
                 use_l_fNoLineDrawDash : 1;			

	int l_index;
	int lColor;
	int lOpacity;
	int lBackColor;
	int lCrMode;
	int lType;
	int lFillBlip;
	int lFillBlipName;
	int lFillBlipFlags;
	int lFillWidth;
	int lFillHeight;
	int lFillDzType;
	int lWidth;
	double lMiterLimit;
	int lStyle;
	int lDashing;
	int lDashStyle;
	int lStartArrowhead;
	int lEndArrowhead;
	int lStartArrowWidth;
	int lEndArrowWidth;
	int lStartArrowLength;
	int lEndArrowLength;
	int lJoinStyle;
	int lEndCapStyle;
	int l_fArrowHeadsOK:1,
	l_fLine            :1, 
	l_fHitTestLine     :1,
	l_FillShape        :1, 
    l_fNoLineDrawDash  :1;			
} ppt_line_info;

typedef struct ppt_shadow_info {
	unsigned int use_s_index           : 1,
	             use_sType             : 1,
	             use_sColor            : 1,
	             use_sHighlight        : 1,
	             use_sCrMod            : 1,
	             use_sOpacity          : 1,
	             use_sOffsetX          : 1,
	             use_sOffsetY          : 1,

	             use_sSecondOffsetX    : 1,
	             use_sSecondOffsetY    : 1,
	             use_sScaleXToX        : 1,
	             use_sScaleYToX        : 1,
	             use_sScaleXToY        : 1,
	             use_sScaleYToY        : 1,
	             use_sPerspectiveX     : 1,
	             use_sPerspectiveY     : 1,

	             use_sWeight           : 1,
	             use_sOriginX          : 1,
	             use_sOriginY          : 1,
	             use_s_fShadow         : 1,
	             use_s_fshadowObscured : 1;

	int s_index;
	int sType;
	int sColor;
	int sHighlight;
	int sCrMod;
	double sOpacity;
	int sOffsetX;
	int sOffsetY;
	int sSecondOffsetX;
	int sSecondOffsetY;
	double sScaleXToX;
	double sScaleYToX;
	double sScaleXToY;
	double sScaleYToY;
	double sPerspectiveX;
	double sPerspectiveY;
	int sWeight;
	int sOriginX;
	int sOriginY;
	int s_fShadow        :1,
	    s_fshadowObscured:1;
} ppt_shadow_info;

typedef struct ppt_obj_anim_info {
	int red;
	int green;
	int blue;
	int pad;
	int flags;
	int soundRef;
	int orderID;
	int delayTime;
	int slideCount;
	int buildType;
	int flyMethod;
	int flyDirection;
	int afterEffect;
	int subEffect;
	int oleVerb;	
} ppt_obj_anim_info;

typedef struct ppt_attr_info {
	struct ppt_rotate_info r_info;
	struct ppt_text_info   t_info;
	struct ppt_gtext_info  gt_info;
	struct ppt_blip_info   b_info;
	struct ppt_fill_info   f_info;
	struct ppt_line_info   l_info;
	struct ppt_shadow_info s_info;
	struct ppt_geom_info   g_info;
	int smartHandles[12]; 
	int have_smart_handle[12];
	/* is the shape flipped? */
	unsigned int flip_H  : 1,
	             flip_V  : 1;
} ppt_attr_info;

typedef struct cvt_group_list {
	thing *t;
	vector extent;
	vector group_area;
	int rot_angle;
	int shape_count;
	unsigned int use_rot_angle  : 1,
	             use_group_area : 1,
				 flip_H  : 1,
	             flip_V  : 1;
} cvt_group_list;

typedef struct ppt_hdr_ftr_info {
	void *info;
	int n_strings;
	char **strings;
} ppt_hdr_ftr_info;

typedef struct oleobj_list {
  int drawAspect;
  int type;
  int objID;
  int subType;
  int objstgDataRef;
  int isBlank;
  int n_strs;
  char **strs;
} oleobj_list;


typedef struct cvt_ppt_info {
	int shape_type;
	int shape_count;
	int shape_pid;
	struct ppt_hdr_ftr_info *hdr_ftr;

    int n_olelist;
    struct oleobj_list *olelist;

	int n_grps;
	struct cvt_group_list *grp_list;
	struct ppt_attr_info *pattrs;   
	void *sh_attrs;
	int obj_anim_ix;
	ppt_obj_anim_info *obj_anim;
	int n_blips;
	struct blip_info **blips;
	int n_shapes;
	struct cvt_shape_info *sinfo;
	int n_cons;
	int n_slides_read;
	int objRefId;
	int fromIX;
	int toIX;
	int tx_type;
	void *recolor_info;
	int def_v_align;
	/* cbody */
	thing_attributes ct1_attr;

	/* half body */
	thing_attributes hb1_attr;
	thing_attributes hb2_attr;
	thing_attributes hb3_attr;
	thing_attributes hb4_attr;
	thing_attributes hb5_attr;

	/* quarter body */
	thing_attributes qb1_attr;
	thing_attributes qb2_attr;
	thing_attributes qb3_attr;
	thing_attributes qb4_attr;
	thing_attributes qb5_attr;

	unsigned int objRefFound      : 1,
				 back_fg_found    : 1,
				 text_chars_found : 1,
				 bad_slide_count  : 1,
				 fst_client_data  : 1,
				 use_recolor      : 1;
  
} cvt_ppt_info;


/* converter global data type */
typedef struct cvt_global_type {
	/* cvt state info */
	unsigned int
	 use          : 1,
	 writing      : 1,
	 as_1_1       : 1,
	 as_3_1       : 1,
	 as_4_0       : 1,
	 delete_file  : 1,
	 widechars    : 1,
	 vers_found   : 1,
	 cmaps_found  : 1,
	 faces_found  : 1,
	 cbacks_found : 1,
	 fills_found  : 1,
	 styles_found : 1,
	 hdrftr_found : 1,
	 sess_found   : 1,
	 udos_found   : 1,
	 tags_found   : 1,
	 slide_found  : 1,
	 layers_found : 1,
	 pict_found   : 1,
	 tmp_found    : 1,
	 swapped      : 1,
	 binary       : 1,
	 grabDisplay  : 1,
	 buffit       : 1,
	 trans        : 1,
	 hfstate      : 1,
	 strike_thru  : 1,
	 words_only   : 1,
	 done         : 1,
	 nextTok      : 1,
	 quantize     : 1;

	unsigned int
	 hackVer             : 1,
	 isa_chart           : 1,
	 point_damage        : 1,
	 inserted_page       : 1,
	 templ_print         : 1,
	 interlace           : 1,
	 reverse_bits        : 1,
	 is_raster           : 1,
	 is_multi_page       : 1,
	 pattern_dither      : 1,
	 grayscale           : 1,
	 use_metafile_header : 1,
	 passed_time_check   : 1,
	 audio_found         : 1,
	 hlinks_found        : 1,
	 font_cache_inited   : 1,
	 default_sys         : 1,
	 fpage_only          : 1,
	 reverse_byte_order  : 1,
	 for_blk_text        : 1,
	 lcmap_found         : 1,
	 flip_image          : 1,
	 set_dst_size        : 1,
	 use_slide_build     : 1,
	 slide_build_found   : 1,
	 inverted            : 1,
	 clipping_on         : 1,
     hdr_found           : 1,
     ftr_found           : 1,
	 master_found        : 1,
	 list_found          : 1; /* 32 */

	unsigned int
	 obj_needs_creation  : 1,
	 obj_already_created : 1,
	 obj_needs_extents   : 1,
	 title_master        : 1,
	 got_obj_extents     : 1,
	 background_shape    : 1,
	 back_color          : 1,
	 skip_header         : 1,
	 start_group         : 1,
	 group_anchor        : 1,
	 handout_found       : 1,
	 notes_found         : 1,
	 swap_fg_bg          : 1,
	 child_anchor        : 1,
	 got_anchor          : 1,
	 wordart_text        : 1,
	 ignore_hdrftrs      : 1,
	 ignore_active_text  : 1,
	 hex_format          : 1,
	 slist_found         : 1;

	unsigned int open_display        : 1;

	int format;
	int jpeg_quality;
	int scale_factor;
	thing_attributes curr_atts;
	int curr_layer;
	int cmapID;
	int page_ix;
    int n_layers;
    struct layer_type *layer;
	int slide_effect;
	int slide_delay;
	int slide_throttle;
	int n_outline_chars;
	tx_char *outline_text;
	int n_notes_chars;
	tx_char *notes_text;
	int layout_ix;
	int object1;
	int object2;
	int object3;
	int object4;
	int hide_objs;
	int hide_pg_backgd;
	int use_backgd;
	int use_color;
	int hide_slide;
	struct ge_color_scheme_type c_scheme;
	struct ge_audio_type audio;
	struct ge_build_info_type build;

	ge_hdrftr_str_type hfstr, *ico;
	ge_hdrftr_line_type *hf;
	ge_hdrftr_page_type hfpage, *hdr_ftr;
	ge_hdrftr_main_type hf_main;

	/* various obj or routine specific items */
	int majorVer, minorVer, appID;
	int geWidth, geHeight;
	int startAngle, endAngle, nsides;
	int x_off, y_off;
	int x_corner_radius, y_corner_radius;
	int scale_corners;
	int x_corner_numerator, y_corner_numerator;
	int sshape_type;
	TmPoint32 sshape_pnt[6];
	int lshape_type;
	int end1_cpnt;
	int end2_cpnt;
	int end1_cpnt_dir;
	int end2_cpnt_dir;
	TmPoint32 lshape_pnt[5];
	int temp_type, temp_size, temp_inactive, temp_chart_ix;

	/* ppt stuff */
	struct cvt_ppt_info *pinfo;
	struct vector temp_area;
	struct vector object_area;
	int read_le;    /* read in little endian for bmp, wmf, emf readers */
	int field_wid; /* for text */
	int n_faces;
	int v_align;
	int sub_txt;

	/* file being converted */
	char file1[STRPATH];
	char file2[STRPATH];
	char *unixName;
	char *fileName;

	/* convenient places to know about */
	char *sysdir;
	char *tmpdir;
	char *langdir;
	char *templatedir;

	/* allow different flavored io routines */
	int (*getcFunc)();
	int (*ungetcFunc)();
	int (*getInt32)();
	int (*getInt16)();
	int (*getInt8)();
	char *(*fgetsFunc)();
	char *inputBuff, *inBufPtr;
	char *outBuff, *outBufPtr, *outBufEndPtr;
	FILE *fp;
	long pos;

	/* image manipulation stuff */
	char in_char;
	char out_char;
	unsigned char *imgP;
	int bits_used;
	int height;
	int width;
	int byte_width;
	int depth;
	int xres,yres;
	int type;
	int compression;
	int encoding;
	int index;
	int epsID;
	int epsWid;
	int epsHyt;
	int maxval;	/* some formats use other than 255 */
	int conv_24;
	int delay;

	/* current offset */
	int dy, dx;

	/* string/token reading fields */
	int n_bufblks;
	char *buf;
	int buf_size;

	char **comments;
	int n_comments;
	struct cvt_token_val tok;

	/* for X connections */
	char *displayName;

	jmp_buf jmpPoint;
	AFileInfo info;
	CVTAXFONT *cvtAxFonts;

	thing *lastobj;
	thing *old_t;
	thing *active_t;
	int indent;
	int lineno;
	int linepos;
	int count;
	int untok;
	int dumponly;
	unsigned int inputBufferSize;

	int o_ix;
	int n_objs;
	struct cvt_obj_info *obj_list;
	struct cvt_obj_info *curr_obj;
	struct rgb_color_tab *GlobalColrTab;
	struct rgb_color_tab *LocalColrTab;
	int vp_wid;
	int vp_hyt;
	int co_wid;
	int co_hyt;
	int n_attrs;
	thing_attributes *attr_list;
	int back_shape_fg;
	int back_shape_bg;

	struct chart_info ch_data;  /* chart data needed for txt measurement */

	/* PowerPoint Info */
	int chartType;    /* Doing excel charts */
	poly_type *shape_path;
	char *pInfo;
	/* raster export */
	struct di_bmap *bmap;
	struct cvt_fillmap *gmap;
	void *gfx;
	int n_glom_datum;
	di_glom_t *glom_data;
	FILE *glom_fp;
	
	int n_images;	/* used in PPT export... */
	int n_bytes;
} cvt_global_type;

typedef struct {
    unsigned char r,g,b;
    int colorNumber;
}PIXEL;

typedef struct bg_info {
	graphics_main_type *ge;
	cvt_global_type *cvti;
	cvt_global_type *cvto;
	char *infile;
	char *outfile;
}bg_info;


typedef struct cvt_io_pointer {
	graphics_main_type *ge;
	cvt_global_type *cvt;
} cvt_io_pointer;

/* external data (declare in cvtglobs.c) */
extern char *pnm[], *pnm2[], *fnt2[], *fnt1[], *fnt[], *siz1[], *siz[];
extern char *und[], *vjst[], *jst[], *lst[], *lth[];
#if SGI
extern char **tok;
#else
extern char *tok[];
#endif
extern char *mkr[], *aro[], *art[], *chrtypes[];
extern char *cmp[], *ity[], *enc[], *tst[], *sts[];
extern int  fnt2val[], siz2val1[], siz2val2[], lth2val[], clr2val[];

#endif /* CVT_DEFINED */
