/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: img.h
   Applix ASC version: 7
   Date: Mon Nov 16 13:56:02 1998
*/
#define LINEART		1
#define HALFTONE	2

typedef struct image {
	unsigned short type;
	short xPels;
	short yPels;
	short zPels;
	unsigned short refCnt;
	unsigned short fileID;
	unsigned short imType;
	short res[3];
} image;

#define XLENPEL(n)	(((long) (n) * ge->win.grPWid) / ge->win.grMWid)
#define YLENPEL(n)	(((long) (n) * ge->win.grPHyt) / ge->win.grMHyt)
#define XLENMIL(n)	(((long) (n) * ge->win.grMWid + ge->win.grPWid - 1) / ge->win.grPWid)
#define YLENMIL(n)	(((long) (n) * ge->win.grMHyt + ge->win.grPHyt - 1) / ge->win.grPHyt)

#ifdef SUN
/*
 * For backdoor rasterfile import
 */
struct rasterfile {
	int ras_magic;		/* magic number */
	int ras_width;		/* width (pixels) of image */
	int ras_height;		/* height (pixels) of image */
	int ras_depth;		/* depth (1, 8, or 24 bits) of pixel */
	int ras_length;		/* length (bytes) of image */
	int ras_type;		/* type of file; see RT_* below */
	int ras_maptype;	/* type of colormap; see RMT_* below */
	int ras_maplength;	/* length (bytes) of following map */
	/* color map follows for ras_maplength bytes, followed by image */
};

/*
 *  the 'default' 68000 order 'ras_magic' header int, and the byte/word swapped
 *   version as seen by a sun 386i.
 */
#define RAS_MAGIC		0x59a66a95
#define RAS_MAGIC_386i 	0x956aa659

/* supported ras_type's */
#define RT_STANDARD	1	/* Raw pixrect image in 68000 byte order */

/* supported ras_maptype's */
#define RMT_NONE	0	/* ras_maplength is expected to be 0 */

#endif	/* #ifdef SUN */

