/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: aospath.c
   Applix ASC version: 2
   Date: Mon Nov 16 13:53:32 1998
*/
#include <stdio.h>		/* for definition of NULL */
#include <aos.h>
#include <scac.h>

/* Convert a file name into a pathname by prepending the
 * directory pathname given by environment variable (AOSDIR).
 *
 * Return NULL if (AOSDIR) does not specify a directory.
 *
 * Caller is responsible for freeing the storage used to hold the
 * resultant string.
 */

char *AOSpathname (filename)
char *filename;
{
char *getenv(), *strcpy(), *strcat(), *ATMmalloc();
char *aosdir, *buf;
int len;

aosdir = getenv(AOSDIR);	/* get value string for symbol */
if (aosdir == NULL)			/* symbol not defined */
	return NULL;

if ( (len = strlen(aosdir)) == 0 )	/* empty string */
	return NULL;

		/* directory pathname string is nonempty */
		/* get space to build new string */

buf = ATMmalloc( len + strlen(filename) + 2 );

strcpy (buf, aosdir);
strcat (buf, "/");
strcat (buf, filename);

return buf;
}

