/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axfont.h
   Applix ASC version: 4
   Date: Mon Nov 16 13:53:42 1998
*/
#ifndef _AXFONT_H
#define _AXFONT_H

#ifndef _AXTEXT_H
#include <axtext.h>
#endif

#define P_DPI 1000

typedef struct screenfont_t {
	fontMetrics *direct;         /* SCREEN_METRICS cache item reference */
	axtext *scaled;              /* scaled metrics data */
	unsigned long kickoutCount;  /* kickout count value for *direct */
} screenFontMetrics;

typedef struct targetfont_t {
	unsigned int resolution;     /* dpi: 300, 1000, ... */
	fontMetrics *metrics;        /* TARGET_METRICS cache item reference */
	fontMetrics *local;          /* local metrics copy in absolute units */
	unsigned long kickoutCount;  /* kickout count value for *metrics */
	float pointsize;
	int (*getCharMetrics)();     /* fill out local char's metrics */
} targetFontMetrics;

typedef struct {
	int resolution;
	textAttrs attrs;
} targetFontAttrs;

#endif /* _AXFONT_H */
