/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axmath.c
   Applix ASC version: 1
   Date: Mon Nov 16 13:53:46 1998
*/
#include <math.h>
#include <global.h>


#if VAX
#define EQL_FUDGE 0.00000001
#else
#define EQL_FUDGE 0.0000000000001
#endif

/*
 * function:  dbl_equal - Return whether two doubles are almost equal
*/
dbl_equal(v1,v2)
double v1, v2;
{
    double fudge;

    /* The code below is the simplest way to fix the bug where
       two equal negative numbers compare unequal.  This problem
       should be revisited later. - rnm 3/31/86
    */

    fudge = fabs( v1 * EQL_FUDGE) + EQL_FUDGE;
    v1 = fabs( v1 - v2);

    if ( v1 <= fudge )
        return(TRUE);
    else
        return(FALSE);
}

/*
 * function:  dbl_grtr - Return whether first double is appr greater than second
*/
dbl_grtr(v1,v2)
double v1, v2;
{
    if ( dbl_equal(v1,v2) )
        return(FALSE);
    if ( v1 > v2 )
        return(TRUE);
    else
        return(FALSE);
}

/*
 * function:  dbl_less - Return whether first double is appr less than second
*/
dbl_less(v1,v2)
double v1, v2;
{
    if ( dbl_equal(v1,v2) )
        return(FALSE);
    if ( v1 < v2 )
        return(TRUE);
    else
        return(FALSE);
}

