/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axol.h
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:32 1998
*/
#ifndef _AXOL_H_   /* should be first line */
#define _AXOL_H_





/*************************************************************************
 * Fonts
 *
 * Note: "-sun-open look glyph" fonts deleted from source tree 7/7/93 JJM
 */

#define MENU_FONT \
			(AxBigFont ? \
			"-b&h-lucida-medium-r-normal-sans-0-140-0-0-p-0-iso8859-1" : \
			"-b&h-lucida-medium-r-normal-sans-12-120-75-75-p-*-iso8859-1")

#define GRAF_FONT1 \
			"-this-open-look-font-has-been-deleted"

#define LABEL_FONT \
			(AxBigFont ? \
			"-b&h-lucida-bold-r-normal-sans-0-140-0-0-p-0-iso8859-1" : \
			"-b&h-lucida-bold-r-normal-sans-12-120-75-75-p-*-iso8859-1")

#define MINI_TEXT_FONT \
			(AxBigFont ? \
			"-b&h-lucida-medium-r-normal-sans-12-120-75-75-p-*-iso8859-1" : \
			"-b&h-lucida-medium-r-normal-sans-10-100-75-75-p-58-iso8859-1")

#define MINI_BUTTON_FONT \
			"-this-open-look-font-has-been-deleted"

#define MINI_LABEL_FONT \
			"-applix-axhvb-bold-r-normal--13-120-75-75-p-68-iso8859-1"
									/* should be 10pt. lucida sans bold? */

#define OL_CURSOR_FONT \
			"-sun-open look cursor-----12-120-75-75-p-160-sunolcursor-1"
	
/* for the asterix symbol used on the leftmost menu bar button */
#define ASTERIX_FONT \
			"-applix-axasx-----18-180-75-75-p-240-applix-fontspecific"


/*************************************************************************
 * Display states, misc defines
 */

/* scrollbar display styles */
#define OLSCRDISP_MIN		1
#define OLSCRDISP_ABBREV	2
#define OLSCRDISP_NOCABLE	4
#define OLSCRDISP_FULL		8

/* scrollbar "armed" -- describing what part is hilit 
 * none should be defined as 0 -- the "off" state */
#define OLSCR_ANCHOR_TOP	1
#define OLSCR_ANCHOR_BOT	2
#define OLSCR_ELEV_DECR		4
#define OLSCR_ELEV_INCR		8
#define OLSCR_ELEV_MIDDLE	16

/* Button states */
#define BUTTON				1
#define EMPH				2
#define HILIT				4
#define DISABLED 			8
#define PLAIN				16
#define DEFAULTCHOICE 		32
#define MINIBUTTON 			64
#define MINIHILIT 			128
#define GRAY 				256

/* toggle states for pulldown choice buttons */
#define NOTOGGLE			0
#define CHECKTOGGLE			1
#define BOXTOGGLE			2

/* Text entry field scroll states */
#define SCROLLSTATE_NONE		0
#define SCROLLSTATE_LEFT		1
#define SCROLLSTATE_RIGHT		2
#define SCROLLSTATE_LEFTRIGHT	(SCROLLSTATE_LEFT | SCROLLSTATE_RIGHT)

/* Widget value flags */
#define WIDGET_WIDTH		1
#define WIDGET_HEIGHT		2
#define WIDGET_XPOS			4
#define WIDGET_YPOS			8
#define WIDGET_PIXLABEL		16
#define WIDGET_FLAGS		32

/* DrawShadow options */
#define OLSHADOW_NODRAW 		0  /* don't draw shadow around button */
#define OLSHADOW_DRAW			1  /* draw shadow */
#define OLSHADOW_COLORSHADOW	2  /* draw shadow only in color */
#define OLSHADOW_LISTBOX		3
#define OLSHADOW_BUTTON_ON		4  /* for GE palette, when button selected */
#define OLSHADOW_BUTTON_OFF		5

/* the default default_pulldown_choice */
#define DEFAULT_PULLDOWN_CHOICE 0



/*************************************************************************
 * Pieces of open look buttons
 */

/* button */
#define OLBUTTON_LEFT			139
#define OLBUTTON_RIGHT			140
#define OLBUTTON_MIDDLE1		141
#define OLBUTTON_MIDDLE2		142
#define OLBUTTON_MIDDLE4		143
#define OLBUTTON_MIDDLE8		144
#define OLBUTTON_MIDDLE16		145
#define OLBUTTON_LEFT_HILIT		146
#define OLBUTTON_RIGHT_HILIT	147
#define OLBUTTON_MIDDLE_HILIT1	148
#define OLBUTTON_MIDDLE_HILIT2	149
#define OLBUTTON_MIDDLE_HILIT4	150
#define OLBUTTON_MIDDLE_HILIT8	151
#define OLBUTTON_MIDDLE_HILIT16	152
#define OLBUTTON_VTRI_LEFT		45
#define OLBUTTON_VTRI_RIGHT		46
#define OLBUTTON_HTRI_LEFT		48
#define OLBUTTON_HTRI_RIGHT		49
#define OLBUTTON_LEFT_EMPH		106
#define OLBUTTON_RIGHT_EMPH		107
#define OLBUTTON_MIDDLE_EMPH1	108
#define OLBUTTON_MIDDLE_EMPH2	109
#define OLBUTTON_MIDDLE_EMPH4	110
#define OLBUTTON_MIDDLE_EMPH8	111
#define OLBUTTON_MIDDLE_EMPH16	112
#define OLBUTTON_LEFT_SEL		153
#define OLBUTTON_RIGHT_SEL		154
#define OLBUTTON_MIDDLE_SEL1	155
#define OLBUTTON_MIDDLE_SEL2	156
#define OLBUTTON_MIDDLE_SEL4	157
#define OLBUTTON_MIDDLE_SEL8	158
#define OLBUTTON_MIDDLE_SEL16	159

/* mini button stuff */
#define OLMINI_LEFT				186
#define OLMINI_RIGHT			187
#define OLMINI_MIDDLE1			188
#define OLMINI_MIDDLE2			189
#define OLMINI_MIDDLE4			190
#define OLMINI_MIDDLE8			191
#define OLMINI_MIDDLE16			192
#define OLMINI_LEFT_HILIT		219
#define OLMINI_RIGHT_HILIT		225
#define OLMINI_MIDDLE_HILIT1	220
#define OLMINI_MIDDLE_HILIT2	221
#define OLMINI_MIDDLE_HILIT4	222
#define OLMINI_MIDDLE_HILIT8	223
#define OLMINI_MIDDLE_HILIT16	224

/* check box */
#define OLBUTTON_CHECK			117
#define OLBUTTON_BOX			119

/* cursor */
#define OLTEXT_CURSOR_ACTIVE	208
#define OLTEXT_CURSOR_INACTIVE	209

/* scroll bar stuff */
#define OLSCRV_DRAG				3
#define OLSCRV_CLICKTOP			2
#define OLSCRV_CLICKBOT			4
#define OLSCRV_MIDDLE			1
#define OLSCRV_BOT_DISABLED		167
#define OLSCRV_TOP_DISABLED		166
#define OLSCRV_BOTH_DISABLED	168
#define OLASCRV_MIDDLE			5
#define OLASCRV_CLICKTOP		6
#define OLASCRV_CLICKBOT		7
#define OLSCRH_DRAG				12
#define OLSCRH_CLICKRIGHT		13			
#define OLSCRH_CLICKLEFT		11
#define OLSCRH_MIDDLE			10
#define OLSCRH_LEFT_DISABLED	169
#define OLSCRH_RIGHT_DISABLED	170
#define OLSCRH_BOTH_DISABLED	171
#define OLASCRH_MIDDLE			14
#define OLASCRH_CLICKLEFT		15
#define OLASCRH_CLICKRIGHT		16
#define OLSCRV_ANCHOR			8
#define OLSCRV_ANCHOR_HILIT		9
#define OLSCRH_ANCHOR			17
#define OLSCRH_ANCHOR_HILIT		18

/* the scrollbar part encodings happen to be arranged so that
 * the horiz and vert correspondents are offset from one another
 * by a couple of constants.  Add the offset to vert to get horiz.
 */
#define OLSCR_VH_OFFSET			9 /* all of the set except for.... */
#define OLSCR_VH_OFFSET_DIS		3 /* the paritally disabled elevators */

/* triangle-in-a-box glyphs used as abbrev. menu buttons, textfield scrollers */
#define OLABBREV_DOWN			22
#define OLABBREV_DOWN_HILIT		23
#define OLABBREV_LEFT			228
#define OLABBREV_LEFT_HILIT		230
#define OLABBREV_RIGHT			229
#define OLABBREV_RIGHT_HILIT	231

/* color button pieces */
#define OLCLRBTN_LFT_TOP		24
#define OLCLRBTN_LFT_BTMOFF		1
#define OLCLRBTN_LFT_FLLOFF		2

#define OLCLRBTN_RHT_TOP		28
#define OLCLRBTN_RHT_BTMOFF		-1
#define OLCLRBTN_RHT_FLLOFF		1

#define OLCLRBTN_MDL1_TOP		30
#define OLCLRBTN_MDL2_TOP		31
#define OLCLRBTN_MDL_BTMOFF		5
#define OLCLRBTN_MDL_FLLOFF		10

/* mini color button pieces */
#define OLMNCLRBTN_LFT_TOP		120
#define OLMNCLRBTN_LFT_BTMOFF	1
#define OLMNCLRBTN_LFT_FLLOFF	99

#define OLMNCLRBTN_RHT_TOP		122
#define OLMNCLRBTN_RHT_BTMOFF	1
#define OLMNCLRBTN_RHT_FLLOFF	103

#define OLMNCLRBTN_MDL1_TOP		30
#define OLMNCLRBTN_MDL2_TOP		31
#define OLMNCLRBTN_MDL_BTMOFF	94
#define OLMNCLRBTN_MDL_FLLOFF	190

/* color abbreviated menu button pieces */
#define OLCLRABBRBTN_TOP		51
#define OLCLRABBRBTN_BOT		52
#define OLCLRABBRBTN_FILL		53
/* triangle offsets for abbrev menu button */
#define OLCLRABBRBTN_TRI_XOFF	4
#define OLCLRABBRBTN_TRI_YOFF	4

/* color triangle pieces */
#define OLCLRTRI_DOWN_TOP		45
#define OLCLRTRI_DOWN_BOT		46
#define	OLCLRTRI_DOWN_FILL		47
#define OLCLRTRI_UP_TOP			202
#define OLCLRTRI_UP_BOT			203
#define	OLCLRTRI_UP_FILL		204
#define OLCLRTRI_RHT_TOP		48
#define OLCLRTRI_RHT_BOT		49
#define OLCLRTRI_RHT_FILL		50
#define OLCLRTRI_LFT_TOP		205
#define OLCLRTRI_LFT_BOT		206
#define OLCLRTRI_LFT_FILL		207

/* color check box pieces */
#define OLCLRCHECK_BOX_TOP		114
#define OLCLRCHECK_BOX_BOT		115
#define OLCLRCHECK_BOX_FILL		116

/* color triangle types */
#define TRITYPE_LEFT			1
#define TRITYPE_RIGHT			2
#define TRITYPE_DOWN			3
#define TRITYPE_UP				4

/* color scrollbar pieces:
 * horizontal pieces are offsets from vertical pieces */
#define OLCLRSCR_V_TOP			54   /* full elevator pieces */
#define OLCLRSCR_V_BOT			55
#define OLCLRSCR_H_TOPOFF		3
#define OLCLRSCR_H_BOTOFF		3
#define OLCLRASCR_V_TOP			133  /* abbreviated elevator pieces */
#define OLCLRASCR_V_BOT			134
#define OLCLRASCR_H_TOPOFF		3
#define OLCLRASCR_H_BOTOFF		3
#define OLCLRSCR_ARROW_UP		56   /* arrow buttons */
#define OLCLRSCR_ARROW_DOWN		59
#define OLCLRSCR_ARROW_LFTOFF	82
#define OLCLRSCR_ARROW_RHTOFF	76
#define OLCLRSCR_DRAG_TOP		196  /* drag-button pieces */
#define OLCLRSCR_DRAG_BOT		197
#define OLCLRSCR_DRAG_FILL		198
#define OLCLRSCR_VEND_TOP		194  /* end-button pieces */
#define OLCLRSCR_VEND_BOT		195
#define OLCLRSCR_HEND_TOPOFF	6
#define OLCLRSCR_HEND_BOTOFF	6
/* color scrollbar end-button offsets */
#define OLCLRSCR_END_OFF		30
#define OLCLRASCR_END_OFF		15
/* color scrollbar drag-button offset */
#define OLCLRSCR_DRAG_OFF		15

/* slider */
#define OL_HSLIDER_ELEV			172
#define OL_HSLIDER_END_LFT		173
#define OL_HSLIDER_END_RHT		174
#define OL_HSLIDER_MID1			175
#define OL_HSLIDER_MID2			176
#define OL_HSLIDER_MID4			177
#define OL_HSLIDER_MID8			178
#define OL_HSLIDER_MID16		179
#define OL_HSLIDER_END_LFT_FILL	77
#define OL_HSLIDER_END_RHT_FILL	78
#define OL_HSLIDER_END_LFT_TOP	63
#define OL_HSLIDER_END_LFT_BOT	64
#define OL_HSLIDER_END_RHT_TOP	65
#define OL_HSLIDER_END_RHT_BOT	66
#define OL_HSLIDER_MID1_TOP		30
#define OL_HSLIDER_MID1_BOT		67
#define OL_HSLIDER_MID2_TOP		31
#define OL_HSLIDER_MID2_BOT		68
#define OL_HSLIDER_MID4_TOP		32
#define OL_HSLIDER_MID4_BOT		69
#define OL_HSLIDER_MID8_TOP		33
#define OL_HSLIDER_MID8_BOT		70
#define OL_HSLIDER_MID16_TOP	34
#define OL_HSLIDER_MID16_BOT	71
#define OL_HSLIDER_ELEV_TOP		60
#define OL_HSLIDER_ELEV_BOT		61
#define OL_HSLIDER_ELEV_FILL	62



/*************************************************************************
 * Font and graphic-glyph geometry info
 * For graphic glyphs (Grafont, MiniButtonFont), the per_char width
 * represents the raster width, and the per_char descent represents the
 * raster height (except for the cursors, #s 208 & 209).
 */

/* info for asterix symbol */
#define ASTERIX_CHAR			33
#define ASTERIX_CHAR_WID		10
#define ASTERIX_CHAR_OFFSET		5

/* min_char_or_byte2 info for fonts */
#define G_M		Grafont->min_char_or_byte2
#define T_M		Txfont->min_char_or_byte2
#define B_M		BoldTxfont->min_char_or_byte2

/* index of space char into per_char array */
#define TX_SPC	((T_M < 33) ? (32 - T_M) : 4)
#define BTX_SPC	((B_M < 33) ? (32 - B_M) : 4)

/* menu font lucidasans is this size in pix */
#define OLTXFONT_ASCENT			(Txfont->ascent)
#define OLTXFONT_DESCENT		(Txfont->descent)
#define OLTXFONT_HEIGHT			(OLTXFONT_ASCENT + OLTXFONT_DESCENT)

#define LABEL_FONT_ASCENT		(BoldTxfont->ascent)
#define LABEL_FONT_DESCENT		(BoldTxfont->descent)
#define MINI_LABEL_FONT_ASCENT	(MiniLabelTxfont->ascent)
#define MINI_LABEL_FONT_DESCENT	(MiniLabelTxfont->descent)
#define MINI_MENU_FONT_ASCENT	(MiniTxfont->ascent)
#define MINI_MENU_FONT_DESCENT	(MiniTxfont->descent)
#define MINI_MENU_FONT_HEIGHT	(MINI_MENU_FONT_ASCENT + MINI_MENU_FONT_DESCENT)

#define OLTXFONT_SPACEWID		(Txfont->per_char[TX_SPC].width)
#define LABEL_FONT_SPACEWID		(BoldTxfont->per_char[BTX_SPC].width)

/* button end cap measurements */
#define OLBUTTON_END_WID_LFT	(Grafont->per_char[OLBUTTON_LEFT-G_M].width)
#define OLBUTTON_END_WID_RHT	(Grafont->per_char[OLBUTTON_RIGHT-G_M].width)
#define OLBUTTON_HT				(Grafont->per_char[OLBUTTON_LEFT-G_M].descent)
#define OLMINI_END_WID_LFT		(MiniButtonFont->per_char[OLBUTTON_LEFT-G_M].width)
#define OLMINI_END_WID_RHT		(MiniButtonFont->per_char[OLBUTTON_RIGHT-G_M].width)
#define OLMINI_HT				(MiniButtonFont->per_char[OLBUTTON_LEFT-G_M].descent)
#define OLMINI_BUTTON_MAX_WID	83 /* for shoehorn onto dc ruler */

/* for menu bar geometry */
#define MENU_BAR_PAD			4
#define MENU_BAR_ADJ			((MENU_BAR_PAD>>1) + OLBUTTON_END_WID_LFT)

/* geometry of menu mark triangle glyph (vert & horz have same dimensions)
 * CAUTION: don't use OLBUTTON_VTRI_LEFT because it has width 0 */
#define OLTRI_WID				(Grafont->per_char[OLCLRTRI_DOWN_FILL-G_M].width)
#define OLTRI_HT				(Grafont->per_char[OLCLRTRI_DOWN_FILL-G_M].descent)

/* dimensions of check box */
#define OLCHECK_BOX_WID			(Grafont->per_char[OLBUTTON_BOX-G_M].width)
#define OLCHECK_BOX_HT			(Grafont->per_char[OLBUTTON_BOX-G_M].descent)

/* geometry of text cursor */
#define CURSORMARGIN			(Grafont->per_char[OLTEXT_CURSOR_ACTIVE-G_M].width)

/* default ht of box bounding exclusive settings
 * +6 is +1 pix gap and +2 pix hilit outline each side */
#define OLRADIO_HT				(OLTXFONT_HEIGHT + 6)

#define DROP_SHADOW_OFF			6

#define PULLDOWN_MARGIN			6
						/* on both sides of pulldown choice buttons */
/* starting y pos for choice placement */
#define PULLDOWN_Y				4
/* starting x pos for choice text placement */
#define PULLDOWN_X				(PULLDOWN_MARGIN + OLBUTTON_END_WID_LFT)
#define TOGGLE_OFFSET			(OLCHECK_BOX_WID - 2)
						/* this much shift in pulldown choice text pos */

/* vertical text-button offset for GRAF_FONT1 */
#define BUTTON_OFFSET			(OLTXFONT_ASCENT + \
									(OLBUTTON_HT - OLTXFONT_HEIGHT - 1)/2)
/* vertical text-button offset for MINI_BUTTON_FONT */
#define MINI_BUTTON_OFFSET		(MINI_MENU_FONT_ASCENT + \
									(OLMINI_HT - MINI_MENU_FONT_HEIGHT - 1)/2)
/* vertical tri offset for GRAF_FONT1 (assuming vert & horz tri of same ht) */
#define TRI_OFFSET				((OLBUTTON_HT - OLTRI_HT) / 2)

/* abbreviated menu button (for option menus) */
#define OLABBREV_DOWN_WID	(Grafont->per_char[OLABBREV_DOWN-G_M].width)
#define OLABBREV_DOWN_HT	(Grafont->per_char[OLABBREV_DOWN-G_M].descent)

/* abbreviated left/right scroll buttons (for entry fields) */
#define OLABBREV_LEFT_WID	(Grafont->per_char[OLABBREV_LEFT-G_M].width)
#define OLABBREV_RIGHT_WID	(Grafont->per_char[OLABBREV_RIGHT-G_M].width)
#define OLABBREV_LEFT_HT	(Grafont->per_char[OLABBREV_LEFT-G_M].descent)

#define OLSCRV_WID			(Grafont->per_char[OLSCRV_MIDDLE-G_M].width)
#define OLSCRV_HT			(Grafont->per_char[OLSCRV_MIDDLE-G_M].descent)
#define OLASCRV_WID			(Grafont->per_char[OLASCRV_MIDDLE-G_M].width)
#define OLASCRV_HT			(Grafont->per_char[OLASCRV_MIDDLE-G_M].descent)
#define OLSCRH_WID			(Grafont->per_char[OLSCRH_MIDDLE-G_M].width)
#define OLSCRH_HT			(Grafont->per_char[OLSCRH_MIDDLE-G_M].descent)
#define OLASCRH_WID			(Grafont->per_char[OLASCRH_MIDDLE-G_M].width)
#define OLASCRH_HT			(Grafont->per_char[OLASCRH_MIDDLE-G_M].descent)
#define OLSCROLLCABLE_WID	(AxBigFont ? 5 : 3)
#define OLSCRV_ANCHOR_HT	(Grafont->per_char[OLSCRV_ANCHOR-G_M].descent)
#define OLSCRV_ANCHOR_WID	(Grafont->per_char[OLSCRV_ANCHOR-G_M].width)
#define OLSCRH_ANCHOR_HT	(Grafont->per_char[OLSCRH_ANCHOR-G_M].descent)
#define OLSCRH_ANCHOR_WID	(Grafont->per_char[OLSCRH_ANCHOR-G_M].width)
#define OLSCROLL_GAP		2
#define OLSCROLL_ELEV		(OLSCRV_HT - OLASCRV_HT)
#define OLSCRV_INCR_HT		(OLASCRV_HT / 2)

#define OLSCRV_MIN_LIMIT	OLASCRV_HT
#define OLSCRV_ABBREV_LIMIT	(OLASCRV_HT+(OLSCRV_ANCHOR_HT<<1)+(OLSCROLL_GAP<<1))
#define OLSCRV_FULL_LIMIT	(OLSCRV_HT+(OLSCRV_ANCHOR_HT<<1)+(OLSCROLL_GAP<<1))
#define OLSCRH_MIN_LIMIT	OLASCRH_WID
#define OLSCRH_ABBREV_LIMIT	(OLASCRH_WID+(OLSCRH_ANCHOR_WID<<1)+(OLSCROLL_GAP<<1))
#define OLSCRH_FULL_LIMIT	(OLSCRH_WID+(OLSCRH_ANCHOR_WID<<1)+(OLSCROLL_GAP<<1))

/* the official y position of scroll buttons in a text field;
 * the '4' term represents the 2pix top margin, 1pix text-rule
 * gap, and 1 thrown in to get the button's bottom shadow to
 * sit on top of the rule
 */
#define OLTXSCROLL_YPOS			(OLTXFONT_HEIGHT + 4 - OLABBREV_LEFT_HT)

/* color abbreviated menu button dimensions */
#define OLCLRABBRBTN_WID		(AxBigFont ? 18 : 16)
#define OLCLRABBRBTN_HT			(AxBigFont ? 16 : 15)
/* color text scroll button y-position */
#define OLCLRTXTSCRL_YPOS		(OLTXFONT_HEIGHT + 4 - OLCLRABBRBTN_HT)

/* slider */
#define OL_HSLIDER_ELEV_WID		(Grafont->per_char[OL_HSLIDER_ELEV-G_M].width)
#define OL_HSLIDER_ELEV_HT		(Grafont->per_char[OL_HSLIDER_ELEV-G_M].descent)
#define OL_HSLIDER_END_LFT_WID	(Grafont->per_char[OL_HSLIDER_END_LFT-G_M].width)
#define OL_HSLIDER_END_RHT_WID	(Grafont->per_char[OL_HSLIDER_END_RHT-G_M].width)
#define OL_HSLIDER_MID1_WID		(Grafont->per_char[OL_HSLIDER_MID1-G_M].width)
#define OL_HSLIDER_MID2_WID		(Grafont->per_char[OL_HSLIDER_MID2-G_M].width)
#define OL_HSLIDER_MID4_WID		(Grafont->per_char[OL_HSLIDER_MID4-G_M].width)
#define OL_HSLIDER_MID8_WID		(Grafont->per_char[OL_HSLIDER_MID8-G_M].width)
#define OL_HSLIDER_MID16_WID	(Grafont->per_char[OL_HSLIDER_MID16-G_M].width)
#define OL_HSLIDER_MID_HT		(Grafont->per_char[OL_HSLIDER_MID1-G_M].descent)



/*************************************************************************
 * AxOpenLook button struct
 */

typedef struct axolbutton {
	char *text;					/* text written on button */
	char *acceltext;			/* 'accelerator' text on pulldown choice */
	int textwidth;				/* if -1, axolDrawButton will measure */
	unsigned int pullRight		:1; /* a pulldown choice that cascades */
	unsigned int pulldownDefault	:1; /* default choice on pd */
	unsigned int menuBar		:1;	/* button controls a pd */
	unsigned int outer			:1;	/* single outer oval as in buttons */
	unsigned int inner			:1;	/* double oval drawn arount text */
	unsigned int highlighted	:1;	/* inside oval reverse vid */
	unsigned int gray			:1;	/* gray screen during action delay */
	unsigned int toggle			:2; /* presence/type of toggle on pd choice */
	unsigned int togwide		:1; /* make room for toggle */
	unsigned int symbolfont		:1; /* alternative text font in button */
	unsigned int mini			:1; /* mini button */
	unsigned int suppressMenuMark :1; /* used w/ button1 on menubar */
} axolButton;



/*************************************************************************
 * Window decor
 */

#define OLWIN_PUSHPIN			1
#define OLWIN_CLOSE				2
#define OLWIN_RESIZE			4
#define OLWIN_HEADER			8

/* cribbed from the XView sources */
typedef struct {
	Atom	win_type;
	Atom	menu_type;
	Atom	pin_initial_state;	
} olWM_Win_Type;





#endif   /* _AXOL_H_ */
/* DON'T ADD DEFS AFTER THIS #endif ( _AXOL_H_ ) */
