/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axwinclr.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:53:45 1998
*/
#if AXMS    /* { (whole file is AXMS only) */
#ifndef _AXWINCLR_H
#define _AXWINCLR_H


#define PALVERSION     0x300
#define PALETTESIZE    256
#define MAXPALETTE     256

#define RGB_WHITE ( RGB(255, 255, 255) )
#define RGB_BLACK ( RGB(0,   0,   0  ) )

extern int AxNColors;      /* total number of colors used by apps */

#if FOR_FILTER
#define GET_COLOR_VALUE(v) (PALETTEINDEX(v))
#define REAL_WHITE_PIXEL (PALETTERGB( 255, 255, 255 ) )
#else

extern short DpyDepth;
/* if display depth is greater than 8 we simply return the color value.
 * otherwise we return a palette index.
 */
#define GET_COLOR_VALUE(v) ( (DpyDepth > 8) ? (v) : (PALETTEINDEX(v)) )

#define REAL_WHITE_PIXEL ( (DpyDepth > 8) ? (RGB(255,255,255)) : ((AxNColors + 10) - 1) )
#endif


/* X version in Xlib.h */
#define DefaultColormap(dpy, scr) MS_GetStockObject(DEFAULT_PALETTE)

/* masks for 16 bit DIBS */
#define RED_MASK16    0x00007C00
#define GREEN_MASK16  0x000003E0
#define BLUE_MASK16   0x0000001F

#define AX_DIB_NORMAL 		1
#define AX_DIB_MASK   		2
#define AX_DIB_TRANSPARENT	3

#endif    /* _AXWINCLR_H */
#endif    /* } AXMS (whole file is AXMS only) */
