/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ddlregw.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:41 1998
*/
#if 0 /* { NOT USING WIDGETS */

/*
static char sccs_id [] = "@(#) ddlregw.c 7.2";
*/
#include <stdio.h>
#include <DrgDrpLibP.h>
typedef char * caddr_t;    /* X11R4/Motif headers fight ANSI C */
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>


typedef struct info
{
    struct info * next;
    Widget        w;
    DrgDrpContext c;
}
info;

static info *registrations = NULL;

static void filter_event ();


int DrgDrpRegisterWidget (widget, formats, n_formats, callback, closure)
Widget widget;
Atom *formats;
unsigned int n_formats;
void (*callback)();
void *closure;
{
    info *context = NULL;
    info *ptr;
    Display *dpy = XtDisplay (widget);
    Window w = XtWindow (widget);

    for (ptr = registrations; ptr != NULL; ptr = ptr->next)
        if (ptr->w == widget)
            context = ptr;
    if (context == NULL)
    {
        context = malloc (sizeof (info));
        if (context == NULL)
            return (False);
        context->c.events = NULL;
        context->w = widget;
        context->next = registrations;
        registrations = context;
    }

    context->c.callback = callback;
    context->c.closure = closure;

    XtAddEventHandler (widget, (EventMask) 0, True, filter_event, context);
    XGrabServer (dpy);
    XChangeProperty (dpy, w, DrgDrp_Atom (dpy), XA_WINDOW, 32,
                     PropModeReplace, (unsigned char *) &w, 1);
    XChangeProperty (dpy, w, DrgDrp_Atom (dpy), XA_WINDOW, 32,
                     PropModeAppend, (unsigned char *) formats, n_formats);
    XUngrabServer (dpy);
    return True;
}


int DrgDrpUnregisterWidget (widget)
Widget widget;
{
    Display *dpy = XtDisplay (widget);
    info **pp;
    info *p;

    XDeleteProperty (dpy, XtWindow (widget), DrgDrp_Atom (dpy));
    for (pp = &registrations; p = *pp, p != NULL; pp = &(p->next))
        if (p->w == widget)
        {
            *pp = p->next;
            free (p);
            return True;
        }
    return True;
}


static void filter_event (w, closure, e, cont_to_disp)
Widget w;
XtPointer closure;
XEvent *e;
Boolean *cont_to_disp;
{
    *cont_to_disp = DrgDrpFilterEvent (e, &(((info *) closure)->c));
}

#else /* } { */
/* So that cc(1) does not warn about empty source */
void ddlregwhack()
{
	return;
}
#endif /* } */
