/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: fntcach.c
   Applix ASC version: 119
   Date: Wed Feb 24 21:13:19 1999
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#if AXMS
#include <basicwin.h>
#endif

#include <aos.h>
#include <eldata.h>
#include <fontcach.h>
#include <axtext.h>
#include <axhtab.h>
#include <axgfs.h>
#include <axfont.h>
#include <axprint.h>
#include <axhtab.h>

#define MXREC 257 /* maximum record length assumed in metrics files */
#define WHITESPACE(ch) (ch==' '|| ch=='\t' || ch==0x0d)
#define AIR(ch) (ch==' '|| ch=='\t' || ch=='\n')
#define DONTCARE 0

extern Display *Dpy;
extern Window RootWin;
extern char* ThimApplixDir;
extern char *DirSlash;
#if FOR_FILTER
XFontStruct *AxDlgMainFont;
#else
extern XFontStruct *AxDlgMainFont;
#endif

#if !FOR_FILTER
extern short THIMpid;
extern data_ptr ElfRetData;
#endif
#if AXMS
int AxElfrtHasNoFonts;	/* if elfrt mode nad cannot find applix fonts */
#else
extern int AxElfrtHasNoFonts;	/* if elfrt mode nad cannot find applix fonts */
#endif

extern char *XLT();
extern char *GetProfileByStr();
extern char *axMakeCompoundWinName();
extern char *AGetHomeDir();
extern int getTfmMetrics();
extern int getTargetFontMetrics();
extern int copyTargetFontMetrics();
extern int freeTargetFontMetrics();
extern int getScreenFontMetrics();
extern int copyScreenFontMetrics();
extern int freeScreenFontMetrics();
extern int getLetterform();
extern int copyLetterform();
extern int freeLetterform();
extern int axGetWinScreenMetrics();
extern int AxPrintSetupFromClassAndType();
extern int axtInitMilTables();
extern int isGFSxlfdName();
extern int haveGFSServer();
#if !FOR_FILTER
extern int ElfbNewTask();
#endif
extern XFontStruct *AXLoadQueryFont();
extern void *THIMfree();
extern void ParseCompoundWinName();
extern void foldFontRecordDefaults();
extern void axgfsInitCharStruct();
extern Pixmap XCreatePixmap();
extern XFontStruct *axgfsOpenFont();

#if AXMS    /* { */
  /* names we re-implement under windows */
int WinPrinterToXFontMetrics();
extern HDC AxGetPrinterHDC(char*, int*);
extern HDC GetDefaultPrinterHDC(void);
int WinTrueTypeToXFontMetrics(HFONT, fontMetrics*, int);
void EnumeratePrinterFonts(char *printer_name, int *targetRes);

extern int Running_WindowsNT;
#endif    /* } AXMS */


#if !FOR_FILTER
extern void FreeFontFamilyCache();
#endif

int axtDecipointSize();
int freeFontRecord(), freeTargetMetrics(), fontMetricsSize();
int axGetTargetFontMetrics();
int axGetCache(), copyFontRecord();
int axPrintDevice();
int axGetWinTargetMetrics();
int qRound();
int axtWellFormedXLFD();
char *getErrString(), *axtXLFDencodingName();
char *axGetFontRecord(), *axGetFontFamily();
char *axGetLetterformImage(), *axGetLetterformPixmap();
char *axGetScreenMetrics(), *axGetEncodingName();
char *axGetTargetMetrics(), *axGetCacheItem();
char *axGetCharacterCode(), *axGetFontRecordName();
char *axGetReferenceCellStruct();
char **axListFontFamilies();
char *axGetXLFD();
char *axGetFontRecordForScreen();
char *axFontmetricsPathname();
void axLoadCacheItem(), loadFontRecord();
void freeErrString(), axtFormScalableName();
unsigned long kickOutCounterValue();
void reverseSXRT();
void  completeCurrentRecord();
void FreeFontCache();
FILE *getFontmetricsFile();
fontTabEnt *newFontRecord();
XCharStruct *getCharStruct();

/* int getFontRecord();    should be static (atmproto.h) */

#if AXMS
int EnumerateWinFonts();
#endif

static int getTargetMetrics();
static int getAfmMetrics();
static int getScreenMetrics();
static int getFontFamily();
static int getEncodingPair();
static int getEncoding();
static int copyTargetMetrics();
static int copyScreenMetrics();
static int copyFontFamily();
static int copyEncodingPair();
static int copyEncoding();
static int freeScreenMetrics();
static int freeFontFamily();
static int freeEncodingPair();
static int freeEncoding();
static int fontRecordSize();
static int nativeFamily();
static int getTrivialItem();
static int copyTrivialItem();
static int freeTrivialItem();
static int axGetDpiTargetFontMetrics();
static int extDataSize(), getKeyVal();
static int axtScalableFontName();
static int writeCharStrType();
static int deleteItem();
static int axtScalableFontName();
static int writeCharStrType();
static int deleteItem();
static int screenFontServerSize();
int getEncodingType();    /* should be static (atmproto.h) */
static int getItem();

static void readBoldItal(), cacheBaseFontSetNames();
static void getCellFontMetrics(), writeIntegerType();
static void setCacheLimit();
/* void initFontCache();     should be static (atmproto.h) */
static void closeFile();

static int getFontRecord(/* char *notUsed, char **rp, int *sizep, char *notUsed2 */);
static void initFontCache();

typedef struct c_item {
    struct c_item *next;
    char *name;
    char *value;
    int size; /* size of *value */
    int lru;
} cItem;

typedef struct cash_list {
    int limit;
    int usage;
    int tableWidth;
    cItem **table;
    unsigned long kickOutCounter;  /* bumped each time an item's kicked */
    unsigned long fetchCounter;    /* bumped each time item created */
} cashList;

typedef struct font_cash {
    int (**fetch)(); /* constructor */
    int (**toss)();  /* destructor */
    int (**copy)();  /* copy constructor */
    int numLists;
    cashList *lists; /* an array numLists in size */
} fontCash;

int ScreenRes, TargetRes;

static fontCash AxFontCache;

/*************************************************************************
function: ElfbGetFontFamilies - Return list of available font families.
*/
ElfbGetFontFamilies( eight_bit_fonts_bit_only )
int eight_bit_fonts_bit_only;
{
#if !FOR_TESTER
#if !FOR_FILTER 
    char **fams;
    int number, ix;
    data_ptr aP;

    fams = axListFontFamilies((char **) NULL, 0, &number);
    aP = AxMakeArray(1);
    for (ix = 0; ix < number; ix++) {
#if BUILD_ORIENT        
        if (eight_bit_fonts_bit_only) {
#if BUILD_KANJI
            if (!IsWideFontFace(fams[ix]) && !IsNarrowKanaFontFace(fams[ix])) 
#else
            if ( !IsWideFontFace(fams[ix]) ) 
#endif
                {
                aP = AxAddStrToArray(aP, ix, fams[ix]);
                }
        }
        else {
            aP = AxAddStrToArray(aP, ix, fams[ix]);
        }
#else
        aP = AxAddStrToArray(aP, ix, fams[ix]);
#endif      
    }
    ElfRetData = aP;
    
    if (fams) {
        for (ix = 0; ix < number; ix++) {
            THIMfree((char *) fams[ix]);
        }
        THIMfree((char *) fams);
    }
#endif  
#endif
    return (TRUE);
}


int
initFonts(lineNumber)
int *lineNumber; /* out */
{
    int lineNo = 0;

    initFontCache();
    if(!updateFontTable(NXLT("fontmap.dir"), &ScreenRes,
                        &TargetRes, &lineNo)) {
        *lineNumber = lineNo;
        return FALSE;
    }
    *lineNumber = lineNo;
    return TRUE;
}


/* public wrapper functions for various item access
 */

int   /* returns index value for use with named cache */
axGetCache(cacheName, tFuncs)
char *cacheName;
typeFuncs *tFuncs;  /* fetch, copy, toss function info needed
                     * for cache creation */
{
    int *dex, itemsize;
    if(!getItem(FIND, CACHELISTS, cacheName,
                (char **) &dex, &itemsize, (char *) tFuncs)) {
        return 0;
    }
    else
        return (*dex);
}

char *  /* OK if null; otherwise, caller must free returned string */
axGetCacheItem(cacheName, itemName, itemValue, itemSize)
char *cacheName;
char *itemName;
char **itemValue;  /* out: do not free this cache item address */
int *itemSize;     /* out */
{
    char *cacheItem;

        /* it's expected that the named cache already exists */
    int dex = axGetCache(cacheName, (typeFuncs *) NULL);
    if (!dex) {
        *itemValue = (char *) NULL;
        return(getErrString(XLT("Could not find cache named"),
                            cacheName));
    }
    if (!getItem(FIND, dex, itemName, (char **) &cacheItem,
                 itemSize, (char *) NULL)) {
        return(getErrString(XLT("Lookup failed for cache item named"),
                            itemName));
    }
    *itemValue = (char *) cacheItem;
    return ((char *) NULL);
}

void
axLoadCacheItem(cacheName, itemName, itemValue, itemSize)
char *cacheName;
char *itemName;
char *itemValue;  /* in: address of item to be copied into cache */
int itemSize;     /* total size of *itemValue */
{
        /* it's expected that the named cache already exists */
    int dex = axGetCache(cacheName, (typeFuncs *) NULL);
    if (!dex) {
        return;
    }
    getItem(LOAD, dex, itemName, (char **) &itemValue,
            &itemSize, (char *) NULL);
}


char *  /* OK if null, otherwise caller must free returned string */
axGetTargetMetrics(metricsName, fontRecord, metricsItem)
char *metricsName;
fontTabEnt *fontRecord;
fontMetrics **metricsItem;  /* out: do not free this cache item address */
{
    int itemsize;
    fontMetrics *fm;

    if(!getItem(FIND, TARGET_METRICS, metricsName, (char **) &fm,
                &itemsize, (char *) fontRecord)) {
        *metricsItem = (fontMetrics *) NULL;
        return(getErrString(
               XLT("Could not find target metrics file named"),
                            metricsName));
    }
    *metricsItem = fm;
    return((char *) NULL);
}

char *  /* OK if null, otherwise caller must free returned string */
axGetScreenMetrics(screenMetricsName, targetFontRec, metricsItem)
char *screenMetricsName;    /* in */
fontTabEnt *targetFontRec;  /* in */
fontMetrics **metricsItem;  /* out: do not free this cache item address */
{
    int itemsize, ix, firstFailure;
    fontMetrics *fm;
    static char **problemNames = (char **) NULL;
    static int numProblemNames = 0;
    static fontMetrics *dbFont = (fontMetrics *) NULL;

    if(!getItem(FIND, SCREEN_METRICS, screenMetricsName, (char **) &fm,
                &itemsize, (char *) targetFontRec)) {
        
            /* can't open the screenfont; supply a pointer to
             * our main dialog box font as a substitute. oh well..
             */
        if (!dbFont) {
            dbFont = (fontMetrics *) malloc(sizeof(fontMetrics));
            memset((char *) dbFont, 0, sizeof(fontMetrics));
            dbFont->xfont = AxDlgMainFont;
            dbFont->resolution = ScreenRes;
        }
        *metricsItem = dbFont;

#if !FOR_FILTER
            /* test whether to post a box warning of the problem
             */
        for (ix = 0, firstFailure = TRUE; ix < numProblemNames; ix++) {
            if (!strcmp(screenMetricsName, problemNames[ix])) {
                
                    /* this screenfont has already been tried this session
                     */
                firstFailure = FALSE;
                break;
            }
        }
        if (firstFailure) {
            char *message_args;
            char *winFamily;
            char pointsize_str[32];    /* big enough for ascii maxint */
            int len, pointsize, weight, slant;
            
            problemNames = (char **) realloc
                (problemNames, (numProblemNames + 1) * sizeof(char *));
            problemNames[numProblemNames] = (char *) malloc
                (strlen(screenMetricsName) + 1);
            strcpy(problemNames[numProblemNames], screenMetricsName);
            numProblemNames++;
            
                /* post a box directly to warn of this failed load attempt
                 * first, need to build an arg vector in which some individual
                 * args are quote-wrapped, then call newtask
                 */
#if AXMS
                    /* get pointsize from AXMS-style xlfd name
                     */
            winFamily = malloc(strlen(screenMetricsName) + 1);
            ParseCompoundWinName(winFamily, &pointsize, &weight, &slant,
                                 screenMetricsName);
#else
                    /* get pointsize from xlfd
                     */
            pointsize = axtDecipointSize(screenMetricsName) / 10;
#endif
            
                    /* alloc for format: fam pointsize bold italic
                     */
            if (targetFontRec) {
                len = strlen(targetFontRec->familyName);
            }
            else {
                len = 1;
            }
            len += strlen(screenMetricsName);
            len += 16;  /* 2 pairs quotes, 3 between-spaces, null, fudge */
            len += strlen(XLT("bold "));
            len += strlen(XLT("italic "));
            message_args = (char *) malloc(len);
            strcpy(message_args, NXLT("\""));
            if (targetFontRec) {
                strcat(message_args, targetFontRec->familyName);
            }
            strcat(message_args, NXLT("\" \""));
            strcat(message_args, screenMetricsName);
            strcat(message_args, NXLT("\" "));
            sprintf(pointsize_str, "%d ", pointsize);
            strcat(message_args, pointsize_str);
            if (targetFontRec) {
                    /* use the same bold,ital nomenclature as on
                     * our char atts' menus, regardless of the font..
                     */
                if (targetFontRec->weight) {
                    strcat(message_args, XLT("bold "));
                }
                if (targetFontRec->slant) {
                    strcat(message_args, XLT("italic "));
                }
            }

			if ( !AxElfrtHasNoFonts )
	            ElfbNewTask(NXLT("cant_open_screenfont$"), message_args);
            free(message_args);
#if AXMS
            free(winFamily);
#endif
        }
#endif      /* !FOR_FILTER */
    }
    else {
        *metricsItem = fm;     /* lookup succeeded */
    }
    return((char *) NULL);
}

char *  /* OK if null, otherwise caller must free returned string */
axGetReferenceCellStruct(referenceCellName, fs)
char *referenceCellName;    /* in:  name in <width> <ascent> <descent> form */
XFontStruct **fs;           /* out: do not free */
{
    int itemsize;

    if(!getItem(FIND, REFERENCE_CELL, referenceCellName, (char **) fs,
                &itemsize, (char *) NULL)) {
        *fs = (XFontStruct *) NULL;
        return(getErrString(XLT("Could not find reference cell named"),
                            referenceCellName));
    }
    return((char *) NULL);
}

char *  /* OK if null, otherwise caller must free returned string */
axGetLetterformImage(letterformName, letterInfo, letterImage)
char *letterformName;
chSeg *letterInfo;
XImage **letterImage;  /* out: do not free this cache item address */
{
    int itemsize;
    XImage *im;
    if (!getItem(FIND, LETTERFORM, letterformName, (char **) &im,
                 &itemsize, (char *) letterInfo)) {
        *letterImage = (XImage *) NULL;
        return(getErrString(
               XLT("Could not find letterform named"),
                            letterformName));
    }
    *letterImage = im;
    return((char *) NULL);
}

char *  /* OK if null, otherwise caller must free returned string */
axGetLetterformPixmap(letterformName, letterInfo, letterPix)
char *letterformName;
chSeg *letterInfo;
Pixmap *letterPix;  /* out: do not free this cache item address */
{
    int itemsize;
    Pixmap pix;
    
    if (!getItem(FIND, LETTERFORM, letterformName, (char **) &pix,
                 &itemsize, (char *) letterInfo)) {
        *letterPix = (Pixmap) NULL;
        return(getErrString(
               XLT("Could not find letterform named"),
                            letterformName));
    }
    *letterPix = pix;
    return((char *) NULL);
}

char *  /* OK if null, otherwise caller must free returned string */
axGetFontFamily(familyName, familyRecord)
char *familyName;
fontFamilyRecord **familyRecord; /* out: don't free this cache item address */
{
    int itemsize;
    fontFamilyRecord *fam = (fontFamilyRecord *) NULL;
    
    if (!getItem(LOOKUP, FONTFAMILY, familyName, (char **) &fam,
                 &itemsize, (char *) NULL)) {
        
            /* lookup failed; try again using the default name
             */
        if (!getItem(LOOKUP, FONTFAMILY, NXLT("axDefaultFontFamily"),
                     (char **) &fam, &itemsize, (char *) NULL)) {
            
            *familyRecord = (fontFamilyRecord *) NULL;
            return(getErrString(
                                XLT("Could not find font family named"),
                                familyName));
        }
    }
    
    if (fam->aliasFor) {
            /* convert to the font family named by aliasFor,
             * for instance "Times New" -> "Times New Roman"
             */
        char *lFamily;

            /* probably unnecessarily paranoid, but take a copy
             * of the alias just in case the cache code kicks out
             * *fam during the upcoming lookup..
             */
        lFamily = (char *) malloc (strlen(fam->aliasFor) + 1);
        strcpy(lFamily, fam->aliasFor);
        
        if (!getItem(LOOKUP, FONTFAMILY, lFamily, (char **) &fam,
                     &itemsize, (char *) NULL)) {
        
                /* lookup failed; try again using the default name
                 */
            if (!getItem(LOOKUP, FONTFAMILY, NXLT("axDefaultFontFamily"),
                         (char **) &fam, &itemsize, (char *) NULL)) {
            
                *familyRecord = (fontFamilyRecord *) NULL;
                free(lFamily);
                return(getErrString(
                                    XLT("Could not find font family named"),
                                    familyName));
            }
            free(lFamily);
            *familyRecord = fam;    /* found the default family */
            return ((char *) NULL);
        }
        free(lFamily);
    }

    *familyRecord = fam;        /* real family, alias, or null */
    return((char *) NULL);
}

char *
axGetFontRecordName(familyName, weight, slant, fontName)
char *familyName; /* e.g., "Times" */
int weight;
int slant;
char **fontName; /* out: caller must free */
{
    int ix, bold, ital;
    fontFamilyRecord *fFam;
    familyMember *fMem = (familyMember *) NULL;
    char *errString;

        /* get the font family record */
    if (!familyName) {
        return (getErrString(XLT("The font family name is null.."),
                (char *)NULL));
    }

    if (errString = axGetFontFamily(familyName, &fFam)) {
        return errString;
    }
    else {
            /* got family: search for member which matches the
               passed weight and slant values */
        if (fFam->numMembers > 0) {
            for(ix = 0; ix < fFam->numMembers; ix++) {
                fMem = fFam->members[ix];
                readBoldItal(fMem->propName, &bold, &ital);
                if (bold == weight && ital == slant) {
                    break;
                }
            }
            if (fMem) {
                *fontName = (char *)
                    malloc (strlen(fMem->fontName) + 1);
                strcpy(*fontName, fMem->fontName);
            }
        }
        else {
                /* there are no members present; a typical reason
                   is that this font family is not in the cache;
                   use default info */
            *fontName = (char *) malloc
                (strlen(NXLT("axDefaultFontRecord")) + 1);
            strcpy(*fontName, NXLT("axDefaultFontRecord"));
        }
    }
    return ((char *) NULL);
}

char *  /* OK if null, otherwise caller must free returned string */
axGetFontRecord(fontName, fontRecord)
char *fontName;
fontTabEnt **fontRecord;  /* out: do not free this cache item address */
{
    int itemsize;
    fontTabEnt *ftab;
    int ret;

    ret = getItem(LOOKUP, FONTRECORD, fontName, (char **) &ftab,
                  &itemsize, (char *) NULL);
    if ( !ret ) {
        /* use the default font record.. usually a lousy fallback
         */
        if (!getItem(FIND, FONTRECORD, NXLT("axDefaultFontRecord"),
                     (char **) &ftab, &itemsize, (char *) NULL)) {
            *fontRecord = (fontTabEnt *) NULL;
            return (getErrString(
       XLT("Cannot find default font record, in attempt to lookup font named"),
                                 fontName));
        }
    }

    *fontRecord = ftab;
    return ((char *) NULL);
}

      /* This function is appropriate for Adobe-style metrics data */
char *    /* OK if null, otherwise caller must free */
axGetCharacterCode(encodingName, charName, charCode)
char *encodingName;  /* e.g., "ISOLatin1Encoding" */
char *charName; /* e.g., "asterisk" */
int **charCode;  /* out */
{
    int itemsize, *tcode;
    int listIndex = getEncodingType(encodingName);
    
    if(!getItem(FIND, listIndex, charName, (char **)&tcode,
                &itemsize, (char *)NULL)) {
        *charCode = (int *) NULL;
        return(getErrString(
               XLT("Could not find character code in encoding"),
                            encodingName));
    }
    *charCode = tcode;
    return ((char *) NULL);
}

/* : axGetEncodingName - return a pointer to a string
 * expressing the charset encoding for the named font
 * family. Do not free returned pointer
 *
 * On failure, the default encoding name of "iso8859-1" is returned.
 */
char *
axGetEncodingName(familyName)
char *familyName;   /* e.g., "Times" */
{
    int unspecified;
    char *err, *fontRecName;
    char *encName;
    fontTabEnt *ftab = (fontTabEnt *) NULL;

    encName = NXLT("iso8859-1");
    unspecified = FALSE;
    
    if (err = axGetFontRecordName(familyName, 0, 0, &fontRecName)) {
        freeErrString(err);
    }
    else {
        if (err = axGetFontRecord(fontRecName, &ftab)) {
            freeErrString(err);
        }
        free(fontRecName);
    }
    
    if (ftab && ftab->encodingFileName) {
        /* check for variations from the default encoding file "latin1.enc"
         */
        if (!strcmp(ftab->encodingFileName, NXLT("ymb.afm"))) {
            /* this is in the adobe symbol encoding
             */
            unspecified = TRUE;
        }
        if (!strcmp(ftab->encodingFileName, NXLT("zpd.enc"))) {
            /* this is in the (our!) zapf dingbats encoding
             */
            unspecified = TRUE;
        }
        if (!strcmp(ftab->encodingFileName, NXLT("unspecified"))) {
            unspecified = TRUE;
        }
        else if (!strcmp(ftab->encodingFileName, NXLT("bics.enc"))) {
            /* bitstream internal encoding
             */
            encName = NXLT("bics-1");
        }
        else if (!strcmp(ftab->encodingFileName, NXLT("tmr.afm"))) {
            /* adobe standard encoding
             */
            encName = NXLT("adobe-fontspecific");
        }
    }
    if (unspecified) {
        encName = NXLT("unspecified");
    }
    return (encName);
}

/* : axGetEncodingNameFromFile - return a pointer to a string
 * expressing the charset encoding found in the passed .enc/.afm file.
 * *** Do _not_ free returned pointer.  On failure, NULL is returned.
 */
char *                             /* out: e.g., "ISOLatin1Encoding" */
axGetEncodingNameFromFile(encoding_filename)
char *encoding_filename;           /* in: e.g., "latin1.enc" */
{
	int itemsize;
	char *encoding_namestr = (char *) NULL;
	
    if (!getItem(FIND, ENCODING, encoding_filename, &encoding_namestr,
                 &itemsize, (char *) NULL)) {
        return ((char *) NULL);
    }
	return encoding_namestr;
}

void
loadFontRecord(fEnt)
fontTabEnt *fEnt;
{
    int ix, newsiz, itemsize, tsiz;
    int bold, ital;
    fontFamilyRecord *fFam, *oldFam;
    fontTabEnt *currRec, *localRec, *tmpRec;
    familyMember *fMem;
    int found = FALSE;
    char *famMod[20];
    
    if (!fEnt)
        return;

    if (fEnt->xNames)
        fEnt->xNamesKnown = TRUE;

    tmpRec = (fontTabEnt *) NULL;
    localRec = (fontTabEnt *) NULL;

#if AX_X11
    if (fEnt->xNames) {
            /* set whether scalable
             */
        if (fEnt->xNameCount == 1 &&
            axtScalableFontName(fEnt->xNames[0])) {
            fEnt->scalable = TRUE;
            if (fEnt->scalableName)
                free((char *) fEnt->scalableName);
            tsiz = strlen(fEnt->xNames[0]) + 1;
            fEnt->scalableName = (char *) malloc(tsiz);
            strcpy(fEnt->scalableName, fEnt->xNames[0]);
        }
    }
#else
    /* On NT, since we may have the same fonts under different names (and
     * coming from either the system, print driver or our own fontmap.dir),
     * we check to see if we have a duplicate font by testing against
     * family name, weight and slant. If we find a match <<AND>> the global
     * name (which the font cache will use as a key) is not the same,
     * then we change the name to the one we know about ('fMem->fontName')
     * and continue on so that we find a duplicate and fold in all the
     * necessary attributes.                -donato
     */
    /* first, we look for a duplicate. */
    getItem(FIND, FONTFAMILY, fEnt->familyName,
            (char **)&oldFam, &itemsize, (char *)NULL);
    for(ix = 0, found = FALSE; ix < oldFam->numMembers; ix++) {
        fMem = oldFam->members[ix];
        readBoldItal(fMem->propName, &bold, &ital);
        if (bold == fEnt->weight && ital == fEnt->slant) {
            found = TRUE;
            break;             /* already there; we're done */
        }
    }
    /* Then check for a name difference. */
    if ( found && strcmp(fMem->fontName, fEnt->globalName) ) {
        fontTabEntUse *tmpUse = &fEnt->use;
        copyFontRecord((char *) DONTCARE, (char **) &tmpRec,
                           (char *) DONTCARE, (char *) fEnt);
        free(tmpRec->globalName);
        tmpRec->globalName = (char*)malloc(strlen(fMem->fontName)+1);
        strcpy(tmpRec->globalName, fMem->fontName);
        fEnt = tmpRec;    /* convert fEnt to tmpRec */
        /* do this to make sure all necessary attrs are folded in later. */
        fEnt->use = *tmpUse;
    }
#endif

    if (!strcmp(fEnt->globalName, NXLT("axDefaultFontFamily"))) {
            /* this block is here just to handle an bug in old fontmap.dir
             * files in which a record is provided named 'axDefaultFontFamily'.
             * Bash the name to 'axDefaultFontRecord'.  What a hack.
             */
                /* take a copy of the passed record onto localRec
                 */
        copyFontRecord((char *) DONTCARE, (char **) &localRec,
                       (char *) DONTCARE, (char *) fEnt);
        
                /* replace globalName
                 */
        free(localRec->globalName);
        localRec->globalName = malloc(strlen(NXLT("axDefaultFontRecord")) + 1);
        strcpy(localRec->globalName, NXLT("axDefaultFontRecord"));
        
        fEnt = localRec;    /* convert fEnt to localRec */
    }
    else if (getItem(LOOKUP, FONTRECORD, fEnt->globalName,
                (char **)&currRec, &itemsize, (char *)NULL)) {
        
        fontTabEntUse whichCurrent;
        
        /* this record already exists, currRec points to it;
         * overload it using the passed record (fEnt).
         */
        if (fEnt->aliasFor) {
            /* don't overload if the passed record is an alias.
             * The exisiting record is assumed to be the real thing,
             * so it's best to just use the existing one.
             */
            if (localRec) {
                freeFontRecord((char **) &localRec);
            }
            if (tmpRec) {
                freeFontRecord((char **) &tmpRec);
            }
            return;
        }
        
        /* make sure family name matches also. */
        if ( !strcmp(fEnt->familyName, currRec->familyName) ) {
                /* take a copy of currRec onto localRec
                 */
            copyFontRecord((char *) DONTCARE, (char **) &localRec,
                           (char *) DONTCARE, (char *) currRec);
        
                /* prevent copying of globalName and familyName;
                 * allow all other members thru
                 */
            memset((char *) &whichCurrent, 0, sizeof(fontTabEntUse));
            whichCurrent.globalName = TRUE;
            whichCurrent.familyName = TRUE;
        
                /* fold fEnt data onto localRec
                 */
            foldFontRecordDefaults(fEnt, &fEnt->use, localRec, &whichCurrent);

            fEnt = localRec;    /* convert fEnt to localRec */
        }
    }

        /* cache the font record
         */
    itemsize = fontRecordSize(fEnt);
    getItem(LOAD, FONTRECORD, fEnt->globalName,
            (char **)&fEnt, &itemsize, (char *)NULL);
    
    if (fEnt->gallium && fEnt->scalableName) {
        /* need to update the fontTabEnt reference living in
         * the cache of GFS xlfd names, because the LOAD that just
         * happened may not have been the first for this record,
         * (which would've readdressed the record's memory....)
         */
        fontfile_xlfd *xf = (fontfile_xlfd *) NULL;
        if (isGFSxlfdName(fEnt->scalableName, &xf) && xf) {
            fontTabEnt *fcacheRef;
            char *errstring;
            
            errstring = axGetFontRecord(fEnt->globalName, &fcacheRef);
            if (errstring) {
                freeErrString(errstring);
                xf->ftab = (fontTabEnt *) NULL;
            }
            else {
                xf->ftab = fcacheRef;
            }
        }
    }

        /* now, get the font family item, and make sure that
         * this record's global name is represented there
         */
    getItem(FIND, FONTFAMILY, fEnt->familyName,
            (char **)&oldFam, &itemsize, (char *)NULL);
    for(ix = 0, found = FALSE; ix < oldFam->numMembers; ix++) {
        fMem = oldFam->members[ix];
        readBoldItal(fMem->propName, &bold, &ital);
        if (bold == fEnt->weight && ital == fEnt->slant) {
            found = TRUE;
            break;             /* already there; we're done */
        }
    }
    if (!found) {
            /* add this record's name to the family */
                /* copy onto a new fam struct, and include new stuff
                 */
        copyFontFamily((char *)NULL, (char **)&fFam, (char *)NULL,
                       (char *)oldFam);
        newsiz = itemsize;
        fFam->numMembers++;
        if(fFam->members) {
            fFam->members = (familyMember **)realloc(
                             (char *)fFam->members,
                             fFam->numMembers * sizeof(familyMember *));
        }
        else {
            fFam->members = (familyMember **)
                malloc(sizeof(familyMember *));
        }
        newsiz += fFam->numMembers * sizeof(familyMember *);
        ix = fFam->numMembers - 1;
        fFam->members[ix] = (familyMember *)
            malloc(sizeof(familyMember));
        newsiz += sizeof(familyMember);
        fMem = fFam->members[ix];
        tsiz = strlen(fEnt->globalName) + 1;
        fMem->fontName = (char *)malloc(tsiz);
        newsiz += tsiz;
        strcpy(fMem->fontName, fEnt->globalName);
        
            /* build a property string out of bold, ital; real quick
             * for now.. bold->"b,", ital->"i,", etc..
             */
        MBstrcpy(famMod, "");
        if (fEnt->weight)
            MBstrcat(famMod, "b,");
        if (fEnt->slant)
            MBstrcat(famMod, "i,");
        tsiz = MBstrlen(famMod) + 1;
        fMem->propName = (char *)malloc(tsiz);
        newsiz += tsiz;
        MBstrcpy(fMem->propName, famMod); /* like "b,i,", for bold & ital */
#if AXMS
        fFam->isWindowsFont = fEnt->isWindowsFont;
        fFam->isPrinterFont = fEnt->isPrinterFont;
#endif
            /* propagate any alias info up to the family
             */
        if (fEnt->aliasFor) {
            fFam->aliasFor = (char *) malloc(strlen(fEnt->aliasFor) + 1);
            strcpy(fFam->aliasFor, fEnt->aliasFor);
        }
        
            /* cache new fam struct
             */
        getItem(LOAD, FONTFAMILY, fEnt->familyName,
                (char **)&fFam, &newsiz, (char *)NULL);
        
            /* the LOAD operation takes a copy; free the local copy
             */
        freeFontFamily((char **) &fFam);
    }
    
    if (localRec) {
        freeFontRecord((char **) &localRec);
    }
    if (tmpRec) {
        freeFontRecord((char **) &tmpRec);
    }
}



/* : axGetTargetFontMetrics - lookup pixel target metrics data (1000 dpi) */
int
axGetTargetFontMetrics(family, weight, slant, pointsize, metrics)
char *family;  /* e.g., "Times" */
int weight;
int slant;
int pointsize;  /* where 12.0 points comes in as 120000 */
targetFontMetrics **metrics;  /* out: init this reference */
{
    int ret;

    ret = axGetDpiTargetFontMetrics(family, weight, slant, pointsize,
                                                            P_DPI, metrics);
    return(ret);
}


/* : axGetTargetFontMetrics300 - lookup pixel target metrics data (300 dpi) */
int
axGetTargetFontMetrics300(family, weight, slant, pointsize, metrics)
char *family;  /* e.g., "Times" */
int weight;
int slant;
int pointsize;  /* where 12.0 points comes in as 120000 */
targetFontMetrics **metrics;  /* out: init this reference */
{
    int ret;

    ret = axGetDpiTargetFontMetrics(family, weight, slant, pointsize,
                                                                300, metrics);
    return(ret);
}


/* : axGetDpiTargetFontMetrics - lookup pixel target metrics data */
static int
axGetDpiTargetFontMetrics(family, weight, slant, pointsize, res, metrics)
char *family;  /* e.g., "Times" */
int weight;
int slant;
int pointsize;  /* where 12.0 points comes in as 120000 */
int res;  /* dpi - 1000, 300, ... */
targetFontMetrics **metrics;  /* out: init this reference */
{
    char name[256];  /* guess max.. no checks, either */
    char *errString;
    char *recName = (char *) NULL;
    int tmp;
    fontMetrics *targ;
    fontTabEnt *ftab;
    targetFontAttrs tfattrs;
    
        /* form name of metrics item */
    sprintf(name, "%s %d %d %d %d", family, pointsize, weight, slant, res);

        /* init attrs data */
    memset((char *)&tfattrs, 0, sizeof(targetFontAttrs));
    tfattrs.resolution = res;
    tfattrs.attrs.fontFamily = family;
    tfattrs.attrs.weight = weight;
    tfattrs.attrs.slant = slant;
    tfattrs.attrs.pointsize = pointsize;

    if (!getItem(FIND, TARGETFONT_METRICS, name, (char **) metrics,
                 &tmp, (char *) &tfattrs)) {
        *metrics = (targetFontMetrics *) NULL;
        return FALSE;
    }

    if ((*metrics)->kickoutCount !=
        (unsigned int)(tmp = kickOutCounterValue(TARGET_METRICS))) {

        (*metrics)->kickoutCount = tmp;  /* update */

            /* need to do a lookup on the 'metrics' member
               of the targetFontMetrics struct */
        if (errString = axGetFontRecordName(tfattrs.attrs.fontFamily,
                                            tfattrs.attrs.weight,
                                            tfattrs.attrs.slant,
                                            &recName)) {
            free(recName);
            freeErrString(errString);
            return FALSE;
        }
        if (errString = axGetFontRecord(recName, &ftab)) {
            free(recName);
            freeErrString(errString);
            return FALSE;
        }
        free(recName);
        if (errString = axGetTargetMetrics(ftab->targetMetricsNames[0],
                                           ftab, &targ)) {
            freeErrString(errString);
            return FALSE;
        }
        (*metrics)->metrics = targ;
    }

    return TRUE;
}


/* : getXFontStruct - use fontcache to get XFontStruct for
 * specified attributes.  A TRUE return means that a screenfont
 * is available that exactly matches the passed attrs (though for
 * pointsize we'll return a nearest 'fit' if the exact size can't be
 * found), and that the XFontStruct's addr is returned on fp.
 * 
 */
int /* TRUE if ok */
getXFontStruct(familyName, pointsize, weight, slant, scalable, fp)
char *familyName; /* e.g., "Palatino" */
int pointsize;      /* in points */
int weight, slant;
int *scalable;      /* out: whether font is scalable */
XFontStruct **fp;   /* out -- a cache item pointer -- do not free */
{
    char *errString;
    fontTabEnt *fent, *targetRec;
    fontMetrics *fm;
    char *txName;
    char *xlfd = (char *) NULL;

    if (!familyName || !scalable || !fp) {
        return FALSE;
    }
    *scalable = FALSE;
    *fp = (XFontStruct *) NULL;
    
    if (errString = axGetFontRecordForScreen(familyName, weight, slant,
                                             pointsize, &targetRec, &fent)) {
        freeErrString(errString);
        return FALSE;
    }
    
#if AXMS
    
        /* on Win32, form the "xlfd" as: <ptsize>,<weight>,<slant>,<family>
         */
    if ( strcmp(fent->familyName, NXLT("axDefaultFontFamily")) == 0 )
        {
        xlfd = axMakeCompoundWinName(NXLT(axDefaultSerifFont), pointsize,
                                                            weight, slant);
        }
    else
        xlfd = axMakeCompoundWinName(fent->familyName,pointsize,weight,slant);
    txName = xlfd;
    
#else      /* {  */

        /* on X, the xlfd will name either a raster or scalable screenfont
         */
    if (!fent->xNamesKnown) {
        return FALSE;
    }
    if (fent->scalable) {
            /* form the name of the scalable xlfd
             */
        xlfd = (char *) malloc (MAXLFD);
        axtFormScalableName(fent->scalableName, pointsize,
                            ScreenRes, (axctm *) 0, xlfd);
        txName = xlfd;
    }
    else {
        int ix;
            /* find the name of the closest raster xlfd
             */
        int nearestSmallerError, nearestSmallerIx;
        int nearestLargerError, nearestLargerIx, tmp, decipts;

        nearestLargerIx = nearestSmallerIx = -1;
        nearestLargerError = nearestSmallerError = INT_MAX;
        for (ix = 0, txName = (char *) NULL; ix < fent->xNameCount; ix++) {
            decipts = pointsize * 10;
            if ((tmp = axtDecipointSize(fent->xNames[ix])) == decipts) {
                txName = fent->xNames[ix];
                break;
            }
            else if (tmp < decipts) {
                if ((tmp = decipts - tmp) < nearestSmallerError) {
                    nearestSmallerError = tmp;
                    nearestSmallerIx = ix;
                }
            }
            else if (tmp > decipts) {
                if ((tmp = tmp - decipts) < nearestLargerError) {
                    nearestLargerError = tmp;
                    nearestLargerIx = ix;
                }
            }
        }
        if (!txName) {
                /* an exact match was not found
                 */
            if (nearestSmallerIx >= 0) {
                    /* nearest smaller size is preferred over
                     * larger size in this 'graceful' failure case
                     */
                txName = fent->xNames[nearestSmallerIx];
            }
            else if (nearestLargerIx >= 0) {
                txName = fent->xNames[nearestLargerIx];
            }
            else {
                return FALSE;    /* shouldn't get here */
            }
        }
    }
#endif    /*  }  */


        /* load the metrics for the screenfont
         */
    fm = (fontMetrics *) NULL;
    if (errString = axGetScreenMetrics(txName, targetRec, &fm)) {
        freeErrString(errString);
        if (xlfd) {
            free(xlfd);
        }
        if (fm) {
            *fp = fm->xfont;  /* a fallback may have been returned */
        }
        return FALSE;
    }

    *fp = fm->xfont;
    *scalable = fent->scalable;

    if (xlfd) {
        free(xlfd);
    }
    return TRUE;
}

/* form a full pathname by appending the passed basename to
 * the pathname of the fontmetrics directory.  Caller must free return.
 */
char *
axFontmetricsPathname(basename)
char *basename;
{
    int len;
    char *fullpath;

    len = strlen(ThimApplixDir) + (2 * strlen(DirSlash));
#if AXMS
    len += strlen(NXLT("fmetrics"));
#else
    len += strlen(NXLT("fontmetrics"));
#endif
    len += strlen(basename);
    len++;    /* trailing null */
    
    fullpath = (char *) malloc(len);
    strcpy(fullpath, ThimApplixDir);
    strcat(fullpath, DirSlash);
#if AXMS
    strcat(fullpath, NXLT("fmetrics"));
#else
    strcat(fullpath, NXLT("fontmetrics"));
#endif
    strcat(fullpath, DirSlash);
    strcat(fullpath, basename);
    return (fullpath);
}

/*
 * Read a target metrics file.  Adobe metrics format 1.0, 2.0
 * Notes:
 *  - if encoding is null, this means that the encoding
 *    should be taken directly from the file.  If no such
 *    encoding can be found, look for "ncoding Latin", failing
 *    that, assign encoding as FontSpecific.
 *  - the metric data is written onto an XFontStruct..
 *  - Must add the code for reading the sun .fm file format.
 *     would take the form of effective-convertfont, then call here.
 *  - use of local vars in this routine reflects assumptions about
 *    the ordering of keys in any .afm file (e.g., FontBBox and
 *    EncodingScheme precede StartCharMetrics)
 */
static int
getAfmMetrics(name, mp, sizep, encoding)
char *name;
char **mp; /* data to return as a fontMetrics struct */
int *sizep;
char *encoding; /* name of separate encoding file */
{
    char rec[MXREC], *kp, *vp, *tp, *locEnc, *tEnc;
    char *charNameStr, *widVecStr, *widthStr, *bboxStr, *codeStr;
    FILE *mfile, *getFontmetricsFile();
    int inChars, nChars, tmp, *ip;
    unsigned minByte1, maxByte1, minByte2, maxByte2, tu1, tu2;
    short minLbearing, minRbearing, minWidth, minAscent, minDescent;
    short maxLbearing, maxRbearing, maxWidth, maxAscent, maxDescent;
    int wid, ht, llx, lly, urx, ury, charCount, ix, itemsize;
    int localEncoding, encodingType;
    int fontAscent, fontDescent; 
    int underlineThickness = 0;
    int underlinePosition = 0;
    int xHeight = 0;
    int capHeight = 0;
    int averageWidth = 0;
    XFontStruct *xf;
    XCharStruct *xc;
    charMetrics *perChars;
    fontMetrics *fm = (fontMetrics *)NULL;
    int ok, noBBoxes;
    int getEncodingType(), getItem();
    int fontMetricsSize(), freeTargetMetrics();

    ok = TRUE;
    mfile = getFontmetricsFile(name);
    if (!mfile) {
        *mp = (char *) NULL;
        *sizep = 0;
        return FALSE;
    }
    inChars = localEncoding = FALSE;
    nChars = 256;
    maxByte1 = maxByte2 = charCount = encodingType = 0;
    maxLbearing = maxRbearing = maxWidth = maxAscent = maxDescent = 0;
    minByte1 = minByte2 = minLbearing = minRbearing = minWidth =
         minAscent = minDescent = MAXSHORT16;
    locEnc = (char *)NULL;  /* encoding hint from file */
    perChars = (charMetrics *)NULL;
    fontAscent = fontDescent = 0;
    while(fgets(rec, MXREC, mfile) != (char *)NULL) {
        if (inChars) {
            if( strncmp(rec, NXLT("EndFont"), 7) == 0) {
                break;
            }
            else if( strncmp(rec, NXLT("EndCharMetrics"), 14) == 0) {
                /* not yet reading composites or kern pairs
                 * so we're done with the metrics file.. */
                break;
            }
            else if( strncmp(rec, NXLT("Comment"), 7) != 0) {
                /* pull off per-char fields where found */
                tp = rec;
                charNameStr = widVecStr = widthStr = bboxStr =
                        codeStr = (char *)NULL;
                noBBoxes = TRUE;
                while(getKeyVal(&tp, &kp, &vp)) {
                    if (localEncoding && strcmp(kp, "C")==0)
                        codeStr = vp;
                    else if (strcmp(kp, "N") == 0)
                        charNameStr = vp;
                    else if (strcmp(kp, "WX") == 0)
                        widthStr = vp;
                    else if (strcmp(kp, "W") == 0)
                        widVecStr = vp;
                    else if (strcmp(kp, "B") == 0) {
                        bboxStr = vp;
                        noBBoxes = FALSE;
                    }
                }
                if (charNameStr) {
                    /* must've found a char metrics record;
                     * assume such records have at least the
                     * char name and char code data */
                    if (noBBoxes) {
                        /* if even one char metrics record is missing
                         * the raster bbox, then mark the *fm struct as
                         * having none at all.
                         */
                        if (fm)
                            fm->noBearings = TRUE;
                    }

                    /* establish character code */
                    if (localEncoding) {
                        /* cache the encoding pair */
                        tmp = atoi(codeStr);
                        if (tmp < 0) { /* common for AdobeStandardEncoding */
                            tmp = 0;
                        }
                        ip = &tmp;
                        itemsize = sizeof(int);
                        getItem(LOAD, encodingType,
                            charNameStr, (char **)&ip, &itemsize,
                            (char *)NULL);
                    }
                    else {
                        /* set charcode tmp via lookup */
                        if (!getItem(FIND, encodingType,
                            charNameStr, (char **)&ip, &itemsize,
                            (char *)NULL)) {
                            /* the fetcher for this sort of lookup just
                             * returns FALSE, so this means that the requested
                             * charname isn't in the encoding cache at this
                             * time; since we're supposed to have processed
                             * the external encoding file by now, this lookup
                             * failure should mean only that this particular
                             * charname isn't defined in the encoding */
                            continue;
                        }
                        tmp = *ip;
                    }
                    memset((char *)&perChars[charCount], 0,
                        sizeof(charMetrics));
                    perChars[charCount].charCode = tmp;
                    tu1 = (tmp>>8) & 0xff;
                    tu2 = tmp & 0xff;
                    if (tu1 > maxByte1)
                        maxByte1 = tu1;
                    if (tu1 < minByte1)
                        minByte1 = tu1;
                    if (tu2 > maxByte2)
                        maxByte2 = tu2;
                    if (tu2 < minByte2)
                        minByte2 = tu2;

                    /* get dimension information */
                    xc = &perChars[charCount].xchar;
                    if (widVecStr) {
                        /* advance vector */
                        if(sscanf(widVecStr, "%d %d", &urx, &ury) != 2) {
                            ok = FALSE;
                            goto alldone;
                        }
                        xc->width = (short)urx;
                        perChars[charCount].yAdvance = ury;
                    }
                    if (widthStr) {
                        /* advance in x */
                        xc->width = (short)atoi(widthStr);
                    }
                    if (bboxStr) {
                        /* raster bounding box */
                        if(sscanf(bboxStr, "%d %d %d %d",
                            &llx, &lly, &urx, &ury) != 4) {
                            ok = FALSE;
                            goto alldone;
                        }
                        xc->lbearing = (short) llx;
                        xc->rbearing = (short) urx;
                        xc->ascent = (short) ury;
                            /* note X and adobe differ by sign here */
                        xc->descent = (short)  -lly;
                    }
                    else {
                        xc->ascent = (short) fontAscent;
                        xc->descent = (short) fontDescent;
                    }

                    /* do min-max stuff */
                    if(xc->lbearing > maxLbearing)
                        maxLbearing = xc->lbearing;
                    if(xc->rbearing > maxRbearing)
                        maxRbearing = xc->rbearing;
                    if(xc->width > maxWidth)
                        maxWidth = xc->width;
                    if(xc->ascent > maxAscent)
                        maxAscent = xc->ascent;
                    if(xc->descent > maxDescent)
                        maxDescent = xc->descent;
                    if(xc->lbearing < minLbearing)
                        minLbearing = xc->lbearing;
                    if(xc->rbearing < minRbearing)
                        minRbearing = xc->rbearing;
                    if(xc->width < minWidth)
                        minWidth = xc->width;
                    if(xc->ascent < minAscent)
                        minAscent = xc->ascent;
                    if(xc->descent < minDescent)
                        minDescent = xc->descent;

                    charCount++;
                }
            }
        }
        else {
            if( strncmp(rec, NXLT("FontBBox"), 8) == 0) {
                /* llx lly urx ury */
                if(sscanf(&rec[8], "%d %d %d %d",
                        &llx, &lly, &urx, &ury) != 4) {
                    ok = FALSE;
                    goto alldone;
                }
                wid = urx - llx;
                ht = ury - lly;
                fontAscent = ht + lly;
                fontDescent = ht - fontAscent;
            }
            else if ( strncmp(rec, NXLT("FontBoundingBox"), 15) == 0) {
                /* wid ht llx, lly */
                if(sscanf(&rec[15], "%d %d %d %d",
                        &wid, &ht, &llx, &lly) != 4) {
                    ok = FALSE;
                    goto alldone;
                }
                fontAscent = ht + lly;
                fontDescent = ht - fontAscent;
            }
            else if( strncmp(rec, NXLT("StartCharMetrics"), 16) == 0) {
                /* a number describing #character records */
                if(sscanf(&rec[16], "%d", &nChars) != 1) {
                    ok = FALSE;
                    goto alldone;
                }
                /* allocate the metrics struct, and the named #
                 * of per-char slots */
                fm = (fontMetrics *)malloc(sizeof(fontMetrics));
                memset((char *)fm, 0, sizeof(fontMetrics));
                fm->xfont = (XFontStruct *)malloc(sizeof(XFontStruct));
                memset((char *)fm->xfont, 0, sizeof(XFontStruct));
                /* we don't yet know the range of charcodes to be
                 * used, only the # of char records in the metrics file.
                 * use a temp array of per-char structs to collect this
                 * info.  we'll do the real alloc and copying later. */
                perChars = (charMetrics *)malloc(nChars *
                                    sizeof(charMetrics));
                
                /* decide which encoding to use
                 */
                if (encoding != (char *)NULL) {
                    /* use the passed-in encoding filename to get
                     * the encoding type
                     */
                    getItem(FIND, ENCODING,
                        encoding, (char **)&tEnc, &itemsize, (char *)NULL);
                    encodingType = getEncodingType(tEnc);
                }
                else {
                    localEncoding = TRUE;
                    if (locEnc) {
                        if ((encodingType = getEncodingType(locEnc)) == -1) {
                            ok = FALSE;
                            goto alldone;
                        }
                        tEnc = locEnc;
                    }
                    else {
                        /* locEnc should've been established by now
                         */
                        ok = FALSE;
                        goto alldone;
                    }
                }
                fm->encodingName = (char *) malloc (strlen(tEnc) + 1);
                strcpy(fm->encodingName, tEnc);
                
                fm->underlineThickness = underlineThickness;
                fm->underlinePosition = underlinePosition;
                if (!xHeight) {
                    fm->xHeight = 450;  /* copied from Times' afm */
                }
                else {
                    fm->xHeight = xHeight;
                }
                    /* these two metrics are used for pcl printing.. */
                fm->capHeight = capHeight;       /* could be 0.. */
                fm->averageWidth = averageWidth; /* currently 0.. */

                inChars = TRUE;
            }
            else if ( strncmp(rec, NXLT("EncodingScheme"), 14) == 0) {
                /* a string naming the encoding */
                tp = &rec[14];
                while(WHITESPACE(*tp))
                    tp++;
                tmp = 0;
                while(!WHITESPACE(*tp)) {
                    tp++;
                    tmp++;
                }
                if (locEnc != (char *)NULL) {
                    free(locEnc);
                }
                locEnc = (char *)malloc(tmp + 1);
                if(sscanf(&rec[14], "%s", locEnc) != 1) {
                    ok = FALSE;
                    goto alldone;
                }
            }
            else if ( strncmp(rec, NXLT("Comment encoding Latin"), 22) == 0) {
                    /* synonomous with ISOLatin1Encoding??  let's pretend */
                if(locEnc == (char *)NULL) {
                    locEnc = (char *)malloc(strlen(NXLT("ISOLatin1Encoding"))+1);
                    strcpy(locEnc, NXLT("ISOLatin1Encoding"));
                }
            }
            else if ( strncmp(rec, NXLT("UnderlinePosition"), 17) == 0) {
                if(sscanf(&rec[17], "%d", &underlinePosition) != 1) {
                    ok = FALSE;
                    goto alldone;
                }
            }
            else if ( strncmp(rec, NXLT("UnderlineThickness"), 18) == 0) {
                if(sscanf(&rec[18], "%d", &underlineThickness) != 1) {
                    ok = FALSE;
                    goto alldone;
                }
            }
            else if ( strncmp(rec, NXLT("XHeight"), 7) == 0) {
                if(sscanf(&rec[7], "%d", &xHeight) != 1) {
                    ok = FALSE;
                    goto alldone;
                }
            }
            else if ( strncmp(rec, NXLT("CapHeight"), 9) == 0) {
                if(sscanf(&rec[9], "%d", &capHeight) != 1) {
                    ok = FALSE;
                    goto alldone;
                }
            }
        }
    }
    /* now determine the character code range, alloc onto the
     * per_char member of xfont, and copy the per-char info
     * collected during the scan */
    xf = fm->xfont;
    xf->min_byte1 = minByte1;
    xf->max_byte1 = maxByte1;
    xf->min_char_or_byte2 = minByte2;
    xf->max_char_or_byte2 = maxByte2;
    tmp = maxByte1 - minByte1 + 1;
    tmp *= maxByte2 - minByte2 + 1;
    tmp *= sizeof(XCharStruct);
    if (tmp <= 0) {
        ok = FALSE;
        goto alldone;
    }
    xf->per_char = (XCharStruct *)malloc(tmp);
    memset((char *)xf->per_char, 0, tmp);
    for(tmp=0; tmp<charCount; tmp++) {
        /* refer to O'Reilly vol 1 on XFontStruct, or
         * CI_GET_CHAR_INFO_2D in Xlibint.h */
        tu1 = (perChars[tmp].charCode>>8) & 0xff; /* row */
        tu2 = perChars[tmp].charCode & 0xff;    /* col */
        ix = ((tu1 - minByte1) * (maxByte2 - minByte2 + 1)) +
            tu2 - minByte2;
        xf->per_char[ix] = perChars[tmp].xchar;
    }
    /* fill out min and max char strucs */
    xc = &xf->min_bounds;
    xc->lbearing = minLbearing;
    xc->rbearing = minRbearing;
    xc->width = minWidth;
    xc->ascent = minAscent;
    xc->descent = minDescent;
    xc = &xf->max_bounds;
    xc->lbearing = maxLbearing;
    xc->rbearing = maxRbearing;
    xc->width = maxWidth;
    xc->ascent = maxAscent;
    xc->descent = maxDescent;
    /* would be nice to fill out: default_char,
     * all_chars_exist, direction */
    xf->ascent = fontAscent;
    xf->descent = fontDescent;
    if (xf->min_char_or_byte2 >= 32 &&
        xf->min_byte1 == 0) {
        tmp = 160 - xf->min_char_or_byte2;
        xc = &xf->per_char[tmp];
        if (!xc->width) {
                /* if charstruct for codepoint 160 is unoccupied,
                   supply metrics from codepoint 32;  For the latin1
                   encoding, this means to supply space metrics for
                   the nonbreakable space.. do this even though the
                   encoding may not be latin1.. */
            tmp = 32 - xf->min_char_or_byte2;
            *xc = xf->per_char[tmp];
        }
    }
alldone:
    if (perChars) {
        free((char *)perChars);
    }
    if (locEnc) {
        free((char *)locEnc);
    }
    if (!ok) {
        if (fm) {
            freeTargetMetrics(fm);
        }
        *sizep = 0;
        *mp = (char *)NULL;
    }
    else {
        *sizep = fontMetricsSize(fm); 
        *mp = (char *)fm;
    }
    closeFile(mfile);
    return ok;
}





#if AX_X11   /*  {  These functions have Windows counterparts */

/* : axGetXLFD - return the xlfd string for the screenfont
 * which matches the passed attributes;  note that if the
 * pointsize isn't found exactly, the xlfd of the nearest
 * smaller pointsize is returned, if any.
 * caller must not free the returned xlfd unless freeXLFD
 * is returned as TRUE
 */

char *
axGetXLFD(fontFamily, weight, slant, pointsize, exact, freeXLFD)
char *fontFamily; /* e.g., "Times" */
int weight;       /* e.g., 1 for bold */
int slant;
int pointsize;    /* in points */
int *exact;       /* out: bool; whether size exactly matches */
int *freeXLFD;    /* out: bool; whether caller should free returned string */
{
    char *errString;
    fontTabEnt *fent, *targetRec;
    int ix, decipts, tmp, nearestIx;
    int nearestSmallerSize, smallestIx, smallestSize;
    
    *exact = FALSE;
    *freeXLFD = FALSE;

        /* get the appropriate font record for 'fontFamily'
         */
    if (errString = axGetFontRecordForScreen(fontFamily, weight, slant,
                                             pointsize, &targetRec, &fent)) {
        freeErrString(errString);
        return ((char *) NULL);
    }
    
    if (fent->scalable) {
        char *lsName = (char *) malloc(MAXLFD);
        axtFormScalableName(fent->xNames[0], pointsize, ScreenRes,
                            (axctm *) 0, lsName);
        *exact = TRUE;
        *freeXLFD = TRUE;
        return (lsName);
    }

        /* look for the requested pointsize among the available fonts
         * if no exact match, take nearest smaller size; remember
         * smallest size in case requested size is smaller than all
         */
    nearestIx = nearestSmallerSize = smallestIx = -1;
    smallestSize = INT_MAX;
    decipts = pointsize * 10;
    for (ix = 0; ix < fent->xNameCount; ix++) {
        if ((tmp = axtDecipointSize(fent->xNames[ix])) == decipts) {
            *exact = TRUE;
            return (fent->xNames[ix]);
        }
        else if (tmp < decipts) {
            if (tmp > nearestSmallerSize) {
                nearestSmallerSize = tmp;
                nearestIx = ix;
            }
        }
        if (tmp < smallestSize) {
            smallestSize = tmp;
            smallestIx = ix;
        }
    }
    *exact = FALSE;
    *freeXLFD = FALSE;
    if (nearestIx >= 0) {
        return (fent->xNames[nearestIx]);
    }
    else if (smallestIx >= 0) {
        return (fent->xNames[smallestIx]);
    }
    return ((char *) NULL);
}

#endif /* } AX_X11 */


/* : getPFontStruct - use fontcache to get printer XFontStruct for
 * specified attributes.  A TRUE return means that the fontstruct
 * has been filled out */
int /* TRUE if ok */
getPFontStruct(familyName, weight, slant, fp)
char *familyName; /* e.g., "Palatino" */
int weight, slant;
XFontStruct **fp;   /* out -- a cache item pointer -- do not free */
{
    char *errString, *tFontName;
    fontTabEnt *fent;
    fontMetrics *fm;

    if (!familyName || !fp) {
        return FALSE;
    }
    *fp = (XFontStruct *) NULL;
    tFontName = (char *) NULL;
    if (errString = axGetFontRecordName(familyName,
                                        weight, slant, &tFontName)) {
        freeErrString(errString);
        if (tFontName)
            free((char *)tFontName);
        return FALSE;
    }
    if (errString = axGetFontRecord(tFontName, &fent)) {
        freeErrString(errString);
        if (tFontName)
            free((char *) tFontName);
        return FALSE;
    }
        /* load the metrics for the font */
    if (errString = axGetTargetMetrics(fent->targetMetricsNames[0],
                                       fent, &fm)) {
        freeErrString(errString);
        if (tFontName)
            free((char *) tFontName);
        return FALSE;
    }

    *fp = fm->xfont;
    if (tFontName)
        free((char *)tFontName);
    return TRUE;
}

/* : axGetFontRecordForScreen - lookup fontTabEnt instance, applying
 * XAlternate/WindowsAlternate as appropriate; return references to
 * both "target" and "screen" font records -- the screen record can
 * differ if an alternate is present
 */
char *  /* OK if null, otherwise caller must free returned string */
axGetFontRecordForScreen(fontFamily, weight, slant, pointsize,
                         targetRec, screenRec)
char *fontFamily;         /* e.g., "Times" */
int weight;               /* e.g., 1 for bold */
int slant;
int pointsize;            /* in: pointsize in points */
fontTabEnt **targetRec;   /* out: do not free this cache item address */
fontTabEnt **screenRec;   /* out: do not free this cache item address */
{
    fontTabEnt *ftab, *sftab;
    char *err;
    char *fontRecName = (char *) NULL;
    
    if (err = axGetFontRecordName(fontFamily, weight, slant, &fontRecName)) {
        if (fontRecName) {
            free(fontRecName);
        }
        return (err);
    }
    if (err = axGetFontRecord(fontRecName, &ftab)) {
        free( fontRecName);
        return (err);
    }
    *targetRec = ftab;    /* the real font record for passed attrs */
    
#if AX_X11
        /* on X, test whether an X alternate is specified
         */
    if (ftab->XAlternate) {
            /* the XAlternate name identifies a font family
             * to use for screenfont lookup; convert to that fontTabEnt
             */
        free(fontRecName);
        fontRecName = (char *) NULL;
        if (err = axGetFontRecordName(ftab->XAlternate,
                                      weight, slant, &fontRecName)) {
            if (fontRecName) {
                free(fontRecName);
            }
            return (err);
        }
        if (err = axGetFontRecord(fontRecName, &sftab)) {
            free( fontRecName);
            return (err);
        }
        ftab = sftab;
    }
    else if (ftab->largeXAlternate &&
             (pointsize > ftab->toleranceHighCutoff) &&
             haveGFSServer()) {
        
        /* use the indicated font record's screen names for
         * doing large pointsizes.
         */
        free(fontRecName);
        fontRecName = (char *) NULL;
        if (err = axGetFontRecordName(ftab->largeXAlternate,
                                      weight, slant, &fontRecName)) {
            if (fontRecName) {
                free(fontRecName);
            }
            return (err);
        }
        if (err = axGetFontRecord(fontRecName, &sftab)) {
            free( fontRecName);
            return (err);
        }
        ftab = sftab;
    }
#endif
    if (fontRecName) {
        free(fontRecName);
    }
    
    *screenRec = ftab;
    return ((char *) NULL);
}

/*
 * supposedely private stuff
 */

static int
getTrivialItem( name, val, siz, notUsed )
char *name;
char **val;
int *siz;
char *notUsed;
{
    if (!val)
        return FALSE;
    *val = (char *) malloc (sizeof(int));
    memset((char *) *val, 0, sizeof(int));
    *siz = sizeof(int);
    return TRUE;
}

static int
freeTrivialItem( val )
char *val;
{
    return FALSE;
}

static int
copyTrivialItem( notUsed1, notUsed2, notUsed3, notUsed4)
char *notUsed1;
char **notUsed2;
int *notUsed3;
char *notUsed4;
{
    return FALSE;
}


/* : getCacheList - create a new list in AxFontCache.
 * the item's value is returned on indexp, as an
 * integer representing the index in AxFontCache.lists
 * for the new list */
static int
getCacheList( name, indexp, sizep, tp )
char *name;
char **indexp; /* to be filled out as an integer value */
int *sizep;
char *tp; /* arrives as pointer to typeFuncs struct */
{
    int tmp, j, wid;
    void setCacheLimit();
    typeFuncs *tfuncs = (typeFuncs *) tp;
    if (!tp) {
        *indexp = (char *)NULL;
        *sizep = 0;
        return FALSE; /* no maintenance funcs, no list */
    }
        /* report the new cache list index */
    writeIntegerType(indexp, AxFontCache.numLists, sizep);
    tmp = AxFontCache.numLists++;
        /* now increase cache arrays for the new list */
    AxFontCache.lists = (cashList *) realloc ((char *)AxFontCache.lists,
        AxFontCache.numLists * sizeof(cashList));
    AxFontCache.fetch = (int (**)()) realloc ((char *)AxFontCache.fetch,
        AxFontCache.numLists * sizeof(int (*)()));
    AxFontCache.copy = (int (**)()) realloc ((char *)AxFontCache.copy,
        AxFontCache.numLists * sizeof(int (*)()));
    AxFontCache.toss = (int (**)()) realloc ((char *)AxFontCache.toss,
        AxFontCache.numLists * sizeof(int (*)()));

        /* init the new list */
    AxFontCache.fetch[tmp] = tfuncs->fetch;
    AxFontCache.copy[tmp] = tfuncs->copy;
    AxFontCache.toss[tmp] = tfuncs->toss;
    AxFontCache.lists[tmp].limit =
    AxFontCache.lists[tmp].usage = 0;
    AxFontCache.lists[tmp].fetchCounter = 0;
    AxFontCache.lists[tmp].kickOutCounter = 0;
/* %%%%%%% better table width control needed */
    wid = AxFontCache.lists[tmp].tableWidth = ENCODING_TABLE_WIDTH;
    AxFontCache.lists[tmp].table = (cItem **)malloc(wid * sizeof(cItem *));
    for(j=0; j<wid; j++) {
        AxFontCache.lists[tmp].table[j] = (cItem *)NULL;
    }
/* %%%%%%% better limit control needed */
    setCacheLimit(&AxFontCache, tmp, MAXLRU);
    return TRUE;
}

static int
copyCacheList(name, onto, sizep, from)
char *name;
char **onto;
int *sizep;
char *from;
{
    return FALSE; /* no copy op defined */
}

/* the CacheList in this case is just the pairing
 * of a cache list name with an index value.  So the
 * data being freed is just an allocated integer */
static int
freeCacheList(dp)
char **dp;
{
    if (*dp) {
        free(*dp);
    }
    return TRUE;
}

FILE *
getFontmetricsFile(name)
char *name;
{
    FILE *fp;
    
    if ( name[0] == *DirSlash ) {
        /* use absolute pathname directly
         */
        fp = fopen(name, READ_BINARY_STR);
    }
    else {
        /* relative path - look in "fontmetrics" directory under axdata
         */
        char *fullpath = axFontmetricsPathname(name);
        fp = fopen(fullpath, READ_BINARY_STR);
        free(fullpath);
    }
    return fp;
}

FILE *
axOpenFontFile(tablefile)
char *tablefile;
{
    FILE *fp = (FILE *) NULL;
    char *homedir;

    if (tablefile[0] == *DirSlash ) {
        /* use absolute pathname directly
         */
        fp = fopen(tablefile, READ_BINARY_STR);
    }
    else {
        /* relative path - look in homedir, failing that,
         * look in "fontmetrics" directory
         */
        char *fullpath;
        homedir = AGetHomeDir();
        if (homedir) {
            int len; 
            len = strlen(homedir) + strlen(DirSlash) + strlen(tablefile) + 1;
            fullpath = (char *) malloc(len);
            strcpy(fullpath, homedir);
            strcat(fullpath, DirSlash);
            strcat(fullpath, tablefile);
            fp = fopen(fullpath, READ_BINARY_STR);
        }
        if (!fp) {
            fullpath = axFontmetricsPathname(tablefile);
            fp = fopen(fullpath, READ_BINARY_STR);
        }
        free(fullpath);
    }
    return (fp);
}

static void
closeFile(file)
FILE *file;
{
        /* should really test return, but only reading files */
    fclose(file);
}

static int
getTargetMetrics(name, mp, sizep, fontRecord)
char *name;
char **mp;   /* out: init as pointer to fontMetrics struct */
int *sizep;
char *fontRecord;   /* in: address of this font's fontTabEnt */
{
    int len;
    fontTabEnt *ftab = (fontTabEnt *) fontRecord;
    int ret;

    *mp = (char *) NULL;
    *sizep = 0;
    
    if (!name)
        return FALSE;
    
    if (ftab && ftab->gallium) {
        /* the target metrics are obtained from the gallium server
         */
        XFontStruct *fs;
        fs = axgfsOpenFont(ftab->targetMetricsNames[0],
                           TargetRes, AXGFS_TARGET_POINTSIZE, ftab);
        if (fs) {
            fontMetrics *fm;
            
            fm = (fontMetrics *) malloc(sizeof(fontMetrics));
            memset((void *) fm, 0, sizeof(fontMetrics));
            
            /* init what we can of *fm
             */
            fm->xfont = fs;
            
            /* these are supplied as hardcoded "survey-result" values....
             */
            fm->underlinePosition = -150;
            fm->underlineThickness = 50;
            fm->xHeight = 450;
            fm->capHeight = 650;

/* %%%%%%%%% just hardcoding as latin1, not good enough..  lookup
 *           internal encoding name from ftab->encodingName (the .enc file)
 */
            fm->encodingName = (char *) malloc
                (strlen(NXLT("ISOLatin1Encoding")) + 1);
            strcpy(fm->encodingName, NXLT("ISOLatin1Encoding"));
            
            *mp = (char *) fm;
            ret = TRUE;
        }
        else {
            ret = FALSE;
        }
    }
    else if (strncmp(name, NXLT("BBox"), 4) == 0) {
        /* this is a special metrics 'file' name denoting
         * a cellfont
         */
        getCellFontMetrics(name, mp, sizep, ftab);
        ret = TRUE;
    }
    else {
        len = strlen(name);
        if (len < 4) {
            return FALSE;
        }
        if (strncmp(&name[len - 4], NXLT(".afm"), 4) == 0) {
            /* we think the metrics file is in the Adobe
             * Font Metrics format
             */
            ret = getAfmMetrics(name, mp, sizep, ftab->encodingFileName);
        }
        else if (strncmp(&name[len - 4], NXLT(".tfm"), 4) == 0) {
            /* we think the metrics file is in the Tagged
             * Font Metrics format
             */
            ret = getTfmMetrics(name, mp, sizep, ftab->encodingName);
        }
#if AXMS
        else if (strncmp(&name[len - 4], NXLT(".win"), 4) == 0) {
            /* this fontTabEnt's target metrics were
             * read from the windows gdi
             */
            ret = axGetWinTargetMetrics( mp, sizep, ftab );
        }
#endif
        else {
            return FALSE;
        }
    }

    return (ret);
}

static void
getCellFontMetrics(name, mp, sizep, ft)
char *name;
char **mp; /* data to return as a fontMetrics struct */
int *sizep;
fontTabEnt *ft;
{
    fontMetrics *fm;
    char *cp;
    int adv, wid, ht, llx, lly;
    int upos, uthick;
    XFontStruct *xf;
    XCharStruct *xc;
    int fontMetricsSize();
    int strike_thru;
    XFontStruct *fp;
    int junk;
        
    /*
     * <name> is of form: BBox[(<adv>,<wid>,<ht>,
     *                          <llx>,<lly>,<upos>,<uthick>)]
     * units in milliems
     */
    cp = name;
    adv = 1000;
    wid = 1000;
    ht = 1000;
    llx = 0;
    lly = 0;
    upos = -150;
    uthick = 50;
    strike_thru = 450;
    if (*cp && strcmp(name, NXLT("BBox"))) {
        /* nonnull, and not merely NXLT("BBox") */
        cp = name + 4; /* skip BBox */
        sscanf(cp, " ( %d , %d , %d , %d , %d  %d %d %d ) ",
            &adv, &wid, &ht, &llx, &lly, &upos, &uthick, &strike_thru);
    }
    fm = (fontMetrics *)malloc(sizeof(fontMetrics));
    memset((char *)fm, 0, sizeof(fontMetrics));
    fm->xfont = (XFontStruct *)malloc(sizeof(XFontStruct));
    memset((char *)fm->xfont, 0, sizeof(XFontStruct));
    xf = fm->xfont;

#if BUILD_KANJI && FOR_FILTER         /*  {  */
   /* For independent filter modules, eg. geinout, the following function
    * getXFontStruct() cannot be applied because it will use the variable
    * "Dpy" after going down some steps. Since independent filters do not
    * linked to Xlib, this may cause failure.
    * Ashisuto added.  96.03.18
    */
   if (IsSimpleWideFontFace(ft->familyName)) {
       /* These setting are only suitable for Japanese wide chars */
        xf->min_char_or_byte2 = 33;
        xf->max_char_or_byte2 = 126;
        xf->min_byte1 = 33;
        xf->max_byte1 = 116;
   } else {
        xf->min_char_or_byte2 = 0;
        xf->max_char_or_byte2 = 223;
        xf->min_byte1 = 0;
        xf->max_byte1 = 0;
   }
#else          /*  }  {  */
    /* Ashisuto added following four lines because these would cause
     * calculation error of width of NarrowKana font.
     * Font metrics defined by an "BBOX" is not necessary be an wide font.
     * 95.10.30
     */
    if (!getXFontStruct(ft->familyName, 12, 0, 0, &junk, &fp)) {
        xf->min_char_or_byte2 = 0;
        xf->max_char_or_byte2 = 255;
        xf->min_byte1 = 0;
        xf->max_byte1 = 255;
    } else {
        xf->min_char_or_byte2 = fp->min_char_or_byte2;
        xf->max_char_or_byte2 = fp->max_char_or_byte2;
        xf->min_byte1 = fp->min_byte1;
        xf->max_byte1 = fp->max_byte1;
    }
#endif              /*  }  */

    xc = &xf->min_bounds;
    xc->lbearing = (short)llx;
    xc->rbearing = (short)(llx + wid);
    xc->width = (short) adv;
    xc->ascent = (short)(lly + ht);
    xc->descent = (short)(ht - xc->ascent);
    xf->max_bounds = xf->min_bounds;
    xf->ascent = xc->ascent;
    xf->descent = xc->descent;
    fm->underlineThickness = uthick;
    fm->underlinePosition = upos;
    fm->xHeight = strike_thru;        /* used for strikethrough */
    /* would be nice to do all_chars_exist, default_char, direction */
    *mp = (char *)fm;
    *sizep = fontMetricsSize(fm);
}

static int
copyTargetMetrics(name, onto, sizep, from)
char *name;
char **onto;
int *sizep;
char *from;
{
    return FALSE; /* this copy op not defined yet */
}


int
freeTargetMetrics(dp)
char **dp;
{
    XExtData *xp;
    fontMetrics *m;
    if(*dp) {
        m = (fontMetrics *) *dp;
        if(m->xfont) {
            if(m->xfont->per_char) {
                free((char *)m->xfont->per_char);
            }
            if(m->xfont->properties) {
                free((char *)m->xfont->properties);
            }
            xp = m->xfont->ext_data;
            while(xp) {
                if (xp->private_data) {
                    (*xp->free_private)(xp);
                }
                xp = xp->next;
            }
            free((char *)m->xfont);
        }
        if (m->encodingName) {
            free((char *)m->encodingName);
        }
        if (m->PCLSymbolSetID) {
            free((char *) m->PCLSymbolSetID);
        }
        free((char *)m);
    }
    return TRUE;
}

static int
getScreenMetrics(name, dp, sp, targetRec)
char *name;
char **dp;
int *sp;
char *targetRec;     /* arrives as NULL, or as fontTabEnt pointer */
{
    int fontMetricsSize();
    fontMetrics *fm;
    fontTabEnt *targetEnt = (fontTabEnt *) targetRec;

#if AX_X11
    XFontStruct *font = (XFontStruct *) NULL;
    fontfile_xlfd *xf = (fontfile_xlfd *) NULL;

    if (isGFSxlfdName(name, &xf)) {
        if (xf) {
            font = axgfsOpenFont(xf->xlfd_template, ScreenRes,
                                 axtDecipointSize(name) / 10, xf->ftab);
        }
        if (!font || !xf) {
            return (FALSE);
        }
    }
    else {
        if ((font = AXLoadQueryFont(Dpy, name)) == NULL) {
            return FALSE;
        }
    }
    *dp = (char *)malloc(sizeof(fontMetrics));
    fm = (fontMetrics *) *dp;
    memset((char *)fm, 0, sizeof(fontMetrics));
    fm->xfont = font;
#else
    /* Windows NT */
    char family_name[80];
    int weight, slant, pointsize;

    ParseCompoundWinName( family_name, &pointsize, &weight, &slant, name );

    *dp = (char *)malloc(sizeof(fontMetrics));
    fm = (fontMetrics *) *dp;
    memset((char *)fm, 0, sizeof(fontMetrics));

    axGetWinScreenMetrics( family_name, weight, slant, pointsize,
                           targetEnt, fm );

#endif
    fm->encodingName = (char *) NULL; /* refer to target for this name */

#if 0   
    *sp = fontMetricsSize(fm);
    *sp += screenFontServerSize(fm->xfont);
#else
        /* as of 4.0 beta, the implicit assumption that screenfonts
         * are never closed is pretty pervasive in our code....
         * (widget kit, FontSet stuff, ss edit line, more to come..)
         * So, account for them as consuming _no_ resources
         */
    *sp = 0;
#endif
           
    return( TRUE );
}

static int
copyScreenMetrics(name, onto, sizep, from)
char *name;
char **onto;
int *sizep;
char *from;
{
    return FALSE; /* this copy op not defined yet */
}

static int
freeScreenMetrics(dp)
char **dp;
{
#if AXMS
    return TRUE;        /* this should be pitching the HFONT */
#else
    fontMetrics *fm;
    if (*dp) {
        fm = (fontMetrics *) *dp;
        if (fm->xfont) {
            AXFreeFont(Dpy, fm->xfont);
        }
        if (fm->encodingName) {
            free((char *) fm->encodingName);
        }
        if (fm->PCLSymbolSetID) {
            free((char *) fm->PCLSymbolSetID);
        }
        free(*dp);
    }
    return TRUE;
#endif
}

int
fontMetricsSize(font)
fontMetrics *font;
{
    XFontStruct *xf;
    int sz, area;

    xf = font->xfont;
    sz = sizeof(*font);
    if (font->encodingName) {
        sz += strlen(font->encodingName) + 1;
    }
    if (font->PCLSymbolSetID) {
        sz += strlen(font->PCLSymbolSetID) + 1;
    }
    sz += sizeof(XFontStruct);
    sz += extDataSize(xf->ext_data); /* as if we know */
    sz += xf->n_properties * sizeof(XFontProp);
    area = xf->max_char_or_byte2 - xf->min_char_or_byte2 + 1;
    area *= xf->max_byte1 - xf->min_byte1 + 1;
    if (xf->per_char) {
        sz += area * sizeof(XCharStruct);
    }
    return(sz);
}

/* can't really size this stuff; this just
 * gets the initial size not counting any
 * initial private data..  At any time an
 * extension could start heaping data on
 * the font struct, adding further uncertainty
 * to the cache limits.  But, if we should
 * start using the XFontStruct's extension
 * hook, we can define a means of detecting
 * size.  So, at such time provide sizing code
 * here in addition to the free_private func(s).
 */
static int
extDataSize(ed)
XExtData *ed;
{
    int siz = 0;

    while(ed) {
        siz += sizeof(XExtData);
        ed = ed->next;
    }
    return(siz);
}

static int
getReferenceCellStruct(name, dp, sp, notUsed)
char *name;
char **dp;
int *sp;
char *notUsed;
{
    int cellWid, cellAscent, cellDescent;
    XFontStruct *fs;
#if BUILD_ORIENT
    extern XFontStruct *AxDefaultReferenceFont;
#endif

        /* a reference cell struct is a monospace
           XFontStruct instance: no per_char array,
           max/min_bounds equal, no properties or
           ext_data; its name specifies the cell
           dimensions: <cell width><' '><cell ascent><' '><cell descent> */
    if (sscanf((char *) name, "%d %d %d", &cellWid, &cellAscent,
               &cellDescent) == EOF) {
        
            /* supply dimensions of axsab-16 cell as a fallback */
        cellWid = 7;
        cellAscent = 13;
        cellDescent = 3;
    }
    
        /* fill out the font structure describing a
           monospace font of the stated cell size */
    
    fs = (XFontStruct *) malloc(sizeof(XFontStruct));
    memset((char *) fs, 0, sizeof(XFontStruct));
    fs->min_char_or_byte2 = (unsigned int) 32;
    fs->max_char_or_byte2 = (unsigned int) 255;
    fs->default_char = (unsigned int) 20;
    fs->min_bounds.width = cellWid;
    fs->min_bounds.ascent = cellAscent;
    fs->min_bounds.descent = cellDescent;
    fs->max_bounds.width = cellWid;
    fs->max_bounds.ascent = cellAscent;
    fs->max_bounds.descent = cellDescent;
    fs->ascent = cellAscent;
    fs->descent = cellDescent;

#if BUILD_ORIENT && !FOR_FILTER
    /* Ashisuto added for ORIENT build. When cell reference font is used in
     * in ORIENT build, the font id must be there, because the string in
     * cell is in wide/single mixed chars, we use AXTextExtent() to calculate
     * and get font id from parent->reference font, then from font id to
     * get font set, finally from fontset and string to calculate the accurate
     * width of the text. Here we add the font id to fs in ORIENT case.
     * 95.09.28
     */
    fs->fid = AxDefaultReferenceFont->fid;
#endif

    
    *sp = sizeof(XFontStruct);
    *dp = (char *) fs;
    
    return( TRUE );
}

static int
copyReferenceCellStruct(name, onto, sizep, from)
char *name;
char **onto;
int *sizep;
char *from;
{
    return FALSE; /* this copy op not defined yet */
}

static int
freeReferenceCellStruct(dp)
char **dp;
{
    XFontStruct *cs;
    if (*dp) {
        cs = (XFontStruct *) *dp;
            /* a reference cell struct is a monospace
               XFontStruct instance: no per_char array,
               max/min_bounds equal, no properties or
               ext_data */
        free((char *) cs);
    }
    return TRUE;
}

/* 
 */
static int
getEncodingPair()
{
    return FALSE; /* at best, this means "charname not in encoding" */
}

static int
copyEncodingPair(notUsed, onto, notUsed2, from)
char *notUsed;
char **onto;
int *notUsed2;
char *from;
{
    int *ifrom, *ito;

    if (!from) {
        ito = (int *)malloc(sizeof(int));
        *ito = 0;
        *onto = (char *)ito;
        return TRUE;
    }
    else {
        ifrom = (int *)from;
    }
    ito = (int *)malloc(sizeof(int));
    *ito = *ifrom;
    *onto = (char *)ito;
    return TRUE;
}


static int
freeEncodingPair(dp)
char **dp;
{
    if (*dp) {
        free(*dp);
    }
    return TRUE;
}

static int
getFontFamily(notUsed, fp, sizep, notUsed2)
char *notUsed;
char **fp; /* to be filled out as an initial fontFamilyRecord item */
int *sizep;
char *notUsed2;
{
    fontFamilyRecord *ff;
    int siz;
    
    siz = sizeof(fontFamilyRecord);
    ff = (fontFamilyRecord *)malloc(siz);
    ff->familyNumber = AxFontCache.lists[FONTFAMILY].fetchCounter;
    ff->numMembers = 0;
    ff->members = (familyMember **) NULL;
    ff->aliasFor = (char *) NULL;
    *sizep = siz;
    *fp = (char *)ff;
    return TRUE;
}

static int
copyFontFamily(notUsed, onto, notUsed2, from)
char *notUsed;
char **onto;
int *notUsed2;
char *from;
{
    fontFamilyRecord *ffrom, *fto;
    familyMember *fMemFrom, *fMemTo;
    int size, i;

    if (!from) {
        getFontFamily((char *)NULL, (char **)&fto,
                &size, (char *)NULL);
        *onto = (char *)fto;
        return TRUE;
    }
    else {
        ffrom = (fontFamilyRecord *)from;
    }
    getFontFamily((char *)NULL, (char **)&fto, &size, (char *)NULL);
    fto->familyNumber = ffrom->familyNumber;
    fto->numMembers = ffrom->numMembers;
    fto->members = (familyMember **)malloc(fto->numMembers *
                sizeof(familyMember *));
    if (ffrom->aliasFor) {
        fto->aliasFor = (char *) malloc (strlen(ffrom->aliasFor) + 1);
        strcpy(fto->aliasFor, ffrom->aliasFor);
    }
#if AXMS
    fto->isWindowsFont = ffrom->isWindowsFont;
    fto->isPrinterFont = ffrom->isPrinterFont;
#endif
    for(i=0; i<fto->numMembers; i++) {
        fMemFrom = ffrom->members[i];
        fto->members[i] = (familyMember *)malloc(sizeof(familyMember));
        fMemTo = fto->members[i];
        memset((char *)fMemTo, 0, sizeof(familyMember));
        if (fMemFrom->propName) {
            size = strlen(fMemFrom->propName);
            fMemTo->propName = (char *)malloc(size + 1);
            strcpy(fMemTo->propName, fMemFrom->propName);
        }
        if (fMemFrom->fontName) {
            size = strlen(fMemFrom->fontName);
            fMemTo->fontName = (char *)malloc(size + 1);
            strcpy(fMemTo->fontName, fMemFrom->fontName);
        }
    }
    *onto = (char *)fto;
    return TRUE;
}

static int
freeFontFamily(dp)
char **dp;
{
    fontFamilyRecord *ff;
    int i;
    
    if(*dp) {
        ff = (fontFamilyRecord *) *dp;
        for(i=0; i<ff->numMembers; i++) {
            if(ff->members[i]) {
                if ((ff->members[i])->propName)
                    free((char *) (ff->members[i])->propName);
                if ((ff->members[i])->fontName)
                    free((char *) (ff->members[i])->fontName);
                free((char *) ff->members[i]);
            }
        }
        if (ff->aliasFor) {
            free(ff->aliasFor);
        }
        free(*dp);
    }
    return TRUE;
}

static int
getFontRecord(notUsed, rp, sizep, notUsed2)
char *notUsed;
char **rp; /* to be filled out as an initial fontTabEnt */
int *sizep;
char *notUsed2;
{
    fontTabEnt *ft = (fontTabEnt *)malloc(sizeof(fontTabEnt));
    memset((char *)ft, 0, sizeof(fontTabEnt));
    *rp = (char *)ft;
    *sizep = sizeof(fontTabEnt);
    return TRUE;
}

int
copyFontRecord(notUsed, onto, notUsed2, from)
char *notUsed;
char **onto;
int *notUsed2;
char *from;
{
    fontTabEnt *ffrom, *fto;
    int size, i;

    if (*onto) {
        freeFontRecord((char **) onto);
    }
    if(!from) {
        getFontRecord((char *)NULL, (char **)&fto,
                &size, (char *)NULL);
        *onto = (char *)fto;
        return TRUE;
    }
    else {
        ffrom = (fontTabEnt *)from;
    }
    getFontRecord((char *)NULL, (char **)&fto, &size, (char *)NULL);
    fto->xNamesKnown = ffrom->xNamesKnown;
    fto->scalable = ffrom->scalable;
    fto->fixedWidth = ffrom->fixedWidth;
    fto->gallium = ffrom->gallium;

    if (ffrom->globalName) {
        size = strlen(ffrom->globalName);
        fto->globalName = (char *)malloc(size + 1);
        strcpy(fto->globalName, ffrom->globalName);
    }
    if (ffrom->familyName) {
        size = strlen(ffrom->familyName);
        fto->familyName = (char *)malloc(size + 1);
        strcpy(fto->familyName, ffrom->familyName);
    }
    if (ffrom->aliasFor) {
        size = strlen(ffrom->aliasFor);
        fto->aliasFor = (char *) malloc(size + 1);
        strcpy(fto->aliasFor, ffrom->aliasFor);
    }
    fto->encodingWidth = ffrom->encodingWidth;
    fto->rasterTolerance = ffrom->rasterTolerance;
    fto->toleranceLowCutoff = ffrom->toleranceLowCutoff;
    fto->toleranceHighCutoff = ffrom->toleranceHighCutoff;
    fto->weight = ffrom->weight;
    fto->slant = ffrom->slant;
#if AXMS
    fto->sizeEM = ffrom->sizeEM;
    fto->avgWidth = ffrom->avgWidth;
    fto->charSet = ffrom->charSet;
    fto->pitchAndFamily = ffrom->pitchAndFamily;
    fto->isWindowsFont = ffrom->isWindowsFont;
    fto->isPrinterFont = ffrom->isPrinterFont;
#endif
    fto->numTargetMetricsNames = ffrom->numTargetMetricsNames;
    if (ffrom->numTargetMetricsNames) {
        i = ffrom->numTargetMetricsNames * sizeof(char *);
        fto->targetMetricsNames = (char **) malloc(i);
        memset((char *) fto->targetMetricsNames, 0, i);
    }
    for (i = 0; i < fto->numTargetMetricsNames; i++) {
        if (ffrom->targetMetricsNames[i]) {
            size = strlen(ffrom->targetMetricsNames[i]);
            fto->targetMetricsNames[i] = (char *) malloc(size + 1);
            strcpy(fto->targetMetricsNames[i],
                   ffrom->targetMetricsNames[i]);
        }
    }
    fto->xNameCount = ffrom->xNameCount;
    if (ffrom->xNameCount) {
        i = ffrom->xNameCount * sizeof(char *);
        fto->xNames = (char **)malloc(i);
        memset((char *)fto->xNames, 0, i);
    }
    for(i=0; i<fto->xNameCount; i++) {
        if (ffrom->xNames[i]) {
            size = strlen(ffrom->xNames[i]);
            fto->xNames[i] = (char *)malloc(size + 1);
            strcpy(fto->xNames[i], ffrom->xNames[i]);
        }
    }
    if (ffrom->scalableName) {
        size = strlen(ffrom->scalableName);
        fto->scalableName = (char *)malloc(size + 1);
        strcpy(fto->scalableName, ffrom->scalableName);
    }
    if (ffrom->encodingFileName) {
        size = strlen(ffrom->encodingFileName);
        fto->encodingFileName = (char *)malloc(size + 1);
        strcpy(fto->encodingFileName, ffrom->encodingFileName);
    }
    if (ffrom->encodingName) {
        size = strlen(ffrom->encodingName);
        fto->encodingName = (char *)malloc(size + 1);
        strcpy(fto->encodingName, ffrom->encodingName);
    }
    if (ffrom->PostScriptPrintName) {
        size = strlen(ffrom->PostScriptPrintName);
        fto->PostScriptPrintName = (char *)malloc(size + 1);
        strcpy(fto->PostScriptPrintName, ffrom->PostScriptPrintName);
    }
    if (ffrom->PCLPrintName) {
        size = strlen(ffrom->PCLPrintName);
        fto->PCLPrintName = (char *)malloc(size + 1);
        strcpy(fto->PCLPrintName, ffrom->PCLPrintName);
    }
    if (ffrom->PostScriptAlternate) {
        size = strlen(ffrom->PostScriptAlternate);
        fto->PostScriptAlternate = (char *)malloc(size + 1);
        strcpy(fto->PostScriptAlternate, ffrom->PostScriptAlternate);
    }
    if (ffrom->PCLAlternate) {
        size = strlen(ffrom->PCLAlternate);
        fto->PCLAlternate = (char *)malloc(size + 1);
        strcpy(fto->PCLAlternate, ffrom->PCLAlternate);
    }
#if BUILD_KANJI
    fto->sans = ffrom->sans;
    if (ffrom->LIPSPrintName) {
        size = strlen(ffrom->LIPSPrintName);
        fto->LIPSPrintName = (char *)malloc(size + 1);
        strcpy(fto->LIPSPrintName, ffrom->LIPSPrintName);
    }
#endif
    if (ffrom->Type1FontFileName) {
        size = strlen(ffrom->Type1FontFileName);
        fto->Type1FontFileName = (char *)malloc(size + 1);
        strcpy(fto->Type1FontFileName, ffrom->Type1FontFileName);
    }
    if (ffrom->WindowsAlternate) {
        size = strlen(ffrom->WindowsAlternate);
        fto->WindowsAlternate = (char *)malloc(size + 1);
        strcpy(fto->WindowsAlternate, ffrom->WindowsAlternate);
    }
    if (ffrom->XAlternate) {
        size = strlen(ffrom->XAlternate);
        fto->XAlternate = (char *)malloc(size + 1);
        strcpy(fto->XAlternate, ffrom->XAlternate);
    }
    if (ffrom->internalEncodingName) {
        size = strlen(ffrom->internalEncodingName);
        fto->internalEncodingName = (char *)malloc(size + 1);
        strcpy(fto->internalEncodingName, ffrom->internalEncodingName);
    }
    if (ffrom->largeXAlternate) {
        size = strlen(ffrom->largeXAlternate);
        fto->largeXAlternate = (char *)malloc(size + 1);
        strcpy(fto->largeXAlternate, ffrom->largeXAlternate);
    }
    *onto = (char *)fto;
    return TRUE;
}


int
freeFontRecord(dp)
char **dp;
{
    fontTabEnt *f;
    int ix;
    
    if (*dp) {
        f = (fontTabEnt *)*dp;
        
        if (f->globalName)
            free(f->globalName);
        
        if (f->familyName)
            free(f->familyName);
        
        if (f->aliasFor)
            free(f->aliasFor);
        
        if (f->scalableName)
            free(f->scalableName);
        
        if (f->encodingFileName)
            free(f->encodingFileName);
        
        if (f->encodingName)
            free(f->encodingName);
        
        if (f->targetMetricsNames) {
            for (ix = 0; ix < f->numTargetMetricsNames; ix++) {
                free((char *) f->targetMetricsNames[ix]);
            }
            free((char *) f->targetMetricsNames);
        }
        
        if (f->PostScriptPrintName)
            free(f->PostScriptPrintName);
        
        if (f->PCLPrintName)
            free(f->PCLPrintName);
        
        if (f->PostScriptAlternate)
            free(f->PostScriptAlternate);
        
        if (f->PCLAlternate)
            free(f->PCLAlternate);

#if BUILD_KANJI
        if (f->LIPSPrintName)
            free(f->LIPSPrintName);
#endif
        
        if (f->Type1FontFileName)
            free(f->Type1FontFileName);
        
        if (f->xNames) {
            for (ix = 0; ix < f->xNameCount; ix++) {
                free((char *) f->xNames[ix]);
            }
            free((char *) f->xNames);
        }
        
        if (f->WindowsAlternate)
            free(f->WindowsAlternate);
        
        if (f->XAlternate)
            free(f->XAlternate);
        
        if (f->largeXAlternate)
            free(f->largeXAlternate);
        
        if (f->internalEncodingName)
            free(f->internalEncodingName);
        
        free(*dp);
    }
    return TRUE;
}

fontTabEnt *
newFontRecord()
{
    fontTabEnt *f;
    f = (fontTabEnt *) malloc (sizeof(fontTabEnt));
    if (!f)
        return ((fontTabEnt *) NULL);
    memset((char *) f, 0, sizeof(fontTabEnt));
    return (f);
}

/* Should get a little fancier and support specification
 * of varying degrees of bold, ital (like b=2, i=5, etc..)
 * For now, just looking for presence of 'b' and 'i' keys;
 * therefore the check here is extrememly cheap n' nasty --
 * e.g., if the modstring says "(brain-dead programmer)",
 * we'll say the font is bold, ital
 */
static void
readBoldItal(modstring, bp, ip)
char *modstring;
int *bp; /* as in bold.. */
int *ip;
{
    char *cp = modstring;
    *bp = *ip = FALSE;
    while(*cp) {
        if (*cp == 'b')
            *bp = TRUE;
        if (*cp == 'i')
            *ip = TRUE;
        cp++;
    }
}

int /* TRUE if ok */
updateFontTable(tableFile, screenRes, targetRes, notUsed)
char *tableFile;            /* in */
int *screenRes, *targetRes; /* out */
int *notUsed;               /* out */
{
    char *axReadFontMapDirFile();
    char *errStr;
#if AXMS
    int ret;
#endif

    /* this was used for reporting approx. line number
     * at which read of fontmap.dir failed..  should be reconnected
     */
    *notUsed = 0;
    
#if AXMS
    /* for windows we enumerate the system supplied fonts first
     */
    ret = EnumerateWinFonts( screenRes );
    if (!ret)
        return( FALSE );

    EnumeratePrinterFonts(NULL, targetRes);

    if ( !tableFile )
        return TRUE;
#endif

    /* read fontmap.dir for any further info
     */
    errStr = axReadFontMapDirFile(tableFile, screenRes, targetRes);
    if (errStr) {
        freeErrString(errStr);
        return FALSE;
    }
    else
        return TRUE;
}

static void
initFontCache()
{
    int j, wid, *itemval, itemsize;
    typeFuncs tfuncs;

        /* the 0th list is the CACHELISTS list; it pairs
         * the other cache list names with their list indices */
    AxFontCache.numLists = 1;
    AxFontCache.lists = (cashList *) malloc(sizeof(cashList));
    AxFontCache.fetch = (int (**)()) malloc(sizeof(int (*)()));
    AxFontCache.copy = (int (**)()) malloc(sizeof(int (*)()));
    AxFontCache.toss = (int (**)()) malloc(sizeof(int (*)()));
    AxFontCache.fetch[0] = getCacheList;
    AxFontCache.copy[0] = copyCacheList;
    AxFontCache.toss[0] = freeCacheList;
    AxFontCache.lists[0].limit =
    AxFontCache.lists[0].usage = 0;
    AxFontCache.lists[0].fetchCounter = 0;
    AxFontCache.lists[0].kickOutCounter = 0;
    wid = AxFontCache.lists[0].tableWidth = ENCODING_TABLE_WIDTH;
    AxFontCache.lists[0].table = (cItem **)malloc(wid * sizeof(cItem *));
    for(j=0; j<wid; j++) {
        AxFontCache.lists[0].table[j] = (cItem *)NULL;
    }
    setCacheLimit(&AxFontCache, CACHELISTS,
        TARGETLIMITFACTOR * AxFontCache.lists[CACHELISTS].tableWidth);

        /* now create the other lists; important to do this in
         * the proper order, so that the assigned indices will match
         * the shortcut constants in fontcach.h */
                    /* "internal" scalable target font metrics */
    tfuncs.fetch = getTargetMetrics;
    tfuncs.copy = copyTargetMetrics;
    tfuncs.toss = freeTargetMetrics;
    getItem(FIND, CACHELISTS, NXLT("TargetMetrics"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
                   /* "internal" pixel screen font metrics */
    tfuncs.fetch = getScreenMetrics;
    tfuncs.copy = copyScreenMetrics;
    tfuncs.toss = freeScreenMetrics;
    getItem(FIND, CACHELISTS, NXLT("ScreenMetrics"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
                   /* application screen font metrics */
    tfuncs.fetch = getScreenFontMetrics;
    tfuncs.copy = copyScreenFontMetrics;
    tfuncs.toss = freeScreenFontMetrics;
    getItem(FIND, CACHELISTS, NXLT("ScreenFontMetrics"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
                   /* application target font metrics */
    tfuncs.fetch = getTargetFontMetrics;
    tfuncs.copy = copyTargetFontMetrics;
    tfuncs.toss = freeTargetFontMetrics;
    getItem(FIND, CACHELISTS, NXLT("TargetFontMetrics"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getLetterform;
    tfuncs.copy = copyLetterform;
    tfuncs.toss = freeLetterform;
    getItem(FIND, CACHELISTS, NXLT("Letterforms"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getFontFamily;
    tfuncs.copy = copyFontFamily;
    tfuncs.toss = freeFontFamily;
    getItem(FIND, CACHELISTS, NXLT("FontFamilies"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getFontRecord;
    tfuncs.copy = copyFontRecord;
    tfuncs.toss = freeFontRecord;
    getItem(FIND, CACHELISTS, NXLT("FontRecords"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getEncoding;
    tfuncs.copy = copyEncoding;
    tfuncs.toss = freeEncoding;
    getItem(FIND, CACHELISTS, NXLT("FontEncoding"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
        /* include a few popular encodings up front */
    tfuncs.fetch = getEncodingPair;
    tfuncs.copy = copyEncodingPair;
    tfuncs.toss = freeEncodingPair;
    getItem(FIND, CACHELISTS, NXLT("ISOLatin1Encoding"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getEncodingPair;
    tfuncs.copy = copyEncodingPair;
    tfuncs.toss = freeEncodingPair;
    getItem(FIND, CACHELISTS, NXLT("FontSpecific"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getEncodingPair;
    tfuncs.copy = copyEncodingPair;
    tfuncs.toss = freeEncodingPair;
    getItem(FIND, CACHELISTS, NXLT("AxDingbatsEncoding"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getEncodingPair;
    tfuncs.copy = copyEncodingPair;
    tfuncs.toss = freeEncodingPair;
    getItem(FIND, CACHELISTS, NXLT("AdobeStandardEncoding"),
            (char **) &itemval,
            &itemsize, (char *) &tfuncs);
    tfuncs.fetch = getReferenceCellStruct;
    tfuncs.copy = copyReferenceCellStruct;
    tfuncs.toss = freeReferenceCellStruct;
    getItem(FIND, CACHELISTS, NXLT("ReferenceCells"),
            (char **) &itemval,
            &itemsize, (char *) &tfuncs);

        /* set limits for the established cache lists */
    setCacheLimit(&AxFontCache, TARGET_METRICS,
        TARGETLIMITFACTOR * AxFontCache.lists[TARGET_METRICS].tableWidth);
    setCacheLimit(&AxFontCache, SCREEN_METRICS,
        SCREENLIMITFACTOR * AxFontCache.lists[SCREEN_METRICS].tableWidth);
    setCacheLimit(&AxFontCache, SCREENFONT_METRICS, MAXLRU);
    setCacheLimit(&AxFontCache, TARGETFONT_METRICS, MAXLRU);
    setCacheLimit(&AxFontCache, LETTERFORM,
        LETTERLIMITFACTOR * AxFontCache.lists[LETTERFORM].tableWidth);
    setCacheLimit(&AxFontCache, FONTFAMILY,
        FONTFAMILYFACTOR * AxFontCache.lists[FONTFAMILY].tableWidth);
    setCacheLimit(&AxFontCache, FONTRECORD,
        FONTRECORDFACTOR * AxFontCache.lists[FONTRECORD].tableWidth);
            /* for encoding resources, set effectively infinite */
    setCacheLimit(&AxFontCache, ENCODING, MAXLRU);
    setCacheLimit(&AxFontCache, LATIN1, MAXLRU);
    setCacheLimit(&AxFontCache, FONTSPECIFIC, MAXLRU);
    setCacheLimit(&AxFontCache, AXBATS, MAXLRU);
    setCacheLimit(&AxFontCache, ADOBESTANDARD, MAXLRU);
            /* reference cell structs will be lightly used */
    setCacheLimit(&AxFontCache, REFERENCE_CELL, MAXLRU);
        
        /* add a fixed list for detecting whether a font
           record's metrics file is from the asterx base
           font set (i.e., from the rev2 asterx font set) */
    tfuncs.fetch = getTrivialItem;
    tfuncs.copy = copyTrivialItem;
    tfuncs.toss = freeTrivialItem;
    getItem(FIND, CACHELISTS, NXLT("axBaseSetNames"), (char **) &itemval,
                &itemsize, (char *) &tfuncs);
        /* make the limit more than large enough to hold
           the 35 (metrics file) names that will be there */
    setCacheLimit(&AxFontCache, *itemval, MAXLRU);
    cacheBaseFontSetNames(*itemval);
}

/* : emptyCacheList - removes all the data from the named cache list.
 * the emptied list is left in place. (there really should exist a
 * deleteCacheList too..) */
int
emptyCacheList(listName)
char *listName;
{
    int *cacheIndex, itemsize, j;
    cItem *ip, *nextIp;
    cashList *list;
        /* get the index for the named cache */
    if(!getItem(FIND, CACHELISTS, listName, (char **) &cacheIndex,
                &itemsize, (char *) NULL)) {
        return FALSE; /* list doesn't exist */
    }
        /* empty the list */
    list = &AxFontCache.lists[*cacheIndex];
    for (j=0; j<list->tableWidth; j++) {
        if (list->table[j]) {
            for (ip = list->table[j], nextIp = ip->next; ip;) {
                deleteItem(ip, *cacheIndex);
                if(ip = nextIp)
                    nextIp = ip->next;
                else
                    break;
            }
            list->table[j] = (cItem *) NULL;
        }
    }
    return TRUE;
}

/* : dumpCachelistNames - reports all the itemnames in the
 * named list.  Caller must free the resultant list
 * (use freeCacheNameList) */
int
dumpCachelistNames(listName, itemNames, numNames)
char *listName;
char **itemNames; /* to be filled as string of newline-separated names */
int *numNames;
{
    int *cacheIndex, itemsize, j, len;
    int nameCount, memSize;
    char *cp;
    cashList *list;
    cItem *ip, *nextIp;
        /* get the index for the named cache */
    if(!getItem(FIND, CACHELISTS, listName, (char **) &cacheIndex,
                &itemsize, (char *) NULL)) {
        *numNames = 0;
        *itemNames = (char *)NULL;
        return FALSE; /* list doesn't exist */
    }
        /* count how many items are in the list */
    list = &AxFontCache.lists[*cacheIndex];
    for (j = 0, nameCount = 0, memSize = 0; j<list->tableWidth; j++) {
        if (list->table[j]) {
            for (ip = list->table[j], nextIp = ip->next; ip;) {
                nameCount++;
                if (ip->name)
                    memSize += strlen(ip->name) + 1;
                if(ip = nextIp)
                    nextIp = ip->next;
                else
                    break;
            }
        }
    }
    if (!nameCount) {
        *numNames = 0;
        *itemNames = (char *)NULL;
        return FALSE;
    }
        /* alloc return mem and fill it out */
    *itemNames = (char *) malloc (memSize + 1);
    for (j = 0, cp = *itemNames; j<list->tableWidth; j++) {
        if (list->table[j]) {
            for (ip = list->table[j], nextIp = ip->next; ip;) {
                if (ip->name) {
                    len = strlen(ip->name);
                    strcpy(cp, ip->name);
                    cp[len] = '\n'; /* change null to newline */
                    cp += len + 1;
                }
                if(ip = nextIp)
                    nextIp = ip->next;
                else
                    break;
            }
        }
    }
    (*itemNames)[memSize - 1] = '\n'; /* probably redundant */
    (*itemNames)[memSize] = 0; /* end the list */
    *numNames = nameCount;
    return TRUE;
}

void
freeCacheNameList(nameList)
char *nameList;
{
    if (nameList)
        free((char *) nameList);
}

    /* given a pointer to a *cItem somewhere in the cache,
     * directly free it.  Note that the caller should determine
     * whether the item just freed was the head of a hash table
     * slot, and if so, null the slot after freeing */
static int
deleteItem(ip, itemType)
cItem *ip;
int itemType;
{
    if (!ip)
        return FALSE;
    if (ip->name)
        free((char *) ip->name);
    if (ip->value) {
        (*AxFontCache.toss[itemType])(&ip->value);
        ip->value = (char *) NULL;
    }

        /* note that this destroys the ip->next value */
    free((char *)ip);
    return TRUE;
}

int
sizeCache()
{
    int total, i;
    fontCash *cache = &AxFontCache;

    for(i=0, total=0; i<NUM_LISTS; i++) {
        total += cache->lists[i].usage;
    }
    return total;
}

/* process an external encoding file (an Adobe .afm can be used, e.g.)
 */
static int
getEncoding(fileName, encodingType, sizep, notUsed)
char *fileName;
char **encodingType; /* returned as char *, e.g., "ISOLatin1Encoding" */
char *sizep;
char *notUsed;
{
    FILE *fp, *getFontmetricsFile();
    char rec[MXREC], *rp, *tp, *tp2; 
    char *cp = (char *) NULL;
    char *np = (char *) NULL;
    char *encoding;
    int inChars, charcode, *ip, itemsize;
    int encodingListIndex, getEncodingType();
    void closeFile();
                    

    fp = getFontmetricsFile(fileName);
    if (!fp) {
        *encodingType = (char *) NULL;
        *sizep = 0;
        return FALSE;
    }
    /* look for records:
     *  EncodingScheme -- use for selecting which encoding
     *  StartCharMetrics
     *  EndCharMetrics -- these delimit section of encoding
     *                    entries
     */
    inChars = FALSE;
    encoding = (char *) NULL;
    encodingListIndex = -1;
    while(fgets(rec, MXREC, fp) != (char *)NULL) {
        if (inChars) {
            if(strncmp(rec, NXLT("EndCharMetrics"), 14) == 0 &&
                    (WHITESPACE(rec[14]) || rec[14] == '\n')) {
                    closeFile(fp);
                    if (encoding) {
                        writeCharStrType(encodingType, encoding, sizep);
                        free((char *) encoding);
                    }
                    else {
                        *encodingType = (char *) NULL;
                    }
                    return TRUE;
            }
            else if (strncmp(rec, NXLT("EndFont"), 7) == 0) {
                    closeFile(fp);
                    if (encoding) {
                        writeCharStrType(encodingType, encoding, sizep);
                        free((char *) encoding);
                    }
                    else {
                        *encodingType = (char *) NULL;
                    }
                    return TRUE;
            }
            else {
                /* assume we've got a char metrics entry.
                 * we want the character code and character
                 * name values */
                rp = rec;
                while(getKeyVal(&rp, &tp, &tp2)) {
                    if(strcmp(tp, "C") == 0) {
                        cp = tp2; /* character code str */
                    }
                    else if(strcmp(tp, "N") == 0) {
                        np = tp2; /* name str */
                    }
                }
                /* load this encoding pair */
                charcode = atoi(cp);
                ip = &charcode;
                itemsize = sizeof(int);
                if (encodingListIndex == -1) {
                        /* don't load if type unset */
                    closeFile(fp);
                    if (encoding)
                        free((char *) encoding);
                    return FALSE;
                }
                getItem(LOAD, encodingListIndex,
                            np, (char **)&ip, &itemsize, (char *)NULL);
            }
        }
        else {
            if(strncmp(rec, NXLT("EncodingScheme"), 14) == 0 &&
                WHITESPACE(rec[14])) {
                cp = &rec[15];
                while(WHITESPACE(*cp))
                    cp++;
                /* now cp points to value */
                tp = cp;
                while(!WHITESPACE(*tp) && *tp != '\n')
                    tp++;
                *tp = '\0'; /* null-term the value string */
                encoding = (char *) malloc (strlen(cp) + 1);
                strcpy(encoding, cp);
                writeCharStrType(encodingType, encoding, sizep);
                encodingListIndex = getEncodingType(encoding);
            }
            else if(strncmp(rec, NXLT("StartCharMetrics"), 16) == 0 &&
                (WHITESPACE(rec[16]) || rec[16] == '\n')) {
                inChars = TRUE;
            }
        }
    }
    /* we were supposed to have found "EndCharMetrics" or 
     * "EndFont.." while in the inChars state; if we're here,
     * then that didn't happen, so */
    closeFile(fp);
    if (encoding)
        free((char *) encoding);
    return FALSE;
}

    /* the value of a "FontEncoding" item is a charstring */
static int
copyEncoding(notUsed, onto, notUsed2, from)
char *notUsed;
char **onto;
int *notUsed2;
char *from;
{
    int len;
    if (!onto)
        return FALSE;
    if (!from) {
        *onto = (char *) NULL;
        return FALSE;   
    }
    len = strlen(from) + 1;
    *onto = (char *) malloc(len);
    strcpy(*onto, from);
    return TRUE;
}

static int
freeEncoding(np)
char **np;
{
    if (!np || !(*np))
        return FALSE;
    free((char *) (*np));
    return TRUE;
}

static void
writeIntegerType(outVal, inVal, sizep)
char **outVal; /* to be written with integer type */
int inVal;
int *sizep;
{
    if (!outVal)
        return;
    *outVal = (char *) malloc(sizeof(int));
    memcpy(*outVal, (char *)&inVal, sizeof(int));
    *sizep = sizeof(int);
}

static int
writeCharStrType(outVal, inVal, sizep)
char **outVal; /* to be written with char* type */
char *inVal;
int *sizep;
{
    int len;
    if (!outVal || !inVal)
        return FALSE;
    len = strlen(inVal) + 1;
    *outVal = (char *) malloc(len);
    strcpy(*outVal, inVal);
    *sizep = len;
    return TRUE;
}

/* get the next key, value pair from a CharMetrics record of a metrics file */
/* an example of a record: "C 208 ; WX 1000 ; N emdash ; B 0 201 1000 250 ;" */
static int
getKeyVal(rec, kp, vp)
/* rec points at the record that we're reading from.  This function
 * will advance the pointer past the current field as it searches.
 * Note also that this func writes nulls onto the record to form
 * terminated strings reported as kp, vp -- so watch out */
char **rec;
char **kp; /* return val set to key string */
char **vp; /* return val set to value string */
{
    /* we expect to be called with *rec pointing either
     * at the record-terminating newline, or at the
     * beginning of a key,value field at or before the
     * keystring.  We'll leave with *rec set to the next
     * such position in the record */
    char *tp;
    while(WHITESPACE(**rec)) {
        (*rec)++;
    }
    if (**rec=='\n' || **rec=='\0')
        return FALSE;
    *kp = *rec;
    while(!WHITESPACE(**rec)) {
        (*rec)++;
    }
    **rec = '\0'; /* null-term key string */
    (*rec)++;
    while(WHITESPACE(**rec)) {
        (*rec)++;
    }
    if (**rec=='\n' || **rec=='\0')
        return FALSE;
    *vp = *rec;
    while(**rec!=';' && **rec!='\n' && **rec!='\0') {
        (*rec)++; /* advance to end of field */
    }
    /* *rec is now at the end-of-field delimiter.
     * omit any whitespace between the end of the
     * valuestring and this point */
    tp = *rec - 1;
    while(WHITESPACE(*tp))
        tp--;
    tp++; /* tp now points at null-stamp position */
    if(**rec != '\0')
        (*rec)++;
    *tp = '\0';
    return TRUE;
}

/* : getEncodingType - return the cache list index for
 * the named encoding.
 *
 * Handles only our adobe-style encoding storage form,
 * i.e., (char *)glyphname paired with character code.
 * Intellifont tfm's express encoding differently..
 * This adobe-style dependence shows up in the last
 * else case, where the get/copy/freeEncodingPair funcs
 * are supplied to maintain items in the added list --
 * those functions handle the adobe-style form only.
 * 
 * Note that we take the encoding name literally, so that
 * if two different encoding vectors are encountered that
 * declare the same encoding name, we'll use the same
 * cache for both.  Should the same glyphname exist in
 * both vectors, the latest instance seen will set the
 * codepoint for that glyphname..
 */
int
getEncodingType(cp)
char *cp;   /* points to EncodingScheme value string */
{
    int *itemval, itemsize;
    typeFuncs tfuncs;

    if (cp == (char *)NULL) {
        return FONTSPECIFIC;
    }
    if (strncmp(cp, NXLT("ISOLatin1Encoding"), 17) == 0) {
        return LATIN1;
    }
    else if(strncmp(cp, NXLT("AxDingbatsEncoding"), 18) == 0) {
        /* our (sob!) home-brew dingbats encoding */
        return AXBATS;
    }
    else if(strncmp(cp, NXLT("FontSpecific"), 12) == 0) {
        /* this is a good example of distinct encoding vectors
         * claiming the same encoding, like Adobe Dingbats and Symbol,
         * ideally, their 'union' should still have the property
         * that only one charcode is specified for a given charname */
        return FONTSPECIFIC;
    }
    else if(strncmp(cp, NXLT("AdobeStandardEncoding"), 21) == 0) {
        return ADOBESTANDARD;
    }
    else {
            /* the above cases are for encoding lists which were
             * added at initFontCache time; their indices are known
             * from the order in which they were added.  For this
             * case, the index must be looked up by name */
        tfuncs.fetch = getEncodingPair;
        tfuncs.copy = copyEncodingPair;
        tfuncs.toss = freeEncodingPair;
        getItem(FIND, CACHELISTS, cp, (char **) &itemval,
                    &itemsize, (char *) &tfuncs);
        return (*itemval);
    }
}

static void
setCacheLimit(cache, type, limit)
fontCash *cache;
int type;
int limit;
{
    cache->lists[type].limit = limit;
    cache->lists[type].kickOutCounter = 0;
}

void
setFontCacheLimit(type, limit)
int type, limit;
{
    setCacheLimit(&AxFontCache, type, limit);
}

static void
incStamp(ip, list)
cItem *ip;
cashList *list;
{
    if (ip->lru >= MAXLRU) {
        /* need to reassign all lru numbers in list */
        cItem *tp;
        int ix, stamp = 0;

        for (ix = 0; ix < list->tableWidth; ix++) {
            if (list->table[ix]) {
                for (tp = list->table[ix]; tp; tp = tp->next) {
                    tp->lru = stamp++;
                }
            }
        }
        ip->lru = stamp;
    }
    else {
        ip->lru++;
    }
}

static cItem *
getOldestItem(list, prev, listhead)
cashList *list;
cItem **prev;        /* out: init as addr of previous cItem;
                        could end up same as oldestItem */
cItem ***listhead;   /* out: init as addr of headptr of list
                        containing oldestItem */
{
    cItem *tp, *ltp, *oldestItem = (cItem *) NULL;
    int ix, smallestLru = MAXLRU;

    *prev = (cItem *) NULL;
    *listhead = (cItem **) NULL;
    for (ix = 0; ix < list->tableWidth; ix++) {
        if (list->table[ix]) {
            for (tp = ltp = list->table[ix]; tp; tp = tp->next) {
                if (tp->lru < smallestLru) {
                    smallestLru = tp->lru;
                    oldestItem = tp;
                    *prev = ltp;
                    *listhead = &list->table[ix];
                }
                ltp = tp;
            }
        }
    }
    return (oldestItem);
}

/* NOTE: might want to use an optimization that if
 * the size of an item is sizeof(int), then rather than
 * allocate onto ip->value, simply write on ip->value; this
 * will avoid hitting the free store for these small items.
 */
/*
 * function: getItem -- get a reference to a cache object (FIND),
 * or, cache an updated object (LOAD).  Any block of code which
 * will use a pointer to a cache object must first call this
 * function to ensure that the pointer is up to date (the object
 * may have a new address since the last pass thru that block.)
 */
    /* note that the pointer 'list' is reassigned after calls
     * to fetch, copy, toss, because it is possible for those
     * funcs to cause the readressing of the arrays AxFontCache.list,
     * .fetch, .toss, .copy (e.g., fetch of a cache list) */
static int /* bool: TRUE if ok */
getItem(op, type, name, item, itemsize, extra)
int op; /* FIND or LOAD */
int type; /* in */
char *name; /* in */
char **item; /* in for LOAD, out for FIND */
int *itemsize; /* in for LOAD, out for FIND */
char *extra; /* extra info particular to the item type */
{
    int hash, wid;
    char *np;
    cItem *ip, **tp;
    cashList *list;
    fontCash *cache = &AxFontCache;
    void incStamp();

    np = name;
    hash = 0;
    list = &cache->lists[type];
    wid = list->tableWidth;

    while (*np)
        hash = (hash<<1) ^ (*np++);
    if (hash < 0)
        hash = -hash;
    hash = hash % wid;

    tp = &list->table[hash];
    ip = (cItem *)(*tp);
    while(ip) {
        if (ip->name && strcmp(name, ip->name) == 0) {
            /* found an item by this name
             */
            if (op == LOAD) {
                /* overwrite with new value --
                 * item holds the data
                 */
                (*cache->toss[type])(&ip->value);
                ip->value = (char *) NULL;
                list = &cache->lists[type];
                list->usage -= ip->size;
                (*cache->copy[type])(ip->name, &ip->value,
                            itemsize, *item);
                list = &cache->lists[type];
                list->usage += *itemsize;
                ip->size = *itemsize;
            }
            else {
                /* operation is FIND or LOOKUP; return what we found
                 */
                if (!ip->value) {
/************** should probably toss the name at fail time, too */
                    /* found nothing paired with the name; this
                     * can occur becuz the fetch for that name's
                     * value failed previously
                     */
                    return FALSE;
                }
                *item = ip->value;
                *itemsize = ip->size;
            }
            incStamp(ip, list);
            return TRUE;
        }
        ip = ip->next;
    }

    if (op == LOOKUP) {
        *item = (char *) NULL;
        *itemsize = 0;
        return FALSE;
    }

    /* not there; go get it, and attach */

    if (list->usage < list->limit) {
        /* add a new item
         */
        ip = (cItem *)malloc(sizeof(cItem));
        memset((char *)ip, 0, sizeof(cItem));
        ip->name = (char *)malloc(strlen(name) + 1);
        strcpy(ip->name, name);
        ip->next = *tp;
        *tp = ip;
    }
    else {
        cItem *prev, **prevtp;

        /* must kick out an item
         */
        cItem *victim = getOldestItem(list, &prev, &prevtp);

        if (victim) {
            /* kick out this 'oldest' data
             */
            ip = victim;
            (*cache->toss[type])(&ip->value);
            if (ip->name)
                free((char *) ip->name);
            list = &cache->lists[type];
            list->usage -= ip->size;
            list->kickOutCounter++;

            /* unthread and free victim
             */
            if (victim == *prevtp) {
                /* victim is the head of the list
                 */
                *prevtp = ip->next;
            }
            else {
                prev->next = ip->next;
            }
            free((char *) ip);
        }

        /* add the new item
         */
        ip = (cItem *)malloc(sizeof(cItem));
        memset((char *)ip, 0, sizeof(cItem));
        ip->name = (char *)malloc(strlen(name) + 1);
        strcpy(ip->name, name);
        ip->next = *tp;
        *tp = ip;
    }
    if (op == LOAD) {
        /* the passed in params carry the data to store;
         * value holds the data
         */
        (*cache->copy[type])(ip->name, &ip->value,
                    itemsize, *item);
        ip->size = *itemsize;
    }
    else {
        /* op == FIND; call the 'constructor' for the item
         */
        if(!(*cache->fetch[type])(ip->name, &ip->value,
                    &ip->size, extra)) {
            return FALSE;
        }
    }
    cache->lists[type].fetchCounter++;
    
    list = &cache->lists[type];
        /* update usage, report itemsize
         */
    list->usage += ip->size;
    if (op == FIND || op == LOOKUP) {
        *item = ip->value;
        *itemsize = ip->size;
    }
    incStamp(ip, list);
    return TRUE;
}

    /* for an optimization in which one can test whether
     * anything at all may have been kicked out of the cache since
     * an earlier access, so that an old item pointer can be
     * reused without lookup.  The counter just increments until
     * it wraps, so there is a very remote possibility that the
     * counter appears to be the same when in reality it has
     * wrapped around to the same value (nearly impossible.) */
unsigned long
kickOutCounterValue(type)
int type;
{
    return (AxFontCache.lists[type].kickOutCounter);
}


static int
fontRecordSize(fr)
fontTabEnt *fr;
{
    int ix;
    int tsize = sizeof(fontTabEnt);

    if (fr->globalName)
        tsize += strlen(fr->globalName);
    if (fr->familyName)
        tsize += strlen(fr->familyName);
    if (fr->numTargetMetricsNames) {
        tsize += fr->numTargetMetricsNames * sizeof(char *);
        for (ix = 0; ix < fr->numTargetMetricsNames; ix++) {
            if (fr->targetMetricsNames[ix])
                tsize += strlen(fr->targetMetricsNames[ix]);
        }
    }
    if ( fr->WindowsAlternate )
        tsize += strlen(fr->WindowsAlternate);
    if ( fr->XAlternate )
        tsize += strlen(fr->XAlternate);

#if AX_X11
    if (fr->xNameCount) {
        tsize += fr->xNameCount * sizeof(char *);
        for (ix = 0; ix < fr->xNameCount; ix++) {
            if (fr->xNames[ix])
                tsize += strlen(fr->xNames[ix]);
        }
    }
    if (fr->scalableName)
        tsize += strlen(fr->scalableName);
    if (fr->encodingFileName)
        tsize += strlen(fr->encodingFileName);
    if (fr->encodingName)
        tsize += strlen(fr->encodingName);
    if (fr->PostScriptPrintName)
        tsize += strlen(fr->PostScriptPrintName);
    if (fr->PCLPrintName)
        tsize += strlen(fr->PCLPrintName);
    if (fr->PostScriptAlternate)
        tsize += strlen(fr->PostScriptAlternate);
    if (fr->PCLAlternate)
        tsize += strlen(fr->PCLAlternate);
#if BUILD_KANJI
    if (fr->LIPSPrintName)
        tsize += strlen(fr->LIPSPrintName);
#endif
    if (fr->Type1FontFileName)
        tsize += strlen(fr->Type1FontFileName);
#endif

    return (tsize);
}

    /* typedef and type funcs for listing font
       family names in axListFontFamilies() */

typedef struct {
    char *name;
    int number;
} fontFamilyName;

static int
getFontFamilyName( name, nData, sizep, familyNumber )
char *name; /* e.g., Times */
char **nData; /* to be filled out as fontFamilyName instance */
int *sizep;
char *familyNumber;  /* read as an integer */
{
    fontFamilyName *famName;
    int len;

    if (!name)
        return FALSE;
    famName = (fontFamilyName *) malloc(sizeof(fontFamilyName));
    len = strlen(name) + 1;
    famName->name = malloc(len);
    strcpy(famName->name, name);
	/* cast to long to avoid compiler warnings on 64-bit platforms */
    famName->number = (int)(long) familyNumber;
    *nData = (char *) famName;
    *sizep = sizeof(fontFamilyName) + len;
    return TRUE;
}

static int
copyFontFamilyName (name, onto, sizep, from )
char *name;
char **onto; /* out; at true return, this addresses a copy of *from */
int *sizep;
char *from;
{
    return FALSE; /* no copy op defined for this type */
}

static int
freeFontFamilyName( nData )
char **nData;
{
    fontFamilyName *fn;
    if (!nData || !(*nData))
        return FALSE;
    fn = (fontFamilyName *) *nData;
    if (fn->name)
        free((char *) fn->name);
    free(fn);
    return TRUE;
}



int AStrcmpP();    /* string comparison for sorting  */


char ** /* list of font family name strings which caller must free */
axListFontFamilies(inList, inListSize, number)
char **inList;  /* in: this list is union'ed with cache list */
int inListSize;
int *number; /* return this -- #names in returned list */
{
    int i, jx, len, wid, numNames, itemsize;
    int famNumber, ordLen;
    cItem *ip;
    cashList *cp;
    typeFuncs tfuncs;
    fontCash *cache = &AxFontCache;
    fontFamilyName *famName;
    fontFamilyRecord *ffam;
    char **families;
    char **orderedFamilies;
    int listIndex;
    int device = axPrintDevice();

        /* create a temp cache list for recording each
         * font family name and its number
         */
    tfuncs.fetch = getFontFamilyName;
    tfuncs.copy = copyFontFamilyName;
    tfuncs.toss = freeFontFamilyName;
    listIndex = axGetCache(NXLT("axFontFams"), (char *) &tfuncs);
    
        /* read thru FONTFAMILY list and record each name & number
         * onto the temp list; note we skip "axDefaultFontFamily" and
         * any family that is "not native" (e.g., .tfm-record-based
         * families are "native" when the default print type is PCL
         */
    cp = &cache->lists[FONTFAMILY];
    wid = cp->tableWidth;
    for(i=0; i<wid; i++) {
        ip = cp->table[i];
        while(ip) {
            if (ip->name && ip->value) {
                ffam = (fontFamilyRecord *) ip->value;
                if (nativeFamily(ip->name, ffam, device)) {
                        /* record this family name in temp list
                         */
                    famNumber = ffam->familyNumber;
                    getItem(FIND, listIndex, ip->name, (char **)
                            &famName, &itemsize, (char *) famNumber);
                }
            }
            ip = ip->next;
        }
    }
    
    famNumber = cache->lists[FONTFAMILY].fetchCounter + 1;
    if (inList && inListSize) {
            /* record these family names as well; assign numbers
             * starting from above FONTFAMILY list's fetchCounter. Names
             * in this list may already be recorded, but that's ok;
             * it means only that famNumber may be bigger than needed
             */
        for (i = 0; i < inListSize; i++) {
            getItem(FIND, listIndex, inList[i], (char **)
                    &famName, &itemsize, (char *) famNumber);
            famNumber++;
        }
    }
    
    /* read the temp list, and record each name in familyNumber order
     */
    ordLen = (famNumber + 1) * sizeof(char *);
    orderedFamilies = (char **) malloc(ordLen);
    memset((char *) orderedFamilies, 0, ordLen);

    cp = &cache->lists[listIndex];
    wid = cp->tableWidth;
    numNames = 0;
    for(i=0; i<wid; i++) {
        ip = cp->table[i];
        while(ip) {
            if (ip->name && ip->value) {
                famName = (fontFamilyName *) ip->value;
                if (famName->number >= 0 && famName->number < famNumber) {
                    if (!orderedFamilies[famName->number]) {
                            /* should always be true */
                        numNames++;
                    }
                    orderedFamilies[famName->number] =
                        famName->name;
                }
            }
            ip = ip->next;
        }
    }
    
        /* now produce the array of family names
         */
    len = numNames * sizeof(char *);
    families = (char **) THIMalloc(len);  /* this mem returned to
                                             caller */
    memset((char *) families, 0, len);

    for(i = 0, jx = 0; i < famNumber; i++) {
        if (orderedFamilies[i] && jx < numNames) {
            families[jx] = THIMalloc(strlen(orderedFamilies[i]) + 1);
            strcpy(families[jx], orderedFamilies[i]);
            jx++;
        }
    }

    /* sort the list of fonts */
    qsort( families, numNames, sizeof(char *), AStrcmpP );

    emptyCacheList(NXLT("axFontFams"));  /* all done with temp list */
    free((char *) orderedFamilies);
    *number = numNames;
    return families;
}

    /* : nativeFamily - return whether to report passed familyName
     * in the 'general' (not document-specific) set of available
     * font families.  rules: 1) if the default print output is
     * applix-written postscript, then include the family if it is
     * based on .afm metrics.  2) if default print output is applix-
     * generated PCL5, then include families based on .tfm metrics.
     * 3) if running on win32, include only families that appear in
     * the system's list of available families, regardless of
     * default print output setting
     */
static int
nativeFamily(familyName, ffam, defaultPrintDevice)
char *familyName;           /* in */
fontFamilyRecord *ffam;     /* in */
int defaultPrintDevice;     /* in */
{
    familyMember *fmem;
    fontTabEnt *fent;
    char *errString;
    int ix;
    
    if (!strcmp(familyName, NXLT("axDefaultFontFamily"))) {
        return FALSE;             /* special family; don't include */
    }
    
    if (ffam->aliasFor) {
        return FALSE;             /* don't include aliases */
    }
    
#if AXMS
    if (ffam->isWindowsFont || ffam->isPrinterFont) {
        return TRUE;              /* name appeared in truetype list */
    }
    else {
        return FALSE;
    }
#endif
    
    for (ix = 0; ix < ffam->numMembers; ix++) {
        fmem = ffam->members[ix];
        if (errString = axGetFontRecord(fmem->fontName, &fent)) {
            freeErrString(errString);
            return FALSE;
        }
        if (defaultPrintDevice == PS_CLASS_NUM && 
            fent->PostScriptAlternate) {
            return FALSE;
        }
        else if (defaultPrintDevice == PCL_CLASS_NUM &&
                 fent->PCLAlternate) {
            return FALSE;
        }
    }
    return TRUE;
}


    /* cacheBaseFontSetNames - store the names of the metrics
       files which underlie the asterx 2.1 font set; this is
       so that we can detect whether a given font record is based
       on a metrics file from that set */
static void
cacheBaseFontSetNames(listIndex)
int listIndex;
{
    int *val, *siz;

    getItem(FIND, listIndex, NXLT("avb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("avi.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("avj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("avr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("bkb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("bki.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("bkj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("bkr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("cob.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("coi.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("coj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("cor.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hnb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hni.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hnj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hnr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hvb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hvi.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hvj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("hvr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("ncb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("nci.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("ncj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("ncr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("plb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("pli.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("plj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("plr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("tmb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("tmi.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("tmj.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("tmr.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("ymb.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("zpc.afm"),
            (char **)&val, &siz, (char *)NULL);
    getItem(FIND, listIndex, NXLT("zpd.afm"),
            (char **)&val, &siz, (char *)NULL);
}

int
isBaseFontSet(metricsFileName)
char *metricsFileName;
{
    int val, siz;
    int listIndex = axGetCache(NXLT("axBaseSetNames"), (typeFuncs *) NULL);

    return(getItem(LOOKUP, listIndex, metricsFileName,
                   (char **) &val, &siz, (char *) NULL));
}


    /* return "setup number" based on profile setting */
int
axPrintDevice()
{
#if !FOR_FILTER
    char *printClass = GetProfileByStr(XLT("axPrintDefaultType"));

    return(AxPrintSetupFromClassAndType(printClass, NULL));
#else
    return PS_CLASS_NUM;
#endif
}

static int
axtScalableFontName(xlfd)
char *xlfd;
{
    int dashcount, zerocount;
    char *cp;

    if (axtWellFormedXLFD(xlfd)) {
        /* a scalable name will have just '0' in three metrics
         * fields of the name: pixel height (field 7),
         * decipoint size (field 8), and average width (field 12)
         * (from XLFD conventions) */
        for(cp=xlfd, zerocount=0, dashcount=0; *(cp+2)!='\0'; cp++) {
            if(*cp == '-') {
                dashcount++;
                if((dashcount==7 || dashcount==8 || dashcount==12) &&
                        *(cp+1)=='0' && *(cp+2)=='-') {
                    zerocount++;
                }
            }
        }
        if (zerocount == 3)
            return TRUE;
        else
            return FALSE;
    }
    else
        return FALSE; /* not well-formed, so treat as non-scalable */
}

/* : axtXLFDencodingName - given a screenfont xlfd, return a
 * pointer to the charset encoding portion of the name. This
 * function returns the pointer without allocating independent
 * storage for the encoding string; so, caller mustn't free.
 */
char *
axtXLFDencodingName(xlfd)
char *xlfd;
{
    int dashcount, zerocount;
    char *cp;

    if (!xlfd)
        return ((char *) NULL);

    if (axtWellFormedXLFD(xlfd)) {
            /* the encoding string starts just after the 13th dash */
        for(cp=xlfd, zerocount=0, dashcount=0; *(cp+2)!='\0'; cp++) {
            if(*cp == '-') {
                dashcount++;
                if (dashcount == 13) {
                    return (cp + 1);
                }
            }
        }
        return ((char *) NULL); /* shouldn't happen if well-formed */
    }
    else
        return ((char *) NULL); /* not well-formed, so report null */
}

int
axtWellFormedXLFD(xlfd)
char *xlfd;
{
    char *cp;
    int dashcount;
    
    if (!xlfd) {
        return (FALSE);
    }

#if AX_X11  
        /* on X, the xlfd is the X Logical Font Description
         */
    for(cp = xlfd, dashcount = 0; *cp != '\0'; cp++) {
        if(*cp == '-') {
            dashcount++;
        }
    }
    return (dashcount == 14);
#else
        /* in Windows, we use the output of axMakeCompoundWinName
         * as the "xlfd" -- this format is a comma-separated
         * concatenation of pointsize, weight, slant, family. So,
         * consider the name well formed if three commas are found..
         */
    for(cp = xlfd, dashcount = 0; *cp != '\0'; cp++) {
        if(*cp == ',') {
            dashcount++;
        }
    }
    return (dashcount == 3);
#endif
}

static int
wildCardsPresent(xlfd)
char *xlfd;
{
    char *cp;
    int present=FALSE;
    for(cp=xlfd; *cp!='\0'; cp++) {
        if (*cp=='*' || *cp=='?') {
            present = TRUE;
            break;
        }
    }
    return (present);
}

static int
samePointsize(size, xlfd)
int size;
char *xlfd;
{
    int ptSize = axtDecipointSize(xlfd);
    return ((size * 10) == ptSize);
}

    /* return the pixel height of the passed, well-formed xlfd name */
static int
pixelHeight(xlfd)
char *xlfd;
{
    char *cp, *tcp, buf[MAXLFD];
    int dashcount;
    if (axtWellFormedXLFD(xlfd)) {
        strcpy(buf, xlfd);
        for(cp=buf, dashcount=0; *cp!='\0'; cp++) {
            if(*cp=='-') {
                dashcount++;
            }
            if(dashcount==7) {
                    /* next field is pix height in screenpix */
                cp++;
                tcp = cp;
                while(*tcp != '-')
                    tcp++;
                *tcp = '\0'; /* now cp is the pixheight string */
                return(atoi(cp));
            }
        }
    }
    return 0;
}

    /* return the nominal pointsize of the passed, well-formed xlfd name */
int
axtDecipointSize(xlfd)
char *xlfd;
{
    char *cp, *tcp, buf[MAXLFD];
    int dashcount;
    if (axtWellFormedXLFD(xlfd)) {
        strcpy(buf, xlfd);
        for(cp=buf, dashcount=0; *cp!='\0'; cp++) {
            if(*cp=='-') {
                dashcount++;
            }
            if(dashcount == 8) {
                    /* next field is pointsize in decipoints */
                cp++;
                tcp = cp;
                while(*tcp != '-')
                    tcp++;
                *tcp = '\0'; /* now cp is the pointsize string */
                return(atoi(cp));
            }
        }
    }
    return 0;
}

void
axtFormScalableName(xlfd_template, pointsize, resolution, ctm, outname)
char *xlfd_template;     /* in */
int pointsize;           /* in: in points */
int resolution;          /* in */
axctm *ctm;              /* in: optional transformation matrix */
char *outname;           /* out: init caller's >= MAXLFD-sized memory */
{
    char *inp, *outp;
    char fieldValue[64];
    int dashcount, plug;

    /* Copy the well-formed template onto outname,
     * and plug in the pointsize field (field 8),
     * and the x/y resolution fields (fields 9/10).
     *
     * If the ctm param is nonnull, supply an x11r6-style
     * ctm expression as the pointsize.
     */
    inp = xlfd_template;
    outp = outname;
    for(dashcount = 0, plug = FALSE; *inp != '\0'; ) {
        if(*inp == '-') {
            dashcount++;
            if (dashcount == 8 || dashcount == 9 || dashcount == 10) {
                plug = TRUE;
            }
        }
        if (plug) {
            plug = FALSE;
            if (ctm && dashcount == 8) {
                char *tcp;
                sprintf(fieldValue, "-[%.4f %.4f %.4f %.4f]",
                        ((float) pointsize * ctm->ca),
                        ((float) pointsize * ctm->cb),
                        ((float) pointsize * ctm->cc),
                        ((float) pointsize * ctm->cd));
                
                /* need to scan for minus signs, and convert to tildes
                 */
                tcp = fieldValue + 1;            /* skip leading dash */
                while (*tcp && *tcp != ']') {
                    if (*tcp == '-') {
                        *tcp = '~';
                    }
                    tcp++;
                }
            }
            else if (dashcount == 8) {
                sprintf(fieldValue, "-%d", pointsize * 10);
            }
            else if (dashcount == 9 || dashcount == 10) {
#if BUILD_ORIENT
               /* Ashisuto changed. If you force the resolution to 75 even
                * when it was set to 72 for an instance, the font will
                * become dirty.
                * e.g.
                *  -morisawa-gothic medium bbb-bold-r-normal-sans\
                *  -14-140-72-72-m-140-jisx0208.1983-0
                * is an existing font. There is also existing
                *  -morisawa-gothic medium bbb-bold-r-normal-sans\
                *  -72-72-0-0-m-0-jisx0208.1983-0
                * again there is another existing format of the same font
                *  -morisawa-gothic medium bbb-bold-r-normal-sans\
                *  -0-0-0-0-m-0-jisx0208.1983-0
                * If you force the resolution from 72-72 to 75-75,
                * then the font loaded will becomes
                *  -morisawa-gothic medium bbb-bold-r-normal-sans\
                *  -15-140-75-75-m-0-jisx0208.1983-0
                * (You can investigate this fact by using command xlsatoms)
                * and it is dirty, does not look like a bold font, rather
                * likes a medium font, and worse, the font is a little bigger.
                * While in resolution of 72-72, the looks of the gothic font
                * is deadly good.
                *  96.02.02 */
               if (inp[1] >= '1' && inp[1] <= '9') {
                   /* copy the existing font resolution */
                   int ix;
                   fieldValue[0] = '-';
                   for (ix = 1; inp[ix] != '-'; ix++)
                       fieldValue[ix] = inp[ix];
                   fieldValue[ix] = '\0';
               } else {
                   sprintf(fieldValue, "-%d", ScreenRes);
               }
#else
                sprintf(fieldValue, "-%d", resolution);
#endif
            }
            strcpy(outp, fieldValue);
            outp += strlen(fieldValue);
            inp++;
            while (*inp && *inp != '-') {
                inp++;
            }
        }
        else {
            *outp++ = *inp++;
        }
    }
    *outp = '\0';
}

char *  /* user must free this when thru */
getErrString(inString, fontResourceName)
char *inString;
char *fontResourceName;
{
    char *errString;
    int inStringlen, rNamelen;

        /* inString is supposed to be immediate string data */
    inStringlen = strlen(inString);
        /* the fontResourceName may well be garbage; nevertheless.. */
    if (fontResourceName)
        rNamelen = strlen(fontResourceName);
    else
        rNamelen = 0;
    if (inStringlen) {
            /* add 4 for colon, space, newline, null */
        errString = (char *) malloc(inStringlen + rNamelen + 4);
        strcpy(errString, inString);
        if (rNamelen) {
            strcat(errString, ": ");
            strcat(errString, fontResourceName);
        }
        strcat(errString, "\n");
        return errString;
    }
    else
        return (char *)NULL;
}

/* : freeErrString - when a char* error string is returned by
 * getErrString, it's best to free it using this call. has to
 * do with the task-specific free store management */
void
freeErrString(errString)
char *errString;
{
    if (errString) {
        free((char *)errString);
    }
}

/* : axtFreeXLFD - free an xlfd string that was allocated
 * from fntcach.o or axtext.o .....
 */
void
axtFreeXLFD(xlfd)
char *xlfd;
{
    if (xlfd) {
        free((char *) xlfd);
    }
}

int
mToPix(milliems, pointsize, devRes)
int milliems; /* input metric in 1000/ths of an em */
float pointsize;
int devRes; /* device resolution in dots per inch */
{
    float f1, f2;
    int qRound();

    f1 = (float)(milliems);
    f2 = f1 * pointsize;    /* now in 1000ths of a point */
    f2 *= (float) devRes;
    f2 /= (float) 72000;    /* now in targetRes pix */
    return(qRound(f2));
}

int
mToMils(milliems, pointsize)
int milliems;
float pointsize;
{
    float f1, f2, f3;

    f1 = (float)(milliems);
    f2 = pointsize;
    f3 = f1 * f2;   /* now in 1000ths of a point */
    f3 /= (float) 72; /* now in 1000ths of an inch */
    return(qRound(f3));
}

/* 
 * round a real into an int.
 */
int
qRound(val)
float val;
{
    int ti, ti2, neg;
    float topf;

    neg = val < 0.0;
    topf = (float) (INT_MAX - 2);
    if (neg)
        val = -val;
    if (val >= topf)
    {
        val = topf;
        ti  = INT_MAX - 2;
        if ( neg )
            return((-1)*ti);
        else
            return(ti);
    }
    else
    {
        ti = (int) (val + 0.5);
        ti2 = (int) val;
    }
    if (ti > ti2)
    {
        return(neg ? -ti : ti);
    }
    else
    {
        return(neg ? -ti2 : ti2);
    }
}



int
axtInitFonts(lineNumber)
int *lineNumber;          /* out */
{
    int ret;
    
    axtInitMilTables();
    ret = initFonts(lineNumber);
    return (ret);
}

XCharStruct *
getCharStruct(ch, xf)
int ch;
XFontStruct *xf;
{
    int row, col, rowWid, idx;
    XCharStruct *xc;

#if BUILD_KANJI
    static XCharStruct auxc;
#endif

#if BUILD_ORIENT && !FOR_FILTER
    /* get more accurate font */
    xf = VerifyFont( ch, xf );
#endif

    if (xf->max_byte1 == 0) {
        col = ch & 0xff;
        if ((unsigned int) col >= xf->min_char_or_byte2 &&
            (unsigned int) col <= xf->max_char_or_byte2) {
            if (xf->per_char == (XCharStruct *) NULL) {
                xc = &xf->min_bounds;
            }
            else {
                xc = &xf->per_char[col - xf->min_char_or_byte2];
                if (!xc->width) {
                    if (IS_AXGFS_FONT(xf)) {
                        axgfsInitCharStruct(xf, ch, AXGFS_FONT_RES(xf), xc);
                    }
                }
            }
        }
        else {
            xc = &xf->min_bounds;
        }
    }
    else {
        row = ((ch >> 8) & 0xff);
        col = (ch & 0xff);
        if (row >= xf->min_byte1 &&
            row <= xf->max_byte1 &&
            col >= xf->min_char_or_byte2 &&
            col <= xf->max_char_or_byte2) {
            
            rowWid = xf->max_char_or_byte2 -
                xf->min_char_or_byte2 + 1;
            idx = ((row - xf->min_byte1) * rowWid) +
                col - xf->min_char_or_byte2;
            if (xf->per_char == NULL) {
                xc = &xf->min_bounds;
            }
            else {
                xc = &xf->per_char[idx];
                if (!xc->width) {
                    if (IS_AXGFS_FONT(xf)) {
                        axgfsInitCharStruct(xf, ch,  AXGFS_FONT_RES(xf), xc);
                    }
                }
            }
        }
#if BUILD_KANJI
        else if ((xf->fid == 0) && (row == 0x8e)) {
            /* wide font, not verified for ch and xf, out of range, and is
             * NarrowKana. This may be true in Japanese version because we
             * had forced NarrowKana behave like a WideKanji until display
             * it, for getting maximum simplicity of font bindings. When
             * here do width calculation, the correct width must be given,
             * as well as in displaying.
             * Ashisuto added. 1996.03.14
             */
            auxc.lbearing = xf->min_bounds.lbearing / 2;
            auxc.rbearing = xf->min_bounds.rbearing / 2;    /* Half width */
            auxc.width = xf->min_bounds.width / 2;  /* Half width */
            auxc.ascent = xf->min_bounds.ascent;
            auxc.descent = xf->min_bounds.descent;
            auxc.attributes = xf->min_bounds.attributes;
            xc = &auxc;
        } 
        else if ((xf->fid && xf->max_byte1 > 0) && (row == 0x8e)) {
            /* Another case is for filter geinout: ch and xf is also not
             * verified. - Ashisuto added. 1997.03.17
             * Must be care to treat the min/max bounds for scalable/bitmap
             * font metrics. Raised problems for SunRaster narrow-kana fonts.
             * Ashisuto, 1997.08.04
             */
            auxc.lbearing = xf->min_bounds.lbearing / 2;
            auxc.rbearing = xf->max_bounds.rbearing / 2;
            auxc.width = xf->max_bounds.width / 2;  /* Half width */
            auxc.ascent = xf->max_bounds.ascent;
            auxc.descent = xf->max_bounds.descent;
            auxc.attributes = xf->max_bounds.attributes;
            xc = &auxc;
        }
#endif
        else {
            xc = &xf->min_bounds;
        }
    }
    return (xc);
}

/* : screenFontServerSize - return an estimate of the
 * server-side consumption for the passed screenfont.
 * Not real scientific, just take a very rough estimate
 * of the weight of the letterform bits.
 */
static int
screenFontServerSize(fs)
XFontStruct *fs;
{
#if 0   
    int numChars;
    int minRasterArea, maxRasterArea;
    
    minRasterArea = (fs->min_bounds.ascent + fs->min_bounds.descent) *
        (fs->min_bounds.rbearing - fs->min_bounds.lbearing);
    maxRasterArea = (fs->max_bounds.ascent + fs->max_bounds.descent) *
        (fs->max_bounds.rbearing - fs->max_bounds.lbearing);

    numChars = (fs->max_char_or_byte2 - fs->min_char_or_byte2 + 1) *
        (fs->max_byte1 - fs->min_byte1 + 1);
    
    return (((minRasterArea + maxRasterArea) * numChars) / 16);
#else
        /* as of 4.0 beta, the implicit assumption that screenfonts
         * are never closed is pretty pervasive in our code....
         * (widget kit, FontSet stuff, ss edit line, more to come..)
         * So, account for them as consuming _no_ resources
         */
    return 0;
#endif  
}

void
FreeFontCache()
{
    int ix, jx;
    cItem *ip, *tmp;
    cashList *cp;

#if !FOR_FILTER
    FreeFontFamilyCache();
#endif
    
    for (ix = 0; ix < AxFontCache.numLists; ix++) {
        cp = &AxFontCache.lists[ix];
        for (jx = 0; jx < cp->tableWidth; jx++) {
            ip = cp->table[jx];
            while (ip) {
                if (ip->value) {
                    AxFontCache.toss[ix](&ip->value);
                }
                if (ip->name) {
                    free(ip->name);
                }
                tmp = ip;
                ip = ip->next;
                free(tmp);
            }
        }
        free(cp->table);
    }
    free(AxFontCache.lists);
    free(AxFontCache.fetch);
    free(AxFontCache.toss);
    free(AxFontCache.copy);
}

/* : axGetEncodingMap - return a mapping array of type ax_encoding_map,
 * which is used to map codepoints in the 'from' encoding to their
 * counterparts in the 'to' encoding.  Caller must free returned array.
 */
void
axGetEncodingMap(fromenc, toenc, emap)
char *fromenc;                         /* in, e.g., "latin1.enc" */
char *toenc;                           /* in, e.g., "bics.enc" */
ax_encoding_map **emap;                /* out: caller must free */
{
    char *tEnc, **charnames;
    int fromCacheIndex, toCacheIndex, itemsize;
    int maxcode, mincode, thiscode, ix, nchars;
    int *codep;
    cItem *ip;
    cashList *list;
    ax_encoding_map *tmap;

    /* make sure the fontcache contains the named to and from encodings.
     */
    if (!getItem(FIND, ENCODING, fromenc, (char **) &tEnc,
                 &itemsize, (char *) NULL)) {
        
        *emap = (ax_encoding_map *) NULL;
        return;
    }
    fromCacheIndex = getEncodingType(tEnc);
    if (!getItem(FIND, ENCODING, toenc, (char **) &tEnc,
                 &itemsize, (char *) NULL)) {
        
        *emap = (ax_encoding_map *) NULL;
        return;
    }
    toCacheIndex = getEncodingType(tEnc);
    
    /* the map array size is determined by the range of codepoints
     * in the 'from' encoding.  scan the from-encoding to get min/max codes.
     */
    maxcode = -1;
    mincode = INT_MAX;
    list = &AxFontCache.lists[fromCacheIndex];
    for (ix = 0; ix < list->tableWidth; ix++) {
        if (list->table[ix]) {
            for (ip = list->table[ix]; ip; ip = ip->next) {
                if (ip->value) {
                    thiscode = *((int *) ip->value);
                    if (thiscode > maxcode) {
                        maxcode = thiscode;
                    }
                    if (thiscode < mincode) {
                        mincode = thiscode;
                    }
                }
            }
        }
    }
    if ((maxcode == -1) || (mincode == INT_MAX)) {
        *emap = (ax_encoding_map *) NULL;
        return;
    }
    
    /* alloc the return object
     */
    tmap = (ax_encoding_map *) malloc(sizeof(ax_encoding_map));
    nchars = (maxcode - mincode + 1);
    tmap->codes = (int *) malloc(nchars * sizeof(int));
    memset((void *) tmap->codes, -1, nchars * sizeof(int));
    tmap->mincode = mincode;
    tmap->maxcode = maxcode;
    
    /* allocate an intermediate array of character name pointers
     */
    charnames = (char **) malloc(nchars * sizeof(char *));
    memset((void *) charnames, 0, nchars * sizeof(char *));
    
    /* rescan the from-encoding, this time recording character name refs
     * onto charnames, positioned on that array in terms of from-codepoint.
     */
    list = &AxFontCache.lists[fromCacheIndex];
    for (ix = 0; ix < list->tableWidth; ix++) {
        if (list->table[ix]) {
            for (ip = list->table[ix]; ip; ip = ip->next) {
                if (ip->value) {
                    thiscode = *((int *) ip->value);
                    charnames[thiscode - mincode] = ip->name;
                }
            }
        }
    }

    /* finally, init tmap->codes by looking up each from-charname
     * in the to-encoding.
     */
    for (ix = 0; ix < nchars; ix++) {
        if (charnames[ix]) {
            if (getItem(FIND, toCacheIndex, charnames[ix], 
                        (char **) &codep, &itemsize, (char *) NULL)) {
                tmap->codes[ix] = *codep;
            }
        }
    }
    
    free(charnames);
    *emap = tmap;
    return;
}



#if AXMS    /*  {    Windows/NT */
/* AXMS-specific funcs */

#include <winspool.h>

HDC InitScreenHDC();


typedef struct EnumData {
     HDC hdc;
     fontTabEnt *default_rec;
     fontTabEntUse *default_which;
     } EnumData;
 

int CALLBACK EnumTrueTypes(ENUMLOGFONT*, NEWTEXTMETRIC*, int, LPARAM);
int CALLBACK EnumPrinterFonts(ENUMLOGFONT*, TEXTMETRIC*, int, LPARAM);
int CALLBACK EnumFamiliesProc(LOGFONT*, TEXTMETRIC*, int, LPARAM);


int
EnumerateWinFonts( screenRes )
int *screenRes;
{
    HDC hdc;
    EnumData enum_data;
    int ret;


    hdc = InitScreenHDC();
    if ( hdc == (HDC)NULL )
        return( FALSE );
        
    /* use hardcoded 75 dpi for now. GetDeviceCaps will return 96 */
    *screenRes = 75;  //GetDeviceCaps( hdc, LOGPIXELSX );

    enum_data.hdc = hdc;
    ret = MS_EnumFontFamilies(hdc, (LPCTSTR)NULL, EnumFamiliesProc,
                              (LPARAM)(&enum_data) );
    return( ret );
}


void
EnumeratePrinterFonts(char *printer_name, int *targetRes)
{
    HDC printer_hdc = NULL;
    EnumData enum_data;
    int ret, delete_dc = FALSE;

    ret = 0;
    *targetRes = 0;
#if !FOR_FILTER
#if 0
    if ( getenv( "ENUM_PRINTER_FONTS" ) == (char *)NULL )
       /* disable by default */
       return;
#endif

    printer_hdc = AxGetPrinterHDC(printer_name, &delete_dc);

    if ( printer_hdc )
        *targetRes = MS_GetDeviceCaps(printer_hdc, LOGPIXELSX);
    else
        /* could not get to the printer, use a postscript default */
        *targetRes = 300;

    if ( printer_hdc )
        {
        enum_data.hdc = printer_hdc;
        ret = MS_EnumFontFamilies(printer_hdc, (LPCTSTR)NULL, EnumFamiliesProc,
                                                        (LPARAM)(&enum_data));
        /* cleanup */
        if ( delete_dc )
            MS_DeleteDC(printer_hdc);
        }
#endif
    return;
}

int CALLBACK EnumFamiliesProc(LOGFONT *lpelf, TEXTMETRIC *lpntm,
                              int FontType, LPARAM lParam)
{
    EnumData *enum_data;
    int ret;


    enum_data = (EnumData *) lParam;
    if ( FontType & TRUETYPE_FONTTYPE )
        {
        ret = MS_EnumFontFamilies(enum_data->hdc, lpelf->lfFaceName,
                                              EnumTrueTypes, lParam);
        }
    else if ( (FontType & DEVICE_FONTTYPE) && !(FontType & RASTER_FONTTYPE) &&
											!(FontType & TRUETYPE_FONTTYPE) )
        {                           /* don't enum truetype or raster fonts */
        /* the following call will enum point sizes for us. */
        ret = MS_EnumFontFamilies(enum_data->hdc, lpelf->lfFaceName,
                                          EnumPrinterFonts, lParam);
        }
    else
        ret = 1;

    return ret;
}


int CALLBACK
EnumTrueTypes(ENUMLOGFONT *lpelf, NEWTEXTMETRIC *lpntm, int FontType, LPARAM lParam)
{
    static nCount;
    fontTabEnt currRec;
    int len;
    char *name_list[2];

    if ( !(FontType & TRUETYPE_FONTTYPE) )
        return TRUE;

    memset( &currRec, 0, sizeof(currRec) );
    currRec.isPrinterFont = FALSE;
    currRec.isWindowsFont = TRUE;
    currRec.use.isWindowsFont = TRUE;

    currRec.scalable = TRUE;
    currRec.use.scalable = TRUE;

    currRec.xNamesKnown = TRUE;        /* even though we don't need xNames */
    currRec.use.xNamesKnown = TRUE;

    /* lsbit of tmPitchAndFamily: 0  means monospace */
    currRec.fixedWidth = !(lpntm->tmPitchAndFamily & 0x1);
    currRec.use.fixedWidth = TRUE;
    
    currRec.globalName = lpelf->elfFullName;  /* e.g. "Arial Bold" */
    currRec.use.globalName = TRUE;

    currRec.familyName = lpelf->elfLogFont.lfFaceName;
    currRec.use.familyName = TRUE;

    /* we need to record the character set. */
    currRec.charSet = lpelf->elfLogFont.lfCharSet;
    currRec.use.charSet = TRUE;
    /* and also the "pitch and family".
     * needed to do printer-->screen font mapping.
     */
    currRec.pitchAndFamily = lpelf->elfLogFont.lfPitchAndFamily;
    currRec.use.pitchAndFamily = TRUE;

    currRec.sizeEM = lpntm->ntmSizeEM;
    currRec.use.sizeEM = TRUE;

    if (lpntm->tmLastChar <= 255)
        {
        currRec.encodingWidth = 8;
        }
    else
        {
        currRec.encodingWidth = 16;
        }
    currRec.use.encodingWidth = TRUE;
    
    /* win32 api doc suggests that normal weight will be 400, bold
     * will be 700; compare to 400 (use inequality) to guess whether bold
     */
    currRec.weight = (lpntm->tmWeight > 400);
    currRec.use.weight = TRUE;
    
    if ( lpntm->tmItalic )
        currRec.slant = 1;
    else
        currRec.slant = 0;
    currRec.use.slant = TRUE;

    /* we make up a pseudo metrics file name to drive the rest of the */
    /*  font code later.   use <globalName>.win                       */
    currRec.numTargetMetricsNames = 1;
    len = strlen(currRec.globalName);
    len += 5;         /* ".win", plus null */
    name_list[0] = (char *) malloc(len);
    strcpy(name_list[0], currRec.globalName);
    strcat(name_list[0], NXLT(".win"));
    currRec.targetMetricsNames = name_list;
    currRec.use.targetMetricsNames = TRUE;
    currRec.use.numTargetMetricsNames = TRUE;

    /* store average width of font, in milliems */
    currRec.avgWidth = (int) (((float) lpntm->ntmAvgWidth * 1000.0) /
                                            (float) lpntm->ntmSizeEM);
    currRec.use.avgWidth = TRUE;

    /* load the font record */
    completeCurrentRecord(&currRec, &currRec.use, (fontTabEnt *)NULL,
                                            (fontTabEntUse *)NULL);
    loadFontRecord( &currRec );
    free(name_list[0]);
    return( TRUE );
}

int CALLBACK
EnumPrinterFonts(ENUMLOGFONT *lpelf, TEXTMETRIC *lptm,
                            int FontType, LPARAM lParam)
{
    static nCount;
    fontTabEnt currRec;
    int len;
    char *name_list[2];
    char global_name[100];

    /* only enum the device vector fonts, don't enum raster fonts. */
	/* for some reason (on Windows 95 anyway) we get here with a font
	 * type of both "device" and "truetype". This is spurious information
     * because we later get the real device font, so make sure we only
	 * record what we want.
	 */
    if ( FontType & TRUETYPE_FONTTYPE )
        return TRUE;
    if ( !(FontType & DEVICE_FONTTYPE) || (FontType & RASTER_FONTTYPE) )
        return TRUE;

    memset( &currRec, 0, sizeof(currRec) );
    currRec.isWindowsFont = FALSE;
    currRec.isPrinterFont = TRUE;
    currRec.use.isPrinterFont = TRUE;

#if 0
    hdc = ((EnumData*)lParam)->hdc;
    /* if we ever do raster fonts, we'll need to record the pointsizes. */
    /* from MS sample code: 
     * Convert the pixels to point size.  Note that because of the
     * definition of the tmHeight field, the tmInternalLeading has
     * to be subtracted from it before converting to get the proper
     * font point size.  This is done automatically by the Windows
     * CreateFont call if you pass in a nHeight parameter that is
     * negative, so be aware of this when doing the reverse calculation
     * to create a font of the proper height!
     */
    height = lptm->tmHeight - lptm->tmInternalLeading;
    dpi = MS_GetDeviceCaps(hdc, LOGPIXELSY);
    pointsize = MulDiv(height, 72, dpi);
    currRec.numPointsizes++;
    currRec.use.numPointsizes = TRUE;
    currRec.pointSizes
#endif

    currRec.scalable = TRUE;
    currRec.use.scalable = TRUE;

    currRec.xNamesKnown = TRUE;        /* even though we don't need xNames */
    currRec.use.xNamesKnown = TRUE;

    /* lsbit of tmPitchAndFamily: 0  means monospace */
    currRec.fixedWidth = !(lptm->tmPitchAndFamily & 0x1);
    currRec.use.fixedWidth = TRUE;

    /* printer drivers do not seem to pass different names for bold/italic */
    /* versions of a font.  To make seperate entries in our font cache, and */
    /* to avoid collisions with similarly named screen fonts, we create a */
    /* unique global name      - jon                                      */
    /* some drivers (e.g. Windows 95) do not always give us a full name.
     * In that case we use the face name.       -donato
     */
    /* there are cases (again with Win95 drivers) where the full name is
     * a non-null, non-empty string that holds garbage (!) So we check
     * to see if the full name contains the face name as a full-name-validity
     * check.       -donato
     */
    if ( lpelf->elfFullName[0] &&
            strstr(lpelf->elfFullName, lpelf->elfLogFont.lfFaceName) )
        strcpy(global_name, lpelf->elfFullName);
    else
        strcpy(global_name, lpelf->elfLogFont.lfFaceName);
    if ( lptm->tmWeight > 400 && !strstr(lpelf->elfFullName, NXLT("Bold")) )
       strcat( global_name, "-Bold" );
    if ( lptm->tmItalic && !strstr(lpelf->elfFullName, NXLT("Italic")) )
       strcat( global_name, "-Italic" );
    currRec.globalName = global_name;  /* e.g. "Arial Bold" */
    currRec.use.globalName = TRUE;

    currRec.familyName = lpelf->elfLogFont.lfFaceName;
    currRec.use.familyName = TRUE;

    /* we need to record the character set. */
    currRec.charSet = lpelf->elfLogFont.lfCharSet;
    currRec.use.charSet = TRUE;
    /* and also the "pitch and family"
     * (useful for keeping track of printer fonts).
     */
    currRec.pitchAndFamily = lpelf->elfLogFont.lfPitchAndFamily;
    currRec.use.pitchAndFamily = TRUE;

    /* we do not have the "sizeEM" info in the case of a device font
     * (only for TrueTypes), so for now we are hard-coding the Windows
     * TrueType value of 2048.
     */
    currRec.sizeEM = 2048;
    currRec.use.sizeEM = TRUE;

    /* store average width of font, in milliems, as a negative value */
    /* this will be "fixed" laterif this font is ever referenced.  I have */
    /* found that the average values passed on font enumeration are bogus  */
    /* the average width always being "1234".  To get the real average     */
    /* width, one must actually create the font, which is slow for a lot   */
    /* of printer fonts one may never use.  See the check in the           */
    /* function axGetWinScreenMetrics() in winfont.c                       */
#if 1
    /* store average width of font, in milliems */
    currRec.avgWidth = (int) (((float)lptm->tmAveCharWidth * 1000.0) /
                                                        (float)2048.0);
#else
    currRec.avgWidth = -1;
#endif
    currRec.use.avgWidth = TRUE;

    if ( lptm->tmLastChar <= 255 )
        {
        currRec.encodingWidth = 8;
        }
    else
        {
        currRec.encodingWidth = 16;
        }
    currRec.use.encodingWidth = TRUE;
    
    /* win32 api doc suggests that normal weight will be 400, bold
     * will be 700; compare to 400 (use inequality) to guess whether bold
     */
    currRec.weight = (lptm->tmWeight > 400);
    currRec.use.weight = TRUE;
    
    if ( lptm->tmItalic )
        currRec.slant = 1;
    else
        currRec.slant = 0;
    currRec.use.slant = TRUE;

    /* we make up a pseudo metrics file name to drive the rest of the */
    /*  font code later.   use <globalName>.win                       */
    currRec.numTargetMetricsNames = 1;
    len = strlen(currRec.globalName);
    len += 5;         /* ".win", plus null */
    name_list[0] = (char *) malloc(len);
    strcpy(name_list[0], currRec.globalName);
    strcat(name_list[0], NXLT(".win"));
    currRec.targetMetricsNames = name_list;
    currRec.use.targetMetricsNames = TRUE;
    currRec.use.numTargetMetricsNames = TRUE;

        /* load the font record */
    completeCurrentRecord(&currRec, &currRec.use, (fontTabEnt *)NULL,
                                            (fontTabEntUse *)NULL);
    loadFontRecord( &currRec );
    free(name_list[0]);
    return( TRUE );
}



/**********************************************************************/
/* Get font metrics from the Windows system. units are in milliems
 */
/**********************************************************************/
int axGetWinTargetMetrics( fontMetrics **outP, /* to be filled out */
                           int *sizep,         /* size of "mp"  returned */
                           fontTabEnt *fent)   /* base font table entry */
{
    fontMetrics *metricsP;
    LOGFONT logfont;
    HFONT win_font;
    int ret;
    XFontStruct *x_info;
    int tried_once = FALSE;

    memset( &logfont, 0, sizeof(logfont) );

    /* allocate the space to hold all the font metrics info */
    metricsP = (fontMetrics *)calloc(1, sizeof(fontMetrics));
    *outP = metricsP;    /* the return value */
    x_info = (XFontStruct *)calloc(1, sizeof(XFontStruct));
    metricsP->xfont = x_info;

    /* Note: a negative value for 'lfHeight' forces "real" size as opposed */
    /*       to a size within a line spacing of the requested size      */
    /* create a logical font, in the size of the em-square.          */
    /*   This will give us the un-hinted sizes                       */
    logfont.lfHeight = -fent->sizeEM;   

    if ( fent->weight )
       logfont.lfWeight = FW_BOLD;   /* bold */
    if ( fent->slant )
       logfont.lfItalic = 1;     /* italic */

    /* use target character set. */
    if ( fent->charSet )
        logfont.lfCharSet = fent->charSet;

    if ( fent->pitchAndFamily )
        logfont.lfPitchAndFamily = fent->pitchAndFamily;

    if ( fent->isPrinterFont && !fent->isWindowsFont )
        logfont.lfOutPrecision = OUT_DEVICE_PRECIS;
    else
        logfont.lfOutPrecision = OUT_TT_ONLY_PRECIS;

    strcpy( logfont.lfFaceName, fent->familyName );

#if 0
    /* printer fnts will have a " (p)" appended to the name */
    p = logfont.lfFaceName + strlen(logfont.lfFaceName) - 4;
    if ( strcmp( p, " (P)") == 0 )
       *p = '\0';     /* take off printer font designation */
#endif

    if ( strcmp( logfont.lfFaceName, NXLT("Times")) == 0 )
       strcpy( logfont.lfFaceName, NXLT("Times New Roman") );
    else if ( strcmp( logfont.lfFaceName, NXLT("Courier")) == 0 )
       strcpy( logfont.lfFaceName, NXLT("Courier New") );

one_try:

    win_font = MS_CreateFontIndirect( &logfont );
    if ( win_font == (HFONT)NULL )
       {
       return( FALSE );
       }

    if ( fent->isPrinterFont && !fent->isWindowsFont )
       ret = WinPrinterToXFontMetrics(win_font, metricsP, TRUE, fent->sizeEM);
    else
       ret = WinTrueTypeToXFontMetrics( win_font, metricsP, TRUE );

    if ( !ret && !tried_once )
        {
        /* failure, perhaps it was not a truetype name */
        tried_once = TRUE;
        strcpy( logfont.lfFaceName, NXLT("Times New Roman") );
        MS_DeleteObject(win_font);
        goto one_try;
        }       

    MS_DeleteObject(win_font);    /* needed only for reading here */
    
    return( ret );
}


/* strange function taken from MS documentation: see the GetGlyphOutline
 * sample and accompanying docs. Used for setting up the matrix needed for
 * the glyph outline call.         -donato
 * Note:  the "FIXED" type is actually a strcture which looks like:   
       typedef struct _FIXED {
           WORD    fract;
           short   value;
       } FIXED;
   Which Microsoft bozo do you thik invented this, as opposed to passing doubles?
                                                                              - jon
 */
static FIXED
FIXEDFromDouble(double d)
{
    long l;
    l = (long) (d * 65536L);
    return *(FIXED *)&l;
}


void MakeIdentityMatrix( MAT2 *mat )
{

    mat->eM11 = FIXEDFromDouble(1.0);
    mat->eM12 = FIXEDFromDouble(0.0);
    mat->eM21 = FIXEDFromDouble(0.0);
    mat->eM22 = FIXEDFromDouble(1.0);

    return;
}

void MakeCtmMatrix( MAT2 *mat, axctm *ctm )
{

    mat->eM11 = FIXEDFromDouble(ctm->ca);
    mat->eM12 = FIXEDFromDouble(ctm->cb);
    mat->eM21 = FIXEDFromDouble(ctm->cc);
    mat->eM22 = FIXEDFromDouble(ctm->cd);

    return;
}

#define NORMALIZE(num) (scalable ? (qRound((float)(num) * scale_factor)) : num)
#define MS_GetGlyphOutline GetGlyphOutline  /* move to winmap.h! */

/* Measure a trutype font, and fill in the passed 'fontMetrics' structure */
/* The passed scale factor is used so that we can scale the values when  */
/*   retrieving "em" values for the font, since Aster*x wants to run     */
/*   with mill-em units (1/1000 of an 'em')                              */
int                       /* return TRUE if ok; FALSE if failure */
WinTrueTypeToXFontMetrics(win_font, metricsP, scalable)
HFONT win_font;           /* in: font to measure */
fontMetrics *metricsP;    /* out: pointer to caller's memory to init */
int scalable;             /* in: bool; whether to report milliem units */
{
    int retval;
    int ix, ret, data_size, num_chars;
    int minLbearing, minRbearing, minWidth, minAscent, minDescent;
    int maxLbearing, maxRbearing, maxWidth, maxAscent, maxDescent;
    float scale_factor;
    XFontStruct *x_info;
    XCharStruct *charP;
    HDC hdc;
    TEXTMETRIC *tm;
    LPOUTLINETEXTMETRIC lpOTM = NULL;
    char face_name[50];
    HFONT old_font;
    UINT curr_char;
    MAT2 mat;
    GLYPHMETRICS gm;

    retval = TRUE;
    hdc = MS_GetDC(NULL);
    x_info = metricsP->xfont;

    /* now select the font into the hDC so that we can get information */
    /*   about it, and can measure the characters */
    old_font = MS_SelectObject( hdc, win_font );

    /** for debug **/
    GetTextFace( hdc, sizeof(face_name), face_name );

    /* get the basic metric information; pass a null LPOUTLINETEXTMETRIC
     * value to get the api to measure its return for us
     */
    data_size = MS_GetOutlineTextMetrics
        ( hdc, sizeof(OUTLINETEXTMETRIC), NULL );
    if ( !data_size )
        {
        retval = MS_GetLastError();
        retval = FALSE;
        goto cleanup;
        }
    lpOTM = (LPOUTLINETEXTMETRIC) malloc(data_size);
    ret = MS_GetOutlineTextMetrics( hdc, data_size, lpOTM );
    if ( !ret )
        {
        retval = FALSE;
        goto cleanup;
        }
    tm = &lpOTM->otmTextMetrics;

    /* we want readout in thousandths of an em  */
    scale_factor = 1000.0 / ((float) lpOTM->otmEMSquare);

    /* allocate the per_char array of the XFontStruct instance
     */
    num_chars = tm->tmLastChar - tm->tmFirstChar + 1;
    x_info->per_char = (XCharStruct *) calloc (num_chars, sizeof(XCharStruct));

    minLbearing = minRbearing = minWidth = minAscent = minDescent = INT_MAX;
    maxLbearing = maxRbearing = maxWidth = maxAscent = maxDescent =
                                                            -(INT_MAX - 1);

    x_info->ascent = NORMALIZE( tm->tmAscent );
    x_info->descent = NORMALIZE( tm->tmDescent );

    /* set up the identity matrix for the GlyphOutline call */
    MakeIdentityMatrix( &mat );

    curr_char = tm->tmFirstChar;
    for ( ix = 0; ix < num_chars; ix++ )
        {
        charP = &(x_info->per_char[ix]);

        /* Get the per char outline metrics. */
        ret = MS_GetGlyphOutline(hdc, curr_char, GGO_METRICS, &gm, 0,
                                            (VOID*)NULL, &mat);
        charP->lbearing = (short)NORMALIZE(gm.gmptGlyphOrigin.x);
        charP->rbearing = NORMALIZE(gm.gmptGlyphOrigin.x + gm.gmBlackBoxX);
        charP->width   = NORMALIZE(gm.gmCellIncX);
        charP->ascent  = (short)NORMALIZE(gm.gmptGlyphOrigin.y);
        if ( gm.gmBlackBoxY > gm.gmptGlyphOrigin.y )
            {
            /* there is some sort of descent */
            charP->descent = NORMALIZE(gm.gmBlackBoxY - gm.gmptGlyphOrigin.y);
            }
        else
            charP->descent = 0;

        if ( (curr_char == 32) || (curr_char == 160) )
            {
            /* a rediculous value.  Have see a blank come through */
            /* with a gmBlackBoxY == 16, and gm.gmptGlyphOrigin.y == 0 */
            /* which computes to a dexcent of -16.  These bogus values */
            /* also seem to happen for the blank in the upper half of the */
            /* font, so just skip the the descent for these entries       */
            charP->descent = 0;
            }
        curr_char++;


        /* remember mins and maxes
         */
        if(charP->lbearing > maxLbearing)
            maxLbearing = charP->lbearing;
        if(charP->rbearing > maxRbearing)
            maxRbearing = charP->rbearing;
        if(charP->width > maxWidth)
            maxWidth = charP->width;
        if(charP->ascent > maxAscent)
            maxAscent = charP->ascent;
        if(charP->descent > maxDescent)
            maxDescent = charP->descent;
        if(charP->lbearing < minLbearing)
            minLbearing = charP->lbearing;
        if(charP->rbearing < minRbearing)
            minRbearing = charP->rbearing;
        if(charP->width < minWidth)
            minWidth = charP->width;
        if(charP->ascent < minAscent)
            minAscent = charP->ascent;
        if(charP->descent < minDescent)
            minDescent = charP->descent;
        }
    
    /* complete the metrics structure
     */
    if (!scalable)
        {
        /* !scalable implies that this font may be used
         * for display work
         */
        x_info->fid = win_font;
        }
    x_info->min_char_or_byte2 = (unsigned) (tm->tmFirstChar & 0xff);
    x_info->max_char_or_byte2 = (unsigned) (tm->tmLastChar & 0xff);
    x_info->min_byte1 = (unsigned) ((tm->tmFirstChar & 0xff00) >> 8);
    x_info->max_byte1 = (unsigned) ((tm->tmLastChar & 0xff00) >> 8);
    x_info->all_chars_exist = TRUE;
    x_info->default_char = (unsigned) ' ';
    
    x_info->min_bounds.lbearing = minLbearing;
    x_info->min_bounds.rbearing = minRbearing;
    x_info->min_bounds.width = minWidth;
    x_info->min_bounds.ascent = minAscent;
    x_info->min_bounds.descent = minDescent;
    
    x_info->max_bounds.lbearing = maxLbearing;
    x_info->max_bounds.rbearing = maxRbearing;
    x_info->max_bounds.width = maxWidth;
    x_info->max_bounds.ascent = maxAscent;
    x_info->max_bounds.descent = maxDescent;
    
#if 1
    /* strike-through text seems to work better when we don't
     * "normalize" the x height.        -donato
     */
    metricsP->xHeight = lpOTM->otmsXHeight;
#else
    metricsP->xHeight = NORMALIZE( lpOTM->otmsXHeight );
#endif
    metricsP->underlineThickness = NORMALIZE( lpOTM->otmsUnderscoreSize );
    metricsP->underlinePosition = NORMALIZE( lpOTM->otmsUnderscorePosition );

cleanup:
    if ( lpOTM )
        free(lpOTM);
    MS_SelectObject(hdc, old_font);
    MS_ReleaseDC(NULL, hdc);    

    return retval;
}



/* Measure a printer font, and fill in the passed 'fontMetrics' structure */
/* The passed scale factor is used so that we can scale the values when  */
/*   retrieving "em" values for the font, since Aster*x wants to run     */
/*   with mill-em units (1/1000 of an 'em')                              */

int                       /* return TRUE if ok; FALSE if failure */
WinPrinterToXFontMetrics(win_font, metricsP, scalable, font_em)
HFONT win_font;           /* in: font to measure */
fontMetrics *metricsP;    /* out: pointer to caller's memory to init */
int scalable;             /* in: bool; whether to report milliem units */
int font_em;              /* em size font was created with, if scalable */
{
    int ix, num_chars;
    int minLbearing, minRbearing, minWidth, minAscent, minDescent;
    int maxLbearing, maxRbearing, maxWidth, maxAscent, maxDescent;
    XFontStruct *x_info;
    XCharStruct *charP;
    HDC printer_hdc;
    TEXTMETRIC tm;
    int delete_dc;
    int t_char;
    char str[2];
    SIZE size;
    char face_name[50];
    float scale_factor;
#if FOR_FILTER
    return FALSE;

#else
    printer_hdc = AxGetPrinterHDC(NULL, &delete_dc);
    x_info = metricsP->xfont;

    /* now select the font into the hDC so that we can get information */
    /*   about it, and can measure the characters */
    MS_SelectObject( printer_hdc, win_font );

    /** for debug **/
    GetTextFace( printer_hdc, sizeof(face_name), face_name );

    /* get the basic metric information */
    memset( &tm, 0, sizeof(tm) );
    MS_GetTextMetrics( printer_hdc, &tm );

    /* we want readout in thousandths of an em  */
    scale_factor = 1000.0 / ((float) font_em);

    /* allocate the per_char array of the XFontStruct instance */
    num_chars = tm.tmLastChar - tm.tmFirstChar + 1;
    x_info->per_char = (XCharStruct *) calloc (num_chars, sizeof(XCharStruct));
    
    /* now measure the characters to get the per-char dimensions */
    minLbearing = minRbearing = minWidth = minAscent = minDescent = INT_MAX;
    maxLbearing = maxRbearing = maxWidth = maxAscent = maxDescent =
        -(INT_MAX - 1);

    x_info->ascent = NORMALIZE( tm.tmAscent );
    x_info->descent = NORMALIZE( tm.tmDescent );

    t_char = tm.tmFirstChar;
    str[1] = 0;
    for (ix = 0; ix < num_chars; ix++)
        {
        str[0] = t_char;
        t_char++;

        MS_GetTextExtentPoint32( printer_hdc, str, 1, &size );

        charP = &(x_info->per_char[ix]);
        charP->lbearing = (short)0;
        charP->rbearing = charP->width = (short)NORMALIZE(size.cx);
        
        /* this assignment of per-char ascent and descent is a hack..
         * should use GetGlyphOutline rather than GetCharABCWidths, but
         * no luck with that call so far.  This hack requires corresponding
         * height-hacking found in getTargetMetrics..
         */
        charP->ascent = x_info->ascent;
        charP->descent = x_info->descent;
        
        /* remember mins and maxes
         */
        if(charP->lbearing > maxLbearing)
            maxLbearing = charP->lbearing;
        if(charP->rbearing > maxRbearing)
            maxRbearing = charP->rbearing;
        if(charP->width > maxWidth)
            maxWidth = charP->width;
        if(charP->ascent > maxAscent)
            maxAscent = charP->ascent;
        if(charP->descent > maxDescent)
            maxDescent = charP->descent;
        if(charP->lbearing < minLbearing)
            minLbearing = charP->lbearing;
        if(charP->rbearing < minRbearing)
            minRbearing = charP->rbearing;
        if(charP->width < minWidth)
            minWidth = charP->width;
        if(charP->ascent < minAscent)
            minAscent = charP->ascent;
        if(charP->descent < minDescent)
            minDescent = charP->descent;
        }
    
    /* complete the metrics structure
     */
    if (!scalable)
        {
        /* !scalable implies that this font may be used
         * for display work
         */
        x_info->fid = win_font;
        }
    x_info->min_char_or_byte2 = (unsigned) (tm.tmFirstChar & 0xff);
    x_info->max_char_or_byte2 = (unsigned) (tm.tmLastChar & 0xff);
    x_info->min_byte1 = (unsigned) ((tm.tmFirstChar & 0xff00) >> 8);
    x_info->max_byte1 = (unsigned) ((tm.tmLastChar & 0xff00) >> 8);
    x_info->all_chars_exist = TRUE;
    x_info->default_char = (unsigned) ' ';
    
    x_info->min_bounds.lbearing = minLbearing;
    x_info->min_bounds.rbearing = minRbearing;
    x_info->min_bounds.width = minWidth;
    x_info->min_bounds.ascent = minAscent;
    x_info->min_bounds.descent = minDescent;
    
    x_info->max_bounds.lbearing = maxLbearing;
    x_info->max_bounds.rbearing = maxRbearing;
    x_info->max_bounds.width = maxWidth;
    x_info->max_bounds.ascent = maxAscent;
    x_info->max_bounds.descent = maxDescent;
    
#if 1
    /* we need some hardcoded default values for the printer fonts. */
    metricsP->xHeight = 450;
    metricsP->underlineThickness = 50;
    metricsP->underlinePosition  = -150;
#else
    metricsP->underlineThickness = NORMALIZE( lpOTM->otmsUnderscoreSize );
    metricsP->underlinePosition = NORMALIZE( lpOTM->otmsUnderscorePosition );
    metricsP->xHeight = NORMALIZE( lpOTM->otmsXHeight );

    free(lpOTM);
#endif
    
    if ( delete_dc )
       MS_DeleteDC(printer_hdc);
    
    return( TRUE );
#endif
}

/*** WRAPPER for getItem. called from winfont.c ...  for now?  ***/
int /* bool: TRUE if ok */
ntLookupFont(op, type, name, item, itemsize, extra)
int op; /* FIND or LOAD */
int type; /* in */
char *name; /* in */
char **item; /* in for LOAD, out for FIND */
int *itemsize; /* in for LOAD, out for FIND */
char *extra; /* extra info particular to the item type */
{
    int ret;
    
    ret = getItem(op, type, name, (char**) &item, &itemsize, (char*) &extra);
    return(ret);
}      

#endif     /*  }  AXMS  Windows/NT */



#if BUILD_ORIENT   /*  {  */
/*** Functions added by Ashisuto  **/


/* Return: pointer to cache item, need not pre-allocated.
 * returns NULL if failed. else return screen font name. (Can be used by "xfd")
 */
char *
getXNameFromFontStruct(fs)
XFontStruct *fs;    /* in */
{
    fontCash *cache = &AxFontCache;
    cashList *list;
    int       index;
    cItem    *ip;
    fontMetrics *fm;

    if (!fs || !fs->fid)
        return(FALSE);

    /* Find the xldf name of the font structure in SCREEN_METRICS cache */
    list = &cache->lists[SCREEN_METRICS];
    for (index = 0; index < list->tableWidth; index++) {
        ip = list->table[index];
        while(ip) {
            if (ip->value && ip->name) {
                fm = (fontMetrics *)ip->value;
                if (fm->xfont->fid == fs->fid) {
                    incStamp(ip, list);
                    return(ip->name);
                }
            }
            ip = ip->next;
        }
    }

    return(NULL);   /* not found */
}

/* Return: pointer to cache item, need not pre-allocated.
 * TURE on OK, FALSE on failure.
 */
getFontRecordFromXName(xName, fontRecRet)
char    *xName;
fontTabEnt  **fontRecRet;
{
    fontCash *cache = &AxFontCache;
    cashList *list;
    int       index, ix;
    cItem    *ip;
    fontTabEnt  *ftab;
    char    xlfd[MAXLFD];
    int     pointsize;

    if (!xName || !xName[0])
        return(FALSE);

    pointsize = axtDecipointSize(xName) / 10;

    /* Find font record from FONTRECORD */
    list = &cache->lists[FONTRECORD];
    for (index = 0; index < list->tableWidth; index++) {
        ip = list->table[index];
        while (ip) {
            if (ip->value && ip->name) {
                ftab = (fontTabEnt *)ip->value;
                if (ftab->scalable) {
                    axtFormScalableName(ftab->scalableName, pointsize, 
                                   ScreenRes, (axctm *) 0, xlfd);
                    if (!strcmp(xName, xlfd)) {
                        *fontRecRet = ftab;
                        incStamp(ip, list);
                        return(TRUE);
                    }
                } else {
                    for (ix = 0; ix < ftab->xNameCount; ix++) {
                        if (!strcmp(xName, ftab->xNames[ix])) {
                            *fontRecRet = ftab;
                            incStamp(ip, list);
                            return(TRUE);
                        }
                    }
                }
            }
            ip = ip->next;
        }
    }

    return(FALSE);
}

/* Return: TRUE on OK, FALSE on failure. */
getXFontAttr(fs, family, point, weight, slant, sans)
XFontStruct *fs;    /* in */
char **family;      /* out, pointer to cache item, need not pre-allocated. */
int *point, *weight, *slant, *sans; /* out */
{
    char    *xName = NULL;
    fontTabEnt  *ftab;

    if (point)
        *point = 0;

    if ((xName = getXNameFromFontStruct(fs)) == NULL)
        return(FALSE);

    if (point)
        *point = axtDecipointSize(xName) / 10;

    if (getFontRecordFromXName(xName, &ftab)) {
        if (family)
            {
            if (ftab->aliasFor)
                *family = ftab->aliasFor;
            else
                *family = ftab->familyName;
            }
        if (weight)
            *weight = ftab->weight;
        if (slant)
            *slant = ftab->slant;
        if (sans)
            *sans = ftab->sans;
        return(TRUE);
    }

    /* Try for some frequently used hard wide/narrow font. */
    if (!strcmp(xName, NXLT("k14"))) {
        if (family)
            *family = NXLT("Minchou");
        if (weight)
            *weight = FALSE;
        if (slant)
            *slant = FALSE;
        if (sans)
            *sans = FALSE;
        return(TRUE);
    }

    return(FALSE);
}

char *
getXFontFace(fs)
XFontStruct *fs;
{
    char    *face;

    if (fs && getXFontAttr(fs, &face, NULL, NULL, NULL, NULL))
        return(face);
    else
        return(NULL);
}

IsSansXFontName(xName)
char *xName;
{
    fontTabEnt  *ftab;

    if (getFontRecordFromXName(xName, &ftab))
        return(ftab->sans);

    /* Try some fontname not in fontmap.dir */
    if (!strcmp(xName, "-applix-axsab-bold-r-normal--16-160-75-75-p-65-iso8859-1"))
        return(TRUE);
    if (!strcmp(xName, "k14"))
        return(FALSE);

    return(FALSE);
}

IsSansFontFace(name)
char *name;
{
    char *errString;
    fontTabEnt *screenRec, *targetRec;

    if (errString = axGetFontRecordForScreen(name, 0, 0, 14, 
                                                  &targetRec, &screenRec)) {
        freeErrString(errString);
        return FALSE;
    }

    return(screenRec->sans);
}




/* TRUE on OK, FALSE on failure. */
getTargetFontFace(fm, face)
targetFontMetrics   *fm;
char    *face;
{
    if (fm && getTargetFontAttr(fm, face, NULL, NULL, NULL))
        return(TRUE);
    else
        return(FALSE);
}



 



/* Return a char point from font cache or NULL. */
/* The reverse of getItem(FIND, TARGETFONT_METRICS, name, fm, ...) */
char *
getTargetNameFromFontMetrics(fm)
targetFontMetrics   *fm;    /* in */
{
    fontCash *cache = &AxFontCache;
    cashList *list;
    int       index;
    cItem    *ip;

    if (!fm)
        return(FALSE);

    /* Find the xldf name of the font structure in SCREEN_METRICS cache */
    list = &cache->lists[TARGETFONT_METRICS];
    for (index = 0; index < list->tableWidth; index++) {
        ip = list->table[index];
        while(ip) {
            if (ip->value && ip->name) {
                if (fm == (targetFontMetrics *)ip->value) {
                    incStamp(ip, list);
                    return(ip->name);
                }
            }
            ip = ip->next;
        }
    }

    return(NULL);   /* not found */
}

/* Return: TRUE on OK, FALSE on failure. */
/* The reverse of axGetTargetFontMetrics(). */
getTargetFontAttr(fm, family, point, weight, slant)
targetFontMetrics   *fm;    /* in */
char *family;       /* output buffer, need pre-allocated, or NULL(no output) */
int *point, *weight, *slant;    /* out */
{
    char    *targetName = NULL;
    char    name[256];
    int     size, bold, italic, dpi;
    int     ix;

    if ((targetName = getTargetNameFromFontMetrics(fm)) == NULL)
        return(FALSE);

    for (ix = 0; targetName[ix]; ix++)
        if (targetName[ix] == ' ' && isdigit(targetName[ix+1]))
            break;
    strncpy(name, targetName, ix);
    name[ix] = '\0';
    sscanf(targetName+ix+1, "%d %d %d %d", &size, &bold, &italic, &dpi);
    if (family)
        strcpy(family, name);
    if (point)
        *point = size / 10000;
    if (weight)
        *weight = bold;
    if (slant)
        *slant = italic;

    return(TRUE);
}


#endif    /*  } BUILD_ORIENT  */



/* ----------------- */


