/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: fontmap.h
   Applix ASC version: 12
   Date: Mon Nov 16 13:53:43 1998
*/
#define FFontRecord           "FontRecord"
#define FFamily               "Family"
#define FScreenName           "ScreenName"
#define FRasterTolerance      "RasterTolerance"
#define FEncodingFile         "EncodingFile"
#define FMetricsFile          "MetricsFile"
#define FPostScriptPrintName  "PostScriptPrintName"
#define FPCLAlternate         "PCLAlternate"
#define FPostScriptAlternate  "PostScriptAlternate"
#define FEncodingName         "EncodingName"
#define FWeight               "Weight"
#define FSlant                "Slant"
#define FWindowsAlternate     "WindowsAlternate"
#define FXAlternate           "XAlternate"
#define FToleranceLowCutoff   "ToleranceLowCutoff"
#define FToleranceHighCutoff  "ToleranceHighCutoff"
#define FPCLPrintName         "PCLPrintName"
#define FFixedWidth           "FixedWidth"
#define FInternalEncoding     "InternalEncoding"
#define FLargeXAlternate      "LargeXAlternate"

#if BUILD_KANJI
#define FLIPSPrintName       "LIPSPrintName"
#define FSans                "Sans"
#endif

#define FType1FontFileName	 "Type1FontFileName"
#define FAliasFor       	 "AliasFor"

/*
 * Some overall fontcache attributes
 */
#define FLetterformCacheSize "LetterformCacheSize"
#define FScreenfontCacheSize "ScreenfontCacheSize"
#define FMetricsCacheSize    "MetricsCacheSize"
#define FPrinterResolution   "PrinterResolution"
#define FScreenResolution    "ScreenResolution"
#define FLetterformPixmaps   "LetterformPixmaps"

/*
 * Misc
 */
#define FEndFontRecord       "EndFontRecord"
#define FNewDefaultRecord    "NewDefaultRecord"

/*
 * These corresponding codes must be one-to-one with above defines
 */
#define ATT_FONT_RECORD            1
#define ATT_FAMILY                 2
#define ATT_SCREENNAME             3
#define ATT_RASTER_TOLERANCE       4
#define ATT_ENCODING_FILE          5
#define ATT_METRICS_FILE           6
#define ATT_POSTSCRIPT_PRINT_NAME  7
#define ATT_PCL_ALTERNATE          8
#define ATT_POSTSCRIPT_ALTERNATE   9
#define ATT_ENCODING_NAME          10
#define ATT_END_FONT_RECORD        11
#define ATT_LETTERFORM_CACHESIZE   12
#define ATT_SCREENFONT_CACHESIZE   13
#define ATT_METRICS_CACHESIZE      14
#define ATT_PRINTER_RESOLUTION     15
#define ATT_SCREEN_RESOLUTION      16
#define ATT_WEIGHT                 17
#define ATT_SLANT                  18
#define ATT_WINDOWS_ALTERNATE      19
#define ATT_X_ALTERNATE            20
#define ATT_TOLERANCE_LOW_CUTOFF   21
#define ATT_TOLERANCE_HIGH_CUTOFF  22
#define ATT_NEW_DEFAULT_RECORD     23
#define ATT_PCL_PRINT_NAME         24
#define ATT_FIXED_WIDTH            25
#define ATT_LETTERFORM_PIXMAPS     26
#define ATT_TYPE1_FONT_FILE_NAME   27
#define ATT_ALIAS_FOR              28

#if BUILD_KANJI
#define ATT_LIPS_PRINT_NAME        29
#define ATT_SANS                   32
#endif

#define ATT_INTERNAL_ENCODING      30
#define ATT_LARGE_X_ALTERNATE      31
                      /* next is 33 */


/*************************************************************/
/* The following are used by the function "MapFontFamily"    */
#define UNIX_TO_WIN 1
#define WIN_TO_UNIX 2

#if AXMS
#define FOREIGN_TO_NATIVE UNIX_TO_WIN
#define NATIVE_TO_FOREIGN WIN_TO_UNIX
#else
#define FOREIGN_TO_NATIVE WIN_TO_UNIX
#define NATIVE_TO_FOREIGN UNIX_TO_WIN
#endif
