/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: in.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:53:34 1998
*/
#define LI_SEL		1			/* selection line input */
#define LI_HOME		2			/* home line input */
#define LI_QA		3			/* QA script facility controls */
#define LI_WINMD	4			/* window mode */
#define LI_ELF		5			/* Elf command mode */
#define LI_CMD		6			/* Command key mode */
#define LI_GOTO		7			/* forward or backward goto key seen */
#if THIMBLE
#define LI_MENUBAR	8			/* in menu bar selection mode */
#endif

#define NULL_LOGKEY	(-1)		/* null logical key code */

#define NO_OLDXS	-32760		/* coordinate that must never occur */

#define MAXPARDATA	16			/* characters to be saved for parsing retry */
/*
 * parser states
 */
/* RESET: nothing under way, nothing recognized: pass character through */
#define PARSING_ACTIVE		1		/* looking for a sequence */
#define FOUND_LOGICAL_KEY	2		/* logical key recognized */
#define PARSE_FAIL			3		/* bad sequence detected */
#define PARSE_OPTIONAL		4		/* optional parse (internal state) */

/*
 * internal logical key (ILK)
 * - allow for 16K internal and 16K external codes in internal 15-bit value
 */

/* masks */

#define ILK_BIT			0x4000			/* flag indicating internal code */
#define ILKM_TYPE		0x3800			/* type of ILK */

/* positions */

#define ILKP_TYPE		11
/*
 * types (in field position)
 * - note array gogr_elk ordering is based on these field values
 */
#define ILKT_GF			0x0000			/* forward goto graphic */
#define ILKT_GB			0x0800			/* backward goto graphic */
#define ILKT_GGF		0x1000			/* double forward goto graphic */
#define ILKT_GGB		0x1800			/* double backward goto graphic */
/*
 * extended character code in goto graphic ILKs
 * - organized into 256-value code pages
 * - code assumes this field is unshifted
 */
#define ILKM_ECHAR		0x07ff

/* positioned attributes -- values and masks in field position */

#define PA_SYMBOL1		((long)TMA_SYMBOL1 << TMFPFONT)
#define PA_SYMBOL2		((long)TMA_SYMBOL2 << TMFPFONT)
#define PA_DFONT		((long)TMA_DEF << TMFPFONT)
#define PA_MFONT		((long)TMFMFONT << TMFPFONT)
