/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: menucom.c
   Applix ASC version: 7
   Date: Mon Nov 16 13:53:46 1998
*/
#include <aos.h>
#include <xmlib.h>
#include <thimble.h>




/*************************************************************************
function: ElfGetMenuStatus - Return menu flagstate by calling elf app
!!0 Need a callByEntryVar!!! This is much too slow!
*/
int ElfGetMenuStatus(w, name)
AXWidget w;
char *name;
{
    data_ptr retData;
    int retCode;
    char *retP;
    int retval;
    char *func;
    int task;
    char *StrFromDataPtr();
    data_ptr nameP;
    menu_opt_status *mop;
     
	if (w->elfObject) {
		for (mop = w->parent->menu_status; mop; mop = mop->next) {
			if ((NULL != mop->name) && streqi(mop->name, name))
				return mop->status;
		}
	}

    task = (w->elfObject) ? (int)w->callbacktag : w->taskOwner;
    AxActiveTask = TaskInfo[task].uid;
    VfyContext(task);
    ElfbSetTaskMaster(AxActiveTask);    /* connect called macro to self */
    nameP = AxTaskCreateElfString(0,name);
    if ( w->elfObject ) {
        retCode = ElfCallByName("MENU_STATE_RQST$", &retData, 2, nameP, w->elfObject);
    }
    else {
        func = StrFromDataPtr(((AXWidget_main) w)->menuCallback);
        retCode = ElfCallByName(func, &retData, 1, nameP);
    }
    if ( retCode != 0 )
        retval = 0;
    else
        retval = AxIntFromDataPtr(retData);
    AxFreeData(retData);
    AxTaskFreeElfData(0,nameP);
    return(retval);
}


/*************************************************************************
function: ElfFetchMenuWord - Return ptr for menu string overide
*/
mbchar *ElfFetchMenuWord(w, func, menuFunc)
AXWidget w;
char *func;
char *menuFunc;
{
    int task;
    data_ptr retData = NULL;
    int retCode;
    mbchar *retP;
    mbchar *p;
    data_ptr tmp;
    menu_opt_status *mop;

	if (w->elfObject) {
		for (mop = w->parent->menu_status; mop; mop = mop->next) {
			if (streqi(mop->name, menuFunc)) {
				if (NULL != mop->item_name) {
					p = mop->item_name;
					goto retter;
				}
				break;
			}
		}
	}

    task = (w->elfObject) ? (int)w->callbacktag : w->taskOwner;
    AxActiveTask = TaskInfo[task].uid;
    VfyContext(task);
    ElfbSetTaskMaster(AxActiveTask);    /* connect called macro to self */
    if ( w->elfObject ) {
        tmp = AxTaskCreateElfString(0,func);
        retCode = ElfCallByName("MENU_NAME_RQST$", &retData, 2, tmp, w->elfObject);
        AxTaskFreeElfData(0,tmp);
    }
    else
        retCode = ElfCallByName(func, &retData, 0);
    if ( retCode != 0 )
        p = (mbchar *)"? ? ?";
    else
        p = AxStrPtrFromDataPtr(retData);
  retter:
    retP = (mbchar*)malloc( MBstrlen(p)+1);
    MBstrcpy(retP,p);
	if (NULL != retData)
		AxFreeData(retData);
    return(retP);
}


/*********************************************************************
function: AccelStr - Alloc & return accelerator string
*/
char *AccelStr(mP)
register menu_item_def *mP;
{
    char buf[100];/* bufsize currently ignored */

    if ( !mP->accel_key )
        return(NULL);
    ElfMakeAccelStr(mP,buf,15);
    return(strcpy((char *)malloc((unsigned int)(strlen(buf)+1)),buf));
}

