/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: paratmgr.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:53:35 1998
*/
#define INCOMPAT_CHANGE		0

/* ATM message types */

/* message types for ATM function requests */

#define QATM_CREATE		1
#define QATM_TERM		2
#define QATM_MODIFY		3
#define QATM_SASIDE		4
#define QATM_DREG		5
#define QATM_MREG		6
#define QATM_RCLOSE		7
#define QATM_ARCLOSE	8
#define QATM_CURWIN		9
#define QATM_INQ		10
#define QATM_DCHAR		11
#define QATM_SCROLL		12
#define QATM_DCURSOR	13
#define QATM_WRITE_TX	14
#define QATM_TEXT_EXT	15
#define QATM_INIT_STR	16
#define QATM_GET_EVENT	17
#define QATM_M_PICK		18
#define QATM_M_STK		19
#define QATM_PMARKER	20
#define QATM_PLINE		21
#define QATM_Arc		22
#define QATM_BBLT		23
#define QATM_SET_WIN	24
#define QATM_SP_WID		25
#define QATM_ALTER_TX	26
#define QATM_RESET		27
#define QATM_STK_ACTION	28
#define QATM_FIELD_WRITE	29
#define QATM_BEEP		30
#define QATM_PUTEVENT	31
#define QATM_HOMELINE	32
#define QATM_GMODE		33
#define QATM_NEXTWIN	34
#define QATM_ST_REGEN	35
#define QATM_QMSELECT	36
#define QATM_QMIDS		37
#define QATM_GWMODE		38
#define QATM_PIMAGE		39
#define QATM_GIMAGE		40
#define QATM_PCMAP		41
#define QATM_GCMAP		42
#define QATM_PMSK		43
#define QATM_GMSK		44
#define QATM_IWIN		45		/* TmInqWin */
#define QATM_RLS		46		/* TmRelease */
#define QATM_RST		47		/* TmRestore */
#define QATM_REC		48		/* TmRecord */
#define QATM_RPL		49		/* TmReplay */

#define QATM_CHAR_REC	50		/* keyboard input */
#define QATM_MOUS_REC	51		/* mouse input */

#define QATM_OPEN		52		/* TmOpATM */
#define QATM_PAGE		53		/* Page category for printing */
#define QATM_AKY		54		/* TmAckKey */

#define QATM_XFER_CONTROL	55	/* for info from mouse xchg peer */
#define QATM_SYNC		56		/* dummy round-trip message */
#define QATM_TABS		57		/* TmSetTabStops */

    /* Status line msg codes - added by Moshe (3/21/87) */
#define QATM_ERRMSG	60
#define QATM_NSTATUS	61
#define QATM_CSTATUS	62
#define QATM_ELF		63		/* Elf message, added by ZANE 5/20 */


#define QATM_MK_CURWIN  64

#define QATM_IMGTXT		65		/* image text mode */

#define QATM_INCLUDE    66      /* eps include */
/* ATM Limits */

/*
 * NOTE: The following two parameters are being phased out.
 * Use TM_RDEF_MAX and TM_RMOD_MAX instead.
 */
#define MAX_R_DEF_NUM	22	/* max # regions in define call */
#define MAX_R_MOD_NUM	22	/* max # regions in modify call */

#if INCOMPAT_CHANGE
#define MAX_HELP_NUM	16	/* max # help IDs in create packet */
#else
#define MAX_HELP_NUM	10	/* max # help IDs in create packet */
#endif

#define MAX_TX_COUNT	512	/* max # chars in TmWriteTx string */

/* buffered IPC message */

#define ATM_MAGIC_NUM	10000
#define TMIPCBUFSIZE	IPC_MAX_LEN

/* message buffer sizes - max message lengths including IPC header */

#define MAXMES			(TMIPCBUFSIZE-4)	/* longest buffered message */
#define MAX_TO_ATM		MAXMES
#define MAX_FM_ATM		MAXMES

/* message buffer sizes for atm runtimes */

#define SEN_BUF_SIZE	(MAX_TO_ATM + 2048)
#define REC_BUF_SIZE	(MAX_FM_ATM + 2048)
/*
 * special flag to implement TmPrompt without changing IPC message formats
 * -- distinct from obsolete option vaules TM_ABSOLUTE, TM_RELATIVE
 */
#define PROMPT_FLAG		2

/* current version number for matching with runtimes in applications */
/* version history:
	4 - increased TMIPCBUFSIZE
*/

#define CURVER		5		/* new field write parameter */

/* device setup numbers */
/* TM_DS_LPR1 (standard 66x80 line printer) is defined as 0 in atm.h */

# define DS_SUN1	1	/* SUN video */
# define DS_DUM1	2	/* 24x80 dumb terminal */
# define DS_IBM1	3	/* IBM PC with Hercules card */
# define DS_HOD1	4	/* Honeywell S11CQ, draft */
# define DS_HOF1	5	/* Honeywell S11CQ, final */
# define DS_IMD1	6	/* Imagen, draft */
# define DS_IMF1	7	/* Imagen, final */
# define DS_SUNH	8	/* SUN with high resolution screen */
# define DS_GT		9	/* CT's GT terminal */
# define DS_HOX		10	/* Honeywell S11CQ, graphics */
# define DS_EPD		11	/* Epson FX80, draft */
# define DS_EPF		12	/* Epson FX80, final */
# define DS_EPG		13	/* Epson FX80, graphic */
# define DS_EPH		14	/* Epson FX80, high res graphic */
# define DS_NSE		15	/* NEC Spinwriter, Emperor thimble */
# define DS_NSP		16	/* NEC Spinwriter, PS and Bold PS thimbles */
# define DS_TKR		17	/* Tektronix Remote Graphics (4107) */
# define DS_TKG		18	/* Tektronix Graphic (BMD) */
# define DS_DVT200	19	/* DEC VT200 series */
# define DS_NS12	20	/* NEC Spinwriter, 12 pitch thimble */
# define DS_NS10	21	/* NEC Spinwriter, 10 pitch thimble */
# define DS_NS15	22	/* NEC Spinwriter, 15 pitch thimble */
# define DS_HPD82906	23	/* HP 82906A printer, draft mode */
# define DS_HPF82906	24	/* HP 82906A printer, final mode */
# define DS_HP2623	25	/* HP 2623 remote graphics terminal */
# define DS_HPNGLJ	26	/* HP LaserJet, no fonts, no graphics */
# define DS_HP300LJ	27	/* HP LaserJet, no fonts, 300 dpi graphics */
# define DS_HP98781	28	/* HP 98781A graphics terminal */
# define DS_HP300L	66	/* HP 98781A graphics terminal */
# define DS_HP75LJ	29	/* HP LaserJet, no fonts, 75 dpi graphics */
# define DS_HP2622	143	/* HP 2622 text terminal */

#define	DS_IBMAT	88	/* IBM PC AT with Hercules/Genius displays */
# define DS_IBMSAS	46	/* IBM Saturn APA-8 (720 x 512) */
# define DS_IBMSES	47	/* IBM Saturn EGA 640 x 350 graphics mode */

#define	DS_MC19M	77	/* Masscomp 19-inch Monochrome terminal */
#define	DS_MC19C	77	/* Masscomp 19-inch Color terminal */
# define DS_HDS200	87	/* HDS 200 series */
#define	DS_CPC		76	/* Counterpoint */

#define DS_X10_HR	105	/* Hi Res fonts for X10 */
#define DS_X11   	106	/* X Window System Version 11 */
#define	DS_VS		142	/* X Window System Version 10 */
#define DS_X11_HR	143	/* Hi Res fonts for X11 */
#define	DS_PCIMAGEN	163	/* NCR PC Imagen Font with Hercules display */
#define	DS_EGAPCIMAGEN	166	/* NCR PC Imagen Font with EGA display */
#define	DS_IBMATEGA	192	/* IBM PC/ATM with EGA display */
