/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: parimage.h
   Applix ASC version: 4
   Date: Sat Jan 23 21:14:20 1999
*/

/* message formats for image and color functions */

struct SEPSimData	/* send to atm for TmInclude */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short window_id;
	struct TmEPSPacket pack;
};

struct SpimData		/* send to atm for TmPutImage */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short window_id;
	struct TmImagePacket pack;
	short imWid;	/* image line width, bytes */
};
/*
 * note: structure must end on 'short' boundary -
 * image follows
 */

struct SgimData		/* send to atm for TmGetImage */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short window_id;
	struct TmImagePacket pack;
	short imWid;	/* image line width, bytes */
};

struct RgimData		/* receive from atm for TmGetImage */
{
	char filler[IPC_HEAD_LEN];
	short status;
	short window_id;
};
/*
 * note: structure must end on 'short' boundary -
 * image follows
 */

struct SpcmData		/* send to atm for TmPutColormap */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short idx;
	short count;
};					/* arrays follow */

struct SgcmData		/* send to atm for TmGetColormap */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short idx;
	short count;
};

struct RgcmData		/* receive from atm for TmGetColormap */
{
	char filler[IPC_HEAD_LEN];
	short status;
};					/* arrays follow */

struct SpmskData	/* send to atm for TmPutMask */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short window_id;
	short bitplane_mask;
};

struct SgmskData	/* send to atm for TmGetMask */
{
	char filler[IPC_HEAD_LEN];
	short event_indicator;
	short window_id;
};

struct RgmskData	/* receive from atm for TmGetMask */
{
	char filler[IPC_HEAD_LEN];
	short status;
	short bitplane_mask;
};
