/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: parwin.h
   Applix ASC version: 4
   Date: Sat Jan 23 21:14:19 1999
*/

/* TmCreate */

	struct SCreateData
    	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		struct TmCrePacket cr_pack;
		short help_num;
		long helpid[MAX_HELP_NUM];
		short title_len;
		short option_len;
	};
	
	struct RCreateData
	{
		char filler1[IPC_HEAD_LEN];

		short status;
		short window_id;
		long widget_id;
		unsigned li_window : 1;	/* line input geometry (menuless mode) */
    };

/* TmTerm */

	struct STermData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		short window_id;
		short pendFlag;		/* true, if application is waiting for response */
	};
	

	struct RTermData
	{
		char filler1[IPC_HEAD_LEN];

		short pack_len;
		short status;
			/* present only if status = TMR_OK: */
		struct TmCrePacket term_pack;
		short help_num;
		long helpid[MAX_HELP_NUM];
		short title_len;
		short option_len;
			/* additional data follows */
	};

/* TmModify */

	struct SModifyData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short window_id;
		struct TmCrePacket modify_pack;
		short help_num;
		long helpid[MAX_HELP_NUM];
		short title_len;
		short option_len;
				/* additional data follows */
	};
		
	struct RModifyData
	{
		char filler1[IPC_HEAD_LEN];

		short status;
		unsigned li_window : 1;	/* line input geometry (menuless mode) */
	};

/* TmSasideAll */

	struct SSasideData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];
	};

	struct RSasideData
	{
		char filler1[IPC_HEAD_LEN];

	        short status;
	};

/* TmCurWin */

	struct SCurWinData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];
	};
	
	struct RCurWinData
	{
		char filler1[IPC_HEAD_LEN];

		short window_id;
		short status;
	};


/* TmMkCurWin */

	struct SMkCurWinData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		short window_id;
		char filler[2];
	};


/* TmNextWin */

	struct SnwData
	{
		char filler[IPC_HEAD_LEN];
		short event_indicator;

		short winID;
	};
	
	struct RnwData
	{
		char filler[IPC_HEAD_LEN];
		short status;

		struct TmWinStat ws;
	};


/* TmWinGMode */

	struct GWModeData
	{
		char filler[IPC_HEAD_LEN];
		short event_indicator;

		short window_id;
		short g_mode;
	};

/* TmInqWin */

	struct SiwinData
	{
		char filler1[IPC_HEAD_LEN];
		short event_indicator;

		short window_id;
	};

	struct RiwinData
	{
		char filler1[IPC_HEAD_LEN];
		short status;

		struct TmCrePacket crePack;
		short selLen;
		short titleLen;
		short helpCount;
	};						/* data follows */
