/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmattr.c
   Applix ASC version: 14
   Date: Mon Nov 16 13:53:35 1998
*/
#include <stdio.h>
#include <aos.h>
#include <paripc.h>
#include <tmi.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parattr.h>
#include <parint.h>
#include <bounds.h>
#include <devsetup.h>

extern short CellWidDC, CellHtDC;
extern short Xmpc, Ympc;
extern short AppPlayback;



		/* TmDcursor function */

void atm_dcursor(){}

		/* TmSetWinAttr function */

void atm_set_win(mes, mesLen, flag)
char *mes;
short mesLen;
short flag;

{
	union 
	{
	    struct SSetWinData set_win_data;
	    char rec_buf[sizeof(struct SSetWinData)];
	} rec_pack;

	short i;
	AxRectangle rr;

	ATMmesMov(mes, rec_pack.rec_buf, mesLen, sizeof(struct SSetWinData), flag);

#if CHECK
	PCkSetWin(rec_pack.rec_buf);	/* check packet */
#endif
	if (AppPlayback) rec_pack.set_win_data.window_id = Wp->window_id;
	wind_pnt = &window[rec_pack.set_win_data.window_id ];
	if (Wp->recording) mesRec(rec_pack.rec_buf, mesLen, flag);

	wind_pnt->lin_des = rec_pack.set_win_data.lin_des;
	wind_pnt->write_tx_des = rec_pack.set_win_data.write_tx_des;
	wind_pnt->read_tx_des = rec_pack.set_win_data.read_tx_des;
	wind_pnt->trans_mode = rec_pack.set_win_data.trans_mode;
	wind_pnt->txAlign = rec_pack.set_win_data.txAlign;

#if COLOR
	wind_pnt->bgcolor = rec_pack.set_win_data.bg_color;
	wind_pnt->fgcolor = rec_pack.set_win_data.fg_color;
#endif

	TLOGGER((ATfp, NXLT("trans_mode=%d write_tx_des=0x%lx\n"),
				wind_pnt->trans_mode, wind_pnt->write_tx_des));

	if (rec_pack.set_win_data.cliprect.x_size >= 0)
	{
		/* application supplied clipping rectangle */

		cTmRect(wind_pnt, &rec_pack.set_win_data.cliprect, &rr);
#ifndef NDEBUG
		if (ATMtrace) ATMshoRect(ATfp, NXLT("  appClip candidate"), &rr);
#endif
		if ( sectRect(&wind_pnt->inner, &rr, &rr) )
		{
			wind_pnt->appClip = rr;
			setclip(wind_pnt->layer, &rr);
			wind_pnt->clipSupplied = TRUE;
		}
	}
}

/*
 *
 */
void atm_imgtxt(mes, mesLen, flag)
char *mes;
short mesLen;
short flag;
{
}

/*
 * TmInqTxExtent function
*/
void atm_text_ext(){abort();}	/* ??c remove refs from sources */

/*
 * TmSetSpWid function
 *
 *		6-12-85 Note: No application is known to be using this function.
 */
atm_sp_wid(mes, mesLen, flag)
char *mes;
short mesLen;
short flag;
{
	union 
	{
	    struct SSetSpWidData set_sp_wid_data;
	    char rec_buf[sizeof(struct SSetSpWidData)];
	} rec_pack;

	short x0; /* discard */

	ATMmesMov(mes, rec_pack.rec_buf, mesLen, sizeof(struct SSetSpWidData),flag);

	wind_pnt = &window[rec_pack.set_sp_wid_data.window_id ];

	wind_pnt->spWid = rec_pack.set_sp_wid_data.spWid;
	if(wind_pnt->spWid != -1)
	{
		/* convert space width in mills to pixel and put it in wind_struct */
		conv_i_p(&rec_pack.set_sp_wid_data.spWid, &x0,
			&wind_pnt->spWid,&x0,MILLS_TO_PIXEL);
	}

/* override alter text extent values */
	wind_pnt->spCnt1 = 0;
	wind_pnt->spCnt2 = 0;
	wind_pnt->spChng1 = 0;
	wind_pnt->spChng2 = 0;
}

void atm_alter_tx(){}
atm_tabs(){}


/*************************************************************************
function: atm_font_size_mapping - Called by TmSetFontSizeMapping
This is called after the "runtime" globals have been set for TmRInqTxExtent()
*/
atm_font_size_mapping (win,shift,smallest,largest)
short win;
short shift;	/* 0 is display fornt shiftup value */
short smallest;	/* smallest char to display (nominally 6) 0 - no limit */
short largest;	/* largest char to display (nominally 36) 0 - no limit */
{
	window[win].smallestFontSize = smallest;
	window[win].largestFontSize = largest;
	window[win].displaySizeShift = shift;
}


