/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmdispat.c
   Applix ASC version: 43
   Date: Fri May 14 21:13:35 1999
*/
#include <stdio.h>
#include <setjmp.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>
#include <paripc.h>
#include <tmi.h>
#include <thimble.h>
#include <getstr5.h>
#include <style.h>
#include <time.h>

#if HP_G
#include <sys/privgrp.h>
#endif

#include <tmassert.h>
#include <atm.h>
#include <atmwin.h>
#include <atmreg.h>
#include <atmattr.h>
#include <atmtxtin.h>
#include <paratmgr.h>
#include <parint.h>
#include <getstr13.h>
#include <getstr5.h>
#include <scac.h>
#include <mincom.h>
#include <paramin.h>
#include <pargmod.h>

extern int TmAmSE;   /* set by pdc when formatting */
int ThimToucherStarted; /* TRUE as soon as working set optimizer started */
extern short ButtonIsUp;	/* Used for pointer/hourglassing */
int AxWindowless;
extern int AxNoMapWindows;		/* -quiet mode */
extern int AxStartedForPrinting;	/* if TRUE, axmain started just for a print job */
extern int AxNoSymbolicFileLinks;	/* for HP-CDROM */
extern int AxElfrtMode;		/* TRUE if running as elfrt rather than axmain */
extern int AxMailrtMode;	/* TRUE if running as elfrt+mail rather than axmain */

/* mouse states */

#define NEUTRAL     0   /* not picking or stroking */
#define IBD     1   /* initial button down */
#define PIP     2   /* pick in progress (button up, waiting for 2nd click) */
#define SIP     3   /* stroke in progress */

/* bit masks for button hardware status */

#define NULLAID     0   /* null application ID */


extern foreignChars UTsymbols;
extern foreignChars UTprofsym;
short ULforColor = 0;	/* underline for color (text on mono device) */
short EightBit = 0;     /* enable 8-bit char code testing for applications */
char DemoPlayback = 0;  /* playback from file */
short GrayBack = 1;     /* gray background switch */
char OldMouse = 0;      /* use old (Millunzi-compatible) mouse scaling */
extern short NoColor;	/* THIMBLE is X11 base let's try color */ 
			/* IF!! we can't allocate Colors set NoColor */
short MevButton;


/* global to this module */
#define MAXEV           66          /* for now */

#if 0
STATIC char *EventTx[MAXEV] = {
/* 1 */
    NXLT("TmCreate"), NXLT("TmTerm"), NXLT("TmModify"), NXLT("TmSasideAll"), NXLT("TmDreg"), NXLT("TmMreg"),
    NXLT("TmRclose"), NXLT("TmARclose"), NXLT("TmCurWin"), NXLT("TmInq"), NXLT("TmDchar"), NXLT("TmScroll"),
    NXLT("TmDcursor"), NXLT("TmWriteTx"), NXLT("TmInqTxExtent"), NXLT("TmFRead"), 0, NXLT("TmInitPick"),
    NXLT("TmIStroke"), 0, NXLT("TmPolyline"), NXLT("TmArc"), NXLT("TmBblt"), NXLT("TmSetWinAttr"),
    NXLT("TmSetSpWid"), 0, NXLT("TmReset"), NXLT("TmStkAction"), NXLT("TmFieldWrite"), NXLT("TmBeep"),
    NXLT("TmPutEvent"), NXLT("TmHomeLine"), NXLT("TmGMode"), NXLT("TmNextWin"), NXLT("TmStRegen"),
    NXLT("TmQmSelect"), NXLT("TmQmIds"), NXLT("TmWinGMode"), NXLT("TmPutImage"), NXLT("TmGetImage"),
    NXLT("TmPutColormap"), NXLT("TmGetColormap"), NXLT("TmPutMask"), NXLT("TmGetMask"), NXLT("TmInqWin"),
    NXLT("TmRelease"), NXLT("TmRestore"), 0, 0,
/* 50 */
    NXLT("keyboard input"), NXLT("mouse input"), NXLT("TmOpATM"), 0, NXLT("TmAckKey"),
	NXLT("TmXfer"), NXLT("TmSync"), NXLT("TmSetTabStops"), 0, 0,
/* 60 */
    NXLT("TmErrmsg"), NXLT("TmCreStatus"), NXLT("TmUpdtStatus"), NXLT("TmElfMsg"),NXLT("TmMkCurWin"),
	NXLT("TmImgTxt"), NXLT("TmInclude")
};
#endif

int TimerExpired = FALSE;

#if NULLPID == 0            /* assume table is initialized by default */
STATIC struct CliEntry {
    short pid;
    short aid;
    short ev_chan;
    short res_chan;
    short rtVersion;
} CliTab[MAX_CHAN];                 /* client table */
#endif
STATIC short NumChans = 0;


#define THIM_ABBREV NXLT("ax")
int THIMredisp;
extern short ElfHasStatusMessageDisplayed;
extern int ThimExposuresMayBeComing;	/* Hint for command startup delaying */
extern int AxViewOnly;	/* TRUE only if axViewOnly set in profile... */

extern int AxOpenLook;		/* TRUE if using OpenLook */
extern int AxMetric;		/* TRUE if running metric mode */
extern int AxShortNames;	/* TRUE if profile imposes short (SYS5) filenames */
extern Display *Dpy;

#if BUILD_ORIENT
extern XIM input_method;
#endif






extern char *AxComlFontPath;	/* NULL or command line fontpath specification */
extern int AxKeepRunning;	/* if TRUE, keey axmain up after last window hoes away */

/* look for the named window size,pos .ax_profile string
 * (e.g., ssWindowPosSize, whose value might be "400,400,8000,9000")
 * format is {xpos,ypos,width,height}, units are in mils.  If xpos
 * and ypos are both zero, then no position is specified, i.e., let
 * the window manager decide */
void
getProfileSizePos(profCode, xpos, ypos, width, height)
int profCode; /* which particular size/pos option */
int *xpos, *ypos, *width, *height; /* fill these out */
{
	extern char *strtok();
	char *sizePosString;

	*xpos = *ypos = *width = *height = 0;
	sizePosString = (char *)GetProfileByCode(profCode);
	if (sizePosString && *sizePosString) {
		int ii, ivalue;
		char *buf, *item;

		ii = 0;
		buf = malloc(strlen(sizePosString)+1);
		strcpy(buf, sizePosString);
		while (	item = strtok(((ii==0) ? buf : NULL), ",")) {
			ii++;
			if (strlen(item) == 0) continue;
			ivalue = atoi(item);
			if (ivalue < 0) ivalue = 0;
			if (ivalue > 32000) ivalue = 32000;
			if (ii == 1) {
				*xpos = ivalue;
			}
			else if (ii == 2) {
				*ypos = ivalue;
			}
			else if (ii == 3) {
				*width = ivalue;
			}
			else if (ii == 4) {
				*height = ivalue;
			}
		}
		free(buf);
	}
}

get_fds(pid,ev_fd,res_fd)
short pid;
short *ev_fd;
short *res_fd;
{
    if ( (pid >= MAX_PIDS) || !TaskInfo[pid].in_use )
        *ev_fd = *res_fd = -1;
    else
        *ev_fd = *res_fd = pid;
}


atm_open(){}
alarmCatch(){}
setAlarm(){}
lockRect(){}
unlkRect(){}
ApolloNeedDisplay(){}
putMous(){}
unlkMous() {}
chMous(){}
