/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmi.h
   Applix ASC version: 5
   Date: Sun Jan 31 21:12:25 1999
*/
#define GMODE       1
#define COLOR	1		/* color support needed in generic modules */



/*****************************************************************************/
/*
 * Mils per celltext character cell: default values
 */

#define Y_MPC			212

#ifndef X_MPC		/* for everybody NOT connected with IBM */
#define X_MPC			100
#endif


/*****************************************************************************/

/* --- compile options */

#define EXTRACHECK	1
#define TRACECOMP	1		/* compile trace output code (obsolete) */
#define DEMO		1		/* compile demo record/playback code (obsolete) */

/* feature marker: must agree with runtime */
#define DIO_CLIENT	1		/* Let client use direct I/O */

/* where optional, make names global to aid debugging */
#define STATIC

/* --- */

/* widely used constants */

#define MAX_WIND_ID	21		/* obsolete--use TM_MAXWIN instead */
#define FNAME_LEN	32		/* max length of simple file name */
#define NULLPID		0
#define NULCHAR		'\0'

/* dumb terminal character attributes (must be bit masks) */

#define TM_HL		1		/* highlighted */
#define TM_UL		2		/* underlined */
#define TM_HLUL		3		/* mask for highlighting and underlining */
#define TM_BORD		4		/* location of regenerative window border */
#define TM_TOUCHED	8		/* flag: character cell touched by output */
#define	TM_SYMF1	16		/* character is from sym font 1 */
#define	TM_SYMF2	32		/* character is from sym font 2 */
#define	TM_LINEDRAW	64		/* special line drawing char */

/* parameters used for terminals with invisible embaded attributes */
#define TM_SO	TM_HL		/* SO seq. */
#define TM_US	TM_UL		/* US seq. */
#define TM_SOUS	TM_HLUL		/* SO and US seq. */
#define TM_SE	4			/* SO or US end */

/* colors */

#define DEFAULT_BG	0
#define DEFAULT_FG	1
#define DESK_COLOR	3
#define BAR_COLOR	15

#ifdef NDEBUG
#define TLOGGER(body)
#define TLOGGER2(body)
#else
#define TLOGGER(body)	if (ATMtrace) { fprintf body; fflush(ATfp); }
#define TLOGGER2(body)	if (ATMtrace >= 2) { fprintf body; fflush(ATfp); }
#endif

/* rasterop type */
#define SOURCELESS(trmode)	((trmode >> 2) == (trmode & 3))
