/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmkeys.h
   Applix ASC version: 3
   Date: Tue Dec 22 21:10:10 1998
*/
#define EURO_SYMBOL_8BIT_VALUE	0x80

#define MAX_MODES	100		/* number of prefix keys */
#define MAX_MODIFIERS 10	/* max sft/ctrl... keys */

#if AXMS
#define KeySym UINT
/* the equivalent of KeySym in MS WINDOWS is passed in the
    uParam message parameter */
#endif  /* DAMNT */

/* Types of key entries in a key_table */

#define KTAB_EMPTY_TYPE		0	/* deleted */
#define KTAB_PREFIX_TYPE	1	/* sub-table */
#define KTAB_ELF_TYPE		2	/* Elf command */

typedef struct {
	KeySym ksym;	/* XK_XX code */
	short type;		/* FKEY, ELF, PREFIX */
	unsigned short modifiers;	/* shft/ctrl state */
	union {
		char *name;	/* for Elf commands */
		int mode;	/* for PREFIX */
	} value;
} key_table_entry;

typedef struct key_table_struct {
	int size;				/* number of entries */
	char *name;				/* logical name */
	struct key_table_struct *parent;	/* parent of this prefix key */
	key_table_entry entries[1];
} key_table_type;



