/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmx.c
   Applix ASC version: 207
   Date: Tue Apr  6 21:50:20 1999
*/
#define APPLIX_WIDGETS 1

#if 0
/*  TEMP  */
/* stubs for now */

DlgCreateBox(){}
DlgDrawWindow(){}
CloseDialogBox(){}
ForceCloseDialogBox(){}
DlgWriteTx(){}
DlgDrawLine(){}
DlgPaintIcon(){}
DlgInvertRect(){}
DlgInnerCorner(){}
DlgFieldRead(){}
DlgReadActive(){return(0);}
PidOfDlgBox(){return(0);}
RegenAllDialogs (){return(0);}
ClearAllDialogs (){}
Popup1Selection(){}
WMinitKB(){}
WMinitMin(){}
WMchMous(){}
dispHG(){}
dispARR(){}
frInputDlg(){}
SelectOptByChar(){}
PopupSelect(){}
PopupSelections(){}
PopupWrapUp(){}
PopupWindowControl(){}
PopupNewMousePoint(){}
DialogPoint(){return(0);}
int DoingSelectionLine; /* TRUE if Popup1Selction was called */
short PopupIgnoreButtonUp;  /* for selection line events */
PopupRootMenu(){}
rqStrk(){}
#endif

#define ABS(x) (((x) > 0) ? (x) : -(x))
#define ATOOLS 1
#define NEED_X_INFO 1
#define X_MILLS_TO_PIXELS(x) (((long)(x) * UWidPels)/UWidMils)
#define Y_MILLS_TO_PIXELS(y) (((long)(y) * UHtPels)/UHtMils)
#define X_PIXELS_TO_MILLS(x) (((long)(x) * UWidMils + UWidPels -1)/UWidPels)
#define Y_PIXELS_TO_MILLS(y) (((long)(y) * UHtMils + UHtPels -1)/UHtPels)
#define AXSelectInput XSelectInput



#include <ax_xm.h>
#include <X11/Shell.h>
#include <X11/keysym.h>
#include <X11/Xproto.h>

#include <string.h>
#include <dwt2xm.h>
#include <aos.h>
#include <xmlib.h>
#include <axtime.h>
#include <setjmp.h>

#include <paripc.h>
#include <scac.h>
#include <tmi.h>
#include <paratm.h>
#include <parint.h>
#include <paratmgr.h>
#include <getstr13.h>
#include <getstr5.h>
#include <paramin.h>
#include <tmkeys.h>
#include <elhelper.h>
#include <aiconids.h>
#if X386_NEW
#define MAXPATHLEN 1024 /* JJM */
#endif
#include <laytext.h>
#include <axtext.h>
#include <afileimg.h>

#if ALPHA
#ifdef ABS /* defined in timers.h */
#undef ABS
#endif
#define ABS(x) (((x) > 0) ? (x) : -(x))
#endif

#if !X386_NEW
#include <thimble.h>
#endif
#include <usrevent.h>
#include <parwin.h>
#include <axproto.h>


#define SOURCELESS(trmode)  ((trmode >> 2) == (trmode & 3))
#define SIG_MM      5       /* significant mouse motion (pixels) */

typedef struct {
    Pixmap map, imap;
    int hyt, wid;
} StippleMap;

extern short LastInputWasMouse;  /* used to override xpos,ypos on window create */
extern unsigned long AxPixels[];
extern int QuietRunning;    /* used to suppress diaply of dialogs */
extern int QuietErrsRunning;    /* used to suppress display of error msgs */
extern short WhiteBack;
extern int AxStartedForPrinting; /*if TRUE, axmain started just for print job */
extern int THIMhelpMode;
extern Pixmap ScratchMap; /* screen size pixmap available as app resource */

AXWidget AxCreateMenuBar();
extern void RWGlyphCallback();
extern Pixmap GetWidgetChildPixmap();
extern Pixmap GetWidgetPixmap();
menu_item_def *ElfFindSlider();
Pixmap AxCreateQueryPixmap ();
AXWidget AXmCreateScrollBar(); 
AXWidget AXmCreateBulletinBoard();
AXWidget AXtAppCreateShell();
AXWidget AXtParent();
AXWidget WidgetOfWindow();
struct wind_struct *SetWp();
struct wind_struct *getActiveWin();
struct wind_struct *make_curwin();
struct wind_struct *SetWpFromX11Window();


/*
In XWINS land, the HostWin is changed with each "locus" change - it is not
a permanent attribute.  A locus change is an appliction call (such as TmWriteTx)
an an event reception in VIDInt().  The HostWin is extracted from the Wp struct.
*/

extern int RealArgc;    /* from main(argc...) */
extern char **RealArgv; /* from main(...argv...) */

#if X11
AxRectangle VisRect = {0, 0, RAST_WID, RAST_HT};    /* visible host window */
AxRectangle DpyRect = {0, 0, RAST_WID, RAST_HT};    /* physical screen rectangle */
#endif

extern Display *Dpy;
extern short ColorDisplay;  /* color available and being used */
extern short NoColor;       /* force monochrome under SunView */
extern int PlaneMask;   /* depth of display */
extern short DpyWid;    /* physical screen size */
extern short DpyHt; /* physical screen size */
extern short DpyDepth;  /* physical screen size */
extern unsigned long AlisPixels[];
extern int ThimBellVolume;
extern Atom AxPROTOCOL_ATOM;
extern Atom AxDELETE_WIN_ATOM;
extern Atom AxWIN_TAKE_FOCUS;
extern Atom AxXA_EDITBOX_PROP;
extern long WindowCreationCounter;    /* incremnting uid for each window */
int DialogBoxActive;        /* TRUE while a DiaogBox is being displayed */
extern unsigned long TimeOfButtonPress; /* event time of button down */
extern unsigned long TimeOfButtonRelease;   /* event time of button up */
static Point Point00;   /* coordinate 0,0 */
extern int ThimExposuresMayBeComing;    /* Hint for command startup delaying */
extern unsigned long TimeOfMessageDismiss;  /* Event time when err msg box dismissed */
extern int AxNoteAllMousePoints;
extern int AxGEToolPalOn, AxGEColorPalOn;
extern int widthInPels, heightInPels;
extern unsigned char *outputBuffer;
extern IFILE *imageFp;

extern AxRectangle savedClip;

short DSnum = DEFDEV;       /* device setup number */
extern short ToggleFG;

extern short TermReleased;      /* ??c unused */

extern short ElfHasStatusMessageDisplayed; /* TRUE if there is a status message */
extern AXWidget InfoBoxWidget;  /* Widget id if ElfHasStatusMessageDisplayed */
extern Window ThimInfoBoxWindow;    /* AxXtWindow() of above */
extern Window ThimInfoDlgWindow; /* win of dlg part of InfoBoxWidget (for events) */
extern int ThimbleSaysToReturnNow; /* hack for breaking out of XtAppNextEvent */
extern AXWidget WidgetOfFocusWindow();
extern struct fieldInfo *FieldInfo; /* for text display */
extern long AxPulldownActive;   /* non-zero while a menubar pulldown is active */
extern int WeThinkItsSunX;  /* wouldn't it be nice if we didn't care? */
extern int AxOpenLook;


extern short MaxwWid;
extern short MaxwHt;
extern short MinWWid, MinWHt;   /* min window width, height, mils */

/* JUST FOR NOW ??x */
#define NEUTRAL     0   /* not picking or stroking */
#define IBD         1   /* initial button down */
#define PIP         2   /* pick in progress (button up) */
#define SIP         3   /* stroke in progress */
extern TmPoint ButDown;
extern int WMstate;     /* mouse state */
extern short MevButton;
/*
 * conventions:
 *  - StrkReq nonzero implies StrkDesel
 *  - StrkDesel implies stroke in progress (SIP)
 *  - TimerRunning and TimerExpired are mutually exclusive (busy/done)
 */
extern short StrkReq;    /* # requests for the next stroke point */
extern short StrkDesel;    /* stroke events have been deselected */


/* The following vars should be phased out: */

extern GC Gc1;          /* grahics context shared by all windows */
extern Drawable HostWin;   /* "current" window to blit to */
extern Window RootWin;  /* created by AxGetDpyAndGCs */
extern Window AxTopWinNeverMapped;  /* created by AxGetDpyAndGCs */
extern unsigned long FGpixel;   /* shared foreground color */
extern unsigned long BGpixel;   /* shared backround color */
extern short FGcolor;   /* What is this??c */
extern short BGcolor;   /* What is this??c */
short UWidMils, UHtMils, UWidPels, UHtPels;
extern short Xmpc, Ympc;
STATIC short HWinWid = RAST_WID;    /* true host window width */
STATIC short HWinHt = RAST_HT;      /* true host window width */
short RastWid = RAST_WID;   /* desktop display width */
short RastHt = RAST_HT;     /* desktop display height */
extern short Mc_xMax, Mc_yMax;      /* mouse cursor limits, mils */
extern short MousWid, MousHt;
extern short CellWidDC, CellHtDC, CellUnder;
extern Cursor ThimPointerCursor, ThimRotateCursor;
extern Cursor ThimUpDownCursor, ThimLeftRightCursor;
extern Cursor ThimTopRightCursor, ThimTopLeftCursor;
extern Cursor ThimBottomRightCursor, ThimBottomLeftCursor;
extern Cursor ThimFleurCursor, ThimTextCursor;
extern XFontStruct *Curpixfontp;

/* maximum # fonts open at a time */
#define MXFONTCNT   20  /* less open/close traffic than with 10 */
#define FONT    XFontStruct

struct FontData
{
    short fontNo;   /* this is global indicating currently loaded font */
    short charHome;
    short charHeight;
    short charBelow;
    short subOffset;
    short superOffset;
    FONT *curpixfontp;
};
struct FontData Fonts[MXFONTCNT];



DlgLiftCursor(){}
ElfbTest(){}


/**********************************************************************/
/* IF YOU CHANGE SOMETHING IN THIS FUNCTION, MAKE SURE THE EQUIVALENT */
/* CHANGE IS MADE IN THE WINDOWS VERSION OF THE FUNCTION (winlib.c)   */
/* IF NOT SURE HOW, ASK jon or donato.                       -donato  */
/*************************************************************************
function: ScrollBarHasBeenMoved - Callback for scroll activity
This is called by ZXtDispatch().
*/
void ScrollBarHasBeenMoved(widget,wID,data)
AXWidget widget;
int wID;
XmScrollBarCallbackStruct *data;
{
    scroll_event_t scroll;
    int i;
    struct wind_struct *windowP;   /* should use this, not the global - jon */

    /* paranoid init of the window context */
    if ( !window[wID].busy_flag )
        return;
    windowP = SetWp(&window[wID]);

    scroll.wid = wID;   /* set the ATM window id */

    /* if the window is borrowed, get the original */
    if ( (windowP->vbar == 0) && (windowP->hbar == 0) ) 
       {
       for ( i=1; i<TM_MAXWIN; i++ )
           {
           if ( window[i].busy_flag && (window[i].winWasBorrowed == wID) )
              {
              windowP = SetWp(&window[i]);
              break;
              }
           }
       }    

    /* check the vertical scroll bar first */
    if ( widget == (AXWidget)windowP->vbar )
    {
        scroll.h_type = UNCHANGED;
        switch ( data->reason )
        {
            default: scroll.v_type = UNCHANGED; break;
            case XmCR_INCREMENT: scroll.v_type = UNIT_INC; break;
            case XmCR_DECREMENT: scroll.v_type = UNIT_DEC; break;
            case XmCR_PAGE_INCREMENT: scroll.v_type = PAGE_INC; break;
            case XmCR_PAGE_DECREMENT: scroll.v_type = PAGE_DEC; break;
            case XmCR_VALUE_CHANGED:
			if ( AxIsGraphicsTask(widget->taskOwner) == FALSE )
                windowP->wind_attr.v_sc_pos = data->value;
                scroll.v_type = NEW_VAL;
                scroll.v_value = data->value;
            break;
        }
        AxSendMes(windowP->p_id, &scroll, sizeof(scroll), APSCROLL);
    }
    else if ( widget == (AXWidget)windowP->hbar ) /* then the horizontal one */
    {
        scroll.v_type = UNCHANGED;
        switch ( data->reason )
        {
            default: scroll.h_type = UNCHANGED; break;
            case XmCR_INCREMENT: scroll.h_type = UNIT_INC; break;
            case XmCR_DECREMENT: scroll.h_type = UNIT_DEC; break;
            case XmCR_PAGE_INCREMENT: scroll.h_type = PAGE_INC; break;
            case XmCR_PAGE_DECREMENT: scroll.h_type = PAGE_DEC; break;
            case XmCR_VALUE_CHANGED:
			if ( AxIsGraphicsTask(widget->taskOwner) == FALSE )
                windowP->wind_attr.h_sc_pos = data->value;
                scroll.h_type = NEW_VAL;
                scroll.h_value = data->value;
            break;
        }
        AxSendMes(windowP->p_id, &scroll, sizeof(scroll), APSCROLL);
    }
}



/**********************************************************************/
/* IF YOU CHANGE SOMETHING IN THIS FUNCTION, MAKE SURE THE EQUIVALENT */
/* CHANGE IS MADE IN THE WINDOWS VERSION OF THE FUNCTION (winlib.c)   */
/* IF NOT SURE HOW, ASK jon or donato.                       -donato  */
/**********************************************************************
function: CreateOrChangeMenuBar - Create or Re-create menu bar
*/
AXWidget_menu
CreateOrChangeMenuBar (w)
AXWidget_main w;
{
    register struct wind_struct *wp;
    AXWidget_menu menu_bar;
    menu_item_def *mp;
    void MenuStartsTask();
    Arg args[10];
    int winID;
    int an = 0;

    if ( !w )
        return(0);

    winID = WindowIdFromShellWidget(w);
    wp = &window[winID];
/* create the menu bar */

    if ( mp = ElfFindSlider(wp) ) {
        menu_bar = (AXWidget_menu)AxCreateMenuBar(w, mp, w->menuBar,
                                   0, (data_ptr)NULL, MenuStartsTask, 
                                   (caddr_t)winID, FALSE);
        w->menuBar = menu_bar;
        wp->menu_bar = menu_bar;
    }
    else
        menu_bar = 0;

    XtSetArg(args[0],AXmNmenuBar,menu_bar);
    XtSetArg(args[1],AXmNworkWindow,w->workWindow);
    XtSetArg(args[2],AXmNhorizontalScrollBar,w->hScrollBar);
    XtSetArg(args[3],AXmNverticalScrollBar,w->vScrollBar);
    XtSetArg(args[4],AXmNpalette,w->palette);
    XtSetArg(args[5],AXmNruler,w->ruler);
    XtSetArg(args[6],AXmNplates,w->plates);
    AxXtSetValues(w,args,7);
	if ( w->workWindow )
		XmRestructureWindow(w);
    return(menu_bar);
}


void MenuStartsTask(widget,window_id,mP)
AXWidget widget;
int window_id;      /* ATM number */
menu_item_def *mP;
{
    char *name;

    if ( !mP )      /* sanity check */
        return;
    name = mP->word2;

/* sanity checks:  nameless, disabled */

    if ( !name )
        return;

/* Send to app */

    AxSendMes(window[window_id].p_id,mP->word2,strlen(mP->word2)+1,APMENUBAR);
}

/*************************************************************************
function: SetCurWinFromMenuWidget - Select window based on menubar widget
*/
SetCurWinFromMenuWidget (widget)
register AXWidget_menu widget;
{
    register int ix;
    struct wind_struct *windowP;

    for ( ix = 0; ix < TM_MAXWIN; ix++ )
	{
        if ( window[ix].busy_flag && (window[ix].menu_bar == widget))
		{
            windowP = make_curwin(ix);
            AXSetInputFocus(windowP->xwin, FALSE, CurrentTime);
            return;
        }
    }
}




/*************************************************************************
function: WidgetOfWindowStruct - Return main window's widget
*/
AXWidgetOfWindowStruct (p)
register struct wind_struct *p;
{
    return((int)p->workWidget);
}



/***************************************************************************
function: ChangeWpX11Window - Change a TM-window's drawable
*/
ChangeWpX11Window (wid, drawable)
int wid;
Drawable drawable;
{
    window[wid].xwin = drawable;
}





/*************************************************************************
function: atm_modify - Change characteristics of a window
XWINS Thimble allows fewer changes than Alis.
This routine is just used for scroll bars, window size and title.
*/
atm_modify(){}  /* never called, see below */





static jmp_buf AlarmLongJump;
static int UsingAlarm;  /* Whether alarm set by GetAndDoEvent */

#if 0
*** does not seems to be used - jon
/*************************************************************************
function: ApplixEventTimeoutCatcher - Catcher for alarm
*/
void ApplixEventTimeoutCatcher (sig,code,sgp)
int sig, code;
struct sigcontext *sgp;
{
    if ( !UsingAlarm )  /* spurious, ignore it */
        return;
    signal(SIGALRM,SIG_IGN);/* see if they changed themself */
    XWINSlog("alarm triggered");
    longjmp(AlarmLongJump,1);
}
#endif

/***************************************************************************
function: AxGetLastMotionEventInQueue - This function takes a motion event
and discards intermedate motion events in the same stroke.  This function
makes sure that the events are for the same window, and that the button/key
state is the same.  The last valid motion event currently in the input queue
is returned (the event is removed from the input queue).  This function scans
the input queue from the head, and stops if any event other than a motion event
is encountered.
*/
void AxGetLastMotionEventInQueue (eventP)
XEvent *eventP;
{
    XEvent event;

    if ( eventP->type != MotionNotify )
        return;

    while ( AXtAppNextEvent(NULL, 0) ) {
        /* check next event in input queue */
#if SUPPORT_HP_VUE
        XtPeekEvent(&event);
#else
        XPeekEvent(Dpy,&event);
#endif

        /* process current motion event if next event is not MotionNotify */
        if ( event.type != MotionNotify )
            return;

        /* process current motion event if next event is for a different
         * window, or has a different button/key state */
        if ( (eventP->xany.window != event.xany.window) ||
                        (eventP->xmotion.state != event.xmotion.state) )
            return;

        /* fetch next event normally, make it current event */
        AXtAppNextEvent(eventP, -1);
    }
}



/*************************************************************************
function: AxGobbleMotionEvents - Fixes a timing issue during border stroking
The server may have queued mouse points during a border stroke, but
the App may have done a TmScroll with a window obscuring the work area.
The additional mouse points willk arrive (causing another scroll) before
the Exposure event from the last scroll arrives.  The app manages
to get out of sync as to which damaged rect needs needs fixed (they
both have the same coordinates, but the prior has moved now)
*/
AxGobbleMotionEvents ()
{
    XEvent event;
    int n;

    XSync(Dpy,FALSE);
    while ( XPending(Dpy) ) {
#if SUPPORT_HP_VUE
        XtPeekEvent(&event);
#else
        XPeekEvent(Dpy,&event);     /* check for motion event */
#endif
        if ( event.type != MotionNotify )       /* no, quit */
            return;
        n = AXtAppNextEvent(&event,-1); /* fetch it normally */
        if ( !n )   /* ignore incoming signal */
            continue;
    }
}


/*
 * Initialize device setup and host system interface to display
 *
 * - Get system display resources and characteristics.
 * - Open the relevant device setup (in WMgetWind for GMODE).
 * - Note: Can be called repeatedly (via TmRestore).
 */
WMinit()
{
    XFontStruct  *fs = NULL;
    char *UPneedByCode();

    WMgetWind();    /* get supporting resources and device characteristics */
    getWMvars();    /* initialize variables to track host window */
}

/*
 * WMgetWind -- get window from host window manager (if necessary)
 */
WMgetWind()
{
    AxGetDpyAndGCs();
    HostWin = (Drawable)AxTopWinNeverMapped;
}

/*
 * assign globals describing (virtual) screen available to atm
 */
getWMvars()
{
    int screen;     /* id of physical display */
    short Mwwp;
    short Mwhp;

    screen = DefaultScreen(Dpy);
    HWinWid = DisplayWidth(Dpy,screen);
    HWinHt = DisplayHeight(Dpy,screen);

    UWidMils = UHtMils = 40;   /* default conversion factor 75dpi */
    UWidPels = UHtPels = 3;

        /* these magic numbers from the past were based on dsiFontDesc
           data for the default font (12pt courier or times..) */
    CellWidDC = 8;
    CellHtDC = 17;
    conv_i_p(&Xmpc, &Ympc, &CellWidDC, &CellHtDC, PIXEL_TO_MILLS);
    if ((CellUnder = CellHtDC) > 1) CellUnder--;
    MinWWid = MINW_COLS * Xmpc;
    MinWHt = MINW_ROWS * Ympc;

    /*
     * window size limits
     *
     * WARNING: DevChar values must be consistent with DeskRect,
     * to be computed by deskCalc
    * Note that for XWINS, the window size limits have a meaning that ??x
    * is not clear.  If these values are used by apps to set up max arrays
    * this will be a problem because an X win can be larger than the display.
    * Likewise, if the values are too big, an app may create a window larger
    * than the display - which is ugly.
     */
    Mwwp = RastWid - 12;
    Mwhp = RastHt - 2 * CellHtDC - 30;

    /* note these conversion from pixels to mils do not round up */

    MaxwWid = ((long) Mwwp * UWidMils / UWidPels);
    MaxwHt = ((long) Mwhp * UHtMils / UHtPels);
    Mc_xMax = (long) (RastWid - MousWid) * UWidMils / UWidPels;
    Mc_yMax = (long) (RastHt - MousHt) * UHtMils / UHtPels;

#if 0    /* not used */ 
    DevChar.h_desktop = MaxwHt;
    DevChar.w_desktop = MaxwWid;
    DevChar.d_height = MaxwHt;
    DevChar.d_width = MaxwWid;
#endif
}

#define NCOLORS     2

int AxHaveGoodColors;   /* Poke FALSE to re-read pixel values */

extern XColor Ax64Defs[];

/*************************************************************************
function: IconIdOfWindow - Return major app's type
*/
IconIdOfWindow (i)
int i;
{
    return(window[i].wind_attr.icon_id);
}

/***********************************************************************
function: MenuBarIdOfWindow - Return major app's menubar id.
*/
MenuBarIdOfWindow(ix)
int ix;
{
    if (ix >= 0 && ix < TM_MAXWIN)
        return(window[ix].wind_attr.menubar_id);
    return(IC_UNKNOWN);
}

/*************************************************************************
function: ThimToggleRuler - Reverse ruler state
*/
ThimToggleRuler (wid)
int wid;
{
    if ( window[wid].ruler )
        ThimRemoveRuler(wid);
    else
        ThimAddRuler(wid);
}

/*************************************************************************
function: ThimTogglePlates - Reverse plates state
*/
ThimTogglePlates (wid)
int wid;
{
    if ( window[wid].plates )
        ThimRemovePlates(wid);
    else
        ThimAddPlates(wid);
}

/*************************************************************************
function: copyPixmap - copy pixmap to window
*/
typeErr
copyPixmap(winID, x, y, pelWidth, pelHeight)
short winID;
int x, y, pelWidth, pelHeight;
{
    AxRectangle *clipRct, unclippedRct, clippedRct;

    /* clip */
    unclippedRct.origin.x = x;
    unclippedRct.origin.y = y;
    unclippedRct.corner.x = x + pelWidth;
    unclippedRct.corner.y = y + pelHeight;
    clipRct = (Wp->layer) ? &Wp->layer->curClip : &A_Display->maprect;

    /* if there is any part of the area unclipped, copy it to the window */
    if ( sectRect(&unclippedRct, clipRct, &clippedRct) )
        XCopyArea(Dpy, HostWin, Wp->xwin, Gc1,
                  clippedRct.origin.x, clippedRct.origin.y,
                  clippedRct.corner.x - clippedRct.origin.x,
                  clippedRct.corner.y - clippedRct.origin.y,
                  clippedRct.origin.x, clippedRct.origin.y);
}

AxPixmapRect(x, y, width, height)
int x, y;
unsigned int width, height;
{
    /* no clipping! */
    XSetForeground(Dpy, Gc1, BlackPixel(Dpy, DefaultScreen(Dpy)));
    XSetClipMask(Dpy, Gc1, None);
    XDrawRectangle( Dpy, HostWin, Gc1, x, y, width, height );
}

AxPixmapBlit(srcX, srcY, Wid, Hyt, dstX, dstY)
int srcX, srcY, Hyt, Wid, dstX, dstY;
{
    /* no clipping! */
    XCopyArea(Dpy,HostWin,HostWin,Gc1,srcX,srcY,Wid,Hyt,dstX,dstY);
}

AxWinToPixmap(srcX, srcY, Wid, Hyt, dstX, dstY)
int srcX, srcY, Hyt, Wid, dstX, dstY;
{
    /* no clipping! */
    XCopyArea(Dpy,Wp->xwin,HostWin,Gc1,srcX,srcY,Wid,Hyt,dstX,dstY);
}




/**********************************************************************/
struct regionPack {
    char *back;
    char *data;
    char *mask;
    int wid, hyt;
    int clipX, clipY, clipWid, clipHyt;
    int old_x, old_y, old_wid, old_hyt;
};

AxMoveRegion(w, command_state, x, y, imPack)
AXWidget w;
int command_state;
int x, y;
struct regionPack *imPack;
{
    int i, j;
    int old_x, old_y, old_hyt, old_wid;
    int new_x, new_y, new_hyt, new_wid;
    int cpy_x, cpy_y, cpy_hyt, cpy_wid;
    XRectangle xClipRect;
    XImage *ximg;
    Drawable xwin;

    /* get the drawable */
    xwin = getWindowFromWidget(w);
    if ( command_state == 0 ) /* initialize region */
    {
        /* init */
        XSetState(Dpy, Gc1, FGpixel, BGpixel, GXcopy, AllPlanes);

        /* grab the image data */
        ximg = XGetImage(Dpy, xwin, x, y, imPack->wid, imPack->hyt,
                         AllPlanes,
                         ZPixmap);
        if ( ximg == (XImage *)0 )
			imPack->data = (char *)0;
		else
		{
			for ( i=0; i<ximg->height; i++ )
			{
				for ( j=0; j<ximg->width; j++ )
				{
					if ( XGetPixel(ximg, j, i) == AlisPixels[0] )
						XPutPixel(ximg, j, i, 0);
				}
			}
			imPack->data = (char *)ximg;
		}

        /* now create a mask for the image data */
        ximg = XGetImage(Dpy, xwin, x, y, imPack->wid, imPack->hyt,
                         AllPlanes,
                         ZPixmap);
        if ( ximg == (XImage *)0 )
			imPack->mask = (char *)0;
		else
		{
			for ( i=0; i<ximg->height; i++ )
			{
				for ( j=0; j<ximg->width; j++ )
				{
					if ( XGetPixel(ximg, j, i) == AlisPixels[0] )
						XPutPixel(ximg, j, i, 0);
					else
						XPutPixel(ximg, j, i, AllPlanes);
				}
			}
			imPack->mask = (char *)ximg;
		}
    }

    else if ( command_state == 1 ) /* move region */
    {
        if ( imPack->data == (char *)0 )
            return;

        /* note the location of the old image */
        old_x = imPack->old_x;
        old_y = imPack->old_y;
        old_wid = imPack->old_wid;
        old_hyt = imPack->old_hyt;

        /* make sure image region doesn't exceed window boundry */
        if ( x < imPack->clipX )
        {
            new_wid = imPack->wid - (imPack->clipX - x);
            new_x = imPack->clipX;
        }
        else
        {
            new_x = x;
            new_wid = imPack->wid;
        }

        if ( y < imPack->clipY )
        {
            new_hyt = imPack->hyt - (imPack->clipY - y);
            new_y = imPack->clipY;
        }
        else
        {
            new_y = y;
            new_hyt = imPack->hyt;
        }

        if ( new_x + new_wid > imPack->clipX + imPack->clipWid )
        {
            new_wid = imPack->clipX + imPack->clipWid - new_x;
            if ( new_wid < 0 )
                new_wid = 0;
        }
        else
            new_wid = imPack->wid;

        if ( new_y + new_hyt > imPack->clipY + imPack->clipHyt )
        {
            new_hyt = imPack->clipY + imPack->clipHyt - new_y;
            if ( new_hyt < 0 )
                new_hyt = 0;
        }
        else
            new_hyt = imPack->hyt;

        /* don't do anything if the region hasn't moved */
        if ( old_x == new_x && old_wid == new_wid &&
             old_y == new_y && old_hyt == new_hyt )
            return;

        /* note the size and shape of the clipped image */
        imPack->old_x = new_x;
        imPack->old_y = new_y;
        imPack->old_wid = new_wid;
        imPack->old_hyt = new_hyt;

        /* restore the old area, draw the region in the new place */
        XSetFunction(Dpy, Gc1, GXcopy);
        if ( ScratchMap == 0 )
        {
            /* set up the clipping area */
            xClipRect.x = imPack->clipX;
            xClipRect.y = imPack->clipY;
            xClipRect.width  = imPack->clipWid;
            xClipRect.height = imPack->clipHyt;
            XSetClipRectangles(Dpy, Gc1, 0, 0, &xClipRect, 1, Unsorted);

            /* draw in the old background, then grab a new background */
            if( imPack->back )
            {
                XPutImage(Dpy, xwin, Gc1, (XImage *)(imPack->back),
                          0, 0, old_x, old_y, old_wid, old_hyt);
                XDestroyImage((XImage *)imPack->back);
            }
            imPack->back = (char *)XGetImage(Dpy, xwin,
                                         new_x, new_y, new_wid, new_hyt,
                                         AllPlanes,
                                         ZPixmap);

            /* lay down the mask */
            XSetFunction(Dpy, Gc1, GXandInverted);
            XPutImage(Dpy, xwin, Gc1,
                      (XImage *)(imPack->mask),
                      0, 0,
                      x, y, imPack->wid, imPack->hyt);

            /* display the region being moved */
            XSetFunction(Dpy, Gc1, GXor);
            XPutImage(Dpy, xwin, Gc1,
                      (XImage *)(imPack->data),
                      0, 0,
                      x, y, imPack->wid, imPack->hyt);
            XSetFunction(Dpy, Gc1, GXcopy);
        }
        else /* do the work on the scratch pixmap */
        {
            cpy_x = (new_x < old_x) ? new_x : old_x;
            cpy_y = (new_y < old_y) ? new_y : old_y;
            cpy_wid = new_wid + ABS(old_x - new_x);
            cpy_hyt = new_hyt + ABS(old_y - new_y);
            x     -= cpy_x;
            old_x -= cpy_x;
            new_x -= cpy_x;
            y     -= cpy_y;
            old_y -= cpy_y;
            new_y -= cpy_y;

            /* copy from HostWin to the offscreen resource */
            XSetClipMask(Dpy, Gc1, None);
            XCopyArea(Dpy, xwin, ScratchMap, Gc1,
                      cpy_x,cpy_y, cpy_wid,cpy_hyt, 0,0);

            /* draw in the old background, then grab a new background */
            if( imPack->back )
            {
                XPutImage(Dpy, ScratchMap, Gc1, (XImage *)(imPack->back),
                          0, 0, old_x, old_y, old_wid, old_hyt);
                XDestroyImage((XImage *)imPack->back);
            }
            imPack->back = (char *)XGetImage(Dpy, ScratchMap,
                                         new_x, new_y, new_wid, new_hyt,
                                         AllPlanes,
                                         ZPixmap);

            /* mask out the non-transparent data */
            XSetFunction(Dpy, Gc1, GXandInverted);
            XPutImage(Dpy, ScratchMap, Gc1,
                      (XImage *)(imPack->mask),
                      0, 0,
                      x, y, imPack->wid, imPack->hyt);

            /* OR the data into the masked area */
            XSetFunction(Dpy, Gc1, GXor);
            XPutImage(Dpy, ScratchMap, Gc1,
                      (XImage *)(imPack->data),
                      0, 0,
                      x, y, imPack->wid, imPack->hyt);

            /* copy the offscreen resource content to the window */
            xClipRect.x = imPack->clipX;
            xClipRect.y = imPack->clipY;
            xClipRect.width  = imPack->clipWid;
            xClipRect.height = imPack->clipHyt;
            XSetClipRectangles(Dpy, Gc1, 0, 0, &xClipRect, 1, Unsorted);
            XSetFunction(Dpy, Gc1, GXcopy);
            XCopyArea(Dpy, ScratchMap, xwin, Gc1,
                      0,0, cpy_wid,cpy_hyt, cpy_x,cpy_y);
        }
    }

    else if ( command_state == 2 ) /* reset */
    {
        xClipRect.x = imPack->clipX;
        xClipRect.y = imPack->clipY;
        xClipRect.width  = imPack->old_wid;
        xClipRect.height = imPack->old_hyt;
        XSetClipRectangles(Dpy, Gc1, 0, 0, &xClipRect, 1, Unsorted);
        if ( imPack->back )
        {
            XDestroyImage((XImage *)(imPack->back));
            imPack->back = (char *)0;
        }
        if ( imPack->mask )
        {
            XDestroyImage((XImage*)(imPack->mask));
            imPack->mask = (char *)0;
        }
        if ( imPack->data )
        {
            XDestroyImage((XImage*)(imPack->data));
            imPack->data = (char *)0;
        }
        imPack->clipX = imPack->clipY = imPack->clipWid = 0;
        imPack->clipHyt = imPack->wid = imPack->hyt = 0;
        imPack->old_x = imPack->old_y = 0;
        imPack->old_wid = imPack->old_hyt = 0;
        XSetClipMask(Dpy, Gc1, None);
    }
}

/*************************************************************************
function: PidOfWidget - Return task that owns a widget
IMPORTANT SIDE EFFECT: Sets Wp to owning window.
*/
PidOfWidget (widget)
AXWidget_main widget;
{
    register int ix;

    while ( widget ) {
        for ( ix = 0; ix < TM_MAXWIN; ix++ )
		{
            if ( window[ix].busy_flag && (window[ix].shell == widget))
                return(window[ix].p_id);
        }
        widget = (AXWidget_main)AXtParent(widget);
    }
    return(0);
}



#if 0 /* documentation on axGridToRuler */
/* axGridToRuler is derived from a simple grid function
   which would look like this:
int
iSimpleGrid(coord, grid)
int coord;
int grid;
{
    return (coord - (coord % grid));
}

/* in floating-point, the same simple grid func looks like: */

float
fSimpleGrid(coord, grid)
float coord;
float grid;
{
    float trueRatio = coord / grid;
    float truncErr, mod;
    int tmp;

    tmp = (int) trueRatio;
    truncErr = trueRatio - tmp;
    mod = truncErr * grid;
    return (coord - mod);
}

/* fGridToRuler is the floating-point version of axGridToRuler.
   It's here to show how axGridToRuler relates to iSimpleGrid,
   and to provide a starting point for gridding in floating
   point (which would be done to trade 'speed' for accuracy) */
void
fGridToRuler(x, y, x_orig, y_orig, x_gsize, y_gsize,
              gridx, gridy)
float x, y;              /* in: input point */
float x_orig, y_orig;    /* in: grid origin */
float x_gsize, y_gsize;  /* in: grid unit size */
float *gridx, *gridy;    /* out: return gridded vals */
{
    *gridx = fSimpleGrid(x, x_gsize) - 
        (x_gsize - (x_orig - fSimpleGrid(x_orig, x_gsize)));

    /* (note that no test is performed on the size of the gridding
        adjustment, unlike the integer version -- this means that
        the point may be adjusted not to the nearest lesser grid
        position, but possibly to the one behind that..) */

    *gridy = fSimpleGrid(y, y_gsize) - 
        (y_gsize - (y_orig - fSimpleGrid(y_orig, y_gsize)));
}

#endif
