/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxcreat.c
   Applix ASC version: 11
   Date: Mon Jan 11 21:14:07 1999
*/
#include <fcntl.h>
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parwin.h>

extern char ComEnable;      /* the -e switch is present */
extern short THIMpid;

/*************************************************************************
function: TmCreate - Create a new window
*/
typeErr TmCreate(window_id, widget_id, cre_ptr)
short *window_id;
long *widget_id;
struct TmCrePacket *cre_ptr;
{
    union
    {
        struct SCreateData cr_data;
        char sen_buf[SEN_BUF_SIZE];
    } sen_pack;

    union
    {
        struct RCreateData cr_data;
        char rec_buf[sizeof(struct RCreateData)];
    } rec_pack;

    short i, discard;
    char *copyP;     /* ptr for memcpy's */

    if(!TmOpFlag) TmOpATM();
    if (!TmValWin(cre_ptr->parent_id, TRUE))
    {
        *window_id = TM_NULWIN;
        *widget_id = 0;
        return TMR_PWIN;
    }

    sen_pack.cr_data.event_indicator = QATM_CREATE;
    sen_pack.cr_data.cr_pack = *cre_ptr;

    if (cre_ptr->title_line == NULL)
        sen_pack.cr_data.title_len = 0;
    else
        sen_pack.cr_data.title_len = strlen(cre_ptr->title_line);

	sen_pack.cr_data.option_len = 0;
    sen_pack.cr_data.help_num = 0;

    copyP = sen_pack.sen_buf+sizeof(struct SCreateData);
    memcpy(copyP,cre_ptr->title_line,sen_pack.cr_data.title_len);
    copyP += sen_pack.cr_data.title_len;
    sen_pack.cr_data.pack_len = sizeof(struct SCreateData)
        + (copyP - sen_pack.sen_buf)
        + sen_pack.cr_data.help_num*sizeof(long);

    TmSenMes(sen_pack.sen_buf, sen_pack.cr_data.pack_len, TMHURRY,
			rec_pack.rec_buf,  sizeof(struct RCreateData));

    *window_id = rec_pack.cr_data.window_id;
    *widget_id = rec_pack.cr_data.widget_id;
    return(rec_pack.cr_data.status);
}

