/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxdchar.c
   Applix ASC version: 12
   Date: Mon Nov 16 13:53:38 1998
*/
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parattr.h>

extern int TmDefDev;  /* Default device. -1 means unknown. */
extern short TmVStretch;   /* flag from axfonts for default device */


#if 0    /* { this doesn't seem to be used - donato */

/* Note the interface changes... writebacks are ints! */
typeErr TmDeviceChars(h_desktop,w_desktop,d_height,d_width, features, printer_class, printer_type)
int *h_desktop;
int *w_desktop;
int *d_height;
int *d_width;
struct TmFeatures *features;
char *printer_class;
char *printer_type;
{
    int pSetup;

    pSetup = AxPrintSetupFromClassAndType(printer_class, printer_type);

    if (TmDummy)
    {
        *h_desktop = *d_height = 60 * CHEIGHT;
        *w_desktop = *d_width = 80 * CWIDTH;
        if (features != NULL)
        {
            (*features).txGrMode = TM_TXMODE;
            (*features).defdev = 0;
            (*features).mcellHt = CHEIGHT;
            (*features).pcellHt = 1;
            (*features).mcellWid = CWIDTH;
            (*features).pcellWid = 1;
            (*features).txMHt = CHEIGHT;
            (*features).txPHt = 1;
            (*features).txMWid = CWIDTH;
            (*features).txPWid = 1;
            (*features).grMHt = CHEIGHT;
            (*features).grPHt = 1;
            (*features).grMWid = CWIDTH;
            (*features).grPWid = 1;
            (*features).modified = 0;
        }
        TmDefDev = 0;
        return(TMR_OK);
    }

    if(!TmOpFlag) TmOpATM();

        /* supply values steeped in history (which
           used to come from the "metrics" datafile) */
    switch (pSetup)
    {

      case 1:
            /* PostScript printer */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 1;
            (*features).pcellHt = 1;
            (*features).mcellWid = 1;
            (*features).pcellWid = 1;
            (*features).defdev = 106;
            (*features).txMHt = 1;
            (*features).txPHt = 1;
            (*features).txMWid = 1;
            (*features).txPWid = 1;
            (*features).grMHt = 1;
            (*features).grPHt = 1;
            (*features).grMWid = 1;
            (*features).grPWid = 1;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
      case 3:
            /* PCL5 printer */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 10;
            (*features).pcellHt = 3;
            (*features).mcellWid = 10;
            (*features).pcellWid = 3;
            (*features).defdev = 106;
            (*features).txMHt = 10;
            (*features).txPHt = 3;
            (*features).txMWid = 10;
            (*features).txPWid = 3;
            (*features).grMHt = 10;
            (*features).grPHt = 3;
            (*features).grMWid = 10;
            (*features).grPWid = 3;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
    case 70:
    case 45:
	/* #if BUILD_ORIENT (case 218, 219) removed, per KKA changes.  20 Apr 98 rjd */
            /* printer */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 10;
            (*features).pcellHt = 3;
            (*features).mcellWid = 10;
            (*features).pcellWid = 3;
            (*features).defdev = 106;
            (*features).txMHt = 10;
            (*features).txPHt = 3;
            (*features).txMWid = 10;
            (*features).txPWid = 3;
            (*features).grMHt = 10;
            (*features).grPHt = 3;
            (*features).grMWid = 10;
            (*features).grPWid = 3;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
#if BUILD_ORIENT
    /* Canon LIPS printer, default paper : A4 */
    case 218:
    case 219:
        *h_desktop = 11692;
        *w_desktop = 8267;
        *d_height = 11692;
        *d_width = 8267;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 1;
            (*features).pcellHt = 1;
            (*features).mcellWid = 1;
            (*features).pcellWid = 1;
            (*features).defdev = 106;
            (*features).txMHt = 1;
            (*features).txPHt = 1;
            (*features).txMWid = 1;
            (*features).txPWid = 1;
            (*features).grMHt = 1;
            (*features).grPHt = 1;
            (*features).grMWid = 1;
            (*features).grPWid = 1;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
#endif

    case -1:
    case 106:
    default:
            /* screen */
        *h_desktop = 8500;
        *w_desktop = 10500;
        *d_height = 8500;
        *d_width = 10500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 40;
            (*features).pcellHt = 3;
            (*features).mcellWid = 40;
            (*features).pcellWid = 3;
            (*features).defdev = 106;
            (*features).txMHt = 40;
            (*features).txPHt = 3;
            (*features).txMWid = 40;
            (*features).txPWid = 3;
            (*features).grMHt = 40;
            (*features).grPHt = 3;
            (*features).grMWid = 40;
            (*features).grPWid = 3;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
    }

    /* following apply to local device regardless of pSetup */
    TmDefDev = 106;
    TmVStretch = FALSE;

    return(TMR_OK);

}
#endif    /* } if 0 */



typeErr TmDchar(h_desktop,w_desktop,d_height,d_width, features, pSetup)
short *h_desktop;
short *w_desktop;
short *d_height;
short *d_width;
struct TmFeatures *features;
short pSetup;
{
    if (TmDummy)
    {
        *h_desktop = *d_height = 60 * CHEIGHT;
        *w_desktop = *d_width = 80 * CWIDTH;
        if (features != NULL)
        {
            (*features).txGrMode = TM_TXMODE;
            (*features).defdev = 0;
            (*features).mcellHt = CHEIGHT;
            (*features).pcellHt = 1;
            (*features).mcellWid = CWIDTH;
            (*features).pcellWid = 1;
            (*features).txMHt = CHEIGHT;
            (*features).txPHt = 1;
            (*features).txMWid = CWIDTH;
            (*features).txPWid = 1;
            (*features).grMHt = CHEIGHT;
            (*features).grPHt = 1;
            (*features).grMWid = CWIDTH;
            (*features).grPWid = 1;
            (*features).modified = 0;
        }
        TmDefDev = 0;
        return(TMR_OK);
    }

    if(!TmOpFlag) TmOpATM();

        /* supply values steeped in history (which
           used to come from the "metrics" datafile) */
    switch (pSetup)
    {
      case 1:
                                /* PostScript printer */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 1;
            (*features).pcellHt = 1;
            (*features).mcellWid = 1;
            (*features).pcellWid = 1;
            (*features).defdev = 106;
            (*features).txMHt = 1;
            (*features).txPHt = 1;
            (*features).txMWid = 1;
            (*features).txPWid = 1;
            (*features).grMHt = 1;
            (*features).grPHt = 1;
            (*features).grMWid = 1;
            (*features).grPWid = 1;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
      case 3:
                                /* PCL5 printer */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 10;
            (*features).pcellHt = 3;
            (*features).mcellWid = 10;
            (*features).pcellWid = 3;
            (*features).defdev = 106;
            (*features).txMHt = 10;
            (*features).txPHt = 3;
            (*features).txMWid = 10;
            (*features).txPWid = 3;
            (*features).grMHt = 10;
            (*features).grPHt = 3;
            (*features).grMWid = 10;
            (*features).grPWid = 3;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;

    case 4:    /* Windows GDI printing. */
        /* same as PostScript for now. */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 1;
            (*features).pcellHt = 1;
            (*features).mcellWid = 1;
            (*features).pcellWid = 1;
            (*features).defdev = 106;
            (*features).txMHt = 1;
            (*features).txPHt = 1;
            (*features).txMWid = 1;
            (*features).txPWid = 1;
            (*features).grMHt = 1;
            (*features).grPHt = 1;
            (*features).grMWid = 1;
            (*features).grPWid = 1;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;

    case 70:
    case 45:
            /* printer */
        *h_desktop = 11000;
        *w_desktop = 8500;
        *d_height = 11000;
        *d_width = 8500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 10;
            (*features).pcellHt = 3;
            (*features).mcellWid = 10;
            (*features).pcellWid = 3;
            (*features).defdev = 106;
            (*features).txMHt = 10;
            (*features).txPHt = 3;
            (*features).txMWid = 10;
            (*features).txPWid = 3;
            (*features).grMHt = 10;
            (*features).grPHt = 3;
            (*features).grMWid = 10;
            (*features).grPWid = 3;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;


#if BUILD_ORIENT
    case 218:
    case 219:
                                /* Canon LIPS printer, default paper:A4 */
        *h_desktop = 11692;
        *w_desktop = 8267;
        *d_height = 11692;
        *d_width = 8267;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 1;
            (*features).pcellHt = 1;
            (*features).mcellWid = 1;
            (*features).pcellWid = 1;
            (*features).defdev = 106;
            (*features).txMHt = 1;
            (*features).txPHt = 1;
            (*features).txMWid = 1;
            (*features).txPWid = 1;
            (*features).grMHt = 1;
            (*features).grPHt = 1;
            (*features).grMWid = 1;
            (*features).grPWid = 1;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
#endif

    case -1:
    case 106:
    default:
            /* screen */
        *h_desktop = 8500;
        *w_desktop = 10500;
        *d_height = 8500;
        *d_width = 10500;
        if (features != NULL)
        {
            (*features).txGrMode = TM_GRMODE;
            (*features).mcellHt = 40;
            (*features).pcellHt = 3;
            (*features).mcellWid = 40;
            (*features).pcellWid = 3;
            (*features).defdev = 106;
            (*features).txMHt = 40;
            (*features).txPHt = 3;
            (*features).txMWid = 40;
            (*features).txPWid = 3;
            (*features).grMHt = 40;
            (*features).grPHt = 3;
            (*features).grMWid = 40;
            (*features).grPWid = 3;
            (*features).modified = 1;
            (*features).extBits = TM_ALISFONT;
            (*features).res1 = 0;
        }
        break;
    }

    /* following apply to local device regardless of pSetup */
    TmDefDev = 106;
    TmVStretch = FALSE;

    return(TMR_OK);
}


