/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxinq.c
   Applix ASC version: 4
   Date: Mon Nov 16 13:53:42 1998
*/
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parattr.h>

extern int TmDefDev;  /* Default device. -1 means unknown. */
extern short TmVStretch;   /* flag from axfonts for default device */

typeErr TmInq (window_id, x_position, y_position, x_size, y_size, h_sc_pos,
    v_sc_pos, curtype, x_cur_pos, y_cur_pos)
short window_id;
short *x_position;
short *y_position;
short *x_size;
short *y_size;
int *h_sc_pos;
int *v_sc_pos;
short *curtype;
short *x_cur_pos;
short *y_cur_pos;

{
    union
    {
        struct SInqData inq_data;
        char sen_buf[sizeof(struct SInqData)];
    } sen_pack;

    union
    {
        struct RInqData inq_data;
        char rec_buf[sizeof(struct RInqData)];
    } rec_pack;

    short i, discard;

    if (TmDummy)
    {
        *x_size = 80 * CWIDTH;
        *y_size = 60 * CHEIGHT;
        return TMR_OK;

        /*all other args are ignored in export-dc*/
    }

    if(!TmOpFlag) return(TMR_OWN);
    if (!TmValWin(window_id, FALSE)) return TMR_NOWIN;
    sen_pack.inq_data.event_indicator = QATM_INQ;
    sen_pack.inq_data.pack_len = sizeof(struct SInqData);
    sen_pack.inq_data.window_id = window_id;

    TmSenMes(sen_pack.sen_buf, sen_pack.inq_data.pack_len, TMHURRY,
			rec_pack.rec_buf,  sizeof(struct RInqData));

    *x_position = rec_pack.inq_data.x_position;
    *y_position = rec_pack.inq_data.y_position;
    *x_size = rec_pack.inq_data.x_size;
    *y_size = rec_pack.inq_data.y_size;
    *h_sc_pos = rec_pack.inq_data.h_sc_pos;
    *v_sc_pos = rec_pack.inq_data.v_sc_pos;
    *curtype = rec_pack.inq_data.curtype;
    *x_cur_pos = rec_pack.inq_data.x_cur_pos;
    *y_cur_pos = rec_pack.inq_data.y_cur_pos;
    return(TMR_OK);
}
