/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxpolyl.c
   Applix ASC version: 14
   Date: Mon Nov 16 13:53:39 1998
*/
#include <fcntl.h>
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parout.h>

/**********************************************************************
 * TmPolyline - this call draws a fancy polyline according to the poly
 * data and the attributes passed in. This poly may be composed of
 * multiple sub polys (open or closed), but all share a single style.
 * Poly data may optionally contain bezier control points.
 */
typeErr
TmPolyline(w, nPolys, attr, poly, clip, clip_info)
AXWidget w;
int nPolys;
attr_type *attr;
poly_type *poly;
TmRect32 *clip;
clip_path *clip_info;
{
    extern int TmAmSE;

	if (nPolys == 0)
		return TMR_OK ;

    /* draw the polyline (may be a compound object) */
    if ( TmAmSE == FALSE )
        ax_tm_pline(w, nPolys, attr, poly, clip, clip_info);
    else
	{
        /* if there is no window, don't do anything */
        if ( TmValWin(WindowIdFromShellWidget(w), FALSE) == FALSE )
            return TMR_NOWIN;
        ax_se_pline(WindowIdFromShellWidget(w), nPolys, attr,
										   poly, clip, clip_info);
    }

    /* done */
    return TMR_OK;
}

AxPolyline(){abort();}
