/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxsetwn.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:40 1998
*/
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parattr.h>

typeErr TmSetWinAttr(window_id, x_cur_pos, y_cur_pos, lin_des,
    read_tx_des, write_tx_des, trans_mode, cliprect, txAlign,
    fg_color, bg_color)
short window_id;
short x_cur_pos,y_cur_pos;
TmLineDescriptor *lin_des;
TmTextDescriptor *write_tx_des;
TmTextDescriptor *read_tx_des;
short trans_mode;
TmRect *cliprect;
short txAlign;
short fg_color;
short bg_color;
{
    union
    {
        struct SSetWinData set_win_data;
        char sen_buf[sizeof(struct SSetWinData)];
    } sen_pack;

    short i, discard;

    if(!TmOpFlag) TmOpATM();
    if (!TmValWin(window_id, FALSE)) return TMR_NOWIN;
    sen_pack.set_win_data.event_indicator = QATM_SET_WIN;
    sen_pack.set_win_data.pack_len = sizeof(struct SSetWinData);
    sen_pack.set_win_data.window_id = window_id;
    sen_pack.set_win_data.x_cur_pos = x_cur_pos;
    sen_pack.set_win_data.y_cur_pos = y_cur_pos;
    sen_pack.set_win_data.lin_des = *lin_des;
    sen_pack.set_win_data.write_tx_des = *write_tx_des;
    sen_pack.set_win_data.read_tx_des = *read_tx_des;
    sen_pack.set_win_data.trans_mode = trans_mode;
    sen_pack.set_win_data.txAlign = txAlign;
    if (cliprect == NULL)           /* no change option */
        sen_pack.set_win_data.cliprect.x_size = -1;
    else
        sen_pack.set_win_data.cliprect = *cliprect;
    sen_pack.set_win_data.fg_color = fg_color;
    sen_pack.set_win_data.bg_color = bg_color;

    TmSenMes(sen_pack.sen_buf, sen_pack.set_win_data.pack_len, TMNOHURRY, NULLP, 0);

    return TMR_OK;
}

/*
 * Turns on mode in which field read/writes & write_tx's first draw text onto
 * a scratch pixmap and transform it before actual display.
 */
typeErr TmSetImageTextMode(window_id, on, zoom, targSetup,
				pt0, pt1, pt2, pt3)
short window_id, on, zoom, targSetup;
TmPoint32 *pt0, *pt1, *pt2, *pt3;
{
    union
    {
        struct SSetImgTxtMode set_imgtxt_data;
        char sen_buf[sizeof(struct SSetImgTxtMode)];
    } sen_pack;


    if(!TmOpFlag) TmOpATM();
    if (!TmValWin(window_id, FALSE)) return TMR_NOWIN;
    sen_pack.set_imgtxt_data.event_indicator = QATM_IMGTXT;
    sen_pack.set_imgtxt_data.pack_len = sizeof(struct SSetImgTxtMode);
    sen_pack.set_imgtxt_data.window_id = window_id;
    sen_pack.set_imgtxt_data.on = on;
	sen_pack.set_imgtxt_data.zoomFactor = (int)zoom;
	sen_pack.set_imgtxt_data.targetSetup = (int)targSetup;

	/* box describes screen extent of next text object to be displayed */
	sen_pack.set_imgtxt_data.imageBox[0].x = pt0->x;
	sen_pack.set_imgtxt_data.imageBox[0].y = pt0->y;
	sen_pack.set_imgtxt_data.imageBox[1].x = pt1->x;
	sen_pack.set_imgtxt_data.imageBox[1].y = pt1->y;
	sen_pack.set_imgtxt_data.imageBox[2].x = pt2->x;
	sen_pack.set_imgtxt_data.imageBox[2].y = pt2->y;
	sen_pack.set_imgtxt_data.imageBox[3].x = pt3->x;
	sen_pack.set_imgtxt_data.imageBox[3].y = pt3->y;

    TmSenMes(sen_pack.sen_buf, sen_pack.set_imgtxt_data.pack_len, TMNOHURRY,
				NULLP, 0);

    return TMR_OK;
}


