/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxterm.c
   Applix ASC version: 4
   Date: Fri Apr 30 21:12:59 1999
*/
#include <fcntl.h>
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parwin.h>

extern char TmIsLIwin[TM_MAXWIN];   /* array of booleans initially all FALSE */
extern short TmLIcount;             /* # line input windows in existence */
extern short TmDummy;
extern char ComEnable;      /* the -e switch is present */
extern short THIMpid;

/*************************************************************************
function: TmTerm - Close a window
*/
typeErr TmTerm(window_id)
short window_id;
{
    union
    {
        struct STermData term_data;
        char sen_buf[sizeof (struct STermData)];
    } sen_pack;

    if (TmDummy)
        return TMR_OK;

    if(!TmOpFlag) return(TMR_OWN);
    if (!TmValWin(window_id, FALSE)) return TMR_NOWIN;
    sen_pack.term_data.event_indicator = QATM_TERM;
    sen_pack.term_data.window_id = window_id;
    sen_pack.term_data.pack_len = sizeof(struct STermData);
    if (TmIsLIwin[window_id])   /* reset line input window flag */
    {
        TmIsLIwin[window_id] = FALSE;
        TmLIcount--;
    }
    sen_pack.term_data.pendFlag = 0;
    TmSenMes(sen_pack.sen_buf, sen_pack.term_data.pack_len, TMHURRY, NULLP, 0);

    return(TMR_OK);
}
