/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxwrite.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:40 1998
*/
#include <fcntl.h>
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parout.h>

extern char TmIsLIwin[];        /* line input window booleans */
extern short TmDummy;           /* dummy runtime mode */

/*************************************************************************
function: TmWriteTx - Paint some text to a window
*/
typeErr TmWriteTx(window_id,x_position,y_position,absrel,byte_count,string,
    attr_string)
short window_id;
short x_position;
short y_position;
short absrel;
short byte_count;
char *string;
TmTextDescriptor *attr_string;

{
    union
    {
        struct SWriteTxData write_tx_data;
        char sen_buf[SEN_BUF_SIZE];
    } sen_pack;

    short i, discard;
    short attrSlen;
    int cc;
    char *bufp;

    if(!TmOpFlag) TmOpATM();
    if (!TmValWin(window_id, FALSE)) return TMR_NOWIN;

    if(attr_string == NULL)
        attrSlen = 0;
    else
        attrSlen = (attr_string[0]*2+1)*sizeof(TmTextDescriptor);
    if(byte_count == -1)
    {
        byte_count = strlen(string);
    }
    if (byte_count < 0 || attrSlen < 0) return TMR_PARM;
    if (byte_count > MAX_TX_COUNT) return TMR_LONG;

    if (TmIsLIwin[window_id])                       /* line input window */
    {
        if (absrel != PROMPT_FLAG) return TMR_OK;   /* prompts only */
    }
    sen_pack.write_tx_data.byte_count = byte_count;
    sen_pack.write_tx_data.event_indicator = QATM_WRITE_TX;
    sen_pack.write_tx_data.pack_len = sizeof(struct SWriteTxData) + byte_count
                                    + attrSlen;

    sen_pack.write_tx_data.window_id = window_id;
    sen_pack.write_tx_data.x_position = x_position;
    sen_pack.write_tx_data.y_position = y_position;
    sen_pack.write_tx_data.absrel = absrel;
    sen_pack.write_tx_data.attrSlen = attrSlen;
    bufp = &sen_pack.sen_buf[sizeof(struct SWriteTxData)];
    memcpy(bufp,string,sen_pack.write_tx_data.byte_count);
    bufp += sen_pack.write_tx_data.byte_count;
    memcpy(bufp,attr_string,attrSlen);

    TmSenMes(sen_pack.sen_buf, sen_pack.write_tx_data.pack_len, TMNOHURRY, NULLP,0);

    return(TMR_OK);
}
