/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winsh.c
   Applix ASC version: 1
   Date: Mon Nov 16 13:53:27 1998
*/
#include <windows.h>
#include <shlobj.h>

#include <winsh.p>

/* move to winmap.h! */
#define MS_WideCharToMultiByte	WideCharToMultiByte




int
axmsGetDrivesFolderName(char *name, int buf_size)
{
	int retval;
    LPSHELLFOLDER lpsf=0;
    LPITEMIDLIST  lpi=0;
    HRESULT hr;

	/* first, get an interface pointer to the desktop folders */
    hr = SHGetDesktopFolder(&lpsf);
	/* next, get the location of a certain folder, namely the "Drives"
	 * folder, which is "My Computer" by default.
	 */
	hr = SHGetSpecialFolderLocation((HWND)NULL, CSIDL_DRIVES, &lpi);
	/* retrieve the string name of the Drives folder. */
	retval = axmsGetName(lpsf, lpi, SHGDN_NORMAL, name, buf_size);
	return retval;
}


/***
Stolen from the Microsoft ENUMDESK sample
***/
static int 
axmsGetName(LPSHELLFOLDER lpsf,
			LPITEMIDLIST  lpi,
			DWORD         display_type,
			LPSTR         lpFriendlyName,
			int			  buf_size)
{
	int   retval=TRUE;
	STRRET str;

	if ( lpsf->lpVtbl->GetDisplayNameOf(lpsf,lpi,display_type,&str) == NOERROR )
		{
		switch (str.uType)
			{
			case STRRET_WSTR:
				MS_WideCharToMultiByte(CP_ACP,              // CodePage
									0,						// dwFlags
									str.pOleStr,            // lpWideCharStr
									-1,                     // cchWideChar
									lpFriendlyName,         // lpMultiByteStr
									buf_size,				// cchMultiByte,
									NULL,                   // lpDefaultChar,
									NULL);                  // lpUsedDefaultChar

			break;

			case STRRET_OFFSET:
				lstrcpy(lpFriendlyName, (LPSTR)lpi+str.uOffset);
				break;

			case STRRET_CSTR:
				lstrcpy(lpFriendlyName, (LPSTR)str.cStr);
				break;

			default:
				retval = FALSE;
				break;
			}
		}
	else
		retval = FALSE;

   return retval;
}
