/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winwdgts.h
   Applix ASC version: 113
   Date: Mon Nov 16 13:53:38 1998
*/
#ifndef _WINWDGTS_H 
#define _WINWDGTS_H 
                 

#include <amenudef.h>

#define MK_CHANGED  0x0016  /* mouse cursor changed.. here for now! */

/* define the lowest Windows Unique-ID used for widgets                */
/* the unique ID's for menu bar items must all be less than this value */
#define FIRST_WIDGET_ID 1000    
#define FIRST_MENU_ID 1

/* FLAGS values: */

#define AXWF_INACTIVE 0x08
#define AXWF_NODISPLAY 0x01

/* include the common widget structure */
#include <xwidgets.h>

extern DLL_IMPORT axw_dialog *WXDlgList;   /* Linked list of all dialogs */

axw_menu *AxCrtMenuStructFromId();

/* The following are structures and deines to get from a unique id */
/* which is returned as part of a window event, to the corresponding */
/* widget structure.  We do this by setting the unique-id to an index */
/* into a table of widget pointers.  Thus, you can get from the unique-id */
/* to the widget pointer with a single dereference                    */
extern DLL_IMPORT AXWidget *WidgetUIDList;
UINT GetAvailableUID();

#define WIDGET_FROM_UID( uid )  \
      ( (WidgetUIDList && (uid >= FIRST_WIDGET_ID)) ? \
      ((AXWidget)(*(WidgetUIDList+(uid-FIRST_WIDGET_ID)))) : (AXWidget)NULL );

#define CLEAR_WIDGET_FROM_UID_LIST( uid ) \
      { if ( WidgetUIDList && (uid >= FIRST_WIDGET_ID) ) \
            *(WidgetUIDList+(uid-FIRST_WIDGET_ID)) = (AXWidget)NULL; }


/**************************************************************************/
/*** The following are "package drawable" defines to allow us to keep track
	 of the different types of drawing contexts we can have.
	 (see AxPackageHandle in winutl.c).                   -donato
 ***/
typedef struct _drawable_list_t {
    short type;
    HANDLE handle;
} drawable_list_t;
 
extern DLL_IMPORT drawable_list_t *DrawableList;
extern DLL_IMPORT UINT DrawableListSize; /* number of "drawable_list_t" units */
 
#define AX_HWND_TYPE    1
#define AX_BITMAP_TYPE  2
#define AX_DC_TYPE      3
#define AX_MEMDC_TYPE   4
 
#define AX_PACKAGE_BIT 0x80000000

#define DEBUG_PACKAGED_HANDLES 0

#if DEBUG_PACKAGED_HANDLES    /*  {  */

int IsPackagedHandle( HANDLE ix );
int GetDrawableType( HANDLE ix );
HANDLE GetDrawableHandle( HANDLE ix );
void RemovePackagedDrawable( HANDLE ix );
#define IS_PACKAGED_DRAWABLE(ix) IsPackagedHandle( ix )
#define GET_DRAWABLE_TYPE(ix) GetDrawableType( ix )
#define GET_DRAWABLE_HANDLE(ix) GetDrawableHandle( ix )
#define REMOVE_DRAWABLE(ix) RemovePackagedDrawable( ix )

#else         /*  }  {  */
   /* A "packaged" handle is indicated by the high bit being set, and */
   /* the fact that the rest of the word is a valid array index into the */
   /* global table of packaged handles, and if all that is true, that the*/
   /* packaged array element we are looking at is still in use           */

#define IS_PACKAGED_DRAWABLE(ix) ( ((UINT)ix & AX_PACKAGE_BIT) && \
   (((UINT)ix & ~AX_PACKAGE_BIT)/sizeof(*DrawableList) < DrawableListSize) && \
   ( ((DrawableList+((UINT)ix & ~AX_PACKAGE_BIT))->type) > 0 ) )
 
#define GET_DRAWABLE_TYPE(ix) \
        ((DrawableList+((UINT)ix & ~AX_PACKAGE_BIT))->type)
 
#define GET_DRAWABLE_HANDLE(ix) \
        ((DrawableList+((UINT)ix & ~AX_PACKAGE_BIT))->handle)
 
#define REMOVE_DRAWABLE(ix) \
        memset( (char *)(DrawableList+((UINT)ix & ~AX_PACKAGE_BIT)), 0, \
                 sizeof(*DrawableList) )
#endif   /*  }   */
/**************************************************************************/

#endif /* _WINWDGTS_H */ 

