/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winwidgt.c
   Applix ASC version: 318
   Date: Tue Feb  2 15:20:34 1999
*/
#define OEMRESOURCE    /* needed to get Windows Bitmap defines */

#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <basicwin.h>
#include <ax_xm.h>
#include <aos.h>
#include <paripc.h>
#define AX_NT_TIMEV_DEFINED 1
#include <thimble.h>
#include <xmlib.h>
#include <xmpixel.h>
#include <xmtable.h>
#include <elf.h>
#include <elxwins.h>
#include <evreason.h>
#include <xmtray.h>
#include <xmchoose.h>
#include <dwt2xm.h>
#include <xmdlged.h>
#include <aiconids.h>
#include <axwinclr.h>
#include <editmask.h>


#define STRALLOC(s) strcpy(malloc(strlen(s)+1),s)

#define WIN_RADIO_WIDTH_PAD  5
#define WIN_RADIO_HEIGHT_PAD 20
#define WIN_RADIO_TITLE_PAD  10
#define DEFAULT_TOOL_BUTTON_WIDTH 29
#define TOGGLE_WIDTH 13
#define STD_OPTION_HYT_PAD 7
#define STD_OPTION_LAB_PAD 2
#define STD_OPTION_YSHIFT 3      /* offset for label */

#define GE_PAGE_WIDTH   136

extern int RunningWin95Look;
extern Cursor ThimPointerCursor;
extern int AxNoFocusManage;
extern int Scrollbar_Thickness;
extern int Entry_Height;
extern int Option_Pad;
extern HANDLE hInst;
extern GC BackGC, ForeGC;
extern PIXEL_VALUE RecessPixel;
extern PIXEL_VALUE RecessPixelRGB, BackWorkPixelRGB;
extern PIXEL_VALUE BackPixel, BackWorkPixel;
extern PIXEL_VALUE SunPixel, ShadowPixel;
extern PIXEL_VALUE ButtonFacePixel, ForePixel, HiliteTextPixel;
extern int AxCharHeight, AxCharAbove;
extern int NtLineHeight;
extern HWND WXDummyWnd;
extern AXWidget TotalWidgetsList;    /* for resource tracking */ 
extern int NumWidgets; 
extern int NumWindows; 
extern int WidgetNeedsUpdated;       /* Set when a widget needs repainted */
extern AXWidget WindowList;
extern XFontStruct *AxDlgMainFont;   
extern XFontStruct *AxDlgMiniFont;
extern XFontStruct *AxStatusLineFont;
extern XFontStruct *MonospaceFont;

extern int ToolbarExtraSep;
extern int BorderWidth;
extern int BorderHeight;

extern HFONT NormalDialogFont;


#if 0    /* save for possible future use? */
/**************************************************************
 * the following are subclass procs for some widgets.
 * for now only dialog editor Windows widgets are subclassed.
 * this is necessary so we can pass the button-down event to 
 * the dialog and begin any move or resize processing.  
 **************************************************************/
WNDPROC OldListProc, OldEnterProc, OldEditboxProc;
WNDPROC OldToggleProc, OldOptionProc;
extern LRESULT CALLBACK ListEventProc(HWND, UINT, WPARAM, LPARAM); 
extern LRESULT CALLBACK EnterEventProc(HWND, UINT, WPARAM, LPARAM); 
extern LRESULT CALLBACK EditboxEventProc(HWND, UINT, WPARAM, LPARAM); 
extern LRESULT CALLBACK ToggleEventProc(HWND, UINT, WPARAM, LPARAM); 
extern LRESULT CALLBACK OptionEventProc(HWND, UINT, WPARAM, LPARAM); 
/**************************************************************/
#else
WNDPROC OldEnterProc, OldEditboxProc, OldListProc;
extern LRESULT CALLBACK EnterEventProc(HWND, UINT, WPARAM, LPARAM); 
extern LRESULT CALLBACK EditboxEventProc(HWND, UINT, WPARAM, LPARAM); 
extern LRESULT CALLBACK ListEventProc(HWND, UINT, WPARAM, LPARAM); 
#endif

extern LRESULT CALLBACK TableClassProc(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK TrayClassProc(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK CanvasClassProc(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK ColorChooserClassProc(HWND, UINT, WPARAM, LPARAM);

typedef struct rm_info {
    int n;
    char **strings;
    char **macros;
    char **argArray;
    int  *ungrey;
} rm_info;

#include <winwidgt.p>





/**************************************************************
 FUNCTION: RealizePushButton - create a push button window.
***/
void
RealizePushButton(AXWidget_pushbutton pb, BOOL use_menu_id)
{
    long wstyle = WS_CHILD;
    long tab_style = WS_TABSTOP;
    long button_style = BS_PUSHBUTTON | BS_NOTIFY;
    pixcache_t *pix_cacheP;
    HMENU menu_uid;
    AXWidget_pushbutton def_pb;
	char *disp_name;

    WIDGET_PARANOID(pb, W_BUTTON);
    /* if button's parent hasn't been created (probably because this *
     * is an instance of a windowless app) do nothing and return.    */
    if ( !pb->parent->winid )
        return;
    if ( pb->style == W_POPUP )
        {
        /* the button is actually a popup widget in disguise. In its "idle"
         * state it resembles a button, but when it is clicked a window
         * is popped up, so we can't actually create a button. Just set
         * some values and return.              -donato
         */
        pb->winid = (HWND)-1;
        pb->owner_draw = TRUE;
        return;
        }

    /* if no thickness, set a default for now */
    if ( !pb->thickness )
        pb->thickness = 2;

    /* a dialog button will (should) already have a uid, *
     * but make sure we have one for non-dialog buttons. */
    if ( !pb->uid )
        pb->uid = GetAvailableUID((AXWidget)pb);

    if ( use_menu_id )
        menu_uid = (HMENU)pb->menu_uid;
    else
        menu_uid = (HMENU)pb->uid;

    /* get default button, if applicable. */
    if ( pb->parent->type == W_DIALOG )
        def_pb = ((AXWidget_dialog)pb->parent)->currentDefaultButton;
    else
        def_pb = NULL;

    /* if we are creating a new button and its value is 1, then its state
     * is down.  However, normal Windows pushbuttons cannot be
     * set to the down position, so we make it an owner_draw button,
     * regardless of pixmap.            -donato
     */
    if ( pb->value )
        pb->owner_draw = TRUE;

	axmsPutMnemonicInString(pb->name, pb->accelerator_key, &disp_name);

    if ( !pb->pixmapLabel && !pb->pixmap &&
            !pb->widgetColor && !pb->textColor &&
            !pb->shadow && !pb->textShadow &&
            !pb->owner_draw )
        {
        /* if this is the default pushbutton, use appropriate style. */
        if ( def_pb && (def_pb->uid == pb->uid) )
            button_style = BS_DEFPUSHBUTTON;

        /* normal text button */
        pb->winid = MS_CreateWindow(NXLT("BUTTON"), disp_name,
                                     wstyle | tab_style | button_style | WS_GROUP,
                                     pb->xpos, pb->ypos,
                                     pb->width, pb->height,
                                     pb->parent->winid, menu_uid,
                                     (HANDLE)NULL, (LPVOID)NULL);
        MS_SendMessage( pb->winid, WM_SETFONT, 
                                       (WPARAM)NormalDialogFont, (LPARAM)0 );

        /* if the font is not the standard dialog font, set it */
        if ( pb->winid && pb->font && (pb->font != AxDlgMainFont) )
            MS_SendMessage(pb->winid, WM_SETFONT, (WPARAM)pb->font->fid, TRUE);

        if ( pb->winid && ( (*(pb->name) & 0xFF) == 0xFF) )
            /* there seems to be a bug in windows, that if we supply a name */
            /* which consists of the string 0xFF (the last button on the    */
            /* group-2 special chars dialog) then Windows gives us garbage  */
            /* on the button.  IT works OK if we explicitly set the text    */
            /* however, so here we go ...                                   */
            MS_SendMessage(pb->winid, WM_SETTEXT, (WPARAM)0, (LPARAM)pb->name);
        }
    else
        {
        /* "ownerdraw" bitmap button */
        button_style = BS_OWNERDRAW;
        pb->winid = MS_CreateWindow(NXLT("BUTTON"), disp_name,
                                     wstyle | tab_style | button_style,
                                     pb->xpos, pb->ypos,
                                     pb->width, pb->height,
                                     pb->parent->winid, menu_uid,
                                     (HANDLE)NULL, (LPVOID)NULL);
        pb->owner_draw = TRUE;

        pb->pixmap   = (Pixmap)NULL;
        pb->pix_mask = (Pixmap)NULL;
        if ( pb->pixmapLabel )
            {
            /* set up the normal and inverted pixmaps for this button */
            pix_cacheP = (pixcache_t*) Pixmapper(pb->name);
            if ( pix_cacheP )
                {
                pb->pixmap   = pix_cacheP->pix;
                pb->pix_mask = pix_cacheP->clip_mask;
                }
            }
        }

	free(disp_name);
    if ( pb->winid )
        {
        MS_ShowWindow(pb->winid, pb->display);
        if ( pb->disabled )
            /* gray out button */
            MS_EnableWindow(pb->winid, FALSE);
        else
            /* enable button */
            MS_EnableWindow(pb->winid, TRUE);

#if 0
        if ( def_pb && (def_pb->uid == pb->uid) )
			{
            MS_SendMessage(pb->winid, BM_SETSTYLE,
                            (WPARAM)LOWORD(BS_DEFPUSHBUTTON),
                            MAKELPARAM(TRUE, 0));
			}
#endif

        /* set cursor class */
        MS_SetClassLong(pb->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        pb->mapped = TRUE;
        }
    else
        DebugMessage(NXLT("RealizePushButton: could not create button!"));
}



/**************************************************************
 FUNCTION: RealizeToolBarWidgets - create the toolbar buttons.
***/
void
RealizeToolBarWidgets(AXWidget_tool w)
{
    int ix;
    unsigned int separator = 0;
    AXWidget_pushbutton pb;
    long wstyle = WS_VISIBLE | WS_CHILD;
    menu_item_def *mP;


    WIDGET_PARANOID(w, W_TOOLBAR);
    for ( ix = 0; ix < MAX_TOOLBAR_ITEMS; ix++ )  /* MAX_TOOLBAR_ITEMS = 200 */
        {
        mP = w->toolBarInfo->menuP[ix];
        pb = (AXWidget_pushbutton) w->toolBarInfo->widgets[ix];
        if ( !pb )
            /* menu separators are null widgets in the array */
            continue;

        if ( mP && !mP->word[0] )
            {
            /* no menu item text; must be a dynamically added separator. */
            separator++;
            continue;
            }

        if ( separator )
            {
            /* add the default toolbar button width to the xpos to  *
             * create a "tool button space" to mimic menu separator.*/
            pb->xpos += (ToolbarExtraSep * separator);
            }           

        /* the menu_uid is used to tie the toolbar button to its       *
         * corresponding menu item function. it is passed to the       *
         * MS_CreateWindow call so that Windows passes this id when    *
         * a WM_COMMAND message is received. however, we cannot use    *
         * this id to obtain the widget in order to draw it, because   *
         * it is a menu id and not part of the global widget UID list. *
         * so we must get an id for this widget from the global list   *
         * so that we can obtain the widget id when needed.            */
        pb->menu_uid = GetUIDfromMenu(w->parent->menuBar,mP->word,mP->word2);
        RealizePushButton(pb, TRUE);
        }
}


/*****************************************************************
 FUNCTION: RealizePaletteButtons - create the GE palette buttons.
***/
void
RealizePaletteButtons(AXWidget_palette pal)
{
    AXWidget_pushbutton pb;

    WIDGET_PARANOID(pal, W_PALETTE);
    for ( pb = (AXWidget_pushbutton)pal->widgets; pb;
                pb = (AXWidget_pushbutton)pb->nextChild )
        {
        /* note the list box widget when found */
        if ( pb->type != W_BUTTON || !pb->display )
            continue;
        if ( !pb )    /* menu separators are null widgets in the array */
            continue;

        RealizePushButton(pb, FALSE);
        }
}



/** this function finds all the dialog widgets associated with an *
 ** app and NULLs their window handles. it is ONLY called when an *
 ** app is being destroyed so we can "tag" its dialogs. see comment *
 ** in WXDestroyWidget. We need to do this because when an app that *
 ** has dialogs still running is destroyed, the dialogs are destroyed *
 ** AFTER its parent.                -donato                          */
static void
DestroyDialogChildren(AXWidget_main parent)
{
    int ix, size_list;
    HWND *listP;
    AXWidget_dialog w_dlg;


    size_list = (int) *parent->dialogHWNDlist;
    listP = parent->dialogHWNDlist + 1;
    for ( ix = 1; ix < size_list; ix++ )
        {
        if ( *listP )
            {
            /* first, find dialog widget. */
            /* we actually find the dialog's "shell" (main widget). */
            w_dlg = (AXWidget_dialog)GetWidgetFromHWND(*listP, W_MAIN);
            /* set its window handle to NULL. */
            if ( w_dlg )
                {
                MS_DestroyWindow(w_dlg->winid);
                w_dlg->winid = NULL;
                }
            }
        listP++;
        }
}

static BOOL
RemoveDialogFromHWNDlist(AXWidget_main parent, HWND hwnd)
{
    int ix, size_list;
    HWND *listP;
    BOOL retval;

    retval = FALSE;
    size_list = (int) *parent->dialogHWNDlist;
    listP = parent->dialogHWNDlist + 1;
    for ( ix = 1; ix < size_list; ix++ )
        {
        if ( *listP == hwnd )
            {
            /* clear entry */
            *listP = (HWND)NULL;
            retval = TRUE;
            break;
            }
        listP++;
        }
    return retval;
}


void AxXtDestroyWidget(AXWidget w)
{
    WXDestroyWidget(w);
}

/*************************************************************************
function: WXDestroyWidget - Free up widget resources
*/
void
WXDestroyWidget(AXWidget w)
{
    int ix;
    int inEdit, wasObject;
    AXWidget childP, next;
    AXWidget_main mw;
    AXWidget_list w_list;
    AXWidget_menu w_menu;
    AXWidget_rect w_rect;
    AXWidget_tool w_tool;
    AXWidget_tray w_tray;
    AXWidget_radio w_radio;
    AXWidget_entry w_enter;
    AXWidget_popup w_popup;
    AXWidget_option w_option;
    AXWidget_canvas w_canvas;
    AXWidget_dialog w_dialog;
    AXWidget_rowcol w_rowcol;
    AXWidget_ribbon w_ribbon;
    AXWidget_buttonbar w_buton;
    AXWidget_pushbutton w_button;
    AXWidget_color_chooser w_choose;
    menu_item_def *mP;


    if ( !w )
        return;

    if ( w->destroyed )
        return;                    /* !! just touched dead memory */
    w->destroyed = TRUE;

    AXmClearGlobalWidgetHandle(w);

    inEdit = (w->flags & WFLG_IN_EDIT); /* true under dialog editor */
    if ( inEdit )
        deRemoveFromSession(w);
    
    /* from back-to-front position list */
    deleteWlayer((AXWidget_dialog)w->parent, w);

    /* Unthread for total widgets list */
    if ( w->next )
        w->next->prev = w->prev;
    if ( w->prev )
        w->prev->next = w->next;
    if ( TotalWidgetsList == w )
        TotalWidgetsList = w->next;

    NumWidgets--;
    RemoveWidgetFromParent(w);
    AxWinDeleteWidgetDrawable(w);
#if 0
    if ( w->font )
        {
        FreeFontInCache(w->font);
        w->font = NULL;
        }
#endif
    if ( w->db_uid )
        {
        if ( w->parent && w->parent->type == W_DIALOG )
            {
            w_dialog = (AXWidget_dialog) w->parent;
            if ( w_dialog->uidWidgets )
                {
                axhTossItemI((void *) &w->db_uid, sizeof(int),
                             w_dialog->uidWidgets, (char *) NULL);
                }
            }
        }

    if ( w->tabctl_linktab )
        {
        axhDeleteTable(w->tabctl_linktab, (void *) TRUE);
        free(w->tabctl_linktab);
        w->tabctl_linktab = (axhtab *) NULL;
        }
	if (w->keyFocusLinks) {
		free(w->keyFocusLinks);
		w->keyFocusLinks = NULL;
	}

    /* event_table and aux data currently used for widget editing */
    if ( w->event_table )
        xmRemoveAllEventHandlers(w);
    if ( w->auxData )
        removeAuxData(w);

    /* free's the ref, not the object */
    if ( w->elfObject )
        {
        char *ov_name;
        elf_obj_grp *ov, *ElfObjData();

        ov_name = NXLT("WIDGET_PTR$$");
        ov = ElfObjData(ElfObjPtr(w->elfObject), ov_name, hash(ov_name));

        if (ElfbIsArray(ov->value) &&
            (w == WidgetPointerFromHandleData(ReadArray((data_array*)ov->value,0)))) {
            ;    /* skip first element in 2-object widgets, free later */
        }
        else {
            AxTaskFreeElfData(0,ov->value);
            ov->value = NULL;
        }

        /* free's the ref, not the object */
        AxTaskFreeElfData(0, w->elfObject);
        w->elfObject = NULL;
        wasObject = TRUE;
        }
    else
        wasObject = FALSE;

    if ( w->type != W_MAIN )
        FreeWidgetName(w);

    if ( w->shadow )
        {
        AxTaskFreeElfData(0, w->shadow);
        w->shadow = NULL;
        }
    if ( w->textShadow )
        {
        AxTaskFreeElfData(0, w->textShadow);        
        w->textShadow = NULL;
        }
    if ( w->textColor )
        AxFreeWColor(w->textColor);
    w->textColor = NULL;

    if ( w->widgetColor )
        AxFreeWColor(w->widgetColor);
    w->widgetColor = NULL;

    if ( w->graphic )
        AxDestroyAssociatedGraphic(w->graphic);
    w->graphic = NULL;

    if ( w->rminfo )
        xmDestroyRmInfo((rm_info*)w->rminfo);
    w->rminfo = NULL;

    if ( w->helpstr )
        {
        free( w->helpstr );
        w->helpstr = NULL;
        }
        


    switch (w->type)
        {
    case W_MAIN:
        mw = (AXWidget_main)w;
        FreeWidgetName((AXWidget)mw);
        ClipFromWindowList((AXWidget)mw);
        /* if this is a dialog with a valid window handle and it has *
         * a parent, remove it from the dialog handle list. -donato  */
        if ( mw->dialog && mw->winid && mw->parent )
            {
            if ( !RemoveDialogFromHWNDlist(mw->parent, mw->winid) )
                DebugMessage(NXLT("Could not clear dialog from list!"));
            }

        WXDestroyWidget((AXWidget)mw->workWindow);
        WXDestroyWidget((AXWidget)mw->menuBar);
        WXDestroyWidget((AXWidget)mw->toolBar);
        WXDestroyWidget((AXWidget)mw->vScrollBar);
        WXDestroyWidget((AXWidget)mw->hScrollBar);
        WXDestroyWidget(mw->corner);
        WXDestroyWidget((AXWidget)mw->statusArea);
        WXDestroyWidget((AXWidget)mw->pageBar);
        WXDestroyWidget((AXWidget)mw->palette);
        WXDestroyWidget((AXWidget)mw->colorpal);
        WXDestroyWidget((AXWidget)mw->debug);
        WXDestroyWidget((AXWidget)mw->ruler);
        WXDestroyWidget((AXWidget)mw->plates);
        WXDestroyWidget((AXWidget)mw->dialog);
        WXDestroyWidget((AXWidget)mw->ge_xruler);
        WXDestroyWidget((AXWidget)mw->ge_yruler);
        WXDestroyWidget((AXWidget)mw->butonBar);

        if ( mw->dialogHWNDlist )
            {
            /* we are destroying an app window. if it still has dialogs *
             * up we need to somehow "tag" those dialogs. otherwise,    *
             * when the software goes to destroy them it will hit the   *
             * code above and attempt to remove the dialog handle from  *
             * its parents list, except the parent has already been     *
             * destroyed (free'd!)                       -donato        */
            DestroyDialogChildren(mw);
            TrueFree((char*)mw->dialogHWNDlist);
            }

        free(mw->wstr);
        if ( mw->iconPixmap )
            XFreePixmap((Display*)NULL, mw->iconPixmap);
        /* destroy "custom" icon (i.e. one that was created thru
         * the GDI), if one exists.
         */
        DeleteIconFromCache(mw->style);

        /* as a final cleanup, destroy the main window, which will also */
        /*   destroy any children */
        if ( mw->winid )
            {
            MS_DestroyWindow(mw->winid);
            mw->winid = NULL;
            }
        /* now give focus to parent if one exists. */
        /* If user has preference set to "let window manager decide focus",
         * AxNoFocusManage will be true and we let Windows set the focus
         * (seems to choose last window that had focus).   -donato
         */
#if 0
        if ( mw->dialog && mw->parent && !AxNoFocusManage )
            MS_SetActiveWindow(mw->parent->winid);
#endif
        break;


    case W_DIALOG:
        w_dialog = (AXWidget_dialog)w;
        if ( WidgetUIDList )
            CLEAR_WIDGET_FROM_UID_LIST(w->uid);
        DestroyDialog(w_dialog, wasObject);
        return;


    case W_LABEL:
    case W_TOGGLE:
        if ( w->helpstr )
            free(w->helpstr);
        break;


    case W_PAGEBAR:
        w->parent->pageBar = NULL;
        ClipFromWindowList(w);
        break;


   case W_BUTBAR:
        w_buton = (AXWidget_buttonbar)w;
        for ( ix = 0; ix < w_buton->num_buttons; ix++ )
            {
            FreeWidgetName((AXWidget)w_buton->buttons[ix]);
            WXDestroyWidget((AXWidget)w_buton->buttons[ix]);
            free(w_buton->buttons[ix]);
            }
        free(w_buton->buttons);
        w_buton->parent->butonBar = NULL;
        ClipFromWindowList((AXWidget)w_buton);
        break; 


    case W_BUTTON:
        w_button = (AXWidget_pushbutton)w;
        if ( w_button->alternatePixmap )
            free(w_button->alternatePixmap);
        if ( w_button->helpstr )
            free(w_button->helpstr);
        break;
 

    case W_TABLE: 
        {      
        register table_info *wt;
        AXWidget_table w_table;  

        w_table = (AXWidget_table)w;
        wt = (table_info *) w_table->info.table;
        
        FreeTableInfo(wt);
        if ( wt->fontFamily )
            free(wt->fontFamily);
        if ( wt->cursor.wtext )
            free(wt->cursor.wtext);
        if ( wt->selected_rows )
            free(wt->selected_rows);
        TblFreeGCs(w_table);    /* requires `wt' */
        free(wt);

        if ( !w_table->window )
            {
            /* If we don't have a table window (device context) then it
             * was most likely removed when the dialog was destroyed and
             * Windows cleaned up its children. So we null out the scrollbar
             * window handles since they have become invalid.   -donato
             */
            if ( w_table->vScrollBar )
                w_table->vScrollBar->winid = NULL;
            if ( w_table->hScrollBar )
                w_table->hScrollBar->winid = NULL;
            }
        WXDestroyWidget((AXWidget)w_table->vScrollBar);
        WXDestroyWidget((AXWidget)w_table->hScrollBar);
        ClipFromWindowList((AXWidget)w_table);
        if ( w->helpstr )
            free(w->helpstr);   
        break; 
        } 
 

    case W_OPTION:
        w_option = (AXWidget_option)w;

        if ( w_option->strs )
            {
            for ( ix=0; ix < w_option->num_strs; ix++ )
                {
                if ( w_option->strs[ix] )
                   free(w_option->strs[ix]);
                }
            free(w_option->strs);
            }

        break;


    case W_TRAY:
        {        
        register tray_data *trayP;
        w_tray = (AXWidget_tray)w;
        trayP = (tray_data *) w_tray->info.tray;

        FreeTrayData(trayP);
        if ( trayP )
            free(trayP);

        if ( !w_tray->window )
            {
            /* If we don't have a tray window (device context) then it
             * was most likely removed when the dialog was destroyed and
             * Windows cleaned up its children. So we null out the scrollbar
             * window handles since they have become invalid.   -donato
             */
            if ( w_tray->vScrollBar )
                w_tray->vScrollBar->winid = NULL;
            if ( w_tray->hScrollBar )
                w_tray->hScrollBar->winid = NULL;
            }
        WXDestroyWidget((AXWidget)w_tray->vScrollBar);
        WXDestroyWidget((AXWidget)w_tray->hScrollBar);
        ClipFromWindowList((AXWidget)w_tray);
        if ( w->helpstr )
            free(w->helpstr);
        break;
        }


    case W_CHOOSE:
        {
        register chooser_data *cP;
        w_choose = (AXWidget_color_chooser)w;

        cP = (chooser_data *) w_choose->info.color_chooser;
        if ( cP )
            FreeChooserData(cP);
        cP = NULL;
        w_choose->info.color_chooser = NULL;

        WXDestroyWidget((AXWidget)w_choose->vScrollBar);
        WXDestroyWidget((AXWidget)w_choose->hScrollBar);
        ClipFromWindowList((AXWidget)w_choose);
        if ( w->helpstr )
            free(w->helpstr);
        break;
        }


    case W_CANVAS:
        w_canvas = (AXWidget_canvas)w;
        free(w_canvas->info.canvas);
        if ( !w_canvas->window )
            {
            /* If we don't have a canvas window (device context) then it
             * was most likely removed when the dialog was destroyed and
             * Windows cleaned up its children. So we null out the scrollbar
             * window handles since they have become invalid.   -donato
             */
            if ( w_canvas->vScrollBar )
                w_canvas->vScrollBar->winid = NULL;
            if ( w_canvas->hScrollBar )
                w_canvas->hScrollBar->winid = NULL;
            }
        WXDestroyWidget((AXWidget)w_canvas->vScrollBar);
        WXDestroyWidget((AXWidget)w_canvas->hScrollBar);
        ClipFromWindowList((AXWidget)w_canvas);
        if ( w->helpstr )
            free(w->helpstr);
        break;


    case W_LIST:
        w_list = (AXWidget_list)w;

        ClipFromWindowList((AXWidget)w_list);
        if ( w_list->let_windows_manage )
            /* there are no local strings */
            w_list->num_strs = 0;

        for ( ix = 0; ix < w_list->num_strs; ix++ )
            {
            if ( w_list->strs[ix] )
                free(w_list->strs[ix]);
            }
        free(w_list->strs);

        if ( w_list->helpstr )
            free(w_list->helpstr);
        free(w_list->selections);
        /* if we are here just to destroy a listbox (rather than  *
         * in the process of destroying a dialog) we need to make *
         * sure the window is destroyed.          -donato         */
        if ( w_list->winid && w_list->parent->winid )
            MS_DestroyWindow(w_list->winid);
        w_list->winid = NULL;
        break;


    case W_ENTER:
        w_enter = (AXWidget_entry)w;
        ClipFromWindowList((AXWidget)w_enter);
        free(w_enter->wstr);
        free(w_enter->validChars);
		if (w_enter->edit_win.editmask) {
			DeleteEditMask(w_enter->edit_win.editmask);
		}
        break;


    case W_EDITBOX:
        destroyEditBox((AXWidget_editbox)w);
        ClipFromWindowList(w);
        break;


    case W_RADIO:
        w_radio = (AXWidget_radio)w;

        if ( w_radio->parent->type != W_DIALOG )
            {
            for ( ix=0; ix < w_radio->num_buttons; ix++ )
                WXDestroyWidget((AXWidget)w_radio->buttons[ix]);
            }
        free(w_radio->buttons);
        break;


    case W_RECT:
        w_rect = (AXWidget_rect) w;
        if ( w_rect->tabctl.num_layers )
            {
            tablayer *tl;
            for ( ix=0; ix < w_rect->tabctl.num_layers; ix++ )
                {
                tl = &w_rect->tabctl.layerlist[ix];
                if ( tl->layerName )
                    free(tl->layerName);
                if ( tl->gadget_uids )
                    AxTaskFreeElfData(0, tl->gadget_uids);
                }
            free(w_rect->tabctl.layerlist);
            }
        break;

    case W_ICON:
    case W_ALIGN:
    case W_SPLITTER:
        break;


    case W_RULER:
        if ( WidgetUIDList )
            CLEAR_WIDGET_FROM_UID_LIST(w->uid);
        /* make sure window handle exists.            *
         * (may not if Words was started windowless). */
        if ( w->winid )
            MS_DestroyWindow(w->winid);
        /* this call will free everything */
        WpDestroyRulerWidget((AXWidget_ruler)w);
        w->uid = 0;
        /* we return so we don't free again at bottom of function. */
        return;


    case W_TOOLBAR:
        w_tool = (AXWidget_tool)w;
        for ( ix = 0; ix < MAX_TOOLBAR_ITEMS; ix++ )
            {
            mP = w_tool->toolBarInfo->menuP[ix];
            if (!mP)
                break;
            childP = w_tool->toolBarInfo->widgets[ix];
            WXDestroyWidget(childP);
            }

        if ( w_tool->toolBarInfo )
            free(w_tool->toolBarInfo);

        w_tool->parent->toolBar = NULL;
        ClipFromWindowList((AXWidget)w_tool);
        if ( w_tool->winid && w_tool->parent->winid )
            MS_DestroyWindow(w_tool->winid);
        break;


    case W_CORNER:
        while ( w->widgets )
            WXDestroyWidget(w->widgets); /* alters `w->widgets' */

        w->parent->corner = NULL;
        ClipFromWindowList(w);
        break;


    case W_STATUS:
        while ( w->widgets )
            WXDestroyWidget(w->widgets); /* alters `w->widgets' */

        w->parent->statusArea = NULL;
        ClipFromWindowList(w);
        break;
        

    case W_SCROLL:
        ClipFromWindowList(w);
        if ( w->winid )
            MS_DestroyWindow(w->winid);
        break;

    case W_WORK:
        {
        char class_name[25];
        ClipFromWindowList(w);
        if ( w->uid > 0 )
            /* this means we have an HTML window which created
             * its own temporary class based on a unique id.
             * We unregister it here.
             */
            {
            MS_GetClassName(w->winid, class_name, 25);
            MS_DestroyWindow(w->winid);
            MS_UnregisterClass(class_name, hInst);
            }
        break;
        }


    case W_MENUBAR:
        w_menu = (AXWidget_menu)w;
        ClipFromWindowList((AXWidget)w_menu); 
        FreeMenuBarItems(w_menu);
        break;
        

    case W_GE_XRULER:
    case W_GE_YRULER:
        ClipFromWindowList(w);
        break;


    case W_COLORPAL:
colorpal_start_again:
        for ( childP = w->widgets; childP; childP = next )
            {
            next = childP->nextChild;
            /* let list box (if an) destroy scroll bars */
            if ( childP->type != W_SCROLL )
                {
                WXDestroyWidget( childP );  /* recurse for child ribbons */
                goto colorpal_start_again;
                }
            } 
        ClipFromWindowList(w);
        break;


    case W_RIBBON:
        w_ribbon = (AXWidget_ribbon)w;
ribbon_start_again:
        for ( childP = w_ribbon->widgets; childP; childP = next )
            {
            next = childP->nextChild;
            if ( childP->type == W_OPTION )
                {
                WXDestroyWidget( childP );
                goto ribbon_start_again;
                }
            }
        free(w_ribbon->wstr );
        free(w_ribbon->selections );
        if ( w_ribbon->pixmap )
            {
            XFreePixmap( (Display*)NULL, w_ribbon->pixmap );
            w_ribbon->pixmap = (Pixmap)NULL;
            }

        ClipFromWindowList((AXWidget)w_ribbon);
        break;


    case W_ROWCOL:
        w_rowcol = (AXWidget_rowcol)w;
        if ( w_rowcol->buttons && w_rowcol->num_buttons )
            {
            for ( ix = 0; ix < w_rowcol->num_buttons; ix++ )
                {
                FreeWidgetName( (AXWidget)w_rowcol->buttons[ix] );
                if ( w_rowcol->buttons[ix] )
                    free(w_rowcol->buttons[ix]);
                }
            free(w_rowcol->buttons);
            }   

        if ( w_rowcol->num_buttons && w_rowcol->strs )
            {
            for ( ix = 0; ix < w_rowcol->num_buttons; ix++ )
                if ( w_rowcol->strs[ix] )
                    free(w_rowcol->strs[ix]);
            free(w_rowcol->strs);
            }
        break;        


    case W_POPUP:
        w_popup = (AXWidget_popup)w;

        for ( ix = 0; ix < w_popup->num_buttons; ix++ )
            {
            FreeWidgetName((AXWidget)w_popup->buttons[ix]);
            free(w_popup->buttons[ix]);
            }
        free(w_popup->buttons);
        ClipFromWindowList((AXWidget)w_popup);

        if ( w_popup->winid )
            MS_DestroyWindow(w_popup->winid);
        break;


    case W_DEBUG:
    case W_PLATES:
    case W_PALETTE:
debug_start_again:
        for ( childP = w->widgets; childP; childP = next )
            {
            next = childP->nextChild;
            /* Let the list box do scroll-bar destroy */
            if ( childP->type != W_SCROLL )
                {
                WXDestroyWidget(childP);
                goto debug_start_again;
                }
            }
        w->parent->debug = NULL;
        if( w->type == W_PLATES )
            w->parent->plates = NULL; 
        ClipFromWindowList(w);

        if ( (w->type == W_DEBUG || w->type == W_PLATES) && w->winid )
            MS_DestroyWindow(w->winid);
        break;


    case W_SCALE: 
        /* label destroyed by dialog */
        break;

    default:
        taskAbort("widget type error in WXDestroyWidget");
        }

    /* we check for existence of the uid list, because it will be NULL
     * in the case of invisible instances of widgets.
     */
    if ( WidgetUIDList )
        CLEAR_WIDGET_FROM_UID_LIST(w->uid);
    w->uid = 0;
    free(w);
}



/*************************************************************************
function: WXAddWidget - Add a widget to a dialog
*/
void
AxWinAddWidgetToParent(axw_widget *widget, AXWidget_dialog dialog,
                                                    int is_default)
{
    if ( !dialog || !widget )
        return;
    WIDGET_PARANOID(dialog, W_DIALOG);
    if ( widget->any.type == W_DIALOG || widget->any.type == W_WORK )
        taskAbort("WXAddWidget: bad widget type!");

    if ( !widget->any.uid )
        {
        /* if the widget does not have a unique id, then we are here *
         * on its initial creation, and need to add it the obj list. */
        widget->any.uid = GetAvailableUID((AXWidget)widget);
        widget->any.parent = (AXWidget_main)dialog;
        widget->any.parent_hwnd = dialog->winid;
        //widget->any.tabToThisHwnd = NULL;

#if 0
        /* add widget to dialog's parent (W_MAIN) */
        dialog->parent->num_objs++;
        dialog->parent->objs = (axw_widget**)realloc(dialog->parent->objs,
                            sizeof(axw_widget*) * dialog->parent->num_objs);
        dialog->parent->objs[dialog->parent->num_objs-1] = widget;
#endif

        if ( is_default )  /* set the default button in the dialog */
            dialog->defaultButton = (AXWidget_pushbutton)widget;
			dialog->currentDefaultButton = dialog->defaultButton;
        }
}


/*************************************************************************
function: WXAddToolBarToWidget - Add toolbar widget to main widget
*/
void
WXAddToolBarToWidget(AXWidget_tool w, AXWidget_main parent)
{
    WIDGET_PARANOID( w, W_TOOLBAR );
    WIDGET_PARANOID( parent, W_MAIN );
    if ( !w->uid )
        w->uid = GetAvailableUID((AXWidget)w);
    w->initial_paint = TRUE;
#if 0
    parent->num_objs++;
    parent->objs = (axw_widget**)realloc(parent->objs,
                                    sizeof(axw_widget*)*parent->num_objs);
    parent->objs[parent->num_objs-1] = w;
#endif
}



/* Strip out all of the 'control' information which is passed as part of the */
/*  list box strings. These are of the form "\[i,a,c](...)"    */
void Strip_Attr_Substrings(str)
char *str;
{
    char *p1, *p2, *end_p;

    p1 = p2 = str;

    while (*p2 != '\0')
        {
        if (*p2 == '\\' && *(p2 + 2) == '(' && (end_p = strchr(p2 + 4, ')')))
            {
            /* a substring to be eliminated */
            p2 = end_p + 1;
            }
        else
            {
            *p1++ = *p2++;
            }
        }
    *p1 = '\0';
    return;
}




AXWidget *WidgetUIDList = (AXWidget*)NULL;

/***********************************************************************/
/* find the next available place in the uid-to-widget mapping table,   */
/* put the passed widget pointer into that table, and return the index */
/***********************************************************************/
UINT 
GetAvailableUID(AXWidget w)
{
    register int i, size_list;
    register AXWidget *listP;

    if (WidgetUIDList == (AXWidget*) NULL)
        {
        /* initialize with a certain size.  We keep the current
         * available */
        /* size in the first element of the table, since we do not
         * allow */
        /* a unique-id value of zero                                     */
        WidgetUIDList = (AXWidget*)TrueMalloc(100 * sizeof(AXWidget));
        memset(WidgetUIDList, 0, (100 * sizeof(AXWidget)));
        *WidgetUIDList = (AXWidget) 100;
        }

try_again:
    size_list = (int) *WidgetUIDList;
    listP = WidgetUIDList + 1;
    for (i = 1; i < size_list; i++)
        {
        if (*listP == (AXWidget) NULL)
            {
            /* found an available entry */
            *listP = w;
            return (i + FIRST_WIDGET_ID);
            }
        listP++;
        }

    /* fell through, no available slots, realloc to meke some more room */
    WidgetUIDList = (AXWidget*)TrueRealloc((char *) WidgetUIDList,
                                 (size_list + 100)*sizeof(AXWidget));
    listP = WidgetUIDList + size_list;  /* where the new stuff begins */
    memset(listP, 0, (100 * sizeof(AXWidget))); /* clear the new entries */
    *WidgetUIDList = (AXWidget) (size_list + 100);
    goto try_again;
}


#define THREE_STATE_TOGGLE 3 /* Note must be > XmHORIZONTAL !! */
void
msPaintToggle(register AXWidget_togglebutton tb, int layered)
{
    unsigned int curr_wid, curr_hyt;
    int style = BS_NOTIFY | WS_TABSTOP | WS_GROUP;
    RECT rect;
    POINT point;
	char *disp_name;

    WIDGET_PARANOID(tb, W_TOGGLE);
    if ( layered )
        {
        if ( tb->flags & WFLG_IN_EDIT )
            {
            if ( dePaintWidget((AXWidget)tb) )
                return;
            }
        else
            {
            if ( (AXWidget_togglebutton)topWidget((AXWidget)tb) == tb )
                {
                paintCompositeWidget((AXWidget)tb, (XExposeEvent*)NULL, FALSE);
                return;
                }
            }
        }

	/* must have a parent! */
	if ( !tb->parent->winid )
		return;

    if ( tb->flags & WFLG_IN_EDIT )
        {
        PaintFakeToggle(tb);
        return;
        }

    if ( !tb->winid )
        {
        if ( tb->like_radio || tb->in_radio )
            {
            style |= BS_AUTORADIOBUTTON;
            tb->like_radio = TRUE;
            }
        else if ( tb->scroll_type == THREE_STATE_TOGGLE )
            style |= BS_AUTO3STATE;
        else
            style |= BS_AUTOCHECKBOX;

        if ( !tb->uid )
            tb->uid = GetAvailableUID((AXWidget)tb);        
		axmsPutMnemonicInString(tb->name, tb->accelerator_key, &disp_name);
        tb->winid = MS_CreateWindow( NXLT("BUTTON"), disp_name,
                                     WS_VISIBLE | WS_CHILD | style,
                                     tb->xpos, tb->ypos,
                                     tb->width, tb->height,
                                     tb->parent->winid, (HMENU)tb->uid,
                                     (HANDLE)hInst, (LPVOID)NULL);
		free(disp_name);

        if ( tb->winid )
            {
            tb->mapped = TRUE;
            if ( tb->font && (tb->font != AxDlgMainFont) )
                {
                MS_SendMessage(tb->winid,WM_SETFONT,(WPARAM)tb->font->fid,
                                                            (LPARAM)TRUE);
                }
            else
                {
                MS_SendMessage(tb->winid,WM_SETFONT,(WPARAM)NormalDialogFont,
                                                                (LPARAM)0);
                }
            }
        else
            DebugMessage(NXLT("msPaintToggle: could not create widget!"));
        }
    else
        {
        /* already been created. */
        /* move or re-size as necessary. */
        MS_GetWindowRect(tb->winid, &rect);
        point.x = rect.left;
        point.y = rect.top;
        MS_ScreenToClient(tb->parent->winid, &point);
        curr_wid = rect.right - rect.left;
        curr_hyt = rect.bottom - rect.top;
        if ( (tb->xpos != point.x) || (tb->ypos != point.y) ||
                (tb->width != curr_wid) || (tb->height != curr_hyt) )
            /* button has changed, move/resize it. */
            {
            MS_MoveWindow(tb->winid, tb->xpos, tb->ypos,
                            tb->width, tb->height, TRUE);
            }
        }

    if ( tb->disabled )
        {
        /* gray out widget. */
        MS_SendMessage(tb->winid, BM_SETCHECK, 0, 0L);
        MS_EnableWindow(tb->winid, FALSE);
        }
    else
        {
        /* set widget */
        MS_EnableWindow(tb->winid, TRUE);
        MS_SendMessage(tb->winid, BM_SETCHECK, tb->value, 0L);
        }

    MS_ShowWindow(tb->winid, tb->display);
	if ( tb->hasFocus )
		MS_SetFocus(tb->winid);

    /* we explicitly invalidate the whole button window to make sure all 
     * of it gets repainted. This should not be necessary but there are
     * cases in the widget code where we draw a rect over a Windows
     * widget without destroying it. Windows doesn't know (and why should it?)
     * that it has to repaint itself.    -donato
     */
    MS_InvalidateRect(tb->winid, (CONST RECT*)NULL, FALSE);

    /* set cursor class */
    MS_SetClassLong(tb->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
}



void
PaintOption(AXWidget_option w, XEvent *not_used, int regen, int layered)
{
    int x_fudge = 0, y_fudge = 0;
    int ix, label_wid, label_hyt;
    long tab_style = WS_TABSTOP;
    long option_style = WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL;
    RECT rect;
    int old_xpos, old_ypos, current_num_strs;
    unsigned int old_width, old_height;
    HFONT hfont;


    WIDGET_PARANOID(w, W_OPTION);    
    if ( layered )
        {
        if ( w->flags & WFLG_IN_EDIT )
            {
            if ( dePaintWidget((AXWidget)w) )
                return;
            }
        else
            {
            if ( (AXWidget_option)topWidget((AXWidget)w) == w )
                {
                paintCompositeWidget((AXWidget)w, (XExposeEvent*)NULL, regen);
                return;
                }
            
            }
        }
    
    if ( w->flags & WFLG_IN_EDIT )
        {
        PaintFakeOption(w);
        return;
        }

    if ( w->font )
        hfont = w->font->fid;
    else
        hfont = NormalDialogFont;

    if ( w->style == W_COMBO_BOX )
        label_wid = label_hyt = 0;
    else
        AxWinGetTextWidthAndHeight(hfont, w->name, &label_wid, &label_hyt);

    if ( w->parent->type == W_RIBBON )
        {
        /* this is the option menu on the GE color palette; *
         * it has the mini font, so reposition it.          */
        x_fudge = -2;
        y_fudge = 2;
        }
    if ( w->winid )    /* re-paint (e.g. when a widget is dragged */
        {              /* over an option menu).  */
        MS_GetClientRect(w->winid, &rect);
        MS_InvalidateRect(w->winid, &rect, FALSE);
        MS_UpdateWindow(w->winid);

        if ( w->update_widget )
            {
            /* first clear option menu */
            MS_SendMessage(w->winid, CB_RESETCONTENT, (WPARAM)0, (LPARAM)0);

            /* see if the option list window is in a new positon, or is */
            /*   a new width.  (The height is always constant )    */
            GetWindowSizeAndPos(w->winid, w->parent->winid,
                    &old_xpos, &old_ypos, &old_width, &old_height);

            if ( label_wid > 0 )
                {
                /* only add padding if we have a label */
                label_wid += STD_OPTION_LAB_PAD;
                }
            if ( (old_xpos != w->xpos+label_wid+x_fudge) || 
                            (old_ypos != w->ypos+y_fudge) ||
                            (old_width != w->width) )
                {
                /* resize it */
                MS_MoveWindow(w->winid, w->xpos + label_wid + x_fudge,
                               w->ypos + y_fudge,
                               w->width, w->pulldown_height, TRUE);
                if ( label_wid > 0 )
                    {
                    /* move/resize label also. */
                    MS_MoveWindow(w->labelid,w->xpos,w->ypos+STD_OPTION_YSHIFT,
                                                   label_wid, label_hyt, TRUE);
                    }
                }

            /* if we have a new string count, we need to reset the
             * pulldown height.
             */
            current_num_strs = MS_SendMessage(w->winid, CB_GETCOUNT, 0, 0L);
            if ( current_num_strs != w->num_strs )
                {
                MS_SetWindowPos(w->winid, (HWND)NULL, 0, 0, w->width,
                                    w->pulldown_height, SWP_NOMOVE);
                }

            /* then add new items */
            for (ix = 0; ix < w->num_strs; ix++)
                MS_SendMessage(w->winid, CB_ADDSTRING, (WPARAM)0,
                                            (LPARAM)(w->strs[ix]));
            if ( w->value < w->num_strs )
                MS_SendMessage(w->winid, CB_SETCURSEL, w->value, 0L);

            if ( w->disabled )
                {
                MS_EnableWindow(w->winid, FALSE);  /* gray out widget */
                MS_EnableWindow(w->labelid, FALSE); /* the label, too */
                }
            else
                {
                MS_EnableWindow(w->winid, TRUE);
                MS_EnableWindow(w->labelid, TRUE);
                }

            /* make sure we update the label widget too. */
            if ( w->labelid )
                {
                MS_InvalidateRect(w->labelid, (CONST RECT*)NULL, FALSE);
                MS_UpdateWindow(w->labelid);
                }
            }
        return;
        }

    /* create option menu. make sure parent has been created. */
    if ( w->parent->winid )
        {
        if ( label_wid > 0 )
            {
            /* draw label if necessary */
			char *disp_name;
			axmsPutMnemonicInString(w->name, w->accelerator_key, &disp_name);

            w->labelid = MS_CreateWindow(NXLT("STATIC"), disp_name,
                                    WS_CHILD | WS_VISIBLE | SS_LEFTNOWORDWRAP,
                                    w->xpos, w->ypos + STD_OPTION_YSHIFT,
                                    label_wid, label_hyt,
                                    w->parent->winid, //(HMENU)(w->uid - 1),
                                    (HMENU)NULL,
                                    (HANDLE)hInst, (LPVOID)NULL);
            label_wid += STD_OPTION_LAB_PAD;

            MS_SendMessage(w->labelid, WM_SETFONT, (WPARAM)hfont, 0L);
			free(disp_name);
            }

        if ( w->flags & WFLG_EDITABLE )     /* combo with edit widget */
            option_style |= CBS_DROPDOWN | CBS_AUTOHSCROLL;
        else
            option_style |= CBS_DROPDOWNLIST; /* without edit widget */

        if ( w->textColor || w->widgetColor || w->textShadow || w->shadow )
            option_style |= CBS_OWNERDRAWFIXED;

        if ( !w->uid )
            w->uid = GetAvailableUID((AXWidget)w);

        w->winid = MS_CreateWindow(NXLT("COMBOBOX"), w->name,
                                    option_style | tab_style,
                                    w->xpos + label_wid + x_fudge,
                                    w->ypos + y_fudge,
                                    w->width, w->pulldown_height,
                                    w->parent->winid, (HMENU)w->uid,
                                    (HANDLE)hInst, (LPVOID)NULL);

        if ( w->winid )
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)hfont, 0L);
            if ( w->parent->type == W_RIBBON )
                {
                /* this is the option menu on the GE color palette. *
                 * set its font to smallest one we have.            */
                MS_SendMessage(w->winid, WM_SETFONT,
#if 0
                                (WPARAM)AxDlgMiniFont->fid,
#else
                                (WPARAM)AxDlgMainFont->fid,
#endif
                                (LPARAM)FALSE);
                }
            if ( w->parent->type == W_RULER )
                {
                /* option menu on the WP ruler. set to our "medium" font. */
                MS_SendMessage(w->winid, WM_SETFONT,
                                (WPARAM)AxStatusLineFont->fid,
                                (LPARAM)FALSE);                
                }

            for ( ix = 0; ix < w->num_strs; ix++ )
                MS_SendMessage(w->winid, CB_ADDSTRING, (WPARAM)0,
                                            (LPARAM)(w->strs[ix]));
            if ( w->value < w->num_strs )
                MS_SendMessage(w->winid, CB_SETCURSEL, w->value, 0L);

			if ( w->style == W_COMBO_BOX )
			{
				/* combo boxes always use a fixed width so enable auto
				 * horizontal scrolling in case a string is longer than
				 * the width.
		 		 */
                MS_SendMessage(w->winid,CB_SETHORIZONTALEXTENT,w->maxLen+1,0L);
			}

            if ( w->disabled )
                {
                MS_EnableWindow(w->winid, FALSE);  /* gray out widget */
                MS_EnableWindow(w->labelid, FALSE); /* the label, too */
                }
            w->mapped = TRUE;
            }
        else
            taskAbort("PaintOption: could not create option menu.");
        }
    /* set cursor class */
    MS_SetClassLong(w->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
    return;
}

/*****************************************************************
function: DrawOptionMenuEvent - called in response to WM_DRAWITEM.
***/
BOOL
DrawOptionMenuEvent(WPARAM wParam, LPARAM lParam)
{
    int xpos, ypos, save_dc;
    LPDRAWITEMSTRUCT lpds;        /* ownerdraw structure   */
    AXWidget_option w;
    HPALETTE old_palette;

    if ( wParam >= FIRST_WIDGET_ID )
        {
        /* wParam identifies widget */
        w = (AXWidget_option) WIDGET_FROM_UID(wParam);
        }
    else
        return FALSE;

    if ( !w )
        taskAbort("DrawOptionMenuEvent: no widget!");

    lpds = (LPDRAWITEMSTRUCT) lParam;
    if ( lpds->itemID == -1 )
        /* no option-menu items, so do nothing. */
        return FALSE;

    save_dc = MS_SaveDC(lpds->hDC);
    w->window = lpds->hDC;

    old_palette = SelectAndRealizeAxWinPalette(w->window);

    xpos = lpds->rcItem.left;
    ypos = lpds->rcItem.top;
    switch (lpds->itemAction)
        {
        case ODA_DRAWENTIRE:
            /* we get this event during painting of the option-menu. it is *
             * similar to a WM_PAINT. So we draw the appropriate string    *
             * and its selection rect if necessary.      -donato           */
            /* clear any current material. */
            if ( w->widgetColor )
                DrawEmptyRect(lpds, w->widgetColor->any.pixel);
            else
                DrawEmptyRect(lpds, 0xEE);
            DrawOptionMenuString(w, lpds->itemID, xpos, ypos);
            if ( lpds->itemState == ODS_SELECTED )
                DrawSelectedString(lpds, xpos);
            break;


        case ODA_SELECT:
            /* we are assuming that lpds->itemState will be either  *
             * 0 (loss of focus) or 1 (ODS_SELECTED). if the item   *
             * is being selected we draw the string first and then  *
             * the selection rect over it. if, however, the item in *
             * question is losing its selection rect, we must draw  *
             * the string after the rect so we don't erase the item.*/ 
            if ( lpds->itemState == ODS_SELECTED )
                {
                /* user clicked on a listbox item, giving it the focus. *
                 * we draw the string first so we can XOR the selection *
                 * rect over it.                                        */
                /* clear any current material. */
                if ( w->widgetColor )
                    DrawEmptyRect(lpds, w->widgetColor->any.pixel);
                else
                    DrawEmptyRect(lpds, 0xEE);
                DrawOptionMenuString(w, lpds->itemID, xpos, ypos);
                }
            
            /* not sure exactly what Windows means by sending us the value  *
             * (ODS_DISABLED | ODS_SELECTED), but it doesn't mean selection *
             * or loss of selection, so let's not process it (causes bugs   *
             * if we do).               -donato                             */
            if ( lpds->itemState != (ODS_DISABLED | ODS_SELECTED) )
                {
                /* the following call won't draw a string, it will *
                 * just return the start xpos (see function decl). */
                DrawOptionMenuString(w, lpds->itemID, xpos, ypos);
                /* the item in question is either being selected or it is *
                 * losing its selection rect. The following function does *
                 * an XOR to get the proper effect.                       */
                DrawSelectedString(lpds, xpos);
                }

            if ( lpds->itemState == (UINT)0 )
                {
                /* we are here when an item loses the focus rect, *
                 * and we need to draw the string since it wasn't *
                 * drawn previously.                              */
                DrawOptionMenuString(w, lpds->itemID, xpos, ypos);
                }
            break;
        }

    UnSelectPalette(lpds->hDC, old_palette);
    MS_RestoreDC(lpds->hDC, save_dc);
    w->window = NULL;
    return TRUE;
}

static void
DrawOptionMenuString(AXWidget_option w, int str_id, int xpos, int ypos)
{
    HDC draw_dc = w->window;
    HFONT old_hfont;

    if ( w->font )
        old_hfont = MS_SelectObject(draw_dc, w->font->fid);

    if ( w->textColor )
        MS_SetTextColor(draw_dc, GET_COLOR_VALUE(w->textColor->any.pixel));

    MS_SetBkMode(draw_dc, TRANSPARENT);
    MS_TextOut(draw_dc, xpos, ypos, w->strs[str_id], strlen(w->strs[str_id]));

    if ( w->font )
        MS_SelectObject(draw_dc, old_hfont);
}

int
xmOptionMenuLineHeight(AXWidget_option w)
{
    int xoff, yoff, lineHeight;
   
    WIDGET_PARANOID(w, W_OPTION);
 
    if ( w->line_height > 0 )
       /* already computed, and constant for every line */
       return w->line_height;

    /* Compute the line height and store it in the widget so we */
    /* do not have to repeat the search for iconed strings below */
    /* We are making all lines in a listbox a constant height     */
    if ( w->font)
        {
        lineHeight = w->font->ascent + w->font->descent;
        }
    else
        {
        lineHeight = AxCharHeight;
        }

    if ( wShadowIsOn(w->textShadow) )
        {
        xmTextShadowOffsets(w->font, &xoff, &yoff);
        lineHeight += yoff + 1;
        }

    w->line_height = lineHeight;    /* set for future reference */
 
    return lineHeight;
}

static void
AxWinGetTextWidthAndHeight(HFONT hfont, char *str, int *width, int *height)
{
    HDC hdc;
    HFONT old_font;
    SIZE size;

    hdc = MS_GetDC(NULL);
    old_font = MS_SelectObject(hdc, hfont);
    MS_GetTextExtentPoint32(hdc, str, strlen(str), &size);
    *width = size.cx;
    *height = size.cy;
    MS_SelectObject(hdc, old_font);
    MS_ReleaseDC(NULL, hdc);
}


/*********************************************************
function: RealizeScrollBar - create scrollbars
*/
static void
RealizeScrollBar(AXWidget_scroll w_scroll, long scroll_style)
{
    POINT points[10];
    axw_push_button button_w;    /* used as temp */
    AXWidget_main w_main;
    AXWidget_dialog parentP;
    HDC hDC;
    int remove_drawable;
    char no_name[2];
    int button_edge, is_ge, page_wid;
    int max;


    WIDGET_PARANOID(w_scroll, W_SCROLL);    
    if ( !w_scroll->display )
        return;
#if 0
    PaintScrollBar(w_scroll, 0, 0, TRUE);
#else    
    if ( w_scroll->flags & WFLG_IN_EDIT )
        {
        /* we are creating this scroll bar as part of the dialog editor */
        /* we therefore draw a Windows look-alike, rather than creating a */
        /* real windows widget                                            */
        /* First, draw the rectangular border around the scroll bar   */
        if ( w_scroll->parent->window == (HDC) NULL )
            return;
        parentP = (AXWidget_dialog)w_scroll->parent;
        hDC = InsureDrawable(parentP->window, &remove_drawable);
        /* Create a dummy button widget which we use to draw the arrow */
        /* buttons and the slider                                          */
        memset( &button_w, 0, sizeof(button_w) );
        button_w.type = W_BUTTON;
        button_w.flags = WFLG_IN_EDIT;
        button_w.display = TRUE;
        button_w.thickness = 2;
        button_w.xpos = w_scroll->xpos;
        button_w.ypos = w_scroll->ypos;
        button_w.parent = w_scroll->parent;
        button_w.noBorder = TRUE;
        no_name[0] = 0;

        /* In all of the stuff below, we draw the buttons first, then the */
        /* black edges.  This is necessary because the button drawing code */
        /* tries to do rounded buttons by setting the corner pixels to widget*/
        /* background color                                                */
        if ( scroll_style == SBS_VERT )
            {
            /* fill the background of the scroll bar */
            FillButtonFace(hDC, w_scroll->xpos, w_scroll->ypos, 
                          w_scroll->width, w_scroll->height, RecessPixel);

            /* draw the black outline around the scroll bar*/
            MS_SelectObject( hDC, MS_GetStockObject(BLACK_PEN) );

            points[0].x = points[3].x = points[4].x = w_scroll->xpos;
            points[0].y = points[1].y = points[4].y = w_scroll->ypos;
            points[1].x = points[2].x = w_scroll->xpos + w_scroll->width;
            points[2].y = points[3].y = w_scroll->ypos + w_scroll->height - 1;

            MS_Polyline( hDC, points, 5 );

            button_edge = w_scroll->width + 1;
            button_w.width = button_w.height = button_edge;
            button_w.pixmapLabel = TRUE;
            button_w.name = NXLT("win_dwn");
            /* use the bitmap that Windows provides us. */
            button_w.pixmap = MS_LoadBitmap((HINSTANCE)NULL,
                                        (LPCTSTR)OBM_UPARROW);
            PaintButton( &button_w, 0, 0, 0 );  /* down arrow */
            MS_DeleteObject(button_w.pixmap);

            button_w.name = NXLT("win_up");
            button_w.pixmap = MS_LoadBitmap((HINSTANCE)NULL,
                                        (LPCTSTR)OBM_DNARROW);
            button_w.ypos = w_scroll->ypos + w_scroll->height - button_edge;
            PaintButton( &button_w, 0, 0, 0 );  /* up arrow */
            MS_DeleteObject(button_w.pixmap);

            /* only draw "thumb" if there's room for it. */
            if ( w_scroll->height > (unsigned int)(button_edge*3) )
                {
                button_w.name = no_name;
                button_w.pixmap = NULL;
                button_w.pixmapLabel = FALSE;
                button_w.ypos = w_scroll->ypos + button_edge - 1;
                PaintButton( &button_w, 0, 0, 0 );  /* slider button */
                }
            }
        else
            {
            /* horizontal scroll bar */
            /* fill the background of the scroll bar */
            FillButtonFace(hDC, w_scroll->xpos, w_scroll->ypos, 
                          w_scroll->width, w_scroll->height, RecessPixel);

            /* now draw the black outline border around the scroll bar */
            MS_SelectObject( hDC, MS_GetStockObject(BLACK_PEN) );

            points[0].x = points[3].x = points[4].x = w_scroll->xpos;
            points[0].y = points[1].y = points[4].y = w_scroll->ypos;
            points[1].x = points[2].x = w_scroll->xpos + w_scroll->width - 1;
            points[2].y = points[3].y = w_scroll->ypos + w_scroll->height;
        
            MS_Polyline( hDC, points, 5 );

            /* now draw the buttons */
            button_w.pixmapLabel = TRUE;
            button_w.name = NXLT("win_left");
            button_w.pixmap = MS_LoadBitmap((HINSTANCE)NULL,
                                        (LPCTSTR)OBM_LFARROW);
            button_edge = w_scroll->height + 1;
            button_w.width = button_w.height = button_edge;
            PaintButton( &button_w, 0, 0, 0 );  /* "left" arrow */
            MS_DeleteObject(button_w.pixmap);

            button_w.name = NXLT("win_rt");
            button_w.xpos = w_scroll->xpos + w_scroll->width - button_edge;
            button_w.pixmap = MS_LoadBitmap((HINSTANCE)NULL,
                                        (LPCTSTR)OBM_RGARROW);
            PaintButton( &button_w, 0, 0, 0 );  /* right arrow */
            MS_DeleteObject(button_w.pixmap);

            /* only draw "thumb" if there's room for it. */
            if ( w_scroll->width > (unsigned int)(button_edge*3) )
                {
                button_w.name = no_name;
                button_w.pixmapLabel = FALSE;
                button_w.xpos = w_scroll->xpos + button_edge - 1;
                button_w.pixmap = NULL;
                PaintButton( &button_w, 0, 0, 0 );  /* slider button */
                }
            }

        if ( remove_drawable )
            RemoveDrawable(parentP->window, hDC);
        return;
        }
#endif
    if ( w_scroll->winid )
        MS_DestroyWindow(w_scroll->winid);

    /* is this a GE main window? (it uses a diffent status line) */
    w_main = w_scroll->parent;
    is_ge = AxIsGraphicsTask(w_main->taskOwner);

    /* default settings are 16, but we want real values. */
    if ( w_scroll->parent->workWindow && scroll_style == SBS_VERT &&
                                            w_scroll->height <= 16 )
        w_scroll->height = w_scroll->parent->workWindow->height;
    if ( w_scroll->parent->workWindow && scroll_style == SBS_HORZ &&
                                            w_scroll->width <= 16 )
        {
        if ( is_ge )
            {
            page_wid = GE_PAGE_WIDTH;
            w_scroll->xpos += page_wid;
            }
        else
            page_wid = 0;
        w_scroll->width = w_scroll->parent->workWindow->width - page_wid -
                                    w_scroll->parent->statusArea->width;
        }

    w_scroll->winid = MS_CreateWindow(NXLT("SCROLLBAR"), w_scroll->name,
                                        WS_CHILD | WS_VISIBLE | scroll_style,
                                        w_scroll->xpos, w_scroll->ypos,
                                        w_scroll->width, w_scroll->height,
                                        w_scroll->parent->winid,
                                        (HMENU)w_scroll->uid,
                                        (HANDLE)NULL, (LPVOID)NULL);
    if ( w_scroll->winid == (HWND)NULL )
        taskAbort("MS_CreateWindow of scrollbar fails");
    else
        w_scroll->mapped = TRUE;

    /* Since the Windows scroll position report is only 16 bits we may */
    /* need to scale the user position to fit a scaled scrollbar range */
    max = w_scroll->scroll_max;
    if ( w_scroll->scroll_max > 32767 )
       {
       /* scale */
       max = ScaleUserToWinScroll( w_scroll, max );
       }

    MS_SetScrollRange(w_scroll->winid, SB_CTL, 0, max, FALSE);
    if ( RunningWin95Look )
        {
        /* set size of thumb ala X */
        SCROLLINFO lpsi;
        memset(&lpsi, 0, sizeof(SCROLLINFO));
        lpsi.cbSize = sizeof(SCROLLINFO);
        lpsi.fMask = SIF_PAGE;
        lpsi.nPage = w_scroll->scroll_per;
        MS_SetScrollInfo(w_scroll->winid, SB_CTL, &lpsi, FALSE);
        }

    /* set cursor class */
    MS_SetClassLong(w_scroll->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);

#if 0
    GetScrollRange( w_scroll->winid, SB_CTL, &min, &max );
    *** this does not seem to exist outside of the documentation
    /* set the size of the scroll bar */
    MS_SetScrollPage( w_scroll->winid, SB_CTL, w_scroll->scroll_per, TRUE );
#endif

}

void
PaintScrollBar(AXWidget_scroll w, int not_used, int regen, int layered)
{
    int normalized_pos, width, height;
    float scroll_range;
    RECT rect;


    WIDGET_PARANOID(w, W_SCROLL);
	if ( !w->display )
		return;

    if ( w->winid )
        {
        /* already painted, but need to change the slider ("thumb") */
        /* Since we can not set the size of the thumb (yet, until Chicago) */
        /* we need to emulate that here.  Basically, the position of the   */
        /* thumb is always the left/top edge.  We keep the value returned  */
        /* to the application within the range that the user could have    */
        /* created if he had a "fat" thumb which could not be moved much   */
        /* by mapping the user movable space (the area not occupied by the */
        /* fat scroll bar) to the Windows space, which is the entire bar   */
        /* We do the computation as float to avoid integer overflow on the */
        /* multiplication                                                  */
        scroll_range = w->scroll_max - w->scroll_per;
        if ( scroll_range < 5 )
            /* there is a (nearly) full scroll bar, user can not move */
            normalized_pos = 0;
        else
            {
            if ( RunningWin95Look )
                /* we have full porportional scroll bars */
                normalized_pos = w->scroll_pos;
            else
                normalized_pos = ((float)w->scroll_pos * (float)w->scroll_max) /
                                                        (float)scroll_range;
            }

        /* the scroll_max may have changed, so set new scroll range. */
        MS_SetScrollRange(w->winid, SB_CTL, 0, w->scroll_max, FALSE);

        if ( RunningWin95Look )
            {
            /* set size of thumb ala X */
            SCROLLINFO lpsi;
            memset(&lpsi, 0, sizeof(SCROLLINFO));
            lpsi.cbSize = sizeof(SCROLLINFO);
            lpsi.fMask = SIF_PAGE;
            lpsi.nPage = w->scroll_per;
            MS_SetScrollInfo(w->winid, SB_CTL, &lpsi, FALSE);
            }

        /* Since the Windows scroll position report is only 16 bits we may */
        /* need to scale the user position to fit a scaled scrollbar range */
        if ( w->scroll_max > 32767 )
            {
            /* scale */
            normalized_pos = ScaleUserToWinScroll( w, normalized_pos );
            }
        MS_SetScrollPos(w->winid, SB_CTL, normalized_pos, TRUE);

        /* the size of the scrollbar may also have changed.   *
         * get the current size and compare with widget size. */
        MS_GetWindowRect(w->winid, &rect);
        width = rect.right - rect.left;
        height = rect.bottom - rect.top;
        if ( (width != (int)w->width) || (height != (int)w->height) )
            MS_MoveWindow(w->winid,w->xpos,w->ypos, w->width,w->height,TRUE);

        w->update_widget = FALSE;
        }
    else
        {
        /* need to create the scrollbar window. */
        if ( w->scroll_type == AXmVERTICAL )
            RealizeScrollBar(w, SBS_VERT);
        else
            RealizeScrollBar(w, SBS_HORZ);
        }
}



void
PaintEnter(AXWidget_entry w, int not_used, int regen, int layered)
{
    char *bufP;
    int num_bytes, buf_len;
    long entry_style = ES_AUTOHSCROLL; /* | ES_NOHIDESEL; */
    long wstyle = WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_BORDER;


    WIDGET_PARANOID(w, W_ENTER);
    if ( w->parent && (w->parent->type == W_DIALOG) &&
            !((AXWidget_dialog) w->parent)->exposed )
        return;

    if ( layered )
        {
        if ( w->flags & WFLG_IN_EDIT )
            {
            if ( dePaintWidget((AXWidget)w) )
                return;
            }
        else
            {
            if ( (AXWidget_entry)topWidget((AXWidget)w) == w )
                {
                paintCompositeWidget((AXWidget)w, (XExposeEvent*)NULL, regen);
                return;
                }
            }
        }

    if ( w->flags & WFLG_IN_EDIT )
        {
        PaintFakeEnter((AXWidget)w);
        return;
        }

    if ( !w->winid )
        {
        /* need to create a new entry widget */
        if ( !w->uid )
            w->uid = GetAvailableUID((AXWidget)w);
        if ( w->height <= 0 )
            w->height = Entry_Height;
        if ( w->no_echo )
            /* tell edit field to echo '*' for passwords. */
            entry_style |= ES_PASSWORD;

        w->winid = MS_CreateWindow(NXLT("EDIT"), w->name,
                               wstyle | entry_style,
                               w->xpos, w->ypos, w->width, w->height,
                               w->parent->winid, (HMENU)w->uid,
                               (HANDLE)hInst, (LPVOID)NULL);
        if ( w->winid )
            {
            w->last_click_time = 0L;
            if ( w->font && (w->font != AxDlgMainFont) )
                {
                MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                            (LPARAM)TRUE);
                }
            else
                {
                MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)NormalDialogFont,
                                                            (LPARAM)0);
                }
            /* let's subclass the entry field so we can capture *
             * accel keys, like shift-F7 and others.            */
            OldEnterProc = MS_SubclassWindow(w->winid,(WNDPROC)EnterEventProc);
            /* clear entry area (may have text from w->name) */
            MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0, 0L);
            }
        }

    if ( w->winid )
        {
        w->mapped = TRUE;
        /* set a limit. */
        MS_SendMessage(w->winid, EM_LIMITTEXT, (WPARAM)w->maxLen, 0L);
        if ( w->disabled )
            {
            if ( w->wstr )
                MS_SendMessage(w->winid, WM_SETTEXT, 0, (LPARAM)w->wstr);

            /* only disable entry field if it hasn't been already. */
            if ( MS_IsWindowEnabled(w->winid) )
                MS_EnableWindow(w->winid, FALSE);
            }
        else if ( w->display )
            {
            /* only enable entry field if it hasn't already been enabled. */
            if ( !MS_IsWindowEnabled(w->winid) )
                MS_EnableWindow(w->winid, TRUE);

            MS_InvalidateRect(w->winid, (CONST RECT*)NULL, FALSE);
            MS_UpdateWindow(w->winid);

            /* get what's presently in the screen widget. */
            buf_len = MS_GetWindowTextLength(w->winid);
            bufP = (char*)malloc((buf_len+1)*sizeof(char));
            num_bytes = MS_GetWindowText(w->winid, bufP, buf_len+1);
            bufP[num_bytes] = 0;

            if ( w->pending_delete && !w->main_loop_paint )
                {
                /* widget has the focus, tell Windows this */
            	/* only set focus if we are the foreground window, otherwise
                 * we'll force the window to the front.    -donato
                 */
            	if ( MS_GetForegroundWindow() == w->parent->parent->winid )
                	MS_SetFocus( w->winid );
                }

            if ( w->pending_delete && !w->wstr[0] )
                {
                /* this means entry field is empty, but has the focus. */
                w->curPos = 0;
                w->pending_delete = FALSE;
                /* there may be something on screen. delete it. */
                if ( num_bytes > 0 )
                    {
                    bufP[0] = 0;
                    MS_SendMessage(w->winid, WM_SETTEXT, 0, (LPARAM)bufP);
                    }
                }
            else if ( w->wstr[0] )
                {
                if ( w->pending_delete )
                    {
                    /* we are most likely here from PaintDialog, *
                     * in which case the pending text will be    *
                     * inserted there.                           */
#if 0
                    *** took this out so initial paint (when num_bytes == 0)
                    *** happens
                    if ( num_bytes > 0 && strcmp(w->wstr, bufP) )
#else
                    if ( strcmp(w->wstr, bufP) )
#endif
                        {
                        /* what's on the screen widget is different from our *
                         * internal widget, so update the screen. also make  *
                         * sure the user isn't just typing a space.          */
                        MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0,
                                                        (LPARAM)w->wstr);
                        }
                    MS_SendMessage(w->winid,EM_SETSEL,(WPARAM)0,(LPARAM)-1);
                    w->curPos = -1;
                    }
                else
                    {
                    /* insert non-pending text */
                    /* only update if we need to. */
                    if ( num_bytes == 0 )
                        {
                        /* nothing is currently on screen, but we have *
                         * a string to insert.                         */
                        MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0,
                                                        (LPARAM)w->wstr);
                        }
                    else if ( num_bytes > 0 && strcmp(w->wstr, bufP) )
                        {
                        /* what's on the screen widget is different from our *
                         * internal widget, so update the screen. also make  *
                         * sure the user isn't just typing a space.          */
                        if (1)// bufP[num_bytes-1] != ' ' )
                            {
                            MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0,
                                                            (LPARAM)w->wstr);
                            }
                        }
                    }
                }
            else
                {
                /* no string in widget struct. check if there's something *
                 * on screen, and if so, delete it.                       */
                if ( num_bytes > 0 )
                    {
                    bufP[0] = 0;
                    MS_SendMessage(w->winid, WM_SETTEXT, 0, (LPARAM)bufP);
                    }
                w->curPos = -1;
                }
            free(bufP);
            /* set "caret" (cursor) in entry field */
            if ( w->curPos > 0 )
                MS_SendMessage(w->winid, EM_SETSEL, w->curPos, w->curPos);
            /* only set focus if we are the foreground window, otherwise we'll
             * force the window to the front.    -donato
             */
            if ( w->hasFocus &&
                    (MS_GetForegroundWindow() == w->parent->parent->winid) )
                MS_SetFocus(w->winid);
            }
        else    /* assume we need to un-display the widget? */
            {
            MS_DestroyWindow(w->winid);
            w->winid = NULL;
            w->mapped = FALSE;
            }
        }
    else
        taskAbort("PaintEnter: could not create entry field.");

    return;
}


void
PaintEditBox(AXWidget_editbox w, int not_used, int regen, int layered)
{
    int vscroll_offset = 0,
        hscroll_offset = 0;
    long wstyle = WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP;
    long edit_style = ES_MULTILINE | ES_AUTOVSCROLL |
					  ES_NOHIDESEL | ES_WANTRETURN;
    mbchar *tempP, *p1;
    mbchar *p2;
    int new_length;
    HWND curr_hwnd;
    RECT rect;
    int max_pix_wid, border_size;
    XFontStruct *fontP;

    WIDGET_PARANOID(w, W_EDITBOX);
    if ( w->parent && (w->parent->type == W_DIALOG) &&
            !((AXWidget_dialog) w->parent)->exposed )
        return;

    if ( layered )
        {
        if ( w->flags & WFLG_IN_EDIT )
            {
            if ( dePaintWidget((AXWidget)w) )
                return;
            }
        else
            {
            if ( (AXWidget_editbox)topWidget((AXWidget)w) == w )
                {
                paintCompositeWidget((AXWidget)w, (XExposeEvent*)NULL, regen);
                return;
                }
            }
        }

    if ( w->flags & WFLG_IN_EDIT )
        {
        PaintFakeEditbox((AXWidget)w);
        return;
        }

    if ( !w->winid )
        {
        int width, height;
        /* need to create the widget. */
        if ( !w->hide_vscroll )
            {
            edit_style = edit_style | WS_VSCROLL;
            vscroll_offset = Scrollbar_Thickness;
            }
        if ( w->list_hscroll )
            {
            edit_style = edit_style | WS_HSCROLL;
            hscroll_offset = Scrollbar_Thickness;
            }

        /* on X, the scrollbars are drawn separate from the editbox. *
         * Windows, on the other hand, draws the scrollbar within    *
         * the specified width. so add scrollbar widths to the edit  *
         * width to get an equivalent sized editbox.                 */
        width = w->width + vscroll_offset;
        height = w->height + hscroll_offset;
        if ( !w->uid )
            w->uid = GetAvailableUID((AXWidget)w);
        w->winid = MS_CreateWindow( NXLT("EDIT"), w->name,
                               wstyle | edit_style,
                               w->xpos, w->ypos, width, height,
                               w->parent->winid, (HMENU)w->uid,
                               (HANDLE)hInst, (LPVOID)NULL);
        if ( w->winid )
            {
            /* let's subclass the editbox so we can capture accel keys,
             * like shift-F7 and others.
             */
            OldEditboxProc = MS_SubclassWindow(w->winid,
                                    (WNDPROC)EditboxEventProc);
            }
        }

    if ( w->winid )
        {
        /* first we must make sure that simple NL's in the input buffer */
        /* are actually CR/NL pairs the way windows wants them          */
        /* worse case, the length expands by double                     */
        new_length = (w->editbox->objs->wsize * 2) + 1;
        tempP = (mbchar *)malloc( new_length * sizeof(wchar) );
        p1 = tempP;
        p2 = WnToMbOneStr( w->editbox->objs->wdata, w->editbox->objs->wsize );
        while ( *p2 != (mbchar)0 )
           {
           if ( *p2 == '\n' )
              {
              if ( *(p1-1) != 0x0d )
                 *p1++ = 0x0d;
              }
           *p1++ = *p2++;
           }
        *p1 = 0;
        
        MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0, (LPARAM)tempP);
        free( tempP );

        if ( w->editbox->sel.startIndex != w->editbox->sel.endIndex )
           {
           /* there is a recorded selection.  Set it */
           MS_SendMessage( w->winid, EM_SETSEL,
                              (WPARAM)w->editbox->sel.startIndex, 
                              (LPARAM)w->editbox->sel.endIndex );
           }
        w->editbox->sel.startIndex = w->editbox->sel.endIndex = 0;

        /* if it has focus and it's edit-able, set the focus. */
        curr_hwnd = MS_GetFocus();
        if ( curr_hwnd == w->parent->parent->winid &&
                        w->hasFocus && !w->no_picks )
            MS_SetFocus(w->winid);
        w->mapped = TRUE;
        if ( w->disabled )
            MS_EnableWindow(w->winid, FALSE);
        else
            MS_EnableWindow(w->winid, TRUE);
        /* On Win95 and NT4.0, read-only editboxes are not sent a CTLCOLOR
         * message (thanks Microsoft!), so read-only functionality has been
         * moved to the subclass proc (EditboxEventProc).    -donato
         */
        /*MS_SendMessage(w->winid, EM_SETREADONLY, (WPARAM)w->no_picks, 0L);*/
        /* if editbox isn't editable, give focus to parent. */
        if ( w->no_picks )
            MS_SetFocus(w->parent->winid);
        /* make sure we set the font for it may have changed. */
        if ( w->font && (w->font != AxDlgMainFont) )
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                        (LPARAM)TRUE);
            fontP = w->font;
            }
        else if ( w->monospace_font )
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)MonospaceFont->fid,
                                                        (LPARAM)TRUE);
            fontP = MonospaceFont;
            }
        else
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)NormalDialogFont,
                                                        (LPARAM)0);
            fontP = NULL;
            }
        if ( w->maxLen > 0 )
            {
            /* set word wrap length */
            max_pix_wid = wEnterPixWidth(w->maxLen, fontP, (data_ptr)NULL);
            MS_SendMessage(w->winid, EM_GETRECT, 0, (LPARAM) (LPRECT)&rect);
            /* the GETRECT call returns the formatting rect reduced by the
             * size of the editbox border. We assume that the x,y coordinates
             * are the border size, and resize the rect accordingly.
             */
            border_size = rect.left;
            rect.left -= border_size;
            rect.right = rect.left + max_pix_wid;
            border_size = rect.top;
            rect.top -= border_size;
            rect.bottom += border_size;
            MS_SendMessage(w->winid, EM_SETRECT, 0, (LPARAM) (LPRECT)&rect);
            }
        }
    return;
}


void
AxWinGetEditBoxData(AXWidget_editbox w)
{
    wchar *buf;
    int size, num_bytes;

    WIDGET_PARANOID(w, W_EDITBOX);

	/* tell Windows to return soft linebreaks in the case where
	 * word wrap occurs. (NOTE: a soft linebreak is two (2) CRs and 
	 * one (1) NL. ElfbGetEditBoxData takes this into account.)
	 */
	MS_SendMessage(w->winid, EM_FMTLINES, (WPARAM)TRUE, (LPARAM)0);

	size = MS_GetWindowTextLength(w->winid) + 1;
	buf = (wchar*)malloc(size * sizeof(wchar));
    num_bytes = MS_SendMessage(w->winid, WM_GETTEXT, size, (LPARAM)buf);
    buf[num_bytes] = '\0';

    if ( w->editbox->objs[0].wdata )
        free(w->editbox->objs[0].wdata);
    w->editbox->objs[0].wdata = buf;
    w->editbox->objs[0].wsize = num_bytes;
}    


/*************************************************************************
 GetGadgetFromHWND - find widget with specified window handle from 
                 specified parent's widgets list. (list of children).
 ***/    
AXWidget
GetGadgetFromHWND(AXWidget parent, HWND hwnd)
{
    AXWidget w;

    /* Find the widget associated with the event */
    for ( w = parent->widgets; w; w = w->nextChild )
        {
        if ( w->type == W_OPTION )
            /* check for the "static" label widget on the option menu. */
            if ( ((AXWidget_option)w)->labelid == hwnd )
                return w;
        if ( w->winid == hwnd )
            return w;
        }

    return ( (AXWidget)NULL );
}


/***************************************************************************
 GetWidgetFromHWND - finds specified widget type with specified window
                 handle from the global WindowList (widgets with windows).
 ***/     
AXWidget
GetWidgetFromHWND(HWND hwnd, int type)
/* int type;    type of widget to get */
{
    AXWidget w;

    /* Find the widget associated with the event */
    for ( w = WindowList; w; w = w->nextWin )
        {
        if ( w->winid == hwnd && w->type == type )
            return w;
        }
    return ( (AXWidget)NULL );
}


AXWidget
GetWidgetFromDC(HDC hdc)
{
    AXWidget w;


    /* Find the widget associated with the hdc */
    for ( w = WindowList; w; w = w->nextWin )
        {
        if ( w->window == hdc )
            return (w);
        }

    return ( (AXWidget)NULL );
}


AXWidget
GetWidgetInFocus(void)
{
    HWND hwnd;
    AXWidget w;


    hwnd = MS_GetFocus();
    /* Find the widget that has the focus */
    for ( w = WindowList; w; w = w->nextWin )
        {
        if ( w->winid == hwnd )
            return w;
        }

    return ( (AXWidget)NULL );
}



/** set row col button vals.  taken from AxXtSetValues **/
void
SetRowColButtonColors(AXWidget_rowcol w, int fg, int bg)
{
    WIDGET_PARANOID(w, W_ROWCOL);
    w->color    = fg;
    w->bg_color = bg;
    w->update_widget = WidgetNeedsUpdated = TRUE;
}


/** set icon vals.  taken from AxXtSetValues **/
void
SetIconValue(AXWidget_icon w, char *val)
{
    pixcache_t *pix;


    WIDGET_PARANOID(w, W_ICON);
    SetWidgetName((AXWidget)w, val);
    pix = Pixmapper(w->name);
    if ( pix )
        {   /* was 'if ( pix && !w->color )' why?? */
        if ( w->maxWidth > 0 && w->maxHeight > 0 ) 
            {
            w->width = MIN((unsigned int)pix->width,
                            (unsigned int)w->maxWidth);
            w->height = MIN((unsigned int)pix->height,
                            (unsigned int)w->maxHeight);
            }
        else
            {
            w->width = pix->width;
            w->height = pix->height;
            }
        }
}


void
WinCreateTableWindow(AXWidget_table w_table)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("TableClass");
    int xpos, ypos, width, height;
    table_info *tbl_info;

    WIDGET_PARANOID(w_table, W_TABLE);

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC)TableClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = NULL;
        wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    tbl_info = (table_info*)w_table->info.table;
    xpos = w_table->xpos + abs(w_table->thickness);
    ypos = w_table->ypos + abs(w_table->thickness);
    width = tbl_info->winWidth;
    height = tbl_info->winHeight;

    if ( width > 0 && height > 0 )
        {
        w_table->winid = MS_CreateWindow(class_name, w_table->name,
                                        WS_VISIBLE | WS_CHILD,
                                        xpos, ypos, width, height,
                                        w_table->parent->winid,
                                        (HMENU)w_table->uid,
                                        (HANDLE)hInst, (LPVOID)NULL);
        w_table->window = AxPackageHandle(w_table->winid, AX_HWND_TYPE);
        if ( w_table->font && (w_table->font != AxDlgMainFont) )
            {
            MS_SendMessage(w_table->winid, WM_SETFONT,
                            (WPARAM)w_table->font->fid,
                            (LPARAM)TRUE);
            }
        else
            {
            MS_SendMessage(w_table->winid, WM_SETFONT,
                            (WPARAM)NormalDialogFont, 0L);
            }
       }
}

void
AxWinCreateTrayWindow(AXWidget_tray w, int xpos,int ypos,int width,int height)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("TrayClass");

    WIDGET_PARANOID(w, W_TRAY);
    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC)TrayClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = NULL;
        wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    w->winid = MS_CreateWindow(class_name, w->name,
                                WS_CHILD | WS_VISIBLE,
                                xpos, ypos, width, height,
                                w->parent->winid,
                                (HMENU)w->uid,
                                (HANDLE)hInst, (LPVOID)NULL);

    w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
    if ( w->font && (w->font != AxDlgMainFont) )
        {
        MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                    (LPARAM)TRUE);
        }
    else
        MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)NormalDialogFont, 0L);
}

void
AxWinCreateCanvasWindow(AXWidget_canvas w, int xpos, int ypos,
                                        int width, int height)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("CanvasClass");

    WIDGET_PARANOID(w, W_CANVAS);
    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC)CanvasClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = NULL;
        wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    w->winid = MS_CreateWindow(class_name, w->name,
                                WS_CHILD | WS_VISIBLE,
                                xpos, ypos, width, height,
                                w->parent->winid, (HMENU)w->uid,
                                (HANDLE)hInst, (LPVOID)NULL);
    if ( w->winid )
        {
        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
        MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)NormalDialogFont, 0L);
        }
}


void
AxCreateWinChooserWindow(AXWidget_color_chooser w)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("ColorChooserClass");

    WIDGET_PARANOID(w, W_CHOOSE);
    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC)ColorChooserClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = NULL;
        wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    w->winid = MS_CreateWindow(class_name, w->name,
                                WS_CHILD | WS_VISIBLE | WS_BORDER,
                                w->xpos, w->ypos,
                                w->width, w->height,
                                w->parent->winid,
                                (HMENU)w->uid,
                                (HANDLE)hInst, (LPVOID)NULL);
    if ( w->winid )
        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
}


void
AxCreateWinRowColWindow(AXWidget_rowcol w)
{
    POINT dialog_point;
    HWND parent;

    WIDGET_PARANOID(w, W_ROWCOL);
    /* we don't want the popup window to be created below the mouse cursor  *
     * (that is, below the rowcol button) because we want the newly created *
     * popup window to capture the mouse. So first translate the widget     *
     * coordinates to screen coordinates (because the pulldown values are   *
     * relative to the screen), and then check where our popup window will  *
     * be created. If below the mouse, adjust the ypos up to the original   *
     * rowcol button position.                                              */
    dialog_point.x = w->xpos;
    dialog_point.y = w->ypos; 
    /* translate from dialog coordinates to screen coordinates. */
    MS_ClientToScreen(w->parent->winid, &dialog_point);
    if ( w->pulldown_ypos >= (int)(dialog_point.y + w->height) )
        w->pulldown_ypos = (short)dialog_point.y;

    /* we need to set the parent, because without this, an indempendent */
    /* window gets creatd, which ends up on the task bar (NT 4.0), and  */
    /* because of some palette issues I do not understand, causes all   */
    /* of the desktop icons to flash.  With the parent set, nothing     */
    /* get posted to the task bar, and no flashes occurr.               */
    parent = w->parent->winid;

    w->winid = MS_CreateWindow(NXLT("PopupClass"), w->name,
                                WS_POPUP | WS_BORDER | WS_VISIBLE,
                                w->pulldown_xpos, w->pulldown_ypos,
                                w->pulldown_width + BorderWidth,
                                w->pulldown_height + BorderHeight,
                                parent, (HMENU)NULL,
                                (HANDLE)hInst, (LPVOID)NULL);

    if ( w->winid )
        {
        if ( w->font && (w->font != AxDlgMainFont) )
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                        (LPARAM)TRUE);
            }
        else
            MS_SendMessage(w->winid,WM_SETFONT,(WPARAM)NormalDialogFont,0L);

        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
        w->mapped = TRUE;
        }
    //else
    //    taskAbort("AxCreateWinRowColWindow: could not create rowcol window");
}

void
AxCreateWinPopupWindow(AXWidget_popup w, int xpos, int ypos)
{
    HWND parent;

    WIDGET_PARANOID(w, W_POPUP);

    /* we need to set the parent, because without this, an indempendent */
    /* window gets creatd, which ends up on the task bar (NT 4.0), and  */
    /* because of some palette issues I do not understand, causes all   */
    /* of the desktop icons to flash.  With the parent set, nothing     */
    /* get posted to the task bar, and no flashes occurr.               */
    parent = w->parent->winid;

    /* Note: we subtract 10 from the input position, which is the mouse */
    /* position, so that the window will be created underneath the     */
    /* mouse, so the mouse events will go to the popup window.          */

    w->winid = MS_CreateWindow(NXLT("PopupClass"), w->name,
                                WS_POPUP | WS_BORDER | WS_VISIBLE,
                                xpos, ypos,
                                w->pulldown_width + BorderWidth,
                                w->height + BorderHeight,
                                parent, (HMENU)NULL,
                                (HANDLE)hInst, (LPVOID)NULL);

    if ( w->winid )
        {
        if ( w->font && (w->font != AxDlgMainFont) )
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                        (LPARAM)TRUE);
            }
        else
            MS_SendMessage(w->winid,WM_SETFONT,(WPARAM)NormalDialogFont,0L);

        MS_SetCapture( w->winid );
        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
        w->mapped = TRUE;
        }
    else
        taskAbort("AxCreateWinPopupWindow: could not create popup window");
}


AXWidget
GetStatusWidgetOfActiveWindow(int is_status)
{
    HWND hwnd;
    register AXWidget_main mw;


    hwnd = MS_GetActiveWindow();
    if ( !hwnd )
        {
        /* we're probably in the debugger, just exit. */
        return (AXWidget)NULL;
        }

    mw = (AXWidget_main) GetWidgetFromHWND(hwnd, W_MAIN);
    if ( !mw )
        {
        if ( is_status )
            taskAbort("no active main window!");
        else
            return( (AXWidget)NULL );
        }

    return( (AXWidget)mw->statusArea );
}



static int
GetWindowSizeAndPos(HWND hwnd, HWND parent_hwnd, int *xpos, int *ypos,
                                                int *width, int *height)
{
    int ret;
    RECT rect;
    POINT point;


    ret = MS_GetWindowRect(hwnd, &rect);
    if ( !ret )
       return( FALSE );

    *width = rect.right - rect.left;
    *height = rect.bottom - rect.top;

    /* convert screen cordinates to the coordinates relative to the parent */
    point.x = rect.left;
    point.y = rect.top;
    ret = MS_ScreenToClient(parent_hwnd, &point);
    if ( !ret )
       return FALSE;
    *xpos = point.x;
    *ypos = point.y;
    return TRUE;
}



int
GetListBoxStrLen(HWND hwnd, char *list_str)
{
    int extent;
    HDC hdc;
    HFONT list_font, old_font;
    SIZE size;
    TEXTMETRIC tm;


    hdc = MS_GetDC(hwnd);
    list_font = (HFONT)MS_SendMessage(hwnd, WM_GETFONT,
                                (WPARAM)NULL, (LPARAM)NULL);
    if ( !list_font )
        /* WM_GETFONT returns NULL if the system font is being used. */
        list_font = NormalDialogFont;

    old_font = MS_SelectObject(hdc, list_font);
    MS_GetTextMetrics(hdc, &tm);
    MS_GetTextExtentPoint32(hdc, list_str, strlen(list_str), &size);

    MS_SelectObject(hdc, old_font);
    MS_ReleaseDC(hwnd, hdc);

    /* from MS documentation: "A few pixels are clipped by the right border *
     * on the list box. The tmAveCharWidth field...provides a consistent    *
     * number of pixels to add to the length of the string, no matter what  *
     * font is presently in use."                                           */
    extent = size.cx + tm.tmAveCharWidth;
    return extent;
}


void
DoWinRadioSizing(AXWidget_radio radio)
{
    unsigned int title_width;
    XFontStruct *fs;

    WIDGET_PARANOID(radio, W_RADIO);
    if ( radio->font )
        fs = radio->font;
    else
        fs = AxDlgMainFont;
    title_width = XTextWidth(fs, radio->name, MBstrlen(radio->name));
    if ( title_width > radio->width )
        {
        radio->width = title_width + WIN_RADIO_TITLE_PAD;
        }
    radio->width += WIN_RADIO_WIDTH_PAD;
    radio->height += WIN_RADIO_HEIGHT_PAD;
}


void
SetOptionItems(AXWidget_option w_option, char **items)
{
    int j;

    /* allocate space, making sure to create at least one valid pointer */
    /* in case there are no strings                                     */
    w_option->strs = (char**)calloc(1,((w_option->num_strs+1)*sizeof(char*)));
    w_option->strs[0] = ""; /* will get overwritten if there is real string */

    for ( j=0; j < w_option->num_strs; j++ )
        {
        w_option->strs[j] = STRALLOC(items[j]);
        }
}


void
AxWinDoOptionMenu(AXWidget_option w_option, int num_strs, mbchar *names[],
                                int xpos, int ypos, mbchar *currentName)
{
    int ix, len, maxlen, item_len, value;
    BOOL found_current = FALSE;
    XFontStruct *ofont;


    WIDGET_PARANOID(w_option, W_OPTION);
    maxlen = 0;
    for ( ix = 0; ix < num_strs; ix++ )
        {
        if ( !found_current && currentName && streq(names[ix], currentName) )
            {
            found_current = TRUE;
            value = ix;
            }

        if ( w_option->font )
            ofont = w_option->font;
        else
            ofont = AxDlgMainFont;

        item_len = strlen(names[ix]);
        len = XTextWidth(ofont, names[ix], item_len);
        if (len > maxlen)
            maxlen = len;
        }

    if ( !w_option->uid )
        w_option->uid = GetAvailableUID((AXWidget)w_option);
    w_option->xpos = xpos;
    w_option->ypos = ypos;
    w_option->value = value;
    w_option->num_strs = num_strs;
    w_option->width = maxlen + Option_Pad;
    /* compute height:  the AXmCreatePulldownMenu call will set the height *
     * to the font height. multiply that by the number of strings in the   *
     * menu, and then add the font height times 2. this is to account for  *
     * the extra space needed by a Windows pulldown.                       */
    /* if number of items is greater than 10, let Windows provide the *
     * option menu scrollbar. Looks better, and is the "Windows way". */
    if ( num_strs > 10 )
        num_strs = 10;
    w_option->pulldown_height = (w_option->height * num_strs) +
                                (w_option->height * 2) + 6;
    //w_option->pulldown_height = (w_option->height * (num_strs+1)) + 6;
    SetOptionItems(w_option, names);
}


/*************************************************************************
function: WXGetWidgetString - Get current text from an entry field
*/
wchar *
WXGetWidgetString(AXWidget_entry w)
{
    char buf[1000];
    int num_bytes;

    if ( !w )
        return NULL;
    WIDGET_PARANOID(w, W_ENTER);
    /* I think we should always take what is in the widget. - jon */
    /* However, if we are in the dialog editor, we won't have a real  *
     * Windows widget to obtain data from so let's just return what's *
     * in memory, like on X.             (27-feb-95)   -donato        */
    /* Yet another note: if the widget needs to be updated, we don't 
     * want to take what's on-screen because it will be wrong. -donato
     */
    if ( w->winid && !w->update_widget )
        {
        num_bytes = MS_SendMessage(w->winid, WM_GETTEXT, 1000, (LPARAM)buf);
        buf[num_bytes] = '\0';

        if ( w->wstr )
            free(w->wstr);
        w->wstr = (wchar *)malloc( (num_bytes+1)*sizeof(wchar) );
        MbToWStr( buf, w->wstr );
        }
    return( w->wstr );
}


void
AxWinAddMenuBarToMain(data_ptr info, AXWidget_main w_main)
{
    data_ptr menu;
    AXWidget_menu menu_bar;


    menu = AnyFromArray(info, DB_bar_widget);
    if ( menu )
        {
        menu_bar = (AXWidget_menu)
                    WidgetPointerFromHandleData(menu);
        w_main->menuBar = menu_bar;
        w_main->menu_handle = menu_bar->menu_handle;
        }
    else
        {
        w_main->menu_handle = (HMENU) NULL;
        w_main->menuBar = (AXWidget_menu) NULL;
        }
}

#if 0
/**********************************************************************
function: FindPopupWidget - Find pointer sensitive popup widget by x/y
*/
AXWidget
FindPopupWidget(AXWidget_palette w_pal, register int x, register int y)
{
    register AXWidget wp;

    for ( wp = w_pal->widgets; wp; wp = wp->nextChild )
        {
        if ( wp->type == W_POPUP )
            {
            if ( (x >= wp->xpos) && (x < (int)(wp->xpos+wp->width)) &&
                    (y >= wp->ypos) && (y < (int)(wp->ypos+wp->height)) &&
                    wp->display && wp->mapped )
                return wp;
            }
        }

    return (AXWidget)NULL;
}
#endif


#define MAX_ITEMS 8192    /* for now? */
/*** based on AddSelection in xmlist.c ***/
static void
AddSelectionsToWidget(AXWidget_list w, int num_sel, int list_sels[])
{
    register int ix;
    register long *new_selections = (long*)NULL;

    new_selections = CreateIntsArray(num_sel + 1);
    for ( ix=0; ix < num_sel; ix++ )
        {
        WriteIntsArray(new_selections, ix, list_sels[ix]);
        }

    if ( w->selections )
        free(w->selections);
    w->selections = new_selections;
}

void
DoSinglePick(AXWidget_list w)
{
    int list_sels[1];

    list_sels[0] = w->value - 1;
    AddSelectionsToWidget(w, 1, list_sels);
}

void
DoMultiPick(AXWidget_list w, XmListCallbackStruct *data)
{
    int num_sel, retrieved;
    int list_sels[MAX_ITEMS];


    num_sel = MS_SendMessage(w->winid, LB_GETSELCOUNT, 0, 0L);
    retrieved = MS_SendMessage(w->winid, LB_GETSELITEMS, (WPARAM)512,
                                            (LPARAM)(LPINT)list_sels);
    if ( retrieved != num_sel )
        taskAbort(NXLT("DoMultiPick: list box selection mismatch!"));

    data->selected_items = (XmString*)malloc(sizeof(XmString));
    AddSelectionsToWidget(w, num_sel, list_sels);

    data->selected_items[0] = (XmString) w->selections;
    data->selected_item_count = num_sel;
}



/* Since the Windows scroll position report is only 16 bits we may */
/* need to scale the user position to fit a scaled scrollbar range */
int ScaleUserToWinScroll( AXWidget_scroll w_scroll, int user_pos )
{
    int ret_val;

    if ( w_scroll->scroll_max < 32767 )
        /* no scaling necessary */
        return( user_pos );

    //ret_val = (float)user_pos * (33767.0/((float)w_scroll->scroll_max));
    ret_val = (float)user_pos * (((float)w_scroll->scroll_max) / 32767.0);

    return( ret_val );
}



/***************************************************************************/
/* finds active entry in dialog (if one exists), and sets the focus to it. */
void SetActiveEntryWidget(w_dlg)
AXWidget_dialog w_dlg;
{
    char buf[1000];
    int  num_bytes;
    int  need_to_set_focus = TRUE;
    AXWidget_entry w = NULL;


    w = ElfbGetActiveWidget((AXWidget)w_dlg);
    if ( w && w->type == W_ENTER && w->winid )
        {
        /* only set widget focus if the dialog has focus. */
        if ( MS_GetActiveWindow() != w->parent->parent->winid )
            need_to_set_focus = FALSE;

        num_bytes = MS_SendMessage(w->winid, WM_GETTEXT, 1000, (LPARAM)buf);
        buf[num_bytes] = 0;

        if ( num_bytes > 0 && strcmp(w->wstr, buf) )
            {
            /* what's already on the screen widget is different *
             * from our internal widget, so update the widget   *
             * string and insert non-pending text.              */
            free(w->wstr);
            w->wstr = STRALLOC(buf);
            MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0, (LPARAM)w->wstr);
            if ( need_to_set_focus )
                MS_SetFocus(w->winid);
            }
        else if ( w->pending_delete )
            {
            /* insert text and highlight it. */
            MS_SendMessage(w->winid, WM_SETTEXT, (WPARAM)0,
                               (LPARAM)(LPCTSTR)w->wstr);
            MS_SendMessage(w->winid, EM_SETSEL, (WPARAM)0, (LPARAM)-1);
            if ( need_to_set_focus )
                MS_SetFocus(w->winid);
            }
        else
            {
            /* just set the focus. */
            if ( need_to_set_focus )
                MS_SetFocus(w->winid);
            }
        }
}



void
AxWinDeleteWidgetDrawable(AXWidget w)
{
    if ( w == (AXWidget)NULL )
        return;

    if ( (w->type == W_MAIN) && ((AXWidget_main)w)->workWindow &&
            (w->window == ((AXWidget_main)w)->workWindow->window) )
        {
        /* this is an "invisible" window, which means we copied its *
         * drawable to its work window, so invalidate that too.     */
        ((AXWidget_main)w)->workWindow->window = NULL;
        }

    /* released DCs are set to 1, so make sure we have a valid object. */
    if ( (int)w->window == 0 || (int)w->window == 1 )
        return;     /* nothing to delete. */

    if ( IS_PACKAGED_DRAWABLE(w->window) )
        {
        REMOVE_DRAWABLE(w->window);
        w->window = NULL;
        }
    else
        {
#if 1
        /* better be a bitmap (because it's unpackaged). */
        MS_DeleteObject(w->window);
        w->window = NULL;
#else
        int inEdit = (w->flags & WFLG_IN_EDIT); /* true under dialog editor */
        /* released DCs are set to 1, so make sure we have a valid object. */
        if ( (int)w->window > 1 )
            {
            if ( inEdit )
                /* the drawable is a pixmap. */
                MS_DeleteObject(w->window);
            else
                MS_ReleaseDC(w->winid, w->window);
            w->window = NULL;
            }
#endif
        }
}



/*****************************************************************
 *************************   LISTBOXES   *************************
             (eventually move these functions to winlist.c)
 *****************************************************************/
#define ATTR_BOLD       1
#define ATTR_ITAL       2
#define ATTR_MONO       4
extern GC DisabledGC;
extern Display *Dpy;
extern Pixmap UnknownPixmap;
extern GC MonospaceGC;       /* monspace system font, forground mode */
extern GC MonospaceBackGC;   /* monspace system font, background mode */
extern GC MonospaceBoldGC, MonospaceBoldBackGC;
extern GC MonospaceItalGC, MonospaceItalBackGC;
extern GC MonospaceItalBoldGC, MonospaceItalBoldBackGC;


void LetWindowsManageListbox( AXWidget_list w )
{
    /* set things so that when this listbox is created, we let Windows */
    /* handle all of the drawing, as opposed to letting it be owner-draw */
    /* this is done for simplicity and speed                             */
    w->let_windows_manage = TRUE;
    return;
}


/** Add a srring to the bottom of a listbox, and make sure it is displayed **/
void AddStringToListbox( AXWidget_list w, mbchar *str )
{
    int num_in_listbox;
    int new_top;
    int ret, i;
    int pixel_str_width, listbox_scroll_width;

    pixel_str_width = GetListBoxStrLen( w->winid, str );
    listbox_scroll_width = MS_SendMessage(w->winid, LB_GETHORIZONTALEXTENT, 
                                                     (WPARAM)0, (LPARAM)0 );
    if ( pixel_str_width > listbox_scroll_width )
        /* reset the horizontal scroll extent */
        MS_SendMessage(w->winid, LB_SETHORIZONTALEXTENT,
                                               (WPARAM)pixel_str_width, 0L);
     

    ret = MS_SendMessage(w->winid, LB_ADDSTRING, (WPARAM)NULL, (LPARAM)str);
    if ( ret == LB_ERRSPACE )  
       {
       /* no more room, delete some of the former strings */
       for ( i=0; i< 20; i++ )
          {
          MS_SendMessage(w->winid, LB_DELETESTRING, (WPARAM)0, (LPARAM)0 );
          }
       MS_SendMessage(w->winid, LB_ADDSTRING, (WPARAM)NULL, (LPARAM)str);
       }
    else if ( ret == LB_ERR )
       {
       taskAbort(NXLT("AddStringToListbox-Invalid return from LB_ADDSTRING") );
       }

    num_in_listbox = MS_SendMessage( w->winid, LB_GETCOUNT, 
                                                      (WPARAM)0, (LPARAM)0 );
    new_top = num_in_listbox - w->scroll_max;
    if ( new_top < 0 )
       new_top = 0;
    
    MS_SendMessage(w->winid, LB_SETTOPINDEX, new_top, 0L );
    w->num_strs = num_in_listbox + 1;
    return;
}

static BOOL
IsMultiPickListbox(HWND list_wnd)
{
    LONG list_style = MS_GetWindowLong(list_wnd, GWL_STYLE);
    if ( list_style & LBS_EXTENDEDSEL )
        return TRUE;
    else
        return FALSE;
}

/**************************************************************
function: PaintList - listbox widget painter.
***/
void
PaintList(AXWidget_list w, int not_used, int regen, int layered)
{
    int width;
    int ix, num_bytes, num_strs;
    int need_to_reset = FALSE;
    int vscroll_offset = 0,
        hscroll_offset = 0;
    long wstyle = WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP;
    long list_style = LBS_NOTIFY | LBS_DISABLENOSCROLL | LBS_WANTKEYBOARDINPUT;
    char item_str[1001];
    HDC tmp_dc;
    HFONT old_font;
    TEXTMETRIC tm;


    WIDGET_PARANOID(w, W_LIST);
    if ( !w->managed )
        return;
    if ( w->parent && (w->parent->type == W_DIALOG) &&
            !((AXWidget_dialog) w->parent)->exposed )
        return;    
    if ( !w->parent->winid )
        /* why does this case happen at all? (check in to it!) -donato */
        return;
#if 0
    /* Unless the calling macro wants to force a particular item to be
       visible, or the list has just been user scrolled, make sure the
       selection is being displayed (except for multi-pick lists).
       Maintain old scroll_pos if this is just an Expose. */
    if ( w->force_list_item_display )
        w->force_list_item_display = FALSE;
    else if ( w->selections && (1 == IntsArraySize(w->selections)) &&
                            (-1 != FirstInIntsArray(w->selections)) )
        force_display_selection = TRUE;
#endif
    if ( layered )
        {
        if ( w->flags & WFLG_IN_EDIT )
            {
            if ( dePaintWidget((AXWidget)w) )
                return;
            }
        else
            {
            if ( (AXWidget_list)topWidget((AXWidget)w) == w )
                {
                paintCompositeWidget((AXWidget)w, (XExposeEvent*)NULL, regen);
                return;
                }
            }
        }

    /* from MS documentation: "A few pixels are clipped by the right border
     * on the list box. The tmAveCharWidth field...provides a consistent
     * number of pixels to add to the length of the string, no matter what
     * font is presently in use."  So we add the average font width to the
     * widget width to make sure the requested amount of characters fit into
     * the listbox.             -donato
     */
#if 0
    width = w->width;
#else
    tmp_dc = MS_GetDC(NULL);
    if ( w->font )
        old_font = MS_SelectObject(tmp_dc, w->font->fid);
    else
        old_font = MS_SelectObject(tmp_dc, NormalDialogFont);
    MS_GetTextMetrics(tmp_dc, &tm);
    width = w->width + tm.tmAveCharWidth;
    MS_SelectObject(tmp_dc, old_font);
    MS_ReleaseDC(NULL, tmp_dc);
#endif

    if ( w->flags & WFLG_IN_EDIT )
        {
        /* if we're in the dialog editor, we have to draw the listbox *
         * ourselves so we can move and resise it correctly.          */
        PaintFakeList(w);
        return;
        }

    if ( w->winid && ((w->multi_pick && !IsMultiPickListbox(w->winid)) ||
                        (!w->multi_pick && IsMultiPickListbox(w->winid))) )
        {
        /* the current, on-screen listbox has a different selection mode
         * than the new widget we need to paint. The only way to change
         * listbox styles on the fly in Windows is to destroy the old one.
         *                                              -donato
         */
        MS_DestroyWindow(w->winid);
        w->winid = NULL;
        }

    if ( !w->winid )
        {
        if ( !w->hide_vscroll )
            {
            list_style |= WS_VSCROLL;
            vscroll_offset = Scrollbar_Thickness + 2;
            }
        if ( w->list_hscroll )
            {
            list_style |= WS_HSCROLL;
            hscroll_offset = Scrollbar_Thickness;
            }
        if ( w->multi_pick )
            list_style |= LBS_EXTENDEDSEL;

#if 1
        if ( !w->let_windows_manage )
            /* we will be drawing these things ourselves */
            list_style |= LBS_OWNERDRAWFIXED | LBS_HASSTRINGS;
#else
        list_style |= LBS_OWNERDRAWVARIABLE | LBS_HASSTRINGS;
#endif

        w->height = wListPixHeight(w->scroll_max, w->font,
                           w->textShadow, w->list_hscroll);

        if ( !w->uid )
            w->uid = GetAvailableUID((AXWidget)w);
        /* only create the listbox if it has a height. */
        if ( w->display && (w->height > 0) )
            {
            w->winid = MS_CreateWindow(NXLT("LISTBOX"), w->name,
                                   wstyle | list_style,
                                   w->xpos, w->ypos, width, w->height,
                                   w->parent->winid, (HMENU)w->uid,
                                   (HANDLE)hInst, (LPVOID)NULL);
            if ( !w->winid )
                taskAbort(NXLT("PaintList: could not create list box"));
            if ( w->font && (w->font != AxDlgMainFont) )
                {
                MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                            (LPARAM)TRUE);
                }
            else
                {
                MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)NormalDialogFont,
                                                            (LPARAM)0);
                }
            }
        /* sub-class the listbox so we can capture the right mouse button */
        if ( w->winid )
            OldListProc = MS_SubclassWindow(w->winid, (WNDPROC)ListEventProc);
        }

    /* if we have strs and they are different from already *
     * existing strs, then reset the listbox.              */
    if ( w->num_strs )
        {
        if ( w->let_windows_manage )
            /* windows will handle the re-paint */
            return;
        num_strs = MS_SendMessage(w->winid, LB_GETCOUNT, 0, 0L);
        if ( num_strs != w->num_strs )
            need_to_reset = TRUE;
        else
            {
            for ( ix = 0; ix < w->num_strs; ix++ )
                {
                num_bytes = MS_SendMessage(w->winid, LB_GETTEXT,
                                    (WPARAM)ix, (LPARAM)item_str);
                item_str[num_bytes+1] = 0;
                if ( !streq(item_str, w->strs[ix]) )
                    {
                    need_to_reset = TRUE;
                    break;
                    }
                }
            }

        if ( need_to_reset )
            /* new items in listbox. */
            ResetListBox(w);
        else
            /* no new items, but set selection(s). */
            SetListboxSelection(w, FALSE);
        }
    else
        {
        /* no items. reset listbox to remove any old items */
        MS_SendMessage(w->winid, LB_RESETCONTENT, (WPARAM)0, 0L);
        if ( w->font && (w->font != AxDlgMainFont) )
            {
            MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)w->font->fid,
                                                        (LPARAM)TRUE);
            }
        else
            MS_SendMessage(w->winid,WM_SETFONT,(WPARAM)NormalDialogFont,0L);
        }

    w->mapped = TRUE;
    if ( w->disabled )
        MS_EnableWindow(w->winid, FALSE);
    else
        MS_EnableWindow(w->winid, TRUE);

    /* we explicitly invalidate the whole listbox window to make sure 
     * it gets repainted in case it gets painted over (e.g. by UnMapWidget
     * in the Data Groups dialog in the SS).
     */
    if ( w->display )
        {
        MS_RedrawWindow(w->winid, (CONST RECT *)NULL, (HRGN)NULL,
                    RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
        }
    else
        MS_ShowWindow(w->winid, SW_HIDE);

    /* set cursor class */
    MS_SetClassLong(w->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
    return;
}



/*****************************************************************
function: DrawListBoxEvent - called in response to WM_DRAWITEM.
***/
BOOL
DrawListBoxEvent(WPARAM wParam, LPARAM lParam)
{
    int ypos, save_dc;
    BOOL retval;
    LPDRAWITEMSTRUCT lpds;        /* ownerdraw structure   */
    AXWidget_list w;
    int xpos=0; /* start of current list item string (not including bitmap) *
                 * so we can draw selection rect only over the text.        */


    if ( wParam >= FIRST_WIDGET_ID )
        {
        /* wParam identifies widget */
        w = (AXWidget_list) WIDGET_FROM_UID(wParam);
        }
    else
        return FALSE;

    if ( !w )
        taskAbort("DrawListBoxEvent: no widget!");

    lpds = (LPDRAWITEMSTRUCT) lParam;
    if ( lpds->itemID == -1 )
        /* no listbox items, so do nothing. */
        return FALSE;

    save_dc = MS_SaveDC(lpds->hDC);
    w->window = AxPackageHandle(lpds->hDC, AX_DC_TYPE);

    retval = TRUE;
    ypos = lpds->rcItem.top;
    switch (lpds->itemAction)
        {
        case ODA_DRAWENTIRE:
            /* we get this event during painting of the listbox.  it is *
             * similar to a WM_PAINT. So we draw the appropriate string *
             * and its selection rect if necessary.      -donato        */
            /* clear any current material. */
            if ( w->widgetColor )
                DrawEmptyRect(lpds, w->widgetColor->any.pixel);
            else
                DrawEmptyRect(lpds, 0xEE);
            DrawIconedString(w,w->strs[lpds->itemID], ypos, &xpos, FALSE);
            if ( lpds->itemState == ODS_SELECTED )
                DrawSelectedString(lpds, xpos);
            break;


        case ODA_SELECT:
            /* we are assuming that lpds->itemState will be either  *
             * 0 (loss of focus) or 1 (ODS_SELECTED). if the item   *
             * is being selected we draw the string first and then  *
             * the selection rect over it. if, however, the item in *
             * question is losing its selection rect, we must draw  *
             * the string after the rect so we don't erase the item.*/ 
            if ( lpds->itemState == ODS_SELECTED )
                {
                /* user clicked on a listbox item, giving it the focus. *
                 * we draw the string first so we can XOR the selection *
                 * rect over it.                                        */
                /* clear any current material. */
                if ( w->widgetColor )
                    DrawEmptyRect(lpds, w->widgetColor->any.pixel);
                else
                    DrawEmptyRect(lpds, 0xEE);
                DrawIconedString(w, w->strs[lpds->itemID], ypos, &xpos, FALSE);
                }
            
            /* not sure exactly what Windows means by sending us the value  *
             * (ODS_DISABLED | ODS_SELECTED), but it doesn't mean selection *
             * or loss of selection, so let's not process it (causes bugs   *
             * if we do).               -donato                             */
            if ( lpds->itemState != (ODS_DISABLED | ODS_SELECTED) )
                {
                /* the following call won't draw a string, it will *
                 * just return the start xpos (see function decl). */
                DrawIconedString(w, w->strs[lpds->itemID], ypos, &xpos, TRUE);
                /* the item in question is either being selected or it is *
                 * losing its selection rect. The following function does *
                 * an XOR to get the proper effect.                       */
                DrawSelectedString(lpds, xpos);
                }

            if ( lpds->itemState == (UINT)0 )
                {
                /* we are here when an item loses the focus rect, *
                 * and we need to draw the string since it wasn't *
                 * drawn previously.                              */
                DrawIconedString(w, w->strs[lpds->itemID], ypos, &xpos, FALSE);
                }
            break;

        case ODA_FOCUS:
            if ( lpds->itemState == (UINT)0 )
                {
                /* for multi-pick listboxes, this is where we get the *
                 * "loss of focus" message for an item; so draw an    *
                 * unselected string.                                 */
                if ( w->multi_pick )
                    {
                    /* clear any current material. */
                    if ( w->widgetColor )
                        DrawEmptyRect(lpds, w->widgetColor->any.pixel);
                    else
                        DrawEmptyRect(lpds, 0xEE);
                    DrawIconedString(w, w->strs[lpds->itemID],
                                        ypos, &xpos, FALSE);
                    }
                }
            break;
        }

    MS_RestoreDC(lpds->hDC, save_dc);
    REMOVE_DRAWABLE(w->window);
    w->window = NULL;
    return retval;
}

static void
DrawEmptyRect(LPDRAWITEMSTRUCT lpds, PIXEL_VALUE color)
{
    BOOL ret;
    HBRUSH hbrush, old_brush;

    if ( color == 0xEE )
        {
        /* clear to the work background.  Note: this uses the RGB value */
        /* a not a pixel offset because this can be called from the listbox */
        /* in the GE when the normal palette has been replaced, so the */
        /* indexes are not valid  - jon                                */
        hbrush = MS_CreateSolidBrush(BackWorkPixelRGB);
        }
    else
        /* a real color, sure hope the normal palette is in place! */
        hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(color));
    old_brush = MS_SelectObject(lpds->hDC, hbrush);
    ret = MS_PatBlt(lpds->hDC, lpds->rcItem.left, lpds->rcItem.top,
                    lpds->rcItem.right - lpds->rcItem.left,
                    lpds->rcItem.bottom - lpds->rcItem.top,
                    PATCOPY);
    MS_SelectObject(lpds->hDC, old_brush);
    MS_DeleteObject(hbrush);
}

static void
DrawSelectedString(LPDRAWITEMSTRUCT lpds, int xpos)
{
    BOOL ret;
    HBRUSH hbrush, old_brush;

    /* XOR a selection rect over the listbox item. */
    hbrush = MS_CreateSolidBrush(BackWorkPixelRGB);
    old_brush = MS_SelectObject(lpds->hDC, hbrush);
    ret = MS_PatBlt(lpds->hDC, xpos, lpds->rcItem.top,
                    lpds->rcItem.right - xpos,
                    lpds->rcItem.bottom - lpds->rcItem.top,
                    PATINVERT);
    MS_SelectObject(lpds->hDC, old_brush);
    MS_DeleteObject(hbrush);
}



static void
DrawIconedString(AXWidget_list w, register char *p, int ypos,
                    int *xpos_return, int return_xpos_only)
/* if return_xpos_only is TRUE, we don't draw anything, *
 * and simply return the text starting position.        */
{
    register int sub_len;
    char buf[1000], sub_buf[1000], *sub_p, *end_p, *strchr();
    int fontAscent;
    GC gc, backgc;
    Drawable drw, pkg_drw;
    int txt_attr;
    unsigned long col_attr, map_fg;
    pixcache_t *pixc;
    Pixmap pix;
    int pix_wid, txt_wid;
    unsigned long valuemask;
    XGCValues values;
    wcolor_t *stringColor;
    XFontStruct *savedFont;
    int xpos, line_height;
    int hscroll_height = 0;
    HDC src_hdc;
    HGDIOBJ old_obj;
    HPALETTE old_palette;
    BITMAP bm;
    int depth;
    int pix_height;
    int twid, curr_max_len;


    if ( w->monospace_font )
        {
        gc = MonospaceGC;
        backgc = MonospaceBackGC;
        }
    else
        {
        gc = w->disabled ? DisabledGC : ForeGC;
        backgc = BackGC;
        }
    /* we actually want the back WORK pixel color, but there's *
     * no GC for that, so set it here (we restore it below).   */
    if ( w->widgetColor )
        {
        backgc->values.foreground = w->widgetColor->any.pixel;
        }
    else
        backgc->values.foreground = BackWorkPixel;


    /* init local buffers */
    memset(buf, 0, sizeof(buf));
    memset(sub_buf, 0, sizeof(sub_buf));
    strncpy(buf,p,999);
    buf[999] = 0;
    p = buf;
    sub_p = sub_buf;
    sub_len = 0;
    txt_attr = 0;
    col_attr = MAXLONGINT;
    valuemask = GCForeground | GCBackground;

    line_height = xmListBoxLineHeight(w);

    if ( return_xpos_only )
        drw = pkg_drw = NULL;    /* don't draw anything. */
    else
        {
        /* we need a "packaged drawable" to send to X calls, 
         * and the real, actual drawable to send to MS calls.
         */
        pkg_drw = w->window;
        /* the window on a listbox will always be an HDC */
        drw = (HDC)GET_DRAWABLE_HANDLE(pkg_drw);
        }
    xpos = 0;

    /* set the line height and widget font ascent */
    if ( w->font )
        {
#if 0
        fontHeight = w->font->ascent + w->font->descent;
#endif
        fontAscent = w->font->ascent;
        }
    else
        {
#if 0
        fontHeight = AxCharHeight;
#endif
        fontAscent = AxCharAbove;
        }

    if ( w->monospace_font )
        {
        /* this declaration overrides widget font */
        savedFont = w->font;
        w->font = (XFontStruct *) NULL;
        } 

    /* read thru the string, handling each sub-element */
    while ( *p )
        {
        /* convert tabs to spaces */
        if ( *p == '\t' )
            *p = ' ';

        /* attribute info? */
        if ( *p == '\\'  && *(p+2) == '(' && (end_p = strchr(p+4,')')) )
            {
            /* if there is an outstanding string, draw it now */
            if ( sub_len )
                {
                XFontStruct *lsavedFont;
                lsavedFont = w->font;     /* in-line font attr may override */

                /* get the correct GC */
                if ( txt_attr )
                    {
                    if ( gc == backgc )
                        gc = BackGCFromAttr(w, txt_attr);
                    else
                        gc = GCFromAttr(w, txt_attr);
                    txt_attr = 0;

                    /* in-line font attribute overrides widget font */
                    w->font = (XFontStruct *) NULL;
                    }

                /* set the GC's color */
                if ( col_attr != MAXLONGINT )
                    {
                    XGetGCValues(Dpy, gc, valuemask, &values);
                    XSetForeground(Dpy, gc, col_attr);

                    /* allow in-line attr to override widget text color */
                    stringColor = (wcolor_t *) NULL;
                    }
                else
                    stringColor = w->textColor;

                /* draw the string */
                sub_buf[sub_len] = (char)0;
                txt_wid = BasicStrlen(sub_buf);
                if ( pkg_drw )
                    {
                    xmDrawString((AXWidget)w, pkg_drw, gc, xpos,
                                ypos + fontAscent, sub_buf, sub_len,
                                w->textShadow, stringColor, (wcolor_t*)NULL);
                    }
                sub_len = 0;

                /* restore widget's font attr */
                w->font = lsavedFont;

                /* restore the GC to it's default state */
                if ( col_attr != MAXLONGINT )
                    {
                    XSetForeground(Dpy, gc, values.foreground);
                    col_attr = MAXLONGINT;
                    }

                /* update the current draw position */
                xpos += txt_wid+2;
                }

            if ( *(p+1) == 'i' ) /* it's an icon */
                {
                /* get the correct GC */
                if ( txt_attr )
                    {
                    if ( gc == backgc )
                        gc = BackGCFromAttr(w, txt_attr);
                    else
                        gc = GCFromAttr(w, txt_attr);
                    txt_attr = 0;
                    }

                /* draw the (variable width) icon */
                *end_p = (char)0;
                pixc = Pixmapper((p+3));
                if ( pixc ) /* draw using width=pixmap width */
                    {
                    pix = pixc->pix;
                    pix_wid = pixc->width;
                    pix_height = pixc->height;
                    }
                else /* unknown pixmap: draw 16x16 of default (50% gray) */
                    {
                    pix = UnknownPixmap;
                    pix_wid = pix_height = 16;
                    }

                if ( pix_height > line_height )
                    {
                    /* force the height smaller so we do not overwrite other */
                    /* lines.  This may scale the pixmap                   */
                    pix_height = line_height;
                    }

                /* set the area behind the icon */
                if ( pkg_drw )
                    {
                    xmColorFillRectangle((AXWidget)w, pkg_drw, backgc, xpos,
                                            ypos, pix_wid + 3, line_height);
                    }
                /* color stuff uses images, not pixmaps */
                if ( col_attr != MAXLONGINT )
                    {
                    /* set the GC's color */
                    XGetGCValues(Dpy, gc, valuemask, &values);
                    if ( gc == backgc )
                        map_fg = values.background;
                    else
                        map_fg = values.foreground;

                    if ( drw )
                        {
                        old_palette = SelectAndRealizeAxWinPalette(drw);
                        /* select the pixmap into a mem dc for later blt'ing. */
                        src_hdc = MS_CreateCompatibleDC(NULL);
                        old_obj = MS_SelectObject(src_hdc, pix);

                        MS_SetBkColor(drw, GET_COLOR_VALUE(col_attr));
                        MS_SetTextColor(drw, GET_COLOR_VALUE(BackWorkPixel));

                        /* put the image onto the display */
                        if ( pixc && pixc->clip_mask )
                            {
                            XSetClipMask(Dpy, gc, pixc->clip_mask);
                            XSetClipOrigin(Dpy, gc, xpos, ypos);
                            }

                        MS_GetObject(pix, sizeof(BITMAP), (LPSTR) &bm);
                        MS_BitBlt(drw, xpos, ypos, bm.bmWidth, bm.bmHeight,
                                                    src_hdc, 0, 0, SRCCOPY);

                        if ( pixc && pixc->clip_mask )
                            {
                            XSetClipMask(Dpy, gc, None);
                            XSetClipOrigin(Dpy, gc, 0, 0);
                            }

                        /* restore the GC to it's default state */
                        XSetForeground(Dpy, gc, values.foreground);
                        col_attr = MAXLONGINT;

                        /* cleanup. */
                        MS_SelectObject(src_hdc, old_obj);
                        MS_DeleteDC(src_hdc);
                        UnSelectPalette(drw, old_palette);
                        }
                    }
                else /* copy from the icon pixmap to the listbox drawable */
                    {
                    MS_GetObject(pix, sizeof(BITMAP), &bm);
                    depth = bm.bmPlanes * bm.bmBitsPixel;
                    if (pixc && pixc->clip_mask)
                        {
                        XSetClipMask(Dpy, gc, pixc->clip_mask);
                        XSetClipOrigin(Dpy, gc, xpos, ypos);
                        }
                    if ( depth == 1 )
                        /* we actually want the back WORK pixel color, *
                         * but there's no GC for that, so set it here  *
                         * (we restore it below).                      */
                        gc->values.background = BackWorkPixel;

                    if ( pkg_drw )
                        {
                        XCopyArea(Dpy, pix, pkg_drw, gc, 0, 0, pix_wid,
                                                pix_height, xpos, ypos);
                        }

                    if ( depth == 1 )    /* restore GC */
                        gc->values.background = BackPixel;
                    if (pixc && pixc->clip_mask)
                        {
                        XSetClipMask(Dpy, gc, None);
                        XSetClipOrigin(Dpy, gc, 0, 0);
                        }   
                    }

                /* update the current draw position */
                xpos += pix_wid+3;
                }

            else if ( *(p+1) == 'a' ) /* it's a text attr */
                {
                *end_p = (char)0;
                txt_attr |= AttrFromName((p + 3));
                }

            else if ( *(p+1) == 'c' ) /* it's an rgb attr */
                col_attr = ColrFromName((p+3));

            /* update the source string pointer */
            p = end_p+1;
            }

        /* just a character */
        else
            {
            /* add the character to the string list */
            sub_buf[sub_len] = *p;
            sub_len++;

            /* update the source string pointer */
            p++;
            }
        }

    /* if there is a string remaining, draw it now */
    if ( sub_len )
        {
        XFontStruct *lsavedFont;
        lsavedFont = w->font;        /* in-line attr may override */

        /* get the correct GC */
        if ( txt_attr )
            {
            if ( gc == backgc )
                gc = BackGCFromAttr(w, txt_attr);
            else
                gc = GCFromAttr(w, txt_attr);

            /* allow in-line font attr to override widget font */
            w->font = (XFontStruct *) NULL;
            }

        /* set the GC's color */
        if ( col_attr != MAXLONGINT )
            {
            XGetGCValues(Dpy, gc, valuemask, &values);
            XSetForeground(Dpy, gc, col_attr);

            /* allow in-line attr to override widget text color */
            stringColor = (wcolor_t *) NULL;
            }
        else
            stringColor = w->textColor;

        /* draw the string */
        if ( pkg_drw )
            {
            xmDrawString((AXWidget)w, pkg_drw, gc, xpos, ypos + fontAscent,
                         sub_buf, sub_len, w->textShadow, stringColor,
                         (wcolor_t *) NULL);

            /* the string may be using its own "local" font, so reset the
             * horizontal scrolling length if necessary.
             */
            if ( w->list_hscroll )
                {
                twid = MeasureWinText(sub_buf, sub_len, gc->values.font);
                curr_max_len = MS_SendMessage(w->winid,LB_GETHORIZONTALEXTENT,
                                                        (WPARAM)0, (LPARAM)0);
                if ( twid > curr_max_len )
                    {
                    MS_SendMessage(w->winid, LB_SETHORIZONTALEXTENT,
                                            (WPARAM)twid, (LPARAM)0);
                    }
                }
            }
        *xpos_return = xpos;    /* return start of text string. */

        /* restore widget's font attr */
        w->font = lsavedFont;

        /* restore the GC to it's default state */
        if ( col_attr != MAXLONGINT )
            {
            XSetForeground(Dpy, gc, values.foreground);
            col_attr = MAXLONGINT;
            }
        }

    if ( w->monospace_font )
        {
        /* restore widget font */
        w->font = savedFont;
        }   
    /* restore BackGC */
    BackGC->values.foreground = BackPixel;
    MonospaceBackGC->values.foreground = BackPixel;
}


static GC
GCFromAttr(w, attr)
AXWidget_list w;
int attr;
{
    if ((attr & ATTR_MONO) || w->monospace_font) {
        if ((attr & ATTR_BOLD) && (attr & ATTR_ITAL))
            return(MonospaceItalBoldGC);
        else if (attr & ATTR_BOLD)
            return(MonospaceBoldGC);
        else if (attr & ATTR_ITAL)
            return(MonospaceItalGC);
        else
            return(MonospaceGC);   /* default for monospace */
    }
    /* attr not recognized - return gc for system default font */
    return(w->disabled ? DisabledGC : ForeGC);
}

static GC
BackGCFromAttr(w, attr)
AXWidget_list w;
int attr;
{
    if ((attr & ATTR_MONO) || w->monospace_font) {
        if ((attr & ATTR_BOLD) && (attr & ATTR_ITAL))
            return(MonospaceItalBoldBackGC);
        else if (attr & ATTR_BOLD)
            return(MonospaceBoldBackGC);
        else if (attr & ATTR_ITAL)
            return(MonospaceItalBackGC);
        else
            return(MonospaceBackGC);   /* default for monospace */
    }
    /* attr not recognized - return gc for system default font */
    return(BackGC);
}

static LRESULT
GetCurrentListboxSelection(AXWidget_list w)
{
    LRESULT cur_sel;

    if ( w->multi_pick )
        cur_sel = MS_SendMessage(w->winid, LB_GETCARETINDEX, 0, 0L);
    else
        cur_sel = MS_SendMessage(w->winid, LB_GETCURSEL, 0, 0L);
    return cur_sel;
}


static void
ResetListBox(AXWidget_list w)
{
    int ix, len;
    int need_to_reset = FALSE;
    int scroll_width = 0;
    int old_line_height;


    WIDGET_PARANOID(w, W_LIST);

    old_line_height = w->line_height;
    w->line_height = 0;       /* force line height to be recomputed */
    xmListBoxLineHeight( w );
    if ( w->line_height != old_line_height )
       MS_SendMessage(w->winid, LB_SETITEMHEIGHT,
                                  (WPARAM)0, MAKELPARAM(w->line_height,0) );
 
    /* clear old contents. */
    MS_SendMessage(w->winid, LB_RESETCONTENT, (WPARAM)0, 0L);
    if ( w->list_hscroll )
        {
        /* set horizontal extent to default of zero. *
         * it will be changed below, as needed.      */
        MS_SendMessage(w->winid, LB_SETHORIZONTALEXTENT, (WPARAM)0, 0L);
        }
    /* add new contents */
    for ( ix=0; ix < w->num_strs; ix++ )
        {
        if ( w->list_hscroll )
            {
            /* if this list box has a horizontal scrollbar, *
             * enable it if we need to.                     */
            len = GetListBoxStrLen(w->winid, w->strs[ix]);
            if ( len > scroll_width )
                {
                scroll_width = len;
                MS_SendMessage(w->winid, LB_SETHORIZONTALEXTENT,
                                                (WPARAM)scroll_width, 0L);
                }
            }

        MS_SendMessage(w->winid, LB_ADDSTRING, (WPARAM)NULL,
                                        (LPARAM)w->strs[ix]);
        }

    SetListboxSelection(w, TRUE);
}

static void
SetListboxSelection(AXWidget_list w, int resetting)
{
    int ix, top, cursel;
    int found_selection = FALSE;

    for ( ix=w->scroll_pos; ix < w->num_strs; ix++ )
        {
        if ( InIntsArray(w->selections, ix) )
            {
            found_selection = TRUE;
            /* set the current selection */
            if ( w->multi_pick )
                {
                /* must send LB_SETSEL to multi pick boxes */
                MS_SendMessage(w->winid, LB_SETSEL, (WPARAM)TRUE, (LPARAM)ix);
                }
            else
                MS_SendMessage(w->winid, LB_SETCURSEL, ix, 0L);
            }
        else if ( w->multi_pick )
            /* unselect multi selection. */
            MS_SendMessage(w->winid, LB_SETSEL, (WPARAM)FALSE, (LPARAM)ix);
        }

    /* if we haven't set a selection and we are scrolling and the number *
     * of list items is greater than the number of visible list items,   *
     * set the top item so the final elements of the listbox are visible.*/
    if ( resetting && !found_selection && (w->scroll_pos > 0) &&
                                (w->num_strs > w->scroll_max) )
        {
        if ( w->multi_pick )
            {
            /* must send LB_SETSEL to multi pick boxes. since we can't set
             * the "top index", we have to add the visible item height to
             * the position to get the correct index.
             */
            top = w->scroll_pos + w->scroll_max;
            MS_SendMessage(w->winid, LB_SETSEL, (WPARAM)TRUE, (LPARAM)top);
            }
        else
            {
            top = w->num_strs - w->scroll_max;
            MS_SendMessage(w->winid, LB_SETTOPINDEX, top, 0L);
            }
        }

    if ( !found_selection )
        {
        /* there is no current selection on the widget, but is there *
         * one on the screen?  if so, remove the selection.          */
        if ( w->multi_pick )
            cursel = MS_SendMessage(w->winid, LB_GETCARETINDEX, 0, 0L);
        else
            cursel = MS_SendMessage(w->winid, LB_GETCURSEL, 0, 0L);
        /* LB_ERR indicates no selection */
        if ( cursel != LB_ERR )
            {
            if ( w->multi_pick )
                MS_SendMessage(w->winid, LB_SETSEL, (WPARAM)FALSE, (LPARAM)-1);
            else
                MS_SendMessage(w->winid, LB_SETCURSEL, (WPARAM)-1, 0L);
            }
        } 
}



static int
AttrFromName(name)
register char *name;
{
    register char *p;

    p = name;
    while (*p) { 
        if ( isupper(*p) )  /* test for isupper needed on some machines */
            *p = (char) tolower(*p);
        p++;
    }
    if ( streq(name, NXLT("bold")) )
        return(ATTR_BOLD);
    else if ( streq(name, NXLT("ital")) || streq(name, NXLT("italic")) )
        return(ATTR_ITAL);
    else if ( streq(name, NXLT("mono")) || streq(name, NXLT("monospace")) )
        return(ATTR_MONO);
    else
        return(0);
}

static unsigned long
ColrFromName(name)
register char *name;
{
    register char *p;
    register char *end_p;
    register char *end_name;
    int r, g, b;
    unsigned long color;

    /* find the closing paren */
    p = name;
    end_name = strchr(p, ')');
    if ( !end_name )
        return ( MAXLONGINT );

    /* get the red */
    end_p = strchr(p, ',');
    if ( !end_p || end_p > end_name )
        return ( MAXLONGINT );
    else
    {
        *end_p = (char)0;
        r = atoi(p);
    }

    /* get the green */
    p = end_p+1;
    end_p = strchr(p, ',');
    if ( !end_p || end_p > end_name )
        return ( MAXLONGINT );
    else
    {
        *end_p = (char)0;
        g = atoi(p);
    }

    /* get the blue */
    p = end_p+1;
    end_p = strchr(p, ')');
    if ( !end_p || end_p > end_name )
        return ( MAXLONGINT );
    else
    {
        *end_p = (char)0;
        b = atoi(p);
    }

    AxGetRealPixel(0, r, g, b, 0, 255, &color);
    return(color);
}



int
xmListBoxLineHeight(AXWidget_list w_list)
{
    int xoff, yoff, lineHeight, iconed_height;
    int found_icon;
    int ix;
    mbchar *strP;
   
    WIDGET_PARANOID(w_list, W_LIST);
 
    if ( w_list->line_height > 0 )
       /* already computed, and constant for every line */
       return( w_list->line_height );

    /* Compute the line height and store it in the widget so we */
    /* do not have to repeat the search for iconed strings below */
    /* We are making all lines in a listbox a constant height     */
    if (w_list->font) {
        lineHeight = w_list->font->ascent + w_list->font->descent;
    }
    else {
        lineHeight = AxCharHeight;
    }
    if (wShadowIsOn(w_list->textShadow)) {
        xmTextShadowOffsets(w_list->font, &xoff, &yoff);
        lineHeight += yoff + 1;
    }
 
    iconed_height = found_icon = 0;
    for ( ix=0; ix<w_list->num_strs; ix++ )
       {
       /* look through all of the strings for an icon */
       strP = *(w_list->strs + ix);
       while ( *strP != (mbchar)0 )
          {
          if ( *strP == '\\' )
             {
             /* might be start of "special" field */
             if ( (*(strP+1) == 'i') && (*(strP+2) == '(') )
                {
                /* it is an icon */
                found_icon = TRUE;
                goto wrap_up;
                }
             }
           strP++;
          } 
       }
wrap_up:
    if ( found_icon )
        /* this is an iconed string, add a little extra room */
        iconed_height = lineHeight + 3;

    if ( iconed_height > lineHeight )
       lineHeight = iconed_height;

    w_list->line_height = lineHeight;    /* set for future reference */
 
    return (lineHeight);
}
/***************   end LISTBOX funcs   ********************************/



/*********************************************************************
 ****************** DIALOG EDITOR WIDGET PAINTERS ********************
 *********************************************************************/
/********************************************************************
 * A NOTE ABOUT THE "FAKE" PAINTERS: 
 * We use 2 device contexts, one "real" and one "packaged".
 * We send the packaged one to the X calls because they assume that any
 * UNpackaged handle is a bitmap. The actual DC we pass to the MS calls.
 *                                       -donato
 ********************************************************************/
static void
PaintFakeList(AXWidget_list w)
{
    axw_scrollbar w_scroll;    /* temp, fake scroll bar. */
    HBRUSH hbrush, old_brush;


    /* draw the main part of the list box. */
    AxWinDrawWidgetPoly((AXWidget)w);

    /* draw scrollbar *within* widget dimensions, just as
     * the real Windows painter does. 
     */
    /* fake a scroll bar and call the painter. */
    memset(&w_scroll, 0, sizeof(w_scroll));
    w_scroll.type = W_SCROLL;
    w_scroll.flags = WFLG_IN_EDIT;
    w_scroll.parent = w->parent;
    if ( !w->hide_vscroll )
        {
        /* draw vertical scroll bar. */
        w_scroll.xpos = w->xpos + w->width - Scrollbar_Thickness;
        w_scroll.ypos = w->ypos;
        w_scroll.width = Scrollbar_Thickness;
        if ( w->list_hscroll )
            w_scroll.height = w->height + 1 - Scrollbar_Thickness;
        else
            w_scroll.height = w->height + 1;
        w_scroll.display = TRUE;
        RealizeScrollBar(&w_scroll, SBS_VERT);
        }
    if ( w->list_hscroll )
        {
        /* draw horizontal scroll bar. */
        w_scroll.xpos = w->xpos;
        w_scroll.ypos = w->ypos + w->height - Scrollbar_Thickness;
        if ( !w->hide_vscroll )
            w_scroll.width = w->width + 1 - Scrollbar_Thickness;
        else
            w_scroll.width = w->width + 1;
        w_scroll.height = Scrollbar_Thickness;
        w_scroll.display = TRUE;
        RealizeScrollBar(&w_scroll, SBS_HORZ);
        }

    if ( !w->hide_vscroll && w->list_hscroll )
        {
        /* draw corner box */
        int remove_drawable;
        HDC hdc = InsureDrawable(w->parent->window, &remove_drawable);
        hbrush = MS_CreateSolidBrush(RecessPixelRGB);
        old_brush = MS_SelectObject(hdc, hbrush);
        MS_PatBlt(hdc, (w->xpos + w->width + 1 - Scrollbar_Thickness),
                        (w->ypos + w->height + 1 - Scrollbar_Thickness),
                        Scrollbar_Thickness - 1, Scrollbar_Thickness - 1,
                        PATCOPY);
        MS_SelectObject(hdc, old_brush);
        MS_DeleteObject(hbrush);
        if ( remove_drawable )
            RemoveDrawable(w->parent->window, hdc);
        }
}

static void
PaintFakeEnter(AXWidget w)
{
    if ( w->height <= 0 )
        w->height = Entry_Height;
    AxWinDrawWidgetPoly(w);
}

static void
PaintFakeEditbox(AXWidget w)
{
    axw_scrollbar w_scroll;    /* temp, fake scroll bar. */

    AxWinDrawWidgetPoly(w);

    /* fake a scroll bar and call the painter. */
    memset(&w_scroll, 0, sizeof(w_scroll));
    w_scroll.type = W_SCROLL;
    w_scroll.flags = WFLG_IN_EDIT;
    w_scroll.parent = w->parent;
    w_scroll.xpos = w->xpos + w->width - Scrollbar_Thickness;
    w_scroll.ypos = w->ypos;
    w_scroll.width = Scrollbar_Thickness;
    w_scroll.height = w->height + 1;
    w_scroll.display = TRUE;
    RealizeScrollBar(&w_scroll, SBS_VERT);
}

static void
PaintFakeOption(AXWidget_option w)
{
    int spacewid, text_width;
    int num_chars;
    int save_xpos, save_ypos;
    HDC hdc, pkg_dc;
    SIZE size;
    XFontStruct *ofont;
    data_ptr oShadow;
    HFONT old_font;
    int remove_dc;
    axw_push_button button_w;    /* used as temp */
	BITMAP bm;
	HBITMAP button_hbm;

    if ( w->font )
        {
        ofont = w->font;
        oShadow = w->textShadow;
        }
    else
        {
        ofont = AxDlgMainFont;
        oShadow = (data_ptr) NULL;
        }
    spacewid = XTextWidth(ofont, " ", 1);

    button_hbm = MS_LoadBitmap((HINSTANCE)NULL, (LPCTSTR)OBM_DNARROW);
	MS_GetObject(button_hbm, sizeof(BITMAP), &bm);
    w->height = bm.bmHeight + 4;    /* 4 = border */

    pkg_dc = w->parent->window;
    hdc = InsureDrawable(w->parent->window, &remove_dc);
    old_font = MS_SelectObject(hdc, ofont->fid);

    if ( w->style != W_COMBO_BOX )
	{
	    num_chars = strlen(w->name);
	   	if ( w->name && w->name[0] )
	   	    MS_GetTextExtentPoint32(hdc, w->name, num_chars, &size);
	   	else
			size.cx = 0;

    	/* draw widget label. */
    	xmDrawString((AXWidget)w, pkg_dc, ForeGC,
    	             w->xpos, w->ypos + wOptionFieldBaseline(ofont),
    	             w->name, num_chars, w->textShadow, w->labelColor,
    	             (wcolor_t *) NULL);

    	save_xpos = w->xpos;
    	save_ypos = w->ypos;
    	w->xpos = w->xpos + size.cx + spacewid;
    	w->ypos = w->ypos - 3;

    	if ( (w->strs != (char **)NULL) && (w->strs[0] != (char *)NULL) )
    	   {
    	   num_chars = strlen(w->strs[0]);
    	   text_width = XTextWidth(ofont, w->strs[0], num_chars);
    	   w->width = text_width + bm.bmWidth + 8;
    	   }
	}
	axmsDraw3dWidgetPoly((AXWidget)w);

    /*** draw the pulldown-button part of the option menu. ***/
    /* Create a dummy button widget which we use to draw the arrow */
    /* buttons and the slider                                          */
    memset( &button_w, 0, sizeof(button_w) );
    button_w.type = W_BUTTON;
    button_w.flags = WFLG_IN_EDIT;
    button_w.display = TRUE;
    button_w.xpos = w->xpos + w->width - 4;
    button_w.ypos = w->ypos;
    button_w.parent = w->parent;
    button_w.noBorder = FALSE;
    button_w.pixmapLabel = TRUE;
    button_w.name = NXLT("");
    /* use the bitmap that Windows provides us. */
    button_w.pixmap = button_hbm;
	button_w.xpos -= bm.bmWidth;
    PaintButton(&button_w, 0, 0, 0);
    MS_DeleteObject(button_hbm);

    if ( w->style != W_COMBO_BOX )
	{
    	/* set new widget width. */
    	w->width = w->width + size.cx + spacewid + 3;
    	/* restore original widget position values. */
    	w->xpos = save_xpos;
    	w->ypos = save_ypos;
	}
    MS_SelectObject(hdc, old_font);
    if ( remove_dc )
        RemoveDrawable(w->parent->window, hdc);
}

static void PaintFakeToggle(AXWidget_togglebutton w)
{
    int length;
    int textVoffset, buttonVoffset, labelXoffset;
    HDC hdc, pkg_dc;
    HPEN old_pen;
    HBRUSH hbrush, old_brush;
    HPALETTE old_palette;
    unsigned long pixel;
    int remove_dc;


    WIDGET_PARANOID(w, W_TOGGLE);
    pkg_dc = w->parent->window;
    hdc = InsureDrawable(w->parent->window, &remove_dc);
    old_palette = SelectAndRealizeAxWinPalette(hdc);

    /* draw toggle button using background brush. */
    if ( w->widgetColor )
        pixel = w->widgetColor->any.pixel;
    else
        pixel = BackPixel;
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(pixel));
    old_pen = MS_SelectObject(hdc, MS_GetStockObject(BLACK_PEN));
    old_brush = MS_SelectObject(hdc, hbrush);
    if ( w->in_radio || w->like_radio )
        {
        /* draw radio style (circle) toggle. */
        /* WE SHOULD PROBABLY USE A BITMAP FOR THIS. */
        MS_Arc(hdc, w->xpos, w->ypos,
                (w->xpos + TOGGLE_WIDTH),
                (w->ypos + TOGGLE_WIDTH),
                0, 0, 0, 0);
        /* draw filled circle to show 'on' state. */
        MS_SelectObject(hdc, MS_GetStockObject(BLACK_BRUSH));
        MS_Pie(hdc, w->xpos + 3, w->ypos + 3,
                (w->xpos + TOGGLE_WIDTH - 3),
                (w->ypos + TOGGLE_WIDTH - 3),
                0, 0, 0, 0);

        textVoffset = wToggleTextOffsets(w->font, TRUE, &buttonVoffset,
                                         &labelXoffset);   
        }
    else
        {
        MS_Rectangle(hdc, w->xpos, w->ypos,
                    (w->xpos + TOGGLE_WIDTH),
                    (w->ypos + TOGGLE_WIDTH));

        textVoffset = wToggleTextOffsets(w->font, FALSE, &buttonVoffset,
                                         &labelXoffset);  
        }
    MS_SelectObject(hdc, old_pen);
    MS_SelectObject(hdc, old_brush);
    UnSelectPalette(hdc, old_palette);

    /* draw toggle text. */
    length = strlen(w->name);
    xmDrawString((AXWidget)w, pkg_dc, ForeGC,
                w->xpos + TOGGLE_WIDTH + 2, w->ypos + textVoffset,
                w->name, length, w->textShadow, w->textColor,
                (wcolor_t *) NULL);
    if ( remove_dc )
        RemoveDrawable(w->parent->window, hdc);
}


/****************************************************************
 this paints the main body of the passed widget.
 ***/
static void
AxWinDrawWidgetPoly(AXWidget w)
{
    int num_chars;
    HDC hdc, pkg_dc;
    POINT points[5];
    HPEN old_pen;
    HBRUSH hbrush, old_brush;
    HPALETTE old_palette;
    unsigned long pixel;
    int remove_dc;

    pkg_dc = w->parent->window;
    hdc = InsureDrawable(w->parent->window, &remove_dc);
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    old_pen = MS_SelectObject(hdc, MS_GetStockObject(BLACK_PEN));

    if ( w->widgetColor )
        pixel = w->widgetColor->any.pixel;
    else
        pixel = BackWorkPixel;
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(pixel));
    old_brush = MS_SelectObject(hdc, hbrush);

    points[0].x = points[3].x = points[4].x = w->xpos;
    points[1].x = points[2].x = w->xpos + w->width;
    points[0].y = points[1].y = points[4].y = w->ypos;
    points[2].y = points[3].y = w->ypos + w->height;
    MS_Polyline(hdc, points, 5);
    MS_PatBlt(hdc, w->xpos + 1, w->ypos + 1,
                w->width - 1, w->height - 1,
                PATCOPY);
    /* if this is an option menu, draw the first string. */
    if ( w->type == W_OPTION )
        {
        if ( ((AXWidget_option)w)->strs[0] )
            {
            /*** on X, the strs in an option-menu are separate button   *
             *** widgets, and so we should be using the textColor on    *
             *** those widgets. however, we do not use separate widgets *
             *** on NT, so what to do?           -donato                */
            num_chars = strlen(((AXWidget_option)w)->strs[0]);
            xmDrawString(w, pkg_dc, ForeGC, w->xpos + 4,
                        w->ypos + (w->height - ((Scrollbar_Thickness/2)-3)),
                        ((AXWidget_option)w)->strs[0], num_chars,
                        w->textShadow, w->textColor, (wcolor_t *) NULL);
            }
        }

    MS_SelectObject(hdc, old_pen);
    MS_SelectObject(hdc, old_brush);
    MS_DeleteObject(hbrush);
    UnSelectPalette(hdc, old_palette);
    if ( remove_dc )
        RemoveDrawable(w->parent->window, hdc);
}

static void
axmsDraw3dWidgetPoly(AXWidget w)
{
    int num_chars;
    HDC hdc, pkg_dc;
    HPEN hPen, hSunPen, hShadowPen;
    HBRUSH hbrush, old_brush;
    HPALETTE old_palette;
    unsigned long pixel;
    int remove_dc;

	hPen       = MS_CreatePen(PS_SOLID, 1, GET_COLOR_VALUE(BackPixel));
    hSunPen    = MS_CreatePen(PS_SOLID, 1, GET_COLOR_VALUE(SunPixel));
    hShadowPen = MS_CreatePen(PS_SOLID, 1, GET_COLOR_VALUE(ShadowPixel));

    pkg_dc = w->parent->window;
    hdc = InsureDrawable(w->parent->window, &remove_dc);
    old_palette = SelectAndRealizeAxWinPalette(hdc);

	/* outer rect */
	axmsDrawTopLeftRect(hdc,hShadowPen, w->xpos,w->ypos,w->width,w->height, 1);
	axmsDrawBottomRightRect(hdc,hSunPen, w->xpos,w->ypos,w->width,w->height, 1);
	/* inner rect */
	axmsDrawTopLeftRect(hdc,MS_GetStockObject(BLACK_PEN), w->xpos+1,w->ypos+1,
										w->width-2,w->height-2, 1);
	axmsDrawBottomRightRect(hdc,hPen, w->xpos+1,w->ypos+1,
									  w->width-2,w->height-2, 1);

    if ( w->widgetColor )
        pixel = w->widgetColor->any.pixel;
    else
        pixel = BackWorkPixel;
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(pixel));
    old_brush = MS_SelectObject(hdc, hbrush);
    MS_PatBlt(hdc, w->xpos + 2, w->ypos + 2,
                w->width - 4, w->height - 4,
                PATCOPY);

    /* if this is an option menu, draw the first string. */
    if ( w->type == W_OPTION )
        {
        if ( ((AXWidget_option)w)->strs[0] )
            {
            /*** on X, the strs in an option-menu are separate button   *
             *** widgets, and so we should be using the textColor on    *
             *** those widgets. however, we do not use separate widgets *
             *** on NT, so what to do?           -donato                */
            num_chars = strlen(((AXWidget_option)w)->strs[0]);
            xmDrawString(w, pkg_dc, ForeGC, w->xpos + 4,
                        w->ypos + (w->height - ((Scrollbar_Thickness/2)-2)),
                        ((AXWidget_option)w)->strs[0], num_chars,
                        w->textShadow, w->textColor, (wcolor_t *) NULL);
            }
        }

    MS_SelectObject(hdc, old_brush);
    MS_DeleteObject(hbrush);
    UnSelectPalette(hdc, old_palette);
	MS_DeleteObject(hPen);
	MS_DeleteObject(hSunPen);
	MS_DeleteObject(hShadowPen);
    if ( remove_dc )
        RemoveDrawable(w->parent->window, hdc);
}
/***************   end DE widget painter funcs ***********************/


void
axmsDrawWidgetFocusRect(Window win, RECT *rect, int clear_area)
{
	HDC hdc;
	int delete_dc;
	HPALETTE old_palette;
	HBRUSH brush = NULL;

	hdc = InsureDrawable(win, &delete_dc);

	/* in some cases we want to "clear" the rect area because we may be
     * drawing a focus rect over an already existing one, but we don't
     * want to XOR it away.
	 */
	if ( clear_area )
		{
		brush = MS_CreateSolidBrush(GET_COLOR_VALUE(BackGC->values.foreground));
		old_palette = SelectAndRealizeAxWinPalette(hdc);
		FrameRect(hdc, rect, brush);   /* GDI call */
		}

	DrawFocusRect(hdc, rect);    /* GDI call */

	if ( clear_area )
		{
		MS_DeleteObject(brush);
		UnSelectPalette(hdc, old_palette);
		}
	if ( delete_dc )
		RemoveDrawable(win, hdc);
}

void
axmsUnDrawWidgetFocusRect(Window win, RECT *rect)
{
	HDC hdc;
	int delete_dc;
	HPALETTE old_palette;
	HBRUSH brush;

	hdc = InsureDrawable(win, &delete_dc);
	brush = MS_CreateSolidBrush(GET_COLOR_VALUE(BackGC->values.foreground));
	old_palette = SelectAndRealizeAxWinPalette(hdc);
	FrameRect(hdc, rect, brush);   /* GDI call */

	/* cleanup */
	MS_DeleteObject(brush);
	UnSelectPalette(hdc, old_palette);
	if ( delete_dc )
		RemoveDrawable(win, hdc);
}

/* this function is used to send a FocusIn event to home-grown widgets
 * that process it. As of now, only the table widget uses this to
 * update the blinking caret.
 */
void
axmsSendActivateMessageToWidget(AXWidget widget)
{
#if 0
	if ( widget->type == W_TABLE )
		MS_SendMessage(widget->winid, WM_ACTIVATE, WA_ACTIVE, (LPARAM)NULL);
#endif
}


int
axmsPutMnemonicInString(char *in_str,	/* IN */
						int accel_key,	/* IN */
						char **out_str	/* OUT: caller must free! */
						)
{
    int current_letter;
    int i, j, found;

    j = 0;
    found = 0;
    if ( !in_str )
		return 1;

	accel_key = toupper(accel_key);
	*out_str = (char*)malloc(strlen(in_str) + 2);
    for ( i=0; *in_str != '\0'; i++ )
        {
		current_letter = toupper(*in_str);
        /* insert a '&' if we find the mnemonic letter, or an actual *
         * ampersand. (Windows wants a '&&' to denote just one '&'). */
        if ( ((current_letter == accel_key) && (found != 1)) || *in_str == '&' )
            {
            /* if we are processing the ampersand, *
             * we haven't found the mnemonic yet.  */
            if ( *in_str != '&' )
                found = 1;
            (*out_str)[j++] = '&';
            (*out_str)[j++] = *in_str++;
            }
        else
            (*out_str)[j++] = *in_str++;
        }

    (*out_str)[j] = '\0';
	return 0;
}

void
axmsPaintLabel(AXWidget w)
{
	char *disp_name;
	HFONT hfont;
	int label_wid, label_hyt;

    if ( w->font )
        hfont = w->font->fid;
    else
        hfont = NormalDialogFont;

	AxWinGetTextWidthAndHeight(hfont, w->name, &label_wid, &label_hyt);

	axmsPutMnemonicInString(w->name, w->accelerator_key, &disp_name);

	if ( w->winid )
		{
		MS_SetWindowText(w->winid, disp_name);
		MS_InvalidateRect(w->winid, (CONST RECT*)NULL, FALSE);
		MS_UpdateWindow(w->winid);
		}
	else
		{
		w->winid = MS_CreateWindow(NXLT("STATIC"), disp_name,
                                    WS_CHILD | WS_VISIBLE | SS_LEFTNOWORDWRAP,
                                    w->xpos, w->ypos, // + STD_OPTION_YSHIFT,
                                    label_wid, label_hyt,
                                    w->parent->winid,
                                    (HMENU)NULL,
                                    (HANDLE)hInst, (LPVOID)NULL);
		}

	MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)hfont, 0L);
	free(disp_name);
}

void
axmsSetDialogWidgetFocus(AXWidget w)
{
	if ( !w )
		return;

	if ( (int)w->winid <= 0 )
		MS_SetFocus(w->parent->parent->winid);
	else if ( (int)w->winid > 1 )
	{
        /* only set focus if we are the foreground window, otherwise
         * we'll force the window to the front.    -donato
         */
        if ( MS_GetForegroundWindow() == w->parent->parent->winid )
			MS_SetFocus(w->winid);
	}
}

