/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ximcomm.h
   Applix ASC version: 10
   Date: Mon Nov 16 13:53:40 1998
*/
#ifndef XIMCOMM_INCLUDED
#define XIMCOMM_INCLUDED 1


#define XLS_BUF_LEN     250 /* max expected keystring */
#if BUILD_ORIENT
#include <xmlib.h>

/********************************************************************/
/* define the dallback data structre used for handling applicaitons */
/* when running the x input mechanism                               */
/********************************************************************/

typedef struct app_call_data {
    int task_pid;
    AXWidget_main xim_widget;
    Window event_win;
    wchar preedit_buf[XLS_BUF_LEN+1];
    XIMFeedback feedback[XLS_BUF_LEN];
    } app_call_data;



/** Here are the definitions for the structures used to communicate between */
/**  the input method callbacks, and the applications        */

typedef struct conversion_data {
    int command;
    int start_change;
    int change_len;
    int highlight_start;
    int highlight_end;
    int under_start;
    int under_end;
    XIC ic;
#if HP800
    XIM im;   /* as a hack on hp we use an input method per input-context */
#endif
    wchar wstr[2];     /* placeholder, may be extended with malloc */
    } conversion_data;


/** here are the various command codes **/
#define XIM_START_CONV 1
#define XIM_DONE_CONV 2
#define XIM_DRAW_CONV 3
#define XIM_START_CONV_MODE 4
#define XIM_DONE_CONV_MODE 5


#endif   /** BUILD_ORIENT **/

#endif   /*  XIMCOMM_INCLUDED */
