/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmcanvas.h
   Applix ASC version: 9
   Date: Mon Nov 16 13:53:43 1998
*/
#ifndef _xm_canvas_h_
#define _xm_canvas_h_

typedef struct {
	int type;
} CanvasAnyEvent;

typedef struct {
	int type;
	int x, y;
	int width, height;
	int count;		/* if non-zero, at least this many more */
} CanvasExposeEvent;

typedef struct {
	int type;
	int leftPoint, topPoint;
} CanvasScrollNotify;

typedef struct {
	int type;
	int which;			/* 1 - button1, 2 - button2, 3 - button3 */
	int x, y;
	int shifted;
	int controlled;
} CanvasButtonEvent;

typedef struct {
	int type;
	int which;			/* 1 - button1, 2 - button2, 3 - button3 */
	int x, y;
	int shifted;
	int controlled;
} CanvasDoubleClickEvent;

typedef struct {
	int type;
	int keycode;
	int shifted;
	int controlled;
} CanvasKeyPressEvent;

typedef union {
	CanvasAnyEvent any;
	CanvasExposeEvent expose;
	CanvasScrollNotify scrolled;
	CanvasButtonEvent button;
	CanvasKeyPressEvent key;
	CanvasDoubleClickEvent double_click;
} CanvasEventData;

typedef struct canvas_info {
	unsigned int use_grid:1,
	             supress_copy:1;
	int hgrid_size;     /* increment value in horiz dir for live scroll */
	int vgrid_size;     /* increment value in vert dir for live scroll */
	int topPoint;		/* scanline to display at top of canvas */
	short leftPoint;	/* xoffset to display at left of canvas */
	int paintWidth;		/* logical width of canvas */
	int paintHeight;	/* logical height of canvas */
	int incX;			/* increment X pixels */
	int incY;			/* increment Y pixels */
	int page_incX;		/* page increment in X pixels */
	int page_incY;		/* page increment in Y pixels */
	int winHeight;		/* slightly smaller than widget height */
	int winWidth;		/* slightly smaller than widget width */
} canvas_info;

#endif /* not _xm_canvas_h_ */
