/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmcombo.c
   Applix ASC version: 52
   Date: Fri Feb  5 21:11:57 1999
*/
#include <math.h>
#include <basicwin.h>
#if AX_X11
#include <X11/keysym.h>
#endif
#include <ax_xm.h>
#include <aos.h>
#include <dwt2xm.h>
#include <xmlib.h>
#include <elxwins.h>
#include <wchars.h>
#include <thimble.h>
#include <ctype.h>
#include <elf_env.h>
#include <eldata.h>
#include <evreason.h>
#include <xmpixel.h>
#include <intsarr.h>

/* Standard Externs for Widget Modules */
extern Window AxCrtWindow();
extern AXWidget CrtWidget();
extern pixcache_t *Pixmapper();
extern void AxDrawBevel();
extern void xmSetWidgetDisplay();
extern XFontStruct *lookupNamedFont();
extern XCharStruct *getCharStruct();

extern int AxLanguage;
extern int WidgetNeedsUpdated; /* Set when a widget needs repainted */
extern int AxCharAbove, AxCharHeight, AxCharBelow;
extern int AxOpenLook;
extern int AxBigFont;
extern int UseWidgetColors;
extern Display *Dpy;
extern short DpyDepth;
extern int AxButtonDown;
extern short THIMpid;

extern long WinMask;
extern XSetWindowAttributes WinAtt;
extern Pixmap UnknownPixmap;
extern AXWidget ClickWidget;
extern AXWidget_menu AxPulldownActive;
extern unsigned long BackWorkPixel;
extern Colormap WorkColormap;
extern GC ForeGC, BackGC;
extern GC SunGC, ShadowGC, DisabledGC, GrayLineGC;
extern GC RecessGC;
extern GC olClrSunButtonGC, olClrShadowButtonGC, olClrRecessButtonGC;
extern GC MonospaceGC;		 /* monspace system font, forground mode */
extern GC MonospaceBackGC;	 /* monspace system font, background mode */
extern GC MonospaceBoldGC, MonospaceBoldBackGC;
extern GC MonospaceItalGC, MonospaceItalBackGC;
extern GC MonospaceItalBoldGC, MonospaceItalBoldBackGC;
extern XFontStruct *AxDlgMainFont;	/* Bolded dialog font */
extern XFontStruct *MonospaceFont, *MonospaceBoldFont;
extern XFontStruct *MonospaceItalFont, *MonospaceItalBoldFont;
extern int DoubleMillisec;
extern unsigned long ForePixel;
extern unsigned long BackPixel;
extern short ColorDisplay;
extern int ThimExposuresMayBeComing;
extern short DpyWid, DpyHt;
extern short NoColor;
extern Window RootWin;
extern Cursor ThimCrosshairCursor;
extern Cursor ThimPointerCursor;
extern Cursor ThimLeftRightCursor;
extern Cursor ThimTextCursor;
extern unsigned long AlisPixels[];
extern unsigned long WidgetPixels[];
extern Window AxDummyWin;       /* un-mapped root window */
extern AXWidget_combo_box ComboBoxArmed;
extern int AxPulldownStayup;
extern int AxExitPulldownStayupMode;
extern AXWidget_scroll ScrollBarArmed; /* currently armed W_SCROLL */
extern void AxAutoScrollHandler(); /* xmlib.c */

/* End of Standard Externs */

extern Atom AxXA_COMBOBOX_PROP;
extern Atom AxXA_ENTER_PROP;

void PaintComboBox();
void PaintComboBoxPulldown();

typedef enum
{
  HIGHLIGHT,
  UNHIGHLIGHT
} highlight; /* also defined in editwin.c - should be in xwidgets.h? */

AXWidget_combo_box ComboBoxInEditWindow; /* combo box w/ cursor on */

#define MAX_XSTR 8000  /* length of seln to be inserted - same as in ATM */
/* IS_NGC adapted from ATM's tmin1.c definition */
#define BS ((unsigned) 0010)
#define DEL ((unsigned) 0177)  /* ascii code */
#define IS_NGC(c) ((((unsigned) (c)) < (unsigned) ' ') || \
                   (((unsigned) (c)) == DEL) || \
		   (((unsigned) (c)) == BS))

#if !BUILD_WIDE /* move to xmlib.h!! */
#define xmDrawString16 xmDrawString
#endif

#define BORDER_WIDTH 2 /* generic shadow borders */
#define TEXT_OFFSET  2 /* offset of text from border edge */

/* to match arrow sizes in xmarrow.c */
#define down1_width 16
#define down1_height 16

#define SCROLLBAR_THICK 16 /* FIXME, from xmlibcom.c */

typedef struct CbItem {
  mbchar *str;     /* the string in w->strs[] */
  int  orig_idx; /* original 0 based idx in w->strs[] */
} CbItem;

typedef struct CbxInfo {
    unsigned int need_vert_scrollbar : 1;
    unsigned int need_horiz_scrollbar : 1;
    int top_row;
    int left_x;
    int origin_shifted;
    int current_value;
    int last_value;       /* current_value val at last pulldown paint */
    int orig_value;       /* original value before pulldown initiated */
    int is_new;
    int choice_width;
    AXWidget_scroll active_scrollbar;
    CbItem *items; /* is non-null if sorted */
    mbchar *search_str;
    int maxlen;
} CbxInfo;

static CbxInfo cbx_info;

/* autoscroll vars ComboListArmed, comboListAutoscrollEdge
 */
extern AXWidget_combo_box ComboListArmed;
enum comboListEdge {
	noEdge = 0, leftEdge = 1, topEdge = 2, rightEdge = 3, bottomEdge = 4,
};
static enum comboListEdge comboListAutoscrollEdge;

#include "xmcombo.p"

/***********************************************************************
  function: AXmCreateComboBox - Create combo box widget.
  */
Widget
AXmCreateComboBox(parentWidget, name, args, cnt)
register AXWidget_dialog parentWidget;
register mbchar *name;
register Arg args[];
register int cnt;
{
    register AXWidget_combo_box w;
    register int already_exists = FALSE;

    if (args[0].value) {
		w = (AXWidget_combo_box) args[0].value;
		if (AXmNewFootprint((AXWidget)w, name, args, cnt)) {
			UnMapWidget((AXWidget)w);
		}
		w->update_widget = TRUE;
		WidgetNeedsUpdated = TRUE;
		already_exists = TRUE;
    }
    else {
		w = (AXWidget_combo_box)CrtWidget(W_COMBO_BOX, (AXWidget)parentWidget,
										  name);
    }
    w->painter = PaintComboBox;
    AxXtSetValues((AXWidget)w, args, cnt);
    w->num_pulldown_opts = 24;	/* number of options visible in the list box */
    CbResetCbxInfo(w);
    return((Widget) w);
}

/***********************************************************************
  Handle KeyPress event in the combo box pulldown, or edit window if active
  */
int ComboBoxKeyEvent(w, ksym, wbuf, nbytes, eventP)
AXWidget_combo_box w;
KeySym ksym;    /* keysym from key event */
wchar *wbuf; /* the displayable character */
int nbytes;     /* number of chars (only looked at for zero)  */
XEvent *eventP; /* the key event */
{
    int event_consumed = FALSE;
    int new_top;
    int new_value;
    int need_paint = FALSE;
    int list_moved = FALSE;
    int new_mark_idx;
    int surfaceWidth;

    if (!w)
		return(event_consumed);
    if (w->type != W_COMBO_BOX)
		return(event_consumed);
    if (eventP->xany.type != KeyPress)
		return(event_consumed);
	
    surfaceWidth = w->pulldown_width - BORDER_WIDTH;
    if (cbx_info.need_vert_scrollbar) {
		surfaceWidth -= SCROLLBAR_THICK;
    }

    if (AxPulldownStayup) {
		switch (ksym) {
		case XK_Escape:
			event_consumed = TRUE;
			ResetActive();
			if (cbx_info.items)
				(void) free(cbx_info.items);
			CbResetCbxInfo(w);
			return(TRUE);
			break;
		case XK_Up:
			event_consumed = TRUE;
			CbTossSearchStr();
			new_mark_idx = CbGetSortedDex(w, cbx_info.current_value) - 1;
			if (new_mark_idx < 0) {
				if (cbx_info.top_row) {
					need_paint = TRUE;
					list_moved = TRUE;
				}
				cbx_info.top_row = 0;
				break;
			}
			new_value = CbGetOrigIdx(w, new_mark_idx);
			if ((new_mark_idx >= cbx_info.top_row) &&
				(new_mark_idx < cbx_info.top_row + w->num_pulldown_opts)) {
			
				CbSetCbxCurrentValue(w, new_value);
				need_paint = TRUE;
			}
			else if (new_mark_idx < cbx_info.top_row) {
				cbx_info.top_row = new_mark_idx;
				CbSetCbxCurrentValue(w, new_value);
				need_paint = TRUE;
				list_moved = TRUE;
			}
			else if (new_mark_idx >= cbx_info.top_row + w->num_pulldown_opts) {
				cbx_info.top_row = new_mark_idx - w->num_pulldown_opts + 1;
				if (cbx_info.top_row > w->num_buttons - 1) {
					cbx_info.top_row = w->num_buttons - 1;
				}
				CbSetCbxCurrentValue(w, new_value);
				need_paint = TRUE;
				list_moved = TRUE;
			}
			break;
		case XK_Down:
			event_consumed = TRUE;
			CbTossSearchStr();
			new_mark_idx = CbGetSortedDex(w, cbx_info.current_value) + 1;
			new_value = CbGetOrigIdx(w, new_mark_idx);
			if (new_mark_idx >= w->num_buttons) {
				int itmp = w->num_buttons - w->num_pulldown_opts;
				if (itmp != cbx_info.top_row) {
					need_paint = TRUE;
					list_moved = TRUE;
				}
				cbx_info.top_row = itmp;
				break;
			}
			if ((new_mark_idx >= cbx_info.top_row) &&
				(new_mark_idx < cbx_info.top_row + w->num_pulldown_opts)) {
				CbSetCbxCurrentValue(w, new_value);
				need_paint = TRUE;
			}
			else if (new_mark_idx >=
					 (cbx_info.top_row + w->num_pulldown_opts)) {
				
				cbx_info.top_row = new_mark_idx - w->num_pulldown_opts + 1;
				CbSetCbxCurrentValue(w, new_value);
				need_paint = TRUE;
				list_moved = TRUE;
			}
			else if (new_mark_idx < cbx_info.top_row) {
				cbx_info.top_row = new_mark_idx;
				CbSetCbxCurrentValue(w, new_value);
				need_paint = TRUE;
				list_moved = TRUE;
			}
			break;
		case XK_Right:
			event_consumed = TRUE;
			if (cbx_info.need_horiz_scrollbar) {
				cbx_info.left_x += 15;
				cbx_info.left_x = MIN(cbx_info.left_x,
									  cbx_info.maxlen - surfaceWidth);
				need_paint = TRUE;
				list_moved = TRUE;
			}
			break;
		case XK_Left:
			event_consumed = TRUE;
			if (cbx_info.need_horiz_scrollbar) {
				cbx_info.left_x -= 15;
				cbx_info.left_x = MAX(0, cbx_info.left_x);
				need_paint = TRUE;
				list_moved = TRUE;
			}
			break;
		case XK_Return:
		case XK_Execute:
			event_consumed = TRUE;
			CbFinish(w, FALSE);
			break;
		case XK_Tab:
			event_consumed = FALSE;	/* toss back tab keys */
			break;
		default:
			if (eventP->xkey.state & ControlMask)
				return(FALSE);	/* dump back controlled keys */
			if (!EditWinIsPrintable((AXWidget)w, wbuf, nbytes))
				return(FALSE);
			event_consumed = TRUE;
			CbIncrSearch(w, wbuf, nbytes);
			break;
		}
    }
    else if (ComboBoxInEditWindow) { /* we're in the edit window */
		event_consumed = EditWinManageKeyPress((AXWidget)w, &(w->edit_win),
											   ksym, wbuf, nbytes, eventP);
    }
    if (need_paint) {
		CbPaintPulldown(w, list_moved);
		CbUpdateScrollbars(w);
    }
    return(event_consumed);
}

/**************************************************************************
  ComboBoxMouseEvent - handle mouse events (button press/release,
  motion) in the combo box.  Returns true if Combo Box is already
  armed on ButtonPress.
**************************************************************************/

int ComboBoxMouseEvent(w, eventP)
AXWidget_combo_box w;
XEvent *eventP;
{
	
    if (w->disabled)
		return FALSE;
	
    if ((eventP->xany.window == w->edit_win.win) &&
		(w->flags & WFLG_EDITABLE)) {
		switch (eventP->type) {
		case ButtonPress:
			EditWinManageButtonPress((AXWidget)w, &(w->edit_win), eventP);
			break;
		case ButtonRelease:
			EditWinManageButtonRelease((AXWidget)w, &(w->edit_win), eventP);
			break;
		case MotionNotify:
			EditWinManageMouseMotion((AXWidget)w, &(w->edit_win), eventP);
			break;
		}
    } else {
		/* handle events outside the edit window (i.e., in pulldown or
		   on arrow */
    
		/* reset cursor if we were just in edit window.  It's safe to use
		   ComboBoxInEditWindow here, since the only time we'll get these
		   mouse events when ComboBoxInEditWindow != NULL is if it equals w */
		if (ComboBoxInEditWindow) {
			ComboBoxInEditWindow = NULL;
			EditWinDrawCursor((AXWidget)w, &(w->edit_win), TC_ERASE);
		}
    
		switch (eventP->type) {
		case ButtonPress:
			if (ComboBoxArmed) {
				if (AxPulldownStayup) {
					PaintComboBoxPulldown(ComboBoxArmed, OPTION_STAYUP_SELECT,
										  eventP);
					break;
				}
				return(TRUE);
			} else {
				PaintComboBoxPulldown(w, OPTION_NEW, eventP);
				break;
			}
		case ButtonRelease:
			ComboListArmed = (AXWidget_combo_box) NULL;
			PaintComboBoxPulldown(ComboBoxArmed, OPTION_DONE, eventP);
			break;
		case MotionNotify:
			if (w->pulldown && Button1 == AxButtonDown) {
				if (!ComboListArmed) {
					/* test whether to start autoscroll
					 */
					comboListAutoscrollEdge = mouseOutsideComboList(w, eventP);
					if (noEdge != comboListAutoscrollEdge) {
						ComboListArmed = w;    /* start autoscroll */
					}
				}
				else if (ComboListArmed) {
					/* test whether to stop autoscroll
					 */
					comboListAutoscrollEdge = mouseOutsideComboList(w, eventP);
					if (noEdge == comboListAutoscrollEdge) {
						ComboListArmed = (AXWidget_combo_box) NULL;
					}
				}
			}
			PaintComboBoxPulldown(ComboBoxArmed, OPTION_MOVE, eventP);
			break;
		}
    }
    return(FALSE);
}

int ComboBoxSelectionCB(w, ev)
AXWidget_combo_box w;
XEvent *ev;
{
    Atom prop, actual_type;
    long long_size;
    unsigned long nitems, bytes_after, *data;
    int len, actual_format;
    int changed = FALSE;
    int ix;
    wchar *wbuf = NULL;
    mbchar *buf = NULL;
    mbchar *p;

    if (!w)
        return(FALSE);
    if (w->type != W_COMBO_BOX)
        return(FALSE);
    if (!ev)
        return(FALSE);
    if (ev->xany.type != SelectionNotify)
        return(FALSE);

    prop = ev->xselection.property;
    if (prop != AxXA_COMBOBOX_PROP)
        return;
    long_size = MAX_XSTR/ sizeof(long);
    if (XGetWindowProperty(Dpy, w->window, prop, 0, long_size, False,
                           AnyPropertyType, &actual_type,
                           &actual_format, &nitems, &bytes_after,
                           (unsigned char **) &data) != Success)
        return(TRUE);
	
	XDeleteProperty(Dpy, w->window, prop);

    if (actual_type != XA_STRING)
        return(TRUE);

    buf = (mbchar *)malloc( strlen((char *)data) + 1 );

    /* Accept buffer, ignoring newline chars  */
    for (ix = 0, p = (mbchar *)data; *p; p++) {
		if (*p == '\n')
			continue;
		buf[ix] = (mbchar)*p;
		ix++;
    }
    buf[ix] = '\0';

#if BUILD_WIDE
    wbuf = (wchar *) malloc(sizeof(wchar) * (strlen(buf) + 1));
    MbToWStr((mbchar *)buf, wbuf);
    EditWinInsertText((AXWidget)w, &(w->edit_win), wbuf);
	free(wbuf);
#else
    EditWinInsertText((AXWidget)w, &(w->edit_win), buf);
#endif
    
    free( buf );
    return(TRUE);
}

/***********************************************************************
  function: PaintComboBox - Paint the combo box.
  Must not make use of 'cbx_info'!!
  'cbx_info' comes alive ONLY after OPTION_NEW.
  */
void
PaintComboBox(w, exP, regen, layered)
register AXWidget_combo_box w;
XExposeEvent *exP;
int regen;
int layered;
{
    unsigned int choice_width, arrow_width;
    unsigned int combo_height;
    int char_above;
    int recreate_edit_win = FALSE;
    XSetWindowAttributes atts;
    unsigned long mask;
    int editWidth, editHeight;

    if (!w)
		return;
    if (!WIN_OF(w))
		return;
    if (w->type != W_COMBO_BOX)
		return;
    if ((w->flags & WFLG_IN_EDIT) && layered) {
		if (dePaintWidget((AXWidget)w))
			return;
    }
    if (!w->mapped)
		w->mapped = TRUE;
    w->height = CbComputeComboHeight(w->font);
    if (!w->window) {
		if (w->flags & WFLG_IN_EDIT) {
			/* in dialog editor; use pixmap rather than window */
			w->window = AxCreateQueryPixmap(Dpy, w->parent->window,
											w->width, w->height, DpyDepth);
			xmColorFillRectangle((AXWidget)w, w->window, BackGC, 0, 0,
								 w->width, w->height);
		}
		else {
			mask = WinMask;
			atts = WinAtt;
			mask |= (CWBackPixel | CWColormap);
			atts.background_pixel = BackWorkPixel;
			atts.colormap = WorkColormap;
			w->window = AxCrtWindow(Dpy, WIN_OF(w), w->xpos, w->ypos,
									w->width, w->height, 0, CopyFromParent,
									InputOutput, CopyFromParent, mask, &atts);
			XSelectInput(Dpy, w->window,
						 (TM_ALL_INPUTS_MASK | Button1MotionMask));
			XMapWindow(Dpy, w->window);
			AddToWindowList((AXWidget)w);
		}
		recreate_edit_win = TRUE;
    }
	
    EditWinWidthHeight((AXWidget)w, &editWidth, &editHeight);
	
    if (recreate_edit_win) {
		mask = WinMask;
		mask |= (CWBackPixel | CWColormap);
		atts = WinAtt;
		atts.background_pixel = BackWorkPixel;
		atts.colormap = WorkColormap;
		if (w->flags & WFLG_EDITABLE) {
			mask |= CWCursor;
			atts.cursor = ThimTextCursor;
		}
		if (w->flags & WFLG_IN_EDIT) {
			/* in dialog editor; use pixmap rather than window */
			w->edit_win.win =
				AxCreateQueryPixmap(Dpy, w->parent->window,
									editWidth + BORDER_WIDTH,
									editHeight + BORDER_WIDTH,
									DpyDepth);
		}
		else {
			w->edit_win.win =
				AxCrtWindow(Dpy, w->window, BORDER_WIDTH,
							BORDER_WIDTH, editWidth, editHeight,
							0, CopyFromParent, InputOutput, CopyFromParent,
							mask, &atts);
			XSelectInput(Dpy, w->edit_win.win,
						 (TM_ALL_INPUTS_MASK | Button1MotionMask));
			XMapWindow(Dpy, w->edit_win.win);
			AXDefineDefaultCursor((AXWidget)w, atts.cursor);
		}
    }
  
    CbPaintCombo(w);
    if (!(w->flags & WFLG_IN_EDIT) && (w->flags & WFLG_EDITABLE)
		&& w->pending_delete) {
		CbActivateEditWin(w);
    }
    if (w->pulldown) {
		CbPaintPulldown(w, TRUE);
		CbUpdateScrollbars(w);
    }
    return;
}

/***********************************************************************
  Event in combo box pulldown.  'mode' can be one of the following:
  OPTION_NEW for initial ButtonPress.
  OPTION_STAYUP_SELECT for ButtonPress in pulldown window.
  OPTION_DONE for ButtonRelease in pulldown window.
  */
void
PaintComboBoxPulldown(w, mode, eventP)
register AXWidget_combo_box w;
int mode;
XEvent *eventP;
{
    int scrollbarHeight = 0;
    int pulldownTextWidth;
    int char_height, char_above;
    int actual_y;
	int pull_off = FALSE;
  
    if (!w)
		return;
    if (!w->display)
		return;
    w->mapped = TRUE;
    if (w->font)
		char_height = w->font->max_bounds.ascent + w->font->max_bounds.descent;
    else
		char_height = AxCharHeight;
    if (w->font)
		char_above = w->font->max_bounds.ascent;
    else
		char_above = AxCharAbove;
	
    /* find actual position relative to pulldown */
    if (eventP->xany.window == w->pulldown) {
		actual_y = eventP->xbutton.y;
    } else if (eventP->xany.window == w->edit_win.win) {
		actual_y = eventP->xbutton.y - (w->height - BORDER_WIDTH);
		/* compensate for possible vertical shift */
		actual_y = actual_y - cbx_info.origin_shifted;
    } else {
		/* decrease by the height of the combo box window */
		actual_y = eventP->xbutton.y - w->height;
		/* compensate for possible vertical shift */
		actual_y = actual_y - cbx_info.origin_shifted;
    }

    if (cbx_info.need_horiz_scrollbar)
		scrollbarHeight = SCROLLBAR_THICK;

    pulldownTextWidth = w->pulldown_width - BORDER_WIDTH;
    if (cbx_info.need_vert_scrollbar)
		pulldownTextWidth -= SCROLLBAR_THICK;


    switch (mode) {
		
    case OPTION_NEW:
		CbOpenComboPulldown(w);
		break;

    case OPTION_MOVE: /* moving within the combo box (button is depressed) */

		/* make sure initial click was not in scrollbar */
		if (!cbx_info.active_scrollbar) {

			/* if we're not in pulldown, un-highlight pulldown choices */
			if ((actual_y > (w->pulldown_height - scrollbarHeight)) ||
				(eventP->xbutton.x > pulldownTextWidth) || 
				(eventP->xbutton.x < 0) ||
				(actual_y < 0))
				{
					/* hack to get CbPaintPulldown to unfill row */
					cbx_info.last_value = cbx_info.current_value;
					CbSetCbxCurrentValue(w, -1);
				}
			else {
				/* find what row we're in */
				int selected_row;
				selected_row = CbClickedRow(w, actual_y);

				if (selected_row != -1) { /* we're in the pulldown */

					cbx_info.is_new = FALSE;

					if (cbx_info.items)
						selected_row = CbGetOrigIdx(w, selected_row);
	  
					/* only redraw if selected row has changed */
					if (cbx_info.current_value != selected_row) {
						CbSetCbxCurrentValue(w, selected_row);
					}
					else
						break;

				} else			/* we're in the combo box, not the pulldown */
					break;
			}

			CbPaintPulldown(w, FALSE);
		}
		break;

    case OPTION_DONE:			/* button-release */
		if (AxPulldownStayup || CbEnterStayup(w)) {
			;					/* Highlight stuff */
		}
		if (!ComboBoxArmed) {
			ComboBoxArmed = w;
			break;
		}
		if (eventP->xany.type != ButtonRelease)
			break;				/* huh? */

		/* Combo box is armed.  The pulldown box is up, and event is
		   ButtonRelease. */
		if (cbx_info.is_new == TRUE) {
			cbx_info.is_new = FALSE;
			break;
		}
		/* button-release in scrollbar */
		if (cbx_info.active_scrollbar) {
			XEvent event;

			/*			event.xany.type = ButtonRelease;
						event.xany.display = Dpy;
						event.xany.window = cbx_info.active_scrollbar->window;
						event.xbutton.x = (eventP->xbutton.x -
						cbx_info.active_scrollbar->xpos);
						event.xbutton.y = (eventP->xbutton.y -
						cbx_info.active_scrollbar->ypos);
						ScrollBarEvent(cbx_info.active_scrollbar,&event); */
			cbx_info.active_scrollbar = NULL;
			break;
		}
		
		if (w->vScrollBar && w->hScrollBar) {
			/* test for button-release in corner box */
			if ((eventP->xbutton.x >= w->vScrollBar->xpos) &&
				(eventP->xbutton.y >= w->hScrollBar->ypos) &&
				(eventP->xbutton.x <= w->pulldown_width) &&
				(eventP->xbutton.y <= w->pulldown_height))
				break;	 /* in the corner box -- don't tear down window */
		}

		/* if pointer is outside of pulldown, reset to original
		   value -- made necessary by OPTION_MOVE behavior */
		if ((eventP->xbutton.x < 0) ||
			(eventP->xbutton.x > pulldownTextWidth) ||
			(actual_y < 0) ||
			(actual_y > (w->pulldown_height - scrollbarHeight))) {
		
			CbSetCbxCurrentValue(w, cbx_info.orig_value);
			pull_off = TRUE;
		}

		/* done -- tear down pulldown, send value if changed */
		CbFinish(w, pull_off);
		break;

    case OPTION_STAYUP_SELECT:	/* button-press */
		if (eventP->xany.type == ButtonPress) {
			XEvent event;
			memset((char *) &event, '\0', sizeof(XEvent));
			if (w->vScrollBar &&
				(eventP->xbutton.x >= w->vScrollBar->xpos) &&
				(eventP->xbutton.x < (w->vScrollBar->xpos +
									  w->vScrollBar->width)) &&
				(eventP->xbutton.y >= w->vScrollBar->ypos) &&
				(eventP->xbutton.y < (w->vScrollBar->ypos +
									  w->vScrollBar->height))) {
				
				event.xany.type = ButtonPress;
				event.xany.display = Dpy;
				event.xany.window = w->vScrollBar->window;
				event.xbutton.x = eventP->xbutton.x - w->vScrollBar->xpos;
				event.xbutton.y = eventP->xbutton.y - w->vScrollBar->ypos;
				ScrollBarArmed =
					cbx_info.active_scrollbar =
						(AXWidget_scroll) w->vScrollBar;
				ScrollBarEvent(w->vScrollBar,&event);
				AxAutoScrollHandler();
				return;
			}
			if (w->hScrollBar &&
				(eventP->xbutton.x >= w->hScrollBar->xpos) &&
				(eventP->xbutton.x < (w->hScrollBar->xpos +
									  w->hScrollBar->width)) &&
				(eventP->xbutton.y >= w->hScrollBar->ypos) &&
				(eventP->xbutton.y < (w->hScrollBar->ypos +
									  w->hScrollBar->height))) {
				event.xany.type = ButtonPress;
				event.xany.display = Dpy;
				event.xany.window = w->hScrollBar->window;
				event.xbutton.x = eventP->xbutton.x - w->hScrollBar->xpos;
				event.xbutton.y = eventP->xbutton.y - w->hScrollBar->ypos;
				ScrollBarArmed =
					cbx_info.active_scrollbar =
						(AXWidget_scroll) w->hScrollBar;
				ScrollBarEvent(w->hScrollBar, &event);
				AxAutoScrollHandler();
				return;
			}
			
			/* event not in any scrollbar */
			cbx_info.active_scrollbar = NULL;
			if (w->vScrollBar && w->hScrollBar &&
				(eventP->xbutton.x >= w->vScrollBar->xpos) &&
				(eventP->xbutton.y >= w->hScrollBar->ypos) &&
				(eventP->xbutton.x <= w->pulldown_width) &&
				(eventP->xbutton.y <= w->pulldown_height))
				break;			/* in the corner box */
			
			if (cbx_info.need_horiz_scrollbar)
				scrollbarHeight = SCROLLBAR_THICK;
			else
				scrollbarHeight = 0;

			/* button-press in list area */
			if ((eventP->xbutton.x >= 0) &&
				(eventP->xbutton.x <= cbx_info.choice_width) &&
				(eventP->xbutton.y >= 0) &&
				(eventP->xbutton.y <=
				 (w->pulldown_height - scrollbarHeight))) {
				int clicked_row;
				clicked_row = CbClickedRow(w, eventP->xbutton.y);
				if (clicked_row != -1) {
					if (cbx_info.items)
						clicked_row = CbGetOrigIdx(w, clicked_row);
					CbSetCbxCurrentValue(w, clicked_row);
					CbPaintPulldown(w, FALSE);
				}
			}
		}
		break;

    default:
		break;
    }
    return;
}

/* : CbOpenComboPulldown - sub called from PaintComboBoxPulldown,
 * and from the combo box key-handling code in xmlib.c:ComboKeyPressEvent
 */
void
CbOpenComboPulldown(w)
AXWidget_combo_box w;
{
#if AX_X11
    XSetWindowAttributes atts;
#endif
    Window child;
    long att_mask;
    int pulldown_xpos, pulldown_ypos;
    int char_height, char_descent;

    if (w->hasFocus) {
		ComboBoxInEditWindow = NULL;
		EditWinDrawCursor((AXWidget)w, &(w->edit_win), TC_ERASE);
    }

    if (w->font) {
		char_height = w->font->max_bounds.ascent + w->font->max_bounds.descent;
		char_descent = w->font->max_bounds.descent;
	}
    else {
		char_height = AxCharHeight;
		char_descent = AxCharBelow;
	}

    CbResetCbxInfo(w);
    cbx_info.top_row = 0;
    cbx_info.origin_shifted = 0;
    cbx_info.maxlen = w->maxLen + TEXT_OFFSET + TEXT_OFFSET;
    XTranslateCoordinates(Dpy, w->window, RootWin, 0, w->height,
						  &pulldown_xpos, &pulldown_ypos, &child);
    w->pulldown_width = w->width;
    if (w->pulldown_width - SCROLLBAR_THICK < cbx_info.maxlen) {
		cbx_info.need_horiz_scrollbar = TRUE;
    }
    else {
		cbx_info.need_horiz_scrollbar = FALSE;
    }
	
    if (w->num_buttons <= w->num_pulldown_opts) {
		w->pulldown_height = ((BORDER_WIDTH + char_height) *
							  w->num_buttons) + BORDER_WIDTH;
		w->num_pulldown_opts = w->num_buttons;
		cbx_info.need_vert_scrollbar = FALSE;
    } else {
		w->pulldown_height = ((BORDER_WIDTH + char_height) *
							  w->num_pulldown_opts) + BORDER_WIDTH;
		cbx_info.need_vert_scrollbar = TRUE;
    }
	
    if (cbx_info.need_horiz_scrollbar) {
		w->pulldown_height += SCROLLBAR_THICK;
    }
	
	w->pulldown_height += char_descent;
	
    /* check if we need to shift the pulldown vertically to keep it fully in
       the display */
    cbx_info.origin_shifted = CbShiftOrigin(&pulldown_ypos, w->pulldown_height);
    w->pulldown_xpos = pulldown_xpos;
    w->pulldown_ypos = pulldown_ypos;
	
#if AX_X11
    att_mask = CWOverrideRedirect | CWSaveUnder | CWBackPixel | CWCursor;
    atts.override_redirect = TRUE;
    atts.save_under = TRUE;
    atts.background_pixel = BackPixel;
    atts.cursor = ThimPointerCursor;
    w->pulldown = AxCrtWindow(Dpy, RootWin,
							  w->pulldown_xpos, w->pulldown_ypos,
							  w->pulldown_width, w->pulldown_height,
							  0, CopyFromParent, InputOutput, CopyFromParent,
							  att_mask, &atts);
    XMapWindow(Dpy, w->pulldown);
#endif
	
    /* creating pulldown */
#if 0
    CbSortList(w);
#endif
    cbx_info.top_row = CbComputeTopRow(w, CbGetSortedDex(w, w->value));
    if (cbx_info.top_row < 0)
		cbx_info.top_row = 0;	/* sanity */
    CbPaintPulldown(w, TRUE);
    CbUpdateScrollbars(w);
    ComboBoxArmed = w;
    cbx_info.is_new = TRUE;
}

/***********************************************************************
  Tear down pulldown and send value if changed.
  */
void
CbFinish(w, suppress_callback)
AXWidget_combo_box w;
int suppress_callback;  /* bool: if true, suppress callback if no valchange */
{
    XmRowColumnCallbackStruct data;
    int value_changed = FALSE;
	int reset_edit_win = FALSE;
	int do_callback = FALSE;
#if BUILD_WIDE
	/* ELF string must be in mbchar.	Ashisuto added, 1998.02.25 */
	mbchar	*mbstr = NULL;
#endif
	
    ThimExposuresMayBeComing = TRUE;
    ResetActive();				/* tear down pulldown */
	
	if (suppress_callback) {
		/* do_callback if a) user has mouse-selected some new dropdown value,
		 * or b) the combo is editable and has been typed into.
		 */
		do_callback = (cbx_info.current_value != cbx_info.orig_value) ||
			((w->flags & WFLG_EDITABLE) && w->edit_win.edited);
	}
	else {
		do_callback = TRUE;
	}

    if (do_callback && ((cbx_info.current_value != -1) ||
						((w->flags & WFLG_EDITABLE) && w->edit_win.edited))) {

		value_changed = TRUE;
		memset((void *) &data, 0, sizeof(XmRowColumnCallbackStruct));
		if ((w->flags & WFLG_EDITABLE) && w->edit_win.edited) {
			/* this is an editable combo into which "none of the above"
			 * has been entered; the value is that variable string
			 */
#if BUILD_WIDE
			mbstr = (mbchar *)malloc((w->edit_win.text_len+1)*sizeof(wchar));
			data.data = (char *)mbstr;
			data.reason = TRUE;	/* hack, means string data & len */
			data.callbackstruct = (char *)WnToMbStr(w->edit_win.text, mbstr,
													w->edit_win.text_len);
#else
			data.data = (char *)w->edit_win.text;
			data.reason = TRUE;	/* hack, means string data & len */
			data.callbackstruct = (char *)w->edit_win.text_len;
#endif
		}
		else {
			/* value is an integer representing an index
			 * into fixed strings array
			 */
			w->value = cbx_info.current_value;
			data.data = (char *)w->value;
			data.reason = FALSE; /* hack, means integer data */
			reset_edit_win = TRUE;
		}
		if (w->callback) {
			AxCallback(w->callback, (AXWidget)w, w->callbacktag,
					   (char *)(&data));
		}
    }
	
	if (reset_edit_win) {
		EditWinReset((AXWidget)w, &(w->edit_win));
	}
#if BUILD_WIDE
	else if (mbstr) {
		free(mbstr);
	}
#endif
	
    /* really done */
    CbTossSearchStr();
    if (cbx_info.items) {
		(void) free(cbx_info.items);
    }
    CbResetCbxInfo(w);
    w->update_widget = TRUE;
	
    if (value_changed) {
		PaintComboBox(w, NULL, TRUE, FALSE);
    }
    return;
}

static void
CbTossSearchStr()
{
    if (cbx_info.search_str && MBstrlen(cbx_info.search_str))
		(void) free(cbx_info.search_str);
    cbx_info.search_str = NULL;
    return;
}

static void
CbIncrSearch(w, wbuf, num_chars)
AXWidget_combo_box w;
wchar *wbuf;
int num_chars;
{
    int ix;
    int matched_idx = -1;		/* index in the sorted list */
	
    if (cbx_info.search_str) {
		mbchar *tmp_buf;
		int   str_size = MBstrlen(cbx_info.search_str); 
		/* if the key pressed was DEL or BS, we actually cut off the last char
		   from the search string */
		if ((((unsigned) *wbuf) == DEL) || (((unsigned) *wbuf) == BS)) {
			tmp_buf = (mbchar *)calloc(1, str_size); /* zeroed mem */
 
			if (str_size > 0)
				MBstrncpy(tmp_buf, cbx_info.search_str, str_size - 1);
			else
				RingTheBell();
 
			free(cbx_info.search_str);
			if (!MBstrlen(tmp_buf)) {
				CbTossSearchStr();
				return;
			}
			cbx_info.search_str = tmp_buf;
		} else {
			tmp_buf = (mbchar *)calloc(1, 
                                str_size + (sizeof(wchar) * num_chars) + 1);
       
			MBstrcpy(tmp_buf, cbx_info.search_str);
            WnToMbStr(wbuf, (mbchar *)(tmp_buf+str_size), num_chars);
			free(cbx_info.search_str);
			cbx_info.search_str = tmp_buf;
		}
    } else {
		cbx_info.search_str = (mbchar *)
                         calloc(1, (sizeof(wchar) * num_chars) + 1); 
		WnToMbStr(wbuf, (mbchar *)cbx_info.search_str, num_chars);
    }
    /* Now, see if accumulated string matches a string in the list */
    for (ix = 0; cbx_info.search_str && (ix < w->num_buttons); ix++) {
		int len = MBstrlen(cbx_info.search_str);
		if (len == 0)
			break;
		if (MBstrncmp(cbx_info.search_str, w->strs[ix], len) == 0) {
			matched_idx = CbGetSortedDex(w, ix);
			break;
		}
    }
    if ((matched_idx != -1) &&
		(cbx_info.current_value != CbGetOrigIdx(w, matched_idx))) {
		int new_top = matched_idx;
		int list_moved = FALSE;
		
		if (new_top < 0)
			new_top = 0;		/* sanity */
		if ((new_top + w->num_pulldown_opts) > w->num_buttons)
			new_top = w->num_buttons - w->num_pulldown_opts; /* sanity */
		if (cbx_info.top_row != new_top) {
			list_moved = TRUE;
		}
		cbx_info.top_row = new_top;
		CbSetCbxCurrentValue(w, CbGetOrigIdx(w, matched_idx));
		CbPaintPulldown(w, list_moved);
		CbUpdateScrollbars(w);
    }
	
    if (matched_idx == -1) {
		RingTheBell();
		CbTossSearchStr();
    }  
	
    return;
}

/***********************************************************************
  Return clicked row number.  Assumed that 'y' lies inside the list
  scrolling area.
  Return -1 if could not get clicked row.
  */
static int
CbClickedRow(w, ypos)
AXWidget_combo_box w;
int ypos;
{
    int char_height, char_above;
    int topy, boty;
    int ix;

    if (w->font) {
		char_height = w->font->max_bounds.ascent + w->font->max_bounds.descent;
		char_above = w->font->max_bounds.ascent;
    } else {
		char_height = AxCharHeight;
		char_above = AxCharAbove;
    }

    topy = BORDER_WIDTH;
    boty = topy + (char_height + BORDER_WIDTH);
    for (ix = cbx_info.top_row;
		 (ix < w->num_buttons) &&
	     (ix < (cbx_info.top_row + w->num_pulldown_opts)); ix++) {
		if ((ypos >= topy) && (ypos <= boty))
			return(ix);
		topy = boty;
		boty += (char_height + BORDER_WIDTH);
    }
    return(-1);
}

/***********************************************************************
 */
int
CbEnterStayup(w)
AXWidget_combo_box w;
{
    unsigned int event_mask = 0;

    event_mask = (ButtonPressMask | ButtonReleaseMask | ButtonMotionMask);
    if (XGrabPointer(Dpy, w->pulldown, False, event_mask, GrabModeAsync,
					 GrabModeAsync, None, None, CurrentTime) == GrabSuccess) {
		AxPulldownStayup = TRUE;
		return(TRUE);
    }
    return(FALSE);
}

/***********************************************************************
 */
static void
CbBarChanged(widget, w, data)
Widget widget;
AXWidget_combo_box w;
XmScrollBarCallbackStruct *data;
{
    int old_top, new_top;
    int old_left, new_left;
    int need_paint = FALSE;

    if (!w)
		return;
    if (w->type != W_COMBO_BOX)
		return;

    if (data->reason == XmCR_VALUE_CHANGED)
		cbx_info.active_scrollbar = NULL; /* because we are not going
											 to get a button release */
    old_top = cbx_info.top_row;
    old_left = cbx_info.left_x;

    if (w->vScrollBar == (AXWidget_scroll) widget) {
		switch (data->reason) {
		case XmCR_INCREMENT:
			new_top = old_top + 1;
			if ((new_top + w->num_pulldown_opts) > w->num_buttons)
				break;
			cbx_info.top_row = new_top;
			need_paint = TRUE;
			break;
		case XmCR_DECREMENT:
			new_top = old_top - 1;
			if (new_top < 0)
				break;
			cbx_info.top_row = new_top;
			need_paint = TRUE;
			break;
		case XmCR_PAGE_INCREMENT:
			new_top = old_top + w->num_pulldown_opts;
			if ((new_top + w->num_pulldown_opts) > w->num_buttons)
				new_top = w->num_buttons - w->num_pulldown_opts;
			cbx_info.top_row = new_top;
			need_paint = TRUE;
			break;
		case XmCR_PAGE_DECREMENT:
			new_top = old_top - w->num_pulldown_opts;
			if (new_top < 0)
				new_top = 0;
			cbx_info.top_row = new_top;
			need_paint = TRUE;
			break;
		case XmCR_VALUE_CHANGED:
			if (data)
				new_top = data->value;
			if (new_top < 0)
				new_top = 0;	/* sanity */
			if ((new_top + w->num_pulldown_opts) > w->num_buttons)
				new_top = w->num_buttons - w->num_pulldown_opts; /* sanity */
			cbx_info.top_row = new_top;
			need_paint = TRUE;
			break;
		default:
			break;
		}
    }
    else if (w->hScrollBar == (AXWidget_scroll) widget) {
		int surfaceWidth;

		surfaceWidth = w->pulldown_width - BORDER_WIDTH;
		if (cbx_info.need_vert_scrollbar) {
			surfaceWidth -= SCROLLBAR_THICK;
		}
		switch (data->reason) {
		case XmCR_INCREMENT:
			if (cbx_info.left_x >= cbx_info.maxlen - surfaceWidth)
				break;
			cbx_info.left_x += 15;
			cbx_info.left_x = MIN(cbx_info.left_x,
								  cbx_info.maxlen - surfaceWidth);
			need_paint = TRUE;
			break;
		case XmCR_DECREMENT:
			if (cbx_info.left_x <= 0)
				break;
			cbx_info.left_x -= 15;
			cbx_info.left_x = MAX(0, cbx_info.left_x);
			need_paint = TRUE;
			break;
		case XmCR_PAGE_INCREMENT:
			cbx_info.left_x += surfaceWidth;
			cbx_info.left_x = MIN(cbx_info.left_x,
								  cbx_info.maxlen - surfaceWidth);
			need_paint = TRUE;
			break;
		case XmCR_PAGE_DECREMENT:
			cbx_info.left_x -= surfaceWidth;
			cbx_info.left_x = MAX(0, cbx_info.left_x);
			need_paint = TRUE;
			break;
		case XmCR_VALUE_CHANGED:
			cbx_info.left_x = data->value;
			need_paint = TRUE;
			break;
		default:
			break;
		}
    }

    if (need_paint) {
		CbPaintPulldown(w, TRUE);
		CbUpdateScrollbars(w);
    }
    return;
}

/***********************************************************************
  Given an idx in cbx_info.items, return the orig_idx (the one in w->strs[]).
  Return -1 for bogus values of rownum
  */
static int
CbGetOrigIdx(w, sorted_dex)
AXWidget_combo_box w;
int sorted_dex;
{
    int ix;

    if (!cbx_info.items)
		return(sorted_dex);		/* not sorted */
    if (sorted_dex < 0)
		return(-1);
    if (sorted_dex >= w->num_buttons)
		return(-1);
    return(cbx_info.items[sorted_dex].orig_idx);
}

/***********************************************************************
  Given a w->strs[] dex, return the dex in cbx_info.items[].
  */
static int
CbGetSortedDex(w, strs_dex)
AXWidget_combo_box w;
int strs_dex;
{
    int ix;

    if (!cbx_info.items)
		return(strs_dex);
    if (!w)
		return(-1);
    if (strs_dex < 0)
		return(-1);
    if (strs_dex >= w->num_buttons)
		return(-1);

    for (ix = 0; ix < w->num_buttons; ix++)
		if (cbx_info.items[ix].orig_idx == strs_dex)
			return(ix);
    return(-1);
}

/***********************************************************************
 */
static int
CbAlphaCompare(const void *p1, const void *p2)
{
	CbItem *ip1 = (CbItem*)p1;
	CbItem *ip2 = (CbItem*)p2;
    int case_sensitive = FALSE;

    return(Istrcmp((unsigned char *) ip1->str, (unsigned char *) ip2->str,
				   AxLanguage, case_sensitive));
}

/***********************************************************************
 */
static void
CbSortList(w)
AXWidget_combo_box w;
{
    int ix;
    cbx_info.items = (CbItem *) calloc(1, sizeof(CbItem) * w->num_buttons);
    for (ix = 0; ix < w->num_buttons; ix++) {
		CbItem *item;
		item = &cbx_info.items[ix];
		item->str = w->strs[ix];
		item->orig_idx = ix;
    }
    qsort(cbx_info.items, w->num_buttons, sizeof(CbItem), CbAlphaCompare);
    return;
}

/***********************************************************************
  Paint combo pulldown.
  */
static void
CbPaintPulldown(w, full)
AXWidget_combo_box w;
int full;
{
    int ix;
    int x, y;
    int char_height, char_above;
    int choice_width;
    mbchar *the_str;
    int current_dex, last_dex;
    XRectangle rect[1];
    int surfaceWidth;
    int surfaceHeight;

    if (!w)
		return;

    surfaceWidth = w->pulldown_width - BORDER_WIDTH;
    if (w->vScrollBar) {
		surfaceWidth -= SCROLLBAR_THICK;
    }
    surfaceHeight = w->pulldown_height - (2 * BORDER_WIDTH);
    if (w->hScrollBar) {
		surfaceHeight -= SCROLLBAR_THICK;
    }
	
    if (w->font)
		char_height = w->font->max_bounds.ascent + w->font->max_bounds.descent;
    else
		char_height = AxCharHeight;
    if (w->font)
		char_above = w->font->max_bounds.ascent;
    else
		char_above = AxCharAbove;

    choice_width = w->width - (down1_width + (2 * BORDER_WIDTH));
    cbx_info.choice_width = choice_width;
    x = BORDER_WIDTH + TEXT_OFFSET;
    y = BORDER_WIDTH + char_above;

    AxSetWidgetWorkColors((AXWidget)w);

    if (cbx_info.items) {
		current_dex = CbGetSortedDex(w, cbx_info.current_value);
		last_dex = CbGetSortedDex(w, cbx_info.last_value);
    }
    else {
		current_dex = cbx_info.current_value;
		last_dex = cbx_info.last_value;
    }
    cbx_info.last_value = cbx_info.current_value;

    if (full) {
		/* clear entire pulldown text surface */
		XFillRectangle(Dpy, w->pulldown, BackGC, BORDER_WIDTH, BORDER_WIDTH,
					   surfaceWidth - BORDER_WIDTH,
					   surfaceHeight - BORDER_WIDTH);
		/* outer shadow */
		AxDrawShadow(w->pulldown, ShadowGC, ShadowGC, BORDER_WIDTH, 0, 0,
					 w->pulldown_width,
					 w->pulldown_height, OLSHADOW_DRAW);
    }

    /* paint in rows */
    rect[0].x = BORDER_WIDTH;
    rect[0].y = 0;
    rect[0].width = surfaceWidth;
    rect[0].height = surfaceHeight;
    XSetClipOrigin(Dpy, ForeGC, 0, 0);
    XSetClipOrigin(Dpy, SunGC, 0, 0);
    XSetClipRectangles(Dpy, ForeGC, 0, 0, rect, 1, YXBanded);
    XSetClipRectangles(Dpy, BackGC, 0, 0, rect, 1, YXBanded);
    for (ix = cbx_info.top_row;
		 (ix < w->num_buttons) &&
	     (ix < (cbx_info.top_row + w->num_pulldown_opts)); ix++) {
		if (cbx_info.items)
			the_str = cbx_info.items[ix].str;
		else
			the_str = w->strs[ix];
		if (ix == current_dex) {
			XFillRectangle(Dpy, w->pulldown, ForeGC, x, y - char_above,
						   surfaceWidth - (2 * BORDER_WIDTH), char_height);
			xmDrawString((AXWidget)w, w->pulldown, BackGC, x - cbx_info.left_x,
						 y, the_str, strlen(the_str),
						 w->textShadow, w->textColor, w->widgetColor);
		}
		else if (full) {
			xmDrawString((AXWidget)w, w->pulldown, ForeGC, x - cbx_info.left_x,
						 y, the_str, strlen(the_str),
						 w->textShadow, w->textColor, w->widgetColor);
		}
		else if ((ix == last_dex) && (last_dex != current_dex)) {
			XFillRectangle(Dpy, w->pulldown, BackGC, x, y - char_above,
						   surfaceWidth - (2 * BORDER_WIDTH), char_height);
			xmDrawString((AXWidget)w, w->pulldown, ForeGC, x - cbx_info.left_x,
						 y, the_str, strlen(the_str),
						 w->textShadow, w->textColor, w->widgetColor);
		}
		y += (BORDER_WIDTH + char_height);
    }

    XSetClipMask(Dpy, ForeGC, None);
    XSetClipMask(Dpy, BackGC, None);

    /* create scrollbar if necessary */
    if (cbx_info.need_horiz_scrollbar || cbx_info.need_vert_scrollbar)
		CbCreateScrollbars(w, cbx_info.need_horiz_scrollbar,
						   cbx_info.need_vert_scrollbar);

    AxUnsetWidgetWorkColors((AXWidget)w);
	
    if (full && w->vScrollBar && w->hScrollBar) {
		/* paint corner box */
		XFillRectangle(Dpy, w->pulldown, BackGC, w->vScrollBar->xpos,
					   w->hScrollBar->ypos,
					   w->pulldown_width - w->vScrollBar->xpos - BORDER_WIDTH,
					   w->pulldown_height - w->hScrollBar->ypos -BORDER_WIDTH);
    }
    return;
}

static int
CbGetRowYpos(w, row_idx)
AXWidget_combo_box w;
int row_idx; /* sorted row idx */
{
    int ix;
    int y;
    int char_height, char_above;

    if (!w)
		return;

    if (w->font)
		char_height = w->font->max_bounds.ascent + w->font->max_bounds.descent;
    else
		char_height = AxCharHeight;
    if (w->font)
		char_above = w->font->max_bounds.ascent;
    else
		char_above = AxCharAbove;

    y = BORDER_WIDTH;

    if (row_idx < cbx_info.top_row)
		return;					/* won't see it anyway */
    if (row_idx >= (cbx_info.top_row + w->num_pulldown_opts))
		return;					/* won't see it anyway */

    for (ix = cbx_info.top_row;
		 (ix < w->num_buttons) &&
	     (ix < (cbx_info.top_row + w->num_pulldown_opts)); ix++) {
		if (ix == row_idx)
			break;
		y += (BORDER_WIDTH + char_height);
    }
    return(y);
}

/***********************************************************************
 */
static void
CbCreateScrollbars(w, create_horiz, create_vert)
AXWidget_combo_box w;
int create_horiz;      /* bool: whether to create horiz scroll bar */
int create_vert;
{
    int n, scroll_width, scroll_height;
    Arg args[20];
    static XtCallbackRec vcallback_list[2];
    static XtCallbackRec hcallback_list[2];

    if (create_vert && !w->vScrollBar) {
		n = 0;
		CALLBACKER(vcallback_list,CbBarChanged,w);
		XtSetArg(args[n], XmNx,
				 w->pulldown_width - SCROLLBAR_THICK - BORDER_WIDTH); n++;
		XtSetArg(args[n], XmNy, BORDER_WIDTH); n++;
		if (create_horiz) {
			scroll_height = w->pulldown_height -
				(2 * BORDER_WIDTH) - SCROLLBAR_THICK;
		}
		else {
			scroll_height = w->pulldown_height - (2 * BORDER_WIDTH);
		}
		XtSetArg(args[n], XmNheight, scroll_height); n++;
		XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
		XtSetArg(args[n], XmNvalueChangedCallback, vcallback_list); n++;
		w->vScrollBar =
			(AXWidget_scroll)AXmCreateScrollBar((AXWidget)w,
												"y", args, n);
		if (w->event_table)
			copyEventHandlerList(w->event_table,
								 &w->vScrollBar->event_table);
		
		xmSetWidgetDisplay((AXWidget)(w->vScrollBar), TRUE);
		w->vScrollBar->scroll_per = 100;
		w->vScrollBar->scroll_max = 100;
		w->vScrollBar->scroll_pos = 0;
		PaintScrollBar(w->vScrollBar, NULL, FALSE, FALSE); /* FIXME */
    }
	
    if (create_horiz && !w->hScrollBar) {
		n = 0;
		CALLBACKER(hcallback_list, CbBarChanged, w);
		XtSetArg(args[n], XmNx, BORDER_WIDTH); n++;
		XtSetArg(args[n], XmNy,
				 w->pulldown_height - SCROLLBAR_THICK - BORDER_WIDTH); n++;
		if (create_vert) {
			scroll_width = w->pulldown_width -
				(2 * BORDER_WIDTH) - SCROLLBAR_THICK;
		}
		else {
			scroll_width = w->pulldown_width - (2 * BORDER_WIDTH);
		}
		XtSetArg(args[n], XmNwidth, scroll_width); n++;
		XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
		XtSetArg(args[n], XmNvalueChangedCallback, hcallback_list); n++;
		w->hScrollBar =
			(AXWidget_scroll) AXmCreateScrollBar((AXWidget)w,
												 "x", args, n);
		if (w->event_table)
			copyEventHandlerList(w->event_table,
								 &w->hScrollBar->event_table);
		xmSetWidgetDisplay((AXWidget)(w->hScrollBar), TRUE);
		w->hScrollBar->scroll_per = 100;
		w->hScrollBar->scroll_max = 100;
		w->hScrollBar->scroll_pos = 0;
		PaintScrollBar(w->hScrollBar, NULL, FALSE, FALSE); /* FIXME */
    }
    return;
}

/***********************************************************************
  function: CbShiftOrigin - adjust vertical position of pulldown to fit
  on screen; returns number of pixels shifted
  */
static int
CbShiftOrigin(yp, height)
int *yp; /* INOUT */
int height;
{
    int shifted = 0;
    if (!yp)
		return(shifted);		/* invalid args -- return default */

    if (*yp < 8) {
		shifted = 8 - *yp;
		*yp = 8;
    }

    if ((*yp + height) > DpyHt) {
		shifted = DpyHt - height - 8 - *yp;
		*yp = DpyHt - height - 8;
    }
    return(shifted);
}

/***********************************************************************
  function: CbComputeChoiceWidth - 
  */
static int
CbComputeChoiceWidth(w)
AXWidget_combo_box w;
{
    int choice_width = 0;

    if (!w)
		return(0);
    choice_width = w->maxLen + (2 * TEXT_OFFSET);
    return(choice_width);
}

/***********************************************************************
  function: CbComputeArrowWidth - 
  */
static int
CbComputeArrowWidth(w)
AXWidget_combo_box w;
{
    int arrow_width = 0;

    arrow_width = down1_width + (2 * BORDER_WIDTH);
    return(arrow_width);
}

/***********************************************************************
  function: CbComputeArrowHeight - 
  */
static int
CbComputeArrowHeight()
{
    int arrow_height = 0;

    arrow_height = down1_height + (2 * BORDER_WIDTH);
    return(arrow_height);
}

/***********************************************************************
  function: CbComputeChoiceHeight
  */
static int
CbComputeChoiceHeight(fp)
XFontStruct *fp;
{
    int choice_height;
    int char_height;

    if (fp)
		char_height = fp->max_bounds.ascent + fp->max_bounds.descent;
    else
		char_height = AxCharHeight;
    choice_height = char_height + (2 * TEXT_OFFSET);
    return(choice_height);
}

/***********************************************************************
  function: CbComputeComboHeight - 
  */
int
CbComputeComboHeight(fp)
XFontStruct *fp;
{
    int combo_height = 0;
    int choice_height = 0;
    int arrow_height = 0;
    int char_height = 0;

    arrow_height = CbComputeArrowHeight();
    choice_height = CbComputeChoiceHeight(fp);
    combo_height = MAX(choice_height, arrow_height);
    combo_height += (2 * BORDER_WIDTH); /* there is a shadow that goes
										   around the choice and arrow */
    return(combo_height);
}

/***********************************************************************
  function: CbPaintCombo - 
  */
static void
CbPaintCombo(w)
AXWidget_combo_box w;
{
    AxSetWidgetWorkColors((AXWidget)w);
    if (!w->edit_win.edited) {
		if (w->edit_win.text) {
			free(w->edit_win.text);
		}
		if (w->value >= 0) {
			if (w->num_buttons > 0) {
				w->edit_win.text = (wchar *)malloc( 
                                (strlen(w->strs[w->value])+1) * sizeof(wchar) );
                w->edit_win.text_len = MbToWStr( (mbchar *)w->strs[w->value], 
												 w->edit_win.text );
			}
			else {
				w->edit_win.text = NULL;
				w->edit_win.text_len = 0;
			}
		}
		else {
			w->edit_win.text = NULL;
			w->edit_win.text_len = 0;
		}
	}
	CbPaintChoice(w);
	AxUnsetWidgetWorkColors((AXWidget)w);
	CbPaintArrow(w);
	if (w->flags & WFLG_IN_EDIT) {
		int editWidth, editHeight;
		EditWinWidthHeight((AXWidget)w, &editWidth, &editHeight);
		XCopyArea(Dpy, w->edit_win.win, w->window, ForeGC, 0, 0,
				  editWidth, editHeight,
				  BORDER_WIDTH, BORDER_WIDTH);
		XCopyArea(Dpy, w->window, w->parent->window, ForeGC, 0, 0,
				  w->width, w->height, w->xpos, w->ypos);
	}
	return;
}

/***********************************************************************
  function: CbPaintChoice - 
  */
static void
CbPaintChoice(w)
AXWidget_combo_box w;
{
    int char_above, char_height, extra, itmp;
    int editWidth, editHeight;
	
    AxDrawBevel((AXWidget)w, w->window, 0, 0, w->width, w->height,
				BORDER_WIDTH, BEVEL_IN);
	
    if (!(w->edit_win.text && w->edit_win.win))
		return;
    if (w->value >= w->num_buttons)
		return;
	
    if (w->font) {
		char_above = w->font->max_bounds.ascent;
		char_height = char_above + w->font->max_bounds.descent;
    }
    else {
		char_above = AxCharAbove;
		char_height = AxCharHeight;
    }
	
    itmp = char_height + ((BORDER_WIDTH + TEXT_OFFSET) * 2);
    if (w->height > itmp) {
		extra = (w->height - itmp + 1) / 2;
    }
    else {
		extra = 0;
    }
	
    EditWinWidthHeight((AXWidget)w, &editWidth, &editHeight);
	
    /* fill in background */
    XFillRectangle(Dpy, w->edit_win.win, BackGC, 0, 0, editWidth, editHeight);
	
    /* write in text */
    EditWinDrawString((AXWidget)w, &(w->edit_win), ForeGC,
					  w->edit_win.text_len);
	
    return;
}

/***********************************************************************
 */
static void
CbUpdateScrollbars(w)
AXWidget_combo_box w;
{
    if (!w)
		return;

    if (w->vScrollBar) {
		w->vScrollBar->scroll_per = w->num_pulldown_opts;
		w->vScrollBar->scroll_max = w->num_buttons;
		w->vScrollBar->scroll_pos = cbx_info.top_row;
		PaintScrollBar(w->vScrollBar, NULL, FALSE, FALSE);
    }
    if (w->hScrollBar) {
		int surfaceWidth;
		surfaceWidth = w->pulldown_width - SCROLLBAR_THICK - BORDER_WIDTH;
		w->hScrollBar->scroll_per = surfaceWidth;
		w->hScrollBar->scroll_max = cbx_info.maxlen;
		w->hScrollBar->scroll_pos = cbx_info.left_x;
		PaintScrollBar(w->hScrollBar, NULL, FALSE, FALSE);
    }
    return;
}

/***********************************************************************
  function: CbPaintArrow - 
  */
static void
CbPaintArrow(w)
AXWidget_combo_box w;
{
    int arrow_xpos;				/* arrow image xpos */
    int choice_width, combo_height;
    int arrow_width, arrow_height; /* width/height of arrow image + borders */

    arrow_width = down1_width + (2 * BORDER_WIDTH);
    choice_width = w->width - arrow_width - BORDER_WIDTH;
    combo_height = CbComputeComboHeight(w->font);

    arrow_height = combo_height - (2 * BORDER_WIDTH);
    arrow_xpos = choice_width + (2 * BORDER_WIDTH);

    xmColorFillRectangle((AXWidget)w, w->window, BackGC,
						 choice_width + BORDER_WIDTH, BORDER_WIDTH,
						 w->width - choice_width - BORDER_WIDTH - BORDER_WIDTH,
						 combo_height - BORDER_WIDTH - BORDER_WIDTH);
    axmPaintBottomArrow((AXWidget)w, w->window, arrow_xpos - BORDER_WIDTH,
						(combo_height / 2) + 8, TRUE);
    AxDrawBevel((AXWidget)w, w->window, choice_width, BORDER_WIDTH,
				arrow_width, arrow_height,
				BORDER_WIDTH, BEVEL_OUT);
	
    return;
}

/***********************************************************************
  Compute the top row given the current value.
  */
static int
CbComputeTopRow(w, value)
AXWidget_combo_box w;
int value;
{
    int top_row;

    if (!w)
		return(0);
    if (value < 0)
		return(0);
    if (value > w->num_buttons)
		return(0);

    if (w->num_buttons <= w->num_pulldown_opts)
		return(0);
    top_row = 0;
    while (TRUE) {
		if (value < (top_row + w->num_pulldown_opts))
			break;
		top_row += w->num_pulldown_opts;
    }

    /* adjust so that there is no blank space at the bottom */
    if ((top_row + w->num_pulldown_opts) > (w->num_buttons - 1))
		top_row = w->num_buttons - w->num_pulldown_opts;

    return(top_row);
}

int ComboStringWidth(w, p)
AXWidget_combo_box w;
register mbchar *p;
{
    XFontStruct *fs;
    if (w->font)
		fs = w->font;
    else
		fs = AxDlgMainFont;
    return(AXTextWidth(fs, p, strlen(p)));
}

/* : CbBaselineOffset - return the pixel distance from the top of
 * the combo box widget to the baseline of the choice text.
 */
int
CbComboBaselineOffset(fs, combo_height)
XFontStruct *fs;
int combo_height;
{
    int char_above, char_height, itmp, extra;
	
    if (fs) {
		char_above = fs->max_bounds.ascent;
		char_height = char_above + fs->max_bounds.descent;
    }
    else {
		char_above = AxCharAbove;
		char_height = AxCharHeight;
    }
    itmp = char_height + ((BORDER_WIDTH + TEXT_OFFSET) * 2);
    if (combo_height > itmp) {
		extra = (combo_height - itmp + 1) / 2;
    }
    else {
		extra = 0;
    }
    return (BORDER_WIDTH + TEXT_OFFSET + char_above + extra);
}

static void
CbResetCbxInfo(w)
AXWidget_combo_box w;
{
    memset((wchar *) &cbx_info, '\0', sizeof(cbx_info));
    if ((w->flags & WFLG_EDITABLE) && w->edit_win.edited) {
		cbx_info.last_value = cbx_info.orig_value = -1;
    }
	else {
		cbx_info.last_value = cbx_info.orig_value = w->value;
    }
	CbSetCbxCurrentValue(w, cbx_info.last_value);
}

static void
CbSetCbxCurrentValue(w, inval)
AXWidget_combo_box w;
int inval;
{
	cbx_info.current_value = inval;
	if (inval != -1) {
		w->edit_win.edited = FALSE;
	}
}

void
CbLosingKeyFocus(w)
AXWidget_combo_box w;
{
    seln_t *sel;
    
    CbFinish(w, TRUE);
    if (w->pending_delete) {
		sel = &(w->edit_win.sel);
		EditWinAdjustHighlight((AXWidget)w, &(w->edit_win),
							   MIN(sel->startIndex, sel->endIndex),
							   MAX(sel->startIndex, sel->endIndex),
							   UNHIGHLIGHT);
		w->pending_delete = FALSE;
    }
}

void CbActivateEditWin(w)
AXWidget_combo_box w;
{
    int text_width;
  
    ComboBoxInEditWindow = w;
    /* we calculate text_width and input to EditWinHighlightLine so that the
       cursor (set w/in EditWinHighlightLine) will be at the end of the
       string */

	if (w->edit_win.text && w->edit_win.text_len) {
		text_width =
			EditWinGetStringWidth((AXWidget) w,
								  w->edit_win.text, 0, w->edit_win.text_len) +
									  + w->edit_win.string_offset;
	}
	else {
		text_width = 0;
	}
    
    EditWinPaintWindow((AXWidget)w, &(w->edit_win));
    EditWinHighlightLine((AXWidget)w, &(w->edit_win), text_width);
    EditWinDrawCursor((AXWidget)w, &(w->edit_win), TC_DRAW);
}

void
ComboListAutoScroll(w)
AXWidget_combo_box w;
{
	XmScrollBarCallbackStruct cbdata;
	XEvent fake_event;
	Window root_return, child_return;
	
	memset((void *) &cbdata, 0, sizeof(XmScrollBarCallbackStruct));
	
	if (XQueryPointer(Dpy, w->edit_win.win, &root_return, &child_return,
					  &fake_event.xbutton.x_root,
					  &fake_event.xbutton.y_root,
					  &fake_event.xbutton.x, &fake_event.xbutton.y,
					  &fake_event.xbutton.state)) {
		if (fake_event.xbutton.state & Button1Mask) {
			comboListAutoscrollEdge = mouseOutsideComboList(w, &fake_event);
			if (noEdge == comboListAutoscrollEdge) {
				ComboListArmed = (AXWidget_combo_box) NULL;
				return;
			}
		}
	}
	
	switch(comboListAutoscrollEdge) {
	case leftEdge:
		if (w->hScrollBar) {
			cbdata.reason = XmCR_DECREMENT;
			CbBarChanged((Widget) w->hScrollBar, w, &cbdata);
		}
		break;
	case rightEdge:
		if (w->hScrollBar) {
			cbdata.reason = XmCR_INCREMENT;
			CbBarChanged((Widget) w->hScrollBar, w, &cbdata);
		}
		break;
	case topEdge:
		if (w->vScrollBar) {
			cbdata.reason = XmCR_DECREMENT;
			CbBarChanged((Widget) w->vScrollBar, w, &cbdata);
		}
		break;
	case bottomEdge:
		if (w->vScrollBar) {
			cbdata.reason = XmCR_INCREMENT;
			CbBarChanged((Widget) w->vScrollBar, w, &cbdata);
		}
		break;
	}
}

/* : mouseOutsideComboList - return whether passed mouse
 * event, assumed to be for the combo pulldown window, is outside
 * the pulldown's footprint.  Can return "noEdge", meaning
 * mouse event is inside pulldown footprint
 */
static enum comboListEdge
mouseOutsideComboList(w, eventP)
AXWidget_combo_box w;
XEvent *eventP;
{
	enum comboListEdge whichedge;
	int fudge = 5;
	
	if (!w->pulldown) {
		return noEdge;    /* don't do autoscroll */
	}
	
	if (eventP->xbutton.x < -fudge) {
		whichedge = leftEdge;
	}
	else if (eventP->xbutton.x > (int) w->pulldown_width + fudge) {
		whichedge = rightEdge;
	}
	else if (eventP->xbutton.y < -fudge) {
		whichedge = topEdge;
	}
	else if (eventP->xbutton.y > (int) w->pulldown_height + fudge) {
		whichedge = bottomEdge;
	}
	else {
		whichedge = noEdge;
	}

	return whichedge;
}

void CbDestroyPulldown(w_cbox)
AXWidget_combo_box w_cbox;
{

	if (w_cbox->pulldown) {
		if (w_cbox->vScrollBar)
			AxXtDestroyWidget((AXWidget) w_cbox->vScrollBar);
		if (w_cbox->hScrollBar)
			AxXtDestroyWidget((AXWidget) w_cbox->hScrollBar);
		w_cbox->vScrollBar = NULL;
		w_cbox->hScrollBar = NULL;
		AxDestroyWindow(Dpy, (AXWidget) w_cbox, w_cbox->pulldown);
	}
	XUngrabPointer(Dpy, CurrentTime);
	w_cbox->pulldown = 0;
	ComboBoxArmed = NULL;
	ComboListArmed = NULL;
}



/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * end:
 */
