/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmevent.h
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:43 1998
*/
#ifndef _XMEVENT_H
#define _XMEVENT_H

	/* a widget can have an array of these on its event_table */
typedef struct event_rec_t {
	struct event_rec_t *next;
	void (*proc)(); 				/* event handler */
	unsigned long eventMask;		/* event set */
	char *clientData;		/* extra data to pass to proc - currently unused */
	unsigned int nonmaskable : 1;	/* currently unused */
} eventRec;

	/* this is just for reference between Elfb and ZXt */
typedef struct event_proc_list_t {
	int numProcs;
	char **eventProcNames;
	unsigned long *eventMasks;
} eventHandlerList;

int ElfbInsertEventHandler();
int ElfbRemoveEventHandlers();
void ZXtInsertEventHandler();
void ZXtRemoveEventHandler();
void xmRemoveAllEventHandlers();
int localEventDispacth();
int setEventHandlers();
void copyEventHandlerList();

#endif /* _XMEVENT_H */

