/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmrowcol.c
   Applix ASC version: 76
   Date: Mon Nov 16 13:53:42 1998
*/
#include <basicwin.h>
#include <ax_xm.h>
#include <math.h>
#include <aos.h>
#include <xmlib.h>
#include <elxwins.h>
#include <xmpixel.h>

#include <xmrowcol.p>


extern int AxOpenLook, UseWidgetColors;
extern int AxCharAbove, AxCharBelow, AxCharHeight;
extern int AxBigFont;
extern unsigned long BackPixel;
extern unsigned long ForePixel;
extern short NoColor;
extern short ColorDisplay;
extern int ThimExposuresMayBeComing;
extern int WidgetNeedsUpdated;
extern GC  ForeGC, BackGC;
extern GC  SunGC, ShadowGC;
extern GC  olBoldTextGC;
extern XFontStruct *Txfont, *MiniTxfont, *Grafont;
extern unsigned long WidgetPixels[];
extern Window  RootWin;
extern Display *Dpy;
extern short   DpyWid, DpyHt;
extern AXWidget_rowcol RowColumnArmed;

/* Point size to for button text symbols (for eqn editor). */
#define BUTTON_TEXT_POINT_SIZE 14

/* For text-only buttons and static choice. */
#define TEXT_LEFT_OFFSET  4 /* offset from left edge of button */
#define TEXT_RIGHT_OFFSET 8 /* gap to leave beyond last char */
#define BAR_LEFT_OFFSET  4 /* offset from TEXT_RIGHT_OFFSET for bar */
#define BAR_RIGHT_OFFSET 8 /* offset from right edge of static choice */
#define BAR_WIDTH  (2 + 8 + 2)
#define BAR_HEIGHT (2 + 3 + 2)



#define BTN_MARGIN_DIM ((AxOpenLook && !UseWidgetColors) ? 2 : 3)

/* Elements of (widget_t) used by this widget:
   ELEMENT                USAGE                              RESOURCE
   w->window              Window of the transient.           ----
   w->display                                                ----
   w->mapped                                                 ----
   w->xpos                xpos of static button w.r.t          
                          parent window.                     XmNx
   w->ypos                ypos of static button w.r.t
                          parent window.                     XmNy
   w->width               Width of static button.            XmNwidth
   w->height              Height of static button.           XmNheight
   w->pulldown_height     Height of transient                -computed-
   w->pulldown_width      Width of transient                 -computed-
   w->value               Default button index.              XmNvalue
   w->style               type of widget RC_TYPE_XXXX        ZXmNstyle
   w->num_buttons         Number of buttons on transient     XmNitemCount
   w->alternatePixmap     (optional) pixmap to use to draw
                          the static button.                 XmNalternatePixmap
   w->strs                Label strings to be used for
                          buttons.  Must have w->num_buttons
                          number of strings.                 XmNitems
   w->color               foreground color of static button  XmNpfg_color
   w->bg_color            background color of static button  XmNpbg_color
   w->scroll_type         Set the number for columns when
                          widget is of type RC_TYPE_SQUARE   XmNorientation
   w->disabled            If true, widget does not respond
                          to btn-clicks... No border on
                          button to indicate condition.      XmNflags

   w->buttons             `w->num_buttons' of buttons.       -allocated-
   w->buttons[n]->name    name of pixmap to use for this
                          button.                            AxXmNpixmapList
   w->buttons[n]->xpos    xpos of button w.r.t transient     -computed-
   w->buttons[n]->ypos    ypos of button w.r.t. transient    -computed-
   w->buttons[n]->width   width of button                    -computed-
   w->buttons[n]->height  height of buttons                  -computed-
   w->buttons[n]->color   foreground color of transient btn  XmNfg_color
   w->buttons[n]->bg_color background color of transient btn XmNbg_color

   NOTE:
   For the Equation Editor:
   In the case when displaying special char in buttons, some of the
   resources listed above take on the following different meanings:
   Also note that this feature cannot be accessed from the elf layer.
   w->scroll_per          Need text string in button cells.  XmNsliderSize
   w->strs                An array of character codes in
                          string form.  Must have w->num_buttons
                          number of strings.                 XmNitems
   w->buttons[n]->name    font name to display the text in
                          this button.                       AxXmNpixmapList
   w->minValue            relative x position of text in
                          each button.                       XmNminValue
   w->maxValue            relative y position of text in
                          each button.                       XmNmaxValue

   For the Word Processor:
   In the case when displaying plain text strings in buttons, some of
   the resources listed above take on the following different meanings:
   w->multi_pick          Need to display plain text in
                          buttons                 XmNmultipleSelectionCallback
   w->buttons[n]->name    The text that needs displaying     AxXmNpixmapList
   */
#if 0
static int  ShiftPulldownOrigin(/* int *xp, int *yp, int width, int height */);
static void DrawRowColumnLabelString(/* widget_t *w, int value, int
                                        btn_area_height */);
static void RenderRowColumnPixmap(/* widget_t *w, int ix, pixcache_t
                                     *pixent */);
static int  SpecialCharRowCol(/* widget_t *w */);
static int  TextOnlyRowCol(/* widget_t *w */);
static void DrawBtnSpecialChar(/* widget_t *w, int btn_idx */);
static void DrawButtonString(/* widget_t *w, int btn_idx */);
static int  ButtonTextRelX(/* widget_t *w */);
static int  ButtonTextRelY(/* widget_t *w */);
static GC   CreateButtonTextGC(/* char *font_name,  int point_size,
                                  int *char_abovep, int *char_belowp,
                                  int *char_heightp */);
#endif

/* Create a row-column pulldown menu */
AXWidget_rowcol
AXmCreateRowColumn(parent, name, args, cnt)
register AXWidget parent;
register char *name;
register Arg  args[];
register int  cnt;
{
    register AXWidget_rowcol w;

    if (args[0].value) {
        w = (AXWidget_rowcol) args[0].value;
        UnMapWidget((AXWidget)w);
        SetWidgetName((AXWidget)w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    } else
        w = (AXWidget_rowcol)CrtWidget(W_ROWCOL, parent, name);
    w->painter = PaintRowColumn;
#if AXMS
	w->thickness = 1;
#else
	w->thickness = 2;
#endif
    AxXtSetValues((AXWidget)w, args, cnt);
    return((AXWidget_rowcol) w);
}

/* compute cell-dimensions and number of rows/columns.
   returns: 0 on success; -1 otherwise. */
static int
ComputeRowColumnPacking(w, cell_widthp, cell_heightp, num_rowsp, num_colsp)
AXWidget_rowcol w;
int *cell_widthp;
int *cell_heightp;
int *num_rowsp;
int *num_colsp;
{
    register int ix;
    int widest, longest;
    pixcache_t *pixent;
    char bitmap_name[STRPATH + 1];
    char button_text[STRPATH + 1];
    
    if (!w || !cell_widthp || !cell_heightp || !num_rowsp || !num_colsp)
        return(-1); /* invalid args */

    if (!w->buttons || (w->num_buttons <= 0))
        return(-1);

    *cell_widthp = *cell_heightp = *num_rowsp = *num_colsp = 0;

    if (SpecialCharRowCol(w)) {
        /* Need dimensions of the static button pixmap to figure out
           height and width of each cell. */
        if (!w->alternatePixmap)
            return(-1);
        if (!(pixent = Pixmapper(w->alternatePixmap)))
            return(-1);
        widest  = (int) pixent->width;
        longest = (int) pixent->height;
    } else if (TextOnlyRowCol(w)) {
        for (ix = 0, widest = 0, longest = 0; ix < w->num_buttons; ix++) {
            int this_width, this_height;
#if BUILD_ORIENT
            /* Ashisuto simplified for multi-byte-chars.    98.03.18 */
            this_width = AXTextWidth(w->font,
                         w->buttons[ix]->name, strlen(w->buttons[ix]->name));
#else
            int len, lx;
            strcpy(button_text, w->buttons[ix]->name);
            len = strlen(w->buttons[ix]->name);
            for (lx = 0, this_width = 0; lx < len; lx++)
                this_width += GetAnyCharWidth(w->font, button_text[lx]);
#endif
            this_width += TEXT_LEFT_OFFSET + TEXT_RIGHT_OFFSET;
            if (this_width > widest)
                widest = this_width;

            if (w->font)
                this_height = w->font->max_bounds.ascent +
                    w->font->max_bounds.descent;
            else
                this_height = AxCharHeight;

            if (this_height > longest)
                longest = this_height;
        }
    } else {
        for (ix = 0, widest = 0, longest = 0; ix < w->num_buttons; ix++) {
            strcpy(bitmap_name, w->buttons[ix]->name);
            if (!(pixent = Pixmapper(bitmap_name)))
                continue;

            if ((int) pixent->width > widest)
                widest = (int) pixent->width;

            if ((int) pixent->height > longest)
                longest = (int) pixent->height;
        }
        if ((widest == 0) || (longest == 0))
            widest = longest = 20; /* default */
    }

    *cell_widthp  = widest + (BTN_MARGIN_DIM * 2);
    *cell_heightp = longest + (BTN_MARGIN_DIM * 2);

    switch (w->style) {
    case RC_TYPE_COLUMN: /* single column widget */
        *num_colsp = 1;
        *num_rowsp = w->num_buttons;
        break;

    case RC_TYPE_ROW: /* single row widget */
        *num_colsp = w->num_buttons;
        *num_rowsp = 1;
        break;

    case RC_TYPE_HORIZ:
        /* TODO */
    case RC_TYPE_VERT:
        /* TODO */
    case RC_TYPE_SQUARE:
        /* fall through */
    default:
        if ((w->scroll_type != 0) && (w->scroll_type < w->num_buttons))
            *num_colsp = w->scroll_type;
        else
            *num_colsp = (int) ceil(sqrt((double) w->num_buttons));
        *num_rowsp = (int) ceil((double) w->num_buttons / (double) *num_colsp);
        break;
    }
    return(0);
}

/* Paint static pixmap/current value pixmap on parent window. */
void
PaintRowColumn(w, exp, regen, layered)
register AXWidget_rowcol w;
XEvent *exp;
int regen;
int layered;
{
    int fg_color, bg_color;
    int r, g, b, cindex;
    unsigned long fg, bg, saved_fg, fore_fg, back_bg, val;
    int x, y, wid, hyt, rows, cols, i, j;
    int char_above;
    pixcache_t *pixent = (pixcache_t *) NULL;
    char bitmap_name[STRPATH + 1];
    void PaintRowColumnPulldown();
    XImage *ximg;
    int stipple_num;

    if (!w || !w->display || !w->parent->display)
        return;

    if ((w->flags & WFLG_IN_EDIT) && layered && dePaintWidget((AXWidget)w))
        return;
    if (!w->buttons || (w->num_buttons < 0))
        return;
    
    /* Clip value to -1 for insane values on w->value */
    if ((w->value != -1) && (w->value >= w->num_buttons))
        w->value = -1;

    /* get the pixmap to be drawn */
    w->mapped = TRUE;

    if (TextOnlyRowCol(w)) {
        int bar_x, bar_y; /* position of the tiny bar */
        int tx, ty; /* position of text */
        int avail_width, label_width;

        if ((w->num_buttons <= 0) || 
                    (!w->buttons[0]->width || !w->buttons[0]->height)) {
            if (ComputeRowColumnPacking(w, &wid, &hyt, &rows, &cols) == 0) {
                /* Note: TEXT LEFT and RIGHT offsets have been
                   accounted in the above call. */
                w->width = (wid + BAR_LEFT_OFFSET + BAR_WIDTH +
                            BAR_RIGHT_OFFSET);
                w->height = hyt;
            }
        }
        x = w->xpos;
        y = w->ypos;
        wid = w->width;
        hyt = w->height;
        if (w->font)
            char_above = w->font->max_bounds.ascent;
        else
            char_above = AxCharAbove;
        XFillRectangle(Dpy, WIN_OF(w), BackGC, x, y, wid, hyt);
        if ( (w->value >= 0) && (w->value < w->num_buttons)) {
            avail_width = wid - (BAR_WIDTH + BAR_RIGHT_OFFSET +
                                 BAR_LEFT_OFFSET + TEXT_LEFT_OFFSET +
                                 TEXT_RIGHT_OFFSET);
            label_width = BasicStrlen(w->buttons[w->value]->name);
            if (label_width < avail_width) {
                tx = (((avail_width / 2) + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET) -
                      (label_width / 2));
                tx += x;
                if ((tx < (x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET)) ||
                    (tx >= (x + avail_width + BTN_MARGIN_DIM)))
                    tx = x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET;
            } else
                tx = x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET;
            ty = y + BTN_MARGIN_DIM + char_above;
/*          tx = x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET; */
            xmDrawString((AXWidget)w, WIN_OF(w), ForeGC, tx, ty,
                         w->buttons[w->value]->name,
                         strlen(w->buttons[w->value]->name),
                         w->textShadow, w->textColor, w->widgetColor);
            bar_x = x + (wid - BAR_RIGHT_OFFSET - BAR_WIDTH);
            bar_y = y + ((hyt / 2) - (BAR_HEIGHT / 2));
            AxDrawShadow(WIN_OF(w), SunGC, ShadowGC, w->thickness, bar_x, bar_y,
                         BAR_WIDTH, BAR_HEIGHT, OLSHADOW_DRAW);
            if (!w->disabled)
                AxDrawShadow(WIN_OF(w), SunGC, ShadowGC, w->thickness, x, y, 
								wid, hyt, OLSHADOW_DRAW);
        }
        else if ((w->value == -1) && w->num_buttons > 0 ) {
            avail_width = wid - (BAR_WIDTH + BAR_RIGHT_OFFSET +
                                 BAR_LEFT_OFFSET + TEXT_LEFT_OFFSET +
                                 TEXT_RIGHT_OFFSET);
            label_width = BasicStrlen(w->buttons[0]->name);
            if (label_width < avail_width) {
                tx = (((avail_width / 2) + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET) -
                      (label_width / 2));
                tx += x;
                if ((tx < (x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET)) ||
                    (tx >= (x + avail_width + BTN_MARGIN_DIM)))
                    tx = x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET;
            } else
                tx = x + BTN_MARGIN_DIM + TEXT_LEFT_OFFSET;
            ty = y + BTN_MARGIN_DIM + char_above;
            bar_x = x + (wid - BAR_RIGHT_OFFSET - BAR_WIDTH);
            bar_y = y + ((hyt / 2) - (BAR_HEIGHT / 2));
            AxDrawShadow(WIN_OF(w), SunGC, ShadowGC, w->thickness, bar_x, bar_y,
                         BAR_WIDTH, BAR_HEIGHT, OLSHADOW_DRAW);
            if (!w->disabled)
                AxDrawShadow(WIN_OF(w), SunGC, ShadowGC, w->thickness, x, y, 
								wid, hyt, OLSHADOW_DRAW);
        }
        return;
    }

    /* Text pulldowns need `alternatePixmap' to display the static button. */
    if (SpecialCharRowCol(w)) {
        if (!w->alternatePixmap)
            return; /* sanity */
    }

    if (w->alternatePixmap) {
        pixent = Pixmapper(w->alternatePixmap);
        if (pixent) {
            w->width  = pixent->width + (BTN_MARGIN_DIM * 2);
            w->height = pixent->height + (BTN_MARGIN_DIM * 2);
        }
    } else if (w->buttons && w->num_buttons) {
        if (!w->buttons[0]->width || !w->buttons[0]->height) {
            if (ComputeRowColumnPacking(w, &wid, &hyt, &rows, &cols) == 0) {
                w->width  = wid;
                w->height = hyt;
            }
        }
        if ((w->value >= 0) && (w->value < w->num_buttons)) {
            strcpy(bitmap_name, w->buttons[w->value]->name);
            pixent = Pixmapper(bitmap_name);
        }
    }

    fg_color = w->color;
    bg_color = w->bg_color;
    if (w->buttons && (w->value >= 0) && (w->value < w->num_buttons)) {
        if (w->buttons[w->value]->color || w->buttons[w->value]->bg_color) {
            fg_color = w->buttons[w->value]->color;
            bg_color = w->buttons[w->value]->bg_color;
        }
    }

    /* validate the height and width */
    if (!w->width)
        w->width = 20; /* safety net */
    if (!w->height)
        w->height = 20; /* safety net */
    x = w->xpos;
    y = w->ypos;
    wid = w->width;
    hyt = w->height;

    /* Clear button */
    XFillRectangle(Dpy, WIN_OF(w), BackGC, x, y, wid, hyt);

    /* draw on the button surface */
    if ( pixent )
    {
        /* ge palette color button */
        if ( w->gePaletteButtonType == 6 && fg_color )
        {
            /* clear the button */
            XFillRectangle(Dpy, WIN_OF(w), BackGC, x, y, wid, hyt);

            saved_fg = AXGetForegroundPixel(Dpy, ForeGC);
            r = ((fg_color & 0x000000FF) >> 0);
            g = ((fg_color & 0x0000FF00) >> 8);
            b = ((fg_color & 0x00FF0000) >> 16);
            AxGetRealPixel(0, r, g, b, 0, 255, &fg);
            XSetForeground(Dpy, ForeGC, fg);
            XFillRectangle(Dpy, WIN_OF(w), ForeGC,
                           w->xpos + BTN_MARGIN_DIM,
                           w->ypos + BTN_MARGIN_DIM,
                           w->width - (2 * BTN_MARGIN_DIM),
                           w->height - (2 * BTN_MARGIN_DIM));
            XSetForeground(Dpy, ForeGC, saved_fg);
        }

        /* special clip masks for the GE palette */
        else if ( w->gePaletteButtonType != 0 )
        {
#if AXMS    /* { */
    /* on X, Pixmapper() returns a DpyDepth image pixmap, which is why *
     * color conversion is done with XPutPixel. On Windows, we'll get  *
     * a mono bitmap handle back from Pixmapper(), so we can just blt  *
     * the image with the correct colors set in the DC. This software  *
     * "split" is probably a "maintenance bug" and should be fixed in  *
     * the future. Until then, we'll at least get a performance gain   *
     * on NT.                          -donato                         */
            AxWin_DrawRowColButton(w, pixent->pix, fg_color, bg_color, TRUE);
#else    /* } { */
            /* copy the pixmap into an image */
            ximg = XGetImage(Dpy, pixent->pix,
                             0, 0, pixent->width, pixent->height,
                             AllPlanes, ZPixmap);
            if ( ximg )
            {
                /* get the fg and bg original pixels */
                fore_fg = fg = WidgetPixels[1];
                back_bg = bg = WidgetPixels[0];

                /* get the fg and bg substitute pixels */
                if ( !fg_color )
                    fg = WidgetPixels[0];
                else
                {
                    r = ((fg_color & 0x000000FF) >> 0);
                    g = ((fg_color & 0x0000FF00) >> 8);
                    b = ((fg_color & 0x00FF0000) >> 16);
                    AxGetRealPixel(0, r, g, b, 0, 255, &fg);
                }
                if ( !bg_color )
                    bg = WidgetPixels[0];
                else
                {
                    r = ((bg_color & 0x000000FF) >> 0);
                    g = ((bg_color & 0x0000FF00) >> 8);
                    b = ((bg_color & 0x00FF0000) >> 16);
                    AxGetRealPixel(0, r, g, b, 0, 255, &bg);
                }

                /* convert fg and bg colors */
                for ( i=0; i<ximg->height; i++ )
                {
                    for ( j=0; j<ximg->width; j++ )
                    {
                        val = XGetPixel(ximg, j, i);
                        if ( val == back_bg )
                            XPutPixel(ximg, j, i, bg);
                        else if ( val == fore_fg )
                            XPutPixel(ximg, j, i, fg);
                    }
                }
    
                /* set the clip */
                if ( w->gePaletteButtonType == 4 )
                    stipple_num = 26;
                else
                    stipple_num = 27;
                XSetClipMask(Dpy, ForeGC, GetStippleMap(stipple_num) );
                XSetClipOrigin(Dpy, ForeGC, w->xpos + BTN_MARGIN_DIM,
                               w->ypos + BTN_MARGIN_DIM);
    
                /* copy the image to the button surface */
                XPutImage(Dpy, WIN_OF(w), ForeGC, ximg, 0,0, 
                          w->xpos + BTN_MARGIN_DIM,
                          w->ypos + BTN_MARGIN_DIM,
                          ximg->width, ximg->height);
                XDestroyImage(ximg);

                /* restore the clip */
                XSetClipMask(Dpy, ForeGC, (Pixmap) 0);
            }
#endif    /* } */
        }

        /* any other button wanting color */
        else if ( fg_color || bg_color )
        {
#if AXMS    /* { */
    /* see comments above. */
            AxWin_DrawRowColButton(w, pixent->pix, fg_color, bg_color, FALSE);
#else    /* } { */
            /* copy the pixmap into an image */
            ximg = XGetImage(Dpy, pixent->pix,
                             0, 0, pixent->width, pixent->height,
                             AllPlanes, ZPixmap);
            if ( ximg )
            {
                /* get the fg and bg original pixels */
                fore_fg = fg = WidgetPixels[1];
                back_bg = bg = WidgetPixels[0];

                /* get the fg and bg substitute pixels */
                if ( !fg_color )
                    fg = WidgetPixels[0];
                else
                {
                    r = ((fg_color & 0x000000FF) >> 0);
                    g = ((fg_color & 0x0000FF00) >> 8);
                    b = ((fg_color & 0x00FF0000) >> 16);
                    AxGetRealPixel(0, r, g, b, 0, 255, &fg);
                }
                if ( !bg_color )
                    bg = WidgetPixels[0];
                else
                {
                    r = ((bg_color & 0x000000FF) >> 0);
                    g = ((bg_color & 0x0000FF00) >> 8);
                    b = ((bg_color & 0x00FF0000) >> 16);
                    AxGetRealPixel(0, r, g, b, 0, 255, &bg);
                }

                /* convert fg and bg colors */
                for ( i=0; i<ximg->height; i++ )
                {
                    for ( j=0; j<ximg->width; j++ )
                    {
                        val = XGetPixel(ximg, j, i);
                        if ( val == back_bg )
                            XPutPixel(ximg, j, i, bg);
                        else if ( val == fore_fg )
                            XPutPixel(ximg, j, i, fg);
                    }
                }
    
                /* copy the image to the button surface */
                XPutImage(Dpy, WIN_OF(w), ForeGC, ximg, 0,0, 
                          w->xpos + BTN_MARGIN_DIM,
                          w->ypos + BTN_MARGIN_DIM,
                          ximg->width, ximg->height);
                XDestroyImage(ximg);
            }
#endif    /* } */
        }
        else /* just copy pixmap */
        {
            /* copy the pixmap onto it */
            XCopyArea(Dpy, pixent->pix, WIN_OF(w), ForeGC, 0, 0,
                      pixent->width, pixent->height,
                      w->xpos + BTN_MARGIN_DIM,
                      w->ypos + BTN_MARGIN_DIM);
        }
    }
    /* draw button shadow */
    if (!w->disabled)
        AxDrawShadow(WIN_OF(w), SunGC, ShadowGC, w->thickness, x, y, wid, hyt, 
                   OLSHADOW_DRAW);
    return;
}

/* Compute the x and y positions of each button inside the transient
   window. */
static void
LayoutButtons(w, cell_width, cell_height, num_rows, num_cols)
register AXWidget_rowcol w;
register int cell_width;
register int cell_height;
register int num_rows;
register int num_cols;
{
    int row_idx, col_idx, btn_idx, btn_ypos, btn_xpos;
    
    /* Text runs top to bottom */
    if (TextOnlyRowCol(w)) {
        for (col_idx = 0, btn_idx = 0, btn_xpos = BTN_MARGIN_DIM;
            col_idx < num_cols; col_idx++) {
            btn_ypos = BTN_MARGIN_DIM;
            for (row_idx = 0; row_idx < num_rows; row_idx++) {
                if (btn_idx >= w->num_buttons)
                    break;
                w->buttons[btn_idx]->xpos = btn_xpos;
                w->buttons[btn_idx]->ypos = btn_ypos;
                w->buttons[btn_idx]->width  = cell_width;
                w->buttons[btn_idx]->height = cell_height;
                btn_ypos +=  cell_height;
                btn_idx++;
            }
            btn_xpos += cell_width;
        }
    }

    /* Graphics runs left to right */
    else {
        for (row_idx = 0, btn_idx = 0, btn_ypos = BTN_MARGIN_DIM;
            row_idx < num_rows; row_idx++) {
            btn_xpos = BTN_MARGIN_DIM;
            for (col_idx = 0; col_idx < num_cols; col_idx++) {
                if (btn_idx >= w->num_buttons)
                    break;
                w->buttons[btn_idx]->xpos = btn_xpos;
                w->buttons[btn_idx]->ypos = btn_ypos;
                w->buttons[btn_idx]->width  = cell_width;
                w->buttons[btn_idx]->height = cell_height;
                btn_xpos +=  cell_width;
                btn_idx++;
            }
            btn_ypos += cell_height;
        }
    }
    return;
}

/* Place button foreground and background colors into *FG and *BG.
   VAL is an index into to the buttons array.  Place a 0 for
   foreground and background colors for invalid arguments.
   Always return 0. */
int
AxRowColColors(w, val, fg, bg)
AXWidget_rowcol w;
int val, *fg, *bg;
{
    if (!w || !w->buttons || val >= w->num_buttons || val < 0) {
        *fg = 0;
        *bg = 0;
    } else {
        *fg = w->buttons[val]->color;
        *bg = w->buttons[val]->bg_color;
    }
    return(0);
}

/* Create and manage a row-column pulldown.
   mode:
   0 - OPTION_NEW   - Initial display
   1 - OPTION_MOVE  - Pointer motion
   2 - OPTION_DONE  - Button up
   */
void
PaintRowColumnPulldown(w, mode, eventP)
register AXWidget_rowcol w;
int mode;
XEvent *eventP;
{
    int cell_width, cell_height;
    int num_rows, num_cols;
#if AX_X11
    XSetWindowAttributes atts;
#endif
    Window child;
    int btn_idx;
    static int new_value;
    static int old_value;
    static int shifted;
    static int btn_area_height;
    static int txt_area_height;
    static int need_label_string;
    static int in_window = FALSE;
    XmRowColumnCallbackStruct data;
    long att_mask;
    int mo_xpos, mo_ypos;
    int ix;
    pixcache_t *pixent;
    int pulldown_xpos, pulldown_ypos;

    if (!w || !w->display)
        return;
    if (w->disabled)
        return;    
    w->mapped = TRUE;

    if (!w->buttons || (w->num_buttons <= 0)) {
        ResetActive();
        return;
    }
    
    switch (mode) {
    case OPTION_NEW: /* Button-1 Down */
        in_window = TRUE;            /* by definition */
        /* Return for insane values on `w->value'. */
        if ((w->value != -1) && (w->value < w->num_buttons))
            new_value = w->value;
        else {
            /* Change widget value if w->value is out of range. */
            w->value  = -1; /* FIXME, return here?? */
            new_value = -1;
        }
        
        old_value = new_value;

        if (ComputeRowColumnPacking(w, &cell_width, &cell_height,
                                    &num_rows, &num_cols) == -1) {
            ThimExposuresMayBeComing = TRUE;
            ResetActive();
            AxXtDestroyWidget((AXWidget)w);
            return;
        }

        w->pulldown_height = (short) ((cell_height * num_rows)
                                   + (BTN_MARGIN_DIM * 2));
        w->pulldown_width  = (short) ((cell_width * num_cols)
                                   + (BTN_MARGIN_DIM * 2));
        /* Determine the need for label text */
        if (SpecialCharRowCol(w))
            need_label_string = FALSE;
        else {
            if (!w->strs)
                need_label_string = FALSE;
            else
                need_label_string = TRUE;
        }

        btn_area_height = w->pulldown_height; /* default btn-area-height */
        if (need_label_string)
            txt_area_height = AxCharHeight + (BTN_MARGIN_DIM * 2);
        else
            txt_area_height = 0;

        /* adjust total pulldown height to accomodate text area */
        if (need_label_string)
            w->pulldown_height += txt_area_height;

        LayoutButtons(w, cell_width, cell_height, num_rows, num_cols);

        XTranslateCoordinates(Dpy, WIN_OF(w), RootWin, w->xpos,
                              w->ypos, &pulldown_xpos, &pulldown_ypos,
                              &child);
        if ((w->value >= 0) && (w->value < w->num_buttons)) {
            /* FIXME, handle the case when pulldown_xpos, pulldown_ypos
               are negative! */
            pulldown_xpos -= w->buttons[w->value]->xpos;
            pulldown_ypos -= w->buttons[w->value]->ypos;
        } else {
            pulldown_ypos += w->height;
            /* leave `pulldown_xpos' unchanged. */
        }
        shifted = ShiftPulldownOrigin(&pulldown_xpos, &pulldown_ypos,
                                      w->pulldown_width, w->pulldown_height);
        w->pulldown_xpos = pulldown_xpos;
        w->pulldown_ypos = pulldown_ypos;
        
#if AXMS
        AxCreateWinRowColWindow(w);
#else    
        att_mask = CWOverrideRedirect | CWSaveUnder | CWBackPixel;
        atts.override_redirect = TRUE;
        atts.save_under = TRUE;
        atts.background_pixel = BackPixel;
        w->window = AxCrtWindow(Dpy, RootWin,
                                w->pulldown_xpos, w->pulldown_ypos,
                                w->pulldown_width, w->pulldown_height,
                                0, CopyFromParent, InputOutput, CopyFromParent,
                                att_mask, &atts);
        XMapWindow(Dpy, w->window);
#endif
        RowColumnArmed = w;

        /* warp pointer if necessary -- very annoying */
        if (shifted) {
            if (w->buttons && (w->value >= 0) &&
                (w->value < w->num_buttons)) {
                XWarpPointer(Dpy, w->window, w->window, 0, 0,
                             w->pulldown_width, w->pulldown_height,
                             w->buttons[w->value]->xpos + (cell_width / 2),
                             w->buttons[w->value]->ypos + (cell_height / 2));
            } /* else, FIXME */
        }
        /* draw background around whole transient */
        XFillRectangle(Dpy, w->window, BackGC, 0, 0,
                       w->pulldown_width, w->pulldown_height);
        /* draw btn-area shadow */
        AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness, 0, 0, 
					w->pulldown_width, btn_area_height, OLSHADOW_DRAW);
                   

        /* draw txt-area shadow */
        if (need_label_string)
            AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness, 
						0, btn_area_height,
						w->pulldown_width, txt_area_height, OLSHADOW_DRAW);

        /* draw buttons on the transient */
        for (btn_idx = 0; btn_idx < w->num_buttons; btn_idx++) {
            if (SpecialCharRowCol(w)) {
                DrawBtnSpecialChar(w, btn_idx);
            } else if (TextOnlyRowCol(w)) {
                DrawButtonString(w, btn_idx);
            } else {
                char bitmap_name[STRPATH + 1];

                strcpy(bitmap_name, w->buttons[btn_idx]->name);
                pixent = Pixmapper(bitmap_name);
                RenderRowColumnPixmap(w, btn_idx, pixent);
            }
            if (TextOnlyRowCol(w)) {
                if (btn_idx == w->value)
                    AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness,
                                 w->buttons[btn_idx]->xpos,
                                 w->buttons[btn_idx]->ypos,
                                 w->buttons[btn_idx]->width,
                                 w->buttons[btn_idx]->height,
                                 OLSHADOW_DRAW);
                else
                    AxDrawShadow(w->window, BackGC, BackGC, w->thickness,
                                 w->buttons[btn_idx]->xpos,
                                 w->buttons[btn_idx]->ypos,
                                 w->buttons[btn_idx]->width,
                                 w->buttons[btn_idx]->height,
                                 OLSHADOW_DRAW);
            } else {
                if (btn_idx == w->value)
                    AxDrawShadow(w->window, ShadowGC, SunGC, w->thickness,
                                 w->buttons[btn_idx]->xpos,
                                 w->buttons[btn_idx]->ypos,
                                 w->buttons[btn_idx]->width,
                                 w->buttons[btn_idx]->height,
                                 OLSHADOW_DRAW);
                else
                    AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness,
                                 w->buttons[btn_idx]->xpos,
                                 w->buttons[btn_idx]->ypos,
                                 w->buttons[btn_idx]->width,
                                 w->buttons[btn_idx]->height,
                                 OLSHADOW_DRAW);
            }
        }
        /* draw label text. */
        if (need_label_string)
            DrawRowColumnLabelString(w, w->value, btn_area_height);
        break;
        
    case OPTION_MOVE: /* Button-1 Motion */
        if (!eventP)
            return;
#if AXMS
        /* on Windows the motion event points are already rowcol relative. */
        mo_xpos = eventP->xmotion.x;
        mo_ypos = eventP->xmotion.y;
#else
        XTranslateCoordinates(Dpy, WIN_OF(w), w->window, eventP->xmotion.x,
                              eventP->xmotion.y, &mo_xpos, &mo_ypos, &child);
#endif
        if ((mo_xpos < (BTN_MARGIN_DIM)) ||
            (mo_xpos > (w->pulldown_width - BTN_MARGIN_DIM))) {
            /* outside window */
            new_value = w->value;
            in_window = FALSE;
        } else if ((mo_ypos < (BTN_MARGIN_DIM)) ||
                  (mo_ypos > (w->pulldown_height - BTN_MARGIN_DIM))){
            /* outside window */
            new_value = w->value;
            in_window = FALSE;
        } else {
            in_window = TRUE;
            for (ix = 0; ix < w->num_buttons; ix++) {
                if ((mo_xpos > (w->buttons[ix]->xpos)) &&
                    (mo_xpos < (w->buttons[ix]->xpos +
                                w->buttons[ix]->width)) &&
                    (mo_ypos > (w->buttons[ix]->ypos)) &&
                    (mo_ypos < (w->buttons[ix]->ypos +
                                w->buttons[ix]->height))) {
                    new_value = ix; /* one of the buttons */
                }
            } /* end for */
        }
        if (new_value == -1) {
            if (old_value != -1) {
                AxDrawShadow(w->window, BackGC, BackGC, w->thickness,
                           w->buttons[old_value]->xpos,
                           w->buttons[old_value]->ypos, 
                           w->buttons[old_value]->width,
                           w->buttons[old_value]->height,
                           OLSHADOW_DRAW);
                if (!TextOnlyRowCol(w))
                    AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness,
                                 w->buttons[old_value]->xpos,
                                 w->buttons[old_value]->ypos, 
                                 w->buttons[old_value]->width,
                                 w->buttons[old_value]->height,
                                 OLSHADOW_DRAW);
            }
            if (need_label_string)
                DrawRowColumnLabelString(w, -1, btn_area_height);
        } else if (new_value != old_value) {
            if (old_value != -1) {
                /* lift shadow from old "choice pending" indication */
                AxDrawShadow(w->window, BackGC, BackGC, w->thickness,
                           w->buttons[old_value]->xpos,
                           w->buttons[old_value]->ypos, 
                           w->buttons[old_value]->width,
                           w->buttons[old_value]->height,
                           OLSHADOW_DRAW);
                /* put normal shadow in it's place */
                if (!TextOnlyRowCol(w))
                    AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness,
                                 w->buttons[old_value]->xpos,
                                 w->buttons[old_value]->ypos, 
                                 w->buttons[old_value]->width,
                                 w->buttons[old_value]->height,
                                 OLSHADOW_DRAW);
            }

            /* turn on new "choice pending" indication */
            if (TextOnlyRowCol(w)) 
                AxDrawShadow(w->window, SunGC, ShadowGC, w->thickness,
                             w->buttons[new_value]->xpos,
                             w->buttons[new_value]->ypos,
                             w->buttons[new_value]->width,
                             w->buttons[new_value]->height,
                             OLSHADOW_DRAW);
            else
                AxDrawShadow(w->window, ShadowGC, SunGC, w->thickness,
                             w->buttons[new_value]->xpos,
                             w->buttons[new_value]->ypos,
                             w->buttons[new_value]->width,
                             w->buttons[new_value]->height, OLSHADOW_DRAW);

            if (need_label_string)
                DrawRowColumnLabelString(w, new_value, btn_area_height);
        }
        old_value = new_value;
        break;

    case OPTION_DONE: /* Button-1 Up */
        if (old_value != -1)
            w->value = old_value;
        data.data = (char *) w->value;
        ThimExposuresMayBeComing = TRUE;
        ResetActive();
        if (w->callback && in_window)
            AxCallback(w->callback,(AXWidget)w,w->callbacktag, (caddr_t)&data);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
        in_window = FALSE;
        if (SpecialCharRowCol(w))
            w->value = -1; /* HACK for eqn editor. */
        break;

    default:
        return;
    }
    return;
}

/* Draw the string associated with the button corresponding to `value'.
   Try to center the string in the text display area. */
static void
DrawRowColumnLabelString(w, value, btn_area_height)
register AXWidget_rowcol w;
register int value;
register int btn_area_height;
{
    GC gc;
    register int avail_width;
    register int label_width;
    register int label_xpos;
    mbchar *label_str;

    if (!w)
        return; /* invalid args */

#if AX_X11        
    if (AxOpenLook)
        gc = olBoldTextGC;
    else
#endif
        gc = ForeGC;

    XFillRectangle(Dpy, w->window, BackGC, BTN_MARGIN_DIM,
                   btn_area_height + BTN_MARGIN_DIM,
                   w->pulldown_width - (2 * BTN_MARGIN_DIM),
                   AxCharHeight);
    if ((value < 0) || (value >= w->num_buttons))
        return;

    if (w->strs)
        label_str = w->strs[value];
    else
        label_str = w->buttons[value]->name;

    if (!label_str)
        return;

    /* try to center the string */
    avail_width = w->pulldown_width - (2 * BTN_MARGIN_DIM);
    label_width = BasicStrlen(label_str);
    if (label_width < avail_width) {
        label_xpos = (((avail_width / 2) + BTN_MARGIN_DIM) -
                      (label_width / 2));
        if ((label_xpos < BTN_MARGIN_DIM) ||
            (label_xpos >= (avail_width + BTN_MARGIN_DIM)))
            label_xpos = BTN_MARGIN_DIM; /* safety net */
    } else
        label_xpos = BTN_MARGIN_DIM;

	xmDrawString((AXWidget)w, w->window, gc, label_xpos,
				 btn_area_height + AxCharHeight,
				 label_str, strlen(label_str), w->textShadow,
				 w->textColor, w->widgetColor);
    return;
}

/* Render button pixmap */
static void
RenderRowColumnPixmap(w, ix, pixent)
AXWidget_rowcol w;
int ix;
pixcache_t *pixent;
{
    unsigned long saved_foreground;
    unsigned long saved_background;
    unsigned long fg;
    unsigned long bg;
    int r, g, b;
    int fg_changed = FALSE;
    int bg_changed = FALSE;

    if (!w)
        return; /* invalid args */

    if (ix == -1)
        return;

    /* save foreground, background */
    saved_foreground = AXGetForegroundPixel(Dpy, ForeGC);
    saved_background = AXGetBackgroundPixel(Dpy, ForeGC);
    /*
      32 bit int:
      byte3   byte2  byte1  byte0
      0x00    blue   green  red
      */

    if (w->buttons[ix]->color) {
        r = (w->buttons[ix]->color & 0x000000FF);
        g = ((w->buttons[ix]->color & 0x0000FF00) >> 8);
        b = ((w->buttons[ix]->color & 0x00FF0000) >> 16);
        AxGetRealPixel(0, r, g, b, 0, 255, &fg);
        fg_changed = TRUE;
    }

    if (w->buttons[ix]->bg_color) {
        r = (w->buttons[ix]->bg_color & 0x000000FF);
        g = ((w->buttons[ix]->bg_color & 0x0000FF00) >> 8);
        b = ((w->buttons[ix]->bg_color & 0x00FF0000) >> 16);
        AxGetRealPixel(0, r, g, b, 0, 255, &bg);
        bg_changed = TRUE;
    }

    /* if there is color, draw color, otherwise copy the pixmap */
    if (pixent && (w->gePaletteButtonType == 4 || w->gePaletteButtonType == 5)) {
        XCopyArea(Dpy, pixent->pix, w->window, ForeGC, 0,
                  0, pixent->width, pixent->height,
                  w->buttons[ix]->xpos + BTN_MARGIN_DIM,
                  w->buttons[ix]->ypos + BTN_MARGIN_DIM);
    }
    else if (fg_changed || bg_changed) {
        /* set foreground, background */
        if (fg_changed)
            XSetForeground(Dpy, ForeGC, fg);
        if (bg_changed)
            XSetBackground(Dpy, ForeGC, bg);

        XFillRectangle(Dpy, w->window, ForeGC,
                       w->buttons[ix]->xpos + BTN_MARGIN_DIM,
                       w->buttons[ix]->ypos + BTN_MARGIN_DIM,
                       w->buttons[ix]->width - 2*BTN_MARGIN_DIM,
                       w->buttons[ix]->height - 2*BTN_MARGIN_DIM);

        /* restore foreground, background */
        XSetForeground(Dpy, ForeGC, saved_foreground);
        XSetBackground(Dpy, ForeGC, saved_background);
    } else if (pixent) {
        XCopyArea(Dpy, pixent->pix, w->window, ForeGC, 0,
                  0, pixent->width, pixent->height,
                  w->buttons[ix]->xpos + BTN_MARGIN_DIM,
                  w->buttons[ix]->ypos + BTN_MARGIN_DIM);
    }
    return;
}

/* Clear button and draw button special char.  Caller draws button shadow. */
static void
DrawBtnSpecialChar(w, btn_idx)
register AXWidget_rowcol w;
register int btn_idx; /* button index. */
{
    int btn_xpos, btn_ypos, btn_width, btn_height;
    int rel_x, rel_y;
    mbchar *text_str;
    mbchar *atm_font_name;
    int point_size = BUTTON_TEXT_POINT_SIZE;
    GC gc;
    int char_above, char_below, char_height;

    if (!w)
        return; /* invalid args. */
    if ((btn_idx < 0) || (btn_idx >= w->num_buttons))
        return;
    if (!w->buttons || !w->strs)
        return;

    btn_xpos = w->buttons[btn_idx]->xpos;
    btn_ypos = w->buttons[btn_idx]->ypos;
    btn_width  = w->buttons[btn_idx]->width;
    btn_height = w->buttons[btn_idx]->height;
    rel_x = ButtonTextRelX(w);
    rel_y = ButtonTextRelY(w);
    text_str = w->strs[btn_idx];
    atm_font_name = w->buttons[btn_idx]->name;
    XFillRectangle(Dpy, w->window, BackGC, btn_xpos, btn_ypos,
                   btn_width, btn_height); /* clear button. */
    gc = CreateButtonTextGC(atm_font_name, point_size, &char_above,
                            &char_below, &char_height);
	
    if (gc == (GC) NULL)
        return;
	
	xmDrawString((AXWidget)w, w->window, gc, btn_xpos + rel_x + BTN_MARGIN_DIM,
				 btn_ypos + rel_y + char_above + BTN_MARGIN_DIM,
				 text_str, 1,   /* 1 for now. */
				 w->textShadow, w->textColor, w->widgetColor);
	
    XFreeGC(Dpy, gc);
    return;
}

/* Clear button and draw button string.  Caller draws button shadow. */
static void
DrawButtonString(w, btn_idx)
register AXWidget_rowcol w;
register int btn_idx;
{
    int btn_xpos, btn_ypos, btn_width, btn_height;
    mbchar *button_text;
    int char_above;

    if (!w)
        return;
    if (btn_idx < 0 || btn_idx >= w->num_buttons)
        return;
    if (!w->buttons)
        return;
    btn_xpos = w->buttons[btn_idx]->xpos;
    btn_ypos = w->buttons[btn_idx]->ypos;
    btn_width  = w->buttons[btn_idx]->width;
    btn_height = w->buttons[btn_idx]->height;
    button_text = w->buttons[btn_idx]->name;
    if (w->font)
        char_above = w->font->max_bounds.ascent;
    else
        char_above = AxCharAbove;
    XFillRectangle(Dpy, w->window, BackGC, btn_xpos, btn_ypos,
                   btn_width, btn_height); /* clear button */
    xmDrawString((AXWidget)w, w->window, ForeGC, btn_xpos + BTN_MARGIN_DIM +
                 TEXT_LEFT_OFFSET,
                 btn_ypos + BTN_MARGIN_DIM + char_above,
                 button_text, strlen(button_text),
                 w->textShadow, w->textColor, w->widgetColor);
    return;
}

/* Create and return a gc to be used to display button text.
   FONT_NAME is an atm font name; i.e. a name that getXFontStruct()
   knows about.
   Return (GC) NULL on failure.
   Note:  Caller is responsible for freeing the returned gc. */
static GC
CreateButtonTextGC(font_name, point_size, char_abovep, char_belowp,
                   char_heightp)
char *font_name;
int  point_size;
int *char_abovep; /* OUT */
int *char_belowp; /* OUT */
int *char_heightp;/* OUT */
{

    XGCValues gcv;
    GC gc;
    int err;
    int scalable;
    XFontStruct *font;

    if (!font_name || !char_abovep || !char_belowp || !char_heightp)
        return((GC) NULL); /* invalid args. */

    err = getXFontStruct(font_name, point_size, 0, 0, &scalable, &font);
    if (err != TRUE)
        return((GC) NULL);
    memset((char *) &gcv, 0, sizeof(XGCValues));
    gcv.fill_style = FillSolid;
    gcv.function = GXcopy;
    gcv.plane_mask = AllPlanes;
#if 1
    if (UseWidgetColors /* ColorDisplay && !NoColor */) {
        gcv.foreground = WidgetPixels[1 /* TMA_BLACK */];
        gcv.background = WidgetPixels[0 /* TMA_WHITE */];
    } else {
        gcv.foreground = ForePixel;
        gcv.background = BackPixel;
    }
#else
    gcv.foreground = WidgetPixels[1 /* TMA_BLACK */];
    gcv.background = WidgetPixels[0 /* TMA_WHITE */];
#endif
    gcv.font = font->fid;
    gc = axCreateGC(Dpy, RootWin, DefaultScreen(Dpy),
					DisplayPlanes(Dpy, DefaultScreen(Dpy)), font,
					(GCForeground  | GCBackground
					 | GCPlaneMask | GCFunction | GCFont), &gcv);
    if (!gc)
        return((GC) NULL);
    *char_abovep  = font->max_bounds.ascent;
    *char_belowp  = font->max_bounds.descent;
    *char_heightp = *char_abovep + *char_belowp;
    return(gc);
}

/* Shift *XP and *YP (if necessary) so that window fits in the display.
   Return TRUE if co-ordinates shifted; FALSE otherwise. */
static int
ShiftPulldownOrigin(xp, yp, width, height)
int *xp; /* INOUT */
int *yp; /* INOUT */
int width;
int height;
{
    int shifted = FALSE;

    if (!xp || !yp)
        return(shifted); /* invalid args: return default */

    if (*xp < 8) {
        *xp = 8;
        shifted = TRUE;
    }

    if (*yp < 8) {
        *yp = 8;
        shifted = TRUE;
    }

    if ((*xp + width) > DpyWid) {
        *xp = DpyWid - width - 8;
        shifted = TRUE;
    }

    if ((*yp + height) > DpyHt) {
        *yp = DpyHt - height - 8;
        shifted = TRUE;
    }
    return(shifted);
}

/* Return 1 if STYLE is one of the implemented row-column styles; 0
   otherwise */
int
IsValidRowColumnStyle(style)
register int style;
{
    if ((style == RC_TYPE_SQUARE) ||
        (style == RC_TYPE_ROW) ||
        (style == RC_TYPE_COLUMN))
        return(1);
    else
        return(0);
}

/* Return 1 if this row column pulldown needs to display ONE special char
   in each button; 0 otherwise.

   The equation editor needs to display one text string in each button.
   Normally, a pixmap is drawn in row column buttons. */
static int
SpecialCharRowCol(w)
register AXWidget_rowcol w;
{
    if ((!w) || w->type != W_ROWCOL)
        return(0);
    if (w->scroll_per)
        return(1); /* need text string in buttons. */

    return(0); /* do not need text string in btns. i.e. need pixmaps. */
}

/* Return TRUE if this row column pulldown needs to display text
   strings only;  FALSE otherwise.

   The width of each button is the max width of all strings, height is
   the height of a character.

   Needed by the Word Processor.*/
static int
TextOnlyRowCol(w)
register AXWidget_rowcol w;
{
    if ((!w) || w->type != W_ROWCOL)
        return(FALSE);
    if (w->multi_pick)
        return(TRUE);
    return(FALSE);
}

static int
ButtonTextRelX(w)
register AXWidget_rowcol w;
{
    if ((!w) || w->type != W_ROWCOL)
        return(0);
    return(w->minValue);
}

static int
ButtonTextRelY(w)
register AXWidget_rowcol w;
{
    if ((!w) || w->type != W_ROWCOL)
        return(0);
    return(w->maxValue);
}


#if AXMS    /* { */
/*************************************************************/
/* This simply Blts a mono bitmap handle using the given colors.
 * for explanation of why we need this see comment at first use
 * of this function, above.
 ***************************/
static void
AxWin_DrawRowColButton(AXWidget_rowcol w, HBITMAP hbm,
                int fg_color, int bg_color, int use_mask)
{
    HDC hdc;
    int r, g, b;
    int remove_dc;
    unsigned long fg, bg;
    HBITMAP mask;

    WIDGET_PARANOID(w, W_ROWCOL);
    hdc = InsureDrawable(w->parent->window, &remove_dc);

    /* get the fg and bg substitute pixels */
    if ( !fg_color )
        fg = WidgetPixels[0];
    else
        {
        r = ((fg_color & 0x000000FF) >> 0);
        g = ((fg_color & 0x0000FF00) >> 8);
        b = ((fg_color & 0x00FF0000) >> 16);
        AxGetRealPixel(0, r, g, b, 0, 255, &fg);
        }

    if ( !bg_color )
        bg = WidgetPixels[0];
    else
        {
        r = ((bg_color & 0x000000FF) >> 0);
        g = ((bg_color & 0x0000FF00) >> 8);
        b = ((bg_color & 0x00FF0000) >> 16);
        AxGetRealPixel(0, r, g, b, 0, 255, &bg);
        }

    if ( use_mask )
        {
        /* set the clip */
        if ( w->gePaletteButtonType == 4 )
            mask = (HBITMAP)GetStippleMap(26);
        else
            mask = (HBITMAP)GetStippleMap(27);
        }
    else
        mask = NULL;

    PaintButtonPixmap(hbm, hdc, w->xpos + BTN_MARGIN_DIM,
                        w->ypos + BTN_MARGIN_DIM,
                        mask, fg, bg, FALSE);

    if ( remove_dc )
        RemoveDrawable(w->parent->window, hdc);
}
#endif    /* } AXMS */




/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
