/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmwcolor.h
   Applix ASC version: 6
   Date: Mon Nov 16 13:53:43 1998
*/
#ifndef _xmwcolor_h_
#define _xmwcolor_h_

typedef union {
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
	} any;
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
		unsigned char r, g, b;
	} rgb;
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
		unsigned char c, m, y, k;
	} cmyk;
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
		mbchar *color_name;
	} named;
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
	} wkit;
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
	} work;
	struct {
		unsigned char type;
		unsigned char flags;
		unsigned long pixel;
		float h; /* [0.0 - 360.0] */
		float s; /* [0.0 - 100.0] */
		float b; /* [0.0 - 100.0] */
	} hsb;
} wcolor_t;

/* Widget Color Space definitions.  Do not define any spec to 0. */
#define WCSPACE_RGB   1
#define WCSPACE_NAMED 2
#define WCSPACE_WKIT  3
#define WCSPACE_WORK  4
#define WCSPACE_HSB   5
#define WCSPACE_CMYK  6

extern wcolor_t *AxCreateWColor(/* AXWidget w, data_ptr dP */);
extern void AxFreeWColor(/* wcolor_t *cp */);
extern data_ptr AxCreateWColorData(/* AXWidget *w, wcolor_t *cp */);
extern void HSBToRGB(/* int *rp, int *gp, int *bp, float h, float s,
						float v */);
extern void RGBToHSB(/* float *oh, float *os, float *ob, int ir, int ig,
						int ib */);
extern int AxGetHSBFromWColor(/* wcolor_t *color, float *hp, float *sp,
								 float *bp */);

#endif /* !_xmwcolor_h_ */


/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
