/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xwidgets.h
   Applix ASC version: 73
   Date: Mon Nov 16 13:53:32 1998
*/
#ifndef _XWIDGETS_H
#define _XWIDGETS_H

#include <axhtab.h>

#define AXW_HEAD                                                              \
    short type; /* W_... */                                                   \
    mbchar *name;        /* text or pixmap-name */                            \
    int flags;           /* passed in from elf_dlg.elf */                     \
    int value;           /* for W_TOGGLE, W_RADIO... */                       \
    struct axw_any *next; /* thread */                                        \
    struct axw_any *prev; /* thread */                                        \
    struct axw_main *parent; /* to walk back up tree */                       \
    struct axw_any *nextWin; /* */                                            \
    struct axw_any *widgets; /* */                                            \
    struct axw_any *nextChild;                                                \
    struct wlayer_t *layerList;                                               \
    XFontStruct *font;                                                        \
    XFontStruct *referenceFont;                                               \
    void (*callback)();    /* status change */                                \
    caddr_t callbacktag;                                                      \
    short taskOwner;      /* the THIMPid of owning task */                    \
    int xpos, ypos;   /* in pixels */                                         \
    unsigned int width,height;    /* in pixels */                             \
    int style;                    /* for W_DIALOG, icon_id for window */      \
    short helpid;                 /* for info/error boxes */                  \
    unsigned int managed : 1,       /* 1: needed for GE palette's list box */ \
                 mapped : 1,        /* 2: if TRUE, widget has been mapped */  \
                 display : 1,       /* 3: if FALSE, don't draw widget */      \
                 disabled : 1,      /* 4: if TRUE, widget dimmed, inactive */ \
                 update_widget : 1, /* 5: if TRUE, widget needs repainting*/  \
                 async_message : 1, /* 6: special class of dialog */          \
                 regen_widget : 1,  /* 7: hint for list boxes */              \
                 multi_pick : 1,    /* 8: enabled for list boxes */           \
                 pending_delete : 1,/* 9: for text widgets */                 \
                 notTransient : 1,  /* 10: for main, dir display */           \
                 use2d : 1,         /* 11: overrides default */               \
                 elf_access : 1,    /* 12:  */                                \
                 small_font : 1,    /* 13: W_BUTTON & W_MENU only */          \
                 destroyed : 1,     /* 14: for debug */                       \
                 useWorkColors : 1, /* 15: if set,use app workarea colors */  \
                 no_echo : 1,       /* 16: echo '*' in entry field passwd */  \
                 hasFocus : 1,      /* 17:           */                       \
                 minorEventNotify: 1,/* 18: W_BUTTON btn down/up notify */    \
                 buttonUpScroll: 1, /* 19: for W_SCROLL: scroll on */         \
                 inheritCursor: 1,  /* 20: use same mcursor as parent */      \
                 saved_display: 1;  /* 21: used while hidden by tab control */\
    Window window;         /* for W_DIALOG only */                            \
    short thickness;  /* border width, rectangle thickness */                 \
    struct w_aux_t *auxData;    /* used by dlg editor */                      \
    eventRec *event_table;                                                    \
    int proc_index; /* to keep track of widget event handlers */              \
    int scroll_pos;     /* for W_COLORPAL */                                  \
    data_ptr elfObject;  /* For object based interface */                     \
    data_ptr shadow;       /* drop shadow info */                             \
    data_ptr textShadow;   /* drop shadow specific to text */                 \
    wcolor_t *textColor;    /* color specific to text */                      \
    wcolor_t *widgetColor;  /* color specific to widget title/surface */      \
    data_ptr graphic;      /* ptr to graphic info */                          \
    char *background_image;                                                   \
    int color;                    /* for VERB only */                         \
    char *rminfo;    /* ptr to array of strs to carry info of mouse */        \
    char *helpstr;   /* alternate for helpid */                               \
    unsigned long last_click_time;                                            \
    Cursor def_cursor;  /* the default for the widget, lowest priority */     \
    Cursor tmp_cursor;  /* a non application temp cursor, low priority */     \
    Cursor app_cursor;  /* an app-defined temp cursor, high priority */       \
    Cursor help_cursor; /* the help cursor, higher priority */                \
    Cursor wait_cursor; /* the wait cursor, highest priority */               \
    Cursor curr_cursor; /* the current cursor, set to the highest priority */ \
	long *keyFocusLinks;                                                      \
    axhtab *tabctl_linktab; /* RECT_LAYERED W_RECT to containees */           \
    int accelerator_key;    /* keycode for Alt-key activation */              \
    int db_uid;            /* DBDEX_uid, unique within dialog */              \
    void (*painter)();


#if AXMS
#define AXW_WIN_HEAD                                                          \
    unsigned int initial_paint   : 1, /* TRUE if first time thru WM_PAINT */  \
                 main_loop_paint : 1; /* used to prevent focus changes */     \
    UINT uid;             /* unique id for this widget */                     \
    HWND winid;           /* ID for windows */                                \
    HWND parent_hwnd;
#else
#define AXW_WIN_HEAD 
#endif

typedef struct axw_plates {    /* widget below menu bar in SS */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_plates;

typedef struct axw_page {    /* W_PAGEBAR */
    AXW_HEAD
    AXW_WIN_HEAD
    int scroll_max;
} axw_page;

typedef struct axw_buttonbar { /* W_BUTBAR */
    AXW_HEAD
    AXW_WIN_HEAD
    short num_buttons;
    struct axw_push_button **buttons;
} axw_buttonbar;

typedef struct axw_push_button {     /* push button */
    AXW_HEAD
    AXW_WIN_HEAD
    short down;                      /* if currently in the down state */
    unsigned int pixmapLabel : 1,    /* 1: if a pixmap */
                 noBorder : 1,       /* 2: graphic pushbuttons only */
                 owner_draw : 1,     /* 3: */
                 arm_callback : 1,   /* 4: */
                 no_arm_reverse : 1, /* 5: */
                 is_default : 1,     /* 6: is the default button in the dlg */
                 changed : 1;        /* 7: */
    int bg_color;
    short buttonType;           /* for AXW_PUSH_BUTTON */
    int whichButton;            /* for W_BUTTON; which button to respond to */
    char *alternatePixmap;
    Pixmap pixmap;
    int gePaletteButtonType;
#if AXMS
    HBITMAP pix_mask;           /* we display the button through this mask */
    int menu_uid;
#endif
} axw_push_button;

typedef struct axw_toggle_button {  /* W_TOGGLE */
    AXW_HEAD
    AXW_WIN_HEAD
    int whichButton;
    short state;                        /* if currently in the down state */
    short scroll_type;
    unsigned int like_radio : 1;        /* for diamond shaped toggles */
    struct axw_option_menu  *in_option; /* for buttons in pulldown menus */
    struct axw_radio_box *in_radio;     /* for toggle buttons in radio boxes */
} axw_toggle_button;

typedef struct axw_radio_box {    /* W_RADIO radio box */
    AXW_HEAD
    AXW_WIN_HEAD
    short num_buttons;
    struct axw_toggle_button **buttons;
} axw_radio_box;

typedef struct axw_work {    /* work area */
    AXW_HEAD
    AXW_WIN_HEAD
}  axw_work;

typedef struct axw_palette {    /*  GE palette */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_palette;

typedef struct axw_ruler {    /* WP ruler */
    AXW_HEAD
    AXW_WIN_HEAD
    short num_buttons;
    struct axw_push_button **buttons;
} axw_ruler;

typedef struct axw_corner {    /* window corner */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_corner;

typedef struct axw_debug {    /* macro debugger */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_debug;

typedef struct axw_colorpal {    /* GE color palette */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_colorpal;

typedef struct axw_rowcol {
    AXW_HEAD
    AXW_WIN_HEAD
    short scroll_type;
    int whichButton;            /* for W_BUTTON; which button to respond to */
    unsigned int pixmapLabel : 1;    /* if a pixmap */
    int bg_color;
    char **strs;
    char *alternatePixmap;
    int scroll_per;
    int minValue, maxValue;
    short pulldown_xpos;
    short pulldown_ypos;
    short pulldown_width;
    short pulldown_height;
    int gePaletteButtonType;
    short num_buttons;
    struct axw_push_button **buttons;
} axw_rowcol;

typedef struct axw_ribbon  {
    AXW_HEAD
    AXW_WIN_HEAD
    short armed;
    int scroll_per;
    int scroll_max;
    wchar *wstr;
    long *selections;   /* for W_LIST */
    Pixmap pixmap;
} axw_ribbon;


typedef struct axw_option_menu {    /* W_OPTION option menu */
    AXW_HEAD
    AXW_WIN_HEAD
    short num_buttons;
#if AXMS
    short num_strs;
    short line_height;
	short maxLen;
    HWND labelid;            /* for label left of option menu */
    wcolor_t *labelColor;    /* color specific to label text */
#endif
    struct axw_toggle_button **buttons;
    char **strs;
    short pulldown_xpos;
    short pulldown_ypos;
    short pulldown_width;
    short pulldown_height;
    short scrolltext;
    short old_value;
    struct axw_any *optionValue;   
} axw_option_menu;

typedef struct axw_list_box {     /* list box */
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int list_hscroll: 1,   /* TRUE if listbox has horz scrollbar */
                 hide_vscroll: 1,   /* FALSE if listbox has vert scrollbar */
                 no_picks : 1,      /* 17: W_LIST, W_EDITBOX display only */
                 double_click : 1,  /* 8: enabled for list boxes */
                 monospace_font : 1,
                 force_list_item_display : 1, /* 5: W_LIST */
                 let_windows_manage : 1;
    struct axw_scrollbar *hScrollBar;    /* for W_MAIN */
    struct axw_scrollbar *vScrollBar;    /* for W_MAIN, W_LIST */
    char **strs;
    long *selections;   /* for W_LIST */  
    long *old_selections;   /* for W_LIST */  
    int scroll_max;     /* also used a list height for W_LIST */
    short maxLen;
    short line_height;
    short maxWidth;
    short curPos;
    short armed;     
    scroll_history *scroll_hist;    /* previous state of scrollbar */
    int num_strs;
    struct axw_push_button **buttons;
#if AX_X11
    Pixmap wapixmap;
#endif
    short hscroll_pos;
    int last_item_selected;
} axw_list_box;

typedef struct axw_label {    /* fixed text label */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_label;

typedef struct axw_splitter {
    AXW_HEAD
    AXW_WIN_HEAD
    int maxHeight;
} axw_splitter;

typedef struct axw_scrollbar {
    AXW_HEAD
    AXW_WIN_HEAD
    int scroll_per;
    int scroll_max;
    int pixmapWidth, pixmapHeight;
    int hscroll_pos;
    short scroll_type;
    short armed;
    short availpix,forepix,pospix;
#if AX_X11
    Pixmap wapixmap;
#endif
} axw_scrollbar;

typedef struct tablayer_t {
    char *layerName;        /* string displayed in folder tab */
    int layerNumber;        /* layer "id" unique only within axw_rect */
    data_ptr gadget_uids;   /* db_uids of widgets contained in this layer */
	int accelerator_key;    /* Alt-<charcode> activator for this layer */
} tablayer;

typedef struct tabctl_info_t {
    /* tab layer info for the tab-control style of axw_rect */
    int layer_style;
    int active_layer;
    int num_layers;
    tablayer *layerlist;
    int left_inset;   /* insets !=0 if tabs take space on that side */
    int right_inset;
    int top_inset;
    int bottom_inset;
} tabctl_info;

typedef struct axw_rect {    /* W_RECT rectangle on the dialog surface */
    AXW_HEAD
    AXW_WIN_HEAD
    tabctl_info tabctl;
} axw_rect;

typedef struct axw_popup { /* W_POPUP */
    AXW_HEAD
    AXW_WIN_HEAD
    short pulldown_width;
    short pulldown_height;
    int whichButton;        /* for W_BUTTON; which button to respond to */
    int gePaletteButtonType; 
    char *alternatePixmap;
    unsigned int pixmapLabel : 1;    /* if a pixmap */
    short num_buttons;
    struct axw_push_button **buttons;
} axw_popup;

typedef struct axw_icon {    /* an icon ie. a bitmap on the icon surface */
    AXW_HEAD
    AXW_WIN_HEAD
    int minWidth, minHeight;    /* for variable size windows */
    int maxWidth, maxHeight;    /* for variable size windows */
    int bg_color;
    Pixmap pixmap;
    Pixmap pix_mask;     /* we display the icon through this mask */
} axw_icon;

typedef struct axw_status { /* W_STATUS */
    AXW_HEAD
    AXW_WIN_HEAD
    char *permStatus;    /* permanent status message */  
} axw_status;

typedef struct axw_kanji { /* W_KANJI_STATUS */
    AXW_HEAD
    AXW_WIN_HEAD
    mbchar *kanjiStatusStr;    /* permanent status message */  
} axw_kanji;

typedef struct axw_kanji_kana { /* W_KANJI_KANA */
    AXW_HEAD
    AXW_WIN_HEAD
    wchar *wstr;
} axw_kanji_kana;

typedef struct axw_ge_ruler { /* W_GE_XRULER /W_GE_YRULER */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_ge_ruler;

typedef struct axw_toolbar {
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int pixmapLabel : 1;
    struct tool_bar_t *toolBarInfo;
} axw_toolbar;

typedef struct axw_menu {    /* W_MENUBAR menu */
    AXW_HEAD
    AXW_WIN_HEAD
    int menu_type;
    char *accel_str;        /* accelerator string for menu item */
    menu_item_def *popups;    /* for menu bar */          
    unsigned int noshow : 1,  /* whether menu item is displayed on menu bar */
                 unshared_menu_bar :1; /* menu bar frees on dlg free */
    char **menu_strs;
    char *menu_seps;
    menu_opt_status *menu_status;
    short *menu_starts;
    short num_buttons;
    struct axw_push_button **buttons;
    Window pulldown;
    Window cascade;
    short num_cascade_opts;
    short cascade_xpos;
    short cascade_ypos;
    short cascade_width;
    short cascade_height;
    short pulldown_xpos;
    short pulldown_ypos;
    short pulldown_width;
    short pulldown_height;
    short num_pulldown_opts;
#if AXMS
    HMENU menu_handle;
    HMENU submenu;
    char menu_key;          /* for MS Windows mnemonic */
#endif
} axw_menu;

/* struct for use with axw_combo_box and axw_entry_field */
struct edit_window {
  Window win;
  wchar *text;
  int text_len;
  seln_t sel;
  short num_clicks;
  int cursor_pos;        /* 0-indexed cursor position in text string */
  int string_offset;     /* offset of string relative to window */
  int edited;
  int cursor_on;
  int last_value;        /* remember w->value in case of XK_Escape */
  void *editmask;        /* when non-null, constrains input */
};

typedef struct axw_entry_field {    /* W_ENTER entry box */
    AXW_HEAD
    AXW_WIN_HEAD
    short curPos;    /* cursorpos for W_ENTER */
    short maxLen;
    wchar *wstr;     /* for W_ENTER (for W_MAIN, set-aside name) */
#if BUILD_WIDE
    mbchar *mb_string;
#endif
    char *validChars;    /* For W_ENTER only */ 
    unsigned int monospace_font : 1;
    short scrolltext;
    struct edit_window edit_win;
} axw_entry_field;

typedef struct axw_editbox {    /* W_EDITBOX edit box */
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int changed : 1,        /* 1: W_EDITBOX - TRUE if edited */
                 no_picks : 1,       /* 2: W_LIST, W_EDITBOX display only */
                 list_hscroll : 1,   /* 3: TRUE if lbox has horz scrollbar */
                 hide_vscroll : 1,   /* 4: FALSE if lbox has vert scrollbar */
                 monospace_font : 1, /* 5: use mono space font */
                 no_primary_seln : 1,/* 6: if set  does not grab seln.*/
                 deleteMarked : 1,   /* 7: */
                 primaryOnly : 1;    /* 8: paste XA_PRIMARY only */
    editbox_t *editbox;
    struct axw_scrollbar *hScrollBar;
    struct axw_scrollbar *vScrollBar;
    int scroll_per, scroll_max;
    short num_multi_clicks;
    short maxLen;
    int last_button_clicked;
} axw_editbox;

typedef struct axw_main { /* W_MAIN */
    AXW_HEAD
    AXW_WIN_HEAD
    wchar *wstr;              /* for W_ENTER (for W_MAIN, set-aside name) */
    short num_objs;           /* widgets within this dialog */
    int minWidth, minHeight;    /* for variable size windows */
    menu_opt_status *menu_status;        /* for W_MAIN */
    union axw_widget **objs;
    struct axw_toolbar   *toolBar;
    struct axw_buttonbar *butonBar;      /* for W_MAIN for GE */
    struct axw_page      *pageBar;       /* for GE */
    struct axw_ruler     *ruler;         /* for W_MAIN for DC */  
    struct axw_work      *workWindow;    /* for W_MAIN */
    struct axw_dialog    *dialog;        /* for W_MAIN, main area of dialogs */
    struct axw_status    *statusArea;    /* for W_MAIN */ 
    struct axw_kanji     *kanji_status;  /* for W_MAIN */ 
    struct axw_plates    *plates;
    struct axw_palette   *palette;
    struct axw_colorpal  *colorpal;      /* for W_MAIN for GE */
    struct axw_ge_ruler  *ge_xruler;     /* for W_MAIN for GE */
    struct axw_ge_ruler  *ge_yruler;     /* for W_MAIN for GE */
    struct axw_debug     *debug;         /* for W_MAIN for ME */  
    struct axw_any       *corner;        /* for W_MAIN for DC */ 
    struct axw_scrollbar *hScrollBar;    /* for W_MAIN */
    struct axw_scrollbar *vScrollBar;    /* for W_MAIN, W_LIST */
    struct axw_menu *menuBar;          /* menu bar structure */
    data_ptr menuCallback; /* for W_MAIN.if macro supplied a status callback */
    Pixmap iconPixmap;     /* setaside icon map, used by W_MAIN only */
    int window_uid;        /* Unique id (counter) for W_MAIN & W_DIALOG */ 
    int maxWidth, maxHeight;          /* for SS print preview! */
    unsigned int exposed : 1, 
                 variable_size : 1,   /* 1: for SS print preview! */
                 disable_record : 1,  /* 2: if TRUE, ELF recording disabled */  
                 topmostwindow : 1,   /* 3: */
#if BUILD_ORIENT
                 allow_wide_input : 1,
                 useOnSpot : 1,
                 inWideInput : 1,
#endif          
                 currently_mapped : 1;/* 4: */
#if BUILD_ORIENT
    XIC ic;
#if HP800
    XIM im;  /* HP hack - one input-method per window */
#endif
    mbchar *callback_data;  /* data passed as part of XIM callbacks */
    int conversion_start;
    int conversion_end;
    int conv_phrase_start;
    int conv_phrase_end;
    int conv_change_start;
    int conv_change_end;
#endif
#if AXMS
    HMENU menu_handle;          /* menu bar handle */
    HWND *dialogHWNDlist;    /* for keeping track of child dialogs. */
#endif
    struct axw_any *frame;
} axw_main;

typedef struct axw_dialog {    /* W_DIALOG dialog box */
    AXW_HEAD
    AXW_WIN_HEAD
    int icon;                  /* icon id to set-aside with */
    long *pokeCodes;           /* Elf array of acceptable pokes */
    short revstamp;            /* only for W_DIALOG */
    int window_uid;            /* Unique id (counter) for W_MAIN & W_DIALOG */ 
    unsigned int exposed         : 1, /* 1: */
                noExpand         : 1, /* 2: */
                no_record        : 1, /* 3: disallows recording */
                autoUnmanage     : 1, /* 4: */ 
                variable_size    : 1, /* 5: for variable sized dialog boxes */
                topmostwindow    : 1, /* 6: */
                currently_mapped : 1, /* 7: */
                list_hscroll     : 1, /* 8:TRUE if widget has horz scrollbar */
                hide_vscroll     : 1; /* 9:FALSE if widget has vert scrollbar*/
    int maxWidth, maxHeight;           /* for variable size windows */
    int minWidth, minHeight;   /* for variable size windows */
    int scroll_max;
    int hscroll_pos;
    struct axw_push_button *defaultButton;  /* program-specified,(permanent) */
    struct axw_push_button *cancelButton;
    struct axw_any *lastWidgetFocus; /* last widg to get kfoc via keystroke */
    struct axw_push_button *currentDefaultButton;  /* according to keyfocus */
    axhtab *uidWidgets;        /* widget's db_uid -> widget's AXWidget */
    struct axw_scrollbar *hScrollBar;
    struct axw_scrollbar *vScrollBar;
} axw_dialog;

typedef struct axw_any {    /* just a header */
    AXW_HEAD
    AXW_WIN_HEAD
} axw_any;

/* Opaque */
typedef struct dummy_info {
    int dummy;
} dummy_info;

typedef union {
    dummy_info *table;
    dummy_info *canvas;
    dummy_info *tray;
    dummy_info *color_chooser;
} widget_info_t;

typedef struct axw_table {          /* table widget */
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int list_hscroll: 1,   /* 1: TRUE if lbox has horz scrollbar */    
                 hide_vscroll: 1,   /* 2: FALSE if lbox has vert scrollbar */
                 variable_size : 1; /* 3: for variable sized dialog boxes */
    axw_scrollbar *hScrollBar;
    axw_scrollbar *vScrollBar;
    widget_info_t info;             /* Info on particular widget. */
    int last_item_selected;
    int armed;                      /* OpenLook stuff */
    char *validChars;
    int scroll_max;
    int hscroll_pos;
    short maxLen;
    char **strs;
} axw_table;

typedef struct axw_canvas {          /* canvas widget */
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int list_hscroll: 1,    /* 1: TRUE if widget has horz scrollbar */
                 hide_vscroll: 1;    /* 2: FALSE if widget has vert scrollbar */
    widget_info_t info;              /* Info on particular widget. */
    int last_item_selected;
    short maxLen;
    struct axw_scrollbar *hScrollBar;
    struct axw_scrollbar *vScrollBar;
    char **strs;
} axw_canvas;

typedef struct axw_tray {            /* tray widget */
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int list_hscroll: 1,    /* TRUE if widget has horz scrollbar */
                 hide_vscroll: 1;    /* FALSE if widget has vert scrollbar */
    widget_info_t info;              /* Info on particular widget. */
    int last_item_selected;
    short maxLen;
    struct axw_scrollbar *hScrollBar;
    struct axw_scrollbar *vScrollBar;
    char **strs;
} axw_tray;

typedef struct axw_color_chooser {
    AXW_HEAD
    AXW_WIN_HEAD
    unsigned int list_hscroll: 1,    /* TRUE if widget has horz scrollbar */
                 hide_vscroll: 1;    /* FALSE if widget has vert scrollbar */
    widget_info_t info;              /* Info on particular widget. */
    short maxLen;
    struct axw_scrollbar *hScrollBar;
    struct axw_scrollbar *vScrollBar;
} axw_color_chooser;

typedef struct axw_scale {
    AXW_HEAD
    AXW_WIN_HEAD
    int elevator_pos; 
    short armed;     
    unsigned int no_label : 1, /* 1: */
                  changed : 1; /* 2: TRUE if edited, */
    int minValue, maxValue;
} axw_scale;

typedef struct axw_combo_box {
    AXW_HEAD
    AXW_WIN_HEAD
    short maxLen;
    short num_buttons;
    short num_pulldown_opts;
    short pulldown_xpos;
    short pulldown_ypos;
    short pulldown_width;
    short pulldown_height;
    char **strs;
    Window pulldown;
    struct axw_scrollbar *hScrollBar;
    struct axw_scrollbar *vScrollBar;
    struct edit_window edit_win;
} axw_combo_box;


typedef struct axw_outline {
    AXW_HEAD
    AXW_WIN_HEAD
    short num_buttons;
    struct axw_push_button **buttons;
} axw_outline;

typedef union axw_widget {
    axw_main          mw;
    axw_push_button   pb;
    axw_toggle_button tb;
    axw_radio_box     rb;
    axw_list_box      lb;
    axw_label         tx;
    axw_dialog        db;
    axw_option_menu   om;
    axw_editbox       eb;
    axw_entry_field   ef;
    axw_menu          mn;
    axw_icon          icon;
    axw_rect          rect;
    axw_toolbar       toolbar;
    axw_ge_ruler      ge_ruler;
    axw_rowcol        rowcol;
    axw_ribbon        ribbon;
    axw_any           any;
    axw_table         table;
    axw_canvas        canvas;
    axw_tray          tray;
    axw_popup         popup;
    axw_status        status;
    axw_work          work;
    axw_palette       palette;
    axw_ruler         ruler;
    axw_corner        corner;
    axw_debug         debug;
    axw_colorpal      colorpal;
    axw_scale         scale;
    axw_plates        plates;
    axw_splitter      splitter;
    axw_color_chooser color_chooser;
    axw_page          pageBar;
    axw_buttonbar     butonBar;
    axw_combo_box     combo_box;
} axw_widget;


typedef axw_any    *AXWidget;
typedef axw_widget *AXWidget_handle;
typedef axw_dialog *AXWidget_dialog;
typedef axw_main   *AXWidget_main;

typedef axw_push_button     *AXWidget_pushbutton;
typedef axw_toggle_button   *AXWidget_togglebutton;
typedef axw_radio_box       *AXWidget_radio;
typedef axw_list_box        *AXWidget_list;
typedef axw_label           *AXWidget_label;
typedef axw_option_menu     *AXWidget_option;
typedef axw_entry_field     *AXWidget_entry;
typedef axw_menu            *AXWidget_menu;
typedef axw_any             *AXWidget_any;
typedef axw_icon            *AXWidget_icon;
typedef axw_rect            *AXWidget_rect;
typedef axw_toolbar         *AXWidget_tool;
typedef axw_scrollbar       *AXWidget_scroll;
typedef axw_ge_ruler        *AXWidget_ge_ruler;
typedef axw_rowcol          *AXWidget_rowcol;
typedef axw_ribbon          *AXWidget_ribbon;
typedef axw_popup           *AXWidget_popup;
typedef axw_status          *AXWidget_status;
typedef axw_kanji           *AXWidget_kanji;
typedef axw_table           *AXWidget_table;
typedef axw_canvas          *AXWidget_canvas;
typedef axw_tray            *AXWidget_tray;
typedef axw_work            *AXWidget_work;
typedef axw_palette         *AXWidget_palette;
typedef axw_ruler           *AXWidget_ruler;
typedef axw_corner          *AXWidget_corner;
typedef axw_debug           *AXWidget_debug;
typedef axw_colorpal        *AXWidget_colorpal;
typedef axw_scale           *AXWidget_scale;
typedef axw_plates          *AXWidget_plates;
typedef axw_splitter        *AXWidget_splitter;
typedef axw_editbox         *AXWidget_editbox;
typedef axw_color_chooser   *AXWidget_color_chooser;
typedef axw_page            *AXWidget_page;
typedef axw_buttonbar       *AXWidget_buttonbar;
typedef axw_combo_box       *AXWidget_combo_box;
typedef axw_kanji_kana      *AXWidget_kanji_kana;
typedef axw_outline         *AXWidget_outline;

typedef axw_widget widget_t;
#define AXWidget_struct axw_any

/* currently the widget pointer is used as the handle */

#define HANDLE_FROM_WIDGET( w ) (AXWidget_handle)w
#define WIDGET_FROM_HANDLE( w ) (AXWidget)w


AXWidget WidgetPointerFromHandleData();

/* link types for use in the HEAD linktab members
 */
#define WIDGLINK_TABLAYER 1   /* this type used for HEAD:tabctl_linktab */

/* FIXME, REMOVE WIDGLINK_KEYORDER (not used) */
#define WIDGLINK_KEYORDER 2   /* this type used for HEAD:keyfoc_linktab */

/* widglink_t is used in the HEAD member linktabs
 */
typedef struct widglink_t {
    int direction;
    AXWidget to;            /* widget pointed to by link */
    AXWidget from;
    int link_type;
    void *link_data;        /* type-specific data */
} widglink;

#endif   /*  _XWIDGETS_H  */
