/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: adlgpoke.h
   Applix ASC version: 85
   Date: Mon Nov 16 13:52:51 1998
*/
/* STRIP LINES THROUGH HERE */

/*

These are big numbers so users can use small numbers.

*/

#define POKE_MIN_APPLIX		9999	/* below this for customers */

#define POKE_EXIT			9999	/* Window manager exit directive */
#define POKE_DESTROY_ALL	10000	/* kill all child dialogs */
#define POKE_DELETE_FILE	10001	/* File deleted, update dir displays */
#define POKE_WRITE_FILE		10002	/* File created/written, update dir displays */
#define POKE_WIDGET         10003   /* general widget activity */
#define POKE_DEBUGGER       10004   /* Just for debugger panels */
#define POKE_MAPPED			10005   /* window was just mapped */

#define POKE_MENU_BAR		10021	/* New menu bar installed */
#define POKE_MENU_STATUS	10022   /* tell toolbar to query app for status */
#define POKE_DIALOG_RESIZED	10023   /* dialog has been resized */
#define POKE_DLG_KEYMACRO   10024   /* default-dlg-keys command occurred */

#define POKE_HDRFTRS		10051	/* hdr/ftr/margins have changed */
#define POKE_DIRDISP_NEWDIR	10052	/* tell dir displayer to look to new dir */
#define POKE_CLEAR_SELECTION 10053	/* window that held selection is told
									that another app now has the selection */
#define POKE_DOC_MODIFIED	10054	/* when a document has changed. */
#define POKE_TASK_EXIT		10055	/* when a task has exited. */
#define POKE_DUMMY_EVENT	10056	/* a resent event - check the data */
#define POKE_NEW_CURSOR	    10057   /* a new cursor has been added */


/* WP poke codes */
#define POKE_WP_DLGS			10101 	/* state of WP has changed */
#define POKE_WP_CURSOR			10102	/* WP cursor has moved */
#define POKE_WP_MARKS			10103	/* WP marks status has changed */
#define POKE_WP_BUTTON_UP		10104	/* mouse button released */
#define POKE_WP_EDIT			10105   /* edit has occurred */
#define POKE_WP_TAGS			10106   /* tag has moved or been added/deleted */
#define POKE_WP_GLOSSARY		10107   /* glossary has been created/deleted */
#define POKE_WP_STYLE			10108   /* style has been created/deleted */
#define POKE_WP_COLOR			10109	/* color modified/created/deleted */
#define POKE_WP_DICTS			10110	/* dictionary added/removed from usage */
#define POKE_WP_LANGUAGE		10111	/* new language specified for curr doc */
#define POKE_WP_HELP_JUMP		10112	/* Help-system hyperjump */
#define POKE_WP_GR_SRC_SIZE		10113	/* graphic source size changed */
#define POKE_WP_UNDO			10114	/* Undo has been accomplished */
#define POKE_WP_REDO			10115	/* Redo has been accomplished */
#define POKE_HELP_SEARCH_LIST	10116	/* search box info state should change */
#define POKE_WP_CHAR_ATTRS		10117	/* current character attrs changed */
#define POKE_WP_PARA_ATTRS		10118	/* current para attrs changed */
#define POKE_WP_TAB_ATTRS		10119	/* current tab attrs changed */
#define POKE_WP_FRAME_ATTRS		10120	/* current frame attrs changed */
#define POKE_WP_BORDER_ATTRS	10121	/* current border attrs changed */
#define POKE_WP_SECTION_TYPE	10122	/* current section type changed */
#define POKE_WP_COLUMNS			10123	/* current column attrs changed */
#define POKE_WP_PAGE_SETUP		10124	/* current page setup changed */
#define POKE_WP_HDR_FTR			10125	/* current hdr/ftr attrs changed */
#define POKE_WP_PAGE_NUMBERING	10126	/* current page numbering attrs changed */
#define POKE_WP_CURRENT_STYLE	10127	/* current style name changed */
#define POKE_WP_ZOOM			10128	/* zoom changed */
#define POKE_WP_SAVE			10129	/* file saved */
#define POKE_HELP_FREEZE_DOMAIN 10130   /* freeze domain at named domain */
#define POKE_WP_FILE			10131	/* File Revert, Open, or New */
#define POKE_WP_HYPER_TARGET	10132   /* Hypertarget has been created/del'd */
#define POKE_WP_DOC_VAR			10133   /* Doc Var has been created/deleted */
#define POKE_WP_XREF_SRC		10134   /* Xref Source has been created/del'd */
#define POKE_HELP_BOOK          10135   /* Need to update book contents box */
#define POKE_HELP_ADD_DOMAIN    10136   /* A new domain has been added */
#define POKE_HELP_RAISE_HISTORY 10137   /* History invoked and history exists */
#define POKE_HELP_RAISE_SEARCH  10138   /* Search invoked and search exists */
#define POKE_HELP_RAISE_CONTENT 10139   /* Contents invoked and already exist */
#define POKE_HELP_NEW_BOOK      10140   /* A new book was selected */
#define POKE_WP_FORM_MODE		10141   /* Enter or exit Form Mode */
#define POKE_HTML_URL			10142   /* A new URL was defined */
#define POKE_HTML_TARGET		10143   /* A new target (e.g. #section2) was defined */
#define POKE_HTML_GOTO_DOC		10144   /* Hyperlink or opened new HTML doc */
#define POKE_WP_INSET			10145	/* Inset was changed */
#define POKE_WP_LINK_HISTORY	10146	/* Hyperlink or opened HTML, WP, ME */

/* GE poke codes */
#define POKE_GE_SELECTION    10201  /* object(s) was marked */
#define POKE_GE_DESELECTION  10202  /* object(s) was unmarked */
#define POKE_GE_NO_TEXT      10203  /* no text objects are selected */
#define POKE_GE_ATTR_CHANGE  10204  /* an objects attributes have changed */
#define POKE_GE_CPARM_CHANGE 10205  /* the bg's data has changed */
#define POKE_GE_TOOL_CHANGE  10206  /* the tool has changed */
#define POKE_GE_PIX_SESS_END 10207  /* a pixed session has ended */
#define POKE_GE_PIX_COLOR    10208  /* pixed fg or bg color has changed */
#define POKE_GE_PIX_RESTART  10209  /* note that the pixed has restarted */
#define POKE_GE_BG_FORMAT    10210  /* the bg's graph type has changed */
#define POKE_GE_CMAP_CHANGE  10211  /* the colormap has changed */
#define POKE_GE_PARTS_CHANGE 10212  /* the user defined parts list changed */
#define POKE_GE_NEW_FILL     10213  /* a new fill pattern has been added */
#define POKE_GE_NEW_UNITS    10214  /* the unit of measure has changed */
#define POKE_GE_NEW_PAGE     10215  /* printable area or zero point changed */
#define POKE_GE_NEW_LINES    10216  /* palette line buttons have changed */
#define POKE_GE_IMAGE_CHANGE 10217  /* image type has changed */
#define POKE_GE_PIX_SESS_BGN 10218  /* a pixed session has begun */
#define POKE_GE_PAGE_EVENT   10219  /* the current page has changed */
#define POKE_GE_RESTART      10220  /* note that the ge has done a revert */
#define POKE_GE_NEW_PRNT_PG  10221  /* note that print page got changed */
#define POKE_GE_SLIDE_OPTION 10222  /* note that slide option got changed */
#define POKE_GE_MOUSE_DOWN   10223  /* note a mouse down */
#define POKE_GE_SPELL_END    10224  /* note spell check  end */
#define POKE_GE_SLIDE_MODE   10225  /* note a change in slide mode */
#define POKE_GE_CHANGE_PALET 10226  /* note a change in palet */
#define POKE_GE_CLIPART      10227  /* repost clipart dlg */
#define POKE_GE_DEL_NSLIDE   10228  /* note del of slide in notes editor */
#define POKE_GE_DEL_NTEXT    10229  /* del of txt placeholder in notes editor */
#define POKE_GE_ZOOM		 10230	/* zoom changed */

/* BG poke codes */
#define POKE_BG_NEW_CHART    10250  /* chart was added or deleted */
#define POKE_BG_CHART_TYPE   10251  /* chart type was changed */
#define POKE_BG_CHART_CHANGE 10252  /* chart was changed (generic) */
#define POKE_BG_CHART_LAYOUT 10253  /* chart layout changed (vert<==>horz) */
#define POKE_BG_CHART_3D     10254  /* chart 3D effect changed */
#define POKE_BG_NEW_AXIS     10255  /* chart axis was added/deleted */
#define POKE_BG_AXIS_CHANGE  10256  /* chart axis was changed */
#define POKE_BG_AXIS1_CHANGE 10257  /* chart axis line was changed */
#define POKE_BG_AXIS2_CHANGE 10258  /* chart axis label was changed */
#define POKE_BG_NEW_GRP      10259  /* chart group was added/deleted */
#define POKE_BG_GRP_CHANGE   10260  /* chart group was changed */

/* SS poke codes */
#define POKE_SS_MARKS		 10301 	/* user has selected new cell/range */
#define POKE_SS_ROWCOL		 10302 	/* user has selected new row/col */
#define POKE_SS_COLS		 10303	/* user has selected new columns */
#define POKE_SS_EDIT		 10304	/* EditMode change ON/OFF */
#define POKE_SS_ROWS		 10305	/* user has selected new rows */
#define POKE_SS_RESTART		 10306	/* File open has been selected */
#define POKE_SS_CHART_CHANGE 10307	/* chart selection changed */
#define POKE_SS_NAME_CHANGE	 10308	/* name has changed or deleted or added */
#define POKE_SS_VIEW_CHANGE	 10309	/* view has changed, deleted or added */
#define POKE_SS_DB_CHANGE	 10310	/* db entity has changed,delted or added */
#define POKE_SS_COL_WIDTH	 10311	/* col width has changed */
#define POKE_SS_ROW_HEIGHT	 10312   /* row height has changed */
#define POKE_SS_GROBJ_CHANGE 10313	/* the graphic object selection changed */
#define POKE_SS_FUNC_OVERWRITE 10314 /* a bltin functions has been overwritten*/
#define POKE_SS_PREVIEW_RESTART 10315 /* ss print preview restart ***/
#define POKE_SS_EXPLINE_UPDATE 10316 /* ss poke to update express line */
#define POKE_SS_REVERT        10317 /* ss poke for revert */
#define POKE_SS_FUNCS_CHANGE      10318 /* ss poke add/remove functions */
#define POKE_SS_SELECTION_CHANGE      10319 /* ss selection change poke */
#define POKE_SS_CHART_UPDATE      10320 /* poke for updating the given chart*/
#define POKE_SS_SAVE_AS      10321 /* occurs only during save as */


/* Mail poke codes */
/*
 * New poke codes added for Spool (Mail) server by Rob.
 */
#define POKE_SP_NEW_MAIL        10400   /* new mail has arrived */
#define POKE_SP_USR_CHANGE		10401	/* a user has been added/deleted */
#define POKE_SP_PREF_CHANGE		10402	/* Mail preferences have changed */
#define POKE_SP_MSG_CHANGE		10403	/* next/prev from Read Mail dbox */
#define POKE_SP_MSG_UPDATE		10404	/* new info available for Read Mail */
#define POKE_OB_MSG_UPDATE		10405	/* new info available for Read Obox */
#define POKE_OB_MSG_CHANGE		10406	/* next/prev from Read Outbox dbox */
#define POKE_OB_NEW_OBOX		10407	/* new outbox item available */
#define POKE_SP_SIGUSR2_TERM	10408	/* signal to terminate sigusr2 */
#define POKE_SP_NOTIFY_OPT      10409   /* new mail notifier response */
#define POKE_SP_FLDR_CHANGE     10410   /* new/renamed/deleted mail folder */
#define POKE_SP_NEW_MARK        10411   /* inbox selection has changed */
#define POKE_SP_MOVE_FILE       10412   /* inbox item has just changed loc */
#define POKE_SP_SYNCH_FLDR		10413	/* current folder contents changed */
#define POKE_SP_COPY_MESSAGE    10414   /* poke from copy_message to inbox */
#define POKE_SP_NEW_RECIP       10415   /* new recipient selection */
#define POKE_SP_DELETE_MESSAGE	10416	/* poke from delete_message to inbox */
#define POKE_SP_TAG_MESSAGE		10417   /* poke from tag_message to inbox */
#define POKE_SP_HOWDY_ROB		10418   /** this poke available for use **/
#define POKE_SP_SELECT_ALL		10419	/* request to select all messages */
#define POKE_SP_FLDR_MARK		10420	/* folder selection in Inbox */
#define POKE_SP_SHOW_NUMBERS	10421	/* display Inbox message numbers */
#define POKE_SP_SHOW_SHARED		10422	/* display shared folders in Inbox */
#define POKE_SP_ADD_INFO		10423	/* add info to a sender dialog */
#define POKE_SP_CHANGE_FOLDER	10424	/* change current Inbox folder */
#define POKE_SP_EDIT_COMMENT	10425	/* change message comment */
#define POKE_SP_FORWRD_MESSAGE	10426	/* forward selected message */
#define POKE_SP_COLOR_MESSAGE	10427	/* color selected message */
#define POKE_SP_ENCRYPT_MESSAGE	10428	/* encrypt selected message */
#define POKE_SP_SELECTION_INFO	10429	/* speller selection poke */
#define POKE_SP_REPLACE_TXT		10430	/* speller replace text poke */
#define POKE_SP_UPDATE_INFO		10431	/* speller request for new info */
#define POKE_SP_SELECT_MESSAGE	10432	/* poke to Inbox to select msg(s) */
#define POKE_SP_GET_SELECTIONS	10433	/* synch request to Inbox for sels */
#define POKE_SP_SYNCH_SHARED	10434	/* synch a (remote) shared folder */
#define POKE_SP_SIGN_MESSAGE	10435	/* current message was just signed */
#define POKE_SP_GET_ATTSELS		10436	/* synch rqst to Inbox for att sels */
#define POKE_SP_SEND_INFO		10437   /* request for save mail context  */
#define POKE_SP_MAIL_SORT		10438   /* change sort order in inbox */
#define POKE_SP_SENT_MAIL		10439   /* hit ok/apply in sendmail dlg */
#define POKE_SP_CANCEL_MAIL		10440   /* hit cancel in sendmail dlg */

#define POKE_BB_SERVER_INFO		10450	/* shared folder status message */

/* OpenMail pokes */
#define POKE_SP_STATUS_MSG		10460	/* update status message in OM Inbox */
#define POKE_SP_NEW_XMSG		10461	/* arrival of new OpenMail message */
#define POKE_OM_CONFIG_DIR		10462	/* user directory configuration */
#define POKE_OM_RECIP_PICK		10463	/* selection from recipient list */
#define POKE_OM_ALT_PICK		10464	/* selection from Directory alts*/
#define POKE_OM_TARGET_SEL		10465	/* selection from folder targets */
#define POKE_OM_COPY_MSG		10466	/* copy request */
#define POKE_OM_MOVE_MSG		10467	/* move request */
#define POKE_OM_NEW_FLDRSEL	10468 /* new folder selected in inbox */
#define POKE_OM_INB_SORT		10469 /* change sort order in inbox */
#define POKE_OM_NEW_SELS		10470 /* set selected item(s) in inbox */
#define POKE_OM_GET_SELS		10471 /* get currently selected item(s) in inbox */
#define POKE_OM_REPL_RECIP		10472 /* replace recip in sendmail dlg  */
#define POKE_OM_USR_CHANGE		10473 /* openmail list changed */
#define POKE_OM_TOGGLE_STATE	10474 /* change state of view option */
#define POKE_OM_MSG_ACTION		10475 /* perform an action on selected inbox item*/
#define POKE_OM_FLDR_ACTION	10476 /* perform action on selected folder */
#define POKE_OM_USR_CONFIG		10477 /* openmail pref changed */
#define POKE_OM_DIR_CHANGE		10478 /* openmail directory changed */
#define POKE_OM_SEND_OPTS		10479 /* open selected attachment */
#define POKE_OM_LIST_STAT		10480 /* user list value change */

/* Dialog Editor */
#define POKE_DE_MESSAGE			10500	/* mid-session message */
#define POKE_DE_SESSION			10501	/* start session, stop session, .. */

/* Licensing */
#define POKE_AXNLM_MESSAGE              10600   /* use non-pending information box */

/* Data Dipper... uses codes 11000 to 11500 ... see dbase_.am */

/* Applix Builder uses codes 12000 to 12100 */

/* filters - use codes from 12101 to 12200 */
#define POKE_FLT_BASE           12100
#define POKE_FLT1               12101
#define POKE_FLT2               12102
#define POKE_FLT3               12103
#define POKE_FLT4               12104
#define POKE_FLT5               12105
#define POKE_FLT6               12106
#define POKE_FLT7               12107
#define POKE_FLT8               12108
#define POKE_FLT9               12109
#define POKE_FLT10              12110
#define POKE_FLT_MAX            12110

#define POKE_OBJECT_THROW		14999	/* event sent to object */
/*
 * Pokes below 15000 are for ELF-ELF communications.
 * If a dialog is up, the suspend the dialog as a "poke_".
 * Otherwise, they are readable using GET_MESSAGE@.
 */
#define POKE_MAX_MESSAGE		15000
