/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: afile.h
   Applix ASC version: 23
   Date: Thu Mar  4 21:13:38 1999
*/
#ifndef AFILE_H_INCLUDED
#define AFILE_H_INCLUDED

#if AX_NT
#include <fcntl.h>
#ifndef F_OK
#define	F_OK		0	/* does file exist */
#endif
#ifndef X_OK
#define	X_OK		1	/* is it executable by caller */
#endif
#ifndef W_OK
#define	W_OK		2	/* writable by caller */
#endif
#ifndef R_OK
#define	R_OK		4	/* readable by caller */
#endif

#else	/* !AXMS */

#if SUN4 | SUN3 | HP300 | HP800 | SGI | AUX | NEC_EWS
#if AUX
#include <sys/types.h>
#endif
#include <sys/file.h>
#else
#include <fcntl.h>
#endif

#if (SYS&(B4_2|VMSSYS))
#include <sys/file.h>
#else
#if !USL54
#include <fcntl.h>
#endif
#endif

#ifndef O_NDELAY
#include <fcntl.h>
#endif


#if SYSV4 || LINUX
#include <unistd.h>
#endif

#if AVIION
#include <sys/file.h>
#endif
#if SCOUNIX || M_88K && !AVIION
#include <sys/unistd.h>
#endif

#if RIOS
#include <sys/access.h>
#endif

#if !RIOS
/* The following definitions do not exist on SYS 5 or VMS */
#if SYS&(SYS5|VMSSYS) & !NEC_EWS
#define	F_OK		0	/* does file exist */
#define	X_OK		1	/* is it executable by caller */
#define	W_OK		2	/* writable by caller */
#define	R_OK		4	/* readable by caller */
#endif
#endif

#ifndef O_BINARY
#define O_BINARY 0
#endif

#endif	/* !AX_NT */


/* Asterx File Reader/Writer Parameters */
#define AREADBUFSIZE 4090  /* Maximum line length, for read */
#define ALINELENGTH 80		/* Suggested maximum line length, for write. */

/* Start of line tokens for standard lines in asterx files */
#define ATOK_ASTERIX NXLT("*") /* all standard lines start with this */
#define ATOK_START NXLT("*BEGIN") /* start of data */
#define ATOK_OLDSTART NXLT("*START") /* old start of data */
#define ATOK_END NXLT("*END")	/* end of data */
#define ATOK_LINK NXLT("*LINK")	/* external reference */
#define ATOK_HOOK NXLT("*HOOK") /* associated macros */
#define ATOK_SEPARATORS NXLT(" \t\n") /* token separators */

/* info for the Asterx Standard File Header  *BEGIN ... */
typedef struct {
    int encoding;    /* TRUE iff file is encoded */
    int version;     /* current version number */
	int old_version; /* original version number */
	int min_version; /* min version (expiration date) */
	int docType;     /* see pgms/axelf/doctypes.h */
	char *content;   /* hint, valid until another call to AFileInfoFromHeader */
	int encrypted;
} AFileInfo;

#ifdef aosHinclude
typeErr AFileInfoFromHeader();
#endif
                                                 
#endif    /* end of AFILE_H_INCLUDED */

