/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: afileimg.h
   Applix ASC version: 3
   Date: Sat Jan 23 21:14:17 1999
*/

/* fileimage.h - image file header & macros */

typedef struct {
	int compression;	/* compression used here */
	int width;		/* width in pixels */
	int height;		/* height in pixels */
	int depth;		/* depth in planes */
} imageInfo;

typedef struct {
	char version;		/* header version */
	char compression;	/* compression used here */
	char offdata[2];	/* image data offset from start of file */
	char width[2];		/* hi-lo width in pixels */
	char height[2];		/* hi-lo height in pixels */
	char depth;		/* depth in planes */
	char maptype;		/* color map format */
	char maplength[2];	/* length of colormap */
	char filler[4];		/* unused filler */
} imageHeader;

typedef struct imagefile {
	FILE *filep;
	char mode;
	char compression;
	unsigned int byte_width;
} IFILE;

/* encodings */
#define VERSION_1	1
#define COMP_RAW	1
#define COMP_RUN	2
#define COMP_LZW	3
#define CMAP_NONE	1

/* for image.c */
#define IM_READ		1
#define IM_WRITE	2
#define BYTE_WIDTH(w)	((((w) + 15) >> 3) & ~1)
#define GET_VALUE(v)	(v[0] << 8) + (v[1] & 0xFF)
#define SET_VALUE(v,n)	{ v[0] = (n) >> 8; v[1] = (n) & 0xFF; }

#if THIMBLE
IFILE *openImage();
#define openi I should not be able ; to compile
#else
IFILE *openi();
#endif

