/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: akeys.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:52:53 1998
*/
#define TM_INS_MODE		1
#define TM_OSTRIKE_MODE		2
#define TM_DC_FORWARD		3
#define TM_DC_BACKWARD		4
#define TM_DW_FORWARD		5
#define TM_DW_BACKWARD		6
#define TM_D_EOL		7
#define TM_D_BEG_OF_LINE	8
#define TM_MC_FORWARD		9
#define TM_MC_BACKWARD		10
#define TM_MW_FORWARD		11
#define TM_MW_BACKWARD		12
#define TM_M_EOL		13
#define TM_M_BEG_OF_LINE	14
#define TM_INS_BLANK		15		/* insert space character */
#define LK_SELECTLINE		16
#define LK_MODE_TOGGLE		17

/* new symbols for local action logical keys - to replace old */

#define LK_INS_MODE 	TM_INS_MODE	
#define LK_OSTRIKE_MODE TM_OSTRIKE_MODE	
#define LK_DC_FORWARD	TM_DC_FORWARD	
#define LK_DC_BACKWARD	TM_DC_BACKWARD	
#define LK_DW_FORWARD	TM_DW_FORWARD	
#define LK_DW_BACKWARD	TM_DW_BACKWARD	
#define LK_D_EOL	TM_D_EOL	
#define LK_D_BEG_OF_LINE TM_D_BEG_OF_LINE
#define LK_MC_FORWARD	TM_MC_FORWARD	
#define LK_MC_BACKWARD	TM_MC_BACKWARD	
#define LK_MW_FORWARD	TM_MW_FORWARD	
#define LK_MW_BACKWARD	TM_MW_BACKWARD	
#define LK_M_EOL	TM_M_EOL	
#define LK_M_BEG_OF_LINE TM_M_BEG_OF_LINE
#define LK_INS_BLANK	TM_INS_BLANK	

/* LKs always reported to the application */

#define LK_REGEN	32
#define LK_HELP		33
#define LK_PICK		34		/* nonmouse pick */
#define LK_CLOSE	35		/* close (icon or key sequence) */
#define LK_UP_SCREEN	36
#define LK_DN_SCREEN	37
#define LK_RT_SCREEN	38
#define LK_LF_SCREEN	39
#define LK_FULL_SCREEN	40
#define LK_SHRINK_SCREEN 41
#define LK_FRAME	42
#define LK_ESCAPE	43
#define LK_EXECUTE	44
#define LK_TAB		45
#define LK_TAB_BACK	46
#define LK_RETURN	47
#define LK_UP_CURSOR	48
#define LK_DN_CURSOR	49
#define LK_UP_UNIT	50
#define LK_DN_UNIT	51
#define LK_LF_UNIT	52
#define LK_RT_UNIT	53
#define LK_THUMB	54
#define LK_MARK		55
#define LK_INDEX	56
#define LK_COMMAND	57
#define LK_OP_CLOSE	58	/* nonmouse open (formerly open/close) */
#define LK_BK_RETURN    59
#define LK_GB_RETURN	60
#define LK_GB_MARK	61
#define LK_HOME		62			/* NOT "home line" */
#define LK_HOME_DOWN	63
#define LK_GB_MENU	64
#define LK_GF_RETURN	65
#define LK_GF_MARK	66
#define LK_GF_MENU	67
#define LK_DELETE	68
#define LK_MOVE		69
#define LK_COPY		70
#define LK_INSERT	71			/* now called "paste" */
#define LK_SMALLER	72
#define LK_LARGER	73
#define LK_INS_FIELD_DEF 74
#define LK_INS_ALIGNMENT 75		/* "insert column" */
#define LK_INDENT        76
#define LK_CHOICES       77		/* "home line" key */
#define LK_GF_CHOICES    78
#define LK_GB_CHOICES    79
#define LK_CENTER	80
#define LK_REDO		81
#define LK_UNDO		82
#define LK_CALC		83
#define LK_ANNOTATE	84
#define LK_F_REDO	85			/* goto forward redo */
#define LK_BOLD		86
#define LK_UNDERLINE	87
#define LK_RESUME	88
#define LK_GO_CENTER	89
#define LK_NX_HEAD		90
#define LK_PV_HEAD		91
#define LK_GRAPH		92
#define LK_INS_LINE		93		/* insert blank line */
#define LK_B_REDO		94		/* goto backward redo */
#define LK_F_UNDO		95		/* goto forward undo */
#define LK_B_UNDO		96		/* goto backward undo */
#define LK_NX_WIN		97		/* activate next window */
#define LK_PV_WIN		98		/* activate previous window */
#define LK_MENU_REQ		99		/* menu request key */
#define LK_G_REGEN		100		/* graphics regeneration request */
/*
 * LK_WINDOW dropped in favor of LK_W_MOVE, _EDIT, ... below.
 */
#define LK_WINDOW		101		/* Window mode key 	*/
#define LK_BOUND		102		/* Window frame key 	*/
#define LK_REDISPLAY	103		/* redisplay screen */
#define LK_MENULESS		104		/* enter prompt mode */
#define LK_NOMENULESS	105		/* exit prompt mode */
#define LK_F_GOTO		106		/* forward goto */
#define LK_B_GOTO		107		/* backward goto */
/*
 * following should replace goto graphic base and max keys
 */
#define LK_GF_GRAPHIC	108
#define LK_GB_GRAPHIC	109
#define LK_GGF_GRAPHIC	110
#define LK_GGB_GRAPHIC	111

#define LK_QA			112		/* QA script command */
#define LK_SMALLEST		113		/* change menu to smallest size */
#define LK_NORMSIZE		114		/* change menu to normal size */
#define LK_ELFMSG		115		/* next IPC contains an ELF message */
#define LK_PALETTE		116		/* sent only to GE */
#define LK_CLEARMARKS	117		/* sent to selection holder */
#define LK_CLEARBINS	118		/* sent to clipboard holder */

#define LK_IGNORE		127		/* discard within ATM */

/* Selection Line LKs */

#define LK_INTERRUPT   128
#define LK_OPTION_BASE 128		/* obsolete symbol */
#define LK_SELBASE		LK_OPTION_BASE	/* new symbol; phase in */
#define LK_SELMAX		198

#define LK_UNDEF	   199		/* undefined key sequence;
								NOTE: immediately follows LK_SELMAX */

#define LK_HOMEBASE	400				/* home line base */
#define LK_HOMEMAX	499				/* home line maximum code */

#define LK_GF_GRAF_BASE 500		/* go forward graphic base code */
#define LK_GF_GRAF_MAX	(500+255)
#define LK_GB_GRAF_BASE 800		/* go backward graphic base code */
#define LK_GB_GRAF_MAX	(800+255)
/*
 * base for composed character codes in Applix standard character set
 * (8-bit values defined in all fonts based on this character set)
 */
#define LK_CODEBASE		1100
/*
 * base values for composed codes in symbol fonts
 *
 * LK value = LK_CODEBASE + <code page> * 256 + <code>
 *
 * "code page" ("semantic font") is a set of 256 character codes and
 * their meanings; a total of 6 code pages (including 0) provides for
 * 1536 distinct meanings
 */
#define LK_SYM1_BASE	(LK_CODEBASE + 1*256)
#define LK_SYM2_BASE	(LK_CODEBASE + 2*256)
#define LK_SYM3_BASE	(LK_CODEBASE + 3*256)
#define LK_SYM4_BASE	(LK_CODEBASE + 4*256)
#define LK_SYM5_BASE	(LK_CODEBASE + 5*256)

#define LK_CODEMAX		(LK_SYM5_BASE + 255)

/*
 * These 'two' are similar to LK_[GF]B_GRAF_BASE above,
 * but are intended for DC multiple char pattern search.
 */
#define	LK_GGB_GRAF_BASE	2700
#define	LK_GGB_GRAF_MAX		(LK_GGB_GRAF_BASE + 255)
#define	LK_GGF_GRAF_BASE	3000
#define	LK_GGF_GRAF_MAX		(LK_GGF_GRAF_BASE + 255)

/*
 * Further goto LKs
 */
#define	LK_GOBEG_ABS		3300	/* go to beg of doc or display */
#define	LK_GOEND_ABS		3301	/* go to end of doc or display */
#define	LK_GOLFT_ABS		3302	/* go to left edge of doc or display */
#define	LK_GORHT_ABS		3303	/* go to right edge of doc or display */

#define	LK_GOHELP		3304	/* give help on the goto options */

#define	LK_GOPRV_PG		3305	/* in DC: go to previous page */
#define	LK_GONXT_PG		3306	/* in DC: go to next page */

#define	LK_GORULER		3307	/* in DC: go to ruler */
#define	LK_GOFIELD		3308	/* in DC: go to field border edit. */

#define	LK_GF_RMARKER		3309	/* in DC: go to next region marker */
#define	LK_GB_RMARKER		3310	/* in DC: go to prev region marker */

#define	LK_GF_INSET		3311	/* in DC: go to next inset */
#define	LK_GB_INSET		3312	/* in DC: go to prev inset */

#define	LK_GGF_RETURN		3313	/* in DC: go to next whole instance */
#define	LK_GGB_RETURN		3314	/* in DC: go to prev whole instance */

#define	LK_DESK_STATUS		3315	/* display desktop status menu */
#define	LK_BIG_ESCAPE		3316	/* anywhere in Filing: -> Main Menu */

#define	LK_MOUSE_ON		3317	/* turn on dumb terminal mouse */

#define	LK_W_MOVE		3318	/* enable window move mode. */
#define	LK_W_FRAME		3319	/* enable window edit mode. */
#define	LK_W_FULL		3320	/* full (.vt) the current window */
#define	LK_W_SHRINK		3321	/* shrink the current window */

#define	LK_SETASIDE		3322	/* set aside the window */

#define LK_LEFT_EXTEND	3400
#define LK_RIGHT_EXTEND	3401
#define LK_UP_EXTEND	3402
#define LK_DOWN_EXTEND	3403

