/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: amenudef.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:52:54 1998
*/
#ifndef AMENUDEF_INCLUDED
#define AMENUDEF_INCLUDED 1

/* Structure that describes a given item on a given selctionline or popup */

#define ITEM_MENU 0
#define ITEM_FUNC 1
#define ITEM_LINE 2
#define ITEM_MARK 3

typedef struct {
	char *word;		/* the word(s) to display in the popup */
	char *word2;	/* used for ITEM_MENU & ITEM_ELFC */
	char *toolword;	/* mnemonic for toolbar display */
	char *bitmap;	/* bitmap name for toolbar */
	unsigned int accel_key;	/* value of X keysym used to drive this function */
	unsigned int type : 2,	/* of ITEM_XXX above */
				 ender : 1,	/* TRUE if last item in menu */
				 noshow : 1, /* if TRUE, item hidden from menubar */
				 toolshow : 1,	/* if TRUE, item displayed in toolbar */
				 accel_modifiers : 5;
	unsigned char *menu_key_str;  /* keyboard mnemonic for op of pulldown */
                              /* only the first char of the string is used */
    unsigned char tooltype;   /* type of button for display in toolbar */
} menu_item_def;

/* Display types for buttons in toolbar */
#define TOOLTYPE_NAME 0		/* use menubar name */
#define TOOLTYPE_BITMAP 1	/* use bitmap */
#define TOOLTYPE_TOOLWORD 2	/* use mnemonic */

/* The accel key is 18 bits because DEC uses the msb (32nd bit) sometimes.
	Since DEC never uses the 17-31 bits, the 32nd DEC bit becomes the
	18th accel bit.  Likewise, here is some paranoia for a vendor that
	decides to use the 17th bit. */

/* structure that defines access for selection info for each window type */

typedef struct selects_desc {
	struct selects_desc *next;
	int wintype;			/* the icon id */
	char *name;				/* logical name of window type */
	menu_item_def *selections;	/* the master slider */
    char menubar_file[10];      /* name of file for this menubar */
} selects_desc;

#define MENUSTAT_INACTIVE 1		/* display grayed */
#define MENUSTAT_TOGGLE_ON 2	/* toggle on to left */
#define MENUSTAT_TOGGLE_OFF 3	/* is a toggle, but off now */
#define MENUSTAT_RADIO_OFF 4	/* is a radio, currently off */
#define MENUSTAT_RADIO_ON 5		/* radio on to left */
#define MENUSTAT_NO_SHOW 6		/* suppress display altogether */
#define MENUSTAT_KEYONLY 7		/* don't display but allow access */

extern selects_desc *ElfWinSelections;

#endif   /* AMENUDEF_INCLUDED */
