/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ashell.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:52:52 1998
*/
#define SHC_RETCODE 1	/* fork, execute, return status */
#define SHC_FORK 2		/* unpended for & execute */
#define SHC_RETSYS 3	/* pended call to system() */
#define SHC_SYSTEM 4	/* unpended call to system() */
#define SHC_PROC 5	/* unpendeded exec rtns code, has input/output redirect */
#define SHC_FORK_RET 6  /* unpended for & execute, returning child pid */
#define SHC_EXIT 7	/* exit */

/* SHC_PROCIN is still pended... I haven't gotten around to this yet */

#define MAX_SHELL_CMD (unsigned)4000

typedef struct {
	char progname[MAX_SHELL_CMD+1];	/* command line to exec */
	char file_stdin[STRPATH+1];	/* if "", use dev/null */
	char file_stdout[STRPATH+1];	/* if "", use dev/null */
	char file_stderr[STRPATH+1];	/* if "", file_stdout */
} exec_request;

#define CMD_TOO_LONG 126	/* error return on command line too long */

