/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: atmreg.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:52:52 1998
*/
#define TM_RDEF_MAX	22	/* max # regions per TmDreg call */
#define TM_RMOD_MAX	22	/* max # regions per TmMreg call */

/* region definition packet */

struct TmRegPacket
{
	short r_id;
	struct 
	{
		unsigned dummy		: 2;
		unsigned pick		: 2;
		unsigned open		: 2;
		unsigned pickstate	: 2;
		unsigned openstate	: 2;
	} action;
	short x_position;
	short y_position;
	short x_size;
	short y_size;
	long help_id;
};

/* flag definitions */

/* action.pick, action.open */

#define TM_DISABLE 	0
#define TM_ENABLE	1
#define TM_HIGHLIGHT	2
#define TM_HIGH_UNHIGH	3

/* action.pickstate, action.openstate */

#ifndef TM_NO_CHANGE		/* also defined in atmtextin.h, atmwin.h */
#define TM_NO_CHANGE	0
#endif
#define TM_INACTIVE	1
#define TM_ACTIVE	2

/* region modify packet */

struct TmRegMPacket
{
	short r_id;
	struct 
	{
		unsigned dummy		: 2;
		unsigned pick		: 2;
		unsigned open		: 2;
		unsigned pickstate	: 2;
		unsigned openstate	: 2;
	} action;
};

/* calls */

#if 1
typeErr TmDreg();
typeErr TmMreg();
typeErr TmRclose();
typeErr TmARclose();
#endif

/* SYNOPSIS */

#if 0				/* documentation only */
************************************************

short TmDreg(window_id,r_def_num,r_def_ptr)
short window_id;
short r_def_num;
struct TmRegPacket *r_def_ptr;

 return status

 TMR_OK
 TMR_OWN
 TMR_NOACT
 TMR_RNUM

*************************************************

short TmMreg(window_id,r_mod_num,r_mod_ptr)
short window_id;
short r_mod_num;
struct TmRegMPacket *r_mod_ptr;

 return status

 TMR_OK
 TMR_OWN
 TMR_NOACT

*************************************************

short TmRclose(window_id,r_id)
short window_id;
short r_id;

 return status

 TMR_OK
 TMR_OWN

*************************************************

short TmARclose(window_id)
short window_id;

 return status

 TMR_OK
 TMR_OWN

************************************************
#endif
