/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axshlib.h
   Applix ASC version: 17
   Date: Thu Jun  3 21:16:23 1999
*/
#ifndef _SHLIB_INCL
#define _SHLIB_INCL

#define WPPROTO_INCL
#define ASPELLER_PROTO_INCL
#define WPFUNC_INCL
#undef THIM_STATIC
#define THIM_STATIC 0

#ifndef AXSHLIB_DEFINES_ONLY		/* { */

#include <stdio.h>
#include <math.h>
#include <varargs.h>
#include <stdlib.h>
#include <aos.h>
#include <thimble.h>
#include <afile.h>
#if AXMS
#if AX_DLL
#include <elapi.h>
#else
#include <eldata.h>
#endif
#else
#include <eldata.h>
#include <elapi.h>
#endif
#include <n_style.h>
#include <atm.h>
#include <ax_inset.h>
#include <axtext.h>
#include <axbitmap.h>
#include <atxint.h>
#include <doclinks.h>
#undef MEMCPY
#undef MEMSET
#include <global.h>
#include <boom.h>
#include <aspeller.h>

#ifndef NO_SS_INCL
#include <ss.h>
#define boolean axbool
#include <finance.h>
#endif

#undef VERIFY
#include <wp.h>
#undef ASSERT
#include <ge.h>
#include <cvt.h>
#include <bg.h>
#undef malloc
#undef calloc
#undef realloc
#undef free

#include <bldrextint.hh>

#endif								/* } */

#define LIBNAME_GE    "libaxge"
#define LIBNAME_WP    "libaxwp"
#define LIBNAME_SS    "libaxss"
#define LIBNAME_DB    "libaxdb"
#define LIBNAME_EL    "libaxel"
#define LIBNAME_OM    "libaxom"
#define LIBNAME_MAIL  "libaxmail"
#define LIBNAME_CORBA "libaxcorba"
#define LIBNAME_TM1   "libaxtm1"
#define LIBNAME_PROX  "libspell"
#define LIBNAME_MC    "libaxmc"
#if AXMS
#define LIBNAME_RT    "axrt"
#else
#define LIBNAME_RT    "libaxrt"
#endif
#if AXMS
#define LIBNAME_LM   "axlm"
#else
#define LIBNAME_LM   "libaxlm"
#endif



#if AXMS
#define SHLIB_EXT ".dll"
#elif HP800
#define SHLIB_EXT ".sl"
#else
#define SHLIB_EXT ".so"
#endif

/* define the libname's with extension */
#define AXSHLIB_GE    LIBNAME_GE    SHLIB_EXT
#define AXSHLIB_WP    LIBNAME_WP    SHLIB_EXT
#define AXSHLIB_SS    LIBNAME_SS    SHLIB_EXT
#define AXSHLIB_DB    LIBNAME_DB    SHLIB_EXT
#define AXSHLIB_EL    LIBNAME_EL    SHLIB_EXT
#define AXSHLIB_OM    LIBNAME_OM    SHLIB_EXT
#define AXSHLIB_MAIL  LIBNAME_MAIL  SHLIB_EXT
#define AXSHLIB_CORBA LIBNAME_CORBA SHLIB_EXT
#define AXSHLIB_TM1   LIBNAME_TM1 	SHLIB_EXT
#define AXSHLIB_PROX  LIBNAME_PROX 	SHLIB_EXT
#define AXSHLIB_MC    LIBNAME_MC 	SHLIB_EXT
#define AXSHLIB_RT    LIBNAME_RT 	SHLIB_EXT
#define AXSHLIB_LM    LIBNAME_LM   SHLIB_EXT


#define LIBID_RESERVED 1 /* used for dynamic_loaded user Elf packages */
#define LIBID_EL    2
#define LIBID_GE    3
#define LIBID_WP    4
#define LIBID_SS    5
#define LIBID_DB    6
#define LIBID_OM    7
#define LIBID_MAIL  8
#define LIBID_CORBA 9
#define LIBID_TM1 	10
#define LIBID_PROX 	11
#define LIBID_MC    12
#define LIBID_RT    13
#define LIBID_LM    14

#ifndef AXSHLIB_DEFINES_ONLY		/* { */

typedef void (*exp_fptr)();

typedef struct {
	char* fname;
	exp_fptr fptr;
} ShlibFuncInfo;

ShlibFuncInfo* AxLoadShlib (int libid, char* firstCall);
void AxElfInstallForShlib(int libId);
int SHLoadAndSnap_EL(int call_idx);
int SHLoadAndSnap_GE(int call_idx);
int SHLoadAndSnap_WP(int call_idx);
int SHLoadAndSnap_SS(int call_idx);
int SHLoadAndSnap_DB(int call_idx);
int SHLoadAndSnap_OM(int call_idx);
int SHLoadAndSnap_MAIL(int call_idx); 
int SHLoadAndSnap_CORBA(int call_idx); 
int SHLoadAndSnap_TM1(int call_idx); 
int SHLoadAndSnap_PROX(int call_idx); 
int SHLoadAndSnap_RT(int call_idx);
int SHLoadAndSnap_LM(int call_idx);
#if LINUX || SUN4S
int SHLoadAndSnap_MC(int call_idx); 
#endif
int AxBindShlibImportFuncs(ShlibFuncInfo*,ShlibFuncInfo*);

#endif								/* } */

#endif /* _SHLIB_INCL */
