/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axsocket.h
   Applix ASC version: 7
   Date: Mon Nov 16 13:52:54 1998
*/
#ifndef _AXSOCKET_H
#define _AXSOCKET_H


#if AXMS    /* { */

#define WIN32_LEAN_AND_MEAN 1    /* to suppres lots of extraneous Microsoft */
                                 /* include files which contain defines for */
                                 /* comon tokens like "boolean", "byte",    */
                                 /* etc ans which use variables like "bool" */
                                 /* which we define.                        */
#include <winsock.h>
#include <errnohack.h>           /* for MS compatibilty */
#define MAXHOSTNAMELEN 64
#define F_SETFL  4
#define O_NDELAY 0x0004

#define CLOSE_CHANNEL(n) closesocket(n);

#else    /* } { */

#include <sys/socket.h>
#include <netinet/in.h>

#include <sys/un.h>
#include <netdb.h>

/* The following defies are so that the code can look the same between */
/* Windows as UNIX                                                     */
#define SOCKET    int
#define SOCKET_ERROR -1      /* Windows/NT defines these to be values other */
#define INVALID_SOCKET -1    /* then the -1 returned from "socket" and "bind" */

#define CLOSE_CHANNEL(n) close(n);
#endif    /* } AXMS */


#endif /* _AXSOCKET_H */

