/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: basicwin.h
   Applix ASC version: 14
   Date: Thu May 27 21:12:36 1999
*/
#ifndef _BASICWIN_H
#define _BASICWIN_H

/* first some useful entities */
#define PIXEL_VALUE unsigned long

#if AXMS    /*   {    ------------------------------------------  */
   /* Microsoft Windows and Windows-NT   */
#define WIN32_LEAN_AND_MEAN 1    /* to suppres lots of extraneous Microsoft */
                                 /* include files which contain defines for */
                                 /* comon tokens like "boolean", "byte",    */
                                 /* etc ans which use variables like "bool" */
                                 /* which we define.                        */
#include <fromxh.h>     /* windows version of X.h */  
#include <x2win.h>
#include <x2winkey.h>
#include <winmap.h>     /* map "identifiable" names to real windows names */

#define COLOR_WHITE (RGB(0xFF, 0xFF, 0xFF) )
#define COLOR_BLACK (RGB( 0, 0, 0) )

#define SOCKET_PSEUDO_EVENT 12345  /* for use by WSAAsyncSelect */
#define AX_WM_PAINT_PALETTE 12346  /* used in PaletteClassProc  */

#else    /*    }   {    ------------------------------------------  */

  /*  X-Windows */
#define COLOR_WHITE (WhitePixel(Dpy, DefaultScreen(Dpy)))
#define COLOR_BLACK (BlackPixel(Dpy, DefaultScreen(Dpy)))

#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#endif    /*   {    ------------------------------------------  */


#endif  /* _BASICWIN_H */
