/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: gstyle.h
   Applix ASC version: 3
   Date: Mon Nov 16 13:52:52 1998
*/
#ifndef __GSTYLE_H	/* { */
#define __GSTYLE_H
typedef struct {
	short year;			/* 1850 = 0 */
	short month;		/* January = 1 */
	short day;			/* 1-31 */
	short hour;			/* 0-23 */
	short minute;			/* 0-59 */
	short second;			/* 0-59 */
} DateStruct;


/* structure to be passed to ParseNum */
typedef struct {
	char	use_me;			/* used to tell ParseNum to use override
							   structure, as opposed to the values it
							   obtained from user profile. */
	
	int 	numForm;		/* number format code from user profile */
	char	decimalChar;  	/* decimal point -      either . or , */
	char	commaChar;		/* thousand separator - either , or . */
	char	moneyLeading;	/* TRUE if user wants money symbol displayed
							   in front of number (not used by ParseNum).
							   This governs the spreadsheet display mode. */
	char	moneyChar[6];	/* money symbol with no blanks (for data entry) */
	char	moneyLen;		/* length of moneyChar */
	char	moneyCharPrt[6];/* money symol with possible blanks for
							   printing (not used at present) */
	char	moneyLenPrt;	/* length of moneyCharPrt (not used) */
	int 	dateForm;		/* date format from user profile */
	int		timeForm;		/* time format from user profile */
	int		dowForm;		/* day of week format from user profile */
	int 	measureInch;	/* use PP defines PGMSENGLISH, PGMSMETRIC */
	char	amstr[5];		/* AM/am str */
	char	pmstr[5];		/* pm/PM str */
	char	listsep;		/* list separtor, used in hour:min:sec */
	char	reserved[16];
/* temp section for ParseNum to return status */
	char	decimal_found;
	char	curr_sym_leading;
	char	spare[8];
} foreignChars;

#endif	/* } */
