/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: memblk.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:52:53 1998
*/
#ifndef AX_MEMBLK_LOADED

#define AX_MEMBLK_LOADED 1
 
/*

This file contains the memory block info for
task management.

When a task type is created, a declarator routine is needed in the app:

In elintr.c:

	ax_mem_block_info_t *ElfMemBlockInfo()
	{
		static ax_mem_block_info_t ElfMemData[2];

		ElfMemData[0].addr = (char*)&Elf;
		ElfMemData[0].size = sizeof(Elf);
		ElfMemData[0].is_zeros = TRUE;
		return(ElfMemData);
	}

The returned mem block info is used by the context switch to define
by memory structure used by the app.

In tmzcontext.c:

	BlockList[THIMTYPE_EL][0] = ElfMemBlockInfo();
	BlockList[THIMTYPE_EL][1] = FSMemBlockInfo();
	BlockList[THIMTYPE_EL][2] = 0;


*/

typedef struct {
	char *addr;		/* addr of object */
	int size;		/* size of object */
	int is_zeros;	/* TRUE if the object is zero filled (BSS) */
	char *virgin;	/* backup copy */
	char *backup;	/* current owner task's backup address */
} ax_mem_block_info_t;

#endif /* AX_MEMBLK_LOADED */

