/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: n_style.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:52:54 1998
*/
#define FMT_UNSTYLED   0
#define FMT_CURRENCY   1
#define FMT_COMMA      2
#define FMT_FIXED      3
#define FMT_GENERAL    4
#define FMT_SCIENTIFIC 5
#define FMT_PERCENTAGE 6
#define FMT_DATE       7
#define FMT_BOOLEAN    8
#define FMT_GRAPH      9
#define FMT_TIME      10
#define FMT_CUSTOM    11

/* auxilliary format types */
#define FMT_DATE1 0
#define FMT_DATE2 1
#define FMT_DATE3 2
#define FMT_DATE4 3
#define FMT_DATE5 4
#define FMT_DATE6 5
#define FMT_TIME1 0
#define FMT_TIME2 1
#define FMT_TIME3 2
#define FMT_TIME4 3
#define FMT_TIME5 4
#define FMT_TIME6 5
#define FMT_MONEY1 0
#define FMT_MONEY2 1

typedef struct number_format {
	int display_format_errors; /* flag - if set, display "########" on error */
	int trim_string;           /* flag - remove zeros (radix override) */
	int id, aux_id;            /* format specifier */
    int units;                 /* scale factor, default 1 */
    int n_radix_places;        /* default 2 */
    char *prefix;              /* null by default */
    char *suffix;              /* null by default */
	char *am;                  /* morning string */
	char *pm;                  /* evening string */
	char *true;                /* true string */
	char *false;               /* false string */
    char t_sep;                /* thousands seperator, default "," */
    char d_sep;                /* decimal seperator, default "." */
} number_format;
