/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: paripc.h
   Applix ASC version: 4
   Date: Mon Nov 16 13:52:53 1998
*/
#include <aos.h>

#ifndef PARIPC_H
#define PARIPC_H

/* Standard Returned Status */

#define IPC_OK		0		/* call processed normally */
#define IPC_TO		1		/* timeout */
#define IPC_SOCKET	2		/* Berkley socket msg, used only by socket listeners */
#define IPC_RESOURCE 3		/* Special resource now available */
#define IPC_NOS		4		/* no server... OBSOLETE */

/* Destination Codes  */

#define IPC_RES		0	/* via response channel: to response waiter */ 
#define IPC_MES		1	/* direct to application */
#define IPC_SRT		2	/* to server runtime */
#define IPC_IPC		3	/* to IPCgetEvent */

/* Constants & Typedefs */

#define IPC_INF		(-1)	/* timeout value meaning infinity (wait forever) */

#define IPC_MAX_LEN	4000/* OBSOLETE */
#define IPC_HEAD_LEN 20	/* OBSOLETE */

#endif
