/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: print.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:52:53 1998
*/
#define CHARSIZE	8

#define PRTMP        "servers/6/prTmp"

#define PRTQUEUE	"PRTQUEUE"
#define CPRTQUEUE	"CPRTQUEUE"
#define SAVEPRT 1	/* save printer info in document file */


/* This file contains the DIA message definitions for the Print
MBAP and the Print Server. */

#define PRTCHAPTER	18

#define DtPRT_NDPRIVATE  (typeDt)(DtNODATA+(DtGENERIC*PRTCHAPTER))
		/*Printer priv (no data)			[0x480] */
#define DtPRT_CHARPRIV  (typeDt)(DtCHAR+(DtGENERIC*PRTCHAPTER))
		/*Printer priv strings				[0x2480] */
#define DtPRT_LONGPRIV  (typeDt)(DtLONG+(DtGENERIC*PRTCHAPTER))
		/*Printer priv longs				[0x6480] */
#define DtPRT_SHORTPRIV  (typeDt)(DtSHORT+(DtGENERIC*PRTCHAPTER))
		/*Printer priv shorts				[0x4480] */
#define DtPRT_CONSPRIV  (typeDt)(DtCONSTRUCTOR+(DtGENERIC*PRTCHAPTER))
		/*Printer priv					[0xa480] */
#define DtPRT_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*PRTCHAPTER))
		/* Print  priv					[0xc480] */




#define DtPRAPINFO	(typeDt) (DtPRT_CONSPRIV+1) /*		[a481]
		constructor; single constructor tuple that contains
		all of the application specific information that must
		be passed form the requesting application to the
		application that actually performs the print formatting.
		This information is simply passed along by the MBAP and
		is never looked at or interpreted.
		This is applicable only to the PRPRINT action. */

#define DtPRINFO	(typeDt) (DtPRT_CONSPRIV+2) /*		[a482]
		constructor containing the information gathered by the
		print document menu. */

#define DtPRPRID	(typeDt) (DtPRT_CONSPRIV+3) /*		[a483]
		constructor; print server's internal id for print jobs. */






#define DtPRACTION	(typeDt) (DtPRT_SHORTPRIV+1) /*		[4481]
		short; value is an action code from one of the
			codes defined below */

/* The action code is required for all MBAP requests, as it defines
the action to be performed. */

#define DtPRCOPIES	(typeDt) (DtPRT_SHORTPRIV+2) /*		[4482]
		short; number of copies of the document to be printed.  */

#define DtPRPRIORITY	(typeDt) (DtPRT_SHORTPRIV+3) /*		[4483]
		short; range (1, 2, 3) implying low, medium, and
		high priority, respectively. */

#define DtPRNOTIFY	(typeDt) (DtPRT_SHORTPRIV+4) /*		[4484]
		short; range (0,1) implying the user does not want
		to be notified and does want to be notified, respectively,
		of the completion of the print job. */

#define DtPRTEMPLATE	(typeDt) (DtPRT_SHORTPRIV+5) /*		[4485]
		short; range (0, 1) implying the user does not want
		the page template used or he does want it used,
		respectively */

#define DtPRVAL_FOR	(typeDt) (DtPRT_SHORTPRIV+6) /* 	[4486]
	For Spreadsheets:  0=print values on a grid.
                           1=print values and formulas*/

#define DtPRTBL_FRM	(typeDt) (DtPRT_SHORTPRIV+7) /* 	[4487]
	For Databases:  0 means print tabular display.
	                   1 means print a series of forms 
	                     (1 value not in Rev 1.)*/

#define DtPRREC_NUMS	(typeDt) (DtPRT_SHORTPRIV+8) /* 	[4488]
	For databases: 0 = do not print record numbers
	                  1 = do print the 'Mark' numbers */

#define DtPRSETUP	(typeDt) (DtPRT_SHORTPRIV+9) /* 	[4489]
		short; number of the setup file for this printer. */

#define DtPRFTYPE	(typeDt) (DtPRT_SHORTPRIV+10) /*	[448a]
		short; file type if not a document */

#define DtPRBANNER	(typeDt) (DtPRT_SHORTPRIV+11) /*	[448b]
		short; 0 - do not print banner page
			1 - print banner page */

#define DtPRADMIN	(typeDt) (DtPRT_SHORTPRIV+12) /*	[448c]
		short;	0 - caller is not an administrator
			1 - caller is an administrator */

#define DtPRSTATUS	(typeDt) (DtPRT_SHORTPRIV+13) /*	[448d]
		short; return status for client requests to server */

#define DtPRSTYLE	(typeDt) (DtPRT_SHORTPRIV+14) /*	[448e]
		short; range (0,1) implying the user wants to print
			style guide of a text document */

#define DtPRPGHGT	(typeDt) (DtPRT_SHORTPRIV+15) /*	[448f]
		short; print setup page height */

#define DtPRPGWDTH	(typeDt) (DtPRT_SHORTPRIV+16) /*	[4490]
		short; print setup page width */

#define DtPRPGYOFF	(typeDt) (DtPRT_SHORTPRIV+17) /*	[4491]
		short; print setup top offset */

#define DtPRPGXOFF	(typeDt) (DtPRT_SHORTPRIV+18) /*	[4492]
		short; print setup left offset */






#define DtPRDOCID	(typeDt) (DtPRT_LONGPRIV+1) /*		[6481]
		long; internal document identifier. Implies all files
		associated with the document. This is applicable to the
		PRPRINT and PRDEFINE actions to specify which document
		is to be processed. */

#define DtPRMERGE	(typeDt) (DtPRT_LONGPRIV+2) /*		[6482]
		long; document id of database merge doc */

#define DtPRTIME	(typeDt) (DtPRT_LONGPRIV+3) /*		[6483]
		long; print MBAP's time stamp for identifying print
		jobs */

#define DtPRPID		(typeDt) (DtPRT_LONGPRIV+4) /*		[6484]
		long; print server to DC to indicate pid of DF */

#define DtPRHOST	(typeDt) (DtPRT_LONGPRIV+5) /*		[6485]
		long; host id where requestor resides */
		
#define DtPRSUBMIT	(typeDt) (DtPRT_LONGPRIV+6) /*		[6486]
		long; time stamp of original submission. in Applix
		standard time format */
			
#define DtPRCREATE	(typeDt) (DtPRT_LONGPRIV+7) /*		[6487]
		long; creation date of the document. in Applix
		standard time format */





#define DtPRNAME	(typeDt) (DtPRT_CHARPRIV+1) /*		[2481]
		text; name of the printer the document is to be printed
		on. */

#define DtPRDEVICE	(typeDt) (DtPRT_CHARPRIV+2) /*		[2482]
		text; pathname of the device the document is to be printed
		on. */

#define DtPRRNAME	(typeDt) (DtPRT_CHARPRIV+3) /*		[2483]
		text; name of printer job is to be redirected to */

#define DtPRUSER	(typeDt) (DtPRT_CHARPRIV+4) /*		[2484]
		complete identification pathname to identify the requestor
		of the print job. Used for notification of completion of
		the print job. */

#define DtPRVIEW    	(typeDt) (DtPRT_CHARPRIV+6) /*		[2486]
		The name of the view to print.  If 
                omitted, print all records, objects, cells, etc. */

#define DtPRDOCNAME	(typeDt) (DtPRT_CHARPRIV+7) /*		[2487]
		text; document name */

#define DtPRCABINET	(typeDt) (DtPRT_CHARPRIV+8) /*		[2488]
		text; cabinet name */

#define DtPRSETNAME	(typeDt) (DtPRT_CHARPRIV+9) /*		[2489]
		text; setup name */

#define DtPRFSTIME	(typeDt) (DtPRT_CHARPRIV+10) /*		[248a]
		text; formatted submit time */

#define DtPRHNAME	(typeDt) (DtPRT_CHARPRIV+11) /*		[248b]
		text; host name */

#define DtPRRANGE	(typeDt) (DtPRT_CHARPRIV+12) /*		[248c]
		text; page range */

#define DtPRFILENAME	(typeDt) (DtPRT_CHARPRIV+13) /*		[248d]
		text; udf or ascii filename */

#define DtPRIMPSCRIPT	(typeDt) (DtPRT_CHARPRIV+14) /*		[248e]
		text; IMP script for forms printing */

#define DtPRCABID	(typeDt) (DtPRT_CHARPRIV+15) /*		[248f]
		text; ACcabid needed by IMP to access profile */

#define DtPRCLASS	(typeDt) (DtPRT_CHARPRIV+16) /*		[2490]
		text; printer class used to validate setup info */

#define DtPRTITLE	(typeDt) (DtPRT_CHARPRIV+17) /*		[2491]
		text; used for header if file type is UDF */

#define DtPRDRAWER	(typeDt) (DtPRT_CHARPRIV+18) /*		[2492]
		text; document's drawer */

#define DtPRFOLDER	(typeDt) (DtPRT_CHARPRIV+19) /*		[2493]
		text; document's folder */

#define DtPRSECTION	(typeDt) (DtPRT_CHARPRIV+20) /*		[2494]
		text; document's section */

#define DtPRSUBSECT	(typeDt) (DtPRT_CHARPRIV+21) /*		[2495]
		text; document's subsection */

#define DtPRPGATTRS	(typeDt) (DtPRT_CHARPRIV+22) /*		[2496]
		text; print setup page attributes (offsets in rsval.h) */

#define DtPRDRAFT	(typeDt) (DtPRT_CHARPRIV+23) /*		[2497]
		text; Y => draft spacing */

#define DtPRCOMMENT	(typeDt) (DtPRT_CHARPRIV+24) /*		[2498]
		text; print setup comment field */

#define DtPRREVISION	(typeDt) (DtPRT_CHARPRIV+25) /*		[2499]
		text; print only revised pages */


/* file types of sent files if the file is not a document */

#define PRASCII		1
#define PRUDF		2
#define PRFORMS		3
#define PRSE		4

/* the PRTcmd structure */

struct PRTcmd {
	int	action;		/* replaces -e switch value - see below */
	int	appid;		/* replaces -s switch value */	
	DocInfoType	*doc;	/* replaces -c switch */
	char	*filename;	/* replaces -a, -j, -f, -x, and -u switches */
	char	*script;	/* replaces -y switch */
	char	*title;		/* replaces -t switch */
	char	*printer;	/* default printer (overrides profile) */
	char	*setup;		/* default setup (overrides profile) */
	char	*view;		/* default view (overrides Current) */
};

/* print commands */

#define PRDEFINE	1
			/* define print style for the accompanying document.  */

#define PRPRINT		2
			/* print the accompanying document */

#define PRUACTIONS	3
			/* display/change the status of requested print jobs
			for the requesting user on all printers */

#define PRAACTIONS	4
			/* display the menu in Figure Print-6, and take the
			appropriate action as specified by the administrator,
			including displaying the current printer queue */

#define PRCANCUR	5
			/* cancel the currently printing job */

#define PRSTAFTER	6
			/* stop the printer after the current print job is
			finished */

#define PRSTNOW		7
			/* stop the printer immediately */

#define PRREDO		8
			/* restart the printer, starting at the beginning of the
			highest priority print job */

#define PRRESTART	9
		/* restart the printer, starting where the job left off that
		was previously stopped */

#define PRQUEUESTATUS	10
		/* return, to the requestor, the current contents
		of the print queue, via the Mail service */

#define PRHOLD		11
		/* hold the specified print jobs.

		This must be accompanied by a series of DtPRPRID tuples
		specifying the print jobs. */

#define PRREDIRECT	12
		/* redirect the specified print jobs to the named printer.
		This must be accompanied by the DtPRNAME tuple.
		This must be accompanied by a series of DtPRPRID tuples
		specifying the print jobs */

#define PRCANCEL	13
		/* cancel the specified print jobs.

		This must be accompanied by a series of DtPRPRID tuples
		specifying the print jobs. */

#define PRUNHOLD	14
		/* unhold the specified print jobs.
		This must be accompanied by a series of DtPRPRID
		tuples specifying the print jobs. */

#define PRCLEAR		15
		/* Clear the completed print jobs from the user's inbox */

#define PRQUEUE		16
		/* The associated mail message includes the print server's
		 rint queue */

#define PRPRUDF		17
			/* print a UDF file */

#define PRPRASCII	18
			/* print an ASCII file */

#define PRPRFORM	19
			/* print forms given a script name */

#define PRPRFILES	20
			/* print a list of documents */

#define PRPRUSER	21
			/* print a user-define document */

#define PRPRSTYLE	22
			/* print style guide or model document */

#define PRPRICON	23
			/* initialize print request menu as a setaside icon */

#define PRPRRANGE	24
			/* print a spreadsheet range */

#define PRPFFONT	25
			/* bash font in print-time attribute */

#define PRPRSE		26
			/* print a formatted se output file */

#define PRDEFAULTS	27
			/* print with defaults (without print request menu) */
