/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: scac.h
   Applix ASC version: 13
   Date: Wed May 12 21:10:28 1999
*/
#define AOSDIR      "AOSDIR"
#define FSDIR       "FSDIR"
#define HOSTADDR    "HOSTADDR"

/*
 * Misc. constants
 */

#define ACMXETXT    78  /* Max # of Error characters */
#define ACMXATXT    ACMXETXT  /* Max # of Alarm characters */
#define ACMXCLL     512 /* Max length of command line */
#define ACCLWIN     1000    /* Offset to indicate closed window id */
#define ACDOSTAT    999 /* ATM sends when it wants desk. status disp */
#define ACMXDTYPES  32  /* Max. no. data types in a discipline */

#if SYS&AEGISO
#define ACMXSIS     75  /* Longest sis returned by ACpassSIS */
#else
#define ACMXSIS     48  /* Longest sis returned by ACpassSIS */
#endif

#define AC_BELL     '!' /* Prefix to error messages to ring bell */
#define AC_SBELL    "!" /* if you insist on strcpy... */
#define AC_SWITCHES     "A:C:DE:F:H:IKOP:R:S:TU:W:" /* For getopt() callers */

/*
 * Application Identifiers
 */

/*
 * Permanent servers
 */
#define APMNPSID    1   /* Min. perm server appl. id */

#define APSC        1   /* System controller */
#define APMAILS     2   /* Mail server */
#define APCALS      3   /* Calendar server */
#define APFILES     4   /* Filing server */
#define APREGIS     5   /* Registration server */
#define APPRNTS     6   /* Print server */
#define APARCHS     7   /* Archive server */
#define APPSERIAL   8   /* Printer serializer */
#define APPDRIVER   9   /* Printer driver */
#define APJANITOR   10  /* Janitor */
#define APGTWY3     11  /* Unix -> Alis gateway */
#define APARCVT     12  /* Archive converter */
#define APALISOP    13 /* Alis operator interface */
#define APDCSUTIL	14 /* DC for utility functions */
#define APML		15 /* Markup Language input filter */

/*======================================================*/
/* mbp SNA and SNADS addons;                */
/* added on Thu Jun 29 16:38:16 MET DST 1989 by hgh */

#define APSNA_SNAAOP    51
#define APSNA_TRACER    52
#define APSNA_TX    53
#define APSNA_HIS   54
#define APSNA_GATEWAY   55
#define APSNA_RX    56
#define APSNADS_SVR 60
#define APSNADS_CNTL    61
#define APSNADS_RCV 62
#define APSNADS_SEND    63
#define APSNA_DLS   64
 
#define APSNA_WAKER 70
#define APSNA_MLU1  71
#define APSNA_MLU2  72
#define APSNA_MLU3  73
#define APSNA_MLU4  74
#define APSNA_MLU5  75
#define APSNA_MLU6  76
#define APSNA_CONSOLE   77
#define APSNA_PRN1  78
 
/* End of 'mbp SNA and SNADS addons'            */
/*======================================================*/

/*
 * Application ids reserved for non-Applix SERVER applications start with
 * this value:
 */
#define APMNUPSID   75

#define APMXPSID    99  /* Max. appl. id */

/*
 * Per-user servers
 */

#define APAC        101 /* Activity controller */
#define APATM       102 /* ATM */
#define APIMP       103 /* IMP */

#define APTINT      999 /* Temp. interrupt handler */

/*
 * Applications & Mbaps started via ACproc.
 */

#define APCALC      104 /* Calculator */
#define APDC        105 /* Document composer */
#define APCALM      106 /* Calendar MBAP */
#define APMAILM     107 /* Mail MBAP */
#define APMPAP      108 /* MPAP */
#define APADM       109 /* Administrator MBAP */
#define APGE        110 /* Graphics editor */
#define APBG        111 /* Business graphics */
#define APSS        112 /* Spreadsheet */
#define APPDB       113 /* Personal database */
#define APFILEM     114 /* Filing MBAP */
#define APARCHM     115 /* Archive MBAP */
#define APHELP      116 /* Help MBAP */
#define APUCM       117 /* Command editor application */
#define APPRNTM     118 /* Printer MBAP */
#define APSCHED     119 /* Scheduler */
#define APPLAN      120 /* Activity planner */
#define APUPGEN     121 /* DUMMY - User Profile General info */
#define APUPACC     122 /* DUMMY - User Profile Access & Delegation info */
#define APSFFT      123 /* Sending file transfer */
#define APRFFT      124 /* Receiving file transfer */
#define APPROFM     125 /* User Profile MBAP */
#define APINBOXM    126 /* Inbox MBAP */
#define APSSCONV    127 /* Spreadsheet conversion program */
#define APINSCR     128 /* Inset creation (aka MPAP) */
#define APTXKEY     129 /* text character keycode reported directly */
#define APPDC       130 /* Printing Document composer */
#define APIDC       131 /* Inport Document composer */
#define APEDC       132 /* Export Document composer */
#define APDCAO      133 /* document composer -> ascii converter */
#define APDCAI      134 /* ascii -> document composer converter */
#define APSPELL     135 /* spelling support program */
#define APGEOCVT    136 /* ge document -> ascii */
#define APGEICVT    137 /* ascii -> ge document */
#define APBGOCVT    138 /* bg document -> ascii */
#define APBGICVT    139 /* ascii -> bg document */
#define APGTWY1     140 /* Alis -> Unix gateway */
#define APGTWY2     141 /* Alis -> Unix -> Alis gateway */
#define APPDBAO     143 /* pdb document -> ascii converter */
#define APPDBAI     144 /* ascii -> pdb document converter */
#define APQRAO      145 /* query -> ascii converter */
#define APQRAI      146 /* ascii -> query converter */
#define APSSEXP     147 /* ss export to ascii */
#define APSSIMP     148 /* ss import from ascii */
#define APACTPL     149 /* activity planner a.k.a. calm */
#define APLDICT     150 /* local dictionary maint. MBAP */
#define APOTHER     151 /* other functions, eg sh */
#define APNDIF      152 /* Navy DIF -> dc ascii converter */
#define APPDB110    153 /* pdb 1.10 -> ascii converter */
#define APFSREF     154 /* FS utility to create interdoc ref. reports */
#define APALISM     155 /* combined MBAP */
#define APFORMPR    156 /* Forms printer */
#define APFONTSVR   157 /* pc atm font server */
#define APPIXED     159 /* Pixel Editor */
#define APDCSG      160 /* Document composer style guide */
#define APPDBIE     161 /* pdb import/export program */
#define APUPSTART   162 /* DUMMY: Start up preferences */
#define APELFM      163 /* ELF mbap */
#define APEDIT      164 /* user command/ascii editor */
#define APELFHELP   165 /* Elf helper process */
#define APUDFMASH   166 /* dc udf->mash transfer translator */
#define APPDB117    167 /* pdb 1.17 -> ascii converter */
#define APELFIO     168 /* import/export for Ascii docs */
#define APDCA	    169 /* import/export for DCA documents */
#define APHPGL	    170 /* import/export for HPGL documents */
#define APPDBS		171 /* silent Personal database */
#define APGTWY4		174	/* Alis -> DCA (unix mail) gateway */
#define APSSBACK    175 /* silent background spreadsheet */
#define APCONVPF    176 /* APOLLO convPF appid for ALISM bug */
#define APBGBACK    177 /* silent background busines graphics */
#define APDCUTIL    178 /* DC for utility functions in the background */
#define APXFER		179	/* Obsolete */
#define APXUDF		180	/* Actually just a xfer material type, not an app */
#define APXFOREIGN	181	/* Actually just a xfer material type, not an app */
#define APXASCII	182	/* Actually just a xfer material type, not an app */
#define APTIFF2GE	183	/* Tiff to GE file converter */
#define APWINXFER	184	/* Data conversion request */
#define APELFDEBUG	185	/* Elf debugger */
#define APXSERVER	200	/* message from X server */
#define APMSGDI		201	/* message MS Windows */
#define APMENUBAR	202	/* selection from menu bar */
#define APELFASYNC	203 /* async elf style message */
#define APSYS		204 /* replacement for APXSERVER & APMSGDI */
#define APSCROLL	205 /* message - scroll bar activity */
#define APPOINTER	206 /* pointer motion (buttons not pressed) */
#define APSOCKET	207	/* socket event to Elf channel */
#define APEQN		208 /* equation editor */
#define APXIM_SERVER 209  /* message from the x input method server */
#define APDUMMY		210  /* dummy message - recycle event loop */
#define APHTML      211 /* HTML Authoring System */

/*======================================================*/
/* mbp SNA and SNADS addons;                */
/* added on Thu Jun 29 16:38:16 MET DST 1989 by hgh */
/* 'normal' applications */

#define APSNA_PROGS 701
#define APSNA_CTRL  702

#define APSNA_EM3270    703
#define APSNA_CV3270    704

#define APSNA_TBHIS 705
#define APSNA_TBSNA 706
#define APSNA_TBAPPC    707
#define APSNA_TBBENLU   708
#define APSNA_MBPCOT    709
 
#define APSNA_SUBRJE    710
#define APSNA_TBRJE 711
 
 
#define APSNADS_AS  720
#define APSNADS_AA  721
#define APSNADS_MAIL    725
 
/* End of 'mbp SNA and SNADS addons'            */
/*======================================================*/

/* the following are "pseudo-ap-ids", used by things not started
*   via ACproc, and therefore not in the acapps file.  They do however
*   do ACinit() calls, and therfore need to pass an ap-id along. - jon */

#define APFSDOCQUAL  900

#define APPCPRTSVR  750 /* PC-ATM printer server , AM mbp */

/*
 * Application ids reserved for non-Applix applications start with
 * this value:
 */
#define APMNUSID    1001


/*
 * Transfer buffer descriptor - metadata to describe contents
 *  of the transfer buffer
 */
typedef struct {
    char *dname;    /* stem for Unix file name(s) */
    int disc;   /* doc. discipline */
    int status; /* bit flags - see below */
} XferDesc;

/*
 * Transfer buffer status flags
 */
#define AC_XNOT_EMPTY   1   /* buffer is not empty */
#define AC_XSCOPIED 2   /* buffer contents have been transferred */

/*
 * Definitions for ACgetEvent
 *
 *
 * Event types
 */
#define AC_LOGIN       1   /* User has logged in to Applix */
#define AC_LOGOUT      2   /* User has logged out */
#define AC_ALACK       3   /* Alarm acknowledged */
#define AC_DOCMOD      4   /* Document has been modified */
#define AC_CLDTRM      5   /* Child process termination */
#define AC_TERM        6   /* Graceful termination request */
#define AC_MAIL        7   /* A server has new mail */
#define AC_FSLOC       8   /* Filing system location changed */
#define AC_FFTSTAT     9   /* Completed fft */
#define AC_GETSIS      10  /* Unpended sis lookup return */
#define AC_FILES       11  /* A server received files via fft */
#define AC_HOSTUP      12  /* A remote host is now up */
#define AC_CLOSE       13  /* Force close databases */
#define AC_DOCREN      14  /* Document has been renamed */
#define AC_DOCLOSTSIGS 15  /* Document has lost signatures (FED only) */
#define AC_RESTART     16  /* Restart application with new cmd line */
#define AC_DOCUPDATE   17  /* like AC_DOCMOD, but it used when databases should be re-queried. */
#define AC_OPEN        18  /* Document has been opened */
#define AC_RTSTARTED   19  /* Real Time gateway was started */
#define AC_NEWFONTS    20  /* Font info has been re-initialized */

/*
 * NOTE: the docid pointer in AC_IND, below, is actually
 *   a pointer to a static DocInfoType structure
 */
typedef union ACevInd { /* AC event indication */
    char *uName;        /* login/out */
    long alarmID;       /* alarm ack */
    char *docid;        /* document was modified or renamed */
    int pid;        /* child termination */
    int fftstat[2];     /* fft status */
    struct {
        char *sis;  /* returned sis */
        long uid;   /* matches reply with the request */
    } getsis;
    char *fname;        /* list of transferred files */
    char *iaddr;        /* network address */
    struct {
        int filler [4]; /* filler */
        long hid;       /* Host ID of terminated fft/child */
    } hidinfo;
    struct {
	int nargc;	/* no. of args in new command line */
	char **nargv;	/* array of args in new command line */
    } newargs;
} AC_IND;

/*
 * Note: AC_MAIL indications do not return a useful AC_IND value.
 *   Instead, after calling ACgetEvent and having it return
 *   an AC_MAIL indication type, copy the ipc message and
 *   search for the contructor data type, Dt_ACMAILENV. It
 *   contains the envelope given to it by the mail server.
 * Also: AC_FSLOC doesn't return an AC_IND value either. Instead,
 *   this indication is a signal to call the filing system
 *   runtime, FSChildChdLoc().
 */

#define Dt_ACMAILENV    DtAC_CONSPRIV + 1   /* defined in dia.h */
#define Dt_ACFILES  DtAC_CONSPRIV + 2   /* Obsolete */
/*
 * Operation codes for ACxfer, ACdocOp & ACgetEvent
 */
#define AC_DOPENED  1   /* Doc. was opened */
#define AC_DCHKPNT  2   /* Doc. was checkpointed */
#define AC_DCLOSED  3   /* Doc. was closed */

#define AC_EXAMINE  4   /* Examine contents of xfer buffer */
#define AC_COPYFR   5   /* Copy from xfer buffer */
#define AC_COPYTO   6   /* Copy to xfer buffer */

#define AC_DRENAMED 7	/* Doc. was renamed */
#define AC_DLOSTSIGS 8  /* Doc. lost signatures (FED only) */
#if THIMBLE
#define AC_XCOPYTO	9	/* Temporary until window/window xfers work right */
#endif

#define AC_DMOD     128 /* Added in if modification occurred */

/*
 * sfft return codes
 */
#define ACFT_AOK    0   /* FFT completed normally */
#define ACFT_NETERR 1   /* Network or remote I/O error */
#define ACFT_NACCESS    2   /* Local file access error */
#define ACFT_WARNING    3   /* Too many fft's already running */

/*
 * Material Type Information
 */

#define MXEXTN      32  /* Max. num. of reqd. or opt. file extensions */

typedef struct {
    int type;       /* Material type id */
    char *name;     /* Material name */
    int appid;      /* Editor/displayer appid */
    char *int2extPr;    /* Internal to external format converter */
    char *ext2intPr;    /* External to internal format converter */
    char *extnm[MXEXTN];    /* List of file extension names */
    char exttp[MXEXTN]; /* List of file types */
    char *convextnm[MXEXTN]; /* List of conversion file extension names */
    int fmttype;        /* Format doc. type: 0 or null - n/a;
                   negative - mandatory */
    char *compcmd;      /* Compaction program command line */
    int insetaid;       /* Inset displayer application - 0 if none;
                   APDC if built into the DC */
    int insetindx;      /* Index of displayer within insetaid -
                   used if insetaid can display several types */
    int ieaid;          /* Import/Export program appid */
} MatInfo;

/*
 * File types
 */
#define MTF_NULL    0   /* Null type - marks end of list */
#define MTF_REQD    1   /* This file is required */
#define MTF_OPT     2   /* This file is optional, but will be copied */

MatInfo *nextMatInfo(), *getMatInfo();
