/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winmap.h
   Applix ASC version: 82
   Date: Mon Nov 16 13:52:54 1998
*/
#ifndef _WINMAP_H    /* { */
#define _WINMAP_H    1


#include <windef.h>


#if DEFINE_GDI_ERROR_GLOBALS
HGDIOBJ obj_e_ret;
int int_e_ret;
HDC hdc_e_ret;
#else
extern HGDIOBJ obj_e_ret;
extern int int_e_ret;
extern HDC hdc_e_ret;
#endif


#if WIN_DEBUG
#define DEBUG_RESOURCES 0
#define ERROR_FUNC tempAbort
#else
#define DEBUG_RESOURCES 0
#define ERROR_FUNC PostErrorMessage
#endif


int ERROR_FUNC();

#if DEBUG_RESOURCES   /*  {  */
/* define the types of objects we will track */
#define PEN_HANDLE 1
#define FONT_HANDLE 2
#define BITMAP_HANDLE 3
#define BRUSH_HANDLE 4
#define PALETTE_HANDLE 5
#define REGION_HANDLE 6

extern void remember_HDC(HDC);

int my_DeleteObject();
#define MS_DeleteObject( obj ) \
( (int_e_ret = my_DeleteObject( obj ) ) ? \
   (int)(obj = (HGDIOBJ)1) : ERROR_FUNC("bad return from DeleteObject()"))

HBITMAP my_LoadBitmap(HANDLE, char*);
#define MS_LoadBitmap( handle, name ) my_LoadBitmap( handle, name )

HDC my_CreateDC();
#define MS_CreateDC(driver, device, output, data) \
               my_CreateDC( driver, device, output, data)

HDC my_CreateCompatibleDC();
#define MS_CreateCompatibleDC( hdc ) my_CreateCompatibleDC( hdc )

int my_DeleteDC();
#define MS_DeleteDC( hdc ) \
   ( (int_e_ret  = my_DeleteDC( hdc ) ) ? \
      (int)(hdc = (HDC)1) : ERROR_FUNC("bad return from DeleteDC()") )


int my_ReleaseDC();
#define MS_ReleaseDC( window, hdc ) \
   ( (int_e_ret  = my_ReleaseDC( window, hdc ) ) ? \
      (int)(hdc = (HDC)1) : ERROR_FUNC("bad return from ReleaseDC()") )


HDC my_GetDC();
#define MS_GetDC( window ) my_GetDC( window )

HPEN my_CreatePen();
#define MS_CreatePen( style, width, color)   my_CreatePen(style, width, color)

HPEN my_ExtCreatePen();
#define MS32_ExtCreatePen( a, b, c, d, e )  my_ExtCreatePen( a, b, c, d, e )

HFONT my_CreateFontIndirect();
#define MS_CreateFontIndirect( log_struct ) my_CreateFontIndirect( log_struct )

HBITMAP my_CreateBitmap();
#define MS_CreateBitmap( width, height, planes, bits, color ) \
      my_CreateBitmap( width, height, planes, bits, color )

HBITMAP my_CreateBitmapIndirect();
#define MS_CreateBitmapIndirect( bitmap_data ) \
      my_CreateBitmapIndirect( bitmap_data )

HBITMAP my_CreateCompatibleBitmap();
#define MS_CreateCompatibleBitmap(hdc, width, height) \
   my_CreateCompatibleBitmap( hdc, width, height )

HBITMAP my_CreateDIBitmap();
#define MS_CreateDIBitmap( hdc, data, flag, init, color, usage ) \
   my_CreateDIBitmap( hdc, data, flag, init, color, usage )

HBRUSH my_CreateSolidBrush();
#define MS_CreateSolidBrush( color )             my_CreateSolidBrush(color)

HBRUSH my_CreatePatternBrush();
#define MS_CreatePatternBrush(bitmap)      my_CreatePatternBrush(bitmap)

HPALETTE my_CreatePalette();
#define MS_CreatePalette(log_pal)          my_CreatePalette(log_pal)

HRGN my_CreatePolygonRgn();
#define MS_CreatePolygonRgn( a, b, c )     my_CreatePolygonRgn( a, b, c )

HRGN my_CreateRectRgn();
#define MS_CreateRectRgn( left, top, right, bottom ) \
                               my_CreateRectRgn( left, top, right, bottom )


#else  /* } ------ Resource Debug Code  ------------------------- {  */

#define MS_CreateDC                     CreateDC
#define MS_CreateFontIndirect           CreateFontIndirect
#define MS_DeleteObject( obj ) \
   ( (int_e_ret = DeleteObject( obj ) ) ? \
   (int)(obj = (HGDIOBJ)1) : ERROR_FUNC("bad return from DeleteObject()"))

#define MS_LoadBitmap( handle, name ) \
 ( (obj_e_ret = LoadBitmap( handle, name ) ) ? \
    obj_e_ret : (HGDIOBJ)ERROR_FUNC("bad return from LoadBitmap()") )

#define MS_CreateCompatibleDC( hdc ) \
   ( (hdc_e_ret  = CreateCompatibleDC( hdc ) ) ? \
      hdc_e_ret : (HDC)ERROR_FUNC("bad return from CreateCompatibleDC()") )

#define MS_DeleteDC( hdc ) \
   ( (int_e_ret  = DeleteDC( hdc ) ) ? \
      (int)(hdc = (HDC)1) : ERROR_FUNC("bad return from DeleteDC()") )

#define MS_ReleaseDC( window, hdc ) \
   ( (int_e_ret  = ReleaseDC( window, hdc ) ) ? \
      (int)(hdc = (HDC)1) : ERROR_FUNC("bad return from ReleaseDC()") )

#define MS_GetDC( window ) \
   ( (hdc_e_ret  = GetDC( window ) ) ? \
      hdc_e_ret : (HDC)ERROR_FUNC("bad return from GetDC()") )

#define MS_CreatePen                    CreatePen

#define MS32_ExtCreatePen( a, b, c, d, e ) ExtCreatePen( a, b, c, d, e ) 

#define MS_CreateBitmap( width, height, planes, bits, color ) \
 ( (obj_e_ret = (HGDIOBJ)CreateBitmap(width,height,planes,bits,color) ) ? \
    obj_e_ret : (HGDIOBJ)ERROR_FUNC("bad return from CreateBitmap()") )

#define MS_CreateBitmapIndirect( bitmap_data ) \
   ( (obj_e_ret = (HGDIOBJ)CreateBitmapIndirect( bitmap_data ) ) ? \
      obj_e_ret : (HGDIOBJ)ERROR_FUNC("bad return from CreateBitmapIndirect()") )

#define MS_CreateCompatibleBitmap(hdc, width, height) \
   ( (obj_e_ret = (HGDIOBJ)CreateCompatibleBitmap(hdc, width, height) ) ? \
      obj_e_ret : (HGDIOBJ)ERROR_FUNC("bad return from CreateCompatibleBitmap()") )

#define MS_CreateDIBitmap( hdc, data, flag, init, color, usage ) \
   ( (obj_e_ret = (HGDIOBJ)CreateDIBitmap(hdc,data,flag,init,color,usage ) ) ? \
      obj_e_ret : (HGDIOBJ)ERROR_FUNC("bad return from CreateDIBitmap()") )

#define MS_CreateSolidBrush             CreateSolidBrush
#define MS_CreatePatternBrush           CreatePatternBrush
#define MS_CreatePalette                CreatePalette
#define MS_CreatePolygonRgn             CreatePolygonRgn
#define MS_CreateRectRgn                CreateRectRgn

#endif   /*  }  */


#define MS_SelectObject( hdc, drawable ) \
 ( (obj_e_ret = SelectObject( hdc, drawable )) ? \
    obj_e_ret : (HGDIOBJ)ERROR_FUNC("bad return from SelectObject()") )


#define MS_GetStockObject               GetStockObject
#define MS32_GetObjectType              GetObjectType

#define MS32_MaskBlt( a, b, c, d, e, f, g, h, i, j, k, l ) \
       MaskBlt( a, b, c, d, e, f, g, h, i, j, k, l )

#define MS32_PlgBlt( a, b, c, d, e, f, g, h, i, j ) \
       PlgBlt( a, b, c, d, e, f, g, h, i, j )

#define MS32_GdiSetBatchLimit( a )  GdiSetBatchLimit( a ) 

#define MS_GetDIBits(hdc,bmap,first,num,array,bdata,rgb) \
   ( (int_e_ret  = GetDIBits(hdc,bmap,first,num,array,bdata,rgb) ) ? \
      int_e_ret : ERROR_FUNC("bad return from GetDIBits()") )

#define MS_SelectClipRgn( hdc, region ) \
   ( (int_e_ret  = SelectClipRgn( hdc, region ) ) ? \
      int_e_ret : ERROR_FUNC("bad return from SelectClipRgn()") )

#define MS_DestroyCursor( hcur ) \
   ( (int_e_ret  = (int)DestroyCursor( hcur ) ) ? \
      (int)(hcur = (HCURSOR)1) : ERROR_FUNC("bad return from DestroyCursor()") )

#define MS_DestroyMenu( hmenu ) \
   ( (int_e_ret  = (int)DestroyMenu( hmenu ) ) ? \
      (int)(hmenu = (HMENU)1) : ERROR_FUNC("bad return from DestroyMenu()") )

#define MS_DestroyWindow( window ) \
   ( (int_e_ret  = (int)DestroyWindow( window ) ) ? \
      int_e_ret : ERROR_FUNC("bad return from DestroyWindow()") )

#define MS_MoveWindow( win, x, y, width, height, flag ) \
   ( (int_e_ret  = (int)MoveWindow( win, x, y, width, height, flag ) ) ? \
      int_e_ret : ERROR_FUNC("bad return from MoveWindow()") )

#define MS_SaveDC( hdc ) \
   ( (int_e_ret  = SaveDC( hdc ) ) ? \
      int_e_ret : ERROR_FUNC("bad return from SaveDC()") )

#define MS_RestoreDC(hdc, state) \
   ( (int_e_ret  = (int)RestoreDC(hdc, state) ) ? \
      int_e_ret : ERROR_FUNC("bad return from RestoreDC()") )

#define MS_PatBlt( hdc, x, y, width, height, rop ) \
   ( (int_e_ret  = (int)PatBlt( hdc, x, y, width, height, rop ) ) ? \
      int_e_ret : ERROR_FUNC("bad return from PatBlt()") )

#define MS_BitBlt(dest,x,y,wid,hgt,src,srcx,srcy,rot) \
   ( (int_e_ret  = (int)BitBlt(dest,x,y,wid,hgt,src,srcx,srcy,rot) ) ? \
      int_e_ret : ERROR_FUNC("bad return from BitBlt()") )



#define MS_CopyFile CopyFile
#define MS_CreateDirectory CreateDirectory
#define MS_GetSystemDirectory GetSystemDirectory
#define MS_GetModuleHandle GetModuleHandle
#define MS_GetModuleFileName GetModuleFileName
#define MS_SearchPath SearchPath
#define MS_CreateProcess CreateProcess
#define MS_LocalAlloc   LocalAlloc
#define MS_LocalFree    LocalFree
#define MS_FormatMessage FormatMessage
#define MSNT_CreateProcessAsUser CreateProcessAsUser
#define MS_GetUserName GetUserName
#define MS_Arc                          Arc
#define MS_GetLastError                 GetLastError
#define MS_CreateWindow                 CreateWindow
#define MS_AppendMenu                   AppendMenu  
#define MS_Beep                         Beep
#define MS_BeginPaint                   BeginPaint
#define MS_CallWindowProc               CallWindowProc
#define MS_CharNext                     CharNext
#define MS_CheckDlgButton               CheckDlgButton 
#define MS_CheckMenuItem                CheckMenuItem  
#define MS_ClientToScreen               ClientToScreen 
#define MS_CloseClipboard               CloseClipboard
#define MS_CloseMetaFile                CloseMetaFile
#define MS_CombineRgn                   CombineRgn
#define MS_CopyMetaFile                 CopyMetaFile
#define MS_CountClipboardFormats        CountClipboardFormats
#define MS_CreateAcceleratorTable       CreateAcceleratorTable
#define MS_CreateCursor                 CreateCursor
#define MS_CreateIC                     CreateIC
#define MS_CreateIcon                   CreateIcon
#define MS_CreateMenu                   CreateMenu  
#define MS_CreateMetaFile               CreateMetaFile
#define MS_CreateWindowEx               CreateWindowEx
#define MS_DefWindowProc                DefWindowProc
#define MS_DeleteMetaFile               DeleteMetaFile
#define MS_DestroyAcceleratorTable      DestroyAcceleratorTable
#define MS_DestroyIcon                  DestroyIcon
#define MS_DeviceCapabilities           DeviceCapabilities
#define MS_DispatchMessage              DispatchMessage 
#define MS_DPtoLP                       DPtoLP
#define MS_DrawIcon                     DrawIcon
#define MS_DrawMenuBar                  DrawMenuBar
#define MS_DrawText                     DrawText
#define MS_EmptyClipboard               EmptyClipboard
#define MS_EnableMenuItem               EnableMenuItem  
#define MS_EnableWindow                 EnableWindow
#define MS_EndPaint                     EndPaint
#define MS_EnumClipboardFormats         EnumClipboardFormats
#define MS_EnumFontFamilies             EnumFontFamilies
#define MS_AddFontResource              AddFontResource
#define MS_RemoveFontResource           RemoveFontResource
#define MS_EqualRgn                     EqualRgn
#define MS_FillRect                     FillRect
#define MS_FreeLibrary                  FreeLibrary 
#define MS_GetActiveWindow              GetActiveWindow
#define MS_GetCapture                   GetCapture 
#define MS_GetCharABCWidths             GetCharABCWidths
#define MS_GetClassInfo                 GetClassInfo
#define MS_GetClassLong                 GetClassLong
#define MS_GetClassName                 GetClassName
#define MS_GetClientRect                GetClientRect
#define MS_GetClipboardData             GetClipboardData
#define MS_GetClipboardFormatName       GetClipboardFormatName      
#define MS_GetClipboardOwner            GetClipboardOwner
#define MS_GetClipBox                   GetClipBox  
#define MS_GetComputerName              GetComputerName
#define MS_GetCurrentObject             GetCurrentObject
#define MS_GetCursor                    GetCursor
#define MS_GetCursorPos                 GetCursorPos
#define MS_GetDesktopWindow             GetDesktopWindow
#define MS_GetDeviceCaps                GetDeviceCaps 
#define MS_GetEnvironmentVariable       GetEnvironmentVariable 
#define MS_GetFocus                     GetFocus
#define MS_GetGlyphOutline              GetGlyphOutline
#define MS_GetKeyState                  GetKeyState 
#define MS_GetAsyncKeyState             GetAsyncKeyState
#define MS_GetLogicalDrives             GetLogicalDrives  
#define MS_GetMenu                      GetMenu  
#define MS_GetMenuItemCount             GetMenuItemCount
#define MS_GetMenuState                 GetMenuState
#define MS_GetMenuString                GetMenuString
#define MS_GetMessage                   GetMessage
#define MS_GetMessageTime               GetMessageTime
#define MS_GetMetaFile                  GetMetaFile
#define MS_GetMetaFileBitsEx            GetMetaFileBitsEx
#define MS_GetNearestPaletteIndex       GetNearestPaletteIndex
#define MS_GetObject                    GetObject
#define MS_GetOutlineTextMetrics        GetOutlineTextMetrics
#define MS_GetPaletteEntries            GetPaletteEntries
#define MS_GetParent                    GetParent
#define MS_GetProcAddress               GetProcAddress
#define MS_GetProfileString             GetProfileString
#define MS_GetRgnBox                    GetRgnBox
#define MS_GetScrollPos                 GetScrollPos
#define MS_GetScrollRange               GetScrollRange
#define MS_GetSubMenu                   GetSubMenu
#define MS_GetSysColor                  GetSysColor
#define MS_GetSystemMetrics             GetSystemMetrics  
#define MS_GetSystemPaletteEntries      GetSystemPaletteEntries
#define MS_GetTextExtentPoint           GetTextExtentPoint
#define MS_GetTextExtentPoint32         GetTextExtentPoint32
#define MS_GetTextMetrics               GetTextMetrics
#define MS_GetUpdateRect                GetUpdateRect
#define MS_GetVersion                   GetVersion
#define MS_GetVersionEx                 GetVersionEx
#define MS_GetViewportExtEx             GetViewportExtEx   
#define MS_GetVolumeInformation         GetVolumeInformation 
#define MS_GetWindowLong                GetWindowLong
#define MS_GetWindowOrgEx               GetWindowOrgEx
#define MS_GetWindowRect                GetWindowRect
#define MS_GlobalAlloc                  GlobalAlloc
#define MS_GlobalFree                   GlobalFree
#define MS_GlobalLock                   GlobalLock
#define MS_GlobalSize                   GlobalSize
#define MS_GlobalUnlock                 GlobalUnlock
#define MS_GrayString                   GrayString
#define MS_InsertMenu                   InsertMenu
#define MS_InvalidateRect               InvalidateRect
#define MS_InvertRect                   InvertRect
#define MS_IsClipboardFormatAvailable   IsClipboardFormatAvailable
#define MS_IsDialogMessage              IsDialogMessage      
#define MS_IsIconic                     IsIconic
#define MS_IsWindowEnabled              IsWindowEnabled
#define MS_KillTimer                    KillTimer
#define MS_LineDDA                      LineDDA
#define MS_LineTo                       LineTo
#define MS_LoadCursor                   LoadCursor  
#define MS_LoadIcon                     LoadIcon  
#define MS_LoadLibrary                  LoadLibrary 
#define MS_LPtoDP                       LPtoDP
#define MS_MapWindowPoints              MapWindowPoints
#define MS_MessageBox                   MessageBox
#define MS_ModifyMenu                   ModifyMenu
#define MS_MoveToEx                     MoveToEx
#define MS_OffsetRgn                    OffsetRgn
#define MS_OpenClipboard                OpenClipboard
#define MS_PeekMessage                  PeekMessage
#define MS_Pie                          Pie
#define MS_PlayMetaFile                 PlayMetaFile
#define MS_Polygon                      Polygon
#define MS_Polyline                     Polyline
#define MS_PostMessage                  PostMessage
#define MS_PostQuitMessage              PostQuitMessage
#define MS_PrintDlg                     PrintDlg
#define MS_RealizePalette               RealizePalette
#define MS_Rectangle                    Rectangle
#define MS_RedrawWindow                 RedrawWindow
#define MS_RegisterClass                RegisterClass 
#define MS_RegisterClipboardFormat      RegisterClipboardFormat
#define MS_ReleaseCapture               ReleaseCapture 
#define MS_RemoveMenu                   RemoveMenu
#define MS_ScreenToClient               ScreenToClient
#define MS_ScrollWindow                 ScrollWindow
#define MS_SelectPalette                SelectPalette
#define MS_SendMessage                  SendMessage
#define MS_SetBkColor                   SetBkColor
#define MS_SetBkMode                    SetBkMode
#define MS_SetBrushOrgEx                SetBrushOrgEx
#define MS_SetCapture                   SetCapture 
#define MS_SetClassLong                 SetClassLong
#define MS_SetClipboardData             SetClipboardData
#define MS_SetCursor                    SetCursor
#define MS_SetCursorPos                 SetCursorPos
#define MS_SetErrorMode                 SetErrorMode 
#define MS_SetFocus                     SetFocus 
#define MS_SetMapMode                   SetMapMode
#define MS_SetMenu                      SetMenu
#define MS_SetPaletteEntries            SetPaletteEntries
#define MS_SetPixel                     SetPixel
#define MS_SetPixelV                    SetPixelV
#define MS_SetROP2                      SetROP2
#define MS_SetScrollInfo                SetScrollInfo
#define MS_SetScrollPos                 SetScrollPos
#define MS_SetScrollRange               SetScrollRange
#define MS_SetScrollPage                SetScrollPage 
#define MS_SetTextAlign                 SetTextAlign
#define MS_SetTextColor                 SetTextColor
#define MS_SetTimer                     SetTimer
#define MS_SetWindowLong                SetWindowLong
#define MS_SetWindowPos                 SetWindowPos
#define MS_SetWindowText                SetWindowText
#define MS_ShowCursor                   ShowCursor
#define MS_ShowScrollBar                ShowScrollBar
#define MS_ShowWindow                   ShowWindow
#define MS_Sleep                        Sleep
#define MS_StretchBlt                   StretchBlt
#define MS_SystemParametersInfo         SystemParametersInfo
#define MS_TextOut                      TextOut
#define MS_TextOutW                     TextOutW
#define MS_timeGetTime                  timeGetTime
#define MS_TranslateAccelerator         TranslateAccelerator
#define MS_TranslateMessage             TranslateMessage
#define MS_UnrealizeObject              UnrealizeObject
#define MS_UnregisterClass              UnregisterClass
#define MS_UpdateWindow                 UpdateWindow
#define MS32_EnumPrinters               EnumPrinters
#define MS32_WritePrinter               WritePrinter
#define MS32_OpenPrinter                OpenPrinter
#define MS32_ClosePrinter               ClosePrinter
#define MS32_GetPrinter                 GetPrinter
#define MS32_StartDocPrinter            StartDocPrinter
#define MS32_EndDocPrinter              EndDocPrinter
#define MS32_GetUserName                GetUserName
#define MS_AbortPrinter                 AbortPrinter
#define MS_GetROP2                      GetROP2
#define MS_GetOpenFileName              GetOpenFileName
#define MS_SetForegroundWindow          SetForegroundWindow
#define MS_IntersectRect                IntersectRect
#define MS_GetWindow                    GetWindow
#define MS_GetWindowText                GetWindowText
#define MS_GetWindowTextLength          GetWindowTextLength
#define MS_IsWindowVisible              IsWindowVisible
#define MS_tmpnam                       tmpnam
#define MS_GetSystemTime                GetSystemTime
#define MS_SetActiveWindow              SetActiveWindow
#define MS_GetTopWindow                 GetTopWindow
#define MS_GetForegroundWindow          GetForegroundWindow
#define MS_CloseHandle                  CloseHandle
#define MS_SetStdHandle                 SetStdHandle
#define MS_CreateFile                   CreateFile
#define MS_DeleteFile                   DeleteFile
#define MS_GetFileAttributes			GetFileAttributes
#define MS_RemoveDirectory				RemoveDirectory
#define MS_WriteFile                    WriteFile
#define MS_DuplicateHandle              DuplicateHandle
#define MS_WaitForSingleObject          WaitForSingleObject
#define MS_GetExitCodeProcess           GetExitCodeProcess
#define MS_CoInitialize                 CoInitialize
#define MS_MultiByteToWideChar          MultiByteToWideChar
#define MS_StgOpenStorage               StgOpenStorage
#define MS_StgCreateDocfile             StgCreateDocfile
#define MS_GetCurrentProcessId          GetCurrentProcessId
#define MS_GetCurrentProcess 		    GetCurrentProcess
#define MS_GetTempPath                  GetTempPath

#define MS_CreateCaret                  CreateCaret
#define MS_DestroyCaret                 DestroyCaret
#define MS_HideCaret                    HideCaret
#define MS_SetCaretPos                  SetCaretPos
#define MS_ShowCaret                    ShowCaret

#define MS_ResetDC          ResetDC
#define MS_CreateDialog     CreateDialog
#define MS_SetAbortProc     SetAbortProc
#define MS_OpenProcess		OpenProcess
#define MS_TerminateProcess	TerminateProcess
#define MS_AbortDoc         AbortDoc
#define MS_SetDlgItemText   SetDlgItemText
#define MS_GetSystemMenu    GetSystemMenu
#define MS_SetPolyFillMode  SetPolyFillMode

#define MS_StartDoc         StartDoc
#define MS_EndDoc           EndDoc
#define MS_StartPage        StartPage
#define MS_EndPage          EndPage

#define MS_Ellipse          Ellipse
#define MS_StretchDIBits    StretchDIBits
#define MS_SetViewportOrgEx SetViewportOrgEx
#define MS32_PolyBezier     PolyBezier

#define MS32_BeginPath         BeginPath
#define MS32_EndPath           EndPath
#define MS32_FillPath          FillPath
#define MS32_StrokePath        StrokePath
#define MS32_StrokeAndFillPath StrokeAndFillPath
#define MS32_PathToRegion      PathToRegion
#define MS32_SelectClipPath    SelectClipPath
#define MS32_WidenPath         WidenPath
#define MS32_CloseFigure       CloseFigure

#define MSNT_SetGraphicsMode      SetGraphicsMode
#define MSNT_SetWorldTransform    SetWorldTransform
#define MSNT_ModifyWorldTransform ModifyWorldTransform

#define MS_MapViewOfFile        MapViewOfFile
#define MS_CreateFileMapping    CreateFileMapping
#define MS_UnmapViewOfFile      UnmapViewOfFile
#define MS_OpenFileMapping      OpenFileMapping

#define MS_AllocConsole         AllocConsole
#define MS_FreeConsole          FreeConsole
#define MS_GetStdHandle         GetStdHandle
#define MS_SetConsoleTitle      SetConsoleTitle

#define MS_ExitThread                 ExitThread
#define MS_CreateThread               CreateThread
#define MS_TerminateThread            TerminateThread
#define MS_PostThreadMessage          PostThreadMessage
#define MS_MsgWaitForMultipleObjects  MsgWaitForMultipleObjects
#define MS_CreateEvent                CreateEvent
#define MS_OpenEvent                  OpenEvent
#define MS_ResetEvent                 ResetEvent
#define MS_SetEvent                   SetEvent
#define MS_GetThreadDesktop                 GetThreadDesktop
#define MS_SetThreadDesktop                 SetThreadDesktop
#define MS_GetCurrentThreadId               GetCurrentThreadId
#define MS_InitializeCriticalSection		InitializeCriticalSection

#define MSNT_LogonUser                    LogonUser
#define MSNT_ImpersonateLoggedOnUser      ImpersonateLoggedOnUser
#define MSNT_LookupAccountName            LookupAccountName
#define MSNT_OpenWindowStation            OpenWindowStation
#define MSNT_GetProcessWindowStation      GetProcessWindowStation
#define MSNT_SetProcessWindowStation      SetProcessWindowStation
#define MSNT_OpenDesktop                  OpenDesktop
#define MSNT_CloseDesktop                 CloseDesktop
#define MSNT_CloseWindowStation           CloseWindowStation

/*** NT Services API ***/
#define MSNT_CreateService                CreateService
#define MSNT_EnumServicesStatus           EnumServicesStatus
#define MSNT_DeleteService                DeleteService
#define MSNT_OpenService                  OpenService
#define MSNT_CloseServiceHandle           CloseServiceHandle
#define MSNT_DeregisterEventSource        DeregisterEventSource
#define MSNT_ReportEvent                  ReportEvent
#define MSNT_StartServiceCtrlDispatcher   StartServiceCtrlDispatcher    
#define MSNT_ControlService               ControlService
#define MSNT_StartService                 StartService
#define MSNT_SetServiceStatus             SetServiceStatus
#define MSNT_RegisterServiceCtrlHandler   RegisterServiceCtrlHandler
#define MSNT_RegisterEventSource          RegisterEventSource
#define MSNT_OpenSCManager                OpenSCManager 
/***********************/

/*** NT Security API ***/
#define MSNT_GetUserObjectSecurity          GetUserObjectSecurity
#define MSNT_InitializeSecurityDescriptor   InitializeSecurityDescriptor
#define MSNT_GetSecurityDescriptorDacl      GetSecurityDescriptorDacl
#define MSNT_GetAclInformation              GetAclInformation
#define MSNT_InitializeAcl                  InitializeAcl
#define MSNT_GetAce                         GetAce
#define MSNT_AddAce                         AddAce
#define MSNT_EqualSid                       EqualSid
#define MSNT_AddAccessAllowedAce            AddAccessAllowedAce
#define MSNT_SetSecurityDescriptorDacl      SetSecurityDescriptorDacl
#define MSNT_SetUserObjectSecurity          SetUserObjectSecurity
/******************/


/** MS macros **/    
#define MS_GetRValue                    GetRValue
#define MS_GetGValue                    GetGValue
#define MS_GetBValue                    GetBValue
#define MS_SubclassWindow               SubclassWindow 
   
#endif    /* } _WINMAP_H */

