/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: pf.h
   Applix ASC version: 13
   Date: Fri May 14 21:13:46 1999
*/
#ifndef PF_H_INCL
#define PF_H_INCL

#if TURBO
#define PF_DEBUG 0
#else
#define PF_DEBUG 1
#endif

#if PF_DEBUG
void pf_asserter();
#define ASSERT(x)  if(!(x)) pf_asserter(NameOfThisSourceFile, __LINE__)
#else
#define ASSERT(x)
#endif

#ifndef NDEBUG

#define DEBUGCOMP	1	/* compile debug output code */

#endif /* NDEBUG not defined */


#ifdef DEBUGCOMP

#define SETDEBUG	PF.PFdebug=1
#define Debugs(s)	if(PF.PFdebug) fputs (s, PF.PFdfp)
#define Debugf(s,n)	if(PF.PFdebug) fprintf (PF.PFdfp, s, n)
#define Debug2f(s,n,m)	if(PF.PFdebug) fprintf (PF.PFdfp, s, n, m)
#define Debug3f(s,n,m,o)	if(PF.PFdebug) fprintf (PF.PFdfp, s, n,m,o)
#define Debug4f(s,n,m,o,p)	if(PF.PFdebug) fprintf (PF.PFdfp, s, n,m,o,p)
#define Debug5f(s,n,m,o,p,q)	if(PF.PFdebug) fprintf (PF.PFdfp, s, n,m,o,p,q)

#else

#define SETDEBUG
#define Debugs(s)
#define Debugf(s,n)
#define Debug2f(s,n,m)
#define Debug3f(s,n,m,o)
#define Debug4f(s,n,m,o,p)
#define Debug5f(s,n,m,o,p,q)

#endif /* DEBUGCOMP defined */


#define Warns(s)	if (PF.PfUnderAC) ACerrlog(s);
#define Warnf(s,n)	if (PF.PfUnderAC) { char warnbuf[256]; sprintf (warnbuf, s, n); ACerrlog(warnbuf); }
#define Warn2f(s,n,m)	if (PF.PfUnderAC) { char warnbuf[256]; sprintf (warnbuf, s, n, m); ACerrlog(warnbuf); }
#define Warn3f(s,n,m,o)	if (PF.PfUnderAC) { char warnbuf[256]; ; sprintf (warnbuf, s, n, m, o); ACerrlog(warnbuf); }

#define EVEN_BYTES_FROM_BITS(x) ((((x) +15) /16) *2)  /* we can optimize this */


#endif /* PF_H_INCL */
