/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: pfextra.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:56:50 1998
*/
#define InsertAtPrologBottom	1
#define InsertAtPrologTop		2
#define InsertAtSetupBottom		3
#define InsertAtSetupTop		4
#define InsertAtPageSetupBottom	5
#define InsertAtPageSetupTop	6
#define InsertAtFirstPageSetupBottom 7
#define InsertAtFirstPageSetupTop 8
#define InsertAtTrailerTop		9
#define InsertAtTrailerBottom	10
#define InsertAtPageTrailerTop	11
#define InsertAtPageTrailerBottom 12
#define InsertAtFirstPageTrailerTop 13
#define InsertAtFirstPageTrailerBottom 14
#define InsertJustBeforePattern 15
#define InsertJustAfterPattern	16
#define ReplacePatternWith		17
#define PPDFileName				18
#define PPDInvocation			19

typedef struct pat_data {
	char	*pattern;	/* look for this in input */
	char	*text;		/* text to insert */
	int		action;
	int		patlen;
	int		hash;		/* of pattern */
} patData;

	/* this is for the search-style patts */
typedef struct searchPat_t {
	int		numPatterns;
		/* init these as pointers into psinsert pats,
		 * ordered shortest pat to longest */
	patData	**pats;
		/* 'offset' and 'hash' store last-call
		 * state in out-of-input case */
	int		offset; /* start this far into passed input string */
	int		hash;   /* offset# chars have been hashed onto this */
} searchPat;

	/* all pats are arranged together as: */
typedef struct PS_inserts {
	int		numInserts;
	patData	*inserts; /* one for each extra postscript frag */
	searchPat searchPatterns;
} PSinserts;

	/* for use when reading adobe printer description files */
typedef struct ppd_key_tab_ent {
	int		hash;
	char	*key;
} ppdKeyTabEnt;



patData **getInserts() ;

