/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: pfprim.c
   Applix ASC version: 88
   Date: Mon Dec 21 21:12:21 1998
*/
#include <stdio.h>
#include <math.h>
#include <pf.h>
#include <aos.h>
#include <paratm.h>
#include <devsetup.h>
#include <pfint.h>
#include <fsrts.h>
#include <axtext.h>

#include <pfprim.p>
 
#if AXMS
#define hypot _hypot
#endif

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
extern char *axDefaultMonospaceFont;



#if BUILD_KANJI
#define LIPS3			1
#endif

/* global functions */

int		StartJob() ;
void	StdBanner() ;
void	pfDrawText() ;


/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
/* These are the indices of the functions in the device function arrays. */

#define STARTJOB	0
#define ENDJOB		1
#define NEWPAGE		2
#define SETPOS		3
#define DRAWTEXT	4
#define DRAWLINE	5
#define GRFSTART	6
#define GRFEND		7
#define CLRBOX		8
#define PUTIMAGE	9
#define DRAWGRAF	10
#define SETCOLOR	11
#define DRAWARC		12
#define DRAWAXTEXT	13
#define SETCLIP		14
#define SAVE_STATE	15
#define RESTORE		16
#define LANDSCAPE	17
#define PRINTMARKS	18
#define DRAWCLIP	19
#define PRCONTROL	20

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
/* set all defaults for text (copied from paratmint.h) */
#define ALLDEF	( ((long)TMA_DEF << TMFPCOLOR) \
					| ((long)TMA_DEF << TMFPFONT) | ((long)TMA_DEF << TMFPSIZ) \
					| ((long)TMA_DEF << TMFPHY) | ((long)TMA_DEF << TMFPHI) \
					| ((long)TMA_DEF << TMFPCC) | ((long)TMA_DEF << TMFPSS) \
					| ((long)TMA_DEF << TMFPII) | ((long)TMA_DEF << TMFPUU) \
					| ((long)TMA_DEF << TMFPBB) )



/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
/* PostScript */
extern int	D01StartJob(), D01EndJob(), D01NewPage(), D01SetPos(),
		D01Line(), D01ClrBox(), D01PutImage(), D01SetColor(),
		D01Ellipse(), D01AxText(), D01SetClip(),
		D01Save(), D01Restore(), D01Landscape(), D01Printmarks(),
		D01DrawClip();

static int	(*D01Ops[])() =
{
		D01StartJob,
		D01EndJob,
		D01NewPage,
		D01SetPos,
		NULL,
		D01Line,
		NULL,
		NULL,
		D01ClrBox,
		D01PutImage,
		NULL,
		D01SetColor,
		D01Ellipse,
		D01AxText,
		D01SetClip,		/* set app clip */
		D01Save,
		D01Restore,
		D01Landscape,
		D01Printmarks,
		D01DrawClip,
		NULL
};



/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
/* PCL5 */
extern int D03StartJob(), D03EndJob(), D03NewPage(), D03SetPos(),
			D03Line(),
			D03ClrBox(), D03PutImage(), D03SetColor(), D03AxText(),
			D03SetClip(),
			D03Save(), D03Restore(),
			D03Landscape(), D03Printmarks(), D03DrawClip(), D03PrControl();
 
static int	(*D03Ops[])() = {
		D03StartJob,
		D03EndJob,
		D03NewPage,
		D03SetPos,
		NULL,
		D03Line,
		NULL,		/* GrfStart */
		NULL,		/* GrfEnd */
		D03ClrBox,
		D03PutImage,
		NULL,
		D03SetColor,
		NULL,
		D03AxText,
		D03SetClip,
		D03Save,
		D03Restore,
		D03Landscape,
		D03Printmarks,
		D03DrawClip,
		D03PrControl
	};

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
#if AXMS	/* { */
/* device 4: Windows GDI */
extern int D04StartJob(), D04EndJob(), D04NewPage(), D04SetPos(),
			D04Line(),
			D04ClrBox(), D04PutImage(), D04SetColor(), D04AxText(),
			D04SetClip(),
			D04Save(), D04Restore(),
			D04Landscape(), D04Printmarks(), D04DoClip();

static int	(*D04Ops[])() = {
		D04StartJob,
		D04EndJob,
		D04NewPage,
		D04SetPos,
		NULL,
		D04Line,
		NULL,
		NULL,
		D04ClrBox,
		D04PutImage,
		NULL,
		D04SetColor,
		NULL,	/* is DrawArc obsolete? -donato */
		D04AxText,
		D04SetClip,
		D04Save,
		D04Restore,
		D04Landscape,
		D04Printmarks,
		D04DoClip,
		NULL
	};
#else		/* } { */
#define D04Ops NULL
#endif	/* } AXMS */



/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
#ifdef LIPS3	/*	{	*/
extern int	D218StartJob(), D218EndJob(), D218NewPage(), D218SetPos(),
		D218Line(), D218ClrBox(), D218PutImage(), D218SetColor(),
		D218Ellipse(), D218AxText(), D218SetClip(),
        D218Landscape(), D218Printmarks(), D218DrawClip();
static int	(*D218Ops[])() = {
		D218StartJob,
		D218EndJob,
		D218NewPage,
		D218SetPos,
		NULL,
		D218Line,
		NULL,
		NULL,
		D218ClrBox,
		D218PutImage,
		NULL,
		D218SetColor,
		D218Ellipse,
		D218AxText,
		D218SetClip,    /* set app clip */
		NULL,		/* Save */
		NULL,		/* restore */
        D218Landscape,  /* landscape */
        D218Printmarks, /* printmarks */
        D218DrawClip,    /* clip */
		NULL
};
static int  (*D219Ops[])() = {
        D218StartJob,
		D218EndJob,
		D218NewPage,
		D218SetPos,
		NULL,
		D218Line,
		NULL,
		NULL,
		D218ClrBox,
		D218PutImage,
		NULL,
		D218SetColor,
		D218Ellipse,
		D218AxText,
		NULL,		/* set app clip */
		NULL,		/* Save */
		NULL,		/* restore */
        D218Landscape,  /* landscape */
        D218Printmarks, /* printmarks */
        D218DrawClip,    /* clip */
		NULL		/* print control */
};
#else
#define D218Ops NULL
#define D219Ops NULL
#endif			/*	}	*/



/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
static int	(**DevOps[])() = {
		NULL,	/*	0 - ascii printer */ /* obsolete - SJP */
		D01Ops, /*	1 - PostScript	*/
		NULL,	/*	2 - undefined */
		D03Ops, /*	3 - PCL */
		D04Ops, /*	4 - Windows GDI */
		NULL,	/*	5 - undefined */
		NULL,	/*	6 - undefined */
		NULL,	/*	7 - undefined */
		NULL,	/*	8 - undefined */
		NULL,	/*	9 - undefined */
		NULL,	/* 10 - undefined */
		NULL,	/* 11 - undefined */
		NULL,	/* 12 - undefined */
		NULL,	/* 13 - undefined */
		NULL,	/* 14 - undefined */
		NULL,	/* 15 - undefined */
		NULL,	/* 16 - undefined */
		NULL,	/* 17 - undefined */
		NULL,	/* 18 - undefined */
		NULL,	/* 19 - undefined */
		NULL,	/* 20 - undefined */
		NULL,	/* 21 - undefined */
		NULL,	/* 22 - undefined */
		NULL,	/* 23 - undefined */
		NULL,	/* 24 - undefined */
		NULL,	/* 25 - undefined */
		NULL,	/* 26 - undefined */
		NULL,	/* 27 - undefined */
		NULL,	/* 28 - undefined */
		NULL,	/* 29 - undefined */
		NULL,	/* 30 - undefined */
		NULL,	/* 31 - undefined */
		NULL,	/* 32 - undefined */
		NULL,	/* 33 - undefined */
		NULL,	/* 34 - undefined */
		NULL,	/* 35 - undefined */
		NULL,	/* 36 - undefined */
		NULL,	/* 37 - undefined */
		NULL,	/* 38 - undefined */
		NULL,	/* 39 - undefined */
		NULL,	/* 40 - undefined */
		NULL,	/* 41 - undefined */
		NULL,	/* 42 - undefined */
		NULL,	/* 43 - undefined */
		NULL,	/* 44 - undefined */
		NULL,	/* 45 - undefined */
		NULL,	/* 46 - undefined */
		NULL,	/* 47 - undefined */
		NULL,	/* 48 - undefined */
		NULL,	/* 49 - undefined */
		NULL,	/* 50 - undefined */
		NULL,	/* 51 - undefined */
		NULL,	/* 52 - undefined */
		NULL,	/* 53 - undefined */
		NULL,	/* 54 - undefined */
		NULL,	/* 55 - undefined */
		NULL,	/* 56 - undefined */
		NULL,	/* 57 - undefined */
		NULL,	/* 58 - undefined */
		NULL,	/* 59 - undefined */
		NULL,	/* 60 - undefined */
		NULL,	/* 61 - undefined */
		NULL,	/* 62 - undefined */
		NULL,	/* 63 - undefined */
		NULL,	/* 64 - undefined */
		NULL,	/* 65 - undefined */
		NULL,	/* 66 - undefined */
		NULL,	/* 67 - undefined */
		NULL,	/* 68 - undefined */
		NULL,	/* 69 - undefined */
		NULL,	/* 70 - undefined */
		NULL,	/* 71 - undefined */
		NULL,	/* 72 - undefined */
		NULL,	/* 73 - undefined */
		NULL,	/* 74 - undefined */
		NULL,	/* 75 - undefined */
		NULL,	/* 76 - undefined */
		NULL,	/* 77 - undefined */
		NULL,	/* 78 - undefined */
		NULL,	/* 79 - undefined */
		NULL,	/* 80 - undefined */
		NULL,	/* 81 - undefined */
		NULL,	/* 82 - undefined */
		NULL,	/* 83 - undefined */
		NULL,	/* 84 - undefined */
		NULL,	/* 85 - undefined */
		NULL,	/* 86 - undefined */
		NULL,	/* 87 - undefined */
		NULL,	/* 88 - undefined */
		NULL,	/* 89 - undefined */
		NULL,	/* 90 - undefined */
		NULL,	/* 91 - undefined */
		NULL,	/* 92 - undefined */
		NULL,	/* 93 - undefined */
		NULL,	/* 94 - undefined */
		NULL,	/* 95 - undefined */
		NULL,	/* 96 - undefined */
		NULL,	/* 97 - undefined */
		NULL,	/* 98 - undefined */
		NULL,	/* 99 - undefined */
		NULL,	/* 100 - undefined */
		NULL,	/* 101 - undefined */
		NULL,	/* 102 - undefined */
		NULL,	/* 103 - undefined */
		NULL,	/* 104 - undefined */
		NULL,	/* 105 - undefined */
		NULL,	/* 106 - X11 screen device */
		NULL,	/* 107 - undefined */
		NULL,	/* 108 - undefined */
		NULL,	/* 109 - undefined */
		NULL,	/* 110 - undefined */
		NULL,	/* 111 - undefined */
		NULL,	/* 112 - undefined */
		NULL,	/* 113 - undefined */
		NULL,	/* 114 - undefined */
		NULL,	/* 115 - undefined */
		NULL,	/* 116 - undefined */
		NULL,	/* 117 - undefined */
		NULL,	/* 118 - undefined */
		NULL,	/* 119 - undefined */
		NULL,	/* 120 - undefined */
		NULL,	/* 121 - undefined */
		NULL,	/* 122 - undefined */
		NULL,	/* 123 - undefined */
		NULL,	/* 124 - undefined */
		NULL,	/* 125 - undefined */
		NULL,	/* 126 - undefined */
		NULL,	/* 127 - undefined */
		NULL,	/* 128 - undefined */
		NULL,	/* 129 - undefined */
		NULL,	/* 130 - undefined */
		NULL,	/* 131 - undefined */
		NULL,	/* 132 - undefined */
		NULL,	/* 133 - undefined */
		NULL,	/* 134 - undefined */
		NULL,	/* 135 - undefined */
		NULL,	/* 136 - undefined */
		NULL,	/* 137 - undefined */
		NULL,	/* 138 - undefined */
		NULL,	/* 139 - undefined */
		NULL,	/* 140 - undefined */
		NULL,	/* 141 - undefined */
		NULL,	/* 142 - undefined */
		NULL,	/* 143 - undefined */
		NULL,	/* 144 - undefined */
		NULL,	/* 145 - undefined */
		NULL,	/* 146 - undefined */
		NULL,	/* 147 - undefined */
		NULL,	/* 148 - undefined */
		NULL,	/* 149 - undefined */
		NULL,	/* 150 - undefined */
		NULL,	/* 151 - undefined */
		NULL,	/* 152 - undefined */
		NULL,	/* 153 - undefined */
		NULL,	/* 154 - undefined */
		NULL,	/* 155 - undefined */
		NULL,	/* 156 - undefined */
		NULL,	/* 157 - undefined */
		NULL,	/* 158 - undefined */
		NULL,	/* 159 - undefined */
		NULL,	/* 160 - undefined */
		NULL,	/* 161 - undefined */
		NULL,	/* 162 - undefined */
		NULL,	/* 163 - undefined */
		NULL,	/* 164 - undefined */
		NULL,	/* 165 - undefined */
		NULL,	/* 166 - undefined */
		NULL,	/* 167 - undefined */
		NULL,	/* 168 - undefined */
		NULL,	/* 169 - undefined */
		NULL,	/* 170 - undefined */
		NULL,	/* 171 - undefined */
		NULL,	/* 172 - undefined */
		NULL,	/* 173 - undefined */
		NULL,	/* 174 - undefined */
		NULL,	/* 175 - undefined */
		NULL,	/* 176 - undefined */
		NULL,	/* 177 - undefined */
		NULL,	/* 178 - undefined */
		NULL,	/* 179 - undefined */
		NULL,	/* 180 - undefined */
		NULL,	/* 181 - undefined */
		NULL,	/* 182 - undefined */
		NULL,	/* 183 - undefined */
		NULL,	/* 184 - undefined */
		NULL,	/* 185 - undefined */
		NULL,	/* 186 - undefined */
		NULL,	/* 187 - undefined */
		NULL,	/* 188 - undefined */
		NULL,	/* 189 - undefined */
		NULL,	/* 190 - undefined */
		NULL,	/* 191 - undefined */
		NULL,	/* 192 - undefined */
		NULL,	/* 193 - undefined */
		NULL,	/* 194 - undefined */
		NULL,	/* 195 - undefined */
		NULL,	/* 196 - undefined */
		NULL,	/* 197 - undefined */
		NULL,	/* 198 - undefined */
		NULL,	/* 199 - undefined */
		NULL,	/* 200 - undefined */
		NULL,	/* 201 - undefined */
		NULL,	/* 202 - undefined */
		NULL,	/* 203 - undefined */
		NULL,	/* 204 - undefined */
		NULL,	/* 205 - undefined */
		NULL,	/* 206 - undefined */
		NULL,	/* 207 - undefined */
		NULL,	/* 208 - undefined */
		NULL,	/* 209 - undefined */
		NULL,	/* 210 - undefined */
		NULL,	/* 211 - undefined */
		NULL,	/* 212 - undefined */
		NULL,	/* 213 - undefined */
		NULL,	/* 214 - undefined */
		NULL,	/* 215 - undefined */
		NULL,	/* 216 - undefined */
		NULL,	/* 217 - undefined */
		D218Ops, /* 218 - Canon LBP + LIPS3 */
		D219Ops, /* 219 - Canon CBJ + LIPS4 */
		NULL};

#define MAXDEV	219





/*-----------------------------------------------------------------------------
	StartJob function for all devices
-----------------------------------------------------------------------------*/
StartJob()
{
	int retval = 0;
	int (*routine)();


	if (PF.PfDev > MAXDEV || DevOps[PF.PfDev] == NULL)
		PFabort("Unsupported device");
	routine = DevOps[PF.PfDev][STARTJOB];
	if (routine != NULL)
	{
		retval = (*routine) (PF.PfBanner, PF.PfUser_name,
								NULL, PF.PfDoc_name,
								PF.PfDoc_date, &PF.PfShell_command);
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
	StdBanner displays the standard banner
-----------------------------------------------------------------------------*/
void StdBanner(font, pointsize, lmargin)
	char *font ;
	int pointsize, lmargin ;
{
	int len, wid ;
	int x_pos, y_pos, tmp, lbear, rbear;
	int dev_w, dev_h, ch_w, ch_h ;
	textAttrs txAtts;
	unsigned int flags;
	XFontStruct *fs;
	tx_char *textstr = (tx_char *) 0;

	/* true as in "1st physical page of output this job" */
	NewPage(TRUE, FALSE, FALSE, FALSE, (TmRect32 *)0, (TmRect32 *)0);

	dev_w = PF.PfPageMilWidth;
	dev_h = PF.PfPageMilHeight;

/* let's change this PLEASE!!!
	Say, 24 point Times?
*/
	/* use a reasonable default text attr like 12pt Courier */
	if (font == NULL)
		txAtts.fontFamily = axDefaultMonospaceFont;
	else
		txAtts.fontFamily = font;
	txAtts.pointsize = pointsize * 10000; /* in 10000ths of a pt */
	flags = TXfontFamily | TXpointsize;
	/* get printer metrics struct for this */
	if (!getPFontStruct(txAtts.fontFamily, 0, 0, &fs))
	{
		return;
	}
	/* get overall font height, and spacechar width, both in mills */
	ch_w = mToMils(milliemCharWid((tx_char)(' '), fs, &lbear, &rbear),
					(float) pointsize);
	ch_h = mToMils(milliemFontHeight(fs, &tmp), (float) pointsize);

	/* get banner text and draw it */
	len = makeBannerString(XLT("Document: "), PF.PfDoc_name, &textstr) ;
	wid = AXTextWidth(fs, (char *)textstr, len) ;
	wid = mToMils(wid, (float)pointsize) ;

	x_pos = (dev_w - len*ch_w) / 2 ;
	x_pos = (dev_w - wid) / 2 ;
x_pos = lmargin ;
	y_pos = (dev_h / 3) + ch_h;
	pfDrawText(textstr, len, x_pos, y_pos, &txAtts, flags);

	len = makeBannerString(XLT("User: "), PF.PfUser_name, &textstr) ;
	wid = AXTextWidth(fs, (char *)textstr, len) ;
	wid = mToMils(wid, (float)pointsize) ;
	x_pos = dev_w - (500 + len*ch_w) ;
	x_pos = dev_w - (500 + wid) ;
x_pos = lmargin ;
	y_pos = dev_h - (9 * ch_h);
	pfDrawText(textstr, len, x_pos, y_pos, &txAtts, flags);

	len = makeBannerString(XLT("Host: "), PF.PfHost_name, &textstr) ;
	wid = AXTextWidth(fs, (char *)textstr, len) ;
	wid = mToMils(wid, (float)pointsize) ;
	x_pos = dev_w - (500 + len*ch_w) ;
	x_pos = dev_w - (500 + wid) ;
x_pos = lmargin ;
	y_pos += ch_h + ch_h;
	pfDrawText(textstr, len, x_pos, y_pos, &txAtts, flags);

	len = makeBannerString(XLT("Date: "), PF.PfDoc_date, &textstr) ;
	wid = AXTextWidth(fs, (char *)textstr, len) ;
	wid = mToMils(wid, (float)pointsize) ;
	x_pos = dev_w - (500 + len*ch_w) ;
	x_pos = dev_w - (500 + wid) ;
x_pos = lmargin ;
	y_pos += ch_h + ch_h;
	pfDrawText(textstr, len, x_pos, y_pos, &txAtts, flags);


	if (textstr)
		free (textstr);
}

/*-----------------------------------------------------------------------------
	makeBannerString
-----------------------------------------------------------------------------*/
static int makeBannerString(s1, s2, wideStr)
	char *s1, *s2 ;
	tx_char **wideStr;
{
	int len ;
	char *narrowStr ;

	len = strlen(s1) + strlen(s2) ;
	narrowStr = malloc(len+1) ;
	sprintf(narrowStr,"%s%s", s1, s2) ;
	widenBannerText(narrowStr, wideStr) ;
	free(narrowStr) ;
	return len ;
}

/*-----------------------------------------------------------------------------
	widenBannerText

	!!0 this is supposed to be temporary..	Note treatment of
		wideStr -- caller must free if nonnull
-----------------------------------------------------------------------------*/
static void	widenBannerText(narrowStr, wideStr)
	char *narrowStr;		/* in */
	tx_char **wideStr;	/* out: write this as wide char copy of narrowStr */
{
	register int ix;
	register int len;

	if (!narrowStr || !wideStr)
		return;
	if (*wideStr)
	{
		free( *wideStr);
		*wideStr = (tx_char *) 0;
	}
	len = strlen(narrowStr);
	if (len > 0)
	{
		*wideStr = (tx_char *) malloc (len * sizeof(tx_char));
		for (ix = 0; ix < len; ix++)
		{
			(*wideStr)[ix] = (tx_char) narrowStr[ix];
		}
	}
}

/*-----------------------------------------------------------------------------
 * EndJob function for all devices
-----------------------------------------------------------------------------*/
EndJob()
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][ENDJOB];
		if (routine != NULL)
		{
			retval = (*routine) ();
		}
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
 * NewPage function for all devices
-----------------------------------------------------------------------------*/
NewPage(firstPage, use_crops, use_regis, use_bounds, bounds, clip)
	int firstPage; /* bool: true for 1st physical page of printed output */
	int use_crops, use_regis, use_bounds;
	TmRect32 *bounds, *clip;
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][NEWPAGE];
		if (routine != NULL)
			(*routine)(firstPage, clip);

		if ( use_crops || use_regis || use_bounds )
		{
			routine = DevOps[PF.PfDev][PRINTMARKS];
			if (routine != NULL)
				retval = (*routine)(use_crops, use_regis, use_bounds, bounds);
		}
	}

	/* new page so clear scaled text flag too */
	PF.PfPage.scaledText = FALSE;
	return(retval);
}

/*-----------------------------------------------------------------------------
 * SetPos function for all devices
-----------------------------------------------------------------------------*/
SetPos(new_x, new_y)
int new_x, new_y;
{
	int retval = 0;
	int (*routine)();

	if (!PF.PfText_ok)
		return(0);

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][SETPOS];
		if (routine != NULL)
		{
			retval = (*routine) (new_x, new_y);
		}
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
DrawAxText(textstr, txlen, pos, width, fontName,
			underPos, underThick, strikePos, txProps, fieldProps,
			xZoom, yZoom, clip)
	tx_char *textstr;
	int txlen;
	p32 *pos;
	int width;
	char *fontName;
	int underPos;
	int underThick;
	int strikePos;
	textAttrs *txProps, *fieldProps;
	int xZoom, yZoom;
	TmRect32 *clip ;
{
	tx_char *tx;
	int tlen, startix;
	int (*routine)();
	int retval = 0;
	
	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][DRAWAXTEXT];
		if (routine != NULL)
		{
			/* first, trim off any leading or trailing newlines/tabs
			 */
			tlen = txlen;
			startix = 0;
			tx = &textstr[startix];
			pfTrimText(tx, &startix, &tlen);
			tx = &textstr[startix];
			
			retval = (*routine) (tx, tlen, pos, width, fontName,
								 underPos, underThick, strikePos,
								 txProps, fieldProps, xZoom, yZoom, clip);
		}
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
	pfGetTextSegTransform
	
	combine this segment's transform with
	that of the overall field
	report whether resultant transform is unity
-----------------------------------------------------------------------------*/
int pfGetTextSegTransform(segProps, fieldProps, xZoom, yZoom, xform)
	textAttrs *segProps;	/* in: properties for this text segment */
	textAttrs *fieldProps;	/* in: properties for the overall text field */
	int xZoom, yZoom;		/* in: zoom factor relative to ref val 100 */
	axform *xform;			/* out: fill in with {segxform * fieldxform} */
{
	axformTerms local, field;
	axform combinedXform;

		/* init local, field xform expressions */
	local.angle = segProps->angle;
	local.xscale = segProps->xscale;
	local.yscale = segProps->yscale;
	local.xshear = segProps->xshear;
	local.unity = xformIsUnity(&local);
	field.angle = fieldProps->angle;
	field.xscale = fieldProps->xscale;
	field.yscale = fieldProps->yscale;
	field.xshear = fieldProps->xshear;
	field.unity = xformIsUnity(&field);
	axtWriteTargetCtm(xZoom, yZoom, &local, &field, &combinedXform);
		/* report ctm terms */
	*xform = combinedXform;
	return(combinedXform.unity);
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
static int xformIsUnity(xform)
	axformTerms *xform;
{
	if (xform->angle == 0 && xform->xscale == 10000 &&
		xform->yscale == 10000 && xform->xshear == 0)
	{
		return TRUE;
	}
	else
		return FALSE;
}



/*-----------------------------------------------------------------------------
	pf_clip
	
-----------------------------------------------------------------------------*/
pf_clip()
{

	TmRect32 clip ;
	int retval = 0;
	int (*routine)();

	InBlock((char *)&clip, sizeof(clip)) ;

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][DRAWCLIP];
		if (routine != NULL)
			retval = (*routine)(&clip);
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
	pf_prcontrol	
-----------------------------------------------------------------------------*/
pf_prcontrol()
{
	char buf[512] ;
	int retval = 0;
	int (*routine)();
	int n, k ;

	n = InInt() ;
	k = InInt() ;
	InBlock(buf, k) ;
	buf[k] = 0 ;
	InAlign() ;

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][PRCONTROL];
		if (routine != NULL)
			retval = (*routine)(n, buf);
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
int DrawLine (nPolys, attr, pol, clip)
	int nPolys;
	attr_type *attr;
	poly_type *pol;
	TmRect32 *clip ;
{
	int retval = 0;
	int (*routine)();

	/* HACK ALERT!!! - not changing line draw routines for all dev's */
	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][DRAWLINE];
		if (routine != NULL)
			retval = (*routine)(nPolys, attr, pol, clip);
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
int DrawArc(bbox, start_angle, arc_angle, attr)
	TmRect32 *bbox;
	int start_angle, arc_angle;
	attr_type *attr;
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
/*	5 Feb 93	SJP	Change this! (then all the DnnLine()s can go away...) */
		if (PF.PfDev == 45)
		{
			/* use old draw line code */
			routine = DevOps[PF.PfDev][DRAWLINE];
		}
		else
		{
			routine = DevOps[PF.PfDev][DRAWARC];
		}
		if (routine != NULL)
		{
			retval = (*routine) (bbox, start_angle, arc_angle, attr);
		}
	}
	return(retval);
}


/*-----------------------------------------------------------------------------
 *	GrfStart function for all devices
-----------------------------------------------------------------------------*/
int GrfStart (x, y, width, height)
	int x, y, width, height;
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][GRFSTART];
		if (routine != NULL)
		{
			retval = (*routine) (x, y, width, height);
		}
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
 *	GrfEnd function for all devices
-----------------------------------------------------------------------------*/
int GrfEnd ()
{
	int retval = 0;
	int (*routine)();

	PF.PfText_ok = TRUE;

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][GRFEND];
		if (routine != NULL)
		{
			retval = (*routine) ();
		}
	}
	return(retval);

}

/*-----------------------------------------------------------------------------
 * DrawGraf function for all devices
-----------------------------------------------------------------------------*/
int DrawGraf( bmid, xoff, yoff, index )
	int bmid, xoff, yoff, index;
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][DRAWGRAF];
		if (routine != NULL)
		{
			retval = (*routine) (bmid, xoff, yoff, index);
		}
	}
	return(retval);
}


/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
int
ClrBox (x, y, w, h)
int x, y, w, h;
{
	int retval = 0;
	int (*routine)();
	int corner_x, corner_y;

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][CLRBOX];
		if (routine != NULL)
		{
			corner_x = x + w;
			corner_y = y + h;
			if (x < PF.PfPage.appClip.origin.x)
				x = PF.PfPage.appClip.origin.x;
			if (y < PF.PfPage.appClip.origin.y)
				y = PF.PfPage.appClip.origin.y;
			if (corner_x > PF.PfPage.appClip.corner.x)
				corner_x = PF.PfPage.appClip.corner.x;
			if (corner_y > PF.PfPage.appClip.corner.y)
				corner_y = PF.PfPage.appClip.corner.y;
			if (corner_x > x && corner_y > y)
				retval = (*routine) (x, y, corner_x - x, corner_y - y);
		}
	}
	return(retval);
}


/*-----------------------------------------------------------------------------
 *	PutImage function for all devices
-----------------------------------------------------------------------------*/
int PutImage (x, y, imP, mode, xform, cmap, attr, clip)
	int x, y;
	ge_image_type *imP;
	int mode;
	poly_type *xform;
	cmap_type *cmap;
	attr_type *attr;
	TmRect32 * clip ;
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][PUTIMAGE];
		if (routine != NULL)
		{
			retval = (*routine) (x, y, imP, mode, xform, cmap, attr, clip);
		}
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
	SetSEClip - sets the app clip in the print graphics context
-----------------------------------------------------------------------------*/
int SetSEClip(clipRect, x, y, last_x, last_y)
	AxRectangle *clipRect;	/* current app clip */
	int x, y, last_x, last_y;	/* coordinates for new clip */
{
	int retval = 0;
	int (*routine)();
	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][SETCLIP];
		if (routine != NULL)
			retval = (*routine)(clipRect, x, y, last_x, last_y);
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
	pf_save
-----------------------------------------------------------------------------*/
int pf_save()
{

	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][SAVE_STATE];
		if (routine != NULL)
			retval = (*routine)();
	}
	return(retval);
}

/*-----------------------------------------------------------------------------
	pf_restore
-----------------------------------------------------------------------------*/
int pf_restore()
{
	
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][RESTORE];
		if (routine != NULL)
			retval = (*routine)();
	}
	return(retval);
}


/*-----------------------------------------------------------------------------
	pfLandscape
-----------------------------------------------------------------------------*/
int pfLandscape()
{
	int retval = 0;
	int (*routine)();

	if (DevOps[PF.PfDev] != NULL)
	{
		routine = DevOps[PF.PfDev][LANDSCAPE];
		if (routine != NULL)
			retval = (*routine)();
	}
	return(retval);
	
}

/*-----------------------------------------------------------------------------
	pfDrawText - monotext print call.	text needs to have
	single attribute description, and no per-char offsets,
	sups, kerns.	No zoom.
-----------------------------------------------------------------------------*/
void pfDrawText(textstr, len, x, y, atts, flags)
	tx_char *textstr;
	int len, x, y;		/* text length in chars, position in mils */
	textAttrs *atts;		/* text attributes */
	unsigned int flags;	/* flags for attributes */
{
	axtext txt;
	textAttrs *segAtts, fieldAtts;
	p32 pos;
	register int width;
	register int ix;
	int numSegs;
	char *errStr, *constructForPrint();
	int insChars(), setDefaultTextAttrs(), getTextAttrs();
	void daxtext(), setPos();
	void freeTextAttrs();

	if (!textstr || !len)
		return;

	memset((char *) &txt, 0, sizeof(txt));				/* start clean */
	setDefaultTextAttrs(&txt, atts, flags);				/* set attr */
	insChars(&txt, textstr, 0, len);					/* add string */
	pos.x = x;
	pos.y = y;

	if (errStr = constructForPrint(&txt))
	{
		freeErrString(errStr);
		return;
	}
		/* get the untransformed printer width for text */
	for (ix = 0, width = 0; ix < txt.whole.nChars; ix++)
	{
		width += txt.items[ix].padvance;
	}
		/* get thorough atts for 0th (only) att segment */
	segAtts = (textAttrs *) NULL;
	getTextAttrs(&txt, 0, txt.whole.nChars, &segAtts, &numSegs);
		/* get overall field atts (this is just xform terms) */
	memset((char *) &fieldAtts, 0, sizeof(fieldAtts));
	axtGetFieldTransform(&txt, &fieldAtts);
		/* call pf monotext painter */
	DrawAxText(textstr, len, &pos, width,
				txt.atts[0].fontAttr.fontName,
				txt.atts[0].fontAttr.underlinePosition,
				txt.atts[0].fontAttr.underlineThickness,
				strikeThruOffset(&(txt.atts[0])), segAtts,
				&fieldAtts, 1000, 1000, NULL);
	freeTextAttrs(segAtts, numSegs);
	daxtext(&txt);										/* destruct */
}

/*-----------------------------------------------------------------------------
	pfDrawLineSeg
-----------------------------------------------------------------------------*/
void pfDrawLineSeg(x1, y1, x2, y2, thickness, attr, cmyk, clip)
	int x1, y1, x2, y2, thickness;		/* mils */
	attr_type *attr;
	int cmyk;
	TmRect32 *clip ;
{
	poly_type stroke;
	attr_type *tp, *props;
	TmPoint32 line[2];

	if (!attr ||
			/* we get this garbage, once in a while */
			(attr->l_type == BUILTIN_FILL_TYPE && attr->l_pat == -1))
	{
			/* use solid fill as default */
		tp = (attr_type *) malloc(sizeof(attr_type));
		memset((char *) tp, 0, sizeof(attr_type));
		tp->l_style = TM_SOLID;
		tp->l_type = GRAY_FILL_TYPE;	/* screen fill */
		tp->l_pat = 1000;				/* of 100% foreground */
		tp->mode = TMS;
		tp->l_cap = TM_CAP_BUTT;
		
			/* set color */
		tp->use_lfg = FALSE;	/* that is, use these supplied vals */
		tp->use_lbg = FALSE;
		tp->lfg.c = axCyanComponent(cmyk);
		tp->lfg.m = axMagentaComponent(cmyk);
		tp->lfg.y = axYellowComponent(cmyk);
		tp->lfg.k = axBlackComponent(cmyk);
		tp->lfg.see_thru = FALSE;
		tp->lfg.ink_type = 0;

		tp->lbg.c = 0;	/* white */
		tp->lbg.m = 0;
		tp->lbg.y = 0;
		tp->lbg.k = 0;
		tp->lbg.see_thru = FALSE;
		tp->lbg.ink_type = 0;

		props = tp;
	}
	else
	{
		tp = (attr_type *) NULL;
		props = attr;
	}

/*	props->l_wid = xmiltopix(thickness);
*/
	props->l_wid = thickness ;


	/* specify end points */
	line[0].x = xmiltopix(x1);
	line[0].y = ymiltopix(y1);
	line[1].x = xmiltopix(x2);
	line[1].y = ymiltopix(y2);
	stroke.nPoints = 2;
	stroke.nCtrls = 0;
	stroke.points = line;
	stroke.controls = (TmPoint32 *)NULL;

	DrawLine(1, props, &stroke, clip);

	if (tp)
	{
		pfFreeFillPattern(tp);
	}
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
void pfDrawRuling(from, to, segAtts, xform, underPos, underThick, strikePos, clip)
	p32 *from, *to;			/* in: tentative ruling endpoints */
	textAttrs *segAtts;		/* in */
	axform *xform;			/* in */
	int underPos;			/* in: base-rel underline position in mils */
	int underThick;			/* in: in mils */
	int strikePos;			/* in: in mils */
	TmRect32 *clip ;
{
	p32 thickness, offset, strikeoffset;
	p32 tfrom, tto;
	int strokewidth;
	attr_type *rul_attr = (attr_type *) NULL;

	thickness.x = offset.x = strikeoffset.x = 0;
	thickness.y = underThick;
	offset.y = underPos;
	if (thickness.y == 0)
		thickness.y = 50; /* most common in our core fontset */
	if (offset.y == 0)
		offset.y = 150;
	strokewidth = thickness.y;
	if (segAtts->strike_thru ) {
		strikeoffset.y = strikePos;
	}
	else {
		strikeoffset.y = 0;
	}
	if (!xform->unity) {
			/* account for the transform
				*/
		forwardSXRT(offset.x, offset.y, &offset.x, &offset.y, xform);
		forwardSXRT(thickness.x, thickness.y, &thickness.x, &thickness.y,
					xform);
		forwardSXRT(strikeoffset.x, strikeoffset.y, &strikeoffset.x,
					&strikeoffset.y, xform);
		strokewidth = (int) hypot((double) thickness.x, (double) thickness.y);
	}
	
	if (segAtts->fillpattern) {
			/* ruling done via line segs; fill attr data is
				* the only pattern data used for text; so, copy
				* text's fill data onto the line pattern portion
				* of the attr used for ruling
				*/
		rul_attr = (attr_type *) malloc(sizeof(attr_type));
		memset((char *) rul_attr, 0, sizeof(attr_type));
		pfCopyFillPattern(segAtts->fillpattern, &rul_attr);
		linePatFromFillPat(rul_attr);
	}
	if (segAtts->strike_thru ) {
		tfrom.x = from->x + strikeoffset.x;
		tfrom.y = from->y + strikeoffset.y;
		tto.x = to->x + strikeoffset.x;
		tto.y = to->y + strikeoffset.y;
		pfDrawLineSeg(tfrom.x, tfrom.y, tto.x, tto.y, strokewidth,
						rul_attr, segAtts->fillcolor, clip);
	}
	if (segAtts->ruling & AXRULING_SINGLE ||
		segAtts->ruling & AXRULING_DOUBLE) {
		
		tfrom.x = from->x + offset.x;
		tfrom.y = from->y + offset.y;
		tto.x = to->x + offset.x;
		tto.y = to->y + offset.y;
		pfDrawLineSeg(tfrom.x, tfrom.y, tto.x, tto.y, strokewidth,
						rul_attr, segAtts->fillcolor, clip);
	}
	if (segAtts->ruling & AXRULING_DOUBLE) {
		tfrom.x = tfrom.x + (3 * thickness.x);
		tfrom.y = tfrom.y + (3 * thickness.y);
		tto.x = tto.x + (3 * thickness.x);
		tto.y = tto.y + (3 * thickness.y);
		pfDrawLineSeg(tfrom.x, tfrom.y, tto.x, tto.y, strokewidth,
						rul_attr, segAtts->fillcolor, clip);
	}
	if (rul_attr) {
		pfFreeFillPattern(rul_attr);
	}
}

/*-----------------------------------------------------------------------------
	pfFreeTextAttrs - free up an array of textAttr structs;
	this is copied from axtext.c just to appease task id checking
	in tmzmalloc..
-----------------------------------------------------------------------------*/
void pfFreeTextAttrs(atts, len)
	textAttrs *atts;
	int len;
{
	int i;
	if (!atts)
		return;
	for (i=0; i< len; i++)
	{
		if (atts[i].fontFamily)
		{
			free(atts[i].fontFamily);
			atts[i].fontFamily = NULL;
		}
		if (atts[i].strokepattern)
			pfFreeFillPattern(atts[i].strokepattern);
		if (atts[i].fillpattern)
			pfFreeFillPattern(atts[i].fillpattern);
	}
	free(atts);
	atts = (textAttrs *) NULL;
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
void pfFreeFillPattern(attr)
	attr_type *attr;
{
	if ( attr->f_data )
	{
		free(attr->f_data);
		attr->f_data = NULL;
	}
	if ( attr->l_data )
	{
		free(attr->l_data);
		attr->l_data = NULL;
	}
	free(attr);
}

/*-----------------------------------------------------------------------------
	pfCopyFillPattern - also copied from axtext.c....
-----------------------------------------------------------------------------*/
void pfCopyFillPattern(from, to)
	attr_type *from;
	attr_type **to;
{
	attr_type *sattr, *dattr;
	int byte_wid, size;

	sattr = (attr_type *)from;
	dattr = (attr_type *)*to;
	*dattr = *sattr;

	/* fg fill color */
	if ( sattr->ffg.name )
	{
		dattr->ffg.name = (char *)malloc
			(strlen(sattr->ffg.name) + 1);
		strcpy(dattr->ffg.name, sattr->ffg.name);
	}

	/* bg fill color */
	if ( sattr->fbg.name )
	{
		dattr->fbg.name = (char *)malloc
			(strlen(sattr->fbg.name) + 1);
		strcpy(dattr->fbg.name, sattr->fbg.name);
	}

	/* fill data */
	if ( sattr->f_data && sattr->f_dhyt && sattr->f_dwid ) {
		if ( sattr->f_ddep	== 8 )
			byte_wid = sattr->f_dwid + sattr->f_dwid%2;
		else
			byte_wid = (sattr->f_dwid+7)/8 + ((sattr->f_dwid+7)/8)%2;
		size = sattr->f_dhyt * byte_wid;
		dattr->f_data = (char *)malloc(size);
		memcpy((char *)dattr->f_data, (char *)sattr->f_data, size);
	}

	/* fg line color */
	if ( sattr->lfg.name )
	{
		dattr->lfg.name = (char *)malloc
			(strlen(sattr->lfg.name) + 1);
		strcpy(dattr->lfg.name, sattr->lfg.name);
	}

	/* bg line color */
	if ( sattr->lbg.name )
	{
		dattr->lbg.name = (char *)malloc
			(strlen(sattr->lbg.name) + 1);
		strcpy(dattr->lbg.name, sattr->lbg.name);
	}

	/* line fill data */
	if ( sattr->l_data && sattr->l_dhyt && sattr->l_dwid ) {
		if ( sattr->l_ddep	== 8 )
			byte_wid = sattr->l_dwid + sattr->l_dwid%2;
		else
			byte_wid = (sattr->l_dwid+7)/8 + ((sattr->l_dwid+7)/8)%2;
		size = sattr->l_dhyt * byte_wid;
		dattr->l_data = (char *)malloc(size);
		memcpy((char *)dattr->l_data, (char *)sattr->l_data, size);
	}
}

/*-----------------------------------------------------------------------------
	a hack func used for doing text ruling in ax3.0; it's
	used because in 3.0 we don't generate outlines for
	text ruling.	The fix is to support outline text and to
	treat text ruling as outlines at print time.

	Write attr's line data as copy of fill data; ok for text
	attr data in 3.0 since we don't do text outlines..

	When adding outline capability, make sure that when
	the thinness of an underline forces a choice between
	underline fill and underline outline stroke, precedence
	is given to the fill; this will be the better choice for
	compatibility (since right now the fill attr is all that's
	getting through)
-----------------------------------------------------------------------------*/
void linePatFromFillPat(fill_attr)
	attr_type *fill_attr;	/* modified in place */
{
	int size;

	if (fill_attr)
	{
		fill_attr->l_type = fill_attr->f_type;
		fill_attr->l_pat = fill_attr->f_pat;
		fill_attr->use_lfg = fill_attr->use_ffg;
		fill_attr->use_lbg = fill_attr->use_fbg;
		fill_attr->lfg.c = fill_attr->ffg.c;
		fill_attr->lfg.m = fill_attr->ffg.m;
		fill_attr->lfg.y = fill_attr->ffg.y;
		fill_attr->lfg.k = fill_attr->ffg.k;
		fill_attr->lfg.see_thru = fill_attr->ffg.see_thru;
		fill_attr->lfg.ink_type = fill_attr->ffg.ink_type;

		if (fill_attr->ffg.name)
		{
			if (fill_attr->lfg.name)
			{
				free(fill_attr->lfg.name);
			}
			fill_attr->lfg.name = (char *) malloc
				(strlen(fill_attr->ffg.name) + 1);
			strcpy(fill_attr->lfg.name, fill_attr->ffg.name);
		}
		
#if 0
		fill_attr->fbg.c = fill_attr->lbg.c;
		fill_attr->fbg.m = fill_attr->lbg.m;
		fill_attr->fbg.y = fill_attr->lbg.y;
		fill_attr->fbg.k = fill_attr->lbg.k;
		fill_attr->fbg.see_thru = fill_attr->lbg.see_thru;
		fill_attr->fbg.ink_type = fill_attr->lbg.ink_type;

		if (fill_attr->fbg.name)
		{
			if (fill_attr->lbg.name)
			{
				free( fill_attr->lbg.name);
			}
			fill_attr->lbg.name = (char *) malloc
				(strlen(fill_attr->fbg.name) + 1);
			strcpy(fill_attr->lbg.name, fill_attr->fbg.name);
		}
#else
		
		fill_attr->lbg.c = fill_attr->fbg.c;
		fill_attr->lbg.m = fill_attr->fbg.m;
		fill_attr->lbg.y = fill_attr->fbg.y;
		fill_attr->lbg.k = fill_attr->fbg.k;
		fill_attr->lbg.see_thru = fill_attr->fbg.see_thru;
		fill_attr->lbg.ink_type = fill_attr->fbg.ink_type;

		if (fill_attr->fbg.name)
		{
			if (fill_attr->lbg.name)
			{
				free( fill_attr->lbg.name);
			}
			fill_attr->lbg.name = (char *) malloc
				(strlen(fill_attr->fbg.name) + 1);
			strcpy(fill_attr->lbg.name, fill_attr->fbg.name);
		}
#endif
		if (fill_attr->f_data && fill_attr->f_dhyt &&
			fill_attr->f_dwid)
		{
			if (fill_attr->l_data)
			{
				free(fill_attr->l_data);
			}
			size = fill_attr->f_dhyt * ((fill_attr->f_dwid + 7) / 8);
			fill_attr->l_data = (char *) malloc(size);
			memcpy((char *) fill_attr->l_data, (char *)
					fill_attr->f_data, size);
		}

		fill_attr->line_flag = fill_attr->fill_flag;
		fill_attr->line_abs = fill_attr->fill_abs;
		fill_attr->use_lfg = fill_attr->use_ffg;
		fill_attr->use_lbg = fill_attr->use_fbg;
	}
}


/*-----------------------------------------------------------------------------
	 pfTrimText - sub called by DrawAxText.  Reduce passed
 * starting index and run length to trim out non-graphic
 * (CHAR_IS_DIMENSIONLESS) characters.  Work on the ends of
 * range only; don't worry about the middle.
-----------------------------------------------------------------------------*/
static void pfTrimText(txstr, startix, len)
	tx_char *txstr;                     /* in */
	int *startix;                       /* in/out */
	int *len;                           /* in/out */
{
	int ix, tix;
	int endix;

	tix = *startix;
	endix = *startix + *len - 1;
	
	/* trim upstream side
	 */
	for (ix = tix; ix <= endix; ix++) {
		if (CHAR_IS_DIMENSIONLESS((int) txstr[ix])) {
			(*startix)++;
			(*len)--;
		}
		else {
			break;
		}
	}
	
	if (*startix > endix) {
		*startix = endix;
		if (*len < 0)
			*len = 0;
		return;
	}
	
	/* trim downstream side
	 */
	tix = *startix;
	for (ix = endix; ix >= tix; ix--) {
		if (CHAR_IS_DIMENSIONLESS((int) txstr[ix])) {
			(*len)--;
		}
		else {
			break;
		}
	}
	
	if (*len < 0)
		*len = 0;
}

pf_display_reg_string(font_family, edge_x1, edge_y1)
char *font_family;
int edge_x1, edge_y1;
{
    char reg_str[STRPATH];
    tx_char tx_str[32];
    unsigned int flags;
    textAttrs atts;
    int i, vnum, maj_ver, min_ver, len;

	flags = TXfontFamily | TXpointsize | TXangle;
	atts.fontFamily = font_family;
	atts.pointsize  = 180000;
	atts.angle = 2700000;

	vnum = AGetCurrentVersion();
	maj_ver = vnum /100; 
	min_ver = vnum %100; 
	min_ver = min_ver/10; 
	sprintf(reg_str, "Applixware %d.%d", maj_ver, min_ver);
	len = strlen(reg_str);
	for ( i=0; i< len; i++ )
		tx_str[i] = (tx_char)(unsigned char)reg_str[i];
	pfDrawText(tx_str, len, edge_x1, edge_y1, &atts, flags);
}
