/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ssrt.h
   Applix ASC version: 16
   Date: Mon Nov 16 13:56:52 1998
*/
#define SSRT_STATUS_COL 0
#define SSRT_NAME_COL 1
#define SSRT_DATA_COL 2

#define RT_SEP_CHAR 0x1E

#define SSRTSTAT_RT	0.0		/* registered, alive and well */
#define SSRTSTAT_RTI 1.0	/* registered, alive and well , but an RtInsert*/
#define SSRTSTAT_REGISTERING 2.0 /* registered, not yet received value */
#define SSRTSTAT_DELETED -1.0	/* unregistered, RTS func will re-register */
#define SSRTSTAT_STALE -2.0	/* unregistered, RTS func uses old values */

/* TODO list codes */

#define SS_TODO_CELL_ATTRS 1
#define SS_TODO_RT_REGISTER 2
#define SS_TODO_MV_DATA	3		/* Market visions get data list */
#define SS_TODO_NOW_UPDATE	4	/* NOW function update every interval time */

#define AXSSMV	NXLT("axmv")	/* name of Market visions */

/* the RtInsert utilities macros */
#define SS_IS_RTI_CELL(x)		(((cell_value *)(ssP->OM.ptrs[x]))->plate_idx ==(RTIN_PLATE - FIRST_PLATE))
#define SS_SET_RT_OD_STATUS(x,y) (((cell_value *)(ssP->OM.ptrs[x]))->isRtODCell = y)
#define SS_IS_OD_CELL(x) 		(((cell_value *)(ssP->OM.ptrs[x]))->isRtODCell)
#define SS_SET_FORCE_RT(x, y) 	(((cell_value *)(ssP->OM.ptrs[x]))->forceRtCalc = y)
#define SS_HAS_FORCE_RT(x) 		(((cell_value *)(ssP->OM.ptrs[x]))->forceRtCalc)
#define SS_SET_RT_COMP_HASH(x,y) (((cell_value *)(ssP->OM.ptrs[x]))->reComputeHashRow=y)
#define SS_RT_COMP_HASH(x) 		(((cell_value *)(ssP->OM.ptrs[x]))->reComputeHashRow)
#define SS_RT_COUNT(x) 			(((formula_value *)(ssP->OM.ptrs[x]))->rtCount)
#define SS_RT_HASH_ROW(x) 		(((cell_formula_value *)(ssP->OM.ptrs[x]))->rtRow)
#define SS_SET_RT_HASH_ROW(x,y) 		(((cell_formula_value *)(ssP->OM.ptrs[x]))->rtRow = y)

#define SS_SET_RTINSERT_STATUS(x,y) (((cell_value *)(ssP->OM.ptrs[x]))->isRtInsertCell = y)
#define SS_IS_RTINSERT_CELL(x) 		(((cell_value *)(ssP->OM.ptrs[x]))->isRtInsertCell)

/* sub message codes used in send_message@ object applications */
#define OBJECT_RT_DATA_ITEM		0	/* message contains real time data */
#define OBJECT_RT_LINK_LIVE		1	/* message is to tell that server is live again */
#define OBJECT_RT_LINK_DIED		2	/* message is to tell that server is dead */

#define MAX_HASH_STR	(2*MAX_CELLSTR)
