/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: genfile.c
   Applix ASC version: 18
   Date: Mon Nov 16 13:57:09 1998
*/
#include <stdio.h>
#if M_88K || X386_NEW || CLIX || SYSV4
#include <sys/types.h>
#include <sys/fcntl.h>
#endif
#if AUX
#include <sys/types.h>
#endif

#if AXMS
#include <fcntl.h>
#else
#include <sys/file.h>
#endif

#include <errno.h>

#define NO_APX_INTERNATIONAL    /* turn off aos.h stuff */

#include <utloc.h>
#include <exitcode.h>
#include <gengetst.h>

int fmtSpec;
char category[8],numstr[10],valu[500];
int fd;
int CurrCategory = 0;
int StringOffset = -1;
int CurrDataBlock = 0;
int line_no = 0;
 
struct {
    short curr0Categ;
    short ixValue0[BLK0MAX];
    short categBlk[MAXCATEG];
} blk0;
 
struct {
    short currCateg;
    short ixValue[BLK1MAX];
} ixblk;
 
struct {
    short dataBlkNum;
    unsigned char stringStuff[DATABLKSZ];
}  datablk;
 
#ifdef getenv
#undef getenv
#endif

char *getenv();


main(argc,argv)
int argc;
char *argv[];
{

    char buff[1024], original_string[500], new_string[500];
    char output_file[1025];
    char temp_buff[1024];
    int no_closing_quote;
    char *p1, *p2, *p3;
    int in_comment = 0;
    int value;
    int have_category = 0;

    if ( getenv("STRFL_DEBUG") != (char *)NULL )
       {
       value = 99;
       while ( value == 99 )
           {
           /* wait for dbxtool */
           value = 99;  
           }
       }

    if(argc < 2) 
        {
        fprintf(stderr,"input file not specified" );
        exit(EXIT_FAILURE);
        }
    if(!freopen(argv[1],"r",stdin)) 
        {
        fprintf(stderr,"not able to open input file <%s>",argv[1]);
        exit(EXIT_FAILURE);
        }

    if ( argc >= 3 )
        {
        /* get the filename of the real output file name                */
        strcpy( output_file, argv[2] );
        }
    else
        /* no touch file, must be English */
         strcpy( output_file, STRFLNM );


#if AXMS
    fd = open(output_file, O_RDWR|O_CREAT|O_TRUNC|O_BINARY, S_IREAD|S_IWRITE);
#else       
    fd = open(output_file,O_RDWR|O_CREAT|O_TRUNC,0744);
#endif  /* DAMNT */
    if(fd == -1) 
        {
        fprintf (stderr,"*******---->create error of <%s>, errno=%d\n", 
                                          STRFLNM, errno);
        exit(EXIT_FAILURE);
        }
    setup();

    while( fgets( buff, 1024, stdin ) != NULL )
       {
       line_no++;
       if ( strlen( buff ) <= (unsigned)1 )
          {
          /* blank line, just output a blank line */  
          continue;
          }

       if ( strncmp( buff, "!BEG", 4 ) == 0 )
          {
          /* special "start" key, no longer used */
          continue;
          }

       if ( (buff[0] == '#') || (buff[0] <= ' ') )
          {
          /* a comment line */
          continue;
          }

      if ( (buff[0] >= '0') && (buff[0] <= '9') && !have_category )
          {
          /* line starts with a digit, may be the "-CATEGORY-" line */
          p1 = buff;
          while ( *p1 != '-' )
             {
             if ( *p1 == '\n' )
                {
                /* hit newline, not "-CATEGORY-" line */
                goto regular_line;
                }
             p1++;
             }
          /* just to make sure */
          if ( strncmp( p1, "-CATEGORY-", 9 ) != 0 )
              {
              /* did not match "-CATEGORY-" */
              goto regular_line;
              }

          /* we have the category line, get the category number */
          p1 = buff;
          while ( (*p1 >= '0') && (*p1 <= '9') )
             {
             p1++;
             }
          *p1 = '\0';    /* step on char after category number */
          CurrCategory = newcat( buff );
          continue;
          }


regular_line:
      /* This should be a line composed of an identifier, a value, and
      *    a string enclosed in quotes.  
      *  We want to split the line up to get the value and  
      *    the string.                                            */
      p1 = buff;
      while ( *p1 > ' ' )
         {
         /* find the end of the identifier string */
         p1++;
         }
      while ( *p1 <= ' ' )
         {
         /* look for the start of the value  */
         p1++;
         }

      p2 = p1;           /* p1 points to start of the value  */
      while ( (*p2 >= '0') && (*p2 <= '9') )
         {
         /* look for the end of the value */
         p2++;
         }
      *p2 = '\0';

      /* make sure the value is all digits.  Some old comments start
      *    in column 1  !!    */
      if ( strlen(p1) == 0 )
         {
         goto bottom_loop;
         }
      p3 = p1;
      while ( *p3 != '\0' )
         {
         if ( (*p3 < '0') || (*p3 > '9') )
            goto bottom_loop;
         p3++;
         }

      value = atoi( p1 );

      while ( *p2 <= ' ' ) 
         { 
         /* look for the start of the text string */
         p2++;
         } 
      *p2++;    /* skip the opening quote */

      /*now we make sure we have a closing quote, if not, we read the next
      *   line, and add it to this one till we get a closing quote  */
      no_closing_quote = 1;
      while ( no_closing_quote )
         {
         p1 = p2 + strlen(p2) - 1;   /* end of the string */
         if ( *p1 == '\n' )
             {
             *p1 = '\0';       /* step on the newline */
             }
         p1 = p2;              /* start of the text string */
         while ( *p1 != '\0' )
             {
             if ( *p1 == '\\' )
                {
                /* escape (ie. skip and don't look at) the next character */
                p1++;
                }
             else if ( *p1 == '"' )
                {
                /* we found the end of the string */
                no_closing_quote = 0;
                *(p1+1) = '\0';     /* cut off any remainder */
                goto good_string;
                }
             p1++;
             }

         /* fell through, get the next string */
         fgets( temp_buff, 1024, stdin );
         strcat( p2, temp_buff );
         }
         
good_string:
      strcpy( original_string, p2 );

      /* now we process through the string to handle the the embedded
      *    escape sequences                             */
      process_string( original_string, new_string );
      output_string( value, CurrCategory, new_string );

bottom_loop:
      p1 = p2;    /* dummy statement for the goto label */

      }   /* end of while reading lines from file */

   finishfl();

   exit(0);
}



fix_shorts( blockP, num_shorts )
unsigned char *blockP;
int num_shorts;
{
    /* we write all of the binary short information out in big-endian order */
    /* regardless of the particular machine architecture.  When we read this */
    /* back in, we convert back tothe native machine representation of a     */
    /* short.  This allows stringfiles to be portable across all machines    */

    unsigned short *shortP;
    unsigned char *byteP;
    short short_val;
    int i;

    byteP = (unsigned char *)blockP;
    shortP = (unsigned short *)blockP;
    for ( i=0; i<num_shorts; i++ )
       {
       short_val = *shortP;
       *byteP = (short_val & 0xFF00) >> 8;
       byteP++;
       *byteP = (short_val & 0xFF);
       byteP++;
       shortP++;
       }
 
    return;
}





process_string( instr, outstr )
char *instr, *outstr;
{
    char *p1, *p2, *p3, *tp;
    char temp1[400];
    int byte_val;
    char *percent_pos;
 
    /* this file will convert the following embedded escape constructs:
    *   "<yyyy>" will be converted to "%s"
    *   "<yyyy%x>" will be converted to "%x"
    *   "\0123" will be converted to a byte, with the value 123 (ocatal)
    *   "\0x123" will be converted to a byte, with the value 123 (hex)
    */

    p1 = instr;
    if ( *p1 == '"' )
      p1++;           /* skip the leading double quote */
    p2 = p1 + strlen(p1) - 1;
    while( *p2 != '"' )
        {
        /* strip off all chars until we get to the closing quote */
        *p2 = '\0';
        p2--;
        if ( p2 < p1 )
            {
            fprintf( stderr, "ERROR - no closing quote found, line %d:\n",
                                                  line_no);
            fprintf( stderr, "<%s>\n",instr);
            exit(EXIT_FAILURE);
            }
        }
    *p2 = '\0';    /* step on the closing quote   */

    /* first look for constructs of the form "\0123", we copy the
    *    string to "temp1" as we go                         */
    p2 = p1; 
    tp = temp1;
    while ( *p2 != '\0' )
       { 
       if ( (*p2 == '\\') && (*(p2+1) == '0') && 
            (*(p2+2) >= '0') && (*(p2+2) <= '9') &&
            (*(p2+3) >= '0') && (*(p2+3) <= '9') &&
            (*(p2+4) >= '0') && (*(p2+4) <= '9') )
          {
          /* we have backslash, followed by a zero, encode a byte */
          if ( (*(p2+2) == 'x') || (*(p2+2) == 'X') )
              {
              /* a hex string */
              byte_val = hexstr( p2+3 );
              }
          else
              {
              byte_val = octstr( p2+1 );
              }
          *tp++ = byte_val; 
          p2 = p2 + 5;              /* skip the sequence */
          }
       else
          {
          *tp++ = *p2++;
          }
       }
    *tp = '\0';

    /* now look for constructs of the form "<zzzz>", we copy the
    *    string to the output as we go                      */
    p2 = temp1;
    tp = outstr;
    while ( *p2 != '\0' )
       {
       if ( *p2 == '\\' )
            {
            /* an escape character */
            p2++;            /* skip the backslash             */
            *tp++ = *p2++;   /* put the escaped char in output */
            continue;
            }
       if ( *p2 == '<' )
            {
            /* we have found an embeded subsitiution sequence,
            * look for the end of the sequence */
            *tp++ = '%';             /* put percent in output */
            p3 = p2;                 /* start of <...>  */
            percent_pos = (char *)NULL;
            while ( *p3 != '>' )
                {
                if ( *p3 == '%' )
                   {
                   percent_pos = p3;
                   }
                p3++;
                }
            p2 = p3 + 1;    /* past closing ">"   */

            /* now see if there was as alternate format specified */
            if ( percent_pos != (char *)NULL )
                {
                /* alternate specified */
                *tp++ = *(percent_pos+1); 
                }
            else
                {
                *tp++ = 's';
                }
            }
        else
            {
            /* just a regular character */
            *tp++ = *p2++;
            }
        }
    *tp = '\0';       /* terminate the output string */
    return;
  }
 
                
    





/*------------------------------------------------*/
setup()
{
	int i = 0;

	while(i < MAXCATEG)
    	blk0.categBlk[i++] = -1;

	StringOffset = -1;
	blk0.curr0Categ = 0;
}

/*--------------------------------------------*/
int newcat(category_str)
char *category_str;
{
	int i = 0;
    int category_value;

	wrapup();
	category_value = atoi(category_str);
	blk0.categBlk[category_value] = CurrDataBlock;
	CurrDataBlock++;
	ixblk.currCateg = category_value;
	while(i < BLK1MAX)
        {
    	ixblk.ixValue[i++] = 0;
        }
    return( category_value );
}
/*-----------------------------------------------*/

output_string( value, category_value, str)
int value;
int category_value;
char str[];
{
	int     i;
	int       vallen;

	vallen = strlen(str) + 1;

#if 0
    printf("%s\n", str);
#endif
	/* Max size string is the minimum of the max signed num that be contained
	   in a byte and max num of characters that can fit in one data blk. */
	if((i = DATABLKSZ - 1) > 254)
        {
		i = 254;
        }
	if(vallen > i) 
        {
    	fprintf(stderr, "********---->category %s, string %s is too long!\n",
                                                       category, str);  /*here print str*/
    	vallen = i;
    	str[i - 1] = '\0';  /* force null terminator into reduced string. */
        }

	if(StringOffset + vallen >= DATABLKSZ)
        {
		wrapupdata();
        }


	ixblk.ixValue[value] = (((long)CurrDataBlock * DISCBLKSZ) + StringOffset) >> OFFSSHIFT;

	datablk.stringStuff[StringOffset] = vallen + 1;
	bcopy(str,&datablk.stringStuff[StringOffset + 1],vallen);
	
	StringOffset = ((StringOffset + vallen + 4) >> OFFSSHIFT) << OFFSSHIFT;
	/* make sure StringOffsetet is always 0 mod 4 so shift above
		   is always shifting out zeros.*/
}

/*---------------------------------------------*/
wrapupdata()
{
	long along;
    long CurrDataBlockL;
	extern off_t lseek();

    datablk.dataBlkNum = CurrDataBlock;
    CurrDataBlockL = CurrDataBlock;
    along = CurrDataBlockL * DISCBLKSZ;
    if(lseek(fd,along,0) == -1)
        {
        fprintf(stderr,"*******---->seek error %d, addr %ld, block %d\n",
                                               errno,along, CurrDataBlock);
        }
    fix_shorts( &datablk, 1 );

    if(write(fd,&datablk,DISCBLKSZ) == -1)
        {
        fprintf(stderr, "*******---->write error %d, fd %d, block %d\n",
                                               errno,fd,CurrDataBlock);
        }
    CurrDataBlock++;
    memset( &datablk, 0, sizeof(datablk) );
    StringOffset = 0;
}

/*--------------------------------------------------*/
wrapup()
{
	int i, wrap;
	long along;
	extern off_t lseek();

	if(StringOffset < 0) 
        {   
        /* first time, do nothing */
    	StringOffset = 0;
    	return(0);
        }

	wrap = 0;
	if(StringOffset) {  /*then there was at least one string in this category*/
		wrap = 1;
		wrapupdata();
    }
	if(!wrap) {  /* no messages in this category, don't waste disc space.*/
    	blk0.categBlk[CurrCategory] = -1;
    	CurrDataBlock--;
    }
	if(CurrCategory && wrap) { /*if there are strings and category not*/
						 /* 0, then must write indx blk. */
    	along = (long)blk0.categBlk[CurrCategory] * DISCBLKSZ;
		if(lseek(fd,along,0) == -1)
            {
        	fprintf(stderr, "*****---->seek cat ix blk error %d %d, errno %d\n",
               CurrCategory,blk0.categBlk[CurrCategory],errno);
            }
        fix_shorts( &ixblk, (DISCBLKSZ/sizeof(short)) );
    	if(write(fd,&ixblk,DISCBLKSZ) == -1)
            {
        	fprintf(stderr, "*****---->write cat ix blk error %d, block %d\n",
               errno,CurrDataBlock);
            }
    	StringOffset = 0;
    }

	if(!CurrCategory) {
    	for(i = 0; i < BLK0MAX; i++)
        	blk0.ixValue0[i] = ixblk.ixValue[i];
    }
}

/*-----------------------------------------------------*/
finishfl()
{
	extern off_t lseek();

	wrapup();
	lseek(fd,0L,0);
    fix_shorts( &blk0, (DISCBLKSZ/sizeof(short)) );
	write(fd,&blk0,DISCBLKSZ);
	if(close(fd))
        {
    	fprintf(stderr,"*******----->Cannot close output file, errno %d\n", errno );
        exit(EXIT_FAILURE);
        }
}

/*----------------------------------------------------------*/
hexstr(string)
char *string;
{
	int i, temp = 0;
    int c;

    for ( i=0; i<4; i++ )
        {
        c = *string;
		if('0' <= c && c <= '9')
			temp = c - '0';
		else if('a' <= c && c <= 'f')
			temp = c - 'a' + 9;
		else
			temp = c - 'A' + 9;
	    }
	return(temp);
}

/*----------------------------------------------------------*/
octstr(string)
char *string;
{
	int i,val = 0;

    val = 0;
    for ( i=0; i<4; i++ )
       {
       val = (val << 3) + (*(string+i) - '0');
       }

    return( val );
}
