/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axmalloc.c
   Applix ASC version: 4
   Date: Fri May 28 21:11:46 1999
*/
#include <stdio.h>
#include <stdlib.h>
#include <amemtrak.h>

#define NXLT(s) s

#include <axmalloc.p>

/***********************************************************************/
/* Other sys's runtime libraries malloc to the REAL malloc, so         */
/*      free in things like in agetNFname the free doesn't work */
/* Compatabilty funtions so ATM kernel and shared runtimes can malloc... */
/* The reason there are so many flavors here is to make the definintions */
/*   match the definitions in the system include file "malloc.h" which the */
/*   newer compiler will insist upon (and which would seem to be good     */
/*   practive in any case) - jon                                          */
/***********************************************************************/
#if LINUX || SYSV4 || ALPHA || HP800 || HP300 || RIOS || CLIX || AX_NT || SCOUNIX || SGI  /*     {   */
#if !AXMS   /* { */
/* On NT, we can't redefine C run-time functions because we are using
 * MSVCRT.LIB, so don't bother to define these.
 */
void *malloc(size)
size_t size;
{
    RETADDR(size);

    return ((void *) TaskAlloc(0, size));
}
void *realloc(px, size)
void *px;
size_t size;
{
    return ((px == NULL) ? (void *) TaskAlloc(0, size) : (void *) TaskRealloc(0, px, size));
}

void free(p)
void *p;
{
    if (p)
        TaskFree(0, p);
}
void *calloc(n, size)
size_t n, size;
{
    RETADDR(n);
    return ((void *) TaskCalloc(0, n, size));
}
#endif   /* } !AXMS */

#else         /*     }  SYSV4 || HP800 || RIOS || CLIX || AX_NT || SCOUNIX { */

#if PMAX            /*     { */
void *malloc(size)
register unsigned size;
{
    RETADDR(size);
    return ((void *) TaskAlloc(0, size));
}

void *realloc(px, size)
register void *px;
register unsigned size;
{
    return ((px == NULL) ? (void *) TaskAlloc(0, size) : (void *) TaskRealloc(0, px, size));
}

void free(p)
register void *p;
{
    if (p)
        TaskFree(0, p);
}

#else               /*     } PMAX         { */

#if LINUX  /* { */

char *malloc(size)
size_t size;
{
    RETADDR(size);

    return ((void *) TaskAlloc(0, size));
}
char *realloc(px, size)
char *px;
size_t size;
{
    return ((px == NULL) ? (void *) TaskAlloc(0, size) : (void *) TaskRealloc(0, px, size));
}

void free(p)
char *p;
{
    if (p)
        TaskFree(0, p);
}
char *calloc(n, size)
size_t n, size;
{
    RETADDR(n);
    return ((void *) TaskCalloc(0, n, size));
}

#else    /*   }   LINUX  {  */

char *malloc(size)
register unsigned size;
{
    RETADDR(size);
    return (TaskAlloc(0, size));
}

char *realloc(px, size)
register void *px;
register unsigned size;
{
    return ((px == NULL) ? TaskAlloc(0, size) : TaskRealloc(0, px, size));
}

#if M_88K || ALPHA /* Need void return type for ALPHA - SCM */
void
#endif
free(p)
register void *p;
{
    if (p)
        TaskFree(0, p);
}

#endif      /* end of if LINUX         } */
#endif      /* end of if PMAX         } */
#endif      /* end of SYSV4 || HP800 || RIOS || CLIX || AX_NT || SCOUNIX  }  */


#if !SYSV4 && !ALPHA && !HP800 && !HP300 && !RIOS && !CLIX && !AX_NT && !SCOUNIX && !SGI && !LINUX /* { */
char *calloc(n, size)
register unsigned n, size;
{
    RETADDR(n);
    return (TaskCalloc(0, n, size));
}

#endif /* } */


#if RIOS || ALPHA
#ifdef valloc
#undef valloc
#endif
#endif

void *valloc(size)
register size_t size;
{
    tempAbort(NXLT("called valloc"));
    return NULL;   /* to keep compiler happy. */
}
