/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axprint.c
   Applix ASC version: 77
   Date: Mon Nov 16 13:53:25 1998
*/
#include <atm.h>
#include <elf_env.h>
#include <paripc.h>
#include <scac.h>
#include <thimble.h>
#include <getstr4.h>
#include <getstr5.h>
#include <getstr6.h>
#include <getstr10.h>
#include <fsrts.h>
#include <atmwin.h>
#include <atmattr.h>
#include <pfint.h>
#include <rsval.h>
#include <afile.h>
#include <axprint.h>
#include <axtrace.h>
#include <java_syms.h>

#if USL54
#include <limits.h>
#endif

#if SYSV4
#include <sys/systeminfo.h>				 /* for SI_HOSTNAME */
#endif

/* This "printer" destination will appear in printer lists from the java client
 */
#define TO_BROWSER  XLT("<Through Browser>")


extern	char	*SEhackname, *SEhackfilename;	/* ?? */
extern	int		SEisReallyTSE;	/* hack to serializer file printing for tutorials */
extern	char	*DirSlash;
extern  char    *ThimApplixDir;
extern  char    *ThimUserDir;
extern	char	*ax_itoa();
extern	char	*ErrnoTextFromUnix();
extern	char	*UPbyName();
extern	char	*GetProfileByCode();
extern	char	*AxCreateTempfile();
extern	char	*AxGetStr();
extern	char	*GetProfileByStr();

/*-----------------------------------------------------------------------------
	global procedures
-----------------------------------------------------------------------------*/
int		AxPrintSetupFromClassAndType();
char	*Agetuser();
void	AxPrintClassAndTypeFromSetup();
typeErr AxPrintFinish2() ;
typeErr AxPrintFinish3() ;

/*-----------------------------------------------------------------------------
	local procedures
-----------------------------------------------------------------------------*/
static	int		AxIssuePrintCommand();
static	char	*readWholeFile();

#if (SYS&B4_2) || SGI || M88K
static	int		dash_r();
static	void	filt_r();
#endif
static	int		strrep() ;


/*-----------------------------------------------------------------------------
	AxPrintFinish - Start PF on serializer file...
					(old style )
-----------------------------------------------------------------------------*/
typeErr AxPrintFinish (printer, copies, pf_file, banner, docname, setup,
						printer_info,
						landscape, error_object, error_string)
char *printer;
int copies;
char *pf_file;
int banner;
char *docname;
int setup;
char *printer_info;
int landscape;
char *error_object; 		/* at least STRPATH+1 big */
char *error_string; 		/* at least STRPATH+1 big */
{
	char print_class[200];
	char print_type[200];

	AxPrintClassAndTypeFromSetup( setup, print_class, print_type );

	return AxPrintFinish2(printer, copies, pf_file, banner, docname,
							print_class, print_type, 
							landscape, NULL, error_object, error_string);
}

/*-----------------------------------------------------------------------------
	AxPrintFinish2 - Start PF on serializer file...
-----------------------------------------------------------------------------*/
typeErr AxPrintFinish2(printer, copies, pf_file, banner, docname,
						printer_class, printer_type,
						landscape, baggage, error_object, error_string)
char *printer;
int copies;
char *pf_file;
int banner;
char *docname;
char *printer_class;
char *printer_type;
int landscape;
char *error_object;
char *error_string;
data_ptr baggage ;
{
	PF_info PfInfo ;
	typeErr err;

	memset(&PfInfo, 0, sizeof(PF_info)) ;
	PfInfo.printer = printer ;
	PfInfo.copies = copies ;
	PfInfo.outfile = pf_file ;
	PfInfo.banner = banner ;
	PfInfo.docname = docname ;
	PfInfo.pclass = printer_class ;

	if (PfInfo.printer == NULL || *PfInfo.printer == 0)
		PfInfo.print_to_file = TRUE;

	if (baggage)
	{
		PfInfo.print_to_file = AxIntFromArray(baggage, 0) ;
		PfInfo.reverse = AxIntFromArray(baggage, 1) ;
		PfInfo.duplex = AxIntFromArray(baggage, 2) ;
		PfInfo.source_all = AxStrFromArray(baggage, 3) ;
		PfInfo.source_1st = AxStrFromArray(baggage, 4) ;
		PfInfo.source_last = AxStrFromArray(baggage, 5) ;
		PfInfo.dest_all = AxStrFromArray(baggage, 6) ;
		PfInfo.dest_1st = AxStrFromArray(baggage, 7) ;
		PfInfo.dest_last = AxStrFromArray(baggage, 8) ;
		PfInfo.source = AxArrayFromArray(baggage, 9) ;
		PfInfo.dest = AxArrayFromArray(baggage, 10) ;
		PfInfo.size = AxArrayFromArray(baggage, 11) ;
		PfInfo.PPDfile = AxStrFromArray(baggage, 12) ;
		PfInfo.duplex_code = AxArrayFromArray(baggage, 13) ;
	}

	err =  AxPrintFinish3(&PfInfo, error_object, error_string) ;

	return(err);

}


/*-----------------------------------------------------------------------------
	AxPrintFinish3 - Start PF on serializer file, no shit
-----------------------------------------------------------------------------*/
typeErr AxPrintFinish3(pi, error_object, error_string)
PF_info *pi ;
char *error_object;
char *error_string;

{
	char *p;
	int code;
	int ret_stat = 0;
	char lpcmd[1000];
	char hostname[STRLONG];
	char username[STRLONG];
	char lpErrFile[STRPATH+1];
	int ret_code;
	int height = 11000, width = 8500;
	int errTextLen;
	int maxcopies;
	int fd;
	char attrs[5];
	char *tempDir;
	char *tuser;
	char *real_outfile_name = 0;
	char *tobrowser_basename = 0;
	int dum;

	Agethostname(hostname, (sizeof(hostname) - 1) ); 

	tuser = Agetuser();
	if (tuser)
		strcpy(username, tuser);
	else
		strcpy(username, XLT("Unknown User") ); 
		
	pi->device = AxPrintSetupFromClassAndType(pi->pclass, 0);

	/*============================================================*/
	/* create the print command */
	/*============================================================*/

	*lpcmd ='\0';

#if !AXMS	/*	{	*/
	if (!pi->print_to_file)
	{
		if ( streq(pi->printer,NXLT("System Default")) )
		{
			p = UPbyName(NXLT("axPrintShellCmdSysDef"));
			if ( !p )
			{
				errTextLen = strlen(pi->outfile);
				strncpy(error_object, pi->outfile, errTextLen);
				error_object[errTextLen] = '\0';
				strncpy(error_string, XLT("No axPrintShellCmdSysDef in .ax_profile"), STRPATH);
				error_string[STRPATH -1] = '\0';
				return(ERR_ILLVAL);
			}
			strcpy(lpcmd,p);
		}
		else
		{
			p = GetProfileByCode(PROF_PRINT_CMD_);
			if ( p == NULL || *p == '\0' )
				p = NXLT("/usr/ucb/lpr -P");
#if 0
			SVERIFY(!strchr(pi->printer,' '), ERR_PRINTERNAME, pi->printer);
#endif
			sprintf(lpcmd,"%s%s", p, pi->printer);

			p = strrchr(pi->outfile,'.');
#if BUILD_ORIENT
			if ( !p ||
				 !(streq(PS_CLASS_SFX, p) ||
					streq(PCL_CLASS_SFX, p) ||
					streq(LIPS3_CLASS_SFX, p)) )

#else
			if ( !p || !(streq(PS_CLASS_SFX,p) || streq(PCL_CLASS_SFX,p)) )
#endif
			{
				errTextLen = strlen(pi->outfile);
				strncpy(error_object, pi->outfile, errTextLen);
				error_object[errTextLen] = '\0';

#if BUILD_ORIENT
				strncpy(error_string, 
						XLT("Filename must end in .ps or .pcl or .lips"), STRPATH);
#else
				strncpy(error_string, 
						XLT("Filename must end in .ps or .pcl"), STRPATH);

#endif
				error_string[STRPATH -1] = '\0';
				return(ERR_ILLVAL);
			}
		}
	}
#endif	/* } !AXMS	*/

#if AXMS
	if ( pi->print_to_file )
		{	/* do not open file unless we are really going to create it */
#endif
	fd = open(pi->outfile, O_WRONLY | O_CREAT, 0666);
	if (fd == -1)
	{
		memset(error_object, '\0', STRPATH);
		strncpy(error_object, pi->outfile, STRPATH);

		sprintf(error_string, "%s (%s), %s", 
				XLT("cannot write this file"),
				pi->outfile,
				AxGetStr(ErrnoErr()));

		error_string[STRPATH -1] = '\0';
		return(ERR_ILLVAL);
	}
	close(fd);

#if AXMS
	}
#endif	


	/* check for copies > axMaxPrintCopies */
	p = UPbyName(NXLT("axPrintMaxCopies"));
	if ((p != NULL) && (*p != '\0'))
	{
#ifndef INT_MAX	 /* should be in limits.h */
#define INT_MAX 2147483647
#endif
		maxcopies = atoi(p);
		if (maxcopies < 0)
			maxcopies = INT_MAX;
		if (pi->copies > maxcopies)
#if 0
		{
			/* DANGER! Silent truncation! */
			pi->copies = maxcopies;
		}
#else
		{
			strncpy(error_object, pi->docname, STRPATH);
			error_object[STRPATH -1] = '\0';
			sprintf(error_string, "%s (%d) %s",
					XLT("Copies requested"),
					pi->copies,
					XLT("exceeds axPrintMaxCopies"));
			error_string[STRPATH -1] = '\0';
			return(ERR_BADCOPIES);
		}
#endif
	}

	/*========================*/
	/* set up args for pf call */
	/*========================*/

	pi->date = time((time_t *)NULL);
	pi->infile = SEhackfilename ;
	pi->command = lpcmd ;
	pi->host = hostname ;
	pi->user = username ;

	/*==============================*/
	/* fire off the print formatter */
	/*==============================*/
	ret_code = PFthimble(pi) ;

	if ( ret_code != 0 )
	{
		Adelete(pi->outfile);
		if (PF.Pferror_message)
		{
			strncpy(error_string, 
						PF.Pferror_message, STRPATH) ;
			error_string[STRPATH] = '\0';
			THIMfree(PF.Pferror_message) ;
			PF.Pferror_message = NULL ;
		}
		else if (PF.Pferrno == -1)
		{
			strcpy(error_string, XLT("Error from PFthimble"));
		}
		else
		{
			errno = PF.Pferrno;
			sprintf(error_string, XLT("Error from PFthimble, %s"),
											AxGetStr(ErrnoErr()));
		}


		return(ret_code);
	}
#if AXMS	/*	{	*/
	else
		return( 0 );	 /* job is all done, already sent to the spooler */
#else		/*	}	{	*/
	else
	{
		if(!pi->print_to_file) 
		{
			/* Issue the print command, with standard error redirected to	*/
			/* the file "/tmp/zzprterr" or	<ThimTempDir>/zzprterr		 */
			tempDir = (char *)GetProfileByCode(PROF_PRT_TEMP);
			if ( !tempDir || !tempDir[0] )
				tempDir = ThimTempDir;
		
			strcpy(lpErrFile, tempDir);
			strcat(lpErrFile, DirSlash );
			strcat( lpErrFile, NXLT("axp%%%%%.tmp") );
			Amktemp( lpErrFile );

			ret_stat = AxIssuePrintCommand(pi->outfile, PF.PfCopies, lpErrFile);

			if (ret_stat != AOK)
			{
				strncpy(error_object,
							XLT("Shell print command failed"), STRPATH);
				error_object[STRPATH] = 0 ;
#if 0			/* this usually results in an arcane error message */
				p = readWholeFile(lpErrFile);
				if (p)
				{
					strncpy(error_string, p, STRPATH) ;
					free((char *) p);
				}
				else
				{
					strncpy(error_string, PF.PfShell_command, STRPATH) ;
				}
#else
/*				strncpy(error_string, PF.PfShell_command, STRPATH) ;
*/
				p = readWholeFile(lpErrFile);
				strcpy(error_string, PF.PfShell_command) ;
				if (p)
				{
					strcat(error_string, "\n") ;
					strcat(error_string, p) ;
					free((char *) p);
				}
#endif
/*				error_string[STRPATH] = 0 ;
*/
			}
			/* remove temp files */
			unlink(lpErrFile); /* toss error text file created by AxRun. */
		}
	}
#endif	/*	}	!AXMS	*/
	
	if (pi->print_to_file && !strcmp(pi->printer, TO_BROWSER)) {
		ElfCallByName(NXLT("aa_post_printer_file$"),(data_ptr*)NULL,1,
					  AxMakeStrData(-1,pi->outfile));	 /* in axjava.els */
	}
	
	return(ret_stat);

}



/*-----------------------------------------------------------------------------
	 Looks simple... but allows us to add more printer setups based
	on PPDs or specific PCL5 printers.
	type is ignored FOR NOW.
-----------------------------------------------------------------------------*/
int
AxPrintSetupFromClassAndType(class, type)
char *class;
char *type;
{
	int setup = PS_CLASS_NUM;
	
	if (strcmp(class, PS_CLASS_NAME) == 0)
		setup = PS_CLASS_NUM;
	else if (strcmp(class, PCL_CLASS_NAME) == 0)
		setup = PCL_CLASS_NUM;
	else if ( strcmp(class, GDI_CLASS_NAME) == 0 )
		setup = GDI_CLASS_NUM;
#if BUILD_ORIENT
	else if (strcmp(class, LIPS3_CLASS_NAME) == 0)
		setup = LIPS3_CLASS_NUM;
	else if (strcmp(class, LIPS4_CLASS_NAME) == 0)
		setup = LIPS4_CLASS_NUM;
#endif
	else if (strcmp(class, XLT("Screen")) == 0)
		setup = -1;

	return(setup);
}


/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
void AxPrintClassAndTypeFromSetup( setup, class, type )
int setup;
char *class;
char *type;
{
	*type = '\0';	/* no types for now */

	if ( setup == PS_CLASS_NUM )
		strcpy( class, PS_CLASS_NAME );	/* postscript */
	else if ( setup == PCL_CLASS_NUM )
		strcpy( class, PCL_CLASS_NAME );	/* HP LaserJet, PCL-5 */
	else if ( setup == GDI_CLASS_NUM )
		strcpy(class, GDI_CLASS_NAME);	/* Windows GDI printing */
#if BUILD_ORIENT
	else if ( setup == LIPS3_CLASS_NUM )
		strcpy( class, LIPS3_CLASS_NAME );	/* Canon bubblejet */
	else if ( setup == LIPS4_CLASS_NUM )
		strcpy( class, LIPS4_CLASS_NAME );
#endif
	else if ( setup == -1 )
		strcpy( class, XLT("Screen") );

	return;
}




/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
static char *readWholeFile(name)
char *name;
{
	long fileSize;
	char *fileData, *cp;
	FILE *fp = fopen(name, "r");
	if (fp == NULL) {
		return ((char *) NULL);
	}
	fseek(fp, 0, 2); /* to end */
	fileSize = ftell(fp);
	fseek(fp, 0, 0); /* back to beginning */
	fileData = cp = (char *) malloc((unsigned int)fileSize);
	while (fgets(cp, 256, fp)) {
		cp += strlen(cp);
	}
	return(fileData);
}

/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
static int AxIssuePrintCommand(file,copies, error_file)
char * file;
int copies;
char *error_file;
{	
	char buf[256];
	char buf2[256];
	char tmpstr1[256];
	char tmpstr2[256];
	char *tmpbuf;
	char *tmpptr;
	char copies_str[20];
	int tmp_copies;
	int ret_stat = 0, i, ii;

	if (!strrep(buf, PF.PfShell_command, "#<n>#", file))
		/* If we didn't insert the name, append it. */
		sprintf (buf, "%s %s", PF.PfShell_command, file);

	tmp_copies = copies;
	ax_itoa(copies_str,10,tmp_copies);
	if (strrep(buf2, buf, "#<c>#", copies_str))
		/*	If we inserted the number of copies,
		 *	they're using a copies switch,
		 *	so set copies to 1 so we only loop once.
		 */
		tmp_copies = 1;

	if (strrep(buf, buf2, "#<r>#", ""))
		/* They don't want us to remove the file. */
		PF.out_remove = FALSE;
 
#if (SYS&B4_2) || SGI || M88K
	if (dash_r(buf))
		/*
		 * The spooler will remove the file for us.
		 * Note that lpr -r will thwart a #<r>#.
		 */
		PF.out_remove = FALSE;
	if (tmp_copies > 1)
		filt_r( buf, buf2 );
#endif
 
		/* put the filename befire the first pipe, rh/mbp Mar-28,1990 */
	for(ii = 0; ii < 1; ii++)
	{
			if(ii == 0)
				tmpbuf = buf;
			else
				tmpbuf = buf2;

			tmpptr = strchr(tmpbuf,'|');
			if( tmpptr != NULL)
			{
				for(i = strlen(tmpbuf); i >=0 && tmpbuf[i] == ' ';i--)
					;
				for(i = strlen(tmpbuf); i >=0 && tmpbuf[i] != ' ';i--)
					;
				if(i > 0)
				{
					strcpy(tmpstr1,&tmpbuf[i+1]);
					tmpbuf[i] = '\0';
					strncpy(tmpstr2,tmpbuf,tmpptr - tmpbuf);
					tmpstr2[tmpptr - tmpbuf] = '\0';
					strcat(tmpstr2," ");
					strcat(tmpstr2,tmpstr1);
					strcat(tmpstr2," ");
					strcat(tmpstr2,tmpptr);
					strcpy(tmpbuf,tmpstr2);
				}
			}
	}

	for (i = 0; i < tmp_copies; i++)
	{
#if SYS&B4_2
		/*	
		 * Use the filt_r-ed shell command
		 * for all but the last copy.
		 */
		/* Berk lpr puts its errors on stdout!	AxRunProgram copes
			with this though (stderr>stdout) */
		if(i <	tmp_copies-1)
		{
			ret_stat = AxRunProgram(buf2,(char *)0,error_file,(char *)0,FALSE);
		}
		else
		{	
			ret_stat = AxRunProgram(buf,(char *)0,error_file,(char *)0,FALSE);
		}
#else	
		ret_stat = AxRunProgram(buf, (char *)0, error_file, (char *)0, FALSE);
#endif
		if (ret_stat != 0)
			break; 
	}
 
	if (PF.out_remove)
		unlink(file) ;

	return (ret_stat); 
}



/*-----------------------------------------------------------------------------
	strrep replaces a substring in a string with a new string.
	It replaces old with new in str, returning result in out.
	It returns 1 if the replacement was made, 0 if not.
	But even when no string is found, the original is copied.
-----------------------------------------------------------------------------*/
static int strrep(out, str, old, new)
char *out, *str, *old, *new;
{
	int indx, len, oldlen;
	char *cp;

	len = strlen(str);
	oldlen = strlen(old);
	indx = 0;
	cp = str;
	*out = '\0';
	for (indx = 0; indx < len - oldlen + 1; indx++)
		if (strncmp(cp, old, oldlen) == 0)
		{
			strncpy(out, str, indx);
			*(out + indx) = '\0';
			strcat(out, new);
			strcat(out, str + indx + oldlen);
			return 1;
		}
		else
			cp++;
	strcpy(out, str);
	return 0;
}

#if (SYS&B4_2) || SGI || M88K
static int dash_r( cmd )
char	*cmd;
{

	int	 i, len, ya;
	char	*pt;

	/* do we have an -r switch? (berkeley lpr command) */

	/* rsh commands with -r switches don't count.... */
	if (strncmp(cmd, NXLT("rsh"), 3) == 0)
		return(0);

	ya = 0;
	len = strlen(cmd);
	for(i=0; i<len-2; i++)
	{
		pt = cmd + i;
		if(strncmp(pt, " -r", 3) == 0)
		{
			ya=1;
			break;
		}
	}
	return(ya);
}

/*-----------------------------------------------------------------------------
	Caller has made some space for newcmd.
	At least strlen(cmd)
-----------------------------------------------------------------------------*/
static void filt_r( cmd, newcmd )
char	*cmd, *newcmd;
{
	int	 i, len;
	char	*pt, *newpt;

	len = strlen(cmd);
	pt = cmd;
	newpt = newcmd;
	for(i=0; i<len-2; i++)
	{
		*newpt++ = *pt++;
		if(strncmp(pt, " -r", 3) == 0)
		{
			pt += 3;
			break;
		}
	}
	while(--len > 2)
		*newpt++ = *pt++;
}

#endif /* #if (SYS&B4_2) */
