/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: context.c
   Applix ASC version: 279.23.7
   Date: Mon Jun 14 21:12:40 1999
*/
#define SLOG 0
#if SLOG
#define SLOGGER(body) printf body ; printf("\n"); fflush(stdout)
#else
#define SLOGGER(body)
#endif

#include <stdio.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <basicwin.h>				/* for Euro key stuff */
#include <adld.h>
#include <aos.h>
#include <afile.h>
#include <paripc.h>
#include <scac.h>
#include <thimble.h>
#include <fsrts.h>
#include <getstr2.h>
#include <getstr5.h>
#include <getstr7.h>
#include <getstr8.h>
#include <signal.h>
#include <appnames.h>
/* #include <revstamp.h> !!0 TEMP */
#include <amemtrak.h>
#include <amenudef.h>				/* for Euro key stuff */
#include <tmkeys.h>					/* for Euro key stuff */
#include <memblk.h>
#include <bldrbltn.h>
#include <adlgpoke.h>
#include <java_syms.h>
#if AXMS
#include <winmap.h>
#endif
#if SYSV4
#include <unistd.h>
#endif

#define AXSHLIB_DEFINES_ONLY
#include <axshlib.h>			/* Need spelling shared library name */

#include <context.p>

#if CLIX
#define NSIG _NSIG
#endif

#if 0
#define LOGGER(body)    XWINSlog body
#else
#define LOGGER(body)
#endif

/* Maximum allowable directory name is around 150 */
#define MAX_DIR_LEN (STRPATH - 90)

#undef getenv

extern char *AxSocketName;
extern int AxSockFd; /* LISTENER$ socket */
extern int AxStartedForPrinting;/* if TRUE, axmain started just for print job */
extern char *AGetTempDir(), *AllcStr();

extern int JavaMode;    /* TRUE for Java slaved axmain */


/*
    How to add a new Task type.

    TODO!!0
*/

/**************** TYPES OF TASKS *********************************/
/* A type is a set of BSS/DATA */

#define THIMTYPE_CALC 0 /* Calculator */
#define THIMTYPE_WP 1   /* Words */
#define THIMTYPE_GE 2   /* Graphics Editor */
#define THIMTYPE_EL 3   /* Elf */
#define THIMTYPE_ED 4   /* Ascii editor */
#define THIMTYPE_SS 5   /* Spreadsheet */
#define THIMTYPE_PF 6   /* Print formatter */
#define THIMTYPE_UD 7   /* UDF masher for DC imports */
#define THIMTYPE_PX 8   /* Pixel editor */
#define THIMTYPE_GC 9   /* GECVT */
#define THIMTYPE_SC 10  /* SPELLER */
#define THIMTYPE_IC 11  /* Import DC (ascii in) */
#define THIMTYPE_ML 12  /* Import ML file (marked up ascii in) */
#define NUM_TYPES 13        /* sum of above */

#if 0
 --- get rid of this hard coded stuff ---
#if AX_NT
#define AXDIRdaxdata 1      /* for now */
#endif  /* DAMNT */

#if AXDIRaxdata
#define THIMBLE_DATA NXLT("axdata")
#define THIMBLE_LOCAL NXLT("axlocal")
#else
#if AXDIRdaxdata
#define THIMBLE_DATA NXLT("daxdata")
#define THIMBLE_LOCAL NXLT("axlocal")
#else
#if AXDIRpaxdata
#define THIMBLE_DATA NXLT("paxdata")
#define THIMBLE_LOCAL NXLT("axlocal")
#else
/*  I won't compile ; because no axdir is defined; */
#endif
#endif
#endif

#endif   /* if 0 */

/*	Sorting support */
#define SORT_ORDER_FILE   NXLT("charsort.dat")
#define CTYPESIZE   256
extern unsigned char Imap[][CTYPESIZE];
unsigned char	*read_Imap();

  
char AxCurrentDir[STRPATH+1];
#define MAX_LANGS 21
char    *AxLangSuffix[MAX_LANGS] = {
    NXLT("eng"), NXLT("eng"), NXLT("grm"), NXLT("frn"), 
    NXLT("spn"), NXLT("itl"), NXLT("brt"), NXLT("swd"), 
    NXLT("dan"), NXLT("nrw"), NXLT("dut"), NXLT("prt"), 
    NXLT("brz"), NXLT("cfr"), NXLT("sgr"), NXLT("nyn"), 
    NXLT("fin"), 
    NXLT("jpn"),     /* Japan */
    NXLT("kor"),     /* Korea */
    NXLT("prc"),     /* China - mainland  (Peoples Republic of China (PRC) */
    NXLT("twn")      /* Chinese - Taiwan  */
};
static char ThimApplixDirEntName[14] = {0};
static char *ThimUserDirEntName    = NXLT("axhome");
static char *ThimLangDirEntName    = NXLT("axlang");
#if TURBO
static char *ThimFiltDirEntName    = NXLT("axfilter");
#else
static char *ThimFiltDirEntName    = NXLT("daxflter");
#endif
static char *ThimCustomDirEntName  = NXLT("axlocal");
static char *ThimClipArtDirEntName = NXLT("axart");
static char *ThimPresTempDirEntName = NXLT("template");
static char *ThimPresColorDirEntName = NXLT("color");
static char *ThimPresMonoDirEntName  = NXLT("mono");
static char *ThimPres35mmDirEntName  = NXLT("35mm");
static char *ThimPresBklitDirEntName = NXLT("backlit");
static char *ThimPresOutlineDirEntName = NXLT("outline");
static char *ThimPresSchemeDirEntName = NXLT("scheme");
static char *ThimPresChartDirEntName = NXLT("chart");

#if TURBO
static char *ThimEnterpriseDirEntName = NXLT("ent");
#else
static char *ThimEnterpriseDirEntName = NXLT("dent");
#endif
static char *ThimEnterpriseAppsDirEntName = NXLT("apps");
static char *ThimEnterpriseAppFileEntName = NXLT("enterprise.abo");

short THIMpid = 0;      /* 0 or task that owns the data system */
extern int AxInTask;    /* 0 or task that owns the current stack */
extern char *DirSlash;   /* either a forward slash or backslash */
long THIMpidUID = 0;
static long PidUID = 1000;
short THIMappid = 0;        /* Current tasks application type */
extern short TmDummy;
int TmAmSE; /* set by pdc when formatting */
int TmDefDev = 106;  /* Default device. -1 means unknown. */

char *ThimApplixDir;        /* Where the THIMBLE executable lies */
extern char *ThimLangDir;   /* Where the THIMBLE alternate language dicts are */
                            /* Lives in elf_static.c so Speller can see it */
extern char *ThimFiltersDir;        /* Where the filters are */
char *ThimExecDir;
char *ThimCustomDir;        /* Where customizeable files are kept */
char *ThimUserDir;          /* Aster*x directory in user's HOME */
char *ThimUserElfDir;   /* optional user's commands directory */
char *ThimClipArtDir;   /* location of default clipart */
char *ThimPresTempDir;  /* location of presentation template */
char *ThimPresColorDir; /* location of presentation color template */
char *ThimPresMonoDir;  /* location of presentation mono template */
char *ThimPres35mmDir;  /* location of presentation 35mm template */
char *ThimPresBklitDir; /* location of presentation backlit template */
char *ThimPresOutlineDir; /* location of presentation outline template */
char *ThimPresSchemeDir; /* location of presentation scheme template */
char *ThimPresChartDir; /* location of presentation chart template */
char **ThimAccessDirPath; /* Directory list above which access to Documents
							 not allowed.  If NULL, no access restrictions.
							 For doc on this feature see axaccess.c */
char AxPresTemplateDir[STRPATH+1];

char *ThimEnterpriseDir; /* Applix Enterprise base dir */
char *ThimEnterpriseAppsDir;  /* Applix Enterprise apps dir */
char *ThimEnterpriseAppFilename;  /* full path to Enterprise client .abo */

char *ThimSpellingLibraryFilename;      /* full path to libspell.so */
char *libspell_handle;
short ThimNoSpellingLibrary;			/* If TRUE, libspell.so is missing */

/* The user's commands directory for this session.  Can only be set by
   specifying the `-elfdir' command line switch.
   NOTE: ThimSessionElfDir is looked at in `SetThimbleDirs ()' and
   `FindThimbleFile ()' only. */
char *ThimSessionElfDir;
char *ThimUserModelsDir;    /* optional user's model docs dir */
char *ThimUserBackupDir;    /* optional user's backup docs dir */
char *AxStrflName;      /* pathname to applix string file axstrfl */
int ThimNewUser;        /* TRUE if newly created profile */
char *AxLangDir;        /*  Where language-dependent files are kept in axdata*/
char *AxLocalLangDir;   /*  Where language-dependent files are kept in axlocal*/
						/*	This dir path has been re-located from
						 *		axlocal/elf/langdir
						 *	to
						 *		axlocal/langdir. */
char *AxLangDemosDir;	/*	Language-dependent sample macros were relocated to:
						 *		axdata/langdir/Demos
						 *	No macro call to locate them yet.
						 */

char *AGetHomeDir();
char *AGetAxHomeDir();
char *UPneedByCode();
char *WhereIsExecDir();
char *UPbyName();
void AxSetTaskMaster();
#if AXMS
char *AxNTgetDrive(void);
int WinVerbose;           /* to turn on verbose error logging */
#endif

context_block TaskInfo[MAX_PIDS];   /* Array of task descriptions */

ax_mem_block_info_t *BlockList[NUM_TYPES][32];  /* 31 max block types */

extern ax_mem_block_info_t *ElfMemBlockInfo();
extern ax_mem_block_info_t *WpMemBlockInfo();
extern ax_mem_block_info_t *SSMemBlockInfo();
extern ax_mem_block_info_t *OMMemBlockInfo();
extern ax_mem_block_info_t *OM2MemBlockInfo();

extern int CLthimble(), WPthimble(), GEthimble(), ELthimble(),
        EQthimble(), MEthimble(), SSthimble(), WorkingSetter(), HLthimble(),
        PXthimble(), GCthimble(), HTMLthimble(), 
        GETiffToGE(), EDtester();
extern char *GetSSPathname();

/* ACAPPS 'file' info.
This is used to define the relationship between Alis appids,
thimble execution image types and entry points.
Multiple appids can share the same image & entry point (DC & PDC).
Multiple appids can share the same image but a different entry point (ED & HELP).
*/

typedef struct {
    int appid;      /* as in scac.h */
    int (*func)();  /* 'main' routine to call to start */
    int thimtype;   /* as in THIMTYPE_DC ... */
    char *argv0;    /* default argv[0] value */
} acapps_info;

static acapps_info Acapps[] = {
    {APCALC,    CLthimble,  THIMTYPE_CALC,  NXLT("APPNAME_XX_")},
    {APDC,      WPthimble,  THIMTYPE_WP,    APPNAME_WP_},
    {APSS,      SSthimble,  THIMTYPE_SS,    APPNAME_SS_},
    {APELFM,    ELthimble,  THIMTYPE_EL,    NXLT("APPNAME_XX_")},
    {APINSCR,   ELthimble,  THIMTYPE_EL,    NXLT("create_inset_")},
    {APREGIS,   ELthimble,  THIMTYPE_EL,    NXLT("regis_indexes_")},
    {APEQN,     EQthimble,  THIMTYPE_WP,    APPNAME_EQ_},
    {APUCM,     MEthimble,  THIMTYPE_WP,    APPNAME_CE_},
    {APGE,      GEthimble,  THIMTYPE_GE,    APPNAME_GE_},
    {APBG,      GEthimble,  THIMTYPE_GE,    APPNAME_GE_},
    {APBGBACK,  GEthimble,  THIMTYPE_GE,    NXLT("APPNAME_XX_")},
    {APTIFF2GE, GETiffToGE, THIMTYPE_GE,    NXLT("APPNAME_XX_")},
    {APSSCONV,  NULL,       -1,             NXLT("SSconv")},
    {APPIXED,   PXthimble,  THIMTYPE_PX,    APPNAME_IC_},
    {APGEOCVT,  GCthimble,  THIMTYPE_GC,    NXLT("gecvt")},
    {APGEICVT,  GCthimble,  THIMTYPE_GC,    NXLT("gecvt")},
    {APBGOCVT,  GCthimble,  THIMTYPE_GC,    NXLT("gecvt")},
    {APBGICVT,  GCthimble,  THIMTYPE_GC,    NXLT("gecvt")},
    {APHELP,    EDtester,   THIMTYPE_ED,    NXLT("Tutor")},
    {APHTML,    HTMLthimble,THIMTYPE_WP,    APPNAME_HTML_},
    {0,0,0,0}
};

typedef struct {
    int pid;        /* task number of task owning this block */
    int piduid;     /* UID of owning task */
    int *data;      /* data group */
} active_context_t;
#define MAX_BLOCK_TYPES 50      /* plenty! */
static active_context_t CurrentContexts[MAX_BLOCK_TYPES];

typedef struct {
    char name[16];
    int offset;
} glom_ptr_t;

static int currentContext;  /* True state of data system... This is needed
                because there are places where THIMpid is explicitly
                hammered to do cross-task memory stuff.  As of Mar 7, 1992,
                one of those places (elfDestroyObject) is calling
                ElfUnloadPackage which calls VfyContext.  When the
                caller restores the THIMpid, it does not know that it
                has to restore full context and thus the task runs with
                the right THIMpid, but the wrong context. */

/*************************************************************************
function: AppidToFunc - Return function entry based on appid
If not in the table, func is returned as NULL and type 0.
If a true proc is needed, func is returned as NULL and type -1.
*/
AppidToFunc (appid,funcP,name,type)
int appid;
int (**funcP)();
char **name;
int *type;
{
    register acapps_info *p;

    for ( p = Acapps; p->appid; p++ ) {
        if ( p->appid == appid ) {
            *funcP = p->func;
            *name = p->argv0;
            *type = p->thimtype;
            return;
        }
    }
    *funcP = NULL;
    *type = 0;
}

AxSetTaskData(pid, data, delete_func, pid_func)
int pid;
char * data;
void (*delete_func)();
int (*pid_func)();
{
    register context_block *cP;
	int size;

	cP = &TaskInfo[pid];
	if ( !data )
	{
		if ( cP->gfx )
			TaskFree(pid, cP->gfx);
		cP->gfx = (task_info_type *)0;
	}
	else
	{
		if ( !cP->gfx )
		{
			size = sizeof(task_info_type);
			cP->gfx = (task_info_type *)TaskAlloc(pid, size);
		}
		cP->gfx->data = data;
		cP->gfx->delete_func = delete_func;
		cP->gfx->pid_func = pid_func;
	}
}

AxSetTaskSSXData(pid, data, delete_func, pid_func)
int pid;
char * data;
void (*delete_func)();
int (*pid_func)();
{
    register context_block *cP;
	int size;

	cP = &TaskInfo[pid];
	if ( !data )
	{
		if ( cP->ssx )
			TaskFree(pid, cP->ssx);
		cP->ssx = (task_info_type *)0;
	}
	else
	{
		if ( !cP->ssx )
		{
			size = sizeof(task_info_type);
			cP->ssx = (task_info_type *)TaskAlloc(pid, size);
		}
		cP->ssx->data = data;
		cP->ssx->delete_func = delete_func;
		cP->ssx->pid_func = pid_func;
	}
}

AxSetTaskWPXData(pid, data, delete_func, pid_func)
int pid;
char * data;
void (*delete_func)();
int (*pid_func)();
{
    register context_block *cP;
	int size;

	cP = &TaskInfo[pid];
	if ( !data )
	{
		if ( cP->wpx )
			TaskFree(pid, cP->wpx);
		cP->wpx = (task_info_type *)0;
	}
	else
	{
		if ( !cP->wpx )
		{
			size = sizeof(task_info_type);
			cP->wpx = (task_info_type *)TaskAlloc(pid, size);
		}
		cP->wpx->data = data;
		cP->wpx->delete_func = delete_func;
		cP->wpx->pid_func = pid_func;
	}
}

char *AxGetTaskData(pid)
int pid;
{
    register context_block *cP;

	cP = &TaskInfo[pid];
	if ( !cP->gfx || !cP->gfx->data )
		return((char *)0);
	else
		return(cP->gfx->data);
}

char *AxGetTaskSSXData(pid)
int pid;
{
    register context_block *cP;

	cP = &TaskInfo[pid];
	if ( !cP->ssx || !cP->ssx->data )
		return((char *)0);
	else
		return(cP->ssx->data);
}

char *AxGetTaskWPXData(pid)
int pid;
{
    register context_block *cP;

	cP = &TaskInfo[pid];
	if ( !cP->wpx || !cP->wpx->data )
		return((char *)0);
	else
		return(cP->wpx->data);
}

AxFreeTaskData(pid)
int pid;
{
	register context_block *cP;
	int err, data_id;

	cP = &TaskInfo[pid];
	if ( cP->gfx )
	{
		/* get rid of the data if the task id matches the current task */
		if ( cP->gfx->data && cP->gfx->pid_func )
		{
			data_id = (*(cP->gfx->pid_func))(cP->gfx->data);
			if ( pid == data_id && cP->gfx->delete_func )
				(*(cP->gfx->delete_func))(data_id);
		}

		/* get rid of the container */
		TaskFree(pid, cP->gfx);
		cP->gfx = (task_info_type *)0;
	}
}

AxFreeTaskSSData(pid)
int pid;
{
	register context_block *cP;
	int err, data_id;

	cP = &TaskInfo[pid];
	if ( cP->ssx )
	{
		/* get rid of the data if the task id matches the current task */
		if ( cP->ssx->data && cP->ssx->pid_func )
		{
			data_id = (*(cP->ssx->pid_func))(cP->ssx->data);
			if ( pid == data_id && cP->ssx->delete_func )
				(*(cP->ssx->delete_func))(data_id);
		}

		/* get rid of the container */
		TaskFree(pid, cP->ssx);
		cP->ssx = (task_info_type *)0;
	}
}

AxFreeTaskWPXData(pid)
int pid;
{
	register context_block *cP;
	int err, data_id;

	cP = &TaskInfo[pid];
	if ( cP->wpx )
	{
		/* get rid of the data if the task id matches the current task */
		if ( cP->wpx->data && cP->wpx->pid_func )
		{
			data_id = (*(cP->wpx->pid_func))(cP->wpx->data);
			if ( pid == data_id && cP->wpx->delete_func )
				(*(cP->wpx->delete_func))(cP->wpx->data);
		}

		/* get rid of the container */
		TaskFree(pid, cP->wpx);
		cP->wpx = (task_info_type *)0;
	}
}


/***************************************************************************
function: AxAppidFromPid 
*/
AxAppidFromPid (pid)
int pid;
{
    if ( (pid >= 0) && (pid < MAX_PIDS) )
		return(TaskInfo[pid].appid);
	return(-1);  /* what should we do here? */
}

/***************************************************************************
function: AxIsGraphicsTask
*/
AxIsGraphicsTask(task_id)
int task_id;
{
	return(TaskInfo[task_id].appid == APGE ? TRUE : FALSE);
}

AxIsSSTask(pid)
int pid;
{
	return(TaskInfo[pid].appid == APSS ? TRUE : FALSE);
}

AxIsWPTask(pid)
int pid;
{
	return(TaskInfo[pid].appid == APDC ? TRUE : FALSE);
}



/*************************************************************************
function: AxFindSSTaskForFile - search for an SS with the given file
if found, return it's uid, else return 0
*/
int AxFindSSTaskForFile(fname)
	char* fname;
{
    int             ix;
    register context_block *p;
	char* sspathname;
	int old_pid, ssUid=0;

	old_pid = THIMpid;
    for ( ix = 1; ix < MAX_PIDS; ix++ ) {
		if (TaskInfo[ix].in_use && TaskInfo[ix].appid == APSS) {
			VfyContext(ix);
			sspathname = (char *)GetSSPathname();
			if ( strcmp(sspathname, fname) == 0 )
				{
					ssUid = TaskInfo[ix].uid;
					break;
				}
		}
	}
	VfyContext(old_pid);
	return(ssUid);
}

/*************************************************************************
function: IsAppidElf - Return whether given appid type is an Elf app
*/
IsAppidElf (appid)
int appid;
{
    register acapps_info *p;

    for ( p = Acapps; p->appid; p++ ) {
        if ( p->appid == appid ) {
            if ( p->thimtype == THIMTYPE_EL )
                return(TRUE);
            else
                return(FALSE);
        }
    }
    return(FALSE);
}



int AxMemoryWarning = 30000000; /* in bytes before warning box */
int AxMemoryLimit = 100000000;      /* in bytes before tearing task down */
int AxLanguage;                 /* set by getenv ("AXLANG") */

/* Euro Method 1: hardware-independent keysym and modifiers */ 
KeySym AxEuroDollarKeysym ;	 	/* processed keysym */ 
int	AxEuroDollarModifiers ; 	/* abstract modifiers */

/* Euro Method 2: hardware-dependent keycode and state */ 
int	AxEuroDollarKeyState ; /* state which X returns */ 
int	AxEuroDollarKeyCode ;  /* code which X returns */


/*************************************************************************
function: UpgradeThimbleProfileVar - Upgrade a variable in the profile file 
          as follows:
            1. Upgrade names (of profile variables) if they have changed
            2. Apply new values to variables, if specified.
*/
static void UpgradeThimbleProfileVar( oldname, code, forceval)
char        *oldname;           /* Old name for this variable (possibly same
                                    as new name!) */
int         code;               /* Profile index for variable */
char        *forceval;          /* If not NULL, desired new val for variable */
{
    char newname[300];      /* New name for variable */
    char *oldval;           /* Old value for variable in profile file */
    typeErr err;
    char *UPbyName();

    /* What is the new name for the variable? */
    if ( err = getStr(code, newname) ) 
        /* error, bail out */
        return;

    /* If the names are the same, update the value if one was supplied */
    if (streq( oldname, newname)) {
        if (forceval) {
            AddProfileByCode( code, forceval);
        }
        return;
    }

    /* Else if the names are different but there is no old value, simply
        add the new name with its desired value to the profile */
    oldval = UPbyName( oldname);
    if (!oldval || !(*oldval)) {
        if (forceval) {
            AddProfileByCode( code, forceval);
        }
        return;
    }

    /* Else the names are different and there is an old value. Remove the
        old entry, but then add the new name with the OLD value */
    ElfbAddProfile( oldname, "");
    ElfbAddProfile( newname, oldval);

    return;
}

/*************************************************************************
function: UpgradeThimbleProfile - Upgrade the profile file if necessary
*/
UpgradeThimbleProfile()
{
    char buf[STRPATH+1];
    char *home;

    /* !!! Tell the user we are messing with the profile file !!! */
    /* ??? Can he prevent this from happening? ??? */

    /* Now update the profile file. Note order of parameters are:
        old name, index in profile, desired value */
    /* Entries copied from macro upgrade_profile$ in upgrade.elfs 2/25/91 */
#if 0       /* DHM 7/15/93: We don't care about 2.0 users, right? */
/* !! REV2.1 -> REV3 !! */
    UpgradeThimbleProfileVar(NXLT("tempDir"),PROF_TEMP_DIR_, NULL);
    UpgradeThimbleProfileVar(NXLT("fontsDir"),PROF_FONTS_DIR_, NULL);
    UpgradeThimbleProfileVar(NXLT("decorateDialogs"),PROF_DLG_DECORATE_, NULL);
    UpgradeThimbleProfileVar(NXLT("iconSize"),PROF_ICON_SIZE_, NULL);
    UpgradeThimbleProfileVar(NXLT("maxPrintCopies"),PROF_MAX_COPIES_, NULL);
    UpgradeThimbleProfileVar(NXLT("printShellCmd"),PROF_PRINT_CMD_, NULL);
    UpgradeThimbleProfileVar(NXLT("meFontCode"),PROF_ME_FONT_, NULL);
    UpgradeThimbleProfileVar(NXLT("printDraftMode"),PROF_PRINT_DRAFT_, NULL);
    UpgradeThimbleProfileVar(NXLT("macrosDir"),PROF_CMDS_DIR_, NULL);
/*  UpgradeThimbleProfileVar(NXLT("modelsDir"),PROF_MODELS_DIR_, NULL); */
    UpgradeThimbleProfileVar(NXLT("dirSortSelect"),PROF_FS_SORT_, NULL);
    UpgradeThimbleProfileVar(NXLT("dirSortUpDown"),PROF_FS_SMODE_, NULL);
    UpgradeThimbleProfileVar(NXLT("defaultPrinter"),PROF_DFLT_PRINTER_, NULL);
    UpgradeThimbleProfileVar(NXLT("defaultLanguage"),PROF_LANGUAGE_, NULL);
    UpgradeThimbleProfileVar(NXLT("printBanner"),PROF_BANNER_, NULL);
    UpgradeThimbleProfileVar(NXLT("dateStyle"),PROF_FMT_DATE_, NULL);
    UpgradeThimbleProfileVar(NXLT("timeStyle"),PROF_FMT_TIME_, NULL);
    UpgradeThimbleProfileVar(NXLT("dayOfWeekStyle"),PROF_FMT_WEEKDAY_, NULL);
    UpgradeThimbleProfileVar(NXLT("englishMetric"),PROF_MEASURE_, NULL);
#if !AXMS
    UpgradeThimbleProfileVar(NXLT("numberStyle"),PROF_NUMBERS_, NULL);
    UpgradeThimbleProfileVar(NXLT("currencySymbol"),PROF_CURRENCY_, NULL);
    UpgradeThimbleProfileVar(NXLT("currencyPosition"),PROF_CURRPOS_, NULL);
    UpgradeThimbleProfileVar(NXLT("cursorPos"),PROF_CURSORPOS_, NULL);
/*  UpgradeThimbleProfileVar(NXLT("styleGuide"),PROF_STYLE_GUIDE_, NULL); */
    UpgradeThimbleProfileVar(NXLT("bellVolume"),PROF_BELL_VOLUME_, NULL);
    UpgradeThimbleProfileVar(NXLT("clickSpeed"),PROF_CLICK_SPEED_, NULL);
    UpgradeThimbleProfileVar(NXLT("menuToggles"),PROF_MENU_TOGGLE_, NULL);
    UpgradeThimbleProfileVar(NXLT("menuWidth"),PROF_MENU_WIDTH_, NULL);
    UpgradeThimbleProfileVar(NXLT("menuShowAccels"),PROF_SHOW_ACCELS_, NULL);
    UpgradeThimbleProfileVar(NXLT("dialog2dstyle"),PROF_2D_STYLE_, NULL);
    UpgradeThimbleProfileVar(NXLT("foreRed"),PROF_FORE_RED_, NULL);
    UpgradeThimbleProfileVar(NXLT("foreGreen"),PROF_FORE_GREEN_, NULL);
    UpgradeThimbleProfileVar(NXLT("foreBlue"),PROF_FORE_BLUE_, NULL);
    UpgradeThimbleProfileVar(NXLT("backRed"),PROF_BACK_RED_, NULL);
    UpgradeThimbleProfileVar(NXLT("backGreen"),PROF_BACK_GREEN_, NULL);
    UpgradeThimbleProfileVar(NXLT("backBlue"),PROF_BACK_BLUE_, NULL);
    UpgradeThimbleProfileVar(NXLT("controlPointer"),PROF_CURS_POINTER_, NULL);
    UpgradeThimbleProfileVar(NXLT("busyPointer"),PROF_CURS_BUSY_, NULL);
    UpgradeThimbleProfileVar(NXLT("wordsPointer"),PROF_CURS_WP_, NULL);
    UpgradeThimbleProfileVar(NXLT("graphicsPointer"),PROF_CURS_GE_, NULL);
    UpgradeThimbleProfileVar(NXLT("spreadsheetPointer"),PROF_CURS_SS_, NULL);
    UpgradeThimbleProfileVar(NXLT("macrosPointer"),PROF_CURS_CE_, NULL);
    UpgradeThimbleProfileVar(NXLT("recordingPointer"),PROF_CURS_ELFREC_, NULL);
    UpgradeThimbleProfileVar(NXLT("recordingOffPointer"),PROF_CURS_NOELFREC_, NULL);
    UpgradeThimbleProfileVar(NXLT("betaMail"),PROF_MAIL_BETA_, NULL);
/*  UpgradeThimbleProfileVar(NXLT("wordsRuler"),PROF_WP_RULER, NULL); */
    UpgradeThimbleProfileVar(NXLT("printerIsColor"),PROF_COLOR_PRINTER_, NULL);
    UpgradeThimbleProfileVar(NXLT("openLook"),PROF_OPEN_LOOK_, NULL);
    UpgradeThimbleProfileVar(NXLT("betaTest"),PROF_BETA_TEST_, NULL);
    UpgradeThimbleProfileVar(NXLT("printersList"),PROF_PRINTER_LIST_, NULL);
    UpgradeThimbleProfileVar(NXLT("revisionStamp"),PROF_REVSTAMP_, NULL);
    UpgradeThimbleProfileVar(NXLT("workForeRed"),PROF_WK_FORE_RED_, NULL);
    UpgradeThimbleProfileVar(NXLT("workForeGreen"),PROF_WK_FORE_GREEN_, NULL);
    UpgradeThimbleProfileVar(NXLT("workForeBlue"),PROF_WK_FORE_BLUE_, NULL);
    UpgradeThimbleProfileVar(NXLT("workBackRed"),PROF_WK_BACK_RED_, NULL);
    UpgradeThimbleProfileVar(NXLT("workBackGreen"),PROF_WK_BACK_GREEN_, NULL);
    UpgradeThimbleProfileVar(NXLT("workBackBlue"),PROF_WK_BACK_BLUE_, NULL);
    UpgradeThimbleProfileVar(NXLT("fileSrchCount"),PROF_SRCH_FILES_, NULL);
    UpgradeThimbleProfileVar(NXLT("fileSrchTime"),PROF_SRCH_SECS_, NULL);
    UpgradeThimbleProfileVar(NXLT("fileSrchDepth"),PROF_SRCH_LEVELS_, NULL);
    UpgradeThimbleProfileVar(NXLT("forceMonochrome"),PROF_NO_COLOR_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlStyleGuide"),PROF_ML_STYLE_GUIDE_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlMessagesToDoc"),PROF_ML_ERRS_TO_DOC_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDiscardLeadingSpaces"),
                                PROF_ML_DISCARD_LEADING_SPACE_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlNewlinesToSpaces"),
                                PROF_ML_NEWLINES_TO_SPACES_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDiscardTrailingSpaces"),
                                PROF_ML_DISCARD_TRAILING_SPACE_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDiscardStartingTextBlock"),
                                PROF_ML_DISCARD_STARTING_BLOCK_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDiscardMiddleTextBlock"),
                                PROF_ML_DISCARD_MIDDLE_BLOCK_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDiscardEndTextBlock"),
                                PROF_ML_DISCARD_END_BLOCK_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlServiceMultiNewlines"),
                                PROF_ML_SERVICE_MULTI_NEWLINES_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlTextForcesTemplate"),
                                PROF_ML_TEXT_FORCES_TEMPLATE_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDuplicateTempAttrs"),
                                PROF_ML_COPY_TEMP_ATTRS_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlAllowZeroFields"),
                                PROF_ML_ALLOW_ZERO_FIELDS_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlFillInitTemp"),
                                PROF_ML_FILL_INITIAL_TEMPLATE_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlDefaultEntryField"),
                                PROF_ML_DEFAULT_ENTRY_FIELD_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlWarnForcedTemp"),
                                PROF_ML_WARN_FORCED_TEMPLATES_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlWarnEmptyFields"),
                                PROF_ML_WARN_EMPTY_FIELDS_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlWarnExtraFields"),
                                PROF_ML_WARN_EXTRA_FIELDS_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlBlankLinesEnd"),PROF_ML_BLANK_LINES_END_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlNumWarnings"),PROF_ML_NUM_WARNINGS_, NULL);
    UpgradeThimbleProfileVar(NXLT("mlNumErrors"),PROF_ML_NUM_ERRORS_, NULL);
    UpgradeThimbleProfileVar(NXLT("spreadsheetCR"),PROF_CR_SS_, NULL);
    UpgradeThimbleProfileVar(NXLT("bgDefaultGraphType"),PROF_GRAF_TYPE_, NULL);
    UpgradeThimbleProfileVar(NXLT("geEpsilon"),PROF_EPSILON_, NULL);
    UpgradeThimbleProfileVar(NXLT("geMaxEdit"),PROF_MAXEDIT_, NULL);
    UpgradeThimbleProfileVar(NXLT("geFullGrids"),PROF_FULLGRIDS_, NULL);
    UpgradeThimbleProfileVar(NXLT("gePaletteLock"),PROF_TOOL_LOCK_, NULL);
/*  UpgradeThimbleProfileVar(NXLT("wpUseStyleGuides"),PROF_WP_USE_STYLE_GUIDES, NULL); */
    UpgradeThimbleProfileVar(NXLT("wpReturnKeyNavigates"), PROF_WP_RETURN_KEY_NAV, NULL);
    UpgradeThimbleProfileVar(NXLT("geXWDInvert"),PROF_XWD_INVERT_, NULL);
    UpgradeThimbleProfileVar(NXLT("spreadsheetGRIDS"),PROF_GRIDS_SS_, NULL);
    UpgradeThimbleProfileVar(NXLT("wpAutoSaveMinutes"),PROF_WP_AUTO_SAVE, NULL);
    UpgradeThimbleProfileVar(NXLT("spreadsheetASCDEL"),PROF_DELIMITER_SS_, NULL);
    UpgradeThimbleProfileVar(NXLT("textCursorTriangle"),PROF_TCURSOR_TRIANGLE_, NULL);
    UpgradeThimbleProfileVar(NXLT("wpZoom"),PROF_WP_ZOOM, NULL);
/*  UpgradeThimbleProfileVar(NXLT("wpViewPagenate"),PROF_WP_PAGENATE, NULL); */
/*  UpgradeThimbleProfileVar(NXLT("wpViewFormatChars"),PROF_WP_FORMAT_CHARS, NULL); */
    UpgradeThimbleProfileVar(NXLT("wpWindowPosSize"),PROF_WP_WINDOW_SIZE, NULL);
    UpgradeThimbleProfileVar(NXLT("wpViewGraphicInsets"),PROF_WP_GRAPHIC_INSETS, NULL);
    UpgradeThimbleProfileVar(NXLT("wpViewIndexFields"),PROF_WP_INDEX_FIELDS, NULL);
    UpgradeThimbleProfileVar(NXLT("wpViewHeaderFooter"),PROF_WP_HEADER_FOOTER, NULL);
    UpgradeThimbleProfileVar(NXLT("wpInitCursor"),PROF_WP_INIT_CURSOR, NULL);
/*  UpgradeThimbleProfileVar(NXLT("wpScale"),PROF_WP_SCALE, NULL); */
    UpgradeThimbleProfileVar(NXLT("wpSpellMisspell"),PROF_WP_SPELL_TOK11,1);
    UpgradeThimbleProfileVar(NXLT("wpSpellRepeatedWords"),PROF_WP_SPELL_TOK5,-1);
    UpgradeThimbleProfileVar(NXLT("wpSpellNumber"),PROF_WP_SPELL_TOK7,"0");
    UpgradeThimbleProfileVar(NXLT("wpSpellDate"),PROF_WP_SPELL_TOK8,"0");
    UpgradeThimbleProfileVar(NXLT("wpSpellTime"),PROF_WP_SPELL_TOK9,"0");
    UpgradeThimbleProfileVar(NXLT("wpSpellNotAlphabet"),PROF_WP_SPELL_TOK10,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadStart"),PROF_WP_SPELL_TOK12,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellRoman"),PROF_WP_SPELL_TOK13,"0");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadPunctPrefix"),PROF_WP_SPELL_TOK14,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadPunctSuffix"),PROF_WP_SPELL_TOK15,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellOutline"),PROF_WP_SPELL_TOK16,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadPrefSuff"),PROF_WP_SPELL_TOK17,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadParens"),PROF_WP_SPELL_TOK22,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellGoodParens"),PROF_WP_SPELL_TOK23,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadCompound"),PROF_WP_SPELL_TOK26,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellSlash"),PROF_WP_SPELL_TOK28,"0");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadHyphen"),PROF_WP_SPELL_TOK34,"-1");
    UpgradeThimbleProfileVar(NXLT("wpSpellBadPossessive"),PROF_WP_SPELL_TOK42,"-1");
    UpgradeThimbleProfileVar(NXLT("axColorHighContrast"),PROF_CONTRAST_,"1");
    UpgradeThimbleProfileVar(NXLT("grEnable64Colors"),PROF_ENABLE_COLOR_,"-1");
    UpgradeThimbleProfileVar(NXLT("grColorXWD"),PROF_COLOR_XWD_,"-1");
    UpgradeThimbleProfileVar(NXLT("grColorTIFF"),PROF_COLOR_TIFF_,"-1");
    UpgradeThimbleProfileVar(NXLT("grEnableZoom"),PROF_ENABLE_ZOOM_,"-1");
#endif  /* DAMNT, for now!! */
#endif

/* !! REV2.1 -> REV3 !! */

    UpgradeThimbleProfileVar(NXLT("wpViewFormatChars"),
                                            PROF_WP_VIEW_FORMAT_CHARS, NULL);
    UpgradeThimbleProfileVar(NXLT("wpRulerOn"), PROF_WP_VIEW_RULER, NULL);
    UpgradeThimbleProfileVar(NXLT("wpStyleGuide"), PROF_WP_NEW_TEMPLATE, NULL);
    UpgradeThimbleProfileVar(NXLT("wpStyleGuideUseContents"),
                                        PROF_WP_NEW_TEMPLATE_CONTENTS, NULL);

    return;
}

/*************************************************************************
function: AxFindLanguageDir - search for a language directory
*/
static int AxFindLanguageDir(lang_ix)
int *lang_ix;
{
    char dirname[STRPATH+1];
    int ix, state;

    state = AOK;
    ix = *lang_ix;
    for ( ix = 1; ix <= MAX_LANGS; ix++ )
        {
        sprintf(dirname, "%s%s%s", ThimApplixDir, DirSlash, AxLangSuffix[ix]);
        if ( ElfbDirExists(dirname) && (0 == Aaccess(dirname, R_OK)) )
           {
           /* found a good language directory */
           *lang_ix = ix;
           return( AOK );
           }
        }

    /* did not find a valid language directory */
    return( !AOK );
}

/***********************************************************************
function: SetAccessDirPath - Set variable 'ThimAccessDirPath'.  This
is looked by AxAccessAllowed() to check whether document or directory access is
allowed or not.
'pathstr' can be of the following forms:
"/tmp:/home/sanjay:/ax/axexec"
or
"/home/sanjay"
Like the shell variable PATH.
If ThimAccessDirPath is non-null, access will be allowed to documents
contained inside the specified directories.
*/
static void
SetAccessDirPath(pathstr)
char *pathstr;
{
	int npaths = 1;
	int cnt;
	char *p;
	char tmpstr[STRPATH + 1];
	char *tp = tmpstr;
    char separator;

	ThimAccessDirPath = NULL;
	if (!pathstr)
		return;
	if (!strlen(pathstr))
		return;

	strcpy(tmpstr, pathstr);

#if AXMS
    separator = ';';
#else
    separator = ':';
#endif
/* Count the number of separator chars in the path list */
	for (p = pathstr; *p; p++)
		if (*p == separator)
			npaths++;

/* Form the ThimAccessDirPath vector */
	ThimAccessDirPath = (char **) calloc(1, sizeof(char *) * (npaths + 1));
	cnt = 0;
	tp = tmpstr;
	while ((p = strchr(tp, separator)) != NULL) {
		*p = '\0'; /* step over separator */
		ThimAccessDirPath[cnt++] = strcpy(malloc(strlen(tp) + 1), tp);
		p++;
		tp = p;
	}
	if (*tp)
		ThimAccessDirPath[cnt] = strcpy(malloc(strlen(tp) + 1), tp);
	return;
}

/*************************************************************************
function: SetThimbleDirs - Set globals and create temp dirs
*/
SetThimbleDirs (execpath)
char *execpath;     /* argv[0] of main */
{
    int test_lang;
	char keycode[100], *keycodeP;
	static char locIMap[CTYPESIZE];
	static int sortmap_initialized = FALSE;
    static char *YesStr = "Y";  /* ??i */
    static typeErr codes[] = {  /* see AxSyncAgainstProfile() */
        PROF_WP_TEMPLATES_DIR,PROF_BACKUP_DIR_,PROF_CMDS_DIR_,
        PROF_AX_MEMWARN,PROF_AX_MEMLIMIT,0
    };
    static char *EnvStr[] = {
		"AXLANG=1",
		"AXLANG=1", "AXLANG=2", "AXLANG=3", "AXLANG=4", "AXLANG=5",
		"AXLANG=6", "AXLANG=7", "AXLANG=8", "AXLANG=9", "AXLANG=10",
		"AXLANG=11", "AXLANG=12", "AXLANG=13", "AXLANG=14", "AXLANG=15",
		"AXLANG=16", "AXLANG=17", "AXLANG=18", "AXLANG=19", "AXLANG=20"
	};
    char *p, *AxL, *tmpname, *home, *axhome, *new_home_name, *AxReadProfile();
    char buf[STRPATH+1], buf2[STRPATH+32], dir[STRPATH+1], drive[5];
    int new_home, new_prof;
	FILE	*fp;

#if AXMS
    /*==================================================================*/
    /*  turn on a Windows run time debug flag based on environment      */
    /*==================================================================*/
    if ( getenv("WINVERBOSE") != NULL )
         WinVerbose = TRUE;
#endif

    /*==================================================================*/
    /* find out where we are in the file system                         */
    /*==================================================================*/
    if ( !getcwd(dir, STRPATH+1) )
    {
        sprintf(buf,
                NXLT("Can not determine current directory, code %d"),
                errno);
        tempAbort(buf);
    }
    p = dir;
    strcpy(AxCurrentDir, p);
    if ( strlen(AxCurrentDir) > MAX_DIR_LEN )
    {
        sprintf(buf2, NXLT("%s:\nPathname too long\n"), AxCurrentDir);
        tempAbort(buf2);
    }

#if AXMS
    strcpy( drive, AxNTgetDrive() );

    /* make sure that the path contains the drive letter, since later */
    /* on the user may move to other drives and we need to be able to */
    /* generate correct paths back to things like filters - jon       */
	/* don't add a drive letter if we have a UNC name (i.e. \\machine_name) */
    if ( ((dir[0] == '\\') || (dir[0] == '/')) &&
		 dir[1] != ':' && dir[1] != '\\' )
       {
       strcpy( buf2, drive );
       strcat( buf2, dir );
       strcpy( dir, buf2 );
       }
#endif
       
    ParsePath(execpath, dir, buf); /* take entry name off */

    /*==================================================================*/
    /* now get the primary executable director, ie. "axdata"            */
    /*==================================================================*/
    ParsePath(dir,dir,ThimApplixDirEntName);
    if ( dir[0] == (char)0 )
    {
        sprintf(buf2, NXLT("Start product with full path to ``axmain''."));
        tempAbort(buf2);
    }
	ThimExecDir = strcpy(malloc(strlen(dir) + 1), dir);

    /*==================================================================*/
    /* Note where the general thimble and customizable thimble data are */
    /*==================================================================*/
    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimApplixDirEntName); 
    ThimApplixDir = strcpy(malloc(strlen(buf)+1), buf);
#if AXMS
    if ( WinVerbose )
        {
        sprintf( buf, "ThimApplixDir = <%s>", ThimApplixDir );
        DebugMessage( buf );
        }
#endif

    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimLangDirEntName);   
    ThimLangDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimFiltDirEntName);   
    ThimFiltersDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimCustomDirEntName); 
    ThimCustomDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimClipArtDirEntName); 
    ThimClipArtDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimPresTempDirEntName); 
    ThimPresTempDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimPresTempDir, DirSlash, ThimPresColorDirEntName); 
    ThimPresColorDir = strcpy(malloc(strlen(buf)+1), buf);
    strcpy(AxPresTemplateDir, ThimPresColorDir);

    sprintf(buf,"%s%s%s", ThimPresTempDir, DirSlash, ThimPresMonoDirEntName); 
    ThimPresMonoDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimPresTempDir, DirSlash, ThimPres35mmDirEntName); 
    ThimPres35mmDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimPresTempDir, DirSlash, ThimPresBklitDirEntName); 
    ThimPresBklitDir = strcpy(malloc(strlen(buf)+1), buf);

	/*	moved ThimPresOutlineDir init to after language recognition since
	 *	this dir is lang-dep.
	 */

    sprintf(buf,"%s%s%s",ThimPresTempDir, DirSlash, ThimPresSchemeDirEntName); 
    ThimPresSchemeDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s",ThimPresTempDir, DirSlash, ThimPresChartDirEntName); 
    ThimPresChartDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", ThimExecDir, DirSlash, ThimEnterpriseDirEntName);   
    ThimEnterpriseDir = strcpy(malloc(strlen(buf)+1), buf);

	/*	moved ThimEnterpriseAppFilename init to after language recognition
	 *	since this dir is lang-dep.
	 */

    sprintf(buf,"%s%s%s", ThimEnterpriseDir, DirSlash,
				ThimEnterpriseAppsDirEntName);
    ThimEnterpriseAppsDir = strcpy(malloc(strlen(buf)+1), buf);

    /*==================================================================*/
    /* read the user profile - if AXLANG's not set, this will end up    */
	/*                         reading the English version              */
    /*==================================================================*/
    new_home_name = AxReadProfile(&ThimNewUser, &new_home);

    /*==================================================================*/
    /* get the language data and set the language directories and files */
    /* AxLanguage may already be non-zero because it was set from then  */
    /* command line, but, for historical reasons, that has the lowest   */
    /* precidence                                                      */
    /*==================================================================*/

    AxL = getenv(NXLT("AXLANG"));
    if ( AxL != (char *)NULL )
        {
        /* environment is set, next to highest precidence */
        test_lang = atoi(AxL);
        if ( (test_lang >= 1) && (test_lang <=MAX_LANGS) )
           /* valid setting */
           AxLanguage = test_lang;
        }

	/* check the profile */
    AxL = UPbyName(NXLT("axDisplayLanguage"));
    if ( AxL != (char *)NULL ) {	/* if set, highest precedence */
        test_lang = atoi(AxL);
        if ( (test_lang >= 1) && (test_lang <=MAX_LANGS) ) {
            /* valid setting */
           AxLanguage = test_lang;
        }
    }

    if ( AxLanguage < 1 || AxLanguage >= MAX_LANGS )
        AxLanguage = 1;
    sprintf(buf, "%s%s%s", ThimApplixDir, DirSlash, AxLangSuffix[AxLanguage]);
    if ( !ElfbDirExists(buf) || (0 != Aaccess(buf, R_OK)) )
    {
        /* recheck all languages starting with English */
        if ( AxFindLanguageDir(&AxLanguage) != AOK )
        {
            sprintf(buf2, NXLT("Language directory %s not found"), buf);
            tempAbort(buf2);
        }
		else
		{
			/*	2100787: if AXLANG is missing, it's never reset although
			 *	we find the correct language directory by brute search in
			 *	AxFindLanguageDir and reset AxLanguage.
			 *	
			 *	So: if we got here, we need to reset AXLANG depending on
			 *	the newly defined AxLanguage, and we need to re-read
			 *	the profile now that we've got the correct pathname
			 *	so that we get the correct axDisplayLanguage and axLanguage
			 */
			putenv(EnvStr[AxLanguage]);
			ResetUPdata();	/*	force re-read by nulling all profile entries */
			new_home_name = AxReadProfile(&ThimNewUser, &new_home);
		}
    }
    sprintf(buf,"%s%s%s", ThimApplixDir, DirSlash, AxLangSuffix[AxLanguage]);   
    AxLangDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s", AxLangDir, DirSlash, "Demos");  
    if ( !ElfbDirExists(buf) || (0 != Aaccess(buf, R_OK)) )
    {
        sprintf(buf2, NXLT("Sample macros directory %s not found"), buf);
#if 0
		/* No need to bring down the product */
        tempAbort(buf2);
#endif
    }
    AxLangDemosDir = strcpy(malloc(strlen(buf)+1), buf);

	/*	Not an error if doesn't exist */
    sprintf(buf,"%s%s%s", ThimCustomDir, DirSlash, AxLangSuffix[AxLanguage]);  
    AxLocalLangDir = strcpy(malloc(strlen(buf)+1), buf);

    if ( AxLanguage <= 1 )
        sprintf(buf, "%s%saxstrfl", AxLangDir, DirSlash);
    else
        sprintf(buf, NXLT("%s%saxstrfl.%s"),
                AxLangDir,
                DirSlash, 
                AxLangSuffix[AxLanguage]);
    AxStrflName = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s%s%s",ThimPresTempDir, DirSlash, 
				ThimPresOutlineDirEntName, DirSlash,
				AxLangSuffix[AxLanguage]); 
    ThimPresOutlineDir = strcpy(malloc(strlen(buf)+1), buf);

    sprintf(buf,"%s%s%s%s%s", ThimEnterpriseAppsDir, DirSlash,
			AxLangSuffix[AxLanguage], DirSlash, ThimEnterpriseAppFileEntName);
    ThimEnterpriseAppFilename = strcpy(malloc(strlen(buf)+1), buf);


	/*	Sort tables for *strcmp()/*strncm() */
	if(sortmap_initialized == FALSE)
	{
		sortmap_initialized = TRUE;
		sprintf(buf,"%s/%s",ThimApplixDir,SORT_ORDER_FILE);
if (getenv("CATCH_FOPEN")) {
	static int spin=1;
	while (spin);
}
		if(!(fp = fopen(buf,READ_STR)))
		{
			sprintf(buf2, NXLT("Character sort info file %s not found"), buf);
			tempAbort(buf2);
		}
				 
		 read_Imap(fp);
		 fclose(fp);
	}

    /*==================================================================*/
    /* force profile file save to disk (new users and new home dirs)    */
    /*==================================================================*/
    AxSyncProfile(ThimNewUser, new_home, new_home_name);

    /*==================================================================*/
    /* From this point on, it is OK to do an XLT of a string            */
    /*==================================================================*/
    XLTInit(AxLangDir, AxLangSuffix[AxLanguage]);

    /*==================================================================*/
    /* verify the real home dir                                         */
    /* #103934 - no need to verify writeability; we only write to axhome*/
    /*==================================================================*/
    home = AGetHomeDir();
    if ( !home || !home[0] )
    {
        sprintf(buf,XLT("Can not find HOME directory - %s"),home);
        tempAbort(buf);
    }

    /*==================================================================*/
    /* verify the axhome dir (making sure it is writable, too)          */
    /*==================================================================*/
    axhome = AGetAxHomeDir();
    ThimUserDir = strcpy(malloc(strlen(axhome)+1), axhome);
    if ( -1 == Aaccess(ThimUserDir, F_OK) )
    {
        if ( -1 == mkdir (ThimUserDir, 0755) )
        {
            sprintf(buf, "axhome: %s: %s", ErrnoTextFromUnix(errno), axhome);
            tempAbort(buf);
        }
    }
    if ( -1 == Aaccess(ThimUserDir,W_OK) )
    {
        sprintf(buf,
                XLT("Can not write to your home data directory - %s"),
                ThimUserDir);
        tempAbort(buf);
    }

	p = (char *) getenv("AX_ACCESS_DIRPATH");
	SetAccessDirPath(p);

#if AXMS
    if ( WinVerbose )
        {
        sprintf( buf, "ThimUserDir = <%s>", ThimUserDir );
        DebugMessage( buf );
        }
#endif

    /*==================================================================*/
    /* Upgrade profile file                                             */
    /*==================================================================*/
    UpgradeThimbleProfile();

    /*==================================================================*/
    /* Read Selections, Profile & Create tempdir                        */
    /*==================================================================*/
    tmpname = AGetTempDir();
    AxSysDosUnixPath(tmpname);
    strcpy(ThimTempDir, tmpname);
    if ( !ElfbDirExists(ThimTempDir) || (0 != Aaccess(ThimTempDir, W_OK)) )
    {
        sprintf(buf,
               XLT("Can not write to your axTempDir:%s"),
               ThimTempDir);
        tempAbort(buf);
    }
    MakeAbsolutePathname(ThimTempDir,ThimTempDir,TRUE);
#if AXMS
    if ( WinVerbose )
        {
        sprintf( buf, "ThimTempDir = <%s>", ThimTempDir );
        DebugMessage( buf );
        }
#endif


    /*==================================================================*/
    /* Note Elf and Model docs dirs - full STRPATH for future strcpy's  */
    /*==================================================================*/
    if ( ThimSessionElfDir )
    {
        /* "-elfdir DIRNAME" on the command line, make it the macros dir */
        ThimUserElfDir = strcpy((char *)malloc(STRPATH+1), ThimSessionElfDir);
    }
    else
    {
        /* Normal processing.  Look at the profile value. */
        p = UPneedByCode(PROF_CMDS_DIR_);
        ThimUserElfDir = strcpy((char *)malloc(STRPATH+1),p);
        if ( strcmp (ThimUserElfDir, "") == 0 )
        {   
            sprintf(buf,"%s%s%s",axhome,DirSlash,NXLT("macros"));   
            AxSysDosUnixPath(buf);
            ThimUserElfDir = strcpy(malloc(strlen(buf)+1),buf);
            AddProfileByCode(PROF_CMDS_DIR_, buf);
        }
    }

    p = UPneedByCode(PROF_WP_TEMPLATES_DIR);
    ThimUserModelsDir = strcpy((char *)malloc(STRPATH+1),p);
    if ( strcmp (ThimUserModelsDir, "") == 0 )
    {
        sprintf(buf,"%s%s%s",axhome,DirSlash,NXLT("template")); 
        AxSysDosUnixPath(buf);
        ThimUserModelsDir = strcpy(malloc(strlen(buf)+1),buf);
        AddProfileByCode(PROF_WP_TEMPLATES_DIR,buf);
    }

    p = UPneedByCode(PROF_BACKUP_DIR_);
    ThimUserBackupDir = strcpy((char *)malloc(STRPATH+1), p);
    if ( strcmp (ThimUserBackupDir, "") == 0 )
    {
        sprintf(buf,"%s%s%s",axhome,DirSlash,NXLT("backup"));   
        AxSysDosUnixPath(buf);
        ThimUserBackupDir = strcpy(malloc(strlen(buf)+1),buf);
        AddProfileByCode(PROF_BACKUP_DIR_,buf);
    }

    /*==================================================================*/
    /* set the memory limits                                            */
    /*==================================================================*/
#if JavaMode
	AxMemoryWarning = 900000000;
	AxMemoryLimit = 900000000;
#else
    AxMemoryWarning = atoi(UPneedByCode(PROF_AX_MEMWARN));
    AxMemoryLimit = atoi(UPneedByCode(PROF_AX_MEMLIMIT));
    if ( !AxMemoryWarning )
        AxMemoryWarning = 30000000;
    else
        AxMemoryWarning *= 1000000;
    if ( !AxMemoryLimit )
        AxMemoryLimit = 100000000;
    else
        AxMemoryLimit *= 1000000;
#endif

    /*==================================================================*/
	/* set the euro $ key sequence codes */
    /*==================================================================*/

	/* Method 1: Hardware-independent */
	AxEuroDollarKeysym = 0;
	AxEuroDollarModifiers = 0;
	keycodeP = UPneedByCode(PROF_EURO_DOLLAR_CURRENCY_KEYSYM_);
	if (keycodeP && *keycodeP) {
		menu_item_def m;

		/* Treat the profile as if it was a menu accelerator
			(e.g. '*E' for alt-E) and bust it up into modifier
			and keysym parts */
		if (ParseKeySequence( keycodeP, &m)) {
			AxEuroDollarKeysym = m.accel_key;
			AxEuroDollarModifiers = m.accel_modifiers;

#if 0						/* Too early - not connected yet */
			/* Notify Java */
			if ( JavaMode ) {
				AxJavaEuroKeysym();
			}
#endif
		}
	}

	/* Method 2: Hardware-dependent */
	/* Although it is tempting to try to set a nice default (Right-Alt + E
		will be used by some European products), the keymaps vary for
		different platforms so most users would end up with a random
		key inserting a Euro instead of behaving as a mnemonic or
		accelerator. Resist the temptation; allow the user to set the
		profile properly for his own hardware. */

	AxEuroDollarKeyState = 0;
	AxEuroDollarKeyCode = 0;
	keycodeP = UPneedByCode(PROF_EURO_DOLLAR_CURRENCY_KEYSEQ_);
	if (keycodeP && *keycodeP) {
		int ii, ivalue;
		char *item;

		ii = 0;
		strcpy(keycode, keycodeP);
		while (	item = strtok(((ii==0) ? keycode : NULL), ",")) {
			ii++;
			if (strlen(item) == 0) continue;
			ivalue = atoi(item);
			if (ivalue < 0 || ivalue > 255) continue ;
			if (ii == 1) {
				AxEuroDollarKeyCode = ivalue;
			} else if (ii == 2) {
				AxEuroDollarKeyState = ivalue;
			}
		}
	}


    /*==================================================================*/
    /* Update the above vars when the profile has been changed          */
    /*==================================================================*/
    AxProfileInterest(codes);

#if AXMS
	/* set the shared library path, in case axmain was started by itself. */
	if ( !axmsSetSharedLibraryPath() )
		tempAbort(XLT("Could not set shared library path. You may need to set it manually."));
#endif

    /*==================================================================*/
	/* See if spelling shared library is available. If not, spelling,   */
	/*	thesaurus and hyphenation functionality will not be available,  */
	/* 	though it is OK to run Applixware.                              */
    /*==================================================================*/
	ThimSpellingLibraryFilename = strcpy(malloc(strlen(AXSHLIB_PROX)+1), AXSHLIB_PROX);
	libspell_handle = Adlopen(AXSHLIB_PROX, ADL_BIND_DEFERRED);
	if ( libspell_handle == NULL )
		ThimNoSpellingLibrary = TRUE;
	else
	{
		ThimNoSpellingLibrary = FALSE;
		Adlclose(libspell_handle);
	}

#if 0	/* edit redone where profile read in colorcom.c and tmcolor.c */
	if ( JavaMode ) {
		AddProfileByCode(PROF_STANDARD_COLORMAP_,"XA_RGB_APPLIX_MAP");
		AddProfileByCode(PROF_LOAD_WIDGET_COLORS_,"-1");
		AddProfileByCode(PROF_LOAD_APP_COLORS_,"-1");
		AddProfileByCode(PROF_COLOR_CUBE_HEIGHT_,"6");
	}
#endif
}

/*************************************************************************
function: AxVerifySharedLibrary - Verify desired shared library exists

Pass the "stem" name of the library; e.g. "axwp" for the WP.
This function will attempt to locate the library with or without
the "lib" prefix, using the proper extension for the platform;
e.g. "axwp.so" and "libaxwp.so" on Solaris.

Returns TRUE if the library was located and loadable.
Else returns FALSE.
*/
int AxVerifySharedLibrary( stem)
char *stem;
{
	char *fullName=NULL;
	char *lib_handle=NULL;

	if (!stem || !*stem)
		return( FALSE);

	/* Allocate enough memory for "lib" + name + ext */
	fullName = malloc(3 + strlen(stem) + strlen(SHLIB_EXT) + 1);
	if (!fullName)
		return( FALSE);

	/* Try without the lib prefix first. Note this will succeed even if
		the user passes the stem with the prefix; e.g. "libaxwp" */
	sprintf( fullName, "%s%s", stem, SHLIB_EXT);  /* SHLIB_EXT = ".so", e.g. */
	lib_handle = Adlopen(fullName, ADL_BIND_DEFERRED);
	if ( lib_handle ) {
		Adlclose(lib_handle);
		free( fullName);
		return( TRUE);
	}

	/* Now try with the "lib" prefix */
	sprintf( fullName, "lib%s%s", stem, SHLIB_EXT);
	lib_handle = Adlopen(fullName, ADL_BIND_DEFERRED);
	if ( lib_handle ) {
		Adlclose(lib_handle);
		free( fullName);
		return( TRUE);
	}
	free( fullName);
	return( FALSE);
}

/*************************************************************************
function: AxJavaEuroKeysym - Send keystroke info to Java
*/
void AxJavaEuroKeysym()
{
	data_ptr infoP;
	infoP = AxMakeArray(5);
	AxAddIntToArray(infoP,0,AxEuroDollarKeysym);
	AxAddIntToArray(infoP,1,AxEuroDollarModifiers);

	/* The preferred value for the Euro is 0x80 but on Java we can't
		send down the glyph so we see nothing. Use the alternate (0xA4)
		so we'll at least see the Int'l Currency Symbol ("Sputnik") */
	AxAddIntToArray(infoP,2,0xa4);
	AxAddIntToArray(infoP,3,EURO_SYMBOL_8BIT_VALUE);

	/* This flag controls whether Java should attempt to display the
		Euro. There will be a performance hit if it does so, as
		strings that are of fonts resident upon the client will
		have to be scanned for the Euro symbol, and those glyphs 
		will have to be sent from the server. I have no idea if
		this performance hit will be noticable. */
	AxAddBoolToArray(infoP,4,TRUE);

	AxJavaCoreNotifier(JV_EURO_KEYSYM,infoP);
}

/*************************************************************************
function: AxSetElfAbortHandler - set the elfAbortHandler field in the 
                                TaskInfo struct for this task
*/
void AxSetElfAbortHandler(func)
void (*func)();
{
    TaskInfo[THIMpid].elfAbortHandler = func;
}

/*************************************************************************
function: AxElfAbort -  call the task specific elf abort handler 
*/
void AxElfAbort(code, object, overrideStr)
int code;
char *object, *overrideStr;
{
	void (*func)();

    func =TaskInfo[THIMpid].elfAbortHandler;
    if(!func)   /* no error handler installed, call default handler */
        tempAbort(overrideStr); /* this doesn't return */

    /* do the application specific elf abort */
    (*func)(code, object, overrideStr); /* this doesn't return */
}

/*************************************************************************
function: AxTaskAcceptPokes - add array of poke codes to taskinfo struct.
*/
void AxTaskAcceptPokes (pid, pokeCodes)
int pid;
data_ptr pokeCodes;
{
	AxTaskFreeElfData(pid,TaskInfo[pid].pokeCodes);
	TaskInfo[pid].pokeCodes = AxTaskCopyElfData(pid,pokeCodes);
}

/*************************************************************************
function: AxGetDevicePaths - Get primary & secondary font paths for device
*/
AxGetDevicePaths (primary,secondary)
char *primary, *secondary;  /* may be same */
{
#if PMAX | VAX | ALPHA | NEC_EWS | LINUX
        sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if SUN3 || SUN4 || SUNIS
#if SUN4S || SUNIS /* { */
                sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
                strcpy(secondary,primary);
#else
        sprintf(primary,NXLT("%s/axfonts/sun_ow"),ThimExecDir);
        strcpy(secondary,primary);
#endif /* SUN4S  } */
#else
#if HP800V3
        sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
        strcpy(secondary,primary);  
#else
#if HP300 | HP800
        sprintf(primary,NXLT("%s/axfonts/hp_snf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if MIPS
        sprintf(primary,NXLT("%s/axfonts/sun_snf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if X386_NEW && !USL54
        sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if SGI
        sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if RIOS
        sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if AUX
        sprintf(primary,NXLT("%s/axfonts/aux_snf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if M_88K && !AVIION
        sprintf(primary,NXLT("%s/axfonts/sun_snf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if CLIX
        sprintf(primary,NXLT("%s/axfonts/clix_snf"),ThimExecDir);
        strcpy(secondary,primary);
#else
#if AVIION
                sprintf(primary,NXLT("%s/axfonts/all_pcf"),ThimExecDir);
                strcpy(secondary,primary);

#else
#if USL54
                sprintf(primary,NXLT("%s/axfonts/svr4_snf"),ThimExecDir);
                strcpy(secondary,primary);
#else


        tempAbort(NXLT("Oh no, this machine has no default font path!"));
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
}

/*************************************************************************
function: InitThimble - Init task manager's data areas
*/
typeErr InitThimble()
{
	/* ELF and GE */
    BlockList[THIMTYPE_EL][0] = BlockList[THIMTYPE_GE][0] = ElfMemBlockInfo();
    BlockList[THIMTYPE_EL][1] = BlockList[THIMTYPE_GE][1] = 0;

	/* WP */
#if 0
    BlockList[THIMTYPE_WP][0] = WpMemBlockInfo();
    BlockList[THIMTYPE_WP][1] = ElfMemBlockInfo();
    BlockList[THIMTYPE_WP][2] = 0;
#else
    BlockList[THIMTYPE_WP][0] = ElfMemBlockInfo();
    BlockList[THIMTYPE_WP][1] = 0;
#endif

	/* SS */
    BlockList[THIMTYPE_SS][0] = ElfMemBlockInfo();
    BlockList[THIMTYPE_SS][1] = 0;
}

/*************************************************************************
function: THIMstart - "Fork" for a new copy of a tasks DATA & BSS
Set this as the new current Task (THIMpid).
Pids begin counting at 1.  The pid 0 is generally associated with the
ATM's kernel state.
*/
typeErr THIMstart(appid,pid)
int appid;      /* scac.h type of context to start */
int *pid;       /* ret'd task id */
{
    register int ix, jx, apptype;
    register acapps_info *acP;
    ax_mem_block_info_t **blocklist;
    char **my_blocks;
    ax_mem_block_info_t *p;
#if AXMS
    int optind, opterr;
#else
    extern int optind, opterr;
#endif  /* DAMNT */
    char *ut_getopt_place;

/* Determine image type from appid */

    for ( acP = Acapps; acP->appid; acP++ ) {
        if ( acP->appid == appid ) {
            apptype = acP->thimtype;
            goto got_type;
        }
    }
    return(THIM_NO_PID);        /* ?? better code */
got_type:

/* Select id for this task */

    for ( ix = 1; ix < MAX_PIDS; ix++ )
        if ( !TaskInfo[ix].in_use )
            break;
    if ( ix == MAX_PIDS )
        return(THIM_NO_PID);
    *pid = ix;

/* Create per-context memory */

    for ( ix = 0; BlockList[apptype][ix]; ix++ );   /* count how many */
    blocklist = (ax_mem_block_info_t **)
                    malloc((ix+1)*sizeof(ax_mem_block_info_t *));
    my_blocks = (char **)malloc((ix+1)*sizeof(char *));

    for ( ix = 0; BlockList[apptype][ix]; ix++ ) {
        p = BlockList[apptype][ix];
        blocklist[ix] = p;
        my_blocks[ix] = (char *)malloc(p->size);
        if ( p->is_zeros ) {
            if ( p->backup )
                memcpy(p->backup,p->addr,p->size);
            memset(p->addr,0,p->size);
        }
        else {
            if ( !p->virgin ) { /* first time block used, back it up */
                p->virgin = (char *)malloc(p->size);
                memcpy(p->virgin,p->addr,p->size);
            }
            else {
                if ( p->backup )
                    memcpy(p->backup,p->addr,p->size);
#if !ALPHA && !(LINUX && __alpha__)
                memset(p->addr,(int)p->virgin,p->size);
#else
				/* Not certain why p->addr is being memset to p->virgin, but
				   it's meaningless on 64-bit platforms anyway where pointers
				   are 16-bits, and would be truncated here */
                memset(p->addr,0,p->size);
#endif
            }
        }
        p->backup = my_blocks[ix];
    }
    blocklist[ix] = 0;
    my_blocks[ix] = 0;

/* go for it! */

    optind = 1;
        opterr = 0;
        ut_getopt_place = "";
    THIMpid = currentContext = ix = *pid;
    memset(&TaskInfo[ix],0,sizeof(context_block));
    TaskInfo[ix].appid = appid;
    TaskInfo[ix].block_types = blocklist;
    TaskInfo[ix].my_blocks = my_blocks;
    THIMappid = appid;
    TaskInfo[ix].in_use = TRUE;
	/* change from Prepend to Append, to start tasks in the FIFO order.
	   The new tasks are given higher priority than pended tasks in axmain().
	   So this should not change the existing order of execution of tasks,
	   as normally there can be only one task waiting to be started,
	   except in the case of new macro newtask_unpended@, where the new tasks
	   are added without pending the current task.
	   */
    AppendToActiveTasks(TaskInfo+ix);
    for ( jx = 0; jx < MAX_OPEN_FILES; jx++ )
        TaskInfo[ix].fds[jx] = -1;
    TaskInfo[ix].uid = THIMpidUID = ++PidUID;
    return(AOK);
}


/*************************************************************************
function: ThimNoteParasite - Make a task a child of another
This is only used to be able to shoot down local insets in the DC.
*/
ThimNoteParasite (child,parent)
int child,parent;
{
    if ( parent >= 0 )
        TaskInfo[child].parasite_of = parent;
}

/*************************************************************************
function: ThimKillOffParasites - Shoot down child tasks
*/
ThimKillOffParasites (mypid)
int mypid;
{
    register int ix;

    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use && (TaskInfo[ix].parasite_of == mypid) )
            KillTask(ix);
    }
}

/*************************************************************************
function: ThimGetHost - return the host of this parasite
*/
ThimGetHostTask(mypid)
int mypid;  /* pid of the task  */
{
    if ( (mypid >= 0) && (mypid < MAX_PIDS) )
        return(TaskInfo[mypid].parasite_of);
    return(-1);
}

/*************************************************************************
function: ThimRegisterDocId - Note pid's doc id into TaskInfo
*/
ThimRegisterDocId (docP)
DocInfoType *docP;
{
    long old;

    old = TaskInfo[THIMpid].fscurrdoc;
    TaskInfo[THIMpid].fscurrdoc = docP->DocId;
    return(old);
}

/*************************************************************************
function: KillTask - Shoot down a task
*/
KillTask (pid)
int pid;
{
    TaskInfo[pid].kill_me = TRUE;
}

/*************************************************************************
function: THIMexit - Close down the current task
This "close"s all fds rather than "fclosing" all fps.  This is a issue
if any processes rely on the exit() functionality to close buffers.  If
so, need a list of fps.
*/
void THIMexit (code)
int code;
{
    AxExitWithData(code,NULL);
    return;
}

static int RepaintAllAtTaskTerm = FALSE;    /* hack for out of memory issue */

AxExitWithData(code,exitData)
int code;       /* exit code number */
data_ptr exitData;  /* Elf data to return back thru */
{
    AxDoExit(code,exitData,TRUE);
}

AxDoExit(code,exitData,msgOnError)
int code;       /* exit code number */
data_ptr exitData;  /* Elf data to return back thru */
int msgOnError; /* If true, error msg on >0 exit code for unpended tasks */
{
    register int ix, pid, uid;
    register context_block *cP;
    int parentWasPended = FALSE;
    extern int (*TmDfltCallBack)();
    extern int ThimDefDevBeforePrinting;    /* Printing hack */
    extern int TmDefDev;    /* Defined in tmcattr.c */
    char errorMsg[5000];
    char errorFile[STRPATH+1];
    int errorLine;
    char errorObject[5000];
	data_ptr uidP;
    int postError = msgOnError;

    pid = AxInTask;
    if ( !pid )
        return;
    SLOGGER((NXLT("Exit %s task %d THIMpid %d code %d"),TaskInfo[pid].argv[0],AxInTask,THIMpid,code));
    uid = TaskInfo[pid].uid;

    /* note that this is being done right up front because the freeing
       of builder insets requires making a call into the Elf code
       using ElfCallByName, which allows task switching -- since we're
       in the exit code, we don't want (at that point) to try to
       switch to a task that doesn't exist -- and this is exactly what
       happens if this call is with the other AxFree{}byPID calls.
       Hence, we do this freeing here, while the task we're exiting
       from still exists.  Note also (in case this problem is later
       (somehow) fixed) that this freeing of builder insets must also
       happen before the graphics inset freeing because the builder
       inset itself makes use of graphics insets, and it frees them
       first */ 
    AxFreeBldrByPID(AxInTask);

/* toss locks from named resources, removed from waiters lists */

    AxUnlockResource(NULL,uid);

/* delete tempfiles */

    if ( TaskInfo[pid].created_tempfiles )
        AxDeleteTemps(pid);

/* unload elf executables slaved to the task */

    if ( TaskInfo[pid].loaded_elf_images )
        ElfUnloadTaskPackages(uid);

/*  Shoot down anybody waiting on this task
    Re-attach priorTaskMaster for anybody for whom this task is task master.
*/

    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( !TaskInfo[ix].in_use )
            continue;
        if ( TaskInfo[ix].ipc_response_waiting == pid ) {
            if ( TaskInfo[ix].rsp )
                AxmReleaseSlavedCursors(pid);
            else
                TaskInfo[ix].kill_me = TRUE;
        }
        if ( TaskInfo[ix].elfCallBlocked == pid )
            TaskInfo[ix].kill_me = TRUE;
        if ( TaskInfo[ix].taskMaster == uid )
            AxSetTaskMaster(ix,TaskInfo[ix].priorTaskMaster);
    }

/* Release info in Segments table */

    for ( ix = 0; TaskInfo[pid].block_types[ix]; ix++ )
        TaskInfo[pid].block_types[ix]->backup = NULL;

/* release sub-tasks & resources */

    /*** release any memory we can back to the system ***/
    ElfCloseAllSockets(pid);
    ThimKillOffParasites(pid);
    if ( TmAmSE ) { /* in case we crash during printing */
        TmAmSE = FALSE;
        TmDefDev = 106;
    }
    TermByApp(pid);     /* Term the window */
    KillTasksDialogs(pid);  /* Term dialog created by this macro */
    cP = &TaskInfo[pid];
	if ( cP->TaskUsesJavaDisplay )
		KillJavaWindows(pid);
	if (cP->pokeCodes)
		AxTaskFreeElfData(pid,cP->pokeCodes);
    cP->in_use = FALSE;

/* send a message to interested tasks for application exit */
	if  ( cP->topLevel ) {
		int *taskList;
		taskList = cP->tasks_interested;
		if (taskList) {
			int rcvr_task;
			uidP = AxMakeIntData(uid);
			for(ix=0;taskList[ix] != 0;ix++) {
				rcvr_task = ThimPidFromUID(taskList[ix]);
				if (rcvr_task != 0)
					SendElfData(rcvr_task, POKE_TASK_EXIT, uidP);
			}
		}
	}

    ClipFromActiveTasks(cP);
    FSClearTask(pid);   /* flush open-doc status */
    AxClearVirtualFiles(pid);   /* flush open descriptors */
    AFCleanFilesByTask( pid );  /* clear any "files in use" elements */
    free(cP->block_types);
    if ( cP->my_blocks ) {
        for ( ix = 0; cP->my_blocks[ix]; ix++ )
            free(cP->my_blocks[ix]);
    }
    free(cP->my_blocks);
    cP->block_types = NULL;
    cP->my_blocks = NULL;
    cP->data = NULL;
	cP->ss_func_call_counter = 0;
	cP->ss_task_calling_bltin_func = 0;
	
    if ( cP->parentTask ) { /* re-activate parent */
        int parent;
        parent = ThimPidFromUID(cP->parentTask);
        if ( parent && (TaskInfo[parent].pended == pid) ) {
            if ( !TaskInfo[parent].ok_pended )
                postError = FALSE;
            parentWasPended = TRUE;
            TaskInfo[parent].unpend_me = TRUE;
            TaskInfo[parent].pended = 0;
            TaskInfo[parent].ok_pended = FALSE;
            TaskInfo[parent].child_retcode = code;
            AxTaskFreeElfData(parent,TaskInfo[parent].child_retdata);
            TaskInfo[parent].child_retdata = AxTaskCopyElfData(parent,exitData);
        }
    }
    if ( code != 0 ) {
        if ( AxIsArray(exitData) ) {
            MBstrcpy(errorMsg,AxStrFromArray(exitData,0));
            MBstrcpy(errorObject,AxStrFromArray(exitData,1));
            errorLine = AxIntFromArray(exitData,2);
            MBstrcpy(errorFile,AxStrFromArray(exitData,3));
/*          printf("%d: %s: %s\n",code,errorMsg,errorObject); */
        }
        else {
            errorMsg[0] = 0;
            errorObject[0] = 0;
            errorFile[0] = 0;
        }
    }
    AxFreeData(exitData);
    AxFreeData(cP->child_retdata);
    cP->child_retdata = NULL;
    for ( ix = 0; ix < MAX_OPEN_FILES; ix++ ) {
        if ( cP->fds[ix] != -1 )
            THIMclose(cP->fds[ix]);
    }
    while ( cP->msgs ) {
        msg_info *next;
        next = cP->msgs->next;
        free(cP->msgs);
        cP->msgs = next;
    }
    if ( cP->numDefered ) {
        for ( ix = 0; ix < cP->numDefered; ix++ )
            free(cP->deferList[ix]);
        free(cP->deferList);
    }
    if ( cP->argv ) {
        if ( cP->usesElfArgs ) {
            free(cP->argv[0]);  /* just the name is a string */
            free(cP->argv);
        }
        else
            ArgvFree(cP->argc,cP->argv);
    }
	AxFreeTaskData(pid); /* get rid of any data attached by a task */
	AxFreeTaskSSData(pid); /* get rid of any ss data attached by a task */
	AxFreeTaskWPXData(pid); /* get rid of any WP data attached by a task */
    ElfDecoupleUnsnappedObjPtrs(AxInTask);
	if (isShlibLoaded_GE())
		AxFreeGFXbyPID(AxInTask);	
	if (isShlibLoaded_WP())
		AxFreeWPXbyPID(AxInTask);
	if (isShlibLoaded_SS())
		AxFreeSSXbyPID(AxInTask);
    THIMfreeAll(AxInTask);
    if ( cP->stack )    /* may have aborted before stack created */
        free(cP->stack);
    cP->doc_interest = NULL;    /* freed by THIMfreeAll */
    cP->tasks_interested = NULL;    /* freed by THIMfreeAll */
	if ( postError && cP->suppressExitErrorBox )
		postError = FALSE;

/* If the stack and data systems aren't the same, kill the other task, too */

    if ( AxInTask != THIMpid ) {
        AxInTask = THIMpid;
        AxExitWithData(code,NULL);
    }
    THIMpid = currentContext = THIMpidUID = AxInTask = 0;

    if ( (code !=0 ) && postError ) {
        if ( !errorMsg[0] )
            StrGet(code,errorMsg);
        if ( errorFile[0] ) {
            if ( errorLine )
                sprintf(errorMsg+strlen(errorMsg),XLT2("filename and line number","\nin %s, line %u"),
                            errorFile,errorLine);
            else
                sprintf(errorMsg+strlen(errorMsg),XLT2("filename","\nin %s"),errorFile);
        }
        AxErrorMessage(-1,code,errorObject,errorMsg);
    }

    FreeUpMemory();
    TaskInfo[pid].uid = -1;   /* so noone ever finds us again */

#ifndef axlongjmp
#define axlongjmp longjmp
#endif
    axlongjmp(KernelJump,1);
}

extern int ATMinitCOMPLETE;    /* TRUE if initialization completed */

/*************************************************************************
function: taskAbort - Send message and abandon current task
*/
void taskAbort (msg)
char *msg;
{
    char buf[200];
    if ( !AxInTask || !ATMinitCOMPLETE ) tempAbort(msg);
    sprintf(buf,XLT2("%s=errormessage","!%s\nAborted."),msg);
    SuperMessage(buf);
    AxDoExit(127,NULL,FALSE);
    return;
}

/*************************************************************************
function: taskLineAbort - Send message with line number, abandon task
*/
taskLineAbort (msg,line)
char *msg;
int line;
{
    char buf[1000];
    if ( msg )
        sprintf(buf,"%d: %s",line,msg);
    else
        sprintf(buf,"lcode-%d",line);
    taskAbort(msg);
}

/*************************************************************************
function: THIMabort - Abort the current task
*/
THIMabort ()
{
    SuperMessage(XLT("!Task abandoned."));
    AxDoExit(127,NULL,FALSE);
}

/*************************************************************************
function: THIMkill - Abort the current task
*/
THIMkill ()
{
    taskAbort(NXLT("kill issued"));
    THIMabort();    /* ?? for now */
}

/*************************************************************************
function: THIMsignal - Signal manager for a task - TODO ??
*/
THIMsignal(signum, func)
int signum, (*func)();
{
    if(signum == SIGFPE)
        TaskInfo[THIMpid].sigfpehandler = func;
    return(0);
}

/*************************************************************************
function: THIMopen - Unix open plus thimble fd tracking
*/
THIMopen (name,mode,more)
char *name;
int mode;
int more;
{
    int fd,ix;

    if ( -1 == (fd = open(name,mode,more)) )
        return(-1);
    for ( ix = 0; ix < MAX_OPEN_FILES; ix++ ) {
        if ( TaskInfo[THIMpid].fds[ix] == -1 ) {
            TaskInfo[THIMpid].fds[ix] = fd;
            return(fd);
        }
    }
    taskAbort(NXLT("too many files opened"));
}

/*************************************************************************
function: THIMclose - Unix close plus thimble fd tracking
*/
THIMclose (fd)
int fd;
{
    int ix,code;

    if ( 0 != (code = close(fd)) )
        return(code);
    for ( ix = 0; ix < MAX_OPEN_FILES; ix++ ) {
        if ( TaskInfo[THIMpid].fds[ix] == fd ) {
            TaskInfo[THIMpid].fds[ix] = -1;
            break;
        }
    }
    return(0);
}

/*************************************************************************
function: THIMcreat - Unix creat plus thimble fd tracking
*/
THIMcreat (name,mode,more)
char *name;
int mode, more;
{
    int fd,ix;

    if ( -1 == (fd = creat(name,mode)) )
        return(-1);
    for ( ix = 0; ix < MAX_OPEN_FILES; ix++ ) {
        if ( TaskInfo[THIMpid].fds[ix] == -1 ) {
            TaskInfo[THIMpid].fds[ix] = fd;
            return(fd);
        }
    }
    taskAbort(NXLT("too many files created"));
}

/*************************************************************************
function: THIMfopen - Unix fopen plus thimble fd tracking
*/
FILE *THIMfopen (name,mode)
char *name, *mode;
{
    int fd,ix;
    FILE *fp;

    if ( NULL == (fp = fopen(name,mode)) )
        return(NULL);
    fd = fileno(fp);
    for ( ix = 0; ix < MAX_OPEN_FILES; ix++ ) {
        if ( TaskInfo[THIMpid].fds[ix] == -1 ) {
            TaskInfo[THIMpid].fds[ix] = fd;
            return(fp);
        }
    }
    taskAbort(NXLT("too many files opened"));
}

/*************************************************************************
function: THIMfclose - Unix fclose plus thimble fd tracking
*/
THIMfclose (fp)
FILE *fp;
{
    int fd,ix,code;

    fd = fileno(fp);
    if ( 0 != (code = fclose(fp)) )
        return(code);
    for ( ix = 0; ix < MAX_OPEN_FILES; ix++ ) {
        if ( TaskInfo[THIMpid].fds[ix] == fd ) {
            TaskInfo[THIMpid].fds[ix] = -1;
            break;
        }
    }
    return(0);
}

/*************************************************************************
function: THIMgetenv - Thimble envolpe for getenv
*/
char *THIMgetenv (p)
char *p;
{
    char *getenv();

    if ( 0 == strcmp(p,NXLT("AOSDIR")) )
        return(ThimApplixDir);
    else if ( 0 == strcmp(p,NXLT("FSDIR")) )
        return(ThimTempDir);
    else
        return(getenv(p));
}


THIMfdopen(){taskAbort(NXLT("fdopen"));}
THIMfreopen(){taskAbort(NXLT("freopen"));}
THIMdup(){taskAbort(NXLT("dup"));}
THIMpipe(){taskAbort(NXLT("pipe"));}
THIMpopen(){taskAbort(NXLT("popen"));}

/*************************************************************************
function: ThimUIDPid - Return uid of task id
*/
ThimUIDPid (id)
int id;
{
    return(TaskInfo[id].uid);
}

/*************************************************************************
function: ThimPidFromUID - Retun pid (or 0) given task's uid
*/
ThimPidFromUID (uid)
int uid;
{
    int ix;

    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use && (TaskInfo[ix].uid == uid) )
            break;
    }
    if ( ix == MAX_PIDS )
        return(0);
    return(ix);
}

/*************************************************************************
function: ThimPidFromUID - Retun pid (or 0) given task's uid
*/
ThimTopPidFromPid(pid)
int pid;
{
	if ( TaskInfo[pid].taskMaster )
		pid = ThimPidFromUID(TaskInfo[pid].taskMaster);
	return(pid);
}

/*************************************************************************
function: CurrentContext - Return current data system context
More reliable than simply looking at THIMpid
*/
CurrentContext ()
{
    return(currentContext);
}

/*************************************************************************
function: VfyContext - Restore tasks global vars from per-context backup place
Saves current task's vars before restoring new task.
*/
VfyContext (pid)
int pid;
{
    register ax_mem_block_info_t *p;
    register int ix;

    MemParanoid();
    if ( currentContext == pid )    /* already active */
        return;
    currentContext = pid;
    THIMpid = pid;
    if ( !pid )
        return;
    THIMappid = TaskInfo[pid].appid;
    THIMpidUID = TaskInfo[pid].uid;
    if ( !TaskInfo[pid].block_types )
        tempAbort(NXLT("selected dead task"));

/* copy the data in if not already there */

    for ( ix = 0; TaskInfo[pid].block_types[ix]; ix++ ) {
        p = TaskInfo[pid].block_types[ix];
        if ( p->backup != TaskInfo[pid].my_blocks[ix] ) {
            if ( p->backup )
                memcpy(p->backup,p->addr,p->size);
            memcpy(p->addr,TaskInfo[pid].my_blocks[ix],p->size);
            p->backup = TaskInfo[pid].my_blocks[ix];
        }
    }
    return;
}




#ifdef exit
#undef exit
#endif
#ifdef abort
#undef abort
#endif
static AxCloseResources();

/***********************************************************************
function: AxRemovePipe - Remove /tmp/.axscNN pipe file.
*/
void
AxRemovePipe()
{
	/* close down any communication channel, and delete any socket file */
    /*   we may have created                           - jon            */
	if (AxSockFd > 0)
		close(AxSockFd);
	AxSockFd = -1;
	if (AxSocketName && (*AxSocketName != '\0'))
		(void) unlink(AxSocketName);
	return;
}

void AxExit();
void NotifyJavaClientWeAreGoingAway();

/*************************************************************************
function: AxfLogout - Terminate Asterix, releasing resources
 */
data_ptr AxfLogout(data_ptr argDatum)
{
	int code = AxIntFromArray(argDatum,0);
	NotifyJavaClientWeAreGoingAway();
	AxExit(code);
}

/*************************************************************************
function: AxExit - Shutdown NOW
Note that this does NOT notify java client. The notify MUST be done by
a task... this can be called from task-0.
*/
void AxExit (int code)
{
    if ( !AxStartedForPrinting )
        ProfileSave();

#if BUILD_ORIENT
    /* close the connection to the input conversion server */
    AXCloseIM( );
#endif

    AxCloseResources(code);
	AxRemovePipe();
    exit(code);
}

/*************************************************************************
function: NotifyJavaClientWeAreGoingAway - Duh...
*/
void NotifyJavaClientWeAreGoingAway (void)
{
	data_ptr msgP, infoP;
	long old_time;
	extern int AxJavaShuttingDown;	/* If true, stop queuing messages */

	if ( !JavaMode )
		return;
	AxJavaCoreNotifier(JV_SHUTDOWN_NOTIFY,NULL);
	AxJavaShuttingDown = TRUE;
	AxSleepMilliseconds(0);	/* with luck, message will go out now */
	old_time = time(0L);
	while ( AxJavaOutputBytesQueued(NULL) ) {
		AxSleepMilliseconds(500);	/* wait till it gets out */
		if ( time(0L) > old_time+30 )	/* regardless, never wait more than 30 secs */
			return;
	}
}

int in_temp_abort = 0;

/*************************************************************************
function: tempAbort - Abort with message string
*/
int tempAbort(mes)
char *mes;
{
    int ix;
    extern int AxAllowCore;
    int last_error;
    char buff[300];

    if ( in_temp_abort )
       exit(1);
    in_temp_abort = TRUE;

    if ( mes && mes[0] ) {
#if AXMS
        last_error = MS_GetLastError();
        sprintf(buff, "%s, last_error=%d", mes, last_error);
        MessageBox(NULL, buff, NXLT("tempAbort"), MB_OK);
#else    
        fprintf(stderr,"%s\n",mes);
        fflush(stderr);
#endif  /* DAMNT */
    }

#if BUILD_ORIENT
    /* close the connection to the input conversion server */
    AXCloseIM( );
#endif

    AxCloseResources(0); 
        /* non-zero code produces "embrace" on ^C from asterx. To repro, 
            run asterx -nobackground and press ^C ...zane */

	AxRemovePipe();
    for ( ix = 1; ix < NSIG; ix++ )
        signal(ix, SIG_DFL);

    if ( AxAllowCore ) {
		char *dir = getenv("HOME");
		if ( dir && dir[0] )
			chdir(dir);
        abort();
	}
    else
        exit(1);
    return(0);     /* to keep the compiler happy about the 'int' type */
                   /* which is need for other error macros under windows */
                   /* see the file "winmap.h" - jon                      */
}



/*************************************************************************
function: AxCloseResources - Kill helper process and delete tempdir
*/
static AxCloseResources (exitCode)
int exitCode;
{
    extern int ThimHelperPid;
    extern char ThimTempDir[];
    int code, channel;
    char *str, *obj;
    extern char *AxSocketName;
    extern int AxSockFd;    /* LISTENER$ socket */
    extern int AxRPCNonBlockingIO;  /* If TRUE, use AxTimedReadBytes() in elfapi.a */

    FreeFontCache();
#if AXMS
    FreeWindowsResources();
#else
    signal(SIGUSR1,SIG_IGN);
#endif

    ElfCloseAllSockets(0);
    AxDeleteAllTemps();
    AxDestroyStandardColormap();
    if ( ThimHelperPid ) {
        if ( exitCode != 0 )    /* for code0 let helper shut self... otherwise asterx Interrupt causes embrace */
            AxHelperExit(exitCode);
        ThimHelperPid = 0;
    }
    if ( AxSockFd ) {   /* zero only when started in axmain debugging mode */
        AxRPCNonBlockingIO = FALSE; /* syncronized server stutdown */
        channel = AxNetConnect(NULL,&code,&str,&obj);
        if ( code == 0 ) {
            AxNetDropServiceBySocket(channel,AxSocketName,&code,&str,&obj);
            AxClientDisConnect(channel);
        }
    }

#if AXMS
    /* clean up any socket stuff the system had allocated for us */
    WSACleanup();

    /* release optional truetype fonts if we installed them */
    RemoveOptionalTruetypeFonts();
#endif

}

/*************************************************************************
function: AxDeleteDir - Delete a file/dir
*/
AxDeleteDir (filename)
char *filename;
{
    int init = TRUE;
    int err = 0;
    char temp[STRPATH+1], *name;
    struct stat statbuf;
    char *place = NULL;
    int code;
    char          **filesInDir;
    int             fileDex;

    if ( 0 != Astat(filename,&statbuf) )
        return(-1);
    if ( (statbuf.st_mode&S_IFMT) == S_IFDIR) {
        filesInDir = AxListFilesInDir(filename);
        for (fileDex = 0; name = filesInDir[fileDex]; fileDex++) {
            if ((strcmp(name, ".") == 0) ||
                (strcmp(name, "..") == 0)) {
                continue;   /* finite recursion preferred */
            }
            sprintf(temp,"%s%s%s",filename,DirSlash,name);
            AxDeleteDir(temp);
        }
        rmdir(filename);
        AxListFilesFreer(filesInDir);
    }
    else
        code = unlink(filename);
    return;
}

/*************************************************************************
function: ArgvAlloc - Malloc an argv vector
This routine is contained in this file because the malloc's must be true
system level mallocs.
*/
char **ArgvAlloc (argc,argv)
register int argc;
register char *argv[];
{
    register char **pp, **retval;
    register int ix;

    retval = pp = (char**)malloc((argc+1)*(sizeof(char*)));
    if ( !retval )
        return(NULL);
    for ( ix = 0; ix < argc; ix++,pp++ ) {
        if ( NULL == (*pp = (char *)malloc(strlen(argv[ix])+1)) )
            return(NULL);
        strcpy(*pp,argv[ix]);
    }
    *pp = NULL;     /* null term the array */
    return(retval);
}

/*************************************************************************
function: ArgvFree - Release argvAlloc'd vector
*/
ArgvFree (argc,argv)
register int argc;
register char *argv[];
{
    register int ix;

    for ( ix = 0; ix < argc; ix++ )
        free(argv[ix]);
    free(argv);
}

/*************************************************************************
function: SuperMessage - Send a message to all windows
*/
SuperMessage (p)
char *p;
{
    ElfbStatusMessage(p);
}

/*************************************************************************
function: CallTask - Call a subroutine in another task
*/
char *CallTask (pid,func,arg)
int pid;            /* task id to call */
int (*func)();  /* function to call */
int arg;            /* single arg to pass the function */
{
    static char data[100];  /* where callee writes result */
    short old_context = THIMpid;

    VfyContext(pid);
    (*func)(arg,data);
    VfyContext(old_context);
    return(data);
}

nothing_func(){}

#ifdef signal
#undef signal
#endif


/*************************************************************************
function: ThimCatchSig1 - Respond to SIGUSR1... stop current task
*/
void
ThimCatchSig1 ()
{
    void ThimCatchSig1callback();
    extern int ThimbleSaysToReturnNow; /* hack for breaking out of XtAppNextEvent */
    extern int AxOutOfMemory;   /* TRUE while out of memory box is up */
    extern int AxAllowStop; /* TRUE is meory box up and stop is allowed */
    int fd;
    char buf[10];
    int old_pid;

/* Handle stop request here */

#if !AX_NT      
#if CLIX
    signal(SIGUSR1,ThimCatchSig1callback);
#else
    signal(SIGUSR2,(void (*)())ThimCatchSig1);
#endif
#endif  /* DAMNT */

    if ( AxOutOfMemory ) {
        if ( AxAllowStop ) {
            AxShowMemoryWindow(FALSE,FALSE);
            AxOutOfMemory = FALSE;
            RepaintAllAtTaskTerm = TRUE;
            THIMexit(0);
        }
        else
            RingTheBell();
    }
    else if ( AxInTask && THIMpid ) {
        THIMexit(0);
    }
    else if ( THIMpid )
        KillTask(THIMpid);
    else
        RingTheBell();
    ThimbleSaysToReturnNow = TRUE;  /* Hint for schedular */
}

/*************************************************************************
function: ThimCatchSig2 - Respond to SIGUSR2
*/
void
ThimCatchSig2 ()
{
    void ThimCatchSig2callback();

#if !AX_NT  
#if CLIX
    signal(SIGUSR1,ThimCatchSig2callback);
#else
    signal(SIGUSR2,(void (*)())ThimCatchSig2);
#endif
#endif  /* DAMNT */

#if MEM_CALL_TRACE_ENABLED
{
    AxReportMemUsage("/tmp/zzmem");
}
#endif
}

/*************************************************************************
function: THIMset_sigs - Set the Unix signal catchers
*/
THIMset_sigs ()
{
    void ThimCatchSig1();
    void ThimCatchSig2();

    extern void THIMsigCatch();
    extern int AxAllowCore;

    if ( !JavaMode && AxAllowCore ) {	/* always catch sigs in JavaMode */
#if !AX_NT      
        signal(SIGUSR1, (void (*)())ThimCatchSig1);
        signal(SIGUSR2, (void (*)())ThimCatchSig2);
#endif
        signal(SIGTERM, (void (*)())THIMsigCatch);
#if !AX_NT
        signal(SIGHUP,   SIG_IGN);
        signal(SIGPIPE, SIG_IGN);   /* may occur from ElfbSockWrite */
#endif  /* DAMNT */
    }
    else {

        /* catch appropriate signals */

#if !AX_NT
        signal(SIGUSR1, (void (*)())ThimCatchSig1);
        signal(SIGUSR2, (void (*)())ThimCatchSig2);
#endif  /* DAMNT */

        /* killers */
#if SYS&SYS5
        if ( isatty(0) )
#endif
#if !AX_NT
        signal(SIGQUIT, (void (*)())THIMsigCatch);
#endif
        signal(SIGILL,  (void (*)())THIMsigCatch);
#if !AX_NT
        signal(SIGTRAP, (void (*)())THIMsigCatch);
#endif  /* DAMNT */

    /*  signal(SIGIOT,  (void (*)())THIMsigCatch); */
#if !AX_NT
#if !M_88K
#ifdef SIGEMT
    /* SIGEMT is not valid under 88-OPEN BCS compatibility (or NT)  */
        signal(SIGEMT,  (void (*)())THIMsigCatch);
#endif
#endif
#endif  /* DAMNT */
        signal(SIGFPE,  (void (*)())THIMsigCatch);
#if !AX_NT
        signal(SIGBUS,  (void (*)())THIMsigCatch);
#endif
        signal(SIGSEGV, (void (*)())THIMsigCatch);
#if !AX_NT
#ifdef SIGSYS
        signal(SIGSYS,  (void (*)())THIMsigCatch);
#endif
#endif  /* DAMNT */

        /* close down */
        signal(SIGTERM, (void (*)())THIMsigCatch);
        /* Don't die */
#if !AX_NT
        signal(SIGHUP,   SIG_IGN);
#endif  /* DAMNT */

#if SYS&SYS5
        if ( isatty(0) )
        signal(SIGINT,  (void (*)())THIMsigCatch);
#else
        signal(SIGINT, (void (*)())THIMsigCatch);
#endif

#if M_88K /* Hitting the DEL key in the shell that started applix
             sends SIGINT to axmain.  Ignore it ... */
        signal(SIGINT, SIG_IGN);
#endif

#if !AX_NT
        signal(SIGPIPE, SIG_IGN);   /* may occur from ElfbSockWrite */
        signal(SIGALRM, (void (*)())THIMsigCatch);

        /* may get TTOU from XBell if running in background (NeWs) */
        signal(SIGTTOU, SIG_IGN);

#if SYS&B4_2
        /* killers */
        signal(SIGXCPU, (void (*)())THIMsigCatch);
        signal(SIGXFSZ, (void (*)())THIMsigCatch);
#endif
#endif  /* DAMNT */
    }
}

#ifdef CLIX
void THIMsigCatch();
void (*funcTHIMsigCatch)() = THIMsigCatch;
#endif
/*************************************************************************
function: THIMsigCatch - Signal catcher
*/
void
THIMsigCatch (signum)
int signum;
{
    int i;
    char buf[1000];
#if LINUX
    extern __const char * __const sys_siglist[];
#else
    extern char *sys_siglist[];
#endif

    signal(signum,THIMsigCatch); /* re-install handler */

#if CLIX
/* highland clix sends SIGALRM ( Ignore ) */
    if ( signum == SIGALRM )
        return;
#endif

/* Ignore SIGPIPE*/
    if ( signum == SIGFPE) {
        /* floating point exception  */
        if(TaskInfo[THIMpid].sigfpehandler != NULL)
            (*(TaskInfo[THIMpid].sigfpehandler))(signum);
        return; 
    }
#if !AX_NT
    if ( signum == SIGPIPE )
        return;
#endif  /* DAMNT */

#if 0   /* for development !!0 */
    if ( (signum == SIGTERM) || (signum == SIGINT) )
        AxExit(0);
    else
#endif

#if (SYS&SYS3) || (SYS&SYS5) || SYSV4
#else
    if ( signum < NSIG )
        sprintf(buf,NXLT("axmain: signal %s"),sys_siglist[signum]);
    else
#endif
        sprintf(buf,NXLT("axmain: caught signal %d, aborted"),signum);

#if 0   /* ??x no task shooter for now */
    if ( !MiniDemoMode && (THIMpid != 0) ) {    /* ??x not during context switches */
        THIMset_sigs();
        if ( buf[0] )
            taskAbort(buf);
        else
            THIMexit(1);
    }
#endif
    for ( i = 1; i < NSIG; i++ )
        signal(i,SIG_DFL);
    tempAbort(buf);
}

/*************************************************************************
function: AxMakeMeTopLevelTask - Set/Reset TaskInfo[THIMpid].topLevel
*/
void AxMakeMeTopLevelTask (doit)
int doit;
{
    TaskInfo[THIMpid].topLevel = doit;
}

context_block *ActiveTasks[MAX_PIDS+1]; /* array of tasks .in_use */

/*************************************************************************
function: AxHaveAnyTopTasks - TRUE if there is at least one TaskInfo[].topLevel
*/
int AxHaveAnyTopTasks ()
{
    register int ix;

    for ( ix = 0; ActiveTasks[ix]; ix++ )
        if ( ActiveTasks[ix]->topLevel )
            return(TRUE);
    return(FALSE);
}

/*************************************************************************
function: AppendToActiveTasks - Add task to end of active tasks list
*/
AppendToActiveTasks (tp)
context_block *tp;
{
    register context_block **p;
    register int task=0;

    for(p = ActiveTasks; task < MAX_PIDS+1 && *p; p++, task++ );    /* find end */
        *p++ = tp;                      /* add it */
    *p = NULL;                          /* add new ender */
}

/*************************************************************************
function: ClipFromActiveTasks - Remove a task from the list
*/
ClipFromActiveTasks (tp)
context_block *tp;
{
    register context_block **p;
    register int task=0;

    for ( p = ActiveTasks; task < MAX_PIDS+1 && *p && (*p != tp); p++, task++ );        /* find it */
    if ( !(*p) ) tempAbort(NXLT("task removal error"));     /* make sure got it */
    while ( *p ) {
        *p = *(p+1);    /* task from next slot */
        p++;
    }
}

/*************************************************************************
function: PrependToActiveTasks - Add task to end of active tasks list
*/
PrependToActiveTasks (tp)
context_block *tp;
{
    register context_block **p;
    register int task=0;

    for ( p = ActiveTasks;  task < MAX_PIDS+1 && *p; p++, task++ );
    *(p+1) = 0;         /* add extra NULL at end */
    while ( p > ActiveTasks ) { /* copy starts at first null at end */
        *p = *(p-1);
        p--;
    }
    *p = tp;
}

/*************************************************************************
function: LowerTaskPriority - Move task to end of list
*/
LowerTaskPriority (tp)
context_block *tp;
{
    ClipFromActiveTasks(tp);
    AppendToActiveTasks(tp);
}

ThimNoSleep()
{}

/*************************************************************************
function: ThimMyPid - Return THIMpid for a task
*/
ThimMyPid ()
{
    return(THIMpid);
}

/*************************************************************************
function: AxMyTaskUID - Return this task's unique id
*/
long AxMyTaskUID ()
{
    return(THIMpidUID);
}

/*************************************************************************
function: AxSetMeAsActiveTask - Deem this the current window/task
*/
AxSetMeAsActiveTask ()
{
    AxActiveTask = AxMyTaskUID();
}

/*************************************************************************
function: AxSetThisPidAsActiveTask - Set active task based on passed non-unique pid
*/
void AxSetThisPidAsActiveTask (pid)
int pid;
{
    AxActiveTask = TaskInfo[pid].uid;
}

/*************************************************************************
function: AxSetTaskMaster - Set task comm's master & priorTaskMaster
Only relavent for Elf tasks. The mastering of Elf code even occurs
when Elf code is run as "part" of a SS/WP.
*/
void AxSetTaskMaster (pid,uid)
int pid, uid;
{
    if ( uid == TaskInfo[pid].taskMaster )  /* do nothing if already there */
        return;
    if ( APELFM == TaskInfo[pid].appid ) {
        if ( uid == TaskInfo[pid].uid ) /* Elf tasks cannot slave to self */
            return;
        TaskInfo[pid].priorTaskMaster = TaskInfo[pid].taskMaster;
    }
    else
        TaskInfo[pid].priorTaskMaster = TaskInfo[pid].taskMaster;
    TaskInfo[pid].taskMaster = uid;
}

/*************************************************************************
function: AxPendForWhom - Make good guess as to who we are pending for
In the hole before a task starts up, this may not work
*/
AxPendedForWhom (pid)
int pid;
{
    int ix;

    if ( !AxTaskPended(pid) )
        return(0);
    return(TaskInfo[pid].pended);
}

/*************************************************************************
function: ElfbMiniDemo - Return whether running in mini demo mode
*/
ElfbMiniDemo ()
{
    return(FALSE);
}

/*************************************************************************
function: ThimIAmModified - Set task's modified flag
*/
ThimIAmModified (id)
int id; /* >0 if window id, 0->THIMpid, <0 for task id */
{
}

/*************************************************************************
function: AxTaskPended - Return whether passed pid is blocked
*/
AxTaskPended (pid)
int pid;
{
    if ( (pid <= 0) || (pid >= MAX_PIDS) || !TaskInfo[pid].in_use ||
            !TaskInfo[pid].pended )
        return(FALSE);
    return(TRUE);
}

ElfbNewUser()
{
    return(ThimNewUser);
}



/************************************************************************
function: CLIX does not handle recursion of signal().  This function 
calls the function it was called from.    -lance
************************************************************************/

void ThimCatchSig1callback()
{
    ThimCatchSig1();
}

void ThimCatchSig2callback()
{
    ThimCatchSig2();
}

AlisArgs(){}
ElfCheckFormat(){return(0);}

static glom_ptr_t *GlomData;
static int NumGlomEntries;
#define GLOM_HDR_SIZE 40000

/*************************************************************************
function: axReadGlomFile - Open & read TOC
*/
FILE *axReadGlomFile ()
{
    FILE *fp;
    char name[STRPATH+100];
    int count;
    char buf[GLOM_HDR_SIZE];    /* should be enough for a long time */
    int ix, offset, nextOffset;
    char *newlineP, *spaceP, *nameP, *numP;

    if ( AxLanguage <= 1 )
       /* english */
       sprintf(name,NXLT("%s%sdatafile.dat"),AxLangDir,DirSlash);
    else
       sprintf(name,NXLT("%s%sdatafile.%s"), AxLangDir, DirSlash,
                                                   AxLangSuffix[AxLanguage] );
#if AXMS
    fp = fopen(name,"rb");
#else
    fp = fopen(name,"r");
#endif
    if ( !fp )
        {
        sprintf(buf, NXLT("Could not open %s"), name );
        tempAbort( buf );
        }
    read(fileno(fp),buf,GLOM_HDR_SIZE);

/* get count */

    newlineP = (char *)strchr(buf,'\n');
    *newlineP = '\0';
    count = atoi(buf);
    GlomData = (glom_ptr_t*)malloc((count+1) * sizeof(glom_ptr_t));
    NumGlomEntries = count;

/* get names & size */

    nameP = newlineP + 1;
    for ( ix = 0; ix < count; ix++ ) {
        spaceP = (char *)strchr(nameP,' ');
        *spaceP = 0;
        strcpy(GlomData[ix].name,nameP);
        numP = spaceP + 1;
        newlineP = (char *)strchr(numP,'\n');
        *newlineP = 0;
        GlomData[ix].offset = atoi(numP);       /* for now, offset is size... */
        nameP = newlineP + 1;
        if ( (nameP-buf) >= GLOM_HDR_SIZE )
            tempAbort(NXLT("glom data too big... bump in tmzcontext.c"));
    }

/* convert sizes to offsets */

    offset = nameP - buf;
    for ( ix = 0; ix < count; ix++ ) {
        nextOffset = offset + GlomData[ix].offset;
        GlomData[ix].offset = offset;
        offset = nextOffset;
    }
	GlomData[count].offset = nextOffset;
    return(fp);
}

/***********************************************************************
function: AxCreateGlomList - Return an IntsArray containing names of entries
in the glom file.
Note: caller must free returned IntsArray by calling `AxFreeGlomList ()'
*/
long *
AxCreateGlomList()
{
    register long *glom_list = (long *) NULL;
    register int ix;
    register char *p;
    FILE *fp = (FILE *) NULL;

    if (!GlomData)
        fp = axReadGlomFile();

    glom_list = (long *)CreateIntsArray(NumGlomEntries);
    for (ix = 0; ix < NumGlomEntries; ix++) {
        p = (char *) malloc(strlen(GlomData[ix].name) + 1);
        strcpy(p, GlomData[ix].name);
        WriteIntsArray(glom_list, ix, (long) p);
    }
    if (fp)
        fclose(fp);
    return(glom_list);
}

/***********************************************************************
function: AxFreeGlomList - Free storage returned by a call to
`AxCreateGlomList ()'.
*/
void
AxFreeGlomList(glom_list)
register long *glom_list;
{
    register int size;
    register int ix;
    register char *p;

    if (!glom_list)
        return;
    size = IntsArraySize(glom_list);
    for (ix = 0; ix < size; ix++) {
        p = (char *) ReadIntsArray(glom_list, ix);
        if (p)
            free(p);
    }
    free(glom_list);
    return;
}

/*************************************************************************
function: AxFindInGlom - Look for name in glom file, return file ptr
*/
FILE *
AxFindInGlom (name, size)
register char *name;
register int *size;
{
    static FILE *fp;
    register int ix;

    if ( !GlomData )
        fp = axReadGlomFile();
    for ( ix = 0; ix < NumGlomEntries; ix++ ) {
        if ( 0 == Astrcmp(GlomData[ix].name,name) ) {
            fseek(fp,GlomData[ix].offset,0);
			*size = GlomData[ix+1].offset - GlomData[ix].offset;
            return(fp);
        }
    }
    return(NULL);
}

/**************************************************************************
function: BuildGlomFile - Given a language prefix, source images dir,
			target dir, and image filenames, build a glom file by
			parsing the current datafile.dat and replacing those images
			given by the image filenames in the source images dir.
			This is part of the translation kit tools.
*/

void
BuildGlomFile ( arg_prefix, arg_src_dir, arg_target_dir, arg_filenames )
data_ptr	arg_prefix, arg_src_dir, arg_target_dir, arg_filenames;
{
	char	*prefix = NULL,
			*src_dir = NULL,
			*target_dir = NULL,
			chgd_images[3000][STRPATH+1],
			*p = NULL, *pp = NULL,
			target_image[STRPATH+1],
			target_file[STRPATH+1];
	int		cnt = 0, i = 0, j = 0,
			*chngd = NULL;
	data_ptr	dP = (data_ptr) NULL;
	FILE	*fp_src = NULL,
			*fp_target = NULL;


	/*	Identify our args */
	prefix = (char *)AxStrFromDataPtr (arg_prefix);
	src_dir = (char *)AxStrFromDataPtr (arg_src_dir);
	target_dir = (char *)AxStrFromDataPtr (arg_target_dir);

	cnt = ElfbArraySize (arg_filenames);
	memset (chgd_images, 0, sizeof(chgd_images));
	for (i = 0; i < cnt; i++)
	{
		dP = AxArrayElement(arg_filenames, i);
		strcpy (chgd_images[i], AxStrFromDataPtr (dP));
	}

	/*	Check that there is already image data loaded in GlomData[] */
	/*	There shld be, but why blow up if not? */
    if ( !GlomData )
        fp_src = axReadGlomFile();

	/*	Set up the flag array for changed images */
	chngd = (int *) malloc (NumGlomEntries * sizeof(int *));
	memset (chngd, -1, NumGlomEntries * sizeof(int *));

	/*	Which filenames are we replacing? */
	for (i = 0; i < cnt; i++)
	{
		strcpy (target_image, chgd_images[i]);
		pp = strrchr(target_image, '.');
		*pp = '\0';		/*	cut off the suffix, which is lang-dependent */
						/*	and compare just the name stub, which is unique */

		for (j = 0; j < NumGlomEntries; j++)
		{
			if ( ! (strncmp (target_image, GlomData[j].name, strlen(target_image))) )
			{
				/*	mark the chgd filename for that glom entry*/
				chngd[j] = i;

				/*	build the complete pathname to the changed file */
				sprintf (chgd_images[i], "%s%s%s", src_dir, DirSlash, target_image);
				break;
			}
		}
	}


	/*	Write the file  */
	
	sprintf (target_file, "%s%sdatafile.%s", target_dir, DirSlash, prefix);
#if 1
	tempAbort("would incorrectly call WriteGlomFile");
#else
	WriteGlomFile(target_file, chngd, chgd_images);
#endif
}


/**************************************************************************
function:	WriteGlomFile. (The guts of this routine were lifted from axglom.c)
			Given a list of changed files and filenames, rebuild the
			datafile.dat for a given language, reading unchanged images
			from the datafile.dat file, and reading changed ones from the
			passed list of filenames, which include path names.
*/

#define MAX_SIZE 200000

static int
WriteGlomFile(target_file, chngd, namebuf)
char	*target_file, *namebuf[];
int		chngd[];
{
	int		size = 0,
			ix = 0,
			ret = 0;
	char	*p = NULL,
			*infile,
			Copybuf[MAX_SIZE],
			sys_file[STRPATH+1];
    struct stat status;
	int		fd = 0;
	FILE	*fp_in = NULL,
			*fp_out = NULL;


	sprintf (sys_file, "%s%sdatafile.dat", AxLangDir, DirSlash);
	fp_in = fopen(sys_file,"r");

	fp_out = fopen(target_file,"wb");

	/* Header is written using fprintf, name & size in bytes of image */

	fprintf(fp_out,"%d\n", NumGlomEntries);

	for (ix = 0; ix < NumGlomEntries; ix++)
	{
		if (chngd[ix] >= 0)
		{
			infile = namebuf[chngd[ix]];
			ret = stat(infile,&status);
			size = status.st_size;
		}
		else
		{
			if (ix < (NumGlomEntries - 1) )
				size = GlomData[ix+1].offset - GlomData[ix].offset;
			else
			{
				fseek(fp_in, GlomData[ix].offset, 0);
				size = read (fileno(fp_in), Copybuf, MAX_SIZE);
			}
		}

		/*	Reset infile to glom_data name for writing */
		infile = GlomData[ix].name;
		fprintf(fp_out,"%s %d\n",infile,size);	/*	Uses '.im' suffix */
	}

	fflush(fp_out);


	/* The image files are then written as binary data to the same file */

	for ( ix = 0; ix < NumGlomEntries; ix++ )
	{
		if (chngd[ix] >= 0)
		{

#if AXMS
			fd = open(namebuf[ix],(O_RDONLY+O_BINARY),0);
#else
			fd = open(namebuf[ix],0,0);
#endif

			size = read(fd,Copybuf,MAX_SIZE);

			close(fd);
		}
		else
		{
			fseek(fp_in, GlomData[ix].offset, 0);
			size = read (fileno(fp_out), Copybuf, MAX_SIZE);
		}

		write(fileno(fp_out),Copybuf,size);
	}

	close(fileno(fp_out));

	return (0);
}

#if AXMS
/*************************************************************************
function: AxUIDFromPid - Convert simple pid to unique task id
*/
AxUIDFromPid (pid)
int pid;
{
    int ix;

    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use )
            break;
    }
    if ( ix == MAX_PIDS )
        return(0);
    return(TaskInfo[ix].uid);
}
#endif  /* DAMNT */

/*************************************************************************
function: AxTaskHasMessagesQueued - Return whether task has events
*/
int AxTaskHasMessagesQueued (pid)
int pid;
{
    return(TaskInfo[pid].msgs != NULL);
}


char *AGetTempDir()
{
    char *p;

    p = UPneedByCode(PROF_TEMP_DIR_);
    if ( *p == '\0' ) 
        {
        p = UPbyName(NXLT("tempDir"));      /* old pre- 1.0.1 */
        if ( !p || (*p == '\0') ) 
            {
#if AXMS
            p = AtempDir();
#if 0
            *** this code moved to AtempDir()  
            p = getenv(NXLT("temp"));
            if ( p != (char *)NULL )
               /* found one */
               return( p );
            p = getenv(NXLT("tmp"));
            if ( p != (char *)NULL )
               /* found one */
               return( p );
            p = NXLT("\\tmp");
#endif
#else                        
            p = NXLT("/tmp");
#endif  /* DAMNT */
            }
        }
    return( p );
}

/*************************************************************************
 *	Character sorting support
 */

#define ENGLISH	1				/*	Proximity value for American English */
#define NUM_LANGS	16			/*	Prox langs are 1-16 */


unsigned char	*
read_Imap(sort_file)
FILE	*sort_file;
{
	int		indx,
			langnum;
	unsigned char
			letter, sortpos;
	char	*bptr,
			buf[CTYPESIZE];

	memset (Imap, 0, (NUM_LANGS + 1) * (CTYPESIZE + 1));

	langnum = 0;
	while ( (bptr = fgets (buf, CTYPESIZE, sort_file)) != NULL )
	{
		/*	Format of file is 
		 *		********%1 # English sort order 1-256
		 *		nb	#optional comment
		 *		nb
		 *		nb	#optional comment
		 *		.
		 *		.
		 *		.
		 *		.
		 *		********%2 # German sort order 1-256
		 *		nb	nb	#optional comment
		 *		.
		 *
		 *	The language is identified and separated by the line of '***'
		 *	followed by the "%#"; everything after that is a comment.
		 *	A line consisting of '****' without a '%#' is a comment.
		 *
		 *	This assumes a full mapping for each language.
		 */

		if (!strncmp (bptr, "***", 3))	/*	comments begin with '***' */
		{
			bptr = strrchr (bptr, '%');
			if (bptr == NULL)
				continue;			/*	no langnum -- it's a comment line */
			else
			{
				langnum = 0;		/*	starting a new language */
				indx = 1;			/*	characters are 1-based too */
			}
			bptr++;
			while (isdigit(*bptr))
			{
				langnum = (langnum * 10) + (*bptr) - '0';
				bptr++;
			}
			Imap[langnum][1] = 1;		/*	Imap for langnum init'd */
			continue;
		}


		/*	Get a sort mapping for this char  */

		get_equivs ((unsigned char*)buf, &letter, &sortpos);


		/*	It didn't have one, create one from its position in the file */

		if ( sortpos == 0 )
		{
			sortpos = indx;		/*	position in file sequence */
		}
		else
		{
			/*	e.g.	'AE A #diphthong -->  sortpos is whatever number 
			 *			Imap[langnum]['A'] is, which we already know
			 */

			sortpos = Imap[langnum][sortpos];	/*	pos already established */
		}

		Imap[langnum][letter] = sortpos;
		indx++;
	}
}

/*	Read a file line that can be:
 *		X						a char
 *		X	#comment			a char with a comment
 *		X X	#comment			2 chars with a comment
 *	Chars can be represented by ascii, octal, hex or decimal, and are
 *	separated by spaces or tabs.
 */
get_equivs(bptr, letter, sortpos)
unsigned char				*bptr, *letter, *sortpos;
{
	unsigned char	*jptr = NULL;
	int				end = FALSE;

	*letter = *sortpos = 0;

	jptr = bptr++;
	while (!isspace(*bptr))
		*bptr++;
	if (*bptr == '\n')
		end = TRUE;
	*bptr = 0;

	if (isdigit(*jptr) && bptr - jptr > 1)
	{
		if (!strncmp ((char*)jptr, "0x",2))
			cvt(jptr+2,16,letter);
		else if (*jptr == '0')
			cvt(jptr+1,8,letter);
		else
			cvt(jptr,10,letter);
	}
	else
	{
		*letter = *jptr;
	}

	/*	There was only a letter; no second char, no comment */
	if (end == TRUE)
		return;

	jptr = ++bptr;
	while (isspace(*bptr))
		*jptr++ = *bptr++;

	/*	There was only a char and a comment; return */
	if (*bptr == '#')
		return;

	/*	There's a second char */
	jptr = bptr;
	while (!isspace(*bptr))
		*bptr++;
	*bptr = '\0';

	if (isdigit(*jptr) && bptr - jptr > 1)
	{
		if (!strncmp ((char*)jptr, "0x",2))
			cvt(jptr+2,16,sortpos);
		else if (*jptr == '0')
			cvt(jptr+1,8,sortpos);
		else
			cvt(jptr,10,sortpos);
	}
	else
	{
		*sortpos = *jptr;
	}
}

int
cvt (bf, base, i)
unsigned char	*bf, *i;
int		base;
{

	*i = 0;

	while (*bf)
	{
		if (*bf >= 'a')
			*i = (*i * base) + (*bf - 'a' + 10);
		else
			*i = (*i * base) + (*bf - '0');

		bf++;
	}
}

int
checkforSSParasite()
{
	int top_pid, pid;

	top_pid = ThimTopPidFromPid(THIMpid);
	if ( TaskInfo[top_pid].appid == APGE && TaskInfo[top_pid].parasite_of )
	{
		pid = TaskInfo[top_pid].parasite_of;
		if ( TaskInfo[pid].appid == APSS )
			return(TRUE);
		else
			return(FALSE);
	}
	return(FALSE);
}

