/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: uid2name.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:26 1998
*/
#include <stdio.h>
#if X386_NEW
#include <stdlib.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#if !AX_NT
#include <pwd.h>
#endif

#define NXLT(str) str	/*	Keep xlt scans sane by NXLT'g where necess */

#define MAX_USERNAME 16

typedef struct passwd_info {
	struct passwd_info *next;
	char name[MAX_USERNAME+1];
	int uid;
} passwd_info;

/*************************************************************************
function: AxUserNameFromUserId - Translate user id to user name
As per passwd file.
*/
char *AxUserNameFromUserId (x)
int x;
{
#if AX_NT /* stub for now !!0 */
	return(NXLT("user"));
#else

	struct passwd *p;
	static passwd_info *names;
	passwd_info *np;
	char *name;

	for ( np = names; np; np = np->next )
		if ( x == np->uid )
			return(np->name);
	p = getpwuid(x);
	if ( !p )
		name = "?????????";
	else
		name = p->pw_name;
	np = (passwd_info *)malloc(sizeof(*np));
	if ( !np ) return(name);
	np->uid = x;
	strncpy(np->name,name,MAX_USERNAME);
	np->name[MAX_USERNAME] = 0;
	np->next = names;
	names = np;
	return(name);
#endif
}

