/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: zmglobal.h
   Applix ASC version: 11
   Date: Mon Nov 16 13:53:26 1998
*/
#include <stdio.h>
#include <setjmp.h>
#include <aos.h>
#include <afile.h>
#include <adocio.h>
#include <boom.h>

#define OFILE_EXTENSION ".sw"

    /* General macros */

#if DEBUG
#define LOG(body) if ( OMlogging ) OMlogger body;
#define CORRUPTION_CHECK(id,p) OMcorruptionCheck(id,p)
#define register
#else
#define LOG(body)
#define CORRUPTION_CHECK(id,p)
#endif
#define ERROR(y,z) if ((memErr=y) && OM2.abortOnError) OMcrash(y);else return(z);
#define VERIFY(x,y,z) if ( !(x) ) ERROR(y,z)
#define INIT_CHK(x) VERIFY(OM.topObj != 0,M_SEQERR,x)

    /* for iopack: */

#define  IOP_MAX_OBJSIZE (28672-sizeof(ObjHeader))    
#define IOP_BUFSIZE (IOP_MAX_OBJSIZE + 3)   /* size of object read/write buffers */

/* MACROS to reduce lint effects */

#define FREECORE(p) free(p)
#define ALLOC(n) malloc((unsigned int)(n))
#define REALLOC(p,n) realloc((char*)(p),(unsigned int)(n))


/* TYPEDEFS */

extern otParams2 	OM2;

extern otParams OM;              /* current object space parameters */
extern FILE *OMlogStream;                   /* log stream set by user */
extern short memErr;                        /* error code on BOOM errors */
extern int OMlogging;   /* whether logging is on */
extern int OMflush;     /* whether to flush after each log message */
extern int OMcheck;            /* compatability */

