/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tm1util.c
   Applix ASC version: 4
   Date: Mon Nov 16 14:27:35 1998
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#define AX_USE_PROTOS 1
#include <aos.h>
#include <elfapi.h>
#include <tm1util.h>

/***************/
/* Definitions */
/***************/

#define FALSE 0
#define TRUE  1

/**********************************/
/* Prototypes of Local Procedures */
/**********************************/

/*******************************************************/
/* Procedures for Manipulating Server-Prefaced Strings */
/*******************************************************/

/**************************************************************************
 * do_tm1_remove_server_name
 */
data_ptr
do_tm1_remove_server_name(data_ptr funcData)
{
  data_ptr rData;
  char buffer[100];
  char *sptr;

  /* verify basic input correctness, and parse out argument */
  if (! AxIsString(funcData)) {
    return(NULL);
  }
  sptr = AxStrFromDataPtr(funcData);
  strcpy(buffer, sptr);

  sptr = buffer;
  while (('\0' != *sptr) && (':' != *sptr)) {
    sptr++;
  }
  if (':' == *sptr) {
    sptr++;
  } else {
    sptr = buffer;
  }
  rData = AxMakeStrData(-1, sptr);
  return(rData);
} /* do_tm1_remove_server_name */

/**************************************************************************
 * do_tm1_remove_table_or_dimension_name
 */
data_ptr
do_tm1_remove_table_or_dimension_name(data_ptr funcData)
{
  data_ptr rData;
  char buffer[100];
  char *sptr;

  /* verify basic input correctness, and parse out argument */
  if (! AxIsString(funcData)) {
    return(NULL);
  }
  sptr = AxStrFromDataPtr(funcData);
  strcpy(buffer, sptr);

  sptr = buffer;
  while (('\0' != *sptr) && (':' != *sptr)) {
    sptr++;
  }
  if (':' == *sptr) {
    *sptr = '\0';
  } else {
    buffer[0] = '\0';
  }
  rData = AxMakeStrData(-1, buffer);
  return(rData);
} /* do_tm1_remove_table_or_dimension_name */
