/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axglom.c
   Applix ASC version: 6
   Date: Mon Nov 16 13:57:10 1998
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#if AXMS
#include <io.h>
#include <fcntl.h>
#endif

#define MAX_SIZE 200000
#define MAX_NAME 15
#define TRUE 1
#define FALSE 0

char Copybuf[MAX_SIZE];

char *strrchr();

main(argc,argv)
int argc;
char *argv[];
{
	char outfile[1024];
	int count;
	char *p;
	char *infile;
    struct stat status;
	int fd;
	FILE *fp;
	int size;
	int ix;


    strcpy( outfile, argv[1] );
	fp = fopen(outfile,"wb");
	if ( !fp )
		quitter(outfile,"could not open");


/* write header stuff */

	count = argc - 2;
	fprintf(fp,"%d\n",count);
	if ( ferror(fp) )
		quitter(outfile,"could not write");
	for ( ix = 2; ix < argc; ix++ ) {
		infile = argv[ix];
	    if ( -1 == stat(infile,&status) )
			quitter(infile,"could not stat");
        size = status.st_size;
		p = strrchr(infile,'/');
		if ( p )
			infile = p + 1;
		if ( strlen(infile) > MAX_NAME )
			quitter(infile,"name too long");
		fprintf(fp,"%s %d\n",infile,size);
		if ( ferror(fp) )
			quitter(outfile,"could not write");
	}
	fflush(fp);

/* write files in */

	for ( ix = 2; ix < argc; ix++ ) {
		infile = argv[ix];
#if AXMS
		fd = open(infile,(O_RDONLY+O_BINARY),0);
#else
		fd = open(infile,0,0);
#endif
		if ( fd == -1 )
			quitter(infile,"could not open");
		size = read(fd,Copybuf,MAX_SIZE);
		if ( size == MAX_SIZE )
			quitter(infile,"file too big");
		if ( size == -1 )
			quitter(infile,"could not read");
		if ( size != write(fileno(fp),Copybuf,size) )
			quitter(outfile,"could not write");
		close(fd);
	}
	
	if ( 0 != close(fileno(fp)) )
		quitter(outfile,"could not close");

	exit(0);
}

quitter(name,msg)
char *name, *msg;
{
	printf("%s: %s\n",name,msg);
	exit(1);
}
