/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cinc2elf.c
   Applix ASC version: 5
   Date: Mon Apr 19 21:15:21 1999
*/
#include <stdio.h>

#define MAXSIZE 4096

#define START_C_BLOCK "/* $ START_C_ONLY $ */"
#define END_C_BLOCK "/* $ END_C_ONLY $ */"

main(int argc, char *argv[])
{
	FILE *inf, *outf;
	char *infile, *outfile;
	char buf[MAXSIZE];
	char pound = '#';
	char quote = '\'';
	int  skipping=0;
	int  startlen = strlen(START_C_BLOCK);
	int  endlen = strlen(END_C_BLOCK);

	/* Check for proper number of args */
	if (argc != 3) {
		fprintf(stderr,
			"usage: cinc2elf ELF_output_file C_input_file\n");
		exit( 1);
	}

	infile = argv[2];
	outfile = argv[1];


	/* Open input file for reading */
	inf = fopen(infile, "r");
	if (!inf) {
		fprintf(stderr,"Could not open input file %s\n",infile);
		exit( 1);
	}

	/* Open output file for writing */
	outf = fopen(outfile, "w");
	if (!outf) {
		fprintf(stderr,"Could not open output file %s\n",outfile);
		exit( 1);
	}

	while (fgets(buf, MAXSIZE, inf)) {
		if (!strncmp( buf, START_C_BLOCK, startlen)) {
			++skipping;
			continue;
		}
		else if (skipping && !strncmp( buf, END_C_BLOCK, endlen)) {
			--skipping;
			continue;			/* skip this last line */
		}
		if (!skipping && (buf[0] != pound)) {
			fputs( buf, outf);
		}
	}
	exit(0);
}
