/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ent_mlist_id.c
   Applix ASC version: 12
   Date: Mon Dec 21 21:12:32 1998
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <axtime.h>
#if !AXMS
#include <sys/utsname.h>
#endif

#define BUFSIZE 100


/***************************************************************************
function: main 
*/
#if defined(__STDC__) || defined(__cplusplus)
main (
int argc,
char *argv[]
)
#else
main (argc, argv)
int argc;
char *argv[];
#endif
{
	int len;
	FILE *ifp;
	FILE *ofp;
	char *p;
	char *version;
	char *timestr;
	char *revname;
	char *mlistname;
	char buf[BUFSIZE+1];
	time_t tloc;
#if !AXMS
	struct utsname name;
#endif

	if ( argc < 3 ) {
		printf("%s: Invalid number of arguments\n", argv[0]);
		printf("Usage: %s <revstamp file (output)> <mlist file (input)>\n",
																	argv[0]);
		exit(1);
	}
	revname = argv[1];
	mlistname = argv[2];

	/* Open files */

	ifp = fopen(mlistname, "r");
	if ( !ifp ) {
		printf("Could not open %s for reading\n", mlistname);
		exit(1);
	}
	ofp = fopen(revname, "w");
	if ( !ofp ) {
		printf("Could not open %s for writing\n", revname);
		exit(1);
	}

	/* Fetch line, get to id pos (after second space)
	 * prototype: "# @(#) PIYUSH 4.190" */

	if ( !fgets(buf, BUFSIZE, ifp) ) {
		printf("Could not read %s\n", mlistname);
		exit(1);
	}

	p = buf;
	p = strchr(buf, ' ');
	if ( !p ) {
err:	printf("Badly formed %s\n", mlistname);
		exit(1);
	}
	while ( *p == ' ' )
		p++;		/* p now points to "@(#)" */
	p = strchr(p, ' ');
	if ( !p )
		goto err;
	while ( *p == ' ' )
		p++;		/* p now points to user "PIYUSH" */
	p = strchr(p, ' ');
	if ( !p )
		goto err;
	while ( *p == ' ' )
		p++;		/* p now points to "4.190" */

	/* Isolate version */

	version = p;
	while ( *p && (*p != ' ') )
		p++;
	*p = 0;

	/* Get current datetime str */

	tloc = time((time_t*)0);
	timestr = ctime(&tloc);
	p = strchr(timestr, '\n');
	if ( p )
		*p = 0;

	/* Write */

    fprintf(ofp, "#define ENT_BUILD_REVISION  \"7.4\"\n");
	fprintf(ofp, "#define ENT_BUILD_VERSION   \"%s\"\n", version);
	fprintf(ofp, "#define ENT_BUILD_REV_VER   7,4,0,%s\n", version); 
	fprintf(ofp, "#define ENT_BUILD_REV_VER_STR   \"7,4,0,%s\\0\"\n", version);
	fprintf(ofp, "#define ENT_BUILD_DATETIME  \"%s\"\n", timestr);

#if AXMS
	fprintf(ofp, "#define ENT_BUILD_MACHINE   \"MS\"\n");
#else
	uname(&name);
	fprintf(ofp, "#define ENT_BUILD_MACHINE   \"%s %s %s %s\"\n",
						name.sysname, name.release, name.version, name.machine);
#endif

	if ( 0 != fclose(ofp) ) {
		printf("Could not close %s\n", argv[1]);
		exit(1);
	}
	
	exit(0);
}

