/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: make_exports.c
   Applix ASC version: 5
   Date: Fri Jun 18 21:15:54 1999
*/
/****************************************************************************\
                                 includes
\****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/****************************************************************************\
                                  defines
\****************************************************************************/
#define TRUE 1
#define FALSE 0

#define LINE_LEN 1024

/****************************************************************************\
                             global variables
\****************************************************************************/
char line[LINE_LEN+1];

/****************************************************************************/
int
cmp_func (const void *input1, const void *input2)
{
	char *str1, *str2;
	str1 = *(char **)input1;
	str2 = *(char **)input2;
	return(strcmp(str1, str2));
}

/****************************************************************************/
static int
read_file (char *file, int *out_n, char ***out_array)
{
	char **array;
	int sz, n, r_val;
	FILE *fp;

	array = *out_array;
	n = *out_n;

	fp = fopen(file, "r");
	if ( fp == NULL )
		r_val = -1;
	else
	{
	        while ( fgets(line, LINE_LEN, fp) )
		{
			if ( line[0] == '#' )
				continue;

			if ( (n%100) == 0 )
			{
				sz = (n+100) * sizeof(char *);
				array = (char **)realloc(array, sz);
			}
			array[n] = (char *)malloc(strlen(line)+1);
			strcpy(array[n], line);
			n++;
		}
		fclose(fp);
		r_val = 0;
	}

	*out_n = n;
	*out_array = array;
	return (r_val);
}

/****************************************************************************/
int
main (int argc, char **argv)
{
	char *outfile, *infile, *ext;
	int n, ix, r_val;
	char **array;
	FILE *outfp;
#if 0
	{
	int wait = TRUE;
	while ( wait )
		sleep(2);
	}
#endif
	/* init */
	array = NULL;
	n = 0;
	r_val = 0;

	/* parse the command line options */
	if ( argc < 3 )
	{
		printf("usage: make_exports <outfile> <infile>\n");
		return(-1);
	}
	outfile = argv[1];
	infile  = argv[2];
	ext = strrchr(outfile, '.');
	if ( ext != NULL )
		ext++;
	if ( ext == NULL || ext[0] == (char)0 )
	{
		printf("could not parse outfile extention\n");
		return(-1);
	}

	/* open the output file */
	outfp = fopen(outfile, "w");
	if ( !outfp )
	{
		printf("Failed to open %s\n", outfile);
		return(-1);
	}
	else
	{
		r_val = read_file(infile, &n, &array);
		if ( r_val == 0 )
		{
			qsort(array, n, sizeof(char *), cmp_func);
			fprintf(outfp, "@1\n");
			fprintf(outfp, "@%d\n", n+1);
			fprintf(outfp, "\"libax%s\n", ext);
			for ( ix=0; ix<n; ix++ )
				fprintf(outfp, "\"%s", array[ix]);
		}
		fclose(outfp);
	}
	return (r_val);
}
