/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: sethot.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:57:13 1998
*/
#include <stdio.h>

main(argc,argv)
int argc;
char *argv[];
{
	if ( argc != 5 ) {
		fprintf(stderr,"Usage: addhotspot outfile infile width height\n");
		exit(1);
	}
	DoIt(argv[4],argv[3],atoi(argv[1]),atoi(argv[2]));
	exit(0);
}

/*************************************************************************
function: DoIt - Read a bitmap file, return malloced data
*/
DoIt (infile,outfile,hotX,hotY)
char *infile, *outfile;
int hotX, hotY;
{
	char sysdir[257];
	FILE *fp;
	char *buf;
	unsigned short width, height, bytewidth, tmpshort;
 	unsigned char shortbuf[2];
 	unsigned char magic[2];
	int ix;
	extern char *ThimApplixDir;		/* Where the THIMBLE executable lies */
	char *malloc();

	if ( NULL == (fp = fopen(infile,"r")) ) {
		fprintf(stderr,"Could not open input file\n");
		exit(1);		
	}
	fread(magic,2,1,fp);
	if ( (magic[0] | magic[1]) == 1 ) 
		fread(shortbuf,2,1,fp);	/* ignreo current hots spots */

	else if ( (magic[0] | magic[1]) != 0 ) { 
		fprintf(stderr,"Input file not an image!\n");
		exit(1);		
	}
	/* 
	 * read dimensions out byte-by-byte
	 */
	fread(shortbuf,2,1,fp);
	width = (short) shortbuf[0];
	tmpshort = (short) shortbuf[1];
	width |= (tmpshort << 8); 

	fread(shortbuf,2,1,fp);
	height = (short) shortbuf[0];
	tmpshort = (short) shortbuf[1];
	height |= (tmpshort << 8); 

	bytewidth = (unsigned int)(width+7)/8;
	buf = malloc(bytewidth*height);
	fread(buf,bytewidth*height,1,fp);
	fclose(fp);

	if ( NULL == (fp = fopen(outfile,"w")) ) {
		fprintf(stderr,"Could not create input file\n");
		exit(1);		
	}
	magic[0] = 0;
	magic[1] = 1;
	fwrite(magic,2,1,fp);
	shortbuf[0] = hotX;
	shortbuf[1] = hotY;
	fwrite(&shortbuf[0],1,1,fp);
	fwrite(&shortbuf[1],1,1,fp);

	shortbuf[0] = width & 0xFF;
	shortbuf[1] = width >> 8;
	fwrite(shortbuf,2,1,fp);
	shortbuf[0] = height & 0xFF;
	shortbuf[1] = height >> 8;
	fwrite(shortbuf,2,1,fp);

	fwrite(buf,bytewidth*height,1,fp);
	fclose(fp);
}

