/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: accrypt.c
   Applix ASC version: 2
   Date: Mon Nov 16 13:58:01 1998
*/
#define MAXPWLEN	8

char *Acrypt (buffer)
char *buffer;
/*
 * Transpose/encode 1st MAXPWLEN chars of buffer
 */
{
	encode(buffer, MAXPWLEN);
	transpose(buffer, MAXPWLEN, 4);
	encode(buffer, MAXPWLEN);
	return(buffer);
}

long Ahash (buffer)
long *buffer;
/*
 * Transpose/encode 1st sizeof(long) bytes of buffer
 */
{
	encode((char *)buffer, sizeof(long));
	transpose((char *)buffer, sizeof(long), 2);
	encode((char *)buffer, sizeof(long));
	return(*buffer);
}

transpose(buffer, num, by)  
char *buffer;
int num; 
int by;
{
	register int i, index;
	char tbuff[MAXPWLEN];

	for (index = 0; index + by <= num; index += by) {
		for (i = 0; i < by; i++)
			tbuff[by - i - 1] = buffer[index + i]; 
		for (i = 0; i < by; i++)
			buffer[index + i] = tbuff[i];
	}
}

encode (buffer, num)  
char *buffer;
int num; 
{
	register int i;
	char key[8];

	key[0] = '*';
	key[1] = 'V';
	key[2] = '\04';
	key[3] = '6';
	key[4] = 'x';
	key[5] = 'c';
	key[6] = '&';
	key[7] = 'G';

	for (i = 0; i < num; i++)
		buffer[i] = buffer[i] ^ key[i % 8];
}
