/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: agetcwd.c
   Applix ASC version: 4
   Date: Mon Nov 16 13:57:58 1998
*/
#include <utloc.h>

/*
.BEGIN MANPAGE
.NAME Agetcwd - Get the pathname of the current working directory.
.DESCRIPTION
	Agetcwd() provides a generic interface for obtaining a processes
	current working directory.  The maximum size of the pathname the
	can be retrieved is STRPATH (defined in aos.h).
.SEE ALSO
	getwd(3) getcwd(3)
.RETURN VALUE
	When successful, Agetcwd() returns a pointer to a static buffer that
	holds the pathname of the current working directory.  On error, 0
	is returned.
.END MANPAGE
*/
/* BEGIN SYNOPSIS */

#ifdef Agetcwd	/* temp HACK till Agetcwd removed from aos.h */
#undef Agetcwd
#endif

char *Agetcwd()
/* END SYNOPSIS */
{
	static char wd[STRPATH + 1];

#if ((SYS&B4_2) || MASSCOMP) && !SYSV4 && !LINUX
	extern char *getwd();

	return(getwd(wd));

#else
	extern char	*getcwd();

#if ALTOS
	if(getcwd(wd,STRPATH))
		return(strchr(wd,'/'));

	return((char *)NULL);
#else

#if SYS&VMSSYS
	char *p;

	if(!(getcwd(wd,STRPATH)))
		return((char *)NULL);

	for(p = wd; *p; p++);
		*p = tolower(*p);

	return(wd);
#else

	return(getcwd(wd,STRPATH));
#endif
#endif
#endif
}
