/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: dateutl.c
   Applix ASC version: 13
   Date: Fri Jan  8 21:11:43 1999
*/
#include <utloc.h>
#if SYS&B4_2
#include <sys/time.h>
#else
#include <time.h>
#endif
#include <getstr9.h>
#include <dt.h>

static int IntConvert(/* int n, char *s */);

struct {
	int	vals,
		mos,
		dys,
		days;
} LangStrfs[] = {
	{ENGVALS, ENGMOS, ENGDYS, ENGDAYS},		/*	default if lang = 0 */
	{ENGVALS, ENGMOS, ENGDYS, ENGDAYS},
	{GRMVALS, GRMMOS, GRMDYS, GRMDAYS},
	{FRNVALS, FRNMOS, FRNDYS, FRNDAYS},
	{SPNVALS, SPNMOS, SPNDYS, SPNDAYS},
	{ITLVALS, ITLMOS, ITLDYS, ITLDAYS},
	{BRTVALS, BRTMOS, BRTDYS, BRTDAYS},
	{SWDVALS, SWDMOS, SWDDYS, SWDDAYS},
	{DANVALS, DANMOS, DANDYS, DANDAYS},
	{NRWVALS, NRWMOS, NRWDYS, NRWDAYS},
	{DUTVALS, DUTMOS, DUTDYS, DUTDAYS},
	{PRTVALS, PRTMOS, PRTDYS, PRTDAYS},
	{BRZVALS, BRZMOS, BRZDYS, BRZDAYS},
	{CFRVALS, CFRMOS, CFRDYS, CFRDAYS},
	{SGRVALS, SGRMOS, SGRDYS, SGRDAYS},
	{NYNVALS, NYNMOS, NYNDYS, NYNDAYS},
	{FINVALS, FINMOS, FINDYS, FINDAYS},
	{JPNVALS, JPNMOS, JPNDYS, JPNDAYS}
};


char FSdtdays[90];	/* holds the day names listcheck string */
char FSdtdys [90];	/* holds the abbrev. day names listcheck string */
extern char DysPermo[];
int  FMoLexFmt;		/*Added 12/14/87 as a  bit of a kludgy way of datelex()
					telling parsedate() whether it saw "Jan" or "January"
					when a month string is recognized. */
short date_len;		/*	Added 12/7/90 as a similarly kludgy way of telling
						parsedate whether it saw a 2- or 4-digit year (for 
						DTDFDOTY4) */

/*--------------------------- Aftime--------------------------------------*/
#if SGI || AUX || M_88K || CLIX || SYSV4 || RIOS

#include <sys/time.h>

#if M_88K
#include <sys/types.h>
#endif

struct timeb
		{
			time_t   time;
			unsigned short millitm;
			short    timezone;
			short    dstflag;
		};

Aftime(tp)
struct timeb *tp;
{
        struct timeval tval;
        struct timezone tzone;
        int val;
 
        if (! gettimeofday(&tval,&tzone) )  {
                tp->time=(time_t)(tval.tv_sec);
                tp->millitm=(unsigned short)tval.tv_usec;
                tp->timezone=(short)tzone.tz_minuteswest;
                tp->dstflag=(short)tzone.tz_dsttime;
        }
        else
                return(-1);
}

#endif

/*--------------------------- FSetDysPerMo -------------------------------*/
void
FSetDysPerMo( yr )
int	 yr;
{
	if( yr%4 == 0 && yr%100 != 0 || yr%400 == 0) /* taken from 'C' manual
												    page 37. */
		DysPermo[1] = 29;	
	else
		DysPermo[1] = 28;
}

/*--------------------------- id_date_lang ----------------------------*/

id_date_lang(vals, mos, dys, days)
int	*vals, *mos, *dys, *days;
{
	int		AxLanguage = id_lang();

	*vals = LangStrfs[AxLanguage].vals;
	*mos = LangStrfs[AxLanguage].mos;
	*dys = LangStrfs[AxLanguage].dys;
	*days = LangStrfs[AxLanguage].days;
}

/*--------------------------- FSetdaysofWeek ----------------------------*/

/* Return the address of a buffer holding a string containing the text
of the days of the week. */

typeErr
FSetdaysofWeek( strngNum, charPP, abbrev )
unsigned int strngNum;
char		 **charPP;
int			abbrev;				/*	1 if abbreviated days/months */
{
	typeErr rtnCode;
	static unsigned int old_strngNum = 0;

	rtnCode = AOK;
	if( abbrev == 0 ) {					/*	full name */
		*charPP = FSdtdays;
		if( FSdtdays[0] == 0 || strngNum != old_strngNum)
			rtnCode = getStr( strngNum, FSdtdays );
	}
	else {								/*	abbrev'd name */
		*charPP = FSdtdys;
		if( FSdtdys[0] == 0 || strngNum != old_strngNum)
			rtnCode = getStr( strngNum, FSdtdys );
	}
	old_strngNum = strngNum;
	return( rtnCode );
}


/*--------------------------- Fmt2DgtYr ----------------------------------*/
int
Fmt2DgtYr( yr, len, strP )
register int yr;
register int len;
register char *strP;
{
int Century;
#if 0
	long time(), sysclock;
	struct tm *systimeP, *localtime();
	static int curCentury = 0;

	if( curCentury == 0 ) {
		sysclock = time( (long *)0 );
		systimeP = localtime( &sysclock );
		curCentury = (systimeP->tm_year +1900) / 100;
	} 
	if( (yr/100) == curCentury )
		yr = yr - (curCentury*100);
#else
	/* Keep format Explicit !!! (i.e. 2000 == 00)*/
		Century = yr/100; /* clip off 1st 2 places */
		Century *= 100;
		yr = yr - Century;
#endif
	return( Fmt2Digits( yr, len, strP) );
}

/*------------------------------ Fmt2Digits ------------------------------*/

/*	moved from formatd.c to here when Formatdt() was re-written not to need
 *	this -- lhunt Apr 16, 1993 */

int	 Fmt2Digits( num, len, strP )

register int  num;	/* If positive and a pad char is needed, use leading 0.
				   If negative and a pad char is needed, use leading blank*/
register int  len;
register char *strP;
{
	/* This procedure formats the day or month field and always takes two spaces 
	   to do so, even if its less than 10.	This is so a vertical column of date 
	   values will line up. 
	   RETURN VALUE:  A revised value for the 'len'.  */

	register int	blnkZeroFlag;

	blnkZeroFlag = 0;
	if( num < 0 ) {
		num = -num;
		blnkZeroFlag = 1;		/* use a blank */
	}
	if( num < 10 )
		strP[ len++ ] = (blnkZeroFlag==0) ? '0'	 : ' ';
	len += IntConvert( num, strP+len );
	return( len );
}

static int IntConvert(n,s)
int n;
char *s;
{
	sprintf(s,"%d",n);
	return(strlen(s));
}


/*---------------------------- datelex --------------------------------------
NAME
	datelex - Produce the next input token from a date-time string
SYNOPSIS
DUTYPE datelex( tokvalP, strP )

long		*tokvalP;  integer value of the token if it has one. The
				tokens with values and their possible 
				values are:
				token=6 (AM or PM):	 AM=0,	PM=1
				token=1 (month):  Jan=1,...,Dec=12
				token=0 (digit string): value of the number
char		**strP;	   On 1st call, pointer to the address of the string
				to be lexed.  Updated by each call.	 Caller
				should not disturb the value between calls.
DESCRIPTION
Identifies the next token in a date-time input string, if possible.	If a
 value is associated with a token, returns that as well.

RETURN VALUES:	are DUTYPE, start with DU_ and are listed in dt.h
*/


DUTYPE
datelex( tokvalP, strP )
long	*tokvalP;
char	**strP;

{
	int ch, gotnum, gotlet,
		val_strfl, mos_strfl, dys_strfl, days_strfl;
	DUTYPE	tok;
	long	atol();
	char *wktxtP;
#define MAXTOKEN 30
	char	tstr[MAXTOKEN];	/*plenty of extra room so long string of letters 
								  will not break this routine. */
	static char mos[240] = "\0",
				eng_mos[240] = "\0";

	id_date_lang(&val_strfl, &mos_strfl, &dys_strfl, &days_strfl);

getNxtToken:
	gotlet = gotnum = -1;
	tok = DU_UNINIT;

	while (tok < 0) {
		ch = **strP;
		ch &= 0xff;		/*by masking for extended/Adobe characters here,
							we can safely test for 'ch > 127' later*/
		(*strP)++;
		if (ch=='.') {
			*tokvalP = ch;
			tok = DU_PERIOD;
		}
		if (ch=='/') {
			*tokvalP = ch;
			tok = DU_SLASH;
		}
		if (ch=='-') {
			*tokvalP = ch;
			tok = DU_DASH;
		}
		if (ch==':') {
			*tokvalP = ch;
			tok = DU_COLON;
		}
		if (ch=='\0') {
			tok = DU_ENDOFSTRING;
		}
		if (tok > 0)  {
			if ( (gotnum == -1) && (gotlet == -1) )
				return( tok );
			break;
		}
		if( ((ch >= 'a' ) && (ch <= 'z' ))  ||  (ch > 127) )
					/*	allow and handle extended/Adobe chars */
			ch = Atoupper(ch);	/* shift to upper case	ASSUMES ASCII !!!!*/
		if( (ch >= '0' )  &&  (ch <= '9' ) ){
			if ( gotlet == -1) {
				if( (gotnum ==0) && (ch =='0') && (tstr[0] == '0'))
					continue;	/*ignore multiple leading zeros.*/
				if( (++gotnum) >= MAXTOKEN )
					return( -1 );
				tstr[gotnum] = ch;
			}
			else	
				tok = DU_NUMBER;	/*have a string of letters which is 
								  implicitly delimited by beginning of next
								  numeric token as in MAR84 */
		}
		else {
					/*	allow and handle extended/Adobe chars */
			if( ((ch >= 'A' ) && (ch <= 'Z' ))  ||  (ch > 127) )  {
				if ( gotnum == -1) {
					if( (++gotlet) >= MAXTOKEN )
						return( -1 );
					tstr[gotlet] = ch;
				}
				else
					tok = DU_NUMBER;
			}
			else {	/*some screwy char like a space, comma ! = +, etc */
				if( (ch == ' ')	 || (ch == ',') ){
					if ( gotnum > -1) /* then this is a delimiter*/
						break;
					if ( gotlet > -1)
						break;

					*tokvalP = ch;

					if (ch == ',')
						return (DU_COMMA);

					if (ch == ' ')
						return (DU_SPACE);
				}

				*tokvalP = ch;
				return( DU_UNIDENTIF );

			}
		}
	}

	(*strP)--;		/* back ptr up to re-examine delimiting char next call*/

	if( gotnum > -1) {
		tstr[++gotnum] = '\0';
		if( gotnum > 8 )
			return( -1);
		*tokvalP = atol(tstr);
		date_len = strlen (tstr);		/*	to be passed back to ParseDate() */
		tok = DU_NUMBER;
		return( tok );
	}

	if( gotlet > -1) {
		tstr[++gotlet] = '\0';
		if( mos[0] == '\0' ) {
			if (getStr( val_strfl, mos) != AOK) {
				return( -1 );
			}
		}
		if ( (tok = ListCk( tstr, mos, (int)0 )) < 0 ) {

			/*	didn't recognize string as a month - check for weekday */

			if( FSetdaysofWeek( dys_strfl, &wktxtP, 1 ) == AOK) {
				if( (tok = ListCk( tstr, wktxtP, 0)) >= 0)
				{
					*tokvalP = tok - 'a';
					return (DU_AWKDY);	/*	abbrev'd weekday name */
				}
			}
			if( FSetdaysofWeek( days_strfl, &wktxtP, 0 ) == AOK) {
				if( (tok = ListCk( tstr, wktxtP, 0)) >= 0)
				{
					*tokvalP = tok - 'a';
					return (DU_FWKDY);
				}
			}

			/*	We haven't recognized a French weekday or month */
			/*	Do a specifically english check to catch day/month values
			 *	from English Unix systems even if we're running a language
			 *	Applixware version -- lhunt 2/2/94
			 */

			if( eng_mos[0] == '\0' ) {
				if (getStr( ENGVALS, eng_mos) != AOK) {
					return( -1 );
				}
			}

			if ( (tok = ListCk( tstr, eng_mos, (int)0 )) < 0 ) {
				if( FSetdaysofWeek( ENGDYS, &wktxtP, 1 ) == AOK) {
					if( (tok = ListCk( tstr, wktxtP, 0)) >= 0)
					{
						*tokvalP = tok - 'a';
						return (DU_AWKDY);	/*	abbrev'd weekday name */
					}
				}
				if( FSetdaysofWeek( ENGDAYS, &wktxtP, 0 ) == AOK) {
					if( (tok = ListCk( tstr, wktxtP, 0)) >= 0)
					{
						*tokvalP = tok - 'a';
						return (DU_FWKDY);
					}
				}

				/*	Couldn't recognize it in <language> or English */
				return( tok );
			}
		}

		tok -= 'a';		/*	it's a month */

		if( tok > 2 ) {			/*	then month value */
			*tokvalP = tok - 2;
			FMoLexFmt = gotlet; /*return the number of chars in
								in the string to Parsedate. */
			if (gotlet > 3)
				return(DU_FMON );
			else
				return(DU_AMON );		/*	abbrev'd month name */
		}

		if( tok == 2 ) {		/* then found TH */
			*tokvalP = -1;
			return( DU_TH );
		}

		/* tok is 0 (am) or 1(pm). */
		*tokvalP = tok;
		if (tok == 1)
			return( DU_PM );
		else
			return (DU_AM);
	}
	*tokvalP = -1;
	tok = DU_UNIDENTIF;
	return ( tok );				/*	should never be able to reach this stmt */
}
