/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: dumpdia.c
   Applix ASC version: 7
   Date: Thu Mar  4 21:13:45 1999
*/
#include <stdio.h>
#include <utloc.h>
#include <dia.h>

static int entflag = 0;
#if AXMS | (SYS&VMSSYS) | (LINUX)
FILE *DiaFp = NULL;
#else
FILE *DiaFp = stderr;
#endif
int DiaHex = 0;					/* Print values in hex? (default is octal) */
int DiaBitSpace = 1;			/* Insert a space after every 8th bit? */

/* BEGIN SYNOPSIS */
dumpDIAmsg(msgP,msgendP,nestlevel )
char *msgP;
char *msgendP;
int	nestlevel;
/* END SYNOPSIS */
{
	AI_desc	desc;
	char	*ptr;
	char	txt[34];
	char	indenttxt[18];
	char	disp[512];
	char	*dispP, *dispE;
	short	limit;
	int	ok;
	int	siz;
	int	i;
	unsigned short	s;
	unsigned long	lng;
	double dbl;

#if AXMS | (SYS&VMSSYS)
	if(!DiaFp)
		DiaFp = stderr;
#endif

	limit = 0;
	if(entflag == 0) {
		fprintf(DiaFp, "                  **********\n");
		fflush(DiaFp);
	}
	++entflag;
	if(msgendP)
		limit = msgendP - msgP + 1;
	ptr = msgP;

	*indenttxt = '\0';
	for(ok = 0; ok < nestlevel; ok++)
		strcat(indenttxt, "  ");

	while(TRUE) {
		if(limit > 0 && ptr - msgP >= limit) {
			ok = 1;
			fprintf(DiaFp,"Hit end of designated buffer\n");
			fflush(DiaFp);
			break;
		}
		ptr = DIAgettype(ptr,&desc);
		ok = 1;
		strcpy(disp,"");
		switch(DtFundamental(desc.AItype)) {
		  case DtNODATA:
			strcpy(txt,NXLT("DtNODATA          "));
				   /*   123456789012345678     */
			break;

		  case DtCHAR:
			if(desc.AIdlen > sizeof(disp) - 1)
				siz = sizeof(disp) - 1;
			else
				siz = desc.AIdlen;
			strncpy(disp,desc.AIptr,siz);

			/* make sure string is null terminated for display, below */
			disp[siz] = '\0';
		
			if(desc.AIptr[desc.AIdlen - 1])
				strcpy(txt,NXLT("DtCHAR (NO null!) "));
					   /*   123456789012345678  */
			else
				strcpy(txt,NXLT("DtCHAR (with null)"));
					   /*   123456789012345678  */
			break;

		  case DtBIT:
			strcpy(txt,NXLT("DtBIT             "));
				 	/*  123456789012345678     */
			dispP = disp;
			dispE = dispP + sizeof (disp) - 3;
			for(i = 0; (unsigned)i < (8 * desc.AIdlen); i++) {
				*dispP++ = tstbit(desc.AIptr,i) ?  '1' : '0';
				if(DiaBitSpace && i > 0 && !(i % 8))
					*dispP++ = ' ';
				if(dispP >= dispE)
					break;
			}
			*dispP = '\0';		/* terminate string w/null */ 
			break;

		  case DtSHORT:
			strcpy(txt,NXLT("DtSHORT           "));
					/*  123456789012345678     */
			DIAgetshort(&desc,&s);
			if(DiaHex)
				sprintf(disp,"%%d:%d %%u:%u %%x:%x",s,s,s);
			else
				sprintf(disp,"%%d:%d %%u:%u %%o:%o",s,s,s);
			break;

		  case DtLONG:
			strcpy(txt,NXLT("DtLONG            ") );
					/*  123456789012345678     */
			DIAgetlong(&desc,&lng);
			if(DiaHex)
				sprintf(disp,"%%d:%ld %%u:%lu %%x:%lx",lng,lng,lng);
			else
				sprintf(disp,"%%d:%ld %%u:%lu %%o:%lo",lng,lng,lng);
			break;

		  case DtDOUBLE:
			strcpy(txt,NXLT("DtDOUBLE          "));
					/*  123456789012345678     */
			DIAgetdouble(&desc,&dbl);
			sprintf(disp,"%%e:%e %%f:%f %%g:%g",dbl,dbl,dbl);
			break; 

		  case DtCONSTRUCTOR:
			strcpy(txt,NXLT("DtCONSTRUCTOR     "));
					/*  123456789012345678     */
			ok = 0;
			break; 

		  default:
			fprintf(DiaFp,NXLT("%s Bogus Dt value %o at %d\n"),indenttxt,desc.AItype,
				desc.AIptr - 2 - msgP);
			fflush(DiaFp);
			ok = 2;
		}

		if(ok == 2)  
			break;

		if(DiaHex)
			fprintf(DiaFp,NXLT("%s %s Typ:0x%x Len:%d <%s>\n"),indenttxt,txt,
				desc.AItype,desc.AIdlen,disp);
		else
			fprintf(DiaFp,NXLT("%s %s Typ:%o Len:%d <%s>\n"),indenttxt,txt,
				desc.AItype, desc.AIdlen, disp );
		fflush(DiaFp);

		if(ok == 0 &&
			(ok = dumpDIAmsg(desc.AIptr,msgendP,nestlevel + 1)))
			break; 

		if(desc.AItype == DtEOM) {
			ok = 0;
			break;
		}
	}
	entflag--;
	return(ok);
}
