/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: parsdat.c
   Applix ASC version: 64
   Date: Thu Feb 25 21:11:32 1999
*/
#include <utloc.h>

#include <axtime.h>

#include <datetime.h>
#include <style.h>
#include <getstr9.h>
#include <getstr8.h>
#include <getstr2.h>
#include <dt.h>

#define MAXDATESTR 480	/*	Max length of string to try and transpose to a date */
#define MAXTOKLEN	20	/*	Max length of token array */

#define	NUM_DTFMTS	19	/*	Curr # of date fmts */

extern foreignChars UTprofsym;	/* defined in strinit.c */
extern int			AxMetric;	/*	set in maininit.c */

extern typeErr getStr(); 
extern DUTYPE datelex();
extern char *GetProfileByCode();
static struct tm *Alocaltime();


extern dttmfmt	dtfmt[],
				tmfmt[];
extern int		MaxDtFmt,
				MaxTmFmt;

typeErr		fmts_loaded(),
			load_datetime_fmts(),
			break_into_date(),
			break_into_time(),
			check_date(),
			check_time(),
			dt_validate(),
			ParseDateToAxTimeStruct();
unsigned long	getApplixDateValue();
unsigned long	getUnixDateValue();
static void tmToAxTime(/* AxTimeStruct *axtimeP, struct tm *tmP */);


/*	Special fmts for date fmts that have no 4-year counterparts.
 *	Must make sure to recognize them if they use 4 digit year,
 *	but will only display them so if yr >= 2000.
 *
 */
int				MaxSpecFmt = 3;

dttmfmt			specdtfmt[] = {

	{
		"d Mm yyyy",					 /*	fmt  3, 4-digit version	*/
		{DU_1DAY,DU_SPACE,DU_AMON,DU_SPACE,DU_4YR},
		DU_SPACE,
		5
	},

	{
		"mm/dd/yyyy",					 /*	fmt  4, 4-digit version	*/
		{DU_2MON,DU_SLASH,DU_2DAY,DU_SLASH,DU_4YR},
		DU_SLASH,
		5
	},

	{
		"dd/mm/yyyy",					/*	fmt 12, 4-digit version	*/
		{DU_2DAY,DU_SLASH,DU_2MON,DU_SLASH,DU_4YR},
		DU_SLASH,
		5
	},

	(int)NULL
};

/*	Special fmts for UNIX mail date fmts.  Recognition only; we don't print
 *	these.
 */
#define NUM_SPECIALS 10
#define UMDTOKLEN	18	/*	Length of token array for Unix mail date fmt */
static DUTYPE	cmp_arryUMD[NUM_SPECIALS][UMDTOKLEN] = {

	/*	Mon Jul 19 14:48:16 1991 */
	{DU_AWKDY,DU_SPACE,DU_AMON,DU_SPACE,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_4YR},

	/*	Mon Jul 19 14:48:16 EDT 1991 */
	{DU_AWKDY,DU_SPACE,DU_AMON,DU_SPACE,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_UNINIT,DU_SPACE,DU_4YR},

	/*	Jul 19 14:48:16 1991 */
	{DU_AMON,DU_SPACE,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_4YR},

	/*	Jul 19 14:48:16 EDT 1991 */
	{DU_AMON,DU_SPACE,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_UNINIT,DU_SPACE,DU_4YR},

	/*	Mon Jul 19 14:48 EDT 1991 */
	{DU_AWKDY,DU_SPACE,DU_AMON,DU_SPACE,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_SPACE,DU_UNINIT,DU_SPACE,DU_4YR},

	/*	Jul 19 14:48 EDT 1991 */
	{DU_AMON,DU_SPACE,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_SPACE,DU_UNINIT,DU_SPACE,DU_4YR},

    /* Wed, 17 Dec 1995 11:59:23 EST */
    /* Used by an NT sendmail deamon - jon */
    {DU_AWKDY,DU_COMMA,DU_SPACE,DU_2DAY,DU_SPACE,DU_AMON,DU_SPACE,DU_4YR,DU_SPACE,
    DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_UNINIT},

    /* Wed, 17 Dec 1995 11:59:23 -nnnn */
    {DU_AWKDY,DU_COMMA,DU_SPACE,DU_2DAY,DU_SPACE,DU_AMON,DU_SPACE,DU_4YR,DU_SPACE,
    DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_DASH,DU_NUMBER},

    /* Wed, 17 Dec 95 11:59:23 EST */
    {DU_AWKDY,DU_COMMA,DU_SPACE,DU_2DAY,DU_SPACE,DU_AMON,DU_SPACE,DU_2YR,DU_SPACE,
    DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_SPACE,DU_UNINIT},

	/* 2088-11-29 00:00:00.000 */
	/* ODBC datetime format, has milliseconds. */
	{DU_4YR,DU_DASH,DU_2MON,DU_DASH,DU_2DAY,DU_SPACE,
	DU_24HR,DU_COLON,DU_MIN,DU_COLON,DU_SEC,DU_PERIOD,DU_MSEC}
};


/*
.BEGIN MANPAGE
.NAME ParseDate - Parse a date-time string.
.SYNOPSIS
#include <datetime.h>
.ARGUMENT pdoption
	PDNORMAL requests normal operation;	 string can contain either
	a date, time or both.
	Times between 0:00 to 12:00 are assumed to be AM if not otherwise specified.
	However, if the external foreignChars UTprofsym (see UTgetsym()) timeForm
	indicates a 12 hour clock (DTTF12HR or DTTF12HB), Times between
	1:00 and 6:00 (inclusive) are assumed to be PM.

	PDNORMEUROPE is like PDNORMAL except that ##/##/## and ##-##-## are
	interpreted as dd/mm/yy instead of the American mm/dd/yy.

	PDDATE only accepts a date.	 If a date and time or just a time is specified,
	an error is returned.  One subtle point: Under this option, if the
	string is a single number, it is interpreted as a day value in the current
	month of the current year.

	PDMOYR only accept a month and year value; the day is implicitly 1.
	A time value not allowed.

	PDDATEEUROPE is like PDDATE except that ##/##/## and ##-##-## are
	interpreted as dd/mm/yy instead of the American mm/dd/yy.

	PDTIMEAMPM only accepts a time.
	Times between 0:00 to 12:00 are assumed to be AM if not otherwise specified.
	However, if the external foreignChars UTprofsym (see UTgetsym()) timeForm
	indicates a 12 hour clock (DTTF12HR or DTTF12HB), Times between
	1:00 and 6:00 (inclusive) are assumed to be PM.

	PDUNIXLONG: given a date-time string, return a UNIX long instead of an
	Applix long

	PDTIME is like PDTIMEAMPM except the external foreignChars UTprofsym
	(see UTgetsym()) timeForm is ignored.

	PDCURRDATE obtain the system date in Applix format.
	The input string is ignored; no parsing is done.

	PDCURRTIME obtain the system time in Applix format.
	The input string is ignored; no parsing is done.

	PDCURRBOTH obtain the system date and time in Applix format.
	The input string is ignored; no parsing is done.

	PDUNIXBOTH given a UNIX date-time value, obtain the Applix format
	The input string is ignored; no parsing is done.
.ARGUMENT stringP
	The address of the date-time string to be parsed.
	Ignored if pdoption is PDCURRDATE, PDCURRTIME, PDCURRBOTH, or PDUNIXBOTH.
.ARGUMENT dtvalueP
	The address to receive the Applix format date-time value.
	If pdoption is PDUNIXBOTH, dtvalueP is also the address of the
	UNIX date-time value.
.ARGUMENT datefmtP
	The address to receive one of the following format codes to indicate
	the format of the string that was parsed:  DTDFABBREV, DTDFMIL,
	DTDFSLASH, DTDFDOT, DTDFDOTY4, DTDFNONE (if no recognizable format was found
	or no date-time value was returned.)
.DESCRIPTION
	ParseDate() will parse a string which contains a date, date and time,
	or just time and obtain the Applix format date-time value. The following
	are valid date-time strings under the PDNORMAL option:

.nf
Jan. 14 1983
JAN 14 1983
Jan 14, 1983
Jan 14		(assume current year)
14JAN83
14Jan.1983
14 Jan		(assume current year)
1/14/83
01/14/1983
1/14		(assume current year)
14.1.83
14.1.1983
14.1
14.jan.83
JAN.14.83
JAN/14/83
14/Jan/83
14/Jan		(assume current year)
14th		(assume current month & year)
14TH		(assume current month & year)

9PM
9:34PM
19:34
9 PM
9:34 am
9: AM

1/14 9AM
jan 14, 1983  9:34AM
14th 9am
14th 9
.fi
 
	ParseDate() will succesfully parse an empty string,
	returning a date-time value of DTNULL.
.SEE ALSO
	Formatdt(3A) ParseMonth(3A)
.RETURN VALUE
	If ParseDate() was successful 0 is returned,
	otherwise a non-zero value is returned and dtvalue will receive DTNULL.
.END MANPAGE
*/

typeErr
ParseDate (pdoption, in_stringP, dtvalueP, datefmtP, datefmt_strP)
int		pdoption;
char	*in_stringP;
unsigned long	*dtvalueP;
short	*datefmtP;
char	*datefmt_strP;
{
	AxTimeStruct axtime;
	int status;

	status = ParseDateToAxTimeStruct(&axtime,
						pdoption,in_stringP,dtvalueP,datefmtP,datefmt_strP);
	if (status == AOK) {
		struct tm tm;

		tm.tm_sec = axtime.second;
		tm.tm_min = axtime.minute;
		tm.tm_hour = axtime.hour;
		tm.tm_mday = axtime.day;
		tm.tm_mon = axtime.month;
		tm.tm_year = axtime.year;
		tm.tm_isdst = -1;		/* Means 'use default def of DST' */
		if (pdoption == PDUNIXLONG) 
			*dtvalueP = getUnixDateValue(&tm);
		else
			*dtvalueP = getApplixDateValue(&tm);
	}
	else {
		*dtvalueP = DTNULL;
	}
	return(status);
}


typeErr
axParseDate (pdoption, in_stringP, tm, datefmtP, datefmt_strP)
int		pdoption;
char	*in_stringP;
short	*datefmtP;
char	*datefmt_strP;
struct tm *tm;
{
	AxTimeStruct axtime;
	int status;
	unsigned long dtvalue;

	status = ParseDateToAxTimeStruct(&axtime,
						pdoption,in_stringP,&dtvalue,datefmtP,datefmt_strP);
	if (status == AOK) {

		tm->tm_sec = axtime.second;
		tm->tm_min = axtime.minute;
		tm->tm_hour = axtime.hour;
		tm->tm_mday = axtime.day;
		tm->tm_mon = axtime.month;
		tm->tm_year = axtime.year;
		tm->tm_isdst = -1;		/* Means 'use default def of DST' */
	}
	return(status);
}

typeErr
ParseDateToAxTimeStruct(axtimeP,pdoption,in_stringP,dtvalueP,datefmtP, datefmt_strP)
AxTimeStruct *axtimeP; /* out */
int		pdoption;
char	*in_stringP;
unsigned long	*dtvalueP; /* in, for PDUNIXBOTH, unused otherwise */
short	*datefmtP;
char	*datefmt_strP;
{
	char	strng[MAXDATESTR],
			strng_cmp[MAXDATESTR],
			fmt_str[MAXDATESTR],
			*catcher = NULL,
			*instrP = &strng[0],
			*strP;
	typeErr	retvalue = !AOK;
	long	sysclock = 0L;
	DUTYPE	result = 0,
			res_arry[MAXTOKLEN],	/*	user's string parsed to tokens */
			toks[MAXTOKLEN],		/*	token values of user's string's tokens */
			cmp_arry[MAXTOKLEN * 6];	/*	the comparison token array we build up */
    DUTYPE  *specialP;
    int j;
	long	token_value = -1;
	int		i = 0,
			euroFlag = 0,		/*	are we in euro fmt? */
			res_len = 0,		/*	length of the user's string in tokens */
			d = 0, t = 0, w = 0,
			dd = 0, tt = 0, ww = 0;
	struct tm		*tm = NULL,			/*	to store system-got time */
					tm2;				/*	to modify */
	static int	loaded = FALSE;			/*	are the datetime fmts loaded? */

	if ( ! loaded && ! fmts_loaded())
	{
		if (load_datetime_fmts() != AOK)
			return (!AOK);
		else
			loaded = TRUE;
	}


	if (pdoption != PDCURRDATE && pdoption != PDCURRTIME
		&& pdoption != PDCURRBOTH && pdoption != PDUNIXBOTH)
	{
		/*	set defaults */

		memset (strng, 0, sizeof(strng));
		strncpy (strng, in_stringP, MAXDATESTR-1); /* truncate if too long */
		strng[MAXDATESTR -1] = '\0';
		memset (strng_cmp, 0, sizeof(strng_cmp));
		memset (res_arry, -1, sizeof(res_arry));

		sysclock = time ( (long *) 0 );
		tm = Alocaltime (&sysclock);	/*	get default date/time */
		if (!tm) return(!AOK);

		*datefmtP = DTDFNONE;

		/*	what kind of date fmt does the input string evaluate to? */
		i = 0;
		while ( (result = datelex (&token_value, &instrP)) != DU_ENDOFSTRING)
		{
			/*	collapse beginning and multiple spaces */
			if (result == DU_SPACE && (res_arry[i - 1] == DU_SPACE || i == 0) )
				continue;

			if (i < MAXTOKLEN - 1)
			{
				res_arry[i] = result;
				toks[i++] = token_value;
			}
			else
			{
				/*	The token array size accommodates all our known formats;
				 *	if it has overflowed, we're not going to recognize this
				 *	string as a date anyway */
				return (!AOK);
			}
		}

		if (res_arry[i - 1] == DU_SPACE)
		{
			res_arry[i - 1] = -1;		/*	collapse trailing space */
			i--;
		}
		
		res_arry[i] = DU_ENDOFSTRING;
		res_len = i;

		/*	First, find out if strng is a Unix mail date. This format
		 *	doesn't match any of our pre-defines:
		 *		e.g.:	Sat Jan 30 10:02:40 1993
		 */
		if (res_len >= UMDTOKLEN - 5)		/*	what's the 5 ? */
		{
			for (j = 0; j < NUM_SPECIALS; j++)
			{
                specialP = cmp_arryUMD[j];

				for (i = 0; i < res_len; i++)
				{
					if (res_arry[i] == DU_NUMBER && specialP[i] > DU_NUMBER)
						break;
					else if (res_arry[i] != DU_NUMBER && res_arry[i] != specialP
[i])
						break;
				}

				if (i == res_len)
				{
#if 0
					printf ("\t\t\tMatched a Unix mail date fmt\n");
#endif

					d = t = -1;		/*	special flag to dt_validate() */
					w = 1;			/*	abbrev'd wkday at beg of date */

					if((result = dt_validate(pdoption,specialP,res_arry,toks,
											d,t,w,tm)) == AOK)
					{
						/*	the date fmt for a Unix mail date is used nowhere */
						/*	else; see ElfbParseDate() */
						*datefmtP = d + t*DTTFBASE + w*DTWFBASE;
						*datefmt_strP = (int)NULL;		/*	don't need for mail */
						if ((pdoption == PDUNIXLONG)
								&& (tm->tm_year < 1970 || tm->tm_year < 70))
							return (!AOK);
						tmToAxTime(axtimeP, tm);
						return (AOK);
					}
				}
			}
		}


		/*	Second, find out if strng matches any of the regular
		 *	expressions:  d, t, w
		 */

		for (w = ww = 0; ww <= DTWFFEND; w++, ww += DTWFBASE)
		{
			for (t = 0; t < MaxTmFmt; t++)
			{
				for (d = 0; d < MaxDtFmt + MaxSpecFmt; d++)
				{

					/*	Build our format token string:
					 */
					memset (fmt_str, 0, sizeof(fmt_str));
					memset (cmp_arry, -1, sizeof(cmp_arry));
					i = 0;

					if (w % 2 == 1)				/*	weekday at beginning */
					{
						if (strlen(fmt_str) > 0)
							strcat (fmt_str, " ");

						if (ww == DTWFFBEG)
						{
							cmp_arry[i] = DU_FWKDY;
							strcat (fmt_str, FWKDY_NAME);
						}
						else if (ww == DTWFBEG)
						{
							cmp_arry[i] = DU_AWKDY;
							strcat (fmt_str, AWKDY_NAME);
						}
						i++;
					}
					if (d)
					{
						if (strlen(fmt_str) > 0)
							strcat (fmt_str, " ");

						if (i)
							cmp_arry[i++] = DU_SPACE;

						if (d < MaxDtFmt)
						{
							memcpy (&cmp_arry[i], dtfmt[d].tok, 
										dtfmt[d].toklen * sizeof (dtfmt[d].tok[0]));
							i += dtfmt[d].toklen;

							strcat (fmt_str, dtfmt[d].fmt);
						}
						else
						{
							dd = d - MaxDtFmt;
							memcpy (&cmp_arry[i], specdtfmt[dd].tok, 
										specdtfmt[dd].toklen * sizeof (specdtfmt[dd].tok[0]));
							i += specdtfmt[dd].toklen;

							strcat (fmt_str, specdtfmt[dd].fmt);
						}
					}
					if (t)
					{
						if (strlen(fmt_str) > 0)
							strcat (fmt_str, " ");

						if (i)
							cmp_arry[i++] = DU_SPACE;

						memcpy (&cmp_arry[i], tmfmt[t].tok,
									tmfmt[t].toklen * sizeof (tmfmt[t].tok[0]));
						i += tmfmt[t].toklen;

						strcat (fmt_str, tmfmt[t].fmt);
					}
					if (w && w % 2 == 0)		/*	weekday trailing */
					{
						if (strlen(fmt_str) > 0)
							strcat (fmt_str, " ");

						if (i)
							cmp_arry[i++] = DU_SPACE;

						if (ww == DTWFFEND)
						{
							cmp_arry[i] = DU_FWKDY;
							strcat (fmt_str, FWKDY_NAME);
						}
						else if (ww == DTWFEND)
						{
							cmp_arry[i] = DU_AWKDY;
							strcat (fmt_str, AWKDY_NAME);
						}
						i++;
					}

					if (res_len != i)	/*	user & format toklens don't match */
						continue;

					for (i = 0; i < res_len; i++)
					{
						if (res_arry[i] == DU_NUMBER && cmp_arry[i] > DU_NUMBER)
							break;
						else if (res_arry[i] == DU_AM || res_arry[i] == DU_PM)
						{
							if (cmp_arry[i] != DU_PM )
								break;
							else
								continue;
						}
						else if (res_arry[i] != DU_NUMBER && res_arry[i] != cmp_arry[i])
							break;
					}

					if (i == res_len)
					{
						/*	Toss out obvious incompatibilities - we match a date
						 *	but only time was asked for, and vice versa */
						if (d != 0
							&& (pdoption == PDTIMEAMPM || pdoption == PDTIME))
						{
							continue;
						}
						
						if (t != 0
							&& (pdoption == PDDATE || pdoption == PDDATEEUROPE))
						{
							continue;
						}

						if ( strncmp(fmt_str, "mm/dd/yy", 8) == 0 
						&&   AxMetric)
						{
							/*	Euro-mode uses "dd/mm/yy" */
							continue; /* equivalent euro mode date must follow */
						}
						else if (strncmp(fmt_str, "dd/mm/yy", 8) == 0
								&& !AxMetric)
							continue; /* Do not recogize euro format date
										when AxMetric is false. */


						/*	matched everything */

#if 0
						printf ("\t\t\tMatch at d=%d, t=%d, w=%d\n", d,t,w);
#endif

						if((result = dt_validate(pdoption,cmp_arry,res_arry,
												toks, d,t,w,tm)) == AOK)
						{
							if (d >= MaxDtFmt)
							{
								/*	If we matched a special fmt (4-digit yr),
								 *	reset d to the appropriate normal fmt
								 *	(2-digit yr)
								 */
								if (d == MaxDtFmt)
									d = 3;
								if (d == MaxDtFmt + 1)
									d = 4;
								if (d == MaxDtFmt + 2)
									d = 12;

								/*	Adjust 'yyyy' in the format str back to 'yy'
								 *	We shld check to see if YR4_NAME is the
								 *	last part of the fmt str, but if it's
								 *	matched one of these fmts, it is.
								 */
								strP = strchr(fmt_str, YR4_NAME[0]);
								while (strspn(strP,YR4_NAME) != YR4_LEN)
									strP = strchr(strP,YR4_NAME[0]);
								if (strP == NULL)
									return (!AOK);
								memset (strP, '\0', YR4_LEN);
								strcat (fmt_str, YR2_NAME);
								strcat (fmt_str, "");
							}
							*datefmtP = d + t*DTTFBASE + w*DTWFBASE;
							strcpy (datefmt_strP, fmt_str);
							if ((pdoption == PDUNIXLONG)
									&& (tm->tm_year < 1970 || tm->tm_year < 70))
								return (!AOK);
							tmToAxTime(axtimeP, tm);
							return (AOK);
						}
					}

				}	/*	for d */
			}	/*	for t */
		}	/*	for w */
	} 	/*	end fmt interpretation */
	else
	{
		/*	no fmt interpretation required; just get system date/time */
		/*	and adjust to applix req'ts */

		if (pdoption == PDUNIXBOTH && dtvalueP == NULL)
			return (!AOK);


		if (pdoption == PDUNIXBOTH)
			sysclock = *dtvalueP;				/*	a unix date-time */
		else
			sysclock = time ( (long *) 0 );		/*	get default date/time */

		tm = Alocaltime (&sysclock);		
		if (!tm) return(!AOK);
		
		if (pdoption == PDCURRTIME)		/*	time only, null out dates */
		{
			tm->tm_year = DTTIMEBASEYEAR;
			tm->tm_mon = tm->tm_mday = 0;
		}
		else if (pdoption == PDCURRDATE)	/*	date only, null out time */
		{
			tm->tm_hour = tm->tm_min = tm->tm_sec = 0;
		}

		*datefmtP = (int)NULL;
		*datefmt_strP = (int)NULL;

		tmToAxTime(axtimeP, tm);
		return (AOK);
	}

	return (retvalue);
}

static void tmToAxTime(axtimeP,tmP)
AxTimeStruct *axtimeP;
struct tm *tmP;
{
	axtimeP->fraction = 0.0;
	axtimeP->second = tmP->tm_sec;
	axtimeP->minute = tmP->tm_min;
	axtimeP->hour = tmP->tm_hour;
	axtimeP->day = tmP->tm_mday;
	axtimeP->month = tmP->tm_mon;
	axtimeP->year = tmP->tm_year;
}


/*	We've matched a date/time pattern; now validate the values that are
 *	expected by that pattern.  If the validation fails, this is not the
 *	correct match
 */
typeErr
dt_validate (pdoption, cmp_arry, res_arry, toks, d, t, w, tm)
int		pdoption,
		d, t, w;
DUTYPE	cmp_arry[],
		res_arry[],
		toks[];
struct tm	*tm;			/*	default system time; selectively overwritten
							 *	during validatation */
{
	DUTYPE	result = 0;
	int		i = 0,				/*	ctr for result array */
			hr12fmt = FALSE,	/*	whether it's a 12hr clock */
			its_pm = FALSE,		/*if it's a 12hr clock, are we am or pm */
			yrfmt = 0,			/*	save whether it's a 2-dig or 4-dig yr */
			day = 0, month = 0, year = 0,
			hour = 0, min = 0, sec = 0,
			baseyear = 1900;	/*is a two-digit year based on 2000 or 1900? */
	int		ddd = FALSE;
	typeErr	r = AOK;


	/*	We need at least a date or a time match to validate anything;
	 *	a single day name will not do it */

	if (!d && !t)
		return (!AOK);


	/*	Now compare */

	for (i = 0; res_arry[i] != DU_ENDOFSTRING; i++)
	{
		switch (res_arry[i])
		{
			case DU_AWKDY:	switch (w * DTWFBASE)
							{
								case DTWFFBEG:
								case DTWFFEND:	return (!AOK);
												break;
							}
							break;

			case DU_FWKDY:	switch (w * DTWFBASE)
							{
								case DTWFBEG:
								case DTWFEND:	return (!AOK);
												break;
							}
							break;

			case DU_FMON:
			case DU_AMON:	month = toks[i];
							break;


			case DU_NUMBER:

				/*	if the matched string shows a number at that point,
				 *	get its value using our matched format string to
				 *	determine what the number represents
				 */
				switch (cmp_arry[i])
				{
					case DU_FMON:
					case DU_AMON:	
					case DU_1MON:	
					case DU_2MON:	month = toks[i];
									break;

					case DU_1DAY:	
					case DU_2DAY:
									day = toks[i];
									ddd = FALSE;
									break;
					case DU_3DAY: 	day = toks[i];
									ddd = TRUE;
									break;

					case DU_2YR:	
					case DU_4YR:	year = toks[i];
									yrfmt = cmp_arry[i];
									if (cmp_arry[i] == DU_2YR)
										baseyear = axGetBaseYear(year);
									break;

					case DU_1DATE2YR:
					case DU_1DATE4YR:
									day = toks[i];
									yrfmt = cmp_arry[i];
									r = break_into_date (&day, &month, &year);
									if (r != AOK)
										return (r);
									if (cmp_arry[i] == DU_1DATE2YR)
										baseyear = axGetBaseYear(year);
									break;

					case DU_1HR:
					case DU_2HR:
					case DU_24HR:	hour = toks[i];
									break;

					case DU_MIN:	min = toks[i];
									break;

					case DU_SEC:	sec = toks[i];
									break;

					case DU_MSEC:	break; /* ignore milliseconds */

					case DU_1TIME:	hour = toks[i];
									r = break_into_time(&hour, &min);
									if (r != AOK)
										return (r);
				}
				break;

			case DU_AM:
			case DU_PM:		if (cmp_arry[i] == DU_PM)
							{
								hr12fmt = TRUE;
								if (res_arry[i] == DU_PM)
									its_pm = DU_PM;
								else
									its_pm = DU_AM;
							}
							break;
		}
	}

	if (d)								/*	sets tm if date valid */
	{
		r = check_date (&day, &month, &year, yrfmt, pdoption, d, tm, 
												baseyear,ddd);

		if (hour || min || sec)
			r |= check_time (&hour, &min, &sec, hr12fmt, its_pm, pdoption, d, tm);
	}
	
	if (t)								/*	sets tm if time valid */
		r |= check_time (&hour, &min, &sec, hr12fmt, its_pm, pdoption, t, tm);

	return (r);
}


typeErr
break_into_date (dy, mo, yr)
int		*dy, *mo, *yr;			/*	mo and yr are guaranteed to be 0 */
{
	int		day = 0;

	/*	This tests possible DTDFY4 and DTDFY2 formats, which are one large
		number made up of yyyymmdd or yymmdd */

	day = *dy;						/*	save in case it doesn't work */

	if (*dy > (long) 0)
	{
		*yr = *dy / (long) 10000;
		if (*yr < 3099)				/*	max possible yr we handle */
		{
			*dy = *dy - (*yr * (long) 10000);
			*mo = *dy / 100;
			*dy = *dy - (*mo * 100);
		}
		else
		{
			*yr = -1;
			*dy = day;			/*	restore status quo for the next try */
			return (!AOK);
		}
	}

	return (AOK);
}



typeErr
break_into_time (hr, min)
int		*hr, *min;			/*	min is guaranteed to be 0 */
{
	int		hour;

	/*	This tests for a DTTF4DIGIT format, which is one large
		number made up of hhmm */
	
	if (*hr > 2359)			/*	if bigger than this, it's a date */
		return (!AOK);

	hour = *hr;				/*	save in case it doesn't work */

	if (*hr >= (long) 0)
	{
		*hr = hour / (long) 100;
		if (*hr < 24)				/*	max possible hour */
		{
			*min = hour - (*hr * 100);
		}

		if (*hr > 23 || *min > 59)	/*	impossibles */
		{
			*hr = hour;		/*	restore status quo */
			*min = -1;
			return (!AOK);
		}
	}

	return (AOK);
}


typeErr
check_date (dy, mo, yr, yrfmt, opt, d, tm, baseyr, ddd)
int		*dy, *mo, *yr, yrfmt, opt, d, baseyr;
struct tm	*tm;
int ddd; /* 1 or 0 if this one has 3 digit day */
{
	int		day,
			month,
			year,
			twodigit = FALSE,
			err = AOK;
				/*	set err to AOK by default;
				 *	if number is outside the limit, err is or'd with 1, and
				 *	is no longer == to AOK */



	/*	set the working values if there are any */

	day = ( (dy && *dy) ? *dy : 0);
	month = ( (mo && *mo) ? *mo : 0);
	year = ( (yr && *yr) ? *yr : 0); /* should'nt this be baseyear */

	/*	If there is only a month, reject it; it may be the result of a string
	 *	which may be taken for a month:  i.e. "DEC" for Digital Equip. Corp.
	 *	This is historically backward compatible; Aster*x 2.1 didn't accept it
	 *	either.
	 */

	if ( !day && month && !year )
		err = !AOK;

	/*	Validate from year on down, filling in holes if necessary */

	if (year)
	{
		/*	is it a 2 digit year ?  If so, flag it and correct to 4 digit */
		if (year < 100)
		{
			twodigit = TRUE;
			year += baseyr;		/*	we assume it's the current year */
		}
		/*	is it between base year and time span? */
		err |=  (year < DTTIMEBASEYEAR || year > (DTTIMEBASEYEAR + DTSPAN));

		/*	is it the correct # of digits for the fmt passed in? */
		switch (yrfmt)
		{
			case DU_1DATE2YR:
			case DU_2YR:	
				err |= (twodigit == FALSE);
				break;

			case DU_4YR:
			case DU_1DATE4YR:
				err |= (twodigit == TRUE);
				break;
		}
	}
	else
	{
		/*	The case of the year value 0:
		 *
		 *	Possibilities:
		 *
		 *		-	A non-0 yrfmt:
		 *				means that we matched a year position in the date
		 *				pattern, but the user entered a year value which
		 *				evaluated to 0,
		 *
		 *					e.g.:		1/1/00,  meaning  Jan 1, 1900
		 *					(We match Lotus, ==> 00 is 1900, 2000 is 2000)
		 *
		 *				-	A 2-digit yrfmt is valid
		 *				-	A 4-digit yrfmt is an error (year 10,000 !) and
		 *					we'll treat it as a missing yrfmt.
		 *
		 *		-	A 0 (missing) yrfmt:
		 *				the pattern we've matched is missing the year, 
		 *				so we fill it in from the current year so we can
		 *				calculate the Applix time value later on.
		 */

		if (!yrfmt)
			year = tm->tm_year + 1900;	/*	reset to current year */
		else
		{
			if (yrfmt != DU_2YR && yrfmt != DU_1DATE2YR)
				err |= TRUE;			/*	keep value of 0, but set err */
		}
	}

	if (month)
	{
		err |=  (month < 1 || month > 12);
	}
	else
	{
		/*	no month given; set it from the default time passed in */
		month = tm->tm_mon + 1;		/*	unix tm is off by one for month */
	}

	if (!ddd) {
		if (day)
		{
			switch (month)
			{
				case 1:
				case 3:
				case 5:
				case 7:
				case 8:
				case 10:
				case 12:
					err |=  (day < 1 || day > 31);
					break;
				case 4:
				case 6:
				case 9:
				case 11:
					err |= (day < 1 || day > 30);
					break;
				case 2:
					/*	check for leap day if year and month exist */
					if (leap (year))
						err |= (day < 1 || day > 29);
					else
						err |= (day < 1 || day > 28);
					break;
			}
		}
		else
		{
			/*no day given; default to 1, because 'Dec 93' == at least 12/1/93*/
			day = 1;
		}
	} else { 
		/* this is a special case where 3day token is used */
		if (day > 0 && (day <= (leap(year) != FALSE ? 366 : 365))) {
			int tday, tmonth;
			/* now extract the month and the day from the day number */
			ax_extract_date(year, day, &tday, &tmonth);
			day = tday;
			month = tmonth;
			err = AOK; 
		} else {
			err = 1;
		}
		
	}

	if (!err)
	{
		/*	zero out the time portion of the struct; if there's a time
		 *	associated with this date, the fields will be filled in,
		 *	but we need to retain DST information for mktime/localtime()
		 *	calls if this will be interpreted as a UNIX long.
		 */
		tm->tm_hour = tm->tm_min = tm->tm_sec = 0;

		if (year < 100)
			year += baseyr;

		tm->tm_year = year;
		tm->tm_mon = month;
		tm->tm_mday = day;
	}

	return (err);
}


typeErr
check_time (hr, min, sec, hr12fmt, its_pm, opt, t, tm)
int		*hr, *min, *sec, hr12fmt, its_pm, opt, t;
struct tm	*tm;
{
	int		err = AOK;

	if (min)
	{
		err |= (*min < 0 || *min > 59);
	}

	if (sec)
	{
		err |= (*sec < 0 || *sec > 59);
	}

	if (hr)
	{
		/*	the possible conflicts are:
			24-hr clock:  hr < 0 or hr > 23
			12-hr clock:  hr < 1 or hr > 12 	(option is AMPM or fmt is 12HR)
		 */
		err |= ( *hr < 0 || *hr > 23);			/*	general error */

		err |= (  ( opt == PDTIMEAMPM || hr12fmt == TRUE )	/*am-pm error */
					&& (*hr < 1 || *hr > 12) );
	}

	if (!err)
	{
		/*	Transform Hour ==> 24-Hr format for the tm structure */

		if (its_pm == DU_PM)
		{
			/*	It's explicitly P.M. in 12-hr format,
			 *	in which case a 12 is 12 noon which is pm.
			 *	so the hour value stays 12 and everything else gets
			 *	added to (p.m.) or stays the same (a.m.)
			 */
			if (*hr < 12)
				tm->tm_hour = *hr + 12;		/*	promote 12-hr to 24-hr value */
			else
				tm->tm_hour = *hr;
		}
		else if (its_pm == DU_AM)
		{
			/*	It's explicitly A.M. in 12-hr format,
			 *	in which case a 12 is 12 midnight which is am.
			 *	so the hour value goes to 0 and everything else
			 *	stays the same
			 */
			if (*hr == 12)
				tm->tm_hour = 0;			/*	12:00 am is 00:00 in 24-hr */
			else
				tm->tm_hour = *hr;
		}
		else
		{
			/*	If we have no other indication in the form of am/pm
			 *	assume 24-hr clock */
			tm->tm_hour = *hr;		
		}

		tm->tm_min = *min;
		tm->tm_sec = *sec;
	}

	return (err);
}


leap (yr)
int	yr;		/*	assumes a four-digit year */
{
	int	result = FALSE;

	result = (yr%4 == 0 && yr%100 != 0 || yr%400 == 0);		/*C manual p. 37*/
	return (result);
}

#define FL			60/DTTIMEGRANULARITY
#define FL60		FL*60
#define FL1440		FL*1440		/* 1440 = 60*24 */
#define FL46080		FL*46080	/* 46080 = 60*24*32 */
#define FL599040	FL*599040	/* 599040 = 60*24*32*13 */

unsigned long
getApplixDateValue(tm)
struct tm	*tm;			/*	packed with Applix values */
{
	int	baseyear = 1900;	/*	is the base 1900 or 2000? */

	if (tm->tm_year < 100)
	{
		baseyear = axGetBaseYear(tm->tm_year);
		tm->tm_year += baseyear;
	}

	return ((unsigned long)tm->tm_sec / DTTIMEGRANULARITY +	
			((unsigned long)tm->tm_min * FL) +
			((unsigned long)tm->tm_hour  * FL60) +
			((unsigned long)tm->tm_mday  * FL1440) +
			((unsigned long)tm->tm_mon  * FL46080) +
			(((unsigned long)tm->tm_year - DTTIMEBASEYEAR) * FL599040) );
}


unsigned long
getUnixDateValue(tm)
struct tm	*tm;			/*	packed with Applix values */
{
	unsigned long	unix_time = 0L;

	if (tm->tm_year > 1900)
		tm->tm_year = tm->tm_year - 1900;
	if (tm->tm_mon > 0)
		tm->tm_mon--;		/*	applix uses 1-12, unix 0-11 */

	/*	Everyone's got a different call for turning a tm back
	 *	into a long!  Sheesh! */

#if HP300 || HP800 || USL54 || SUN4S || AX_NT || PMAX || RIOS || SUNIS || SGI || AVIION || ALPHA || SCOUNIX || LINUX || NEC_EWS
	unix_time = mktime(tm);
#else
	unix_time = timelocal(tm);
#endif

	return (unix_time);
}

/*
*=============================================================================*
*	Routines to handle the century for two year digits
*=============================================================================*
*/

typedef struct  {
    int baseYear;
    int start;
    int end;
}ax_dd_pair;
 
typedef struct  {
    int inited; /* TRUE if initialized */
    ax_dd_pair ddp[2];
}ax_dd_type;
 
static ax_dd_type   AxDD;
char *axGetDDStr();
/*
*   axInitDD - will initialize a date struct based on the period from
*   profile.
*   Notes: uses the profiled value to compute a 100-year perioid in which
*       we recognize the century correctly  when a date with just two digits
*       for year is entered. For eg: if profiled period is 30 and current year
*       is 1995, then the end period is 1995+30-1 ==> 2024. So we can
*       auto-recognize dates in the period 1925-2025. ie,  if user enters
*       any number from 25 to 99, the year is 1900 and any number from
*       00 to 24 the year will be 2000.
*
*   The routine fills a structure that has date periods that recognize these
*   periods
*
*/
void axInitDD(axddP)
    ax_dd_type  *axddP;
{
    struct tm *tmp, *localtime();
    long clk;
    int cur_year, cur_century,
		roll_yr, roll_century;
    int nextPeriod, year;
	char strbuf[STRPATH+1];
 
    if(axddP->inited)
        return; /* was already initialized */

    strcpy(strbuf, GetProfileByCode(PROF_CENTURY_PERIOD_AX_));
	year = atoi(strbuf);

    /* get current year */
    clk = time((long*)0);
    tmp = localtime(&clk);

    cur_year = 1900 + tmp->tm_year;
    cur_century = cur_year / 100;

	if(0 != axDDValidateArg(year))
		year = -1;	/* set default */

	/* deal with all special cases first */
	if(-1 == year)	{
		/* all ways default two digits to current century */
    	axddP->ddp[0].start = 0;
    	axddP->ddp[0].end = 99;
    	axddP->ddp[1].start = 0;
    	axddP->ddp[1].end = 99;
		/* two digit years always default to current century */
    	axddP->ddp[0].baseYear = cur_century * 100;
    	axddP->ddp[1].baseYear = cur_century * 100;
		axddP->inited = TRUE;
		return;	/* done */
	}

	if(year >= 00 && year <= 99)	{
		/* delta method, the delta specifies how far back from the */
		/* current year the user is interested in this century */
		year = cur_year - year;	
		/* fall thru the last case */
	}

	if((year >= 1800) && (year <= 2200))	{
		/* rollover year specified */
		roll_century = year / 100;	/* the century of the specified year */
		roll_yr = year % 100;		/* the last two digits of the specified yr*/

    	axddP->ddp[0].start = roll_yr;
    	axddP->ddp[0].end = 99;
    	axddP->ddp[1].start = 00;
    	axddP->ddp[1].end = roll_yr - 1;

		if(roll_century == cur_century)	{
    		axddP->ddp[0].baseYear = cur_century * 100;
    		axddP->ddp[1].baseYear = (cur_century+1) * 100;
		}else	if(roll_century < cur_century)	{
    		axddP->ddp[0].baseYear = (cur_century - 1) * 100;
    		axddP->ddp[1].baseYear = cur_century * 100;
		}else {
    		axddP->ddp[0].baseYear = roll_century  * 100;
    		axddP->ddp[1].baseYear = (roll_century+1) * 100;
		}
	}
	axddP->inited = TRUE;
	return;
}

int axDDValidateArg(year)
	int year; 	/* rollover year */
{
	long		clk;
	struct tm	*tmp;
	int			cur_year;

    /* get current year */
    clk = time((long*)0);
    tmp = localtime(&clk);
    cur_year = 1900 + tmp->tm_year;

	if(-1 == year)
		return(0);	
	if( year >= 0 && year <= 99)
		return(0);
	if( year < 1800 || year > 2200)
		return(1);	/* error */
	if(ABS(year - cur_year) >= 100)
		return(1);
	return(0);	/* ok */
}
 
/*
*   axGetBaseYear - return the base year based on the two digit year
*/
int axGetBaseYear(yr)
    int yr;
{
    axInitDD(&AxDD);
    yr %= 100;
    if(yr >= AxDD.ddp[0].start && yr <= AxDD.ddp[0].end)
        return(AxDD.ddp[0].baseYear);
    return(AxDD.ddp[1].baseYear);
}

/*
*	axGetDefCenturyPeriodValue - if the profile is not set then come up
*	with the value that defaults to that century for two digit years
*/
int axGetDefCenturyPeriodValue()
{
	struct tm *tmp, *localtime();
    long clk;
    int cur_year, cur_century, value;
 
    /* get current year */
    clk = time((long*)0);
    tmp = localtime(&clk);
 
    cur_year = tmp->tm_year % 100;
	value = 99 - cur_year + 1;
	return(value);
}

void AxSetCenturyPeriodValue(value)
	int value;	/* not used for the moment */
{
	AxDD.inited = FALSE;	/* will cause the caller to re-initialize */
}


#define MAX_AX_DD_STR   (4+1+1+1+4) /* "1956 - 2025" */
char *axGetDDStr()
{
    static char str[2 * MAX_AX_DD_STR+1];
 
    axInitDD(&AxDD);
    sprintf(str,": %d - %d",  (AxDD.ddp[0].baseYear + AxDD.ddp[0].start),
                            (AxDD.ddp[1].baseYear + AxDD.ddp[1].end));
    return(str);
}

/* added because tm, returned by localtime(), is modified in this
code, and because error checking was done in one case, but not another
-chris 23 dec 96 */
static struct tm *Alocaltime(clock)
time_t *clock;
{
	static struct tm tmStatic;
	struct tm *tm;

	tm = localtime(clock);
	memcpy ((char *)&tmStatic, (char *)tm, sizeof (tmStatic));
	tmStatic.tm_year += 1900;
	if (tmStatic.tm_year < DTTIMEBASEYEAR)
	{
		return (0);
	}
	if (tmStatic.tm_year > (DTTIMEBASEYEAR + DTSPAN) )
	{
		return (0);
	}
	tmStatic.tm_mon += 1;	/*	system time uses month 0-11, we use 1-12 */

	return(&tmStatic);
}
	
