/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: strtrim.c
   Applix ASC version: 2
   Date: Mon Nov 16 13:58:00 1998
*/
#include <utloc.h>

/*
.BEGIN MANPAGE
.NAME strtrim - Trim string in buffer.
.ARGUMENT ins
    The address of the buffer which conatains the string to be trimmed.
.DESCRIPTION
    Strtrim() trims a string by stepping over any leading space characacters
	and replacing the first space character of any trailing space characters
	by the null character.
.SEE ALSO
    strntrim(3A) struntrim(3A)
.RETURN VALUE
    Strtrim() returns the address of the first character in the buffer
	which is not a space character.
*/

/* BEGIN SYNOPSIS */
char *strtrim(ins)
REGISTER char  *ins;
/* END SYNOPSIS */
{
	REGISTER char *ends;

	while(*ins == ' ')
		ins++;
	ends = ins;
	while(*ends)
		ends++;
	while(--ends > ins && *ends == ' ');
	*(ends + 1) = '\0';
	return (ins);
}
