/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tstrncp.c
   Applix ASC version: 2
   Date: Mon Nov 16 13:58:00 1998
*/
#include <utloc.h>

/*
.BEGIN MANPAGE
.NAME Tstrncpy - Copy and trim a string.
.ARGUMENT outs
    The address of a buffer to receive the trimmed string.
.ARGUMENT ins
    The address of the string to be trimmed.
.ARGUMENT max
	The maximum number of characters in the dtring being trimmed.
.DESCRIPTION
    Tstrncpy() copies a string of up to a specified maximum number of
	characters without leading or trailing space characters.
.SEE ALSO
    Tstrcpy(3A)
.RETURN VALUE
    Tstrncpy() returns outs.
.END MANPAGE
*/

/* BEGIN SYNOPSIS */
char *Tstrncpy(outs,ins,max)
REGISTER char *outs;
REGISTER char *ins;
REGISTER int max;
/* END SYNOPSIS */
{
	REGISTER char *ends;

	while(max > 0 && *ins == ' ') {
		max--;
		ins++;
	}
	ends = ins;
	while(max-- > 0 && *ends)
		ends++;
	while(--ends > ins && *ends == ' ');
	max = ends - ins + 1;
	memcpy(outs,ins,max);
	*(outs + max) = '\0';
	return(outs);
}
