/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: utcnvpf.c
   Applix ASC version: 6
   Date: Mon Nov 16 13:57:59 1998
*/
#include <stdlib.h>
#include <utloc.h>
#if SYS&SYS5 || AXMS
#include <fcntl.h>
#else
#include <sys/file.h>
#endif
#include <errno.h>
#include <convert.h>
#include <pageform.h>


/* RETURN VALUE: 0 if the conversion was successful, otherwise one of
	the X_* status codes #define'd in convert.h.  The X_WRERR value might
	be expected under normal circumstances; i.e. it is normally possible 
	to run out of disc space.  If the caller is unaware of whether or
	not header or footer data exists, X_OPNPF or X_OPNASCII might be
	"expected" errors.   The other errors indicate a more serious 
	problem of some sort and should be treated as a single class. 
*/
ConvPF(option,pathnameStem,pathnmOfFileBuilt)
int  option;     		/* Either PF2A or A2PF  (A means ascii) */
char pathnameStem[]; 	/* Must be provided (with trailing null). */
char pathnmOfFileBuilt[];  /* Returned with the pathname of the
							file constructed as a result of the conversion. */
{
	char cmdLine[2 * STRPATH];
	char *progDir;
	
	progDir = getenv(NXLT("AOSDIR"));
	sprintf(pathnmOfFileBuilt,"%s.pf%c",pathnameStem,
		(option == PF2A) ? '_' : '\0');

	sprintf(cmdLine,"%s%sconvPF -%cf%s",(progDir) ? progDir : "",
#if SYS&VMSSYS
		(progDir) ? "/" : "",
#else
		(progDir) ? "/" : "./",
#endif
		(option == PF2A) ? 'o' : 'i',pathnameStem);

	return(shcmdReturningChildsExitCode(cmdLine));
}
