/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: utgtsym.c
   Applix ASC version: 10
   Date: Mon Nov 16 13:57:57 1998
*/
#include <utloc.h>
#include <style.h>
#include <getstr5.h>
#include <scac.h>
#include <userp.h>
#include <upconst.h>
#include <datetime.h>

foreignChars UTprofsym =
	{ 0, 0, '.', ',', 1, "$", 1, "$", 1, 0, 0, 0, 1, "", "", ':', "", 
		0, 0, "" };

/*************************************************************************
function: UTgetsym - A hacked profile info getter for SS
This has a historical base in Alis's profile mechanism.
It has been lightly hacked to Thimble's use.
*/
#define MAXCURRENCYSYMBOL 7

UTgetsym()
{
	int currLoc;
	static char    currSym[MAXCURRENCYSYMBOL] = "";
	int currency_val;
	char *p;
	char *UPbyCode();

	/* get date, time, day of week stuff. (Not used by ss) */

	UTprofsym.dateForm = DTDFNONE;
	UTprofsym.timeForm = DTTFNONE;
	UTprofsym.dowForm = DTWFNONE;

	if ( UPnumVal(PROF_MEASURE_) )
		UTprofsym.measureInch = PGMSMETRIC;
	else
		UTprofsym.measureInch = PGMSENGLISH;

	/* number format */

	UTprofsym.numForm = 0;
	if(UPnumVal(PROF_NUMBERS_) == 0)
		{
		UTprofsym.decimalChar = '.';
		UTprofsym.commaChar = ',';
		}
	else
		{
		UTprofsym.decimalChar = ',';
		UTprofsym.commaChar = '.';
		}



	/* currency position */

	currLoc = UPnumVal(PROF_CURRPOS_);
	if ( currLoc == 0 )
		UTprofsym.moneyLeading = FALSE;
	else
		UTprofsym.moneyLeading = TRUE;

	/* curency symbol */

	p = UPbyCode(PROF_CURRENCY_);
	if ( !p || !strlen(p) )			/* not there, use American */
		strcpy( currSym, "$");
	else 
		if ( currency_val = atoi(p) ) 
			{	/* decimal number use ASCII val */
			currSym[0] = currency_val;
			currSym[1] = 0;
			}
		else
			if ( strlen(p) <= MAXCURRENCYSYMBOL )		/* short string, use it */
				strcpy( currSym, p);
			else							/* not there, use American */
					strcpy( currSym, "$");

	strcpy(UTprofsym.moneyChar, currSym);

	return(TRUE);
}
