/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: fm.h
   Applix ASC version: 18
   Date: Mon Jan  4 21:12:15 1999
*/
#ifndef _FM_H_  /* should be first line  { */
#define _FM_H_



/* Formatter return status */
#define FM_FMT_ERR				0
#define FM_FMT_STOP				1   /* frame/footnote doesn't fit on page */
#define FM_FMT_CONT				2   /* reformat not needed */
#define FM_FMT_MORE				3   /* more material needs formatted */
#define FM_FMT_DOC_END			4   /* reached end of material */
#define FM_FMT_FRAME_END		5   /* done formatting frame */
#define FM_FMT_SECTION			6   /* encountered new section */
#define FM_FMT_PAGE_BREAK		7   /* encountered page break */
#define FM_FMT_COLUMN_BREAK		8   /* encountered column break */
#define FM_FMT_ROW_START		9   /* encountered start of row */
#define FM_FMT_ROW_END			10  /* done formatting row */
#define FM_FMT_CELL_END			11  /* done formatting cell */
#define FM_FMT_FOOTNOTE_END		12  /* done formatting footnote */
#define FM_FMT_HDRFTR_END		13  /* done formatting hdr/ftr */
#define FM_FMT_UOVERFLOWEDEXPANDABLE 14 /* too much matter in expandable cell */
#define FM_FMT_UWASCLEAN		15	/* FmInc'FormatUrect received clean U	  */
#define FM_FMT_UOVERFLOWEDNOTCELL 16 /* Too much matter in Flow Urect */
#define FM_FMT_UOVERFLOWEDFIXED 17  /* Too much matter, cell not expandable */

/* Quick Format types */
#define FM_QUICK_FMT_TYPING		0	/* inserted character */
#define FM_QUICK_FMT_RETURN		1	/* new paragraph */
#define FM_QUICK_FMT_BACKSPACE	2	/* deleted character */

#define FM_PAGETYPE_FM			0	/* Formatter fdtype field in page_t		  */
#define FM_PAGETYPE_DS			1	/* Display page							  */

#define FM_HDRFTR_FIRST			0	/* Header, footer type					  */
#define FM_HDRFTR_LAST			1
#define FM_HDRFTR_EVEN			2
#define FM_HDRFTR_ODD			3

#endif  /* _FM_H_  should be last line  } */
