/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: wp.h
   Applix ASC version: 535.19
   Date: Fri May 28 21:11:51 1999
*/
#ifndef WP_H
#define WP_H


								/*		CONSTANTS		*/

#define SMALL_DOC_DEMO_MAX_PAGENUM 1	/* max internal page # to display in  */
										/* SMALL_DOC_DEMO 					  */
#include <axtime.h>

#include <aos.h>
#include <wpdefs.h>     /*defines common to wp & elf*/
#include <axfont.h>


					/*    Fundamental Build & Execution Control  */


#if !TURBO_BUILD            /* i.e. if building daxdata... */
#define WP_DEBUG 1          /* enables logging & asserts */
#endif

#if !BUILD_WIDE
#define CHAR8_MODE 1        /* 8-bit rather than 16 bit chars */
#endif

#ifndef SUN4
#define AX_USE_PROTOS 1     /* enables protos for external modules (ax.h...) */
#endif

#ifdef AX_USE_PROTOS
#undef AX_USE_PROTOS 		/* till we all get better compilers */
#undef AX_SUPPRESS_PROTOS
#define AX_SUPPRESS_PROTOS 1
#endif

/* Don't release the Java-WP on "Randy's" builds */
#ifndef TURBO_BUILD
#define TURBO_BUILD 0
#endif
#ifndef DOWORK
#define DOWORK 0
#endif
#define ALLOW_JAVA_WP 1

/*
    Development cycle HACKS!!!
*/

#define WP_DFLT_FONT_SIZE 12
#define WP_PRINTER wpP->printerDevice
#define WP_SCREEN (wpP->printing ? wpP->printerDevice : -1) /* -1 was 106 */

#if AX_X11
#define WP_DFLT_FONT_NAME NXLT("Times")
#else
#define WP_DFLT_FONT_NAME NXLT("Times New Roman")
#endif
#define DS_FIELD_MARKER_WIDTH 100
#define WP_DFLT_STYLE_NAME NXLT("para")
#define WP_DFLT_FIRST_INDENT 500
#define WP_DFLT_LEFT_INDENT 100
#define WP_DFLT_RIGHT_INDENT 200
#define WP_DFLT_LEVEL_INDENT 500

/* Things that can be selected by special mouse operations */
#define WP_SELECT_CHAR          0   /* Normal text cursor selection (default) */
#define WP_SELECT_WORD          1   /* Double click on word */
#define WP_SELECT_LINE          2   /* Click or drag left of line */
#define WP_SELECT_PARA          3   /* Double click left of line */

#define WP_SUGGESTED_TOP_STYLE          XLT2("WP Style name","Normal")
#define WP_SUGGESTED_TOP_STYLE_NAME ((mbchar *)WpStyleName(wpP,WP_SUGGESTED_TOP_STYLE))
#define WP_NORMAL_STYLE                 ((mbchar *)WpGetTopStyleName(wpP))
#define WP_NORMAL_STYLE_ID              WpGetTopStyleBead(wpP)

#define WP_BLACK    (mbchar *)WpColorName(wpP, XLT("Black"))

					/* Boundary display info (Not "Border"! */

											/* See DsRepairBoundaries,		  */
											/* DsRedrawOldBorders [sic],	  */
											/* DsPaintNewBorders [sic]		  */
#define WP_BOUNDARY_URECT_COLOR "Blue 50" 	/* (See wpmain.c:WpCommonInit)	  */
#define WP_BOUNDARY_RECT_COLOR  "Grey 50"
#define WP_BOUNDARY_PAGE_COLOR  "Black"
#define WP_BOUNDARY_WEED_SHADING WP_SHADING_FILL_C
#define WP_BOUNDARY_WEED_FG_COLOR  "Black"
#define WP_BOUNDARY_WEED_BG_COLOR  "White"
											/*17 Dec 1998 WIDTHS MUST BE 1!	  */
#define WP_BOUNDARY_RECT_WIDTH 1			/*# pixels in boundary thicknesses*/
#define WP_BOUNDARY_URECT_WIDTH 1
#define WP_BOUNDARY_PAGE_WIDTH 1

#define WP_BOUNDARY_URECT_TYPE 1			/* Kind of boundary in			  */
#define WP_BOUNDARY_RECT_TYPE 2				/* DsDrawBoundaryLine 			  */
#define WP_BOUNDARY_PAGE_TYPE 3
#define WP_BOUNDARY_RECT_SHIFT WP_BOUNDARY_URECT_WIDTH /*Expand Rect bounds	  */
													 /*by this amount to avoid*/
													 /*coinciding with urects */

					/* Page info: size, position */

/* !!0PKJ these numbers ok for now; should finally be 8.5x11, 1 margin */
#define WP_DFLT_SECTION_TYPE        WP_SECTION_CONTINUOUS
#define WP_DFLT_PAGE_WIDTH          8500
#define WP_DFLT_PAGE_HEIGHT         11000
#define WP_DFLT_PAGE_ORIENTATION    WP_PAGE_PORTRAIT
#define WP_DFLT_LEFT_MARGIN         500
#define WP_DFLT_RIGHT_MARGIN        500
#define WP_DFLT_TOP_MARGIN          750
#define WP_DFLT_BOTTOM_MARGIN       750
#define WP_DFLT_BINDING_MARGIN      0
#define WP_DFLT_HDRFTR_MARGIN       250
#define WP_DFLT_NUM_COLUMNS         1
#define WP_DFLT_GUTTER_WIDTH        0
#define WP_PAGE_LEFT_DISPLACEMENT		20				/* pixels at left	  */
#define WP_PAGE_VERTICAL_DISPLACEMENT	5				/* pixels between pgs */

#define WP_SPACE    ' '
#define WP_HYPHEN   '-'
#define WP_TAB      '\t'
#define WP_NEWLINE  '\n'

/* equation editor mode */
#define WP_EQN_EDITOR  (wpP->eqnEditing)

/* These are used when selecting a word, useful for spellcheck, hyphenation,
and thesaurus.
For search, and line breaking, a word is non-whitespace surrounded by
whitespace. */
/* $ and @ are in macro editor words */
#define WP_WORD_ENDERS ((wpP->macroEditing) \
                            ? NXLT(" \t\n.,!?\"'`</\\:;%^&*()[]{}-=+") \
                            : NXLT(" \t\n.,!?\"'`</\\:;@#$%^&*()[]{}-=+"))
#define WP_WORD_STARTERS WP_WORD_ENDERS

/* WP.wysiwyg codes */

#define WP_WYSIWYG_LINE     0
#define WP_WYSIWYG_CHAR     1
#define WP_IS_BASIC_SIZE(size) (strchr(WpBasicSizes,size))

/* Cursor and mouse clicks.  See wpselec.c:WpButtonDown */

#define WP_CURSOR_IRRELEVANT_EOL 0	/*Where DsGetNearestGobFromXY finds cursor*/
#define WP_CURSOR_RIGHTWARD_EOL  1	/* cursor rightward of line extent		  */


/*
    Fundamental types. Note that some compiler's prototyping business (DEC)
    has trouble with typedef'ing to ints/shorts... use #defines
*/

#define anyType double  /* for hiding data thru casts */
#define byte unsigned char  /* rest of world should be wpchar */

#define wpchar char     /* 8-bit char */

#define WP_HASH_PRIME 1009  /* Hash basis (must be prime number) */


/* Drag state ... WP.dragStatus */

#define WP_NOT_DRAGGING             0   /* normal state */
#define WP_DRAG_NEW_FRAME           1   /* user bounding box for new frame */
#define WP_DRAG_MOVE_FRAME          2   /* move frame */
#define WP_DRAG_FRAME_ANCHOR        3   /* pointer over frame anchor gob */
#define WP_DRAG_RESIZE_TOP_LEFT     4   /* resize frame from top-left corner */
#define WP_DRAG_RESIZE_TOP_RIGHT    5   /* resize frame from top-right corner */
#define WP_DRAG_RESIZE_BOT_LEFT     6   /* resize frame from bottom-left corner */
#define WP_DRAG_RESIZE_BOT_RIGHT    7   /* resize frame from bottom-right corner */
#define WP_DRAG_RESIZE_TOP          8   /* resize frame from top edge */
#define WP_DRAG_RESIZE_BOTTOM       9   /* resize frame from bottom edge */
#define WP_DRAG_RESIZE_LEFT         10  /* resize frame from left edge */
#define WP_DRAG_RESIZE_RIGHT        11  /* resize frame from right edge */
#define WP_DRAG_ROW_INDENT          12  /* adjust table row indent */
#define WP_DRAG_COLUMN_RESIZE       13  /* adjust table column width */
#define WP_DRAG_COLUMN_SELECT       14  /* selecting table columns */


/* Document view modes */

#define WP_PAGE_VIEW        0       /* Page layout view */
#define WP_NORMAL_VIEW      1       /* "Linear layout" view */
#define WP_PRINT_VIEW       2       /* Print preview */
#define WP_OUTLINE_VIEW     3       /* Outline (level-sensitive) view */

/* User visible undo transactions */

#define UNDO_TYPING XLT("Typing")       /* typeing and backspacing */
#define UNDO_CUT    XLT("Cut")          /* Cut */
#define UNDO_COPY   XLT("Copy")         /* Copy */
#define UNDO_PASTE  XLT("Paste")            /* Paste */
#define UNDO_DELETE XLT("Delete")       /* Delete */
#define UNDO_FIELD  XLT("Field")            /* Insert field */
#define UNDO_EVAL_FIELD XLT("Evaluate Field")   /* Evaluate field(s) */
#define UNDO_ATTRIBUTES XLT("Attributes")   /* Set attributes */
#define UNDO_NOP    XLT("NOP")      /* only used internally by the undo logic itself */

/* Low level undo codes */

#define UT_TYPE_MASK 7
#define UT_START 0      /* beginning of sequence */
#define UT_REPLACE 1        /* bead replace */
#define UT_DELETE 2         /* bead inserty before */
#define UT_INSERT 3         /* bead delete */
#define UT_END 4        /* end of sequence */
#define UT_NOOP 5       /* No-op for uninteresting operation */

#define UT_MERGE 8      /* Set if a merged operation */
#define UT_MULTIPLE 16  /* Set if multiple inserts/deletes */

typedef struct {    /* Undo object written to file */
    int type;       /* delete/insert/replace in    0000 0111
                            merge flag in          0000 1000 
                            multiple ops flag in   0001 0000 */
    int event;      /* user interface transaction sequence num */
    long bead;      /* Bead number of relevant bead */
} undo_value;


#define WP_MAX_PARA_LEVEL 10    /* for numbered fields & para indents */


/* page break types */
#define WP_PAGE_BREAK_NEXT      0
#define WP_PAGE_BREAK_ODD       1
#define WP_PAGE_BREAK_EVEN      2


/* snaking columns */
#define WP_MAX_COLS             100  /* !! enough?? */



/* page types */
#define WP_PAGE_ODD             0
#define WP_PAGE_EVEN            1


/* name prefix for automatic hdr/ftrs */
#define WP_HDRFTR_PREFIX        NXLT("_AX_HF_")
#define WP_HDRFTR_PREFIX_LEN    7            /* num chars in above string */
#define WP_HDRFTR_PREFIX_FMT    NXLT("_AX_HF_%d")  /* for sscanf */


/* Thrown error stuff */
#define MAX_ERRSTR STRPATH  /* Max text of an error mesage */
#define MAX_ERROBJ STRPATH  /* Max len of the object of an error */


/* Macro Editor/Debugger */

#define MAX_DEBUG_STRS 2000

/* Clipboards */

#define ED_CLIP_PRIMARY 0   /* Default clipboard */

 
/* Cursor End-line/Beginning-line tracking	  */
/* See wpselect.c, dscursor.c, etc.			  */


#define WP_CURSOR_NOT_AT_END_LINE 0				/* Current cursor position	  */
#define WP_CURSOR_AT_END_LINE 1
#define WP_CURSOR_AT_BEGINNING_LINE 2


/****************************************************************************/
/*                                                                          */
/*                      Debugging and Error Handling                        */
/*                                                                          */
/****************************************************************************/

/*
**  See WP_DEBUG under Execution Control
*/

 
/* Error handling */
 
#define VERIFY(x) if ( !(x) ) WPAsserter(NameOfThisSourceFile,__LINE__)

#if WP_DEBUG
#define ASSERT(x) if ( !(x) ) WPAsserter(NameOfThisSourceFile,__LINE__)
#define CHECK(x) if ( !(x) ) WPCheck(NameOfThisSourceFile,__LINE__)
#define WP_RING_BELL() RingTheBell();
#else
#define ASSERT(x)
#define CHECK(x)
#define WP_RING_BELL() RingTheBell()
#endif
 
 
/* For functions that expect a ptr to the global structure as their 1st
    arg, here's how we check (in debug code only) that they got it. */

#define ASSERT_PASSED_WP(wpP)   ASSERT(wpP->appInfo.GlobalCode == WP_GLOBAL_CODE)


/****************************************************************************/
/*                                                                          */
/*                              CODE MACROS                                 */
/*                                                                          */
/****************************************************************************/

/* Coordinate system */

#define HalfPix 0   /* !!0 why was this 6 in RWSet.h ? */

#define WP_FULL_ZOOM        100         /* 100 represents 100% zoom */
#define WP_10_PERCENT_ZOOM  10          /* Ten percent of WP_FULL_ZOOM */

/* ATM scale factor (e.g. as used in dispTx) uses 10000 as 100% */
/* The proper WP zoom to ATM scale conversion would be: 
                    ((z) * ATM_FULL_SCALE / WP_FULL_ZOOM)
    but we will hardwire the result of the divide for performance.
    THIS MUST CHANGE IF WP_FULL_ZOOM OR ATM_FULL_SCALE CHANGE! */

#define ATM_FULL_SCALE      10000
#define WPZOOM2ATMSCALE(z)  ((z) * 100)

/* mil / display pixel conversions */
#define WPXMIL2PIX(m) ((((m)+HalfPix) * wpP->tmPixWd)/wpP->tmMilWd)
#define WPYMIL2PIX(m) (int)((((double)(m)+HalfPix) * wpP->tmPixHt)/wpP->tmMilHt)
/* Type cast float arg, and without (int) type cast on WPY: */
#define WPXMIL2PIXF(m) ((((double)(m)+HalfPix) * wpP->tmPixWd)/wpP->tmMilWd)
#define WPYMIL2PIXF(m) ((((double)(m)+HalfPix) * wpP->tmPixHt)/wpP->tmMilHt)

#define WPXPIX2MIL(p) (((p) * wpP->tmMilWd + wpP->tmPixWd - 1)/wpP->tmPixWd)
#define WPYPIX2MIL(p) (int)(((double)(p) * wpP->tmMilHt + wpP->tmPixHt - 1)/wpP->tmPixHt)

#define WPXSCREENPIX2MIL(p) (((p) * 40 + 3 - 1)/3) /* !!0 75 dpi assumption */
#define WPYSCREENPIX2MIL(p) WPXSCREENPIX2MIL(p)
#define WPXPIX2SCREENMIL(p) (wpP->printing ? \
                    WPXPIX2MIL(p) : \
                    (WPXPIX2MIL(p) * wpP->dsXZoomFactor)/WP_FULL_ZOOM)
#define WPYPIX2SCREENMIL(p) (wpP->printing ? \
                  WPYPIX2MIL(p) : \
                  (int)((double)WPYPIX2MIL(p) * wpP->dsYZoomFactor)/WP_FULL_ZOOM)
 /* the following 2 defines are rounding-up versions of the previous 2 */
#define WPXPIX2SCREENMILR(p) (wpP->printing ? \
                  WPXPIX2MIL(p) : \
                  (((WPXPIX2MIL(p+1) * wpP->dsXZoomFactor) + WP_FULL_ZOOM - 1) \
														/ WP_FULL_ZOOM) - 1)
#define WPYPIX2SCREENMILR(p) (wpP->printing ? \
                  WPYPIX2MIL(p) : \
                  (int)((((double)WPYPIX2MIL(p+1) * wpP->dsYZoomFactor) \
													  + WP_FULL_ZOOM - 1) \
														/ WP_FULL_ZOOM) - 1)

#define WP_INCH 1000
#define DS_DPI (WPXMIL2PIX(WP_INCH))


/* Character set */

#if CHAR8_MODE || BUILD_WIDE
  /** since these were not used consistently, and the datatype **/
  /** "wpchar" was not used consistently, these should always be **/
  /**  define to be the 'real' functions                         **/
#define wpstrcat(s1,s2) strcat(s1,s2)
#define wpstrncat(s1,s2,n) strncat(s1,s2,n)
#define wpstrcmp(s1,s2) strcmp(s1,s2)
#define wpstrncmp(s1,s2,n) strncmp(s1,s2,n)
#define wpstrcasecmp(s1,s2) strcasecmp(s1,s2)
#define wpstrncasecmp(s1,s2,n) strncasecmp(s1,s2,n)
#define wpstrlen(s) ((int)(strlen(s)))
#define wpstreq(s,c) streq(s,c)
#define wpstrcpy(s,c) strcpy(s,c)
#define wpstrncpy(s,c,n) strncpy(s,c,n)
#define wpstrbufcpy(s,c,n) (strncpy(s,c,n), s[n] = 0)
#define wpstrchr(s,c) strchr(s,c)
#define wpstrrchr(s,c) strrchr(s,c)
#define wpstreqcase(s,c) (wpstrcasecmp(s,c) == 0)
#endif


/*** Memory and string stuff ***/

#if WP_FOR_FILTER

/* Filters get to do direct memory allocation */
#define WPTASKMALLOC(pid,siz)           malloc((siz))
#define WPTASKCALLOC(pid,n,siz)         calloc((n),(siz))
#define WPTASKREALLOC(pid,p,siz)        realloc((p),(siz))
#define WPTASKFREE(pid,p)               free((p))

#define WPMALLOC(siz)           malloc((siz))
#define WPCALLOC(n,siz)         calloc((n),(siz))
#define WPREALLOC(p,siz)        realloc((p),(siz))
#define WPFREE(p)               free((p))

#else

/* Allocate WP memory against the stored pid. For a WP window, this will be the
    WP task. For a WP inset, this will be the calling task. */
#define WPTASKMALLOC(pid,siz)           TaskAlloc((pid), (siz))
#define WPTASKCALLOC(pid,n,siz)         TaskCalloc((pid),(n),(siz))
#define WPTASKREALLOC(pid,p,siz)        TaskRealloc((pid),(p),(siz))
#define WPTASKFREE(pid,p)               TaskFree((pid),(p))

#define WPMALLOC(siz)           WPTASKMALLOC(wpP->pid, (siz))
#define WPCALLOC(n,siz)         WPTASKCALLOC(wpP->pid,(n),(siz))
#define WPREALLOC(p,siz)        WPTASKREALLOC(wpP->pid,(p),(siz))
#define WPFREE(p)               WPTASKFREE(wpP->pid,(p))

#endif

mbchar *WToMbOneStr();

#define ALCSTR(p)           /* Alloc & copy string */   \
        strcpy((char *)WPMALLOC((strlen((char *)p)+1)*sizeof(char)),(char *)p)

#define MBALCSTR(p)         /* Alloc & copy string */   \
        ((mbchar *)strcpy((char *)WPMALLOC((strlen((char *)p)+1)*sizeof(mbchar)),(char *)p))

#define WALCSTR(p)          /* Alloc & copy  a wide string */   \
        Wstrcpy((wchar *)WPMALLOC((Wstrlen(p)+1)*sizeof(wchar)),(wchar *)p)

#define WMB_ALCSTR(p)   /* Alloc & copy a wide to a mixed-byte string */    \
    ((mbchar *)MBstrcpy((char *)WPMALLOC((Wstrlen(p)+1)*sizeof(wchar)), WToMbOneStr(p) ))

#if BUILD_WIDE
#define MBW_ALCSTR(p)  /* Alloc & copy a mixed-byte string to wide string */ \
        (wchar *)WMbstrcpy( (wchar *)WPMALLOC(((MBstrlen(p)+1)*sizeof(wchar))),p )
#else
#define MBW_ALCSTR(p)  ALCSTR(p)        /* Hack till above is fixed */
#endif

#define SAFE_STR( s)        /* Guard against NULL string */ \
        ( s ? (mbchar *)s : (mbchar *)"")

#define WMB_SAFE_STR( s )  /* convert wide to narrow and guard NULL string */ \
        ( s ? WToMbOneStr(s): (mbchar *)"" )


                        /****************************/
                        /*                          */
                        /*      Bead Handling       */
                        /*                          */
                        /****************************/

#define BEADP(n)            /* Get bead address from bead pointer */    \
        wpP->beads[n]
#define FIRST_BEAD 1        /* Trivial bead access */
#define DOC_START_BEAD 1    /* Where the document globals are */
#define LAST_BEAD           /* Trivial bead access */   \
        (wpP->numBeads-1)

/*  
**  FINDBEADFORWARD_NOTCLASS  searches forward for a bead not in a specified
**                            class.
**      In:  argstartbeadnumber  - first bead to look at   
**           argnotclass         - skips beads in this class 
**      Out: argfoundbead        - subscript of first bead seen not in
**                                 argnotclass.  Returns 0 if all beads
**                                 through end of bead array are in
**                                 argnotclass, i.e. if no bead not in
**                                 argnotclass is found.    
*/
                                                          
#define FINDBEADFORWARD_NOTCLASS(argstartbeadnumber,argnotclass,argfoundbead) \
    for(argfoundbead = argstartbeadnumber;\
           (argfoundbead <= LAST_BEAD) \
        && (BEADP(argfoundbead)->any.class == argnotclass);\
        argfoundbead++);\
    if(argfoundbead > LAST_BEAD) argfoundbead = 0;      /* 0: bead not found */

/* 
**  FINDBEADREVERSE_NOTCLASS  searches backward for a bead not in a specified
**                            class.                       
**      In:  argstartbeadnumber  - first bead to look at
**           argnotclass         - skips beads in this class
**      Out: argfoundbead        - subscript of first bead seen not in
**                                 argnotclass.  Returns 0 if all beads
**                                 through beginning of bead array are in
**                                 argnotclass, i.e. if no bead not in
**                                 argnotclass is found.
*/

#define FINDBEADREVERSE_NOTCLASS(argstartbeadnumber,argnotclass,argfoundbead) \
    for(argfoundbead = argstartbeadnumber; \
        argfoundbead && (BEADP(argfoundbead)->any.class == argnotclass); \
        argfoundbead--);

/******************************************************************************/


#define ELF_TRUE            -1
#define ELF_FALSE           0
#define ELF_BOOL_TO_C(e)    ( ((e) == ELF_FALSE) ? FALSE : TRUE )
#define C_BOOL_TO_ELF(c)    ( (c) ? ELF_TRUE : ELF_FALSE )

/* codes for different types of pastes, when pasting cells in tables */
#define PASTE_QUERY 0   /* ask user */ 
#define PASTE_ROWS 1    /* insert new rows */
#define PASTE_COLS 2    /* insert new columns */
#define PASTE_COLS_AFTER 3  /* insert new columns after cursor pos */
#define PASTE_REPLACE 4 /* replace contents of selected cells */


/* Logging */

#define LOGIT(body)     printf body; fflush(stdout);
#if DSLOGGING
#define DSLOG(body)     LOGIT(body)
#else
#define DSLOG(body)
#endif
#if EDLOGGING
#define EDLOG(body)     LOGIT(body)
#else
#define EDLOG(body)
#endif
#if FMLOGGING
#define FMLOG(body)     LOGIT(body)
#else
#define FMLOG(body)
#endif
#if WPLOGGING
#define WPLOG(body)     LOGIT(body)
#else
#define WPLOG(body)
#endif

/* Suppress some compile warnings when compiling with gcc (used when gcc
 * complains, but manual inspection shows that there's no problem). */

#ifdef __GNUC__
#define GCC_INITIALIZE(x, val) x = (val);
#else
#define GCC_INITIALIZE(x, val)
#endif


/*** System include files everyone needs ***/

#include <setjmp.h>

#include <basicwin.h>

#if 0

#if AX_X11
#include <X11/Xlib.h>
#define HFONT XFontStruct *
#endif

#if AX_GDI
#define HFONT XFontStruct *
/*#include <windows.h>*/
#include <paripc.h>
#endif

#endif

#include <xmlib.h> /* to get AXWidget declaration */

#if AX_SUPPRESS_PROTOS      /* for filters */
#undef AXP_
#define AXP_(body) ()
#endif

#include <afile.h>  /* move to aos.h !!! */

#if AX_GDI
#include <wpgdi.h>      /* really a <system> file! */
#endif

/* to get doc_links_info_t */
#include <doclinks.h>

/* the following must be after aos.h */
#ifndef SEEK_SET
#define SEEK_SET    0   /* Set file pointer to "offset" */
#define SEEK_CUR    1   /* Set file pointer to current plus "offset" */
#define SEEK_END    2   /* Set file pointer to EOF plus "offset" */
#endif

/* On HP 10.2, "page_t" is a typedef in include/sys/types.h.
	Here we rename our page_t struct to avoid a conflict */
#if HP800V3
#define page_t wp_page_t
#endif


/****************************************************************************/
/*                              TYPEDEFS                                    */
/****************************************************************************/

#ifndef BOOL_DEFINED
typedef int bool;
#define BOOL_DEFINED 1
#endif

/*
    Document location structure: identifies a bead plus an offset within
    the bead (i.e. for text). This should uniquely identify a logical
    "position" within a document (though it is not necessarily true that
    the text cursor can be placed at all locations.
*/

typedef struct {
    int pos;        /* Access to bead  */
    int offset;     /* Offset within the bead */
} wp_location;

/*
    A range of material. The start had better occur before the end, or else.
    The range is inclusive of the endpoints. To represent a single point:
    make start.addr == end.addr and start.offset == end.offset + 1.
    This is the only exception to the rule of start occuring before end.
*/

typedef struct {
    wp_location         start;  /* first location in range */
    wp_location         end;    /* last location in range */
} wp_range;

#define IS_CURSOR( rng )    ( ((rng).start.pos == (rng).end.pos) && \
                                ((rng).start.offset == (rng).end.offset) )

/* Character level attributes */

typedef struct {
    unsigned
        bold : 1,
        italic : 1,
        strikethru : 1,
        hidden : 1,
        caps : 2,       /* WP_ATTRS_CAPS_XXXX */
        underline : 3,  /* WP_ATTRS_UNDER_XXXX */
#if ALLOW_JAVA_WP
        deliveredJava : 1,  /* if true, have cached to java client */
#endif
        hyphenate : 1;
    mbchar *color;      /* color name */
    mbchar *face;       /* typeface name */
    short size;         /* in points */
    short pos;          /* baseline shift (points) negative for subscript */
    mbchar *tag;        /* character style name, or just name */
} wp_char_attrs;

#define WPELFDEX_TXT_bold 0     /* for C/Elf communications */
#define WPELFDEX_TXT_italic 1
#define WPELFDEX_TXT_strikethru 2
#define WPELFDEX_TXT_hidden 3
#define WPELFDEX_TXT_caps 4
#define WPELFDEX_TXT_underline 5
#define WPELFDEX_TXT_pos 6
#define WPELFDEX_TXT_hyphenate 7
#define WPELFDEX_TXT_color 8
#define WPELFDEX_TXT_face 9
#define WPELFDEX_TXT_size 10
#define WPELFDEX_TXT_tag 11
#define WPELFSIZE_TXT 12

/* Paragraph attributes */

typedef struct {
    unsigned
        pageBreak : 1,   	   	/* Pagebreak before para? */
        keepWith : 1,   		/* Keep together w/next para? */
        block : 1,      		/* Keep entire para on single page? */
        justify : 3,    		/* WP_ATTRS_HAL_XXXX */
        inTOC : 1,      		/* !!0 Obsolete - 4/93 DHM */
        indentToLevel : 1,	  	/* Add level-controlled indent? */
        noSpell : 1;    		/* Avoid spellchecking this para? */
    short level;        	/*Level number (for indent & autonum;0 -> default)*/
    int firstIndent;    	/* left indent of first line */
    int leftIndent;     	/* left indent of subsequent lines */
    int rightIndent;    	/* right indent from right edge of enclosing rect */
    int preParaSpacing; 	/* space before para */
    int postParaSpacing;    /* space after para */
    int lineSpacing;    	/* space after each line (4 Jan 1999 obsolete)	  */
    int hyphZone;       	/* max mils whitespace at end before hyphenating  */
    int hyphMinFrag;    	/* smallest word fragment after hyphenating 	  */
	struct {
								/* 100*MULTI multiplier (317 => 3.17 lines)	  */
		byte lineSpacingMode;	/* ATLEAST, EXACT, MULTI_LINE		 		  */
    	int lineSpacing2;       /* EXACT, ATLEAST line height, No. multi lines*/
								/* Units: mils, no. lines * scale			  */
		int lineSpacingSep;		/* Additional space added to line height	  */
	} lineSpacingGroup;
} wp_para_attrs;

/* Index values into wpbeads.elf:wp_para_attrs@.							  */
/* The definition of wp_para_attrs@ must parallel the following list.*/

#define WPELFDEX_PARA_pageBreak 0       /* for C/Elf communications */
#define WPELFDEX_PARA_keepWith 1
#define WPELFDEX_PARA_block 2
#define WPELFDEX_PARA_justify 3
#define WPELFDEX_PARA_inTOC 4
#define WPELFDEX_PARA_indentToLevel 5
#define WPELFDEX_PARA_noSpell 6
#define WPELFDEX_PARA_firstIndent 7
#define WPELFDEX_PARA_leftIndent 8
#define WPELFDEX_PARA_rightIndent 9
#define WPELFDEX_PARA_preParaSpacing 10
#define WPELFDEX_PARA_postParaSpacing 11
#define WPELFDEX_PARA_lineSpacing 12
#define WPELFDEX_PARA_level 13
#define WPELFDEX_PARA_hyphZone 14
#define WPELFDEX_PARA_hyphMinFrag 15
#define WPELFDEX_PARA_lineSpacingGroup 16		/* Sub array				  */
#define WPELFSIZE_PARA 17			   /* Add above this line,				  */
									   /*and adjust WPELFSIZE_PARA = last + 1!*/


#define WPELFDEX_PARA_LINESPACINGGROUP_Mode 0			/*Offsets within group*/
#define WPELFDEX_PARA_LINESPACINGGROUP_Spacing2 1
#define WPELFDEX_PARA_LINESPACINGGROUP_Sep 2
#define WPELFSIZE_PARA_LINESPACINGGROUP 3	/* Add above this line, and adjust*/
											/*WPELFSIZE_PARA_LINESPACINGGROUP */


/*
    General purpose flags for each character attribute.
    Used to indicate inherit, mixed...
    Contained within text beads and para beads.
*/

typedef union {
    struct {
        unsigned
            bold : 1,
            italic : 1,
            strikethru : 1,
            hidden : 1,
            caps : 1,
            underline : 1,
            pos : 1,
            hyphenate : 1,
            color : 1,
            face : 1,
            size : 1,
            tag : 1;
    } flag;
    short word;
} wp_char_attr_flags;

typedef union {
    struct {
        unsigned
            pageBreak : 1,
            keepWith : 1,
            block : 1,
            justify : 1,
            inTOC : 1,
            indentToLevel : 1,
            noSpell : 1,
            firstIndent : 1,
            leftIndent : 1,
            rightIndent : 1,
            preParaSpacing : 1,
            postParaSpacing : 1,
            lineSpacing : 1,						/*(6 Jan 1999 Obsolete.   */
            level : 1,
            frame : 2,  				/* WP_FRAME_DEF_INHERIT, NONE, LOCAL  */
            hyphZone : 1,
            hyphMinFrag : 1,
			lineSpacingGroup : 1;
     } flag;
    int word;
} wp_para_attr_flags;

typedef struct {
    wp_char_attr_flags uflags; /* set if attribute value is used or inherited */
    wp_char_attr_flags iflags; /* set if attribute value is inherited */
    wp_char_attrs attrs;
} wp_flagged_char_attrs;

typedef struct {
    wp_para_attr_flags uflags; /* set if attribute value is used or inherited */
    wp_para_attr_flags iflags; /* set if attribute value is inherited */
    wp_para_attrs attrs;
} wp_flagged_para_attrs;


#define WP_MAX_TAB_LEADER   7  /* max length of tab leader control string */
typedef struct {
    unsigned
        type : 3,       /* WP_TAB_LEFT... */
        deleted : 1;    /* if TRUE, tab was deleted rather than added */
    wchar decimalChar;  /* decimal tab control char... (0 => '.') */
    int xpos;           /* from rect, just like para indents */
    wchar leaderStr[WP_MAX_TAB_LEADER+1];   /* leadering for tab (0 => none) */
} wp_tab;

#define WPELFDEX_TAB_type 0     /* for C/Elf communications */
#define WPELFDEX_TAB_deleted 1
#define WPELFDEX_TAB_xpos 2
#define WPELFDEX_TAB_leaderStr 3
#define WPELFDEX_TAB_decimalChar 4
#define WPELFSIZE_TAB 4
#define WPELFSIZE_DECIMAL_TAB 5


/* frame attributes */
typedef struct {
    unsigned
        frameType : 2,        /* flow around, jump over, background */
        xposType : 3,         /* exact, left, center, right, inside, outside */
        xposRelative : 2,     /* page, column, margin */
        yposType : 2,         /* exact, top, center, bottom */
        yposRelative : 2,     /* page, margin, para */
        widthType : 1,        /* auto, exact */
        heightType : 2;       /* auto, exact, min, max */
    int xpos;
    int ypos;
    int width;
    int height;
    int leftFrameMargin;
    int rightFrameMargin;
    int topFrameMargin;
    int bottomFrameMargin;
} wp_frame_attrs;

/* frame attr indices for C/Elf communication */
#define WPELFDEX_FRAME_type             0
#define WPELFDEX_FRAME_xposType         1
#define WPELFDEX_FRAME_xposRelative     2
#define WPELFDEX_FRAME_xpos             3
#define WPELFDEX_FRAME_yposType         4
#define WPELFDEX_FRAME_yposRelative     5
#define WPELFDEX_FRAME_ypos             6
#define WPELFDEX_FRAME_widthType        7
#define WPELFDEX_FRAME_width            8
#define WPELFDEX_FRAME_heightType       9
#define WPELFDEX_FRAME_height           10
#define WPELFDEX_FRAME_leftMargin       11
#define WPELFDEX_FRAME_rightMargin      12
#define WPELFDEX_FRAME_topMargin        13
#define WPELFDEX_FRAME_bottomMargin     14
#define WPELFSIZE_FRAME                 15

typedef struct {
    short thickness;    /* line thickness in mils */
    unsigned
        doubleLine : 1; /* two lines of same thickness */
    mbchar *color;      /* color name */
} wp_line_attrs;

#define WPELFDEX_LINE_thickness 0
#define WPELFDEX_LINE_doubleLine 1
#define WPELFDEX_LINE_color 2
#define WPELFSIZE_LINE 3

typedef struct {
    int shadingStyle;   /* shading style pattern number (see wpdefs.h)  */
    mbchar *fillName;   /* user defined fill pattern (Aster*x image obj name) */
    mbchar *fgColor;    /* foreground color name */
    mbchar *bgColor;    /* background color name */
} wp_shading_attrs;

#define WPELFDEX_SHADING_shadingStyle 0
#define WPELFDEX_SHADING_fillName 1
#define WPELFDEX_SHADING_fgColor 2
#define WPELFDEX_SHADING_bgColor 3
#define WPELFSIZE_SHADING 4

typedef struct {
    wp_line_attrs left;
    wp_line_attrs right;
    wp_line_attrs top;
    wp_line_attrs bottom;
    wp_line_attrs horizontal;   /* horizontal separator (cells, between paras) */
    wp_line_attrs vertical;     /* vertical separator for cells (C-Elf only) */
    wp_shading_attrs shading;   /* background shading atributes */
    short horizontalMargin;     /* dist from text in mils - para border only */
    short verticalMargin;       /* dist from text in mils - para border only */
    int dropShadow;             /* drop shadow type - para brdr only (wpdefs.h)*/
} wp_border_attrs;

#define WPELFDEX_BORDER_left 0
#define WPELFDEX_BORDER_right 1
#define WPELFDEX_BORDER_top 2
#define WPELFDEX_BORDER_bottom 3
#define WPELFDEX_BORDER_horizontal 4
#define WPELFDEX_BORDER_vertical 5
#define WPELFDEX_BORDER_shading 6
#define WPELFDEX_BORDER_horizontalMargin 7
#define WPELFDEX_BORDER_verticalMargin 8
#define WPELFDEX_BORDER_dropShadow 9
#define WPELFSIZE_BORDER 10

typedef union {
    struct {
        unsigned
            left : 1,
            right : 1,
            top : 1,
            bottom : 1,
            horizontal : 1,
            vertical : 1,
            shading : 1,
            horizontalMargin : 1,
            verticalMargin : 1,
            dropShadow : 1;
    } flag;
    short word;
} wp_border_attr_flags;

/* Color Definitions */

typedef struct {
    wpchar *name;
    int cyan;
    int magenta;
    int yellow;
    int black;
} wp_color_t;

#define WPELFDEX_COLOR_name 0
#define WPELFDEX_COLOR_cyan 1
#define WPELFDEX_COLOR_magenta 2
#define WPELFDEX_COLOR_yellow 3
#define WPELFDEX_COLOR_black 4
#define WPELFSIZE_COLOR 5


/* convenience macros to access bead attributes */

#define TEXTP(beadP) (&(beadP)->text.pool->text)
#define PARAP(beadP) (&(beadP)->para.pool->para)
#define STYLEP(beadP) (&(beadP)->style.pool->style)
#define ERRORP(beadP) (&(beadP)->error.pool->error)
#define CELLP(beadP) (&(beadP)->cellEnd.pool->cellEnd)

/* convenience macros to access field args */
#define FPARG(f,n) (f->wargbuf + f->argOffsets[n])
#define FPNUMARGS(f) (f->numArgs)
#define FIELDP(fieldStart)  (&(BEADP(fieldStart)->fldStart))
#define FARG(b,n) (FIELDP(b)->wargbuf + FIELDP(b)->argOffsets[n])
#define FNUMARGS(b) (FIELDP(b)->numArgs)


/* Pooled Attrs header... note that every pooled attr MUST begin with this */

#define POOLED_ATTR_HEADER \
    short class;                /* pooled attr type (same as bead class) */ \
    unsigned \
        inPooledAttrsTable : 1;

typedef struct {    /* Text & Attributes */
    POOLED_ATTR_HEADER
} ed_pooled_any;

typedef struct {    /* Text & Attributes */
    POOLED_ATTR_HEADER
    wp_char_attrs textAttrs;    /* Character attrs for text */
    wp_char_attr_flags local;   /* map for local/inherited values */
} ed_pooled_text;

typedef struct {    /* Paragraph ... first four MUST match ed_pooled_text */
    POOLED_ATTR_HEADER
    wp_char_attrs textAttrs;    /* Character attrs for text */
    wp_char_attr_flags local;   /* map for local/inherited values */
    wp_para_attrs paraAttrs;    /* Paragraph attrs for preceeding material */
    wp_para_attr_flags paraLocal;   /* mask for local/inherit */
    wp_border_attrs borderAttrs;    /* paragraph's border attributes */
    wp_border_attr_flags borderLocal;   /* mask for local/inherit */
    short frameDefType;         /* WP_FRAME_DEF_INHERIT, NONE, LOCAL */
    wp_frame_attrs frame;       /* frame definition if local */
    mbchar *styleName;          /* parent style bead */
    short tabDefType;           /* WP_ATTRS_INHERIT, LOCAL */
    short numTabs;          /* how many local tabs (thus no inherits) follow */
    wp_tab tabs[1];             /* varying extent */
} ed_pooled_para;

typedef struct {    /* Style ... first ten MUST match ed_pooled_para */
    POOLED_ATTR_HEADER
    wp_char_attrs textAttrs;    /* Character attrs for text */
    wp_char_attr_flags local;   /* map for local/inherited values */
    wp_para_attrs paraAttrs;    /* Paragraph attrs for preceeding material */
    wp_para_attr_flags paraLocal;   /* mask for local/inherit */
    wp_border_attrs borderAttrs;    /* paragraph's border attributes */
    wp_border_attr_flags borderLocal;   /* mask for local/inherit */
    short frameDefType;         /* WP_FRAME_DEF_INHERIT, NONE, LOCAL */
    wp_frame_attrs frame;       /* frame definition if local */
    mbchar *glossaryName;       /* NULL or glossary this style begins with */
    mbchar *parentName;         /* parent style */
    mbchar *nameP;              /* e.g. "para" */
    mbchar *nextStyle;          /* name of next style. may be NULL. */
    short tabDefType;           /* WP_ATTRS_INHERIT, LOCAL */
    short numTabs;          /* how many local tabs (thus no inherits) follow */
    wp_tab tabs[1];             /* varying extent */
} ed_pooled_style;

typedef struct {    /* Error ... first four MUST match ed_pooled_text */
    POOLED_ATTR_HEADER
    wp_char_attrs textAttrs;    /* Character attrs for text */
    wp_char_attr_flags local;   /* map for local/inherited values */
} ed_pooled_error;

typedef struct {    /* Cell End */
    POOLED_ATTR_HEADER
    int width;              /* cell width in mils */
    short leftCellMargin;   /* distance of text in mils from left edge of cell */
    short rightCellMargin;  /* distance of text in mils from right edge of cell */
    short topCellMargin;    /* distance of top of first line from top of cell */
    short bottomCellMargin; /* distance of bot of last line from bot of cell */
    wp_border_attrs borderAttrs;        /* cell's border attributes */
    wp_border_attr_flags borderLocal;   /* mask to indicate which border set */
    unsigned
        verticalAlignment : 2;  /* WP_VERT_ALIGN_TOP, CENTER, BOTTOM, JUSTIFIED */
} ed_pooled_cell_end;

typedef union ed_pooled_attrs {
    short class;                /* pooled attr type (same as bead class) */
    ed_pooled_any any;
    ed_pooled_text text;
    ed_pooled_para para;
    ed_pooled_style style;
    ed_pooled_error error;
    ed_pooled_cell_end cellEnd;
} ed_pooled_attrs;


/* Hash entry for pooled attrs */

typedef struct ed_pooled_attrs_entry {
    struct ed_pooled_attrs_entry *next;
    ed_pooled_attrs *pool;
} ed_pooled_attrs_entry;


/* Bead header... note that every bead MUST begin with this */

#define BEAD_HEADER \
    int lastRev;        /* Required. */ \
    short class;        /* Required.*/ \
    unsigned \
        inTable : 1,    /* TRUE if bead in table */ \
        fldLevel : 8,   /* up to 255 levels field nesting */ \
        changes : 2,    /* WP_CB_NOCHANGE... */ \
        grouped : 1,    /* member of a field group */ \
        referenced : 1, /* used during copy. Bead is referenced by another */ \
        dontSave : 1;   /* Bead need not be saved (e.g. it's unreferenced), \
                            but we can't outright delete it for some reason */

/* Beads!! */

typedef struct {    /* An "empty" bead exactly equivalent to ed_node */
    BEAD_HEADER
} ed_any_bead;

					/************************************************/
					/* ed_text, ed_para, ed_style, and ed_error must*/
					/* be the same through "pool".  See				*/
					/* fmline.c:FmFormatLine's call to				*/
					/* FmChooseAttrsForBead(para bead).				*/
					/************************************************/

#define TEXT_GROUP \
	BEAD_HEADER \
    short attrDex;              /* 0 or offset for resolved attr handle */\
    short reserved;             /* alignment pad - reserved for future use */\
    ed_pooled_attrs *pool;      /* pooled attributes */

typedef struct {    /* Text & Attributes bead */
	TEXT_GROUP
    wchar wtext[sizeof(int)];
} ed_text;

typedef struct {    /*Paragraph bead ... attrDex,pool MUST match ed_text*/
	TEXT_GROUP
	int lineSpacing;		    /* Computed in FmFormatLine.  For backward 	  */
								/* compatibility (pre-442)					  */
} ed_para;

typedef struct {    /* Style bead ... attrDex,pool MUST match ed_text, ed_para*/
	TEXT_GROUP
} ed_style;

typedef struct {    /* Error text bead ... attrDex,pool MUST match ed_text */
	TEXT_GROUP
    wpchar text[STRLONG+1];
} ed_error;


typedef struct {    /* Marker bead */
    BEAD_HEADER
    bool deletable; /* whether to move or delete on EdDelete !!0 TODO */
    bool saveToFile;    /* TRUE -> save bead to file !!0 TODO */
    bool excludeFromRange;  /* TRUE -> Not "in" para, row, cell if first bead */
    bool cursorOKbefore;    /* TRUE -> can put cursor before this marker */
    wpchar name[STRNORMAL+1];
} ed_marker;

#define WP_DATA_APPLIX		0		/* <start_data Applix> */
#define WP_DATA_ASCII		1		/* <start_data ascii> */
#define WP_DATA_BINARY		2		/* <start_data binary> */

typedef struct {    /* Graphics bead */
    BEAD_HEADER
    wpchar name[STRPATH+1];     /* reference name to find picture bead */
    wpchar tmpName[STRPATH+1];  /* tmpfile (just while local inset is open!) */
    long dateStamp;             /* dtmod of file */
    typeErr err;                /* useful if dateStamp is */
	int dataType;				/* WP_DATA_XXXXX */
    int sizeData;
    byte data[1];
} ed_graphics;

typedef struct {    /* Bitmap or 'picture' bead - image rendered by another app */
    BEAD_HEADER
    unsigned
        readInstance : 1,       /* if FALSE, need to read data into instance */
        srcSized : 1,           /* if FALSE, need to measure src again */
        picSized : 1,           /* if FALSE, need to recalc pic & true size */
        clipMode : 3,           /* clip mode as set by user (WP_PICT_..._MODE) */
        formatClipMode : 3,     /* clip mode used when formatted */
        useXOffset : 1,         /* if TRUE, other app determines src x offset */
        useYOffset : 1,         /* if TRUE, other app determines src y offset */
        useWidth : 1,           /* if TRUE, other app determines src width */
        useHeight : 1,          /* if TRUE, other app determines src height */
        proportionalScaling : 1,/* for clip mode scale */
        builtIn : 1,            /* use data in release directory */
        showingIcon : 1,        /* similar to 'builtIn'; involuntarily showing icon */
        isFile : 1,             /* TRUE for a file; FALSE for object or graphics bead */
        beingEdited : 1;        /* TRUE if file is currently being edited by someone */
    mbchar *hashedPicName;      /* hashed name of object, graphics, or foreign file */
    mbchar *hashedAxName;       /* hashed name of (temp) file cvt'd into Ax format */
    mbchar *hashedEditName;     /* hashed name of file being edited (listen for pokes) */
    int picAppId;               /* of picture: IC_GE, IC_SS, IC_DC... */
    int picDocType;             /* of picture: AX_DOC_TYPE_XXXX */
    int srcXOffset;             /* in mils as defined in src material */
    int srcYOffset;             /* in mils as defined in src material */
    int srcWidth;               /* in mils as defined in src material */
    int srcHeight;              /* in mils as defined in src material */
    int picXOffset;             /* actually-used xpos in mils */
    int picYOffset;             /* actually-used ypos in mils */
    int picWidth;               /* actually-used width in mils */
    int picHeight;              /* actually-used height in mils */
    double picXScale;           /* nominally 1.0; applied after offsets & sizes */
    double picYScale;           /* nominally 1.0; applied after offsets & sizes */
    int trueWidth;              /* width in mils at 100% zoom */
    int trueHeight;             /* height in mils at 100% zoom */
    void *srcP;                 /* Really 'source' in ax_inset_object@ */
    unsigned int gePtrCacheId;  /* location in cache of object handle */
    int javaId;                 /* Java bitmap uid */
} ed_bitmap;

typedef struct {    /* Object bead */
    BEAD_HEADER
    mbchar name[STRPATH+1];     /* reference name */
    mbchar tmpName[STRPATH+1];  /* tmpfile (just while local inset is open!) */
    bool allowUnreferenced;     /* if TRUE, save even if not referenced */
    long dateStamp;             /* dtmod of file */
    typeErr err;                /* useful if dateStamp is */
    int docType;                /* doc type of file */
    int appType;                /* asterx doc type after conv */
    mbchar cvtMacro[STRLONG+1]; /* macro to run for conversion */
    mbchar appMacro[STRLONG+1]; /* macro to run on double click */
    bool dataIsBinary;
    int sizeData;
    byte data[1];
} ed_object;

typedef struct {    /* Column bead */
    BEAD_HEADER
} ed_column_break;

typedef struct {    /* Page bead */
    BEAD_HEADER
    int type;     /* next page, odd page, even page */
} ed_page_break;

typedef struct {    /* Section bead */
    BEAD_HEADER
    int type;        /* WP_SECTION_CONTINUOUS, WP_SECTION_NEXT_PAGE,.. */
    int numColumns;  /* number of snaking columns */
    int gutterWidth; /* space between snaking columns */
    int pageWidth;
    int pageHeight;
    int pageOrientation;
    int paperSize;          /* code for letter, legal, A4, etc. */ 
    int printSourceTray;    /* override code determining paper source tray */
    int printDestTray;      /* override code re paper destination tray */
    int duplex;             /* WP_PRINT_SIMPLEX, _DUPLEX_LONG, _DUPLEX_SHORT */
    int leftMargin;
    int rightMargin;
    int topMargin;
    int bottomMargin;
    int bindingMargin;
    int oddHeaderType;
    int evenHeaderType;
    int firstHeaderType;
    int lastHeaderType;
    int oddFooterType;
    int evenFooterType;
    int firstFooterType;
    int lastFooterType;
    wpchar oddHeaderName[STRNORMAL+1];
    wpchar evenHeaderName[STRNORMAL+1];
    wpchar firstHeaderName[STRNORMAL+1];
    wpchar lastHeaderName[STRNORMAL+1];
    wpchar oddFooterName[STRNORMAL+1];
    wpchar evenFooterName[STRNORMAL+1];
    wpchar firstFooterName[STRNORMAL+1];
    wpchar lastFooterName[STRNORMAL+1];
    int sectNumStyle;       /* ARABIC, LETTER_U, LETTER_L, ROMAN_U, ROMAN_L */
    int controlSectNum;     /* WP_SECT_NUM_SAME, _INCREM, _RESTART */
    int restartSectNumVal;  /* If restarting, use this number */
    int sectNum;            /* !!0 Calculated sect # (used by fmt code only) */
    wpchar separator[STRNORMAL+1];  /* Between section and page # */
    int pageNumStyle;       /* ARABIC, LETTER_U, LETTER_L, ROMAN_U, ROMAN_L */
    bool restartPageNum;        /* TRUE -> restart at following value... */
    int restartPageNumVal;      /* Restart page # at this value */
    struct {                    /* Formatting hints, e.g. remember Rect sizes */
        struct {int ypos, height;} oddHeader;
        struct {int ypos, height;} evenHeader;
        struct {int ypos, height;} firstHeader;
        struct {int ypos, height;} lastHeader;
        struct {int ypos, height;} oddFooter;
        struct {int ypos, height;} evenFooter;
        struct {int ypos, height;} firstFooter;
        struct {int ypos, height;} lastFooter;
    } hints;
} ed_section;

typedef struct {    /* Autonumber series definition bead */
    BEAD_HEADER
    int multiLevel;                     /* show multiple levels */
    int style[WP_MAX_PARA_LEVEL];       /* code for 1,2,3... or a,b,c... etc. */
    char sepStyle[WP_MAX_PARA_LEVEL][STRNORMAL+1];  /* only if multi-level */
    int showFrom[WP_MAX_PARA_LEVEL];        /* parent levels to show */
    mbchar name[STRNORMAL+1];           /* name of this series */
    mbchar leader[STRLONG+1];           /* Global leader */
    mbchar trailer[STRLONG+1];          /* Global trailer */
    mbchar leaders[WP_MAX_PARA_LEVEL][STRLONG+1];   /* Per-level leaders */
    mbchar trailers[WP_MAX_PARA_LEVEL][STRLONG+1];  /* Per-level trailers */
} ed_series;

typedef struct eqn_tok {
    int         type;       /* EQNTOK_BEGIN, EQNTOK_END, EQNTOK_TMPL */
    union {
        struct eqn_attrs {  /* equation pile attrs */
            int pileAlign;      /* pile align type */
            int rowAlign;       /* matrix row align type */
            int colAlign;       /* matrix col align type */
        } eqAttrs;
        struct tmpl_attrs { /* template attrs */
            int tmplType;           /* major type of template */
            int tmplSubtype;        /* subtype of template */
            unsigned
                rowAlignType : 8,       /* matrix row align type */
                colAlignType : 8,       /* matrix col align type */
                equalRowHeights : 1,    /* TRUE if rows have equal heights */
                equalColWidths : 1;     /* TRUE if cols have equal widths */
            mbchar *styleName;      /* name of equation style */
            wp_char_attrs attrs;    /* local text attrs */
            wp_char_attr_flags local;   /* local attr flags */
            int xnudge;             /* xnudge amount (mils) */
            int ynudge;             /* ynudge amount (mils) */
            wchar wsymbol[32];      /* string of chars */
        } tmplAttrs;
    } attrs;
} eqn_tok;

typedef struct eqn_style {
    mbchar              *nameP;     /* equation style name */
    wp_char_attrs       attrs;      /* text attrs */
    wp_char_attr_flags  local;      /* local flags */
} eqn_style;

#define MAX_EQN_STYLES  8

typedef struct {        /* Equation bead */
    BEAD_HEADER
    eqn_style style[MAX_EQN_STYLES];    /* style table */
    int     eqnRev;         /* if it does not match header's lastRev, toss gobs! */
    char    *eqn;           /* points to eqn_t structure (type casted)*/
    int     lineSpace;      /* line space */
    int     rowSpace;       /* space btw matrix rows */
    int     colSpace;       /* space btw matrix cols */
    int     subDepth;       /* subscript depth */
    int     supHeight;      /* superscript height */
    int     limHeight;      /* limit height */
    int     symbolSize;     /* font size (points) for sum,integral,etc. symbols */
    int     subSymbolSize;  /* font size (points) for subscript sum, integrals */
    int     fullSize;       /* font size (points) for normal symbols */
    int     subSize;        /* font size (points) for subscript */
    int     subSubSize;     /* font size (points) for sub-subscript */
    int     numToks;        /* number of tokens */
    eqn_tok toks[1];        /* array of tokens, varying extent */
} ed_equation;

typedef struct {
    BEAD_HEADER
    mbchar *name;   /* variable name */
    bool field;     /* conditional field depends on this variable */
    int dataSize;   /* size of ELF data */
    byte elfData[1];    /* ELF data, in IPC message form */
} ed_docvar;

typedef struct {
    BEAD_HEADER
    wp_color_t data;
} ed_color;

typedef struct {
    BEAD_HEADER
    wpchar *name;               /* tag name */
    wp_char_attrs textAttrs;    /* Character attrs */
    wp_char_attr_flags local;   /* flags set for locally defined values */
} ed_tag;

/* for ELF/C communications */
#define WPELFDEX_SERIES_name 0
#define WPELFDEX_SERIES_style 1
#define WPELFDEX_SERIES_showHighest 2
#define WPELFDEX_SERIES_repeatLowest 3

#define WP_MAX_FIELD_ARGS 20

/* Force case in Form Cell or Entry Field */
#define WP_ENTRY_CASE_ANY       0       /* Do nothing */
#define WP_ENTRY_CASE_LOWER     1       /* Force lowercase */
#define WP_ENTRY_CASE_UPPER     2       /* Force uppercase */

typedef struct {    /* Field START marker bead */
    BEAD_HEADER
    int field_type;
    int subType;    /* time/date format type */
    mbchar series[STRNORMAL+1]; /* !!0 obsolete - use number.series below */
    unsigned
        editable : 1,                   /* Field val not protected */
        outOfDate : 1,                  /* Needs reevaluation */
        evalError : 1,                  /* Field val contains eval err msg */
        readEval : 1,                   /* Evaluate when file is read */
        printEval : 1,                  /* Evaluate when file is printed */
        saveEval : 1,                   /* Evaluate when file is saved */
        noEval : 1,                     /* Evaluation has no effect on fld val*/
        emptyValue : 1,                 /* Evaluation empties fld val*/
        preserveValue : 1;              /* Only reformat field value */
    mbchar *textStyle;                  /* Value of optional -textStyle flag */
    union ed_bead **evalValueBeads; /* field value as evaluated
                                    (null term'ed array) FREED ON TASK EXIT */
    union {
        struct {                    /* Numbered series & footnote stuff */
            int levelNumber;    /* blasted in during series eval */
            bool hardwiredLevel;    /* TRUE -> use above level, not para's */
            int counters[WP_MAX_PARA_LEVEL];    /* set during series eval */
            mbchar series[STRNORMAL+1]; /* series name or empty string */
            bool noIncrement;
            bool noDisplay;
            int type;        /* WP_FOOTNOTE_BOTTOM_PAGE, ... */
            mbchar bodyName[STRNORMAL+1];   /* Name of matching body */
        } number;
        struct {
            int width;      /* 0 for computed width */
            mbchar name[STRNORMAL+1];
            bool isPixmap;
            bool doubleClick;   /* TRUE -> dbl-click on value to exec macro */
        } button;
        struct {
            bool live;          /* TRUE -> auto update matching xrefs */
        } xref_source;
        struct {
            bool perPage;       /* TRUE -> in hdr/ftr, fmtr evals on @ page */
        } xref;
        struct {
            int colNum;         /* Column number in current data table */
        } merge;
        struct {
            /* !!0 TAKES UP TOO MUCH SPACE */
            long dateStamp;             /* dtmod of linked file */
            void *urlResponse;          /* Really url_response_ struct for url's */
            int docType;                /* doc type of file */
            int appType;                /* asterx doc type after conv */
            mbchar cvtMacro[STRLONG+1]; /* macro to run for conversion */
            mbchar appMacro[STRLONG+1]; /* macro to run on double click */
            mbchar viewname[STRNORMAL+1];   /* viewname (for ss) */
            unsigned char viewtype;     /*1=View, 2=Object(default), 3=Range*/
            int clipMode;               /* WP_PICT_..._MODE */
            double xScale;              /* nominally 1.0 */
            double yScale;              /* nominally 1.0 */
            int xOffset;                /* in mils in src material */
            int yOffset;                /* in mils in src material */
            int srcWidth;               /* in mils */
            int srcHeight;              /* in mils */
            unsigned
                proportionalScaling : 1,    /* for clip mode scale */
                useXOffset : 1,     /* if TRUE, GE determines src x offset */
                useYOffset : 1,     /* if TRUE, GE determines src y offset */
                useWidth : 1,       /* if TRUE, GE determines src width */
                useHeight : 1,      /* if TRUE, GE determines src height */
                lastSection : 1,    /* include last section of wp insets */
                helpDisplay : 1,    /* Double-click OK in Help mode */
                url : 1,            /* Graphics accessed across the Web */
                picture : 1,        /* TRUE if other app is rendering the object */
                beingEdited : 1,    /* TRUE if file is curr being edited by someone */
                shrinkToFit : 1;    /* TRUE if non-picture SS or Data table must fit */
        } inset;
        struct {
            int maxChars;               /* ...allowed by f. mode typing macro */
            mbchar *fieldId;            /* Unique fld id (for form mode) */
            mbchar *dblClickMacro;      /* Macro to call on dbl click (f. m.) */
            mbchar *enterMacro;         /* Macro to call when fld val entered */
            mbchar *exitMacro;          /* Macro to call when fld val exited */
            mbchar *typingMacro;        /* Macro to call when typing in val */
            mbchar *nextId;             /* Next field (or cell?) to go to */
            mbchar *startValue;         /* Displayed before typing area */
            mbchar *endValue;           /* Displayed after typing area */
            mbchar *promptText;         /* Put in status line */
            unsigned
                locked : 1,         /* if TRUE, can't edit in Form mode */
                nextIfFull : 1,     /* if TRUE, put overflow txt in next area */
                underline : 1,      /* if TRUE, underline field value */
                caseness : 2;       /* WP_ENTRY_CASE_XXXX */
        } entry;
        mbchar *glossaryName;
    } more;
    int numArgs;
    short argOffsets[WP_MAX_FIELD_ARGS];
    int sizeArgBuf;
    wchar wargbuf[1];       /* varying extent */
} ed_field_start;

typedef struct {    /* Field END marker bead */
    BEAD_HEADER
    unsigned
        isEntryField : 1;       /* Matching Field Start defines Entry field */
    int minFieldWidth;          /* minimum width for entry field; 0 = no min */
} ed_field_end;

typedef struct {    /* Field method/value splitter marker bead */
    BEAD_HEADER
} ed_field_split;

typedef struct {    /* Cell END bead */
    BEAD_HEADER
    ed_pooled_attrs *pool;      /* pooled attributes */
    unsigned
        sized : 1,              /* user-defined cell shading - if TRUE, size OK */
        locked : 1,             /* In form mode, cannot edit contents */
        nextIfFull : 1,         /* Put text in next area if cell is full? */
        underline : 1,          /* if TRUE, underline field value */
        caseness : 2,           /* WP_ENTRY_CASE_XXXX */
        padded : 1,             /* TRUE if cell added by Copy */
        lastCellInRow : 1;      /* TRUE if this cell is last in row */
    unsigned int gePtrCacheId;  /* unique picture cache id; 0 if no backgd bitmap */
    mbchar *hashedPicName;      /* hashed name of picture's object, graphics, or file */
    int bitmapTrueWidth;        /* width in mils at 100% zoom */
    int bitmapTrueHeight;       /* height in mils at 100% zoom */
    int maxChars;               /* ...allowed (by form mode typing macro) */
    mbchar *cellId;             /* Unique cell id (useful in form mode) */
    mbchar *dblClickMacro;      /* Macro to call on dbl click (form mode) */
    mbchar *enterMacro;         /* Macro to call when cell entered (form mode)*/
    mbchar *exitMacro;          /* Macro to call when cell exited (form mode) */
    mbchar *typingMacro;        /* Macro to call when typing in cell (f. m.) */
    mbchar *nextCellId;         /* Where Select Next Cell goes in form mode */
    mbchar *promptText;         /* Put in status line */
    int javaId;                 /* Java bitmap uid */
} ed_cell_end;

typedef struct {    /* Row START bead */
    BEAD_HEADER
    bool heading;           /* TRUE if row is table heading */
    int justification;      /* left, center, right */
    int indent;             /* indent from left */
    int topRowMargin;       /* distance above row */
    int bottomRowMargin;    /* distance below row */
    int heightType;         /* auto, exact, min, max */
    int height;             /* row height, interpreted based on heightType */
    unsigned long tableId;  /* Same for all rows in same table */
} ed_row_start;

typedef struct {    /* Table START bead */
    BEAD_HEADER
} ed_table_start;

typedef struct {    /* Table END bead */
    BEAD_HEADER
} ed_table_end;

typedef struct {    /* Style START bead */
    BEAD_HEADER
} ed_style_start;

typedef struct {    /* Style END bead */
    BEAD_HEADER
} ed_style_end;

typedef struct {    /* Footnote START bead */
    BEAD_HEADER
    wpchar name[STRNORMAL+1];
} ed_footnote_start;

typedef struct {    /* Footnote END bead */
    BEAD_HEADER
} ed_footnote_end;

typedef struct {    /* Header/footer START bead */
    BEAD_HEADER
    wpchar name[STRNORMAL+1];
} ed_hdrftr_start;

typedef struct {    /* Header/footer END bead */
    BEAD_HEADER
} ed_hdrftr_end;

typedef struct {    /* Glossary START bead */
    BEAD_HEADER
    wpchar name[STRNORMAL+1];
    bool live;          /* TRUE -> auto update matching refs if gloss changes */
} ed_glossary_start;

typedef struct {    /* Glossary END bead */
    BEAD_HEADER
} ed_glossary_end;

typedef struct {    /* Clipboard START bead */
    BEAD_HEADER
    int type;       /* CLIP_PRIMARY... */
    bool justAttrs; /* TRUE for copying para attrs... clip holds pilcro only */
} ed_clip_start;

typedef struct {    /* Clipboard END bead */
    BEAD_HEADER
} ed_clip_end;

typedef struct {    /* Flow START bead */
    BEAD_HEADER
} ed_flow_start;

typedef struct {    /* Flow END bead */
    BEAD_HEADER
} ed_flow_end;

typedef struct {    /* Document START bead */
    BEAD_HEADER
    int     levelIndent;    /* Extra left/first indent per para level */
                            /* !!1 may want to move to section at some point */
    int     language;       /* Document's language code */
                            /* !!1 may want to move to section at some point */
    bool    printIndex;     /* TRUE -> print index with doc */
    bool    printTOC;       /* TRUE -> print Table of Contents with doc */
    bool    allowWidowOrphan;
    bool    facingPages;    /* !!0 FOR NOW; may go to section */
    int     headerMargin;   /* top of page to top of header */
    int     footerMargin;   /* bottom of page to bottom of footer */
    wpchar  origin[STRNORMAL+1];    /* e.g. Aster*x WP, WordPerfect, Frame */
    wpchar  generator[STRNORMAL+1]; /* Creator of disk file (WP or customer) */
    wpchar  version[STRNORMAL+1];   /* Aster*x version (when file created) */
    bool ignoreLastPilcro;  /* for copy/paste */
    bool ignoreLastSection; /* for copy/paste */
    int     changeBarPos;   /* Change Bar pos: WP_CB_POS_LEFT, _RIGHT, _OUTER */
    int hyphMethod;         /* Hyphenation method: WP_HYPH_NONE, _CALC, _DICT */
                            /* !!1 may want to move to section at some point */
} ed_doc_start;

typedef struct {    /* Document END bead */
    BEAD_HEADER
} ed_doc_end;

typedef union ed_bead {
    ed_any_bead             any;
    ed_text                 text;
    ed_error                error;
    ed_marker               marker;
    ed_para                 para;
    ed_style                style;
    ed_graphics             graphics;
    ed_bitmap               bitmap;
    ed_object               object;
    ed_column_break         columnBreak;
    ed_page_break           pageBreak;
    ed_section              section;
    ed_series               series;
    ed_equation             equation;
    ed_docvar               docvar;
    ed_color                color;
    ed_tag                  tag;
    ed_field_start          fldStart;
    ed_field_end            fldEnd;
    ed_field_split          fldSplit;
    ed_cell_end             cellEnd;
    ed_row_start            rowStart;
    ed_table_start          tableStart;
    ed_table_end            tableEnd;
    ed_style_start          styleStart;
    ed_style_end            styleEnd;
    ed_footnote_start       footnoteStart;
    ed_footnote_end         footnoteEnd;
    ed_hdrftr_start         hdrftrStart;
    ed_hdrftr_end           hdrftrEnd;
    ed_glossary_start       glossStart;
    ed_glossary_end         glossEnd;
    ed_clip_start           clipStart;
    ed_clip_end             clipEnd;
    ed_flow_start           flowStart;
    ed_flow_end             flowEnd;
    ed_doc_start            docStart;
    ed_doc_end              docEnd;
} ed_bead;

/* Print info */
/* ( Moved to wp_print.h )*/

/* Mark */

#define WP_MAX_MARK_NAME    (STRPATH+STRNORMAL)
typedef struct wp_mark_t {          /* a named location */
    int pos;            /* bead number */
    int offset;         /* offset in bead */
    wpchar name[WP_MAX_MARK_NAME+1];
    struct wp_mark_t *next;
} wp_mark_t;


/* Action list */

#define WP_ACTION_MAINLOOP_REASON   1   /* mainloop entered */
#define WP_ACTION_IDLE_REASON       2   /* user is currently idle */
#define WP_ACTION_UNDO_REASON       3   /* Undo request forces cleanup */
#define WP_ACTION_PRINT_REASON      4   /* Print request forces cleanup */

#define WP_ACTION_UNUSED            0
#define WP_ACTION_SERIES_CHANGE     1
#define WP_ACTION_SECTION           2
#define WP_ACTION_CONDITIONAL_VAR   3
#define WP_ACTION_GLOSSARY_CHANGE   4
#define WP_ACTION_XRF_FIELD_CHANGE  5
#define WP_ACTION_POKE              6
#define WP_ACTION_POLL              7   /* poll link/object */
#define WP_ACTION_PAGE_COUNT        8
#define WP_ACTION_OBJECT            9   /* obj changed - update fields/shading */

typedef union wp_action_t {
    struct {
        int type;                   /* WP_ACTION_SERIES_CHANGE... */
    } any;
    struct {
        int type;                   /* WP_ACTION_SERIES_CHANGE */
        wpchar name[STRNORMAL+1];   /* name of series that changed */
        int bead;                   /* Field start bead. Zero -> re-eval ALL,
                                        non-zero -> true start loc is tagged */
        int tagCount;               /* Unique suffix for tag */
    } series;
    struct {
        int type;                   /* WP_ACTION_CONDITIONAL_VAR */
        wpchar *varName;            /* name of document variable that changed */
    } condVar;
    struct {
        int type;                   /* WP_ACTION_GLOSSARY_CHANGE */
        wpchar name[STRNORMAL+1];   /* name of glossary that changed */
    } glossary;
    struct {
        int type;                   /* WP_ACTION_XRF_FIELD_CHANGE */
        wpchar name[STRNORMAL+1];   /* name of xrf source that changed */
    } xrf;
    struct {
        int type;                   /* WP_ACTION_POKE */
        int code;                   /* poke code */
        bool wpOnly;                /* TRUE: only poke WP dboxes; update ruler.
                                      FALSE: poke all dboxes; no ruler update */
    } poke;
    struct {
        int type;                   /* WP_ACTION_POLL */
        mbchar name[WP_MAX_MARK_NAME+1];    /* tag to link/object */
    } poll;
    struct {
        int type;                   /* WP_ACTION_OBJECT */
        mbchar name[STRPATH+1];     /* object name */
    } object;
} wp_action_t;



/* Formatter work item */

#define FM_WORK_ANY                     0
#define FM_WORK_FRAME                   1  /* new frame */
#define FM_WORK_SECTION                 2  /* new section */
#define FM_WORK_PAGE_BREAK              3  /* page break */
#define FM_WORK_FOOTNOTE_BOTTOM_PAGE    4  /* footnote for bottom of page */
#define FM_WORK_FOOTNOTE_END_DOC        5  /* footnote for end of document */

typedef struct {
    int type;     /* type of work item */
    int bead;     /* the interesting bead - frame, section, footnote ... */
} fm_work_item_t;



/* Frame anchor image size in pixels */
#define DS_FRAME_ANCHOR_WIDTH   14
#define DS_FRAME_ANCHOR_HEIGHT  13



/*
 * Formatting Tables
 *
 * Only FmGetRowInfo() is allowed to allocate cell info array.
 * Caller to FmGetRowInfo() MUST call FmCleanRowInfo() to free cell info array.
 */
typedef struct {
    int cellEndBead;
    bool locked;            /* cell locked flag */
    int cellWidths;         /* cell width */
    int leftCellMargins;    /* cell left margin */
    int rightCellMargins;   /* cell right margin */
    int topCellMargins;     /* cell top margin */
    int bottomCellMargins;  /* cell bottom margin */
} fm_cell_info_t;

typedef struct {
    int rowBead;
    int numCells;           /* number of cells in row */
    fm_cell_info_t *cells;  /* array of cell info */
    int rowWidth;           /* width of row in mils */
    int rowHeight;          /* height of cells */
    int topRowMargin;       /* height above cells */
    int bottomRowMargin;    /* height below cells */
    int headingRowBead;     /* first heading row_start */
    int numHeadingRows;     /* num heading rows required */
    int headingWidth;       /* total width of all heading rows */
    int headingHeight;      /* total height of all heading rows */
    bool repeatedHeading;   /* (heading only) TRUE if info for repeated heading */
    int numURects;          /* (heading only) */
    struct urect_t *urects; /* (heading only) heading row format info */
} fm_row_info_t;



/*
 * Formatter/Displayer generic rectangle
 */
typedef struct {
    int xpos;
    int ypos;
    int width;
    int height;
} fmRectangle;



/* general purpose check to see if two rectangular areas intersect */
#define FM_RECTS_INTERSECT(r1P, r2P) \
                    ((((r1P)->xpos + (r1P)->width) > (r2P)->xpos) && \
                    ((r1P)->xpos < ((r2P)->xpos + (r2P)->width)) && \
                    (((r1P)->ypos + (r1P)->height) > (r2P)->ypos) && \
                    ((r1P)->ypos < ((r2P)->ypos + (r2P)->height)))

/* general purpose check to see if two rectangular areas same */
#define FM_RECTS_SAME(r1P, r2P) \
                    (((r1P)->xpos == (r2P)->xpos) && \
                    ((r1P)->ypos == (r2P)->ypos) && \
                    ((r1P)->width == (r2P)->width) && \
                    ((r1P)->height == (r2P)->height))

/* general purpose check to see if two rectangular areas intersect */
#define DS_COORDS_INTERSECT(x1, y1, w1, h1, x2, y2, w2, h2) \
                    ((((x1) + (w1)) > (x2)) && \
                    ((x1) < ((x2) + (w2))) && \
                    (((y1) + (h1)) > (y2)) && \
                    ((y1) < ((y2) + (h2))))

 /* like DS_COORDS_INTERSECT, but only check vertical direction */
#define DS_Y_COORDS_INTERSECT(y1, h1, y2, h2) \
                    ((((y1) + (h1)) > (y2)) && \
                    ((y1) < ((y2) + (h2))))

/* general purpose check to see if rectangle is at least partly on screen */
#define DS_RECT_ON_SCREEN(rP, pageP) \
                    DS_COORDS_INTERSECT((rP)->xpos, \
                        (rP)->ypos + (pageP)->ypos, \
                        (rP)->width, \
                        (rP)->height, \
                        wpP->DsXoffset, \
                        wpP->DsYoffset, \
                        wpP->DsWidth, \
                        wpP->DsHeight)

/* general purpose check to see if rectangle is only partly on screen 
 * (this macro assumes that the rectangle intersects the screen) */
#define DS_RECT_CLIPPED(rP, pageP) \
    ( (((rP)->xpos - wpP->DsXoffset) < 0) || \
    (((rP)->ypos + (pageP)->ypos - wpP->DsYoffset) < 0) || \
    (((rP)->xpos + (rP)->width - wpP->DsXoffset) > wpP->DsWidth) || \
    (((rP)->ypos + (pageP)->ypos + (rP)->height - wpP->DsYoffset) > wpP->DsHeight) )



/*
 * Border Info for Displayer Regions  (Really "Boundary"?)
 */
typedef struct {
    int updateIndex;
    int xpos;
    int ypos;
    int width;
    int height;
	short type;						/* Page, Rect, Urect 					  */
	short xshift, yshift;			/* To avoid overlap of R and U boundaries */
} dsBorder;

/*
 * Displayer region
 */
#define DS_REGION_WIDTH     50      /* width of Displayer region in pixels    */
#define DS_REGION_HEIGHT    15      /* height of Displayer region in pixels   */
#define REGION_PREALLOCED_GOBLIST_SIZE 2 /* No. gobList ptrs in this struct.  */
typedef struct {
    int numGobs;            /* number of gobs intersecting this region 		  */
    int numBorders;         /* number of border lines x-ing this region 	  */
    dsBorder **borderList;  /* list of border lines x-ing this region 		  */
							/*This struct contains a few preallocated pointers*/
							/* to avoid reallocating for the common case of	  */
							/* having only a few gobs in each region.  When	  */
							/* the code discovers it needs more than the pre- */
							/* allocated number of gob ptrs, it allocates in  */
							/* an expandable array of pointers outside this   */
							/* struct.  25 Nov 97 rjd	4441508				  */
	int currentNumPtrsgobList;/* current size of gobList array				  */
							/* ptrs -> gobs intersecting this region 		  */
    struct gob_t *preallocgobList[REGION_PREALLOCED_GOBLIST_SIZE];
	/*Next entry cannot be an expandable dummy, because this struct (dsRegion)*/
	/* is an element in an array.											  */
    struct gob_t **gobList; /* ptr -> ptrs[] -> gobs intersecting this region */
} dsRegion;



/* Formatter/Displayer page */
typedef struct page_t {
    int pagenum;        /* index in page array (not user visible page number) */
    unsigned
        type : 3,          /* odd/even/first */
        orientation : 1,   /* portrait/landscape */
        hasHeader : 1,     /* TRUE if page has a header rect */
        hasFooter : 1,     /* TRUE if page has a footer rect */
        exposePending : 1, /* DISPLAYER: needs redraw (should use expose areas)*/
        quickPageFormatNeeded : 1,  /* TRUE if quick format needed after typing*/
        cleanPageFormatNeeded : 1,  /* TRUE if full page format needed */
        flowAreadirty : 1,          /* TRUE if need to format all Flow contents*/
                                    /* e.g. if Flow Area changes size. This is */
                                    /* a shortcut to avoid looping over U's.   */
        fdtype : 1,         /* 0 = Fm page, 1 = Ds */
        haveSentToClient : 1;   /* TRUE if display page replicated in client */
    int userPageNum;    /* user visible pagenum (based on section) */
    int leftMargin;     /* from binding (for odd pages) or page edge (even) */
    int rightMargin;    /* from binding (for odd pages) or page edge (even) */
    int topMargin;      /* from page edge */
    int bottomMargin;   /* from page edge */
    int bindingMargin;  /* from page edge */
    int ypos;           /* position in total doc galley */
    int width;          /* width of page (paper width) */
    int height;         /* height of page (paper height) */
    int printSourceTray;/* override code determining paper tray */
    int printDestTray;  /* override code determining paper tray */
    int duplex;         /* WP_PRINT_SIMPLEX, _DUPLEX_LONG, _DUPLEX_SHORT */
    int sectionBead;    /* section bead governing page attrs, hdr/ftr */
    int breakBead;      /* section/page_break bead if any */
    fmRectangle flowArea;  /* area avail for flow material */
    int numRegionRows;
    int numRegionCols;
    dsRegion **regions;  /* gridded regions for Displayer */
    int numBorders;
    dsBorder **borders;  /* view-border line - needed during Displayer update */
    int numFootnoteRects;  /* number of footnote rects on this page */
    int numEndDocFootnoteRects;  /* number of end-doc footnote rects on page */
    int numFootnoteBarRects; /* number of footnote bars; cannot be > 2 */
    int numFrameRects;  /* number of frame rects on this page */
    int numRects;       /* total number of rects on this page */
    struct rect_t *rects;  /* array of rects */
} page_t;


/* Formatter/Displayer rect types */
#define FM_FLOW_RECT                0  /* normal flow material */
#define FM_HEADER_RECT              1  /* header */
#define FM_FOOTER_RECT              2  /* footer */
#define FM_FRAME_RECT               3  /* frame */
#define FM_FOOTNOTE_RECT            4  /* bottom of page footnote */
#define FM_END_DOC_FOOTNOTE_RECT    5  /* end-doc footnote */
#define FM_FOOTNOTE_BAR_RECT        6  /* separator above footnote area */

/* footnote bar types */
#define FM_FOOTNOTE_BAR_UNKNOWN     0  /* used if cannot determine type */
#define FM_FOOTNOTE_BAR_BOT_PAGE    1
#define FM_FOOTNOTE_BAR_CONT        2
#define FM_FOOTNOTE_BAR_END_DOC     3

/* Formatter/Displayer rect */
typedef struct rect_t {
    struct page_t *page; /* parent page */
    unsigned
        type : 3,            /* FLOW, HEADER, FOOTER, FRAME ... */
        dirty : 1,           /* needs formatted if TRUE */
        frameType : 3,       /* how frame affects material flow (FRAME_RECT) */
        hasColumnBreak: 1,   /* if TRUE, this rect contains a column/page break */
        balancingColumns: 1, /* HACK so lower layers don't add/get work items */
        skipHeading: 1;      /* heading doesn't fit (flag reset on dirty) */
    int numColumns;          /* # columns in region which this rect is part of */
    int columnNum;           /* 0-based column num of rect in region */
    int stopBead;            /* stop bead so FormatAllRects can stop too */
    int refBead;             /* interesting bead - frame, footnote, hdrftr... */
    int xpos;                /* offset from page (absolute from paper edges) */
    int ypos;                /* offset from page (absolute from paper edges) */
    int width;               /* width of rect */
    int height;              /* height of rect */
    int headingRowStartPos;  /* "real" start for urect (table heading) */
wp_location startOfFlow;        /* for now, just used by java */
    wp_location start;       /* first bead & offset within */
    wp_location end;         /* last bead & offset (same as start on next rect) */
    int numURects;           /* number of urects within this rect */
    struct urect_t *urects;  /* array of urects */
} rect_t;


/* Formatter/Displayer micro rect (urect) types */
#define FM_FLOW_URECT           0
#define FM_CELL_URECT           1

/* Formatter/Displayer micro rect (urect) */
typedef struct urect_t {
    struct rect_t *rect; /* parent rect */
    unsigned
        type : 2,        /* FLOW, CELL, TABLE_HEADING ... */
        dirty : 1,       /* needs formatted if TRUE */
        locked : 1,      /* cell locked if TRUE */
        repeatedHeading : 1,    /* TRUE if table heading (not first instance) */
        splitLinesAligned : 1,  /* set to TRUE after split lines aligned */
        firstRowInTable : 1;    /* for now, just used by java */
    int leftCellMargin;  /* left margin (for CELL_URECT) */
    int rightCellMargin; /* right margin (for CELL_URECT) */
    int topCellMargin;   /* top margin (for CELL_URECT) */
    int bottomCellMargin;  /* bottom margin (for CELL_URECT) */
    int heightUsed;      /* total height of lines; used while formatting */
    int extraHeightDown; /* max height by which urect can grow downwards */
    int extraHeightUp;   /* max height by which urect can grow upwards */
    int numSplitLines;   /* num split line urects if in split line region */
    int splitLineNum;    /* 0-based split line num of urect in region */
    int splitLineMaxHt;  /* max height of split line */
    int xpos;            /* offset from page (absolute from paper edges) */
    int ypos;            /* offset from page (absolute from paper edges) */
    int width;           /* width of urect */
    int height;          /* height of urect */
int tableUid;       /* for now, just used by java */
int tableColNum;        /* for now, just used by java */
wp_range rangeOfRow;        /* for now, just used by java */
wp_range rangeOfCell;       /* for now, just used by java */
    wp_location start;   /* first bead & offset within */
    wp_location end;     /* last bead & offset (same as start on next urect) */
    int numLines;        /* number of lines within this urect */
    int status;          /* return from FormatURect (rjd 7XI96)                */
    struct line_t *lines;  /* array of lines */
} urect_t;


/* Formatter/Displayer line types */
#define FM_NORMAL_LINE      0
#define FM_CELL_BORDER_LINE 1

/* Formatter/Displayer line */
typedef struct line_t {
    struct urect_t *urect;  /* parent urect */
    unsigned
        type : 2,           /* NORMAL, CELL_BORDER */
        dirty : 1,          /* TRUE if needs formatted */
        addsWorkItem : 1,   /* TRUE if this line adds work item */
        quickFormat : 1,    /* TRUE if doing quick format while typing */
        noHyphenation : 1;  /* TRUE if last word on line cannot be hyphenated */
    short status;           /* Return status from FmFormatLine, used if cached*/
	short baseline;
    int xpos;           	/* offset from page (absolute from paper edges) */
    int ypos;           	/* offset from page (absolute from paper edges) */
    int height;         	/* height of line */
int justify;        		/* for now, just used by java */
int rightIndent;    		/* for now, just used by java */
wp_range rangeOfPara;   	/* for now, just used by java */
wp_range rangeOfLine;   	/* for now, just used by java */
    wp_location start;  	/* first bead & offset within */
    wp_location end;    	/* last bead & offset (same as start on next line) */
    int numGobs;        	/* number of gobs within this line */
    struct gob_t *gobs; 	/* array of gobs */
} line_t;


/* Formatter/Displayer graphic object (gob) types */
#define WP_GOB_TEXT                 0   /* simple text */
#define WP_GOB_LEFT_TAB             1   /* a gob type */
#define WP_GOB_RIGHT_TAB            2   /* a gob type */
#define WP_GOB_CENTER_TAB           3   /* a gob type */
#define WP_GOB_DECIMAL_TAB          4   /* a gob type */
#define WP_GOB_BITMAP               5   /* bitmap gob */
#define WP_GOB_PILCRO               6   /* pilcro (paragraph marker) */
#define WP_GOB_LEFT_BORDER          7   /* left border */
#define WP_GOB_RIGHT_BORDER         8   /* right border */
#define WP_GOB_TOP_BORDER           9   /* top border */
#define WP_GOB_BOTTOM_BORDER        10  /* bottom border */
#define WP_GOB_HORIZONTAL_BORDER    11  /* horizontal separator */
#define WP_GOB_SHADING              12  /* background shading */
#define WP_GOB_BUTTON               13  /* pushbutton */
#define WP_GOB_PAGE_BREAK           14  /* page break bead */
#define WP_GOB_SECTION_BREAK        15  /* section bead */
#define WP_GOB_COLUMN_BREAK         16  /* column break bead */
#define WP_GOB_FRAME_ANCHOR         17  /* frame anchor */
#define WP_GOB_EQUATION             18  /* equation object */
#define WP_GOB_FORMATTER_EVAL_FIELD 19  /* Formatter evaluated field */
#define WP_GOB_NEWLINE              20  /* newline character */
#define WP_GOB_CHANGE_BAR           21  /* change bar */
#define WP_GOB_CHANGE_DEL           22  /* change mark for deletions */
#define WP_GOB_CHANGE_ADD           23  /* change mark for additions */
#define WP_GOB_ERROR                24  /* error (for macro editor) */
#define WP_GOB_FIELD_START          25  /* field start */
#define WP_GOB_FIELD_SPLIT          26  /* field split */
#define WP_GOB_FIELD_END            27  /* field end */

/* Formatter/Displayer graphic object (gob) */
typedef struct gob_t {
    line_t *line;       /* parent line */
    unsigned
        type : 8,       /* WP_GOB_TAB... */
        switched : 1,   /* if TRUE, left/right top/bottom border gobs switched */
        haveClearArea : 1,  /* TRUE if clear area computed (displayer gobs) */
        inEntryField : 1,   /* TRUE for text/field_end gobs in entry fields */
        entryAreaUnderline : 1, /* TRUE for t/f gobs in underlined entry areas*/
        haveProcessedForSubGobs : 1,    /* whether subGob info accurate */
        printerContolCode : 1;  /* TRUE for fldStrt gob for this fld type */
    int subType;        /* subtype of gob, used in equations EQN_FENCE... */
    int revNum;         /* lastRev of associated bead */
    int xpos;           /* offset from page (absolute from paper edges) */
    int ypos;           /* offset from page (absolute from paper edges) */
    int width;          /* width of formatted material */
    int height;         /* includes effect of line & end-para spacing */
    fmRectangle clearArea;  /* actual dimensions of area to be cleared */
    int displayWidth;   /* -1 or unadjusted screen width for text gobs */
    int compHeight;     /* screen-pix ht used for gob comparisions (Displayer) */
    int baseline;       /* offset from ypos, includes effect pre-para spacing */
    char *fgColor;      /* only used for Java gob diffs */
    char *bgColor;      /* only used for Java gob diffs */
    int shadingStyle;   /* only used for Java shading gob diffs */
    int javaId;         /* used for bitmaps' Java cache id references */
    int offset;         /* offset from xpos for drawing text (for tab leader) */
    int attrDex;        /* attributes info copied from text bead only */
    int updateIndex;    /* index in gob list during Displayer update */
    wp_location start;  /* first bead & offset within */
    wp_location end;    /* last bead & offset (same as start on next gob) */
    int hilitStart;     /* selection state (in pix) */
    int hilitWidth;     /* selection state (in pix) */
    wp_tab *tabP;       /* tabstop info for tab gobs (NULL if default stop) */
    wchar *wtext;       /* NULL or allocated text string */
    int numSubGobs;     /* 0 or how many substrings in gob */
    struct sub_gob_t *subGobs;  /* array of sub-gobs */
} gob_t;

/* Formatter/Displayer Sub-Gob */
typedef struct sub_gob_t {
    wchar *wtext;       /* ptr to start of sub-gob string (NOT allocated) */
    int numChars;       /* char count for sub string */
    int xoffset;        /* intra-gob position (in pix) for sub string */
    int xshift;         /* how many pixels xoffset was adjusted by */
} sub_gob_t;




/* Ruler Widget info */

typedef struct RWState {

/* basic parameters */

    int YPosTabs;       /* placement of tabs */
    int YPosRule;       /* placement of inch rule */
    int YPosChoices;    /* placemnt of choices list */
    int MaxChoiceWidth; /* width of default choice box */
#define RW_PARAGRAPH_MODE 1
#define RW_SECTION_MODE 2
#define RW_TABLE_MODE 4
#define RW_WAS_TABLE_MODE 8 /* used to indicate temporary change from table
                            mode */
#define RW_FRAME_MODE 16

/* relationship of glyph dex to data structures */

    int MarginsStartDex;/* End of rule, start of margins */
    int TabsStartDex;   /* End of margins, start of tabs */
    int ColsStartDex;   /* End of tabs, start of indents */
    int TableStartDex;  /* End of indents, start of table cells */
    int FrameStartDex;  /* End of cells, start of frame edges */
    int NumberOfItems;  /* top of the world */

    AXWidget RulerWidget;
    AXWidget ChoiceMenuWidget;
    AXWidget FontWidget;
    AXWidget FontButton;
    AXWidget SizeWidget;
    AXWidget SizeButton;
    AXWidget TabLeftButton;
    AXWidget TabRightButton;
    AXWidget TabCenterButton;
    AXWidget TabDecimalButton;
    AXWidget InsertChoiceButton;
    AXWidget activeJustButton;  /* depressed jutification button */
    AXWidget IndentModeButton; /* to show paragraph indents */
    AXWidget SectionModeButton; /* to show section margins */
    AXWidget TableModeButton; /* to show cellwidths  */
    AXWidget FrameModeButton; /* to show Frame position,width  */
    unsigned
        RWChangedHasBeenCalled : 1; /* Set on first call */

/* widgets for equation editor tool bar */
    AXWidget LoSymbol;      /* lower case greek symbols */
    AXWidget UpSymbol;      /* upper case greek symbols */
    AXWidget SetSymbol;     /* set theory symbols */
    AXWidget RelSymbol;     /* operator symbols <=, >=, ~=, =/, .. */
    AXWidget SpaceSymbol;       /* spaces, align marker etc */
    AXWidget ArrowSymbol;       /* arrows */
    AXWidget SpecialSymbol; /* special symbols: infty, do' */
    AXWidget GeneralSymbol; /* general symbols */

    AXWidget Fence;         /* fence templates */
    AXWidget Fraction;      /* fraction & square root templates */
    AXWidget SubSup;            /* subscript, superscript and script tempaltes */
    AXWidget Summation;     /* summation and product tempaltes */
    AXWidget Integral;      /* integral , 2integral, O-integral .. templates */
    AXWidget Overbar;           /* overbar and underbar templates */
    AXWidget LabelArrow;        /* labelled arrows templates */
    AXWidget CupCap;            /* cups and caps tempaltes */
    AXWidget Matrix;            /* matrix templates */

/* vars associated with dragging glyphs */

    AXWidget ArmedTabButton;    /* used during tab creation */
    struct drag {
        int armedGlyph;     /* dex in glyph list */
        int pointerXoffset; /* initial relationship between ptr and hotspot */
        int pointerYoffset; /* initial relationship between ptr and hotspot */
    } drag;

/* list of 16th inch spots on ruler */

    int num_pix16s;
    short pix16s[1000];     /* enough for 40 inches */
} RWState;

/* This struct matches format wp_status@ as defined in wp.elf */
typedef struct {
    int pageNum;            /* page number at cursor */
    int pageCount;          /* total number of pages */
    int colCount;           /* num columns selected (0 for non-table selection)*/
    int verticalPosition;   /* position on page (from top) of cursor          */
							/* (Y mil coord of line containing cursor)		  */
    int pageHeight;         /* height of page in mils */
    int inFootNote;         /* TRUE iff cursor is in a footnote */
    int inHdrFtr;           /* TRUE iff cursor is in a header or footer */
    int inFrame;            /* TRUE iff cursor is in a frame */
    int inTable;            /* TRUE iff cursor is in a table */
    int inHeading;          /* TRUE iff cursor is in a table heading */
    int inField;            /* TRUE iff cursor is in a field */
    char *fieldMethod;      /* level 1 field method string, if cursor in field */
    int overtypeMode;       /* TRUE iff typing mode is overtype. */
    int macroEditing;       /* TRUE iff we are macro editor */
    int equationEditing;    /* TRUE iff we are equation editor */
    int helpMode;           /* TRUE iff we are in help mode */
    int formMode;           /* TRUE iff we are in form mode */
    int paraNum;            /* Paragraph number (line number in macro editor) */
    int paraCount;          /* num paras in current flow (line count in ME)*/
    int readOnly;           /* TRUE iff we are in read-only mode */
    int viewOnly;           /* TRUE iff we are in view-only mode */
    int zoomFactor;         /* zoom percentage */
    bool modified;          /* TRUE if document modified */
    int htmlEditing;        /* HTML_MODE_NONE, _EDIT, _VIEW */
    bool windowless;        /* TRUE if opened in background by ELF script */
} wpStatus;


/* foreign object handle cache */
typedef struct {
    int cacheId;            /* unique id */
    int lastUsedIndex;      /* unique index to indicate when last used */
    int referenceCount;     /* num beads in doc using this handle */
    int handle;             /* uid of object as managed by gebltn.c, wpbltn.c, etc. */
    int type;               /* Type of object: IC_DC, IC_GE, IC_SS */
    mbchar *hashedPicName;  /* Hashed linked filename or object or graphic name */
    void *objP;             /* ax_inset_object@, but get 'source' from picture bead */
} ds_ge_handle_cache_t;

typedef struct {
    unsigned
        scale_mode : 2,
        proportional : 1;
    double prescale_x;
    double prescale_y;
    int src_wid;
    int src_hyt;
    int dst_wid;
    int dst_hyt;
} wp_graphics_info_for_ge;


/* cache of current effective style properties, used with WpGetStyleInfo() */
typedef struct styleInfoStruct {
    mbchar *hashname; /* hashtable name of style */
    int bead;       /* style bead, 0 if style does not exist */
    wp_para_attrs paraAttrs; /* effective resolved para attrs */
    wp_char_attrs textAttrs; /* effective resolved text attrs */
    struct styleInfoStruct *next; 
} styleInfo;


/* Table beads cache */
typedef struct wp_table_beads_cache_t {
    struct wp_table_beads_cache_t *next;
    int start;              /* ROW_START bead of first row */
    int end;                /* last CELL_END bead of last row */
    int lastCheckBeadRev;   /* beadRev when checked */
} wp_table_beads_cache_t;


/* Formatter line cache */
typedef struct fm_line_cache_t {
    struct fm_line_cache_t *next;
    int width;
    int rectType;
    int urectType;
    int urectHeading;
    line_t line;
} fm_line_cache_t;


/* Some WP Instance defines - see insets_.am */
/* !!0 Should be available via a product-wide common .h file !!0 */
#define WPX_CLIP_TO_FIT                 0
#define WPX_CLIP_TO_FIT_STR             NXLT("clip to fit")
#define WPX_SCALE_TO_FIT                1
#define WPX_SCALE_TO_FIT_STR            NXLT("scale to fit")
#define WPX_SCALE_IF_CLIPS              2
#define WPX_SCALE_IF_CLIPS_STR          NXLT("scale if clips")

#define WPX_NO_BORDER                   0
#define WPX_NO_BORDER_STR               NXLT("none")
#define WPX_SOLID_BORDER                1
#define WPX_SOLID_BORDER_STR            NXLT("solid")
#define WPX_DASHED_BORDER               2
#define WPX_DASHED_BORDER_STR           NXLT("dashed")
#define WPX_SHADED_DASHED_BORDER        3
#define WPX_SHADED_DASHED_BORDER_STR    NXLT("screen dashed")

/* Special 'Paste Hack' codes - for wpP->specialPasteHack */
#define WP_PASTE_NONE               0       /* No special hack needed */
#define WP_PASTE_NO_STYLE_CHECK     1       /* set to cause function that gets styles 
                                                by name to not assert when it can't 
                                                find a style, but to instead return top 
                                                style */
#define WP_PASTE_PARA_AT_END        2       /* Pasted material ends with para bead */
#define WP_PASTE_NO_PARA_AT_END     3       /* Pasted material DOESN'T end with para */
#define WP_PASTE_NO_OBJECTS_YET     4       /* Pasted fields have no objects yet */

/* For wpP->readMode: */
#define WP_READ_FILE                0       /* Read doc from disk */
#define WP_READ_FILEOBJ             1       /* Read doc from FS fcns (axio.c)*/
#define WP_READ_BUFFER              2       /* Read doc from passed buffer */



                        /* The major structure!!!! */

    /****************************************************************/
    /*                      wp_global_data                          */
    /*                                                              */
    /*      This is the "WP" structure.  "wpP" points to this.      */
    /*                                                              */
    /****************************************************************/

#define WP_GLOBAL_CODE          13579           /* 'Random', recognizable tag */

typedef struct {

	genericAppStruct appInfo; /* generic app info - */
    int pid;            /* Id of task that owns this struct */
/* TASK / WPX controls */
    unsigned
        invalid : 1,    /* TRUE if structure is not yet valid */
        asTask : 1,     /* TRUE for separate WP task; FALSE for inset */
        busy : 1;       /* TRUE -> called ELF and must block events till done */
    bool javaDisplay;   /* TRUE is window is or will be on java client */

/* DOCUMENT / FILE */

    char *trueName;     /* Absolute path of actual file requested to open - could be 
                            a URL, and could be a foreign file format */
    char *documentName; /* Physical disk file we opened - could be a URL fetched to
                            a temp file, or the output of a filter */
    unsigned
        fileOnDisk : 1, /* saved/read-from above name */
        fileInUse : 1,  /* TRUE if we called AFNoteFileInUse for 'documentName' */
        updatedLinks : 1,   /* TRUE if did initial link update (WPX only)  */
		non_native : 1;	/* TRUE if doc was imported and not yet saved as WP */
    int fileSaveMode;   /* see fs_save.h */
    int fileGrpAccess;  /* Unix group enabled */
    int fileAllAccess;  /* Unix all access enabled */
    int fileWritable;   /* whether saved/read in writeable mode */
    mbchar ascNum[16];  /* ASC source code control version number */
    int readMode;       /* WP_READ_FILE, _FILEOBJ, _BUFFER */
    int readOnly;       /* Read-only: FALSE, FORCE_ON (due to file permissions),
                            or OPTIONAL_ON (due to ELF macro request) */
    int viewOnly;       /* View-only: FALSE, FORCE_ON (due to license),
                            or OPTIONAL_ON (due to ELF macro request) */
    mbchar *fileDataLines; /* Asterx standard comment lines read from
                        the input file, to be written with file.
                        each is NULL terminated. double NULL ends the
                        list. */
    bool initialized;   /* Has gone thru full initialization process? */
    bool newWindow;     /* Currently initializing new window? */
    int curVersion;     /* current version number */
    int oldVersion;     /* original version number (where doc came from) */

/* BEADS */

    int numBeads;       /* bead array size, including 0'th bead */
    ed_bead **beads;    /* The data!  0'th is illegal, first bead at 1'th */
    int flowStartBead;  /* ED_FLOW_START bead pos */
    int flowEndBead;    /* ED_FLOW_END bead pos */
    int beadRev;        /* bumped each time one or more beads is changed */
    int readerNumBeadsAlloced;  /* used during file read */
    int readerFieldLevel;       /* used during file read */

/* POOLED BEAD ATTRS */

    ed_pooled_attrs_entry ***pooledAttrsHash;   /* hashed pooled bead attrs */


/* ELF CALL */

    int wpTaskBeingCalledByElf; /* THIMpid of wp task being called */
    int elfCaller;              /* THIMpid of elf task calling WP */
    int oldParent;              /* relavent only during ElfbWpCall() */
    int oldPended;              /* relavent only during ElfbWpCall() */


/* CLIPBOARD, CUT & PASTE */

    ed_bead **clipBoard;    /* copy/paste */
    int numClipBeads;
    ed_bead **selectionBoard;   /* copy/paste */
    int numSelectionBeads;
    int requestingXferType; /* copy/paste handshake */
    int tablePasteMode; /* when pasting cells are rows created, or
                            columns created, or do we query user via
                            dialog box.
                            values are PASTE_QUERY PASTE_ROWS PASTE_COLS. */
    mbchar *pasteOverwrite; /* if Non-zero, when pasting external material and
                        pasted styles, colors, etc already exist, overwrite
                        with clipboard material.
                        Points to list of style names that are to be
                        overwritten. Each is NULL terminated.
                        double NULL ends the list. */


/* TYPING ATTRS */

#define WP_SMART_QUOTES 1
#define WP_SMART_SPACES 2
    int smartTextInsert; /* set bit 0 for smart quotes, bit 1 for smart spaces*/
    wp_char_attr_flags useTypingAttrs; /* use the following local attrs
                                        for next char entered. */
    wp_char_attrs typingAttrs; /* attrs of next character entered */
    wp_range typingAttrCursor; /* cursor when typing attrs last updated */
    int typingAttrRev;          /* rev when typing attrs last updated */

    wp_char_attrs overrideAttrs; /* temporary override attrs (e.g. bold key) */
    wp_char_attr_flags overrideAttrFlags; /* use with 'overrideAttrs' */

    wp_range selTextAttrsCursor;        /* cursor when text atts last resolved*/
    wp_char_attr_flags selTextAttrFlags; /* text attr flags of selection */
    wp_char_attrs selTextAttrs;         /* text attrs of selection */
    int overtypeMode;   /* TRUE for overtype typing mode. FALSE for
                            insert mode. */


/* EDIT */

    bool pokeEdited;    /* set to TRUE after each edit; FALSE after poke */
    bool pokeColors;    /* set to TRUE if colors modified; FALSE after poke */
    bool modified;      /* set to TRUE after each edit */
    bool lastJavaModified;  /* as last sent to Java client */
    bool noEditScroll;  /* TRUE -> don't scroll to cursor loc after this edit */
    ed_bead *savedAtts; /* para bead result of "Copy para attributes" */
    bool autoSetParaAtts;   /* TRUE if ""Apply to New Paragraphs" */
    char **elfVarsTable;    /* (casted) linked list of elf vars */
    bool fieldOutOfDate;    /* TRUE if edited a field method */
    int writeChangeBars;    /* WP_CB_NONE, _STANDARD, _NO_ATTRS */
    bool saveForExport;     /* TRUE if saving file for export 
                                (doesnt skip field values while saving) */


/* CACHES OF CALCULATED INFORMATION */

    styleInfo *styleInfoCache; /* cache of current effective style properties */
    int sectionBead;    /* latest section bead found by EdGetSectionOfBead */
    int inSectionBead;  /* first known bead in the above section */
    int colorBead;      /* last color bead that was found */
    wpchar *colorName;  /* name of the color of the last color bead found */
    int fieldCacheBeadRev;  /* bead rev when field cache last calculated */
    int fieldCacheStart;    /* field start bead of field in cache */
    int fieldCacheEnd;      /* field end bead of field in cache */
    wp_table_beads_cache_t *tableBeadsCache;


/* ACTION LIST */

    int sizeActionList;     /* number of items in action list */
    wp_action_t *actionList;    /* leftover work from editor logic */
    int ALseriesCounter;    /* to generate unique tag names for series items */


/* MAINLOOP */

    bool rulerNeedsUpdate;      /* TRUE if ruler/status need update */
    bool rulerTicsNeedUpdate;   /* Just the cell margins (e.g.) need update */
    bool pointerNeedsUpdate;    /* TRUE if need to set mouse pointer shape */
    bool scrollToCursor;        /* scroll to cursor location after format */
    bool cursorNeedsRedraw;     /* set to TRUE if cleared during update */
    int timeoutBeforeBackgroundWork;    /* small timer for mainloop */
    long linkPollInterval;      /* in seconds, -1 means link poll update is off */
    long lastLinkPollTime;      /* last time link poll update occurred */
    bool autoScrolling;         /* TRUE if auto scrolling */
    long autoScrollInterval;    /* in msec */
#if !AXMS
    struct timeval lastAutoScrollTime;  /* time last auto scroll occurred */
#else
    DWORD lastAutoScrollTime;
#endif


/* MARKS */

    wp_mark_t *markerList;  /* list of named marks */


/* AUTO SAVE */

    int autoSaveInterval;   /* in seconds, 0 means auto-save is off */
    int autoSaveBeadRev;    /* beadRev at last auto-save */
    long lastAutoSaveTime;  /* last time auto-save occurred */
    char *autoSaveFilePath; /* Path to autosave file. WpAutoSave              */

/* UNDO */

    bool lastEventWasTyping;    /* for undo brackting of typing */
    int lastTypingBead;         /* for undo brackting of typing */

    bool undoAble;  /* TRUE if should log things for undo (set by WpUndoStart) */
    short undoEventCounter;  /* user interfaceface loop counter */
    char *undoFileName;     /* undo file name */
    FILE *undoFp;           /* undo file stream */
    bool canRedo;   /* Becomes TRUE only after undos, reset on other cmds */
    long undoFilePos;       /* where to read/write undo records */
    long redoFilePos;       /* where to read/write redo records */
    long baseRedoFilePos;   /*  ... but now lower than here */
    long trueFilePos;       /* physical current file pos */
    bool undoing;   /* TRUE only while undoing */
    bool redoing;   /* TRUE only while redoing */
    int undoCount;  /* non-zero between undos & redos */
    int redoCount;  /* non-zero between redos & undos */
    int undoNesting;    /* nesting count of WpUndoStarts */
    undo_value lastUndoInfo;  /* used to minimize typing log */
    bool undoError;     /* set when a file i/o error occurs */
    bool undoOn;        /* set to activate undo/redo logic. Clear
                            to supress it. */
    bool undoMergeWithPrevious;     /* TRUE -> user wants to merge upcoming 
                                        operation with the previous one */
    bool undoPrivateMerge;          /* TRUE -> current transactions are part
                                        of an operation to be merged with
                                        previous operation (for private use
                                        of Undo code only!) */
    int numBeadsToFreeOnUndoClear;
    ed_bead ***beadsToFreeOnUndoClear;  /* free bead arrays on undo clear */

    char *lastUndoString; /* (Java) last string sent for @WP_UNDO_STATE@ */
    char *lastRedoString; /* (Java) last string sent for @WP_UNDO_STATE@ */

/* SPELLER */

    wpchar      *skipDict;              /* Name of (temp) skip dictionary */
    /* wpchar   *docDict; */            /* Name of document dictionary */
    wpchar      *userDict;              /* Name of default user dict */
    int         nDicts;                 /* Number of other dictionaries */
    wpchar      **dicts;                /* Names of other dictionaries */


/* ERROR HANDLING */

    mbchar errorStr[MAX_ERRSTR+1];  /* override error str; reset in main loop */
    mbchar errorObj[MAX_ERROBJ+1];  /* object of error; reset in main loop */


/* VIEW */

    bool viewPilcros;       /* Show paragraph end markers (pilcros) */
    bool viewRuler;         /* Ruler */
    bool viewBreaks;        /* page/column/section breaks */
    bool viewFieldMethods;  /* show field method rather than value */
    bool viewAllBounds;     /* Text boundaries */
    bool viewCellBounds;    /* Cell boundaries */
    bool viewFrameBounds;   /* Frames boundaries */
    bool viewHdrFtrBounds;  /* Hdr/Ftr boundaries */
    bool viewPageBounds;    /* page boundaries (useful for help system) */
    bool viewGraphics;      /* Use picture placeholders if false */
    int wysiwyg;                /* WP_WYSIWYG_CHAR... */
    bool viewEchoCursorInRuler; /* show bar in ruler at cursor loc */
    int userZoomFactor;     /* user visible zoom percentage (100 - normal) */
    int dsXZoomFactor;      /* X or proportional scale factor; 100 = normal */
    int dsYZoomFactor;      /* Y scale factor (for non-proportional scaling) */
    int oldZoomFactor;      /* for use in zoom button */


/* WINDOW */

    short wid;          /* ATM window id - into which we are drawing */
    AXWidget widget;    /* Widget id - into which we are drawing */
    anyType *winCre;    /* ATM window create packet (struct TmCrePacket winCre) */
    int appId;          /* Type of app: IC_DC, IC_CE, IC_EQN */
    int menuId;         /* Menu bar: IC_DC, IC_CE, IC_EQN, or custom value */
    bool windowless;    /* if TRUE, don't map window */
    char *windowTitle;  /* window title */
    char *iconTitle;    /* icon title */
    int iconId;         /* IC_DC, IC_CE, ... */
    Window XWin;

/* DISPLAYER */

    int DsWidth;            /* width of window */
    int DsHeight;           /* height of window */
    int DsXoffset;          /* xpos of window origin in doc coordinates */
    int DsYoffset;          /* ypos of window origin in doc coordinates */
    int DsNumPages;         /* number of pages in display list */
    struct page_t *DsPages; /* array of pages in display list */

    GC TmpGC;
    GC BlackLine;           /* for cursor */
    GC WhiteLine;           /* for removal of cursor */
    GC InvertGC;            /* for hilights */
    GC GrayLineGC;          /* for page/urect boundaries */
    Cursor pointerShape;    /* currently displayed pointer shape in window */

    bool haveClip;          /* TRUE if clip rect set on drawing contexts */
    fmRectangle clipRect;   /* clipping rect */

/* WPX DISPLAYER - Rendering part of doc on a widget or other app's window */

    int unitsDPI;               /* Dots per inch, for passed rects */
    int unitsDPU;               /* Dots per units, for passed rects */
    int unitsPrecision;         /* Desired precision of dpi/dpu calculation */
    fmRectangle destRect;       /* destination rect (screen mils) */
    int destXOffsetMils;        /* Dest rect xpos + optional centering (screen mils) */
    int destYOffsetMils;        /* Dest rect ypos + optional centering (screen mils) */
    bool haveDestClip;          /* TRUE if only drawing on part of destRect */
    fmRectangle destClipRect;   /* clip to this (screen mils) */
    fmRectangle clippedDestRectMils;    /* Thus, draw to this (screen mils) */
    fmRectangle clippedDestRectPixels;  /* Thus, draw to this (screen pixels) */
    fmRectangle sourceRectMils; /* Portion of document to render (doc mils) */
    fmRectangle sourceRectPixels;/* 'sourceRectMils' in zoomed screen pixels */
    bool suppressPointer;       /* TRUE if should not alter pointer */
    bool directRender;          /* TRUE if render directly; else via buffer */
    bool iconOnly;              /* TRUE if should only display Words icon */
    int scaleMode;              /* WPX_CLIP_TO_FIT, _SCALE_TO_FIT, etc. */
    bool proportional;          /* TRUE if proportionally scaling */
    bool centered;              /* TRUE if centering material in destRect */
    bool widgetBg;              /* TRUE if drawing in widget, else window */
    bool clear;                 /* TRUE to clear destRect before rendering */
    bool fill;                  /* TRUE to fill destRect before rendering */
    int borderMode;             /* WPX_NO_BORDER, _SOLID_BORDER, etc. */
    bool shadeContent;          /* TRUE to overlay 50% shade after rendering */
    bool shadeBorder;           /* Like 'shadeContent', but for instance border only */

/* CURSOR / SELECTION */

    wp_range cursor;                /* Current cursor pos OR selection range */
    wp_range prevCursor;            /* Used ONLY for poke logic				 */
    wp_range DsCursor;              /* cursor as last displayed				 */

	byte cursorEndline;				/* Type of end_of_line. See DsDrawCursor */
	byte cursorEndlinestate;		/* Cursor state after drawcursor		 */



#if 0 /*28 Dec 1998 rjd I think these are not needed.  See what happens. */
	/*Dec  2 1998 rjd Don't need these 4 lines, I think. */
	wp_range FmCursor;				/* cursor in Fm data, e.g. end-line		 */
	bool cursorIncludeEndline;					/* Nov 23 1998  needed? used?*/
	wp_location cursorOriginalEndline; /* cursor loc when eol requested		 */
	wp_range cursorEolgob;
#endif



    int colSelectionCount;          /* only meaning for selections in tables */
    int colSelectionFirst;          /* only meaning for selections in tables */
    int colSelectionLast;           /* only meaning for selections in tables */
    wp_range LastClientCursor;      /* last cursor sent to Java client */
    bool LastClientCursorInFlow;    /* as sent to java client */
    bool LastClientCursorInTable;   /* as sent to java client */
    bool LastClientCursorInFrame;   /* as sent to java client */
    bool LastClientCursorHadHeader; /* as sent to java client */
    bool LastClientCursorHadFooter; /* as sent to java client */
    int LastClientCursorOnPage;     /* as sent to java client */
	bool LastClientCursorGeObjSelected; /* as sent to java client */
	bool LastClientCursorSsObjSelected; /* as sent to java client */
	bool LastClientCursorWpObjSelected; /* as sent to java client */
    int LastClientCursorColCount;   /* todo !!0 */
    int LastClientCursorColFirst;   /* todo !!0 */
    int LastClientCursorColLast;    /* todo !!0 */

    wp_char_attr_flags prevCharAttrsMask;
    wp_char_attr_flags prevCharAttrsInMask;
    wp_char_attrs prevCharAttrs;
    wp_para_attr_flags prevParaAttrsMask;
    wp_para_attr_flags prevParaAttrsInMask;
    wp_para_attrs prevParaAttrs;
    int prevBorderType;
    wp_border_attr_flags prevBorderAttrsMask;
    wp_border_attr_flags prevBorderAttrsInMask;
    wp_border_attrs prevBorderAttrs;
    mbchar *prevStyleName;

    bool frameSelected;     /* only meaningfull if WpHaveSelection() */
    wp_range selectedFrame; /* valid only during move */
    bool newFrameInProgress;    /* if TRUE, user interaction for bounding box */
    int minFrameWidth;          /*Minimum allowed width for frame being resized*/
    int mouseDownInTableCol;    /* while stroking */
    bool mouseOutOfCell;    /* TRUE -> mouse dragged out of original cell */
    int mouseDownXPlace;    /* for selecting big (graphic) gobs */
    int mouseDownYPlace;    /* for selecting big (graphic) gobs */

    long timeOfButtonClick; /* used for double clicking selection timing */
    bool clickIsDouble;     /* used for double clicking selection timing */
    wp_location mouseDownLocation;  /* only meaningfull during a stroke */
    wp_range mousePrevRange;    /* Range of previous special selection */
    int prevColSelectionCount;  /* Cols sel'd in previous special selection */
    int mousePrevType;          /* WP_SELECT_CHAR, _WORD, etc. */
    int mousePickSensitivePix;  /*pix tolerance for setting frame/cell/.. drag*/
    int mouseMoveSensitivePix;  /* num pix before considered move */
    bool mouseButtonIsDown;     /* TRUE if Button1 pressed */
    bool strokeInProgress;      /* TRUE if moved <n> pix after button down */
    urect_t *dragURectP;        /* urect the button went down in */
    urect_t *dragCellURectP;    /* urect during table drag operations */
    int dragCellColumnNum;      /* column num during drag */
    int dragStatus;             /* for frame dragging, cell resize, ... */
    int dragXStart;             /* button down location in doc pixels */
    int dragYStart;             /* button down location in doc pixels */
    int dragStartDsXoffset;     /* wpP->DsXoffset value at button down time */
    int dragStartDsYoffset;     /* wpP->DsYoffset value at button down time */

    int stickyX;            /* sticky cursor for up/down arrows (-1 for none) */
    int cursorX, cursorY;   	/* window relative, adjusted. See DsDrawCursor*/
    int cursorWidth, cursorHeight;  /* size of area covered by cursor */
    bool cursorOnDisplay;   	/* TRUE after draw, FLASE after undraw */
    XImage *cursorImage;    	/* material that was under the cursor */
	struct {
		int xpix;					/* x pixels of cursor's gob, screen		  */
		int ypix;					/* y									  */
		int xpixpage;				/* x pixels, page						  */
		int ypixpage;				/* y pixels, page						  */
		int xpixdoc;				/* x pixels, doc						  */
		int ypixdoc;				/* y pixels, doc						  */
	} cursorGobInfo;
    int objSelectX, objSelectY;     /* doc based x, y of selected graphic obj */
    int objSelectWidth, objSelectHeight;    /* wid, ht of selected graphic obj*/
    bool objSelected;               /* TRUE if handles drawn */


/* GRAPHICS HANDLE CACHE */

    unsigned int currentGraphicsHandleCacheId;  /*last graphics handle cache id*/
    ds_ge_handle_cache_t *dsGraphicsHandleCache;
    int dsGraphicsHandleCacheSize;


/* FONTS, MEASUREMENTS, CONVERSIONS */

    wp_char_attrs *fontsUsed;   /* fonts actually realized in doc */
    int numFontsUsed;           /* size of fontsUsed array */
    XFontStruct **idFontsUsed;          /* parallel screen font id array */
    unsigned long *fontKickOutCounter;  /* when last updated idFontsUsed */
    targetFontMetrics **tmFontsUsed; /* parallel target metrics ptrs */
    unsigned long *tmKickOutCounter; /* for tmFontsUsed kickout detect */
    int *partialWidths;     /* character spans (in dsfonts.c) */
    int numPartialWidths;   /* size of partailWidths (in dsfonts.c) */
    int tmMilHt, tmPixHt;   /* From TmDchar() ... for conversions */
    int tmMilWd, tmPixWd;   /* Companions to above */


/* PRINTING */

    bool printing;              /* TRUE if started for printing */
    int printerDevice;          /* printer class for measurement... */
    wpchar printerClass[STRNORMAL+1]; /* eg "PostScript" / "PCL5" */
    wpchar printerType[STRNORMAL+1];  /* eg "HP3SI523.PPD" / "LaserJet4" */
    bool deferRendering;        /* Set by printing logic while formatting */


/* COLORS */

    int numColors;          /* number of color definitions in color table */
    wp_color_t *colorTable; /* array of color definitions */


/* ENTRY FIELD SHADING */

    wp_shading_attrs entryFldShading;
    bool entryFldSentToJava; /* entry field info has been sent already to
                                Java client */

/* TABLES */

    unsigned long tableIdCounter; /* Used in Row Beads - unique per table */


/* LINKS/OBJECTS */

    bool docMayNeedLinkPoll;/* TRUE after first link/object inserted */
    bool isChildObject;     /* this WP is a child doc (object) */
    bool isChildLink;       /* this WP is a child doc (link) */
    mbchar *childName;      /* name in parent doc/object */
    mbchar *parentName;     /* parent doc/object */
    mbchar *parentDocName;  /* parent _document_ */
    mbchar *actualDocName;  /* actual doc (different if this WP is tempfile) */
    int *hasLinksP;
    doc_links_info_t *docLinksP;
    mbchar *linksServicesSaveFile;
    byte *hooks;            /* ELF array of hook classes and macros */


/* CURRENT INDICES */

    int currentHdrFtrNum;       /* for unique hdr/ftr names */
    int currentFootnoteNum;     /* for unique footnote names */
    int currentInsetNum;        /* for unique inset names */


/* FORMATTER */

    int  FmWidth;               /* maximum page width in doc (for scroll bars)*/
    long FmHeight;              /* total galley height (for scroll bars) */
    int  FmNumPages;            /* number of pages in doc */
    struct page_t *FmPages;     /* array of pages in doc */
    int  FmStopAtBead;          /* frame/footnote doesn't fit on page */
    int  FmNumWorkItems;        /* number of pending work items */
    fm_work_item_t *FmWorkItems;  /* array of pending work items */
    int  startDirty;            /* start of FmBeadsChanged affected area */
    int  endDirty;              /* end of FmBeadsChanged affected area */
    bool FmQuickBackGroundWork; /* TRUE if quick page formatting needed in bg */
    bool FmBackGroundWork;      /* TRUE if formatting needed in background */
    bool FmEmulate21;           /*emulate Aster*x 2.1 tabs/formatting behavior*/
    int  FmHyphMethod;          /* HYPH_NONE, _DICT, _CALC, _DICT_CALC */
    unsigned                    /*Bools faster? Faster enough to change this? */
        FmWrapTabs : 1,         /* Whether Tabs wrap to next line             */
        FmWrapSpaces : 1;       /* Whether spaces wrap                        */
    bool FmCleanBackGroundFormatNeeded; /* To force Clean formatting in bkgd  */
                                        /* (118354)                           */

/* FORMATTER HEADING ROW INFO CACHE */

    int FmNumHeadingRowInfo;
    fm_row_info_t *FmHeadingRowInfo;    /* array of info; freed only if dirty */


/* QUICK FORMAT (during typing) */

    int FmNumQuickFormatLines;
    int FmNumQuickFormatLinesAlloced;
    int *FmQuickFormatPageIndex;
    int *FmQuickFormatRectIndex;
    int *FmQuickFormatURectIndex;
    int *FmQuickFormatLineIndex;
    bool *FmTypingInFirstWord;      /* TRUE if typing in first word on line */
    bool *FmQuickFormattingPrevLine;/*TRUE if starting with line before cursor*/
    wp_location *FmQuickFormatLocation;

    bool FmQuickFormatDidSomething; /* helps control mainloop timer */

	long JavaWPKeysSerialNum;


/* FORMATTER LINE CACHE */

    bool FmLineCacheActive;         /* If TRUE, FmCleanLine adds to cache 	  */
    int FmLineCacheRevNum;          /* Bead rev num when cache created 		  */
    int FmLineCacheNumSlots;        /* Number of slots in cache array 		  */
    fm_line_cache_t **FmLineCache;  /* The line cache 						  */
	char *FmLineCachePoolP;			/* line cache's memory pool				  */

/* RULER */

    int rulerRev;           /* beadRev when ruler was last updated */
    wp_range rulerLoc;      /* cursor location ruler is displaying */
    int rulerHorizScroll;   /* amount of horizontal scroll in pixels */
    int rulerFirstIndent;   /* (in mils) */
    int rulerLeftIndent;    /* (in mils) */
    int rulerLevelIndent;   /* part of above indents due to level (in mils) */
    int rulerRightIndent;   /* as last displayed (in mils) */
    int rulerPixFirstIndent;    /* pixel pos in widget */
    int rulerPixLeftIndent; /* pixel pos in widget */
    int rulerPixRightIndent;    /* pixel pos in widget */
    int rulerPixLeftRectEdge;
    int rulerPixRightRectEdge;
    int rulerMode;  /* showing indents, section margins, or cell margins */
#if ALLOW_JAVA_WP
    int lastJavaRulerMode; /* last JV_SET_RULER_MODE sent to Java client */
#endif
    int rulerPixLeftMargin; /* offset from left of page to content */
    int rulerPixRightMargin; /* offset from left of page to right margin
                                (including binding margin, if any) */
    int rulerColumnCount;   /* number of columns in section */
    int rulerPixGutter;     /* width of gutter between columns */
    int rowStartBead;       /* if in a table, this is bead of start of row,
                            otherwise it is zero. */
    struct RulerTableInfo {
        int cellCount;  /* number of cells in current row */
        int leftEdge;       /* left edge of table, in mils */
        struct RulerCellInfo {
            int width;  /* in mils */
            int leftMargin; /* in mils */
            int rightMargin;    /* in mils */
        } cell[1]; /* array of info for each cell */
    } *rowInfoP;
    RWState *rulerState;
    int rulerLocInFrame; /* TRUE iff cursor or selection start is in a frame */
    int rulerPixFrameLeft; /* left edge of frame in pixels */
    int rulerPixFrameRight; /* right edge of frame in pixels */
    wchar decimalTabChar;   /* char for decimal tabs inserted on ruler */
    int rulerZoom;  /* zoom factor, as displayed on ruler */
    int rulerZeroAtPageEdge; /* if TRUE, ruler zero is left edge of
                            page, otherwise ruler zero is at section
                            left margin when displaying tabs and indents,
                            and at page edge when displaying margins.
                            This is set by a profile item */
    int rulerParaBeadRev; /* rev of para bead when ruler was last updated */
    int rulerSize;      /* text size, as indicated by rulere */
    mbchar *rulerFace;  /* Font face name as indicated by ruler */


/* STATUS LINE */

    wpStatus status;        /* current status, used in status line display */
    bool helpModeCanCursor; /* TRUE iff allowed to cursor & navigate in Help */
    bool haveTempStatusMsg; /* TRUE if temp msg being displayed */
    bool haveUserStatusMsg; /* TRUE if temp msg being displayed from ELF */

/* MENU */

    mbchar *menuStatusCallback;  /* macro to call for unresolved menu status */


/* EQUATION EDITING */

    int eqnEditing;     /* TRUE if running as equation editor */

/* HTML AUTHORING */

    int htmlEditing;    /* HTML_MODE_NONE, _EDIT, _VIEW */
    bool viewHTMLtags;      /* unknown HTML tags */


/* HELP MODE */

    int helpMode;       /* TRUE if running as Help server */


/* FORM MODE */

    int formMode;       /* TRUE if running in form mode */
    bool strictFormLocking;     /* TRUE: cursor must be in Cell or Entry fld */


/* MACRO EDITING */

    int macroEditing;   /* TRUE iff macro editor is running */
    int compilationErrors;
    bool dbgMode;   /* TRUE if running as debugger */
    AXWidget dbgBreakWidget;
    AXWidget dbgContWidget;
    AXWidget dbgSlowWidget;
    AXWidget dbgStepWidget;
    AXWidget dbgNextWidget;
    AXWidget dbgPrintWidget;
    AXWidget dbgWhereWidget;
    AXWidget dbgUpWidget;
    AXWidget dbgDownWidget;
    AXWidget dbgClearWidget;
    AXWidget dbgClrallWidget;
    AXWidget dbgStatusWidget;
    AXWidget dbgRunWidget;
    AXWidget dbgQuitWidget;
    AXWidget dbgHelpWidget;
    AXWidget dbgLogWidget;
    AXWidget dbgErrorWidget;
    int macroTask;      /* task under debug */
    int dbgSlowMode;    /* TRUE while the slow motion button is down */
    int dbgUpDownLevel; /* Current level for Up/Down buttons */
    char **dbgLogStrs;
    int dbgNumDebugLogStrs;
    char *dbgDocumentName;  /* Absolutified version of wpP->documentName */


#if BUILD_ORIENT
    wp_char_attrs XimEntryAttrs;
    int start_conv_bead;
    int start_conv_offset;
    int end_conv_offset;
    int start_phrase_offset;
    int end_phrase_offset;
    int save_underline;
    mbchar *save_face;
#endif

    int macroEditingLicType;    /* Holds type of license which was checked */
                                /* out for the macro editing session */

    /* NULL or points to array of beads numbers for document file lines.
     * (Used to compute change bars) */
    struct WpBeadLine {
        int size;       /* of bead array */
        int lastLine;   /* last line number */
        int bead[1];    /* bead[x] is bead associated with line x of
                        file. array is resizable. */
    } *beadOfLine;

/* EXECUTION */

    int specialPasteHack; /* One of WP_PASTE_XXXX - special behavior needed from
                            low-level utilities during Paste operation */

                            /* Hack (almost) to detect dependency on whether  */
                            /* wp structure is between docs. rjd 23IX96       */
    char phase;             /* 2 => set on entry to WpReadMainDoc             */
                            /* 3 => set on exit from WpReadMainDoc			  */
	bool oktoDsUpdate;	  /*FALSE: FmCleanAndFormatPage omits calling DsUpdate*/
							/* See FmDoBackGroundWork						  */

/* DEBUGGING */

            /* This controls built-in debugging tools for the WP              */

        /*  xsynchronize                                                      */
        /*                                                                    */
        /*    Normally 0. If = 1, WPthimble calls XSynchronize.               */
        /*                                                                    */
        /*  readfromlinecache                                                 */
        /*                                                                    */
        /*    Normally 1.  If = 0, FmLineFromCache will not search the        */
        /*     line cache, but all other line-cache operations proceed.       */

    unsigned
        checkMemory : 1,    /* WP_DEBUG_CHECK_MEMORY                          */
        docValid : 1,       /* WP_DEBUG_DOC_VALID                             */
        xsynchronize : 1,   /* WP_DEBUG_XSYNCHRONIZE whether to call          */
                            /* xsynchronize in WPthimble                      */
        readfromlinecache: 1;/*whether to read lines from cache in FmFormatLin*/

    short debugEventCounter;  /* detect when a complete operation occurred    */

} wp_global_data;



/****************************************************************************/
/*                              PROTOTYPES                                  */
/****************************************************************************/

/* This global is going away. In the interim, those who need it must define
    the extern themselves (the global is now WPGLOBAL - see wpmain.c) */
#if 0               
#if !WP_EXTERNAL_CONSUMER
extern wp_global_data WP;
#endif
#endif

/* WP Function prototypes are now in wpproto.h */
#include <wpproto.h>

#include <ds.h>
#include <fm.h>

extern DLL_IMPORT Display *Dpy;
extern DLL_IMPORT Pixmap ScratchMap;

extern DLL_IMPORT int8 WpBasicSizes[];

#include <wpfuncs.h>

#endif  /* WP_H  */

