/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: wpproto.h
   Applix ASC version: 60
   Date: Mon Nov 16 13:54:26 1998
*/
#ifndef WPPROTO_INCL
#define WPPROTO_INCL

/*** From wp.h: ***/

#if AX_X11
extern void WPXEvent AXP_((XEvent *eventP));
#endif
#if AX_GDI
extern void WpVScrollValueChanged AXP_((void));
extern void WpHScrollValueChanged AXP_((void));
#endif
extern void WpWindowReFramed AXP_((int pixWidth, int pixHeight));
extern void WpTalkToElf AXP_((void));
extern bool WpLocLessThanLoc AXP_((register wp_location *l, register wp_location *g));
extern bool WpLocLessOrEqualToLoc AXP_((register wp_location *l, register wp_location *g));
extern bool WpLocEqualToLoc AXP_((register wp_location *l, register wp_location *g));
extern void WpConvertLocToNormal AXP_((register wp_location *loc));
extern bool WpLocInRange AXP_((register wp_location *loc, register wp_range *r));
extern bool WpRangeEqualToRange AXP_((register wp_range *r1, register wp_range *r2));
extern void WpButtonUp AXP_((int x, int y));
extern void WpMouseDrag AXP_((int x, int y));
extern bool WpHaveSelection AXP_((void));
extern typeErr WpReadAsciiDoc AXP_((void));
extern bool WPRangesIntersect AXP_((register wp_range *r1, register wp_range *r2, register wp_range *rOut));
#if 0
extern wp_global_data WP;
#endif
extern void WPthimble AXP_((int argc, char *argv[]));
extern void WPInsertCharAtCursor AXP_((int ch));
extern void WPAsserter AXP_((char *file, int line));
extern void WPThrowError AXP_((int code, char *str, char *object));
extern int WPCmdStatus AXP_((char *name, int timeUID, int toggle_state_too, register int cmd));
extern void WpLegalizeRange AXP_((wp_range *r));
extern void WPInsertWCharAtCursor AXP_ ((int ch));
extern void WpEraseBackward AXP_((void));
extern void WpInsertParagraph AXP_((void));
extern void WpUndoStart AXP_((char *type));
extern void WpUndoEnd AXP_((char *type));
extern void WpUndoClear AXP_((void));
extern typeErr WpUndo AXP_((void));
extern typeErr WpRedo AXP_((void));
extern void WpUndoInfo AXP_((int type,int bead));
extern void WpInsertFrame AXP_((wp_frame_attrs *frameAttrsP));
extern void WpFormatFrame AXP_((wp_frame_attrs *frameAttrsP));
extern void WpInsertTable AXP_((int numRows, int numColumns, int columnWidth, int heightType, int height, int leftMargin, int rightMargin, int topMargin, int bottomMargin, wp_location *loc));
extern int WpInsertColumnBreak AXP_((void));
extern int WpInsertPageBreak AXP_((ed_page_break *pageBreakP));
extern void WpInsertFootnote AXP_((int footnoteType));
extern void WpCut AXP_((void));
extern void WpCopy AXP_((void));
extern void WpPaste AXP_((void));
extern void WpDelete AXP_((void));
extern void WpInsertWTextAtCursor AXP_((wpchar *str));
extern int edBeadEnd AXP_((int n));
extern void EdAddBeadsToDoc AXP_((ed_bead *targetNode, bool before, ed_bead *firstBead, ed_bead *lastBead));
extern void EdDeleteBeadsFromDoc AXP_((ed_bead *firstBead, ed_bead *lastBead));
extern void EdBeadFree AXP_((ed_bead *bead));
extern bool EdFindSimple AXP_((wpchar *text, bool exactC, bool wholeW));
extern void EdReplaceSimple AXP_((wpchar *text));
extern bool EdFindReplaceSimple AXP_((wpchar *findText, bool exactC, bool wholeW, wpchar *replaceText));
extern bool EdFind AXP_((ed_bead *searchBeads, wp_range *select, wp_range *searchRange, bool fwdFlag, bool exactC, bool wholeW, wp_range *found));
extern bool EdFindWord AXP_((wp_location *loc, bool incSpace, wp_range *found));
extern wpchar EdAtLoc AXP_((wp_location *loc, int *class));
extern bool EdNextLoc AXP_((wp_location *loc));
extern wpchar EdAtNextLoc AXP_((wp_location *loc, register int *class));
extern bool EdPrevLoc AXP_((wp_location *loc));
extern void EdInitNode AXP_((ed_bead *node));
extern void EDFuncRenumber AXP_((ed_bead *start, ed_bead *end, bool insertFlag));
extern int EdCountNodes AXP_((ed_bead *start, ed_bead *end));
extern void EDNodeAdd AXP_((int targetNode, bool before, ed_bead *firstBead, ed_bead *lastBead, int context));
extern void EdAddMarkerPair AXP_((ed_bead *startMarker, ed_bead *startBefore, ed_bead *endMarker, ed_bead *endAfter, bool noSpan, int context));
extern void EDNodeBuildSpans AXP_((ed_bead *start));
extern void EDNodeDelete AXP_((int start, int end, int context));
extern void EdRemoveMarkerPair AXP_((ed_bead *start, int context));
extern void EdBeadsWillChange AXP_((ed_bead *firstBead, ed_bead *lastBead));
extern void EdRegenerateDocSpans AXP_((void));
extern void EdDemolishSpans AXP_((ed_bead *start, ed_bead *end));
extern void EdDump AXP_((void));
extern void EdReport AXP_((ed_bead *beads));
extern void EdReportRange AXP_((wp_range *range));
extern void EdReportLoc AXP_((wp_location *loc));
extern typeErr EdPaste AXP_((wp_location *pnt));
extern typeErr EdCut AXP_((wp_range *range));
extern typeErr EdInsertParagraph AXP_((wp_location *loc,wp_location *bestCursor));
extern typeErr EdCopy AXP_((wp_range *range));
extern typeErr EdDelete AXP_((wp_range *range));
extern typeErr EdInsertText AXP_((wp_range *range, wpchar *text));
extern void EDtester AXP_((void));
extern ed_bead *EDBeadAlloc AXP_((int class));
extern ed_bead *EDBeadAllocText AXP_((mbchar *buf));
extern ed_bead *EDBeadAllocMbText AXP_((mbchar *buf));
extern ed_bead *EDBeadAllocWText AXP_((wchar *wbuf));
extern int EdBeadSize AXP_((ed_bead *bead));
extern int EdGetMatchingMarker AXP_((int node));
extern int EdGetStartMarker AXP_((int bead));
extern int EdGetSectionOfBead AXP_((int bead));
extern void EdBeadCreateDoc AXP_((void));
extern ed_bead *EdBeadCopy AXP_((int oldBead));
extern ed_bead *EdStringCopy AXP_((ed_bead *start, ed_bead *end));
extern ed_bead *EdGetLastNode AXP_((ed_bead *firstBead));
extern void EdFlushClipboard AXP_((void));
extern void EdFillClipboard AXP_((ed_bead *start, ed_bead *end));
extern int EdTrueBeadSize AXP_((ed_bead *beadP));
extern wchar *edGetRawText AXP_((wp_range *rng,bool wantValue,bool evalAsYouGo));
extern void edDeleteSomeBeads AXP_((int bead,int count));
extern int EdEvaluateField AXP_((int bead));
extern bool edFindInSentence AXP_((wp_location *loc));
extern bool edFindInPara AXP_((wp_location *loc));
extern void edSuggestCursor AXP_((wp_location *loc));
extern void edDeleteBeforeInsert AXP_((wp_range *range, wp_location *loc));
extern void edDeleteRange AXP_((wp_range *range, wp_location *loc));
extern void edSplitText AXP_((wp_location *loc));
extern void edMergeTextBeads AXP_((int loc));
extern void edCalcTextAtts AXP_((ed_bead *bP));
extern void edBeadResize AXP_((int node, int newsize));
extern void edDeleteText AXP_((int beadno, int offset1, int offset2));
extern void edNormalizeRange AXP_((wp_range *range));
extern ed_bead *edCopyToBuffer AXP_((wp_range *range));
extern ed_bead *edCopyBuffer AXP_((ed_bead *buffer));
extern void edPasteBuffer AXP_((wp_location *loc, ed_bead *buffer));
extern void edHammerFmt AXP_((void));
extern int edFindBeadType AXP_((wp_location *loc, int type, int forward));
extern void edInsertTextInBead AXP_((wp_location *loc, wpchar *text));
extern ed_bead *edCreateClipboard AXP_((void));
extern bool edClipboardMaterial AXP_((ed_bead **start, ed_bead **end));
extern void edSplitStartAndEndBeads AXP_((wp_range *range));
extern void edSplitBead AXP_((wp_location *loc));
extern ed_bead *edNormalizeTextBeadSize AXP_((ed_bead *beadP));
extern void WpUndoInfo AXP_((int type,int bead));
extern ed_bead *edCopyBead AXP_((ed_bead *p));
extern void edReplaceBead AXP_((int bead,ed_bead *beadP));
extern void edDeleteBead AXP_((int bead));
extern void edCopyRangeToClipBoard AXP_((wp_range *range,int clipbead));
extern void EdInsertBeads AXP_((int beforeHere,int count,int start));
extern void edInsertBead AXP_((int before,ed_bead *beadP));
extern int edFindClipboard AXP_((int type));
extern void edInsertSomeBeads AXP_((int before,ed_bead **arrP));
extern void EdDeleteTabInRange AXP_((int pos,wp_range *rng));
extern typeErr EdInsertTabInRange AXP_((int pos, int type, wchar decimalChar, wchar * leaderStr, wp_range *rng));
extern int EdTrySearchForBeadType AXP_((int bead,int type,int endbead));
extern int edSizeFromClass AXP_((int class));
extern void FmShiftBeadRefs AXP_((int cnt,int bead));
extern int EdSearchForBeadType AXP_((int bead,int type));
extern int DsBeadFontHeight AXP_((int bead,int *ascent));
extern int DsBeadCharsWidth AXP_((char *str,int bead,int len));
extern void DsResolveBeadFont AXP_((int bead));
extern int WpFindAttsInTable AXP_((wp_char_attrs *findP));
extern void WpMergeAttrs AXP_((wp_char_attrs *newAttsP,wp_char_attr_flags mask,wp_char_attrs *parentP));
extern int DsCharsWidth AXP_((char *chars,XFontStruct *font, int len));
wchar *FmBeadTextFitWidth AXP_((wchar *str,int width,int bead,int *charsUsedP));
extern void WpGetAllFonts AXP_((void));
extern typeErr EdApplyAttrs AXP_((wp_range *range,wp_char_attrs *attrsP,wp_char_attr_flags mask));
extern void WpApplyAttrs AXP_((wp_char_attr_flags mask,wp_char_attrs *atts));
extern bool WpBeadIsFirstOfPara AXP_((int bead));
extern void WpResolveTextAttrs AXP_((wp_char_attrs *attrsT,int bead));
extern void WpResolveParaAttrs AXP_((wp_para_attrs *attrsP,int bead));
extern bool WpResolveFrameAttrs AXP_((wp_frame_attrs *frameAttrsP, int bead));
extern void WpMergeParaAttrs AXP_((wp_para_attrs *newAttsP,wp_para_attr_flags mask,wp_para_attrs *parentP));
extern FILE *AxLogFp;
extern void WpLegalizeLoc AXP_((wp_location *l));
extern void WpDumpOne AXP_((int bead));
extern int WpDumpRange AXP_((int start,int end));
extern void WpDumpAll AXP_((void));
extern int WpFindFirstBeadOfPara AXP_((int bead));
extern int WpFindFirstBeadOfSection AXP_((int bead));
extern bool EdSameFrameAttrs AXP_((int para1, int para2));
extern int EdFindFirstParaOfFrame AXP_((int para));
extern int EdFindLastParaOfFrame AXP_((int para));
extern bool WpFrameAttrsAtCursor AXP_((wp_frame_attrs *frameAttrsP));
extern void WpSendPokeIfCursorHasChanged AXP_((void));
extern bool WpGetSelection AXP_((int num,wp_range *range));
extern bool WPGetSelectedCell AXP_((int num,bool includeCellEnd,wp_range *range));
extern int WpNumSelections AXP_((bool rows));
extern void WpSetSelectionMarkers AXP_((wpchar *name,bool rows,bool includeCellEnd));
extern bool WpGetSelectionMarkers AXP_((wpchar *name,int num,wp_range *range));
extern void WpDeleteSelectionMarkers AXP_((wpchar *name));
extern int WpNumCellsInRow AXP_((int bead));
extern int WpRowNumOfBead AXP_((int bead));
extern void WpResetTextAttrs AXP_ ((int start,int end));
extern void EdChangeParaLevel AXP_ ((wp_range *r,int increment,int indentIt));
extern char *WpNthArgInField AXP_((char *argsP,int n));
extern void WpUpdateHdrFtrInheritance AXP_((int sect));
extern int EdCreateHdrFtr AXP_((void));
extern void EdGenerateHdrFtrName AXP_((wpchar *name));


/*** From ds.h: ***/

extern void DsMoveCursorToTopOfScreen AXP_((void));
extern void DsMoveCursorUp1 AXP_((void));
extern void DsMoveCursorDown1 AXP_((void));
extern void DsMoveCursorRight1 AXP_((void));
extern void DsMoveCursorLeft1 AXP_((void));
extern bool DsRightAdjustCursorToLegalBead AXP_((void));
extern bool DsGetLocationFromXY AXP_((wp_location *locP, int x, int y));
extern gob_t *DsGetGobFromXY AXP_((int x, int y, bool flowOnly));
extern void DsRedrawScreen AXP_((void));
extern void DsInitScreen AXP_((int width, int height));
extern void DsExpose AXP_((int x, int y, int width, int height));
extern void DsExposePage AXP_((page_t *dspP, int x, int y, int width, int height));
extern void DsDrawGob AXP_((gob_t *gobP));
extern bool DsPageOnScreen AXP_((page_t *dsPageP));
extern bool DsLineOnScreen AXP_((line_t *dsLineP));
extern bool DsCoordsIntersect AXP_((register int x1, register int y1, register int w1, register int h1, register int x2, register int y2, register int w2, register int h2));
extern void DsPageUp AXP_((void));
extern void DsPageDown AXP_((void));
extern void DsFirstPage AXP_((void));
extern void DsLastPage AXP_((void));
extern bool DsUpdate AXP_((page_t *fmPageP));
extern page_t *DsPageFromCache AXP_((page_t *fmPageP));
extern void DsExposeNewPage AXP_((page_t *dsOldPageP, page_t *dsNewpageP));
extern void DsCreateWindow AXP_((int menu_id,int width,int height));
extern void DsModifyVScroll AXP_((void));
extern void DsModifyHScroll AXP_((void));
extern void DsUnDrawUnaryCursor AXP_((void));
extern void DsDrawCursor AXP_((void));
extern void CreateWindowX11 AXP_((int menu_id,int width,int height));
extern void DsQuickUpdate AXP_((line_t *oldLineP, line_t *newLineP));

extern void DsConvertPageCoords AXP_((page_t *pageP));

extern bool DsConvertRectCoords AXP_((rect_t *rectP));
extern bool DsConvertURectCoords AXP_((urect_t *urectP));

extern void DsConvertLineCoords AXP_((line_t *lineP));
extern void DsDisplayLocation AXP_((wp_location *locP, int xpos));
extern void DsDisplayFormatterLine AXP_((line_t *lineP));
extern rect_t *DsRectFromLocation AXP_((wp_location *locP));
extern rect_t *DsRectFromXY AXP_((int x, int y));
extern urect_t *DsURectFromXY AXP_((int x, int y));
extern void WpAddNamedMark AXP_((char *name, int bead, int offset));
extern wp_mark_t *WpGetNamedMark AXP_((char *name));
extern void WpDeleteNamedMark AXP_((char *name));
extern line_t *DsBestLineForFrame AXP_((int x, int y, int bead));

extern void WpSwitchToFile AXP_((char *newFile,wp_global_data *wpP));
extern typeErr WpReadDoc AXP_((wp_global_data *wpP));
extern typeErr WpReadDocFile AXP_((char *name,wp_global_data *wpP));
extern typeErr wpDocReader AXP_((bool justStyle,wp_global_data *wpP));
extern typeErr wpReadEngine AXP_((bool justStyle,wp_global_data *wpP,char *pathname));
extern void WpCheckBeads AXP_((wp_global_data *wpP));
extern void EdSetSectionDefaults AXP_((ed_bead *beadP,wp_global_data *wpP));
extern void WpUpdateCurrentHdrFtrNum AXP_((wpchar *name, wp_global_data *wpP));


/*** From fm.h: ***/

extern int FmFirstFlowRectIndex AXP_((page_t *pageP));
extern int FmLastFlowRectIndex AXP_((page_t *pageP));
extern rect_t *FmFirstFlowRect AXP_((page_t *pageP));
extern rect_t *FmLastFlowRect AXP_((page_t *pageP));
extern rect_t *FmFrameRectFromBead AXP_((page_t *pageP, int frameBead));
extern rect_t *FmLastMainFlowFrameRect AXP_((page_t *pageP));
extern rect_t *FmFirstFootnoteRect AXP_((page_t *pageP));
extern rect_t *FmLastFootnoteRect AXP_((page_t *pageP));
extern rect_t *FmFootnoteRectFromBead AXP_((page_t *pageP, int fnRefStartBead));
extern rect_t *FmContFootnoteRect AXP_((page_t *pageP, int fnRefStartBead));
extern rect_t *FmLastEndDocFootnoteRect AXP_((page_t *pageP));
extern rect_t *FmEndDocFootnoteRectFromBead AXP_((page_t *pageP, int fnRefStartBead));
rect_t *FmContEndDocFootnoteRect AXP_((page_t *pageP, rect_t *fnrectP));
extern rect_t *FmFootnoteBarRect AXP_((page_t *pageP, int type));
extern rect_t *FmHeaderRect AXP_((page_t *pageP));
extern rect_t *FmFooterRect AXP_((page_t *pageP));
extern void FmUpdateRectBackPtrs AXP_((page_t *pageP));
extern void FmUpdateURectBackPtrs AXP_((rect_t *rectP));
extern void FmUpdateLineBackPtrs AXP_((urect_t *urectP));
extern void FmInitFormat AXP_((void));
extern void FmBeadsChanged AXP_((int start, int end));
extern void FmDoBackGroundWork AXP_((void));
extern void FmCopyPage AXP_((page_t *srcPageP, page_t *destPageP));
extern void FmCopyRects AXP_((page_t *srcPageP, page_t *destPageP));
extern void FmCopyURects AXP_((rect_t *srcRectP, rect_t *destRectP));
extern void FmCopyLines AXP_((urect_t *srcURectP, urect_t *destURectP));
extern void FmCopyLine AXP_((line_t *srcLineP, line_t *destLineP));
extern void FmCleanPage AXP_((page_t *pageP));
extern void FmCleanAllRects AXP_((page_t *pageP));
extern void FmCleanRect AXP_((rect_t *rectP));
extern void FmCleanURect AXP_((urect_t *urectP));
extern void FmCleanLine AXP_((line_t *lineP));
extern void FmCleanGob AXP_((gob_t *gobP));
extern void FmDestroyRects AXP_((page_t *pageP, int startix, int numRectsToDestroy));
extern void FmDestroyURects AXP_((rect_t *rectP, int startix, int numURectsToDestroy));
extern void FmDestroyFlowRects AXP_((page_t *pageP));
extern void FmDestroyLines AXP_((urect_t *urectP, int startix, int numLinesToDestroy));
extern void FmDestroyGobs AXP_((line_t *lineP, int startix, int numGobsToDestroy));
extern void FmFormatDoc AXP_((void));
extern int FmFormatPage AXP_((page_t *pageP));
extern int FmFormatRect AXP_((rect_t *rectP));
extern int FmFormatURect AXP_((urect_t *urectP));
extern int FmFormatLine AXP_((line_t *lineP));

extern void FmQuickFormat AXP_((line_t *fmLineP, line_t *dsLineP, wp_location *startLocP));
extern rect_t *FmRectFromLocation AXP_((wp_location *locP));
extern urect_t *FmURectFromLocation AXP_((wp_location *locP));
extern line_t *FmLineFromLocation AXP_((wp_location *locP));
extern rect_t * FmAddFootnoteRect AXP_((page_t *pageP, int fnRefStartBead));
extern rect_t * FmAddEndDocFootnoteRect AXP_((page_t *pageP, int fnRefStartBead));
extern rect_t *FmAddFrameRect AXP_((page_t *pageP, int frameBead));
extern rect_t *FmAddHeaderRect AXP_((page_t *pageP, int hdrftrBead));
extern rect_t *FmAddFooterRect AXP_((page_t *pageP, int hdrftrBead));
extern rect_t *FmAddFlowRects AXP_((page_t *pageP, int numNewRects));
extern void FmInsertRects AXP_((page_t *pageP, int startix, int numNewRects));
extern void FmInsertURects AXP_((rect_t *rectP, int startix, int numNewURects));
extern int FmPageHeaderBead AXP_((page_t *pageP));
extern int FmPageFooterBead AXP_((page_t *pageP));
extern void FmMoveRect AXP_((rect_t *rectP, int newx, int newy));
extern void FmFormatAllRects AXP_((page_t *pageP));
extern rect_t *FmAddFootnoteBarRect AXP_((page_t *pageP, int type));
extern void FmFootnoteBarGlossaryName AXP_((wpchar *name, int type));
extern int FmFootnoteBarTypeFromGlossary AXP_((int refBead));
extern typeErr WpPrintDocDraw AXP_((void));
extern typeErr WpPrintDocEnd AXP_((void));
extern wp_color_t *WpGetColorFromName AXP_((wpchar *name));
extern int WpGetColorIndexFromName AXP_((wp_global_data *wpP, wpchar *name));
extern mbchar *WpGetColorNameFromIndex AXP_((wp_global_data *wpP, int ix));
extern void WpAddColor AXP_((wp_color_t *colorP));
extern void WpDeleteColor AXP_((wpchar *name));
extern void WpModifyColor AXP_((wpchar *name, wp_color_t *colorP));
extern int WpBrightnessFromColor AXP_((wp_color_t *colorP));
extern mbchar *WpColorName AXP_((wpchar *name));
extern void DsFreePages AXP_((int pagenum));
extern page_t *DsForcePageToCache AXP_((int pagenum));
extern page_t *DsPageFromCache AXP_((page_t *newPageP));
extern void DsCopyArea AXP_((int oldx, int oldy, int width, int height, int newx, int newy));
extern void DsClearArea AXP_((int x, int y, int width, int height));
extern urect_t *FmPreviousCellURect AXP_((urect_t *urectP));
extern urect_t *FmNextCellURect AXP_((urect_t *urectP));
bool FmLineHasHyphenation AXP_((line_t *lineP));
extern void WpUndoEnable AXP_((int switcheroo));
extern typeErr WpReadMainDoc AXP_((void));
extern mbchar *WpStyleName AXP_((char *name));
extern int WpStyleBead AXP_((char *name));
extern void WpVerifySection AXP_((ed_bead *beadP));
extern gob_t *DsGetGobAndLocationFromXY AXP_((wp_location *locP, int x, int y));
mbchar *WpGlossaryName();
mbchar *WpReadColor AXP_((wp_global_data *wpP));
mbchar *DsGetFontNamePtr AXP_((char *str));
mbchar *WpTagName AXP_((wpchar *));
styleInfo *WpGetStyleInfo AXP_((wpchar *hashname));
extern ed_pooled_attrs *EdCreatePooledAttrs();
extern ed_pooled_attrs *EdCopyPooledAttrs();
extern ed_pooled_attrs *EdCopyPooledAttrsReally();
extern ed_pooled_attrs *EdAddPooledAttrs();
extern ed_pooled_attrs *edNormalizePooledParaAttrsSize();
extern ed_pooled_attrs *edNormalizePooledStyleAttrsSize();

/* from dan.h - Piyush 3/9/94 */
extern int EdGenericSearchForBeadType AXP_((register int bead,register int type,register ed_bead **array,register int endbead,register int endclass));
extern int EdTrySearchForVisibleBead AXP_((register int bead,register int type,register int endbead,register int endclass));
extern int EdTrySearchForFlowBead AXP_((register int bead,register int type,register int endbead,register int endclass));
extern int EdSearchBackForBeadType AXP_((register int bead,register int type));
extern int EdTrySearchBackForBeadType AXP_((register int bead,register int type,register int endbead));
extern int EdGenericSearchBackForBeadType AXP_((register int bead,register int type,register ed_bead **array,register int endbead,register int endclass));
extern int EdTrySearchBackForVisibleBead AXP_((register int bead,register int type,register int endbead,register int endclass));
extern int EdTrySearchBackForFlowBead AXP_((register int bead,register int type,register int endbead,register int endclass));
extern bool WpFindRangeOfPara AXP_((register int bead, wp_range *range));
extern int WpFindParaBeadOfPara AXP_((register int bead));
extern int WpNextVisibleBead AXP_((register int bead));
extern int WpPrevVisibleBead AXP_((register int bead));
extern int WpNextBeadInFlow AXP_((register int bead));
extern int WpPrevBeadInFlow AXP_((register int bead));
extern void WpSelectWholeParas AXP_(());
extern void WpPreserveCurrentSelection AXP_((wpchar *name));
extern void WpRestoreCurrentSelection AXP_((wpchar *name));
extern void WpExpandSelectionToEndRow AXP_((wp_range *r));
extern void WpExpandSelectionToStartRow AXP_((wp_range *r));
extern void WpFindNthCellBeads AXP_((register int bead,register int colNum,register int *startP,register int *endP));
extern void WpExpandTableSelection AXP_((wp_range *r));
extern void WpFindBeadsOfCell AXP_((register int cellBead,register int *startP,register int *endP));
extern void WpFindBeadsOfRow AXP_((register int cellBead,register int *startP,register int *endP));
extern int WpCellOfBead AXP_((register int bead));
extern int WpColNumOfBead AXP_((register int bead));
extern int WpRowNumOfBead AXP_((register int bead));
extern bool WpSingleCellSelected AXP_((wp_range *range));
extern void WpProtectLastParaInCell AXP_((wp_range *range));

#endif /* WPPROTO_INCL */
