/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elb.c
   Applix ASC version: 467.48
   Date: Mon Jun 28 21:13:51 1999
*/
#define is_Latin_1(c) ( (unsigned char)(c) != 0 && ( ((unsigned char)(c)<0x7F) || (((unsigned char)(c)) >= 160) || (((unsigned char)(c)) == 0x80) ) )

#if !AXMS
#include <unistd.h>
#include <sys/param.h> /* for MAXHOSTNAMELEN */
#endif
#include <sys/types.h>
#if !AXMS && !M_88K
#include <varargs.h>
#endif
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <errno.h>
#include <sys/stat.h>
#include <axtime.h>

#if AXMS
#include <process.h>    /* for getpid() */
#endif

#if AX_STUB
#include <fcntl.h>
#endif

#include <aos.h>
#include <elf_env.h>
#include <paripc.h>
#include <elipc.h>
#include <elf_strs.h>
#include <editmask.h>

#include <axsocket.h>
#include <adld.h>

#if !AX_STUB && !AXMS
#include <pwd.h>
#endif
#include <scac.h>
#include <adocio.h>
#include <aiconids.h>
#include <xmlib.h>

#include <thimble.h>
#include <datetime.h>
#include <gstyle.h>
#include <elhelper.h>
#include <afile.h>
#include <getstr0.h>
#include <getstr5.h>
#include <getstr6.h>
#include <getstr10.h>
#include <adlgpoke.h>
#include <elf_ins.h>
#include <ax.h>
#include <amenudef.h>
#include <elfnodes.h>
#include <pageform.h>
#include <elrecarg.h>
#include <memblk.h>
#include <eldebug.h>
#include <elcomp.h>
#include <wchars.h>
#include <arghdr.h>
#include <axtrace.h>

#include <elf.h>

#if !BUILD_KANJI
#include <tm1files.h>
#include <tm1util.h>
#endif

#define EPSILON     (1e-150)  
#define MAX_FRDLEN 240      /* smaller than a power of 2 */

#ifndef LOCK_SH
#define LOCK_SH 1
#define LOCK_EX 2
#define LOCK_NB 4
#define LOCK_UN 8
#endif


#if AXMS
#include <basicwin.h>
#define MAXHOSTNAMELEN 64    /* for now */
#define AX_WM_SNAPINIT  (WM_USER+101)

extern int Running_Windows95;
extern int RunningWin95Look;

extern HWND AxTopHWNDNeverMapped;

char *AxNTgetDrive();
void CheckForClipFromMenuBar();
void MakePathWithLongNames( char *doc_path );
data_ptr report_resource_counts();
static int axmsCheckForBatchOutputHeader(FILE*, char*);
extern data_ptr GetWinPrinters(void);
extern HDC GetPrinterHDCfromName(char*);
extern char *DoWinOpenDialog(char*);
extern void WXErrorMessage(mbchar*);
extern void EnumeratePrinterFonts(char*, int*);
#else
extern struct passwd *getpwnam();
#endif

#if DEBUG
#define LOGGER(body)     {if ( ElfbLogging ) ElfbLogger body;}
#else
#define LOGGER(body)
#endif
#define MAX_FILES 10        /* opened by helper logic */


extern char    *AxTempFile(), *AxMFgets();
extern char    *axgfsStartFontManager();
extern char     AxCurrentDir[];
extern char     AxPresTemplateDir[];
extern int      ElfcPatchMode;
extern short	ThimNoSpellingLibrary;
extern char		*ThimSpellingLibraryFilename;

extern int JavaMode;    /* TRUE for Java slaved axmain */
extern int AxLanguage;          /* set in context.c by getenv("AXLANG") */

mbchar *XLT_Complex();

extern int      AxOpenLook;
extern int      SupportsAudio;
extern char     *DirSlash;
extern char     *AxStrflName;

axglobal double PiValue = 3.1415926;

static char    *OpenFiles[MAX_FILES];   /* names of open files */
static FILE    *OpenFps[MAX_FILES]; /* file descriptors */
static int     OpenReadOnly[MAX_FILES]; /* read or read/write */

extern bint     ElfInLearnMode; /* TRUE while in learn mode */
extern char   **AxListFilesInDir();
extern void     AxListFilesFreer();
extern void     TmReloadMenuBar();
extern void     freeErrString();
char           *AGetHomeDir();
char           *AGetUserHomeDir();
AXWidget_dialog XmDlgInWidget();
int             ATMelfReadSourceLine(), ATMelfPostError(), TSTelfPostError();
char           *AxGetStr();

axglobal int    ElfAllowAbort = FALSE;
axglobal int    Logging = FALSE;/* for compiler */
axglobal int    ElfbLogging = FALSE;    /* enables bltins logging */

extern int      ElfLogging; /* interpreter logging */
extern          ElfbSendMes();
extern          ElfbGetMes();
extern          ElfbCallByName(), ElfbNewTask();
extern          ElfbDumpData(), ElfbDoLogging(), ElfbNoLogging();
extern typeErr  ParseDate();
extern typeErr  UPIsLocked();
extern data_ptr NullDataPtr;
extern data_ptr ElfRetData; /* generic func return value */
extern data_ptr ElfCompileArray();
extern data_ptr AxJavaChannelStats();
extern char    *ElfStrPtrRet;
extern          ElfPlayTypeAhead();
extern char    *TrueMalloc();
extern short    THIMpid;
extern char    *ThimCustomDir, *ThimApplixDir, *ThimLangDir, *ThimFiltersDir,
               *ThimClipArtDir, *AxLangDir, *AxLocalLangDir, *AxLangDemosDir,
               *AxDisplayName;
extern char    *ThimPresColorDir, *ThimPresMonoDir, *ThimPresBklitDir;
extern char    *ThimPresOutlineDir, *ThimPresSchemeDir, *ThimPresChartDir;
extern char    *ThimPres35mmDir;
extern short    CellWidDC, CellHtDC, CellUnder;

extern char *ThimEnterpriseDir;
extern char *ThimEnterpriseAppsDir;
extern char *ThimEnterpriseAppFilename;

extern data_ptr AxElfDocHasLinks(), AxElfGetDocLinksInfo();
extern data_ptr AxFilePermissions(),AxfWriteBinaryToFile();
extern data_ptr AxTaskCreateSizedElfString();
extern data_ptr AxTaskCreateElfBinaryWithData(),AxTaskCreateElfBinary(),
                AxfAxNet();
data_ptr AxfFormatDate_Str();
data_ptr AxElfGetLoadedLibInfo();
char *ElfSymbolNameFromId ();

#if BUILD_ORIENT
int OrientIndexCmp();
#endif

typeErr         ErrnoErr(), IsValidPathFilename();
typeErr         docSetupInfo();
char           *FSGenName();
char           *AxCreateTempfile(); /* Needed in ElfbExportDCA() */
extern char    *AxReadFileIntoBuf();

data_ptr ElfCRNLStringToElfStrsArray();
data_ptr ElfStrsArrayToElfCRNLString();
void AddEncryptedPasswordToTable();

#if !(RIOS || PMAX) && !AX_STUB
#if (SYSV4 && SUN4)
char           *TrueRealloc();
#else
char           *TrueRealloc(), *realloc(), *malloc();
#endif
#endif

void    xxxELFDataDumper ();
void xxxDumpELFData ();
void xxxLog ();
data_ptr AxReadODBC_INIFile ();
data_ptr tm1_read_1_line_from_file();

extern wchar *MbToWOneStr();
extern mbchar *WToMbOneStr();
static int ElfSrchDir();

/* Set TRUE if AxfElfbDayArray is to return day numbers with respect to
	year start (i.e. 1-366) rather than month start (1-31). Careful -
	OpenMail uses AxfElfbDayArray too. */
static int day_of_year = FALSE;

/* Other calendar stuff */
#define MAXDAYS		42
#define SPACE		-1
#define THURSDAY	4
#define SATURDAY	6

#define FIRST_MISSING_DAY   639787      /* 3 Sep 1752 */
#define NUMBER_MISSING_DAYS     11      /* 11 day correction */

static int days_in_month[2][13] = {
	{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
	{0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
};

int sep1752[MAXDAYS] = {
	SPACE,	SPACE,	1,	2,	14,	15,	16,
	17,	18,	19,	20,	21,	22,	23,
	24,	25,	26,	27,	28,	29,	30,
	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,
	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,
	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,
}, j_sep1752[MAXDAYS] = {
	SPACE,	SPACE,	245,	246,	258,	259,	260,
	261,	262,	263,	264,	265,	266,	267,
	268,	269,	270,	271,	272,	273,	274,
	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,
	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,
	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,	SPACE,
};

/* leap year -- account for gregorian reformation in 1752 */
#define	leap_year(yr) \
	((yr) <= 1752 ? !((yr) % 4) : \
	!((yr) % 4) && ((yr) % 100) || !((yr) % 400))

#define centuries_since_1700(yr) \
	((yr) > 1700 ? (yr) / 100 - 17 : 0)

#define quad_centuries_since_1700(yr) \
	((yr) > 1600 ? ((yr) - 1600) / 400 : 0)

#define leap_years_since_year_1(yr) \
	((yr) / 4 - centuries_since_1700(yr) + quad_centuries_since_1700(yr))

/* Number of days left in Applixware demo. Zero implies not a demo! */
extern int AxDemoDays;

ElfbNilVal()
{
    ElfRetData = NULL;
}


/*************************************************************************
function: AxfArgsToArray - Convert PASSED args to an array
Note that this only grabs the passed args, NOT the declared args.
Thus if no args are passed, but 5 declared the array size is zero.
The inverse is also true.
*/
data_ptr AxfArgsToArray()
{
    register int    count,ix;
    data_ptr aP;

    count = Elf.curFrame->num_args_passed;
    aP = ELF_CREATE_ARRAY(count);
    for ( ix = 0; ix < count; ix++ )
        WriteArray(aP,ix,ElfDataCopy(
            *((data_ptr *) ((long) Elf.curFrame->argvars[ix] & ~FAULT_BIT))));
    return(aP);
}

/*************************************************************************
function: AxfGetDtmod - Get file's time last moded or 0 if no access
*/
data_ptr AxfGetDtmod(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
    struct stat     status;

    if ( !name[0] )
        return(ELF_CREATE_NUMBER(0.0));

    if (-1 == Astat(name, &status))
        return(ELF_CREATE_NUMBER(0.0));
    else
        return(ELF_CREATE_NUMBER((double)status.st_mtime));
}

/*************************************************************************
function: AxfGetFilesize - Get file's size
*/
data_ptr AxfGetFilesize(argDatum)
data_ptr argDatum;
{
    char           *name = StrFromArgArray(argDatum,0);
    struct stat     status;

    if (-1 == Astat(name, &status))
        return (ELF_CREATE_INTEGER(-1));
    else
        return (ELF_CREATE_NUMBER((double)status.st_size));
}

/*************************************************************************
function: AxfCatchErrors - Enable error catcher
*/
data_ptr AxfCatchErrors()
{
    Elf.curFrame->error_caught = FALSE;
    return(NullDataPtr);
}

/*************************************************************************
function: ElfbGetLiveData - Grab live keystroke
*/
ElfbGetLiveData()
{
    return;         /* OBSOLETE */
}

/*************************************************************************
function: ElfbKillTask - Kill task, wait for it to go away
*/
ElfbKillTask(uid)
    int             uid;    /* task's unique id - not slot number */
{
#if !FOR_TESTER
    int             ix;

    /* Find slot number of task */

start_over:
    for (ix = 0; ix < MAX_PIDS; ix++) {
        if (TaskInfo[ix].in_use && (TaskInfo[ix].uid == uid))
            break;
    }
    if (ix == MAX_PIDS)
        return;
    if (ix == THIMpid)  /* cannot kill self this way */
        return;

    if (!TaskInfo[ix].have_okayed) {
        AxSleepSeconds(0);
        goto start_over;
    }
    if (TaskInfo[ix].in_use) {
        KillTask(ix);
        TaskRecycle();  /* to let schedular's killer to execute */
        goto start_over;/* just to make sure */
    }
#endif
}


/*************************************************************************
function: AxfListTasks - Return array of info about all tasks
*/
data_ptr AxfListTasks(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
        int             fixcase = IntFromArgArray(argDatum,0);
        register data_ptr aP, saP;
        register        int ix, cnt = 0;
        char            str[ELFIDSTR + 1];
        char           *p;
 
        aP = ELF_CREATE_ARRAY(0);
        for (ix = 0; ix < MAX_PIDS; ix++) {
                if (!TaskInfo[ix].in_use)
                        continue;
                saP = ELF_CREATE_ARRAY(3);
                ElfAddNumToArray(saP, 0, TaskInfo[ix].uid);
                strcpy(str, TaskInfo[ix].argv[0]);
                if (fixcase && (TaskInfo[ix].appid == APELFM)) {
                        for (p = str; *p; p++) {
                                if (islower(*p))
                                        *p = toupper(*p);
                                else
                                        *p = *p;
                        }
                }
                ElfAddStrToArray(saP, 1, str);
                ElfAddNumToArray(saP, 2, TaskInfo[ix].topLevel ? BTRUE:FALSE);
                aP = WriteArray(aP, cnt++, saP);
        }
        return(aP);
#endif
}


data_ptr        TruncArray();
axstatic int    ElfDescendingSort;
axstatic int    ElfCaseSensitiveSort;
axstatic int    ElfLanguageSort;

#define FI_RELNAME 0        /* relative path for FS query func */
#define FI_TYPE 1       /* type: -1 dir, 0-file, 1-dc, 2-ge, 3-ss, 4-ce */
#define FI_DTMOD 2      /* time last modified */
#define FI_HISIZE 3     /* size in Kbytes */
#define FI_LOSIZE 4     /* remainder size in bytes */
#define FI_MODE 5       /* mode str as in Unix */
#define FI_LINKS 6      /* number of links */
#define FI_USERNAME 7       /* user name */
#define FI_TOTAL 8

/*************************************************************************
function: AxfSplitPath - Convert pathname to dir/file based on current FS info
*/
data_ptr AxfSplitPath(argDatum)
data_ptr argDatum;
{
    char           *searchstr = StrFromArgArray(argDatum,0);
    char            dirname[STRPATH + 1];
    char            entryname[STRPATH + 1];
    data_ptr        aP;

    SplitPath(searchstr, dirname, entryname);
    aP = ELF_CREATE_ARRAY(2);
    ElfAddStrToArray(aP, 0, dirname);
    ElfAddStrToArray(aP, 1, entryname);
    return(aP);
}

/*************************************************************************
function: AxfFullPathname - Convert a relative pathname to an absolute pathname
*/
data_ptr AxfFullPathname(argDatum)
data_ptr argDatum;
{
    char *relative = StrFromArgArray(argDatum,0);
    char            dirname[STRPATH + 1];
    char            entryname[STRPATH + 1];
    char           *name;
    char            result[STRPATH + 1];

    SplitPath(relative, dirname, entryname);    /* split */
    if (0 != chdir(dirname))/* go there */
        ElfStrAbort(ErrnoErr(), NULL, dirname);
    if (NULL == (name = Agetcwd(result, STRPATH)))
        ElfStrAbort(ErrnoErr(), NULL, dirname);
    sprintf(dirname, "%s/%s", name, entryname); /* re-assmble */
    chdir(AxCurrentDir);    /* go back ?? what if this fails? */
    return(ELF_CREATE_STRING(dirname));
}

/***********************************************************************
function: AxfGetHostname - Return hostname.
*/
data_ptr AxfGetHostname()
{
    char hostname[MAXHOSTNAMELEN + 1];

    if (gethostname(hostname, MAXHOSTNAMELEN + 1) == -1) {
        return(NullDataPtr);
    } else {
        hostname[MAXHOSTNAMELEN] = '\0'; /* safety */
        return(ELF_CREATE_STRING(hostname));
    }
}

/***************************************************************************
function: AxfGetServByName - Return port number from services.
*/
data_ptr AxfGetServByName (argDatum)
data_ptr argDatum;
{
    struct servent *info;

    info = getservbyname(StrFromArgArray(argDatum,0),StrFromArgArray(argDatum,1));
    if ( info )
        return(ELF_CREATE_INTEGER(ntohs(info->s_port)));
    else
        return(NullDataPtr);
}

/***************************************************************************
function: AxfGetCurrentLanguage - Return the current language code
*/
data_ptr AxfGetCurrentLanguage ()
{
    return(ELF_CREATE_INTEGER(AxLanguage));
}

/*************************************************************************
function: SplitPath - Convert pathname to dir/file based on current FS info
*/
SplitPath(searchstr, dirname, entryname)
    IN char        *searchstr;
    OUT char       *dirname;
    OUT char       *entryname;
{
    struct stat     x;
    char           *p;

    VERIFY((strlen(searchstr) < STRPATH), ERR_ILLVAL);
    AxSysDosUnixPath(searchstr);

    /*
     * separate entryname from dir in search str. Only entryname may have
     * wildcard characters
     */

    if (!DocTypeFromName(searchstr) &&
        (0 == stat(searchstr, &x)) &&
        ((x.st_mode & S_IFDIR) == S_IFDIR)) {   /* search is a simple
                             * dirname */
        strcpy(dirname, searchstr);
        entryname[0] = 0;
    } else if (streq(searchstr, ".") || streq(searchstr, "..")) {
        strcpy(dirname, searchstr);
        entryname[0] = 0;
    } else if (!strchr(searchstr, *DirSlash)) {
        strcpy(dirname, ".");
        strcpy(entryname, searchstr);
    } else {
        strcpy(dirname, searchstr);
        for (p = dirname + strlen(dirname) - 1; *p != *DirSlash; p--) {;
        }
        *p++ = 0;
        strcpy(entryname, p);
    }
}

int             CmpStrObj(), CmpDatePiece(), CmpNamePiece();

/*************************************************************************
function: AxfFSQuery - Return an array of info about the file system

If the passed name is a non-doc directory, use a "*" entryname

sort_mode flags:
                      10           1       5
               -----------------------------------
               |    unused      | dir | sort_val |
               -----------------------------------
dir:
    0 - Include directories in array (default)
    1 - Exclude directories

sort_val:
    0 - unsorted
    2 - by date ascending
    3 - by date descending
    4 - by name ascending
    5 - by name descending
*/
data_ptr AxfFSQuery(argDatum)
data_ptr argDatum;
{
#define MAX_SRCH_FILES 10000

    char *pdirname = StrFromArgArray(argDatum,0);   /* directory to query in */
    char *pentryname = StrFromArgArray(argDatum,1); /* optionally wildcarded
                                                     * entryname criterion */
    int recurse = IntFromArgArray(argDatum,2);      /* TRUE if recursion for
                                                     * directory searches */
    int names_only = IntFromArgArray(argDatum,3);   /* TRUE if should not
                                                     * return full stats */
    int sort_mode = IntFromArgArray(argDatum,4);    /* 0 - unsorted see
                                                     * filing.h for
                                                     * mode/asc/desc opts */
    int change_dir = IntFromArgArray(argDatum,5);   /* TRUE if should change
                                                     * dir as part of search */
    int do_dots = IntFromArgArray(argDatum,6);      /* TRUE if should list .*
                                                     * files with * search */
    int             got, len;
    register data_ptr aP;
    int             dates = FALSE;
    char            dirname[STRPATH + 1];
    char            entryname[STRPATH + 1];
    char           *p;
    int             sort_val;
    int             exclude_dirs;
#if AXMS
	char			folder_name[MAX_PATH+1]; /* to hold "My Computer" */
#endif

    /* Extract sort command and directory bit from passed flag */
    sort_val = (sort_mode & 31);    /* The lower 5 bits */
    exclude_dirs = ((sort_mode & 32) ? TRUE : FALSE);   /* The next bit */

    VERIFY((strlen(pdirname) < STRPATH) &&
           (strlen(pentryname) < STRPATH) &&
           (sort_val >= 0) && (sort_val <= 5), ERR_ILLVAL);
    VERIFY((pdirname[0] != 0) ||
      (!strchr(pentryname, '*') && !strchr(pentryname, '?')), ERR_ILLVAL);

    /* Need to stat for dates if sort is is by date */

    if (sort_val & 2)
        dates = TRUE;

    strcpy(dirname, pdirname);
    strcpy(entryname, pentryname);

#if 0
    for (p = entryname; *p; p++)
        if (*p == ' ')
            *p = '_';
    for (p = dirname; *p; p++)
        if (*p == ' ')
            *p = '_';
#endif

    /* create an ELF array and stuff in unsorted mode */

    aP = ELF_CREATE_ARRAY(MAX_SRCH_FILES);
#if AXMS
    len = strlen( dirname );
    if ( dirname[len-1] == '\\' )
        /* lower levels do not expect a trailing slash */
        dirname[len-1] = 0;

	if ( !axmsGetDrivesFolderName(folder_name, MAX_PATH+1) )
		strcpy(folder_name, "My Computer");  /* sane default */

    if ( strnicmp(dirname, folder_name, strlen(folder_name)) == 0 )
		{
        /* special case, return a list of the drive letters availble */
        got = axmsGetAvailableDrives(aP);
		sort_val = 0; /* the list of drives will already be sorted by alpha */
		}
    else
#endif
    got = ElfSrchDir(dirname, "", recurse, entryname, aP, 0, names_only, 
						dates, 0, exclude_dirs, do_dots);
             
    aP = TruncArray(aP, got);

    if (sort_val == 0)
        return (aP);
    ElfDescendingSort = sort_val & 1;
    ElfCaseSensitiveSort = FALSE;
    if (sort_val & 2)
        qsort(AX(aP)->vals, AX(aP)->size, sizeof(char *), CmpDatePiece);
    else if (sort_val != 0)
        qsort(AX(aP)->vals, AX(aP)->size, sizeof(char *), CmpNamePiece);
    
    return (aP);
}

CmpStrObj(arg1, arg2)     /* used for FSQery sorting */
ACONST void *arg1, *arg2;
{
	data_ptr *pp1 = (data_ptr *)arg1;
	data_ptr *pp2 = (data_ptr *)arg2;
    register data_ptr p1, p2;
    register char  *t1, *t2;

    p1 = *pp1;
    p2 = *pp2;
    if (!XX(p1))
        t1 = "";
    else
        t1 = SX(p1)->text;
    if (!XX(p2))
        t2 = "";
    else
        t2 = SX(p2)->text;

#if 0

    if (ElfCaseSensitiveSort)
        /* !!0 OK to use "raw" strcmp as follows? */
        /* strcmp() is case SENSITIVE */
        return (ElfDescendingSort ? strcmp(t2, t1) : strcmp(t1, t2));
    else
        /* Astrcmp() in astrcmp.c is case INSENSITIVE */
        return (ElfDescendingSort ? Astrcmp(t2, t1) : Astrcmp(t1, t2));

#else

    if (ElfLanguageSort > 0 && ElfLanguageSort != AxLanguage)
    {
    return (ElfDescendingSort ? Istrcmp(t2, t1, ElfLanguageSort, ElfCaseSensitiveSort) : Istrcmp(t1, t2, ElfLanguageSort, ElfCaseSensitiveSort));
    }
    else
    {
    return (ElfDescendingSort ? Istrcmp(t2, t1, AxLanguage, ElfCaseSensitiveSort) : Istrcmp(t1, t2, AxLanguage, ElfCaseSensitiveSort));
    }

#endif

}

CmpNumObj(arg1, arg2)     /* used for sorting */
ACONST void *arg1, *arg2;
{
	data_ptr *pp1 = (data_ptr *)arg1;
	data_ptr *pp2 = (data_ptr *)arg2;
    data_ptr        p1, p2;
    double          v1, v2;
    int             retval;

    p1 = *pp1;
    p2 = *pp2;
    if (IS_INTEGER(p1) && IS_INTEGER(p2))
        retval = GET_INTEGER(p2) - GET_INTEGER(p1);
    else {
        if (IS_INTEGER(p1))
            v1 = GET_INTEGER(p1);
        else if (!XX(p1))
            v1 = 0.0;
        else
            v1 = NX(p1)->value;
        if (IS_INTEGER(p2))
            v2 = GET_INTEGER(p2);
        else if (!XX(p2))
            v2 = 0.0;
        else
            v2 = NX(p2)->value;
        if (v2 > v1)
            retval = 1;
        else if (v2 == v1)
            retval = 0;
        else
            retval = -1;
    }
    if (ElfDescendingSort)
        return (retval);
    else
        return (-retval);
}

CmpNamePiece(pp1, pp2)      /* used for FSQery sorting */
    data_ptr       *pp1, *pp2;
{
    data_ptr        p1, p2;

    p1 = *pp1;
    p2 = *pp2;
    p1 = AX(p1)->vals[FI_RELNAME];
    p2 = AX(p2)->vals[FI_RELNAME];
#if BUILD_ORIENT
    return (OrientIndexCmp(&p1, &p2));
#else
    return (CmpStrObj(&p1, &p2));
#endif
}

CmpDatePiece(pp1, pp2)      /* used for FSQery sorting */
    data_ptr       *pp1, *pp2;
{
    data_ptr        p1, p2;
    double          NumFromDataPtr(), v1, v2;

    p1 = *pp1;
    p2 = *pp2;
    v1 = NumFromDataPtr(AX(p1)->vals[FI_DTMOD]);
    v2 = NumFromDataPtr(AX(p2)->vals[FI_DTMOD]);
    if (ElfDescendingSort)
        return ((int) (v2 - v1));
    else
        return ((int) (v1 - v2));
}




#if AXMS       /*  {   */
int 
axmsGetAvailableDrives(data_ptr aP)
{
   int drive;
   char buff[4];
   int ret;
   data_ptr saP;
   int pos = 0;
   int mask;
   DWORD drive_bits;

   /* get the bitmask representing the currently available disk drives. */
   /* the return value is a bitmask representing the currently available */
   /* disk drives. Bit position 0 (the least-significant bit) is drive A, */
   /* bit position 1 is drive B, bit position 2 is drive C, and so on.    */
   drive_bits = MS_GetLogicalDrives();

   mask = 1;
   for( drive = 0; drive < 26; drive++ )
      {
      if( mask & drive_bits )
        {
        /* drive exists */
        sprintf( buff, "%c:", 'A'+drive );
        saP = ELF_CREATE_ARRAY( 2 );  /* name, type */
        ElfAddStrToArray(saP, FI_RELNAME, buff);
        ElfAddNumToArray(saP, FI_TYPE, -1);   /* treat as a directory */
        WriteArray(aP, pos++, saP);
        }
      mask = mask * 2;
      }

   return( pos );
}
#endif       /*  }  ASMS  */



/*************************************************************************
function: ElfSrchDir - Add entry info to a directory search list
returns next index pos available in list
*/
static
ElfSrchDir(dir, subdir, recurse, entryname, aP, pos, names_only, need_date,
               level, noDirs, dotfiles)
char *dir;          /* dir to search */
char *subdir;           /* subdir to include in name object generation */
int recurse;            /* TRUE if recursion for directory searches */
char *entryname;        /* wildcard to match file entries against */
data_ptr aP;            /* dir info array to write to */
int pos;            /* pos in array to write to */
int names_only;         /* TRUE if should not return full stats */
int need_date;          /* TRUE if need date in names_only (for sorting) */
int level;          /* current search level */
int noDirs;         /* TRUE if no dirs to be put on list. */
int dotfiles;       /* TRUE is you want to see .* files - used with wildcard */
{
#define MAX_SUBDIRS 100
    int type;
    long TrueDirSize();
    long size;
    char mode[11];
    char *AxUserNameFromUserId();
    char name[STRPATH + 1]; /* plenty for a single entryname */
    char fixedname[STRPATH + 1];
    char thimname[STRPATH + 1];
    char newsubdir[STRPATH + 1];
    char fullname[STRPATH + 1];

    int have_stat;
    struct stat x;
    register data_ptr saP;
    int just_one = FALSE;

    axstatic int num_files_skimmed = 0;
    axstatic long cur_time;
    axstatic int max_files, max_levels;
    axstatic long max_time;
    char **filesInDir = NULL;
    int fileDex;

    /* If there is no dirspec and the file has no wildcards, just return info
     * about the file */

    if (dir[0] == 0)
        {
        strcpy(fullname, entryname);
        strcpy(name, entryname);
        type = DocIconIdFromName(name);
        have_stat = TRUE;
#if X386_NEW || AXMS
        if ((0 != stat(fullname, &x)))
#else
        if ((0 != stat(fullname, &x)) && (0 != lstat(fullname, &x)))
#endif
            return (pos);
        just_one = TRUE;
        goto doit;
        }
    if (recurse && (level == 0))
        {
        max_files = UPnumVal(PROF_SRCH_FILES_);
        max_time = UPnumVal(PROF_SRCH_SECS_);
        max_levels = UPnumVal(PROF_SRCH_LEVELS_);
        max_files = MAX(100, max_files);
        max_time = MAX(1, max_time) + time(0L);
        max_levels = MAX(0, max_levels);
        num_files_skimmed = 0;
        }
    filesInDir = AxListFilesInDir(dir);
    for (fileDex = 0; filesInDir[fileDex]; fileDex++)
        {
        strcpy(name, filesInDir[fileDex]);
        num_files_skimmed++;
        if (recurse)
        {
            if ( (num_files_skimmed >= max_files) || (cur_time >= max_time) )
                ElfAbort(ERR_BIGSRCH);
        }

        have_stat = FALSE;
        VERIFY(pos < MAX_SRCH_FILES, ERR_ARRTOOBIG);
        if (name[0] == '.')
            {
            if ((!entryname || (entryname[0] != '.')) && (dotfiles == FALSE))
                continue;
            }
        sprintf(fullname, "%s%s%s", dir, DirSlash, name);
        type = DocIconIdFromName(name);
#if 1               /* now shows all dirs! */
        if (type)
            goto file_case;
#else
        if (type || !recurse)
            goto file_case;
#endif

        if (subdir[0])
            sprintf(newsubdir, "%s%s%s", subdir, DirSlash, name);
        else
            strcpy(newsubdir, name);

        have_stat = TRUE;
#if X386_NEW || AXMS
        if ((0 != stat(fullname, &x)))
#else
        if ((0 != stat(fullname, &x)) && (0 != lstat(fullname, &x)))
#endif
            {
            memset(&x, 0, sizeof(x));
            goto file_case;
            }
        if ((x.st_mode & S_IFDIR) != S_IFDIR)
            goto file_case;

        /* If we're here, we have a directory. If the caller didn't want
         * directories in the list, ignore the entry */
        if (noDirs)
            {
            continue;
            }
        if (!recurse || (level >= max_levels))
            goto doit;
        cur_time = time(0L);
        pos = ElfSrchDir(fullname, newsubdir, TRUE, entryname, aP,
                 pos, names_only, need_date, level + 1, FALSE, dotfiles);
        continue;
file_case:
        if (!WildMatches(name, entryname))
            continue;
bad:
        if (!have_stat && !(names_only && !need_date && type))
#if X386_NEW || AXMS
            if ((0 != stat(fullname, &x)))
#else
            if ((0 != stat(fullname, &x)) && (0 != lstat(fullname, &x)))
#endif
                memset(&x, 0, sizeof(x));
doit:
        if (type)
            {
            strcpy(fixedname, name);
#if 0
            /* we should not deen to validate what we found on the disk */
            /* This is related to bug #5016  - jon    */
            if (!just_one && (AOK != IsValidPathFilename(fixedname)))
                {
                type = 0;
                goto bad;
                }
#endif
            if (type != IC_DIALOG)
                {
                ClipDocSuffix(fixedname);
                strcpy(name, fixedname);
                }
            }
        else if ((x.st_mode & S_IFDIR) == S_IFDIR)
            type = -1;
        else
            type = 0;
        if (subdir[0])
            sprintf(thimname, "%s%s%s", subdir, DirSlash, name);
        else
            strcpy(thimname, name);
        if (names_only)
            saP = ELF_CREATE_ARRAY(2 + need_date);  /* name, type, [date] */
        else
            saP = ELF_CREATE_ARRAY(FI_TOTAL);   /* all */
        ElfAddStrToArray(saP, FI_RELNAME, thimname);
        ElfAddNumToArray(saP, FI_TYPE, type);
        if (!names_only || need_date)
            ElfAddDblToArray(saP, FI_DTMOD, ((double) x.st_mtime));
        if (!names_only)
            {
            strcpy(mode, " ---------");
            if (x.st_mode & 0400)
                mode[1] = 'r';
            if (x.st_mode & 0200)
                mode[2] = 'w';
            if (x.st_mode & 0100)
                mode[3] = 'x';
            if (x.st_mode & 040)
                mode[4] = 'r';
            if (x.st_mode & 020)
                mode[5] = 'w';
            if (x.st_mode & 010)
                mode[6] = 'x';
            if (x.st_mode & 04)
                mode[7] = 'r';
            if (x.st_mode & 02)
                mode[8] = 'w';
            if (x.st_mode & 01)
                mode[9] = 'x';
            size = x.st_size;
#if !X386_NEW && !AX_STUB && !AXMS
            if ((x.st_mode & S_IFLNK) == S_IFLNK)
                mode[0] = 'l';
#endif
            ElfAddStrToArray(saP, FI_MODE, mode);
            ElfAddNumToArray(saP, FI_HISIZE, size / 1024);
            ElfAddNumToArray(saP, FI_LOSIZE, size % 1024);
            ElfAddNumToArray(saP, FI_LINKS, x.st_nlink);
            ElfAddStrToArray(saP, FI_USERNAME, AxUserNameFromUserId(x.st_uid));
            }
        WriteArray(aP, pos++, saP);
        if (just_one)
            break;
        }
    if (filesInDir)
        AxListFilesFreer(filesInDir);
    return (pos);
}
/*************************************************************************
function: WildMatches - Return whether a name matches a wildcard spec
*/
WildMatches(passed_name, passed_spec)
    register char  *passed_name;
    register char  *passed_spec;
{
    char           *name = passed_name;
    char           *spec = passed_spec;

#if AX_NT
    char            namebuf[STRPATH + 1];
    char            specbuf[STRPATH + 1];
    char           *p;

    strcpy(namebuf, passed_name);
    strcpy(specbuf, passed_spec);
    name = namebuf;
    spec = specbuf;
    for (p = name; *p; p++)
        *p = toupper(*p);
    for (p = spec; *p; p++)
        *p = toupper(*p);
#endif

    while (*spec && *name) {
        if (*spec == '?') {
            name++;
            spec++;
            continue;
        }
        if (*spec == '[') {
            spec++;
            if (*spec == '!') {
                spec++;
                while (*spec && (*spec != ']')) {
                    if (*spec++ == *name)
                        return (FALSE);
                }
                while (*spec && (*spec != ']'))
                    spec++; /* get to ']' */
                if (*spec == 0) /* unterminated '[' */
                    return (FALSE);
                spec++; /* move to next char in spec */
                name++; /* succeeded */
                continue;
            } else {
                while (*spec && (*spec != ']')) {
                    if (*spec++ == *name)
                        goto ok;
                }
                return (FALSE);
        ok:     while (*spec && (*spec != ']'))
                    spec++; /* get to ']' */
                if (*spec == 0) /* unterminated '[' */
                    return (FALSE);
                spec++; /* move to next char in spec */
                name++; /* succeeded */
                continue;
            }
        }
        if (*spec != '*') {
            if (*name++ != *spec++)
                return (FALSE);
            continue;
        }
        spec++;
        if (*spec == '\0')  /* rest is an easy match, no need to
                     * loop */
            return (TRUE);
        while (*name) {
            if (WildMatches(name++, spec))
                return (TRUE);
        }
        return (FALSE);
    }
    while (*spec == '*')
        spec++;
    return ((*spec == '\0') && (*name == '\0'));
}

#if AX_X11
void get_unix_user_name(namebuf, maxlen)
char *namebuf;        /* out: write onto caller's memory */
int maxlen;           /* size of buf */
{
#if !FOR_TESTER && !AX_STUB /*  {  */
    int             uid;
#if CLIX
    struct passwd  *getpwuid(const int), *entry;
#else
    struct passwd  *getpwuid(), *entry;
#endif
    uid = getuid();
    entry = getpwuid(uid);
    if (entry == NULL)
    {   
        namebuf[0] = 0;
        return;
    }
    strncpy(namebuf, entry->pw_name, maxlen);
#endif    /*  }  !FOR_TESTER && !AX_STUB  */
}
#endif

/*************************************************************************
function: AxfUserName - Return user name
*/
data_ptr AxfUserName()
{
    char retBuf[STRPATH];
#if AX_X11    /* { */    
    get_unix_user_name(retBuf, STRPATH);
    if (!retBuf[0]) {
        ElfStrAbort(ErrnoErr(), NULL, NULL);
    }

#else    /*  } {  */

    char username[200];
    DWORD name_size;
    char *nameP;
    int ret;

    name_size = 200;
    ret = MS_GetUserName( username, &name_size );
    if ( !ret )
        {
        /* above call failed, look for an environment variable */
        nameP = getenv( "USER" );
        if ( nameP == (char *)NULL )
            ElfStrAbort( ERR_ESCAPE, XLT("Could not get username, and environment variable \"USER\" is not set"), NULL );
        strcpy( username, nameP );
        name_size = strlen( username );
        }
    else
        username[ name_size ] = 0;  /* null terminate to make sure */

    strcpy( retBuf, username );
#endif   /*  }  AXMS  */

    return(ELF_CREATE_STRING(retBuf));

}

/*************************************************************************
function: AxfProcessId - Return Unix pid
*/
data_ptr AxfProcessId()
{
    return(ELF_CREATE_INTEGER(getpid()));
}

/*************************************************************************
function: AxfCurrDir - Return current directory
*/
data_ptr AxfCurrDir()
{
    return(ELF_CREATE_STRING( AxCurrentDir));
}

/*************************************************************************
function: AxfSetCurrDir - Change current directory
*/
data_ptr AxfSetCurrDir(argDatum)
data_ptr argDatum;
{
	char drive[3], path[STRPATH+1];
	char *in_path, *p;
	int len, dlen;

	/* Prohibit directories that have long names */
	in_path = StrFromArgArray(argDatum, 0);
	if ( streq(in_path, "..") ) /* form a path from the ".." directory */
	{
		len = strlen(AxCurrentDir) + 1 + 2; /* 1 for slash, 2 for ".." */
		if ( len > STRPATH )
		{
			ElfStrAbort(ERR_STRTOOLONG, XLT("\nPathname too long"), "..");
			return(NullDataPtr);
		}
		else
		{
			sprintf(path, "%s%s..", AxCurrentDir, DirSlash);
			AXLOG(("AxfSetCurrDir %s\n", in_path));
		}
	}
	else /* have a pathname - insure it's validitiy */
	{
		/* get the current drive */
		len = strlen(in_path);
#if AXMS
		if ( len > 1 && in_path[1] == ':' )
		{
			if ( islower(in_path[0]) )
				drive[0] = toupper(in_path[0]);
			else
				drive[0] = in_path[0];
			drive[1] = ':';
			drive[2] = (char)0;
			dlen = 2;
			in_path += dlen;
			len -= dlen;
		}
		else /* get the drive from the current dir */
		{
			if ( AxCurrentDir[1] != ':' )
			{
				drive[0] = (char)0;
				dlen = 0;
			}
			else
			{
				drive[0] = AxCurrentDir[0];
				drive[1] = ':';
				drive[2] = (char)0;
				dlen = 2;
			}
		}
#else
		drive[0] = (char)0;
		dlen = 0;
#endif
		if ( (dlen+len) > STRPATH )
		{

			ElfStrAbort(ERR_STRTOOLONG, XLT("\nPathname too long"), in_path);
			return(NullDataPtr);
		}
		else
		{
			/* copy the drive and the raw string */
			sprintf(path, "%s%s", drive, in_path);
			AXLOG(("AxfSetCurrDir %s\n", path));

			/* convert to DOS style slashes (just in case) */
			AxSysDosUnixPath(path);
		}
	}
	AXLOG(("AxfSetCurrDir do '%s'\n", path));

	/* trim off trailing slashes */
	p = path + strlen(path) - 1;    /* the last char in the path */
	if ( (*p == '\\') || (*p == '/') )
	{
		*p = '\0';             /* take of a terminating slash */
		p--;                   /* still the last char in the path */
	}

	/* expand trailing "." and ".." directory references */
	if ( (*p == '.') && (*(p-1) == *DirSlash) ) /* ends with "/." */
		*(p-1) = 0; /* remove "/." by stepping on last slash */
	else if ( (*p == '.') && (*(p-1) == '.') && (*(p-2) == *DirSlash) )
	{
		/* remove "/.." */
		*(p-2) = 0;   /* step on the last slash */
		p = p - 2; 

		/* find the end of the level above */
		while ( (p > path) && (*p != *DirSlash ) )
			p--;

		/* step on slash to trim one level up */
		*p = 0;
	}

	/* whoops, trimmed off the entire path - make it root on this drive */
	if ( *path == 0 || streq(path, drive) )
		sprintf(path, "%s%s", drive, DirSlash);

	/* update the string and the directory */
	if ( 0 != Achdir(path) )
		ElfStrAbort(ErrnoErr(), NULL, path);
	AXLOG(("AxfSetCurrDir did it \n"));
	strcpy(AxCurrentDir, path);

	/* done */
	return(NullDataPtr);
}

/*************************************************************************
function: AxfSort - Return a sorted array
This determines whether we are doing string or number sort
based on the first element of the passed array.  All elements MUST
be of the same type.
*/
data_ptr AxfSort(argDatum)
data_ptr argDatum;
{
    data_ptr tosort = AnyFromArgArray(argDatum,0);
    int descending = IntFromArgArray(argDatum,1);
    int caseSens = IntFromArgArray(argDatum,2);     /* FALSE (default) ->
                                                        case INSENSITIVE as in
                                                        2.1 */
    int lang_num = IntFromArgArray(argDatum,3);     /*  WP may use diff. lang */

    register data_ptr p;
    data_ptr        aP;
    register int    ix, size;
    register int    is_str = FALSE, is_num = FALSE, is_array = FALSE;

    size = ElfbArraySize(tosort);   /* validates is actually an array */
    for (ix = 0; ix < size; ix++) {
        p = AX(tosort)->vals[ix];
        if (!XX(p))
            continue;
        if ( IS_INTEGER(p) )
            is_num = TRUE;
        else {
            switch ( p->type ) {
            case TYPE_NUMBER:
                is_num = TRUE;
                break;
            case TYPE_STRING:
                is_str = TRUE;
                break;
            case TYPE_ARRAY:
                is_array = TRUE;
                break;
            default:
                ElfAbort(ERR_ILLVAL);
            }
        }
    }
    aP = ElfDataCopy(tosort);
    if (!is_num && !is_str && !is_array)    /* just an array of nulls */
        return(NullDataPtr);
    if ( is_array ) {
        VERIFY(!is_num && !is_str, ERR_ILLVAL); /* mixed sort */
    }
    else {
        VERIFY(is_num != is_str, ERR_ILLVAL);   /* mixed sort */
    }
    ElfDescendingSort = descending ? TRUE : FALSE;
    ElfCaseSensitiveSort = caseSens ? TRUE : FALSE;
    ElfLanguageSort = lang_num;

    if (is_str)
#if BUILD_ORIENT
        qsort(AX(aP)->vals, AX(aP)->size, sizeof(char *), OrientIndexCmp);
#else
        qsort(AX(aP)->vals, AX(aP)->size, sizeof(char *), CmpStrObj);
#endif
    else
        qsort(AX(aP)->vals, AX(aP)->size, sizeof(char *), CmpNumObj);
    
    ElfLanguageSort = 0;        /*  Reset to 0 to not affect any other ops */

    return(aP);
}

/*************************************************************************
function: AxfSortIndexed - Return a sorted array plus a pair of index
    arrays that indicate where the original material ended up.

The function determines whether we are doing string or number sort
    based on the first element of the passed array.  All elements MUST
    be of the same type.

An array containing three arrays is returned as follows. Assume the array
    IN[] was passed to this function...
    - The first is simply the sorted array OUT[].
    - The second is an array A1 that tells "where the input data ended up".
        Thus, for some IN[i], if OUT[j] = IN[i], A1[i] = j
    - The third is an array A2 that tells "where the output data came from".
        Thus, for some IN[i], if OUT[j] = IN[i], A2[j] = i
*/
data_ptr AxfSortIndexed(argDatum)
data_ptr argDatum;
{
    data_ptr tosort = AnyFromArgArray(argDatum,0);
    int descending = IntFromArgArray(argDatum,1);
    int caseSens = IntFromArgArray(argDatum,2);     /* 0 (default) ->
                                                     *  case INSENSITIVE (to
                                                     * match AxfSort) */
    int lang_num = IntFromArgArray(argDatum,3);     /*  WP may use diff. lang */
    register data_ptr p;
    data_ptr        aP, outP, a1P, a2P, retP;
    register data_array *arr;
    register int    ix, size, jx;
    register int    is_str = FALSE, is_num = FALSE;
    char          **sortArray;
    char          **c;

    size = ElfbArraySize(tosort);   /* validates is actually an array */
    for (ix = 0; ix < size; ix++) {
        p = AX(tosort)->vals[ix];
        if (!XX(p))
            continue;
        else if (ElfbIsNumber(p))
            is_num = TRUE;
        else if (ElfbIsString(p))
            is_str = TRUE;
        else
            ElfAbort(ERR_ILLVAL);
    }
    aP = ElfDataCopy(tosort);
    if (!is_num && !is_str) /* just an array of nulls */
        return(NullDataPtr);
    VERIFY(is_num != is_str, ERR_ILLVAL);   /* mixed sort */
    arr = (data_array *) aP;

    /*
     * To perform the indexed sort, create an array as follows: Each
     * element consists of two items: the sort data and its original index.
     * Our sorting routine only sorts on the sort data; after the sort is
     * done we can recover the indices and determine what went where.
     */
    sortArray = (char **) malloc(2 * size * sizeof(char *));
    for (ix = 0, c = sortArray; ix < size; ++ix) {
        *(c++) = (char *) arr->vals[ix];
        *(c++) = (char *) ix;
    }

    ElfDescendingSort = descending ? TRUE : FALSE;
    ElfCaseSensitiveSort = caseSens ? TRUE : FALSE;
    ElfLanguageSort = lang_num;

    /*
     * Note that in the following calls we say that one element of the
     * array consists of a pair of pointers (data & index)
     */
    if (is_str)
        {
#if BUILD_ORIENT
        qsort(sortArray, arr->size, 2 * sizeof(char *), OrientIndexCmp);
#else
        qsort(sortArray, arr->size, 2 * sizeof(char *), CmpStrObj);
#endif
        }
    else
        qsort(sortArray, arr->size, 2 * sizeof(char *), CmpNumObj);

    ElfLanguageSort = 0;        /*  Reset to 0 to not affect any other ops */

    retP = ELF_CREATE_ARRAY(3);
    outP = ELF_CREATE_ARRAY(size);
    a1P = ELF_CREATE_ARRAY(size);
    a2P = ELF_CREATE_ARRAY(size);
    for (ix = 0, c = sortArray; ix < size; ++ix) {  /* ix -> new index */
        outP = WriteArray(outP, ix, ElfDataCopy((data_ptr) * (c++)));
        jx = (int) *(c++);  /* jx -> original index */
        ElfAddNumToArray(a1P, jx, ix);  /* Where data ended up */
        ElfAddNumToArray(a2P, ix, jx);  /* Where data came from */
    }
    free(sortArray);
    retP = WriteArray(retP, 0, outP);
    retP = WriteArray(retP, 1, a1P);
    retP = WriteArray(retP, 2, a2P);
    return(retP);
}

/*************************************************************************
function: AxfShWin - Start a new process
*/
data_ptr AxfShWin(argDatum)
data_ptr argDatum;
{
    char           *cmd = StrFromArgArray(argDatum,0);
    return(ELF_CREATE_INTEGER(system(cmd)));
}

/*************************************************************************
function: AxfShXterm - Start an XTERM
*/
data_ptr AxfShXterm(argDatum)
data_ptr argDatum;
{
    char           *cmd = StrFromArgArray(argDatum,0);
    char *buf;

    buf = malloc(strlen(cmd)+50);
    sprintf(buf, NXLT("xterm -e %s &"), cmd);
    system(buf);
    free(buf);
    return(NullDataPtr);
}



/*************************************************************************
function: AxfShcmd - Execute shell cmd w/no error checking, return array

Use this function to call a command with a non-standard exit status;
e.g. diff.
*/
data_ptr AxfShcmd (argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    char *cmd = StrFromArgArray(argDatum,0);
    int errReport = FALSE;      /* future feature */
    char            buf[STRPATH*2+5000];    /* plenty big */
    char *line;
    char            filename[STRPATH + 1];
    register int    ix = 0;
    register data_ptr aP;
    register FILE  *fp;
    char bat_file[STRPATH+1];
    FILE *fileP;
    char *start_cmdP, first_cmd[STRPATH+1];
    int cmdlen, line_count;

    int code, errNum;

    SVERIFY(AxTempFile(NULL,filename), ErrnoErr(), filename);
#if AXMS    /*  {  */
    if ( getenv("LOGSHELLCMD") )
        {
        /* just to log what shell command is trying to execute, so we know
         * what commands things like the SS tutorials are running.
         */
        FILE *logfp;
        char logfile[STRPATH];
        sprintf(logfile, "%s/shellcmd.log", ThimTempDir);
        logfp = fopen(logfile, "a");
        fprintf(logfp, "%s\n", cmd);
        fclose(logfp);
        }

    /* take the input, split it up into individual commands (which are passed */
    /* as sperated by semi-colons) and create a ".BAT" file so we can run     */
    /* it and get some shell-like functionality, like environment vars,       */
    /* path lookup, etc.                                                      */
    /* run program with temp file as stdout. */
    AxTempFile("ax%%%%%%.bat", bat_file );
     /* this must be a "w" not WRITE_STR, win95 requires text batch files */
    fileP = fopen( bat_file, "w" );
    if ( fileP == (FILE *)NULL )
       {
       code = -1;
       goto error_out;
       }

    line = cmd;
    start_cmdP = cmd;
    first_cmd[0] = 0;
    line_count = 1;
    while ( *line != '\0' )
       {
       if ( *line == ';' )
           {
           /* end of individual command */
           *line = '\0';
           fprintf( fileP, "%s\n", start_cmdP);
           if ( !first_cmd[0] )
               strcpy(first_cmd, start_cmdP);
           start_cmdP = line+1;
           *line = ';';              /* restore semi-colon */
           line_count++;
           }
       line++;
       }
    fprintf( fileP, "%s\n", start_cmdP);   /* the last or only line */
    fclose( fileP );

    /* if not a multi-command batch file,set 'first cmd' to the one command */
    if ( !first_cmd[0] )
        strcpy(first_cmd, cmd);

    code = AxRunProgram(bat_file, NULL, filename, NULL, FALSE);
    AxDeleteTempfile(bat_file);

#else       /*  }  {  */

    cmdlen = strlen(cmd) + strlen(filename) + 21;
    VERIFY(cmdlen < sizeof(buf), ERR_STRTOOLONG);

    sprintf(buf, NXLT("(%s) </dev/null >%s 2>&1"), cmd, filename);
    code = system(buf);
#endif     /*  } not AXMS  */

error_out:
    if ( errReport && (code != 0) ) {
        if ( (code == 127) || ((code >> 8) == 127) )
            ElfStrAbort(ERR_ILLVAL,XLT("shell_command@ could not start"),cmd);
        else if ( (code == 1) || ((code >> 8) == 1) )
            ElfStrAbort(ERR_ILLVAL,XLT("Command did not execute properly"),cmd);
        else
            ElfStrAbort(code + FEErrno, NULL, cmd);
    }
    aP = ELF_CREATE_ARRAY(0);
    fp = fopen(filename, "r");
    WORK(WORK_INFINITY);
    SVERIFY(fp, ErrnoErr(), filename);
#if AXMS
    /* skip first 2 lines, because the Windows batch file wrote an empty line
     * and the command line itself to the output file (!)    -donato
     */
    {
    int i;
    int skip_lines = axmsCheckForBatchOutputHeader(fp, first_cmd);
    if ( skip_lines )
        {
        for ( i=0; i < (line_count*2); i++ )
            line = AxMFgets(fp);
        }
    }
#endif
    while ( line = AxMFgets(fp) )
        aP = ElfAddStrToArray(aP, ix++, line);
    fclose(fp);
    unlink(filename);
    return(aP);
#endif
}

/*************************************************************************
function: AxfMkTempName - Create a temp filename using mktemp
*/
data_ptr AxfMkTempName(argDatum)
data_ptr argDatum;
{
    register char *str = StrFromArgArray(argDatum,0);   /* base name */
    register char  *p;

    register int len;
    len = strlen( str );
    if ( len == 0 )
        {
        /* guarantee that there is at least on leading character, to prevent */
        /* the "mktemp" system call from looking backwards for "x"s, and     */
        /* falling off the front of the string.  This has been seen to happen */
        /* with Purify ! - jon                                               */
        str = "ax";
        len = 2;
        }

    p = ElfMalloc( len + 1 + 6);
    strcpy( p, str );
    strcat(p, NXLT("XXXXXX"));
    mktemp(p);
    return(ELF_CREATE_STRING(p));
}

/*************************************************************************
function: AxfMk1TempName - Create a tempfile name if not already created
*/
data_ptr AxfMk1TempName()
{
    axstatic char  *name = 0;
    data_ptr    aP;
    data_ptr    passedD;

    if (name)
        return(ELF_CREATE_STRING(name));
    else {
        passedD = ELF_CREATE_ARRAY(1);
        passedD = ElfAddStrToArray(passedD,0,NXLT("zzELF"));
        aP = AxfMkTempName(passedD);
        AxFreeData(passedD);
        return(aP);
    }
}

/*************************************************************************
function: AxfErrStr - Return string of error message
*/
data_ptr AxfErrStr(argDatum)
data_ptr argDatum;
{
    register int n = IntFromArgArray(argDatum,0);
    char            buf[256];
    typeErr         StrGet();

    if (n < 1)      /* not passed or a bogus value */
        return(ELF_CREATE_STRING(Elf.ErrorStr));
    else {
        n = n & 0xFFFF;
        if (AOK != StrGet(n, buf))
            buf[0] = 0;
        return(ELF_CREATE_STRING(buf));
    }
}

/*************************************************************************
function: AxfErrObject - Return object of lasterr thrown
*/
data_ptr AxfErrObject()
{
    return(ELF_CREATE_STRING(Elf.ErrorObject));
}

/*************************************************************************
function: AxfErrFile - Return source file of last error
*/
data_ptr AxfErrFile()
{
    return(ELF_CREATE_STRING(Elf.ErrorFile));
}

/*************************************************************************
function: AxfErrLine - Return line number of last error
*/
data_ptr AxfErrLine()
{
    return(ELF_CREATE_INTEGER(Elf.ErrorLine));
}

/***************************************************************************
function: AxfErrFunc - Return macro name of last error thown
*/
data_ptr
AxfErrFunc ()
{
    return(ELF_CREATE_STRING(Elf.ErrorFunc));
}

/***************************************************************************
function: AxfErrorElfObj - Return elf object of last error
*/
data_ptr
AxfErrElfObj ()
{
    if (Elf.ErrorElfObj)
        return(ELF_CREATE_OBJECT(Elf.ErrorElfObj->dex,Elf.ErrorElfObj->uid,NULL));
    else
        return(NullDataPtr);
}

/*************************************************************************
function: AxfDefErrStr - Define an error string
*/
data_ptr AxfDefErrStr(argDatum)
data_ptr argDatum;
{
    register int n = IntFromArgArray(argDatum,0);
    register char *str = StrFromArgArray(argDatum,1);
    register elf_str *p;
    char            buf[STRLONG + 1];

    VERIFY((n > 0) && (n < 1024), ERR_ILLVAL);
    p = (elf_str *) TrueMalloc(sizeof(elf_str));
    strncpy(buf, str, STRLONG); /* clip to max errmsg size */
    buf[STRLONG] = 0;
    strcpy(p->text = TrueMalloc(strlen(buf) + 1), buf);
    p->num = n;
    p->next = ElfStrings;
    ElfStrings = p;

    return(NullDataPtr);
}

/****************************************************************************
 *
 *     module: AxfMeasureInsetObject - get units and size from inset object
 */
data_ptr AxfMeasureInsetObject(argDatum)
data_ptr argDatum;
{
    data_ptr objP, ElfbMeasureInsetObject();
    objP = AnyFromArgArray(argDatum, 0);
    return(ElfbMeasureInsetObject(objP));
}

/****************************************************************************
 *
 *     module: AxfMeasureInsetObjectArea - get units and area from inset object
 */
data_ptr AxfMeasureInsetObjectArea(argDatum)
data_ptr argDatum;
{
    data_ptr objP, ElfbMeasureInsetObjectArea();
    objP = AnyFromArgArray(argDatum, 0);
    return(ElfbMeasureInsetObjectArea(objP));
}

/****************************************************************************
 *
 *     module: AxfEncSetPasswd - set a file encryption password
 */
data_ptr AxfEncSetPasswd(argDatum)
data_ptr argDatum;
{
	char *passwd;
	int mode;
	mode = IntFromArgArray(argDatum,0);
	passwd = StrFromArgArray(argDatum,1);
	switch(mode)
	{
		default:
		case 0: AxAddKeys(passwd);  break;
		case 1: AxAddSKeys(passwd); break;
	}
	return(NullDataPtr);
}

/****************************************************************************
 *
 *     module: AxfEncDisable - terminate passwords for this session
 */
data_ptr AxfEncDisable(argDatum)
data_ptr argDatum;
{
/*	void AxDisableEncryption();

	AxDisableEncryption(); */
    return(NullDataPtr);
}

/*************************************************************************
function: AxfFRwait - Wait until there is a field read up
Allow anyone else to run first.
*/
data_ptr AxfFRwait()
{
    int             ix;
    register context_block *p;
    extern context_block *ActiveTasks[MAX_PIDS + 1];    /* array of tasks
                                 * .in_use */

    /*
     * See if anyone has anything to do, kee this task down till all
     * others. are done.
     */

loop:
    for (ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix]) {
        if ((p - TaskInfo) == AxInTask)
            continue;   /* ignore self */
        if (p->pended || p->elfCallBlocked)
            continue;   /* ignore anyone that is blocked */
        if (p->rsp || (p->start_me) ||
            p->kill_me ||
            (!p->ipc_response_waiting && p->msgs)) {
            TaskRecycle();
            goto loop;
        }
    }
    return(NullDataPtr);
}

/*************************************************************************
function: AxfStrIndex - return substr index if string in string
*/
data_ptr AxfStrIndex(argDatum)
data_ptr argDatum;
{
    /* the only real way to do this is to expan the strings and then go */
    /* through the comparison loop.                                  */

    register mbchar *big = (mbchar *)StrFromArgArray(argDatum,0);
    register mbchar *small = (mbchar *)StrFromArgArray(argDatum,1);
    wchar           *source, *pattern;
    register wchar *sourceP, *patP;
    int             source_len, pattern_len;
    register int    ix, jx, max;

    source = (wchar*)malloc((MBstrlen(big)+1) * sizeof(wchar));
    pattern = (wchar*)malloc((MBstrlen(small)+1) * sizeof(wchar));
    source_len = MbToWStr(big, source);
    pattern_len = MbToWStr(small, pattern);

    max = source_len - pattern_len; /* no further than this in source */
    for (ix = 0; ix <= max; ix++) {
        sourceP = &source[ix];
        patP = pattern;
        for (jx = 0; jx < pattern_len; jx++) {
            if (*sourceP != *patP)
                goto not_same;
            sourceP++;
            patP++;
        }
        /** fell through, we matched the entire pattern */
        free(source);
        free(pattern);
        return(ELF_CREATE_INTEGER(ix + 1));     /* elf string positions are
                                                 *  1 relative */
not_same:   ;
    }
    free(source);
    free(pattern);
    return(ELF_CREATE_INTEGER(0));
}

/*************************************************************************
function: ElfbRevStrIndex - return substr index if string in string
Same as ElfStrIndex, but searches from end (like strchr/strrchr).
*/
ElfbRevStrIndex(big, small)
    register mbchar *big;
    register mbchar *small;
{
    /* the only real way to do this is to expan the strings and then go */
    /* through the comparison loop.                                  */

    wchar           *source, *pattern;
    register wchar *sourceP, *patP;
    int             source_len, pattern_len;
    register int    ix, jx, max;

    source = (wchar*)malloc((MBstrlen(big)+1) * sizeof(wchar));
    pattern = (wchar*)malloc((MBstrlen(small)+1) * sizeof(wchar));
    source_len = MbToWStr(big, source);
    pattern_len = MbToWStr(small, pattern);

    max = source_len - pattern_len; /* no further than this in source */
    for (ix = max; ix >= 0; ix--) {
        sourceP = &source[ix];
        patP = pattern;
        for (jx = 0; jx < pattern_len; jx++) {
            if (*sourceP != *patP)
                goto not_same;
            sourceP++;
            patP++;
        }
        /** fell through, we matched the entire pattern */
        free(source);
        free(pattern);
        return (ix + 1);/* elf string positions are 1 relative */
not_same:   ;
    }
    free(source);
    free(pattern);
    return (0);
}



/*************************************************************************
function: AxfSubstr - Perform PL1 like substring operation
*/
data_ptr AxfSubstr(argDatum)
data_ptr argDatum;
{
    register mbchar *str = (mbchar *)StrFromArgArray(argDatum,0);
    register int    start = IntFromArgArray(argDatum,1);
    data_ptr        lenP = AnyFromArgArray(argDatum,2);
    register int    string_len;
    register data_ptr axdRetVal;
    register mbchar *startP, *endP;
    int             byte_len, char_len;

    VERIFY(start > 0, ERR_ILLVAL);
    start--;        /* one relative from caller to zero relative */
    string_len = MB_CHAR_LEN(str);
    start = MIN(start, string_len);
    startP = MB_CHAR_POS(str, start);

    if ( lenP ) {
        char_len = IntFromDataPtr(lenP);
        VERIFY(char_len >= 0, ERR_ILLVAL);
        if (start + char_len > string_len)
            char_len = string_len - start;
    }
    else
        char_len = string_len - start;

    endP = MB_CHAR_POS(startP, char_len);
    byte_len = endP - startP;

    axdRetVal = AxTaskCreateSizedElfString(THIMpid, byte_len, "");
    memcpy(SX(axdRetVal)->text, startP, byte_len);
    SX(axdRetVal)->text[byte_len] = 0;
    return(axdRetVal);
}


#define MAX_SUBSTR 10000    /* TEMP LIMIT !!1 */

/*************************************************************************
function: ElfbSetSubstr -
*/
data_ptr AxfSetSubstr(argDatum)
data_ptr argDatum;
{
    char *str = StrFromArgArray(argDatum,0);
    int pos = IntFromArgArray(argDatum,1);
    int span = IntFromArgArray(argDatum,2);
    char *newstr = StrFromArgArray(argDatum,3);

    int             len, ix;
    mbchar         *startP;
    int             first_seg_len;
    int             blanks_needed = 0;
    int             total_new_len;
    mbchar          temp_buf[MAX_SUBSTR*2 + 1];

    VERIFY((pos > 0) && (pos <= MAX_SUBSTR) && (span >= 0), ERR_ILLVAL);

    pos--;          /* one relative user to zero internally * */
    MBstrcpy(temp_buf, str);    /* so we can blank pad if necessary */
    len = MB_CHAR_LEN(temp_buf);    /* length in characters, not bytes */
    if (pos > len) {
        span = 1;
        blanks_needed = pos - len + span;
        startP = temp_buf + MBstrlen(temp_buf);
        for (ix = 0; ix < blanks_needed; ix++) {
            *startP++ = ' ';
        }
        *startP = 0;
    }
    else if (pos + span > len)
        /* if the span crosses the end of the string, just use the rest
            of the string */
        span = len - pos;

    startP = MB_CHAR_POS(temp_buf, pos);    /* start of area to be replaced */
    first_seg_len = startP - (mbchar *) temp_buf;

    startP = MB_CHAR_POS(startP, span); /* where in original to resume */
    total_new_len = first_seg_len + MBstrlen(newstr) + MBstrlen(startP);
    VERIFY(total_new_len <= MAX_SUBSTR, ERR_STRTOOLONG);

    {mbchar retbuf[MAX_SUBSTR*2 + 1];
     data_ptr axdRetVal;
        memcpy(retbuf, temp_buf, first_seg_len);
        strcpy((retbuf + first_seg_len), newstr);
        MBstrcat(retbuf, startP);
        axdRetVal = ELF_CREATE_STRING(retbuf);
        return(axdRetVal);
    }
}

/*************************************************************************
function: ElfbCompose_String - Perform a printf with arbitrary re-arrangement
of arg order; stolen directly from ElfbFormat, above.
Parallels comp_str() in utils/comp_str.c.
Used for XLT's of format strings with more than 1 variable.
*/

#define MAX_ARGS    20
#define MAX_CMPSTR 2048 /* Should be arbitrary !!2 */

ElfbCompose_String (va_alist) va_dcl    /* data to format */
{
    va_list     ptr;                    /*  list of arguments */
    data_ptr    dP;                     /*  generic data ptr */
    register char   *pattern;           /* pattern strg */
    char    subs[MAX_ARGS][MAX_CMPSTR], /*  arguments as strings */
            result[MAX_CMPSTR+1],       /*  result string */
            *rP,                        /* result string ptr */
            *pP,                        /* pattern string scan ptr */
            *StrFromDataPtr();
    int     indx = 0,
            hi_indx = 0;


    va_start(ptr);
    pattern = va_arg(ptr,char *);

    pP = pattern;       /* pattern string scan ptr */
    rP = result;        /*  result string scan ptr */

    memset (subs, 0, sizeof(subs));
    memset (result, 0, sizeof(result));

    /* Store the arguments in an easy-to-access array and save the array size */
    while ( (dP = va_arg(ptr, data_ptr)) != (data_ptr) NULL)
            strcpy(subs[indx++], StrFromDataPtr(dP));
    hi_indx = indx;

    /* loop through the pattern copying it into result until a
       '$' is met. */
    while (*pP != '\0')
    {
        if (*pP != '$') {

        /* normal character, just copy it */
            *rP = *pP;

        /* increment pointers accordingly */
            rP++;
            pP++;

        }
        else
        {
        /* Encountered a $. The following character will be the 
           number of the substitute argument. To save this as an
           integer subtract the character '0' from it. */

            pP++;
            indx = *pP - '0';
            pP++;

        /* Use this indx (decrement since C starts from 0) to get 
           the proper substitute string from the array and append 
           this to rP */

            indx -= 1;

        /* Check that the value retrieved is valid array indx */
           if ( (indx < 0) || (indx > hi_indx - 1) ) {
    LOGGER(("ElfbCompose_String: Resetting invalid arg# %d to 1. \n",indx+1));
                indx = 0;
            }

            if (subs[indx][0] != '\0') {
                strcat(result,subs[indx]);
                rP = rP + strlen(subs[indx]);
            }
            else {
            /* if the substitute is NULL, then a blank space will
               be written into the out_buf and an error message logged */
                *rP = ' ';
                rP++;
                LOGGER(("Index %d was a null string. Writing a blank space to the result buffer.\n", indx+1));
            }

        } /* else if '$' */

    } /* while *pP */

    /* null terminate the new string */
    *rP = '\0';

    strcpy(ElfStrPtrRet = ElfMalloc(strlen(result)+1),result);
}


/*************************************************************************
function: AxfTrim - Trim leading and trailing spaces
*/
data_ptr AxfTrim(argDatum)
data_ptr argDatum;
{
    register char  *str = StrFromArgArray(argDatum,0);
    register int    len;
    register char  *p;
    register data_ptr axdRetVal;

    while (*str && (*str == ' '))
        str++;
    for (p = str + strlen(str) - 1; (p > str) && (*p == ' '); p--);
    len = p + 1 - str;

    axdRetVal = AxTaskCreateSizedElfString(THIMpid, len, "");
    memcpy(SX(axdRetVal)->text, str, len);
    SX(axdRetVal)->text[len] = 0;
    return(axdRetVal);
}

/*************************************************************************
function: AxfUpCase - Convert a string to upper case
*/
data_ptr AxfUpCase(argDatum)
data_ptr argDatum;
{

    /* conditioned for wide characters */
    register unsigned char *str = (unsigned char*)StrFromArgArray(argDatum,0);
    register unsigned char *p;
    register data_ptr axdRetVal;

    axdRetVal = AxTaskCreateSizedElfString(THIMpid, MBstrlen(str), "");
    p = (unsigned char *)(SX(axdRetVal)->text);
    while (*str != '\0') {
        if (IS_MULTI_BYTE(str)) {
            /* for mulit-byte characters we just copy both bytes, */
            /* no up/down case currently */
            *p++ = *str++;
            *p++ = *str++;
        } else {
            *p = Atoupper( (unsigned int)(*str) );
            p++;
            str++;
        }
    }
    *p = 0;
    return(axdRetVal);
}

/*************************************************************************
function: AxfDnCase - Convert a string to lower case
*/
data_ptr AxfDnCase(argDatum)
data_ptr argDatum;
{
    register unsigned char *str = (unsigned char*)StrFromArgArray(argDatum,0);
    register unsigned char *p;
    register data_ptr axdRetVal;

    axdRetVal = AxTaskCreateSizedElfString(THIMpid, MBstrlen(str), "");
    p = (unsigned char *)(SX(axdRetVal)->text);

    while (*str != '\0') {
        if (IS_MULTI_BYTE(str)) {
            /* for mulit-byte characters we just copy both bytes, */
            /* no up/down case currently */
            *p++ = *str++;
            *p++ = *str++;
        } else {
            *p = Atolower( (unsigned int)(*str) );
            p++;
            str++;
        }
    }
    *p = 0;
    return(axdRetVal);
}

/*************************************************************************
function: ElfbGetKeyName - Return name of function key or ""
*/
ElfbGetKeyName(key)     /* ??x remove me */
    register int    key;
{
    abort();
}

/*************************************************************************
function: AxfGetKeyCode - Return keycode from a passed key name
Accepts spaces as underscores, allows _key suffix
*/
data_ptr AxfGetKeyCode(argDatum)        /* ??x remove me */
data_ptr argDatum;
{
    register char *p = StrFromArgArray(argDatum,0);
    /*return (0);*/
    return(NullDataPtr);
}

/*************************************************************************
function: AxfBinaryByte - Return a byte at passed pos
*/
data_ptr AxfBinaryByte(argDatum)
data_ptr argDatum;
{
    register data_ptr aP = AnyFromArgArray(argDatum,0);
    register int    pos = IntFromArgArray(argDatum,1);
    register int    size;

    VERIFY(pos >= 0, ERR_ILLVAL);
    size = ElfbBinarySize(aP);  /* may throw error */
    if (pos >= size)
        return ((data_ptr) 0);
    return(ELF_CREATE_SMALL_INTEGER(((data_binary *) aP)->bytes[pos] & 0x0FF));
}

/*************************************************************************
function: AxfReadBinaryFile - Read a binary file into a binary object
*/
data_ptr AxfReadBinaryFile(argDatum)
data_ptr argDatum;
{
    char        *name = StrFromArgArray(argDatum,0);
    int         fd, err, pid, read_only, size;
    struct stat status;
    data_ptr    aP;
    FILE        *fp;

    /* lock/open the file for read */
    AxSysDosUnixPath(name);
    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(name, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, name);
    fp = (FILE *)AFTaskfopen(pid, name, READ_BINARY_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(name, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, name);
    }

    /* get the file size */
    fd = fileno(fp);
    if ( fstat(fd, &status) == (-1) )
    {
        err = ErrnoErr();
        AFfclose(name, read_only, fp);
        AFTaskUnlockFile(name, pid, read_only);
        ElfStrAbort(err, NULL, name);
    }
    size = status.st_size;

    /* read the file contents onto an ELF binary object */
    if ( size <= 0 )
        aP = (data_ptr)0;
    else
    {
        aP = ELF_CREATE_BINARY(size);
        if ( fread(((data_binary *) aP)->bytes, size, 1, fp) == 0 )
        {
            err = ErrnoErr();
            AFfclose(name, read_only, fp);
            AFTaskUnlockFile(name, pid, read_only);
            ElfFree(aP);
            ElfStrAbort(err, NULL, name);
        }
    }

    /* done */
    AFfclose(name, read_only, fp);
    AFTaskUnlockFile(name, pid, read_only);
    return(aP);
}


/*************************************************************************
function: ReadPartBinaryFile - Read part of a binary file into a binary object
*/
data_ptr ReadPartBinaryFile(char *name, int start_offset, int request_len)
{
    int         fd, err, pid, read_only, file_size;
    struct stat status;
    data_ptr    aP;
    FILE        *fp;
    int read_size;

    /* lock/open the file for read */
    AxSysDosUnixPath(name);
    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(name, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, name);
    fp = (FILE *)AFTaskfopen(pid, name, READ_BINARY_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(name, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, name);
    }

    /* get the file file_size */
    fd = fileno(fp);
    if ( fstat(fd, &status) == (-1) )
    {
        err = ErrnoErr();
        AFfclose(name, read_only, fp);
        AFTaskUnlockFile(name, pid, read_only);
        ElfStrAbort(err, NULL, name);
    }
    file_size = status.st_size;

    /* read the file contents onto an ELF binary object */
    if ( (start_offset + request_len) > file_size )
        /* clip the read to what is available */
        read_size = file_size - start_offset;
    else
        read_size = request_len;
    
    if ( read_size <= 0 )
        /* bad request, return numm data pointer */
        aP = (data_ptr)0;
    else
    {
        aP = ELF_CREATE_BINARY(read_size);
        fseek( fp, start_offset, SEEK_SET );

        if ( fread(((data_binary *) aP)->bytes, read_size, 1, fp) == 0 )
        {
            err = ErrnoErr();
            AFfclose(name, read_only, fp);
            AFTaskUnlockFile(name, pid, read_only);
            ElfFree(aP);
            ElfStrAbort(err, NULL, name);
        }
    }

    /* done */
    AFfclose(name, read_only, fp);
    AFTaskUnlockFile(name, pid, read_only);
    return(aP);
}
/*************************************************************************
function: ElfbWriteBinaryFile - Write a binary object to a file
*/
void
ElfbWriteBinaryFile(filename, aP)
char *filename;
data_ptr aP;
{
    int size, read_only, pid, err;
    FILE *fp;

    /* make sure we have a valid data buffer (may throw error) */
    size = ElfbBinarySize(aP);

    /* lock (truncate/create) a file for writing */
    pid = THIMpid;
    read_only = FALSE;
    err = AFTaskLockFile(filename, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, filename);
    fp = (FILE *)AFTaskfopen(pid, filename, WRITE_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(filename, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, filename);
    }

    /* write the data to the file */
    if ( size > 0 )
    {
        fwrite(((data_binary *)aP)->bytes, size, 1, fp);
        if ( ferror(fp) ) /* delete file on error */
        {
            err = ErrnoErr();
            AFfclose(filename, read_only, fp);
            AFTaskUnlockFile(filename, pid, read_only);
            unlink(filename);
            ElfStrAbort(err, NULL, filename);
        }
    }

    /* close and unlock the file */
    if ( AFfclose(filename, read_only, fp) == EOF )
        err = ErrnoErr();
    else
        err = AOK;
    AFTaskUnlockFile(filename, pid, read_only);
    if ( err ) /* delete file on error */
    {
        unlink(filename);
        ElfStrAbort(err, NULL, filename);
    }
    return;
}

/*************************************************************************
function: AxfBinaryAppend - Append a binary to another, return result
*/
data_ptr AxfBinaryAppend (argDatum)
data_ptr argDatum;
{
	data_ptr b1 = AnyFromArgArray(argDatum,0);
	data_ptr b2 = AnyFromArgArray(argDatum,1);
	int size1 = ElfbBinarySize(b1);
	int size2 = ElfbBinarySize(b2);
	data_ptr retP;

	retP = ELF_CREATE_BINARY(size1+size2);
	if ( size1 )
		memcpy(BX(retP)->bytes,BX(b1)->bytes,size1);
	if ( size2 )
		memcpy(BX(retP)->bytes+size1,BX(b2)->bytes,size2);
	return(retP);
}

/*************************************************************************
function: AxfBinarySubArray - return the portion of an ELF binary object
which starts at 'start' and runs 'span' bytes
*/
data_ptr AxfBinarySubArray(argDatum)
data_ptr argDatum;
{
    data_ptr aP = AnyFromArgArray(argDatum,0);
    int start = IntFromArgArray(argDatum,1);
    data_ptr lenP = AnyFromArgArray(argDatum,2);

    data_ptr retP;
    int span;
    int size;
    int len;

    VERIFY(start >= 0, ERR_ILLVAL);

    size = ElfbBinarySize(aP);

    start = MIN(start,size);

    if (lenP)
    {
        span = IntFromDataPtr(lenP);
        VERIFY(span > 0, ERR_ILLVAL);

        if (start + span > size)
            len = size - start;
        else
            len = span;
    }
    else
        len = size - start;

    retP = ELF_CREATE_BINARY(len);

    memcpy(BX(retP)->bytes,BX(aP)->bytes + start,len);

    return(retP);
}

/*************************************************************************
function: AxfBinaryToArray - Convert a binary object to a 1/2d array
*/
data_ptr AxfBinaryToArray(argDatum)
data_ptr argDatum;
{
    register data_ptr dP = AnyFromArgArray(argDatum,0);
    register int    subsize = IntFromArgArray(argDatum,1);  /* 1000 is best
                                                             * size of all! */
    register int    size, ix, jx;
    register int    topsize;
    register data_ptr aP, saP;
    register data_array *aap;
    register int    n;
    register int    bytes_left;
    register int    this_size;

    VERIFY(subsize >= 0, ERR_ILLVAL);
    size = ElfbBinarySize(dP);  /* may throw error */
    if (subsize == 0) {
        aP = ELF_CREATE_ARRAY(size);
        aap = AX(aP);
        for (ix = 0; ix < size; ix++) {
            n = (((data_binary *) dP)->bytes[ix]) & 0x00FF;
            aap->vals[ix] = (data_ptr) (MK_INTEGER(n));
        }
        return(aP);
    }
    /* if got here, making a 2-dim array */

    topsize = (size + subsize - 1) / subsize;
    aP = ELF_CREATE_ARRAY(topsize);
    bytes_left = size;
    for (ix = 0; ix < topsize; ix++) {
        if (subsize > bytes_left)
            this_size = bytes_left;
        else
            this_size = subsize;
        saP = ELF_CREATE_ARRAY(this_size);
        WriteArray(aP, ix, saP);
        aap = AX(saP);
        for (jx = 0; jx < this_size; jx++) {
            n = (((data_binary *) dP)->bytes[ix * subsize + jx]) & 0x00FF;
            aap->vals[jx] = (data_ptr) (MK_INTEGER(n));
        }
        bytes_left -= this_size;
    }
    return(aP);
}

/*************************************************************************
function: AxfArrayToBinary - Fold an array to a binary object
Array must be either a 1-dim or 2-dim array.  All items in the array
must be small (<256) integers or null datums (=0).
Note that strings are NOT converted to numbers.
*/
data_ptr AxfArrayToBinary(argDatum)
data_ptr argDatum;
{
    data_ptr theArray = AnyFromArgArray(argDatum,0);
    register data_ptr dP, sdP, outP;
    register int    totalsize = 0, dex = 0, ix, jx;
    register int    val, topsize, subsize;

    /* verify content of array */

    topsize = ElfbArraySize(theArray);
    for (ix = 0; ix < topsize; ix++) {
        dP = AX(theArray)->vals[ix];
        if (!dP) {
            totalsize++;
            continue;
        } else if (IS_INTEGER(dP)) {    /* normal case */
            val = GET_INTEGER(dP);
            VERIFY((val >= 0) && (val <= 255), ERR_ILLVAL);
            totalsize++;
        } else if (ElfbIsNumber(dP)) {  /* not a good sign */
            val = IntFromDataPtr(dP);
            VERIFY((val >= 0) && (val <= 255), ERR_ILLVAL);
            totalsize++;
        } else if (ElfbIsBinary(dP)) {
            totalsize += ElfbBinarySize(dP);
        } else if (ElfbIsArray(dP)) {
            subsize = ElfbArraySize(dP);
            for (jx = 0; jx < subsize; jx++, totalsize++) {
                sdP = AX(dP)->vals[jx];
                if (!sdP)
                    continue;
                else if (IS_INTEGER(sdP)) { /* normal case */
                    val = GET_INTEGER(sdP);
                    VERIFY((val >= 0) && (val <= 255), ERR_ILLVAL);
                } else if (ElfbIsNumber(sdP)) { /* not a good sign */
                    val = IntFromDataPtr(sdP);
                    VERIFY((val >= 0) && (val <= 255), ERR_ILLVAL);
                } else if (ElfbIsBinary(dP)) {
                    totalsize += ElfbBinarySize(dP);
                    totalsize--;    /* cause of loop counter */
                } else
                    ElfAbort(ERR_NOTNUMBER);
            }
        } else
            ElfAbort(ERR_NOTNUMBER);
    }

    /* create the output object */

    outP = ELF_CREATE_BINARY(totalsize);
    for (ix = 0; ix < topsize; ix++) {
        dP = AX(theArray)->vals[ix];
        if (!dP) {
            ((data_binary *) outP)->bytes[dex] = 0;
            dex++;
        } else if (IS_INTEGER(dP)) {    /* normal case */
            ((data_binary *) outP)->bytes[dex] = GET_INTEGER(dP);
            dex++;
        } else if (ElfbIsNumber(dP)) {  /* not a good sign */
            ((data_binary *) outP)->bytes[dex] = IntFromDataPtr(dP);
            dex++;
        } else if (ElfbIsBinary(dP)) {
            memcpy(((data_binary *) outP)->bytes + dex,
                 ((data_binary *) dP)->bytes, ElfbBinarySize(dP));
            dex += ElfbBinarySize(dP);
        } else if (ElfbIsArray(dP)) {
            subsize = ElfbArraySize(dP);
            for (jx = 0; jx < subsize; jx++, dex++) {
                sdP = AX(dP)->vals[jx];
                if (!sdP)
                    ((data_binary *) outP)->bytes[dex] = 0;
                else if (IS_INTEGER(sdP))   /* normal case */
                    ((data_binary *) outP)->bytes[dex] = GET_INTEGER(sdP);
                else if (ElfbIsNumber(sdP)) /* not a good sign */
                    ((data_binary *) outP)->bytes[dex] = IntFromDataPtr(sdP);
                else if (ElfbIsBinary(sdP)) {
                    memcpy(((data_binary *) outP)->bytes + dex,
                           ((data_binary *) sdP)->bytes, ElfbBinarySize(sdP));
                    dex += ElfbBinarySize(sdP);
                    dex--;  /* compensate for loop var */
                }
            }
        }
    }

    return(outP);
}

/*************************************************************************
function: AxfTruncArray - Truncate array
*/
data_ptr AxfTruncArray(argDatum)
data_ptr argDatum;
{
    data_ptr        aP = AnyFromArgArray(argDatum,0);
    int             newsize = IntFromArgArray(argDatum,1);
    int             oldsize;

    VERIFY(newsize >= 0, ERR_ILLVAL);
    oldsize = ElfbArraySize(aP);    /* performs validation */
    aP = ElfDataCopy(aP);
    if (oldsize <= newsize)
        return(aP);
    else
        return(TruncArray(aP, newsize));
}

/*************************************************************************
function: AxfStartApp - Start another task
*/
data_ptr AxfStartApp(argDatum)
    data_ptr argDatum;
{
    int     elf_appid    = IntFromArgArray(argDatum,0);
    char    *opts    = StrFromArgArray(argDatum,1);
    int     app_id;
    int     uid;

    /* map the elf appids from app_ids_.am to the ones in scac.h */
    switch(elf_appid)   {
        case 1:     /* APP#WORDS_ */
            app_id = APDC;
            break;
        case 2:     /* APP#GRAPHICS_ */
            app_id = APGE;
            break;
        case 3:     /* APP#SPREADSHEET_ */
            app_id = APSS;
            break;
        case 4:     /* APP#MACRO_EDIT_ */
            app_id = APUCM;
            break;
        case 9:     /* APP#BIT_EDIT_ */
            app_id = APGE;
            break;
        case 12:    /* APP#EQUATION_ */
            app_id = APEQN;
            break;
        case 14:    /* APP#HTML_ */
            app_id = APHTML;
            break;
        case 34:    /* APP#SLIDE_SHOW_ */
            app_id = APGE;
            break;
        default:
            app_id = 0;
            break;
    }   

    /* create a new filename from the template */
    XmPutBusyCursor(NULL);

    /* start a new task and return the uid */
    uid = ElfbProc(app_id, opts);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: ElfbProc - Start another task
*/
ElfbProc(aid, cmdline)
    int             aid;    /* app id */
    char           *cmdline;/* command line to pass to process */
{
    int             pid;
    int             code;

    code = ACprocWithError(aid, cmdline, &pid);
    return (TaskInfo[pid].uid);
}

/*************************************************************************
function: AxfPProc - Start another process (pended)
*/
data_ptr AxfPProc(argDatum)
data_ptr argDatum;
{
    int aid = IntFromArgArray(argDatum,0);              /* app id */
    char *cmdline = StrFromArgArray(argDatum,1);        /* command line to pass
                                                            to process */
    int             code;

    code = ACpproc(aid, cmdline);
    return(ELF_CREATE_INTEGER(code));
}

#if !FOR_TESTER
ATMelfPostError(line, a, b, c, d, e, f, g, h, i, j, k, l)
    int             line;
    char           *a;
    int             b, c, d, e, f, g, h, i, j, k, l;
{
}

#endif

/*************************************************************************
function: AxfDelay - Sleep for n seconds 
*/
data_ptr AxfDelay(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    double d;
    int n;
    d = DblFromArgArray(argDatum, 0);
    ACImOk();       /* calling task should not block on sleeping
                 * task */
    /* convert seconds to milliseconds */
    n = (int)(1000.0 * d);
    AxSleepMilliseconds(MAX(0, n));
    return(NullDataPtr);
#endif
}

/*************************************************************************
function: AxfAbsPath - Return Absolute path from linked/relative path
*/
data_ptr AxfAbsPath(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    char *name = StrFromArgArray(argDatum,0);
    char            path[STRPATH + 1];

    if (!name[0])
        return(ELF_CREATE_STRING(""));
    else {
        MakeAbsolutePathname(path, name, TRUE);
        return(ELF_CREATE_STRING(path));
    }
#endif
}

/*************************************************************************
function: ElfbDelete - Delete a file.
*/
ElfbDelete(filename)
    char           *filename;
{
    struct stat     statbuf;
    int             code;

    /* The current 'files in use' list strategy involves storage of the
        file's inodes (and not filename). If the file is deleted from
        the disk, the inodes can be recycled and used for another new
        file, which would be blocked from opening unless we remove those
        inodes from the 'in use' list. */
    AFDoneWithFile( filename);

    if (0 != Astat(filename, &statbuf))
        /* deleting a file which is not there is ok */
        return;
    if ((statbuf.st_mode & S_IFMT) == S_IFDIR) {
        ElfStrAbort(FEEISDIR, NULL, filename);
    } else {
        code = unlink(filename);
        if ((code == -1) && (errno != ENOENT))
            ElfStrAbort(ErrnoErr(),NULL,filename);
    }
    return;
}

/*************************************************************************
function: AxfRecursiveDelete - Delete a file/dir
? ?c Does not use Armdir - I could not figure out what second arg really means
*/
data_ptr AxfRecursiveDelete(argDatum)
data_ptr argDatum;
{
    char *filename = StrFromArgArray(argDatum,0);

    /* char temp[STRPATH+1], name[STRPATH+1]; */
    char            temp[STRPATH + 1], *name;
    struct stat     statbuf;

    int             code;
    char          **filesInDir;
    int             fileDex;
    data_ptr        nameD;

    if (0 != Astat(filename, &statbuf))
        /* deleting a file which is not there is OK */
        return (NullDataPtr);
    
    if ((statbuf.st_mode & S_IFMT) == S_IFDIR) {
        filesInDir = AxListFilesInDir(filename);
        for (fileDex = 0; name = filesInDir[fileDex]; fileDex++) {
            if ((strcmp(name, ".") == 0) ||
                (strcmp(name, "..") == 0)) {
                continue;   /* finite recursion preferred */
            }
            sprintf(temp, "%s/%s", filename, name);
            nameD = ELF_CREATE_ARRAY(1);
            nameD = ElfAddStrToArray(nameD,0,temp);
            AxfRecursiveDelete(nameD);
            AxFreeData(nameD);
        }
        rmdir(filename);
        AxListFilesFreer(filesInDir);
    } else {
        code = unlink(filename);
        if ((code == -1) && (errno != ENOENT))
            ElfAbort(ErrnoErr());
    }
    return(NullDataPtr);
}

/*************************************************************************
function: AxfDeleteDir - Delete a directory
??c Does not use Armdir - I could not figure out what second arg really means
*/
data_ptr AxfDeleteDir(argDatum)
data_ptr argDatum;
{
    char *dirname = StrFromArgArray(argDatum,0);
    struct stat     statbuf;
    char          **filesInDir = NULL;
    int ix;
    int is_empty = TRUE;
    char *name;

    if (0 != Astat(dirname, &statbuf))
        /* deleting a file which is not there is OK */
        return(NullDataPtr);
    if ((statbuf.st_mode & S_IFMT) == S_IFDIR) {
        filesInDir = AxListFilesInDir(dirname);
        for (ix = 0; name = filesInDir[ix]; ix++) {
            if (strcmp(name, ".") == 0)
                continue;
            if (strcmp(name, "..") == 0)
                continue;
            is_empty = FALSE;
            break;
        }
#if 0
        if (filesInDir[0]) {
            ElfStrAbort(FEENOTEMPTY, NULL, dirname);
        }
#endif
        if (filesInDir)
            AxListFilesFreer(filesInDir); /* free mem */
        if (is_empty)
            rmdir(dirname);
        else
            ElfStrAbort(FEENOTEMPTY, NULL, dirname);
    } else {
        ElfStrAbort(FEENOTDIR, NULL, dirname);
    }
    return(NullDataPtr);
}

/*************************************************************************
function: AxfInt - Return integer part of a floating point number
                    matchtes the Spreadsheets int function  
*/
#define EPS 0.00000003  /* machine accuracy for a 32 bit word */
data_ptr AxfInt(argDatum)
data_ptr argDatum;
{
    double x = DblFromArgArray(argDatum,0);

    if (x > 0.0)    {
        x += EPS;
        return (ELF_CREATE_NUMBER(floor(x)));
    } else  {
        x -= EPS;
        return (ELF_CREATE_NUMBER(ceil(x)));
    }
}

/*************************************************************************
function: ElfbExit - Term with code/str
!!0 VERY IMPORTANT: MUST ROLL ELF STACK BACK!! BIG MEMORY LEAK HERE!!!
*/
ElfbExit(p)
data_ptr        p;
{
    AxExitWithData(0, p);
}

/*************************************************************************
function: AxfNlog - Return natural log
*/
data_ptr AxfNlog(argDatum)
data_ptr argDatum;
{
#if !AXMSBUG
    double n = DblFromArgArray(argDatum,0);

    VERIFY(n > EPSILON, ERR_ARITHMETIC);
    return(ELF_CREATE_NUMBER(log(n)));
#endif
}

/*************************************************************************
function: Axflog10 - Return decimal log
*/
data_ptr Axflog10(argDatum)
data_ptr argDatum;
{
    double          n = DblFromArgArray(argDatum,0);
#if !AXMSBUG
    VERIFY(n > EPSILON, ERR_ARITHMETIC);
    return (ELF_CREATE_NUMBER(log10(n)));
#endif
}

/*************************************************************************
function: Axfsqrt - Return the sqrae root of a number
*/
data_ptr Axfsqrt(argDatum)
data_ptr argDatum;
{
#if !AXMSBUG
    double          n = DblFromArgArray(argDatum,0);
    double          sqrt();

    VERIFY(n >= 0.0, ERR_ARITHMETIC);
    return(ELF_CREATE_NUMBER(sqrt(n)));
#endif
}

/*************************************************************************
function: AxfSysMode - Set/Reset system mode
*/
data_ptr AxfSysMode(argDatum)
data_ptr argDatum;
{
    register int    n = IntFromArgArray(argDatum,0);
    extern int      ElfSysMode;

    ElfSysMode = (n != 0);
    return(NullDataPtr);
}

/*************************************************************************
function: AxfReadBigFile - Read an ascii file into a 2-d array of strings
*/
data_ptr AxfReadBigFile(argDatum)
data_ptr argDatum;
{
    char *filename = StrFromArgArray(argDatum,0);
    register FILE *fp;
    register int dex;
    register data_ptr aP, topP;
    char *buf;
    int pid, err, read_only;

#define BIG_FILE_BREAK 1000

    /* open the file */
    topP = ELF_CREATE_ARRAY(0);
    aP = ELF_CREATE_ARRAY(0);
    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(filename, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, filename);
    fp = (FILE *)AFTaskfopen(pid, filename, READ_BINARY_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(filename, pid, read_only);
        ElfStrAbort(err, NULL, filename);
    }

    /* read the file */
    for (dex = 0; buf = AxMFgets(fp); dex++) {

        /* Create new sub array if needed, add current to top array */

        if (dex == BIG_FILE_BREAK) {
            topP = WriteArray(topP, ElfbArraySize(topP), aP);
            aP = ELF_CREATE_ARRAY(0);
            dex = 0;
        }
        aP = ElfAddStrToArray(aP, dex, buf);
    }
    if (ElfbArraySize(aP) != 0)
        topP = WriteArray(topP, ElfbArraySize(topP), aP);

    /* close the file */
    if ( AFfclose(filename, read_only, fp) == EOF )
        err = ErrnoErr();
    else
        err = AOK;
    AFTaskUnlockFile(filename, pid, read_only);
    return(topP);
}

/*************************************************************************
function: AxfWriteFile - Write an array of strings as a file
*/
data_ptr AxfWriteFile(argDatum)
data_ptr argDatum;
{
    register char  *name = StrFromArgArray(argDatum,0);
    register data_ptr strs = AnyFromArgArray(argDatum,1);
    register FILE *fp;
    register char *p;
    register int ix;
    int size, err, pid, read_only;
    int is_string = FALSE;

    if(AxIsString(strs))
        is_string = TRUE;   /* single string passed */
    else
        size = ElfbArraySize(strs); /* validates is actually an array */

    /* lock the file for writing */
    pid = THIMpid;
    read_only = FALSE;
    err = AFTaskLockFile(name, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, name);
    fp = (FILE *)AFTaskfopen(pid, name, WRITE_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(name, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, name);
    }

    if(is_string)   {
        p = StrFromDataPtr(strs);
        fwrite(p, strlen(p), 1, fp);
        if ((errno = ferror(fp)) != 0) {
            AFfclose(name, read_only, fp);
            AFTaskUnlockFile(name, pid, read_only);
            unlink(name);
            ElfStrAbort(ErrnoErr(),NULL,name);
        }
    }else   {
        for (ix = 0; ix < size; ix++) {
            p = StrFromArray(strs, ix);
            fwrite(p, strlen(p), 1, fp);
            if ((errno = ferror(fp)) != 0) {
                AFfclose(name, read_only, fp);
                AFTaskUnlockFile(name, pid, read_only);
                unlink(name);
                ElfStrAbort(ErrnoErr(),NULL,name);
            }
            fwrite("\n", 1, 1, fp);
        }
    }

    if ( AFfclose(name, read_only, fp) == EOF )
        err = ErrnoErr();
    else
        err = AOK;
    AFTaskUnlockFile(name, pid, read_only);
    if ( err != AOK )
    {
        unlink(name);
        ElfStrAbort(err,NULL,name);      
    }

    return(NullDataPtr);
}

/*************************************************************************
function: AxfWriteBigFile - Write a 2-d array of strings as a file
*/
data_ptr AxfWriteBigFile(argDatum)
data_ptr argDatum;
{
    register char  *name = StrFromArgArray(argDatum,0);
    register data_ptr strs = AnyFromArgArray(argDatum,1);
    register data_ptr substrs;
    register FILE  *fp;
    register char  *p;
    register int    ix, jx;
    int size, subsize, err, pid, read_only;

    size = ElfbArraySize(strs); /* validates is actually an array */

    /* lock the file for writing */
    pid = THIMpid;
    read_only = FALSE;
    err = AFTaskLockFile(name, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, name);
    fp = (FILE *)AFTaskfopen(pid, name, WRITE_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(name, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, name);
    }

    for (ix = 0; ix < size; ix++) {
        substrs = AnyFromArray(strs, ix);
        subsize = ElfbArraySize(substrs);
        for (jx = 0; jx < subsize; jx++) {
            p = StrFromArray(substrs, jx);
            fwrite(p, strlen(p), 1, fp);
            if ((errno = ferror(fp)) != 0) {
                AFfclose(name, read_only, fp);
                AFTaskUnlockFile(name, pid, read_only);
                unlink(name);
                ElfAbort(ErrnoErr());
            }
            fwrite("\n", 1, 1, fp);
        }
    }
    if ( AFfclose(name, read_only, fp) == EOF )
        err = ErrnoErr();
    else
        err = AOK;
    AFTaskUnlockFile(name, pid, read_only);
    if ( err != AOK )
    {
        unlink(name);
        ElfStrAbort(err,NULL,name);      
    }

    return(NullDataPtr);
}


/*************************************************************************
function: AxfNumToStr - Convert a number to a character
*/
data_ptr AxfNumToStr(argDatum)
data_ptr argDatum;
{
#if 1
    int n = IntFromArgArray(argDatum,0);

    /* conditioned for wide characters */
    wchar           char_value[2];
    mbchar          p[5];

    char_value[0] = n;
    char_value[1] = 0;
    WToMbStr(char_value, p);
    return(ELF_CREATE_STRING(p));
#else
    /* the old narrow char way */
    char            buf[5];

    buf[0] = n;
    buf[1] = 0;
    return(ELF_CREATE_STRING( buf));
#endif
}

/*************************************************************************
function: AxfStrToNum - Convert a character to a number
*/
data_ptr AxfStrToNum(argDatum)
data_ptr argDatum;
{
#if 1
    /*** conditioned for wide characters */
    mbchar         *p = (mbchar *)StrFromArgArray(argDatum,0);
    int             ret;

    if (IS_MULTI_BYTE(p))
        ret = MAKE_WIDE_FROM_MULTI(p);
    else
        ret = (*p & 0xFF);
    return(ELF_CREATE_INTEGER(ret));
#else
    return(ELF_CREATE_STRING(*p));
#endif
}

/*************************************************************************
function: AxfStrToValue - Convert a string to a numeric value.

Handles decimal points, thousands separators, and parentheses properly;
e.g. (1,000) is -1000. Returns...
*/
data_ptr AxfStrToValue(argDatum)
data_ptr argDatum;
{
    mbchar         *p = (mbchar *)StrFromArgArray(argDatum,0);
    double  dval;
    int     ival, retval;
    int     is_int;

    retval = ParseNumSimple( p, &dval, &ival, &is_int);
    if (!retval) {                      /* Not a good number */
        return(NullDataPtr);
    }
    else {
        if (is_int)
            return(ELF_CREATE_INTEGER( ival));
        else
            return(ELF_CREATE_NUMBER( dval));
    }
}

/*************************************************************************
function: AxfTabsToSpaces - Convert tab chars to spaces chars using a tab width
*/
data_ptr AxfTabsToSpaces(argDatum)
data_ptr argDatum;
{
    register char  *p = StrFromArgArray(argDatum,0);
    register int    twid = IntFromArgArray(argDatum,1);
    register char  *wrtP, *start;
    register int    ix;
    register data_ptr axdRetVal;

    start = wrtP = (char*)malloc( strlen(p)*(twid+1)*sizeof(char));
    while (*p) {
        if (*p == 9) {  /* ASCII TAB */
            for (ix = twid - ((wrtP - start) % twid); ix > 0; ix--)
                *wrtP++ = ' ';
        } else
            *wrtP++ = *p;
        p++;
    }
    *wrtP = 0;

    axdRetVal = ELF_CREATE_STRING(start);
    free( start);
    return(axdRetVal);
}

/*************************************************************************
function: AxfOpenFile
*/
data_ptr AxfOpenFile(argDatum)
data_ptr argDatum;
{
    register char  *name = StrFromArgArray(argDatum,0),
                    *passed_mode = StrFromArgArray(argDatum,1);
    register int    ix;
    register FILE  *fp;
    register char  *mode;
    int err, read_only, grp_access, all_access, exists, filemask;

    /* validate request - find empty file name in open file list */
    SVERIFY(strlen(name), ERR_ILLVAL, name);
    mode = passed_mode;
    if (mode[0] == 0)
        mode = "r";
    if ( !streq(mode, "r") && !streq(mode, "w") && !streq(mode, "a") &&
          !streq(mode,"rb") && !streq(mode,"wb") && !streq(mode,"ab") )
        ElfAbort(ERR_ILLVAL);
    for (ix = 0; ix < MAX_FILES; ix++)
        if (OpenFiles[ix] && streq(OpenFiles[ix], name))
            ElfAbort(ERR_FILEOPEN);
    for (ix = 0; (ix < MAX_FILES) && OpenFiles[ix]; ix++);
    SVERIFY(ix != MAX_FILES, ERR_FILTOOMANY, name);

    /* validate permissions */
    read_only = af_read_only_mode(mode);
    err = AFGetAccessInfo(name, &read_only, &grp_access, &all_access, &exists);
    if ( err != AOK )
        ElfStrAbort(err,NULL,name);      
    if ( read_only != af_read_only_mode(mode) )
    {
        errno = EACCES;
        ElfStrAbort(ErrnoErr(), NULL, name);
    }

    /* lock the file and get update open file list */
    err = AFTaskLockFile(name, 0, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, name);
    fp = (FILE *)AFTaskfopen(0, name, mode);
    if ( !fp )
    {
        AFTaskUnlockFile(name, 0, read_only);
        ElfStrAbort(ErrnoErr(), NULL, name);
    }

    /* set permissions on new files open for write */
    if ( (streq(mode,"w") || streq(mode,"wb")) && exists == FALSE )
    {
        filemask = umask(0);    /* fetch old */
        umask(filemask);/* restore it */
        filemask = ~filemask;   /* use it in a positve rather than
                     * negative manner */
        filemask &= 0666;
        chmod(name, filemask);  /* ?? pass as arg */
    }
    OpenFiles[ix] = strcpy((char *)TaskAlloc(0,strlen(name) + 1), name);
    OpenReadOnly[ix] = read_only;
    OpenFps[ix] = fp;

    return(NullDataPtr);
}

/*************************************************************************
function: AxfReadLine
*/
data_ptr AxfReadLine(argDatum)
data_ptr argDatum;
{
    register char  *name = StrFromArgArray(argDatum,0);
    char            *str;
    register int    ix;

    for (ix = 0; ix < MAX_FILES; ix++) {
        if (OpenFiles[ix] && streq(OpenFiles[ix], name)) {
            if ( str = AxMFgets(OpenFps[ix]) ) {
                return(ELF_CREATE_STRING(str));
            } else
                ElfAbort(ERR_NOREAD);
        }
    }
    ElfAbort(ERR_FILENOPEN);
    return(NullDataPtr);
}

#if FOR_TESTER == 0
/*************************************************************************
function: ElfbProfile - Return a profile value or the NULL datum
*/
data_ptr AxfProfile(argDatum)
data_ptr argDatum;
{
    char *code = StrFromArgArray(argDatum,0);
    char           *p;
    char           *UPbyName();

    if (NULL == (p = UPbyName(code)))
        return(NullDataPtr);
    else
        return(ELF_CREATE_STRING(p));
}

/*************************************************************************
function: AxfProfileByCode - Return profile info
*/
data_ptr AxfProfileByCode(argDatum)
data_ptr argDatum;
{
    int code = IntFromArgArray(argDatum,0);
    char           *p;
    char           *UPbyCode();

    if (NULL == (p = UPbyCode(code)))
        return(NullDataPtr);
    else
        return(ELF_CREATE_STRING(p));
}

#endif

/*************************************************************************
function: AxfReadBinaryFromFile - Read some data
*/
data_ptr AxfReadBinaryFromFile (argDatum)
data_ptr argDatum;
{
	char *name = StrFromArgArray(argDatum,0);
	data_ptr bP;
	int size = IntFromArgArray(argDatum,1);
	int ix,cnt;

    VERIFY(size >= 0, ERR_ILLVAL);
	bP = ELF_CREATE_BINARY(size);
	if ( size == 0 )
		return(bP);
	for (ix = 0; ix < MAX_FILES; ix++) {
		if (OpenFiles[ix] && streq(OpenFiles[ix], name)) {
			cnt = fread(BX(bP)->bytes,1,size,OpenFps[ix]);
			if ( cnt <= 0 )
				ElfStrAbort(ErrnoErr(), NULL, name);
			if ( cnt != size )
				bP = TruncArray(bP, cnt);
			return(bP);
		}
	}
	ElfAbort(ERR_FILENOPEN);
	return(NullDataPtr);
}


/*************************************************************************
function: AxfWriteBinaryToFile - Write a binary object to an open file
*/
data_ptr AxfWriteBinaryToFile (argDatum)
data_ptr argDatum;
{
	char *name = StrFromArgArray(argDatum,0);
	data_ptr bP = AnyFromArgArray(argDatum,1);
	int len = ElfbBinarySize(bP);
	int ix;

	for (ix = 0; ix < MAX_FILES; ix++) {
		if (OpenFiles[ix] && streq(OpenFiles[ix], name)) {
			if ( OpenReadOnly[ix] ) {
				errno = EACCES;
				ElfStrAbort(ErrnoErr(), NULL, name);
			}
			fwrite(BX(bP)->bytes,len,1,OpenFps[ix]);
			if ( EOF == fflush(OpenFps[ix]) )
				ElfStrAbort(ErrnoErr(), NULL, name);
			return(NullDataPtr);
		}
	}
	ElfAbort(ERR_FILENOPEN);
	return(NullDataPtr);
}

/*************************************************************************
function: AxfWriteLine
*/
data_ptr AxfWriteLine(argDatum)
data_ptr argDatum;
{
    register char  *name = StrFromArgArray(argDatum,0),
                    *str = StrFromArgArray(argDatum,1);
    register int    ix, len;

    for (ix = 0; ix < MAX_FILES; ix++) {
        if (OpenFiles[ix] && streq(OpenFiles[ix], name)) {
            if ( OpenReadOnly[ix] )
            {
                errno = EACCES;
                ElfStrAbort(ErrnoErr(), NULL, name);
            }
            fwrite(str, strlen(str), 1, OpenFps[ix]);
            fputc('\n',OpenFps[ix]);
            if ( EOF == fflush(OpenFps[ix]) )
                ElfStrAbort(ErrnoErr(), NULL, name);
            return(NullDataPtr);
        }
    }
    ElfAbort(ERR_FILENOPEN);
    return(NullDataPtr);
}


/*************************************************************************
function: AxfCloseFile - Close a Unix file by name
*/
data_ptr AxfCloseFile(argDatum)
data_ptr argDatum;
{
    register char *name = StrFromArgArray(argDatum,0);
    register int ix;
    int err;

    for (ix = 0; ix < MAX_FILES; ix++) {
        if (OpenFiles[ix] && streq(OpenFiles[ix], name)) {
            if ( AFfclose(name, OpenReadOnly[ix], OpenFps[ix]) == EOF )
                err = ErrnoErr();
            else
                err = AOK;
            AFTaskUnlockFile(name, 0, OpenReadOnly[ix]);
            if ( err != AOK )
                ElfStrAbort(err, NULL, name);
            TaskFree(0,OpenFiles[ix]);
            OpenFiles[ix] = 0;
            return(NullDataPtr);
        }
    }
    ElfAbort(ERR_FILENOPEN);
}

/*************************************************************************
function: AxfMkdir - Create a directory
This does NOT use Amkdir because it can degrade to a system() call.
*/
data_ptr AxfMkdir(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
    char           *p;

    if (DocTypeFromName(name))  /* don't make a directory that looks like */
        ElfAbort(ERR_ILLVAL);   /* a document name! */
    /* name cannot start with #,
    would be confused with shell parameter reference  */
    if (*name == '#') ElfAbort(ERR_ILLVAL);
    for (p = name; *p; p++) {
#if 1   /* !!0 for now because of Arcade's data:Dataset1 naming! */
#if AXMS
        /* NT/Win95: allow spaces in directory names. */
        if (iscntrl(*p) || strchr("?*!", *p))
#else
        if (iscntrl(*p) || strchr("?* !", *p))
#endif
#else
        if ((*p < 32) || strchr("?* !:", *p))
#endif
            ElfAbort(ERR_ILLVAL);
    }
    if (0 != mkdir(name, 0770))
        ElfAbort(ErrnoErr());

    return(NullDataPtr);
}

/*************************************************************************
function: ElfbCopyFile - Copy a directory from one place to another
*/
ElfbCopyFile(src, passed_dst)
char *src, *passed_dst;
{
#if !FOR_TESTER
    char name[STRPATH+1], dir[STRPATH+1], dst[STRPATH+1], *buf;
    int mode, mask, size, cnt, err, exists, pid, read_only;
    FILE *src_fp, *dst_fp;
    struct stat lstat;

    /* validate filenames */
    SVERIFY(strlen(src) <= STRPATH,ERR_STRTOOLONG,src);
    SVERIFY(strlen(passed_dst) <= STRPATH,ERR_STRTOOLONG,passed_dst);

    /* get source file info (must already exist and not be a directory) */
    SVERIFY(0 == Astat(src, &lstat), ErrnoErr(), src);
    SVERIFY(0 == (lstat.st_mode & S_IFDIR), ElfAbort(FEEISDIR), src);

    /* get dest file info */
    strcpy(dst, passed_dst);
    if ( Astat(dst, &lstat) != 0 ) /* file doesn't exist */
        exists = FALSE;
    else /* file exists */
    {
        exists = TRUE;
        if ( lstat.st_mode & S_IFDIR )
        {
            /* dst is a dir, append srcname (copy TO dir, not OVER dir) */
            ParsePath(src, dir, name);
            strcat(dst, DirSlash);
            strcat(dst, name);
            if ( Astat(dst, &lstat) != 0 ) /* file doesn't exist */
                exists = FALSE;
        }
    }

    /* lock/open the source file for read */
    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(src, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, src);
    src_fp = (FILE *)AFTaskfopen(pid, src, READ_BINARY_STR);
    if ( !src_fp )
    {
        AFTaskUnlockFile(src, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, src);
    }

    /* lock/open the destination file for read/write */
    read_only = FALSE;
    err = AFTaskLockFile(dst, pid, &read_only, FALSE);
    if ( err != AOK )
    {
        read_only = TRUE;
        AFfclose(src, read_only, src_fp);
        AFTaskUnlockFile(src, pid, read_only);
        ElfStrAbort(err, NULL, dst);
    }
    dst_fp = (FILE *)AFTaskfopen(pid, dst, WRITE_STR);
    if ( !dst_fp )
    {
        AFTaskUnlockFile(dst, pid, read_only);
        read_only = TRUE;
        AFfclose(src, read_only, src_fp);
        AFTaskUnlockFile(src, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, dst);
    }

    /* copy data from source */
    fseek(src_fp, 0L, 2);
    size = ftell(src_fp);
    fseek(src_fp, 0L, 0);
    if ( size > 0 )
    {
        buf = (char *)TaskAlloc(pid, size+1);
        if ( fread(buf, size, 1, src_fp) == 0 )
        {
            err = ErrnoErr();
            read_only = TRUE;
            AFfclose(src, read_only, src_fp);
            AFTaskUnlockFile(src, pid, read_only);
            read_only = FALSE;
            AFfclose(dst, read_only, dst_fp);
            AFTaskUnlockFile(dst, pid, read_only);
            if ( exists == FALSE )
                unlink(dst);
            TaskFree(pid, buf);
            ElfAbort(err);
        }

        /* write data to destination */
        if ( fwrite(buf, size, 1, dst_fp) != 1 )
        {
            err = ErrnoErr();
            read_only = TRUE;
            AFfclose(src, read_only, src_fp);
            AFTaskUnlockFile(src, pid, read_only);
            read_only = FALSE;
            AFfclose(dst, read_only, dst_fp);
            AFTaskUnlockFile(dst, pid, read_only);
            if ( exists == FALSE )
                unlink(dst);
            TaskFree(pid, buf);
            ElfAbort(err);
        }
        TaskFree(pid, buf);
    }

    /* close/unlock source */
    read_only = TRUE;
    AFfclose(src, read_only, src_fp);
    AFTaskUnlockFile(src, pid, read_only);

    /* close/unlock destination */
    read_only = FALSE;
    if ( AFfclose(dst, read_only, dst_fp) == EOF )
        err = ErrnoErr();
    else
        err = AOK;
    AFTaskUnlockFile(dst, pid, read_only);
    if ( err != AOK )
    {
        if ( exists == FALSE )
            unlink(dst);
        ElfAbort(err);
    }

    /* set permissions on new files */
    if ( exists == FALSE )
    {
        mask = umask(0);
        umask(mask);
        mode = 0666 & ~mask;
        chmod(dst, mode);
    }
#endif
}

/*************************************************************************
function: AxfMoveFile - Move a file from one place to another
 This has a side effect - the timestamp is ALWAYS changed!!!
*/
data_ptr AxfMoveFile(argDatum)
data_ptr argDatum;
{
	char *src, dstbuf[2*STRPATH + 1];
	char *dst, srcbuf[2*STRPATH + 1];
	char pathname[STRPATH + 1];
	char filename[STRPATH + 1];
	char dirname [STRPATH + 1];
	struct stat statbuf;

	/* get the source path */
	src = StrFromArgArray(argDatum,0);
	strcpy(srcbuf, src);

	/* get the destination path */
	dst = StrFromArgArray(argDatum,1);
	if ( (0 == Astat(dst, &statbuf)) && (statbuf.st_mode & S_IFMT) == S_IFDIR )
	{
		ParsePath(src, dirname, filename);
		sprintf(pathname, "%s%s%s", dst, DirSlash, filename);
		dst = pathname;
	}
	strcpy(dstbuf, dst);

	/* if absolute paths are different, copy the source into the dest */
	MakeAbsolutePathname(srcbuf, srcbuf, TRUE);
	MakeAbsolutePathname(dstbuf, dstbuf, TRUE);
	if ( streq(dstbuf, srcbuf) == FALSE )
	{
		/* If renaming a directory use Arename */
		/* If this fails, drop back to ElfbCopyFile */
		if ( (0 == Astat(src, &statbuf)) && 
						(statbuf.st_mode & S_IFMT) == S_IFDIR ) {
			if (0 == Arename(src, dst))
				/* Success */
				return(NullDataPtr);
		}

		/* Normal file rename */
		ElfbCopyFile(src, dst);
		ElfbDelete(src);
	}

	/* done */
	return(NullDataPtr);
}

/*************************************************************************
function: AxfAed - Start the THIMBLE ASCII editor
*/
data_ptr AxfAed(argDatum)
data_ptr argDatum;
{
    int isdoc = IntFromArgArray(argDatum,0),
        mode = IntFromArgArray(argDatum,1);
    char *name = StrFromArgArray(argDatum,2);
    int parent_wid = IntFromArgArray(argDatum,3);
    char            opts[STRPATH + 100];
    int uid;

    parent_wid = MAX(0, parent_wid);    /* TM_NULWIN hack */
    VERIFY(!isdoc, ERR_ILLVAL);
    sprintf(opts, NXLT("-pX -u -f%s -i%d"), name, mode);
    opts[2] = 'A' + parent_wid;
    uid = ElfbProc(APUCM, opts);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: AxfGenSafeName - Create a safe name for doc creations
Template must be of the form "Grafix.ag", "Sheet.as"...
This returns item of the form "Grafix4.ag"...
*/
data_ptr AxfGenSafeName(argDatum)
data_ptr argDatum;
{
    char *template = StrFromArgArray(argDatum,0);
    char           *name;

    name = FSGenName(template);
    SVERIFY(name[0], ERR_ILLVAL, template);
    return(ELF_CREATE_STRING(name));
}

/*************************************************************************
function: AxfNewSS - Start new spreadsheet window
*/
data_ptr AxfNewSS(argDatum)
data_ptr argDatum;
{
    char           *name = StrFromArgArray(argDatum,0);
    int             uappid = IntFromArgArray(argDatum,1);
    int             quiet = IntFromArgArray(argDatum,2);
    char            opts[STRPATH + 3];
    int uid;

    XmPutBusyCursor(NULL);
    if (quiet)
        sprintf(opts, NXLT("\"-c%s\" -W%d -B"), name, uappid); /* don't Map the window */
    else
        sprintf(opts, NXLT("\"-c%s\" -W%d"), name, uappid);
    uid = ElfbProc(APSS, opts);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: ElfbBookDisplay -
*/
ElfbBookDisplay(name)
    char           *name;
{
    char            opts[STRPATH + 3];
    int uid;

    if (*name)
        sprintf(opts, NXLT("-x -v%s"), name);
    else
        strcpy(opts, NXLT("-cxxx"));
    uid = ElfbProc(APCALC, opts);
    return(uid);
}


/***************************************************************************
function: buildWPcommandLine - build command line string for WP based procs
 (used by AxfNewAE, AxfNewDC, AxfNewHelp)
*/
static char *
buildWPcommandLine (argDatum, argsP)
data_ptr argDatum;
char *argsP;
{
    mbchar *template = (mbchar *)StrFromArgArray(argDatum,0);
    data_ptr uappidP = AnyFromArgArray(argDatum,1);
    data_ptr quietP = AnyFromArgArray(argDatum,2);
    data_ptr readOnlyP = AnyFromArgArray(argDatum,3);
    data_ptr widthP = AnyFromArgArray(argDatum,4);
    data_ptr heightP = AnyFromArgArray(argDatum,5);
    data_ptr titleP = AnyFromArgArray(argDatum,6);
    data_ptr iconP = AnyFromArgArray(argDatum,7);
    data_ptr iconIdP = AnyFromArgArray(argDatum,8);
    int             uappid;
    int             quiet;
    int             readOnly;
    int             width;
    int             height;
    char            *name;
    mbchar          windowTitle[STRPATH+1];
    mbchar          iconTitle[STRPATH+1];
    char            opts[2*STRPATH + 64];

    if ( !template )
        template = (mbchar *)"";
    name = FSGenName(template);
    SVERIFY(name[0], ERR_ILLVAL, template);

    uappid = AxIntFromDataPtr(uappidP);
    quiet = AxIntFromDataPtr(quietP);
    readOnly = AxIntFromDataPtr(readOnlyP);
    width = AxIntFromDataPtr(widthP);
    height = AxIntFromDataPtr(heightP);
    MBstrcpy(windowTitle, AxStrFromDataPtr(titleP));
    MBstrcpy(iconTitle, AxStrFromDataPtr(iconP));

    /* Options */
    MBstrcpy(opts, NXLT(""));
    if (quiet)              /* windowless */
        sprintf(opts, NXLT("%s -B"), opts);
    if (readOnly)           /* read-only */
        sprintf(opts, NXLT("%s -r"), opts);
    if (width > 0)          /* Specific width */
        sprintf(opts, NXLT("%s -w%d"), opts, width);
    if (height > 0)         /* Specific height */
        sprintf(opts, NXLT("%s -h%d"), opts, height);
    if ( windowTitle[0] )   /* window title */
        sprintf(opts, NXLT("%s -T \"%s\""), opts, windowTitle);
    if ( iconTitle[0] )     /* icon title */
        sprintf(opts, NXLT("%s -t \"%s\""), opts, iconTitle);
    if ( iconIdP )
        sprintf(opts, NXLT("%s -I%d"), opts, AxIntFromDataPtr(iconIdP));

    /* Build the overall command line */
    sprintf(argsP, NXLT("\"-c%s\" -W%d %s"), name, uappid, opts);

    return(argsP);
}

/*************************************************************************
function: AxfNewAE - Start new Macro Editor window
*/
data_ptr AxfNewAE(argDatum)
data_ptr argDatum;
{
    char args[3*STRPATH + 128];
    int uid;

    XmPutBusyCursor(NULL);

    buildWPcommandLine(argDatum, args);
    uid = ElfbProc(APUCM, args);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: AxfNewDC - Start new DC
*/
data_ptr AxfNewDC(argDatum)
data_ptr argDatum;
{
    char args[3*STRPATH + 128];
    int uid;

    XmPutBusyCursor(NULL);

    buildWPcommandLine(argDatum, args);
    uid = ElfbProc(APDC, args);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: AxfNewHLP - Start new WP in Help mode
*/
data_ptr AxfNewHLP(argDatum)
data_ptr argDatum;
{
    char args[3*STRPATH + 128];
    char opts[3*STRPATH + 128];
    int uid;

    XmPutBusyCursor(NULL);

    buildWPcommandLine(argDatum, opts);
    sprintf(args, NXLT("-H %s"), opts);
    uid = ElfbProc(APDC, args);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: AxfNewHTML - Start new HTML Authoring System
*/
data_ptr AxfNewHTML(argDatum)
data_ptr argDatum;
{
    char args[3*STRPATH + 128];
    int uid;

    XmPutBusyCursor(NULL);

    buildWPcommandLine(argDatum, args);
    uid = ElfbProc(APHTML, args);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: AxfNewGE - Start new graphics editor window
*/
data_ptr AxfNewGE(argDatum)
data_ptr argDatum;
{
    char *template = StrFromArgArray(argDatum,0);
    int  uappid    = IntFromArgArray(argDatum,1);
    int  quiet     = IntFromArgArray(argDatum,2);
    char *name, opts[STRPATH+3];
    int uid;

    /* create a new filename from the template */
    XmPutBusyCursor(NULL);
    name = FSGenName(template);
    SVERIFY(name[0], ERR_ILLVAL, template);

    /* format the command line (file to create, menubar id) */
    sprintf(opts, NXLT("\"-c%s\"" "-W%d"), name, uappid);
    if ( quiet )
        strcat(opts, NXLT(" -B"));

    /* start a new task and return the uid */
    uid = ElfbProc(APGE, opts);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: AxfNewGP - Start new presentation editor window
*/
data_ptr AxfNewGP(argDatum)
data_ptr argDatum;
{
    char *template = StrFromArgArray(argDatum, 0);
    int  uappid    = IntFromArgArray(argDatum, 1);
    int  quiet     = IntFromArgArray(argDatum, 2);
    int  doc_type  = IntFromArgArray(argDatum, 3);
    int  layout    = IntFromArgArray(argDatum, 4);
    char *name, opts[STRPATH+3];
    int uid;

    /* create a new filename from the template */
    XmPutBusyCursor(NULL);
    name = FSGenName(template);
    SVERIFY(name[0], ERR_ILLVAL, template);

    /* format the command line (presentation, file to create, menubar id) */
    sprintf(opts, NXLT("-a -c%s -W%d"), name, uappid);
    if ( quiet )
        strcat(opts, NXLT(" -B")); /* no window flag */

    /* start a new task and return the uid */
    uid = ElfbProc(APGE, opts);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
}

/*************************************************************************
function: ElfbAllowNew - Set to allow command key to work
*/
ElfbAllowNew()
{
    extern int      ElfAllowNewTask;

    ElfAllowNewTask = TRUE;
}

#if TESTER == 0
/*************************************************************************
function: AxfFindElfFile - Search standard dirs for an Elf file
Returns either full path or an empty string.
*/
data_ptr AxfFindElfFile(argDatum)
data_ptr argDatum;
{
    char *entryname = StrFromArgArray(argDatum,0);
    char            path[STRPATH + 1];
    long            junk;

    if (!FindThimbleFile(THIM_FIND_ELF, entryname, path, &junk, &junk))
        path[0] = 0;
    return(ELF_CREATE_STRING(path));
}

char *AGetHomeDir();

/*************************************************************************
function: AxfGetenv - Get the value of an environment var or return ""
*/
data_ptr AxfGetenv(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
    char           *p;

#if AXMS 
    if ( strcmp( name, NXLT("HOME") ) == 0 )
       {
       /* special case a common case for now */
       p = AGetHomeDir();
       }
    else
#endif
    p = getenv(name);
    if (p == NULL)
        return(NullDataPtr);
    else
        return(ELF_CREATE_STRING(p));
}

#endif

/*************************************************************************
function: AxfIsFunc - Return whether passed arg is a func entry ptr
*/
data_ptr AxfIsFunc(argDatum)
data_ptr        argDatum;
{
    if (XX(argDatum) && !IS_INTEGER(argDatum) && (SX(argDatum)->type == TYPE_ENTRY))
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(BFALSE));
}

/*************************************************************************
function: UnixToApplixTime - Convert Unix long date to Applix long date
*/
unsigned long UnixToApplixTime(u)
time_t   u;
{
#if !FOR_TESTER && !AX_STUB
    unsigned long   f;
    struct tm      *p;

#if !AX_STUB    /* removed item alloced but not freed. related?... zane */
    struct tm      *localtime();
#endif
    unsigned long   val;

    p = localtime(&u);
    f = 60 / DTTIMEGRANULARITY;
    val = p->tm_sec / DTTIMEGRANULARITY +
        (p->tm_min * f) +
        (p->tm_hour * f * 60) +
        (p->tm_mday * f * 60 * 24) +
        ((p->tm_mon + 1) * f * 60 * 24 * 32) +
        ((p->tm_year + 1900 - DTTIMEBASEYEAR) * f * 60 * 24 * 32 * 13);
    return (val);
#endif
}

/*************************************************************************
function: AxfDatePieces - Decompose date number to array
*/
data_ptr AxfDatePieces(argDatum)
data_ptr argDatum;
{
    time_t   u = IntFromArgArray(argDatum,0);

#if !FOR_TESTER && !AX_STUB

    struct tm      *p, *localtime();
    data_ptr        aP;
    aP = ELF_CREATE_ARRAY(9);
    p = localtime(&u);
    ElfAddNumToArray(aP, 0, p->tm_sec);
    ElfAddNumToArray(aP, 1, p->tm_min);
    ElfAddNumToArray(aP, 2, p->tm_hour);
    ElfAddNumToArray(aP, 3, p->tm_mday);
    ElfAddNumToArray(aP, 4, p->tm_mon);
    ElfAddNumToArray(aP, 5, p->tm_year);
    ElfAddNumToArray(aP, 6, p->tm_wday);
    ElfAddNumToArray(aP, 7, p->tm_yday);
    ElfAddNumToArray(aP, 8, p->tm_isdst);
#endif

    return(aP);
}

/*************************************************************************
function: AxfFormatDate - Convert a Unix date val to a date string
Takes Daylight savibgs time into consideration. If second arg is
a number it refers to a format in datetime.sp. If it is a string, it
is the format string itself. 
*/

data_ptr AxfFormatDate(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER && !AX_STUB
    long dval;
    int mode;
    char *fmt;
    long        clock;
    char        datestr[100];

    dval = IntFromArgArray(argDatum,0);
    if (AxIsString(AxArrayElement(argDatum, 1))) { /* format string is given */
        char datestr[240];
        fmt =  StrFromArgArray(argDatum,1);
        Formatdt_str_unix(dval, fmt, datestr);
        return(ELF_CREATE_STRING(datestr));
    }
    mode = IntFromArgArray(argDatum,1);
    if (mode < 10000)
        clock = UnixToApplixTime(dval);
    else {
        clock = dval;
        mode = mode - 10000;
    }

    Formatdt(clock, mode, datestr);
    return(ELF_CREATE_STRING(datestr));
#endif
}

/*************************************************************************
function: AxfFormatDate_Str - Convert a Applix date val to a date string
using a fmt string instead of a mode number.
Takes Daylight savibgs time into consideration.
*/

data_ptr AxfFormatDate_Str(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER && !AX_STUB
    long            dval = IntFromArgArray(argDatum,0);
    char            *fmt = StrFromArgArray(argDatum,1);
    char        datestr[240];

    Formatdt_str(dval, fmt, datestr);
    return(ELF_CREATE_STRING(datestr));
#endif
}

/*************************************************************************
function: AxfCurrentTime - Return current Unix time
*/
data_ptr AxfCurrentTime()
{

    return(ELF_CREATE_INTEGER(time(0L)));
}

/*************************************************************************
function: AxfElfbDayArray - returns a "calendar" for the passed month.

This is a 42-member array that should be visualized as a 6 x 7 grid,
containing the day of the month or -1. A picture is worth a 1000 words,
so here is what you get back for May 1999:
    -1  -1  -1  -1  -1  -1   1
     2   3   4   5   6   7   8
     9  10  11  12  13  14  15
	16  17  18  19  20  21  22
	23  24  25  26  27  28  29
	30  31  -1  -1  -1  -1  -1
The days run Sunday to Saturday. Again, you get back a 42-member array;
the caller is free to arrange it as above.
*/
data_ptr
AxfElfbDayArray( argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER

	int month = AxIntFromArray(argDatum, 0);
	int year = AxIntFromArray(argDatum, 1);
	data_ptr rData;
	register int day, dw, dm;
	int *pday, ix;

	rData = MkArray(42);

	if (month == 9 && year == 1752) {
		if (day_of_year)
			pday = j_sep1752;
		else
			pday = sep1752;
		for (ix=0; ix<MAXDAYS; ++ix, ++pday)
			if (*pday != SPACE)
				rData = ElfAddNumToArray(rData,ix,*pday);
		return( rData);
	}
	dm = days_in_month[leap_year(year)][month];
	dw = day_in_week(1, month, year);
	day = day_of_year ? day_in_year(1, month, year) : 1;
	while (dm--)
		rData = ElfAddNumToArray(rData,dw++,day++);
	return( rData);
#endif
}


/*
 * day_in_year --
 *	return the 1 based day number within the year
 */
day_in_year(day, month, year)
	register int day, month;
	int year;
{
#if !FOR_TESTER

	register int i, leap;

	leap = leap_year(year);
	for (i = 1; i < month; i++)
		day += days_in_month[leap][i];
	return(day);
#endif
}

/*
 * day_in_week
 *	return the 0 based day number for any date from 1 Jan. 1 to
 *	31 Dec. 9999.  Assumes the Gregorian reformation eliminates
 *	3 Sep. 1752 through 13 Sep. 1752.  Returns Thursday for all
 *	missing days.
 */
day_in_week(day, month, year)
	int day, month, year;
{
#if !FOR_TESTER

	long temp;

	temp = (long)(year - 1) * 365 + leap_years_since_year_1(year - 1)
	    + day_in_year(day, month, year);
	if (temp < FIRST_MISSING_DAY)
		return((temp - 1 + SATURDAY) % 7);
	if (temp >= (FIRST_MISSING_DAY + NUMBER_MISSING_DAYS))
		return(((temp - 1 + SATURDAY) - NUMBER_MISSING_DAYS) % 7);
	return(THURSDAY);
#endif
}



/*************************************************************************
function: AxfSeedRand - Cause UNIX rand() to be seeded (with time of day)

Stolen from axelf/livedata.c
*/
data_ptr AxfSeedRand()
{
    srand(time(0L));
    return(ELF_CREATE_INTEGER(rand()));
}


/*************************************************************************
function: AxfRand - Return a 32-bit random number from UNIX rand()

Stolen from axelf/livedata.c
*/
data_ptr AxfRand()
{
    long            rnd;
    int             result;

    /*
     * Since SysV creates 15bit nums & Berkley 31 bit nums, call rand()
     * twice
     */
    rnd = (rand() & 0x7FFF) | ((rand() & 0x7FFF) << 16);
    result = rnd;
    return(ELF_CREATE_INTEGER(result));
}

#if FOR_TESTER == 0

/*************************************************************************
function: AxfMaxStrlen - Return length of longest str in array
*/
data_ptr AxfMaxStrlen(argDatum)
data_ptr argDatum;
{
    data_ptr theStr = AnyFromArgArray(argDatum,0);
    int             size;
    int             len, ix;
    int             max = 0;

    size = ElfbArraySize(theStr);/* validates is actually an array */
    for (ix = 0; ix < size; ix++) {
        len = strlen(StrFromArray(theStr, ix));
        max = MAX(len, max);
    }
    return(ELF_CREATE_INTEGER(max));
}

/*************************************************************************
function: AxfValDocName - Determined whether name is a valid doc name
*/
data_ptr AxfValDocName(argDatum)
data_ptr argDatum;
{
    char           *passed_name = StrFromArgArray(argDatum,0);
    typeErr         err;

    err = IsValidPathFilename(passed_name);
    if ( err == AOK )
         return(ELF_CREATE_INTEGER( BTRUE ));
    else
         return(ELF_CREATE_INTEGER( BFALSE ));
}

/*************************************************************************
function: AxfGetDisplayVar  - return the current X display
*/
data_ptr AxfGetDisplayVar()
{
    return(ELF_CREATE_STRING(AxDisplayName));
}

/*************************************************************************
function: AxfGetTempDir - Return the name of the temps directory
*/
data_ptr AxfGetTempDir()
{
    return(ELF_CREATE_STRING(ThimTempDir));
}

/*************************************************************************
function: AxfGetLangDir - Return the name of the Alternate language dir
*/
data_ptr AxfGetLangDir()
{
    return(ELF_CREATE_STRING(ThimLangDir));
}

/*************************************************************************
function: AxfGetDataDir - Return the name of the system dir
*/
data_ptr AxfGetDataDir()
{
    return(ELF_CREATE_STRING(ThimApplixDir));
}

/*************************************************************************
function: AxfGetFilterDir - Return the name of the filters dir
*/
data_ptr AxfGetFilterDir()
{
    return(ELF_CREATE_STRING(ThimFiltersDir));
}

/*************************************************************************
function: AxfGetCustomDir - Return the name of the custom dir
*/
data_ptr AxfGetCustomDir()
{
    return(ELF_CREATE_STRING(ThimCustomDir));
}

/*************************************************************************
function: AxfSetPresTemplateDir - set the name of the current template dir
*/
data_ptr AxfSetPresTemplateDir(argDatum)
data_ptr argDatum;
{
    char           *passed_name = StrFromArgArray(argDatum,0);
    char            name[STRPATH + 1];
    char *p;

    /* Prohibit directories that have long names */
    if (strlen(passed_name) > STRPATH) {
        ElfStrAbort(ERR_STRTOOLONG, XLT("\nPathname too long"), passed_name);
        return(NullDataPtr);
    }

    strcpy(name, passed_name);
    AxSysDosUnixPath(name);

    /* go through an "clean up" the name, and handle some special cases */
    if ( streq( name, ".." ) )
       {
       /* move up one level on our current path */
       strcpy( name, AxCurrentDir );
       strcat( name, DirSlash );
       strcat( name, ".." );   /* code below will do the right thing */
       }

    p = name + strlen(name) - 1;    /* the last char in the path */
    if ( (*p == '.') && (*(p-1) == *DirSlash) )
    {
       /* a pathname with a single dot on the end. get rid of the "/."  */
       *(p-1) = 0;
    }
    else if ( (*p == '.') && (*(p-1) == '.') && (*(p-2) == *DirSlash) )
    {
       /* a pathname with "/.." on the end, go up one level */
       *(p-2) = 0;   /* step on the last slash */
       p = p - 2; 

       while ( (p > name) && (*p != *DirSlash ) )
          /* find the end of the level above */
          { p--; }
       *p = 0;             /* step on slash to trim one level up */

       if ( *name == 0 )
          /* nothing left, make it root */
          strcpy( name, DirSlash );
    }
    if (0 != Achdir(name))
        ElfStrAbort(ErrnoErr(), NULL, name);
    strcpy(AxPresTemplateDir, name);

    return(NullDataPtr);
}

/*************************************************************************
function: AxfGetPresTemplateDir - Return the name of the current  template dir
*/
data_ptr AxfGetPresTemplateDir()
{
    return(ELF_CREATE_STRING(AxPresTemplateDir));
}

/*************************************************************************
function: AxfGetPresChartDir - Return the name of the chart template dir
*/
data_ptr AxfGetPresChartDir()
{
    return(ELF_CREATE_STRING(ThimPresChartDir));
}

/*************************************************************************
function: AxfGetPresSchemeDir - Return the name of the scheme template dir
*/
data_ptr AxfGetPresSchemeDir()
{
    return(ELF_CREATE_STRING(ThimPresSchemeDir));
}

/*************************************************************************
function: AxfGetPresOutlineDir - Return the name of the outline template dir
*/
data_ptr AxfGetPresOutlineDir()
{
    return(ELF_CREATE_STRING(ThimPresOutlineDir));
}

/*************************************************************************
function: AxfGetPresBklitDir - Return the name of the backlit  template dir
*/
data_ptr AxfGetPresBklitDir()
{
    return(ELF_CREATE_STRING(ThimPresBklitDir));
}

/*************************************************************************
function: AxfGetPres35mmDir - Return the name of the 35mm template dir
*/
data_ptr AxfGetPres35mmDir()
{
    return(ELF_CREATE_STRING(ThimPres35mmDir));
}

/*************************************************************************
function: AxfGetPresMonoDir - Return the name of the mono template dir
*/
data_ptr AxfGetPresMonoDir()
{
    return(ELF_CREATE_STRING(ThimPresMonoDir));
}

/*************************************************************************
function: AxfGetPresColorDir - Return the name of the color template dir
*/
data_ptr AxfGetPresColorDir()
{
    return(ELF_CREATE_STRING(ThimPresColorDir));
}

/*************************************************************************
function: AxfGetClipArtDir - Return the name of the clipart dir
*/
data_ptr AxfGetClipArtDir()
{
    return(ELF_CREATE_STRING(ThimClipArtDir));
}

/*************************************************************************
function: AxfGetAxLangDir - Return the name of the dir holding the
language-dependent files
*/
data_ptr AxfGetAxLangDir()
{
    return(ELF_CREATE_STRING(AxLangDir));
}
/*************************************************************************
function: AxfGetAxLocalLangDir - Return the name of the dir holding the
axlocal language-dependent files
*/
data_ptr AxfGetAxLocalLangDir()
{
    return(ELF_CREATE_STRING(AxLocalLangDir));
}

/*************************************************************************
function: AxfGetAxLangDemosDir - Return the name of the dir holding the
sample macro language-dependent files
*/
data_ptr AxfGetAxLangDemosDir()
{
    return(ELF_CREATE_STRING(AxLangDemosDir));
}

/*************************************************************************
function: AxfGetUserDir - Return name of user's home dir;  if no username
is passed, return the caller's home directory
*/
data_ptr AxfGetUserDir(argDatum)
data_ptr argDatum;
{
    char *username = StrFromArgArray(argDatum,0);

    if (!username[0])
        return(ELF_CREATE_STRING( AGetHomeDir() ));
    else
        return(ELF_CREATE_STRING( AGetUserHomeDir(username) ));
}

/*************************************************************************
function: AxfGetAxHomeDir - Return name of axhome directory in user's dir
*/
data_ptr AxfGetAxHomeDir()
{
    return(ELF_CREATE_STRING( AGetAxHomeDir() ));
}

/*************************************************************************
function: AxfGetEnterpriseDir - Return name of Enterprise base dir
*/
data_ptr AxfGetEnterpriseDir ()
{
    return(ELF_CREATE_STRING(ThimEnterpriseDir));
}

/***************************************************************************
function: AxfGetEnterpriseAppsDir - Return name of Enterprise apps dir
*/
data_ptr AxfGetEnterpriseAppsDir ()
{
    return(ELF_CREATE_STRING(ThimEnterpriseAppsDir));
}

/***************************************************************************
function: AxfGetEnterpriseAppFilename - Return full pathname of Enterprise
client .abo
*/
data_ptr AxfGetEnterpriseAppFilename ()
{
    return(ELF_CREATE_STRING(ThimEnterpriseAppFilename));
}


#endif

data_ptr AxfFuncList()
{
    return(ELF_CREATE_INTEGER(1));
}

#if DEBUG
#if FOR_TESTER
#define ElfbLogFp stdout
#else
FILE           *ElfbLogFp = NULL;

#endif

/*************************************************************************
function: ElfbLogger - Logging routine for elf bltins
*/
LINTCOMMENT(VARARG1)
ElfbLogger(str, a, b, c, d, e, f, g, h, i, j, k)
    char           *str;
    int             a, b, c, d, e, f, g, h, i, j, k;
{
#if FOR_TESTER == 0
    if (!ElfbLogFp)
        ElfbLogFp = fopen(NXLT("zzelfb.log"), "w");
#endif
    fprintf(ElfbLogFp, str, a, b, c, d, e, f, g, h, i, j, k);
    fprintf(ElfbLogFp, "\n");
    fflush(ElfbLogFp);
}

#endif

#if DEBUG
/*************************************************************************
function: ElfbDoLogging - Turn logging on
*/
ElfbDoLogging()
{
    Logging = TRUE;     /* for compiler */
    ElfbLogging = TRUE; /* enables bltins logging */
    ElfLogging = TRUE;  /* enables interprter logging */
}

/*************************************************************************
function: ElfbNoLogging - Turn logging off
*/
ElfbNoLogging()
{
    Logging = FALSE;    /* for compiler */
    ElfbLogging = FALSE;    /* enables bltins logging */
    ElfLogging = FALSE; /* enables interprter logging */
}

#endif

#if FOR_TESTER
ElfPlayTypeAhead()
{
}

#endif

#if !FOR_TESTER
#define MAX_ACCELS 500

/*************************************************************************
function: AxfVfyMenu - Verify sanity of a menu descriptor
Checks for valid accels syntax.
Checks for non-duplicate accels.
Checks for non-duplicate mnemonics.
*/
data_ptr AxfVfyMenu(argDatum)
data_ptr argDatum;
{
    data_ptr        dataP = AnyFromArgArray(argDatum,0);    /* the Elf array */
    char           *menuname = StrFromArgArray(argDatum,1);
    int            *accel_code;
    short          *accel_mods;
    char          **accel_menu;
    char          **accel_name;
    int             num_accels = 0;

    accel_code = (int *) malloc(MAX_ACCELS * sizeof(int));
    accel_mods = (short *) malloc(MAX_ACCELS * sizeof(short));
    accel_menu = (char **) malloc(MAX_ACCELS * sizeof(char *));
    accel_name = (char **) malloc(MAX_ACCELS * sizeof(char *));

    ElfVfySubMenu(dataP, "", &num_accels, accel_code, accel_mods, accel_menu, accel_name);

    free( accel_code);
    free( accel_mods);
    free( accel_menu);
    free( accel_name);

    return(NullDataPtr);
}

ElfVfySubMenu(dataP, menuname,
          num_accels, accel_code, accel_mods, accel_menu, accel_name)
    data_ptr        dataP;  /* the Elf array */
    char           *menuname;

    int            *num_accels;
    int            *accel_code;
    short          *accel_mods;
    char          **accel_menu;
    char          **accel_name;
{
    data_ptr        grpP, cP;
    register int    asize,  /* of name/value/helpid/attribute array */
                    count,  /* how many real items there are */
                    ix, jx;
    char           *TrueRealloc();
    menu_item_def  *MenuGlob();
    char           *name;   /* name of option */
    char           *funcname;   /* name of macro */
    char           *accelstr;
    menu_item_def   mdef;
    char            errbuf[1000];
    char            errstr[1000];
    char           *mnc_str;/* str holding mnemonic key for item */
    char            mnemonic;   /* mnemonic key for item */
    int             num_mnc;/* running count of number of mnemonics in
                 * sub-menu */
    char           *mnc_keys;   /* array of mnemonic keys in sub-menu */
    char          **mnc_names;  /* parallel array of corresponding menu
                     * names */

    count = ElfbArraySize(dataP);

    num_mnc = 0;
    mnc_keys = (char *) TrueMalloc(count);
    mnc_names = (char **) TrueMalloc(count * sizeof(char *));
    memset(mnc_keys, 0, count);
    memset(mnc_names, 0, sizeof(mnc_names));

    /* Fill in the real records */
    for (ix = 0; ix < count; ix++) {
        grpP = AX(dataP)->vals[ix];
        asize = ElfbArraySize(grpP);
        if (asize <= 1)
            continue;
        name = StrFromArray(grpP, 0);
        name = (char *)XLT_Complex_Strip( name );

        cP = AX(grpP)->vals[1];
        if (cP == NULL) /* separator */
            continue;
        if (AX(grpP)->size >= 9) {
            /*
             * complain if duplicate mnemonic in same
             * sub-menu
             */
            mnc_str = StrFromArray(grpP, 8);
            mnc_str = (char *)XLT_Complex_Strip( mnc_str );

            if (mnc_str && (mnc_str[0] != '\0')) {
                /* ignore if no mnemonic ("0" is valid) */
                mnemonic = mnc_str[0];
                if (islower(mnemonic))
                    mnemonic = (char) toupper(mnemonic);
                for (jx = 0; jx < num_mnc; jx++) {
                    if (mnemonic == mnc_keys[jx]) {
                        /*
                         * !! duplicate
                         * mnemonic found in
                         * sub-menu !!
                         */
                        errbuf[0] = mnemonic;
                        errbuf[1] = '\0';
                        strcpy(errstr, AxGetStr(ERR_DUPMNEMONIC));
                        strcat(errstr, "\n");
                        if (menuname && menuname[0]) {
                            sprintf(errstr + strlen(errstr), NXLT("%s-->%s\n"),
                                menuname, mnc_names[jx]);
                            sprintf(errstr + strlen(errstr), NXLT("%s-->%s"),
                                menuname, name);
                        } else {
                            sprintf(errstr + strlen(errstr), "%s\n",
                            mnc_names[jx]);
                            sprintf(errstr + strlen(errstr), "%s", name);
                        }
                        ElfStrAbort(ERR_DUPMNEMONIC, errstr, errbuf);
                    }
                }
                mnc_keys[num_mnc] = mnemonic;
                mnc_names[num_mnc] = name;
                num_mnc++;
            }
        }

        if (ElfbIsString(cP)) {
            funcname = StrFromArray(grpP, 1);
            accelstr = StrFromArray(grpP, 2);

            if (!accelstr || (strlen(accelstr) == 0))
                continue;
 
            accelstr = (char *)XLT_Complex_Strip( accelstr );
 
            if (!ParseKeySequence(accelstr, &mdef)) {
                strcpy(errbuf, accelstr);
                strcpy(errstr, AxGetStr(ERR_BADACCEL));
                strcat(errstr, "\n");
                if (strlen(menuname))
                    sprintf(errstr + strlen(errstr), NXLT("(%s-->%s)"),
                        menuname, name);
                else
                    sprintf(errstr + strlen(errstr), "(%s)", name);
                ElfStrAbort(ERR_BADACCEL, errstr, errbuf);
            }
            for (jx = 0; jx < *num_accels; jx++) {
                if ((accel_code[jx] == mdef.accel_key) &&
                    (accel_mods[jx] == mdef.accel_modifiers)) {
                    strcpy(errbuf, accelstr);
                    strcpy(errstr, AxGetStr(ERR_DUPACCEL));
                    strcat(errstr, "\n");
                    if (strlen(accel_menu[jx]))
                        sprintf(errstr + strlen(errstr), NXLT("%s-->%s\n"),
                            accel_menu[jx], accel_name[jx]);
                    else
                        sprintf(errstr + strlen(errstr), "%s\n", accel_name[jx]);
                    if (strlen(menuname))
                        sprintf(errstr + strlen(errstr), NXLT("%s-->%s"),
                            menuname, name);
                    else
                        sprintf(errstr + strlen(errstr), "%s", name);
                    ElfStrAbort(ERR_DUPACCEL, errstr, errbuf);
                }
            }

            if (*num_accels < MAX_ACCELS) {
                accel_menu[*num_accels] = menuname;
                accel_name[*num_accels] = name;
                accel_code[*num_accels] = mdef.accel_key;
                accel_mods[*num_accels] = mdef.accel_modifiers;

                *num_accels = *num_accels + 1;
            }
        } else if (ElfbIsArray(cP))
            ElfVfySubMenu(cP, name, /* RECURSE */
                      num_accels, accel_code, accel_mods, accel_menu, accel_name);
    }

    if (!AxOpenLook) {
        TrueFree(mnc_keys);
        TrueFree((char *) mnc_names);
    }
}

/*************************************************************************
function: ElfCrtMenuBarDesc Crt a menu bar info array from Elf array
This exactly emulates the behaviour of Read1Menu!
*/
menu_item_def  *ElfCrtMenuBarDesc(dataP)
    data_ptr        dataP;  /* the Elf array */
{
    data_ptr        grpP, cP;
    register menu_item_def *mP, *menuP;
    register int    size,   /* of primary array */
                    asize,  /* of name/value/helpid/attribute array */
                    count,  /* how many real items there are */
                    ix;
    char           *TrueRealloc();
    menu_item_def  *MenuGlob();
    char           *mnc_str;/* mnemonic */
    unsigned char *str;


    count = ElfbArraySize(dataP);

    /* create array making room for header/trailer records */

    size = sizeof(menu_item_def) * (count + 2);

    mP = (menu_item_def *)TaskCalloc( 0, 1, size );
    menuP = mP;

    mP->type = ITEM_MARK;   /* header record */
    mP++;

    /* Fill in the real records */

    for (ix = 0; ix < count; ix++, mP++) {
        grpP = AX(dataP)->vals[ix];
        asize = ElfbArraySize(grpP);
        if (asize == 0) {
            mP->word = "-";
            cP = NULL;
        } else {
            /* Here is a small piece of code which will translate the user */
            /* visible portion of the menu bar dynamically at runtime      */
            str = (unsigned char *)StrFromArray(grpP, 0);  /*user visible */
            mP->word = (char *)XLT_Complex( (mbchar *)str );

            if (asize == 1)
                cP = NULL;
            else
                cP = AX(grpP)->vals[1];
        }
        if (cP == NULL) {
            mP->type = ITEM_LINE;
            if (grpP) {
                if ((AX(grpP)->size >= 4) && IntFromArray(grpP, 3))
                    mP->noshow = TRUE;
                if ((AX(grpP)->size >= 5) && IntFromArray(grpP, 4))
                    mP->toolshow = TRUE;
            }
        } else if (ElfbIsString(cP)) {
            mP->word2 = StrFromArray(grpP, 1);
            mP->type = ITEM_FUNC;
            str = (unsigned char *)StrFromArray(grpP, 2); /*accell string */
            str = (unsigned char *)XLT_Complex( (mbchar *)str );

            ParseKeySequence( str, mP);

            if ((AX(grpP)->size >= 4) && IntFromArray(grpP, 3))
                mP->noshow = TRUE;
            if ((AX(grpP)->size >= 5) && IntFromArray(grpP, 4))
                mP->toolshow = TRUE;
            if (AX(grpP)->size >= 6)
                mP->bitmap = StrFromArray(grpP, 5);
            else
                mP->bitmap = "";
            if (AX(grpP)->size >= 7)
                mP->toolword = StrFromArray(grpP, 6);
            else
                mP->toolword = "";
            if (AX(grpP)->size >= 8)
                mP->tooltype = IntFromArray(grpP, 7);
            if (AX(grpP)->size >= 9) {
                /* mnemonic */
                str = (unsigned char *)StrFromArray(grpP, 8);
                str = (unsigned char *)XLT_Complex( (mbchar *)str );
                mP->menu_key_str = (unsigned char *)str;
            }
#if AXMS
            CheckForClipFromMenuBar( mP );
#endif

        } else if (ElfbIsArray(cP)) {
            mP->type = ITEM_MENU;
            if (AX(grpP)->size >= 9) {
                /* mnemonic */
                str = (unsigned char *)StrFromArray(grpP, 8);
                str = (unsigned char *)XLT_Complex( (mbchar *)str );
                mP->menu_key_str = (unsigned char *)str;
            }
            mP->word2 = (char *) ElfCrtMenuBarDesc(cP); /* RECURSE */
        }
    }

    mP->type = ITEM_MARK;   /* trailer record */
    mP->ender = TRUE;
    return (MenuGlob(menuP, count, size));
}






/*************************************************************************
function: AxfSelections - Create sliders/verb/dialog info for a window type
*/
data_ptr AxfSelections(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    char buf[20];
    char *menufileP;
    int type = IntFromArgArray(argDatum,0);
    data_ptr aP = AnyFromArgArray(argDatum,1);
    int just_register = IntFromArgArray(argDatum,2);

    selects_desc   *p;

    if ( JavaMode ) {
        char name[100];

        sprintf(name,"menubar$vals$%d",type);
        ElfbSetSysVar(name,aP);
        if ( !just_register )
            return(NullDataPtr);
    }

    p = (selects_desc *) TrueMalloc(sizeof(selects_desc));
    p->next = ElfWinSelections;
    ElfWinSelections = p;
    p->wintype = type;
    p->selections = NULL;   /* in case of failure later */
    p->menubar_file[0] = 0;
 
    if ( just_register == 1 )
       {
       /* the passed second argument is the name of the menubar file.  We */
       /* do not load it now, that will be done later in ElfLookupSlider  */
       /* if the menubar is actually referenced                           */
       menufileP = StrFromArgArray(argDatum,1);
       strcpy( p->menubar_file, menufileP );
       return( NullDataPtr );
       }
 

    if (XX(aP) == NULL)
        return(NullDataPtr);
    p->selections = ElfCrtMenuBarDesc(aP);

    /* Free old structure from memory */

#if 0               /* for some reason, this causes SubMenuHidden
                 * to crash! !!0 */
    prev = p;
    for (old = p->next; old; old = tmp, prev = prev->next) {
        tmp = old->next;
        if (old->wintype == type) {
            prev->next = old->next;
            TrueFree(old->selections);
            TrueFree(old);
        }
    }
#endif

    /* Load the updated menu bar to affected windows */

    TmReloadMenuBar(type);

    /* Poke all dialogs */
    sprintf(buf, "%d", type);
    TmPokeDialogs(0, POKE_MENU_BAR, buf);
    return(NullDataPtr);
#endif
}

 



/*************************************************************************
function: AxfSetServices - Create popup slider for services display
*/
data_ptr AxfSetServices(argDatum)
data_ptr argDatum;
{
    extern menu_item_def *ServicesMenuPopup;    /* Elf specified  */
    /* services popup */

    if (XX(argDatum) == NULL) {
        if (ServicesMenuPopup)
            TrueFree((char *) ServicesMenuPopup);
        ServicesMenuPopup = NULL;
        return(NullDataPtr);
    }
    ServicesMenuPopup = ElfCrtMenuBarDesc(argDatum);
    return(NullDataPtr);
}

/*************************************************************************
function: ElfReadMenuBarFile - read contents of menubar file, e.g., "ax_mm4"
*/
data_ptr
ElfReadMenuBarFile(basename)
char *basename;              /* in: basename of menubar file, e.g., "ax_mm4" */
{
    int where_found;
    struct stat status;
    char file_path[STRPATH+1];
	
	if (!(basename && *basename)) {
		return ((data_ptr) NULL);
	}
	
	sprintf(file_path, "%s%s%s", 
			ThimUserDir, DirSlash, basename );
	
	if ( 0 != stat(file_path, &status) ) {
		/* not in axhome, try the others
		 */
		if ( !FindThimbleFile( THIM_FIND_CUSTOM, basename,
							  file_path, &where_found ) ) {
			if ( !FindThimbleFile( THIM_FIND_APPLIX, basename,
								  file_path, &where_found ) ) {
				return( NULL );    /* not found anywhere */
			}
		}
	}

	/* read in the file.  Result is in the global "ElfRetData"
	 */
	ElfbReadDataFile( file_path );
	
	return ( ElfRetData );
}

/*************************************************************************
function: ElfLookupSlider - Return menu bar ptr from id number
*/
menu_item_def  *ElfLookupSlider(wintype)
    int             wintype;
{
    selects_desc   *p;
    data_ptr aP;

    for (p = ElfWinSelections; p; p = p->next)
        {
        if ((p->wintype == wintype) && (p->selections))
            return (p->selections);
        if ( (p->wintype == wintype) && (p->menubar_file[0] != '\0') )
            {
            /* the menubar file name has been registered, but we have */
            /* not yet read it in.  Do so now.                        */
			aP = ElfReadMenuBarFile( p->menubar_file );
            p->selections = ElfCrtMenuBarDesc( aP );
            return (p->selections);
            }
        }

    return (NULL);
}


#endif              /* FOR_TESTER */

/*************************************************************************
function: AxfSuppressDisplay - Enable QuietRunning mode for status messages
*/
data_ptr AxfSuppressDisplay(argDatum)
data_ptr argDatum;
{
    int             mode;
    extern int      QuietRunning;

    /* if arg is null, simply return current state */
    if (AxArrayElement(argDatum, 0) != 0) {
        mode = IntFromArgArray(argDatum,0);
        if (mode)
            QuietRunning = TRUE;
        else
            QuietRunning = FALSE;
    }
    if (QuietRunning)
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(BFALSE));
}

/*************************************************************************
function: AxfSuppressErrsDisplay - Enable QuietErrsRunning mode for error msgs
*/
data_ptr AxfSuppressErrsDisplay(argDatum)
data_ptr argDatum;
{
    int             mode;
    extern int      QuietErrsRunning;

    /* if arg is null, simply return current state */
    if (AxArrayElement(argDatum, 0) != 0) {
        mode = IntFromArgArray(argDatum,0);
        if (mode)
            QuietErrsRunning = TRUE;
        else
            QuietErrsRunning = FALSE;
    }
    if (QuietErrsRunning)
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(BFALSE));
}

/*************************************************************************
function: ElfbHelpAvailable - Return whether help is available for a topic
*/
ElfbHelpAvailable(name)
    char           *name;
{
#if !FOR_TESTER
    data_ptr    retData;
    int         err;

/*  err = ElfCallByName("help_search_all_domains$", &retData, 1,
                            ELF_CREATE_STRING(name));
    if (err != AOK)
        return (BFALSE);
    if (AxBoolFromDataPtr(retData))
        return(BTRUE);
*/
    if (HelpScreenPos(name) || AxIsUserHelp(name))
        return (BTRUE);
    else
        return (BFALSE);
#endif
}

/*************************************************************************
function: AxfGetHelp - Return array of strs from help database
*/

data_ptr AxfGetHelp(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER && !AX_STUB
    char *name = StrFromArgArray(argDatum,0);   /* helpid in database */

    if (AxIsUserHelp(name)) {
        ElfbGetUserHelp(name);
        return(NullDataPtr);
    }


    /*  If it gets down to here, it hasn't been found in the help hyperlinks
     *  list or the user-defined help list, and preferences aren't checked
     *  here any more.  Return an error message */

    ElfStrAbort(ERR_NOHELP, NULL,name);


#if 0
    Removed code that read in preferences help, since that routine has
    been taken out of C code and moved into menus.els ped_set_help,
    and the error messages have been moved into mainstream help.

    This routine should now only be used for locating user-defined help.

    -- lhunt 4/18/94
#endif  /*  #if 0 */

    return(NullDataPtr);

#endif
}

/*************************************************************************
function: ElfStrRetter - Convenience function for returning strings
*/
ElfStrRetter(p)
    char           *p;
{
    if (!p)
        strcpy(ElfStrPtrRet = ElfMalloc(1), "");
    else
        strcpy(ElfStrPtrRet = ElfMalloc(strlen(p) + 1), p);
}

#if 0

*** no longer used
ElfReturnArrayOfTwoLongs(i1, i2)
    long             i1, i2;
{
    data_ptr        aP;

    ElfRetData = aP = ELF_CREATE_ARRAY(2);
    ElfAddDblToArray(aP, 0, (double) i1);
    ElfAddDblToArray(aP, 1, (double) i2);
}
#endif

ElfReturnArrayOfFourNums(n1, n2, n3, n4)
    int             n1, n2, n3, n4;
{
    data_ptr        aP;

    ElfRetData = aP = ELF_CREATE_ARRAY(4);
    ElfAddNumToArray(aP, 0, (int) n1);
    ElfAddNumToArray(aP, 1, (int) n2);
    ElfAddNumToArray(aP, 2, (int) n3);
    ElfAddNumToArray(aP, 3, (int) n4);
}

ElfReturnArrayOfStrings(str)
    char           *str;
{
    char            *buf;
    data_ptr        aP = NULL;
    char            c;
    int             len = 0;
    int             line = 0;

    if ( !str ) {
        ElfRetData = aP;
        return;
    }
    buf = malloc(strlen(str)+1);
    buf[0] = '\0';
    while (c = *str++) {
        if ( !aP )
            aP = ELF_CREATE_ARRAY(0);
        if ( c != '\n' ) {
            buf[len++] = c;
            buf[len] = '\0';
        } else {
            aP = ElfAddStrToArray(aP, line++, buf);
            len = 0;
            buf[0] = '\0';
        }
    }
    if (buf[0] && aP)
        aP = ElfAddStrToArray(aP, line++, buf);
    free(buf);
    ElfRetData = aP;
}

/*************************************************************************
function: AxfNormlKeySeq - Normalize & return key sequence
*/
data_ptr AxfNormlKeySeq(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    char *instr = StrFromArgArray(argDatum,0);
    char            outstr[100];
    menu_item_def   tmp;

    ParseKeySequence(instr, &tmp);
    ElfMakeAccelStr(&tmp, outstr, 15);
    return(ELF_CREATE_STRING(outstr));
#endif
}

/*************************************************************************
function: AxfFileExecutable - Check for executability of file
*/
data_ptr AxfFileExecutable(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);

    if (strchr(name, '*'))  /* strange hack for local insets! */
        return(NullDataPtr);
    SVERIFY((0 == Aaccess(name, X_OK)), ErrnoErr(), name);
    return(NullDataPtr);
}

/*************************************************************************
function: AxfFileExists - Check for existance of file
Really checks whether accessable to this user.
*/
data_ptr AxfFileExists(argDatum)
data_ptr argDatum;
{
    char *passed_name;
    struct stat     lstat;
    char            name[STRPATH + 1];

    passed_name = StrFromArgArray(argDatum,0);
    if ( passed_name == (char *)NULL )
        return(ELF_CREATE_INTEGER(FALSE));
    strcpy( name, passed_name ); /* don't mash input with AxSysDosUnixPath() */

#if AXMS
    AxSysDosUnixPath( name );
#endif
    if ( 0 != Astat(name,&lstat) )
        return(ELF_CREATE_INTEGER(FALSE));
    if ( (lstat.st_mode & S_IFDIR) != S_IFDIR )
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(FALSE));
}

/*************************************************************************
function: ElfbDirExists - Check for existance of a directory
Really checks whether accessable to this user.
*/
ElfbDirExists(name)
char           *name;
{
    struct stat     lstat;

    /* NULL or empty directory does not exist */
    if (!name || !*name)
        return(FALSE);

#if AXMS
	{
    char	*goodname;
    int		ret;
    goodname = (char*)malloc((strlen(name)+1) * sizeof(char));
    strcpy(goodname, name);
    AxSysDosUnixPath( goodname );		/* Can't alter 'name'! */
    if ( 0 != Astat(goodname,&lstat) )
        ret = FALSE;
    else if ( (lstat.st_mode & S_IFDIR) == S_IFDIR )
        ret = BTRUE;
    else
        ret = FALSE;
    free(goodname);
    return(ret);
    }
#else
    if ( 0 != Astat(name,&lstat) )
        return(FALSE);
    if ( (lstat.st_mode & S_IFDIR) == S_IFDIR )
        return(BTRUE);
    else
        return(FALSE);
#endif
}

/*************************************************************************
function: AxfFileSavedNotify - Tell C apps... for insets
*/
data_ptr AxfFileSavedNotify (argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
    FSPokeAll(name, AC_DOCMOD);
    return(NullDataPtr);
}

/*************************************************************************
function: AxfVfyFileExists - Throw error if file does not exist
*/
data_ptr AxfVfyFileExists(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);

    if (strchr(name, '*'))  /* strange hack for local insets! */
        return(NullDataPtr);
    SVERIFY((0 == Aaccess(name, F_OK)), ErrnoErr(), name);
    return(NullDataPtr);
}

/*************************************************************************
function: AxfFileReadable - Check for readability of file
*/
data_ptr AxfFileReadable(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);

    if (strchr(name, '*'))  /* strange hack for local insets! */
        return(NullDataPtr);
    SVERIFY((0 == Aaccess(name, R_OK)), ErrnoErr(), name);
    return(NullDataPtr);
}

/*************************************************************************
function: ElfbFileWritable - Check for writability of file
*/
ElfbFileWritable(name)
    char           *name;
{
    if (strchr(name, '*'))  /* strange hack for local insets! */
        return;
    SVERIFY((0 == Aaccess(name, W_OK)) || (errno == ENOENT), ErrnoErr(), name);
}

/*************************************************************************
function: AxfMakeFileWriteable - Try to hammer permissions
*/
data_ptr AxfMakeFileWriteable(argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
	data_ptr wide_openP = AxArrayElement(argDatum, 1);
    struct stat     status;
    int             mode;
	int wideopen = FALSE;
	
	if (wide_openP) {
		wideopen = BTRUE == AxIntFromDataPtr(wide_openP);
	}
    if (strchr(name, '*'))  /* strange hack for local insets! */
        return(NullDataPtr);
    if (!wideopen && 0 == Aaccess(name, W_OK))
        return(NullDataPtr);   /* already writable by this user */
    VERIFY(0 == stat(name, &status) || (errno == ENOENT), ErrnoErr());
    mode = status.st_mode;
    mode |= 0600;
	if (wideopen) {
		mode |= 066;
	}
    VERIFY(0 == chmod(name, mode) || (errno == ENOENT), ErrnoErr());
    return(NullDataPtr);
}

/*************************************************************************
function: CaseLessFindMacroFile - Search a dir for a case insestive filename
Returns TRUE if found.
*/
CaseLessFindMacroFile(dir, entryname, retname)
char           *dir;    /* dir to search */
char           *entryname;  /* name to find - missing extension */
char           *retname;/* returned, case sensitive name */
{
    char          **filesInDir;
    int             fileDex;
    char           *name;
    char            dirname[STRPATH + 1], tstpath[STRPATH+1];
    char            elo_name[STRPATH + 1], am_name[STRPATH + 1];
    struct stat     status;
    int elo_time = 0;
    int am_time = 0;

    name = NULL;
    strcpy(dirname, dir);
    AxSysDosUnixPath(dirname);
    filesInDir = AxListFilesInDir(dirname);

    /* Look for .elo version first */
    sprintf( elo_name, NXLT("%s.elo"), entryname);
    for (fileDex = 0; name = filesInDir[fileDex]; fileDex++) {
        if ( 0 == Astrcmp(name, elo_name) ) { 
            sprintf(tstpath,"%s/%s",dirname,name);
            AxSysDosUnixPath(tstpath);
            if ( 0 == Astat(tstpath, &status) ) {
                elo_time = status.st_mtime;
                strcpy(elo_name,name);
                break;
            }
        }
    }

    /* Try .am version */
    sprintf( am_name, NXLT("%s.am"), entryname);
    for (fileDex = 0; name = filesInDir[fileDex]; fileDex++) {
        if ( 0 == Astrcmp(name, am_name) ) { 
            sprintf(tstpath,"%s/%s",dirname,name);
            AxSysDosUnixPath(tstpath);
            if ( 0 == Astat(tstpath, &status) ) {
                am_time = status.st_mtime;
                strcpy(am_name,name);
                break;
            }
        }
    }
    AxListFilesFreer(filesInDir);

    if ( !elo_time && !am_time )
        return(FALSE);
    else if ( elo_time >= am_time ) {
        strcpy(retname,elo_name);
        return(TRUE);
    }
    else {
        strcpy(retname,am_name);
        return(TRUE);
    }
}


/*************************************************************************
function: AxfWindowPos - Query server for shell window pos
*/
data_ptr AxfWindowPos(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    int             wid = IntFromArgArray(argDatum,0);
    register data_ptr aP;
    int             xpos, ypos;

    XmGetShellPos(wid, &xpos, &ypos);
    aP = ELF_CREATE_ARRAY(2);
    ElfAddNumToArray(aP, 0, xpos);
    ElfAddNumToArray(aP, 1, ypos);
    return(aP);
#endif
}

/*************************************************************************
function: AxfErrNum - Return error number
*/
data_ptr AxfErrNum()
{
    return(ELF_CREATE_INTEGER(Elf.ErrorCode));
}

/*************************************************************************
function: AxfInLearn - Return status of learn mode
*/
data_ptr AxfInLearn()
{
    return(ELF_CREATE_INTEGER(ElfInLearnMode));
}

/*************************************************************************
function: AxfXlateGothic - Convert Gothic name to current language
*/
data_ptr AxfXlateGothic(argDatum)
data_ptr argDatum;
{
    char           *gothic = StrFromArgArray(argDatum,0);
    char           *ElfSymbolNameFromId(), *p;
    int             id;

    id = ElfCaselessLookupSymbol(gothic, 0);
    if (id == 0)
        p = gothic;
    else
        p = ElfSymbolNameFromId(id, ElfLanguage);
    return(ELF_CREATE_STRING(p));
}

/*************************************************************************
function: AxfError - Throw an error
*/
data_ptr AxfError(argDatum)
data_ptr argDatum;
{
    int code = IntFromArgArray(argDatum,0);
    char *str = StrFromArgArray(argDatum,1);
    char *prepend = StrFromArgArray(argDatum,2);

    if (code == 0)
        code = Elf.ErrorCode;
    if (*str == 0)
        str = NULL; /* causes ElfbDoAbort to fetch str from
                 * stringfile */
    ElfStrAbort(code, str, prepend);

    return(NullDataPtr);
}

/*************************************************************************
function: AxfErrorBox - Post error box
*/
data_ptr AxfErrorBox(argDatum)
data_ptr argDatum;
{
    int code = IntFromArgArray(argDatum,0);
    char *str = StrFromArgArray(argDatum,1);
    char *prepend = StrFromArgArray(argDatum,2);

    if (code == 0)
        code = Elf.ErrorCode;
    if (*str == 0)
        str = Elf.ErrorStr;
    if (*prepend == 0)
        prepend = Elf.ErrorObject;
#if FOR_TESTER
    printf(str);
#else

#if WIN_DEBUG && 0
    /* find the location into static array so we can look at it in debugger*/
    ElfStaticWhere();
#endif

    AxErrorMessage(-1, code, prepend, str);
#endif

    return(NullDataPtr);
}

/*************************************************************************
function: AxfTaskMaster - What task owns this task?
*/
data_ptr AxfTaskMaster()
{
    return(ELF_CREATE_INTEGER(TaskInfo[THIMpid].taskMaster));
}

/*************************************************************************
function: AxfTaskId - Return my task id
*/
data_ptr AxfTaskId()
{
    return(ELF_CREATE_INTEGER(TaskInfo[AxInTask].uid));
}

/*************************************************************************
function: AxfIsTask - Return AxInTask
*/
data_ptr AxfIsTask()
{
    return(ELF_CREATE_INTEGER(AxInTask));
}

/*************************************************************************
function: ElfbSetTaskMaster - Change task master
*/
ElfbSetTaskMaster(uid)
int             uid;
{
    if ( uid == 0 )
        AxMakeMeTopLevelTask(TRUE);
    else if ( uid == 1 )
        AxMakeMeTopLevelTask(FALSE);
    AxSetTaskMaster(THIMpid,uid);
    if ( !ThimPidFromUID(uid) )
        return(FALSE);
    else
        return(BTRUE);
}

/*************************************************************************
function: AxfDispTutor - Display tutorial window
*/
data_ptr AxfDispTutor(argDatum)
data_ptr argDatum;
{
#if !AX_STUB
    char *name = StrFromArgArray(argDatum,0);
    int xpos = IntFromArgArray(argDatum,1),
        ypos = IntFromArgArray(argDatum,2),
        width = IntFromArgArray(argDatum,3),
        height = IntFromArgArray(argDatum,4);
    char            opts[STRPATH + 3];
    int uid;

    XmPutBusyCursor(NULL);
    sprintf(opts, NXLT("-f%s -x%d -y%d -w%d -h%d"), name, xpos, ypos, width, height);
    uid = ElfbProc(APHELP, opts);
    ElfbSetTaskMaster(uid);
    return(ELF_CREATE_INTEGER(uid));
#endif
}

/*************************************************************************
function: ElfbSys5 - Return whether sys5 machine
*/
ElfbSys5()
{
#if SYS&SYS5
    return (BTRUE);
#else
    return (FALSE);
#endif
}

extern int      AxMetric;

/*************************************************************************
function: AxfIsMetric - Return whether the sofware is in Metric mode
*/
data_ptr AxfIsMetric()
{
    if (AxMetric)
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(FALSE));
}

/*************************************************************************
function: AxfTrunc -  Truncate a number
Truncates user's entry into integer
*/
data_ptr AxfTrunc(argDatum)
data_ptr argDatum;
{
    double n = DblFromArgArray(argDatum,0);
    return (ELF_CREATE_NUMBER((int)n/1));
}

/*************************************************************************
function: AxfI2IN - Convert cm/in to inches
Converts user's entry into inches.
*/
data_ptr AxfI2IN(argDatum)
data_ptr argDatum;
{
    double n = DblFromArgArray(argDatum,0);
    if (AxMetric)
        return (ELF_CREATE_NUMBER(n / 2.54));
    else
        return (ELF_CREATE_NUMBER(n));
}

/*************************************************************************
function: AxfI2CM - Convert inches to cm/in
Converts inches to cm's if sofware in metric mode.
*/
data_ptr AxfI2CM(argDatum)
data_ptr argDatum;
{
    double n = DblFromArgArray(argDatum,0);

    if (AxMetric)
        return(ELF_CREATE_NUMBER(n * 2.54));
    else
        return(ELF_CREATE_NUMBER(n));
}

/*************************************************************************
function: AxfValidCmdName - Throw error on invalid name
*/
data_ptr AxfValidCmdName(argDatum)
data_ptr argDatum;
{
    char *str = StrFromArgArray(argDatum,0);
    typeErr         code;
    char            name[ELFIDSTR+1];
    char           *p = name;

    if ( strlen(str) > ELFIDSTR )
        return(ELF_CREATE_INTEGER(ERR_STRTOOLONG));
    strcpy(name, str);
    while (*str) {
        *p++ = toupper(*str);
        *str++;
        }
        
    code = ElfValidName(name);
    if (code != AOK)
        ElfStrAbort(code, NULL, name);

    return(NullDataPtr);
}

/*************************************************************************
function: AxfParseDate - Convert a date string to a number
*/
data_ptr AxfParseDate(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    /* See ElfbFormatDate and UnixTimeToApplixTime elsewhere in this file. */
    char           *datestr = StrFromArgArray(argDatum,0);
    int             unix_time = IntFromArgArray(argDatum,1);
    short           precision;
    unsigned long   date_long;
    int             option;
    char            fmt_string[240];

    precision = 0;

    if (unix_time != 0)
        option = PDUNIXLONG;        /*  return a Unix long */
    else
        option = PDNORMAL;          /*  return an Applix long */

    if (AOK != ParseDate(option, datestr, &date_long, &precision, fmt_string))
        return(ELF_CREATE_INTEGER(0));

    if ((precision == 0) || (date_long == DTNULL))
        return(ELF_CREATE_INTEGER(0));

    return(ELF_CREATE_NUMBER((double)date_long));
#endif

}

/*************************************************************************
function: AxfJulianDate - Convert a date string to a number
WARNING: looses time.
*/
data_ptr AxfJulianDate(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    /* See ElfbFormatDate and UnixTimeToApplixTime elsewhere in this file. */
    char           *datestr = StrFromArgArray(argDatum,0);
    short           precision;
    unsigned long   date_long;
    int             option;
    char            fmt_string[240];
    DateStruct      dt;
    long            jdate, DateBuild();

    precision = 0;

    option = PDNORMAL;          /*  return an Applix long */

    if (AOK != ParseDate(option, datestr, &date_long, &precision, fmt_string))
        return(ELF_CREATE_STRING(""));

    if ((precision == 0) || (date_long == DTNULL))
        return(ELF_CREATE_STRING(""));

    Explodedt(date_long, &dt);
    jdate = DateBuild(dt.year - 50, dt.month - 1, dt.day);
    return(ELF_CREATE_NUMBER((double)jdate));
#endif

}


/*************************************************************************
function: AxfChmodAbsolute - chmod using absolute modes. Eg: "666",..
(as opposed to symbolic modes like "+w",...)
Note: mode_str may contain leading/trailing white spaces.
      *cannot* change mode to "000"
Returns: 0 on success; ElfStrAbort() on failure.
*/
data_ptr AxfChmodAbsolute(argDatum)
data_ptr argDatum;
{
    register char  *f_name = StrFromArgArray(argDatum,0);   /* name of
                                                             * file/directory */
    register char  *mode_str = StrFromArgArray(argDatum,1); /* absolute octal
                                                             * mode string eg:
                                                             * "644", "777" */
#if !FOR_TESTER && !AX_STUB && !AXMS
#if MIPS | SUN3
    register unsigned short mode;

#else
    register mode_t mode;   /* from <sys/stdtypes.h>|<sys/stat.h> */

#endif
    register char  *p;

    /* Check if valid mode value string. */
    for (p = mode_str; *p != '\0'; p++) {
        if ((*p == '\t') || (*p == ' ') || ((*p >= '0') && (*p <= '7')))
            continue;
        else
            ElfStrAbort(ERR_ILLVAL, XLT("Illegal absolute mode value string"), mode_str);
    }
#if MIPS | SUN3
    mode = (unsigned short) strtol(mode_str, (char **) NULL, 8);
#else
    mode = (mode_t) strtol(mode_str, (char **) NULL, 8);
#endif
    if (mode == 0)      /* mode_str was "000" or strtol failed */
        ElfStrAbort(ERR_ILLVAL, XLT2("File permissions","Bad mode string"), mode_str);

    if (chmod(f_name, mode) != 0)
        ElfStrAbort(ErrnoErr(), NULL, f_name);
#endif

    return(ELF_CREATE_INTEGER(0));
}

/*************************************************************************
function: ElfbIsLikeAscii - Open file, return whether looks like ascii
*/
ElfbIsLikeAscii(filename)
    char           *filename;
{
    int             is_ascii = TRUE;
    FILE           *fp;
    register int    f_depth;
    char            buf[1024];
    register char  *buf_p = buf;
    int             n_ascii = 0;
    register int    cnt;
    int err, read_only, pid;
    long pos;

    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(filename, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, filename);
    fp = (FILE *)AFTaskfopen(pid, filename, READ_BINARY_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(filename, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, filename);
    }
    errno = 0;
    pos = ftell(fp);
    if ((f_depth = fread(buf_p, 1, 1024, fp)) == 0) {
        if (errno != 0) {
            err = ErrnoErr();
            fseek(fp, pos, 0);
            AFfclose(filename, read_only, fp);
            AFTaskUnlockFile(filename, 0, read_only);
            ElfStrAbort(err, NULL, filename);
        }
        fseek(fp, pos, 0);
        AFfclose(filename, read_only, fp);
        AFTaskUnlockFile(filename, pid, read_only);
        return (BTRUE); /* empty file */
    }
    fseek(fp, pos, 0);
    AFfclose(filename, read_only, fp);
    AFTaskUnlockFile(filename, pid, read_only);
#if BUILD_ORIENT
    /* Ashisuto added for judge multi-byte chars external files.    95.10.06 */
    for (cnt = 0; cnt < f_depth; buf_p++, cnt++)
          if (is_external_ascii_multi_byte(buf_p))
#if BUILD_KANJI
          if ( ascii_is_shift_jis() && 
                    ((mbchar)*buf_p >= 0xa1) && ((mbchar)*buf_p <= 0xdf)) 
            /* single byte case */
            n_ascii++;
          else
#endif
            {
            n_ascii += 2;
            buf_p++;
            cnt++;
        }
        else if (is_Latin_1(*buf_p))
             n_ascii++;

        else if (n_ascii == f_depth-1) {
            /* ignor judging of last unrecognized byte because
             * it might be half of a multi-byte char.
             */
            n_ascii++;
            break;
        } else
            break;
#else
    for (cnt = 0; (cnt < f_depth) && (isascii(*buf_p)); buf_p++, cnt++)
       {  n_ascii++; }
#endif
    is_ascii = (n_ascii == f_depth) ? TRUE : FALSE;
    return (is_ascii ? BTRUE : FALSE);
}


/*************************************************************************
function: AxfIsLikeLatin1 - Open file, return whether smells like Latin1
*/
data_ptr
AxfIsLikeLatin1(argDatum)
data_ptr argDatum;
{
    char *filename = StrFromArgArray(argDatum,0);
    int             is_ascii = TRUE;
    FILE           *fp;
    register int    f_depth;
    char            buf[1024];
    register char  *buf_p = buf;
    int             n_ascii = 0;
    register int    cnt;
    int err, read_only, pid;

    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(filename, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, filename);
    fp = (FILE *)AFTaskfopen(pid, filename, READ_BINARY_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(filename, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, filename);
    }
    errno = 0;
    if ((f_depth = fread(buf_p, 1, 1024, fp)) == 0) {
        if (errno != 0) {
            err = ErrnoErr();
            AFfclose(filename, read_only, fp);
            AFTaskUnlockFile(filename, 0, read_only);
            ElfStrAbort(err, NULL, filename);
        }
        AFfclose(filename, read_only, fp);
        AFTaskUnlockFile(filename, pid, read_only);
        return(ELF_CREATE_INTEGER(BTRUE));
    }
    AFfclose(filename, read_only, fp);
    AFTaskUnlockFile(filename, pid, read_only);
#if BUILD_ORIENT
    /* Ashisuto added for judge multi-byte chars external files.    95.10.06 */
    for (cnt = 0; cnt < f_depth; buf_p++, cnt++)
          if (is_external_ascii_multi_byte(buf_p))
#if BUILD_KANJI
          if ( ascii_is_shift_jis() && 
                    ((mbchar)*buf_p >= 0xa1) && ((mbchar)*buf_p <= 0xdf)) 
            /* single byte case */
            n_ascii++;
          else
#endif
            {
            n_ascii += 2;
            buf_p++;
            cnt++;
        }
        else if (is_Latin_1(*buf_p))
             n_ascii++;

        else if (n_ascii == f_depth-1) {
            /* ignor judging of last unrecognized byte because
             * it might be half of a multi-byte char.
             */
            n_ascii++;
            break;
        } else
            break;
#else
    for (cnt = 0; (cnt < f_depth) && (is_Latin_1(*buf_p)); buf_p++, cnt++)
       {  n_ascii++; }
#endif
    is_ascii = (n_ascii == f_depth) ? TRUE : FALSE;

    if (is_ascii)
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(FALSE));
}

/*************************************************************************
function: AxfFormatArray - format the input elf array of strings into
one which contains word wrapped lines of maximum length 'width'
*/
data_ptr AxfFormatArray(argDatum)
data_ptr argDatum;
{
    register data_ptr in_elfdata = AnyFromArgArray(argDatum,0);
    register int    width = IntFromArgArray(argDatum,1);
    register data_ptr out_elfdata;
    register char  *lineptr;
    char            *swap_buf;
    char            *out_buf;
    char            *tmp_buf;
    int             ix;
    int             in_size;
    int             old_size;
    int             new_size;
    int             swap_cnt;
    int             tmp_cnt;
    int             linelen;
    int             cliplen;
    int             out_index = 0;


    VERIFY(width > 0, ERR_ILLVAL);
    in_size = ElfbArraySize(in_elfdata);    /* we have 'in_size' # of
                         * strings */

    if (in_size <= 0)
        ElfStrAbort(ERR_ARRTOOBIG, NULL, NULL);

    out_elfdata = ELF_CREATE_ARRAY(0);

    ix = 0;

    lineptr = StrFromArray(in_elfdata, ix);

    old_size = strlen(lineptr);

    tmp_buf = (char*)malloc((old_size+1) * sizeof(char));
    swap_buf = (char*)malloc((old_size+1) * sizeof(char));
    out_buf = (char*)malloc((width+1) * sizeof(char));

    strcpy(tmp_buf, lineptr);   /* is null terminated */

    while (1) {
        linelen = 0;
        cliplen = 0;
        linelen = strlen(tmp_buf);

        if (width < linelen) {
#if BUILD_ORIENT
            /* Ashisuto added. In Oriental language, pay attension:
             *  (1) Do not cut a multi-byte char into single bytes.
             *  (2) Let the Carrage-Return be inserted between any two
             *      multi-byte chars. ( There is a necessity in Words only
             *      to considering if the position of insersion is
             *      IsOktoBreakOriental() ).
             *  95.10.04
             */
            char    *mbP;
            int     tlen = 0;
            cliplen = width;
            for (mbP = tmp_buf; mbP - tmp_buf < width; mbP++) {
                if (IS_MULTI_BYTE(mbP)) {
                    mbP++;
                    tlen += 2;
                    if (tlen <= width)
                        cliplen = tlen;
                } else if (isspace(*mbP)) {
                    tlen++;
                    cliplen = tlen;
                } else {
                    tlen++;
                }
            }
#else
            cliplen = width;
            if (!isspace(tmp_buf[cliplen])) {   /* back off right here */
                while ((cliplen != 0) && (!isspace(tmp_buf[cliplen])))
                    cliplen--;
                if (cliplen == 0)   /* did not find any
                             * space on this line */
                    cliplen = width;    /* take in the whole
                                 * line */
            }   /* else, the current cliplen is ok */
#endif
        } else {
            cliplen = linelen;
        }

        for (tmp_cnt = 0; (tmp_cnt < cliplen) && (tmp_buf[tmp_cnt] != '\0'); tmp_cnt++)
            out_buf[tmp_cnt] = tmp_buf[tmp_cnt];
        out_buf[tmp_cnt] = '\0';
        out_elfdata = ElfAddStrToArray(out_elfdata, out_index, out_buf);
        /* Form tmp_buf for next loop */
        if (cliplen < linelen) {    /* some chars still remaining */
            tmp_cnt = cliplen;
            for (swap_cnt = 0; tmp_cnt < linelen; swap_cnt++, tmp_cnt++)
                swap_buf[swap_cnt] = tmp_buf[tmp_cnt];
            swap_buf[swap_cnt] = '\0';
            tmp_buf[0] = '\0';
            strcpy(tmp_buf, swap_buf);
        } else {
            ix++;
            if (ix < in_size) {
                lineptr = StrFromArray(in_elfdata, ix);

                /*
                 * see if this string requires more space
                 * than any string previously allocated
                 */

                new_size = strlen(lineptr);

                if (new_size > old_size)
                {
                    tmp_buf = realloc(tmp_buf,new_size);
                    swap_buf = realloc(swap_buf,new_size);

                    old_size = new_size;
                }

                strcpy(tmp_buf, lineptr);   /* is null terminated */
            } else
                goto finish_up; /* BREAK OUT */
        }
        out_index++;    /* for the next string segment */
    }

finish_up:

    free(tmp_buf);
    free(swap_buf);
    free(out_buf);

    return(out_elfdata);
}

/*************************************************************************
function: AxfIsUUEncoded - Check if a file is uuencoded.
returns: BTRUE if file appears to be uuencoded; FALSE otherwise.
ElfStrAbort() on error.
*/
data_ptr AxfIsUUEncoded(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER
    char           *file = StrFromArgArray(argDatum,0);
    char            buf[1024 + 1];
    char            str_begin[1024 + 1];
    char            rem_file[1024 + 1];
    int             mode, read_only, err, pid;
    int             is_encoded = 0;
    int             seen_begin = 0;
    FILE           *fp;

    if (file == (char *) NULL)
        return (ELF_CREATE_INTEGER(FALSE));

    pid = THIMpid;
    read_only = TRUE;
    err = AFTaskLockFile(file, pid, &read_only, FALSE);
    if ( err != AOK )
        ElfStrAbort(err, NULL, file);
    fp = (FILE *)AFTaskfopen(pid, file, READ_BINARY_STR);
    if ( !fp )
    {
        AFTaskUnlockFile(file, pid, read_only);
        ElfStrAbort(ErrnoErr(), NULL, file);
    }

    while (fgets(buf, 1024, fp)) {
        if (!seen_begin) {
            if (strncmp(buf, NXLT("begin"), 5) == 0) {
                mode = 0;
                rem_file[0] = '\0';
                sscanf(buf, "%s %o %s", str_begin, &mode, rem_file);
                if ((mode > 0) && (strlen(rem_file) > (unsigned) 0))
                    seen_begin = 1;
            }
            continue;
        }
        if (strncmp(buf, NXLT("end"), 3) == 0) {
            is_encoded = 1;
            break;
        }
    }
    AFfclose(file, read_only, fp);
    AFTaskUnlockFile(file, pid, read_only);
    return(ELF_CREATE_INTEGER(is_encoded ? BTRUE : FALSE));
#endif
}


#if !FOR_TESTER && !AXMS
ElfbDBList()
{
#define MAX_NUM_DIALOGS 1024    /* same as in xmlib.c */
    data_ptr        aP;
    char          *names[MAX_NUM_DIALOGS];
    int             ix;
    extern void AxXmDialogList();

    aP = ELF_CREATE_ARRAY(0);
	memset(names, 0, sizeof(names));
    AxXmDialogList(&names);
    for (ix = 0; names[ix]; ix++) {
        aP = ElfAddStrToArray(aP, ix, names[ix]);
		free(names[ix]);
    }
    ElfRetData = aP;
}

#endif

/*************************************************************************
function: AxfCreateTempfile - Create a tempfile, return name
Accepts an Amktemp style template of xxx%%%%%%xxx.
The %%%% (min 5, max 14) are converted to a unique string.
*/
data_ptr AxfCreateTempfile(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER && !AX_STUB
    char           *template = StrFromArgArray(argDatum,0);
    mbchar          newname[STRPATH + 1];
    mbchar         *p;

    errno = 0;      /* sanity against subroutine badness */
    if (!template[0])
        /* no template passed from elf */
        template = NULL;
    p = (mbchar *) AxTempFile(template, newname);
    if (!p) {
        if (errno && (errno != EBADF))
            ElfStrAbort(ErrnoErr(), NULL, template);
        else
            ElfStrAbort(ERR_ILLVAL, NULL, template);
    }
    return(ELF_CREATE_STRING(newname));
#endif
}


/*************************************************************************
function: AxfGetPageInfo - get info about pages to be printed.
Takes the string entered by the user and decomposes the string into
page numbers and their extensions. Returns an elf array  of five integers.
The elements are status, starting page, ending page, starting page extension
and ending page extension respectively. If status is not 0, then error
occured and the rest of the elements in the array have no meaning .

Examples of Valid strings are
1a - 1c
3a-1z
999a- 9999zz
1-2
*/

#define INVALID_PAGESPEC    1   /* Invalid page range was specified */
#define INVALID_STARTPAGE   2   /* Invalid starting page was specified */
#define INVALID_ENDPAGE     3   /* Invalid ending page was specified */

data_ptr AxfGetPageInfo(argDatum)
data_ptr argDatum;
{
    char *pagestr = StrFromArgArray(argDatum,0);    /* String to be parsed and
                                                        decomposed */
    int             page1, pageN, pageext1, pageextN;
    char            p1[80], p2[80];
    char           *p;
    int             singlepage = 0;
    int             status;
    data_ptr        aP;


    status = 0;     /* assume no error */
    /* create an elf array */
    aP = ELF_CREATE_ARRAY(5);

    if ((p = strchr(pagestr, '-')) == NULL) {   /* try for a dash
         * separator *//* no separator found ,assume single page is
         * specified */
        singlepage = TRUE;
        strcpy(p1, pagestr);
    } else {        /* found a separator, a page range is specified */
        singlepage = FALSE;
        /* get the second page in the page range */
        strcpy(p2, (p + 1));
        /* get the first page in the page range */
        strncpy(p1, pagestr, (p - pagestr));
        p1[p - pagestr] = '\0';
    }

    /* parse the first page to see if it is valid */
    if (!parsepage(p1, &page1, &pageext1)) {    /* parsing failed */
        if (singlepage)
            status = INVALID_PAGESPEC;  /* Invalid page range
                             * specification */
        else
            status = INVALID_STARTPAGE; /* Invalid starting page */

        ElfAddNumToArray(aP, 0, status);
        return(aP);
    }
    if (!singlepage) {  /* we have a page range , parse the second page */
        if (!parsepage(p2, &pageN, &pageextN)) {    /* parsing failed */
            status = INVALID_ENDPAGE;   /* Invalid ending page */
            ElfAddNumToArray(aP, 0, status);
            return(aP);
        }
    } else {        /* we have only one page, so starting and
                 * ending pages and */
        /* extensions are same */
        pageN = page1;
        pageextN = pageext1;
    }

    if (page1 > pageN) {    /* starting page is greater than ending page,
                 * swap them */
        int             tmp;

        /* swap page numbers */
        tmp = page1;
        page1 = pageN;
        pageN = tmp;
        /* swap page extensions */
        tmp = pageext1;
        pageext1 = pageextN;
        pageextN = tmp;
    }
    if (page1 == pageN) {   /* starting and ending pages are equal */
        if (pageext1 > pageextN) {  /* starting page extension is
                         * greater than ending page */
            /* extension ,swap them */
            int             tmp;

            tmp = pageext1;
            pageext1 = pageextN;
            pageextN = tmp;
        }
    }
    /* Add all the elements to the array */
    ElfAddNumToArray(aP, 0, status);
    ElfAddNumToArray(aP, 1, page1);
    ElfAddNumToArray(aP, 2, pageN);
    ElfAddNumToArray(aP, 3, pageext1);
    ElfAddNumToArray(aP, 4, pageextN);

    return(aP);
}

#define MAXPAGECHAR (unsigned)6 /* total no of chars per page specification */
#define MAXEXTCHAR  (unsigned)2 /* no of chars per page extension */
#define MAXPAGENUM  (unsigned)9999  /* max value for a page */

/* The function takes in the page string and returns the pagenum and the
 * pageext Examples of valid strings are 1  -> pagenum is 1, pageext is 0 1a ->
 * pagenum is 1, pagext is 1 1zz -> pagenum is 1, pageext is 702 999za ->
 * pagenum is 999, pageext is 677 */
parsepage(page, pagenum, pageext)
    char           *page;   /* string to be parsed */
    int            *pagenum;
    int            *pageext;
{
    int             i;
    char            num[80];
    int             len;
    char           *p, ch;

    p = page;
    /* skip leading spaces */
    while (isspace(*p))
        p++;

    len = strlen(page);

    /* skip trailing spaces */
    while (isspace(page[len - 1]))
        len--;
    page[len] = '\0';

    if (strlen(page) > MAXPAGECHAR)
        return (FALSE); /* string has more chars than allowed */

    /* check if first char is a digit */
    if (!isdigit(p[0]))
        return (FALSE); /* first char is not a digit */

    /* collect all digits into a buffer */
    i = 0;
    for (;;) {
        if (*p == '\0')
            break;
        if (isdigit(*p)) {
            num[i] = *p;
            i++;
            p++;
        } else
            break;
    }
    num[i] = '\0';

    *pagenum = atoi(num);

    if ((*pagenum > MAXPAGENUM) || (*pagenum < 0))
        return (FALSE); /* Invalid page number */

    /* Here p points to the first character after the digits */
    if (*p == '\0') {   /* there is no page extension */
        *pageext = 0;
        return (TRUE);
    }
    if (strlen(p) > MAXEXTCHAR)
        return (FALSE); /* string has more chars than allowed */

    /* make sure page extension string is valid */
    /* can contain only alphabets */
    i = 0;
    while (p[i] != '\0') {
        if (!isalpha(p[i]))
            return (FALSE);
        i++;
    }

    /* convert the page extension string into a number */
    /* "a" -> 1 */
    /* "b" -> 2 */
    /* "z" -> 26 */
    /* "aa" -> 27 */
    /* "ab" -> 28 */
    /* "zy -> 701 */
    /* "zz -> 702 */

    ch = toupper(*p);
    *pageext = ch - 'A' + 1;
    p++;
    if (*p != '\0') {
        ch = toupper(*p);
        *pageext = (*pageext * 26) + ch - 'A' + 1;
    }
    return (TRUE);
}


#include <ashell.h>

/*************************************************************************
function: AxfRunProgramPid - Run an external program getting pid
*/
data_ptr AxfRunProgramPid(argDatum)
data_ptr argDatum;
{
    char *progname;
    int  pid, no_hide;

    progname = StrFromArgArray(argDatum,0);
	no_hide = IntFromArgArray(argDatum,1);

    VERIFY(strlen(progname) < MAX_SHELL_CMD, ERR_STRTOOLONG);

    pid = THIMexecRet(progname, no_hide);
    return(ELF_CREATE_INTEGER(pid));
}

/*************************************************************************
function: AxfRunProgram - Run an external program getting exit code
*/
data_ptr AxfRunProgram(argDatum)
data_ptr argDatum;
{
    data_ptr        p_progname = AnyFromArgArray(argDatum,0),
                    p_file_stdout = AnyFromArgArray(argDatum,1),
                    p_file_stderr = AnyFromArgArray(argDatum,2),
					p_no_hide_flag = AnyFromArgArray(argDatum,3);
    char           *progname, *file_stdout, *file_stderr;
    int             code, no_hide;

    progname = StrFromDataPtr(p_progname);
    file_stdout = StrFromDataPtr(p_file_stdout);
    file_stderr = StrFromDataPtr(p_file_stderr);
	no_hide = IntFromDataPtr(p_no_hide_flag);

    VERIFY(strlen(progname) < MAX_SHELL_CMD, ERR_STRTOOLONG);
    VERIFY(strlen(file_stdout) < STRPATH, ERR_STRTOOLONG);
    VERIFY(strlen(file_stderr) < STRPATH, ERR_STRTOOLONG);

    code = AxRunProgram(progname, "", file_stdout, file_stderr, no_hide);
    return(ELF_CREATE_INTEGER(code));
}

/*************************************************************************
function: AxfRunStdinProgram - Run an external program getting exit code
*/
data_ptr AxfRunStdinProgram(argDatum)
data_ptr argDatum;
{
    data_ptr        p_progname = AnyFromArgArray(argDatum,0),
                    p_file_stdin = AnyFromArgArray(argDatum,1),
                    p_file_stdout = AnyFromArgArray(argDatum,2),
                    p_file_stderr = AnyFromArgArray(argDatum,3),
					p_no_hide_flag = AnyFromArgArray(argDatum,4);
    char           *progname, *file_stdin, *file_stdout, *file_stderr;
    int             code, no_hide;

    progname = StrFromDataPtr(p_progname);
    file_stdin = StrFromDataPtr(p_file_stdin);
    file_stdout = StrFromDataPtr(p_file_stdout);
    file_stderr = StrFromDataPtr(p_file_stderr);
	no_hide = IntFromDataPtr(p_no_hide_flag);

    VERIFY(strlen(progname) < MAX_SHELL_CMD, ERR_STRTOOLONG);
    VERIFY(strlen(file_stdin) < STRPATH, ERR_STRTOOLONG);
    VERIFY(strlen(file_stdout) < STRPATH, ERR_STRTOOLONG);
    VERIFY(strlen(file_stderr) < STRPATH, ERR_STRTOOLONG);

    code = AxRunProgram(progname, file_stdin,file_stdout,file_stderr, no_hide);
    return(ELF_CREATE_INTEGER(code));
}

/*************************************************************************
function: AxfRunBatchProgram - Run an external program getting exit code
Unlike RunProgram, thsi just locks the current macro
*/
data_ptr AxfRunBatchProgram(argDatum)
data_ptr argDatum;
{
    data_ptr        p_progname = AnyFromArgArray(argDatum,0),
                    p_file_stdout = AnyFromArgArray(argDatum,1),
                    p_file_stderr = AnyFromArgArray(argDatum,2),
					p_no_hide_flag = AnyFromArgArray(argDatum,3);
    char           *progname, *file_stdout, *file_stderr;
    int             code, no_hide;

    progname = StrFromDataPtr(p_progname);
    file_stdout = StrFromDataPtr(p_file_stdout);
    file_stderr = StrFromDataPtr(p_file_stderr);
	no_hide = IntFromDataPtr(p_no_hide_flag);

    VERIFY(strlen(progname) < MAX_SHELL_CMD, ERR_STRTOOLONG);
    VERIFY(strlen(file_stdout) < STRPATH, ERR_STRTOOLONG);
    VERIFY(strlen(file_stderr) < STRPATH, ERR_STRTOOLONG);

    code = AxRunBatchProgram(progname, "", file_stdout, file_stderr, no_hide);
    return(ELF_CREATE_INTEGER(code));
}

/*************************************************************************
function: AxfRunStdinBatchProgram - Run an external program getting exit code
Unlike RunProgram, thsi just locks the current macro
*/
data_ptr AxfRunStdinBatchProgram(argDatum)
data_ptr argDatum;
{
    data_ptr        p_progname = AnyFromArgArray(argDatum,0),
                    p_file_stdin = AnyFromArgArray(argDatum,1),
                    p_file_stdout = AnyFromArgArray(argDatum,2),
                    p_file_stderr = AnyFromArgArray(argDatum,3),
					p_no_hide_flag = AnyFromArgArray(argDatum,4);
    char           *progname, *file_stdin, *file_stdout, *file_stderr;
    int             code, no_hide;

    progname = StrFromDataPtr(p_progname);
    file_stdin = StrFromDataPtr(p_file_stdin);
    file_stdout = StrFromDataPtr(p_file_stdout);
    file_stderr = StrFromDataPtr(p_file_stderr);
	no_hide = IntFromDataPtr(p_no_hide_flag);

    VERIFY(strlen(progname) < MAX_SHELL_CMD, ERR_STRTOOLONG);
    VERIFY(strlen(file_stdin) < STRPATH, ERR_STRTOOLONG);
    VERIFY(strlen(file_stdout) < STRPATH, ERR_STRTOOLONG);
    VERIFY(strlen(file_stderr) < STRPATH, ERR_STRTOOLONG);

    code = AxRunBatchProgram(progname,file_stdin,file_stdout,file_stderr,no_hide);
    return(ELF_CREATE_INTEGER(code));
}

/*************************************************************************
function: AxfGetBluTime - Return time, encoded in Blueberry style
*/

#define Asterix 30
#define MAXTLEN 10

axstatic char   Pos[MAXTLEN] = {6, 8, 2, 5, 1, 7, 0, 4, 3};
axstatic char   AlphaMix[MAXTLEN] = NXLT("ASTERIXNE");  /* for APPLIX only */

#if !FOR_TESTER && !AX_STUB
data_ptr AxfGetBluTime()
{
    long            Now;
    char            TimeBuffer[MAXTLEN];
    char            OutputBuffer[MAXTLEN];
    void            EncryptTime();

    time(&Now);
    sprintf(TimeBuffer, "%ld", Now);
    TimeBuffer[3] += (((int) Asterix) / 100) % 10;
    TimeBuffer[4] += (((int) Asterix) / 10) % 10;
    TimeBuffer[5] += ((int) Asterix) % 10;
    EncryptTime(OutputBuffer, TimeBuffer);
    return(ELF_CREATE_STRING(OutputBuffer));
}


void EncryptTime(Optr, Iptr)
    char           *Optr, *Iptr;
{
    int             I, Val;
    char            InBuffer[MAXTLEN];
    char            OutBuffer[MAXTLEN];
    char            KeyCh;

    if (*Iptr == '1')
        Iptr++;
    strncpy(InBuffer, Iptr, MAXTLEN);
    KeyCh = InBuffer[MAXTLEN - 2] - '0';
    for (I = 0; I < (MAXTLEN - 1); I++) {
        Val = (InBuffer[I] - '0') + AlphaMix[I] + KeyCh;
        OutBuffer[Pos[I]] = (Val > 'Z') ? Val - 23 : Val;
    }
    OutBuffer[I] = 0;
    strncpy(Optr, OutBuffer, MAXTLEN);
}

#endif

#define CRYPTLEN 10

/*
  see dcrypt.c

  'A', AxFilterStringI['A' - 'A'] = 'B', AxFilterStringO['B' - 'A'] = 'A'
  'J', AxFilterStringI['J' - 'A'] = 'U', AxFilterStringO['U' - 'A'] = 'J'
  etc ...
*/

static char *AxFilterStringI = NXLT("BJKXOIERTUWAQZLYMNCPVSGDFH10");

/*************************************************************************
function: AxfEncryptTime - an Asterx Time encrypter for filter use.
  see decrypter in dcrypt.c
*/
data_ptr AxfEncryptTime()
{
    time_t now;
    char timeBuffer[CRYPTLEN];
    int len,ii,val;

    time(&now);
    sprintf(timeBuffer, "%ld", now);
    len = strlen(timeBuffer);
    val = timeBuffer[len-1] - '0';
    for (ii=0; ii<len; ii++)
        timeBuffer[ii] = AxFilterStringI[(timeBuffer[ii] - '0') + val + val];
    timeBuffer[len] = 0;
    return(ELF_CREATE_STRING(timeBuffer));
}


/*************************************************************************
function: AxfNoMapWindowsFlag - Control -quite mode
*/
data_ptr AxfNoMapWindowsFlag(argDatum)
data_ptr argDatum;
{
#if !FOR_TESTER && !AX_STUB
    extern int      AxNoMapWindows; /* -quiet mode */
    int             doit = IntFromArgArray(argDatum,0);

    AxNoMapWindows = (doit != FALSE);
    return(NullDataPtr);
#endif
}

/*************************************************************************
function: AxfViewRest - Sets/clears the varying viewer control
*/
data_ptr AxfViewRest(argDatum)
data_ptr argDatum;
{
    extern int      AxViewRest; /* Set/Clear able by ELF macro */
    int             set = IntFromArgArray(argDatum,0);

    AxViewRest = set;
    return(NullDataPtr);
}

/*************************************************************************
function: AxfViewOnly - Return whether user in view-only licensed
*/
data_ptr AxfViewOnly()
{
    extern int      AxViewOnly; /* Set/Clear able by ELF macro */

    if (AxViewOnly)
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(FALSE));
}


/*************************************************************************
function: AxfUnixFileSystem - Return TRUE is Unix rather than DOS style FS
*/
data_ptr AxfUnixFileSystem()
{
#if AX_UNIX
    return(ELF_CREATE_INTEGER(BTRUE));
#else
    return(ELF_CREATE_INTEGER(FALSE));
#endif
}


/*************************************************************************
function: AxfCompileArray - Compile array of strs, return binary code buffer
*/
data_ptr AxfCompileArray(argDatum)
data_ptr argDatum;
{
    char *srcname = StrFromArgArray(argDatum,0);
    data_ptr lines = AnyFromArgArray(argDatum,1);

    if (!srcname[0])
        ElfStrAbort(ERR_ILLVAL, XLT("Compiler requires a module name"), NULL);
    if (!lines)
        return(NullDataPtr);
    VERIFY(!IS_INTEGER(lines) && AX(lines)->type == TYPE_ARRAY, ERR_NOTARRAY);
    ElfbArraySize(lines);       /* make sure source array */
    return(ElfCompileArray(srcname,lines));
}

/*************************************************************************
function: AxfStrlen - strlen
*/
data_ptr AxfStrlen(argDatum)
data_ptr argDatum;
{
    char *s = StrFromArgArray(argDatum,0);
#if BUILD_KANJI
    /* Ashisuto changed to fit the composition usage of len@(), substring@(),
     * string_index@(). substring@() or string_index@() use multi-byte char
     * unit as their counting base. We only change here for Japanese build.
     * 95.09.25
     */
     return(ELF_CREATE_INTEGER(MbCharLen(s)));
#else
    return(ELF_CREATE_INTEGER(strlen(s)));
#endif
}

/*************************************************************************
function: AxfParentTask - Return uid of task that proc'd this one
*/
data_ptr AxfParentTask()
{
    return(ELF_CREATE_INTEGER(TaskInfo[AxInTask].parentTask));
}

/*************************************************************************
function: AxfIsElfrt - Return whether running as elfrt rather than axmain
*/
data_ptr AxfIsElfrt()
{
    extern int      AxElfrtMode;

	if ( AxElfrtMode )
        return(ELF_CREATE_INTEGER(BTRUE));
    else
        return(ELF_CREATE_INTEGER(FALSE));
}

/*************************************************************************
function: AxfIsMailrt - Return whether running as elfrt+mail 
*/
data_ptr AxfIsMailrt()
{
    extern int      AxMailrtMode;

    return(ELF_CREATE_INTEGER(AxMailrtMode));
}

/*************************************************************************
function: AxfMakeEntryLink - Create an entry linkage
*/
data_ptr AxfMakeEntryLink(argDatum)
data_ptr argDatum;
{
    char           *name = StrFromArgArray(argDatum,0);
    SVERIFY(strlen(name) <= ELFIDSTR, ERR_ILLVAL, name)
        return(ELF_CREATE_ENTRY(name));
}

/*************************************************************************
function: AxfNameFromEntry - Extract routine name from entry var
*/
data_ptr AxfNameFromEntry(argDatum)
data_ptr argDatum;
{
    VERIFY(ElfbIsEntry(argDatum), ERR_ILLVAL);
    return(ELF_CREATE_STRING(EX(argDatum)->linkage.nameP));
}




/*************************************************************************
function: ElfbPrintf - Put a string to shell window
Deirect to device 1 to get most reliability.  No buffer confusion, etc.
*/
ElfbPrintf(str)
char           *str;
{
#if AX_X11
    write(1, str, strlen(str));
#else
    WinPrintf( str );
#endif
    return( 0 );
}



/*************************************************************************
function: AxfFreeNamedBitmap - free named bitmap from PixMapCache[]
*/
data_ptr AxfFreeNamedBitmap(argDatum)
data_ptr argDatum;
{
    char           *s = StrFromArgArray(argDatum,0);
    deletePixmapFromCache(s);
    return(NullDataPtr);
}

/*************************************************************************
function: AxfIsOrientBuild - return whether we are in an oriental environment 
*/

data_ptr AxfIsOrientBuild()
{
#if BUILD_ORIENT
    return(ELF_CREATE_INTEGER(BTRUE));
#else
    return(ELF_CREATE_INTEGER(FALSE));
#endif
}
 
/*************************************************************************
function: AxfIsAXMS - Return whether runnign on MS NT
*/
data_ptr AxfIsAXMS()
{
#if AXMS
    return(ELF_CREATE_INTEGER(BTRUE));
#else
    return(ELF_CREATE_INTEGER(FALSE));
#endif
}



/*************************************************************************
function: AxfUseWideMenuBarEdit - return whether we should use wide fields
                                   when editing menu bars               */
data_ptr AxfUseWideMenuBarEdit()
{
#if !ANLM
       return(ELF_CREATE_INTEGER(BTRUE));
#else
    if ( getenv("AX_WIDE_MENUBAR") != (char *)NULL )
       return(ELF_CREATE_INTEGER(BTRUE));
    else
       return(ELF_CREATE_INTEGER(FALSE));
#endif
}




/***************************************************************************
function: AxfFileHeaderFromInfo - Produce file header from info.
*/
data_ptr AxfFileHeaderFromInfo(argDatum)
data_ptr argDatum; /* in: file info */
{
    mbchar headerLine[ALINELENGTH+1];
    data_ptr aP, datP;
    AFileInfo info;
    mbchar *mbstr;
    int len;

    datP = AxArrayElement(argDatum, 0);
    len = AxArraySize(datP);
    if ( len < 3 )
        headerLine[0] = (mbchar)0;
    else
    {
        /* read the data from the passed in ELF array */
        memset((char *)&info, 0, sizeof(AFileInfo));
        info.encoding = AxIntFromArray(datP, 0);
        info.version  = AxIntFromArray(datP, 1);
        info.docType  = AxIntFromArray(datP, 2);
        if ( aP = AxArrayElement(datP, 3) )
            info.old_version = AxIntFromDataPtr(aP);
        else
            info.old_version = info.version;
        if ( aP = AxArrayElement(datP, 4) )
            info.min_version = AxIntFromDataPtr(aP);
        else
            info.min_version = info.version;
        if ( aP = AxArrayElement(datP, 5) )
        {
            mbstr = AxStrPtrFromDataPtr(aP);
            len = MBstrlen(mbstr);
            info.content = (char *)malloc(len+1);
            MBstrcpy(info.content, mbstr);
        }

        /* create the string */
        AFileHeaderFromInfo(&info, headerLine);
        if ( info.content )
            free(info.content);
    }

    /* convert the string to ELF data and return it */
    return(ELF_CREATE_STRING(headerLine));
}

/***************************************************************************
function: AxfInfoFromFileHeader - recognize and process asterx file header.
*/
data_ptr AxfInfoFromFileHeader(argDatum)
data_ptr argDatum;
{
    data_ptr aP, retP;
    mbchar *header; /* file header line or empty string to get default */
    AFileInfo info;
    typeErr status;

    /* read the data */
    aP = AxArrayElement(argDatum, 0);
    header = aP ? (mbchar *)AxStrPtrFromDataPtr(aP) : (mbchar *)0;

    /* evaluate the data */
    retP = (data_ptr)0;
    status = AFileInfoFromHeader(header, &info);
    if (!header || !*header || (status == AOK) || (status == FETooNew)) {
        /* Note if no line was passed, AFileInfoFromHeader
            returns the default values */
        retP = AxMakeArray(6);
        AxAddIntToArray(retP, 0, info.encoding);
        AxAddIntToArray(retP, 1, info.version);
        AxAddIntToArray(retP, 2, info.docType);
        AxAddIntToArray(retP, 3, info.old_version);
        AxAddIntToArray(retP, 4, info.min_version);
        if ( info.content )
            AxAddStrToArray(retP, 5, info.content);
    }
    else {                  /* No header, or invalid header (e.g. *EL_STARTO) */
        return(NullDataPtr);
    }
    return(retP);
}

/***************************************************************************
function: AxfDocHasLinks
*/
data_ptr AxfDocHasLinks (argDatum)
data_ptr argDatum;
{
    mbchar *name = (mbchar *)StrFromArgArray(argDatum,0);
    return(AxElfDocHasLinks(name));
}

/***************************************************************************
function: AxfGetDocLinksInfo 
*/
data_ptr AxfGetDocLinksInfo (argDatum)
data_ptr argDatum;
{
    mbchar *name = (mbchar *)StrFromArgArray(argDatum,0);
    return(AxElfGetDocLinksInfo(name));
}

/***************************************************************************
function: AxfChangeDocLinksInfo 
*/
data_ptr AxfChangeDocLinksInfo (argDatum)
data_ptr argDatum;
{
    mbchar *name = (mbchar *)StrFromArgArray(argDatum,0);
    data_ptr docLinksObj = AnyFromArgArray(argDatum,1);

    AxElfChangeDocLinksInfo(name, docLinksObj);
    return(NullDataPtr);
}

/***************************************************************************
function: AxfLocalizeDocLinks 
*/
data_ptr AxfLocalizeDocLinks (argDatum)
data_ptr argDatum;
{
    data_ptr aP1 = AnyFromArgArray(argDatum,0); /* doc name */
    data_ptr aP2 = AnyFromArgArray(argDatum,1); /* elf doc links info */
    data_ptr aP3 = AnyFromArgArray(argDatum,2); /* save file */
    data_ptr aP4 = AnyFromArgArray(argDatum,3); /* parent document (used to get
                                                original path) */
    data_ptr aP5 = AnyFromArgArray(argDatum,4),
            aP6 = AnyFromArgArray(argDatum,5),
            aP7 = AnyFromArgArray(argDatum,6);  /* dummy */
    mbchar name[STRPATH+1];
    mbchar savefile[STRPATH+1];
    mbchar parentdoc[STRPATH+1];

    MBstrncpy(name, AxStrPtrFromDataPtr(aP1), STRPATH);
    name[STRPATH] = 0;
    MBstrncpy(savefile, AxStrPtrFromDataPtr(aP3), STRPATH);
    savefile[STRPATH] = 0;
    MBstrncpy(parentdoc, AxStrPtrFromDataPtr(aP4), STRPATH);
    parentdoc[STRPATH] = 0;
    AxElfLocalizeDocLinks(name, aP2, savefile, parentdoc);
    return(NullDataPtr);
}




/***********************************************************************
**  Use a system call to find out how long a filename we can create.
**  Note: this system call does not presently work across NFS mounts,
**        at least based on some test run on a variety of machines in April 93
**        If we get an error return on the 'pathconf' call we get the 
**        size from /tmp and use that as a fallback.
********************************************************************/

int ElfbGetMaxFileLength( dir_path )
char *dir_path;
{

#if AXMS    /*  {  */
        return( _MAX_FNAME );
#else
    int ret;

    ret = pathconf( dir_path, _PC_NAME_MAX );
    if ( ret < 0 )
       {
       /* a negative response, look at /tmp */
       ret =  pathconf( NXLT("/tmp"),  _PC_NAME_MAX );
       if ( ret < 0 )
           {
           /* still not good, return the system default */
#if X386_NEW || SGI || M_88K
           ret = 14;
#else
           ret = 255;
#endif
           }
       }

    return( ret );
#endif               /*  }  AXMS */
}

/*************************************************************************
function: AxfArrayTranspose - Produce transposed array
*/
data_ptr AxfArrayTranspose (argDatum)
data_ptr argDatum;
{
    data_ptr theArray = AnyFromArgArray(argDatum,0);
    register int ix, jx;
    register data_ptr old_row;
    register int old_row_count, old_col_count, cols_this_row;
    register data_ptr newData;

    old_row_count = ElfbArraySize(theArray);
    old_col_count = 0;
    for ( ix = 0; ix < old_row_count; ix++ ) {
        cols_this_row = ElfbArraySize(ReadArray(theArray,ix));
        if (cols_this_row > old_col_count) old_col_count = cols_this_row;
    }

    newData = AxMakeArray(old_col_count); /* create new row array */

/* copy the pointers, not the data */

    for ( ix = old_row_count-1; ix>=0; ix-- ) {
        old_row = ReadArray(theArray,ix);
        cols_this_row = ElfbArraySize(old_row);
        for ( jx = 0; jx < cols_this_row ; jx++ ) {
            if (!AX(newData)->vals[jx])
                WriteArray(newData,jx,AxMakeArray(ix+1)); /* make new row */
            AX(AX(newData)->vals[jx])->vals[ix] = 
                    ElfDataCopy(AX(old_row)->vals[jx]);
        }
    }

    return(newData);
}


/*************************************************************************
function: AxfArray1Column - Return a column from an array (as simple array)
This is a subset of the transpose.
*/
data_ptr AxfArray1Column (argDatum)
data_ptr argDatum;
{
    data_ptr oldData = AnyFromArgArray(argDatum,0),
            colDexP = AnyFromArgArray(argDatum,1);
    int colDex, ix, size;
    data_ptr aP;

    colDex = IntFromDataPtr(colDexP);
    VERIFY(colDex >= 0,ERR_ILLVAL);
    aP = MkArray(size = ElfbArraySize(oldData));
    for ( ix = 0; ix < size; ix++ )
        WriteArray(aP,ix,ElfDataCopy(AxArrayElement(ReadArray(oldData,ix),colDex)));
    return(aP);
}

data_ptr AxfArrayColumns(){ElfStrAbort(ERR_ILLVAL,XLT("Not Implemented"),NULL);}

/*************************************************************************
function: AxfBecomeParasite - Become a parasite of another task
*/
data_ptr AxfBecomeParasite (argDatum)
data_ptr argDatum;
{
    data_ptr aP;

    int parent, child;
    int parent_pid, child_pid;

    parent = IntFromArgArray(argDatum,0);
    parent_pid = ThimPidFromUID(parent);

    if(!AxArrayElement(argDatum, 1))        
        child_pid = AxInTask;
    else {
        child = IntFromArgArray(argDatum,1);
        child_pid = ThimPidFromUID(child);
    }

    ThimNoteParasite(child_pid, parent_pid);
    return(NullDataPtr);
}

extern data_ptr ElfMemoryUsage(), ElfFdStatus(), ElfResourceStatus();

/***************************************************************************
function: AxfListParasites 
*/
data_ptr AxfListParasites (argDatum)
data_ptr argDatum;
{
    int taskuid = IntFromArgArray(argDatum,0);  /* uid of task whose list of
                                                parasites is to be returned */
    int ix;
    int dex;
    int taskpid;
    data_ptr aP;

    taskpid = ThimPidFromUID(taskuid);
    if ( !taskpid )
        return(NullDataPtr);        /* invalid task uid passed */

    dex = 0;
    aP = (data_ptr)NULL;

    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use && (TaskInfo[ix].parasite_of == taskpid) ) {
            if ( !aP ) {
                aP = AxMakeArray(0);
            }
            aP = AxAddIntToArray(aP, dex++, ThimUIDPid(ix));
        }
    }

    return(aP);
}


/*************************************************************************
function: ElfWildcarder - Given an array of strs & wildspec, return array of str
*/
data_ptr ElfWildcarder (specD,strsD,indexesD)
data_ptr specD, strsD, indexesD;
{
    char *spec = StrFromDataPtr(specD);
    char *str;
    int dex = 0;
    int size, ix;
    int dexes = IntFromDataPtr(indexesD);
    data_ptr retD = AxMakeArray(0);

    size = ElfbArraySize(strsD);
    for ( ix = 0; ix < size; ix++ ) {
        if ( WildMatches(str = StrFromArray(strsD,ix), spec) ) {
            if ( dexes )
                retD = ElfAddNumToArray(retD, dex++, ix);
            else
                retD = ElfAddStrToArray(retD, dex++, str);
        }
    }
    return(retD);
}

extern int PrintMemoryStatsFlag;
extern int WidthOfDialogZero;
extern int AxCharHeight;
 
#if AXMS
extern int Scrollbar_Thickness;
#define SCROLLBAR_THICK Scrollbar_Thickness   /* variable on Windows */
#else
#define SCROLLBAR_THICK 16
#endif



extern data_ptr elfRenderInsetForJava();
extern data_ptr elfCreateInsetImageForJava();
extern data_ptr elfColorFromName();
extern data_ptr AxElfGetInstalledSharedLibs();
extern char *Adlerror();
extern char *JVGetMappedFontName();
/*************************************************************************
function: AxfUtil - General funcs 
*/
data_ptr AxfUtil (argDatum)
data_ptr argDatum;
{
    data_ptr cmdCodeP = AnyFromArgArray(argDatum,0),
            arg1 = AnyFromArgArray(argDatum,1),
            arg2 = AnyFromArgArray(argDatum,2),
            arg3 = AnyFromArgArray(argDatum,3),
            arg4 = AnyFromArgArray(argDatum,4),
            arg5 = AnyFromArgArray(argDatum,5),
            arg6 = AnyFromArgArray(argDatum,6);
    int cmdCode = IntFromDataPtr(cmdCodeP);
    int taskid, childid, uid;
    data_ptr aP;
    mbchar *str, *str2, *obj;
	wchar *wstr, *wstr2;
    int code;
    int len, ix, jx, pid;
    char buff[ STRPATH+1 ];
    data_ptr val;

    switch ( cmdCode ) {

    case 1:     /* MACRO_PARENT_KEEP_BLOCKED@(trueFalse) */
        TaskInfo[AxInTask].defer_acimok = (IntFromDataPtr(arg1) ? TRUE : FALSE);
        if ( !TaskInfo[AxInTask].defer_acimok )
            ACImOk();
        break;
    case 2:     /* LIST_OF_WINDOWS@ */
        ElfbListOfWindows();
        return(ElfRetData);
    case 3:     /* PEND_ON_TASK$ */
        taskid = IntFromDataPtr(arg1);
        taskid = ThimPidFromUID(taskid);
        VERIFY(THIMpid == ThimPidFromUID(TaskInfo[taskid].parentTask), ERR_ILLVAL);
        TaskInfo[THIMpid].pended = taskid;
        SuspendTask();
        if ( TaskInfo[THIMpid].child_retcode == 0 )
            return(ElfDataCopy(TaskInfo[THIMpid].child_retdata));
        else {
            code = TaskInfo[THIMpid].child_retcode;
            str = AxStrPtrFromArray(TaskInfo[THIMpid].child_retdata,0);
            obj = AxStrPtrFromArray(TaskInfo[THIMpid].child_retdata,1);
            ElfStrAbort(code,str,obj);
        }
        break;
    case 4:     /* INSTALLED@ */
        ElfbFuncInstalled(arg1);
        return(ElfRetData);
    case 5:
        aP = MkArray(0);
        aP = WriteArray(aP,0,ElfMemoryUsage());
        aP = WriteArray(aP,1,ElfFdStatus());
        aP = WriteArray(aP,2,ElfResourceStatus());
        return(aP);
        break;
    case 6:
        return(MK_INTEGER(ElfbRevStrIndex(StrFromDataPtr(arg1),StrFromDataPtr(arg2))));
    case 7:
        ElfbInstallBinaryPatch(arg1);
        break;
    case 8:
        ElfcPatchMode = IntFromDataPtr(arg1);
        break;
    case 9:     /* TASK_WINS_BUSY@ */
        if ( IntFromDataPtr(arg1) )
            AxmHourglassTaskWindows(TaskInfo[THIMpid].uid);
        else
            AXmRestoreNormalCursorPointer(TaskInfo[THIMpid].uid);
        break;

    case 10:    /* XLT_EXCEPTIONS_LOG_ON */
               /*   Args: turn_on, logname, open a+/w+ */
        XltExceptionsLog( TRUE, StrFromDataPtr(arg1), IntFromDataPtr(arg2));
        break;
    case 11:    /* XLT_EXCEPTONS_LOG_OFF */
        XltExceptionsLog( FALSE, (char *)NULL );
        break;
    case 12:   /* Load a new XLT translation file */
               /*   Args: filename, reload_flag */
        LoadGlossary( StrFromDataPtr(arg1), IntFromDataPtr(arg2) );
        break;

    case 13:
        /* return the length of a string in the current dialog box font */
        len = BasicStrlen( StrFromDataPtr(arg1) );
        return(AxMakeNumData( len ));
        break;
    case 14:
#if AXMS
        /* return an array which lists the printers on the Windows-NT system */
        return(GetWinPrinters());
#else
        return(NullDataPtr);
#endif
        break;

    case 15:
        ElfbUnBindSharedLib(arg1);
        break;

    case 16:
        ElfbSharedLibs(arg1,arg2);
        break;
    
    case 17:        /*  Build images file dynamically */
        /*  BuildGlomFile( prefix, src_dir, target_dir, filenames[])    */
        BuildGlomFile( arg1, arg2, arg3, arg4 );
        break;

    case 18:
        /* normalize a pathname to the local platform */
        strcpy( buff, StrFromDataPtr(arg1) );
        AxSysDosUnixPath( buff );
       return(AxMakeStrData( -1, buff ));
        break;

#if AXMS
    case 19:
        /* return the current drive letter, with colon, ie. "C:" */
        return (AxMakeStrData( -1, AxNTgetDrive() ));
        break;
#endif

    case 20:
        /*  Turn xlt exception loggin on & off without truncating exception
         *  file.  Supports context translation of dialog boxes. */
        XltExceptionsLogOnly( IntFromDataPtr(arg1) );
        break;

    case 21:    /* Wildcarder@ */
        return(ElfWildcarder(arg1,arg2,arg3));

    case 22:    /* promote_app_window@ - promote application window */
        return(MK_INTEGER(ElfPromoteAppWindow(StrFromDataPtr(arg1),
                                              IntFromDataPtr(arg2),
                                              IntFromDataPtr(arg3))));
    case 23:    /* pixel = ax_get_real_pixel@ - (0,r,g,b) or (2,c,m,y,k) */
        {
            unsigned long pixel;
        
            AxGetRealPixel(IntFromDataPtr(arg1), IntFromDataPtr(arg2),
                           IntFromDataPtr(arg3), IntFromDataPtr(arg4),
                           IntFromDataPtr(arg5), 255, &pixel);
            return(MK_INTEGER(pixel));
        }

    case 24:
        /* is this a Hyundai build? */
#if HYUNDAI
        return(MK_INTEGER(-1));    /* return TRUE */
#else
        return(MK_INTEGER(0));
#endif
 
    case 25:
        /* is this a Japanese build? */
#if BUILD_KANJI
        return(MK_INTEGER(-1));    /* return TRUE */
#else
        return(MK_INTEGER(0));
#endif

    case 26: /* alarm_set$() */
        AxSetAlarm(IntFromDataPtr(arg1), IntFromDataPtr(arg2));
        break;

    case 27: /* alarm_has_fired$() */
        return(MK_INTEGER((AxAlarmHasFired() ? BTRUE : FALSE)));

    case 28: /* get display string for specified century period */
        return(AxMakeStrData(-1, axGetDDStr()));
    case 29: /* set the century perioid value for date parsing */
        AxSetCenturyPeriodValue(IntFromDataPtr(arg1));
        break;
    case 30:
        code = axDDValidateArg(IntFromDataPtr(arg1));
        return(MK_INTEGER(code));
        break;

    case 31:  /* print memory statistics next time through the main loop */
        PrintMemoryStatsFlag = TRUE;  /* will cause print on task termination */
        break;

    case 32:  /* print memory stats now */
        Print_Memory_Stats();
        break;

#if AXMS
    case 33:
        /* use Windows common file open dialog box. */
        {
        char *pathname;
        pathname = DoWinOpenDialog(StrFromDataPtr(arg1));
        if ( pathname )
            return AxMakeStrData(-1, pathname);
        /* else, NULL is returned by default. */
        break;
        }
#endif

    case 34:     /* TASKINFO$ */
        uid = IntFromDataPtr(arg1);         /* Pass zero for task zero info */
        if (uid) {
            taskid = ThimPidFromUID(uid);
            if (!taskid)                    /* No such uid in use */
                return(NullDataPtr);
        }
        else
            taskid = 0;

        /* Eventually, an ELF format and defines for the positions of its
            members will be available. For now, callers will just have
            to keep in synch with the following. - D Miller 5/95 */
        aP = MkArray(0);
        aP = AxAddIntToArray(aP, 0, taskid);
        aP = AxAddIntToArray(aP, 1, TaskInfo[taskid].appid);
        aP = AxAddBoolToArray(aP, 2, (TaskInfo[taskid].gfx ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 3, (TaskInfo[taskid].start_me ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 4, (TaskInfo[taskid].kill_me ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 5, (TaskInfo[taskid].unpend_me ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 6, (TaskInfo[taskid].usesElfArgs ? TRUE : FALSE));
        if (TaskInfo[taskid].stack) {
            sprintf( buff, "0x%x", TaskInfo[taskid].stack);
            aP = AxAddStrToArray(aP, 7, TaskInfo[taskid].stack);
        }
        aP = AxAddIntToArray(aP, 8, TaskInfo[taskid].stack_size);
        aP = AxAddIntToArray(aP, 9, TaskInfo[taskid].helper_type);
        for (ix=0,jx=0; ix<MAX_OPEN_FILES; ++ix)
            if (TaskInfo[taskid].fds[ix] != -1) ++jx;
        aP = AxAddIntToArray(aP, 10, jx);
        aP = AxAddBoolToArray(aP, 11, (TaskInfo[taskid].in_busy_loop ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 12, (TaskInfo[taskid].ipc_response_waiting ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 13, (TaskInfo[taskid].ipc_timed_wait ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 14, (TaskInfo[taskid].ipc_true_timer ? TRUE : FALSE));
        aP = AxAddIntToArray(aP, 15, TaskInfo[taskid].ipc_milliseconds);
        aP = AxAddBoolToArray(aP, 16, (TaskInfo[taskid].recycle_only ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 17, (TaskInfo[taskid].have_polled ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 18, (TaskInfo[taskid].timed_out ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 19, (TaskInfo[taskid].pended ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 20, (TaskInfo[taskid].ok_pended ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 21, (TaskInfo[taskid].elfCallBlocked ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 22, (TaskInfo[taskid].interruptable ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 23, (TaskInfo[taskid].have_okayed ? TRUE : FALSE));
        aP = AxAddIntToArray(aP, 24, TaskInfo[taskid].parentTask);
        aP = AxAddIntToArray(aP, 25, TaskInfo[taskid].child_retcode);
        aP = AxAddBoolToArray(aP, 26, (TaskInfo[taskid].child_retdata ? TRUE : FALSE));
        aP = AxAddBoolToArray(aP, 27, (TaskInfo[taskid].haveSocketInput ? TRUE : FALSE));
        aP = AxAddIntToArray(aP, 28, TaskInfo[taskid].numDefered);
        aP = AxAddIntToArray(aP, 29, TaskInfo[taskid].taskMaster);
        aP = AxAddIntToArray(aP, 30, TaskInfo[taskid].priorTaskMaster);
        aP = AxAddIntToArray(aP, 31, TaskInfo[taskid].parasite_of);

        return( aP);
        break;

    case 35:
        /* return an array of the measuremnts for various dialog box elements */
        /* the array is:  width of basic char, line height, width of scrollbar*/
        aP = MkArray(0);
        aP = AxAddIntToArray(aP, 0, WidthOfDialogZero );
        aP = AxAddIntToArray(aP, 1, AxCharHeight );
        aP = AxAddIntToArray(aP, 2, SCROLLBAR_THICK );
 
        return( aP );
        break;

    case 36:
        /* return TRUE if the passed dialog is set-aside, else FALSE */
        {
            AXWidget id_widget;
            AXWidget_dialog dlg;

            id_widget = WidgetPointerFromHandleData(arg1);
            dlg = (AXWidget_dialog)XmDlgInWidget(id_widget);

            if ( dlg && dlg->type == W_DIALOG )
            {
#if AX_X11
                if ( dlg->parent && dlg->parent->currently_mapped )
#else
                if ( !MS_IsIconic(dlg->parent->winid) )
#endif
                    return(ELF_CREATE_INTEGER(FALSE));
            }

            return(ELF_CREATE_INTEGER(BTRUE));

            break;
        }

    case 37:
        /* [un]iconify the passed dialog */
        {
            AXWidget id_widget, dlg;

            id_widget = WidgetPointerFromHandleData(arg1);
            dlg = (AXWidget)XmDlgInWidget(id_widget);

            code = IntFromDataPtr(arg2);

            if ( dlg && dlg->type == W_DIALOG )
            {
                if ( AxIconifyWindow(dlg,code) )
                    return(ELF_CREATE_INTEGER(BTRUE));
            }

            return(ELF_CREATE_INTEGER(FALSE));

            break;
        }

#if AXMS    /* { */
    case 38:
        /* get Win32 GDI printer driver capabilities */
        {
        int ii, ret;
        char *strP;
        int dc_code = IntFromDataPtr(arg1);
        char *printer_name = StrFromDataPtr(arg2);
        data_ptr arrP, sizeP;
        switch (dc_code) {
        case 0:    /* get color capability */
            {
            int num_colors = 0;
            HDC hdc = GetPrinterHDCfromName(printer_name);
            if ( hdc )
                {
                num_colors = MS_GetDeviceCaps(hdc, NUMCOLORS);
                MS_DeleteDC(hdc);
                }
            if ( num_colors > 2 )
                return ELF_CREATE_INTEGER(BTRUE);
            else
                return ELF_CREATE_INTEGER(BFALSE);
            }
        case 1:    /* retrieve duplex caps */
            {
            ret = 0;
            if ( printer_name && printer_name[0] )
                {
                ret = MS_DeviceCapabilities(printer_name, "LPT1:", DC_DUPLEX,
                                                                 NULL, NULL);
                }
            if ( ret == 1 )
                return ELF_CREATE_INTEGER(BTRUE);
            else if ( ret == -1 )
                WXErrorMessage("DeviceCapabilities failed!");
            return ELF_CREATE_INTEGER(BFALSE);
            }
        case 2:    /* retrieve bin names */
            {
            int num_bins=0;
            char *bin_names;
            if ( printer_name && printer_name[0] )
                {
                num_bins = MS_DeviceCapabilities(printer_name, "LPT1:",
                                            DC_BINNAMES, NULL, NULL);
                }
            if ( num_bins > 0 )
                {
                bin_names = malloc(num_bins*24*sizeof(char));
                num_bins = MS_DeviceCapabilities(printer_name, "LPT1:",
                                        DC_BINNAMES, bin_names, NULL);
                arrP = ELF_CREATE_ARRAY(num_bins);
                for ( ii=0, strP=bin_names; ii < num_bins; ii++, strP += 24 )
                    {
                    if ( strP )
                        arrP = ElfAddStrToArray(arrP, ii, strP);
                    }
                free(bin_names);
                return arrP;
                }
            break;
            }
        case 3:    /* retrieve paper sizes */
            {
            int num_papers=0, width, height;
            POINT *paper_sizes;
            char *paper_names;
            WORD *papers;
            if ( printer_name && printer_name[0] )
                {
                num_papers = MS_DeviceCapabilities(printer_name, "LPT1:",
                                                DC_PAPERS, NULL, NULL);
                }
            if ( num_papers > 0 )
                {
                papers      = (WORD*)malloc(num_papers*sizeof(WORD));
                paper_names = malloc(num_papers*64);
                paper_sizes = (POINT*)malloc(num_papers*sizeof(POINT));
                /* retrieve paper sizes (in 10ths of millimeters). */
                num_papers = MS_DeviceCapabilities(printer_name, "LPT1:",
                                    DC_PAPERSIZE, (LPTSTR)paper_sizes, NULL);
                /* retrieve the paper names: Legal, A4, etc... */
                num_papers = MS_DeviceCapabilities(printer_name, "LPT1:",
                                        DC_PAPERNAMES, paper_names, NULL);
                /* retrieve the values that represent the paper names:
                 * DMPAPER_LETTER, DMPAPER_LEGAL, DMPAPER_A4, etc...
                 * (They are actually more important than the string names).
                 */
                num_papers = MS_DeviceCapabilities(printer_name, "LPT1:",
                                        DC_PAPERS, (LPTSTR)papers, NULL);
                arrP = ELF_CREATE_ARRAY(num_papers);
                for ( ii=0,strP=paper_names; ii < num_papers; ii++,strP+=64 )
                    {
                    /* the paper size dimensions are in 10ths of millimeters,
                     * so convert to 1000ths of inches for the PF code.-donato
                     */
                    width  = (double)(paper_sizes[ii].x/254.0) * 1000;
                    height = (double)(paper_sizes[ii].y/254.0) * 1000;

                    sizeP = ELF_CREATE_ARRAY(4);
                    sizeP = ElfAddNumToArray(sizeP, 0, width);
                    sizeP = ElfAddNumToArray(sizeP, 1, height);
                    sizeP = ElfAddStrToArray(sizeP, 2, strP);
                    sizeP = ElfAddNumToArray(sizeP, 3, papers[ii]);
                    arrP = WriteArray(arrP, ii, sizeP);
                    }
                free(papers);
                free(paper_sizes);
                free(paper_names);
                return arrP;
                }
            break;
            }

        default:
            break;
            }
        /* break for case 38: */
        break;
        }

    case 39:
        {
        int targetRes;
        char *printer_name = StrFromDataPtr(arg1);
        EnumeratePrinterFonts(printer_name, &targetRes);
        break;
        }

    case 40:  /* return array (r, g, b) of the work background color on NT. */
        {
        data_ptr arrP = ELF_CREATE_ARRAY(3);
        DWORD sys_color = MS_GetSysColor(COLOR_WINDOW);

        arrP = ElfAddNumToArray(arrP, 0, MS_GetRValue(sys_color));
        arrP = ElfAddNumToArray(arrP, 1, MS_GetGValue(sys_color));
        arrP = ElfAddNumToArray(arrP, 2, MS_GetBValue(sys_color));
        return arrP;
        }
#endif    /* } AXMS */

    case 41:    /*  Free xlt glossary memory */
                /*  Args: no filename, reload_flag */
        LoadGlossary( "", 1 );
        break;
    case 42:        /* set/clear Java'nees of task */
        TaskInfo[ThimPidFromUID(IntFromDataPtr(arg1))].TaskUsesJavaDisplay = 
                (IntFromDataPtr(arg2) != FALSE);
        break;
    case 43:        /* get task's Java'ness */
        return(ELF_CREATE_INTEGER(
            TaskInfo[ThimPidFromUID(IntFromDataPtr(arg1))].TaskUsesJavaDisplay ?
                BTRUE : FALSE));
    case 44:            /* task_accept_pokes@(codesArray) */
        AxTaskAcceptPokes(THIMpid, arg1);
        break;

    case 45: {      /* socket_register_inherited$ */
        int channel = IntFromDataPtr(arg1);
        if ( !AxSockMakeChannelNonBlocking(channel) )
            ElfStrAbort(ErrnoErr(),NULL,"nonblock");
        channel = AxNoteSocket(channel,NULL,AxInTask,FALSE);
        return(ELF_CREATE_INTEGER(channel));
        }
    case 46: {          /* get_java_image_packet$(iconname) */
        data_ptr AxGetJavaImagePacket();
        return(AxGetJavaImagePacket(StrFromDataPtr(arg1)));     /* tmimage.c */
        }
    case 47:
        JavaMode = (IntFromDataPtr(arg1) != 0);
        break;
    case 48:
        AxSocketSetPacking(IntFromDataPtr(arg1),TRUE);
        break;
    case 49:        /* TEMP HACK!!! */
        return((data_ptr)ssJavaGetChart(StrFromDataPtr(arg1)));
        break;
    case 50:    /* ax_get_shared_libs@ */
        aP = (data_ptr)AxElfGetLoadedLibNames();
        return( aP);
    case 51:    /* set the state AXTrace */
        if(!AxArrayElement(argDatum, 1))        
            break;
        str = AxStrPtrFromArray(argDatum, 1);
        return(AxMakeIntData(AXTraceON(str)) );
        break;
    case 52:    /* turn off tracing */
        return(AxMakeIntData(AXTraceOFF()) );
        break;
    case 53: /* get the trace file */
        if(!AXTrace)
            return(NULL);
        return(AxMakeStrData(-1, AXTraceFile()) );
    case 54:
        str = Adlerror();   
        if((str == NULL) || (*str == '\0'))
            return(NULL);
        return(AxMakeStrData(-1, str));
    case 55:
        return(MK_INTEGER(ElfFaceNameToJavaCode(StrFromDataPtr(arg1))));        
    case 56: {
        int channel = IntFromDataPtr(arg1);
        AxSocketUseCheckSums(channel);
        break;
    }
    case 57:
        if(AXTrace && (AxArrayElement(argDatum, 1))) {
            str = AxStrPtrFromArray(argDatum, 1) ;
            AXTRACE(("%s\n", str));
        }
        break;
    case 58:
        /* return an array of the resource counts */
#if AXMS
#if DEBUG_RESOURCES
        return( report_resource_counts() );
#else
        aP = AxMakeArray(1);
        aP = WriteArray(aP,0,
                    AxMakeStrData(-1, NXLT("Not a resource tracking build")) );
        return( aP );
#endif
#endif
        break;
    case 59:    /* rpc_buffer_writes$(channel,flag) */
        AxSockBufferWrites(IntFromDataPtr(arg1),IntFromDataPtr(arg2));
        break;
    case 60:
        /* are we running Windows 95? */
#if AXMS
        if ( Running_Windows95 )
            return ELF_CREATE_INTEGER(BTRUE);
        else
#endif
            return ELF_CREATE_INTEGER(FALSE);
 
    case 61:
        /* Read the .odbc.ini file for elfodbc gateway /
        return (AxReadODBC_INIFile(arg1)); */
       return (ELF_CREATE_INTEGER(FALSE));

    case 62:
#if AXMS
        {
        /*** SNAP-to-CLIPBOARD on Windows NT/95 ***/
        /* We activate the hidden, "unmapped" window by making it transparent
         * and maximizing it. See UnMappedClassProc in winevent.c for how
         * it accomplishes the screen capture.          -donato
         */
        HWND hwnd = AxTopHWNDNeverMapped;
        int screen_wid = MS_GetSystemMetrics(SM_CXSCREEN);
        int screen_hyt = MS_GetSystemMetrics(SM_CYSCREEN);

        MS_SendMessage(hwnd, WM_ERASEBKGND, 0, 0L);
        MS_SetWindowLong(hwnd, GWL_EXSTYLE, WS_EX_TRANSPARENT);
        MS_SetWindowPos(hwnd, HWND_TOP, 0, 0, screen_wid, screen_hyt,
                                                    SWP_NOACTIVATE);
        MS_SendMessage(hwnd, AX_WM_SNAPINIT, 0, 0L);
        MS_ShowWindow(hwnd, SW_SHOW);
        return ELF_CREATE_INTEGER(BTRUE);
        }
#else
        break;
#endif
    case 63:
        /* add a hostname and encrypted copy of user's password to */
        /* the internal table we use when making remote connections */
        /* this is required only of the remote machine isan NT machine */
        str = StrFromDataPtr(arg1);    /* remote host name */
        obj = StrFromDataPtr(arg2);    /* clear text password */
        AddEncryptedPasswordToTable( str, obj );
        break;

    case 64:
        /* Are we running Windows 95 OR Windows NT? */
#if AXMS
        return ELF_CREATE_INTEGER(BTRUE);
#else
        return ELF_CREATE_INTEGER(FALSE);
#endif

        break;

    case 65:    /* Return bitmap for inset to send over wire for Java */
        return elfRenderInsetForJava(arg1,arg2,arg3, arg4);

    case 66:
        /*
         * file_is_writable$ - a file writable test that doesn't
         * throw errors
         */

        if (Aaccess(StrFromDataPtr(arg1), W_OK) != 0)
        {
            if (errno == ENOENT)
                return(ELF_CREATE_INTEGER(BTRUE));
            else
                return(ELF_CREATE_INTEGER(FALSE));
        }
        else
            return(ELF_CREATE_INTEGER(BTRUE));

        break;

    case 67:    /* return lock status of passed profile entry */
        str = StrFromDataPtr(arg1);

        if ( UPIsLocked(str) )
            return(ELF_CREATE_INTEGER(BTRUE));
        else
            return(ELF_CREATE_INTEGER(FALSE));

        break;

    case 68:
        return elfColorFromName(StrFromDataPtr(arg1));  /* see colorcom.c */

    case 69:    /* allow_java_wp$ */
        if ( AllowJavaWp() )
            return(ELF_CREATE_INTEGER(BTRUE));
        else
            return(ELF_CREATE_INTEGER(FALSE));

    case 70:    /* wait_resource@ */
        AxWaitOnResource(StrFromDataPtr(arg1), IntFromDataPtr(arg2),
                        TaskInfo[AxInTask].uid);
        break;

    case 71:    /* notify_resource@ */
        AxNotifyResource(StrFromDataPtr(arg1));
        break;

    case 72:
#if AXMS
        /* expand a path to the "long" filename version */
        str = StrFromDataPtr(arg1);
        strcpy( buff, str );
        MakePathWithLongNames( buff );
        return( AxMakeStrData( -1, buff ) );
#endif
        break;
    case 73:
        AxJavaNoteClientChannel(AxInTask,
			IntFromDataPtr(arg1),StrFromDataPtr(arg2));
        break;
    case 74:     /* JV_TASK_WINS_BUSY$ */
        {
        int task = IntFromDataPtr(arg1);
        if ( IntFromDataPtr(arg2) )
            AxmHourglassTaskWindows(task);
        else
            AXmRestoreNormalCursorPointer(task);
        }
        break;
    case 75:    /* SET_DEFAULT_ELF_SEARCH_LIST$ */
        ElfSetStandardSearchList();
        break;
    case 78:
#if !AXMS
        /* get list of printers for Solaris type systems */
        {
        FILE *fp = popen(NXLT("/usr/bin/lpstat -v"), NXLT("r+")) ;
        char line[512] ;
        char *printer ;
        data_ptr plist ;
        int k = 0 ;

        plist = ELF_CREATE_ARRAY(0) ;
            
        while (fp && fgets(line, sizeof(line), fp) != NULL)
        {
            strtok(line, NXLT(": ")) ;
            strtok(NULL, NXLT(": ")) ;
            printer = strtok(NULL, NXLT(": ")) ;
            plist = ElfAddStrToArray(plist, k++, printer);
        }
        pclose(fp) ;
        return (plist) ;
        }
#endif
        break;
    case 80: /* regular expression matching */
    {
      char *reg_exp_ptr;
      char *next_char;
      int ix, asize, rsize, rval;
      data_ptr rData;

      /* set up the return value */
      rData = AxMakeArray(0);
      rsize = 0;

      /* get the regular expression string */
      reg_exp_ptr = AxStrFromDataPtr(arg1);

      /* for each element in the second argument array, check to see if
         it matches the regular expression; if so, add the array index
         to the return value */
      asize = AxArraySize(arg2);
      for (ix=0; (ix < asize); ix++) {
        next_char = AxStrFromArray(arg2, ix);
        rval = WildMatches(next_char, reg_exp_ptr);
        if (rval) {
          rData = AxAddIntToArray(rData, rsize++, ix);
        }
      }
      return(rData);
    }
    break;
    case 81:
        /* notify all SS tasks, that a Real Time Gateway has been started */
        AxNotifySSRtStarted(AxStrPtrFromDataPtr(arg1));
        break;
    case 82:
        /* are we running Windows 95/nt4.x? */
#if AXMS
        if ( RunningWin95Look )
            return ELF_CREATE_INTEGER(BTRUE);
        else
#endif
            return ELF_CREATE_INTEGER(FALSE);

#if !BUILD_KANJI           /*  {  */
      case 83:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = do_parse_cda_for_charlines(funcData);
	  return(rval);
	}
      case 84:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(4);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  funcData = AxAddDataToArray(funcData, 3, arg4);
	  rval = do_parse_cda_for_substructure(funcData);
	  return(rval);
	}
      case 85:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = do_remove_substructure_in_cda(funcData);
	  return(rval);
	}
      case 86:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(5);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  funcData = AxAddDataToArray(funcData, 3, arg4);
	  funcData = AxAddDataToArray(funcData, 4, arg5);
	  rval = do_add_or_replace_substructure_in_cda(funcData);
	  return(rval);
	}
      case 87:
	{
	  return(do_tm1_remove_server_name(arg1));
	}
      case 88:
	{
	  return(do_tm1_remove_table_or_dimension_name(arg1));
	}
		
	case 89:
		return ElfReadMenuBarFile(AxStrFromDataPtr(arg1));
		break;
#endif                 /*  }  !BUILD_KANJI */

	case 90:
		{
		int rval;
		/* ax_is_na@() */
		rval = AxSSIsNa(arg1);
		if(rval)
			return(AxMakeIntData(BTRUE));
		return(AxMakeIntData(FALSE));
		break;
		}
	  
	case 91:	/* aa_client_id@ */
		return(ELF_CREATE_INTEGER(AxJavaClientId(AxInTask)));

    case 92:	/* aa_client_shut$ */
        AxJavaClientShut();
        break;

	case 93:	/* java_add_dlg_to_list$(uid,title,parent_task) */
		JVAddDlgToList (IntFromDataPtr(arg1),StrFromDataPtr(arg2),
					IntFromDataPtr(arg3),IntFromDataPtr(arg4));
		break;

	case 94:	/* java_remove_dlg_from_list$(uid) */
		JVRemoveDlgFromList(IntFromDataPtr(arg1));
		break;
	case 95: /* aa_curwin_id@ */
		return( ELF_CREATE_INTEGER(AxJavaGetCurwinId(AxIntFromDataPtr(arg1))) );
	case 96: /* find_ss_task_for_file$ */
		return( ELF_CREATE_INTEGER(AxFindSSTaskForFile(AxStrFromDataPtr(arg1))) );

	case 97:	/* aa_info_message_all@ */
		AxJavaPostMessage(NULL,NULL,StrFromDataPtr(arg1),FALSE,IntFromDataPtr(arg2));
		break;
	case 98:	/* aa_channel_stats@ */
		return(AxJavaChannelStats());
		break;
	case 99:	/* aa_reset_stats@ */
		AxJavaChannelStatsReset();
		break;
	case 100:	/* elf_timing_start@ */
		ElfProfileStart();
		break;
	case 101:	/* elf_timing_stop@ */
		ElfProfileStart();
		break;
	case 102:	/* elf_timing_report@ */
		ElfProfileReport(StrFromDataPtr(arg1));
		break;
	case 103:	/* aa_dump_messages$ */
		SetAADumpCounter (IntFromDataPtr(arg1));
		break;
	case 104:   /* jv_get_mapped_font_name$ */
		str = JVGetMappedFontName(StrFromDataPtr(arg1));
        if((str == NULL) || (*str == '\0'))
            return(NULL);
		return(AxMakeStrData(-1, str));
		break;
	case 105:	/* aa_note_cli_resources$(info) */
		AxJavaNoteClientResources(arg1);
		break;
    case 106:	/* aa_set_secure$ */
        AxSocketSetXORNoise(IntFromDataPtr(arg1),TRUE);
        break;
    case 107:	/* aa_set_client_noise$ */
		ElfClientNoiseDelivery(IntFromDataPtr(arg1),BX(arg2)->bytes);
		break;
	case 110:	/* Read first line from file for TM1 */
	/* This is case 110 in 4.3.7, I maitained it for this
	   version also */
	{
		data_ptr rval;
		rval = (data_ptr) tm1_read_1_line_from_file(AxStrFromDataPtr(arg1));
		return(rval);
	}

	case 111:
		/* encrypt passed string - used to send password to axnet on NT */
		EncryptPassword(StrFromDataPtr(arg1), buff);
		return(AxMakeStrData(-1, buff));
		
		
	case 112:  /* get keys-minus-mask from masked entry field */
		str = StrFromDataPtr(arg1);   /* edit mask string */
		str2 = StrFromDataPtr(arg2);  /* value from so-masked field */
		wstr = EditMaskKeystrokes((char *) str, MbToWOneStr(str2));
		return (AxMakeStrData(-1, WToMbOneStr(wstr)));
    case 113:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(5);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  funcData = AxAddDataToArray(funcData, 3, arg4);
	  funcData = AxAddDataToArray(funcData, 4, arg5);
	  rval = (data_ptr)tm1ui_calc_browse_canvas_layout(funcData);
	  return(rval);
	}
    case 114:
	{
	  data_ptr funcData, rval;
	  rval = (data_ptr)tm1ui_subset_calc_layout_init(arg1);
	  return(rval);
	}
    case 115:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(5);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  funcData = AxAddDataToArray(funcData, 3, arg4);
	  funcData = AxAddDataToArray(funcData, 4, arg5);
	  rval = (data_ptr)tm1ui_calc_browse_init_canvas_layout(funcData);
	  return(rval);
	}
    case 116:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = (data_ptr)tm1subset_get_subset_elements(funcData);
	  return(rval);
	}
    case 117:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = (data_ptr)tm1subset_get_subset_element_by_index(funcData);
	  return(rval);
	}
    case 118:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = (data_ptr)tm1subset_get_subset_layout(funcData);
	  return(rval);
	}
    case 119:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = (data_ptr)tm1subset_set_subset_layout(funcData);
	  return(rval);
	}
    case 120:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = (data_ptr)tm1subset_get_subset_size(funcData);
	  return(rval);
	}
    case 121:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(1);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  rval = (data_ptr)tm1subset_get_level_list(funcData);
	  return(rval);
	}
    case 122:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(1);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  rval = (data_ptr)tm1subset_get_parent_list(funcData);
	  return(rval);
	}
    case 123:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(1);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  rval = (data_ptr)tm1subset_get_children_list(funcData);
	  return(rval);
	}
    case 124:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = (data_ptr)tm1subset_add_new_subset(funcData);
	  return(rval);
	}
    case 125:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = (data_ptr)tm1subset_remove_subset_info(funcData);
	  return(rval);
	}
    case 126:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = (data_ptr)tm1subset_retrieve_subset_max_width(funcData);
	  return(rval);
	}
    case 127:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = (data_ptr)tm1subset_store_subset_max_width(funcData);
	  return(rval);
	}
    case 128:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(2);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  rval = (data_ptr)tm1subset_retrieve_subset_max_height(funcData);
	  return(rval);
	}
    case 129:
	{
	  data_ptr funcData, rval;
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = (data_ptr)tm1subset_store_subset_max_height(funcData);
	  return(rval);
	}
    case 130:
	{
	  data_ptr rval;
	  rval = (data_ptr)tm1subset_clear_subset_caches();
	  return(rval);
	}
    case 131:
	{
	  data_ptr funcData, rval, tm1subset_get_layout_info_entry_by_index();
	  funcData = AxMakeArray(3);
	  funcData = AxAddDataToArray(funcData, 0, arg1);
	  funcData = AxAddDataToArray(funcData, 1, arg2);
	  funcData = AxAddDataToArray(funcData, 2, arg3);
	  rval = (data_ptr)tm1subset_get_layout_info_entry_by_index(funcData);
	  return(rval);
	}

	case 132:    /* ax_get_shared_lib_info@ */
	  return(AxElfGetLoadedLibInfo());

	case 133:    /* dir_access_allowed$ */
        if(!AxArrayElement(argDatum, 1))        
			/* As in AxAccessAllowed, null file returns FALSE */
            return(ELF_CREATE_INTEGER(FALSE));
        str = AxStrPtrFromArray(argDatum, 1);
        code = AxAccessAllowed(str);		/* see axaccess.c */
		if (code)
            return(ELF_CREATE_INTEGER(BTRUE));
		else
            return(ELF_CREATE_INTEGER(FALSE));
	case 134: /* get_macro_id$ */
		return(ELF_CREATE_INTEGER(
			ElfCaselessLookupSymbol(AxStrFromDataPtr(arg1),1)));
	case 135: /* get_macroname_from_id$ */
		return(AxMakeStrData(-1,
			ElfSymbolNameFromId(AxIntFromDataPtr(arg1),1)));

	case 136:	/** aa_http_post_file@({host,port,url,filename}) */
		return (data_ptr)AxfAAgtwyPostFile(arg1);
	case 137:
		AxfJvCloseInfoMsg(IntFromDataPtr(arg1)); /* xmutils.c */
		break;
		
	case 138:    /* enterprise.ab::strs_array_to_crnl_string$ */
		return (ElfStrsArrayToElfCRNLString(arg1));

	case 139:    /* enterprise.ab::crnl_string_to_strs_array$ */
		return (ElfCRNLStringToElfStrsArray(arg1));

    case 140:    /* Return uid for inset for Java */
        return elfCreateInsetImageForJava(arg1,arg2,arg3, arg4);
    case 141:
		pid = ThimTopPidFromPid(ThimPidFromUID(AxIntFromDataPtr(arg1)));
		if ( AxIsGraphicsTask(pid))
			GEMenuBarInfoModified(pid);
		break;
	case 142:
#if AXMS
		{
		char folder_name[MAX_PATH+1];
		if ( !axmsGetDrivesFolderName(folder_name, MAX_PATH+1) )
			strcpy(folder_name, "My Computer");  /* sane default */
        return AxMakeStrData(-1, folder_name);
		}
#else
		break;	
#endif
	case 145:
		{
        char *filename = StrFromDataPtr(arg1);
	    if ( AxIsOleStorageFile(filename) )
            return(ELF_CREATE_INTEGER(BTRUE));
		else
            return(ELF_CREATE_INTEGER(FALSE));
		break;
		}
    case 146:
        {
            char *ret_str, *mbstr;
            char *str = StrFromDataPtr(arg1);
            if ( str )
            {
                int slen = strlen(str);
                ret_str = (char*)malloc(slen + 1);
#if !(LINUX && !LIBC5) /* Posix threads olefilter doesn't use UTF */
                MButf2sjis(str, ret_str);
#endif
#if BUILD_KANJI
                MBsjis2euc_str(ret_str);
#endif
                return AxMakeStrData(-1, ret_str);
            }
        }
        break;
    case 160: /* remove messages on task que, return as array */
			return((data_ptr)AxPopMsgP());
		break;
    case 161: /* appends array to messages on task que */
			return((data_ptr)AxSetMsgP(arg1));
		break;
    case 162:  /* return the first entry on the "allowed" directory list */
        GetFirstAccessPath( buff );
        if ( buff[0] == '\0' )
            /* no restricted paths set, return system tem dir */
            return(AxMakeStrData( -1, "" ));
        else
            return(AxMakeStrData( -1, buff ));
        break;
    case 163:
        /* read part of a binary file  */
        str = AxStrFromDataPtr( arg1 );   /* path to the file */
        ix = AxIntFromDataPtr(arg2);      /* starting offset */
        len = AxIntFromDataPtr(arg3);     /* length to read */

        aP = ReadPartBinaryFile( str, ix, len );
        return( aP );
        break;
    case 164:
		{
#if AXMS
        char *cmd = AxStrFromDataPtr(arg1);
		code = axmsStartProcessAndWaitForEvent(cmd);
        return(MK_INTEGER(code));
#endif
		}
	case 165:
		{
			char *filename = AxStrFromDataPtr(arg1);
			if (tm1_file_exists(filename))
				return(MK_INTEGER(BTRUE));
			else
				return(MK_INTEGER(FALSE));
		}
		break;
	case 166:
		{
			char *dirname = AxStrFromDataPtr(arg1);
			char *wildcard = AxStrFromDataPtr(arg2);
			return(tm1_file_system_files(dirname, wildcard));
		}
		break;
	case 167:
		{
			char *newname = AxStrFromDataPtr(arg2);
			if (tm1_write_ascii_lines(arg1, newname) < 0)
				return(MK_INTEGER(FALSE));
			return(MK_INTEGER(BTRUE));
		}
		break;
	case 168:
		return(tm1_read_ascii_lines(AxStrFromDataPtr(arg1)));
        break;
	case 169:
		AxJavaEuroKeysym();				/* context.c */
		break;
	case 170:
		AxRefreshFontInfo();
		break;
	case 171:
		if (AxVerifySharedLibrary( AxStrFromDataPtr(arg1)))		/* context.c */
			return(MK_INTEGER(BTRUE));
		return(MK_INTEGER(FALSE));
		break;
	case 172:
        return(MK_INTEGER(AxDemoDays));
		break;

    }      /* end of switch */

    return(NullDataPtr);
}

/**************************************************************************
 *
 * AxfAxStringFileName
 *
 * Returns the name of the Applix string file currently in use.
 */
data_ptr AxfAxStringFileName ()

{
    return(ELF_CREATE_STRING(AxStrflName));
}





#if BUILD_ORIENT   /*  {  */

/************************************************************************/
/* The following will take two data objects, and sort them as wide      */
/*   strings. At the same time, we process the strings to use only the  */
/*   'sort portion', if it exists.  This 'sort portion' is any characters */
/*   before a pipe symbol "|" within an 'index' field.  The index fields */
/*   are seperated by bytes with a value of 1 (^A).  The user used a     */
/*   semi-colon as the delimiter but these have been transformed to the  */
/*   ^A values so that the entire string can be compared, an not indivisual */
/*   subfields.                                                         */
/* Note: There is a limit on the length of the strings being sorted of  */
/*   MAX_ORIENT_SORT_CHARS.  Any chars beyond this will be clipped      */
/************************************************************************/

#define MAX_ORIENT_SORT_CHARS 100
int Wstrcmp();
int AWstrcmp();

int OrientIndexCmp(pp1, pp2)
    data_ptr       *pp1, *pp2;
{
    register data_ptr p1, p2;
    wchar  t1[MAX_ORIENT_SORT_CHARS+1], t2[MAX_ORIENT_SORT_CHARS+1];
    int retval;

    p1 = *pp1;
    p2 = *pp2;
    if (!XX(p1))
        t1[0] = 0;
    else
        MbToWnStr( SX(p1)->text, t1, MAX_ORIENT_SORT_CHARS );

    if (!XX(p2))
        t2[0] = 0;
    else
        MbToWnStr( SX(p2)->text, t2, MAX_ORIENT_SORT_CHARS );

    WProcessIndexStringForSort( t1, TRUE );
    WProcessIndexStringForSort( t2, TRUE );

    if (ElfCaseSensitiveSort)
        retval = ElfDescendingSort ? Wstrcmp(t2, t1) : Wstrcmp(t1, t2);
    else
        /* AWstrcmp() in astrcmp.c is case INSENSITIVE */
        retval = ElfDescendingSort ? AWstrcmp(t2, t1) : AWstrcmp(t1, t2);

    return( retval );
}


#define FIELD_DELIMITER (wchar)1

WProcessIndexStringForSort( str, get_sort_portion)
wchar *str;
int get_sort_portion;
{
    register wchar *p1, *p2;
    register int direction;
    register int skip_till_break = FALSE;

    if ( get_sort_portion )
       {
       /* we start from the front of the string */
       p1 = p2 = str;

       while ( *p1 != (wchar)0 )
          {
          if ( !skip_till_break )
             {
             if ( *p1 == '|' )
                {
                /* the rest of the stuff, up to the field delimiter */
                /* is the visible display string, so skip it */
                skip_till_break = TRUE;
                }
             else if ( *p1 == FIELD_DELIMITER )
                {
                *p2 = *p1;
                skip_till_break = FALSE;
                }
             else
                {
                /* a normal character */
                *p2 = *p1;
                p2++;
                }
             }
          p1++;
          }
       *p2 = (wchar)0;
       }
    else
       {
       /* we want the displayable portion of the string, we work backwards */
       p1 = p2 = str + Wstrlen(str) - 1;
       while ( p1 >= str )
          {
          if ( !skip_till_break )
             {
             if ( *p1 == '|' )
                {
                /* the rest of the stuff, up to the field delimiter */
                /* is the sort portion of the string, so skip it */
                skip_till_break = TRUE;
                }
             else if ( *p1 == FIELD_DELIMITER )
                {
                *p2 = *p1;
                skip_till_break = FALSE;
                }
             else
                {
                /* a normal character */
                *p2 = *p1;
                p2--;
                }
             }
          p1--;
          }
       if ( p1 != p2 )
           Wstrcpy( str, p2 );/* move string down to get just visible portion */
       }
    return;
}
#endif   /*  }  BUILD_ORIENT  */

data_ptr AxfREV32(){return(ELF_CREATE_INTEGER(BTRUE));}


/** This is an interface to the tranlation routine which will handle */
/**  'complex' strings which may have embedded pipe symbols which seperate */
/**  a 'tag' from the real string                */
data_ptr AxfXLT_Complex(argDatum)
data_ptr argDatum;
{
    mbchar *str = (mbchar *)StrFromArgArray(argDatum,0);
    mbchar *trans_str;
 
    trans_str = XLT_Complex( str );
 
    return(ELF_CREATE_STRING( trans_str ));
}

/*************************************************************************
function: AxfRtReader - Convert a single list of messages to per-task lists
Message content also re-ordered from the "from gateway" to the "for SS" format
*/
data_ptr AxfRtReader (inData)
data_ptr inData;
{
    data_ptr iP, ssP;
    int tasks[MAX_PIDS];
    data_ptr taskData[MAX_PIDS];
    int sizes[MAX_PIDS];
    int numTasks = 0;
    data_ptr value, offsets, row, pair, allData, argDatum;
    int ix, jx, task;
    int cnt;

    argDatum = AxArrayElement(inData, 0);
    cnt = ElfbArraySize(argDatum);
    for ( ix = 0; ix < cnt; ix++ ) {
        iP = AX(argDatum)->vals[ix];
        value = AX(iP)->vals[0];
        task = GET_INTEGER(AX(iP)->vals[1]);
        row = AX(iP)->vals[2];
        offsets = AX(iP)->vals[3];
        ssP = MkArray(3);
        WriteArray(ssP,0,ElfDataCopy(row));
        WriteArray(ssP,1,ElfDataCopy(value));
        WriteArray(ssP,2,ElfDataCopy(offsets));
        for ( jx = 0; jx < numTasks; jx++ ) {
            if ( tasks[jx] == task )
                break;
        }
        if ( jx == numTasks ) {
            tasks[jx] = task;
            taskData[jx] = MkArray(1);
            sizes[jx] = 0;
            numTasks++;
        }
        taskData[jx] = WriteArray(taskData[jx],sizes[jx],ssP);
        sizes[jx]++;
    }
    allData = MkArray(numTasks);
    for ( ix = 0; ix < numTasks; ix++ ) {
        pair = MkArray(2);
        WriteArray(pair,0,MK_INTEGER(tasks[ix]));
        WriteArray(pair,1,taskData[ix]);
        allData = WriteArray(allData,ix,pair);
    }
    return(allData);
}

/*************************************************************************
function: ElfbListScreenfonts - return a list of available screenfonts
*/
int
ElfbListScreenfonts()
{
#if AXMS
    return (ElfbMSListScreenfonts());
#else
    return (ElfbXListScreenfonts());
#endif
}

/*************************************************************************
function: AxfNormalizeIn - Convert external document string into internal
format.
*/
data_ptr AxfNormalizeIn(strdata)
data_ptr strdata; /* encoded string */
{
    mbchar *instr, outstr[STRPATH];
    mbchar *AxStrPtrFromDataPtr();
    int len;

    instr = AxStrPtrFromDataPtr(strdata);

    /* internal form should be smaller, according to the understanding of
    this developer. However, allocate more than enough space, to be safe. */
    len = MBstrlen(instr) * 2;
    len = NormalizeIn(instr,outstr,len,(AFileInfo *)NULL);
    return(ELF_CREATE_STRING(outstr));
}

/*************************************************************************
function: AxfNormalizeOut - Convert internal string into encoded form.
*/
data_ptr AxfNormalizeOut(strdata)
data_ptr strdata; /* string */
{
    mbchar *instr, outstr[STRPATH];
    mbchar *AxStrPtrFromDataPtr();
    int len;

    instr = AxStrPtrFromDataPtr(strdata);

    /* encoded form may well be bigger. Allow 4 times string length. */
    len = MBstrlen(instr) * 4;
    len = NormalizeOut(instr,outstr,len,(AFileInfo *)NULL);
    return(ELF_CREATE_STRING(outstr));
}

/*************************************************************************
function: AxfNewFilePermissions - returns default group and world access for
new files (as 2-element array). For unix, gets umask. optional arg.
*/
data_ptr AxfNewFilePermissions(argDatum)
data_ptr argDatum;
{
    data_ptr filename = AnyFromArgArray(argDatum,0); /* name of existing file (optional) */
    return(AxFilePermissions(filename));
}


/*
*   AxfSSUtil() - get the information on the ss profile independent
*           of ss being up or not 
*       This function takes  in a code 
*   1->     Get Font Familes 
*   2->     Get Edit Typeface 
*   3->     get Font Sizes
*   4->     get the names of the ss addins library
*   5->     get the category names of the ss addins library
*/
extern char **axListFontFamilies();
int fontsizes[] = {6, 8, 10, 12, 14, 18, 24, 36} ;
data_ptr AxfSSUtil(argDatum)
data_ptr argDatum;
{
    int code = IntFromArgArray(argDatum,0);
    int numfamily, numfonts = 8 ;
    data_ptr retP, aP;
    char **fntfamily ;
    int ix;
    data_ptr ssXUtil();
	char *SSGetEditTypeFaceStr();
    
    switch(code) {
        case 1:     /** get Font Familes **/
            fntfamily = axListFontFamilies((char **)NULL, 0, &numfamily);
            retP = AxMakeArray(1);
            for( ix = 0; ix < numfamily; ++ix) {
                retP = AxAddStrToArray(retP, ix, fntfamily[ix]) ;
            }
            if (fntfamily) {
                for(ix = 0; ix < numfamily; ++ix) {
                    THIMfree((char *) fntfamily[ix]);
                }
                THIMfree((char *) fntfamily);
            }
            return(retP);
            break; 
        case 2: {    /** get edit type faces ***/
			char* SSEditTypeFaceStr = SSGetEditTypeFaceStr();
            if (SSEditTypeFaceStr[0] != '\0') {
                retP = AxMakeStrData(-1, SSEditTypeFaceStr) ;
            } else  {
                retP = AxMakeStrData(-1, axDefaultSansSerifFont); 
            }
            return(retP);
			break;
		}
        case 3:     /** get font sizes ***/
            /** for the time being we are going to hard code the font sizes
                later when needed we would create a dynamic list */
            retP = AxMakeArray(numfonts);
            for(ix =0; ix < numfonts ; ++ix) {
                AxAddIntToArray(retP, ix, fontsizes[ix]);
            }
            return(retP);
            break; 
        case 4:     /* get name of add in library */
            retP = AxMakeArray(3);
#if HP800V3
            aP = AxMakeArray(3);
            aP = AxAddStrToArray(aP, 0, NXLT("libssadd.sl"));
            aP = AxAddStrToArray(aP, 1, NXLT("libsstat.sl"));
            aP = AxAddStrToArray(aP, 2, NXLT("libssdte.sl"));
            aP = AxAddStrToArray(aP, 3, NXLT("libaxtm1.sl"));
            retP = AxAddArrayToArray(retP, 0, aP);
#else
#if RIOS
            aP = AxMakeArray(3);
            aP = AxAddStrToArray(aP, 0, NXLT("lib_ss_1"));
            aP = AxAddStrToArray(aP, 1, NXLT("lib_ss_2"));
            aP = AxAddStrToArray(aP, 2, NXLT("lib_ss_3"));
            aP = AxAddStrToArray(aP, 3, NXLT("libaxtm1"));
            retP = AxAddArrayToArray(retP, 0, aP);
#else
#if AXMS
            aP = AxMakeArray(3);
            aP = AxAddStrToArray(aP, 0, NXLT("libssadd.dll"));
            aP = AxAddStrToArray(aP, 1, NXLT("libsstat.dll"));
            aP = AxAddStrToArray(aP, 2, NXLT("libssdte.dll"));
            aP = AxAddStrToArray(aP, 3, NXLT("libaxtm1.dll"));
            retP = AxAddArrayToArray(retP, 0, aP);
#else
#if PMAX
            aP = AxMakeArray(3);
            aP = AxAddStrToArray(aP, 0, NXLT("rpcssadd"));
            aP = AxAddStrToArray(aP, 1, NXLT("rpcsstat"));
            aP = AxAddStrToArray(aP, 2, NXLT("rpcssdte"));
            aP = AxAddStrToArray(aP, 3, NXLT("rpcsstm1"));
            retP = AxAddArrayToArray(retP, 0, aP);
            retP = AxAddIntToArray(retP, 0, -1);    /* rpcs */
#else
            aP = AxMakeArray(3);
            aP = AxAddStrToArray(aP, 0, NXLT("libssadd.so"));
            aP = AxAddStrToArray(aP, 1, NXLT("libsstat.so"));
            aP = AxAddStrToArray(aP, 2, NXLT("libssdte.so"));   
            aP = AxAddStrToArray(aP, 3, NXLT("libaxtm1.so"));   
            retP = AxAddArrayToArray(retP, 0, aP);
#endif
#endif
#endif
#endif
            return(retP);
            break; 
        case 5:     /** get the category names of the addin library **/
            /* should match the order in which the library 
                                                 names are returned **/
            retP = AxMakeArray(2);
            retP = AxAddStrToArray(retP, 0, NXLT("General"));
            retP = AxAddStrToArray(retP, 1, NXLT("Statistical"));
            return(retP);
            break; 
        case 6:     /* SSX UTIL FUNCTIONS */
            retP = ssXUtil(AxArrayElement(argDatum, 1));    
            return(retP);
            break;
        case 7:     /* SSX UTIL FUNCTIONS */
            retP = (data_ptr)SSElfExtDocInfo(NULL, AxArrayElement(argDatum, 1));    
            return(retP);
            break;
        default :
            /** error **/
            break;
    }

    return(NullDataPtr);
}


/*
*   AxfUnRegisterFunction - unregister a function by removing it from
*       the register.dat file and from the spreadsheets function hash
*/
data_ptr AxfSSRegisterFunction(aP)
    data_ptr aP;
{
    mbchar *category, *engname;
    mbchar *alias;
    mbchar *argInfo;
    int     cmdCode;

    cmdCode = AxIntFromArray(aP, 0);
    switch(cmdCode) {
        case 1: /* register the function */
            category = AxStrPtrFromArray(aP, 1);
            alias = AxStrPtrFromArray(aP, 2);
            argInfo = AxStrPtrFromArray(aP, 3);
            engname = AxStrPtrFromArray(aP, 4);
            if ((engname == NULL) || (engname[0]==NULL))
                engname = alias ;
            SSNoteUserFunc(category, alias, engname, argInfo, 1);
            break;
        case 0: /* unregister the function */
            alias = AxStrPtrFromArray(aP, 1);
            SSRemoveUserFunc(alias);
            break;
        default:
            break;
    }
    return(NullDataPtr);
}



/*************************************************************************
function: AxfLockFile- apply an advisory file lock to the passed file
*/

data_ptr AxfLockFile(argDatum)
data_ptr argDatum;
{
    register char *filename = StrFromArgArray(argDatum,0);
    int err, read_only, pos;
    register int ix;
    FILE *fp;

    /* try to get a read/write lock */
    for (ix=0; ix<MAX_FILES; ix++)
    {
        if (OpenFiles[ix] && streq(OpenFiles[ix], filename))
        {
            /* noop if already locked for read/write */
            if ( OpenReadOnly[ix] )
            {
                /* open file read/write and lock it */
                read_only = FALSE;
                err = AFTaskLockFile(filename, 0, &read_only, FALSE);
                if ( err != AOK )
                    ElfStrAbort(err, NULL, filename);
                fp = (FILE *)AFTaskfopen(0, filename, READ_TRUNC_STR); /* r+ */
                if ( !fp )
                {
                    AFTaskUnlockFile(filename, 0, read_only);
                    ElfStrAbort(ErrnoErr(), NULL, filename);
                }

                /* convert read lock to read/write lock */
                pos = ftell(OpenFps[ix]);
                AFfclose(filename, OpenReadOnly[ix], OpenFps[ix]);
                AFTaskUnlockFile(filename, 0, OpenReadOnly[ix]);
                OpenReadOnly[ix] = FALSE;
                OpenFps[ix] = fp;
                fseek(fp, pos, 0);
            }
            return(NullDataPtr);
        }
    }
    ElfAbort(ERR_FILENOPEN);
}

/*************************************************************************
function: AxfUnlockFile- apply an advisory file unlock to the passed file
*/

data_ptr AxfUnlockFile(argDatum)
data_ptr argDatum;
{
    register char *filename = StrFromArgArray(argDatum,0);
    int err, read_only, pos;
    register int ix;
    FILE *fp;

    /* convert the read/write lock to a read lock */
    for (ix=0; ix<MAX_FILES; ix++)
    {
        if (OpenFiles[ix] && streq(OpenFiles[ix], filename))
        {
            /* noop if already locked for read only */
            if ( OpenReadOnly[ix] == FALSE )
            {
                /* open file read/write and lock it */
                read_only = TRUE;
                err = AFTaskLockFile(filename, 0, &read_only, FALSE);
                if ( err != AOK )
                    ElfStrAbort(err, NULL, filename);
                fp = (FILE *)AFTaskfopen(0, filename, READ_BINARY_STR); /* r */
                if ( !fp )
                {
                    AFTaskUnlockFile(filename, 0, read_only);
                    ElfStrAbort(ErrnoErr(), NULL, filename);
                }

                /* convert read/write lock to read lock */
                pos = ftell(OpenFps[ix]);
                AFfclose(filename, OpenReadOnly[ix], OpenFps[ix]);
                AFTaskUnlockFile(filename, 0, OpenReadOnly[ix]);
                OpenReadOnly[ix] = TRUE;
                OpenFps[ix] = fp;
                fseek(fp, pos, 0);
            }
            return(NullDataPtr);
        }
    }
    ElfAbort(ERR_FILENOPEN);
}

/*************************************************************************
function: AxfAbs - Absolute value
*/
data_ptr AxfAbs (argDatum)
data_ptr argDatum;
{
    double          n = DblFromArgArray(argDatum,0);
    return(ELF_CREATE_NUMBER(fabs(n)));
}

/*************************************************************************
function: AxfCos - Cosine
*/
data_ptr AxfCos (argDatum)
data_ptr argDatum;
{
    double          n = DblFromArgArray(argDatum,0);
    return(ELF_CREATE_NUMBER(cos(n)));
}

/*************************************************************************
function: AxfSin - Trignometric sine
*/
data_ptr AxfSin (argDatum)
data_ptr argDatum;
{
    double          n = DblFromArgArray(argDatum,0);
    return(ELF_CREATE_NUMBER(sin(n)));
}


double ElfbI2IN(n)      /* TEMP FOR SS COMPATIBLE... MOVE INTO UIMAIN */
double          n;
{
    if (AxMetric)
        return (n / 2.54);
    else
        return (n);
}

/***************************************************************************
function: AxfFilterWpToAsciiLayout 
*/
data_ptr AxfFilterWpToAsciiLayout (argDatum)
data_ptr argDatum;
{
    int uid;
    mbchar infile[STRPATH+1];
    mbchar outfile[STRPATH+1];
    mbchar opts[2*STRPATH+25];  /* enough? */

    MBstrcpy(infile, StrFromArray(argDatum, 0));
    MBstrcpy(outfile, StrFromArray(argDatum, 1));

    sprintf(opts, "-v%s -A%s", infile, outfile);
	sprintf(opts, "-v \"%s\" -A \"%s\"", infile, outfile);
    uid = ElfbProc(APDC, opts);

    return((data_ptr)NULL);
}

/***************************************************************************
function: AxfAppIsSS()
*/
data_ptr AxfAppIsSS()
{
    int pid;
    int ret;

    pid = ThimPidFromUID(TaskInfo[THIMpid].taskMaster); 
    ret = (TaskInfo[pid].appid == APSS) ? BTRUE : FALSE;
    return(ELF_CREATE_NUMBER((double)ret));
}




/***************************************************************************
function: AxfAppIsData()

return array where 
   [0] == true if parent task is data, false otherwise
   [1] == macro_parent_task@ if parent task is data, null otherwise
   [2] == elf_task_id@ if parent task is data, null otherwise

*/
data_ptr AxfAppIsData()
{
    register int pid;
    data_ptr ret;

    /* get macro_parent_task@ */
    pid = ThimPidFromUID(TaskInfo[THIMpid].taskMaster); 

    /* don't get suckered into reading from a null pointer */
    if(  TaskInfo[pid].argv == 0 || TaskInfo[pid].argv[0] == 0 )
        goto return_false;

    /* if parent macro name is data_ or dbase_open_from_wp@ then
       this is indeed the data dipper */
    if((strcasecmp(NXLT("DATA_"),TaskInfo[pid].argv[0]) == 0)
    ||(strcasecmp(NXLT("DBASE_OPEN_FROM_WP@"),TaskInfo[pid].argv[0]) == 0)
    ||(strcasecmp(NXLT("DBASE_OPEN_FROM_ARCADE$"),TaskInfo[pid].argv[0])==0)
    ||(strcasecmp(NXLT("DBASE_OPEN_FROM_WP$"),TaskInfo[pid].argv[0]) == 0)
    ){
        ret = AxMakeArray(3);
        AxAddIntToArray(ret, 0, BTRUE);
        AxAddIntToArray(ret, 1, TaskInfo[THIMpid].taskMaster);
        AxAddIntToArray(ret, 2, TaskInfo[AxInTask].uid);
        return(ret);
    } 

return_false:
    ret = AxMakeArray(1);
    AxAddIntToArray(ret, 0, FALSE);
    return(ret);

}




#if AXMS   /*  {  */
  /** This function is used to globally clip certain items from the menu */
  /** bars which are not applicable to Windows/NT.  This is done in code */
  /** since we do not have a good way to conditionalize the menu-bars    */
  /** themselves. - jon                                                  */
 
void CheckForClipFromMenuBar( mP )
menu_item_def *mP;
{
	char *mapi=UPbyName(NXLT("amMapiClient"));
	int is_mapi=(mapi && streq(mapi, "-1"));

    if ( mP->word2 != (char *)NULL )
       {
       if ( ((stricmp( mP->word2, "INBOX_DLG@" ) == 0) && is_mapi) ||
            (stricmp( mP->word2, "WP_CHANGE_BARS_DLG@") == 0) ||
            (stricmp( mP->word2, "X_PREFS_DLG@") == 0) ||
            (stricmp( mP->word2, "axFax") == 0) ||
            (stricmp( mP->word2, "triarch_clpbdpst@") == 0) ||  /* Reuters ATW cut/paste*/
            (stricmp( mP->word2, "WP_CHANGE_BARS_REMOVE@") == 0) ||
            (stricmp( mP->word2, "AX_FONT_INSTALLER@") == 0) )
          {
          mP->noshow = TRUE;
          mP->toolshow = FALSE;
          return;
          }
        /* remove Data from the Win95 menu bar. */
        if ( Running_Windows95 )
          { if ((stricmp(mP->word2, "LICENSE@") == 0) ||
                (stricmp(mP->word2, "DATABASE_DLG@") == 0) ||
                (stricmp(mP->word2, "CHOOSE_LICENSE@") == 0) ||
                (stricmp(mP->word2, "WP_LINK_QUERY_DLG@") == 0) ||
                (stricmp(mP->word2, "WP_NEW_QUERY@") == 0) ||
                (stricmp(mP->word2, "SS_INSERT_DBASE_DLG@") == 0) ||
                (stricmp(mP->word2, "SS_INSERT_NEW_DBASE_DLG@") == 0) ||
                (stricmp(mP->word2, "GR_INSET_DBASE_DLG@") == 0) ||
                (stricmp(mP->word2, "GR_CREATE_DBASE_OBJECT@") == 0) )
               {
               mP->noshow = TRUE;
               mP->toolshow = FALSE;
               return;
               }
            }
       }
    return;
}



void MakePathWithLongNames( char *doc_path )
{
    char work_path[MAX_PATH+1];
    char base_path[MAX_PATH+1];
    char *p;
    int ret, len;
    HANDLE fh;
    WIN32_FIND_DATA find_data;

    /* Microsoft supplies a function "GetShortPathName" to get the short     */
    /* filename version of a path, but no corresponding function to expand   */
    /* things to long names, so here is a recursive function to do just that */
    /* Note:  This is necessary since, contrary to Microsoft doc, the file   */
    /*  manager seems to insist on passing short names when a user double    */
    /*  clicks on an Applixware doc.                                         */
    len = strlen( doc_path );
    if ( (len < 2) || ((len <= 3) && (*(doc_path+1) == ':'))) 
       return;

    strcpy( work_path, doc_path );

    /* get the real name of the last filename in the path */
    fh = FindFirstFile( work_path, &find_data );
    if ( fh == INVALID_HANDLE_VALUE )
        {
        ret = GetLastError();
        return;
        }
    else
        FindClose( fh );

    /* clip off the last part of the path, and expand the rest */
    p = work_path + strlen(work_path) - 1;
    while ( (p > work_path) && (*p != '\\') && (*p != '/') )
        { p--; }    /* pointer to the last part of name */

    *p = '\0';    /* clip off the last component of path */
    strcpy( base_path, work_path );
    MakePathWithLongNames( base_path );   /* rescusive call */

    /* return result */
    if ( strlen(base_path) > 0 )
       sprintf( doc_path, "%s\\%s", base_path, find_data.cFileName );  
    else
       strcpy( doc_path, find_data.cFileName );

    return;
}


#endif   /*  }  AXMS  */


/* The following code for AxfFormat lifted shamelessly from
   iovfprintf.c of GNU libc library  -Babu 28-jun-95. ;<
*/

#define BUF     40
#define RESULT_BUF 10000
#define DEFPREC 6

/*
 * Macros for converting digits to letters and vice versa
 */
#define to_digit(c) ((c) - '0')
#define is_digit(c) ((unsigned)to_digit(c) <= 9)
#define to_char(n)  ((n) + '0')

/*
 * Flags used during conversion.
 */
#define LONGINT         0x01        /* long integer */
#define LONGDBL         0x02        /* long double; unimplemented */
#define SHORTINT        0x04        /* short integer */
#define ALT             0x08        /* alternate form */
#define LADJUST         0x10        /* left adjustment */
#define ZEROPAD         0x20        /* zero (as opposed to blank) pad */
#define HEXPREFIX       0x40        /* add 0x or 0X prefix */

static char *
__cvt_double_(number, fmt, width, prec, flags, sign)
double number;  
int fmt;
int width, prec;
int flags;
int sign;
{
    static char buf[200];		/* Must hold all digits of 10e150 at least! */
    char fmt_str[40];
    char sign_s[] = " ",
         align_s[] = " ",
         alt_s[] = " ",
         fill_s[] = " ";
    
    sign_s[0] = sign;
    align_s[0] = (flags & LADJUST) ? '-' : 0;
    alt_s[0] = (flags & ALT) ? '#': 0;
    fill_s[0] = (flags & ZEROPAD) ? '0': 0;
        
    sprintf(fmt_str, "%%%s%s%s%s%d.%d%c", sign_s, align_s, fill_s, alt_s, width, prec, fmt);
    sprintf(buf, fmt_str, number);
    return(buf);
}

data_ptr
AxfFormat (argP)
data_ptr argP;
{
    register char *fmt;         /* format string */
    register int ch;            /* character from fmt */
    register int n;             /* handy integer (short term usage) */
    register char *cp;          /* handy char pointer (short term usage) */
    char *fmark;                /* for remembering a place in fmt */
    register int flags;         /* flags as above */
    int width;                  /* width from format (%8d), or 0 */
    int prec;                   /* precision from format (%.3d), or -1 */
    char sign;                  /* sign prefix (' ', '+', '-', or \0) */
    double _double;             /* double precision arguments %[eEfgG] */
    unsigned long _ulong;       /* integer arguments %[diouxX] */
    enum { OCT, DEC, HEX } base;/* base for [diouxX] conversion */
    int dprec;                  /* a copy of prec if [diouxX], 0 otherwise */
    int dpad;                   /* extra 0 padding needed for integers */
    int fieldsz;                /* field size expanded by sign, dpad etc */
    /* The initialization of 'size' is to suppress a warning that
       'size' might be used unitialized.  It seems gcc can't
       quite grok this spaghetti code ... */
    int size = 0;               /* size of converted field or string */
    char buf[BUF];              /* space for %c, %[diouxX], %[eEfgG] */
    char ox[2];                 /* space for 0x hex-prefix */
    int rdex;                   /* next char in fmtResult */
    int argDex;                 /* next argument */
    int argn=-1;                /* print nth argument */
    data_ptr retval;
    static char *fmtResult = NULL; /* Reallocated as needed */
    static int fmtBufSize;  /* current size of fmtResult */

#define MAKEROOM(len) if (rdex+len >= fmtBufSize) fmtResult = (char*)TaskRealloc(0,fmtResult,fmtBufSize=(fmtBufSize+len)*2)

#define PRINT(s,n) do {MAKEROOM(n); strncpy(fmtResult+rdex,s,n); rdex += n;} while(0)
#define PAD_C(c,n) do {int l=n; MAKEROOM(l); while (--l >= 0) fmtResult[rdex++] = c;} while(0)

#define STR_ARG() ((argn > 0) ? AxStrFromArray(argP, argn) :AxStrFromArray(argP, argDex++))
#define INT_ARG() ((argn > 0) ? AxIntFromArray(argP, argn) :AxIntFromArray(argP, argDex++))
#define DBL_ARG() ((argn > 0) ? AxDblFromArray(argP, argn) :AxDblFromArray(argP, argDex++))

    argDex = 0;
    rdex = 0;
    fmt = STR_ARG();    /* format string */
    if ( fmtResult )    /* release buffer left over from prior run */
        TaskFree(0,fmtResult);
    fmtResult = (char*)TaskAlloc(0,fmtBufSize=1000);
    fmtResult[0] = 0;

    /*
     * Scan the format for conversions (`%' character).
     */
    for (;;) {
        for (fmark = fmt; (ch = *fmt) != '\0' && ch != '%'; fmt++)
            /* void */;
        if ((n = fmt - fmark) != 0)
            PRINT(fmark, n);
        if (ch == '\0')
            goto done;
        fmt++;      /* skip over '%' */

        argn = -1;
        flags = 0;
        dprec = 0;
        width = 0;
        prec = -1;
        sign = '\0';

rflag:
        ch = *fmt++;
reswitch:
        switch (ch) {
        case ' ':
            /*
             * ``If the space and + flags both appear, the space
             * flag will be ignored.''
             *  -- ANSI X3J11
             */
            if (!sign)
                sign = ' ';
            goto rflag;
        case '#':
            flags |= ALT;
            goto rflag;
        case '*':
            /*
             * ``A negative field width argument is taken as a
             * - flag followed by a positive field width.''
             *  -- ANSI X3J11
             * They don't exclude field widths read from args.
             */
            if ((width = INT_ARG()) >= 0)
                goto rflag;
            width = -width;
            /* FALLTHROUGH */
        case '-':
            flags |= LADJUST;
            flags &= ~ZEROPAD; /* '-' disables '0' */
            goto rflag;
        case '+':
            sign = '+';
            goto rflag;
        case '.':
            if ((ch = *fmt++) == '*') {
                n = INT_ARG();
                prec = n < 0 ? -1 : n;
                goto rflag;
            }
            n = 0;
            while (is_digit(ch)) {
                n = 10 * n + to_digit(ch);
                ch = *fmt++;
            }
            prec = n < 0 ? -1 : n;
            goto reswitch;
        case '0':
            /*
             * ``Note that 0 is taken as a flag, not as the
             * beginning of a field width.''
             *  -- ANSI X3J11
             */
            if (!(flags & LADJUST))
                flags |= ZEROPAD; /* '-' disables '0' */
            goto rflag;
        case '1': case '2': case '3': case '4':
        case '5': case '6': case '7': case '8': case '9':
            n = 0;
            do {
                n = 10 * n + to_digit(ch);
                ch = *fmt++;
            } while (is_digit(ch));
            width = n;
            goto reswitch;
        case '$':
            argn = width;
            width = 0;
            goto rflag;
        case 'L':
            flags |= LONGDBL;
            goto rflag;
        case 'h':
            flags |= SHORTINT;
            goto rflag;
        case 'l':
            flags |= LONGINT;
            goto rflag;
        case 'c':
            *(cp = buf) = INT_ARG();
            size = 1;
            sign = '\0';
            break;
        case 'D':
            flags |= LONGINT;
            /*FALLTHROUGH*/
        case 'd':
        case 'i':
            _ulong = INT_ARG();
            if ((long)_ulong < 0) {
                _ulong = -_ulong;
                sign = '-';
            }
            base = DEC;
            goto number;
        case 'e':
        case 'E':
        case 'f':
        case 'F':
        case 'g':
        case 'G': {
            char *dbl_s;
            
            _double = DBL_ARG();
            dbl_s = __cvt_double_(_double, ch, width,
                                  prec < 0 ? DEFPREC : prec,
                                  flags,sign);
            PRINT(dbl_s,strlen(dbl_s));
            /* CHECK ERROR! */
            continue;
        }
        case 'O':
            flags |= LONGINT;
            /*FALLTHROUGH*/
        case 'o':
            _ulong = INT_ARG();
            base = OCT;
            goto nosign;
        case 'p':
            /*
             * ``The argument shall be a pointer to void.  The
             * value of the pointer is converted to a sequence
             * of printable characters, in an implementation-
             * defined manner.''
             *  -- ANSI X3J11
             */
            /* NOSTRICT */
            _ulong = INT_ARG();
            base = HEX;
            flags |= HEXPREFIX;
            ch = 'x';
            goto nosign;
        case 's':
            if ((cp = STR_ARG()) == NULL)
                cp = "(null)";
            if (prec >= 0) {
                /*
                 * can't use strlen; can only look for the
                 * NUL in the first `prec' characters, and
                 * strlen() will go further.
                 */
                char *p = (char*)memchr(cp, 0, prec);

                if (p != NULL) {
                    size = p - cp;
                    if (size > prec)
                        size = prec;
                } else
                    size = prec;
            } else
                size = strlen(cp);
            sign = '\0';
            break;
        case 'U':
            flags |= LONGINT;
            /*FALLTHROUGH*/
        case 'u':
            _ulong = INT_ARG();
            base = DEC;
            goto nosign;
        case 'X':
        case 'x':
            _ulong = INT_ARG();
            base = HEX;
            /* leading 0x/X only if non-zero */
            if (flags & ALT && _ulong != 0)
                flags |= HEXPREFIX;

            /* unsigned conversions */
nosign:         sign = '\0';
            /*
             * ``... diouXx conversions ... if a precision is
             * specified, the 0 flag will be ignored.''
             *  -- ANSI X3J11
             */
number:         if ((dprec = prec) >= 0)
                flags &= ~ZEROPAD;

            /*
             * ``The result of converting a zero value with an
             * explicit precision of zero is no characters.''
             *  -- ANSI X3J11
             */
            cp = buf + BUF;
            if (_ulong != 0 || prec != 0) {
                    char *xdigs; /* digits for [xX] conversion */
                /*
                 * unsigned mod is hard, and unsigned mod
                 * by a constant is easier than that by
                 * a variable; hence this switch.
                 */
                switch (base) {
                case OCT:
                    do {
                        *--cp = to_char(_ulong & 7);
                        _ulong >>= 3;
                    } while (_ulong);
                    /* handle octal leading 0 */
                    if (flags & ALT && *cp != '0')
                        *--cp = '0';
                    break;

                case DEC:
                    /* many numbers are 1 digit */
                    while (_ulong >= 10) {
                        *--cp = to_char(_ulong % 10);
                        _ulong /= 10;
                    }
                    *--cp = to_char(_ulong);
                    break;

                case HEX:
                    if (ch == 'X')
                        xdigs = "0123456789ABCDEF";
                    else /* ch == 'x' || ch == 'p' */
                        xdigs = "0123456789abcdef";
                    do {
                        *--cp = xdigs[_ulong & 15];
                        _ulong >>= 4;
                    } while (_ulong);
                    break;

                default:
                    cp = "bug in AxfFormat: bad base";
                    goto skipsize;
                }
            }
            size = buf + BUF - cp;
        skipsize:
            break;
        default:    /* "%?" prints ?, unless ? is NUL */
            if (ch == '\0')
                goto done;
            /* pretend it was %c with argument ch */
            cp = buf;
            *cp = ch;
            size = 1;
            sign = '\0';
            break;
        }

        /*
         * All int/str formats wind up here.  At this point,
         * `cp' points to a string which (if not flags&LADJUST)
         * should be padded out to `width' places.  If
         * flags&ZEROPAD, it should first be prefixed by any
         * sign or other prefix; otherwise, it should be blank
         * padded before the prefix is emitted.  After any
         * left-hand padding and prefixing, emit zeroes
         * required by a decimal [diouxX] precision, then print
         * the string proper, then emit zeroes required by any
         * leftover floating precision; finally, if LADJUST,
         * pad with blanks.
         */

        /*
         * compute actual size, so we know how much to pad.
         */
        fieldsz = size;
        dpad = dprec - size;

        if (dpad < 0)
            dpad = 0;

        if (sign)
            fieldsz++;
        else if (flags & HEXPREFIX)
            fieldsz += 2;
        fieldsz += dpad;

        /* right-adjusting blank padding */
        if ((flags & (LADJUST|ZEROPAD)) == 0)
            PAD_C(' ', (width - fieldsz));

        /* prefix */
        if (sign)
            PRINT(&sign, 1);
        else if (flags & HEXPREFIX) {
            ox[0] = '0';
            ox[1] = ch;
            PRINT(ox, 2);
        }

        /* right-adjusting zero padding */
        if ((flags & (LADJUST|ZEROPAD)) == ZEROPAD)
            PAD_C('0', (width - fieldsz));

        /* leading zeroes from decimal precision */
        PAD_C('0', dpad);

        /* the string or number proper */
        PRINT(cp, size);

        /* left-adjusting padding (always blank) */
        if (flags & LADJUST)
            PAD_C(' ', (width - fieldsz));
    }
done:
    retval = AxMakeStrData(rdex, fmtResult);
    TaskFree(0,fmtResult);
    fmtResult = NULL;
    return(retval);
}

/*************************************************************************
function: AxfStringToBinary - convert ELF string to ELF binary
*/
data_ptr AxfStringToBinary (argDatum)
data_ptr argDatum;
{
    data_ptr dptr = AnyFromArgArray(argDatum,0); /* ELF  */
    mbchar *strP;
    int size;
    data_ptr retval;

    if (!AxIsString(dptr)) /* must be an ELF string */
        ElfStrAbort(ERR_ILLVAL,NULL,NULL);
    strP = AxStrPtrFromDataPtr(dptr);
    size = MBstrlen(strP); /* size in bytes */
    /* null terminator is stripped here */
    retval = AxMakeBinaryData(size, strP);
    return(retval);
}

/*************************************************************************
function: AxfBinaryToString - convert ELF binary to ELF string
*/
data_ptr AxfBinaryToString (argDatum)
data_ptr argDatum;
{
    data_ptr dptr = AnyFromArgArray(argDatum,0); /* ELF  */
    char *binP;
    int size;
    data_ptr retval;

    if (!AxIsBinary(dptr)) /* must be an ELF string */
        ElfStrAbort(ERR_ILLVAL,NULL,NULL);
    size = AxBinaryFromDataPtr(dptr, &binP);

    /* null terminator gets added here */
    retval = AxMakeStrData(size, (mbchar *)binP);
    return(retval);
}

/*************************************************************************
function: AxfReadGlomBitmap - read a bitmap from glom file and save it 
*/
data_ptr
AxfReadGlomBitmap(argDatum)
data_ptr argDatum;
{
    char           *name = StrFromArgArray(argDatum,0);
    char           *path = StrFromArgArray(argDatum,1);
    int err;

    err = ElfbReadGlomBitmap(name, path);
    if ( err != AOK )
        return(ELF_CREATE_INTEGER(BFALSE));
    else
        return(ELF_CREATE_INTEGER(BTRUE));
}

/*************************************************************************
function: AxfFontUtils - various font-related utilites
*/
data_ptr AxfFontUtils (argDatum)
data_ptr argDatum;
{
    int opcode;
    char *galliumDir = (char *) NULL;
    data_ptr retval = (data_ptr) NULL;
    
    opcode = AxIntFromArray(argDatum, 0);
    
    switch (opcode) {
        
    case 1:
#if AX_X11
        /* start up gallium font installer program
         */
        galliumDir = getenv("AXGFSDIR");  /* env var set by axmain */
        if (galliumDir) {
            char *err;
            err = axgfsStartFontManager(galliumDir);
            if (err) {
                if (!retval) {
                    retval = AxMakeArray(0);
                }
                retval = AxAddStrToArray(retval, 0, err);
                freeErrString(err);
            }
        }
#endif
        break;
        
    }
    
    return (retval);
}



/*******************************************************************
 * ELFC FUNCTIONS FOR JAPANESE
 *******************************************************************/

/*************************************************************************
function: AxfByteLen - strlen, used in ELF macro as byte_len@().
*/
data_ptr AxfByteLen(argDatum)
data_ptr argDatum;
{
    char *s = StrFromArgArray(argDatum,0);
    return(ELF_CREATE_INTEGER(strlen(s)));
}



data_ptr AxfNoOp( argDatum )
data_ptr argDatum;
{
    /* a "do nothing" function, used as a stub for western builds, which */
    /* do not need to call the Japanese functions below                  */
    return( argDatum );
}



/*************************************************************************
function: AxfStrClip - get sub-string in bytes, take care of multi-byte chars.
*/
data_ptr AxfStrClip(argDatum)
data_ptr argDatum;
{
    register mbchar *str = (mbchar *)StrFromArgArray(argDatum,0);
    register int    start = IntFromArgArray(argDatum,1);
    data_ptr        lenP = AnyFromArgArray(argDatum,2);
    register int    string_len;
    register data_ptr axdRetVal;
    register mbchar *startP, *endP;
    int             clip_len;

    VERIFY(start > 0, ERR_ILLVAL);
    start--;        /* one relative from caller to zero relative */
    string_len = strlen(str);
    start = MIN(start, string_len);
    startP = str;
    while (startP < str + start) {
        if (IS_MULTI_BYTE(startP))
            startP += 2;
        else
            startP++;
    }
    start = startP - str;

    if ( lenP ) {
        clip_len = IntFromDataPtr(lenP);
        VERIFY(clip_len >= 0, ERR_ILLVAL);
        if (start + clip_len > string_len)
            clip_len = string_len - start;
    }
    else
        clip_len = string_len - start;

    endP = startP;
    while (endP < startP + clip_len) {
        if (IS_MULTI_BYTE(startP) && endP+2 <= startP+clip_len)
            endP += 2;
        else
            endP++;
    }
    clip_len = endP - startP;

    axdRetVal = AxTaskCreateSizedElfString(THIMpid, clip_len, "");
    memcpy(SX(axdRetVal)->text, startP, clip_len);
    SX(axdRetVal)->text[clip_len] = 0;
    return(axdRetVal);
}


#if BUILD_KANJI       /*  {  */

/************************************************************************
/*  Japanese code conversion functions among EUC, Shift-JIS(SJIS), JIS
/*  For strings or arrays.
/************************************************************************

/*************************************************************************
function: Axfeuc2sjis - Japanese code conversion: EUC => Shift-JIS.
*/
data_ptr Axfeuc2sjis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        newstr = (mbchar *)get_static_buffer(strlen(string)+1);
        MBstrcpy(newstr, string);
        MBeuc2sjis_str(newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (mbchar *)AxStrFromDataPtr(p);
                newstr = (mbchar *)get_static_buffer(strlen(string)+1);
                MBstrcpy(newstr, string);
                MBeuc2sjis_str(newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfeuc2sjis(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfsjis2euc - Japanese code conversion: SJIS => EUC.
*/
data_ptr Axfsjis2euc(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        newstr = (mbchar *)get_static_buffer(2*strlen(string)+1);
        MBstrcpy(newstr, string);
        MBsjis2euc_str(newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (mbchar *)AxStrFromDataPtr(p);
                newstr = (mbchar *)get_static_buffer(2*strlen(string)+1);
                MBstrcpy(newstr, string);
                MBsjis2euc_str(newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfsjis2euc(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfeuc2jis - Japanese code conversion: EUC => JIS.
*/
data_ptr Axfeuc2jis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        newstr = (mbchar *)get_static_buffer(4*strlen(string)+1);
        MBeuc2jis_str(string, newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (mbchar *)AxStrFromDataPtr(p);
                newstr = (mbchar *)get_static_buffer(4*strlen(string)+1);
                MBeuc2jis_str(string, newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfeuc2jis(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfjis2euc - Japanese code conversion: JIS => EUC.
*/
data_ptr Axfjis2euc(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        newstr = (mbchar *)get_static_buffer(2*strlen(string)+1);
        MBjis2euc_str(string, newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (mbchar *)AxStrFromDataPtr(p);
                newstr = (mbchar *)get_static_buffer(2*strlen(string)+1);
                MBjis2euc_str(string, newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfjis2euc(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfsjis2jis - Japanese code conversion: Shift-JIS => JIS.
*/
data_ptr Axfsjis2jis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        newstr = (mbchar *)get_static_buffer(4*strlen(string)+1);
        MBsjis2jis_str(string, newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (mbchar *)AxStrFromDataPtr(p);
                newstr = (mbchar *)get_static_buffer(4*strlen(string)+1);
                MBsjis2jis_str(string, newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfsjis2jis(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfjis2sjis - Japanese code conversion: JIS => Shift-JIS.
*/
data_ptr Axfjis2sjis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        newstr = (mbchar *)get_static_buffer(2*strlen(string)+1);
        MBjis2sjis_str(string, newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (mbchar *)AxStrFromDataPtr(p);
                newstr = (mbchar *)get_static_buffer(2*strlen(string)+1);
                MBjis2sjis_str(string, newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfjis2sjis(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfjis2mime - Japanese code conversion: JIS => MIME.
*/
data_ptr Axfjis2mime(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register char   *string, *newstr;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (char *)AxStrPtrFromDataPtr(element);
        newstr = (char *)get_static_buffer((strlen(string)+2)*4/3+1);
        MBjis2mime(string, newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(arrsize);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (char *)AxStrFromDataPtr(p);
                newstr = (char *)get_static_buffer((strlen(string)+2)*4/3+1);
                MBjis2mime(string, newstr);
                retDatum = AxAddStrToArray(retDatum, ix, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, ix, Axfjis2mime(p));
            else
                retDatum = AxWriteArray(retDatum, ix, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfmime2jis - Japanese code conversion: MIME => JIS.
*/
data_ptr Axfmime2jis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix, jx, kx, nx;
    register int    arrsize;
    register char   *string, *newstr, *nextstr, *newstrP;
    register int    length;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (char *)AxStrPtrFromDataPtr(element);
        newstr = (char *)get_static_buffer(strlen(string)+1);
        MBmime2jis(string, newstr);
        retDatum = AxMakeStrData(-1, newstr);
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        retDatum = AxMakeArray(0);
        for (ix = 0, jx = 0; ix < arrsize; ix++, jx++) {
            p = AxArrayElement(element, ix);
            if (AxIsString(p)) {
                string = (char *)AxStrFromDataPtr(p);
                length = strlen(string);
                /* peek next lines if to adjoin it to last line */
                nx = ix;
                for (kx = ix + 1; kx < arrsize; kx++) {
                    if (AxIsString(AxArrayElement(element, kx))) {
                        nextstr = (char *)AxStrFromArray(element, kx);
                        if (is_wraped_mime(nextstr)) {
                            length += strlen(nextstr);
                            nx = kx;
                        } else
                            break;
                    } else
                        break;
                }
                newstr = (char *)get_static_buffer(length+1);
                MBmime2jis(string, newstr);
                newstrP = newstr + strlen(newstr);
                while (ix < nx) {
                    ix++;
                    nextstr = AxStrFromArray(element, ix);
                    MBmime2jis(nextstr, newstrP);
                    newstrP += strlen(newstrP);
                }
                retDatum = AxAddStrToArray(retDatum, jx, newstr);
            } else if (ElfbIsArray(p))
                retDatum = AxWriteArray(retDatum, jx, Axfmime2jis(p));
            else
                retDatum = AxWriteArray(retDatum, jx, AxCopyData(p));
        }
    } else
        retDatum = AxCopyData(element);

    return(retDatum);
}

/*************************************************************************
function: Axfascissjis - Japanese local encoding judgement.
return value - if is sjis, then True, else if EUC, then False
ELF form: ASCII_IS_SJIS@, ASCISSJIS; c form: ascii_is_shift_jis().
*/
data_ptr Axfascissjis()
{
    if (ascii_is_shift_jis())
        return (ELF_CREATE_INTEGER(-1));
    else
        return (ELF_CREATE_INTEGER(0));
}

/*************************************************************************
function: Axfispureascii - Japanese arry/string data encoding judgement.
return value - if it is pure ascii codes, then True, else False.
ELF form: IS_PURE_ASCII@, ISPUREASCII; c correspondence: is_pure_ascii_str().
*/
data_ptr Axfispureascii(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register int    ix;
    register int    arrsize;
    register mbchar *string;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        if (is_pure_ascii_str(string))
            return (ELF_CREATE_INTEGER(-1));
        else
            return (ELF_CREATE_INTEGER(0));
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (ElfbIsString(p)) {
        		string = (mbchar *)AxStrPtrFromDataPtr(p);
				if (!is_pure_ascii_str(string))
            		return (ELF_CREATE_INTEGER(0));
			} else if (AxIntFromDataPtr(Axfispureascii(p)) == 0)
                return (ELF_CREATE_INTEGER(0));
        }
    } else
        return (ELF_CREATE_INTEGER(0));

    return (ELF_CREATE_INTEGER(-1));
}

/*************************************************************************
function: Axfiseuc - Japanese arry/string data encoding judgement.
return value - if it is EUC encoded, then True, else False.
ELF form: IS_EUC@, ISEUC; c correspondence: is_euc_str().
*/
data_ptr Axfiseuc(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register int    ix;
    register int    arrsize;
    register mbchar *string;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        if (is_euc_str(string))
            return (ELF_CREATE_INTEGER(-1));
        else
            return (ELF_CREATE_INTEGER(0));
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (ElfbIsString(p)) {
        		string = (mbchar *)AxStrPtrFromDataPtr(p);
				if (!is_euc_str(string))
            		return (ELF_CREATE_INTEGER(0));
			} else if (AxIntFromDataPtr(Axfiseuc(p)) == 0)
                return (ELF_CREATE_INTEGER(0));
        }
    } else
        return (ELF_CREATE_INTEGER(0));

    return (ELF_CREATE_INTEGER(-1));
}

/*************************************************************************
function: Axfissjis - Japanese arry/string data encoding judgement.
return value - if it is Shift-JIS encoded, then True, else False.
ELF form: IS_SJIS@, ISSJIS; c correspondence: is_sjis_str().
*/
data_ptr Axfissjis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        if (is_sjis_str(string))
            return (ELF_CREATE_INTEGER(-1));
        else
            return (ELF_CREATE_INTEGER(0));
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (ElfbIsString(p)) {
        		string = (mbchar *)AxStrPtrFromDataPtr(p);
				if (!is_sjis_str(string))
            		return (ELF_CREATE_INTEGER(0));
			} else if (AxIntFromDataPtr(Axfissjis(p)) == 0)
                return (ELF_CREATE_INTEGER(0));
        }
    } else
        return (ELF_CREATE_INTEGER(0));

    return (ELF_CREATE_INTEGER(-1));
}

/*************************************************************************
function: Axfisjis - Japanese arry/string data encoding judgement.
return value - if it is JIS encoded, then True, else False.
ELF form: IS_JIS@, ISJIS; c correspondence: is_jis_str().
*/
data_ptr Axfisjis(argDatum)
data_ptr argDatum;
{
    data_ptr element;
    register data_ptr p;
    register data_ptr retDatum;
    register int    ix;
    register int    arrsize;
    register mbchar *string;

    if (AxArraySize(argDatum) == 1)
        /* called from outside */
        element = AxArrayElement(argDatum,0);
    else
        /* call by myself */
        element = argDatum;

    if (ElfbIsString(element)) {
        string = (mbchar *)AxStrPtrFromDataPtr(element);
        if (is_jis_str(string) || is_pure_ascii_str(string))
            return (ELF_CREATE_INTEGER(-1));
        else
            return (ELF_CREATE_INTEGER(0));
    } else if (ElfbIsArray(element)) {
        arrsize = ElfbArraySize(element);
        for (ix = 0; ix < arrsize; ix++) {
            p = AxArrayElement(element, ix);
            if (ElfbIsString(p)) {
        		string = (mbchar *)AxStrPtrFromDataPtr(p);
				if (!is_jis_str(string) && !is_pure_ascii_str(string))
            		return (ELF_CREATE_INTEGER(0));
			} else if (AxIntFromDataPtr(Axfisjis(p)) == 0)
                return (ELF_CREATE_INTEGER(0));
        }
    } else
        return (ELF_CREATE_INTEGER(0));

    return (ELF_CREATE_INTEGER(-1));
}

#endif       /* } BUILD_KANJI */

/*************************************************************************
function: ElfFaceNameToJavaCode - Given standard fontface name, return Java face index
Returns 2 (times) if none found
*/
int ElfFaceNameToJavaCode (name)
char *name;
{
    typedef struct {
        char *name;
        int jval;
    } name_map;
    static name_map map[] = {
        {"Alburtus",1},{"Antique Olive",1},{"Arial",1},
        {"Avant Garde",1},{"Bookman",2},{"CG Omega",1},
        {"CG Times",2},{"Century Schoolbook",2},{"Clarendon Condensed",2},
        {"Cloisterblack",2},{"Coronet",2},{"Courier Swa",0},
        {"Courier",0},{"Dutch",2},{"Freeform",2},
        {"Garamond",2},{"Helvetica Narrow",1},{"Helvetica",1},
        {"Holidaypi",3},{"Letter Gothic",0},{"Marigold",2},
        {"Morewingbats",3},{"New Century Schoolbook",2},{"Palatino",2},
        {"Shelley",2},{"Snowcap",1},{"Swiss Narrow",1},
        {"Swiss",1},{"Symbol Swa",2},{"Symbol",2},
        {"Times New Roman",2},{"Times",2},{"Univers Condensed",1},
        {"Univers",1},{"Zapf Calligraphic",2},{"Zapf Chancery",2},
        {"Zapf Dingbats",3},{NULL,2}};
    int ix;

    for ( ix = 0; map[ix].name; ix++ )
        if ( streq(map[ix].name,name) )
            return(map[ix].jval);
    return(2);
}

/******************************************************************
 function: AxfGetBlobData - Fetch the Binary Object Data from the
 elfodbc gateway in increments & send the whole object to the caller
*/
data_ptr AxfGetBlobData (argDatum)
data_ptr argDatum;
{
    data_ptr retData, serviceArgs, response;
    data_ptr cmdCodeP, aP;
    data_ptr rArg1, rArg2, rArg3;
    int channel, hstmt, coldex;
    int fCType, cbValueMax;
    char tempName[128];
    char *namep, *szSqlState;
    FILE *fp;
    int code, total_size=0, idx=0;
    char *str, *obj;
    int size, FileOnly;
    char *data_bin=NULL;
    int retcode=0;

    serviceArgs = AxArrayElement (argDatum, 0);
    FileOnly = AxBoolFromArray (argDatum, 1);

    aP = AxMakeArray( 7 );
    cmdCodeP = AxMakeIntData (2);         /* RPC CALL */
    aP = AxAddDataToArray(aP, 0, cmdCodeP );
    aP = AxAddDataToArray(aP, 1, AxArrayElement(serviceArgs, 0) );
    aP = AxAddDataToArray(aP, 2, AxArrayElement(serviceArgs, 1) );
    aP = AxAddDataToArray(aP, 3, AxArrayElement(serviceArgs, 2) );
    aP = AxAddDataToArray(aP, 4, AxArrayElement(serviceArgs, 3) );
    aP = AxAddDataToArray(aP, 5, AxArrayElement(serviceArgs, 4) );
    aP = AxAddDataToArray(aP, 6, AxArrayElement(serviceArgs, 5) );

    sprintf (tempName, "%s/blob%%%%", ThimTempDir);
    if ((namep = (char *) Amktemp(tempName)) == NULL)
         ElfStrAbort(ErrnoErr(), NULL, tempName);
    strcpy(tempName, namep);
    fp = fopen (tempName, WRITE_STR );
        
moreData:
    response = AxfAxNet( aP );

/* response is a 3 element array */
    retcode = AxIntFromArray (response, 0); /* RETCODE */
    rArg2 = AxArrayFromArray (response, 1); /* Ret Value */
    rArg3 = AxArrayFromArray (response, 2); /* Error Info */

    if (retcode == -1)  /* SQL_ERROR */
    {
        fclose (fp);
        unlink(tempName);
        ElfStrAbort (99, AxStrFromArray (rArg3, 2), "");
    }
    else if (retcode == 1)  /* SQL_SUCCESS_WITH_INFO */
    {
        szSqlState = AxStrFromArray(rArg3,0);
        if (strcmp(szSqlState, "01004") == 0)
        {
            rArg1 = AxArrayElement (rArg2, 0);
            size = ElfbBinarySize(rArg1);
            total_size += size;
            fwrite (((data_binary *)rArg1)->bytes, size, 1, fp);
            if (ferror (fp)) 
            {
                fclose (fp);
                unlink (tempName);
                ElfStrAbort (ErrnoErr (), NULL, tempName);
            }
            goto moreData;
        }
    }
    else
    {
        rArg1 = AxArrayElement (rArg2, 0);
        size = ElfbBinarySize(rArg1);
        total_size += size;
        fwrite (((data_binary *)rArg1)->bytes, size, 1, fp);   
        if (ferror (fp)) 
        {
            fclose (fp);
            unlink (tempName);
            ElfStrAbort (ErrnoErr (), NULL, tempName);
        }
    }

    fclose (fp);
    if (! FileOnly)
    {
        fp = fopen(tempName, READ_BINARY_STR );
        data_bin = AxMalloc (total_size);
        fread (data_bin, total_size, 1, fp);
        if (ferror(fp))
        {
            fclose (fp);
            unlink (tempName);
            ElfStrAbort (ErrnoErr (), NULL, tempName);
        }
        retData = AxMakeBinaryData (total_size, data_bin);
        AxFree (data_bin);
        fclose (fp);
        unlink (tempName);
    }
    else
    {
        retData = AxMakeStrData (strlen(tempName), tempName);
    }
    return (retData);
}

/*********
  The following are utility functions which can be used to dump 
  ELF data while using a debugger/dbxtool/dbx   --Kiran 4/29/96
  USAGE:   debugger/dbxtool -> 
            Add a button to get selection
                    button expand elf
            create an alias for xxxDumpELFData
                    kalias elf="call xxxDumpELFData (!:1, 0)"
        dbx ->
            create an alias as above & invoke "elf"
*********/

/***************************************************************************
function: xxxLog - Print passed message to logfile/stderr.
Usage: Identical to printf(3).
*/
void xxxLog (va_alist)
va_dcl
{
    va_list args;
    FILE *fp;
    char *fmt;

    fp = stderr;

    va_start(args);
    fmt = va_arg(args, char *);  /*LOK pa*/
    vfprintf(fp, fmt, args);
    va_end(args);
    fprintf(fp, NXLT("\n"));
    fflush(fp);
}

/***************************************************************************
function: xxxDumpELFData 
*/
void xxxDumpELFData (aP)
elfData aP;
{
    xxxELFDataDumper(aP, 0);
}

/***************************************************************************
function: xxxELFDataDumper - Dump ELF data - call initially with level 0.
Should be called only from WfDumpELFData within the code. (This is set up
this way so that this can be called from the debugger even if logging is
disabled.)
*/
void xxxELFDataDumper (aP, level)
elfData aP;
int level;
{
    int ix;
    int size;
    char tabString[256];  /* plenty ? */

    for ( ix = 0; ix <= level; ix++ ) {
        tabString[ix] = '\t';
    }
    tabString[level+1] = 0;

    if ( aP == NULL ) {
        xxxLog(NXLT("%sNULL"), tabString);
    }
    else if ( AxIsArray(aP) ) {
        size = AxArraySize(aP);
        xxxLog(NXLT("%sARRAY (size %d)"), tabString, size);
        for ( ix = 0; ix < size; ix++ ) {
            xxxELFDataDumper(AxArrayElement(aP, ix), level + 1);  /* RECURSE */
        }
    }
    else if ( AxIsInt(aP) ) {
        xxxLog(NXLT("%sINTEGER %d"), tabString, AxIntFromDataPtr(aP));
    }
    else if ( AxIsNumber(aP) ) {
        xxxLog(NXLT("%sNUMBER %f"), tabString, AxFloatFromDataPtr(aP));
    }
    else if ( AxIsString(aP) ) {
        xxxLog(NXLT("%sSTRING %s"), tabString, AxStrFromDataPtr(aP));
    }
    else if ( AxIsBinary(aP) ) {
        xxxLog(NXLT("%sBINARY (size %d)"), tabString, AxBinarySize(aP));
    }
    else if ( AxIsObject(aP) ) {
        xxxLog(NXLT("%sOBJECT"), tabString);
    }
    else {
        xxxLog(NXLT("%sUNKNOWN"), tabString);
    }
}


/***************************************************************************
function: getUserHomeDir - retrieve home directory for the passed user
*/
char *
AGetUserHomeDir(username)
char *username;
{
#if AXMS
    /*
     * I couldn't find any way to do this on Windows...
     */

    return(NULL);
#else
    struct passwd *pwent;

    pwent = getpwnam(username);

    if (pwent == (struct passwd *)NULL)
        ElfStrAbort(ERR_ILLVAL, NXLT("Unknown user"), username);
    else
        return(pwent->pw_dir);
#endif
}

/*
 * Function: AxfNoteTaskInterested
 * Args:     2 element array.
 *           1st element -> uid of task to notify on exit.
 *           2nd element -> uid of task that has to do the notification upon exit.
 *                          This is an optional argument. The current task is the
 *                          default.
 * Synopsis: This function will set the UID of the task that has to be notified
 *           onto the task that should do the notification. tasks_interested
 *           is a array of tasks that will be sent a message when this task exits.
 *           The last element of the array is always a zero.
 */
 
data_ptr AxfNoteTaskInterested(argDatum)
data_ptr argDatum;
{
    int ix=0;
    int *taskList;
    int current_task = 0;

    current_task = ThimPidFromUID(IntFromArgArray(argDatum, 1));
    if (!current_task)
        /* By default use THIMpid */
        current_task = ThimTopPidFromPid(THIMpid);
    else
        current_task = ThimTopPidFromPid(current_task);

    taskList = (int *)TaskInfo[current_task].tasks_interested;
    if (taskList) {
        for(ix=0;taskList[ix]!=0;ix++)
            ;
    }
    TaskInfo[current_task].tasks_interested = (int *)TaskRealloc(current_task, 
                                    TaskInfo[current_task].tasks_interested, 
                                    (ix+2)*sizeof(int));

    /* Note the UID of the task wanting notification of exit */
    TaskInfo[current_task].tasks_interested[ix] 
                        = IntFromArgArray(argDatum,0);
    /* terminate array with a zero */
    TaskInfo[current_task].tasks_interested[ix+1] = 0;
    return(NULL);
}


/*************************************************************************
function: AxfFileOpenedNotify - Tell C apps... for insets
*/
data_ptr AxfFileOpenedNotify (argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
    FSPokeAll(name, AC_OPEN);
    return(NullDataPtr);
}

/*************************************************************************
function: AxfFileClosedNotify - Tell C apps... for insets
*/
data_ptr AxfFileClosedNotify (argDatum)
data_ptr argDatum;
{
    char *name = StrFromArgArray(argDatum,0);
    FSPokeAll(name, AC_TERM);
    return(NullDataPtr);
}

/*
*   AxNotifySSRtStarted - let SS tasks know that a RealTime Gateway is started
*/
AxNotifySSRtStarted(rtGateWay)
    char *rtGateWay;
{
    int ix;
    scac_message_info msg;
    int len;

    memset((char *)&msg, '\0', sizeof(scac_message_info));
    msg.type = AC_RTSTARTED;
    len = MIN( (sizeof(msg.buf) - 1), strlen(rtGateWay));
    strncpy(msg.buf, rtGateWay,  len);
    msg.buf[len] = '\0';
    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use && TaskInfo[ix].appid == APSS)  
            IPCXsendMes(IPC_SRT, ix, &msg, sizeof(msg), APAC, 0);
    }
}

/* function: AxRefreshFontInfo - re-initialize font information, and
   refresh WP ruler font menus if necessary */
AxRefreshFontInfo()
{
    int ix;
    scac_message_info msg;

	InitFontInfo();
    memset((char *)&msg, '\0', sizeof(scac_message_info));
    msg.type = AC_NEWFONTS;
	msg.buf[0] = '\0';
    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use && 
			 (TaskInfo[ix].appid == APDC ||
			  TaskInfo[ix].appid == APHTML ||
			  TaskInfo[ix].appid == APEQN) ) {
            IPCXsendMes(IPC_SRT, ix, &msg, sizeof(msg), APAC, 0);
		}
	}
}

#if AXMS
static int
axmsCheckForBatchOutputHeader(FILE *fp, char *cmd)
{
    int ret = FALSE;
    char line[256];

/* Batch files seem to like writing a line-feed plus command-line
 * to standard out.    -donato
 */

    fgets(line, 255, fp);
    if ( line && (line[0] == '\0' || line[0] == 0x0A) )
        {
        fgets(line, 255, fp);
        if ( strstr(line, cmd) )
            ret = TRUE;
        }
    fseek(fp, 0L, SEEK_SET);
    return ret;
}
#endif

/* TM1 specific routine --Kiran.
   // Need to make a generic routine to read line by line
	  from a file.
 ****/
data_ptr tm1_read_1_line_from_file(char *file)
{
	FILE *fp;
	char line[1024];
	char *tmp;

	fp = fopen(file, "r");
	if (! fp)
		return(NULL);

	tmp = fgets(line, 1024, fp);
	if (tmp && (tmp[0] == '\0' || tmp[0] == '\n'))
	{
		tmp = fgets(line, 1024, fp);
		if (! tmp)
			return(NULL);
	}
	return(AxMakeStrData(-1, line));
}

/* Convert the passed elf strings array to a single
 * elf string, using CR-NL as the line separator.
 */
data_ptr
ElfStrsArrayToElfCRNLString(inarr)
data_ptr inarr;
{
	int array_size, ix, str_size;
	mbchar *outstr, crnl[4];
	data_ptr ret_str;
	
	if (!AxIsArray(inarr)) {
		return (NULL);
	}
	array_size = AxArraySize(inarr);
	if (0 == array_size) {
		return (NULL);
	}
	crnl[0] = (mbchar) '\r';
	crnl[1] = (mbchar) '\n';
	crnl[2] = crnl[3] = 0;
	for (str_size = 0, ix = 0; ix < array_size; ix++) {
		str_size += MBstrlen(AxStrFromArray(inarr, ix));
	}
	str_size += 2 * (array_size - 1) + 2; /* add in cr-nl's, plus null & fuj */
	outstr = (mbchar *) malloc(str_size);
	outstr[0] = (mbchar) 0;
	for (ix = 0; ix < array_size; ix++) {
		MBstrcat(outstr, AxStrFromArray(inarr, ix));
		if (ix < array_size - 1) {
			MBstrcat(outstr, crnl);
		}
	}
	ret_str = AxMakeStrData(-1, outstr);
	free(outstr);
	return (ret_str);
}

/* Convert the passed elf string to an elf strs array,
 * based on occurrences of CR-NL as the line separator.
 */
data_ptr
ElfCRNLStringToElfStrsArray(instrP)
data_ptr instrP;
{
	mbchar *cp, *lcp, *instr, crnl[4];
	data_ptr outarr;
	int ax;
	
	if (!AxIsString(instrP)) {
		return (NULL);
	}
	
	instr = AxStrFromDataPtr(instrP);
	crnl[0] = (mbchar) '\r';
	crnl[1] = (mbchar) '\n';
	crnl[2] = crnl[3] = 0;
	
	outarr = AxMakeArray(0);
	ax = 0;
	
	cp = lcp = instr;
	while(TRUE) {
		cp = MBstrstr(cp, crnl);
		if (cp) {
			*cp = 0;
			cp += 2;
			outarr = AxAddStrToArray(outarr, ax++, lcp);
			lcp = cp;
		}
		else {
			outarr = AxAddStrToArray(outarr, ax++, lcp);
			break;
		}
	}
	return (outarr);
}



#define ENCRYPT_LEN 200  /* if this is changed, change in int_enc.c too */
typedef struct enc_pwd {
	char host_name[15];
	char encrypt_pwd[ENCRYPT_LEN+1];
} enc_pwd;
 
static int Remote_Pwd_size;
static enc_pwd *Remote_Pwd_Table;

/***************************************************************************
function: AddEncryptedPasswordToTable 
*/
void AddEncryptedPasswordToTable ( host_name, in_password )
char *host_name;
char *in_password;
{
    int i;
    int entry_ix;
    enc_pwd *entryP;
    char encrypt_pwd[ENCRYPT_LEN+1];
 
	/* frist encrypt passed password */

	EncryptPassword(in_password, encrypt_pwd);

    /* now create the table entry */
    /* first we check to see if it is already there, and if so, we just */
    /* replace the entry                                                */
    entryP = Remote_Pwd_Table;
    for ( i=0; i<Remote_Pwd_size; i++ )
        {
        if ( strcmp( entryP->host_name, host_name ) == 0 )
            {
            /* found it, just replace the passwrod */
            strcpy( entryP->encrypt_pwd, encrypt_pwd );
            return;
            }
        entryP++;
        }

    /* not found, create a new entry */
    entry_ix = Remote_Pwd_size;
    Remote_Pwd_size++;
    if ( Remote_Pwd_Table == (enc_pwd *)NULL )
         Remote_Pwd_Table = (enc_pwd *)TrueMalloc( sizeof(enc_pwd) );
    else
         Remote_Pwd_Table = (enc_pwd *)TrueRealloc( Remote_Pwd_Table,
                                              Remote_Pwd_size*sizeof(enc_pwd) );

    entryP = Remote_Pwd_Table + entry_ix;
    strcpy( entryP->host_name, host_name );
    strcpy( entryP->encrypt_pwd, encrypt_pwd );

    return;

}

/***************************************************************************
function: GetEncryptedPassword 
*/
char *GetEncryptedPassword ( host_name )
char *host_name;
{
    int i;
    enc_pwd *entryP;
 
    entryP = Remote_Pwd_Table;
    for ( i=0; i<Remote_Pwd_size; i++ )
        {
        if ( strcmp( host_name, entryP->host_name) == 0 )
           /* fount it */
           return( entryP->encrypt_pwd );
        entryP++;
 
        }
 
    /* not found */
    return( "" );
}

data_ptr RtTm1Funcs();

data_ptr AxRtTm1Funcs(funcData)
data_ptr funcData;
{
data_ptr aP;
	/* check out if the library is loaded, if it is then only proceed else
		return error */
	
	if (aP = (data_ptr)ElfGetSysVar ("TM1_ADDIN_INSTALLED") ) {
		if (AxIntFromDataPtr(aP) == 0) {
			/* error out and return */
			return(NULL) ;
		}
	}
	return(RtTm1Funcs(funcData));
}

/***************************************************************************
function: AxfCheckSpellingLibrary 

As of 442 the Proximity Spelling code is in a shared library (libspell.so). 
If this library is missing, Applixware can run but not provide any 
spelling/hyphenation/thesaurus functionality.  This function determines 
whether the library is present or absent, optionally throwing an error.

TRUE is returned if the library is present, else FALSE.
*/
data_ptr AxfCheckSpellingLibrary (argDatum)
data_ptr argDatum;
{
	int len;
	int err=FALSE, warn=FALSE;

    len = AxArraySize(argDatum);
	if (len >= 1)
    	err = IntFromArgArray(argDatum, 0);
#if 0
	if (len >= 2)
    	warn = IntFromArgArray(argDatum, 1);
#endif

	if (!ThimNoSpellingLibrary)
		return(ELF_CREATE_INTEGER(BTRUE));		 /* shared lib exists */

	if (err)
		ElfStrAbort(ERR_NOOPEN,NULL,ThimSpellingLibraryFilename);
	return(ELF_CREATE_INTEGER(BFALSE));			/* no shared lib */
}

/***************************************************************************
  Function:  AxfCallLibFunc

  p1 = dataptr => array with 2 or 3 elements 
      1: library name (string)
      2: function name (string: case sensitive!!)
      3: parameters for function

*/
  data_ptr AxfCallLibFunc (data_ptr aP)
{
	static char **loaded_lib;
	static void **loaded_dl;
	static int n_loaded;

	char err_str[STRPATH+1], *lib1, *lib2=NULL, *func, *dl_err, **argv = NULL;
	int n_args, ix, lib_ix, argc, have_func=TRUE;
	data_ptr retP, dataP;
   data_ptr ret_val;
   data_ptr (*entry_func)(int, char **);
   data_ptr (*entry_func_noargs)();
	void *dl;

	/* get the libname */
	n_args = AxArraySize(aP);
	if ( n_args < 1 )
		ElfStrAbort(ERR_NOOPEN,NULL,"No library specified");
	else
	{
		lib1 = StrFromArgArray(aP, 0);
		if ( !lib1 || lib1[0] == (char)0 )
			ElfStrAbort(ERR_NOOPEN,NULL,"No library specified");
	}

	/* get the func name */
	if ( n_args < 2 )
		ElfStrAbort(ERR_ILLVAL,NULL,"No function specified");
	else
	{
		func = StrFromArgArray(aP, 1);
		if ( !func || func[0] == (char)0 )
			ElfStrAbort(ERR_ILLVAL,NULL,"No function specified");
	}


	/* package the data */
	if ( n_args < 3 )
	{
		argc = 0;
		argv = (char **)0;
	}
	else
	{
		dataP = AxArrayElement(aP, 2);
		if ( AxIsArray(dataP) == FALSE )
		{
			argc = 1;
			argv = (char **)malloc(argc * sizeof(char *));
			argv[0] = StrFromDataPtr(dataP);
		}
		else
		{
         /* already in dataP format */ 
         argc = 1;
			argv = (char **)malloc(sizeof(char *));
         argv[0] = (char *)dataP;
		}
	}

	/* expand the passed in lib */
	lib2 = malloc(3+strlen(lib1)+3+1);
#if AXMS
	sprintf(lib2, "%s.dll", lib1);
#elif HP800
	sprintf(lib2, "lib%s.sl", lib1);
#else
	sprintf(lib2, "lib%s.so", lib1);
#endif
	
	/* load the shared library (if not already loaded) */
	dl = (void *)0;
	for ( lib_ix=ix=0; ix<n_loaded; ix++ ) /* sort this!!! */
	{
		if ( strcmp(loaded_lib[ix], lib2) == 0 )
		{
			dl = loaded_dl[ix];
			lib_ix = ix;
			break;
		}
	}
	if ( dl == (void *)0 )
	{
		/* open the dynamic lib */
		dl = Adlopen(lib2, ADL_BIND_IMMEDIATE|ADL_BIND_FIRST);
		if ( dl == (void *)0 )
		{
			dl_err = Adlerror();
			if ( dl_err )
				sprintf(err_str, "Error loading lib %s[%s]: %s\n", lib2,lib1, dl_err);
			else
				sprintf(err_str, "Error loading lib %s[%s]\n", lib2,lib1);
			ElfStrAbort(ERR_NOOPEN, "",err_str);
		}

		/* add the dl to the list */
		loaded_lib = (char **)TaskRealloc( 0, loaded_lib, 
											(n_loaded+1)*sizeof(char *) );
		loaded_lib[n_loaded] = (char *)TaskAlloc( 0, strlen(lib2)+1 );
		strcpy(loaded_lib[n_loaded], lib2);
		loaded_dl = (void **)TaskRealloc( 0, loaded_dl, 
											(n_loaded+1)*sizeof(void *) );
		loaded_dl[n_loaded] = dl;
		lib_ix = n_loaded++;
	}

	/* load the function */
	if ( n_args < 3 )
	  {
		 entry_func_noargs = (data_ptr(*)())Adlsym(dl, func);
		 have_func = ( entry_func_noargs != NULL );
	  }
	else
	  {
		 entry_func = (data_ptr(*)(int, char**))Adlsym(dl, func);
		 have_func = ( entry_func != NULL );
	  }

	if ( !have_func)
	{
		sprintf(err_str, "Error loading func %s in lib %s[%s]\n", func, lib2,lib1);
		ElfStrAbort(ERR_ILLVAL,"", err_str);
	}

	/* call the function */
	if ( n_args < 3 )
	   ret_val = (*entry_func_noargs)();
	else
	   ret_val = (*entry_func)(argc, argv);

	if (argv != NULL)
	  free (argv);

	if (lib2 != NULL)
	  free (lib2);

   /* return value is data ptr already */
   return (ret_val);
}
