/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxcom.c
   Applix ASC version: 209
   Date: Wed Jun 16 21:11:21 1999
*/
#define NEED_X_INFO 1 
#define X_MILLS_TO_PIXELS(x) (((long)(x) * UWidPels)/UWidMils)              
#define Y_MILLS_TO_PIXELS(y) (((long)(y) * UHtPels)/UHtMils)                
#define X_PIXELS_TO_MILLS(x) (((long)(x) * UWidMils + UWidPels -1)/UWidPels)
#define Y_PIXELS_TO_MILLS(y) (((long)(y) * UHtMils + UHtPels -1)/UHtPels)   

#define MAXEV           66          /* for now */  

#include <stdio.h>
#include <dwt2xm.h>
#include <basicwin.h>
#include <sys/types.h>
#include <axtime.h>
#include <math.h>
#include <ax_xm.h>
#include <aos.h>
#include <paripc.h> 
#include <scac.h>
#include <xmlib.h>
#include <tmi.h>   
#include <paratm.h>
#include <parint.h>
#include <paratmgr.h>
#include <usrevent.h>
#include <parwin.h>
#include <paramin.h>
#include <parattr.h>
#include <aiconids.h>
#include <axtext.h>
#include <elhelper.h>
#include <el_syms.h>
#include <afileimg.h>
#include <colors.h>
#include <doctypes.h>
#if AXMS
#include <axtimev.h>
#endif
/* JUST FOR NOW ??x */
#define NEUTRAL     0   /* not picking or stroking */
#define IBD         1   /* initial button down */
#define PIP         2   /* pick in progress (button up) */
#define SIP         3   /* stroke in progress */

#define SIG_MM      5       /* significant mouse motion (pixels) */

/* input mask for work area window - includes pointer motion mask */
#define TM_PTR_INPUTS_MASK (TM_NO_PTR_INPUTS_MASK | PointerMotionMask)

/* input mask for work area window - does not include pointer motion mask */
#define TM_NO_PTR_INPUTS_MASK KeyPressMask | KeyReleaseMask | \
        ResizeRedirectMask | FocusChangeMask | SubstructureNotifyMask | \
        StructureNotifyMask | ButtonPressMask | ButtonReleaseMask | \
        ButtonMotionMask | ExposureMask | LeaveWindowMask | EnterWindowMask

/* here for now! */
#define MSG_WIDTH 400
#define GE_MSG_WIDTH 225
#define GE_PAGE_WIDTH 136


#if AXMS
extern int Scrollbar_Thickness;
#define MSG_HEIGHT Scrollbar_Thickness
#define SCROLLBAR_THICK Scrollbar_Thickness
#else
#define MSG_HEIGHT 		16
#define SCROLLBAR_THICK 16
#endif
#define RAND_FUNC(x)  (rand() % (x))
 


static imageInfo imInfo;

unsigned char *outputBuffer;
IFILE *imageFp;
struct wind_struct *StatWp = NULL;   /* status line window pointer */
short CreCount = 0;                  /* creation order counter */ 
int AxNoteAllMousePoints = FALSE;    /* TRUE during GE object stroke */
int AxGEToolPalOn = TRUE, AxGEColorPalOn = TRUE;
int WMstate = NEUTRAL;
short LastInputWasMouse;   /* used to override xpos,ypos on window create */
int widthInPels, heightInPels;

short FGcolor = DEFAULT_FG; /* What is this??c */
short BGcolor = DEFAULT_BG; /* What is this??c */

short MevButton1, MevButton2, MevButton3;
Pixmap BackupPixmap = (Pixmap)NULL;
Pixmap FinalPixmap = (Pixmap)NULL;
Pixmap FlyInPixmap = (Pixmap)NULL;
/*
 * conventions:
 *  - StrkReq nonzero implies StrkDesel
 *  - StrkDesel implies stroke in progress (SIP)
 *  - TimerRunning and TimerExpired are mutually exclusive (busy/done)
 */
short StrkReq = 0;          /* # requests for the next stroke point */
short StrkDesel = FALSE;    /* stroke events have been deselected */


extern Window RootWin;
extern unsigned long AxPixels[];
extern short MevButton;
extern int WidgetNeedsUpdated;
extern Cursor ThimPointerCursor, ThimRotateCursor;
extern Cursor ThimUpDownCursor, ThimLeftRightCursor;
extern Cursor ThimTopRightCursor, ThimTopLeftCursor;
extern Cursor ThimBottomRightCursor, ThimBottomLeftCursor;
extern Cursor ThimFleurCursor, ThimTextCursor;
extern Pixmap ScratchMap; /* screen size pixmap available as app resource */
extern Display *Dpy;      /* Resolution of DisplayWidget */
extern int PlaneMask;     /* depth of display */
extern GC Gc1;            /* graphics context shared by all windows */
extern GC Gc2;            /* graphics context shared by all windows */
extern short DpyDepth;
extern int QuietRunning;    /* used to suppress diaply of dialogs */
extern int QuietErrsRunning;    /* used to suppress display of error msgs */
extern int THIMhelpMode;
extern TmPoint ButDown;
extern short ColorDisplay;
extern short ToggleFG;
extern short NoColor;       /* force monochrome under SunView */
extern unsigned long AlisPixels[];
AxRectangle savedClip;
extern unsigned long TimeOfButtonPress;
extern int DoubleMillisec;
extern int DoublePixSpan;
extern int AxOpenLook;
#if AX_X11
extern long AxPulldownActive; /* non-zero while a menubar pulldown is active */
#endif

/* dcls to satify dispatch table below */                           
void atm_create(), atm_term(), atm_modify(),
    atm_rclose(), atm_arclose(), atm_inq(),
    atm_dcursor(), atm_text_ext(), atm_init_str(),
    atm_m_pick(), atm_m_stk(), atm_pmark(), atm_pline(),
    atm_Arc(), atm_bblt(), atm_set_win(), atm_alter_tx(),
    atm_beep(), atm_open(),
    ElfMsgPipe(), atm_mk_curwin();


/* Function dispatch table for evDispat. NULLs are no-ops */        
/* TAKE OUT OF tmdispat.c !! */
void (*DispatchTable[MAXEV+1])() = {            
/* QATM_NONE 0 */                 NULL,        
/* QATM_CREATE 1 */               atm_create,
/* QATM_TERM 2 */                 atm_term,    
/* QATM_MODIFY 3 */               NULL,  
/* QATM_SASIDE 4 */               NULL,        
/* QATM_DREG 5 */                 NULL,        
/* QATM_MREG 6 */                 NULL,        
/* QATM_RCLOSE 7 */               atm_rclose,  
/* QATM_ARCLOSE 8 */              atm_arclose, 
/* QATM_CURWIN 9 */               NULL,        
/* QATM_INQ 10 */                 atm_inq,     
/* QATM_DCHAR 11 */               NULL,        
/* QATM_SCROLL 12 */              NULL,        
/* QATM_DCURSOR 13 */             NULL, 
/* QATM_WRITE_TX 14 */            NULL,        
/* QATM_TEXT_EXT 15 */            NULL,
/* QATM_INIT_STR 16 */            NULL,
/* QATM_GET_EVENT 17 */           NULL,        
/* QATM_M_PICK 18 */              atm_m_pick,  
/* QATM_M_STK 19 */               NULL,   
/* QATM_PMARKER 20 */             atm_pmark,   
/* QATM_PLINE 21 */               atm_pline,   
/* QATM_Arc 22 */                 NULL,     
/* QATM_BBLT 23 */                atm_bblt,                            
/* QATM_SET_WIN 24 */             atm_set_win,                         
/* QATM_SP_WID 25 */              NULL,                                
/* QATM_ALTER_TX 26 */            NULL,                        
/* QATM_RESET 27 */               NULL,                                
/* QATM_STK_ACTION 28 */          NULL,                      
/* QATM_FIELD_WRITE 29 */         NULL,                                
/* QATM_BEEP 30 */                atm_beep,                            
/* QATM_PUTEVENT 31 */            NULL,                                
/* QATM_HOMELINE 32 */            NULL,                                
/* QATM_GMODE 33 */               NULL,                                
/* QATM_NEXTWIN 34 */             NULL,                                
/* QATM_ST_REGEN 35 */            NULL,                                
/* QATM_QMSELECT 36 */            NULL, /* no longer used as of 2.0A */
/* QATM_QMIDS 37 */               NULL, /* no longer used as of 2.0A */
/* QATM_GWMODE 38 */              NULL,                          
/* QATM_PIMAGE 39 */              NULL,                          
/* QATM_GIMAGE 40 */              NULL,                          
/* QATM_PCMAP 41 */               NULL,                           
/* QATM_GCMAP 42 */               NULL,                           
/* QATM_PMSK 43 */                NULL,                            
/* QATM_GMSK 44 */                NULL,                            
/* QATM_IWIN 45 */                NULL,                            
/* QATM_RLS 46 */                 NULL,                                
/* QATM_RST 47 */                 NULL,         
/* QATM_REC 48 */                 NULL,         
/* QATM_RPL 49 */                 NULL,         
/* QATM_CHAR_REC 50 */            NULL,         
/* QATM_MOUS_REC 51 */            NULL,         
/* QATM_OPEN 52 */                NULL,     
/* QATM_PAGE 53 */                NULL,         
/* QATM_AKY 54 */                 NULL,         
/* QATM_XFER_CONTROL 55 */        NULL,         
/* QATM_SYNC 56 */                NULL,     
/* QATM_TABS 57 */                NULL,         
/* QATM_SPARE2 58 */              NULL,         
/* QATM_SPARE3 59 */              NULL,         
/* QATM_ERRMSG 60 */              NULL,   
/* QATM_NSTATUS 61 */             NULL,         
/* QATM_CSTATUS 62 */             NULL,  
/* QATM_ELF 63 */                 ElfMsgPipe,   
/* QATM_MK_CURWIN 64 */           atm_mk_curwin,
/* QATM_IMGTXT 65 */              NULL   
};                                              


short MaxwWid;
short MaxwHt;
short MinWWid = MINW_COLS * X_MPC;    /* min window width, mils */
short MinWHt = MINW_ROWS * Y_MPC;     /* min window height, mils */
int AxWindowCreationCounter;           /* incremnting uid for each window */

extern short UWidMils, UHtMils, UWidPels, UHtPels; 
extern short LocTmR;            /* local call flag */                       
extern short LocWid;            /* window_id of a locally created window */ 
extern int TmAmSE;   /* set by pdc when formatting */
extern short ACwin;                                                          
extern Window HostWin;
extern unsigned long FGpixel;   /* shared foreground color */
extern unsigned long BGpixel;   /* shared backround color */

Drawable temporarySaveDrawable;
void ScrollBarHasBeenMoved();
extern void SSZoomCallback();
extern void DCZoomCallback();
extern void RWGlyphCallback();  
#if 1
#include <tmxcom.p>
#endif

/************************************************************************* 
function: AxIsMain - Return true if type is main
*/                                                      
AxIsMain(w)
AXWidget w;
{
    if ( w && w->type == W_MAIN )
        return(TRUE);
    return(FALSE);
}

/*******************************************************
function: WidgetOfWindow - Return window's widget value 
*/                                                      
AXWidget_main
WidgetOfWindow (x)                             
int x;                                                  
{                                                       
    if (x >= 0 && x < TM_MAXWIN)
        return(window[x].shell);
    return(NULL);
}                                                       

/*******************************************************
function: WidgetOfWorkWindow - Return work window's widget value
*/
AXWidget_work WidgetOfWorkWindow (x)
int x;
{
    WIDGET_PARANOID( window[x].workWidget, W_WORK );

    return(window[x].workWidget);
}

/************************************************************************* 
function: WidgetOfRuler - Return ruler widget                              
*/                                                                         
AXWidget_ruler WidgetOfRuler (x)                                          
int x;                                                                     
{                                                                          
    WIDGET_PARANOID( window[x].ruler, W_RULER );

    return(window[x].ruler);
}                                                                          
/************************************************************************* 
function: WidgetOfCorner - Return corner widget                            
*/                                                                         
AXWidget_corner WidgetOfCorner (x)                                                
int x;                                                                     
{                                                                          
    WIDGET_PARANOID(  window[x].corner, W_CORNER );

    if ( (x > 0) && window[x].busy_flag )
        return(window[x].corner);
    else
        return(0);
}                                                                          

/**************************************************
function: WidgetOfDebugger - Return debugger widget
*/                                                 
AXWidget_debug  WidgetOfDebugger (x)
int x;                                             
{                                                  
    WIDGET_PARANOID(  window[x].debugger, W_DEBUG );

    return(window[x].debugger);                    
}                                                  


/****************************************************************
function: WidgetOfCurrentAtmWindow - Return window's widget value
*/
AXWidget_main WidgetOfCurrentAtmWindow ()
{
    WIDGET_PARANOID(  window[cur_win].shell, W_MAIN );

    if ( cur_win >= 1 )
        return(window[cur_win].shell);
    else
        return(0);
}


/*************************************************************************
function: ApIdOfCurrWindow - Return major app's type
*/
int AppIdOfCurrWindow ()
{
    if ( cur_win > 0 )
        return(window[cur_win].ap_id);
    else
        return(0);
}



/****************************************************************
function: WindowIdFromPid - Return ATM window id based on pid
This assued the pid has only one window.
*/
int WindowIdFromPid (pid)
int pid;
{
    register int ix;

    for ( ix = 0; ix < TM_MAXWIN; ix++ ) {
        if ( window[ix].busy_flag && (window[ix].p_id == pid) )
            return(ix);
    }
    return( -1);        /* Generally recognized as invalid id */
}
/*************************************************************************
function: WindowIdFromWidget - Return window id from  widget
Returns 0 if not found.
*/
int WindowIdFromWidget (widget)
AXWidget_main widget;
{
    register int ix;

    if(!widget )
        return(0);

    if( widget->type == W_MAIN)
    {
        for(ix = 0; ix < TM_MAXWIN; ix++ )
        {
            if ( window[ix].busy_flag && (window[ix].shell == widget) )
                break;
        }
    }
    else
        ix = 0; 
  return(ix);
}

/*************************************************************************
function: AxWindowIdFromShellWidget - Return window id from shell widget
Returns 0 if not found.
*/
int 
AxWindowIdFromShellWidget (widget)
AXWidget_main widget;
{
    register int ix;

    if ( !widget )
        return(0);

    WIDGET_PARANOID( widget, W_MAIN );

    for ( ix = 0; ix < TM_MAXWIN; ix++ ) {
        if ( window[ix].busy_flag && (window[ix].shell == widget) ) {
            return(ix);
        }
    }
    return(0);
}

/*************************************************************************
*/
int
WindowIdFromShellWidget (wd)
long wd;
{
    return(AxWindowIdFromShellWidget((AXWidget_main)wd));
}

AxUpdateRulerInfo(w, ruler, update_state)
AXWidget_main w;
struct TmGridRulerInfo *ruler;
{
    int len;
    if ( Wp->x_zero_pt != ruler->x_zero_point )
    {
        Wp->x_zero_pt = ruler->x_zero_point;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->y_zero_pt != ruler->y_zero_point )
    {
        Wp->y_zero_pt = ruler->y_zero_point;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->x_scroll_origin != ruler->x_scroll_origin )
    {
        Wp->x_scroll_origin = ruler->x_scroll_origin;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->y_scroll_origin != ruler->y_scroll_origin )
    {
        Wp->y_scroll_origin = ruler->y_scroll_origin;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->x_zoom != ruler->x_resolution )
    {
        Wp->x_zoom = ruler->x_resolution;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->y_zoom != ruler->y_resolution ) 
    {
        Wp->y_zoom = ruler->y_resolution;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->gridSize != ruler->grid_size )
    {
        Wp->gridSize = ruler->grid_size;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->unitSize != ruler->unit_size )
    {
        Wp->unitSize = ruler->unit_size;
        if ( !update_state )
            update_state = TRUE;
    }
    if ( Wp->unitPrec != ruler->unit_prec )
    {
        Wp->unitPrec = ruler->unit_prec;
        if ( !update_state )
            update_state = TRUE;
    }

    /* make sure it's null terminated (just in case) */

    /* make sure it's null terminated (just in case) */
    len = strlen(ruler->unit_name);
    if ( strncmp(Wp->unitName, ruler->unit_name, len) == 0 )
        Wp->unitName[len] = (char)0;
    else
    {
        strcpy(Wp->unitName, ruler->unit_name);
        if ( !update_state )
            update_state = TRUE;
    }
    return(update_state);
}

/*******************************************************************
function: TmRaiseWindow -
*/
TmRaiseWindow(wp)
struct wind_struct * wp;
{
    XRaiseWindow(Dpy, wp->topwindow);
    XSync(Dpy, FALSE);
}

#define NEWVAL(new,old) ((new != -1) && (new != old))
/*******************************************************************
function: TmModify - Change a window's thumbing bars or icon id
*/
typeErr TmModify(w, new, ruler)
AXWidget_main w;
struct TmCrePacket *new;
struct TmGridRulerInfo *ruler;
{
    int an, val, winID, ruler_needs_update;
    struct TmCrePacket *old;
    Arg arglist[10];

    winID = AxWindowIdFromShellWidget(w);

    if ( !winExists(winID) || (winID == 0) )
        return(TMR_NOWIN);

    SetWp(&window[winID]);
    old = &Wp->wind_attr;

    /* New icon id? */
    if ( (new->icon_id != 0) && NEWVAL(new->icon_id,old->icon_id) )
    {
        old->icon_id = new->icon_id;
        CreateOrChangeMenuBar(w);
    }

    /* New vertical scroll bar state */
    ruler_needs_update = FALSE;
    if ( w->vScrollBar )
    {
        an = 0;
        if ( NEWVAL(new->v_sc_per,old->v_sc_per) )
        {
            old->v_sc_per = new->v_sc_per;
            val = MAX(1,old->v_sc_per);
            XtSetArg(arglist[an],AXmNsliderSize,val); an++;
        }
        if ( NEWVAL(new->v_sc_pos,old->v_sc_pos) )
        {
            val = old->v_sc_pos = new->v_sc_pos;
            XtSetArg(arglist[an],AXmNvalue,val);an++;
        }
        if ( an )
        {
            AxXtSetValues((AXWidget)w->vScrollBar,arglist,an);
            ruler_needs_update = TRUE;
        }
    }

    /* New horizontal scroll bar state */
    if ( w->hScrollBar )
    {
        an = 0;
        if ( NEWVAL(new->h_sc_per,old->h_sc_per) )
        {
            old->h_sc_per = new->h_sc_per;
            val = MAX(1,old->h_sc_per);
            XtSetArg(arglist[an],AXmNsliderSize,val); an++;
        }
        if ( NEWVAL(new->h_sc_pos,old->h_sc_pos) )    
        {
            val = old->h_sc_pos = new->h_sc_pos;
            XtSetArg(arglist[an],AXmNvalue,val);an++;
        }
        if ( an )
        {
            AxXtSetValues((AXWidget)w->hScrollBar,arglist,an);
            ruler_needs_update = TRUE;
        }
    }

    /* redraw the GE's rulers if the window scrolled or resolution changed */
    if ( ruler && AxUpdateRulerInfo(w, ruler, ruler_needs_update) )
        AxXmRepaintGErulers(w);
    return(AOK);
}
/********************************************************************
*/                                                                   
AxUpdateScrollbars(wd, new)
long wd;
struct TmCrePacket *new;
{
    Arg arglist[10], getarg[1];
    int an, val, old_val;
    AXWidget_main w;

    w = (AXWidget_main)wd;
    /* New vertical scroll bar state */
    if ( w->vScrollBar )
    {
        an = 0;
        XtSetArg(getarg[0], AXmNsliderSize, &old_val);
        AxXtGetValues((AXWidget)w->hScrollBar, getarg, 1);
        if ( NEWVAL(new->v_sc_per, old_val) )
        {
            val = MAX(1,new->v_sc_per);
            XtSetArg(arglist[an],AXmNsliderSize,val); an++;
        }
        XtSetArg(getarg[0], AXmNvalue, &old_val);
        AxXtGetValues((AXWidget)w->hScrollBar, getarg, 1);
        if ( NEWVAL(new->v_sc_pos, old_val) )
        {
            val = new->v_sc_pos;
            XtSetArg(arglist[an], AXmNvalue, val);an++;
        }
        if ( an )
            AxXtSetValues((AXWidget)w->vScrollBar,arglist,an);
    }

    /* New horizontal scroll bar state */
    if ( w->hScrollBar )
    {
        an = 0;
        XtSetArg(getarg[0], AXmNsliderSize, &old_val);
        AxXtGetValues((AXWidget)w->hScrollBar, getarg, 1);
        if ( NEWVAL(new->h_sc_per, old_val) )
        {
            val = MAX(1,new->h_sc_per);
            XtSetArg(arglist[an],AXmNsliderSize,val); an++;
        }
        XtSetArg(getarg[0], AXmNvalue, &old_val);
        AxXtGetValues((AXWidget)w->hScrollBar, getarg, 1);
        if ( NEWVAL(new->h_sc_pos,old_val) )    
        {
            val = new->h_sc_pos;
            XtSetArg(arglist[an],AXmNvalue,val);an++;
        }
        if ( an )
            AxXtSetValues((AXWidget)w->hScrollBar,arglist,an);
    }
    return(AOK);
}
/********************************************************************
*/                                                                   
AxUpdateRulers(w, new, ruler)
AXWidget_main w;
struct TmCrePacket *new;
struct TmGridRulerInfo *ruler;
{
    AxXmRepaintGErulers(w);
    return(AOK);
}

/********************************************************************
*/                                                                   
AxUpdateMenubar(w, new, ruler)
AXWidget_main w;
struct TmCrePacket *new;
struct TmGridRulerInfo *ruler;
{
    return(AOK);
}

/********************************************************************
*/                                                                   
AxUpdateIconId(w, icon_id)
AXWidget_main w;
int icon_id;
{
    register struct wind_struct *wp;
    struct TmCrePacket *old;
    register int winID;

    winID = AxWindowIdFromShellWidget(w);

    if ( !winExists(winID) || (winID == 0) )
        return(TMR_NOWIN);

    wp = &window[winID];
    old = &wp->wind_attr;

    /* New icon id? */
    if ( (icon_id != 0) && NEWVAL(icon_id,old->icon_id) )
    {
        old->icon_id = icon_id;
        AxSetWidgetVal((AXWidget)wp->shell,AXmNIconId, icon_id);
    }
    return(AOK);
}

/********************************************************************
function: TmNewTitle - Change the window's title                     
*/                                                                   
void TmNewTitle (wid,full_name,icon_name)                                 
int wid;                                                             
char *full_name;                                                     
char *icon_name;                                                     
{                                                                    
    register struct wind_struct *wp;                             
                                                                     
    if ( (wid < 1) || !window[wid].busy_flag )                   
        return;                                              
                                                                     
    wp = &window[wid];                                           
    if ( !streq(wp->wind_attr.title_line,full_name) ) {          
        ATMfree(wp->wind_attr.title_line);                   
        wp->title_len = strlen(full_name);                   
        wp->wind_attr.title_line=ATMmalloc(wp->title_len+1); 
        strcpy(wp->wind_attr.title_line,full_name);          
    }

    XmNewTitle(wp->shell,full_name,icon_name);                   
}                                                                    


/*************************************************************************
function: ThimCreateRuler - Add ruler to DC window if not there
*/
int ThimCreateRuler (wid)
int wid;
{
    AXWidget_main mw;
	AXWidget w;
    
    if ( window[wid].ruler )
        return(FALSE);

    mw = window[wid].topwidget;
   	w = (AXWidget)WidgetOfWindow(wid); 
    window[wid].ruler = (AXWidget_ruler)AxCreateRuler(w, NXLT("ruler"),
                                                 RWGlyphCallback, (caddr_t)wid);
                                                                           
    /* add to parent widget */                                                 
    mw->ruler = window[wid].ruler;
    window[wid].topwidget = mw;

    return(TRUE);                                                      
}                                                                          

/************************************************************************* 
function: ThimAddRuler - Add ruler to SS window if not there
*/
void ThimAddRuler (wid)
int wid;
{
    if ( !ThimCreateRuler(wid) )
        return;
    XmRestructureWindow(WidgetOfWindow(wid));
}

/************************************************************
function: ThimRemoveRuler - Remove ruler if there is one
*/
ThimRemoveRuler (wid)
int wid;
{
    if ( !window[wid].ruler )
        return(FALSE);

    AxXtDestroyWidget((AXWidget)window[wid].ruler);
    window[wid].ruler = NULL;
    XmRestructureWindow(WidgetOfWindow(wid));
}

/*************************************************************************
function: ThimCreatePlates - Add plates to SS window if not there
*/
int ThimCreatePlates (wid)
int wid;
{
    AXWidget_main mw;
	AXWidget w;
    
    if ( window[wid].plates )
        return(FALSE);

    mw = window[wid].topwidget;
	w = (AXWidget)WidgetOfWindow(wid);
    window[wid].plates = (AXWidget_plates)AxCreatePlates(w, NXLT("plates"),
                                           wid);
                                                                           
    /* add to parent widget */                                                 
    mw->plates = window[wid].plates;
    window[wid].topwidget = mw;

    return(TRUE);                                                      
}                                                                          

/************************************************************************* 
function: ThimAddPlates - Add plates to SS window if not there
*/
void ThimAddPlates (wid)
int wid;
{
    if ( !ThimCreatePlates(wid) )
        return;
    XmRestructureWindow(WidgetOfWindow(wid));
}

/************************************************************
function: ThimRemovePlates - Remove plates if there is one
*/
ThimRemovePlates (wid)
int wid;
{
    if ( !window[wid].plates )
        return(FALSE);
 
    AxXtDestroyWidget((AXWidget)window[wid].plates);
    window[wid].plates = NULL;
    XmRestructureWindow(WidgetOfWindow(wid));
}



/*********************************************************************
function: ThimCreateDebug - Add debugger to ME window if not there
*/
static ThimCreateDebug (wid)
int wid;
{
    if ( window[wid].debugger )
        return(FALSE);

    window[wid].debugger = (AXWidget_debug)ZXmCreateDebug(WidgetOfWindow(wid));

/* add to parent widget */
#if 0
        XtSetArg(args[0],XmNdebugger,window[wid].debugger);
        AxXtSetValues((AXWidget)window[wid].topwidget,args,1);
#endif
        return(TRUE);
}

/*********************************************************************
function: ThimAddDebug - Add debugger to ME window if not there
*/
void ThimAddDebug (wid)
int wid;
{
    if ( !ThimCreateDebug(wid) )
        return;
    XmRestructureWindow(WidgetOfWindow(wid));
}

/**************************************************************
function: ThimRemoveDebug - Remove debugger if there is one
*/
ThimRemoveDebug (wid)
int wid;
{
    if ( !window[wid].debugger )
        return(FALSE);

    AxXtDestroyWidget((AXWidget)window[wid].debugger);
    window[wid].debugger = NULL;
    XmRestructureWindow(WidgetOfWindow(wid));
}


/*
*   AxSetAppClip - sets the app clip in the window pointer to the
*                  specified rectangle
*   Note: Although this the corners of the rectangle here, are off by
*       1 pixel, this routine had to be written in this way,
*   so that the effect of WMsetClip() is correct.
*/
void AxSetAppClip(wid, clipRect, mills)
short wid;  /* ATM window id */
TmRect *clipRect;   /* clipping rectangle */
int mills;  /* TRUE if the coordiantes are in mills, FALSE if in pixels */
{
    struct wind_struct *wp;
    AxRectangle *rect;

    /* get the window ptr for the specified window */
    wp = &window[wid];
    /* get the appClip */
    rect = &(wp->appClip);

    /* set the app clip */
    if(mills)
        {/* specified rect is in mills, convert to pixels before use */
        rect->origin.x = X_MILLS_TO_PIXELS(clipRect->x_position);
        rect->origin.y = Y_MILLS_TO_PIXELS(clipRect->y_position);
        rect->corner.x = rect->origin.x +
                                X_MILLS_TO_PIXELS(clipRect->x_size);
        rect->corner.y = rect->origin.y +
                                Y_MILLS_TO_PIXELS(clipRect->y_size);
        }
    else
        {/* specified rect is in pixels */
        rect->origin.x = clipRect->x_position; 
        rect->origin.y = clipRect->y_position;                      
        rect->corner.x = clipRect->x_position + clipRect->x_size;   
        rect->corner.y = clipRect->y_position + clipRect->y_size;   
        }                                                           
}                                                                   


/*********************************************************************
function: PidOfCurrWindow - Return major app's pid                    
*/                                                                    
int PidOfCurrWindow ()                                                    
{                                                                     
        if ( cur_win > 0 )                                            
                return(window[cur_win].p_id);                         
        else                                                          
                return(0);                                            
}                                                                     
                                                                      
/*********************************************************************
function: PidFromATMWindow - Return pid associated with an atm window.
*/                                                                    
int PidFromATMWindow (wid)                                                
int wid;                                                              
{                                                                     
        if ( (wid <= 0) || (wid >= TM_MAXWIN) )                       
                return(-1);                                           
        return(window[wid].p_id);                                     
}                                                                     

int PidFromATMWin(ix)       
{                           
    return(window[ix].p_id);
}                           


Window XWinFromATMWin(ix)                
{                                        
        if( window[ix].xMap == (Pixmap)-1 )
                return(window[ix].xwin); 
        else                             
                return(window[ix].xMap); 
}                                        

struct wind_struct *SetWp(p)                                   
struct wind_struct *p;                     
{                                          
        if ( Wp = p )                      
        {                                  
                if( Wp->xMap == (Pixmap)-1 )
                        HostWin = Wp->xwin;
                else                       
                        HostWin = Wp->xMap;
        }                                  
        return( Wp );
}                                          

void SetWpFromAtmID(id)
int id;   /* atm window id */
{
    struct wind_struct *wp;

    if (id > 0 && id < TM_MAXWIN && window[id].busy_flag) {
        wp = &window[id];
        SetWp(wp);
    }
}


void UpdateHostWin( windowP )
struct wind_struct *windowP;
{
    if ( windowP )
       {
       if( windowP->xMap == (Pixmap)-1 )
               HostWin = windowP->xwin;
       else
               HostWin = windowP->xMap;
       }
}
/*
 * TmToolBarStatus - return current display status of tool bar
 * Returns MENUSTAT_NO_SHOW/MENUSTAT_TOGGLE_ON/MENUSTAT_TOGGLE_OFF
 */
TmToolBarStatus(wId)
int wId;  /* ATM window ID */
{
    if ( wId > 0 )
        return( AxXmToolBarStatus(WidgetOfWindow(wId)) );
    else
        return(0);
}



/*--------------------------------*/
/***********************************************
function: FrameAppFromShellWidgetId             
*/                                              
void FrameAppFromShellWidgetId (shell, width, height)
AXWidget_main shell;                                 
int width, height;                              
{                                               
    int ix;                                     
                                                
    WIDGET_PARANOID( shell, W_MAIN );
    /* set the window context */                
    for ( ix = 1; ix < TM_MAXWIN; ix++ ) {      
        if ( window[ix].shell == shell )        
            break;                              
    }                                           
    if ( ix == TM_MAXWIN )                      
        return;                                 
                                                
    FrameAppFromATMWinId(ix, width, height);    
}                                               



#if AXMS   /* {  */

/* The following func is passed to a special version of the IPC code in  */
/* FrameAppFromATMWinId() to avoid putting a series of configure messages */
/* on a tasks queue during a full-drag-mode window resize.  We rreally only */
/* want the last message                                                    */

static int check_for_dupicate_cfg( sys_event_t *old_mess, 
                                   sys_event_t *new_mess )
{
    if ( (old_mess->type != CONFIG_EVENT) || (new_mess->type != CONFIG_EVENT) )
       return( FALSE );
    if ( old_mess->wid != new_mess->wid )
       return( FALSE );
    return( TRUE );
}
#endif   /*  }  */

/****************************************************************
function: FrameAppFromATMWinId  - Send an frame request to an app
*/                                                               
void FrameAppFromATMWinId (winID, width, height)                      
int winID;  /* ATM window id */                                  
int width, height;                                               
{                                                                
    int old_width, old_height;                                   
    int minsize, maxsize;                                        
    sys_event_t sys_event;                                       
                                                                 
    if ( (winID <= 0) || (winID >= TM_MAXWIN) )                  
        return;  /* bad ATM window id */                         
                                                                 
    SetWp(&window[winID]);                                       
    sys_event.wid = winID;  /* set the ATM window id */          
    /* get the current dimensions of the window */               
    old_width = X_MILLS_TO_PIXELS(Wp->wind_attr.x_size);         
    old_height = Y_MILLS_TO_PIXELS(Wp->wind_attr.y_size);        
                                                                 
    if ( width != old_width || height != old_height )            
    {                                                            
        /* new width must be in the legal range for the window */
#if 0    /*  {  */
        /* The min/max checks below are not valid since the x_min_size is for */
        /* the main window, not the work window which comes through here.     */
        /* In addition, this routine is current called AFTER we have told     */
        /* the window manager (on both X and Windows) how big to make the     */
        /* window, so I do not see how we can adjust the size sent to the     */
        /* application. - jon                                                 */
        if ( width != old_width )                                
        {                                                              
            if ( Wp->wind_attr.x_min_size > 0 )                        
            {                                                          
                minsize = X_MILLS_TO_PIXELS(Wp->wind_attr.x_min_size); 
                width = MAX(width,minsize);                            
            }                                                          
            if ( Wp->wind_attr.x_max_size > 0 )                        
            {                                                          
                maxsize = X_MILLS_TO_PIXELS(Wp->wind_attr.x_max_size); 
                width = MIN(width,maxsize);                            
            }                                                          
        }                                                              
                                                                       
        /* new height must be in the legal range for the window */     
        if ( height != old_height )                                    
        {                                                              
            if ( Wp->wind_attr.y_min_size > 0 )                        
            {                                                          
                minsize = Y_MILLS_TO_PIXELS(Wp->wind_attr.y_min_size); 
                height = MAX(height,minsize);                          
            }                                                          
            if ( Wp->wind_attr.y_max_size > 0 )                        
            {                                                          
                maxsize = X_MILLS_TO_PIXELS(Wp->wind_attr.y_max_size); 
                height = MIN(height,maxsize);                                 
            }                                                                 
        }                                                                     
#endif      /*  } if zero */
                                                                              
        /* if adjusted size request is same as current size, nothing to do */ 
        if ( width == old_width && height == old_height )                     
            return;                                                           
                                                                              
        Wp->wind_attr.x_size = X_PIXELS_TO_MILLS(width);                      
        Wp->wind_attr.y_size = Y_PIXELS_TO_MILLS(height);                     
        Wp->inner.origin.x = 0;                                               
        Wp->inner.origin.y = 0;                                               
        Wp->inner.corner.x = width;                                           
        Wp->inner.corner.y = height;                                          
        Wp->layer->rect = Wp->outer = Wp->inner;                              
        Wp->appClip = Wp->frClip = Wp->layer->rect;                           
        delClipList(Wp->layer,TRUE);                                          
        Wp->layer->clp = NULL;                                                
        setclip(Wp->layer,&(Wp->layer->rect));                                
        SetCurwinFromWp( Wp );
                                                                              
        /* notify window of a FRAME */                                        
        sys_event.type = CONFIG_EVENT;                                        
        if ( Wp->ap_id == APGE ) {                                            
            sys_event.ev.config.wid = Wp->wind_attr.x_size;       
            sys_event.ev.config.hyt = Wp->wind_attr.y_size;       
        }                                                         
        else {                                                    
            sys_event.ev.config.wid = width;                      
            sys_event.ev.config.hyt = height;                     
        }                                                         
#if AXMS
        AxSendUniqueMes( Wp->p_id, &sys_event, sizeof(sys_event), APSYS, 
                                   check_for_dupicate_cfg  );
#else
        AxSendMes(Wp->p_id, &sys_event, sizeof(sys_event), APSYS);
#endif
    }                                                             
}                                                                 
/*************************************************************************
function: FrameAppFromXWinId
*/
void FrameAppFromXWinId (xwin, width, height)
Drawable xwin;
int width, height;
{
    int ix;

    /* set the window context */
    for ( ix = 1; ix < TM_MAXWIN; ix++ ) {
        if ( (window[ix].xwin == xwin) || (window[ix].xMap == xwin) )
            break;
    }
    if ( ix == TM_MAXWIN )
        return;
    
    FrameAppFromATMWinId(ix, width, height);
}



void SetCurwinFromWp ( windowP )                 
struct wind_struct *windowP;
{                                  
    if ( !windowP )                     
        return;                    
    if ( cur_win == windowP->window_id )
        return;                    
    make_curwin(windowP->window_id);    
}                                  
/*------------------*/

/*************************************************************************
function: CmdStatusFromAtmApp - Get whether to dim/nodisplay/check menu item
*/
int CmdStatusFromAtmApp (w,name,uid,toggle_state_too,cmd_code)
AXWidget_main w;                                 
char *name;
int uid;
int toggle_state_too,cmd_code;
{
    int retval;
    Window xwin;
    int appid, pid, atm_win;
    int current_pid;

    if ( w->workWindow && w->workWindow->window )
    {
        xwin = w->workWindow->window;
        atm_win = ATMWindowFromXWindow(xwin);
        pid = PidFromATMWin(atm_win);
        appid = AppIdFromATMWin(atm_win);
    }
    else if ( AxIsGraphicsTask(w->taskOwner))
    {
        pid  = w->taskOwner;
        appid = APGE;
    }
    else
        pid  = -1;

    retval = 0;
    if ( pid != -1 )
    {
        current_pid = THIMpid;
        VfyContext(pid);
        switch ( appid ) {
        case APUCM:
            retval = MECmdStatus(name,uid,toggle_state_too,cmd_code);
            break;
        case APSS:
            retval = SSCmdStatus(name,uid,toggle_state_too,cmd_code, atm_win);
            break;
        case APEQN:
            retval = EQCmdStatus(name,uid,toggle_state_too,cmd_code);
        case APDC:
        case APDCSG:
            retval = DCCmdStatus(name,uid,toggle_state_too,cmd_code);
            break;
        case APHTML: 
            retval = HTMLCmdStatus(name,uid,toggle_state_too,cmd_code);
            break;
        case APGE:
        case APBG:
        case APPIXED:
            retval = GECmdStatus(name,uid,toggle_state_too,cmd_code);
            break;
        default:
            retval = 0;
            break;
        }
        VfyContext( current_pid );   /* restore original state */
    }
    return(retval);
}

/*************************************************************************
function: ATMWindowFromXWindow - Return FALSE or ATM window id
*/
int ATMWindowFromXWindow (win)
Window win;
{
    int ix;

    for ( ix = 0; ix < TM_MAXWIN; ix++ )
        if(window[ix].busy_flag )
            if ( window[ix].xwin == win || window[ix].xMap == win )
                return(ix);

    return(FALSE);
}

/***********************************************************************
function: ATMWindowFromShellWindow - Return the ATM window associated
with a shell window.  Return -1 on failure.
*/
int
ATMWindowFromShellWindow(win)
Window win;
{
    register int ix;

    for (ix = 0; ix < TM_MAXWIN; ix++) {
        if (window[ix].busy_flag) {
            if (window[ix].shell)
                if (AxXtWindow((AXWidget)window[ix].shell) == win)
                    return(ix);
    }
    }
    return(-1);
}


Window HostWinFromCurWin()
{
    if ( cur_win > 0 )
    {
        if( window[cur_win].xMap == (Pixmap)-1 )
            return(window[cur_win].xwin);
        else
            return(window[cur_win].xMap);
    }
    else
        return(0);
}


int AppIdFromATMWin(ix)
{
    return(window[ix].ap_id);
}

#if 0

ClearWp()
{
    Wp = NULL;
}

ThimSetHostWinFromWp ()
{
    if(Wp->xMap == -1)
        HostWin = Wp->xwin;
    else
        HostWin = Wp->xMap;
}
#endif

/************************************************************************/
int
AxGetHScrollMax(wd)
long wd;
{
    int maxx;
    Arg arglist[10];
    AXWidget_main w;

    w = (AXWidget_main)wd;
    WIDGET_PARANOID( w, W_MAIN );
    if (w->hScrollBar) {
        XtSetArg(arglist[0], XXmNvisibleItemCount, &maxx);
        AxXtGetValues((AXWidget)w->hScrollBar, arglist, 1);
    }
    return(maxx);
}


void AxSetHScrollMax(w, maxx, x_scroll_origin)
AXWidget_main w;
int maxx;
int x_scroll_origin;
{
    WIDGET_PARANOID( w, W_MAIN );
    if (w->hScrollBar)
        AxSetWidgetVal((AXWidget)w->hScrollBar, AXmNmaximum, maxx);
}

void AxSetVScrollMax(w, maxy, y_scroll_origin)
AXWidget_main w;
int maxy;
int y_scroll_origin;
{
    WIDGET_PARANOID( w, W_MAIN );
    if (w->vScrollBar)
        AxSetWidgetVal((AXWidget)w->vScrollBar, AXmNmaximum, maxy);
}


/*************************************************************************
function: WidgetOfPalette - Return palette widget
*/
AXWidget_palette WidgetOfPalette (x)
int x;
{
    WIDGET_PARANOID( window[x].palette, W_PALETTE );

    return(window[x].palette);
}

/****************************************************************************/
void AxTogglePalette(w)
AXWidget_main w;
{
    if ( w )
        AxXmTogglePalette(w);
}

void AxToggleColorpal(w)
AXWidget_main w;
{
    if ( w )
        AxXmToggleColorpal(w);
}

void AxReloadMenuBar(w)
long w;
{
    if ( w )
        CreateOrChangeMenuBar((AXWidget_main)w);
}

/****************************************************************************/
long
AxGetScratchMap(pmap)
Drawable pmap;
{
    Drawable old_drw;
    int x_off, y_off;

	old_drw = ScratchMap;
	ScratchMap = pmap;
    return((long)old_drw);
}

/****************************************************************************/
long
AxLoadTempPixMap(w, pmap)
long w;
Drawable pmap;
{
    Drawable old_drw;
    int x_off, y_off;

	old_drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
	AxSetDrawableOfWidget((AXWidget_main)w, pmap);
    return((long)old_drw);
}

/****************************************************************************/
long
AxLoadScratchMap(w)
long w;
{
    Drawable old_drw;
    int x_off, y_off;

    if ( !ScratchMap || TmAmSE )
        old_drw = (Drawable)NULL;
    else
    {
        old_drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
        AxSetDrawableOfWidget((AXWidget_main)w, ScratchMap);
    }
    return((long)old_drw);
}

/****************************************************************************/

/* these two are used as brackets around scratchmap use. */
int
ChangeHostWinToScratchMap(w)
AXWidget_main w;
{
    if (ScratchMap)
        temporarySaveDrawable = (Drawable)AxLoadScratchMap((long)w);
    return (ScratchMap != (Pixmap) NULL);
}

/****************************************************************************/
int
RestoreHostWinFromScratchMap(w)
AXWidget_main w;
{
    Drawable xwin;
    if (ScratchMap && temporarySaveDrawable)
        xwin = AxSetDrawableOfWidget(w, temporarySaveDrawable);
    return (ScratchMap != (Pixmap) NULL);
}

/****************************************************************************/
void DisplayFromScratchMap(w, x, y, wid, ht)
AXWidget_main w;
int x, y, wid, ht;
{
    int px, py, pwid, pht;
    int x_off, y_off;
    Drawable xwin;;

    conv_i_p32(&x, &y, &px, &py, MILLS_TO_PIXEL);
    conv_i_p32(&wid, &ht, &pwid, &pht, MILLS_TO_PIXEL);

    /* get the drawble from widget */
    xwin = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);

    XSetGraphicsExposures(Dpy, Gc1, TRUE);
    XSetClipMask(Dpy, Gc1, None);
    XSetFunction(Dpy, Gc1, GXcopy);
    XSetPlaneMask(Dpy, Gc1, PlaneMask);
    XCopyArea(Dpy, ScratchMap, xwin, Gc1, px, py,
              (unsigned int) pwid, (unsigned int) pht,
              px, py);
    XSetGraphicsExposures(Dpy, Gc1, FALSE);
}

/***************************************************************************/


TmPoint32 pix_pnt[] = {
{0,9},{9,8},{5,4},{7,7},{3,4},{5,7},{3,0},{8,0},{4,2},{0,1},
{2,7},{4,7},{0,6},{9,6},{4,4},{5,0},{3,7},{8,6},{1,7},{5,9},
{0,3},{7,6},{1,8},{6,8},{5,6},{3,6},{8,7},{1,6},{6,6},{9,9},
{2,6},{9,5},{4,9},{0,8},{4,0},{6,4},{2,5},{7,9},{3,8},{2,4},
{7,5},{3,5},{9,3},{5,2},{1,2},{1,4},{4,5},{7,4},{8,4},{2,1},
{4,1},{3,9},{3,2},{8,2},{7,3},{5,8},{6,5},{3,1},{0,2},{2,0},
{4,6},{0,5},{7,2},{2,2},{9,1},{7,1},{5,3},{7,8},{5,1},{2,8},
{9,2},{8,8},{3,3},{8,3},{1,3},{4,8},{0,7},{9,7},{8,1},{1,1},
{5,5},{6,1},{0,0},{2,3},{9,0},{6,9},{2,9},{7,0},{8,9},{8,5},
{6,3},{1,5},{0,4},{6,2},{9,4},{1,9},{6,7},{1,0},{4,3},{6,0}
};

TmPoint32 pix_pnt5x5[] = {
{2,2},{0,4},{3,0},{4,3},{4,4},
{0,1},{4,1},{1,3},{1,0},{2,4},
{3,2},{1,4},{0,2},{4,0},{0,3},
{0,0},{3,4},{2,1},{4,2},{2,3},
{1,1},{3,3},{2,0},{3,1},{1,2}
};

TmPoint32 pix_pnt5x10[] = {
{2,4},{4,8},{4,0},{0,9},{0,1},
{4,6},{1,3},{2,9},{3,1},{0,6},
{2,2},{3,5},{1,7},{4,9},{4,3},
{0,7},{0,0},{3,3},{1,8},{2,5},
{1,9},{4,2},{0,4},{4,7},{1,1},
{2,6},{3,9},{0,3},{2,0},{2,7},
{0,8},{4,4},{3,7},{1,0},{1,5},
{4,1},{0,5},{4,5},{1,2},{3,4},
{1,6},{0,2},{3,8},{2,8},{3,0},
{3,6},{1,4},{2,3},{3,2},{2,1}
};

TmPoint32 pix_pnt10x5[] = {
{4,2},{5,3},{0,4},{8,0},{3,1},{9,4},{0,2},{5,0},{7,2},{2,4},
{0,1},{4,3},{2,0},{8,2},{1,3},{6,1},{2,2},{6,4},{3,0},{7,3},
{9,1},{6,2},{2,3},{3,4},{6,0},{1,4},{0,0},{1,1},{9,2},{3,3},
{8,4},{2,1},{7,0},{4,1},{0,3},{4,4},{9,0},{3,2},{5,4},{5,1},
{9,3},{8,1},{8,3},{7,4},{7,1},{6,3},{5,2},{4,0},{1,0},{1,2}
};

static int
get_ctime(curr_time)
struct timeval *curr_time;
{
    int stat;
    stat = gettimeofday(curr_time, (void *)0);
    if ( stat != -1 )
        stat = AOK;
    else
    {   
        stat = ErrnoErr();
        curr_time->tv_sec = curr_time->tv_usec = 0;
    }
    return(stat);
}

static int
time_remaining(t0, t1, interval)
struct timeval *t0;
struct timeval *t1;
long interval;
{
    long d_tot;
    d_tot = (t1->tv_sec - t0->tv_sec) * 1000000 + t1->tv_usec - t0->tv_usec;
    return((d_tot < interval) ? TRUE : FALSE);
}

static int
churn_interval(orig_time, interval)
struct timeval *orig_time;
long interval;
{
    struct timeval curr_time;
    int val, i;

    val = 0;
    if ( get_ctime(&curr_time) == AOK )
    {
        while(time_remaining(orig_time, &curr_time, interval))
        {
            for ( i=0; i<10000; i++ );
                val++;

            if ( get_ctime(&curr_time) != AOK )
                break;
        }
    }
    return(val);
}

/****************************************************************************
 * styles - copy
 *        - fade
 *        - wipe
 *        - slide
 *        - spread
 *        - encroach
 */
void
AxSlideshow(w, x1,y1, x2,y2, style, throttle)
long w;
int x1,y1, x2,y2, style, throttle;
{
    int i,j, k, pwid,phyt, x_off,y_off, x_ix,y_ix, x,y;
    int cwid, chyt, s_x, s_y, dst_x, dst_y;
    int sz, n_wids, n_hyts, step, count;
    double fwid, fhyt, fsz;
    short *indices;
    unsigned int wid,hyt;
    Drawable drw;
    TmPoint32 pnts[100];
    struct timeval orig_time, curr_time;
    int timed;
    long interval;

    /* copies from ScratchMap to current drawable */
    if ( !ScratchMap ) /* no scratch map, nothing to do */
        return;
    drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
    if ( drw == ScratchMap ) /* same drawable, no point in doing anything */
        return;
    
    /* convert units */
    conv_i_p32(&x1, &y1, &x1, &y1, MILLS_TO_PIXEL);
    conv_i_p32(&x2, &y2, &x2, &y2, MILLS_TO_PIXEL);
    wid = x2 - x1 + 1;
    hyt = y2 - y1 + 1;

    /* copy from the ScratchMap to the drawable */
    XSetGraphicsExposures(Dpy, Gc1, TRUE);
    XSetClipMask(Dpy, Gc1, None);
    XSetFunction(Dpy, Gc1, GXcopy);
    XSetPlaneMask(Dpy, Gc1, PlaneMask);

    /* scaling control to improve performance for large images */
    if ( wid < 200 || hyt < 200 )
        step = 1;
    else if ( wid < 500 || hyt < 500 )
        step = 2;
    else 
        step = 3;

    /* speed control - set by user */
    if ( throttle <= 0 )
        timed = FALSE;
    else
        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;

    /* do it */
    if ( style ) switch ( style )
    {
        /* fade - pixilate (40x40 l=>r, t=>b for now) */
        case 1:
            interval = timed ? 500.0 * throttle : 0;
            fwid = (double)wid / 40.0;
            fhyt = (double)hyt / 40.0;
            pwid = ceil(fwid);
            phyt = ceil(fhyt);
            for ( i=0; i<10; i++ )
            {
                for ( j=0; j<10; j++ )
                {
                    /* get the index */
                    x_ix = j*10 + i;

                    /* quad1 */
                    x = x1 + (double)pix_pnt[x_ix].x * fwid;
                    y = y1 + (double)pix_pnt[x_ix].y * fhyt;
                    s_x = x1 + (double)(pix_pnt[x_ix].x + 20) * fwid; 
                    s_y = y1 + (double)(pix_pnt[x_ix].y + 20) * fhyt; 

                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y,
                                   pwid, phyt, x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x, y,
                                   pwid, phyt,s_x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x, s_y,
                                   pwid, phyt, x, s_y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1,s_x,s_y,
                                   pwid, phyt, s_x, s_y);

                    /* quad2 */
                    x = x1 + (double)(pix_pnt[x_ix].x + 10) * fwid;
                    y = y1 + (double)pix_pnt[x_ix].y * fhyt;
                    s_x = x1 + (double)(pix_pnt[x_ix].x + 30) * fwid; 
                    s_y = y1 + (double)(pix_pnt[x_ix].y + 20) * fhyt; 
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y,
                                   pwid, phyt, x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x,y,
                                   pwid, phyt, s_x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x, s_y,
                                   pwid, phyt, x, s_y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1,s_x,s_y,
                                   pwid, phyt, s_x, s_y);

                    /* quad3 */
                    x = x1 + (double)pix_pnt[x_ix].x * fwid;
                    y = y1 + (double)(pix_pnt[x_ix].y + 10) * fhyt;
                    s_x = x1 + (double)(pix_pnt[x_ix].x + 20) * fwid; 
                    s_y = y1 + (double)(pix_pnt[x_ix].y + 30) * fhyt; 
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y,
                                   pwid, phyt, x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x,y,
                                   pwid, phyt, s_x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x, s_y,
                                   pwid, phyt, x, s_y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1,s_x,s_y,
                                   pwid, phyt, s_x, s_y);

                    /* quad4 */
                    x = x1 + (double)(pix_pnt[x_ix].x + 10) * fwid;
                    y = y1 + (double)(pix_pnt[x_ix].y + 10) * fhyt;
                    s_x = x1 + (double)(pix_pnt[x_ix].x + 30) * fwid; 
                    s_y = y1 + (double)(pix_pnt[x_ix].y + 30) * fhyt; 
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y,
                                   pwid, phyt, x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x,y,
                                   pwid, phyt, s_x,y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x, s_y,
                                   pwid, phyt, x, s_y);
                    XCopyArea(Dpy, ScratchMap, drw, Gc1,s_x,s_y,
                                   pwid, phyt, s_x, s_y);

                    if ( timed )
                    {
                        churn_interval(&orig_time, interval);
                        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                        XSync(Dpy, FALSE);
                    }
                }
            }
        break;

    /* wipe (l=>r, overwrite) */
    case 2:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y1, pwid, hyt, x1,y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide (l=>r, overwrite) */
    case 3:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y1, pwid, hyt, x1, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* wipe (r=>l, overwrite) */
    /* wipe left */
    case 4:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y1, pwid, hyt, x, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide (r=>l, overwrite) */
    /* slide left */
    case 5:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, pwid, hyt, x, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* wipe (t=>b, overwrite) */
    /* wipe down */
    case 6:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y1, wid, phyt, x1, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide (t=>b, overwrite) */
    /* slide down */
    case 7:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <= count; i++ )
        {
            phyt = hyt * i / (float)count;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y, wid, phyt, x1, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* wipe (b=>t, overwrite) */
    /* wipe up */
    case 8:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y, wid, phyt, x1, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide (b=>t, overwrite) */
    /* slide up */
    case 9:
        x = x1;
        pwid = wid;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y1, wid, phyt, x1, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide diagonal l->r */
    /* slide right up */
    case 10:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, phyt, x1, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide diagonal r->l */
    /* slide left down */
    case 11:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, pwid, phyt, x, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide diagonal t->b */
    /* slide left up */
    case 12:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, pwid, phyt, x, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide diagonal b->t */
    case 13:
        /* slide right down */
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = hyt * (i+1.0) / (float)count;
            pwid = wid * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y, pwid, phyt, x1, y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* blinds - horizontal (right) */
    case 14:
        fwid = wid/10.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = (double)(fwid * (double)(i+1))/(double)count;
            for ( j=0; j<10; j++ )
            {
                x = x1 + j*fwid;
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* blinds - vertical */
    case 15:
        fhyt = hyt/10.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = fhyt*(i+1)/(float)count;
            for ( j=0; j<10; j++ )
            {
                y = y1 + j*fhyt;
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - right down */
    case 16:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = y1 + i*fhyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = x1 + j*fwid;
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - left up */
    case 17:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = y1 + hyt - i*fhyt - phyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = x1 + wid - j*fwid - pwid;
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* spread out */
    case 18:
        interval = timed ? 500.0 * throttle : 0;
        for ( i=0; i<100; i++ ) 
        {
            y = y1 + hyt/2.0 - (i+1.0)*hyt/200.0;
            x = x1 + wid/2.0 - (i+1.0)*wid/200.0;
            pwid = wid * (i+1)/100.0 -1.0;
            phyt = hyt*(i+1)/100.0 -1.0;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y, pwid, phyt, x, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* split - vertical in */
    case 19:
        count = 60.0/(double)step;
        fhyt = (double)hyt/(double)(2.0*count);
        phyt = ceil(fhyt);
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( j=0; j<count; j++ )
        {
            y = y1 + j*fhyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);

            y = y1 + hyt - j*fhyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* split - vertical out */
    case 20:
        count = 60.0/(double)step;
        fhyt = (double)hyt/(double)(2.0*count);
        phyt = ceil(fhyt);
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( j=0; j<count; j++ )
        {
            y = y1 + hyt/2.0 - j*fhyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);

            y = y1 + hyt/2.0 + j*fhyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* split - horizontal in */
    case 21:
        count = 60.0/(double)step;
        fwid = (double)wid/(double)(2.0*count);
        pwid = ceil(fwid);
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( j=0; j<count; j++ )
        {
            x = x1 + j*fwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);

            x = x1 + wid - j*fwid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* split - horizontal out */
    case 22:
        count = 60.0/(double)step;
        fwid = (double)wid/(double)(2.0*count);
        pwid = ceil(fwid);
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( j=0; j<count; j++ )
        {
            x = x1 + wid/2.0 - j*fwid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);

            x = x1 + wid/2.0 + j*fwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    case 23:
        /* implode */
        /* 4 Quad */
        cwid = wid/2.0;
        chyt = hyt/2.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = chyt * (i+1.0) / (float)count;
            pwid = cwid * (i+1.0) / (float)count;
            s_x = x1;
            s_y = y1;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y, pwid, phyt, s_x, s_y);

            s_x = x1 + cwid;
            s_y = y1;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x, y, pwid, phyt, x, s_y);

            s_x = x1;
            s_y = y1 + chyt;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, s_y, pwid, phyt, s_x, y);

            s_x = x1 + cwid;
            s_y = y1 + chyt;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x, s_y, pwid, phyt, x, y);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* meltdown */
    case 24:
        count = 10*(float)step;
        cwid = wid/10.0;
        chyt = hyt/2.0;
        k = x1;
        
        indices = (short *)malloc(wid*sizeof(short));
        for ( i=0; i<wid; i++ )
            indices[i] = y1;

        /* infinite for loop */
        interval = timed ? 5000.0 * throttle / count : 0;
        for ( j=0; j!=(-1); j++ )
        {
            /* set the width of the patch */
            pwid = 20 + RAND_FUNC(count);

            /* set the x position of the patch */
            s_x = RAND_FUNC(x1 + wid + count) - count;
            if ( s_x < x1 )
                s_x = x1;
            else if ( (s_x + pwid) > (x1 + wid) )
                s_x = x1 + wid - pwid;

            /* set the y position of the patch */
            s_y = y1 + hyt;
            for ( i=s_x; i<(s_x + pwid); i++ )
                s_y = MIN(s_y, indices[i-x1]);
            if ( s_y == (y1 + hyt) )
                continue;

            /* set the height of the patch */
            phyt = RAND_FUNC(s_y/10 + count);

            /* set the height of the smudge */
            sz = RAND_FUNC(MAX(s_y + 10, chyt));
            if ( (s_y + phyt + sz) > (y1 + hyt))
                continue;

            /* smudge the screen */
            XCopyArea(Dpy, drw, drw, Gc1,
                      s_x, s_y, pwid, sz,
                      s_x, s_y+phyt);

            /* copy more to the screen */
            XCopyArea(Dpy, ScratchMap, drw, Gc1,
                      s_x, s_y, pwid, phyt,
                      s_x, s_y);

            s_y += phyt;
            for ( i=s_x; i<(s_x+pwid); i++ )
            {
                if ((indices[i-x1] < (y1+hyt - 10)) && (s_y >= (y1+hyt - 10)))
                    k++;
                indices[i-x1] = MAX(indices[i-x1], s_y);
            }

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }

            /* terminating condition */
            if ( k >= (x1 + wid - cwid))
                j = -2;
        }
    break;

    /* blinds - horizontal (left) */
    case 25:
        fwid = wid/10.0;
        count = 30/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = (double)(fwid * (double)(i+1))/(float)count;
            for ( j=0; j<10; j++ )
            {
                x = x1 + wid - j*fwid - pwid;
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* blinds - vertical */
    case 26:
        fhyt = hyt/10.0;
        count = 30/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            phyt = fhyt*(i+1)/(float)count;
            for ( j=0; j<10; j++ )
            {
                y = y1 + hyt - j*fhyt - phyt;
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* wipe (l=>r, overwrite) */
    case 27:
        x = x1;
        y = y1;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            phyt = hyt * (i+1.0) / (float)count;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y1, pwid, phyt, x1,y1);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* wipe (r=>l, overwrite) */
    /* wipe left */
    case 28:
        y = y1;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            phyt = hyt * (i+1.0) / (float)count;
            x = x1 + wid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid, phyt, x, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* slide (l=>r, overwrite) */
    case 29:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            phyt = hyt * (i+1.0) / (float)count;
            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y, pwid, phyt, x1, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* wipe (r=>l, overwrite) */
    /* wipe left */
    case 30:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = wid * (i+1.0) / (float)count;
            phyt = hyt * (i+1.0) / (float)count;
            y = y1 + hyt - phyt;
            x = x1 + wid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid, phyt, x, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - left down */
    case 31:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = y1 + i*fhyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = x1 + wid - j*fwid - pwid;
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - right up */
    case 32:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = y1 + hyt - i*fhyt - phyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = x1 + j*fwid;
                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - left */
    case 33:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        phyt = ceil(fhyt);
        interval = timed ? 2500.0 * throttle : 0;
        for ( k=0; k<20; k++ )
        {
            for ( i=0; i<n_hyts; i++ )
            {
                y = y1 + fhyt*(i);
                for ( j=0; j<=n_wids; j++ )
                {
                    if ( (i+j)%2 == 0 )
                        continue;

                    pwid = (fwid*(k+1))/10;
                    x = x1 + wid + fwid - j*fwid - pwid;
                    if ( x <= x1 )
                    {
                        pwid -= x1 - x;
                        x = x1;
                    }
                    if ( (x + pwid) > (x1 + wid) )
                        pwid -= (x+pwid) - (x1+wid);
                    if ( pwid <= 0 )
                        continue;

                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - right */
    case 34:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        phyt = ceil(fhyt);
        interval = timed ? 2500.0 * throttle : 0;
        for ( k=0; k<20; k++ )
        {
            for ( i=0; i<n_hyts; i++ )
            {
                y = y1 + i*fhyt;
                for ( j=0; j<=n_wids; j++ )
                {
                    if ((i+j)%2 == 0 )
                        continue;

                    pwid = (fwid*(k+1))/10;
                    x = x1 + j*fwid - fwid;
                    if ( x <= x1 )
                    {
                        pwid -= x1 - x;
                        x = x1;
                    }
                    if ( (x + pwid) > (x1 + wid) )
                        pwid -= (x+pwid) - (x1+wid);
                    if ( pwid <= 0 )
                        continue;

                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - down */
    case 35:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        pwid = ceil(fwid);
        interval = timed ? 2500.0 * throttle : 0;
        for ( k=0; k<20; k++ )
        {
            for ( j=0; j<n_wids; j++ )
            {
                x = x1 + j*fwid;
                for ( i=0; i<=n_hyts; i++ )
                {
                    if ((i+j)%2 == 0 )
                        continue;

                    phyt = fhyt*(k+1)/10.0;
                    y = y1 + i*fhyt - fhyt;
                    if ( y <= y1 )
                    {
                        phyt -= y1 - y;
                        y = y1;
                    }
                    if ( (y + phyt) > (y1 + hyt) )
                        phyt -= (y+phyt) - (y1+hyt);
                    if ( phyt <= 0 )
                        continue;

                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* checker - up */
    case 36:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        pwid = ceil(fwid);
        interval = timed ? 2500.0 * throttle : 0;
        for ( k=0; k<20; k++ )
        {
            for ( j=0; j<n_wids; j++ )
            {
                x = x1 + j*fwid;
                for ( i=0; i<=n_hyts; i++ )
                {
                    if ((i+j)%2 == 0 )
                        continue;

                    phyt = fhyt*(k+1)/10.0;
                    y = y1 + hyt + fhyt - i*fhyt - phyt;
                    if ( y <= y1 )
                    {
                        phyt -= y1 - y;
                        y = y1;
                    }
                    if ( (y + phyt) > (y1 + hyt) )
                        phyt -= (y+phyt) - (y1+hyt);
                    if ( phyt <= 0 )
                        continue;

                    XCopyArea(Dpy, ScratchMap, drw, Gc1, x,y, pwid,phyt, x,y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - left */
    case 37:
        count = 60/(float)step;
        sz = (double)wid/(float)count + 0.5;
        n_wids = ceil((double)((double)wid/(double)sz));
        fwid = (double)wid / (double)n_wids;
        count = wid / fwid;
        s_x = (double)x1 + fwid;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = fwid * (i+1);
            cwid = wid - pwid;
            x = x1 + cwid;
            if ( x > x1)
            {
                XCopyArea(Dpy, drw, drw, Gc1, s_x, y1, cwid, hyt, x1, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - right */
    case 38:
        count = 60/(float)step;
        sz = (double)wid/(float)count + 0.5;
        n_wids = ceil((double)((double)wid/(double)sz));
        fwid = (double)wid/n_wids;
        count = wid / fwid;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            pwid = fwid * (i+1);
            cwid = wid - pwid;
            s_x = x1 + pwid - fwid;
            x = s_x + fwid;
            if ( x < (x1+wid))
            {
                XCopyArea(Dpy, drw, drw, Gc1, s_x, y1, cwid, hyt, x, y1);
                XCopyArea(Dpy,ScratchMap, drw, Gc1, x1, y1, pwid, hyt, x1, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - down */
    case 39:
        count = 60/(float)step;
        sz = (double)hyt/(float)count + 0.5;
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fhyt = (double)hyt/n_hyts;
        count = hyt / fhyt;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = fhyt * (i+1);
            chyt = hyt - phyt;
            s_y = y1 + fhyt*i;
            y = s_y + fhyt;
            if ( y < (y1+hyt))
            {
                XCopyArea(Dpy, drw, drw, Gc1, x1, s_y, wid, chyt, x1, y);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y1, wid, phyt, x1, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - up */
    case 40:
        count = 60/(float)step;
        sz = (double)hyt/(float)count + 0.5;
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fhyt = (double)hyt/n_hyts;
        count = hyt / fhyt;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = fhyt * (i+1);
            chyt = hyt - phyt;
            y = y1 + hyt - phyt;
            s_y = y1 + fhyt;
            if ( s_y < (y1+hyt))
            {
                XCopyArea(Dpy, drw, drw, Gc1, x1, s_y, wid, chyt, x1, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1,y, wid, phyt,x1, y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    case 41:
        /* explode */
        /* 4 Quad */
        fwid = (double)wid/2.0;
        fhyt = (double)hyt/2.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            phyt = fhyt * (i+1.0) / (float)count;
            pwid = fwid * (i+1.0) / (float)count;

            s_x = x1;
            s_y = y1;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x, s_y, pwid, phyt, x, y);

            s_x = x1 + fwid;
            s_y = y1;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, s_y, pwid, phyt, s_x, y);

            s_x = x1;
            s_y = y1 + fhyt;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, s_x, y, pwid, phyt, x, s_y);

            s_x = x1 + fwid;
            s_y = y1+ fhyt;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y, pwid, phyt, s_x, s_y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - right up */
    case 42:
        count = 60/(float)step;
        sz = hyt/(float)count + 0.5;
        n_hyts = (double)hyt / (double)sz;
        fhyt = (double)hyt/n_hyts;
        sz = wid/(float)count + 0.5;
        n_wids = (double)wid / (double)sz;
        fwid = (double)wid/n_wids;
        s_y = y1 + fhyt;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = fhyt * (i+1);
            pwid = fwid * (i+1);
            chyt = hyt - phyt;
            cwid = wid - pwid;
            y = y1 + chyt;
            s_x = x1 + fwid*i;
            x = s_x + fwid;
            if ( x < (x1+wid) && ( y < (y1+hyt)))
            {
                XCopyArea(Dpy, drw, drw, Gc1, s_x, s_y, cwid, chyt, x, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, pwid,chyt, x1, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - left down */
    case 43:
        count = 60/(float)step;

        sz = hyt/(float)count + 0.5;
        n_hyts = (double)hyt / (double)sz;
        fhyt = (double)hyt/n_hyts;

        sz = wid/(float)count + 0.5;
        n_wids = (double)wid / (double)sz;
        fwid = (double)wid/n_wids;

        s_x = x1 + fwid;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i<count; i++ )
        {
            phyt = fhyt * (i+1);
            pwid = fwid * (i+1);
            chyt = hyt - phyt;
            cwid = wid - pwid;
            s_y = y1 + fhyt*i;
            x = x1 + cwid;
            y = y1 + phyt;
            if ( y < (y1+hyt) && x > x1)
            {
                XCopyArea(Dpy, drw, drw, Gc1, s_x, s_y, cwid, chyt, x1, y);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, wid, phyt, x1, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, hyt, x, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - left up */
    case 44:
        count = 60/(float)step;
        sz = hyt/(float)count + 0.5;
        n_hyts = (double)hyt / (double)sz;
        fhyt = (double)hyt/n_hyts;
        sz = wid/(float)count + 0.5;
        n_wids = (double)wid / (double)sz;
        fwid = (double)wid/n_wids;
        s_x = x1 + fwid;
        s_y = y1 + fhyt;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = fhyt * (i+1);
            pwid = fwid * (i+1);
            chyt = hyt - phyt;
            cwid = wid - pwid;
            x = x1 + cwid;
            y = y1 + chyt;
            if ( y > y1 && x > x1)
            {
                XCopyArea(Dpy, drw, drw, Gc1, s_x, s_y, cwid, chyt, x1, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x, y1, pwid, chyt, x, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1,y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* uncover - right down */
    case 45:
        count = 60/(float)step;
        sz = hyt/(float)count + 0.5;
        n_hyts = (double)hyt / (double)sz;
        fhyt = (double)hyt/n_hyts;
        sz = wid/(float)count + 0.5;
        n_wids = (double)wid / (double)sz;
        fwid = (double)wid/n_wids;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
            phyt = fhyt * (i+1);
            pwid = fwid * (i+1);
            s_y = y1 + fhyt*i;
            s_x = x1 + fwid*i;
            chyt = hyt - phyt;
            cwid = wid - pwid;
            x = s_x + fwid;
            y = s_y + fhyt;
            if ( y < (y1+hyt) && x < (x1+wid))
            {
                XCopyArea(Dpy, drw, drw, Gc1, s_x, s_y, cwid, chyt, x, y);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, wid, phyt, x1, y1);
                XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, pwid, hyt, x1, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    /* spread in */
    case 46:
        /* spread in */
        chyt = (double)hyt/3.0;
        cwid = (double)wid/2.0;
        count = 60/(float)step;
        fhyt = (double)hyt/(double)(2*count);
        fwid = (double)wid/(double)(2*count);
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        { 
            phyt = fhyt * (i+1);
            pwid = fwid * (i+1);
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, wid, phyt, x1, y1);

            y = y1 + hyt - phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y, wid, phyt, x1, y);

            s_y = y1 + phyt;
            chyt = hyt - 2*phyt;
            XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, s_y, pwid, chyt, x1, s_y);
            s_x = x1 + wid - pwid;
            XCopyArea(Dpy, ScratchMap, drw, Gc1,s_x,s_y, pwid, chyt, s_x, s_y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
        }
    break;

    }

    XCopyArea(Dpy, ScratchMap, drw, Gc1, x1, y1, wid, hyt, x1, y1);
    XSetGraphicsExposures(Dpy, Gc1, FALSE);
}

void
AxScratchToScreen(w, x1,y1, x2,y2, style)
long w;
int x1,y1, x2,y2, style;
{
    AxSlideshow(w, x1,y1, x2,y2, style, 0);
}

/****************************************************************************/
long
AxGetFinalMap(pmap)
Drawable pmap;
{
    Drawable old_drw;
    int x_off, y_off;

	old_drw = (Pixmap)NULL;
	FinalPixmap = pmap;
    return((long)old_drw);
}

/****************************************************************************/
long
AxGetFlyInMap(pmap)
Drawable pmap;
{
    Drawable old_drw;
    int x_off, y_off;

	old_drw = (Pixmap)NULL;
	FlyInPixmap = pmap;
    return((long)old_drw);
}

/****************************************************************************/
long
AxGetBackMap(pmap)
Drawable pmap;
{
    Drawable old_drw;
    int x_off, y_off;

	old_drw = (Pixmap)NULL;
	BackupPixmap = pmap;
    return((long)old_drw);
}

AxCreateBackUpPixmap(w, ox1, oy1, ox2, oy2, old_drw)
long w;
int *ox1, *oy1, *ox2, *oy2;
long old_drw;
{
	int x_off, y_off, wid, hyt;
	extern short DpyDepth;
    Drawable drw;
	XImage *ximg;

	if ( old_drw != (Drawable)NULL )
	{
		BackupPixmap = old_drw;
		convMilsToPix((*ox1), (*oy1), ox1, oy1);
		convMilsToPix((*ox2), (*oy2), ox2, oy2);
		wid = (*ox2) - (*ox1) + 1;
		hyt = (*oy2) - (*oy1) + 1;
	}
	else
	{
		if ( !ScratchMap )
			return(!AOK);
		drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);

		convMilsToPix((*ox1), (*oy1), ox1, oy1);
		convMilsToPix((*ox2), (*oy2), ox2, oy2);
		wid = (*ox2) - (*ox1) + 1;
		hyt = (*oy2) - (*oy1) + 1;

		BackupPixmap = AxCreateQueryPixmap(Dpy, RootWin, wid, hyt, DpyDepth);
		if ( BackupPixmap == (Pixmap)NULL )
			return(!AOK);
		else
		{
			ximg = XGetImage(Dpy, drw, (*ox1), (*oy1),  wid, hyt, AllPlanes, ZPixmap);
			if ( ximg )
			{
				XPutImage(Dpy, BackupPixmap, Gc1, ximg, 0, 0, 0, 0,
							   ximg->width, ximg->height);
				XDestroyImage(ximg);
			}
			else
				return(!AOK);
		}
	}
	return(AOK);
}

long
AxLoadBackUpPixmap(w)
long w;
{
    Drawable old_drw;
	old_drw = AxSetDrawableOfWidget((AXWidget_main)w, BackupPixmap);
    return((long)old_drw);
}

AxBackUpToScreen(w, ox1, oy1, ox2, oy2)
long w;
int ox1, oy1, ox2, oy2;
{
    Drawable drw;
    int x_off, y_off, wid, hyt;

	drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
    wid = ox2 - ox1 + 1;
    hyt = oy2 - oy1 + 1;
	XCopyArea(Dpy, BackupPixmap, drw, Gc1, 0, 0, wid, hyt, ox1, oy1);
}

AxClearFinalPmap()
{
	FinalPixmap = (Pixmap)NULL;
}

void
ax_clear_pixmap(Pixmap pmap, int wid, int hyt)
{
	XSetState(Dpy, Gc1,AlisPixels[0], AlisPixels[1], GXcopy, AllPlanes);
	XSetFillStyle(Dpy, Gc1, FillSolid);
	XSetClipMask(Dpy, Gc1, None);
	XFillRectangle(Dpy, pmap, Gc1, 0, 0, wid, hyt);
}

AxDestroyBackUpPixmap(w, backup_exists)
long w;
int backup_exists;
{
	if ( backup_exists == FALSE )
	{
		AxFreePixmap(BackupPixmap);
	}
	BackupPixmap = (Pixmap)NULL;
}

/****************************************************************************/
long
AxCreateFlyInMap(w, wid, hyt)
long w;
int wid, hyt;
{
	FlyInPixmap = AxCreateQueryPixmap(Dpy, RootWin, wid, hyt, DpyDepth);
    return((long)FlyInPixmap);
}

/****************************************************************************/
long
AxLoadDimPixmap(w, dim_pmap, wid, hyt)
long w;
long dim_pmap;
int wid, hyt;
{
    Drawable old_drw;

	ax_clear_pixmap(dim_pmap, wid, hyt);
	old_drw = AxSetDrawableOfWidget((AXWidget_main)w, dim_pmap);
    return((long)old_drw);
}

/****************************************************************************/
long
AxLoadFlyInMap(w, flyin_pmap, wid, hyt)
long w;
long flyin_pmap;
int wid, hyt;
{
    Drawable old_drw;
    int x_off, y_off;

	if( flyin_pmap )
    {
		FlyInPixmap = flyin_pmap;
		ax_clear_pixmap(FlyInPixmap, wid, hyt);
        old_drw = AxSetDrawableOfWidget((AXWidget_main)w, FlyInPixmap);
    }
	else
		old_drw = (Drawable)NULL;
    return((long)old_drw);
}

AxDestroyFlyInMap(w, backup_exists)
long w;
int backup_exists;
{
	if ( backup_exists == FALSE )
		AxFreePixmap(FlyInPixmap);
	FlyInPixmap = (Pixmap)NULL;

}

Pixmap
getClipMaskFromFlyInPmap(w, drw, x, y, wid, hyt)
long w;
Drawable drw;
int x, y;
int wid, hyt;
{
	XImage *ximg;
	Pixmap clip_mask;
	unsigned char *mask;
	extern GC PixClearGC, PixGC;

#if AXMS
	clip_mask = axmsGetMonochromeBitmapFromColorBitmap(FlyInPixmap, wid, hyt);
#else
	ximg = XGetImage(Dpy, FlyInPixmap, 0, 0, wid, hyt,AllPlanes, ZPixmap);
	if ( ximg == (XImage *)0 )
		return((Pixmap) NULL);
	else
	{
		clip_mask = AxCreateMonoPixmap(ximg, drw);
		XDestroyImage(ximg);
	}
#endif
	return(clip_mask);
}

AxAnimateObject(w, style, throttle, in_x, in_y, wid, hyt, ox1, oy1, ox2, oy2)
long w;
int style, throttle;
int in_x, in_y;
int wid, hyt;
int ox1, oy1, ox2, oy2;
{
	int x, y;
    int twid, thyt;
	int tmp_wid;
    Drawable drw;
    Pixmap clip_mask;
    int i,j, k, pwid,phyt, x_off,y_off, x_ix,y_ix;
    int cwid, chyt, s_x, s_y, dst_x, dst_y;
    int sz, n_wids, n_hyts, step, count;
    double fwid, fhyt, fsz;
    TmPoint32 pnts[100];
    struct timeval orig_time, curr_time;
    int timed, x1, y1, clip_x, clip_y, val;
    long interval;

    drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
    /* convert units */
    convMilsToPix(in_x, in_y, &x1, &y1);
	convMilsToPix(wid, hyt, &wid, &hyt);
    
    twid = ox2 - ox1 + 1;
    thyt = oy2 - oy1 + 1;

    clip_mask = getClipMaskFromFlyInPmap(w, drw, x1, y1, wid, hyt);
    XSetGraphicsExposures(Dpy, Gc1, TRUE);
    XSetClipMask(Dpy, Gc1, None);
    XSetFunction(Dpy, Gc1, GXcopy);
    XSetPlaneMask(Dpy, Gc1, PlaneMask);

    XSetGraphicsExposures(Dpy, Gc2, TRUE);
    XSetClipMask(Dpy, Gc2, None);
    XSetFunction(Dpy, Gc2, GXcopy);
    XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
                   twid, thyt, ox1, oy1);
    XSetGraphicsExposures(Dpy, Gc2, FALSE);


    /* scaling control to improve performance for large images */
    if ( wid < 200 || hyt < 200 )
        step = 6;
    else if ( wid < 500 || hyt < 500 )
        step = 9;
    else 
        step = 12;

    /* speed control - set by user */
    if ( throttle <= 0 )
        timed = FALSE;
    else
        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
    if ( clip_mask )
       XSetClipMask(Dpy, Gc1, clip_mask);
    switch ( style )
    {
        /* fade - pixilate (40x40 l=>r, t=>b for now) */
        case 1:
			ax_fade_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt, throttle);
        break;

		/* wipe right (l=>r, overwrite) */
		case 2:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
		break;
		
		case 3:    /* slide (in) right */
			count = 60/(float)step;
			interval = timed ? 50000.0 * throttle / count : 0;
			for ( i=0; i<count; i++ )
			{
				XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
				x = (x1*(i+1.0))/(float)count;
				XSetClipOrigin(Dpy, Gc1, x, y1);
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x, y1);
				if ( timed )
				{
					churn_interval(&orig_time, interval);
					timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
					XSync(Dpy, FALSE);
				}
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
			}
		break;

		/* wipe left (in place) */
		case 4:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
		break;

		/* slide (in) left */
		case 5:
			count = 60/(float)step;
			interval = timed ? 50000.0 * throttle / count : 0;
			for ( i=count; i>0; i-- )
			{
				XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);

				x = x1 + (((twid-x1)*(i-1.0))/(float)count);
				XSetClipOrigin(Dpy, Gc1, x, y1);
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x, y1);

				if ( timed )
				{
					churn_interval(&orig_time, interval);
					timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
					XSync(Dpy, FALSE);
				}
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
			}
		break;

		/* wipe down */
		case 6:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
		break;

    /* slide (t=>b, overwrite) */
		/* slide (in) down */
		case 7:
			count = 60/(float)step;
			interval = timed ? 50000.0 * throttle / count : 0;
			for ( i=0; i < count; i++ )
			{
				XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);

				y = (y1*(i+1.0))/(float)count;
				XSetClipOrigin(Dpy, Gc1, x1, y);
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x1, y);

				if ( timed )
				{
					churn_interval(&orig_time, interval);
					timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
					XSync(Dpy, FALSE);
				}
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
								   twid, thyt, ox1, oy1);
			}
		break;

    	/* wipe (b=>t, overwrite) */
    	/* wipe up */
    	case 8:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
    	break;

		/* slide (in) up */
		case 9:
			x = x1;
			pwid = wid;
			count = 60/(float)step;
			interval = timed ? 50000.0 * throttle / count : 0;
			for ( i=count; i>0; i-- )
			{
				XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);

				y = y1 + (((thyt-y1)*(i-1.0))/(float)count);
				XSetClipOrigin(Dpy, Gc1, x1, y);
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x1, y);

				if ( timed )
				{
					churn_interval(&orig_time, interval);
					timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
					XSync(Dpy, FALSE);
				}
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
						   twid, thyt, ox1, oy1);
			}
		break;

		/* slide diagonal l->r */
		/* slide (in) right up */
		case 10:
			count = 60/(float)step;
			interval = timed ? 50000.0 * throttle / count : 0;
			for ( i=count; i>0; i-- )
			{
				XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);

				x = (x1*((count-i)+1.0))/(float)count;
				y = y1 + (((thyt-y1)*(i-1.0))/(float)count);
				XSetClipOrigin(Dpy, Gc1, x, y);
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x, y);

				if ( timed )
				{
					churn_interval(&orig_time, interval);
					timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
					XSync(Dpy, FALSE);
				}
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
			}
		break;

		/* slide diagonal r->l */
		/* slide (in) left down */
		case 11:
			count = 60/(float)step;
			interval = timed ? 50000.0 * throttle / count : 0;
			for ( i=count; i>0; i-- )
			{
				XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);

				x = x1 + (((twid-x1)*(i-1.0))/(float)count);
				y = (y1*((count-i)+1.0))/(float)count;
				XSetClipOrigin(Dpy, Gc1, x, y);
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x, y);
				if ( timed )
				{
					churn_interval(&orig_time, interval);
					timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
					XSync(Dpy, FALSE);
				}
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
			}
		break;

    /* slide diagonal t->b */
    /* slide (in) left up */
    case 12:
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=count; i>0; i-- )
        {
			XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
						   twid, thyt, ox1, oy1);

			x = x1 + (((twid-x1)*(i-1.0))/(float)count);
			y = y1 + (((thyt-y1)*(i-1.0))/(float)count);
			XSetClipOrigin(Dpy, Gc1, x, y);
			XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   wid, hyt, x, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* slide diagonal b->t */
    case 13:
        /* slide (in) right down */
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
        for ( i=0; i <count; i++ )
        {
			XCopyArea(Dpy, BackupPixmap, FinalPixmap, Gc2, ox1, oy1,
						   twid, thyt, ox1, oy1);
			x = (x1*(i+1.0))/(float)count;
			y = (y1*(i+1.0))/(float)count;
			XSetClipOrigin(Dpy, Gc1, x, y);
			XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
						   wid, hyt, x, y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
						   twid, thyt, ox1, oy1);
        }
    break;

    /* blinds - horizontal (right) */
    case 14:
        fwid = wid/7.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i<count; i++ )
        {
            pwid = (fwid * (i+1.0))/(float)count;
            for ( j=0; j<7; j++ )
            {
                x = j*fwid;
                XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
				          x1+x, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
					   twid, thyt, ox1, oy1);
        }
    break;

    /* blinds - vertical (down) */
    case 15:
        fhyt = hyt/10.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i <count; i++ )
        {
            phyt = (fhyt*(i+1.0))/(float)count;
            for ( j=0; j<10; j++ )
            {
                y = j*fhyt;
                XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
				          x1, y1+y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
				XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - right down */
    case 16:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = i*fhyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = j*fwid;
                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - left up */
    case 17:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = hyt - i*fhyt - phyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = wid - j*fwid - pwid;
                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* spread out */
    case 18:
        count = 60/(float)step;
        interval = timed ? 500.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i<count; i++ ) 
        {
            y = (hyt/2.0) - ((i+1.0)*hyt)/(count*2.0);
            x = (wid/2.0) - ((i+1.0)*wid)/(count*2.0);
            pwid = (wid*(i+1)/count);
            phyt = (hyt*(i+1)/count);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y, pwid, phyt,
			          x1+x, y1+y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* split - vertical in */
    case 19:
        count = 60.0/(double)step;
        fhyt = (double)hyt/(double)(2.0*count);
        phyt = ceil(fhyt);
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( j=0; j<count; j++ )
        {
            y = j*fhyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
			          x1, y1+y);

            y = hyt - j*fhyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
			          x1, y1+y);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* split - vertical out */
    case 20:
        count = 60.0/(double)step;
        fhyt = (double)hyt/(double)(2.0*count);
        phyt = ceil(fhyt);
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( j=0; j<count; j++ )
        {
            y = hyt/2.0 - j*fhyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
			          x1, y1+y);

            y = hyt/2.0 + j*fhyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
			          x1, y1+y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* split - horizontal in */
    case 21:
        count = 60.0/(double)step;
        fwid = (double)wid/(double)(2.0*count);
        pwid = ceil(fwid);
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( j=0; j<count; j++ )
        {
            x = j*fwid;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
			          x1+x, y1);

            x = wid - j*fwid - pwid;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
			          x1+x, y1);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* split - horizontal out */
    case 22:
        count = 60.0/(double)step;
        fwid = (double)wid/(double)(2.0*count);
        pwid = ceil(fwid);
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( j=0; j<count; j++ )
        {
            x = wid/2.0 - j*fwid - pwid;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
			          x1+x, y1);

            x = wid/2.0 + j*fwid;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
			          x1+x, y1);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    case 23:
        /* implode */
        /* 4 Quad */
        cwid = wid/2.0;
        chyt = hyt/2.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i <count; i++ )
        {
            phyt = chyt * (i+1.0) / (float)count;
            pwid = cwid * (i+1.0) / (float)count;
            s_x = 0;
            s_y = 0;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y, pwid, phyt,
			          x1+s_x, y1+s_y);

            s_x = cwid;
            s_y = 0;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x, y, pwid, phyt,
			          x1+x, y1+s_y);

            s_x = 0;
            s_y = chyt;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, s_y, pwid, phyt,
			          x1+s_x, y1+y);

            s_x = cwid;
            s_y = chyt;
            x = s_x + cwid - pwid;
            y = s_y + chyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x, s_y, pwid, phyt,
			          x1+x, y1+y);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    	/* meltdown */
    	case 24:
#if 1
	/* use fade for now, until we have a working meltdown algorithm. */
			ax_fade_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt, throttle);
#else
    		count = 10*(float)step;
			ax_meltdown_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                   throttle, count);
#endif
		break;

    /* blinds - horizontal (left) */
    case 25:
        fwid = wid/10.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i<count; i++ )
        {
            pwid = (fwid * (i+1.0))/(float)count;
            for ( j=0; j<10; j++ )
            {
                x = wid - j*fwid - pwid;
                XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
				          x1+x, y1);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* blinds - vertical (up) */
    case 26:
        fhyt = hyt/10.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i<count; i++ )
        {
            phyt = (fhyt*(i+1.0))/(float)count;
            for ( j=0; j<10; j++ )
            {
                y = hyt - j*fhyt - phyt;
                XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
				          x1, y1+y);
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    	/* wipe right down */
    	case 27:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
    	break;

    	/* wipe left down */
    	case 28:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
    	break;

    	/* wipe right up */
    	case 29:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
    	break;

    	/* wipe left up */
    	case 30:
			ax_wipe_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			               throttle, step, style);
    	break;

    /* checker - left down */
    case 31:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = i*fhyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = wid - j*fwid - pwid;
                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+x);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - right up */
    case 32:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        interval = timed ? 5000.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<10; k++ )
        {
            pwid = ceil((double)((fwid*(k+1))/10.0));
            phyt = ceil((double)((fhyt*(k+1))/10.0));
            for ( i=0; i<n_hyts; i++ )
            {
                y = hyt - i*fhyt - phyt;
                for ( j=0; j<n_wids; j++ )
                {
                    x = j*fwid;
                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - left */
    case 33:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        phyt = ceil(fhyt);
        interval = timed ? 2500.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<20; k++ )
        {
            for ( i=0; i<n_hyts; i++ )
            {
                y = fhyt*(i);
                for ( j=0; j<=n_wids; j++ )
                {
                    if ( (i+j)%2 == 0 )
                        continue;

                    pwid = (fwid*(k+1))/10;
                    x = wid + fwid - j*fwid - pwid;
                    if ( x <= 0 )
                    {
                        pwid -= x;
                        x = 0;
                    }
                    if ( (x + pwid) > wid )
                        pwid -= (x+pwid) - wid;
                    if ( pwid <= 0 )
                        continue;

                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - right */
    case 34:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        phyt = ceil(fhyt);
        interval = timed ? 2500.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<20; k++ )
        {
            for ( i=0; i<n_hyts; i++ )
            {
                y = i*fhyt;
                for ( j=0; j<=n_wids; j++ )
                {
                    if ((i+j)%2 == 0 )
                        continue;

                    pwid = (fwid*(k+1))/10;
                    x = j*fwid - fwid;
                    if ( x <= 0 )
                    {
                        pwid -= x;
                        x = 0;
                    }
                    if ( (x + pwid) > wid )
                        pwid -= (x+pwid) - wid;
                    if ( pwid <= 0 )
                        continue;

                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - down */
    case 35:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        pwid = ceil(fwid);
        interval = timed ? 2500.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<20; k++ )
        {
            for ( j=0; j<n_wids; j++ )
            {
                x = j*fwid;
                for ( i=0; i<=n_hyts; i++ )
                {
                    if ((i+j)%2 == 0 )
                        continue;

                    phyt = fhyt*(k+1)/10.0;
                    y = i*fhyt - fhyt;
                    if ( y <= 0 )
                    {
                        phyt -= y;
                        y = 0;
                    }
                    if ( (y + phyt) > hyt )
                        phyt -= (y+phyt) - hyt;
                    if ( phyt <= 0 )
                        continue;

                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    /* checker - up */
    case 36:
        sz = (wid < hyt) ? hyt/10.0 : wid/10.0;
        n_wids = ceil((double)((double)wid/(double)sz));
        n_hyts = ceil((double)((double)hyt/(double)sz));
        fwid = wid/(double)n_wids;
        fhyt = hyt/(double)n_hyts;
        pwid = ceil(fwid);
        interval = timed ? 2500.0 * throttle : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( k=0; k<20; k++ )
        {
            for ( j=0; j<n_wids; j++ )
            {
                x = j*fwid;
                for ( i=0; i<=n_hyts; i++ )
                {
                    if ((i+j)%2 == 0 )
                        continue;

                    phyt = fhyt*(k+1)/10.0;
                    y = hyt + fhyt - i*fhyt - phyt;
                    if ( y <= 0 )
                    {
                        phyt -= y;
                        y = 0;
                    }
                    if ( (y + phyt) > hyt )
                        phyt -= (y+phyt) - hyt;
                    if ( phyt <= 0 )
                        continue;

                    XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
					          pwid, phyt, x1+x, y1+y);
                }
            }
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    	/* uncover - left */
    	case 37:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    	/* uncover - right */
    	case 38:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    	/* uncover - down */
    	case 39:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    	/* uncover - up */
    	case 40:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    case 41:
        /* explode */
        /* 4 Quad */
        fwid = (double)wid/2.0;
        fhyt = (double)hyt/2.0;
        count = 60/(float)step;
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i<count; i++ )
        {
            phyt = (fhyt * (i+1.0)) / (float)count;
            pwid = (fwid * (i+1.0)) / (float)count;

            s_x = 0;
            s_y = 0;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x, s_y, pwid, phyt,
			          x1+x, y1+y);

            s_x = fwid;
            s_y = 0;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, s_y, pwid, phyt,
			          x1+s_x, y1+y);

            s_x = 0;
            s_y = fhyt;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x, y, pwid, phyt,
			          x1+x, y1+s_y);

            s_x = fwid;
            s_y = fhyt;
            x = s_x + fwid - pwid;
            y = s_y + fhyt - phyt;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y, pwid, phyt,
			          x1+s_x, y1+s_y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;

    	/* uncover - right up */
    	case 42:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    	/* uncover - left down */
    	case 43:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    	/* uncover - left up */
    	case 44:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    	/* uncover - right down */
    	case 45:
			ax_uncover_object(x1,y1,wid,hyt, drw, ox1,oy1,twid,thyt,
			                  throttle, step, style, clip_mask);
    	break;

    /* spread in */
    case 46:
        /* spread in */
        chyt = (double)hyt/2.0;
        cwid = (double)wid/2.0;
        count = 60/(float)step;
        fhyt = (double)hyt/(double)(2*count);
        fwid = (double)wid/(double)(2*count);
        interval = timed ? 50000.0 * throttle / count : 0;
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        for ( i=0; i <count; i++ )
        { 
            phyt = fhyt * (i+1);
            pwid = fwid * (i+1);
            XCopyArea(Dpy, FlyInPixmap,FinalPixmap, Gc1, 0,0,wid,phyt,
			          x1,y1);

            y = hyt - phyt;
            XCopyArea(Dpy, FlyInPixmap,FinalPixmap, Gc1, 0,y,wid,phyt,
			          x1,y1+y);

            s_y = phyt;
            chyt = hyt - 2*phyt;
            XCopyArea(Dpy, FlyInPixmap,FinalPixmap, Gc1, 0,s_y,pwid,chyt,
			          x1,y1+s_y);
            s_x = wid - pwid;
            XCopyArea(Dpy, FlyInPixmap,FinalPixmap, Gc1, s_x,s_y,pwid,chyt,
			          x1+s_x,y1+s_y);
            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
			XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
							   twid, thyt, ox1, oy1);
        }
    break;
	default:
    case 0:
		XSetClipOrigin(Dpy, Gc1, x1, y1);
        XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0, wid, hyt, x1, y1);
    break;

    }

    XSetClipMask(Dpy, Gc1, None);
	XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1, twid, thyt, ox1, oy1);
    XSetGraphicsExposures(Dpy, Gc1, FALSE);
	/* restore gc2 state */
    XSetFunction(Dpy, Gc2, GXxor);
	if ( clip_mask )
		AxFreePixmap(clip_mask);
}

data_ptr
createDummyPixmapWidget(wid, hyt)
int wid, hyt;
{
	AXWidget w;
	data_ptr wP;
	Pixmap pmap;

	pmap = AxCreateQueryPixmap(Dpy, RootWin, wid, hyt,DpyDepth);

	w = (AXWidget)InitWidget(W_CANVAS);
	w->parent = (AXWidget_main)w;
	w->width = wid;
	w->height = hyt;
	AxSetDrawableOfWidget((AXWidget_main)w, pmap);
	wP = (data_ptr)HandleDataFromWidgetPointer(w);
	return(wP);
}

destroyDummyPixmapWidget(wP)
data_ptr wP;
{
	AXWidget w;
	Pixmap pmap;
	int x_off, y_off;

	w = (AXWidget)WidgetPointerFromHandleData(wP);
    pmap = AxGetDrawableFromWidget(w, &x_off, &y_off);
	AxFreePixmap(pmap);
	free(w);
}

data_ptr
createDummyWidget()
{
	AXWidget w;
	data_ptr wP;

	w = (AXWidget)InitWidget(W_DUMMY);
	wP = (data_ptr)HandleDataFromWidgetPointer(w);
	return(wP);
}

destroyDummyWidget(wP)
data_ptr wP;
{
	AXWidget w;

	w = (AXWidget)WidgetPointerFromHandleData(wP);
	free(w);
}

/*************************************************************************
function: OldButtonEventType - Interpret combination of mouse button and
keys for old elf recordings. (Called ONLY from ElfbPick() and ElfbStroke())
*/
int OldButtonEventType(button,shifted,controled)
int button, shifted, controled;
{
    int type;

    if ( button == TM_L_BUTTON ) {
        if ( shifted && !controled )
            type = TM_EXTENDED_SELECT;
        else if ( controled && !shifted )
            type = TM_MULTIPLE_SELECT;
        else
            type = TM_NORMAL_SELECT;
    }
    else if ( button == TM_M_BUTTON )
        type = TM_PASTE_SELECT;
    else
        type = TM_IGNORE_SELECT;

    return(type);
}

/* : axGridToRuler - truncate the input point to the nearest
 * lesser grid point.  This function grids the input against
 * the grid's origin, not the coordinate system origin.  It
 * is derived from a 'simple' grid function (p = p - (p % grid_size))
 * (which grids against the coord sys origin) applied to both the
 * input point and the grid origin
 */
void
axGridToRuler(x, y, x_orig, y_orig, x_gsize, y_gsize,
              gridx, gridy)
int x, y;              /* in: input point */
int x_orig, y_orig;    /* in: grid origin */
int x_gsize, y_gsize;  /* in: grid unit size */
int *gridx, *gridy;    /* out: return gridded vals */
{
    *gridx = x + (x_orig % x_gsize) -
        (x % x_gsize) - x_gsize;
    if (x - *gridx >= x_gsize)
        *gridx += x_gsize;

    *gridy = y + (y_orig % y_gsize) -
        (y % y_gsize) - y_gsize;
    if (y - *gridy >= y_gsize)
        *gridy += y_gsize;
}

void AxGetGridInfo(wID, xScrollPos, yScrollPos, xScrollPer, yScrollPer,
              xZeroPt, yZeroPt, xZoom, yZoom, unitSize, gridSize, unitPrec, 
              unitName)
int wID;                       /* in: (wind_struct) window[] array index */
int *xScrollPos, *yScrollPos;  /* out: report scroll geom in mils */
int *xScrollPer, *yScrollPer;
int *xZeroPt, *yZeroPt;        /* out: report grid orgin in mils */
int *xZoom, *yZoom;            /* out: report zoom (reference val 100) */
int *unitSize;                 /* out: report unit size in mils */
int *gridSize;                 /* out: report grid cell size in mils */
int *unitPrec;                 /* out: report unit precision number */
char **unitName;               /* out: name string of unit */
{
    struct wind_struct *wp = &window[wID];

    *xScrollPos = wp->wind_attr.h_sc_pos + wp->x_scroll_origin;
    *yScrollPos = wp->wind_attr.v_sc_pos + wp->y_scroll_origin;
    *xScrollPer = wp->wind_attr.h_sc_per;
    *yScrollPer = wp->wind_attr.v_sc_per;
    *xZeroPt = wp->x_zero_pt;
    *yZeroPt = wp->y_zero_pt;
    *xZoom = wp->x_zoom;
    *yZoom = wp->y_zoom;
    *unitSize = wp->unitSize;
    *gridSize = wp->gridSize;
    *unitPrec = wp->unitPrec;
    *unitName = wp->unitName;
}



void 
AxSetWinAttr(wID, l_width,l_style,l_mode,
                  l_pat,
                  l_fg,l_bg,
                  lfg_cyan, lfg_magn, lfg_yell, lfg_blck,
                  lbg_cyan, lbg_magn, lbg_yell, lbg_blck,
                  lf_type,lf_ang,lf_off,l_name,
                  f_pat,
                  f_fg,f_bg,
                  ffg_cyan, ffg_magn, ffg_yell, ffg_blck,
                  fbg_cyan, fbg_magn, fbg_yell, fbg_blck,
                  ff_type,ff_ang,ff_off,f_name )
short wID;
int l_width,l_style,l_mode,
    l_pat,
    l_fg,l_bg,
    lfg_cyan, lfg_magn, lfg_yell, lfg_blck,
    lbg_cyan, lbg_magn, lbg_yell, lbg_blck,
    lf_type,lf_ang,lf_off,
    f_pat,
    f_fg,f_bg,
    ffg_cyan, ffg_magn, ffg_yell, ffg_blck,
    fbg_cyan, fbg_magn, fbg_yell, fbg_blck,
    ff_type,ff_ang,ff_off;
char *l_name, *f_name;
{
    int index;

    SetWp(&window[wID]);
    Wp->line_width = l_width;
    Wp->line_style = l_style;
    Wp->line_mode  = l_mode;

    Wp->line_pat   = l_pat;
    Wp->line_fg    = l_fg;
    Wp->line_bg    = l_bg;
    Wp->lfg_cyan   = lfg_cyan;
    Wp->lfg_magn   = lfg_magn;
    Wp->lfg_yell   = lfg_yell;
    Wp->lfg_blck   = lfg_blck;
    Wp->lbg_cyan   = lbg_cyan;
    Wp->lbg_magn   = lbg_magn;
    Wp->lbg_yell   = lbg_yell;
    Wp->lbg_blck   = lbg_blck;
    Wp->lfill_type = lf_type;
    Wp->lfill_ang  = lf_ang;
    Wp->lfill_off  = lf_off;
    Wp->line_pat_name = l_name;

    Wp->fill_pat   = f_pat;
    Wp->fill_fg    = f_fg;
    Wp->fill_bg    = f_bg;
    Wp->ffg_cyan   = ffg_cyan;
    Wp->ffg_magn   = ffg_magn;
    Wp->ffg_yell   = ffg_yell;
    Wp->ffg_blck   = ffg_blck;
    Wp->fbg_cyan   = fbg_cyan;
    Wp->fbg_magn   = fbg_magn;
    Wp->fbg_yell   = fbg_yell;
    Wp->fbg_blck   = fbg_blck;
    Wp->ffill_type = ff_type;
    Wp->ffill_ang  = ff_ang;
    Wp->ffill_off  = ff_off;
    Wp->fill_pat_name = f_name;
}

void AxSetWinContextGridSize(wid, gridSize)
int wid, gridSize;
{
    if ( wid > 0 )
    {
        window[wid].gridSize = gridSize;
        AxXmRepaintGErulers(WidgetOfWindow(wid));
    }
}

/* : AxScroll - do a copy area of a portion of the screen,
 * and report the dimensions of the vacated area.
 */
void
AxScroll(w, dx, dy, ruler, xshift, yshift, dxpix, dypix)
AXWidget_main w;
int dx, dy;     /* in: scroll direction and amount, mils */
int ruler;
r32 *xshift;    /* out: report area vacated by scrolling, in
                   window-relative mils */
r32 *yshift;
int *dxpix;   /* out: report copyarea displacement vals in pix */
int *dypix;
{
    r32 winrect, xclear, yclear;
	TmRect32 trect;
    int wid, ht, srcx, srcy, dstx, dsty;
    int x_off, y_off;
    int fg_pixel;
    extern short DpyWid, DpyHt;
    Drawable srcDrw, dstDrw;
    Arg args[3];

    if (!w) {
        xshift->origin.x = xshift->origin.y = xshift->width =
            xshift->height = 0;
        yshift->origin.x = yshift->origin.y = yshift->width =
            yshift->height = 0;
        *dxpix = *dypix = 0;
        return;
    }
    args[0].name = XmNheight;
    args[1].name = XmNwidth;
    XtSetArg(args[0], XmNheight, &winrect.height);
    XtSetArg(args[1], XmNwidth, &winrect.width);
    AxXtGetValues((AXWidget)w->workWindow, args, 2);
    winrect.origin.x = winrect.origin.y = 0;
#if 1
    if ( ruler )
    {
        winrect.width -= 33;
        winrect.height -= 33;
    }
#endif
	wid = winrect.width;
	ht = winrect.height;
    conv_i_p32(&wid, &ht, &wid, &ht, PIXEL_TO_MILLS);

	winrect.width  = wid;
	winrect.height = ht;
    xclear.width = abs(dx);
    yclear.height = abs(dy);

        /* get copyArea width and height */
    wid = (int) winrect.width - (int) xclear.width;
    ht = (int) winrect.height - (int) yclear.height;

    if (wid <= 0 || ht <= 0 || (dx == 0 && dy == 0)) {
        xshift->origin.x = xshift->origin.y = xshift->width =
            xshift->height = 0;
        yshift->origin.x = yshift->origin.y = yshift->width =
            yshift->height = 0;
        *dxpix = *dypix = 0;
        return;
    }

        /* init the copyArea args srcx, srcy, dstx, dsty, and
           complete the init of the xclear, yclear rects */
    xclear.origin.y = 0;
    xclear.height = winrect.height;
    yclear.width = winrect.width - xclear.width;
    if (dx > 0) {
        srcx = 0;  /* move material toward the right */
        dstx = xclear.width + 1;
        xclear.origin.x = 0;
        yclear.origin.x = xclear.width;
    }
    else {
        srcx = xclear.width + 1;
        dstx = 0;
        xclear.origin.x = wid + 1;
        yclear.origin.x = 0;
    }
    if (dy > 0) {
        srcy = 0;  /* move material toward the bottom */
        dsty = yclear.height + 1;
        yclear.origin.y = 0;
    }
    else {
        srcy = winrect.height - ht;
        dsty = 0;
        yclear.origin.y = ht + 1;
    }
    *xshift = xclear;
    *yshift = yclear;

        /* convert to screenpix and do the copyarea */
    conv_i_p32(&srcx, &srcy, &srcx, &srcy, MILLS_TO_PIXEL);
    conv_i_p32(&dstx, &dsty, &dstx, &dsty, MILLS_TO_PIXEL);
    conv_i_p32(&wid, &ht, &wid, &ht, MILLS_TO_PIXEL);
        /* init the drawable, and workwindow dimensions */
    srcDrw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
    if (ScratchMap)
    {
        dstDrw = ScratchMap;
    }
    else
        dstDrw = srcDrw;
    XSetGraphicsExposures(Dpy, Gc1, TRUE);
    XSetClipMask(Dpy, Gc1, None);
    XSetFunction(Dpy, Gc1, GXcopy);
    XSetPlaneMask(Dpy, Gc1, PlaneMask);
    XCopyArea(Dpy, srcDrw, dstDrw, Gc1, srcx, srcy,
              (unsigned int) wid, (unsigned int) ht, dstx, dsty);
    XSetGraphicsExposures(Dpy, Gc1, FALSE);

    *dxpix = dstx - srcx;
    *dypix = dsty - srcy;
}

/*************************************************************************
function: AxGetDecorations
*/
void AxGetDecorations(winID, pal_flag, colorpal_flag, rulers_flag)
int winID, *pal_flag, *colorpal_flag, *rulers_flag;
{
    /* these should be null pointers if not in use */
    AxXmGetDisplayState((AXWidget)window[winID].palette, pal_flag);
    AxXmGetDisplayState((AXWidget)window[winID].colorpal, colorpal_flag);
    AxXmGetDisplayState((AXWidget)window[winID].GExruler, rulers_flag);
}

/****************************************************************************\
* the following code manages the ge's color ribbon pixmap                    *
\****************************************************************************/
#define RIBB_SZ 15 /* as in xmlib.c */
void AxLoadNewRibbon(w, n_colors, ix, str, pixed)
long w;
int n_colors;
int ix;
char *str;
int pixed;
{
    Pixmap ribbonMap;
    int wid;
    int x_off, y_off;
	AXWidget colorpal;
    Drawable xwin;

    if (!w)
        return;

    /* get the drawable */
    xwin = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
    colorpal = (AXWidget)AxgetColorpalFromWidget((AXWidget_main)w);
    if ( colorpal )
    {
        /* allocate and clear a pixmap to be used for the ribbon */
        wid = n_colors*RIBB_SZ;
        ribbonMap = AxCreateQueryPixmap(Dpy, xwin, wid, RIBB_SZ, DpyDepth);
        XSetState(Dpy, Gc1,
                  WhitePixel(Dpy, DefaultScreen(Dpy)),
                  WhitePixel(Dpy, DefaultScreen(Dpy)),
                  TMS, AllPlanes);
        XSetClipMask(Dpy, Gc1, None);
        XSetFillStyle(Dpy, Gc1, FillSolid);
        XSetLineAttributes(Dpy, Gc1, 0, LineSolid, CapButt, JoinMiter);
        XFillRectangle(Dpy, ribbonMap, Gc1, 0, 0, wid, RIBB_SZ);
        XDrawRectangle(Dpy, ribbonMap, Gc1, 0, 0, wid, RIBB_SZ);

        /* set up the color palette */
        loadRibbons((AXWidget)colorpal, WindowIdFromShellWidget(w),
                    n_colors, ix,str, ribbonMap, pixed);
    }
}

void AxChangeRibbonColor(w, cyan, magn, yell, blck, max, trans, ix)
long w;
int cyan, magn, yell, blck, max, trans, ix;
{
    Pixmap ribbonMap;
    unsigned long fg_pixel;
    char dash_list[2];
    AXWidget colorpal;

    if (!w)
        return;

    colorpal = (AXWidget)AxgetColorpalFromWidget((AXWidget_main)w);
    if ( colorpal )
    {
        /* modify the correct color cell on the ribbon */
        ribbonMap = GetWidgetChildPixmap(colorpal);
        if ( trans )
        {
            /* white out cell */
            AxGetRealPixel(2, 0,0,0,0,max, &fg_pixel);
            XSetState(Dpy, Gc1, fg_pixel, fg_pixel, TMS, AllPlanes);
            XFillRectangle(Dpy, ribbonMap, Gc1,
                           ix*RIBB_SZ+1, 1,
                           RIBB_SZ-2, RIBB_SZ-2);

            /* draw dotted outline indicating transparent */
            AxGetRealPixel(2, 0,0,0,max,max, &fg_pixel);
            XSetState(Dpy, Gc1, fg_pixel, fg_pixel, TMS, AllPlanes);
            dash_list[0] = dash_list[1] = 1;
            XSetDashes(Dpy, Gc1, 0, dash_list, 2);
            XSetLineAttributes(Dpy, Gc1, 0, LineOnOffDash, CapButt, JoinMiter);
            XDrawRectangle(Dpy, ribbonMap, Gc1,
                           ix*RIBB_SZ+3, 3,
                           RIBB_SZ-6, RIBB_SZ-6);
            XSetLineAttributes(Dpy, Gc1, 0, LineSolid, CapButt, JoinMiter);
        }
        else
        {
            /* fill the cell with the correct color */
            AxGetRealPixel(2, cyan,magn,yell,blck,max, &fg_pixel);
            XSetState(Dpy, Gc1, fg_pixel, fg_pixel, TMS, AllPlanes);
            XFillRectangle(Dpy, ribbonMap, Gc1,
                           ix*RIBB_SZ+1, 1,
                           RIBB_SZ-2, RIBB_SZ-2);
        }
    }
}

void
AxSetRibbon(w, ix, str, pixed)
AXWidget_main w;
int ix;
char *str;
int pixed;
{
    Pixmap ribbon_map;
    AXWidget_ribbon colorpal;

    colorpal = (AXWidget_ribbon)AxgetColorpalFromWidget(w);
    if ( colorpal )
        changeRibbons(colorpal, AxWindowIdFromShellWidget(w), ix, str, pixed);
}

/**********************************************************************/
void AxSync()
{
    XSync(Dpy,FALSE);
}


/* IS_NGC adapted from ATM's tmin1.c definition */
/* OBSOLETE -- can't handle multiple encodings.. in general, it's necessary
 * to know the font attribute that the keystroke will 'inherit' before testing
 * whether printable */
#define DEL     0177        /* ascii code */
#define TAB     '\t'
#define IS_NGC(c) ((((unsigned char)(c)) < ' ')||(((unsigned char)(c)) == DEL))
/*************************************************************************
function: HandleKeyEvent - Respond to a key up/down
*/
void HandleKeyEvent (event)
XEvent *event;
{
    int is_text;
    char *buf; /* OBSOLETE -- needs to be at least 16bits wide */
    int cnt;    /* 0 or numchars for text entry (if is_text) */
    int ix;
    int bell;
    int textChar;
    int num_chars;
    wchar *wideP;
    

#if AX_X11    /*  menu key events handled differently on Windows */
    if ( AxPulldownActive )
        return;
#endif

    if ( WMstate != NEUTRAL )
        return;

    QuietRunning = FALSE;
    QuietErrsRunning = FALSE;
    SetCurwinFromWp( Wp );
    cnt = ProcessKeyEvent(ElfFindSlider(Wp),event,&is_text,&buf,&bell);
    if ( bell )
        RingTheBell();

    if ( cnt > 0 )
    {
        if ( is_text )
        {
			wideP = MbToWOneStr(buf);
			num_chars = Wstrlen(wideP);
            for ( ix=0; ix<num_chars; ix++ )
            {
                if ( !IS_NGC(*wideP) || (*wideP == TAB) )
                {
                    ElfRecord(ELFREC_WCHAR,*wideP);
                    textChar = *wideP;
                    AxSendMes(Wp->p_id,&textChar,sizeof(textChar),APTXKEY);
                }
                wideP++;
            }
        }
        else
        {
            if ( THIMhelpMode )
            {
#if 1 /* rev3 always tries to show help */
                ElfPostHelp(buf);
#else
                if ( HelpScreenPos(buf) )
                    ElfPostHelp(buf);
                else
                    RingTheBell();
#endif
                ElfbSetHelpMode(FALSE);
            }
            else
            {
                if ( IsCommandAvailable(cur_win,buf) )
                    AxSendMes(Wp->p_id,buf,strlen(buf)+1,APMENUBAR);
                else
                    RingTheBell();
            }
        }
    }
}


static int LeftBorderWidth, TitleHeight;    /* in mills, hacked computation */

/*************************************************************************
function: HandleExposureEvent - Regen Applix-owned part of window
*/
void HandleExposureEvent (eventP)
XEvent *eventP;
{
    XEvent event;
    Window root;
    int width,height,border_width,depth;
    Point pnt;
    int x1, y1, x2, y2;
    Window w;
    int asked_x, asked_y;
    sys_event_t uEvent;
    static int called = FALSE;

    /* get the damaged area */
    x1 = eventP->xexpose.x;
    y1 = eventP->xexpose.y;
    x2 = x1 + eventP->xexpose.width;
    y2 = y1 + eventP->xexpose.height;

    /* now get the union of the current regen area and this one */
    Wp->damagedRect.origin.x = MIN(Wp->damagedRect.origin.x, x1);
    Wp->damagedRect.origin.y = MIN(Wp->damagedRect.origin.y, y1);
    Wp->damagedRect.corner.x = MAX(Wp->damagedRect.corner.x, x2);
    Wp->damagedRect.corner.y = MAX(Wp->damagedRect.corner.y, y2);

    /* always pre-clear since some servers don't */
    if (eventP->xany.window == Wp->xwin)/** do only for the main window **/
        lrectf(Wp->layer, &Wp->damagedRect, R_CLEAR);

    XmGetShellPos(Wp->window_id,&x1,&y1);

    /* attempt to compute height of system title & system left border */
    if ( !called )
    {
        asked_x = X_MILLS_TO_PIXELS(Wp->wind_attr.x_position);
        asked_y = Y_MILLS_TO_PIXELS(Wp->wind_attr.y_position);
        TitleHeight = y1 - asked_y;
        TitleHeight = Y_PIXELS_TO_MILLS(TitleHeight);
        LeftBorderWidth = x1 - asked_x;
        LeftBorderWidth = X_PIXELS_TO_MILLS(LeftBorderWidth);
        called = TRUE;
    }

    Wp->wind_attr.x_position = X_PIXELS_TO_MILLS(x1) - LeftBorderWidth;
    Wp->wind_attr.x_position = MAX(0,Wp->wind_attr.x_position);
    Wp->wind_attr.y_position = Y_PIXELS_TO_MILLS(y1) - TitleHeight;
    Wp->wind_attr.y_position = MAX(0,Wp->wind_attr.y_position);

    /* set all the atm cliprects */
    Wp->layer->rect =
     Wp->layer->rect =
      Wp->appClip =
       Wp->frClip =
        Wp->outer = Wp->inner;

    /* report the expose */
    if ( (Wp->ap_id == APDC) || (Wp->ap_id == APUCM) ||
                            (Wp->ap_id == APHTML) || 
                            (Wp->ap_id == APEQN) || (Wp->ap_id == APSS) )
    {
        AxSendMes(Wp->p_id, eventP, sizeof(XEvent), APXSERVER);
    }
    else
    {
        uEvent.type = REGEN_EVENT;
        uEvent.wid = Wp->window_id;
        uEvent.ev.regen.x1 = X_PIXELS_TO_MILLS(Wp->damagedRect.origin.x);
        uEvent.ev.regen.y1 = Y_PIXELS_TO_MILLS(Wp->damagedRect.origin.y);
        uEvent.ev.regen.x2 = X_PIXELS_TO_MILLS(Wp->damagedRect.corner.x);
        uEvent.ev.regen.y2 = Y_PIXELS_TO_MILLS(Wp->damagedRect.corner.y);
        AxSendMes(Wp->p_id, &uEvent, sizeof(uEvent), APSYS);
    }

    /* regen sent, restore damage list */
    Wp->damagedRect.origin.x = Wp->damagedRect.origin.y = 32767;
    Wp->damagedRect.corner.x = Wp->damagedRect.corner.y = 0;
    Wp->hasBeenMapped = TRUE;   /* needed for initial regen only */
}

static int is_ptr_ev(state)
unsigned int state;
{
    if ( state&Button1Mask )
        return(FALSE);
    if ( state&Button2Mask )
        return(FALSE);
    if ( state&Button3Mask )
        return(FALSE);
    if ( state&Button4Mask )
        return(FALSE);
    if ( state&Button5Mask )
        return(FALSE);
    return(TRUE);
}

static int mouse_move_is_valid(x, y)
int x, y;
{
    /* not a mouse paste? */
    if ( ButtonEventType() != TM_PASTE_SELECT )
    {
        /* shakey hand? */
        if ( WMstate != IBD )
            return(TRUE);
        if ( ABS(x-ButDown.x) + ABS(y-ButDown.y) >= SIG_MM )
            return(TRUE);
    }
    return(FALSE);
}

grClearMouseData(xP, yP, mP, rP)
data_ptr xP, yP, mP, rP;
{
    int i, n;
    if ( xP ) AxFreeData(xP);
    if ( yP ) AxFreeData(yP);
    if ( rP ) AxFreeData(rP);
    if ( mP )
    {
        n = AxArraySize(mP);
        for ( i=0; i<n; i++ )
            AxFreeData(AxArrayElement(mP, i));
        AxFreeData(mP);
    }
}

grSendMouseDown(pid, x, y)
int pid, x, y;
{
    static int last_x = 0, last_y = 0, quick = 0;
    static unsigned long last_t = 0;
    data_ptr xP, yP, mP, retP;
    double xval, yval;
    int dt, dx, dy;

    /* convert to units the GE can use */
    if ( grMouseDotsToUnits(pid, x, y, &xval, &yval) == FALSE )
        return;
    
    /* package the data */
    VfyContext(pid);
    mP = (data_ptr)grPackageMouseData(MevButton1, MevButton2, MevButton3);
    xP = AxMakeFloatData(xval);
    yP = AxMakeFloatData(yval);

    /* get the double click info */
    dt = TimeOfButtonPress - last_t;
    dx = ABS(last_x - x);
    dy = ABS(last_y - y);
    if ( last_t && dt<DoubleMillisec && dx<DoublePixSpan && dy<DoublePixSpan )
        quick = (quick >= 4) ? 0 : quick + 1;
    else
        quick = 0;
    last_t = TimeOfButtonPress;
    last_x = x;
    last_y = y;

    /* call the mouse down macro dispatcher */
    switch ( quick )
    {
        case 0:
        default:
            ElfCallByName(NXLT("gr_mouse_down@"), &retP, 3, xP, yP, mP);
        break;

        case 1:
            ElfCallByName(NXLT("gr_mouse_double_down@"), &retP, 3, xP, yP, mP);
        break;

        case 2:
            ElfCallByName(NXLT("gr_mouse_triple_down@"), &retP, 3, xP, yP, mP);
        break;

        case 3:
            ElfCallByName(NXLT("gr_mouse_quadruple_down@"),&retP,3, xP, yP, mP);
        break;
    }
    grClearMouseData(xP, yP, mP, retP);
}

grSendMouseMove(pid, x, y)
int pid, x, y;
{
    data_ptr xP, yP, mP, retP;
    double xval, yval;

    /* convert to units the GE can use */
    if ( grMouseDotsToUnits(pid, x, y, &xval, &yval) == FALSE )
        return;

    /* package the data */
    VfyContext(pid);
    mP = (data_ptr)grPackageMouseData(MevButton1, MevButton2, MevButton3);
    xP = AxMakeFloatData(xval);
    yP = AxMakeFloatData(yval);

    /* call the mouse move macro dispatcher */
    ElfCallByName(NXLT("gr_mouse_move@"), &retP, 3, xP, yP, mP);
    grClearMouseData(xP, yP, mP, retP);
}

grSendMouseUp(pid, x, y)
int pid, x, y;
{
    data_ptr xP, yP, mP, retP;
    double xval, yval;

    /* convert to units the GE can use */
    if ( grMouseDotsToUnits(pid, x, y, &xval, &yval) == FALSE )
        return;

    /* package the data */
    VfyContext(pid);
    mP = (data_ptr)grPackageMouseData(MevButton1, MevButton2, MevButton3);
    xP = AxMakeFloatData(xval);
    yP = AxMakeFloatData(yval);

    /* call the mouse up macro dispatcher */
    ElfCallByName(NXLT("gr_mouse_up@"), &retP, 3, xP, yP, mP);
    grClearMouseData(xP, yP, mP, retP);
}

/*************************************************************************
function: HandleButtonPressEvent - Respond to button down
*/
void Handle_ButtonPressEvent(bep, winP)
XButtonEvent *bep;
struct wind_struct *winP;
{
    /* init */
    QuietRunning = QuietErrsRunning = FALSE;
    LastInputWasMouse = TRUE;
    SetCurwinFromWp(Wp);

    /* get the mouse buttons currently depressed */
    MevButton3 = ((bep->button&0xFF) == Button3) ? TRUE : FALSE;
    MevButton2 = ((bep->button&0xFF) == Button2) ? TRUE : FALSE;
    MevButton1 = ((bep->button&0xFF) == Button1) ? TRUE : FALSE;

    /* get the mouse position */
    ButDown.x = mous_x = bep->x;
    ButDown.y = mous_y = bep->y;

    /* first mouse event (Initial Button Down) */
    if ( WMstate == NEUTRAL )
    {
        /* get the initial stroke button */
        if ( MevButton2 )
            MevButton = TM_M_BUTTON;
        else if ( MevButton3 )
            MevButton = TM_R_BUTTON;
        else if ( MevButton1 )
            MevButton = TM_L_BUTTON;
#if LINUX
		else if ( (bep->button&0xff) == Button4 ) {
			char *str = (char *)UPbyName(NXLT("axMouseWheelScroll"));
			if (str && (atoi(str) != 0)) {
				data_ptr retP;
				if (ThimIsShifted())
					ElfCallByName(NXLT("gr_prev_screen_key@"), &retP, 0);
				else
					ElfCallByName(NXLT("gr_previous_page@"), &retP, 0);
			}
			return;
		} else if ( (bep->button&0xff) == Button5 ) {
			char *str = (char *)UPbyName(NXLT("axMouseWheelScroll"));
			if (str && (atoi(str) != 0)) {
				data_ptr retP;
				if (ThimIsShifted())
					ElfCallByName(NXLT("gr_next_screen_key@"), &retP, 0);
				else
					ElfCallByName(NXLT("gr_next_page@"), &retP, 0);
			}
			return;
		}
#endif

        /* process it */
        grSendMouseDown(winP->p_id, mous_x, mous_y);

        /* set the Initial Button Down flag */
        WMstate = IBD;
    }
}

/*************************************************************************
function: HandleMotionEvent - Respond to button motion
*/
int Handle_MotionEvent(eventP, winP)
XEvent *eventP;
struct wind_struct *winP;
{
    /* If this is pointer motion, don't pre-process */
    if ( is_ptr_ev(eventP->xmotion.state) )
    {
        ptr_ev(ATMWindowFromXWindow(eventP->xmotion.window),
               eventP->xmotion.x,
               eventP->xmotion.y,
               eventP->xmotion.state&ShiftMask,
               eventP->xmotion.state&ControlMask);
    }

    /* If motion from other window entered work area, don't process */
    else if ( WMstate != NEUTRAL )
    {
        /* ignore small initial motion for "shakey hand" users */
        mous_x = eventP->xmotion.x;
        mous_y = eventP->xmotion.y;
        LastInputWasMouse = TRUE;
        if ( mouse_move_is_valid(mous_x, mous_y) )
        {
            /* process it */
            grSendMouseMove(winP->p_id, mous_x, mous_y);

            /* set the Stroke In Progress flag */
            WMstate = SIP;
        }
    }
    return(FALSE);
}

/*************************************************************************
function: HandleButtonReleaseEvent - Handle button up
*/
void Handle_ButtonReleaseEvent(bep, winP)
XButtonEvent *bep;
struct wind_struct *winP;
{
#if LINUX
	if ( (bep->button&0xff) == Button4 || (bep->button&0xff) == Button5 ) {
		return;
	}
#endif
	
    /* init */
    LastInputWasMouse = TRUE;
    SetCurwinFromWp(Wp);

    /* get the mouse position */
    mous_x = bep->x;
    mous_y = bep->y;

    /* do it */
    grSendMouseUp(winP->p_id, mous_x, mous_y);

    /* set the Neutral flag */
    WMstate = NEUTRAL;
}

/*************************************************************************
function: ElfPostHelp - Post a help window
*/
int ElfPostHelp (name)
char *name;
{
    char *ElfSymbolNameFromId();
    extern int ElfLanguage;

    VfyContext(0);
    return(ElfTaskProcArgs(ELElfMacroId(ELFM_HELP_FROM_C_),name));
}



void WMsetClip(rr)
AxRectangle *rr;
{
    XRectangle rects[1];

    rects[0].x = rr->origin.x;
    rects[0].y = rr->origin.y;
    rects[0].width  = rr->corner.x - rr->origin.x;
    rects[0].height = rr->corner.y - rr->origin.y;
    XSetClipRectangles(Dpy, Gc1, 0, 0, rects, 1, Unsorted);
}

void WMUnsetClip()
{
    XSetClipMask(Dpy, Gc1, None);
}


void WMfbInit(bp)
    A_Bitmap *bp;
{
    bp->mapdata = NULL;    /* no access to frame buffer as bitmap */
}

int AxClearArea(w, x, y, width, height, mills)
AXWidget w;
int x,y;
int width, height;
int mills; /* True if coordiantes are in mills */
{
    Drawable xwin;
    int x_off, y_off;
    /* get the drawable */
    xwin = AxGetDrawableFromWidget(w, &x_off, &y_off);
    if (mills)
    {
        x = X_MILLS_TO_PIXELS(x);
        y = Y_MILLS_TO_PIXELS(y);
        width = X_MILLS_TO_PIXELS(width);
        height = Y_MILLS_TO_PIXELS(height);
    }
    XClearArea(Dpy, xwin, x, y, width, height, TRUE);
}

int
createMovementMaps(actionFlag, x, y, width, height, xOff, yOff, convertToPix)
int actionFlag, x, y;
unsigned int width, height;
int xOff, yOff;
int convertToPix;
{
 static Pixmap saveMap, moveMap, screenMap;
 static unsigned int mapWidth, mapHeight;
 static int xOffset, yOffset;
 static orMode;
 static int lastX, lastY;
 static int lastmoveMapXPos, lastmoveMapYPos;
 AxRectangle unclippedRct;
 int moveMapXPos, moveMapYPos;
 int screenMapXPos, screenMapYPos;
 int i;
 int xPos, yPos;
 unsigned long planeMask;

 if ( convertToPix )
 {
    x = X_MILLS_TO_PIXELS(x);
    y = Y_MILLS_TO_PIXELS(y);
    width = X_MILLS_TO_PIXELS(width);
    height = Y_MILLS_TO_PIXELS(height);
 }

 switch( actionFlag )
 {
    case 0: /* initialize */
        mapWidth = width;
        mapHeight = height;
        xOffset = X_MILLS_TO_PIXELS(xOff);
        yOffset = Y_MILLS_TO_PIXELS(yOff);
        saveMap = XCreatePixmap(Dpy, HostWin,
                                (unsigned int)(mapWidth),
                                (unsigned int)(mapHeight),
                                (unsigned int)DpyDepth);
        moveMap = XCreatePixmap(Dpy, HostWin,
                                (unsigned int)(mapWidth),
                                (unsigned int)(mapHeight),
                                (unsigned int)DpyDepth);
        orMode = GXor;
        break;
/* after got window map, dissasociate from window and restore Hostwin
 * then get save info from HostWin, copy to dissasociated window,
 * copy move map onto it, copy to HostWin - remember to free it when
 * finished */
    case 1: /* setup contents of move map */
        if(DpyDepth==1 && !BlackPixel(Dpy,DefaultScreen(Dpy)))
        {
            XSetFunction(Dpy, Gc1, GXcopyInverted);
        }
        else
        {
            XSetFunction(Dpy, Gc1, GXcopy);
        }
        XCopyArea(Dpy, HostWin, moveMap, Gc1,
                  x, y, mapWidth, mapHeight, 0, 0);
#if 1
        screenMap = Wp->xMap;
        Wp->xMap = -1;
        HostWin = Wp->xwin;
#endif
        lastX = x;
        lastY = y;
        break;

    case 2: /* move */
        if ( x > lastX )
        {
            screenMapXPos = lastX - xOffset;
            moveMapXPos = screenMapXPos + x - lastX;
            width = x - lastX + mapWidth;
        }
        else
        {
            screenMapXPos = x - xOffset;
            moveMapXPos = screenMapXPos;
            width = lastX - x + mapWidth;
        }

        if ( y > lastY )
        {
            screenMapYPos = lastY - yOffset;
            moveMapYPos = screenMapYPos + y - lastY;
            height = y - lastY + mapHeight;
        }
        else
        {
            screenMapYPos = y - yOffset;
            moveMapYPos = screenMapYPos;
            height = lastY - y + mapHeight;
        }

#if 0
        lastX = x;
        lastY = y;

        /* COPY the area of the screen pixmap to be used */
        XSetFunction(Dpy, Gc1, GXcopy);
        XCopyArea(Dpy, HostWin, saveMap, Gc1,
                  moveMapXPos, moveMapYPos, mapWidth, mapHeight,
                  0, 0);
        
        /* OR the move map onto the screen pixmap */
        XSetFunction(Dpy, Gc1, orMode);
        XCopyArea(Dpy, moveMap, HostWin, Gc1,
                  0, 0, mapWidth, mapHeight,
                  moveMapXPos, moveMapYPos);

        /* COPY the portion of the screen pixmap onto the window */
        XSetFunction(Dpy, Gc1, GXcopy);
        XCopyArea(Dpy, HostWin, Wp->xwin, Gc1,
                  screenMapXPos, screenMapYPos, width, height,
                  screenMapXPos, screenMapYPos);

        /* restore the screen pixmap */
        XCopyArea(Dpy, saveMap, HostWin, Gc1,
                  0, 0, mapWidth, mapHeight,
                  moveMapXPos, moveMapYPos);
#else
        /* COPY the portion of the window onto the screen pixmap */
        XSetFunction(Dpy, Gc1, GXcopy);
        XCopyArea(Dpy, HostWin, screenMap, Gc1,
                  screenMapXPos, screenMapYPos, width, height,
                  screenMapXPos, screenMapYPos);

        /* restore the previously damaged portion of the screen pixmap */
        XCopyArea(Dpy, saveMap, screenMap, Gc1,
                  0, 0, mapWidth, mapHeight,
                  lastmoveMapXPos, lastmoveMapYPos);

        /* COPY the area of the screen pixmap to be used for later resoration */
        XSetFunction(Dpy, Gc1, GXcopy);
        XCopyArea(Dpy, screenMap, saveMap, Gc1,
                  moveMapXPos, moveMapYPos, mapWidth, mapHeight,
                  0, 0);

        /* OR the move map onto the screen pixmap */
        XSetFunction(Dpy, Gc1, orMode);
        XCopyArea(Dpy, moveMap, screenMap, Gc1,
                  0, 0, mapWidth, mapHeight,
                  moveMapXPos, moveMapYPos);

        /* COPY the portion of the screen pixmap onto the window */
        XSetFunction(Dpy, Gc1, GXcopy);
        XCopyArea(Dpy, screenMap, HostWin, Gc1,
                  screenMapXPos, screenMapYPos, width, height,
                  screenMapXPos, screenMapYPos);

        lastX = x;
        lastY = y;
        lastmoveMapXPos = moveMapXPos;
        lastmoveMapYPos = moveMapYPos;
#endif
        break;

    case 3: /* terminate */
        XFreePixmap(Dpy, saveMap);
        XFreePixmap(Dpy, moveMap);
#if 1
        XFreePixmap(Dpy, screenMap);
        if(outputBuffer != NULL)
            free(outputBuffer);
         if(imageFp != 0)
            closei(imageFp);
#endif
        break;
    }
    return(AOK);
}


/*************************************************************************
function: SetWpFromX11Window - Return FALSE on failure
*/
struct wind_struct *SetWpFromX11Window(winP)
Window winP;
{
    int ix;
    for ( ix =0; ix < TM_MAXWIN; ix++ )
    {
        if ( window[ix].busy_flag )
        {
            if ( (window[ix].xwin == winP) || (window[ix].xMap == winP)  ||
                    (window[ix].editwin == winP) || 
                    (window[ix].inCellWin == winP) || 
                    (window[ix].rowwin == winP) || 
                    (window[ix].colwin == winP) )
            {
                Wp = &window[ix];
                if(Wp->xMap == -1)
                    HostWin = Wp->xwin;
                else
                    HostWin = Wp->xMap;
                return( Wp );
            }
        }
    }
    return( (struct wind_struct *)NULL );
}


/*************************************************************************
function: ButtonEventType - Interpret combination of mouse button and keys 
in Motif and OpenLook.  ( Called ONLY from stkAction() and pick_term() )
*/
int ButtonEventType()
{
    int type;
    int button, shifted, controled;

    button = MevButton;
    shifted = ThimIsShifted();
    controled = ThimIsControled();

    if ( AxOpenLook )
    {
        if ( button == TM_L_BUTTON ) {
            if ( controled && !shifted )
                type = TM_MULTIPLE_SELECT;
            else
                type = TM_NORMAL_SELECT;
        }
        else if ( button == TM_M_BUTTON )
            type = TM_EXTENDED_SELECT;
        else
            type = TM_IGNORE_SELECT;
    }
    else
    {
        if ( button == TM_L_BUTTON ) {
            if ( shifted && !controled )
                type = TM_EXTENDED_SELECT;
            else if ( controled && !shifted )
                type = TM_MULTIPLE_SELECT;
            else
                type = TM_NORMAL_SELECT;
        }
        else if ( button == TM_M_BUTTON )
            type = TM_PASTE_SELECT;
        else
            type = TM_IGNORE_SELECT;
    }

    return(type);
}

/*************************************************************************
function: AxPutImageOntoWidget - copy image onto widget
*/
void AxPutImageOntoWidget ( header, dataP, dstX,dstY, win_handle, context )
char *header, *dataP; /* image buffer                                   */
int dstX, dstY;       /* where to start drawing in window, in pel's     */
char *win_handle;       /* to get to window                               */
char *context;
{
    GC Gc;
    Drawable w;  
    XImage *ximg;

    ximg = (XImage *)header;
    ximg->data = dataP;
    w = (Drawable)win_handle;
    Gc = (GC)context;

    XPutImage ( Dpy, w, Gc, ximg,
                0,0, dstX,dstY,
                ximg->width, ximg->height );
}

/***************************************************************************
function: AxSubImage - Extract a sub-image from an image.
THE RECTANGLE DEFINED BY (x, y, width, height) MUST BE CONTAINED IN THE IMAGE
*/
XImage *AxSubImage (ximg, x, y, width, height)
XImage *ximg;
int x, y;
int width, height;
{
    return(XSubImage(ximg, x, y, width, height));
}

/***************************************************************************
 * TmToggleToolBar - display/hide tool bar
 */
void TmToggleToolBar()
{
    if ( cur_win > 0 )
        AxXmToggleToolBar(WidgetOfWindow(cur_win));
}

void AxDestroyImage(im)
char *im;
{
    XImage *ximg;

    ximg = (XImage *)im;
    XDestroyImage(ximg);
}


/*************************************************************************
function: TmReloadMenuBar - Update windows based on menubar type
Called by ElfbSelections()
*/
void TmReloadMenuBar (type)
int type;
{
    int ix;

    for (ix = 0; ix < TM_MAXWIN; ix++) {
        if (window[ix].busy_flag && (window[ix].wind_attr.menubar_id == type))
            CreateOrChangeMenuBar(WidgetOfWindow(ix));
    }
}


char *GetProfileByStr();

/*************************************************************************
function: AxExitThisAppWindow - Select the exit option
*/
void AxExitThisAppWindow ()
{
    char *name;

    if ( !Wp || !Wp->busy_flag ) {
        RingTheBell();
        return;
    }
    make_curwin(Wp->window_id);

    switch ( Wp->ap_id ) {
    case APUCM:
        name = GetProfileByStr(NXLT("meWindowDeleteMacro"));
        if ( !name[0] )
            name = NXLT("ME_QUIT_DLG@");
        break;
    case APDC:
    case APEQN:
    case APHTML:
        name = GetProfileByStr(NXLT("wpWindowDeleteMacro"));
        if ( !name[0] )
            name = NXLT("WP_QUIT_DLG@");
        break;
    case APSS:
        /** This is a hack for the print preview. Since the print preview
            is not a task by itself but a window created by ss. And when 
            one pulls down a motif window  on the print preview and exits
            it brings down the ss also. So to get around this bug we make 
            a trivial check. Hopefully this would not break something else
                -vikas **/  
        if (Wp->wind_attr.icon_id == IC_SSPR) {
            name = NXLT("SS_PREVIEW_CLOSE@") ;
        } else {
            name = GetProfileByStr(NXLT("ssWindowDeleteMacro"));
            if ( !name[0] )
                name = NXLT("SS_QUIT_DLG@");
        }
        break;
    case APGE:
    case APBG:
        name = GetProfileByStr(NXLT("grWindowDeleteMacro"));
        if ( !name[0] )
            name = NXLT("GR_QUIT_DLG@");
        break;
    case APPIXED:
        name = GetProfileByStr(NXLT("pxWindowDeleteMacro"));
        if ( !name[0] )
            name = NXLT("PIXEL_CLOSE@");
        break;
    default:
        RingTheBell();
        return;
    }

    AxSendMes(Wp->p_id,name,strlen(name)+1,APMENUBAR);

}



/*** from tmwin.c ***/
/*****************************************************************/          
/* TmCreate function */                                                      
                                                                             
void
atm_create(mes, mesLen, flag, mesback)
char *mes;
short mesLen;
short flag;
char *mesback;  /* return msg buffer for local (flag=2) calls THIMBLE-only */
{
    typeErr PCkCreate();

    union
    {
        struct SCreateData cr_data;
        char rec_buf[MAX_TO_ATM];
    } rec_pack;

    union
    {
        struct RCreateData cr_data;
        char sen_buf[sizeof(struct RCreateData)];
    } sen_pack;

    extern short MaxwWid, MaxwHt;
    short winID, actDonor, oldSubID;
    short i;
    struct wind_struct *pwp;    /* parent window pointer */
    short pwid;                 /* parent window ID */
    short status;
    extern short THIMappid;     /* Current tasks application type */
    extern short THIMpid;

    ATMmesMov(mes, rec_pack.rec_buf, mesLen, MAX_TO_ATM, flag);

    /*
     * Note: borderless, fullscreen, and TM_SCREEN_REL positioning are current-
     * ly implemented as a package.  The flag 'borderless' is used in the
     * code to identify the special case of the three together.
     * To unbundle the feature, presumably a 'fullscreen' flag would be
     * introduced.
     *     Evolving toward this scheme, 'bordlerless' and TM_SCREEN_REL are
     * now being set for the status/selection line window. (3-28-88)
     */
    if (rec_pack.cr_data.cr_pack.modifiers.borderless)
        rec_pack.cr_data.cr_pack.modifiers.rel_pos = TM_SCREEN_REL;
    status = TMR_OK;

    if (rec_pack.cr_data.cr_pack.modifiers.sub_window)
    {
        /* creating a subordinate window */

        pwid = rec_pack.cr_data.cr_pack.parent_id;  /* parent window ID */
        if (!winExists(pwid) || pwid == ACwin)
        {
            /* don't make window subordinate */

            rec_pack.cr_data.cr_pack.modifiers.sub_window = FALSE;
        }
    }

    winID = 0;      /* minimum window ID */
    while (winID < TM_MAXWIN && window[winID].busy_flag) winID++;
    if (winID == TM_MAXWIN)
        status = TMR_TOOM;

    if (status == TMR_OK)
    {
    Wp = &window[winID];    /* cannot use SetWp() until wind_struct filled in */
    memset(Wp, '\0', sizeof(*Wp));
    Wp->busy_flag = TRUE;
    Wp->widget_uid = ++AxWindowCreationCounter;
    Wp->regen_locked = FALSE;
    TLOGGER((ATfp, "win %d\n", winID));
    Wp->window_id = winID;
    Wp->p_id = THIMpid;
    Wp->ap_id = THIMappid;
    sen_pack.cr_data.window_id = winID;

    Wp->wind_attr = rec_pack.cr_data.cr_pack;
    /*
     * override 0-valued component of set-aside position, treat as
     * default selection
     */
    if (Wp->wind_attr.sa_x_position == 0) Wp->wind_attr.sa_x_position = -1;
    if (Wp->wind_attr.sa_x_position == 0) Wp->wind_attr.sa_x_position = -1;

    /* assign prompt status if mode dependent */

    Wp->title_len = rec_pack.cr_data.title_len;
    Wp->option_len = rec_pack.cr_data.option_len;
    Wp->help_num = rec_pack.cr_data.help_num;

    if(1)   /* if(Wp->title_len != ZERO) */
    {
        Wp->wind_attr.title_line=ATMmalloc(Wp->title_len+1);
        for(i=0;i<Wp->title_len;++i)
            Wp->wind_attr.title_line[i] =
            rec_pack.rec_buf[i + sizeof(struct SCreateData)];
        Wp->wind_attr.title_line[i] = NUL;
    }
    TLOGGER((ATfp, "title: %s\n", Wp->wind_attr.title_line));
    Wp->cur_reg_num = ZERO;
    Wp->sub_window = TM_NULWIN;

    /* normally parent is "donor" of active window status */
    actDonor = Wp->wind_attr.parent_id;
    if (!winExists(actDonor)) actDonor = TM_NULWIN;

    if (Wp->wind_attr.modifiers.sub_window)
    {   /*
         * creating subordinate window; parent exists (checked earlier)
         */
        pwp = &window[actDonor];    /* parent window pointer */
        oldSubID = pwp->sub_window;
        if (oldSubID != TM_NULWIN)  /* parent already has a subordinate */
        {   /*
             * cut off old subordinate,
             * but make it the donor of active window status
             */
            window[oldSubID].wind_attr.modifiers.sub_window = FALSE;
            actDonor = oldSubID;
        }
        pwp->sub_window = winID;    /* put ID in parent's database */
    }

    }  /* if (status == TMR_OK) */
    else
    {
        /* for applications that don't check return status */
        sen_pack.cr_data.window_id = TM_NULWIN;
        TLOGGER((ATfp, "status=%d\n", status));
    }
    if (status == TMR_OK) {
        Wp->trans_mode = B_STORE;
        Wp->bgcolor = 0;    /* DEFAULT_BG */
        Wp->fgcolor = 1;    /* DEFAULT_FG */

        Wp->spWid = -1;
        Wp->newPS = SET;
        Wp->newTit = SET;
        Wp->newBord = SET;
        Wp->stkCode = TMK_NONE;     /* disable local echoing of strokes */
        Wp->stkClip.origin.x = -1;  /* stroke clipping rect never supplied */
        Wp->stkReportF = TRUE;      /* report intermediate stroke points */
        Wp->lin_des.line_style = TM_SOLID;
        Wp->lin_des.line_thickness = TM_VTHIN;
        Wp->txAlign = TM_TOPLEFT;
        if ( ACwin == TM_NULWIN ) { /* check for status line window */
            IntWin = ACwin = winID;
            StatWp = Wp;
            Wp->wind_attr.modifiers.rel_pos = TM_SCREEN_REL;
        }

        /* override min size */
        if (Wp->wind_attr.x_min_size < MinWWid)
            Wp->wind_attr.x_min_size = MinWWid;
        if (Wp->wind_attr.y_min_size < MinWHt)
            Wp->wind_attr.y_min_size = MinWHt;

        if ( Wp->wind_attr.modifiers.borrow_shell )
            Wp->winWasBorrowed = Wp->wind_attr.parent_id;
    
        CreateAxWindow( Wp );
        Wp->creOrd = CreCount++;
        sen_pack.cr_data.widget_id = (long)Wp->shell;
    }  /* if (status == TMR_OK) */

    if(LocTmR)
    {
        /* local call, no ATMsendMes required */
        LocWid = ((status == TMR_OK) ? Wp->window_id : TM_NULWIN);
    }
    else    /* not a local call */
    {
        sen_pack.cr_data.status = status;
        if (flag==2) {    /* local call */
            memcpy(mesback,sen_pack.sen_buf,sizeof(struct RCreateData));
            return;
        }
    }
}  /* atm_create() */


/*** from tmdispat.c ***/
void evDispat(evInd, mes, mesLen, flag, rtnMes)
short evInd;
char *mes;
short mesLen;
short flag;
char *rtnMes; /* return message buf for local calls only THIMBLE-only */
{
    extern int Balmalloc;
    extern int BmapCount;
    extern short CellWidDC;

    if ( TmAmSE ) {             /* forward print serializer messages */
        SEevDispat(evInd, mes, mesLen, rtnMes);
        return;
    }

    if ( (evInd <= MAXEV) && (DispatchTable[evInd] != NULL) )
        (*DispatchTable[evInd])(mes,mesLen,flag,rtnMes);        /* DO IT!!!! */

}  /* evDispat */



/*
*   AxSetEditRowColWin - sets the editwin,rowwin and the colwin  fields 
*                   of the wind_struct to the passed window handles.
*                   Used by ss only.
*/
void AxSetEditRowColWin(wID, editwin, rowwin, colwin, inCellWin)
short wID;  /* ATM window id */
Window editwin,
    inCellWin,
    rowwin,
    colwin;
{
struct wind_struct *wp;
    wp = &window[wID];
    wp->editwin = editwin;
    wp->rowwin = rowwin;
    wp->colwin = colwin;
    wp->inCellWin = inCellWin;
}

/*
*   AxClearEditRowColWin - clears the editwin field from the window ptr.
*    only used by SS.
*/
void AxClearEditRowColWin(wID)
short wID; /* ATM window id */
{
struct wind_struct *wp;
    wp = &window[wID];
    wp->editwin = (Window)None;
    wp->rowwin = (Window)None;
    wp->colwin = (Window)None;
    wp->inCellWin = (Window)None;
}


        /* TmInq function */
void
atm_inq (mes, mesLen, flag,mesback)
char *mes;
short mesLen;
short flag;
char *mesback;    /* return msg buffer for local (flag=2) calls THIMBLE-only */
{
    union
    {
        struct SInqData inq_data;
        char rec_buf[sizeof(struct SInqData)];
    } rec_pack;

    union
    {
        struct RInqData inq_data;
        char sen_buf[sizeof(struct RInqData)];
    } sen_pack;
    short ev_fd;
    short res_fd;
    short i;
    short windId;

    ATMmesMov(mes, rec_pack.rec_buf, mesLen, sizeof(struct SInqData), flag);

#if CHECK && !AXMS
    PCkInq(rec_pack.rec_buf);
#endif
    
    windId = rec_pack.inq_data.window_id;
    wind_pnt = &window[windId ];
    sen_pack.inq_data.x_position = wind_pnt->wind_attr.x_position;
    sen_pack.inq_data.y_position = wind_pnt->wind_attr.y_position;
    sen_pack.inq_data.x_size = wind_pnt->wind_attr.x_size;
    sen_pack.inq_data.y_size = wind_pnt->wind_attr.y_size;
    sen_pack.inq_data.h_sc_pos = wind_pnt->wind_attr.h_sc_pos;
    sen_pack.inq_data.v_sc_pos = wind_pnt->wind_attr.v_sc_pos;
    sen_pack.inq_data.x_cur_pos = 0;
    sen_pack.inq_data.y_cur_pos = 0;
    sen_pack.inq_data.curtype = 0;
    memcpy(mesback,sen_pack.sen_buf,sizeof(struct RInqData));
    return; 
}


void
cacheGEPixmap(w, name)
AXWidget w;
char *name;
{
    /* pass value of work area background pixel (AlisPixels[TMA_WHITE]),
    which will be treated as transparent */
    Drawable drw;
    int x_off, y_off;
    int wid, hyt;

    drw = AxGetDrawableFromWidget(w, &x_off, &y_off);
    AxGetSizeOfWidget(w, &wid, &hyt);
    addGEPixmapToCache(name, drw, wid, hyt, AlisPixels[TMA_WHITE]);
}

/*************************************************************************
function: createPixmap - Create pixmap for dump
*/
typeErr
createPixmap(w, pix_id, mil_wid, mil_hyt, pel_wid, pel_hyt, nMapsInGE)
AXWidget w;
int *pix_id;
int mil_wid, mil_hyt;
int *pel_wid, *pel_hyt;
int *nMapsInGE;
{
    int bufferSize;
    Pixmap pixmap;

    
    *pel_wid = widthInPels  = X_MILLS_TO_PIXELS(mil_wid);
    *pel_hyt = heightInPels = Y_MILLS_TO_PIXELS(mil_hyt);


    /* Create the pixmap */
    *nMapsInGE = 1;
    pixmap = AxCreateQueryPixmap(Dpy, DefaultRootWindow(Dpy),
                            (unsigned int)(widthInPels),
                            (unsigned int)(heightInPels),
                            (unsigned int)DpyDepth);
    
    /* If you can't get it in one chunk, try for smaller and smaller pieces */
    while(pixmap == (Pixmap)NULL)
    {
        if(heightInPels < 1)
            break;
    
        pixmap = AxCreateQueryPixmap(Dpy, DefaultRootWindow(Dpy),
                                    (unsigned int)(widthInPels),
                                    (unsigned int)(heightInPels),
                                    (unsigned int)DpyDepth);
    
        heightInPels /= 2;
        (*nMapsInGE)++;
    }

    /* Book-keeping and clean up */
    if((pixmap ==(Pixmap)NULL))
    {
        *nMapsInGE = 0;
        heightInPels = widthInPels = 0;
        return(!AOK);
    }
    else
    {
        *pix_id = (int)pixmap;
        return(AOK);
    }
}




/*************************************************************************
function: createImage - create XImage 
*/
unsigned char *createImage(w,wid,hyt,redraw)
AXWidget w;
int wid, hyt;
int redraw; 
{
    XImage *imageMap;
    char   *imageData;
    int size,bwid;

    if ( DpyDepth > 8 )
    {
        bwid = 4 *wid;
        size = bwid * hyt;
        imageData = (char *) malloc(size * sizeof(char));
        memset( imageData, 0x0, size * sizeof(char));

        imageMap = (XImage *)XCreateImage( Dpy, DefaultVisual( Dpy,
                                           DefaultScreen( Dpy )),
                                           (unsigned int) DpyDepth, ZPixmap,0,
                                           (char *)imageData,
                                           (unsigned int) wid, 
                                           (unsigned int) hyt,32,bwid);
    }
    else if ( DpyDepth == 8 )
    { 
        bwid = wid + wid%2;
        size = bwid * hyt;
        imageData = (char *) malloc(size * sizeof(char));
        memset( imageData, 0x0, size * sizeof(char));
    
        imageMap = (XImage *)XCreateImage( Dpy, DefaultVisual( Dpy,
                                           DefaultScreen( Dpy )),
                                           (unsigned int) DpyDepth, ZPixmap,0,
                                           (char *)imageData,
                                           (unsigned int) wid, 
                                           (unsigned int) hyt,16,bwid);
    }
    else if ( DpyDepth == 4 )
    {
        bwid = ( wid + 1 )/2 + ( ( wid + 1 )/2 )%2;
        size = bwid * hyt;
        imageData = (char *) malloc(size * sizeof(char));
        memset( imageData, 0x0, size * sizeof(char));

        imageMap = (XImage *)XCreateImage( Dpy, DefaultVisual( Dpy,
                                           DefaultScreen( Dpy )),
                                           (unsigned int) DpyDepth, ZPixmap,0,
                                           (char *)imageData,
                                           (unsigned int) wid, 
                                           (unsigned int) hyt,16,bwid);
    }
    else
    {

        bwid = ( wid+7 )/8 + ( ( wid+7 )/8 )%2;
        size = bwid * hyt;
        imageData = ( char * ) malloc( size * sizeof( char ));
        memset( imageData, 0x0, size * sizeof(char));

        imageMap = (XImage *)XCreateImage( Dpy, DefaultVisual( Dpy,
                                           DefaultScreen( Dpy )),
                                           (unsigned int) DpyDepth, ZPixmap,0,
                                           (char *)imageData,
                                           (unsigned int) wid, 
                                           (unsigned int) hyt,16,bwid);
    }
    return(( unsigned char *)imageMap );
}

/*************************************************************************
function: localizePixmap - get XImage from pixmap
*/
typeErr
localizePixmap(w, slicehyt,image,x,y, headP, dataP,headSize, dataSize, hyt,wid)
AXWidget w;
int slicehyt;
int x,y;
char **headP, **dataP;
unsigned char *image;
int *headSize, *dataSize;
int *hyt, *wid;
{
    XImage *imageMap;
    int i,height,x_loc,y_loc;
    int x_off, y_off;
    Drawable xwin;

    imageMap = (XImage *)image;
    /* Get the data from the pixmap */
    if ( imageMap == (XImage *)NULL )
    {
        *headP = *dataP = NULL;
        *headSize = *dataSize = 0;
        *wid = *hyt = 0;
        return(!AOK);
    }
    x_loc  = X_MILLS_TO_PIXELS(x);
    y_loc  = Y_MILLS_TO_PIXELS(y);
    height = Y_MILLS_TO_PIXELS(slicehyt);

    /* get the drawable */
    xwin = AxGetDrawableFromWidget(w, &x_off, &y_off);
    imageMap = AxGetSubImage(Dpy, xwin, 0, 0, widthInPels,  height,
                            AllPlanes, ZPixmap, imageMap,x_loc,y_loc);
    if ( imageMap == (XImage *)NULL )
    {
        *headP = *dataP = NULL;
        *headSize = *dataSize = 0;
        *wid = *hyt = 0;
        return(!AOK);
    }
    else
    {
        *headP = (char *)imageMap;
        *headSize = sizeof(XImage);
        *dataP = (char *)imageMap->data;
        *dataSize = imageMap->bytes_per_line * imageMap->height;
        *wid = widthInPels;
        *hyt = imageMap->height;
        return(AOK);
    }
}

/*************************************************************************
function: readPixmap - Read bits from pixmap created for dump
*/
typeErr
readPixmap(winID, sliceNumber)
short winID;
int sliceNumber;
{
#if 0
	XImage *imageMap;
	int x, y;
	imageInfo imInfo;
	unsigned char bitMask, outVal, *outByte;
	unsigned long pixelValue; /* hoping only the lower 8 bits are significant */
	int invertPix;

	/* Get the data from the pixmap */
	imageMap = XGetImage(Dpy, Wp->xMap, 0, 0, widthInPels, heightInPels, AllPlanes, ZPixmap);
	if(imageMap == NULL)
	{
		/* Fail, and pass along the information */
		return(!AOK);
	}

	/* before extraction, note if mono pix must be inverted */
	if(!ColorDisplay)
	{
		invertPix = FALSE;
		if (BlackPixel(Dpy, DefaultScreen(Dpy)))
		{
			if (ToggleFG)
			{
				invertPix = TRUE;
			}
		}
		else
		{
			if (!ToggleFG)
			{
				invertPix = TRUE;
			}
		}
	}

	/* Extract the data, transforming it to a useful format */
	for(y=0; y<imageMap->height; y++)
	{
		bitMask = 0x80;
		outVal = 0;
		memset(outputBuffer, 0, imageFp->byte_width);
		outByte = outputBuffer;
		for(x=0; x<imageMap->width; x++)
		{
			/* this methid is very slow...speed up later */
			pixelValue = XGetPixel(imageMap, x, y);
			if ( NoColor == FALSE )
			{
				if(pixelValue != AlisPixels[0] && pixelValue != AxPixels[215])
					outVal |= bitMask;
			}
			/* mono */
			else if(invertPix)
			{
				if(pixelValue == TMA_WHITE)
					outVal |= bitMask;
			}
			else
			{
				if(pixelValue != TMA_WHITE)
					outVal |= bitMask;
			}

			if((bitMask >>=1) == 0)
			{
				*outByte++ = outVal;
				outVal = 0;
				bitMask = 0x80;
			}
		}

		/* Finish up that last byte */
		if(bitMask != 0x80)
			*outByte = outVal;

		if(scanw(imageFp, outputBuffer) != imageFp->byte_width)
		{
			XDestroyImage(imageMap);
			return(!AOK);
		}
	}

	XDestroyImage(imageMap);
#endif
	return(AOK);
}

/*************************************************************************
function: deletePixmap - Delete pixmap created for dump
*/
typeErr
deletePixmap(w, deleteFlag)
AXWidget w;
int deleteFlag;
{
    Drawable xwin;
    int x_off, y_off;

    /* get the drawable */
    xwin = AxGetDrawableFromWidget(w, &x_off, &y_off);

    /* Make sure there is a pixmap associated with this window... */
    if (xwin != 0)
    {
        if ( deleteFlag )
            XFreePixmap(Dpy, xwin);
        xwin = -1;
    }
    return(AOK);
}


/****************************************************************************
function AxCopyArea - Copies a pixmap on to a application window
*/

void AxCopyArea(filename, wid, x, y)
char *filename; /* file containing the pixmap */
short wid; /* ATM window id */
int x,y;    /* x and y positions on the destination window where the pixmap*/
            /* is to be copied */
{
Window xwin;
AxRectangle *clipRct, unclippedRct, clippedRct;
int width, height;
Pixmap pix;
XRectangle rects[1];

    struct wind_struct *winP;

    /* get the X window id */
    xwin = XWinFromATMWin(wid);

    /* set Wp to the specified window if not already set */
    winP = SetWp(&window[wid]);

    /* read the pixmap */
    if( !AxGetPixmap(filename, &pix, &width, &height))
        return; /* pixmap not available */

    /* set the window pointer again */
    winP = SetWp(&window[wid]);

    /* get the current clipping rectangle from the window structure */
    if(winP->layer)
        clipRct = &(winP->layer->curClip);
    else
        clipRct = &(winP->appClip);

    rects[0].x = clipRct->origin.x;
    rects[0].y = clipRct->origin.y;
    rects[0].width = clipRct->corner.x - clipRct->origin.x + 1;
    rects[0].height = clipRct->corner.y - clipRct->origin.y + 1;

    /* set the clipping rectangle */
    XSetClipRectangles(Dpy, Gc1, 0, 0, rects, 1, Unsorted);
    /* copy the area */
    XCopyArea(Dpy, pix, xwin, Gc1, 0, 0, width, height, x, y);
    /* reset the clipping rectangle */
    XSetClipMask(Dpy, Gc1, None);
}

/*************************************************************************
function: AxLoadDrawable
*/
typeErr
AxLoadDrawable(winID, drw, x1,y1, x2,y2)
int winID;
Drawable drw;
int *x1, *y1, *x2, *y2;
{
    AxRectangle old_clip;
	short x, y;

    /* Make sure the window exists... */
    if ( !winExists(winID) || (winID == 0) )
        return(TMR_NOWIN);
    
    /* then get a pointer to the window structure and set HostWin */
    SetWp(&window[winID]);

    /* set the clip */
    old_clip = Wp->inner;
	x = *x2;
	y = *y2;
    milPix(&x, &y);
	*x2 = x;
	*y2 = y;
    Wp->inner.origin.x = 0;
    Wp->inner.origin.y = 0;
    Wp->inner.corner.x = *x2;
    Wp->inner.corner.y = *y2;
    Wp->appClip = Wp->outer = Wp->inner;
    *x1 = old_clip.origin.x;
    *y1 = old_clip.origin.y;
    *x2 = old_clip.corner.x;
    *y2 = old_clip.corner.y;

    /* hope this is not called if there is already an aux drawable */
    if ( drw )
        HostWin = Wp->xMap = drw;

    return(AOK);
}

/*************************************************************************
function: AxClearDrawable
*/
typeErr
AxClearDrawable(winID, x1,y1, x2,y2)
int winID, x1,y1, x2,y2;
{
    /* Make sure the window exists... */
    if ( !winExists(winID) || (winID == 0) )
        return(TMR_NOWIN);
    
    /* then get a pointer to the window structure and set HostWin */
    SetWp(&window[winID]);
    Wp->inner.origin.x = x1;
    Wp->inner.origin.y = y1;
    Wp->inner.corner.x = x2;
    Wp->inner.corner.y = y2;
    Wp->appClip = Wp->outer = Wp->inner;

    /* Make sure there is an aux drawable associated with this window... */
    if ( Wp->xMap != 0 )
    {
        Wp->xMap = -1;
        HostWin = Wp->xwin;
    }

    return(AOK);
}
/************************************************************************ 
 * function AxGetPixel32 -
 */
unsigned long
AxGetPixel32(ximage,x,y)
register XImage *ximage;
int x,y;
{
    register unsigned char *addr;
    unsigned long pixel;

    addr = &((unsigned char *)ximage->data)
             [y * ximage->bytes_per_line + (x << 2)];
    if ( ximage->byte_order == MSBFirst )
    {
        pixel = ( (unsigned long)addr[0] << 24 |
                 (unsigned long)addr[1] << 16 |
                 (unsigned long)addr[2] << 8 |
                  addr[3] );
    }
    else
    {
        pixel = ( (unsigned long)addr[3] << 24 |
                 (unsigned long)addr[2] << 16 |
                 (unsigned long)addr[1] << 8 |
                  addr[0] );
    }
    return pixel;
}
/************************************************************************ 
 * function AxGetPixel16 -
 */
unsigned long
AxGetPixel16(ximage,x,y)
register XImage *ximage;
int x,y;
{
    register unsigned char *addr;
    unsigned long pixel;

    addr = &((unsigned char *)ximage->data)
             [y * ximage->bytes_per_line + (x << 1)];
    if ( ximage->byte_order == MSBFirst )
        pixel = ( (unsigned long)addr[0] << 8 | addr[1] );
    else
        pixel = ( (unsigned long)addr[1] << 8 | addr[0] );

    return pixel;
}
/************************************************************************ 
 * function AxGetPixel24 -
 */
unsigned long
AxGetPixel24(ximage,x,y)
register XImage *ximage;
int x,y;
{
    register unsigned char *addr;
    register char *src;
    register char *dst;
    register int i, j;
    unsigned long pixel,px;

    src = &ximage->data[ZINDEX(x, y, ximage)];
    dst = (char *)&px;
    px  = 0;
    for (i = (ximage->bits_per_pixel + 7) >> 3; --i >= 0; )
        *dst++ = *src++;
    if ( ximage->byte_order == MSBFirst )
        ZNORMALIZE(&px, ximage);
    pixel = 0;
    for (i=sizeof(unsigned long); --i >= 0; )
        pixel = (pixel << 8) | ((unsigned char *)&px)[i];
    if (ximage->bits_per_pixel == ximage->depth)
        return pixel;
    else
        return (pixel & low_bits_table[ximage->depth]);
}
/************************************************************************/
static normalizebits(bp,img)
register unsigned char *bp;
register XImage *img;
{
    register unsigned char c;
    switch ( img->bits_per_pixel ) 
    {
        case 24:
                c = *(bp + 2);
                *(bp + 2) = *bp;
                *bp = c;
        break;
        case 32:
                c = *(bp + 3);
                *(bp + 3) = *bp;
                *bp = c;
                c = *(bp + 2);
                *(bp + 2) = *(bp + 1);
                *(bp + 1) = c;
        break;
    }

}
/************************************************************************/
unsigned long
AxGetPixel(ximage,x,y)
register XImage *ximage;
int x,y;
{
    return (XGetPixel(ximage,x,y));
}

/***************************************************************************
function: AxGetClip
*/
AxGetClip(wID, rect)
short wID;
TmRect32 *rect;
{
    rect->x_position = window[wID].appClip.origin.x;
    rect->y_position = window[wID].appClip.origin.y;
    rect->x_size  = window[wID].appClip.corner.x - rect->x_position;
    rect->y_size = window[wID].appClip.corner.y - rect->y_position;
    conv_i_p32(&rect->x_position, &rect->y_position,
               &rect->x_position, &rect->y_position, PIXEL_TO_MILLS);
    conv_i_p32(&rect->x_size, &rect->y_size,
               &rect->x_size, &rect->y_size, PIXEL_TO_MILLS);
}
/************************************************************************/
/************************************************************************/

void AxSetClip(gc, rr)
GC gc;
TmRect32 *rr;
{
    XRectangle rects[1];
    int x1, y1, x2, y2;
    if(NULL == rr)
        return;

    /* get the corner points (in MILLS) */
    x1 = rr->x_position;
    y1 = rr->y_position;
    x2 = rr->x_size + x1 - 1;
    y2 = rr->y_size + y1 - 1;

    /* convert from MILL to PIXELS */
    conv_i_p32(&x1, &y1, &x1, &y1, MILLS_TO_PIXEL);
    conv_i_p32(&x2, &y2, &x2, &y2, MILLS_TO_PIXEL);

    /* create a rect and set it as the clip */
    rects[0].x = x1;
    rects[0].y = y1;
    rects[0].width  = x2 - x1 + 1;
    rects[0].height = y2 - y1 + 1;
    XSetClipRectangles(Dpy, gc, 0, 0, rects, 1, Unsorted);
}
/*************************************************************************
function: AxGetDrawableFromWidget - returns drawable from widget
*/
Drawable 
AxGetDrawableFromWidget(wd, x_off, y_off)
AXWidget wd;
int *x_off, *y_off;
{
    Drawable xwin;

    if ( !wd )
        xwin = (Drawable)NULL;
    else
    {
        *x_off = wd->xpos;
        *y_off = wd->ypos;
        switch(wd->type)
        {
            case W_DIALOG:
                xwin = wd->parent->window;
            break;
            case W_LABEL:
            case W_TOGGLE:
            case W_RADIO:
            case W_OPTION:
            case W_LIST:
            case W_SCROLL:
            case W_ENTER:
            case W_ICON:
            case W_HGROOVE:
            case W_POPUP:
            case W_WORK:
            case W_MENUBAR:
            case W_RULER:
            case W_CORNER:
            case W_TOOLBAR:
            case W_EDITBOX:
            case W_COLORPAL:
            case W_RIBBON:
                xwin = (Drawable)NULL;
            break;
            case W_BUTTON:
            case W_RECT:
            case W_PALETTE:
                xwin = wd->parent->window;
            break;
            case W_MAIN:
                xwin = ((AXWidget_main) wd)->workWindow->window;
            break;
            case W_STATUS:
                xwin = wd->window;
            break;
            case W_DEBUG:
                xwin = wd->parent->window;
            break;
            case W_SPLITTER:
                xwin = wd->parent->window;
            break;
            case W_SCALE:
                xwin = wd->parent->window;
            break;
            case W_GE_XRULER:
            case W_GE_YRULER:
                xwin = wd->window;
            break;
            case W_ALIGN:
                xwin = (Drawable)NULL;
            break;
            case W_TABLE:
                xwin = wd->window;
            break;
                case W_KANJI_KANA:
            case W_ROWCOL:
            case W_KANJI_STATUS:
                xwin = (Drawable)NULL;
            break;
            case W_CANVAS:
                xwin = wd->window;
            break;
            case W_TRAY:
                xwin = wd->window;
            break;
            case W_PLATES:
                xwin = (Drawable)NULL;
            break;
            default:
                xwin = (Drawable)NULL;
            break;
        }
    }
    return(xwin);
}

/*************************************************************************
function: AxSetDrawableOfWidget - changes drawable of a W_MAIN widget
*/
Drawable AxSetDrawableOfWidget(wd, drw)
AXWidget_main wd;
Drawable drw;
{
    Drawable xwin;
    if ( !wd )
        xwin = (Drawable)NULL;
    else switch(wd->type)
    {
        case W_DIALOG:
        case W_RECT:
        case W_BUTTON:
            xwin = wd->parent->window;
            wd->parent->window = drw;
        break;
        case W_MAIN:
            xwin = wd->workWindow->window;
            wd->workWindow->window = drw;
        break;
        case W_TABLE:
        case W_CANVAS:
        case W_TRAY:
            xwin = wd->window;
            wd->window = drw;
        break;
        default:
            xwin = (Drawable)NULL;
        break;
    }
    return(xwin);
}

int Creating_atm_window = FALSE;

/*************************************************************************
function: CreateAxWindow - Create X frame, make things look like ATM info
*/
void CreateAxWindow(windowP)
struct wind_struct *windowP;
{
    int width, height, xpos, ypos, msg_width;
    int i, an =0, n,  selection;
    XFontStruct *font;
    char *fontname;
    Window xwin;
    AXWidget workplace, button, label;
    AXWidget_menu menu_bar;
    AXWidget_main main_win, shell;
    AXWidget menu, menu_top, build_menu(), dlg_box;
    AXWidget vbar = 0, hbar = 0;
    Arg arglist[20];
    static XtCallbackRec callback_list[2];  /* ??1 static? */
    char title[STRPATH+1];  /* STRPATH should be long enough! */
    extern int ThimNoWindowsLeft;   /* goes TRUE after terming last window */
    int min_width = 0, min_height = 0;
    int max_width = 0, max_height = 0;
    struct wind_struct *temp_wp;
    extern Colormap ApplixCmap;
    AXWidget XmCreateCorner();
    static long trueval = 1;
    extern Atom AxXA_VISIX_ACCEPT_DROP;

    if (!windowP->wind_attr.title_line || !windowP->wind_attr.title_line[0])
        strcpy(title,XLT2("window title","nameless"));
    else
        strcpy(title,windowP->wind_attr.title_line);
    ElfRecord(ELFREC_CRTWIN,title);

    windowP->layer = (Layer*)malloc(sizeof(Layer));
    memset(windowP->layer,0,sizeof(Layer));

    /* Mills to pix of size/pos */
    width = X_MILLS_TO_PIXELS(windowP->wind_attr.x_size);
    height = Y_MILLS_TO_PIXELS(windowP->wind_attr.y_size);
    if ( windowP->wind_attr.x_min_size > 0 )
        min_width = X_MILLS_TO_PIXELS(windowP->wind_attr.x_min_size);
    if ( windowP->wind_attr.y_min_size > 0 )
        min_height = Y_MILLS_TO_PIXELS(windowP->wind_attr.y_min_size);
    if (windowP->wind_attr.x_max_size > 0)
        max_width = X_MILLS_TO_PIXELS(windowP->wind_attr.x_max_size);
    if ( windowP->wind_attr.y_max_size > 0 )
        max_height = Y_MILLS_TO_PIXELS(windowP->wind_attr.y_max_size);
    xpos = X_MILLS_TO_PIXELS(windowP->wind_attr.x_position);
    ypos = Y_MILLS_TO_PIXELS(windowP->wind_attr.y_position);

    windowP->x_zoom = windowP->y_zoom = 1000;
    windowP->inner.origin.x = windowP->inner.origin.y = 0;
    windowP->inner.corner.x = width;
    windowP->inner.corner.y = height;
    windowP->layer->rect = windowP->outer = windowP->inner;
    windowP->appClip = windowP->frClip = windowP->layer->curClip = windowP->layer->rect;
    /* init damaged rect */
    windowP->damagedRect.origin.x = windowP->damagedRect.origin.y = 32767;
    windowP->damagedRect.corner.x = windowP->damagedRect.corner.y = 0;

    if ( windowP->window_id == 0 )
        return;

#if AXMS
    Creating_atm_window = TRUE;
#endif


    strcpy(title,windowP->wind_attr.title_line);
    if ( !title[0] )
        strcpy(title,XLT2("window title","nameless"));

    /* Create a new main window */
    shell = (AXWidget_main) AXtAppCreateShell(title,
                                windowP->wind_attr.icon_name);
    AxSetWidgetVal((AXWidget)shell,AXmNIconId,windowP->wind_attr.icon_id);

    XtSetArg(arglist[0],XmNx,xpos);
    XtSetArg(arglist[1],XmNy,ypos);
    AxXtSetValues((AXWidget)shell,arglist,2);
    XtSetArg(arglist[0],XmNwidth,0);
    XtSetArg(arglist[1],XmNheight,0);
    XtSetArg(arglist[2],XmNminWidth,min_width);
    XtSetArg(arglist[3],XmNminHeight,min_height);
    AxXtSetValues((AXWidget)shell, arglist, 4);
    if (windowP->wind_attr.menubar_id == IC_SSPR) {  /** print preview should
        not be able to resize  ***/
        /** added since we do not want the print preview window to resize */
            XtSetArg(arglist[0],XmNmaxWidth,max_width);
            XtSetArg(arglist[1],XmNmaxHeight,max_height);
            AxXtSetValues((AXWidget)shell, arglist, 2);
            XtSetArg(arglist[0],XmNresize,FALSE);
            AxXtSetValues((AXWidget)shell, arglist, 1);
    } else {  /**all the application should be able to resize **/
            XtSetArg(arglist[0],XmNresize,TRUE);
            AxXtSetValues((AXWidget)shell, arglist, 1);
    }
    if ( windowP->wind_attr.modifiers.windowless )
        shell->display = FALSE;

    windowP->shell = windowP->topwidget = main_win = shell;

    /* Create the menu bar (this relies on windowP->topwidget having been set) */
    if ( windowP->wind_attr.modifiers.windowless )
        menu_bar = 0;
    else
    {
        temp_wp = windowP;
        menu_bar = (AXWidget_menu) CreateOrChangeMenuBar(main_win);
        SetWp(temp_wp);
    }

    /* Create GE Palette/Color Palette/GE Rulers if this is a GE */
    windowP->gridSize = windowP->wind_attr.grid_size;
    windowP->unitPrec = 2;
    if ( !windowP->wind_attr.modifiers.windowless &&
          windowP->wind_attr.modifiers.gr_window )
    {
        temp_wp = windowP;

        /* create the palette */
        windowP->palette = ZXmCreatePalette(main_win, NXLT("palette"));
        if ( windowP->wind_attr.modifiers.gepalette == FALSE )
        {
            XtSetArg(arglist[0], XmNflags, 0x01); /* NODISPLAY, xmlib.h */
            AxXtSetValues((AXWidget)windowP->palette,arglist,1);
        }

        /* create the color palette */
        windowP->colorpal = ZXmCreateColorpal(main_win,NXLT("colorpal"));
        if ( windowP->wind_attr.modifiers.gecolorpal == FALSE )
        {
            XtSetArg(arglist[0], XmNflags, 0x01); /* NODISPLAY, xmlib.h */
            AxXtSetValues((AXWidget)windowP->colorpal,arglist,1);
        }

        /* create the rulers */
        if ( windowP->wind_attr.modifiers.geruler )
        {
            windowP->GExruler = ZXmCreateGExruler(main_win,NXLT("ge_xruler"));
            windowP->GEyruler = ZXmCreateGEyruler(main_win,NXLT("ge_yruler"));
        }

        /* set the initial state of the palette */
        InitPalette(main_win);
        SetWp(temp_wp);
    }

    /* Create Ruler if this is a DC and ruler flag is set */
    if ( ( windowP->wind_attr.icon_id == IC_DC ||
           windowP->wind_attr.icon_id == IC_EQN ||
           windowP->wind_attr.icon_id == IC_HTML ||
            windowP->wind_attr.icon_id == IC_CE ) &&
         windowP->wind_attr.modifiers.ruler ) {
        ThimCreateRuler(windowP->window_id);
    }

    /* Create Plates if this is an SS and plates flag is set */
    if ( ((windowP->wind_attr.icon_id == IC_SS ) || 
                (windowP->wind_attr.icon_id == IC_SSPG)) && 
                (windowP->wind_attr.modifiers.plates) ) {
        ThimCreatePlates(windowP->window_id);
    }

    /* create the work area */
    XtSetArg(arglist[0],XmNwidth,width);
    XtSetArg(arglist[1],XmNheight,height);
    XtSetArg(arglist[2],XmNdialogStyle,XmDIALOG_WORK_AREA);
    workplace = (AXWidget) AXmCreateBulletinBoard((AXWidget)main_win,
												  NXLT("work"), arglist, 3);
    windowP->workWidget = (AXWidget_work)workplace;
    WMsetColors(DEFAULT_FG, DEFAULT_BG);
    AxXtManageChild(workplace);


    /* create the page bar for ge */
    if ( windowP->wind_attr.modifiers.pagebar )
    {
        XtSetArg(arglist[0], XmNoldWidget, 0);
        XtSetArg(arglist[1], XmNflags, 0);    
        XtSetArg(arglist[2], XmNy, 0);    /* status-window relative x/y pos */
        XtSetArg(arglist[3], XmNx, 0);
        XtSetArg(arglist[4], XmNwidth, GE_PAGE_WIDTH);
        XtSetArg(arglist[5], XmNheight,MSG_HEIGHT);    
        XtSetArg(arglist[6],AXmNvalue,windowP->wind_attr.page_ix);
        XtSetArg(arglist[7],AXmNmaximum,windowP->wind_attr.n_pages);
        XtSetArg(arglist[8],XmNmenuHelpWidget,3570);
        ZXmCreatePageBar(main_win, NXLT("pagebar"), arglist, 9);
    }
    /* create the status area */
    XtSetArg(arglist[0], XmNoldWidget, 0);
    XtSetArg(arglist[1], XmNflags, 0);    
    XtSetArg(arglist[2], XmNy, 0);    /* status-window relative x/y pos */
    XtSetArg(arglist[3], XmNx, 0);
    if ( windowP->wind_attr.modifiers.gr_window )
        /* GE main window uses a diffent status line */
        msg_width = GE_MSG_WIDTH;
    else
        msg_width = MSG_WIDTH;
    XtSetArg(arglist[4], XmNwidth, msg_width);
    XtSetArg(arglist[5], XmNheight,MSG_HEIGHT);    
    XtSetArg(arglist[6],XmNmenuHelpWidget,3572);
    shell->statusArea = (AXWidget_status)ZXmCreateStatusArea(main_win, " ", 
                                                arglist, 7, W_STATUS);

    if ( windowP->wind_attr.modifiers.presentation )
    {
        /*  the button bar */
        XtSetArg(arglist[0], XmNoldWidget, 0);
        XtSetArg(arglist[1], XmNflags, 0);    
        XtSetArg(arglist[2], XmNy, 0);    /* status-window relative x/y pos */
        XtSetArg(arglist[3], XmNx, 0);
        XtSetArg(arglist[4], XmNwidth, SCROLLBAR_THICK);
        XtSetArg(arglist[5], XmNitemCount, 5);
        if ( windowP->wind_attr.modifiers.no_outliner )
            XtSetArg(arglist[6], XmNvalue, 4);
        else
            XtSetArg(arglist[6], XmNvalue, 5);
        ZXmCreateButtonBar(main_win, NXLT("butonbar"), arglist, 7);
        InitButtonPalette(main_win);
#if 0
        /* init the outline palet */
        XtSetArg(arglist[0], XmNoldWidget, 0);
        XtSetArg(arglist[1], XmNflags, 0x01); /* NODISPLAY, xmlib.h */
        XtSetArg(arglist[2], XmNitemCount, 2*windowP->wind_attr.n_pages);
        ZXmCreateOutline(main_win, NXLT("outline"), arglist, 3);
#endif
    }

    /* create the scroll bars if requested */
    if ( windowP->wind_attr.border_control & TMBARV_FLAG )
    {
        CALLBACKER(callback_list,ScrollBarHasBeenMoved,(int)windowP->window_id);
        an = 0;
        XtSetArg(arglist[an],XmNoldWidget,0);                         an++;
        XtSetArg(arglist[an],XmNflags,0);                             an++;
        XtSetArg(arglist[an],AXmNsliderSize,MAX(1,windowP->wind_attr.v_sc_per));
        an++;
        XtSetArg(arglist[an],AXmNvalue,windowP->wind_attr.v_sc_pos);  an++;
        XtSetArg(arglist[an],XmNorientation,AXmVERTICAL);             an++;
        XtSetArg(arglist[an],XmNvalueChangedCallback,callback_list);  an++;
        XtSetArg(arglist[an],XmNincrementCallback,callback_list);     an++;
        XtSetArg(arglist[an],XmNdecrementCallback,callback_list);     an++;
        XtSetArg(arglist[an],XmNpageIncrementCallback,callback_list); an++;
        XtSetArg(arglist[an],XmNpageDecrementCallback,callback_list); an++;
        if ( windowP->wind_attr.modifiers.gr_window )
        {
            XtSetArg(arglist[an],AXmNmaximum,12000);                  an++;
            XtSetArg(arglist[an],AXmNbuttonUpScroll,TRUE);            an++;
            XtSetArg(arglist[an],XmNmenuHelpWidget,3573);             an++;
        }
        else
        {
            XtSetArg(arglist[an],AXmNmaximum,32767);                  an++;
            XtSetArg(arglist[an],XmNmenuHelpWidget,0);                an++;
        }
        vbar =(AXWidget)AXmCreateScrollBar((AXWidget)main_win,
										   NXLT("vscroll"),arglist,an);
        AxXtManageChild(vbar);
        windowP->vbar = (AXWidget_scroll)vbar;
    }
    if ( windowP->wind_attr.border_control & TMBARH_FLAG )
    {
        CALLBACKER(callback_list,ScrollBarHasBeenMoved,(int)windowP->window_id);
        XtSetArg(arglist[0],AXmNsliderSize,MAX(1,windowP->wind_attr.h_sc_per));
        XtSetArg(arglist[1],AXmNvalue,windowP->wind_attr.h_sc_pos);
        XtSetArg(arglist[2],XmNorientation,AXmHORIZONTAL);
        XtSetArg(arglist[3],XmNvalueChangedCallback,callback_list);
        XtSetArg(arglist[4],XmNincrementCallback,callback_list);
        XtSetArg(arglist[5],XmNdecrementCallback,callback_list);
        XtSetArg(arglist[6],XmNpageIncrementCallback,callback_list);
        XtSetArg(arglist[7],XmNpageDecrementCallback,callback_list);
        if ( windowP->wind_attr.modifiers.gr_window )
        {
            XtSetArg(arglist[8],XmNmenuHelpWidget,3574);
            XtSetArg(arglist[9],AXmNmaximum,9500);
            XtSetArg(arglist[10],AXmNbuttonUpScroll,TRUE);
            hbar = (AXWidget)AXmCreateScrollBar((AXWidget)main_win,
												NXLT("hscroll"),
												arglist,11);
        }
        else
        {
            XtSetArg(arglist[8],XmNmenuHelpWidget,0);
            XtSetArg(arglist[9],AXmNmaximum,32767);
            hbar = (AXWidget)AXmCreateScrollBar((AXWidget)main_win,
												NXLT("hscroll"),
												arglist,10);
        }
        AxXtManageChild(hbar);
        windowP->hbar = (AXWidget_scroll)hbar;
    }

    /* create the corner piece */
    windowP->corner = (AXWidget_corner)XmCreateCorner(main_win);
    if ( windowP->wind_attr.modifiers.zoomButton ) {
        /* !! currently WP (and its variants - ME, EQN, HELP) only !! */
        if ( windowP->wind_attr.icon_id == IC_SS )  {
            CALLBACKER(callback_list,SSZoomCallback,(int)windowP->p_id);
        }   else    {
            CALLBACKER(callback_list,DCZoomCallback,(int)windowP->p_id);
        }
        XtSetArg(arglist[0],XmNoldWidget,0);
        XtSetArg(arglist[1],XmNflags,0);
        XtSetArg(arglist[2],XmNactivateCallback,callback_list);
        XtSetArg(arglist[3],XmNx,1);
        XtSetArg(arglist[4],XmNy,1);
        XtSetArg(arglist[5],XmNlabelPixmap,TRUE);
        XtSetArg(arglist[6],XmNalternatePixmap,NXLT("zoomdn"));
        XtSetArg(arglist[7],XmNwhichButton,Button1);
        AXmCreatePushButtonGadget((AXWidget)windowP->corner,NXLT("zoomup"),arglist,8);
    }


    /* Tell WM to handle geometry and display functions */
    XtSetArg(arglist[0],AXmNmenuBar,menu_bar);
    XtSetArg(arglist[1],AXmNworkWindow,workplace);
    XtSetArg(arglist[2],AXmNhorizontalScrollBar,hbar);
    XtSetArg(arglist[3],AXmNverticalScrollBar,vbar);
    XtSetArg(arglist[4],AXmNruler,windowP->ruler);
    XtSetArg(arglist[5],AXmNplates,windowP->plates);
    AxXtSetValues((AXWidget)main_win,arglist,6);

    AxXtManageChild((AXWidget)main_win);

    AxRealizeWidget(shell);

    xwin = AxXtWindow(workplace);
    XSetWindowColormap(Dpy,xwin, ApplixCmap);
#if AX_X11
    /* On Windows, the background has already been registered with
     * the window class, so no need to set it again.   -donato
     */
    XSetWindowBackground(Dpy,xwin,BGpixel);
#endif

    /* let X know the events that the window will listen for */
    XSelectInput(Dpy, xwin, TM_PTR_INPUTS_MASK);

    /* set the window context */
    HostWin = windowP->xwin = xwin;
    windowP->xMap = -1;
    windowP->editwin = (Window)None;
    windowP->inCellWin = (Window)None;
    windowP->rowwin =  (Window)None;
    windowP->colwin = (Window)None;
    windowP->num_points = windowP->num_control_points = 0;
    windowP->line_width = windowP->line_style = windowP->end1 = windowP->end2 = -1;
    windowP->join_style = windowP->fill_style = -1;
    windowP->line_fg = windowP->line_bg = windowP->line_pat = -1;
    windowP->fill_fg = windowP->fill_bg = windowP->fill_pat = -1;
    windowP->ffg_cyan = windowP->ffg_magn = windowP->ffg_yell = windowP->ffg_blck = -1;
    windowP->fbg_cyan = windowP->fbg_magn = windowP->fbg_yell = windowP->fbg_blck = -1;
    windowP->lfg_cyan = windowP->lfg_magn = windowP->lfg_yell = windowP->lfg_blck = -1;
    windowP->lbg_cyan = windowP->lbg_magn = windowP->lbg_yell = windowP->lbg_blck = -1;
    windowP->line_mode = windowP->lfill_type = windowP->lfill_ang = windowP->lfill_off = -1;
    windowP->ffill_type = windowP->ffill_ang = windowP->ffill_off = -1;
    windowP->gridSize = windowP->wind_attr.grid_size ? windowP->wind_attr.grid_size : -1;
    windowP->x_zero_pt = windowP->y_zero_pt = 0;
    windowP->line_pat_name = windowP->fill_pat_name = NULL;
    windowP->shell = shell;
    windowP->topwindow = AxXtWindow((AXWidget)main_win);
    XSetWindowColormap(Dpy,windowP->topwindow,ApplixCmap);
    cur_win = windowP->layer->window_id = windowP->window_id;

    /* make the window appear NOW! */
    AxSync();

    ThimNoWindowsLeft = FALSE;

    /* see commentary in xmlib.c */
    if ( windowP->wind_attr.modifiers.windowless )
    {
        SetWp(&window[i = windowP->window_id]);
        make_curwin(windowP->window_id);
    }
    else
    {
        /* sleep this task until the window exposure occurs */
        i = windowP->window_id;
        window[i].hasBeenMapped = FALSE;
        XmPutHourglass();

        /*
         *  MAGIC INCANTATION:
         *      TWM requires a XSetStandardProperties to be done after
         *      any potential XSetWMHints() to get proper set-aside icons.
         *      Motif requires the XSetWmHints to get the window for the
         *      SA pixmap, but doesn't need the info once the window is
         *      realized -- so we bang the standard props again here.
         *      Thus TWM now gets what it needs and MWM has already gotten
         *      what it needed.
         *      To test this bug in the future, open spreadsheet from main
         *      menu and imemdiately set aside under both window managers.
         */
        ZXmHammerStandardProperties(window[i].shell);
        SetWp(&window[i]);
        make_curwin(i);

        /* Declare interest in Visix document drops */
        XChangeProperty(Dpy,window[cur_win].topwindow,
                        AxXA_VISIX_ACCEPT_DROP,XA_ATOM,
                        32,PropModeReplace,(unsigned
                        char *)&trueval,1);
        XChangeProperty(Dpy,window[cur_win].xwin,
                        AxXA_VISIX_ACCEPT_DROP,XA_ATOM,
                        32,PropModeReplace,(unsigned
                        char *)&trueval,1);

        /* make the window topmost, but don't grab input focus */
        XRaiseWindow(Dpy,windowP->topwindow);
#if AXMS
        /* if the window is a GE window and it's visible, generate an *
         * expose to get the initial paint done. This is needed when  *
         * bringing up a linked GE object.                            */
        if ( windowP->wind_attr.modifiers.gr_window &&
                        windowP->workWidget->display )
           MS_InvalidateRect(windowP->workWidget->winid, (RECT *)NULL, FALSE);
#endif
    }

    Creating_atm_window = FALSE;
    return;
}


/*************************************************************************
function: DestroyX11Window - Undoes the work of CreateAxWindow
*/
DestroyAxWindow(windowP)
struct wind_struct *windowP;
{
    int old = windowP->winWasBorrowed;
    int vn = 0, hn = 0, val;
    Arg arglist[10];
    static XtCallbackRec callback_list[2];  /* ??1 static? */
    struct TmCrePacket *attsP;
	int mypid;
	AXWidget myparentWidget;

    AxClearSelectionsIfOwnedByWindow(windowP->window_id);
    ThimDestroyChildDialogs(windowP->shell);
	mypid = windowP->shell->taskOwner;
	myparentWidget = (AXWidget)windowP->shell->parent;
    AxXtDestroyWidget((AXWidget)windowP->shell);
    XSync(Dpy,FALSE);
    free(windowP->layer);
    resWindStruct(windowP);
    cur_win = TM_NULWIN;
	AxMakeParentActive(myparentWidget, mypid);
}



/*
 * WMresInit -- build bitmap resources managed by the window manager
 */
WMresInit()
{
#if 0    /* ARE THESE USED? */
    extern A_Bitmap PEN0, PEN1, PEN2, PEN3, PEN4;
    extern A_Bitmap BarTone;

    mkWMmap(&ToneBM, (short *) ToneBM.mapdata);
/*  mkWMmap(&BarTone, (short *) BarTone.mapdata); */
    mkWMbitmap(&PEN0, (short *) PEN0.mapdata);
    mkWMbitmap(&PEN1, (short *) PEN1.mapdata);
    mkWMbitmap(&PEN2, (short *) PEN2.mapdata);
    mkWMbitmap(&PEN3, (short *) PEN3.mapdata);
    mkWMbitmap(&PEN4, (short *) PEN4.mapdata);
#endif

#if 0
    /* pattern pixmaps are now allocated dynamically - jon */
    AxInitPatternPixmaps();
#endif
}

char *
AxS()
{
    char *str;
    str = NXLT("%s");
    return(str);
}
char *
AxD()
{
    char *str;
    str = NXLT("%d");
    return(str);
}


/*************************************************************************
function: SetCurWinFromShellId - Select win based on window[].shell
The set_focus is only set when a dialog goes away.
*/
void SetCurWinFromShellId (w_id,set_focus)
register AXWidget_main w_id;
int set_focus;      /* if TRUE, set keyboard focus to the window */
{
    register int ix;
    struct wind_struct *windowP;

    if ( !w_id )
        return;
    for ( ix = 0; ix < TM_MAXWIN; ix++ ) {
        if ( window[ix].busy_flag && (window[ix].shell == w_id) ) {
            windowP = make_curwin(ix);
            if ( set_focus ) {
#if AXMS
                SetWindowsFocusFromChild( windowP->xwin );
#else
                AXSetInputFocus(windowP->xwin, FALSE, CurrentTime);
#endif
            }
            return;
        }
    }
}

static char *
isaKnownGraphicFormat(doctype, stat)
int doctype;
int *stat;
{
    char *file_type;
    char *c;

    *stat = AOK;
    switch ( doctype )
    {
        case AX_DOC_TYPE_ASTERX_GRAPHICS: 
            file_type = NXLT("ag");
        break;
        case AX_DOC_TYPE_CGM:
            file_type = NXLT("cgm");
        break;
        case AX_DOC_TYPE_DXF:
            file_type = NXLT("dxf");
        break;
        case AX_DOC_TYPE_EPSI:
            file_type = NXLT("eps");
        break;
        case AX_DOC_TYPE_FAX_I:
            file_type = NXLT("fax");
        break;
        case AX_DOC_TYPE_GP4:
            file_type = NXLT("gp4");
        break;
        case AX_DOC_TYPE_GEM:
            file_type = NXLT("gem");
        break;
        case AX_DOC_TYPE_GIF:
            file_type = NXLT("gif");
        break;
        case AX_DOC_TYPE_HPGL:
            file_type = NXLT("hgl");
        break;
        case AX_DOC_TYPE_ILBM:
            file_type = NXLT("ag");
        break;
        case AX_DOC_TYPE_MAC_PAINT:
            file_type = NXLT("mpt");
        break;
        case AX_DOC_TYPE_MS_WINDOWS_BITMAP:
            file_type = NXLT("bmp");
        break;
        case AX_DOC_TYPE_PBM:
            file_type = NXLT("pbm");
        break;
        case AX_DOC_TYPE_PGM:
            file_type = NXLT("pgm");
        break;
        case AX_DOC_TYPE_PPM:
            file_type = NXLT("ppm");
        break;
        case AX_DOC_TYPE_PCX:
            file_type = NXLT("pcx");
        break;
        case AX_DOC_TYPE_PICT:
            file_type = NXLT("pict");
        break;
        case AX_DOC_TYPE_PICT2:
            file_type = NXLT("pict");
        break;
        case AX_DOC_TYPE_RAW:
            file_type = NXLT("raw");
        break;
        case AX_DOC_TYPE_IRIS:
            file_type = NXLT("rgb");
        break;
        case AX_DOC_TYPE_SUN_RASTER:
            file_type = NXLT("rs");
        break;
        case AX_DOC_TYPE_TIFF_M:
            file_type = NXLT("tif");
        break;
        case AX_DOC_TYPE_TIFF_I:
            file_type = NXLT("tif");
        break;
        case AX_DOC_TYPE_WMF:
            file_type = NXLT("wmf");
        break;
        case AX_DOC_TYPE_WPG:
            file_type = NXLT("wpg");
        break;
        case AX_DOC_TYPE_X_BITMAP:
            file_type = NXLT("xbm");
        break;
        case AX_DOC_TYPE_XPM:
            file_type = NXLT("xpm");
        break;

        default:
            *stat = !AOK;
            file_type = (char *)0;
        break;
    }
    if ( file_type )
    {
        c = (char *)TaskAlloc(0, (strlen(file_type)+1));
        strcpy(c, file_type);
        return(c);
    }
    else
        return((char * )0);
}

AxToGraphic(to_ag, doctype, pathname, tempname)
int to_ag;
int doctype;
char *pathname;
char *tempname;
{
    extern char *ThimApplixDir, *DirSlash;
    extern char ThimTempDir[];
    char *in_type;
    char buf[STRPATH];
    int stat;

    in_type = (char *)isaKnownGraphicFormat(doctype, &stat);
    if ( stat == AOK )
    {
        if ( to_ag )
        {
            sprintf(buf,
                    NXLT("%s%sfilters%sgeinout %s %s -t %s -s %s -i %s -o ag"),
                    ThimApplixDir,
                    DirSlash,
                    DirSlash,
                    pathname,
                    tempname,
                    ThimTempDir,
                    ThimApplixDir,
                    in_type);
        }
        else /* to im */
        {
            sprintf(buf,
                    NXLT("%s%sfilters%sgeinout %s %s -t %s -s %s -i %s -o im"),
                    ThimApplixDir,
                    DirSlash,
                    DirSlash,
                    pathname,
                    tempname,
                    ThimTempDir,
                    ThimApplixDir,
                    in_type);
        }
        if ( 0 != AxRunProgram(buf,NULL,NULL,NULL,FALSE) )
            stat = !AOK;
        else
            stat = AOK;
        TaskFree(0, in_type);
    }
    return(stat);
}

AxToIm(doctype, pathname, tempname)
int doctype;
char *pathname;
char *tempname;
{
    return(AxToGraphic(FALSE, doctype, pathname, tempname));
}

AxToGr(doctype, pathname, tempname)
int doctype;
char *pathname;
char *tempname;
{
    return(AxToGraphic(TRUE, doctype, pathname, tempname));
}

/*
*	AxWindowHasPlates - returns TRUE if has the plates widget, else FALSE
*/
AxWindowHasPlates(wid)
	int wid;	/* ATM window id */
{
    if((wid >= TM_MAXWIN) || (wid <= 0))
		return(FALSE);
	if(window[wid].plates)
		return(TRUE);
	return(FALSE);
}

/*************************************************************************
function: GrabCurWin - Set the input focus to the cur_win
Zane added AxMapWindow on 4/21/93 beause on exit_all@, if the window
was iconized, user got a "disconnected" "Save/Abandon/Cancel" box.
Now the window becomes visible so he can see what he is going to save/abandon.
*/
void
GrabCurWin(void)
{
    struct wind_struct *windowP;
#if AXMS
    AXWidget w;

    windowP = getActiveWin(cur_win);
    if ( !windowP )
        return;     /* ??c is this possible? */

    w = GetWidgetFromDC(windowP->xwin);
    /* for now! ASSUMPTION: parent of widget is W_MAIN. */
    if ( MS_IsIconic(w->parent->winid) )
        MS_ShowWindow(w->parent->winid, SW_RESTORE);
    else
        MS_SetForegroundWindow(w->parent->winid);
#else

    windowP = getActiveWin( cur_win );
	
    if ( !windowP )
        return;     /* ??c is this possible? */
	
    AXSetInputFocus(windowP->xwin, FALSE, CurrentTime);
	
    AxMapWindow((AXWidget)windowP->shell, Dpy, windowP->topwindow,
                                            windowP->wind_attr.title_line);
    XRaiseWindow(Dpy,windowP->topwindow);

    ThimIOSync();
#endif
}


#if AXMS
Pixmap
axmsGetMonochromeBitmapFromColorBitmap(Pixmap src_hbm, int wid, int hyt)
{
	Pixmap clip_mask;
	HDC clip_dc, src_dc;
	HBITMAP old_src_mask, old_clip_mask;

	/* select color bitmap into a color dc */
	src_dc = MS_CreateCompatibleDC(NULL);
	old_src_mask = MS_SelectObject(src_dc, src_hbm);

	/* create a monochrome bitmap */
	clip_dc = MS_CreateCompatibleDC(NULL);
	clip_mask = MS_CreateCompatibleBitmap(clip_dc, wid, hyt);
	old_clip_mask = MS_SelectObject(clip_dc, clip_mask);

	/* blt the color dc to the mono dc, which does the convert. */
	MS_PatBlt(clip_dc, 0,0,wid,hyt, BLACKNESS);
	MS_BitBlt(clip_dc, 0,0,wid,hyt, src_dc, 0,0, SRCCOPY);
	MS_PatBlt(clip_dc, 0,0,wid,hyt, DSTINVERT);

	/* cleanup */
	MS_SelectObject(clip_dc, old_clip_mask);
	MS_DeleteDC(clip_dc);
	MS_SelectObject(src_dc, old_src_mask);
	MS_DeleteDC(src_dc);

	return clip_mask;
}
#endif

int
axCopyPixmap(Pixmap src_pmap, Pixmap dst_pmap, int sx, int sy, int swid,
             int shyt, int dx, int dy)
{
	XCopyArea(Dpy, src_pmap, dst_pmap, Gc1, sx, sy, swid, shyt, dx, dy);
}

#if !TURBO
int
dbg_copyarea(Pixmap src_pmap, Pixmap dst_pmap, int sx, int sy, int swid,
             int shyt, int dx, int dy)
{
	if ( !dst_pmap )
		dst_pmap = RootWin;
	XCopyArea(Dpy, src_pmap, dst_pmap, Gc1, sx, sy, swid, shyt, dx, dy);
	AxSync();
}
#endif

static void
ax_fade_object(int x1, int y1, int wid, int hyt, Drawable drw,
               int ox1, int oy1, int twid, int thyt, int throttle)
{
	int x, y, n_xi, n_yi;
    int i,j, pwid, phyt, x_ix;
    int s_x, s_y;
	int timed;
    double fwid, fhyt;
	double x_offset, y_offset;
    struct timeval orig_time;
    long interval;
	TmPoint32 *pixels;

    /* speed control - set by user */
    if ( throttle <= 0 )
        timed = FALSE;
    else
        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
	interval = timed ? 250.0 * throttle : 0;

	n_xi = twid > 500 ? 5 : 10;
	n_yi = thyt > 500 ? 5 : 10;
    fwid = (double)wid / 4.0;
    fhyt = (double)hyt / 4.0;
    pwid = ceil(fwid/(double)n_xi);
    phyt = ceil(fhyt/(double)n_yi);
	if ( n_xi > 5 && n_yi > 5 )
		pixels = &pix_pnt[0];
	else if ( n_xi == 5 && n_yi == 10 )
		pixels = &pix_pnt5x10[0];
	else if ( n_xi == 10 && n_yi == 5 )
		pixels = &pix_pnt10x5[0];
	else
		pixels = pix_pnt5x5;

	x_offset = (fwid - (double)pwid) / ((double)n_xi-1.0);
	y_offset = (fhyt - (double)phyt) / ((double)n_yi-1.0);

	XSetClipOrigin(Dpy, Gc1, x1, y1);
    for ( i=0; i<n_xi; i++ )
    {
		for ( j=0; j<n_yi; j++ )
        {
			/* get the index */
            x_ix = j*n_xi + i;

            /* quad1 */
            x = ((double)pixels[x_ix].x * x_offset) + 0.5;
            y = ((double)pixels[x_ix].y * y_offset) + 0.5;
            s_x = (fwid*2.0 + ((double)pixels[x_ix].x * x_offset)) + 0.5;
            s_y = (fhyt*2.0 + ((double)pixels[x_ix].y * y_offset)) + 0.5;

            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y,
                                   pwid, phyt, x1+x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x, y,
                                   pwid, phyt, x1+s_x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, s_y,
                                   pwid, phyt, x1+x, y1+s_y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1,s_x,s_y,
                                   pwid, phyt, x1+s_x, y1+s_y);

            /* quad2 */
            x = (fwid + ((double)pixels[x_ix].x * x_offset)) + 0.5;
            y = ((double)pixels[x_ix].y * y_offset) + 0.5;
            s_x = (fwid*3.0 + ((double)pixels[x_ix].x * x_offset)) + 0.5;
            s_y = (fhyt*2.0 + ((double)pixels[x_ix].y * y_offset)) + 0.5;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x,y,
                                   pwid, phyt, x1+x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x,y,
                                   pwid, phyt, x1+s_x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, s_y,
                                   pwid, phyt, x1+x, y1+s_y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1,s_x,s_y,
                                   pwid, phyt, x1+s_x, y1+s_y);

            /* quad3 */
            x = ((double)pixels[x_ix].x * x_offset) + 0.5;
            y = (fhyt + ((double)pixels[x_ix].y * y_offset)) + 0.5;
            s_x = (fwid*2.0 + ((double)pixels[x_ix].x * x_offset)) + 0.5;
            s_y = (fhyt*3.0 + ((double)pixels[x_ix].y * y_offset)) + 0.5;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x,y,
                           pwid, phyt, x1+x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x,y,
                                   pwid, phyt, x1+s_x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, s_y,
                                   pwid, phyt, x1+x, y1+s_y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1,s_x,s_y,
                                   pwid, phyt, x1+s_x, y1+s_y);

            /* quad4 */
            x = (fwid + ((double)pixels[x_ix].x * x_offset)) + 0.5;
            y = (fhyt + ((double)pixels[x_ix].y * y_offset)) + 0.5;
            s_x = (fwid*3.0 + ((double)pixels[x_ix].x * x_offset)) + 0.5;
            s_y = (fhyt*3.0 + ((double)pixels[x_ix].y * y_offset)) + 0.5;
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x,y,
                                   pwid, phyt, x1+x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x,y,
                                   pwid, phyt, x1+s_x, y1+y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, s_y,
                                   pwid, phyt, x1+x, y1+s_y);
            XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1,s_x,s_y,
                                   pwid, phyt, x1+s_x, y1+s_y);

            if ( timed )
            {
                churn_interval(&orig_time, interval);
                timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
                XSync(Dpy, FALSE);
            }
            XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
                           twid, thyt, ox1, oy1);
        }
	}
}

static void
ax_wipe_object(int x1, int y1, int wid, int hyt, Pixmap drw,
               int ox1, int oy1, int twid, int thyt,
               int throttle, int step, int style)
{
	int i, x, y;
    int pwid, phyt;
	int count, timed;
    struct timeval orig_time;
    long interval;

    /* speed control - set by user */
    if ( throttle <= 0 )
        timed = FALSE;
    else
        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;

	count = 60/(float)step;
	interval = timed ? 50000.0 * throttle / count : 0;
	XSetClipOrigin(Dpy, Gc1, x1, y1);
	for ( i=0; i<count; i++ )
	{
		pwid = wid * (i+1.0) / (float)count;
		phyt = hyt * (i+1.0) / (float)count;
		x = wid - pwid;
       	y = hyt - phyt;
    	switch ( style )
    	{
			case 2:    /* right */
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0,
							   pwid, hyt, x1,y1);
			break;
			case 4:    /* left */
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x,0,
							   pwid, hyt, x1+x, y1);
			break;
			case 6:    /* down */
				XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0,0,
							   wid, phyt, x1, y1);
			break;
			case 8:    /* up */
            	XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, wid, phyt,
				          x1, y1+y);
			break;
    		case 27:   /* right down */
            	XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, 0, pwid, phyt,
				          x1, y1);
			break;
    		case 28:   /* left down */
            	XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, 0, pwid, phyt,
				          x1+x, y1);
			break;
    		case 29:   /* right up */
            	XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, 0, y, pwid, phyt,
				          x1, y1+y);
			break;
    		case 30:   /* left up */
            	XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, x, y, pwid, phyt,
				          x1+x, y1+y);
			break;
		}
		if ( timed )
		{
			churn_interval(&orig_time, interval);
			timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
			XSync(Dpy, FALSE);
		}
		XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
				   twid, thyt, ox1, oy1);
	}
}

static void
ax_meltdown_object(int x1, int y1, int wid, int hyt, Drawable drw,
                   int ox1, int oy1, int twid, int thyt,
                   int throttle, int count)
{
	int x, y;
    int i,k, pwid, phyt, x_ix;
	int cwid, chyt;
    int s_x, s_y;
	int timed, sz;
    double fwid, fhyt;
    struct timeval orig_time;
    long interval;
    short *indices;

    cwid = wid/10.0;
    chyt = hyt/2.0;
    k = 0;
        
    indices = (short *)malloc(wid*sizeof(short));
	memset(indices, 0, wid*sizeof(short));

    /* speed control - set by user */
    if ( throttle <= 0 )
        timed = FALSE;
    else
        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;

    interval = timed ? 5000.0 * throttle / count : 0;
	XSetClipOrigin(Dpy, Gc1, x1, y1);
	while (TRUE)
    {
        /* set the width of the patch */
        pwid = 20 + RAND_FUNC(count);

        /* set the x position of the patch */
        s_x = RAND_FUNC(wid + count) - count;
        if ( s_x < 0 )
            s_x = 0;
        else if ( (s_x + pwid) > wid )
            s_x = wid - pwid;

        /* set the y position of the patch */
        s_y = hyt;
        for ( i=s_x; i<(s_x + pwid); i++ )
            s_y = MIN(s_y, indices[i]);
        if ( s_y == hyt )
            continue;

        /* set the height of the patch */
        phyt = RAND_FUNC(s_y/10 + count);

        /* set the height of the smudge */
        sz = RAND_FUNC(MAX(s_y + 10, chyt));
        if ( (s_y + phyt + sz) > hyt )
            continue;

        /* smudge the screen */
        XCopyArea(Dpy, FinalPixmap, FinalPixmap, Gc1, s_x, s_y, pwid, sz,
                  x1+s_x, y1+s_y+phyt);

        /* copy more to the screen */
        XCopyArea(Dpy, FlyInPixmap, FinalPixmap, Gc1, s_x, s_y, pwid, phyt,
                  x1+s_x, y1+s_y);

        s_y += phyt;
        for ( i=s_x; i<(s_x+pwid); i++ )
        {
            if ((indices[i] < (hyt - 10)) && (s_y >= (hyt - 10)))
                k++;
            indices[i] = MAX(indices[i], s_y);
        }

        if ( timed )
        {
            churn_interval(&orig_time, interval);
            timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
            XSync(Dpy, FALSE);
        }
		XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
		          twid, thyt, ox1, oy1);

        /* terminating condition */
        if ( k >= (wid - cwid))
			break;
    }
}

static void
ax_uncover_object(int x1, int y1, int wid, int hyt, Pixmap drw,
                  int ox1, int oy1, int twid, int thyt,
                  int throttle, int step, int style, Pixmap clip_mask)
{
	int i, x, y;
    int pwid, phyt;
	int count, timed;
    struct timeval orig_time;
    long interval;
	Pixmap uncover_pmap, obj_pmap;

	XSetClipMask(Dpy, Gc1, None);

	/* create a pixmap which will hold the background.
	 * this will be the pixmap that "uncovers" the object.
	 */
	uncover_pmap = AxCreateQueryPixmap(Dpy, RootWin, wid, hyt, DpyDepth);
	XCopyArea(Dpy, FinalPixmap, uncover_pmap, Gc2, x1, y1, wid, hyt, 0, 0);

	/* create a pixmap which will hold the object and the background.
	 * this will represent what's being uncovered.
	 */
	obj_pmap = AxCreateQueryPixmap(Dpy, RootWin, wid, hyt, DpyDepth);
	XCopyArea(Dpy, uncover_pmap, obj_pmap, Gc1, 0, 0, wid, hyt, 0, 0);
	XSetClipMask(Dpy, Gc1, clip_mask);
	XSetClipOrigin(Dpy, Gc1, 0, 0);
	XCopyArea(Dpy, FlyInPixmap, obj_pmap, Gc1, 0, 0, wid, hyt, 0, 0);

    /* speed control - set by user */
    if ( throttle <= 0 )
        timed = FALSE;
    else
        timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;

    count = 60/(float)step;
    interval = timed ? 50000.0 * throttle / count : 0;
	XSetClipMask(Dpy, Gc1, None);
	for ( i=0; i<count; i++ )
	{
		pwid = wid * (i+1.0) / (float)count;
        phyt = hyt * (i+1.0) / (float)count;
		x = wid - pwid;
        y = hyt - phyt;
    	switch ( style )
    	{
    		case 37:    /* uncover left */
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, pwid, 0, x, hyt,
				          x1, y1);
				XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, x, 0, pwid, hyt,
				          x1+x, y1);
			break;
    		case 38:    /* uncover right */
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, 0, 0, x, hyt,
				          x1+pwid, y1);
				XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, 0, pwid, hyt,
				          x1, y1);
			break;
    		case 39:    /* uncover down */
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, 0, 0, wid, y,
				          x1, y1+phyt);
				XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, 0, wid, phyt,
				          x1, y1);
			break;
    		case 40:    /* uncover up */
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, 0, phyt, wid, y,
				          x1, y1);
				XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, y, wid, phyt,
				          x1, y1+y);
			break;

    		case 42:    /* uncover - right up */
				XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, 0, wid, hyt,
				          x1, y1);
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, 0, phyt, x, y,
				          x1+pwid, y1);
    		break;
    		case 43:    /* uncover - left down */
                XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, 0, wid, hyt,
                          x1, y1);
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, pwid, 0, x, y,
				          x1, y1+phyt);
    		break;
    		case 44:    /* uncover - left up */
                XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, 0, wid, hyt,
                          x1, y1);
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, pwid, phyt, x, y,
				          x1, y1);
    		break;
    		case 45:    /* uncover - right down */
                XCopyArea(Dpy, obj_pmap, FinalPixmap, Gc1, 0, 0, wid, hyt,
                          x1, y1);
				XCopyArea(Dpy, uncover_pmap, FinalPixmap, Gc1, 0, 0, x, y,
				          x1+pwid, y1+phyt);
    		break;
		}
		if ( timed )
		{
			churn_interval(&orig_time, interval);
			timed = (get_ctime(&orig_time) == AOK) ? TRUE : FALSE;
			XSync(Dpy, FALSE);
		}
		XCopyArea(Dpy, FinalPixmap, drw, Gc2, ox1, oy1,
				   twid, thyt, ox1, oy1);
	}

	AxFreePixmap(uncover_pmap);
	AxFreePixmap(obj_pmap);
}
