/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winevent.c
   Applix ASC version: 411
   Date: Thu Jun 10 21:14:59 1999
*/
#define DEFINE_GDI_ERROR_GLOBALS 1    /* for winmap.h */
#define NEED_X_INFO 1

#include <stdlib.h>
#include <string.h>
#include <winsock.h>
//#include <ctl3d.h>    //save for later 
#include <basicwin.h>
#include <ax_xm.h>
#include <aos.h>
#include <paripc.h>
#include <tmi.h>
#include <paratm.h>
#include <parint.h>
#define AX_NT_TIMEV_DEFINED 1
#include <scac.h>
#include <xmlib.h>
#include <elxwins.h>
#include <elf.h>
#include <evreason.h>
#include <xmpixel.h>
#include <adlgpoke.h>
#include <aos_xfer.h>
#include <fsrts.h> 
#include <eldata.h>
#include <axwinclr.h>
#include <aiconids.h>
#include <usrevent.h>
#include <doctypes.h>
#include <tmkeys.h>



#define STRALLOC(s) strcpy(malloc(strlen(s)+1),s)


/* The following are used on Win95 only, but are defined generically.
 * However, they are defined only in up-to-date SDKs. In the case of
 * old SDKs on NT, we just define it to anything. It doesn't matter
 * since the defines are not valid on NT anyway.     -donato
 */
#ifndef SM_CXSMICON
#define SM_CXSMICON SM_CXICON
#define SM_CYSMICON SM_CYICON
#endif

#ifndef WM_SETICON
#define WM_SETICON (WM_USER + 99)
#endif
/******************************************************************/


#define PALETTE_WIDTH 101
#define COLORPAL_HEIGHT 23
#define GE_YRULER_WIDTH 32
#define GE_XRULER_HEIGHT 32
#define GE_PAGE_WIDTH   136

#define ARROW_KEY(p) (((p) >= VK_PRIOR) && ((p) <= VK_DOWN))
#define FUNCTION_KEY(p) (((p) >= VK_F1) && ((p) <= VK_F16))
#define MAIN_NUM_KEY(p) (((p) >= 0x30) && ((p) <= 0x39))
#define HACK_KEY(p) (((p) >= 0xB1) && ((p) <= 0xBF))/* see hack comment in
														WinToXEvent at the,
                                                        wm_keydown case. */
int BorderWidth;
int BorderHeight;
int RunningWin95Look;
int Scrollbar_Thickness;
int CheckBoxSize;
int Entry_Height;
int Option_Pad;
int UniqueOnly;     /* only send unique resize messages to widgets */
int AxWinDisplayHeight, AxWinDisplayWidth;
int AxWinDefaultMenuHeight;
static int RunningAsBuilder = FALSE;
static int ResizeBorderWidth;
static int ResizeBorderHeight;
static int AxWinTitleHeight;
static int IgnoreButtonState = FALSE;

int have_hidden_startup = FALSE;

HANDLE hInst;
HDC RootWin;                    /* for compatibility with 'X' root window */
HWND WXDummyWnd;
HWND AxTopWinNeverMapped;       /* used in xmdlged.c */
HWND CurrentDialogHwnd = NULL;  /* currently active dialog's window handle */
HWND AxTopHWNDNeverMapped;      /* used for MAPI dialog parentage */
int NtLineHeight;               /* height (with leading) of default font */

int Running_Windows95;
unsigned int CursorWidth, CursorHeight, CursorImageSize;
unsigned int AxWinIconWidth, AxWinIconHeight;
int ShowNextWindow;     /* initally set to nCmdShow value in WinMain */
AXWidget_pushbutton ToolBarButtonWidget = NULL;

extern int AxEuroDollarKeyState, AxEuroDollarKeyCode;
extern int AxEuroDollarModifiers;
extern KeySym AxEuroDollarKeysym;
extern int Creating_atm_window;
extern int DoubleMillisec;
extern int Running_WindowsNT;
extern Cursor ThimPointerCursor;
extern Cursor ThimRecordCursor;
extern int Ax_Clear_Selection;  /* whether to process WM_DESTROYCLIPBOARD */
extern Window AxDummyWin; /* "root window" that may have Clipboard ownership */
extern int AxNoMapWindows;

extern int THIMhelpMode;
extern bint ElfInLearnMode;

extern HFONT NormalDialogFont;
extern AXWidget_popup PopupArmed;
extern AXWidget_ribbon RibbonArmed;
extern AXWidget_rowcol RowColumnArmed;
extern AXWidget RightButtonArmed;    /* displayed right buttonpopup menu */

extern Colormap ApplixCmap;
extern HPALETTE   AxWinPaletteHandle;
extern LOGPALETTE *AxWinPalette;
extern short ElfHasStatusMessageDisplayed;
extern AXWidget WindowList;
extern int ThimbleSaysToReturnNow;    /* IPC msg queued */
extern unsigned long TimeOfButtonPress;
extern unsigned long TimeOfButtonRelease;
extern int AxNoteAllMousePoints;
extern int WidgetNeedsUpdated;        /* Set when a widget needs repainted */

extern DocInfoType XferDoc;    /* transfer bin document wrapper */

#define TIMEOUT_FOREVER -1    /* from axmain.c */
extern int AxKeepRunning;
extern AXWidget TotalWidgetsList;  /* for resource tracking */

extern PIXEL_VALUE BackPixelRGB, RecessPixelRGB;
extern PIXEL_VALUE ForeWorkPixelRGB, BackWorkPixelRGB;
extern PIXEL_VALUE BackPixel;  /* backround for control panels */
extern PIXEL_VALUE ForePixel;  /* foreground for control panels */
extern PIXEL_VALUE SunPixel, ShadowPixel; /*highlight and shadow for dialogs*/
extern PIXEL_VALUE ForeWorkPixel, BackWorkPixel;
extern PIXEL_VALUE ButtonFacePixel;
extern PIXEL_VALUE RecessPixel;
extern unsigned long WidgetPixels[];
extern Pixmap ScratchMap;
extern int AxButtonDown;
extern Display *Dpy;
extern short DpyWid, DpyHt, DpyDepth;

extern XFontStruct *AxDlgMainFont;
extern XFontStruct *AxDlgMiniFont;
extern XFontStruct *AxStatusLineFont;

#if 0
/* let stdlib.h declare these. */
/* a windows program must get argc and argv from globals */
extern int __argc;
extern char **__argv;
#endif


extern WNDPROC OldEnterProc, OldEditboxProc, OldListProc;

LRESULT CALLBACK DialogClassProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SimpleClassProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ToolBarClassProc(HWND, UINT, WPARAM, LPARAM);


struct XMlibStr {
    PIXEL_VALUE FGpixel;    /* foreground color for app work areas */
    PIXEL_VALUE BGpixel;    /* backround color for app work areas */
    int FullRegenForUpdate;  /* Set by UnMapWidget,
                                            hint for WidgetNeedsUpdated */
};
extern struct XMlibStr xmlibStr; 



int RunningWin32s;    /* obsolete */

#include <winevent.p>



/**********************************************************************
function:  WinMain - Windows entry point
*/
int
axWinMain(int argc,
          char **argv,
          HINSTANCE hInstance,
          HINSTANCE hPrevInstance,
          LPSTR lpCmdLine,
          int nCmdShow)
{
    OSVERSIONINFO osversion;
    int ret;

    if (!InitInstance(hInstance, nCmdShow, argc, argv))
        return (FALSE);

    ShowNextWindow = nCmdShow;

#if 1
    osversion.dwOSVersionInfoSize = sizeof( OSVERSIONINFO );
    ret = MS_GetVersionEx( &osversion );
    if ( !ret )
       return( FALSE );
    if ( osversion.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
         {
         /* Windows 95 */
         Running_Windows95 = TRUE;
         RunningWin95Look = TRUE;
         }
    else if ( osversion.dwPlatformId == VER_PLATFORM_WIN32_NT )
         {
         /* windows NT */
         Running_WindowsNT = TRUE;
         if ( osversion.dwMajorVersion >= 4 )
            {
            /* NT 4.0 or later */
            RunningWin95Look = TRUE;
            }
         }

#else
    DWORD version;
    int major_ver,  minor_ver;

    version = MS_GetVersion();      /* get windows version */
    major_ver = (version & 0xFF);
    minor_ver = (version & 0xFF00) >> 8;
    if ( version & 0x80000000 )
        {
        /* we are not running NT; so make sure we are Windows 95. */
        if ( major_ver < 4 )
            {
            RunningWin32s = TRUE;
            Running8_3Names = TRUE;
            }
        }
    else if ( (major_ver = 3) && (minor_ver < 50) )
        {
        /* NT 3.1 (at least before 3.5) uses short filename */
        }
#endif


    if (!hPrevInstance)
        {
        if (!InitApplication(hInstance))
            return (FALSE);
        if (!InitDialogs(hInstance))
            return (FALSE);
        if (!InitToolWidgets(hInstance))
            return (FALSE);
        }

    if (!InitGlobals(WXDummyWnd))
        return (FALSE);

#if WIN_DEBUG

        MS32_GdiSetBatchLimit(1);    /* flush every gdi call immediatly */
#endif

    axmain(argc, argv);        /* never returns */
}


/*************************************************************************
function: GetAndDoEvent - Process event, queue Thimble actions
*/
void
GetAndDoEvent(int timeout_val)
{
    MSG msg;
    int code;
    struct timeval time_struct;
    int ret, junk;
    BOOL translate_dispatch_msg = TRUE;
    int timer_id = 0;
    int message_waiting;
    static int ExitTask = 0;    /* Task uid fired of for exiting */

    if ( (timeout_val > 10) || (timeout_val < 0) )
        /* not a simple poll, clear any hourglass cursor */
        XmClrHourglass();

    /* see if we need to exit. */
    if ( !AxKeepRunning &&    /* The -stay is dominant */
            /* let delay@(0) be ok, allow 1 millisec! */
            (timeout_val == TIMEOUT_FOREVER || timeout_val > 1) &&
            /* Any windows at all keep us up (even unmapped) */
            !TotalWidgetsList &&
            !AxHaveAnyTopTasks() )
        {
        VfyContext(0);  /* required for kernel startups of tasks */
        if ( !ExitTask || !ThimPidFromUID(ExitTask) )
            {
            ExitTask = ElfbNewTask("EXIT_ALL@",""); /* may or may not logout */
            return;
            }
        }

/* again: */
    message_waiting = MS_PeekMessage(&msg, (HWND) NULL, 0, 0, PM_NOREMOVE);
    if ( !message_waiting && (timeout_val >=0 ) )
        {
        /* nothing in the incoming message queue */

        if ( timeout_val <= 10 )
            {
            /* just checking to see if anything is there */
            return;
            }
        else if ( timeout_val < 3600000 )
            {
            /* start a timer so that the GetMessage will wake up in the */
            /* specified time period.  The 3600000 test is so that we do */
            /* not bother to set a timer for anything greater than 1 hour. */
            /* This is because the WP and the SS pass large positive values */
            /* meaning a "long time" rather than -1.  If we set a timer  */
            /* for these we would keep putting it up and taking it down  */
            timer_id = MS_SetTimer((HWND)NULL, 0, timeout_val, (TIMERPROC)NULL);
            if ( timer_id == 0 )
               taskAbort("Could not create timer");
            }
         }


#if 0
    if (ToolBarButtonWidget)
        {
        /* there is a button down on a toolbar.  Force a draw of it "up" */
        /* since there seems to be a bug in NT where we do not get the */
        /* DRAW_ENTIRE message untile the window focus changes, which */
        /* would leave this button showing as "down"                  */
        if ( ToolBarButtonWidget->parent->type == W_DIALOG )
            {
            ToolBarButtonWidget->value = 0;
            PaintButton(ToolBarButtonWidget, 0, 0, FALSE);
            }
        else if ( ToolBarButtonWidget->parent->type == W_TOOLBAR )
            {
            UpdateToolBarDisplay(ToolBarButtonWidget);
            }

        ToolBarButtonWidget = NULL;
        }
#endif

    /* update widgets that need to be updated */
    if ( WidgetNeedsUpdated )
        {        
        doWidgetUpdates();
        WidgetNeedsUpdated = FALSE;
        xmlibStr.FullRegenForUpdate = FALSE;
        }


    code = MS_GetMessage(&msg, (HWND) NULL, 0, 0);
    if ( !code )
        exit(0);

    if ( timer_id != 0 )
        {
        /* clear the timer we have set */
        ret = MS_KillTimer( (HWND)NULL, timer_id );
        if ( ret == 0 )
            taskAbort("KillTimer invalid return");
        timer_id = 0;
        }

    if ( (msg.message == SOCKET_PSEUDO_EVENT) || (msg.message == WM_TIMER) )
        {
        /* there has been some activity on a socket> Call the standard */
        /* 'select' routine, with a zero timeout since we know there is */
        /* something there) to set the appropriate per-task flags.  This  */
        /* will also handle extraneous SOCKET_PSEUDO_EVENT messages which */
        /* may result if a task issues multiple 'recv()' calls to read a */
        /* block of data.  See the discussion of WSAAsyncSelect() in the */
        /* Win Socket on-line discussion - jon                           */
        memset(&time_struct, 0, sizeof(time_struct));
        code = AxSelectForInput(0, &time_struct, &junk);
        return;    /* back to the upper layer to get this event processed */
        }


    if ( CurrentDialogHwnd )
        {
		translate_dispatch_msg = !axmsHandleDialogKeys(CurrentDialogHwnd,&msg); 
        }

    if ( translate_dispatch_msg )
        {
        MS_TranslateMessage(&msg);
        MS_DispatchMessage(&msg);
        }

#if 0
    if (ThimbleSaysToReturnNow) /* An ipc message was sent */
        return;

    if (MS_PeekMessage(&msg, (HWND) NULL, 0, 0, PM_NOREMOVE))
        goto again;
#endif
}


static unsigned int
axmsGetXKeyState(void)
{
	int state = 0;

    if ( (MS_GetKeyState(VK_SHIFT)) < 0 )  /* high bit set if key is down */
        state = state | ShiftMask;
    if ( (MS_GetKeyState(VK_CONTROL)) < 0 )
        state = state | ControlMask;
    if ( (MS_GetKeyState(VK_CAPITAL)) > 0 )
        state = state | LockMask;
    if ( GetKeyState(VK_LMENU) < 0 )    /* left ALT */
        state = state | Mod1Mask;
    if ( GetKeyState(VK_RMENU) < 0 )    /* right ALT */
        state = state | Mod2Mask;
    if ( (MS_GetKeyState(VK_MENU)) < 0 )
        {
        /* this is the "alt" key.  On European keyboards the "Alt-Gr"  */
        /* key used to access alternate charcters is implemented such  */
        /* that it sends <control><alt>.  In this case, we want to turn   */
        /* off the control flag, since this is a "real" char, and not  */
        /* a "controlled" char.  (All of this would seem to preclude   */
        /* using any of the "alternate" chars with <control> as an     */
        /* accellerator.  Ex: the "@" is <Alt-gr><zero> on the French  */
        /* keyboard.  One can not use ^@ as a menu-bar accellerator-jon*/
        if ( state | ControlMask )
            state = state & ~ControlMask;   /* turn it off */
        }
	return state;
}

static int
axmsIsEuroKeyEvent(HWND hWnd, UINT message, WPARAM wParam, XEvent *xevent)
{
	int retval;
	unsigned int state;

	retval = FALSE;
	if ( message == WM_KEYDOWN )
	{
		state = axmsGetXKeyState();
		if ( (AxEuroDollarKeyCode && wParam == AxEuroDollarKeyCode &&
		      state == AxEuroDollarKeyState) ||
             (AxEuroDollarKeysym && wParam == AxEuroDollarKeysym &&
		          AxDecodeModifiers(state) == AxEuroDollarModifiers) )
		{
            xevent->xkey.keycode = wParam;
            xevent->type = KeyPress;
            FillXKeyStruct(hWnd, state, &xevent->xkey);
           	retval = TRUE;
		}
	}
	else if ( message == WM_CHAR )
	{
		if ( AxEuroDollarKeysym && wParam == AxEuroDollarKeysym )
		{
			state = axmsGetXKeyState();
			if ( AxDecodeModifiers(state) == AxEuroDollarModifiers )
			{
                xevent->xkey.keycode = wParam;
                xevent->type = KeyPress;
                FillXKeyStruct(hWnd, state, &xevent->xkey);
           		retval = TRUE;
			}
		}
	}
	return retval;
}

/*********************************************************************
function: WinToXEvent  -  convert Windows message event to XEvent
*
* Returns TRUE if the event is one we are "interested" in,
*         FALSE if the event is something we choose not to deal with
*/
int
WinToXEvent(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam,
                                       XEvent *xevent, AXWidget w)
{
    int retval;
    int vkey, use_key_mask;
    UINT state_mask;
    RECT update_rect;
    POINT screenPoint;
    unsigned int state=0;
    static int ix = 1;
    static int line_feed_hack = FALSE;/* see below (WM_CHAR) for explanation */
    static int ButtonDownFlag = FALSE;
    static int xMouseDownPos, yMouseDownPos;
    /* A click in Windows seems to get reported as 3 events:
       BUTTONDOWN, MOUSEMOVE, BUTTONUP even if the mouse doesn't
       move, causing the apps the think they are getting a stroke
       event.  To prevent this, we set a flag on the buttondown
       and toss the mousemove if the flag is set and x,y vals are
       the same as the buttondown x,y vals. - jimr
    */


    /* set the common values */
    if ( w == (AXWidget) NULL )
        xevent->xany.window = NULL;
    else
        xevent->xany.window = w->window;    /* packaged window handle */

	state = axmsGetXKeyState();
    AxSetKeyModifiers (state);

    retval = 0;
    switch (message)
        {
#if 0
    case WM_ACTIVATE:
        if ( LOWORD(wparam) == WA_INACTIVE )
            {
            /* we need to remove the caret here rather than let the app do it,
             * because a widget that needs it might already have been created
             * by the time the app gets around to doing it.
             */
            MS_DestroyCaret();
            xevent->type = FocusOut;
            retval = TRUE;
            }
        else
            {
            xevent->type = FocusIn;
            retval = TRUE;
            }
        break;
#endif
	case WM_SETFOCUS:
		xevent->type = FocusIn;
		retval = TRUE;
		break;

	case WM_KILLFOCUS:
		MS_DestroyCaret();
		xevent->type = FocusOut;
		retval = TRUE;
		break;

    case WM_LBUTTONUP:
        if ( MS_GetCapture() == hwnd )
            MS_ReleaseCapture();
        ButtonDownFlag = FALSE;
        AxButtonDown = FALSE;
        xevent->type = ButtonRelease;
        xevent->xbutton.button = Button1;   /* left button */
        xevent->xbutton.state = state;
        FillXButtonStruct(hwnd, wparam, lparam, &xevent->xbutton, w);
        retval = TRUE;
        break;

    case WM_MBUTTONUP:
        ButtonDownFlag = FALSE;
        AxButtonDown = FALSE;
        xevent->type = ButtonRelease;
        xevent->xbutton.button = Button2;
        xevent->xbutton.state = state;
        FillXButtonStruct(hwnd, wparam, lparam, &xevent->xbutton, w);
        retval = TRUE;
        break;

    case WM_RBUTTONUP:
        ButtonDownFlag = FALSE;
        AxButtonDown = FALSE;
        xevent->type = ButtonRelease;
        xevent->xbutton.button = Button3;
        xevent->xbutton.state = state;
        FillXButtonStruct(hwnd, wparam, lparam, &xevent->xbutton, w);
        retval = TRUE;
        break;

    case WM_LBUTTONDOWN:
    case WM_LBUTTONDBLCLK:
        xevent->type = ButtonPress;
        AxButtonDown = xevent->xbutton.button = Button1;   /* left button */
        xevent->xbutton.state = state;
        FillXButtonStruct(hwnd, wparam, lparam, &xevent->xbutton, w);
        if ( Wp && (Wp->ap_id == APSS) && (xevent->xany.window == NULL) )
            {
            /* process ss rowcol win events via main ss win */
            xevent->xany.window = (HGDIOBJ) Wp->xwin;
            }
        ButtonDownFlag = TRUE;
        xMouseDownPos = xevent->xbutton.x;
        yMouseDownPos = xevent->xbutton.y;
        retval = TRUE;
        break;

    case WM_MBUTTONDOWN:
    case WM_MBUTTONDBLCLK:
        xevent->type = ButtonPress;
        AxButtonDown = xevent->xbutton.button = Button2;
        xevent->xbutton.state = state;
        FillXButtonStruct(hwnd, wparam, lparam, &xevent->xbutton, w);
        ButtonDownFlag = TRUE;
        xMouseDownPos = xevent->xbutton.x;
        yMouseDownPos = xevent->xbutton.y;
        retval = TRUE;
        break;

    case WM_RBUTTONDOWN:
    case WM_RBUTTONDBLCLK:
        xevent->type = ButtonPress;
        AxButtonDown = xevent->xbutton.button = Button3;
        xevent->xbutton.state = state;
        FillXButtonStruct(hwnd, wparam, lparam, &xevent->xbutton, w);
        ButtonDownFlag = TRUE;
        xMouseDownPos = xevent->xbutton.x;
        yMouseDownPos = xevent->xbutton.y;
        retval = TRUE;
        break;

    case WM_MOUSEMOVE:
        MS_GetCursorPos(&screenPoint);

        state_mask = GetButtonMask(wparam);
        if ( state_mask == 0 )
            AxButtonDown = FALSE;
        /* X automatically grabs the pointer on a button down, *
         * so we do the same here on Windows.                  */
        if ( state_mask == Button1Mask || state_mask == Button3Mask )
            MS_SetCapture(hwnd);

        xevent->type = MotionNotify;
        /* Windows bug! (or perhaps feature?) If the mouse moves to a  * 
         * negative position we'll get a negative lparam, which then   *
         * translates to a wrong value (65535...). So we cast to short *
         * to ensure reasonable values.             -donato            */
        xevent->xmotion.x = (short)LOWORD(lparam);
        xevent->xmotion.y = (short)HIWORD(lparam);
        xevent->xmotion.time = MS_GetMessageTime();
        xevent->xmotion.state = state_mask | state;
        xevent->xmotion.x_root = screenPoint.x;
        xevent->xmotion.y_root = screenPoint.y;
        xevent->xmotion.is_hint = NotifyNormal; /* for now? */
        xevent->xmotion.subwindow = NULL;
        xevent->xmotion.same_screen = TRUE;
        if ( (ButtonDownFlag == TRUE) &&
            (xevent->xmotion.x == xMouseDownPos) &&
            (xevent->xmotion.y == yMouseDownPos) )
            {
            /*  ignore "move" which comes in the middle of a multi-click */
            retval = FALSE;
            }
        else
            {
            /* we'll process this mouse move event */
            retval = TRUE;
            }
        break;


    case WM_VKEYTOITEM:
        /* a key was pressed while a listbox had focus */    
        vkey = LOWORD(wparam);

        /* keep only messages we are interested in */
        if ( (vkey >= VK_F1) && (vkey <= VK_F16) )   /* the functions keys */
            use_key_mask = TRUE;
        else if ( (vkey > VK_HELP) && (vkey < VK_NUMPAD0) ) /* aplha keys */     
            use_key_mask = FALSE;
        else
            {
            retval = FALSE;    /* uninteresting keypress */
            break;
            }

        if ( use_key_mask )
            xevent->xkey.keycode = (vkey | KEY_TYPE_MASK);
        else
            xevent->xkey.keycode = vkey;

        xevent->type = KeyPress;
        FillXKeyStruct(hwnd, state, &xevent->xkey);
        retval = TRUE;
        break;
            
    case WM_SYSKEYDOWN:
        /* the F10 key on Windows functions like the Alt key, that is      *
         * it activates the menubar. However, Applixware occasionally uses *
         * it for other purposes. So we override it here (note: any time   *
         * a user presses F10 and Applixware ignores it, the default       *
         * Windows action will take place).         -donato                */
        if ( wparam == VK_F10 )
            {
            xevent->xkey.keycode = XK_F10;
            xevent->type = KeyPress;
            FillXKeyStruct(hwnd, state, &xevent->xkey);
            retval = TRUE;
            }
        else
            retval = FALSE;
        break;


/**** The keypress message we are most interested in is the WM_CHAR message.
 * this is the one with the ascii key code. But non-printable keys, like 
 * arrow keys and function keys, need to go thru WM_KEYDOWN. However,
 * because we are using Applixware's method of handling accel keys (rather
 * than a Windows Accel Table), we notice "strange" key messages. For 
 * example, if we wanted Ctrl+Dash ("-") to be an accel in a normal Windows
 * program, we'd just set it up in the accel table and we'd never see
 * what sort of Window messages we got (Windows would do everything for us
 * with TranslateAccelerator). But since we have to translate each message
 * and pass it on to the generic X key lookup, we see that pressing
 * Ctrl-Dash gives us 2 messages: a wm_keydown for the ctrl key, and a 
 * wm_keydown for the dash key, except since the ascii code for "-"
 * conflicts with the virtual key code for VK_INSERT, we get a code of 0xBD
 * which is useless to the Applix key lookup. Another example of strange
 * behavior: simply pressing Tab gives us wm_keydown with keycode VK_TAB,
 * and then a subsequent wm_char, and things work fine. However, pressing
 * Ctrl+Tab gives us TWO wm_keydowns, one with the ctrl code and the other
 * with the Tab code, and no wm_char messages. And so we have the
 * convoluted if statement below to deal with these exceptions. Again,
 * none of this would be necessary if we did accel keys "the Windows way".
 *                                               -donato
 ****/
    case WM_KEYDOWN:
        /* keep only messages we are interested in: */
        /* the arrow keys and those above them (VK_PRIOR - VK_DOWN), *
         * the function keys (F1 - F16 for now),                     *
         * Ctrl+Tab, Ctrl+Shift+Return, Ctrl+[0-9 on main keyboard]; *
         * the hack keys are explained below.             -donato    */
        if ( ARROW_KEY(wparam) || FUNCTION_KEY(wparam) ||
            (wparam == VK_DELETE) ||
            ((state & ControlMask) && (MAIN_NUM_KEY(wparam) ||
                    (wparam == VK_RETURN) ||
                    HACK_KEY(wparam) || (wparam == VK_TAB))) )
            {
            if ( MAIN_NUM_KEY(wparam) )
                xevent->xkey.keycode = wparam;
            else
                xevent->xkey.keycode = (wparam | KEY_TYPE_MASK);
            xevent->type = KeyPress;
            FillXKeyStruct(hwnd, state, &xevent->xkey);
            if ( wparam == VK_RETURN )
                line_feed_hack = TRUE;
			retval = TRUE;
            }
        else
            retval = FALSE;

        /*** HACK to deal with virtual/ascii key code conflicts: ***
         * virtual key codes 0x21 thru 0x2F (VK_PRIOR - VK_HELP) conflict  *
         * with ascii codes "!" thru "/".  When a user presses "-", for    *
         * example, we receive a wm_keydown with keycode 0xBD (rather than *
         * 0x2D). We also get a wm_char message with the proper ascii code *
         * and everything works fine. However, if the user presses the ctrl*
         * key first, we do not receive wm_char, just a wm_keydown with    *
         * the wrong ascii code. The following hack will not cause double  *
         * characters to show up because we only process wm_keydown for    *
         * arrow keys, function keys, and controlled keys.    -donato      */
        if ( wparam == 0xBD )
            xevent->xkey.keycode = 0x2D;    /* "-" */
        break;

    case WM_CHAR:
        /* we treat all character messages as "key press" events  */
        retval = TRUE;
        switch (wparam)
            {
            /* Applix wants these as 'keys', not chars */
            case VK_BACK:
            case VK_TAB:
            case VK_RETURN:    /* same as carriage return. */
            case VK_ESCAPE:
                /* a '[' key comes in with the same code as VK_ESCAPE, *
                 * so to get the Ctrl+[ accel to work we test for the  *
                 * control key being down. A bit hacky; right now let's*
                 * hope Ctrl+Esc isn't ever going to be used.  -donato */
                /* actually, Ctrl+Esc is a Windows system accelerator *
                 *  for "Switch To..." so we better not use it!       */
                /* All we need to do is check to see whether the Ctrl *
                 * key is down (see the table below).                 */
                if ( state & ControlMask )
                    xevent->xkey.keycode = wparam;
                else
                    xevent->xkey.keycode = (wparam | KEY_TYPE_MASK);
                break;
            case 0xA:
                /* if line_feed_hack is true, then the user previously*
                 * pressed the RETURN key, and we get this line feed  *
                 * key code from Windows. We don't need to process it,*
                 * so return false. If line_feed_hack is false, then  *
                 * the user pressed Ctrl+J, and we do need to process *
                 * that (this hack is the same as the above actually, *
                 * and the following table from Petzold shows why. As *
                 * above, doing accel keys the "Windows way" would    *
                 * avoid this problem)          -donato               */
                /* KEY              ASCII CODE       DUPLICATED BY    *
                 * Backspace          0x08             Ctrl+H         *
                 * Tab                0x09             Ctrl+I         *
                 * Ctrl+Enter         0x0A             Ctrl+J         *
                 * Enter              0x0D             Ctrl+M         *
                 * Esc                0x1B             Ctrl+[         */
                if ( line_feed_hack )
                    retval = FALSE;
                else
                    xevent->xkey.keycode = wparam;
                line_feed_hack = FALSE;
                break;

            default:
                xevent->xkey.keycode = wparam;
            }
        xevent->type = KeyPress;
        FillXKeyStruct(hwnd, state, &xevent->xkey);
        break;


    case WM_PAINT:
        MS_GetUpdateRect(hwnd, &update_rect, FALSE);
        xevent->type = Expose;
        xevent->xexpose.x = update_rect.left;
        xevent->xexpose.y = update_rect.top;
        xevent->xexpose.width = update_rect.right - update_rect.left;
        xevent->xexpose.height = update_rect.bottom - update_rect.top;
        xevent->xexpose.count = 0;

        if ( IgnorePaintMessages() )
           {
           /* we are not going to process this message just yet */
           /* since a "drag" is in progress                     */
           return( -2 );    /* tell upper level NOT to call DefWindowProc */
           }                /* which will validate the paint region       */

        if ( Creating_atm_window && (w != (AXWidget)NULL) &&
                                    (w->type != W_PLATES) )
            {
            /* do not do anything other than paint the background above */
            /* while the window is being created */
            retval = FALSE;
            }
        else
            {
            retval = TRUE;
            }
        break;


    case WM_SIZE:
        if ( w )
            {
            /* if a widget wasn't passed, we don't care about this event */
            xevent->type = ConfigureNotify;
            xevent->xconfigure.x = w->xpos;
            xevent->xconfigure.y = w->ypos;
            xevent->xconfigure.width = LOWORD(lparam);
            xevent->xconfigure.height = HIWORD(lparam);
            xevent->xconfigure.border_width = MS_GetSystemMetrics(SM_CXFRAME);
            xevent->xconfigure.above = (Window)1;    /* ? */
            xevent->xconfigure.serial = ix++;/* just a unique value. for now? */
            xevent->xconfigure.override_redirect = FALSE;
            retval = TRUE;
            }
        else
            retval = FALSE;
        break;

    case WM_DESTROYCLIPBOARD:
        xevent->type = SelectionClear;
        xevent->xselectionclear.window = xevent->xany.window;
        xevent->xselectionclear.selection = XA_CLIPBOARD;
        retval = TRUE;
        break;

    default:
        retval = FALSE;
        }

    return retval;
}


static void 
FillXButtonStruct(HWND hwnd, WPARAM wparam, LPARAM lparam,
                        XButtonEvent *button, AXWidget w)
{
    POINT screenPoint;


    /* Windows bug! (or perhaps feature?) If the mouse moves to a  * 
     * negative position we'll get a negative lparam, which then   *
     * translates to a wrong value (65535...). So we cast to short *
     * to ensure reasonable values.             -donato            */
    button->x = (short)LOWORD(lparam);
    button->y = (short)HIWORD(lparam);

    screenPoint.x = button->x;
    screenPoint.y = button->y;
    MS_ClientToScreen(hwnd, &screenPoint);
    button->x_root = screenPoint.x;
    button->y_root = screenPoint.y;
    button->time  = MS_GetMessageTime();
    button->subwindow = NULL;
    button->same_screen = TRUE;
}

static void
FillXKeyStruct(HWND hwnd, int state, XKeyEvent *key_event)
{
    static int ix = 1;
    POINT screenPoint;

    MS_GetCursorPos(&screenPoint);
    key_event->x_root = screenPoint.x;
    key_event->y_root = screenPoint.y;

    MS_ScreenToClient(hwnd, &screenPoint);
    key_event->x = screenPoint.x;
    key_event->y = screenPoint.y;
    key_event->time = MS_GetMessageTime();

    /* set the state of the shift, control, and caps lock keys */
    key_event->state = state;

    key_event->subwindow = NULL;
    key_event->serial = ix++; /* just a unique value. for now? */
}


UINT
GetButtonMask(WPARAM wparam)
{
    UINT ret = 0;

    if ( wparam & MK_LBUTTON )
        ret = Button1Mask;
    else if ( wparam & MK_MBUTTON )
        ret = Button2Mask;
    else if ( wparam & MK_RBUTTON )
        ret = Button3Mask;

    if ( wparam & MK_CONTROL )
        ret = ret | ControlMask;
    if ( wparam & MK_SHIFT )
        ret = ret | ShiftMask;
    return( ret );
}


static UINT ApplixPokeMessage;

BOOL 
AXtAppNextEvent(XEvent *junkP, int junk) /* declare params just to match X */
{
    MSG msg;
    BOOL ret;


    ret = MS_PeekMessage(&msg, (HWND) NULL, 0, 0, PM_NOREMOVE);
    if ( ret && msg.message == ApplixPokeMessage )
       {
       /* Treat this "ping" message */
       /* like no message at all, so background tasks will wake up      */
       ret = MS_GetMessage( &msg, (HWND)NULL, 0, 0 );
       if ( msg.message != ApplixPokeMessage )
           taskAbort("message mismatch in AXtAppNextEvent");
       return( FALSE );
       }
    else
       return( ret );

}


void PingMyself()
{
    if ( ApplixPokeMessage == 0 )
       {
       /* create a unique message number */
       ApplixPokeMessage = RegisterWindowMessage(NXLT("Applixware-poke"));
       if ( ApplixPokeMessage == 0 )
          {
          /* fallback */
          ApplixPokeMessage = WM_USER + 345;
          }
       }

    MS_PostMessage( (HWND)NULL, ApplixPokeMessage, 0, 0 );
    return;
}


/*************************************************************************
function: AxPeekUserEvent - See if there is an incoming user event
*/
AxPeekUserEvent()
{
    MSG msg;

    return (MS_PeekMessage(&msg, (HWND) NULL, 0, 0, PM_NOREMOVE));
}


static BOOL
InitGlobals(HWND wnd)
{
    unsigned int bytewidth, win_bytewidth;
    HDC hDC;
    TEXTMETRIC TextMetric;  /* metrics of default font */

    hDC = MS_GetDC(wnd);

    MS_GetTextMetrics(hDC, &TextMetric);
    NtLineHeight = TextMetric.tmExternalLeading + TextMetric.tmHeight;

    /* cursor globals */
    CursorWidth = MS_GetSystemMetrics( SM_CXCURSOR );
    CursorHeight = MS_GetSystemMetrics( SM_CYCURSOR );
    bytewidth = (CursorWidth+7)/8;
    win_bytewidth = ((bytewidth + 3)/4 ) * 4;
    CursorImageSize = CursorHeight * win_bytewidth;    

    /* icon globals */
    AxWinIconWidth = MS_GetSystemMetrics(SM_CXICON);
    AxWinIconHeight = MS_GetSystemMetrics(SM_CYICON);
    //AxWinSmallIconWidth = MS_GetSystemMetrics(SM_CXSMICON);
    //AxWinSmallIconHeight = MS_GetSystemMetrics(SM_CYSMICON);

    /* window info globals */
    AxWinDisplayWidth  = MS_GetDeviceCaps(hDC, HORZRES);
    AxWinDisplayHeight = MS_GetDeviceCaps(hDC, VERTRES);
    if ( RunningWin95Look )
       {
       BorderWidth = MS_GetSystemMetrics(SM_CXFIXEDFRAME);
       BorderHeight = MS_GetSystemMetrics(SM_CYFIXEDFRAME);
       }
    else
       {
       BorderWidth = MS_GetSystemMetrics(SM_CXBORDER);
       BorderHeight = MS_GetSystemMetrics(SM_CYBORDER);
       }
    AxWinTitleHeight = MS_GetSystemMetrics(SM_CYCAPTION);
    ResizeBorderWidth = MS_GetSystemMetrics(SM_CXFRAME);
    ResizeBorderHeight = MS_GetSystemMetrics(SM_CYFRAME);
    AxWinDefaultMenuHeight = MS_GetSystemMetrics(SM_CYMENU);
    CheckBoxSize = MS_GetSystemMetrics(SM_CXMENUCHECK);

    RootWin = MS_CreateDC(NXLT("DISPLAY"), (LPCTSTR)NULL, (LPCTSTR)NULL,
                                                (CONST DEVMODE*)NULL);
    MS_ReleaseDC(wnd, hDC);

    InitDefaultBitmap();

    return TRUE;
}








/** send our command line, as a serioes of messages, to an already running */
/** copy of axmain.  We do this as a series of messages, since to send     */
/** a block of data would require getting into DDE which seems too complex */
/** for what we need to do.                                                */

#define AX_EXECINSTANCE     (WM_USER+100)
#define AX_EXEC_START (-1)
#define AX_EXEC_END (-2)


void SendCommandLine( int argc, char *argv[], HWND hwndT )
{
    char buff[500];
    char *p;
    int i, len, l_size, message_units;
    LPARAM lparam;
    DWORD pid;
    char working_dir[ STRPATH+1 ];

    /* take all the arguments, and make one string, with the arguments */
    /* seperated by newline characters so that it can be taken apart   */
    /* easily on the other side.                                       */
    memset( buff, 0, sizeof(buff) );
    if (getcwd(working_dir, STRPATH + 1))
       {
       /* add the current working directory for relative names */
       strcpy( buff, "-pwd\n" );
       strcat( buff, working_dir );
       strcat( buff, "\n" );
       }

    for ( i=1; i<argc; i++ )
       {
       strcat( buff, argv[i] );
       strcat( buff, "\n" );
       }


    pid = MS_GetCurrentProcessId();
    len = strlen( buff );
    p = buff;
    l_size = sizeof(lparam);
    message_units = (len+(l_size-1))/l_size;   /* how many chunks */

    /* send an initial message so the other side can set things up */
    MS_SendMessage(hwndT, AX_EXECINSTANCE, (WPARAM)pid, (LPARAM)AX_EXEC_START);

    /* now send the command line 4 bytes at a time */
    for ( i=0; i<len; i=i+sizeof(lparam) )
       {
       strncpy( (char*)&lparam, p, l_size );
       MS_SendMessage(hwndT, AX_EXECINSTANCE, (WPARAM)pid, (LPARAM)lparam );
       p = p + 4;
       }

    /* send a final message to get the command executed over there */
    MS_SendMessage(hwndT, AX_EXECINSTANCE, (WPARAM)pid, (LPARAM)AX_EXEC_END );

    return;
}



typedef struct _command_struct {
    char *lineP;
    DWORD pid;
    } command_struct;

#define NUM_STARTS 10 /* support 10 simultaneous "starts" */
static command_struct commands[NUM_STARTS];  

/** Collect incomimg message pieces from another copy of applixware which */
/** the user started up.  When we have a complete message we convert it   */
/** to an argv array, and process the command line                        */
static void
CollectMessage( WPARAM wparam, LPARAM lparam )
{

   command_struct *commandP;
   int i, num_args;
   char **argv;
   int argc;
   char *p;
   elfData request;
   char tmp_str[10];

   if ( lparam == AX_EXEC_START )
      {
      /* start of a new command line being sent to us, find a place */
      /* to start collecting the data                               */
      commandP = (command_struct *)NULL;
      for ( i=0; i<NUM_STARTS; i++ )
         {
         if ( commands[i].lineP == (char *)NULL )
             {
             /* found an available slot */
             commandP = &commands[i];
             commandP->pid = wparam;
             commandP->lineP = TrueMalloc( 500 );
             *commandP->lineP = '\0';
             break;
             }
         }
      return;  /* if there are not slots we ignore this start command */
      }

   /* This should be a continuation of a start command started previously. */
   /* Find the entry for this message from the process-id which is passed  */
   /* in the wparam field                                       */
   commandP = (command_struct *)NULL;
   for ( i=0; i<NUM_STARTS; i++ )
      {
      if ( commands[i].pid == wparam )
         {
         /* found it */
         commandP = &commands[i];
         break;
         }
      }
   if ( commandP == (command_struct *)NULL )
      /* message for non-registerd pid, ignore */
      return;

   /** "commandP" now points to the entry for the command line we are being */
   /**  sent.                                                               */
   if ( lparam != AX_EXEC_END )
      {
      /* we are in the process of colleting command line characters */
      strncpy( tmp_str, (const char*)&lparam, sizeof(lparam) );
      tmp_str[ sizeof(lparam) ] = 0;
      strcat( commandP->lineP, tmp_str);
      }
   else
      {
      /* we have the whole thing, process this message into an "argv" */
      /* structure, hand it to common code to get it parsed and converted to */
      /* an ELF data structrue, so we can get it processed by the common     */
      /* ELF functions.                                                      */
      argv = (char **)TrueMalloc( 50 * sizeof(char **) );

      argv[0] = "dummy";

      argc = 1;
      argv[argc] = p = commandP->lineP;
      while ( *p != '\0' )
         {
         if ( *p == '\n' )
             {
             /* end of an argument */
             *p = '\0';
             argc++;
             argv[argc] = p+1;   /* start of next string */
             }
         p++;
         }
             
      num_args = GetRealCommandLineOptions(argc, argv, 0, FALSE, &request );
      ElfbSetSysVar( "command_line_options$", (data_ptr)request );
      ElfbNewTask( "process_options$", "" );
      PingMyself();    /* make sure to run through the scheduler */

      TrueFree( commandP->lineP );
      commandP->lineP = NULL;
      commandP->pid = 0;
      }
   return;
}



/***************************************************************************/
static BOOL
InitInstance(HANDLE hInstance, int nCmdShow, int argc, char *argv[])
{
    HWND hWnd;
    HWND hwndT;
    int FoundPrev;
    CHAR szClassName[40];
    char unmapped_name[50];
    char prog_name[20];
    static WNDCLASS umc;    /* "unmapped window" class */
    BITMAP bm_info;
    int ret, width, height, style;
    HBITMAP hBitmap = (HBITMAP)NULL;
    HDC hdc;
    int screen_width, screen_height, xpos, ypos;
    int show_window;
    int i;
    char *p;
    int running_anyware = FALSE;
    int run_multiple = FALSE;

    hInst = hInstance;

    if ( argc > 1 )
       /* if we are run with some command line arguments, do not show */
       /* the startup bitmap.  THis is shown only when we are run directly */
       /* from the desktop.  THis means that if a user double clicks in the */
       /* file manager to open a document, only the document will be displayed */
       show_window = FALSE;
    else
       show_window = TRUE;

    /** see if we are running as "elfrt", in which case we can have multiple */
    /** instances                                                            */
    p = argv[0] + strlen( argv[0] );
    while ( (*p != '/') && (*p != '\\') && (p >= argv[0]) )
       { p--;  }     

    strcpy( prog_name, (p+1) );
    p = prog_name + strlen(prog_name) - 4;
    if ( stricmp( p, ".exe" ) == 0 )
       /* clip .EXE */
       *p = '\0';

    /** see if we are running as "Builder" */
    for ( i=1; i<argc; i++ )
       {
       if ( stricmp( argv[i], "start_builder@" ) == 0 )
          {
          RunningAsBuilder = TRUE;
          break;
          }
       if ( stricmp( argv[i], "-background" ) == 0 )
          {
          /* running in the background as a seperate task, do not */
          /* bother looking for other instances */
          return( TRUE );
          }
       if ( (stricmp(argv[i], "-sysvar") == 0) && 
			(strstr(argv[i+1], "JAVA") || strstr(argv[i+1], "AAHTTP")) )
          running_anyware = TRUE;
	   if ( stricmp(argv[i], "-add") == 0 )
		  /* allow for multiple axmains */
		  run_multiple = TRUE;	
       }

    /* make sure we have a unique window class name depending on
     * what we are running.    -donato
     */
    if ( running_anyware )
        strcpy(unmapped_name, "UnMappedClass-anyware");
    else
        sprintf(unmapped_name, "UnMappedClass-%s", prog_name);

    if ( stricmp( prog_name, "elfrt" ) == 0 )
       {  
       show_window = FALSE;
       goto create_unmapped;
       }
    else if ( stricmp( prog_name, "elfmain" ) == 0 )
       {  
       show_window = FALSE;
       goto create_unmapped;
       }

    /* Loop through windows to find one of our unmapped class    */
    /* If we find one it means that there is already an Applixware */
    /* running and we should poke it and exit                      */

    FoundPrev = FALSE;

	if ( !run_multiple )
		{
		if ( !running_anyware )
			{
			for ( hwndT = MS_GetWindow(MS_GetDesktopWindow(), GW_CHILD); hwndT;
                                hwndT = MS_GetWindow(hwndT, GW_HWNDNEXT) )
				{
				if ( MS_GetClassName(hwndT, szClassName, 40) )
					{
					if ( lstrcmpi(szClassName, unmapped_name ) == 0 )
						{
						/* we found another axmain, send it our command line
						 * so it does what the user wanted, and then we exit
						 */
						FoundPrev = TRUE;
						SendCommandLine(argc, argv, hwndT);
						return FALSE;
						}
					}
				}
			}
		else
			{
			/* java mode: need to set error mode so that system errors are
			 * not displayed on the server and instead logged to the EventLog.
			 */
			MS_SetErrorMode(SEM_FAILCRITICALERRORS);
			}
		}
   
    /* find the dimensions of the startup bitmap to use for the dummy window */
    width = height = 500;       /* some hard default values */
    if ( RunningAsBuilder )
        hBitmap = MS_LoadBitmap( hInstance, NXLT("builder_bitmap") );
    else
        hBitmap = MS_LoadBitmap( hInstance, NXLT("startup_bitmap") );

    if ( hBitmap != (HBITMAP)NULL )
       {
       /* loaded, get the dimensions */
       ret = MS_GetObject( hBitmap, sizeof(BITMAP), &bm_info );
       if ( ret )
        {
         width = bm_info.bmWidth;
         height = bm_info.bmHeight;
         }
       }

create_unmapped:
    /* create a top level un-mapped window as the central hook for the
     * clipboard and for snap-to-clipboard functionality.
     */
    memset(&umc, 0, sizeof(umc));
    umc.style = (UINT) NULL;
    umc.lpfnWndProc = (WNDPROC) UnMappedClassProc;
    umc.cbClsExtra = 0;
    umc.cbWndExtra = 0;
    umc.hInstance = hInstance;
    umc.hIcon = NULL;
    umc.hCursor = NULL;         //MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
    umc.hbrBackground = NULL;   //(HBRUSH) (COLOR_BTNFACE + 1);
    umc.lpszClassName = unmapped_name;
    if ( !MS_RegisterClass(&umc) )
        return (FALSE);

    /* get the dimensions of the screen so that we can put the startup */
    /* bitmap right in the middle of the screen                        */
    hdc = MS_CreateDC("DISPLAY", NULL, NULL, NULL );
    screen_width = MS_GetDeviceCaps( hdc, HORZRES );
    screen_height = MS_GetDeviceCaps( hdc,VERTRES );
    MS_DeleteDC( hdc );

    xpos = (screen_width - width) / 2;
    ypos = (screen_height - height) / 2;

    style = WS_POPUP;
    AxTopHWNDNeverMapped = AxDummyWin = WXDummyWnd =
        hWnd = MS_CreateWindow( unmapped_name,
                             NXLT("Applixware Startup"),
                             style,
                             xpos, ypos, width, height,  /* x,y pixels */
                             (HWND)NULL, (HMENU)NULL,
                             hInstance, (LPVOID)NULL);
    if ( !hWnd )
        return FALSE;
    if ( show_window )
        {
        MS_ShowWindow(hWnd, SW_SHOW);
        MS_UpdateWindow(hWnd);
        }

    if ( hBitmap )
        /** Note: the bitmap is painted on WM_PAINT in UnMappedClassProc() **/
        MS_DeleteObject(hBitmap);

    //Ctl3dRegister(hInst); /* to enable 3-D controls */
    //Ctl3dAutoSubclass(hInst);

    return (TRUE);
}


/****************************************************************************/
static BOOL
InitApplication(HANDLE hInstance)
{
    static WNDCLASS mc,    /* main "shell" class */
                    wc,    /* application "work" class */
           table_class,    /* table widget class */
                    sc,    /* application "simple" class */
                    pc;    /* plase widget class */

    memset(&mc, 0, sizeof(mc));
    mc.style = (UINT) NULL;
    mc.lpfnWndProc = (WNDPROC) MainClassProc;
    mc.cbClsExtra = 0;
    mc.cbWndExtra = 0;
    mc.hInstance = hInstance;
    mc.hIcon = NULL;    /* icon is painted during WM_PAINT */
    mc.hCursor = NULL; //MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
    /* user defined background */
    mc.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
    mc.lpszClassName = NXLT("MainClass");
    if ( !MS_RegisterClass(&mc) )
        return (FALSE);

    memset(&wc, 0, sizeof(wc));
    /* the OWNDC style means that any device context we create for this
     * window class is "private", and does not need to be released by
     * the programmer (Windows removes it when the window is destroyed).
     * Doing this seems to cure the HDC problems encountered on Win 95,
     * and should pose no problem on NT. One wonders how quickly we will
     * run out of resources on Win 95...       -donato
     */
    wc.style = CS_DBLCLKS; // | CS_OWNDC;
    wc.lpfnWndProc = (WNDPROC) WorkClassProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = NULL;      /* icon is painted during WM_PAINT */
    wc.hCursor = NULL;    /* cursor should be set elsewhere */
    /* user defined background */
    wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
    wc.lpszClassName = NXLT("WorkClass");
    if ( !MS_RegisterClass(&wc) )
        return (FALSE);

    memset(&sc, 0, sizeof(sc));
    sc.style = (UINT) NULL;
    sc.lpfnWndProc = (WNDPROC) SimpleClassProc;
    sc.cbClsExtra = 0;
    sc.cbWndExtra = 0;
    sc.hInstance = hInstance;
    sc.hIcon = NULL;
    sc.hCursor = NULL;
    sc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
    sc.lpszClassName = NXLT("SimpleClass");
    return (MS_RegisterClass(&sc));
}

/****************************************************************************
 - Registers a separate window  class for dialogs
*/
static BOOL
InitDialogs(HANDLE hInstance)
{
    static WNDCLASS dc,    /* dialog class */
                    mdc;   /* main class for dialogs only */ 

    /* create a main class for dialogs only. is is the same as the *
     * normal main class, except the CS_SAVEBITS flag is set.      */
    memset(&mdc, 0, sizeof(mdc));
    mdc.style = CS_SAVEBITS;
    mdc.lpfnWndProc = (WNDPROC) MainClassProc;
    mdc.cbClsExtra = 0;
    mdc.cbWndExtra = 0;
    mdc.hInstance = hInstance;
    mdc.hIcon = NULL;    /* icon is painted during WM_PAINT */
    mdc.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
    /* user defined background */
    mdc.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
    mdc.lpszClassName = NXLT("MainDialogClass");
    if ( !MS_RegisterClass(&mdc) )
        return (FALSE);

    memset(&dc, 0, sizeof(dc));
    dc.style = CS_DBLCLKS;
    dc.lpfnWndProc = (WNDPROC) DialogClassProc;
    dc.cbClsExtra = 0;
    dc.cbWndExtra = 0;
    dc.hInstance = NULL;
    dc.hIcon = NULL;    /* icon is painted during WM_PAINT */
    dc.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
    /* user defined background */
    dc.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
    dc.lpszClassName = NXLT("DialogClass");
    return (MS_RegisterClass(&dc));
}

/****************************************************************************
 - Registers a separate window class and procedure for toolbars & rulers
*/
static BOOL
InitToolWidgets(HANDLE hInstance)
{
    static WNDCLASS wid_class;

    /* first get some basic screen metrics.  These help sort out the */
    /* differences between the user running "large" or "small" fonts - jon */
    Scrollbar_Thickness = MS_GetSystemMetrics( SM_CXHSCROLL );
    if ( RunningWin95Look )
        Option_Pad = Scrollbar_Thickness + 10;
    else
        Option_Pad = Scrollbar_Thickness + 6;
    Entry_Height = MS_GetSystemMetrics( SM_CYCAPTION );

    memset(&wid_class, 0, sizeof(wid_class));
    wid_class.style = (UINT) NULL;
    wid_class.lpfnWndProc = (WNDPROC) ToolBarClassProc;
    wid_class.cbClsExtra = 0;
    wid_class.cbWndExtra = 0;
    wid_class.hInstance = NULL;
    wid_class.hIcon = NULL;
    wid_class.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
    /* user defined background */
    wid_class.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
    wid_class.lpszClassName = NXLT("ToolBarClass");
    if ( !MS_RegisterClass(&wid_class) )
        return (FALSE);

    memset(&wid_class, 0, sizeof(wid_class));
    wid_class.style = CS_SAVEBITS;
    wid_class.lpfnWndProc = (WNDPROC) PopupClassProc;
    wid_class.cbClsExtra = 0;
    wid_class.cbWndExtra = 0;
    wid_class.hInstance = hInstance;
    wid_class.hIcon = NULL;
    wid_class.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
    /* user defined background */
    wid_class.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
    wid_class.lpszClassName = NXLT("PopupClass");
    return (MS_RegisterClass(&wid_class));
}



/*************************************************************************
function: WXInfoMessage - Post a blocking info box
*/
void
WXInfoMessage(mbchar *str)
{
    /* on Windows, this is the "i" in the circle bitmap */
    MS_MessageBox((HWND)NULL, str, NXLT("msg"),
        MB_TASKMODAL | MB_OK | MB_ICONINFORMATION);
    ElfHasStatusMessageDisplayed = FALSE;
}

/*************************************************************************
function: WXErrorMessage - Post an error message
*/
void
WXErrorMessage(mbchar *str)
{
    /* on Windows, this is the STOP sign bitmap */
    /* Zmsgup( str );    common hook for debugging */
    MS_MessageBox((HWND)NULL, str, NXLT("msg"),
            MB_TASKMODAL | MB_OK | MB_ICONSTOP);
    ElfHasStatusMessageDisplayed = FALSE;
}


/*************************************************************************
function: EventAsserter - Abort
*/
void
EventAsserter(char *name, int line)
{
    char buf[500];
    sprintf(buf, "assertion failed at line %d in %s\n", line, name);
    taskAbort(buf);
}




extern char *ThimApplixDir;
#define AX_WM_SNAPINIT (WM_USER+101)

LRESULT CALLBACK
UnMappedClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    LRESULT retval;
    PAINTSTRUCT ps;
    HDC hdc;
    HBITMAP hBitmap;
	HPALETTE hpalette;
    static POINT ptBeg, ptEnd, ptTemp;
    static POINTS sptBeg, sptEnd;
    static int in_snap_mode = FALSE;
    static int snapping = FALSE;
    /* the snap-to-clipboard cursors. */
    static HCURSOR top_left_cursor, top_right_cursor,
                    bottom_left_cursor, bottom_right_cursor;


    retval = 0;
    switch (message)
        {
        case WM_PAINT:
            if ( in_snap_mode )
                {
                retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
                break;
                }

            /* paint the startup bitmap */
            hdc = MS_BeginPaint( hWnd, &ps );
            if ( RunningAsBuilder )
				{
				hBitmap = axmsLoadBitmapWithPalette(hInst,
													NXLT("builder_bitmap"),
													&hpalette);
				}
			else
				{
				hBitmap = axmsLoadBitmapWithPalette(hInst,
													NXLT("startup_bitmap"),
													&hpalette);
				}
			if ( hBitmap )
				{
				axmsDrawWindowsBitmapWithPalette(hdc, hBitmap, hpalette, 0, 0);
				MS_DeleteObject(hBitmap);
				MS_DeleteObject(hpalette);
				}
            MS_EndPaint( hWnd, &ps );
            break;
              
        case AX_EXECINSTANCE:
            /* message from another applixware which is starting, collect */
            /* the command line it will pass us and do the request        */
            CollectMessage( wParam, lParam );
            break;

        case WM_RENDERFORMAT:
            /* user has pasted, time to render data onto the clipboard. */
            /* We are here because the "exit clipboard" (that is, the   *
             * non-mapped WXDummyWnd) owns the clipboard. It must now   *
             * supply the data.                                         */
            SupplyExitClipboardData((UINT)wParam);
            break;

        case WM_DESTROYCLIPBOARD:
            {
            XEvent xevent;
            xevent.type = SelectionClear;
            xevent.xselectionclear.window = hWnd;
            xevent.xselectionclear.selection = XA_CLIPBOARD;
            if ( Ax_Clear_Selection )
                {
                /* only clear the selection if the app is exiting. *
                 * as opposed to when clipboard changes ownership. */
                AxSelectionEvent(&xevent);
                XDeleteProperty(Dpy, xevent.xselectionclear.window,
                                xevent.xselectionclear.selection);
                }
            break;
            }
#if 0
        case WM_RENDERALLFORMATS:
            /* applixware is terminating. */
            RenderExitClipboardData();
            break;
#endif

        case AX_WM_SNAPINIT:
            MS_SetCapture(hWnd);
            in_snap_mode = TRUE;

            /* load the cursors we'll need. */
            top_left_cursor = MS_LoadCursor(hInst, "ul_angle");
            top_right_cursor = MS_LoadCursor(hInst, "ur_angle");
            bottom_left_cursor = MS_LoadCursor(hInst, "ll_angle");
            bottom_right_cursor = MS_LoadCursor(hInst, "lr_angle");
            break;

        case WM_LBUTTONDOWN:
            snapping = TRUE;
            sptBeg = MAKEPOINTS (lParam);
            ptBeg.x = ptEnd.x = (long)sptBeg.x;
            ptBeg.y = ptEnd.y = (long)sptBeg.y;
            MS_ClientToScreen(hWnd, &ptBeg);
            MS_ClientToScreen(hWnd, &ptEnd);
            break;

        case WM_MOUSEMOVE:
            if ( snapping )
                {
                HDC hdc = MS_GetDC(hWnd);
                sptEnd = MAKEPOINTS(lParam);

                /* first set the appropriate corner cursor... */
                if ( (sptEnd.x > ptBeg.x) && (sptEnd.y > ptBeg.y) )
                    MS_SetCursor(bottom_right_cursor);
                else if ( (sptEnd.x < ptBeg.x) && (sptEnd.y > ptBeg.y) )
                    MS_SetCursor(bottom_left_cursor);
                else if ( (sptEnd.x < ptBeg.x) && (sptEnd.y < ptBeg.y) )
                    MS_SetCursor(top_left_cursor);
                else if ( (sptEnd.x > ptBeg.x) && (sptEnd.y < ptBeg.y) )
                    MS_SetCursor(top_right_cursor);

                /* now draw the bounding box. */
                MS_SelectObject(hdc, MS_GetStockObject(NULL_BRUSH));
                MS_SetROP2(hdc, R2_NOT);
                MS_Rectangle(hdc, ptBeg.x, ptBeg.y, ptEnd.x, ptEnd.y);
                ptEnd.x = (long)sptEnd.x;
                ptEnd.y = (long)sptEnd.y;
                MS_ClientToScreen(hWnd, &ptEnd);
                MS_Rectangle(hdc, ptBeg.x, ptBeg.y, ptEnd.x, ptEnd.y);
                MS_ReleaseDC(hWnd, hdc);
                }
            else
                {
                MS_SetCursor(top_left_cursor);
                }
            break;

        case WM_LBUTTONUP:
            {
            HBITMAP hbm, old_hbm;
            HDC hdc, mem_hdc;
            int rectWid, rectHyt, left, top;
            char bmp_tempfile[STRPATH+1],
                    ge_tempfile[STRPATH+1],
                    cmdbuf[STRPATH+1];

            hdc = MS_GetDC(hWnd);

            sptEnd = MAKEPOINTS(lParam);
            ptEnd.x = (long)sptEnd.x;
            ptEnd.y = (long)sptEnd.y;

            /* The reason for the -2 below and the "+1" is that we do not  */
            /* want to copy the bounding box we have drawn around the area */
            rectWid = ABS(ptEnd.x - ptBeg.x) - 2;
            rectHyt = ABS(ptEnd.y - ptBeg.y) - 2;
            left = MIN( ptBeg.x, ptEnd.x ) + 1;
            top = MIN( ptBeg.y, ptEnd.y ) + 1;

            MS_ReleaseCapture();
            in_snap_mode = snapping = FALSE;

            if ( rectWid <= 0 || rectHyt <= 0 )
                goto done;

            /* Now the bitmap */
            mem_hdc = MS_CreateCompatibleDC(hdc);
            hbm = MS_CreateCompatibleBitmap(hdc, rectWid, rectHyt);
            old_hbm = MS_SelectObject(mem_hdc, hbm);
            MS_BitBlt(mem_hdc, 0, 0, rectWid, rectHyt, hdc, left, top, SRCCOPY);
            MS_SelectObject(mem_hdc, old_hbm);
            MS_DeleteDC(mem_hdc);

            AxTempFile(NULL, bmp_tempfile);
            WriteBitmapToFile(hbm, bmp_tempfile);

            AxTempFile(NULL, ge_tempfile);
            sprintf(cmdbuf, "\"%s\\filters\\geinout.exe\" \"%s\" \"%s\" -i bmp -s \"%s\"",
                    ThimApplixDir, bmp_tempfile, ge_tempfile, ThimApplixDir);
            XmPutHourglass();
            AxRunProgram(cmdbuf, NULL, NULL, NULL, FALSE);/* run the filter. */
            ElfbCopyFileToClipboard(ge_tempfile, AX_DOC_TYPE_UNKNOWN);

            /* cleanup */
            MS_DeleteObject(hbm);
            MS_ReleaseDC(hWnd, hdc);
            AxDeleteTempfile(ge_tempfile);
            AxDeleteTempfile(bmp_tempfile);

done:
            /* restore the unmapped window to its hidden position */
            MS_SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 100, 100, SWP_NOACTIVATE);
            MS_ShowWindow(hWnd, SW_HIDE);
            break;
            }

        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }

    return retval;
}


/**************************************************************************/
/* the following function, CheckForSpecialMessages(), is used to look for */
/* particular "global" message which we want to process, while Applixware */
/* is "running".  Currently we check for window position change messages  */
/* which are sent by the "TopDesk" virtual desktop application            */
/* This function is currently called from within the ELF main loop in     */
/*    "elintr.c"                                                          */
/**************************************************************************/
int Special_Check_Limit = 1;

void
CheckForSpecialMessages()
{
    MSG msg;
    int ret;
    static counter = -1;
    char *p;

    if ( Special_Check_Limit == 1 )
        {
        p = GetProfileByStr("SpecialCheckFrequency");
        Special_Check_Limit = atoi( p );
        if ( Special_Check_Limit == 1 )
           Special_Check_Limit = 2;      /* we use 1 as a flag */
        }

    if ( Special_Check_Limit < 2 )
        return;

    counter++;
    if ( counter < Special_Check_Limit )
       return;

    counter = 0;

    ret = MS_PeekMessage(&msg, (HWND)NULL, WM_WINDOWPOSCHANGING, 
                              WM_WINDOWPOSCHANGED, PM_REMOVE);
    if ( ret )
        MS_DefWindowProc(msg.hwnd, msg.message, msg.wParam, msg.lParam);
       
    return;
}

static void
axmsClose(AXWidget_main mw)
{
    XmRowColumnCallbackStruct data;
    int size, ix, didPoke;
    AXWidget_main tw = mw;
    AXWidget_dialog w_dlg;

	if ( mw->elfObject || (mw->dialog && mw->dialog->elfObject) )
    {
	    if ( !mw->elfObject )
            mw->elfObject = AxTaskCopyElfData(0,mw->dialog->elfObject);
        CallWidget(mw->taskOwner,(AXWidget)mw,EV_DLG_DESTROY_,(data_ptr)NULL);
    }
    else if ( mw->dialog )
    {
        /* do exit poke if dialog is interested. */
        w_dlg = mw->dialog;
        size = IntsArraySize(w_dlg->pokeCodes);
        for( ix = 0, didPoke = FALSE; ix < size; ix++ )
        {
            if ( ReadIntsArray(w_dlg->pokeCodes, ix) == POKE_EXIT )
            {
                data.reason = POKE_EXIT;
                data.data = "";
                if ( w_dlg->callback && w_dlg->callbacktag )
                {
                    AxCallback(w_dlg->callback, (AXWidget)tw,
                               w_dlg->callbacktag, (caddr_t)&data);
                    didPoke = TRUE;
                    break;
                }
            }
        }
        if ( !didPoke )
            KillTask(w_dlg->taskOwner);
    }
    else
    {
        /* this is an app (rather than a dialog) */
        AxExitThisAppWindow();
    }
}


#define AX_WM_PAINT_TOOLBAR       (WM_USER + 1)  /* used in MainClassProc  */
#define AX_WM_EXPOSURE            (WM_USER + 2)
#define AX_WM_SETWINDOWBACKGROUND (WM_USER + 3)
#define AX_WM_PAINTBACKGROUND     (WM_USER + 4)


/************************************************************************
 FUNCTION : MainClassProc( HWND, UINT, WPARAM, LPARAM )
 PURPOSE  : Processes messages for the MainClass (app/dialog shell)
*/
LRESULT CALLBACK
MainClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int is_ge, moving_vertical;
    UINT entries_realized;    /* for palette realization */
    AXWidget w;
    AXWidget_main mw;
    HDC hdc;
    PAINTSTRUCT ps;
    HPALETTE old_palette;
    UINT widgetId;
    LRESULT retval;
    struct wind_struct *winP;
    XEvent xevent;
    XmAnyCallbackStruct data;    
    int sub_command;
    HICON hicon;
    unsigned long pixel;    /* for use during the WM_CTLCOLOR events. */
    int ret;
    static HBRUSH button_brush = NULL;
    static HBRUSH static_brush = NULL;
    //static HBRUSH edit_brush = NULL;
    //static FILE *fp;


    /* Find the main window (widget) associated with the event */
    mw = (AXWidget_main) GetWidgetFromHWND(hWnd, W_MAIN);

    /* process WM_DESTROY message first because we do not need a *
     * widget, and in fact won't have one, because it will have  *
     * been removed from the list by WXDestroyWidget.            */
    /* actually, we will have a widget if a child dialog is being     *
     * destroyed. (e.g. if we exit an application with a child dialog *
     * still active, Windows will destroy the child for us before we  *
     * call WXDestroyWidget). So make sure we invalidate the window   *
     * handles in the widget.                                -donato  */
    if ( message == WM_DESTROY )
        {
        if ( mw )
            {
            AxWinDeleteWidgetDrawable((AXWidget)mw);
            mw->winid = NULL;
			if (mw->dialog)
				AxWinDeleteWidgetDrawable((AXWidget)mw->dialog);
				if (mw->dialog) 
					mw->dialog->winid = NULL;
            }
        if ( button_brush )
            {
            MS_DeleteObject(button_brush);
            button_brush = NULL;
            }
         if ( static_brush )
            {
            MS_DeleteObject(static_brush);
            static_brush = NULL;
            }
        DeleteDlgBrush();
        return (0);
        }

    if ( !mw )
        {
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }
    if ( (mw->workWindow != NULL) && (mw->workWindow->window != (Window)NULL) )
        {
        winP = SetWpFromX11Window(mw->workWindow->window);
        if ( winP == NULL )
            winP = Wp;        /* use the old global */
        }


    retval = 0;
    switch (message)
        {
#if 0
    case WM_WINDOWPOSCHANGING:
        {
        WINDOWPOS *wp;
        char flags[1000];
        flags[0] = '\0';

        wp = (WINDOWPOS *)lParam;
        if ( fp == (FILE *)NULL )
           {
           fp = fopen("\\tmp\\log", "w+" );
           }
        if ( fp )
           {
           fprintf( fp, "\nWM_WINDOWPOSCHANGING:   hwnd = 0x%lx\n", wp->hwnd );
           fprintf( fp, "   x = %d\n", wp->x );
           fprintf( fp, "   y = %d\n", wp->y );
           fprintf( fp, "   width = %d\n", wp->cx );
           fprintf( fp, "   height = %d\n", wp->cy );
           if ( wp->flags & SWP_NOSIZE )
               strcat( flags, "SWP_NOSIZE " );
           if ( wp->flags & SWP_NOMOVE )
               strcat( flags, "SWP_NOMOVE " );
           if ( wp->flags & SWP_NOZORDER )
               strcat( flags, "SWP_NOZORDERE " );
           if ( wp->flags & SWP_NOREDRAW )
               strcat( flags, "SWP_NOREDRAW " );
           if ( wp->flags & SWP_NOACTIVATE )
               strcat( flags, "SWP_NOACTIVATE " );
           if ( wp->flags & SWP_DRAWFRAME  )
               strcat( flags, "SWP_DRAWFRAME ");
           if ( wp->flags & SWP_SHOWWINDOW )
               strcat( flags, "SWP_SHOWWINDOW ");
           if ( wp->flags & SWP_HIDEWINDOW )
               strcat( flags, "SWP_HIDEWINDOW ");
           if ( wp->flags & SWP_NOCOPYBITS )
               strcat( flags, "SWP_NOCOPYBITS ");
           if ( wp->flags & SWP_NOOWNERZORDER )
               strcat( flags, "SWP_NOOWNERZORDER" );
           fprintf( fp, "    %s\n", flags );
           fflush( fp );
           }


        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }
    case WM_WINDOWPOSCHANGED:
        {
        WINDOWPOS *wp;
        char flags[1000];
        flags[0] = '\0';

        wp = (WINDOWPOS *)lParam;
        if ( fp == (FILE *)NULL )
           {
           fp = fopen("\\tmp\\log", "w+" );
           }
        if ( fp )
           {
           fprintf( fp, "\nWM_WINDOWPOSCHANGED:   hwnd = 0x%lx\n", wp->hwnd );
           fprintf( fp, "   x = %d\n", wp->x );
           fprintf( fp, "   y = %d\n", wp->y );
           fprintf( fp, "   width = %d\n", wp->cx );
           fprintf( fp, "   height = %d\n", wp->cy );
           if ( wp->flags & SWP_NOSIZE )
               strcat( flags, "SWP_NOSIZE " );
           if ( wp->flags & SWP_NOMOVE )
               strcat( flags, "SWP_NOMOVE " );
           if ( wp->flags & SWP_NOZORDER )
               strcat( flags, "SWP_NOZORDERE " );
           if ( wp->flags & SWP_NOREDRAW )
               strcat( flags, "SWP_NOREDRAW " );
           if ( wp->flags & SWP_NOACTIVATE )
               strcat( flags, "SWP_NOACTIVATE " );
           if ( wp->flags & SWP_DRAWFRAME  )
               strcat( flags, "SWP_DRAWFRAME ");
           if ( wp->flags & SWP_SHOWWINDOW )
               strcat( flags, "SWP_SHOWWINDOW ");
           if ( wp->flags & SWP_HIDEWINDOW )
               strcat( flags, "SWP_HIDEWINDOW ");
           if ( wp->flags & SWP_NOCOPYBITS )
               strcat( flags, "SWP_NOCOPYBITS ");
           if ( wp->flags & SWP_NOOWNERZORDER )
               strcat( flags, "SWP_NOOWNERZORDER" );
           fprintf( fp, "    %s\n", flags );
           fflush( fp );
           }
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }
#endif

    case WM_SETCURSOR:
        {
        HCURSOR hcursor;
        /* if the cursor is in the client area or over the menubar,
         * set the cursor appropriately; otherwise let Windows set it.
         */
        if ( LOWORD(lParam) == HTCLIENT || LOWORD(lParam) == HTMENU )
            {
            if ( THIMhelpMode )
                {
                MS_SetCursor(mw->help_cursor);
                retval = TRUE;
                }
            else if ( ElfInLearnMode )
                {
                MS_SetCursor(ThimRecordCursor);
                retval = TRUE;
                }
            else
                retval = AXSetActiveCursor((AXWidget)mw);

            if ( !retval )
                {
                hcursor = (HCURSOR)MS_GetWindowLong(hWnd, GWL_USERDATA);
                MS_SetCursor(hcursor);
                retval = TRUE;
                }
            }
        else
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }


    case WM_ACTIVATE:
#if 0
    /* this is REALLY historical!  do we need it?   -donato */
        if ( mw->notTransient )
            AxActiveTask = AxUIDFromPid(mw->taskOwner);
#endif
		/* if an application is being activated, set the cur_win global */
        if ( !mw->dialog && LOWORD(wParam) != WA_INACTIVE )
    	    SetCurwinFromWp(winP);

        if ( mw->dialog )
            {
            if ( LOWORD(wParam) == WA_INACTIVE )
                {
                /* dialog is losing focus */
				xmDialogFocus(mw, FALSE);
                CurrentDialogHwnd = NULL;
				MS_DestroyCaret();
                }
            else
                {
                /* activate window */
                if ( mw->dialog->winid )
                    {
					xmDialogFocus(mw, TRUE);
                    CurrentDialogHwnd = mw->dialog->winid;
                    SetActiveEntryWidget(mw->dialog);
                    }
                else 
                    {
                    retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
                    if ( lParam != (LPARAM)NULL )
                        {
                        /* one of our other windows has been de-activated */
                        /* post a message back to ourselves so that things */
                        /* get correctly set up in the dialog.  The need for */
                        /* this is not understood, but it seems to be required*/
                        /* to get the setting of "CurrentDialogHwnd" correct */
                        /* do not send another one to ourselves */
                        MS_PostMessage(mw->winid, WM_ACTIVATE,
                                (WPARAM)WA_ACTIVE, (LPARAM)NULL);
                        }
                    else
                        {
                        /* lparam is zero, meaning we are being activated */
                        /* from the desktop                               */
                        MS_SetForegroundWindow( mw->winid );
                        }
                 
                    }
                }
            }
        else if ( mw->workWindow )
            {
            /* when an application is activated, give the work space focus. */
            if ( LOWORD(wParam) != WA_INACTIVE )
                {
                MS_SetFocus(mw->workWindow->winid);
                }
            /* send down the Focus Change event */
            if ( WinToXEvent(hWnd, message, wParam,lParam, &xevent,
                                         (AXWidget)mw->workWindow) )
                {
                DoAppEvent(&xevent);
                }
            }
        break;


    case WM_MOUSEACTIVATE:
        if ( TaskOfWidgetPended(mw) )
            {
            /* user tried to activate a pended dialog (i.e. a modal *
             * dialog is taking precedence).        -donato         */
            RingTheBell();
            retval = MA_NOACTIVATEANDEAT;
            }
        else
            {
            /* if a rowcol or popup widget is active while the *
             * user has activated another window, we must make *
             * sure the widget is destroyed.                   */
            if ( RowColumnArmed )
                {
                PaintRowColumnPulldown(RowColumnArmed, OPTION_DONE, &xevent);
                RowColumnArmed = NULL;
                }
            if ( PopupArmed )
                {
                PaintPopupPulldown(PopupArmed, OPTION_DONE, &xevent);
                PopupArmed = NULL;
                }
            if ( RightButtonArmed )
                {
                RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                            OPTION_DONE, &xevent);
                }
            retval = MA_ACTIVATE;
            }
        break;


    case WM_MOUSEMOVE:
        if ( wParam != MK_LBUTTON &&
                wParam != MK_RBUTTON &&
                wParam != MK_MBUTTON )
            {
            if ( RowColumnArmed )
                {
                PaintRowColumnPulldown(RowColumnArmed, OPTION_DONE, &xevent);
                RowColumnArmed = NULL;
                }
            if ( PopupArmed )
                {
                PaintPopupPulldown(PopupArmed, OPTION_DONE, &xevent);
                PopupArmed = NULL;
                }
            }
        break;


    case WM_SETFOCUS:
        if ( mw->workWindow )
            MS_SetFocus(mw->workWindow->winid);
        break;


    case WM_INITMENU:
        if ( wParam != (UINT)MS_GetMenu(hWnd) )
            return MS_DefWindowProc(hWnd, message, wParam, lParam);

        SetCurWinFromMenuWidget(mw->menuBar);
        AxSetMenuFlags(mw->menuBar, (HMENU)wParam);
        break;


    case WM_PALETTECHANGED:
        /* don't realize palette if called from same window, *
         * or else it will infinitely loop!                  */
        if ( (HWND)wParam == hWnd )
            break;

        hdc = MS_GetDC(hWnd);
        old_palette = MS_SelectPalette(hdc, AxWinPaletteHandle, FALSE);
        MS_RealizePalette(hdc);

        // When updating the colors for an inactive window,
        // UpdateColors can be called because it is faster than
        // redrawing the client area (even though the results are
        // not as good)
        UpdateColors(hdc);

        if ( old_palette )
            MS_SelectPalette( hdc, old_palette, FALSE );
        MS_ReleaseDC( hWnd, hdc );
        break;

    case WM_QUERYNEWPALETTE:
        hdc = MS_GetDC(hWnd);
        old_palette = MS_SelectPalette(hdc, AxWinPaletteHandle, FALSE);
        entries_realized = MS_RealizePalette(hdc);
        if ( entries_realized )
#if 1
            /* I have gone to a strategy of using "UpdateColors" rather */
            /* than re-drawing the entire screen since it is much faster */
            /* and much less "flashy".  I have tested this against Excel */
            /* which is also a palette based application, and UpdateColors */
            /* seems to work fine.  If this gets to be a problem on some   */
            /* user's computer, we may have to add some profile setting    */
            /* to go back to the "full display" model. - jon               */
            UpdateColors(hdc);
#else
            MS_InvalidateRect(hWnd, (CONST RECT*)NULL, TRUE);
#endif
        MS_SelectPalette(hdc, old_palette, TRUE);
        MS_RealizePalette(hdc);
        MS_ReleaseDC(hWnd, hdc);
        retval = entries_realized;
        break;

#if 0
/* we need to handle this message ("Windows is shutting down..."),
 * but how?  Windows wants us to finish our business and return TRUE,
 * but we need to send each Applixware app a message, which means we
 * have to somehow wait for them to close down...
 */
	case WM_QUERYENDSESSION:
		axmsClose(mw);
		retval = TRUE;  /* tell Windows it can end the session */
		break;
#endif

    case WM_SYSCOMMAND:
        if ( wParam == SC_MINIMIZE )
            {
            /* if this is an app with dialogs, we want to minimize *
             * the dialogs too. In actuality, we only "hide" the   *
             * dialog windows, otherwise we'd end up with dialog   *
             * icons on the desktop.               -donato         */
            DoChildDialogs(mw, SW_HIDE);
            /* tell Windows to do its thing. */
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            }

        else if ( wParam == SC_RESTORE )
            {
            /* if this is an app with dialogs, we want to restore *
             * the dialogs too. In actuality, we "un-hide" the    *
             * dialog windows (see above).        -donato         */
            DoChildDialogs(mw, SW_RESTORE);
            /* tell Windows to do its thing. */
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            }
        else if ( wParam == SC_CLOSE )
            {
            /* user chose "Close" on the system menu... */
			axmsClose(mw);
            }
        else
            {
            /* uninteresting system command, do default. */
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            }
        break;


    case WM_SETTINGCHANGE:
        {
        HDC hdcInfo;
        int screenRes, targetRes, dep, junk;
        if ( lParam )
            {
            if ( !strcmp((char*)lParam, NXLT("TrueType")) )
                /* re-enumerate all fonts. */
                updateFontTable(NULL, &screenRes, &targetRes, &junk);
            }

        hdcInfo = MS_CreateDC(NXLT("DISPLAY"), NULL, NULL, NULL);
        dep = MS_GetDeviceCaps(hdcInfo, PLANES) *
              MS_GetDeviceCaps(hdcInfo, BITSPIXEL);
        if ( dep < 8 )
            {
            MS_MessageBox((HWND)NULL,
                     XLT("Applixware requires a minimum of 256 colors"),
                     NXLT("Applixware"), MB_OK);
            //exit(1);
            }
		else if ( dep != DpyDepth )
			{
			DpyDepth = dep;
			if ( AxWinPalette )
				{
        		free(AxWinPalette);
        		AxWinPalette = NULL;
				}
       		AxWinSetPalette();
        	/* set up application color array */
        	AxWinSetPixels();
			}
        DpyWid = MS_GetDeviceCaps(hdcInfo, HORZRES);
        DpyHt = MS_GetDeviceCaps(hdcInfo, VERTRES);
        MS_DeleteDC(hdcInfo);
        break;
        }

    case WM_SYSCOLORCHANGE:
        /* user has changed Windows system colors. */
        /* updates pixel globals (ForePixel, etc...) */
        SetupUserColors();
        /* update WidgetPixel global array and GCs (ForeGC, etc...) */
        WidgetColorsFromProfile();

        /* NECESSARY HACK: the SS plates tab widgets are made of 8-bit
         * images based on widget pixel values. On Unix, a color change
         * (which always happens thru Applixware) goes thru the SS main loop
         * which will re-create the tab widgets. on Windows (where the colors
         * are set thru the system, for now), we get this message and a
         * later WM_PAINT to do re-paints. Since we only get a re-paint
         * we still have handles to the old bitmap images in the pix cache.
         * So we delete the appropriate images here so that they get
         * properly updated at paint time.               -donato
         */
        deletePixmapFromCache(NXLT("ssbkltab"));
        deletePixmapFromCache(NXLT("ssbwltab"));
        deletePixmapFromCache(NXLT("ssfrltab"));
        deletePixmapFromCache(NXLT("ssbkrtab"));
        deletePixmapFromCache(NXLT("ssbwrtab"));
        deletePixmapFromCache(NXLT("ssfrrtab"));
        deletePixmapFromCache(NXLT("sslrtab"));
        deletePixmapFromCache(NXLT("ssltab"));
        deletePixmapFromCache(NXLT("ssrrtab"));
        deletePixmapFromCache(NXLT("ssrtab"));
        break;


    case WM_CTLCOLORBTN:
        /* we use RGB colors here because we must use the Windows default *
         * palette anyway (the only colors the user can choose from).     */
        /* Find the button widget associated with the event */
        w = GetWidgetFromHWND((HWND)lParam, W_BUTTON);
        if ( !button_brush )
            {
            if ( w && w->widgetColor )
                pixel = w->widgetColor->any.pixel;
            else
                pixel = BackPixel;
            button_brush = MS_CreateSolidBrush(GET_COLOR_VALUE(pixel));
            //button_brush = MS_CreateSolidBrush(BackPixelRGB);
            }
        MS_SetBkColor((HDC)wParam, GET_COLOR_VALUE(pixel));
        //MS_SetBkColor((HDC)wParam, BackPixelRGB);
        if ( w && w->textColor )
            pixel = w->textColor->any.pixel;
        else
            pixel = ForeWorkPixel;
        MS_SetTextColor((HDC)wParam, GET_COLOR_VALUE(pixel));
        //MS_SetTextColor((HDC)wParam, ForeWorkPixelRGB);

#if 0
        /* do not know why this needs to be done, and the "point" positions */
        /* passed to MS_SetBrushOrgEx must be between 0-7, not window coords */
        point.x = point.y = 0;
        MS_ClientToScreen(hWnd, &point);
        MS_LPtoDP((HDC)wParam, (LPPOINT) & point, 1);
        MS_SetBrushOrgEx((HDC)wParam, point.x, point.y, (LPPOINT)NULL);
#endif

        retval = (DWORD)button_brush;
        break;


    case WM_CTLCOLORSTATIC:
        /* we use RGB colors here because we must use the Windows default *
         * palette anyway (the only colors the user can choose from).     */
        if ( !static_brush )
            static_brush = MS_CreateSolidBrush(RecessPixelRGB);
        MS_SetBkColor((HDC)wParam, RecessPixelRGB);
        MS_SetTextColor((HDC)wParam, ForeWorkPixelRGB);

        retval = (DWORD)static_brush;
        break;


    case WM_CHAR:
    case WM_KEYDOWN:
        {
        int did_event;
        if ( mw->workWindow )
            did_event = DoCharEvent(mw, hWnd, message, wParam, lParam);

        if ( mw->dialog )
            did_event = DialogKeyEvent(mw, hWnd, message, wParam, lParam);

        if ( !did_event )
            {
            /* make sure we let Windows process it. */
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            }
        break;
        }

    case WM_SYSKEYDOWN:
        /* We get this message for 2 possible reasons: 1) the ALT key is
         * down while another key is pressed, thus producing a "system"
         * keydown, and 2) no window has the keyboard focus.  For case 1,
         * we just let Windows process it. We are interested in case 2,
         * however, because an Applix window may have focus, but not the
         * __keyboard__ focus. In this latter case, we send a real keydown
         * message back to the window.         -donato
         */
        if ( MS_GetKeyState(VK_MENU) < 0 )
            /* ALT key is down, make sure we let Windows process it. */
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        else
            MS_SendMessage(hWnd, WM_KEYDOWN, wParam, lParam);
        break;


    case WM_DRAWITEM:
        retval = DoOwnerdrawEvent(wParam, lParam);
        break;


    case WM_COMMAND:
        {
        AXWidget corner_button;

        widgetId = LOWORD(wParam);
        if ( widgetId < FIRST_WIDGET_ID )
            {
            /* this must be an event on the menu bar */
            CallBackToMenu(mw, wParam);
            }
        else
            {
            if ( mw->corner )
                {
                corner_button = mw->corner->widgets;
                if ( corner_button->uid == widgetId )
                    {
                    data.event  = NULL;
                    data.reason = EV_CHANGED_;
                    AxCallback(corner_button->callback, corner_button,
                            corner_button->callbacktag, (caddr_t)&data);

                    /* set focus back to the work window. */
                    MS_SetFocus(mw->workWindow->winid);
                    }
                else
                    taskAbort(NXLT("MainClassProc: WM_COMMAND, invalid id."));
                }
            else
                taskAbort(NXLT("MainClassProc: WM_COMMAND, invalid id."));
            }
        break;
        }


    case WM_GETMINMAXINFO:
        {
        int min_width, min_height, max_width, max_height;
        RECT work_area;

        if ( mw->dialog && !mw->dialog->variable_size )
            break;
        /* only set min/max if this is an app or a variable size dialog */
        if ( mw->dialog && mw->dialog->variable_size )
            {
            min_width = mw->dialog->minWidth;
            min_height = mw->dialog->minHeight;
            max_width = mw->dialog->maxWidth;
            max_height = mw->dialog->maxHeight;
            }
        else
            {
            min_width = mw->minWidth;
            min_height = mw->minHeight;

            /* get the current work area of the desktop      */
            max_height = AxWinDisplayHeight;
            max_width = AxWinDisplayWidth;
            if ( RunningWin95Look )
                {
                /* get the available work area, which is less than the full screen */
                /* because of the task bar                                         */
                ret = MS_SystemParametersInfo( SPI_GETWORKAREA, sizeof(work_area),
                                                                   &work_area, 0 );
                if ( ret )
                    {
                    max_width = work_area.right - work_area.left + 1;
                    max_height = work_area.bottom - work_area.top + 1;
                    }
                }
            }
        ((LPMINMAXINFO)lParam)->ptMinTrackSize.x = min_width;
        ((LPMINMAXINFO)lParam)->ptMinTrackSize.y = min_height;
        ((LPMINMAXINFO)lParam)->ptMaxSize.x = max_width;
        ((LPMINMAXINFO)lParam)->ptMaxSize.y = max_height;
        break;
        }


    case WM_SIZE:
        /* convert Windows message to X ConfigureNotify event. */
        (void)WinToXEvent(hWnd, message, wParam,lParam, &xevent, (AXWidget)mw);

        /* only rebuild the window if it hasn't been minimized.    *
         * let the PaintWindowsIcon code handle the minimized case.*/
        if ( wParam != SIZE_MINIMIZED )
            {
            RebuildGDIWindow(mw, &xevent);
            MS_SetWindowText(mw->winid, mw->name);
            }
        else
            {
            /* we are minimizing, set the icon name. *
             * wstr holds the icon name.             */
            MS_SetWindowText(mw->winid, mw->wstr);
            }
        break;

    case AX_WM_PAINT_TOOLBAR:
        if ( mw->toolBar && mw->toolBar->height > 0 )
            RealizeToolBar(mw->toolBar);
        break;

    case WM_PAINT:
        {
        MS_BeginPaint(hWnd, &ps);
        if ( mw->toolBar && mw->toolBar->initial_paint && 
                mw->toolBar->height > 0 )
            {
#if 0
            /* make sure toolbar exists and is visible */
            RealizeToolBar(mw->toolBar);
            mw->toolBar->initial_paint = FALSE;
#else
            /* initially, toolbar is not set up correctly, *
             * so post a custom WM_PAINT message. when we  *
             * are here again, toolbar will be ready to paint. */
            MS_PostMessage(mw->winid, AX_WM_PAINT_TOOLBAR, (WPARAM)0, 0L);
            mw->toolBar->initial_paint = FALSE;
#endif
            }

        if ( mw->dialog && !mw->dialog->winid )
            RealizeDialog(mw->dialog);

        if ( mw->ruler && !mw->ruler->winid )
            RealizeRuler(mw);

        if ( mw->plates && !mw->plates->winid )
            RealizePlates(mw->plates);

        if ( mw->corner && !mw->corner->winid )
            PaintCorner(mw->corner, (XExposeEvent*)NULL, 0, TRUE);

        if ( mw->pageBar && !mw->pageBar->winid )            
            {
            RealizePageBar(mw->pageBar, mw->statusArea->xpos,
                                        mw->statusArea->ypos);
            }
        if ( mw->statusArea && !mw->statusArea->winid )           
            RealizeStatusWidget(mw);

        if ( mw->palette && !mw->palette->winid && mw->palette->display )
            RealizePaletteWidget( (AXWidget)mw->palette );

        if ( mw->colorpal && !mw->colorpal->winid && mw->colorpal->display )
            RealizePaletteWidget( (AXWidget)mw->colorpal );

        if ( (mw->ge_xruler && !mw->ge_xruler->winid) &&
             (mw->ge_yruler && !mw->ge_yruler->winid) )
            {
            RealizeGExruler(mw->ge_xruler);
            RealizeGEyruler(mw->ge_yruler);
            }

        if ( mw->butonBar && !mw->butonBar->winid )
            {
            RealizeButtonBar(mw->butonBar, mw->vScrollBar->xpos,
                    (mw->vScrollBar->ypos - mw->butonBar->height));
            }

        if ( mw->workWindow && !mw->workWindow->winid )
            RealizeAppWindow(mw, Wp->ap_id);

        if ( MS_IsIconic(hWnd) && mw->display )
            /* draw set-aside icon (NT only). */
            PaintWindowsIcon(ps.hdc, mw->style);

        MS_EndPaint(hWnd, &ps);
        break;
        }

    case WM_ERASEBKGND:
        if ( MS_IsIconic(hWnd) )
            retval = TRUE;
        else
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;

    case WM_QUERYDRAGICON:
        hicon = GetIconHandleFromId(mw->style, TRUE);
        retval = (LRESULT)hicon;
        break;

    case WM_VSCROLL:
    case WM_HSCROLL:
        sub_command = LOWORD(wParam);
        if ( sub_command == SB_THUMBTRACK )
           {
           /* user is draging the thumb, turn off the defer of painting */
           /* wne the mouse button is down we put in to handle full drag */
           IgnoreButtonState = TRUE;
           }
        else if ( sub_command == SB_ENDSCROLL )
           {
           /* turn paint suppression back on now that scrolling is over */
           IgnoreButtonState = FALSE;
           }

        moving_vertical = (message == WM_VSCROLL);
        is_ge = AxIsGraphicsTask(mw->taskOwner);
        if ( sub_command == SB_THUMBPOSITION )
            sub_command = LOWORD(wParam);  /* handy place to stop debugger */
        if ( sub_command == SB_THUMBTRACK && is_ge )
            /* GE does not activly track the scroll bar */
            break;
        ScrollBarHasBeenMoved(mw, winP->window_id, wParam, lParam,
                                                moving_vertical);
        break;


#if 0    /* { */
    case WM_HSCROLL:
        sub_command = LOWORD(wParam);
        if ( (sub_command != SB_THUMBTRACK) && 
             (sub_command != SB_THUMBPOSITION))
            break;
        is_ge =  AxIsGraphicsTask(mw->taskOwner);
        if ( LOWORD(wParam) == SB_THUMBTRACK && is_ge )
            break;
        ScrollBarHasBeenMoved(mw, winP->window_id, wParam, FALSE);
        break;
#endif    /* } #if 0 */

    case AX_EXECINSTANCE:
        /* message from another applixware which is starting, collect */
        /* the command line it will pass us and do the request        */
        CollectMessage( wParam, lParam );
        break;

    case WM_RENDERFORMAT:
        /* user has pasted, time to render data onto the clipboard. */
        /* see below in WorkClassProc.  We should only be here (MainClass)
         * if the app that owns the clipboard is "windowless". In normal apps,
         * the work window registers with the clipboard, but windowless apps
         * don't create a work window (see WXShowWindow) so we arrive here
         * instead.     -donato
         */
        DoTaskXfer(winP, (UINT)wParam, (AXWidget)mw);
        break;

    case WM_DESTROYCLIPBOARD:
        {
        XEvent xevent;
        xevent.type = SelectionClear;
        xevent.xselectionclear.window = mw->window;
        xevent.xselectionclear.selection = XA_CLIPBOARD;
        if ( Ax_Clear_Selection )
            {
            /* only clear the selection if the app is exiting. *
             * as opposed to when clipboard changes ownership. */
            AxSelectionEvent(&xevent);
            XDeleteProperty(Dpy, xevent.xselectionclear.window,
                            xevent.xselectionclear.selection);
            }
        break;
        }

    default:
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }
    return (retval);
}



LRESULT CALLBACK
WorkClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    AXWidget w;
    XEvent xevent;
    LRESULT retval;


    /* Find the work window associated with the event */
    w = (AXWidget) GetWidgetFromHWND(hWnd, W_WORK);
    if ( !w )
        {
        /* have no idea about this window yet */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return retval;
        }

    if ( message == WM_LBUTTONDOWN )
        MS_SetFocus(w->winid);
#if 0
    /* for now, GE does not support full drag active paints,
     * so we do the button down hack here.   -donato
     */
    if ( Wp && (Wp->ap_id == APGE) && (message == WM_PAINT) )
        {
        state = MS_GetAsyncKeyState(VK_LBUTTON) |
                    MS_GetAsyncKeyState(VK_RBUTTON);
        if ( state & 0x80000000 )
            return retval;
        }
#endif
    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd, message, wParam, lParam, &xevent, w);
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }

    SetWpFromX11Window(w->window);

/** do we need to do this? (it's done above in MainClassProc).  -donato **/
#if 0
    winP = SetWpFromX11Window(w->window);
    if ( winP == NULL )
        winP = Wp;        /* use the old global */
#endif

    if ( !Wp )
        {
        /* window does not match anything we know about */
        /* at least not yet                             */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    if ( bEvent )
        {
        if ( xevent.type == SelectionClear )
            {
            /* WM_DESTROYCLIPBOARD message */
            if ( Ax_Clear_Selection )
                {
                /* only clear the selection if the app is exiting. *
                 * as opposed to when clipboard changes ownership. */
                AxSelectionEvent(&xevent);
                XDeleteProperty(Dpy, xevent.xselectionclear.window,
                                xevent.xselectionclear.selection);
                }
            return 0;
            }
        else
            DoAppEvent(&xevent);
        }

    retval = 0;
    switch (message)
        {
    case WM_SETCURSOR:
        {
        HCURSOR hcursor;
#if 0
        /* make sure help cursor is set when necessary. */
        if ( THIMhelpMode )
            {
            MS_SetCursor(pw->help_cursor);
            retval = TRUE;
            }
        else
#endif
        retval = AXSetActiveCursor(w);
        if ( !retval )
            {
            hcursor = (HCURSOR)MS_GetWindowLong(hWnd, GWL_USERDATA);
            MS_SetCursor(hcursor);
            retval = TRUE;
            }
            //retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }

    case WM_ERASEBKGND:
        {
        RECT rect;
        char class_name[256];
        int num_bytes = MS_GetClassName(hWnd, class_name, 255);
        class_name[num_bytes] = 0;
        if ( strstr(class_name, NXLT("AxHtmlClass")) )
            {
            /* If this is an HTML Author window we paint the background
             * ourselves. The reason is because the user can set the background
             * to any color at any time, which we implement by creating a brush
             * based on an Applix color palette index and setting the bkgnd
             * attribute on the unique html window class (see RealizeAppWindow)
             * Once the brush is set on the class, Windows will use it to paint
             * backgrounds. The problem is that the brush is based on our color
             * palette which Windows doesn't know about. So to ensure that the
             * correct color is used, we do the painting here.   -donato
             */
            DWORD class_brush;
            HPALETTE old_palette = SelectAndRealizeAxWinPalette((HDC)wParam);
            class_brush = MS_GetClassLong(hWnd, GCL_HBRBACKGROUND);
            MS_GetClientRect(hWnd, &rect);
            MS_FillRect((HDC)wParam, &rect, (HBRUSH)class_brush);
            retval = 1;    /* tell Windows we did the work. */
            UnSelectPalette((HDC)wParam, old_palette);
            }
        else
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }

    case WM_PAINT:
        {
        PAINTSTRUCT ps;
        /* just to validate the exposed area, which lets Windows
         * paint the class background.
         */
        MS_BeginPaint(hWnd, &ps);
        //if ( Wp->ap_id == APSS ) // || Wp->ap_id == 0 )
        //    DoAppEvent(&xevent);
        MS_EndPaint(hWnd, &ps);
        break;
        }

    case WM_COMMAND:
        w = WIDGET_FROM_UID( LOWORD(wParam) );
        if ( w->winid && !w->disabled )
            {
            if ( w->callback )
                (*w->callback) (w, w->callbacktag);
            else
                WorkWidgetCallback(wParam);
            }
        break;


    case WM_LBUTTONDOWN:
        if ( THIMhelpMode )
            {
            RingTheBell();
            ElfbSetHelpMode(FALSE);
            }
        break;


    case WM_RBUTTONDOWN:
        RightButtonEvent((AXWidget_popup)w, OPTION_NEW, &xevent);
        break;

    case WM_RBUTTONUP:
        {
        int xpos, ypos;
        HWND parent_hwnd;
        if ( RightButtonArmed )
            {
            /* save the parent winid because RightButtonEvent() *
             * will make RightButtonArmed NULL.                 */
            parent_hwnd = RightButtonArmed->parent->winid;
            RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                        OPTION_DONE, &xevent);
            /* we need to make sure the parent (i.e. the GE) gets  *
             * a button-up notification, otherwise GE mouse states *
             * won't get set properly.           -donato           */
            xpos = xevent.xbutton.x;
            ypos = xevent.xbutton.y;
            MS_SendMessage(parent_hwnd, WM_RBUTTONUP,
                            (WPARAM)xevent.xbutton.state,
                            MAKELPARAM(xpos, ypos));
            }
        }
        break;   


    case WM_DRAWITEM:
        retval = DoOwnerdrawEvent(wParam, lParam);
        break;

    case WM_MEASUREITEM:
        {
        LPMEASUREITEMSTRUCT lpms;
        AXWidget_list w_list = (AXWidget_list)WIDGET_FROM_UID(wParam);
        if ( w_list->type == W_LIST )
            {
            /* fill out measure-item struct for the listbox. */
            lpms = (LPMEASUREITEMSTRUCT)lParam;
            lpms->itemHeight = xmListBoxLineHeight( w_list );
            lpms->itemData = 0;
            retval = TRUE;
            }
        break;
        }
#if 0
    case AX_WM_SETWINDOWBACKGROUND:
        {
        data_ptr aP;
        wcolor_t color;

        color.any.type  = WCSPACE_WORK;
        color.any.flags = 0;
        aP = AxCreateWColorData(w, &color);
        if ( w->widgetColor )
            AxFreeWColor(w->widgetColor);
        w->widgetColor = AxCreateWColor(w, aP);
        if ( w->widgetColor )
            w->widgetColor->any.pixel = lParam;
        break;
       }

    case AX_WM_PAINTBACKGROUND:
        {
        RECT rect;
        HBRUSH hbrush;

        rect.left = LOWORD(wParam);
        rect.top = HIWORD(wParam);
        rect.right = LOWORD(lParam);
        rect.bottom = HIWORD(lParam);
        if ( w->widgetColor )
            {
            hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(
                                    w->widgetColor->any.pixel));
            }
        else
            hbrush = MS_CreateSolidBrush(BackWorkPixelRGB);
        MS_FillRect(w->window, &rect, hbrush);
        MS_DeleteObject(hbrush);
        break;
        }
#endif

    case WM_RENDERFORMAT:
        /* user has pasted, time to render data onto the clipboard. */
        /* we are here because an app called MS_GetClipboardData.   *
         * we must set the clipboard data NOW so the requestor can     *
         * receive the memory handle.  This means we can't go sending  *
         * messages to applix tasks. We must call the appropriate task *
         * xfer function to set the data.               -donato        */
        DoTaskXfer(Wp, (UINT)wParam, w);
        break;
/*  case WM_RENDERALLFORMATS:
        normally, this is where an app would render any un-rendered
        data to the clipboard on exit. in Applixware, however, each
        app will take care of exiting the clipboard properly.
        (AxMoveClipboardToExitClipboard).
        however, we do need to process this when applixware terminates.
        should be done in UnMappedClassProc, but we don't seem to
        be getting the messages there. why?!     -donato
*/

    default:
		/* only do the default if we didn't handle the event */
		if ( !bEvent )
        	retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }

    return retval;
}


LRESULT CALLBACK
MEDebuggerClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    XEvent xevent;
    LRESULT retval;
    AXWidget w_debug;
    PAINTSTRUCT ps;
    static HBRUSH hbrush = NULL;


    w_debug = (AXWidget)GetWidgetFromHWND(hWnd, W_DEBUG);
    if ( !w_debug )
        {
        /* have no idea about this window yet */
        return MS_DefWindowProc(hWnd, message, wParam, lParam);
        }

    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message,wParam,lParam,&xevent,(AXWidget)NULL);

    retval = 0;
    switch (message)
        {
    case WM_SETCURSOR:
        {
        /* make sure help cursor is set when necessary. */
        if ( THIMhelpMode )
            {
            MS_SetCursor(w_debug->help_cursor);
            retval = TRUE;
            }
        else
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }

    case WM_CTLCOLORBTN:
        if ( !hbrush )
            hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(BackPixel));

        MS_SetBkColor((HDC)wParam, GET_COLOR_VALUE(BackPixel));
        MS_SetTextColor((HDC)wParam, GET_COLOR_VALUE(ForePixel));

        retval = (DWORD)hbrush;
        break;

    case WM_PAINT:
        {
        Window save_handle;
        MS_BeginPaint(hWnd, &ps);

        save_handle = w_debug->window;
        /* use clipping DC that Windows gives us */
        w_debug->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);

        (*w_debug->painter)(w_debug, &xevent.xexpose, NULL, NULL);

        REMOVE_DRAWABLE(w_debug->window);
        w_debug->window = save_handle;
        MS_EndPaint(hWnd, &ps);
        break;
        }

    case WM_COMMAND:
        {
        AXWidget w;
        w = WIDGET_FROM_UID( LOWORD(wParam) );
        if ( w->winid && !w->disabled )
            {
            if ( WorkWidgetCallback(wParam) )
            	/* give focus to application work space. */
            	MS_SetFocus(w_debug->parent->workWindow->winid);
            }
        break;
        }

    case WM_LBUTTONDOWN:
        if ( THIMhelpMode )
            {
            RingTheBell();
            ElfbSetHelpMode(FALSE);
            }
        break;

    case WM_DRAWITEM:
        retval = DoOwnerdrawEvent(wParam, lParam);
        break;

    case WM_MEASUREITEM:
        {
        LPMEASUREITEMSTRUCT lpms;
        AXWidget_list w_list = (AXWidget_list)WIDGET_FROM_UID(wParam);
        if ( w_list->type == W_LIST )
            {
            /* fill out measure-item struct for the listbox. */
            lpms = (LPMEASUREITEMSTRUCT)lParam;
            lpms->itemHeight = xmListBoxLineHeight( w_list );
            lpms->itemData = 0;
            retval = TRUE;
            }
        break;
        }

    case WM_DESTROY:
        if ( hbrush )
            {
            MS_DeleteObject(hbrush);
            hbrush = NULL;
            }
        break;

    default:
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }

    return retval;
}


/**** class proc for WP ruler, and GE x & y rulers ****/
LRESULT CALLBACK
RulerClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int newValue;
    BOOL bEvent;
    AXWidget bw, rw, w;
    XEvent xevent;
    XmAnyCallbackStruct data;
    XmRowColumnCallbackStruct rcData;
    LRESULT retval;
    PAINTSTRUCT ps;
    struct wind_struct *winP;


    /* Find the ruler associated with the event */
    rw = (AXWidget) GetWidgetFromHWND(hWnd, W_RULER);
    if ( !rw )
        {
        /* could be a GE ruler */
        if ( !(rw = (AXWidget)GetWidgetFromHWND(hWnd, W_GE_XRULER)) )
            rw = (AXWidget)GetWidgetFromHWND(hWnd, W_GE_YRULER);

        if ( rw )
            {
            /* for GE rulers, all we care about are the *
             * WM_PAINT and WM_DESTROY messages.        */
            retval = DoGErulerEvent((AXWidget_ge_ruler)rw, message);
            if ( retval == -1 )
                /* an event we don't care about. */
                retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            }
        else
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);

        return (retval);
        }

    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd, message, wParam, lParam, &xevent, rw);
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }

    SetWpFromX11Window(rw->window);
    winP = Wp;

    retval = 0;
    switch (message)
        {
        case WM_SETCURSOR:
            {
            /* make sure help cursor is set when necessary. */
            if ( THIMhelpMode )
                {
                MS_SetCursor(rw->help_cursor);
                retval = TRUE;
                }
            else
                retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
            }


        case WM_DRAWITEM:
            DrawButtonEvent(wParam, lParam);
            retval = TRUE;
            break;


        case WM_COMMAND:
            /* if here, either an option menu or 1 of the first 4 buttons *
             * on the ruler (indent, section, table, frame) was pressed.  *
             * (the tab buttons are not real buttons so do not get        *
             * handled here. see below). -donato                          */
            w = WIDGET_FROM_UID( LOWORD(wParam) );
            if ( !w )
                break;

            if ( w->type == W_OPTION )
                {
                if ( HIWORD(wParam) == CBN_SELCHANGE )
                    {
                    /* get option menu selection */
                    newValue = MS_SendMessage(w->winid,CB_GETCURSEL,0,0L);
                    if ( newValue == LB_ERR )
                        break;
                    rcData.data = (char*) w->value = (char*)newValue;
                    AxCallback(w->callback, w, w->callbacktag,
                                            (caddr_t)&rcData);
                    }
                else if ( THIMhelpMode && (HIWORD(wParam) == CBN_SETFOCUS) )
                    {
                    AxPostHelp(w);
                    }
                else break;
                }
            else if ( THIMhelpMode )
                {
                AxPostHelp(w);
                break;
                }
            else    /* must be a button */
                AxCallback(w->callback, w,w->callbacktag, (caddr_t)&data);

            /* set focus back to the app space. otherwise *
             * focus would stay on the ruler widget.      */
            MS_SetFocus(rw->parent->workWindow->winid);
            break;


        case WM_LBUTTONDOWN:
            /* since tab buttons on the ruler are not "real" buttons, *
             * i.e. they were not created with the MS_CreateWindow    *
             * call, a WM_COMMAND message is not received when one is *
             * pressed. so handle them here on the button down event. */
            bw = (AXWidget)FindGadget(hWnd, xevent.xbutton.x,xevent.xbutton.y);
            if ( bw )
                {
                if ( winP->ap_id == APDC )
                    {
                    /* WORDS */
                    if ( bw->type == W_BUTTON )
                        {
                        data.reason = EV_CHANGED_;
                        data.event = &xevent;
                        AxCallback(bw->callback, bw, (caddr_t)bw->callbacktag,
                                                            (caddr_t)&data);
                        }
                    }
                else
                    {
                    /* Equation Editor: could be a rowcol widget */
                    if ( bw->type == W_ROWCOL )
                        {
                        PaintRowColumnPulldown((AXWidget_rowcol)bw, 
                                              OPTION_NEW, &xevent);
                        }
                    }
                }
            else
                {
                /* user clicked on empty ruler space; make sure we give focus
                 * to the application work space.
                 */
                MS_SetFocus(rw->parent->workWindow->winid);
                }
        /* we FALL THRU on purpose. */

        case WM_LBUTTONUP:
        case WM_MOUSEMOVE:
            /* send event to WP, which will decide if it's for the ruler. */
            AxSendMes(rw->taskOwner, (mbchar*)&xevent, sizeof(xevent),
                                                            APXSERVER);
            break;


        case WM_PAINT:
            if ( IgnorePaintMessages() )
                /* do not draw yet until drag stops to deal with "full drag" */
                break;

            MS_BeginPaint(hWnd, &ps);
#if 0
            /* save for later? */
            DoTaskExpose(&xevent, winP);
#else
            /* send event to WP, which will decide if it's for the ruler. */
            AxSendMes(rw->taskOwner, (mbchar*) &xevent, sizeof(xevent),
                                                            APXSERVER);
#endif
            MS_EndPaint(hWnd, &ps);
            break;


        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }
    return (retval);
}


LRESULT CALLBACK
RibbonClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int newValue;
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget_ribbon w_ribbon;
    XEvent xevent;
    XmRowColumnCallbackStruct rcData;
    LRESULT retval;


    /* Find the ribbon associated with the event */
    w_ribbon = (AXWidget_ribbon) GetWidgetFromHWND(hWnd, W_RIBBON);
    if (!w_ribbon)
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd, message, wParam, lParam, &xevent, NULL/*w_ribbon*/);
#if 0
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }
#endif

    retval = 0;
    switch (message)
        {
    case WM_LBUTTONDOWN:
        TimeOfButtonPress = xevent.xbutton.time;
        ArmRibbon(w_ribbon, &xevent);
        AxSendMes(Wp->p_id, (mbchar*)&xevent, sizeof(xevent), APELFM);
        break;


    case WM_LBUTTONUP:
        TimeOfButtonRelease = xevent.xbutton.time;
        if (RibbonArmed)
            ArmRibbon(RibbonArmed, &xevent);
        break;


    case WM_PAINT:
        {
        HANDLE save_handle;
        MS_BeginPaint(hWnd, &ps);

        save_handle = w_ribbon->window;
        /* use clipping DC */
        w_ribbon->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);

        PaintRibbon(w_ribbon, 0, 0, FALSE);

        REMOVE_DRAWABLE(w_ribbon->window);
        w_ribbon->window = save_handle;
        MS_EndPaint(hWnd, &ps);
        break;
        }


    case WM_COMMAND:
        {
        /* option menu was picked */
        AXWidget_option w;

        w = (AXWidget_option)WIDGET_FROM_UID( LOWORD(wParam) );
        if ( !w )
            break;

        if ( THIMhelpMode && (HIWORD(wParam) == CBN_SETFOCUS) )
            AxPostHelp((AXWidget)w);
        else
            {
            /* get option menu selection */
            newValue = MS_SendMessage(w->winid, CB_GETCURSEL, 0, 0L);
            if ( w->value == newValue )
                break;
            if ( newValue == LB_ERR )
                break;

            rcData.data = (char*)w->value = (char*)newValue;
            AxCallback(w->callback, (AXWidget)w, w->callbacktag,
                                            (caddr_t)&rcData);
            break;
            }
        }


    default:
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }
    return (retval);
}



LRESULT CALLBACK
PaletteClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget pw, w;
    XEvent xevent;
    XmAnyCallbackStruct data;
    LRESULT retval;


    /* Find the palette associated with the event */
    pw = (AXWidget) GetWidgetFromHWND(hWnd, W_PALETTE);
    if ( !pw )
        {
        /* could be a colorpal */
        pw = (AXWidget) GetWidgetFromHWND(hWnd, W_COLORPAL);
        }

    if ( !pw )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }

    retval = 0;
    switch (message)
        {
    case WM_SETCURSOR:
        /* make sure help cursor is set when necessary. */
        if ( THIMhelpMode )
            {
            MS_SetCursor(pw->help_cursor);
            retval = TRUE;
            }
        else
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;


    case WM_MOUSEACTIVATE:
        /* if a rowcol or popup widget is active while the *
         * user has activated another window, we must make *
         * sure the widget is destroyed.                   */
        if ( RowColumnArmed )
            {
            PaintRowColumnPulldown(RowColumnArmed, OPTION_DONE, &xevent);
            RowColumnArmed = NULL;
            }
        if ( PopupArmed )
            {
            PaintPopupPulldown(PopupArmed, OPTION_DONE, &xevent);
            PopupArmed = NULL;
            }
        /* we don't want the palette to be "activated". *
         * Focus should stay on the work space.         */
        if ( pw->parent->winid == MS_GetFocus() )
            retval = MA_NOACTIVATE;
        else
            retval = MA_ACTIVATE;
        break;


    case WM_LBUTTONDOWN:
        w = (AXWidget)FindGadget(hWnd, xevent.xbutton.x, xevent.xbutton.y);
        if ( w )
            {
            if ( THIMhelpMode )
                AxPostHelp(w);
            else
                {
                if ( w->type == W_ROWCOL )
                    {
                    PaintRowColumnPulldown((AXWidget_rowcol)w, 
                                           OPTION_NEW, &xevent);
                    }
                else if ( w->type == W_BUTTON && w->style == W_POPUP )
                    {
                    data.reason = 0;
                    data.event = &xevent;
                    AxCallback(w->callback, w, w->callbacktag, (caddr_t)&data);
                    }
                }
            }
        break;


    case WM_COMMAND:
        w = WIDGET_FROM_UID( LOWORD(wParam) );

        if ( w && w->winid && !w->disabled && w->type == W_LIST )
            PaletteWidgetCallback(wParam);
        else if ( THIMhelpMode )
            AxPostHelp(w);
        else if ( w && w->winid && !w->disabled )
            (*w->callback) (w, w->callbacktag);

        /* set focus to GE work window, unless user has clicked in the *
         * GE palette listbox, in which case focus should stay there.  */
        if ( pw->type == W_PALETTE && w->type != W_LIST )
            MS_SetFocus(pw->parent->workWindow->winid);
        break;

#if 0
    case AX_WM_PAINT_PALETTE:
        /* user defined message. first set up the * 
         * expose event, then paint the palette.  */
        x_exposeP = (XExposeEvent *) calloc(1, sizeof(XExposeEvent));
        memset(x_exposeP, 0, sizeof(XExposeEvent));
        x_exposeP->type = Expose;
        x_exposeP->width = LOWORD(lParam);
        x_exposeP->height = HIWORD(lParam);
        x_exposeP->window = pw->window;

        (*pw->painter) (pw, x_exposeP, TRUE, FALSE);
        free(x_exposeP);
        break;
#endif

    case WM_PAINT:
        {
        HDC save_handle;
#if 0
        if ( pw->initial_paint )
            {
            /* we are here on the palette's initial creation, which    *
             * means the GE hasn't yet set appropriate values and      *
             * widgets. therefore, we must post a message to windows   *
             * so that it can paint the palette after those values     *
             * have been set.  the message is posted with the width    *
             * and height of the exposed area as the long param, since *
             * this will always be the area of the entire palette      *
             * initially. the message that is posted is a user defined *
             * ("custom") message called AX_WM_PAINT_PALETTE, and the  *
             * expose event structure is filled when that message is   *
             * received.                    -donato                    */
            expose_area = MAKELONG(xevent.xexpose.width,
                                    xevent.xexpose.height);
            MS_PostMessage(pw->winid, AX_WM_PAINT_PALETTE, (WPARAM)0,
                                                (LPARAM)expose_area);

            pw->initial_paint = FALSE;
            break;
            }
#endif
        MS_BeginPaint(hWnd, &ps);
        save_handle = pw->window;
        pw->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);/* use clipping DC */

        /* only repaint if no popups are visible */
        if ( !RowColumnArmed && !PopupArmed )
            {
            if (pw->type == W_PALETTE)
                {
                PaintGEPalette((AXWidget_palette)pw, (XExposeEvent*)&xevent,
                                                            TRUE, FALSE);
                }
            else if (pw->type == W_COLORPAL)
                PaintColorpal((AXWidget_colorpal)pw, 0, 0, FALSE);
            }
        REMOVE_DRAWABLE(pw->window);
        pw->window = save_handle;
        MS_EndPaint(hWnd, &ps);
        break;
        }


    case WM_DRAWITEM:
        retval = DoOwnerdrawEvent(wParam, lParam);
        break;


    default:
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        break;
        }

    return (retval);
}


LRESULT CALLBACK
PlatesClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    AXWidget pw, w;
    LRESULT retval;
    BOOL bEvent;
    XEvent xevent;
    PAINTSTRUCT ps;
    XmAnyCallbackStruct data;


    /* Find the plates associated with the event */
    pw = (AXWidget) GetWidgetFromHWND(hWnd, W_PLATES);
    if ( !pw )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent, 0, sizeof(XEvent));
    bEvent = WinToXEvent(hWnd, message, wParam, lParam, &xevent, pw);
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }

    retval = 0;
    switch (message)
        {
        case WM_COMMAND:
            w = WIDGET_FROM_UID( LOWORD(wParam) );
            if ( THIMhelpMode )
                AxPostHelp(w);
            else
                {
                if ( w && !w->disabled )
                    AxCallback(w->callback, w, w->callbacktag, (caddr_t)&data);
                }
            /* set focus back to the app space. otherwise *
             * focus would stay on the plates widget.    */
            if ( pw->parent->workWindow )
                MS_SetFocus(pw->parent->workWindow->winid);
            break;


        case WM_PAINT:
            if ( IgnorePaintMessages() )
                /* do not draw yet until drag stops to deal with "full drag" */
                break;

            MS_BeginPaint(hWnd, &ps);
            /* send event to SS, which will decide if it's for the plates. */
            /* we will get an expose that covers the ownerdraw buttons on  *
             * the plates widget, but the 'folder' buttons are non-Windows *
             * buttons, so they won't create an expose. Therefore, add a   *
             * fudge to the exposed area height to account for all buttons */
            xevent.xexpose.height += 2;
            //SSXEvent(&xevent, NULL);
            AxSendMes(pw->taskOwner, (mbchar*)&xevent, sizeof(xevent),
                                                            APXSERVER);
            MS_EndPaint(hWnd, &ps);
            break;


        case WM_DRAWITEM:
            DrawButtonEvent(wParam, lParam);
            retval = TRUE;
            break;


        case WM_LBUTTONDOWN:
        case WM_LBUTTONDBLCLK:
            w = (AXWidget)FindGadget(hWnd, xevent.xbutton.x, xevent.xbutton.y);

            if ( w && w->type == W_BUTTON )
                {
                if ( !w->value )
                    {
                    w->value = !w->value;
                    PaintButton((AXWidget_pushbutton)w, 0, 0, TRUE);
                    }
                }

            if ( w )
                {
                data.reason = EV_CHANGED_;
                data.event = &xevent;
                //AxCallback(w->callback, w, (caddr_t)w->taskOwner,
                //                                (caddr_t)&data);
                AxCallback(w->callback, w, (caddr_t)w->callbacktag,
                                                (caddr_t)&data);
                }
            break;


        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }

    return (retval);
}


LRESULT CALLBACK
PopupClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    XEvent xevent;
    LRESULT retval;


    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);
#if 0
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }
#endif

    retval = 0;
    switch (message)
        {
        case WM_MOUSEMOVE:
            if ( RowColumnArmed && wParam == MK_LBUTTON )
                PaintRowColumnPulldown(RowColumnArmed, OPTION_MOVE, &xevent);
            else if ( PopupArmed && wParam == MK_LBUTTON )
                PaintPopupPulldown(PopupArmed, OPTION_MOVE, &xevent);
            else if ( RightButtonArmed && wParam == MK_RBUTTON )
                {
                RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                            OPTION_MOVE, &xevent);
                }
            break;


        case WM_LBUTTONUP:
            if ( RowColumnArmed )
                {
                PaintRowColumnPulldown(RowColumnArmed, OPTION_DONE, &xevent);
                RowColumnArmed = NULL;
                }
            else if ( PopupArmed )
                {
                PaintPopupPulldown(PopupArmed, OPTION_DONE, &xevent);
                PopupArmed = NULL;
                }
            break;


        case WM_RBUTTONUP:
            {
            int xpos, ypos;
            HWND parent_hwnd;

            if ( RightButtonArmed )
                {
                /* save the parent winid because RightButtonEvent() *
                 * will make RightButtonArmed NULL.                 */
                parent_hwnd = RightButtonArmed->parent->winid;
                RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                            OPTION_DONE, &xevent);
                /* we need to make sure the parent (i.e. the GE) gets  *
                 * a button-up notification, otherwise GE mouse states *
                 * won't get set properly.           -donato           */
                xpos = xevent.xbutton.x;
                ypos = xevent.xbutton.y;
                MS_SendMessage(parent_hwnd, WM_RBUTTONUP,
                                (WPARAM)xevent.xbutton.state,
                                MAKELPARAM(xpos, ypos));
                }
            break;
            }


        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }
    return (retval);
}



LRESULT CALLBACK
TableClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget_main mw;
    AXWidget_table w_table;
    XEvent xevent;
    LRESULT retval;
    int event_consumed = FALSE;


    /* Find the table associated with the event */
    w_table = (AXWidget_table)GetWidgetFromHWND(hWnd, W_TABLE);
    if ( !w_table )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return retval;
        }

    memset(&xevent, 0, sizeof(XEvent));
	/* need to check for Euro key outside of WinToXEvent because it
	 * (WinToXEvent) ignores most Ctrl-key sequences.
	 */
	if ( axmsIsEuroKeyEvent(hWnd, message, wParam, &xevent) )
		bEvent = TRUE;
	else
   		bEvent = WinToXEvent(hWnd, message, wParam, lParam, &xevent, NULL);
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }

    if ( (xevent.xany.type == KeyPress) &&
            (xevent.xkey.keycode & KEY_TYPE_MASK) &&
            FUNCTION_KEY(xevent.xkey.keycode & ~KEY_TYPE_MASK) ||
            message == WM_RBUTTONDOWN )
        {
        /* don't let the table widget process function keys
         * or the right mouse button.
         */
        event_consumed = FALSE;
        }
    else if ( bEvent )
        event_consumed = TableEvent(w_table, &xevent);

    if ( (xevent.xany.type == KeyPress) && !event_consumed )
        {
        /* if the table widget did not process the key event or a function *
         * key was pressed, let the parent do the processing.  we are      *
         * assuming that all table widgets are children of dialog boxes.   */
        mw = w_table->parent->parent;
        DialogKeyEvent(mw, mw->winid, message, wParam, lParam);
        }

    retval = 0;
    switch (message)
        {
        case WM_SETCURSOR:
            {
            HCURSOR hcursor;
            retval = AXSetActiveCursor((AXWidget)w_table);
            if ( !retval )
                {
                /* cursor needs to be changed, so get the cursor handle
                 * which is associated with this window.
                 */
                if ( w_table->curr_cursor )
                    hcursor = w_table->curr_cursor;
                else
                    hcursor = (HCURSOR)MS_GetWindowLong(hWnd, GWL_USERDATA);
                MS_SetCursor(hcursor);
                retval = TRUE;
                }
            break;
            }

        case WM_PAINT:
            {
            HDC save_handle;
            MS_BeginPaint(hWnd, &ps);
            save_handle = w_table->window;
            /* use clipping DC */
            w_table->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);

            (*w_table->painter)(w_table, &xevent.xexpose, TRUE, TRUE);

            REMOVE_DRAWABLE(w_table->window);
            w_table->window = save_handle;
            MS_EndPaint(hWnd, &ps);
            break;
            }

        case WM_LBUTTONDOWN:
            /* make sure table widget has the focus */
			xmTakeKeyFocus((AXWidget)w_table, (XButtonEvent*)NULL, FALSE);
            MS_SetFocus(w_table->winid);
            if ( THIMhelpMode )
                {
                RingTheBell();
                ElfbSetHelpMode(FALSE);
                }
            break;

        case WM_RBUTTONDOWN:
            if ( w_table->rminfo )
                RightButtonEvent((AXWidget_popup)w_table,OPTION_NEW,&xevent);
            break;

        case WM_RBUTTONUP:
            if ( RightButtonArmed )
                {
                RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                            OPTION_DONE, &xevent);
                }
            break;

        case WM_DESTROY:
            /* We release the drawable (device context) here because
             * we may be in the process of exiting an application that
             * has a dialog with a canvas up.  In that case, the dialog
             * (and its children) is destroyed automatically which means
             * the table's drawable is invalid when we hit WXDestroyWidget.
             */
            AxWinDeleteWidgetDrawable((AXWidget)w_table);
            break;

        default:
           	retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }

    return retval;
}


LRESULT CALLBACK
TrayClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int event_consumed;
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget_tray w_tray;
    XEvent xevent;
    LRESULT retval;


    /* Find the tray associated with the event */
    w_tray = (AXWidget_tray)GetWidgetFromHWND(hWnd, W_TRAY);
    if ( !w_tray )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent, 0, sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);

    /* ignore simple mouse movement.  also, let the widget painter handle *
     * WM_PAINT messages, rather than sending an expose to the widget.    */
    if ( ((xevent.type == MotionNotify) && (xevent.xmotion.state == 0)) ||
                                                    xevent.type == Expose )
        event_consumed = FALSE;
    else if ( bEvent )
        event_consumed = TrayEvent(w_tray, &xevent);

    retval = 0;
    switch (message)
        {                  
        case WM_PAINT:
#if 1
            if ( IgnorePaintMessages( ) )
                {
                /* we are not going to process this message just yet */
                /* since a "drag" is in progress                     */
                break;
                }
            MS_BeginPaint(hWnd, &ps);

            if ( bEvent )
                (*w_tray->painter)(w_tray, &xevent, TRUE, TRUE);
            else
                (*w_tray->painter)(w_tray, (XEvent*)NULL, FALSE, TRUE);

            MS_EndPaint(hWnd, &ps);
#else
            MS_BeginPaint(hWnd, &ps);
            (*w_tray->painter)(w_tray, 0, 0, FALSE);
            MS_EndPaint(hWnd, &ps);
#endif
            break;
    
		case WM_CHAR:
			if ( !event_consumed && wParam == VK_RETURN )
				{
                MS_SendMessage(w_tray->parent->winid, WM_COMMAND,
                        		MAKEWPARAM(IDOK, 0), (LPARAM)hWnd);
				}
			else if ( !event_consumed && wParam == VK_ESCAPE )
				{
                MS_SendMessage(w_tray->parent->winid, WM_COMMAND,
                        		MAKEWPARAM(IDCANCEL, 0), (LPARAM)hWnd);
				}
			else
            	retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;

        case WM_LBUTTONDOWN:
            /* make sure tray widget has the focus */
			xmTakeKeyFocus((AXWidget)w_tray, (XButtonEvent*)NULL, FALSE);
            MS_SetFocus(w_tray->winid);
            break;

        case WM_RBUTTONDOWN:
            if ( w_tray->rminfo )
                RightButtonEvent((AXWidget_popup)w_tray,OPTION_NEW,&xevent);
            break;

        case WM_RBUTTONUP:
            if ( RightButtonArmed )
                {
                RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                            OPTION_DONE, &xevent);
                }
            break;

        case WM_DESTROY:
            /* We release the drawable (device context) here because
             * we may be in the process of exiting an application that
             * has a dialog with a tray up.  In that case, the dialog
             * (and its children) is destroyed automatically which means
             * the tray's drawable is invalid when we hit WXDestroyWidget.
             */
            AxWinDeleteWidgetDrawable((AXWidget)w_tray);
            break;

        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }

    return (retval);
}



LRESULT CALLBACK
CanvasClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int event_consumed;
    BOOL do_xevent;
    PAINTSTRUCT ps;
    AXWidget_canvas w_canvas;
    XEvent xevent;
    LRESULT retval;


    /* Find the canvas associated with the event */
    w_canvas = (AXWidget_canvas)GetWidgetFromHWND(hWnd, W_CANVAS);
    if ( !w_canvas )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }
#if 0
    /* the canvas widget does a lot of full paints, regardless of exposed
     * area, so we do the "delayed paint" under full drag.  -donato
     */
    if ( message == WM_PAINT )
        {
        state = MS_GetAsyncKeyState(VK_LBUTTON) |
                    MS_GetAsyncKeyState(VK_RBUTTON);
        if ( state & 0x80000000 )
            return retval;
        }
#endif
    memset(&xevent, 0, sizeof(XEvent));
    do_xevent = WinToXEvent(hWnd,message,wParam,lParam,&xevent,(AXWidget)NULL);
#if 0
    if ( do_xevent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }
#endif

    /* ignore simple mouse movement.  also, let the widget painter handle *
     * WM_PAINT messages, rather than sending an expose to the widget.    */
    if ( ((xevent.type == MotionNotify) && (xevent.xmotion.state == 0)) ||
                                                    xevent.type == Expose )
        event_consumed = FALSE;
    else if ( do_xevent )
        {
        if ( (xevent.type == KeyPress) &&
                (xevent.xkey.keycode & KEY_TYPE_MASK) &&
                FUNCTION_KEY(xevent.xkey.keycode & ~KEY_TYPE_MASK) )
            /* don't let the canvas widget process function keys. */
            event_consumed = FALSE;
        else
            {
            /* In many cases, the Windows version of an Xkey is the same 
             * as the X version. But there are a few cases (e.g. arrow keys)
             * where they are different, and in order to provide platform
             * independence on the canvas/Builder we map the Windows key
             * to a real X key.                   -donato
             */
            if ( (xevent.type == KeyPress) &&
                (xevent.xkey.keycode & KEY_TYPE_MASK) )
                {
                unsigned int xkey, win_key;
                win_key = xevent.xkey.keycode & ~KEY_TYPE_MASK;
                if ( NeedToUseXKey(win_key, &xkey) )
                    xevent.xkey.keycode = xkey;
                }
            if ( message != WM_RBUTTONDOWN && message != WM_RBUTTONUP )
                event_consumed = CanvasEvent(w_canvas, &xevent);
            }
        }

    if ( (xevent.type == KeyPress) && !event_consumed )
        {
        AXWidget_main mw;
        /* if the canvas widget did not process the key event or a function *
         * key was pressed, let the parent do the processing.  we are      *
         * assuming that all canvas widgets are children of dialog boxes.   */
        mw = w_canvas->parent->parent;
        DialogKeyEvent(mw, mw->winid, message, wParam, lParam);
        }

    retval = 0;
    switch (message)
        {                  
        case WM_PAINT:
            if ( IgnorePaintMessages( ) )
                {
                /* we are not going to process this message just yet */
                /* since a "drag" is in progress                     */
                break;
                }
            MS_BeginPaint(hWnd, &ps);

            if ( do_xevent )
                (*w_canvas->painter)(w_canvas, &xevent, TRUE, TRUE);
            else
                (*w_canvas->painter)(w_canvas, (XEvent*)NULL, FALSE, TRUE);

            MS_EndPaint(hWnd, &ps);
            break;

        case WM_LBUTTONDOWN:
            /* make sure canvas widget has the focus */
			xmTakeKeyFocus((AXWidget)w_canvas, (XButtonEvent*)NULL, FALSE);
            MS_SetFocus(w_canvas->winid);
            break;

        case WM_RBUTTONDOWN:
            if ( w_canvas->rminfo )
                RightButtonEvent((AXWidget_popup)w_canvas,OPTION_NEW,&xevent);
            break;

        case WM_RBUTTONUP:
            if ( RightButtonArmed )
                {
                RightButtonEvent((AXWidget_popup)RightButtonArmed,
                                            OPTION_DONE, &xevent);
                }
            break;

        case WM_DESTROY:
            /* We release the drawable (device context) here because
             * we may be in the process of exiting an application that
             * has a dialog with a canvas up.  In that case, the dialog
             * (and its children) is destroyed automatically which means
             * the canvas's drawable is invalid when we hit WXDestroyWidget.
             */
            AxWinDeleteWidgetDrawable((AXWidget)w_canvas);
            break;

        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }
    return retval;
}


LRESULT CALLBACK
ColorChooserClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget_color_chooser w_chooser;
    XEvent xevent;
    LRESULT retval;


    /* Find the chooser widget associated with the event */
    w_chooser = (AXWidget_color_chooser)GetWidgetFromHWND(hWnd, W_CHOOSE);
    if ( !w_chooser )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent, 0, sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);
#if 0
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }
#endif
    if ( bEvent )
        ColorChooserEvent(w_chooser, &xevent);

    retval = 0;
    switch (message)
        {                  
        case WM_PAINT:
            {
            HDC save_handle;
            MS_BeginPaint(hWnd, &ps);
            save_handle = w_chooser->parent->window;
            w_chooser->parent->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);

            (*w_chooser->painter)(w_chooser, 0, 0, FALSE);    

            REMOVE_DRAWABLE(w_chooser->parent->window);
            w_chooser->parent->window = save_handle;
            MS_EndPaint(hWnd, &ps);
            break;
            }

        case WM_LBUTTONDOWN:
            /* make sure color chooser widget has the focus */
			xmTakeKeyFocus((AXWidget)w_chooser, (XButtonEvent*)NULL, FALSE);
            MS_SetFocus(w_chooser->winid);
            break;

        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }

    return retval;
}


LRESULT CALLBACK
PageBarClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget_page w_page;
    XEvent xevent;
    LRESULT retval;


    /* Find the pagebar associated with the event */
    w_page = (AXWidget_page)GetWidgetFromHWND(hWnd, W_PAGEBAR);
    if ( !w_page )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent, 0, sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);
#if 0
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }
#endif

    retval = 0;
    switch (message)
        {
        case WM_PAINT:
            {
            Window save_handle;
            MS_BeginPaint(hWnd, &ps);
            save_handle = w_page->window;
            w_page->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);

            (*w_page->painter)(w_page, &xevent, TRUE, TRUE);

            REMOVE_DRAWABLE(w_page->window);
            w_page->window = save_handle;
            MS_EndPaint(hWnd, &ps);
            break;
            }

        case WM_LBUTTONUP:
        case WM_LBUTTONDOWN:
            ArmPageButton((AXWidget)w_page, &xevent);
            break;

        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }
    return (retval);
}


LRESULT CALLBACK
ButtonBarClassProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    PAINTSTRUCT ps;
    AXWidget_buttonbar w_buton;
    AXWidget w_child;
    XEvent xevent;
    LRESULT retval;
    XmAnyCallbackStruct data;


    /* Find the buttonbar associated with the event */
    w_buton = (AXWidget_buttonbar)GetWidgetFromHWND(hWnd, W_BUTBAR);
    if ( !w_buton )
        {
        /* no widget, return */
        retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
        return (retval);
        }

    memset(&xevent, 0, sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);
#if 0
    if ( bEvent == -2 )
       {
       /* special flag meaning that we doo not want to do anything with */
       /* this message.                                                 */
       return( FALSE );
       }
#endif

    retval = 0;
    switch (message)
        {
        case WM_PAINT:
            MS_BeginPaint(hWnd, &ps);
            /* We don't need to do any painting here because this widget *
             * is made up of ownerdraw buttons, which means they all get *
             * drawn during processing of WM_DRAWITEM.      -donato      */
            /* (*w_buton->painter)(w_buton, &xevent, TRUE, TRUE); */
            MS_EndPaint(hWnd, &ps);
            break;

        case WM_DRAWITEM:
            retval = DoOwnerdrawEvent(wParam, lParam);
            break;

        case WM_COMMAND:
            w_child = WIDGET_FROM_UID(LOWORD(wParam));
            if ( THIMhelpMode )
                AxPostHelp(w_child);
            else
                {
                if ( w_child && !w_child->disabled )
                    {
                    AxCallback(w_child->callback, w_child,
                                    w_child->callbacktag,
                                    (caddr_t)&data);
                    }
                }
            break;

#if 0
        case WM_LBUTTONUP:
        case WM_LBUTTONDOWN:
            w_page->window = MS_GetDC(hWnd);
            ArmPageButton(w_page, &xevent);
            MS_ReleaseDC(hWnd, w_page->window);
            w_page->window = NULL; 
            break;
#endif
        default:
            retval = MS_DefWindowProc(hWnd, message, wParam, lParam);
            break;
        }
    return (retval);
}



/*** caller must free what this returns! ***/
static char *
AxWinCreateUniqueHTMLClass(AXWidget w)
{
    int uid_len;
    char *class_name, uid_str[10];
    WNDCLASS wc;

/* This function creates a unique window class based on a unique widget id
 * (It is later unregistered at widget destroy time). The reason we do this
 * is because the HTML app allows the user to change the window background
 * color at any time, for any HTML window. Since Windows doesn't have the
 * concept of a unique background color for each window, we have been forced
 * to this method. XSetWindowBackground does a SetClassLong to modify the
 * background attribute on the class, and XClearArea retrieves that value
 * to do its painting.            -donato
 */

    w->uid = GetAvailableUID(w);
    sprintf(uid_str, "%d", w->uid);
    uid_len = strlen(uid_str);

    class_name = malloc(uid_len + 11 + 1);  /* 11 = len of AxHtmlClass */
    strcpy(class_name, NXLT("AxHtmlClass"));
    strcat(class_name, uid_str);

    memset(&wc, 0, sizeof(wc));
    wc.style = CS_DBLCLKS;
    wc.lpfnWndProc = (WNDPROC)WorkClassProc;
    wc.hInstance = hInst;
    wc.hbrBackground = NULL;    /* background will be set dynamically */
    wc.lpszClassName = class_name;
    /* all other fields are zero... */

    if ( !MS_RegisterClass(&wc) )
        return NULL;
    else
        return class_name;
}

/*********************************************************
function: RealizeAppWindow - create application window
*/
static void
RealizeAppWindow(AXWidget_main mw, int app_id)
{
    char *class_name;
    DWORD window_style = WS_VISIBLE | WS_CHILD;

    WIDGET_PARANOID(mw, W_MAIN);
	if ( !mw->workWindow->display )
		return;

    if ( mw->workWindow->winid )
        {
        MS_DestroyWindow(mw->workWindow->winid);
        REMOVE_DRAWABLE(mw->workWindow->window);
        }

    if ( mw->style == IC_HTML )
        /* see function above for explanation of this... */
        class_name = AxWinCreateUniqueHTMLClass((AXWidget)mw->workWindow);
    else
        class_name = STRALLOC(NXLT("WorkClass"));

    /* we use the CLIPCHILDREN window style so that if a work window has
     * children (like the rulers of the GE), any painting is clipped
     * to the work window itself, rather than its children.
     */  
    window_style |= WS_CLIPCHILDREN | WS_CLIPSIBLINGS;

    mw->workWindow->winid = MS_CreateWindow(class_name, mw->workWindow->name,
                                            window_style,
                                            mw->workWindow->xpos,
                                            mw->workWindow->ypos,
                                            mw->workWindow->width,
                                            mw->workWindow->height,
                                            mw->winid, (HMENU)NULL,
                                            (HANDLE)NULL, (LPVOID)NULL);
    free(class_name);

    if ( mw->workWindow->winid )
        {
        /* make sure work area stays under any other children that *
         * may be drawn over it (e.g. GE rulers).                  */
        MS_SetWindowPos(mw->workWindow->winid, HWND_BOTTOM, 0, 0, 0, 0,
                                            SWP_NOMOVE | SWP_NOSIZE);
        MS_SetFocus(mw->workWindow->winid);
        mw->workWindow->window = AxPackageHandle(mw->workWindow->winid,
                                                        AX_HWND_TYPE);
        /* set some attributes */
        MS_SetBkMode(mw->workWindow->window, TRANSPARENT);
        MS_SetTextAlign(mw->workWindow->window, TA_LEFT | TA_BASELINE);
        }
}

static void
AxWinCreateMEDebuggerWindow(AXWidget_debug w)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("MEDebuggerClass");

    WIDGET_PARANOID(w, W_DEBUG);
    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC) MEDebuggerClassProc;
        wndclass.hInstance = NULL;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    w->winid = MS_CreateWindow(class_name, w->name, WS_CHILD | WS_VISIBLE,
                                w->xpos, w->ypos, w->width, w->height,
                                w->parent->winid, (HMENU)NULL, (HANDLE)NULL,
                                (LPVOID)NULL);
    w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
}

/*********************************************************
function: RealizeRuler - create ruler
*/
void
RealizeRuler(AXWidget_main mw)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("RulerClass");

    WIDGET_PARANOID(mw, W_MAIN);
    if ( !mw->ruler->display || mw->ruler->height == 0 )
        return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC) RulerClassProc;
        wndclass.hInstance = NULL;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    if ( mw->ruler->winid )
        {
        MS_DestroyWindow(mw->ruler->winid);
        REMOVE_DRAWABLE(mw->ruler->window);
        }

    if ( !mw->ruler->display )
        /* no ruler to display, so abandon. */
        return;

    mw->ruler->winid = MS_CreateWindow(class_name, mw->ruler->name,
                               WS_VISIBLE | WS_CHILD,
                               mw->ruler->xpos, mw->ruler->ypos,
                               mw->ruler->width, mw->ruler->height,
                               mw->winid, (HMENU)NULL, (HANDLE)NULL,
                               (LPVOID)NULL);

    MS_SetWindowPos(mw->ruler->winid, HWND_BOTTOM, 0, 0, 0, 0,
                                    SWP_NOMOVE | SWP_NOSIZE);
    /* get DC for drawing */
    mw->ruler->window = AxPackageHandle(mw->ruler->winid, AX_HWND_TYPE);
    MS_SetClassLong(mw->ruler->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
}


/*********************************************************
function: RealizePlates - create plates window
*/
static void
RealizePlates(AXWidget_plates w)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("PlatesClass");

    WIDGET_PARANOID(w, W_PLATES);
    if ( !w->display || w->height == 0 )
        return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) CS_DBLCLKS;
        wndclass.lpfnWndProc = (WNDPROC)PlatesClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        /* always use user-defined 'Arrow' cursor */
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    if ( w->winid )
        {
        MS_DestroyWindow(w->winid);
        REMOVE_DRAWABLE(w->window);
        }

    w->winid = MS_CreateWindow(class_name, w->name,
                                WS_CHILD | WS_CLIPSIBLINGS,
                                w->xpos, w->ypos,
                                w->width, w->height,
                                w->parent->winid,
                                (HMENU)NULL, (HANDLE)NULL, (LPVOID)NULL);
    if ( w->winid )
        {
        /* get DC for drawing */
        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
        MS_ShowWindow(w->winid, SW_SHOW);
        MS_SetClassLong(w->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        }
}



/*********************************************************
function: RealizeGExruler - create GE x_ruler
*/
void
RealizeGExruler(AXWidget_ge_ruler w)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("RulerClass");

    WIDGET_PARANOID(w, W_GE_XRULER);
    if ( w->height == 0 || !w->display )
        return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC) RulerClassProc;
        wndclass.hInstance = NULL;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    if ( w->winid)
        {
        MS_DestroyWindow(w->winid);
        REMOVE_DRAWABLE(w->window);
        }

    w->winid = MS_CreateWindow(class_name, w->name,
                                WS_VISIBLE | WS_CHILD,
                                w->xpos, w->ypos,
                                w->width, w->height,
                                w->parent->winid,
                                (HMENU)NULL, (HANDLE)NULL, (LPVOID)NULL);
    if ( w->winid )
        {
        /* get DC for drawing */
        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
        /* make sure ruler is above work area. */
        MS_SetWindowPos(w->winid, HWND_TOP, 0,0, 0,0, SWP_NOMOVE | SWP_NOSIZE);
        MS_SetClassLong(w->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        }
}

/*********************************************************
function: RealizeGEyruler - create GE y_ruler
*/
void
RealizeGEyruler(AXWidget_ge_ruler w)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("RulerClass");

    WIDGET_PARANOID(w, W_GE_YRULER);
    if ( w->height == 0 || !w->display )
        return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC) RulerClassProc;
        wndclass.hInstance = NULL;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    if ( w->winid )
        {
        MS_DestroyWindow(w->winid);
        REMOVE_DRAWABLE(w->window);
        }

    w->winid = MS_CreateWindow(class_name, w->name,
                                WS_VISIBLE | WS_CHILD,
                                w->xpos, w->ypos,
                                w->width, w->height,
                                w->parent->winid,
                                (HMENU)NULL, (HANDLE)NULL, (LPVOID)NULL);
    if ( w->winid )
        {
        /* get DC for drawing */
        w->window = AxPackageHandle(w->winid, AX_HWND_TYPE);
        /* make sure ruler is above work area. */
        MS_SetWindowPos(w->winid, HWND_TOP, 0,0, 0,0, SWP_NOMOVE | SWP_NOSIZE);
        MS_SetClassLong(w->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        }
}

/*****************************************************************
function: RealizePaletteWidget - create GE palette or GE colorpal
*/
void
RealizePaletteWidget(AXWidget pal)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("PaletteClass");
    AXWidget childP;

    if ( pal->type != W_PALETTE && pal->type != W_COLORPAL )
        tempAbort("RealizePaletteWidget:  widget type mismatch.");
	if ( !pal->display )
		return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC) PaletteClassProc;
        wndclass.hInstance = NULL;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    if ( pal->winid )
        {
        /* destroy palette's listbox because it is a real window */
        for( childP = pal->widgets; childP; childP = childP->nextChild )
            {
            if ( childP->type == W_LIST )
                {
                /* listbox will need to be re-drawn */
                childP->managed = FALSE;
                if ( childP->winid )
                    {
                    AxDestroyWindow(Dpy, childP, childP->window);
                    childP->winid = NULL;
                    break;
                    }
                }
            }
        MS_DestroyWindow(pal->winid);
        REMOVE_DRAWABLE(pal->window);
        ClearPaletteButtonUids( (AXWidget_palette)pal );
        }

    if ( pal->width == 0 && pal->height == 0 )
        return;

    pal->winid = MS_CreateWindow(class_name, pal->name,
                                 WS_CHILD | WS_CLIPSIBLINGS,
                                 pal->xpos, pal->ypos,
                                 pal->width, pal->height,
                                 pal->parent->winid,
                                 (HMENU)NULL, (HANDLE)NULL, (LPVOID)NULL);
    if ( pal->winid )
        {
        /* get DC for drawing */
        pal->window = AxPackageHandle(pal->winid, AX_HWND_TYPE);
        if ( pal->type == W_PALETTE )
            RealizePaletteButtons( (AXWidget_palette)pal );
        MS_ShowWindow(pal->winid, SW_SHOW);
        MS_SetClassLong(pal->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        }
}

void
RealizeRibbon(AXWidget_ribbon w_ribbon)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("RibbonClass");

    WIDGET_PARANOID(w_ribbon, W_RIBBON);
    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC) RibbonClassProc;
        wndclass.hInstance = NULL;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    if ( w_ribbon->parent->winid )
        {
        /* make sure ribbon's parent (the color palette) has been created. */        
        w_ribbon->winid = MS_CreateWindow(class_name, w_ribbon->name,
                                        WS_VISIBLE | WS_CHILD,
                                        w_ribbon->xpos, w_ribbon->ypos,
                                        w_ribbon->width, w_ribbon->height,
                                        w_ribbon->parent->winid,
                                        (HMENU)NULL, (HANDLE)NULL,
                                        (LPVOID)NULL);
        if ( w_ribbon->winid )
            {
            /* get DC for drawing */
            w_ribbon->window = AxPackageHandle(w_ribbon->winid, AX_HWND_TYPE);
            MS_SetClassLong(w_ribbon->winid, GCL_HCURSOR,
                                (LONG)ThimPointerCursor);
            }
        }
}


static void
RealizePageBar(AXWidget_page w_page, int xpos, int ypos)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("PageBarClass");

    WIDGET_PARANOID(w_page, W_PAGEBAR);
	if ( !w_page->display )
		return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC)PageBarClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_SCROLLBAR + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    w_page->winid = MS_CreateWindow(class_name, w_page->name,
                                    WS_VISIBLE | WS_CHILD,
                                    xpos, ypos,
                                    w_page->width, w_page->height,
                                    w_page->parent->winid,
                                    (HMENU)NULL, (HANDLE)NULL, (LPVOID)NULL);
    if ( w_page->winid )
        {
        w_page->window = AxPackageHandle(w_page->winid, AX_HWND_TYPE);
        MS_SetClassLong(w_page->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        }
}


static void
RealizeButtonBar(AXWidget_buttonbar wb, int xpos, int ypos)
{
    WNDCLASS wndclass;
    char *class_name = NXLT("ButtonBarClass");

    WIDGET_PARANOID(wb, W_BUTBAR);
	if ( !wb->display )
		return;

    if ( !MS_GetClassInfo(hInst, class_name, &wndclass) )
        {
        memset(&wndclass, 0, sizeof(wndclass));
        wndclass.style = (UINT) NULL;
        wndclass.lpfnWndProc = (WNDPROC)ButtonBarClassProc;
        wndclass.hInstance = hInst;
        wndclass.hIcon = NULL;
        wndclass.hCursor = MS_LoadCursor((HINSTANCE)NULL, IDC_ARROW);
        wndclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
        wndclass.lpszClassName = class_name;
        MS_RegisterClass(&wndclass);
        }

    wb->winid = MS_CreateWindow(class_name, wb->name,
                                    WS_VISIBLE | WS_CHILD,
                                    xpos, ypos,
                                    wb->width, wb->height,
                                    wb->parent->winid,
                                    (HMENU)NULL, (HANDLE)NULL, (LPVOID)NULL);
    if ( wb->winid )
        {
        wb->window = AxPackageHandle(wb->winid, AX_HWND_TYPE);
        MS_SetClassLong(wb->winid, GCL_HCURSOR, (LONG)ThimPointerCursor);
        }
}


/*********************************************************
function: RealizeStatusWidget - create status widget
*/
static void
RealizeStatusWidget(AXWidget_main mw)
{
    WIDGET_PARANOID(mw, W_MAIN);
	if ( !mw->statusArea->display )
		return;

    if ( mw->statusArea->winid )
        MS_DestroyWindow(mw->statusArea->winid);

    if ( !mw->statusArea->uid )
        mw->statusArea->uid = GetAvailableUID((AXWidget)mw->statusArea);     

    if ( mw->pageBar )
        mw->statusArea->xpos += mw->pageBar->width;
    mw->statusArea->winid = MS_CreateWindow(NXLT("STATIC"), 
                                mw->statusArea->name,
                                WS_CHILD | WS_VISIBLE | 
                                WS_BORDER | SS_LEFTNOWORDWRAP,
                                mw->statusArea->xpos, mw->statusArea->ypos,
                                mw->statusArea->width, mw->statusArea->height,
                                mw->winid, (HMENU)mw->statusArea->uid,
                                (HANDLE)NULL, (LPVOID)NULL);
}


static int
check_for_dupicate_configures( XConfigureEvent *old_mess, 
                                   XConfigureEvent *new_mess )
{
    if ( (old_mess->type != CONFIG_EVENT) ||
            (new_mess->type != CONFIG_EVENT) )
        return( FALSE );
    if ( old_mess->window != new_mess->window )
        return( FALSE );
    return( TRUE );
}




void
DoAppEvent(XEvent *xevent)
{
    struct wind_struct *winP;

    if ( Wp->ap_id == 0 )
        Wp->ap_id = APSS;
    if ( Wp->ap_id == APSS )
        SetWpFromX11Window(xevent->xany.window);
    else if ( !SetWpFromX11Window(xevent->xany.window) )
        {
        /* event from a non-application window, or event for a *
         * window which just sent away */
        return;
        }

    winP = Wp;                
    /* respond to window-based event, apps that handle X directly */
    if ( (winP->ap_id == APDC) || (winP->ap_id == APUCM) ||
            (winP->ap_id == APEQN) || (winP->ap_id == APSS) ||
            (winP->ap_id == APHTML) )
        {
        if ( xevent->type == ButtonPress && xevent->xbutton.button == Button3 )
            ; /* don't let the apps handle right mouse buttons.
               * they are handled separately.
               */
        else if ( xevent->type != NoExpose || winP->ap_id == APSS )
            {
            /* needed by SS */
            if ( xevent->type == ConfigureNotify )
                {
				/* this will send a sys event (CONFIG_EVENT) to the SS */
        		FrameAppFromXWinId(xevent->xany.window,
									xevent->xconfigure.width,
									xevent->xconfigure.height);
                }
            else
                {
                AxSendMes(winP->p_id, (mbchar*)xevent, sizeof(*xevent),
                                                            APXSERVER);
                }
            }

        ThimbleSaysToReturnNow = FALSE;
        return;
        }

    /* respond to window-based event, apps that preprocess system events */
    AxSetThisPidAsActiveTask(winP->p_id);
    switch (xevent->type)
    {
    case Expose:
#if 0
        if ( winP->ap_id == APGE )
            DoTaskExpose(xevent, winP);
        else
#endif
        HandleExposureEvent(xevent);
        ThimbleSaysToReturnNow = TRUE;
        break;

    case KeyPress:
    case KeyRelease:
        TimeOfButtonPress = xevent->xkey.time;
        HandleKeyEvent(xevent);
        break;

    case ButtonPress:
        TimeOfButtonPress = xevent->xbutton.time;
        AxSetKeyModifiers(xevent->xbutton.state);
        Handle_ButtonPressEvent((XButtonEvent*)xevent, winP);
        if ( SetWpFromX11Window(xevent->xany.window) && (winP->ap_id == APGE ||
                            winP->ap_id == APBG || winP->ap_id == APPIXED) )
            AxNoteAllMousePoints = TRUE;
        else
            AxNoteAllMousePoints = FALSE;
        break;

    case ButtonRelease:
        TimeOfButtonRelease = xevent->xbutton.time;
        Handle_ButtonReleaseEvent((XButtonEvent*)xevent, winP);
        AxNoteAllMousePoints = FALSE;
        break;

    case MotionNotify:
        Handle_MotionEvent(xevent,winP);
        break;

    case SelectionRequest:
    case SelectionNotify:
    case SelectionClear:
        AxSelectionEvent(xevent);
        break;
    }
}


static int
DoCharEvent(AXWidget_main mw, HWND hWnd, UINT message,
                        WPARAM wParam, LPARAM lParam)
{
    BOOL bEvent;
    XEvent xevent;


    WIDGET_PARANOID( mw, W_MAIN );
    memset(&xevent,0,sizeof(XEvent));
    bEvent = WinToXEvent(hWnd,message, wParam,lParam, &xevent, (AXWidget)NULL);
    if (bEvent)
        AxSendMes(mw->taskOwner, (mbchar*) &xevent, sizeof(xevent), APXSERVER);
    return bEvent;
}



#define MSG_WIDTH       400
#define DEBUG_THICK     180
#define GE_MSG_WIDTH    225

/****************************************/
void
RebuildGDIWindow(AXWidget_main w, XEvent *eventP)
{
    HWND hwnd;
    unsigned int main_width=0, main_height=0;
    unsigned int palt_width = 0, palt_height = 0;
    int work_width=0, work_height=0;
    int menu_height=0;
    int ruler_width = 0, ruler_height = 0;
    int plates_width = 0, plates_height = 0, plates_ypos = 0;
    int tool_width = 0, tool_height = 0;
    int colorpal_width = 0, colorpal_height = 0;
    int ge_xruler_width = 0, ge_xruler_height = 0;
    int ge_yruler_width = 0, ge_yruler_height = 0;
    int vsc_width=0, msg_height=Scrollbar_Thickness;
    int page_wid, msg_width, msg_pos, hsc_pos=0, msg_ypos;
    int hsc_width = 0;
    int dbg_height = 0;
    int buton_hyt = 0;
    unsigned int old_dlg_width=0, old_dlg_height=0;
    AXWidget childP;
    AXWidget_ribbon ribbon;
    extern void sizeRibbons();
    int total_width, ribbon_width;
    int ruler_ypos, vsc_ypos;
    int is_ge, toolbar_changed = FALSE;
    RECT rect;
    int new_x, new_y;


    WIDGET_PARANOID(w, W_MAIN);
    if ( eventP )
        {
        if ( eventP->type == ConfigureNotify )
            {
            w->xpos = eventP->xconfigure.x;
            w->ypos = eventP->xconfigure.y;
            if ( (w->width == (unsigned int)eventP->xconfigure.width) &&
                    (w->height == (unsigned int)eventP->xconfigure.height) )
                return;   /* no change, do nothing */

            w->width = eventP->xconfigure.width;
            w->height = eventP->xconfigure.height;
            }
        else
            return;   /* un-interesting event */
        }

    /* is this a GE main window? (it uses a diffent status line) */
    is_ge = AxIsGraphicsTask(w->taskOwner);

    if ( w->vScrollBar )
        vsc_width = Scrollbar_Thickness;

    if ( w->palette && w->palette->display )
        palt_width = PALETTE_WIDTH;

    if ( w->butonBar )
        buton_hyt = w->butonBar->height;

    if ( w->ruler )
        {
        ruler_width = w->width;
        ruler_height = WpRulerHeight(w->style);
        }
    if ( w->plates )
        {
        plates_width = w->width;
        plates_height = SSPlatesHeight();
        }
    if ( w->toolBar )
        {
        tool_width = (MAX(30, w->width) - palt_width);
        tool_height = AxToolBarHeight(w, tool_width);

        /* has toolbar size changed? */
        MS_GetClientRect(w->toolBar->winid, &rect);
        if ( (tool_width != (rect.right - rect.left)) ||
            (tool_height != (rect.bottom - rect.top)) )
            toolbar_changed = TRUE;
        }
    if ( w->dialog )
        {
        old_dlg_width = w->dialog->width;
        old_dlg_height = w->dialog->height;
        }

    if ( eventP == NULL )
        {
        if ( w->dialog )
            {
            /* we're here because of menubar poke (called from
             * ElfbRebuildDialog) - dialog shell may need resize
             * if toolbar window created/destroyed/resized */
			if ( w->menuBar->display )
            	menu_height = AxWinDefaultMenuHeight;
			else
				menu_height = 0;
            main_width = old_dlg_width + (BorderWidth*2);
            main_height = menu_height + AxWinTitleHeight + tool_height +
                                        old_dlg_height + (BorderWidth*2);
            if ( w->width != main_width || w->height != main_height )
                {
                /* if variable sized dialog - resize dialog,
                 * else resize dialog shell */
                if ( w->window )
                    {
                    /* resize W_MAIN window */
                    MS_SetWindowPos(w->winid, HWND_TOP, 0, 0,
                            main_width, main_height, SWP_NOMOVE);
                    return;
                    }
                }
            }
        }


    main_width = w->width;
    main_height = w->height;

    work_width = MAX(30, w->width - vsc_width - palt_width);
    msg_pos = palt_width;
    if ( w->debug )
        dbg_height = DEBUG_THICK;

    if ( w->ge_yruler && w->ge_yruler->display )
        {
        ge_yruler_width = GE_YRULER_WIDTH;
        ge_yruler_height = work_height;
        }
    if ( w->ge_xruler && w->ge_xruler->display )
        {
        ge_xruler_width = work_width;
        ge_xruler_height = GE_XRULER_HEIGHT;
        }

    if ( w->colorpal && w->colorpal->display )
        {
        colorpal_width = work_width + vsc_width;
        colorpal_height = COLORPAL_HEIGHT;
        main_height -= colorpal_height;
        }

    if ( w->hScrollBar )
        {
        if ( is_ge )
            {
            msg_width = GE_MSG_WIDTH;
            page_wid = GE_PAGE_WIDTH;
            }
        else
            {
            msg_width = MSG_WIDTH;
            page_wid = 0;
            }
        hsc_width = work_width - msg_width - page_wid;
        hsc_pos = msg_pos + msg_width + page_wid;
        }
    else
        msg_width = work_width;

    if ( w->workWindow )
        {
        w->workWindow->width = work_width;
        work_height = MAX(30, main_height -
                                menu_height -
                                tool_height -
                                plates_height -
                                msg_height -
                                ruler_height -
                                dbg_height);

        if ( w->workWindow->winid )
            {
            MS_MoveWindow(w->workWindow->winid, palt_width,
                        menu_height + ruler_height +
                        tool_height + plates_height,
                        w->workWindow->width, work_height, FALSE);
            /* we explicitly invalidate the whole work window *
             * to make sure all of it gets repainted.         */
            MS_InvalidateRect(w->workWindow->winid, (CONST RECT*)NULL, TRUE);
            /* also invalidate any child windows that may exist, which is
             * generally rare, but is always the case in the SS where the
             * row/col/edit windows are children of the work area.
             */
            for ( hwnd = MS_GetWindow(w->workWindow->winid, GW_CHILD); hwnd;
                                     hwnd = MS_GetWindow(hwnd, GW_HWNDNEXT) )
                {
                MS_InvalidateRect(hwnd, (CONST RECT*)NULL, TRUE);
                }
            }

        w->workWindow->height = work_height;
        FrameAppFromXWinId(w->workWindow->window, w->workWindow->width,
                                                w->workWindow->height);
        }

    msg_ypos = menu_height + tool_height + ruler_height + dbg_height +
                                           plates_height + work_height;

    if ( w->ruler )
        {
        ruler_ypos = menu_height + tool_height;
        if ( !w->ruler->winid )
            {  /* just turned on now */
            w->ruler->xpos = 0;
            w->ruler->ypos = ruler_ypos;
            w->ruler->width = ruler_width;
            w->ruler->height = ruler_height;
            w->ruler->mapped = TRUE;
            }
        else if ( (main_width != w->ruler->width) ||
                                    (w->ruler->ypos != ruler_ypos) )
            {
            w->ruler->width = main_width;
            w->ruler->ypos = ruler_ypos;
            MS_MoveWindow(w->ruler->winid, w->ruler->xpos, w->ruler->ypos,
                                w->ruler->width, w->ruler->height, TRUE);
            }
        }

    if ( w->plates )
        {
        plates_ypos = menu_height + tool_height;
        if ( !w->plates->winid ) 
            {  /* just turned on now */
            w->plates->xpos = 0;
            w->plates->ypos = plates_ypos;
            w->plates->width = plates_width;
            w->plates->height = plates_height;
            RealizePlates(w->plates);
            w->plates->mapped = TRUE;
            }
        else if ( (main_width != w->plates->width) ||
                                    (w->plates->ypos != plates_ypos) )
            {
            w->plates->width = main_width;
            w->plates->ypos = plates_ypos;
            MS_MoveWindow(w->plates->winid,
                            w->plates->xpos,w->plates->ypos,
                            w->plates->width,w->plates->height, FALSE);
            }
        /* we explicitly invalidate the whole plates window *
         * to make sure all of it gets repainted.           */
        MS_InvalidateRect(w->plates->winid, (CONST RECT*)NULL, FALSE);
        }

    if ( w->toolBar )
        {
        if ( tool_height == 0 )
            {   /* No bar needed */
            if ( w->toolBar->winid )
                {     /* take away old one */
                AxDestroyWindow(Dpy, (AXWidget)w->toolBar, w->toolBar->window);
                w->toolBar->window = NULL;
                }
            }
        else
            {
            w->toolBar->xpos = palt_width;
            if ( !w->toolBar->winid )
                {    /* create toolbar window */
                w->toolBar->ypos = 0;
                if ( w->window && !w->toolBar->initial_paint )
                    {  /* toolbar needed */
                    RealizeToolBar(w->toolBar);
                    }
                }
            else
                {
                /* adjust toolbar window (wid/hyt set in AxToolBarHeight). */
                /* (only if there's been a configuration event).           */
                if ( eventP || toolbar_changed )
                    RealizeToolBar(w->toolBar);
                }
            }
        }

    if ( w->corner && w->corner->widgets && w->corner->widgets->winid )
        {
        new_x = w->width - w->corner->widgets->width;
        new_y = main_height - w->corner->widgets->height;
        MS_MoveWindow(w->corner->widgets->winid,
                        new_x, new_y,
                        w->corner->widgets->width,
                        w->corner->widgets->height, TRUE);
        }

    if ( w->debug )
        {
        w->debug->xpos = 0;
        w->debug->ypos = menu_height+ruler_height+work_height+tool_height;
        w->debug->height = dbg_height;
        w->debug->width = main_width;
        if ( !w->debug->window )
            {  /* just turned on now */
            w->debug->mapped = TRUE;
            AxWinCreateMEDebuggerWindow(w->debug);
            AddToWindowList((AXWidget)w->debug);
            MS_SetClassLong(w->debug->winid, GCL_HCURSOR,
                                (LONG)ThimPointerCursor);
            }
        else
            {
            MS_MoveWindow(w->debug->winid, w->debug->xpos, w->debug->ypos,
                                w->debug->width, w->debug->height, TRUE);
            /* we explicitly invalidate the whole debug window *
             * to make sure all of it gets repainted.          */
            MS_InvalidateRect(w->debug->winid, (CONST RECT*)NULL, FALSE);
            }
        }

    if ( w->palette )
        {
        if ( !w->palette->display )
            {
            for( childP=w->palette->widgets; childP; childP=childP->nextChild )
                {
                if ( childP->winid )
                    {
                    AxDestroyWindow(Dpy, childP, childP->window);
                    childP->winid = NULL;
                    childP->window = NULL;
                    }
                }
            if ( w->palette->winid )
                {
                AxDestroyWindow(Dpy, (AXWidget)w->palette, w->palette->window);
                w->palette->winid = NULL;
                w->palette->window = NULL;
                }
            }
        else if ( main_height+colorpal_height-menu_height-ruler_height !=
                   w->palette->height ||
                  palt_width != w->palette->width )
            {
            w->palette->xpos = 0;
            w->palette->ypos = menu_height + ruler_height;
            w->palette->width = palt_width;
            w->palette->height = main_height +
                                 colorpal_height -
                                 menu_height -
                                 ruler_height;
            if ( w->palette->winid )
                {
                RealizePaletteWidget((AXWidget)w->palette);
                }
            }
        }

    if ( w->ge_xruler )
        {
        if ( !w->ge_xruler->display && w->ge_xruler->window )
            {
            AxDestroyWindow(Dpy, (AXWidget)w->ge_xruler, w->ge_xruler->window);
            w->ge_xruler->window = NULL;
            }
        else
            {
            w->ge_xruler->value = 0;
            w->ge_xruler->width = work_width;
            w->ge_xruler->height = GE_XRULER_HEIGHT;
            w->ge_xruler->xpos = palt_width;
            w->ge_xruler->ypos = main_height -
                                 Scrollbar_Thickness -
                                 GE_XRULER_HEIGHT;
            if ( !w->ge_xruler->window )
                {
                if ( w->ge_xruler->display )
                    {
                    w->ge_xruler->mapped = TRUE;
                    }
                }
            else
                {
                MS_MoveWindow(w->ge_xruler->winid,
                                w->ge_xruler->xpos,
                                w->ge_xruler->ypos,
                                w->ge_xruler->width,
                                w->ge_xruler->height, TRUE);
                /* we explicitly invalidate the whole ruler window *
                 * to make sure all of it gets repainted.          */
                MS_InvalidateRect(w->ge_xruler->winid,(CONST RECT*)NULL,FALSE);
                }
            }
        }

    if ( w->ge_yruler )
        {
        if ( !w->ge_yruler->display && w->ge_yruler->window )
            {
            AxDestroyWindow(Dpy, (AXWidget)w->ge_yruler, w->ge_yruler->window);
            w->ge_yruler->window = NULL;
            }
        else
            {
            w->ge_yruler->value = 0;
            w->ge_yruler->width = GE_YRULER_WIDTH;
            w->ge_yruler->height = work_height - ge_xruler_height;
            w->ge_yruler->xpos = palt_width + work_width - ge_yruler_width;
            w->ge_yruler->ypos = menu_height + tool_height;
            if ( !w->ge_yruler->window )
                {
                if ( w->ge_yruler->display )
                    {
                    w->ge_yruler->mapped = TRUE;
                    }
                }
            else
                {
                MS_MoveWindow(w->ge_yruler->winid,
                                w->ge_yruler->xpos,
                                w->ge_yruler->ypos,
                                w->ge_yruler->width,
                                w->ge_yruler->height, TRUE);
                /* we explicitly invalidate the whole ruler window *
                 * to make sure all of it gets repainted.          */
                MS_InvalidateRect(w->ge_yruler->winid,(CONST RECT*)NULL,FALSE);
                }
            }
        }

    if ( w->colorpal )
        {
        if ( !w->colorpal->display )
            {
            for(childP=w->colorpal->widgets; childP; childP=childP->nextChild)
                {
                if ( childP->window )
                    {
                    AxDestroyWindow(Dpy, childP, childP->window);
                    childP->window = NULL;
                    /* the ribbon widget was just destroyed which also *
                     * destroyed its child (the option menu). so make  *
                     * sure its window handle is set to null.          */
                    childP->widgets->winid = (HWND)NULL;
                    }
                }
            if ( w->colorpal->window )
                {
                AxDestroyWindow(Dpy,(AXWidget)w->colorpal,w->colorpal->window);
                w->colorpal->window = NULL;
                }
            }
        else
            {
            w->colorpal->xpos = palt_width;
            w->colorpal->ypos = main_height;
            w->colorpal->width = colorpal_width;
            if ( w->colorpal->winid )
                {
                MS_MoveWindow(w->colorpal->winid,
                            w->colorpal->xpos, w->colorpal->ypos,
                            w->colorpal->width, w->colorpal->height, TRUE);
                /* we explicitly invalidate the whole colorpal window *
                 * to make sure all of it gets repainted.             */
                MS_InvalidateRect(w->colorpal->winid, (CONST RECT*)NULL,FALSE);
                }
            for( childP = w->colorpal->widgets; childP;
                            childP = childP->nextChild )
                {
                if ( childP->type == W_RIBBON )
                    ribbon = (AXWidget_ribbon)childP;
                else
                    ribbon = childP;

                sizeRibbons(w->colorpal->width, &total_width, &ribbon_width);
                ribbon->width = total_width;
                ribbon->scroll_per = ribbon_width;
                if( (ribbon->scroll_max - ribbon->scroll_pos)
                                        < ribbon->scroll_per )
                    ribbon->scroll_pos = 0;
                if ( ribbon->winid )
                    {
                    MS_MoveWindow(ribbon->winid, ribbon->xpos, ribbon->ypos,
                                        ribbon->width, ribbon->height, TRUE);
                    /* we explicitly invalidate the whole ribbon window *
                     * to make sure all of it gets repainted.           */
                    MS_InvalidateRect(ribbon->winid,
                                        (CONST RECT*)NULL,
                                        FALSE);
                    if ( ribbon->widgets->winid )
                        {
                        int hyt, x_option;
                        /* move the option menu of the ribbon */
                        x_option = ribbon->width - ribbon->widgets->width - 2;
                        hyt = ((AXWidget_option)ribbon->widgets)->pulldown_height;
                        MS_MoveWindow(ribbon->widgets->winid,
                                        x_option, ribbon->ypos + 3,
                                        ribbon->widgets->width, hyt, TRUE);
                        }
                    }
                ribbon->display = TRUE;
                }
            }
        }


    if ( w->vScrollBar )
        {
        w->vScrollBar->height = work_height - buton_hyt;
        vsc_ypos = menu_height + ruler_height + plates_height +
                                        tool_height + buton_hyt;
        if ( w->vScrollBar->winid )
            {
            MS_MoveWindow(w->vScrollBar->winid, (work_width + palt_width),
                    vsc_ypos, Scrollbar_Thickness, w->vScrollBar->height, TRUE);
            /* we explicitly invalidate the whole scrollbar window *
             * to make sure all of it gets repainted.              */
            MS_InvalidateRect(w->vScrollBar->winid, (CONST RECT*)NULL, FALSE);
            }
        else
            {
            w->vScrollBar->xpos = palt_width + work_width;
            w->vScrollBar->ypos = vsc_ypos;
            }
        }

    if ( w->hScrollBar )
        {
        w->hScrollBar->width = hsc_width;
        if ( w->hScrollBar->winid )
            {
            MS_MoveWindow(w->hScrollBar->winid, hsc_pos, msg_ypos,
                                hsc_width, Scrollbar_Thickness, TRUE);
            /* we explicitly invalidate the whole scrollbar window *
             * to make sure all of it gets repainted.              */
            MS_InvalidateRect(w->hScrollBar->winid, (CONST RECT*)NULL, FALSE);
            }
        else
            {
            w->hScrollBar->xpos = hsc_pos;
            w->hScrollBar->ypos = msg_ypos;
            }
        }

    if ( w->statusArea )
        {
        if ( w->statusArea->winid )
            {
            MS_MoveWindow(w->statusArea->winid, msg_pos + page_wid, msg_ypos,
                            w->statusArea->width = msg_width, Scrollbar_Thickness,
                            TRUE);
            /* we explicitly invalidate the whole status window *
             * to make sure all of it gets repainted.           */
            MS_InvalidateRect(w->statusArea->winid, (CONST RECT*)NULL, FALSE);
            }
        else
            w->statusArea->ypos = msg_ypos;
        }

    if ( w->pageBar )
        {
        if ( w->pageBar->winid )
            {
            MS_MoveWindow(w->pageBar->winid, msg_pos, msg_ypos,
                w->pageBar->width = page_wid, Scrollbar_Thickness, TRUE);
            /* we explicitly invalidate the whole pagebar window *
             * to make sure all of it gets repainted.            */
            MS_InvalidateRect(w->pageBar->winid, (CONST RECT*)NULL, FALSE);
            }
        }

    if ( w->butonBar && w->butonBar->winid )
        {
        MS_MoveWindow(w->butonBar->winid, (work_width + palt_width),
                        (vsc_ypos - buton_hyt), w->butonBar->width,
                        w->butonBar->height, TRUE);
        /* we explicitly invalidate the whole pagebar window *
         * to make sure all of it gets repainted.            */
        MS_InvalidateRect(w->butonBar->winid, (CONST RECT*)NULL, FALSE);
        }

    if ( w->dialog )
        {
        w->dialog->ypos =  menu_height + tool_height;
        w->dialog->width = w->width;
        w->dialog->height = main_height - w->dialog->ypos;
        if ( w->dialog->winid )
            {
            MS_MoveWindow(w->dialog->winid, w->dialog->xpos, w->dialog->ypos,
                                w->dialog->width, w->dialog->height, TRUE);
            }
        if ( w->dialog->variable_size && (w->dialog->width!=old_dlg_width ||
                                w->dialog->height!=old_dlg_height) )
            {
            data_ptr aP;
            int dlg_wid, dlg_ht;

            if (w->dialog->noExpand)
                {
                dlg_wid = w->dialog->width;
                dlg_ht = w->dialog->height;
                }
            else
                {
                dlg_wid = axDlgUnscaleX(w->dialog->width,
                                        w->dialog->referenceFont);
                dlg_ht = axDlgUnscaleY(w->dialog->height,
                                       w->dialog->referenceFont);
                }

            aP = AxMakeArray(2);
            AxAddIntToArray(aP, 0, dlg_wid);
            AxAddIntToArray(aP, 1, dlg_ht);
            if ( !w->elfObject )
                w->elfObject = AxTaskCopyElfData(0,w->dialog->elfObject);

            UniqueOnly = TRUE;
            CallWidget(w->taskOwner, (AXWidget)w, EV_DLG_RESIZED_, aP);
            UniqueOnly = FALSE;
            }
        }
}

void
AXmUpdateDialogSz(AXWidget_main w, int x, int y, int wid, int hyt, int type)
{
    int main_wid, main_hyt;
    int bar_wid, tool_wid;
    int bar_hyt, tool_hyt;

    /* do we have the correct widget? */
    if ( !w || w->type != W_MAIN || !w->dialog )
        return;
    if ( !w->winid || !w->dialog->winid )
        return;

    type = (type > 2) ? 0 : type;
    if ( type != 1 && wid > 0 && hyt > 0 )
        {
        if ( w->dialog->width == wid && w->dialog->height == hyt )
            {
            if ( type == 0 )
                return;
            else
                type = 1;
            }
        else
            {
            /* calculate new size info for main window */
            if ( !w->menuBar )
                bar_wid = bar_hyt = 0;
            else
                bar_hyt = AxWinDefaultMenuHeight;
            if ( !w->toolBar )
                tool_wid = tool_hyt = 0;
            else
                {
                tool_wid = MAX(30, wid);
                tool_hyt = AxToolBarHeight(w, tool_wid);
                }
            if ( w->dialog->variable_size )
                {
                main_wid = wid + (ResizeBorderWidth*2);
                main_hyt = hyt + bar_hyt + tool_hyt +  AxWinTitleHeight +
                                                (ResizeBorderHeight*2);
                }
            else
                {
                main_wid = wid + (BorderWidth*2);
                main_hyt = hyt + bar_hyt + tool_hyt + AxWinTitleHeight +
                                                    (BorderHeight*2);
                }
            }
        }

    /* do it (generates ConfigureNotify - rebuild dialog shell then) */
    if ( type == 2 )
        MS_MoveWindow(w->winid, x, y, main_wid, main_hyt, FALSE);
    else if ( type == 1 )
        {
        /* we use the NOZORDER flag to make sure the window
         * doesn't pop to the front.
         */
        MS_SetWindowPos(w->winid, 0, x, y, 0, 0,
            SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOZORDER);
        }
    else
        {
        MS_SetWindowPos(w->winid, 0, 0, 0, main_wid, main_hyt,
                    SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER);
        }
    AxMapWindow((AXWidget)w, Dpy, w->window, w->name);
}



static LRESULT
DoGErulerEvent(AXWidget_ge_ruler w, UINT message)
{
    PAINTSTRUCT ps;
    LRESULT retval;


    if ( w->type != W_GE_XRULER && w->type != W_GE_YRULER )
        tempAbort(NXLT("Widget type mismatch"));

    if ( message == WM_PAINT )
        {
        HDC save_handle;
        if ( IgnorePaintMessages( ) )
            {
            /* we are not going to process this message just yet */
            /* since a "drag" is in progress                     */
            return( 0 );
            }

        MS_BeginPaint(w->winid, &ps);

        save_handle = w->window;
        w->window = AxPackageHandle(ps.hdc, AX_DC_TYPE);

        if ( w->type == W_GE_XRULER )
            PaintGExruler(w, (XExposeEvent*)NULL, TRUE, TRUE);

        if ( w->type == W_GE_YRULER )
            PaintGEyruler(w, (XExposeEvent*)NULL, TRUE, TRUE);

        REMOVE_DRAWABLE(w->window);
        w->window = save_handle;
        MS_EndPaint(w->winid, &ps);
        retval = 0;
        }
    else if ( message == WM_DESTROY )
        {
        /* since the ge ruler is created over the work space, *
         * we need to make sure the work area is re-painted   *
         * when the ruler is destroyed.          -donato      */
        MS_UpdateWindow(w->parent->workWindow->winid);
        retval = 0;
        }
    else
        {
        /* just a flag to mean we don't care about the event. */
        retval = -1;
        }

    return retval;
}


static void
ClearPaletteButtonUids(AXWidget_palette w_palette)
{
    AXWidget_pushbutton w_button;


    for ( w_button = (AXWidget_pushbutton)w_palette->widgets; w_button;
                    w_button = (AXWidget_pushbutton)w_button->nextChild )
        {
        if ( !w_button )  /* menu separators are null widgets in the array */
            continue;

        if ( w_button->uid )
            {
            CLEAR_WIDGET_FROM_UID_LIST(w_button->uid);
            w_button->uid = 0;
            }
        }
}

#define WONT_FIT_INC 5
#define WONT_FIT_FUDGE 0

/*************************************************************************
function: WXShowWindow - Display & paint window
*/
BOOL WXShowWindow(mw)
AXWidget_main mw;
{
    static int first_time = TRUE;
    static int y_wont_fit_count = 0;
    static int x_wont_fit_count = 0;
    int map_window;
    HWND hWnd;
    HMENU hMenu;
    LONG main_style;
    int is_ge;
    int xpos, ypos;
    int hsc_pos, vsc_width;
    int width, height, orig_width, orig_height;
    int plates_width=0,plates_height=0;
    int menu_height, win_width, msg_width;
    int tool_width, tool_height;
    int ruler_width, ruler_height;
    int buton_hyt = 0;
    int palette_width   = 0, palette_height   = 0,
        colorpal_width  = 0, colorpal_height  = 0,
        ge_xruler_width = 0, ge_xruler_height = 0,
        ge_yruler_width = 0, ge_yruler_height = 0;
    AXWidget_dialog dlgP;
    RECT work_area;
    int ret, work_width, work_height, work_top, work_left;

    /* we record the current window position so that we can space new windows */
    /* down the screen when they are created, like the X-server does for us   */
    static force_zero = -1;
    static POINT current_pos;

    WIDGET_PARANOID(mw, W_MAIN);

    if ( force_zero < 0 )
        {
        if ( getenv("AX_FORCE_ZERO") != (char *)NULL )
            force_zero = TRUE;
        else
            force_zero = FALSE;
        }

    /* Find out how much screen we have to work with */
    work_width = work_height = work_top = work_left = 0;
    if ( RunningWin95Look )
        {
        /* get the available work area, which is less than the full screen because */
        /* of the task bar                                                         */
        ret = MS_SystemParametersInfo( SPI_GETWORKAREA, sizeof(work_area), 
                                                                 &work_area, 0 );
        if ( ret )
           {
           work_width = work_area.right - work_area.left;
           work_height = work_area.bottom - work_area.top;
           work_top = work_area.top;
           work_left = work_area.left;
           }
        }
    if ( work_width == 0 )
        {
        /* use full screen */
        work_width = AxWinDisplayWidth;
        work_height = AxWinDisplayHeight;
        }

    if ( !AxNoMapWindows && mw->display && AxMapWinName(mw->name) )
        map_window = TRUE;
    else
        map_window = FALSE;

    /* is this a GE main window? (it uses a diffent status line) */
    is_ge =  AxIsGraphicsTask(mw->taskOwner);

    if ( mw->menuBar && !(mw->dialog && mw->dialog->topmostwindow) )
        {
		/* if the height is set on the menu bar, that means it's greater
		 * than the default Windows menubar height (SM_CYMENU) and we need
		 * to use it. Otherwise use the default.
		 */
		if ( !mw->menuBar->display )
			menu_height = 0;
		else if ( mw->menuBar->height > 0 )
			{
			menu_height = mw->menuBar->height;
			mw->menuBar->height = 0;
			}
		else
			menu_height = AxWinDefaultMenuHeight;
        hMenu = mw->menuBar->menu_handle;
        }
    else
        {
        menu_height = 0;
        hMenu =  (HMENU)NULL;
        }

    /** dialog window **/
    if ( mw->dialog )
        {
            
        if (!mw->dialog->xpos && !mw->dialog->ypos)
            {
            AxCenterWidgetOverMouse(mw->dialog);
            }

        dlgP = mw->dialog;
        main_style = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX;

        xpos = dlgP->xpos;
        ypos = dlgP->ypos;
        orig_width  = dlgP->width;
        orig_height = dlgP->height;

        /* adjust for the stuff windows puts on the borders of the windows & *
         * takes up some of the space we specify on the create window call.  */
        if ( !dlgP->variable_size )
            {
            width = orig_width + (2*BorderWidth);
            height = orig_height + menu_height + AxWinTitleHeight +
                                                   (2*BorderHeight);
            }
        else
            {
            /* variable size borders may be a different width */
            width = orig_width + (2*ResizeBorderWidth);
            height = orig_height + menu_height + AxWinTitleHeight +
                                             (2*ResizeBorderHeight);
            /* set dialog resize flag  */
            main_style |= WS_SIZEBOX | WS_MAXIMIZEBOX;
            }

        /* this sets 'pending_delete' flag for any edit fields that need it. */
        SetTopPendingDelete((AXWidget)mw->dialog);
        }
    else
        {
        orig_width  = mw->workWindow->width;
        orig_height = mw->workWindow->height;

        if ( mw->variable_size )
            {
            main_style = WS_OVERLAPPEDWINDOW;
            width  = orig_width + (2*ResizeBorderWidth);
            height = orig_height + menu_height + AxWinTitleHeight +
                                            (2*ResizeBorderHeight);
            }
        else
            {
            /* non size-able atm window (SS print preview). */
            main_style = WS_CAPTION | WS_BORDER | WS_SYSMENU | 
                            WS_MINIMIZEBOX | WS_MAXIMIZEBOX;
            width  = orig_width + (2*BorderWidth);
            height = orig_height+menu_height + AxWinTitleHeight +
                                                (2*BorderHeight);
            }
        }

    if ( mw->ge_yruler )
        {
        ge_yruler_width = GE_YRULER_WIDTH;
        ge_yruler_height = orig_height;
        mw->ge_yruler->width = ge_yruler_width;
        mw->ge_yruler->height = ge_yruler_height;
        }

    if ( mw->ge_xruler )
        {
        ge_xruler_width = orig_width;
        ge_xruler_height = GE_XRULER_HEIGHT;
        mw->ge_xruler->width = ge_xruler_width;
        mw->ge_xruler->height = ge_xruler_height;
        }

    if ( mw->colorpal && mw->colorpal->display && map_window )
        {
        colorpal_width = orig_width + Scrollbar_Thickness;
        colorpal_height = COLORPAL_HEIGHT;
        mw->colorpal->width = colorpal_width;
        mw->colorpal->height = colorpal_height;
        }
    else if ( mw->colorpal && !map_window )
        mw->colorpal->display = FALSE;

    if ( mw->palette && mw->palette->display && map_window )
        {
        palette_width = PALETTE_WIDTH;
        palette_height = orig_height + colorpal_height;
        mw->palette->width = palette_width;
        }
    else if ( mw->palette && !map_window )
        mw->palette->display = FALSE;

    if ( mw->butonBar )
        buton_hyt = mw->butonBar->height;

    if ( mw->vScrollBar )
        win_width = palette_width + orig_width + Scrollbar_Thickness;
    else
        win_width = palette_width + orig_width;

    if ( mw->toolBar )
        {
        tool_width  = win_width - palette_width;
        tool_height = AxToolBarHeight(mw, tool_width);
        mw->toolBar->xpos = palette_width;
        }
    else
        {
        tool_width  = 0;
        tool_height = 0;
    }

    if ( mw->ruler)
        {
        ruler_width = win_width;
        ruler_height = WpRulerHeight(mw->style);

        mw->ruler->ypos = tool_height;
        mw->ruler->width  = ruler_width;
        mw->ruler->height = ruler_height;
    }
    else
        {
        ruler_width  = 0;
        ruler_height = 0;
    }

    if ( mw->plates )
        {
        plates_width = win_width;
        plates_height = SSPlatesHeight();
        mw->plates->width  = plates_width;
        mw->plates->height = plates_height;
        mw->plates->xpos = 0;
        mw->plates->ypos = tool_height;
        }

    if ( ge_xruler_width )
        {    /*  ge_xruler exists */
        mw->ge_xruler->xpos = palette_width;
        mw->ge_xruler->ypos = orig_height - Scrollbar_Thickness - colorpal_height;
        }

    if ( ge_yruler_width )
        {    /* ge_yruler exists */
        mw->ge_yruler->xpos = palette_width + orig_width;
        mw->ge_yruler->ypos = tool_height;
        }

    if ( mw->dialog )    /* adjust "inner" window positions */
        {
        mw->dialog->xpos = 0;
        mw->dialog->ypos = tool_height + ruler_height + plates_height;
        }
    else
        {
        mw->workWindow->xpos  = palette_width;
        mw->workWindow->ypos  = tool_height + ruler_height + plates_height;
        }

    if ( mw->vScrollBar )
        {
        vsc_width = mw->vScrollBar->width;

        mw->vScrollBar->xpos = win_width;
        mw->vScrollBar->ypos = tool_height + ruler_height +
                                plates_height + buton_hyt;

        /* re-do toolbar */
        tool_width  = orig_width + vsc_width;
        tool_height = AxToolBarHeight(mw, tool_width);
        }
    else
        vsc_width = 0;

    if ( mw->hScrollBar )
        {
        if ( is_ge )
            msg_width = GE_MSG_WIDTH;
        else
            msg_width = MSG_WIDTH;

        hsc_pos = mw->hScrollBar->xpos = palette_width + msg_width;
        mw->hScrollBar->ypos = orig_height + tool_height +
                                ruler_height + plates_height;
        }


    mw->width  = width + palette_width + vsc_width;
    mw->height = height + tool_height + ruler_height + vsc_width +
                                colorpal_height + plates_height;


    if ( (mw->height > (unsigned int) (work_height - WONT_FIT_FUDGE)) &&
                        ((mw->type == W_MAIN) && mw->workWindow) )
        {
        mw->height = work_height - WONT_FIT_FUDGE;
        if ( mw->workWindow )
            {
            mw->workWindow->width  = orig_width;
            mw->workWindow->height = mw->height - tool_height -
                                        ruler_height - menu_height -
                                        AxWinTitleHeight - plates_height -
                                        (2*ResizeBorderHeight) - Scrollbar_Thickness;
            mw->vScrollBar->height = mw->workWindow->height;
            mw->hScrollBar->ypos   = mw->workWindow->height + tool_height +
                                            plates_height + ruler_height;
            FrameAppFromShellWidgetId(mw, mw->workWindow->width,
                                            mw->workWindow->height);
            }

        if ( mw->dialog )
            mw->dialog->height = mw->height - tool_height - menu_height -
                                    AxWinTitleHeight - (2*BorderHeight);
        }


    if ( mw->statusArea )
        {
        mw->statusArea->xpos = palette_width;
        mw->statusArea->ypos = mw->workWindow->height + tool_height + 
                                     plates_height + ruler_height;
        }

    if ( palette_height )
        mw->palette->height = palette_height + vsc_width +
                                         mw->statusArea->height;

    if ( colorpal_width )
        {
        mw->colorpal->xpos = palette_width;
        mw->colorpal->ypos = orig_height + tool_height +
                                    mw->statusArea->height;
        }

    if ( mw->corner )
        {
        mw->corner->xpos = orig_width;
        mw->corner->ypos = mw->workWindow->height + tool_height +
                               plates_height + ruler_height;
        }

    /* set up minimum size values for window. */
    mw->minWidth += (2*ResizeBorderWidth) + vsc_width + palette_width;
    mw->minHeight += AxWinTitleHeight + menu_height + (2*ResizeBorderWidth) +
                                    tool_height +/* ??x also for resize!*/
                                    colorpal_height +
                                    plates_height + ruler_height;

    mw->dialogHWNDlist = (HWND*)NULL;

         
    if ( mw->dialog )
        {
        /* make sure dialog will fit on the screen. */
        if ( xpos < work_left )
             /* move it out from under the task-bar which seems to be on the left */
             xpos = work_left;
        if ( (xpos + (int)mw->width) > work_width )
            xpos = work_width - (int)mw->width - 1;
        xpos = MAX(0, xpos);
        xpos = MAX( xpos, work_left );

        /* for the height we let the top part of the dialog hang off the top of */
        /* the screen, if necessary, since the "OK" buttons are on the bottom of */
        /* the dialog, and if they are not visible, there is no way to move the  */
        /* window to get to them.  - jon                                         */
        if ( ypos < work_top )
            /* move it out from under the task-bar which seems to be on the top */
            ypos = work_top;
        if ( (ypos + (int)mw->height) > work_height )
            {
            if ( mw->toolBar )
                /* this dialog has a toolbar, therfore a menu bar, do not let */
                /* these hang off the top of the screen. example: inbox dialog */
                ypos = work_top;
            else
                ypos = work_top + work_height - (int)mw->height - 1;
            }

        /* here, "topmostwindow" actually means "full screen, no decoration"
         * mode. This is a misnomer, in my opinion.  -donato
         */
        if ( mw->topmostwindow )
            main_style = WS_POPUP;

        /* for dialogs, use a different class proc that has CS_SAVEBITS *
         * set. (the equivalent of 'backing store' on X).               */
            hWnd = MS_CreateWindow(NXLT("MainDialogClass"), mw->name,
                                main_style | WS_CLIPCHILDREN,
                                xpos, ypos, mw->width, mw->height,
                                mw->parent_hwnd, hMenu, hInst, (LPVOID)NULL);

        if ( mw->parent )
            {
            /* this dialog is a child of an app window so add it *
             * to the list of dialog window handles.    -donato  */
            SetDialogChildren(mw->parent, hWnd);
            }
        }
    else
        {
        if ( first_time )
            {
            /* we record the position so that we can space new windows */
            /* down the screen, like the X-server does for us          */
            current_pos.x = mw->xpos;
            current_pos.y = mw->ypos;
            first_time = FALSE;
            }

        if ( force_zero )
            {
            xpos = ypos = 0;
            }
        else
            {
            if ( mw->xpos == 0 )
               /* use default positioning */
               xpos = current_pos.x + WONT_FIT_INC;
            else
               /* hard coded positioning from wpWindowPosSize profile var */
               xpos = mw->xpos;
            if ( mw->ypos == 0 )
               /* use default positioning */
               ypos = current_pos.y + WONT_FIT_INC;
            else
               /* hard coded positioning from wpWindowPosSize profile var */
               ypos = mw->ypos;
            }

        /* make sure window upper left is in visible area of screen */
        if ( xpos < work_left )
             /* move it out from under the task-bar which seems to be on the left */
             xpos = work_left;
        if ( ypos < work_top )
            /* move it out from under the task-bar which seems to be on the top */
            ypos = work_top;

        /* dont't allow windows to be created bigger than the screen plus */
        /* a bit of a fudge factor                                         */
        if ( (int)mw->width > work_width - WONT_FIT_FUDGE )
            mw->width = work_width - WONT_FIT_FUDGE;
        if ( (int)mw->height > work_height - WONT_FIT_FUDGE )
            mw->height = work_height - WONT_FIT_FUDGE;

        while ( (xpos + (int)mw->width) > (work_left + work_width) ||
                (ypos + (int)mw->height) > (work_top + work_height) )
            {
            /* if window won't fit on screen, select a position to the     *
             * right of the last time we were here, and if that is too far *
             * right, step down a bit and then try again                   */
            if ( (xpos + (int)mw->width) > work_width )
                {
                /** too far to the right, restart at the left edge down */
                /** a bit so that the windows will "tile".              */
                x_wont_fit_count = 0;
                y_wont_fit_count++;
                ypos = mw->ypos + (y_wont_fit_count*WONT_FIT_INC);
                xpos = work_left;
                }
            else
                {
                /* room in the x direction, check the height */
                if ( ypos + (int)mw->height > work_height )
                   {
                   /* too far down, restart at the top left corner */
                   xpos = work_left;
                   ypos = work_top;
                   x_wont_fit_count = y_wont_fit_count = 0;
                   }
                }
            }

        hWnd = MS_CreateWindow(NXLT("MainClass"), mw->name,
                                main_style | WS_CLIPCHILDREN,
                                xpos, ypos, mw->width, mw->height,
                                mw->parent_hwnd, hMenu, hInst, (LPVOID)NULL);

        current_pos.x = xpos;
        current_pos.y = ypos;
        }

    if ( !hWnd )
        return FALSE;

    mw->winid = hWnd;
    mw->window = AxPackageHandle(hWnd, AX_HWND_TYPE);

    if ( !(mw->dialog && mw->dialog->topmostwindow) && map_window )
        MS_DrawMenuBar(mw->winid);

    /* if we have not yet hidden the startup window, do so now */
    if ( !have_hidden_startup )
        {
        MS_ShowWindow( AxTopHWNDNeverMapped, SW_HIDE );
        have_hidden_startup = TRUE;
        }
 
    if ( map_window )
        {
        /* Windows 95 handles window icons differently than NT. */
        if ( RunningWin95Look )
            {
            HICON hicon;
            /* Set the small icon for this window */
            hicon = GetIconHandleFromId(mw->style, FALSE);
            MS_SendMessage(mw->winid, WM_SETICON, (WPARAM)FALSE, (LPARAM)hicon);
            /* Set the large icon for this window */
            hicon = GetIconHandleFromId(mw->style, TRUE);
            MS_SendMessage(mw->winid, WM_SETICON, (WPARAM)TRUE, (LPARAM)hicon);
            }

        MS_ShowWindow(mw->winid, ShowNextWindow);
        MS_UpdateWindow(mw->winid);
        ShowNextWindow = SW_SHOWNORMAL;
        mw->mapped = TRUE;
        }
    else
        {
        /* windowless (invisible) app. if there's a work space assign *
         * it an HDC so we have something to draw on.                 */
        mw->display = FALSE;
        if ( mw->workWindow )
            {
            mw->workWindow->winid = mw->winid;
            mw->workWindow->window = mw->window;
            /* ...and so we know this is windowless. */
            mw->workWindow->display = FALSE;
            }
        MS_ShowWindow(mw->winid, SW_HIDE);
        MS_SetWindowPos(mw->winid, HWND_BOTTOM, 0, 0, 0, 0,
                                SWP_NOMOVE | SWP_NOSIZE);
        }

    return TRUE;
}



/**********************************/
/** move this to windlg.c **/
char *
DoWinOpenDialog(char *suffix)
{
    static char  szFilterName[128];
    static TCHAR szFilter[128];
    static TCHAR szTitle[32];
    static TCHAR szDebugeeTitle[128];
    static TCHAR szDirName[256];
    static TCHAR szFile[256];
    static TCHAR szFileTitle[256];
    static TCHAR szDefExt[8];
    static TCHAR szCustomFilter[40];
    static OPENFILENAME    OpenFileName;
    UINT   FilterNameLen;
    BOOL   ret;

    strcpy(szFilterName, "*");
    strcat(szFilterName, suffix);
    strcpy(szFilter, szFilterName);
    FilterNameLen = strlen(szFilterName);
    strcpy(&szFilter[++FilterNameLen], suffix);
    strcpy(szFile, szFilter);
 
    OpenFileName.lStructSize       = sizeof(OPENFILENAME);
    OpenFileName.hwndOwner         = NULL;
    OpenFileName.hInstance         = hInst;
    OpenFileName.lpstrFilter       = (LPSTR) szFilter;
    OpenFileName.lpstrCustomFilter = (LPSTR) szCustomFilter;
    OpenFileName.nMaxCustFilter    = (DWORD) sizeof(szCustomFilter);
    OpenFileName.nFilterIndex      = (DWORD) 0;
    OpenFileName.lpstrFile         = (LPSTR) szFile;
    OpenFileName.nMaxFile          = sizeof(szFile);
    OpenFileName.lpstrFileTitle    = (LPSTR) szFileTitle;
    OpenFileName.nMaxFileTitle     = sizeof(szFileTitle);
    OpenFileName.lpstrInitialDir   = (LPSTR) NULL;  // (fSavedDirectory ? szInitialDir : NULL);
    OpenFileName.lpstrTitle        = (LPSTR) NXLT("Open");
    OpenFileName.Flags             = OFN_HIDEREADONLY;// | OFN_SHOWHELP |
                                   //OFN_ENABLEHOOK | OFN_ENABLETEMPLATEHANDLE;
    OpenFileName.nFileOffset       = (WORD) NULL;
    OpenFileName.nFileExtension    = (WORD) NULL;
    OpenFileName.lpstrDefExt       = (LPSTR) szDefExt;
    OpenFileName.lCustData         = (DWORD) NULL;
    OpenFileName.lpfnHook          = NULL; //(LPOFNHOOKPROC) OpenDlgHookProc;
    OpenFileName.lpTemplateName    = (LPSTR) NULL;

    ret = MS_GetOpenFileName(&OpenFileName);
    if ( ret && OpenFileName.lpstrFile )
        return (char*)OpenFileName.lpstrFile;
    else
        return (char*)NULL;
}
#if 0
DoWinPrintDialog()
{
    PRINTDLG pd;

    pd.lStructSize = sizeof(PRINTDLG);
    pd.hDevMode = (HANDLE) NULL;
    pd.hDevNames = (HANDLE) NULL;
    pd.Flags = PD_RETURNDC;
    pd.hwndOwner = NULL;
    pd.hDC = (HDC) NULL;
    pd.nFromPage = 1;
    pd.nToPage = 1;
    pd.nMinPage = 0;
    pd.nMaxPage = 0;
    pd.nCopies = 1;
    pd.hInstance = (HANDLE) NULL;
    pd.lCustData = 0L;
    pd.lpfnPrintHook = (LPPRINTHOOKPROC) NULL;
    pd.lpfnSetupHook = (LPSETUPHOOKPROC) NULL;

    pd.lpPrintTemplateName = (LPSTR) NULL;
    pd.lpSetupTemplateName = (LPSTR)  NULL;
    pd.hPrintTemplate = (HANDLE) NULL;
    pd.hSetupTemplate = (HANDLE) NULL;
}
#endif



void
FreeWindowsResources(void)
{
    MS_DeleteDC(RootWin);
    if ( ScratchMap )
        MS_DeleteObject(ScratchMap);

    /* fonts */
#if 0
    *** this is a stock object and should not be free'd - jon
    *** see InitFontInfo()
    MS_DeleteObject(AxDlgMainFont->fid);
#endif
    if ( AxDlgMainFont )
        free(AxDlgMainFont);
    if ( AxDlgMiniFont )
        {
        MS_DeleteObject(AxDlgMiniFont->fid);    
        free(AxDlgMiniFont);
        }
    if ( AxStatusLineFont )
        {
        MS_DeleteObject(AxStatusLineFont->fid);
        free(AxStatusLineFont);
        }

    /* palettes */
    if ( ApplixCmap )
        MS_DeleteObject(ApplixCmap);

    if ( AxWinPalette )
        {
        MS_DeleteObject(AxWinPaletteHandle);
        free(AxWinPalette);
        AxWinPalette = NULL;
        }
}



BOOL
DoOwnerdrawEvent(WPARAM wParam, LPARAM lParam)
{
    BOOL retval;
    LPDRAWITEMSTRUCT lpds;    /* ownerdraw structure */


    retval = FALSE;
    lpds = (LPDRAWITEMSTRUCT) lParam;
    if ( lpds->CtlType == ODT_BUTTON )
        {
        retval = DrawButtonEvent(wParam, lParam);
        }
    else if ( lpds->CtlType == ODT_LISTBOX )
        {
        retval = DrawListBoxEvent(wParam, lParam);
        }
    else if ( lpds->CtlType == ODT_COMBOBOX )
        {
        retval = DrawOptionMenuEvent(wParam, lParam);
        }

    return retval;
}


/* these defines taken from editwin.c */
#define BS ((unsigned) 0010)
#define DEL ((unsigned) 0177)  /* ascii code */
#define IS_NGC(c) ((((unsigned) (c)) < (unsigned) ' ') || \
                   (((unsigned) (c)) == DEL) || \
           (((unsigned) (c)) == BS))

/************************************************************************
 ******************* WIDGET SUBCLASS PROCS ******************************
 ************************************************************************/
LRESULT CALLBACK 
EnterEventProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    LRESULT retval;
    BOOL control_key_is_down = FALSE;
    AXWidget parent_w;
    HWND parent_hwnd;
    int processed_event = FALSE;
	unsigned int state;

    switch (message)
        {
        case WM_KEYDOWN:
			state = axmsGetXKeyState();
            if ( AxEuroDollarKeyCode && 
			     wParam == AxEuroDollarKeyCode &&
			     state == AxEuroDollarKeyState )
				{
				/* send euro dollar char to entry field */
              	MS_SendMessage(hWnd, WM_CHAR, EURO_SYMBOL_8BIT_VALUE, 0L);
             	retval = 0;
				break;
				}
            else if ( AxEuroDollarKeysym && 
			          wParam == AxEuroDollarKeysym &&
			          AxDecodeModifiers(state) == AxEuroDollarModifiers )
				{
				/* send euro dollar char to entry field */
              	MS_SendMessage(hWnd, WM_CHAR, EURO_SYMBOL_8BIT_VALUE, 0L);
             	retval = 0;
				break;
				}
            else if ( state & ControlMask )
                control_key_is_down = TRUE;

            if ( control_key_is_down && (wParam >= 0x41 && wParam <= 0x5a) )
                {
                /* ctrl-CHAR key press. */
                /* send message up to its parent. we have to send to the *
                 * W_MAIN widget which is two levels up (we are assuming *
                 * that all entry fields are in dialog boxes).  -donato  */
                MS_SendMessage(MS_GetParent(MS_GetParent(hWnd)), WM_CHAR,
                                                        wParam, lParam);
                retval = 0;
                }
            else if ( wParam >= VK_F1 && wParam <= VK_F16 )
                {
                /* function key was pressed in edit control. */
                /* send message up to its parent. we have to send to the *
                 * W_MAIN widget which is two levels up (we are assuming *
                 * that all entry fields are in dialog boxes).  -donato  */
                MS_SendMessage(MS_GetParent(MS_GetParent(hWnd)), WM_KEYDOWN,
                                                            wParam, lParam);
                retval = 0;
                }
            else if ( wParam == VK_ESCAPE )
                {
                /* send cancel command to parent (dialog). */
                MS_SendMessage(MS_GetParent(hWnd), WM_COMMAND,
                        MAKEWPARAM(IDCANCEL, 0), (LPARAM)hWnd);
                retval = 0;
                }
            else
                {
                retval = MS_CallWindowProc(OldEnterProc, hWnd, message,
                                                        wParam, lParam);
                }
            break;

        case WM_LBUTTONDOWN:
        case WM_LBUTTONDBLCLK:
            {
            /* These button-down cases are only here to implement triple-click
             * in entry fields. Therefore 'processed_event' means we did the
             * triple-click (select all) and return zero, otherwise we do the
             * Windows default.    -donato
             */
            AXWidget_entry w;
            long click_time = MS_GetMessageTime();

            parent_hwnd = MS_GetParent(hWnd);
            parent_w = GetWidgetFromHWND(parent_hwnd, W_DIALOG);
            if ( parent_w )
                {
                w = (AXWidget_entry)GetGadgetFromHWND(parent_w, hWnd);
                if ( w )
                    {
                    if ( (click_time - w->last_click_time) <= DoubleMillisec )
                        w->edit_win.num_clicks++;
                    else if ( message == WM_LBUTTONDBLCLK )
                        w->edit_win.num_clicks = 2;
                    else
                        w->edit_win.num_clicks = 1;
                    w->last_click_time = click_time;
                    /* check for triple-click. */
                    if ( w->edit_win.num_clicks == 3 )
                        {
                        /* select everything in the field */
                        retval = 0;
                        processed_event = TRUE;
                        MS_SendMessage(hWnd, EM_SETSEL, (WPARAM)0, (LPARAM)-1);
                        }
                    }
                }

            if ( !processed_event )
                {
                retval = MS_CallWindowProc(OldEnterProc, hWnd, message,
                                                        wParam, lParam);
                }
            break;
            }

        case WM_RBUTTONDOWN:
            {
            HDC hdc;
            XEvent xevent;
            AXWidget w;

            parent_hwnd = MS_GetParent(hWnd);
            parent_w = GetWidgetFromHWND(parent_hwnd, W_DIALOG);
            if ( parent_w )
                {
                w = GetGadgetFromHWND(parent_w, hWnd);
                if ( w )
                    {
                    hdc = MS_GetDC(hWnd);
                    w->window = AxPackageHandle(hdc, AX_DC_TYPE);
                    WinToXEvent(hWnd, message, wParam, lParam, &xevent, NULL);
                    RightButtonEvent((AXWidget_popup)w, OPTION_NEW, &xevent);
                    REMOVE_DRAWABLE(w->window);
                    w->window = NULL;
                    MS_ReleaseDC(hWnd, hdc);
                    retval = 0;
                    processed_event = TRUE;
                    }
                }

            if ( !processed_event )
                {
                retval = MS_CallWindowProc(OldEnterProc, hWnd, message,
                                                        wParam, lParam);
                }
            }
            break;

        case WM_CHAR:
            {
            AXWidget_entry ew;
            /* if the entry field doesn't have focus when it receives   *
             * this character message, return 0. Otherwise we fall thru *
             * and do the default (the former case happens if the user  *
             * presses an accel key while entry field has focus, and the*
             * processing of the accel causes the entry field to lose   *
             * focus).                                   -donato        */
            if ( hWnd != MS_GetFocus() )
                {
                retval = 0;
                break;
                }
			else if ( AxEuroDollarKeysym && wParam == AxEuroDollarKeysym )
				{
				state = axmsGetXKeyState();
				if ( AxDecodeModifiers(state) == AxEuroDollarModifiers )
					{
					/* send euro dollar char to entry field */
               		MS_SendMessage(hWnd, WM_CHAR, EURO_SYMBOL_8BIT_VALUE, 0L);
               		retval = 0;
					break;
					}
				}

            /* Find the entry widget associated with the event. */
            parent_hwnd = MS_GetParent(hWnd);
            parent_w = GetWidgetFromHWND(parent_hwnd, W_DIALOG);
            if ( parent_w )
                {
                ew = (AXWidget_entry)GetGadgetFromHWND(parent_w, hWnd);
                if ( ew && ew->validChars )
                    {
                    /* note: wParam is the character code of the key pressed. */
                    /* check valid chars, but let delete and backspace go
                     * through, along with any key "less than space".
                     */
                    if ( !IS_NGC(wParam) && !strchr(ew->validChars, wParam) )
                        {
                        /* not a valid char, so break and don't display */
                        RingTheBell();
                        retval = 0;
                        break;
                        }
                    }
                }
            }
            /* FALL THROUGH */
        default:
            retval = MS_CallWindowProc(OldEnterProc, hWnd, message,
                                                    wParam, lParam);
        }

    return retval;
}

LRESULT CALLBACK 
EditboxEventProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    LRESULT retval;
    BOOL control_key_is_down = FALSE;
	unsigned int state;

    switch (message)
        {
        case WM_GETDLGCODE:
            {
        /* tell editbox we only care about arrow keys if it is read-only.
         * Otherwise just do the default processing.
         */
            HWND parent_hwnd;
            AXWidget parent_w;
            AXWidget_editbox w;

            parent_hwnd = MS_GetParent(hWnd);
            parent_w = GetWidgetFromHWND(parent_hwnd, W_DIALOG);
            if ( parent_w )
                {
                w = (AXWidget_editbox)GetGadgetFromHWND(parent_w, hWnd);
                if ( w && w->no_picks )
                    retval = DLGC_WANTARROWS;
                else
                    {
                    if ( wParam == 9 && (MS_GetKeyState(VK_CONTROL) >= 0) )
                        /* bit of a HACK here. since Windows seems to insist
                         * on sending the tab key thru our subclass proc (in
                         * direct opposition to the way entry fields work,
                         * which is to let the dialog message handler handle
                         * it, which by default is to tab to the next widget),
                         * we hardcode the same return value an entry field
                         * returns (but only if the ctrl-key is not also being
                         * pressed, since Windows does handle that default case
                         * properly which is to actually put a tab in the edit
                         * box).    -donato
                         */
                        retval = 137;
                    else
                        {
                        retval = MS_CallWindowProc(OldEditboxProc, hWnd, message,
                                                        wParam, lParam);
                        /* by default, any text in a Windows editbox is high-
                         * lighted (selected) when one tabs into an editbox.
                         * This behavior is undesireable in cases such as Send
                         * Mail where a .signature may be present and the user
                         * does not want to start typing and erase his .sig.
                         * So here we remove the dialog code which tells the
                         * dialog widget to set the selection.  -donato
                         */
                        retval &= ~DLGC_HASSETSEL;
                        }
                    }
                }
            else
                retval = MS_CallWindowProc(OldEditboxProc, hWnd, message,
                                                        wParam, lParam);
            }
            break;

        case WM_KEYDOWN:
			state = axmsGetXKeyState();
            if ( AxEuroDollarKeyCode && 
			     wParam == AxEuroDollarKeyCode &&
			     state == AxEuroDollarKeyState )
				{
				/* send euro dollar char to entry field */
              	MS_SendMessage(hWnd, WM_CHAR, EURO_SYMBOL_8BIT_VALUE, 0L);
             	retval = 0;
				break;
				}
            else if ( AxEuroDollarKeysym && 
			          wParam == AxEuroDollarKeysym &&
			          AxDecodeModifiers(state) == AxEuroDollarModifiers )
				{
				/* send euro dollar char to entry field */
              	MS_SendMessage(hWnd, WM_CHAR, EURO_SYMBOL_8BIT_VALUE, 0L);
             	retval = 0;
				break;
				}
            else if ( (MS_GetKeyState(VK_CONTROL)) < 0 )
                control_key_is_down = TRUE;

            if ( control_key_is_down && (wParam >= 0x41 && wParam <= 0x5a) )
                {
                /* ctrl-CHAR key press. */
                /* send message up to its parent. we have to send to the *
                 * W_MAIN widget which is two levels up (we are assuming *
                 * that all entry fields are in dialog boxes).  -donato  */
                MS_SendMessage(MS_GetParent(MS_GetParent(hWnd)), WM_CHAR,
                                                        wParam, lParam);
                retval = 0;
                }
            else if ( wParam >= VK_F1 && wParam <= VK_F16 )
                {
                /* function key was pressed in edit control. */
                /* send message up to its parent. we have to send to the *
                 * W_MAIN widget which is two levels up (we are assuming *
                 * that all entry fields are in dialog boxes).  -donato  */
                MS_SendMessage(MS_GetParent(MS_GetParent(hWnd)), WM_KEYDOWN,
                                                            wParam, lParam);
                retval = 0;
                }
            else if ( wParam == VK_ESCAPE )
                {
                /* send cancel command to parent (dialog). */
                MS_SendMessage(MS_GetParent(hWnd), WM_COMMAND,
                        MAKEWPARAM(IDCANCEL, 0), (LPARAM)hWnd);
                retval = 0;
                }
            else
                {
                retval = MS_CallWindowProc(OldEditboxProc, hWnd, message,
                                                        wParam, lParam);
                }
            break;

        case WM_CHAR:
            /* if the entry field doesn't have focus when it receives   *
             * this character message, return 0. Otherwise we pass the  *
             * message on.  (the former case happens if the user        *
             * presses an accel key while entry field has focus, and the*
             * processing of the accel causes the entry field to lose   *
             * focus.                                    -donato        */
            /* more hacking: if the editbox does not have focus
             * and we receive a backspace character, we are most likely
             * processing a WM_CLEAR message. (Windows seems to clear
             * selected text by sending itself a backspace. clever eh?)
             * So we are assuming that a backspace will never be
             * an accel key, which is what the original GetFocus
             * hack is for.
             */
            if ( (hWnd != MS_GetFocus()) && (wParam != VK_BACK) )
				{
                /* editbox does not have focus */
                retval = 0;
				}
			else if ( AxEuroDollarKeysym && wParam == AxEuroDollarKeysym )
				{
				state = axmsGetXKeyState();
				if ( AxDecodeModifiers(state) == AxEuroDollarModifiers )
					{
					/* send euro dollar char to entry field */
               		MS_SendMessage(hWnd, WM_CHAR, EURO_SYMBOL_8BIT_VALUE, 0L);
               		retval = 0;
					}
				}
            else
				{
                retval = MS_CallWindowProc(OldEditboxProc, hWnd, message,
                                                        wParam, lParam);
				}
            break;

        case WM_RBUTTONDOWN:
            {
            HDC hdc;
            HWND parent_hwnd;
            XEvent xevent;
            AXWidget w, parent_w;

            hdc = MS_GetDC(hWnd);
            parent_hwnd = MS_GetParent(hWnd);
            parent_w = GetWidgetFromHWND(parent_hwnd, W_DIALOG);
            if ( parent_w )
                {
                w = GetGadgetFromHWND(parent_w, hWnd);
                if ( w )
                    {
                    w->window = AxPackageHandle(hdc, AX_DC_TYPE);
                    WinToXEvent(hWnd, message, wParam, lParam, &xevent, NULL);
                    RightButtonEvent((AXWidget_popup)w, OPTION_NEW, &xevent);
                    REMOVE_DRAWABLE(w->window);
                    w->window = NULL;
                    }
                }
            MS_ReleaseDC(hWnd, hdc);
            retval = 0;
            break;
            }

        default:
            retval = MS_CallWindowProc(OldEditboxProc, hWnd, message,
                                                    wParam, lParam);
        }
    return retval;
}


LRESULT CALLBACK
ListEventProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    HWND parent_hwnd;
    XEvent xevent;
    AXWidget w, parent_w;
    LRESULT retval;

    retval = 0;
    if ( message == WM_RBUTTONDOWN )
        {
        hdc = MS_GetDC(hWnd);
        parent_hwnd = MS_GetParent(hWnd);
        parent_w = GetWidgetFromHWND(parent_hwnd, W_DIALOG);
        if ( parent_w )
            {
            w = GetGadgetFromHWND(parent_w, hWnd);
            if ( w )
                {
                w->window = AxPackageHandle(hdc, AX_DC_TYPE);
                WinToXEvent(hWnd, message, wParam, lParam, &xevent, NULL);
                RightButtonEvent((AXWidget_popup)w, OPTION_NEW, &xevent);
                REMOVE_DRAWABLE(w->window);
                w->window = NULL;
                }
            }
        MS_ReleaseDC(hWnd, hdc);
        }
    else
        retval = MS_CallWindowProc(OldListProc, hWnd,message,wParam,lParam);

    return retval;
}
/********************* end widget subclass procs ************************/






/* each instance of an app has a list of dialog children handles. *
 * we initialize it here (starts off as NULL) and add the passed  *
 * in element. When an app is minimized, we go thru the list and  *
 * hide the dialogs (see DoChildDialogs() below); when an app is  *
 * restored we restore the dialogs too. When a dialog is destroyed*
 * we remove its handle from the list (see WXDestroyWidget).      */
static void 
SetDialogChildren(AXWidget_main parent, HWND dialog_hwnd)
{
    register int i, size_list;
    register HWND *listP;

    WIDGET_PARANOID(parent, W_MAIN);
    if ( !parent->dialogHWNDlist )
        {
        /* initialize dialog list with size 5 (it's a good average number; *
         * most users don't have that many dialogs up per app anyway. At   *
         * least i hope not!)  We keep the current available size in the   *
         * first element of the table.                    -donato          */
        parent->dialogHWNDlist = (HWND*)TrueMalloc(5 * sizeof(HWND));
        memset(parent->dialogHWNDlist, 0, (5 * sizeof(HWND)));
        *parent->dialogHWNDlist = (HWND)5;
        }

try_again:
    size_list = (int) *parent->dialogHWNDlist;
    listP = parent->dialogHWNDlist + 1;
    for ( i = 1; i < size_list; i++ )
        {
        if ( *listP == (HWND)NULL )
            {
            /* found an available entry */
            *listP = dialog_hwnd;
            return;
            }
        listP++;
        }

    /* fell through, no available slots, realloc to make some more room */
    parent->dialogHWNDlist = (HWND*)TrueRealloc((char *)parent->dialogHWNDlist,
                                             (size_list + 5)*sizeof(HWND));
    listP = parent->dialogHWNDlist + size_list;/* where the new stuff begins */
    memset(listP, 0, (5 * sizeof(HWND)));    /* clear the new entries */
    *parent->dialogHWNDlist = (HWND) (size_list + 5);
    goto try_again;
}

static void
DoChildDialogs(AXWidget_main parent, UINT show_cmd)
{
    int ix, list_size;
    HWND *listP;

    WIDGET_PARANOID(parent, W_MAIN);
    if ( parent->dialogHWNDlist )
        {
        list_size = (int) *parent->dialogHWNDlist;
        listP = parent->dialogHWNDlist + 1;
        for ( ix = 1; ix < list_size; ix++ )
            {
            if ( *listP )
                MS_ShowWindow(*listP, show_cmd);
            listP++;
            }
        }
}



/***********************************************************************/
/* See comments in CanvasClassProc for explanation on why we sometimes
 * have to map the Windows virtual key (VK_*) to an X key (XK_*)
 */
static BOOL
NeedToUseXKey(unsigned int win_key, unsigned int *xkey)
{
    BOOL retval = TRUE;
    switch (win_key)
        {
        case VK_PRIOR:
            *xkey = 0xFF55;
            break;
        case VK_NEXT:
            *xkey = 0xFF56;
            break;
        case VK_END:
            *xkey = 0xFF57;
            break;
        case VK_HOME:
            *xkey = 0xFF50;
            break;
        case VK_LEFT:
            *xkey = 0xFF51;
            break;
        case VK_UP:
            *xkey = 0xFF52;
            break;
        case VK_RIGHT:
            *xkey = 0xFF53;
            break;
        case VK_DOWN:
            *xkey = 0xFF54;
            break;
        case VK_INSERT:
            *xkey = 0xFF63;
            break;
        case VK_DELETE:
            *xkey = 0xFFFF;
            break;
        default:
            *xkey = 0;
            retval = FALSE;
            break;
        }
    return retval;
}
/************************************************************************/


int
IgnorePaintMessages(void)
{
    if ( Running_Windows95 )
        return FALSE;

    if ( IgnoreButtonState )
       {
       /* hook from scroll bars, where we do want to draw, even though the */
       /* mouse button is down                                             */
       return( FALSE );
       }

    /* to deal with full drag, we do not paint if the button is down */
    return( AxButtonIsDown() );
}



int AxButtonIsDown()
{
    int state;

    state = GetAsyncKeyState( VK_LBUTTON ) | GetAsyncKeyState( VK_RBUTTON );
    if ( state & 0x80000000 )
       {
       /* high bit set means button is down */
       return( TRUE );       /* do not draw at this time */
       }

    /* mouse not down, draw */
    return( FALSE );
}


/*************************************************************************
function: AxCenterWidgetOverMouse - Adjust x/y/ vals of passed (W_DIALOG)
widget based on current mouse position.
*/
void
AxCenterWidgetOverMouse(AXWidget_dialog w)
{
    POINT point;
    int xoffset, yoffset;    /* offset from widget origin to mouse coord */
    static int force_to_zero = -1;

    WIDGET_PARANOID(w, W_DIALOG);

    MS_GetCursorPos(&point);
    if ( w->defaultButton )
        {
        AxDefaultButtonCenter(w, &xoffset, &yoffset);
        yoffset += AxWinTitleHeight;
        }
    else
        {
        xoffset = w->width / 2;
        yoffset = w->height / 2;
        }

    /* approx center */
    point.x -= xoffset;
    point.x = MAX(point.x, 5);  /* leave 5 for margin */
    point.y -= yoffset;
    point.y = MAX(point.y, 20); /* leave 20 for title bar */

/* keep from being below/beyond desktop */

    if ( (point.x + w->width) > (unsigned int)AxWinDisplayWidth )
        point.x = AxWinDisplayWidth - w->width;
    if ( (point.y + w->height + AxWinTitleHeight) >
                (unsigned int)AxWinDisplayHeight )
        point.y = AxWinDisplayHeight - w->height - AxWinTitleHeight;

/* but NEVER above/before desktop */

    point.x = MAX(0, point.x);
    point.y = MAX(0, point.y);

    if ( force_to_zero == -1 )
        {
        /* see if we are to run in a special mode where all dialog
         * boxes */
        /* are posted in the upper left corner of the window   */
        if (getenv(NXLT("AX_FORCE_ZERO")) != (char *) NULL)
            force_to_zero = TRUE;
        else
            force_to_zero = FALSE;
        }
    if ( force_to_zero )
        point.x = point.y = 0;

    w->xpos = point.x;
    w->ypos = point.y;
}


static void
axmsHandleWidgetTabKey(AXWidget widget)
{
	AXWidget next_w;

	if ( (MS_GetKeyState(VK_SHIFT)) < 0 )
		{
		/* shift key is down, so go backwards. */
		next_w = TabToPrevWidget(widget, (AXWidget)widget->parent);
		}
	else
		{
		next_w = TabToNextWidget(widget, (AXWidget)widget->parent);
		}
}

/*************************************************************************
 axmsHandleDialogKeys:  see if there's any keyboard functionality
						we want to override (TAB, ALT, etc).
						
              returns:	TRUE if we processed the event ourselves,
						FALSE if we want to let Windows handle it.
***************************************************************************/	
static BOOL
axmsHandleDialogKeys(HWND dlg_hwnd, MSG *msg)
{
    AXWidget widget;
    AXWidget_dialog w_dlg;
	BOOL consumed = FALSE;
    BOOL translate_dialog_msg = TRUE;

	/* find the dlg widget associated with the event */
	w_dlg = (AXWidget_dialog)GetWidgetFromHWND(dlg_hwnd, W_DIALOG);
	if ( w_dlg )
		{
		/* first, process any widget mnemonics that may exist. */
		if ( msg->message == WM_SYSKEYDOWN )
			{
			/* we get this message when a user "holds down the ALT key and 
			 * then presses another key". wParam holds the other key.
			 */
			if ( AxDoDialogAccelerator(w_dlg, msg->wParam) )
				{
				translate_dialog_msg = FALSE;
				consumed = TRUE;
				}
			}
		else
			{
            /* we have a message that may be for a non-edit dialog *
             * widget. If it's a non-Windows widget (eg, Table),   *
             * we want to let it pass on to its ClassProc, otherwise *
             * we want the dialog message handler to handle it.      */
            widget = GetGadgetFromHWND((AXWidget)w_dlg, msg->hwnd);
            if ( widget )
                {
               	if ( widget->winid == msg->hwnd &&
               	        msg->message == WM_KEYDOWN &&
               	        msg->wParam == VK_TAB )
					{
					axmsHandleWidgetTabKey(widget);
					translate_dialog_msg = FALSE;
                    consumed = TRUE;
					}
				else if ( widget->type == W_TOGGLE && 
						((AXWidget_togglebutton)widget)->in_radio &&
						msg->message == WM_KEYDOWN && ARROW_KEY(msg->wParam) )
					{
					/* so we can navigate within a radio array. */
					DialogKeyEvent(widget->parent->parent, msg->hwnd,
									msg->message, msg->wParam, msg->lParam);
					translate_dialog_msg = FALSE;
                    consumed = TRUE;
					}
				if ( widget->type == W_TABLE || widget->type == W_CANVAS ||
													widget->type == W_TRAY )	
					{
                    translate_dialog_msg = FALSE;
					/* if we have an editable table we want to handle the
					 * keystrokes ourselves (TableClassProc).
					 */
					if (widget->type == W_TABLE && AxXmTableIsEditable(widget))
						consumed = FALSE;
					}
                }
			/* we may be dealing with a widget without a window (e.g. W_SCALE)
			 * but we still need to handle the tab key.
			 */
			else if ( (widget = xmKeyFocusWidget(w_dlg)) &&
               	        msg->message == WM_KEYDOWN &&
               	        msg->wParam == VK_TAB )
				{
				axmsHandleWidgetTabKey(widget);
				translate_dialog_msg = FALSE;
                consumed = TRUE;
				}

			/* process any menu accel keys (not mnemonics, but actual
			 * accelerators). 
			 */
			if ( (msg->message == WM_KEYDOWN || msg->message == WM_CHAR) && 
											!consumed && w_dlg->hasFocus )
				{
				if ( widget && widget->type == W_EDITBOX &&
									msg->wParam == VK_RETURN )
					consumed = TRUE;  /* we'll let the dlg handle it... */
				else if ( DialogKeyEvent(w_dlg->parent, msg->hwnd, msg->message,
												msg->wParam, msg->lParam) )
					{
					/* we're done. */
					translate_dialog_msg = FALSE;
					consumed = TRUE;
					}
				}
            }
		}

	if ( translate_dialog_msg )
		if ( MS_IsDialogMessage(dlg_hwnd, msg) )
			consumed = TRUE;

	return consumed;
}
