/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winlib.c
   Applix ASC version: 249
   Date: Thu Feb 11 21:11:25 1999
*/
#define NEED_X_INFO 1
#include <math.h>
#include <string.h>
#include <basicwin.h>
#include <commdlg.h>
#include <ax_xm.h>
#include <aos.h>
#include <paripc.h>
#include <xmlib.h>
#include <tmi.h>
#include <paratm.h>
#include <parint.h>
#include <usrevent.h>
#include <xmdlged.h>
#include <axwinclr.h>
#include <wp.h>
#define SS_FILTER 1    /* hack to fool global.h */
#include <global.h>    /* ss stuff */
#include <java_syms.h>


#define STRALLOC(s) strcpy(malloc(strlen(s)+1),s)

#define LEFT_RIGHT 100
#define UP_DOWN 101
#define N_GRAD_PATS 8
#define hypot _hypot

#define AX_GRADIENT_THRESHOLD 5120

typedef struct _expose_list {
    int left;
    int top;
    int right;
    int bottom;
    HDC hdc;
    } expose_list;
 
static expose_list *DeferList;
static int DeferNum;

struct WINDNOMAP
    {
    char title[1024];
    struct WINDNOMAP *next;
    };

/* List of Windows NOT to be Displayed */
extern struct WINDNOMAP *WindNotMapped;


/* visuals not used in Windows, so just define to be NULL *
 * so we can pass it around when necessary */
Visual *AxVisual = NULL;

extern XFontStruct *AxDlgMainFont;

Atom AxXA_RTF_DATA = 0; /*Atom for registering "Rich Text Format" data.*/
int Ax_Clear_Selection = 0; /* whether to process WM_DESTROYCLIPBOARD */
int DoingActiveScroll = 0;  /* TRUE if in middle of active scroll */

extern DocInfoType XferDoc; /* transfer bin document wrapper */
extern HWND WXDummyWnd;     /* window handle of AX_ROOT_WINDOW_ID */

extern int AxNColors;      /* total number of colors used by apps */
extern HDC RootWin;
extern Window HostWin;
extern AXWidget   TotalWidgetsList;    /* for resource tracking */
extern AXWidget WindowList;
extern win_list_t *TotalWindowsList;   /* for resource tracking */
extern int NumWidgets;
extern int NumWindows;
extern int AxWinDisplayWidth, AxWinDisplayHeight;

extern char *ThimApplixDir;

extern int WidgetNeedsUpdated;    /* Set when a widget needs repainted */
extern int MenuUID;               /* counter of menu starts */
extern int InSysHourglassMode;    /* TRUE while all windows glassed */

extern Display *Dpy;
extern HANDLE hInst;
extern Pixmap ScratchMap;
extern unsigned long AlisPixels[];
extern GC Gc1;
extern unsigned int CursorWidth, CursorHeight, CursorImageSize;
extern unsigned long FGpixel, BGpixel;
extern int AxCharHeight;
extern HPALETTE AxWinPaletteHandle;
extern int RunningWin95Look;
extern int Running_Windows95;
extern PIXEL_VALUE ForePixel, BackPixel;

struct XMlibStr {
    PIXEL_VALUE FGpixel;    /* foreground color for app work areas */
    PIXEL_VALUE BGpixel;    /* backround color for app work areas */
    int FullRegenForUpdate;  /* Set by UnMapWidget,
                                            hint for WidgetNeedsUpdated */
};
extern struct XMlibStr xmlibStr;

#include <winlib.p>



/* return pixels values for the "standard" color entries of black and white */
static void
get_black_white_colors(COLORREF *black_pixel, COLORREF *white_pixel)
{
    if ( DpyDepth > 8 )
        {
        *white_pixel = RGB( 255, 255, 255 );
        *black_pixel = RGB( 0, 0, 0 );
        }
    else
        {
        *white_pixel = GET_COLOR_VALUE( ((AxNColors + 10) - 1) );
        *black_pixel = GET_COLOR_VALUE( 10 );
        }
    return;
}


#if WIN_DEBUG
/*****************************************************************************
 DEBUG FUNCTION: BltTest - use this to see what's been drawn to a memory DC.
                    (modify variables as needed).
 ******/
void BltTest(HDC mem_dc, int width, int height)
{
    HDC display_dc = RootWin;
    int x = 0, y = 275;
    MS_BitBlt(display_dc, x, y, width, height, mem_dc, 0, 0, SRCCOPY);
    GdiFlush();
}

/*****************************************************************************
 DEBUG FUNCTION: PixTest - use this to see what's been drawn to a Pixmap.
                    (modify variables as needed).
 ******/
void PixTest(HBITMAP hbm)
{
    BITMAP bm;
    HBITMAP old_hbm;
    HDC mem_dc, display_dc = RootWin;
    int x = 0, y = 275;

    MS_GetObject(hbm, sizeof(BITMAP), &bm);

    mem_dc = MS_CreateCompatibleDC(NULL);
    old_hbm = MS_SelectObject(mem_dc, hbm);

    MS_BitBlt(display_dc, x,y, bm.bmWidth,bm.bmHeight, mem_dc, 0,0, SRCCOPY);

    MS_SelectObject(mem_dc, old_hbm);
    MS_DeleteDC(mem_dc);
    GdiFlush();
}
#endif


/*** make this function common!!! -donato 11.feb.97 ***/
/**********************************************************************
function: XmNewTitle - Change window's title (UNIX version in xmlib.c)
*/
void XmNewTitle(w, full_name, iconstr)
AXWidget_main w;
char *full_name;
char *iconstr;
{
    if ( !w )
        return;
    WIDGET_PARANOID(w, W_MAIN);

    if ( TaskIsJavaBased(w->taskOwner) )
        {
        data_ptr infoP;
        infoP = AxMakeArray(2);
        AxAddStrToArray(infoP,0,full_name);
        AxAddStrToArray(infoP,1,iconstr);
        AxJavaPidNotifier(w->taskOwner,JV_SET_WINTITLE,infoP);
        }

    if ( MS_IsIconic(w->winid) )
        MS_SetWindowText(w->winid, iconstr);
    else
        MS_SetWindowText(w->winid, full_name);

    if ( !AxMapWinName(w->name) )
        {
        AxDelNoMapWindow(w->name);
        AxAddNoMapWindow(full_name);
        }

    /* store the window title in the widget */
    if ( w->name )
        free( w->name );
    w->name = STRALLOC( full_name );

    /* set icon string on main widget (note: we don't use SetWidgetString() *
     * because that expects an entry field widget).                         */
    if ( w->wstr )
        free(w->wstr);
    w->wstr = STRALLOC(iconstr);
}


void WindowToWidgetYpos(w)
AXWidget w;
{
    int base;

    base = w->parent->height - w->parent->ruler->height - w->height;
    w->ypos = w->ypos - base;    /* new y position */
}


HBITMAP
AxWinGetInverseBitmap(HBITMAP hbm)
{
    HDC src_dc, mem_dc;
    HBITMAP ret_hbm, old_ret_hbm, old_hbm;
    BITMAP bm;

    MS_GetObject(hbm, sizeof(BITMAP), &bm);

    src_dc = MS_CreateCompatibleDC(NULL);
    old_hbm = MS_SelectObject(src_dc, hbm);

    mem_dc = MS_CreateCompatibleDC(NULL);
    ret_hbm = MS_CreateCompatibleBitmap(mem_dc, bm.bmWidth, bm.bmHeight);
    old_ret_hbm = MS_SelectObject(mem_dc, ret_hbm);
    MS_PatBlt(mem_dc, 0, 0, bm.bmWidth, bm.bmHeight, WHITENESS);

    MS_BitBlt(mem_dc, 0, 0, bm.bmWidth, bm.bmHeight, src_dc, 0, 0, SRCINVERT);

    MS_SelectObject(mem_dc, old_ret_hbm);
    MS_SelectObject(src_dc, old_hbm);
    MS_DeleteDC(mem_dc);
    MS_DeleteDC(src_dc);
    return ret_hbm;     /*** CALLER MUST DELETE BITMAP HANDLE! ***/
}


/************************************************************************* 
function: ScrollBarHasBeenMoved - Callback for scroll activity
This is called by ZXtDispatch().
*/
/*** NT version.  UNIX version is in tmx.c ***/
void
ScrollBarHasBeenMoved(AXWidget_main widget, int wID, WPARAM wParam,
                                LPARAM lParam, BOOL is_vertical_bar)
{
    scroll_event_t scroll;
    int scroll_code, win_scroll_pos, app_scroll_pos;
    int i, save_THIMpid, junk;
    struct wind_struct *winP;
    AXWidget_scroll w_scroll;
    int min, max, user_space;
    XmScrollBarCallbackStruct sbData;


    WIDGET_PARANOID(widget, W_MAIN);
    w_scroll = (AXWidget_scroll)NULL;
    if ( is_vertical_bar )
       {
       if ( widget->vScrollBar )
          w_scroll = widget->vScrollBar;
       }
    else
       {
       if ( widget->hScrollBar )
          w_scroll = widget->hScrollBar;
       }
    if ( !w_scroll )
        {
        /* might be a dialog widget, search for it there. */
        w_scroll = (AXWidget_scroll)GetGadgetFromHWND((AXWidget)widget->dialog,
                                                                (HWND)lParam);
        }

    if ( !w_scroll )
       return;       /* should never happen but ... */

    min = max = -1;
    MS_GetScrollRange(w_scroll->winid, SB_CTL, &min, &max);

    scroll_code = LOWORD(wParam);
    win_scroll_pos  = HIWORD(wParam);

    /* Since the Windows scroll position report is only 16 bits we may */
    /* need to scale the reported measurements back up to the user range */
    if ( w_scroll->scroll_max > 32767 )
       {
       /* scale up to max position */
       app_scroll_pos = (float)win_scroll_pos * 
                                     (((float)w_scroll->scroll_max) / 32767.0);
       }
    else
       app_scroll_pos = win_scroll_pos;

    user_space = w_scroll->scroll_max - w_scroll->scroll_per;
    if ( user_space < 0 || w_scroll->scroll_max == 0 )
        return;
    if ( !RunningWin95Look )
        {
        /* Since we can not set the size of the thumb (yet, until Chicago) */
        /* we need to emulate that here.  Basically, the position of the   */
        /* thumb is always the left/top edge.  We keep the value returned  */
        /* to the application within the range that the user could have    */
        /* created if he had a "fat" thumb which could not be moved much   */
        /* by mapping the user movable space (the area not occupied by the */
        /* fat scroll bar) to the Windows space, which is the entire bar   */
        app_scroll_pos = ((float)user_space * (float)app_scroll_pos) / 
                                             (float)w_scroll->scroll_max;
        }

    /* paranoid init of the window context */
    if ( !window[wID].busy_flag )
        return;
    winP = (struct wind_struct*) SetWp(&window[wID]);

    memset(&scroll, 0, sizeof(scroll));
    scroll.wid = wID;   /* set the ATM window id */

    if ( (winP->vbar == 0) && (winP->hbar == 0) )
        {
        /* window is borrowed, get the original */
        for ( i=1; i<TM_MAXWIN; i++ )
            {
            if ( window[i].busy_flag && (window[i].winWasBorrowed == wID) )
                {
                winP = (struct wind_struct*)SetWp(&window[i]);
                break;
                }
            }
        }

    /* check the vertical scroll bar first */
    if ( is_vertical_bar )
        {
        scroll.h_type = UNCHANGED;
        switch (scroll_code)
            {
            default:
                scroll.v_type = UNCHANGED;
                sbData.reason = XmCR_NONE;
                break;
            case SB_TOP:
                sbData.reason = XmCR_TO_TOP;
                winP->wind_attr.v_sc_pos = 0;
                scroll.v_type = NEW_VAL;
                scroll.v_value = 0;
                break;
            case SB_BOTTOM:
                sbData.reason = XmCR_TO_BOTTOM;
                winP->wind_attr.v_sc_pos = w_scroll->scroll_max;
                scroll.v_type = NEW_VAL;
                scroll.v_value = w_scroll->scroll_max;
                break;

            case SB_PAGEDOWN:
                scroll.v_type = PAGE_INC;
                sbData.reason = XmCR_PAGE_INCREMENT;
                break;
            case SB_LINEDOWN:
                scroll.v_type = UNIT_INC;
                sbData.reason = XmCR_INCREMENT;
                break;

            case SB_PAGEUP:
                scroll.v_type = PAGE_DEC;
                sbData.reason = XmCR_PAGE_DECREMENT;
                break;
            case SB_LINEUP:
                scroll.v_type = UNIT_DEC;
                sbData.reason = XmCR_DECREMENT;
                break;

            case SB_THUMBPOSITION:
                scroll.v_type = NEW_VAL;   /* place to stop in debugger */
            case SB_THUMBTRACK:
                sbData.reason = XmCR_VALUE_CHANGED;
                scroll.v_type = NEW_VAL;
                scroll.v_value = app_scroll_pos;
                /* don't set the window attribute for the GE because it
                 * makes a calculation based on the old value.
                 */
                if ( AxIsGraphicsTask(widget->taskOwner) == FALSE )
                    winP->wind_attr.v_sc_pos = app_scroll_pos;

                /* tell windows to move the thumb.  */
                if ( user_space < 5 )
                   /* thumb is same size as scroll bar, user can not move */
                   win_scroll_pos = 0;

                MS_SetScrollPos(w_scroll->winid, SB_CTL, win_scroll_pos, TRUE);
                break;

            case SB_ENDSCROLL:
                /* end of scroll action.  If this is a WP, wake it up to get */
                /* things like the ruler re-painted */
                if ( winP->ap_id == APDC )
                   {
                   AxSendMes(winP->p_id, (mbchar*)&scroll, 1, APDUMMY );
                   PingMyself();       /* wake up message loop */
                   }
                return;
            }

        if ( winP->ap_id == APGE )
            {
            AxSendUniqueMes(winP->p_id, (mbchar*)&scroll, sizeof(scroll), 
                                    APSCROLL, check_for_dupicate_scroll);
            }
        else
            {
            /* set the per-task context, and then call the interface 
             * function in that task.
             */
            DoingActiveScroll = TRUE;
            save_THIMpid = THIMpid;
            VfyContext(winP->p_id);
            if ( winP->ap_id == APDC || winP->ap_id == APUCM ||
                                        winP->ap_id == APEQN ||
                                        winP->ap_id == APHTML )
                {    /* Words, macro editor or HTML author */
                wp_global_data *wpP;
                wpP = (wp_global_data *) AxGetTaskWPXData(winP->p_id);
                WpEventRoutine(wpP, APSCROLL, 0, (char*)&scroll,
                                sizeof(scroll), &junk, &junk);
                }
            else if ( winP->ap_id == APSS )
                {
                SSScrollEvent( (char*)&scroll, sizeof(scroll) );
                }
            else
                {
                sbData.value = scroll.v_value;
                AxCallback(w_scroll->callback, (AXWidget)w_scroll,
                            w_scroll->callbacktag, (caddr_t)&sbData);
                }
            VfyContext( save_THIMpid );
            PaintScrollBar( w_scroll, 0, FALSE, TRUE );
            DoingActiveScroll = FALSE;
            }
        }
    else
        {
        /* the event is for the horizontal scroll bar */
        scroll.v_type = UNCHANGED;
        switch (scroll_code)
            {
            default:
                scroll.h_type = UNCHANGED;
                sbData.reason = XmCR_NONE;
                break;
            case SB_TOP:
                winP->wind_attr.h_sc_pos = 0;
                scroll.h_type = NEW_VAL;
                sbData.reason = XmCR_TO_TOP;
                scroll.h_value = 0;
                break;
            case SB_BOTTOM:
                winP->wind_attr.h_sc_pos = w_scroll->scroll_max;
                scroll.h_type = NEW_VAL;
                sbData.reason = XmCR_TO_BOTTOM;
                scroll.h_value = w_scroll->scroll_max;
                break;

            case SB_LINEDOWN:
                scroll.h_type = UNIT_INC;
                sbData.reason = XmCR_INCREMENT;
                break;
            case SB_LINEUP:
                scroll.h_type = UNIT_DEC;
                sbData.reason = XmCR_DECREMENT;
                break;

            case SB_PAGEDOWN:
                scroll.h_type = PAGE_INC;
                sbData.reason = XmCR_PAGE_INCREMENT;
                break;
            case SB_PAGEUP:
                scroll.h_type = PAGE_DEC;
                sbData.reason = XmCR_PAGE_DECREMENT;
                break;

            case SB_THUMBPOSITION:
                scroll.h_type = NEW_VAL;   /* handy place for debugger */
            case SB_THUMBTRACK:
                sbData.reason = XmCR_VALUE_CHANGED;
                scroll.h_type = NEW_VAL;
                scroll.h_value = app_scroll_pos;
                /* don't set the window attribute for the GE because it
                 * makes a calculation based on the old value.
                 */
                if ( AxIsGraphicsTask(widget->taskOwner) == FALSE )
                    winP->wind_attr.h_sc_pos = app_scroll_pos;

                /* tell windows to move the thumb.  */
                if ( user_space < 5 )
                   /* thumb is same size as scroll bar, user can not move */
                   win_scroll_pos = 0;
 
                MS_SetScrollPos(w_scroll->winid, SB_CTL, win_scroll_pos, TRUE );
                break;

            case SB_ENDSCROLL:
                /* end of scroll action.  If this is a WP, wake it up to get */
                /* things like the ruler re-painted */
                if ( winP->ap_id == APDC )
                   {
                   AxSendMes(winP->p_id, (mbchar*)&scroll, 1, APDUMMY );
                   PingMyself();       /* wake up message loop */
                   }
                return;

            }

        /* set the per-task context, and then call the interface function */
        /*   in that task                                                 */
        if ( winP->ap_id == APGE )
            {
            AxSendUniqueMes(winP->p_id, (mbchar*)&scroll, sizeof(scroll), 
                                    APSCROLL, check_for_dupicate_scroll);
            }
        else
            {
            /* set the per-task context, and then call the interface function */
            /*   in that task                                                 */
            DoingActiveScroll = TRUE;
            save_THIMpid = THIMpid;
            VfyContext(winP->p_id);
            if ( winP->ap_id == APDC || winP->ap_id == APUCM ||
                                        winP->ap_id == APEQN ||
                                        winP->ap_id == APHTML )
                {    /* Words, macro editor or HTML author */
                wp_global_data *wpP;
                wpP = (wp_global_data *) AxGetTaskWPXData(winP->p_id);
                WpEventRoutine(wpP, APSCROLL, 0, (char*)&scroll,
                                sizeof(scroll), &junk, &junk);
                }
            else if ( winP->ap_id == APSS )
                {
                SSScrollEvent( (char*)&scroll, sizeof(scroll) );
                }
            else
                {
                sbData.value = scroll.v_value;
                AxCallback(w_scroll->callback, (AXWidget)w_scroll,
                            w_scroll->callbacktag, (caddr_t)&sbData);
                }
            VfyContext( save_THIMpid );
            PaintScrollBar( w_scroll, 0, FALSE, TRUE );
            DoingActiveScroll = FALSE;
            }

        }
}




HWND GetHWNDFromTotalWindowsList( hdc )
Window hdc;
{
    win_list_t *wp;
 
    for ( wp = TotalWindowsList; wp; wp = wp->next )
        {
        if ( wp->win == hdc )
            return (wp->hwnd);
        }
 
    return( (HWND)NULL );
}


void
AxDestroyWindow(Display *dpy, AXWidget owner, Window win)
{
    int ix;
    HWND hwnd;
    win_list_t *w;
    AXWidget_togglebutton tb;
    short obj_type;

    hwnd = (HWND)NULL;
    if ( IS_PACKAGED_DRAWABLE(win) )
        {
        obj_type = GET_DRAWABLE_TYPE(win);
        if ( obj_type == AX_HWND_TYPE )
            {
            hwnd = (HWND)GET_DRAWABLE_HANDLE(win);
            REMOVE_DRAWABLE(win);
            if ( ((long)owner > 0) && (owner->window == win) )
                owner->window = NULL;
            }
        else
            tempAbort("AxDestroyWindow: incorrect window type!");
        }
    else if ( (long)owner > 0 )
        hwnd = owner->winid;
    else
        tempAbort("AxDestroyWindow: incorrect window type!");


    if ( !hwnd )
        return;    /* may be a windowless app. */

    /* non-Windows widgets will have a non-zero hwnd, but since they are *
     * not real windows we cannot destroy them, so make sure our hwnd is *
     * greater than zero and let the Windows call return any errors.     */
    if ( (int)hwnd > 0 )
        {
        MS_DestroyWindow(hwnd);
        if ( ((long)owner > 0) && (owner->winid == hwnd) )
            owner->winid = NULL;
        }
    else if ( ((long)owner > 0) && owner->type == W_RADIO )
        {
        /* the radio widget is not a real window but its children are, *
         * so make sure they are destroyed.            -donato         */
        for ( ix=0; ix < ((AXWidget_radio)owner)->num_buttons; ix++ )
            {
            tb = ((AXWidget_radio)owner)->buttons[ix];
            /*WXDestroyWidget(tb);*/
            if ( tb->winid )
                {
                MS_DestroyWindow(tb->winid);
                tb->winid = NULL;
                }
            }
        }

    /* remove from TotalWindowsList; this is only valid for the SS windows
     * (editline, row/col, etc...)
     */
    for ( w = TotalWindowsList; w; w = w->next )
        if ( w->win == win )
            break;
    if ( w )
        {
        REMOVE_DRAWABLE(w->win);
        if ( w->next )
            w->next->prev = w->prev;
        if ( w->prev )
            w->prev->next = w->next;
        if ( TotalWindowsList == w )
            TotalWindowsList = w->next;
        free(w);
        NumWindows--;
        }

    if ( ((long)owner > 0) && (owner->uid >= FIRST_WIDGET_ID) )
        {
        CLEAR_WIDGET_FROM_UID_LIST(owner->uid);
        owner->uid = 0;
        }
}


#if 0    /* { */
/****************************************************************************/
/* XtGet and SetValues are now generic functions located in widgtcom.c
 * I have left these old Windows versions here for historical reference.
 */
void
AxXtGetValues(register AXWidget in_widget, register Arg args[], register int cnt)
{
    register int ix;
    int attr_code;
    char msg[80];
    AXWidget_list w_list;


    if ( in_widget == (AXWidget)NULL )
        return;

    for ( ix = 0; ix < cnt; ix++ )
        {
        attr_code = args[ix].name;
        switch (attr_code)
            {
        case XXmNvalue:
            if ( in_widget->type == W_ENTER)
                {
#if BUILD_WIDE
                if ( in_widget->mb_string != (mbchar *)NULL )
                    free(in_widget->mb_string);
                in_widget->mb_string = (mbchar *)malloc(
                                            (Wstrlen(in_widget->wstr)+1)*
                                                            sizeof(wchar) );
                WToMbStr(in_widget->wstr, in_widget->mb_string);
                *((char**)(args[ix].value)) = (char *)in_widget->mb_string;
#else
                *((char**)(args[ix].value)) =
                            (char *) ((AXWidget_entry) in_widget)->wstr;
#endif
                }
            else
                *((int*)(args[ix].value)) = in_widget->value;
            break;
        case XXmNflags:
            *((int*)(args[ix].value)) = (int)(in_widget->flags & 0xffff);
            break;
        case XXmNrevstamp:
            *((int*)(args[ix].value)) = ((AXWidget_dialog)in_widget)->revstamp;
            break;
        case XXmNwidth:
            *((int*)(args[ix].value)) = in_widget->width;
            break;
        case XXmNheight:
            *((int*)(args[ix].value)) = in_widget->height;
            break;
        case XXmNx:
            *((int*)(args[ix].value)) = in_widget->xpos;
            break;
        case XXmNy:
            *((int*)(args[ix].value)) = in_widget->ypos;
            break;
        case XXmNitems:
            if ( in_widget->type == W_LIST )
                {
                *((char***)(args[ix].value)) =
                                        ((AXWidget_list)in_widget)->strs;
                }
            else if ( in_widget->type == W_ROWCOL )
                {
                *((AXWidget_pushbutton**)(args[ix].value)) =
                                        ((AXWidget_rowcol)in_widget)->buttons;
                }
            break;
        case XXmNvisibleItemCount:
            {
            if ( in_widget->type == W_LIST )
                {
                w_list = (AXWidget_list) in_widget;
                *((int*)(args[ix].value)) = 
                    wListVisibleItemCount(w_list->height, w_list->font,
                                          w_list->textShadow,
                                          w_list->list_hscroll);
                }
            else if ( in_widget->type == W_RADIO )
                *((int*)(args[ix].value)) =
                                    ((AXWidget_radio)in_widget)->num_buttons;
            //else
                //*((int*)(args[ix].value)) = in_widget->scroll_max;  /* ?? */
            break;
            }
        default:
            switch (in_widget->type)
                {
            case 0:
                /* ignore zero filled widgets */
                break;
            case W_LIST:
                w_list = (AXWidget_list)in_widget;
                switch (attr_code)
                    {
                    case XXmNitemCount:
                        *((int*)(args[ix].value)) = w_list->num_strs;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtGetValues for W_LIST called with %d"),
                                                                attr_code);
                        WXInfoMessage(msg);
                        break;
                    }  /* end of switch for listbox widget items */
                break;
            default:
                    sprintf(msg,
                        NXLT("AxXtGetValues for unknown widget type = %d"),
                                                        in_widget->type);
                    WXInfoMessage(msg);
                    break;
                }   /* end of switch for widget-type-specific items */
            }
        }
}


/*************************************************************************
function: AxXtSetValues - Write standard args
*
* This functions has two major sections;  An outer switch statement for
*   those attributes which are "generic" (ie. are part of AXWidget_any) and
*   then a per-widget-type switch as the default case for the first part to
*   deal with those attributes which are specific to a particualr widget.
*/
void AxXtSetValues(in_widget, args, cnt)
register AXWidget in_widget;
register Arg args[];
register int cnt;
{
    register int ix, j, tempint;
    AXWidget newP;
    AXWidget_any w_any;
    AXWidget_icon w_icon;
    AXWidget_list w_list;
    AXWidget_main w_main;
    AXWidget_page w_page;
    AXWidget_rect w_rect;
    AXWidget_tray w_tray;
    AXWidget_entry w_enter;
    AXWidget_popup w_popup;
    AXWidget_radio w_radio;
    AXWidget_scale w_scale;
    AXWidget_table w_table;
    AXWidget_canvas w_canvas;
    AXWidget_dialog w_dialog;
    AXWidget_ribbon w_ribbon;
    AXWidget_rowcol w_rowcol;
    AXWidget_scroll w_scroll;
    AXWidget_editbox w_editbox;
    AXWidget_splitter w_splitter;
    AXWidget_pushbutton w_button;
    AXWidget_togglebutton w_toggle;
    AXWidget_color_chooser w_choose;
    int attr_code;
    char msg[80], *p;
    int new_size, ret;


    if ( in_widget == (AXWidget)NULL )
        return;
    w_any = in_widget;
    for (ix = 0; ix < cnt; ix++)
        {
        attr_code = args[ix].name;
        switch (attr_code)
            {
        case XXmNxruler:
        case XXmNyruler:
        case XXmNoldWidget:
        case XXmNdialogStyle:
            break;
        case XXmNflags:
            SetWidgetFlags(in_widget, args[ix].value);
            break;
        case XXmNvalue:
            SetWidgetValues(in_widget, args[ix].value);
            break;
        case XXmNelfObject:
            if (!w_any->elfObject)
                w_any->elfObject = AxTaskCopyElfData(0, (data_ptr)args[ix].value);
            break;
        case XXmNfg_color:
            SetWidgetColors(in_widget, (int*)args[ix].value,
                                        args[ix].value, TRUE);
            break;
        case XXmNbg_color:
            SetWidgetColors(in_widget, (int*)args[ix].value,
                                        args[ix].value, FALSE);
            break;
        case XXmNitems:
            SetWidgetItems(in_widget, args[ix].value);
            break;
        case XXmNitemCount:
            SetWidgetItemCount(in_widget, args[ix].value);
            break;
        case XXmNactivateCallback:
        case XXmNcancelCallback:
        case XXmNvalueChangedCallback:
        case XXmNentryCallback:
        case XXmNsingleSelectionCallback:
        case XXmNdefaultActionCallback:
        case XXmNextendedSelectionCallback:
        case XXmNincrementCallback:
        case XXmNdecrementCallback:
        case XXmNpageIncrementCallback:
        case XXmNpageDecrementCallback:
        case XXmNbrowseSelectionCallback:
        case XXmNokCallback:
            w_any->callback = ((XtCallbackRec *) args[ix].value)->callback;
            w_any->callbacktag = ((XtCallbackRec *) args[ix].value)->closure;
            break;
        case XXmNaxFont:
            if ( (char *)args[ix].value != (char *)NULL )
                {
                /* we have a font name */
                w_any->font = lookupNamedFont((data_ptr)args[ix].value);
                if ( w_any->type == W_TABLE &&
                        ((AXWidget_table)w_any)->info.table )
                    {
                    TblSetFont(w_any, (data_ptr) args[ix].value);
                    }     
                }
            break;

        case XXmNshadow:
            if ( w_any->shadow )
                {
                AxTaskFreeElfData(0, w_any->shadow);
                w_any->shadow = (data_ptr)NULL;
                }
            if ( args[ix].value )
                w_any->shadow = AxTaskCopyElfData(0, (data_ptr)args[ix].value);
            break;

        case XXmNtextShadow:
            if ( w_any->textShadow )
                {
                AxTaskFreeElfData(0, w_any->textShadow);
                w_any->textShadow = (data_ptr) NULL;
                }
            if ( args[ix].value )
                {
                w_any->textShadow = AxTaskCopyElfData
                    (0, (data_ptr)args[ix].value);
                if ( w_any->type == W_TABLE &&
                        ((AXWidget_table)w_any)->info.table )
                    {
                    int xoff, yoff;
                    table_info *tp;
                    tp = (table_info *) ((AXWidget_table)w_any)->info.table;
                    if ( tp->font )
                        {
                        xmTextShadowOffsets(tp->font, &xoff, &yoff);
                        tp->char_below = tp->font->descent + yoff + 2;
                        }
                    }
                } 
            break;

        case XXmNtextColor:
            if ( w_any->textColor )
                {
                AxFreeWColor(w_any->textColor);
                }
            w_any->textColor =
                AxCreateWColor(w_any, (data_ptr)args[ix].value);
            break;
        case XXmNwidgetColor:
            if ( w_any->widgetColor )
                {
                AxFreeWColor(w_any->widgetColor);
                }
            w_any->widgetColor =
                AxCreateWColor(w_any, (data_ptr)args[ix].value);
            break;
        case XXmNreferenceFont:
            w_any->referenceFont = lookupNamedFont((data_ptr)args[ix].value);
            break;
        case XXmNcompositeLinkUp: /* dlg editor */
            addCompositeLink(w_any, WLINKUP, (AXWidget ) args[ix].value);
            break;
        case XXmNcompositeLinkDown: /* dlg editor */
            addCompositeLink(w_any, WLINKDOWN, (AXWidget ) args[ix].value);
            break;
        case XXmNinEdit: /* dlg editor */
            if (args[ix].value)
                w_any->flags |= WFLG_IN_EDIT;
            else
                w_any->flags &= ~WFLG_IN_EDIT;
            break;
        case XXmNx:
            w_any->xpos = args[ix].value;
            break;
        case XXmNy:
            w_any->ypos = args[ix].value;
            break;
        case XXmNwidth:
            w_any->width = args[ix].value;
            break;
        case XXmNheight:
            w_any->height = args[ix].value;
            break;
        case XXmNthickness:
            w_any->thickness = (short) args[ix].value;
            break;
        case XXmNIconId:
        case XXmNstyle:
            w_any->style = args[ix].value;
            break;
        case XXmNhelpStr:
            free(w_any->helpstr);
            w_any->helpstr = STRALLOC((char *)args[ix].value);
            break;  
        case XXmNrminfo:
            SetRmInfoFrmDatPtr((AXWidget_popup)w_any, (data_ptr)args[ix].value);
            break;
        case XXmNmessageString:
            if ( in_widget->type == W_RIBBON )
                {
                w_ribbon = (AXWidget_ribbon)in_widget;
                SetRibbonWString(w_ribbon, (mbchar *)args[ix].value);
                }
            else
                SetNWidgetName(in_widget, (char *) args[ix].value, MAX_NAME);
            break;
        case XXmNmultipleSelectionCallback:
            w_any->multi_pick = args[ix].value;  
            break;
        case XXmNmenuHelpWidget:
            w_any->helpid = (short) args[ix].value;
            break;
        case XXmNuseWorkColors:
            if ( (w_any->useWorkColors != (unsigned int)args[ix].value) &&
                    w_any->window )
                {
                if ( w_any->flags & WFLG_IN_EDIT )
                    XFreePixmap(Dpy, w_any->window);
                else
                    XDestroyWindow(Dpy, w_any->window);
                w_any->window = NULL;
                }
            w_any->useWorkColors = args[ix].value;
            break;
        case XXmNeventHandlers:
            setEventHandlers(w_any, (eventHandlerList *) args[ix].value);
            break;
        case XXmNminorEventNotify:
            w_any->minorEventNotify = (args[ix].value != 0);
            break;
        case XXmNelfAccess:
            w_any->elf_access = TRUE;
            break;
        case XXmNnotTransient:
            w_any->notTransient = TRUE;
            break;
        case XXmNDefaultCursor: /* default cursor on the dlg box */
            {
            Cursor lcursor = None;
            ZXmBindCursor((char*)args[ix].value, &lcursor);
            AXDefineDefaultCursor(w_any, lcursor);
            break;
            }
        case XXmNgraphic:
            if ( w_any->graphic )
                AxDestroyAssociatedGraphic(w_any->graphic);
            w_any->graphic = AxTaskCopyElfData(0,(data_ptr)args[ix].value);
            w_any->update_widget = WidgetNeedsUpdated = TRUE;
            break;
        case XXmCArmCallback:
            /* Should we do anything with this? */
            break;
        case XXmNmenuHistory:
            /* used for option menus on X, but N/A on Windows. */
            break;
        case XXmNuid:
            if ((int) args[ix].value && w_any)
                {
                int tuid = (int) (args[ix].value);
                if ( w_any->parent && (W_DIALOG == w_any->parent->type) )
                    {
                    char *notUsed;
                    AXWidget_dialog wd = (AXWidget_dialog) w_any->parent;
                    if ( !wd->uidWidgets )
                        {
                        /* init table associating uid's with AXWidget handles
                         */
                        axInitUidWidgets(wd);
                        }
                    axhGetItemI((void *) &tuid, sizeof(int), wd->uidWidgets,
                                (char *) w_any, &notUsed);
                    w_any->db_uid = tuid;
                    }
                else if (W_DIALOG == w_any->type)
                    {
                    w_any->db_uid = tuid;
                    }
                }
            break;

        default:
            switch (in_widget->type)
                {
            case 0:
                /* ignore zero filled widgets */
                break;
            case W_RECT:
                w_rect = (AXWidget_rect)in_widget;
                switch (attr_code)
                    {
                    case XXmNmessageString:
                        SetNWidgetName(in_widget, (char*)args[ix].value,
                                                                MAX_NAME);
                        if ( RECT_LABELED == w_rect->style )
                            w_rect->update_widget = WidgetNeedsUpdated = TRUE;
                        break;

                    case XXmNtablayers:
                        SetTabLayers(w_rect, (data_ptr) args[ix].value);
                        w_rect->update_widget = WidgetNeedsUpdated = TRUE;
                        break;

                    case XmNactiveTablayer:
                        if (w_rect->tabctl.active_layer != (int)args[ix].value)
                            {
                            w_rect->tabctl.active_layer = (int) args[ix].value;
                            w_rect->update_widget = WidgetNeedsUpdated = TRUE;
                            }
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_RECT called with %d"),
                                                                attr_code);
                        WXInfoMessage(msg);
                        break;
                    }  /* end of switch for rect widget items */
                break;
            case W_MAIN:
                w_main = (AXWidget_main)in_widget;
                switch (attr_code)
                    {
                    case XXmNmenuBar: 
                        break;
                    case XXmNresize:
                        w_main->variable_size = args[ix].value; 
                        break;
                    case XXmNmaxWidth:
                        w_main->maxWidth = args[ix].value;
                        break;
                    case XXmNmaxHeight:
                        w_main->maxHeight = args[ix].value;
                        break;
                    case XXmNtopmostwindow: /* override-redirect */
                        if ( w_main->dialog )
                            {
                            w_main->dialog->topmostwindow =
                                    args[ix].value ? TRUE : FALSE;
                            }
                        break;
                    case XXmNworkWindow:
                        if ( !w_main->workWindow )
                            w_main->workWindow = (AXWidget_work)(args[ix].value);
                        break;
                    case XXmNhorizontalScrollBar:
                        newP = (AXWidget)(args[ix].value);
                        SetHorizontalScrollBar((AXWidget)w_main,
                                            (AXWidget_scroll)newP);
                        break;
                    case XXmNverticalScrollBar:
                        newP = (AXWidget)(args[ix].value);
                        SetVerticalScrollBar((AXWidget)w_main,
                                            (AXWidget_scroll)newP);
                        break;
                    case XXmNcolorpal:
                        w_main->colorpal = (AXWidget_colorpal)args[ix].value;
                        break; 
                    case XXmNpalette:
                        w_main->palette = (AXWidget_palette)(args[ix].value);
                        break;
                    case XXmNplates:
                        w_main->plates = (AXWidget_plates)(args[ix].value);
                        break;
                    case XXmNruler:
                        w_main->ruler  = (AXWidget_ruler)(args[ix].value);
                        break; 
                    case XXmNminWidth:
                        w_main->minWidth = args[ix].value;
                        break;
                    case XXmNminHeight:
                        w_main->minHeight = args[ix].value;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_MAIN called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for main widget items */
                break;


            case W_DIALOG:
                w_dialog = (AXWidget_dialog)in_widget;
                switch (attr_code)
                    {
                case XXmNtopmostwindow: /* override-redirect */
                    w_dialog->topmostwindow = args[ix].value ? TRUE : FALSE;
                    break;
                case XXmNdisableElfRecord:
                    /* w is of type W_DIALOG but disable_record
                     * property sits on parent W_MAIN */
                    w_dialog->parent->disable_record = args[ix].value;
                    break;
                case XXmNnoExpand:
                    w_dialog->noExpand = args[ix].value;
                    break;
                case XXmNbackgroundImage:
                    {
                    char *im_name = NULL;
                    im_name = (char *) args[ix].value;
                    if ( !w_dialog->background_image )
                        { /* Can only be set once */
                        if ( im_name )
                            {
                            w_dialog->background_image =
                                        (char *)malloc(strlen(im_name) + 1);
                            strcpy(w_dialog->background_image, im_name);
                            }
                        }
                    break;
                    }
                case XXmNautoUnmanage:
                    w_dialog->autoUnmanage = args[ix].value;
                    break;
                case XXmNresize:
                    w_dialog->variable_size = args[ix].value; 
                    break;
                case XXmNrevstamp:
                    w_dialog->revstamp = (short) args[ix].value;
                    break; 
                case XXmNminWidth:
                    w_dialog->minWidth = args[ix].value;
                    break;
                case XXmNminHeight:
                    w_dialog->minHeight = args[ix].value;
                    break;
                case XXmNmaxWidth:
                    w_dialog->maxWidth = args[ix].value;
                    break;
                case XXmNmaxHeight:
                    w_dialog->maxHeight = args[ix].value;
                    break;
                case XXmNdefaultButton:
                    {
                    AXWidget_pushbutton old_w;

                    old_w = w_dialog->defaultButton;
                    /* Unmapping is silly! */
                    //if ( old_w )
                    //    UnMapWidget((AXWidget)old_w);
                    w_dialog->defaultButton =
                                    (AXWidget_pushbutton)(args[ix].value);
                    if ( old_w )
                        {
                        /* redraw in non-default state */
                        if ( !old_w->owner_draw )
                            old_w->value = FALSE;   /* button up */
                        PaintWidget((AXWidget)old_w);
                        }
                    }
                    break;
                case XXmNcancelButton:
                    w_dialog->cancelButton =
                                    (AXWidget_pushbutton)(args[ix].value);
                    break;
                case XXmNpokeCodes:
                    if ( ElfbIsArray((data_ptr)args[ix].value) )
                        {
                        j = ElfbArraySize((data_ptr)args[ix].value);
                        if ( w_dialog->pokeCodes )
                            free(w_dialog->pokeCodes);
                        w_dialog->pokeCodes = (long*)CreateIntsArray(j);
                        for ( j=0; j<IntsArraySize(w_dialog->pokeCodes); j++ )
                            {
                            tempint = IntFromArray((data_ptr)args[ix].value,j);
                            WriteIntsArray(w_dialog->pokeCodes,j,tempint);
                            }
                        }
                    else if ( w_dialog->pokeCodes )
                        {
                        free(w_dialog->pokeCodes);
                        w_dialog->pokeCodes = (long *) NULL;
                        }
                    break;                                          
                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_DIALOG called with %d"),
                                                                attr_code);
                    taskAbort( msg );
                    break;
                    }  /* end of switch for dialog widget items */
                break;


            case W_RADIO:
                w_radio = (AXWidget_radio)in_widget;
                switch (attr_code)
                    {
                    case XXmNupdate:
                        /*x, y, or num_buttons has changed: unmap and update.*/
                        UnMapWidget((AXWidget)w_radio);
                        new_size = args[ix].value;
                        /* free extra buttons if num_buttons has decreased */
                        if ( (new_size>0) && (new_size<w_radio->num_buttons) )
                            {
                            for ( j=new_size; j < w_radio->num_buttons; j++ )
                                WXDestroyWidget((AXWidget)w_radio->buttons[j]);
                            w_radio->num_buttons = new_size;
                            w_radio->buttons = (AXWidget_togglebutton*)realloc(
                                                w_radio->buttons,
                                                w_radio->num_buttons*
                                                sizeof(AXWidget_togglebutton));
                            }
                        /* reset widths and heights; will be updated when *
                         * buttons created in AXmCreateToggleButtonGadget */
                        w_radio->width = 0;
                        w_radio->height = 0;
                        for ( j=0; j < w_radio->num_buttons; j++ )
                            {
                            w_radio->buttons[j]->width = 0;
                            w_radio->buttons[j]->height = 0;
                            }
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_RADIO called with %d"),
                                                                attr_code);
                        taskAbort( msg );
                        break;
                    }  /* end of switch for radio box widget items */
                break;


            case W_ENTER:
                w_enter = (AXWidget_entry)in_widget;
                switch (attr_code)
                    {
                    case XXmNcolumns:
                        w_enter->width = wEnterPixWidth(args[ix].value,
                                        w_enter->font, w_enter->textShadow);
                        break;
                    case XXmNmaxLength:
                        /* for entry fields */
                        w_enter->maxLen = (short) args[ix].value;
                        break;
                    case XXmNtextOptions:
                        free(w_enter->validChars);
                        w_enter->validChars = 0; /* in case next test fails */
                        if ( args[ix].value )
                            {
                            w_enter->validChars =
                                strcpy((char *)malloc(
                                            strlen((char *)args[ix].value)+1),
                                                    (char *)args[ix].value);
                            }
                        break;
                    case XXmNmonospaceFont:
                        if ( args[ix].value )
                            {
                            if ( w_enter->monospace_font == FALSE )
                                {
                                w_enter->update_widget =
                                                WidgetNeedsUpdated = TRUE;
                                /* force a full-regen */
                                xmlibStr.FullRegenForUpdate = TRUE;
                                }
                            w_enter->monospace_font = TRUE;
                            } 
                        else
                            {
                            if ( w_enter->monospace_font == TRUE )
                                {
                                w_enter->update_widget =
                                                WidgetNeedsUpdated = TRUE;
                                /* force a full-regen */
                                xmlibStr.FullRegenForUpdate = TRUE;
                                }
                            w_enter->monospace_font = FALSE;
                            }
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_ENTER called with %d"),
                                                                attr_code);
                        taskAbort( msg );
                        break;
                    }  /* end of switch for enter widget items */
                break;


            case W_EDITBOX:
                w_editbox = (AXWidget_editbox)in_widget;
                switch (attr_code)
                    {
                    case XXmNmaxLength:
                        /* for entry fields */
                        w_editbox->maxLen = (short) args[ix].value;
                        break;
                    case XXmNno_picks:
                        w_editbox->no_picks = args[ix].value;
                        break;
                    case XXmNnoPrimarySeln:
                        w_editbox->no_primary_seln = args[ix].value;
                        break;  
                    case XXmNmonospaceFont:
                        if ( args[ix].value )
                            {
                            if ( w_editbox->monospace_font == FALSE )
                                {
                                w_editbox->update_widget =
                                                WidgetNeedsUpdated = TRUE;
                                /* force a full-regen */
                                xmlibStr.FullRegenForUpdate = TRUE;
                                }
                            w_editbox->monospace_font = TRUE;
                            } 
                        else
                            {
                            if ( w_editbox->monospace_font == TRUE )
                                {
                                w_editbox->update_widget =
                                                WidgetNeedsUpdated = TRUE;
                                /* force a full-regen */
                                xmlibStr.FullRegenForUpdate = TRUE;
                                }
                            w_editbox->monospace_font = FALSE;
                            }
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_EDITBOX called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for editbox widget items */
                break;


            case W_SPLITTER:
                w_splitter = (AXWidget_splitter)in_widget;
                switch (attr_code)
                    {
                    case XXmNmaxHeight:
                        w_splitter->maxHeight = args[ix].value;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_SPLITTER called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for splitter widget items */
                break;


            case W_TOGGLE:
                w_toggle = (AXWidget_togglebutton)in_widget;
                switch (attr_code)
                    {
                    case XXmNset:
                        if ( args[ix].value )
                            SetRadioValue(w_toggle, FALSE);
                        w_toggle->value = args[ix].value;
                        break;
                    case XXmNsmallFont:
                        w_toggle->small_font = TRUE; //args[ix].value; ?
                        break;
                    case XXmNwhichButton:
                        w_toggle->whichButton = args[ix].value;
                        break;
                    case XXmNorientation:
                        /*    note:
                         *    for W_TOGGLE, holds 0 or THREE_STATE_TOGGLE
                         *    to indicate whether or not toggle is
                         *    a three-state-toggle-button.
                         */
                        w_toggle->scroll_type = (short) args[ix].value;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_TOGGLE called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for toggle widget items */
                break;


            case W_PAGEBAR:
                w_page = (AXWidget_page)in_widget;
                switch (attr_code)
                    {
                    case XXmNmaximum:
                        w_page->scroll_max = args[ix].value;
                        w_page->update_widget = WidgetNeedsUpdated = TRUE;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_PAGEBAR called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for pagebar widget items */
                break;


            case W_SCROLL:
                w_scroll = (AXWidget_scroll)in_widget;
                switch (attr_code)
                    {
                    case XXmNbuttonUpScroll:
                        w_scroll->buttonUpScroll = args[ix].value;
                        break;
                    case XXmNmaximum:
                        w_scroll->scroll_max = args[ix].value;
                        w_scroll->update_widget = WidgetNeedsUpdated = TRUE;
                        if ( w_scroll->winid != (HWND)NULL )
                           {
                           /* tell windows that the max value has changed */
                           ret = MS_SetScrollRange( w_scroll->winid, SB_CTL, 
                                   0, w_scroll->scroll_max, TRUE );
                           if ( !ret )
                              {
                              ret = MS_GetLastError();
                              tempAbort("SetScrollRange fails");
                              }
                           }
                        break;
                    case XXmNorientation:
                        w_scroll->scroll_type = (short) args[ix].value;
                        break;
                    case XXmNsliderSize:
                        w_scroll->scroll_per = args[ix].value;
                        w_scroll->update_widget = WidgetNeedsUpdated = TRUE;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_SCROLL called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for scroll widget items */
                break;


            case W_RIBBON:
                w_ribbon = (AXWidget_ribbon)in_widget;
                switch (attr_code)
                    {
                case XXmNpixmap:
                    if ( w_ribbon->pixmap != (Pixmap) args[ix].value )
                        {
                        if ( w_ribbon->pixmap )
                            AxFreePixmap(w_ribbon->pixmap);
                        w_ribbon->pixmap = (Pixmap) args[ix].value;
                        }
                    break;
                case XXmNsliderSize:
                    w_ribbon->scroll_per = args[ix].value;
                    w_ribbon->update_widget = WidgetNeedsUpdated = TRUE;
                    break;
                case XXmNmaximum:
                    w_ribbon->scroll_max = args[ix].value;
                    w_ribbon->update_widget = WidgetNeedsUpdated = TRUE;
                    break;
                /* for W_LIST, must be before selectedItems */
                case XXmNselectedItemCount:
                    free(w_ribbon->selections);
                    w_ribbon->selections = CreateIntsArray(args[ix].value);
                    break;
                case XXmNselectedItems:
                    if ( w_ribbon->elf_access )
                        {
                        if ( ElfbIsArray((data_ptr)args[ix].value) )
                            {
                            for ( j=0; j < IntsArraySize(w_ribbon->selections); j++ )
                                {
                                tempint = IntFromArray(
                                            (data_ptr)args[ix].value, j);
                                WriteIntsArray(w_ribbon->selections,j,tempint);
                                }
                            }
                        else
                            {
                            tempint = IntFromDataPtr((data_ptr)args[ix].value);
                            WriteIntsArray(w_ribbon->selections, 0, tempint);
                            }
                        }
                    else
                        {
                        WriteIntsArray(w_ribbon->selections, 0,
                                                args[ix].value);
                        }
                    w_ribbon->update_widget = TRUE;
                    WidgetNeedsUpdated = TRUE;
                    break;
                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_RIBBON called with %d"),
                                                                attr_code);
                    taskAbort(msg);
                    break;
                    }  /* end of switch for ribbon widget items */
                break;


            case W_POPUP:
                w_popup = (AXWidget_popup)in_widget;
                switch (attr_code)
                    {
                    case XXmNwhichButton:
                        w_popup->whichButton = args[ix].value;
                        break;
                    case XXmNlabelPixmap:
                        w_popup->pixmapLabel = args[ix].value;
                        break;
                    case XXmNalternatePixmap:
                        p = (char*)args[ix].value;
                        free(w_popup->alternatePixmap);
                        if ( p )
                            w_popup->alternatePixmap =
                                            strcpy(malloc(strlen(p)+1),p);
                        else
                            w_popup->alternatePixmap = (char *)NULL;
                        break;
                    case XXmNgePaletteButtonType:
                        w_popup->gePaletteButtonType = args[ix].value;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_POPUP called with %d"),
                                                                attr_code);
                        WXInfoMessage(msg);
                        break;
                    }  /* end of switch for popup widget items */
                break;


            case W_BUTTON:
                w_button = (AXWidget_pushbutton)in_widget;
                switch (attr_code)
                    {
                    case XXmNpixmap:
                        w_button->pixmap = (Pixmap)args[ix].value;
                        break;
                    case XXmNlabelPixmap:
                        w_button->pixmapLabel = args[ix].value;
                        break;
                    case XXmNgePaletteButtonType:
                        w_button->gePaletteButtonType = args[ix].value;
                        break;
                    case XXmNsmallFont:
                        w_button->small_font = TRUE;
                        break;
                    case XXmNwhichButton:
                        w_button->whichButton = args[ix].value;
                        break;
                    case XXmNalternatePixmap:
                        p = (char*)args[ix].value;
                        free(w_button->alternatePixmap);
                        if ( p )
                            w_button->alternatePixmap =
                                        strcpy(malloc(strlen(p)+1),p);
                        else
                            w_button->alternatePixmap = (char *)NULL;
                        break;
                    case XXmNbuttonType:
                        w_button->buttonType = (short) args[ix].value;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_BUTTON called with %d"),
                                                                attr_code);
                        WXInfoMessage(msg);
                        break;
                    }  /* end of switch for button widget items */
                break;


            case W_LIST:
                w_list = (AXWidget_list)in_widget;
                switch (attr_code)
                    {
                /* FOR NOW. these seem to be obsolete! */
                case XXmNlistSizePolicy:
                case XXmNscrollBarDisplayPolicy:
                case XXmNautomaticSelection:
                    break;
                case XXmNcurPos:
                    /* save old curPos in maxWidth */
                    //w_list->maxWidth = w_list->curPos;
                    /* box_marker_value */
                    //w_list->curPos = (short) args[ix].value;
                    break;
                case XXmNno_picks:
                    w_list->no_picks = args[ix].value;
                    break;
                case XXmNbuttonUpScroll:
                    w_list->buttonUpScroll = args[ix].value;

                    /* set attribute on scrollbars as well */
                    if ( w_list->hScrollBar )
                        w_list->hScrollBar->buttonUpScroll = args[ix].value;
                    if ( w_list->vScrollBar )
                        w_list->vScrollBar->buttonUpScroll = args[ix].value;
                    break;
                case XXmNdoubleClickInterval:
                    /* do we need this on NT? */
                    w_list->double_click = args[ix].value;
                    break;
                case XXmNresize:
                    if ( args[ix].value )
                        {
                        /* force recompute scrollbar geometry */
                        UnMapWidget((AXWidget)w_list); /* destroy window */
                        if ( w_list->vScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_list->vScrollBar);
                            w_list->vScrollBar = (AXWidget_scroll)NULL;
                            }
                        if ( w_list->hScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_list->hScrollBar);
                            w_list->hScrollBar = (AXWidget_scroll)NULL;
                            }
                        }
                    break;
                case XXmNhideListVScroll:
                    w_list->hide_vscroll = args[ix].value;
                    break;
                case XXmNlistHScroll:
                    if ( w_list->list_hscroll != (unsigned int)args[ix].value )
                        {
                        w_list->list_hscroll = args[ix].value;
                        if ( w_list->list_hscroll )
                            {
                            /* get max text width */
                            if ( w_list->maxLen == 0 )
                                {
                                /* other cases handled in XmNitems */
                                w_list->maxLen =
                                            (short) ListStrsMaxWidth(w_list);
                                }
                            }
                        else
                            w_list->maxLen = 0;
                        }
                    break;
                /* for W_LIST, must be before selectedItems */
                case XXmNselectedItemCount:
                    free(w_list->selections);
                    w_list->selections = CreateIntsArray(args[ix].value);
                    break;
                case XXmNselectedItems:
                    if ( w_list->elf_access )
                        {
                        if ( ElfbIsArray((data_ptr)args[ix].value) )
                            {
                            for (j=0; j<IntsArraySize(w_list->selections); j++)
                                {
                                tempint = IntFromArray(
                                            (data_ptr)args[ix].value, j);
                                WriteIntsArray(w_list->selections,j,tempint);
                                }
                            }
                        else
                            {
                            tempint = IntFromDataPtr((data_ptr)args[ix].value);
                            WriteIntsArray(w_list->selections,0,tempint);
                            }
                        }
                    else
                        {
                        WriteIntsArray(w_list->selections, 0, args[ix].value);
                        }
                    w_list->update_widget = TRUE;
                    WidgetNeedsUpdated = TRUE;
                    break;
                case XXmNmaximum:
                    w_list->scroll_max = args[ix].value;
                    w_list->update_widget = WidgetNeedsUpdated = TRUE;
                    break;
                case XXmNvisibleItemCount:
                    w_list->scroll_max = args[ix].value;
                    w_list->height = wListPixHeight(args[ix].value,
                                                    w_list->font,
                                                    w_list->textShadow,
                                                    w_list->list_hscroll);
                    break;
                case XXmNmonospaceFont:
                    if ( args[ix].value )
                        {
                        if ( w_list->monospace_font == FALSE )
                            {
                            w_list->update_widget =
                                            WidgetNeedsUpdated = TRUE;
                            /* force a full-regen */
                            xmlibStr.FullRegenForUpdate = TRUE;
                            }
                        w_list->monospace_font = TRUE;
                        } 
                    else
                        {
                        if ( w_list->monospace_font == TRUE )
                            {
                            w_list->update_widget =
                                            WidgetNeedsUpdated = TRUE;
                            /* force a full-regen */
                            xmlibStr.FullRegenForUpdate = TRUE;
                            }
                        w_list->monospace_font = FALSE;
                        }
                    break;
                case XXmNforce_list_item_display:
                    w_list->force_list_item_display = TRUE;
                    w_list->update_widget = TRUE;
                    WidgetNeedsUpdated = TRUE;
                    break; 
                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_LIST called with %d"),
                                                                attr_code);
                    WXInfoMessage(msg);
                    break;
                    }  /* end of switch for listbox widget items */
                break;


            case W_TRAY:
                w_tray = (AXWidget_tray)in_widget;
                switch (attr_code)
                    {
                case XXmNhideListVScroll:
                    w_tray->hide_vscroll = args[ix].value;
                    break;
                case XXmNlistHScroll:
                    if ( w_tray->list_hscroll != (unsigned int)args[ix].value )
                        {
                        w_tray->list_hscroll = args[ix].value;
                        if ( w_tray->list_hscroll )
                            {
                            /* get max text width */
                            if ( w_tray->maxLen == 0 )
                                {
                                /* other cases handled in XmNitems */
                                w_tray->maxLen = 0;
                                }
                            }
                        else
                            w_tray->maxLen = 0;
                        }
                    break;
                case XXmNresize:
                    if ( args[ix].value )
                        {
                        /* force recompute scrollbar geometry */
                        UnMapWidget((AXWidget)w_tray); /* destroy window */
                        if ( w_tray->vScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_tray->vScrollBar);
                            w_tray->vScrollBar = (AXWidget_scroll)NULL;
                            }
                        if ( w_tray->hScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_tray->hScrollBar);
                            w_tray->hScrollBar = (AXWidget_scroll)NULL;
                            }
                        }
                    break;
                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_TRAY called with %d"),
                                                                attr_code);
                    WXInfoMessage(msg);
                    break;
                    }  /* end of switch for tray widget items */
                break;


            case W_CANVAS:
                w_canvas = (AXWidget_canvas)in_widget;
                switch (attr_code)
                    {
                case XXmNhideListVScroll:
                    w_canvas->hide_vscroll = args[ix].value;
                    break;
                case XXmNlistHScroll:
                    if ( w_canvas->list_hscroll !=
                            (unsigned int)args[ix].value )
                        {
                        w_canvas->list_hscroll = args[ix].value;
                        if ( w_canvas->list_hscroll )
                            {
                            /* get max text width */
                            if ( w_canvas->maxLen == 0 )
                                {
                                /* other cases handled in XmNitems */
                                w_canvas->maxLen = 0;
                                }
                            }
                        else
                            w_canvas->maxLen = 0;
                        }
                    break;
                case XXmNresize:
                    if ( args[ix].value )
                        {
                        /* force recompute scrollbar geometry */
                        UnMapWidget((AXWidget)w_canvas); /* destroy window */
                        if ( w_canvas->vScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_canvas->vScrollBar);
                            w_canvas->vScrollBar = (AXWidget_scroll)NULL;
                            }
                        if ( w_canvas->hScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_canvas->hScrollBar);
                            w_canvas->hScrollBar = (AXWidget_scroll)NULL;
                            }
                        }
                    break;
                    
                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_CANVAS called with %d"),
                                                                attr_code);
                    WXInfoMessage(msg);
                    break;
                    }  /* end of switch for canvas widget items */
                break;


            case W_ICON:
                w_icon = (AXWidget_icon)in_widget;
                switch (attr_code)
                    {
                    case XXmNmaxWidth:
                        w_icon->maxWidth = args[ix].value;
                        break;
                    case XXmNmaxHeight:
                        w_icon->maxHeight = args[ix].value;
                        break;
                    case XXmNpixmap:
                        w_icon->pixmap = (Pixmap)args[ix].value;
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_ICON called with %d"),
                                                                attr_code);
                        taskAbort(msg);
                        break;
                    }  /* end of switch for icon widget items */
                break;


            case W_SCALE:
                w_scale = (AXWidget_scale)in_widget;
                switch (attr_code)
                    {
                    case XXmNminValue:
                        w_scale->minValue = args[ix].value;
                        break;
                    case XXmNmaxValue:
                        w_scale->maxValue = args[ix].value;
                        break;
                    case XXmNno_label:
                        w_scale->no_label = (args[ix].value != 0);
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_SCALE called with %d"),
                                                                attr_code);
                        WXInfoMessage(msg);
                        break;
                    }  /* end of switch for scale widget items */
                 break;


            case W_ROWCOL:
                w_rowcol = (AXWidget_rowcol)in_widget;
                switch (attr_code)
                    {
                    case XXmNpfg_color:
                        w_rowcol->color = (int) args[ix].value;
                        w_rowcol->update_widget = WidgetNeedsUpdated = TRUE;
                        break;
                    case XXmNpbg_color:
                        w_rowcol->bg_color = (int) args[ix].value;
                        w_rowcol->update_widget = WidgetNeedsUpdated = TRUE;
                        break;
                    case XXmNwhichButton:
                        w_rowcol->whichButton = args[ix].value;
                        break;
                    case XXmNminValue:
                        w_rowcol->minValue = args[ix].value;
                        break;
                    case XXmNmaxValue:
                        w_rowcol->maxValue = args[ix].value;
                        break;
                    case XXmNalternatePixmap:
                        p = (char*)args[ix].value;
                        free(w_rowcol->alternatePixmap);
                        if ( p )
                            w_rowcol->alternatePixmap =
                                            strcpy(malloc(strlen(p)+1),p);
                        else
                            w_rowcol->alternatePixmap = (char *)NULL;
                        break;
                    case XXmNgePaletteButtonType:
                        w_rowcol->gePaletteButtonType = args[ix].value;
                        break;
                    case XXmNorientation:
                        /* note:  for W_ROWCOL, this field holds the
                         *               number of columns hint.
                         */
                        w_rowcol->scroll_type = (short) args[ix].value;
                        break;
                    case XXmNsliderSize:
                        /* for W_ROWCOL, 0 means normal pixmap buttons. *
                         * != 0 means text buttons (for eqn editor).    */
                        w_rowcol->scroll_per = args[ix].value;
                        break;
                    case XXmNlabelPixmap:
                        w_rowcol->pixmapLabel = args[ix].value;
                        break;
                    case XXmNbtnPixmapList:
                        SetButtonPixmaps(w_rowcol, (char**)args[ix].value);
                        break;
                    default:
                        sprintf(msg,
                            NXLT("AxXtSetValues for W_ROWCOL called with %d"),
                                                                attr_code);
                        WXInfoMessage(msg);
                        break;
                    }  /* end of switch for rowcol widget items */
                break;


            case W_CHOOSE:
                w_choose = (AXWidget_color_chooser)in_widget;
                switch (attr_code)
                    {
                case XXmNhideListVScroll:
                    w_choose->hide_vscroll = args[ix].value;
                    break;
                case XXmNlistHScroll:
                    if ( w_choose->list_hscroll !=
                            (unsigned int)args[ix].value )
                        {
                        w_choose->list_hscroll = args[ix].value;
                        if ( w_choose->list_hscroll )
                            {
                            /* get max text width */
                            if ( w_choose->maxLen == 0 )
                                {
                                /* other cases handled in XmNitems */
                                w_choose->maxLen = 0;
                                }
                            }
                        else
                            w_choose->maxLen = 0;
                        }
                    break;
                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_CHOOSE called with %d"),
                                                                attr_code);
                    WXInfoMessage(msg);
                    break;
                    }  /* end of switch for color chooser widget items */
                break;


            case W_TABLE:
                w_table = (AXWidget_table)in_widget;
                switch (attr_code)
                    {
                /* the following group of things is for table widgets.  */
                /* The cases are designed to fall through to make one */
                /* generic function call */
                case XXmNmarkerWidth:
                case XXmNallowHiddenColumns:
                case XXmNallowColumnResizing:
                case XXmNsuppressRowMarkers:
                case XXmNallowColumnReordering:
                case XXmNhideVerticalGrid:
                case XXmNhideHorizontalGrid:
                case XXmNuseDataRequestModel:
                case XXmNalisStyleScroll:
                case XXmNvscrollOrigin:
                case XXmNvscrollLength:
                case XXmNhscrollOrigin:
                case XXmNhscrollLength:
                case XXmNshowRowNumbers:
                case XXmNRowColCreate:
                    SetTableAttributes(w_table, attr_code, args[ix].value);
                    break;
                case XXmNhideListVScroll:
                    w_table->hide_vscroll = args[ix].value;
                    break;
                case XXmNlistHScroll:
                    if ( w_table->list_hscroll !=
                            (unsigned int)args[ix].value )
                        {
                        w_table->list_hscroll = args[ix].value;
                        if ( w_table->list_hscroll )
                            {
                            /* get max text width */
                            if ( w_table->maxLen == 0 )
                                {
                                /* other cases handled in XmNitems */
                                w_table->maxLen = 0;
                                }
                            }
                        else
                            w_table->maxLen = 0;
                        }
                    break;
                case XXmNbuttonUpScroll:
                    /* This attribute is applicable to child scrollbars *
                     * of the table and list widgets.  The table/list   *
                     * might not have scrollbars at this point.  We     *
                     * therefore generically set `buttonUpScroll' here. *
                     * The table/list widgets will propogate this value *
                     * to their scrollbars at Realize() time.           */
                    w_table->buttonUpScroll = args[ix].value;
                    if ( w_table->hScrollBar )
                        w_table->hScrollBar->buttonUpScroll = args[ix].value;
                    if ( w_table->vScrollBar )
                        w_table->vScrollBar->buttonUpScroll = args[ix].value;
                    break;
                case XXmNmaximum:
                    w_table->scroll_max = args[ix].value;
                    w_table->update_widget = WidgetNeedsUpdated = TRUE;
                    break;
                case XXmNresize:
                    if (args[ix].value)
                        {
                        /* force recompute scrollbar geometry */
                        UnMapWidget((AXWidget)w_table); /* destroy window */
                        if ( w_table->vScrollBar )
                            {
                            AxDestroyWidget((AXWidget)w_table->vScrollBar);
                            w_table->vScrollBar = (AXWidget_scroll)NULL;
                            }
                        if (w_table->hScrollBar)
                            {
                            AxDestroyWidget((AXWidget)w_table->hScrollBar);
                            w_table->hScrollBar = (AXWidget_scroll)NULL;
                            }
                        }
                    break;
                case XXmNhorizontalScrollBar:
                    newP = (AXWidget)(args[ix].value);
                    SetHorizontalScrollBar((AXWidget)w_table,
                                        (AXWidget_scroll)newP);
                    break;
                case XXmNverticalScrollBar:
                    newP = (AXWidget)(args[ix].value);
                    SetVerticalScrollBar((AXWidget)w_table,
                                        (AXWidget_scroll)newP);
                    break;
                case XXmNvisibleItemCount:
                    w_table->scroll_max = args[ix].value;
                    w_table->height = wTablePixHeight(args[ix].value,
                                                      w_table->thickness);
                    break;

                case XXmNlabelColor:
                    if ( w_table->info.table )
                        {
                        table_info *tp = (table_info *) w_table->info.table;
                        if ( tp->headingColor )
                            AxFreeWColor(tp->headingColor);
                        tp->headingColor =
                            AxCreateWColor(w_table, (data_ptr)args[ix].value);
                        }
                    break;

                case XXmNlabelFont:
                    if ( w_table->info.table)
                        {
                        table_info *tp;
                        tp = (table_info *) w_table->info.table;
                        if (tp)
                            {
                            tp->headingFont =
                                    lookupNamedFont((data_ptr)args[ix].value);
                            if ( tp->headingFont )
                                {
                                tp->heading_char_above =
                                    tp->headingFont->ascent;
                                tp->heading_char_below =
                                    tp->headingFont->descent;
                                tp->heading_char_height =
                                    tp->headingFont->ascent +
                                        tp->headingFont->descent;
                                }
                            tp->headingHeight =
                                TblComputeHeadingHeight(w_table);
                            tp->numLines = TblComputeNumLines(w_table);
                            }
                        }
                    break;

                case XXmNlabelShadow:
                    if ( w_table->info.table )
                        {
                        table_info *tp = (table_info *) w_table->info.table;
                        if ( tp->headingShadow )
                            {
                            AxTaskFreeElfData(0, tp->headingShadow);
                            tp->headingShadow = (data_ptr) NULL;
                            }
                        if ( args[ix].value )
                            {
                            tp->headingShadow =
                                    AxTaskCopyElfData
                                        (0, (data_ptr)args[ix].value);
                            if ( tp->headingFont )
                                {
                                int xoff, yoff;
                                xmTextShadowOffsets(tp->headingFont,
                                                    &xoff, &yoff);
                                tp->heading_char_below =
                                        tp->headingFont->descent + yoff + 2;
                                }
                            }
                        }
                    break;

                default:
                    sprintf(msg,
                            NXLT("AxXtSetValues for W_TABLE called with %d"),
                                                                attr_code);
                    WXInfoMessage(msg);
                    break;
                    }  /* end of switch for table widget items */
                break;

            default:
                sprintf(msg, NXLT("AxXtSetValues for unknown widget type = %d"),
                                                            in_widget->type);
                WXInfoMessage(msg);
                break;
                }   /* end of switch for widget-type-specific items */
            }  /* end of switch for generic items */
        }   /* end of "for each item */
}
/****************************************************************************/
#endif    /* } #if 0 */




/********************************************************************
 *  AxGetHDCFromHWND - get hdc given hwnd for TotalWindowsList
 *
 */
Window AxGetHDCFromHWND(hwnd)
HWND hwnd;
{
    win_list_t *w;

    for ( w = TotalWindowsList; w; w = w->next )
    {
        if ( w->hwnd == hwnd )
            return (w->win);
    }
    return(NULL);
}


/*****************************************************************
* function: GetSimpleWindowHandles - retrieve simple window handles
*                                     from the TotalWindowsList
**/                                   
void GetSimpleWindowHandles(parent_hwnd, row_win, col_win, edit_win)
HWND parent_hwnd;
HWND *row_win, *col_win, *edit_win;
{
    int count;
    HWND tmp_row = NULL,
         tmp_col = NULL,
         tmp_edit = NULL;   /* window handle guesses */
    RECT win_rect;
    win_list_t *w;
    POINT point;

    count = 0;
    for ( w=TotalWindowsList; w; w=w->next )
        {
        if ( w->parentHwnd == parent_hwnd )
            {
            if ( count <= 0 )
                tmp_row = w->hwnd;
            else if ( count == 1 )
                tmp_col = w->hwnd;
            else
                tmp_edit = w->hwnd;
            count++;
            }
        }

    /* at this point we have the simple window handles, *
     * but we don't know which belongs to which window. */
    MS_GetWindowRect( tmp_row, &win_rect );
    point.x = win_rect.left;
    point.y = win_rect.top;
    MS_ScreenToClient( parent_hwnd, &point );
    if ( point.x == 0 && point.y > 20 )    /* HACK */
        /* this must be the row window */
        *row_win = tmp_row;
    else if ( point.y == 0 )
        /* this must be the edit window */
        *edit_win = tmp_row;
    else
        /* must be the column window */
        *col_win = tmp_row;

    MS_GetWindowRect( tmp_col, &win_rect );
    point.x = win_rect.left;
    point.y = win_rect.top;
    MS_ScreenToClient( parent_hwnd, &point );
    if ( point.x == 0 && point.y > 20 )    /* HACK */
        /* this must be the row window */
        *row_win = tmp_col;
    else if ( point.y == 0 )
        /* this must be the edit window */
        *edit_win = tmp_col;
    else
        /* must be the column window */
        *col_win = tmp_col;

    MS_GetWindowRect( tmp_edit, &win_rect );
    point.x = win_rect.left;
    point.y = win_rect.top;
    MS_ScreenToClient( parent_hwnd, &point );
    if ( point.x == 0 && point.y > 20 )    /* HACK */
        /* this must be the row window */
        *row_win = tmp_edit;
    else if ( point.y == 0 )
        /* this must be the edit window */
        *edit_win = tmp_edit;
    else
        /* must be the column window */
        *col_win = tmp_row;
}


#if 0
Pixmap GetInversePixmap(old_pixmap)
Pixmap old_pixmap;
{
    int i, bytesize, bytewidth, image_size;
    Pixmap new_pixmap;
    XImage *ximage;


    ximage = BitmapToXImage(old_pixmap, FALSE);
    image_size = ximage->bitmap_info->bmiHeader.biSizeImage;

    for ( i=0; i < image_size; i++ )
        ximage->data[i] = ~ximage->data[i];

    new_pixmap = MS_CreateBitmap(ximage->width, ximage->height, 1, 1,
                                                                ximage->data);
                                              
    XDestroyImage(ximage);
    return(new_pixmap);
}

unsigned long GetColorFromPixelValue(pixel_val)
UINT pixel_val;
{
    BYTE r, g, b;
    HPALETTE hpal;
    PALETTEENTRY pal_entry[1];

    hpal = MS_GetStockObject( DEFAULT_PALETTE );
    GetPaletteEntries( hpal, pixel_val, 1, pal_entry );

    r = pal_entry[0].peRed;
    g = pal_entry[0].peGreen;
    b = pal_entry[0].peBlue;

    return( RGB(r,g,b) );
}
#endif
    


void
GetRadialPoints(int x, int y, int width, int height, int angle,
                                int *x_radial, int *y_radial)
{
    int x_center, y_center, segment;
    double pi = 3.1415926535;
    double angle_in_radians;

    x_center = x + (width/2);
    y_center = y + (height/2);
 
    switch (angle)
        {
        case 0:
            *x_radial = x + width;
            *y_radial = y + (height/2);
            break;
        case 45:
            *x_radial = x + width;
            *y_radial = y;
            break;
        case 90:
            *x_radial = x + (width/2);
            *y_radial = y;
            break;
        case 135:
            *x_radial = x;
            *y_radial = y;
            break;
        case 180:
            *x_radial = x;
            *y_radial = y + (height/2);
            break;
        case 225:
            *x_radial = x;
            *y_radial = y + height;
            break;
        case 270:
            *x_radial = x + (width/2);
            *y_radial = y + height;
            break;
        case 315:
            *x_radial = x + width;
            *y_radial = y + height;
            break;
        case 360:
            *x_radial = x + width;
            *y_radial = y + (height/2);
            break;

        default:
            if ( angle > 0 && angle < 45 )
                {
                angle_in_radians = pi * (angle/180);
                segment = sin(angle_in_radians) * (width/2);
                *x_radial = x + width;
                *y_radial = y_center - segment;
                }
            else if ( angle > 45 && angle < 90 )
                {
                angle_in_radians = pi * ( (90-angle)/180 );
                segment = sin(angle_in_radians) * (height/2);
                *x_radial = x_center + segment;
                *y_radial = y;
                }
            else if ( angle > 90 && angle < 135 )
                {
                angle_in_radians = pi * ( (angle-90)/180 );
                segment = sin(angle_in_radians) * (height/2);
                *x_radial = x_center - segment;
                *y_radial = y;
                }
            else if ( angle > 135 && angle < 180 )
                {
                angle_in_radians = pi * ( (180-angle)/180 );
                segment = sin(angle_in_radians) * (width/2);
                *x_radial = x;
                *y_radial = y_center - segment;
                }
            else if ( angle > 180 && angle < 225 )
                {
                angle_in_radians = pi * ( (angle-180)/180 );
                segment = sin(angle_in_radians) * (width/2);
                *x_radial = x;
                *y_radial = y_center + segment;
                }
            else if ( angle > 225 && angle < 270 )
                {
                angle_in_radians = pi * ( (270-angle)/180 );
                segment = sin(angle_in_radians) * (height/2);
                *x_radial = x_center - segment;
                *y_radial = y + height;
                }
            else if ( angle > 270 && angle < 315 )
                {
                angle_in_radians = pi * ( (angle-270)/180 );
                segment = sin(angle_in_radians) * (height/2);
                *x_radial = x_center + segment;
                *y_radial = y + height;
                }
            else if ( angle > 315 && angle < 360 )
                {
                angle_in_radians = pi * ( (360-angle)/180 );
                segment = sin(angle_in_radians) * (width/2);
                *x_radial = x + width;
                *y_radial = y_center + segment;
                }                        
            else
                {  /* default to zero, for now? */
                *x_radial = 0;
                *y_radial = 0;
                }
            break;
        }
}



HCURSOR
CreateWinCursor(XImage *ximage, XImage *mask, XColor *fore, XColor *back,
                                                            int x, int y)
{
    int i, j;
    unsigned char *and_bits, *xor_bits;
    unsigned char *sourceP, *destP;
    unsigned char *mask_sourceP, *image_sourceP;
    unsigned int ax_byte_wid, size_win_im, win_byte_wid;
    HCURSOR cursor;

    /* we "clear" the "AND" bits to ones; see truth table below. */
    and_bits = (char*)TrueMalloc(CursorImageSize*sizeof(char));
    memset(and_bits, 0xFF, (CursorImageSize*sizeof(char)));
    /* we "clear" the "XOR" bits to zeros; see truth table below. */
    xor_bits = (char*)TrueMalloc(CursorImageSize*sizeof(char));
    memset(xor_bits, 0x00, (CursorImageSize*sizeof(char)));

    ax_byte_wid = ximage->bytes_per_line;
    if ( (ax_byte_wid % 4) != 0 )
        {
        /* image is not 4-byte padded, so make sure it is. */
        win_byte_wid = ((ax_byte_wid + 3)/4 ) * 4;
        }
    else
        win_byte_wid = ax_byte_wid;
    size_win_im = win_byte_wid * ximage->height;

    sourceP = mask->data;
    if ( !sourceP )
        sourceP = ximage->data;
    for ( i=0; i < ximage->height; i++ )
        {
        destP = and_bits + (i * win_byte_wid);
        for ( j=0; j < (int)ax_byte_wid; j++ )
            {
            /* note, we invert the source; see comment below. */
            *destP++ = ~(*sourceP++);
            }
        }

    mask_sourceP = mask->data;
    if ( !mask_sourceP )
        mask_sourceP = ximage->data;
    image_sourceP = ximage->data;
    for ( i=0; i < ximage->height; i++ )
        {
        destP = xor_bits + (i * win_byte_wid);
        for ( j=0; j < (int)ax_byte_wid; j++ )
            {
            /* note, we XOR the source with the mask; see comment below. */
            *destP++ = *image_sourceP++ ^ *mask_sourceP++;
            }
        }

    /* the Windows CreateCursor call requires AND and XOR bits.   *
     * so we must invert the bits of the mask data so that there  *
     * are zeros where we want the image, and 1's where we the    *
     * screen. this will be the AND bitmask. the XOR bitmask      *
     * (xor_bits) is set to all zeros. the bitmasks are combined  *
     * using the following truth table:                           *
     *   AND   XOR   Display                                      *
     *    0     0     Black                                       *
     *    0     1     White                                       *
     *    1     0     Screen                                      *
     *    1     1     Reverse of screen                           */

    /* create the actual cursor handle (GDI object). */
    cursor = MS_CreateCursor(hInst, x, y, CursorWidth, CursorHeight,
                                (BYTE*)and_bits, (BYTE*)xor_bits);

    /* cleanup */
    TrueFree(and_bits);
    TrueFree(xor_bits);
    return(cursor);
}


void Overlapped_XCopyArea( hdc, gc, old_xpos, old_ypos, width, height, 
                              new_xpos, new_ypos, main_hwnd, work_hwnd, defer)
HDC hdc;               /* window in which the bits are moved */
GC gc;
int old_xpos, old_ypos, width, height;
int new_xpos, new_ypos;
HWND main_hwnd;     /* window handle of main top-level window */
HWND work_hwnd;     /* handle of the window being scrolled    */
int defer;          /* should the generation of extra expose events for */
                    /* scrolled areas be defered to some future call to */
                    /* DoDeferedExpose().  This is used by things like the */
                    /* spreadsheet, which does the scroll, and then adjusts */
                    /* various data structures to re-draw an area.  The    */
                    /* re-draw can not be done as part of the scroll since */
                    /* the data structures are not set up yet.             */
{

    int right, bottom, i;
    RECT *rectP, *visibleP;
    int visible_rects;
    int dstx, dsty, srcx, srcy;
    int scroll_type;
    int dx, dy, xlen, ylen;

    dx = new_xpos - old_xpos;
    dy = new_ypos - old_ypos;

    /* we determine how to break up the window into smaller rectangles */
    /* based on whether things will scroll up-down or left-right.  We must */
    /* have the longest blocks possible along the axis of the scroll        */
    if ( dx != 0 )
        scroll_type = LEFT_RIGHT;
    else
        scroll_type = UP_DOWN;

    right = old_xpos + width;
    bottom = old_ypos + height;

    visible_rects = ComputeVisibleRectangles( old_xpos, old_ypos, 
                     right, bottom, scroll_type, work_hwnd, main_hwnd, &rectP );

    if ( visible_rects == 1 )
        {
        if ( (dx == 0) && 
                (rectP->top == old_ypos) && (rectP->bottom == bottom) &&
                (rectP->left == old_xpos) && (rectP->right == right) )
            {
            /* vertical scroll, no obscuring windows, the fast path */
            XCopyArea(Dpy, hdc, hdc, gc, old_xpos, old_ypos, width, height,
                                                     new_xpos, new_ypos );
            return;
            }
        else if ( (dy == 0) &&
                (rectP->left == old_xpos) && (rectP->bottom == bottom) &&
                (rectP->right == right) && (rectP->top == old_ypos) )
            {
            /* horizontal scroll no obscuring windows, the fast path */
            XCopyArea(Dpy, hdc, hdc, gc, old_xpos, old_ypos, 
                                           width, height, new_xpos, new_ypos );
            return;
            }
        }           

    visibleP = rectP;
    for ( i=0; i<visible_rects; i++ )
        {
        xlen = visibleP->right - visibleP->left;
        ylen = visibleP->bottom - visibleP->top;

        if ( (xlen <= 0) && (ylen <= 0) )
            continue;

        if( dx == 0 )
            {  /* screen contents shift up or down */
            srcx = dstx = visibleP->left;
            srcy = visibleP->top;
            if ( visibleP->top != old_ypos )
                /* we are moving a partial area, which does not start */
                /* at the old source, so adjust the destination       */
                dsty = new_ypos + (visibleP->top - old_ypos);
            else
                dsty = new_ypos;
            }
        else
            {
            /* a left or right scroll */
            srcy = dsty = visibleP->top;
            srcx = visibleP->left;
            if ( visibleP->left != old_xpos )
                /* we are moving a partial area, which does not start */
                /* at the old source, so adjust the destination       */
                dstx = new_xpos + (visibleP->left - old_xpos);
            else
                dstx = new_xpos;
            }


        XCopyArea(Dpy, hdc, hdc, gc, srcx, srcy, xlen, ylen, dstx, dsty);
        visibleP++;
        }    /* end for-each-visible-rectangle  */

    GenerateRequiredRegens( rectP, visible_rects, hdc, work_hwnd,
                          old_xpos, old_ypos, right, bottom, dx, dy, defer);
    TrueFree( (char*)rectP );
}



/**************************************************************************/
/* Compute which portions of the input rectangle, within the input window, */
/* are actually visible, and are not obscured by other windows.  This returns */
/* an array of visible rectangles, which the caller should TrueFree          */
/**************************************************************************/

ComputeVisibleRectangles( left, top, right, bottom, scroll_type,
                                      work_hwnd, main_hwnd, ret_listP )
int top, left, bottom, right;
int scroll_type;
HWND work_hwnd, main_hwnd;
RECT **ret_listP;
{

    RECT inter_rect;
    RECT in_rect;
    RECT win_rect;
    RECT overlap_rect;
    RECT view_rect;
    RECT *listP;
    RECT rect;
    RECT *visibleP;
    RECT *newNextP, *newListP;
    HWND hPrevWnd, hNextWnd;
    int new_size;
    int num_on_new_list, num_visible_rects;
    int i, clip_edge;
    int ret;

    if ( !MS_GetWindowRect( work_hwnd, &win_rect ) )
       {
       /* some error, treat the entire window as visible as a bailout */
       listP = (RECT *)TrueMalloc( sizeof(RECT) );
       listP->top = top;
       listP->bottom = bottom;
       listP->left = left;
       listP->right = right;
       *ret_listP = listP;
       return 0;
       }

    if ( top < 0 )
       {
       /* whole window */
       view_rect = win_rect;
       }
    else
       {
       /* compute visible rectanges for only a portion of the window */
       in_rect.left = left;
       in_rect.top = top;
       in_rect.bottom = bottom;
       in_rect.right = right;

       MS_MapWindowPoints( work_hwnd, HWND_DESKTOP, (LPPOINT)&in_rect, 2 );
       MS_IntersectRect( &view_rect, &in_rect, &win_rect );
       }

    /* first check to see if part of the window is hanging off of the screen */
    clip_edge = FALSE;
    if ( RunningWin95Look )
       {
       RECT work_area;

       /* get the available work area, which is less than the full screen */
       /* because of the task bar                                         */
       ret = MS_SystemParametersInfo( SPI_GETWORKAREA, sizeof(work_area),
                                                                   &work_area, 0 );
       if ( !ret )
           /* some error, default to whole screen */
           goto clip_screen;
       if ( view_rect.left < work_area.left )
          {
          /* window off left edge of screen */
          view_rect.left = work_area.left;
          clip_edge = TRUE;
          }
       if ( view_rect.right > work_area.right )
          {
          /* window off right edge of screen */
          view_rect.right =   work_area.right;
          clip_edge = TRUE;
          }
       if ( view_rect.top < work_area.top )
          {
          view_rect.top = work_area.top;
          clip_edge = TRUE;
          }
       if ( view_rect.bottom > work_area.bottom )
          {
          view_rect.bottom = work_area.bottom;
          clip_edge = TRUE;
          }
       }
    else
       {
clip_screen:
       if ( view_rect.left < 0 )
          {
          /* window off left edge of screen */
          view_rect.left = 0;
          clip_edge = TRUE;
          }
       if ( view_rect.right > AxWinDisplayWidth )
          {
          /* window off right edge of screen */
          view_rect.right =  AxWinDisplayWidth;
          clip_edge = TRUE;
          }
       if ( view_rect.bottom > AxWinDisplayHeight )
          {
          view_rect.bottom = AxWinDisplayHeight;
          clip_edge = TRUE;
          }
       }
   
    if ( clip_edge )
       {
       /* part of the window is hanging off of the screen, we create 2 initial */
       /* rectangles, one of which has a zero width-height, just to force */
       /* the uuper levels to do partial displays of the "real" rectangle */
       /* we we have now clipped to the window border, as if there were   */
       /* overlapping windows.                                            */
       newListP = (RECT *)TrueMalloc( 2*sizeof(RECT) );
       listP = newListP;     /* the dummy second rectangle */
       memset( listP, 0, 2*sizeof(RECT) );
       listP = newListP;
       num_visible_rects = 2;
       }
    else
       {
       listP = newListP = (RECT *)TrueMalloc( sizeof(RECT) );
       num_visible_rects = 1;
       }

    *listP = view_rect;   /* start with one visible rectangle */

    /* now start from the current window, and move through all of the */
    /* windows which are above this on the Z order.  For each of those */
    /* widdows, compute the intersection with the visible areas on the */
    /* list of rectanges, and split a visible rectangle if necessary   */
    hPrevWnd = main_hwnd;
    while ( (hNextWnd = MS_GetWindow( hPrevWnd, GW_HWNDPREV )) != NULL )
         {
         hPrevWnd = hNextWnd;
         MS_GetWindowRect( hNextWnd, &overlap_rect );
         if ( MS_IsWindowVisible( hNextWnd ) &&
             MS_IntersectRect( &inter_rect, &overlap_rect, &view_rect ) )
            {
            /* this window overlaps the base window we are checking. */
            /* check the overlap on the list of visible rectangles */
            new_size = num_visible_rects+4;
            num_on_new_list = 0;
            newNextP = newListP = (RECT *)TrueMalloc( new_size * sizeof(RECT) );
            for ( i=0; i<num_visible_rects; i++ )
               {
               visibleP = listP + i;
               if ( !MS_IntersectRect( &inter_rect, visibleP, &overlap_rect ) )
                  {
                  /* no intersection. leave the visible list alone */
                  *newNextP = *visibleP;
                  newNextP++;
                  num_on_new_list++;
                  }
               else
                  {
                  /* Split this rectangle into pieces.  The general cace is */
                  /* where the overlaped window is in the middle of the     */
                  /* visible portion.  This results in splitting the visible */
                  /* portion into 4 pieces, one to the left of the overlap,  */
                  /* one above, one below, and one to the right.  Overlaps   */
                  /* which just obscure some corner or edge poriton of the   */
                  /* visible area are treated as if the overlap poriton is   */
                  /* just the intersection with the visible area, making     */
                  /* one or more of the 4 pieces either zero height or width */
                  /* or both. We compute the  4 possible rectangles,         */
                  /* and put the non-zero size new ones ones on the list of  */
                  /* visible rectangles                */

                  if ( num_on_new_list+4 > new_size )
                     {
                     /* make room for at least 4 */
                     new_size = new_size + 4;
                     newListP = (RECT *)realloc( newListP, 
                                                   (new_size*sizeof(RECT)) );
                     newNextP = newListP + num_on_new_list;
                     }
                     
                  /*--------------------------------------------*/
                  /* rectangle to the left of the overlapped win */
                  /*--------------------------------------------*/
                  rect.left = visibleP->left;
                  rect.right = inter_rect.left;
                  if ( scroll_type == UP_DOWN )
                     {
                     /* make block to the left full height of wiewable area*/
                     rect.top = visibleP->top;
                     rect.bottom = visibleP->bottom;
                     }
                  else
                     {
                     /* left-right scroll.  block to the left is same height */
                     /* as overlapped window                                 */
                     rect.top = inter_rect.top;
                     rect.bottom = inter_rect.bottom;
                     }
                  if ( ((rect.right - rect.left) > 0 ) &&
                       ((rect.bottom - rect.top) > 0 ) )
                     {
                     *newNextP = rect;
                     newNextP++;
                     num_on_new_list++;
                     }

                  /*------------------------------------------------------*/
                  /* now the rectangle to the right of the overlapped win */
                  /* the top-bottom values were set just above   */
                  /*------------------------------------------------------*/
                  rect.left = inter_rect.right;
                  rect.right = visibleP->right;
                  if ( ((rect.right - rect.left) > 0 ) &&
                       ((rect.bottom - rect.top) > 0 ) )
                     {
                     *newNextP = rect;
                     newNextP++;
                     num_on_new_list++;
                     }
          
                  /*--------------------------------------------*/
                  /* now the rectangle above the overlapped win */
                  /*--------------------------------------------*/
                  rect.top = visibleP->top;
                  rect.bottom = inter_rect.top;
                  if ( scroll_type == UP_DOWN )
                     {
                     /* top block is area just above overlapped win */
                     rect.left = inter_rect.left;
                     rect.right = inter_rect.right;
                     }
                  else
                     {
                     /* left-right scroll.  block is full width of visible */
                     rect.left = visibleP->left;
                     rect.right = visibleP->right;
                     }
                  if ( ((rect.right - rect.left) > 0 ) &&
                       ((rect.bottom - rect.top) > 0 ) )
                     {
                     *newNextP = rect;
                     newNextP++;
                     num_on_new_list++;
                     }

                  /*--------------------------------------------*/
                  /* now the rectangle below the overlapped win */
                  /* the left-right values are already set from above   */
                  /*--------------------------------------------*/
                  rect.top = inter_rect.bottom;
                  rect.bottom = visibleP->bottom;
                  if ( ((rect.right - rect.left) > 0 ) &&
                       ((rect.bottom - rect.top) > 0 ) )
                     {
                     *newNextP = rect;
                     newNextP++;
                     num_on_new_list++;
                     }
     
                  }
               }   /* end of for each visible rectangle */
            num_visible_rects = num_on_new_list;
            TrueFree( (char*)listP );       /* free the old list */
            listP = newListP;
            }    /* end of processing for a single overlapped window */
         }    /* end of processing for each window above on Z order */

     /* finally, go through and convert all the screen relative points to */
     /* window relative                                                   */
     visibleP = listP;
     for ( i=0; i<num_visible_rects; i++ )
        {
        MS_MapWindowPoints( HWND_DESKTOP, work_hwnd, (LPPOINT)visibleP, 2 );
        visibleP++;
        }

     *ret_listP = listP;
     return( num_visible_rects );
}

   

/***************************************************************************/
/* Since on Windows, when you do a BitBlt to copy an area, you get the bits */
/*  in any overalpped window, we previously computed the visible areas and */
/*  scrolled just those areas.  Now, given that list, and how the scroll   */
/*  was done, compute the areas which will need to be regenned, since the  */
/*  bits in that area are not available due to the the overlapped window   */
/* Under X, you get a "graphics-expose" for these areas                    */
/***************************************************************************/

ComputeRequiredRegenAreas( visible_rectsP, num_visible, hdc, ret_rectsP, 
                                           left, top, right, bottom, dx, dy )
RECT *visible_rectsP;     /* an array of visible areas which were scrolled */
int num_visible;         /* how many visible areas */
HDC hdc;
expose_list **ret_rectsP;       /* list of rectangles for the regen areas */
int top, left, bottom, right;   /* original area which was copied */
int dx, dy;                     /* negative means screen shifted up */
{

    expose_list *listP;
    int i, num_regens;

    num_regens = 0;
    *ret_rectsP = listP = 
                   (expose_list *)TrueMalloc( num_visible*sizeof(expose_list) );

    for ( i=0; i<num_visible; i++ )
       {
       listP->hdc = hdc;
       if ( (visible_rectsP->left == visible_rectsP->right) &&
            (visible_rectsP->top == visible_rectsP->bottom) )
          /* a dummy entry because a window hung off the screen */
          continue;

       if ( dx == 0 )
          {
          /* scroll was up-down */
          listP->left = visible_rectsP->left;
          listP->right = visible_rectsP->right;
          if ( visible_rectsP->top != top )
             {
             /* area copied was only part of source, compute where non-moved */
             /* part of original source would have landed, and regen that area*/
             listP->top = top + dy;
             listP->bottom = listP->top + (visible_rectsP->top - top);
             num_regens++;
             listP++;
             }
          else if ( visible_rectsP->bottom != bottom )
             {
             listP->top = visible_rectsP->bottom + dy;
             listP->bottom = listP->top + (bottom - visible_rectsP->bottom);
             num_regens++;
             listP++;
             }
          else if ( visible_rectsP->right != right )
             {
             /* entire right part of window was objscured */
             listP->top = top;
             listP->bottom = bottom;
             listP->left = visible_rectsP->right;
             listP->right = right;
             }
          else if ( visible_rectsP->left != left )
             {
             /* entire left part was obscured */
             listP->top = top;
             listP->bottom = bottom;
             listP->left = left;
             listP->right = visible_rectsP->left;
             }
          }
       else
          {
          /* scroll was left-right */
          listP->top = visible_rectsP->top;
          listP->bottom = visible_rectsP->bottom;
          if ( visible_rectsP->left != left )
             {
             /* area copied was only part of source, compute where non-moved */
             /* part of original source would have landed, and regen that area*/
             listP->left = left + dx;
             listP->right = listP->left + (visible_rectsP->left - left);
             num_regens++;
             listP++;
             }
          else if ( visible_rectsP->right != right )
             {
             /* somewhere in the middle of the screen */
             listP->left = visible_rectsP->right + dx;
             listP->right = listP->left + (right - visible_rectsP->right);
             num_regens++;
             listP++;
             }
          else if ( visible_rectsP->bottom != bottom )
             {
             /* entire bottom part of window was objscured */
             listP->top = visible_rectsP->bottom;
             listP->bottom = bottom;
             listP->left = left;
             listP->right = right;
             }
          else if ( visible_rectsP->top != top );
             {
             /* entire top part was obscured */
             listP->top = top;
             listP->bottom = visible_rectsP->top;
             listP->left = left;
             listP->right = right;
             }
          }
       visible_rectsP++;
       }    /* end of "for each visible rectangle */
             
    return( num_regens );
}




void GenerateRequiredRegens( visible_rectsP, num_visible, hdc, hwnd,
                                    left, top, right, bottom, dx, dy, defer )
RECT *visible_rectsP;     /* an array of visible areas which were scrolled */
HDC hdc;                /* expose on this window */
HWND hwnd;              /* handle to the exposed window */
int num_visible;         /* how many visible areas */
int top, left, bottom, right;   /* overall window being scrolled */
int dx, dy;              /* negative means screen shifted up */
int defer;               /* see comment under OverlappedXCopyArea()  */
{

    int num_regen_rects;
    int i, new_size;
    expose_list *rect_listP, *regen_rectP, *new_listP;


    num_regen_rects = ComputeRequiredRegenAreas( visible_rectsP, num_visible,
                   hdc, &rect_listP, left, top, right, bottom, dx, dy);

    if ( defer )
       {
       /* put the rectangles on a global, to be drawn later */
       if ( DeferList == NULL )
          {
          /* new list */
          DeferList = rect_listP;
          DeferNum = num_regen_rects;
          }
       else
          {
          /* add to an existing list */
          new_size = DeferNum + num_regen_rects;
          new_listP = (expose_list *)TrueRealloc( (char*)DeferList,
                                  (new_size * sizeof(expose_list)) );
          memcpy( new_listP+DeferNum, rect_listP, 
                                 (num_regen_rects * sizeof(expose_list)) );
          DeferList = new_listP;
          DeferNum = new_size;
          }
       return;
       }

    regen_rectP = rect_listP;
    for ( i=0; i<num_regen_rects; i++ )
       {
       MS_InvalidateRect( hwnd, (CONST RECT*)regen_rectP, TRUE );
       regen_rectP++;
       }

    TrueFree( (char*)rect_listP );
    return;
}

void
DoDeferredExpose(int app_type, void *app_data)
{
    expose_list *listP;
    XEvent xevent;
    int i;

    if ( DeferList == NULL )
       return;

    memset( &xevent, 0, sizeof(xevent) );
    xevent.type = Expose;

    listP = DeferList;
    for ( i=0; i < DeferNum; i++ )
       {
       xevent.xany.window = listP->hdc;
       xevent.xexpose.x = listP->left;
       xevent.xexpose.y = listP->top;
       xevent.xexpose.width = (listP->right - listP->left + 1);
       xevent.xexpose.height = (listP->bottom - listP->top + 1);
       
       if ( app_type == APSS )
          {
          ss_value *ssP = (ss_value*)app_data;
          SSXEvent(ssP, &xevent, (ss_stroke_buf*)NULL);
          }
       else if (  app_type == APDC )
          {
          wp_global_data *wpP = (wp_global_data*)app_data;
          DsExpose(wpP, xevent.xexpose.x, xevent.xexpose.y,
                  xevent.xexpose.width, xevent.xexpose.height,
                  NULL);
          }
       else
          tempAbort( "DoDeferedExpose() call with unknown app type" );
       listP++;
       }

    TrueFree( (char*)DeferList );
    DeferList = NULL;
    DeferNum = 0;
    
    return;
}



 
/********************************************************************
 *  AxGetHWNDFromHDC - get hwnd given hdc for widget WindowList
 *
 */
HWND AxGetHWNDFromHDC(hdc)
Window hdc;
{
    AXWidget w;
 
 
    for ( w = WindowList; w; w = w->nextWin )
        {
        if ( w->window == hdc )
            return (w->winid);
        }
    return ( (HWND)NULL );
}



/* same as the unix "rotate_around_center" (pol.c) except it takes
 * a Windows Point structure rather than an XPoint.
 */
static void
nt_rotate_around_center(POINT *pt,XPoint *center, double sinAng,double cosAng)
{
    int xt, yt;

    xt = pt->x - center->x;
    yt = pt->y - center->y;
    pt->x = (double)xt*cosAng + (double)yt*sinAng + (double)center->x;
    pt->y = (double)yt*cosAng - (double)xt*sinAng + (double)center->y;
}

/************ GRADIENT FUNCTIONS: ****************************/
void
win_linear_gradient(HGDIOBJ draw_dc, GC gc, int xpos, int ypos,
                    int uwid, int uhyt, int color_steps, int true_steps,
                    double c_inc, double m_inc, double y_inc,
                    double c, double m, double y, unsigned long back_pixel,
                    int orig_x, int orig_y, int orig_wid, int orig_hyt,
                    double sinAng, double cosAng, int y_offset)
{
    int initial_back_pixel = back_pixel;
    int src_x, src_y, swid, shyt, tmp_wid;
    int skip_cnt, prev_cnt, s_off, last_hyt, mem_offset;
    int i, j, patHyt, mem_ypos, last_ypos, delete_dc;
    HDC src_dc, mem_hdc;
    HBRUSH hbrush, old_brush;
    HBITMAP pattern, mem_hbm, mask_hbm, old_hbm, src_hbm;
    HPALETTE old_palette;
    unsigned long fore_pixel;
    POINT rpts[3], upts[4];
    XPoint center;


    mask_hbm = gc->values.clip_mask;
    prev_cnt = skip_cnt = 0;
    mem_offset = 0;
    if ( y_offset >= 0 )
        mem_offset = y_offset;
    else
        uhyt = uhyt + ABS(y_offset);

    draw_dc = InsureDrawable(draw_dc, &delete_dc);

    tmp_wid = hypot((double)uwid, (double)uhyt);
    if ( tmp_wid > AX_GRADIENT_THRESHOLD )
        {
        /* dimensions that are too big will eat up GDI resources,
         * so instead of drawing a gradient, we draw a solid color
         * that best approximates the 2 gradient colors.
         */
re_color:
        c += c_inc;
        m += m_inc;
        y += y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);
        if ( fore_pixel == back_pixel )
            goto re_color;

        win_solid_gradient(draw_dc, fore_pixel, xpos, ypos, mask_hbm);

        if ( delete_dc )
            MS_DeleteDC(draw_dc);
        return;
        }

    /* create a memory dc to do our linear drawing on. */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, uwid, uhyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);

    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    for ( i=0; i < color_steps; i++ )
        {
        /* increment the foreground color */
        c += c_inc;
        m += m_inc;
        y += y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);
        /* if there is no color change, skip it */
        if ( fore_pixel == back_pixel )
            {
            skip_cnt += N_GRAD_PATS; 
            continue;
            }

        /* set current colors */
        MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
        MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));

        skip_cnt += N_GRAD_PATS;
        s_off = (skip_cnt - prev_cnt)/N_GRAD_PATS;
        /* do the bg/fg mix - 100%,87%,75%,62%,50%,37%,25%,12% */
        for ( j=0; j < N_GRAD_PATS; j++ )
            {
            get_gradient_map(&pattern, j, 0);
            hbrush = MS_CreatePatternBrush(pattern);
            mem_ypos = mem_offset + ((s_off*j + prev_cnt) * uhyt/true_steps);
            patHyt = mem_offset + ((s_off*(j+1) + prev_cnt)*(double)uhyt/true_steps)
                                                            - mem_ypos;
            old_brush = MS_SelectObject(mem_hdc, hbrush);
            MS_PatBlt(mem_hdc, 0, mem_ypos, uwid, patHyt, PATCOPY);
            MS_SelectObject(mem_hdc, old_brush);
            MS_DeleteObject(hbrush);
            }

        /* set the background color to the previous foreground */
        back_pixel = fore_pixel;
        prev_cnt = skip_cnt;
        }

    /* fill remainder with pure background */
    if ( color_steps > 0 )
        {
        last_ypos = mem_ypos + patHyt;
        last_hyt = uhyt - last_ypos;
        hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(back_pixel));
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        MS_PatBlt(mem_hdc, 0, last_ypos, uwid, last_hyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);

        if ( y_offset > 0 )
            {
            last_ypos = 0;
            last_hyt = y_offset;
            hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(initial_back_pixel));
            old_brush = MS_SelectObject(mem_hdc, hbrush);
            MS_PatBlt(mem_hdc, 0, last_ypos, uwid, last_hyt, PATCOPY);
            MS_SelectObject(mem_hdc, old_brush);
            MS_DeleteObject(hbrush);
            }
        }
    else
        {
        /* no color steps, just fill whole object with foreground */
        hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(back_pixel));
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        MS_PatBlt(mem_hdc, 0, 0, uwid, uhyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);
        }

    if ( y_offset > 0 )
        ypos = ypos - y_offset;

    /* rotate the unionized shape so we can create a new memory DC,
     * onto which we will actually rotate the gradient with PlgBlt.
     */
    center.x = xpos + uwid/2;
    center.y = ypos + uhyt/2;
    upts[0].x = upts[2].x = xpos;
    upts[0].y = upts[1].y = ypos;
    upts[1].x = upts[3].x = xpos + uwid;
    upts[2].y = upts[3].y = ypos + uhyt;
    nt_rotate_around_center(&upts[0], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[1], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[2], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[3], &center, sinAng, cosAng);

    xpos = MIN(MIN(MIN(upts[0].x, upts[1].x), upts[2].x), upts[3].x);
    ypos = MIN(MIN(MIN(upts[0].y, upts[1].y), upts[2].y), upts[3].y);
    swid = MAX(MAX(MAX(upts[0].x, upts[1].x), upts[2].x), upts[3].x) - xpos;
    shyt = MAX(MAX(MAX(upts[0].y, upts[1].y), upts[2].y), upts[3].y) - ypos;

    src_x = (swid - orig_wid)/2;
    src_y = (shyt - orig_hyt)/2;
    src_dc = MS_CreateCompatibleDC(NULL);
    src_hbm = MS_CreateCompatibleBitmap(RootWin, swid, shyt);
    MS_SelectObject(src_dc, src_hbm);

    /* first, rotate the linear gradient to a memory dc */
    rpts[0].x = upts[0].x - xpos;    /* upper left corner */
    rpts[0].y = upts[0].y - ypos;
    rpts[1].x = upts[1].x - xpos;    /* upper right corner */
    rpts[1].y = upts[1].y - ypos;
    rpts[2].x = upts[2].x - xpos;
    rpts[2].y = upts[2].y - ypos;    /* lower left corner */
    MS32_PlgBlt(src_dc, rpts, mem_hdc, 0, 0, uwid, uhyt, NULL, 0, 0);
    /* draw the linear gradient to screen thru shape mask. */
    /* rop_code = 0xAACC0000;   non-transparent ROP4 code. */
    MS32_MaskBlt(draw_dc, orig_x, orig_y, orig_wid, orig_hyt,
                        src_dc, src_x, src_y, mask_hbm, 0, 0,
                        MAKEROP4(SRCCOPY, 0x00AA0029));

    /* cleanup */
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_DeleteDC(mem_hdc);
    MS_DeleteObject(mem_hbm);
    if ( delete_dc )
        MS_DeleteDC(draw_dc);
    MS_DeleteObject(src_hbm);
    MS_DeleteDC(src_dc);
}
void
win_bilinear_gradient(HDC dest_dc, GC gc, int xpos,int ypos, int wid,int hyt,
                                            attr_type *attr, int for_lines)
{
    int last_hyt, last_ypos, tmp_wid;
    double angle, sinAng, cosAng, c,m,y, c_inc, m_inc, y_inc;
    int color_steps, true_steps, i, j, n, patTopHyt, patBotHyt;
    int f_c,f_y,f_m,f_k, b_c,b_m,b_y,b_k, avail;
    int y_off, thyt, bhyt;
    unsigned long back_pixel, fore_pixel;
    XPoint pts[5], center;
    POINT rpts[3], upts[4];
    int src_x, src_y, swid, shyt, delete_dc;
    int mem_ypos_top=0, mem_ypos_bot=0;
    HDC src_dc, mem_hdc;
    HBRUSH hbrush, old_brush;
    HBITMAP pattern, mem_hbm, mask_hbm, old_hbm, src_hbm;
    HPALETTE old_palette;
    int orig_x = xpos, orig_y = ypos;
    int orig_wid = wid, orig_hyt = hyt;


    dest_dc = InsureDrawable(dest_dc, &delete_dc);
    mask_hbm = gc->values.clip_mask;

    y_off = attr->f_yoff/200.0 * hyt;
    center.x = xpos + wid/2;
    center.y = ypos + hyt/2;
    thyt = center.y - ypos + y_off;
    bhyt = ypos + hyt - center.y - y_off - 1;

    /* rotate the coordinates */
    angle  = (double)attr->f_ang / 180.0 * M_PI;
    sinAng = (double)sin(angle);
    cosAng = (double)cos(angle);
    pts[0].x = pts[2].x = xpos;
    pts[0].y = pts[1].y = ypos;
    pts[1].x = pts[3].x = xpos + wid;
    pts[2].y = pts[3].y = ypos + hyt;
    rotate_around_center(&pts[0], &center, sinAng, cosAng);
    rotate_around_center(&pts[1], &center, sinAng, cosAng);
    rotate_around_center(&pts[2], &center, sinAng, cosAng);
    rotate_around_center(&pts[3], &center, sinAng, cosAng);

    /* recalc the size and position */
    xpos  = MIN( MIN( MIN(pts[0].x, pts[1].x), pts[2].x), pts[3].x);
    ypos  = MIN( MIN( MIN(pts[0].y, pts[1].y), pts[2].y), pts[3].y);
    wid = MAX( MAX( MAX(pts[0].x, pts[1].x), pts[2].x ), pts[3].x ) - xpos;
    hyt = MAX( MAX( MAX(pts[0].y, pts[1].y), pts[2].y ), pts[3].y ) - ypos;

    /* remove black component from color step calcs */
    if ( for_lines )
        {
        f_c = MIN(attr->lfg.c + attr->lfg.k, 255);
        f_m = MIN(attr->lfg.m + attr->lfg.k, 255);
        f_y = MIN(attr->lfg.y + attr->lfg.k, 255);
        f_k = 0;
        b_c = MIN(attr->lbg.c + attr->lbg.k, 255);
        b_m = MIN(attr->lbg.m + attr->lbg.k, 255);
        b_y = MIN(attr->lbg.y + attr->lbg.k, 255);
        b_k = 0;
        }
    else
        {
        f_c = MIN(attr->ffg.c + attr->ffg.k, 255);
        f_m = MIN(attr->ffg.m + attr->ffg.k, 255);
        f_y = MIN(attr->ffg.y + attr->ffg.k, 255);
        f_k = 0;
        b_c = MIN(attr->fbg.c + attr->fbg.k, 255);
        b_m = MIN(attr->fbg.m + attr->fbg.k, 255);
        b_y = MIN(attr->fbg.y + attr->fbg.k, 255);
        b_k = 0;
        }

    tmp_wid = hypot((double)wid, (double)hyt);
    if ( tmp_wid > AX_GRADIENT_THRESHOLD )
        {
        /* dimensions that are too big will eat up GDI resources,
         * so instead of drawing a gradient, we draw a solid color
         * that best approximates the 2 gradient colors.
         */
        thyt = hyt/2  + y_off;
#if 0
        axmsGetGradientColorInfo(attr, thyt, for_lines,
                                    &f_c, &f_m, &f_y,
                                    &b_c, &b_m, &b_y,
                                    &color_steps);
#else
        avail = MAX(1, (int)(thyt/(N_GRAD_PATS+1)));
        color_steps = ABS(f_c - b_c);
        color_steps = MAX(ABS(f_m - b_m), color_steps);
        color_steps = MAX(ABS(f_y - b_y), color_steps);
        color_steps = MIN(avail, color_steps);
#endif
        c_inc = (double)(f_c - b_c) / (double)(color_steps);
        m_inc = (double)(f_m - b_m) / (double)(color_steps);
        y_inc = (double)(f_y - b_y) / (double)(color_steps);
        c = b_c;
        m = b_m;
        y = b_y;
        AxGetRealPixel(2, (int)f_c, (int)f_m, (int)f_y, 0, 255, &fore_pixel);
re_color:
        c -= c_inc;
        m -= m_inc;
        y -= y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &back_pixel);
        if ( fore_pixel == back_pixel )
            goto re_color;

        win_solid_gradient(dest_dc, back_pixel, xpos, ypos, mask_hbm);

        if ( delete_dc )
            MS_DeleteDC(dest_dc);
        return;
        }


    /* create a memory dc to do our linear drawing on. */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, wid, hyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);
    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);

    /* draw the top half */
    y_off = attr->f_yoff/200.0 * hyt;
    if ( thyt > 0 )
        {
        thyt = hyt/2  + y_off;
        /* get the number of divisible sections */
        avail = MAX(1, (int)(thyt/(N_GRAD_PATS+1)));

        /* get the maximum number of color steps */
        color_steps = ABS(f_c - b_c);
        color_steps = MAX(ABS(f_m - b_m), color_steps);
        color_steps = MAX(ABS(f_y - b_y), color_steps);
        color_steps = MIN(avail, color_steps);

        /* get the number of color steps FOR THIS DISPLAY */
        c_inc = (double)(f_c - b_c) / (double)(color_steps);
        m_inc = (double)(f_m - b_m) / (double)(color_steps);
        y_inc = (double)(f_y - b_y) / (double)(color_steps);
        c = b_c;
        m = b_m;
        y = b_y;
        AxGetRealPixel(2, b_c, b_m, b_y, 0, 255, &back_pixel);
        true_steps = 1;

        for ( i=0; i<color_steps; i++ )
            {
            /* increment the foreground color */
            c += c_inc;
            m += m_inc;
            y += y_inc;
            AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);

            /* if there is no color change, widen patterns and try again */
            if ( fore_pixel != back_pixel )
                {
                true_steps++;
                back_pixel = fore_pixel;
                }
            }
        AxGetRealPixel(2, f_c, f_m, f_y, 0, 255, &fore_pixel);
        if ( fore_pixel != back_pixel )
            true_steps++;

        /* tile in the gradient patterns */
        patTopHyt = thyt / (true_steps*N_GRAD_PATS+1);
        while ( patTopHyt == 0 && true_steps > 1 )
            {
            true_steps--;
            patTopHyt = thyt / (true_steps*N_GRAD_PATS+1);
            }

        c_inc = (double)(f_c - b_c) / (double)(color_steps);
        m_inc = (double)(f_m - b_m) / (double)(color_steps);
        y_inc = (double)(f_y - b_y) / (double)(color_steps);
        c = b_c;
        m = b_m;
        y = b_y;
        AxGetRealPixel(2, b_c, b_m, b_y, 0, 255, &back_pixel);

        for ( i=n=0; i < color_steps && n < true_steps; i++ )
            {
            /* increment the foreground color */
            c += c_inc;
            m += m_inc;
            y += y_inc;
            AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);
            /* if there is no color change, skip it */
            if ( fore_pixel == back_pixel )
                continue;
            /* set current colors */
            MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
            MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));

            /* do the bg/fg mix - 100%,87%,75%,62%,50%,37%,25%,12% */
            for ( j=0; j<N_GRAD_PATS; j++ )
                {
                get_gradient_map(&pattern, j, 0);
                hbrush = MS_CreatePatternBrush(pattern);
                mem_ypos_top = n*N_GRAD_PATS*patTopHyt + patTopHyt*j;
                old_brush = MS_SelectObject(mem_hdc, hbrush);
                MS_PatBlt(mem_hdc, 0, mem_ypos_top, wid, patTopHyt, PATCOPY);
                MS_SelectObject(mem_hdc, old_brush);
                MS_DeleteObject(hbrush);
                }
            /* set the background color to the previous foreground */
            back_pixel = fore_pixel;
            n++;
            }
        }

    /* draw the bottom half */
    if ( bhyt > 0 )
        {
        bhyt = hyt/2 - y_off;
        /* get the number of divisible sections */
        avail = MAX(1, (int)(bhyt/(N_GRAD_PATS+1)));

        /* get the maximum number of color steps */
        color_steps = ABS(f_c - b_c);
        color_steps = MAX(ABS(f_m - b_m), color_steps);
        color_steps = MAX(ABS(f_y - b_y), color_steps);
        color_steps = MIN(avail, color_steps);

        /* get the number of color steps FOR THIS DISPLAY */
        c_inc = (double)(f_c - b_c) / (double)(color_steps);
        m_inc = (double)(f_m - b_m) / (double)(color_steps);
        y_inc = (double)(f_y - b_y) / (double)(color_steps);
        c = b_c;
        m = b_m;
        y = b_y;
        AxGetRealPixel(2, b_c, b_m, b_y, 0, 255, &back_pixel);
        true_steps = 1;
        for ( i=0; i<color_steps; i++ )
            {
            /* increment the foreground color */
            c += c_inc;
            m += m_inc;
            y += y_inc;
            AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);

            /* if there is no color change, widen patterns and try again */
            if ( fore_pixel != back_pixel )
                {
                true_steps++;
                back_pixel = fore_pixel;
                }
            }

        AxGetRealPixel(2, f_c, f_m, f_y, 0, 255, &fore_pixel);
        if ( fore_pixel != back_pixel )
            true_steps++;

        /* tile in the gradient patterns */
        patBotHyt = bhyt / (true_steps*N_GRAD_PATS+1);

        while ( patBotHyt == 0 && true_steps > 1 )
            {
            true_steps--;
            patBotHyt = bhyt / (true_steps*N_GRAD_PATS+1);
            }

        c_inc = (double)(f_c - b_c) / (double)(color_steps);
        m_inc = (double)(f_m - b_m) / (double)(color_steps);
        y_inc = (double)(f_y - b_y) / (double)(color_steps);
        c = b_c;
        m = b_m;
        y = b_y;
        AxGetRealPixel(2, b_c, b_m, b_y, 0, 255, &back_pixel);
        for ( i=n=0; i<color_steps && n < true_steps; i++ )
            {
            /* increment the foreground color */
            c += c_inc;
            m += m_inc;
            y += y_inc;
            AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);
            /* if there is no color change, skip it */
            if ( fore_pixel == back_pixel )
                continue;
            /* set current colors */
            MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
            MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));
            /* do the bg/fg mix - 100%,87%,75%,62%,50%,37%,25%,12% */
            for ( j=0; j<N_GRAD_PATS; j++ )
                {
                get_gradient_map(&pattern, j, 0);
                hbrush = MS_CreatePatternBrush(pattern);
                mem_ypos_bot = hyt-(n*N_GRAD_PATS*patBotHyt)-(patBotHyt*(j+1));
                old_brush = MS_SelectObject(mem_hdc, hbrush);
                MS_PatBlt(mem_hdc, 0, mem_ypos_bot, wid, patBotHyt, PATCOPY);
                MS_SelectObject(mem_hdc, old_brush);
                MS_DeleteObject(hbrush);
                }
            /* set the background color to the previous foreground */
            back_pixel = fore_pixel;
            n++;
            }
        }

    /* fill remainder with pure background */
    if ( mem_ypos_bot == 0 )
        last_hyt = hyt - mem_ypos_top;
    else
        last_hyt = ABS(mem_ypos_bot - mem_ypos_top);
    last_ypos = mem_ypos_top;
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(back_pixel));
    old_brush = MS_SelectObject(mem_hdc, hbrush);
    MS_PatBlt(mem_hdc, 0, last_ypos, wid, last_hyt, PATCOPY);
    MS_SelectObject(mem_hdc, old_brush);
    MS_DeleteObject(hbrush);

    /* rotate the unionized shape so we can create a new memory DC,
     * onto which we will actually rotate the gradient with PlgBlt.
     */
    center.x = xpos + wid/2;
    center.y = ypos + hyt/2;
    upts[0].x = upts[2].x = xpos;
    upts[0].y = upts[1].y = ypos;
    upts[1].x = upts[3].x = xpos + wid;
    upts[2].y = upts[3].y = ypos + hyt;
    nt_rotate_around_center(&upts[0], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[1], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[2], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[3], &center, sinAng, cosAng);

    xpos = MIN(MIN(MIN(upts[0].x, upts[1].x), upts[2].x), upts[3].x);
    ypos = MIN(MIN(MIN(upts[0].y, upts[1].y), upts[2].y), upts[3].y);
    swid = MAX(MAX(MAX(upts[0].x, upts[1].x), upts[2].x ), upts[3].x) - xpos;
    shyt = MAX(MAX(MAX(upts[0].y, upts[1].y), upts[2].y ), upts[3].y) - ypos;

    src_x = orig_x - xpos;
    src_y = orig_y - ypos;

    src_dc = MS_CreateCompatibleDC(NULL);
    src_hbm = MS_CreateCompatibleBitmap(RootWin, swid, shyt);
    MS_SelectObject(src_dc, src_hbm);

    /* first, rotate the bilinear gradient to a memory dc */
    rpts[0].x = upts[0].x - xpos;    /* upper left corner */
    rpts[0].y = upts[0].y - ypos;
    rpts[1].x = upts[1].x - xpos;    /* upper right corner */
    rpts[1].y = upts[1].y - ypos;
    rpts[2].x = upts[2].x - xpos;
    rpts[2].y = upts[2].y - ypos;    /* lower left corner */
    MS32_PlgBlt(src_dc, rpts, mem_hdc, 0, 0, wid, hyt, NULL, 0, 0);
    /* now blt to the screen thru the object mask. */
    /* rop_code = 0xAACC0000;   non-transparent ROP4 code. */
    MS32_MaskBlt(dest_dc, orig_x, orig_y, orig_wid, orig_hyt,
                        src_dc, src_x, src_y, mask_hbm, 0, 0,
                        MAKEROP4(SRCCOPY, 0x00AA0029));

    /* cleanup */
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_DeleteDC(mem_hdc);
    MS_DeleteObject(mem_hbm);
    if ( delete_dc )
        MS_DeleteDC(dest_dc);
    MS_DeleteObject(src_hbm);
    MS_DeleteDC(src_dc);
}

void
win_radial_gradient(HGDIOBJ drawing_dc, GC gc, int xpos, int ypos,
                    int width, int height, int x_off, int y_off,
                    int color_steps, int f_c, int f_m, int f_y,
                    int b_c, int b_m, int b_y)
{
    int dc_wid, dc_hyt, true_steps;
    int s_off, skip_cnt, prev_cnt;
    int arc_xpos, arc_ypos, arc_wid, arc_hyt;
    int mask_x, mask_y;
    int i, j, delete_dc;
    HDC mask_dc, temp_dc, mem_hdc;
    BOOL ret;
    HPEN old_pen;
    DWORD fg_rop_code, bg_rop_code;
    HBRUSH hbrush, old_brush;
    HBITMAP pattern, mem_hbm, mask_hbm;
    HBITMAP old_hbm, old_mask_hbm, old_temp_hbm;
    HPALETTE old_palette;
    double x_size, y_size;
    double c,m,y, c_inc, m_inc, y_inc;
    unsigned long fore_pixel, back_pixel;

    drawing_dc = InsureDrawable(drawing_dc, &delete_dc);

    c_inc = (double)(f_c - b_c) / (double)(color_steps);
    m_inc = (double)(f_m - b_m) / (double)(color_steps);
    y_inc = (double)(f_y - b_y) / (double)(color_steps);
    c = f_c;
    m = f_m;
    y = f_y;
    AxGetRealPixel(2, f_c, f_m, f_y, 0, 255, &fore_pixel);

    /* set the position and size of the field */
    x_size = y_size = hypot((double)width, (double)height);

    if ( x_size > AX_GRADIENT_THRESHOLD )
        {
        /* dimensions that are too big will eat up GDI resources,
         * so instead of drawing a gradient, we draw a solid color
         * that best approximates the 2 gradient colors.
         */
re_color:
        c -= c_inc;
        m -= m_inc;
        y -= y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &back_pixel);
        if ( fore_pixel == back_pixel )
            goto re_color;

        win_solid_gradient(drawing_dc, back_pixel, xpos, ypos,
                                        gc->values.clip_mask);

        if ( delete_dc )
            MS_DeleteDC(drawing_dc);
        return;
        }

    dc_wid = dc_hyt = (int)x_size;    /* square dimensions */
    /* our mask is the size of the polygon being drawn, but our *
     * radial drawing area is larger. Since the MS_MaskBlt call *
     * requires the src and mask to be the same size, we create *
     * a larger mask here, and blt the old one onto it.         */
    mask_dc = MS_CreateCompatibleDC(NULL);
    mask_hbm = MS_CreateCompatibleBitmap(mask_dc, dc_wid, dc_hyt);
    old_mask_hbm = MS_SelectObject(mask_dc, mask_hbm);
    MS_PatBlt(mask_dc, 0, 0, dc_wid, dc_hyt, BLACKNESS);

    /* select the previously created shape mask into our temp hdc. */
    temp_dc = MS_CreateCompatibleDC(NULL);
    old_temp_hbm = MS_SelectObject(temp_dc, gc->values.clip_mask);
    /* get center points */
    if ( x_off < 0 )
        mask_x = (dc_wid / 2) - (width / 2) - x_off;
    else
        mask_x = (dc_wid / 2) - (width / 2);
    if ( y_off < 0 )
        mask_y = (dc_hyt / 2) - (height / 2) - y_off;
    else
        mask_y = (dc_hyt / 2) - (height / 2);
    MS_BitBlt(mask_dc, mask_x, mask_y, dc_wid, dc_hyt,
                                temp_dc, 0, 0, SRCCOPY);

    /* delete unnecessary objects, and save the new *
     * mask bitmap for later use in MS_MaskBlt.     */
    MS_SelectObject(mask_dc, old_mask_hbm);
    MS_SelectObject(temp_dc, old_temp_hbm);
    MS_DeleteDC(temp_dc);
    MS_DeleteDC(mask_dc);

    /* create a memory dc to do our radial drawing on. */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, dc_wid, dc_hyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);
    old_pen = MS_SelectObject(mem_hdc, MS_GetStockObject(NULL_PEN));

    skip_cnt = prev_cnt = 0;
    true_steps = 2 * N_GRAD_PATS * color_steps;
    arc_xpos = arc_ypos = 0;
    arc_wid = arc_hyt = (int)x_size;
    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    for ( i=0; i < color_steps; i++ )
        {
        /* increment the foreground color */
        c -= c_inc;
        m -= m_inc;
        y -= y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &back_pixel);

        /* if there is no color change, skip it */
        if ( fore_pixel == back_pixel )
            {
            skip_cnt += N_GRAD_PATS;
            continue;
            }

        /* set current colors */
        MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
        MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));

        skip_cnt += N_GRAD_PATS;
        s_off = (skip_cnt - prev_cnt)/N_GRAD_PATS;
        /* do the bg/fg mix - 100%,87%,75%,62%,50%,37%,25%,12% */
        for ( j=0; j < N_GRAD_PATS; j++ )
            {
            get_gradient_map(&pattern, j, TRUE);
            hbrush = MS_CreatePatternBrush(pattern);
            old_brush = MS_SelectObject(mem_hdc, hbrush);

            arc_xpos = (s_off*j+prev_cnt)*x_size/true_steps - 1;
            arc_ypos = (s_off*j+prev_cnt)*y_size/true_steps - 1;
            arc_wid = x_size - ((s_off*j+prev_cnt)*1.0*x_size/true_steps) + 1;
            arc_hyt = y_size - ((s_off*j+prev_cnt)*1.0*y_size/true_steps) + 1;

            /* we draw filled arcs with a null pen to create
             * the gradient effect.
             */
            MS_Pie(mem_hdc, arc_xpos,arc_ypos, arc_wid,arc_hyt, 0,0,0,0);

            MS_SelectObject(mem_hdc, old_brush);
            MS_DeleteObject(hbrush);
            }

        /* set the background color to the previous foreground */
        fore_pixel = back_pixel;
        prev_cnt = skip_cnt;
        }

    if ( color_steps <= 0 )
        {
        /* no color steps, just fill whole object with foreground */
        hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(fore_pixel));
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        MS_PatBlt(mem_hdc, 0, 0, dc_wid, dc_hyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);
        }

    /* draw the radial gradient to screen thru shape mask. */
    /* rop_code = 0xAACC0000;    non-transparent ROP code. */
    fg_rop_code = SRCCOPY;
    bg_rop_code = 0x00AA0029;
    ret = AxWinMaskBlt(drawing_dc, xpos - mask_x, ypos - mask_y,
                         dc_wid, dc_hyt, mem_hdc, 0,0, mask_hbm, 0,0,
                         fg_rop_code, bg_rop_code);

    /* cleanup */
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_SelectObject(mem_hdc, old_pen);
    MS_DeleteDC(mem_hdc);
    MS_DeleteObject(mem_hbm);
    MS_DeleteObject(mask_hbm);
    if ( delete_dc )
        MS_DeleteDC(drawing_dc);
}

void
win_rect_gradient(HGDIOBJ draw_dc, GC gc, int xpos,int ypos, int uwid,int uhyt,
                        int x_off, int y_off, int color_steps,
                        double c_inc, double m_inc, double y_inc,
                        double c, double m, double y,
                        int orig_x, int orig_y, int orig_wid, int orig_hyt,
                        double sinAng, double cosAng)
{
    int did_patterns=FALSE;
    int mem_wid, mem_hyt;
    int i, j, delete_dc;
    int s_off, skip_cnt, prev_cnt, true_steps;
    int src_x, src_y, swid, shyt;
    HDC src_dc, mem_hdc;
    HPEN old_pen;
    HBRUSH hbrush, old_brush;
    HBITMAP pattern, mem_hbm, mask_hbm, old_hbm, src_hbm;
    HPALETTE old_palette;
    unsigned long fore_pixel, back_pixel;
    POINT pts[4], rpts[3], upts[4];
    XPoint center;
    int wid1, hyt1, wid2, hyt2, tmp_wid;

    mask_hbm = gc->values.clip_mask;
    draw_dc = InsureDrawable(draw_dc, &delete_dc);
    AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &fore_pixel);

    tmp_wid = hypot((double)uwid, (double)uhyt);
    if ( tmp_wid > AX_GRADIENT_THRESHOLD )
        {
        /* dimensions that are too big will eat up GDI resources,
         * so instead of drawing a gradient, we draw a solid color
         * that best approximates the 2 gradient colors.
         */
re_color:
        c -= c_inc;
        m -= m_inc;
        y -= y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &back_pixel);
        if ( fore_pixel == back_pixel )
            goto re_color;

        win_solid_gradient(draw_dc, back_pixel, xpos, ypos, mask_hbm);

        if ( delete_dc )
            MS_DeleteDC(draw_dc);
        return;
        }

    /* create a memory dc to do our linear drawing on. */
    /* uwid and uhyt represent the union of the original shape
     * and the rotated shape.
     */
    mem_wid = uwid;
    mem_hyt = uhyt;
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, mem_wid, mem_hyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);
    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    /* initially fill everything with foreground */
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(fore_pixel));
    old_brush = MS_SelectObject(mem_hdc, hbrush);
    MS_PatBlt(mem_hdc, 0, 0, mem_wid, mem_hyt, PATCOPY);
    MS_SelectObject(mem_hdc, old_brush);
    MS_DeleteObject(hbrush);
    old_pen = MS_SelectObject(mem_hdc, MS_GetStockObject(NULL_PEN));

    skip_cnt = 0;
    prev_cnt = 0;
    true_steps = N_GRAD_PATS * color_steps;
    wid1 = x_off + mem_wid/2;
    wid2 = mem_wid - wid1;
    hyt1 = y_off + mem_hyt/2;
    hyt2 = mem_hyt - hyt1;
    for ( i=0; i < color_steps; i++ )
        {
        /* increment the foreground color */
        c -= c_inc;
        m -= m_inc;
        y -= y_inc;
        AxGetRealPixel(2, (int)c, (int)m, (int)y, 0, 255, &back_pixel);

        /* if there is no color change, widen patterns and try again */
        if ( fore_pixel == back_pixel )
            {
            skip_cnt += N_GRAD_PATS;
            continue;
            }

        did_patterns = TRUE;
        /* do the bg/fg mix - 100%,87%,75%,62%,50%,37%,25%,12% */
        MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
        MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));
        skip_cnt += N_GRAD_PATS;
        s_off = (skip_cnt - prev_cnt)/N_GRAD_PATS;
        for ( j=0; j < N_GRAD_PATS; j++ )
            {
            get_gradient_map(&pattern, j, TRUE);
            hbrush = MS_CreatePatternBrush(pattern);
            old_brush = MS_SelectObject(mem_hdc, hbrush);

            pts[0].x = (s_off*j + prev_cnt)*(double)wid1/true_steps;
            pts[0].y = (s_off*j + prev_cnt)*(double)hyt1/true_steps;
            pts[1].x = mem_wid - (s_off*j + prev_cnt)*(double)wid2/true_steps;
            pts[1].y = (s_off*j + prev_cnt)*(double)hyt1/true_steps;
            pts[2].x = mem_wid - (s_off*j + prev_cnt)*(double)wid2/true_steps;
            pts[2].y = mem_hyt - (s_off*j + prev_cnt)*(double)hyt2/true_steps;
            pts[3].x = (s_off*j + prev_cnt)*(double)wid1/true_steps;
            pts[3].y = mem_hyt - (s_off*j + prev_cnt)*(double)hyt2/true_steps;
            MS_Polygon(mem_hdc, pts, 4);

            MS_SelectObject(mem_hdc, old_brush);
            MS_DeleteObject(hbrush);
            }

        /* set the background color to the previous foreground */
        fore_pixel = back_pixel;
        prev_cnt = skip_cnt;
        }

    if ( color_steps <= 0 || !did_patterns )
        {
        /* no color steps, just fill whole object with foreground */
        hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(fore_pixel));
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        MS_PatBlt(mem_hdc, 0, 0, mem_wid, mem_hyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);
        }

    /* rotate the unionized shape so we can create a new memory DC,
     * onto which we will actually rotate the gradient with PlgBlt.
     */
    center.x = xpos + x_off + uwid/2;
    center.y = ypos + y_off + uhyt/2;
    upts[0].x = upts[2].x = xpos;
    upts[0].y = upts[1].y = ypos;
    upts[1].x = upts[3].x = xpos + uwid;
    upts[2].y = upts[3].y = ypos + uhyt;
    nt_rotate_around_center(&upts[0], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[1], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[2], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[3], &center, sinAng, cosAng);

    xpos = MIN( MIN( MIN(upts[0].x, upts[1].x), upts[2].x), upts[3].x);
    ypos = MIN( MIN( MIN(upts[0].y, upts[1].y), upts[2].y), upts[3].y);
    swid = MAX( MAX( MAX(upts[0].x, upts[1].x), upts[2].x ), upts[3].x);
    swid -= xpos;
    shyt = MAX( MAX( MAX(upts[0].y, upts[1].y), upts[2].y ), upts[3].y);
    shyt -= ypos;

    src_x = (swid - orig_wid) / 2;
    src_y = (shyt - orig_hyt) / 2;
    src_dc = MS_CreateCompatibleDC(NULL);
    src_hbm = MS_CreateCompatibleBitmap(RootWin, swid, shyt);
    MS_SelectObject(src_dc, src_hbm);

    /* first, rotate the rect gradient to a memory dc */
    rpts[0].x = upts[0].x - xpos;    /* upper left corner */
    rpts[0].y = upts[0].y - ypos;
    rpts[1].x = upts[1].x - xpos;    /* upper right corner */
    rpts[1].y = upts[1].y - ypos;
    rpts[2].x = upts[2].x - xpos;
    rpts[2].y = upts[2].y - ypos;    /* lower left corner */
    MS32_PlgBlt(src_dc, rpts, mem_hdc, 0, 0, uwid, uhyt, NULL, 0, 0);
    /* draw the linear gradient to screen thru shape mask. */
    /* rop_code = 0xAACC0000;   non-transparent ROP4 code. */
    MS32_MaskBlt(draw_dc, orig_x, orig_y, orig_wid, orig_hyt,
                        src_dc, src_x, src_y, mask_hbm, 0, 0,
                        MAKEROP4(SRCCOPY, 0x00AA0029));

    /* cleanup */
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_SelectObject(mem_hdc, old_pen);
    MS_DeleteDC(mem_hdc);
    MS_DeleteObject(mem_hbm);
    if ( delete_dc )
        MS_DeleteDC(draw_dc);
    MS_DeleteObject(src_hbm);
    MS_DeleteDC(src_dc);
}

void
win_solid_gradient(HDC draw_dc, unsigned long pixel, int xpos, int ypos,
                                                        HBITMAP mask_hbm)
{
    HDC mask_dc, mem_dc;
    HBRUSH hbrush, old_brush;
    HBITMAP mem_hbm, old_hbm, old_mask_hbm;
    HPALETTE old_palette, old_mem_palette;
    DWORD rasterop;
    COLORREF old_bk_color, old_text_color;
    int mem_wid, mem_hyt;


    old_palette = SelectAndRealizeAxWinPalette(draw_dc);

    /* get reasonable memory dc dimensions. */
    mem_wid = mem_hyt = hypot((double)AxWinDisplayWidth, (double)AxWinDisplayHeight);
    mem_dc = MS_CreateCompatibleDC(draw_dc);
    mem_hbm = MS_CreateCompatibleBitmap(draw_dc, mem_wid, mem_hyt);
    old_hbm = MS_SelectObject(mem_dc, mem_hbm);

    old_mem_palette = SelectAndRealizeAxWinPalette(mem_dc);
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(pixel));
    old_brush = MS_SelectObject(mem_dc, hbrush);
    MS_PatBlt(mem_dc, 0, 0, mem_wid, mem_hyt, PATCOPY);

    mask_dc = MS_CreateCompatibleDC(draw_dc);
    old_mask_hbm = MS_SelectObject(mask_dc, mask_hbm);

    /* "True Mask Method" of doing transparency. */
    MS_BitBlt(draw_dc, 0, 0, mem_wid, mem_hyt, mem_dc, 0, 0, SRCINVERT);
    old_bk_color = MS_SetBkColor(draw_dc, RGB(255, 255, 255));
    old_text_color = MS_SetTextColor(draw_dc, RGB(0,0,0));
    rasterop = 0x220326;   /* not source and destination */
    MS_BitBlt(draw_dc, xpos,ypos, AX_GRADIENT_THRESHOLD,AX_GRADIENT_THRESHOLD,
                                                    mask_dc, 0, 0, rasterop);
    MS_SetBkColor(draw_dc, old_bk_color);
    MS_SetTextColor(draw_dc, old_text_color);
    MS_BitBlt(draw_dc, 0, 0, mem_wid, mem_hyt, mem_dc, 0, 0, SRCINVERT);

    /* cleanup */
    MS_SelectObject(mask_dc, old_mask_hbm);
    MS_DeleteDC(mask_dc);
    MS_SelectObject(mem_dc, old_brush);
    MS_SelectObject(mem_dc, old_hbm);
    MS_DeleteDC(mem_dc);
    MS_DeleteObject(mem_hbm);
    MS_DeleteObject(hbrush);

    UnSelectPalette(draw_dc, old_palette);
    UnSelectPalette(mem_dc, old_mem_palette);
}

void
win_mask_solid_gradient(HDC draw_dc, unsigned long pixel, int xpos, int ypos,
                                                        HBITMAP mask_hbm)
{
    HDC mask_dc, mem_dc;
    HBRUSH hbrush, old_brush;
    HBITMAP mem_hbm, old_hbm, old_mask_hbm;
    HPALETTE old_palette, old_mem_palette;
    DWORD rasterop;
    COLORREF black, white, old_bk_color, old_text_color;
    int mem_wid, mem_hyt;
    HBITMAP pattern;

    get_black_white_colors(&black, &white);

    old_palette = SelectAndRealizeAxWinPalette(draw_dc);

    /* get reasonable memory dc dimensions. */
    mem_wid = mem_hyt = hypot((double)AxWinDisplayWidth, (double)AxWinDisplayHeight);
    mem_dc = MS_CreateCompatibleDC(draw_dc);
    mem_hbm = MS_CreateCompatibleBitmap(draw_dc, mem_wid, mem_hyt);
    old_hbm = MS_SelectObject(mem_dc, mem_hbm);

    old_mem_palette = SelectAndRealizeAxWinPalette(mem_dc);
    MS_SetBkColor(mem_dc, GET_COLOR_VALUE(pixel));
    MS_SetTextColor(mem_dc, black);
    get_gradient_map(&pattern, N_GRAD_PATS/2, 0);
    hbrush = MS_CreatePatternBrush(pattern);
    old_brush = MS_SelectObject(mem_dc, hbrush);
    MS_PatBlt(mem_dc, 0, 0, mem_wid, mem_hyt, PATCOPY);

    mask_dc = MS_CreateCompatibleDC(draw_dc);
    old_mask_hbm = MS_SelectObject(mask_dc, mask_hbm);

    /* "True Mask Method" of doing transparency. */
    MS_BitBlt(draw_dc, 0, 0, mem_wid, mem_hyt, mem_dc, 0, 0, SRCINVERT);
    old_bk_color = MS_SetBkColor(draw_dc, white);
    old_text_color = MS_SetTextColor(draw_dc, black);
    rasterop = 0x220326;   /* not source and destination */
    MS_BitBlt(draw_dc, xpos,ypos, AX_GRADIENT_THRESHOLD,AX_GRADIENT_THRESHOLD,
                                                    mask_dc, 0, 0, rasterop);
    MS_SetBkColor(draw_dc, old_bk_color);
    MS_SetTextColor(draw_dc, old_text_color);
    MS_BitBlt(draw_dc, 0, 0, mem_wid, mem_hyt, mem_dc, 0, 0, SRCINVERT);

    /* cleanup */
    MS_SelectObject(mask_dc, old_mask_hbm);
    MS_DeleteDC(mask_dc);
    MS_SelectObject(mem_dc, old_brush);
    MS_SelectObject(mem_dc, old_hbm);
    MS_DeleteDC(mem_dc);
    MS_DeleteObject(mem_hbm);
    MS_DeleteObject(hbrush);

    UnSelectPalette(draw_dc, old_palette);
    UnSelectPalette(mem_dc, old_mem_palette);
}



void
axmsGetGradientColorInfo(attr_type *attr, int hyt, int for_lines,
                            int *f_c, int *f_m, int *f_y,
                            int *b_c, int *b_m, int *b_y,
                            int *color_steps)
{
    int avail, steps;

    /* remove black component from color step calcs */
    if ( for_lines )
        {
        *f_c = MIN(attr->lfg.c + attr->lfg.k, 255);
        *f_m = MIN(attr->lfg.m + attr->lfg.k, 255);
        *f_y = MIN(attr->lfg.y + attr->lfg.k, 255);
        *b_c = MIN(attr->lbg.c + attr->lbg.k, 255);
        *b_m = MIN(attr->lbg.m + attr->lbg.k, 255);
        *b_y = MIN(attr->lbg.y + attr->lbg.k, 255);
        }
    else
        {
        *f_c = MIN(attr->ffg.c + attr->ffg.k, 255);
        *f_m = MIN(attr->ffg.m + attr->ffg.k, 255);
        *f_y = MIN(attr->ffg.y + attr->ffg.k, 255);
        *b_c = MIN(attr->fbg.c + attr->fbg.k, 255);
        *b_m = MIN(attr->fbg.m + attr->fbg.k, 255);
        *b_y = MIN(attr->fbg.y + attr->fbg.k, 255);
        }

    /* get the number of divisible sections */
    avail = MAX(1, (int)(hyt/(N_GRAD_PATS+1)));

    /* get the maximum number of color steps */
    steps = ABS(*f_c - *b_c);
    steps = MAX(ABS(*f_m - *b_m), steps);
    steps = MAX(ABS(*f_y - *b_y), steps);
    *color_steps = MIN(avail, steps);
}


/***  TRANSPARENT GRADIENT FUNCTIONS: ***/
/****************************************************************************/
void
win_mask_linear_gradient(HDC dst_dc, GC gc, int xpos, int ypos, int uwid,
                        int uhyt, int orig_x, int orig_y, int orig_wid,
                        int orig_hyt, unsigned long drawing_pixel, int inv,
                        double sinAng, double cosAng, int y_offset)
{
    int src_x, src_y, swid, shyt, tmp_wid;
    int j, patHyt, last_ypos, mem_ypos, last_hyt, mem_offset;
    COLORREF fore_color, back_color, white_color, black_color;
    int delete_dc;
    HDC src_dc, mem_hdc;
    HBRUSH hbrush, old_brush, drawing_brush, old_drawing_brush;
    HBITMAP pattern, mem_hbm, mask_hbm, old_hbm, src_hbm;
    HPALETTE old_palette, old_drawing_palette;
    COLORREF old_bk_color;
    POINT rpts[3], upts[4];
    XPoint center;

    dst_dc = InsureDrawable(dst_dc, &delete_dc);
    mask_hbm = gc->values.clip_mask;

    tmp_wid = hypot((double)uwid, (double)uhyt);
    if ( tmp_wid > AX_GRADIENT_THRESHOLD )
        {
        /* dimensions that are too big will eat up GDI resources,
         * so instead of drawing a gradient, we draw a solid color
         * that best approximates the 2 gradient colors.
         */
        win_mask_solid_gradient(dst_dc, drawing_pixel, xpos, ypos, mask_hbm);
        if ( delete_dc )
            MS_DeleteDC(dst_dc);
        return;
        }

    patHyt = uhyt/(N_GRAD_PATS + 1);
    if ( y_offset > 0 )
        mem_ypos = y_offset;
    else
        mem_ypos = 0;
    mem_offset = mem_ypos;

    get_black_white_colors(&black_color, &white_color);
    if ( inv )
        {
        back_color = white_color;
        fore_color = black_color;
        }
    else
        {
        back_color = black_color;
        fore_color = white_color;
        }

    /* create a memory dc to do our linear drawing on. */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, uwid, uhyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);
    MS_PatBlt(mem_hdc, 0, 0, uwid, uhyt, BLACKNESS);

    /* set mono colors */
    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    MS_SetBkColor(mem_hdc, fore_color);
    MS_SetTextColor(mem_hdc, back_color);
    for ( j=0; j<N_GRAD_PATS; j++ )
        {
        mem_ypos = mem_offset + (j*patHyt);
        get_gradient_map(&pattern, j, 0);
        hbrush = MS_CreatePatternBrush(pattern);
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        MS_PatBlt(mem_hdc, 0, mem_ypos, uwid, patHyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);
        }

    /* fill remainder with pure background */
    if ( y_offset <= 0 )
        {
        if ( y_offset == 0 )
            {
            last_ypos = y_offset + N_GRAD_PATS*patHyt;
            last_hyt = y_offset + uhyt - last_ypos;
            }
        else
            {
            last_ypos = uhyt - (-1)*y_offset;
            if ( last_ypos > mem_ypos )
                last_ypos = mem_ypos; 
            last_hyt  = uhyt - last_ypos;
            }
        }
     else
        {
        last_ypos = mem_offset + N_GRAD_PATS*patHyt;
        last_hyt  = uhyt - last_ypos;
        }
    hbrush = MS_CreateSolidBrush(fore_color);
    old_brush = MS_SelectObject(mem_hdc, hbrush);
    MS_PatBlt(mem_hdc, 0, last_ypos, uwid, last_hyt, PATCOPY);
    MS_SelectObject(mem_hdc, old_brush);
    MS_DeleteObject(hbrush);


    /* rotate the unionized shape so we can create a new memory DC,
     * onto which we will actually rotate the gradient with PlgBlt.
     */
    center.x = xpos + uwid/2;
    center.y = ypos + uhyt/2;
    upts[0].x = upts[2].x = xpos;
    upts[0].y = upts[1].y = ypos;
    upts[1].x = upts[3].x = xpos + uwid;
    upts[2].y = upts[3].y = ypos + uhyt;
    nt_rotate_around_center(&upts[0], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[1], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[2], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[3], &center, sinAng, cosAng);

    xpos = MIN( MIN( MIN(upts[0].x, upts[1].x), upts[2].x), upts[3].x);
    ypos = MIN( MIN( MIN(upts[0].y, upts[1].y), upts[2].y), upts[3].y);
    swid = MAX( MAX( MAX(upts[0].x, upts[1].x), upts[2].x), upts[3].x) - xpos;
    shyt = MAX( MAX( MAX(upts[0].y, upts[1].y), upts[2].y), upts[3].y) - ypos;

    src_x = (swid - orig_wid) / 2;
    src_y = (shyt - orig_hyt) / 2;
    src_dc = MS_CreateCompatibleDC(NULL);
    src_hbm = MS_CreateCompatibleBitmap(RootWin, swid, shyt);
    MS_SelectObject(src_dc, src_hbm);

    /* first, rotate the bilinear gradient to a memory dc */
    rpts[0].x = upts[0].x - xpos;    /* upper left corner */
    rpts[0].y = upts[0].y - ypos;
    rpts[1].x = upts[1].x - xpos;    /* upper right corner */
    rpts[1].y = upts[1].y - ypos;
    rpts[2].x = upts[2].x - xpos;
    rpts[2].y = upts[2].y - ypos;    /* lower left corner */
    MS32_PlgBlt(src_dc, rpts, mem_hdc, 0, 0, uwid, uhyt, NULL, 0, 0);

    old_drawing_palette = SelectAndRealizeAxWinPalette(dst_dc);
    drawing_brush = MS_CreateSolidBrush(GET_COLOR_VALUE(drawing_pixel));
    old_drawing_brush = MS_SelectObject(dst_dc, drawing_brush);
    old_bk_color = MS_SetBkColor(dst_dc, GET_COLOR_VALUE(drawing_pixel));
    /* draw the linear gradient to screen thru shape mask. */
    /* rop_code = 0xAAE20000;       transparent ROP4 code. */
    MS32_MaskBlt(dst_dc, orig_x, orig_y, orig_wid, orig_hyt,
                        src_dc, src_x, src_y, mask_hbm, 0, 0,
                        MAKEROP4(0x00E20746, 0x00AA0029));

    /* cleanup */
    MS_SetBkColor(dst_dc, old_bk_color);
    MS_SelectObject(dst_dc, old_drawing_brush);

    UnSelectPalette(dst_dc, old_drawing_palette);
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);

    MS_DeleteObject(mem_hbm);
    MS_DeleteObject(drawing_brush);
    MS_DeleteDC(mem_hdc);
    if ( delete_dc )
        MS_DeleteDC(dst_dc);
    MS_DeleteObject(src_hbm);
    MS_DeleteDC(src_dc);
}

void
win_mask_bilinear_gradient(HDC dst_dc, GC gc, int xpos, int ypos,
                            int uwid, int uhyt, int orig_x, int orig_y,
                            int orig_wid, int orig_hyt, int patHyt,
                            unsigned long drawing_pixel, int inv,
                            double sinAng, double cosAng)
{
    int last_hyt, last_ypos, tmp_wid;
    int j, mem_ypos1, mem_ypos2, delete_dc;
    int src_x, src_y, swid, shyt;
    HDC src_dc, mem_hdc;
    HPEN hpen, old_pen;
    HBRUSH hbrush, old_brush, drawing_brush, old_drawing_brush;
    HBITMAP pattern, mem_hbm, mask_hbm, old_hbm, src_hbm;
    HPALETTE old_palette, old_drawing_palette;
    COLORREF old_bk_color;
    COLORREF fore_color, back_color, white_color, black_color;
    POINT rpts[3], upts[4];
    XPoint center;

    dst_dc = InsureDrawable(dst_dc, &delete_dc);
    mask_hbm = gc->values.clip_mask;

    tmp_wid = hypot((double)uwid, (double)uhyt);
    if ( tmp_wid > AX_GRADIENT_THRESHOLD )
        {
        /* dimensions that are too big will eat up GDI resources,
         * so instead of drawing a gradient, we draw a solid color
         * that best approximates the 2 gradient colors.
         */
        win_mask_solid_gradient(dst_dc, drawing_pixel, xpos, ypos, mask_hbm);
        if ( delete_dc )
            MS_DeleteDC(dst_dc);
        return;
        }

    get_black_white_colors(&black_color, &white_color);
    if ( inv )
        {
        back_color = white_color;
        fore_color = black_color;
        }
    else
        {
        back_color = black_color;
        fore_color = white_color;
        }

    /* create a memory dc to do our bilinear drawing on. */
    /* uwid and uhyt represent the union of the original shape
     * and the rotated shape.
     */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, uwid, uhyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);

    hpen = (HPEN) MS_GetStockObject(NULL_PEN);
    old_pen = MS_SelectObject(mem_hdc, hpen);

    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    /* set mono colors */
    MS_SetBkColor(mem_hdc, fore_color);
    MS_SetTextColor(mem_hdc, back_color);
    /* do the bg/fg mix - 100%,87%,75%,62%,50%,37%,25%,12% */
    mem_ypos1 = 0;
    mem_ypos2 = uhyt - patHyt;
    for ( j=0; j<N_GRAD_PATS; j++ )
        {
        get_gradient_map(&pattern, j, 0);
        hbrush = MS_CreatePatternBrush(pattern);
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        /* top part of gradient. */
        MS_PatBlt(mem_hdc, 0, mem_ypos1, uwid, patHyt, PATCOPY);
        /* bottom part of gradient */
        MS_PatBlt(mem_hdc, 0, mem_ypos2, uwid, patHyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);

        mem_ypos1 += patHyt;
        mem_ypos2 -= patHyt;
        }

    /* fill remainder with pure background */
    last_hyt = (mem_ypos2 - mem_ypos1) + patHyt;
    last_ypos = mem_ypos1;
    hbrush = MS_CreateSolidBrush(fore_color);
    old_brush = MS_SelectObject(mem_hdc, hbrush);
    MS_PatBlt(mem_hdc, 0, last_ypos, uwid, last_hyt, PATCOPY);
    MS_SelectObject(mem_hdc, old_brush);
    MS_DeleteObject(hbrush);

    /* rotate the unionized shape so we can create a new memory DC,
     * onto which we will actually rotate the gradient with PlgBlt.
     */
    center.x = xpos + uwid/2;
    center.y = ypos + uhyt/2;
    upts[0].x = upts[2].x = xpos;
    upts[0].y = upts[1].y = ypos;
    upts[1].x = upts[3].x = xpos + uwid;
    upts[2].y = upts[3].y = ypos + uhyt;
    nt_rotate_around_center(&upts[0], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[1], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[2], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[3], &center, sinAng, cosAng);

    xpos = MIN( MIN( MIN(upts[0].x, upts[1].x), upts[2].x), upts[3].x);
    ypos = MIN( MIN( MIN(upts[0].y, upts[1].y), upts[2].y), upts[3].y);
    swid = MAX( MAX( MAX(upts[0].x, upts[1].x), upts[2].x), upts[3].x) - xpos;
    shyt = MAX( MAX( MAX(upts[0].y, upts[1].y), upts[2].y), upts[3].y) - ypos;
    src_x = orig_x - xpos;
    src_y = orig_y - ypos;

    src_dc = MS_CreateCompatibleDC(NULL);
    src_hbm = MS_CreateCompatibleBitmap(RootWin, swid, shyt);
    MS_SelectObject(src_dc, src_hbm);

    /* first, rotate the bilinear gradient to a memory dc */
    rpts[0].x = upts[0].x - xpos;    /* upper left corner */
    rpts[0].y = upts[0].y - ypos;
    rpts[1].x = upts[1].x - xpos;    /* upper right corner */
    rpts[1].y = upts[1].y - ypos;
    rpts[2].x = upts[2].x - xpos;
    rpts[2].y = upts[2].y - ypos;    /* lower left corner */
    MS32_PlgBlt(src_dc, rpts, mem_hdc, 0, 0, uwid, uhyt, NULL, 0, 0);
    /* now blt to the screen thru the object mask. */
    old_drawing_palette = SelectAndRealizeAxWinPalette(dst_dc);
    drawing_brush = MS_CreateSolidBrush(GET_COLOR_VALUE(drawing_pixel));
    old_drawing_brush = MS_SelectObject(dst_dc, drawing_brush);
    old_bk_color = MS_SetBkColor(dst_dc, GET_COLOR_VALUE(drawing_pixel));
    /* rop_code = 0xAAE20000;       transparent ROP4 code. */
    MS32_MaskBlt(dst_dc, orig_x, orig_y, orig_wid, orig_hyt,
                        src_dc, src_x, src_y, mask_hbm, 0, 0,
                        MAKEROP4(0x00E20746, 0x00AA0029));

    /* cleanup */
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_SelectObject(mem_hdc, old_pen);
    MS_DeleteDC(mem_hdc);
    MS_DeleteObject(mem_hbm);

    MS_SetBkColor(dst_dc, old_bk_color);
    MS_SelectObject(dst_dc, old_drawing_brush);
    UnSelectPalette(dst_dc, old_drawing_palette);

    if ( delete_dc )
        MS_DeleteDC(dst_dc);
    MS_DeleteObject(src_hbm);
    MS_DeleteDC(src_dc);
}

#if 0
    /* comment out transparent rect and radial gradients for now.
     * they aren't an X feature, anyway...
     */
void
do_mask_rect_gradient(HDC dst_dc, GC gc, int xpos,int ypos, int uwid,int uhyt,
            attr_type *attr, int for_lines)
{
    int delete_dc;
    HDC mem_hdc;
    HBRUSH hbrush, old_brush, drawing_brush, old_drawing_brush;
    LOGBRUSH lbrush;
    DWORD fg_rop_code, bg_rop_code;
    BOOL ret;
    int rect_xpos, rect_ypos, rect_wid, rect_hyt;
    int j, patHyt, inv;
    int c, m, y, k;
    unsigned long back_pixel, fore_pixel, drawing_pixel, white_pixel, black_pixel;
    HBITMAP pattern, mem_hbm, mask_hbm, old_hbm;
    HPALETTE old_palette, old_drawing_palette;
    COLORREF old_bk_color;


    dst_dc = InsureDrawable(dst_dc, &delete_dc);
    mask_hbm = gc->values.clip_mask;
    /* set the color */
    if ( for_lines )
    {
        inv = attr->lfg.see_thru ? TRUE : FALSE;
        if ( inv )
        {
            c = attr->lbg.c;
            m = attr->lbg.m;
            y = attr->lbg.y;
            k = attr->lbg.k;
        }
        else
        {
            c = attr->lfg.c;
            m = attr->lfg.m;
            y = attr->lfg.y;
            k = attr->lfg.k;
        }
    }
    else
    {
        inv = attr->ffg.see_thru ? TRUE : FALSE;
        if ( inv )
        {
            c = attr->fbg.c;
            m = attr->fbg.m;
            y = attr->fbg.y;
            k = attr->fbg.k;
        }
        else
        {
            c = attr->ffg.c;
            m = attr->ffg.m;
            y = attr->ffg.y;
            k = attr->ffg.k;
        }
    }
    AxGetRealPixel(2, c,m,y,k, 255, &drawing_pixel);
    get_black_white_pixels( &white_pixel, &black_pixel );
    if ( inv )
        {
        back_pixel = white_pixel;
        fore_pixel = black_pixel;
        }
    else
        {
        back_pixel = black_pixel;
        fore_pixel = white_pixel;
        }


    /* create a memory dc to do our rectangular drawing on. */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, uwid, uhyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);

    rect_wid = uwid;
    rect_hyt = uhyt;
    rect_xpos = rect_ypos = 0;
    patHyt = (height/(N_GRAD_PATS + 1)) / 2;
    /* set mono colors */
    MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
    MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));
    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    for ( j=0; j < N_GRAD_PATS; j++ )
        {
        get_gradient_map(&pattern, j, TRUE);
        hbrush = MS_CreatePatternBrush(pattern);
        old_brush = MS_SelectObject(mem_hdc, hbrush);
        MS_PatBlt(mem_hdc, rect_xpos, rect_ypos, rect_wid, rect_hyt, PATCOPY);
        MS_SelectObject(mem_hdc, old_brush);
        MS_DeleteObject(hbrush);

        rect_xpos += patHyt;
        rect_ypos += patHyt;
        rect_wid -= (patHyt*2);
        rect_hyt -= (patHyt*2);
        }

    /* get last rect dimensions */
    rect_xpos += patHyt;
    rect_ypos += patHyt;
    rect_wid -= (patHyt*2);
    rect_hyt -= (patHyt*2);
    /* fill remainder with pure background */
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(back_pixel));
    old_brush = MS_SelectObject(mem_hdc, hbrush);
    MS_PatBlt(mem_hdc, rect_xpos, rect_ypos, rect_wid, rect_hyt, PATCOPY);
    MS_SelectObject(mem_hdc, old_brush);
    MS_DeleteObject(hbrush);

    /* rotate the unionized shape so we can create a new memory DC,
     * onto which we will actually rotate the gradient with PlgBlt.
     */
    center.x = xpos + uwid/2;
    center.y = ypos + uhyt/2;
    upts[0].x = upts[2].x = xpos;
    upts[0].y = upts[1].y = ypos;
    upts[1].x = upts[3].x = xpos + uwid;
    upts[2].y = upts[3].y = ypos + uhyt;
    nt_rotate_around_center(&upts[0], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[1], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[2], &center, sinAng, cosAng);
    nt_rotate_around_center(&upts[3], &center, sinAng, cosAng);
    xpos = MIN( MIN( MIN(upts[0].x, upts[1].x), upts[2].x), upts[3].x);
    ypos = MIN( MIN( MIN(upts[0].y, upts[1].y), upts[2].y), upts[3].y);
    swid = MAX( MAX( MAX(upts[0].x, upts[1].x), upts[2].x), upts[3].x) - xpos;
    shyt = MAX( MAX( MAX(upts[0].y, upts[1].y), upts[2].y), upts[3].y) - ypos;

    src_x = orig_x - xpos;
    src_y = orig_y - ypos;
    src_dc = MS_CreateCompatibleDC(NULL);
    src_hbm = MS_CreateCompatibleBitmap(RootWin, swid, shyt);
    MS_SelectObject(src_dc, src_hbm);

    /* first, rotate the bilinear gradient to a memory dc */
    rpts[0].x = upts[0].x - xpos;    /* upper left corner */
    rpts[0].y = upts[0].y - ypos;
    rpts[1].x = upts[1].x - xpos;    /* upper right corner */
    rpts[1].y = upts[1].y - ypos;
    rpts[2].x = upts[2].x - xpos;
    rpts[2].y = upts[2].y - ypos;    /* lower left corner */
    MS32_PlgBlt(src_dc, rpts, mem_hdc, 0, 0, uwid, uhyt, NULL, 0, 0);

    old_drawing_palette = SelectAndRealizeAxWinPalette(xwin);
    drawing_brush = MS_CreateSolidBrush(GET_COLOR_VALUE(drawing_pixel));
    old_drawing_brush = MS_SelectObject(xwin, drawing_brush);
    old_bk_color = MS_SetBkColor(xwin, GET_COLOR_VALUE(drawing_pixel));
    /* draw the rect gradient to screen thru shape mask. */
    /* rop_code = 0xAAE20000;     transparent ROP4 code. */
#if 1
    MS32_MaskBlt(dst_dc, orig_x, orig_y, orig_wid, orig_hyt,
                        src_dc, src_x, src_y, mask_hbm, 0, 0,
                        MAKEROP4(0x00E20746, 0x00AA0029));
#else
    fg_rop_code = 0x00E20746;
    bg_rop_code = 0x00AA0029;
    ret = AxWinMaskBlt(xwin, xpos, ypos, width, height,
                        mem_hdc, 0, 0, mask_hbm, 0, 0,
                        fg_rop_code, bg_rop_code);
#endif
    /* cleanup */
    MS_SetBkColor(xwin, old_bk_color);
    MS_SelectObject(xwin, old_drawing_brush);

    UnSelectPalette(xwin, old_drawing_palette);
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);

    MS_DeleteObject(mem_hbm);
    MS_DeleteObject(drawing_brush);
    MS_DeleteDC(mem_hdc);
    if ( delete_xwin )
        MS_DeleteDC(xwin);
}

void
do_mask_radial_gradient(Drawable xwin, GC gc, int xpos, int ypos, int width,
                                int height, attr_type *attr, int for_lines)
{
    int delete_xwin;
    HDC mask_dc, temp_dc, mem_hdc;
    HPEN hpen, old_pen;
    HBRUSH hbrush, old_brush, drawing_brush, old_drawing_brush;
    LOGBRUSH lbrush;
    DWORD fg_rop_code, bg_rop_code, pen_style;
    BOOL ret;
    int arc_wid, arc_hyt, arc_xpos, arc_ypos;
    int dc_wid, dc_hyt, pen_width, mask_x, mask_y;
    int j, patHyt, inv;
    int c, m, y, k, size;
    unsigned long back_pixel, fore_pixel, drawing_pixel, white_pixel, black_pixel;
    HBITMAP pattern, mem_hbm, mask_hbm;
    HBITMAP old_hbm, old_mask_hbm, old_temp_hbm;
    HPALETTE old_palette, old_drawing_palette;
    COLORREF old_bk_color;


    xwin = InsureDrawable(xwin, &delete_xwin);
    /* set the size of the field */
    size = (int)hypot((double)width, (double)height);

    /* set the color */
    if ( for_lines )
    {
        inv = attr->lfg.see_thru ? TRUE : FALSE;
        if ( inv )
        {
            c = attr->lbg.c;
            m = attr->lbg.m;
            y = attr->lbg.y;
            k = attr->lbg.k;
        }
        else
        {
            c = attr->lfg.c;
            m = attr->lfg.m;
            y = attr->lfg.y;
            k = attr->lfg.k;
        }
    }
    else
    {
        inv = attr->ffg.see_thru ? TRUE : FALSE;
        if ( inv )
        {
            c = attr->fbg.c;
            m = attr->fbg.m;
            y = attr->fbg.y;
            k = attr->fbg.k;
        }
        else
        {
            c = attr->ffg.c;
            m = attr->ffg.m;
            y = attr->ffg.y;
            k = attr->ffg.k;
        }
    }
    AxGetRealPixel(2, c,m,y,k, 255, &drawing_pixel);
    get_black_white_pixels( &white_pixel, &black_pixel );
    if ( inv )
        {
        back_pixel = white_pixel;
        fore_pixel = black_pixel;
        }
    else
        {
        back_pixel = black_pixel;
        fore_pixel = white_pixel;
        }

 
    /* create a mask of the shape. */
    dc_wid = dc_hyt = size;    /* square dimensions */
    /* our mask is the size of the polygon being drawn, but our *
     * radial drawing area is larger. Since the MS_MaskBlt call *
     * requires the src and mask to be the same size, we create *
     * a larger mask here, and blt the old one onto it.         */
    mask_dc = MS_CreateCompatibleDC(NULL);
    mask_hbm = MS_CreateCompatibleBitmap(mask_dc, dc_wid, dc_hyt);
    old_mask_hbm = MS_SelectObject(mask_dc, mask_hbm);
    MS_PatBlt(mask_dc, 0, 0, dc_wid, dc_hyt, BLACKNESS);

    /* select the previously created shape mask into our temp hdc. */
    temp_dc = MS_CreateCompatibleDC(NULL);
    old_temp_hbm = MS_SelectObject(temp_dc, gc->values.clip_mask);
    /* get center points */
    mask_x = (dc_wid / 2) - (width / 2);
    mask_y = (dc_hyt / 2) - (height / 2);
    MS_BitBlt(mask_dc, mask_x, mask_y, dc_wid, dc_hyt,
                            temp_dc, 0, 0, SRCCOPY);

    /* delete unnecessary objects, and save the new *
     * mask bitmap for later use in MS_MaskBlt.     */
    MS_SelectObject(mask_dc, old_mask_hbm);
    MS_SelectObject(temp_dc, old_temp_hbm);
    MS_DeleteDC(temp_dc);
    MS_DeleteDC(mask_dc);

    /* we will be using a geometric pen with a pattern */
    lbrush.lbStyle = BS_PATTERN;
    lbrush.lbColor = 0;    /* this field ignored when BS_PATTERN */

    /* create a memory dc to do our radial drawing on. */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(RootWin, dc_wid, dc_hyt);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);

    arc_wid = arc_hyt = size;
    arc_xpos = arc_ypos = 0;

    /* draw the gradient thru the mask */
    patHyt = height/(N_GRAD_PATS + 1);
    pen_width = patHyt + 5;    /* 5: fudge factor! */
    pen_style = PS_GEOMETRIC | PS_ENDCAP_FLAT | PS_JOIN_MITER;

    /* set mono colors */
    MS_SetBkColor(mem_hdc, GET_COLOR_VALUE(fore_pixel));
    MS_SetTextColor(mem_hdc, GET_COLOR_VALUE(back_pixel));
    old_palette = SelectAndRealizeAxWinPalette(mem_hdc);
    for ( j=0; j < N_GRAD_PATS; j++ )
        {
        get_gradient_map(&pattern, j, TRUE);
        lbrush.lbHatch = (LONG)pattern;
        hpen = (HPEN)MS32_ExtCreatePen(pen_style, pen_width,
                                            &lbrush, 0, NULL);
        old_pen = MS_SelectObject(mem_hdc, hpen);

        /* non-filled arc */
        MS_Arc(mem_hdc, arc_xpos, arc_ypos,
                arc_wid, arc_hyt,
                0, 0, 0, 0);

        arc_xpos += patHyt;
        arc_ypos += patHyt;
        size  -= patHyt;
        arc_wid = arc_hyt = size;

        MS_SelectObject(mem_hdc, old_pen);
        MS_DeleteObject(hpen);
        }

    /* last arc to draw, fill it. */
    hpen = MS_CreatePen(PS_SOLID, 0, GET_COLOR_VALUE(back_pixel));
    hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(back_pixel));
    old_pen = MS_SelectObject(mem_hdc, hpen);
    old_brush = MS_SelectObject(mem_hdc, hbrush);
    MS_Pie(mem_hdc, arc_xpos, arc_ypos,
                arc_wid, arc_hyt,
                0, 0, 0, 0);
    MS_SelectObject(mem_hdc, old_pen);
    MS_SelectObject(mem_hdc, old_brush);
    MS_DeleteObject(hpen);
    MS_DeleteObject(hbrush);

    old_drawing_palette = SelectAndRealizeAxWinPalette(xwin);
    drawing_brush = MS_CreateSolidBrush(GET_COLOR_VALUE(drawing_pixel));
    old_drawing_brush = MS_SelectObject(xwin, drawing_brush);
    old_bk_color = MS_SetBkColor(xwin, GET_COLOR_VALUE(drawing_pixel));

    /* draw the radial gradient to screen thru shape mask. */
    /* rop_code = 0xAAE20000;       transparent ROP4 code. */
    fg_rop_code = 0x00E20746;
    bg_rop_code = 0x00AA0029;
    ret = AxWinMaskBlt(xwin, xpos - mask_x, ypos - mask_y, dc_wid, dc_hyt,
                                         mem_hdc, 0, 0, mask_hbm, 0, 0,
                                         fg_rop_code, bg_rop_code);

    /* cleanup */
    MS_SetBkColor(xwin, old_bk_color);
    MS_SelectObject(xwin, old_drawing_brush);

    UnSelectPalette(xwin, old_drawing_palette);
    UnSelectPalette(mem_hdc, old_palette);
    MS_SelectObject(mem_hdc, old_hbm);

    MS_DeleteObject(mem_hbm);
    MS_DeleteObject(mask_hbm);
    MS_DeleteObject(drawing_brush);
    MS_DeleteDC(mem_hdc);
    if ( delete_xwin )
        MS_DeleteDC(xwin);
}
#endif  /* } 0 */
/**************** end transparent gradient funcs ***********************/



 
void
WinInitPredefinedAtoms(void)
{
    UINT atom_id;
 
    /* X does it free, but we must initialize these */
    /* at a minimum, maybe all of them */
    //WinInitAtom(Dpy,NXLT("XA_PRIMARY"), XA_PRIMARY);
    //WinInitAtom(Dpy,NXLT("XA_SECONDARY"), XA_SECONDARY);
    WinInitAtom(NULL, NXLT("XA_STRING"), XA_STRING);
 
    /* MS Windows private formats. */
    /* 1. RTF - what MS Word puts on the clipboard. */
    atom_id = MS_RegisterClipboardFormat(NXLT("Rich Text Format"));
    AxXA_RTF_DATA = AxWinExternAtom(NXLT("Rich Text Format"), atom_id);
}
 


int
MarkEditBoxRegion(AXWidget_editbox w, int start_row, int start_col,
                                        int end_row, int end_col)
{
    int start_char, end_char;

    /* first find out where the start and end character positons to be */
    /* marked are located.                                             */
    start_char = MS_SendMessage( w->winid, EM_LINEINDEX,
                                           (WPARAM)start_row, (LPARAM)0 );
    if ( start_char < 0 )
        /* out of bounds */
        return( -1 );
    start_char = start_char + start_col;

    end_char = MS_SendMessage( w->winid, EM_LINEINDEX,
                                           (WPARAM)end_row, (LPARAM)0 );
    if ( end_char < 0 )
        /* out of bounds */
        return( -1 );
    end_char = end_char + end_col;

    /* now set the mark */
    MS_SendMessage( w->winid, EM_SETSEL, 
                                     (WPARAM)start_char, (LPARAM)end_char );

    /* record selection in our widget struct in case we need to repaint */
    /*  (see PaintEditBox() )                                           */
    w->editbox->sel.startIndex = start_char;
    w->editbox->sel.endIndex = end_char;

    return( 0 );
}



/* If the edit box has been changed, return all of text in it, otherwise */
/* return NULL                                                          */
/* Note: the caller must free the returned string */
mbchar *
AxXmEditBoxEdited(AXWidget_editbox w)
{
   int ret;
   char *str;

   if ( w->type != W_EDITBOX )
        return((String)NULL);
 
   ret = MS_SendMessage( w->winid, EM_GETMODIFY, (WPARAM)0, (LPARAM)0 );
   if ( !ret )
       /* has not been modified */
       return( (mbchar *)NULL ); 

    /* It has been modified, return the text */
    str = getEditBoxData(w);

    return( str );
}




void
AxXmCopyEditBoxSeln(AXWidget w)
{
    AXWidget_entry childP;
 
    if ( !w )
        return;
    if ( w->type == W_MAIN )
        w = (AXWidget) ((AXWidget_main)w)->dialog;
    if ( !w || w->type != W_DIALOG )
        return;
 
    childP = ElfbGetActiveWidget(w);
    if ( childP )
        /* copy the selection to the clipboard  */
        MS_SendMessage( childP->winid, WM_COPY, (WPARAM)0, (LPARAM)0 );

    return;
}

void
AxXmCutEditBoxSeln(AXWidget w)
{
    AXWidget_entry childP;
 
    if ( !w )
        return;
    if ( w->type == W_MAIN )
        w = (AXWidget) ((AXWidget_main)w)->dialog;
    if ( !w || w->type != W_DIALOG )
        return;
 
    childP = ElfbGetActiveWidget(w);
    if ( childP )
        /* cut the selection to the clipboard  */
        MS_SendMessage( childP->winid, WM_CUT, (WPARAM)0, (LPARAM)0 );

    return;
}


void
AxXmPasteEditBoxSeln(AXWidget w)
{
    AXWidget_entry childP;
 
    if ( !w )
        return;
    if ( w->type == W_MAIN )
        w = (AXWidget) ((AXWidget_main)w)->dialog;
    if ( !w || w->type != W_DIALOG )
        return;
 
    childP = ElfbGetActiveWidget(w);
    if ( childP )
        /* paste the selection to the clipboard  */
        MS_SendMessage(childP->winid, WM_PASTE, (WPARAM)0, (LPARAM)0);

    return;
}



int AxXmGetEditBoxSelectedRegion(w, start_rowp, start_colp, end_rowp, end_colp)
AXWidget_editbox w;
int *start_rowp;
int *start_colp;
int *end_rowp;
int *end_colp;
{
    DWORD start_char, end_char;
    int line_start;

    /* get the start and end points of the selection */
    MS_SendMessage(w->winid, EM_GETSEL, (WPARAM)&start_char, (LPARAM)&end_char);

    if ( start_char > end_char )
        /* no selection */
        return -1;

    /* convert selection char positions to row + col offset */
    /* to do this we must get the start of the line, get the offset of the */
    /* start of the line, and then subtract to get the offset within the */
    /* line where the selection starts or ends                           */
    *start_rowp = MS_SendMessage( w->winid, EM_LINEFROMCHAR, 
                                           (WPARAM)start_char, (LPARAM)0 );
    line_start = MS_SendMessage( w->winid, EM_LINEINDEX, 
                                           (WPARAM)(*start_rowp), (LPARAM)0 );
    *start_colp = start_char - line_start;

    *end_rowp = MS_SendMessage( w->winid, EM_LINEFROMCHAR, 
                                           (WPARAM)end_char, (LPARAM)0 );
    line_start = MS_SendMessage( w->winid, EM_LINEINDEX, 
                                           (WPARAM)(*end_rowp), (LPARAM)0 );
    *end_colp = end_char - line_start;

    return( end_char - start_char );
}

/** make common once tree is unlocked? (X version in tmx.c)
 ** actually, may need to optimize this for Windows. It's pretty
 ** darn slow right now.        -donato
 **/
/**********************************************************************/
struct regionPack {
    char *back;
    char *data;
    char *mask;
    int wid, hyt;
    int clipX, clipY, clipWid, clipHyt;
    int old_x, old_y, old_wid, old_hyt;
};
void
AxMoveRegion(AXWidget w, int command_state, int x, int y,
                            struct regionPack *imPack)
{
    int i, j;
    int old_x, old_y, old_hyt, old_wid;
    int new_x, new_y, new_hyt, new_wid;
    XRectangle xClipRect;
    XImage *ximg;
    Drawable xwin;

    /* get the drawable */
    xwin = getWindowFromWidget((AXWidget_main)w);
    if ( command_state == 0 ) /* initialize region */
        {
        /* init */
        XSetState(Dpy, Gc1, FGpixel, BGpixel, GXcopy, (unsigned)AllPlanes);

        /* grab the image data */
        ximg = XGetImage(Dpy, xwin, x, y, imPack->wid, imPack->hyt,
                                        (unsigned)AllPlanes, ZPixmap);
        for ( i=0; i < ximg->height; i++ )
            {
            for ( j=0; j < ximg->width; j++ )
                {
                if ( XGetPixel(ximg, j, i) == AlisPixels[0] )
                    XPutPixel(ximg, j, i, 0);
                }
            }
        imPack->data = (char *)ximg;

        /* now create a mask for the image data */
        ximg = XGetImage(Dpy, xwin, x, y, imPack->wid, imPack->hyt,
                                        (unsigned)AllPlanes, ZPixmap);
        for ( i=0; i < ximg->height; i++ )
            {
            for ( j=0; j < ximg->width; j++ )
                {
                if ( XGetPixel(ximg, j, i) == AlisPixels[0] )
                    XPutPixel(ximg, j, i, 0);
                else
                    XPutPixel(ximg, j, i, (unsigned)AllPlanes);
                }
            }
        imPack->mask = (char *)ximg;
        }

    else if ( command_state == 1 ) /* move region */
        {
        if ( imPack->data == (char *)0 )
            return;

        /* note the location of the old image */
        old_x = imPack->old_x;
        old_y = imPack->old_y;
        old_wid = imPack->old_wid;
        old_hyt = imPack->old_hyt;

        /* make sure image region doesn't exceed window boundry */
        if ( x < imPack->clipX )
            {
            new_wid = imPack->wid - (imPack->clipX - x);
            new_x = imPack->clipX;
            }
        else
            {
            new_x = x;
            new_wid = imPack->wid;
            }

        if ( y < imPack->clipY )
            {
            new_hyt = imPack->hyt - (imPack->clipY - y);
            new_y = imPack->clipY;
            }
        else
            {
            new_y = y;
            new_hyt = imPack->hyt;
            }

        if ( new_x + new_wid > imPack->clipX + imPack->clipWid )
            {
            new_wid = imPack->clipX + imPack->clipWid - new_x;
            if ( new_wid < 0 )
                new_wid = 0;
            }
        else
            new_wid = imPack->wid;

        if ( new_y + new_hyt > imPack->clipY + imPack->clipHyt )
            {
            new_hyt = imPack->clipY + imPack->clipHyt - new_y;
            if ( new_hyt < 0 )
                new_hyt = 0;
            }
        else
            new_hyt = imPack->hyt;

        /* don't do anything if the region hasn't moved */
        if ( old_x == new_x && old_wid == new_wid &&
             old_y == new_y && old_hyt == new_hyt )
            return;

        /* note the size and shape of the clipped image */
        imPack->old_x = new_x;
        imPack->old_y = new_y;
        imPack->old_wid = new_wid;
        imPack->old_hyt = new_hyt;

        /* restore the old area, draw the region in the new place */
        XSetFunction(Dpy, Gc1, GXcopy);
        /* set up the clipping area */
        xClipRect.x = imPack->clipX;
        xClipRect.y = imPack->clipY;
        xClipRect.width  = imPack->clipWid;
        xClipRect.height = imPack->clipHyt;
        XSetClipRectangles(Dpy, Gc1, 0, 0, &xClipRect, 1, Unsorted);

        /* draw in the old background, then grab a new background */
        if( imPack->back )
            {
            XPutImage(Dpy, xwin, Gc1, (XImage *)(imPack->back),
                          0, 0, old_x, old_y, old_wid, old_hyt);
            XDestroyImage((XImage *)imPack->back);
            }
        imPack->back = (char *)XGetImage(Dpy, xwin, new_x, new_y,
                                            new_wid, new_hyt,
                                            (unsigned)AllPlanes, ZPixmap);

        /* lay down the mask */
        XSetFunction(Dpy, Gc1, GXandInverted);
        XPutImage(Dpy, xwin, Gc1, (XImage *)(imPack->mask), 0, 0, x, y,
                                            imPack->wid, imPack->hyt);

        /* display the region being moved */
        XSetFunction(Dpy, Gc1, GXor);
        //XSetForeground(Dpy, Gc1, AlisPixels[TMA_WHITE]);
        XSetBackground(Dpy, Gc1, AlisPixels[TMA_WHITE]);
        XPutImage(Dpy, xwin, Gc1, (XImage *)(imPack->data), 0, 0, x, y,
                                            imPack->wid, imPack->hyt);
        XSetFunction(Dpy, Gc1, GXcopy);
        }

    else if ( command_state == 2 ) /* reset */
        {
        xClipRect.x = imPack->clipX;
        xClipRect.y = imPack->clipY;
        xClipRect.width  = imPack->old_wid;
        xClipRect.height = imPack->old_hyt;
        XSetClipRectangles(Dpy, Gc1, 0, 0, &xClipRect, 1, Unsorted);
        if ( imPack->back )
            {
            XDestroyImage((XImage *)(imPack->back));
            imPack->back = (char *)0;
            }
        if ( imPack->mask )
            {
            XDestroyImage((XImage*)(imPack->mask));
            imPack->mask = (char *)0;
            }
        if ( imPack->data )
            {
            XDestroyImage((XImage*)(imPack->data));
            imPack->data = (char *)0;
            }
        imPack->clipX = imPack->clipY = imPack->clipWid = 0;
        imPack->clipHyt = imPack->wid = imPack->hyt = 0;
        imPack->old_x = imPack->old_y = 0;
        imPack->old_wid = imPack->old_hyt = 0;
        XSetClipMask(Dpy, Gc1, None);
        }
}


/* ----------------------------------------------------------------------- */
/* these 2 functions are taken from xmlib.c and they're not really obsolete.
 * perhaps they SHOULD be, but they are being used to decide whether some
 * windows are mapped or not (see bug18741.am for example).
/*
 * A x A d d N o M a p W i n d o w ()  OBSOLETE!!!!0
 *
 * Add a X-Window Title to the list of X-Windows NOT to be displayed
 */
AxAddNoMapWindow(WinName)   /* OBSOLETE!!!!0 */
char *WinName;
{
struct WINDNOMAP *ptr, *last;

        if ( WinName[0] == '\0' )
            {
            /* No Window Title */
            return(TRUE);
            }
        if ( WindNotMapped == (struct WINDNOMAP *)NULL )
            {
            /*
             * most often case, the list is empty
             */
            if ( (WindNotMapped = (struct WINDNOMAP *)malloc(sizeof(struct WINDNOMAP))) == (struct WINDNOMAP *)NULL )
                return(FALSE);
            WindNotMapped->next = (struct WINDNOMAP *)NULL;
            strcpy(WindNotMapped->title, WinName);
            return(TRUE);
            }

        ptr = WindNotMapped;
        while(ptr != (struct WINDNOMAP *)NULL)
            {
            if(!strcmp(WinName, ptr->title))
                {
                return(TRUE);
                }
            last = ptr;
            ptr = ptr->next;
            }

        /*
         * add to the end of the list
         */
        if((last->next = (struct WINDNOMAP *)malloc(sizeof(struct WINDNOMAP))) == (struct WINDNOMAP *)NULL)
            return(FALSE);
        ptr = last->next;
        ptr->next = (struct WINDNOMAP *)NULL;
        strcpy(ptr->title, WinName);

        return(TRUE);
}
/*
 * A x D e l N o M a p W i n d o w ()
 *
 * Delete a X-Window Title from the list of X-Windows NOT to be displayed
 */
AxDelNoMapWindow(WinName)   /* OBSOLETE!!!!0 */
char *WinName;
{
struct WINDNOMAP *ptr, *last;

    if(WinName == NULL)
        return(TRUE);

    ptr = last = WindNotMapped;
    while(ptr != (struct WINDNOMAP *)NULL)
        {
        if(!strcmp(WinName, ptr->title))
            {
            if(ptr == WindNotMapped)
                WindNotMapped = ptr->next;
            else
                last->next = ptr->next;

            free(ptr);
            return(TRUE);
            }
        last = ptr; 
        ptr = ptr->next;
        }
    return(FALSE);
}
/***************************************************************************/
/* ----------------------------------------------------------------------- */


/**** TEMP!  to go into winmap.h ****/
#define MS_LocalAlloc LocalAlloc
#define MS_LocalFree  LocalFree
/************************************/


/************************************************************************
* CreatePhysicalPalette
*
* Creates a palette for the app to use.  The palette references the
* physical palette, so that it can properly display images grabbed
* from palette managed apps.
*
* History:
*    This function was stolen from the sample code for the "zoom" utility
*    found (as of this rev) in "mstools\samples\sdktools\zoomin.c"
*
************************************************************************/
#define NPAL 256
static HPALETTE
CreatePhysicalPalette(void)
{
    LOGPALETTE *ppal;
    HPALETTE hpal = NULL;
    int ix;
 
    ppal = (LOGPALETTE*)MS_LocalAlloc(LPTR, sizeof(LOGPALETTE) +
                                    sizeof(PALETTEENTRY) * NPAL);
    if ( ppal )
        {
        ppal->palVersion = 0x300;
        ppal->palNumEntries = NPAL;
 
        for ( ix=0; ix < NPAL; ix++ )
            {
            ppal->palPalEntry[ix].peFlags = (BYTE)PC_EXPLICIT;
            ppal->palPalEntry[ix].peRed   = (BYTE)ix;
            ppal->palPalEntry[ix].peGreen = (BYTE)0;
            ppal->palPalEntry[ix].peBlue  = (BYTE)0;
            }
 
        hpal = MS_CreatePalette(ppal);
        MS_LocalFree(ppal);
        }
    return hpal;
}



/* this was used in the Win32 SDK sample (from which much of the
 * code in the folowing function is taken), but not defined! 
 * so i've set it to this arbitrary value.         -donato
 */
#define MAXWRITE 1024

/* This function takes a Windows bitmap handle and a filename
 * and writes the bitmap to the file in .BMP format.
 */
void
WriteBitmapToFile(HBITMAP hbm, char *bmp_file)
{
    int ncolors, sizeBMI;
    HDC hdc;
    BITMAPINFO *bmi;
    BITMAPINFOHEADER *bmih;
    HANDLE hf;                  /* file handle                */
    BITMAPFILEHEADER hdr;
    char *data_bits;
    DWORD dwTotal;              /* total count of bytes       */
    DWORD cb;                   /* incremental count of bytes */
    BYTE *hp;                   /* byte pointer               */
    DWORD dwTmp;
    HPALETTE hpal, old_palette;

/** most of this is taken from the Win32 SDK, Chap 29.2.3 **
 ** (with some modification, including bug fixes!)        **/

    hdc = MS_GetDC(NULL);
    /* make sure a physcial palette is selected into the device context
     * so that we get the proper colors.
     */
    hpal = CreatePhysicalPalette();
    old_palette = MS_SelectPalette(hdc, hpal, FALSE);
    MS_RealizePalette(hdc);

    /* First call GetDIBits with a zero'ed structure (particularly */
    /*   the bm_infoP->bmiHeader.biBitCount field) to get the image size */
    bmi = (BITMAPINFO*)calloc(1, sizeof(BITMAPINFO));
    bmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    if ( !MS_GetDIBits(hdc, hbm, (UINT)0, (UINT)0, (LPBYTE)NULL,
                       (LPBITMAPINFO)bmi, (DWORD)DIB_RGB_COLORS) )
        {
        taskAbort("WriteBitmapToFile: GetDIBits failed!");
        }

    ncolors = GetNumDIBColors(&bmi->bmiHeader);
    if ( ncolors )
        {
        /* has color table */
        sizeBMI = sizeof(BITMAPINFO) + sizeof(RGBQUAD) * ncolors;
        /* I need more memory for the color table */
        bmi = (BITMAPINFO *)realloc(bmi, sizeBMI);
        }
    if ( bmi->bmiHeader.biCompression == BI_BITFIELDS )
        {
        /* need more space for color mask values (3 double words). */
        sizeBMI = sizeof(BITMAPINFO) + (sizeof(DWORD) * 3);
        bmi = (BITMAPINFO *)realloc(bmi, sizeBMI);
        }

    bmih = (PBITMAPINFOHEADER)bmi;
    data_bits = (char*)malloc(bmih->biSizeImage);
    /*
     * Retrieve the color table (RGBQUAD array) and the bits
     * (array of palette indices) from the DIB.
     */
    if ( !MS_GetDIBits(hdc, hbm, 0, (WORD)bmih->biHeight,
                           data_bits, bmi, DIB_RGB_COLORS))
        taskAbort(NXLT("WriteBitmapToFile: GetDIBits failed!"));

    /* Create the .BMP file. */
    hf = CreateFile(bmp_file, GENERIC_READ | GENERIC_WRITE,
                       (DWORD)0, (LPSECURITY_ATTRIBUTES)NULL,
                       CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL,
                       (HANDLE) NULL);
    if ( hf == INVALID_HANDLE_VALUE )
        taskAbort(NXLT("WriteBitmapToFile: CreateFile failed!"));

    hdr.bfType = 0x4d42;        /* 0x42 = "B" 0x4d = "M" */
    /* Compute the size of the entire file. */
    if ( bmi->bmiHeader.biCompression == BI_BITFIELDS )
        {
        hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
                     bmih->biSize + 3 * sizeof(DWORD) +
                     bmih->biSizeImage);
        }
    else
        {
        hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
                     bmih->biSize + ncolors
                     * sizeof(RGBQUAD) + bmih->biSizeImage);
        }
    hdr.bfReserved1 = 0;
    hdr.bfReserved2 = 0;

    /* Compute the offset to the array of color indices. */
    if ( bmi->bmiHeader.biCompression == BI_BITFIELDS )
        {
        hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
                        bmih->biSize + 3 * sizeof(DWORD);
        }
    else
        {
        hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
                    bmih->biSize + ncolors * sizeof (RGBQUAD);
        }

    /* Copy the BITMAPFILEHEADER into the .BMP file. */
    if ( !WriteFile(hf, (LPVOID)&hdr, sizeof(BITMAPFILEHEADER),
                       (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL) )
       taskAbort(NXLT("WriteBitmapToFile: WriteFile failed"));

    /* Copy the BITMAPINFOHEADER and RGBQUAD array into the file. */
    if ( bmi->bmiHeader.biCompression == BI_BITFIELDS )
        {
        if ( !WriteFile(hf, (LPVOID)bmih, sizeof(BITMAPINFOHEADER)
                          + 3 * sizeof(DWORD),
                          (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL) )
           taskAbort(NXLT("WriteBitmapToFile: WriteFile failed"));
        }
    else
        {
        if ( !WriteFile(hf, (LPVOID)bmih, sizeof(BITMAPINFOHEADER)
                          + ncolors * sizeof (RGBQUAD),
                          (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL) )
           taskAbort(NXLT("WriteBitmapToFile: WriteFile failed"));
        }

    /* Copy the array of color indices into the .BMP file. */
    dwTotal = cb = bmih->biSizeImage;
    hp = data_bits;
    while ( cb > MAXWRITE )
        {
        if ( !WriteFile(hf, (LPSTR)hp, (int)MAXWRITE, (LPDWORD)&dwTmp,
                                                (LPOVERLAPPED)NULL) )
            taskAbort(NXLT("WriteBitmapToFile: WriteFile failed"));
        cb -= MAXWRITE;
        hp += MAXWRITE;
        }
    if ( !WriteFile(hf, (LPSTR)hp, (int)cb, (LPDWORD)&dwTmp,
                                        (LPOVERLAPPED)NULL) )
            taskAbort(NXLT("WriteBitmapToFile: WriteFile failed"));

    /* cleanup */
    if ( !CloseHandle(hf) )
       taskAbort(NXLT("WriteBitmapToFile: CloseHandle failed"));
    free(bmi);
    free(data_bits);
    UnSelectPalette(hdc, old_palette);
    MS_ReleaseDC(NULL, hdc);
    MS_DeleteObject(hpal);
}






/** It is assumed that the caller has set the background color and text */
/* color to a needed value if the source bitmap is a monochrome bitmap  */
/* NOTE: There is a bug in NT, prior to 4.0, which can cause a crash if */
/*   you used "plgBlt".  Therefore the routine below has been re-coded  */
/*   to do things the WIn95 way, where Win95 does not include PlgBlt.   */
/*   The bug has only been seen when using a mask, but the reading from */
/*   Microsoft is that this is more a matter of "getting lucky" since the */
/*   bug is due to a memory overwrite.                                  */

/*   This routine assumes that there will be no stretching/roation of   */
/*   the transfer.                                                      */

BOOL
AxWinPlgBlt(HDC dest_dc, POINT *points, HDC src_dc, int src_x, int src_y,
            int width, int height, HBITMAP mask, int mask_x, int mask_y)
{
    HDC mask_dc;
    BOOL ret;
    HBITMAP old_hbm;
    COLORREF old_bk_color, old_text_color;
#if 0
    POINT *pointsP, *points2P; 
    int dest_width, dest_height;
    int fg_rop_code, bg_rop_code;
#endif
    static int do_mask_blt = -1;
    DWORD rasterop;

    if ( do_mask_blt == -1 )
       {
       char *p;
       do_mask_blt = 0;
       p = getenv("AX_DO_MASKBLT");
       if ( p != (char *)NULL )
          {
          /* force the use of MaskBlt */
          do_mask_blt = 1;
          }
       }


    if ( (!do_mask_blt && (mask != (HBITMAP)NULL)) )
        {
        mask_dc = MS_CreateCompatibleDC(dest_dc);
        old_hbm = MS_SelectObject(mask_dc, mask);

        /* "True Mask Method" of doing transparency. */
        ret = MS_BitBlt(dest_dc, points[0].x, points[0].y, width, height,
                                        src_dc, src_x, src_y, SRCINVERT);

        old_bk_color = MS_SetBkColor(dest_dc, RGB(255, 255, 255));
        old_text_color = MS_SetTextColor(dest_dc, RGB(0,0,0));
        rasterop = 0x220326;   /* not source and destination */
        ret = MS_BitBlt(dest_dc, points[0].x, points[0].y, width, height,
                                        mask_dc, mask_x, mask_y, rasterop);
        MS_SetBkColor(dest_dc, old_bk_color);
        MS_SetTextColor(dest_dc, old_text_color);

        ret = MS_BitBlt(dest_dc, points[0].x, points[0].y, width, height,
                                        src_dc, src_x, src_y, SRCINVERT);

        /* cleanup */
        MS_SelectObject(mask_dc, old_hbm);
        MS_DeleteDC(mask_dc);
        }
    else if ( mask == (HBITMAP)NULL )
        {
        /* no mask, and we are suuming no stretching at this level.  That */
        /* make this a pure BitBlt call. - jon                           */
        ret = MS_BitBlt(dest_dc, points[0].x, points[0].y, width, height,
                                        src_dc, src_x, src_y, SRCCOPY);
        }
    else
        {
        /* because of problems withe the PlgBlt call, when using a mask, */
        /* avoid it in favor of MaskBlt if all the dimensions are the same */
        /* Otherwise, do the Win95 thing, which does not use PlgBlt      */
        taskAbort( "Call to AxWinPlgBlt accesses forbidden condition");
        }
    return ret;
}




/** THIS NEEDS WORK! **/
/*********************************************************************
 * portable way to do MaskBlt.  NOTE: the parameters to this are NOT
 * the same as those to the actual MS32_MaskBlt call!
 */
BOOL
AxWinMaskBlt(HDC dest_dc, int dest_x, int dest_y, int width, int height,
                                    HDC src_dc, int src_x, int src_y,
                                    HBITMAP mask, int mask_x, int mask_y,
                                    DWORD fg_rop_code, DWORD bg_rop_code)
{
    BOOL ret;
    HDC mask_dc;
    DWORD rop_code;
    HBITMAP old_hbm;
    COLORREF old_bk_color, old_text_color;


    if ( Running_Windows95 )
        {
        rop_code = SRCPAINT;
        mask_dc = MS_CreateCompatibleDC(dest_dc);
        old_hbm = MS_SelectObject(mask_dc, mask);

        old_bk_color = MS_SetBkColor(dest_dc, GET_COLOR_VALUE(ForePixel));
        old_text_color = MS_SetTextColor(dest_dc, GET_COLOR_VALUE(BackPixel));
        MS_BitBlt(dest_dc, dest_x, dest_y, width, height,
                    mask_dc, mask_x, mask_y, SRCAND); //fg_rop_code);
        ret = MS_BitBlt(dest_dc, dest_x, dest_y, width, height,
                            src_dc, src_x, src_y, rop_code);

        //MS_BitBlt(dest_dc, dest_x, dest_y, width, height,
        //            mask_dc, mask_x, mask_y, bg_rop_code);
        //ret = MS_BitBlt(dest_dc, dest_x, dest_y, width, height,
        //                        src_dc, src_x, src_y, rop_code);

        /* cleanup */
        MS_SelectObject(mask_dc, old_hbm);
        MS_DeleteDC(mask_dc);
        MS_SetBkColor(dest_dc, old_bk_color);
        MS_SetTextColor(dest_dc, old_text_color);
        }
    else
        {
        /* Windows NT: direct MaskBlt call */
        rop_code = MAKEROP4(fg_rop_code, bg_rop_code);
        ret = MS32_MaskBlt(dest_dc, dest_x, dest_y, width, height,
                                            src_dc, src_x, src_y,
                                            mask, mask_x, mask_y,
                                            rop_code);
        }
    return ret;
}


char font_location[] = NXLT("\\fmetrics\\fonts");

char **GetListOfFontFiles()
{
    /* These should all be in the directory ".../axdata/fmetrics/fonts"    */
    /* Note: this returns full path-names, not just file-names             */
    char fonts_dir[STRPATH+1];
    char **file_listP;
    int fileDex;
    char full_path[STRPATH+1];
    
    strcpy( fonts_dir, ThimApplixDir );  /* path to "axdata"  */
    strcat( fonts_dir, font_location );
    file_listP = AxListFilesInDir( fonts_dir );

    strcat( fonts_dir, "\\" );

    for (fileDex = 0; file_listP[fileDex]; fileDex++)
        {
        /* convert the list to full path-names */
        strcpy( full_path, fonts_dir );
        strcat( full_path, file_listP[fileDex] );
        file_listP[fileDex] = realloc( file_listP[fileDex], 
                                                    (strlen(full_path)+1) );
        strcpy( file_listP[fileDex], full_path );
        }
    return( file_listP );
}


int CALLBACK
FoundCallback(LOGFONT *lpnlf,TEXTMETRIC *lpntm, int type,LPARAM callback_data)
{
    int *count = (int*)callback_data;
    *count = *count + 1;
    return( 0 );         /* return == 0 will stop enumeration */
}

#ifndef MS_AddFontResource
#define MS_AddFontResource              AddFontResource
#define MS_RemoveFontResource           RemoveFontResource
#endif

static int did_install_fonts = FALSE;

void
InstallOptionalTruetypeFonts(void)
{
    /* install the optional true-type fonts which match the ones we ship with */
    /* Gallium on the Unix side.                                              */
    HDC hdc;
    int found_count, fileDex;
    char **file_listP;

#if 0
    hdc = MS_GetDC(NULL);
#else
    hdc = InitScreenHDC();
#endif
    if ( hdc == (HDC)NULL )
        return;

    /* first check to see if they are already installed by looking for a */
    /* few of the "odd" ones.  This is not a complete test, it is done   */
    /* with a trade-off between completness and performance. - jon       */
    found_count = 0;
    EnumFontFamilies( hdc, NXLT("Freeform"), 
                    (FONTENUMPROC)FoundCallback, (LPARAM)&found_count );
    EnumFontFamilies( hdc, NXLT("Snowcap"), 
                    (FONTENUMPROC)FoundCallback, (LPARAM)&found_count );
    EnumFontFamilies( hdc, NXLT("Dutch"), 
                    (FONTENUMPROC)FoundCallback, (LPARAM)&found_count );

    if ( found_count == 3 )
       /* assume they are all installed already */
       return;

    file_listP = GetListOfFontFiles();
    if ( (file_listP == (char **)NULL) || (file_listP[0] == (char *)NULL) )
        /* no font files */
        return;

    for (fileDex = 0; file_listP[fileDex]; fileDex++)
        {
        MS_AddFontResource( file_listP[fileDex] );
        }

    AxListFilesFreer( file_listP );
    did_install_fonts = TRUE;
    //MS_ReleaseDC(NULL, hdc);
    return;
}

void
RemoveOptionalTruetypeFonts(void)
{
    /* remove the optional true-type fonts which match the ones we ship with */
    /* Gallium on the Unix side.                                              */
    char **file_listP;
    int fileDex;

    if ( !did_install_fonts )
       return;

    file_listP = GetListOfFontFiles();
    if ( file_listP == (char **)NULL )
        /* no font files */
        return;

    for (fileDex = 0; file_listP[fileDex]; fileDex++)
        {
        MS_RemoveFontResource( file_listP[fileDex] );
        }

    AxListFilesFreer( file_listP );
    return;
}





#if 0
/* the following 2 functions are needed for "active full drag painting".
 * as of now (6.16.95), we are staying away from this approach.
 * saved here for possible future use.            -donato
 */
/* move this stuff to wintask.c ? */
#include <ge.h>
static unsigned int doGraphicsExpose(XEvent*, struct wind_struct*);
#define X_PIXELS_TO_MILLS(x) (((long)(x) * UWidMils + UWidPels -1)/UWidPels)
#define Y_PIXELS_TO_MILLS(y) (((long)(y) * UHtMils + UHtPels -1)/UHtPels)
/************************************************************/
/* for calling application expose handlers directly
 * save for later?         -donato
 */
void
DoTaskExpose(XEvent *xevent, struct wind_struct *winP)
{
    int junk;
    int save_THIMpid = THIMpid;

#if 0
    if ( winP->ap_id == APGE )
        {
        doGraphicsExpose(xevent, winP);
        }
    else
        {
#endif
        VfyContext(winP->p_id);
        if ( winP->ap_id == APDC || winP->ap_id == APUCM )
            {    /* Words or macro editor */
            WpEventRoutine(APXSERVER, 0, (char*)xevent, sizeof(xevent),
                                                        &junk, &junk);
            }
        else if ( winP->ap_id == APSS )
            {
            SSXEvent(xevent, (struct ss_stroke_buf*)NULL);
            }
        VfyContext(save_THIMpid);
        //}
}
#if 0
static unsigned int
doGraphicsExpose(XEvent *xevent, struct wind_struct *winP)
{
    vector v;
    sys_event_t uEvent;
    int x1, y1, x2, y2;
    graphics_main_type *ge;

    ge = (graphics_main_type *)AxGetTaskData(winP->p_id);
    if ( !ge )
        return FALSE;  /* paranoia, should not happen */

    /* get the damaged area */
    x1 = xevent->xexpose.x;
    y1 = xevent->xexpose.y;
    x2 = x1 + xevent->xexpose.width;
    y2 = y1 + xevent->xexpose.height;
    /* now get the union of the current regen area and this one */
    winP->damagedRect.origin.x = x1; //MIN(winP->damagedRect.origin.x, x1);
    winP->damagedRect.origin.y = y1; //MIN(winP->damagedRect.origin.y, y1);
    winP->damagedRect.corner.x = x2; //MAX(winP->damagedRect.corner.x, x2);
    winP->damagedRect.corner.y = y2; //MAX(winP->damagedRect.corner.y, y2);

    uEvent.type = REGEN_EVENT;
    uEvent.wid = winP->window_id;
    convPixToMils(winP->damagedRect.origin.x, winP->damagedRect.origin.y,
                                &uEvent.ev.regen.x1, &uEvent.ev.regen.y1);
    convPixToMils(winP->damagedRect.corner.x, winP->damagedRect.corner.y,
                                &uEvent.ev.regen.x2, &uEvent.ev.regen.y2);

    if ( ge->state.editing_pix )
        PXdrawDamagedWindow(ge, ge->px, uEvent.ev.regen.x1,uEvent.ev.regen.y1,
                                        uEvent.ev.regen.x2,uEvent.ev.regen.y2);
    else
        {
        /* tell ed.txt that it's been lifted from the screen */
        if ( geGetActiveText(ge) )
            axtTextEditCleared(&ge->ed.txt);

        /* establish clipping draw rect */
        v.x1 = uEvent.ev.regen.x1;
        v.y1 = uEvent.ev.regen.y1;
        v.x2 = uEvent.ev.regen.x2;
        v.y2 = uEvent.ev.regen.y2;
        gsetClip(ge, &v);

        /* redraw the paintlist into the cleared area */
        rePicture(ge, TRUE, &v);

        /* no clipping */
        gsetClip(ge, &ge->state.vp);
        }
    return NON_EVENT;
}            
#endif
/************************************************************/
#endif






int check_for_dupicate_scroll( scroll_event_t *old_mess,
                                  scroll_event_t  *new_mess )

{
    if ( old_mess->v_type != new_mess->v_type )
        return( FALSE );
    if ( old_mess->h_type != new_mess->h_type )
        return( FALSE );
    if ( old_mess->wid != new_mess->wid )
        return( FALSE );
    return( TRUE );
}


void
axmsDrawInactiveCaret(HWND hwnd, int x, int y, int wid, int hyt)
{
    HDC hdc;
    HPEN hpen, old_pen;

    /* setup the device context */
    hdc = MS_GetDC(hwnd);
    hpen = MS_CreatePen(PS_SOLID, wid, RGB(0,0,0));
    old_pen = MS_SelectObject(hdc, hpen);
    MS_SetROP2(hdc, R2_NOT);

    /* draw the line (caret) */
    MS_MoveToEx(hdc, x, y, (POINT*)NULL);
    MS_LineTo(hdc, x, y + hyt);

    /* cleanup */
    MS_SelectObject(hdc, old_pen);
    MS_ReleaseDC(hwnd, hdc); 
    MS_DeleteObject(hpen);
}

#if 0
/****************************************************************************
 *                                      *
 *  FUNCTION   : DrawBitmap(HDC hdc, int x, int y, HBITMAP hbm, DWORD rop)  *
 *                                      *
 *  PURPOSE    : Draws bitmap <hbm> at the specifed position in DC <hdc>    *
 *                                      *
 *  RETURNS    : Return value of BitBlt()                   *
 *                                      *
 ****************************************************************************/
BOOL
DrawWindowsBitmap(HDC hdc, int x, int y, HBITMAP hbm, DWORD rop)
{
    HDC       hdcBits;
    BITMAP    bm;
    BOOL      f;

    if ( !hdc || !hbm )
        return FALSE;

    hdcBits = MS_CreateCompatibleDC(hdc);
    MS_GetObject(hbm,sizeof(BITMAP),(LPSTR)&bm);
    MS_SelectObject(hdcBits,hbm);
    f = MS_BitBlt(hdc, 0,0,bm.bmWidth,bm.bmHeight, hdcBits,0,0, rop);
    MS_DeleteDC(hdcBits);

    return f;
    UNREFERENCED_PARAMETER(y);
    UNREFERENCED_PARAMETER(x);
}
#endif

#define MS_SetDIBitsToDevice SetDIBitsToDevice   /* move to winmap.h! */

/****************************************************************************
 * DrawWindowsBitmapBits:  gets the bits from the given bitmap handle
 *                         and draws them to the given device context.
 *     This allows us to draw full-color bitmaps, as opposed to the
 *     LoadBitmap/BitBlt combination, which is limited to display depth.
 */
BOOL
DrawWindowsBitmapBits(HDC hdc, HBITMAP hbm, int x, int y)
{
    int retval, ncolors, sizeBMI;
    BITMAPINFO *bmiP;
    BITMAPINFOHEADER *bmihP;
    char *data_bits;

    /* First call GetDIBits with a zero'ed structure (particularly */
    /* the bmiP->bmiHeader.biBitCount field) to get the image size */
    bmiP = (BITMAPINFO*)calloc(1, sizeof(BITMAPINFO));
    bmiP->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    if ( !MS_GetDIBits(hdc, hbm, (UINT)0, (UINT)0, (LPBYTE)NULL,
                       (LPBITMAPINFO)bmiP, (DWORD)DIB_RGB_COLORS) )
        taskAbort("DrawWindowsBitmapBits: GetDIBits failed!");

    ncolors = GetNumDIBColors(&bmiP->bmiHeader);
    if ( ncolors )
        {
        /* has color table */
        sizeBMI = sizeof(BITMAPINFO) + sizeof(RGBQUAD) * ncolors;
        /* I need more memory for the color table */
        bmiP = (BITMAPINFO *)realloc(bmiP, sizeBMI);
        }
    if ( bmiP->bmiHeader.biCompression == BI_BITFIELDS )
        {
        /* need more space for color mask values (3 double words). */
        sizeBMI = sizeof(BITMAPINFO) + (sizeof(DWORD) * 3);
        bmiP = (BITMAPINFO *)realloc(bmiP, sizeBMI);
        }

    bmihP = (PBITMAPINFOHEADER)bmiP;
    data_bits = (char*)malloc(bmihP->biSizeImage);
    /*
     * Retrieve the color table (RGBQUAD array) and the bits
     * (array of palette indices) from the DIB.
     */
    if ( !MS_GetDIBits(hdc, hbm, 0, (WORD)bmihP->biHeight,
                           data_bits, bmiP, DIB_RGB_COLORS))
        taskAbort(NXLT("DrawWindowsBitmapBits: GetDIBits failed!"));

    retval = MS_SetDIBitsToDevice(hdc, x, y, bmihP->biWidth, bmihP->biHeight, 
                                  0, 0, 0, bmihP->biHeight,
                                  data_bits, bmiP, DIB_RGB_COLORS);
    free(bmiP);
    free(data_bits);
    return retval;
}

