/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: x2win.c
   Applix ASC version: 212
   Date: Mon Nov 16 13:53:38 1998
*/
#define NEED_X_INFO 1  /* temp, needed for SetCurWinFromMenuWidget */

#include <stdlib.h>
#include <math.h>
#include <basicwin.h>
#include <aos.h>
#include <aos_xfer.h>
#include <xmlib.h>
#include <paripc.h>
#include <paratm.h>
#include <parint.h>
#include <scac.h>
#include <winclip.h>
#include <axwinclr.h>


#define AX_WIN_XREGION      2
#define AX_WIN_RECTREGION   3


/* These undefs are to undo the effects of wrapper defines in aos.h
 */
#undef XChangeGC
#undef XCopyArea
#undef XCopyGC
#undef XCopyPlane
#undef XDrawArc
#undef XDrawArcs
#undef XDrawImageString
#undef XDrawImageString16
#undef XDrawLine
#undef XDrawLines
#undef XDrawPoint
#undef XDrawPoints
#undef XDrawRectangle
#undef XDrawRectangles
#undef XDrawSegments
#undef XDrawString
#undef XDrawString16
#undef XDrawText
#undef XDrawText16
#undef XFillArc
#undef XFillArcs
#undef XFillPolygon
#undef XFillRectangle
#undef XFillRectangles
#undef XFlushGC
#undef XFreeGC
#undef XGContextFromGC
#undef XGetGCValues
#undef XPutImage
#undef XSetArcMode
#undef XSetBackground
#undef XSetClipMask
#undef XSetClipOrigin
#undef XSetClipRectangles
#undef XSetDashes
#undef XSetFillRule
#undef XSetFillStyle
#undef XSetFont
#undef XSetForeground
#undef XSetFunction
#undef XSetGraphicsExposures
#undef XSetLineAttributes
#undef XSetPlaneMask
#undef XSetRegion
#undef XSetState
#undef XSetStipple
#undef XSetSubwindowMode
#undef XSetTSOrigin
#undef XSetTile



/*** for drawing lines on Windows 95; work in progress.  donato, 3.21.96 */
typedef struct line_gc_type {
    HDC hdc;
    unsigned long fg;
    unsigned long bg;
    int fill_style;
    HBITMAP stipple;
    int line_style;
    int line_width;
    int cap_style;
    int join_style;
    DWORD dashes[10];
    int dash_offset;
    int dash_list_size;
/* the following are used to draw thick dashes (straight lines only!). */
    double slope;       /* slope of original line. */
    double x_offset;    /* amount to offset from the original line in the x
                         * direction when drawing dashes (which are simply
                         * polygons).
                         */
    int y_intercept;    /* y intercept of original line. */
    int infinite_slope; /* just a flag */
} line_gc_type;
/*************************************************************************/


int Running_WindowsNT;

#if FOR_FILTER   /*  {  */
int Running_Windows95;
int DpyDepth = 8;    /* just a default for filters */

#else            /*  }  {  */
extern int AxNColors;      /* total number of colors used by apps */
extern GC DisabledGC;
extern PIXEL_VALUE ForePixel, BackPixel;
extern char *ThimApplixDir;
extern char *DirSlash;

#if ANLM
/* in license builds, this is defined in axnlmutl.c */
extern int Running_Windows95;
#else
int Running_Windows95;
#endif

#endif           /*   }  */


extern HDC RootWin;
extern PIXEL_VALUE BackWorkPixelRGB, ForeWorkPixelRGB;
extern XFontStruct *AxDlgMainFont;    /* main dialog font */ 
extern HPALETTE AxWinPaletteHandle;
extern int AxStartedForPrinting;




/************************************************************
    PLEASE PUT ALL X STUBS HERE - Temporary or otherwise.
*************************************************************/
Display *XOpenDisplay(const char *junk) { return (Display*)1; }
void XCloseDisplay(Display *d) { return; }
XFontStruct *XLoadQueryFont(Display *d, const char *cp) { return NULL; }
int XGetWindowAttributes(Display *d, Window w, XWindowAttributes *xwa)
                                                    { return FALSE; }
void XFlush(Display *display) { return; }
void XSync(Display *display, BOOL discard) { return; }
void XSetTransientForHint(Display *d, Window w, Window prop_win) { return; }
int XSetWMProtocols(Display *d, Window w, Atom *protocols, int c)
                                                { return FALSE; }
void XChangeWindowAttributes(Display *d, Window w, unsigned long valuemask,
                                    XSetWindowAttributes *xwa) { return; }
void XSelectInput(Display *d, Window w, long event_mask) { return; }
void XSetWindowColormap(Display *d, Window w, Colormap c) { return; }
void XDrawArcs(Display *d, Drawable drw, GC gc, XArc *xa, int i) { return; }
void XDrawImageString(Display *d, Drawable drw, GC gc, int i1, int i2,
                                const char *str, int i3) { return; }
void XDrawImageString16(Display *d, Drawable drw, GC gc, int i1, int i2,
                                const XChar2b *str, int i3) { return; }
void XDrawRectangles(Display *d, Drawable drw, GC gc, XRectangle *xr, int i)
                                                                { return; }
void XFillArcs(Display *d, Drawable drw, GC gc, XArc *xa, int i) { return; }
void XFillRectangles(Display *d, Drawable drw, GC gc, XRectangle *xr, int i)
                                                                { return; }
/****** END STUBS ******/


static AXSelectionOwner *SelectionList;
static AXATOMLIST *AtomList;
static int NextAtom = XA_LAST_PREDEFINED; /* from X11/Xatom.h */

#include <x2win.p>



int
DisplayPlanes(Display *d, int screen_number)
{
    return (DefaultDepth());
}

HDC
RootWindow(Display *d)
{
    return (RootWin);
}


void
XBell(Display *display, int percent)
{
    int volume;
    if ( percent < 0 )
        volume = 1000 - ((1000*percent)/100) + percent;
    else
        volume = 1000 + ((1000*percent)/100);
    MS_Beep(volume, 100);
}


void
XSetWindowBackground(Display *display, Window hdc, unsigned long bg_pixel)
{
#if !FOR_FILTER
    HWND hwnd;
    HBRUSH hbrush;

    hwnd = AxGetHWNDfromDrawable(hdc);
    if ( hwnd )
        {
        hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(bg_pixel));
        MS_SetClassLong(hwnd, GCL_HBRBACKGROUND, (LONG)hbrush);
        }
#endif
}



BOOL 
XCopyArea(Display *display, HGDIOBJ in_srcDC, Drawable in_destDC, GC gc,
    int src_x, int src_y, unsigned int width, unsigned int height,
    int dest_x, int dest_y)
{
    BOOL ret;
    short obj_type;
    int remove_region, release_src_dc, remove_dest_dc;
    HDC srcDC, destDC;
    HBITMAP hbm, mask;
    HWND hwnd;


    remove_region = release_src_dc = FALSE;
    destDC = InsureDrawable(in_destDC, &remove_dest_dc);
    mask = gc->values.clip_mask;
    if ( mask )
        {
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;

            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(destDC, (HRGN)mask);
            mask = NULL;
            }       
        else
            {
            /* if clip mask is of type HBITMAP, then we use the mask *
             * in subsequent Blt calls; otherwise illegal clip mask. */
            if ( IS_PACKAGED_DRAWABLE(mask) )
                DebugMessage("XCopyArea: bad clip mask type");
            }
        }

    hbm = NULL;
    if ( IS_PACKAGED_DRAWABLE(in_srcDC) )
        obj_type = GET_DRAWABLE_TYPE(in_srcDC);
    else
        {
        /*** if it's not a bitmap, we have problems! ***/
#if 1
        obj_type = AX_BITMAP_TYPE;
#else
        obj_type = MS32_GetObjectType(in_srcDC);
        if ( obj_type == OBJ_BITMAP )
            {
            hbm = in_srcDC;
            obj_type = AX_BITMAP_TYPE;
            }
#endif
        }

    if ( obj_type == AX_BITMAP_TYPE )
        {
        //if ( !hbm )
        //  hbm = (HBITMAP)GET_DRAWABLE_HANDLE(in_srcDC);
        hbm = in_srcDC;
        ret = PaintPixmap(hbm, destDC, gc, dest_x, dest_y, width, height,
                                                    src_x, src_y, mask);
        }
    else
        {
        if ( obj_type == AX_HWND_TYPE )
            {
            hwnd = (HWND)GET_DRAWABLE_HANDLE(in_srcDC);
            srcDC = MS_GetDC(hwnd);
            release_src_dc = TRUE;
            }
        else
            {
            srcDC = (HDC)GET_DRAWABLE_HANDLE(in_srcDC);
            release_src_dc = FALSE;
            }

        if ( mask )
            {
            HDC mask_dc;
            HBITMAP old_hbm;
            COLORREF old_bk_color, old_text_color;
            /* a mask. draw the src through the mask */
            mask_dc = MS_CreateCompatibleDC(destDC);
            old_hbm = MS_SelectObject(mask_dc, mask);

            old_bk_color = MS_SetBkColor(destDC, PALETTERGB(255,255,255));
            old_text_color = MS_SetTextColor(destDC, PALETTERGB(0,0,0));

            /* "True Mask Method" of doing transparency. */
            MS_BitBlt(destDC, dest_x, dest_y, width, height,
                            srcDC, src_x, src_y, SRCINVERT);
            MS_BitBlt(destDC, dest_x, dest_y, width, height,
                                    mask_dc, 0, 0, SRCAND);
            MS_BitBlt(destDC, dest_x, dest_y, width, height,
                            srcDC, src_x, src_y, SRCINVERT);

            /* local cleanup */
            MS_SelectObject(mask_dc, old_hbm);
            MS_DeleteDC(mask_dc);
            MS_SetBkColor(destDC, old_bk_color);
            MS_SetTextColor(destDC, old_text_color);
            }
        else
            {
            ret = MS_BitBlt(destDC, dest_x, dest_y, width, height, srcDC,
                                                src_x, src_y, SRCCOPY);
            }

        if ( release_src_dc )
            MS_ReleaseDC(hwnd, srcDC);
        }

    /* clean up */
    if ( remove_region )
        MS_SelectClipRgn(destDC, (HRGN)NULL);
    if ( remove_dest_dc )
        RemoveDrawable(in_destDC, destDC);
    return(ret);
}


GC
XCreateGC(Display *display, Drawable drawable, unsigned long valuemask,
                                                    XGCValues *values)
{
    GC new_gc;

    /* create a new GC */
    new_gc = (GC)TrueMalloc( sizeof(struct _XGC) );
    memset( new_gc, 0, sizeof(struct _XGC) );

    /* set up the defaults */
    if ( valuemask & GCPlaneMask )
        new_gc->values.plane_mask = values->plane_mask;
    else        
        new_gc->values.plane_mask = (unsigned)~0L;    /*   all 1's  */

    if ( valuemask & GCForeground )
        new_gc->values.foreground = values->foreground;
    else
        new_gc->values.foreground = 0;

    if ( valuemask & GCBackground )        
        new_gc->values.background = values->background;
    else
        new_gc->values.background = 1;

    if ( valuemask & GCFunction )
        new_gc->values.function = values->function;
    
    new_gc->values.line_style = LineSolid;
    new_gc->values.cap_style = CapButt;
    new_gc->values.join_style = JoinMiter;
    new_gc->values.fill_style = FillSolid;
    new_gc->values.fill_rule = EvenOddRule;

    if ( values != (XGCValues *)NULL )
        /* now put in the user requested values */
        XChangeGC( display, new_gc, valuemask, values );

    return( new_gc );
}


XImage *
XCreateImage(Display *display, Visual *visual, unsigned int depth,
                            int format, int offset, char *data,
                            unsigned int width, unsigned int height,
                            int bitmap_pad, int bytes_per_line)
{
    XImage *ximage;
    int raw_bytes_per_line, byte_pad;

    ximage = (XImage *)calloc( 1, sizeof(XImage ) );
    ximage->bitmap_info = (BITMAPINFO *)calloc( 1, sizeof(BITMAPINFO) );

    ximage->data = data;    /* assumed to be allocated by caller */
    ximage->depth = depth;
    ximage->format = format;
    ximage->xoffset = offset;
    ximage->width = width;
    ximage->height = height;
    ximage->bits_per_pixel = depth;
    if ( depth == 1 )
       ximage->bitmap_pad = 16;    /* monochrome is padded to even bytes */
    else
       ximage->bitmap_pad = 32;    /* color is padded to 4 byte boundries */

    raw_bytes_per_line = ((width * depth) + 7)/8;
    byte_pad = ximage->bitmap_pad / 8;
    ximage->bytes_per_line = 
                       ((raw_bytes_per_line + byte_pad - 1)/byte_pad)*byte_pad;

    if ( depth == 16 )
        {
        /* for now, we'll use the standard 5-5-5 format,
         * that is, 5 bits for each R G and B value.
         */
        ximage->red_mask   = RED_MASK16;
        ximage->green_mask = GREEN_MASK16;
        ximage->blue_mask  = BLUE_MASK16;
        }
    else if ( depth == 24 )
        {
        /* no real masks, but create some fake ones to keep the rest */
        /* of the code "generic"                                    */
        ximage->red_mask   = 0x00FF0000;
        ximage->green_mask = 0x0000FF00;
        ximage->blue_mask  = 0x000000FF;
        }

    else if ( depth == 32 )
        {
        ximage->red_mask   = 0x00FF0000;
        ximage->green_mask = 0x0000FF00;
        ximage->blue_mask  = 0x000000FF;
        }
    return (ximage);
}


Pixmap
XCreatePixmap(Display *display, Drawable hdc, unsigned int width,
                        unsigned int height, unsigned int depth)
{
    Pixmap pix;

    if ( depth == 1 )
        {
        /* create monochrome bitmap by using a memory DC. */
        HDC memDC;
        memDC = MS_CreateCompatibleDC((HDC)NULL);
        pix = MS_CreateCompatibleBitmap(memDC, width, height);
        MS_DeleteDC(memDC);
        }
    else
        {
        /* create "color-compatible" bitmap by using the screen's device
         * context: RootWin.
         */
#if FOR_FILTER
    /* the filters won't have initialized RootWin. So use a temp dc. */
        HDC tmp_dc = MS_GetDC(NULL);
        pix = MS_CreateCompatibleBitmap(tmp_dc, width, height);
        MS_ReleaseDC(NULL, tmp_dc);
#else
        pix = MS_CreateCompatibleBitmap(RootWin, width, height);
#endif
        }

    return pix;
}


void
FreeImageElements(XImage *ximage)
{
    if ( ximage->bitmap_info != (BITMAPINFO *)NULL )
        free(ximage->bitmap_info);
    if ( ximage->data != (char *)NULL )
        free(ximage->data);
    if ( ximage->bitmap_handle )
        MS_DeleteObject(ximage->bitmap_handle);
    if ( ximage->palette_handle )
        MS_DeleteObject(ximage->palette_handle);
    ximage->bitmap_handle = (HBITMAP)NULL;
    ximage->palette_handle = (HPALETTE)NULL;
    ximage->data = (char *)NULL;
    return;
}

void
XDestroyImage(XImage *ximage)
{
    FreeImageElements( ximage );

    free(ximage);
    return;
}


BOOL
XDrawLine(Display *display, HGDIOBJ hObj, GC gc, int x1,int y1, int x2,int y2)
{
    HDC hdc;
    int addToX, addToY; 
    BOOL retval, delete_dc;
    BOOL transparent, remove_region = FALSE;
    HPEN hpen=NULL, old_pen;
    int sHdc;
    POINT points[2];
    HPALETTE old_palette;
    line_gc_type line_gc;


    retval = FALSE;
    if ( !hObj )
        /* no drawable. don't draw */
        return retval;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* input was a real DC */
        sHdc = MS_SaveDC(hdc);  /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;

            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XDrawLine: bad clip mask type."));
        }

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    MS_SetBkMode(hdc, TRANSPARENT);

    if ( (x1 - x2) == 0 )
        {
        addToX = 0;
        addToY = 1;
        }
    else if ( (y1 - y2) == 0 )
        {
        addToX = 1;
        addToY = 0;
        }
    else
        {
        addToX = 1;
        addToY = 1;
        }

    if ( Running_Windows95 && gc->values.function != GXxor &&
                                    gc->values.line_style != LineSolid &&
                                    /*gc->values.line_width <= 1 &&*/
                                    gc->values.dash_list_size != 0 )
        {
        HBRUSH hbrush, old_brush;
        CreateLineGCfromGC(gc, hdc, &line_gc);
        if ( gc->values.line_width > 1 )
            {
            /* If it's a thick line we'll be drawing filled polygons
             * for each dash, so set up a solid brush and a pen color.
             */
            hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(line_gc.fg));
            old_brush = MS_SelectObject(hdc, hbrush);
            //old_pen = MS_SelectObject(hdc, MS_GetStockObject(NULL_PEN));
            hpen = MS_CreatePen(PS_SOLID, 0, GET_COLOR_VALUE(line_gc.fg));
            old_pen = MS_SelectObject(hdc, hpen);
            }

        if ( (x2 - x1) == 0 )
            {
            /* vertical line */
            line_gc.infinite_slope = TRUE;
            line_gc.slope = 0.0;
            line_gc.x_offset = 0.0;
            line_gc.y_intercept = 0;
            }
        else
            {
            double len_2, slope_2;

            line_gc.slope = (double)(y2 - y1) / (double)(x2 - x1);
            line_gc.y_intercept = y1 - (line_gc.slope * x1);
            /* calculate half the line thickness squared. */
            len_2  = pow((double)line_gc.line_width, 2.0);
            slope_2 = pow(line_gc.slope, 2.0);  /* the slope squared */
            if ( line_gc.slope == 0.0 )
                {
                line_gc.x_offset = 0.0;
                }
            else
                {
                line_gc.x_offset = sqrt(((len_2 * slope_2) /
                                        (4.0 * (slope_2 + 1.0))));
                }
            }

        retval = MS_LineDDA(x1, y1, x2 + addToX, y2 + addToY,
                                (LINEDDAPROC)DrawDashLineProc,
                                (LPARAM)&line_gc);

        if ( gc->values.line_width > 1 )
            {
            MS_SelectObject(hdc, old_brush);
            MS_SelectObject(hdc, old_pen);
            MS_DeleteObject(hbrush);
            MS_DeleteObject(hpen);
            hpen = NULL;
            }
        }
    else    /* Running_WindowsNT */
        {
        int old_mode;
        hpen = AxWinGetPen(gc, hdc, &transparent);
        if ( hpen )
            old_pen = MS_SelectObject(hdc, hpen);
        else
            {
            DebugMessage(NXLT("XDrawLine: could not create pen! running low \
                                                on memory/resources!"));
            old_pen = MS_SelectObject(hdc, MS_GetStockObject(NULL_PEN));
            }

        if ( gc->values.function == GXxor )
            old_mode = MS_SetROP2(hdc, R2_NOT);

        if ( gc->values.line_style != LineSolid )
            {
            /* try to allign dotted lines correctly.  We only do this for */
            /* vertical or horizontal lines, since the real bug here is   */
            /* getting partial dotted grid re-draws in the spreadsheet to */
            /* allign properly.  Mayber more wil have to be done here -jon */
            if ( x1 == x2 )
                {
                /* vertical line */
                y1 = y1 - gc->values.dash_offset;
                }
            else if ( y1 == y2 )
                {
                /* horizontal line */
                x1 = x1 - gc->values.dash_offset;
                }
            }

        points[0].x = x1;
        points[0].y = y1;
        points[1].x = x2 + addToX;
        points[1].y = y2 + addToY;

        if ( Running_Windows95 && (gc->values.fill_style == FillStippled ||
                            gc->values.fill_style == FillOpaqueStippled) )
            {
            /* since Win95 doesn't support patterned lines we use our
             * homegrown implementation.
             */
            if ( gc->values.fill_style == FillStippled )
                /* transparent fill. */
                DrawPatternedLine(hdc, gc, points, 2, TRUE);
            else
                DrawPatternedLine(hdc, gc, points, 2, FALSE);
            remove_region = TRUE;
            }
        else if ( transparent )
            {
            /* if we are here, we have a valid stipple in the GC. */
            retval = DrawTransparentPolyline(gc,hdc,gc->values.stipple,points,2);
            }
        else
            {
            retval = MS_Polyline(hdc, points, 2);
            }

        if ( gc->values.function == GXxor )
            MS_SetROP2(hdc, old_mode);
        }

    /* cleanup */
    UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);

    if ( hpen )
        {
        MS_SelectObject(hdc, old_pen);
        MS_DeleteObject(hpen);
        }

    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        MS_RestoreDC(hdc, sHdc);
    return retval;
}


BOOL
XDrawString(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                                const char *string, int length)
{
    int str_len, sHdc, old_map_mode;
    HDC hdc;
    BOOL ret, delete_dc,
              remove_region = FALSE;
    HFONT hFont, old_font;
    COLORREF fore_color;
    HPALETTE old_palette;
    TEXTMETRIC tm;


    if ( !hObj )
        {
        /* no drawable. could be the case that we have a windowless *
         * app running, in which case just returning does no harm.  *
         * Otherwise, this could be an error. How often does the    *
         * latter case happen?       -donato                        */
        return FALSE;
        }
    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(hdc);   /* save this DC so that it can be restored */
        }

#if 1
    /* I changed this to "if 1" so that long text strings in the SS */
    /* would get clipped against a cell boundry, rather than overwriting */
    /* the cell to the right  - jon    Nov 21, 1994                 */
    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn( hdc, (HRGN)gc->values.clip_mask );
            }
        else
            DebugMessage(NXLT("XDrawString: bad clip mask type."));
        }
#endif

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);

    /* use specified font (from GC) */
    hFont = gc->values.font;
    if ( !hFont )
        {
        if ( AxDlgMainFont->fid )
            hFont = AxDlgMainFont->fid;
        else
            DebugMessage("XDrawString: no font!");
        }
    old_font = MS_SelectObject(hdc, hFont);

    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
        /* make sure we have the real white pixel. */
#if FOR_FILTER
        fore_color = REAL_WHITE_PIXEL;
#else
        fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
        }
    else
        fore_color = GET_COLOR_VALUE(gc->values.foreground);

    /* only draw foreground text color, ignore background */
    MS_SetBkMode(hdc, TRANSPARENT);

    str_len = strlen(string);
    if ( gc->values.fill_style == FillTiled )
        {
#if FOR_FILTER   /*  {  */
        ;
#else
        /* NOTE: string tile fills are not implemented. However, the   *
         * software currently uses this for disabled strings, so let's *
         * ASSUME that's why we're here and call MS_GrayString. If, in *
         * the future, someone uses this for other purposes we'll have *
         * rethink our strategy.                 -donato               */
        old_map_mode = MS_SetMapMode(hdc, MM_TEXT);

        /* MS_GrayString seems to ignore the text alignment setting *
         * so we have to adjust the ypos.                           */
        MS_GetTextMetrics(hdc, &tm);
        y -= tm.tmAscent;

        /* Due to the strange behavior of MS_GrayString (it doesn't  *
         * paint over already existing text (?!)), we first draw the *
         * text using the background widget color, which will erase  *
         * any existing text.                -donato                 */
        MS_SetTextColor(hdc, GET_COLOR_VALUE(BackPixel));
        MS_TextOut(hdc, x, y, string, length);

        ret = MS_GrayString(hdc, (HBRUSH)NULL, (GRAYSTRINGPROC)NULL,
                                (LPARAM)string, length, x, y, 0, 0);
        MS_SetMapMode(hdc, old_map_mode);
#endif   /*  }  FOR_FILTER */
        }
    else
        {
        MS_SetTextColor(hdc, fore_color);
        MS_SetTextAlign(hdc, TA_LEFT | TA_BASELINE);
        if ( gc->values.function == GXxor )
            {
            ret = DrawXORstring(hdc, gc, (char*)string, length, x, y);
            }
        else
            {
            if ( length > str_len )    /* for now */
                ret = MS_TextOut(hdc, x, y, string, str_len);
            else
                ret = MS_TextOut(hdc, x, y, string, length);
            }
        }

    /* cleanup */
    UnSelectPalette(hdc, old_palette);
    MS_SelectObject(hdc, old_font);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        MS_RestoreDC(hdc, sHdc);
    return ret;
}



   /* we have seen an optimizer bug in XDrawString16 which results in */
   /* not text, or the wron color (as evidenced by the fact that one gets */
   /* all zero bits when one gets a bitmap from the hdc being drawn here) */
   /* see "getLetterform()".  So, turn off optimization for this function-jon*/
 
#pragma optimize( "", off )   /*  {  */

BOOL
XDrawString16(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                                const XChar2b *string, int length)
{
    int sHdc;
    HDC hdc;
    BOOL ret, delete_dc,
                mono_drawable = FALSE,
                remove_region = FALSE;
    POINT point[1];
    char buf[1];
    HFONT hFont, old_font;
    COLORREF fore_color;
    HPALETTE old_palette;

    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(hdc);   /* save this DC so that it can be restored */
        }

    if ( IsMonochromeDrawable(hObj) )
        mono_drawable = TRUE;

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn( hdc, (HRGN)gc->values.clip_mask );
            }       
        else
            DebugMessage(NXLT("XDrawString16: bad clip mask type."));
        }
        

    if ( mono_drawable )
        {
        if ( gc->values.foreground == 1 )
            fore_color = PALETTERGB(255,255,255);
        else if (  gc->values.foreground == 0 )
            fore_color = PALETTERGB(0,0,0);
        else
            fore_color = PALETTERGB(0,0,0); /* error? */
        }
    else
        {
        old_palette = SelectAndRealizeAxWinPalette(hdc);
        if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
            {
            /* make sure we have the real white pixel. */
#if FOR_FILTER
            fore_color = REAL_WHITE_PIXEL;
#else
            fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
            }
        else
            fore_color = GET_COLOR_VALUE(gc->values.foreground);
        }

    /* only draw foreground text color, ignore background */
    MS_SetBkMode(hdc, TRANSPARENT);
    MS_SetTextColor(hdc, fore_color);
    MS_SetTextAlign(hdc, TA_LEFT | TA_BASELINE);

    /* use specified font (from GC) */
    hFont = gc->values.font;
    if ( !hFont )
        {
        if ( AxDlgMainFont->fid )
            hFont = AxDlgMainFont->fid;
        else
            DebugMessage("XDrawString16: no font!");
        }
    old_font = MS_SelectObject(hdc, hFont);

    /* Windows will use the given coordinates as "logical points", *
     * which are GDI coordinates (not pixels), so we must convert. */
    point[0].x = x;
    point[0].y = y;
    MS_LPtoDP(hdc, point, 1);   

    sprintf(buf, "%c", string->byte2);
    if ( gc->values.function == GXxor )
        {
        ret = DrawXORstring(hdc,gc, (char*)buf,length, point[0].x,point[0].y);
        }
    else
        {
        ret = MS_TextOut(hdc, point[0].x, point[0].y, buf, length);
        }

    /* cleanup */
    if ( !mono_drawable )
        UnSelectPalette(hdc, old_palette);
    MS_SelectObject(hdc, old_font);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        MS_RestoreDC(hdc, sHdc);
    return ret;
}
 
  /** turn optimization back on */
#pragma optimize( "", off )   /*  {  */
 

static int
axmsPolygonIsLine(POINT *points, int npoints)
{
    int ix;
    double slope, max_slope, min_slope;

    if ( (points[1].x - points[0].x) != 0 )
        {
        min_slope = max_slope = (double)(points[1].y - points[0].y) /
                                (double)(points[1].x - points[0].x);
        }
    else
        min_slope = max_slope = 0.0;
    for ( ix=2; ix < npoints-1; ix++ )
        {
        if ( (points[ix].x - points[0].x) == 0 )
            slope = 1.0;
        else
            slope = (double)(points[ix].y - points[0].y) /
                    (double)(points[ix].x - points[0].x);
        if ( slope > max_slope )
            max_slope = slope;
        if ( slope < min_slope )
            min_slope = slope;
        }

    if ( (double)(max_slope-min_slope) <= (double)abs(min_slope*0.05) )
        return TRUE;
    else
        return FALSE;
}

/***
    For manually tiling bitmap images.
 ***/
static void
DrawPatternFill(HDC hdc, HBITMAP hbm, POINT *points,int npoints, int poly_wid,
    int poly_hyt, int xpos, int ypos, COLORREF fore_color, COLORREF back_color,
    BOOL mask_it, BOOL is_arc)
{
    int i, j, x, y, tile_x, tile_y;
    HDC mem_hdc;
    HBITMAP pattern, old_hbm;
    BITMAP bm;
    DWORD rop_code;
    BOOL ret;
    int save_dc;

    if ( !hbm )
        return; /* uh oh! */

    if ( IS_PACKAGED_DRAWABLE(hbm) )
        pattern = (HBITMAP)GET_DRAWABLE_HANDLE(hbm);
    else
        pattern = hbm;

    save_dc = MS_SaveDC(hdc);
    /* use the poly to set a clip */
    MS32_BeginPath(hdc);
    if ( is_arc )
        {
        /* the points array contains the necessary radial points. */
        MS_Pie(hdc, xpos, ypos, xpos + poly_wid, ypos + poly_hyt,
                points[1].x, points[1].y, points[2].x, points[2].y);
        }
    else
        {
        MS_Polygon(hdc, points, npoints);
        }
    MS32_CloseFigure(hdc);
    MS32_EndPath(hdc);
    MS32_SelectClipPath(hdc, RGN_AND);
#if 1
    if ( axmsPolygonIsLine(points, npoints) )
        {
        /* a clipping path failure or the region is null, which probably means
         * it's a polygon that forms a line. Just color the line and return.
         */
        HPEN old_pen, hpen;
        hpen = MS_CreatePen(PS_SOLID, 0, fore_color);
        old_pen = MS_SelectObject(hdc, hpen);
        ret = MS32_StrokePath(hdc);
        MS_SelectObject(hdc, old_pen);
        MS_DeleteObject(hpen);
        return;
        }
#endif
    mem_hdc = MS_CreateCompatibleDC((HDC)NULL);
    old_hbm = MS_SelectObject(mem_hdc, pattern);

    MS_GetObject(pattern, sizeof(BITMAP), (LPSTR)&bm);
    if ( bm.bmBitsPixel == 1 )
        {
        /* we have a mono image, so set the fore and back colors. */ 
        MS_SetBkColor(hdc, fore_color);
        MS_SetTextColor(hdc, back_color);
        }

    /* "mask_it" means draw the pattern (source) onto the destination only 
     * where there are ones.      -donato
     */
    if ( mask_it )
        rop_code = SRCAND;
    else
        rop_code = SRCCOPY;

    x = xpos;
    y = ypos;
    tile_x = (poly_wid / bm.bmWidth) + 1;
    tile_y = (poly_hyt / bm.bmHeight) + 1;
    for ( i=0; i < tile_y; i++ )
        {
        for ( j=0; j < tile_x; j++ )
            {
            MS_BitBlt(hdc,x,y,bm.bmWidth,bm.bmHeight, mem_hdc,0,0, rop_code);
            x += bm.bmWidth;
            }
        y += bm.bmHeight;
        x = xpos;
        }

    MS_SelectObject(mem_hdc, old_hbm);
    MS_DeleteDC(mem_hdc);
    MS_RestoreDC(hdc, save_dc);
}

static void
DrawPatternedLine(HDC hdc, GC gc, POINT *msPoints, int npoints, BOOL mask_it)
{
    int save_dc;
    int wid, hyt, minx, miny;
    int i, j, x, y, tile_x, tile_y;
    HDC mem_hdc;
    HBITMAP pattern, old_hbm;
    BITMAP bm;
    DWORD rop_code;

    if ( !gc->values.stipple )
        return; /* uh oh! */

    if ( IS_PACKAGED_DRAWABLE(gc->values.stipple) )
        pattern = (HBITMAP)GET_DRAWABLE_HANDLE(gc->values.stipple);
    else
        pattern = gc->values.stipple;

    save_dc = MS_SaveDC(hdc);

    MS32_BeginPath(hdc);
    MS_Polyline(hdc, msPoints, npoints);
    MS32_EndPath(hdc);
    MS32_WidenPath(hdc);
    MS32_SelectClipPath(hdc, RGN_AND);

    GetPolyInfo(msPoints, npoints, &wid, &hyt, &minx, &miny);

    mem_hdc = MS_CreateCompatibleDC((HDC)NULL);
    old_hbm = MS_SelectObject(mem_hdc, pattern);

    MS_GetObject(pattern, sizeof(BITMAP), (LPSTR)&bm);
    if ( bm.bmBitsPixel == 1 )
        {
        /* we have a mono image, so set the fore and back colors. */ 
        MS_SetBkColor(hdc, GET_COLOR_VALUE(gc->values.foreground));
        MS_SetTextColor(hdc, GET_COLOR_VALUE(gc->values.background));
        }

    /* "mask_it" means draw the pattern (source) onto the destination only 
     * where there are ones.      -donato
     */
    if ( mask_it )
        rop_code = SRCAND;
    else
        rop_code = SRCCOPY;

    x = minx;
    y = miny;
    tile_x = (wid / bm.bmWidth) + 1;
    tile_y = (hyt / bm.bmHeight) + 1;
    for ( i=0; i < tile_y; i++ )
        {
        for ( j=0; j < tile_x; j++ )
            {
            MS_BitBlt(hdc,x,y,bm.bmWidth,bm.bmHeight, mem_hdc,0,0, rop_code);
            x += bm.bmWidth;
            }
        y += bm.bmHeight;
        x = minx;
        }

    MS_SelectObject(mem_hdc, old_hbm);
    MS_DeleteDC(mem_hdc);
    MS_RestoreDC(hdc, save_dc);
}



void
XFillRectangle(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                            unsigned int width, unsigned int height)
{
    int     sHdc, save_draw_dc;
    int     blt_x, blt_y;
    int     ret;
    HDC     fill_dc, mem_hdc, draw_dc, pass_dc;
    HPEN    old_pen, hpen;
    HBRUSH  hbrush, old_brush;
    HBITMAP hbm, fill_hbm, mem_hbm, pattern, old_fill_hbm;
    BOOL bMask = FALSE,           /* tell whether we are using a mask */
         bTransparent = FALSE,    /* tell whether fill is transparent */
         remove_region = FALSE,
         delete_fill_hbm = FALSE,
         delete_mem_objs = FALSE,
         delete_fill_dc, delete_draw_dc, remove_fill_dc;
    POINT rect_points[3];
    COLORREF fore_color, back_color;
    BITMAP bm;
    HPALETTE old_palette, old_draw_palette;
    BOOL do_manual_pattern_fill = FALSE,
         do_manual_transparent_fill = FALSE;


    if ( !hObj )
        /* no drawable. don't draw */
        return;

    sHdc = save_draw_dc = 0;
    delete_fill_dc = delete_draw_dc = remove_fill_dc = FALSE;
    old_brush = hbrush = (HBRUSH)NULL;
    fill_dc = mem_hdc = draw_dc = (HDC)NULL;
    pass_dc = hObj;     /* hdc we will pass to routines below this */
    blt_x = x;
    blt_y = y;

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HBITMAP, we create a memory DC which we will use to draw *
         * the rectangle on. we set a flag (bMask) to true, so that *
         * we can later blt the memory DC thru the mask and onto    *
         * the screen.                                              */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            /* check the drawable type */
            fill_dc = InsureDrawable(hObj, &remove_fill_dc);
            if ( !remove_fill_dc )
                {
                /* we were passed an HDC, so just use that to draw on */
                sHdc = MS_SaveDC(fill_dc);
                }
            /* the passed object is a bitmap which is selected by */
            /* InsureDrawable into an HDC, use that HDC for any routines */
            /* called from here to avoid trying to select the bitmap     */
            /* into another HDC below this                               */
            pass_dc = fill_dc;

            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(fill_dc, (HRGN)gc->values.clip_mask);
            }
        else
            {
            /*** clip mask better be a bitmap handle. ***/
            /* set to zero because we will be blt'ing to a memory DC */
            blt_x = 0;
            blt_y = 0;
            hbm = gc->values.clip_mask;
            MS_GetObject(hbm, sizeof(BITMAP), (LPSTR)&bm);

            /* check to see what type of "drawable" we were passed. */
            draw_dc = InsureDrawable(hObj, &delete_draw_dc);
            if ( !delete_draw_dc )
                {
                /* save non-memory DC so it can be restored */
                save_draw_dc = MS_SaveDC(draw_dc);
                }
            /* the passed object is a bitmap which is selected by */
            /* InsureDrawable into an HDC, use that HDC for any routines */
            /* called from here to avoid trying to select the bitmap     */
            /* into another HDC below this                               */
            pass_dc = draw_dc;

            fill_dc = MS_CreateCompatibleDC((HDC)RootWin);
            fill_hbm = MS_CreateCompatibleBitmap(RootWin,bm.bmWidth,bm.bmHeight);
            old_fill_hbm = MS_SelectObject(fill_dc, fill_hbm);
            bMask = TRUE;
            delete_fill_dc = TRUE;
            delete_fill_hbm = TRUE;
            }
        }
    else
        {
        /* no clip mask was specified. check to see what type *
         * of "drawable" we were passed.                      */
        fill_dc = InsureDrawable(hObj, &remove_fill_dc);
        if ( !remove_fill_dc )
            {
            /* we were passed an HDC, so just use that to draw on */
            sHdc = MS_SaveDC(fill_dc); /* save DC so that it can be restored */
            }
        /* the passed object is a bitmap which is selected by */
        /* InsureDrawable into an HDC, use that HDC for any routines */
        /* called from here to avoid trying to select the bitmap     */
        /* into another HDC below this                               */
        pass_dc = fill_dc;
        }

    /* Select the palette into the window device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(fill_dc);

    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
#if FOR_FILTER
        fore_color = REAL_WHITE_PIXEL;
#else
        fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
        }
    else
        fore_color = GET_COLOR_VALUE(gc->values.foreground);

    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
#if FOR_FILTER
        back_color = REAL_WHITE_PIXEL;
#else
        back_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
        }
    else
        back_color = GET_COLOR_VALUE(gc->values.background);


    if ( gc->values.fill_style != FillSolid &&
          gc->values.fill_style != FillTiled )
        {
        /* fill style is Stipple, so make sure we have a stipple map */
        if ( gc->values.stipple )
            {
            /* use specified stipple pattern to fill rectangle. *
             * Pattern brushes use text fore and back-ground    *
             * colors to paint with. (only use stipples with    *
             * appropriate fill styles).                        */
            if ( Running_Windows95 )
                {
                /* On Win95, we'll need to tile the bitmap ourselves. */
                pattern = gc->values.stipple;
                do_manual_pattern_fill = TRUE;
                }
            else if ( gc->values.fill_style == FillStippled )
                {
                /* background remains untouched (transparent) */
                hbrush = MS_CreatePatternBrush(gc->values.stipple);
                mem_hdc = MS_CreateCompatibleDC((HDC)NULL);
                mem_hbm = MS_CreateCompatibleBitmap(RootWin, width, height);
                MS_SelectObject(mem_hdc, mem_hbm);
                bTransparent = TRUE;
                delete_mem_objs = TRUE;
                }
            else if ( gc->values.fill_style == FillOpaqueStippled )
                {
                hbrush = MS_CreatePatternBrush(gc->values.stipple);
                MS_SetBkColor(fill_dc, fore_color);
                MS_SetTextColor(fill_dc, back_color);
                }
            }
        else
            DebugMessage(NXLT("XFillRectangle: Stipple Fill requested without a stipple map!"));
        }

    else if ( gc->values.fill_style == FillTiled )
        {
        /* fill style is Tile, so make sure we have a tile */
        if ( gc->values.tile )
            {
            if ( Running_Windows95 )
                {
                /* On Win95, we'll need to tile the bitmap ourselves. */
                pattern = gc->values.tile;
                do_manual_pattern_fill = TRUE;
                }
            else
                {
                hbrush = MS_CreatePatternBrush(gc->values.tile);
                MS_SetBkColor(fill_dc, fore_color);
                MS_SetTextColor(fill_dc, back_color);
                }
            }
        else
            DebugMessage(NXLT("XFillRectangle: Tile Fill requested without a tile!"));
        }

    else if ( gc->values.fill_style == FillSolid )
        {
        /* use a solid color brush */
        hbrush = MS_CreateSolidBrush(fore_color);
        }

    /* this is a fill routine, so don't use a pen (no line is drawn) */
    hpen = (HPEN) MS_GetStockObject(NULL_PEN);
    old_pen = MS_SelectObject(fill_dc, hpen);

    /* draw rectangle */
    if ( do_manual_pattern_fill )
        {
        /*** This should only be true on Windows 95 ***/
        POINT points[4];
        points[0].x = blt_x;            points[0].y = blt_y;
        points[1].x = blt_x + width;    points[1].y = blt_y;
        points[2].x = blt_x + width;    points[2].y = blt_y + height;
        points[3].x = blt_x;            points[3].y = blt_y + height;
        if ( gc->values.fill_style == FillStippled )
            do_manual_transparent_fill = TRUE;
        DrawPatternFill(fill_dc, pattern, points,4, width,height,blt_x,blt_y,
                                        fore_color, back_color, FALSE, FALSE);
        }
    else if ( bTransparent )
        {
        rect_points[0].x = x;
        rect_points[0].y = y;
        rect_points[1].x = x + width;
        rect_points[1].y = y;
        rect_points[2].x = x;
        rect_points[2].y = y + height;
        ret = DrawTransparentFill(gc, fill_dc, mem_hdc, hbrush,
                                        rect_points, 0,
                                        width, height,
                                        FILL_TRANS_RECT, bMask, pass_dc);
        }
    else
        {
        if ( hbrush )
            {
            /* we have a valid brush, use that to fill. */
            old_brush = MS_SelectObject(fill_dc, hbrush);
            if ( gc->values.function == GXxor )
                /* draws a reverse video rect */
                ret = MS_PatBlt(fill_dc, blt_x,blt_y, width,height, PATINVERT);
            else
                ret = MS_PatBlt(fill_dc, blt_x,blt_y, width,height, PATCOPY);
            MS_SelectObject(fill_dc, old_brush);
            }
        else
            {
            /* no brush!  not enough memory, or who knows why... */
            DebugMessage(NXLT("XFillRectangle: could not create brush! \
                            running low on memory/resources..."));

            MS_SetBkColor(fill_dc, fore_color);
#if FOR_FILTER
            MS_SelectObject(fill_dc, MS_GetStockObject( BLACK_BRUSH ) );
#else
            MS_SelectObject(fill_dc, GetStippleMap(4));
#endif
            MS_PatBlt(fill_dc, blt_x, blt_y, width, height, PATCOPY);
            }
        }

    if ( bMask && !bTransparent )
        {
        HDC mask_dc;
        HBITMAP old_hbm;
        COLORREF old_bk_color, old_text_color;

        mask_dc = MS_CreateCompatibleDC(draw_dc);
        old_hbm = MS_SelectObject(mask_dc, hbm);
        if ( do_manual_transparent_fill )
            {
            /*** This should only be true on Windows 95 ***/
            POINT points[4];
            points[0].x = 0;            points[0].y = 0;
            points[1].x = bm.bmWidth;   points[1].y = 0;
            points[2].x = bm.bmWidth;   points[2].y = bm.bmHeight;
            points[3].x = 0;            points[3].y = bm.bmHeight;
            DrawPatternFill(mask_dc, pattern, points, 4, bm.bmWidth,
                            bm.bmHeight, 0, 0, PALETTERGB(255,255,255),
                            PALETTERGB(0,0,0), TRUE, FALSE);
            }
        /* invert the mask */
        MS_PatBlt(mask_dc, 0, 0, bm.bmWidth, bm.bmHeight, DSTINVERT);

        /* a mask, draw the rectangle through the clip mask */
        old_draw_palette = SelectAndRealizeAxWinPalette(draw_dc);
        old_bk_color = MS_SetBkColor(draw_dc, PALETTERGB(255,255,255));
        old_text_color = MS_SetTextColor(draw_dc, PALETTERGB(0,0,0));

        /* "True Mask Method" of doing transparency. */
        MS_BitBlt(draw_dc, x, y, width, height, fill_dc, 0, 0, SRCINVERT);
        MS_BitBlt(draw_dc, x, y, width, height, mask_dc, 0, 0, SRCAND);
        MS_BitBlt(draw_dc, x, y, width, height, fill_dc, 0, 0, SRCINVERT);

        MS_SetBkColor(draw_dc, old_bk_color);
        MS_SetTextColor(draw_dc, old_text_color);

        MS_SelectObject(mask_dc, old_hbm);
        MS_DeleteDC(mask_dc);

        UnSelectPalette(draw_dc, old_draw_palette);
        }

    /* cleanup */
    if ( remove_region )
        MS_SelectClipRgn(fill_dc, (HRGN)NULL);

    if ( delete_mem_objs )
        {
        MS_DeleteDC(mem_hdc);
        MS_DeleteObject(mem_hbm);
        }

    MS_SelectObject(fill_dc, old_pen);
    UnSelectPalette(fill_dc, old_palette);

    if ( delete_fill_hbm )
        {
        MS_SelectObject(fill_dc, old_fill_hbm);
        MS_DeleteObject(fill_hbm);
        }

    if ( remove_fill_dc )
        RemoveDrawable(hObj, fill_dc);
    else if ( delete_fill_dc )
        MS_DeleteDC(fill_dc);
    else if ( sHdc != 0 )
        MS_RestoreDC(fill_dc, sHdc);

    if ( delete_draw_dc )
        RemoveDrawable(hObj, draw_dc);
    else if ( save_draw_dc != 0 )
        MS_RestoreDC(draw_dc, save_draw_dc);

    if ( hbrush )
        MS_DeleteObject(hbrush);
    return;
}



void
XFreePixmap(Display *display, HGDIOBJ pixmap)
{
#if 1
    if ( pixmap == (HGDIOBJ)NULL )
        return;

    if ( IS_PACKAGED_DRAWABLE(pixmap) )
        {
        /* better be an HDC! */
        short obj_type;
        obj_type = GET_DRAWABLE_TYPE(pixmap);
        if ( (obj_type == AX_DC_TYPE) || (obj_type == AX_MEMDC_TYPE) )
            {
            HDC hdc = (HDC)GET_DRAWABLE_HANDLE(pixmap);
            MS_DeleteDC(hdc);
            REMOVE_DRAWABLE(pixmap);
            }
        else
            DebugMessage(NXLT("XFreePixmap: bad object type."));
        }
    else
        {
        /*** better be a bitmap! ***/
        MS_DeleteObject( pixmap );
        }
#else
    if ( IS_PACKAGED_DRAWABLE(pixmap) )
        {
        short obj_type;
        obj_type = GET_DRAWABLE_TYPE(pixmap);
        if ( (obj_type == AX_DC_TYPE) || (obj_type == AX_MEMDC_TYPE) )
            {
            HDC hdc = (HDC)GET_DRAWABLE_HANDLE(pixmap);
            MS_DeleteDC(hdc);
            }
        else if ( obj_type == AX_BITMAP_TYPE )
            {
            HBITMAP hbm = (HBITMAP)GET_DRAWABLE_HANDLE(pixmap);
            MS_DeleteObject(hbm);
            }
        else
            DebugMessage(NXLT("XFreePixmap: bad object type."));
        REMOVE_DRAWABLE(pixmap);
        }
    else
        {
        DWORD obj_type;
        obj_type = MS32_GetObjectType( pixmap );
        if ( (obj_type == OBJ_DC) || (obj_type == OBJ_MEMDC) )
            MS_DeleteDC( pixmap );
        else if ( obj_type == OBJ_BITMAP )
            MS_DeleteObject( pixmap );
        else
            DebugMessage(NXLT("XFreePixmap: bad object type."));
        }
#endif
}


void
XChangeGC(Display *display, GC gc, unsigned long valuemask, XGCValues *values)
{ 
    if ( valuemask & GCPlaneMask )
        gc->values.plane_mask = values->plane_mask;
    if ( valuemask & GCForeground)
        gc->values.foreground = values->foreground;
    if ( valuemask & GCBackground )
        gc->values.background = values->background;
    if ( valuemask & GCLineWidth )
        gc->values.line_width = values->line_width;
    if ( valuemask & GCLineStyle )
        gc->values.line_style = values->line_style;
    if ( valuemask & GCCapStyle )
        gc->values.cap_style = values->cap_style;
    if ( valuemask & GCJoinStyle )
        gc->values.join_style = values->join_style;
    if ( valuemask & GCFillStyle )
        gc->values.fill_style = values->fill_style;
    if ( valuemask & GCFillRule )
        gc->values.fill_rule = values->fill_rule;
    if ( valuemask & GCFunction )
        gc->values.function = values->function;

    if ( valuemask & GCClipMask )
        {
        DWORD obj_type = MS32_GetObjectType(values->clip_mask);
        gc->values.clip_mask = values->clip_mask;
        if ( obj_type == OBJ_REGION )
            {
            /* we know the clip mask is a Windows HRGN, but we don't
             * know if it is an "X Region" (XSetRegion), or a rectangular
             * region created in XSetClipRectangles. For now, we will
             * assume it is rectangular.            -donato
             */
            gc->clip_mask_is_hregion = AX_WIN_RECTREGION;
            }
        }
    if ( valuemask & GCFont )
        {
        gc->values.font = values->font;
        }
    if ( valuemask & GCStipple )
        {
        gc->values.stipple = values->stipple;
        }
    if ( valuemask & GCTile )
        {
        gc->values.tile = values->tile;
        }

    return;
}



XImage *
XGetImage(Display *display, HGDIOBJ hObj, int x, int y, unsigned int width,
                unsigned int height, unsigned long plane_mask, int format)
{
    HDC memDC;
    HWND hwnd;
    short obj_type;
    HBITMAP hbm, old_hbm;
    XImage *ximg;
    int release_obj = FALSE,
        converted_to_dc = FALSE;

    if ( !hObj || (x < 0) || (y < 0) || (width < 0) || (height < 0) )
        /* null object, or bogus positions, ignore */
        return( (XImage*)NULL );


    if ( IS_PACKAGED_DRAWABLE(hObj) )
        {
        obj_type = GET_DRAWABLE_TYPE(hObj);
        if ( obj_type == AX_HWND_TYPE )
            {
            /* we have a window handle; get a DC. */
            hwnd = (HWND)GET_DRAWABLE_HANDLE(hObj);
            hObj = MS_GetDC(hwnd);
            release_obj = TRUE;
            obj_type = AX_DC_TYPE;  /* we've converted to DC */
            converted_to_dc = TRUE;
            }

        if ( obj_type == AX_BITMAP_TYPE )
            {
            hbm = (HBITMAP)GET_DRAWABLE_HANDLE(hObj);
            ximg = BitmapToXImage(hbm);
            }
        else if ( (obj_type == AX_DC_TYPE) || (obj_type == AX_MEMDC_TYPE) )
            {
            HDC hdc;
            if ( converted_to_dc )
                hdc = hObj;
            else
                hdc = (HDC)GET_DRAWABLE_HANDLE(hObj);
            memDC = MS_CreateCompatibleDC(hdc);
            hbm   = MS_CreateCompatibleBitmap(hdc, width, height);
            old_hbm = MS_SelectObject(memDC, hbm);

            /* copy stuff in specified rect of given hdc into the memory DC */
            /* this has the effect of updating the info in the bitmap */
            MS_BitBlt(memDC, 0, 0, width, height, (HDC)hdc, x, y, SRCCOPY);

            MS_SelectObject(memDC, old_hbm);
            MS_DeleteDC(memDC);   /* no longer need the memory DC */

            /* since we were passed an HDC, we take the short route and do not */
            /*  build all the ximage data structure, since in most cases the */
            /*  caller will simply turn around and use the bitmap handle to draw */
            /*  this image back onto the display                              */
            ximg = (XImage *)calloc( 1, sizeof(XImage) );
            ximg->bitmap_handle = hbm;
            }
        }
    else
        {
        /*** ASSUME unpackaged bitmap ***/
        hbm = hObj;
        ximg = BitmapToXImage(hbm);
        }

    if ( release_obj )
        MS_ReleaseDC(hwnd, hObj);

    return( ximg );
}



static unsigned char ByteMask[] = {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

unsigned long
XGetPixel(XImage *ximage, int x, int y)
{
    int width, image_index;
    unsigned long pixel;
    unsigned char *pixel_byteP;

    pixel_byteP = ximage->data + (y * ximage->bytes_per_line) +
                                    ((x * ximage->depth) / 8);

    if ( ximage->depth == 1 )
        pixel = *pixel_byteP & ByteMask[x%8];
    else if ( ximage->depth == 8 )
        {
        width = ((ximage->width + 3)/4) * 4;
        image_index = ( (width * y) + x );
        pixel = (unsigned char)ximage->data[image_index];
        }
    /* byte order ASSUMPTION for greater than 8 bit images: LSBFirst */
    else if ( ximage->depth == 16 )
        {
        pixel = *((unsigned short *)pixel_byteP);
        }
    else if ( ximage->depth == 24 )
        {
        pixel = *pixel_byteP << 16;
        pixel_byteP++;
        pixel |= *pixel_byteP << 8;
        pixel_byteP++;
        pixel |= *pixel_byteP;
        }
    else if ( ximage->depth == 32 )
        {
        pixel = *((unsigned int *)pixel_byteP);
        }
    return pixel;
}

int
XPutPixel(XImage *ximage, int x, int y, unsigned long pixel)
{
    unsigned char *pixel_byteP;
    register unsigned long pixel_value, mask;
    register int shift, unit_shift, pixels_per_byte;

    if ( ximage->depth == 1 )
        mask = 1;
    else if ( ximage->depth == 4 )
        mask = 0xF;
    else if ( ximage->depth == 8 )
        mask = 0xFF;
    else if ( ximage->depth == 16 )
        mask = 0xFFFF;
    else if ( ximage->depth == 24 )
        mask = 0xFFFFFF;
    else
        /* assume 32 bit */
        mask = 0xFFFFFFFF;

    pixel_value = pixel & mask;
    pixel_byteP = ximage->data + (y * ximage->bytes_per_line) +
                                    ((x * ximage->depth) / 8);

    if ( ximage->depth < 8 )
        {
        pixels_per_byte = 8 / ximage->depth;
        unit_shift = (pixels_per_byte-1) - (x % pixels_per_byte);
        shift = unit_shift * ximage->depth; 

        pixel_value = pixel_value << shift;
        mask = mask << shift;
        mask = ~mask;          /* want to clear any old bits */
        *pixel_byteP = (*pixel_byteP & mask) | pixel_value;
        }
    else if ( ximage->depth == 8 )
        *pixel_byteP = pixel_value;
    /* byte order ASSUMPTION for greater than 8 bit images: LSBFirst */
    else if ( ximage->depth == 16 )
        {
        /* 16 bits = 2 bytes per pixel (5 bits per R, G, B). */
        *((unsigned short *)pixel_byteP) = pixel_value;
        }
    else if ( ximage->depth == 24 )
        {
        /* 24 bits = 3 bytes per pixel  */
        /* Microsoft stores the tripple as blue-green-red, and we are */
        /* passed a pixel value with red-green-blue.                  */
        *pixel_byteP = pixel_value & 0xFF;             /* blue */
        pixel_byteP++;
        *pixel_byteP = (pixel_value & 0xFF00) >> 8;    /* green */
        pixel_byteP++;
        *pixel_byteP = (pixel_value & 0xFF0000) >> 16; /* red */
        }
    else
        {
        /* 32 bits = 4 bytes per pixel  */
        *((unsigned int *)pixel_byteP) = pixel_value;
        }
    return TRUE;
}



void
XPutImage(Display *display, HGDIOBJ hObj, GC gc, XImage *image,
                int src_x, int src_y, int dest_x, int dest_y,
                unsigned int width, unsigned int height)
{
    int unselect_palette = FALSE, remove_region = FALSE;
    HDC hdc;
    HBITMAP hbm, mask;
    BOOL delete_dc;
    HPALETTE old_palette;


    if ( !hObj )
        /* no drawable. don't draw */
        return;

    hdc = InsureDrawable(hObj, &delete_dc);
    hbm = image->bitmap_handle;
    mask = gc->values.clip_mask;
    if ( mask )
        {
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;

            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)mask);
            mask = NULL;
            }       
        else
            {
            /* if clip mask is of type HBITMAP, then we use the mask *
             * in subsequent Blt calls; otherwise illegal clip mask. */
            if ( IS_PACKAGED_DRAWABLE(mask) )
                DebugMessage(NXLT("XPutImage: bad clip_mask type"));
            }
        }

    if ( image->palette_handle )
        {
        old_palette = MS_SelectPalette(hdc, image->palette_handle, FALSE);
        MS_RealizePalette(hdc);
        unselect_palette = TRUE;
        }

    if ( !hbm )
        {
        hbm = BitmapFromXImage(image);
        }

    PaintPixmap(hbm, hdc, gc, dest_x, dest_y, width, height,
                                        src_x, src_y, mask);

    /* cleanup */
    if ( unselect_palette )
        UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
}


void
XSetClipOrigin(Display *display, GC gc, int clip_x_origin, int clip_y_origin)
{
    gc->values.clip_x_origin = clip_x_origin;
    gc->values.clip_y_origin = clip_y_origin;
}

void
XSetArcMode(Display *display, GC gc, int arc_mode)
{
    gc->values.arc_mode = arc_mode;
}

void
XSetFillRule(Display *display, GC gc, int fill_rule)
{
    gc->values.fill_rule = fill_rule;
}

void
XSetSubwindowMode(Display *display, GC gc, int subwindow_mode)
{
    gc->values.subwindow_mode = subwindow_mode;
}

void
XSetFunction(Display *display, GC gc, int function)
{
    gc->values.function = function;
}

void
XSetPlaneMask(Display *display, GC gc, unsigned long plane_mask)
{
    gc->values.plane_mask = plane_mask;
}
    
void
XSetState(Display *display, GC gc, unsigned long foreground,
            unsigned long background, int function,
            unsigned long plane_mask)
{
    gc->values.foreground = foreground;
    gc->values.background = background;         
    gc->values.function   = function;
    gc->values.plane_mask = plane_mask;
}

void
XSetForeground(Display *display, GC gc, unsigned long pixel_val)
{
    gc->values.foreground = pixel_val;
}

void
XSetBackground(Display *display, GC gc, unsigned long pixel_val)
{
    gc->values.background = pixel_val;
}

void
XSetFillStyle(Display *display, GC gc, int fill_style)
{
    gc->values.fill_style = fill_style;
}

void
XSetFont(Display *display, GC gc, Font font)
{
    gc->values.font = font;
}                       

void
XSetTile(Display *display, GC gc, Pixmap tile)
{
    gc->values.tile = tile;
}

void
XSetStipple(Display *display, GC gc, Pixmap stipple)
{
    gc->values.stipple = stipple;
}

void
XSetTSOrigin(Display *display, GC gc, int ts_x_origin, int ts_y_origin)
{
    gc->values.ts_x_origin = ts_x_origin;
    gc->values.ts_y_origin = ts_y_origin;    
}


void
XSetClipMask(Display *display, GC gc, Pixmap clip_mask)
{
    if ( (gc->clip_mask_is_hregion == AX_WIN_RECTREGION) &&
                                    gc->values.clip_mask )
        {
        /* we only want to delete "rectangular regions"; that is, regions
         * created by XSetClipRectangles.  X Regions will be deleted in
         * XDestroyRegion.          -donato
         */
        MS_DeleteObject(gc->values.clip_mask);
        }

    /* if new mask is the same as the already existing one, just return. */
    if ( clip_mask == gc->values.clip_mask )
        return;

    /* now we can set the new clip mask */
    if ( !clip_mask )
        {
        /* NULL clip mask. just set and return */
        gc->values.clip_mask = clip_mask;
        gc->clip_mask_is_hregion = FALSE;
        return;
        }

#if 1
    /* the clip mask better be a bitmap! */
    if ( !IS_PACKAGED_DRAWABLE(clip_mask) )
        {
        /* unpackaged drawables *must* be bitmaps */
        gc->values.clip_mask = clip_mask;
        }
    else
        {
        DebugMessage(NXLT("XSetClipMask: bad clip mask type"));
        }
#else
    temp_pix = clip_mask;
    if ( IS_PACKAGED_DRAWABLE(temp_pix) )
        clip_mask = GET_DRAWABLE_HANDLE(temp_pix);

    obj_type = MS32_GetObjectType(clip_mask);
    if ( obj_type == OBJ_MEMDC )
        {
        width = MS_GetDeviceCaps(clip_mask, HORZRES);
        height = MS_GetDeviceCaps(clip_mask, VERTRES);
        hbm = MS_CreateBitmap(width, height, 1, 1, (CONST VOID*)NULL);
        MS_SelectObject(clip_mask, hbm);
        MS_DeleteObject(clip_mask);
        gc->values.clip_mask = hbm;
        }
    else if ( obj_type == OBJ_BITMAP )
        gc->values.clip_mask = clip_mask;
    else
        DebugMessage(NXLT("XSetClipMask: bad object type"));
#endif

    gc->clip_mask_is_hregion = FALSE;
}


void
XSetClipRectangles(Display *display,  GC gc,  int clip_x_origin,
                    int clip_y_origin, XRectangle rectangles[],
                    int nrects, int ordering)
{
    int ix, ret;
    int x1, y1, x2, y2;
    HRGN region, final_region = NULL;


    /* if nrects is zero or rectangles is empty, we'll skip processing and *
     * set the clip_mask to NULL (same as passing None to XSetClipMask).   */

    if ( (nrects == 1) && rectangles )
        {
        /* if we have one rectangle, just create the clip region */
        x1 = ( clip_x_origin ? clip_x_origin : rectangles[0].x );
        y1 = ( clip_y_origin ? clip_y_origin : rectangles[0].y );
        x2 = x1 + rectangles[0].width;
        y2 = y1 + rectangles[0].height;
        final_region = MS_CreateRectRgn(x1, y1, x2, y2);
        }
    else if ( (nrects > 1) && rectangles )
        {
        /* don't think this case ever happens in the product. */
        /* we have more than one rectangle, so create a region for each *
         * one and combine them together to form one clipping region.   */
        for ( ix=0; ix < nrects; ix++ )
            {
            x1 = rectangles[ix].x;
            y1 = rectangles[ix].y;
            x2 = x1 + rectangles[ix].width;
            y2 = y1 + rectangles[ix].height;
            region = MS_CreateRectRgn(x1, y1, x2, y2);
            if ( final_region == NULL )
                {
                /* first time thru, we don't have 2 regions to combine yet, *
                 * so set final_region to first region, and iterate.        */
                final_region = region;
                continue;
                }
            ret = MS_CombineRgn(final_region, region, final_region, RGN_OR);
            MS_DeleteObject(region);
            if ( ret == ERROR )
                DebugMessage(NXLT("XSetClipRectangles: could not combine regions!"));
            }
        }

    /* if current clip mask is an HRGN, make sure it's deleted. */
    if ( (gc->clip_mask_is_hregion == AX_WIN_RECTREGION) &&
                                    gc->values.clip_mask )
        {
        /* we only want to delete "rectangular regions"; that is, regions
         * created by XSetClipRectangles.  X Regions will be deleted in
         * XDestroyRegion.          -donato
         */
        MS_DeleteObject(gc->values.clip_mask);
        }

    gc->values.clip_mask = final_region;
    /* tell the GC we have a clip mask that is a rectangular Windows region
     * created here. This means that XSetClipMask will have to make sure it
     * is deleted since there is no equivalent X function.      -donato
     */
    gc->clip_mask_is_hregion = AX_WIN_RECTREGION;
    gc->values.clip_x_origin = clip_x_origin;
    gc->values.clip_y_origin = clip_y_origin;
}

void
axmsXSetClipMaskAsRegion(GC gc, HRGN hrgn)
{
    /* if current clip mask is an HRGN, make sure it's deleted. */
    if ( (gc->clip_mask_is_hregion == AX_WIN_RECTREGION) &&
                                    gc->values.clip_mask )
        {
        /* we only want to delete "rectangular regions"; that is, regions
         * created by XSetClipRectangles.  X Regions will be deleted in
         * XDestroyRegion.          -donato
         */
        MS_DeleteObject(gc->values.clip_mask);
        }

    gc->values.clip_mask = hrgn;
    /* tell the GC we have a clip mask that is a rectangular Windows region
     * created here. This means that XSetClipMask will have to make sure it
     * is deleted since there is no equivalent X function.      -donato
     */
    gc->clip_mask_is_hregion = AX_WIN_RECTREGION;
}

void
XSetLineAttributes(Display *display, GC gc, unsigned int line_width,
                        int line_style, int cap_style, int join_style)
{
    gc->values.line_style = line_style;
    gc->values.line_width = line_width;
    gc->values.cap_style  = cap_style;
    gc->values.join_style = join_style;
}


static void
AxXFillTransparentPoly(HDC dest_dc, HBITMAP hbm, POINT *points, int npoints,
                        int xpos, int ypos, int width, int height,
                        COLORREF fore_color, COLORREF back_color,
                        BOOL is_arc)
{
    int ix;
    HDC mask_dc, pattern_dc;
    HPEN old_pen;
    HBRUSH old_brush;
    HBITMAP mask_hbm, old_mask_hbm, old_pattern_hbm, pattern_hbm;
    POINT *mask_points, rect_points[4];
    HPALETTE old_pattern_palette;
    COLORREF old_bk_color, old_text_color;

    rect_points[0].x = 0;       rect_points[0].y = 0;
    rect_points[1].x = width;   rect_points[1].y = 0;
    rect_points[2].x = width;   rect_points[2].y = height;
    rect_points[3].x = 0;       rect_points[3].y = height;

/*** first, fill a memory dc with the pattern bitmap. ***/
    pattern_dc = MS_CreateCompatibleDC(RootWin);
    pattern_hbm = MS_CreateCompatibleBitmap(RootWin, width, height);
    old_pattern_hbm = MS_SelectObject(pattern_dc, pattern_hbm);
    old_pattern_palette = SelectAndRealizeAxWinPalette(pattern_dc);
    DrawPatternFill(pattern_dc, hbm, rect_points, 4, width, height, 0, 0,
                                    fore_color, back_color, FALSE, FALSE);

/*** second, draw the poly to a memory dc, creating a mask. ***/
    mask_dc = MS_CreateCompatibleDC(NULL);
    mask_hbm = MS_CreateCompatibleBitmap(mask_dc, width, height);
    old_mask_hbm = MS_SelectObject(mask_dc, mask_hbm);
    MS_PatBlt(mask_dc, 0, 0, width, height, BLACKNESS);
    old_brush = MS_SelectObject(mask_dc, MS_GetStockObject(WHITE_BRUSH));
    old_pen = MS_SelectObject(mask_dc, MS_GetStockObject(NULL_PEN));
    if ( is_arc )
        {
        /* the points array contains the necessary radial points */
        MS_Pie(mask_dc, xpos, ypos, xpos + width, ypos + height,
                points[1].x, points[1].y, points[2].x, points[2].y);
        }
    else
        {
        /* we are drawing to a mask so we want to zero the coordinates */
        mask_points = (POINT*)malloc(npoints*sizeof(POINT));
        for ( ix=0; ix < npoints; ix++ )
            {
            mask_points[ix].x = points[ix].x - xpos;
            mask_points[ix].y = points[ix].y - ypos;
            }
        MS_Polygon(mask_dc, mask_points, npoints);
        free(mask_points);
        }
    MS_SelectObject(mask_dc, old_brush);
    MS_SelectObject(mask_dc, old_pen);
    /* fill the mask with the pattern bitmap, but only where there are 1s,
     * that is, only where the object is.
     */
    DrawPatternFill(mask_dc, hbm, rect_points, 4, width, height, 0, 0,
                            RGB(255,255,255), RGB(0,0,0), TRUE, FALSE);
    /* invert the mask */
    //MS_PatBlt(mask_dc, 0, 0, width, height, DSTINVERT);

/*** finally, do the transparency blts to the destination. ***/
    /* "True Mask Method" of doing transparency. */
    MS_BitBlt(dest_dc, xpos, ypos, width, height, pattern_dc, 0,0, SRCINVERT);
    old_bk_color = MS_SetBkColor(dest_dc, RGB(255,255,255));
    old_text_color = MS_SetTextColor(dest_dc, RGB(0,0,0));
    MS_BitBlt(dest_dc, xpos, ypos, width, height, mask_dc, 0,0, 0x00220326);
    MS_SetBkColor(dest_dc, old_bk_color);
    MS_SetTextColor(dest_dc, old_text_color);
    MS_BitBlt(dest_dc, xpos, ypos, width, height, pattern_dc, 0,0, SRCINVERT);

    /* cleanup */
    MS_SelectObject(mask_dc, old_mask_hbm);
    MS_DeleteDC(mask_dc);
    MS_DeleteObject(mask_hbm);

    UnSelectPalette(pattern_dc, old_pattern_palette);
    MS_SelectObject(pattern_dc, old_pattern_hbm);
    MS_DeleteDC(pattern_dc);
    MS_DeleteObject(pattern_hbm);
}

BOOL
XFillPolygon(Display *display, Drawable hObj, GC gc, XPoint *points,
                                    int npoints, int shape, int mode)
{
    int ix, sHdc, s_draw_dc, old_mode;
    int min_x, min_y, clip_x, clip_y;
    int width, height;
    BOOL ret, delete_fill_dc, delete_draw_dc, remove_fill_dc,
         bMask = FALSE,
         bTransparent = FALSE,
         delete_fill_hbm = FALSE,
         delete_mem_objs = FALSE,
         remove_region = FALSE,
         use_pen = FALSE;
    HDC     fill_hdc, mem_hdc, draw_dc, pass_dc;
    HPEN    old_pen, hpen;
    HBRUSH  old_brush, hbrush, fill_brush;
    HBITMAP hbm, fill_hbm, mem_hbm, pattern, old_fill_hbm;
    BITMAP bm;
    DWORD fg_rop_code, bg_rop_code;
    POINT *msPoints, *mask_points;
    COLORREF fore_color, back_color;
    HPALETTE old_palette, old_draw_palette;
    BOOL do_manual_pattern_fill = FALSE;

    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    /* convert XPoints to POINTs so GDI calls work properly. */
    msPoints = (POINT*)malloc(npoints*sizeof(POINT));
    for ( ix=0; ix < npoints; ix++ )
        {
        msPoints[ix].x = points[ix].x;
        msPoints[ix].y = points[ix].y;
        }
    GetPolyInfo(msPoints, npoints, &width, &height, &min_x, &min_y);

    hbrush = NULL;
    sHdc = s_draw_dc = old_mode = 0;
    delete_fill_dc = delete_draw_dc = remove_fill_dc = FALSE;
    fill_hdc = mem_hdc = draw_dc = (HDC)NULL;
    pass_dc = hObj;     /* hdc we will pass to routines below this */
    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HBITMAP, we create a memory DC which we will use to draw *
         * the polygon on. we set a flag (bMask) to true, so that   *
         * we can later blt the memory DC thru the mask and onto    *
         * the screen.                                              */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            /* check the drawable type */
            fill_hdc = InsureDrawable(hObj, &remove_fill_dc);
            if ( !remove_fill_dc )
                {
                /* we were passed an HDC, so just use that to draw on */
                sHdc = MS_SaveDC(fill_hdc); /* save DC so it can be restored */
                }
            /* the passed object is a bitmap which is selected by */
            /* InsureDrawable into an HDC, use that HDC for any routines */
            /* called from here to avoid trying to select the bitmap     */
            /* into another HDC below this                               */
            pass_dc = fill_hdc;

            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn( fill_hdc, (HRGN)gc->values.clip_mask );
            }
        else
            {
            /*** clip mask better be a bitmap handle! ***/
            hbm = gc->values.clip_mask;
            MS_GetObject(hbm, sizeof(BITMAP), (LPSTR)&bm);

            /* check to see what type of "drawable" we were passed. */
            draw_dc = InsureDrawable(pass_dc, &delete_draw_dc);
            if ( !delete_draw_dc )
                {
                /* save non-memory DC so it can be restored */
                s_draw_dc = MS_SaveDC(draw_dc);
                }
            /* the passed object is a bitmap which is selected by */
            /* InsureDrawable into an HDC, use that HDC for any routines */
            /* called from here to avoid trying to select the bitmap     */
            /* into another HDC below this                               */
            pass_dc = draw_dc;

            fill_hdc = MS_CreateCompatibleDC((HDC)NULL);
            fill_hbm = MS_CreateCompatibleBitmap(RootWin,
                                    bm.bmWidth, bm.bmHeight);
            old_fill_hbm = MS_SelectObject(fill_hdc, fill_hbm);
            MS_PatBlt(fill_hdc, 0, 0, bm.bmWidth, bm.bmHeight, BLACKNESS);

            bMask = TRUE;
            delete_fill_dc = TRUE;
            delete_fill_hbm = TRUE;
            }
        }
    else
        {
        /* no clip mask was specified. check to see what type *
         * of "drawable" we were passed.                      */
        fill_hdc = InsureDrawable(hObj, &remove_fill_dc);
        if ( !remove_fill_dc )
            {
            /* we were passed an HDC, so just use that to draw on */
            sHdc = MS_SaveDC(fill_hdc); /* save DC so it can be restored */
            }
        /* the passed object is a bitmap which is selected by */
        /* InsureDrawable into an HDC, use that HDC for any routines */
        /* called from here to avoid trying to select the bitmap     */
        /* into another HDC below this                               */
        pass_dc = draw_dc;
        }

    /* Select the palette into the window device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(fill_hdc);
 
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
#if FOR_FILTER
        fore_color = REAL_WHITE_PIXEL;
#else
        fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
        }
    else
        fore_color = GET_COLOR_VALUE(gc->values.foreground);

    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
#if FOR_FILTER
        back_color = REAL_WHITE_PIXEL;
#else
        back_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
        }
    else
        back_color = GET_COLOR_VALUE(gc->values.background);


    if ( gc->values.fill_style != FillSolid &&
          gc->values.fill_style != FillTiled )
        {
        /* fill style is Stipple, so make sure we have a stipple map */
        if ( gc->values.stipple )
            {
            /* use specified stipple pattern to fill polygon. *
             * Pattern brushes use text fore and back-ground  *
             * colors to paint with.  (only use stipples with *
             * appropriate fill styles).                      */
            if ( Running_Windows95 )
                {
                do_manual_pattern_fill = TRUE;
                pattern = gc->values.stipple;
                }
            else if ( gc->values.fill_style == FillStippled )
                {
                /* background remains untouched (transparent) */
                hbrush = MS_CreatePatternBrush(gc->values.stipple);
                mem_hdc = MS_CreateCompatibleDC((HDC)NULL);
                mem_hbm = MS_CreateCompatibleBitmap(RootWin, width, height);
                MS_SelectObject(mem_hdc, mem_hbm);
                bTransparent = TRUE;
                delete_mem_objs = TRUE;
                }
            else if ( gc->values.fill_style == FillOpaqueStippled )
                {
                hbrush = MS_CreatePatternBrush(gc->values.stipple);
                MS_SetBkColor(fill_hdc, fore_color);
                MS_SetTextColor(fill_hdc, back_color);
                }
            }
        else
            DebugMessage(NXLT("XFillPolygon: Stipple Fill requested without a stipple map!"));
        }

    else if ( gc->values.fill_style == FillTiled )
        {
        /* fill style is Tile, so make sure we have a tile */
        if ( gc->values.tile )
            {
            if ( Running_Windows95 )
                {
                pattern = gc->values.tile;
                do_manual_pattern_fill = TRUE;
                }
            else
                {
                hbrush = MS_CreatePatternBrush(gc->values.tile);
                MS_SetBkColor(fill_hdc, fore_color);
                MS_SetTextColor(fill_hdc, back_color);
                }
            }
        else
            DebugMessage(NXLT("XFillPolygon: Tile Fill requested without a tile!"));
        }

    else if ( gc->values.fill_style == FillSolid )
        {
        /* use a solid color brush */ 
        if ( gc->values.function == GXxor )
            old_mode = MS_SetROP2(fill_hdc, R2_NOT);
        hbrush = MS_CreateSolidBrush(fore_color);
        }

    /* this is a fill routine, so don't use a pen (no line is drawn) */
    hpen = (HPEN) MS_GetStockObject(NULL_PEN);
    old_pen = MS_SelectObject(fill_hdc, hpen);

    if ( bMask )
        {
        /* if we are drawing to a mask we want to zero the coordinates */
        mask_points = (POINT*)malloc(npoints*sizeof(POINT));
        for ( ix=0; ix < npoints; ix++ )
            {
            mask_points[ix].x = points[ix].x - min_x;
            mask_points[ix].y = points[ix].y - min_y;
            }
        }

    if ( do_manual_pattern_fill )
        {
        /*** This should only be true on Windows 95 ***/
        POINT *tmp_points;
        if ( bMask )
            {
            tmp_points = mask_points;
            min_x = min_y = 0;
            }
        else
            tmp_points = msPoints;
        if ( gc->values.fill_style == FillStippled )
            {
            AxXFillTransparentPoly(fill_hdc, pattern, tmp_points, npoints,
                        min_x,min_y,width,height,fore_color,back_color,FALSE);
            }
        else
            {
            DrawPatternFill(fill_hdc,pattern, tmp_points,npoints,width,height,
                            min_x,min_y, fore_color,back_color, FALSE, FALSE);
            }
        }
    else if ( bTransparent )
        {
        /* need to draw a transparent polygon */
        ret = DrawTransparentFill(gc, fill_hdc, mem_hdc, hbrush,
                                        msPoints, npoints,
                                        width, height,
                                        FILL_TRANS_POLY, bMask, pass_dc);
        }
    else if ( hbrush )
        {
        old_brush = MS_SelectObject(fill_hdc, hbrush);
        ret = MS_Polygon(fill_hdc, msPoints, npoints);
        MS_SelectObject(fill_hdc, old_brush);
        if ( old_mode )
            MS_SetROP2(fill_hdc, old_mode);
        }

    if ( bMask && !bTransparent )
        {
        HBRUSH old_fill_brush;
        old_draw_palette = SelectAndRealizeAxWinPalette(draw_dc);

        if ( Running_WindowsNT )
            {
            old_brush = MS_SelectObject(draw_dc, hbrush);
            fill_brush = MS_GetStockObject(WHITE_BRUSH);

            MS_SetBkColor(draw_dc, fore_color);
            MS_SetTextColor(draw_dc, back_color);

            old_fill_brush = MS_SelectObject(fill_hdc, fill_brush);
            clip_x = gc->values.clip_x_origin;
            clip_y = gc->values.clip_y_origin;
            mask_points[2].y = mask_points[3].y = bm.bmHeight;
            ret = MS_Polygon(fill_hdc, mask_points, npoints);
            MS_SelectObject(fill_hdc, old_fill_brush);

            fg_rop_code = 0x00E20746;
            bg_rop_code = 0x00AA0029;
#if FOR_FILTER
            MS32_MaskBlt(draw_dc, gc->values.clip_x_origin, msPoints[0].y,
                                        width, height, fill_hdc, 0, 0,
                                        hbm, 0, (msPoints[0].y - clip_y),
                                        MAKEROP4(fg_rop_code, bg_rop_code));
#else
            AxWinMaskBlt(draw_dc, gc->values.clip_x_origin, msPoints[0].y,
                                            width, height, fill_hdc, 0, 0,
                                            hbm, 0, (msPoints[0].y - clip_y),
                                            fg_rop_code, bg_rop_code);
#endif
            MS_SelectObject(draw_dc, old_brush);
            }
        else    /* Running Windows 95 */
            {
            DWORD rop_code;
            HDC mask_dc;
            HBITMAP old_hbm;
            COLORREF old_bk_color, old_text_color;
            int x = msPoints[0].x;
            int y = msPoints[0].y;
            int mask_x = (msPoints[0].x - gc->values.clip_x_origin);
            int mask_y = (msPoints[0].y - gc->values.clip_y_origin);

            mask_dc = MS_CreateCompatibleDC(draw_dc);
            old_hbm = MS_SelectObject(mask_dc, hbm);

            /* "True Mask Method" of doing transparency. */
            MS_BitBlt(draw_dc, x, y, width, height, fill_hdc, 0, 0, SRCINVERT);

            /* a mask, draw the rectangle through the clip mask */
            old_bk_color = MS_SetBkColor(draw_dc, PALETTERGB(255,255,255));
            old_text_color = MS_SetTextColor(draw_dc, PALETTERGB(0,0,0));
            rop_code = 0x220326;   /* not source and destination */
            MS_BitBlt(draw_dc, x, y, width, height, mask_dc,mask_x,mask_y, rop_code);
            MS_SetBkColor(draw_dc, old_bk_color);
            MS_SetTextColor(draw_dc, old_text_color);

            MS_BitBlt(draw_dc, x, y, width, height, fill_hdc, 0, 0, SRCINVERT);


            MS_SelectObject(mask_dc, old_hbm);
            MS_DeleteDC(mask_dc);
            }
        /* cleanup */
        UnSelectPalette(draw_dc, old_draw_palette);
        free(mask_points);
        }


    /* cleanup */
    UnSelectPalette(fill_hdc, old_palette);
    MS_SelectObject(fill_hdc, old_pen);
    if ( remove_region )
        MS_SelectClipRgn(fill_hdc, (HRGN)NULL);

    if ( delete_mem_objs )
        {
        MS_DeleteDC(mem_hdc);
        MS_DeleteObject(mem_hbm);
        }

    if ( delete_fill_hbm )
        {
        MS_SelectObject(fill_hdc, old_fill_hbm);
        MS_DeleteObject(fill_hbm);
        }

    if ( remove_fill_dc )
        RemoveDrawable(hObj, fill_hdc);
    else if ( delete_fill_dc )
        MS_DeleteDC(fill_hdc);
    else
        MS_RestoreDC(fill_hdc, sHdc);

    if ( delete_draw_dc )
        RemoveDrawable(hObj, draw_dc);
    else if ( s_draw_dc != 0 )
        MS_RestoreDC(draw_dc, s_draw_dc);

    if ( hbrush )
        MS_DeleteObject(hbrush);
    free(msPoints);
    return ret;
}


BOOL
XDrawRectangle(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                            unsigned int width, unsigned int height)
{
    int sHdc, old_mode;
    BOOL ret, delete_dc, remove_region = FALSE, not_used;
    HDC hdc;
    HBRUSH hbrush, old_brush;
    HPEN hpen, old_pen;
    HPALETTE old_palette;


    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(hdc);   /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }
        else
            DebugMessage(NXLT("XDrawRectangle: bad clip mask type."));
        }

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    MS_SetBkMode(hdc, TRANSPARENT);
    /* set brush */
    hbrush    = MS_GetStockObject(NULL_BRUSH);
    old_brush = MS_SelectObject(hdc, hbrush);
    /* set drawing pen */
    hpen = AxWinGetPen(gc, hdc, &not_used);
    old_pen = MS_SelectObject(hdc, hpen);

    if ( gc->values.function == GXxor || gc->values.function == GXinvert )
        old_mode = MS_SetROP2(hdc, R2_NOT);

    /* XDrawRectangle draws a rect _outlining_ the passed in coords. *
     * Therefore passing in (0, 0, 19, 11) creates a 20x12 rect. The *
     * MS_Rectangle call works differently, so we add one.           */
    ret = MS_Rectangle(hdc, x, y, x + width + 1, y + height + 1);

    if ( gc->values.function == GXxor || gc->values.function == GXinvert )
        MS_SetROP2(hdc, old_mode);

    /* clean up */
    UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        {
        MS_RestoreDC(hdc, sHdc);
        MS_SelectObject(hdc, old_brush);
        MS_SelectObject(hdc, old_pen);
        }
    MS_DeleteObject(hpen);
    return ret;
}





#if !FOR_FILTER    /* { */

GC
XDefaultGC(Display *dpy, int junk)
{
    static GC DefaultGC=NULL;

    if ( !DefaultGC )
        {
        XGCValues gcv;
        gcv.foreground = ForePixel;
        gcv.background = BackPixel;
        gcv.plane_mask = AllPlanes;
        DefaultGC = XCreateGC(dpy, (Drawable)NULL,
                                GCForeground | GCBackground | GCPlaneMask,
                                &gcv);
        }
    return DefaultGC;
}

void
XRaiseWindow(Display *display, Window w)
{
    HWND hwnd;
    hwnd = AxGetHWNDfromDrawable(w);
    if ( hwnd )
        MS_SetFocus(hwnd);
}




extern AXWidget WindowList;

/** Set the focus given the drawable of any of the children  */
/** This is very useful, because it has been found that during dialog */
/*  transitions, if you do a SetForegroundWindow of a child window, (such */
/*  as the work window in the spreadsheet), when the dialog window is actually*/
/*  destroyed (which happens just after a call to this func) Windows does  */
/*  not see any active top level window, an so promots another window from */
/*  Applixware, often the Main Menu.  If we do a SetForegroundWindow of a  */
/*  true main widget window  (a true top level window) then things work OK */
/*  and the main menu does not get promoted. - jon                         */
/*  Repro example of above:  Open SS, goto Borders & Shading, select a color */
/*     and OK the dialog.  man menu used to pop to front.                    */
void SetWindowsFocusFromChild( Window win )
{
    HWND hwnd;
    AXWidget w;

    hwnd = AxGetHWNDfromDrawable( win );

    /* Find the main widget associated with the window */
    for ( w = WindowList; w; w = w->nextWin )
        {
        if ( w->winid == hwnd )
            {
            while ( w->parent != NULL )
               {
               w = (AXWidget)w->parent;
               }
            hwnd = w->winid;
            break;
            }
        }

    if ( hwnd )
        MS_SetForegroundWindow( hwnd );

    return;
}

 

void
XSetInputFocus(Display *display, Window focus, int revert_to, Time time)
{
    HWND hwnd;

    hwnd = AxGetHWNDfromDrawable(focus);
    if ( hwnd )
        MS_SetForegroundWindow(hwnd);
    else
        {
        if ( revert_to == RevertToParent )
            MS_SetForegroundWindow(GetParent(hwnd));
        else
            MS_SetForegroundWindow(NULL);
        }
}



void
XClearArea(Display *display, Window in_hdc, int x, int y, unsigned int width,
                                        unsigned int height, BOOL exposures)
{
    HDC hdc;
    HWND hwnd;
    int delete_dc=FALSE;
    RECT rect, win_rect;
    HPALETTE old_palette;
    DWORD class_brush;
    short obj_type;

    /* in this function we'll need both a window handle and a device context */
    if ( IS_PACKAGED_DRAWABLE(in_hdc) )
        {
        obj_type = GET_DRAWABLE_TYPE(in_hdc);
        if ( obj_type == AX_HWND_TYPE )
            {
            hwnd = (HWND)GET_DRAWABLE_HANDLE(in_hdc);
            hdc = InsureDrawable(in_hdc, &delete_dc);
            }
        else
            {
            /* must be an HDC */
            hdc = (HDC)GET_DRAWABLE_HANDLE(in_hdc);
            hwnd = AxXGetHWND(hdc);
            }
        }
    else
		{
        DebugMessage(NXLT("XClearArea: invalid drawable!"));
		return;
		}

    rect.left   = x;
    rect.top    = y;
    rect.right  = x + width;
    rect.bottom = y + height;
    if ( width == 0 || height == 0 )
        {
        MS_GetClientRect(hwnd, &win_rect);
        if ( width == 0 )
            rect.right = win_rect.right;
        if ( height == 0 )
            rect.bottom = win_rect.bottom;
        }

    old_palette = SelectAndRealizeAxWinPalette(hdc);

    /* get background brush value from the window class */
    class_brush = MS_GetClassLong(hwnd, GCL_HBRBACKGROUND);
    if ( !class_brush )
        class_brush = COLOR_WINDOW + 1;  /* a sane default to fall back on. */

    /* clear the area. */
    MS_FillRect(hdc, &rect, (HBRUSH)class_brush);

    /* cause an exposure if requested. */
    if ( exposures )
        {
        if ( x == 0 && y == 0 && width == 0 && height == 0 )
            /* send expose event to whole window */
            MS_InvalidateRect(hwnd, (CONST RECT*)NULL, FALSE);
        else
            MS_InvalidateRect(hwnd, &rect, FALSE);
        }

    UnSelectPalette(hdc, old_palette);
    if ( delete_dc )
       RemoveDrawable(in_hdc, hdc);
}               

 

BOOL
XCopyPlane(Display *display, HGDIOBJ srcDC, Drawable destDC, GC gc,
            int src_x, int src_y, unsigned int width, unsigned int height,
            int dest_x, int dest_y, unsigned long plane)
{
    HDC drawDC, bitmapDC;
    BOOL ret, ret1, ret2, remove_region = FALSE;
    DWORD rop_code;
    int delete_dc, delete_dest_dc;
    HBRUSH hbrush, old_brush;
    unsigned long white_pixel;


    bitmapDC = InsureDrawable(srcDC, &delete_dc);
    drawDC = InsureDrawable(destDC, &delete_dest_dc);

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;

            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(drawDC, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XCopyPlane: bad clip mask type."));
        }

    /* set up drawing palette */
    //old_palette = SelectAndRealizeAxWinPalette(drawDC);
    if ( gc->values.function == GXxor )
        {
        /* THE FOLLOWING 'sort of' WORKS.  (doesn't work if user changes  *
         * system colors without logging out of Applixware). HOW THE HELL *
         * DOES ONE DO A PROPER XOR ON Windows?!            -donato       */
        white_pixel = REAL_WHITE_PIXEL;
        /* invert the foreground and background colors in our destination. */
        MS_SetBkColor(drawDC, ForeWorkPixelRGB);
        MS_SetTextColor(drawDC, COLOR_WHITE);
        /* to accomplish the XOR, we need to do 2 blts: *
         * one with a rop code that XORs the memory DC  *
         * with the destination DC, and one that XORs   *
         * the background brush with the destination.   */
        rop_code = SRCINVERT;    /* XOR source and dest */
        ret1 = MS_BitBlt(drawDC, dest_x, dest_y, width, height,
                            bitmapDC, src_x, src_y, rop_code);

        rop_code = PATINVERT;    /* XOR brush and destination */
        hbrush = MS_CreateSolidBrush(BackWorkPixelRGB);
        old_brush = MS_SelectObject(drawDC, hbrush);
        ret2 = MS_PatBlt(drawDC, dest_x, dest_y, width, height, rop_code);

        ret = (ret1 & ret2);

        /* cleanup */
        MS_SelectObject(drawDC, old_brush);
        MS_DeleteObject(hbrush);
        }
    else if ( gc->values.function == GXcopy )
        {
        rop_code = SRCCOPY;
        ret = MS_BitBlt(drawDC, dest_x, dest_y, width, height, bitmapDC,
                                                src_x, src_y, rop_code);
        }
    else
        DebugMessage(NXLT("XCopyPlane: called with un-ported GC function"));


    /* cleanup */
    //UnSelectPalette(drawDC, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(drawDC, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(srcDC, bitmapDC);
    if ( delete_dest_dc )
        RemoveDrawable(destDC, drawDC);
    return ret;
}


Pixmap
XCreatePixmapFromBitmapData(Display *display, Drawable hdc, char *data,
                            unsigned int width, unsigned int height,
                            unsigned long fg, unsigned long bg,
                            unsigned int desired_depth)
/* unsigned int  desired_depth;    not used under windows */
{
    int  i;
    int ax_bytewidth, win_bytewidth, win_imgSize;
    Pixmap pixmap;
    PBITMAPINFO bm_infoP;
    unsigned char *destP, *bitmap_bits;
    unsigned char *srcP;
    unsigned short *colorP;


    /* Windows non-monochrome bitmap data must be 4 byte alligned */
    /* so if the incoming image does not happen to be a multiple of */
    /* 4 bytes wide, we need to copy it to a new, bigger buffer    */

    /* applixware images are 2-byte alligned  */
    ax_bytewidth  = (width+7)/8;
    ax_bytewidth  = ((ax_bytewidth + 1) & ~0x1); 

    /* windows images are 4 byte alligned */
    win_bytewidth = ((ax_bytewidth + 3) & ~0x3);
    win_imgSize   = win_bytewidth * height;

    bitmap_bits = data;          /* assume 4-byte multiple */
    destP = (unsigned char *)NULL;
    if ( ax_bytewidth != win_bytewidth )
       {
       /* not a multile of 4 bytes wide, need to copy */
       bitmap_bits = calloc( 1, win_imgSize );
       destP = bitmap_bits;
       srcP = data;
       for ( i=0; i < (int)height; i++ )
          {
          memcpy(destP, srcP, ax_bytewidth );
          destP = destP + win_bytewidth;
          srcP = srcP + ax_bytewidth;
          }
       } 

    bm_infoP = (BITMAPINFO *)calloc( 1, 
                         (sizeof(BITMAPINFO) + (2 * sizeof(short))) );
    bm_infoP->bmiHeader.biSize      = sizeof(BITMAPINFOHEADER);
    bm_infoP->bmiHeader.biWidth     = width;
    bm_infoP->bmiHeader.biHeight    = -(int)height;
    bm_infoP->bmiHeader.biPlanes    = 1;
    bm_infoP->bmiHeader.biBitCount  = 1;
    bm_infoP->bmiHeader.biClrUsed      = 2;
    bm_infoP->bmiHeader.biClrImportant = 2;
    bm_infoP->bmiHeader.biCompression  = BI_RGB;
    bm_infoP->bmiHeader.biSizeImage    = win_imgSize;
    colorP = (unsigned short *)(&bm_infoP->bmiColors[0]);
    *colorP = bg;
    *(colorP+1) = fg;

    pixmap = MS_CreateDIBitmap(hdc, &bm_infoP->bmiHeader, CBM_INIT,
                            bitmap_bits, bm_infoP, DIB_PAL_COLORS);
    free(bm_infoP);

    if ( destP != (unsigned char *)NULL )
       free( bitmap_bits );

    return( pixmap );
}


Cursor
XCreateFontCursor(Display *display, unsigned int shape)
{
    Cursor cur;

    cur = MS_LoadCursor((HINSTANCE)NULL, (LPCTSTR) MAKEINTRESOURCE(shape));
    return cur;
}


Cursor
XCreatePixmapCursor(Display *display, Pixmap source, Pixmap mask,
                    XColor *fg_color, XColor *bg_color,
                    unsigned int x, unsigned int y)
{
/* on X, pixmaps are created from image bits and then this function  *
 * is called to create the cursor. Windows just wants the bits, so   *
 * we would end up creating pixmaps from bits, and then getting the  *
 * bits back from those pixmaps; clearly redundant operations. so we *
 * have scrapped the port of this function.  Use CreateWinCursor to  *
 * get the same functionality.     -donato                           */

    DebugMessage(NXLT("XCreatePixmapCursor not ported. Use CreateWinCursor!"));
    return NULL;
}


Cursor
XCreateGlyphCursor(Display *display, Pixmap src_font, Pixmap mask_font,
                    unsigned int src_char, unsigned int mask_char,
                    XColor *fg_color, XColor *bg_color)
{
    return (Cursor)NULL;    /* for now ? */
}


/*** USE THIS ONLY ON CURSORS CREATED WITH MS_CreateCursor !! ***/
/* all other cursors are not need to be free'd/destroyed */
/* calls to this function which do not reference a "custom" cursor
 * should be if-def'd out! */
void
XFreeCursor(Display *display, Cursor cursor)
{
    HCURSOR hcur;
    /* before destroying cursor, make sure it's not being used. */
    hcur = MS_GetCursor();
    if ( cursor == hcur )
        MS_SetCursor(NULL);
    MS_DestroyCursor(cursor);
    return;
}


void
XDefineCursor(Display *display, Window w, Cursor cursor)
{
    HWND hwnd;
    hwnd = AxGetHWNDfromDrawable(w);
    if ( hwnd )
        MS_SetClassLong(hwnd, GCL_HCURSOR, (LONG)cursor);
    if ( !AxStartedForPrinting )
       /* we are not running in the background */
       MS_SetCursor(cursor);
}

void
AxWinDefineCursor(HWND hwnd, HCURSOR cursor)
{
    MS_SetWindowLong(hwnd, GWL_USERDATA, (LONG)cursor);
    if ( !AxStartedForPrinting )
       /* we are not running in the background */
       MS_SetCursor(cursor);
}


void
XDestroyWindow(Display *display, Window w)
{
    MS_DestroyWindow(w);
}


BOOL
XDrawLines(Display *display, HGDIOBJ hObj, GC gc, XPoint *points,
                                        int npoints, int mode)
{
    int ix, sHdc;
    HDC hdc;
    BOOL retval, delete_dc;
    BOOL transparent, remove_region = FALSE;
    POINT *msPoints;
    HPEN hpen=NULL, old_pen;
    HPALETTE old_palette;
    line_gc_type line_gc;


    retval = FALSE;
    if ( !hObj )
        /* no drawable. don't draw */
        return retval;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(hdc);   /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XDrawLines: bad clip mask type."));
        }
            
    /* convert XPoints to POINTs */
    msPoints = (POINT*)malloc( (npoints)*sizeof(POINT) );
    for ( ix=0; ix < npoints; ix++ )
        {
        msPoints[ix].x = points[ix].x;
        msPoints[ix].y = points[ix].y;
        }

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);

    MS_SetBkMode(hdc, TRANSPARENT);
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
        /* make sure we have the real white pixel. */
        gc->values.foreground = REAL_WHITE_PIXEL;
        }

    if ( Running_Windows95 && gc->values.function != GXxor &&
                                    gc->values.line_style != LineSolid &&
                                    /*gc->values.line_width <= 1 &&*/
                                    gc->values.dash_list_size != 0 )
        {
        HBRUSH hbrush, old_brush;
        CreateLineGCfromGC(gc, hdc, &line_gc);
        /* DASHED LINE */
        if ( gc->values.line_width > 1 )
            {
            /* If it's a thick line we'll be drawing filled polygons
             * for each dash, so set up a solid brush and a pen color.
             */
            hbrush = MS_CreateSolidBrush(GET_COLOR_VALUE(line_gc.fg));
            old_brush = MS_SelectObject(hdc, hbrush);
            hpen = MS_CreatePen(PS_SOLID, 0, GET_COLOR_VALUE(line_gc.fg));
            old_pen = MS_SelectObject(hdc, hpen);
            }

        for ( ix=0; ix < npoints-1; ix++ )
            {
            if ( (points[ix+1].x - points[ix].x) == 0 )
                {
                /* vertical line */
                line_gc.infinite_slope = TRUE;
                line_gc.slope = 0.0;
                line_gc.x_offset = 0.0;
                line_gc.y_intercept = 0;
                }
            else
                {
                double len_2, slope_2;

                line_gc.slope = (double)(points[ix+1].y-points[ix].y) /
                                    (double)(points[ix+1].x-points[ix].x);
                line_gc.y_intercept = points[ix].y -
                            (line_gc.slope * points[ix].x);
                /* calculate half the line thickness squared. */
                len_2  = pow((double)(line_gc.line_width/2), 2.0);
                slope_2 = pow(line_gc.slope, 2.0);  /* the slope squared */
                if ( line_gc.slope == 0.0 )
                    {
                    line_gc.x_offset = 0.0;
                    }
                else
                    {
                    line_gc.x_offset = sqrt(((len_2 * slope_2) /
                                            (4.0 * (slope_2 + 1.0))));
                    }
                }

            retval = MS_LineDDA(points[ix].x, points[ix].y,
                                points[ix+1].x, points[ix+1].y,
                                (LINEDDAPROC)DrawDashLineProc,
                                (LPARAM)&line_gc);
            }

        if ( gc->values.line_width > 1 )
            {
            MS_SelectObject(hdc, old_brush);
            MS_SelectObject(hdc, old_pen);
            MS_DeleteObject(hbrush);
            MS_DeleteObject(hpen);
            hpen = NULL;
            }
        }
    else
        {
        int old_mode;
        hpen = AxWinGetPen(gc, hdc, &transparent);
        if ( hpen )
            old_pen = MS_SelectObject(hdc, hpen);
        else
            {
            DebugMessage(NXLT("XDrawLines: could not create pen! running low \
                                            on memory/resources!"));
            old_pen = MS_SelectObject(hdc, MS_GetStockObject(NULL_PEN));
            }

        if ( gc->values.function == GXxor )
            old_mode = MS_SetROP2(hdc, R2_NOT);

        if ( Running_Windows95 && (gc->values.fill_style == FillStippled ||
                            gc->values.fill_style == FillOpaqueStippled) )
            {
            /* since Win95 doesn't support patterned lines we use our
             * homegrown implementation.
             */
            if ( gc->values.fill_style == FillStippled )
                /* transparent fill. */
                DrawPatternedLine(hdc, gc, msPoints, npoints, TRUE);
            else
                DrawPatternedLine(hdc, gc, msPoints, npoints, FALSE);
            remove_region = TRUE;
            }
        else if ( transparent )
            {
            /* if we are here, we have a valid stipple in the GC. */
            retval = DrawTransparentPolyline(gc, hdc, gc->values.stipple,
                                                msPoints, npoints);
            }
        else
            {
            retval = MS_Polyline(hdc, msPoints, npoints);
            }

        if ( gc->values.function == GXxor )
            MS_SetROP2(hdc, old_mode);
        }

    /* cleanup */
    if ( hpen )
        {
        MS_SelectObject(hdc, old_pen);
        MS_DeleteObject(hpen);
        }
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    UnSelectPalette(hdc, old_palette);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        MS_RestoreDC(hdc, sHdc);
    free(msPoints);
    return retval;
}


void
XDrawPoint(Display *display, Drawable hObj, GC gc, int x, int y)
{
    int save_hdc;
    HDC hdc;
    BOOL delete_dc, remove_region = FALSE;
    COLORREF fore_color;
    HPALETTE old_palette;


    if ( !hObj )
        /* no drawable. don't draw */
        return;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        save_hdc = MS_SaveDC(hdc);   /* save DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XDrawPoint: bad clip mask type!"));
        }    
    
    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);

    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    MS_SetPixelV(hdc, x, y, fore_color);

    /* clean up */
    UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        MS_RestoreDC(hdc, save_hdc);
}


void
XDrawPoints(Display *display, Drawable hObj, GC gc, XPoint *points,
                                            int npoints, int mode)
{
    int ix, save_hdc;
    POINT *msPoints;
    HDC hdc;
    BOOL delete_dc, remove_region = FALSE;
    COLORREF fore_color;
    HPALETTE old_palette;


    if ( !hObj )
        /* no drawable. don't draw */
        return;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        save_hdc = MS_SaveDC(hdc); /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XDrawPoints: bad clip mask type!"));
        }       

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);

    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    
    msPoints = (POINT*)malloc( (npoints)*sizeof(POINT) );
    /* convert XPoints to POINTs */
    for ( ix=0; ix < npoints; ix++ )
        {
        msPoints[ix].x = points[ix].x;
        msPoints[ix].y = points[ix].y;
        }
    
    for ( ix=0; ix < npoints; ix++ )
        MS_SetPixelV(hdc, points[ix].x, points[ix].y, fore_color);

    /* clean up */
    UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        MS_RestoreDC(hdc, save_hdc);
    free(msPoints);
}



void
XDrawSegments(Display *display, Drawable hdc, GC gc,
                XSegment *segments, int nsegments)
{
    int ix;

    for ( ix=0; ix < nsegments; ix++ )
        {
        XDrawLine(display, hdc, gc, segments[ix].x1, segments[ix].y1,
                                    segments[ix].x2, segments[ix].y2);
        }
}


BOOL
XDrawText(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                                XTextItem *items, int nitems)
{
    int ix, sHdc, offset;
    HDC hdc;
    BOOL ret, delete_dc,
              remove_region = FALSE;
    POINT point[1];
    HFONT hFont, old_font;
    SIZE size;
    COLORREF fore_color;
    HPALETTE old_palette;

    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(hdc);   /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XDrawText: bad clip mask type."));
        }

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
        /* make sure we have the real white pixel. */
        fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
        }
    else
        fore_color = GET_COLOR_VALUE(gc->values.foreground);

    /* only draw foreground text color, ignore background */
    MS_SetBkMode(hdc, TRANSPARENT);
    MS_SetTextColor(hdc, fore_color);
    MS_SetTextAlign(hdc, TA_LEFT | TA_BASELINE);

    /* use specified font (from GC) */
    hFont = gc->values.font;
    if ( !hFont )
        {
        if ( AxDlgMainFont->fid )
            hFont = AxDlgMainFont->fid;
        else
            DebugMessage("XDrawText: no font!");
        }
    old_font = MS_SelectObject(hdc, hFont);

    /* Windows will use the given coordinates as "logical points", *
     * which are GDI coordinates (not pixels), so we must convert. */
    point[0].x = x;
    point[0].y = y;
    MS_LPtoDP(hdc, point, 1);
    
    offset = 0;
    for ( ix=0; ix < nitems; ix++ )
        { 
        ret = MS_TextOut(hdc, point[0].x + offset, point[0].y,
                            items[ix].chars, items[ix].nchars);
        if ( !ret )
            return ret;    /* error */

        /* compute length of last printed string so that the *
         * next string can be drawn at the correct location. */
        MS_GetTextExtentPoint32(hdc, items[ix].chars, items[ix].nchars, &size);
        offset += size.cx;
        //offset += MeasureWinText(items[ix].chars, items[ix].nchars, hFont);
        }

    /* cleanup */
    UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        {
        MS_RestoreDC(hdc, sHdc);
        MS_SelectObject(hdc, old_font);
        }
    return ret;        
} 


BOOL
XDrawText16(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                                XTextItem16 *items, int nitems)
{
    int ix, sHdc, offset;
    HDC hdc;
    BOOL ret, delete_dc, remove_region = FALSE;
    POINT point[1];
    char buf[1];
    HFONT hFont, old_font;
    SIZE size;
    COLORREF fore_color;
    HPALETTE old_palette;

    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    hdc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(hdc);   /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(hdc, (HRGN)gc->values.clip_mask);
            }       
        else
            DebugMessage(NXLT("XDrawText16: bad clip mask type."));
        }

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
        /* make sure we have the real white pixel. */
        fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
        }
    else
        fore_color = GET_COLOR_VALUE(gc->values.foreground);

    /* only draw foreground text color, ignore background */
    MS_SetBkMode(hdc, TRANSPARENT);
    MS_SetTextColor(hdc, fore_color);  
    MS_SetTextAlign(hdc, TA_LEFT | TA_BASELINE);

    /* use specified font (from GC) */
    hFont = gc->values.font;
    if ( !hFont )
        {
        if ( AxDlgMainFont->fid )
            hFont = AxDlgMainFont->fid;
        else
            DebugMessage("XDrawText16: no font!");
        }
    old_font = MS_SelectObject(hdc, hFont);

    /* Windows will use the given coordinates as "logical points", *
     * which are GDI coordinates (not pixels), so we must convert. */
    point[0].x = x;
    point[0].y = y;
    MS_LPtoDP(hdc, point, 1);

    offset = 0;
    for ( ix=0; ix < nitems; ix++ )
        {
        sprintf(buf, "%c", items[ix].chars->byte2);
        ret = MS_TextOut(hdc, point[0].x + offset, point[0].y,
                                        buf, items[ix].nchars);
        if ( !ret )
            return ret;    /* error */

        /* compute length of last printed string so that the *
         * next string can be drawn at the correct location. */
        MS_GetTextExtentPoint32(hdc, buf, items[ix].nchars, &size);
        offset += size.cx;
        //offset += MeasureWinText( buf, items[ix].nchars, hFont ); 
        }

    /* cleanup */
    UnSelectPalette(hdc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(hdc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, hdc);
    else
        {    
        MS_RestoreDC(hdc, sHdc);
        MS_SelectObject(hdc, old_font);
        }
    return ret;        
} 


BOOL
XDrawArc(Display *display, HGDIOBJ hObj, GC gc, int x, int y,
                    unsigned int width, unsigned int height,
                    int angle1, int angle2)
{
    int sHdc, old_mode;
    BOOL ret, delete_dc, remove_region = FALSE, not_used;
    HDC draw_dc;
    HBRUSH hbrush, old_brush;
    HPEN hpen, old_pen;
    HPALETTE old_palette;


    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    draw_dc = InsureDrawable(hObj, &delete_dc);
    if ( !delete_dc )
        {
        /* we were passed an HDC, so just use that to draw on */
        sHdc = MS_SaveDC(draw_dc);   /* save this DC so that it can be restored */
        }

    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HRGN, select it into an HDC, and use that DC to draw on. */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn(draw_dc, (HRGN)gc->values.clip_mask);
            }
        else
            DebugMessage(NXLT("XDrawArc: bad clip mask type."));
        }

    /* Select the palette into the device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(draw_dc);
    MS_SetBkMode(draw_dc, TRANSPARENT);

    /* set brush */
    hbrush    = MS_GetStockObject(NULL_BRUSH);
    old_brush = MS_SelectObject(draw_dc, hbrush);
    /* set drawing pen */
    hpen = AxWinGetPen(gc, draw_dc, &not_used);
    old_pen = MS_SelectObject(draw_dc, hpen);

    if ( gc->values.function == GXxor || gc->values.function == GXinvert )
        old_mode = MS_SetROP2(draw_dc, R2_NOT);

    ret = MS_Arc(draw_dc, x, y, width, height, 0, 0, 0, 0);

    if ( gc->values.function == GXxor || gc->values.function == GXinvert )
        MS_SetROP2(draw_dc, old_mode);

    /* clean up */
    UnSelectPalette(draw_dc, old_palette);
    if ( remove_region )
        MS_SelectClipRgn(draw_dc, (HRGN)NULL);
    if ( delete_dc )
        RemoveDrawable(hObj, draw_dc);
    else
        {
        MS_RestoreDC(draw_dc, sHdc);
        MS_SelectObject(draw_dc, old_brush);
        MS_SelectObject(draw_dc, old_pen);
        }
    MS_DeleteObject(hpen);
    return ret;
}




BOOL
XFillArc(Display *display, Drawable hObj, GC gc, int x, int y,
                    unsigned int width, unsigned int height,
                    int angle1, int angle2)
{
    int sHdc, s_draw_dc, old_mode;
    int clip_x, clip_y;
    int start_angle, sweep_angle;
    int x_start_radial, y_start_radial, x_end_radial, y_end_radial;
    BOOL ret, delete_fill_dc, delete_draw_dc, remove_fill_dc,
         bMask = FALSE,
         bTransparent = FALSE,
         delete_fill_hbm = FALSE,
         delete_mem_objs = FALSE,
         remove_region = FALSE,
         use_pen = FALSE;
    HDC     fill_hdc, mem_hdc, draw_dc, pass_dc;
    HPEN    old_pen, hpen;
    HBRUSH  old_brush, hbrush, fill_brush;
    HBITMAP hbm, fill_hbm, mem_hbm, old_fill_hbm, pattern;
    BITMAP bm;
    DWORD fg_rop_code, bg_rop_code;
    COLORREF fore_color, back_color;
    HPALETTE old_palette, old_draw_palette;
    BOOL do_manual_pattern_fill = FALSE;
    POINT arc_points[3];

    if ( !hObj )
        /* no drawable. don't draw */
        return FALSE;

    hbrush = NULL;
    sHdc = s_draw_dc = old_mode = 0;
    delete_fill_dc = delete_draw_dc = remove_fill_dc = FALSE;
    fill_hdc = mem_hdc = draw_dc = (HDC)NULL;
    pass_dc = hObj;     /* hdc we will pass to routines below this */
    if ( gc->values.clip_mask )
        {
        /* we have a clip mask. check its type. if it is a windows  *
         * HBITMAP, we create a memory DC which we will use to draw *
         * the polygon on. we set a flag (bMask) to true, so that   *
         * we can later blt the memory DC thru the mask and onto    *
         * the screen.                                              */
        if ( gc->clip_mask_is_hregion )
            {
            /* clip mask type is a Windows HRGN. select the region into *
             * the DC that was passed in, and draw with that.           */
            /* check the drawable type */
            fill_hdc = InsureDrawable(hObj, &remove_fill_dc);
            if ( !remove_fill_dc )
                {
                /* we were passed an HDC, so just use that to draw on */
                sHdc = MS_SaveDC(fill_hdc); /* save DC so it can be restored */
                }
            /* the passed object is a bitmap which is selected by */
            /* InsureDrawable into an HDC, use that HDC for any routines */
            /* called from here to avoid trying to select the bitmap     */
            /* into another HDC below this                               */
            pass_dc = fill_hdc;

            remove_region = TRUE;
            /* set clipping region specified in the clip mask */
            MS_SelectClipRgn( fill_hdc, (HRGN)gc->values.clip_mask );
            }
        else
            {
            /*** clip mask better be a bitmap handle! ***/
            hbm = gc->values.clip_mask;
            MS_GetObject(hbm, sizeof(BITMAP), (LPSTR)&bm);

            /* check to see what type of "drawable" we were passed. */
            draw_dc = InsureDrawable(hObj, &delete_draw_dc);
            if ( !delete_draw_dc )
                {
                /* save non-memory DC so it can be restored */
                s_draw_dc = MS_SaveDC(draw_dc);
                }
            /* the passed object is a bitmap which is selected by */
            /* InsureDrawable into an HDC, use that HDC for any routines */
            /* called from here to avoid trying to select the bitmap     */
            /* into another HDC below this                               */
            pass_dc = draw_dc;

            fill_hdc = MS_CreateCompatibleDC((HDC)NULL);
            fill_hbm = MS_CreateCompatibleBitmap(RootWin,
                                    bm.bmWidth, bm.bmHeight);
            old_fill_hbm = MS_SelectObject(fill_hdc, fill_hbm);
            MS_BitBlt(fill_hdc, 0, 0, bm.bmWidth, bm.bmHeight,
                                   (HDC)0, 0, 0, BLACKNESS);

            bMask = TRUE;
            delete_fill_dc = TRUE;
            delete_fill_hbm = TRUE;
            }
        }
    else
        {
        /* no clip mask was specified. check to see what type *
         * of "drawable" we were passed.                      */
        fill_hdc = InsureDrawable(hObj, &remove_fill_dc);
        if ( !remove_fill_dc )
            {
            /* we were passed an HDC, so just use that to draw on */
            sHdc = MS_SaveDC(fill_hdc); /* save DC so it can be restored */
            }
        /* the passed object is a bitmap which is selected by */
        /* InsureDrawable into an HDC, use that HDC for any routines */
        /* called from here to avoid trying to select the bitmap     */
        /* into another HDC below this                               */
        pass_dc = fill_hdc;
        }

    /* Select the palette into the window device context and
     * make the Palette Manager map the logical palette to the
     * system palette (realize it).
     */
    old_palette = SelectAndRealizeAxWinPalette(fill_hdc);
 
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        gc->values.foreground = REAL_WHITE_PIXEL;
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        gc->values.background = REAL_WHITE_PIXEL;
    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    back_color = GET_COLOR_VALUE(gc->values.background);

    if ( gc->values.fill_style != FillSolid &&
          gc->values.fill_style != FillTiled )
        {
        /* fill style is Stipple, so make sure we have a stipple map */
        if ( gc->values.stipple )
            {
            /* use specified stipple pattern to fill polygon. *
             * Pattern brushes use text fore and back-ground  *
             * colors to paint with.  (only use stipples with *
             * appropriate fill styles).                      */
            if ( Running_Windows95 )
                {
                do_manual_pattern_fill = TRUE;
                pattern = gc->values.stipple;
                }
            else if ( gc->values.fill_style == FillStippled )
                {
                /* background remains untouched (transparent) */
                hbrush = MS_CreatePatternBrush(gc->values.stipple);
                mem_hdc = MS_CreateCompatibleDC((HDC)NULL);
                mem_hbm = MS_CreateCompatibleBitmap(RootWin, width, height);
                MS_SelectObject(mem_hdc, mem_hbm);
                bTransparent = TRUE;
                delete_mem_objs = TRUE;
                }
            else if ( gc->values.fill_style == FillOpaqueStippled )
                {
                hbrush = MS_CreatePatternBrush(gc->values.stipple);
                MS_SetBkColor(fill_hdc, fore_color);
                MS_SetTextColor(fill_hdc, back_color);
                }
            }
        else
            DebugMessage(NXLT("XFillArc: Stipple Fill requested without a stipple map!"));
        }

    else if ( gc->values.fill_style == FillTiled )
        {
        /* fill style is Tile, so make sure we have a tile */
        if ( gc->values.tile )
            {
            if ( Running_Windows95 )
                {
                pattern = gc->values.tile;
                do_manual_pattern_fill = TRUE;
                }
            else
                {
                hbrush = MS_CreatePatternBrush(gc->values.tile);
                MS_SetBkColor(fill_hdc, fore_color);
                MS_SetTextColor(fill_hdc, back_color);
                }
            }
        else
            DebugMessage(NXLT("XFillArc: Tile Fill requested without a tile!"));
        }

    else if ( gc->values.fill_style == FillSolid )
        {
        /* use a solid color brush */ 
        if ( gc->values.function == GXxor )
            old_mode = MS_SetROP2(fill_hdc, R2_NOT);
        hbrush = MS_CreateSolidBrush(fore_color);
        }

    /* this is a fill routine, so don't use a pen (no line is drawn) */
    hpen = (HPEN) MS_GetStockObject(NULL_PEN);
    old_pen = MS_SelectObject(fill_hdc, hpen);

    /* compute radial lines for the Windows arc-ing function */
    start_angle = angle1/64;
    sweep_angle = angle2/64;

    GetRadialPoints(x, y, width, height, start_angle,
                    &x_start_radial, &y_start_radial);

    GetRadialPoints(x, y, width, height, sweep_angle,
                        &x_end_radial, &y_end_radial);

    if ( do_manual_pattern_fill || bTransparent )
        {
        /* fill a points array with bounding rect begin point, and 
         * each of the radial points needed for the Arc function.
         */
        arc_points[0].x = x;
        arc_points[0].y = y;
        arc_points[1].x = x_start_radial;
        arc_points[1].y = y_start_radial;
        arc_points[2].x = x_end_radial;
        arc_points[2].y = y_end_radial;
        }

    if ( do_manual_pattern_fill )
        {
        /*** This should only be true on Windows 95 ***/
        if ( gc->values.fill_style == FillStippled )
            {
            AxXFillTransparentPoly(fill_hdc, pattern, arc_points, 3, x, y,
                            width, height, fore_color, back_color, TRUE);
            }
        else
            {
            DrawPatternFill(fill_hdc,pattern, arc_points,3, width,height,
                            x, y, fore_color, back_color, FALSE, TRUE);
            }
        }
    else if ( bTransparent )
        {
        /* need to draw a transparent arc */
        ret = DrawTransparentFill(gc, fill_hdc, mem_hdc, hbrush,
                                    arc_points, 3, width, height,
                                    FILL_TRANS_ARC, bMask, pass_dc);
        }
    else if ( hbrush )
        {
        old_brush = MS_SelectObject(fill_hdc, hbrush);
        /* use the Windows Pie function to draw a filled arc, because *
         * the Windows function Arc does not do a fill.               */
        ret = MS_Pie(fill_hdc, x, y, x+width, y+height,
                        x_start_radial, y_start_radial,
                        x_end_radial, y_end_radial);
        MS_SelectObject(fill_hdc, old_brush);
        if ( old_mode )
            MS_SetROP2(fill_hdc, old_mode);
        }


    if ( bMask && !bTransparent )
        {
        HBRUSH old_fill_brush;
        old_draw_palette = SelectAndRealizeAxWinPalette(draw_dc);

        clip_x = gc->values.clip_x_origin;
        clip_y = gc->values.clip_y_origin;
        if ( Running_WindowsNT )
            {
            old_brush = MS_SelectObject(draw_dc, hbrush);
            fill_brush = MS_GetStockObject(WHITE_BRUSH);

            MS_SetBkColor(draw_dc, fore_color);
            MS_SetTextColor(draw_dc, back_color);

            old_fill_brush = MS_SelectObject(fill_hdc, fill_brush);
            /* use the Windows Pie function to draw a filled arc, because *
             * the Windows function Arc does not do a fill.               */    
            ret = MS_Pie(fill_hdc, x, y, x + width, y + height,
                            x_start_radial, y_start_radial,
                            x_end_radial, y_end_radial);
            MS_SelectObject(fill_hdc, old_fill_brush);

            fg_rop_code = 0x00E20746;
            bg_rop_code = 0x00AA0029;
            AxWinMaskBlt(draw_dc, clip_x, clip_y, width, height,
                                    fill_hdc, 0, 0, hbm, 0, 0,
                                    fg_rop_code, bg_rop_code);
            MS_SelectObject(draw_dc, old_brush);
            }
        else    /* Running Windows 95 */
            {
            DWORD rop_code;
            HDC mask_dc;
            HBITMAP old_hbm;
            COLORREF old_bk_color, old_text_color;
            int xpos = x + clip_x;
            int ypos = y + clip_y;
            int mask_x=0;// = x + gc->values.clip_x_origin;
            int mask_y=0;// = y + gc->values.clip_y_origin;

            mask_dc = MS_CreateCompatibleDC(draw_dc);
            old_hbm = MS_SelectObject(mask_dc, hbm);

            /* "True Mask Method" of doing transparency. */
            MS_BitBlt(draw_dc, clip_x,clip_y, width,height, fill_hdc, 0,0, SRCINVERT);

            old_bk_color = MS_SetBkColor(draw_dc, PALETTERGB(255,255,255));
            old_text_color = MS_SetTextColor(draw_dc, PALETTERGB(0,0,0));
            rop_code = SRCAND; //0x220326;   /* not source and destination */
            MS_BitBlt(draw_dc, clip_x, clip_y, width, height, mask_dc,mask_x,mask_y, rop_code);
            MS_SetBkColor(draw_dc, old_bk_color);
            MS_SetTextColor(draw_dc, old_text_color);

            MS_BitBlt(draw_dc, clip_x,clip_y, width,height, fill_hdc, 0,0, SRCINVERT);
            MS_SelectObject(mask_dc, old_hbm);
            MS_DeleteDC(mask_dc);
            }
        /* cleanup */
        UnSelectPalette(draw_dc, old_draw_palette);
        }


    /* cleanup */
    UnSelectPalette(fill_hdc, old_palette);
    MS_SelectObject(fill_hdc, old_pen);
    if ( remove_region )
        MS_SelectClipRgn(fill_hdc, (HRGN)NULL);

    if ( delete_mem_objs )
        {
        MS_DeleteDC(mem_hdc);
        MS_DeleteObject(mem_hbm);
        }

    if ( delete_fill_hbm )
        {
        MS_SelectObject(fill_hdc, old_fill_hbm);
        MS_DeleteObject(fill_hbm);
        }

    if ( remove_fill_dc )
        RemoveDrawable(hObj, fill_hdc);
    else if ( delete_fill_dc )
        MS_DeleteDC(fill_hdc);
    else
        MS_RestoreDC(fill_hdc, sHdc);

    if ( delete_draw_dc )
        RemoveDrawable(hObj, draw_dc);
    else if ( s_draw_dc != 0 )
        MS_RestoreDC(draw_dc, s_draw_dc);

    if ( hbrush )
        MS_DeleteObject(hbrush);
    return ret;
}



XImage *
XSubImage(XImage *ximage, int x, int y, unsigned int subimage_width,
                                        unsigned int subimage_height)
{
    int i, j, last_x, last_y;
    int byte_width, new_image_size;
    unsigned long image_bit;
    unsigned char *new_image_data;
    XImage *new_image;


    /* set up new image */
    if ( ximage->depth == 1 )
        byte_width = (subimage_width + 7) / 8;
    else
        byte_width = subimage_width + subimage_width % 2;

    new_image_size = byte_width * subimage_height;
    new_image_data = (char*)malloc(new_image_size * sizeof(char));
    new_image = XCreateImage((Display*)NULL, (Visual*)NULL,
                                ximage->depth, ximage->format,
                                ximage->xoffset, new_image_data,
                                subimage_width, subimage_height,
                                ximage->bitmap_pad, ximage->bytes_per_line);

    /* get the subimage bits from the original image bits */
    last_x = x + subimage_width - 1;
    last_y = y + subimage_height - 1;
    for ( i=0; i < ximage->height; i++ )
        {
        for ( j=0; j < ximage->width; j++ )
            {  
            if ( (j >= x || j <= last_x) &&
                (i >= y || i <= last_y) )
                {
                image_bit = XGetPixel(ximage, j, i);
                XPutPixel(new_image, j, i, image_bit);
                }
            }
        }

    /* ? fill out the new image struct with Windows bitmap stuff. ? */
    return new_image;
}


int
XLookupString(XKeyEvent *event, char *buffer, int num_bytes,
                    KeySym *keysym, XComposeStatus *status)
/* char           *buffer;    buffer_return *
 * int            num_bytes;  bytes_buffer  *
 * KeySym         *keysym;    keysym_return *
 * XComposeStatus *status;    status_in_out */
{
    unsigned int key;


    key = event->keycode;
    if ( key >= 'a' && key <= 'z' )
        {
        if ( keysym )
            *keysym = key - ' ';
        }
    else if ( key >= 1 && key <= 31 )
        {
        if ( keysym )
            *keysym = key + 'A' - 1;
        }
    else
        {
        if ( keysym )
            *keysym = key;
        }

    if ( key & KEY_TYPE_MASK )    /* non-character */
        {
#if 0					/* Obsolete - see 4447475 */
        /* this is a key which has already been through the encoding in */
        /* WinToXEvent.  return the real key code    */
        *buffer = key & ~KEY_TYPE_MASK;
        *(buffer+1) = 0;
        return( 1 );
#else
        return( 0 );
#endif
        }
    else
        {
        *buffer = (char)key;
        num_bytes = strlen(buffer);
        return num_bytes;
        }
}

void
XMoveWindow(Display *display, Window hdc, int x, int y)
{
    HWND hwnd;
    if ( !hdc )
        return;
    hwnd = AxGetHWNDfromDrawable(hdc);
    MS_MoveWindow(hwnd, x, y, 0, 0, FALSE);
}

void
XMoveResizeWindow(Display *display, Window hdc, int x, int y,
                    unsigned int width, unsigned int height)
{
    HWND hwnd;
    if ( !hdc )
        return;
    hwnd = AxGetHWNDfromDrawable(hdc);
    MS_MoveWindow(hwnd, x, y, width, height, FALSE);
}


long
XMaxRequestSize(Display *display)
{
    /* return minimum size.  do we need this for Windows? */
    return 16384;
} 

void
XNextEvent(Display *display, XEvent *report)
{
    MS_GetMessage(&report->msg, (HWND)NULL, (UINT)0, (UINT)0);
}

void
XPeekEvent(Display *display, XEvent *report)
{
    MS_PeekMessage(&report->msg, (HWND)NULL, (UINT)0, (UINT)0, PM_NOREMOVE);
}



BOOL
XQueryPointer(Display *display, Window hdc, Window *root_return,
    Window *child_return, int *root_x_return, int *root_y_return,
    int *win_x_return, int *win_y_return, unsigned int *mask_return)
{
    POINT cursor_pos;
    HWND hwnd;

    /* set the things we currently don't handle to null values */
    *child_return = (HDC)NULL;
    *root_return = (HDC)NULL;
    *mask_return = 0;

    *root_x_return = 0;
    *root_y_return = 0;
    *win_x_return = 0;
    *win_y_return = 0;

    if ( !MS_GetCursorPos(&cursor_pos) )
        return FALSE;
    
    *root_x_return = cursor_pos.x;
    *root_y_return = cursor_pos.y;

    /* now map the screen coordinates to the client window coordinates */
    hwnd = AxGetHWNDfromDrawable(hdc);
    if ( hwnd == (HWND)NULL )
		{
		DebugMessage( "XQueryPointer - could not find window from hdc" );
		return FALSE;
		}
 
    if ( !MS_ScreenToClient( hwnd, &cursor_pos ) )
		{
		DebugMessage( "XQueryPointer - ScreenToClient fails" );
		return FALSE;
		}

    *win_x_return = cursor_pos.x;
    *win_y_return = cursor_pos.y;
	return TRUE;
}



void
XSetDashes(Display *display,GC gc,int dash_offset,const char dash_list[],int n)
{
    int ix;

    if ( n > 10 )
		{
        /* we have created a dash list array of size 10 in the GC, for now */
        DebugMessage(NXLT("XSetDashes: dash list too big"));
		return;
		}

    for ( ix=0; ix < n; ix++ )
        gc->values.dashes[ix] = (DWORD)dash_list[ix];

    gc->values.dash_offset    = dash_offset;
    gc->values.dash_list_size = n;
}

void
XSetGraphicsExposures(Display *display, GC gc, int graphics_exposures)
{
    gc->values.graphics_exposures = graphics_exposures;
}


int
XTextWidth(XFontStruct *font_struct, const char *string, int count)
{
    int width, ix;
    XCharStruct *cs;
    
    if (font_struct->fid)
        {
        /* a real screenfont resource; we can call the api */
        width = MeasureWinText((char*)string, count, font_struct->fid);
        }
    else
        {
        /* no actual screenfont resource; sum widths directly */
        for (ix = 0, width = 0; ix < count; ix++)
            {
            cs = getCharStruct((int)((unsigned char) string[ix]), font_struct);
            width += cs->width;
            }       
        }
    return width;
}


#if 0
/*** not used at the moment. ***/
void
XTextExtents(XFontStruct *fontP, char *string, int nchars, int *direction,
                        int *ascent, int *descent, XCharStruct *overall)
{
    int ix;
    short overall_width;
    short lbearing_ix, rbearing_ix;
    short smallest_lbearing, largest_rbearing;
    HDC hdc;
    HFONT old_font;
    SIZE size;
    XCharStruct *xcharP;


    hdc = MS_GetDC(NULL);
    old_font = MS_SelectObject(hdc, fontP->fid);

    *direction = 0;    /* do we need to fill this out? */
    *ascent = fontP->ascent;
    *descent = fontP->descent;

    xcharP = getCharStruct((int)((unsigned char) string[0]), fontP);
    smallest_lbearing = xcharP->lbearing;
    largest_rbearing = xcharP->rbearing;
    lbearing_ix = 0;
    rbearing_ix = 0;
    overall_width = xcharP->width;
    for ( ix=1; ix < nchars; ix++ )
        {
        xcharP = getCharStruct((int)((unsigned char) string[ix]), fontP);
        if ( xcharP->lbearing < smallest_lbearing )
            {
            smallest_lbearing = xcharP->lbearing;
            lbearing_ix = ix;
            }
        if ( xcharP->rbearing > largest_rbearing )
            {
            largest_rbearing = xcharP->rbearing;
            rbearing_ix = ix;
            }
        overall_width += xcharP->width;
        }
    MS_GetTextExtentPoint32(hdc, string, lbearing_ix, &size);
    overall->lbearing = smallest_lbearing + size.cx;
    MS_GetTextExtentPoint32(hdc, string, rbearing_ix, &size);
    overall->rbearing = largest_rbearing + size.cx;
    overall->width = overall_width;

    /* cleanup */
    MS_SelectObject(hdc, old_font);
    MS_ReleaseDC(NULL, hdc);
}
#endif



/**************************************************************************/
/* If XTranslateCoordinates is being called with a gadget window (that is,
 * a window that isn't on the global WindowList) then AxWinTranslateCoordinates
 * should be used instead. The Windows call to translate between 2 arbitrary
 * windows expects a window handle (HWND) rather than a device context (HDC),
 * which is what the X version is being passed. So here we search the
 * global WindowList and use the corresponding window handle(s) to perform
 * the translation. Either check the return on XTranslateCoordinates and call
 * the Windows version as a backup, or simply call the Windows version
 * when on NT.            -donato
 */
BOOL
XTranslateCoordinates(Display *display, HDC src_w, HDC dest_w, int src_x,
                        int src_y, int *new_x, int *new_y, Window *child)
/* int     *new_x;    return *
 * int     *new_y;    return *
 * Window  *child;    return */
{
    int translated;
    HWND src_hwnd, dst_hwnd;
    POINT screen_point, client_point;

    *new_x = 0;
    *new_y = 0;
    translated = FALSE;
    if ( dest_w == RootWin )
        {    /* do a ClientToScreen */
        src_hwnd = AxGetHWNDfromDrawable(src_w);
        if ( src_hwnd )
            {
            screen_point.x = src_x;
            screen_point.y = src_y;
            MS_ClientToScreen(src_hwnd, &screen_point);
            *new_x = screen_point.x;
            *new_y = screen_point.y;
            translated = TRUE;
            }
        }
    else if ( src_w == RootWin )
        {    /* do a ScreenToClient */
        dst_hwnd = AxGetHWNDfromDrawable(dest_w);
        if ( dst_hwnd )
            {
            client_point.x = src_x;
            client_point.y = src_y;
            MS_ScreenToClient(dst_hwnd, &client_point);
            *new_x = client_point.x;
            *new_y = client_point.y;
            translated = TRUE;
            }
        }
    else
        {
        src_hwnd = AxGetHWNDfromDrawable(src_w);
        dst_hwnd = AxGetHWNDfromDrawable(dest_w);
        if ( src_hwnd && dst_hwnd )
            {
            AxWinTranslateCoordinates(src_hwnd, dst_hwnd, src_x, src_y,
                                                        new_x, new_y);
            translated = TRUE;
            }
        }

    *child = NULL;
    if ( !translated )
        return FALSE;
    else
        return TRUE;
}
/* Windows only version of XTranslateCoordinates (see above) */
void
AxWinTranslateCoordinates(HWND src_hwnd, HWND dst_hwnd, int src_x, int src_y,
                                                    int *new_x, int *new_y)
{
    POINT point;

    point.x = src_x;
    point.y = src_y;
    MS_MapWindowPoints(src_hwnd, dst_hwnd, &point, 1);
    *new_x = point.x;
    *new_y = point.y;
}
/***********************************************************************/



void
XWarpPointer(Display *display, Window src_w, Window dest_w, int src_x,
                        int src_y, unsigned int src_width,
                        unsigned int src_height, int dest_x, int dest_y)
{
    POINT point, curPoint, screen_point;
    HWND  hwnd;


    MS_GetCursorPos(&curPoint);
    if ( dest_w )
        {
        hwnd = MS_GetActiveWindow();
        screen_point.x = dest_x;
        screen_point.y = dest_y;
        MS_ClientToScreen(hwnd, &screen_point);
        MS_SetCursorPos(screen_point.x, screen_point.y);
        }
    else if ( dest_w == None )
        {
        /* move mouse pos relative to current pos */
        MS_GetCursorPos(&point);
        MS_SetCursorPos(point.x + dest_x, point.y + dest_y);
        }
    else if ( src_w == None )
        {
        /* not relative to current pos, use global coordinates */
        MS_SetCursorPos(dest_x, dest_y);
        }
    else if ( src_w )
        {
        /* move cursor only if in specified rectangle */
        if ( (curPoint.x > src_x || curPoint.x < (int)(src_x + src_width)) &&
             (curPoint.y > src_y || curPoint.y < (int)(src_y + src_height)) )
            {
            point.x = dest_x;
            point.y = dest_y;
            hwnd = MS_GetActiveWindow();
            MS_ScreenToClient(hwnd, &point);
            MS_SetCursorPos(abs(point.x) + (dest_x*2),
                            abs(point.y) + (dest_y*2));
            }
        }
    return;
}


void
XFreeGC(Display *display, GC gc)
{
    /* we check if the already existing resource is greater than one, *
     * because an already free'd resource will have a value of 1.     */
    if ( (int)gc->values.clip_mask > 1 )
        AxWinDestroyGCmask(gc->values.clip_mask);

    if ( (int)gc->values.tile > 1 )
        MS_DeleteObject(gc->values.tile);
    if ( (int)gc->values.stipple > 1 )
        MS_DeleteObject(gc->values.stipple);
#if 0
    *** font handles are global as far as I know - jon
    if ( (int)gc->values.font > 1 )
        MS_DeleteObject(gc->values.font);
#endif

    TrueFree((char*)gc);
    return;
}

GC
DefaultGC(Display *display, Drawable drawable)
{
    GC new_gc;

    new_gc = XCreateGC(display, drawable, (unsigned long)0, (XGCValues *)NULL);
    return(new_gc);
}

void
XCopyGC(Display *display, GC src, unsigned long valuemask, GC dest)
{
    if ( !src )
        return;

    if ( valuemask & GCFunction )
        dest->values.function = src->values.function;       
    if ( valuemask & GCPlaneMask )
        dest->values.plane_mask = src->values.plane_mask;
    if ( valuemask & GCForeground)
        dest->values.foreground = src->values.foreground;
    if ( valuemask & GCBackground )
        dest->values.background = src->values.background;
    if ( valuemask & GCLineWidth )
        dest->values.line_width = src->values.line_width;
    if ( valuemask & GCLineStyle )
        dest->values.line_style = src->values.line_style;
    if ( valuemask & GCCapStyle )
        dest->values.cap_style = src->values.cap_style;
    if ( valuemask & GCJoinStyle )
        dest->values.join_style = src->values.join_style;
    if ( valuemask & GCFillStyle )
        dest->values.fill_style = src->values.fill_style;
    if ( valuemask & GCFillRule )
        dest->values.fill_rule = src->values.fill_rule;
    if ( valuemask & GCTile )
        dest->values.tile = src->values.tile;
    if ( valuemask & GCStipple )
        dest->values.stipple = src->values.stipple;
    if ( valuemask & GCTileStipXOrigin )
        dest->values.ts_x_origin = src->values.ts_x_origin;
    if ( valuemask & GCTileStipYOrigin )
        dest->values.ts_y_origin = src->values.ts_y_origin;
    if ( valuemask & GCTileStipXOrigin )
        dest->values.ts_x_origin = src->values.ts_x_origin;
    if ( valuemask & GCFont  )
        dest->values.font = src->values.font;
    if ( valuemask & GCSubwindowMode  )
        dest->values.subwindow_mode = src->values.subwindow_mode;
    if ( valuemask & GCGraphicsExposures  )
        dest->values.graphics_exposures = src->values.graphics_exposures;
    if ( valuemask & GCClipXOrigin  )
        dest->values.clip_x_origin = src->values.clip_x_origin;
    if ( valuemask & GCClipYOrigin  )
        dest->values.clip_y_origin = src->values.clip_y_origin;
    if ( valuemask & GCClipMask  )
        {
        dest->values.clip_mask = src->values.clip_mask;
        dest->clip_mask_is_hregion = src->clip_mask_is_hregion;
        }
    if ( valuemask & GCDashOffset  )
        dest->values.dash_offset = src->values.dash_offset;
    if ( valuemask & GCDashList  )
        {
        XSetDashes(NULL,dest,src->values.dash_offset,(char*)src->values.dashes,
                                            src->values.dash_list_size);
        }
    if ( valuemask & GCArcMode  )
        dest->values.arc_mode = src->values.arc_mode;
    return;
}

BOOL
XGetGCValues(Display *display, GC gc, unsigned long valuemask,
                                    XGCValues *values_return)
{
    *values_return = gc->values;    /* for now! */
    return TRUE;
}


int
XIconifyWindow(Display *display, Window w, int screen_number)
{
    HWND hwnd;
    int retval;

    hwnd = AxGetHWNDfromDrawable(w);
    if ( hwnd )
        retval = MS_ShowWindow(hwnd, SW_SHOWMINIMIZED);
    else
        retval = 0;
    return retval;
}


void
XMapWindow(Display *display, Window win)
{
    HWND hwnd;
    if ( !win )
        return;
    hwnd = AxGetHWNDfromDrawable(win);
    MS_ShowWindow(hwnd, SW_SHOWDEFAULT);
}

/* Unmap (i.e. hide) window, but do not destroy it */
void
XUnmapWindow(Display *display, Window win)
{
    HWND hwnd;
    if ( !win )
        return;
    hwnd = AxGetHWNDfromDrawable(win);
    MS_ShowWindow(hwnd, SW_HIDE);
}

void
XResizeWindow(Display *display, Window win, unsigned int width,
                                            unsigned int height)
{
    HWND hwnd;
    if ( win == (HDC)NULL )
        return;
    hwnd = AxGetHWNDfromDrawable(win);
    /* resize window, but do not move it */
    MS_SetWindowPos(hwnd, 0, 0, 0, width, height, SWP_NOMOVE);
}


void
XRestackWindows(Display *display, Window wins[], int num_wins)
{
    /* X would stack tho 0th on top, the 1st next, etc. */
    /* Simulate by stacking each window to the top in reverse */
#if 0
    int ii;
    RECT rc;
    LPRECT lprc;

    lprc = &rc;
    for (ii=num_wins; ii>0; --ii)
    {
        SetWindowPos(wins[ii], (HWND TOP), 0,0,0,0,SWP NOMOVE|SWP NORESIZE);
    }
#endif
    return;
}


void
XOffsetRegion(Region region, int dx, int dy)
{
    int ret;
    region->xoffset = dx;
    region->yoffset = dy;
    ret = MS_OffsetRgn(region->region_handle, dx, dy);
    if ( ret == ERROR )
        DebugMessage(NXLT("XOffsetRegion: error in offset!"));
}

void
XIntersectRegion(Region src_region1, Region src_region2, Region dest_region)
{
    int ret;
    ret = MS_CombineRgn(dest_region->region_handle,
                        src_region1->region_handle,
                        src_region2->region_handle, RGN_AND);
    if ( ret == ERROR )
        DebugMessage(NXLT("XIntersectRegion: could not intersect regions!"));
}

void
XSubtractRegion(Region src_region1, Region src_region2, Region dest_region)
{
    int ret;
    ret = MS_CombineRgn(dest_region->region_handle,
                        src_region1->region_handle,
                        src_region2->region_handle, RGN_DIFF);
    if ( ret == ERROR )
        DebugMessage(NXLT("XSubtractRegion: could not subtract regions!"));
}

void
XUnionRegion(Region src_region1, Region src_region2, Region dest_region)
{
    int ret;
    ret = MS_CombineRgn(dest_region->region_handle,
                        src_region1->region_handle,
                        src_region2->region_handle, RGN_OR);
    if ( ret == ERROR )
        DebugMessage(NXLT("XUnionRegion: could not combine regions!"));
}

void
XUnionRectWithRegion(XRectangle *rectangle, Region src_region,
                                            Region dest_region)
{
    int ret;
    HRGN rect_hregion;
    
    rect_hregion = MS_CreateRectRgn((int)rectangle->x, (int)rectangle->y,
                                    (int)(rectangle->x + rectangle->width),
                                    (int)(rectangle->y + rectangle->height));
    ret = MS_CombineRgn(dest_region->region_handle,
                        src_region->region_handle,
                        rect_hregion, RGN_OR);
    if ( ret == ERROR )
        DebugMessage(NXLT("XUnionRectWithRegion: could not combine regions!"));
    MS_DeleteObject(rect_hregion);

    return;
}


Region
XPolygonRegion(XPoint points[], int n, int fill_rule)
{
    int ix;
    POINT *msPoints;
    Region region;


    region         = (Region)calloc( 1, sizeof(REGION) );
    region->points = (XPoint*)malloc( n*sizeof(XPoint) );

    memcpy( region->points, points, n*sizeof(XPoint) );    
    region->numPoints = n;
    region->fill_rule = (fill_rule == WindingRule) ? WINDING : ALTERNATE;

    /* convert XPoints to POINTs */
    msPoints = (POINT*)malloc( (region->numPoints)*sizeof(POINT) );
    for ( ix=0; ix < region->numPoints; ix++ )
        {
        msPoints[ix].x = region->points[ix].x;
        msPoints[ix].y = region->points[ix].y;
        }
    region->region_handle = MS_CreatePolygonRgn(msPoints, region->numPoints, 
                                                    region->fill_rule);

    free(msPoints);
    return region;
}

Region
XCreateRegion(void)
{
    Region region;

    region = (Region)calloc( 1, sizeof(REGION) );
    region->size = 0;
    region->numPoints = 0;
    region->points = (XPoint*)malloc( 3*sizeof(XPoint) );
    region->fill_rule = 0;
    /* create undefined region */
    region->region_handle = MS_CreateRectRgn(0, 0, 0, 0);

    return region;
}


void
XDestroyRegion(Region region)
{
    if ( region->region_handle )
        MS_DeleteObject(region->region_handle);
    free(region->points);
    free(region);
}


void
XSetRegion(Display *display, GC gc, Region region)
{
    if ( (gc->clip_mask_is_hregion == AX_WIN_RECTREGION) &&
                        gc->values.clip_mask &&
                        gc->values.clip_mask != region->region_handle )
        {
        /* we only want to delete "rectangular regions"; that is, regions
         * created by XSetClipRectangles.  X Regions will be deleted in
         * XDestroyRegion.          -donato
         */
        MS_DeleteObject(gc->values.clip_mask);
        }

    gc->values.clip_mask = region->region_handle;
    /* tell the GC we have a clip mask created by XSetRegion, which means
     * XDestroyRegion will delete it, not XSetClipMask.     -donato
     */
    gc->clip_mask_is_hregion = AX_WIN_XREGION;
}

BOOL
XEqualRegion(Region reg1, Region reg2)
{
    if ( reg1->region_handle && reg2->region_handle )
        {
        return (MS_EqualRgn(reg1->region_handle, reg2->region_handle));
        }
    else
        return (FALSE);
}


BOOL
XGetGeometry(Display *display, Drawable drw, Window *root, int *x, int *y,
                        unsigned int *width, unsigned int *height,
                        unsigned int *border_width, unsigned int *depth)
{          
    HWND hwnd;
    RECT rect;
    BOOL ret;
    BITMAP bm;
    short obj_type;

    if ( IS_PACKAGED_DRAWABLE(drw) )
        {
        obj_type = GET_DRAWABLE_TYPE(drw);
        if ( obj_type == AX_HWND_TYPE )
            hwnd = (HWND)GET_DRAWABLE_HANDLE(drw);
        else
            {
            /* must be an HDC */
            HDC hdc = (HDC)GET_DRAWABLE_HANDLE(drw);
            hwnd = AxXGetHWND(hdc);
            }
        }
    else
        {
        /* must be a bitmap */
        hwnd = NULL;
        MS_GetObject(drw, sizeof(BITMAP), (LPSTR)&bm);
        }

    *root = RootWin;  /* should this be something else in the bitmap case? */
    if ( hwnd )
        {
        ret = MS_GetClientRect(hwnd, &rect);
        *x = rect.left;
        *y = rect.top;
        *width = rect.right - rect.left;
        *height = rect.bottom - rect.top; 
        *border_width = 2;
        *depth = DpyDepth;
        }
    else
        {
        /* drawable is a bitmap */
        ret = TRUE;
        *x = 0;
        *y = 0;
        *width = bm.bmWidth;
        *height = bm.bmHeight;
        *border_width = 0;
        *depth = bm.bmPlanes * bm.bmBitsPixel;
        }

    return ret;
}


void
XFree(void *data)
{
    free(data);
}



/************* COPY and PASTE STUFF (to end of file) *********************/
void
XSetSelectionOwner(Display *display, Atom selection, Window owner, Time time)
{
    AXSelectionOwner *sP;

    /* check to see if this Atom is already in the list */
    for (sP = SelectionList; sP; sP = sP->nextSel)
    {
        /* if it is, return the window which owns Atom */
        if (sP->selection == selection)
        {
            sP->ownerWindow = owner;
            sP->time = time;
            return;
        }
    }

    /* New Atom type, add it to the list and make owner */
    sP = (AXSelectionOwner*)malloc(sizeof(AXSelectionOwner));
    sP->selection = selection;
    sP->ownerWindow = owner;
    sP->time = time;
    sP->prevSel = NULL;
    sP->nextSel = SelectionList;
    if ( SelectionList )
        SelectionList->prevSel = sP;
    SelectionList = sP;
    return;
}

void
XDeleteProperty(Display *display, Window win, Atom selection)
{
    AXSelectionOwner *sP;

    if ( SelectionList == NULL )
        return;

    if ( (SelectionList->selection == selection) &&
            (SelectionList->ownerWindow == win) )
        {
        sP = SelectionList->nextSel;
        free(SelectionList);
        SelectionList = sP;
        if ( SelectionList )
            SelectionList->prevSel = NULL;
        }
    else
        {
        for ( sP = SelectionList; sP; sP = sP->nextSel )
            {
            if ( (sP->selection == selection) &&
                        (sP->ownerWindow == win) )
                {
                sP->prevSel->nextSel = sP->nextSel;
                if ( sP->nextSel )
                    sP->nextSel->prevSel = sP->prevSel;
                free(sP);
                }
            }
        }
    return;
}


Window
XGetSelectionOwner(Display *display, Atom selection)
{
    AXSelectionOwner *sP;

    for (sP = SelectionList; sP; sP = sP->nextSel)
    {
        if (sP->selection == selection)
            return (sP->ownerWindow);
    }
#if 1
    return (None);       /* do we 1) do what X does or */
#else
    return ((Window)-1); /* 2) simulate a real non-zero window */
#endif

}


#if !ELFRT_ONLY    /*  {  */

/*********************************************************************
 ** this function is used to ask for a clipboard format. if there's a
 ** clipboard owner we send a SelectionNotify event to the requestor
 ** of clipboard data (if the requested format isn't on the clipboard
 ** we pass None to allow the app to ask for another).
 *********************************************************************/
void
XConvertSelection(Display *display, Atom selection, Atom target, Atom property,
                                Window requestor, Time time)
{
    UINT cb_format;
    XEvent xevent;
    AXATOMLIST *aP;


    xevent.type = SelectionNotify;
    xevent.xany.window = requestor;
    xevent.xselection.requestor = requestor;
    xevent.xselection.selection = selection;
    xevent.xselection.target = target;

    /* check to see if our target clipboard format is available. */
    if ( target == CF_TEXT || target == XA_STRING )
        cb_format = target = CF_TEXT;
    else
        {
        aP = AXGetAtomElement(target);
        if ( aP )
            cb_format = aP->winFormatID;
        else
            cb_format = target;    /* assume non-applix format. */
        }

    if ( MS_IsClipboardFormatAvailable(cb_format) )
        xevent.xselection.property = target;
    else
        {
        /* format not found on clipboard. */
        xevent.xselection.property = None;
        }

    AxSelectionEvent(&xevent);
    return;
}



//#define AxXA_DDE_OBJECT CF_PRIVATEFIRST
int
XGetWindowProperty(Display *display, Window w, Atom property, long long_offset,
                long long_length, BOOL delete_property, Atom req_type,
                Atom *actual_type_return, int *actual_format_return,
                unsigned long *nitems_ret, unsigned long *bytes_after_ret,
                unsigned char **prop_return)
{
    int strLen;
    LPTSTR  lpClipMemory;
    HANDLE hClipMemory;
    AXATOMLIST *aP;
    UINT cb_format;
    DWORD cb_error;
    UINT num_bytes;
    //int retval;

/* make debug true to see what clipboard formats are available. *
 * useful for looking at what NON-applix apps register.         */
int debug = 0;
    if ( debug )
        ShowClipboardFormats();

/* property = Windows clipboard format id:
        either one of the given Windows formats, like CF_TEXT;
        or one of our Applix registered formats, like _AX_WP_FILE.
*/
/* req_type = junk! */

    if ( REGISTERED_CLIPBOARD_FORMAT(property) )
        {
        /* the clipboard format is already in registered format id form. */
        cb_format = property;
        }
    if ( property == CF_TEXT || property == XA_STRING )
        cb_format = CF_TEXT;
#if 0
    else if ( property == AxXA_DDE_OBJECT )
        {
        /* get the "richest" data format. */
        cb_format = MS_EnumClipboardFormats(0);
        retval = ax_dde_request(cb_format);
        return retval;
        }
#endif
    else
        {
        aP = AXGetAtomElement(property);
        if ( aP )
            cb_format = (UINT)aP->winFormatID;
        else
            cb_format = property;    /* assume non-applix format. */
        }

    if ( !MS_IsClipboardFormatAvailable(cb_format) )
        {
        DebugMessage(NXLT("XGetWindowProperty: clipboard format not available!"));
        return !Success;
        }

    if ( !MS_OpenClipboard((HWND)NULL) )
        {
        cb_error = MS_GetLastError();    /* could be useful. */
        return !Success;
        }

    /* get what's on the clipboard (due to "delayed rendering" this may  *
     * cause a WM_RENDERFORMAT message to be sent to the clipboard owner.*
     * The appropriate task will set the clipboard data and the memory   *
     * handle will be returned here).                -donato             */
    hClipMemory = MS_GetClipboardData(cb_format);
    if ( hClipMemory == NULL )    /* NULL if not requested type */
        {
        MS_CloseClipboard();
        return !Success;
        }

    /* check what kind of data we've retrieved and deal with it accordingly. */
    switch (cb_format)
        {
    case CF_METAFILEPICT:
        {
        char wmf_tempfile[STRPATH+1];
        HMETAFILE hmf;
        METAFILEPICT *lpMetaFilePict;

        /* Windows Metafile (WMF). */
        lpMetaFilePict = (LPMETAFILEPICT)MS_GlobalLock(hClipMemory);
        num_bytes = GetMetaFileBitsEx(lpMetaFilePict->hMF, 0, NULL);
        if ( num_bytes > 0 )
            {
            /* we have a valid metafile. create a temp file so we can *
             * create a disk metafile to perform the filter on.       */
            AxTempFile(NULL, wmf_tempfile);

            /* copy memory metafile to disk. */
            hmf = MS_CopyMetaFile(lpMetaFilePict->hMF, (LPCTSTR)wmf_tempfile);
            /* we don't need the handle, so delete it. */
            MS_DeleteMetaFile(hmf);
            /* return the disk metafile name to be read later. *
             * (see convertWMFtoGE).                           */
            *prop_return = malloc(strlen(wmf_tempfile) + 1);
            strcpy(*prop_return, wmf_tempfile);
            }
        else
            {
            DebugMessage(NXLT("XGetWindowProperty: couldn't get metafile bits"));
            MS_CloseClipboard();
            return !Success;
            }
        break;
        }

    case CF_BITMAP:
        {
        HBITMAP hbm;
        char bmp_tempfile[STRPATH+1];

        /* a Windows 2-compatible bitmap (BMP). */
        hbm = (HBITMAP)hClipMemory;
        if ( hbm )
            {
            AxTempFile(NULL, bmp_tempfile);
            WriteBitmapToFile(hbm, bmp_tempfile);
            /* return the disk .BMP filename to be read later. *
             * (see convertBMPtoGE).                           */
            *prop_return = malloc(strlen(bmp_tempfile) + 1);
            strcpy(*prop_return, bmp_tempfile);
            }
        else
            {
            DebugMessage(NXLT("XGetWindowProperty: no bitmap handle!"));
            MS_CloseClipboard();
            return !Success;
            }
        break;
        }

#if 0
    case CF_TIFF:
        {
        /* how can we test this? are there any apps that register *
         * data in TIFF format?               -donato             */
        char *tiff_data;

        data_size = MS_GlobalSize(hClipMemory);
        tiff_data = malloc(data_size);
        if ( !tiff_data )
            {
            MS_CloseClipboard();
            return(!Success);
            }
        lpClipMemory = (LPSTR)MS_GlobalLock(hClipMemory);
        strcpy(tiff_data, lpClipMemory);

        AxTempFile(NULL, tiff_tempfile);
        WriteTiffToFile(tiff_data, tiff_tempfile);
        /* return the disk tiff filename to be read later. *
         * (see convertTIFFtoGE).                          */
        *prop_return = malloc(strlen(tiff_tempfile) + 1);
        strcpy(*prop_return, tiff_tempfile);
        break;
        }
#endif

    case CF_SYLK:
        /* SYLK is an ascii format, but can we assume same as TEXT? */
    case CF_TEXT:
        strLen = MS_GlobalSize(hClipMemory);
        *prop_return = malloc(strLen);
        if ( *prop_return == NULL )
            {
            MS_CloseClipboard();
            return(!Success);
            }
        lpClipMemory = (LPSTR)MS_GlobalLock(hClipMemory);
        strcpy(*prop_return, lpClipMemory);
        break;

    default:
        if ( aP )
            {
            /* this means we have an Applix format, which is always ascii*
             * (for now?).                  -donato                      */
            strLen = MS_GlobalSize(hClipMemory);
            *prop_return = malloc(strLen);
            if ( *prop_return == NULL )
                {
                MS_CloseClipboard();
                return(!Success);
                }
            lpClipMemory = (LPSTR)MS_GlobalLock(hClipMemory);
            strcpy(*prop_return, lpClipMemory);
            }
        else
            {
            char buf[80];
            strcpy(buf, 
                XLT("Current Clipboard format not supported by Applixware."));
            AxDirectInfoMessage(-1, buf);
            MS_CloseClipboard();
            return !Success;
            }
        break;
        }    /** end switch on cb_format **/


    /* cleanup and return. */
    MS_GlobalUnlock(hClipMemory);
    MS_CloseClipboard();
    if ( property == CF_TEXT )
        *actual_type_return = XA_STRING;
    else
        *actual_type_return = property;
    *nitems_ret = strlen(*prop_return);
    *bytes_after_ret = 0;
    return Success;
}

#endif   /*   } !ELFRT_ONLY */

/**************************************************************************
 *** This function is called during processing of WM_RENDERFORMAT.
 *** that is, an application (either applix or non-applix) has asked for 
 *** clipboard data (a paste operation) and since we are using the
 *** "delayed rendering" clipboard scheme, we supply the proper data here.
 *** DO NOT open and/or empty the clipboard!!
 **************************************************************************/
/* this is void on X, but here we are returning a status... */
int
XChangeProperty(Display *display, Window w, Atom property, Atom type,
            int format, int mode, const unsigned char *data, int nelements)
{
    UINT cb_format;
    GLOBALHANDLE clipMemory;
    unsigned char *lpClipMemory;
    AXATOMLIST *aP;


/* property = format that app has requested data in. */

    /* Get the windows clipboard id for this type */
    if ( REGISTERED_CLIPBOARD_FORMAT(property) )
        {
        /* the clipboard format is already in registered format id form. */
        cb_format = property;
        }
    else if ( property == XA_STRING )
        cb_format = CF_TEXT;
    else
        {
        aP = AXGetAtomElement(property);
        if ( aP )
            cb_format = (UINT)aP->winFormatID;
        else
            cb_format = property;    /* assume non-applix format. */
        }

    /* deal with different formats appropriately. */
    switch (cb_format)
        {
    case CF_METAFILEPICT:
        {
        HMETAFILE disk_hmf;
        METAFILEPICT *mfP;

        /* 'data' contains the filtered WMF filename which was created in
         * the convertGEtoWMF function. we delete it below.
         * Get a metafile handle of the disk metafile. the Clipboard wants
         * a memory metafile, however, so we copy one into the the structure.
         */
        disk_hmf = MS_GetMetaFile((LPCTSTR)data);
        /* set up METAFILEPICT struct to transfer the metafile. */
        clipMemory = MS_GlobalAlloc(GHND, (DWORD)sizeof(METAFILEPICT));
        mfP = (LPMETAFILEPICT)MS_GlobalLock(clipMemory);
        mfP->mm = MM_ANISOTROPIC;
        mfP->xExt = 0;
        mfP->yExt = 0;
        mfP->hMF = MS_CopyMetaFile(disk_hmf, NULL);
        /* cleanup */
        AxDeleteTempfile((char*)data);
        MS_DeleteMetaFile(disk_hmf);
        break;
        }

    case CF_TEXT:
        /* copy the data to a global handle which clipboard needs */
        /* Note: we give up this data, so do NOT use malloc! */
        clipMemory = MS_GlobalAlloc(GHND, (DWORD)(nelements + 1));
        if ( clipMemory == NULL )
            return !Success;

        /* copy the local data to a global area */
        lpClipMemory = (unsigned char*)MS_GlobalLock(clipMemory);
        memcpy(lpClipMemory, data, nelements);
        lpClipMemory[nelements] = 0;
        break;

    default:
        if ( aP )
            {
            /* this means we have an Applix format, which is always ascii*
             * (for now?).                  -donato                      */
            /* copy the data to a global handle which clipboard needs */
            /* Note: we give up this data, so do NOT use malloc! */
            clipMemory = MS_GlobalAlloc(GHND, (DWORD)(nelements + 1));
            if ( clipMemory == NULL )
                return !Success;

            /* copy the local data to a global area */
            lpClipMemory = (unsigned char*)MS_GlobalLock(clipMemory);
            memcpy(lpClipMemory, data, nelements);
            lpClipMemory[nelements] = 0;
            }
        else
            {
            char buf[80];
            sprintf(buf, NXLT("Clipboard type %d not ported"), cb_format);
            DebugMessage(buf);
            }
        }    /** end switch **/


    /* unlock the data so the clipboard can use it */
    MS_GlobalUnlock(clipMemory);

    /* put our data onto the clipboard */
    MS_SetClipboardData(cb_format, clipMemory);

    return Success;
}


void
XSendEvent(Display *display, Window w, BOOL propagate, long eventMask,
                                                        XEvent *eventP)
{
#if 0
    /* DO WE NEED TO PORT THIS?   -donato */
    struct wind_struct *wp, *curWp;

    /* temporary global Wp hack */
    curWp = Wp;

    /* For now, assume another Applix window */
    wp = SetWpFromX11Window(w); 
    if (wp)
        DoAppEvent(eventP);

    Wp = curWp;
    return;
#endif
}


Atom
XInternAtom(Display *display, const char *propertyName, BOOL onlyIfExists)
{
    AXATOMLIST *aP;

    for (aP = AtomList; aP; aP = aP->nextItem)
    {
        if (strcmp(aP->propertyName, propertyName) == 0)
            return (aP->atom);
    }

    if ( !onlyIfExists )
    {
        AddToAtomList((char*)propertyName, ++NextAtom);
        return (AtomList->atom);
    }

    return ((Atom)None);

}


/********************** Atom funcs - NON X! ***************************/
Atom
AxWinExternAtom(char *atomName, UINT external_format_id)
{
    AXATOMLIST *aP;

    for ( aP = AtomList; aP; aP = aP->nextItem )
        {
        /* if already on the list, just return it. */
        if ( aP->winFormatID == (int)external_format_id )
            return aP->atom;
        }

    /* otherwise, add to Atom list and return. */
    aP = (AXATOMLIST*)malloc(sizeof(AXATOMLIST));
    aP->atom = NextAtom++;
    aP->propertyName = (char*)malloc(strlen(atomName)+1);
    strcpy(aP->propertyName, atomName);
    aP->winFormatID = external_format_id;
    aP->nextItem = AtomList;
    AtomList = aP;

    return aP->atom;
}


void
WinInitAtom(Display *display, char *propertyName, Atom property)
{
    AddToAtomList(propertyName, property);
}

static void
AddToAtomList(char *atomName, Atom atom)
{
    AXATOMLIST *aP;

    /* add to Atom list */
    aP = (AXATOMLIST*)malloc(sizeof(AXATOMLIST));
    aP->atom = atom;
    aP->propertyName = (char*)malloc(strlen(atomName)+1);
    strcpy(aP->propertyName,atomName);
    aP->winFormatID = MS_RegisterClipboardFormat(atomName);
    aP->nextItem = AtomList;
    AtomList = aP;
}

AXATOMLIST *
AXGetAtomElement(Atom atom)
{
    AXATOMLIST *aP;

    for ( aP = AtomList; aP; aP = aP->nextItem )
        {
        if ( aP->atom == atom )
            return aP;
        }
    return NULL;
}

/*********************************************************************
 * this returns the X atom that corresponds to the Windows clipboard *
 * format id (for example, XA_STRING, etc...)                        *
 ********************************************************************/
Atom
AxWinGetAtomId(int win_format_id)
{
    AXATOMLIST *aP;

    for ( aP = AtomList; aP; aP = aP->nextItem )
        {
        if ( aP->winFormatID == win_format_id )
            return aP->atom;
        }

    return (Atom)0;
}

UINT
AxWinGetWinFormatId(int atom)
{
    AXATOMLIST *aP;

    for ( aP = AtomList; aP; aP = aP->nextItem )
        {
        if ( aP->atom == (Atom)atom )
            return aP->winFormatID;
        }

    return (UINT)0;
}
/****************** end atom funcs ***********************************/

static HWND
AxXGetHWND(HDC hdc)
{
    HWND hwnd;
    AXWidget w;

    hwnd = NULL;
    w = GetWidgetFromDC(hdc);
    if ( w )
        hwnd = w->winid;
    else
        {
        /* search total windows list first. */
        hwnd = GetHWNDFromTotalWindowsList(hdc);
        if ( !hwnd )
            /* now search WindowList (widgets that have windows). */
            hwnd = AxGetHWNDFromHDC(hdc);
        }
    return hwnd;
}

static HWND
AxGetHWNDfromDrawable(HANDLE drw)
{
    HWND hwnd;
    short obj_type;

    if ( IS_PACKAGED_DRAWABLE(drw) )
        {
        obj_type = GET_DRAWABLE_TYPE(drw);
        if ( obj_type == AX_HWND_TYPE )
            hwnd = (HWND)GET_DRAWABLE_HANDLE(drw);
        else
            {
            /* assume we have an HDC. if we don't, something is wrong.
             * the folowing returns an already "unpackaged" window handle.
             */
            HDC hdc = (HDC)GET_DRAWABLE_HANDLE(drw);
            hwnd = AxXGetHWND(hdc);
            }
        }
    else
		{
        DebugMessage("AxGetHWNDfromDrawable: unpackaged handle!");
		hwnd = NULL;
		}

    return hwnd;
}
#endif    /* } !FOR_FILTER */


static HPEN
AxWinGetPen(GC gc, HDC hdc, BOOL *transparent)
{
    int pen_width, pen_style;
    HPEN hpen;
    LOGBRUSH lbrush;
    HBITMAP pattern;
    COLORREF fore_color, back_color;

    hpen = NULL;
    *transparent = FALSE;
    if ( gc->values.foreground == 1 ||
            (DpyDepth == 8 && gc->values.foreground == 255) )
        {
        /* make sure we have the real white pixel. */
#if FOR_FILTER
        fore_color = REAL_WHITE_PIXEL;
#else
        fore_color = GET_COLOR_VALUE(REAL_WHITE_PIXEL);
#endif
        }
    else
        fore_color = GET_COLOR_VALUE(gc->values.foreground);

    if ( gc->values.line_style == LineSolid )
        {
        if ( gc->values.fill_style == FillStippled ||
                gc->values.fill_style == FillOpaqueStippled )
            {
            /* solid line with a stipple pattern. */
            if ( Running_Windows95 )
                {
                /* on Win95 we create a simple pen of the requested width.
                 * we will later use it as a clipping region to do the
                 * pattern fill (see DrawPatternedLine).
                 * We later use WidenPath to create the clip, which requires
                 * a pen created with ExtCreatePen (see MS docs).
                 */
                lbrush.lbStyle = BS_SOLID;
                lbrush.lbColor = RGB(0,0,0);
                lbrush.lbHatch = 0;
                if ( gc->values.line_width == 0 )
                    pen_width = 1;
                else
                    pen_width = gc->values.line_width;
                hpen = MS32_ExtCreatePen(PS_GEOMETRIC | PS_ENDCAP_FLAT,
                                            pen_width, &lbrush,
                                            (DWORD)0, (CONST DWORD*)NULL);
                }
            else
                {
                if ( gc->values.stipple )
                    pattern = gc->values.stipple;
                else
					{
                    DebugMessage(NXLT("Stipple Fill requested without a stipple map!"));
					pattern = NULL;
					}

                /* we will be using a geometric pen with a pattern */
                lbrush.lbStyle = BS_PATTERN;
                lbrush.lbColor = 0;    /* this field ignored when BS_PATTERN */
                lbrush.lbHatch = (LONG)pattern;

                pen_style = PS_GEOMETRIC;
                pen_width = gc->values.line_width;
                hpen = MS32_ExtCreatePen((DWORD)pen_style, (DWORD)pen_width,
                                    &lbrush, (DWORD)0, (CONST DWORD*)NULL);

                if ( gc->values.fill_style == FillStippled )
                    {
                    /* transparent stipple. */
                    *transparent = TRUE;
                    }
                else
                    {
                    back_color = GET_COLOR_VALUE(gc->values.background);
                    MS_SetBkColor(hdc, fore_color);
                    MS_SetTextColor(hdc, back_color);
                    }
                }
            }
        else
            {
            /* normal solid line. */
            pen_style = PS_SOLID;
            pen_width = gc->values.line_width;
            /* normal solid pens have a default cap style of CapRound.   *
             * to get anything other than that, we need to use a Windows *
             * GEOMETRIC style pen.               -donato                */
            if ( gc->values.cap_style == CapButt )
                {
#if !FOR_FILTER    /* temp until we figure out Win95 stuff */
                if ( Running_Windows95 )
                    hpen = MS_CreatePen(pen_style, pen_width, fore_color);
                else
#endif
                    {
                    pen_style |= PS_GEOMETRIC | PS_ENDCAP_FLAT;
                    lbrush.lbStyle = BS_SOLID;
                    lbrush.lbColor = fore_color;
                    lbrush.lbHatch = 0;
                    hpen = MS32_ExtCreatePen(pen_style, pen_width, &lbrush,
                                            (DWORD)0, (CONST DWORD*)NULL);

                    }
                }
            else
                hpen = MS_CreatePen(pen_style, pen_width, fore_color);
            }
        }
    else
        {
        /* non solid line. need special pen */
        pen_style = GetPenStyle(gc);
        if ( pen_style & PS_GEOMETRIC )
            {
            if ( gc->values.line_width )
                pen_width = gc->values.line_width;
            else
                pen_width = 1;
            }
        else
            pen_width = 1;

#if !FOR_FILTER    /* temp until we figure out Win95 stuff */
        if ( Running_Windows95 )
            {
            if ( !(pen_style & PS_COSMETIC) )
                pen_style |= PS_COSMETIC;
            }
#endif

        if ( gc->values.fill_style == FillStippled ||
                gc->values.fill_style == FillOpaqueStippled )
            {
            /* special line with a stipple pattern. */
            /* we will be using a geometric pen with a pattern */
#if !FOR_FILTER    /* temp until we figure out Win95 stuff */
            if ( Running_Windows95 )
                lbrush.lbStyle = BS_SOLID;
            else
#endif
                lbrush.lbStyle = BS_PATTERN;
            lbrush.lbColor = 0;    /* this field ignored when BS_PATTERN */
            lbrush.lbHatch = (LONG)gc->values.stipple;

            if ( gc->values.fill_style == FillStippled )
                {
                /* transparent stipple. */
                *transparent = TRUE;
                }
            else
                {
                back_color = GET_COLOR_VALUE(gc->values.background);
                MS_SetBkColor(hdc, fore_color);
                MS_SetTextColor(hdc, back_color);
                }
            }
        else
            {
            /* non-stippled special pen. */
            lbrush.lbStyle = BS_SOLID;
            lbrush.lbColor = fore_color; 
            lbrush.lbHatch = 0;
            }

        /* if ( gc->values.dash_list_size > 0 && !Running_Windows95 ) *
         * need to figure out pens on Windows 95   -donato
         */
        if ( gc->values.dash_list_size > 0 )
            {
            /* create special 'dashed' pen */
            hpen = AxWinCreateDashedPen(gc->values.dashes,
                                        gc->values.dash_list_size,
                                        pen_style, pen_width, &lbrush);
            }
        else
            {
            hpen = MS32_ExtCreatePen((DWORD)pen_style, (DWORD)pen_width,
                                    &lbrush, (DWORD)0, (CONST DWORD*)NULL);
            }
        }

    if ( Running_Windows95 )
        *transparent = FALSE; /* until we figure out how to do it... */
    return hpen;
}







#if !FOR_FILTER    /*  {  */

#define MAX_COLOR_NAME 21
typedef struct _color_list {
    unsigned short red;
    unsigned short green;
    unsigned short blue;
    char name[MAX_COLOR_NAME];
    } color_list;

color_list *colorP;
int size_colorP;


/***********************************************************************/
/* We have lifed the "axrgb.txt" file from X, and read it here to allow  */
/* ELF code to set the colors on a widget by name, ie. "blue".  Rather */
/* than reading and storing the entire axrgb.txt file, we read it when we *
/* get a request for a new color, and then cache that entry.  While this */
/* is may be slower on startup, it saves quite a bit of memory, and it  */
/* is expected that any one user will use only a small fraction of the  */
/* color names in axrgb.txt (there are 738 colors defined)      - jon     */
/***********************************************************************/
XParseColor( display, cmap, color_name, cdef )
void *display;
Colormap cmap;
char *color_name;
XColor *cdef;
{
    int i;
    char temp_name[MAX_COLOR_NAME];
    color_list *cP;
    FILE *fp;
    int red, green, blue;
    char filename[STRPATH+1];
    char buff[200];
    char *name, *p;

   
    /* make sure name is not too long */
    strncpy( temp_name, color_name, MAX_COLOR_NAME-1 );
    temp_name[MAX_COLOR_NAME] = 0;

    /** se if the requested color is already in our cache  */
    cP = colorP;
    for ( i=0; i<size_colorP; i++ )
       {
       if ( stricmp( temp_name, cP->name ) == 0 )
          {
          /* found it */
          cdef->red = cP->red;
          cdef->green = cP->green;
          cdef->blue = cP->blue;
          return( TRUE );
          }
       cP++;
       }

    /** fell through not in our cached list.  Read through the RGB file */
    /** to find the requested entry, and add it to the cache             */
    strcpy( filename, ThimApplixDir );
    strcat( filename, DirSlash );
    strcat( filename, "axrgb.txt" );

    fp = fopen( filename, READ_STR );
    if ( fp == (FILE *)NULL )
        return( FALSE );

    while ( fgets( buff, sizeof(buff), fp ) != (char *)NULL )
       {
       if ( buff[0] == ';' )
          /* comment */
          continue;

       p = buff + strlen(buff);
       while ( *p < ' ' )
         {
         /* step on any trailing newlines */
         *p = '\0';
         p--;
         }
       p = buff;
       while ( *p <= ' ' )
         { p++; }
       red = atoi( buff );
       p = index( p, (int)' ' );
       p++;
       while ( *p <= ' ' )
         { p++; }
       green = atoi( p );
       p = index( p, (int)' ' );
       p++;
       while ( *p <= ' ' )
         { p++; }
       blue = atoi( p );
       while ( *p > ' ')
          { p++; }        /* skip over "blue" numbers */ 
       while ( *p <= ' ' ) 
          { p++; }        /* skip to color name */
       name = p;

       if ( stricmp( temp_name, name ) == 0 )
           {
           /* found it, add to the cache */
           size_colorP++;
           colorP = (color_list*)realloc(colorP, 
                                        (size_colorP * sizeof(color_list)));
           cP = colorP + size_colorP - 1;
           /* X seems to store the RGB values in the upper byte of the short */
           cdef->red = cP->red = red << 8;
           cdef->green = cP->green = green << 8;
           cdef->blue = cP->blue = blue<<8;
           strcpy( cP->name, name );
           fclose( fp );
           return( TRUE );
           }
       }

    /* feel through, did not find the color */
    fclose( fp );
    return( FALSE );
}

#if !ELFRT_ONLY
/* this should eventually move to a common file. */
/*************************************************************************
function: SetCurWinFromMenuWidget - Select window based on menubar widget
*/
void
SetCurWinFromMenuWidget(AXWidget_menu widget)
{
    register int ix;
    struct wind_struct *windowP;

    for ( ix = 0; ix < TM_MAXWIN; ix++ ) {
        if ( window[ix].busy_flag && (window[ix].menu_bar == widget) ) {
            windowP = make_curwin(ix);
            AXSetInputFocus(windowP->xwin, FALSE, CurrentTime);
            return;
        }
    }
}
#endif

#endif    /*  }  !FOR_FILTER  */


static void
CreateLineGCfromGC(GC gc, HDC hdc, line_gc_type *line_gc)
{
    int ix;

    line_gc->hdc = hdc;
    line_gc->fg = gc->values.foreground;
    line_gc->bg = gc->values.background;
    line_gc->fill_style = gc->values.fill_style;
    line_gc->stipple = gc->values.stipple;
    line_gc->line_style = gc->values.line_style;
    line_gc->line_width = gc->values.line_width;
    line_gc->cap_style = gc->values.cap_style;
    line_gc->join_style = gc->values.join_style;
    for ( ix=0; ix < 10; ix++ )    /* see XSetDashes */
        line_gc->dashes[ix] = gc->values.dashes[ix];
    line_gc->dash_list_size = gc->values.dash_list_size;
    line_gc->dash_offset = gc->values.dash_offset;
    line_gc->infinite_slope = FALSE;
}


static void
DrawThickDash(line_gc_type *line_gc, int x, int y, int dash_ix)
{
    int dash_len, y_intercept;
    int dash_end_x, dash_end_y;
    POINT pts[4];
    double slope_2, dash_len_2;

    dash_len = line_gc->dashes[dash_ix];

    if ( line_gc->slope == 0.0 )
        {
        /* we have "simple" case of either horizontal or vertical line. */
        if ( line_gc->infinite_slope )
            {
            /* we have a vertical line */
            dash_end_x = x;
            dash_end_y = y - dash_len;
            pts[0].x = pts[1].x = x - (line_gc->line_width / 2);
            pts[0].y = pts[3].y = y;
            pts[1].y = pts[2].y = dash_end_y;
            pts[2].x = pts[3].x = x + (line_gc->line_width / 2);
            }
        else
            {
            /* we have a horizontal line */
            dash_end_x = x + dash_len;
            dash_end_y = y;
            pts[0].x = pts[3].x = x;
            pts[0].y = pts[1].y = y - (line_gc->line_width / 2);
            pts[1].x = pts[2].x = dash_end_x;
            pts[2].y = pts[3].y = y + (line_gc->line_width / 2);
            }
        }
    else
        {
        dash_len_2 = pow((double)dash_len, 2.0);  /* length of dash squared */
        slope_2 = pow(line_gc->slope, 2.0);       /* the slope squared. */

        dash_end_x = x + sqrt(dash_len_2 / (1.0 + slope_2));
        dash_end_y = (line_gc->slope * dash_end_x) + line_gc->y_intercept;

        /* get y_intercept of the perpendicular. */
        y_intercept = y + (x / line_gc->slope);
        pts[0].x = x - line_gc->x_offset;
        pts[0].y = -(pts[0].x / line_gc->slope) + y_intercept;

        pts[3].x = ceil(x + line_gc->x_offset);
        pts[3].y = -(pts[3].x / line_gc->slope) + y_intercept;

        /* get y_intercept of the second perpendicular. */
        y_intercept = dash_end_y + (dash_end_x / line_gc->slope);
        pts[1].x = dash_end_x - line_gc->x_offset;
        pts[1].y = -(pts[1].x / line_gc->slope) + y_intercept;

        pts[2].x = ceil(dash_end_x + line_gc->x_offset);
        pts[2].y = -(pts[2].x / line_gc->slope) + y_intercept;
        }

    if ( dash_len == 1 )
        {
        /* the length of the dash is only a pixel, so just draw a line. */
        MS_MoveToEx(line_gc->hdc, pts[0].x, pts[0].y, (POINT*)NULL);
        MS_LineTo(line_gc->hdc, pts[3].x + 1, pts[3].y + 1);
        }
    else
        MS_Polygon(line_gc->hdc, pts, 4);
}

void CALLBACK
DrawDashLineProc(int x, int y, LPARAM line_data)
{
    int dash_off;
    line_gc_type *line_gc = (line_gc_type*)line_data;
    static int dash_counter;
    static int dash_ix;

    /* "dash_off" indicates whether we should be drawing pixels or not.
     * in the dash_list array, the even indices indicate dash on.
     */
    dash_off = dash_ix % 2;

    if ( (dash_counter < line_gc->dashes[dash_ix]) )
        {
        if ( !dash_off )
            {
            if ( line_gc->line_width <= 1 )
                SetPixelV(line_gc->hdc, x, y, GET_COLOR_VALUE(line_gc->fg));
            else if ( dash_counter == 0 )
                {
                /* we only want to draw the thick dash at the start of
                 * the dash cycle because we draw the whole dash at once
                 * rather than pixel by pixel.          -donato
                 */
                DrawThickDash(line_gc, x, y, dash_ix);
                }
            }
        dash_counter++;
        if ( dash_counter < line_gc->dashes[dash_ix] )
            return;
        }

    dash_counter = 0;

    if ( dash_ix > (line_gc->dash_list_size - 1) )
        dash_ix = 0;
    else
        dash_ix++;
}

void CALLBACK
DrawSolidLineProc(int x, int y, LPARAM line_data)
{
    HDC dest_dc;
    line_gc_type *line_gc = (line_gc_type*)line_data;

    dest_dc = line_gc->hdc;
    if ( 0 )// line_gc->fill_style == FillStippled ||
        //line_gc->fill_style == FillOpaqueStippled )
        {
        HDC src_dc;
        BITMAP bm;
        HBITMAP old_hbm;
#if 1
        MS_GetObject(line_gc->stipple, sizeof(BITMAP), (LPSTR)&bm);

        //hbrush = MS_CreatePatternBrush(line_gc->stipple);
        src_dc = MS_CreateCompatibleDC(dest_dc);
        old_hbm = MS_SelectObject(src_dc, line_gc->stipple);

        //old_brush = MS_SelectObject(dest_dc, hbrush);
        //MS_Polygon(dest_dc, points, 4);
        MS_StretchBlt(dest_dc, x, y, 2, 2, src_dc, 0, 0,
                        bm.bmWidth, bm.bmHeight, SRCCOPY);

        /* local cleanup */
        //MS_SelectObject(dest_dc, old_brush);
        MS_SelectObject(src_dc, old_hbm);
        MS_DeleteDC(src_dc);
#else
        /* solid line with a stipple pattern. */
        if ( gc->values.stipple )
            pattern = gc->values.stipple;
        else
            DebugMessage(NXLT("Stipple Fill requested without a stipple map!"));

        if ( gc->values.fill_style == FillStippled )
            {
            /* transparent stipple. */
             *transparent = TRUE;
            }
        else
            {
            back_color = GET_COLOR_VALUE(gc->values.background);
            MS_SetBkColor(hdc, fore_color);
            MS_SetTextColor(hdc, back_color);
            }
#endif
        }
    else
        {
        /* normal solid line. */
#if 1
        SetPixelV(dest_dc, x, y, GET_COLOR_VALUE(line_gc->fg));
#else
        pen_style = PS_SOLID;
        pen_width = gc->values.line_width;
        /* normal solid pens have a default cap style of CapRound.   *
         * to get anything other than that, we need to use a Windows *
         * GEOMETRIC style pen.               -donato                */
        if ( gc->values.cap_style == CapButt )
                {
#if !FOR_FILTER    /* temp until we figure out Win95 stuff */
                if ( Running_Windows95 )
                    hpen = MS_CreatePen(pen_style, pen_width, fore_color);
                else
#endif
                    {
                    pen_style |= PS_GEOMETRIC | PS_ENDCAP_FLAT;
                    lbrush.lbStyle = BS_SOLID;
                    lbrush.lbColor = fore_color;
                    lbrush.lbHatch = 0;
                    hpen = MS32_ExtCreatePen(pen_style, pen_width, &lbrush,
                                            (DWORD)0, (CONST DWORD*)NULL);

                    }
                }
            else
                hpen = MS_CreatePen(pen_style, pen_width, fore_color);
            }
#endif
        }
}




#if 0
    *transparent = FALSE;
    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    if ( gc->values.line_style == LineSolid )
        {        

    else
        {
        /* non solid line. need special pen */
        pen_style = GetPenStyle(gc);
        if ( pen_style & PS_GEOMETRIC )
            {
            if ( gc->values.line_width )
                pen_width = gc->values.line_width;
            else
                pen_width = 1;
            }
        else
            pen_width = 1;

#if !FOR_FILTER    /* temp until we figure out Win95 stuff */
        if ( Running_Windows95 )
            {
            if ( !(pen_style & PS_COSMETIC) )
                pen_style |= PS_COSMETIC;
            }
#endif

        if ( gc->values.fill_style == FillStippled ||
                gc->values.fill_style == FillOpaqueStippled )
            {
            /* special line with a stipple pattern. */
            /* we will be using a geometric pen with a pattern */
#if !FOR_FILTER    /* temp until we figure out Win95 stuff */
            if ( Running_Windows95 )
                lbrush.lbStyle = BS_SOLID;
            else
#endif
                lbrush.lbStyle = BS_PATTERN;
            lbrush.lbColor = 0;    /* this field ignored when BS_PATTERN */
            lbrush.lbHatch = (LONG)gc->values.stipple;

            if ( gc->values.fill_style == FillStippled )
                {
                /* transparent stipple. */
                *transparent = TRUE;
                }
            else
                {
                back_color = GET_COLOR_VALUE(gc->values.background);
                MS_SetBkColor(hdc, fore_color);
                MS_SetTextColor(hdc, back_color);
                }
            }
        else
            {
            /* non-stippled special pen. */
            lbrush.lbStyle = BS_SOLID;
            lbrush.lbColor = fore_color; 
            lbrush.lbHatch = 0;
            }

        /* if ( gc->values.dash_list_size > 0 && !Running_Windows95 ) *
         * need to figure out pens on Windows 95   -donato
         */
        if ( gc->values.dash_list_size > 0 )
            {
            /* create special 'dashed' pen */
            hpen = AxWinCreateDashedPen(gc->values.dashes,
                                        gc->values.dash_list_size,
                                        pen_style, pen_width, &lbrush);
            }
        else
            {
            hpen = MS32_ExtCreatePen((DWORD)pen_style, (DWORD)pen_width,
                                    &lbrush, (DWORD)0, (CONST DWORD*)NULL);
            }
        }
#endif

