/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmdlged.c
   Applix ASC version: 249
   Date: Wed Feb 24 21:13:18 1999
*/
#define ATMPROTO_H_INCL

#include <limits.h>
#include <stdio.h>

#include <dwt2xm.h>
#include <basicwin.h>
#include <ax_xm.h>
#if AX_X11
#include <X11/keysym.h>
#endif

#include <aos.h>
#include <xmlib.h>
#include <xmpixel.h>
#include <xmdlged.h>
#include <elxwins.h>
#include <ximcomm.h>
#include <adlgpoke.h>
#include <axtext.h>
#include <axhtab.h>
#include <scac.h>

/* %%%%%%%%%%% add the app_ids.elf defines to elxwins.h .... */
#define APP_DLGED 20    /* cribbed from app_ids.elf */

/* %%%%%%%%%%% add these defines to xmlib.h */
    /* some constants describing the default dialog font axsab-16 */
#define AXSAB_PIXHT  16     /* font height in screenpix */
#define AXSAB_AVGWID 65     /* average screen pixwid in decipix */
#define AXSAB_DIGWID  7     /* pixel width of digit in axsab-16 */

extern short ColorDisplay;
extern Display *Dpy;
extern Pixmap ScratchMap;
extern int AxCharHeight;
extern int WidgetNeedsUpdated;
#if AXMS
HDC ScratchMapDrawable = (HDC)NULL;
extern int Scrollbar_Thickness;
extern int Entry_Height;
#define SCROLLBAR_THICK Scrollbar_Thickness   /* variable on Windows */
#else
Pixmap ScratchMapDrawable;
#endif

extern GC ForeGC, BackGC;
extern GC ShadowGC;
extern Window RootWin, AxTopWinNeverMapped;
extern XFontStruct *AxDlgMainFont, *Txfont, *BoldTxfont, *Grafont;
extern XFontStruct *MiniTxfont, *AxDlgMiniFont; /* ol, mt small fonts */
extern int AxButtonDown;
extern data_ptr ElfRetData, AxDialogFontName;
extern short THIMpid;
extern AXWidget_main WindowList;

edWidget DE;

static XtCallbackRec Callback[2];

extern void ElfXCradioPushed(), ElfXCchoicePushed();
extern void deTossColorFile(), deTossColor();
extern char *deNewColorFile(), *deNewColor();

#include <xmdlged.p>

/*
 * Note that there's an assumption that dialog widgets are
 * all direct children of the W_DIALOG widget, even those
 * which are logically children inside a composite dialog
 * widget (e.g., the scrollbar of an editbox -- both editbox
 * and scrollbar are direct children of W_DIALOG)
 */

    /* set 'create mode'; next click or stroke will result in new w */
int
ElfbDEloadNewGadget(parent, wType, wInfo)
data_ptr parent;
data_ptr wType; /* holds gadget type */
data_ptr wInfo; /* format gadget_ */
{
    AXWidget_dialog dlg;
    AXWidget_handle wh;
    wCreate *nw = &DE.newWidget;
    int me = THIMpid;

    dlg = XmDlgInWidget((AXWidget_main)WidgetPointerFromHandleData(parent));
    if (dialogGone(dlg))
        return FALSE;
    VfyContext(dlg->taskOwner);
    if (nw->wInfo) {
            /* toss old, which may have been put there
             * by another task */
        int tmp = THIMpid;
        VfyContext((int) nw->whichDialog->taskOwner);
        AxFreeData(nw->wInfo);
        nw->wInfo = (data_ptr) NULL;
        VfyContext(tmp);
    }

    nw->wType = IntFromDataPtr(wType);
    nw->doCreate = TRUE;
    nw->whichDialog = dlg;

    if (wInfo) {
        nw->wInfo = ElfDataCopy(wInfo); /* take elf-specified defaults */
    }

    deInitElfGadget(nw); /* supply whatever defaults are still needed */

    /* create a widget_t instance using the defaults info
     */
    switch(nw->wType) {
    case DLG_ENTER:
    case DLG_RADIO_BOX:
        /* return value (ElfRetData) is a 2-element array for these two types
         */
        wh = HANDLE_FROM_WIDGET(nw->whichDialog->parent);
        ElfbCreateChangeWidget(wType, NULL, 
                               AxMakeBinaryData(sizeof(wh), (char*)&wh),
                               nw->wInfo);
        /* we want the 0th element of the resultant ElfRetData
         */
        nw->wWidget = WidgetPointerFromHandleData
            (AxArrayElement(ElfRetData, 0));
        
        /* record return on gadget array
         */
        nw->wInfo = AxAddArrayToArray(nw->wInfo, DBDEXwidget,
                                      ElfDataCopy(ElfRetData));
        AxFreeData(ElfRetData);
        ElfRetData = (data_ptr) NULL;
        break;
        
    case DLG_CHOICE:
    case DLG_TOGGLE_BUTTON:
    case DLG_VERB_BUTTON:
    case DLG_TEXT:
    case DLG_ICON:
    case DLG_LIST_BOX:
    case DLG_RECT:
    case DLG_EDIT_BOX:
    case DLG_SCALE:
    case DLG_TABLE:
    case DLG_CANVAS:
    case DLG_COMBO_BOX:
        wh = HANDLE_FROM_WIDGET(nw->whichDialog->parent);
        ElfbCreateChangeWidget(wType, NULL,
                               AxMakeBinaryData(sizeof(wh), (char*)&wh),
                               nw->wInfo);
        nw->wWidget = WidgetPointerFromHandleData(ElfRetData);
        
        /* record return on gadget array
         */
        nw->wInfo = AxWriteArray(nw->wInfo, DBDEXwidget,
                                 ElfDataCopy(ElfRetData));
        break;
    }
    VfyContext(me);
}

static void deAlignWidgets();

    /* perform specified edit */
int
ElfbDEeditWidget(parent, info)
data_ptr parent;
data_ptr info;
{
    int editType;
    AXWidget_dialog dlg = NULL;

    editType = AxIntFromArray(info, 0);
    
    if (needsParticularDialog(editType)) {
        dlg = XmDlgInWidget((AXWidget_main)WidgetPointerFromHandleData(parent));
        if (dialogGone(dlg)) {
            return 0;
        }
    }
    switch(editType) {

        case DE_ALIGN_SELECTED_WIDGETS:
            deAlignWidgets(dlg, info);
            break;
        
        case DE_DELETE_SELECTED:
            deDeleteSelected(dlg);
            break;
            
        case DE_WIDGET_ATTS:
            if (AxIntFromArray(info, 1) == DE_APPLYSET_HANDLE) {
                deChangeByHandle(dlg, info);
            }
            else {
                    /* DE_APPLYSET_WTYPE or DE_APPLYSET_ALL_SELECTED.
                     * both take effect only on selected widgets
                     */
                deChangeSelected(dlg, info);
            }
            break;
            
        case DE_SET_DIALOG_ATTS:
            deSetDialogAtts(dlg, info);
            break;
            
        case DE_WIDGETS_LIST:
            deSelectWidgets(dlg, info);
            break;
            
        case DE_CLOSE_EDIT_SESSION:
            deCloseEditSession(dlg, info);
            break;
            
        case DE_OPEN_EDIT_SESSION:
            deOpenEditSession(dlg, info);
            break;
            
        case DE_NEW_LAYER:
            appendNewWlayer(dlg, (AXWidget) AxIntFromArray(info, 1));
            break;
            
        case DE_WRITE_MM:
            deWriteMainMenuState(AxIntFromArray(info, 1));
            break;
            
        case DE_WRITE_CLIPBOARD:
            deWriteClipboard(dlg, info);
            break;
            
        case DE_ADD_COLORS:
            deAddColors(info);  /* add colors to palette */
            break;
            
        case DE_DELETE_COLORS:
            deDeleteColors(info); /* delete colors from palette */
            break;
            
        case DE_INCLUDE_DLG_COLORS:
            deIncludeDlgColors(info);  /* ensure dlg's colors are in palette */
            break;

        case DE_CLEAR_COLORSET:
            deClearColorset();  /* delete all colors on palette */
            break;
            
        case DE_SEND_UPDATE_POKE:
            deSendUpdatePoke(AxIntFromArray(info, 1), FALSE);
            break;
            
        case DE_FLUSH_UPDATE_POKES:
            deFlushUpdatePokes();
            break;
            
        case DE_DEFER_UPDATE_POKES:
            deDeferUpdatePokes();
            break;
    }
    deFlushWidgetUpdates();
	return 0;
}

    /* so far, all this means is to set the prefs */
int
ElfbDEeditSession(notUsed, info)
int notUsed;
data_ptr info;
{
    int size, ix, jx;
    int lastGridSize, lastGrid;
    mbchar *prefname, *prefval;
    AXWidget tw;
    int toggleBorders = FALSE;
    int checkGrids = FALSE;
    int editType = AxIntFromArray(info, 0);
    switch (editType) {
        case DE_EDIT_PREFS:
                /* ,<#prefs>,<pref1>,<val1>,..,<prefn>,<valn> */
            size = AxIntFromArray(info, 1);
            for (jx = 0, ix = 2; jx < size; jx++, ix += 2) {
                prefname = AxStrPtrFromArray(info, ix);
                prefval = AxStrPtrFromArray(info, ix + 1);
                ElfbAddProfile(prefname, prefval);
                if (MBstrncmp(prefname, NXLT("deGrids"), 7) == 0) {
                    lastGrid = DE.prefs.grid;
                    checkGrids = TRUE;
                    if (MBstrncmp(prefval, "-1", 2) == 0) {
                        DE.prefs.grid = TRUE;
                    }
                    else {
                        DE.prefs.grid = FALSE;
                    }
                }
                else if (MBstrncmp(prefname, NXLT("deGridSize"), 10) == 0) {
                    lastGridSize = DE.prefs.gridsize;
                    checkGrids = TRUE;
                    if (prefval && prefval[0]) {
                        DE.prefs.gridsize = atoi(prefval);
                        if (DE.prefs.gridsize < 3)
                            DE.prefs.gridsize = 3;
                    }
                }
                else if (MBstrncmp(prefname, NXLT("deGridSnap"), 10) == 0) {
                    if (MBstrncmp(prefval, "-1", 2) == 0)
                        DE.prefs.snapToGrid = TRUE;
                    else
                        DE.prefs.snapToGrid = FALSE;
                }
                else if (MBstrncmp(prefname, NXLT("deBorders"), 9) == 0) {
                    toggleBorders = TRUE;
                    DE.prefs.borders = !DE.prefs.borders;
                }
                else if (MBstrncmp(prefname, NXLT("deGhostMove"), 10) == 0) {
                    if (MBstrncmp(prefval, "-1", 2) == 0)
                        DE.prefs.ghost = TRUE;
                    else
                        DE.prefs.ghost = FALSE;
                }
            }
                /* apply the edits just read in */
            if (checkGrids && DE.prefs.grid) {
                if (!lastGrid) {
                        /* grids have been turned on */
                    for (ix = 0; ix < DE.numDlgs; ix++) {
                        if (!(DE.dialogs[ix].dlg)->auxData) {
                            (DE.dialogs[ix].dlg)->auxData = newAuxData();
                        }
                        tw = (DE.dialogs[ix].dlg)->auxData->wEdit.gridWidget = 
                            deXmCreateAlign((AXWidget_dialog)DE.dialogs[ix].dlg,
                                            ALIGN_GRID, (r32 *) NULL);
                        displayWidget(&tw, 1, TRUE);
                    }
                            
                }
                if (lastGrid && (DE.prefs.gridsize != lastGridSize)) {
                        /* grids are still on, but have changed size */
                    for (ix = 0; ix < DE.numDlgs; ix++) {
                        tw = (DE.dialogs[ix].dlg)->auxData->wEdit.gridWidget;
                        liftWidget(tw);
                        displayWidget(&tw, 1, TRUE);
                    }
                }
            }
            else if (checkGrids && lastGrid) {
                    /* grids have been turned off */
                for (ix = 0; ix < DE.numDlgs; ix++) {
                    tw = (DE.dialogs[ix].dlg)->auxData->wEdit.gridWidget;
                    liftWidget(tw);
                    AxXtDestroyWidget(tw);
                    (DE.dialogs[ix].dlg)->auxData->wEdit.gridWidget =
                            (AXWidget) NULL;
                }
            }
            if (toggleBorders) {
                    /* border display has been toggled */
                for (ix = 0; ix < DE.numDlgs; ix++) {
                    doRefresh((AXWidget_dialog)DE.dialogs[ix].dlg,
                              (XExposeEvent *) NULL);
                }
            }
            break;
        default:
            break;
    }
}

    /* express some data to the elf layer */
ElfbDEreadData(notUsed, info)
int notUsed;
data_ptr info;
{
    int readType = AxIntFromArray(info, 0);
    
    switch(readType) {
                
        case DE_READ_PREFS:
            ElfRetData = deReadPrefs(info);
            break;
            
        case DE_READ_ATTS:  /* read 'union' atts across selected set */
            ElfRetData = deReadSelectedAtts(info);
            break;
            
        case DE_READ_WIDGET_ATTS:   /* atts for all selected of type t */
            ElfRetData = deReadWidgetAtts(info);
            break;
            
        case DE_GENERIC_ATTS:   /* atts for all selected */
            ElfRetData = deReadGenericAtts(info);
            break;
            
        case DE_READ_DIALOG_ATTS:
            ElfRetData = deReadDialogAtts(info);
            break;
            
        case DE_READ_VERB_BUTTON_SIZE:
            ElfRetData = deReadVerbButtonSize(info);
            break;
            
        case DE_WIDGETS_LIST:
            ElfRetData = deReadWidgetsList(info);
            break;
            
        case DE_READ_DIALOGS_LIST:
            ElfRetData = deReadDialogsList();
            break;
            
        case DE_READ_MM:
            ElfRetData = deReadMainMenuState();
            break;
            
        case DE_UNIQUE_DLG_NAME:
            ElfRetData = deUniqueDialogName(info);
            break;
            
        case DE_UNIQUE_GADGET_ID:
            ElfRetData = deUniqueGadgetID(info);
            break;
            
        case DE_READ_CLIPBOARD:
            ElfRetData = deReadClipboard();
            break;
            
        case DE_READ_SELECTION_DLG:
            ElfRetData = deReadSelectionDlg();
            break;
            
        case DE_READ_SELECTED_WTYPES:
            ElfRetData = deReadSelectedWtypes();
            break;
            
        case DE_READ_GADGET_ORDER:
            ElfRetData = deComputeGadgetOrder(info);
            break;
            
        case DE_READ_COLOR_SET:
            ElfRetData = deReadColorset(); /* read back the current palette */
            break;
            
        case DE_READ_COLOR_FILE:
            ElfRetData = deReadColorsetFile(info);
            break;
            
        case DE_READ_COLORSET_INDEX:
            ElfRetData = deReadColorsetIndex(info);
            break;
            
        case DE_HSB_TO_RGB:
            ElfRetData = deHSBToRGB(info);
            break;
            
        case DE_LIST_COLORS_UNIQUE_TO_FILE:
            ElfRetData = deListColorsUniqueToFile(info);
            break;
            
        case DE_WIDGET_HANDLES_MATCH:
            ElfRetData = deEqualWidgetHandles(info);
            break;
            
        case DE_LIST_FONT_FAMILIES:
            ElfRetData = deListFontFamilies();
            break;
            
    }
}

ElfbDEscaleDialog(dbox)
data_ptr dbox;
{
    ElfRetData = deScaleDialogLayout(dbox);
}

/* : dlgEventProc - used by the dialog edit dialog. The
 * expected events are KeyPress, KeyRelease, ButtonPress,
 * ButtonRelease, MotionNotify, Expose */
void
dlgEventProc(dialog_w, notUsed, event, consumed)
AXWidget_dialog dialog_w;
char *notUsed;
XEvent *event;
int *consumed;
{
    AXWidget tmp_w;
    p32 tpt;
    int strokeStart;
    
    *consumed = TRUE; /* unless gadget says otherwise */

    if (dialog_w->type == W_MAIN)
        dialog_w = ((AXWidget_main)dialog_w)->dialog;

    if (event->type == KeyPress || event->type == KeyRelease) {
        if (!DE.textEditWidget) {
            *consumed = FALSE; /* let regular wkit handle event */
            return;
        }
    }
    adjustPoint(event, &tpt);    /* assign tpt with adjusted pos */
        /* must first determine whether a gadget gets the event */
    
    if (tmp_w = dlgFindGadget(dialog_w, event)) {
        
        if ((ButtonPress == event->type) &&
            (W_RECT == tmp_w->type) && (RECT_LAYERED == tmp_w->style)) {

            AXWidget_rect rw = (AXWidget_rect) tmp_w;
            XButtonEvent *xb = (XButtonEvent *) event;
            if ((xb->x >= rw->xpos) &&
                (xb->x < rw->xpos + rw->width) &&
                (xb->y >= rw->ypos) &&
                (xb->y < rw->ypos + rw->tabctl.top_inset) ) {

                /* a button press may have hit one of the tabs;
                 * if so, let the regular-wkit event code handle it.
                 */
                p32 tpt;
                int onHandle, curr_active;
                enum handleType whichHandle;
                
                tpt.x = xb->x;
                tpt.y = xb->y;
                onHandle = FALSE;
                pointInsideWidget(&tpt, tmp_w, &onHandle, &whichHandle);

                curr_active = rw->tabctl.active_layer;
                if (!onHandle && RectEvent(rw, event)) {
                    if (curr_active != rw->tabctl.active_layer) {
                        /* just changed tablayers
                         */
                        int itmp;
                        char *stmp;
                        data_ptr attinfo;
                        
                        deDeselectTabctlHidden();

                        itmp = rw->tabctl.active_layer;
                        if (rw->tabctl.layerlist[itmp].layerName) {
                            int me = THIMpid;
                            VfyContext(rw->parent->taskOwner);
                            stmp = rw->tabctl.layerlist[itmp].layerName;
                            attinfo = AxMakeArray(2);
                            attinfo = AxAddIntToArray(attinfo, 0,
                                                      DBDEXactive_tablayer);
                            attinfo = AxAddStrToArray(attinfo, 1, stmp);
                            deSendUpdate((AXWidget)dialog_w->parent,
                                         (AXWidget*)&rw, 1, wAtts, attinfo);
                            VfyContext(me);
                        }
                    }
                    return;
                }
            }
            
        }

        if (localEventDispatch(tmp_w, event)) {
            return;
        }
        else {
            *consumed = FALSE; /* the gadget didn't consume the event */
            return;
        }
    }
    switch(event->type) {
        case KeyPress:
            break;
        case KeyRelease:
            break;
        case ButtonPress:
            AxSetKeyModifiers(event->xbutton.state);
            DE.possiblePick = TRUE;
            if (recent(DE.lastPressTime, event->xbutton.time)) {
                DE.possibleDblPick = TRUE;
            }
            DE.lastPressTime = event->xbutton.time;
            DE.startpt = tpt;
/* %%%%%% cheapie exit poke */
            if (event->xbutton.button == Button3) {
                XmPoker(POKE_EXIT, 0, dialog_w->parent, TRUE, TRUE);
            }
            break;
        case ButtonRelease:
            if (DE.newWidget.doCreate) {
                if (!isStroke(&tpt, &DE.startpt, &strokeStart)) {
                        /* end of a create-click */
                    if(tmp_w = deCreateWidget(dialog_w, &DE.newWidget,
                                &DE.startpt, FALSE)) {
                        deSendCreate((AXWidget)tmp_w->parent->parent, tmp_w,
                                     &DE.newWidget);
                        deDoSinglePick(tmp_w, &event->xbutton);
                        displayWidget(&tmp_w, 1, TRUE);
#if AXMS
                        AllToolbarButtonsUp( dialog_w );
#endif
                    }
                        
/* %%%%%%%% need support for rapid-fire create, which would be modal,
 * %%%%%%%% where mode-exit resets doCreate.. for now: */
                    DE.newWidget.doCreate = FALSE;
                }
                else if (DE.stretching) {
                        /* end of a create-stroke */
                    deSendCreate((AXWidget)DE.dragWidget->parent->parent,
                                 DE.dragWidget, &DE.newWidget);
                    DE.newWidget.doCreate = FALSE;

                    tmp_w = DE.dragWidget;    /* force non-ghost display */
                    DE.dragWidget = (AXWidget) NULL;

                    deDoSinglePick(tmp_w, &event->xbutton);
                    if (DE.prefs.ghost) {
                            /* reset last-ghost rect info */
                        deGhostDisplayWidget(&tmp_w, 1, FALSE); /* lift */
                        TaskFree(0, (char *) DE.lastGhost);
                        DE.lastGhost = (r32 *) NULL;
                    }
                    displayWidget(&tmp_w, 1, TRUE);
                }
            }
            else if (!isStroke(&tpt, &DE.startpt, &strokeStart)) {
                    /* a click that didn't hit anything */
                liftAllMarks();
            }
            else if (isStroke(&tpt, &DE.startpt, &strokeStart) &&
                     DE.dragSelecting) {
                deDrawSelectorRect(dialog_w, &DE.startpt, &tpt, DE_STROKE_END);
                deSelectAllInside(dialog_w, &DE.startpt, &tpt);
                DE.dragSelecting = FALSE;
                TaskFree(0, (char *) DE.lastGhost);   /* reset last-rect info */
                DE.lastGhost = (r32 *) NULL;
            }
            DE.lastReleaseTime = event->xbutton.time;
            DE.possiblePick = DE.possibleDblPick = FALSE;
            DE.dragWidget = (AXWidget) NULL;
            DE.stretching = FALSE;
            break;
        case MotionNotify:
            if (!(event->xmotion.state & Button1Mask))
                break;   /* interested only if button1 down */
            if (DE.newWidget.doCreate &&
                isStroke(&tpt, &DE.startpt, &strokeStart)) {
                if (DE.stretching) {
                    preEdit( DE.dragWidget );
                    resizeByHandle(DE.dragWidget, DE.stretchHandle,  
                                                        &tpt, &DE.origSize);
                }
                else {
                        /* first stroke motion notify of a create-stroke */
                            /* adjust startpt to account for margins;
                               this makes it easier to align things */
                    DE.startpt.x -= deMarginSize(DE.newWidget.wWidget) - 1;
                    DE.startpt.y -= deMarginSize(DE.newWidget.wWidget) - 1;
                    DE.stretching = TRUE;
                    DE.dragWidget = deCreateWidget(dialog_w, &DE.newWidget,
                                        &DE.startpt, TRUE);
                    if (DE.prefs.ghost) {
                            /* init last-rect info */
                        DE.lastGhost = (r32 *) TaskAlloc(0, sizeof(r32));
                        memset((char *) DE.lastGhost, 0, sizeof(r32));
                    }
                    paintWidgetForConstruct(DE.dragWidget);
                    getWidgetSize(DE.dragWidget, &DE.origSize, TRUE);
                        /* set stretch handle based on tpt vs startpt */
                    if (tpt.y > DE.startpt.y) {
                        if (tpt.x > DE.startpt.x)
                            DE.stretchHandle = botRight;
                        else
                            DE.stretchHandle = botLeft;
                    }
                    else {
                        if (tpt.x > DE.startpt.x)
                            DE.stretchHandle = topRight;
                        else
                            DE.stretchHandle = topLeft;
                    }
                        /* jump the mouse so that the initial resize
                         * takes place with a strokerect >= minimum
                         * widget size */
                    initMouseForCreateStroke(&tpt);
                }
/* %%%%%%%%%% should do this thru clip which is sized to the stroke
 * %%%%%%%%%% area, but not so easy for our multi-GC widget kit! */
                displayWidget(&DE.dragWidget, 1, TRUE);
            }
            else if (isStroke(&tpt, &DE.startpt, &strokeStart)) {
                    /* draw selector-rect using xor gc */
                if (DE.dragSelecting) {
                    deDrawSelectorRect(dialog_w, &DE.startpt,
                                       &tpt, DE_STROKE_MID);
                }
                else {
                        /* init selector-rect info, start strokedraw */
                    DE.lastGhost = (r32 *) TaskAlloc(0, sizeof(r32));
                    memset((char *) DE.lastGhost, 0, sizeof(r32));
                    DE.dragSelecting = TRUE;
                    deDrawSelectorRect(dialog_w, &DE.startpt,
                                       &tpt, DE_STROKE_START);
                }
            }
            break;
        case Expose:
            doRefresh(dialog_w, &event->xexpose);
            break;
    }

    return;
}


/* : dlgChildEventProc - used by widgets/gadgets under edit.
 * expected events are KeyPress, KeyRelease, ButtonPress,
 * ButtonRelease, MotionNotify, Expose */
void
dlgChildEventProc(w, notUsed, event, consumed)
AXWidget w;
char *notUsed;
XEvent *event;
int *consumed;
{
    p32 tpt, displ;
    r32 trect;
    AXWidget eventWidget;
    int onHandle, ix, strokeStart;
    int tmp;
    
    *consumed = TRUE; /* event will be completely consumed here */
    if (event->type == KeyPress || event->type == KeyRelease) {
        if (!DE.textEditWidget) {
            *consumed = FALSE; /* let regular wkit handle event */
            return;
        }
    }
    eventWidget = w;
    adjustPoint(event, &tpt);    /* assign tpt with adjusted pos */
    w = topWidget(w); /* get to top of possible composite */
    switch(event->type) {
        case KeyPress:
            break;
        case KeyRelease:
            break;
        case ButtonPress:
            if (event->xbutton.button != Button1)
                break;     /* widgets are interested in button1 only */
            
            AxSetKeyModifiers(event->xbutton.state);
            DE.possiblePick = TRUE;
            if (recent(DE.lastPressTime, event->xbutton.time)) {
                DE.possibleDblPick = TRUE;
            }
            DE.lastPressTime = event->xbutton.time;
            DE.startpt = tpt;
            if (pointInsideWidget(&tpt, w, &onHandle, &DE.stretchHandle)) {
                getWidgetSize(w, &DE.origSize, TRUE);
                if (onHandle) {
                    getHandleOffset(w, &DE.origSize, DE.stretchHandle,
                                        &DE.dragpt);
                    DE.dragpt.x += DE.origSize.origin.x;
                    DE.dragpt.y += DE.origSize.origin.y;
                    DE.dragpt.x = tpt.x - DE.dragpt.x;
                    DE.dragpt.y = tpt.y - DE.dragpt.y;
                    DE.stretching = TRUE;
                }
                else {
                    DE.dragpt.x = tpt.x - DE.origSize.origin.x;
                    DE.dragpt.y = tpt.y - DE.origSize.origin.y;
                }
                DE.dragWidget = eventWidget;
                if (DE.dragWidget->auxData &&
                        DE.dragWidget->auxData->wEdit.marked) {
                        /* will drag selected set as a group */
                    for(ix = 0; ix < DE.selectedSetSize; ix++) {
                        getWidgetSize(DE.selectedSet[ix],
                                &DE.selsetOrigSizes[ix], TRUE);
                    }
                }
            }
            break;
        case ButtonRelease:
            if (event->xbutton.button != Button1)
                break;     /* widgets are interested in button1 only */
            
            if (!isStroke(&tpt, &DE.startpt, &strokeStart)) {
                if (DE.possibleDblPick) {
                        /* double pick */
                        /* open wtype-specific atts dlg */
                    deOpenAttsDlg(w);
                }
                else if (DE.possiblePick) {
                        /* single pick */
                    deDoSinglePick(w, &event->xbutton);
                }
            }
            else if (DE.dragWidget) {
                enum wEditType edit;
                    /* end of mouse move or resize */
                AXWidget w = topWidget(DE.dragWidget);
                if (DE.stretching) {
                    edit = wResize;
                }
                else {
                    edit = wMove;
                }
                if (DE.prefs.ghost) {
                        /* reset last-ghost rect info */
                    deGhostDisplayWidget(&w, 1, FALSE); /* lift ghosts */
                    TaskFree(0, (char *) DE.lastGhost);
                    DE.lastGhost = (r32 *) NULL;
                }
                if (DE.dragWidget->auxData &&
                        DE.dragWidget->auxData->wEdit.marked) {
                        /* edit perfomed on selected set; send
                         * update info to affected dialogs
                         */
                    deSendUpdateForSelected(edit, (data_ptr)0);
                }
                else {
                        /* moved or resized just this widget
                         */
                    deSendUpdate((AXWidget)w->parent->parent, &w, 1, edit, (data_ptr)0);
                }
                    /* display in new state. though elf will soon
                     * echo, display here for quicker visual effect
                     */
                DE.dragWidget = (AXWidget) NULL;  /* force non-ghost */
                if (w->auxData && w->auxData->wEdit.marked) {
                    displayWidget(DE.selectedSet, DE.selectedSetSize, TRUE);
                }
                else {
                    displayWidget(&w, 1, TRUE);
                }
                deFlushWidgetUpdates();
            }
            DE.lastReleaseTime = event->xbutton.time;
            DE.possiblePick = DE.possibleDblPick = FALSE;
            DE.dragWidget = (AXWidget) NULL;
            DE.stretching = FALSE;
            break;
        case MotionNotify:
            if (!(event->xmotion.state & Button1Mask))
                break;   /* interested only if button1 down */
            if (w == topWidget(DE.dragWidget)) {

                if ( isStroke(&tpt, &DE.startpt, &strokeStart)) {
                    if (strokeStart) {
                        /* first motion notify of move/resize
                         */
                        if (DE.prefs.ghost) {
                            /* lift real display and replace with
                             * ghost-style
                             */
                            AXWidget wtmp;
                            if (DE.dragWidget->auxData &&
                                DE.dragWidget->auxData->wEdit.marked) {
                                liftWidgetList(DE.selectedSet,
                                               DE.selectedSetSize);
                                for (ix = 0; ix < DE.selectedSetSize; ix++) {
                                    wtmp = DE.selectedSet[ix];
                                    if ((W_RECT == wtmp->type) &&
                                        (RECT_LAYERED == wtmp->style)) {
                                        
                                        deTabctlLiftContainees((AXWidget_rect)wtmp);
                                    }
                                }
                            }
                            else {
                                liftWidget(w);
                                if ((W_RECT == w->type) &&
                                    (RECT_LAYERED == w->style)) {
                                    
                                    deTabctlLiftContainees((AXWidget_rect)w);
                                }
                            }
                            
                            /* init last-ghost rect info
                             */
                            if (w->auxData &&
                                w->auxData->wEdit.marked) {
                                tmp = DE.selectedSetSize *
                                    sizeof(r32);
                            }
                            else {
                                tmp = sizeof(r32);
                            }
                            DE.lastGhost = (r32 *) TaskAlloc(0, tmp);
                            memset((char *) DE.lastGhost, 0, tmp);
                            deGhostDisplayWidget(&w, 1, TRUE);
                        }
                    }
                    DE.possiblePick = DE.possibleDblPick = FALSE;
                }
                else
                    break;  /* not enough motion, so drop event */

                if (DE.dragWidget->auxData &&
                        DE.dragWidget->auxData->wEdit.marked) {
                    for (ix = 0; ix < DE.selectedSetSize; ix++) {
                        preEdit(DE.selectedSet[ix]);
                    }
                }
                else {
                    preEdit(w);
                }
                tpt.x -= DE.dragpt.x;
                tpt.y -= DE.dragpt.y;
                if (DE.stretching) {
                        /* (possibly) resize the widget */
                    if (DE.dragWidget->auxData &&
                            DE.dragWidget->auxData->wEdit.marked) {
                        p32 tmp;
                            /* resize the lot by applying the stretch handle
                             * displacement to the selected set */
                        getHandleOffset(w, &DE.origSize,
                                DE.stretchHandle, &displ);
                        displ.x += DE.origSize.origin.x;
                        displ.y += DE.origSize.origin.y;
                        displ.x = tpt.x - displ.x;
                        displ.y = tpt.y - displ.y;
                        for(ix = 0; ix < DE.selectedSetSize; ix++) {
                            getHandleOffset(w, &DE.selsetOrigSizes[ix],
                                DE.stretchHandle, &tmp);
                            tpt.x = DE.selsetOrigSizes[ix].origin.x +
                                        tmp.x + displ.x;
                            tpt.y = DE.selsetOrigSizes[ix].origin.y +
                                        tmp.y + displ.y;
                            resizeByHandle(DE.selectedSet[ix],
                                DE.stretchHandle, &tpt,
                                &DE.selsetOrigSizes[ix]);
                        }
                    }
                    else {
                        resizeByHandle(w, DE.stretchHandle, &tpt,
                                       &DE.origSize);
                    }
                }
                else {
                        /* move the widget */
                    if (DE.dragWidget->auxData &&
                            DE.dragWidget->auxData->wEdit.marked) {
                            /* move the lot by applying the position
                             * displacement to the selected set */
                        getWidgetSize(w, &trect, TRUE); /* current size */
                        displ.x = tpt.x - trect.origin.x;
                        displ.y = tpt.y - trect.origin.y;
                        for(ix = 0; ix < DE.selectedSetSize; ix++) {
                            getWidgetSize(DE.selectedSet[ix], &trect, TRUE);
                            tpt.x = trect.origin.x + displ.x;
                            tpt.y = trect.origin.y + displ.y;
                            setWidgetPosition(DE.selectedSet[ix], &tpt);
                        }
                    }
                    else {
                        setWidgetPosition(w, &tpt);
                    }
                }
                    /* display in new state */
                if (DE.dragWidget->auxData &&
                        DE.dragWidget->auxData->wEdit.marked) {
                    
                    displayWidget(DE.selectedSet, DE.selectedSetSize, TRUE);
                }
                else {
                    displayWidget(&w, 1, TRUE);
                }
            }
            break;
        case Expose:
            doRefresh((AXWidget_dialog)w, &event->xexpose);
            break;
    }
}

    /* expected event set: KeyPress, KeyRelease, ButtonPress,
     * ButtonRelease, MotionNotify */
static AXWidget     /* return NULL or gadget handle */
dlgFindGadget(dlg, event)
AXWidget_dialog dlg;
XEvent *event;
{
    AXWidget tw;
    p32 pt;
    int onHandle;
    enum handleType whichHandle;

    if (!dlg || !event)
        return (AXWidget) NULL;
    if (DE.newWidget.doCreate) {
        return (AXWidget) NULL;
    }
    if (DE.dragSelecting) {
        return (AXWidget) NULL;
    }
    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
        
    if ((event->type == MotionNotify ||
         event->type == ButtonRelease) && DE.dragWidget)
        return DE.dragWidget;
    if (event->type == KeyPress || event->type == KeyRelease) {
        /* the 'focus' gadget is chosen on the basis of
         * whether it has text under edit.  There should only
         * be one such gadget at a time */ 
        if (DE.textEditWidget) {
            for (tw = ((AXWidget_main)dlg)->widgets; tw;
                 tw = tw->nextChild) {
                if (tw == DE.textEditWidget)
                    return tw;
            }
        }
    }
    else {
        int x, y;
        wLayer *ly, *initly, **listHead;

        /* choice based on pointer vs. gadget position */
        if (event->type == MotionNotify) {
            x = event->xmotion.x;
            y = event->xmotion.y;
        }
        else {
            x = event->xbutton.x;
            y = event->xbutton.y;
        }
        listHead = layerListHead(dlg);

        if (listHead == (wLayer**)NULL)
            return (AXWidget)NULL; 
    
        /* find list tail, which represents frontmost widget */
        for (ly = *listHead; ly; ly = ly->next) {
            if (!ly->next)
                break;
        }
        initly = ly; /* remember in case re-search is needed */

        /* find frontmost containing widget */
        for ( ; ly; ly = ly->prev) {
            tw = ly->w;
            if (tw->type == W_ALIGN && tw->style == ALIGN_GRID)
                continue; /* grids don't do events */
            if (!tw->display) {
                if (!tw->auxData || !tw->auxData->wEdit.marked)
                    continue; /* invisible w's sensitive only if selected */
            }
            pt.x = x;
            pt.y = y;
            if (pointInsideWidget(&pt, tw, &onHandle, &whichHandle)) {
                if (tw->auxData && tw->auxData->wEdit.marked)
                    return tw;
            }

#if 0  /* for double-click-to-pop-open-option stuff */
            if (tw->type == W_OPTION && tw->window) {
                AXWidget_option ow;
                /* the pulldown is open; check it, also */
                ow = (AXWidget_option)tw;
                if (x > ow->pulldown_xpos &&
                    x < (ow->pulldown_xpos + ow->pulldown_width) &&
                    y > ow->pulldown_ypos &&
                    y < (ow->pulldown_ypos + ow->pulldown_height))
                        return tw;
            }
#endif

        }

        /* the above search required that the widget be selected;
           that failed, so re-do without the restriction */
        for (ly = initly; ly; ly = ly->prev) {
            tw = ly->w;
            if (tw->type == W_ALIGN && tw->style == ALIGN_GRID)
                continue; /* grids don't do events */
            if (!tw->display) {
                if (!tw->auxData || !tw->auxData->wEdit.marked)
                    continue;
            }
            pt.x = x;
            pt.y = y;
            if (pointInsideWidget(&pt, tw, &onHandle,
                                  &whichHandle)) {
                return tw;
            }
        }
    }
    return (AXWidget) NULL;
}

static void
initFakeExpose()
{
        /* init this to describe a full expose */
    DE.fakeExpose.type = Expose;
    DE.fakeExpose.serial = 0;
    DE.fakeExpose.send_event = 0;
    DE.fakeExpose.display = Dpy;
    DE.fakeExpose.window = 0; /* this one does have to be plugged in */
    DE.fakeExpose.x = DE.fakeExpose.y = 0;
    DE.fakeExpose.width = DE.fakeExpose.height = 100000;
    DE.fakeExpose.count = 0;
}

static void
setFakeExpose(win, rect)
Drawable win;
r32 *rect;
{
    if (!rect) {
        initFakeExpose();
        DE.fakeExpose.window = win;
        return;
    }
    DE.fakeExpose.window = win;
    DE.fakeExpose.x = rect->origin.x;
    DE.fakeExpose.y = rect->origin.y;
    DE.fakeExpose.width = rect->width;
    DE.fakeExpose.height = rect->height;
}


static void
deInitGCs()
{
    unsigned long mask;
    XGCValues gcv;
    char dashes[4];
    PIXEL_VALUE ptmp;

    DE.alignGC = ShadowGC;

    mask = GCFunction | GCPlaneMask | GCForeground | GCBackground;
    gcv.function = GXcopy;
    gcv.plane_mask = AllPlanes;
    gcv.foreground = AllPlanes;
    gcv.background = ~AllPlanes;
    DE.borderGC = axCreateGC(Dpy, AxTopWinNeverMapped, DefaultScreen(Dpy),
                             DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                             (XFontStruct *) 0, mask, &gcv);
    XCopyGC(Dpy, DE.alignGC, mask, DE.borderGC); /* we want ShadowGC's fpix */
    XSetLineAttributes(Dpy, DE.borderGC, 0, LineDoubleDash, CapButt,
                       JoinMiter);
    dashes[0] = 1;
    dashes[1] = dashes[2] = dashes[3] = 0;
    XSetDashes(Dpy, DE.borderGC, 0, dashes, 1);

    gcv.function = GXxor;
    gcv.plane_mask = AllPlanes;
    ptmp = BlackPixel(Dpy, DefaultScreen(Dpy));
    gcv.foreground = AXGetForegroundPixel(Dpy, ForeGC) ^ ptmp;
    gcv.background = AXGetForegroundPixel(Dpy, BackGC) ^ ptmp;
    DE.rubberGC = axCreateGC(Dpy, AxTopWinNeverMapped, DefaultScreen(Dpy),
                             DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                             (XFontStruct *) 0, mask, &gcv);
    XSetLineAttributes(Dpy, DE.rubberGC, 0, LineDoubleDash, CapButt,
                       JoinMiter);
    dashes[0] = 4;
    dashes[1] = 4;
    XSetDashes(Dpy, DE.rubberGC, 0, dashes, 2);
    
    gcv.function = GXxor;
    gcv.plane_mask = AllPlanes;
    ptmp = BlackPixel(Dpy, DefaultScreen(Dpy));
    gcv.foreground = AXGetForegroundPixel(Dpy, ForeGC) ^ ptmp;
    gcv.background = AXGetForegroundPixel(Dpy, BackGC) ^ ptmp;
    DE.ghostGC = axCreateGC(Dpy, AxTopWinNeverMapped, DefaultScreen(Dpy),
                            DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                            (XFontStruct *) 0, mask, &gcv);
    XSetLineAttributes(Dpy, DE.ghostGC, 0, LineDoubleDash, CapButt,
                       JoinMiter);
    dashes[0] = 1;
    dashes[1] = 1;
    XSetDashes(Dpy, DE.ghostGC, 0, dashes, 2);
    
    XSync(Dpy, 0);
}

int
deInitDlgEdit(dlg)
AXWidget_dialog dlg; /* to be edited */
{
    if (!DE.init) {
        deInitGCs();
        initFakeExpose();
        deInitTypeTable();
        deInitColorTable();
        DE.init = TRUE;
    }
    deInitPrefs();
    if (!dlg)
        return FALSE;

    /* add the dlg handle to the edit global DE
     */
    if (!DE.dialogs) {
        DE.dialogs = (de_dialog *) TaskAlloc(0, sizeof(de_dialog));
        memset((void *) &DE.dialogs[0], 0, sizeof(de_dialog));
        DE.dialogs[0].dlg = (AXWidget) dlg;
        DE.numDlgs = 1;
    }
    else {
        DE.numDlgs++;
        DE.dialogs = (de_dialog *) TaskRealloc(0, (char *) DE.dialogs,
            DE.numDlgs * sizeof(de_dialog));
        memset((void *) &DE.dialogs[DE.numDlgs - 1], 0, sizeof(de_dialog));
        DE.dialogs[DE.numDlgs - 1].dlg = (AXWidget) dlg;
    }

    /* init DE_SEND_UPDATE message accumulator for this dialog
     */
    axhInitTable(&DE.dialogs[DE.numDlgs - 1].widgetUpdates, 7,
                 deNewWidgetUpdater, deFreeWidgetUpdater);
    
    if (DE.prefs.grid) {
        /* turn on grid for this dialog
         */
        if (!(DE.dialogs[DE.numDlgs - 1].dlg)->auxData) {
            (DE.dialogs[DE.numDlgs - 1].dlg)->auxData = newAuxData();
        }
        (DE.dialogs[DE.numDlgs - 1].dlg)->auxData->wEdit.gridWidget =
                        deXmCreateAlign(dlg, ALIGN_GRID, (r32 *) NULL);
    }
    deSendUpdatePoke(DE_OPEN_EDIT_SESSION, FALSE);
    return TRUE;
}

    /* end editing on a particular dialog */
int
deCloseDlgEdit(dlg)
AXWidget_dialog dlg;
{
    int ix, jx;
    int foundDlg = FALSE;

    if (!dlg)
        return FALSE;

    /* remove the dlg handle from DE's data
     */
    for (ix = 0; ix < DE.numDlgs; ix++) {
        if (DE.dialogs[ix].dlg == (AXWidget) dlg) {
            foundDlg = TRUE;
            if (DE.dialogs[ix].widgetUpdates.width) {
                /* free up DE_SEND_UPDATE message accumulator for this dlg
                 */
                axhDeleteTable(&DE.dialogs[ix].widgetUpdates, (void *) 0);
            }
            for (jx = ix; jx < DE.numDlgs - 1; jx++) {
                DE.dialogs[jx] = DE.dialogs[jx + 1];
            }
            DE.numDlgs--;
            if (DE.numDlgs) {
                DE.dialogs = (de_dialog *)
                    TaskRealloc(0, (char *) DE.dialogs,
                                DE.numDlgs * sizeof (de_dialog));
            }
            else if (DE.dialogs) {
                TaskFree(0, (char *) DE.dialogs);
                DE.dialogs = (de_dialog *) NULL;
            }
            if (DE.newWidget.whichDialog == dlg) {
                if (DE.newWidget.wInfo) {
                    int me = THIMpid;
                    VfyContext((int) dlg->taskOwner);
                    AxFreeData(DE.newWidget.wInfo);
                    DE.newWidget.wInfo = (data_ptr) NULL;
                    VfyContext(me);
                }
                DE.newWidget.wType = 0;
            }
        }
    }
    if (!foundDlg) {
        return FALSE;
    }
        /* remove any members of the selected set that belong
         * to this dialog; do this by copying */
    for (ix = 0, jx = 0; ix < DE.selectedSetSize; ix++) {
        if (DE.selectedSet[ix] &&
            ((AXWidget_dialog)(DE.selectedSet[ix])->parent) == dlg)
            jx++;
    }
    if (DE.selectedSetSize - jx > 0) {
        AXWidget *newSet;
        int kx;
        newSet = (AXWidget*) TaskAlloc(0, (DE.selectedSetSize - jx) *
                                       sizeof (AXWidget));
        for (ix = 0, kx = 0; ix < DE.selectedSetSize; ix++) {
            if (DE.selectedSet[ix] &&
                ((AXWidget_dialog)(DE.selectedSet[ix])->parent) != dlg)
                newSet[kx++] = DE.selectedSet[ix]; 
        }
        TaskFree(0, (char *) DE.selectedSet);
        DE.selectedSet = newSet;
        DE.selectedSetSize -= jx;
        DE.selsetOrigSizes = (r32 *) TaskRealloc
            (0, DE.selsetOrigSizes, DE.selectedSetSize * sizeof(r32));
    }
    else {
        if (DE.selectedSet)
            TaskFree(0, (char *) DE.selectedSet);
        if (DE.selsetOrigSizes)
            TaskFree(0, (char *) DE.selsetOrigSizes);
        DE.selectedSet = (AXWidget*) NULL;
        DE.selsetOrigSizes = (r32 *) NULL;
        DE.selectedSetSize = 0;
    }

    return TRUE;
}


static void
deCloseEditSession(dlg, info)
AXWidget_dialog dlg;
data_ptr info;
{
    Arg args[2];
    wComposite *tc;
    AXWidget tw, nextChild;
    data_ptr pokeCodes;
    int save;
    
    if (!dlg)
        return;
    
    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
    
        /* restore user's poke codes
         */
    pokeCodes = AxArrayFromArray(info, 1);
    XtSetArg(args[0], XmNpokeCodes, pokeCodes);
    AxXtSetValues((AXWidget)dlg, args, 1);
    
        /* remove edit-only stuff from screen
         */
    dlgLiftAllMarks(dlg);
    if (dlg->auxData && dlg->auxData->wEdit.gridWidget) {
        liftWidget(dlg->auxData->wEdit.gridWidget);
        AxXtDestroyWidget(dlg->auxData->wEdit.gridWidget);
    }
    save = DE.prefs.borders;
    DE.prefs.borders = FALSE;
    doRefresh(dlg, (XExposeEvent *) NULL);
    DE.prefs.borders = save;
    
        /* remove dialog from list of those under edit
         */
    deCloseDlgEdit(dlg);
    
        /* remove edit-only resources from dlg and kids
         */
    dlg->flags &= ~WFLG_IN_EDIT;
    xmRemoveAllEventHandlers((AXWidget)dlg); /* rude, if user wanted event handlers */
    if (dlg->auxData) {
        tc = dlg->auxData->compositeList; /* have to save this if present */
        dlg->auxData->compositeList = (wComposite *) NULL;
        removeAuxData((AXWidget)dlg);
        dlg->auxData = newAuxData();
        dlg->auxData->compositeList = tc;
    }
    for (tw = ((AXWidget_main)dlg)->widgets; tw; tw = nextChild) {
        nextChild = tw->nextChild;
        tw->flags &= ~WFLG_IN_EDIT;
        if (tw->auxData) {
            tc = tw->auxData->compositeList;
            tw->auxData->compositeList = (wComposite *) NULL;
            removeAuxData(tw);
            tw->auxData = newAuxData();
            tw->auxData->compositeList = tc;
        }
        deFreePixmap(tw);
        xmRemoveAllEventHandlers(tw);
    }
    if (DE.newWidget.wWidget &&
        ((AXWidget)(DE.newWidget.wWidget)->parent) == (AXWidget)dlg)
    {
            /* the user has invoked one of the create-widget commands,
             * but has not done a pick or stroke to complete the creation;
             * remove the DE references to this almost-widget
             */
        DE.newWidget.wWidget = (AXWidget) NULL;
        if (DE.newWidget.wInfo) {
                /* remove the widget's gadget array, too
                 */
            int me = THIMpid;
            VfyContext((int) dlg->taskOwner);
            AxFreeData(DE.newWidget.wInfo);
            DE.newWidget.wInfo = (data_ptr) NULL;
            VfyContext(me);
        }
            /* reset the rest of DE stuff pertaining to this widget
             */
        DE.newWidget.doCreate = FALSE;
        DE.stretching = FALSE;
        DE.dragWidget = (AXWidget) NULL;
    }
    deSendUpdatePoke(DE_CLOSE_EDIT_SESSION, FALSE);
}

    /* start up dialog editing on already-posted dialog */
static void
deOpenEditSession(dlg, info)
AXWidget_dialog dlg;
data_ptr info;
{
    int dlgEventMask, widgetEventMask;
    mbchar *dlgEventProcName, *widgetEventProcName;
    data_ptr pokeCodes;
    Arg args[2];
    AXWidget tw, nextChild;
    if (!dlg || !info)
        return;

    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;     
        
    deInitDlgEdit(dlg);

    dlgEventMask = AxIntFromArray(info, 2);
    dlgEventProcName = AxStrPtrFromArray(info, 3);
    widgetEventMask = AxIntFromArray(info, 4);
    widgetEventProcName = AxStrPtrFromArray(info, 5);
        /* put in-edit event handlers onto dialog and kids */
    InsertEventHandler((AXWidget)dlg, (unsigned long) dlgEventMask,
            FALSE, dlgEventProcName, (char *) NULL, 0);
    dlg->flags |= WFLG_IN_EDIT;
    for (tw = ((AXWidget_main)dlg)->widgets; tw; tw = nextChild) {
        nextChild = tw->nextChild;
        tw->flags |= WFLG_IN_EDIT;
        InsertEventHandler(tw, (unsigned long) widgetEventMask,
                FALSE, widgetEventProcName, (char *) NULL, 0);
        if (tw->window) {
            XDestroyWindow(Dpy, tw->window); /* will become pixmap in edit */
            tw->window = 0;
        }
        if (tw->type == W_SCROLL) {
            xmDestroyScrollPixmap((AXWidget_scroll)tw);
        }
        else if (tw->type == W_LIST) {
            xmDestroyListPixmap((AXWidget_list)tw);
        }
    }

    pokeCodes = AxArrayFromArray(info, 6);  /* edit-session pokecodes */
    XtSetArg(args[0], XmNpokeCodes, pokeCodes);
    AxXtSetValues((AXWidget)dlg, args, 1);
        /* force full repaint to get edit-mode widgets fully constructed */
    doRefresh(dlg, (XExposeEvent *) NULL);
}

static void
deInitPrefs()
{
    char *prefval;
    memset((char *) &DE.prefs, 0, sizeof(wPrefs));
        /* currently 5 defined: deGrids, deGridSnap, deGridSize,
         * deBorders, deGhostMove */
    prefval = GetProfileByStr(NXLT("deGrids"));
    if (prefval && prefval[0]) {
        if (strncmp(prefval, "-1", 2) == 0) {
            DE.prefs.grid = TRUE;
        }
        else {
            DE.prefs.grid = FALSE;
        }
    }
    else {
        DE.prefs.grid = TRUE;  /* default to on if no profile info */
        ElfbAddProfile(NXLT("deGrids"), "-1");
    }

    prefval = GetProfileByStr(NXLT("deGridSnap"));
    if (prefval && prefval[0]) {
        if (strncmp(prefval, "-1", 2) == 0) {
            DE.prefs.snapToGrid = TRUE;
        }
        else {
            DE.prefs.snapToGrid = FALSE;
        }
    }
    else {
        DE.prefs.snapToGrid = FALSE;
        ElfbAddProfile(NXLT("deGridSnap"), "0");
    }

    prefval = GetProfileByStr(NXLT("deGridSize"));
    if (prefval && prefval[0]) {
        DE.prefs.gridsize = atoi(prefval);
        if (DE.prefs.gridsize < 3)
            DE.prefs.gridsize = 3;
    }
    else {
        DE.prefs.gridsize = 10;
        ElfbAddProfile(NXLT("deGridSize"), "10");
    }
    if (DE.prefs.grid && !DE.prefs.gridsize) {
        DE.prefs.gridsize = 10;
        ElfbAddProfile(NXLT("deGridSize"), "10");
    }

    prefval = GetProfileByStr(NXLT("deBorders"));
    if (prefval && prefval[0]) {
        if (strncmp(prefval, "-1", 2) == 0) {
            DE.prefs.borders = TRUE;
        }
        else {
            DE.prefs.borders = FALSE;
        }
    }
    else {
        DE.prefs.borders = FALSE;
        ElfbAddProfile(NXLT("deBorders"), "0");
    }

    prefval = GetProfileByStr(NXLT("deGhostMove"));
    if (ScratchMap) {
        if (prefval && prefval[0]) {
            if (strncmp(prefval, "-1", 2) == 0) {
                DE.prefs.ghost = TRUE;
            }
            else {
                DE.prefs.ghost = FALSE;
            }
        }
        else {
            DE.prefs.ghost = FALSE;
            ElfbAddProfile(NXLT("deGhostMove"), "0");
        }
    }
    else {
            /* force ghost move/resize if no scratchmap */
        DE.prefs.ghost = TRUE;
    }
}

int
dePaintWidget(w)
AXWidget w;
{
    AXWidget topw = topWidget(w);
    
    if (topw == w) {
        displayWidget(&w, 1, TRUE);
    }
    return TRUE;
}

static void
displayWidget(wList, numWidgets, showHandles)
AXWidget *wList;
int numWidgets;
int showHandles; /* that is, draw handles if they're on */
{
    int ix;
    AXWidget tw;
    
    if (!wList) {
        return;
    }
    if (DE.dragWidget && DE.prefs.ghost &&
        !(DE.possiblePick || DE.possibleDblPick)) {
            /* doing a move or resize, ghost-style */
        deGhostDisplayWidget(wList, numWidgets, TRUE);
    }
    else {
        if (ScratchMap) {
            pixDisplayWidget(wList, numWidgets, showHandles);
        }
        else {
            directDisplayWidget(wList, numWidgets, showHandles);
        }
    }
    for (ix = 0; ix < numWidgets; ix++) {
        tw = wList[ix];
        if (tw && tw->auxData && tw->auxData->wEdit.old) {
            destroyCloneWidget(tw->auxData->wEdit.old);
            tw->auxData->wEdit.old = (AXWidget) NULL;
        }
    }
}

static void
deGhostDisplayWidget(wList, numWidgets, drawNew)
AXWidget *wList;
int numWidgets;
int drawNew;    /* bool: FALSE means just lift old */
{
    r32 rect, totalRect;
    int ix;
    
    if (!numWidgets || !wList || !wList[0])
        return;
    
    if (!DE.lastGhost)
        return;

    totalRect.width = 0;
    for (ix = 0; ix < numWidgets; ix++) {
        if (wList[ix]) {
            getWidgetSize(wList[ix], &rect, FALSE);
            if (!totalRect.width) {
                totalRect = rect;
            }
            else {
                unionRectangle(&rect, &totalRect, &totalRect);
            }
        }
    }
    
    if (DE.lastGhost[0].width) {
        XDrawRectangle(Dpy, wList[0]->parent->window, DE.ghostGC,
                       DE.lastGhost[0].origin.x,
                       DE.lastGhost[0].origin.y,
                       (unsigned int) DE.lastGhost[0].width,
                       (unsigned int) DE.lastGhost[0].height);
    }
    if (drawNew && totalRect.width) {
        /* new ghost size/pos
         */
        XDrawRectangle(Dpy, wList[0]->parent->window, DE.ghostGC,
                       totalRect.origin.x, totalRect.origin.y,
                       (unsigned int) totalRect.width,
                       (unsigned int) totalRect.height);
        DE.lastGhost[0] = totalRect;
    }
    else {
        DE.lastGhost[0].width = 0;
    }
}

static void
directDisplayWidget(wList, numWidgets, showHandles)
AXWidget *wList;
int numWidgets;
int showHandles; /* draw handles if widget is marked */
{
    wLayer *ly, **listHead;
    r32 damageRect, trect;
    AXWidget tw;
    int ix;
    int drewGrid = FALSE;
    
    if (!numWidgets || !wList || !wList[0])
        return;
    
    listHead = layerListHead((AXWidget_dialog)wList[0]->parent);
    
    if (!listHead)
        return;

    /* init rect bounding all lifts
     */
    damageRect.width = 0;
    for (ix = 0; ix < numWidgets; ix++) {
        if (wList[ix]) {
            tw = wList[ix];
            if (tw->auxData && tw->auxData->wEdit.old) {
                getWidgetSize(tw->auxData->wEdit.old, &trect, TRUE);
                if (damageRect.width) {
                    unionRectangle(&trect, &damageRect, &damageRect);
                }
                else {
                    damageRect = trect;
                }
            }
        }
    }

    if (damageRect.width) {
        /* do the lift
         */
        XFillRectangle(Dpy, wList[0]->parent->window, BackGC,
                       damageRect.origin.x, damageRect.origin.y,
                       (unsigned int) damageRect.width,
                       (unsigned int) damageRect.height);
    }
    
    /* enlarge damageRect as needed to contain the new widget extents
     */
    for (ix = 0; ix < numWidgets; ix++) {
        if (wList[ix]) {
            tw = wList[ix];
            getWidgetSize(tw, &trect, TRUE);
            if (damageRect.width) {
                unionRectangle(&trect, &damageRect, &damageRect);
            }
            else {
                damageRect = trect;
            }
        }
    }

    if (damageRect.width) {
        /* now display all that intersects with damage.  Note there's
         * no clipping, so the damage can funnel outward during this...
         */
        setFakeExpose(wList[0]->parent->window, &damageRect);
        for (ly = *listHead; ly; ly = ly->next) {
            if (ly->w && widgetOnScreen(ly->w)) {
                getWidgetSize(ly->w, &trect, TRUE);
                if (widgetIntersectsUpdateRect(ly->w, &damageRect)) {
                
                    paintWidget(ly->w, &DE.fakeExpose);

                    if (ly->w->type != W_ALIGN) {
                        /* the damage may just have grown, update damageRect
                         */
                        unionRectangle(&trect, &damageRect, &damageRect);
                        setFakeExpose(wList[0]->parent->window, &damageRect);
                    }
                }
            }
        }
    }
    
    if (showHandles) {
        drawHandles(listHead, (AXWidget*)NULL, 0);
    }
}

static void
pixDisplayWidget(wList, numWidgets, showHandles)
AXWidget *wList;
int numWidgets;
int showHandles; /* draw handles if widget is marked */
{
    wLayer *ly, **listHead;
    r32 updateRect, trect, thisRect;
    AXWidget tw;
    Drawable savedDraw;
    int ix, includeOld;
#if AXMS
    HDC tmp_dc;
    HBITMAP old_hbm;
#endif
    
    if (!numWidgets || !wList || !wList[0])
        return;

    listHead = layerListHead((AXWidget_dialog)wList[0]->parent);
    
    if (!listHead)
        return;
    
    savedDraw = wList[0]->parent->window;
#if AXMS
    if ( ScratchMapDrawable == (HDC)NULL )
        {
        tmp_dc = MS_CreateCompatibleDC(NULL);
        old_hbm = MS_SelectObject(tmp_dc, ScratchMap);
        ScratchMapDrawable = AxPackageHandle(tmp_dc, AX_MEMDC_TYPE);
        }
#else
    ScratchMapDrawable = ScratchMap;
#endif
    wList[0]->parent->window = ScratchMapDrawable;

        /* init the update rect
         */
    updateRect.width = 0;
    for (ix = 0; ix < numWidgets; ix++) {
        if (wList[ix]) {
            tw = wList[ix];
            if (tw->auxData && tw->auxData->wEdit.old) {
                tw->auxData->wEdit.old->parent->window = ScratchMapDrawable;
                getWidgetSize(tw->auxData->wEdit.old, &thisRect, TRUE);
                includeOld = TRUE;
            }
            else {
                includeOld = FALSE;
            }
            if (includeOld) {
                getWidgetSize(tw, &trect, TRUE);
                unionRectangle(&trect, &thisRect, &thisRect);
            }
            else {
                getWidgetSize(tw, &thisRect, TRUE);
            }
            if (!updateRect.width) {
                updateRect = thisRect;
            }
            else {
                unionRectangle(&thisRect, &updateRect, &updateRect);
            }
        }
    }
    
    setFakeExpose(wList[0]->parent->window, &updateRect);

    if (updateRect.width) {
        /* fudge updateRect outward a bit, and init ScratchMap
         */
        updateRect.origin.x -= 2;
        updateRect.origin.y -= 2;
        updateRect.width += 4;
        updateRect.height += 4;
        XFillRectangle(Dpy, ScratchMapDrawable, BackGC, updateRect.origin.x,
                       updateRect.origin.y, updateRect.width,
                       updateRect.height);

        /* reshoot all that intersect updateRect
         */
        for (ly = *listHead; ly; ly = ly->next) {
            getWidgetSize(ly->w, &trect, TRUE);
            if (widgetOnScreen(ly->w) &&
                widgetIntersectsUpdateRect(ly->w, &updateRect)) {
                
                paintWidget(ly->w, (XExposeEvent *) NULL);
            }
        }
    }
    if (showHandles)
        drawHandles(listHead, (AXWidget*)NULL, 0);

    if (updateRect.width) {
        /* go to screen
         */
        XCopyArea(Dpy, wList[0]->parent->window, savedDraw, ForeGC,
                  updateRect.origin.x, updateRect.origin.y, updateRect.width,
                  updateRect.height, updateRect.origin.x, updateRect.origin.y);
    }

#if AXMS
    MS_SelectObject(tmp_dc, old_hbm);
    MS_DeleteDC(tmp_dc);
    REMOVE_DRAWABLE(ScratchMapDrawable);
    ScratchMapDrawable = (HDC)NULL;
#endif

    wList[0]->parent->window = savedDraw;

    initFakeExpose();
}

static void
liftWidget(w)
AXWidget w;
{
    if (!w)
        return;
    if (ScratchMap) {
        pixLiftWidgetList(&w, 1);
    }
    else {
        directLiftWidgetList(&w, 1);
    }
}

static void
liftWidgetList(w, numWidgets)
AXWidget *w;      /* in: array of widget handles */
int numWidgets;   /* in: size of array */
{
    if (DE.numDlgs > 1 && numWidgets > 1) {
            /* it's possible that the widgets list spans
               dialogs..  so, partition the list according
               do parent dialog */
        int numLists, *numKids, ix, jx, tmp;
        AXWidget **lists;

        numLists = 0;
        jx = DE.numDlgs * sizeof(AXWidget);
        lists = (AXWidget **) TaskAlloc(0, jx);
        memset((char *) lists, 0, jx);

        jx = DE.numDlgs * sizeof(int);
        numKids = (int *) TaskAlloc(0, jx);
        memset((char *) numKids, 0, jx);

        for (ix = 0; ix < DE.numDlgs; ix++) {
            for (jx = 0; jx < numWidgets; jx++) {
                if (((AXWidget)(w[jx])->parent) == DE.dialogs[ix].dlg) {
                    
                    if (!lists[ix]) {
                        lists[ix] = (AXWidget *) TaskAlloc
                            (0, sizeof(AXWidget));
                        lists[ix][0] = w[jx];
                        numKids[ix] = 1;
                    }
                    else {
                        tmp = numKids[ix];
                        lists[ix] = (AXWidget *) TaskRealloc
                            (0, lists[ix], (tmp + 1) * sizeof(AXWidget));
                        lists[ix][tmp] = w[jx];
                        (numKids[ix])++;
                    }
                }
            }
        }
            /* do the lifts per-partition */
        for (ix = 0; ix < DE.numDlgs; ix++) {
            if (lists[ix]) {
                if (ScratchMap) {
                    pixLiftWidgetList(lists[ix], numKids[ix]);
                }
                else {
                    directLiftWidgetList(lists[ix], numKids[ix]);
                }
                TaskFree(0, (char *) lists[ix]);
            }
        }
        TaskFree(0, (char *) numKids);
        TaskFree(0, (char *) lists);
    }
    else {
        if (ScratchMap) {
            pixLiftWidgetList(w, numWidgets);
        }
        else {
            directLiftWidgetList(w, numWidgets);
        }
    }
}

static void
pixLiftWidgetList(w, numWidgets)
AXWidget *w;
int numWidgets;
{
    wLayer *ly, **listHead;
    r32 updateRect, trect, trect2;
    Drawable savedDraw;
    int ix, onLiftList;
#if AXMS
    HDC tmp_dc;
    HBITMAP old_hbm;
#endif

    if (!w || !w[0])
        return;

    savedDraw = (w[0])->parent->window;
#if AXMS
    if ( ScratchMapDrawable == (HDC)NULL )
        {
        tmp_dc = MS_CreateCompatibleDC(NULL);
        old_hbm = MS_SelectObject(tmp_dc, ScratchMap);
        ScratchMapDrawable = AxPackageHandle(tmp_dc, AX_MEMDC_TYPE);
        }
#else
      ScratchMapDrawable = ScratchMap;
#endif
    (w[0])->parent->window = ScratchMapDrawable;

    listHead = layerListHead((AXWidget_dialog)(w[0])->parent);

        /* get the bounding area of the lift */
    getWidgetSize(w[0], &updateRect, TRUE);
    if (numWidgets > 1) {
        for (ix = 0; ix < numWidgets; ix++) {
            if (w[ix]) {
                trect = updateRect;
                getWidgetSize(w[ix], &trect2, TRUE);
                unionRectangle(&trect, &trect2, &updateRect);
            }
        }
    }
    setFakeExpose((w[0])->parent->window, &updateRect);
    XFillRectangle(Dpy, ScratchMapDrawable, BackGC, updateRect.origin.x,
            updateRect.origin.y, updateRect.width, updateRect.height);

        /* reshoot all that aren't on the lift-list and intersect */
    if ( listHead != (wLayer **)NULL ) {
       for (ly = *listHead; ly; ly = ly->next) {
           for (ix = 0, onLiftList = FALSE; ix < numWidgets; ix++) {
               if (ly->w == w[ix]) {
                   onLiftList = TRUE;
                   break;
               }
           }
           if (!onLiftList) {
               getWidgetSize(ly->w, &trect, TRUE);
               if (widgetOnScreen(ly->w) && 
                   widgetIntersectsUpdateRect(ly->w, &updateRect)) {
                   
                   paintWidget(ly->w, (XExposeEvent *) NULL);
               }
           }
       }
       drawHandles(listHead, w, numWidgets);
    }

        /* go to screen */
    (w[0])->parent->window = savedDraw;
    XCopyArea(Dpy, ScratchMapDrawable, (w[0])->parent->window, ForeGC,
            updateRect.origin.x, updateRect.origin.y, updateRect.width,
            updateRect.height, updateRect.origin.x, updateRect.origin.y);
    initFakeExpose();

#if AXMS
    MS_SelectObject(tmp_dc, old_hbm);
    MS_DeleteDC(tmp_dc);
    REMOVE_DRAWABLE(ScratchMapDrawable);
    ScratchMapDrawable = (HDC)NULL;
#endif
}

static void
directLiftWidgetList(w, numWidgets)
AXWidget *w;
int numWidgets;
{
    wLayer *ly, **listHead;
    r32 updateRect, trect, trect2;
    int ix, onLiftList;

    if (!w || !w[0])
        return;

    listHead = layerListHead((AXWidget_dialog)(w[0])->parent);

        /* lift the widgets, and get bounding area of lift */
    getWidgetSize(w[0], &updateRect, TRUE);
    if (numWidgets > 1) {
        for (ix = 0; ix < numWidgets; ix++) {
            if (w[ix]) {
                simpleLiftWidget(w[ix]);
                trect = updateRect;
                getWidgetSize(w[ix], &trect2, TRUE);
                unionRectangle(&trect, &trect2, &updateRect);
            }
        }
    }
    else {
        simpleLiftWidget(w[0]);
    }
    setFakeExpose((w[0])->parent->window, &updateRect);

        /* reshoot all that aren't on the lift-list, and intersect */
    for (ly = *listHead; ly; ly = ly->next) {
        for (ix = 0, onLiftList = FALSE; ix < numWidgets; ix++) {
            if (ly->w == w[ix]) {
                onLiftList = TRUE;
                break;
            }
        }
        if (!onLiftList) {
            getWidgetSize(ly->w, &trect, TRUE);
            if (widgetOnScreen(ly->w) && 
                widgetIntersectsUpdateRect(ly->w, &updateRect)) {
                
                paintWidget(ly->w, (XExposeEvent *) NULL);
                
                    /* accumulate bounder over total possible damage */
                if (ly->w->type != W_ALIGN) {
                    unionRectangle(&trect, &updateRect, &updateRect);
                    setFakeExpose((w[0])->parent->window, &updateRect);
                }
            }
        }
    }
    drawHandles(listHead, w, numWidgets);
    initFakeExpose();
}

static void
simpleLiftWidget(w)
AXWidget w;
{
    r32 r;

    getWidgetSize(w, &r, TRUE);
    XFillRectangle(Dpy, w->parent->window, BackGC,
        r.origin.x, r.origin.y,(unsigned int) r.width,
        (unsigned int) r.height);
}

/* : deTabctlLiftContainees - ghost-move utility
 * for starting the move on a tabcontrol widget.
 */
static void
deTabctlLiftContainees(rw)
AXWidget_rect rw;           /* in: tabcontrol-style W_RECT */
{
    int ix, cx, num_containees;
	long layer_ix;
    hitem *list;
    widglink *wl;
    AXWidget *containee_list;
    
    if (!(rw && rw->tabctl_linktab))
        return;

    /* first, count visible containees
     */
    for (num_containees = 0, ix = 0; ix < rw->tabctl_linktab->width; ix++) {
        list = rw->tabctl_linktab->table[ix];
        while (list) {
            wl = (widglink *) list->value;
            if (wl && wl->direction && (WIDGLINK_TABLAYER == wl->link_type)) {
                layer_ix = (long) wl->link_data;
                if (layer_ix == rw->tabctl.active_layer) {
                    num_containees++;
                }
            }
            list = list->next;
        }
    }
    
    if (!num_containees)
        return;
    
    /* repeat, this time to make a list of their handles
     */
    containee_list = (AXWidget *) malloc(num_containees * sizeof(AXWidget));
    for (cx = 0, ix = 0; ix < rw->tabctl_linktab->width; ix++) {
        list = rw->tabctl_linktab->table[ix];
        while (list) {
            wl = (widglink *) list->value;
            if (wl && wl->direction && (WIDGLINK_TABLAYER == wl->link_type)) {
                layer_ix = (long) wl->link_data;
                if (layer_ix == rw->tabctl.active_layer) {
                    containee_list[cx] = (AXWidget) wl->to;
                    cx++;
                }
            }
            list = list->next;
        }
    }
    
    liftWidgetList(containee_list, num_containees);
    
    free(containee_list);
}


static void
PaintAlign(w, exP, full_regen, layered)
AXWidget w;
XExposeEvent *exP;
int full_regen;
int layered;
{
    r32 rect;
    if ((w->flags & WFLG_IN_EDIT) && layered) {
        if (dePaintWidget(w))
            return;
    }
    if (w->style == ALIGN_GRID) {
        if (exP) {
            rect.origin.x = exP->x;
            rect.origin.y = exP->y;
            rect.width = exP->width;
            rect.height = exP->height;
        }
        else {
            rect.origin.x = rect.origin.y = 0;
            rect.width = w->parent->width;
            rect.height = w->parent->height;
        }
        w->width = w->parent->width; /* keep ht, wid up to date */
        w->height = w->parent->height;
        deDrawGrid(w->parent->window, &rect);
        return;
    }
}

static void
deDrawGrid(win, rect)
Drawable win;
r32 *rect;  /* draw over this area, approximately */
{
    int xx, yy, ix, iy, lx, ly, tmp;
    int nTall, nWide, nPoints;
    XPoint *points;
    if (!DE.prefs.grid)
        return;
    xx = rect->origin.x - (rect->origin.x % DE.prefs.gridsize);
    yy = rect->origin.y - (rect->origin.y % DE.prefs.gridsize);
    lx = rect->origin.x + rect->width + DE.prefs.gridsize;
    ly = rect->origin.y + rect->height + DE.prefs.gridsize;
    nTall = (ly - yy + 1) / DE.prefs.gridsize + 1;
    nWide = (lx - xx + 1) / DE.prefs.gridsize + 1;
    nPoints = nTall * nWide;
    if (nPoints >= (int) XMaxRequestSize(Dpy) - 3) {
        for(ix = xx; ix < lx; ix += DE.prefs.gridsize) {
            for(iy = yy; iy < ly; iy += DE.prefs.gridsize) {
                XDrawPoint(Dpy, win, DE.alignGC, ix, iy);
            }
        }
    }
    else {
        points = (XPoint *) TaskAlloc(0, nPoints * sizeof(XPoint));
        tmp = 0;
        for(ix = xx; ix < lx; ix += DE.prefs.gridsize) {
            for(iy = yy; iy < ly; iy += DE.prefs.gridsize) {
                if (tmp < nPoints) {
                    points[tmp].x = (short) ix;
                    points[tmp++].y = (short) iy;
                }
            }
        }
        XDrawPoints(Dpy, win, DE.alignGC, points, tmp, CoordModeOrigin);
        TaskFree(0, (char *) points);
    }
}

static int
pointInsideWidget(pt, w, onHandle, whichHandle)
p32 *pt;
AXWidget w;
int *onHandle;  /* bool: true when on a grab handle */
enum handleType *whichHandle; /* meaningful only if *onHandle */
{
    r32 rect;
    if (w->type == W_RECT) {
            /* rect widgets are "hollow", so inside means
             * within a perimeter margin measuring 2 HANDLESIZE's wide */
        r32 inner;
        panelWidgetRects(w, &rect, &inner);
        if (pointInsideRect(pt, &rect) &&
            (!pointInsideRect(pt, &inner))) {
            *onHandle = findHandle(w, pt, &rect, whichHandle);
            return TRUE;
        }
        else {
            *onHandle = FALSE;
            return FALSE;
        }
    }
    else {
        getWidgetSize(w, &rect, TRUE);
        if (pointInsideRect(pt, &rect)) {
            *onHandle = findHandle(w, pt, &rect, whichHandle);
            return TRUE;
        }
        else {
            *onHandle = FALSE;
            return FALSE;
        }
    }
}

static void
panelWidgetRects(w, outer, inner)
AXWidget w;
r32 *inner; /* out: init this */
r32 *outer; /* out: init this */
{
    int tmp;
    if (w->type == W_RECT) {
        AXWidget_rect rw = (AXWidget_rect) w;
        
        getWidgetSize(w, outer, TRUE);
        
        inner->origin.x = outer->origin.x + (2 * HANDLESIZE);
        tmp = outer->width - (4 * HANDLESIZE);
        if (tmp >= 0) {
            inner->width = (unsigned int) tmp;
        }
        else {
            inner->width = (unsigned int) 0;
        }

        if (RECT_LAYERED == rw->style) {
            inner->origin.y = outer->origin.y + (2 * HANDLESIZE) +
                rw->tabctl.top_inset;
            tmp = outer->height - (4 * HANDLESIZE) - rw->tabctl.top_inset;
        }
        else if (1234/*RECT_LABELED*/ == rw->style) {
            XFontStruct *labelfont = rw->font ? rw->font : AxDlgMainFont;
            inner->origin.y = outer->origin.y + (2 * HANDLESIZE) +
                labelfont->ascent + labelfont->descent;
            tmp = outer->height - (4 * HANDLESIZE) -
                labelfont->ascent + labelfont->descent;
        }
        else {
            inner->origin.y = outer->origin.y + (2 * HANDLESIZE);
            tmp = outer->height - (4 * HANDLESIZE);
        }

        if (tmp >= 0) {
            inner->height = (unsigned int) tmp;
        }
        else {
            inner->height = (unsigned int) 0;
        }
    }
}

int
rectanglesIntersect(r1, r2)
r32 *r1, *r2;
{
    int tmp1, tmp2;
    int maxOx, minCx; /* limits in x direction; max origin, min corner */
    int maxOy, minCy; /* limits in y direction */

    if (r1->origin.x > r2->origin.x) {
        maxOx = r1->origin.x;
    }
    else {
        maxOx = r2->origin.x;
    }
    if ((tmp1 = r1->origin.x + r1->width - 1) <
        (tmp2 = r2->origin.x + r2->width - 1)) {
        minCx = tmp1;
    }
    else {
        minCx = tmp2;
    }
    if (r1->origin.y > r2->origin.y) {
        maxOy = r1->origin.y;
    }
    else {
        maxOy = r2->origin.y;
    }
    if ((tmp1 = r1->origin.y + r1->height - 1) <
        (tmp2 = r2->origin.y + r2->height - 1)) {
        minCy = tmp1;
    }
    else {
        minCy = tmp2;
    }
    return (maxOx < minCx && maxOy < minCy);
}

int /* true only if r1 is inside r2 */
rectInsideRect(r1, r2)
r32 *r1, *r2;
{
    if (r1->origin.x > r2->origin.x &&
        r1->origin.y > r2->origin.y &&
        ((r1->origin.x + r1->width - 1) < (r2->origin.x + r2->width - 1)) &&
        ((r1->origin.y + r1->height - 1) < (r2->origin.y + r2->height - 1))) {
        return TRUE;
    }
    else {
        return FALSE;
    }
}

int /* same as rectInsideRect, but equal coords accepted, too */
rectInsideRectInclusive(r1, r2)
r32 *r1, *r2;
{
    if (r1->origin.x >= r2->origin.x &&
        r1->origin.y >= r2->origin.y &&
        ((r1->origin.x + r1->width - 1) <= (r2->origin.x + r2->width - 1)) &&
        ((r1->origin.y + r1->height - 1) <= (r2->origin.y + r2->height - 1))) {
        return TRUE;
    }
    else {
        return FALSE;
    }
}

void
unionRectangle(r1, r2, unionRect)
r32 *r1, *r2;   /* in */
r32 *unionRect; /* out: fill this out */
{
    int tmp1, tmp2;
    r32 urect;
    if (r1->origin.x < r2->origin.x) {
        urect.origin.x = r1->origin.x;
    }
    else {
        urect.origin.x = r2->origin.x;
    }
    if (r1->origin.y < r2->origin.y) {
        urect.origin.y = r1->origin.y;
    }
    else {
        urect.origin.y = r2->origin.y;
    }
    tmp1 = r1->origin.x + r1->width;
    tmp2 = r2->origin.x + r2->width;
    if (tmp1 > tmp2) {
        urect.width = tmp1 - urect.origin.x;
    }
    else {
        urect.width = tmp2 - urect.origin.x;
    }
    tmp1 = r1->origin.y + r1->height;
    tmp2 = r2->origin.y + r2->height;
    if (tmp1 > tmp2) {
        urect.height = tmp1 - urect.origin.y;
    }
    else {
        urect.height = tmp2 - urect.origin.y;
    }
    unionRect->origin = urect.origin;
    unionRect->width = urect.width;
    unionRect->height = urect.height;
}

static int
pointInsideRect(pt, r)
p32 *pt;
r32 *r;
{
    if (pt->x > r->origin.x &&
        pt->y > r->origin.y &&
        pt->x < r->origin.x + (int) r->width &&
        pt->y < r->origin.y + (int) r->height) {

        return TRUE;
    }
    else {
        return FALSE;
    }
}

static void
paintWidget(w, exp)
AXWidget w;
XExposeEvent *exp;
{
    wComposite *cp;
    if (!w || !w->display) {
        return;
    }
    paintSimpleWidget(w, exp); /* paint top of composite */
    if (w->auxData) {
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->type == WLINKDOWN) /* should be true */
                paintSimpleWidget(cp->w, exp); /* paint composite child */
        }
    }
    if (w->hasFocus && w->parent->hasFocus) {
        xmPaintFocusSelector(w);
    }
    if (DE.prefs.borders)
        dePaintWidgetBorder(w);
}

static void
paintSimpleWidget(w, exp)
AXWidget w;
XExposeEvent *exp;
{
    XExposeEvent *texp;
    int full_regen = TRUE;
    if (!w)
        return;

    if (w->painter) {
        if (w->type == W_TABLE) {
                /* suppress table painter's clip logic.. */
            texp = (XExposeEvent *) NULL;
        }
        else if (exp) {
            if (w->window) {
                    /* edit-mode widget windows are pixmaps, so
                     * make this expose look 'personalized' */
                exp->window = w->window;
            }
            texp = exp;
        }
        else {
            DE.fakeExpose.window = w->window;
            texp = &DE.fakeExpose;
        }

        (*w->painter)(w, texp, full_regen, FALSE);
        
        if ((w->type == W_OPTION) && w->window) {
            AXWidget_option ow;
            ow = (AXWidget_option)w;
                /* under edit, the pulldown is implemented as
                 * a pixmap rather than an override_redirect win */
            XCopyArea(Dpy, ow->window, ow->parent->window, ForeGC,
                    0, 0, ow->pulldown_width, ow->pulldown_height,
                    ow->pulldown_xpos, ow->pulldown_ypos);
        }
    }
}

    /* Put a dotted line around the widget to show its sensitive area
     * The W_RECT type is hollow and requires two borders */
static void
dePaintWidgetBorder(w)
AXWidget w;
{
    r32 rect, inner;
    GC tgc;
    tgc = DE.borderGC;
    if (w->type == W_RECT) {
        panelWidgetRects(w, &rect, &inner);
        rect.origin.x++;
        rect.origin.y++;
        rect.width -= 3;
        rect.height -= 3;
        XDrawRectangle(Dpy, w->parent->window, tgc,
            rect.origin.x, rect.origin.y, (unsigned int) rect.width,
            (unsigned int) rect.height);
        if (inner.width && inner.height) {
            inner.origin.x++;
            inner.origin.y++;
            inner.width -= 3;
            inner.height -= 3;
            XDrawRectangle(Dpy, w->parent->window, tgc,
                           inner.origin.x, inner.origin.y,
                           (unsigned int) inner.width,
                           (unsigned int) inner.height);
        }
    }
    else {
        getWidgetSize(w, &rect, TRUE);
        rect.origin.x++;
        rect.origin.y++;
        rect.width -= 3;
        rect.height -= 3;
        XDrawRectangle(Dpy, w->parent->window, tgc,
            rect.origin.x, rect.origin.y, (unsigned int) rect.width,
            (unsigned int) rect.height);
    }
}

/* : topWidget - if w is part of a composite, return the topmost
 * widget of the composite, otherwise just return w. An example of
 * a composite is the radio button widget, made of toggles, label, etc.
 * Caller should test whether return is nonnull */
AXWidget
topWidget(w)
AXWidget w;
{
    wComposite *cp;
    int found = FALSE;
    AXWidget tw = w;
    if (!tw || !tw->auxData || !tw->auxData->compositeList) {
        return( tw );
    }
    for (cp = tw->auxData->compositeList; cp; cp = cp->next) {
        if (cp->type == WLINKUP) {
            tw = cp->w;
            continue;
        }
    }
    return( tw ); /* no up links found, so this is the top */
}



/* : cloneWidget - produce a copy of the passed widget.  The
 * copy is incomplete, storing only what is needed for interactive
 * display (stuff like position & size, parent window, etc..) */
static AXWidget
cloneWidget(w, deep)
AXWidget w;
int deep; /* bool */
{
    wComposite *cp, **tcp;
    AXWidget tw;

    if (w->type == W_OPTION) 
        {
        /* pulldown stuff for W_OPTION includes stuff outside if generic */
        /* "AXWidget" (ie axw_any) structure, and must therefore be created */
        /* in the proper size.                                           */
        tw = (AXWidget) TaskCalloc(0, 1, sizeof(axw_option_menu) );
        ((AXWidget_option)tw)->pulldown_xpos = 
            ((AXWidget_option)w)->pulldown_xpos;
        ((AXWidget_option)tw)->pulldown_ypos = 
            ((AXWidget_option)w)->pulldown_ypos;
        ((AXWidget_option)tw)->pulldown_width =
            ((AXWidget_option)w)->pulldown_width;
        ((AXWidget_option)tw)->pulldown_height =
            ((AXWidget_option)w)->pulldown_height;
        }
    else
        tw = (AXWidget) TaskCalloc(0, 1, sizeof(axw_any));

    tw->type = w->type;
    tw->xpos = w->xpos;
    tw->ypos = w->ypos;
    tw->width = w->width;
    tw->height = w->height;
    tw->window = w->window;
    tw->parent = w->parent; /* w's parent is clone's parent */

    if (deep && w->auxData && w->auxData->compositeList) {
            /* clone composite mates, too */
        tw->auxData = newAuxData();
        tcp = &tw->auxData->compositeList;
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->w != w) {
                if (cp->type == WLINKDOWN) {
                    *tcp = newCompositeLink(cloneWidget(cp->w, TRUE),
                                cp->type);
                }
                else {
                        /* do shallow clone of uplinks */
                    *tcp = newCompositeLink(cloneWidget(cp->w, FALSE),
                                cp->type);
                }
                tcp = &((*tcp)->next);
            }
        }
    }
    return tw;
}

    /* this is  used on the 'old' widget copy, which
     * resulted from cloneWidget; as such it must match
     * cloneWidget.  So, e.g., a window handle on the
     * clone mustn't be freed, don't pass a clone handle
     * to XtDestroy, etc.. */
void
destroyCloneWidget(w)
AXWidget w;
{
    wComposite *cp, *ctmp;
    if (!w)
        return;
    if (w->auxData) {
        for (cp = ctmp = w->auxData->compositeList; cp; cp = ctmp) {
            ctmp = cp->next;
            if (cp->w && (cp->w != w)) {
                destroyCloneWidget(cp->w);
                ctmp = cp->next;    /* could now be null */
                cp->w = (AXWidget) NULL;
            }
        }
        removeAuxData(w);
    }
    TaskFree(0, (char *) w);
}


    /* w may be a composite, in which case its size is
     * the overall bounder of all the composite members */
static void
getWidgetSize(w, r, useMargins)
AXWidget w;
r32 *r;
int useMargins; /* whether to include some extra margin around widget */
{
    wComposite *cp;
    r32 rect;
    int minx, miny, maxx, maxy, tmp;
    
    if (w->auxData) {
        if (widgetOnScreen(w)) {
            getSimpleSize(w, &rect, useMargins);
            minx = rect.origin.x;
            miny = rect.origin.y;
            maxx = rect.origin.x + rect.width - 1;
            maxy = rect.origin.y + rect.height - 1;
        }
        else {
            minx = miny = INT_MAX;
            maxx = maxy = 0;
        }
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->w && widgetOnScreen(cp->w)) {
                getSimpleSize(cp->w, &rect, useMargins);
                if (rect.origin.x < minx)
                    minx = rect.origin.x;
                if (rect.origin.y < miny)
                    miny = rect.origin.y;
                if ((tmp = rect.origin.x + rect.width) > maxx)
                    maxx = tmp;
                if ((tmp = rect.origin.y + rect.height) > maxy)
                    maxy = tmp;
            }
        }
        r->origin.x = minx;
        r->origin.y = miny;
        r->width = maxx - minx + 1;
        r->height = maxy - miny + 1;
    }
    else {
        getSimpleSize(w, r, useMargins);
    }
}

    /* option menu one reason this test is needed;
     * with the pulldown closed, the buttons aren't on display */
static int
widgetOnScreen(w)
AXWidget w;
{
    AXWidget tw;
    if (w->type == W_TOGGLE) {
        tw = topWidget(w);
        if (tw && tw->type == W_OPTION) {
            return (tw->window != (Window) NULL);
        }
        else
            return TRUE;
    }
    if (w->type == W_BUTTON) {
        tw = topWidget(w);
        if (tw && tw->type == W_OPTION) {
            return (tw->window != (Window) NULL);
        }
        else
            return TRUE;
    }
    else if (w->type == W_LABEL) {
        return (w->style != LABEL_NONE);
    }
    else
        return TRUE;
}

int
deMarginSize(w)
AXWidget w;
{
    if (w->type == W_RECT) {
        if (wShadowIsOn(w->shadow)) {
            return WMARGIN;
        }
        else {
            return 3;   /* outside a rect is often outside the dlg window */
        }
    }
    else
        return WMARGIN; /* outside the object usually works best */
}

static void
getSimpleSize(w, r, useMargins)
AXWidget w;
r32 *r; /* out: fill this in */
int useMargins; /* in: bool: whether to include extra margin in measurement */
{
    AXWidget tw;
    int margin;

    margin = useMargins ? deMarginSize(w) : 0;
    
    switch (w->type) {
        
    case W_TOGGLE:
        tw = topWidget(w);
        if (tw && (tw->type == W_OPTION) && tw->window) {
            AXWidget_option ow;
            ow = (AXWidget_option)tw;
                /* for any of the buttons on an open option pulldown,
                 * just report the dlg-relative dimensions of the
                 * pulldown window itself */
            r->origin.x = ow->pulldown_xpos - margin;
            r->origin.y = ow->pulldown_ypos - margin;
            r->width = ow->pulldown_width + margin * 2;
            r->height = ow->pulldown_height + margin * 2;
        }
        else {
            r->origin.x = w->xpos - margin;
            r->origin.y = w->ypos - margin;
            r->width = w->width + margin * 2;
            r->height = w->height + margin * 2;
        }
        break;
        
    case W_BUTTON:
        tw = topWidget(w);
        if (tw && (tw->type == W_OPTION) && tw->window) {
            AXWidget_option ow;
            ow = (AXWidget_option)tw;
                /* for any of the buttons on an open option pulldown,
                 * just report the dlg-relative dimensions of the
                 * pulldown window itself */
            r->origin.x = ow->pulldown_xpos - margin;
            r->origin.y = ow->pulldown_ypos - margin;
            r->width = ow->pulldown_width + margin * 2;
            r->height = ow->pulldown_height + margin * 2;
        }
        else {
            r->origin.x = w->xpos - margin;
            r->origin.y = w->ypos - margin;
            r->width = w->width + margin * 2;
            r->height = w->height + margin * 2;
        }
        break;
        
    case W_RECT:
        if (1234/*RECT_LABELED*/ == w->style) {
            /* the w->name is visible along the top edge,
             * and may affect size.
             */
            XFontStruct *labelfont;
            labelfont = w->font ? w->font : AxDlgMainFont;

            r->origin.x = w->xpos - margin;
            r->origin.y = w->ypos - (labelfont->ascent / 2) - margin;
            r->width = w->width + (margin * 2);
            r->height = w->height + labelfont->ascent + (margin * 2);
        }
        else {
            r->origin.x = w->xpos - margin;
            r->origin.y = w->ypos - margin;
            r->width = w->width + margin * 2;
            r->height = w->height + margin * 2;
        }
        break;
        
    default:
        r->origin.x = w->xpos - margin;
        r->origin.y = w->ypos - margin;
        r->width = w->width + margin * 2;
        r->height = w->height + margin * 2;
#if AXMS
        if ( w->style == W_COMBO_BOX )
            {
            /* Under NT, the functionality of combo boxes is the same as */
            /* for option menus, but the geometry is slightly wider      */
            r->width = r->width + 3;
            }
#endif
        break;
        
    }
}

static void
setWidgetPosition(w, pt)
AXWidget w;
p32 *pt; /* in: new position (including margin) */
{
    p32 displ;
    r32 trect;
    wComposite *cp;
    int margin = deMarginSize(w);

    if (!w)
        return;
    getWidgetSize(w, &trect, TRUE);
    if (DE.prefs.grid && DE.prefs.snapToGrid) {
        pt->x += margin;
        pt->y += margin;
        gridSnap(w, pt, pt);
        pt->x -= margin;
        pt->y -= margin;
    }
    displ.x = pt->x - trect.origin.x;
    displ.y = pt->y - trect.origin.y;
    
    if ((W_RECT == w->type) && (RECT_LAYERED == w->style) &&
        (w->tabctl_linktab)) {
        
        /* perform parallel move on all (non-selected) containees
         */
        int ix;
        hitem *list;
        widglink *wl;
        p32 tpt;
        r32 rtmp;
        for (ix = 0; ix < w->tabctl_linktab->width; ix++) {
            list = w->tabctl_linktab->table[ix];
            while (list) {
                wl = (widglink *) list->value;
                if (wl->direction &&
                    !(wl->to && wl->to->auxData &&
                      wl->to->auxData->wEdit.marked)) {
                    
                    getWidgetSize(wl->to, &rtmp, TRUE);
                    tpt.x = rtmp.origin.x + displ.x;
                    tpt.y = rtmp.origin.y + displ.y;
                    setWidgetPosition(wl->to, &tpt);
                }
                list = list->next;
            }
        }
    }

    if (w->type == W_OPTION) {
        AXWidget_option ow;

        ow = (AXWidget_option)w;
        ow->xpos += displ.x;
        ow->ypos += displ.y;
        if (ow->window) {
                /* for the option menu under edit, w->window
                 * is a pixmap; adjust its position here */
            ow->pulldown_xpos += displ.x;
            ow->pulldown_ypos += displ.y;
        }
            /* the composite kids are the pulldown buttons,
             * whose positions shouldn't be adjusted */
        return;
    }
    if (w->auxData) {
            /* apply same displacement to rest of composite group */
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->w) {
                cp->w->xpos += displ.x;
                cp->w->ypos += displ.y;
            }
        }
    }
    w->xpos += displ.x;
    w->ypos += displ.y;
    if (w->type == W_EDITBOX && ((AXWidget_editbox)w)->editbox) {
        setEditBoxSize((AXWidget_editbox)w, ((AXWidget_editbox)w)->editbox);
    }
}

static void
gridSnap(w, inp, outp)
AXWidget w;
p32 *inp, *outp;
{
    p32 snapOffset, tpt;

    getSnapOffset(w, &snapOffset);
        /* add offset to get point that will be gridded */
    tpt.x = inp->x + snapOffset.x;
    tpt.y = inp->y + snapOffset.y;
        /* snap this point to grid */
    tpt.x = tpt.x - (tpt.x % DE.prefs.gridsize);
    tpt.y = tpt.y - (tpt.y % DE.prefs.gridsize);
        /* remove offset to get new widget origin */
    outp->x = tpt.x - snapOffset.x;
    outp->y = tpt.y - snapOffset.y;
}

static void
getSnapOffset(w, off)
AXWidget w;  /* in */
p32 *off;     /* out: offset from widget origin to 'snap origin' */
{
    AXWidget label;
    wComposite *cp;
    int labelWid, labelHt;
    XFontStruct *ofont;
    Arg args[2];

    off->x = off->y = 0;
    switch(w->type) {
    case W_OPTION:
        if (w->font) {
            ofont = w->font;
        }
        else {
            ofont = AxDlgMainFont;
        }
        off->x = AXTextWidth(ofont, w->name, strlen(w->name)) +
            AXTextWidth(ofont, " ", 1);
        break;
    case W_ENTER:
            /* snap the entry area topleft corner; so, offset
               extends from label topleft to this corner */
        label = NULL;
        if (w->auxData) {
            for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                if (cp->type == WLINKDOWN && cp->w->type == W_LABEL) {
                    label = cp->w;
                    break;
                }
            }
        }
        if (label && (label->style == LABEL_TOP)) {
            XtSetArg(args[0], XmNheight, &labelHt);
            AxXtGetValues(label, args, 1);
            off->y = labelHt + 4;
        }
        if (label && (label->style == LABEL_LEFT)) {
            XtSetArg(args[0], XmNwidth, &labelWid);
            AxXtGetValues(label, args, 1);
            off->x = labelWid + 3;
        }
        break;
    case W_TOGGLE:
        break;
    case W_RADIO:
        break;
    }
}

static void
setWidgetSize(w, width, height)
AXWidget w;
int width, height; /* new composite dimensions (including margins) */
{
    p32 displ; /* change in width, height */
    r32 currSize;
    int tht, twid;
    AXWidget_scroll vScrollP, hScrollP;

    getWidgetSize(w, &currSize, TRUE);
    displ.x = width - currSize.width;
    displ.y = height - currSize.height;
    
    /* these are those few dialog widgets that have
     * sizeConstraint != noStretch
     */
    switch( w->type ) {
        case W_BUTTON:
        case W_RECT:
            w->width += displ.x;
            w->height += displ.y;
            break;
        case W_SCALE: 
            w->width += displ.x;
            w->height = xmScaleHeight(w);
            break;
        case W_ENTER: /* constraint widthOnly */
        case W_COMBO_BOX:
            w->width += displ.x;
            w->width = adjustWidth(w, w->width);
            if (displ.x) {
                deFreePixmap(w);
            }
            break;

        case W_EDITBOX:
            if ( ((AXWidget_editbox)w)->editbox) {
                 setEditBoxSize((AXWidget_editbox)w,
                                ((AXWidget_editbox)w)->editbox);
			}

            vScrollP = ((AXWidget_editbox)w)->vScrollBar;
            hScrollP = ((AXWidget_editbox)w)->hScrollBar;
            goto common_stuff;
           
        case W_LIST:
            /* adjust displacement so that resultant pixwid,ht
             * represent integral # of 'elf' units (columns,chars) */
            twid = w->width + displ.x;
            twid = adjustWidth(w, twid);
            tht = w->height + displ.y;
            tht = adjustHeight(w, tht);
            displ.x = twid - w->width;
            displ.y = tht - w->height;

            vScrollP = ((AXWidget_list)w)->vScrollBar;
            hScrollP = ((AXWidget_list)w)->hScrollBar;
            goto common_stuff;

        case W_TABLE:
            vScrollP = ((AXWidget_table)w)->vScrollBar;
            hScrollP = ((AXWidget_table)w)->hScrollBar;
            goto common_stuff;

        case W_CANVAS:
            vScrollP = ((AXWidget_canvas)w)->vScrollBar;
            hScrollP = ((AXWidget_canvas)w)->hScrollBar;

common_stuff:
            w->width += displ.x;
            w->height += displ.y;
            if (vScrollP) {
                vScrollP->height += displ.y;
                vScrollP->xpos += displ.x;
                if (displ.y) {
                    deFreePixmap((AXWidget)vScrollP);
                }
            }
            if (hScrollP) {
                hScrollP->width += displ.x;
                hScrollP->ypos += displ.y;
                if (displ.x) {
                    deFreePixmap((AXWidget)hScrollP);
                }
            }
            if ((displ.x || displ.y)) {
                deFreePixmap(w);
            }
            break;

        default:
            break;
    }
}

static void
deChangeWidgetHeight(w, displacement)
AXWidget w;
int displacement;
{
    r32 trect, minrect;
    getWidgetSize(w, &trect, TRUE);
    trect.height += displacement;
    getMinimumWidgetSize(w, &minrect);
    if ((int)trect.height < (int)minrect.height) {
        trect.height = minrect.height +
            (2 * deMarginSize(w));
    }
    setWidgetSize(w, trect.width, trect.height);
}

static void
deChangeWidgetWidth(w, displacement)
AXWidget w;
int displacement;
{
    r32 trect, minrect;
    getWidgetSize(w, &trect, TRUE);
    trect.width += displacement;
    getMinimumWidgetSize(w, &minrect);
    if ((int)trect.width < (int)minrect.width) {
        trect.width = minrect.width +
            (2 * deMarginSize(w));
    }
    setWidgetSize(w, trect.width, trect.height);
}


/*==============================================================*/
/* respond to a resize motion event by (possibly)               */
/* repositioning the grabbed mark handle, and doing the resize. */
/*==============================================================*/
static void
resizeByHandle(w, whichHandle, pt, origSize)
AXWidget w;
enum handleType whichHandle;
p32 *pt;
r32 *origSize; /* widget size at start of stroke */
{
    p32 newPos, tmp; /* of grabbed handle */
    p32 fixedPos; /* of fixed_corner */
    int dx, dy, dwid, dht; /* displacement in size, pos */
    int minwidth, minheight;
    r32 limit;
    enum handleType fixed_corner;
    enum stretch_constraint stretch;
    int margin = deMarginSize(w);
        /* test the stretch constraint to filter out a few
         * cases where the grabbed handle won't be repositioned
         * at all */
    switch ( stretch = stretchConstraint(w) ) {
        case noStretch:
            return; /* all handles immovable */
        case widthOnly:
                /* the only immovable handles are the
                 * top and bottom edge middles */
            if (whichHandle == topEdge || whichHandle == botEdge)
                return;
            break;
        case heightOnly:
                /* the left and right edge middle handles
                 * are immovable */
            if (whichHandle == leftEdge || whichHandle == rightEdge)
                return;
            break;
    }
        /* determine fixed corner, and its pos */
    fixed_corner = fixedCorner(whichHandle);
    getHandleOffset(w, origSize, fixed_corner, &fixedPos);
    fixedPos.x += origSize->origin.x; /* make dlg-relative */
    fixedPos.y += origSize->origin.y;
        /* pt is the current pos of the resize stroke.  Determine
         * where the grabbed handle should be repositioned. (It
         * should be on pt only if the resize is unconstrained, e.g.) */
    if (stretch == noConstraint) {
        newPos = *pt;
    }
    else if (stretch == widthOnly) {
            /* reposition using horiz projection of displacement */
        getHandleOffset(w, origSize, whichHandle, &newPos);
        newPos.x = pt->x;
        newPos.y += origSize->origin.y;
    }
    else if (stretch == heightOnly) {
            /* use vert projection of displacement */
        getHandleOffset(w, origSize, whichHandle, &newPos);
        newPos.y = pt->y;
        newPos.x += origSize->origin.x;
    }
        /* now determine the sizechange for the widget, based on
         * the new grab handle position and fixed corner.  First
         * get the new width/height, which is implicit in the
         * displacement between newPos and fixedPos */
    dx = dy = dwid = dht = 0;
            /* put size and pos changes on dx, dy, dwid, dht */
    switch (fixed_corner) {
        case topLeft:
            dwid = newPos.x - fixedPos.x - origSize->width + 1;
            dht = newPos.y - fixedPos.y - origSize->height + 1;
            break;
        case topRight:
            dwid = fixedPos.x - newPos.x - origSize->width + 1;
            dht = newPos.y - fixedPos.y - origSize->height + 1;
            break;
        case botRight:
            dwid = fixedPos.x - newPos.x - origSize->width + 1;
            dht = fixedPos.y - newPos.y - origSize->height + 1;
            break;
        case botLeft:
            dwid = newPos.x - fixedPos.x - origSize->width + 1;
            dht = fixedPos.y - newPos.y - origSize->height + 1;
            break;
    }
    if (whichHandle == rightEdge || whichHandle == leftEdge ||
        stretch == widthOnly) {
            /* height can't change by definition */
        dht = 0;
    }
    else if (whichHandle == topEdge || whichHandle == botEdge ||
             stretch == heightOnly) {
        dwid = 0;
    }
            /* check size limits */
    getMinimumWidgetSize(w, &limit);
        /* adjust limits to include margins */
    minwidth = limit.width + 2 * margin;
    minheight = limit.height + 2 * margin;
    if (dwid + (int) origSize->width <= minwidth) {
        dwid = minwidth - (int) origSize->width;
    }
    if (dht + (int) origSize->height <= minheight) {
        dht = minheight - (int) origSize->height;
    }
    if (w->type == W_ENTER || w->type == W_LIST) {
            /* these types have constraints on pixel size;
             * determine adjustment to sizechange in order
             * to get an accurate position change */
        r32 tmprect;
        setWidgetSize(w, origSize->width + dwid, origSize->height + dht);
        getWidgetSize(w, &tmprect, TRUE);
        if (dwid) {
            dwid = tmprect.width - origSize->width;
        }
        if (dht) {
            dht = tmprect.height - origSize->height;
        }
    }
        /* determine position change */
    switch(fixed_corner) {
        case topRight:
            dx = -dwid;
            break;
        case botRight:
            dx = -dwid;
            dy = -dht;
            break;
        case botLeft:
            dy = -dht;
            break;
        default:
            break;
    }

        /* now set the widget's new size and pos */
    newPos.x = origSize->origin.x + dx;
    newPos.y = origSize->origin.y + dy;
    if (DE.prefs.grid && DE.prefs.snapToGrid) {
            /* determine gridsnap displacement as done in
             * setWidgetPos, and reflect on dwid, dht */
        tmp = newPos;
        tmp.x += margin;
        tmp.y += margin;
        gridSnap(w, &tmp, &tmp);
        tmp.x -= margin;
        tmp.y -= margin;
        dwid -= tmp.x - newPos.x;
        dht -= tmp.y - newPos.y;
    }
    setWidgetSize(w, origSize->width + dwid, origSize->height + dht);
    setWidgetPosition(w, &newPos);
}

static int /* return which corner should remain fixed during resize */
fixedCorner(whichHandle)
enum handleType whichHandle;
{
    switch( whichHandle ) {
        case topLeft:
            return botRight;
        case topRight:
        case topEdge:
            return botLeft;
        case botRight:
        case rightEdge:
        case botEdge:
            return topLeft;
        case botLeft:
        case leftEdge:
            return topRight;
    }
}

static int
adjustWidth(w, width)
AXWidget w;
int width;
{
    int colwid;
    AXWidget_dialog dw;
    int ret;
    
    if (width < 0)
        width = 0;
    
    dw = (AXWidget_dialog) w->parent;
    
    switch(w->type) {
    case W_ENTER:
        /* constrain to n columns wide */
        colwid = wEnterColWidth(width, w->font, w->textShadow);
        return (wEnterPixWidth(colwid, w->font, w->textShadow));
    case W_LIST:
        colwid = wListColWidth(width, dw->revstamp,
                               dw->referenceFont);
#if 0
    /* used to be AXMS. do we need this?  historical?    -donato */
        ret = wListPixWidth(colwid, -1,  /* special rev means "do not adjust" */
                              dw->referenceFont);
#else
        ret = wListPixWidth(colwid, dw->revstamp,
                              dw->referenceFont);
#endif
        return( ret );

    default:
        return (width);
    }
}

static int
adjustHeight(w, height)
AXWidget w;
int height;
{
    AXWidget_list lw;
    int nItems;

    if (height < 0)
        height = 0;
    
    switch(w->type) {
        
    case W_LIST: /* constrain height to n rows tall */
        lw = (AXWidget_list)w;
        nItems = wListVisibleItemCount(height, lw->font, lw->textShadow,
                                       lw->list_hscroll);
        lw->scroll_max = nItems;
        height = wListPixHeight(nItems, lw->font, lw->textShadow,
                                lw->list_hscroll);
        return (height);
        
        
    default:
        return (height);
        
    }
}

static void
adjustPoint(event, pt)
XEvent *event;
p32 *pt;        /* out: init this */
{
    XEvent tevent;

    switch(event->type) {
        case KeyPress:
        case KeyRelease:
            pt->x = event->xkey.x;
            pt->y = event->xkey.y;
            break;
        case ButtonPress:
        case ButtonRelease:
            pt->x = event->xbutton.x;
            pt->y = event->xbutton.y;
            break;
        case MotionNotify:
            AxFilterMotionNotify(event, &tevent);
            pt->x = tevent.xmotion.x;
            pt->y = tevent.xmotion.y;
            break;
    }
}

static int
isStroke(p1, p2, strokeStart)
p32 *p1, *p2;      /* in:  button down pos, current pos */
int *strokeStart;  /* out: set true if detect start of stroke */
{
    *strokeStart = FALSE;
    if (!(DE.possiblePick || DE.possibleDblPick)) {
        return TRUE;
    }
    else if ( abs(p1->x - p2->x) > MAX_PICK_DISTANCE ||
              abs(p1->y - p2->y) > MAX_PICK_DISTANCE ) {
        if (DE.possiblePick || DE.possibleDblPick) {
            *strokeStart = TRUE;
            DE.possiblePick = DE.possibleDblPick = FALSE;
        }
        return TRUE;
    }
    else
        return FALSE;
}

#if 0
static void
closeOptionPulldown(w, event)
AXWidget w;
XEvent *event;
{
    if (!w->window)
        return;
    preEdit(w);         /* so that coming display will clean things up */
    deFreePixmap(w);
    displayWidget(&w, 1, TRUE); /* display again now that pd is gone */
}
#endif

#if 0
static void
openOptionPulldown(w, event)
AXWidget w;
XEvent *event;
{
    PaintOptionPulldown(w, OPTION_NEW, event);
    if (w->window) {
        XCopyArea(Dpy, w->window, w->parent->window, ForeGC,
            0, 0, w->pulldown_width, w->pulldown_height,
            w->pulldown_xpos, w->pulldown_ypos);
    }
}
#endif

/* : preEdit - save current state
 * in preparation for an edit */
static void
preEdit(w)
AXWidget w;
{
    if (!w->auxData) {
        w->auxData = newAuxData();
    }
    if (w->auxData->wEdit.old) {
            /* toss anything still on old */
        destroyCloneWidget(w->auxData->wEdit.old);
    }
    w->auxData->wEdit.old = cloneWidget(w, TRUE);
}

static void
doRefresh(w, exp)
AXWidget_dialog w;
XExposeEvent *exp;
{
    wLayer *ly, **listHead;
    r32 updateRect;

    if (w->type == W_MAIN)
        w = ((AXWidget_main)w)->dialog;
            
    if (w->type != W_DIALOG)
        w = (AXWidget_dialog)w->parent;
    
    w->exposed = TRUE;
    
    if (!exp) {
            /* expose all widgets in the dialog
             */
        updateRect.origin.x = updateRect.origin.y = 0;
        updateRect.width = w->width;
        updateRect.height = w->height;
    }
    else {
        updateRect.origin.x = exp->x;
        updateRect.origin.y = exp->y;
        updateRect.width = exp->width;
        updateRect.height = exp->height;
    }
    
        /* set DE.fakeExpose, which the painters will
         * will be passed if the exposure event pointer is null
         */
    setFakeExpose(w->window, &updateRect);
    
        /* pre-clear initial updateRect to dialog background.
         */
    XFillRectangle(Dpy, w->window, BackGC, updateRect.origin.x,
                   updateRect.origin.y, updateRect.width,
                   updateRect.height);
    
        /* redraw kids
         */
    listHead = layerListHead(w);
    if (!listHead) {
        return;
    }
    for (ly = *listHead; ly; ly = ly->next) {
        
        if (!widgetOnScreen(ly->w))
            continue;
        
        if (widgetIntersectsUpdateRect(ly->w, &updateRect)) {
            r32 thisRect;
            
            paintWidget(ly->w, (XExposeEvent *) NULL);
            
                /* make sure updateRect contains any damage
                 * caused by reshooting this widget
                 */
            widgetFootprint(ly->w, &thisRect);
            unionRectangle(&thisRect, &updateRect, &updateRect);
        }
    }
    drawHandles(listHead, (AXWidget*)NULL, 0);
}

    /* there are 8 handles around the periphery of rectangle r */
static int
findHandle(w, pt, r, which)
AXWidget w;
p32 *pt;    /* in */
r32 *r;     /* in */
enum handleType *which; /* meaningful only on true return */
{
    r32 hrect;
    hrect.width = hrect.height = HANDLESIZE;
    if (w->auxData && !w->auxData->wEdit.marked) {
        return FALSE; /* not marked, so must not be on handle */
    }
        /* test upper left corner */
    hrect.origin.x = r->origin.x;
    hrect.origin.y = r->origin.y;
    if (pointInsideRect(pt, &hrect)) {
        *which = topLeft;
        return TRUE;
    }
        /* upper edge middle */
    hrect.origin.x = r->origin.x + (r->width / 2) - HANDLEHALF;
    if (pointInsideRect(pt, &hrect)) {
        *which = topEdge;
        return TRUE;
    }
        /* upper right corner */
    hrect.origin.x = r->origin.x + r->width - HANDLESIZE - 1;
    if (pointInsideRect(pt, &hrect)) {
        *which = topRight;
        return TRUE;
    }
        /* right edge middle */
    hrect.origin.y = r->origin.y + (r->height / 2) - HANDLEHALF;
    if (pointInsideRect(pt, &hrect)) {
        *which = rightEdge;
        return TRUE;
    }
        /* lower right corner */
    hrect.origin.y = r->origin.y + r->height - HANDLESIZE - 1;
    if (pointInsideRect(pt, &hrect)) {
        *which = botRight;
        return TRUE;
    }
        /* lower edge middle */
    hrect.origin.x = r->origin.x + (r->width / 2) - HANDLEHALF;
    if (pointInsideRect(pt, &hrect)) {
        *which = botEdge;
        return TRUE;
    }
        /* lower left corner */
    hrect.origin.x = r->origin.x;
    if (pointInsideRect(pt, &hrect)) {
        *which = botLeft;
        return TRUE;
    }
        /* left edge middle */
    hrect.origin.y = r->origin.y + (r->height / 2) - HANDLEHALF;
    if (pointInsideRect(pt, &hrect)) {
        *which = leftEdge;
        return TRUE;
    }
    return FALSE; /* none of the above */
}

static void
simpleDrawHandles(w)
AXWidget w;
{
    r32 wrect, hrect;
    GC tgc;
    if (!w)
        return;
    tgc = DE.alignGC;
    getWidgetSize(w, &wrect, TRUE);
    hrect.width = hrect.height = HANDLESIZE;
        /* top left corner */
    hrect.origin = wrect.origin;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* upper edge middle */
    hrect.origin.x = wrect.origin.x + (wrect.width / 2) - HANDLEHALF;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* upper right corner */
    hrect.origin.x = wrect.origin.x + wrect.width - HANDLESIZE - 1;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* right edge middle */
    hrect.origin.y = wrect.origin.y + (wrect.height / 2) - HANDLEHALF;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* lower right corner */
    hrect.origin.y = wrect.origin.y + wrect.height - HANDLESIZE - 1;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* lower edge middle */
    hrect.origin.x = wrect.origin.x + (wrect.width / 2) - HANDLEHALF;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* lower left corner */
    hrect.origin.x = wrect.origin.x;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
        /* left edge middle */
    hrect.origin.y = wrect.origin.y + (wrect.height / 2) - HANDLEHALF;
    XFillRectangle(Dpy, w->parent->window, tgc,
                hrect.origin.x, hrect.origin.y,
                (unsigned int) hrect.width, (unsigned int) hrect.height);
}

    /* return the offset between the widget origin and the
     * origin of the specified handle */
static void
getHandleOffset(w, wrect, whichHandle, off)
AXWidget w;
r32 *wrect; /* overall widget size */
enum handleType whichHandle;
p32 *off; /* out: fill this in */
{
    if (!off || !w)
        return;
    switch(whichHandle) {
        case topLeft:
            off->x = 0;
            off->y = 0;
            break;
        case topRight:
            off->x = wrect->width - HANDLESIZE;
            off->y = 0;
            break;
        case botRight:
            off->x = wrect->width - HANDLESIZE;
            off->y = wrect->height - HANDLESIZE;
            break;
        case botLeft:
            off->x = 0;
            off->y = wrect->height - HANDLESIZE;
            break;
        case topEdge: /* middle top edge */
            off->x = (wrect->width / 2) - HANDLEHALF;
            off->y = 0;
            break;
        case rightEdge:
            off->x = wrect->width - HANDLESIZE;
            off->y = (wrect->height / 2) - HANDLEHALF;
            break;
        case botEdge:
            off->x = (wrect->width / 2) - HANDLEHALF;
            off->y = wrect->height - HANDLESIZE;
            break;
        case leftEdge:
            off->x = 0;
            off->y = (wrect->height / 2) - HANDLEHALF;
            break;
    }
}

static enum stretch_constraint /* return the constraint on the widget type */
stretchConstraint(w)
AXWidget w;
{
    AXWidget_pushbutton pw;
                
    if (!w)
        return noStretch;
    switch( w->type ) {
    case W_BUTTON:
        pw = (AXWidget_pushbutton)w;
        if (pw->color || pw->font)
            return noConstraint;
        else if (pw->pixmapLabel)
            return noStretch;   /* lots of preexisting nonsense sizes */
        else
            return noConstraint;
    case W_SCALE:
    case W_COMBO_BOX:
        return widthOnly;
    case W_LABEL:
    case W_OPTION:
    case W_RADIO:
    case W_TOGGLE:
    case W_ICON:
    case W_SPLITTER:
        return noStretch;
    case W_ENTER:
        return widthOnly;
    case W_EDITBOX:
    case W_LIST:
    case W_RECT:
    case W_TABLE:
    case W_CANVAS:
        return noConstraint;
    default:
        return noStretch;
    }
}

void
getMinimumWidgetSize(w, rect)
AXWidget w;
r32 *rect; /* out */
{
    XFontStruct *fs;
    wComposite *cp;
    int width, height;
    AXWidget_pushbutton pw;
    AXWidget_struct tmpwidget;

    if (!rect)
        return;
    
    rect->origin.x = rect->origin.y = 0; /* only height, width meaningful */
    
    switch( w->type ) {
    case W_BUTTON:
        pw = (AXWidget_pushbutton)w;
        width = height = 0;              /* to get min vals */
        wVerbButtonSize(pw->name, pw->pixmapLabel, pw->font,
                        pw->thickness, pw->shadow, pw->textShadow,
                        &width, &height);
        rect->width = width;
        rect->height = height;
        break;
    case W_ENTER:
        fs =  AxDlgMainFont;
        rect->height = (unsigned int) abs((int)(fs->max_bounds.ascent +
                                                fs->max_bounds.descent));
        rect->height += 2;
        rect->width = adjustWidth(w, 10);
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->w && (cp->w->type == W_LABEL)) {
                rect->width += (w->xpos - cp->w->xpos);
                rect->height += (w->ypos - cp->w->ypos);
            }
        }
        break;
    case W_EDITBOX:
            tmpwidget.width = tmpwidget.height = 0;
            checkEditBoxSize(&tmpwidget); /* looks only at ht, wid */
            rect->width = tmpwidget.width;
            rect->height = tmpwidget.height;

            if (((AXWidget_editbox)w)->vScrollBar) {
                rect->width += ((AXWidget_editbox)w)->vScrollBar->width + 2;
            }
            if (((AXWidget_editbox)w)->hScrollBar) {
                rect->height += ((AXWidget_editbox)w)->hScrollBar->height + 2;
            }
            break;

    case W_LIST:
            rect->width = adjustWidth(w, 30);
            rect->height = adjustHeight(w, 40);

            if (((AXWidget_list)w)->vScrollBar) {
                rect->width += ((AXWidget_list)w)->vScrollBar->width + 2;
            }
            if (((AXWidget_list)w)->hScrollBar) {
                rect->height += ((AXWidget_list)w)->hScrollBar->height + 2;
            }
            break;

    case W_TABLE:
            rect->width = 50;
            rect->height = 45;
        
            if (((AXWidget_table)w)->vScrollBar) 
                rect->width += ((AXWidget_table)w)->vScrollBar->width + 2;
            if (((AXWidget_table)w)->hScrollBar) 
                rect->height += ((AXWidget_table)w)->hScrollBar->height + 2;
            break;

    case W_CANVAS:
            rect->width = rect->height = 40;

            if (((AXWidget_canvas)w)->vScrollBar) {
                rect->width += ((AXWidget_canvas)w)->vScrollBar->width + 2;
            }
            if (((AXWidget_canvas)w)->hScrollBar) {
                rect->height += ((AXWidget_canvas)w)->hScrollBar->height + 2;
            }
            break;

            /* this is a minimum window width; increase as needed to
             * account for any scrollbars that may be present */
        break;
    case W_SCALE:
        rect->width = 30;
        rect->height = 19;
        break;
    case W_RECT:
            /* this is set below the value of 4 in PaintRect,
               to allow the etch form of W_RECT */
        rect->width = rect->height = 2;
        break;
    case W_COMBO_BOX:
        /* try to guarantee some window, edit_win.win area
         */
        rect->width = 45;
        rect->height = 24;
        break;
    default:
        rect->width = rect->height = 10; /* arbitrary */
        break;
    }
}

static int
recent(timeAgo, presentTime)
Time timeAgo, presentTime;
{
    return ( (presentTime - timeAgo) < 250 ); /* millisecs */
}

/* : deElfPos - given the widget_t for the top of a composite,
 * possibly adjust for the difference between that w_t's pos and
 * its position as seen by elf */
static void
deElfPos(w, pt)
AXWidget w;
p32 *pt; /* out: fill this in w/ adjusted position */
{
    wComposite *cp;
    if (!w || !pt)
        return;
    pt->x = w->xpos;
    pt->y = w->ypos;
    switch(w->type) {
        case W_ENTER:
            if (w->auxData) {
                    /* elf really wants position of the label if present */
                for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                    if (cp->w && (cp->w->type == W_LABEL) &&
                            (cp->w->style != LABEL_NONE)) {
                        pt->x = cp->w->xpos;
                        pt->y = cp->w->ypos;
                    }
                }
            }
            break;
        case W_RADIO: /* elf really wants position of label */
            if (w->auxData) {
                for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                    if (cp->w && (cp->w->type == W_LABEL)) {
                        pt->y = cp->w->ypos;
                    }
                }
            }
            break;
        default:
            break;
    }
}

    /* similar to deElfPos, but for handling size unit inconsistencies */
static void
deElfSize(w, rr)
AXWidget w;
r32 *rr; /* out: fill this in w/ adjusted size */
{
    AXWidget_dialog dw;
    AXWidget_list lw;
    int pix_height;
    
    if (!w || !rr)
        return;
    
    dw = (AXWidget_dialog) w->parent;
    
    rr->width = w->width;
    rr->height = w->height;
    switch(w->type) {
        case W_ENTER:
                /* elf wants width units in 'character units' */
            rr->width = wEnterColWidth(w->width, w->font, w->textShadow);
            break;
        case W_LIST:
            lw = (AXWidget_list) w;
            /* elf wants width,height units in 'character units' */
#if AX_X11
            rr->width = wListColWidth(lw->width, dw->revstamp,
                                      dw->referenceFont);
#else
            /* (We adjust dialogs when they are read in to get the correct  */
            /* NT size, see wListPixWidth() On X, "WidthOfDialogZero" == 7  */
            rr->width = lw->width / 7;
#endif

#if 1       /* { */
            rr->height = wListVisibleItemCount(lw->height, lw->font,
                                               lw->textShadow,
                                               lw->list_hscroll);
#else       /*  }  {  */
    /* used to be AXMS. do we need this?  historical?    -donato */
            /* on NT we normalize all measuremtns to the X metrics so that */
            /* the dialog will work on X.  (We adjust dialogs when they are */
            /* read in to get the correct NT size, see wListPixWidth()      */
            /* On X, "WidthOfDialogZero" == 7                               */
            rr->width = lw->width / 7;
            if ( lw->font )
               /* there is some non-default font, we can not guess at the  */
               /* X size, so punt and do it the X way with the NT font!    */
               rr->height = wListVisibleItemCount(lw->height, lw->font,
                                               lw->textShadow,
                                               lw->list_hscroll);
            else
               {
               pix_height = lw->height - 2;
               if ( lw->list_hscroll )
                   pix_height = pix_height - SCROLLBAR_THICK;
               rr->height = pix_height / AxCharHeight;
               if ( rr->height < 0 )
                   rr->height = 0;
                if ( lw->list_hscroll )
                    rr->height = (rr->height * AxCharHeight - 21 + SCROLLBAR_THICK)/16;
                else
                    rr->height = (rr->height * AxCharHeight - 5)/16;
               }
#endif    /*  }   AXMS */
            break;
        case W_LABEL:
        case W_ICON:
            rr->width = rr->height = 0;
            break;
        case W_SCALE:
            rr->width = xmScaleWidth(w);
            rr->height = xmScaleHeight(w);
            break;
        default:
            break;
    }
}

    /* display layering list support. each wLayer instance
     * represents one of the dialog's widgets; head-to-tail position
     * on the list represents back-to-front position during edit */

static void
tossWlayer(ly)
wLayer *ly;
{
    if (ly) {
        TaskFree(0, (char *)ly);
    }
}

static wLayer *
newWlayer()
{
    wLayer *nl = (wLayer *) TaskAlloc(0, sizeof(wLayer));
    memset((char *)nl, 0, sizeof(wLayer));
    return nl;
}

static void
threadWlayer(listhead, ly, nly)
wLayer **listhead;
wLayer *ly;     /* insert nly just after this element */
wLayer *nly;    /* new element to insert */
{
    if (!ly) {
            /* add as head of list */
        nly->next = *listhead;
        nly->prev = (wLayer *) NULL;
        if ( *listhead ) {
            (*listhead)->prev = nly;
        }
        *listhead = nly;
    }
    else {
        if (ly->next) {
            ly->next->prev = nly;
        }
        nly->next = ly->next;
        nly->prev = ly;
        ly->next = nly;
    }
}

static void
unthreadWlayer(listhead, ly)
wLayer **listhead; /* list head */
wLayer *ly;
{
        /* Unthread from list */
    if ( ly->next )
        ly->next->prev = ly->prev;
    if ( ly->prev )
        ly->prev->next = ly->next;
    if ( *listhead == ly )
        *listhead = ly->next;
}

static int
useLayers(w)
AXWidget w;
{
    if (w->type == W_MAIN) {
        return (FALSE); /* layers apply to dialog kids only */
    }
    if (!w->parent || (w->parent->type != W_DIALOG)) {
        return (FALSE); /* layers apply to dialog kids only */
    }
    return (TRUE);
}

void
deleteWlayer(dlg, w)
AXWidget_dialog dlg;
AXWidget w;
{
    wLayer *ly;
    wLayer **listhead;

    if (!useLayers(w))
        return;
    
    if (listhead = layerListHead(dlg)) {
        for (ly = *listhead; ly; ly = ly->next) {
            if (ly->w == w)
                break;
        }
        if (ly) {
            unthreadWlayer(listhead, ly);
            tossWlayer(ly);
        }
    }
}

    /* append a wLayer element representing w onto the layerlist
     * at the end of the appropriate 'range' of the list; the ranges
     * go (from back to front): rects, images, alignment objects, the rest */
void
appendNewWlayer(dlg, w)
AXWidget_dialog dlg;
AXWidget w; /* widget to be represented on layerlist for the first time */
{
    wLayer *ly, **listHead, *tmp; 

    if (!w || !useLayers(w))
        return;
    
    listHead = layerListHead(dlg);
    if (!w || !listHead)
        return;
    ly = newWlayer();
    ly->w = w;
        /* the head of DE.layerList represents the backmost object;
         * first find the frontmost element of the rects range */
    tmp = (wLayer *) 0;
    tmp = findFront(listHead, tmp, W_RECT);
    if (w->type == W_RECT) {
        threadWlayer(listHead, tmp, ly);
        return;
    }
        /* find the frontmost element of the images (W_ICON) range */
    tmp = findFront(listHead, tmp, W_ICON);
    if (w->type == W_ICON) {
        threadWlayer(listHead, tmp, ly);
        return;
    }
        /* find the frontmost element of the alignment object range */
    tmp = findFront(listHead, tmp, W_ALIGN);
    if (w->type == W_ALIGN) {
        threadWlayer(listHead, tmp, ly);
        return;
    }
        /* none of the above; append to the end of the list */
    if (!tmp)
        tmp = *listHead;
    while(tmp) {
        if (!tmp->next)
            break;
        tmp = tmp->next;
    }
    threadWlayer(listHead, tmp, ly);
    /*unBuryWidget(ly->w);*/
}

    /* make exisiting layerlist element ly the frontmost of its range */
static void
makeFrontLayer(listhead, ly)
wLayer **listhead;
wLayer *ly;
{
    wLayer *tmp;
    if (!ly || !ly->w)
        return;
    tmp = findFront(listhead, ly, ly->w->type);
    unthreadWlayer(listhead, ly);
    threadWlayer(listhead, tmp, ly);
}

    /* make exisiting layerlist element ly the backmost of its range */
static void
makeBackLayer(listhead, ly)
wLayer **listhead;
wLayer *ly;
{
    wLayer *tmp;
    if (!ly || !ly->w)
        return;
    tmp = findBack(listhead, ly, ly->w->type);
    unthreadWlayer(listhead, ly);
    if (tmp == *listhead) {
        threadWlayer(listhead, (wLayer *) NULL, ly);
    }
    else {
        threadWlayer(listhead, tmp->prev, ly);
    }
}

     /* starting from ly, find the frontmost element
      * of the range containing wType.  If no such range
      * currently, (or if called beyond end of range),
      * just return ly */
static wLayer * /* return addr of frontmost element in range */
findFront(listhead, ly, wType)
wLayer **listhead;
wLayer *ly;
int wType;
{
    wLayer *origly = ly;
    wLayer *prev;
    if (!ly) {
        ly = *listhead;
        prev = (wLayer *) 0; /* 'prev element' */
    }
    else {
        prev = ly->prev;
    }
    while (ly) {
        if ((ly->w && (ly->w->type != wType)) &&
            (prev && prev->w && (prev->w->type == wType))) {
            return prev;
        }
        else if (!ly->next && ly->w && (ly->w->type == wType)) {
            return ly;
        }
        prev = ly;
        ly = ly->next;
    }
    return origly;
}

     /* starting from ly, find the backmost element of the
      * range containing wType.  If no such range currently,
      * (or if called before beginning of range), just return ly */
static wLayer *
findBack(listhead, ly, wType)
wLayer **listhead;
wLayer *ly;
int wType;
{
    wLayer *next;
    wLayer *origly = ly;
    if (!ly) {
        return *listhead;
    }
    else {
        next = ly->next;
    }
    while (ly != *listhead) {
        if ((ly->w && (ly->w->type != wType)) &&
                (next && next->w && (next->w->type == wType))) {
            return next;
        }
        else if ((ly->prev == *listhead) && 
                 ly->w && (ly->w->type == wType)) {
            return ly;
        }
        next = ly;
        ly = ly->prev;
    }
    if (ly->w && (ly->w->type == wType)) {
        return ly;
    }
    else {
        return origly;
    }
}

wLayer **
layerListHead(dlg)
AXWidget_dialog dlg;
{
    if (!dlg) {
        return ((wLayer **) NULL);
    }
    return (&dlg->layerList);
}

/* : layerRange - return range that this widget lives in.
 * name the range by using the name of a representative widget
 * from the range; so, the ranges are named (back-to-front):
 * W_RECT, W_ICON, W_ALIGN, and W_BUTTON */
static int
layerRange(w)
AXWidget w;
{
    if (w->type == W_RECT) {
        return W_RECT;
    }
    else if (w->type == W_ICON) {
        return W_ICON;
    }
    else if (w->type == W_ALIGN) {
        return W_ALIGN;
    }
    else
        return W_BUTTON; /* i.e., none of the above */
}

/* : deCreateWidget - complete the initialization of a new
 * widget_t instance before reporting it to the dlg editor elf code
 */
static AXWidget
deCreateWidget(dlg, nw, pos, stroke)
AXWidget_dialog dlg; /* dialog that will get the new widget */
wCreate *nw;
p32 *pos;
int stroke; /* true for stroke-create, false for click-create */
{
    wComposite *cp;
    AXWidget tw;
    if (!nw || !pos) {
        return ((AXWidget)NULL);
    }
    if (nw->wWidget) {
            /* set initial position */
        setWidgetPosition(nw->wWidget, pos);
        if (stroke) {
                /* start the widget at its minimum size */
            r32 minSize;
            getMinimumWidgetSize(nw->wWidget, &minSize);
			    /* add margin size to both width, height */
			minSize.width += deMarginSize(nw->wWidget);
			minSize.height += deMarginSize(nw->wWidget);
            setWidgetSize(nw->wWidget, minSize.width, minSize.height);
        }
            /* turn on display, which had been suppressed until now */
        nw->wWidget->flags &= (~WFLG_NODISPLAY);
        nw->wWidget->display = TRUE;
        if (nw->wWidget->auxData) {
            for (cp = nw->wWidget->auxData->compositeList; cp; cp = cp->next) {
                if (cp->w) {
                    cp->w->flags &= (~WFLG_NODISPLAY);
                    cp->w->display = TRUE;
                }
            }
        }
    }
    
    tw = nw->wWidget;

    nw->wWidget = (AXWidget) NULL; /* 'disconnect' instance from *nw */
    return tw;
}

/* : deSendUpdateForSelected - the context is that an edit has
 * occurred across the current selected set; send update information
 * about the edit.  since the selected set may span more than one
 * dialog, arbitrate the update info.
 */
static void
deSendUpdateForSelected(edit, info)
enum wEditType edit;
data_ptr info;        /* option att-list */
{
    AXWidget **widgs;
    int *wCount, tmp, ix, jx;

    if (DE.numDlgs == 0)
        return;

    if (DE.numDlgs == 1) {
        deSendUpdate((AXWidget)DE.dialogs[0].dlg->parent, DE.selectedSet,
                     DE.selectedSetSize, edit, (data_ptr)0);
        return;
    }

    tmp = DE.numDlgs * sizeof(AXWidget);
    widgs = (AXWidget **) TaskAlloc(0, tmp);
    memset((char *) widgs, 0, tmp);

    tmp = DE.numDlgs * sizeof(int);
    wCount = (int *) TaskAlloc(0, tmp);
    memset((char *) wCount, 0, tmp);

    for (ix = 0; ix < DE.numDlgs; ix++) {
        for (jx = 0; jx < DE.selectedSetSize; jx++) {
            if ((AXWidget)((AXWidget)DE.selectedSet[jx])->parent ==
                DE.dialogs[ix].dlg) {
                
                tmp = wCount[ix];
                if (!widgs[ix]) {
                    widgs[ix] = (AXWidget *) TaskAlloc
                        (0, sizeof(AXWidget));
                }
                else {
                    widgs[ix] = (AXWidget *) TaskRealloc
                        (0, widgs[ix], (tmp + 1) * sizeof(AXWidget));
                }
                widgs[ix][tmp] = DE.selectedSet[jx];
                wCount[ix]++;
            }
        }
    }

    for (ix = 0; ix < DE.numDlgs; ix++) {
        deSendUpdate((AXWidget)DE.dialogs[ix].dlg->parent, widgs[ix],
                     wCount[ix], edit, (data_ptr)0);
    }

    TaskFree(0, (char *) wCount);
    for (ix = 0; ix < DE.numDlgs; ix++) {
        if (widgs[ix])
            TaskFree(0, (char *)widgs[ix]);
    }
    TaskFree(0, (char *) widgs);
}

/* : deSendUpdate - send dialog a message expressing changes to
 * specified members of the subject widget.  Message format:
 * DE_WIDGET_UPDATE, <#widgets>, <wlist1>, <wlist2>, ..., <wlistN>, where
 * wlist is: <wHandle>, <#members>,<mem1Name>,<val1>,..,<memJname>,<valJ>
 *
 * the <wlist> data is saved in DE.dialogs, then collected and sent
 * from deFlushWidgetUpdates();
 */
static void
deSendUpdate(w, widgs, num, edit, info)
AXWidget w;  /* addressee */
AXWidget *widgs;  /* list of subject widgets */
int num;  /* this many on list */
enum wEditType edit;
data_ptr info;  /* optional att-list */
{
    int ix, dlg_ix, me;
    data_ptr dtmp;
    de_message_holder *mh;
    
    if (!w || !widgs)
        return;

    /* first find index on DE.dialogs corresponding to passed widgets' dialog
     */
    for (dlg_ix = -1, ix = 0; ix < DE.numDlgs; ix++) {
        if ((AXWidget) widgs[0]->parent == DE.dialogs[ix].dlg) {
            dlg_ix = ix;
            break;
        }
    }
    if (-1 == dlg_ix)
        return;
    
    me = THIMpid;
    VfyContext(DE.dialogs[dlg_ix].dlg->taskOwner);

    for (ix = 0; ix < num; ix++) {
        /* look up this widgets' message_holder in DE.dialogs
         */
        mh = (de_message_holder *) NULL;
        axhGetItemI((void *) &widgs[ix], sizeof(AXWidget),
                    &DE.dialogs[dlg_ix].widgetUpdates,
                    (char *) 0, (char **) &mh);
        if (mh) {
            /* append att-value list to the message data;
             * note we alloc the list-list to num_lists+2
             * in case an additional list is appended, just below.
             */
            dtmp = deAddToUpdate(w, widgs[ix], edit, info);
            mh->lists = (data_ptr *) 
                TaskRealloc(0, mh->lists,
                            (mh->num_lists + 2) * sizeof(de_message_holder));
            mh->lists[mh->num_lists] = dtmp;
            mh->num_lists++;

            if ((W_RECT == widgs[ix]->type) &&
                deEditAffectsTabctlLinkage((AXWidget_rect)widgs[ix], edit, info)) {
                
                /* This is a tab-control that has just changed such that
                 * containee linkage may have changed.  Check _every_
                 * widget in the dbox for possible tablayer link changes....
                 */
                deRectSendMakeTablinks((AXWidget_dialog)DE.dialogs[dlg_ix].dlg, mh);
                if ((wMove == edit) || deIsPositionEdit(info)) {
                    /* send move-updates for any containees
                     */
                    deRectSendMoveContainees((AXWidget_rect)widgs[ix]);
                }
            }
            else {
                /* possibly append info to get the subject-dialog
                 * elftask to make/break tablayer links
                 */
                if (dtmp = deSendMakeTablinks(widgs[ix])) {
                    mh->lists[mh->num_lists] = dtmp; /* additional list */
                    mh->num_lists++;
                }
            }
                
            DE.dialogs[dlg_ix].doUpdate = TRUE;
        }
    }
    
    VfyContext(me);
    
    return;
}

/* : deAddToUpdate - add segment of message for one w, segment format:
 * <wHandle>, <#members>,<mem1Name>,<val1>,..,<memJname>,<valJ>
 */
static data_ptr /* caller must free */
deAddToUpdate(w, subjectWidget, edit, info)
AXWidget w; /* addressee */
AXWidget subjectWidget;
enum wEditType edit;
data_ptr info; /* optional att-list elf array */
{
    p32 pos;
    r32 size;
    AXWidget_handle wh;
    data_ptr tmp;
    data_ptr dp = AxMakeArray(3);

    switch(edit) {
    case wMove: /* mouse-move: send xpos and ypos */
        wh = HANDLE_FROM_WIDGET(subjectWidget);
        dp = AxWriteArray(dp, 0, AxMakeBinaryData(sizeof(wh), (char*)&wh));
        deElfPos(subjectWidget, &pos);
        dp = AxAddIntToArray(dp, 1, 2); /* as in 2 members */
        tmp = AxMakeArray(4);
        tmp = AxAddIntToArray(tmp, 0, DBDEXxpos);
        tmp = AxAddIntToArray(tmp, 1, pos.x);
        tmp = AxAddIntToArray(tmp, 2, DBDEXypos);
        tmp = AxAddIntToArray(tmp, 3, pos.y);
        dp = AxAddArrayToArray(dp, 2, tmp);
        break;
    case wResize: /* mouse-resize: send xpos, ypos, width, height */
        wh = HANDLE_FROM_WIDGET(subjectWidget);
        dp = AxWriteArray(dp, 0, AxMakeBinaryData(sizeof(wh), (char*)&wh));
        dp = AxAddIntToArray(dp, 1, 4); /* as in 4 members */
        deElfPos(subjectWidget, &pos);
        deElfSize(subjectWidget, &size);
        tmp = AxMakeArray(8);
        tmp = AxAddIntToArray(tmp, 0, DBDEXxpos);
        tmp = AxAddIntToArray(tmp, 1, pos.x);
        tmp = AxAddIntToArray(tmp, 2, DBDEXypos);
        tmp = AxAddIntToArray(tmp, 3, pos.y);
        tmp = AxAddIntToArray(tmp, 4, DBDEXwidth);
        tmp = AxAddIntToArray(tmp, 5, size.width);
        tmp = AxAddIntToArray(tmp, 6, DBDEXheight);
        tmp = AxAddIntToArray(tmp, 7, size.height);
        dp = AxAddArrayToArray(dp, 2, tmp);
        break;
    case wAtts: /* send elf array of att changes */
        wh = HANDLE_FROM_WIDGET(subjectWidget);
        dp = AxWriteArray(dp, 0, AxMakeBinaryData(sizeof(wh), (char*)&wh));
        dp = AxAddIntToArray(dp, 1,
                             AxArraySize(info) / 2); /* #att-val pairs */
        dp = AxAddArrayToArray(dp, 2, info);
        break;
    }
    return dp;
}

/* : deAddToDeferredSelection - add the passed widget handle to
 * DE.deferredSelection array; this array describes a set of widgets
 * that will take the selection during deFlushUpdatePokes (this is
 * done for pasted material)
 */
static void
deAddToDeferredSelection(w)
AXWidget w;
{
    int tmp;
    
    if (w) {
        tmp = DE.numDeferredSelected;
        DE.deferredSelection = (AXWidget *) TaskRealloc
            (0, DE.deferredSelection, (tmp + 1) * sizeof(AXWidget));
        DE.deferredSelection[tmp] = w;
        DE.numDeferredSelected++;
    }
}

/* : deRegisterUpdatePoke - store update poke for deferred
 * delivery.  delivery is performed via builtin, from dialog-level
 * elf code.
 */
static void
deRegisterUpdatePoke(reason)
int reason;
{
    int ix;
    intab *tab = &(DE.updatePokes);
    
    for (ix = 0; ix < tab->numInts; ix++) {
        if (tab->table[ix] == reason) {
            return;                         /* already there */
        }
    }
    if (tab->table) {
        tab->table = (int *) TaskRealloc(0, (char *) tab->table,
                                         (tab->numInts + 1) * sizeof(int));
        tab->table[tab->numInts] = reason;
        tab->numInts++;
    }
    else {
        tab->table = (int *) TaskAlloc(0, sizeof(int));
        tab->table[0] = reason;
        tab->numInts = 1;
    }
}

/* : deFlushUpdatePokes - send an updatePoke of each type found
 * in DE->updatePokes.
 */
static void
deFlushUpdatePokes()
{
    int ix;
    intab *tab = &(DE.updatePokes);

    DE.deferUpdatePokes = FALSE;
    
    if (!tab->numInts)
        return;
    
    for (ix = 0; ix < tab->numInts; ix++) {
        deSendUpdatePoke(tab->table[ix], FALSE);
    }
    tab->numInts = 0;
    TaskFree(0, tab->table);
    tab->table = (int *) NULL;

    if (DE.numDeferredSelected) {
        /* DE.deferredSelection holds a set of widget handles
         * which should now grab the selection ( pasted material, e.g.)
         */
        AXWidget tw;
        for (ix = 0; ix < DE.numDeferredSelected; ix++) {
            if (DE.deferredSelection && DE.deferredSelection[ix]) {
                tw = DE.deferredSelection[ix];
                setMark(tw);
            }
        }
        displayWidget(DE.deferredSelection, DE.numDeferredSelected, TRUE);
        DE.numDeferredSelected = 0;
        TaskFree(0, DE.deferredSelection);
        DE.deferredSelection = (AXWidget *) NULL;

        deSendUpdatePoke(DE_SELSET_CHANGED, FALSE);
    }
}

/* : deDeferUpdatePokes - set bool controlling whether
 * deSendUpdatePoke merely registers the poke (deferred)
 * or immediately delivers the poke
 */
static void
deDeferUpdatePokes()
{
    DE.deferUpdatePokes = TRUE;
}

/* : deSendUpdatePoke - prod de dialogs into doing update work */
void
deSendUpdatePoke(reason, defer)
int reason;                     /* in: description of type of change */
int defer;                      /* in: bool; whether to defer delivery */
{
    data_ptr message;
    
    if (defer) {
        deRegisterUpdatePoke(reason);
        return;
    }
    
        /* reason is taken into account in order to keep things
         * 'sparse'. (this is to minimize the effects of races.)
         * The update notify is done as a broadcast, but an editor
         * dialog reporting a widget's position needn't update
         * itself just because the selection set changed, e.g..
         */
    switch(reason) {
        case DE_DELETE_WIDGET: /* which also changes selset */
            message = AxMakeArray(3);
            message = AxAddIntToArray(message, 1, reason);
            message = AxAddIntToArray(message, 2, DE_SELSET_CHANGED);
            break;
        case DE_WIDGET_ATTS_CHANGED:
        case DE_SET_DIALOG_ATTS:
        case DE_SELSET_CHANGED:
        case DE_SELSET_CHANGED_BY_MENU:
        case DE_CLOSE_EDIT_SESSION:
        case DE_OPEN_EDIT_SESSION:
        case DE_COLORSET_CHANGED:
            message = AxMakeArray(2);
            message = AxAddIntToArray(message, 1, reason);
            break;
    }
    message = AxAddIntToArray(message, 0, DE_UPDATE_NOTIFY);
    XmPoker(POKE_DE_MESSAGE, message, (AXWidget_main)NULL, TRUE, TRUE);
    AxFreeData(message);
}

/* : deSendCreate - message expressing new widget to add to dialog
 */
static void
deSendCreate(w, cw, newWidget)
AXWidget w; /* addressee */
AXWidget cw;   /* subject widget */
wCreate *newWidget; /* re: subject widget */
{
    data_ptr message;
    data_ptr dp;
    int curflags;

    if (!newWidget->wInfo)
        return;

        /* do a construct-paint, then display the widget */
    paintWidgetForConstruct(cw);
    displayWidget(&cw, 1, TRUE);

        /* send the message, in format: DE_NEW_WIDGET, wType, data */
    message = AxMakeArray(3);
            /* keep wInfo around; send copy */
    dp = (data_ptr) ElfDataCopy ((data_ptr) newWidget->wInfo);
            /* since the widget's initial creation, the pos and
             * size may have changed; write these changes onto
             * the data_array for the widget */
    updateElfGadgetPosSize(THIMpid, dp, cw);
            /* display has been suppressed on the new widget; turn it
             * on now before reporting it */
    curflags = AxIntFromArray(dp, DBDEXflags);
    curflags &= (~WFLG_NODISPLAY);
    dp = AxAddIntToArray(dp, DBDEXflags, curflags);

    message = AxAddIntToArray(message, 0, DE_NEW_WIDGET);
    message = AxAddIntToArray(message, 1, newWidget->wType);
    message = AxAddArrayToArray(message, 2, dp);
    XmPoker(POKE_DE_MESSAGE, message, (AXWidget_main)w, TRUE, TRUE); /* send */
        /* keep a local copy for the editor's attr dlgs to read from */
    deCopyGadget(cw, dp);
    AxFreeData(message);
    
    if ((W_RECT == cw->type) && (RECT_LAYERED == cw->style)) {
        data_ptr dtmp = AxArrayElement(newWidget->wInfo, DBDEXtablayers);
        if (dtmp) {
            /* do creation-time full-init of tablayer info
             */
            SetTabLayers((AXWidget_rect) cw, dtmp, TRUE);
        }
    }
    
    /* do an update on this widget's position, just
     * to get it to check whether it should be connected
     * to any tabcontrol-style rects; it may have landed in one
     */
    deSendUpdate(w, &cw, 1, wMove, (data_ptr) 0);
    
    return;
}

static void
deDeleteSelected(dlg)
AXWidget_dialog dlg;
{
    int ix;

    for (ix = 0; ix < DE.numDlgs; ix++) {
        deDlgDeleteSelected((AXWidget_dialog)DE.dialogs[ix].dlg);
    }
}

static void
deDlgDeleteSelected(dlg)
AXWidget_dialog dlg;
{
    AXWidget tw, *wlist, tmp;
    wComposite *cp, *ctmp;
    int numWidgets, ix;
    int me = THIMpid;

    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
        
    if (dialogGone(dlg))
        return;
    for (tw = ((AXWidget_main)dlg)->widgets, numWidgets = 0; tw;
         tw = tw->nextChild) {
        if (tw->auxData && tw->auxData->wEdit.marked)
            numWidgets++;
    }
    if (!numWidgets)
        return;
    wlist = (AXWidget *) TaskAlloc(0, numWidgets * sizeof(AXWidget));
    for (tw = tmp = ((AXWidget_main)dlg)->widgets, ix = 0; tw;
         tw = tmp) {
        tmp = tw->nextChild;
        if (tw->auxData && tw->auxData->wEdit.marked) {
            wlist[ix++] = tw;
            liftWidget(tw);
            if ((W_RECT == tw->type) && (RECT_LAYERED == tw->style)) {
                /* reveal all tabcontrol layer containees first
                 */
                int l_x;
                AXWidget_rect rw = (AXWidget_rect) tw;
                for (l_x = 0; l_x < rw->tabctl.num_layers; l_x++) {
                    xmRectHideOrRevealLayer(rw, l_x, FALSE);
                }
            }
            VfyContext(tw->taskOwner);
            if (tw->auxData) {
                for (cp = ctmp = tw->auxData->compositeList; cp;
                     cp = ctmp) {
                    ctmp = cp->next;
                    if (cp->w && (cp->type == WLINKDOWN)) {
                        AxXtDestroyWidget(cp->w);
                        tmp = tw->nextChild;    /* could be null now */
                        cp->w = (AXWidget) NULL;
                    }
                }
            }
            AxXtDestroyWidget(tw);
            VfyContext(me);
        }
    }
    deSendUpdatePoke(DE_DELETE_WIDGET, DE.deferUpdatePokes);
    TaskFree(0, (char *) wlist );
}

/* getWidgetSizeM - used in deAlignWidgets() and setWidgetPositionM() *
 * This will return the size of the complete widget (getWidgetSize()) *
 * if wholeWidget is true else the size of one part of the composite  *
 * widget is returned (getSimpleSize()).                              *
 */
static void 
getWidgetSizeM(w, r, useMargins, wholeWidget)
AXWidget w;
r32 *r;
int useMargins, wholeWidget;
{
    if (!wholeWidget)
        getSimpleSize(w, r, useMargins);
    else
        getWidgetSize(w, r, useMargins);
}

/* setWidgetPositionM - used in deAlignWidgets() *
 * This is the same as setWidgetPosition() except*
 * it takes wholeWidget as an argument and calls *
 * getWidgetSizeM() instead of getWidgetSize()   *
 * This is needed in setting the size of a comp- *
 * -site widget when alignment is not done for   *
 * the whole widget.                             *
 */
static void
setWidgetPositionM(w, pt, wholeWidget)
AXWidget w;
p32 *pt; /* in: new position (including margin) */
int wholeWidget;
{
    p32 displ;
    r32 trect;
    wComposite *cp;
    int margin = deMarginSize(w);
 
    if (!w)
        return;
    getWidgetSizeM(w, &trect, TRUE, wholeWidget);
    if (DE.prefs.grid && DE.prefs.snapToGrid) {
        pt->x += margin;
        pt->y += margin;
        gridSnap(w, pt, pt);
        pt->x -= margin;
        pt->y -= margin;
    }
    displ.x = pt->x - trect.origin.x;
    displ.y = pt->y - trect.origin.y;
 
    if ((W_RECT == w->type) && (RECT_LAYERED == w->style) &&
        (w->tabctl_linktab)) {
 
        /* perform parallel move on all containees
         */
        int ix;
        hitem *list;
        widglink *wl;
        p32 tpt;
        r32 rtmp;
        for (ix = 0; ix < w->tabctl_linktab->width; ix++) {
            list = w->tabctl_linktab->table[ix];
            while (list) {
                wl = (widglink *) list->value;
                if (wl->direction) {
                    getWidgetSizeM(wl->to, &rtmp, TRUE, wholeWidget);
                    tpt.x = rtmp.origin.x + displ.x;
                    tpt.y = rtmp.origin.y + displ.y;
                    setWidgetPositionM(wl->to, &tpt, wholeWidget);
                }
                list = list->next;
            }
        }
    }
 
    if (w->type == W_OPTION) {
        AXWidget_option ow;
 
        ow = (AXWidget_option)w;
        ow->xpos += displ.x;
        ow->ypos += displ.y;
        if (ow->window) {
                /* for the option menu under edit, w->window
                 * is a pixmap; adjust its position here */
            ow->pulldown_xpos += displ.x;
            ow->pulldown_ypos += displ.y;
        }
            /* the composite kids are the pulldown buttons,
             * whose positions shouldn't be adjusted */
        return;
    }
    if (w->auxData) {
            /* apply same displacement to rest of composite group */
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->w) {
                cp->w->xpos += displ.x;
                cp->w->ypos += displ.y;
            }
        }
    }
    w->xpos += displ.x;
    w->ypos += displ.y;
    if (w->type == W_EDITBOX && ((AXWidget_editbox)w)->editbox) {
        setEditBoxSize((AXWidget_editbox)w, ((AXWidget_editbox)w)->editbox);
    }
}

/* temporarily defined here */
#define LEFT_ALIGN_M 1
#define RIGHT_ALIGN_M 2
#define TOP_ALIGN_M 3
#define BOTTOM_ALIGN_M 4
#define MAX_SPACING_WIDGETS 32

typedef struct SPACINGWIDGET SPACINGWIDGET;
struct SPACINGWIDGET {
    int dimension;
    AXWidget widget;
};

/* Computes and sets the (x,y) position of selected *
 * widgets based on the (x,y) of the anchor widget. *
 * Also handles any requests for spacing in the     *
 * dialog box - horizontal or vertical
 */
static void
deAlignWidgets(dlg, info)
AXWidget_dialog dlg;
data_ptr info;
{
    int ix, align, alignedPos, numWidgets, iAtt;
    AXWidget anchorWidget, tw;
    p32 newP, wp;
    r32 wsize;
    data_ptr attsAccepted, message, wdata;
    int wholeWidget;
    int me = THIMpid;

    int min, spacing, startPos, total, interWidgetSpacing, dlgDimension;
    SPACINGWIDGET *list[MAX_SPACING_WIDGETS];
 
    if (dlg->type == W_MAIN)
         dlg = ((AXWidget_main)dlg)->dialog;
 
    if (dialogGone(dlg))
        return;
 
    VfyContext(dlg->taskOwner);
 
    /* Get the Anchor Widget Handle from info */
    wdata = AxArrayElement(info, 5);
    anchorWidget = WidgetPointerFromHandleData(wdata);
 
    /* Get the type of Alignment required */
    align = AxIntFromArray(info, 2);

    /* Get the type of Spacing required */
    spacing = AxIntFromArray(info, 3);
    if (spacing == 1)   /* vertical */
        dlgDimension = dlg->height;
    else if (spacing == 2)  /* horizontal */
        dlgDimension = dlg->width;

    /* For entry box RadioButton etc -  use label or use box */
    wholeWidget = AxIntFromArray(info, 4); 

    /* Get the size attrs (x,y,w,h) in "C" units */
    getWidgetSizeM(anchorWidget, &wsize, TRUE, wholeWidget);
    /* Does this require going thru the auxdata ?? */
    switch(align) {
        case LEFT_ALIGN_M:
            alignedPos = wsize.origin.x;
            break;
        case RIGHT_ALIGN_M:
            alignedPos = wsize.origin.x + wsize.width;
            break;
        case TOP_ALIGN_M:
            alignedPos = wsize.origin.y;
            break;
        case BOTTOM_ALIGN_M:
            alignedPos = wsize.origin.y + wsize.height;
            break;
        default:
            alignedPos = -1;
            break;
    }
 
    for (tw = ((AXWidget_main)dlg)->widgets, numWidgets = 0; tw;
        tw = tw->nextChild) {
        if (tw->auxData && tw->auxData->wEdit.marked)
            numWidgets++;
    }
    if (!numWidgets)
        return;
    
    total = 0; 
    message = AxMakeArray(numWidgets + 2);
    message = AxAddIntToArray(message, 0, DE_WIDGET_UPDATE);
    /* Calculate the new xpos or ypos for each selected widget */
    /* and Set these on the widget */
    for (tw = ((AXWidget_main)dlg)->widgets, ix = 0; tw; tw = tw->nextChild) {
        if (tw->auxData && tw->auxData->wEdit.marked) {
            preEdit(tw);
            attsAccepted = AxMakeArray(2);
            getWidgetSizeM(tw, &wsize, TRUE, wholeWidget);
 
            wp.x = wsize.origin.x;
            wp.y = wsize.origin.y;
            switch (align) {
                case LEFT_ALIGN_M:
                    wp.x = alignedPos;
                    setWidgetPositionM(tw,&wp, wholeWidget);
                    attsAccepted = AxAddIntToArray(attsAccepted, 0, DBDEXxpos);
                    deElfPos(tw, &newP);
                    iAtt = newP.x;
                    attsAccepted = AxAddIntToArray(attsAccepted, 1, iAtt);
                    break;
                case RIGHT_ALIGN_M:
                    wp.x = alignedPos - wsize.width;
                    setWidgetPositionM(tw,&wp, wholeWidget);
                    attsAccepted = AxAddIntToArray(attsAccepted, 0, DBDEXxpos);
                    deElfPos(tw, &newP);
                    iAtt = newP.x;
                    attsAccepted = AxAddIntToArray(attsAccepted, 1, iAtt);
                    break;
                case TOP_ALIGN_M:
                    wp.y = alignedPos;
                    setWidgetPositionM(tw,&wp, wholeWidget);
                    attsAccepted = AxAddIntToArray(attsAccepted, 0, DBDEXypos);
                    deElfPos(tw, &newP);
                    iAtt = newP.y;
                    attsAccepted = AxAddIntToArray(attsAccepted, 1, iAtt);
                    break;
                case BOTTOM_ALIGN_M:
                    wp.y = alignedPos - wsize.height;
                    setWidgetPositionM(tw,&wp, wholeWidget);
                    attsAccepted = AxAddIntToArray(attsAccepted, 0, DBDEXypos);
                    deElfPos(tw, &newP);
                    iAtt = newP.y;
                    attsAccepted = AxAddIntToArray(attsAccepted, 1, iAtt);
                    break;
                default:
                    break;
            }
            if (spacing == 1) { /* vertical */
                total = total + wsize.height;
                list[ix] = (SPACINGWIDGET *)malloc(sizeof(SPACINGWIDGET));
                list[ix]->widget = tw;
                list[ix]->dimension = wsize.origin.y;
            }
            else if (spacing == 2) {    /* horizontal */
                total = total + wsize.width;
                list[ix] = (SPACINGWIDGET *)malloc(sizeof(SPACINGWIDGET));
                list[ix]->widget = tw;
                list[ix]->dimension = wsize.origin.x;
            }
            else {
                paintWidgetForConstruct(tw);
                displayWidget(&tw, 1, TRUE);
                message = AxAddArrayToArray(message, ix+2,
                            deAddToUpdate((AXWidget)dlg->parent, tw, wAtts, attsAccepted));
            }
            ix++;   
                
        }
    }

    if (total) {
        /* Free the previous message */
/*
        AxFreeData(message);
        message = AxMakeArray(numWidgets + 2);
        message = AxAddIntToArray(message, 0, DE_WIDGET_UPDATE);
*/
        /* sort list according to increasing dimension */
        for(ix=0;ix<numWidgets;ix++) {
            SPACINGWIDGET *tmp;
            int jx;
            min = list[ix]->dimension;
            for(jx=ix+1;jx<numWidgets;jx++) {
                if (list[jx]->dimension < min) {
                    min = list[jx]->dimension;
                    tmp = list[jx];
                    list[jx] = list[ix];
                    list[ix] = tmp;
                }   
            }
        }

        /* initialize starting position */
        startPos = 0;
        interWidgetSpacing = (dlgDimension-total)/(numWidgets+1);
        if (spacing == 1) { /* vertical */
            for (ix=0;ix<numWidgets;ix++) {
                tw = list[ix]->widget;
                attsAccepted = AxMakeArray(2);
                getWidgetSize(tw, &wsize, TRUE);
                wp.x = wsize.origin.x;
                wp.y = startPos + interWidgetSpacing;
                startPos = wp.y + wsize.height;
                setWidgetPosition(tw,&wp);
                deElfPos(tw, &newP);
                attsAccepted = AxAddIntToArray(attsAccepted, 0, DBDEXypos);
                iAtt = newP.y;
                attsAccepted = AxAddIntToArray(attsAccepted, 1, iAtt);
                attsAccepted = AxAddIntToArray(attsAccepted, 2, DBDEXxpos);
                iAtt = newP.x;
                attsAccepted = AxAddIntToArray(attsAccepted, 3, iAtt);
                paintWidgetForConstruct(tw);
                displayWidget(&tw, 1, TRUE);
                message = AxAddArrayToArray(message, ix+2,
                            deAddToUpdate((AXWidget)dlg->parent, tw, wAtts, attsAccepted));
            }
        }
        else {  /* horizontal */
            for (ix=0;ix<numWidgets;ix++) {
                tw = list[ix]->widget;
                attsAccepted = AxMakeArray(2);
                getWidgetSize(tw, &wsize, TRUE);
                wp.y = wsize.origin.y;
                wp.x = startPos + interWidgetSpacing;
                startPos = wp.x + wsize.width;
                setWidgetPosition(tw,&wp);
                deElfPos(tw, &newP);
                attsAccepted = AxAddIntToArray(attsAccepted, 0, DBDEXypos);
                iAtt = newP.y;
                attsAccepted = AxAddIntToArray(attsAccepted, 1, iAtt);
                attsAccepted = AxAddIntToArray(attsAccepted, 2, DBDEXxpos);
                iAtt = newP.x;
                attsAccepted = AxAddIntToArray(attsAccepted, 3, iAtt);
                paintWidgetForConstruct(tw);
                displayWidget(&tw, 1, TRUE);
                message = AxAddArrayToArray(message, ix+2,
                            deAddToUpdate((AXWidget)dlg->parent, tw, wAtts, attsAccepted));
            }
        }
/*
        for(ix=0;ix<numWidgets;ix++) 
            free(list[ix]);
*/
            
    }

    message = AxAddIntToArray(message, 1, numWidgets);
    XmPoker(POKE_DE_MESSAGE, message, dlg->parent, TRUE, TRUE);
    AxFreeData(message);
    VfyContext(me);
}

static void
deChangeSelected(dlg, info)
AXWidget_dialog dlg;
data_ptr info;
{
    int ix;

    for (ix = 0; ix < DE.numDlgs; ix++) {
        deDlgChangeSelected((AXWidget_dialog)DE.dialogs[ix].dlg, info);
    }
}

    /* set the specified attrs on the set of selected widgets.
     *
     * info format: <DE_WIDGET_ATTS><opType><[type]>,
     *                 <#atts><att1name><att1val><att2name><att2val>,...
     */
static void
deDlgChangeSelected(dlg, info)
AXWidget_dialog dlg;
data_ptr info; /* elfarray describing what changes to make */
{
    int numWidgets, opType, wType;
    AXWidget tw;
    data_ptr attsAccepted;

    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
        
    if (dialogGone(dlg))
        return;

    opType = AxIntFromArray(info, 1);     /* e.g., "apply to all of a type" */
    if (opType == DE_APPLYSET_WTYPE) {
        wType = AxIntFromArray(info, 2);  /* e.g., "type == DLG_RECT" */
    }
    else if (opType != DE_APPLYSET_ALL_SELECTED)
        return;
        
    for (tw = ((AXWidget_main)dlg)->widgets, numWidgets = 0; tw;
         tw = tw->nextChild) {
        if (tw->auxData && tw->auxData->wEdit.marked)
            numWidgets++;
    }
    
    if (!numWidgets)
        return;

    for (tw = ((AXWidget_main)dlg)->widgets; tw; tw = tw->nextChild) {
        if (tw->auxData && tw->auxData->wEdit.marked) {
            if (opType == DE_APPLYSET_WTYPE &&
                    deElfWidgetType(tw) != wType) {
                
                /* skip this widget, not of requested type
                 */
                numWidgets--;
                continue;
            }
            
            /* apply the attr settings to the widget
             */
            if (attsAccepted = deApplyAtts(tw, info, 3)) {
                deSendUpdate(tw, &tw, 1, wAtts, attsAccepted);
            }
            else {
                        /* none of the attr settings applied, so.. */
                numWidgets--;
            }
        }
    }
    return;
}

    /* set the specified attrs on the set of listed widgets
     * info format:
     * 
     *  <DE_WIDGET_ATTS><DE_APPLYSET_HANDLE><#widgets><w1 data><w2 data>,...
     * 
     * w<n>data:
     *  <wHandle><#members><att1name><att1val><att2name><att2val>,...
     */
static void
deChangeByHandle(dlg, info)
AXWidget_dialog dlg;
data_ptr info; /* elfarray describing what changes to make */
{
    int ix, numWidgets;
    AXWidget tw, subjectWidget;
    data_ptr attsAccepted, wdata;

    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
        
    if (dialogGone(dlg))
        return;
    
    numWidgets = AxIntFromArray(info, 2);
    if (!numWidgets)
        return;

    /* for each of the passed widget handles, apply the
     * corresponding changes
     */
    for (ix = 0; ix < numWidgets; ix++) {
        
        wdata = AxArrayElement(info, ix + 3);
        subjectWidget = 
            WidgetPointerFromHandleData(AxArrayElement(wdata, 0));
        
        for (tw = ((AXWidget_main)dlg)->widgets; tw; tw = tw->nextChild) {
            
            if (tw == subjectWidget) {
                /* apply the attr settings to the widget
                 */
                if (attsAccepted = deApplyAtts(tw, wdata, 1)) {
                    deSendUpdate(tw, &tw, 1, wAtts, attsAccepted);
                }
            }
        }
    }
}


    /* info format: <DE_SET_DIALOG_ATTS>
     *  <#atts>,<name1>,<val1>,..,<nameN>,<valN>. */
static void
deSetDialogAtts(dlg, info)
AXWidget_dialog dlg;
data_ptr info; /* elfarray of current editable set of dlg atts */
{
    int ix, dex, numAtts, attName;
    int jx, numStored, sdex;
    int me = THIMpid;
    if (dialogGone(dlg) || !dlg->auxData || !dlg->auxData->gadget) {
        return;
    }
        /* fold passed, sparse atts onto locally stored, complete copy.
         * both passed and currently stored copies in same format */
    VfyContext(dlg->taskOwner);
    numAtts = AxIntFromArray(info, 1);
    if (!numAtts) {
        return;
    }
    numStored = AxIntFromArray(dlg->auxData->gadget, 0);
    for (ix = 0, dex = 2; ix < numAtts; ix++, dex += 2) {
        attName = AxIntFromArray(info, dex);
        for (jx = 0, sdex = 1; jx < numStored; jx++, sdex += 2) {
            if (AxIntFromArray(dlg->auxData->gadget, sdex) == attName) {
                if (attName == DB_width || attName == DB_height) {
                        /* these two can be distinct under mt, ol; but, the
                         * passed data on info is always just one or other */
                    data_ptr newdp, stored;
                    stored = AxArrayElement(dlg->auxData->gadget, sdex + 1);
                    if (AxIsArray(stored)) {
                        stored = AxAddIntToArray
                            (stored, 0,
                             AxIntFromArray(info, dex + 1));
                    }
                    else {
                            /* make it an array, store same for ol, mt */
                        newdp = AxMakeArray(2);
                        newdp = AxAddIntToArray
                            (newdp, 0, AxIntFromArray(info, dex + 1));
                        newdp = AxAddIntToArray
                            (newdp, 1, AxIntFromArray(info, dex + 1));
                        dlg->auxData->gadget = 
                            AxAddArrayToArray
                                (dlg->auxData->gadget,
                                 sdex + 1, ElfDataCopy(newdp));
                        AxFreeData(newdp);
                    }
                }
                else if (AxIsArray(info)) {
                    dlg->auxData->gadget = 
                        AxAddArrayToArray
                            (dlg->auxData->gadget, sdex + 1,
                             ElfDataCopy(AxArrayElement(info, dex + 1)));
                }
                else if (AxIsString(AxArrayElement(info, dex + 1))) {
                    dlg->auxData->gadget =
                                AxAddStrToArray(dlg->auxData->gadget,
                                                sdex + 1,
							                    AxStrFromArray(info, dex + 1));
                }
                else if (AxIsInt(AxArrayElement(info, dex + 1))) {
                    dlg->auxData->gadget =
                                AxAddIntToArray(dlg->auxData->gadget,
                                                sdex + 1,
							                    AxIntFromArray(info, dex + 1));
                }
            }
        }
    }
        /* relay new info to subject dialog */
    XmPoker(POKE_DE_MESSAGE, info, dlg->parent, TRUE, TRUE);
    deSendUpdatePoke(DE_SET_DIALOG_ATTS, DE.deferUpdatePokes);
    VfyContext(me);
}

#define MAX_ARGS 51 /* corresponds with elxwins max #buttons number */

/* : deApplyAtts - apply a list of attr changes to a widget.
 * determines which of the passed list of attrs actually applies
 * to the widget type, and builds the return list of 'accepted' atts
 * while setting those accepted atts on the widget_t instance. (The
 * work done on the widget_t must correspond to the elxwins.c create
 * code; it would be clean not to do anything here but return the
 * appropriate accepted atts info, and lift the widget instance, letting
 * elfb echo the update, but display here first for quicker visual effect
 */
static data_ptr /* which caller must free if nonnull */
deApplyAtts(w, info, info_offset)
AXWidget w;
data_ptr info;     /* proposed atts */
int info_offset;   /* starting offset into info */
{
        /* info format:
         *         <whatever..><#atts>,<name1>,<val1>,..,<nameN>,<valN>.
         *         (deApplyAtts cares about segment starting at <#atts>,
         *          and uses info_offset to find the start of this seg)
         * output format: <a1>,<val1>,<a2>,<val2>,..,<aM>,<valM>, where
         * a1,a2,.. are the 'accepted' atts' names */
    data_ptr attsAccepted;
    Arg args[MAX_ARGS];
    int ix, jx, kx, numAtts, numTaken, iAtt, margin, size, attx;
    mbchar *sAtt;
    data_ptr eAtt, accels;
    wComposite *cp;
    int me = THIMpid;
    int reMeasure = FALSE;
    int doLift = FALSE;
    int doRepaint = TRUE;
    int liftMarks = FALSE;
    int thisAtt, curFlags;
    p32 tpt, displ;
    mbchar *bName;
        /* make 2 separate for push and toggle buttons??  DAM */    
    AXWidget *buttons;
    AXWidget label;
    AXWidget_list listw;
    mbchar *valid_chars;

    if (!w || !info)
        return ((data_ptr) NULL);
    
    margin = deMarginSize(w);
    numAtts = AxIntFromArray(info, info_offset);
    
    if (!numAtts)
        return ((data_ptr) NULL);
    VfyContext(w->parent->taskOwner);
    attsAccepted = AxMakeArray(numAtts * 2);
    preEdit(w);
    for (attx = 0, ix = info_offset + 1, numTaken = 0;
         attx < numAtts; attx++, ix += 2) {
        
        switch(thisAtt = AxIntFromArray(info, ix)) {
            
            case DBDEXflags: /* all widgets accept flags */
            case DBDEXclear_flags:
                iAtt = AxIntFromArray(info, ix + 1);
                if (thisAtt == DBDEXflags && (iAtt & WFLG_NODISPLAY)) {
                    doLift = TRUE; /* we're setting nodisplay */
                    liftMarks = TRUE;
                }
                attsAccepted = AxAddIntToArray(attsAccepted, 
                                               numTaken * 2, thisAtt);
                attsAccepted = AxAddIntToArray(attsAccepted, 
                                               (numTaken * 2) + 1, iAtt);
                XtSetArg(args[0], XmNflags, &curFlags);
                AxXtGetValues(w, args, 1);
                if (thisAtt == DBDEXflags) {
                    curFlags |= iAtt;
                }
                else {
                    curFlags &= ~iAtt;
                }
                XtSetArg(args[0], XmNflags, curFlags);
                deCompositeSetValues(w, args, 1);
                numTaken++;
                break;
                
            case DBDEXid: /* all; id has no c-side correspondent; just echo */
                sAtt = AxStrPtrFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2, DBDEXid);
                attsAccepted = AxAddStrToArray(attsAccepted,
                                               (numTaken * 2) + 1, sAtt);
                numTaken++;
                break;
                
            case DBDEXtitle: /* all; set directly onto w->name */
                sAtt = AxStrPtrFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2, DBDEXtitle);
                attsAccepted = AxAddStrToArray(attsAccepted,
                                               (numTaken * 2) + 1, sAtt);
                if (MBstrcmp(w->name, sAtt)) {
                    SetNWidgetName(w, sAtt, MAX_NAME);
                    adjustForTitle(w);
                }
                numTaken++;
                break;
                
            case DBDEXxpos: /* all */
                iAtt = AxIntFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2, DBDEXxpos);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               (numTaken * 2) + 1, iAtt);
                deElfPos(w, &tpt);
                displ.x = iAtt - tpt.x;
                if (displ.x) {
                    tpt.x += displ.x;
                    tpt.x -= margin;
                    tpt.y -= margin;
                    setWidgetPosition(w, &tpt);
                }
                numTaken++;
                break;
                
            case DBDEXypos: /* all */
                iAtt = AxIntFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2, DBDEXypos);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               (numTaken * 2) + 1, iAtt);
                deElfPos(w, &tpt);
                displ.y = iAtt - tpt.y;
                if (displ.y) {
                    tpt.y += displ.y;
                    tpt.x -= margin;
                    tpt.y -= margin;
                    setWidgetPosition(w, &tpt);
                }
                numTaken++;
                break;
                
            case DBDEXvalue:
                if (w->type == W_RADIO ||
                        w->type == W_OPTION ||
                        w->type == W_SCALE ||
                        w->type == W_BUTTON ||
                        w->type == W_TOGGLE) {
					
					iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXvalue);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], XmNvalue, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                else if (w->type == W_ENTER) {
                            /* editbox and list should be handled, too.. */
                    sAtt = AxStrPtrFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXvalue);
                    attsAccepted = AxAddStrToArray(attsAccepted,
                                                   (numTaken * 2) + 1, sAtt);
                    XtSetArg(args[0], XmNvalue, sAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
				else if (w->type == W_COMBO_BOX) {
					/* The combo expects the Nvalue AxArg to hold an
					 * elf datum, which may be either int or string.
					 * Dialog editor always sets int, tho..
					 */
					iAtt = AxIntFromArray(info, ix + 1);
					eAtt = AxMakeIntData(iAtt);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXvalue);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], XmNvalue, eAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
				}
                break;
                
            case DBDEXstrs:
                if (w->type == W_RADIO || w->type == W_OPTION ||
                    w->type == W_COMBO_BOX) {
                    eAtt = AxArrayFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXstrs);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     ElfDataCopy(eAtt));
					numTaken++;
                    size = AxArraySize(eAtt);
                }
				
				if (w->type == W_RADIO) {
					/* test whether to reassign accelerator keys
					 * based on the possible change in layernames
					 */
					accels = deFoldAccelerators(w, eAtt);
					if (NULL != accels) {
						attsAccepted =
							AxAddIntToArray(attsAccepted,
											numTaken * 2,
											DBDEXaccelerator_key);
						attsAccepted =
							AxAddArrayToArray(attsAccepted,
											  (numTaken * 2) + 1,
											  ElfDataCopy(accels));
						numTaken++;
					}
					else {
						accels = (data_ptr) NULL;
					}
				}
				
#if AXMS
                if (w->type == W_RADIO) {
#else
                if (w->type == W_RADIO || w->type == W_OPTION) {
#endif
                    /* the widget_t representation of the strs for these
                     * wtypes is the w->buttons array.  It will need to
                     * be destroyed then recreated to effect the change
                     */
                    if ( w->type == W_RADIO ) {
                        AXWidget_radio wr;

                        wr = (AXWidget_radio) w;
                        for (jx = 0; jx < wr->num_buttons; jx++) {
                            AxXtDestroyWidget((AXWidget)wr->buttons[jx]);
                            wr->buttons[jx] = (AXWidget_togglebutton) NULL;
                        }
                        wr->num_buttons = 0;
                    }
                    ((AXWidget_radio)w)->num_buttons = 0;
                    buttons = (AXWidget *) TaskAlloc
                        (0, size * sizeof(AXWidget_togglebutton));
                    if (w->type == W_RADIO) {
                            /* get 1st new choice just under label */
                        w->height = 0;
                    }
                    for (jx = 0; jx < size; jx++) {
                        kx = 0;
                        XtSetArg(args[kx], XmNoldWidget, 0); kx++;
                        XtSetArg(args[kx], XmNflags, w->flags); kx++;
                        XtSetArg(args[kx], XmNwhichButton,Button1); kx++;
                        if (w->auxData && w->auxData->gadget) {
                            data_ptr dtmp;
                            dtmp = AxArrayElement(w->auxData->gadget,
                                                  DBDEXfontAttr);
                            XtSetArg(args[kx], XmNaxFont, dtmp); kx++;
                            dtmp = AxArrayElement(w->auxData->gadget,
                                                  DBDEXtextShadow);
                            XtSetArg(args[kx], AXmNtextShadow, dtmp); kx++;
                        }
                        bName = AxStrPtrFromArray(eAtt, jx);
                        if (w->type == W_RADIO) {
                            XtSetArg(args[kx], XmNset, jx == w->value); kx++;
                            CALLBACKER(Callback, ElfXCradioPushed, jx);
                            XtSetArg(args[kx],
                                XmNvalueChangedCallback,Callback); kx++;
                            buttons[jx] = (AXWidget)
                                AXmCreateToggleButtonGadget(w,
                                                            bName, args, kx);
                        }
                        else if (w->type == W_OPTION) {
                            CALLBACKER(Callback, ElfXCchoicePushed, jx);
                            XtSetArg(args[kx], XmNactivateCallback,Callback); 
                            kx++;
                            buttons[jx] = (AXWidget)
                                AXmCreateToggleButtonGadget(w, bName, args, kx);
                        }
                        if (w->type == W_OPTION && jx == w->value) {
                            XtSetArg(args[0], XmNmenuHistory, buttons[jx]);
                            AxXtSetValues(w, args, 1);
                        }
                        if (w->event_table) {
                            copyEventHandlerList(w->event_table,
                                &(buttons[jx])->event_table);
                        }
                    }
                        /* redo the composite link info */
                    if (w->type == W_RADIO && w->auxData) {
                                /* for radios, ferret out the label handle */
                        label = NULL;
                        for (cp=w->auxData->compositeList; cp; cp=cp->next) {
                            if (cp->w && (cp->type == WLINKDOWN) &&
                                    (cp->w->type == W_LABEL)) {
                                label = cp->w;
                            }
                        }
                            /* toss the compositeList, and reinstall */
                        removeCompositeList(w);
                        ebDoRadioCompositeLinks(w, label, buttons, size);
                    }
                    if (w->type == W_OPTION && w->auxData) {
                            /* toss the compositeList, and reinstall */
                        removeCompositeList(w);
                        ebDoOptionCompositeLinks(w, buttons, size);
                    }
					if (W_RADIO == w->type && accels) {
						/* accel keys were redone above; reapply to widget
						 */
						SetWidgetAccelerator(w, accels);
					}
                    TaskFree(0, (char *) buttons);
                    reMeasure = TRUE;
                }
#if AXMS
                else if (w->type == W_OPTION) {
#else
                else if (w->type == W_COMBO_BOX) {
#endif
                    char **strings, *this_str;
                    
                    strings = (char **) malloc(size * sizeof(char *));
                    for (jx = 0; jx < size; jx++) {
                        this_str = AxStrFromArray(eAtt, jx);
                        strings[jx] = (char *) malloc (strlen(this_str)+ 1);
                        strcpy(strings[jx], this_str);
                    }
                    SetWidgetItemCount(w, size);
                    SetWidgetItems(w, strings);
                    for (jx = 0; jx < size; jx++) {
                        free(strings[jx]);
                    }
                    free(strings);
                }
                break;
                
            case DBDEXwidth:
                if (w->type == W_SCALE ||
                        w->type == W_RECT ||
                        w->type == W_BUTTON ||
                        w->type == W_ENTER ||
                        w->type == W_LIST ||
                        w->type == W_COMBO_BOX ||
                        w->type == W_EDITBOX ||
                        w->type == W_TABLE ||
                        w->type == W_CANVAS) {
                    int curWidth, newWidth, displacement;
                    r32 trect;
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXwidth);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    deElfSize(w, &trect);
                    if (trect.width != iAtt) {
                        if (w->type == W_LIST) {
                            AXWidget_dialog dw = (AXWidget_dialog)w->parent;
                            newWidth = wListPixWidth(iAtt,
                                                     dw->revstamp,
                                                     dw->referenceFont);
                            curWidth = w->width;
                            displacement = newWidth - curWidth;
                        }
                        else if (w->type == W_ENTER) {
                            newWidth = wEnterPixWidth(iAtt, w->font,
                                                      w->textShadow);
                            curWidth = w->width;
                            displacement = newWidth - curWidth;
                        }
                        else {
                            newWidth = iAtt;
                            displacement = newWidth - trect.width;
                        }
                        deChangeWidgetWidth(w, displacement);
                    }
                    numTaken++;
                }
                break;
                
            case DBDEXheight:
                if (w->type == W_RECT ||
                        w->type == W_BUTTON ||
                        w->type == W_LIST ||
                        w->type == W_EDITBOX ||
                        w->type == W_TABLE ||
                        w->type == W_CANVAS) {
                    int curHeight, newHeight, displacement;
                    r32 trect;
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXheight);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    deElfSize(w, &trect);
                    if (trect.height != iAtt) {
                        if (w->type == W_LIST) {
                            listw = (AXWidget_list) w;
                            newHeight = wListPixHeight(iAtt, listw->font,
                                                       listw->textShadow,
                                                       listw->list_hscroll);
                            curHeight = w->height;
                            displacement = newHeight - curHeight;
                        }
                        else {
                            newHeight = iAtt;
                            displacement = newHeight - trect.height;
                        }
                        deChangeWidgetHeight(w, displacement);
                    }
                    numTaken++;
                }
                break;
                
            case DBDEXlength:
                if (w->type == W_ENTER) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXlength);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], XmNmaxLength, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXno_title:
                    /* "no_title" has 3 values: left label, top label, none
                     */
                if (w->type == W_ENTER) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXno_title);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0],ZXmNstyle, iAtt);
                    AxXtSetValues(w, args, 1);
                    reMeasure = TRUE;
                    numTaken++;
                }
                break;
                
            case DBDEXmulti_pick:
                if (w->type == W_LIST || w->type == W_BUTTON) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXmulti_pick);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    ((AXWidget_list)w)->multi_pick = (iAtt != 0);
                    numTaken++;
                }
                break;
                
            case DBDEXhoriz_scroll:
                if (w->type == W_LIST || w->type == W_CANVAS) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXhoriz_scroll);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0],AXmNlistHScroll, iAtt != 0);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXthickness:
                if (w->type == W_BUTTON || w->type == W_RECT ||
                    w->type == W_TABLE || w->type == W_CANVAS) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXthickness);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], XmNthickness, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXdflt:
                if (w->type == W_BUTTON) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXdflt);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    numTaken++;
                }
                break;
                
            case DBDEXtype:
                if (w->type == W_BUTTON) {
                    AXWidget_pushbutton pw;
                    
                    pw = (AXWidget_pushbutton)w;
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXtype);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    jx = 0;
                    if (pw->buttonType == DLG_ICON_BUTTON &&
                                iAtt != DLG_ICON_BUTTON) {
                        XtSetArg(args[jx], XmNlabelPixmap, FALSE); jx++;
                    }
                    else if (pw->buttonType != DLG_ICON_BUTTON &&
                                iAtt == DLG_ICON_BUTTON) {
                        XtSetArg(args[jx], XmNlabelPixmap, TRUE); jx++;
                    }
                    XtSetArg(args[jx], XmNbuttonType, iAtt); jx++;
                    AxXtSetValues((AXWidget)pw, args, jx);
                    numTaken++;
                }
                break;
                
            case DBDEXstyle:
                if (w->type == W_RECT) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXstyle);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    
                    XtSetArg(args[0], ZXmNstyle, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXtablayers:
                if (w->type == W_RECT) {
                    /* the incoming data is not the full tablayers info,
                     * only the tablayer names.  If names are different,
                     * then lift the widget.
                     */
                    eAtt = AxArrayElement(info, ix + 1);
                    if (eAtt) {
                        if (deDifferentTablayerNames((AXWidget_rect)w, eAtt)) {
                            doLift = TRUE;
                        }
                        doRepaint = FALSE; /* insufficient info for painting */
                        attsAccepted = AxAddIntToArray(attsAccepted,
                                                       numTaken * 2,
                                                       DBDEXtablayers);
                        attsAccepted =
                            AxAddArrayToArray(attsAccepted,
                                              (numTaken * 2) + 1,
                                              ElfDataCopy(eAtt));
                        numTaken++;
						
						/* test whether to reassign accelerator keys
						 * based on the possible change in layernames
						 */
						accels = deFoldAccelerators(w, eAtt);
						if (NULL != accels) {
							attsAccepted =
								AxAddIntToArray(attsAccepted,
												numTaken * 2,
												DBDEXaccelerator_key);
							attsAccepted =
								AxAddArrayToArray(attsAccepted,
												  (numTaken * 2) + 1,
												  ElfDataCopy(accels));
							numTaken++;
							AxFreeData(accels);
						}
                    }
                }
                break;
                
            case DBDEXactive_tablayer:
                if (w->type == W_RECT) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXactive_tablayer);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    numTaken++;
                }
                break;
                
            case DBDEXhelpid:
                if (w->type == W_BUTTON ||
                        w->type == W_TOGGLE ||
                        w->type == W_LIST ||
                        w->type == W_TABLE || w->type == W_CANVAS) {
                    int helpid;
                    sAtt = AxStrPtrFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2, DBDEXhelpid);
                    attsAccepted = AxAddStrToArray(attsAccepted,
                                                   (numTaken * 2) + 1, sAtt);
                    if (sAtt[0])
                        helpid = atoi(sAtt);
                    if ( sAtt ) {
                        kx = 0;
                        XtSetArg(args[kx], XmNhelpStr, sAtt); kx++;
                        XtSetArg(args[kx], XmNmenuHelpWidget, helpid); kx++;
                        AxXtSetValues(w, args, kx);
                    }
                    numTaken++;
                }
                break;
                
            case DBDEXvalid_chars:
                if (w->type == W_ENTER) {
                    sAtt = AxStrPtrFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXvalid_chars);
                    attsAccepted = AxAddStrToArray(attsAccepted,
                                                   (numTaken * 2) + 1, sAtt);
                    if (!sAtt[0])
                        valid_chars = NULL;
                    else
                        valid_chars = sAtt;
                    XtSetArg(args[0], XmNtextOptions, valid_chars);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXfg_color:
                iAtt = AxIntFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2,
                                               DBDEXfg_color);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               (numTaken * 2) + 1, iAtt);
                if (w->type == W_LIST || w->type == W_EDITBOX) {
                        /* shouldn't have been done as a bool.. */
                    XtSetArg(args[0], AXmNuseWorkColors, iAtt != 0);
                }
                else {
                    XtSetArg(args[0], XmNfg_color, iAtt);
                }
                deCompositeSetValues(w, args, 1);
                numTaken++;
                break;
                
            case DBDEXbg_color:
                if (w->type == W_ICON || w->type == W_BUTTON) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXbg_color);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], XmNbg_color, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXhide_vscroll:
                if (w->type == W_LIST || w->type == W_CANVAS) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXhide_vscroll);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0],AXmNhideListVScroll, iAtt != 0);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXfontAttr:
                if (w->type == W_RADIO || w->type == W_OPTION ||
                    w->type == W_ENTER || w->type == W_EDITBOX ||
                    w->type == W_COMBO_BOX ||
                    w->type == W_LIST || w->type == W_TABLE) {
                    
                    int isString;
                    
                    eAtt = AxArrayElement(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXfontAttr);
                    
                    eAtt = deCompleteFontAttr(w, DBDEXfontAttr, eAtt,
                                              &isString);
                    if (isString) {
                        attsAccepted = AxAddStrToArray
                            (attsAccepted, (numTaken * 2) + 1, SX(eAtt)->text);
                    }
                    else {
                        attsAccepted = AxAddArrayToArray
                            (attsAccepted, (numTaken * 2) + 1, eAtt);
                    }
                    
                    if (w->type == W_LIST) {
                            /* compute height displacement and reset
                               listbox height now, as pixheight is a 
                               function of item count, font, and text
                               shadow
                             */
                        int oldheight, newheight, itemCount;
                        oldheight = w->height;
                        listw = (AXWidget_list) w;
                        itemCount = wListVisibleItemCount(oldheight,
                                                          listw->font,
                                                          listw->textShadow,
                                                          listw->list_hscroll);
                        XtSetArg(args[0], XmNaxFont, eAtt);
                        deSetTextValues(w, args, 1);
                        newheight = wListPixHeight(itemCount, listw->font,
                                                   listw->textShadow,
                                                   listw->list_hscroll);
                        deChangeWidgetHeight(w, newheight - oldheight);
                    }
                    else if (w->type == W_ENTER) {
                            /* compute width displacement and reset width
                               now, as pix width is a function of font and
                               #columns.  reset height while here
                             */
                        int oldwidth, newwidth, nCols, winHt, totHt;
                        oldwidth = w->width;
                        nCols = wEnterColWidth(oldwidth, w->font,
                                               w->textShadow);
                        XtSetArg(args[0], XmNaxFont, eAtt);
                        deSetTextValues(w, args, 1);
                        newwidth = wEnterPixWidth(nCols, w->font,
                                                  w->textShadow);
                        deChangeWidgetWidth(w, newwidth - oldwidth);
#if 1
                        wEnterPixHeight(w->font,w->textShadow, &winHt,&totHt);
#else
	/* wEnterPixHeight does not return a value. Should it? */
                        w->height = wEnterPixHeight(w->font, w->textShadow,
                                                    &winHt, &totHt);
#endif
                        adjustForTitle(w);
                    }
                    else {
                        XtSetArg(args[0], XmNaxFont, eAtt);
                        deSetTextValues(w, args, 1);
                        reMeasure = TRUE;
                    }
                    numTaken++;
                }
                break;
                
            case DBDEXlabelFont:
                if (w->type == W_LABEL || w->type == W_BUTTON ||
                    w->type == W_TOGGLE || w->type == W_RADIO ||
                    w->type == W_OPTION || w->type == W_ENTER ||
                    w->type == W_TABLE || w->type == W_RECT) {
                    
                    int isString;
                    
                    eAtt = AxArrayElement(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXlabelFont);
                    
                    eAtt = deCompleteFontAttr(w, DBDEXlabelFont, eAtt,
                                              &isString);
                    if (isString) {
                        attsAccepted = AxAddStrToArray
                            (attsAccepted, (numTaken * 2) + 1, SX(eAtt)->text);
                    }
                    else {
                        attsAccepted = AxAddArrayToArray
                            (attsAccepted, (numTaken * 2) + 1, eAtt);
                    }
                    
                    if (w->type == W_ENTER) {
                        adjustForTitle(w);
                    }
                    if (w->type == W_TABLE) {
                            /* the table implements labelFont via property
                             * NlabelFont
                             */
                        XtSetArg(args[0], AXmNlabelFont, eAtt);
                        AxXtSetValues(w, args, 1);
                    }
                    else {
                        XtSetArg(args[0], XmNaxFont, eAtt);
                        deSetLabelValues(w, args, 1);
                    }
                    reMeasure = TRUE;
                    numTaken++;
                }
                break;
                
            case DBDEXminValue:
                if (w->type == W_SCALE) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXminValue);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], AXmNminValue, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXmaxValue:
                if (w->type == W_SCALE) {
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXmaxValue);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    XtSetArg(args[0], AXmNmaxValue, iAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXreverseBitmap:
                if (w->type == W_BUTTON) {
                    sAtt = AxStrPtrFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXreverseBitmap);
                    attsAccepted = AxAddStrToArray(attsAccepted,
                                                   (numTaken * 2) + 1, sAtt);
                    if ( sAtt && !sAtt[0] )
                        sAtt = NULL;
                    XtSetArg(args[0],XmNalternatePixmap,sAtt);
                    AxXtSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXuser_callbacks: /* all */
                    /* no c-side representation; just echo */
                eAtt = AxArrayFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2,
                                               DBDEXuser_callbacks);
                attsAccepted = AxAddArrayToArray(attsAccepted,
                                                 (numTaken * 2) + 1,
                                                 ElfDataCopy(eAtt));
                numTaken++;
                break;
                
            case DBDEXoptional:
                if (w->type == W_ENTER) {
                        /* no c-side representation; just echo */
                    iAtt = AxIntFromArray(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXoptional);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   (numTaken * 2) + 1, iAtt);
                    numTaken++;
                }
                break;
                
            case DBDEXgroupNames: /* all */
                    /* no c-side representation; just echo */
                eAtt = AxArrayFromArray(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2, DBDEXgroupNames);
                attsAccepted = AxAddArrayToArray(attsAccepted,
                                                 (numTaken * 2) + 1,
                                                 ElfDataCopy(eAtt));
                numTaken++;
                break;
                
            case DBDEXshadow:
                if (w->type == W_BUTTON || w->type == W_RECT ||
                    w->type == W_TOGGLE || w->type == W_OPTION) {
                    eAtt = ElfDataCopy(AxArrayFromArray(info, ix + 1));
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXshadow);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     eAtt);
                    XtSetArg(args[0], AXmNshadow, eAtt);
                    deCompositeSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXtextShadow:
                if (w->type == W_RADIO || w->type == W_OPTION ||
                    w->type == W_ENTER || w->type == W_EDITBOX ||
                    w->type == W_COMBO_BOX ||
                    w->type == W_LIST || w->type == W_TABLE) {
                    
                    eAtt = ElfDataCopy(AxArrayFromArray(info, ix + 1));
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXtextShadow);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     eAtt);
                    if (w->type == W_LIST) {
                            /* compute height displacement and reset
                               listbox height now, as pixheight is a 
                               function of item count, font, and text
                               shadow
                             */
                        int oldheight, newheight, itemCount;
                        oldheight = w->height;
                        listw = (AXWidget_list) w;
                        itemCount = wListVisibleItemCount(oldheight,
                                                          listw->font,
                                                          listw->textShadow,
                                                          listw->list_hscroll);
                        XtSetArg(args[0], AXmNtextShadow, eAtt);
                        deSetTextValues(w, args, 1);
                        newheight = wListPixHeight(itemCount, listw->font,
                                                   listw->textShadow,
                                                   listw->list_hscroll);
                        deChangeWidgetHeight(w, newheight - oldheight);
                    }
                    else {
                        XtSetArg(args[0], AXmNtextShadow, eAtt);
                        deSetTextValues(w, args, 1);
                        reMeasure = TRUE;
                    }
                    numTaken++;
                }
                break;
                
            case DBDEXlabelShadow:
                if (w->type == W_LABEL || w->type == W_BUTTON ||
                    w->type == W_TOGGLE || w->type == W_RADIO ||
                    w->type == W_OPTION || w->type == W_ENTER ||
                    w->type == W_TABLE || w->type == W_RECT) {
                    
                    eAtt = ElfDataCopy(AxArrayFromArray(info, ix + 1));
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXlabelShadow);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     eAtt);
                    if (w->type == W_TABLE) {
                            /* the table implements labelShadow via property
                             * NlabelShadow
                             */
                        XtSetArg(args[0], AXmNlabelShadow, eAtt);
                        AxXtSetValues(w, args, 1);
                    }
                    else {
                        XtSetArg(args[0], AXmNtextShadow, eAtt);
                        deSetLabelValues(w, args, 1);
                    }
                    reMeasure = TRUE;
                    numTaken++;
                }
                break;
                
            case DBDEXtextColor:
                if (w->type == W_RADIO || w->type == W_OPTION ||
                    w->type == W_ENTER || w->type == W_EDITBOX ||
                    w->type == W_COMBO_BOX ||
                    w->type == W_LIST || w->type == W_TABLE) {
                    
                    eAtt = AxArrayElement(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXtextColor);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     ElfDataCopy(eAtt));
                    XtSetArg(args[0], AXmNtextColor, eAtt);
                    deSetTextValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXlabelColor:
                if (w->type == W_LABEL || w->type == W_BUTTON ||
                    w->type == W_TOGGLE || w->type == W_RADIO ||
                    w->type == W_OPTION || w->type == W_ENTER ||
                    w->type == W_TABLE || w->type == W_RECT) {
                    
                    eAtt = AxArrayElement(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXlabelColor);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     ElfDataCopy(eAtt));

                    if (w->type == W_TABLE) {
                            /* the table implements labelColor via property
                             * NlabelColor
                             */
                        XtSetArg(args[0], AXmNlabelColor, eAtt);
                        AxXtSetValues(w, args, 1);
                    }
                    else {
                        XtSetArg(args[0], AXmNtextColor, eAtt);
                        deSetLabelValues(w, args, 1);
                    }
                    numTaken++;
                }
                break;
                
            case DBDEXwidgetColor:
                if (w->type != W_RADIO && w->type != W_ICON &&
                    w->type != W_CANVAS) {
                        /* we definitely should implement widget color
                         * for radios (the diamonds), and
                         * canvases, but none now, so filter..
                         */
                    eAtt = AxArrayElement(info, ix + 1);
                    attsAccepted = AxAddIntToArray(attsAccepted,
                                                   numTaken * 2,
                                                   DBDEXwidgetColor);
                    attsAccepted = AxAddArrayToArray(attsAccepted,
                                                     (numTaken * 2) + 1,
                                                     ElfDataCopy(eAtt));
                    XtSetArg(args[0], AXmNwidgetColor, eAtt);
                    deCompositeSetValues(w, args, 1);
                    numTaken++;
                }
                break;
                
            case DBDEXaccelerator_key: /* all */
                eAtt = AxArrayElement(info, ix + 1);
                attsAccepted = AxAddIntToArray(attsAccepted,
                                               numTaken * 2,
											   DBDEXaccelerator_key);
                attsAccepted = AxAddArrayToArray(attsAccepted,
												 (numTaken * 2) + 1,
												 ElfDataCopy(eAtt));
				SetWidgetAccelerator(w, eAtt);
                numTaken++;
                break;
                
            default:
                break;
        }
    }
    if (numTaken) {
        if (doLift) {
            if (liftMarks) {
                liftMark(w);
            }
            liftWidget(w);
        }
        else {
            if (reMeasure) {
                deRemeasureWidget(w);
            }
            if (doRepaint) {
                paintWidgetForConstruct(w);
                displayWidget(&w, 1, TRUE);
            }
        }
    }
    if (liftMarks) {
        deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
    }
    VfyContext(me);
    return (attsAccepted);
}

    /* context is that the widget's title (w->name) has just
     * changed.  for a few types, title affects geometry; do
     * whatever adjustment is needed based on the new title */
static void
adjustForTitle(w)
AXWidget w;
{
    int tmp;
    wComposite *cp;
    r32 limit;
    AXWidget_togglebutton tb;

    switch(w->type) {
        case W_TOGGLE:
            tb = (AXWidget_togglebutton)w;
            xmToggleButtonSize(tb, tb->font, tb->name);
            if (tb->in_radio) {
                    /* redo radio's width, which derives
                     * from the choice toggle widths */
                r32 trect, trect2;
                trect.origin.x = trect.origin.y = trect.width =
                        trect.height = 0;
                for (cp = tb->in_radio->auxData->compositeList; cp;
                        cp = cp->next) {
                    if (cp->w && (cp->type == WLINKDOWN) &&
                            (cp->w->type == W_TOGGLE)) {
                        trect2.origin.x = cp->w->xpos;
                        trect2.origin.y = cp->w->ypos;
                        trect2.width = cp->w->width;
                        trect2.height = cp->w->height;
                        unionRectangle(&trect2, &trect, &trect);
                    }
                }
                tb->in_radio->width = trect.width;
            }
            else if (tb->in_option && tb->in_option->window) {
                    /* redo option pulldown width, which derives
                     * from the choice toggle widths */
                r32 trect, trect2;
                trect.origin.x = trect.origin.y = trect.width =
                        trect.height = 0;
                for (cp = tb->in_option->auxData->compositeList; cp;
                        cp = cp->next) {
                    if (cp->w && (cp->type == WLINKDOWN) &&
                            (cp->w->type == W_TOGGLE)) {
                        trect2.origin.x = cp->w->xpos;
                        trect2.origin.y = cp->w->ypos;
                        trect2.width = cp->w->width;
                        trect2.height = cp->w->height;
                        unionRectangle(&trect2, &trect, &trect);
                    }
                }
                tb->in_option->pulldown_width = trect.width;
            }
            break;
        case W_LABEL:
            xmLabelSize(w, w->name, w->font, w->textShadow);
            break;
        case W_ENTER:
            if (w->auxData) {
                for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                    if (cp->w && (cp->type == WLINKDOWN) &&
                            (cp->w->type == W_LABEL)) {
#if 0 /* name-fix */
                        strncpy(cp->w->name, w->name, MAX_NAME);
#else
                        SetNWidgetName(cp->w, w->name, MAX_NAME);
#endif
                        if (cp->w->style == 0) {
                                /* label positioned to left of field */
                            tmp = cp->w->width;
                            xmLabelSize(cp->w, cp->w->name,
                                        cp->w->font, cp->w->textShadow);
                            w->xpos += (cp->w->width - tmp);
                        }
                    }
                }
            }
            break;
        case W_RADIO:
            if (w->auxData) {
                for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                    if (cp->w && (cp->type == WLINKDOWN) &&
                            (cp->w->type == W_LABEL)) {
                        SetNWidgetName(cp->w, w->name, MAX_NAME);
                        xmLabelSize(cp->w, w->name, cp->w->font,
                                    cp->w->textShadow);
                    }
                }
            }
            break;
        case W_ICON:
            /* this updates size for new title */
            xmIconPixmapAndSize((AXWidget_icon)w);
            break;
        case W_BUTTON:
            getMinimumWidgetSize(w, &limit);
            if (w->width < limit.width) {
                w->width = limit.width;
            }
            if (w->height < limit.height) {
                w->height = limit.height;
            }
            break;
        default:
            break;
    }
}

    /* write the size and pos info on an elf gadget_ array */
static void
updateElfGadgetPosSize(taskPid, dp, cw)
int taskPid;  /* task which owns the array mem */
data_ptr dp; /* in format gadget_ */
AXWidget cw;
{
    p32 pos;
    r32 size;
    int me = THIMpid;

        /* our convention is that any mem should be alloced to dlg's task */
    VfyContext(taskPid);
    deElfPos(cw, &pos);
    dp = deAddToGadgetArray(dp, (char *)pos.x, DTYPE_INT, DBDEXxpos);
    dp = deAddToGadgetArray(dp, (char *)pos.y, DTYPE_INT, DBDEXypos);
    deElfSize(cw, &size);
    dp = deAddToGadgetArray(dp, (char *)size.width, DTYPE_INT, DBDEXwidth);
    dp = deAddToGadgetArray(dp, (char *)size.height, DTYPE_INT, DBDEXheight);
    VfyContext(me);
}

/* : deInitElfGadget - set some initial values for a newly created
 * widget.  Values set here are those not determined by the elf code
 * for new widgets, like: id, edit-mode, etc.. */
static void
deInitElfGadget(nw)
wCreate *nw;
{
    int emask, curflags;
    data_ptr atmp;
    
    if (!nw)
        return;
    
        /* we should verify task context in here, but the
         * caller (elfb) is already doing so.. */
    if (!nw->wInfo) {
        nw->wInfo = AxMakeArray(1);
        deElfGadgetDefaults(nw);
    }
    
    /* remove any DBDEXuid value that may have come in thru default-widget
     * info.  There also may be other gadget members that should be nulled..
     */
    nw->wInfo = AxAddArrayToArray(nw->wInfo, DBDEXuid, (data_ptr) NULL);
               
        /* set unique id, and possibly also title */
    deInitElfGTitleId(nw);
    
        /* make the new widget editable */
    nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) WFLG_IN_EDIT,
                                   DTYPE_INT, DBDEXflags);
    emask = KeyPressMask | KeyReleaseMask | ButtonPressMask |
            ButtonReleaseMask | ButtonMotionMask | ExposureMask;
    atmp = AxMakeArray(1);
    atmp = AxAddIntToArray(atmp, 0, emask);
    nw->wInfo = AxAddArrayToArray(nw->wInfo, DBDEXevent_masks, atmp);
    atmp = AxMakeArray(1);
    atmp = AxAddStrToArray(atmp, 0, NXLT("dlgChildEventProc"));
    nw->wInfo = AxAddArrayToArray(nw->wInfo, DBDEXevent_handlers, atmp);
    
        /* make sure the new instance is not displayable at first */
    curflags = AxIntFromArray(nw->wInfo, DBDEXflags);
    curflags |= WFLG_NODISPLAY;
    nw->wInfo = AxAddIntToArray(nw->wInfo, DBDEXflags, curflags);
}

#define DE_DEFAULT_BITMAP NXLT("tmpimage")

static void
deInitElfGTitleId(nw)
wCreate *nw;
{
        /* we assume that task context is set to dlg's task.. */
    mbchar *currTitle;
    mbchar *iconID = (mbchar *) NULL;
    mbchar *newName = (mbchar *) NULL;

    currTitle = AxStrPtrFromArray(nw->wInfo, DBDEXtitle);
    if (currTitle && (MBstrlen(currTitle) > (unsigned)0)) {
        if (nw->wType == DLG_ICON) {
                /* don't 'uniqueify' an icon title */
            newName = (char *) TaskAlloc(0, strlen(currTitle) + 1);
            strcpy(newName, currTitle);
                /* appropriate for ids, though */
            iconID = deUniqueName(nw->whichDialog,
                                  currTitle);
        }
        else {
            newName = deUniqueName(nw->whichDialog, currTitle);
        }
    }
    else {
        switch( nw->wType ) {
            case DLG_RADIO_BOX:
                newName = deUniqueName(nw->whichDialog,
                       XLT2("Dbox Editor default name", "RadioButtonGroup"));
                break;
            case DLG_TOGGLE_BUTTON:
                newName = deUniqueName(nw->whichDialog,
                       XLT2("Dbox Editor default name", "Toggle Button"));
                break;
            case DLG_CHOICE:
                newName = deUniqueName(nw->whichDialog,
                       XLT2("Dbox Editor default name", "Option Button"));
                break;
            case DLG_VERB_BUTTON:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Push Button"));
                break;
            case DLG_ENTER:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Entry Box"));
                break;
            case DLG_TEXT:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Label"));
                break;
            case DLG_ICON:
                newName = (char *) TaskAlloc(0, strlen(DE_DEFAULT_BITMAP) + 1);
                strcpy(newName, DE_DEFAULT_BITMAP);
                iconID = deUniqueName(nw->whichDialog,
                                         DE_DEFAULT_BITMAP);
                break;
            case DLG_LIST_BOX:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "List Box"));
                break;
            case DLG_RECT:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Panel"));
                break;
            case DLG_EDIT_BOX:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Editbox"));
                break;
            case DLG_SCALE:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Scale"));
                break;
            case DLG_TABLE:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Table"));
                break;
            case DLG_CANVAS:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Canvas"));
                break;
            case DLG_COMBO_BOX:
                newName = deUniqueName(nw->whichDialog,
                          XLT2("Dbox Editor default name", "Combo Box"));
                break;
            default:
                break;
        }
    }
    if (newName) {
        nw->wInfo = deAddToGadgetArray(nw->wInfo, newName,
                                       DTYPE_STR, DBDEXtitle);
        if (iconID) {
            nw->wInfo = deAddToGadgetArray(nw->wInfo, iconID,
                                           DTYPE_STR, DBDEXid);
            TaskFree(0, (char *) iconID);
        }
        else {
            nw->wInfo = deAddToGadgetArray(nw->wInfo, newName,
                                           DTYPE_STR, DBDEXid);
        }
        TaskFree(0, (char *) newName);
    }
}

    /* Provide some default new-gadget default values, in case the
     * elf layer hasn't provided any; the intent is that the dlged
     * elf code should provide all user-defaults, but .. */
static void
deElfGadgetDefaults(nw)
wCreate *nw;
{
    data_ptr atmp;
    
    deInitElfGWidthHeight(nw);
        /* set strs for option buttons or radios */
    if (nw->wType == DLG_CHOICE || nw->wType == DLG_RADIO_BOX) {
        atmp = AxMakeArray(1);
        atmp = deAddToGadgetArray(atmp,
                        XLT2("Dbox Editor default choice label", "Choice1"),
                        DTYPE_STR, 0);
        nw->wInfo = AxAddArrayToArray(nw->wInfo, DBDEXstrs, atmp);
    }
    if (nw->wType == DLG_LIST_BOX ||
        nw->wType == DLG_TABLE ||
        nw->wType == DLG_CANVAS) {
            /* init with horiz scroll bars */
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) TRUE, DTYPE_INT,
                                       DBDEXhoriz_scroll);
    }
    if (nw->wType == DLG_VERB_BUTTON) {
            /* set thickness, differently for ol and mt */
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 2,
                                       DTYPE_INT, DBDEXthickness);
            /* make the button type 'normal' (type 0) */
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 0,
                                       DTYPE_INT, DBDEXtype);
    }
    if (nw->wType == DLG_RECT) {
            /* set thickness of -1 for recessed appearance */
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) -1,
                                       DTYPE_INT, DBDEXthickness);
    }
    if (nw->wType == DLG_TABLE || nw->wType == DLG_CANVAS) {
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) -2,
                                       DTYPE_INT, DBDEXthickness);
    }
    if (nw->wType == DLG_SCALE) {
            /* supply sane min and max values */
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 0,
                                       DTYPE_INT, DBDEXminValue);
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 100,
                                       DTYPE_INT, DBDEXmaxValue);
            /* shut off the label, which isn't coded for.. */
        nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) TRUE,
                                       DTYPE_INT, DBDEXno_label);
    }
}

static void
deInitElfGWidthHeight(nw)
wCreate *nw;
{
        /* we assume that task context is set to dlg's task.. */
    switch (nw->wType) {
        case DLG_SCALE:
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 17,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_ICON:
/* %%%%%%%%%%% can't tell, really, without the bitmap!!!! */
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_RECT:
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_VERB_BUTTON:
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 30,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 22,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_ENTER:   /* character units */
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 10,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 20,
                                           DTYPE_INT, DBDEXlength);
            break;
        case DLG_LIST_BOX:  /* character units */
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 10,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 5,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_EDIT_BOX:
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 50,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_CANVAS:
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 40,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 40,
                                           DTYPE_INT, DBDEXheight);
            break;
        case DLG_TABLE:
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 100,
                                           DTYPE_INT, DBDEXwidth);
            nw->wInfo = deAddToGadgetArray(nw->wInfo, (char *) 100,
                                           DTYPE_INT, DBDEXheight);
            break;
        default:
            break;
    }
}

static data_ptr
deAddToGadgetArray(gp, val, dtype, dex)
data_ptr gp; /* the gadget array */
char *val;   /* the value */
int dtype;   /* the datatype of the value */
int dex;   /* write this position in the array */
{
    data_ptr tdp;
    
        /* we assume that task context is set to dlg's task.. */
    if (AxIsArray(AxArrayElement(gp, dex))) {
        tdp = ElfDataCopy(AxArrayElement(gp, dex));
        if (de_mtol_val(dex)) {
            tdp = deWriteGadget(tdp, val, dtype, 0);
        }
        else {      /* append to end of array */
            tdp = deWriteGadget(tdp, val, dtype, AxArraySize(tdp));
        }
        gp = AxAddArrayToArray(gp, dex, tdp);
    }
    else {
        if (de_mtol_val(dex)) {
                /* if isn't already an array, make it one; supply
                 * same val for both ol, mt */
            data_ptr mtol = AxMakeArray(2);
            mtol = deWriteGadget(mtol, val, dtype, 0);
            mtol = deWriteGadget(mtol, val, dtype, 1);
            gp = AxAddArrayToArray(gp, dex, mtol);
        }
        else {
            gp = deWriteGadget(gp, val, dtype, dex);
        }
    }
    return (gp);
}

static data_ptr
deWriteGadget(dp, val, dtype, dex)
data_ptr dp;
char *val;
int dtype;
int dex;
{
        /* we assume that task context is set to dlg's task.. */
    switch(dtype) {
        case DTYPE_INT:
            dp = AxAddIntToArray(dp, dex, (int)val);
            break;
        case DTYPE_STR:
            dp = AxAddStrToArray(dp, dex, val);
            break;
        default:
            break;
    }
    return (dp);
}

    /* return whether gadget array index refers to
     * member which may have distinct values under
     * motif vs. openlook */
static int
de_mtol_val(dex)
int dex;
{
    if (dex == DBDEXxpos ||
        dex == DBDEXypos ||
        dex == DBDEXheight ||
        dex == DBDEXwidth ||
        dex == DBDEXthickness) {
            return TRUE;
    }
    else {
        return FALSE;
    }
}

    /* warp mouse position past range where stroke area would
     * describe a size smaller than minimum for the widget; at
     * call time, this minimum size is stored on DE.origSize */
static void
initMouseForCreateStroke(pt)
p32 *pt; /* in/out: in as current mouse pos, out as adjusted pos */
{
    p32 tpt;
    if (!pt)
        return;
    tpt = DE.origSize.origin;
    switch(DE.stretchHandle) {
        case topLeft:
            tpt.x -= DE.origSize.width;
            tpt.y -= DE.origSize.height;
            break;
        case topRight:
            tpt.x += DE.origSize.width;
            tpt.y -= DE.origSize.height;
            break;
        case botLeft:
            tpt.x -= DE.origSize.width;
            tpt.y += DE.origSize.height;
            break;
        case botRight:
            tpt.x += DE.origSize.width;
            tpt.y += DE.origSize.height;
            break;
    }
    XWarpPointer(Dpy, DE.dragWidget->parent->window,
        DE.dragWidget->parent->window, pt->x, pt->y, 0, 0, tpt.x, tpt.y);
    *pt = tpt;
}

    /* some widgets (like editboxes and list boxes) aren't fully
     * constructed until after their first painter call; for existing
     * widgets, this happens when the dlg box is first displayed; for
     * newly created widgets, this jump-start will establish geometry */
static void
paintWidgetForConstruct(w)
AXWidget w;
{
    Drawable savedDraw;
#if AXMS
    HDC tmp_dc;
    HBITMAP old_hbm;
#endif

    if (ScratchMap) {
#if AXMS
        if ( ScratchMapDrawable == (HDC)NULL )
            {
            tmp_dc = MS_CreateCompatibleDC(NULL);
            old_hbm = MS_SelectObject(tmp_dc, ScratchMap);
            ScratchMapDrawable = AxPackageHandle(tmp_dc, AX_MEMDC_TYPE);
            }
#else
        ScratchMapDrawable = ScratchMap;
#endif
        savedDraw = w->parent->window;
        w->parent->window = ScratchMapDrawable;
    }
    paintWidget(w, &DE.fakeExpose);
    if (w->type == W_OPTION && w->window) {
            /* the option pulldown is open, and may have changed,
             * so delete and repaint to force reconstruct */
        deFreePixmap(w);
        if (ScratchMap) {
                /* to get window parentage on the pixmap as above */
            w->parent->window = ScratchMapDrawable;
        }
        PaintOptionPulldown((AXWidget_option)w, OPTION_NEW,
                            (XEvent*)&DE.fakeExpose);
    }
    if (ScratchMap) {
#if AXMS
        MS_SelectObject(tmp_dc, old_hbm);
        MS_DeleteDC(tmp_dc);
        REMOVE_DRAWABLE(ScratchMapDrawable);
        ScratchMapDrawable = (HDC)NULL;
#endif
        w->parent->window = savedDraw;
    }
}

static void
setMark(w)
AXWidget w;
{
    if (!xmWidgetIsHidden(w)) {
        if (!w->auxData) {
            w->auxData = newAuxData();
        }
        w->auxData->wEdit.marked = TRUE;
        addToSelset(w);
    }
}

static void
liftMark(w)
AXWidget w;
{
    if (!w->auxData) {
        w->auxData = newAuxData();
    }
    w->auxData->wEdit.marked = FALSE;
    removeFromSelset(w);
}

static void
toggleMark(w)
AXWidget w;
{
    if (!w->auxData) {
        w->auxData = newAuxData();
    }
    if (w->auxData->wEdit.marked) {
        w->auxData->wEdit.marked = FALSE;
        removeFromSelset(w);
    }
    else if (!xmWidgetIsHidden(w)) {
        w->auxData->wEdit.marked = TRUE;
        addToSelset(w);
    }
}

static void
liftAllMarks()
{
    int ix;

    for (ix = 0; ix < DE.numDlgs; ix++) {
        dlgLiftAllMarks((AXWidget_dialog)DE.dialogs[ix].dlg);
    }
}

static void
dlgLiftAllMarks(dlg)
AXWidget_dialog dlg;
{
    wLayer **listHead, *ly;
    r32 updateRect, trect;
    Drawable savedDraw;
#if AXMS
    HDC tmp_dc;
    HBITMAP old_hbm;
#endif
    if (!dlg)
        return;

    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
        
    if (ScratchMap) {
#if AXMS
        if ( ScratchMapDrawable == (HDC)NULL )
            {
            tmp_dc = MS_CreateCompatibleDC(NULL);
            old_hbm = MS_SelectObject(tmp_dc, ScratchMap);
            ScratchMapDrawable = AxPackageHandle(tmp_dc, AX_MEMDC_TYPE);
            }
#else
        ScratchMapDrawable = ScratchMap;
#endif
        savedDraw = dlg->window;
        dlg->window = ScratchMapDrawable;
    }
    updateRect.origin.x = updateRect.origin.y =
                updateRect.width = updateRect.height = 0;

        /* accumulate bounder over all currently marked */
    listHead = layerListHead(dlg);
    if (listHead == (wLayer **)NULL)
        return;
    for (ly = *listHead; ly; ly = ly->next) {
        if (widgetOnScreen(ly->w) && ly->w->auxData &&
                    ly->w->auxData->wEdit.marked) {
            liftMark(ly->w);
            if (!ScratchMap) {
                simpleLiftWidget(ly->w); /* to lift handles, too.. */
            }
            getWidgetSize(ly->w, &trect, TRUE);
            if (updateRect.width) {
                unionRectangle(&trect, &updateRect, &updateRect);
            }
            else {
                updateRect = trect;
            }
        }
    }

    if (!updateRect.width) {
            /* nothing marked */
        if (ScratchMap) {
#if AXMS
            MS_SelectObject(tmp_dc, old_hbm);
            MS_DeleteDC(tmp_dc);
            REMOVE_DRAWABLE(ScratchMapDrawable);
            ScratchMapDrawable = (HDC)NULL;
#endif
            dlg->window = savedDraw;
        }
        initFakeExpose();
        return;
    }

    if (ScratchMap) {
        XFillRectangle(Dpy, ScratchMapDrawable, BackGC, updateRect.origin.x,
                updateRect.origin.y, updateRect.width, updateRect.height);
    }

        /* now shoot all that intersect */
    DE.fakeExpose.x = DE.fakeExpose.y = 0;
    DE.fakeExpose.width = dlg->width;
    DE.fakeExpose.height = dlg->height;
    DE.fakeExpose.window = dlg->window;
    for (ly = *listHead; ly; ly = ly->next) {
        getWidgetSize(ly->w, &trect, TRUE);
        if (widgetOnScreen(ly->w) &&
            widgetIntersectsUpdateRect(ly->w, &updateRect)) {
            
            paintWidget(ly->w, &DE.fakeExpose);
            if (!ScratchMap && (ly->w->type != W_ALIGN)){
                    /* straight-to-screen display is unclipped, so
                       include effects of each widg's reshoot */
                unionRectangle(&trect, &updateRect, &updateRect);
            }
        }
    }

    if (ScratchMap) {
        XCopyArea(Dpy, ScratchMapDrawable, savedDraw, ForeGC,
            updateRect.origin.x, updateRect.origin.y, updateRect.width,
            updateRect.height, updateRect.origin.x, updateRect.origin.y);
        dlg->window = savedDraw;
#if AXMS
        MS_SelectObject(tmp_dc, old_hbm);
        MS_DeleteDC(tmp_dc);
        REMOVE_DRAWABLE(ScratchMapDrawable);
        ScratchMapDrawable = (HDC)NULL;
#endif
    }

    initFakeExpose();
    deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
}

static void
addToSelset(w)
AXWidget w;
{
    int ix;

    deselectCousins(w);    /* un-select all from other dialog(s) */
    
    if (!DE.selectedSet) {
        DE.selectedSet = (AXWidget *) TaskAlloc(0, sizeof(AXWidget) );
        DE.selsetOrigSizes = (r32 *) TaskAlloc(0, sizeof(r32));
        DE.selectedSetSize = 1;
        DE.selectedSet[0] = w;
        return;
    }
    for (ix = 0; ix < DE.selectedSetSize; ix++) {
        if (w == DE.selectedSet[ix])
            return; /* already there */
    }
    DE.selectedSet = (AXWidget *) TaskRealloc
        (0, DE.selectedSet, (DE.selectedSetSize + 1) * sizeof(AXWidget));
    DE.selectedSet[DE.selectedSetSize] = w;
    DE.selectedSetSize++;
    DE.selsetOrigSizes = (r32 *) TaskRealloc
        (0, DE.selsetOrigSizes, DE.selectedSetSize * sizeof(r32));
}

void
removeFromSelset(w)
AXWidget w;
{
    int ix;
    if (!DE.selectedSet)
        return;
    for (ix = 0; ix < DE.selectedSetSize; ix++) {
        if (w == DE.selectedSet[ix]) {
            DE.selectedSetSize--;
            for ( ; ix < DE.selectedSetSize; ix++) {
                DE.selectedSet[ix] = DE.selectedSet[ix + 1];
            }
            if (DE.selectedSetSize > 0) {
                DE.selectedSet = (AXWidget *) TaskRealloc
                    (0, DE.selectedSet, DE.selectedSetSize * sizeof(AXWidget));
                DE.selsetOrigSizes = (r32 *) TaskRealloc
                    (0, DE.selsetOrigSizes, DE.selectedSetSize * sizeof(r32));
            }
            else {
                DE.selectedSetSize = 0;
                if (DE.selectedSet) /* needless paranoia */
                    TaskFree(0, (char *) DE.selectedSet);
                if (DE.selsetOrigSizes)
                    TaskFree(0, (char *) DE.selsetOrigSizes);
                DE.selectedSet = (AXWidget *) NULL;
                DE.selsetOrigSizes = (r32 *) NULL;
            }
            return;
        }
    }
}

/*
 * : deselectCousins - widget w is about to be added to the
 * selected set.  before adding, de-select all those that
 * have dialog parents other than w's.  this is to keep the
 * dlged's selection within a single dialog at a time.
 */
static void
deselectCousins(w)
AXWidget w;
{
    int ix, jx, numCousins;
    AXWidget *cousins;
    
    if (!w || !DE.selectedSet)
        return;
    
    for (ix = 0, numCousins = 0; ix < DE.selectedSetSize; ix++) {
        if ((DE.selectedSet[ix])->parent != w->parent) {
            numCousins++;
        }
    }
    if (!numCousins)
        return;
    
    cousins = (AXWidget *) TaskAlloc(0, numCousins * sizeof(AXWidget *));
    for (ix = 0, jx = 0; ix < DE.selectedSetSize; ix++) {
        if ((DE.selectedSet[ix])->parent != w->parent) {
            cousins[jx] = DE.selectedSet[ix];
            jx++;
        }
    }
    for (jx = 0; jx < numCousins; jx++) {
        liftMark(cousins[jx]);
        if (!ScratchMap) {
            simpleLiftWidget(cousins[jx]);    /* to lift handles, too.. */
        }
    }
    displayWidget(cousins, numCousins, TRUE);
    TaskFree(0, (char *) cousins);
}

static void
drawHandles(listHead, omitList, numOmit)
wLayer **listHead;
AXWidget *omitList; /* skip those on this list */
int numOmit;
{
    wLayer *ly;
    int ix, onOmitList;

    for (ly = *listHead; ly; ly = ly->next) {
        for (ix = 0, onOmitList = FALSE; ix < numOmit; ix++) {
            if (ly->w == omitList[ix]) {
                onOmitList = TRUE;
                break;
            }
        }
        if (!onOmitList) {
            if (ly->w && ly->w->auxData) {
                if (ly->w->auxData->wEdit.marked) {
                    simpleDrawHandles(ly->w);
                }
            }
        }
    }
}

/* return name string which is unique among the current
 * set of dlg's child widgets' names.  Caller must free string */
static mbchar *
deUniqueName(dlg, candidate)
AXWidget_dialog dlg;
mbchar *candidate;
{
    mbchar *tryName;
    int len, unique = TRUE;
    int firstTime = TRUE;
    AXWidget tw;

    len = MBstrlen(candidate) + 1;
    tryName = (mbchar *) TaskAlloc(0, len);
    MBstrcpy(tryName, candidate);
    while (TRUE) {
        for (tw = dlg->widgets; tw; tw = tw->nextChild) {
            if (!MBstrcmp(tw->name, tryName)) {
                unique = FALSE;
                break;
            }
        }
        if (unique) {
            return (tryName);
        }
        else {
                /* 'increment' the name and try again */
            unique = TRUE;
            deIncrementName(&tryName, firstTime);
            firstTime = FALSE;
        }
    }
}

/* return id string which is unique among the current
 * set of dlg's child widgets' ids.  Caller must free string */
static mbchar *
deUniqueID(dlg, candidate)
AXWidget_dialog dlg;
mbchar *candidate;
{
    mbchar *tryID, *thisId;
    int len;
    int unique = TRUE;
    int firstTime = TRUE;
    AXWidget tw;

    len = MBstrlen(candidate) + 1;
    tryID = (mbchar *) TaskAlloc(0, len);
    MBstrcpy(tryID, candidate);
    while (TRUE) {
        for (tw = dlg->widgets; tw; tw = tw->nextChild) {
            if (tw->auxData && tw->auxData->gadget) {
                thisId = AxStrFromArray(tw->auxData->gadget, DBDEXid);
                if (!MBstrcmp(thisId, tryID)) {
                    unique = FALSE;
                    break;
                }
            }
        }
        if (unique) {
            return (tryID);
        }
        else {
                /* ' increment' the name and try again */
            unique = TRUE;
            deIncrementName(&tryID, firstTime);
            firstTime = FALSE;
        }
    }
}

/* return title string which is unique among the current
 * set of in-edit dialogs.  Caller must free string */
static data_ptr
deUniqueDialogName(info)
data_ptr info;
{
    mbchar *tryName, *candidate;
    int len, unique = TRUE, ix;
    int firstTime = TRUE;
    AXWidget_dialog tw;
    data_ptr ret;

    candidate = AxStrPtrFromArray(info, 1);
    if (!candidate) {
        return ((data_ptr) NULL);
    }
    len = MBstrlen(candidate) + 1;
    tryName = (mbchar *) TaskAlloc(0, len);
    MBstrcpy(tryName, candidate);
    while (TRUE) {
        for (ix = 0; ix < DE.numDlgs; ix++) {
            tw = (AXWidget_dialog) DE.dialogs[ix].dlg;
            if (!MBstrcmp(tw->name, tryName)) {
                unique = FALSE;
                break;
            }
        }
        if (unique) {
            ret = AxMakeArray(1);
            ret = AxAddStrToArray(ret, 0, tryName);
            return (ret);
        }
        else {
                /* 'increment' the name and try again */
            unique = TRUE;
            deIncrementName(&tryName, firstTime);
            firstTime = FALSE;
        }
    }
}

/* return id string which is unique among the current
 * gadgets in the specified dialog */
static data_ptr
deUniqueGadgetID(info)
data_ptr info;
{
    data_ptr nameData;
    AXWidget_dialog dlg;
    mbchar *candidate, *uniqID;
    data_ptr retID, dptr;
    
    if (!info || !AxIsArray(info)) {
        return ((data_ptr) NULL);
    }
    nameData = AxArrayElement(info, 1);  /* <<dlg handle><candidate id>> */
    if (!nameData || !AxIsArray(nameData)) {
        return ((data_ptr) NULL);
    }
	dptr = AxArrayElement(nameData, 0);
    dlg = XmDlgInWidget((AXWidget_main)WidgetPointerFromHandleData(dptr));
    if (dialogGone(dlg)) {
        return ((data_ptr) NULL);
    }
    candidate = AxStrPtrFromArray(nameData, 1);
    uniqID = deUniqueID(dlg, candidate);
    retID = AxMakeStrData(-1, uniqID);
    TaskFree(0, (char *) uniqID);
    return (retID);
}

static void
deDoSinglePick(w, buttonEvent)
AXWidget w;
XButtonEvent *buttonEvent;
{
    if (ThimIsControled()) {
            /* BToggle - toggle marked state of this widget */
        toggleMark(w);
        if (!ScratchMap) {
            simpleLiftWidget(w); /* to lift handles, too.. */
        }
        displayWidget(&w, 1, TRUE);
        deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
        return;
    }
    else if (ThimIsShifted()) {
            /* BExtend - make sure this widget is marked */
        setMark(w);
        displayWidget(&w, 1, TRUE);
        deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
        return;
    }
    else {
            /* BSelect - mark this widget and unmark all others */
        doSingleSelect(w);
        return;
    }
}

static void
doSingleSelect(w)
AXWidget w;
{
    liftAllMarks();
    setMark(w);
    displayWidget(&w, 1, TRUE);
    deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
}

/* info format: <DE_WIDGETS_LIST>,
 *   <#w><<w1ID>,<w1elfWtype>,<w1Handle>,<w1Selected>,<w1AccelKey>>,<w2ID..
 * This list completely overrides the current selected set
 */
static void
deSelectWidgets(dlg, info)
AXWidget_dialog dlg;
data_ptr info;
{
    data_ptr dp;
    int ix;
    AXWidget *wList;
    int numWidgets = AxIntFromArray(info, 1);

    if (!numWidgets) {
        liftAllMarks();
        return;
    }

    wList = (AXWidget *) TaskAlloc(0, numWidgets * sizeof(AXWidget));
    for (ix = 0; ix < numWidgets; ix++) {
        dp = AxArrayElement(info, ix + 2);
        wList[ix] = WidgetPointerFromHandleData(AxArrayElement(dp, 2));
        if (AxIntFromArray(dp, 3)) {
            setMark(wList[ix]);
        }
        else {
            liftMark(wList[ix]);
            if (!ScratchMap) {
                simpleLiftWidget(wList[ix]);    /* to lift handles, too.. */
            }
        }
    }
    displayWidget(wList, numWidgets, TRUE);
    TaskFree(0, wList);
             
    deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
}

static int
dialogGone(dlg)
AXWidget_dialog dlg;
{
    int ix;
    for (ix = 0; ix < DE.numDlgs; ix++) {
        if (dlg == (AXWidget_dialog) DE.dialogs[ix].dlg) {
            return FALSE;
        }
    }
    return TRUE;
}

static AXWidget
deXmCreateAlign(parent, style, rect)
AXWidget_dialog parent;
int style; /* ALIGN_GRID, ALIGN_LINE, .. */
r32 *rect; /* size and pos */
{
        AXWidget tw;
    unsigned long evmask;
    int me = THIMpid;
    VfyContext(parent->taskOwner);
    tw = CrtWidget(W_ALIGN, (AXWidget)parent, "");
        /* add event handling for this de-only widget */
    evmask = KeyPressMask | KeyReleaseMask | ButtonPressMask |
                ButtonReleaseMask | ButtonMotionMask | ExposureMask;
    ZXtInsertEventHandler(tw, evmask, FALSE, dlgChildEventProc,
                (char *) NULL, 0);
    tw->flags |= WFLG_IN_EDIT;
    tw->style = style;
    tw->painter = PaintAlign;
    tw->auxData = newAuxData();
    switch(style) {
        case ALIGN_LINE:
        case ALIGN_RECT:
            tw->xpos = rect->origin.x;
            tw->ypos = rect->origin.y;
            tw->width = rect->width;
            tw->height = rect->height;
            break;
        case ALIGN_GRID:
            tw->xpos = tw->ypos = 0;
            tw->width = tw->parent->width;
            tw->height = tw->parent->height;
            break;
    }
    appendNewWlayer(parent, tw);
    VfyContext(me);
    return(tw);
}

void
deCopyGadget(w, info)
AXWidget w;
data_ptr info;
{
    int me = THIMpid;
    
    if (!w)
        return;
    
    if (!(w->flags & WFLG_IN_EDIT))
        return; /* do this copy only when under dialog edit */
    
    if (!w->auxData) {
        w->auxData = newAuxData();
    }
    
    VfyContext(w->parent->taskOwner);
    if (w->auxData->gadget) {
        AxFreeData(w->auxData->gadget);
    }
    w->auxData->gadget = ElfDataCopy(info);
    VfyContext(me);
    
    /* this func is used to perform updates to in-edit
     * widgets, so notify any open editor dlgs
     */
    deSendUpdatePoke(DE_WIDGET_ATTS_CHANGED, DE.deferUpdatePokes);
    
    if (!AxArrayElement(info, DBDEXwidget)) {
        /* this widget has just been created
         */
        if (AxArrayElement(info, DBDEXdeSelect)) {
            /* the elf layer wants this widget to be in
             * DE.selectedSet upon creation; this will occur
             * at deFlushUpdatePokes time.
             */
            deAddToDeferredSelection(w);
            
            /* do an update on this widget's position, just
             * to get it to check whether it should be connected
             * to any tabcontrol-style rects; it may have landed in one
             * (create-time DBDEXdeSelect occurs for pasted widgets)
             */
            deSendUpdate((AXWidget)w->parent->parent, &w, 1,wMove,(data_ptr)0);
        }
    }
    return;
}

    /* positions of attrs in the dialog copy */
#define DE_DLGCOPY_TITLE 1
#define DE_DLGCOPY_WIDTH 3
#define DE_DLGCOPY_HEIGHT 5
#define DE_DLGCOPY_VARSIZE 7
#define DE_DLGCOPY_MINWIDTH 9
#define DE_DLGCOPY_MINHEIGHT 11
#define DE_DLGCOPY_MAXWIDTH 13
#define DE_DLGCOPY_MAXHEIGHT 15
#define DE_DLGCOPY_CALLBACKS 17
static int deCopyDialogHeight(), deCopyDialogWidth();

void
deCopyDialog(w, info)
AXWidget_dialog w; /* dialog widget handle */
data_ptr info; /* array in format dialog_box_ */
{
    data_ptr newGadget;
    int widChange, htChange;
    int me = THIMpid;
    if (!w)
        return;
    if (!(w->flags & WFLG_IN_EDIT))
        return; /* do this copy only when under dialog edit */

        /* the set of currently editable dialog atts: title, width,
         * height, varsize, max/min width, max/min height, callbacks */
    if (!w->auxData) {
        w->auxData = newAuxData();
    }
    VfyContext(w->parent->taskOwner);
        /* write in 'update' format: <#atts>,<a1name>,<a1val>,... */
    newGadget = AxMakeArray(20);
    newGadget = AxAddIntToArray(newGadget, 0, 9);
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_TITLE, DB_title);
    newGadget = AxAddStrToArray(newGadget, DE_DLGCOPY_TITLE + 1,
                                AxStrPtrFromArray(info, DB_title));

    widChange = deCopyDialogWidth(w->auxData->gadget, newGadget, info);
    htChange = deCopyDialogHeight(w->auxData->gadget, newGadget, info);

    newGadget = AxAddIntToArray(newGadget,
                                DE_DLGCOPY_VARSIZE, DB_user_var_size);
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_VARSIZE + 1,
                                AxIntFromArray(info, DB_user_var_size));
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MINWIDTH,
                                DB_min_width);
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MINWIDTH + 1,
                                AxIntFromArray(info, DB_min_width));
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MINHEIGHT,
                                DB_min_height); 
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MINHEIGHT + 1,
                                AxIntFromArray(info, DB_min_height));
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MAXWIDTH,
                                DB_max_width); 
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MAXWIDTH + 1,
                                AxIntFromArray(info, DB_max_width));
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MAXHEIGHT,
                                DB_max_height); 
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_MAXHEIGHT + 1,
                                AxIntFromArray(info, DB_max_height));
    newGadget = AxAddIntToArray(newGadget, DE_DLGCOPY_CALLBACKS,
                                DB_user_callbacks); 
    newGadget = AxAddArrayToArray(newGadget, DE_DLGCOPY_CALLBACKS + 1,
                                  ElfDataCopy(AxArrayElement
                                              (info, DB_user_callbacks)));
    if (w->auxData->gadget) {
        AxFreeData(w->auxData->gadget);
    }
    w->auxData->gadget = newGadget;
    VfyContext(me);
    if (widChange || htChange) {
        deSendUpdatePoke(DE_SET_DIALOG_ATTS, DE.deferUpdatePokes);
    }
}

static int
deCopyDialogWidth(curInfo, newCopy, newInfo)
data_ptr curInfo; /* current dialog copy in 'DLGCOPY' format */
data_ptr newCopy; /* soon-to-be-attached new dialog copy, same format */
data_ptr newInfo; /* new info from elf in format dialog_box_ */
{
    data_ptr odp, ndp;
    int curwid, newwid;

    newCopy = AxAddIntToArray(newCopy, DE_DLGCOPY_WIDTH, DB_width);
    odp = AxArrayElement(curInfo, DE_DLGCOPY_WIDTH + 1);
    if (AxIsArray(odp)) {
        curwid = AxIntFromArray(odp, 0);
    }
    else {
        curwid = AxIntFromArray(curInfo, DE_DLGCOPY_WIDTH + 1);
    }
    ndp = AxArrayElement(newInfo, DB_width);
    if (AxIsArray(ndp)) {
        newwid = AxIntFromArray(ndp, 0);
        newCopy = AxAddArrayToArray(newCopy, DE_DLGCOPY_WIDTH + 1,
                                    ElfDataCopy(ndp));
    }
    else {
        newwid = AxIntFromArray(newInfo, DB_width);
        newCopy = AxAddIntToArray(newCopy, DE_DLGCOPY_WIDTH + 1,
                                  newwid);
    }
    return (newwid != curwid);
}

static int
deCopyDialogHeight(curInfo, newCopy, newInfo)
data_ptr curInfo; /* current dialog copy in 'DLGCOPY' format */
data_ptr newCopy; /* soon-to-be-attached new dialog copy, same format */
data_ptr newInfo; /* new info from elf in format dialog_box_ */
{
    data_ptr odp, ndp;
    int curht, newht;

    newCopy = AxAddIntToArray(newCopy, DE_DLGCOPY_HEIGHT, DB_height);
    odp = AxArrayElement(curInfo, DE_DLGCOPY_HEIGHT + 1);
    if (AxIsArray(odp)) {
        curht = AxIntFromArray(odp, 0);
    }
    else {
        curht = AxIntFromArray(curInfo, DE_DLGCOPY_HEIGHT + 1);
    }
    ndp = AxArrayElement(newInfo, DB_height);
    if (AxIsArray(ndp)) {
        newht = AxIntFromArray(ndp, 0);
        newCopy = AxAddArrayToArray(newCopy, DE_DLGCOPY_HEIGHT + 1,
                                    ElfDataCopy(ndp));
    }
    else {
        newht = AxIntFromArray(newInfo, DB_height);
        newCopy = AxAddIntToArray(newCopy, DE_DLGCOPY_HEIGHT + 1, newht);
    }
    return (newht != curht);
}

static void
deOpenAttsDlg(w)
AXWidget w;
{
        /* msg format: DE_WIDGET_ATTS, <w->type>, <w> */
    data_ptr message;
    AXWidget_handle wh;

    doSingleSelect(w); /* make w only selected */
    message = AxMakeArray(3);
    message = AxAddIntToArray(message, 0, DE_WIDGET_ATTS);
    message = AxAddIntToArray(message, 1, deElfWidgetType(w));
    wh = HANDLE_FROM_WIDGET(w);
    message = AxWriteArray(message, 2,
                           AxMakeBinaryData(sizeof(wh), (char*)&wh));
    XmPoker(POKE_DE_MESSAGE, message, w->parent->parent, TRUE, TRUE);
    AxFreeData(message);
}

static int
deElfWidgetType(w)
AXWidget w;
{
    switch(w->type) {
        case W_RADIO:
            return DLG_RADIO_BOX;
        case W_TOGGLE:
            return DLG_TOGGLE_BUTTON;
        case W_OPTION:
#if AXMS
			if ( w->style == W_COMBO_BOX )
				return DLG_COMBO_BOX;
			else
#endif
            return DLG_CHOICE;
        case W_BUTTON:
            return DLG_VERB_BUTTON;
        case W_ENTER:
            return DLG_ENTER;
        case W_LABEL:
            return DLG_TEXT;
        case W_ICON:
            return DLG_ICON;
        case W_LIST:
            return DLG_LIST_BOX;
        case W_RECT:
            return DLG_RECT;
        case W_EDITBOX:
            return DLG_EDIT_BOX;
        case W_SCALE:
            return DLG_SCALE;
        case W_TABLE:
            return DLG_TABLE;
        case W_CANVAS:
            return DLG_CANVAS;
        case W_COMBO_BOX:
            return DLG_COMBO_BOX;
        default:
            return DLG_VERB_BUTTON;
    }
}

int
elfToXmWidgetType(elfWtype)
int elfWtype;
{
    switch(elfWtype) {
        case DLG_RADIO_BOX:
            return W_RADIO;
        case DLG_TOGGLE_BUTTON:
            return W_TOGGLE;
        case DLG_CHOICE:
            return W_OPTION;
        case DLG_VERB_BUTTON:
            return W_BUTTON;
        case DLG_ENTER:
            return W_ENTER;
        case DLG_TEXT:
            return W_LABEL;
        case DLG_ICON:
            return W_ICON;
        case DLG_LIST_BOX:
            return W_LIST;
        case DLG_RECT:
            return W_RECT;
        case DLG_EDIT_BOX:
            return W_EDITBOX;
        case DLG_SCALE:
            return W_SCALE;
        case DLG_TABLE:
            return W_TABLE;
        case DLG_CANVAS:
            return W_CANVAS;
        case DLG_COMBO_BOX:
            return W_COMBO_BOX;
        default:
            return -1;
    }
}

static void
addToAttsArray(w, atts)
AXWidget w; /* widget whose atts are to be folded onto the array */
data_ptr atts; /* the array <a1name>,<a1type>,<a1val>, <a2name>, ... */
{
    int ix, iVal, attName, aType, currType;
    mbchar *sVal;
    data_ptr currInfo, arrVal, info, tmp;
    if (!w->auxData || !w->auxData->gadget)
        return; /* nothing to add */
    if (w->type == W_BUTTON) {
        wVerbButtonSize(w->name, ((AXWidget_pushbutton)w)->pixmapLabel, 
                        w->font, w->thickness, w->shadow, w->textShadow,
                        &w->width, &w->height);
    }
    for (ix = 0; ix < NUM_GADGET_ATTS; ix++) {
        attName = DE.typeTable[ix][0];
        if (attName == DBDEXvalue) {
            aType = DBDEXvalueType(w);
        }
        else {
            aType = DE.typeTable[ix][1];
        }
        if (AxIsArray(currInfo = AxArrayElement(atts, ix))) {
                /* Something's already been written here.
                 * This represents the attempt to express the attrs of
                 * two or more gadgets, which will almost always result
                 * in nothing interesting.. */
                    /* if type or value at this position are dissimilar
                     * from w's, pitch the data and rewrite type as none */
            currType = AxIntFromArray(currInfo, 1);
            if (currType != DTYPE_NONE) {
                if (currType != aType) {
                    currInfo = AxAddIntToArray(currInfo, 1, DTYPE_NONE);
                    currInfo = AxAddIntToArray(currInfo, 2, 0);
                }
                else {
                    int pitch = FALSE;
                        /* compare gadget's value with that on atts array */
                    switch(aType) {
                        case DTYPE_INT:
                            if (AxIsArray(tmp =
                                AxArrayElement(w->auxData->gadget,attName))) {
                                iVal = AxIntFromArray(tmp, 0);
                            }
                            else {
                                iVal = AxIntFromArray(w->auxData->gadget,
                                            attName);
                            }
                            if (w->type == W_BUTTON) {
                                if (attName == DBDEXwidth) {
                                    iVal = w->width;
                                }
                                else if (attName == DBDEXheight) {
                                    iVal = w->height;
                                }
                            }
                            if (iVal != AxIntFromArray(currInfo, 2)) {
                                pitch = TRUE;
                            }
                            break;
                        case DTYPE_STR:
                            sVal = AxStrPtrFromArray(w->auxData->gadget,
                                            attName);
                            if (MBstrcmp(sVal,
                                    AxStrPtrFromArray(currInfo, 2))) {
                                pitch = TRUE;
                            }
                            break;
                        case DTYPE_STRS_ARRAY:
                                /* in practice this dtype means any array;
                                   attempt to compare the arrays; they'll
                                   match only if they're the same shape and
                                   size, with the same types and values in
                                   sequence */
                            arrVal = AxArrayElement(w->auxData->gadget,
                                                    attName);
                            if (!AXequalData(arrVal,
                                             AxArrayElement(currInfo, 2))) {
                                pitch = TRUE;
                            }
                            break;
                        case DTYPE_FONT_ATTR:
                            currInfo = deFoldFontAttr
                                (AxArrayElement(w->auxData->gadget, attName),
                                 currInfo, &pitch);
                            break;
                        default:
                            pitch = TRUE;
                            break;
                    }
                    if (pitch) {
                        currInfo = AxAddIntToArray(currInfo, 1, DTYPE_NONE);
                        currInfo = AxAddIntToArray(currInfo, 2, 0);
                    }
                }
            }
        }
        else {
                /* nothing has been recorded at this position yet;
                 * write w's value there */
            info = AxMakeArray(3);
            info = AxAddIntToArray(info, 0, attName);
            info = AxAddIntToArray(info, 1, aType);
            info = AxAddIntToArray(info, 2, 0); /* probably unneeded */
            switch(aType) {
                case DTYPE_INT:
                    if (AxIsArray(tmp = AxArrayElement(w->auxData->gadget,
                                    attName))) {
                            /* though we report here as simple int, intatts
                             * distinct for ol, mt are stored array-style on
                             * the gadget arrays.  motif gets index 0 */
                        iVal = AxIntFromArray(tmp, 0);
                    }
                    else {
                        iVal = AxIntFromArray(w->auxData->gadget, attName);
                    }
                    info = AxAddIntToArray(info, 2, iVal);
                    break;
                case DTYPE_STR:
                    sVal = AxStrPtrFromArray(w->auxData->gadget, attName);
                    info = AxAddStrToArray(info, 2, sVal);
                    break;
                case DTYPE_STRS_ARRAY:
                    if (AxIsInt(AxArrayElement(w->auxData->gadget, attName))) {
                            /* force into array form */
                        iVal = AxIntFromArray(w->auxData->gadget, attName);
                        tmp = AxMakeArray(1);
                        tmp = AxAddIntToArray(tmp, 0, iVal);
                        info = AxAddArrayToArray(info, 2, tmp);
                    }
                    if (AxIsString(AxArrayElement(w->auxData->gadget,
                                                  attName))) {
                        
                            /* force into array form */
                        sVal = AxStrPtrFromArray(w->auxData->gadget, attName);
                        tmp = AxMakeArray(1);
                        tmp = AxAddStrToArray(tmp, 0, sVal);
                        info = AxAddArrayToArray(info, 2, tmp);
                    }
                    else {
                        arrVal = AxArrayFromArray(w->auxData->gadget, attName);
                        info = AxAddArrayToArray(info, 2, ElfDataCopy(arrVal));
                    }
                    break;
                case DTYPE_POLY:
                    tmp = AxArrayElement(w->auxData->gadget, attName);
                    if (AxIsArray(tmp)) {
                        info = AxAddArrayToArray(info, 2, ElfDataCopy(tmp));
                    }
                    else {
                            /* treat as int */
                        iVal = IntFromDataPtr(tmp);
                        info = AxAddIntToArray(info, 2, iVal);
                    }
                    break;
                case DTYPE_FONT_ATTR:
                    arrVal = AxArrayElement(w->auxData->gadget, attName);
                    info = deAddFontAttrToArray(info, 2, arrVal);
                    break;
            }
            atts = AxAddArrayToArray(atts, ix, info);
        }
    }
}

static int
DBDEXvalueType(w)
AXWidget w;
{
    switch (w->type) {
        case W_SCALE:
        case W_ICON:
        case W_RECT:
        case W_BUTTON:
        case W_RADIO:
        case W_OPTION:
        case W_COMBO_BOX:
        case W_TOGGLE:
        case W_LABEL:
            return DTYPE_INT;
        case W_ENTER:
            return DTYPE_STR;
        case W_EDITBOX:
            return DTYPE_STRS_ARRAY;
        case W_LIST:
            return DTYPE_POLY;
        default:
            return 0;
    }
}

static void
deInitTypeTable()
{
    DE.typeTable[0][0] = DBDEXflags;
        DE.typeTable[0][1] = DTYPE_INT;
    DE.typeTable[1][0] = DBDEXxpos;
        DE.typeTable[1][1] = DTYPE_INT;
    DE.typeTable[2][0] = DBDEXypos;
        DE.typeTable[2][1] = DTYPE_INT;
    DE.typeTable[3][0] = DBDEXtitle;
        DE.typeTable[3][1] = DTYPE_STR;
    DE.typeTable[4][0] = DBDEXid;
        DE.typeTable[4][1] = DTYPE_STR;
    DE.typeTable[5][0] = DBDEXvalue;
        DE.typeTable[5][1] = DTYPE_POLY;
    DE.typeTable[6][0] = DBDEXstrs;
        DE.typeTable[6][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[7][0] = DBDEXwidth;
        DE.typeTable[7][1] = DTYPE_INT;
    DE.typeTable[8][0] = DBDEXheight;
        DE.typeTable[8][1] = DTYPE_INT;
    DE.typeTable[9][0] = DBDEXlength;
        DE.typeTable[9][1] = DTYPE_INT;
    DE.typeTable[10][0] = DBDEXno_title;
        DE.typeTable[10][1] = DTYPE_INT;
    DE.typeTable[11][0] = DBDEXmulti_pick;
        DE.typeTable[11][1] = DTYPE_INT;
    DE.typeTable[12][0] = DBDEXhoriz_scroll;
        DE.typeTable[12][1] = DTYPE_INT;
    DE.typeTable[13][0] = DBDEXthickness;
        DE.typeTable[13][1] = DTYPE_INT;
    DE.typeTable[14][0] = DBDEXdflt;
        DE.typeTable[14][1] = DTYPE_INT;
    DE.typeTable[15][0] = DBDEXtype;
        DE.typeTable[15][1] = DTYPE_INT;
    DE.typeTable[16][0] = DBDEXhelpid;
        DE.typeTable[16][1] = DTYPE_STR;
    DE.typeTable[17][0] = DBDEXvalid_chars;
        DE.typeTable[17][1] = DTYPE_STR;
    DE.typeTable[18][0] = DBDEXfg_color;
        DE.typeTable[18][1] = DTYPE_INT;
    DE.typeTable[19][0] = DBDEXbg_color;
        DE.typeTable[19][1] = DTYPE_INT;
    DE.typeTable[20][0] = DBDEXhide_vscroll;
        DE.typeTable[20][1] = DTYPE_INT;
    DE.typeTable[21][0] = DBDEXfontAttr;
        DE.typeTable[21][1] = DTYPE_FONT_ATTR;
    DE.typeTable[22][0] = DBDEXval_changed;
        DE.typeTable[22][1] = DTYPE_INT;
    DE.typeTable[23][0] = DBDEXminValue;
        DE.typeTable[23][1] = DTYPE_INT;
    DE.typeTable[24][0] = DBDEXmaxValue;
        DE.typeTable[24][1] = DTYPE_INT;
    DE.typeTable[25][0] = DBDEXno_label;
        DE.typeTable[25][1] = DTYPE_INT;
    DE.typeTable[26][0] = DBDEXforce_list_item_display;
        DE.typeTable[26][1] = DTYPE_INT;
    DE.typeTable[27][0] = DBDEXlist_item_for_display;
        DE.typeTable[27][1] = DTYPE_INT;
    DE.typeTable[28][0] = DBDEXreverseBitmap;
        DE.typeTable[28][1] = DTYPE_STR;
    DE.typeTable[29][0] = DBDEXuser_callbacks;
        DE.typeTable[29][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[30][0] = DBDEXoptional;
        DE.typeTable[30][1] = DTYPE_INT;
    DE.typeTable[31][0] = DBDEXshadow;
        DE.typeTable[31][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[32][0] = DBDEXtextShadow;
        DE.typeTable[32][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[33][0] = DBDEXtextColor;
        DE.typeTable[33][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[34][0] = DBDEXwidgetColor;
        DE.typeTable[34][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[35][0] = DBDEXlabelFont;
        DE.typeTable[35][1] = DTYPE_FONT_ATTR;
    DE.typeTable[36][0] = DBDEXlabelColor;
        DE.typeTable[36][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[37][0] = DBDEXlabelShadow;
        DE.typeTable[37][1] = DTYPE_STRS_ARRAY;
    DE.typeTable[38][0] = DBDEXstyle;
        DE.typeTable[38][1] = DTYPE_INT;
    DE.typeTable[39][0] = DBDEXtablayers;
        DE.typeTable[39][1] = DTYPE_STRS_ARRAY;
}

static data_ptr
deReadPrefs(info)
data_ptr info;
{
    data_ptr ret;
        /* currently 5 prefs: deGrids, deGridSize, deGridSnap,
         * deBorders, deGhostMove */
    ret = AxMakeArray(11);
    ret = AxAddIntToArray(ret, 0, 5); /* as in 3 prefs */
    ret = AxAddStrToArray(ret, 1, NXLT("display grid"));
    ret = AxAddStrToArray(ret, 2, GetProfileByStr(NXLT("deGrids")));
    ret = AxAddStrToArray(ret, 3, NXLT("grid size"));
    ret = AxAddStrToArray(ret, 4, GetProfileByStr(NXLT("deGridSize")));
    ret = AxAddStrToArray(ret, 5, NXLT("grid snap"));
    ret = AxAddStrToArray(ret, 6, GetProfileByStr(NXLT("deGridSnap")));
    ret = AxAddStrToArray(ret, 7, NXLT("view borders"));
    ret = AxAddStrToArray(ret, 8, GetProfileByStr(NXLT("deBorders")));
    ret = AxAddStrToArray(ret, 9, NXLT("ghost move"));
    if (ScratchMap) {
        ret = AxAddStrToArray(ret, 10,
                              GetProfileByStr(NXLT("deGhostMove")));
    }
    else {
            /* force ghost move/resize if no scratchmap */
        ret = AxAddStrToArray(ret, 10, "D");   /* grey out choice */
        DE.prefs.ghost = TRUE;
    }
    return (ret);
}

static data_ptr
deReadSelectedAtts(info)
data_ptr info;
{
    data_ptr ret;
    int ix;
        /* read 'union' of attrs of the selected set of gadgets.
         * output: typed atts array, format:
         * <a1name>,<a1type>,<a1val>, <a2name>,<a2type>,<a2val>,.. */
    ret = AxMakeArray(NUM_GADGET_ATTS);
    for(ix = 0; ix < DE.selectedSetSize; ix++) {
        addToAttsArray(DE.selectedSet[ix], ret);
    }
    return(ret);
}

static data_ptr
deReadWidgetAtts(info)
data_ptr info;
{
    int wtype, ix;
    data_ptr ret = AxMakeArray(NUM_GADGET_ATTS); 
        /* read 'union' attrs for all selected gadgets of wtype t.
         * output: typed atts array, format:
         * <a1name>,<a1type>,<a1val>, <a2name>,<a2type>,<a2val>,.. */
    wtype = AxIntFromArray(info, 1);
    for(ix = 0; ix < DE.selectedSetSize; ix++) {
        if (wtype == deElfWidgetType(DE.selectedSet[ix]))
            addToAttsArray(DE.selectedSet[ix], ret);
    }
    return(ret);
}

static data_ptr
deReadGenericAtts(info)
data_ptr info;
{
    int ix;
    data_ptr ret = AxMakeArray(NUM_GADGET_ATTS); 
        /* read 'union' attrs for all selected gadgets.
         * output: typed atts array, format:
         * <a1name>,<a1type>,<a1val>, <a2name>,<a2type>,<a2val>,.. */
    for(ix = 0; ix < DE.selectedSetSize; ix++) {
        addToAttsArray(DE.selectedSet[ix], ret);
    }
    return(ret);
}

static data_ptr
deReadDialogAtts(info)
data_ptr info;
{
    AXWidget_dialog tw;
        /* relay saved attr info */

        /* get the handle of the dialog shell */
    tw = (AXWidget_dialog)WidgetPointerFromHandleData(AxArrayElement(info, 1));
    tw = XmDlgInWidget((AXWidget_main)tw);
    if (tw && tw->auxData && tw->auxData->gadget) {
        return (ElfDataCopy(tw->auxData->gadget));
    }
    else {
        return((data_ptr) NULL);
    }
}

static data_ptr
deReadVerbButtonSize(info)
data_ptr info;
{
    data_ptr ret;
    int ix, tht, twid;
    AXWidget w;
        /* lots of dialogs have zero button dimensions; but dlg
         * needs to know what to report for size; fold all selected
         * buttons together in doing this, as in READ_WIDGET_ATTS */
    twid = tht = -1;
    for(ix = 0; ix < DE.selectedSetSize; ix++) {
        if ((DE.selectedSet[ix])->type == W_BUTTON) {
/* %%%%%%%%%%% this is reading the widget_t rather than the gadget array.. */
            w = DE.selectedSet[ix];
            wVerbButtonSize(w->name, ((AXWidget_pushbutton)w)->pixmapLabel, 
                            w->font, w->thickness, w->shadow, w->textShadow,
                            &w->width, &w->height);
            if (twid == -1) {
                twid = (DE.selectedSet[ix])->width; /* not taken yet; record */
            }
            else if (twid != (DE.selectedSet[ix])->width) {
                twid = 0; /* differing widths among set */
            }
            if (tht == -1) {
                tht = (DE.selectedSet[ix])->height;
            }
            else if (tht != (DE.selectedSet[ix])->width) {
                tht = 0;
            }
        }
    }
    ret = AxMakeArray(2);
    ret = AxAddIntToArray(ret, 0, twid);
    ret = AxAddIntToArray(ret, 1, tht);
    return(ret);
}

static data_ptr
deReadWidgetsList(info)
data_ptr info;
{
    data_ptr dp, ret;
    AXWidget tw, ww;
    AXWidget_dialog dlg;
    int ix, numwidgets;
    AXWidget_handle wh;
	mbchar accel_str[2];

	/* return format: <DE_WIDGETS_LIST><#w>,
	 *  <<w1ID><w1elfWtype><w1handle><w1selected><w1AccelKey>>,<w2ID...
	 */
    tw = WidgetPointerFromHandleData(AxArrayElement(info, 1));
    if (!tw) {
        return ((data_ptr) NULL);
    }
    
    dlg = XmDlgInWidget((AXWidget_main)tw);/* get dlg handle from shell */
    for(tw = dlg->widgets, numwidgets = 0; tw; tw = tw->nextChild) {
        ww = tw;
        if (tw == topWidget(ww)) {
            numwidgets++; /* count # elf-visible widgets */
        }
    }
    ret = AxMakeArray(numwidgets + 2);
    ret = AxAddIntToArray(ret, 0, DE_WIDGETS_LIST);
    for(tw = ((AXWidget_main)dlg)->widgets, ix = 2; tw; tw = tw->nextChild) {
        ww = tw;
        if (tw->type == W_ALIGN && tw->style == ALIGN_GRID) {
            numwidgets--;
            continue;   /* don't report the grid */
        }
        if (tw == topWidget(ww)) {
            dp = AxMakeArray(4);
            if (tw->auxData && tw->auxData->gadget) {
                dp = AxAddStrToArray
                    (dp, 0, AxStrFromArray(tw->auxData->gadget, DBDEXid));
            }
            else {
                dp = AxAddStrToArray(dp, 0, "");
            }
            dp = AxAddIntToArray(dp, 1, deElfWidgetType(tw));

            wh = HANDLE_FROM_WIDGET(tw);
            dp = AxWriteArray(dp, 2, AxMakeBinaryData(sizeof(wh), (char*)&wh));

            if (tw->auxData) {
                if (tw->auxData->wEdit.marked)
                    dp = AxAddIntToArray(dp, 3, ELFTRUE);
                else
                    dp = AxAddIntToArray(dp, 3, 0);
            }
            else {
                dp = AxAddIntToArray(dp, 3, 0); /* not selected */
            }
			accel_str[0] = (mbchar) tw->accelerator_key;
			accel_str[1] = 0;
			dp = AxAddStrToArray(dp, 4, accel_str);
            ret = AxAddArrayToArray(ret, ix, dp);
            ix++;
        }
    }
    ret = AxAddIntToArray(ret, 1, numwidgets);
    return (ret);
}

/* : deReadDialogsList - produce list of "in-edit" dialogs
 * list format: <<dlg1title>,<dlg1taskUid>>, <<dlg2title>,<dlg2taskUid>>, ..
 */
static data_ptr
deReadDialogsList()
{
    int ix;
    data_ptr dlginfo;
    data_ptr message = AxMakeArray(DE.numDlgs);
    for (ix = 0; ix < DE.numDlgs; ix++) {
        dlginfo = AxMakeArray(2);
        dlginfo = AxAddStrToArray(dlginfo, 0,
                                  (DE.dialogs[ix].dlg)->parent->name);
        dlginfo = AxAddIntToArray(dlginfo, 1,
                                  ThimUIDPid((DE.dialogs[ix].dlg)->taskOwner));
        message = AxAddArrayToArray(message, ix, dlginfo);
    }
    return (message);
}

/* : deReadMainMenuState - return whether de main menu is up */
static data_ptr
deReadMainMenuState()
{
    data_ptr running = AxMakeArray(1);
    running = AxAddIntToArray(running, 0, DE.main_menu);
    return (running);
}

/* : deWriteMainMenuState - write whether de main menu is up */
static void
deWriteMainMenuState(on)
int on;
{
    DE.main_menu = on;
}

/* : deComputeGadgetOrder - produce the gadget_order as used by
 * the dialog box elf code, where the order written here reflects
 * the back-to-front paint order of the dialog's widgets
 *
 * each element of the gadget_order array represents one of the
 * dbox's widgets.  the format of each element is a number that
 * has a "high byte" and a "low byte"; the high byte stores the
 * (dialog_box_ format) gadget_type, and the low byte stores the
 * gadget_dex.  (the dbox's gadgets are arranged by type at the
 * top of the dialog_box_)
 */
typedef struct gOrder_t {
    unsigned int present;
    unsigned int orderWord;
    AXWidget wHandle;
} gOrder;                /* use this typedef to help with sorting */

static data_ptr
deComputeGadgetOrder(info)
data_ptr info;
{
    AXWidget_dialog dw;
    data_ptr dlg, dHandle, atmp, htmp;
    data_ptr orderedList, gadg;
    int ix, jx, gx, asize, numGadgets;
    unsigned int utmp;
    wLayer *ly;
    gOrder *gList, *gtmp;
    
    dlg = AxArrayElement(info, 1);             /* a copy of the dialog */
    if (!dlg) {
        return ((data_ptr) NULL);
    }
    
    dHandle = AxArrayElement(dlg, DB_widget);
    dw = (AXWidget_dialog)WidgetPointerFromHandleData(dHandle);
    if (!dw) {
        return ((data_ptr) NULL);
    }
    dw = XmDlgInWidget((AXWidget_main)dw);  /* the dbox's AXWidget */
    if (!dw) {
        return ((data_ptr) NULL);
    }
    
    if (!dw->layerList) {
        return ((data_ptr) NULL);
    }

        /* count the number of gadgets in the dbox */
    for (ix = 0, numGadgets = 0; ix < DLG_NUM_GADGETS; ix++) {
        atmp = AxArrayElement(dlg, ix);
        asize = AxArraySize(atmp);
        for (jx = 0; jx < asize; jx++) {
            gadg = AxArrayElement(atmp, jx);
            if (AxArraySize(gadg)) {
                numGadgets ++;
            }
        }
    }
        /* write their handles and type/dex vals onto the gList */
    ix = numGadgets * sizeof(gOrder);
    gList = (gOrder *) TaskAlloc(0, ix);
    memset((char *) gList, 0, ix);
    for (ix = 0, gx = 0; ix < DLG_NUM_GADGETS; ix++) {
        atmp = AxArrayElement(dlg, ix);
        asize = AxArraySize(atmp);
        for (jx = 0; jx < asize; jx++) {
            gadg = AxArrayElement(atmp, jx);
            if (AxArraySize(gadg)) {
                htmp = AxArrayElement(gadg, DBDEXwidget);
                if (AxIsArray(htmp)) {
                        /* use the 0th handle -- that's the top widget
                         */
                    gList[gx].wHandle =
                        WidgetPointerFromHandleData(AxArrayElement(htmp, 0));
                }
                else {
                    gList[gx].wHandle = WidgetPointerFromHandleData(htmp);
                }
                utmp = (unsigned int) (ix << 8);     /* gadget_type */
                utmp |= (unsigned int) jx;           /* gadget_dex */
                gList[gx].orderWord = utmp;
                gx++;
            }
        }
    }
        /* write the ordered list in layerList order */
    orderedList = AxMakeArray(numGadgets);
    for (jx = 0, ly = dw->layerList; ly; ly = ly->next) {
        for (gx = 0, gtmp = (gOrder *) NULL; gx < numGadgets; gx++) {
            if (gList[gx].wHandle == ly->w) {
                gtmp = &gList[gx];
                gList[gx].present = TRUE;
                break;
            }
        }
        if (gtmp) {
            orderedList = AxAddIntToArray(orderedList, jx,
                                          (int) gtmp->orderWord);
            jx++;
        }
    }
        /* now include any that weren't found on the layerList */
    for (gx = 0; gx < numGadgets; gx++) {
        if (!gList[gx].present) {
            orderedList = AxAddIntToArray(orderedList, jx,
                                          (int) gList[gx].orderWord);
            jx++;
        }
    }
    
    TaskFree(0, (char *) gList);
    if (jx) {
        return (orderedList);
    }
    else {
        AxFreeData(orderedList);
        return ((data_ptr) NULL);
    }
}

static data_ptr
deEqualWidgetHandles(info)
data_ptr info;              /* <<DE_WIDGET_HANDLES_MATCH><h1><h2>> */
{
    AXWidget h1, h2;
    
    h1 = WidgetPointerFromHandleData(AxArrayElement(info, 1));
    h2 = WidgetPointerFromHandleData(AxArrayElement(info, 2));
    
    return (AxMakeIntData(h1 == h2));
}

static data_ptr
deListFontFamilies()
{
    char **edfams, **totalfams, *cp;
    mbchar *thisFam;
    int ix, fx, numFams, numTotal;
    AXWidget kid;
    AXWidget_dialog dlg;
    axhtab edit_fams;
    hitem *list;
    data_ptr ret_list;

    /* make a list of all font families present across all
     * dialog boxes currently under edit.  These would be
     * found as gadget atts DBDEXfontAttr, DBDEXlabelFont
     */
    axhInitTable(&edit_fams, 31, 0, 0);
    for (ix = 0; ix < DE.numDlgs; ix++) {
        dlg = (AXWidget_dialog)DE.dialogs[ix].dlg;
        for (kid = dlg->widgets; kid; kid = kid->nextChild) {
            if (kid->auxData && kid->auxData->gadget) {
                thisFam = deFontFamilyFromAttr
                    (AxArrayElement(kid->auxData->gadget, DBDEXfontAttr));
                if (thisFam) {
                    axhGetItem((char *) thisFam, &edit_fams,
                               (char *) NULL, &cp);
                }
                thisFam = deFontFamilyFromAttr
                    (AxArrayElement(kid->auxData->gadget, DBDEXlabelFont));
                if (thisFam) {
                    axhGetItem((char *) thisFam, &edit_fams,
                               (char *) NULL, &cp);
                }
            }
        }
    }
    for (ix = 0, numFams = 0; ix < edit_fams.width; ix++) {
        list = edit_fams.table[ix];
        while(list) {
            if (list->name) {
                numFams++;
            }
            list = list->next;
        }
    }
    if (numFams) {
        edfams = (char **) malloc(numFams * sizeof(mbchar *));
        for (ix = 0, fx = 0; ix < edit_fams.width; ix++) {
            list = edit_fams.table[ix];
            while(list) {
                if (list->name) {
                    edfams[fx] = list->name;
                    fx++;
                }
                list = list->next;
            }
        }
    }
    else {
        edfams = (char **) NULL;
    }
    
    /* mix with all available font families
     */
    totalfams = axListFontFamilies(edfams, numFams, &numTotal);

    /* return as elf array of strings
     */
    ret_list = AxMakeArray(0);
    for (ix = 0; ix < numTotal; ix++) {
        ret_list = AxAddStrToArray(ret_list, ix, totalfams[ix]);
    }

    /* toss local allocated
     */
    axhDeleteTable(&edit_fams, (char *) NULL);
    if (edfams)
        free(edfams);
    if (totalfams)
        free(totalfams);
    
    return (ret_list);
}

/* : deScaleDialogLayout - scale positions and sizes
 * of the dbox and its widgets if the dbox's reference
 * font (wkit dialog main font in effect at time of last
 * edit) differs from the current dialog main font. this
 * occurs before realizing the dbox.  this function will
 * modify the dialog box elf array in place.
 */
static data_ptr
deScaleDialogLayout(dbox)
data_ptr dbox;
{
    XFontStruct *rfs;
    int itmp, different, ix, asize, gx;
    int wid, ht, minwid, minht, maxwid, maxht;
    data_ptr atmp, gadg, sbox, rCell, rCellVal, rCellPair;
    
    if (!dbox)
        return ((data_ptr) NULL);
    
    sbox = ElfDataCopy(dbox);
    
    if (AxIntFromArray(sbox, DB_no_expand)) {
        return (sbox);       /* don't scale */
    }

        /* check whether there is a difference between
           the current dialog main font and this dbox's
           reference font */
    rfs = lookupReferenceFont(AxArrayElement(sbox, DB_reference_font),
                              &different);
    if (!different) {
        return (sbox);       /* good. no need to scale anything */
    }
    
        /* scale all dimension info in place */

        /* do the dialog box sizes */
    AxScaleDialogFrame(sbox, &wid, &ht, &minwid, &minht,
                       &maxwid, &maxht);
    sbox = deWriteSizeValue(sbox, DB_width, wid);
    sbox = deWriteSizeValue(sbox, DB_height, ht);
    sbox = deWriteSizeValue(sbox, DB_min_width, minwid);
    sbox = deWriteSizeValue(sbox, DB_min_height, minht);
    sbox = deWriteSizeValue(sbox, DB_max_width, maxwid);
    sbox = deWriteSizeValue(sbox, DB_max_height, maxht);

        /* now do the widgets */

    for (ix = 0; ix < DLG_NUM_GADGETS; ix++) {
        atmp = ElfDataCopy(AxArrayElement(sbox, ix));
        asize = AxArraySize(atmp);
        for (gx = 0; gx < asize; gx++) {
            gadg = ElfDataCopy(AxArrayElement(atmp, gx));
            if (ix == DLG_RECT || ix == DLG_VERB_BUTTON ||
                ix == DLG_EDIT_BOX || ix == DLG_TABLE ||
                ix == DLG_SCALE || ix == DLG_TRAY || ix == DLG_COMBO_BOX ||
                ix == DLG_SPLITTER || ix == DLG_CANVAS) {
                    /* position is scaled for all types, but height
                       and width are scaled only for these types (this
                       is because for the others the size depends on
                       the font size, and therefore scales 'automatically') */
                       
                itmp = AxMtOlVal(AxArrayElement(gadg, DBDEXwidth));
                itmp = axDlgScaleX(itmp, rfs);
                gadg = deWriteSizeValue(gadg, DBDEXwidth, itmp);
            
                itmp = AxMtOlVal(AxArrayElement(gadg, DBDEXheight));
                itmp = axDlgScaleY(itmp, rfs);
                gadg = deWriteSizeValue(gadg, DBDEXheight, itmp);
            }
            else {
                    /* don't scale height, width */
                itmp = AxMtOlVal(AxArrayElement(gadg, DBDEXwidth));
                gadg = deWriteSizeValue(gadg, DBDEXwidth, itmp);
            
                itmp = AxMtOlVal(AxArrayElement(gadg, DBDEXheight));
                gadg = deWriteSizeValue(gadg, DBDEXheight, itmp);
            }
            
            itmp = AxMtOlVal(AxArrayElement(gadg, DBDEXxpos));
            itmp = axDlgScaleX(itmp, rfs);
            gadg = deWriteSizeValue(gadg, DBDEXxpos, itmp);
            
            itmp = AxMtOlVal(AxArrayElement(gadg, DBDEXypos));
            itmp = axDlgScaleY(itmp, rfs);
            gadg = deWriteSizeValue(gadg, DBDEXypos, itmp);
            
            atmp = AxAddArrayToArray(atmp, gx, gadg);
        }
        sbox = AxAddArrayToArray(sbox, ix, atmp);
    }
    
        /* now change this box's reference font to the
           current wkit dialog main font; the reference
           "font" format (character cell, actually) looks like:
           <<<FONT_CELLSIZE>><<cellWidth><cellAscent><cellDescent>>>
         */
    rCell = AxMakeArray(1);       /* an array of 1 of: attr-value */
    rCellPair = AxMakeArray(2);   /* attr-value: CELLSIZE-sizedata */
    rCellVal = AxMakeArray(3);    /* sizedata */
    rCellPair = AxAddIntToArray(rCellPair, 0, FONT_CELLSIZE);
    rCellVal = AxAddIntToArray(rCellVal, 0,
                               AXTextWidth(AxDlgMainFont, "0", 1));
    rCellVal = AxAddIntToArray(rCellVal, 1, AxDlgMainFont->ascent);
    rCellVal = AxAddIntToArray(rCellVal, 2, AxDlgMainFont->descent);
    rCellPair = AxAddArrayToArray(rCellPair, 1, rCellVal);
    rCell = AxAddArrayToArray(rCell, 0, rCellPair);
    sbox = AxAddArrayToArray(sbox, DB_reference_font, rCell);
    
    return (sbox);
}

#if 0  /* re-use dialog for new contents stuff */
/* : deResetDialog - prepare dialog for different contents,
 * e.g., because the dialog is being 'changed' into another,
 * or for a revert or  undo operation.
 */
static void
deResetDialog(dlg)
AXWidget dlg;
{
    AXWidget cw, tmp;

        /* force reset of widget-create data, in case it's
           referring to any of the widgets about to be nixed */
    DE.newWidget.doCreate = FALSE;
    DE.newWidget.whichDialog = (AXWidget_dialog) NULL;
    DE.newWidget.wType = 0;
    DE.newWidget.wWidget = (AXWidget) NULL;
    AxFreeData(DE.newWidget.wInfo);

    liftAllMarks();  /* remove all kids from selected set */

    for (cw = tmp = dlg->widgets; cw; cw = tmp) {
        tmp = cw->nextChild;
        liftWidget(cw);
        AxXtDestroyWidget(cw);
    }
}
#endif

/* : deMenuBarKey - return true when accelerator key event is detected.
 *   Menu bar is the de's mb, regardless of whatever mb the dlg w may have.
 *   send the accel event as a menubar event to w's task
 */
int
deMenuBarKey(w, eventP)
AXWidget w; /* if menu bar event sent, send to this widget's task */
XEvent *eventP;
{
    AXWidget_dialog tw;
    char *name;
    int is_text;
    menu_item_def *mP = NULL;       /* the elf menu bar data */
    int bell;
    char keybuf[XLS_BUF_LEN+1];
    KeySym ksym;
    data_ptr message;
        
    mP = deMenuBar(&tw);
    if ( ProcessKeyEvent(mP,eventP,&is_text,&name,&bell) &&
                        !is_text ) {
        if ( !AxIsCommandAvailable((AXWidget)tw->parent, name) ) {
            return FALSE;
        }
        if (!name) {
            return FALSE;
        }
        message = AxMakeArray(2);
        message = AxAddIntToArray(message, 0, DE_MENU_BAR);
        message = AxAddStrToArray(message, 1, name);
        SendElfData(w->taskOwner, POKE_DE_MESSAGE, message);
        AxFreeData(message);
        return TRUE;
    }
#if AX_X11
        /* must test for certain keystroke events
         */
    AXLookupString(eventP, keybuf, XLS_BUF_LEN, &ksym);
    if (ksym == XK_Escape) {
            /* escape will kill the box; give task
             * a chance to clean up first
             */
        XmPoker(POKE_EXIT, 0, w->parent, TRUE, TRUE);
        return TRUE;
    }
    else if (ksym == XK_Return) {
            /* filter the return key unconditionally;
             * (this is to prevent box-kill if OK is
             * the default action)
             */
        return TRUE;
    }
#endif

    return FALSE;
}

static menu_item_def *
deMenuBar(w)
AXWidget_dialog *w; /* out: init to handle of 1st dlg found with de menubar */
{
    AXWidget_main tw;
    
    for ( tw = (AXWidget_main)WindowList; tw;tw =(AXWidget_main)tw->nextWin ) {
        if (tw->type == W_MAIN && tw->dialog) {
            if (tw->style == APP_DLGED && tw->menuBar) {
                if (w) {
                    *w = tw->dialog;
                }
                return (tw->menuBar->popups);
            }
        }
    }
    return ((menu_item_def *) NULL);
}

static void
deDrawSelectorRect(dlg, p1, p2, strokeState)
AXWidget_dialog dlg;
p32 *p1, *p2;
{
    r32 rect;

    if (dlg->type == W_MAIN)
        dlg = ((AXWidget_main)dlg)->dialog;
        
    deNormalRect(p1, p2, &rect);

    if (strokeState != DE_STROKE_START) {
            /* lift old */
        XDrawRectangle(Dpy, dlg->window, DE.rubberGC,
            DE.lastGhost[0].origin.x, DE.lastGhost[0].origin.y,
            (unsigned int) DE.lastGhost[0].width,
            (unsigned int) DE.lastGhost[0].height);
    }
    if (strokeState != DE_STROKE_END) {
            /* draw new */
        XDrawRectangle(Dpy, dlg->window, DE.rubberGC,
            rect.origin.x, rect.origin.y,
            (unsigned int) rect.width, (unsigned int) rect.height);
    }
    DE.lastGhost[0] = rect;
}

static void
deSelectAllInside(dlg, p1, p2)
AXWidget_dialog dlg;
p32 *p1, *p2;
{
    AXWidget tw;
    r32 trect, selRect;
    AXWidget_handle wh;
    data_ptr tp;
    data_ptr wlist = (data_ptr) NULL;
    int numIn = 0;
    int me = THIMpid;

    
	/* describe set to be selected using array of form:
	 * <DE_WIDGETS_LIST>,
	 *  <#w><<w1ID>,<w1elfWtype><w1Handle>,<w1Selected>,<w1AccelKey>>,<w2ID..
	 */
    deNormalRect(p1, p2, &selRect);
    for (tw = dlg->widgets; tw; tw = tw->nextChild) {
        if (tw->flags & WFLG_NODISPLAY)
            continue;  /* don't select if not visible */
        if (tw == topWidget(tw)) {
            getWidgetSize(tw, &trect, FALSE);
            if (rectInsideRect(&trect, &selRect)) {
                if (!numIn) {
                    VfyContext(dlg->taskOwner);
                    wlist = AxMakeArray(3);
                    wlist = AxAddIntToArray(wlist, 0, DE_WIDGETS_LIST);
                }
                tp = AxMakeArray(4);
                    /* 0th, 1th, 4th elements not used in this context */
                wh = HANDLE_FROM_WIDGET(tw);
                tp = AxWriteArray(tp, 2,
                                  AxMakeBinaryData(sizeof(wh), (char*)&wh));
                tp = AxAddIntToArray(tp, 3, TRUE);
                wlist = AxAddArrayToArray(wlist, numIn + 2, tp);
                numIn++;
            }
        }
    }
    if (numIn) {
        liftAllMarks();
        wlist = AxAddIntToArray(wlist, 1, numIn);
        deSelectWidgets(dlg, wlist);
        AxFreeData(wlist);
        VfyContext(me);
    }
    deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
}

    /* return in origin-corner form the rect described by p1, p2 */
static void
deNormalRect(p1, p2, rect)
p32 *p1, *p2;   /* in: any two points */
r32 *rect;      /* out: the normalized rect */
{
    p32 origin, corner;
    origin.x = p1->x < p2->x ? p1->x : p2->x;
    origin.y = p1->y < p2->y ? p1->y : p2->y;
    corner.x = p1->x > p2->x ? p1->x : p2->x;
    corner.y = p1->y > p2->y ? p1->y : p2->y;
    rect->origin = origin;
    rect->width = corner.x - origin.x + 1;
    rect->height = corner.y - origin.y + 1;
}


/* : AxFilterMotionNotify - intended for use on MotionNotify
 * events.  caller should pass a MotionNotify, and will get
 * back the most recently received MotionNotify in any contiguous
 * group (this is often just a copy of the passed MotionNotify)
 */
void
AxFilterMotionNotify(inEvent, outEvent)
XEvent *inEvent;    /* in: for sanity check */
XEvent *outEvent;   /* out: return most recent in contig. group */
{
#if AXMS
    /* basically a no-op function for NT */
    *outEvent = *inEvent;
    return;
#else

    XEvent curEvent, lastEvent;

    if (inEvent->type != MotionNotify) {
        *outEvent = *inEvent;
        return;
    }
    lastEvent = *inEvent;
    while ( QLength(Dpy) > 1 ) {
        XPeekEvent(Dpy, &curEvent);
        if ( curEvent.type != MotionNotify ) {
            break;
        }
        else {
            XNextEvent(Dpy, &curEvent);
            lastEvent = curEvent;
        }
    }
    *outEvent = lastEvent;

#endif
}

static data_ptr
deWriteSizeValue(info, offset, val)
data_ptr info;
int offset;
int val;
{
    data_ptr atmp;

    atmp = AxArrayElement(info, offset);
    if (AxIsArray(atmp)) {
            /* once upon a time, size vals were split
               into motif and openlook values. the motif
               numbers (the only ones that matter anymore)
               are stored on element 0 */
        atmp = ElfDataCopy(AxArrayElement(info, offset));
        atmp = AxAddIntToArray(atmp, 0, val);
        info = AxAddArrayToArray(info, offset, atmp);
    }
    else {
        info = AxAddIntToArray(info, offset, val);
    }
    return (info);
}

/* : deRemeasureWidget - get the height and width
 * members of the AXWidget struct in sync with
 * the rest of the struct data.  This is used
 * in the context of the local-echo in deApplyAtts,
 * and so is incomplete since many of the widget
 * types update OK without this extra work.
 */
static void
deRemeasureWidget(w)
AXWidget w;
{
    AXWidget topw;
    int width, height, itmp;
    
    switch(w->type) {
        
    case W_LABEL:
        topw = topWidget(w);
        if (topw->type == W_RADIO) {
            deRemeasureRadioBox(topw);
        }
        else {
            wLabelSize(w->name, w->font, w->textShadow, &w->width, &w->height);
        }
        break;
        
    case W_TOGGLE:
        topw = topWidget(w);
        if (topw->type == W_RADIO) {
            deRemeasureRadioBox(topw);
        }
        else {
            wToggleButtonSize(w->name, w->font, &w->width, &w->height);
        }
        break;
        
    case W_BUTTON:
            /* need to get the gadget width, height so that
             * we get #'s that will match the elf-echo
             */
        if (w->auxData && w->auxData->gadget) {
            width = AxMtOlVal(AxArrayElement(w->auxData->gadget,
                                             DBDEXwidth));
            height = AxMtOlVal(AxArrayElement(w->auxData->gadget,
                                              DBDEXheight));
        }
        else {
            width = height = 0;
        }
        wVerbButtonSize(w->name, ((AXWidget_pushbutton)w)->pixmapLabel, 
                        w->font, w->thickness, w->shadow, w->textShadow,
                        &width, &height);
        w->width = width;
        w->height = height;
        break;
        
    case W_RADIO:
        deRemeasureRadioBox(w);
        break;
        
    case W_OPTION:
        deRemeasureOptionMenu((AXWidget_option)w);
        break;
        
    case W_ENTER:
        deRemeasureEnter((AXWidget_entry)w);
        break;
        
    case W_COMBO_BOX:
        itmp = wComboHeight(w->font);
        if (itmp != w->height) {
            deFreePixmap(w);
        }
        w->height = itmp;
        break;
    }
}

static void
deRemeasureRadioBox(w)
AXWidget w;
{
    wComposite *cp;
    int ypos;
    int labelHeight = 0;
    int maxwidth = 0;
    int height = 0;

        /* get the label height
         */
    ypos = w->ypos;                   /* fallback y position.. */
    if (w->auxData) {
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->type == WLINKDOWN) { /* should be true */
                if (cp->w->type == W_LABEL) {
                    wLabelSize(cp->w->name, cp->w->font, cp->w->textShadow,
                               &cp->w->width, &cp->w->height);
                    maxwidth = cp->w->width;
                    labelHeight = cp->w->height;
                    ypos = cp->w->ypos;
                }
            }
        }
    }
    ypos += labelHeight + 2;     /* the 2 comes from CreateRadioBox */
    w->ypos = ypos;
    if (w->auxData) {
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->type == WLINKDOWN) { /* should be true */
                if (cp->w->type == W_TOGGLE) {
                    wToggleButtonSize(cp->w->name, cp->w->font,
                                      &cp->w->width, &cp->w->height);
                    if (cp->w->width > maxwidth) {
                        maxwidth = cp->w->width;
                    }
                    cp->w->ypos = ypos;
                    ypos += cp->w->height;
                    height += cp->w->height;
                }
            }
        }
        w->height = height;
        w->width = maxwidth;
    }
}

static void
deRemeasureOptionMenu(w)
AXWidget_option w;
{
    int ix, max, width, barwid, barspc, totWid, twid;
    int labelYoffset, fieldYoffset;
    XFontStruct *labelFont, *choicesFont;
    data_ptr labelShadow, choicesShadow;
    
    if (w->font) {
        labelFont = w->font;
        labelShadow = w->textShadow;
    }
    else {
        labelFont = AxDlgMainFont;
        labelShadow = (data_ptr) NULL;
    }
#if AXMS
    choicesFont = AxDlgMainFont;
    choicesShadow = (data_ptr) NULL;
    for ( ix = 0, max = 0; ix < w->num_strs; ix++ ) {
        twid = AXTextWidth(choicesFont, w->strs[ix], strlen(w->strs[ix]));
        if ( twid > max )
            max = twid;
    }
#else   
    if (w->num_buttons && (w->buttons[0])->font) {
        choicesFont = (w->buttons[0])->font;
        choicesShadow = (w->buttons[0])->textShadow;
    }
    else {
        choicesFont = AxDlgMainFont;
        choicesShadow = (data_ptr) NULL;
    }
    for ( ix = 0, max = 0; ix < w->num_buttons; ix++ ) {
        twid = AXTextWidth(choicesFont, w->buttons[ix]->name,
                           strlen(w->buttons[ix]->name));
        if ( twid > max )
            max = twid;
    }
#endif
    wOptionWidth(w->name, labelFont, max, &width, &barwid,
                 &barspc, &totWid);
    w->pulldown_width = (short) width;
    w->width = totWid;
    w->height = wOptionHeight(labelFont, choicesFont, labelShadow,
                              choicesShadow, &labelYoffset, &fieldYoffset);

#if AX_X11
        /* scrolltext is used to hold max choice width; reset */
    w->scrolltext = -1;
#endif  
}

static void
deRemeasureEnter(w)
AXWidget_entry w;
{
    wComposite *cp;
    AXWidget_label lw;
    int xoffset, yoffset, itmp, nCols;

        /* find the label of the entry field
         */
    lw = (AXWidget_label) NULL;
    if (w->auxData) {
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->type == WLINKDOWN) { /* should be true */
                if (cp->w->type == W_LABEL) {
                    lw = (AXWidget_label)cp->w; /* the entry field's label */
                    break;
                }
            }
        }
    }
        /* update width, height of enterable field portion
         */
    wEnterPixHeight(w->font, w->textShadow, &itmp, &w->height);
    nCols = wEnterColWidth(w->width, w->font, w->textShadow);
    wEnterPixWidth(nCols, w->font, w->textShadow);
    
    if (lw) {
            /* there should always be a label widget, even when
             * the label style is LABEL_NONE (during which its
             * display is off).  update the position of the
             * field portion by relating it to the label position
             */
        wEnterFieldOffset(w->style, lw->name, lw->font,
                          w->font, nCols, w->textShadow, &xoffset, &yoffset);
        w->xpos = lw->xpos + xoffset;
        w->ypos = lw->ypos + yoffset;
            /* update label size as well
             */
        xmLabelSize((AXWidget)lw, lw->name, lw->font, lw->textShadow);
    }
}

/*
 * : deAddFontAttrToArray - copy the passed font attribute data
 * onto 'attr' in the form used for combining multiple gadgets'
 * attributes: <<attr type><attr dtype><attr val>>   in the case
 * of font attrs, do this for each of face, size, weight, slant
 * (in that order)
 */
static data_ptr
deAddFontAttrToArray(info, attIx, attr)
data_ptr info;       /* in/out: xform attr data onto this */
int attIx;           /* in: write this element of info */
data_ptr attr;       /* in: font attr data in form stored on gadget */
{
    mbchar *defFace, *face;
    int defSize, defWeight, defSlant;
    int size, weight, slant;
    int asize, ix;
    data_ptr fAtt, atmp, btmp;
    
    deNamedFontDefaults(&defFace, &defSize, &defWeight, &defSlant);
    face = defFace;
    size = defSize;
    weight = defWeight;
    slant = defSlant;
    
    if (attr && !AxIsString(attr)) {
            /* override with passed-in values */
        asize = AxArraySize(attr);
        for (ix = 0; ix < asize; ix++) {
            btmp = AxArrayElement(attr, ix);
            switch (AxIntFromArray(btmp, 0)) {
            case FONT_FAMILY:
                face = AxStrFromArray(btmp, 1);
                break;
            case FONT_WEIGHT:
                weight = AxIntFromArray(btmp, 1);
                break;
            case FONT_SLANT:
                slant = AxIntFromArray(btmp, 1);
                break;
            case FONT_SIZE:
                size = AxIntFromArray(btmp, 1);
                break;
            }
        }
    }
        /* create output form of attr */
    fAtt = AxMakeArray(4);
    
    atmp = AxMakeArray(3);
    atmp = AxAddIntToArray(atmp, 0, FONT_FAMILY);
    atmp = AxAddIntToArray(atmp, 1, DTYPE_STR);
    atmp = AxAddStrToArray(atmp, 2, face);
    fAtt = AxAddArrayToArray(fAtt, 0, ElfDataCopy(atmp));
    
    atmp = AxMakeArray(3);
    atmp = AxAddIntToArray(atmp, 0, FONT_SIZE);
    atmp = AxAddIntToArray(atmp, 1, DTYPE_INT);
    atmp = AxAddIntToArray(atmp, 2, size);
    fAtt = AxAddArrayToArray(fAtt, 1, ElfDataCopy(atmp));
        
    atmp = AxMakeArray(3);
    atmp = AxAddIntToArray(atmp, 0, FONT_WEIGHT);
    atmp = AxAddIntToArray(atmp, 1, DTYPE_INT);
    atmp = AxAddIntToArray(atmp, 2, weight);
    fAtt = AxAddArrayToArray(fAtt, 2, ElfDataCopy(atmp));
        
    atmp = AxMakeArray(3);
    atmp = AxAddIntToArray(atmp, 0, FONT_SLANT);
    atmp = AxAddIntToArray(atmp, 1, DTYPE_INT);
    atmp = AxAddIntToArray(atmp, 2, slant);
    fAtt = AxAddArrayToArray(fAtt, 3, atmp);
    
    return (AxAddArrayToArray(info, attIx, fAtt));
}

/*
 * : deFoldFontAttr - fold from's font attr value onto to,
 * by comparing the two values; to represents the intersection
 * of the font attr values of 1 or more widgets.  Return whether
 * the from and to attrs are completely different, on param 'different'
 */
static data_ptr
deFoldFontAttr(from, to, different)
data_ptr from;             /* in */
data_ptr to;               /* in/out */
int *different;            /* out: return whether from completely differs */
{
    int fx, fromInt, toInt;
    int fatt, fromsize, defaultFrom;
    int faceDifferent, sizeDifferent, weightDifferent, slantDifferent;
    data_ptr fa, ta, fVal, currAtt;
    mbchar *fromName, *toName;
    
        /* "to" is expected to be in this format:
           <DBDEXfontAttr/labelFont><DTYPE_FONT_ATTR><attVal>
           where <attVal> :: <<FONT_FACE><DTYPE_STR><facename>>
                             <<FONT_SIZE><DTYPE_INT><size>>, ..
           in the order face, size, weight, slant
         */
    
    if (AxIsString(from)) {
            /* from is string-datum form and to isn't;
               consider this as totally different */
        *different = TRUE;
        return (to);
    }
    
    currAtt = AxArrayElement(to, 2);
    if (!AxIsArray(currAtt)) {
        *different = TRUE;    /* already intersected down to nothing */
        return (to);
    }

    defaultFrom = FALSE;
    fromsize = AxArraySize(from);
    if (!fromsize) {
        mbchar *family;
        int size, weight, slant;
        data_ptr dtmp;

            /* dummy up the default attr as if it arrived explicitly */
        defaultFrom = TRUE;
        deNamedFontDefaults(&family, &size, &weight, &slant);
        from = AxMakeArray(4);
        
        dtmp = AxMakeArray(2);
        dtmp = AxAddIntToArray(dtmp, 0, FONT_FAMILY);
        dtmp = AxAddStrToArray(dtmp, 1, family);
        from = AxAddArrayToArray(from, 0, dtmp);
                                 
        dtmp = AxMakeArray(2);
        dtmp = AxAddIntToArray(dtmp, 0, FONT_SIZE);
        dtmp = AxAddIntToArray(dtmp, 1, size);
        from = AxAddArrayToArray(from, 1, dtmp);
        
        dtmp = AxMakeArray(2);
        dtmp = AxAddIntToArray(dtmp, 0, FONT_WEIGHT);
        dtmp = AxAddIntToArray(dtmp, 1, weight);
        from = AxAddArrayToArray(from, 2, dtmp);
        
        dtmp = AxMakeArray(2);
        dtmp = AxAddIntToArray(dtmp, 0, FONT_SLANT);
        dtmp = AxAddIntToArray(dtmp, 1, slant);
        from = AxAddArrayToArray(from, 3, dtmp);
        fromsize = 4;
    }

    faceDifferent = sizeDifferent =
        weightDifferent = slantDifferent = FALSE;
    
        /* to is attr-list form */
    for (fx = 0; fx < fromsize; fx++) {
        fa = AxArrayElement(from, fx);   /* format: <att type><att val> */
        fatt = AxIntFromArray(fa, 0);
        fVal = AxArrayElement(fa, 1);
        switch(fatt) {
        case FONT_FAMILY:
            currAtt = AxArrayElement(to, 2);
            ta = AxArrayElement(currAtt, 0);
            if (AxIsArray(ta)) {
                if (AxIntFromArray(ta, 1) == DTYPE_STR) {
                    toName = AxStrFromArray(ta, 2);
                    fromName = AxStrPtrFromDataPtr(fVal);
                    if (strcmp(fromName, toName)) {
                        faceDifferent = TRUE;
                        ta = AxAddIntToArray(ta, 1, DTYPE_NONE);
                        currAtt = AxAddArrayToArray(currAtt, 0,
                                                    ElfDataCopy(ta));
                        to = AxAddArrayToArray(to, 2, ElfDataCopy(currAtt));
                    }
                }
            }
            else {
                faceDifferent = TRUE;     /* faces already different */
            }
            break;
        case FONT_SIZE:
            currAtt = AxArrayElement(to, 2);
            ta = AxArrayElement(currAtt, 1);
            if (AxIsArray(ta)) {
                if (AxIntFromArray(ta, 1) == DTYPE_INT) {
                    toInt = AxIntFromArray(ta, 2);
                    fromInt = AxIntFromDataPtr(fVal);
                    if (toInt != fromInt) {
                        sizeDifferent = TRUE;
                        ta = AxAddIntToArray(ta, 1, DTYPE_NONE);
                        currAtt = AxAddArrayToArray(currAtt, 1,
                                                    ElfDataCopy(ta));
                        to = AxAddArrayToArray(to, 2, ElfDataCopy(currAtt));
                    }
                }
            }
            else {
                sizeDifferent = TRUE;
            }
            break;
        case FONT_WEIGHT:
            currAtt = AxArrayElement(to, 2);
            ta = AxArrayElement(currAtt, 2);
            if (AxIsArray(ta)) {
                if (AxIntFromArray(ta, 1) == DTYPE_INT) {
                    toInt = AxIntFromArray(ta, 2);
                    fromInt = AxIntFromDataPtr(fVal);
                    if (toInt != fromInt) {
                        weightDifferent = TRUE;
                        ta = AxAddIntToArray(ta, 1, DTYPE_NONE);
                        currAtt = AxAddArrayToArray(currAtt, 2,
                                                    ElfDataCopy(ta));
                        to = AxAddArrayToArray(to, 2, ElfDataCopy(currAtt));
                    }
                }
            }
            else {
                weightDifferent = TRUE;
            }
            break;
        case FONT_SLANT:
            currAtt = AxArrayElement(to, 2);
            ta = AxArrayElement(currAtt, 3);
            if (AxIsArray(ta)) {
                if (AxIntFromArray(ta, 1) == DTYPE_INT) {
                    toInt = AxIntFromArray(ta, 2);
                    fromInt = AxIntFromDataPtr(fVal);
                    if (toInt != fromInt) {
                        slantDifferent = TRUE;
                        ta = AxAddIntToArray(ta, 1, DTYPE_NONE);
                        currAtt = AxAddArrayToArray(currAtt, 3,
                                                    ElfDataCopy(ta));
                        to = AxAddArrayToArray(to, 2, ElfDataCopy(currAtt));
                    }
                }
            }
            else {
                slantDifferent = TRUE;
            }
            break;
        }
    }
    *different = faceDifferent && sizeDifferent &&
            weightDifferent && slantDifferent;
    if (defaultFrom) {
            /* from was null on the way in, and was locally created */
        AxFreeData(from);
    }
    return (to);
}

static void
deNamedFontDefaults(family, size, weight, slant)
mbchar **family;
int *size;
int *weight;
int *slant;
{
        /* this is not quite the same as elwincom.c:namedFontDefaults */
    *family = NXLT("(Default)");
    *size = 14;
    *weight = 1;
    *slant = 0;
}

/*
 * : deCompleteFontAttr - fold the possibly sparse inAtt with
 * the widget's current font attr description (DBDEXfontAttr/labelFont
 * members of w->auxData->gadget elf array) and return a font attr
 * description at least as complete as the current
 */
static data_ptr
deCompleteFontAttr(w, att_index, inAtt, isString)
AXWidget w;
int att_index;
data_ptr inAtt;
int *isString;       /* out: bool */
{
    int currSize, inSize, ix;
    data_ptr currAtt, outAtt, atmp;
    mbchar *family;
    int size, weight, slant;

    *isString = FALSE;
    if (!inAtt) {
        return ((data_ptr) NULL);
    }
    if (AxIsString(inAtt)) {
            /* xlfd name arriving as string datum */
        *isString = TRUE;
        return (ElfDataCopy(inAtt));
    }
        /* the attribute data is array-style */
    if (!w || !w->auxData || !w->auxData->gadget) {
        return (ElfDataCopy(inAtt));
    }
    if (!AxIsArray(w->auxData->gadget)) {
        return (ElfDataCopy(inAtt));
    }
    currAtt = AxArrayElement(w->auxData->gadget, att_index);
    if (!AxIsArray(currAtt)) {
        return (ElfDataCopy(inAtt));
    }
        /* both currAtt and inAtt are expected to be arrays of form:
           <<att type><att val>><att2 type><att2 val>>, ... */
    currSize = AxArraySize(currAtt);
    inSize = AxArraySize(inAtt);
    outAtt = AxMakeArray(4);  /* only four font attrs in use currently */
    deNamedFontDefaults(&family, &size, &weight, &slant);

        /* override defaults with current vals */
    for (ix = 0; ix < currSize; ix++) {
        atmp = AxArrayElement(currAtt, ix);
        if (AxIsArray(atmp)) {
            switch(AxIntFromArray(atmp, 0)) {
            case FONT_FAMILY:
                family = AxStrPtrFromArray(atmp, 1);
                break;
            case FONT_SIZE:
                size = AxIntFromArray(atmp, 1);
                break;
            case FONT_WEIGHT:
                weight = AxIntFromArray(atmp, 1);
                break;
            case FONT_SLANT:
                slant = AxIntFromArray(atmp, 1);
                break;
            }
        }
    }
        /* next override with passed-in vals */
    for (ix = 0; ix < inSize; ix++) {
        atmp = AxArrayElement(inAtt, ix);
        if (AxIsArray(atmp)) {
            switch(AxIntFromArray(atmp, 0)) {
            case FONT_FAMILY:
                family = AxStrPtrFromArray(atmp, 1);
                break;
            case FONT_SIZE:
                size = AxIntFromArray(atmp, 1);
                break;
            case FONT_WEIGHT:
                weight = AxIntFromArray(atmp, 1);
                break;
            case FONT_SLANT:
                slant = AxIntFromArray(atmp, 1);
                break;
            }
        }
    }
        /* copy att info onto outAtt */
    atmp = AxMakeArray(2);
    AxAddIntToArray(atmp, 0, FONT_FAMILY);
    AxAddStrToArray(atmp, 1, family);
    AxAddArrayToArray(outAtt, 0, ElfDataCopy(atmp));
    atmp = AxMakeArray(2);
    AxAddIntToArray(atmp, 0, FONT_SIZE);
    AxAddIntToArray(atmp, 1, size);
    AxAddArrayToArray(outAtt, 1, ElfDataCopy(atmp));
    atmp = AxMakeArray(2);
    AxAddIntToArray(atmp, 0, FONT_WEIGHT);
    AxAddIntToArray(atmp, 1, weight);
    AxAddArrayToArray(outAtt, 2, ElfDataCopy(atmp));
    atmp = AxMakeArray(2);
    AxAddIntToArray(atmp, 0, FONT_SLANT);
    AxAddIntToArray(atmp, 1, slant);
    AxAddArrayToArray(outAtt, 3, atmp);
    return (outAtt);
}

/* 
 * the elf interpreter can do this real easily i bet..
 * compare two data_ptrs' contents, return whether equal
 */
#define EINT      1
#define EFLOAT    2
#define EARRAY    3
#define ESTRING   4
int
AXequalData(d1, d2)
data_ptr d1, d2;    /* in */
{
    register int d1type;
    
    if (!d1 && !d2) {
        return TRUE;
    }
    d1type = eDataType(d1);
    if (d1type != eDataType(d2)) {
        return FALSE;
    }
    if (d1type == EARRAY) {
        if (eDataType(d2) == EARRAY) {
            return (equalEarrays(d1, d2));
        }
        else {
            return FALSE;
        }
    }
    switch(d1type) {
    case EINT:
        return (AxIntFromDataPtr(d1) == AxIntFromDataPtr(d2));
        break;
    case ESTRING:
        return (!MBstrcmp(AxStrPtrFromDataPtr(d1),
                          AxStrPtrFromDataPtr(d2)));
        break;
    case EFLOAT:
        return (AxFloatFromDataPtr(d1) == AxFloatFromDataPtr(d2));
        break;
    }
}

static int
equalEarrays(a1, a2)
data_ptr a1, a2;    /* in */
{
    register int ix, a1size, a2size, type1, type2;
    register data_ptr e1, e2;
    if (!a1 && !a2) {
        return TRUE;
    }
    a1size = AxArraySize(a1);
    a2size = AxArraySize(a2);
    if (a1size != a2size) {
        return FALSE;
    }
    for (ix = 0; ix < a1size; ix++) {
        type1 = eDataType(e1 = AxArrayElement(a1, ix));
        type2 = eDataType(e2 = AxArrayElement(a2, ix));
        if (type1 != type2) {
            return FALSE;
        }
        else if (!AXequalData(e1, e2)) {
            return FALSE;
        }
    }
    return (TRUE);
}
static int
equalDtype(d1, d2)
data_ptr d1, d2;   /* in */
{
    return (eDataType(d1) == eDataType(d2));
}

static int
eDataType(d)
data_ptr d;         /* in */
{
    if (!d)
        return (EARRAY);
    if (AxIsArray(d))
        return (EARRAY);
    else if (AxIsInt(d))
        return (EINT);
    else if (AxIsString(d))
        return (ESTRING);
    else if (AxIsFloat(d))
        return (EFLOAT);
}

/* : deCompositeSetValues - AxXtSetValues wrapper
 * which applies the same arglist to w and its
 * composite kids if any
 */
static void
deCompositeSetValues(w, args, count)
AXWidget w;
Arg *args;
int count;
{
    wComposite *cp;

    AxXtSetValues(w, args, count);
    if (w->auxData) {
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->type == WLINKDOWN) {
                AxXtSetValues(cp->w, args, count);
            }
        }
    }
}

/* : deSetTextValues - deCompositeSetValues variant
 * which applies one of DBDEXfontAttr, DBDEXtextShadow,
 * DBDEXtextColor.
 */
static void
deSetTextValues(w, args, count)
AXWidget w;
Arg *args;
int count;
{
    wComposite *cp;
    
    switch (w->type) {
        
    case W_RADIO:
            /* text attrs apply to the choices and not the label */
        if (w->auxData) {
            for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                if ((cp->type == WLINKDOWN) && (cp->w->type == W_TOGGLE)) {
                    AxXtSetValues(cp->w, args, count);
                }
            }
        }
        break;
        
    case W_OPTION:
            /* text attrs apply to the choices and not the label */
        if (w->auxData) {
            for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                if ((cp->type == WLINKDOWN) && (cp->w->type == W_BUTTON)) {
                    AxXtSetValues(cp->w, args, count);
                }
            }
        }
        break;
        
    case W_EDITBOX:
    case W_LIST:
    case W_ENTER:     /* (for W_ENTER, apply to field and not label) */
    case W_COMBO_BOX:
        AxXtSetValues(w, args, count);
        break;
        
    }
}

/* : deSetLabelValues - deCompositeSetValues variant
 * which applies one of DBDEXlabelAttr, DBDEXlabelShadow,
 * DBDEXlabelColor.
 */
static void
deSetLabelValues(w, args, count)
AXWidget w;
Arg *args;
int count;
{
    wComposite *cp;
    
    switch (w->type) {
        
    case W_ENTER:
    case W_RADIO:
            /* label attrs apply to the label only */
        if (w->auxData) {
            for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                if ((cp->type == WLINKDOWN) && (cp->w->type == W_LABEL)) {
                    AxXtSetValues(cp->w, args, count);
                    break;
                }
            }
        }
        break;
        
    case W_OPTION:
    case W_LABEL:
    case W_BUTTON:
    case W_TOGGLE:
        AxXtSetValues(w, args, count);
        break;
        
    }
}

static data_ptr
deReadClipboard(void)
{
    return (ElfDataCopy(DE.clipboard));
}

static void
deWriteClipboard(dlg, info)
AXWidget_dialog dlg;
data_ptr info;
{
    int currTask = THIMpid;
    if (DE.clipboard) {
        VfyContext(0);
        AxFreeData(DE.clipboard);
    }
    VfyContext(0);    /* clipboard memory should be task 0 */
    DE.clipboard = ElfDataCopy(AxArrayElement(info, 1));
    VfyContext(currTask);
}

/* : deReadSelectionDlg - report the dialog handle of the dbox
 * that has material currently selected; there should be 0 or 1
 */
static data_ptr
deReadSelectionDlg()
{
    AXWidget_dialog dlg;
    AXWidget_handle wh;
    data_ptr dlgHandle;
    
    if (!DE.selectedSetSize) {
        dlg = (AXWidget_dialog) NULL;
    }
    else {
            /* here we assume that the dlged's selection has been
               restricted to within one dialog; read the 0th selected
               widget to get its parent */
        dlg = (AXWidget_dialog)((AXWidget)DE.selectedSet[0])->parent;
    }
    wh = HANDLE_FROM_WIDGET(dlg);
    dlgHandle = AxMakeBinaryData(sizeof(wh), (char*)&wh);
    return (dlgHandle);
}

/* : deReadSelectedWtypes - return a list of the gadget types
 * present in the selected set.  return elf gadget types, in
 * format: <<gtype1><gtype2><gtype3>,...>
 */
static data_ptr
deReadSelectedWtypes()
{
    int *wIndexes, nTypes, ix, jx, thisType, found;
    data_ptr retList;
    
        /* build a list of the currently selected widget types */
    for(ix = 0, nTypes = 0, wIndexes = (int *) NULL;
        ix < DE.selectedSetSize; ix++) {
        thisType = (DE.selectedSet[ix])->type;
        if (!nTypes) {
            wIndexes = (int *) TaskAlloc(0, sizeof(int));
            wIndexes[0] = ix;
            nTypes++;
        }
        else {
            for (jx = 0, found = FALSE; jx < nTypes; jx++) {
                if (wIndexes[jx] == thisType) {
                    found = TRUE;
                    break;
                }
            }
            if (!found) {
                wIndexes = (int *) TaskRealloc
                    (0, wIndexes, (nTypes + 1) * sizeof(int));
                wIndexes[nTypes] = ix;
                nTypes++;
            }
        }
    }
    
        /* copy onto elf array for return, translate to elftypes */
    retList = AxMakeArray(nTypes);
    for (ix = 0; ix < nTypes; ix++) {
        retList = AxAddIntToArray(retList, ix,
                               deElfWidgetType(DE.selectedSet[wIndexes[ix]]));
    }
	TaskFree(0, wIndexes);
    return (retList);
}

static void
deIncrementName(tryName, firstTime)
mbchar **tryName;         /* in/out */
int    firstTime;         /* bool: first time trying a new name */
{
    int len, dotlen, extlen, number;
    mbchar *cp, scratch[32];

    if (firstTime) {
            /* stick a ".1" onto the end */
        len = MBstrlen(*tryName) + 3;
        *tryName = (mbchar *) TaskRealloc(0, *tryName, len);
        (*tryName)[len - 3] = '.';
        (*tryName)[len - 2] = '1';
        (*tryName)[len - 1] = '\0';
    }
    else {
            /* increment the number on the end */
        len = MBstrlen(*tryName);
        cp = &(*tryName)[len - 1];
        while(*cp != '.' && (len > 0)) {
            cp--;
            len--;
        }
        cp++;              /* just to the right of the '.' */
        dotlen = len;      /* #chars from start to dot, including dot */
        if (sscanf((char *) cp, "%d", &number) == EOF) {
            return;
        }
        number++;
        sprintf((char *) scratch, "%d", number);
        extlen = MBstrlen(scratch);
        len = dotlen + extlen;
        *tryName = (mbchar *) TaskRealloc(0, *tryName, len);
        strcpy((char *) &(*tryName)[dotlen], scratch);
    }
}

void
deInitColorTable()
{
    if (!DE.colorFiles.width) {
        axhInitTable(&DE.colorFiles, 32, deNewColorFile, deTossColorFile);
    }
    if (!DE.colorTable.width) {
        axhInitTable(&DE.colorTable, 256, deNewColor, deTossColor);
    }
}

static int
needsParticularDialog(editType)
int editType;
{
    switch (editType) {
    case DE_ADD_COLORS:
    case DE_DELETE_COLORS:
    case DE_INCLUDE_DLG_COLORS:
    case DE_CLEAR_COLORSET:
    case DE_SEND_UPDATE_POKE:
    case DE_FLUSH_UPDATE_POKES:
    case DE_DEFER_UPDATE_POKES:
        return FALSE;
    default:
        return TRUE;
    }
}

/* : deRemoveFromSession - remove from the global DE any
 * references to this to-be-destroyed widget.  This func
 * is called from AxXtDestroyWidget
 */
void
deRemoveFromSession(w)
AXWidget w;
{
    removeFromSelset(w);    /* in case currently selected */
    
    if (w == DE.newWidget.wWidget) {
            /* this widget was in the process of being created;
             * null the reference held on DE
             */
        DE.newWidget.wWidget = (AXWidget) NULL;
        
            /* free its gadget info, too
             */
        if (DE.newWidget.wInfo) {
            int me = THIMpid;
            VfyContext((int) w->parent->taskOwner);
            AxFreeData(DE.newWidget.wInfo);
            DE.newWidget.wInfo = (data_ptr) NULL;
            VfyContext(me);
        }
        
            /* reset the rest of DE stuff pertaining to this widget
             */
        DE.newWidget.doCreate = FALSE;
        DE.stretching = FALSE;
        DE.dragWidget = (AXWidget) NULL;
    }
    
    if (DE.numDeferredSelected) {
        int ix;
        for (ix = 0; ix < DE.numDeferredSelected; ix++) {
            if (DE.deferredSelection &&
                w == DE.deferredSelection[ix]) {
                
                DE.deferredSelection[ix] = (AXWidget) NULL;
            }
        }
    }
}

static mbchar *             /* family name if found; caller must not free */
deFontFamilyFromAttr(fatt)
data_ptr fatt;
{
    int asize, ix;
    data_ptr dtmp;
    
    if (!fatt || !AxIsArray(fatt)) {
        return ((mbchar *) NULL);
    }
    asize = AxArraySize(fatt);
    for (ix = 0; ix < asize; ix++) {
        dtmp = AxArrayElement(fatt, ix);
        if (AxIntFromArray(dtmp, 0)) {
            return (AxStrPtrFromArray(dtmp, 1));
        }
    }
    return ((mbchar *) NULL);
}

/* : deCheckTablayerContainment - find the nearest enclosing
 * RECT_LAYERED-style W_RECT widget which contains the passed
 * widget.  Compare with any existing uplinks to tabctl rects.
 * Nonnull return is the handle of a new tabctl rect to link to.
 */
static AXWidget_rect
deCheckTablayerContainment(w, break_existing_links)
AXWidget w;
int *break_existing_links;  /* out; bool */
{
    wLayer *ly, *myLayer;
    r32 myRect, trect;
    AXWidget_rect rw, smallestRect;
    int smallestArea, itmp;
    
    *break_existing_links = FALSE;
    if (!w || !w->parent || (w->type == W_DIALOG) || !w->parent->layerList) {
        return ((AXWidget_rect) NULL);
    }
    
    w = topWidget(w);
    if (!w) {
        return ((AXWidget_rect) NULL);
    }

    /* first, check whether I'm currently linked
     * to a tabcontrol which currently contains me.
     * If I'm hidden inside such a tabctl, then stay put.
     * If on the other hand, I'm visible, I should keep looking.
     */
    if (rw = deGetLinkedTabctl(w)) {
        myRect.origin.x = w->xpos;
        myRect.origin.y = w->ypos;
        myRect.width = w->width;
        myRect.height = w->height;
        trect.origin.x = rw->xpos;
        trect.origin.y = rw->ypos;
        trect.width = rw->width;
        trect.height = rw->height;
        if (rectInsideRectInclusive(&myRect, &trect)) {
            if (xmWidgetIsHidden(w)) {
                return ((AXWidget_rect) NULL);     /* current link is ok */
            }
        }
    }
    
    /* find myself on the layerlist
     */
    myLayer = (wLayer *) NULL;
    for (ly = w->parent->layerList; ly; ly = ly->next) {
        if (ly->w == w) {
            myLayer = ly;
            break;
        }
    }
    if (!myLayer) {
        return ((AXWidget_rect) NULL);
    }
    
    /* now search backward for the smallest enclosing panel
     */
    myRect.origin.x = myLayer->w->xpos;
    myRect.origin.y = myLayer->w->ypos;
    myRect.width = myLayer->w->width;
    myRect.height = myLayer->w->height;
    smallestArea = INT_MAX;
    smallestRect = (AXWidget_rect) NULL;
    for (ly = myLayer; ly; ly = ly->prev) {
        if ((ly != myLayer) &&
            (W_RECT == ly->w->type) &&
            (RECT_LAYERED == ly->w->style) && !xmWidgetIsHidden(ly->w)) {

            trect.origin.x = ly->w->xpos;
            trect.origin.y = ly->w->ypos;
            trect.width = ly->w->width;
            trect.height = ly->w->height;
            if (rectInsideRectInclusive(&myRect, &trect)) {
                /* passed widget is contained inside this
                 * tabctl panel.
                 */
                if ((itmp = (trect.width * trect.height)) < smallestArea) {
                    smallestArea = itmp;
                    smallestRect = (AXWidget_rect) ly->w;
                }
            }
        }
    }
    
    if (smallestRect) {
        /* See whether passed widget is
         * already linked to this panel.
         */
        rw = deGetLinkedTabctl(w);
        if (rw && (rw == smallestRect)) {
            /* already linked to this rect, nothing needs to change.
             */
            return ((AXWidget_rect) NULL);
        }
        else {
            *break_existing_links = TRUE;
            /* need to get linked to this rect
             */
            return (smallestRect);
        }
    }

    /* we're currently not contained in any tabctl panel
     */
    rw = deGetLinkedTabctl(w);
    if (rw) {
        *break_existing_links = TRUE;
    }

    return ((AXWidget_rect) NULL);
}

/* : deGetLinkedTabctl - return handle of 1st tab-control
 * style W_RECT to which the passed widget is linked, if any.
 */
static AXWidget_rect
deGetLinkedTabctl(w)
AXWidget w;
{
    int ix;
    hitem *list;
    widglink *wl;

    if (!(w && w->tabctl_linktab)) {
        return ((AXWidget_rect) NULL);
    }
    for (ix = 0; ix < w->tabctl_linktab->width; ix++) {
        list = w->tabctl_linktab->table[ix];
        while (list) {
            wl = (widglink *) list->value;
            if (!wl->direction) {
                /* this is an uplink, (which would be to a tabctl panel)
                 */
                return ((AXWidget_rect) wl->to);
            }
            list = list->next;
        }
    }

    return ((AXWidget_rect) NULL);
}

static data_ptr
deMakeTablinkMessage(widg, rw)
AXWidget widg;                   /* in: subject widget */
AXWidget_rect rw;                /* in: rect to link to, or NULL for none */
{
    AXWidget_handle w_handle;
    data_ptr msg, attval;
            
    msg = AxMakeArray(3);
    w_handle = HANDLE_FROM_WIDGET(widg);
    msg = WriteArray(msg, 0,
                     AxMakeBinaryData(sizeof(w_handle), (char*)&w_handle));
    msg = AxAddIntToArray(msg, 1, 1);  /* as in 1 att-val pair */
    
    attval = AxMakeArray(2);
    attval = AxAddIntToArray(attval, 0, DBDEXmake_tablayer_link);
    w_handle = HANDLE_FROM_WIDGET(rw);
    attval = WriteArray(attval, 1,
                        AxMakeBinaryData(sizeof(w_handle), (char*)&w_handle));
    
    msg = AxAddArrayToArray(msg, 2, attval);
    
    return (msg);
}

static data_ptr
deSendMakeTablinks(widg)
AXWidget widg;       /* in: subject widget */
{
    int break_links;
    AXWidget_rect rw;
    data_ptr msg;

    msg = (data_ptr) 0;
    rw = deCheckTablayerContainment(widg, &break_links);
    if (rw || break_links) {
        msg = deMakeTablinkMessage(widg, rw);
    }
    return (msg);
}

static void
deRectSendMakeTablinks(dlg, mh)
AXWidget_dialog dlg;    /* in */
de_message_holder *mh;  /* in/out: append any additional message info here */
{
    AXWidget_rect rw;
    AXWidget kidP;
    int itmp, break_links;
    
    /* start by counting all kids; mh->lists will grow by this amount!
     */
    for (itmp = 0, kidP = dlg->widgets; kidP; kidP = kidP->nextChild) {
        itmp++;
    }
    mh->lists = (data_ptr *) TaskRealloc(0, mh->lists,
                                         (mh->num_lists + itmp) *
                                         sizeof(de_message_holder));

    /* redo, this time testing each kid for possible tablink change
     */
    for (kidP = dlg->widgets; kidP; kidP = kidP->nextChild) {
        rw = deCheckTablayerContainment(kidP, &break_links);
        if (rw || break_links) {
            mh->lists[mh->num_lists] = deMakeTablinkMessage(kidP, rw);
            mh->num_lists++;
            if (break_links && DE.prefs.ghost) {
                /* kidP may currently be ghosted, need to force repaint
                 */
                kidP->update_widget = WidgetNeedsUpdated = TRUE;
            }
        }
    }
}

static void
deRectSendMoveContainees(rw)
AXWidget_rect rw;            /* in */
{
    int ix;
    hitem *list;
    widglink *wl;

    if (!(rw && rw->tabctl_linktab)) {
        return;
    }
    for (ix = 0; ix < rw->tabctl_linktab->width; ix++) {
        list = rw->tabctl_linktab->table[ix];
        while (list) {
            wl = (widglink *) list->value;
            if (wl->direction) {
                /* this is a downlink, (which would be to a containee)
                 */
                deSendUpdate((AXWidget)rw->parent->parent, &wl->to,
                             1, wMove, (data_ptr)0);
            }
            list = list->next;
        }
    }
    return;
}


/* : deDeselectTabctlHidden - shut off selectedness for any
 * widgets in tabcontrol layers now hidden.  Kinda rude,
 * but simplifies the de's ui in this area.
 */
static void
deDeselectTabctlHidden(void)
{
    int ix, selset_changed;
    
    for (selset_changed = FALSE, ix = 0; ix < DE.selectedSetSize; ix++) {
        if (xmWidgetIsHidden(DE.selectedSet[ix])) {
            liftMark(DE.selectedSet[ix]);
            selset_changed = TRUE;
        }
    }
    if (selset_changed) {
        deSendUpdatePoke(DE_SELSET_CHANGED, DE.deferUpdatePokes);
    }
    return;
}

static int
deDifferentTablayerNames(rw, layerNames)
AXWidget_rect rw;      /* in */
data_ptr layerNames;   /* in: new layer names, not yet applied to rw */
{
    int num_new_names, lx;
    mbchar *tname;
    
    num_new_names = AxArraySize(layerNames);
    if (num_new_names != rw->tabctl.num_layers) {
        return (TRUE);    /* list of layers is changing */
    }
    for (lx = 0; lx < rw->tabctl.num_layers; lx++) {
        tname = AxStrFromArray(layerNames, lx);
        if (tname && rw->tabctl.layerlist[lx].layerName) {
            if (MBstrcmp(tname, rw->tabctl.layerlist[lx].layerName)) {
                return (TRUE);  /* new layer name is different at lx */
            }
        }
        else if (tname || rw->tabctl.layerlist[lx].layerName) {
            return (TRUE);      /* one is null and the other isn't */
        }
    }
    return (FALSE);
}

/* : deIsPositionEdit - return whether passed att-val list
 * describes an edit to a widget's position.
 */
static int
deIsPositionEdit(info)
data_ptr info;         /* in: att-val pairs describing edit to widget */
{
    int ix, att;
    int asize = AxArraySize(info) / 2;
    
    if (!info) {
        return FALSE;
    }
    
    for (ix = 0; ix < asize; ix += 2) {
        att = AxIntFromArray(info, ix);
        if ((DBDEXxpos == att) || (DBDEXypos == att)) {
            return (TRUE);  /* even tho pos may not actually be changing.. */
        }
    }
    return (FALSE);
}

/* : deEditAffectsTabctlLinkage - return whether passed att-val list
 * will possibly affect tabcontrol-containee linkage.
 */
static int
deEditAffectsTabctlLinkage(rw, edit, info)
AXWidget_rect rw;      /* in: widget being edited */
enum wEditType edit;
data_ptr info;         /* in: att-val pairs describing edit to widget */
{
    int ix, att, attval;
    int asize = AxArraySize(info) / 2;
    
    if ((wMove == edit) || (wResize == edit)) {
        return TRUE;
    }
    
    if (!info) {
        return FALSE;
    }
    
    /* first test whether DBDEXstyle is included,
     * and whether it describes a transition to/from layered style.
     */
    for (ix = 0; ix < asize; ix += 2) {
        att = AxIntFromArray(info, ix);
        if (DBDEXstyle == att) {
            attval = AxIntFromArray(info, ix + 1);
            if (RECT_LAYERED == rw->style) {
                if (RECT_LAYERED != attval) {
                    return TRUE;   /* changing from layered to non-layered */
                }
            }
            else if (RECT_LAYERED == attval) {
                return TRUE;       /* changing from non-layered to layered */
            }
        }
    }
    if (RECT_LAYERED == rw->style) {
        for (ix = 0; ix < asize; ix += 2) {
            att = AxIntFromArray(info, ix);
            if ((DBDEXxpos == att) || (DBDEXypos == att) ||
                (DBDEXwidth == att) || (DBDEXheight == att)) {
                
                return (TRUE);
            }
        }
    }
    return (FALSE);
}

static char *
deNewWidgetUpdater(notUsed, notUsed2, notUsed3)
void *notUsed;
int notUsed2;
void *notUsed3;
{
    de_message_holder *mh;
    mh = (de_message_holder *) TrueMalloc(sizeof(de_message_holder));
    memset((void *) mh, 0, sizeof(de_message_holder));
    return ((char *) mh);
}

static void
deFreeWidgetUpdater(message_holder, notUsed)
void *message_holder;
int notUsed;
{
    de_message_holder *mh = (de_message_holder *) message_holder;
    if (mh) {
        if (mh->lists) {
            TrueFree(mh->lists);
        }
        TrueFree(mh);
    }
    return;
}

/* : deFlushWidgetUpdates - dump the contents of each dialog's slot
 * on DE.dialogs into a DE_UPDATE_WIDGET message and send it.
 */
static void
deFlushWidgetUpdates()
{
    int dx, ix, jx, num_widgets, me;
    axhtab *tab;
    hitem *list;
    data_ptr message;
    de_message_holder *mh;
    
    me = THIMpid;
    
    for (dx = 0; dx < DE.numDlgs; dx++) {
        if (DE.dialogs[dx].dlg && DE.dialogs[dx].dlg->parent &&
            DE.dialogs[dx].doUpdate) {

            DE.dialogs[dx].doUpdate = FALSE;
            
            VfyContext(DE.dialogs[dx].dlg->taskOwner);
            
            message = AxMakeArray(2);
            message = AxAddIntToArray(message, 0, DE_WIDGET_UPDATE);

            tab = &DE.dialogs[dx].widgetUpdates;
            for (num_widgets = 0, ix = 0; ix < tab->width; ix++) {
                list = tab->table[ix];
                while(list) {
                    if (list->value) {
                        mh = (de_message_holder *) list->value;
                        for (jx = 0; jx < mh->num_lists; jx++) {
                            message =
                                AxAddArrayToArray(message, num_widgets + 2,
                                                  mh->lists[jx]);
                            num_widgets++;
                        }
                        mh->num_lists = 0;
                        TaskFree(0, mh->lists);
                        mh->lists = (data_ptr *) NULL;
                    }
                    list = list->next;
                }
            }
            if (num_widgets) {
                message = AxAddIntToArray(message, 1, num_widgets);
                XmPoker(POKE_DE_MESSAGE, message,
                        DE.dialogs[dx].dlg->parent, TRUE, TRUE);
            }
            AxFreeData(message);
        }
    }
    
    VfyContext(me);
    
    return;
}

static void
deFreePixmap(ww)
AXWidget ww;      /* in */
{
    if (ww->window) {
        XFreePixmap(Dpy, ww->window);
        ww->window = 0;
    }
    if (W_COMBO_BOX == ww->type) {
        AXWidget_combo_box cb = (AXWidget_combo_box) ww;
        if (cb->edit_win.win) {
            XFreePixmap(Dpy, cb->edit_win.win);
            cb->edit_win.win = 0;
        }
    }
    if (W_ENTER == ww->type) {
        AXWidget_entry cb = (AXWidget_entry) ww;
        if (cb->edit_win.win) {
            XFreePixmap(Dpy, cb->edit_win.win);
            cb->edit_win.win = 0;
        }
    }
}

/* : deGhostMode - report whether dialog editor in ghost-move/resize mode.
 */
int
deGhostMode() {
	return (TRUE == DE.prefs.ghost);
}

#if AXMS     /*  {   */
/** Redraw any toolbar buttons which may be 'down', back into their 'up' */
/**    positions.                                                        */

void
AllToolbarButtonsUp(AXWidget_dialog dialog_w)
{
    AXWidget_main main_w;
    AXWidget_tool w_toolbar;
    int ix;
    AXWidget childP;

    WIDGET_PARANOID( dialog_w, W_DIALOG );

    /* we need to redraw any tool bar buttons back up */
    main_w = dialog_w->parent;
    w_toolbar = main_w->toolBar;
    if ( w_toolbar != (AXWidget_tool)NULL )
       {
       for ( ix = 0; ix < MAX_TOOLBAR_ITEMS; ix++ )
          {
          childP = w_toolbar->toolBarInfo->widgets[ix];
          if ( !childP )
              break;       /* all done */
          if ( childP->type != W_BUTTON )
              continue;
          if ( childP->value != 0 )
              {
              /* button was down, make it up */
              childP->value = 0;
              childP->update_widget = TRUE;
              PaintButton( (AXWidget_pushbutton)childP, 0,0, FALSE );
              childP->update_widget = FALSE;
              }
           }
        }
}
#endif    /*   }  AXMS  */

/* deGetAccelerator - sub used by deFoldAccelerators
 */
static mbchar *       /* single accelerator char as string; allocated within */
deGetAccelerator(ww, target)
AXWidget ww;
mbchar *target;
{
	int ix;
	wComposite *cp;
	mbchar *accel = (mbchar *) NULL;

	if (ww && target) {
		switch (ww->type) {
		case W_RADIO:
			for (cp = ww->auxData->compositeList; cp; cp = cp->next) {
				if (cp->type == WLINKDOWN && W_TOGGLE == cp->w->type) {
					if (cp->w && !MBstrcmp(cp->w->name, target)) {
						accel = malloc(2);
						accel[0] = (mbchar) cp->w->accelerator_key;
						accel[1] = 0;
						break;
					}
				}
			}
			break;
		case W_RECT:
			if (RECT_LAYERED == ww->style) {
				AXWidget_rect rw = (AXWidget_rect) ww;
				if (rw->tabctl.num_layers > 0) {
					for (ix = 0; ix < rw->tabctl.num_layers; ix++) {
						if (!MBstrcmp(rw->tabctl.layerlist[ix].layerName,
									  target)) {
							accel = malloc(2);
							accel[0] = (mbchar)
								rw->tabctl.layerlist[ix].accelerator_key;
							accel[1] = 0;
							break;
						}
					}
				}
			}
			break;
		}
	}
	return accel;
}


/* : deFoldAccelerators - possibly redo the W_RADIO/W_RECT(tabcontrol)
 * accelerator-keys array in response to the arrival of new strings
 * representing the accelerator targets.  For W_RADIO, these new strings
 * represent the individual toggles of the radio widget; for tabcontrol-
 * style W_RECT, these strings are the individual layer names.
 * 
 * The idea is to try to preserve existing accelerator-key assignments
 * whenever the set of toggles/tablayers changes size, e.g.
 *
 * (radio and tabcontrol are distinct from the other widget types in
 *  that they have an array of accelerator keys rather than a single
 *  accelerator; all other types have a one-to-one relation of ELF-widget
 *  to accelerator-key)
 */
static data_ptr                   /* return new accelerator keys array */
deFoldAccelerators(ww, newstrsP)
AXWidget ww;
data_ptr newstrsP;   /* the array of new toggle/tablayer names */
{
	int ix, asize;
	data_ptr accels;
	mbchar *accelstr;
	
	if (!newstrsP || !AxIsArray(newstrsP)) {
		return ((data_ptr) NULL);
	}
	asize = AxArraySize(newstrsP);
	accels = AxMakeArray(asize);
	for (ix = 0; ix < asize; ix++) {
		accelstr = deGetAccelerator(ww, AxStrFromArray(newstrsP, ix));
		if (NULL != accelstr) {
			AxAddStrToArray(accels, ix, accelstr);
			free(accelstr);
		}
		else {
			AxAddStrToArray(accels, ix, "");
		}
	}
	return accels;
}

