/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmlib.c
   Applix ASC version: 620
   Date: Wed May 26 21:36:47 1999
*/
#define TM_MAXWIN 21    /* copied atmwin.h!! */

#if (ALPHA || AVIION || HP800V3)
#define XLIB_ILLEGAL_ACCESS 1 /* in order to access display structure */
#endif

#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <math.h>
#include <setjmp.h>
#include <errno.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/param.h> /* for MAXHOSTNAMELEN */
#if SUN4S || USL54 || SUNIS || NEC_EWS
#include <netdb.h>  /* for MAXHOSTNAMELEN */
#endif
#if RIOS
#include <sys/select.h>
#endif


#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <ax_xm.h>
#if AUX
#include <X11/fd.h>
#endif

#if 0
#include <bitmaps.h>     /* standard patterns */
#endif

#include <dwt2xm.h>
#include <aos.h>
#include <thimble.h>
#include <scac.h>
#include <getstr4.h>
#include <getstr5.h>
#include <getstr7.h>
#include <aiconids.h>
#include <adlgpoke.h>
#include <xmcanvas.h>
#include <xmtable.h>
#include <xmtray.h>
#include <xmchoose.h>
#include <atmproto.h>


#include <xmlib.h>        /* contains widget_t def, OpenLook defs */
#include <elxwins.h>
#include <xmpixel.h>

#include <xmdlged.h>
#include <cursors.h>
#include <eldata.h>
#include <axdnd.h>
#include <xim.h>
#include <wchars.h>
#include <ximcomm.h>
#include <evreason.h>
#include <java_syms.h>
#include <aos_xfer.h>
#include <infobox.h>
#include <editmask.h>

#if USE_XIM
#include <locale.h>
#endif

#if BUILD_KANJI && HP800V3
#include <sys/utsname.h>
#endif

#define LESS_MENU_PAINT 1   /* Make always TRUE one debug is done! */

#define USE_CHECKS_FOR_TOGGLES 1
#define PALETTE_WIDTH 101
#define PALETTE_USED 360
#define COLORPAL_HEIGHT 23
#define RIBB_SZ  15
#define RIBB_OFF 0
#define RIBB_OP_SZ 85
#define GE_YRULER_WIDTH 32
#define GE_XRULER_HEIGHT 32
#define DEBUG_THICK 180
#define MSG_WIDTH 400
#define GE_MSG_WIDTH 225
#define GE_PAGE_WIDTH 136
#define SCROLLBAR_THICK 16
#define HELP_STR XLT("Help")

#define THREE_STATE_TOGGLE 3 /* Note must be > XmHORIZONTAL !! */

extern int  errno;
extern int  JavaMode;
#if !LINUX
extern char *sys_errlist[];
#endif
extern int AxButtonDown; /* which mouse button down, 0==>none (for widgets) */
extern XSetWindowAttributes WinAtt;
Pixmap colorpalMap;
AXWidget AXmCreateOptionMenu();
AXWidget_scroll AXmCreateScrollBar();
char *WidgetTypeToStr();
AXWidget WidgetOfWindow();
AXWidget topWidget();
AXWidget AXmCreatePushButtonGadget();
AXWidget AXmCreatePulldownMenu();
XFontStruct *AXLoadQueryFont(), *xmWidgetFontStruct();
int TaskOfWidgetPended();

/* used by Fixparents() in RWMap.c as flag to XmClipText(): implies use 
 * of MiniLabelTxfont for OpenLook label width calculations */
#define DCRULER_LABEL_FONT  3

extern data_ptr AxTaskCopyElfData();
extern data_ptr AxCopyData();
menu_item_def *ElfLookupSlider();

extern unsigned short CurrentMods;    /* current modifier mask */
extern int AxElfrtMode;
extern Window AxTopWinNeverMapped;  /* created by AxGetDpyAndGCs */
extern int AxBigFont;   /* obsolete */
extern int AxAlternateDialogFont;
extern int ToolbarButtonSep;    /* nominally 2 */
extern int ToolbarExtraSep; /* nominally 25 */
extern int AxFontShift; /* Hack to force all fonts selects up in size */
extern int ElfLanguage;
extern char *ThimApplixDir;    /* Where the THIMBLE executable lies */
extern char *ThimCustomDir;    /* Where customizeable files are kept */
extern int AxProgramSpecifiedWindowPos; /* affects WMHints */
extern int AxSuppressBackingStore;
extern int AxUseGrayScale;  /* to display color images as grayscale */

#if QATOOL
extern void QaRegisterWindow();
extern void QaUnregisterWindow();
extern int QaCaptureMode();
extern int QaPlaybackMode();
extern void QaCaptureEvent();
extern int QaNextEvent();
#endif

void AxXtDestroyWidget();

int QaWidgetStyle = 0;



extern char *IconSizeStr;
Window ThimFocusWindow; /* The window that had the last FocusIn event */
/* AXFocusWindow is the thim window that now has focus; it is either 0,
 * or equal to ThimFocusWindow.
 */
Window AXFocusWindow = 0;
int WindowBorder = 1;   /* pixel thickness of work window border */
extern int DoubleMillisec;
extern int DoublePixSpan;
extern int AxMarkMenuMnemonics; /* if TRUE: underline menu key mnemonics */
extern int AxHideDisabledTools; /* TRUE==> undisplay disabled toolbar buttons */
#ifdef PMAX
int DECKeyboardMode = TRUE;
#else
int DECKeyboardMode = FALSE;
#endif


extern int Thim2dMode;
extern PIXEL_VALUE AlisPixels[];
extern int AxLoadWidgetColors, AxLoadApplicationColors;
extern int AxNColorLevels, AxNColors;
GC AxColorGC;       /* For colormap64 based references */
extern int AxNewMailMenuIcon;/* If TRUE,display "new-mail" rather than asterix */


struct XMlibStr {
  PIXEL_VALUE FGpixel;    /* foreground color for app work areas */
  PIXEL_VALUE BGpixel;    /* backround color for app work areas */
  int FullRegenForUpdate;  /* Set by UnMapWidget,
                  hint for WidgetNeedsUpdated */
};

extern struct XMlibStr xmlibStr;

/* global AxExpose is used for accumulating contiguous expose event info
 */
struct ax_expose {
  AXWidget wp;
  Window win;
  r32 rect;
};
static struct ax_expose AxExpose;

static int FontCacheSize = 0;

/* Dialog box key bindings */
static menu_item_def *AxDialogKeyBindings = NULL;

#if SUPPORT_HP_VUE
static jmp_buf AxPendBreaker;
static XtWorkProcId CurrentPendBreaker = NULL;
#endif

extern PIXEL_VALUE ForePixel;   /* foreground for control panels */
extern PIXEL_VALUE BackPixel;   /* backround for control panels */
extern PIXEL_VALUE SunPixel, ShadowPixel;
extern PIXEL_VALUE ForeWorkPixel, BackWorkPixel;  /* for alt widget colors */
extern PIXEL_VALUE SunWorkPixel, ShadowWorkPixel, RecessWorkPixel;
extern Colormap WorkColormap;
int GotWorkColorCells = FALSE;
extern int GotWorkAuxColorCells;

extern GC ForeGC;   /* label text (nominally black) */
extern GC GXForeGC; /* same as ForeGC, but with graphics_exposures=TRUE */
extern GC DisabledGC;       /* "grayed" text (e.g. menu bar inactive) */
extern GC BackGC;   /* "white" */
extern GC RecessGC;
extern GC ElfGC;    /* label text (nominally black) */

extern GC MonospaceBoldGC;
extern GC SmallFontGC;  /* smaller sans-serif system font, forground mode */
extern GC SunGC;            /* sunlit side */
extern GC ShadowGC; /* shaded side */

/* OpenLook stuff */
extern PIXEL_VALUE RecessPixel;
Pixmap axolDropShadow;
static unsigned char axolShadow[] = {
  0xff, 0xff, 0xaa, 0xaa, 0xff, 0xff, 0xaa, 0xaa,
  0xff, 0xff, 0xaa, 0xaa, 0xff, 0xff, 0xaa, 0xaa,
  0xff, 0xff, 0xaa, 0xaa, 0xff, 0xff, 0xaa, 0xaa,
  0xff, 0xff, 0xaa, 0xaa, 0xff, 0xff, 0xaa, 0xaa,
};


/* Used by `XSetClassHint()'. */
char *AxWmResNameStr  = NXLT("applix");
/* char *AxWmResClassStr = NXLT("Asterx"); */

extern XFontStruct *AxDlgMainFont;
extern XFontStruct *AxDlgMiniFont, *MonospaceFont, *MonospaceBoldFont;
extern XFontStruct *MonospaceItalFont, *MonospaceItalBoldFont;
extern XFontStruct *Grafont, *Txfont, *olCursorfont, *BoldTxfont;
extern XFontStruct *MiniTxfont, *MiniLabelTxfont, *MiniButtonFont;
extern XFontStruct *Curpixfontp;    /* for measuring text */

GC olButtonGC, olTextGC, olDisabledButtonGC, olDisabledTextGC;
GC olBoldTextGC, olDisabledBoldTextGC;
GC olHilitButtonGC, olHilitTextGC, olCursorGC;
GC olMiniTextGC, olMiniHilitTextGC, olMiniLabelTextGC;
GC olMiniDisabledTextGC, olMiniDisabledLabelTextGC, olMiniButtonGC;
GC olMiniHilitButtonGC;

extern unsigned long TimeOfButtonPress; /* event time of button down */
extern unsigned long TimeOfKeyPress; /* event time of key press */
extern unsigned long TimeOfButtonRelease;   /* event time of button up */

extern int UseWidgetColors;  /* OpenLook color */
extern short ColorDisplay;
KeySym AxControlKeyDown=0; /* which control key is down, 0 if none */
GC olClrSunButtonGC, olClrShadowButtonGC;
GC olClrForeButtonGC, olClrBackButtonGC, olClrRecessButtonGC;
GC olClrRecessPixGC, olClrInvertedRecessPixGC, olInvertedPixGC;
GC olClrSunMiniButtonGC, olClrShadowMiniButtonGC;
GC olClrForeMiniButtonGC, olClrBackMiniButtonGC, olClrRecessMiniButtonGC;
GC olBusyButtonGC;

GC olAsterixGC, olHilitAsterixGC;
XFontStruct *Asterixfont;
Atom axolDecorAdd, axolDecorDel, axolPinState;
Atom axolDecorResize, axolDecorHeader, axolDecorPin, axolDecorClose;
Atom axolWinAttr, axolWtBase, axolMenuFull;

AXWidget CrtWidget();
AXWidget ElfbGetActiveWidget();
AXWidget AXmMainWidgetOfTask();
int axolPulldownY();
extern int TextWidth();
extern int axDlgUnscaleX(), axDlgUnscaleY();
void axolInit();
void axolPaintDropShadow();
extern void destroyCloneWidget();
extern void deRemoveFromSession();
extern void wOptionWidth();
extern void xmLabelSize(), wIconSize();
extern void wWidgetShadowOffsets();
extern void AxTaskFreeElfData();
extern void AxCenterWidgetOverMouse();
extern void SetTabLayers();
extern void axInitUidWidgets();
extern void xmPaintFocusSelector(), xmLiftFocusSelector();
extern void xmtcSwitchLayer();
extern void CbOpenComboPulldown();
extern void CbDestroyPulldown();
extern void xmEditboxSetLineHeight();
extern int TblSetFont();
extern int TableEvent();
extern int EntryBoxEvent();
extern int  wOptionHeight();
extern int AxFilterExpose();
extern int CbEnterStayup();
extern int AxPostHelp();
extern int xmToggleThreeStatePress();
extern int xmToggleAction();
void axolDrawPulldownChoice();
void axolDrawRadioChoice();
void axolDrawClrTriangle(); 
void axolDrawClrAbbrBtn();
void axolDrawClrRect();
static int axolMenuButtonWidth();
/* end OpenLook stuff */

void AdjustPulldownOrigin();
void mtDrawBevel();
pixcache_t *xmIconPixmapAndSize();
AXWidget TabToNextWidgetVert(), TabToNextWidgetHoriz();
AXWidget TabToPrevWidgetVert(), TabToPrevWidgetHoriz();

extern void axmCreateArrowStipples();
extern void AxDrawBevel();
extern void xmColorFillRectangle();
extern void AXmClearGlobalWidgetHandle();
extern int  ComboBoxKeyEvent();
extern int  ComboBoxMouseEvent();
extern int  ComboBoxSelectionCB();

extern Window AxDummyWin;       /* un-mapped root window */
Window AxMemoryWindow;  /* out of memory window */
extern int NumDlgNonTransients;    /* Number of major dialogs */

extern short DpyWid, DpyHt,DpyDepth;
extern Display *Dpy;
extern Window RootWin;

extern int CharWids[];  /* of dialog font */
extern int SmallCharWids[]; /* of reduced dialog font */
extern Pixmap UnknownPixmap;    /* 16x16 pixmap of unknown image */
extern int NWidth,N2Width,N3Width;      /* width of "n", "nn", "nnn" */
extern int AxCharAbove, AxCharBelow, AxCharHeight;
extern int SmallCharAbove, SmallCharBelow, SmallCharHeight;
extern int AXTextCursorTriangle;    /* app. text cursor appearance */

    /* Asterix key modifier masks - set in AxModifierMapping() based 
     * on current modifier map.
     * (ShiftMask, LockMask, & ControlMask usually correspond to
     * Shift, CapsLock, & Control keys, but modifier masks for Alt,
     * NumLock, etc. are server-dependent. This mapping from X modmap
     * to Asterix modmap eliminates the dependency.) */
extern int AxShiftMask;
extern int AxLockMask;
extern int AxControlMask;
extern int AxAltMask;
extern int AxMetaMask;
extern int AxNumLockMask;

static int ModifierMaskFromIndex(), ModifierMaskFromName();

char *UPneedByCode();

Pixmap LookupPixmap();
AXWidget ZXmCreateStatusArea();
extern int THIMhelpMode;
extern short THIMpid;
extern int ThimExposuresMayBeComing;    /* Hint for command startup delaying */
extern int ElfInLearnMode;    /* TRUE while in learn mode */


#define MAX_GUN 65535L

pixcache_t *Pixmapper();

    /* The widget-kit font cache has a finite size; if a non-cached
     * font needs to be used when the cache is full, the least
     * recently used font is freed. */
typedef struct {
  char *name;    /* name to be passed to XLoadQueryFont */
  XFontStruct *font; /* pointer to XFontStruct corresponding to name */
  int LRUix;         /* least recently used number; 0 => oldest */
  int numInUse;      /* num widgets using this font */
} fontcache_t;
#define MAX_WIDGET_FONTS 20
XFontStruct *AxProfXLoadQueryFont(), *lookupNamedFont();
static fontcache_t FontCache[MAX_WIDGET_FONTS];
static XFontStruct *LookupFont();
static void FreeFontInCache();
static fontcache_t *LoadFontFromCache();
static void doExpose();
static void xmContainerWidgetPointer();

menu_item_def *MenuItemFromTool();

AXWidget SetTopPendingDelete();

struct WINDNOMAP 
{       
  char title[1024];
  struct WINDNOMAP *next;
};

/* List of Windows NOT to be Displayed */
extern struct WINDNOMAP *WindNotMapped;

typedef struct {
  void (*painters)();
  void (*manage)();   /* to display */
  void (*unmanage)(); /* to clear */
} dsp_info;

AXWidget ClickWidget;   /* used to track double clicks */
void DestroyDialog();
static void ShiftHelpRightMost();
static void PaintMenuBar();

extern void PaintRibbon(), PaintToggle(), xmDrawString();
extern void xmDrawStringAndAccelerator();
void PaintToolBar();
void PaintGExruler(), PaintGEyruler();
void PaintGEPalette(), PaintColorpal(), PaintMEDebugger(), PaintStatus();
void PaintOrientalStatus();
void ResetActive();
void PaintRowColumnPulldown();

extern int rectanglesIntersect(), rectInsideRect();
extern int wListVisibleItemCount();
extern int RectEvent();
extern XFontStruct *lookupNamedFont(), *lookupReferenceFont();
extern char **axListFontFamilies();
extern void unionRectangles();
extern void PaintListBorder(/* widget_t *w */);
extern void PaintTableBorder(/* widget_t *w */);
extern long *CreateIntsArray(), *CopyIntsArray();
extern long FirstInIntsArray(), WriteIntsArray(),
  ReadIntsArray(), IntsArraySize();
extern AXWidget backgroundWidget();
extern AXWidget xmkfHasLink();
extern AXWidget FindGadget();
extern AXWidget xmKeyFocusWidget();

extern AXWidget_table TableArmed; /* currently armed W_TABLE for auto-scroll */
extern AXWidget_rowcol RowColumnArmed; /* currently armed row-column */
extern AXWidget_combo_box ComboBoxArmed; /* currently armed combo box */
extern AXWidget_combo_box ComboBoxInEditWindow; /* combo box w/ cursor on */
extern AXWidget_combo_box ComboListArmed;  /* armed combo dropdown list */
extern AXWidget_canvas CanvasArmed;
extern AXWidget_entry EditWinArmed;
AXWidget_editbox EditBoxArmed;

int FlagsFromApp();

int EditBoxEvent();
static void EditBoxChanged();

void PaintEditBox();
void AxXmDialogList();


AXWidget MenuArmed = NULL;     /* currently displayed menu */
AXWidget_scroll ScrollBarArmed;       /* currently armed W_SCROLL */
AXWidget_list ListBoxArmed = NULL;  /* currently armed W_LIST for auto-scroll */
AXWidget_tray TrayArmed = NULL;     /* currently armed W_TRAY for auto-scroll */
AXWidget StrokingBar;
extern AXWidget WindowList;
extern AXWidget RightButtonArmed;/*  displayed right buttonpopup menu  */
extern AXWidget_popup PopupArmed;    /* current displayed popup menu */
extern AXWidget_pushbutton ButtonArmed;   /* currently armed button */
extern AXWidget_ribbon RibbonArmed;   /* currently armed ribbon */
extern AXWidget_scale ScaleArmed;    /* currently armed scale */
extern AXWidget_splitter SplitterArmed; /* currently armed splitter */

AXWidget_menu AxPulldownActive; /* non-zero while menubar pulldown is active */
int AxMenuItem = -1;      /* current item in menuBar */
int AxPulldownItem = -1;  /* current item in pulldown */
int AxCascadeItem = -1;   /* current item in cascade */
int AxPulldownStayup=FALSE;    /* if TRUE: menu pulldown is in stayup mode*/
int PointerHasMoved; /* TRUE if pointer has moved since last set to FALSE */
/* ResetActive() exits from menu pulldown stayup mode unless asked not to */
int AxExitPulldownStayupMode = TRUE;

AXWidget TabToNextWidget(), TabToPrevWidget();
static AXWidget axTopLeftmostWidget(), axBottomRightmostWidget();

extern void PaintMenuPulldown();
extern int PullDownKeyEvent();
extern void PaintPopupPulldown();
extern void PaintOption(), PaintOptionPulldown();
extern void ArmButton(), PaintButton();
extern void PaintScrollBar(), ScrollBarEvent(); 
extern void PaintList();
extern void PaintEnter();
extern int axolInTextScrollButtons();
extern char *MnemonicInString(), *axGetScreenMetrics();
extern char *UPbyName();
extern void ArmScale();
extern int  ListEvent(), wToggleTextOffsets();
extern void ListAutoScroll(/* AXWidget w */);
extern void TableAutoScroll(/* AXWidget w */);
extern void EditWinAutoScroll();
extern void EditBoxAutoScroll();
extern void ComboListAutoScroll();
#if 0
extern void ListDrawCursor(/* AXWidget w, int put_cursor */);
#endif
extern struct edit_window *GetEditWin();

extern wAux *newAuxData(); /* xmlibcom.c */

extern struct timeval TimeCascadeShouldPopup;

/* Auto Scroll */
#define AUTOSCROLL_NOTARMED 0 /* not in AutoScroll mode */
#define AUTOSCROLL_ARMED    1 /* in AutoScroll mode, but don't execute now */
#define AUTOSCROLL_WAIT  2 /* execute AutoScroll after timer expires */
#define AUTOSCROLL_READY    3 /* AutoScroll timer has expired, execute */
int AutoScrollState;
struct timeval TimeAutoScrollNeedsUpdate;  /* wrt system time */

#define AUTOSCROLL_TIMEOUT 300 /* initial timeout before auto scroll (in ms) */
#define AUTOSCROLL_INTERVAL 100 /* used for actual auto scrolling */
int AutoScrollUpdateTimeout = AUTOSCROLL_TIMEOUT;
void AxAutoScrollHandler();
static void HandleScrollBarAutoScroll();
static void HandleListBoxAutoScroll();
static void HandleTableAutoScroll();
static void HandleEditWinAutoScroll();
static void HandleEditBoxAutoScroll();
static void drawDiamondDropShadow();
static void liftDiamondDropShadow();
static void AxmCreateDlgFrame();
static void ComputeMenuBarWidth();

extern void xmDialogFocus();
extern int AxSubtractTime();
extern void xmDrawRectShadow(), xmDrawRectAntiShadow();
extern void CanvasUpdateScrollbars();
extern GC axCreateGC();

/* active box in menu bar */
extern int BarBoxX,BarBoxY,BarBoxWidth,BarBoxHeight;
extern int BarBoxMenuBarIndex;

extern int WidgetNeedsUpdated; /* Set when a widget needs repainted */
AXWidget ToolArmedForUpdate = NULL; /* if set, update tool menu status
                                            will have max of one outstanding */

extern long WinMask;
extern int MenuUID;    /* counter of menu starts */

extern Cursor ThimTextCursor;

#if BUILD_ORIENT
mbchar *OrientFace[2];
extern XIM input_method;
extern XIC ICWhichHasFocus;
extern Window WinOfICFocus;
#endif

extern Cursor ThimHelpCursor;
extern Cursor ThimPointerCursor;
extern Cursor ThimBusyCursor;
extern Cursor ThimRecordCursor;
extern Cursor ThimNoRecordCursor;

extern int InSysHourglassMode; /* TRUE while all windows glassed */
extern int UseGloballyActiveFocus;  /* re: ICCCM input focus conventions */

#define MAX_APP_CURSORS 20
typedef struct {
  Cursor curs;
  int iconid;
} app_curs_info;
static app_curs_info AppCursors[MAX_APP_CURSORS];


extern AXWidget TotalWidgetsList;  /* for resource tracking */
extern win_list_t *TotalWindowsList;   /* for resource tracking */
extern int NumWidgets;
extern int NumWindows;

static void mtDrawShadow ();
static void Messager ();

typedef struct {
  char *name;  /* name bound to key */
  int (*func)();   /* function to call */
} dlg_function_list;

static int CallDlgFuncFromName();
static int DlgCancel(), DlgExecute();
static int DlgNextField(), DlgPrevField();
static int DlgDeleteBack(), DlgDeleteForward();
static int DlgCut(), DlgCopy(), DlgPaste();

    /* Dialog key binding functions have hard coded names because they
     * cannot be macros (currently no way to communicate with task of
     * "current dialog" as is done in the ATM). */
static dlg_function_list AxDlgKeyFuncList[] = {
  {NXLT("DLG.CANCEL"), DlgCancel},
  {NXLT("DLG.EXECUTE"), DlgExecute},
  {NXLT("DLG.NEXT_FIELD"), DlgNextField},
  {NXLT("DLG.PREV_FIELD"), DlgPrevField},
  {NXLT("DLG.DELETE_BACK"), DlgDeleteBack},
  {NXLT("DLG.DELETE_FORWARD"), DlgDeleteForward},
  {NXLT("DLG.CUT"), DlgCut},
  {NXLT("DLG.COPY"), DlgCopy},
  {NXLT("DLG.PASTE"), DlgPaste},
  {NULL,NULL},
};

ElfbFixupQuirks () {}

AxGetMaxHyt()
{
	int val, delta = 50;
	val = DpyHt - delta;
	return(val);
}
AxGetMaxWid()
{
	int val, delta = 50;
	val = DpyWid - delta;
	return(val);
}

/*
*   AxButtonIsDown - returns TRUE if mouse button is down
*/
AxButtonIsDown()
{
  return(0 != AxButtonDown);
}

AxUpdateTotalWindowsList(win)
     Window win;
{
  win_list_t *w;
  int size;

  size = sizeof(win_list_t);
  w = (win_list_t *)malloc(size);
  memset((char *)w, 0, size);
  w->win = win;
  w->next = TotalWindowsList;
  if ( w->next )
    w->next->prev = w;
  w->prev = NULL;
  TotalWindowsList = w;
  NumWindows++;
}

/*************************************************************************
function: AxCrtWindow - Wrapper for XCreateWindow, used for resource tracking
*/
Window AxCrtWindow (dpy,parent,x,y,wid,ht,bord,depth,class,visual,mask,atts)
     Display *dpy;
     Window parent;
     int x, y;
     unsigned int wid, ht, bord;
     int depth;
     unsigned int class;
     Visual *visual;
     unsigned long mask;
     XSetWindowAttributes *atts;
{
  static int dblPaint = FALSE;    /* patch for a DEC bug */
  static int called = FALSE;
  Window win;

  /* turn on backing store */
  if ( atts && !AxSuppressBackingStore )
    {
      if ( DoesBackingStore(DefaultScreenOfDisplay(dpy)) )
        {
      mask |= (CWBackingStore | CWBackingPlanes | CWBackingPixel);
      atts->backing_store = WhenMapped;
      atts->backing_planes = AllPlanes;
      atts->backing_pixel = ~AllPlanes;
        }
    }


  /* create the window */
  win = XCreateWindow(dpy,parent,x,y,wid,ht,bord,depth,class,visual,mask,atts);

#if QATOOL
  if ( QaCaptureMode() || QaPlaybackMode() )
    QaRegisterWindow(dpy, win);
#endif

  AxUpdateTotalWindowsList(win);

  /**********************************************************************\
   * On the proper combination of DEC UWS and window manager,           *
   * sub-windows never get initial exposure events.  This is a patch    *
   * for those machines.                                                *
   \**********************************************************************/
  if ( dblPaint || (!called && (dblPaint = UPnumVal(PROF_DBL_PAINT_))) ) {
    XClearArea(Dpy, win, 0, 0, wid, ht, True);
    called = TRUE;
  }

  return(win);
}

/*************************************************************************
function: AxCrtSimpleWindow - Wrapper for XCreateWindow, used for resource tracking
*/
Window AxCrtSimpleWindow (dpy,parent,x,y,wid,ht,bordwidth,border,back)
     Display *dpy;
     Window parent;
     int x, y;
     unsigned int wid, ht, bordwidth;
     unsigned long border;
     unsigned long back;
{
  Window win;

  win = XCreateSimpleWindow(dpy,parent,x,y,wid,ht,bordwidth,border,back);

#if QATOOL
  if ( QaCaptureMode() || QaPlaybackMode() )
    QaRegisterWindow(dpy, win);
#endif

  AxUpdateTotalWindowsList(win);
  return(win);
}

/*************************************************************************
function: AxDestroyWindow - Wrapper for XDestroyWindow
*/
AxDestroyWindow (dpy, owner, win)
     Display *dpy;
     AXWidget owner;
     Window win;
{
  win_list_t *w;

  /* printf("destroy win %d\n",win); */

  /* Unthread for total windows list */

  for ( w = TotalWindowsList; w; w = w->next )
    if ( w->win == win )
      break;
  if ( w ) {
    if ( w->next )
      w->next->prev = w->prev;
    if ( w->prev )
      w->prev->next = w->next;
    if ( TotalWindowsList == w )
      TotalWindowsList = w->next;
    free(w);
  }
  AxDndUnregisterWindow(dpy, win);
  /*  else printf("window tracking error on %d\n",win); */
  NumWindows--;
  if (((long)owner > 0) && (owner->flags & WFLG_IN_EDIT)) {
    XFreePixmap(dpy,win);
  }
  else {
    XDestroyWindow(dpy,win);
  }

  /* *Absolutely need this sync* -- The Motif Window Manager sends
     ClientMessages (SAVE_YOURSELF) to destroyed windows, then
     expects a reply!  This sync is here in the hope that the Window
     Manager will immediately know when a Window dies (and won't send
     ClientMessages to it). */
  XSync(Dpy, False);

#if 1
  /* A dialog box with *many* windows triggers *many* calls to
     HandleExposures () because of this.  The top level call,
     typically DestroyDialog () sets this variable to true; that is
     enough to (X)sync the server and peek for exposures.
     Note: #if zeroing this does not make any difference.  Instead,
     #if zeroed out call to (X)Sync in HandleExposures ().  I have
     tried out the software with and without
     `axSuppressBackingStore'.  Product is well behaved. */
  ThimExposuresMayBeComing = TRUE;
#endif
}


/***********************************************************************
function: AxInWindowsList - Return TRUE if XWIN is `TotalWindowsList';
FALSE otherwise.
*/
int
AxInWindowsList(xwin)
     register Window xwin;
{
  register win_list_t *w;

  for (w = TotalWindowsList; w; w = w->next)
    if (w->win == xwin)
      return(TRUE);
  return(FALSE);
}

/*************************************************************************
function: AxHaveAnyWindows - Returns whether window list is empty
*/
int AxHaveAnyWindows ()
{
  return(TotalWidgetsList != NULL);
}

/*************************************************************************
function: AxShowMemoryWindow - Display/undisplay "out-of-memory" window
*/
AxShowMemoryWindow (show,allow_kill)
     int show;
     int allow_kill;
{
  char *msg1, *msg2;

  msg1 = XLT2("xmlib.c-(1)","Applixware is blocked waiting for swap space.");
  msg2 = XLT2("xmlib.c-(2)","Terminate other application windows to proceed");

  if ( show ) {
    XMapWindow(Dpy,AxMemoryWindow);
    XRaiseWindow(Dpy,AxMemoryWindow);
    AxDrawBevel((AXWidget) NULL, AxMemoryWindow, 0, 0,
        MEMWIN_WID, MEMWIN_HT, 2, BEVEL_IN);
    axDrawString(Dpy, AxMemoryWindow, ForeGC, (XFontStruct *) 0,
         10, 25, msg1, strlen(msg1));
    axDrawString(Dpy, AxMemoryWindow, ForeGC, (XFontStruct *) 0,
         10, 45, msg2, strlen(msg2));
  }
  else {
    XUnmapWindow(Dpy,AxMemoryWindow);
  }
  XFlush(Dpy);
}


LoadDialogKeyBindings()
{
  AxDialogKeyBindings = ElfLookupSlider(0);
}

/***********************************************************************
function: DialogScrollNewHScrollPos - Scroll to a new `hscroll_pos' value.
*/
static void
DialogScrollNewHScrollPos(w, new_hscroll_pos)
AXWidget_dialog w;
register int new_hscroll_pos;
{
    int old_hscroll_pos;
    int max_width;
    int win_height;
    int line_height;
    int src_x, src_y, dst_x, dst_y;
    unsigned int width, height;
    int clip_x_origin, clip_y_origin;
    int win_width;
    XRectangle crect[1];
    int shift_amt;

    if (!w)
        return;

    if (w->type != W_DIALOG)
        return;

	if (!(w->parent && w->parent->frame))
		return;

	if (w->hscroll_pos == new_hscroll_pos)
		return;

    w->hscroll_pos = new_hscroll_pos;
	
	XMoveWindow(Dpy, w->window, w->xpos, w->ypos);
	
	if (w->parent->menuBar && w->parent->menuBar->window) {
		AXWidget_menu mb = ((AXWidget_main) w->parent)->menuBar;
		XMoveWindow(Dpy, mb->window, mb->xpos, mb->ypos);
		XRaiseWindow(Dpy, mb->window);
		if (w->parent->toolBar && w->parent->toolBar->window) {
			AXWidget_tool tb = ((AXWidget_main) w->parent)->toolBar;
			XMoveWindow(Dpy, tb->window, tb->xpos, tb->ypos);
			XRaiseWindow(Dpy, tb->window);
		}
	}
	w->hScrollBar->scroll_pos = new_hscroll_pos;
	PaintScrollBar(w->hScrollBar,NULL, FALSE, FALSE);
}

/***********************************************************************
function: DialogScrollNewVScrollPos - Scroll to a new `scroll_pos' value.
*/
static void
DialogScrollNewVScrollPos(w, new_scroll_pos)
AXWidget_dialog w;
int new_scroll_pos;
{
    int lines;
    int old_scroll_pos;
    int win_height;
    int max_hyt, line_height;
    int src_x, src_y, dst_x, dst_y;
    unsigned int width, height;
    int clip_x_origin, clip_y_origin;
    XRectangle crect[1];

    if (!w)
        return;

    if (w->type != W_DIALOG)
        return;

	if (!(w->parent && w->parent->frame))
		return;

	if (w->scroll_pos == new_scroll_pos)
		return;
    w->scroll_pos = new_scroll_pos;
	
	XMoveWindow(Dpy, w->window, w->xpos, w->ypos);
	
	if (w->parent->menuBar && w->parent->menuBar->window) {
		AXWidget_menu mb = ((AXWidget_main) w->parent)->menuBar;
		XRaiseWindow(Dpy, mb->window);
		if (w->parent->toolBar && w->parent->toolBar->window) {
			AXWidget_tool tb = ((AXWidget_main) w->parent)->toolBar;
			XRaiseWindow(Dpy, tb->window);
		}
	}

	w->vScrollBar->scroll_pos = new_scroll_pos;
	PaintScrollBar(w->vScrollBar,NULL, FALSE, FALSE);
}

/*************************************************************************
function: DialogBarChanged - Callback routine for W_DIALOG scrollbars
*/
static void DialogBarChanged (widget,w,data)
AXWidget widget;
AXWidget_dialog w;
XmScrollBarCallbackStruct *data;
{
    int new_scroll_pos, pos; /* top row */
    int new_hscroll_pos, hpos; /* xpos */
    int span;

    if ( w->vScrollBar == (AXWidget_scroll)widget ) {
        switch ( data->reason ) {
        case XmCR_INCREMENT:
            new_scroll_pos = w->scroll_pos + widget->height/20;
            new_scroll_pos = MIN(new_scroll_pos, w->height - widget->height);
			span = new_scroll_pos - w->scroll_pos;
            break;
        case XmCR_DECREMENT:
            new_scroll_pos = w->scroll_pos - widget->height/20;
            new_scroll_pos = MAX(0, new_scroll_pos);
			span = new_scroll_pos - w->scroll_pos;
            break;
        case XmCR_PAGE_INCREMENT:
            new_scroll_pos = w->scroll_pos + widget->height;
            new_scroll_pos = MIN(new_scroll_pos, w->height-widget->height);
			span = new_scroll_pos - w->scroll_pos;
            break;
        case XmCR_PAGE_DECREMENT:
            new_scroll_pos = w->scroll_pos - widget->height;
            new_scroll_pos = MAX(0, new_scroll_pos);
			span = new_scroll_pos - w->scroll_pos;
            break;
        case XmCR_VALUE_CHANGED:
            new_scroll_pos = data->value;
			span = new_scroll_pos - w->scroll_pos; 
            break;
        default:
            break;
        }
		w->ypos -= span;
        DialogScrollNewVScrollPos(w, new_scroll_pos);
    }
    else if ( w->hScrollBar == (AXWidget_scroll)widget ) {
        switch ( data->reason ) {
        case XmCR_INCREMENT:
            new_hscroll_pos = w->hscroll_pos + widget->width/20;
			new_hscroll_pos = MIN(new_hscroll_pos, w->width - widget->width);
			span = new_hscroll_pos - w->hscroll_pos;
            break;
        case XmCR_DECREMENT:
            new_hscroll_pos = w->hscroll_pos - widget->width/20;
			new_hscroll_pos = MAX(0, new_hscroll_pos);
            span = new_hscroll_pos - w->hscroll_pos;
            break;
        case XmCR_PAGE_INCREMENT:
            new_hscroll_pos = w->hscroll_pos + widget->width;
			new_hscroll_pos = MIN(new_hscroll_pos, w->width - widget->width);
            span = new_hscroll_pos - w->hscroll_pos;
            break;
        case XmCR_PAGE_DECREMENT:
            new_hscroll_pos = w->hscroll_pos - widget->width;
			new_hscroll_pos = MAX(0, new_hscroll_pos);
            span = new_hscroll_pos - w->hscroll_pos;
            break;
        case XmCR_VALUE_CHANGED:
            new_hscroll_pos = data->value;
			span = new_hscroll_pos - w->hscroll_pos; 
            break;
        default:
            break;
        }
		w->xpos -= span;
		if (w->parent->toolBar) {
			w->parent->toolBar->xpos -= span;
		}
		if (w->parent->menuBar) {
			w->parent->menuBar->xpos -= span;
		}
        DialogScrollNewHScrollPos(w, new_hscroll_pos);
    }
}

static void
AxmCreateDlgFrame(mw, dw)
AXWidget_main mw;
AXWidget_dialog dw;
{
	static XtCallbackRec callback_list[2];
	int wid, hyt, n, ybar_height, ybar_pos;
	Arg args[20];
	int createVScroll, createHScroll;

	if ( (dw->flags & WFLG_IN_EDIT) || dw->topmostwindow )
	{
		dw->hScrollBar = (AXWidget_scroll)0;
		dw->vScrollBar = (AXWidget_scroll)0;
		mw->frame      = (AXWidget)0;
		return;
	}

	/* sanity check */
	wid = AxGetMaxWid();
	hyt = AxGetMaxHyt();

	/* By default create both scroll bars */
	createVScroll = createHScroll = TRUE;

	if ( dw->minHeight <= hyt ) {
		/* No vScroll */
		createVScroll = FALSE;	
		dw->vScrollBar = (AXWidget_scroll)0;
		hyt = dw->parent->height-SCROLLBAR_THICK;
	}

	if ( dw->minWidth <= wid ) {
		/* No hScroll */
		createHScroll = FALSE;			
		dw->hScrollBar = (AXWidget_scroll)0;
		wid = dw->parent->width-SCROLLBAR_THICK;
	}

	if (!createVScroll && !createHScroll) {
		mw->frame      = (AXWidget)0;
		return;
	}

	hyt = dw->parent->height;
	wid = dw->parent->width;

	if (createVScroll)
		wid = wid - SCROLLBAR_THICK;

	if (createHScroll)
		hyt = hyt - SCROLLBAR_THICK;


	/* create the vertical scroll bar */
	if ( !dw->vScrollBar && createVScroll)
	{
		CALLBACKER(callback_list,DialogBarChanged,dw);
		n = 0;
		XtSetArg(args[n], XmNx, wid); n++;
		ybar_height = hyt;
		ybar_pos = 0;
		if (mw->menuBar && mw->menuBar->window) {
			ybar_height -= mw->menuBar->height;
			ybar_pos += mw->menuBar->height;
		}
		if (mw->toolBar && mw->toolBar->window) {
			ybar_height -= mw->toolBar->height;
			ybar_pos += mw->toolBar->height;
		}
		XtSetArg(args[n], XmNy, ybar_pos); n++;
		XtSetArg(args[n], XmNheight, ybar_height); n++;
		XtSetArg(args[n], AXmNmaximum, dw->height); n++;
		XtSetArg(args[n], AXmNsliderSize, ybar_height); n++;
		XtSetArg(args[n], XmNvalue, ybar_pos - dw->ypos); n++;
		XtSetArg(args[n], XmNorientation, AXmVERTICAL); n++;
		XtSetArg(args[n], XmNvalueChangedCallback, callback_list); n++;
		dw->vScrollBar = AXmCreateScrollBar(dw->parent, "", args, n);
		dw->vScrollBar->mapped = TRUE;
	}

	/* create the horizontal scroll bar */
	if ( !dw->hScrollBar && createHScroll)
	{
		CALLBACKER(callback_list,DialogBarChanged,dw);
		n = 0;
		XtSetArg(args[n], XmNx, 0); n++;
		XtSetArg(args[n], XmNy, hyt); n++;
		XtSetArg(args[n], XmNwidth, wid); n++;
		XtSetArg(args[n], AXmNmaximum, dw->width); n++;
		XtSetArg(args[n], AXmNsliderSize, wid); n++;
		XtSetArg(args[n], XmNvalue, -dw->xpos); n++;
		XtSetArg(args[n], XmNorientation, AXmHORIZONTAL); n++;
		XtSetArg(args[n], XmNvalueChangedCallback, callback_list); n++;
		dw->hScrollBar = AXmCreateScrollBar(dw->parent, "", args, n);
		dw->hScrollBar->mapped = TRUE;
	}

	/* create the frame window */
	if ( !mw->frame )
	{
		/* create the widget */
		mw->frame = CrtWidget(W_FRAME, mw, "");
		AddToWindowList(mw->frame);

		/* set the widget size */
		n = 0;

		/* Frame always starts at (0,0) */
		XtSetArg(args[n], XmNx,0); n++;
		XtSetArg(args[n], XmNy,0); n++;
		XtSetArg(args[n], XmNwidth, mw->width - SCROLLBAR_THICK); n++;
		XtSetArg(args[n], XmNheight, mw->height - SCROLLBAR_THICK); n++;
		AxXtSetValues(mw->frame, args, n);

		/* create the widget window */
		mw->frame->window = AxCrtWindow(Dpy, mw->window,
										mw->frame->xpos, mw->frame->ypos,
										mw->frame->width, mw->frame->height,
										0, CopyFromParent, InputOutput,
										CopyFromParent, WinMask,&WinAtt);
		XSelectInput(Dpy, mw->frame->window, TM_ALL_INPUTS_MASK);
		AxMapWindow(dw, Dpy, mw->frame->window, dw->name);
		mw->frame->mapped = TRUE;
	}
}

extern int AxNoMapWindows;
extern Colormap ApplixCmap;

/**********************************************************************/
/* IF YOU CHANGE SOMETHING IN THIS FUNCTION, MAKE SURE THE EQUIVALENT */
/* CHANGE IS MADE IN THE FUNCTION WXShowWindow (windlg.c) IF NOT SURE */
/* HOW, ASK jon or donato.                           -donato          */
/*************************************************************************
function: AXtRealizeWidget - Create the window
*/
void AXtRealizeWidget (w)
     register AXWidget_main w;
{
  XSizeHints xsh;
  int work_width, work_height, bar_width=0, bar_height=0;
  int ruler_width=0,ruler_height=0;
  int plates_width=0,plates_height=0;
  int vsc_xpos, vsc_ypos, vsc_width = 0;
  int msg_height = SCROLLBAR_THICK, msg_width = 0;
  int palt_width = 0, palt_height = 0;
  int hsc_pos=0, hsc_width = 0;
  int tool_width = 0, tool_height = 0;
  int colorpal_width = 0, colorpal_height = 0;
  int ge_xruler_width = 0, ge_xruler_height = 0;
  int ge_yruler_width = 0, ge_yruler_height = 0;
  int kanji_status_width = 0, kanji_status_height = 0, itmp;
  int add_in_kanji_status = 0;
  int buton_hyt, page_wid, msg_pos, msg_ypos;
  int win_width;
  Pixmap pixmap;
  AXWidget childP;
  int decorations;
  int dialogHasApply;
  unsigned long event_mask;
  int is_ge;
  XTextProperty text_prop;
  char host_name[MAXHOSTNAMELEN + 1];
  char *text_prop_list[2];
  AXWidget_dialog wd;
  Window win;

  memset(&xsh,0,sizeof(xsh));

  /*
    If this is a dialog box, the geometry is determined by the
    dialog portion.  Otherwise, geoemtry is set by the work area.
    */

#if QATOOL
  QaWidgetStyle = w->style;
#endif

  if ( w->type == W_DIALOG ) {
    w = w->parent;
  }
  if ( (w->type != W_MAIN) && (w->type != W_KANJI_KANA) ) /* sanity */
    return;
    
  if (w->dialog && !w->dialog->xpos && !w->dialog->ypos) {
    AxCenterWidgetOverMouse(w->dialog);
  }

  /* is this a GE main window? (it uses a diffent status line) */
  if ( w->type != W_MAIN )
    is_ge = FALSE;
  else if ( w->style == IC_GE || w->style == IC_BG || w->style == IC_PIXED )
    is_ge = TRUE;
  else
    is_ge = FALSE;

  if ( w->dialog ) {
    work_width = w->dialog->width;
    work_height = w->dialog->height;
    msg_height = 0; /* HACK!, see comments below about status area ??x */
  }
  else if ( w->type == W_KANJI_KANA ) {
    work_width = w->width - 2;
    work_height = w->height - 2;
    msg_height = 0;
  }
  else {
    work_width = w->workWindow->width + (2 * WindowBorder);
    work_height = w->workWindow->height + (2 * WindowBorder);
  }

  if ( w->vScrollBar )
    vsc_width = SCROLLBAR_THICK;

  if ( w->ge_yruler ) {
    ge_yruler_width = GE_YRULER_WIDTH;
    ge_yruler_height = work_height;
  }
  if ( w->ge_xruler ) {
    ge_xruler_width = work_width;
    ge_xruler_height = GE_XRULER_HEIGHT;
  }

  if ( w->colorpal && w->colorpal->display ) {
    colorpal_width = work_width + vsc_width;
    colorpal_height = COLORPAL_HEIGHT;
  }

  if ( w->palette && w->palette->display ) {
    palt_width = PALETTE_WIDTH;
    palt_height = work_height + colorpal_height;
  }

  win_width = palt_width + work_width + vsc_width;

  if ( w->menuBar && !(w->dialog && w->dialog->topmostwindow) ) {
    bar_width = win_width;
    bar_height = w->menuBar->height;
  }
  if ( w->ruler ) {
    ruler_width = win_width;
    ruler_height = WpRulerHeight(w->style);
  }
  if ( w->plates ) {
    plates_width = win_width;
    plates_height = SSPlatesHeight();
  }
  if ( w->toolBar ) {
    tool_width = win_width-palt_width;
    tool_height = AxToolBarHeight(w, tool_width);
  }

#if BUILD_ORIENT
  if ( input_method != (XIM)NULL )
    {
      /* we add a kanji input status widget at the bottom of dialogs, and */
      /* just above the message/scroll area of main windows    */
      add_in_kanji_status = TRUE;
      kanji_status_width = work_width /*+ ge_yruler_width*/;

      /* Ashisuto changed to correspond the selectable Dialog-Font-Set */
      wEnterPixHeight(NULL, NULL, &itmp, &kanji_status_height);
    }
#endif

  /*..........................................*/
  /* share message and horizontal scroll area */
  /*..........................................*/
  msg_pos = palt_width;
  page_wid  = 0;
  if ( w->pageBar )
    page_wid  = GE_PAGE_WIDTH;

  if ( w->hScrollBar ) {
    if ( is_ge ) {
      msg_width = GE_MSG_WIDTH;
    }
    else {
      msg_width = MSG_WIDTH;
    }
    hsc_width = w->hScrollBar->width = work_width - msg_width - page_wid;
    hsc_pos = w->hScrollBar->xpos = msg_pos + msg_width + page_wid;
  }
  else {
    msg_width = work_width;
  }

  buton_hyt  = 0;
  vsc_xpos = work_width+palt_width;
  vsc_ypos = bar_height+tool_height+ruler_height + plates_height;
  if ( w->butonBar )
    buton_hyt  = w->butonBar->height;

  w->width = xsh.width = win_width;

  w->height = xsh.height = work_height + 
    bar_height + 
    tool_height +
    msg_height + 
    colorpal_height + 
    kanji_status_height +
    plates_height +
    ruler_height;

  /* !! Don't allow window to be taller than display.
   * Doing this here avoids the resize (hence the double paint) immediately
   * after the window is reparented by the WM (from CheckWMShellSize()).
   * This sends a config msg to the app. Can the GE handle such a msg
   * generated here during it's initialization??  The SS uses direct
   * subroutine calls instead of msgs for resizes; it probably cannot handle
   * this during initialization. Anyway, this is useful only for the WP
   * since it's the only app that creates tall windows on a regular basis.
   * !! Assume WM top/bottom border to be 32 pix - works on most WMs. */
  if ( w->height > (DpyHt - 32) ) {
    if ( (w->type == W_MAIN) && w->workWindow && ((w->style == IC_DC) ||
                          (w->style == IC_HTML) || 
                          (w->style == IC_EQN) || (w->style == IC_CE)) ) {
      w->height = xsh.height = DpyHt - 32;
      work_height = w->height -
    bar_height -
    tool_height -
    msg_height -
    colorpal_height -
    kanji_status_height -
    plates_height -
    ruler_height;
      w->workWindow->height = work_height - (2 * WindowBorder);
      FrameAppFromShellWidgetId(w, w->workWindow->width,
                w->workWindow->height);
    }
  }

  if ( w->dialog ) {
	  xsh.flags = (PSize | PMinSize);
	  xsh.flags |= AxProgramSpecifiedWindowPos ? PPosition : USPosition;
	  xsh.x = w->xpos = w->dialog->xpos;
	  xsh.y = w->ypos = w->dialog->ypos;
	  if ( w->dialog->variable_size ) {
		  if ( !w->dialog->maxWidth )
			  w->dialog->maxWidth = DpyWid;
		  if ( !w->dialog->maxHeight )
			  w->dialog->maxHeight = DpyHt;

		  xsh.min_width  = w->dialog->minWidth;
		  xsh.min_height = w->dialog->minHeight;
		  xsh.max_width  = w->dialog->maxWidth;
		  xsh.max_height = w->dialog->maxHeight;
	  }
	  else {
		  xsh.flags |= PMaxSize;
		  xsh.min_width  = xsh.max_width  = xsh.width;
		  xsh.min_height = xsh.max_height = xsh.height;
		  w->dialog->minWidth = w->dialog->maxWidth = xsh.width;
		  w->dialog->minHeight = w->dialog->maxHeight = xsh.height;

	  }
	  if ( w->dialog->topmostwindow ) {
		  XSetWindowAttributes att;
		  long mask;

		  mask = CWOverrideRedirect | CWSaveUnder | CWBackPixel;
		  att.override_redirect = TRUE;
		  att.save_under = FALSE;
		  att.background_pixel = BackPixel;
		  w->window = AxCrtWindow(Dpy, RootWin,
								  xsh.x, xsh.y, xsh.width, xsh.height,
								  0, CopyFromParent, InputOutput,
								  CopyFromParent, mask, &att);
	  }
	  else {

		  /* Fixed Size Dbox. - if width or height is greater than the
		   * screen size then change its dimensions and make it scrollable.
		   * Also allow it to be resized to 6th of the screen dimensions.
		   *
		   * Variable Size Dbox - if min width or height is greater than
		   * the screen size then change its dimensions and allow scrolling.
		   */
		  if (!w->dialog->variable_size ) {
			  if ( xsh.width > AxGetMaxWid() ) {
				  xsh.max_width = xsh.width;
				  xsh.width = AxGetMaxWid()+6;
				  xsh.min_width = xsh.width/6;
			  }		 
			  if ( xsh.height > AxGetMaxHyt() ) {
				  xsh.max_height = xsh.height;
				  xsh.height = AxGetMaxHyt()+6;
				  xsh.min_height = xsh.height/6;
			  }
		  }
		  else {
			  if (xsh.min_width > AxGetMaxWid() ) {
				  w->width = xsh.width = AxGetMaxWid()+6;
				  xsh.min_width = xsh.width/6;
			  }
			  if (xsh.min_height > AxGetMaxHyt() ) {
				  w->height = xsh.height = AxGetMaxHyt()+6;
				  xsh.min_height = xsh.height/6;
			  }
		  }

		  w->window = AxCrtSimpleWindow(Dpy, RootWin,
										xsh.x, xsh.y, xsh.width, xsh.height,
										2, ForePixel, BackPixel);
	  }
  }
  else {
	  xsh.x = w->xpos;
	  xsh.y = w->ypos;
	  xsh.flags = PSize;
	  if (xsh.x || xsh.y)
		  xsh.flags |= AxProgramSpecifiedWindowPos ? PPosition : USPosition;
	  if (w->variable_size) {
		  if ( w->minWidth || w->minHeight ) {
			  xsh.flags |= PMinSize;
			  if ( w->minWidth )
				  xsh.min_width = w->minWidth + vsc_width + palt_width;
			  else
				  xsh.min_width = 0;
			  if ( w->minHeight )
				  xsh.min_height = w->minHeight + 
					  bar_height + 
						  tool_height + /* ??x also for resize! */
							  msg_height + 
								  colorpal_height + 
									  kanji_status_height +
										  plates_height +
											  ruler_height;
			  else
				  xsh.min_height = 0;
		  }
	  } else {
		  if ( w->minWidth || w->minHeight ) {
			  xsh.flags |= PMinSize | PMaxSize ;
			  if ( w->minWidth )
				  xsh.max_width = xsh.min_width = w->minWidth + vsc_width + palt_width;
			  else
				  xsh.min_width = xsh.max_width = 0;
			  if ( w->minHeight )
				  xsh.max_height = xsh.min_height = w->minHeight + 
					  bar_height + 
						  tool_height + /* ??x also for resize! */
							  msg_height + 
								  colorpal_height + 
									  kanji_status_height +
										  plates_height +
											  ruler_height;
			  else
				  xsh.min_height = xsh.max_height = 0;
		  }
	  }
	  w->window = AxCrtSimpleWindow(Dpy, RootWin,
									xsh.x, xsh.y, xsh.width, xsh.height,
									2, xmlibStr.FGpixel, xmlibStr.BGpixel);
	  
  }

  /* Set WM_CLIENT_MACHINE */
  if (gethostname(host_name, MAXHOSTNAMELEN + 1) == -1)
    strcpy(host_name, NXLT("UNKNOWN"));
  else
    host_name[MAXHOSTNAMELEN] = '\0'; /* safety */
  memset((char *) &text_prop, 0, sizeof(XTextProperty));
  *text_prop_list = (char *) host_name;
  if (AXStringListToTextProperty(text_prop_list, 1, &text_prop)) {
    XSetWMClientMachine(Dpy, w->window, &text_prop);
    if (text_prop.value)
      free(text_prop.value);
  }

  XSetWindowColormap(Dpy,w->window,ApplixCmap);
  AxSetWindowProperties(Dpy, w->window, w, w->name, w->wstr, w->style, &xsh);
  SetWindowHints(w, w->style);

  event_mask = StructureNotifyMask|FocusChangeMask|KeyPressMask|KeyReleaseMask;
  if ( w->dialog )
  {
    /* include any event mask data found here */
    if ( w->event_table )
    {
      eventRec *ep;
      for ( ep=w->event_table; ep; ep=ep->next )
        event_mask |= ep->eventMask;
    }
  }
  XSelectInput(Dpy,w->window,event_mask);

  if ( w->dialog ) {
    AXWidget tmp;

    if ( ThimPointerCursor != None )
      AXDefineDefaultCursor(w->dialog,ThimPointerCursor);
    if ( w->dialog->notTransient )
      NumDlgNonTransients++;
    if (tmp = SetTopPendingDelete(w->dialog)) {
      AxUnFocusCurrent(tmp);
      if (tmp->type == W_ENTER) {
	  ElfXCfieldChanged(tmp, tmp->taskOwner);
      }
      else if (tmp->type == W_EDITBOX)
	ElfXCeboxFocusChanged(tmp, tmp->taskOwner);
      else if (tmp->type == W_COMBO_BOX)
	CbActivateEditWin(tmp);
      
    }
  }

  /*
    For exporting from the GE to TIFF, the GE needs a full window
    mess, but actually just works against a pixmap.  Simplest
    approach is to create, but not map, everything.
    */
  if ( !AxNoMapWindows && w->display && AxMapWinName(w->name) ) {
    AxMapWindow(w, Dpy, w->window,w->name);
    AddToWindowList(w);
    w->mapped = TRUE;
  }
  else {
    AddToWindowList(w);
    w->mapped = FALSE;
  }

  if ( w->workWindow ) {
    XSetWindowAttributes att;
    long mask = WinMask;
    int ix;

    att = WinAtt;
    att.background_pixel = xmlibStr.BGpixel;    /* just for work area */
	if ( JavaMode ) {
		mask &= ~CWCursor;
	}
	else {
	    if ( ElfInLearnMode ) {
			if ( w->disable_record )
				att.cursor = ThimNoRecordCursor;
			else
				att.cursor = ThimRecordCursor;
			w->workWindow->tmp_cursor = att.cursor;
		}
		else if ( InSysHourglassMode )
			att.cursor = ThimBusyCursor;
		else if ( w->style ) {
			for ( ix = 0; (ix < MAX_APP_CURSORS) &&
				 (AppCursors[ix].iconid != w->style); ix++ );
			if ( ix == MAX_APP_CURSORS )
				att.cursor = ThimPointerCursor;
			else
				att.cursor = AppCursors[ix].curs;
		}
		else
			att.cursor = ThimPointerCursor;
	}

    if ( WindowBorder ) {
      mask |= CWBorderPixmap;
      att.border_pixmap = UnknownPixmap; /* 50% gray */
    }
    w->workWindow->xpos = palt_width;
    w->workWindow->ypos = bar_height+ruler_height+plates_height+tool_height;
    w->workWindow->window = AxCrtWindow(Dpy,w->window,
                    w->workWindow->xpos,
                    w->workWindow->ypos,
                    w->workWindow->width,
                    w->workWindow->height,
                    WindowBorder,CopyFromParent,InputOutput,
                    CopyFromParent,mask,&att);
    XSelectInput(Dpy, w->workWindow->window, TM_ALL_INPUTS_MASK);
    if (AxMapWindow(w, Dpy, w->workWindow->window,w->name))
      w->workWindow->mapped = TRUE;
    else
      w->workWindow->mapped = FALSE;
  }

  msg_ypos = bar_height + tool_height +
    ruler_height + plates_height + work_height + 
    kanji_status_height;

  if ( w->pageBar ) {
    w->pageBar->window = AxCrtWindow(Dpy,w->window,
                     msg_pos, msg_ypos,
                     w->pageBar->width, w->pageBar->height,
                     0,CopyFromParent,InputOutput,
                     CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->pageBar->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->pageBar->window,w->name);
    w->pageBar->mapped = TRUE;
  }
  if ( w->statusArea ) {
    w->statusArea->window = AxCrtWindow(Dpy,w->window,
                    msg_pos + page_wid, msg_ypos,
                    msg_width, SCROLLBAR_THICK,
                    0,CopyFromParent,InputOutput,
                    CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->statusArea->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->statusArea->window,w->name);
    w->statusArea->mapped = TRUE;
  }

  if ( w->butonBar ) {
    w->butonBar->window = AxCrtWindow(Dpy,w->window,
                      vsc_xpos, vsc_ypos,
                      w->butonBar->width, w->butonBar->height,
                      0,CopyFromParent,InputOutput,
                      CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->butonBar->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->butonBar->window,w->name);
    w->butonBar->mapped = TRUE;
  }
  if ( w->vScrollBar ) {
    w->vScrollBar->height = work_height + kanji_status_height - buton_hyt;
    w->vScrollBar->window = AxCrtWindow(Dpy,w->window,
                    vsc_xpos, vsc_ypos+buton_hyt,
                    SCROLLBAR_THICK, w->vScrollBar->height,
                    0,CopyFromParent,InputOutput,
                    CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->vScrollBar->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->vScrollBar->window,w->name);
    w->vScrollBar->mapped = TRUE;
  }
  if ( w->hScrollBar ) {
    w->hScrollBar->xpos = hsc_pos;
    w->hScrollBar->ypos = msg_ypos;
    w->hScrollBar->width = hsc_width;
    w->hScrollBar->height = SCROLLBAR_THICK;
    w->hScrollBar->window = AxCrtWindow(Dpy,w->window,
                    w->hScrollBar->xpos,
                    w->hScrollBar->ypos,
                    w->hScrollBar->width,
                    w->hScrollBar->height,
                    0,CopyFromParent,InputOutput,
                    CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->hScrollBar->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->hScrollBar->window,w->name);
    w->hScrollBar->mapped = TRUE;
  }

  if ( w->dialog ) {
    pixcache_t *pix;
    XSetWindowAttributes winatt;
        
    winatt = WinAtt;
    winatt.win_gravity = UnmapGravity;

	wd = (AXWidget_dialog)w->dialog;
    wd->xpos = 0;
    wd->ypos = bar_height + tool_height;
	
	if (!wd->variable_size && 
		(wd->width > AxGetMaxWid() || wd->height > AxGetMaxHyt())) {
		wd->minWidth = wd->maxWidth = wd->width;
		wd->minHeight = wd->maxHeight = wd->height;
	}
		
	AxmCreateDlgFrame(w, wd);
	
	if ( w->frame && w->frame->window ) 
		win = w->frame->window;
	else
		win = w->window;
	
	wd->window = AxCrtWindow(Dpy, win,
							 wd->xpos, wd->ypos,
							 wd->width, wd->height,
							 0,CopyFromParent,InputOutput,
							 CopyFromParent,WinMask,&winatt);
    XSelectInput(Dpy, wd->window, TM_ALL_INPUTS_MASK);

#if 1 /* THIS CODE IS TEMPORARY -- WILL CHANGE -- sanjay */
    if (wd->background_image && strlen(wd->background_image)) {
      pix = Pixmapper(wd->background_image);
      if (pix && pix->pix)
    XSetWindowBackgroundPixmap(Dpy, wd->window, pix->pix);
      /* FIXME, arrange for this pixmap to be freed when the
     dialog gets destroyed. */
    }
#endif

    AxMapWindow(w, Dpy, wd->window, w->name);
	if ( wd->topmostwindow ) {
		/* grab the keyboard */
		XGrabKeyboard(Dpy, wd->window, True, GrabModeAsync,
		                   GrabModeAsync, CurrentTime);
		AXSetInputFocus(wd->window, TRUE, CurrentTime);
	}
	
    wd->mapped = TRUE;
  }

  if ( w->menuBar && !(w->dialog && w->dialog->topmostwindow) ) {
	if (w->dialog && w->frame) {
		w->menuBar->width = w->dialog->width;
		if (w->dialog->vScrollBar) {
			w->menuBar->width += SCROLLBAR_THICK;
		}
	}
	else {
		w->menuBar->width = w->width;
	}
    w->menuBar->window = AxCrtWindow(Dpy, w->window, 0, 0,
									 w->menuBar->width, w->menuBar->height,
									 0, CopyFromParent, InputOutput,
									 CopyFromParent, WinMask, &WinAtt);
    XSelectInput(Dpy, w->menuBar->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->menuBar->window,w->name);
    w->menuBar->mapped = TRUE;
    ShiftHelpRightMost(w->menuBar);
  }
  if ( w->toolBar && (tool_height != 0) ) {
	  w->toolBar->xpos = palt_width;
	  w->toolBar->ypos = bar_height;
	  if ( w->toolBar->height && w->toolBar->display ) { /* toolbar needed */
		  if (w->dialog && w->frame) {
			  w->toolBar->width = w->dialog->width;
		  }
		  else {
			  w->toolBar->width = w->width;
		  }
		  w->toolBar->window = AxCrtWindow(Dpy, w->window, 
										   w->toolBar->xpos, w->toolBar->ypos,
										   w->toolBar->width,
										   w->toolBar->height,
										   0,CopyFromParent,InputOutput,
										   CopyFromParent,WinMask,&WinAtt);
		  XSelectInput(Dpy, w->toolBar->window, TM_ALL_INPUTS_MASK);
		  AxMapWindow(w, Dpy, w->toolBar->window,w->name);
		  w->toolBar->mapped = TRUE;
	  }
  }

  if ( w->ruler ) {
    w->ruler->xpos = 0;
    w->ruler->ypos = bar_height + tool_height;
    w->ruler->width = ruler_width;
    w->ruler->height = ruler_height;
    w->ruler->window = AxCrtWindow(Dpy,w->window,
                   w->ruler->xpos, w->ruler->ypos,
                   w->ruler->width, w->ruler->height,
                   0,CopyFromParent,InputOutput,
                   CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->ruler->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->ruler->window,w->name);
    w->ruler->mapped = TRUE;
  }
  if ( w->plates ) {
    w->plates->xpos = 0;
    w->plates->ypos = bar_height + tool_height;
    w->plates->width = plates_width;
    w->plates->height = plates_height;
    w->plates->window = AxCrtWindow(Dpy,w->window,
                    w->plates->xpos, w->plates->ypos,
                    w->plates->width, w->plates->height,
                    0,CopyFromParent,InputOutput,
                    CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->plates->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->plates->window,w->name);
    w->plates->mapped = TRUE;
  }
  if ( w->corner ) {
    w->corner->xpos = w->width-16;
    w->corner->ypos = w->height-colorpal_height-16;
    w->corner->width = 16;
    w->corner->height = 16;
    w->corner->window = AxCrtWindow(Dpy,w->window,
                    w->corner->xpos, w->corner->ypos,
                    w->corner->width, w->corner->height,
                    0,CopyFromParent,InputOutput,
                    CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->corner->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->corner->window,w->name);
    w->corner->mapped = TRUE;
  }

  if ( w->palette )
    {
#if BUILD_ORIENT
      /* mark the GE window capable of handling wide char input */
      SetWidgetWideCapable( w );
#endif
      w->palette->height = w->height - bar_height;
      w->palette->width = palt_width;
      w->palette->xpos = 0;
      w->palette->ypos = bar_height;
      if ( w->palette->display )
        {
      w->palette->window = AxCrtWindow(Dpy,w->window,
                       w->palette->xpos,
                       w->palette->ypos,
                       w->palette->width,
                       w->palette->height,
                       0,CopyFromParent,InputOutput,
                       CopyFromParent,WinMask,&WinAtt);
      XSelectInput(Dpy, w->palette->window, TM_ALL_INPUTS_MASK);
      AxMapWindow(w, Dpy, w->palette->window,w->name);
      w->palette->mapped = TRUE;
        }
    }

  if ( w->ge_xruler ) {
    w->ge_xruler->value = 0;
    w->ge_xruler->width = work_width;
    w->ge_xruler->height = GE_XRULER_HEIGHT;
    w->ge_xruler->xpos = palt_width;
    w->ge_xruler->ypos = w->height -
      SCROLLBAR_THICK -
      colorpal_height -
      kanji_status_height -
      GE_XRULER_HEIGHT;
    w->ge_xruler->window = AxCrtWindow(Dpy, w->window,
                       w->ge_xruler->xpos,
                       w->ge_xruler->ypos,
                       w->ge_xruler->width,
                       w->ge_xruler->height,
                       0,CopyFromParent,InputOutput,
                       CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->ge_xruler->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->ge_xruler->window, w->name);
    w->ge_xruler->mapped = TRUE;
  }
  
#if BUILD_ORIENT
  /* we create an area at the bottom of each window for the kanji input */
  /*   conversion status */
  if ( add_in_kanji_status )
    {
      if ( !w->kanji_status ) 
    {
      int n;
      Arg arg[10];
      n = 0;
      XtSetArg(arg[n],XmNoldWidget,0); n++;
      XtSetArg(arg[n],XmNflags,0); n++;
    
      /* status-window relative x/y pos */
      XtSetArg(arg[n],XmNy,0); n++;
    
      XtSetArg(arg[n],XmNx,0); n++;
      XtSetArg(arg[n],XmNwidth,kanji_status_width); n++;
      XtSetArg(arg[n],XmNheight,kanji_status_height); n++;
    
      w->kanji_status = (AXWidget_kanji)ZXmCreateStatusArea( w, " ", 
                                arg, n, W_KANJI_STATUS );
      w->allow_wide_input = TRUE;
    }

      w->kanji_status->value = 0;
      w->kanji_status->width = kanji_status_width;
      w->kanji_status->height = kanji_status_height;
      w->kanji_status->xpos = palt_width;

      /* the kanji status area is just above the normal status area */
      w->kanji_status->ypos = msg_ypos - kanji_status_height;

      w->kanji_status->window = AxCrtWindow(Dpy, w->window,
                        w->kanji_status->xpos,
                        w->kanji_status->ypos,
                        w->kanji_status->width,
                        w->kanji_status->height,
                        0,CopyFromParent,InputOutput,
                        CopyFromParent,WinMask,&WinAtt);
      XSelectInput(Dpy, w->kanji_status->window, TM_ALL_INPUTS_MASK);
      AxMapWindow(w, Dpy, w->kanji_status->window, w->name);
      w->kanji_status->mapped = TRUE;
    }
#endif      /* BUILD_ORIENT */



  if ( w->ge_yruler ) {
    w->ge_yruler->value = 0;
    w->ge_yruler->width = GE_YRULER_WIDTH;
    w->ge_yruler->height = work_height - ge_xruler_height;
    w->ge_yruler->xpos = palt_width + work_width - ge_yruler_width;
    w->ge_yruler->ypos = bar_height + tool_height;
    w->ge_yruler->window = AxCrtWindow(Dpy, w->window,
                       w->ge_yruler->xpos,
                       w->ge_yruler->ypos,
                       w->ge_yruler->width,
                       w->ge_yruler->height,
                       0,CopyFromParent,InputOutput,
                       CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->ge_yruler->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->ge_yruler->window, w->name);
    w->ge_yruler->mapped = TRUE;
  }

  if ( w->colorpal )
    {
      w->colorpal->width = colorpal_width;
      w->colorpal->height = COLORPAL_HEIGHT;
      w->colorpal->xpos = palt_width;
      w->colorpal->ypos = w->height - w->colorpal->height;
      if ( w->colorpal->display )
        {
      w->colorpal->window = AxCrtWindow(Dpy, w->window,
                        w->colorpal->xpos,
                        w->colorpal->ypos,
                        w->colorpal->width,
                        w->colorpal->height,
                        0,CopyFromParent,InputOutput,
                        CopyFromParent,
                        WinMask,&WinAtt);
      XSelectInput(Dpy, w->colorpal->window, TM_ALL_INPUTS_MASK);
      AxMapWindow(w, Dpy, w->colorpal->window, w->name);
      w->colorpal->mapped = TRUE;
        }
    }

#if 0   
  ResetShiftState();
#endif
}

/*************************************************************************
function: CheckWMShellSize - Check if main window's WM shell is larger
than display.  ( We wouldn't have to worry about such things in a
perfect world... )
*/
CheckWMShellSize(w, eventP)
AXWidget_main w;
XEvent *eventP;
 {
  Window wmShellWin;
  XWindowAttributes wmWinAttrs;
  int mainWidth, mainHeight;

  if ( !w || (w->type != W_MAIN) )
    return;

  if ( eventP && (eventP->type == ReparentNotify) ) {
    /* get size of main window's WM shell */
    wmShellWin = eventP->xreparent.parent;
    if ( XGetWindowAttributes(Dpy, wmShellWin, &wmWinAttrs) ) {
      if ( wmWinAttrs.y < 0 ) {
    /* Force title bar to be visible because on some
     * WMs (Motif), windows can be moved only by using
     * title bars. */
    XMoveWindow(Dpy, wmShellWin, wmWinAttrs.x, 0);
      }
      if ( (wmWinAttrs.width > DpyWid) ||
       (wmWinAttrs.height > DpyHt) ) {
    /* Resize W_MAIN so that the parent shell window
     * (owned by the WM) is completely visible.
     * This generates a ConfigureNotify, at which time
     * the app window is rebuilt.  */
    mainWidth = w->width;
    mainHeight = w->height;
    if ( wmWinAttrs.width > DpyWid ) {
      if ( wmWinAttrs.width < w->width ) {
        /* weird case, but happens sometimes (OpenWin) */
        mainWidth = DpyWid - (wmWinAttrs.width - DpyWid);
      }
      else {
		if ( w->dialog && w->frame )
			mainWidth = w->width;
		else
			mainWidth = DpyWid - (wmWinAttrs.width - w->width);
      }
    }
    if ( wmWinAttrs.height > DpyHt ) {
      if ( wmWinAttrs.height < w->height ) {
        /* weird case, but happens sometimes (OpenWin) */
        mainHeight = DpyHt - (wmWinAttrs.height - DpyHt);
      }
      else {
		if ( w->dialog && w->frame )
			mainHeight = w->height;
		else
			mainHeight = DpyHt - (wmWinAttrs.height - w->height);
      }
    }
    XResizeWindow(Dpy, w->window, mainWidth, mainHeight);
      }
    }
  }
}


/**********************************************************************/
/* IF YOU CHANGE SOMETHING IN THIS FUNCTION, MAKE SURE THE EQUIVALENT */
/* CHANGE IS MADE IN THE FUNCTION RebuildGDIWindow (winevent.c). IF   */
/* NOT SURE HOW, ASK jon or donato.                   -donato     */
/*************************************************************************
function: RebuildMainWindow - Respond to a resize
Note that 30 pix is used as min work area to reduce effect of boundary issues.
*/
void RebuildMainWindow (w, eventP)
     AXWidget_main w;
     XEvent *eventP;
{
	int main_width=0,main_height=0;
	int work_width=0, work_height=0;
	int bar_width=0, bar_height=0;
	int palt_width = 0, palt_height = 0;
	int ruler_width = 0, ruler_height = 0;
	int tool_width = 0, tool_height = 0;
	int colorpal_width = 0, colorpal_height = 0;
	int ge_xruler_width = 0, ge_xruler_height = 0;
	int ge_yruler_width = 0, ge_yruler_height = 0;
	int kanji_status_width = 0, kanji_status_height = 0, itmp;
	int plates_width = 0, plates_height = 0;
	int add_in_kanji_status;
	int vsc_width=0, msg_height=SCROLLBAR_THICK;
	int vsc_xpos, vsc_ypos, buton_hyt;
	int page_wid, msg_width, msg_pos, hsc_pos=0, msg_ypos;
	int hsc_width = 0;
	int dbg_height = 0, dbg_pos;
	int old_wid=0, old_hyt=0;
	AXWidget childP;
	AXWidget_ribbon ribbonP;
	extern void sizeRibbons();
	int total_width, ribbon_width;
	int ruler_ypos, plates_ypos;
	int is_ge;
#if BUILD_KANJI && SUN4 && !USE_XIM
	int old_kanji_status_width = 0;
#endif
	
	if ( eventP ) {
		if ( eventP->type == ConfigureNotify ) {
			w->xpos = eventP->xconfigure.x;
			w->ypos = eventP->xconfigure.y;
			if ( (w->width == eventP->xconfigure.width) &&
				(w->height == eventP->xconfigure.height) ) {
				return;			/* no change, do nothing */
			}
			w->width = eventP->xconfigure.width;
			w->height = eventP->xconfigure.height;
		}
		else
			return;				/* un-interesting event */
	}
	
	/* is this a GE main window? (it uses a diffent status line) */
	if ( w->type != W_MAIN )
		is_ge = FALSE;
	else if ( w->style == IC_GE || w->style == IC_BG || w->style == IC_PIXED )
		is_ge = TRUE;
	else
		is_ge = FALSE;
	
	if ( w->vScrollBar ) {
		vsc_width = SCROLLBAR_THICK;
	}
	if ( w->palette && w->palette->display ) {
		palt_width = PALETTE_WIDTH;
	}
	if ( w->ruler ) {
		ruler_width = w->width;
		ruler_height = WpRulerHeight(w->style);
	}
	if ( w->plates )    {
		plates_width = w->width;
		plates_height = SSPlatesHeight();
	}
	if ( w->menuBar && !(w->dialog && w->dialog->topmostwindow) ) {
		bar_height = w->menuBar->height;
		if (w->dialog && w->frame) {
			/* this dialog is scrollable; it's typically larger than w->width
			 */
			if (w->width > (w->dialog->width + w->dialog->xpos)) {
				bar_width = w->width - w->dialog->xpos;  /* overstretched */
			}
			else {
				bar_width = w->dialog->width;
				if (w->dialog->vScrollBar) {
					bar_width += SCROLLBAR_THICK;
				}
			}
		}
		else {
			bar_width = MAX(30, w->width);
		}
	}
	if ( w->toolBar ) {
		tool_width = bar_width - palt_width;
		tool_height = AxToolBarHeight(w, tool_width);
	}
	if (w->dialog) {
		if (w->frame) {
			old_wid = w->width;
			old_hyt = w->height;
		}
		else {
			old_wid = w->dialog->width;
			old_hyt = w->dialog->height;
		}
	}

#if BUILD_ORIENT
	/* Ashisuto added for SUN4+JAPANESE build. 95.09.14 */
	if ( input_method != (XIM)NULL )
		wEnterPixHeight(NULL, NULL, &itmp, &kanji_status_height);
#endif

	if ((NULL == eventP) && w->dialog && !w->frame) {
		/* we're here because of menubar POKE (called from
		 * ElfbRebuildDialog) - dialog shell may need resize 
		 * if toolbar window created/destroyed/resized.
		 */
		main_width = old_wid;
		main_height = bar_height + tool_height + old_hyt + 
			kanji_status_height;
		if (w->width!=main_width || w->height!=main_height) {
			if ( w->window ) {
				/* First update WM's knowledge of win's min & max size.
				 * (Some WM's don't allow resize if the size hints
				 * are not updated.)
				 */
				XSizeHints xsh;
				xsh.flags = (PSize | PMinSize | PMaxSize);
				if (AxProgramSpecifiedWindowPos) {
					xsh.flags |= PPosition;
				}
				else {
					xsh.flags |= USPosition;
				}
				xsh.x = w->xpos;
				xsh.y = w->ypos;
				xsh.width = main_width;
				xsh.height = main_height;
				if (w->dialog->variable_size) {
					xsh.min_width = w->minWidth;
					xsh.min_height = w->minHeight;
					if (w->maxWidth)
						xsh.max_width = w->maxWidth;
					else
						xsh.max_width = w->maxWidth = DpyWid;
					if (w->maxHeight)
						xsh.max_height = w->maxHeight;
					else
						xsh.max_height = w->maxHeight = DpyHt;
				}
				else {
					xsh.min_width = xsh.max_width = xsh.width;
					xsh.min_height = xsh.max_height = xsh.height;
				}
				AxSetWindowProperties(Dpy, w->window, w, w->name,
									  w->wstr, w->style, &xsh);
				/* resize W_MAIN window */
				XResizeWindow(Dpy, w->window, main_width, main_height);
				AxMapWindow(w, Dpy, w->window,w->name);
				/* XResizeWindow generates a ConfigureNotify 
				 * event - rebuild dialog shell at that time */
				return;
			}
		}
	}
	
	main_width = w->width;
	main_height = w->height;
	
	work_width = MAX(30, w->width-vsc_width-palt_width);
	msg_pos = palt_width;
	if ( w->debug ) {
		dbg_height = DEBUG_THICK;
	}
	
	if ( w->ge_yruler && w->ge_yruler->display ) {
		ge_yruler_width = GE_YRULER_WIDTH;
		ge_yruler_height = work_height;
	}
	if ( w->ge_xruler && w->ge_xruler->display ) {
		ge_xruler_width = work_width;
		ge_xruler_height = GE_XRULER_HEIGHT;
	}
	
#if BUILD_ORIENT
	if ( w->kanji_status ) {
#if BUILD_KANJI && SUN4 && !USE_XIM
		old_kanji_status_width = w->kanji_status->width;
#endif
		kanji_status_width = work_width;
	}
#endif
	
	if ( w->colorpal && w->colorpal->display ) {
		colorpal_width = work_width + vsc_width;
		colorpal_height = COLORPAL_HEIGHT;
		main_height -= colorpal_height;
	}
	
	page_wid = 0;
	if ( w->pageBar )
		page_wid = GE_PAGE_WIDTH;
	
	if ( w->hScrollBar ) {
		if ( is_ge ) {
			msg_width = GE_MSG_WIDTH;
		}
		else {
			msg_width = MSG_WIDTH;
		}
		hsc_width = work_width - msg_width - page_wid;
		hsc_pos = msg_pos + msg_width + page_wid;
	}
	else {
		msg_width = work_width;
	}
	buton_hyt = 0;
	vsc_xpos = work_width + palt_width;
	vsc_ypos = bar_height + ruler_height + tool_height + plates_height;
	if ( w->butonBar )
		buton_hyt = w->butonBar->height;
	
	if ( w->menuBar && !(w->dialog && w->dialog->topmostwindow) ) {
		w->menuBar->width = bar_width;
		if (w->menuBar->window)
			XResizeWindow(Dpy,w->menuBar->window,bar_width,bar_height);
		ShiftHelpRightMost(w->menuBar);
	}

	if (w->workWindow) {
		w->workWindow->width = work_width - 2*WindowBorder;
		work_height = MAX(30,main_height - 
						  bar_height -
						  tool_height -
						  msg_height -
						  ruler_height -
						  kanji_status_height -
						  dbg_height - 
						  plates_height);

		w->workWindow->height = work_height - 2*WindowBorder;
		if (w->workWindow->window) {
			XMoveResizeWindow
				(Dpy,w->workWindow->window,
				 palt_width,
				 bar_height+ruler_height+tool_height+plates_height, 
				 w->workWindow->width,w->workWindow->height);
		}
		FrameAppFromXWinId(w->workWindow->window,
						   w->workWindow->width,w->workWindow->height);
	}
	msg_ypos = bar_height + tool_height + ruler_height + dbg_height +
		work_height + plates_height +
			kanji_status_height;
	
	if ( w->ruler ) {
		ruler_ypos = bar_height + tool_height;
		if ( !w->ruler->window ) { /* just turned on now */
			w->ruler->xpos = 0;
			w->ruler->ypos = ruler_ypos;
			w->ruler->width = ruler_width;
			w->ruler->height = ruler_height;
			w->ruler->window = AxCrtWindow(Dpy,w->window,
										   0, w->ruler->ypos,
										   w->ruler->width, w->ruler->height,
										   0,CopyFromParent,InputOutput,
										   CopyFromParent,WinMask,&WinAtt);
			XSelectInput(Dpy, w->ruler->window, TM_ALL_INPUTS_MASK);
			AxMapWindow(w, Dpy, w->ruler->window,w->name);
			w->ruler->mapped = TRUE;
		}
		else if ( (main_width != w->ruler->width) || 
				 (w->ruler->ypos != ruler_ypos) ) {
			w->ruler->width = main_width;
			w->ruler->ypos = ruler_ypos;
			XMoveResizeWindow(Dpy,w->ruler->window,
							  w->ruler->xpos,w->ruler->ypos,
							  w->ruler->width,w->ruler->height);
		}
	}
	if ( w->plates ) {
		plates_ypos = bar_height + tool_height;
		if ( !w->plates->window ) {	/* just turned on now */
			w->plates->xpos = 0;
			w->plates->ypos = plates_ypos;
			w->plates->width = plates_width;
			w->plates->height = plates_height;
			w->plates->window = AxCrtWindow(Dpy,w->window,
											0, w->plates->ypos,
											w->plates->width,
											w->plates->height,
											0,CopyFromParent,InputOutput,
											CopyFromParent,WinMask,&WinAtt);
			XSelectInput(Dpy, w->plates->window, TM_ALL_INPUTS_MASK);
			AxMapWindow(w, Dpy, w->plates->window,w->name);
			w->plates->mapped = TRUE;
		}
		else if ( (main_width != w->plates->width) || 
				 (w->plates->ypos != plates_ypos) ) {
			w->plates->width = main_width;
			w->plates->ypos = plates_ypos;
			XMoveResizeWindow(Dpy,w->plates->window,
							  w->plates->xpos,w->plates->ypos,
							  w->plates->width,w->plates->height);
		}
	}
	if ( w->toolBar ) {
		if ( tool_height == 0 ) { /* No bar needed */
			if ( w->toolBar->window ) { /* take away old one */
				AxDestroyWindow(Dpy, w->toolBar, w->toolBar->window);
				w->toolBar->window = (Window)NULL;
			}
		}
		else {
			AXWidget_main mw = (AXWidget_main) w;
			w->toolBar->xpos = palt_width;
			w->toolBar->ypos = bar_height;
			if (mw->dialog && mw->frame) {
				w->toolBar->xpos += mw->dialog->xpos;
			}
			if ( !w->toolBar->window ) { /* create toolbar window */
				if ( w->window && w->toolBar->display ) { /* toolbar needed */
					w->toolBar->window = 
						AxCrtWindow(Dpy, w->window,
									w->toolBar->xpos, w->toolBar->ypos,
									w->toolBar->width, w->toolBar->height,
									0,CopyFromParent,InputOutput,
									CopyFromParent,WinMask,&WinAtt);
					XSelectInput(Dpy, w->toolBar->window, TM_ALL_INPUTS_MASK);
					AxMapWindow(w, Dpy, w->toolBar->window,w->name);
					w->toolBar->mapped = TRUE;
				}
			}
			else { /* adjust toolbar window (wid/hyt set in AxToolBarHeight) */
				XMoveResizeWindow(Dpy,w->toolBar->window,
								  w->toolBar->xpos, w->toolBar->ypos,
								  w->toolBar->width, w->toolBar->height);
			}
		}
	}
	if ( w->corner ) {
		if ( !w->corner->window ) {
			w->corner->xpos = w->width-16;
			w->corner->ypos = main_height-16;
			w->corner->width = 16;
			w->corner->height = 16;
			w->corner->window = AxCrtWindow(Dpy,w->window,
											w->corner->xpos, w->corner->ypos,
											w->corner->width,
											w->corner->height,
											0,CopyFromParent,InputOutput,
											CopyFromParent,WinMask,&WinAtt);
			XSelectInput(Dpy, w->corner->window, TM_ALL_INPUTS_MASK);
			AxMapWindow(w, Dpy, w->corner->window,w->name);
			w->corner->mapped = TRUE;
		}
		else {
			w->corner->xpos = w->width-16;
			w->corner->ypos = main_height-16;
			XMoveResizeWindow(Dpy,w->corner->window,
							  w->corner->xpos, w->corner->ypos,
							  w->corner->width, w->corner->height);
		}
	}
	if ( w->debug ) {
		w->debug->xpos = 0;
		w->debug->ypos = bar_height+ruler_height+work_height+tool_height;
		w->debug->height = dbg_height;
		w->debug->width = main_width;
		if ( !w->debug->window ) { /* just turned on now */
			w->debug->window = AxCrtWindow(Dpy,w->window,
										   w->debug->xpos, w->debug->ypos,
										   w->debug->width, w->debug->height,
										   0,CopyFromParent,InputOutput,
										   CopyFromParent,WinMask,&WinAtt);
			XSelectInput(Dpy, w->debug->window, TM_ALL_INPUTS_MASK);
			AxMapWindow(w, Dpy, w->debug->window,w->name);
			w->debug->mapped = TRUE;
		}
		else {
			XMoveResizeWindow(Dpy,w->debug->window,
							  w->debug->xpos, w->debug->ypos,
							  w->debug->width, w->debug->height);
		}
	}
	if ( w->palette ) {
		if ( !w->palette->display ) {
			for(childP=w->palette->widgets; childP; childP=childP->nextChild) {
				if ( childP->window ) {
					AxDestroyWindow(Dpy, childP, childP->window);
					childP->window = (Window)NULL;
				}
			}
			if ( w->palette->window ) {
				AxDestroyWindow(Dpy,w->palette,w->palette->window);
				w->palette->window = (Window)NULL;
			}
		}
		else if ( main_height+colorpal_height-bar_height-ruler_height !=
				 w->palette->height ||
				 palt_width != w->palette->width ) {
			w->palette->xpos = 0;
			w->palette->ypos = bar_height + ruler_height;
			w->palette->width = palt_width;
			w->palette->height = main_height +
				colorpal_height -
					bar_height -
						ruler_height;
			if ( w->palette->window ) {
				XResizeWindow(Dpy,w->palette->window,
							  w->palette->width, w->palette->height);
				XFillRectangle(Dpy,w->palette->window,BackGC,0,0,
							   w->palette->width, w->palette->height);
			}
        }
    }
	if ( w->ge_xruler ) {
		if ( !w->ge_xruler->display ) {
			if (w->ge_xruler->window)
				AxDestroyWindow(Dpy, w->ge_xruler, w->ge_xruler->window);
			w->ge_xruler->window = (Window)NULL;
			w->ge_xruler->xpos = -1;
		}
		else {
			w->ge_xruler->value = 0;
			w->ge_xruler->width = work_width;
			w->ge_xruler->height = GE_XRULER_HEIGHT;
			w->ge_xruler->xpos = palt_width;
			w->ge_xruler->ypos = main_height -
				SCROLLBAR_THICK -
					kanji_status_height -
						GE_XRULER_HEIGHT;
			if ( !w->ge_xruler->window ) {
				if ( w->ge_xruler->display ) {
					w->ge_xruler->window = AxCrtWindow(Dpy,w->window,
													   w->ge_xruler->xpos,
													   w->ge_xruler->ypos,
													   w->ge_xruler->width,
													   w->ge_xruler->height,
													   0, CopyFromParent,
													   InputOutput,
													   CopyFromParent,
													   WinMask,&WinAtt);
					XSelectInput(Dpy, w->ge_xruler->window,
								 TM_ALL_INPUTS_MASK);
					AxMapWindow(w, Dpy, w->ge_xruler->window,w->name);
					w->ge_xruler->mapped = TRUE;
				}
			}
			else {
				XMoveResizeWindow(Dpy,
								  w->ge_xruler->window,
								  w->ge_xruler->xpos,
								  w->ge_xruler->ypos,
								  w->ge_xruler->width,
								  w->ge_xruler->height);
				AxMapWindow(w, Dpy, w->ge_xruler->window, w->name);
			}
		}
	}
	if ( w->ge_yruler ) {
		if ( !w->ge_yruler->display ) {
			if (w->ge_yruler->window)
				AxDestroyWindow(Dpy, w->ge_yruler, w->ge_yruler->window);
			w->ge_yruler->window = (Window)NULL;
			w->ge_yruler->xpos = -1;
		}
		else {
			w->ge_yruler->value = 0;
			w->ge_yruler->width = GE_YRULER_WIDTH;
			w->ge_yruler->height = work_height - ge_xruler_height;
			w->ge_yruler->xpos = palt_width + work_width - ge_yruler_width;
			w->ge_yruler->ypos = bar_height + tool_height;
			if ( !w->ge_yruler->window ) {
				if ( w->ge_yruler->display ) {
					w->ge_yruler->window = AxCrtWindow(Dpy,w->window,
													   w->ge_yruler->xpos,
													   w->ge_yruler->ypos,
													   w->ge_yruler->width,
													   w->ge_yruler->height,
													   0, CopyFromParent,
													   InputOutput,
													   CopyFromParent,
													   WinMask,&WinAtt);
					XSelectInput(Dpy, w->ge_yruler->window,
								 TM_ALL_INPUTS_MASK);
					AxMapWindow(w, Dpy, w->ge_yruler->window,w->name);
					w->ge_yruler->mapped = TRUE;
				}
			}
			else {
				XMoveResizeWindow(Dpy,
								  w->ge_yruler->window,
								  w->ge_yruler->xpos,
								  w->ge_yruler->ypos,
								  w->ge_yruler->width,
								  w->ge_yruler->height);
				AxMapWindow(w, Dpy, w->ge_yruler->window, w->name);
			}
		}
	}
	
	if ( w->colorpal ) {
		if ( !w->colorpal->display ) {
			for(childP = w->colorpal->widgets; childP;
				childP = childP->nextChild) {
				
				if ( childP->window ) {
					AxDestroyWindow(Dpy, childP, childP->window);
					childP->window = (Window)NULL;
                }
            }
			
			if ( w->colorpal->window ) {
				AxDestroyWindow(Dpy, w->colorpal, w->colorpal->window);
				w->colorpal->window = (Window)NULL;
            }
        }
		else {
			w->colorpal->xpos = palt_width;
			w->colorpal->ypos = main_height;
			w->colorpal->width = colorpal_width;
			if (w->colorpal->window) {
				XMoveResizeWindow(Dpy,
								  w->colorpal->window,
								  w->colorpal->xpos,
								  w->colorpal->ypos,
								  w->colorpal->width,
								  w->colorpal->height);
            }

			for(childP = w->colorpal->widgets; childP;
				childP = childP->nextChild) {
				
				ribbonP = (AXWidget_ribbon)childP;
				sizeRibbons(w->colorpal->width, &total_width, &ribbon_width);
				ribbonP->width = total_width;
				ribbonP->scroll_per = ribbon_width;
				if(ribbonP->scroll_max-ribbonP->scroll_pos<ribbonP->scroll_per)
					ribbonP->scroll_pos = 0;
				if (ribbonP->window) {
					XResizeWindow(Dpy,
								  ribbonP->window, 
								  ribbonP->width,
								  ribbonP->height);
				}
				ribbonP->display = TRUE;
            }

			if (w->colorpal->window) {
				/* because of UnmapGravity */
				AxMapWindow(w, Dpy, w->colorpal->window, w->name);
			}
        }
    }
	if ( w->pageBar && w->pageBar->window ) {
		w->pageBar->width = page_wid;
		XMoveResizeWindow(Dpy,w->pageBar->window,
						  msg_pos, msg_ypos,
						  w->pageBar->width,SCROLLBAR_THICK);
		
		/* because of UnmapGravity */
		AxMapWindow(w, Dpy, w->pageBar->window,w->name);
	}
	if ( w->statusArea && w->statusArea->window ) {
		w->statusArea->width = msg_width;
		XMoveResizeWindow(Dpy,w->statusArea->window,
						  msg_pos + page_wid, msg_ypos,
						  w->statusArea->width,SCROLLBAR_THICK);
		
		/* because of UnmapGravity */
		AxMapWindow(w, Dpy, w->statusArea->window,w->name);
	}
#if BUILD_ORIENT    /*  {  */
	if ( w->kanji_status && w->kanji_status->window ) {
		w->kanji_status->width = work_width;
		w->kanji_status->xpos = palt_width;
		w->kanji_status->ypos = main_height - msg_height - kanji_status_height;
		XMoveResizeWindow(Dpy, w->kanji_status->window,
						  w->kanji_status->xpos,         /* xpos  */
						  w->kanji_status->ypos,         /* ypos */
						  w->kanji_status->width, kanji_status_height );
		
#if SUN4S    /*  {  */
		if ( !w->useOnSpot && w->style != IC_MAIN ) {
			/* Ashisuto - do not let the Input Method's status line */
			/* display on the Applixware's mainmenu.   95.09.14 */
			/* As part of the HACK we must delete and re-create the input */
			/* context, since the current X input method always positions */
			/* things relative to the root window */
			if ( w->ic != (XIC)NULL ) {
				if ( w->ic == ICWhichHasFocus ){
					XUnsetICFocus( ICWhichHasFocus );
					ICWhichHasFocus = (XIC)NULL;
				}
				XDestroyIC( w->ic );
				w->ic = (XIC)NULL;
			}
			WinOfICFocus = 0;
			FindMainWidgetFromWindow( (Window)NULL ); /* passing a null will */
			/* clear any cahced id */
			if ( w->callback_data != (mbchar *)NULL ) {
				free( w->callback_data );
				w->callback_data = (mbchar *)NULL;
			}
			
			InitOffSpotIC( w ); /* re-create the IC */
		}
#endif    /*  }  SUN4S  */
#if HP800
		/* we must re-set the spot location to track the new location of */
		/*  the status window */
		ResetSpotLocation( w->window );
#endif
#if BUILD_KANJI && SUN4 && !USE_XIM
		/* Ashisuto added for SUN4+JAPANESE build. 95.09.14 */
		if (w->ic && w->inWideInput) {
			AXWidget preedit_w = (AXWidget)w->ic->entry_widget;
			if (preedit_w && preedit_w->window) {
				preedit_w->width += work_width - old_kanji_status_width;
				XResizeWindow(Dpy, preedit_w->window,
							  preedit_w->width - 8, preedit_w->height - 6);
			}
		}
#endif
	}
#endif    /*  }  BUILD_ORIENT  */
        
	if ( w->hScrollBar && w->hScrollBar->window ) {
		w->hScrollBar->width = hsc_width;
		XMoveResizeWindow(Dpy, w->hScrollBar->window,
						  hsc_pos, msg_ypos,
						  hsc_width, SCROLLBAR_THICK);

		/* because of UnmapGravity */
		AxMapWindow(w, Dpy, w->hScrollBar->window,w->name);
	}
	
	if ( w->butonBar && w->butonBar->window ) {
		XMoveResizeWindow(Dpy,w->butonBar->window,
						  vsc_xpos, vsc_ypos,
						  w->butonBar->width,w->butonBar->height);

		/* because of UnmapGravity */
		AxMapWindow(w, Dpy, w->butonBar->window,w->name);
	}
	
	if ( w->vScrollBar && w->vScrollBar->window ) {
										/* work_height is already adjusted for*/
										/* kanji_status_height				  */
		w->vScrollBar->height = work_height - buton_hyt; /* 6Aug98digrazia */
		XMoveResizeWindow( Dpy, w->vScrollBar->window,
						  vsc_xpos, vsc_ypos +buton_hyt,
						  SCROLLBAR_THICK, w->vScrollBar->height);

		/* because of UnmapGravity */
		AxMapWindow(w, Dpy, w->vScrollBar->window,w->name);
	}
	if ( w->dialog ) {

		if ( w->frame ) {

			AxXtDestroyWidget(w->dialog->hScrollBar);
			AxXtDestroyWidget(w->dialog->vScrollBar);
			w->dialog->hScrollBar = (AXWidget_scroll)0;
			w->dialog->vScrollBar = (AXWidget_scroll)0;

			w->frame->width = w->width-SCROLLBAR_THICK;
			w->frame->height = w->height-SCROLLBAR_THICK;
	
			AxmCreateDlgFrame(w, w->dialog);

			w->dialog->ypos = bar_height + tool_height - w->dialog->scroll_pos;
			if (w->dialog->window) {
				XMoveWindow(Dpy, w->dialog->window,
							w->dialog->xpos, w->dialog->ypos);
			}
			
			/* reposition the scroll bars */
			if (w->dialog->vScrollBar) {
				w->dialog->vScrollBar->scroll_pos = w->dialog->scroll_pos;
				PaintScrollBar(w->dialog->vScrollBar,NULL, FALSE, FALSE);
			}
			if (w->dialog->hScrollBar) {
				w->dialog->hScrollBar->scroll_pos = w->dialog->hscroll_pos;
				PaintScrollBar(w->dialog->hScrollBar,NULL, FALSE, FALSE);
			}
		}
		else {
			w->dialog->ypos =  bar_height + tool_height;
			w->dialog->width = w->width;
			w->dialog->height = main_height - w->dialog->ypos;
		
#if BUILD_ORIENT
			/* Here we had to put the status area of Input Method
		 	* into proper position */
			if (w->kanji_status && w->kanji_status->window) {
				w->kanji_status->ypos =
					main_height - kanji_status_height;
				XMoveWindow(Dpy, w->kanji_status->window,
							w->kanji_status->xpos,
							w->kanji_status->ypos);
			}
			w->dialog->height = w->dialog->height - kanji_status_height;
#endif
			
			if (w->dialog->window) {
				XMoveResizeWindow(Dpy, w->dialog->window, w->dialog->xpos,
							  	w->dialog->ypos, w->dialog->width,
							  	w->dialog->height);
				AxMapWindow(w, Dpy, w->dialog->window,w->name);
			}
			if ( w->dialog->variable_size &&
				(w->dialog->width != old_wid ||
				 w->dialog->height != old_hyt) ) {
				
				data_ptr aP;
				int dlgWid, dlgHt;
           	 
				if (w->dialog->noExpand) {
					dlgWid = w->dialog->width;
					dlgHt = w->dialog->height;
				}
				else {
					dlgWid = axDlgUnscaleX(w->dialog->width,
										   w->dialog->referenceFont);
					dlgHt = axDlgUnscaleY(w->dialog->height,
										  w->dialog->referenceFont);
				}
				
				aP = AxMakeArray(2);
				AxAddIntToArray(aP, 0, dlgWid);
				AxAddIntToArray(aP, 1, dlgHt);
				if ( !w->elfObject ) {
					w->elfObject = AxTaskCopyElfData(0, w->dialog->elfObject);
				}
				CallWidget(w->taskOwner,w,EV_DLG_RESIZED_,aP);
			}
		}
	}
}

/*************************************************************************
function: AXmUpdateDialogSize - Update dialog width/height.
Called when dialog reposted.

Variable sized dialogs not updated because that may lead to timing issues
(if user resizes window before macro reposts in response to callback from
this update).  Solution is to avoid callback in RebuildMainWindow if resize
originated here, but cannot do that because there is no easy way of
determing whether user or macro originated resize.  Needs more thought.
Biggest problem so far: On OpenWindows, maybe other WM's too, cannot rebuild
dialog till we receive ConfigureNotify from W_MAIN resize.  XSync after
W_MAIN resize doesn't help.  If we can get around this, all we have to do
is resize menubar, toolbar and dialog here without callback.

Nov 10, 1992 - Zane removed varible_size constraint... let's see what happens
*/
AXmUpdateDialogSz(w, x,y, wid,hyt, type)
     AXWidget_main w;
     int x,y, wid,hyt, type;
{
  int main_wid, main_hyt;
  int bar_wid, tool_wid;
  int bar_hyt, tool_hyt;
  static XSizeHints xsh;
#if BUILD_ORIENT
  int kanji_status_height = 0, itmp;
#endif

  /* do we have the correct widget? */
  if ( !w || w->type != W_MAIN || !w->dialog )
    return;
  if ( !w->window || !w->dialog->window )
    return;

  /* update WM hints (some WM's don't allow resize if hints not updated) */
  type = (type > 2) ? 0 : type;
  xsh.flags = 0;
  if ( type != 1 && wid > 0 && hyt > 0 )
    {
      if ( w->dialog->width == wid && w->dialog->height == hyt )
    {
      if ( type == 0 )
        return;
      else
        type = 1;
    }
      else
    {
      /* calculate new size info for main window */
      if ( !w->menuBar || (w->dialog && w->dialog->topmostwindow) )
        bar_wid = bar_hyt = 0;
      else
        {
          bar_wid = MAX(30, wid);
          bar_hyt = w->menuBar->height;
        }
      if ( !w->toolBar )
        tool_wid = tool_hyt = 0;
      else
        {
          tool_wid = bar_wid;
          tool_hyt = AxToolBarHeight(w, tool_wid);
        }
      main_wid = wid;
      main_hyt = bar_hyt + tool_hyt + hyt;

#if BUILD_ORIENT
      if ( input_method != (XIM)NULL )
        wEnterPixHeight(NULL, NULL, &itmp, &kanji_status_height);
      main_hyt += kanji_status_height;
#endif

      /* set the properties */
      xsh.flags |= PSize|PMinSize|PMaxSize;
      xsh.width = main_wid;
      xsh.height = main_hyt;
      if ( w->dialog->variable_size )
        {
          xsh.min_width = w->dialog->minWidth;
          xsh.min_height = w->dialog->minHeight;
          if (w->dialog->maxWidth)
        xsh.max_width = w->dialog->maxWidth;
          else
        xsh.max_width = w->dialog->maxWidth = DpyWid;
          if (w->dialog->maxHeight)
        xsh.max_height = w->dialog->maxHeight;
          else
        xsh.max_height = w->dialog->maxHeight = DpyHt;
        }
      else
        {
          xsh.min_width = xsh.max_width = xsh.width;
          xsh.min_height = xsh.max_height = xsh.height;
        }
    }
    }
  if ( type != 0 )
    {
      xsh.flags |= PPosition;
      xsh.x = x;
      xsh.y = y;
    }
  AxSetWindowProperties(Dpy, w->window, w,
            w->name, w->wstr, w->style, &xsh);

  /* do it (generates ConfigureNotify - rebuild dialog shell then) */
  if ( type == 2 )
    XMoveResizeWindow(Dpy, w->window, x,y, main_wid,main_hyt);
  else if ( type == 1 )
    XMoveWindow(Dpy, w->window, main_wid,main_hyt);
  else
    XResizeWindow(Dpy, w->window, main_wid,main_hyt);
  AxMapWindow(w, Dpy, w->window,w->name);
}


/*************************************************************************
function: AXmCreateMainWindow - Create main window in main shell object
*/
AXWidget AXmCreateMainWindow (w,name,args,cnt)
     register AXWidget w;
     register Arg args[];
     register int cnt;
{
  AxXtSetValues(w,args,cnt);
  return((AXWidget)w);
}



/*************************************************************************
function: WidgetOfFocusWindow - Return the widget that has the focus
If the widget is a transient dialog, return its parent. This is needed
because the callers in tmx.c and elf_xwins.c cannot expect transient
parents.
*/
AXWidget
WidgetOfFocusWindow ()
{
  register AXWidget bp;

  for ( bp = WindowList; bp; bp = bp->nextWin ) {
    if ( bp->window == ThimFocusWindow ) {
      if ( (bp->type == W_MAIN) && ((AXWidget_main)bp)->dialog ) {
    while ( (bp->type == W_MAIN) && ((AXWidget_main)bp)->dialog &&
        !bp->notTransient && bp->parent )
      bp = (AXWidget)bp->parent;
      }
      return((AXWidget)bp);
    }
  }
  return((AXWidget)WindowList);   /* sanity in case window is gone */
}


/*************************************************************************
function: ZXmRePaintMenuBar - Recompute menu bar
Used by DC->SG, SG->DC transition to get/remove Templates Menu
*/
ZXmRePaintMenuBar (wid)
     int wid;        /* ATM window id of shell window */
{
  register AXWidget_main w;

  if ( wid <= 0 )
    return;
  w = (AXWidget_main)WidgetOfWindow(wid);
  if ( !w )
    return;
  if ( !w->menuBar || (w->dialog && w->dialog->topmostwindow) )
    return;
  ComputeMenuBarWidth(w->menuBar,TRUE);
  PaintMenuBar(w->menuBar,NULL,TRUE,TRUE);
}



/*************************************************************************
function: PaintStatus - Handle exposure to status area
*/
void
PaintStatus (w, exP, regen, layered)
     AXWidget w;
     XExposeEvent *exP;
     int regen;
     int layered;
{
  register void (*func)();
  register AXWidget childP;

  if ( !w->window )
    return;

  if ((w->flags & WFLG_IN_EDIT) && layered) {
    if(dePaintWidget(w))
      return;
  }

  /* draw rect */
    
  AxDrawBevel(w, w->window, w->xpos, w->ypos,
          w->width, w->height, 2, BEVEL_IN);

  /* repaint embedded text */

  UpdateStatusMessage(w);
}

AXWidget 
AXmCreateOptionMenu (w,name,args,cnt)
     register AXWidget w;
     register char *name;
     register Arg args[];
     register int cnt;
{
  register int ix;

  /*
    This is logically regarded as a child of the pulldown, so find
    and set attrs of the pulldown.
    */
  for ( ix = 0; ix < cnt; ix++ ) {
    if ( args[ix].name == XmNsubMenuId ) {
      w = (AXWidget)args[ix].value;
      break;
    }
  }
  AxXtSetValues(w,args,cnt);
  return((AXWidget)w);
}
AXWidget
AXmOptionLabelGadget (w)
     register AXWidget w;
{
  return((AXWidget)w);
}
AXWidget
AXmOptionButtonGadget (w)
     register AXWidget w;
{
  return((AXWidget)w);
}



/*************************************************************************
function: AxXmDialogList - Return titles of all dialogs
( called from ElfbDBList() )
*/
     void
     AxXmDialogList(char **names)
{
#define MAX_NUM_DIALOGS 1024    /* same as in elb.c */
  AXWidget w;
  int cnt = 0;

  for ( w = WindowList; w; w = w->nextWin ) {
    if ( (w->type == W_MAIN) && ((AXWidget_main)w)->dialog ) {
      if ( cnt >= MAX_NUM_DIALOGS )
    break;
      names[cnt] = (char *) malloc(MBstrlen(w->name) + 1);
      MBstrcpy(names[cnt++], w->name);
    }
  }
}

/*************************************************************************
function: ParentWinOfWidget - Given a widget, find parent window
This is line the WIN_OF macro but allows app windows to regard the
root window as the parent.
*/
static Window ParentWinOfWidget (w)
     AXWidget_main w;
{
  if ( w->type == W_MAIN )
    return(RootWin);
  return(WIN_OF(w));
}

/*************************************************************************
function: RepaintDialog - Update paint
*/
RepaintDialog (w, exP, regen, layered)
     register AXWidget_dialog w;
     register XExposeEvent *exP;
     int regen;
     int layered;
{
  static XSizeHints xsh;

  if ( !w->exposed ) {    /* make sure on top & focus when created */
    XGetSizeHints(Dpy,w->window,&xsh,XA_WM_NORMAL_HINTS);
    AxSetWindowProperties(Dpy, w->window, w, w->name,
              MbToWOneStr(w->name), 
              w->style, &xsh);
    XRaiseWindow(Dpy,w->window);
    /* don't set input focus for stand-alone dialogs, for example: 
     * main menu, directory displayer, mail, etc. */
    if ( w->parent && !w->parent->menuBar ) { /* menubar child of W_MAIN */
      AXSetInputFocus(w->window, FALSE, CurrentTime);
      xmDialogFocus(w, TRUE);
    }
  }
  w->exposed = TRUE;
  AXmExposeChildren(w,exP,regen,layered);
}



/***************************************************************************/
/* IF YOU CHANGE SOMETHING IN THIS FUNCTION, MAKE SURE THE EQUIVALENT      */
/* CHANGE IS MADE IN THE FUNCTION WXDestroyWidget (winwidgt.c) IF NOT SURE */
/* HOW, ASK jon or donato.                           -donato               */
/***************************************************************************
function: AxXtDestroyWidget - Destroy a widget and its children
Keeps menu bar window intact until the main window goes away.
This is required because the sofware is able to re-create the menu
bar on the fly - involving calling AxXtDestroyWidget.
*/
void AxXtDestroyWidget (w)
     AXWidget w; 
{
  register int ix;
  Window win=None;
  int inEdit;
  int pixWindow;
  int wasObject;  /* if TRUE, was created by the object model */
  register AXWidget childP, next;
  AXWidget_dialog wd;
  AXWidget_main mw;
  AXWidget_list w_list;
  AXWidget_menu w_menu;
  AXWidget_tool w_tool;
  AXWidget_radio w_radio;
  AXWidget_entry w_enter;
  AXWidget_popup w_popup;
  AXWidget_option w_option;
  AXWidget_canvas w_canvas;
  AXWidget_dialog w_dialog;
  AXWidget_rowcol w_rowcol;
  AXWidget_ribbon w_ribbon;
  AXWidget_buttonbar w_butbar;
  AXWidget_pushbutton w_button;
  AXWidget_color_chooser w_choose;
  AXWidget_tray w_tray;
  AXWidget_scroll w_scroll;
  AXWidget_kanji w_kanji;
  AXWidget_entry w_kana;
  AXWidget_combo_box w_cbox;
  AXWidget_editbox w_editbox;
  AXWidget_rect w_rect;

  if ( !w ) {
    return;
  }

  if ( w->destroyed )
    return;      /* !! just touched dead memory */
    
  w->destroyed = TRUE;
    
  inEdit = (w->flags & WFLG_IN_EDIT); /* true under dialog editor */
  if (inEdit) {
    deRemoveFromSession(w);
  }
  pixWindow = (inEdit && (W_DIALOG == w->parent->type));
    
  deleteWlayer(w->parent, w); /* from back-to-front position list */

  /* Unthread for total widgets list */
  if ( w->next )
    w->next->prev = w->prev;
  if ( w->prev )
    w->prev->next = w->next;
  if ( TotalWidgetsList == w )
    TotalWidgetsList = w->next;

  NumWidgets--;

  RemoveWidgetFromParent(w);
  if ( w->window ) {
    win = w->window;
    w->window = (Window)NULL;
  }

  if ( w->font ) {
    FreeFontInCache(w->font);
    w->font = NULL;
  }
    
  if (w->db_uid) {
    if (w->parent && w->parent->type == W_DIALOG) {
      w_dialog = (AXWidget_dialog) w->parent;
      if (w_dialog->uidWidgets) {
    axhTossItemI((void *) &w->db_uid, sizeof(int),
             w_dialog->uidWidgets, (char *) NULL);
      }
    }
  }
    
  if (w->tabctl_linktab) {
    axhDeleteTable(w->tabctl_linktab, (void *) TRUE);
    free(w->tabctl_linktab);
    w->tabctl_linktab = (axhtab *) NULL;
  }
  if (w->keyFocusLinks) {
	  free(w->keyFocusLinks);
	  w->keyFocusLinks = NULL;
  }

  /* event_table and aux data currently used for widget editing */
  if (w->event_table)
    xmRemoveAllEventHandlers(w);
  if (w->auxData)
    removeAuxData(w);

  if ( w->elfObject ) {
    char *ov_name;
    elf_obj_grp *ov, *ElfObjData();

    ov_name = NXLT("WIDGET_PTR$$");
    ov = ElfObjData(ElfObjPtr(w->elfObject), ov_name, hash(ov_name));

    if (ElfbIsArray(ov->value) &&
    (w == WidgetPointerFromHandleData(ReadArray(ov->value,0)))) {
      ;    /* skip first element in 2-object widgets, free later */
    }
    else {
      AxTaskFreeElfData(0,ov->value);
      ov->value = NULL;
    }

    /* free's the ref, not the object */
    AxTaskFreeElfData(0,(char*)w->elfObject);
    w->elfObject = NULL;
    wasObject = TRUE;
  }
  else
    wasObject = FALSE;

  if (w->type != W_MAIN) /* W_MAIN uses w->name.  It will free it */
    FreeWidgetName(w);

  if (w->shadow)
    AxTaskFreeElfData(0, w->shadow);
  w->shadow = NULL;

  if (w->textShadow)
    AxTaskFreeElfData(0, w->textShadow);
  w->textShadow = NULL;

  if (w->textColor)
    AxFreeWColor(w->textColor);
  w->textColor = NULL;

  if (w->widgetColor)
    AxFreeWColor(w->widgetColor);
  w->widgetColor = NULL;

  if (w->graphic)
    AxDestroyAssociatedGraphic(w->graphic);
  w->graphic = NULL;

  if (w->rminfo)
    xmDestroyRmInfo(w->rminfo);
  w->rminfo = NULL;

  switch ( w->type ) {

  case W_MAIN:
    mw = (AXWidget_main)w;
    AxDelNoMapWindow(mw->name);
    FreeWidgetName(mw);
    ClipFromWindowList(mw);
    AxXtDestroyWidget(mw->workWindow);
    AxXtDestroyWidget(mw->menuBar);
    AxXtDestroyWidget(mw->toolBar);
    AxXtDestroyWidget(mw->vScrollBar);
    AxXtDestroyWidget(mw->hScrollBar);
    AxXtDestroyWidget(mw->corner);
    AxXtDestroyWidget(mw->statusArea);
    AxXtDestroyWidget(mw->pageBar);
    AxXtDestroyWidget(mw->butonBar);
    AxXtDestroyWidget(mw->palette);
    AxXtDestroyWidget(mw->colorpal);
    AxXtDestroyWidget(mw->debug);
    AxXtDestroyWidget(mw->ruler);
    AxXtDestroyWidget(mw->plates);
    AxXtDestroyWidget(mw->dialog);
    AxXtDestroyWidget(mw->frame);
	mw->frame = (AXWidget) 0;
    AxXtDestroyWidget(mw->ge_xruler);
    AxXtDestroyWidget(mw->ge_yruler);
#if BUILD_ORIENT
    AxXtDestroyWidget(mw->kanji_status);
    if ( mw->ic != (XIC)NULL )
      {
    if ( mw->ic == ICWhichHasFocus )
      {
        XUnsetICFocus( ICWhichHasFocus );
        ICWhichHasFocus = (XIC)NULL;
      }
    XDestroyIC( mw->ic );
    mw->ic = (XIC)NULL;
      }
#if HP800
    if ( mw->im != (XIM)NULL )
      {
    XCloseIM( mw->im );
    mw->im = (XIM)NULL;
      }
#endif
    WinOfICFocus = 0;
    /* passing a null will clear any cahced window id */
    FindMainWidgetFromWindow( (Window)NULL );  

    if ( mw->callback_data != (mbchar *)NULL )
      {
    free( mw->callback_data );
    mw->callback_data = (mbchar *)NULL;
      }
#endif
    free(mw->wstr);
    if (mw->iconPixmap) {
      XFreePixmap(Dpy, mw->iconPixmap);
    }
    free(mw);
    break;
  case W_DIALOG:
    wd = (AXWidget_dialog)w;
    AxXtDestroyWidget(wd->hScrollBar);
    AxXtDestroyWidget(wd->vScrollBar);
	wd->hScrollBar = (AXWidget_scroll)0;
	wd->vScrollBar = (AXWidget_scroll)0;
    DestroyDialog(w, wasObject);
    break;
  case W_GE_XRULER:
  case W_GE_YRULER:
    ClipFromWindowList(w);
    free(w);
    break;
  case W_COLORPAL:
  colorpal_start_again:
  for ( childP = w->widgets; childP; childP = next ) {
    next = childP->nextChild;
    /* let list box (if an) destroy scroll bars */
    if (childP->type != W_SCROLL) {
      AxXtDestroyWidget(childP);  /* recurse for child ribbons */
      goto colorpal_start_again;
    }
  }
  ClipFromWindowList(w);
  free(w);
  break;
  case W_RIBBON:
    w_ribbon = (AXWidget_ribbon)w;
  ribbon_start_again:
    for ( childP = w_ribbon->widgets; childP; childP = next ) {
      next = childP->nextChild;
      if ( childP->type == W_OPTION ) {
    AxXtDestroyWidget(childP);
    goto ribbon_start_again;
      }
    }
    free(w_ribbon->wstr);
    free(w_ribbon->selections);
    ClipFromWindowList(w_ribbon);
    free(w_ribbon);
    break;
  case W_LABEL:
  case W_TOGGLE:
    if ( w->helpstr )
      free(w->helpstr);
    if ( w == ToolArmedForUpdate )
      ToolArmedForUpdate = NULL;
    free(w);
    break;
  case W_BUTTON:
    w_button = (AXWidget_pushbutton)w;
    if ( w_button->alternatePixmap )
      free(w_button->alternatePixmap);
    if ( w_button->helpstr )
      free(w_button->helpstr);
    free(w_button);
    break;
  case W_TABLE:
    {
      register table_info *wt;
      AXWidget_table w_table;

      w_table = (AXWidget_table)w;
      wt = (table_info *) w_table->info.table;
      FreeTableInfo(wt);
      if (wt->fontFamily)
    free(wt->fontFamily);
      if (wt->cursor.wtext)
    free(wt->cursor.wtext);
      if (wt->selected_rows)
    free(wt->selected_rows);
      TblFreeGCs(w); /* requires `wt' */
      free(wt);
      AxXtDestroyWidget(w_table->vScrollBar);
      AxXtDestroyWidget(w_table->hScrollBar);
      ClipFromWindowList(w_table);
      if ( w_table->helpstr )
    free(w_table->helpstr);
      free(w_table);
    }
  break;
  case W_TRAY:
    {
      register tray_data *trayP;

      w_tray = (AXWidget_tray)w;
      trayP = (tray_data *) w_tray->info.tray;
      FreeTrayData(trayP);
      if (trayP)
    free(trayP);
      AxXtDestroyWidget(w_tray->vScrollBar);
      AxXtDestroyWidget(w_tray->hScrollBar);
      ClipFromWindowList(w_tray);
      if ( w_tray->helpstr )
    free(w_tray->helpstr);
      free(w_tray);
    }
  break;
  case W_CHOOSE:
    {
      register chooser_data *cP;

      w_choose = (AXWidget_color_chooser)w;
      cP = (chooser_data *) w_choose->info.color_chooser;
      if (cP) {
    FreeChooserData(cP);
      }
      cP = NULL;
      w_choose->info.color_chooser = NULL;
      AxXtDestroyWidget(w_choose->vScrollBar);
      AxXtDestroyWidget(w_choose->hScrollBar);
      ClipFromWindowList(w_choose);
      if ( w_choose->helpstr )
    free(w_choose->helpstr);
      free(w_choose);
    }
  break;
  case W_CANVAS:
    w_canvas = (AXWidget_canvas)w;
    free(w_canvas->info.canvas);
    AxXtDestroyWidget(w_canvas->vScrollBar);
    AxXtDestroyWidget(w_canvas->hScrollBar);
    ClipFromWindowList(w_canvas);
    if ( w_canvas->helpstr )
      free(w_canvas->helpstr);
    free(w_canvas);
    break;
  case W_LIST:
    w_list = (AXWidget_list)w;
    AxXtDestroyWidget(w_list->vScrollBar);
    AxXtDestroyWidget(w_list->hScrollBar);
    ClipFromWindowList(w_list);
    if (w_list->num_strs) {
      for ( ix = 0; ix < w_list->num_strs; ix++ )
    free(w_list->strs[ix]);
      free(w_list->strs);
      free(w_list->buttons);
      w_list->num_strs = 0;
    }
    if ( w_list->helpstr )
      free(w_list->helpstr);
    free(w_list->selections);
    if ( w_list->old_selections )
      free(w_list->old_selections);
    if (w_list->wapixmap) {
#if !USE_SYS_MAP
      XFreePixmap(Dpy, w_list->wapixmap);
#endif
      w_list->wapixmap = (Pixmap) NULL;
    }
    if (w_list->scroll_hist)
      free(w_list->scroll_hist);
    free(w_list);
    break;
  case W_SCROLL:
    w_scroll = (AXWidget_scroll)w;
    /* !! if changed here, change in AxXtSetValues too !! */
    ClipFromWindowList(w_scroll);
    if (w_scroll->wapixmap) {
      XFreePixmap(Dpy, w_scroll->wapixmap);
      w_scroll->wapixmap = (Pixmap) NULL;
    }
    free(w_scroll);
    break;
  case W_RADIO:
    w_radio = (AXWidget_radio)w;
    if (w_radio->parent->type != W_DIALOG) {
      for ( ix = 0; ix < w_radio->num_buttons; ix++ )
    AxXtDestroyWidget(w_radio->buttons[ix]);
    }
    free(w_radio->buttons);
    free(w_radio);
    break;
  case W_OPTION:  /* elements destroyed by DestroyDialog */
    w_option = (AXWidget_option)w;
    if ((w_option->parent->type != W_DIALOG) &&
    (w_option->parent->type != W_RULER)) {
      for ( ix = 0; ix < w_option->num_buttons; ix++ )
    AxXtDestroyWidget(w_option->buttons[ix]);
    }
    free(w_option->buttons);
    free(w_option);
    break;
  case W_ENTER:
    w_enter = (AXWidget_entry)w;
    ClipFromWindowList(w_enter);
    free(w_enter->wstr);
    free(w_enter->validChars);
	if (w_enter->edit_win.editmask) {
		DeleteEditMask(w_enter->edit_win.editmask);
	}
    free(w_enter);
    break;
  case W_ROWCOL:
    w_rowcol = (AXWidget_rowcol)w;
    if (w_rowcol->buttons && w_rowcol->num_buttons) {
      for (ix = 0; ix < w_rowcol->num_buttons; ix++) {
    FreeWidgetName(w_rowcol->buttons[ix]);
    if (w_rowcol->buttons[ix])
      free(w_rowcol->buttons[ix]);
      }
      free(w_rowcol->buttons);
    }
    if (w_rowcol->num_buttons && w_rowcol->strs) {
      for (ix = 0; ix < w_rowcol->num_buttons; ix++)
    if (w_rowcol->strs[ix])
      free(w_rowcol->strs[ix]);
      free(w_rowcol->strs);
    }
    free(w_rowcol);
    break;
  case W_COMBO_BOX:
    w_cbox = (AXWidget_combo_box)w;
	CbDestroyPulldown(w_cbox);
    if (w_cbox->num_buttons && w_cbox->strs) {
      for (ix = 0; ix < w_cbox->num_buttons; ix++)
    if (w_cbox->strs[ix])
      free(w_cbox->strs[ix]);
      free(w_cbox->strs);
    }
	if (w_cbox->edit_win.text) {
		free (w_cbox->edit_win.text);
	}
	if (w_cbox->edit_win.win) {
		if (pixWindow) {
			XFreePixmap(Dpy, w_cbox->edit_win.win);
		}
		else {
			AxDestroyWindow(Dpy, w_cbox, w_cbox->edit_win.win);
		}
		w_cbox->edit_win.win = (Window)NULL;
	}
    ClipFromWindowList(w_cbox);
    free(w_cbox);
    break;

  case W_MENUBAR:
    /* !! if changed here, change in AxXtSetValues under XXmNmenuBar !! */
    w_menu = (AXWidget_menu)w;
    if ( AxPulldownActive == w_menu )
      ResetActive();
    ClipFromWindowList(w_menu);
    if ( w_menu->unshared_menu_bar )
      free(w_menu->popups);
    free(w_menu->menu_strs);
    free(w_menu->menu_starts);
    free(w_menu);
    break;
  case W_TOOLBAR:
    w_tool = (AXWidget_tool)w;
#if 0
    for ( childP = w->widgets; childP; childP = next ) {
      next = childP->nextChild;
      AxXtDestroyWidget(childP);
    }
#else
    while (w_tool->widgets)
      AxXtDestroyWidget(w_tool->widgets); /* This call alters `w->widgets' */
#endif
    if ( w_tool->toolBarInfo ) {
      free(w_tool->toolBarInfo);
    }
    w_tool->parent->toolBar = NULL;
    ClipFromWindowList(w_tool);
    free(w_tool);
    break;
  case W_CORNER:
#if 0
    for ( childP = w->widgets; childP; childP = next ) {
      next = childP->nextChild;
      AxXtDestroyWidget(childP);
    }
#else
    while (w->widgets)
      AxXtDestroyWidget(w->widgets); /* alters `w->widgets' */
#endif
    w->parent->corner = NULL;
    ClipFromWindowList(w);
    free(w);
    break;
  case W_PLATES:
  case W_PALETTE:
  case W_DEBUG:
  debug_start_again:
  for ( childP = w->widgets; childP; childP = next ) {
    next = childP->nextChild;
    /* Let the list box do scroll-bar destroy */
    if (childP->type != W_SCROLL) {
      AxXtDestroyWidget(childP);
      goto debug_start_again;
    }
  }
  w->parent->debug = NULL;
  if(w->type == W_PLATES)
    w->parent->plates = NULL;
  ClipFromWindowList(w);
  free(w);
  break;
  case W_WORK:
    ClipFromWindowList(w);
    free(w);
    break;
  case W_POPUP:
    w_popup = (AXWidget_popup)w;
    for ( ix = 0; ix < w_popup->num_buttons; ix++ ) {
      FreeWidgetName(w_popup->buttons[ix]);
      free(w_popup->buttons[ix]);
    }
    free(w_popup->buttons);
    ClipFromWindowList(w_popup);
    XSync(Dpy,FALSE);
    free(w_popup);
    break;
  case W_STATUS:
    while (w->widgets)
      AxXtDestroyWidget(w->widgets); /* Alters `w->widgets' */
    w->parent->statusArea = NULL;
    ClipFromWindowList(w);
    free(w);
    break;
  case W_KANJI_STATUS:
    w_kanji = (AXWidget_kanji)w;
#if 0
    for ( childP = w->widgets; childP; childP = next ) {
      next = childP->nextChild;
      AxXtDestroyWidget(childP);
    }
#else
    while (w_kanji->widgets)
      AxXtDestroyWidget(w_kanji->widgets); /* Alters `w->widgets' */
#endif
    if ( w_kanji->kanjiStatusStr != (mbchar *)NULL )
      free(w_kanji->kanjiStatusStr);
    w_kanji->parent->kanji_status = NULL;
    ClipFromWindowList(w_kanji);
    free(w_kanji);
    break;
  case W_PAGEBAR:
    w->parent->pageBar = NULL;
    ClipFromWindowList(w);
    free(w);
    break;
  case W_BUTBAR:
    w_butbar = (AXWidget_buttonbar)w;
    for ( ix = 0; ix < w_butbar->num_buttons; ix++ ) {
      AxXtDestroyWidget(w_butbar->buttons[ix]);
    }
    free(w_butbar->buttons);
    w_butbar->parent->butonBar = NULL;
    ClipFromWindowList(w_butbar);
    free(w_butbar);
    break;
  case W_RULER:
    WpDestroyRulerWidget(w);
    break;
        
  case W_RECT:
    w_rect = (AXWidget_rect) w;
    if (w_rect->tabctl.num_layers) {
      tablayer *tl;
            
      for (ix = 0; ix < w_rect->tabctl.num_layers; ix++) {
    tl = &w_rect->tabctl.layerlist[ix];
    if (tl->layerName) {
      free(tl->layerName);
    }
    if (tl->gadget_uids) {
      AxTaskFreeElfData(0, tl->gadget_uids);
    }
      }
      free(w_rect->tabctl.layerlist);
    }
    free(w);
    break;
        
  case W_ICON:
  case W_ALIGN:
    free(w);
    break;
  case W_EDITBOX:
    w_editbox = (AXWidget_editbox)w;
    AxXtDestroyWidget(w_editbox->vScrollBar);
    destroyEditBox(w_editbox);
    ClipFromWindowList(w_editbox);
    free(w_editbox);
    break;
  case W_SPLITTER:
    free(w);
    break;
  case W_SCALE:
    free(w);  /* label destroyed by dialog */
    break;
#if SUN4 && !USE_XIM && BUILD_KANJI
      /* added by Ashisuto. Simulate W_ENTER, or it would not displayed since
       * the Entry Widget has been changed including an inner text area, and
       * the display of kanji_kana widget making use of drawing functions
       * of Entry Widgets.    1998.02.25
       */
  case W_KANJI_KANA:
    w_kana = (AXWidget_entry)w;
    if (w_kana->wstr) {
      TrueFree(w_kana->wstr);
      w_kana->wstr = NULL;
    }
    if (w_kana->validChars) {
      TrueFree(w_kana->validChars);
      w_kana->validChars = NULL;
    }
    while (w_kana->widgets)
      AxXtDestroyWidget(w_kana->widgets);
    ClipFromWindowList(w_kana);
    free(w_kana);
    break;
#endif
  case W_FRAME:
    ClipFromWindowList(w);
    free(w);
    break;
  default:
    tempAbort("widget error");
  }

  if ( win != None ) {
    if (pixWindow) {
      XFreePixmap(Dpy, win);
    }
    else {
      AxDestroyWindow(Dpy, (AXWidget ) NULL, win);
    }
  }
    
  AXmClearGlobalWidgetHandle(w);
}



#define BYTE_WIDTH(w)   (((w) + 15 >> 3) & ~1)


/*************************************************************************
function: HandleScrollBarAutoScroll - Auto scrolling for scroll bars
*/
static void
HandleScrollBarAutoScroll(w)
     AXWidget_scroll w;
{
  int doCallBack;
  XmScrollBarCallbackStruct data;

  if (AutoScrollState == AUTOSCROLL_NOTARMED)
    return;

  /* A widget that has `buttonUpScroll' is probably a slow widget.
     Hold off auto scroll for it -- Helpful for the GE main window. */
  if (w->buttonUpScroll)
    return;

  /* handle only for up and down arrow */
  /* include page up/down when they support pointer warp */
  if (w->armed!=XmCR_INCREMENT && w->armed!=XmCR_DECREMENT)
    return;

  if ( w->scroll_max <= w->scroll_per )
    doCallBack = 0;
  else {
    doCallBack = 1;
    data.reason = w->armed;
  }

  if ( doCallBack && w->callback ) {
    AxCallback(w->callback,w,w->callbacktag,&data);
    AxAutoScrollHandler();
  }
}

/***********************************************************************
function: HandleListBoxAutoScroll - Auto scrolling for drag select in
list boxes.
*/
static void
HandleListBoxAutoScroll(w)
     AXWidget_list w;
{
  if (!w)
    return;
  if (w != ListBoxArmed)
    return;
  if (w->type != W_LIST)
    return;
  if (AutoScrollState == AUTOSCROLL_NOTARMED)
    return;

  if ((w->armed != XmCR_INCREMENT) && (w->armed != XmCR_DECREMENT))
    return;
  ListAutoScroll(w); /* xmlist.c */

  AxAutoScrollHandler();
  return;
}

/***********************************************************************
  function: HandleEditWinAutoScroll - Auto scrolling for drag select in
  edit window (combo box, entry field).
  */
static void HandleEditWinAutoScroll(w)
AXWidget w;
{
	struct edit_window *ee;
	
    /* sanity check */
    if ((!w) ||
		
	/* AutoScrollState should not be NOTARMED */
	(AutoScrollState == AUTOSCROLL_NOTARMED) ||
    
	/* if I'm not a combo box or entry field, return */
	((w->type != W_COMBO_BOX) && (w->type != W_ENTER)) ||

	/* if I'm not the selected combo box, return */
	((w->type == W_COMBO_BOX) &&
	 ((AXWidget_combo_box)w != ComboBoxInEditWindow)) ||
	
	/* if I'm not the selected entry field, return */
	((w->type == W_ENTER) && ((AXWidget_entry)w != EditWinArmed)))

	/* ESCAPE FROM HandleEditWinAutoScroll! =b */
	return;

    /* defined in editwin.c */
	ee = GetEditWin(w);
    EditWinAutoScroll(w, ee);
    
    AxAutoScrollHandler();
    return;
}

/***********************************************************************
  function: HandleEditBoxAutoScroll - Auto scrolling for drag select in
  edit box.
  */
static void HandleEditBoxAutoScroll(w)
AXWidget_editbox w;
{
    /* sanity check */
    if ((!w) ||
		
	/* AutoScrollState should not be NOTARMED */
	(AutoScrollState == AUTOSCROLL_NOTARMED) ||
    
	/* if I'm not an editbox, return */
	(w->type != W_EDITBOX) ||
	
	/* if I'm not the selected edit box, return */
	(w != EditBoxArmed))
    {
	/* ESCAPE FROM HandleEditBoxAutoScroll! =b */
	return;
    }

    /* defined in xmeditbx.c */
    EditBoxAutoScroll(w);
    AxAutoScrollHandler();

    return;
}

/***********************************************************************
  function: HandleCanvasAutoScroll - Auto scrolling for dragging in canvas
  */
static void HandleCanvasAutoScroll(w)
AXWidget_canvas w;
{
    /* no widget?  sanity check */
    if ((!w) ||
		
	/* AutoScrollState should not be NOTARMED */
	(AutoScrollState == AUTOSCROLL_NOTARMED) ||
    
	/* if I'm not a canvas, return */
	(w->type != W_CANVAS) ||
	
	/* if I'm not the selected canvas, return */
	(w != CanvasArmed)) {
		
		return;
    }

    /* defined in xmcanvas.c */
    CanvasAutoScroll(w);
    AxAutoScrollHandler();

    return;
}

/***********************************************************************
function: HandleTableAutoScroll - Auto scrolling for drag select in
tables.
*/
static void
HandleTableAutoScroll(w)
     AXWidget_table w;
{
  if (!w)
    return;
  if (w != TableArmed)
    return;
  if (w->type != W_TABLE)
    return;
  if (AutoScrollState == AUTOSCROLL_NOTARMED)
    return;

  if ((w->armed != XmCR_INCREMENT) && (w->armed != XmCR_DECREMENT))
    return;
#if 0
  printf("xmlib.c: HandleTableAutoScroll: about to call TableAutoScroll\n");
#endif
  TableAutoScroll(w); /* xmtable.c */
  AxAutoScrollHandler();
  return;
}

/***********************************************************************
  function: HandleComboListAutoScroll - Auto scrolling for combo dropdown list.
  */
static void HandleComboListAutoScroll(w)
AXWidget_combo_box w;
{
    /* no widget?  sanity check */
    if ((!w) ||
		
	/* AutoScrollState should not be NOTARMED */
	(AutoScrollState == AUTOSCROLL_NOTARMED) ||
    
	/* if I'm not a combo, return */
	(w->type != W_COMBO_BOX) ||
	
	/* if I'm not the selected combo, return */
	(w != ComboListArmed)) {
		
		return;
    }

    /* defined in xmcombo.c */
    ComboListAutoScroll(w);
    AxAutoScrollHandler();

    return;
}

/*************************************************************************
  function: AxAutoScrollHandler - handle scrollbar autoscroll
*/

void AxAutoScrollHandler()
{
  struct timeval tp;
  struct timezone tzp;
  gettimeofday(&tp, &tzp);

  if ((tp.tv_usec+AutoScrollUpdateTimeout*1000) > 1000000) {
    TimeAutoScrollNeedsUpdate.tv_sec =
      tp.tv_sec + (tp.tv_usec + (AutoScrollUpdateTimeout*1000))/1000000;
    TimeAutoScrollNeedsUpdate.tv_usec = 
      (tp.tv_usec+AutoScrollUpdateTimeout*1000)%1000000;
  }
  else {
    TimeAutoScrollNeedsUpdate.tv_sec = tp.tv_sec;
    TimeAutoScrollNeedsUpdate.tv_usec = 
      tp.tv_usec+AutoScrollUpdateTimeout*1000;
  }

  AutoScrollState = AUTOSCROLL_ARMED;
}




void mtPaintToggle(w, layered)
AXWidget_togglebutton w;
int layered;
{
	register AXWidget_radio radP;
	register int x,y,by,width,height,sep;
	register GC gc;
	int size, textVoffset, buttonVoffset, labelXoffset;
	AXWidget backWidget;
	wcolor_t *backColor;

	if ( !w->display )
		return;

	if (w->parent && (w->parent->type == W_DIALOG))
		{
			if ( !((AXWidget_dialog)w->parent)->exposed)
				return;
		}

	if (layered) {
		if (w->flags & WFLG_IN_EDIT) {
			if (dePaintWidget(w)) {
				return;
			}
		}
		else {
			if (topWidget(w) == (AXWidget)w) {
				paintCompositeWidget(w, NULL, FALSE);
				return;
			}
		}
	}
    
	w->mapped = TRUE;
    
	if ( (radP = w->in_radio) || w->like_radio ) {
        
		if ( radP )
			radP->mapped = TRUE;
		x = w->xpos;
		by = y = w->ypos;		/* based on xsab-16 */
		size = 16;
		width = 13;				/* based on xsab-16 */
		sep = 5;				/* based on xsab-16 */
		textVoffset = wToggleTextOffsets(w->font, TRUE, &buttonVoffset,
										 &labelXoffset);
		by += buttonVoffset;
        
		if ( radP )
			gc = radP->disabled ? DisabledGC : ForeGC;
		else
			gc = w->disabled ? DisabledGC : ForeGC;
		if ( w->value == TRUE ) {
			if ( Thim2dMode ) {
				AxDrawDiamond(WIN_OF(w),x,by,size,gc,gc,gc);
			}
			else {
				AxDrawDiamond(WIN_OF(w),x,by,size,ShadowGC,SunGC,gc);
			}
		}
		else {
			if ( Thim2dMode ) {
				AxDrawDiamond(WIN_OF(w),x,by,size,ForeGC,ForeGC,BackGC);
			}
			else {
				AxDrawDiamond(WIN_OF(w),x,by,size,SunGC,ShadowGC,BackGC);
			}
		}
	}
	else {
		x = w->xpos;
		by = y = w->ypos;		/* based on xsab-16 */
		width = 13;				/* based on xsab-16 */
		height = 13;			/* based on xsab-16 */
		size = 2;				/* of border */
		sep = 6;				/* based on xsab-16 */
		textVoffset = wToggleTextOffsets(w->font, FALSE, &buttonVoffset,
										 &labelXoffset);
		by += buttonVoffset;
        
		gc = w->disabled ? DisabledGC : ForeGC;
		if ( w->value == TRUE ) {
			/* toggle on */
			if ( wShadowIsOn(w->shadow) ) {
				/* lift drop shadow when button is turned on */
				xmLiftRectShadow(w, BackGC, x, by, width, height);
			}
			if ( Thim2dMode ) {
				AxDrawBevel(w, WIN_OF(w), x, by, width, height,
							1, BEVEL_SIMPLE);
			}
			else {
				AxDrawBevel(w, WIN_OF(w), x, by, width, height,
							size, BEVEL_IN);
			}
			XFillRectangle(Dpy,WIN_OF(w),gc,x+3,by+3,width-6,height-6);
		}
		else if ( w->value == 2 ) {
			/* toggle in indeterminate state */
			if ( Thim2dMode ) {
				AxDrawBevel(w, WIN_OF(w), x, by, width, height,
							1, BEVEL_SIMPLE);
			}
			else {
				AxDrawBevel(w, WIN_OF(w), x, by, width, height,
							1, BEVEL_OUT);
			}
			if ( wShadowIsOn(w->shadow) ) {
				xmDrawRectShadow(w, x, by, width, height);
				xmDrawRectAntiShadow(w, x, by, width, height);
			}
			XFillRectangle(Dpy,WIN_OF(w),DisabledGC,x+3,by+3,
						   width-6,height-6);
		}
		else {
			/* toggle off */
			if ( Thim2dMode ) {
				AxDrawBevel(w, WIN_OF(w), x, by, width, height,
							1, BEVEL_SIMPLE);
			}
			else {
				AxDrawBevel(w, WIN_OF(w), x, by, width, height,
							size, BEVEL_OUT);
			}
			if ( wShadowIsOn(w->shadow) ) {
				xmDrawRectShadow(w, x, by, width, height);
				xmDrawRectAntiShadow(w, x, by, width, height);
			}
			xmColorFillRectangle(w, WIN_OF(w), BackGC, x + 2, by + 2,
								 width - 4, height - 4);
		}
	}
    
	backColor = (wcolor_t *) NULL;
	if (w->disabled && (backWidget = backgroundWidget(w))) {
		backColor = backWidget->widgetColor;
	}
    
	xmDrawStringAndAccelerator(w, WIN_OF(w), gc, x+sep+width+labelXoffset,
							   w->ypos+textVoffset, w->name, MBstrlen(w->name),
							   w->textShadow, w->textColor, backColor,
							   w->accelerator_key);
}

/*************************************************************************
function: AxSetWindowProperties - set window properties,
* and request window-manager protocols
*/
AxSetWindowProperties(dpy, win, w, winName, iconName, iconId, hints)
     Display *dpy;
     Window win;
     AXWidget_main w;
     mbchar *winName;
     wchar *iconName; /* name to appear w/ icon when displayed */
     mbchar *iconId;   /* (read w->style) */
     XSizeHints *hints;
{
  mbchar name[BUFSIZ];
  mbchar mb_name[BUFSIZ];
  Pixmap getOnePlanePixmap();
  Pixmap tpix = (Pixmap) None;
  pixcache_t *p;
  mbchar *iconP;
  char **argVec;
  int argCount, ix, wm_save_yourself;
  XClassHint classhint;

  if (w && w->type == W_MAIN && iconId && !w->iconPixmap) {
    /* create an icon pixmap for a setaside icon
     */
    sprintf((char *)name,"%d-%s", iconId, IconSizeStr);
    if(p = Pixmapper(name)) {
      w->iconPixmap = getOnePlanePixmap(p->pix, win, p->width,
                    p->height);
      tpix = w->iconPixmap;
    }
  }

#if BUILD_WIDE
  /* The icon name is passed to us as a wide string */
  WToMbStr( iconName, mb_name );
  iconP = mb_name;
#else
  iconP = (mbchar *)iconName;
#endif
  
#if HP800 && !BUILD_KANJI && !BUILD_KOREAN && !BUILD_CHINA
  /* the HP window manager seems to run with the window title in an **/
  /*   HP-Roman-8 font                                           **/
  ConvertRoman8( winName );
  ConvertRoman8( iconP );
#endif

#if BUILD_KANJI
  /* Added by Ashisuto for converting the string so that the string consumed
   * by window manager fitting the window manager. Inner Applixware, we use
   * the EUC coding string, but the window manager sometimes is Shift-JIS
   * coded, do conversion in those cases. 95.09.14
   * Shouldn't change w->name into Shift-JIS, keep w->name in EUC always!
   * Ashisuto, 1998.02.25
   */
  if (env_is_sjis()) {
      MBstrcpy(name, winName);
      MBeuc2sjis_str(name);
      winName = name;
      MBeuc2sjis_str(iconP);
  }
#endif


  argVec = (char **) NULL;
  argCount = 0;
  classhint.res_class = NXLT("Unknown");
  classhint.res_name  = AxWmResNameStr;
  wm_save_yourself = FALSE;
  if (w && w->type == W_MAIN) {
    if (AxFormWMCommand(w, &argVec, &argCount, &classhint)) {
      wm_save_yourself = TRUE;
    }
    XSetClassHint(dpy, w->window, &classhint);
    AxSetWMProtocols(w->window, wm_save_yourself);
  }
  XSetStandardProperties(dpy, win, winName, iconP, tpix,
             argVec, argCount, hints);

#if BUILD_KANJI && (RIOS || SUN4S || SUNIS || LINUX)
  /* Ashisuto added to corresponding AIX-dtwm: to show the window name on
   * TitleBar, it must use the function XSetWMProperties() instead of
   * XSetStandardProperties(). On X-Window reference manual, it is said that
   * XSetStandardProperties() is superseded by XSetWMProperties() in X11R4.
   * Since we do not build on platforms older than X11R4(at least in Japanese
   * version) on AIX, we use new function for IBM-AIX here.   95.10.12
   */
  /* From Solaris2.5 in Japanese under CommonDesktopEnvironment, the X11R4
   * function XSetStandardProperties() is also not work correctly. Move to
   * use new function XmbSetWMProperties() as possible. Though the old
   * HP-VUE (HP-UX ver9.x) is left unable to correspond the new function.
   * Ashisuto, 1998.02.25
   */
  XmbSetWMProperties(dpy, win, winName, iconP, NULL, 0, NULL, NULL, NULL);
#elif BUILD_KANJI && HP800V3
  {
    /* HP-UX Release 9.x HACK!! - Ashisuto eliminated the compile define
     * option HPUX10 and do HPUX release judgement here. - 1997.02.21 */
    struct utsname os;
    int main_release_num;
    char *p, *q, *rel;
    char *digits = "0123456789";

    uname(&os);
#if 0
  /* This is the original KKA edit, which doesn't seem syntactically correct.
   * I can't ascertain the intent, so i'm leaving it here for future reference.
   *     -donato 20.APR.98
   */
  if (strcmp(os.sysname, "HP-UX") == 0) {
    rel = os.release;
    p = rel + strcspn(rel, digits);
    q = p + strspn(p, digits);
    *q = '\0';
    main_release_num = atoi(p);
    if (main_release_num > 9)
      XmbSetWMProperties(dpy, win, winName, iconP, NULL, 0, NULL, NULL, NULL);
    }
  } else {
    XmbSetWMProperties(dpy, win, winName, iconP, NULL, 0, NULL, NULL, NULL);
  }
#else
    if (strcmp(os.sysname, "HP-UX") == 0) {
        rel = os.release;
        p = rel + strcspn(rel, digits);
        q = p + strspn(p, digits);
        *q = '\0';
        main_release_num = atoi(p);
        if (main_release_num > 9)
            XmbSetWMProperties(dpy, win, winName, iconP, NULL,0,NULL,NULL,NULL);
    }
  }
#endif
#endif

  if (argVec) {
    for (ix = 0; ix < argCount; ix++) {
      free(argVec[ix]);
    }
    free(argVec);
  }
}

/***************************************************************************
 * : AxFormWMCommand - determine whether the passed top-level widget
 * should have the WM_COMMAND property set on its window, and build
 * the command data if so. return bool whether set.  Caller must free argVec
 */
int                     /* return TRUE if WM_COMMAND data is returned */
AxFormWMCommand(w, argVec, argCount, classhint)
     AXWidget_main w;            /* in */
     char ***argVec;        /* out: WM_COMMAND; caller must free if TRUE returned */
     int *argCount;         /* out: size of argVec */
     XClassHint *classhint; /* out: associated class hint; init caller's mem */
{
  char **cmd_args;
  int  cmd_cnt;
  int  cmd_supported = TRUE;
    
  if (w->type != W_MAIN) {
    *argCount = 0;
    *argVec = (char **) NULL;
    return FALSE;
  }
    
  cmd_cnt = 0;
  cmd_args = (char **) malloc (2 * sizeof(char *));
  cmd_args[1] = (char *) NULL;
  cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("applix")) + 1);
  strcpy(cmd_args[cmd_cnt], NXLT("applix"));
  cmd_cnt++;

  classhint->res_name  = AxWmResNameStr;
    
  switch (w->style) {
  case IC_DC: /* Words */
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-wp")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-wp"));
    cmd_cnt++;
    classhint->res_class = NXLT("Words");
    break;
        
  case IC_GE: /* Graphics */
  case IC_BG: /* Graphics */
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-gr")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-gr"));
    cmd_cnt++;
    classhint->res_class = NXLT("Graphics");
    break;
        
  case IC_SS: /* Spreadsheet */
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-ss")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-ss"));
    cmd_cnt++;
    classhint->res_class = NXLT("Spreadsheet");
    break;
        
  case IC_CE: /* Command editor */
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-me")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-me"));
    cmd_cnt++;
    classhint->res_class = NXLT("Macros");
    break;
        
  case IC_HTML: /* HTML Authoring System */
    cmd_supported = FALSE;          /* !!0 do we need one? */
    classhint->res_class = NXLT("HTML");
    break;
        
  case IC_MAIN:   /* Main Menu */
    /* just `applix' to get the main menu */
    classhint->res_class = NXLT("Main");
    break;
        
  case IC_FILING: /* Filing -- directory displayer*/
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-dd")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-dd"));
    cmd_cnt++;
    classhint->res_class = NXLT("DirectoryDisplayer");
    break;
        
  case IC_HELP:   /* Help */
    cmd_supported = FALSE;
    classhint->res_class = NXLT("Help");
    break;
        
  case IC_DIALOG: /* Dialog Editor */
    cmd_supported = FALSE;
    classhint->res_class = NXLT("Dialogs");
    break;
        
  case IC_PIXED:  /* Pixel Editor */
    cmd_supported = FALSE;
    classhint->res_class = NXLT("Pixed");
    break;
        
  case IC_SQL:    /* Data Dipper */
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-db")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-db"));
    cmd_cnt++;
    classhint->res_class = NXLT("Data");
    break;
        
  case IC_TUTOR:  /* Tutorial Displayer */
    cmd_supported = FALSE;
    classhint->res_class = NXLT("Tutor");
    break;
        
  case IC_EQN:    /* Equation Editor */
    cmd_supported = FALSE;
    classhint->res_class = NXLT("Equations");
    break;
        
  case 17: /* Mail */
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-mail")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-mail"));
    cmd_cnt++;
    classhint->res_class = NXLT("Mail");
    break;
        
  case 21: /* Inbox */
  case 22:
  case 23:
    cmd_args[cmd_cnt] = (char *) malloc(strlen(NXLT("-inbox")) + 1);
    strcpy(cmd_args[cmd_cnt], NXLT("-inbox"));
    cmd_cnt++;
    classhint->res_class = NXLT("Inbox");
    break;
        
  default:
    cmd_supported = FALSE;
    classhint->res_class = NXLT("Unknown");
    break;
  }
    
  if (cmd_supported && cmd_cnt) {
    *argCount = cmd_cnt;
    *argVec = cmd_args;
    return (TRUE);
  }
  else {
    *argCount = 0;
    *argVec = (char **) NULL;
    free(cmd_args[0]);
    free(cmd_args);
    return (FALSE);
  }
}

/*************************************************************************
function: SetWindowHints - Assign an icon to a window, focus...
*/
SetWindowHints (w, icon_id)
     AXWidget_main w;
     int icon_id;        /* should really be a char*, fetch file... */
{
  char name[BUFSIZ];
  pixcache_t *p;
  Window window;  /* From the CreateSimple call */
  XWMHints hints;

  if ( !w || !w->window )
    return;

  window = w->window;
  memset(&hints, 0, sizeof(hints));

  hints.flags = StateHint | InputHint;
  hints.initial_state = NormalState;

#if 0   /* Turn this on if XSetWMProtocols has been turned off
       in tmx.c... aka if X11R3. */
  hints.input = True;
#else
  if (UseGloballyActiveFocus) {
    /* combined with WM_TAKE_FOCUS, for globally active
     * input focus model */
    hints.input = False;
  }
  else {
    hints.input = True;
  }
#endif

  if ( w->type == W_MAIN && icon_id && !w->iconPixmap) {
    /* create pixmap for setaside icon */
    sprintf(name,"%d-%s",icon_id,IconSizeStr);
    if(p = Pixmapper(name)) {
      Pixmap getOnePlanePixmap();
      w->iconPixmap = getOnePlanePixmap(p->pix, window,
                    p->width, p->height);
    }
  }
  if (W_MAIN == w->type && w->iconPixmap) {
    hints.flags |= IconPixmapHint;
    hints.icon_pixmap = w->iconPixmap;
  }
  XSetWMHints(Dpy, window, &hints);
}

/* return the 1-deep version of the passed pixmap, however distorted */
Pixmap
getOnePlanePixmap(deepMap, win, wid, ht)
     Pixmap deepMap;
     Window win;
     int wid, ht;
{
  Pixmap pix;
  GC tgc;
  XImage *img, *img2;
  XGCValues gcvals;
  unsigned long mask, thisPix, blackPix;
  int xx, yy, paddedWid, size;
  char *imageData;

  if (deepMap == None || !deepMap || !wid || !ht)
    return ((Pixmap) NULL);

  /* copy the server image into our space */
  img = XGetImage(Dpy, deepMap, 0, 0, (unsigned int) wid, (unsigned int) ht,
          AllPlanes, ZPixmap);
  if (!img)
    return ((Pixmap) NULL);

  paddedWid = 0;
  while( (paddedWid += img->bitmap_pad) < wid) ; 
  size = (paddedWid / 8) * ht;

  imageData = (char *) TrueMalloc(size);
  memset((char *)imageData, 0, size);

  /* get a one-plane-deep image to write on */
  img2 = XCreateImage(Dpy, DefaultVisual(Dpy, DefaultScreen(Dpy)),
              (unsigned int) 1, ZPixmap, 0, imageData, (unsigned int) wid,
              (unsigned int) ht, img->bitmap_pad, 0);
  if (!img2) {
    XDestroyImage(img);
    TrueFree ((char *) imageData);
    return ((Pixmap) NULL);
  }
  /* index thru img, writing pixvals onto img2 */
  blackPix = XGetPixel(img, 0, 0); /* typically a border.. */
  for (yy = 0; yy < ht; yy++) {
    for (xx = 0; xx < wid; xx++) {
      thisPix = XGetPixel(img, xx, yy);
      if ( thisPix == blackPix )
    XPutPixel(img2, xx, yy, (unsigned long) AllPlanes);
    }
  }
  /* get a 1-plane pixmap, and shoot img2 onto it */
  pix = XCreatePixmap(Dpy, win, (unsigned int)wid, (unsigned int)ht, 1);
  /* need a 1-plane gc to do this.. */
  mask = GCForeground | GCBackground;
  gcvals.foreground = (unsigned long) AllPlanes;
  gcvals.background = (unsigned long) ~AllPlanes;
  tgc = axCreateGC(Dpy, pix, DefaultScreen(Dpy), 1,
           (XFontStruct *) 0, mask, &gcvals);
  XPutImage(Dpy, pix, tgc, img2, 0, 0, 0, 0, (unsigned int)wid,
        (unsigned int ) ht);
  /* clean up */
  XFreeGC(Dpy, tgc);
  XDestroyImage(img);
  TrueFree ((char *) imageData);
  img2->data = (char *) NULL;
  XDestroyImage(img2);
  return(pix);
}

ZXmNewTitle(){}


/*************************************************************************
function: XmNewTitle - Change window's title
*/
XmNewTitle (w,full_name,iconstr)
     AXWidget_main w;
     char *full_name;
     char *iconstr;
{
  static XSizeHints xsh;
  mbchar temp_str[BUFSIZ];
  int sz;

  if ( !w )
    return;
  if (TaskIsJavaBased(w->taskOwner)) {
	  data_ptr infoP;
	  int jwId;
	  infoP = AxMakeArray(2);
	  AxAddStrToArray(infoP,0,full_name);
	  AxAddStrToArray(infoP,1,iconstr);
	  jwId = JavaWinIdFromWidget(w);
      AxJavaWinNotifier(jwId,JV_SET_WINTITLE,infoP);
  }
#if BUILD_WIDE
  WToMbStr( w->wstr, temp_str );
  if ( streq(w->name,full_name) && streq( temp_str,iconstr) )
    return;
#else
  if ( streq(w->name,full_name) && streq(w->wstr,iconstr) )
    return;
#endif

#if DEBUG_NOMAP
  puts("NEW TITLE");
#endif
  if(!AxMapWinName(w->name))
    {
      AxDelNoMapWindow(w->name);
      AxAddNoMapWindow(full_name);
    }
  SetWidgetName(w, full_name);

  sz = strlen(iconstr)+1;
  if (w->wstr)
    free(w->wstr);
  w->wstr = (wchar *) malloc(sz * sizeof(wchar));
  MbToWStr(iconstr, w->wstr);

  XGetSizeHints(Dpy,w->window,&xsh,XA_WM_NORMAL_HINTS);
  AxSetWindowProperties(Dpy, w->window, w, w->name, w->wstr, 
            w->style, &xsh);
  XFlush(Dpy);
}

/*************************************************************************
function: ZXmHammerStandardProperties - Set std props again
*/
ZXmHammerStandardProperties (w)
     AXWidget_main w;
{
  static XSizeHints xsh;

  if ( !w )
    return;
  XGetSizeHints(Dpy,w->window,&xsh,XA_WM_NORMAL_HINTS);
  AxSetWindowProperties(Dpy, w->window, w, w->name, w->wstr, 
            w->style, &xsh);
  XFlush(Dpy);
}


#if SUPPORT_HP_VUE
/***********************************************************************
function: AxWorkProc - Work procedure to be called when the event loop
is idle -- Used for HP (since we call XtNextEvent()).  This
procedure is called by XtNextEvent() if there are no events pending.
*/
Boolean
AxWorkProc()
{
  /* This function has been called by XtNextEvent() instead of it
     blocking.  Jump back to inside `AXtAppNextEvent()', so that we
     don't block. */
  longjmp(AxPendBreaker, TRUE);
  return(False); /*NOTREACHED*/
}
#endif

/*************************************************************************
 * function: AXtAppNextEvent - Read next event from X or just return
 * whether is one. Handle deferred activities and pend for next event.
 */
AXtAppNextEvent (eventP,timer)
XEvent *eventP;
int timer;  /* -1 == infinite or time in miliseconds */
{
	register AXWidget w, bp;
	register void (*func)();
	register int do_again;  /* for handling UnMaps damaging other widgets */
	register int pass = 0;  /* Sanity - keeps from infinite looping */
	static struct timeval timeout;
	struct timeval *timeP = NULL;
	int events;
	int ix;
	int use_qa_event = 0;
	short pid;
	menu_item_def *mP;
	int haveXserverInput;
	static int serial_count = 0;
	
	
	/* Wait for event from X or any declared sockets */
	
	if ( (AutoScrollState != AUTOSCROLL_NOTARMED) && (timer != 0) ) {
		struct timeval curr_time;
		struct timezone curr_timezone;
		int scroll_timeout;
		gettimeofday(&curr_time, &curr_timezone);
		scroll_timeout = AxSubtractTime(&TimeAutoScrollNeedsUpdate,
										&curr_time);
		if ( scroll_timeout <= 0 ) {
			AutoScrollState = AUTOSCROLL_READY;
			timer = 1;			/* process this immediately */
		}
		else if ( (scroll_timeout <= timer) || (timer == -1) ) {
			AutoScrollState = AUTOSCROLL_WAIT;
			timer = scroll_timeout;
		}
		else {
			AutoScrollState = AUTOSCROLL_ARMED;
		}
	} else if ( AxPulldownActive && AxButtonDown &&
			   !(AxPulldownActive->cascade) &&
			   (TimeCascadeShouldPopup.tv_sec != 0) && (timer != 0) ) {
		struct timeval curr_time;
		struct timezone curr_timezone;
		int cascade_interval;
		gettimeofday(&curr_time, &curr_timezone);
		cascade_interval = AxSubtractTime(&TimeCascadeShouldPopup,
										  &curr_time);
		if (cascade_interval <= 0 ) {
			timer = 1;
		}
		else if ( (cascade_interval <= timer) || (timer == -1) ) {
			timer = cascade_interval;
		}
	}
	
	if ( ToolArmedForUpdate && (timer != 0) ) {
		MenuUID++;
		pid = THIMpid;
		mP = MenuItemFromTool(ToolArmedForUpdate);
		UpdateToolStatus(ToolArmedForUpdate, mP);
		ToolArmedForUpdate = NULL;
		VfyContext(pid);
	}
	
	if ( timer != -1 ) {
		timeout.tv_sec = timer / 1000;
		timeout.tv_usec = (timer%1000) * 1000;
		timeP = &timeout;
	}
	
#if QATOOL
	/* lance */
	/* We don't want to block forever we might */
	/* have a qa event just around the corrner so set the time out */
	/* value to something reasonable. This allows real X events get */
	/* through, and if there is not a real X event we can load the */
	/* qa event in a timely manner */
	if ( QaPlaybackMode() && timer >= 50 ) {
		timeout.tv_sec = 0;
		timeout.tv_usec = 100;
		timeP = &timeout;
	}
	
	if ( QaPlaybackMode() && timer == -1 ) {
		timeout.tv_sec = 0;
		timeout.tv_usec = 100;
		timeP = &timeout;
	}
#endif

	if ( WidgetNeedsUpdated ) {
		doWidgetUpdates();
		WidgetNeedsUpdated = FALSE;
		xmlibStr.FullRegenForUpdate = FALSE;
	}
	
#if SUPPORT_HP_VUE
	XFlush(Dpy);
	if ( !XtPending() )
#else
		if ( !XPending(Dpy) )
#endif
		{
			events = AxSelectForInput(ConnectionNumber(Dpy),
									  timeP, &haveXserverInput);
			if ( events == -1 ) {
				if (errno == EINTR) {
					return(0);
				}
				else {
					char abort_mes[200];
					sprintf(abort_mes,
							NXLT("Channel to X-server has been closed: %s"),
							sys_errlist[errno]);
					tempAbort(abort_mes);
				}
			}
			else if ( events == 0 ) {   /* timer expired */
				if (AutoScrollState==AUTOSCROLL_WAIT ||
					AutoScrollState==AUTOSCROLL_READY) {
					/* set faster timeout now for actual autoscrolling */
					AutoScrollUpdateTimeout = AUTOSCROLL_INTERVAL;
					if (ScrollBarArmed && AxButtonDown) {
						HandleScrollBarAutoScroll(ScrollBarArmed);
					} else if (ListBoxArmed && AxButtonDown) {
						HandleListBoxAutoScroll(ListBoxArmed);
					} else if (TableArmed && AxButtonDown) {
						HandleTableAutoScroll(TableArmed);
					} else if (EditWinArmed && AxButtonDown) {
						AutoScrollUpdateTimeout = AUTOSCROLL_INTERVAL / 2;
						HandleEditWinAutoScroll(EditWinArmed);
					} else if (EditBoxArmed && AxButtonDown) {
						AutoScrollUpdateTimeout = AUTOSCROLL_INTERVAL / 2;
						HandleEditBoxAutoScroll(EditBoxArmed);
					} else if (CanvasArmed && AxButtonDown) {
						AutoScrollUpdateTimeout = AUTOSCROLL_INTERVAL / 2;
						HandleCanvasAutoScroll(CanvasArmed);
					} else if (ComboListArmed && AxButtonDown) {
						AutoScrollUpdateTimeout = AUTOSCROLL_INTERVAL / 2;
						HandleComboListAutoScroll(ComboListArmed);
					}
				}
				else if (AxPulldownActive && AxButtonDown &&
						 (TimeCascadeShouldPopup.tv_sec != 0) &&
						 !(AxPulldownActive->cascade)) {
					XEvent dummy_ev;
					/* all these variables get thrown away */
					Window root_return, child_return;
					int root_x, root_y;
					unsigned int mask_return;
					XQueryPointer(Dpy,AxPulldownActive->window,
								  &root_return,&child_return,
								  &root_x, &root_y,
								  &dummy_ev.xmotion.x,&dummy_ev.xmotion.y,
								  &mask_return);
					dummy_ev.xbutton.x = dummy_ev.xmotion.x;
					dummy_ev.xbutton.y = dummy_ev.xmotion.y;
					dummy_ev.type = MotionNotify;
					PaintMenuPulldown(AxPulldownActive,
									  OPTION_MOVE, &dummy_ev);
					return(TRUE);
				}
				
#if QATOOL
				/* X server had no events now check qa-playback */
				/* simulation for any events -lance */
				if ( QaPlaybackMode() && eventP ) {
					use_qa_event = 1;
					haveXserverInput = 1;
					QaNextEvent(eventP);
				}
				else {
					return(FALSE);
				}
#else
				return(FALSE);
#endif
			}
			if ( !haveXserverInput )
				return(FALSE);
			if (AutoScrollState == AUTOSCROLL_READY) {
				if (ScrollBarArmed && AxButtonDown)
					HandleScrollBarAutoScroll(ScrollBarArmed);
				else if (ListBoxArmed && AxButtonDown)
					HandleListBoxAutoScroll(ListBoxArmed);
				else if (TableArmed && AxButtonDown)
					HandleTableAutoScroll(TableArmed);
				else if (EditWinArmed && AxButtonDown)
					HandleEditWinAutoScroll(EditWinArmed);
				else if (EditBoxArmed && AxButtonDown)
					HandleEditBoxAutoScroll(EditBoxArmed);
				else if (CanvasArmed && AxButtonDown)
					HandleCanvasAutoScroll(CanvasArmed);
				else if (ComboListArmed && AxButtonDown)
					HandleComboListAutoScroll(ComboListArmed);
			}
		}
	
	if ( !eventP || (timer == 0) ) /* caller just checking if events pending */
		return(TRUE);
	
#if SUPPORT_HP_VUE
	/* Make absolutely sure that XtNextEvent will not block */
	if (!setjmp(AxPendBreaker)) {
		if (CurrentPendBreaker) {
			XtRemoveWorkProc(CurrentPendBreaker);
			CurrentPendBreaker = NULL;
		}
		CurrentPendBreaker = XtAddWorkProc((XtWorkProc) AxWorkProc, NULL);
		XtNextEvent(eventP);
	} else
		return(FALSE);
#else
	if (XPending(Dpy)) {
		/* checking for qa event lance */
		if ( !use_qa_event) 
			XNextEvent(Dpy,eventP);
	} else {
		/* AxSelectForInput() has told us there is data on the X channel,
		   but XPending() does not say so.  The X server might have gone.
		   Do an XSync() -- we might get an IO error. */
		XSync(Dpy, FALSE);
		return(FALSE);
	}
#endif
	
	/* Ingres sends us Expose events with all members (except `type')
	   zeroed out.  We crash on those events.  Return if such an event. */
	if (eventP->xany.type == Expose && eventP->xexpose.x == 0 &&
		eventP->xexpose.y == 0 && eventP->xexpose.width == 0 &&
		eventP->xexpose.height == 0)
		return(FALSE);
	
	if ( handle_low_mem_property(eventP) )
		return(FALSE);
	
	/* Events are at times addressed to windows that have been
	   destroyed.  Return *here* if that is so.  Bad things happen to
	   our software if we let in events to windows we don't know about. */
  if (!AxInWindowsList(eventP->xany.window))
  {
#if BUILD_KANJI && RIOS
      /* IBM-AIX uses homonyms windows in Japanese input. Inside homonyms
       * windows there are buttons, scrollbars and lists. Applixware didn't
       * refresh the display of homonyms window after it poped up, and
       * the mouse click or the keypress inside homonyms windows had no
       * effects. While the AIXTERMs do that.
       * The reason of why Applixware didn't refresh homonyms window is that:
       * homonyms windows are not in the AxWindowList, the events belong to
       * homonyms windows though accepted in Applixware by calling
       * XNextEvent() but not dispatched by Applixware.
       *
       * The addition of XFilterEvent(eventP->xany.window) here wouldn't
       * raise any new trouble because even if the eventP->xany.window
       * was destroyed, the event filtering just returns FALSE, and we
       * do not use the return value here. If the filtering event window
       * is homonyms window, the event will be passed and dispatched by
       * XIM or anyone who monites homonyms window.
       *
       * Ashisuto added. 95/09/14
       */
      XFilterEvent(eventP, NULL);
      return(FALSE);
#else
      return(FALSE);
#endif
  }
	
	LogX11Event(eventP);
	
	/* we need to insure complete uniquenes of a messsage, to be checked */
	/* in AXLookupString. This is because at least the ATOK Japanese     */
	/* conversion server has been seen to return messages of the same type, */
	/* with the same time value.  This could happen on other X servers */
	/* as they get faster, so checking time and type is not guaranteed  */ 
	/* to be unique. AXLookupString must be able to tell when it is getting */
	/* a new event, vs. being called with an event it has already seen  */
	eventP->xany.serial = serial_count;
	serial_count++;
	
	if (eventP->type==ButtonPress) {
		/*
		 * If no other mouse button is down, set mouse button-down state. 
		 *
		 * Before setting button-down state, confirm that no other mouse 
		 * button is down, don't just rely on the value of AxButtonDown!! 
		 * This test is needed - if a window (to which events are being 
		 * reported) is torn down during a very fast double click (for 
		 * example, the dialog window is destroyed after the second 
		 * ButtonPress when selecting items from a listbox), the second 
		 * ButtonRelease event is not reported by XNextEvent, in effect not 
		 * resetting AxButtonDown.  The event is reported if the double 
		 * select is slow enough.  Why??
		 */
		unsigned int button_mask;
#if LINUX
		char *str = (char *)UPbyName(NXLT("axMouseWheelScroll"));
		if (str && (atoi(str) != 0)) {
			button_mask = Button1Mask | Button2Mask | Button3Mask |
				Button4Mask | Button5Mask;
		}
#endif
		button_mask = Button1Mask | Button2Mask | Button3Mask;
		if ((eventP->xbutton.state & button_mask) == 0) {
			/* no other mouse button down at time of this ButtonPress */
			AxButtonDown = (int)eventP->xbutton.button;
			/* reset AutoScrollState here also for safety */
			AutoScrollState = AUTOSCROLL_NOTARMED;  
			/* reset AutoScrollUpdateTimeout for initial timeout */
			AutoScrollUpdateTimeout = AUTOSCROLL_TIMEOUT;
		}
		if (!(eventP->xbutton.state & ControlMask))
			AxControlKeyDown = 0;
	}
	else if (eventP->type==ButtonRelease) {
		if ((int)eventP->xbutton.button == AxButtonDown) {
			AxButtonDown = 0;
			AutoScrollState = AUTOSCROLL_NOTARMED;
			/* reset AutoScrollUpdateTimeout for initial timeout */
			AutoScrollUpdateTimeout = AUTOSCROLL_TIMEOUT;
		}
		if (!(eventP->xbutton.state & ControlMask))
			AxControlKeyDown = 0;
	}
	
	if (AutoScrollState == AUTOSCROLL_READY) {
		if (ScrollBarArmed && AxButtonDown)
			HandleScrollBarAutoScroll(ScrollBarArmed);
		else if (ListBoxArmed && AxButtonDown)
			HandleListBoxAutoScroll(ListBoxArmed);
		else if (TableArmed && AxButtonDown)
			HandleTableAutoScroll(TableArmed);
		else if (EditWinArmed && AxButtonDown)
			HandleEditWinAutoScroll(EditWinArmed);
		else if (EditBoxArmed && AxButtonDown)
			HandleEditBoxAutoScroll(EditBoxArmed);
		else if (CanvasArmed && AxButtonDown)
			HandleCanvasAutoScroll(CanvasArmed);
		else if (ComboListArmed && AxButtonDown)
			HandleComboListAutoScroll(ComboListArmed);
	}
	
	return(TRUE);
}

/***********************************************************************
function: is_key_event - 
*/
static Bool
is_keypress_event(dpy, ev, data)
     register Display *dpy;
     register XEvent *ev;
     register char *data;
{
  if (!dpy || !ev)
    return(False);
  if (ev->xany.type == KeyPress) {
    KeySym evksym;
    int nb;
    char buf[250 + 1];

    evksym = XK_VoidSymbol;
    nb = AXLookupString(ev, buf, 250, &evksym);
    if (evksym == (KeySym) data)
      return(True);
  }
  return(False);
}

/***********************************************************************
function: AxTossExcessiveKeys - Toss out all instances of KeyPress on 'ksym'
from the queue.  This is used to toss out backlog of the same key in
the queue.

This is to cure the following problem:
Say the user leans on the up arrow key which generates, say 50 keypress
events in a Spreadsheet.  This causes 50 scrolls to happen.  If each
line scroll takes 1 second (because of an expensive calculation
or graph rendering), user will have to wait 50 seconds before the
spreadsheet stops scrolling!
*/
static void
AxTossExcessiveKeys(dpy, ksym)
     register Display *dpy;
     register KeySym ksym;
{
  XEvent event;

  while (XCheckIfEvent(dpy, &event, is_keypress_event, (char *) ksym))
    ;
  return;
}

/***********************************************************************
function: AxFindEvent - Return the serial number of event if event_type is
found; 0 otherwise.
*/
static unsigned long
AxFindEvent(dpy, event_type)
     register Display *dpy;
     int event_type;
{
  XEvent event;

  if (XCheckTypedEvent(dpy, event_type, &event))
    return(event.xany.serial);
  return(0);
}

static Bool
is_tossable_keypress(dpy, ev, data)
     register Display *dpy;
     register XEvent *ev;
     register char *data;
{
  if (!dpy || !ev)
    return(False);
  if (ev->xany.type == KeyPress) {
    if (ev->xany.serial < (unsigned long) data)
      return(True);
  }
  return(False);
}

static void
AxTossKeyPressUptoSerial(dpy, serial_no)
     register Display *dpy;
     register unsigned long serial_no;
{
  XEvent ev;

  /* Assume 'serial_no' will be found in queue */
  while (XCheckIfEvent(dpy, &ev, is_tossable_keypress, (char *)
               serial_no))
    ;
  return;
}

extern Atom AxPROTOCOL_ATOM;
extern Atom AxDELETE_WIN_ATOM;
extern Atom AxWIN_TAKE_FOCUS;
extern Atom AxXA_SAVE_YOURSELF;

/*************************************************************************
function: ZXtDispatchEvent - Handle X event if for self
Returns either 0, or the xwin handle to which to reroute the event.
*/
Window ZXtDispatchEvent (eventP)
XEvent *eventP;
{
    XButtonEvent *bep = &eventP->xbutton;
    XMotionEvent *mep = &eventP->xmotion;
    Window window = eventP->xany.window;
    register int ix;
	int in_menu_bar = FALSE;
	int in_default_menu_bar = FALSE;
    KeySym ksym;
    register int num_chars;
    wchar *buf;
    Window retval = 0;  /* re-route to window for ruler/menubar typeing */
    int leftButton, middleButton, rightButton;
#if LINUX
	int upButton, downButton; /* mouse wheel scrolling */
#endif
    int consumed;
    XComposeStatus compose;
    unsigned long keyrelease_serial_no;
    AXWidget wp, savedwp, w, parent;
    AXWidget childP;
    AXWidget_dialog d_w;
    AXWidget_work work_w;
    AXWidget_main mw;
	menu_item_def *mP;
    
    if (!AxInWindowsList(eventP->xany.window))
        return((Window) NULL);

    for ( wp = WindowList; wp; wp = wp->nextWin ) {
        if ( wp->window == window )
            break;
        if ( wp->type == W_MENUBAR ) {
            if ( ((AXWidget_menu)wp)->pulldown == window )
                break;
        }
        else if ( wp->type == W_COMBO_BOX ) {
            if ( ((AXWidget_combo_box)wp)->pulldown == window )
                break;
	    if ( ((AXWidget_combo_box)wp)->edit_win.win == window )
		break;
        }
	else if (wp->type == W_ENTER) {
	    if (((AXWidget_entry)wp)->edit_win.win == window)
		break;
	}
    }
    if ( !wp ) {
        return((Window)NULL);
	}
    if (localEventDispatch(wp, eventP)) {
        return((Window)NULL); /* an event handler consumed the event */
    }

    if (wp->type != W_COMBO_BOX)
	if (ComboBoxInEditWindow)
	    if (eventP->type != KeyPress)
		if (eventP->type != KeyRelease)
		    ComboBoxInEditWindow == NULL;

    switch(eventP->type) {
        
    case ClientMessage:
        if (eventP->xclient.message_type == AxPROTOCOL_ATOM) {
            if (eventP->xclient.data.l[0] == AxDELETE_WIN_ATOM) {
                if ( wp->type == W_MAIN ) {
                    mw = (AXWidget_main)wp;
                    if ( mw->elfObject ||
                        (mw->dialog &&
                         ((AXWidget_dialog)mw->dialog)->elfObject) ) {
                        
                        if ( !mw->elfObject ) {
                            mw->elfObject = AxTaskCopyElfData
                                (0, ((AXWidget_dialog)mw->dialog)->elfObject);
                        }
                        CallWidget(mw->taskOwner,wp,EV_DLG_DESTROY_,NULL);
                    }
                    else if ( mw->dialog ) {
                        /* do exit poke if dialog is interested */
                        XmRowColumnCallbackStruct data;
                        int size, ix, didPoke;
                        d_w = mw->dialog;
                        size = IntsArraySize(d_w->pokeCodes);
                        for(ix = 0, didPoke = FALSE; ix < size; ix++) {
                            if (ReadIntsArray(d_w->pokeCodes, ix) ==
                                POKE_EXIT) {
                                data.reason = POKE_EXIT;
                                data.data = "";
                                if ( d_w->callback && d_w->callbacktag) {
                                    AxCallback(d_w->callback, mw,
                                               d_w->callbacktag, &data);
                                    didPoke = TRUE;
                                    break;
                                }
                            }
                        }
                        if (!didPoke)
                            KillTask(d_w->taskOwner);
                    }
                    else /* it's an application window */
                        return(mw->workWindow->window); /*re_route to parent */
                }
            }
            else if (eventP->xclient.data.l[0] == AxXA_SAVE_YOURSELF) {
                /* The session manager needs a SetCommand to happen */
                
                char **cmd_argv = (char **) NULL ;
                int  cmd_argc = 0;
                if (!XGetCommand(Dpy, wp->window, &cmd_argv, &cmd_argc)) {
                    /* No existing WM_COMMAND on this window.  Set
                       a NULL command. */
                    char *null_cmd[2];
                    null_cmd[0] = "";
                    XSetCommand(Dpy, wp->window, null_cmd, 1);
                } else {
                    /* Just set the same command */
                    /* FIXME, Save the application here!! */
                    XSetCommand(Dpy, wp->window, cmd_argv, cmd_argc);
                }
            }
            else if (eventP->xclient.data.l[0] == AxWIN_TAKE_FOCUS) {
                if ( AxInfoMessages && !IsWinInfoBox(window) ) {
                    KeepMessageBoxOnTop(eventP);
                }
                else {
                    AXSetInputFocus(window, TRUE,
									(Time)(eventP->xclient.data.l[1]));
                    xmDialogFocus(wp, TRUE);
                }
            }
        }
        AxDndHandleEvent(eventP);
        break;

    case ConfigureNotify:
        if ( wp->type == W_MAIN ) {
            RebuildMainWindow(wp, eventP);
            break;
        }
        if ( (wp->type == W_RULER) || (wp->type == W_PLATES) ) {
            AxSendMes(wp->taskOwner, eventP, sizeof(*eventP), APXSERVER);
        }
        break;

    case ReparentNotify:
        if ( wp->type == W_MAIN ) {
            CheckWMShellSize(wp, eventP);
        }
        break;

    case MapNotify:
        if ( (wp->type == W_DIALOG) || (wp->type == W_MAIN) ) {
            if ( wp->type == W_DIALOG )
                ((AXWidget_dialog)wp)->currently_mapped = TRUE;
            else if ( wp->type == W_MAIN )
                ((AXWidget_main)wp)->currently_mapped = TRUE;
            MapChildren(wp);

            if (  wp->type == W_MAIN && ((AXWidget_main)wp)->dialog ) {
                /* send map poke if dialog is interested */
                
                XmRowColumnCallbackStruct data;
                int size;
                
                d_w = ((AXWidget_main)wp)->dialog;
                size = IntsArraySize(d_w->pokeCodes);
                
                for (ix = 0; ix < size; ix++) {
                    if (ReadIntsArray(d_w->pokeCodes, ix) == POKE_MAPPED) {
                        data.reason = POKE_MAPPED;
                        data.data = "";
                        if ( d_w->callback && d_w->callbacktag) {
                            AxCallback(d_w->callback, wp,
                                       d_w->callbacktag,&data);
                            break;
                        }
                    }
                }
            }
        }
        break;

    case UnmapNotify:
        if ( (wp->type == W_DIALOG) || (wp->type == W_MAIN) ) {
            if ( wp->type == W_DIALOG )
                ((AXWidget_dialog)wp)->currently_mapped = FALSE;
            else if ( wp->type == W_MAIN )
                ((AXWidget_main)wp)->currently_mapped = FALSE;
            UnMapChildren(wp);
        }
        break;

    case GraphicsExpose:
        if (wp->type == W_TRAY) {
            TrayEvent(wp, eventP);
        }
        else if (wp->type == W_TABLE) {
            TableEvent(wp, eventP);
        }
        else if (wp->type == W_CHOOSE) {
            ColorChooserEvent(wp, eventP);
        }
        else {
            /* GraphicsExpose is similar enough to Expose
             * that we can pass it thru..   (Though we should
             * temporarily shut off sensitivity to GraphicsExpose
             * during doExpose, to guard against busyhang..)
             */
            doExpose(wp, (XExposeEvent *) eventP);
        }
        if ( wp->type == W_DIALOG)
            ((AXWidget_dialog)wp)->exposed = TRUE;
        else if ( wp->type == W_MAIN )
            ((AXWidget_main)wp)->exposed = TRUE;
        break;
        
    case Expose:
        AxFilterExpose(wp, eventP, doExpose);
        break;
        
    case FocusIn:
        /* Pump this event into all table widgets of dialog.*/
        if (((wp->type == W_MAIN) && /* a window with a dialog */
	     (d_w = (AXWidget_dialog)(((AXWidget_main)wp)->dialog))) ||
	    ((wp->type == W_DIALOG) && /* the dialog itself */
	     (d_w = (AXWidget_dialog)wp))) {
            xmDialogFocus(d_w, TRUE);
            for (w = d_w->widgets; w; w = w->nextChild) {
                if (w->type == W_TABLE)
                    TableEvent(w, eventP);
                if (w->type == W_TRAY)
                    TrayEvent(w, eventP);
            }
	}
        
        if ( AxInfoMessages && !IsWinInfoBox(window) ) {
            KeepMessageBoxOnTop(eventP);
            return((Window)NULL);
        }
#if BUILD_ORIENT
        SetXIMFocus( wp, eventP->xany.window );
#endif
        if ( wp->type == W_MAIN) {
            mw = (AXWidget_main)wp;
            if ( mw->workWindow )
                return(mw->workWindow->window);
        }
        break;

    case FocusOut:
        /* Pump this event into all table widgets of dialog.*/
        if (((wp->type == W_MAIN) && /* a window with a dialog */
	     (d_w = (AXWidget_dialog)(((AXWidget_main)wp)->dialog))) ||
	    ((wp->type == W_DIALOG) && /* the dialog itself */
	     (d_w = (AXWidget_dialog)wp))) {
            xmDialogFocus(d_w, FALSE);
            for (w = d_w->widgets; w; w = w->nextChild) {
                if (w->type == W_TABLE)
                    TableEvent(w, eventP);
                if (w->type == W_TRAY)
                    TrayEvent(w, eventP);
            }
        }

#if BUILD_ORIENT
        UnSetXIMFocus( wp, eventP->xany.window );
#endif
        if ( wp->type == W_MAIN) {
            mw = (AXWidget_main)wp;
            if ( mw->workWindow )
                return(mw->workWindow->window);
        }
        break;

    case KeyPress:
        /* maintain globals related to key/mouse handing. */
        ClickWidget = NULL;
        TimeOfKeyPress = eventP->xkey.time;
        if ( TaskOfWidgetPended(wp) ) 
            return((Window)NULL);
        if ( AxInfoMessages && !IsWinInfoBox(window) ) {
            KeepMessageBoxOnTop(eventP);
            return((Window)NULL);
        }
        if ( ElfInLearnMode ) {
            parent = (AXWidget)wp->parent;
            while ( parent ) {
                if ( parent->type == W_MAIN ) {
                    if ( ((AXWidget_main)parent)->disable_record )
                        return((Window)NULL);
                    else
                        break;
                }
                parent = (AXWidget)parent->parent;
            }
        }
        num_chars = AXLookupString16(eventP, &buf, &ksym);
        if ( (ksym == XK_Control_L) || (ksym == XK_Control_R) ) {
            if ( !AxControlKeyDown )
                AxControlKeyDown = ksym;
        }

/* modes in which there's an open pulldown can steal any key */		
        if (ComboBoxArmed) {
            if (ComboBoxKeyEvent(ComboBoxArmed, ksym, buf, num_chars,
                                 eventP))
				break;
		}
        if ( PullDownKeyEvent(wp, ksym, buf[0], num_chars, eventP) ) {
            break;
        }
        if ( AxPulldownActive ) {
            break;
        }

/* get reference to work-window or dialog-box widget */
        xmContainerWidgetPointer(wp, &d_w, &work_w);
        
/* Pass event back up to application window if this is not a dialog box */
        if (work_w) {
            return (work_w->window);
        }
        if (!d_w) {
            return((Window) NULL); /* neither dialog or app window....? */
        }

/* keystroke goes to dialog box d_w */

		AxSetKeyModifiers(eventP->xkey.state);  /* make sure mods readable */
		if (ThimIsAlted()) {
			/* possibly perform dbox-widget-accelerator
			 */
			if (AxDoDialogAccelerator(d_w, ksym)) {
				break;   /* found accel and executed it, all done */
			}
			else {
				/* hack-set in_menu_bar bool so that the widgets themselves
				 * can avoid consuming any alt-modified key.  Can't simply
				 * break out here, because of the possibility that there
				 * are alt-<key> mnemonics defined in the menubar or
				 * default menubar.....(such alt- mnemonics aren't a great
				 * idea in a menubar; can lead to ambiguity)
				 */
				in_menu_bar = TRUE;
			}
		}
		
/* precheck whether key appears in menubar bindings */		
		mP = NULL;
		if (d_w->parent->menuBar) {
			mP = d_w->parent->menuBar->popups;
		}
		if (!mP) {
			mP = AxDialogKeyBindings;  /* default dialog-box menubar */
		}
		if (mP) {
			if (!in_menu_bar) {
				in_menu_bar =
					(NULL != (char *)xmKeysymInMenubar(mP, eventP,
											   xmPreprocessKeysym(ksym)));
			}
			if (AxDialogKeyBindings) {
				in_default_menu_bar =
					(NULL != (char *)xmKeysymInMenubar(AxDialogKeyBindings,
													   eventP,
											   xmPreprocessKeysym(ksym)));
			}
		}
        
        xmDialogFocus(d_w, TRUE);  /* just to ensure d_w->hasFocus==true */

/* give the key-focus widget a chance to consume the keystroke */
        
		consumed = xmWidgetKeyPressHandler(xmKeyFocusWidget(d_w),
										   eventP, ksym, buf, num_chars,
										   in_menu_bar || in_default_menu_bar);
        if (!consumed) {
/* finally, check whether keystroke matches menubar- or dialog-box-binding */
            char *name;
            int is_text;
            XmRowColumnCallbackStruct data;
            menu_item_def md;
            int flag;
            int bell;

            mP = NULL;

            /*
             * If this dialog has a menu bar, see if key event is an 
             * accelerator in the menu bar.
             */
            if (d_w->flags & WFLG_IN_EDIT) {
                /* use de's menubar for key accels */
                if(deMenuBarKey(d_w, eventP))
                    break;
            }
            else {
                if ( d_w->parent->menuBar )              /* fetch menu bar */
                    mP = d_w->parent->menuBar->popups;
                if ( ProcessKeyEvent(mP,eventP,&is_text,&name,&bell) &&
                    !is_text ) {
                    
                    if ( AxIsCommandAvailable(d_w->parent, name) ) {
						if ( d_w->parent->menuBar->callback ) {
							md.word2 = name; /*md for ElfXCmenuBarSelected()*/
							AxCallback(d_w->parent->menuBar->callback,
									   d_w->parent->menuBar,
									   d_w->parent->menuBar->callbacktag,&md);
						}
						break;  /* found in d_w->parent->menuBar, that wins */
					}
					if (!in_default_menu_bar) {
						break;  /* in neither menubar, all done */
					}
                }
            }

            /*
             * See if key event is an accelerator in dialog key bindings
             */
            if ( DECKeyboardMode && (ksym == XK_F16) ) {  
                DlgExecute(d_w);  /* an old HACK for DECs */
                break;
            }
            mP = AxDialogKeyBindings;   /* dialog key bindings */
            if (ProcessKeyEvent(mP,eventP,&is_text,&name,&bell) && !is_text) {
                if (!CallDlgFuncFromName(d_w, name)) {
                    VfyContext(0);
                    ElfbNewTask(name,"");
                }
                break;
            }
            
        }
        break;

    case KeyRelease:
        TimeOfButtonPress = eventP->xkey.time;
        if ( TaskOfWidgetPended(wp) )
            return((Window)NULL);
        if ( AxInfoMessages && !IsWinInfoBox(window) ) {
            KeepMessageBoxOnTop(eventP);
            return((Window)NULL);
        }
        
        num_chars = AXLookupString16(eventP, &buf, &ksym);

        if (AxControlKeyDown == ksym)
            AxControlKeyDown = 0;

/* Pass event back up to application window if this is not a dialog box */

        xmContainerWidgetPointer(wp, &d_w, &work_w);
        if (work_w) {
            return (work_w->window);
        }
        if (!d_w) {
            return((Window)NULL);
        }
		if (ButtonArmed) {
			ArmButton(ButtonArmed, TRUE, eventP);
		}
        break;

    case ButtonPress:
        TimeOfButtonPress = bep->time;
        AxSetKeyModifiers(bep->state);
        
        if (wp->type == W_DIALOG ||
            (wp->parent && wp->parent->type == W_DIALOG)) {
            
            Window twin = (Window)NULL;
            
            if (wp->type == W_DIALOG) {
                twin = wp->window;
                xmDialogFocus(wp, TRUE);
            }
            else if (wp->parent && wp->parent->type == W_DIALOG) {
                twin = wp->parent->window;
                xmDialogFocus(wp->parent, TRUE);
            }
			if (twin) {
				AXSetInputFocus(twin, TRUE, TimeOfButtonPress);
			}
        }
        
        if ( TaskOfWidgetPended(wp) ) {
            if ( !(wp->type == W_SCROLL && wp->parent->type == W_DIALOG) ) {
                /* scrollbars connected to widgets remain active */
                RingTheBell();
                ClickWidget = NULL;
                return((Window)NULL);
            }
        }
        if ( AxInfoMessages && !IsWinInfoBox(window) ) {
            KeepMessageBoxOnTop(eventP);
            ClickWidget = NULL;
            return((Window)NULL);
        }
        if ( ElfInLearnMode ) {
            parent = (AXWidget)wp->parent;
            while ( parent ) {
                if ( parent->type == W_MAIN ) {
                    if ( ((AXWidget_main)parent)->disable_record )
                        return((Window)NULL);
                    else
                        break;
                }
                parent = (AXWidget)parent->parent;
            }
        }
        if ( AxButtonDown != (int)bep->button ) {
            /* button already down - ignore event */
            ClickWidget = NULL;
            break;
        }
        leftButton   = (AxButtonDown == Button1);
        middleButton = (AxButtonDown == Button2);
        rightButton  = (AxButtonDown == Button3);
#if LINUX
        upButton = (AxButtonDown == Button4);
		downButton = (AxButtonDown == Button5);
#endif
		
        if (!(AxPulldownActive || AxPulldownStayup) &&
            ((W_DIALOG == wp->type) || (W_DIALOG == wp->parent->type))) {

            /* set keyboard focus to the widget just touched.
             */
            AXWidget press_w = (AXWidget) NULL;
            if (W_DIALOG == wp->type) {
                d_w = (AXWidget_dialog) wp;
                press_w = FindGadget(window, bep->x, bep->y);
            }
            else {
                d_w = (AXWidget_dialog) wp->parent;
                press_w = wp;
            }
            d_w->hasFocus = TRUE;   /* force true on click */
            if (press_w && (W_SCROLL == press_w->type)) {
                press_w = topWidget(press_w);
            }
            if (press_w && xmCanTakeKeyFocus(d_w, press_w, TRUE)) {
                xmTakeKeyFocus(press_w, bep, FALSE);
				if (press_w && (W_COMBO_BOX == press_w->type) &&
					press_w->flags & WFLG_EDITABLE) {
					
					ComboBoxInEditWindow = (AXWidget_combo_box) press_w;
				}
            }
        }
        
        if (wp->type == W_CANVAS) {
            if (rightButton && wp->rminfo) {
                RightButtonEvent(wp, OPTION_NEW, eventP);
                ClickWidget = NULL;
                break;
            }
			if (leftButton) {
				AxAutoScrollHandler();
			}
        }
        else if ( rightButton ) {
            RightButtonEvent(wp, OPTION_NEW, eventP);
            ClickWidget = NULL;
            break;
        }

#if LINUX /* implement mouse wheel scrolling */
        if ( (bep->button & 0xff) != Button1 && wp->type != W_CANVAS &&
			 wp->type != W_LIST && wp->type != W_EDITBOX &&
			 wp->type != W_TRAY && wp->type != W_TABLE) {
			/* enter, and combo_box only care about button 1 & 2 */
            if (!(middleButton && (wp->type == W_ENTER) ||
				  (wp->type == W_COMBO_BOX))) {
				ClickWidget = NULL;
				break;     /* widgets ONLY interested in button 1 */
            }
        }
#else
		/* Only canvas, edit box, enter, and combo box want non-button 1
		   events */
        if ( (bep->button & 0xff) != Button1 && wp->type != W_CANVAS) {
			/* editbox, enter, and combo_box only care about button 1 & 2 */
            if (!(middleButton && ((wp->type == W_EDITBOX) ||
								   (wp->type == W_ENTER) ||
								   (wp->type == W_COMBO_BOX)))) {
				ClickWidget = NULL;
				break;      /* widgets ONLY interested in button1 */
            }
        }
#endif
        if ( AxPulldownActive ) {
            ClickWidget = NULL;
            if (AxPulldownStayup) {
                PaintMenuPulldown(AxPulldownActive,OPTION_STAYUP_SELECT,
                                  eventP);
                break;
            }
            return((Window)NULL);
        }
        if ( leftButton && wp->type == W_SCROLL ) {
            AXWidget_scroll wsc;
            wsc = (AXWidget_scroll)wp;
            if ( THIMhelpMode )
                AxPostHelp(wsc);
            else
                ScrollBarEvent(wsc,eventP);
            wp->last_click_time = TimeOfButtonPress;
            if (wsc->armed==XmCR_INCREMENT || wsc->armed==XmCR_DECREMENT) {
                AxAutoScrollHandler();
            }
            ClickWidget = wp;
            break;
        }
        if ( (leftButton || middleButton) && wp->type == W_ENTER ) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else {
                EntryBoxEvent(wp, eventP);
            }
            ClickWidget = wp;
	    if (leftButton)
		AxAutoScrollHandler();
            break;
        }
#if LINUX /* mouse wheel scroll */
        if ( wp->type == W_LIST && (leftButton || middleButton ||
									upButton || downButton) ) {
#else
        if ( wp->type == W_LIST && (leftButton || middleButton) ) {
#endif
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else
                ListEvent(wp,eventP);
            ClickWidget = wp;
            break;
        }
        if ( wp->type == W_CANVAS ) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else
                CanvasEvent(wp, eventP);
            ClickWidget = wp;
            break;
        }
        if (wp->type == W_TABLE) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else
                TableEvent(wp, eventP);
            ClickWidget = wp;
            break;
        }
        if (wp->type == W_CHOOSE) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else
                ColorChooserEvent(wp, eventP);
            ClickWidget = wp;
        }
        if (wp->type == W_TRAY) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else
                TrayEvent(wp, eventP);
            ClickWidget = wp;
            break;
        }
        if ((leftButton || middleButton) && (wp->type == W_COMBO_BOX) &&
	    wp->mapped) {
	    if(ComboBoxMouseEvent(wp, eventP)) {
	      return((Window) NULL);
	    }
	    wp->last_click_time = TimeOfButtonPress;
            ClickWidget = wp;
	    if (leftButton)
	      AxAutoScrollHandler();
	    break;
        }
        if ( wp->type == W_EDITBOX ) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else {
                EditBoxEvent(wp, eventP);
            }
            ClickWidget = wp;
	    if (leftButton) {
		AxAutoScrollHandler();
	    }
            break;
        }
        if ( wp->type == W_RIBBON ) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else {
                ArmRibbon(wp, eventP);
            }
            ClickWidget = wp;
            break;
        }
        if ( wp->type == W_PAGEBAR  ) {
            if ( THIMhelpMode )
                AxPostHelp(wp);
            else {
                ArmPageButton(wp, eventP);
            }
            ClickWidget = wp;
            break;
        }
        if ( wp->type == W_STATUS  && THIMhelpMode ) {
            AxPostHelp(wp);
            break;
        }
        savedwp = wp;
        if ( wp->type != W_MENUBAR ) {
            wp = FindGadget(window,bep->x,bep->y);
            if ( THIMhelpMode ) {
                if ( !wp ) {
                    AxPostHelp(0);
                }
                else if ( wp->parent && (wp->parent->type == W_TOOLBAR) ) {
                    menu_item_def *mP = NULL;
                    if ( bep->button !=
                        ((AXWidget_pushbutton)wp)->whichButton) {
                        
                        /* using wrong mouse button - warn but
                         * don't exit help mode */
                        RingTheBell();
                        break;
                    }
                    mP = MenuItemFromTool(wp);
                    if ( mP ) {
                        ElfPostHelp(mP->word2);
                        ElfbSetHelpMode(FALSE);
                    }
                    else
                        AxPostHelp(0);
                }
                else {
                    AxPostHelp(wp);
                }
                ClickWidget = NULL;
                break;
            }
        }

        if ( leftButton && !wp && savedwp->type == W_RULER )
            AxSendMes(savedwp->taskOwner,eventP,sizeof(*eventP),APXSERVER);

        if ( !wp ) {
            ClickWidget = NULL;
            ResetActive();
            break;
        }

        if (leftButton && wp->type == W_ROWCOL && wp->mapped) { /* sgd */
            PaintRowColumnPulldown(wp, OPTION_NEW, eventP);
            ClickWidget = NULL;
            break;
        }
        if ( wp->type == W_MENUBAR ) {
            ClickWidget = NULL;
            PaintMenuPulldown(wp,OPTION_NEW,eventP);
            break;
        }
        if ( wp->type == W_OPTION ) {
            PaintOptionPulldown(wp,OPTION_NEW,eventP);
            ClickWidget = NULL;
            break;
        }
        ResetActive();
        if ( wp->type == W_BUTTON ) {
            int long_time;
            long_time = 
                ((TimeOfButtonPress - DoubleMillisec >= wp->last_click_time) ||
                 (wp != ClickWidget));
            if ( long_time || wp->multi_pick ) {
                ArmButton(wp,FALSE,eventP);
            }
            wp->last_click_time = TimeOfButtonPress;
            ClickWidget = wp;
        }
        else if ( leftButton && wp->type == W_TOGGLE ) {
            ClickWidget = wp;
			xmToggleAction((AXWidget_togglebutton) wp);
        }
        else if ( leftButton && (wp->type == W_SPLITTER) ) {
            ArmSplitter(wp, eventP);
        }
        else if ( leftButton && (wp->type == W_SCALE) ) {
            ArmScale(wp, eventP);
        }
        else if ( leftButton && (W_RECT == wp->type) ) {
            RectEvent(wp, eventP);
        }
        ClickWidget = wp;
        break;

    case ButtonRelease:
        TimeOfButtonRelease = bep->time;
#if LINUX
		if ((bep->button & 0xff) == Button4 || (bep->button & 0xff) == Button5)
			return((Window)NULL);
#endif
        if ( TaskOfWidgetPended(wp) ) {
            if ( !(wp->type == W_SCROLL && wp->parent->type == W_DIALOG) ) {
                /* scrollbars connected to widgets remain active */
                return((Window)NULL);
            }
        }
        if ( AxInfoMessages && !IsWinInfoBox(window) ) {
            KeepMessageBoxOnTop(eventP);
            return((Window)NULL);
        }
        /* 
         * widgets ONLY interested if ButtonRelease corresponds to 
         * the arming ButtonDown (AxButtonDown==0 in such a case) and
         * if the button is valid
         */

        if (wp->type == W_CANVAS) {
            if ( ((bep->button & 0xff) == Button3) &&  RightButtonArmed ) {
                /* button3 menu action */
                RightButtonEvent(RightButtonArmed, OPTION_DONE, eventP);
                break;
            }
        }
        else if ( (bep->button & 0xff) == Button3 ) {
            if ( RightButtonArmed )
                RightButtonEvent(RightButtonArmed, OPTION_DONE, eventP);
            break;
        }
        if ( wp->type != W_CANVAS && 
            (AxButtonDown || (bep->button & 0xff)!=Button1) )  {
            if (!((bep->button & 0xff)==Button2 
                  && wp->type==W_EDITBOX)) {
                /* editboxes interested in middle button */
                break; 
            }
        }
        if ( StrokingBar ) {
            ScrollBarEvent(StrokingBar,eventP);
            break;
        }
        else if ( ScrollBarArmed ) {
            ScrollBarArmed->armed = 0;
            ScrollBarArmed = (AXWidget_scroll)NULL;
        }
        if (ListBoxArmed) {
            ListBoxArmed->armed = 0;
            ListBoxArmed = (AXWidget_list) NULL;
        }
        if (TableArmed) {
            TableArmed->armed = 0;
            TableArmed = (AXWidget_table) NULL;
        }
        if ( MenuArmed ) {
            PaintOptionPulldown(MenuArmed,OPTION_DONE,eventP);
            break;
        }
        if (RowColumnArmed) {
            PaintRowColumnPulldown(RowColumnArmed, OPTION_DONE, eventP);
            break;
        }
        if (ComboBoxArmed || (AXWidget_combo_box)wp == ComboBoxInEditWindow) {
	    ComboBoxMouseEvent(wp, eventP);
	    break;
	}
        if ( PopupArmed ) {
            PaintPopupPulldown(PopupArmed,OPTION_DONE,eventP);
            break;
        }
        if ( AxPulldownActive ) {
            PaintMenuPulldown(AxPulldownActive,OPTION_DONE,eventP);
            break;
        }
        if ( SplitterArmed ) {
            ArmSplitter(SplitterArmed, eventP);
            break;
        }
        if ( ScaleArmed ) {
            ArmScale(ScaleArmed, eventP);
            break;
        }
	if (wp->type == W_ENTER) {
	    EntryBoxEvent(wp, eventP);
	    break;
	}
        if (wp->type == W_EDITBOX ) {
            EditBoxEvent(wp, eventP);
            break;
        }
        if (wp->type == W_LIST) {
            ListEvent(wp, eventP);
            break;
        }
        if (wp->type == W_TABLE) {
            TableEvent(wp, eventP);
            break;
        }
        if (wp->type == W_TRAY) {
            TrayEvent(wp, eventP);
            break;
        }
        if (wp->type == W_CHOOSE) {
            ColorChooserEvent(wp, eventP);
            break;
        }
        if (wp->type == W_PAGEBAR) {
            ArmPageButton(wp, eventP);
            break;
        }
        if (wp->type == W_CANVAS) {
            CanvasEvent(wp, eventP);
            break;
        }
        savedwp = wp;
        wp = FindGadget(window,bep->x,bep->y);
        if ( RibbonArmed ) {
            ArmRibbon(RibbonArmed, eventP);
            break;
        }
        if (savedwp->type == W_RULER && (!wp || !ButtonArmed )) {
            ResetActive();
            AxSendMes(savedwp->taskOwner,eventP,sizeof(*eventP),APXSERVER);
        }
        else if ( ButtonArmed ) {
            ArmButton(wp,TRUE,eventP);
        }
        ResetActive();
        break;
        
    case MotionNotify:
        PointerHasMoved = TRUE;
#if SUPPORT_HP_VUE
        XFlush(Dpy);
        if (XtPending())
#else
            if ( XPending(Dpy) )
#endif
                return((Window)NULL);
        if ( StrokingBar ) {
            XEvent nextmot;
            while (XCheckWindowEvent(Dpy, StrokingBar->window,
                                     ButtonMotionMask, &nextmot)) {
                memcpy(eventP, (char *) &nextmot, sizeof(XEvent));
            }
            ScrollBarEvent(StrokingBar,eventP);
            break;
        }
        if ( RightButtonArmed ) {
            RightButtonEvent(RightButtonArmed, OPTION_MOVE, eventP);
            break;
        }
        if ( MenuArmed ) {
            PaintOptionPulldown(MenuArmed,OPTION_MOVE,eventP);
            break;
        }
        if ( PopupArmed ) {
            PaintPopupPulldown(PopupArmed,OPTION_MOVE,eventP);
            break;
        }
        if (RowColumnArmed) {
            PaintRowColumnPulldown(RowColumnArmed, OPTION_MOVE, eventP);
            break;
        }
        if (ComboBoxArmed || (AXWidget_combo_box)wp == ComboBoxInEditWindow) {
	    ComboBoxMouseEvent(wp, eventP);
	    break;
        }
	if (wp->type == W_ENTER) {
	    EntryBoxEvent(wp, eventP);
	    break;
	}
        if ( AxPulldownActive ) {
            if ( !AxButtonDown || AxButtonDown!=Button1 )  {
                break;  
            }
            PaintMenuPulldown(AxPulldownActive,OPTION_MOVE,eventP);
            break;
        }
        if ( wp->type == W_RULER ) {
            AxSendMes(wp->taskOwner,eventP,sizeof(*eventP),APXSERVER);
            break;
        }
        if ( SplitterArmed ) {
            ArmSplitter(SplitterArmed, eventP);
            break;
        }
        if ( ScaleArmed ) {
            ArmScale(ScaleArmed, eventP);
            break;
        }
        if (wp->type == W_CANVAS) {
            CanvasEvent(wp, eventP);
            break;
        }
        else if ( wp->type == W_EDITBOX ) {
            EditBoxEvent(wp, eventP);
            break;
        }
        else if (wp->type == W_TRAY) {
            TrayEvent(wp, eventP);
            break;
      }
      else if (wp->type == W_TABLE) {
          AXWidget_table w_t;

          w_t = (AXWidget_table)wp;
          TableEvent(w_t, eventP);
          /*          if (w_t->multi_pick) { */
          w_t->last_click_time = TimeOfButtonPress;
          if (w_t->armed==XmCR_INCREMENT || w_t->armed==XmCR_DECREMENT) {
              AxAutoScrollHandler();
          }
          /*          } */
          break;
      }
      else if (wp->type == W_CHOOSE) {
          ColorChooserEvent(wp, eventP);
          break;
      }
      else if (wp->type == W_LIST) {
          AXWidget_list wl;
          
          wl = (AXWidget_list)wp;
          ListEvent(wl, eventP);
          if (wl->multi_pick) {
              wl->last_click_time = TimeOfButtonPress;
              if (wl->armed==XmCR_INCREMENT || wl->armed==XmCR_DECREMENT) {
                  AxAutoScrollHandler();
              }
          }
          break;
      }
        savedwp = wp;
        wp = FindGadget(window,mep->x,mep->y);
        if (ButtonArmed) {
            /* button may need to be hilighted/unhighlighted */
            ArmButton(ButtonArmed, FALSE, eventP);
            if (wp && wp->type==W_BUTTON &&
                (AXWidget_pushbutton)wp != ButtonArmed && 
                wp->parent->type!=W_PALETTE && 
                wp->parent->type!=W_PLATES && 
                wp->parent->type!=W_RULER) {
                /* new button has been choosen */
                ButtonArmed->changed = FALSE;
                ButtonArmed = 0;
                ArmButton(wp,FALSE,eventP);
            }
        }
        break;
        
    case SelectionRequest:
    case SelectionNotify:
    case SelectionClear:
        if (wp->type == W_EDITBOX)
	  EditBoxEvent(wp, eventP);
        else if (wp->type == W_ENTER)
	  EntryBoxEvent(wp, eventP);
	else if ((wp->type == W_COMBO_BOX) && (wp->flags & WFLG_EDITABLE))
	  ComboBoxSelectionCB(wp, eventP);
        AxDndHandleEvent(eventP);
        break;
    }  /* switch (event.type) */
    return(retval);
}


/* : xmContainerWidgetPointer - return one of W_DIALOG or
 * W_WORK widget pointers, representing the dialog-box or
 * application-window, respectively, that should dispatch
 * the event associated with the passed widget's window.
 * A subroutine of ZXtDispatchEvent.
 */
static void
xmContainerWidgetPointer(wp, w_dialog, w_work)
AXWidget wp;                   /* in: event widget */
AXWidget_dialog *w_dialog;     /* out: return non-null if resolves to dbox */
AXWidget_work   *w_work;       /* out: return non-null if to app work widg */
{
    AXWidget_main mw;
    
    *w_dialog = (AXWidget_dialog) NULL;
    *w_work = (AXWidget_work) NULL;
    
    if ((wp->type != W_DIALOG) && (wp->type != W_MAIN)) {
        wp = (AXWidget) wp->parent;
    }
    if (wp->type == W_MAIN) {
        mw = (AXWidget_main) wp;
        if (mw->workWindow) {
            *w_work = mw->workWindow;
            return;
        }
        else if (mw->dialog) {
            *w_dialog = mw->dialog;
            return;
        }
    }
    else {
        if (W_DIALOG == wp->type) {
            *w_dialog = (AXWidget_dialog) wp;
        }
        return;
    }
}   

static void
doExpose(wp, exP)
AXWidget wp;
XExposeEvent *exP;
{
	if ( (wp->type == W_RULER) || (wp->type == W_PLATES) ) {
		if (exP)
			AxSendMes(wp->taskOwner, exP, sizeof(*exP), APXSERVER);
	}
	else if (wp->type == W_DIALOG) {
		RepaintDialog(wp, exP, TRUE, TRUE);
	}
	else if (wp->type == W_FRAME) {
		AXWidget_main mw = wp->parent;
		if (mw && mw->dialog) {
			RepaintDialog(mw->dialog, exP, TRUE, TRUE);
		}
	}
	else if (wp->painter) {
		(*wp->painter)(wp, exP, TRUE, TRUE);
	}
}

/*************************************************************************
function: CallDlgFuncFromName - Call function associated with "name"
( "name" is the macro name bound the pressed key ).
Return TRUE if successful.
*/
static int
CallDlgFuncFromName(w, name)
AXWidget_dialog w;
char *name;
{
	int ix;

	/* search through list for name */
	for ( ix = 0; AxDlgKeyFuncList[ix].name; ix++ ) {
		if ( streq(name, AxDlgKeyFuncList[ix].name) ) {
			if ( AxDlgKeyFuncList[ix].func ) {
				/* call function and return its status */
				return( (*AxDlgKeyFuncList[ix].func)(w) );
			}
			break;
		}

	}
	return(FALSE);
}

static int
DlgCancel(d_w)
AXWidget_dialog d_w;
{
  if ( d_w->cancelButton && !d_w->cancelButton->disabled ) {
    ArmButton(d_w->cancelButton, FALSE, NULL);
  }
  return(TRUE);
}

static int
DlgExecute(d_w)
AXWidget_dialog d_w;
{

	if ( d_w->currentDefaultButton && !d_w->currentDefaultButton->disabled ) {
		ArmButton(d_w->currentDefaultButton, FALSE, NULL);
	}
	else {
		AXWidget foc = xmKeyFocusWidget(d_w);
		if (foc && (W_BUTTON == foc->type)) {
			/* no default, so give the press to the in-focus pushbutton
			 */
			ArmButton(foc, FALSE, NULL);
		}
	}
	return(TRUE);
}

static int
DlgNextField(d_w)
AXWidget_dialog d_w;
{
	AXWidget childP, nextChildP;

	{
		/* default, algorithmic focus ordering
		 */
		childP = xmKeyFocusWidget(d_w);
		if (!childP) {
			childP = d_w->lastWidgetFocus;
		}
		nextChildP = TabToNextWidget(childP, d_w);
	}
	return(TRUE);
}

static int
DlgPrevField(d_w)
AXWidget_dialog d_w;
{
	AXWidget childP, prevChildP;

	{
		/* default, algorithmic focus ordering
		 */
		childP = xmKeyFocusWidget(d_w);
		if (!childP) {
			childP = d_w->lastWidgetFocus;
		}
		prevChildP = TabToPrevWidget(childP, d_w);
	}
	return(TRUE);
}

static int
DlgDeleteBack (d_w)
AXWidget_dialog d_w;
{
	AXWidget childP, wtmp;

	wtmp = xmKeyFocusWidget(d_w);
	if ( wtmp && wtmp->type == W_TABLE ) {
		TblBackwardCharErase(wtmp);
		return(TRUE);
	}

	/* get active text widget */
	childP = ElfbGetActiveWidget(d_w);
	if ( !(childP || ComboBoxInEditWindow) )
		return(TRUE);  /* no text area, or not active - ignore request */

	if ( childP && childP->type == W_EDITBOX ) {
		EditBoxBackwardDeleteChar(childP);
		return(TRUE);
	}
	else {
		struct edit_window *ee = 0;
		if (ComboBoxInEditWindow) {
			ee = &ComboBoxInEditWindow->edit_win;
			childP = (AXWidget) ComboBoxInEditWindow;
		}
		else if ( childP && childP->type == W_ENTER ) {
			ee = &(((AXWidget_entry)childP)->edit_win);
		}
		if (ee) {
			EditWinManageDelete(childP, ee);
			return(TRUE);
		}
	}
	return(FALSE);
}

static int
DlgDeleteForward (d_w)
AXWidget_dialog d_w;
{
	AXWidget childP, wtmp;

	wtmp = xmKeyFocusWidget(d_w);
	if ( wtmp && wtmp->type == W_TABLE ) {
		TblEraseChar(wtmp);
		return(TRUE);
	}

	/* get active text widget */
	childP = ElfbGetActiveWidget(d_w);
	if ( !(childP || ComboBoxInEditWindow) )
		return(TRUE);  /* no text area, or not active - ignore request */

	if ( childP && childP->type == W_EDITBOX ) {
		EditBoxForwardDeleteChar(childP);
		return(TRUE);
	}
	else {
		struct edit_window *ee = 0;
		if (ComboBoxInEditWindow) {
			ee = &ComboBoxInEditWindow->edit_win;
			childP = (AXWidget) ComboBoxInEditWindow;
		}
		else if ( childP && childP->type == W_ENTER ) {
			ee = &(((AXWidget_entry)childP)->edit_win);
		}
		if (ee) {
			if ((ee->cursor_pos < ee->text_len) &&
				!(childP->pending_delete) && (ee->text_len > 0)) {
				
				ee->cursor_pos++;
				EditWinManageDelete(childP, ee);
			}
			else if (childP->pending_delete) {
				EditWinManageDelete(childP, ee);
			}
			return(TRUE);
		}
	}
	return(FALSE);
}

/* : DlgSendKeyBindingPoke - sub used by DlgCut/Copy/Paste.  Basically,
 * poke the elf layer to get it to perform the action from up there.
 */
static void
DlgSendKeyBindingPoke(d_w, macro)
AXWidget_dialog d_w;
mbchar *macro;
{
	data_ptr aP;
	
	if (d_w->elfObject) {
		data_ptr subP;
		
		aP = AxMakeArray(3);
		aP = AxAddArrayToArray(aP, 0, AxCopyData((data_ptr) d_w->elfObject));
		aP = AxAddStrToArray(aP, 1, NXLT("poke_"));
		subP = AxMakeArray(2);
		subP = AxAddIntToArray(subP, 0, POKE_DLG_KEYMACRO);
		subP = AxAddStrToArray(subP, 1, macro);
		aP = AxAddArrayToArray(aP, 2, subP);
		SendElfData(d_w->taskOwner, POKE_OBJECT_THROW, aP);
	}
	else {
		aP = AxMakeArray(1);
		aP = AxAddStrToArray(aP, 0, macro);
		SendElfData(d_w->taskOwner, POKE_DLG_KEYMACRO, aP);
	}
	AxFreeData(aP);
}

static int
DlgCut (d_w)
AXWidget_dialog d_w;
{
	DlgSendKeyBindingPoke(d_w, NXLT("DLG.CUT"));
	return TRUE;
}

static int
DlgCopy (d_w)
AXWidget_dialog d_w;
{
	DlgSendKeyBindingPoke(d_w, NXLT("DLG.COPY"));
}

static int
DlgPaste (d_w)
AXWidget_dialog d_w;
{
	DlgSendKeyBindingPoke(d_w, NXLT("DLG.PASTE"));
}


DrawShadow (d, top_GC, bottom_GC, size, x, y, width, height,olshadow)
     Drawable d;
     GC top_GC;
     GC bottom_GC;
     register int size;
     register int x;
     register int y;
     register int width;
     register int height;
     int olshadow;
{
  mtDrawShadow (d,top_GC,bottom_GC,size,x,y,width,height);
}

static void mtDrawShadow (d, top_GC, bottom_GC, size, x, y, width, height)
     Drawable d;
     GC top_GC;
     GC bottom_GC;
     register int size;
     register int x;
     register int y;
     register int width;
     register int height;
{
  GC topGC, bottomGC;
  int fillmode;
  static XRectangle * rects = NULL;
  static int rect_count = 0;
  register int i;
  register int size2;
  register int size3;

  if ( Thim2dMode && (top_GC != bottom_GC) ) {    /* ??x LINES INSTEAD */
    size = 1;
    top_GC = bottom_GC = ForeGC;
  }

  if (size <= 0) return;
  if (size > width / 2) size = width / 2;
  if (size > height / 2) size = height / 2;
  if (size <= 0) return;

  size2 = size + size;
  size3 = size2 + size;

  if (rect_count < size) {
    rects = (XRectangle *)realloc(rects,sizeof(XRectangle) * size * 4);
    rect_count = size;
  }

  for (i = 0; i < size; i++) {
    /*  Top segments  */
    rects[i].x = x;
    rects[i].y = y + i;
    rects[i].width = width - i;
    rects[i].height = 1;
    /*  Left segments  */
    rects[i + size].x = x + i;
    rects[i + size].y = y;
    rects[i + size].width = 1;
    rects[i + size].height = height - i;
    /*  Bottom segments  */
    rects[i + size2].x = x + i + 1;
    rects[i + size2].y = y + height - i - 1;
    rects[i + size2].width = width - i - 1;
    rects[i + size2].height = 1;
    /*  Right segments  */
    rects[i + size3].x = x + width - i - 1;
    rects[i + size3].y = y + i + 1;
    rects[i + size3].width = 1;
    rects[i + size3].height = height - i - 1;
  }
  XFillRectangles (Dpy, d, top_GC, &rects[0], size2);
  XFillRectangles (Dpy, d, bottom_GC, &rects[size2], size2);
}

void
mtDrawBevel(drw, topGC, bottomGC, x, y, width, height, thickness)
     Drawable drw;
     GC topGC;
     GC bottomGC;
     int x, y, width, height;
     int thickness;
{
  int fillmode;
  static XRectangle * rects = NULL;
  static int rect_count = 0;
  register int i;
  register int thickness2;
  register int thickness3;

  if ( Thim2dMode && (topGC != bottomGC) ) {    /* ??x LINES INSTEAD */
    thickness = 1;
    topGC = bottomGC = ForeGC;
  }
    
  if (thickness <= 0)
    return;
  if (thickness > width / 2)
    thickness = width / 2;
  if (thickness > height / 2)
    thickness = height / 2;
  if (thickness <= 0)
    return;
    
  thickness2 = thickness + thickness;
  thickness3 = thickness2 + thickness;
    
  if (rect_count < thickness) {
    rects = (XRectangle *)
      realloc(rects,sizeof(XRectangle) * thickness * 4);
    rect_count = thickness;
  }
    
  for (i = 0; i < thickness; i++) {
    /*  Top segments  */
    rects[i].x = x;
    rects[i].y = y + i;
    rects[i].width = width - i;
    rects[i].height = 1;
    /*  Left segments  */
    rects[i + thickness].x = x + i;
    rects[i + thickness].y = y;
    rects[i + thickness].width = 1;
    rects[i + thickness].height = height - i;
    /*  Bottom segments  */
    rects[i + thickness2].x = x + i + 1;
    rects[i + thickness2].y = y + height - i - 1;
    rects[i + thickness2].width = width - i - 1;
    rects[i + thickness2].height = 1;
    /*  Right segments  */
    rects[i + thickness3].x = x + width - i - 1;
    rects[i + thickness3].y = y + i + 1;
    rects[i + thickness3].width = 1;
    rects[i + thickness3].height = height - i - 1;
  }
  XFillRectangles (Dpy, drw, topGC, &rects[0], thickness2);
  XFillRectangles (Dpy, drw, bottomGC, &rects[thickness2], thickness2);
}


void DrawHorizGroove(d,x,y,width)
     Drawable d;
     int x,y,width;
{
  if ( !Thim2dMode )
    XDrawLine(Dpy,d,ShadowGC,x,y,x+width,y);
  XDrawLine(Dpy,d,SunGC,x,y+1,x+width,y+1);
}

void DrawVertGroove(d,x,y,height)
     Drawable d;
     int x,y,height;
{
  if ( !Thim2dMode )
    XDrawLine(Dpy,d,ShadowGC,x,y,x,y+height);
  XDrawLine(Dpy,d,SunGC,x+1,y,x+1,y+height);
}

void XtFree(p)
     char *p;
{
  abort();
}


/*
    Do not use XmStringCreateLtoR from Xm.h as SCO's latest X
    development system typedefs XmString to a struct pointer
    instead of a char pointer, causing it to come up redefined
    when we defined it to String ( a char pointer ) below.
    Also changed this name in dwt2xm.h.
*/
String AxXmStringCreateLtoR(p,x)
     String p;
     int x;
{
  return(strcpy(malloc(strlen(p)+1),p));
}



WidgetClass applicationShellWidgetClass;

void BoxDone(widget,tag)
     AXWidget widget;
     Widget tag;
{
  AxXtDestroyWidget(tag);
}

/*************************************************************************
function: AXmCreateErrorDialog - Post message box
*/
AXWidget_main
AXmCreateErrorDialog (parentWidget,name,args,cnt)
     register AXWidget parentWidget;
     register char *name;
     register Arg args[];
     register int cnt;
{
  AXWidget_main dlgShell;
  AXWidget_dialog box;

  dlgShell = (AXWidget_main)XmCreateDlgShell(parentWidget,name,name);
  box = (AXWidget_dialog)AXmCreateBulletinBoardDialog(dlgShell,name,args,cnt);
  Messager(box,TRUE);
  return(dlgShell);
}

/*************************************************************************
function: AXmCreateInformationDialog - Post message box
*/
AXWidget_main
AXmCreateInformationDialog (parentWidget,name,args,cnt)
     register AXWidget parentWidget;
     register char *name;
     register Arg args[];
     register int cnt;
{
  AXWidget_main dlgShell;
  AXWidget_dialog box;

  dlgShell = (AXWidget_main)XmCreateDlgShell(parentWidget,name,name);
  box = (AXWidget_dialog)AXmCreateBulletinBoardDialog(dlgShell,name,args,cnt);
  Messager(box,FALSE);
  return(dlgShell);
}

/*************************************************************************
function: Messager - Post an info/error message box
*/
static void Messager (box,is_error)
     AXWidget_dialog box;
     int is_error;
{
  AXWidget_dialog wp;
  AXWidget xwp;
  char *linesP[50];
  char *buf;
  int num_lines = 1;
  char *p;
  char helpstr[20];
  int maxwid = 0;
  int thiswid = 0;
  Arg arg[10];
  int n = 0;
  int y, ix;

  is_error = FALSE;   /* ??1 for now, same presentation */

  /* tear down all other active widgets */
  AxExitPulldownStayupMode = TRUE;
  ResetActive();

  /* count the number of newlines */

  wp = box;
  wp->parent->async_message = wp->async_message = TRUE;
  buf = strcpy((char *)malloc(MBstrlen(wp->name)+1), (char *)wp->name);
  while ( p = strchr(buf,'\t') )  /* convert tabs to spaces (dumbly) */
    *p = ' ';

  linesP[num_lines-1] = buf;
  for ( p = buf; *p; p++ ) {
    if ( *p == '\n' ) {
      *p = 0;
      linesP[num_lines] = p+1;
      num_lines++;
      if ( thiswid >maxwid )
    maxwid = thiswid;
      thiswid = 0;
      if ( num_lines > 40 )
    break;
    }
    else {
      thiswid += CharWids[*p & 0xFF];
    }
  }
  if ( thiswid >maxwid )
    maxwid = thiswid;
  SetWidgetName(wp, " "); /* make message boxes nameless */
  wp->width = MAX(maxwid+60,250);

  /* not child of anything */
  wp->parent->notTransient = wp->notTransient = TRUE;

  /* apply text */

  y = 16;
#if BUILD_ORIENT          /*  {  */
   /* Ashisuto added for wide chars. The width of label can not be
    * calculated by CharWids[256]. The real width are in LabelGadget xwp.
    * If you do the calculation here, the above addition of CharWids[]
    * and the variable "thiswid" will be superfluous.
    * 96.02.02
    */
   maxwid = 0;
    for ( ix = 0; ix < num_lines; ix++ ) {
        n = 0;
        XtSetArg(arg[n],XmNoldWidget,0); n++;
        XtSetArg(arg[n],XmNx,45); n++;
        XtSetArg(arg[n],XmNy,y); n++;
        xwp = AXmCreateLabelGadget(box,linesP[ix],arg,n);
        y += xwp->height;
       if (maxwid < xwp->width)
           maxwid = xwp->width;
    }
    wp->width = MAX(maxwid+60,250);

#else         /*  }  BUILD_ORIENT  {  */

  for ( ix = 0; ix < num_lines; ix++ ) {
    n = 0;
    XtSetArg(arg[n],XmNoldWidget,0); n++;
    XtSetArg(arg[n],XmNx,45); n++;
    XtSetArg(arg[n],XmNy,y); n++;
    xwp = (AXWidget)AXmCreateLabelGadget(box,linesP[ix],arg,n);
    y += xwp->height;
  }
#endif     /*  } */

  y += 10;
  free(buf);

  /* apply icon */
  n = 0;
  XtSetArg(arg[n],XmNoldWidget,0); n++;
  XtSetArg(arg[n],XmNflags,0); n++;
  if ( is_error ) {
    XtSetArg(arg[n],XmNvalue,NXLT("errorbox")); n++;
  }
  else {
    XtSetArg(arg[n],XmNvalue,NXLT("infobox")); n++;
  }
  XtSetArg(arg[n],XmNy,8); n++;
  XtSetArg(arg[n],XmNx,8); n++;
  ZXmCreateIconImage(box,NXLT("xxx"),arg,n);
    
  /* apply line */
  y = MAX(y,45);
  n = 0;
  XtSetArg(arg[n],XmNoldWidget,0); n++;
  XtSetArg(arg[n],XmNflags,0); n++;
  XtSetArg(arg[n],XmNx,0); n++;
  XtSetArg(arg[n],XmNy,y); n++;
  XtSetArg(arg[n],XmNwidth,wp->width); n++;
  XtSetArg(arg[n],XmNheight,0); n++;
  XtSetArg(arg[n],XmNthickness,0); n++;
  XmCreateRect(box,NXLT("line"),arg,n);
  y += 15;

  /* create the buttons */
  n = 0;
  XtSetArg(arg[n],XmNoldWidget,0); n++;
  XtSetArg(arg[n],XmNx,45); n++;
  XtSetArg(arg[n],XmNy,y); n++;
  XtSetArg(arg[n],XmNwidth,70); n++;
  XtSetArg(arg[n],XmNwhichButton,Button1); n++;
  wp->defaultButton = (AXWidget_pushbutton)AXmCreatePushButtonGadget(box,
                                     XLT("OK"),arg,n);
  wp->currentDefaultButton = wp->defaultButton;

  if ( wp->helpstr )
    strcpy(helpstr,wp->helpstr);
  else
    sprintf(helpstr,"%d",wp->helpid);

  wp->height = y + 40;
  return;
}

/*************************************************************************
function: ComputeMenuBarWidth - Assign w->menu_starts, w->menu_strs
*/
static void
ComputeMenuBarWidth (w,test_for_dynamic_noshow)
register AXWidget_menu w;
int test_for_dynamic_noshow;
{
	register menu_item_def *mP;
	register int pad, len, posleft;
	register int cnt = 0;
	int twidth;
	char *strs[MAX_MENU_ITEMS];
	short starts[MAX_MENU_ITEMS];
	register int xpos = 0;
	
	if ( !(mP = w->popups) )
		return;
	
	twidth = N2Width;
	posleft = NWidth;
	pad = N2Width;
	
	while ( TRUE ) {
		if ( mP->type == ITEM_MARK ) {
			if ( mP->ender )
				break;
		}
		else if ( mP->type == ITEM_MENU ) {
			starts[cnt] = twidth - posleft;
			if (SubMenuHidden(w,mP,test_for_dynamic_noshow) || !mP->word[0] )
				strs[cnt] = "";
			else {
				strs[cnt] = mP->word;
				if ( streq(mP->word,"*") )
					twidth += ASTER_MENU_WID + pad;
				else
					twidth += BasicStrlen(mP->word) + pad;
			}
			if ( ++cnt == MAX_MENU_ITEMS-1 )
				break;
		}
		mP++;
	}
	twidth -= NWidth;
	free(w->menu_strs);
	free(w->menu_starts);
	w->menu_strs = (char**)malloc(cnt*sizeof(char**));
	w->menu_starts = (short*)malloc(cnt*sizeof(short*));
	memcpy(w->menu_strs,strs,cnt*sizeof(char**));
	memcpy(w->menu_starts,starts,cnt*sizeof(short*));
	w->num_buttons = cnt;
	ShiftHelpRightMost(w);
}

/*************************************************************************
function: ShiftHelpRightMost - Move help pulldown to right edge of menubar
*/
static void ShiftHelpRightMost (w)
register AXWidget_menu w;
{
	register int pad = CharWids['n'];
	register int newpos, ix, wid, overlays;
	register int avail;
	AXWidget_main mw = (AXWidget_main) w->parent;
	
	ix = w->num_buttons-1;
	if ( ix < 0 )
		return;
	if ( !streq(w->menu_strs[ix],HELP_STR) )
		return;
	if (!w->width && w->parent) {
		w->width = w->parent->width;
	}
	avail = w->width;
	newpos = avail - BasicStrlen(HELP_STR) - pad;
	if ( ix != 0 ) {			/* keep from lying on top of preceding */
		while ( ((overlays = InMenuOpt(w,newpos)) != -1) &&
			   (overlays != ix) )
			newpos += 2;
	}
	w->menu_starts[ix] = newpos;
}

int InMenuOpt(w,x)  /* figure which menu bar option point is in */
     register AXWidget_menu w;
     register int x;
{
  register int pad;
  register int leftof, ix, wid;

  pad = CharWids['n'];

  for ( ix = 0; ix < w->num_buttons; ix++ ) {
    if ( *(w->menu_strs[ix]) == 0 ) /* hidden pulldown */
      continue;
    leftof = (x < w->menu_starts[ix]-pad);
    if ( ix == 0 ) {
      if ( streq(w->menu_strs[0],"*") ) {
    wid = ASTER_MENU_WID + pad;
      }
      else {
    wid = BasicStrlen(w->menu_strs[0]) + pad;
      }
      if ( leftof )
    return(-1);
      if ( x < w->menu_starts[0] + wid )
    return(0);
    }
    else if ( ix == w->num_buttons-1 ) {
      if ( streq(w->menu_strs[ix],"*") ) {
    wid = ASTER_MENU_WID;
      }
      else {
    wid = BasicStrlen(w->menu_strs[ix]);
      }
      if ( !leftof && (x < w->menu_starts[ix]+wid) )
    return(ix);
      else
    return(-1);
    }
    else if ( ix == w->num_buttons-2 ) {    /* item may be before Help */
      if ( streq(w->menu_strs[ix],"*") ) {
    wid = ASTER_MENU_WID;
      }
      else {
    wid = BasicStrlen(w->menu_strs[ix]);
      }
      if ( !leftof && (x < w->menu_starts[ix]+wid) )
    return(ix);
    }
    else if ( !leftof && (x < w->menu_starts[ix+1]-pad) )
      return(ix);
  }
  return(-1);
}

/*************************************************************************
function: AxCreateMenuBar - Create a menu bar widget
*/
AXWidget_menu
AxCreateMenuBar( parentWidget, mP, old_widget, flags, 
                 elf_obj, callback_func, pid, is_not_shared)
     register AXWidget parentWidget;
     register menu_item_def *mP; /* the elf menu bar data */
     AXWidget_menu old_widget;
     int flags;
     data_ptr elf_obj;
     void (*callback_func)();
     caddr_t pid;             /* a bad type, but that is how it is in the */
     /*  widget structure !  !!fix               */
     int is_not_shared;  /* TRUE if bar should be free'd when box goes away */
{
  register AXWidget_menu w;
  register int changing = FALSE;
  if ( !mP )
    return(0);

  if ( AxPulldownActive )
    ResetActive();
  if ( old_widget ) {
    /* we are nodifing an existing widget */
    w = old_widget;
    w->update_widget = TRUE;
    WidgetNeedsUpdated = TRUE;
    changing = TRUE;
    if ( w->unshared_menu_bar ) {
      free(w->popups);
      w->popups = NULL;
    }
  }
  else {
    w = (AXWidget_menu)CrtWidget(W_MENUBAR,parentWidget,"");
    w->unshared_menu_bar = is_not_shared;
  }
  w->parent->menuBar = w;
  w->popups = mP;
  w->height = AxCharHeight + 14;
  w->painter = PaintMenuBar;
  AddToWindowList(w);
  ComputeMenuBarWidth(w,FALSE);

  /* now set the various input flags and values into the widget */
  SetWidgetFlags( w, flags );
  if ( elf_obj != (data_ptr)NULL && !w->elfObject )
    w->elfObject = AxTaskCopyElfData(0,elf_obj);
  w->callback = callback_func;
  w->callbacktag = pid;

  ZXmCreateToolBar(parentWidget, mP, flags, elf_obj, callback_func, pid);
  return((AXWidget_menu)w);
}

/*************************************************************************
function: PaintMenuBar - Paint the menu bar in its static state
*/

static void
PaintMenuBar (w, exP, regen, layered)
     register AXWidget_menu w;
     XExposeEvent *exP;  /* NULL or exposure event.  If null, do all */
     int regen;
     int layered;
{
  register menu_item_def *mP;
  register GC gc;
  register char *p;
  register int cnt,x,y,width,height,ix;
  axolButton button;
  char asterixSymbol[2];
  int drawButton;
  int xoff;
  char *menu_keys;  /* array holding menu keys for menuBar items */
  char *key_start;
  int key_start_x, key_char_wid;

  if ( !w || w->type != W_MENUBAR )
    return;
  if ( w->parent && w->parent->dialog && w->parent->dialog->topmostwindow )
    return;
    
  if ( !WIN_OF(w) ) {
    return;
  }

  mP = w->popups;
  if ( !mP )
    return;

  if (exP && w->pulldown == exP->window) {
    PaintMenuPulldown(AxPulldownActive,OPTION_EXPOSE,exP);
    return;
  }
  else {
    regen = TRUE;
  }

  if ((w->flags & WFLG_IN_EDIT) && layered) {
    if (dePaintWidget(w))
      return;
  }

  if ( !w->window ) {
    w->width = w->parent->width;
    w->window = AxCrtWindow(Dpy,WIN_OF(w),
                0, 0,
                w->width, w->height,
                0,CopyFromParent,InputOutput,
                CopyFromParent,WinMask,&WinAtt);
    XSelectInput(Dpy, w->window, TM_ALL_INPUTS_MASK);
    AxMapWindow(w, Dpy, w->window, w->name);
    w->mapped = TRUE;
    ShiftHelpRightMost(w);
  }

#if LESS_MENU_PAINT
  w->regen_widget = FALSE;
  w->update_widget = FALSE;
#endif

  if (!w->width) {
	  w->width = w->parent->width;
  }
  width = w->width;
  height = w->height;

  /* blank and draw rect */
  XFillRectangle(Dpy, w->window, BackGC, 0, 0, width, height);
  AxDrawBevel(w, w->window, 0, 0, width, height, 2, BEVEL_OUT);

  y = 7;

  menu_keys = (char *)calloc(1,w->num_buttons);
  ix = 0;
  while ( TRUE ) {  /* this loop same as in ComputeMenuBarWidth() */
    if ( (mP->type == ITEM_MARK) && mP->ender )
      break;
    if ( mP->type == ITEM_MENU ) {
      if ( !SubMenuHidden(w,mP,FALSE) && mP->word[0] &&
       (mP->menu_key_str != (unsigned char *)NULL) )
    menu_keys[ix] = *(mP->menu_key_str);
      if ( ++ix == MAX_MENU_ITEMS-1 )
    break;
    }
    mP++;
  }
  for ( ix = 0; ix < w->num_buttons; ix++ ) {
    if ( streq(w->menu_strs[ix],"*") ) {
      if ( AxNewMailMenuIcon )
    XCopyArea(Dpy,LookupPixmap(NXLT("menu_mail")),
          w->window,ForeGC,0,0,ASTER_MENU_WID,ASTER_MENU_HT,
          w->menu_starts[ix],y-2);
      else
    XCopyArea(Dpy,LookupPixmap(NXLT("menu_ax")),
          w->window,ForeGC,0,0,ASTER_MENU_WID,ASTER_MENU_HT,
          w->menu_starts[ix],y-2);
    }
    else {
      axDrawString(Dpy, w->window, ForeGC,
           w->font ? w->font : AxDlgMainFont,
           w->menu_starts[ix], y+AxCharAbove,
           w->menu_strs[ix], strlen(w->menu_strs[ix]));
      if ( AxMarkMenuMnemonics && menu_keys[ix] ) {
    /* underline key mnemonic */
    key_start = MnemonicInString(menu_keys[ix],w->menu_strs[ix]);
    if ( key_start && key_start[0] ) {
      key_start_x = w->menu_starts[ix];
      key_start_x += BasicStrlen(w->menu_strs[ix]) -
        BasicStrlen(key_start);
      key_char_wid = CharWids[*key_start];
      XDrawLine(Dpy,w->window,ForeGC,
            key_start_x,y+AxCharHeight,
            key_start_x+key_char_wid,y+AxCharHeight);
    }
      }
    }
  }
  free(menu_keys);
  return;
}

/* : xmWidgetFontStruct - get an XFontStruct representing
 * the passed xlfd (X logical font description) name.  The
 * global font cache (should be) searched first, so that only those
 * font structs unique to the widget kit end up in the wkit's
 * private cache.
 */
XFontStruct *
xmWidgetFontStruct(xlfd)
     char *xlfd;
{
  fontMetrics *fm;
  char *errString;

  if (!xlfd || !(*xlfd)) {
    return ((XFontStruct *) NULL);
  }

  /* first look in the global fontcache */
  if (errString = axGetScreenMetrics(xlfd, (fontTabEnt *) NULL, &fm)) {
    freeErrString(errString);
    /* not in the global fontcache, so try
       the widgetkit's private cache */
    return(LookupFont(xlfd));
  }
  /* return reference from global fontcache */
  return(fm->xfont);
}

/*************************************************************************
function: LookupFont - Add and/or get font from cache.
Used to manage fonts for w->font buttons.
*/
static XFontStruct *
LookupFont(name)
     char *name;
{
  fontcache_t *font_struct;

  if ( !name || !name[0] )
    return(NULL);
    
  font_struct = LoadFontFromCache(name);
  if ( font_struct )
    return( font_struct->font );
  else
    return( (XFontStruct *) NULL );
}

static void
FreeFontInCache(font)
     XFontStruct *font;
{
  int ix;

  /*
   * This function only updates the number of widgets
   * using this font.  The font is freed only if the
   * font cache runs out of space (in LoadFontFromCache).
   */

  for ( ix = 0; ix < FontCacheSize; ix++ ) {
    if ( FontCache[ix].font == font ) {
      FontCache[ix].numInUse--;
      break;
    }
  }
}

static fontcache_t *
LoadFontFromCache(name)
     char *name;
{
  XFontStruct *font;
  int ix, slot, lru;

  /* search cache first */
  for ( ix = 0; ix < FontCacheSize; ix++ ) {
    if ( streq(FontCache[ix].name, name) ) {
      /* font found in cache */
      slot = ix;
      FontCache[slot].numInUse++;
      if ( FontCache[slot].LRUix < (FontCacheSize - 1) ) {
    /* This is not the most recently used font.
     * Make this the most recent, recompute LRU ages */
    lru = FontCache[slot].LRUix;
    FontCache[slot].LRUix = FontCacheSize - 1;
    for ( ix = 0; ix < FontCacheSize; ix++ ) {
      if ( FontCache[ix].LRUix > lru )
        FontCache[ix].LRUix--;
    }
      }
      return( &FontCache[slot] );
    }
  }

  /* font not in cache - needs to be loaded */
  font = AXLoadQueryFont(Dpy, name);
  if ( !font )
    return( (fontcache_t *) NULL );

  /* find slot in cache to hold new font */
  if ( FontCacheSize == MAX_WIDGET_FONTS ) {
    /* All slots in fonts cache used up.
     * Find the least recently used slot which is not in use, make
     * it the most recently used, and adjust the ages of the rest.
     */
    lru = MAX_WIDGET_FONTS;
    for ( ix = 0; ix < MAX_WIDGET_FONTS; ix++ ) {
      if ( (FontCache[ix].numInUse == 0) && (FontCache[ix].LRUix < lru) ) {
    slot = ix;
    lru = FontCache[ix].LRUix;
      }
      FontCache[ix].LRUix--;
    }
    if ( lru = MAX_WIDGET_FONTS ) {
      /* All slots in use.  MAX_WIDGET_FONTS should be
       * large enough so that this doesn't happen. */
      for ( ix = 0; ix < MAX_WIDGET_FONTS; ix++ ) {
    FontCache[ix].LRUix++;  /* update LRU ages */
      }
      AXFreeFont(Dpy, font);
      return( (fontcache_t *) NULL );
    }
    free(FontCache[slot].name);
    AXFreeFont(Dpy, FontCache[slot].font);
    FontCache[slot].LRUix = MAX_WIDGET_FONTS - 1;
    FontCache[slot].numInUse++;
  }
  else {
    /* slots available in cache - add font to cache */
    slot = FontCacheSize;
    FontCache[slot].LRUix = slot;
    FontCache[slot].numInUse++;
    FontCacheSize++;
  }

  FontCache[slot].name = strcpy( (char *)malloc(strlen(name)+1), name );
  FontCache[slot].font = font;

  return( &FontCache[slot] );
}




/*************************************************************************
function: HammerChildCallbackTags - What a HACK!
*/
HammerChildCallbackTags (w,tag)
     AXWidget w;
     caddr_t tag;
{
  AXWidget childP;

  for ( childP = w->widgets; childP; childP = childP->nextChild )
    childP->callbacktag = tag;
}

/*************************************************************************
function: MapChildren - Given main window id, map related dialogs
*/
MapChildren (mw)
     AXWidget_main mw;        /* main window widget */
{
  AXWidget w;

  for ( w = WindowList; w; w = w->nextWin ) {
    if ( (w->type == W_MAIN) &&
     ((AXWidget_main)w)->dialog && (w->parent == mw) )
      {
    AxMapWindow(w, Dpy,w->window, w->name);
    /* raise & set input focus at expose */
    ((AXWidget_main)w)->exposed = FALSE;
      }
  }
}

/*************************************************************************
function: UnMapChildren - Given main window id, unmap related dialogs
*/
UnMapChildren (mw)
     AXWidget_main mw;        /* main window widget */
{
  AXWidget w;

  for ( w = WindowList; w; w = w->nextWin ) {
    if ( (w->type == W_MAIN) &&
     ((AXWidget_main)w)->dialog && (w->parent == mw) )
      XUnmapWindow(Dpy,w->window);
  }
}


/*************************************************************************
function: AxRePaintAllMenuBars - Repaint all menubar windows
Currently called only if AxMarkMenuMnemonics profile setting has 
changed (Motif), or if "*" needs update because of new mail.
*/
AxRePaintAllMenuBars()
{
  AXWidget w;

  for ( w = WindowList; w; w = w->nextWin ) {
    if ( w->type == W_MENUBAR )
      PaintMenuBar(w, NULL, TRUE, TRUE);
  }
}


/*************************************************************************
function: KeepMessageBoxOnTop - Promote message box based on Focus events
*/
KeepMessageBoxOnTop (eventP)
     XEvent *eventP;
{
  AXWidget w;
  Window win;

  if ( (eventP->type == FocusIn) || (eventP->type == KeyPress) ||
       (eventP->type == ButtonPress) ||
       ((eventP->type == ClientMessage) 
    && (eventP->xclient.data.l[0] == AxWIN_TAKE_FOCUS)) ) {
    win = eventP->xany.window;
    if ( IsWinInfoBox(win) )
      return;
    for ( w = WindowList; w; w = w->nextWin )
      if ( w->window == win )
        RaiseMessageBoxToTop();
  }
}

/*
 * Adjust origin of pulldown to keep it on-screen.
 * The 8pix margin is arbitrary, but looks ok.
 */
void
AdjustPulldownOrigin( xp, yp, width, height, xadj, yadj )
     int *xp, *yp, width, height, *xadj, *yadj;
{
  int origx, origy;

  origx = *xp;
  origy = *yp;

  if (*xp < 8)
    {
      *xp = 8;
    }
  if (*xp + width > DpyWid)
    {
      *xp = DpyWid - width - 8;
    }
  if (*yp < 8)
    {
      *yp = 8;
    }
  if (*yp + height > DpyHt)
    {
      *yp = DpyHt - height - 8;
    }

  *xadj = *xp - origx;
  *yadj = *yp - origy;
}

void
axolPaintDropShadow( w, winp, x, y, width, height)   /* obsolete */
     AXWidget w;
     Window *winp;
     int x,y,width,height;
{
}

void
axolDrawPulldownChoice( win, width, text, accels, menus, flags,
            modifier, make_room_for_toggles, index)
     Window win;
     int width;
     char *text, **accels, *menus, *flags;
     int modifier, make_room_for_toggles;
     int index;
{
}

int
axolPulldownY(index)
     int index;
{
  return (PULLDOWN_Y + (OLBUTTON_HT * index));
}

/* For W_DIALOG's.
 * An OLIT window manager will read these properties to
 * determine window decorations.
 */
axolSetWinDecor(win, decorations)
     Window win;
     int decorations; /* bitmask */
{
}

int
axolTestPushPin(win)
     Window win;
{
}

void
axolDrawRadioChoice( win, gc, x, y, width, height, str, on, usePixmap )
     Window win;
     GC gc;
     int x, y, width, height;
     char *str;
     int on; /* when TRUE, choice gets double rect */
     int usePixmap;
{
}

void
axolDrawClrAbbrBtn(win, isDisabled, topGC, bottomGC, fillGC, triType, x, y)
     Window win;
     int isDisabled; /* draw triangle as disabled if true */
     GC topGC, bottomGC, fillGC;
     int triType; /* direction of arrow in button (see axolDrawClrTriangle) */
     int x, y;
{
}

/* Draw a triangle in color */
void
axolDrawClrTriangle(win, isDisabled, triType, x, y)
     Window win;
     int triType; /* TRITYPE_LEFT, TRITYPE_RIGHT, TRITYPE_DOWN, TRITYPE_UP */
     int isDisabled, x, y;
{
}

/* Draw a rectangle in color */
void
axolDrawClrRect(win,topGC,botGC,fillGC,fillmode,x,y,width,height)
     Window win;
     GC topGC, botGC, fillGC;
     int fillmode;  /* if 0, no fill */
     int x, y, width, height;
{
}



static int
axolMenuButtonWidth(name, asterix)
     char *name;
     int asterix; /* bool: true if this is the asterix menu button */
{
}

/*************************************************************************
function: AxModifierMapping - Set Asterix server-dependent modifier masks
from current modifier key mapping.
*/
AxModifierMapping()
{
  XModifierKeymap *modmap;
  KeySym ksym;
  int modifier_mask;
  int i, j, k = 0;
  char *mask_name;
  char *UPbyName();

  /* use profile choice for AxShiftMask if provided */
  mask_name = UPbyName(XLT("axShiftModifierName"));
  if ( mask_name && mask_name[0] ) {
    if ( modifier_mask = ModifierMaskFromName(mask_name) ) {
      AxShiftMask = modifier_mask;
    }
  }
  /* use profile choice for AxLockMask if provided */
  mask_name = UPbyName(XLT("axLockModifierName"));
  if ( mask_name && mask_name[0] ) {
    if ( modifier_mask = ModifierMaskFromName(mask_name) ) {
      AxLockMask = modifier_mask;
    }
  }
  /* use profile choice for AxControlMask if provided */
  mask_name = UPbyName(XLT("axControlModifierName"));
  if ( mask_name && mask_name[0] ) {
    if ( modifier_mask = ModifierMaskFromName(mask_name) ) {
      AxControlMask = modifier_mask;
    }
  }
  /* use profile choice for AxAltMask if provided */
  mask_name = UPbyName(XLT("axAltModifierName"));
  if ( mask_name && mask_name[0] ) {
    if ( modifier_mask = ModifierMaskFromName(mask_name) ) {
      AxAltMask = modifier_mask;
      /* don't set AltMask below - OK for now because Meta, NumLock
       * modifiers not used to set CurrentMods var in tmkeys.c  */
      return;
    }
  }

  /* set Asterix server-dependent modifier masks
   * from current server modifier map */

  modmap = XGetModifierMapping(Dpy);

  for ( i = 0; i < 8; i++ ) {
    modifier_mask = ModifierMaskFromIndex(i);
    for ( j = 0; j < modmap->max_keypermod; j++ ) {
      if ( modmap->modifiermap[k] ) {
    ksym = XKeycodeToKeysym(Dpy, modmap->modifiermap[k], 0);
    switch ( ksym ) {
    case XK_Alt_L:
    case XK_Alt_R:
      AxAltMask = modifier_mask;
      break;
    case XK_Meta_L:
    case XK_Meta_R:
      AxMetaMask = modifier_mask;
      break;
    case XK_Num_Lock:
      AxNumLockMask = modifier_mask;
    }
      }
      k++;
    }
  }

  XFreeModifiermap(modmap);
}

static int
ModifierMaskFromIndex(ix)
     int ix;
{
  switch ( ix ) {
  case ShiftMapIndex:
    return(ShiftMask);
  case LockMapIndex:
    return(LockMask);
  case ControlMapIndex:
    return(ControlMask);
  case Mod1MapIndex:
    return(Mod1Mask);
  case Mod2MapIndex:
    return(Mod2Mask);
  case Mod3MapIndex:
    return(Mod3Mask);
  case Mod4MapIndex:
    return(Mod4Mask);
  case Mod5MapIndex:
    return(Mod5Mask);
  }
}

static int
ModifierMaskFromName(mask_name)
     char *mask_name;
{
  char *p;

  /* convert to uppercase */
  p = mask_name;
  while (*p) {
    if ( islower(*p) )  /* test for islower needed on some machines */
      *p = (char) toupper(*p);
    p++;
  }

  /* compare with known modifier-mask names */
  if ( streq(mask_name,NXLT("SHIFT")) || streq(mask_name,NXLT("SHIFTMASK")) )
    return(ShiftMask);
  if ( streq(mask_name,NXLT("LOCK")) || streq(mask_name,NXLT("LOCKMASK")) )
    return(LockMask);
  if ( streq(mask_name,NXLT("CONTROL"))
       || streq(mask_name,NXLT("CONTROLMASK")) )
    return(ControlMask);
  if ( streq(mask_name,NXLT("MOD1")) || streq(mask_name,NXLT("MOD1MASK")) )
    return(Mod1Mask);
  if ( streq(mask_name,NXLT("MOD2")) || streq(mask_name,NXLT("MOD2MASK")) )
    return(Mod2Mask);
  if ( streq(mask_name,NXLT("MOD3")) || streq(mask_name,NXLT("MOD3MASK")) )
    return(Mod3Mask);
  if ( streq(mask_name,NXLT("MOD4")) || streq(mask_name,NXLT("MOD4MASK")) )
    return(Mod4Mask);
  if ( streq(mask_name,NXLT("MOD5")) || streq(mask_name,NXLT("MOD5MASK")) )
    return(Mod5Mask);

  /* fail: unknown name */
  return(0);
}

/*************************************************************************
                            Edit Box Widget
*************************************************************************/


/*************************************************************************
  function: PaintEditBox - Painter for W_EDITBOX
  */
void
PaintEditBox(w, exP, full_regen, layered)
AXWidget_editbox w;
XExposeEvent *exP;
int full_regen;
int layered;
{
	any_obj_t *op;
	int expy, expht;			/* ypos & ht of exposed area */
	int expx, expwid;
	int cleared_bg = FALSE;
	unsigned long mask;
	XSetWindowAttributes atts;
	AXWidget_main parent;

	if ( !w->parent->window )
		return;					/* dialog not yet created */
    
	if (!w->display)
		return;

	if (w->parent && (w->parent->type == W_DIALOG) &&
		!((AXWidget_dialog)w->parent)->exposed)
		return;

	if (layered) {
		if (w->flags & WFLG_IN_EDIT) {
			if (dePaintWidget(w)) {
				return;
			}
		}
		else {
			if (topWidget(w) == (AXWidget)w) {
				paintCompositeWidget(w, exP, full_regen);
				return;
			}
		}
	}
	
	xmEditboxSetLineHeight(w);

	if ( !w->mapped )
		w->mapped = TRUE;

	/* draw bevel, clear area between bevel and window (always full draw) */
	AxDrawBevel(w, WIN_OF(w), w->xpos, w->ypos,
				w->width, w->height, 2, BEVEL_IN);
	if ( w->useWorkColors ) {
		SetWorkColors(BackGC, 0);
	}
	xmColorFillRectangle(w, WIN_OF(w), BackGC, w->xpos+2, w->ypos+2,
						 w->width-4, w->height-4);

	if ( !w->window ) {
		/* create window */
		mask = WinMask | CWCursor;
		atts = WinAtt;
		if ( ElfInLearnMode ) {
			/* if parent W_MAIN has elf ecording disabled,
			 * set cursor type to ThimNoRecordCursor */
			parent = w->parent;
			while ( parent ) {
				if ( parent->type == W_MAIN )
					break;
				parent = parent->parent;
			}
			if ( parent && parent->disable_record ) {
				atts.cursor = ThimNoRecordCursor;
			} else {
				atts.cursor = ThimRecordCursor;
			}
		} else {
			atts.cursor = ThimTextCursor;
		}
		if ( w->useWorkColors ) {
			mask |= CWBackPixel | CWColormap;
			atts.background_pixel = BackWorkPixel;
			atts.colormap = WorkColormap;
		}
		if (w->flags & WFLG_IN_EDIT) { /* under dialog editor */
			w->window = AxCreateQueryPixmap(Dpy, w->parent->window,
											w->editbox->width, 
											w->editbox->height, DpyDepth);
		}
		else {
			w->window = AxCrtWindow(Dpy,WIN_OF(w),
									w->editbox->xpos, w->editbox->ypos,
									w->editbox->width,w->editbox->height,
									0,CopyFromParent,InputOutput,
									CopyFromParent,mask,&atts);
			XSelectInput(Dpy, w->window, TM_ALL_INPUTS_MASK);
			AxMapWindow(w, Dpy,w->window,w->name);
			AddToWindowList(w);
			AXDefineDefaultCursor((AXWidget)w, atts.cursor);
		}
		xmColorFillRectangle((AXWidget)w, w->window, BackGC, 0, 0,
							 w->editbox->width, w->editbox->height);
		cleared_bg = TRUE;
        
		/* format (reformat) contents */
		resetScrollInfo(w);
		formatObjs(w, FMT_ALL);
	}

	/* determine draw dimensions */
	expx = 0;
	expwid = w->editbox->width;
	if (exP) {
		/* update vertical draw dimensions based on expose size */
		expy = exP->y;
		expht = exP->height;
	}
	else {
		/* use defaults */
		expy = 0;
		expht = w->editbox->height;
	}
    
	/* adjust scroll_pos; possibly adjust draw size also */
	if (w->scroll_per >= w->scroll_max) 
		w->scroll_pos = 0;
	if (w->scroll_pos < 0)
		w->scroll_pos = 0;
	if (w->scroll_pos != (-w->editbox->yoffset)) {
		/* manage scrolling and update area to be redisplayed */
		manageScroll(w, &expy, &expht);
		if ( w->useWorkColors ) {
			SetWorkColors(BackGC, 0);
		}
	}
    
	if (!cleared_bg) {
		/* clear window background */
		xmColorFillRectangle(w, w->window, BackGC, expx, expy, expwid, expht);
	}
	if ( w->useWorkColors ){
		UnSetWorkColors(BackGC, 0);
	}
    
	displayObjs(w, expy, expht);

	/* draw the cursor */
	EditBoxDrawCursor(w, TRUE);

	/* scrollbar for editbox
	 * NOTE: scrollbar parent MUST be dialog to ensure proper
	 *       behavior when task of editbox is pended */
	if ( !w->vScrollBar ) {
		Arg args[10];
		int n = 0;
		static XtCallbackRec callback_list[2];
		CALLBACKER(callback_list,EditBoxChanged,w);
		XtSetArg(args[n],XmNx,w->xpos+w->width+2); n++;
		XtSetArg(args[n],XmNy,w->ypos); n++;
		XtSetArg(args[n],XmNheight,w->height); n++;
		XtSetArg(args[n],XmNorientation,AXmVERTICAL); n++;
		XtSetArg(args[n],XmNvalueChangedCallback,callback_list); n++;
		if ( w->vScrollBar )
			AxXtSetValues(w->vScrollBar, args, n);
		else
			w->vScrollBar = (AXWidget_scroll)AXmCreateScrollBar
				(w->parent,"xx",args,n);

		if (w->event_table) {
			/* give the newly created scrollbar an event table
			 * which matches that of the editbox widget */
			copyEventHandlerList(w->event_table,&w->vScrollBar->event_table);
		}
		/* dlg editor support */
		XtSetArg(args[0], ZXmNcompositeLinkUp, w);
		XtSetArg(args[1], ZXmNinEdit, w->flags & WFLG_IN_EDIT);
		AxXtSetValues(w->vScrollBar, args, 2);
		XtSetArg(args[0], ZXmNcompositeLinkDown, w->vScrollBar);
		AxXtSetValues(w, args, 1);
	}
	updateScroll(w, exP);
	if (w->flags & WFLG_IN_EDIT) {
		XCopyArea(Dpy, w->window, w->parent->window, ForeGC, 0, 0,
				  w->editbox->width, w->editbox->height,
				  w->editbox->xpos, w->editbox->ypos);
	}
}


static void 
EditBoxChanged(widget, w, data)
     AXWidget widget;
     AXWidget_editbox w;
     XmScrollBarCallbackStruct *data;
{
  any_obj_t *op;
  tline_t *lp;
  int y;

  /* !! currently assumes that only one object exists (text) !! */

  switch ( data->reason ) {
  case XmCR_INCREMENT:
    /* get obj and line nearest to top of window */
    getNearestObj(w, 0, 0, &op, &lp);
    if (lp && lp->next)
      w->scroll_pos = op->ypos + lp->next->ypos;
    break;
  case XmCR_DECREMENT:
    /* get obj and line nearest to top of window */
    getNearestObj(w, 0, 0, &op, &lp);
    if (lp && lp->prev)
      w->scroll_pos = op->ypos + lp->prev->ypos;
    break;
  case XmCR_PAGE_INCREMENT:
    /* get obj and line nearest to bottom of window */
    y = w->editbox->height;
    getNearestObj(w, 0, y, &op, &lp);
    if (lp)
      w->scroll_pos = op->ypos + lp->ypos;
    else if (lp && lp->prev)
      w->scroll_pos = op->ypos + lp->prev->ypos;
    break;
  case XmCR_PAGE_DECREMENT:
    /* get obj and line nearest to top of prev page */
    y = -w->editbox->height;
    getNearestObj(w, 0, y, &op, &lp);
    if (y<=w->editbox->yoffset && lp)
      /* this check for y<=w->editbox->yoffset is a hack 
       * to ensure that the top of the doc is displayed */
      w->scroll_pos = op->ypos + lp->ypos;
    else if (lp && lp->next)
      w->scroll_pos = op->ypos + lp->next->ypos;
    else if (lp)
      w->scroll_pos = op->ypos + lp->ypos;
    break;
  case XmCR_VALUE_CHANGED:
    /* get obj and line nearest to specified pos */
    y = w->editbox->yoffset + data->value;
    getNearestObj(w, 0, y, &op, &lp);
    if (data->value==0 && lp)
      /* this check for data->value==0 is a hack to
       * ensure that the top of the doc is displayed */
      w->scroll_pos = op->ypos + lp->ypos;
    else if (lp && lp->next)
      w->scroll_pos = op->ypos + lp->next->ypos;
    else if (lp)
      w->scroll_pos = op->ypos + lp->ypos;
    break;
  }
  w->regen_widget = TRUE;
  if (w->scroll_pos != -w->editbox->yoffset)
    PaintEditBox(w,NULL,TRUE,TRUE);
}

int
EditBoxEvent(w, eventP)
AXWidget_editbox w;
XEvent *eventP;
{
    int consumed = FALSE;
    if ( !w || !eventP || (w->type != W_EDITBOX) )
        return (FALSE);
    
    switch (eventP->type) {
    case KeyPress:
        consumed = editboxKeyEvent(w, eventP, FALSE);
        break;
    case ButtonPress:
    case ButtonRelease:
    case MotionNotify:
        consumed = editboxMouseEvent(w, eventP);
        break;
    case SelectionRequest:
    case SelectionNotify:
    case SelectionClear:
        consumed = editboxSelectionEvent(w, eventP);
        break;
    default:
        break;
    }
    return (consumed);
}

EditBoxCursorChanged(w, parentHasFocus)
     AXWidget_editbox w;
     int parentHasFocus;  /* boolean indicating if parent shell win has focus */
{
  int cursor_type;

  if ( !w || (w->type != W_EDITBOX) )
    return;

  cursor_type = parentHasFocus ? TC_ACTIVE : TC_INACTIVE;
  changeCursorType(w, cursor_type);
}

EditBoxDrawCursor(w, draw)
     AXWidget_editbox w;
     int draw;     /* boolean indicating if cursor should be drawn or erased */
{
  int mode;

  if ( !w || (w->type != W_EDITBOX) )
    return;

  mode = draw ? TC_DRAW : TC_ERASE;
  drawCursor(w, mode);
}

String 
AxXmEditBoxEdited(w)
     AXWidget_editbox w;
{
  if ( w->type != W_EDITBOX )
    return((String)NULL);

  if ( w->changed ) {
    w->changed = FALSE;
    return( (String)getEditBoxData(w) );
  }
  else
    return((String)NULL);
}


AxXmDelEditBoxData(w)
     AXWidget_editbox w;
{
  clearEditBoxData(w);
  PaintEditBox(w, NULL, TRUE, TRUE);
}

String 
AxXmGetEditBoxData(w)
     AXWidget_editbox w;
{
  if ( w->type != W_EDITBOX )
    return((String)"");

  return( (String)getEditBoxData(w) );
}

AxXmGetEditBoxSelectedRegion(w, start_rowp, start_colp, end_rowp, end_colp)
     AXWidget_editbox w;
     int *start_rowp;
     int *start_colp;
     int *end_rowp;
     int *end_colp;
{
  return(GetEditBoxSelectedRegion(w, start_rowp, start_colp, end_rowp,
                  end_colp));
}

AxXmMarkEditBoxRegion(w, start_row, start_col, end_row, end_col)
     AXWidget_editbox w;
     int start_row;
     int start_col;
     int end_row;
     int end_col;
{
  return(MarkEditBoxRegion(w, start_row, start_col, end_row, end_col));
}


AxXmCutEditBoxSeln(w)
     AXWidget w;
{
  AXWidget_editbox childP;
  AXWidget_dialog d_w;

  if ( !w )
    return;
  if ( w->type == W_MAIN )
    d_w = ((AXWidget_main)w)->dialog;
  else
    d_w = (AXWidget_dialog)w;
  if ( !d_w || d_w->type != W_DIALOG )
    return;

  childP = (AXWidget_editbox)ElfbGetActiveWidget(d_w);
  if ( !childP || childP->type != W_EDITBOX )
    return;

  saveSelection(childP);
  if ( !childP->no_picks )
    deleteSelection(childP);
}

AxXmCopyEditBoxSeln(w)
     AXWidget w;
{
  AXWidget_editbox childP;
  AXWidget_dialog d_w;

  if ( !w )
    return;
  if ( w->type == W_MAIN )
    d_w = ((AXWidget_main)w)->dialog;
  else
    d_w = (AXWidget_dialog)w;
  if ( !d_w || d_w->type != W_DIALOG )
    return;

  childP = (AXWidget_editbox)ElfbGetActiveWidget(d_w);
  if ( !childP || childP->type != W_EDITBOX )
    return;

  saveSelection(childP);
}

AxXmPasteEditBoxSeln(w)
     AXWidget w;
{
  AXWidget_editbox childP;
  AXWidget_dialog d_w;

  if ( !w )
    return;
  if ( w->type == W_MAIN )
    d_w = ((AXWidget_main)w)->dialog;
  else
    d_w = (AXWidget_dialog)w;
  if ( !d_w || d_w->type != W_DIALOG )
    return;

  childP = (AXWidget_editbox)ElfbGetActiveWidget(d_w);
  if ( !childP || childP->type != W_EDITBOX )
    return;

  if ( !childP->no_picks ) {
    xmEditboxRequestSelection(childP, XFER_BIN_CLIPBOARD);
  }
}

XMlog(str,a,b,c,d,e,f)
     char *str;
     int a,b,c,d,e,f;
{
  static FILE *fp = NULL;

  if ( !fp )
    fp = fopen("/tmp/zzxmlib.log", "w");
  if ( fp ) {
    fprintf(fp,str,a,b,c,d,e,f);
    fflush(fp);
  }
}

char *
WidgetTypeToStr(type)
     int type;
{
  switch (type) {
  case W_DIALOG:
    return(NXLT("W_DIALOG"));
  case W_LABEL:
    return(NXLT("W_LABEL"));
  case W_TOGGLE:
    return(NXLT("W_TOGGLE"));
  case W_RADIO:
    return(NXLT("W_RADIO"));
  case W_BUTTON:
    return(NXLT("W_BUTTON"));
  case W_OPTION:
    return(NXLT("W_OPTION"));
  case W_LIST:
    return(NXLT("W_LIST"));
  case W_SCROLL:
    return(NXLT("W_SCROLL"));
  case W_ENTER:
    return(NXLT("W_ENTER"));
  case W_ICON:
    return(NXLT("W_ICON"));
  case W_HGROOVE:
    return(NXLT("W_HGROOVE"));
  case W_POPUP:
    return(NXLT("W_POPUP"));
  case W_RECT:
    return(NXLT("W_RECT"));
  case W_MAIN:
    return(NXLT("W_MAIN"));
  case W_WORK:
    return(NXLT("W_WORK"));
  case W_MENUBAR:
    return(NXLT("W_MENUBAR"));
  case W_PALETTE:
    return(NXLT("W_PALETTE"));
  case W_PLATES:
    return(NXLT("W_PLATES"));
  case W_RULER:
    return(NXLT("W_RULER"));
  case W_STATUS:
    return(NXLT("W_STATUS"));
  case W_PAGEBAR:
    return(NXLT("W_PAGEBAR"));
  case W_DEBUG:
    return(NXLT("W_DEBUG"));
  case W_CORNER:
    return(NXLT("W_CORNER"));
  case W_TOOLBAR:
    return(NXLT("W_TOOLBAR"));
  case W_EDITBOX:
    return(NXLT("W_EDITBOX"));
  case W_TABLE:
    return(NXLT("W_TABLE"));
  case W_TRAY:
    return(NXLT("W_TRAY"));
  case W_ROWCOL:
    return(NXLT("W_ROWCOL"));
  case W_KANJI_STATUS:
    return(NXLT("W_KANJI_STATUS"));
  case W_CANVAS:
    return(NXLT("W_CANVAS"));
  case W_GE_XRULER:
    return(NXLT("W_GE_XRULER"));
  case W_GE_YRULER:
    return(NXLT("W_GE_YRULER"));
  case W_RIBBON:
    return(NXLT("W_RIBBON"));
  case W_SPLITTER:
    return(NXLT("W_SPLITTER"));
  case W_SCALE:
    return(NXLT("W_SCALE"));
  case W_ALIGN:
    return(NXLT("W_ALIGN"));
  case W_COLORPAL:
    return(NXLT("W_COLORPAL"));
  case W_COMBO_BOX:
    return(NXLT("W_COMBO_BOX"));
  default:
    return(NXLT("UNKNOWN WIDGET TYPE"));
  }
}



/* -------- */

/*
 * A x A d d N o M a p W i n d o w ()  OBSOLETE!!!!0
 *
 * Add a X-Window Title to the list of X-Windows NOT to be displayed
 */
AxAddNoMapWindow(WinName)   /* OBSOLETE!!!!0 */
     char *WinName;
{
  struct WINDNOMAP *ptr, *last;

  if(WinName[0] == '\0')
    {
      /* No Window Title */
      return(TRUE);
    }
  if(WindNotMapped == (struct WINDNOMAP *)NULL)
    {
      /* 
       * most often case, the list is empty
       */
      if((WindNotMapped = (struct WINDNOMAP *)malloc(sizeof(struct WINDNOMAP))) == (struct WINDNOMAP *)NULL)
    return(FALSE);
      WindNotMapped->next = (struct WINDNOMAP *)NULL;
#if DEBUG_NOMAP
      printf("Created & Added NoMapWindow %s\n",WinName);
#endif
      strcpy(WindNotMapped->title, WinName);
      return(TRUE);
    }

  ptr = WindNotMapped;
  while(ptr != (struct WINDNOMAP *)NULL)
    {
      if(!strcmp(WinName, ptr->title))
    {
#if DEBUG_NOMAP
      printf("ALREADY Added NoMapWindow %s\n",WinName);
#endif
      return(TRUE);
    }
      last = ptr;
      ptr = ptr->next;
    }

  /* 
   * add to the end of the list
   */
  if((last->next = (struct WINDNOMAP *)malloc(sizeof(struct WINDNOMAP))) == (struct WINDNOMAP *)NULL)
    return(FALSE);
  ptr = last->next;
  ptr->next = (struct WINDNOMAP *)NULL;
  strcpy(ptr->title, WinName);
#if DEBUG_NOMAP
  printf("Added NoMapWindow %s\n",WinName);
#endif

  return(TRUE);
}




/*
 * A x D e l N o M a p W i n d o w ()
 *
 * Delete a X-Window Title from the list of X-Windows NOT to be displayed
 */
AxDelNoMapWindow(WinName)   /* OBSOLETE!!!!0 */
     char *WinName;
{
  struct WINDNOMAP *ptr, *last;

  if(WinName == NULL)
    return(TRUE);

  ptr = last = WindNotMapped;
  while(ptr != (struct WINDNOMAP *)NULL)
    {
      if(!strcmp(WinName, ptr->title))
    {
      if(ptr == WindNotMapped)
        WindNotMapped = ptr->next;
      else
        last->next = ptr->next;

      free(ptr);
#if DEBUG_NOMAP
      printf("Delete NoMapWindow %s\n",WinName);
#endif
      return(TRUE);
    }
      last = ptr;
      ptr = ptr->next;
    }
  return(FALSE);
}


/*
*   Get the font struct used for openlook cursor font.
*/
XFontStruct *AxGetGrafont()
{
  return(Grafont);
}

Window
ShellWindowFromXWindow(win)
     Window win;
{
  AXWidget w;

  for ( w = WindowList; w; w = w->nextWin ) {
    if ( w->window == win ) 
      break;
  }

  while ( w ) {
    if ( w->type == W_MAIN ) {
      return((Window) w->window);
    }
    w = (AXWidget)w->parent;
  }
  return((Window) None);
}

/* Print the window list.  Useful when debugging with dbxtool */
int
PrintWindowList()
{
  extern AXWidget WindowList;
  register AXWidget w;
  int cnt = 0;

  printf("Window List:\n");
  if (!WindowList) {
    printf("Empty WindowList\n");
    return(0);
  }
  for (w = WindowList; w; w = w->nextWin) {
    cnt++;
    printf(NXLT("0x%lx -> type %d \"%s\"\n"), w, w->type,
       WidgetTypeToStr(w->type));
  }
  printf("Total: %d\n", cnt);
  return(0);
}

/* Print widget's children.  Useful when debugging with dbxtool */
int
PrintWidgetChildren(w)
     AXWidget w;
{
  AXWidget childP;
  int cnt = 0;

  if (!w)
    return(0);
  printf("Children of Widget @ 0x%lx\n", w);
  for (childP = w->widgets; childP; childP = childP->nextChild) {
    cnt++;
    printf(NXLT("0x%lx -> W type %d name <%s>\n"), childP,
       childP->type, childP->name);
  }
  printf("%d children\n", cnt);
  return(0);
}

/*
 * AXStringListToTextProperty - fill in TextProperty structure with
 * concatenated list of null-separated strings.  Return True if successful
 * else False.  Allocate room on end for trailing NULL, but don't include in
 * count.
 */

Status 
AXStringListToTextProperty(argv, argc, textprop)
     char          **argv;
     int     argc;
     XTextProperty  *textprop;
{
  register int    i;
  register unsigned int nbytes;
  XTextProperty   proto;

  /* figure out how much space we'll need for this list */
  for (i = 0, nbytes = 0; i < argc; i++) {
    nbytes += (unsigned) ((argv[i] ? strlen(argv[i]) : 0) + 1);
  }

  /* fill in a prototype containing results so far */
  proto.encoding = XA_STRING;
  proto.format = 8;
  if (nbytes)
    proto.nitems = nbytes - 1;  /* subtract one for trailing
                 * <NUL> */
  else
    proto.nitems = 0;
  proto.value = NULL;

  /* build concatenated list of strings */
  if (nbytes > 0) {
    register char  *buf = malloc(nbytes);
    if (!buf)
      return False;

    proto.value = (unsigned char *) buf;
    for (i = 0; i < argc; i++) {
      char           *arg = argv[i];

      if (arg) {
    (void) strcpy(buf, arg);
    buf += (strlen(arg) + 1);
      } else {
    *buf++ = '\0';
      }
    }
  } else {
    proto.value = (unsigned char *) malloc(1);  /* easier for client */
    if (!proto.value)
      return False;

    proto.value[0] = '\0';
  }

  /* we were successful, so set return value */
  *textprop = proto;
  return True;
}




#if HP800 && !BUILD_KANJI && !BUILD_KOREAN && !BUILD_CHINA /*  {  */

/** The following is a table to convert ISO-8859 to HP-Roman-8  */
/** The table is one array, with every other element being an 8859 value, */
/**    which is followed by the Roman-8 equivalent.               */
/** The table is in sorted order by the ISO-8859 value to speed lookup,   */
/**    and the last value must be 255 to stop the search                  */
unsigned char Roman8Lookup[] = {
  192,161,
  193,224,
  194,162,
  195,225,
  196,216,
  197,208,
  198,211,
  199,180,
  200,163,
  201,220,
  202,164,
  203,165,
  204,230,
  205,229,
  206,166,
  207,167,
  208,227,
  209,182,
  210,232,
  211,231,
  212,223,
  213,233,
  214,218,
  216,210,
  217,173,
  218,237,
  219,174,
  220,219,
  221,177,
  224,200,
  225,196,
  226,192,
  227,226,
  228,204,
  229,212,
  230,215,
  231,181,
  232,201,
  233,197,
  234,193,
  235,205,
  236,217,
  237,213,
  238,209,
  239,221,
  241,183,
  242,202,
  243,198,
  244,194,
  245,234,
  246,206,
  249,203,
  250,199,
  251,195,
  252,207,
  253,178,
  255,239 };


ConvertRoman8( str )
     unsigned char *str;
{

  register unsigned int ch;
  register int ix;

  static int roman8_window_title = -1;
  if ( roman8_window_title == -1 )
    {
      /* initialize */
      if ( getenv("AX_ISO8859_TITLE") == (char *)NULL )
    roman8_window_title = TRUE;
      else
    roman8_window_title = FALSE;
    }

  if ( !roman8_window_title )
    /* no conversion required */
    return;

  /** convert the string **/
  while ( *str != (unsigned char)0 )
    {
      ch = *str;
      ix = 0;
      while ( ch >= Roman8Lookup[ix] )
    {
      if ( ch == Roman8Lookup[ix] )
        {
          /* convert */
          *str = Roman8Lookup[ix+1];
          break;
        }
      ix = ix + 2;
    }
      str++;
    }

  return;
}
       
#endif   /* }  HP800  */
       

/* : AxFilterExpose - this is an n-more filter for XExpose events.
 * successive events grouped by #more count are collected in order to
 * deliver a single expose containing all.
 *
 * This is based on the claim in O'Reilly that the server guarantees a
 * contiguous report of XExpose events whenever exP->count > 0. (Vol 2,
 * Event Reference, Expose)....
 */
int                          /* bool: return whether exposure is 'delivered' */
AxFilterExpose(wp, exP, exposeProc)
AXWidget wp;                 /* in: widget getting newest expose event */
XExposeEvent *exP;           /* in: real expose event */
void (*exposeProc)();        /* in: call if needed, passing (wp, exP) */
{
	r32 newRect;
	XExposeEvent filteredExpose;
    
	if (!exP || !exposeProc || !wp)
		return FALSE;
    
	if ((exP->window != AxExpose.win) || (wp != AxExpose.wp)) {
		if (AxExpose.wp && AxExpose.win && AxExpose.rect.width) {
			/* this would happen only if the server interleaves
			 * groups of exposes bound for different windows (doubtful)
			 */
			memset((char *) &filteredExpose, 0, sizeof(XExposeEvent));
			filteredExpose.type = Expose;
			filteredExpose.display = Dpy;
			filteredExpose.window = AxExpose.win;
			filteredExpose.x = AxExpose.rect.origin.x;
			filteredExpose.y = AxExpose.rect.origin.y;
			filteredExpose.width = AxExpose.rect.width;
			filteredExpose.height = AxExpose.rect.height;
			exposeProc(AxExpose.wp, &filteredExpose); /* deliver */
			if ( (AxExpose.wp)->type == W_MAIN )
				((AXWidget_main)(AxExpose.wp))->exposed = TRUE;
			else if ( (AxExpose.wp)->type == W_DIALOG )
				((AXWidget_dialog)(AxExpose.wp))->exposed = TRUE;
            
		}
		memset((char *) &AxExpose, 0, sizeof(AxExpose)); /* reset */
		AxExpose.wp = wp;
		AxExpose.win = exP->window;
	}
    
	if (!exP->count) {
		/* the event claims no more are coming; report the total
		 */
		/* add this event's rect info to the total
		 */
		if (!AxExpose.rect.width || !AxExpose.rect.height) {
			AxExpose.rect.origin.x = exP->x;
			AxExpose.rect.origin.y = exP->y;
			AxExpose.rect.width = exP->width;
			AxExpose.rect.height = exP->height;
		}
		else {
			newRect.origin.x = exP->x;
			newRect.origin.y = exP->y;
			newRect.width = exP->width;
			newRect.height = exP->height;
			unionRectangle(&newRect, &AxExpose.rect, &AxExpose.rect);
		}
            
		memset((char *) &filteredExpose, 0, sizeof(XExposeEvent));
		filteredExpose.type = Expose;
		filteredExpose.display = Dpy;
		filteredExpose.window = AxExpose.win;
		filteredExpose.x = AxExpose.rect.origin.x;
		filteredExpose.y = AxExpose.rect.origin.y;
		filteredExpose.width = AxExpose.rect.width;
		filteredExpose.height = AxExpose.rect.height;
        
		exposeProc(AxExpose.wp, &filteredExpose); /* deliver */
        
		if ( wp->type == W_MAIN )
			((AXWidget_main)wp)->exposed = TRUE;
		else if ( wp->type == W_DIALOG )
			((AXWidget_dialog)wp)->exposed = TRUE;
        
		memset((char *) &AxExpose, 0, sizeof(AxExpose)); /* reset */
        
		return TRUE;
	}
	else {
		/* the event claims that more are coming; add to total
		 */
		newRect.origin.x = exP->x;
		newRect.origin.y = exP->y;
		newRect.width = exP->width;
		newRect.height = exP->height;
		unionRectangle(&newRect, &AxExpose.rect, &AxExpose.rect);
        
		return FALSE;
	}
}

int
VerbButtonKeyPressEvent(wp, eventP, ksym, kbuf, num_chars)
AXWidget_pushbutton wp;   /* in: widget getting the keypress */
XEvent *eventP;           /* in: keypress event */
KeySym ksym;
wchar *kbuf;       /* in: key string associated with ksym, from LookupString */
int num_chars;            /* num_chars in kbuf */
{
	/* assume that any execute-key will be handled by the
	 * dialog-box keybindings code.  So in here, we're looking
	 * only for the space key, which presses the button.  Note
	 * that for boxes with no default button, XK_Return is ok, too.
	 */
	int no_default = FALSE;
    
	if (wp->parent->type == W_DIALOG) {
		AXWidget_dialog d_w = (AXWidget_dialog) wp->parent;
		no_default = (d_w->defaultButton == (AXWidget_pushbutton) NULL);
	}
	if ((no_default && (XK_Return == ksym)) || (XK_space == ksym)) {
		ArmButton(wp, FALSE, NULL);
		return (TRUE);
	}
	return (FALSE);
}

int
ComboKeyPressEvent(wp, eventP, ksym, kbuf, num_chars, in_menu_bar)
AXWidget_combo_box wp; /* in: widget getting the keypress */
XEvent *eventP;        /* in: keypress event */
KeySym ksym;
wchar *kbuf;       /* in: key string associated with ksym, from LookupString */
int num_chars;     /* num_chars in kbuf */
int in_menu_bar;   /* bool: passed ksym has menubar binding */
{
    /* if the combo box is already open, then it steals
     * keystrokes early on, as a stayup-mode.  */

    /* if the event is an up/down arrow key press, open up the pulldown. */
  
    if ((XK_Down == ksym) || (XK_Up == ksym)) {
        ComboBoxInEditWindow = NULL;
        CbOpenComboPulldown(wp);
        CbEnterStayup(wp);
		return (TRUE);
    }
	if (wp->flags & WFLG_EDITABLE) {
		ComboBoxInEditWindow = wp;
		if (in_menu_bar) {
			if ((XK_Return == ksym) || (XK_Execute == ksym)) {
				/* use but don't consume these keys
				 */
				ComboBoxKeyEvent(ComboBoxInEditWindow, ksym, 
								 kbuf, num_chars, eventP);
			}
			return FALSE;
		}
		else {
			return (ComboBoxKeyEvent(ComboBoxInEditWindow, ksym, kbuf,
									 num_chars, eventP));
		}
	}
	return FALSE;
}


int
ToggleKeyPressEvent(wp, eventP, ksym, kbuf, num_chars)
     AXWidget_togglebutton wp; /* in: widget getting the keypress */
     XEvent *eventP;           /* in: keypress event */
     KeySym ksym;
     wchar *kbuf;       /* in: key string associated with ksym, from LookupString */
     int num_chars;            /* num_chars in kbuf */
{
  if (wp->in_radio) {
    return (RadioKeyPressEvent(wp->in_radio, eventP,
                   ksym, kbuf, num_chars));
  }
    
  /* space bar changes value
   */
  if (XK_space == ksym) {
    XmToggleButtonCallbackStruct tog_data;
    if (THREE_STATE_TOGGLE == wp->scroll_type) {
      wp->value = xmToggleThreeStatePress(wp);
    }
    else {
      wp->value = (wp->value != TRUE);
    }
    tog_data.set = wp->value;
    if ( wp->callback ) {
      AxCallback(wp->callback, wp, wp->callbacktag, &tog_data);
    }
    wp->update_widget = TRUE;
    WidgetNeedsUpdated = TRUE;
    return (TRUE);
  }
  return (FALSE);
}

int
OptionKeyPressEvent(wp, eventP, ksym, kbuf, num_chars)
     AXWidget_option wp;       /* in: widget getting the keypress */
     XEvent *eventP;           /* in: keypress event */
     KeySym ksym;
     wchar *kbuf;       /* in: key string associated with ksym, from LookupString */
     int num_chars;            /* num_chars in kbuf */
{
  /* xxx like combo, vert arrow invokes stayup mode */
  /* xxx must actually add a stayup mode first.. */
  return (FALSE);
}


#undef XSelectInput

HACKSelectInput(Dpy, win, event_mask)
Display *Dpy;
Window win;
long event_mask;
{
#if 0
	Atom *list;
	int i, n;
 
	if ( !(event_mask & PropertyChangeMask) )
		event_mask |= PropertyChangeMask;
	if ( win == RootWin )
	{
		list = XListProperties(Dpy, RootWin, &n);
		printf("*********** Atom list *********\n");
		for ( i=0; i<n; i++ )
			printf("* %s (%d)\n", XGetAtomName(Dpy, list[i]), list[i]);
		printf("*******************************\n");
 
		printf("Select events for root window %d\n.", RootWin);
	}
#endif
	XSelectInput(Dpy, win, event_mask);
}

